function replaceCode(code, replaces) {
    var shift = 0;
    var prevEnd = -1;
    for (var i = 0; i < replaces.length; i++) {
        var replace = replaces[i];
        var pos = replace[0] + shift;
        var end = replace[1] + shift;
        if (prevEnd > pos) {
            continue;
        }
        var replacedCode = replace[2];
        code = code.substr(0, pos) + replacedCode + code.substr(end);
        var diff = replacedCode.length - (end - pos);
        shift += diff;
        prevEnd = end + diff;
    }
    return code;
}

var s = `(node) {
            // no rest parameters \x5c declaration context \x5c overload - no codegen impact
            if (!ts.hasDeclaredRestParameter(node) || ts.isInAmbientContext(node) || ts.nodeIsMissing(node.body)) {
                return;
            }
            ts.forEach(node.parameters, function (p) {
                if (p.name && !ts.isBindingPattern(p.name) && p.name.text === argumentsSymbol.name) {
                    error(p, ts.Diagnostics.Duplicate_identifier_arguments_Compiler_uses_arguments_to_initialize_rest_parameters);
                }
            });
        }`;
console.log(replaceCode(s, [[116, 120, '@@@@']]));