--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isLineBreak) id{0,0} ---
(ch) {
        // ES5 7.3:
        // The ECMAScript line terminator characters are listed in Table 3.
        //     Table 3: Line Terminator Characters
        //     Code Unit Value     Name                    Formal Name
        //     \x5cu000A              Line Feed               <LF>
        //     \x5cu000D              Carriage Return         <CR>
        //     \x5cu2028              Line separator          <LS>
        //     \x5cu2029              Paragraph separator     <PS>
        // Only the characters in Table 3 are treated as line terminators. Other new line or line
        // breaking characters are treated as white space but not as line terminators.
        return ch === 10 /* lineFeed */ ||
            ch === 13 /* carriageReturn */ ||
            ch === 8232 /* lineSeparator */ ||
            ch === 8233 /* paragraphSeparator */;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{1,0} ---
() {
            return currentToken;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{2,0} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseOptional) id{3,0} ---
(t) {
            if (token() === t) {
                nextToken();
                return true;
            }
            return false;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{3,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{3,1} AS 1 AT <0:22>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{3,2} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{3,2} AS 2 AT <0:55>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getStartPos) id{4,0} ---
() { return startPos; }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIdentifierPart) id{5,0} ---
(ch, languageVersion) {
        return ch >= 65 /* A */ && ch <= 90 /* Z */ || ch >= 97 /* a */ && ch <= 122 /* z */ ||
            ch >= 48 /* _0 */ && ch <= 57 /* _9 */ || ch === 36 /* $ */ || ch === 95 /* _ */ ||
            ch > 127 /* maxAsciiCharacter */ && isUnicodeIdentifierPart(ch, languageVersion);
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:scan) id{6,0} ---
() {
            startPos = pos;
            hasExtendedUnicodeEscape = false;
            precedingLineBreak = false;
            tokenIsUnterminated = false;
            while (true) {
                tokenPos = pos;
                if (pos >= end) {
                    return token = 1 /* EndOfFileToken */;
                }
                var ch = text.charCodeAt(pos);
                // Special handling for shebang
                if (ch === 35 /* hash */ && pos === 0 && isShebangTrivia(text, pos)) {
                    pos = scanShebangTrivia(text, pos);
                    if (skipTrivia) {
                        continue;
                    }
                    else {
                        return token = 6 /* ShebangTrivia */;
                    }
                }
                switch (ch) {
                    case 10 /* lineFeed */:
                    case 13 /* carriageReturn */:
                        precedingLineBreak = true;
                        if (skipTrivia) {
                            pos++;
                            continue;
                        }
                        else {
                            if (ch === 13 /* carriageReturn */ && pos + 1 < end && text.charCodeAt(pos + 1) === 10 /* lineFeed */) {
                                // consume both CR and LF
                                pos += 2;
                            }
                            else {
                                pos++;
                            }
                            return token = 4 /* NewLineTrivia */;
                        }
                    case 9 /* tab */:
                    case 11 /* verticalTab */:
                    case 12 /* formFeed */:
                    case 32 /* space */:
                        if (skipTrivia) {
                            pos++;
                            continue;
                        }
                        else {
                            while (pos < end && isWhiteSpaceSingleLine(text.charCodeAt(pos))) {
                                pos++;
                            }
                            return token = 5 /* WhitespaceTrivia */;
                        }
                    case 33 /* exclamation */:
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            if (text.charCodeAt(pos + 2) === 61 /* equals */) {
                                return pos += 3, token = 34 /* ExclamationEqualsEqualsToken */;
                            }
                            return pos += 2, token = 32 /* ExclamationEqualsToken */;
                        }
                        pos++;
                        return token = 50 /* ExclamationToken */;
                    case 34 /* doubleQuote */:
                    case 39 /* singleQuote */:
                        tokenValue = scanString();
                        return token = 9 /* StringLiteral */;
                    case 96 /* backtick */:
                        return token = scanTemplateAndSetTokenValue();
                    case 37 /* percent */:
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 63 /* PercentEqualsToken */;
                        }
                        pos++;
                        return token = 41 /* PercentToken */;
                    case 38 /* ampersand */:
                        if (text.charCodeAt(pos + 1) === 38 /* ampersand */) {
                            return pos += 2, token = 52 /* AmpersandAmpersandToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 67 /* AmpersandEqualsToken */;
                        }
                        pos++;
                        return token = 47 /* AmpersandToken */;
                    case 40 /* openParen */:
                        pos++;
                        return token = 18 /* OpenParenToken */;
                    case 41 /* closeParen */:
                        pos++;
                        return token = 19 /* CloseParenToken */;
                    case 42 /* asterisk */:
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 60 /* AsteriskEqualsToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 42 /* asterisk */) {
                            if (text.charCodeAt(pos + 2) === 61 /* equals */) {
                                return pos += 3, token = 61 /* AsteriskAsteriskEqualsToken */;
                            }
                            return pos += 2, token = 39 /* AsteriskAsteriskToken */;
                        }
                        pos++;
                        return token = 38 /* AsteriskToken */;
                    case 43 /* plus */:
                        if (text.charCodeAt(pos + 1) === 43 /* plus */) {
                            return pos += 2, token = 42 /* PlusPlusToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 58 /* PlusEqualsToken */;
                        }
                        pos++;
                        return token = 36 /* PlusToken */;
                    case 44 /* comma */:
                        pos++;
                        return token = 25 /* CommaToken */;
                    case 45 /* minus */:
                        if (text.charCodeAt(pos + 1) === 45 /* minus */) {
                            return pos += 2, token = 43 /* MinusMinusToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 59 /* MinusEqualsToken */;
                        }
                        pos++;
                        return token = 37 /* MinusToken */;
                    case 46 /* dot */:
                        if (isDigit(text.charCodeAt(pos + 1))) {
                            tokenValue = scanNumber();
                            return token = 8 /* NumericLiteral */;
                        }
                        if (text.charCodeAt(pos + 1) === 46 /* dot */ && text.charCodeAt(pos + 2) === 46 /* dot */) {
                            return pos += 3, token = 23 /* DotDotDotToken */;
                        }
                        pos++;
                        return token = 22 /* DotToken */;
                    case 47 /* slash */:
                        // Single-line comment
                        if (text.charCodeAt(pos + 1) === 47 /* slash */) {
                            pos += 2;
                            while (pos < end) {
                                if (isLineBreak(text.charCodeAt(pos))) {
                                    break;
                                }
                                pos++;
                            }
                            if (skipTrivia) {
                                continue;
                            }
                            else {
                                return token = 2 /* SingleLineCommentTrivia */;
                            }
                        }
                        // Multi-line comment
                        if (text.charCodeAt(pos + 1) === 42 /* asterisk */) {
                            pos += 2;
                            var commentClosed = false;
                            while (pos < end) {
                                var ch_2 = text.charCodeAt(pos);
                                if (ch_2 === 42 /* asterisk */ && text.charCodeAt(pos + 1) === 47 /* slash */) {
                                    pos += 2;
                                    commentClosed = true;
                                    break;
                                }
                                if (isLineBreak(ch_2)) {
                                    precedingLineBreak = true;
                                }
                                pos++;
                            }
                            if (!commentClosed) {
                                error(ts.Diagnostics.Asterisk_Slash_expected);
                            }
                            if (skipTrivia) {
                                continue;
                            }
                            else {
                                tokenIsUnterminated = !commentClosed;
                                return token = 3 /* MultiLineCommentTrivia */;
                            }
                        }
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 62 /* SlashEqualsToken */;
                        }
                        pos++;
                        return token = 40 /* SlashToken */;
                    case 48 /* _0 */:
                        if (pos + 2 < end && (text.charCodeAt(pos + 1) === 88 /* X */ || text.charCodeAt(pos + 1) === 120 /* x */)) {
                            pos += 2;
                            var value = scanMinimumNumberOfHexDigits(1);
                            if (value < 0) {
                                error(ts.Diagnostics.Hexadecimal_digit_expected);
                                value = 0;
                            }
                            tokenValue = "" + value;
                            return token = 8 /* NumericLiteral */;
                        }
                        else if (pos + 2 < end && (text.charCodeAt(pos + 1) === 66 /* B */ || text.charCodeAt(pos + 1) === 98 /* b */)) {
                            pos += 2;
                            var value = scanBinaryOrOctalDigits(/* base */ 2);
                            if (value < 0) {
                                error(ts.Diagnostics.Binary_digit_expected);
                                value = 0;
                            }
                            tokenValue = "" + value;
                            return token = 8 /* NumericLiteral */;
                        }
                        else if (pos + 2 < end && (text.charCodeAt(pos + 1) === 79 /* O */ || text.charCodeAt(pos + 1) === 111 /* o */)) {
                            pos += 2;
                            var value = scanBinaryOrOctalDigits(/* base */ 8);
                            if (value < 0) {
                                error(ts.Diagnostics.Octal_digit_expected);
                                value = 0;
                            }
                            tokenValue = "" + value;
                            return token = 8 /* NumericLiteral */;
                        }
                        // Try to parse as an octal
                        if (pos + 1 < end && isOctalDigit(text.charCodeAt(pos + 1))) {
                            tokenValue = "" + scanOctalDigits();
                            return token = 8 /* NumericLiteral */;
                        }
                    // This fall-through is a deviation from the EcmaScript grammar. The grammar says that a leading zero
                    // can only be followed by an octal digit, a dot, or the end of the number literal. However, we are being
                    // permissive and allowing decimal digits of the form 08* and 09* (which many browsers also do).
                    case 49 /* _1 */:
                    case 50 /* _2 */:
                    case 51 /* _3 */:
                    case 52 /* _4 */:
                    case 53 /* _5 */:
                    case 54 /* _6 */:
                    case 55 /* _7 */:
                    case 56 /* _8 */:
                    case 57 /* _9 */:
                        tokenValue = scanNumber();
                        return token = 8 /* NumericLiteral */;
                    case 58 /* colon */:
                        pos++;
                        return token = 55 /* ColonToken */;
                    case 59 /* semicolon */:
                        pos++;
                        return token = 24 /* SemicolonToken */;
                    case 60 /* lessThan */:
                        if (isConflictMarkerTrivia(text, pos)) {
                            pos = scanConflictMarkerTrivia(text, pos, error);
                            if (skipTrivia) {
                                continue;
                            }
                            else {
                                return token = 7 /* ConflictMarkerTrivia */;
                            }
                        }
                        if (text.charCodeAt(pos + 1) === 60 /* lessThan */) {
                            if (text.charCodeAt(pos + 2) === 61 /* equals */) {
                                return pos += 3, token = 64 /* LessThanLessThanEqualsToken */;
                            }
                            return pos += 2, token = 44 /* LessThanLessThanToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 29 /* LessThanEqualsToken */;
                        }
                        if (languageVariant === 1 /* JSX */ &&
                            text.charCodeAt(pos + 1) === 47 /* slash */ &&
                            text.charCodeAt(pos + 2) !== 42 /* asterisk */) {
                            return pos += 2, token = 27 /* LessThanSlashToken */;
                        }
                        pos++;
                        return token = 26 /* LessThanToken */;
                    case 61 /* equals */:
                        if (isConflictMarkerTrivia(text, pos)) {
                            pos = scanConflictMarkerTrivia(text, pos, error);
                            if (skipTrivia) {
                                continue;
                            }
                            else {
                                return token = 7 /* ConflictMarkerTrivia */;
                            }
                        }
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            if (text.charCodeAt(pos + 2) === 61 /* equals */) {
                                return pos += 3, token = 33 /* EqualsEqualsEqualsToken */;
                            }
                            return pos += 2, token = 31 /* EqualsEqualsToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 62 /* greaterThan */) {
                            return pos += 2, token = 35 /* EqualsGreaterThanToken */;
                        }
                        pos++;
                        return token = 57 /* EqualsToken */;
                    case 62 /* greaterThan */:
                        if (isConflictMarkerTrivia(text, pos)) {
                            pos = scanConflictMarkerTrivia(text, pos, error);
                            if (skipTrivia) {
                                continue;
                            }
                            else {
                                return token = 7 /* ConflictMarkerTrivia */;
                            }
                        }
                        pos++;
                        return token = 28 /* GreaterThanToken */;
                    case 63 /* question */:
                        pos++;
                        return token = 54 /* QuestionToken */;
                    case 91 /* openBracket */:
                        pos++;
                        return token = 20 /* OpenBracketToken */;
                    case 93 /* closeBracket */:
                        pos++;
                        return token = 21 /* CloseBracketToken */;
                    case 94 /* caret */:
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 69 /* CaretEqualsToken */;
                        }
                        pos++;
                        return token = 49 /* CaretToken */;
                    case 123 /* openBrace */:
                        pos++;
                        return token = 16 /* OpenBraceToken */;
                    case 124 /* bar */:
                        if (text.charCodeAt(pos + 1) === 124 /* bar */) {
                            return pos += 2, token = 53 /* BarBarToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 68 /* BarEqualsToken */;
                        }
                        pos++;
                        return token = 48 /* BarToken */;
                    case 125 /* closeBrace */:
                        pos++;
                        return token = 17 /* CloseBraceToken */;
                    case 126 /* tilde */:
                        pos++;
                        return token = 51 /* TildeToken */;
                    case 64 /* at */:
                        pos++;
                        return token = 56 /* AtToken */;
                    case 92 /* backslash */:
                        var cookedChar = peekUnicodeEscape();
                        if (cookedChar >= 0 && isIdentifierStart(cookedChar, languageVersion)) {
                            pos += 6;
                            tokenValue = String.fromCharCode(cookedChar) + scanIdentifierParts();
                            return token = getIdentifierToken();
                        }
                        error(ts.Diagnostics.Invalid_character);
                        pos++;
                        return token = 0 /* Unknown */;
                    default:
                        if (isIdentifierStart(ch, languageVersion)) {
                            pos++;
                            while (pos < end && isIdentifierPart(ch = text.charCodeAt(pos), languageVersion))
                                pos++;
                            tokenValue = text.substring(tokenPos, pos);
                            if (ch === 92 /* backslash */) {
                                tokenValue += scanIdentifierParts();
                            }
                            return token = getIdentifierToken();
                        }
                        else if (isWhiteSpaceSingleLine(ch)) {
                            pos++;
                            continue;
                        }
                        else if (isLineBreak(ch)) {
                            precedingLineBreak = true;
                            pos++;
                            continue;
                        }
                        error(ts.Diagnostics.Invalid_character);
                        pos++;
                        return token = 0 /* Unknown */;
                }
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isDigit) id{6,1} ---
(ch) {
        return ch >= 48 /* _0 */ && ch <= 57 /* _9 */;
    }
--- END ---
INLINE (isDigit) id{6,1} AS 1 AT <0:6077>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIdentifierStart) id{6,2} ---
(ch, languageVersion) {
        return ch >= 65 /* A */ && ch <= 90 /* Z */ || ch >= 97 /* a */ && ch <= 122 /* z */ ||
            ch === 36 /* $ */ || ch === 95 /* _ */ ||
            ch > 127 /* maxAsciiCharacter */ && isUnicodeIdentifierStart(ch, languageVersion);
    }
--- END ---
INLINE (isIdentifierStart) id{6,2} AS 2 AT <0:17770>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIdentifierPart) id{6,3} ---
(ch, languageVersion) {
        return ch >= 65 /* A */ && ch <= 90 /* Z */ || ch >= 97 /* a */ && ch <= 122 /* z */ ||
            ch >= 48 /* _0 */ && ch <= 57 /* _9 */ || ch === 36 /* $ */ || ch === 95 /* _ */ ||
            ch > 127 /* maxAsciiCharacter */ && isUnicodeIdentifierPart(ch, languageVersion);
    }
--- END ---
INLINE (isIdentifierPart) id{6,3} AS 3 AT <0:17895>
[deoptimizing (DEOPT soft): begin 0x29cc38d46711 <JS Function scan (SharedFunctionInfo 0x16f3adb53cc1)> (opt #6) @9, FP to SP delta: 96, caller sp: 0x7fff5fbfde50]
            ;;; deoptimize at 2_135: Insufficient type feedback for combined type of binary operation
  reading input frame scan => node=4746, args=1, height=8; inputs:
      0: 0x29cc38d46711 ; [fp - 16] 0x29cc38d46711 <JS Function scan (SharedFunctionInfo 0x16f3adb53cc1)>
      1: 0x29cc38d467e9 ; [fp + 16] 0x29cc38d467e9 <an Object with map 0x33abe2a503e9>
      2: 0x29cc38d2b499 ; rax 0x29cc38d2b499 <FixedArray[39]>
      3: 0x30bcea4069a9 ; (literal 8) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      4: 95 ; r11 
      5: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
      6: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
      7: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
      9: 0x29cc38d2f169 ; rbx 0x29cc38d2f169 <JS Function isIdentifierStart (SharedFunctionInfo 0x3504a53ca859)>
  reading input frame isIdentifierStart => node=15, args=3, height=1; inputs:
      0: 0x29cc38d2f169 ; (literal 9) 0x29cc38d2f169 <JS Function isIdentifierStart (SharedFunctionInfo 0x3504a53ca859)>
      1: 0x1f9f6c0532e1 ; (literal 10) 0x1f9f6c0532e1 <JS Global Object>
      2: 95 ; r11 
      3: 0x30bcea404311 ; rdx 0x30bcea404311 <undefined>
      4: 0x29cc38d2a849 ; (literal 11) 0x29cc38d2a849 <FixedArray[37]>
  translating frame scan => node=4746, height=56
    0x7fff5fbfde48: [top + 88] <- 0x29cc38d467e9 ;  0x29cc38d467e9 <an Object with map 0x33abe2a503e9>  (input #1)
    0x7fff5fbfde40: [top + 80] <- 0x2c21d242b099 ;  caller's pc
    0x7fff5fbfde38: [top + 72] <- 0x7fff5fbfde68 ;  caller's fp
    0x7fff5fbfde30: [top + 64] <- 0x29cc38d2b499 ;  context    0x29cc38d2b499 <FixedArray[39]>  (input #2)
    0x7fff5fbfde28: [top + 56] <- 0x29cc38d46711 ;  function    0x29cc38d46711 <JS Function scan (SharedFunctionInfo 0x16f3adb53cc1)>  (input #0)
    0x7fff5fbfde20: [top + 48] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #3)
    0x7fff5fbfde18: [top + 40] <- 0x5f00000000 ;  95  (input #4)
    0x7fff5fbfde10: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfde08: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfde00: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfddf8: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfddf0: [top + 0] <- 0x29cc38d2f169 ;  0x29cc38d2f169 <JS Function isIdentifierStart (SharedFunctionInfo 0x3504a53ca859)>  (input #9)
  translating frame isIdentifierStart => node=15, height=0
    0x7fff5fbfdde8: [top + 48] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdde0: [top + 40] <- 0x5f00000000 ;  95  (input #2)
    0x7fff5fbfddd8: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #3)
    0x7fff5fbfddd0: [top + 24] <- 0x2c21d240d389 ;  caller's pc
    0x7fff5fbfddc8: [top + 16] <- 0x7fff5fbfde38 ;  caller's fp
    0x7fff5fbfddc0: [top + 8] <- 0x29cc38d2a849 ;  context    0x29cc38d2a849 <FixedArray[37]>  (input #4)
    0x7fff5fbfddb8: [top + 0] <- 0x29cc38d2f169 ;  function    0x29cc38d2f169 <JS Function isIdentifierStart (SharedFunctionInfo 0x3504a53ca859)>  (input #0)
[deoptimizing (soft): end 0x29cc38d46711 <JS Function scan (SharedFunctionInfo 0x16f3adb53cc1)> @9 => node=15, pc=0x2c21d240e208, caller sp=0x7fff5fbfde50, state=NO_REGISTERS, took 0.211 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:hasPrecedingLineBreak) id{7,0} ---
() { return precedingLineBreak; }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{8,0} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{8,1} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{8,1} AS 1 AT <0:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{8,2} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{8,2} AS 2 AT <0:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{8,3} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{8,3} AS 3 AT <0:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:finishNode) id{9,0} ---
(node, end) {
            node.end = end === undefined ? scanner.getStartPos() : end;
            if (contextFlags) {
                node.flags |= contextFlags;
            }
            // Keep track on the node if we encountered an error while parsing it.  If we did, then
            // we cannot reuse the node incrementally.  Once we've marked this node, clear out the
            // flag so that we don't mark any subsequent nodes.
            if (parseErrorBeforeNextFinishedNode) {
                parseErrorBeforeNextFinishedNode = false;
                node.flags |= 32768 /* ThisNodeHasError */;
            }
            return node;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:speculationHelper) id{10,0} ---
(callback, isLookAhead) {
            // Keep track of the state we'll need to rollback to if lookahead fails (or if the
            // caller asked us to always reset our state).
            var saveToken = currentToken;
            var saveParseDiagnosticsLength = parseDiagnostics.length;
            var saveParseErrorBeforeNextFinishedNode = parseErrorBeforeNextFinishedNode;
            // Note: it is not actually necessary to save/restore the context flags here.  That's
            // because the saving/restoring of these flags happens naturally through the recursive
            // descent nature of our parser.  However, we still store this here just so we can
            // assert that invariant holds.
            var saveContextFlags = contextFlags;
            // If we're only looking ahead, then tell the scanner to only lookahead as well.
            // Otherwise, if we're actually speculatively parsing, then tell the scanner to do the
            // same.
            var result = isLookAhead
                ? scanner.lookAhead(callback)
                : scanner.tryScan(callback);
            ts.Debug.assert(saveContextFlags === contextFlags);
            // If our callback returned something 'falsy' or we're just looking ahead,
            // then unconditionally restore us to where we were.
            if (!result || isLookAhead) {
                currentToken = saveToken;
                parseDiagnostics.length = saveParseDiagnosticsLength;
                parseErrorBeforeNextFinishedNode = saveParseErrorBeforeNextFinishedNode;
            }
            return result;
        }
--- END ---
--- FUNCTION SOURCE (native string.js:substring) id{11,0} ---
(L,M){
if((%IS_VAR(this)===null)||(this===(void 0)))throw %make_type_error(17,"String.prototype.subString");
var p=(%_ToString(this));
var Z=p.length;
var aa=(%_ToInteger(L));
if(aa<0){
aa=0;
}else if(aa>Z){
aa=Z;
}
var ab=Z;
if(!(M===(void 0))){
ab=(%_ToInteger(M));
if(ab>Z){
ab=Z;
}else{
if(ab<0)ab=0;
if(aa>ab){
var ah=ab;
ab=aa;
aa=ah;
}
}
}
return %_SubString(p,aa,ab);
}
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIdentifierToken) id{12,0} ---
() {
            // Reserved words are between 2 and 11 characters long and start with a lowercase letter
            var len = tokenValue.length;
            if (len >= 2 && len <= 11) {
                var ch = tokenValue.charCodeAt(0);
                if (ch >= 97 /* a */ && ch <= 122 /* z */ && hasOwnProperty.call(textToToken, tokenValue)) {
                    return token = textToToken[tokenValue];
                }
            }
            return token = 70 /* Identifier */;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createIdentifier) id{13,0} ---
(isIdentifier, diagnosticMessage) {
            identifierCount++;
            if (isIdentifier) {
                var node = createNode(70 /* Identifier */);
                // Store original token kind if it is not just an Identifier so we can report appropriate error later in type checker
                if (token() !== 70 /* Identifier */) {
                    node.originalKeywordKind = token();
                }
                node.text = internIdentifier(scanner.getTokenValue());
                nextToken();
                return finishNode(node);
            }
            return createMissingNode(70 /* Identifier */, /*reportAtCurrentPosition*/ false, diagnosticMessage || ts.Diagnostics.Identifier_expected);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{13,1} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{13,1} AS 1 AT <0:126>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{13,2} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{13,2} AS 2 AT <1:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{13,3} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{13,3} AS 3 AT <1:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{13,4} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{13,4} AS 4 AT <1:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{13,5} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{13,5} AS 5 AT <0:313>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{13,6} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{13,6} AS 6 AT <0:395>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:internIdentifier) id{13,7} ---
(text) {
            text = ts.escapeIdentifier(text);
            return identifiers[text] || (identifiers[text] = text);
        }
--- END ---
INLINE (internIdentifier) id{13,7} AS 7 AT <0:450>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{13,8} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{13,8} AS 8 AT <0:509>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTokenValue) id{14,0} ---
() { return tokenValue; }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:escapeIdentifier) id{15,0} ---
(identifier) {
        return identifier.length >= 2 && identifier.charCodeAt(0) === 95 /* _ */ && identifier.charCodeAt(1) === 95 /* _ */ ? "_" + identifier : identifier;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:scan) id{16,0} ---
() {
            startPos = pos;
            hasExtendedUnicodeEscape = false;
            precedingLineBreak = false;
            tokenIsUnterminated = false;
            while (true) {
                tokenPos = pos;
                if (pos >= end) {
                    return token = 1 /* EndOfFileToken */;
                }
                var ch = text.charCodeAt(pos);
                // Special handling for shebang
                if (ch === 35 /* hash */ && pos === 0 && isShebangTrivia(text, pos)) {
                    pos = scanShebangTrivia(text, pos);
                    if (skipTrivia) {
                        continue;
                    }
                    else {
                        return token = 6 /* ShebangTrivia */;
                    }
                }
                switch (ch) {
                    case 10 /* lineFeed */:
                    case 13 /* carriageReturn */:
                        precedingLineBreak = true;
                        if (skipTrivia) {
                            pos++;
                            continue;
                        }
                        else {
                            if (ch === 13 /* carriageReturn */ && pos + 1 < end && text.charCodeAt(pos + 1) === 10 /* lineFeed */) {
                                // consume both CR and LF
                                pos += 2;
                            }
                            else {
                                pos++;
                            }
                            return token = 4 /* NewLineTrivia */;
                        }
                    case 9 /* tab */:
                    case 11 /* verticalTab */:
                    case 12 /* formFeed */:
                    case 32 /* space */:
                        if (skipTrivia) {
                            pos++;
                            continue;
                        }
                        else {
                            while (pos < end && isWhiteSpaceSingleLine(text.charCodeAt(pos))) {
                                pos++;
                            }
                            return token = 5 /* WhitespaceTrivia */;
                        }
                    case 33 /* exclamation */:
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            if (text.charCodeAt(pos + 2) === 61 /* equals */) {
                                return pos += 3, token = 34 /* ExclamationEqualsEqualsToken */;
                            }
                            return pos += 2, token = 32 /* ExclamationEqualsToken */;
                        }
                        pos++;
                        return token = 50 /* ExclamationToken */;
                    case 34 /* doubleQuote */:
                    case 39 /* singleQuote */:
                        tokenValue = scanString();
                        return token = 9 /* StringLiteral */;
                    case 96 /* backtick */:
                        return token = scanTemplateAndSetTokenValue();
                    case 37 /* percent */:
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 63 /* PercentEqualsToken */;
                        }
                        pos++;
                        return token = 41 /* PercentToken */;
                    case 38 /* ampersand */:
                        if (text.charCodeAt(pos + 1) === 38 /* ampersand */) {
                            return pos += 2, token = 52 /* AmpersandAmpersandToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 67 /* AmpersandEqualsToken */;
                        }
                        pos++;
                        return token = 47 /* AmpersandToken */;
                    case 40 /* openParen */:
                        pos++;
                        return token = 18 /* OpenParenToken */;
                    case 41 /* closeParen */:
                        pos++;
                        return token = 19 /* CloseParenToken */;
                    case 42 /* asterisk */:
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 60 /* AsteriskEqualsToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 42 /* asterisk */) {
                            if (text.charCodeAt(pos + 2) === 61 /* equals */) {
                                return pos += 3, token = 61 /* AsteriskAsteriskEqualsToken */;
                            }
                            return pos += 2, token = 39 /* AsteriskAsteriskToken */;
                        }
                        pos++;
                        return token = 38 /* AsteriskToken */;
                    case 43 /* plus */:
                        if (text.charCodeAt(pos + 1) === 43 /* plus */) {
                            return pos += 2, token = 42 /* PlusPlusToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 58 /* PlusEqualsToken */;
                        }
                        pos++;
                        return token = 36 /* PlusToken */;
                    case 44 /* comma */:
                        pos++;
                        return token = 25 /* CommaToken */;
                    case 45 /* minus */:
                        if (text.charCodeAt(pos + 1) === 45 /* minus */) {
                            return pos += 2, token = 43 /* MinusMinusToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 59 /* MinusEqualsToken */;
                        }
                        pos++;
                        return token = 37 /* MinusToken */;
                    case 46 /* dot */:
                        if (isDigit(text.charCodeAt(pos + 1))) {
                            tokenValue = scanNumber();
                            return token = 8 /* NumericLiteral */;
                        }
                        if (text.charCodeAt(pos + 1) === 46 /* dot */ && text.charCodeAt(pos + 2) === 46 /* dot */) {
                            return pos += 3, token = 23 /* DotDotDotToken */;
                        }
                        pos++;
                        return token = 22 /* DotToken */;
                    case 47 /* slash */:
                        // Single-line comment
                        if (text.charCodeAt(pos + 1) === 47 /* slash */) {
                            pos += 2;
                            while (pos < end) {
                                if (isLineBreak(text.charCodeAt(pos))) {
                                    break;
                                }
                                pos++;
                            }
                            if (skipTrivia) {
                                continue;
                            }
                            else {
                                return token = 2 /* SingleLineCommentTrivia */;
                            }
                        }
                        // Multi-line comment
                        if (text.charCodeAt(pos + 1) === 42 /* asterisk */) {
                            pos += 2;
                            var commentClosed = false;
                            while (pos < end) {
                                var ch_2 = text.charCodeAt(pos);
                                if (ch_2 === 42 /* asterisk */ && text.charCodeAt(pos + 1) === 47 /* slash */) {
                                    pos += 2;
                                    commentClosed = true;
                                    break;
                                }
                                if (isLineBreak(ch_2)) {
                                    precedingLineBreak = true;
                                }
                                pos++;
                            }
                            if (!commentClosed) {
                                error(ts.Diagnostics.Asterisk_Slash_expected);
                            }
                            if (skipTrivia) {
                                continue;
                            }
                            else {
                                tokenIsUnterminated = !commentClosed;
                                return token = 3 /* MultiLineCommentTrivia */;
                            }
                        }
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 62 /* SlashEqualsToken */;
                        }
                        pos++;
                        return token = 40 /* SlashToken */;
                    case 48 /* _0 */:
                        if (pos + 2 < end && (text.charCodeAt(pos + 1) === 88 /* X */ || text.charCodeAt(pos + 1) === 120 /* x */)) {
                            pos += 2;
                            var value = scanMinimumNumberOfHexDigits(1);
                            if (value < 0) {
                                error(ts.Diagnostics.Hexadecimal_digit_expected);
                                value = 0;
                            }
                            tokenValue = "" + value;
                            return token = 8 /* NumericLiteral */;
                        }
                        else if (pos + 2 < end && (text.charCodeAt(pos + 1) === 66 /* B */ || text.charCodeAt(pos + 1) === 98 /* b */)) {
                            pos += 2;
                            var value = scanBinaryOrOctalDigits(/* base */ 2);
                            if (value < 0) {
                                error(ts.Diagnostics.Binary_digit_expected);
                                value = 0;
                            }
                            tokenValue = "" + value;
                            return token = 8 /* NumericLiteral */;
                        }
                        else if (pos + 2 < end && (text.charCodeAt(pos + 1) === 79 /* O */ || text.charCodeAt(pos + 1) === 111 /* o */)) {
                            pos += 2;
                            var value = scanBinaryOrOctalDigits(/* base */ 8);
                            if (value < 0) {
                                error(ts.Diagnostics.Octal_digit_expected);
                                value = 0;
                            }
                            tokenValue = "" + value;
                            return token = 8 /* NumericLiteral */;
                        }
                        // Try to parse as an octal
                        if (pos + 1 < end && isOctalDigit(text.charCodeAt(pos + 1))) {
                            tokenValue = "" + scanOctalDigits();
                            return token = 8 /* NumericLiteral */;
                        }
                    // This fall-through is a deviation from the EcmaScript grammar. The grammar says that a leading zero
                    // can only be followed by an octal digit, a dot, or the end of the number literal. However, we are being
                    // permissive and allowing decimal digits of the form 08* and 09* (which many browsers also do).
                    case 49 /* _1 */:
                    case 50 /* _2 */:
                    case 51 /* _3 */:
                    case 52 /* _4 */:
                    case 53 /* _5 */:
                    case 54 /* _6 */:
                    case 55 /* _7 */:
                    case 56 /* _8 */:
                    case 57 /* _9 */:
                        tokenValue = scanNumber();
                        return token = 8 /* NumericLiteral */;
                    case 58 /* colon */:
                        pos++;
                        return token = 55 /* ColonToken */;
                    case 59 /* semicolon */:
                        pos++;
                        return token = 24 /* SemicolonToken */;
                    case 60 /* lessThan */:
                        if (isConflictMarkerTrivia(text, pos)) {
                            pos = scanConflictMarkerTrivia(text, pos, error);
                            if (skipTrivia) {
                                continue;
                            }
                            else {
                                return token = 7 /* ConflictMarkerTrivia */;
                            }
                        }
                        if (text.charCodeAt(pos + 1) === 60 /* lessThan */) {
                            if (text.charCodeAt(pos + 2) === 61 /* equals */) {
                                return pos += 3, token = 64 /* LessThanLessThanEqualsToken */;
                            }
                            return pos += 2, token = 44 /* LessThanLessThanToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 29 /* LessThanEqualsToken */;
                        }
                        if (languageVariant === 1 /* JSX */ &&
                            text.charCodeAt(pos + 1) === 47 /* slash */ &&
                            text.charCodeAt(pos + 2) !== 42 /* asterisk */) {
                            return pos += 2, token = 27 /* LessThanSlashToken */;
                        }
                        pos++;
                        return token = 26 /* LessThanToken */;
                    case 61 /* equals */:
                        if (isConflictMarkerTrivia(text, pos)) {
                            pos = scanConflictMarkerTrivia(text, pos, error);
                            if (skipTrivia) {
                                continue;
                            }
                            else {
                                return token = 7 /* ConflictMarkerTrivia */;
                            }
                        }
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            if (text.charCodeAt(pos + 2) === 61 /* equals */) {
                                return pos += 3, token = 33 /* EqualsEqualsEqualsToken */;
                            }
                            return pos += 2, token = 31 /* EqualsEqualsToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 62 /* greaterThan */) {
                            return pos += 2, token = 35 /* EqualsGreaterThanToken */;
                        }
                        pos++;
                        return token = 57 /* EqualsToken */;
                    case 62 /* greaterThan */:
                        if (isConflictMarkerTrivia(text, pos)) {
                            pos = scanConflictMarkerTrivia(text, pos, error);
                            if (skipTrivia) {
                                continue;
                            }
                            else {
                                return token = 7 /* ConflictMarkerTrivia */;
                            }
                        }
                        pos++;
                        return token = 28 /* GreaterThanToken */;
                    case 63 /* question */:
                        pos++;
                        return token = 54 /* QuestionToken */;
                    case 91 /* openBracket */:
                        pos++;
                        return token = 20 /* OpenBracketToken */;
                    case 93 /* closeBracket */:
                        pos++;
                        return token = 21 /* CloseBracketToken */;
                    case 94 /* caret */:
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 69 /* CaretEqualsToken */;
                        }
                        pos++;
                        return token = 49 /* CaretToken */;
                    case 123 /* openBrace */:
                        pos++;
                        return token = 16 /* OpenBraceToken */;
                    case 124 /* bar */:
                        if (text.charCodeAt(pos + 1) === 124 /* bar */) {
                            return pos += 2, token = 53 /* BarBarToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 68 /* BarEqualsToken */;
                        }
                        pos++;
                        return token = 48 /* BarToken */;
                    case 125 /* closeBrace */:
                        pos++;
                        return token = 17 /* CloseBraceToken */;
                    case 126 /* tilde */:
                        pos++;
                        return token = 51 /* TildeToken */;
                    case 64 /* at */:
                        pos++;
                        return token = 56 /* AtToken */;
                    case 92 /* backslash */:
                        var cookedChar = peekUnicodeEscape();
                        if (cookedChar >= 0 && isIdentifierStart(cookedChar, languageVersion)) {
                            pos += 6;
                            tokenValue = String.fromCharCode(cookedChar) + scanIdentifierParts();
                            return token = getIdentifierToken();
                        }
                        error(ts.Diagnostics.Invalid_character);
                        pos++;
                        return token = 0 /* Unknown */;
                    default:
                        if (isIdentifierStart(ch, languageVersion)) {
                            pos++;
                            while (pos < end && isIdentifierPart(ch = text.charCodeAt(pos), languageVersion))
                                pos++;
                            tokenValue = text.substring(tokenPos, pos);
                            if (ch === 92 /* backslash */) {
                                tokenValue += scanIdentifierParts();
                            }
                            return token = getIdentifierToken();
                        }
                        else if (isWhiteSpaceSingleLine(ch)) {
                            pos++;
                            continue;
                        }
                        else if (isLineBreak(ch)) {
                            precedingLineBreak = true;
                            pos++;
                            continue;
                        }
                        error(ts.Diagnostics.Invalid_character);
                        pos++;
                        return token = 0 /* Unknown */;
                }
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isDigit) id{16,1} ---
(ch) {
        return ch >= 48 /* _0 */ && ch <= 57 /* _9 */;
    }
--- END ---
INLINE (isDigit) id{16,1} AS 1 AT <0:6077>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIdentifierStart) id{16,2} ---
(ch, languageVersion) {
        return ch >= 65 /* A */ && ch <= 90 /* Z */ || ch >= 97 /* a */ && ch <= 122 /* z */ ||
            ch === 36 /* $ */ || ch === 95 /* _ */ ||
            ch > 127 /* maxAsciiCharacter */ && isUnicodeIdentifierStart(ch, languageVersion);
    }
--- END ---
INLINE (isIdentifierStart) id{16,2} AS 2 AT <0:17770>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIdentifierPart) id{16,3} ---
(ch, languageVersion) {
        return ch >= 65 /* A */ && ch <= 90 /* Z */ || ch >= 97 /* a */ && ch <= 122 /* z */ ||
            ch >= 48 /* _0 */ && ch <= 57 /* _9 */ || ch === 36 /* $ */ || ch === 95 /* _ */ ||
            ch > 127 /* maxAsciiCharacter */ && isUnicodeIdentifierPart(ch, languageVersion);
    }
--- END ---
INLINE (isIdentifierPart) id{16,3} AS 3 AT <0:17895>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextJSDocToken) id{17,0} ---
() {
                    return currentToken = scanner.scanJSDocToken();
                }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTokenText) id{18,0} ---
() { return text.substring(tokenPos, pos); }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseIdentifier) id{19,0} ---
(diagnosticMessage) {
            return createIdentifier(isIdentifier(), diagnosticMessage);
        }
--- END ---
--- FUNCTION SOURCE (native array.js:ConvertToString) id{20,0} ---
(A,O){
if((O==null))return'';
return(%_ToString(A?O.toLocaleString():O));
}
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseListElement) id{21,0} ---
(parsingContext, parseElement) {
            var node = currentNode(parsingContext);
            if (node) {
                return consumeNode(node);
            }
            return parseElement();
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isWhiteSpaceSingleLine) id{22,0} ---
(ch) {
        // Note: nextLine is in the Zs space, and should be considered to be a whitespace.
        // It is explicitly not a line-break as it isn't in the exact set specified by EcmaScript.
        return ch === 32 /* space */ ||
            ch === 9 /* tab */ ||
            ch === 11 /* verticalTab */ ||
            ch === 12 /* formFeed */ ||
            ch === 160 /* nonBreakingSpace */ ||
            ch === 133 /* nextLine */ ||
            ch === 5760 /* ogham */ ||
            ch >= 8192 /* enQuad */ && ch <= 8203 /* zeroWidthSpace */ ||
            ch === 8239 /* narrowNoBreakSpace */ ||
            ch === 8287 /* mathematicalSpace */ ||
            ch === 12288 /* ideographicSpace */ ||
            ch === 65279 /* byteOrderMark */;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIdentifier) id{23,0} ---
() {
            if (token() === 70 /* Identifier */) {
                return true;
            }
            // If we have a 'yield' keyword, and we're in the [yield] context, then 'yield' is
            // considered a keyword and is not an identifier.
            if (token() === 115 /* YieldKeyword */ && inYieldContext()) {
                return false;
            }
            // If we have a 'await' keyword, and we're in the [Await] context, then 'await' is
            // considered a keyword and is not an identifier.
            if (token() === 120 /* AwaitKeyword */ && inAwaitContext()) {
                return false;
            }
            return token() > 106 /* LastReservedWord */;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{23,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{23,1} AS 1 AT <0:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{23,2} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{23,2} AS 2 AT <0:272>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{23,3} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{23,3} AS 3 AT <0:547>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{23,4} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{23,4} AS 4 AT <0:668>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIdentifierStart) id{24,0} ---
(ch, languageVersion) {
        return ch >= 65 /* A */ && ch <= 90 /* Z */ || ch >= 97 /* a */ && ch <= 122 /* z */ ||
            ch === 36 /* $ */ || ch === 95 /* _ */ ||
            ch > 127 /* maxAsciiCharacter */ && isUnicodeIdentifierStart(ch, languageVersion);
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:pushComment) id{25,0} ---
(text) {
                        if (!margin) {
                            margin = indent;
                        }
                        comments.push(text);
                        indent += text.length;
                    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getLeadingCommentRanges) id{26,0} ---
(text, pos) {
        return reduceEachLeadingCommentRange(text, pos, appendCommentRange, undefined, undefined);
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:reduceEachLeadingCommentRange) id{26,1} ---
(text, pos, cb, state, initial) {
        return iterateCommentRanges(/*reduce*/ true, text, pos, /*trailing*/ false, cb, state, initial);
    }
--- END ---
INLINE (reduceEachLeadingCommentRange) id{26,1} AS 1 AT <0:29>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:iterateCommentRanges) id{27,0} ---
(reduce, text, pos, trailing, cb, state, initial) {
        var pendingPos;
        var pendingEnd;
        var pendingKind;
        var pendingHasTrailingNewLine;
        var hasPendingCommentRange = false;
        var collecting = trailing || pos === 0;
        var accumulator = initial;
        scan: while (pos >= 0 && pos < text.length) {
            var ch = text.charCodeAt(pos);
            switch (ch) {
                case 13 /* carriageReturn */:
                    if (text.charCodeAt(pos + 1) === 10 /* lineFeed */) {
                        pos++;
                    }
                case 10 /* lineFeed */:
                    pos++;
                    if (trailing) {
                        break scan;
                    }
                    collecting = true;
                    if (hasPendingCommentRange) {
                        pendingHasTrailingNewLine = true;
                    }
                    continue;
                case 9 /* tab */:
                case 11 /* verticalTab */:
                case 12 /* formFeed */:
                case 32 /* space */:
                    pos++;
                    continue;
                case 47 /* slash */:
                    var nextChar = text.charCodeAt(pos + 1);
                    var hasTrailingNewLine = false;
                    if (nextChar === 47 /* slash */ || nextChar === 42 /* asterisk */) {
                        var kind = nextChar === 47 /* slash */ ? 2 /* SingleLineCommentTrivia */ : 3 /* MultiLineCommentTrivia */;
                        var startPos = pos;
                        pos += 2;
                        if (nextChar === 47 /* slash */) {
                            while (pos < text.length) {
                                if (isLineBreak(text.charCodeAt(pos))) {
                                    hasTrailingNewLine = true;
                                    break;
                                }
                                pos++;
                            }
                        }
                        else {
                            while (pos < text.length) {
                                if (text.charCodeAt(pos) === 42 /* asterisk */ && text.charCodeAt(pos + 1) === 47 /* slash */) {
                                    pos += 2;
                                    break;
                                }
                                pos++;
                            }
                        }
                        if (collecting) {
                            if (hasPendingCommentRange) {
                                accumulator = cb(pendingPos, pendingEnd, pendingKind, pendingHasTrailingNewLine, state, accumulator);
                                if (!reduce && accumulator) {
                                    // If we are not reducing and we have a truthy result, return it.
                                    return accumulator;
                                }
                                hasPendingCommentRange = false;
                            }
                            pendingPos = startPos;
                            pendingEnd = pos;
                            pendingKind = kind;
                            pendingHasTrailingNewLine = hasTrailingNewLine;
                            hasPendingCommentRange = true;
                        }
                        continue;
                    }
                    break scan;
                default:
                    if (ch > 127 /* maxAsciiCharacter */ && (isWhiteSpace(ch))) {
                        if (hasPendingCommentRange && isLineBreak(ch)) {
                            pendingHasTrailingNewLine = true;
                        }
                        pos++;
                        continue;
                    }
                    break scan;
            }
        }
        if (hasPendingCommentRange) {
            accumulator = cb(pendingPos, pendingEnd, pendingKind, pendingHasTrailingNewLine, state, accumulator);
        }
        return accumulator;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:appendCommentRange) id{27,1} ---
(pos, end, kind, hasTrailingNewLine, _state, comments) {
        if (!comments) {
            comments = [];
        }
        comments.push({ pos: pos, end: end, hasTrailingNewLine: hasTrailingNewLine, kind: kind });
        return comments;
    }
--- END ---
INLINE (appendCommentRange) id{27,1} AS 1 AT <0:2609>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:appendCommentRange) id{27,2} ---
(pos, end, kind, hasTrailingNewLine, _state, comments) {
        if (!comments) {
            comments = [];
        }
        comments.push({ pos: pos, end: end, hasTrailingNewLine: hasTrailingNewLine, kind: kind });
        return comments;
    }
--- END ---
INLINE (appendCommentRange) id{27,2} AS 2 AT <0:3914>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:tryParse) id{28,0} ---
(callback) {
            return speculationHelper(callback, /*isLookAhead*/ false);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseIntersectionTypeOrHigher) id{29,0} ---
() {
            return parseUnionOrIntersectionType(165 /* IntersectionType */, parseTypeOperatorOrHigher, 47 /* AmpersandToken */);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseUnionOrIntersectionType) id{29,1} ---
(kind, parseConstituentType, operator) {
            parseOptional(operator);
            var type = parseConstituentType();
            if (token() === operator) {
                var types = createNodeArray([type], type.pos);
                while (parseOptional(operator)) {
                    types.push(parseConstituentType());
                }
                types.end = getNodeEnd();
                var node = createNode(kind, type.pos);
                node.types = types;
                type = finishNode(node);
            }
            return type;
        }
--- END ---
INLINE (parseUnionOrIntersectionType) id{29,1} AS 1 AT <0:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseOptional) id{29,2} ---
(t) {
            if (token() === t) {
                nextToken();
                return true;
            }
            return false;
        }
--- END ---
INLINE (parseOptional) id{29,2} AS 2 AT <1:53>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{29,3} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{29,3} AS 3 AT <2:22>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{29,4} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{29,4} AS 4 AT <2:55>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{29,5} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{29,5} AS 5 AT <1:141>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNodeArray) id{29,6} ---
(elements, pos) {
            var array = (elements || []);
            if (!(pos >= 0)) {
                pos = getNodePos();
            }
            array.pos = pos;
            array.end = pos;
            return array;
        }
--- END ---
INLINE (createNodeArray) id{29,6} AS 6 AT <1:193>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodePos) id{29,7} ---
() {
            return scanner.getStartPos();
        }
--- END ---
INLINE (getNodePos) id{29,7} AS 7 AT <6:113>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseOptional) id{29,8} ---
(t) {
            if (token() === t) {
                nextToken();
                return true;
            }
            return false;
        }
--- END ---
INLINE (parseOptional) id{29,8} AS 8 AT <1:251>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{29,9} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{29,9} AS 9 AT <8:22>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{29,10} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{29,10} AS 10 AT <8:55>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeEnd) id{29,11} ---
() {
            return scanner.getStartPos();
        }
--- END ---
INLINE (getNodeEnd) id{29,11} AS 11 AT <1:380>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{29,12} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{29,12} AS 12 AT <1:421>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{29,13} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{29,13} AS 13 AT <12:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{29,14} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{29,14} AS 14 AT <12:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{29,15} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{29,15} AS 15 AT <12:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseTypeOperatorOrHigher) id{30,0} ---
() {
            switch (token()) {
                case 126 /* KeyOfKeyword */:
                    return parseTypeOperator(126 /* KeyOfKeyword */);
            }
            return parseArrayTypeOrHigher();
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{30,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{30,1} AS 1 AT <0:25>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isStartOfFunctionType) id{31,0} ---
() {
            if (token() === 26 /* LessThanToken */) {
                return true;
            }
            return token() === 18 /* OpenParenToken */ && lookAhead(isUnambiguouslyStartOfFunctionType);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{31,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{31,1} AS 1 AT <0:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{31,2} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{31,2} AS 2 AT <0:121>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:lookAhead) id{31,3} ---
(callback) {
            return speculationHelper(callback, /*isLookAhead*/ true);
        }
--- END ---
INLINE (lookAhead) id{31,3} AS 3 AT <0:160>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseType) id{32,0} ---
() {
            // The rules about 'yield' only apply to actual code/expression contexts.  They don't
            // apply to 'type' contexts.  So we disable these parameters here before moving on.
            return doOutsideOfContext(20480 /* TypeExcludesFlags */, parseTypeWorker);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:doOutsideOfContext) id{33,0} ---
(context, func) {
            // contextFlagsToClear will contain only the context flags that are
            // currently set that we need to temporarily clear
            // We don't just blindly reset to the previous flags to ensure
            // that we do not mutate cached flags for the incremental
            // parser (ThisNodeHasError, ThisNodeOrAnySubNodesHasError, and
            // HasAggregatedChildData).
            var contextFlagsToClear = context & contextFlags;
            if (contextFlagsToClear) {
                // clear the requested context flags
                setContextFlag(/*val*/ false, contextFlagsToClear);
                var result = func();
                // restore the context flags we just cleared
                setContextFlag(/*val*/ true, contextFlagsToClear);
                return result;
            }
            // no need to do anything special as we are not in any of the requested contexts
            return func();
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseTypeWorker) id{33,1} ---
() {
            if (isStartOfFunctionType()) {
                return parseFunctionOrConstructorType(158 /* FunctionType */);
            }
            if (token() === 93 /* NewKeyword */) {
                return parseFunctionOrConstructorType(159 /* ConstructorType */);
            }
            return parseUnionTypeOrHigher();
        }
--- END ---
INLINE (parseTypeWorker) id{33,1} AS 1 AT <0:966>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isStartOfFunctionType) id{33,2} ---
() {
            if (token() === 26 /* LessThanToken */) {
                return true;
            }
            return token() === 18 /* OpenParenToken */ && lookAhead(isUnambiguouslyStartOfFunctionType);
        }
--- END ---
INLINE (isStartOfFunctionType) id{33,2} AS 2 AT <1:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{33,3} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{33,3} AS 3 AT <2:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{33,4} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{33,4} AS 4 AT <2:121>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:lookAhead) id{33,5} ---
(callback) {
            return speculationHelper(callback, /*isLookAhead*/ true);
        }
--- END ---
INLINE (lookAhead) id{33,5} AS 5 AT <2:160>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseFunctionOrConstructorType) id{33,6} ---
(kind) {
            var node = createNode(kind);
            if (kind === 159 /* ConstructorType */) {
                parseExpected(93 /* NewKeyword */);
            }
            fillSignature(35 /* EqualsGreaterThanToken */, /*yieldContext*/ false, /*awaitContext*/ false, /*requireCompleteParameterList*/ false, node);
            return finishNode(node);
        }
--- END ---
INLINE (parseFunctionOrConstructorType) id{33,6} AS 6 AT <1:71>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{33,7} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{33,7} AS 7 AT <6:32>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{33,8} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{33,8} AS 8 AT <7:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{33,9} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{33,9} AS 9 AT <7:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{33,10} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{33,10} AS 10 AT <7:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{33,11} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{33,11} AS 11 AT <1:157>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseUnionTypeOrHigher) id{33,12} ---
() {
            return parseUnionOrIntersectionType(164 /* UnionType */, parseIntersectionTypeOrHigher, 48 /* BarToken */);
        }
--- END ---
INLINE (parseUnionTypeOrHigher) id{33,12} AS 12 AT <1:307>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseUnionOrIntersectionType) id{33,13} ---
(kind, parseConstituentType, operator) {
            parseOptional(operator);
            var type = parseConstituentType();
            if (token() === operator) {
                var types = createNodeArray([type], type.pos);
                while (parseOptional(operator)) {
                    types.push(parseConstituentType());
                }
                types.end = getNodeEnd();
                var node = createNode(kind, type.pos);
                node.types = types;
                type = finishNode(node);
            }
            return type;
        }
--- END ---
INLINE (parseUnionOrIntersectionType) id{33,13} AS 13 AT <12:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseOptional) id{33,14} ---
(t) {
            if (token() === t) {
                nextToken();
                return true;
            }
            return false;
        }
--- END ---
INLINE (parseOptional) id{33,14} AS 14 AT <13:53>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{33,15} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{33,15} AS 15 AT <14:22>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{33,16} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{33,16} AS 16 AT <14:55>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{33,17} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{33,17} AS 17 AT <13:141>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNodeArray) id{33,18} ---
(elements, pos) {
            var array = (elements || []);
            if (!(pos >= 0)) {
                pos = getNodePos();
            }
            array.pos = pos;
            array.end = pos;
            return array;
        }
--- END ---
INLINE (createNodeArray) id{33,18} AS 18 AT <13:193>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodePos) id{33,19} ---
() {
            return scanner.getStartPos();
        }
--- END ---
INLINE (getNodePos) id{33,19} AS 19 AT <18:113>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseOptional) id{33,20} ---
(t) {
            if (token() === t) {
                nextToken();
                return true;
            }
            return false;
        }
--- END ---
INLINE (parseOptional) id{33,20} AS 20 AT <13:251>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{33,21} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{33,21} AS 21 AT <20:22>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{33,22} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{33,22} AS 22 AT <20:55>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseIntersectionTypeOrHigher) id{33,23} ---
() {
            return parseUnionOrIntersectionType(165 /* IntersectionType */, parseTypeOperatorOrHigher, 47 /* AmpersandToken */);
        }
--- END ---
INLINE (parseIntersectionTypeOrHigher) id{33,23} AS 23 AT <13:309>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeEnd) id{33,24} ---
() {
            return scanner.getStartPos();
        }
--- END ---
INLINE (getNodeEnd) id{33,24} AS 24 AT <13:380>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{33,25} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{33,25} AS 25 AT <13:421>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{33,26} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{33,26} AS 26 AT <25:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{33,27} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{33,27} AS 27 AT <25:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{33,28} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{33,28} AS 28 AT <25:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTokenPos) id{34,0} ---
() { return tokenPos; }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenOrIdentifierObject) id{35,0} ---
(pos, end) {
            // Set properties in same order as NodeObject
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.parent = undefined;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:pushComment) id{36,0} ---
(text) {
                        if (!margin) {
                            margin = indent;
                        }
                        comments.push(text);
                        indent += text.length;
                    }
--- END ---
[deoptimizing (DEOPT eager): begin 0x29cc38d46c01 <JS Function doOutsideOfContext (SharedFunctionInfo 0x3504a53f1271)> (opt #33) @20, FP to SP delta: 248, caller sp: 0x7fff5fbfd678]
            ;;; deoptimize at 13_221: wrong map
  reading input frame doOutsideOfContext => node=94, args=3, height=4; inputs:
      0: 0x29cc38d46c01 ; [fp - 16] 0x29cc38d46c01 <JS Function doOutsideOfContext (SharedFunctionInfo 0x3504a53f1271)>
      1: 0x1f9f6c0532e1 ; [fp + 32] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x500000000000 ; [fp + 24] 20480
      3: 0x29cc38d49361 ; [fp + 16] 0x29cc38d49361 <JS Function parseTypeWorker (SharedFunctionInfo 0x3504a53f7b71)>
      4: 0x29cc38d2b619 ; [fp - 24] 0x29cc38d2b619 <FixedArray[334]>
      5: 0x30bcea4069a9 ; (literal 36) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      6: 0x30bcea404311 ; (literal 35) 0x30bcea404311 <undefined>
      7: 0x29cc38d49361 ; [fp + 16] 0x29cc38d49361 <JS Function parseTypeWorker (SharedFunctionInfo 0x3504a53f7b71)>
  reading input frame parseTypeWorker => node=67, args=1, height=2; inputs:
      0: 0x29cc38d49361 ; (literal 37) 0x29cc38d49361 <JS Function parseTypeWorker (SharedFunctionInfo 0x3504a53f7b71)>
      1: 0x1f9f6c0532e1 ; (literal 38) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x29cc38d2b619 ; (literal 39) 0x29cc38d2b619 <FixedArray[334]>
      3: 0x29cc38d49169 ; [fp - 56] 0x29cc38d49169 <JS Function parseUnionTypeOrHigher (SharedFunctionInfo 0x3504a53f7631)>
  reading input frame parseUnionTypeOrHigher => node=7, args=1, height=2; inputs:
      0: 0x29cc38d49169 ; (literal 42) 0x29cc38d49169 <JS Function parseUnionTypeOrHigher (SharedFunctionInfo 0x3504a53f7631)>
      1: 0x1f9f6c0532e1 ; (literal 38) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x29cc38d2b619 ; (literal 39) 0x29cc38d2b619 <FixedArray[334]>
      3: 0x29cc38d490d9 ; [fp - 64] 0x29cc38d490d9 <JS Function parseUnionOrIntersectionType (SharedFunctionInfo 0x3504a53f74b1)>
  reading input frame parseUnionOrIntersectionType => node=88, args=4, height=7; inputs:
      0: 0x29cc38d490d9 ; (literal 43) 0x29cc38d490d9 <JS Function parseUnionOrIntersectionType (SharedFunctionInfo 0x3504a53f74b1)>
      1: 0x1f9f6c0532e1 ; (literal 38) 0x1f9f6c0532e1 <JS Global Object>
      2: 0xa400000000 ; (literal 44) 164
      3: 0x29cc38d49121 ; [fp - 72] 0x29cc38d49121 <JS Function parseIntersectionTypeOrHigher (SharedFunctionInfo 0x3504a53f7571)>
      4: 0x3000000000 ; (literal 45) 48
      5: 0x29cc38d2b619 ; (literal 39) 0x29cc38d2b619 <FixedArray[334]>
      6: 0x19a2de385679 ; rbx 0x19a2de385679 <a TokenObject with map 0x33abe2a67411>
      7: 0x30bcea404311 ; (literal 35) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; (literal 35) 0x30bcea404311 <undefined>
      9: 0x29cc38d476f9 ; rdx 0x29cc38d476f9 <JS Function createNodeArray (SharedFunctionInfo 0x3504a53f2fb1)>
     10: 0x30bcea404311 ; (literal 35) 0x30bcea404311 <undefined>
     11: 0x19a2de3856b9 ; rcx 0x19a2de3856b9 <JS Array[1]>
  translating frame doOutsideOfContext => node=94, height=24
    0x7fff5fbfd670: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd668: [top + 64] <- 0x500000000000 ;  20480  (input #2)
    0x7fff5fbfd660: [top + 56] <- 0x29cc38d49361 ;  0x29cc38d49361 <JS Function parseTypeWorker (SharedFunctionInfo 0x3504a53f7b71)>  (input #3)
    0x7fff5fbfd658: [top + 48] <- 0x2c21d246127e ;  caller's pc
    0x7fff5fbfd650: [top + 40] <- 0x7fff5fbfd690 ;  caller's fp
    0x7fff5fbfd648: [top + 32] <- 0x29cc38d2b619 ;  context    0x29cc38d2b619 <FixedArray[334]>  (input #4)
    0x7fff5fbfd640: [top + 24] <- 0x29cc38d46c01 ;  function    0x29cc38d46c01 <JS Function doOutsideOfContext (SharedFunctionInfo 0x3504a53f1271)>  (input #0)
    0x7fff5fbfd638: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #5)
    0x7fff5fbfd630: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfd628: [top + 0] <- 0x29cc38d49361 ;  0x29cc38d49361 <JS Function parseTypeWorker (SharedFunctionInfo 0x3504a53f7b71)>  (input #7)
  translating frame parseTypeWorker => node=67, height=8
    0x7fff5fbfd620: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd618: [top + 32] <- 0x2c21d241fd4e ;  caller's pc
    0x7fff5fbfd610: [top + 24] <- 0x7fff5fbfd650 ;  caller's fp
    0x7fff5fbfd608: [top + 16] <- 0x29cc38d2b619 ;  context    0x29cc38d2b619 <FixedArray[334]>  (input #2)
    0x7fff5fbfd600: [top + 8] <- 0x29cc38d49361 ;  function    0x29cc38d49361 <JS Function parseTypeWorker (SharedFunctionInfo 0x3504a53f7b71)>  (input #0)
    0x7fff5fbfd5f8: [top + 0] <- 0x29cc38d49169 ;  0x29cc38d49169 <JS Function parseUnionTypeOrHigher (SharedFunctionInfo 0x3504a53f7631)>  (input #3)
  translating frame parseUnionTypeOrHigher => node=7, height=8
    0x7fff5fbfd5f0: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd5e8: [top + 32] <- 0x2c21d241ff43 ;  caller's pc
    0x7fff5fbfd5e0: [top + 24] <- 0x7fff5fbfd610 ;  caller's fp
    0x7fff5fbfd5d8: [top + 16] <- 0x29cc38d2b619 ;  context    0x29cc38d2b619 <FixedArray[334]>  (input #2)
    0x7fff5fbfd5d0: [top + 8] <- 0x29cc38d49169 ;  function    0x29cc38d49169 <JS Function parseUnionTypeOrHigher (SharedFunctionInfo 0x3504a53f7631)>  (input #0)
    0x7fff5fbfd5c8: [top + 0] <- 0x29cc38d490d9 ;  0x29cc38d490d9 <JS Function parseUnionOrIntersectionType (SharedFunctionInfo 0x3504a53f74b1)>  (input #3)
  translating frame parseUnionOrIntersectionType => node=88, height=48
    0x7fff5fbfd5c0: [top + 104] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd5b8: [top + 96] <- 0xa400000000 ;  164  (input #2)
    0x7fff5fbfd5b0: [top + 88] <- 0x29cc38d49121 ;  0x29cc38d49121 <JS Function parseIntersectionTypeOrHigher (SharedFunctionInfo 0x3504a53f7571)>  (input #3)
    0x7fff5fbfd5a8: [top + 80] <- 0x3000000000 ;  48  (input #4)
    0x7fff5fbfd5a0: [top + 72] <- 0x2c21d24201f6 ;  caller's pc
    0x7fff5fbfd598: [top + 64] <- 0x7fff5fbfd5e0 ;  caller's fp
    0x7fff5fbfd590: [top + 56] <- 0x29cc38d2b619 ;  context    0x29cc38d2b619 <FixedArray[334]>  (input #5)
    0x7fff5fbfd588: [top + 48] <- 0x29cc38d490d9 ;  function    0x29cc38d490d9 <JS Function parseUnionOrIntersectionType (SharedFunctionInfo 0x3504a53f74b1)>  (input #0)
    0x7fff5fbfd580: [top + 40] <- 0x19a2de385679 ;  0x19a2de385679 <a TokenObject with map 0x33abe2a67411>  (input #6)
    0x7fff5fbfd578: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfd570: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfd568: [top + 16] <- 0x29cc38d476f9 ;  0x29cc38d476f9 <JS Function createNodeArray (SharedFunctionInfo 0x3504a53f2fb1)>  (input #9)
    0x7fff5fbfd560: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #10)
    0x7fff5fbfd558: [top + 0] <- 0x19a2de3856b9 ;  0x19a2de3856b9 <JS Array[1]>  (input #11)
[deoptimizing (eager): end 0x29cc38d46c01 <JS Function doOutsideOfContext (SharedFunctionInfo 0x3504a53f1271)> @20 => node=88, pc=0x2c21d24203b8, caller sp=0x7fff5fbfd678, state=NO_REGISTERS, took 0.219 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseTypeWorker) id{37,0} ---
() {
            if (isStartOfFunctionType()) {
                return parseFunctionOrConstructorType(158 /* FunctionType */);
            }
            if (token() === 93 /* NewKeyword */) {
                return parseFunctionOrConstructorType(159 /* ConstructorType */);
            }
            return parseUnionTypeOrHigher();
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isStartOfFunctionType) id{37,1} ---
() {
            if (token() === 26 /* LessThanToken */) {
                return true;
            }
            return token() === 18 /* OpenParenToken */ && lookAhead(isUnambiguouslyStartOfFunctionType);
        }
--- END ---
INLINE (isStartOfFunctionType) id{37,1} AS 1 AT <0:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{37,2} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{37,2} AS 2 AT <1:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{37,3} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{37,3} AS 3 AT <1:121>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:lookAhead) id{37,4} ---
(callback) {
            return speculationHelper(callback, /*isLookAhead*/ true);
        }
--- END ---
INLINE (lookAhead) id{37,4} AS 4 AT <1:160>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseFunctionOrConstructorType) id{37,5} ---
(kind) {
            var node = createNode(kind);
            if (kind === 159 /* ConstructorType */) {
                parseExpected(93 /* NewKeyword */);
            }
            fillSignature(35 /* EqualsGreaterThanToken */, /*yieldContext*/ false, /*awaitContext*/ false, /*requireCompleteParameterList*/ false, node);
            return finishNode(node);
        }
--- END ---
INLINE (parseFunctionOrConstructorType) id{37,5} AS 5 AT <0:71>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{37,6} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{37,6} AS 6 AT <5:32>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{37,7} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{37,7} AS 7 AT <6:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{37,8} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{37,8} AS 8 AT <6:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{37,9} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{37,9} AS 9 AT <6:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{37,10} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{37,10} AS 10 AT <0:157>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseUnionTypeOrHigher) id{37,11} ---
() {
            return parseUnionOrIntersectionType(164 /* UnionType */, parseIntersectionTypeOrHigher, 48 /* BarToken */);
        }
--- END ---
INLINE (parseUnionTypeOrHigher) id{37,11} AS 11 AT <0:307>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseUnionOrIntersectionType) id{37,12} ---
(kind, parseConstituentType, operator) {
            parseOptional(operator);
            var type = parseConstituentType();
            if (token() === operator) {
                var types = createNodeArray([type], type.pos);
                while (parseOptional(operator)) {
                    types.push(parseConstituentType());
                }
                types.end = getNodeEnd();
                var node = createNode(kind, type.pos);
                node.types = types;
                type = finishNode(node);
            }
            return type;
        }
--- END ---
INLINE (parseUnionOrIntersectionType) id{37,12} AS 12 AT <11:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseOptional) id{37,13} ---
(t) {
            if (token() === t) {
                nextToken();
                return true;
            }
            return false;
        }
--- END ---
INLINE (parseOptional) id{37,13} AS 13 AT <12:53>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{37,14} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{37,14} AS 14 AT <13:22>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{37,15} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{37,15} AS 15 AT <13:55>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{37,16} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{37,16} AS 16 AT <12:141>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNodeArray) id{37,17} ---
(elements, pos) {
            var array = (elements || []);
            if (!(pos >= 0)) {
                pos = getNodePos();
            }
            array.pos = pos;
            array.end = pos;
            return array;
        }
--- END ---
INLINE (createNodeArray) id{37,17} AS 17 AT <12:193>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodePos) id{37,18} ---
() {
            return scanner.getStartPos();
        }
--- END ---
INLINE (getNodePos) id{37,18} AS 18 AT <17:113>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseOptional) id{37,19} ---
(t) {
            if (token() === t) {
                nextToken();
                return true;
            }
            return false;
        }
--- END ---
INLINE (parseOptional) id{37,19} AS 19 AT <12:251>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{37,20} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{37,20} AS 20 AT <19:22>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{37,21} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{37,21} AS 21 AT <19:55>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseIntersectionTypeOrHigher) id{37,22} ---
() {
            return parseUnionOrIntersectionType(165 /* IntersectionType */, parseTypeOperatorOrHigher, 47 /* AmpersandToken */);
        }
--- END ---
INLINE (parseIntersectionTypeOrHigher) id{37,22} AS 22 AT <12:309>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeEnd) id{37,23} ---
() {
            return scanner.getStartPos();
        }
--- END ---
INLINE (getNodeEnd) id{37,23} AS 23 AT <12:380>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{37,24} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{37,24} AS 24 AT <12:421>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{37,25} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{37,25} AS 25 AT <24:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{37,26} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{37,26} AS 26 AT <24:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{37,27} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{37,27} AS 27 AT <24:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNodeArray) id{38,0} ---
(elements, pos) {
            var array = (elements || []);
            if (!(pos >= 0)) {
                pos = getNodePos();
            }
            array.pos = pos;
            array.end = pos;
            return array;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodePos) id{38,1} ---
() {
            return scanner.getStartPos();
        }
--- END ---
INLINE (getNodePos) id{38,1} AS 1 AT <0:113>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:lookAhead) id{39,0} ---
(callback) {
            return speculationHelper(callback, /*isLookAhead*/ true);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:inContext) id{40,0} ---
(flags) {
            return (contextFlags & flags) !== 0;
        }
--- END ---
[deoptimizing (DEOPT soft): begin 0x29cc38d46711 <JS Function scan (SharedFunctionInfo 0x16f3adb53cc1)> (opt #16) @96, FP to SP delta: 96, caller sp: 0x7fff5fbfda18]
            ;;; deoptimize at 0_12699: Insufficient type feedback for LHS of binary operation
  reading input frame scan => node=3371, args=1, height=9; inputs:
      0: 0x29cc38d46711 ; [fp - 16] 0x29cc38d46711 <JS Function scan (SharedFunctionInfo 0x16f3adb53cc1)>
      1: 0x29cc38d467e9 ; [fp + 16] 0x29cc38d467e9 <an Object with map 0x33abe2a503e9>
      2: 0x29cc38d2b499 ; rbx 0x29cc38d2b499 <FixedArray[39]>
      3: 0x30bcea4069a9 ; (literal 8) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      4: 0x30bcea4069a9 ; (literal 8) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      5: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
      6: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
      7: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
      9: 0x19a2de304201 ; [fp - 96] 0x19a2de304201 <Very long string[189592]>
     10: 0x30bcea4b47a9 ; rax 0x30bcea4b47a9 <JS Function charCodeAt (SharedFunctionInfo 0x30bcea46c659)>
  translating frame scan => node=3371, height=64
    0x7fff5fbfda10: [top + 96] <- 0x29cc38d467e9 ;  0x29cc38d467e9 <an Object with map 0x33abe2a503e9>  (input #1)
    0x7fff5fbfda08: [top + 88] <- 0x2c21d242b099 ;  caller's pc
    0x7fff5fbfda00: [top + 80] <- 0x7fff5fbfda30 ;  caller's fp
    0x7fff5fbfd9f8: [top + 72] <- 0x29cc38d2b499 ;  context    0x29cc38d2b499 <FixedArray[39]>  (input #2)
    0x7fff5fbfd9f0: [top + 64] <- 0x29cc38d46711 ;  function    0x29cc38d46711 <JS Function scan (SharedFunctionInfo 0x16f3adb53cc1)>  (input #0)
    0x7fff5fbfd9e8: [top + 56] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #3)
    0x7fff5fbfd9e0: [top + 48] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #4)
    0x7fff5fbfd9d8: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfd9d0: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfd9c8: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfd9c0: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfd9b8: [top + 8] <- 0x19a2de304201 ;  0x19a2de304201 <Very long string[189592]>  (input #9)
    0x7fff5fbfd9b0: [top + 0] <- 0x30bcea4b47a9 ;  0x30bcea4b47a9 <JS Function charCodeAt (SharedFunctionInfo 0x30bcea46c659)>  (input #10)
[deoptimizing (soft): end 0x29cc38d46711 <JS Function scan (SharedFunctionInfo 0x16f3adb53cc1)> @96 => node=3371, pc=0x2c21d240b500, caller sp=0x7fff5fbfda18, state=TOS_REGISTER, took 0.107 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:setAwaitContext) id{41,0} ---
(val) {
            setContextFlag(val, 16384 /* AwaitContext */);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:setContextFlag) id{41,1} ---
(val, flag) {
            if (val) {
                contextFlags |= flag;
            }
            else {
                contextFlags &= ~flag;
            }
        }
--- END ---
INLINE (setContextFlag) id{41,1} AS 1 AT <0:20>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:tokenIsIdentifierOrKeyword) id{42,0} ---
(token) {
        return token >= 70 /* Identifier */;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:scan) id{43,0} ---
() {
            startPos = pos;
            hasExtendedUnicodeEscape = false;
            precedingLineBreak = false;
            tokenIsUnterminated = false;
            while (true) {
                tokenPos = pos;
                if (pos >= end) {
                    return token = 1 /* EndOfFileToken */;
                }
                var ch = text.charCodeAt(pos);
                // Special handling for shebang
                if (ch === 35 /* hash */ && pos === 0 && isShebangTrivia(text, pos)) {
                    pos = scanShebangTrivia(text, pos);
                    if (skipTrivia) {
                        continue;
                    }
                    else {
                        return token = 6 /* ShebangTrivia */;
                    }
                }
                switch (ch) {
                    case 10 /* lineFeed */:
                    case 13 /* carriageReturn */:
                        precedingLineBreak = true;
                        if (skipTrivia) {
                            pos++;
                            continue;
                        }
                        else {
                            if (ch === 13 /* carriageReturn */ && pos + 1 < end && text.charCodeAt(pos + 1) === 10 /* lineFeed */) {
                                // consume both CR and LF
                                pos += 2;
                            }
                            else {
                                pos++;
                            }
                            return token = 4 /* NewLineTrivia */;
                        }
                    case 9 /* tab */:
                    case 11 /* verticalTab */:
                    case 12 /* formFeed */:
                    case 32 /* space */:
                        if (skipTrivia) {
                            pos++;
                            continue;
                        }
                        else {
                            while (pos < end && isWhiteSpaceSingleLine(text.charCodeAt(pos))) {
                                pos++;
                            }
                            return token = 5 /* WhitespaceTrivia */;
                        }
                    case 33 /* exclamation */:
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            if (text.charCodeAt(pos + 2) === 61 /* equals */) {
                                return pos += 3, token = 34 /* ExclamationEqualsEqualsToken */;
                            }
                            return pos += 2, token = 32 /* ExclamationEqualsToken */;
                        }
                        pos++;
                        return token = 50 /* ExclamationToken */;
                    case 34 /* doubleQuote */:
                    case 39 /* singleQuote */:
                        tokenValue = scanString();
                        return token = 9 /* StringLiteral */;
                    case 96 /* backtick */:
                        return token = scanTemplateAndSetTokenValue();
                    case 37 /* percent */:
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 63 /* PercentEqualsToken */;
                        }
                        pos++;
                        return token = 41 /* PercentToken */;
                    case 38 /* ampersand */:
                        if (text.charCodeAt(pos + 1) === 38 /* ampersand */) {
                            return pos += 2, token = 52 /* AmpersandAmpersandToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 67 /* AmpersandEqualsToken */;
                        }
                        pos++;
                        return token = 47 /* AmpersandToken */;
                    case 40 /* openParen */:
                        pos++;
                        return token = 18 /* OpenParenToken */;
                    case 41 /* closeParen */:
                        pos++;
                        return token = 19 /* CloseParenToken */;
                    case 42 /* asterisk */:
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 60 /* AsteriskEqualsToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 42 /* asterisk */) {
                            if (text.charCodeAt(pos + 2) === 61 /* equals */) {
                                return pos += 3, token = 61 /* AsteriskAsteriskEqualsToken */;
                            }
                            return pos += 2, token = 39 /* AsteriskAsteriskToken */;
                        }
                        pos++;
                        return token = 38 /* AsteriskToken */;
                    case 43 /* plus */:
                        if (text.charCodeAt(pos + 1) === 43 /* plus */) {
                            return pos += 2, token = 42 /* PlusPlusToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 58 /* PlusEqualsToken */;
                        }
                        pos++;
                        return token = 36 /* PlusToken */;
                    case 44 /* comma */:
                        pos++;
                        return token = 25 /* CommaToken */;
                    case 45 /* minus */:
                        if (text.charCodeAt(pos + 1) === 45 /* minus */) {
                            return pos += 2, token = 43 /* MinusMinusToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 59 /* MinusEqualsToken */;
                        }
                        pos++;
                        return token = 37 /* MinusToken */;
                    case 46 /* dot */:
                        if (isDigit(text.charCodeAt(pos + 1))) {
                            tokenValue = scanNumber();
                            return token = 8 /* NumericLiteral */;
                        }
                        if (text.charCodeAt(pos + 1) === 46 /* dot */ && text.charCodeAt(pos + 2) === 46 /* dot */) {
                            return pos += 3, token = 23 /* DotDotDotToken */;
                        }
                        pos++;
                        return token = 22 /* DotToken */;
                    case 47 /* slash */:
                        // Single-line comment
                        if (text.charCodeAt(pos + 1) === 47 /* slash */) {
                            pos += 2;
                            while (pos < end) {
                                if (isLineBreak(text.charCodeAt(pos))) {
                                    break;
                                }
                                pos++;
                            }
                            if (skipTrivia) {
                                continue;
                            }
                            else {
                                return token = 2 /* SingleLineCommentTrivia */;
                            }
                        }
                        // Multi-line comment
                        if (text.charCodeAt(pos + 1) === 42 /* asterisk */) {
                            pos += 2;
                            var commentClosed = false;
                            while (pos < end) {
                                var ch_2 = text.charCodeAt(pos);
                                if (ch_2 === 42 /* asterisk */ && text.charCodeAt(pos + 1) === 47 /* slash */) {
                                    pos += 2;
                                    commentClosed = true;
                                    break;
                                }
                                if (isLineBreak(ch_2)) {
                                    precedingLineBreak = true;
                                }
                                pos++;
                            }
                            if (!commentClosed) {
                                error(ts.Diagnostics.Asterisk_Slash_expected);
                            }
                            if (skipTrivia) {
                                continue;
                            }
                            else {
                                tokenIsUnterminated = !commentClosed;
                                return token = 3 /* MultiLineCommentTrivia */;
                            }
                        }
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 62 /* SlashEqualsToken */;
                        }
                        pos++;
                        return token = 40 /* SlashToken */;
                    case 48 /* _0 */:
                        if (pos + 2 < end && (text.charCodeAt(pos + 1) === 88 /* X */ || text.charCodeAt(pos + 1) === 120 /* x */)) {
                            pos += 2;
                            var value = scanMinimumNumberOfHexDigits(1);
                            if (value < 0) {
                                error(ts.Diagnostics.Hexadecimal_digit_expected);
                                value = 0;
                            }
                            tokenValue = "" + value;
                            return token = 8 /* NumericLiteral */;
                        }
                        else if (pos + 2 < end && (text.charCodeAt(pos + 1) === 66 /* B */ || text.charCodeAt(pos + 1) === 98 /* b */)) {
                            pos += 2;
                            var value = scanBinaryOrOctalDigits(/* base */ 2);
                            if (value < 0) {
                                error(ts.Diagnostics.Binary_digit_expected);
                                value = 0;
                            }
                            tokenValue = "" + value;
                            return token = 8 /* NumericLiteral */;
                        }
                        else if (pos + 2 < end && (text.charCodeAt(pos + 1) === 79 /* O */ || text.charCodeAt(pos + 1) === 111 /* o */)) {
                            pos += 2;
                            var value = scanBinaryOrOctalDigits(/* base */ 8);
                            if (value < 0) {
                                error(ts.Diagnostics.Octal_digit_expected);
                                value = 0;
                            }
                            tokenValue = "" + value;
                            return token = 8 /* NumericLiteral */;
                        }
                        // Try to parse as an octal
                        if (pos + 1 < end && isOctalDigit(text.charCodeAt(pos + 1))) {
                            tokenValue = "" + scanOctalDigits();
                            return token = 8 /* NumericLiteral */;
                        }
                    // This fall-through is a deviation from the EcmaScript grammar. The grammar says that a leading zero
                    // can only be followed by an octal digit, a dot, or the end of the number literal. However, we are being
                    // permissive and allowing decimal digits of the form 08* and 09* (which many browsers also do).
                    case 49 /* _1 */:
                    case 50 /* _2 */:
                    case 51 /* _3 */:
                    case 52 /* _4 */:
                    case 53 /* _5 */:
                    case 54 /* _6 */:
                    case 55 /* _7 */:
                    case 56 /* _8 */:
                    case 57 /* _9 */:
                        tokenValue = scanNumber();
                        return token = 8 /* NumericLiteral */;
                    case 58 /* colon */:
                        pos++;
                        return token = 55 /* ColonToken */;
                    case 59 /* semicolon */:
                        pos++;
                        return token = 24 /* SemicolonToken */;
                    case 60 /* lessThan */:
                        if (isConflictMarkerTrivia(text, pos)) {
                            pos = scanConflictMarkerTrivia(text, pos, error);
                            if (skipTrivia) {
                                continue;
                            }
                            else {
                                return token = 7 /* ConflictMarkerTrivia */;
                            }
                        }
                        if (text.charCodeAt(pos + 1) === 60 /* lessThan */) {
                            if (text.charCodeAt(pos + 2) === 61 /* equals */) {
                                return pos += 3, token = 64 /* LessThanLessThanEqualsToken */;
                            }
                            return pos += 2, token = 44 /* LessThanLessThanToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 29 /* LessThanEqualsToken */;
                        }
                        if (languageVariant === 1 /* JSX */ &&
                            text.charCodeAt(pos + 1) === 47 /* slash */ &&
                            text.charCodeAt(pos + 2) !== 42 /* asterisk */) {
                            return pos += 2, token = 27 /* LessThanSlashToken */;
                        }
                        pos++;
                        return token = 26 /* LessThanToken */;
                    case 61 /* equals */:
                        if (isConflictMarkerTrivia(text, pos)) {
                            pos = scanConflictMarkerTrivia(text, pos, error);
                            if (skipTrivia) {
                                continue;
                            }
                            else {
                                return token = 7 /* ConflictMarkerTrivia */;
                            }
                        }
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            if (text.charCodeAt(pos + 2) === 61 /* equals */) {
                                return pos += 3, token = 33 /* EqualsEqualsEqualsToken */;
                            }
                            return pos += 2, token = 31 /* EqualsEqualsToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 62 /* greaterThan */) {
                            return pos += 2, token = 35 /* EqualsGreaterThanToken */;
                        }
                        pos++;
                        return token = 57 /* EqualsToken */;
                    case 62 /* greaterThan */:
                        if (isConflictMarkerTrivia(text, pos)) {
                            pos = scanConflictMarkerTrivia(text, pos, error);
                            if (skipTrivia) {
                                continue;
                            }
                            else {
                                return token = 7 /* ConflictMarkerTrivia */;
                            }
                        }
                        pos++;
                        return token = 28 /* GreaterThanToken */;
                    case 63 /* question */:
                        pos++;
                        return token = 54 /* QuestionToken */;
                    case 91 /* openBracket */:
                        pos++;
                        return token = 20 /* OpenBracketToken */;
                    case 93 /* closeBracket */:
                        pos++;
                        return token = 21 /* CloseBracketToken */;
                    case 94 /* caret */:
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 69 /* CaretEqualsToken */;
                        }
                        pos++;
                        return token = 49 /* CaretToken */;
                    case 123 /* openBrace */:
                        pos++;
                        return token = 16 /* OpenBraceToken */;
                    case 124 /* bar */:
                        if (text.charCodeAt(pos + 1) === 124 /* bar */) {
                            return pos += 2, token = 53 /* BarBarToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 68 /* BarEqualsToken */;
                        }
                        pos++;
                        return token = 48 /* BarToken */;
                    case 125 /* closeBrace */:
                        pos++;
                        return token = 17 /* CloseBraceToken */;
                    case 126 /* tilde */:
                        pos++;
                        return token = 51 /* TildeToken */;
                    case 64 /* at */:
                        pos++;
                        return token = 56 /* AtToken */;
                    case 92 /* backslash */:
                        var cookedChar = peekUnicodeEscape();
                        if (cookedChar >= 0 && isIdentifierStart(cookedChar, languageVersion)) {
                            pos += 6;
                            tokenValue = String.fromCharCode(cookedChar) + scanIdentifierParts();
                            return token = getIdentifierToken();
                        }
                        error(ts.Diagnostics.Invalid_character);
                        pos++;
                        return token = 0 /* Unknown */;
                    default:
                        if (isIdentifierStart(ch, languageVersion)) {
                            pos++;
                            while (pos < end && isIdentifierPart(ch = text.charCodeAt(pos), languageVersion))
                                pos++;
                            tokenValue = text.substring(tokenPos, pos);
                            if (ch === 92 /* backslash */) {
                                tokenValue += scanIdentifierParts();
                            }
                            return token = getIdentifierToken();
                        }
                        else if (isWhiteSpaceSingleLine(ch)) {
                            pos++;
                            continue;
                        }
                        else if (isLineBreak(ch)) {
                            precedingLineBreak = true;
                            pos++;
                            continue;
                        }
                        error(ts.Diagnostics.Invalid_character);
                        pos++;
                        return token = 0 /* Unknown */;
                }
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isDigit) id{43,1} ---
(ch) {
        return ch >= 48 /* _0 */ && ch <= 57 /* _9 */;
    }
--- END ---
INLINE (isDigit) id{43,1} AS 1 AT <0:6077>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIdentifierStart) id{43,2} ---
(ch, languageVersion) {
        return ch >= 65 /* A */ && ch <= 90 /* Z */ || ch >= 97 /* a */ && ch <= 122 /* z */ ||
            ch === 36 /* $ */ || ch === 95 /* _ */ ||
            ch > 127 /* maxAsciiCharacter */ && isUnicodeIdentifierStart(ch, languageVersion);
    }
--- END ---
INLINE (isIdentifierStart) id{43,2} AS 2 AT <0:17770>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIdentifierPart) id{43,3} ---
(ch, languageVersion) {
        return ch >= 65 /* A */ && ch <= 90 /* Z */ || ch >= 97 /* a */ && ch <= 122 /* z */ ||
            ch >= 48 /* _0 */ && ch <= 57 /* _9 */ || ch === 36 /* $ */ || ch === 95 /* _ */ ||
            ch > 127 /* maxAsciiCharacter */ && isUnicodeIdentifierPart(ch, languageVersion);
    }
--- END ---
INLINE (isIdentifierPart) id{43,3} AS 3 AT <0:17895>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:inDisallowInContext) id{44,0} ---
() {
            return inContext(2048 /* DisallowInContext */);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:inContext) id{44,1} ---
(flags) {
            return (contextFlags & flags) !== 0;
        }
--- END ---
INLINE (inContext) id{44,1} AS 1 AT <0:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseExpected) id{45,0} ---
(kind, diagnosticMessage, shouldAdvance) {
            if (shouldAdvance === void 0) { shouldAdvance = true; }
            if (token() === kind) {
                if (shouldAdvance) {
                    nextToken();
                }
                return true;
            }
            // Report specific message if provided with one.  Otherwise, report generic fallback message.
            if (diagnosticMessage) {
                parseErrorAtCurrentToken(diagnosticMessage);
            }
            else {
                parseErrorAtCurrentToken(ts.Diagnostics._0_expected, ts.tokenToString(kind));
            }
            return false;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{45,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{45,1} AS 1 AT <0:127>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{45,2} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{45,2} AS 2 AT <0:204>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeEnd) id{46,0} ---
() {
            return scanner.getStartPos();
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseAnyContextualModifier) id{47,0} ---
() {
            return ts.isModifierKind(token()) && tryParse(nextTokenCanFollowModifier);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{47,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{47,1} AS 1 AT <0:42>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:tryParse) id{47,2} ---
(callback) {
            return speculationHelper(callback, /*isLookAhead*/ false);
        }
--- END ---
INLINE (tryParse) id{47,2} AS 2 AT <0:54>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseOptionalToken) id{48,0} ---
(t) {
            if (token() === t) {
                return parseTokenNode();
            }
            return undefined;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{48,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{48,1} AS 1 AT <0:22>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseTokenNode) id{48,2} ---
() {
            var node = createNode(token());
            nextToken();
            return finishNode(node);
        }
--- END ---
INLINE (parseTokenNode) id{48,2} AS 2 AT <0:62>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{48,3} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{48,3} AS 3 AT <2:39>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{48,4} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{48,4} AS 4 AT <2:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{48,5} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{48,5} AS 5 AT <4:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{48,6} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{48,6} AS 6 AT <4:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{48,7} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{48,7} AS 7 AT <4:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{48,8} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{48,8} AS 8 AT <2:61>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseKeywordAndNoDot) id{49,0} ---
() {
            var node = parseTokenNode();
            return token() === 22 /* DotToken */ ? undefined : node;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseTokenNode) id{49,1} ---
() {
            var node = createNode(token());
            nextToken();
            return finishNode(node);
        }
--- END ---
INLINE (parseTokenNode) id{49,1} AS 1 AT <0:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{49,2} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{49,2} AS 2 AT <1:39>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{49,3} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{49,3} AS 3 AT <1:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{49,4} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{49,4} AS 4 AT <3:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{49,5} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{49,5} AS 5 AT <3:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{49,6} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{49,6} AS 6 AT <3:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{49,7} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{49,7} AS 7 AT <1:61>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{49,8} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{49,8} AS 8 AT <0:65>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseIdentifierOrPattern) id{50,0} ---
() {
            if (token() === 20 /* OpenBracketToken */) {
                return parseArrayBindingPattern();
            }
            if (token() === 16 /* OpenBraceToken */) {
                return parseObjectBindingPattern();
            }
            return parseIdentifier();
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{50,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{50,1} AS 1 AT <0:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{50,2} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{50,2} AS 2 AT <0:143>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseIdentifier) id{50,3} ---
(diagnosticMessage) {
            return createIdentifier(isIdentifier(), diagnosticMessage);
        }
--- END ---
INLINE (parseIdentifier) id{50,3} AS 3 AT <0:267>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseInitializer) id{51,0} ---
(inParameter) {
            if (token() !== 57 /* EqualsToken */) {
                // It's not uncommon during typing for the user to miss writing the '=' token.  Check if
                // there is no newline after the last token and if we're on an expression.  If so, parse
                // this as an equals-value clause with a missing equals.
                // NOTE: There are two places where we allow equals-value clauses.  The first is in a
                // variable declarator.  The second is with a parameter.  For variable declarators
                // it's more likely that a { would be a allowed (as an object literal).  While this
                // is also allowed for parameters, the risk is that we consume the { as an object
                // literal when it really will be for the block following the parameter.
                if (scanner.hasPrecedingLineBreak() || (inParameter && token() === 16 /* OpenBraceToken */) || !isStartOfExpression()) {
                    // preceding line break, open brace in a parameter (likely a function body) or current token is not an expression -
                    // do not try to parse initializer
                    return undefined;
                }
            }
            // Initializer[In, Yield] :
            //     = AssignmentExpression[?In, ?Yield]
            parseExpected(57 /* EqualsToken */);
            return parseAssignmentExpressionOrHigher();
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{51,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{51,1} AS 1 AT <0:32>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{51,2} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{51,2} AS 2 AT <0:910>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isBinaryOperator) id{52,0} ---
() {
            if (inDisallowInContext() && token() === 91 /* InKeyword */) {
                return false;
            }
            return getBinaryOperatorPrecedence() > 0;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:inDisallowInContext) id{52,1} ---
() {
            return inContext(2048 /* DisallowInContext */);
        }
--- END ---
INLINE (inDisallowInContext) id{52,1} AS 1 AT <0:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:inContext) id{52,2} ---
(flags) {
            return (contextFlags & flags) !== 0;
        }
--- END ---
INLINE (inContext) id{52,2} AS 2 AT <1:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isModifierKind) id{53,0} ---
(token) {
        switch (token) {
            case 116 /* AbstractKeyword */:
            case 119 /* AsyncKeyword */:
            case 75 /* ConstKeyword */:
            case 123 /* DeclareKeyword */:
            case 78 /* DefaultKeyword */:
            case 83 /* ExportKeyword */:
            case 113 /* PublicKeyword */:
            case 111 /* PrivateKeyword */:
            case 112 /* ProtectedKeyword */:
            case 130 /* ReadonlyKeyword */:
            case 114 /* StaticKeyword */:
                return true;
        }
        return false;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isStartOfParameter) id{54,0} ---
() {
            return token() === 23 /* DotDotDotToken */ || isIdentifierOrPattern() || ts.isModifierKind(token()) || token() === 56 /* AtToken */ || token() === 98 /* ThisKeyword */;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{54,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{54,1} AS 1 AT <0:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIdentifierOrPattern) id{54,2} ---
() {
            return token() === 16 /* OpenBraceToken */ || token() === 20 /* OpenBracketToken */ || isIdentifier();
        }
--- END ---
INLINE (isIdentifierOrPattern) id{54,2} AS 2 AT <0:63>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{54,3} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{54,3} AS 3 AT <2:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{54,4} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{54,4} AS 4 AT <2:63>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{54,5} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{54,5} AS 5 AT <0:108>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{54,6} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{54,6} AS 6 AT <0:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{54,7} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{54,7} AS 7 AT <0:152>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodePos) id{55,0} ---
() {
            return scanner.getStartPos();
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isLiteralPropertyName) id{56,0} ---
() {
            return ts.tokenIsIdentifierOrKeyword(token()) ||
                token() === 9 /* StringLiteral */ ||
                token() === 8 /* NumericLiteral */;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{56,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{56,1} AS 1 AT <0:54>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:tryScan) id{57,0} ---
(callback) {
            return speculationHelper(callback, /*isLookahead*/ false);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:doOutsideOfContext) id{58,0} ---
(context, func) {
            // contextFlagsToClear will contain only the context flags that are
            // currently set that we need to temporarily clear
            // We don't just blindly reset to the previous flags to ensure
            // that we do not mutate cached flags for the incremental
            // parser (ThisNodeHasError, ThisNodeOrAnySubNodesHasError, and
            // HasAggregatedChildData).
            var contextFlagsToClear = context & contextFlags;
            if (contextFlagsToClear) {
                // clear the requested context flags
                setContextFlag(/*val*/ false, contextFlagsToClear);
                var result = func();
                // restore the context flags we just cleared
                setContextFlag(/*val*/ true, contextFlagsToClear);
                return result;
            }
            // no need to do anything special as we are not in any of the requested contexts
            return func();
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseTypeWorker) id{58,1} ---
() {
            if (isStartOfFunctionType()) {
                return parseFunctionOrConstructorType(158 /* FunctionType */);
            }
            if (token() === 93 /* NewKeyword */) {
                return parseFunctionOrConstructorType(159 /* ConstructorType */);
            }
            return parseUnionTypeOrHigher();
        }
--- END ---
INLINE (parseTypeWorker) id{58,1} AS 1 AT <0:966>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isStartOfFunctionType) id{58,2} ---
() {
            if (token() === 26 /* LessThanToken */) {
                return true;
            }
            return token() === 18 /* OpenParenToken */ && lookAhead(isUnambiguouslyStartOfFunctionType);
        }
--- END ---
INLINE (isStartOfFunctionType) id{58,2} AS 2 AT <1:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{58,3} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{58,3} AS 3 AT <2:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{58,4} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{58,4} AS 4 AT <2:121>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:lookAhead) id{58,5} ---
(callback) {
            return speculationHelper(callback, /*isLookAhead*/ true);
        }
--- END ---
INLINE (lookAhead) id{58,5} AS 5 AT <2:160>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseFunctionOrConstructorType) id{58,6} ---
(kind) {
            var node = createNode(kind);
            if (kind === 159 /* ConstructorType */) {
                parseExpected(93 /* NewKeyword */);
            }
            fillSignature(35 /* EqualsGreaterThanToken */, /*yieldContext*/ false, /*awaitContext*/ false, /*requireCompleteParameterList*/ false, node);
            return finishNode(node);
        }
--- END ---
INLINE (parseFunctionOrConstructorType) id{58,6} AS 6 AT <1:71>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{58,7} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{58,7} AS 7 AT <6:32>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{58,8} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{58,8} AS 8 AT <7:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{58,9} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{58,9} AS 9 AT <7:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{58,10} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{58,10} AS 10 AT <7:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{58,11} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{58,11} AS 11 AT <1:157>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseUnionTypeOrHigher) id{58,12} ---
() {
            return parseUnionOrIntersectionType(164 /* UnionType */, parseIntersectionTypeOrHigher, 48 /* BarToken */);
        }
--- END ---
INLINE (parseUnionTypeOrHigher) id{58,12} AS 12 AT <1:307>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseUnionOrIntersectionType) id{58,13} ---
(kind, parseConstituentType, operator) {
            parseOptional(operator);
            var type = parseConstituentType();
            if (token() === operator) {
                var types = createNodeArray([type], type.pos);
                while (parseOptional(operator)) {
                    types.push(parseConstituentType());
                }
                types.end = getNodeEnd();
                var node = createNode(kind, type.pos);
                node.types = types;
                type = finishNode(node);
            }
            return type;
        }
--- END ---
INLINE (parseUnionOrIntersectionType) id{58,13} AS 13 AT <12:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseOptional) id{58,14} ---
(t) {
            if (token() === t) {
                nextToken();
                return true;
            }
            return false;
        }
--- END ---
INLINE (parseOptional) id{58,14} AS 14 AT <13:53>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{58,15} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{58,15} AS 15 AT <14:22>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{58,16} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{58,16} AS 16 AT <14:55>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{58,17} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{58,17} AS 17 AT <13:141>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNodeArray) id{58,18} ---
(elements, pos) {
            var array = (elements || []);
            if (!(pos >= 0)) {
                pos = getNodePos();
            }
            array.pos = pos;
            array.end = pos;
            return array;
        }
--- END ---
INLINE (createNodeArray) id{58,18} AS 18 AT <13:193>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodePos) id{58,19} ---
() {
            return scanner.getStartPos();
        }
--- END ---
INLINE (getNodePos) id{58,19} AS 19 AT <18:113>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseOptional) id{58,20} ---
(t) {
            if (token() === t) {
                nextToken();
                return true;
            }
            return false;
        }
--- END ---
INLINE (parseOptional) id{58,20} AS 20 AT <13:251>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{58,21} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{58,21} AS 21 AT <20:22>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{58,22} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{58,22} AS 22 AT <20:55>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseIntersectionTypeOrHigher) id{58,23} ---
() {
            return parseUnionOrIntersectionType(165 /* IntersectionType */, parseTypeOperatorOrHigher, 47 /* AmpersandToken */);
        }
--- END ---
INLINE (parseIntersectionTypeOrHigher) id{58,23} AS 23 AT <13:309>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeEnd) id{58,24} ---
() {
            return scanner.getStartPos();
        }
--- END ---
INLINE (getNodeEnd) id{58,24} AS 24 AT <13:380>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{58,25} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{58,25} AS 25 AT <13:421>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{58,26} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{58,26} AS 26 AT <25:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{58,27} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{58,27} AS 27 AT <25:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{58,28} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{58,28} AS 28 AT <25:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseSemicolon) id{59,0} ---
() {
            if (canParseSemicolon()) {
                if (token() === 24 /* SemicolonToken */) {
                    // consume the semicolon if it was explicitly provided.
                    nextToken();
                }
                return true;
            }
            else {
                return parseExpected(24 /* SemicolonToken */);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:canParseSemicolon) id{59,1} ---
() {
            // If there's a real semicolon, then we can always parse it out.
            if (token() === 24 /* SemicolonToken */) {
                return true;
            }
            // We can parse out an optional semicolon in ASI cases in the following cases.
            return token() === 17 /* CloseBraceToken */ || token() === 1 /* EndOfFileToken */ || scanner.hasPrecedingLineBreak();
        }
--- END ---
INLINE (canParseSemicolon) id{59,1} AS 1 AT <0:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{59,2} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{59,2} AS 2 AT <1:98>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{59,3} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{59,3} AS 3 AT <1:290>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{59,4} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{59,4} AS 4 AT <1:330>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{59,5} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{59,5} AS 5 AT <0:64>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{59,6} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{59,6} AS 6 AT <0:199>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getFullWidth) id{60,0} ---
(node) {
        return node.end - node.pos;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseParameterType) id{61,0} ---
() {
            if (parseOptional(55 /* ColonToken */)) {
                return parseType();
            }
            return undefined;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseOptional) id{61,1} ---
(t) {
            if (token() === t) {
                nextToken();
                return true;
            }
            return false;
        }
--- END ---
INLINE (parseOptional) id{61,1} AS 1 AT <0:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{61,2} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{61,2} AS 2 AT <1:22>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{61,3} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{61,3} AS 3 AT <1:55>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseType) id{61,4} ---
() {
            // The rules about 'yield' only apply to actual code/expression contexts.  They don't
            // apply to 'type' contexts.  So we disable these parameters here before moving on.
            return doOutsideOfContext(20480 /* TypeExcludesFlags */, parseTypeWorker);
        }
--- END ---
INLINE (parseType) id{61,4} AS 4 AT <0:82>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseBindingElementInitializer) id{62,0} ---
(inParameter) {
            return inParameter ? parseParameterInitializer() : parseNonParameterInitializer();
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseParameterInitializer) id{62,1} ---
() {
            return parseInitializer(/*inParameter*/ true);
        }
--- END ---
INLINE (parseParameterInitializer) id{62,1} AS 1 AT <0:49>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTrailingCommentRanges) id{63,0} ---
(text, pos) {
        return reduceEachTrailingCommentRange(text, pos, appendCommentRange, undefined, undefined);
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:reduceEachTrailingCommentRange) id{63,1} ---
(text, pos, cb, state, initial) {
        return iterateCommentRanges(/*reduce*/ true, text, pos, /*trailing*/ true, cb, state, initial);
    }
--- END ---
INLINE (reduceEachTrailingCommentRange) id{63,1} AS 1 AT <0:29>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:concatenate) id{64,0} ---
(array1, array2) {
        if (!some(array2))
            return array1;
        if (!some(array1))
            return array2;
        return array1.concat(array2);
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:some) id{64,1} ---
(array, predicate) {
        if (array) {
            if (predicate) {
                for (var _i = 0, array_5 = array; _i < array_5.length; _i++) {
                    var v = array_5[_i];
                    if (predicate(v)) {
                        return true;
                    }
                }
            }
            else {
                return array.length > 0;
            }
        }
        return false;
    }
--- END ---
INLINE (some) id{64,1} AS 1 AT <0:32>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseIdentifierName) id{65,0} ---
() {
            return createIdentifier(ts.tokenIsIdentifierOrKeyword(token()));
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{65,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{65,1} AS 1 AT <0:71>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIndexSignature) id{66,0} ---
() {
            if (token() !== 20 /* OpenBracketToken */) {
                return false;
            }
            return lookAhead(isUnambiguouslyIndexSignature);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{66,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{66,1} AS 1 AT <0:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parsePropertyName) id{67,0} ---
() {
            return parsePropertyNameWorker(/*allowComputedPropertyNames*/ true);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parsePropertyNameWorker) id{67,1} ---
(allowComputedPropertyNames) {
            if (token() === 9 /* StringLiteral */ || token() === 8 /* NumericLiteral */) {
                return parseLiteralNode(/*internName*/ true);
            }
            if (allowComputedPropertyNames && token() === 20 /* OpenBracketToken */) {
                return parseComputedPropertyName();
            }
            return parseIdentifierName();
        }
--- END ---
INLINE (parsePropertyNameWorker) id{67,1} AS 1 AT <0:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{67,2} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{67,2} AS 2 AT <1:47>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{67,3} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{67,3} AS 3 AT <1:84>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{67,4} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{67,4} AS 4 AT <1:244>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseIdentifierName) id{67,5} ---
() {
            return createIdentifier(ts.tokenIsIdentifierOrKeyword(token()));
        }
--- END ---
INLINE (parseIdentifierName) id{67,5} AS 5 AT <1:370>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{67,6} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{67,6} AS 6 AT <5:71>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseTypeMember) id{68,0} ---
() {
            if (token() === 18 /* OpenParenToken */ || token() === 26 /* LessThanToken */) {
                return parseSignatureMember(153 /* CallSignature */);
            }
            if (token() === 93 /* NewKeyword */ && lookAhead(isStartOfConstructSignature)) {
                return parseSignatureMember(154 /* ConstructSignature */);
            }
            var fullStart = getNodePos();
            var modifiers = parseModifiers();
            if (isIndexSignature()) {
                return parseIndexSignatureDeclaration(fullStart, /*decorators*/ undefined, modifiers);
            }
            return parsePropertyOrMethodSignature(fullStart, modifiers);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{68,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{68,1} AS 1 AT <0:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{68,2} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{68,2} AS 2 AT <0:60>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseSignatureMember) id{68,3} ---
(kind) {
            var node = createNode(kind);
            if (kind === 154 /* ConstructSignature */) {
                parseExpected(93 /* NewKeyword */);
            }
            fillSignature(55 /* ColonToken */, /*yieldContext*/ false, /*awaitContext*/ false, /*requireCompleteParameterList*/ false, node);
            parseTypeMemberSemicolon();
            return addJSDocComment(finishNode(node));
        }
--- END ---
INLINE (parseSignatureMember) id{68,3} AS 3 AT <0:121>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{68,4} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{68,4} AS 4 AT <3:32>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{68,5} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{68,5} AS 5 AT <4:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{68,6} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{68,6} AS 6 AT <4:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{68,7} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{68,7} AS 7 AT <4:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseTypeMemberSemicolon) id{68,8} ---
() {
            // We allow type members to be separated by commas or (possibly ASI) semicolons.
            // First check if it was a comma.  If so, we're done with the member.
            if (parseOptional(25 /* CommaToken */)) {
                return;
            }
            // Didn't have a comma.  We must have a (possible ASI) semicolon.
            parseSemicolon();
        }
--- END ---
INLINE (parseTypeMemberSemicolon) id{68,8} AS 8 AT <3:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseOptional) id{68,9} ---
(t) {
            if (token() === t) {
                nextToken();
                return true;
            }
            return false;
        }
--- END ---
INLINE (parseOptional) id{68,9} AS 9 AT <8:196>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{68,10} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{68,10} AS 10 AT <9:22>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{68,11} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{68,11} AS 11 AT <9:55>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseSemicolon) id{68,12} ---
() {
            if (canParseSemicolon()) {
                if (token() === 24 /* SemicolonToken */) {
                    // consume the semicolon if it was explicitly provided.
                    nextToken();
                }
                return true;
            }
            else {
                return parseExpected(24 /* SemicolonToken */);
            }
        }
--- END ---
INLINE (parseSemicolon) id{68,12} AS 12 AT <8:362>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:canParseSemicolon) id{68,13} ---
() {
            // If there's a real semicolon, then we can always parse it out.
            if (token() === 24 /* SemicolonToken */) {
                return true;
            }
            // We can parse out an optional semicolon in ASI cases in the following cases.
            return token() === 17 /* CloseBraceToken */ || token() === 1 /* EndOfFileToken */ || scanner.hasPrecedingLineBreak();
        }
--- END ---
INLINE (canParseSemicolon) id{68,13} AS 13 AT <12:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{68,14} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{68,14} AS 14 AT <13:98>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{68,15} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{68,15} AS 15 AT <13:290>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{68,16} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{68,16} AS 16 AT <13:330>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{68,17} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{68,17} AS 17 AT <12:64>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{68,18} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{68,18} AS 18 AT <12:199>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{68,19} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{68,19} AS 19 AT <0:198>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:lookAhead) id{68,20} ---
(callback) {
            return speculationHelper(callback, /*isLookAhead*/ true);
        }
--- END ---
INLINE (lookAhead) id{68,20} AS 20 AT <0:233>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseSignatureMember) id{68,21} ---
(kind) {
            var node = createNode(kind);
            if (kind === 154 /* ConstructSignature */) {
                parseExpected(93 /* NewKeyword */);
            }
            fillSignature(55 /* ColonToken */, /*yieldContext*/ false, /*awaitContext*/ false, /*requireCompleteParameterList*/ false, node);
            parseTypeMemberSemicolon();
            return addJSDocComment(finishNode(node));
        }
--- END ---
INLINE (parseSignatureMember) id{68,21} AS 21 AT <0:298>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{68,22} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{68,22} AS 22 AT <21:32>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{68,23} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{68,23} AS 23 AT <22:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{68,24} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{68,24} AS 24 AT <22:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{68,25} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{68,25} AS 25 AT <22:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseTypeMemberSemicolon) id{68,26} ---
() {
            // We allow type members to be separated by commas or (possibly ASI) semicolons.
            // First check if it was a comma.  If so, we're done with the member.
            if (parseOptional(25 /* CommaToken */)) {
                return;
            }
            // Didn't have a comma.  We must have a (possible ASI) semicolon.
            parseSemicolon();
        }
--- END ---
INLINE (parseTypeMemberSemicolon) id{68,26} AS 26 AT <21:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseOptional) id{68,27} ---
(t) {
            if (token() === t) {
                nextToken();
                return true;
            }
            return false;
        }
--- END ---
INLINE (parseOptional) id{68,27} AS 27 AT <26:196>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{68,28} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{68,28} AS 28 AT <27:22>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{68,29} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{68,29} AS 29 AT <27:55>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseSemicolon) id{68,30} ---
() {
            if (canParseSemicolon()) {
                if (token() === 24 /* SemicolonToken */) {
                    // consume the semicolon if it was explicitly provided.
                    nextToken();
                }
                return true;
            }
            else {
                return parseExpected(24 /* SemicolonToken */);
            }
        }
--- END ---
INLINE (parseSemicolon) id{68,30} AS 30 AT <26:362>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:canParseSemicolon) id{68,31} ---
() {
            // If there's a real semicolon, then we can always parse it out.
            if (token() === 24 /* SemicolonToken */) {
                return true;
            }
            // We can parse out an optional semicolon in ASI cases in the following cases.
            return token() === 17 /* CloseBraceToken */ || token() === 1 /* EndOfFileToken */ || scanner.hasPrecedingLineBreak();
        }
--- END ---
INLINE (canParseSemicolon) id{68,31} AS 31 AT <30:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{68,32} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{68,32} AS 32 AT <31:98>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{68,33} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{68,33} AS 33 AT <31:290>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{68,34} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{68,34} AS 34 AT <31:330>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseTypeMemberSemicolon) id{69,0} ---
() {
            // We allow type members to be separated by commas or (possibly ASI) semicolons.
            // First check if it was a comma.  If so, we're done with the member.
            if (parseOptional(25 /* CommaToken */)) {
                return;
            }
            // Didn't have a comma.  We must have a (possible ASI) semicolon.
            parseSemicolon();
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseOptional) id{69,1} ---
(t) {
            if (token() === t) {
                nextToken();
                return true;
            }
            return false;
        }
--- END ---
INLINE (parseOptional) id{69,1} AS 1 AT <0:196>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{69,2} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{69,2} AS 2 AT <1:22>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{69,3} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{69,3} AS 3 AT <1:55>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseSemicolon) id{69,4} ---
() {
            if (canParseSemicolon()) {
                if (token() === 24 /* SemicolonToken */) {
                    // consume the semicolon if it was explicitly provided.
                    nextToken();
                }
                return true;
            }
            else {
                return parseExpected(24 /* SemicolonToken */);
            }
        }
--- END ---
INLINE (parseSemicolon) id{69,4} AS 4 AT <0:362>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:canParseSemicolon) id{69,5} ---
() {
            // If there's a real semicolon, then we can always parse it out.
            if (token() === 24 /* SemicolonToken */) {
                return true;
            }
            // We can parse out an optional semicolon in ASI cases in the following cases.
            return token() === 17 /* CloseBraceToken */ || token() === 1 /* EndOfFileToken */ || scanner.hasPrecedingLineBreak();
        }
--- END ---
INLINE (canParseSemicolon) id{69,5} AS 5 AT <4:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{69,6} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{69,6} AS 6 AT <5:98>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{69,7} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{69,7} AS 7 AT <5:290>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{69,8} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{69,8} AS 8 AT <5:330>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{69,9} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{69,9} AS 9 AT <4:64>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{69,10} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{69,10} AS 10 AT <4:199>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseTypeParameters) id{70,0} ---
() {
            if (token() === 26 /* LessThanToken */) {
                return parseBracketedList(18 /* TypeParameters */, parseTypeParameter, 26 /* LessThanToken */, 28 /* GreaterThanToken */);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{70,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{70,1} AS 1 AT <0:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseBracketedList) id{70,2} ---
(kind, parseElement, open, close) {
            if (parseExpected(open)) {
                var result = parseDelimitedList(kind, parseElement);
                parseExpected(close);
                return result;
            }
            return createMissingList();
        }
--- END ---
INLINE (parseBracketedList) id{70,2} AS 2 AT <0:82>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getJSDocCommentRanges) id{71,0} ---
(node, text) {
        var commentRanges = (node.kind === 144 /* Parameter */ ||
            node.kind === 143 /* TypeParameter */ ||
            node.kind === 184 /* FunctionExpression */ ||
            node.kind === 185 /* ArrowFunction */) ?
            ts.concatenate(ts.getTrailingCommentRanges(text, node.pos), ts.getLeadingCommentRanges(text, node.pos)) :
            getLeadingCommentRangesOfNodeFromText(node, text);
        // True if the comment starts with '/**' but not if it is '/**/'
        return ts.filter(commentRanges, function (comment) {
            return text.charCodeAt(comment.pos + 1) === 42 /* asterisk */ &&
                text.charCodeAt(comment.pos + 2) === 42 /* asterisk */ &&
                text.charCodeAt(comment.pos + 3) !== 47 /* slash */;
        });
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getLeadingCommentRangesOfNodeFromText) id{71,1} ---
(node, text) {
        return ts.getLeadingCommentRanges(text, node.pos);
    }
--- END ---
INLINE (getLeadingCommentRangesOfNodeFromText) id{71,1} AS 1 AT <0:375>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseTypeAnnotation) id{72,0} ---
() {
            return parseOptional(55 /* ColonToken */) ? parseType() : undefined;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseOptional) id{72,1} ---
(t) {
            if (token() === t) {
                nextToken();
                return true;
            }
            return false;
        }
--- END ---
INLINE (parseOptional) id{72,1} AS 1 AT <0:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{72,2} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{72,2} AS 2 AT <1:22>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{72,3} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{72,3} AS 3 AT <1:55>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseType) id{72,4} ---
() {
            // The rules about 'yield' only apply to actual code/expression contexts.  They don't
            // apply to 'type' contexts.  So we disable these parameters here before moving on.
            return doOutsideOfContext(20480 /* TypeExcludesFlags */, parseTypeWorker);
        }
--- END ---
INLINE (parseType) id{72,4} AS 4 AT <0:61>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:setContextFlag) id{73,0} ---
(val, flag) {
            if (val) {
                contextFlags |= flag;
            }
            else {
                contextFlags &= ~flag;
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:fillSignature) id{74,0} ---
(returnToken, yieldContext, awaitContext, requireCompleteParameterList, signature) {
            var returnTokenRequired = returnToken === 35 /* EqualsGreaterThanToken */;
            signature.typeParameters = parseTypeParameters();
            signature.parameters = parseParameterList(yieldContext, awaitContext, requireCompleteParameterList);
            if (returnTokenRequired) {
                parseExpected(returnToken);
                signature.type = parseTypeOrTypePredicate();
            }
            else if (parseOptional(returnToken)) {
                signature.type = parseTypeOrTypePredicate();
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseTypeParameters) id{74,1} ---
() {
            if (token() === 26 /* LessThanToken */) {
                return parseBracketedList(18 /* TypeParameters */, parseTypeParameter, 26 /* LessThanToken */, 28 /* GreaterThanToken */);
            }
        }
--- END ---
INLINE (parseTypeParameters) id{74,1} AS 1 AT <0:211>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{74,2} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{74,2} AS 2 AT <1:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseBracketedList) id{74,3} ---
(kind, parseElement, open, close) {
            if (parseExpected(open)) {
                var result = parseDelimitedList(kind, parseElement);
                parseExpected(close);
                return result;
            }
            return createMissingList();
        }
--- END ---
INLINE (parseBracketedList) id{74,3} AS 3 AT <1:82>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseTypeOrTypePredicate) id{74,4} ---
() {
            var typePredicateVariable = isIdentifier() && tryParse(parseTypePredicatePrefix);
            var type = parseType();
            if (typePredicateVariable) {
                var node = createNode(156 /* TypePredicate */, typePredicateVariable.pos);
                node.parameterName = typePredicateVariable;
                node.type = type;
                return finishNode(node);
            }
            else {
                return type;
            }
        }
--- END ---
INLINE (parseTypeOrTypePredicate) id{74,4} AS 4 AT <0:463>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:tryParse) id{74,5} ---
(callback) {
            return speculationHelper(callback, /*isLookAhead*/ false);
        }
--- END ---
INLINE (tryParse) id{74,5} AS 5 AT <4:63>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseType) id{74,6} ---
() {
            // The rules about 'yield' only apply to actual code/expression contexts.  They don't
            // apply to 'type' contexts.  So we disable these parameters here before moving on.
            return doOutsideOfContext(20480 /* TypeExcludesFlags */, parseTypeWorker);
        }
--- END ---
INLINE (parseType) id{74,6} AS 6 AT <4:122>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{74,7} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{74,7} AS 7 AT <4:203>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{74,8} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{74,8} AS 8 AT <7:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{74,9} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{74,9} AS 9 AT <7:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{74,10} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{74,10} AS 10 AT <7:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseOptional) id{74,11} ---
(t) {
            if (token() === t) {
                nextToken();
                return true;
            }
            return false;
        }
--- END ---
INLINE (parseOptional) id{74,11} AS 11 AT <0:526>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{74,12} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{74,12} AS 12 AT <11:22>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{74,13} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{74,13} AS 13 AT <11:55>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseTypeOrTypePredicate) id{74,14} ---
() {
            var typePredicateVariable = isIdentifier() && tryParse(parseTypePredicatePrefix);
            var type = parseType();
            if (typePredicateVariable) {
                var node = createNode(156 /* TypePredicate */, typePredicateVariable.pos);
                node.parameterName = typePredicateVariable;
                node.type = type;
                return finishNode(node);
            }
            else {
                return type;
            }
        }
--- END ---
INLINE (parseTypeOrTypePredicate) id{74,14} AS 14 AT <0:589>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:tryParse) id{74,15} ---
(callback) {
            return speculationHelper(callback, /*isLookAhead*/ false);
        }
--- END ---
INLINE (tryParse) id{74,15} AS 15 AT <14:63>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseType) id{74,16} ---
() {
            // The rules about 'yield' only apply to actual code/expression contexts.  They don't
            // apply to 'type' contexts.  So we disable these parameters here before moving on.
            return doOutsideOfContext(20480 /* TypeExcludesFlags */, parseTypeWorker);
        }
--- END ---
INLINE (parseType) id{74,16} AS 16 AT <14:122>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{74,17} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{74,17} AS 17 AT <14:203>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{74,18} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{74,18} AS 18 AT <17:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{74,19} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{74,19} AS 19 AT <17:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{74,20} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{74,20} AS 20 AT <17:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseParameterList) id{75,0} ---
(yieldContext, awaitContext, requireCompleteParameterList) {
            // FormalParameters [Yield,Await]: (modified)
            //      [empty]
            //      FormalParameterList[?Yield,Await]
            //
            // FormalParameter[Yield,Await]: (modified)
            //      BindingElement[?Yield,Await]
            //
            // BindingElement [Yield,Await]: (modified)
            //      SingleNameBinding[?Yield,?Await]
            //      BindingPattern[?Yield,?Await]Initializer [In, ?Yield,?Await] opt
            //
            // SingleNameBinding [Yield,Await]:
            //      BindingIdentifier[?Yield,?Await]Initializer [In, ?Yield,?Await] opt
            if (parseExpected(18 /* OpenParenToken */)) {
                var savedYieldContext = inYieldContext();
                var savedAwaitContext = inAwaitContext();
                setYieldContext(yieldContext);
                setAwaitContext(awaitContext);
                var result = parseDelimitedList(16 /* Parameters */, parseParameter);
                setYieldContext(savedYieldContext);
                setAwaitContext(savedAwaitContext);
                if (!parseExpected(19 /* CloseParenToken */) && requireCompleteParameterList) {
                    // Caller insisted that we had to end with a )   We didn't.  So just return
                    // undefined here.
                    return undefined;
                }
                return result;
            }
            // We didn't even have an open paren.  If the caller requires a complete parameter list,
            // we definitely can't provide that.  However, if they're ok with an incomplete one,
            // then just return an empty set of parameters.
            return requireCompleteParameterList ? undefined : createMissingList();
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:inYieldContext) id{75,1} ---
() {
            return inContext(4096 /* YieldContext */);
        }
--- END ---
INLINE (inYieldContext) id{75,1} AS 1 AT <0:779>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:inContext) id{75,2} ---
(flags) {
            return (contextFlags & flags) !== 0;
        }
--- END ---
INLINE (inContext) id{75,2} AS 2 AT <1:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:inAwaitContext) id{75,3} ---
() {
            return inContext(16384 /* AwaitContext */);
        }
--- END ---
INLINE (inAwaitContext) id{75,3} AS 3 AT <0:837>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:inContext) id{75,4} ---
(flags) {
            return (contextFlags & flags) !== 0;
        }
--- END ---
INLINE (inContext) id{75,4} AS 4 AT <3:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:setYieldContext) id{75,5} ---
(val) {
            setContextFlag(val, 4096 /* YieldContext */);
        }
--- END ---
INLINE (setYieldContext) id{75,5} AS 5 AT <0:871>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:setContextFlag) id{75,6} ---
(val, flag) {
            if (val) {
                contextFlags |= flag;
            }
            else {
                contextFlags &= ~flag;
            }
        }
--- END ---
INLINE (setContextFlag) id{75,6} AS 6 AT <5:20>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:setAwaitContext) id{75,7} ---
(val) {
            setContextFlag(val, 16384 /* AwaitContext */);
        }
--- END ---
INLINE (setAwaitContext) id{75,7} AS 7 AT <0:918>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:setContextFlag) id{75,8} ---
(val, flag) {
            if (val) {
                contextFlags |= flag;
            }
            else {
                contextFlags &= ~flag;
            }
        }
--- END ---
INLINE (setContextFlag) id{75,8} AS 8 AT <7:20>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:setYieldContext) id{75,9} ---
(val) {
            setContextFlag(val, 4096 /* YieldContext */);
        }
--- END ---
INLINE (setYieldContext) id{75,9} AS 9 AT <0:1051>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:setContextFlag) id{75,10} ---
(val, flag) {
            if (val) {
                contextFlags |= flag;
            }
            else {
                contextFlags &= ~flag;
            }
        }
--- END ---
INLINE (setContextFlag) id{75,10} AS 10 AT <9:20>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:setAwaitContext) id{75,11} ---
(val) {
            setContextFlag(val, 16384 /* AwaitContext */);
        }
--- END ---
INLINE (setAwaitContext) id{75,11} AS 11 AT <0:1103>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:setContextFlag) id{75,12} ---
(val, flag) {
            if (val) {
                contextFlags |= flag;
            }
            else {
                contextFlags &= ~flag;
            }
        }
--- END ---
INLINE (setContextFlag) id{75,12} AS 12 AT <11:20>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseNonArrayType) id{76,0} ---
() {
            switch (token()) {
                case 118 /* AnyKeyword */:
                case 134 /* StringKeyword */:
                case 132 /* NumberKeyword */:
                case 121 /* BooleanKeyword */:
                case 135 /* SymbolKeyword */:
                case 137 /* UndefinedKeyword */:
                case 129 /* NeverKeyword */:
                    // If these are followed by a dot, then parse these out as a dotted type reference instead.
                    var node = tryParse(parseKeywordAndNoDot);
                    return node || parseTypeReference();
                case 9 /* StringLiteral */:
                case 8 /* NumericLiteral */:
                case 100 /* TrueKeyword */:
                case 85 /* FalseKeyword */:
                    return parseLiteralTypeNode();
                case 37 /* MinusToken */:
                    return lookAhead(nextTokenIsNumericLiteral) ? parseLiteralTypeNode() : parseTypeReference();
                case 104 /* VoidKeyword */:
                case 94 /* NullKeyword */:
                    return parseTokenNode();
                case 98 /* ThisKeyword */: {
                    var thisKeyword = parseThisTypeNode();
                    if (token() === 125 /* IsKeyword */ && !scanner.hasPrecedingLineBreak()) {
                        return parseThisTypePredicate(thisKeyword);
                    }
                    else {
                        return thisKeyword;
                    }
                }
                case 102 /* TypeOfKeyword */:
                    return parseTypeQuery();
                case 16 /* OpenBraceToken */:
                    return lookAhead(isStartOfMappedType) ? parseMappedType() : parseTypeLiteral();
                case 20 /* OpenBracketToken */:
                    return parseTupleType();
                case 18 /* OpenParenToken */:
                    return parseParenthesizedType();
                default:
                    return parseTypeReference();
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{76,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{76,1} AS 1 AT <0:25>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:tryParse) id{76,2} ---
(callback) {
            return speculationHelper(callback, /*isLookAhead*/ false);
        }
--- END ---
INLINE (tryParse) id{76,2} AS 2 AT <0:501>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseLiteralTypeNode) id{76,3} ---
() {
            var node = createNode(171 /* LiteralType */);
            node.literal = parseSimpleUnaryExpression();
            finishNode(node);
            return node;
        }
--- END ---
INLINE (parseLiteralTypeNode) id{76,3} AS 3 AT <0:794>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{76,4} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{76,4} AS 4 AT <3:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{76,5} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{76,5} AS 5 AT <4:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{76,6} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{76,6} AS 6 AT <4:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{76,7} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{76,7} AS 7 AT <4:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseTokenNode) id{76,8} ---
() {
            var node = createNode(token());
            nextToken();
            return finishNode(node);
        }
--- END ---
INLINE (parseTokenNode) id{76,8} AS 8 AT <0:1087>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{76,9} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{76,9} AS 9 AT <8:39>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{76,10} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{76,10} AS 10 AT <8:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{76,11} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{76,11} AS 11 AT <10:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{76,12} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{76,12} AS 12 AT <10:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{76,13} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{76,13} AS 13 AT <10:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{76,14} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{76,14} AS 14 AT <8:61>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseThisTypeNode) id{76,15} ---
() {
            var node = createNode(167 /* ThisType */);
            nextToken();
            return finishNode(node);
        }
--- END ---
INLINE (parseThisTypeNode) id{76,15} AS 15 AT <0:1188>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{76,16} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{76,16} AS 16 AT <15:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{76,17} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{76,17} AS 17 AT <16:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{76,18} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{76,18} AS 18 AT <16:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{76,19} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{76,19} AS 19 AT <16:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{76,20} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{76,20} AS 20 AT <15:72>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:lookAhead) id{77,0} ---
(callback) {
            return speculationHelper(callback, /*isLookahead*/ true);
        }
--- END ---
[deoptimizing (DEOPT eager): begin 0xd6230d98dd9 <JS Function doOutsideOfContext (SharedFunctionInfo 0x3504a53f1271)> (opt #58) @3, FP to SP delta: 248, caller sp: 0x7fff5fbfd820]
            ;;; deoptimize at 0_966: value mismatch
  reading input frame doOutsideOfContext => node=33, args=3, height=3; inputs:
      0: 0xd6230d98dd9 ; [fp - 16] 0xd6230d98dd9 <JS Function doOutsideOfContext (SharedFunctionInfo 0x3504a53f1271)>
      1: 0x1f9f6c0532e1 ; [fp + 32] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x80000000000 ; [fp + 24] 2048
      3: 0xd6230dd54c1 ; rbx 0xd6230dd54c1 <JS Function parseNonParameterInitializer (SharedFunctionInfo 0x3504a53fd271)>
      4: 0xd6230d980d1 ; rax 0xd6230d980d1 <FixedArray[334]>
      5: 0x30bcea4069a9 ; (literal 36) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      6: 0x30bcea404311 ; (literal 35) 0x30bcea404311 <undefined>
  translating frame doOutsideOfContext => node=33, height=16
    0x7fff5fbfd818: [top + 64] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd810: [top + 56] <- 0x80000000000 ;  2048  (input #2)
    0x7fff5fbfd808: [top + 48] <- 0xd6230dd54c1 ;  0xd6230dd54c1 <JS Function parseNonParameterInitializer (SharedFunctionInfo 0x3504a53fd271)>  (input #3)
    0x7fff5fbfd800: [top + 40] <- 0x2c21d2486284 ;  caller's pc
    0x7fff5fbfd7f8: [top + 32] <- 0x7fff5fbfd838 ;  caller's fp
    0x7fff5fbfd7f0: [top + 24] <- 0xd6230d980d1 ;  context    0xd6230d980d1 <FixedArray[334]>  (input #4)
    0x7fff5fbfd7e8: [top + 16] <- 0xd6230d98dd9 ;  function    0xd6230d98dd9 <JS Function doOutsideOfContext (SharedFunctionInfo 0x3504a53f1271)>  (input #0)
    0x7fff5fbfd7e0: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #5)
    0x7fff5fbfd7d8: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
[deoptimizing (eager): end 0xd6230d98dd9 <JS Function doOutsideOfContext (SharedFunctionInfo 0x3504a53f1271)> @3 => node=33, pc=0x2c21d241fd33, caller sp=0x7fff5fbfd820, state=NO_REGISTERS, took 0.068 ms]
[deoptimizing (DEOPT soft): begin 0xd6230db10c1 <JS Function isLiteralPropertyName (SharedFunctionInfo 0x3504a53f34f1)> (opt #56) @6, FP to SP delta: 32, caller sp: 0x7fff5fbfdad0]
            ;;; deoptimize at 0_90: Insufficient type feedback for combined type of binary operation
  reading input frame isLiteralPropertyName => node=40, args=1, height=2; inputs:
      0: 0xd6230db10c1 ; [fp - 16] 0xd6230db10c1 <JS Function isLiteralPropertyName (SharedFunctionInfo 0x3504a53f34f1)>
      1: 0x1f9f6c0532e1 ; [fp + 16] 0x1f9f6c0532e1 <JS Global Object>
      2: 0xd6230d980d1 ; [fp - 24] 0xd6230d980d1 <FixedArray[334]>
      3: 0x3900000000 ; rax 57
  translating frame isLiteralPropertyName => node=40, height=8
    0x7fff5fbfdac8: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdac0: [top + 32] <- 0x2c21d243d441 ;  caller's pc
    0x7fff5fbfdab8: [top + 24] <- 0x7fff5fbfdae8 ;  caller's fp
    0x7fff5fbfdab0: [top + 16] <- 0xd6230d980d1 ;  context    0xd6230d980d1 <FixedArray[334]>  (input #2)
    0x7fff5fbfdaa8: [top + 8] <- 0xd6230db10c1 ;  function    0xd6230db10c1 <JS Function isLiteralPropertyName (SharedFunctionInfo 0x3504a53f34f1)>  (input #0)
    0x7fff5fbfdaa0: [top + 0] <- 0x3900000000 ;  57  (input #3)
[deoptimizing (soft): end 0xd6230db10c1 <JS Function isLiteralPropertyName (SharedFunctionInfo 0x3504a53f34f1)> @6 => node=40, pc=0x2c21d241e24c, caller sp=0x7fff5fbfdad0, state=NO_REGISTERS, took 0.045 ms]
[deoptimizing (DEOPT soft): begin 0xd6230db05c9 <JS Function scan (SharedFunctionInfo 0x16f3adb53cc1)> (opt #43) @128, FP to SP delta: 128, caller sp: 0x7fff5fbfdb80]
            ;;; deoptimize at 0_4271: Insufficient type feedback for LHS of binary operation
  reading input frame scan => node=1095, args=1, height=9; inputs:
      0: 0xd6230db05c9 ; [fp - 16] 0xd6230db05c9 <JS Function scan (SharedFunctionInfo 0x16f3adb53cc1)>
      1: 0xd6230dd29d9 ; [fp + 16] 0xd6230dd29d9 <an Object with map 0x33abe2a503e9>
      2: 0xd6230dd5e59 ; rbx 0xd6230dd5e59 <FixedArray[39]>
      3: 0x30bcea4069a9 ; (literal 8) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      4: 0x30bcea4069a9 ; (literal 8) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      5: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
      6: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
      7: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
      9: 0x101bfd309889 ; [fp - 64] 0x101bfd309889 <Very long string[189592]>
     10: 0x30bcea4b47a9 ; rax 0x30bcea4b47a9 <JS Function charCodeAt (SharedFunctionInfo 0x30bcea46c659)>
  translating frame scan => node=1095, height=64
    0x7fff5fbfdb78: [top + 96] <- 0xd6230dd29d9 ;  0xd6230dd29d9 <an Object with map 0x33abe2a503e9>  (input #1)
    0x7fff5fbfdb70: [top + 88] <- 0x2c21d242b099 ;  caller's pc
    0x7fff5fbfdb68: [top + 80] <- 0x7fff5fbfdb98 ;  caller's fp
    0x7fff5fbfdb60: [top + 72] <- 0xd6230dd5e59 ;  context    0xd6230dd5e59 <FixedArray[39]>  (input #2)
    0x7fff5fbfdb58: [top + 64] <- 0xd6230db05c9 ;  function    0xd6230db05c9 <JS Function scan (SharedFunctionInfo 0x16f3adb53cc1)>  (input #0)
    0x7fff5fbfdb50: [top + 56] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #3)
    0x7fff5fbfdb48: [top + 48] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #4)
    0x7fff5fbfdb40: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfdb38: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfdb30: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfdb28: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfdb20: [top + 8] <- 0x101bfd309889 ;  0x101bfd309889 <Very long string[189592]>  (input #9)
    0x7fff5fbfdb18: [top + 0] <- 0x30bcea4b47a9 ;  0x30bcea4b47a9 <JS Function charCodeAt (SharedFunctionInfo 0x30bcea46c659)>  (input #10)
[deoptimizing (soft): end 0xd6230db05c9 <JS Function scan (SharedFunctionInfo 0x16f3adb53cc1)> @128 => node=1095, pc=0x2c21d2408694, caller sp=0x7fff5fbfdb80, state=TOS_REGISTER, took 0.080 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:scan) id{78,0} ---
() {
            startPos = pos;
            hasExtendedUnicodeEscape = false;
            precedingLineBreak = false;
            tokenIsUnterminated = false;
            while (true) {
                tokenPos = pos;
                if (pos >= end) {
                    return token = 1 /* EndOfFileToken */;
                }
                var ch = text.charCodeAt(pos);
                // Special handling for shebang
                if (ch === 35 /* hash */ && pos === 0 && isShebangTrivia(text, pos)) {
                    pos = scanShebangTrivia(text, pos);
                    if (skipTrivia) {
                        continue;
                    }
                    else {
                        return token = 6 /* ShebangTrivia */;
                    }
                }
                switch (ch) {
                    case 10 /* lineFeed */:
                    case 13 /* carriageReturn */:
                        precedingLineBreak = true;
                        if (skipTrivia) {
                            pos++;
                            continue;
                        }
                        else {
                            if (ch === 13 /* carriageReturn */ && pos + 1 < end && text.charCodeAt(pos + 1) === 10 /* lineFeed */) {
                                // consume both CR and LF
                                pos += 2;
                            }
                            else {
                                pos++;
                            }
                            return token = 4 /* NewLineTrivia */;
                        }
                    case 9 /* tab */:
                    case 11 /* verticalTab */:
                    case 12 /* formFeed */:
                    case 32 /* space */:
                        if (skipTrivia) {
                            pos++;
                            continue;
                        }
                        else {
                            while (pos < end && isWhiteSpaceSingleLine(text.charCodeAt(pos))) {
                                pos++;
                            }
                            return token = 5 /* WhitespaceTrivia */;
                        }
                    case 33 /* exclamation */:
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            if (text.charCodeAt(pos + 2) === 61 /* equals */) {
                                return pos += 3, token = 34 /* ExclamationEqualsEqualsToken */;
                            }
                            return pos += 2, token = 32 /* ExclamationEqualsToken */;
                        }
                        pos++;
                        return token = 50 /* ExclamationToken */;
                    case 34 /* doubleQuote */:
                    case 39 /* singleQuote */:
                        tokenValue = scanString();
                        return token = 9 /* StringLiteral */;
                    case 96 /* backtick */:
                        return token = scanTemplateAndSetTokenValue();
                    case 37 /* percent */:
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 63 /* PercentEqualsToken */;
                        }
                        pos++;
                        return token = 41 /* PercentToken */;
                    case 38 /* ampersand */:
                        if (text.charCodeAt(pos + 1) === 38 /* ampersand */) {
                            return pos += 2, token = 52 /* AmpersandAmpersandToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 67 /* AmpersandEqualsToken */;
                        }
                        pos++;
                        return token = 47 /* AmpersandToken */;
                    case 40 /* openParen */:
                        pos++;
                        return token = 18 /* OpenParenToken */;
                    case 41 /* closeParen */:
                        pos++;
                        return token = 19 /* CloseParenToken */;
                    case 42 /* asterisk */:
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 60 /* AsteriskEqualsToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 42 /* asterisk */) {
                            if (text.charCodeAt(pos + 2) === 61 /* equals */) {
                                return pos += 3, token = 61 /* AsteriskAsteriskEqualsToken */;
                            }
                            return pos += 2, token = 39 /* AsteriskAsteriskToken */;
                        }
                        pos++;
                        return token = 38 /* AsteriskToken */;
                    case 43 /* plus */:
                        if (text.charCodeAt(pos + 1) === 43 /* plus */) {
                            return pos += 2, token = 42 /* PlusPlusToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 58 /* PlusEqualsToken */;
                        }
                        pos++;
                        return token = 36 /* PlusToken */;
                    case 44 /* comma */:
                        pos++;
                        return token = 25 /* CommaToken */;
                    case 45 /* minus */:
                        if (text.charCodeAt(pos + 1) === 45 /* minus */) {
                            return pos += 2, token = 43 /* MinusMinusToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 59 /* MinusEqualsToken */;
                        }
                        pos++;
                        return token = 37 /* MinusToken */;
                    case 46 /* dot */:
                        if (isDigit(text.charCodeAt(pos + 1))) {
                            tokenValue = scanNumber();
                            return token = 8 /* NumericLiteral */;
                        }
                        if (text.charCodeAt(pos + 1) === 46 /* dot */ && text.charCodeAt(pos + 2) === 46 /* dot */) {
                            return pos += 3, token = 23 /* DotDotDotToken */;
                        }
                        pos++;
                        return token = 22 /* DotToken */;
                    case 47 /* slash */:
                        // Single-line comment
                        if (text.charCodeAt(pos + 1) === 47 /* slash */) {
                            pos += 2;
                            while (pos < end) {
                                if (isLineBreak(text.charCodeAt(pos))) {
                                    break;
                                }
                                pos++;
                            }
                            if (skipTrivia) {
                                continue;
                            }
                            else {
                                return token = 2 /* SingleLineCommentTrivia */;
                            }
                        }
                        // Multi-line comment
                        if (text.charCodeAt(pos + 1) === 42 /* asterisk */) {
                            pos += 2;
                            var commentClosed = false;
                            while (pos < end) {
                                var ch_2 = text.charCodeAt(pos);
                                if (ch_2 === 42 /* asterisk */ && text.charCodeAt(pos + 1) === 47 /* slash */) {
                                    pos += 2;
                                    commentClosed = true;
                                    break;
                                }
                                if (isLineBreak(ch_2)) {
                                    precedingLineBreak = true;
                                }
                                pos++;
                            }
                            if (!commentClosed) {
                                error(ts.Diagnostics.Asterisk_Slash_expected);
                            }
                            if (skipTrivia) {
                                continue;
                            }
                            else {
                                tokenIsUnterminated = !commentClosed;
                                return token = 3 /* MultiLineCommentTrivia */;
                            }
                        }
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 62 /* SlashEqualsToken */;
                        }
                        pos++;
                        return token = 40 /* SlashToken */;
                    case 48 /* _0 */:
                        if (pos + 2 < end && (text.charCodeAt(pos + 1) === 88 /* X */ || text.charCodeAt(pos + 1) === 120 /* x */)) {
                            pos += 2;
                            var value = scanMinimumNumberOfHexDigits(1);
                            if (value < 0) {
                                error(ts.Diagnostics.Hexadecimal_digit_expected);
                                value = 0;
                            }
                            tokenValue = "" + value;
                            return token = 8 /* NumericLiteral */;
                        }
                        else if (pos + 2 < end && (text.charCodeAt(pos + 1) === 66 /* B */ || text.charCodeAt(pos + 1) === 98 /* b */)) {
                            pos += 2;
                            var value = scanBinaryOrOctalDigits(/* base */ 2);
                            if (value < 0) {
                                error(ts.Diagnostics.Binary_digit_expected);
                                value = 0;
                            }
                            tokenValue = "" + value;
                            return token = 8 /* NumericLiteral */;
                        }
                        else if (pos + 2 < end && (text.charCodeAt(pos + 1) === 79 /* O */ || text.charCodeAt(pos + 1) === 111 /* o */)) {
                            pos += 2;
                            var value = scanBinaryOrOctalDigits(/* base */ 8);
                            if (value < 0) {
                                error(ts.Diagnostics.Octal_digit_expected);
                                value = 0;
                            }
                            tokenValue = "" + value;
                            return token = 8 /* NumericLiteral */;
                        }
                        // Try to parse as an octal
                        if (pos + 1 < end && isOctalDigit(text.charCodeAt(pos + 1))) {
                            tokenValue = "" + scanOctalDigits();
                            return token = 8 /* NumericLiteral */;
                        }
                    // This fall-through is a deviation from the EcmaScript grammar. The grammar says that a leading zero
                    // can only be followed by an octal digit, a dot, or the end of the number literal. However, we are being
                    // permissive and allowing decimal digits of the form 08* and 09* (which many browsers also do).
                    case 49 /* _1 */:
                    case 50 /* _2 */:
                    case 51 /* _3 */:
                    case 52 /* _4 */:
                    case 53 /* _5 */:
                    case 54 /* _6 */:
                    case 55 /* _7 */:
                    case 56 /* _8 */:
                    case 57 /* _9 */:
                        tokenValue = scanNumber();
                        return token = 8 /* NumericLiteral */;
                    case 58 /* colon */:
                        pos++;
                        return token = 55 /* ColonToken */;
                    case 59 /* semicolon */:
                        pos++;
                        return token = 24 /* SemicolonToken */;
                    case 60 /* lessThan */:
                        if (isConflictMarkerTrivia(text, pos)) {
                            pos = scanConflictMarkerTrivia(text, pos, error);
                            if (skipTrivia) {
                                continue;
                            }
                            else {
                                return token = 7 /* ConflictMarkerTrivia */;
                            }
                        }
                        if (text.charCodeAt(pos + 1) === 60 /* lessThan */) {
                            if (text.charCodeAt(pos + 2) === 61 /* equals */) {
                                return pos += 3, token = 64 /* LessThanLessThanEqualsToken */;
                            }
                            return pos += 2, token = 44 /* LessThanLessThanToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 29 /* LessThanEqualsToken */;
                        }
                        if (languageVariant === 1 /* JSX */ &&
                            text.charCodeAt(pos + 1) === 47 /* slash */ &&
                            text.charCodeAt(pos + 2) !== 42 /* asterisk */) {
                            return pos += 2, token = 27 /* LessThanSlashToken */;
                        }
                        pos++;
                        return token = 26 /* LessThanToken */;
                    case 61 /* equals */:
                        if (isConflictMarkerTrivia(text, pos)) {
                            pos = scanConflictMarkerTrivia(text, pos, error);
                            if (skipTrivia) {
                                continue;
                            }
                            else {
                                return token = 7 /* ConflictMarkerTrivia */;
                            }
                        }
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            if (text.charCodeAt(pos + 2) === 61 /* equals */) {
                                return pos += 3, token = 33 /* EqualsEqualsEqualsToken */;
                            }
                            return pos += 2, token = 31 /* EqualsEqualsToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 62 /* greaterThan */) {
                            return pos += 2, token = 35 /* EqualsGreaterThanToken */;
                        }
                        pos++;
                        return token = 57 /* EqualsToken */;
                    case 62 /* greaterThan */:
                        if (isConflictMarkerTrivia(text, pos)) {
                            pos = scanConflictMarkerTrivia(text, pos, error);
                            if (skipTrivia) {
                                continue;
                            }
                            else {
                                return token = 7 /* ConflictMarkerTrivia */;
                            }
                        }
                        pos++;
                        return token = 28 /* GreaterThanToken */;
                    case 63 /* question */:
                        pos++;
                        return token = 54 /* QuestionToken */;
                    case 91 /* openBracket */:
                        pos++;
                        return token = 20 /* OpenBracketToken */;
                    case 93 /* closeBracket */:
                        pos++;
                        return token = 21 /* CloseBracketToken */;
                    case 94 /* caret */:
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 69 /* CaretEqualsToken */;
                        }
                        pos++;
                        return token = 49 /* CaretToken */;
                    case 123 /* openBrace */:
                        pos++;
                        return token = 16 /* OpenBraceToken */;
                    case 124 /* bar */:
                        if (text.charCodeAt(pos + 1) === 124 /* bar */) {
                            return pos += 2, token = 53 /* BarBarToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 68 /* BarEqualsToken */;
                        }
                        pos++;
                        return token = 48 /* BarToken */;
                    case 125 /* closeBrace */:
                        pos++;
                        return token = 17 /* CloseBraceToken */;
                    case 126 /* tilde */:
                        pos++;
                        return token = 51 /* TildeToken */;
                    case 64 /* at */:
                        pos++;
                        return token = 56 /* AtToken */;
                    case 92 /* backslash */:
                        var cookedChar = peekUnicodeEscape();
                        if (cookedChar >= 0 && isIdentifierStart(cookedChar, languageVersion)) {
                            pos += 6;
                            tokenValue = String.fromCharCode(cookedChar) + scanIdentifierParts();
                            return token = getIdentifierToken();
                        }
                        error(ts.Diagnostics.Invalid_character);
                        pos++;
                        return token = 0 /* Unknown */;
                    default:
                        if (isIdentifierStart(ch, languageVersion)) {
                            pos++;
                            while (pos < end && isIdentifierPart(ch = text.charCodeAt(pos), languageVersion))
                                pos++;
                            tokenValue = text.substring(tokenPos, pos);
                            if (ch === 92 /* backslash */) {
                                tokenValue += scanIdentifierParts();
                            }
                            return token = getIdentifierToken();
                        }
                        else if (isWhiteSpaceSingleLine(ch)) {
                            pos++;
                            continue;
                        }
                        else if (isLineBreak(ch)) {
                            precedingLineBreak = true;
                            pos++;
                            continue;
                        }
                        error(ts.Diagnostics.Invalid_character);
                        pos++;
                        return token = 0 /* Unknown */;
                }
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isDigit) id{78,1} ---
(ch) {
        return ch >= 48 /* _0 */ && ch <= 57 /* _9 */;
    }
--- END ---
INLINE (isDigit) id{78,1} AS 1 AT <0:6077>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIdentifierStart) id{78,2} ---
(ch, languageVersion) {
        return ch >= 65 /* A */ && ch <= 90 /* Z */ || ch >= 97 /* a */ && ch <= 122 /* z */ ||
            ch === 36 /* $ */ || ch === 95 /* _ */ ||
            ch > 127 /* maxAsciiCharacter */ && isUnicodeIdentifierStart(ch, languageVersion);
    }
--- END ---
INLINE (isIdentifierStart) id{78,2} AS 2 AT <0:17770>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIdentifierPart) id{78,3} ---
(ch, languageVersion) {
        return ch >= 65 /* A */ && ch <= 90 /* Z */ || ch >= 97 /* a */ && ch <= 122 /* z */ ||
            ch >= 48 /* _0 */ && ch <= 57 /* _9 */ || ch === 36 /* $ */ || ch === 95 /* _ */ ||
            ch > 127 /* maxAsciiCharacter */ && isUnicodeIdentifierPart(ch, languageVersion);
    }
--- END ---
INLINE (isIdentifierPart) id{78,3} AS 3 AT <0:17895>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isStartOfLeftHandSideExpression) id{79,0} ---
() {
            switch (token()) {
                case 98 /* ThisKeyword */:
                case 96 /* SuperKeyword */:
                case 94 /* NullKeyword */:
                case 100 /* TrueKeyword */:
                case 85 /* FalseKeyword */:
                case 8 /* NumericLiteral */:
                case 9 /* StringLiteral */:
                case 12 /* NoSubstitutionTemplateLiteral */:
                case 13 /* TemplateHead */:
                case 18 /* OpenParenToken */:
                case 20 /* OpenBracketToken */:
                case 16 /* OpenBraceToken */:
                case 88 /* FunctionKeyword */:
                case 74 /* ClassKeyword */:
                case 93 /* NewKeyword */:
                case 40 /* SlashToken */:
                case 62 /* SlashEqualsToken */:
                case 70 /* Identifier */:
                    return true;
                default:
                    return isIdentifier();
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{79,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{79,1} AS 1 AT <0:25>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseTypePredicatePrefix) id{80,0} ---
() {
            var id = parseIdentifier();
            if (token() === 125 /* IsKeyword */ && !scanner.hasPrecedingLineBreak()) {
                nextToken();
                return id;
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseIdentifier) id{80,1} ---
(diagnosticMessage) {
            return createIdentifier(isIdentifier(), diagnosticMessage);
        }
--- END ---
INLINE (parseIdentifier) id{80,1} AS 1 AT <0:26>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{80,2} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{80,2} AS 2 AT <0:61>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{80,3} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{80,3} AS 3 AT <0:148>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:doOutsideOfContext) id{81,0} ---
(context, func) {
            // contextFlagsToClear will contain only the context flags that are
            // currently set that we need to temporarily clear
            // We don't just blindly reset to the previous flags to ensure
            // that we do not mutate cached flags for the incremental
            // parser (ThisNodeHasError, ThisNodeOrAnySubNodesHasError, and
            // HasAggregatedChildData).
            var contextFlagsToClear = context & contextFlags;
            if (contextFlagsToClear) {
                // clear the requested context flags
                setContextFlag(/*val*/ false, contextFlagsToClear);
                var result = func();
                // restore the context flags we just cleared
                setContextFlag(/*val*/ true, contextFlagsToClear);
                return result;
            }
            // no need to do anything special as we are not in any of the requested contexts
            return func();
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getBinaryOperatorPrecedence) id{82,0} ---
() {
            switch (token()) {
                case 53 /* BarBarToken */:
                    return 1;
                case 52 /* AmpersandAmpersandToken */:
                    return 2;
                case 48 /* BarToken */:
                    return 3;
                case 49 /* CaretToken */:
                    return 4;
                case 47 /* AmpersandToken */:
                    return 5;
                case 31 /* EqualsEqualsToken */:
                case 32 /* ExclamationEqualsToken */:
                case 33 /* EqualsEqualsEqualsToken */:
                case 34 /* ExclamationEqualsEqualsToken */:
                    return 6;
                case 26 /* LessThanToken */:
                case 28 /* GreaterThanToken */:
                case 29 /* LessThanEqualsToken */:
                case 30 /* GreaterThanEqualsToken */:
                case 92 /* InstanceOfKeyword */:
                case 91 /* InKeyword */:
                case 117 /* AsKeyword */:
                    return 7;
                case 44 /* LessThanLessThanToken */:
                case 45 /* GreaterThanGreaterThanToken */:
                case 46 /* GreaterThanGreaterThanGreaterThanToken */:
                    return 8;
                case 36 /* PlusToken */:
                case 37 /* MinusToken */:
                    return 9;
                case 38 /* AsteriskToken */:
                case 40 /* SlashToken */:
                case 41 /* PercentToken */:
                    return 10;
                case 39 /* AsteriskAsteriskToken */:
                    return 11;
            }
            // -1 is lower than all other precedences.  Returning it will cause binary expression
            // parsing to stop.
            return -1;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{82,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{82,1} AS 1 AT <0:25>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isStartOfExpression) id{83,0} ---
() {
            if (isStartOfLeftHandSideExpression()) {
                return true;
            }
            switch (token()) {
                case 36 /* PlusToken */:
                case 37 /* MinusToken */:
                case 51 /* TildeToken */:
                case 50 /* ExclamationToken */:
                case 79 /* DeleteKeyword */:
                case 102 /* TypeOfKeyword */:
                case 104 /* VoidKeyword */:
                case 42 /* PlusPlusToken */:
                case 43 /* MinusMinusToken */:
                case 26 /* LessThanToken */:
                case 120 /* AwaitKeyword */:
                case 115 /* YieldKeyword */:
                    // Yield/await always starts an expression.  Either it is an identifier (in which case
                    // it is definitely an expression).  Or it's a keyword (either because we're in
                    // a generator or async function, or in strict mode (or both)) and it started a yield or await expression.
                    return true;
                default:
                    // Error tolerance.  If we see the start of some binary operator, we consider
                    // that the start of an expression.  That way we'll parse out a missing identifier,
                    // give a good message about an identifier being missing, and then consume the
                    // rest of the binary expression.
                    if (isBinaryOperator()) {
                        return true;
                    }
                    return isIdentifier();
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{83,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{83,1} AS 1 AT <0:121>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isBinaryOperator) id{83,2} ---
() {
            if (inDisallowInContext() && token() === 91 /* InKeyword */) {
                return false;
            }
            return getBinaryOperatorPrecedence() > 0;
        }
--- END ---
INLINE (isBinaryOperator) id{83,2} AS 2 AT <0:1438>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:inDisallowInContext) id{83,3} ---
() {
            return inContext(2048 /* DisallowInContext */);
        }
--- END ---
INLINE (inDisallowInContext) id{83,3} AS 3 AT <2:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:inContext) id{83,4} ---
(flags) {
            return (contextFlags & flags) !== 0;
        }
--- END ---
INLINE (inContext) id{83,4} AS 4 AT <3:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseParameter) id{84,0} ---
() {
            var node = createNode(144 /* Parameter */);
            if (token() === 98 /* ThisKeyword */) {
                node.name = createIdentifier(/*isIdentifier*/ true, undefined);
                node.type = parseParameterType();
                return finishNode(node);
            }
            node.decorators = parseDecorators();
            node.modifiers = parseModifiers();
            node.dotDotDotToken = parseOptionalToken(23 /* DotDotDotToken */);
            // FormalParameter [Yield,Await]:
            //      BindingElement[?Yield,?Await]
            node.name = parseIdentifierOrPattern();
            if (ts.getFullWidth(node.name) === 0 && !ts.hasModifiers(node) && ts.isModifierKind(token())) {
                // in cases like
                // 'use strict'
                // function foo(static)
                // isParameter('static') === true, because of isModifier('static')
                // however 'static' is not a legal identifier in a strict mode.
                // so result of this function will be ParameterDeclaration (flags = 0, name = missing, type = undefined, initializer = undefined)
                // and current token will not change => parsing of the enclosing parameter list will last till the end of time (or OOM)
                // to avoid this we'll advance cursor to the next token.
                nextToken();
            }
            node.questionToken = parseOptionalToken(54 /* QuestionToken */);
            node.type = parseParameterType();
            node.initializer = parseBindingElementInitializer(/*inParameter*/ true);
            // Do not check for initializers in an ambient context for parameters. This is not
            // a grammar error because the grammar allows arbitrary call signatures in
            // an ambient context.
            // It is actually not necessary for this to be an error at all. The reason is that
            // function/constructor implementations are syntactically disallowed in ambient
            // contexts. In addition, parameter initializers are semantically disallowed in
            // overload signatures. So parameter initializers are transitively disallowed in
            // ambient contexts.
            return addJSDocComment(finishNode(node));
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{84,1} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{84,1} AS 1 AT <0:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{84,2} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{84,2} AS 2 AT <1:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{84,3} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{84,3} AS 3 AT <1:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{84,4} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{84,4} AS 4 AT <1:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{84,5} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{84,5} AS 5 AT <0:77>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseOptionalToken) id{84,6} ---
(t) {
            if (token() === t) {
                return parseTokenNode();
            }
            return undefined;
        }
--- END ---
INLINE (parseOptionalToken) id{84,6} AS 6 AT <0:428>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{84,7} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{84,7} AS 7 AT <6:22>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseTokenNode) id{84,8} ---
() {
            var node = createNode(token());
            nextToken();
            return finishNode(node);
        }
--- END ---
INLINE (parseTokenNode) id{84,8} AS 8 AT <6:62>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{84,9} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{84,9} AS 9 AT <8:39>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{84,10} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{84,10} AS 10 AT <8:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{84,11} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{84,11} AS 11 AT <10:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{84,12} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{84,12} AS 12 AT <10:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{84,13} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{84,13} AS 13 AT <10:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{84,14} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{84,14} AS 14 AT <8:61>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseIdentifierOrPattern) id{84,15} ---
() {
            if (token() === 20 /* OpenBracketToken */) {
                return parseArrayBindingPattern();
            }
            if (token() === 16 /* OpenBraceToken */) {
                return parseObjectBindingPattern();
            }
            return parseIdentifier();
        }
--- END ---
INLINE (parseIdentifierOrPattern) id{84,15} AS 15 AT <0:593>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{84,16} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{84,16} AS 16 AT <15:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{84,17} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{84,17} AS 17 AT <15:143>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseIdentifier) id{84,18} ---
(diagnosticMessage) {
            return createIdentifier(isIdentifier(), diagnosticMessage);
        }
--- END ---
INLINE (parseIdentifier) id{84,18} AS 18 AT <15:267>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseOptionalToken) id{84,19} ---
(t) {
            if (token() === t) {
                return parseTokenNode();
            }
            return undefined;
        }
--- END ---
INLINE (parseOptionalToken) id{84,19} AS 19 AT <0:1428>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{84,20} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{84,20} AS 20 AT <19:22>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseTokenNode) id{84,21} ---
() {
            var node = createNode(token());
            nextToken();
            return finishNode(node);
        }
--- END ---
INLINE (parseTokenNode) id{84,21} AS 21 AT <19:62>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{84,22} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{84,22} AS 22 AT <21:39>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{84,23} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{84,23} AS 23 AT <21:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{84,24} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{84,24} AS 24 AT <23:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{84,25} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{84,25} AS 25 AT <23:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{84,26} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{84,26} AS 26 AT <23:327>
[deoptimizing (DEOPT eager): begin 0xd6230d98eb1 <JS Function fillSignature (SharedFunctionInfo 0x3504a53f5fb1)> (opt #74) @13, FP to SP delta: 272, caller sp: 0x7fff5fbfdaf8]
            ;;; deoptimize at 0_209: Unknown map in polymorphic access
  reading input frame fillSignature => node=40, args=6, height=4; inputs:
      0: 0xd6230d98eb1 ; [fp - 16] 0xd6230d98eb1 <JS Function fillSignature (SharedFunctionInfo 0x3504a53f5fb1)>
      1: 0x1f9f6c0532e1 ; [fp + 56] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x3700000000 ; [fp + 48] 55
      3: 0x30bcea404421 ; [fp + 40] 0x30bcea404421 <false>
      4: 0x30bcea404421 ; [fp + 32] 0x30bcea404421 <false>
      5: 0x30bcea404421 ; [fp + 24] 0x30bcea404421 <false>
      6: 0x139ed251cbb9 ; rbx 0x139ed251cbb9 <a NodeObject with map 0x33abe2a66a71>
      7: 0xd6230d980d1 ; [fp - 24] 0xd6230d980d1 <FixedArray[334]>
      8: 0x30bcea404421 ; [fp - 32] 0x30bcea404421 <false>
      9: 0x139ed251cbb9 ; rbx 0x139ed251cbb9 <a NodeObject with map 0x33abe2a66a71>
     10: 0x30bcea404311 ; rax 0x30bcea404311 <undefined>
  translating frame fillSignature => node=40, height=24
    0x7fff5fbfdaf0: [top + 96] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdae8: [top + 88] <- 0x3700000000 ;  55  (input #2)
    0x7fff5fbfdae0: [top + 80] <- 0x30bcea404421 ;  0x30bcea404421 <false>  (input #3)
    0x7fff5fbfdad8: [top + 72] <- 0x30bcea404421 ;  0x30bcea404421 <false>  (input #4)
    0x7fff5fbfdad0: [top + 64] <- 0x30bcea404421 ;  0x30bcea404421 <false>  (input #5)
    0x7fff5fbfdac8: [top + 56] <- 0x139ed251cbb9 ;  0x139ed251cbb9 <a NodeObject with map 0x33abe2a66a71>  (input #6)
    0x7fff5fbfdac0: [top + 48] <- 0x2c21d249405f ;  caller's pc
    0x7fff5fbfdab8: [top + 40] <- 0x7fff5fbfdb18 ;  caller's fp
    0x7fff5fbfdab0: [top + 32] <- 0xd6230d980d1 ;  context    0xd6230d980d1 <FixedArray[334]>  (input #7)
    0x7fff5fbfdaa8: [top + 24] <- 0xd6230d98eb1 ;  function    0xd6230d98eb1 <JS Function fillSignature (SharedFunctionInfo 0x3504a53f5fb1)>  (input #0)
    0x7fff5fbfdaa0: [top + 16] <- 0x30bcea404421 ;  0x30bcea404421 <false>  (input #8)
    0x7fff5fbfda98: [top + 8] <- 0x139ed251cbb9 ;  0x139ed251cbb9 <a NodeObject with map 0x33abe2a66a71>  (input #9)
    0x7fff5fbfda90: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #10)
[deoptimizing (eager): end 0xd6230d98eb1 <JS Function fillSignature (SharedFunctionInfo 0x3504a53f5fb1)> @13 => node=40, pc=0x2c21d2423f7b, caller sp=0x7fff5fbfdaf8, state=TOS_REGISTER, took 0.129 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseTypeOrTypePredicate) id{85,0} ---
() {
            var typePredicateVariable = isIdentifier() && tryParse(parseTypePredicatePrefix);
            var type = parseType();
            if (typePredicateVariable) {
                var node = createNode(156 /* TypePredicate */, typePredicateVariable.pos);
                node.parameterName = typePredicateVariable;
                node.type = type;
                return finishNode(node);
            }
            else {
                return type;
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:tryParse) id{85,1} ---
(callback) {
            return speculationHelper(callback, /*isLookAhead*/ false);
        }
--- END ---
INLINE (tryParse) id{85,1} AS 1 AT <0:63>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseType) id{85,2} ---
() {
            // The rules about 'yield' only apply to actual code/expression contexts.  They don't
            // apply to 'type' contexts.  So we disable these parameters here before moving on.
            return doOutsideOfContext(20480 /* TypeExcludesFlags */, parseTypeWorker);
        }
--- END ---
INLINE (parseType) id{85,2} AS 2 AT <0:122>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{85,3} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{85,3} AS 3 AT <0:203>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{85,4} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{85,4} AS 4 AT <3:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{85,5} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{85,5} AS 5 AT <3:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{85,6} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{85,6} AS 6 AT <3:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isStartOfDeclaration) id{86,0} ---
() {
            return lookAhead(isDeclaration);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:lookAhead) id{86,1} ---
(callback) {
            return speculationHelper(callback, /*isLookAhead*/ true);
        }
--- END ---
INLINE (lookAhead) id{86,1} AS 1 AT <0:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isLiteralPropertyName) id{87,0} ---
() {
            return ts.tokenIsIdentifierOrKeyword(token()) ||
                token() === 9 /* StringLiteral */ ||
                token() === 8 /* NumericLiteral */;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{87,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{87,1} AS 1 AT <0:54>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{87,2} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{87,2} AS 2 AT <0:82>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{87,3} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{87,3} AS 3 AT <0:135>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isListElement) id{88,0} ---
(parsingContext, inErrorRecovery) {
            var node = currentNode(parsingContext);
            if (node) {
                return true;
            }
            switch (parsingContext) {
                case 0 /* SourceElements */:
                case 1 /* BlockStatements */:
                case 3 /* SwitchClauseStatements */:
                    // If we're in error recovery, then we don't want to treat ';' as an empty statement.
                    // The problem is that ';' can show up in far too many contexts, and if we see one
                    // and assume it's a statement, then we may bail out inappropriately from whatever
                    // we're parsing.  For example, if we have a semicolon in the middle of a class, then
                    // we really don't want to assume the class is over and we're on a statement in the
                    // outer module.  We just want to consume and move on.
                    return !(token() === 24 /* SemicolonToken */ && inErrorRecovery) && isStartOfStatement();
                case 2 /* SwitchClauses */:
                    return token() === 72 /* CaseKeyword */ || token() === 78 /* DefaultKeyword */;
                case 4 /* TypeMembers */:
                    return lookAhead(isTypeMemberStart);
                case 5 /* ClassMembers */:
                    // We allow semicolons as class elements (as specified by ES6) as long as we're
                    // not in error recovery.  If we're in error recovery, we don't want an errant
                    // semicolon to be treated as a class member (since they're almost always used
                    // for statements.
                    return lookAhead(isClassMemberStart) || (token() === 24 /* SemicolonToken */ && !inErrorRecovery);
                case 6 /* EnumMembers */:
                    // Include open bracket computed properties. This technically also lets in indexers,
                    // which would be a candidate for improved error reporting.
                    return token() === 20 /* OpenBracketToken */ || isLiteralPropertyName();
                case 12 /* ObjectLiteralMembers */:
                    return token() === 20 /* OpenBracketToken */ || token() === 38 /* AsteriskToken */ || token() === 23 /* DotDotDotToken */ || isLiteralPropertyName();
                case 17 /* RestProperties */:
                    return isLiteralPropertyName();
                case 9 /* ObjectBindingElements */:
                    return token() === 20 /* OpenBracketToken */ || token() === 23 /* DotDotDotToken */ || isLiteralPropertyName();
                case 7 /* HeritageClauseElement */:
                    // If we see { } then only consume it as an expression if it is followed by , or {
                    // That way we won't consume the body of a class in its heritage clause.
                    if (token() === 16 /* OpenBraceToken */) {
                        return lookAhead(isValidHeritageClauseObjectLiteral);
                    }
                    if (!inErrorRecovery) {
                        return isStartOfLeftHandSideExpression() && !isHeritageClauseExtendsOrImplementsKeyword();
                    }
                    else {
                        // If we're in error recovery we tighten up what we're willing to match.
                        // That way we don't treat something like "this" as a valid heritage clause
                        // element during recovery.
                        return isIdentifier() && !isHeritageClauseExtendsOrImplementsKeyword();
                    }
                case 8 /* VariableDeclarations */:
                    return isIdentifierOrPattern();
                case 10 /* ArrayBindingElements */:
                    return token() === 25 /* CommaToken */ || token() === 23 /* DotDotDotToken */ || isIdentifierOrPattern();
                case 18 /* TypeParameters */:
                    return isIdentifier();
                case 11 /* ArgumentExpressions */:
                case 15 /* ArrayLiteralMembers */:
                    return token() === 25 /* CommaToken */ || token() === 23 /* DotDotDotToken */ || isStartOfExpression();
                case 16 /* Parameters */:
                    return isStartOfParameter();
                case 19 /* TypeArguments */:
                case 20 /* TupleElementTypes */:
                    return token() === 25 /* CommaToken */ || isStartOfType();
                case 21 /* HeritageClauses */:
                    return isHeritageClause();
                case 22 /* ImportOrExportSpecifiers */:
                    return ts.tokenIsIdentifierOrKeyword(token());
                case 13 /* JsxAttributes */:
                    return ts.tokenIsIdentifierOrKeyword(token()) || token() === 16 /* OpenBraceToken */;
                case 14 /* JsxChildren */:
                    return true;
                case 23 /* JSDocFunctionParameters */:
                case 24 /* JSDocTypeArguments */:
                case 26 /* JSDocTupleTypes */:
                    return JSDocParser.isJSDocType();
                case 25 /* JSDocRecordMembers */:
                    return isSimplePropertyName();
            }
            ts.Debug.fail("Non-exhaustive case in 'isListElement'.");
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{88,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{88,1} AS 1 AT <0:963>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:lookAhead) id{88,2} ---
(callback) {
            return speculationHelper(callback, /*isLookAhead*/ true);
        }
--- END ---
INLINE (lookAhead) id{88,2} AS 2 AT <0:1257>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:lookAhead) id{88,3} ---
(callback) {
            return speculationHelper(callback, /*isLookAhead*/ true);
        }
--- END ---
INLINE (lookAhead) id{88,3} AS 3 AT <0:1694>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{88,4} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{88,4} AS 4 AT <0:2882>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isHeritageClauseExtendsOrImplementsKeyword) id{88,5} ---
() {
            if (token() === 107 /* ImplementsKeyword */ ||
                token() === 84 /* ExtendsKeyword */) {
                return lookAhead(nextTokenIsStartOfExpression);
            }
            return false;
        }
--- END ---
INLINE (isHeritageClauseExtendsOrImplementsKeyword) id{88,5} AS 5 AT <0:3134>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{88,6} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{88,6} AS 6 AT <5:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{88,7} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{88,7} AS 7 AT <5:80>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIdentifierOrPattern) id{88,8} ---
() {
            return token() === 16 /* OpenBraceToken */ || token() === 20 /* OpenBracketToken */ || isIdentifier();
        }
--- END ---
INLINE (isIdentifierOrPattern) id{88,8} AS 8 AT <0:3674>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{88,9} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{88,9} AS 9 AT <8:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{88,10} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{88,10} AS 10 AT <8:63>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isStartOfParameter) id{88,11} ---
() {
            return token() === 23 /* DotDotDotToken */ || isIdentifierOrPattern() || ts.isModifierKind(token()) || token() === 56 /* AtToken */ || token() === 98 /* ThisKeyword */;
        }
--- END ---
INLINE (isStartOfParameter) id{88,11} AS 11 AT <0:4261>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{88,12} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{88,12} AS 12 AT <11:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIdentifierOrPattern) id{88,13} ---
() {
            return token() === 16 /* OpenBraceToken */ || token() === 20 /* OpenBracketToken */ || isIdentifier();
        }
--- END ---
INLINE (isIdentifierOrPattern) id{88,13} AS 13 AT <11:63>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{88,14} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{88,14} AS 14 AT <13:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{88,15} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{88,15} AS 15 AT <13:63>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{88,16} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{88,16} AS 16 AT <11:108>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{88,17} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{88,17} AS 17 AT <11:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{88,18} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{88,18} AS 18 AT <11:152>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{88,19} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{88,19} AS 19 AT <0:4404>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isHeritageClause) id{88,20} ---
() {
            return token() === 84 /* ExtendsKeyword */ || token() === 107 /* ImplementsKeyword */;
        }
--- END ---
INLINE (isHeritageClause) id{88,20} AS 20 AT <0:4530>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{88,21} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{88,21} AS 21 AT <20:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{88,22} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{88,22} AS 22 AT <20:63>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{88,23} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{88,23} AS 23 AT <0:4663>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseContextualModifier) id{89,0} ---
(t) {
            return token() === t && tryParse(nextTokenCanFollowModifier);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{89,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{89,1} AS 1 AT <0:25>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:inDecoratorContext) id{90,0} ---
() {
            return inContext(8192 /* DecoratorContext */);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:inContext) id{90,1} ---
(flags) {
            return (contextFlags & flags) !== 0;
        }
--- END ---
INLINE (inContext) id{90,1} AS 1 AT <0:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isListTerminator) id{91,0} ---
(kind) {
            if (token() === 1 /* EndOfFileToken */) {
                // Being at the end of the file ends all lists.
                return true;
            }
            switch (kind) {
                case 1 /* BlockStatements */:
                case 2 /* SwitchClauses */:
                case 4 /* TypeMembers */:
                case 5 /* ClassMembers */:
                case 6 /* EnumMembers */:
                case 12 /* ObjectLiteralMembers */:
                case 9 /* ObjectBindingElements */:
                case 22 /* ImportOrExportSpecifiers */:
                    return token() === 17 /* CloseBraceToken */;
                case 3 /* SwitchClauseStatements */:
                    return token() === 17 /* CloseBraceToken */ || token() === 72 /* CaseKeyword */ || token() === 78 /* DefaultKeyword */;
                case 7 /* HeritageClauseElement */:
                    return token() === 16 /* OpenBraceToken */ || token() === 84 /* ExtendsKeyword */ || token() === 107 /* ImplementsKeyword */;
                case 8 /* VariableDeclarations */:
                    return isVariableDeclaratorListTerminator();
                case 18 /* TypeParameters */:
                    // Tokens other than '>' are here for better error recovery
                    return token() === 28 /* GreaterThanToken */ || token() === 18 /* OpenParenToken */ || token() === 16 /* OpenBraceToken */ || token() === 84 /* ExtendsKeyword */ || token() === 107 /* ImplementsKeyword */;
                case 11 /* ArgumentExpressions */:
                    // Tokens other than ')' are here for better error recovery
                    return token() === 19 /* CloseParenToken */ || token() === 24 /* SemicolonToken */;
                case 15 /* ArrayLiteralMembers */:
                case 20 /* TupleElementTypes */:
                case 10 /* ArrayBindingElements */:
                    return token() === 21 /* CloseBracketToken */;
                case 16 /* Parameters */:
                case 17 /* RestProperties */:
                    // Tokens other than ')' and ']' (the latter for index signatures) are here for better error recovery
                    return token() === 19 /* CloseParenToken */ || token() === 21 /* CloseBracketToken */ /*|| token === SyntaxKind.OpenBraceToken*/;
                case 19 /* TypeArguments */:
                    // All other tokens should cause the type-argument to terminate except comma token
                    return token() !== 25 /* CommaToken */;
                case 21 /* HeritageClauses */:
                    return token() === 16 /* OpenBraceToken */ || token() === 17 /* CloseBraceToken */;
                case 13 /* JsxAttributes */:
                    return token() === 28 /* GreaterThanToken */ || token() === 40 /* SlashToken */;
                case 14 /* JsxChildren */:
                    return token() === 26 /* LessThanToken */ && lookAhead(nextTokenIsSlash);
                case 23 /* JSDocFunctionParameters */:
                    return token() === 19 /* CloseParenToken */ || token() === 55 /* ColonToken */ || token() === 17 /* CloseBraceToken */;
                case 24 /* JSDocTypeArguments */:
                    return token() === 28 /* GreaterThanToken */ || token() === 17 /* CloseBraceToken */;
                case 26 /* JSDocTupleTypes */:
                    return token() === 21 /* CloseBracketToken */ || token() === 17 /* CloseBraceToken */;
                case 25 /* JSDocRecordMembers */:
                    return token() === 17 /* CloseBraceToken */;
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{91,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{91,1} AS 1 AT <0:25>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{91,2} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{91,2} AS 2 AT <0:602>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{91,3} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{91,3} AS 3 AT <0:912>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{91,4} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{91,4} AS 4 AT <0:1300>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{91,5} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{91,5} AS 5 AT <0:1913>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{91,6} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{91,6} AS 6 AT <0:2190>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{91,7} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{91,7} AS 7 AT <0:2230>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{91,8} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{91,8} AS 8 AT <0:2488>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{91,9} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{91,9} AS 9 AT <0:2595>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{91,10} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{91,10} AS 10 AT <0:2634>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parsePropertyOrMethodSignature) id{92,0} ---
(fullStart, modifiers) {
            var name = parsePropertyName();
            var questionToken = parseOptionalToken(54 /* QuestionToken */);
            if (token() === 18 /* OpenParenToken */ || token() === 26 /* LessThanToken */) {
                var method = createNode(148 /* MethodSignature */, fullStart);
                method.modifiers = modifiers;
                method.name = name;
                method.questionToken = questionToken;
                // Method signatures don't exist in expression contexts.  So they have neither
                // [Yield] nor [Await]
                fillSignature(55 /* ColonToken */, /*yieldContext*/ false, /*awaitContext*/ false, /*requireCompleteParameterList*/ false, method);
                parseTypeMemberSemicolon();
                return addJSDocComment(finishNode(method));
            }
            else {
                var property = createNode(146 /* PropertySignature */, fullStart);
                property.modifiers = modifiers;
                property.name = name;
                property.questionToken = questionToken;
                property.type = parseTypeAnnotation();
                if (token() === 57 /* EqualsToken */) {
                    // Although type literal properties cannot not have initializers, we attempt
                    // to parse an initializer so we can report in the checker that an interface
                    // property or type literal property cannot have an initializer.
                    property.initializer = parseNonParameterInitializer();
                }
                parseTypeMemberSemicolon();
                return addJSDocComment(finishNode(property));
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parsePropertyName) id{92,1} ---
() {
            return parsePropertyNameWorker(/*allowComputedPropertyNames*/ true);
        }
--- END ---
INLINE (parsePropertyName) id{92,1} AS 1 AT <0:48>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parsePropertyNameWorker) id{92,2} ---
(allowComputedPropertyNames) {
            if (token() === 9 /* StringLiteral */ || token() === 8 /* NumericLiteral */) {
                return parseLiteralNode(/*internName*/ true);
            }
            if (allowComputedPropertyNames && token() === 20 /* OpenBracketToken */) {
                return parseComputedPropertyName();
            }
            return parseIdentifierName();
        }
--- END ---
INLINE (parsePropertyNameWorker) id{92,2} AS 2 AT <1:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{92,3} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{92,3} AS 3 AT <2:47>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{92,4} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{92,4} AS 4 AT <2:84>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{92,5} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{92,5} AS 5 AT <2:244>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseIdentifierName) id{92,6} ---
() {
            return createIdentifier(ts.tokenIsIdentifierOrKeyword(token()));
        }
--- END ---
INLINE (parseIdentifierName) id{92,6} AS 6 AT <2:370>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{92,7} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{92,7} AS 7 AT <6:71>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseOptionalToken) id{92,8} ---
(t) {
            if (token() === t) {
                return parseTokenNode();
            }
            return undefined;
        }
--- END ---
INLINE (parseOptionalToken) id{92,8} AS 8 AT <0:101>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{92,9} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{92,9} AS 9 AT <8:22>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseTokenNode) id{92,10} ---
() {
            var node = createNode(token());
            nextToken();
            return finishNode(node);
        }
--- END ---
INLINE (parseTokenNode) id{92,10} AS 10 AT <8:62>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{92,11} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{92,11} AS 11 AT <10:39>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{92,12} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{92,12} AS 12 AT <10:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{92,13} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{92,13} AS 13 AT <12:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{92,14} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{92,14} AS 14 AT <12:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{92,15} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{92,15} AS 15 AT <12:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{92,16} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{92,16} AS 16 AT <10:61>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{92,17} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{92,17} AS 17 AT <0:161>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{92,18} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{92,18} AS 18 AT <0:200>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{92,19} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{92,19} AS 19 AT <0:267>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{92,20} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{92,20} AS 20 AT <19:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{92,21} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{92,21} AS 21 AT <19:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{92,22} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{92,22} AS 22 AT <19:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseTypeMemberSemicolon) id{92,23} ---
() {
            // We allow type members to be separated by commas or (possibly ASI) semicolons.
            // First check if it was a comma.  If so, we're done with the member.
            if (parseOptional(25 /* CommaToken */)) {
                return;
            }
            // Didn't have a comma.  We must have a (possible ASI) semicolon.
            parseSemicolon();
        }
--- END ---
INLINE (parseTypeMemberSemicolon) id{92,23} AS 23 AT <0:751>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseOptional) id{92,24} ---
(t) {
            if (token() === t) {
                nextToken();
                return true;
            }
            return false;
        }
--- END ---
INLINE (parseOptional) id{92,24} AS 24 AT <23:196>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{92,25} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{92,25} AS 25 AT <24:22>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{92,26} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{92,26} AS 26 AT <24:55>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseSemicolon) id{92,27} ---
() {
            if (canParseSemicolon()) {
                if (token() === 24 /* SemicolonToken */) {
                    // consume the semicolon if it was explicitly provided.
                    nextToken();
                }
                return true;
            }
            else {
                return parseExpected(24 /* SemicolonToken */);
            }
        }
--- END ---
INLINE (parseSemicolon) id{92,27} AS 27 AT <23:362>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:canParseSemicolon) id{92,28} ---
() {
            // If there's a real semicolon, then we can always parse it out.
            if (token() === 24 /* SemicolonToken */) {
                return true;
            }
            // We can parse out an optional semicolon in ASI cases in the following cases.
            return token() === 17 /* CloseBraceToken */ || token() === 1 /* EndOfFileToken */ || scanner.hasPrecedingLineBreak();
        }
--- END ---
INLINE (canParseSemicolon) id{92,28} AS 28 AT <27:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{92,29} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{92,29} AS 29 AT <28:98>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{92,30} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{92,30} AS 30 AT <28:290>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{92,31} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{92,31} AS 31 AT <28:330>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{92,32} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{92,32} AS 32 AT <27:64>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{92,33} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{92,33} AS 33 AT <27:199>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:fillSignature) id{93,0} ---
(returnToken, yieldContext, awaitContext, requireCompleteParameterList, signature) {
            var returnTokenRequired = returnToken === 35 /* EqualsGreaterThanToken */;
            signature.typeParameters = parseTypeParameters();
            signature.parameters = parseParameterList(yieldContext, awaitContext, requireCompleteParameterList);
            if (returnTokenRequired) {
                parseExpected(returnToken);
                signature.type = parseTypeOrTypePredicate();
            }
            else if (parseOptional(returnToken)) {
                signature.type = parseTypeOrTypePredicate();
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseTypeParameters) id{93,1} ---
() {
            if (token() === 26 /* LessThanToken */) {
                return parseBracketedList(18 /* TypeParameters */, parseTypeParameter, 26 /* LessThanToken */, 28 /* GreaterThanToken */);
            }
        }
--- END ---
INLINE (parseTypeParameters) id{93,1} AS 1 AT <0:211>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{93,2} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{93,2} AS 2 AT <1:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseBracketedList) id{93,3} ---
(kind, parseElement, open, close) {
            if (parseExpected(open)) {
                var result = parseDelimitedList(kind, parseElement);
                parseExpected(close);
                return result;
            }
            return createMissingList();
        }
--- END ---
INLINE (parseBracketedList) id{93,3} AS 3 AT <1:82>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseTypeOrTypePredicate) id{93,4} ---
() {
            var typePredicateVariable = isIdentifier() && tryParse(parseTypePredicatePrefix);
            var type = parseType();
            if (typePredicateVariable) {
                var node = createNode(156 /* TypePredicate */, typePredicateVariable.pos);
                node.parameterName = typePredicateVariable;
                node.type = type;
                return finishNode(node);
            }
            else {
                return type;
            }
        }
--- END ---
INLINE (parseTypeOrTypePredicate) id{93,4} AS 4 AT <0:463>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:tryParse) id{93,5} ---
(callback) {
            return speculationHelper(callback, /*isLookAhead*/ false);
        }
--- END ---
INLINE (tryParse) id{93,5} AS 5 AT <4:63>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseType) id{93,6} ---
() {
            // The rules about 'yield' only apply to actual code/expression contexts.  They don't
            // apply to 'type' contexts.  So we disable these parameters here before moving on.
            return doOutsideOfContext(20480 /* TypeExcludesFlags */, parseTypeWorker);
        }
--- END ---
INLINE (parseType) id{93,6} AS 6 AT <4:122>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{93,7} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{93,7} AS 7 AT <4:203>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{93,8} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{93,8} AS 8 AT <7:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{93,9} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{93,9} AS 9 AT <7:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{93,10} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{93,10} AS 10 AT <7:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseOptional) id{93,11} ---
(t) {
            if (token() === t) {
                nextToken();
                return true;
            }
            return false;
        }
--- END ---
INLINE (parseOptional) id{93,11} AS 11 AT <0:526>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{93,12} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{93,12} AS 12 AT <11:22>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{93,13} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{93,13} AS 13 AT <11:55>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseTypeOrTypePredicate) id{93,14} ---
() {
            var typePredicateVariable = isIdentifier() && tryParse(parseTypePredicatePrefix);
            var type = parseType();
            if (typePredicateVariable) {
                var node = createNode(156 /* TypePredicate */, typePredicateVariable.pos);
                node.parameterName = typePredicateVariable;
                node.type = type;
                return finishNode(node);
            }
            else {
                return type;
            }
        }
--- END ---
INLINE (parseTypeOrTypePredicate) id{93,14} AS 14 AT <0:589>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:tryParse) id{93,15} ---
(callback) {
            return speculationHelper(callback, /*isLookAhead*/ false);
        }
--- END ---
INLINE (tryParse) id{93,15} AS 15 AT <14:63>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseType) id{93,16} ---
() {
            // The rules about 'yield' only apply to actual code/expression contexts.  They don't
            // apply to 'type' contexts.  So we disable these parameters here before moving on.
            return doOutsideOfContext(20480 /* TypeExcludesFlags */, parseTypeWorker);
        }
--- END ---
INLINE (parseType) id{93,16} AS 16 AT <14:122>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{93,17} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{93,17} AS 17 AT <14:203>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{93,18} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{93,18} AS 18 AT <17:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{93,19} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{93,19} AS 19 AT <17:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{93,20} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{93,20} AS 20 AT <17:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseTypeReference) id{94,0} ---
() {
            var typeName = parseEntityName(/*allowReservedWords*/ false, ts.Diagnostics.Type_expected);
            var node = createNode(157 /* TypeReference */, typeName.pos);
            node.typeName = typeName;
            if (!scanner.hasPrecedingLineBreak() && token() === 26 /* LessThanToken */) {
                node.typeArguments = parseBracketedList(19 /* TypeArguments */, parseType, 26 /* LessThanToken */, 28 /* GreaterThanToken */);
            }
            return finishNode(node);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseEntityName) id{94,1} ---
(allowReservedWords, diagnosticMessage) {
            var entity = parseIdentifier(diagnosticMessage);
            while (parseOptional(22 /* DotToken */)) {
                var node = createNode(141 /* QualifiedName */, entity.pos); // !!!
                node.left = entity;
                node.right = parseRightSideOfDot(allowReservedWords);
                entity = finishNode(node);
            }
            return entity;
        }
--- END ---
INLINE (parseEntityName) id{94,1} AS 1 AT <0:32>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseIdentifier) id{94,2} ---
(diagnosticMessage) {
            return createIdentifier(isIdentifier(), diagnosticMessage);
        }
--- END ---
INLINE (parseIdentifier) id{94,2} AS 2 AT <1:67>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseOptional) id{94,3} ---
(t) {
            if (token() === t) {
                nextToken();
                return true;
            }
            return false;
        }
--- END ---
INLINE (parseOptional) id{94,3} AS 3 AT <1:122>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{94,4} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{94,4} AS 4 AT <3:22>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{94,5} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{94,5} AS 5 AT <3:55>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{94,6} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{94,6} AS 6 AT <1:185>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{94,7} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{94,7} AS 7 AT <6:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{94,8} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{94,8} AS 8 AT <6:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{94,9} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{94,9} AS 9 AT <6:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{94,10} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{94,10} AS 10 AT <0:132>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{94,11} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{94,11} AS 11 AT <10:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{94,12} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{94,12} AS 12 AT <10:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{94,13} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{94,13} AS 13 AT <10:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{94,14} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{94,14} AS 14 AT <0:273>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseBracketedList) id{94,15} ---
(kind, parseElement, open, close) {
            if (parseExpected(open)) {
                var result = parseDelimitedList(kind, parseElement);
                parseExpected(close);
                return result;
            }
            return createMissingList();
        }
--- END ---
INLINE (parseBracketedList) id{94,15} AS 15 AT <0:348>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:hasModifier) id{95,0} ---
(node, flags) {
        return (getModifierFlags(node) & flags) !== 0;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:canParseSemicolon) id{96,0} ---
() {
            // If there's a real semicolon, then we can always parse it out.
            if (token() === 24 /* SemicolonToken */) {
                return true;
            }
            // We can parse out an optional semicolon in ASI cases in the following cases.
            return token() === 17 /* CloseBraceToken */ || token() === 1 /* EndOfFileToken */ || scanner.hasPrecedingLineBreak();
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{96,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{96,1} AS 1 AT <0:98>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{96,2} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{96,2} AS 2 AT <0:290>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{96,3} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{96,3} AS 3 AT <0:330>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseLeftHandSideExpressionOrHigher) id{97,0} ---
() {
            // Original Ecma:
            // LeftHandSideExpression: See 11.2
            //      NewExpression
            //      CallExpression
            //
            // Our simplification:
            //
            // LeftHandSideExpression: See 11.2
            //      MemberExpression
            //      CallExpression
            //
            // See comment in parseMemberExpressionOrHigher on how we replaced NewExpression with
            // MemberExpression to make our lives easier.
            //
            // to best understand the below code, it's important to see how CallExpression expands
            // out into its own productions:
            //
            // CallExpression:
            //      MemberExpression Arguments
            //      CallExpression Arguments
            //      CallExpression[Expression]
            //      CallExpression.IdentifierName
            //      super   (   ArgumentListopt   )
            //      super.IdentifierName
            //
            // Because of the recursion in these calls, we need to bottom out first.  There are two
            // bottom out states we can run into.  Either we see 'super' which must start either of
            // the last two CallExpression productions.  Or we have a MemberExpression which either
            // completes the LeftHandSideExpression, or starts the beginning of the first four
            // CallExpression productions.
            var expression = token() === 96 /* SuperKeyword */
                ? parseSuperExpression()
                : parseMemberExpressionOrHigher();
            // Now, we *may* be complete.  However, we might have consumed the start of a
            // CallExpression.  As such, we need to consume the rest of it here to be complete.
            return parseCallExpressionRest(expression);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{97,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{97,1} AS 1 AT <0:1477>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseMemberExpressionOrHigher) id{98,0} ---
() {
            // Note: to make our lives simpler, we decompose the the NewExpression productions and
            // place ObjectCreationExpression and FunctionExpression into PrimaryExpression.
            // like so:
            //
            //   PrimaryExpression : See 11.1
            //      this
            //      Identifier
            //      Literal
            //      ArrayLiteral
            //      ObjectLiteral
            //      (Expression)
            //      FunctionExpression
            //      new MemberExpression Arguments?
            //
            //   MemberExpression : See 11.2
            //      PrimaryExpression
            //      MemberExpression[Expression]
            //      MemberExpression.IdentifierName
            //
            //   CallExpression : See 11.2
            //      MemberExpression
            //      CallExpression Arguments
            //      CallExpression[Expression]
            //      CallExpression.IdentifierName
            //
            // Technically this is ambiguous.  i.e. CallExpression defines:
            //
            //   CallExpression:
            //      CallExpression Arguments
            //
            // If you see: "new Foo()"
            //
            // Then that could be treated as a single ObjectCreationExpression, or it could be
            // treated as the invocation of "new Foo".  We disambiguate that in code (to match
            // the original grammar) by making sure that if we see an ObjectCreationExpression
            // we always consume arguments if they are there. So we treat "new Foo()" as an
            // object creation only, and not at all as an invocation)  Another way to think
            // about this is that for every "new" that we see, we will consume an argument list if
            // it is there as part of the *associated* object creation node.  Any additional
            // argument lists we see, will become invocation expressions.
            //
            // Because there are no other places in the grammar now that refer to FunctionExpression
            // or ObjectCreationExpression, it is safe to push down into the PrimaryExpression
            // production.
            //
            // Because CallExpression and MemberExpression are left recursive, we need to bottom out
            // of the recursion immediately.  So we parse out a primary expression to start with.
            var expression = parsePrimaryExpression();
            return parseMemberExpressionRest(expression);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseFunctionBlockOrSemicolon) id{99,0} ---
(isGenerator, isAsync, diagnosticMessage) {
            if (token() !== 16 /* OpenBraceToken */ && canParseSemicolon()) {
                parseSemicolon();
                return;
            }
            return parseFunctionBlock(isGenerator, isAsync, /*ignoreMissingOpenBrace*/ false, diagnosticMessage);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{99,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{99,1} AS 1 AT <0:60>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:canParseSemicolon) id{99,2} ---
() {
            // If there's a real semicolon, then we can always parse it out.
            if (token() === 24 /* SemicolonToken */) {
                return true;
            }
            // We can parse out an optional semicolon in ASI cases in the following cases.
            return token() === 17 /* CloseBraceToken */ || token() === 1 /* EndOfFileToken */ || scanner.hasPrecedingLineBreak();
        }
--- END ---
INLINE (canParseSemicolon) id{99,2} AS 2 AT <0:99>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{99,3} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{99,3} AS 3 AT <2:98>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{99,4} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{99,4} AS 4 AT <2:290>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{99,5} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{99,5} AS 5 AT <2:330>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseSemicolon) id{99,6} ---
() {
            if (canParseSemicolon()) {
                if (token() === 24 /* SemicolonToken */) {
                    // consume the semicolon if it was explicitly provided.
                    nextToken();
                }
                return true;
            }
            else {
                return parseExpected(24 /* SemicolonToken */);
            }
        }
--- END ---
INLINE (parseSemicolon) id{99,6} AS 6 AT <0:138>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:canParseSemicolon) id{99,7} ---
() {
            // If there's a real semicolon, then we can always parse it out.
            if (token() === 24 /* SemicolonToken */) {
                return true;
            }
            // We can parse out an optional semicolon in ASI cases in the following cases.
            return token() === 17 /* CloseBraceToken */ || token() === 1 /* EndOfFileToken */ || scanner.hasPrecedingLineBreak();
        }
--- END ---
INLINE (canParseSemicolon) id{99,7} AS 7 AT <6:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{99,8} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{99,8} AS 8 AT <7:98>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{99,9} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{99,9} AS 9 AT <7:290>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{99,10} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{99,10} AS 10 AT <7:330>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{99,11} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{99,11} AS 11 AT <6:64>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{99,12} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{99,12} AS 12 AT <6:199>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseLiteralNode) id{100,0} ---
(internName) {
            return parseLiteralLikeNode(token(), internName);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{100,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{100,1} AS 1 AT <0:55>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:hasExtendedUnicodeEscape) id{101,0} ---
() { return hasExtendedUnicodeEscape; }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isUnterminated) id{102,0} ---
() { return tokenIsUnterminated; }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:canFollowModifier) id{103,0} ---
() {
            return token() === 20 /* OpenBracketToken */
                || token() === 16 /* OpenBraceToken */
                || token() === 38 /* AsteriskToken */
                || token() === 23 /* DotDotDotToken */
                || isLiteralPropertyName();
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{103,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{103,1} AS 1 AT <0:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{103,2} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{103,2} AS 2 AT <0:81>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{103,3} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{103,3} AS 3 AT <0:136>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{103,4} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{103,4} AS 4 AT <0:190>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isLiteralPropertyName) id{103,5} ---
() {
            return ts.tokenIsIdentifierOrKeyword(token()) ||
                token() === 9 /* StringLiteral */ ||
                token() === 8 /* NumericLiteral */;
        }
--- END ---
INLINE (isLiteralPropertyName) id{103,5} AS 5 AT <0:245>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{103,6} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{103,6} AS 6 AT <5:54>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{103,7} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{103,7} AS 7 AT <5:82>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{103,8} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{103,8} AS 8 AT <5:135>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isLeftHandSideExpression) id{104,0} ---
(node) {
        return isLeftHandSideExpressionKind(ts.skipPartiallyEmittedExpressions(node).kind);
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:skipParameterStart) id{105,0} ---
() {
            if (ts.isModifierKind(token())) {
                // Skip modifiers
                parseModifiers();
            }
            if (isIdentifier() || token() === 98 /* ThisKeyword */) {
                nextToken();
                return true;
            }
            if (token() === 20 /* OpenBracketToken */ || token() === 16 /* OpenBraceToken */) {
                // Return true if we can parse an array or object binding pattern with no errors
                var previousErrorCount = parseDiagnostics.length;
                parseIdentifierOrPattern();
                return previousErrorCount === parseDiagnostics.length;
            }
            return false;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{105,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{105,1} AS 1 AT <0:39>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{105,2} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{105,2} AS 2 AT <0:219>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseDecorators) id{106,0} ---
() {
            var decorators;
            while (true) {
                var decoratorStart = getNodePos();
                if (!parseOptional(56 /* AtToken */)) {
                    break;
                }
                var decorator = createNode(145 /* Decorator */, decoratorStart);
                decorator.expression = doInDecoratorContext(parseLeftHandSideExpressionOrHigher);
                finishNode(decorator);
                if (!decorators) {
                    decorators = createNodeArray([decorator], decoratorStart);
                }
                else {
                    decorators.push(decorator);
                }
            }
            if (decorators) {
                decorators.end = getNodeEnd();
            }
            return decorators;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodePos) id{106,1} ---
() {
            return scanner.getStartPos();
        }
--- END ---
INLINE (getNodePos) id{106,1} AS 1 AT <0:97>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseOptional) id{106,2} ---
(t) {
            if (token() === t) {
                nextToken();
                return true;
            }
            return false;
        }
--- END ---
INLINE (parseOptional) id{106,2} AS 2 AT <0:132>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{106,3} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{106,3} AS 3 AT <2:22>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{106,4} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{106,4} AS 4 AT <2:55>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextTokenIsIdentifierOnSameLine) id{107,0} ---
() {
            nextToken();
            return !scanner.hasPrecedingLineBreak() && isIdentifier();
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{107,1} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{107,1} AS 1 AT <0:17>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isDeclaration) id{108,0} ---
() {
            while (true) {
                switch (token()) {
                    case 103 /* VarKeyword */:
                    case 109 /* LetKeyword */:
                    case 75 /* ConstKeyword */:
                    case 88 /* FunctionKeyword */:
                    case 74 /* ClassKeyword */:
                    case 82 /* EnumKeyword */:
                        return true;
                    // 'declare', 'module', 'namespace', 'interface'* and 'type' are all legal JavaScript identifiers;
                    // however, an identifier cannot be followed by another identifier on the same line. This is what we
                    // count on to parse out the respective declarations. For instance, we exploit this to say that
                    //
                    //    namespace n
                    //
                    // can be none other than the beginning of a namespace declaration, but need to respect that JavaScript sees
                    //
                    //    namespace
                    //    n
                    //
                    // as the identifier 'namespace' on one line followed by the identifier 'n' on another.
                    // We need to look one token ahead to see if it permissible to try parsing a declaration.
                    //
                    // *Note*: 'interface' is actually a strict mode reserved word. So while
                    //
                    //   "use strict"
                    //   interface
                    //   I {}
                    //
                    // could be legal, it would add complexity for very little gain.
                    case 108 /* InterfaceKeyword */:
                    case 136 /* TypeKeyword */:
                        return nextTokenIsIdentifierOnSameLine();
                    case 127 /* ModuleKeyword */:
                    case 128 /* NamespaceKeyword */:
                        return nextTokenIsIdentifierOrStringLiteralOnSameLine();
                    case 116 /* AbstractKeyword */:
                    case 119 /* AsyncKeyword */:
                    case 123 /* DeclareKeyword */:
                    case 111 /* PrivateKeyword */:
                    case 112 /* ProtectedKeyword */:
                    case 113 /* PublicKeyword */:
                    case 130 /* ReadonlyKeyword */:
                        nextToken();
                        // ASI takes effect for this modifier.
                        if (scanner.hasPrecedingLineBreak()) {
                            return false;
                        }
                        continue;
                    case 139 /* GlobalKeyword */:
                        nextToken();
                        return token() === 16 /* OpenBraceToken */ || token() === 70 /* Identifier */ || token() === 83 /* ExportKeyword */;
                    case 90 /* ImportKeyword */:
                        nextToken();
                        return token() === 9 /* StringLiteral */ || token() === 38 /* AsteriskToken */ ||
                            token() === 16 /* OpenBraceToken */ || ts.tokenIsIdentifierOrKeyword(token());
                    case 83 /* ExportKeyword */:
                        nextToken();
                        if (token() === 57 /* EqualsToken */ || token() === 38 /* AsteriskToken */ ||
                            token() === 16 /* OpenBraceToken */ || token() === 78 /* DefaultKeyword */ ||
                            token() === 117 /* AsKeyword */) {
                            return true;
                        }
                        continue;
                    case 114 /* StaticKeyword */:
                        nextToken();
                        continue;
                    default:
                        return false;
                }
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{108,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{108,1} AS 1 AT <0:56>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextTokenIsIdentifierOnSameLine) id{108,2} ---
() {
            nextToken();
            return !scanner.hasPrecedingLineBreak() && isIdentifier();
        }
--- END ---
INLINE (nextTokenIsIdentifierOnSameLine) id{108,2} AS 2 AT <0:1771>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{108,3} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{108,3} AS 3 AT <2:17>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextTokenIsIdentifierOrStringLiteralOnSameLine) id{108,4} ---
() {
            nextToken();
            return !scanner.hasPrecedingLineBreak() && (isIdentifier() || token() === 9 /* StringLiteral */);
        }
--- END ---
INLINE (nextTokenIsIdentifierOrStringLiteralOnSameLine) id{108,4} AS 4 AT <0:1940>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{108,5} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{108,5} AS 5 AT <4:17>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{108,6} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{108,6} AS 6 AT <4:104>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{108,7} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{108,7} AS 7 AT <0:2372>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{108,8} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{108,8} AS 8 AT <0:2914>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{108,9} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{108,9} AS 9 AT <0:2958>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{108,10} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{108,10} AS 10 AT <0:2995>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{108,11} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{108,11} AS 11 AT <0:3213>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{108,12} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{108,12} AS 12 AT <0:3254>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{108,13} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{108,13} AS 13 AT <0:3290>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{108,14} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{108,14} AS 14 AT <0:3356>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{108,15} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{108,15} AS 15 AT <0:3395>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{108,16} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{108,16} AS 16 AT <0:3462>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:setDisallowInContext) id{109,0} ---
(val) {
            setContextFlag(val, 2048 /* DisallowInContext */);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:setContextFlag) id{109,1} ---
(val, flag) {
            if (val) {
                contextFlags |= flag;
            }
            else {
                contextFlags &= ~flag;
            }
        }
--- END ---
INLINE (setContextFlag) id{109,1} AS 1 AT <0:20>
--- FUNCTION SOURCE (native string.js:slice) id{110,0} ---
(L,M){
if((%IS_VAR(this)===null)||(this===(void 0)))throw %make_type_error(17,"String.prototype.slice");
var p=(%_ToString(this));
var Z=p.length;
var aa=(%_ToInteger(L));
var ab=Z;
if(!(M===(void 0))){
ab=(%_ToInteger(M));
}
if(aa<0){
aa+=Z;
if(aa<0){
aa=0;
}
}else{
if(aa>Z){
return'';
}
}
if(ab<0){
ab+=Z;
if(ab<0){
return'';
}
}else{
if(ab>Z){
ab=Z;
}
}
if(ab<=aa){
return'';
}
return %_SubString(p,aa,ab);
}
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:scanString) id{111,0} ---
(allowEscapes) {
            if (allowEscapes === void 0) { allowEscapes = true; }
            var quote = text.charCodeAt(pos);
            pos++;
            var result = "";
            var start = pos;
            while (true) {
                if (pos >= end) {
                    result += text.substring(start, pos);
                    tokenIsUnterminated = true;
                    error(ts.Diagnostics.Unterminated_string_literal);
                    break;
                }
                var ch = text.charCodeAt(pos);
                if (ch === quote) {
                    result += text.substring(start, pos);
                    pos++;
                    break;
                }
                if (ch === 92 /* backslash */ && allowEscapes) {
                    result += text.substring(start, pos);
                    result += scanEscapeSequence();
                    start = pos;
                    continue;
                }
                if (isLineBreak(ch)) {
                    result += text.substring(start, pos);
                    tokenIsUnterminated = true;
                    error(ts.Diagnostics.Unterminated_string_literal);
                    break;
                }
                pos++;
            }
            return result;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isStartOfStatement) id{112,0} ---
() {
            switch (token()) {
                case 56 /* AtToken */:
                case 24 /* SemicolonToken */:
                case 16 /* OpenBraceToken */:
                case 103 /* VarKeyword */:
                case 109 /* LetKeyword */:
                case 88 /* FunctionKeyword */:
                case 74 /* ClassKeyword */:
                case 82 /* EnumKeyword */:
                case 89 /* IfKeyword */:
                case 80 /* DoKeyword */:
                case 105 /* WhileKeyword */:
                case 87 /* ForKeyword */:
                case 76 /* ContinueKeyword */:
                case 71 /* BreakKeyword */:
                case 95 /* ReturnKeyword */:
                case 106 /* WithKeyword */:
                case 97 /* SwitchKeyword */:
                case 99 /* ThrowKeyword */:
                case 101 /* TryKeyword */:
                case 77 /* DebuggerKeyword */:
                // 'catch' and 'finally' do not actually indicate that the code is part of a statement,
                // however, we say they are here so that we may gracefully parse them and error later.
                case 73 /* CatchKeyword */:
                case 86 /* FinallyKeyword */:
                    return true;
                case 75 /* ConstKeyword */:
                case 83 /* ExportKeyword */:
                case 90 /* ImportKeyword */:
                    return isStartOfDeclaration();
                case 119 /* AsyncKeyword */:
                case 123 /* DeclareKeyword */:
                case 108 /* InterfaceKeyword */:
                case 127 /* ModuleKeyword */:
                case 128 /* NamespaceKeyword */:
                case 136 /* TypeKeyword */:
                case 139 /* GlobalKeyword */:
                    // When these don't start a declaration, they're an identifier in an expression statement
                    return true;
                case 113 /* PublicKeyword */:
                case 111 /* PrivateKeyword */:
                case 112 /* ProtectedKeyword */:
                case 114 /* StaticKeyword */:
                case 130 /* ReadonlyKeyword */:
                    // When these don't start a declaration, they may be the start of a class member if an identifier
                    // immediately follows. Otherwise they're an identifier in an expression statement.
                    return isStartOfDeclaration() || !lookAhead(nextTokenIsIdentifierOrKeywordOnSameLine);
                default:
                    return isStartOfExpression();
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{112,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{112,1} AS 1 AT <0:25>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isStartOfDeclaration) id{112,2} ---
() {
            return lookAhead(isDeclaration);
        }
--- END ---
INLINE (isStartOfDeclaration) id{112,2} AS 2 AT <0:1406>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:lookAhead) id{112,3} ---
(callback) {
            return speculationHelper(callback, /*isLookAhead*/ true);
        }
--- END ---
INLINE (lookAhead) id{112,3} AS 3 AT <2:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseStatement) id{113,0} ---
() {
            switch (token()) {
                case 24 /* SemicolonToken */:
                    return parseEmptyStatement();
                case 16 /* OpenBraceToken */:
                    return parseBlock(/*ignoreMissingOpenBrace*/ false);
                case 103 /* VarKeyword */:
                    return parseVariableStatement(scanner.getStartPos(), /*decorators*/ undefined, /*modifiers*/ undefined);
                case 109 /* LetKeyword */:
                    if (isLetDeclaration()) {
                        return parseVariableStatement(scanner.getStartPos(), /*decorators*/ undefined, /*modifiers*/ undefined);
                    }
                    break;
                case 88 /* FunctionKeyword */:
                    return parseFunctionDeclaration(scanner.getStartPos(), /*decorators*/ undefined, /*modifiers*/ undefined);
                case 74 /* ClassKeyword */:
                    return parseClassDeclaration(scanner.getStartPos(), /*decorators*/ undefined, /*modifiers*/ undefined);
                case 89 /* IfKeyword */:
                    return parseIfStatement();
                case 80 /* DoKeyword */:
                    return parseDoStatement();
                case 105 /* WhileKeyword */:
                    return parseWhileStatement();
                case 87 /* ForKeyword */:
                    return parseForOrForInOrForOfStatement();
                case 76 /* ContinueKeyword */:
                    return parseBreakOrContinueStatement(214 /* ContinueStatement */);
                case 71 /* BreakKeyword */:
                    return parseBreakOrContinueStatement(215 /* BreakStatement */);
                case 95 /* ReturnKeyword */:
                    return parseReturnStatement();
                case 106 /* WithKeyword */:
                    return parseWithStatement();
                case 97 /* SwitchKeyword */:
                    return parseSwitchStatement();
                case 99 /* ThrowKeyword */:
                    return parseThrowStatement();
                case 101 /* TryKeyword */:
                // Include 'catch' and 'finally' for error recovery.
                case 73 /* CatchKeyword */:
                case 86 /* FinallyKeyword */:
                    return parseTryStatement();
                case 77 /* DebuggerKeyword */:
                    return parseDebuggerStatement();
                case 56 /* AtToken */:
                    return parseDeclaration();
                case 119 /* AsyncKeyword */:
                case 108 /* InterfaceKeyword */:
                case 136 /* TypeKeyword */:
                case 127 /* ModuleKeyword */:
                case 128 /* NamespaceKeyword */:
                case 123 /* DeclareKeyword */:
                case 75 /* ConstKeyword */:
                case 82 /* EnumKeyword */:
                case 83 /* ExportKeyword */:
                case 90 /* ImportKeyword */:
                case 111 /* PrivateKeyword */:
                case 112 /* ProtectedKeyword */:
                case 113 /* PublicKeyword */:
                case 116 /* AbstractKeyword */:
                case 114 /* StaticKeyword */:
                case 130 /* ReadonlyKeyword */:
                case 139 /* GlobalKeyword */:
                    if (isStartOfDeclaration()) {
                        return parseDeclaration();
                    }
                    break;
            }
            return parseExpressionOrLabeledStatement();
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{113,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{113,1} AS 1 AT <0:25>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseVariableStatement) id{113,2} ---
(fullStart, decorators, modifiers) {
            var node = createNode(205 /* VariableStatement */, fullStart);
            node.decorators = decorators;
            node.modifiers = modifiers;
            node.declarationList = parseVariableDeclarationList(/*inForStatementInitializer*/ false);
            parseSemicolon();
            return addJSDocComment(finishNode(node));
        }
--- END ---
INLINE (parseVariableStatement) id{113,2} AS 2 AT <0:321>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{113,3} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{113,3} AS 3 AT <2:60>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{113,4} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{113,4} AS 4 AT <3:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{113,5} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{113,5} AS 5 AT <3:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{113,6} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{113,6} AS 6 AT <3:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseSemicolon) id{113,7} ---
() {
            if (canParseSemicolon()) {
                if (token() === 24 /* SemicolonToken */) {
                    // consume the semicolon if it was explicitly provided.
                    nextToken();
                }
                return true;
            }
            else {
                return parseExpected(24 /* SemicolonToken */);
            }
        }
--- END ---
INLINE (parseSemicolon) id{113,7} AS 7 AT <2:308>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:canParseSemicolon) id{113,8} ---
() {
            // If there's a real semicolon, then we can always parse it out.
            if (token() === 24 /* SemicolonToken */) {
                return true;
            }
            // We can parse out an optional semicolon in ASI cases in the following cases.
            return token() === 17 /* CloseBraceToken */ || token() === 1 /* EndOfFileToken */ || scanner.hasPrecedingLineBreak();
        }
--- END ---
INLINE (canParseSemicolon) id{113,8} AS 8 AT <7:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{113,9} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{113,9} AS 9 AT <8:98>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{113,10} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{113,10} AS 10 AT <8:290>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{113,11} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{113,11} AS 11 AT <8:330>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{113,12} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{113,12} AS 12 AT <7:64>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{113,13} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{113,13} AS 13 AT <7:199>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseClassDeclaration) id{113,14} ---
(fullStart, decorators, modifiers) {
            return parseClassDeclarationOrExpression(fullStart, decorators, modifiers, 226 /* ClassDeclaration */);
        }
--- END ---
INLINE (parseClassDeclaration) id{113,14} AS 14 AT <0:931>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isStartOfDeclaration) id{113,15} ---
() {
            return lookAhead(isDeclaration);
        }
--- END ---
INLINE (isStartOfDeclaration) id{113,15} AS 15 AT <0:3291>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:lookAhead) id{113,16} ---
(callback) {
            return speculationHelper(callback, /*isLookAhead*/ true);
        }
--- END ---
INLINE (lookAhead) id{113,16} AS 16 AT <15:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseDeclaration) id{114,0} ---
() {
            var fullStart = getNodePos();
            var decorators = parseDecorators();
            var modifiers = parseModifiers();
            switch (token()) {
                case 103 /* VarKeyword */:
                case 109 /* LetKeyword */:
                case 75 /* ConstKeyword */:
                    return parseVariableStatement(fullStart, decorators, modifiers);
                case 88 /* FunctionKeyword */:
                    return parseFunctionDeclaration(fullStart, decorators, modifiers);
                case 74 /* ClassKeyword */:
                    return parseClassDeclaration(fullStart, decorators, modifiers);
                case 108 /* InterfaceKeyword */:
                    return parseInterfaceDeclaration(fullStart, decorators, modifiers);
                case 136 /* TypeKeyword */:
                    return parseTypeAliasDeclaration(fullStart, decorators, modifiers);
                case 82 /* EnumKeyword */:
                    return parseEnumDeclaration(fullStart, decorators, modifiers);
                case 139 /* GlobalKeyword */:
                case 127 /* ModuleKeyword */:
                case 128 /* NamespaceKeyword */:
                    return parseModuleDeclaration(fullStart, decorators, modifiers);
                case 90 /* ImportKeyword */:
                    return parseImportDeclarationOrImportEqualsDeclaration(fullStart, decorators, modifiers);
                case 83 /* ExportKeyword */:
                    nextToken();
                    switch (token()) {
                        case 78 /* DefaultKeyword */:
                        case 57 /* EqualsToken */:
                            return parseExportAssignment(fullStart, decorators, modifiers);
                        case 117 /* AsKeyword */:
                            return parseNamespaceExportDeclaration(fullStart, decorators, modifiers);
                        default:
                            return parseExportDeclaration(fullStart, decorators, modifiers);
                    }
                default:
                    if (decorators || modifiers) {
                        // We reached this point because we encountered decorators and/or modifiers and assumed a declaration
                        // would follow. For recovery and error reporting purposes, return an incomplete declaration.
                        var node = createMissingNode(244 /* MissingDeclaration */, /*reportAtCurrentPosition*/ true, ts.Diagnostics.Declaration_expected);
                        node.pos = fullStart;
                        node.decorators = decorators;
                        node.modifiers = modifiers;
                        return finishNode(node);
                    }
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodePos) id{114,1} ---
() {
            return scanner.getStartPos();
        }
--- END ---
INLINE (getNodePos) id{114,1} AS 1 AT <0:33>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{114,2} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{114,2} AS 2 AT <0:161>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseVariableStatement) id{114,3} ---
(fullStart, decorators, modifiers) {
            var node = createNode(205 /* VariableStatement */, fullStart);
            node.decorators = decorators;
            node.modifiers = modifiers;
            node.declarationList = parseVariableDeclarationList(/*inForStatementInitializer*/ false);
            parseSemicolon();
            return addJSDocComment(finishNode(node));
        }
--- END ---
INLINE (parseVariableStatement) id{114,3} AS 3 AT <0:329>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{114,4} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{114,4} AS 4 AT <3:60>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{114,5} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{114,5} AS 5 AT <4:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{114,6} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{114,6} AS 6 AT <4:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{114,7} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{114,7} AS 7 AT <4:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseSemicolon) id{114,8} ---
() {
            if (canParseSemicolon()) {
                if (token() === 24 /* SemicolonToken */) {
                    // consume the semicolon if it was explicitly provided.
                    nextToken();
                }
                return true;
            }
            else {
                return parseExpected(24 /* SemicolonToken */);
            }
        }
--- END ---
INLINE (parseSemicolon) id{114,8} AS 8 AT <3:308>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:canParseSemicolon) id{114,9} ---
() {
            // If there's a real semicolon, then we can always parse it out.
            if (token() === 24 /* SemicolonToken */) {
                return true;
            }
            // We can parse out an optional semicolon in ASI cases in the following cases.
            return token() === 17 /* CloseBraceToken */ || token() === 1 /* EndOfFileToken */ || scanner.hasPrecedingLineBreak();
        }
--- END ---
INLINE (canParseSemicolon) id{114,9} AS 9 AT <8:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{114,10} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{114,10} AS 10 AT <9:98>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{114,11} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{114,11} AS 11 AT <9:290>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{114,12} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{114,12} AS 12 AT <9:330>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{114,13} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{114,13} AS 13 AT <8:64>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{114,14} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{114,14} AS 14 AT <8:199>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseClassDeclaration) id{114,15} ---
(fullStart, decorators, modifiers) {
            return parseClassDeclarationOrExpression(fullStart, decorators, modifiers, 226 /* ClassDeclaration */);
        }
--- END ---
INLINE (parseClassDeclaration) id{114,15} AS 15 AT <0:592>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseInterfaceDeclaration) id{114,16} ---
(fullStart, decorators, modifiers) {
            var node = createNode(227 /* InterfaceDeclaration */, fullStart);
            node.decorators = decorators;
            node.modifiers = modifiers;
            parseExpected(108 /* InterfaceKeyword */);
            node.name = parseIdentifier();
            node.typeParameters = parseTypeParameters();
            node.heritageClauses = parseHeritageClauses();
            node.members = parseObjectTypeMembers();
            return addJSDocComment(finishNode(node));
        }
--- END ---
INLINE (parseInterfaceDeclaration) id{114,16} AS 16 AT <0:725>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{114,17} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{114,17} AS 17 AT <16:60>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{114,18} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{114,18} AS 18 AT <17:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{114,19} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{114,19} AS 19 AT <17:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{114,20} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{114,20} AS 20 AT <17:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseIdentifier) id{114,21} ---
(diagnosticMessage) {
            return createIdentifier(isIdentifier(), diagnosticMessage);
        }
--- END ---
INLINE (parseIdentifier) id{114,21} AS 21 AT <16:276>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseTypeParameters) id{114,22} ---
() {
            if (token() === 26 /* LessThanToken */) {
                return parseBracketedList(18 /* TypeParameters */, parseTypeParameter, 26 /* LessThanToken */, 28 /* GreaterThanToken */);
            }
        }
--- END ---
INLINE (parseTypeParameters) id{114,22} AS 22 AT <16:329>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{114,23} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{114,23} AS 23 AT <22:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseBracketedList) id{114,24} ---
(kind, parseElement, open, close) {
            if (parseExpected(open)) {
                var result = parseDelimitedList(kind, parseElement);
                parseExpected(close);
                return result;
            }
            return createMissingList();
        }
--- END ---
INLINE (parseBracketedList) id{114,24} AS 24 AT <22:82>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseHeritageClauses) id{114,25} ---
() {
            // ClassTail[Yield,Await] : (Modified) See 14.5
            //      ClassHeritage[?Yield,?Await]opt { ClassBody[?Yield,?Await]opt }
            if (isHeritageClause()) {
                return parseList(21 /* HeritageClauses */, parseHeritageClause);
            }
            return undefined;
        }
--- END ---
INLINE (parseHeritageClauses) id{114,25} AS 25 AT <16:387>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isHeritageClause) id{114,26} ---
() {
            return token() === 84 /* ExtendsKeyword */ || token() === 107 /* ImplementsKeyword */;
        }
--- END ---
INLINE (isHeritageClause) id{114,26} AS 26 AT <25:165>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{114,27} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{114,27} AS 27 AT <26:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{114,28} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{114,28} AS 28 AT <26:63>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseObjectTypeMembers) id{114,29} ---
() {
            var members;
            if (parseExpected(16 /* OpenBraceToken */)) {
                members = parseList(4 /* TypeMembers */, parseTypeMember);
                parseExpected(17 /* CloseBraceToken */);
            }
            else {
                members = createMissingList();
            }
            return members;
        }
--- END ---
INLINE (parseObjectTypeMembers) id{114,29} AS 29 AT <16:438>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseModifiers) id{115,0} ---
(permitInvalidConstAsModifier) {
            var modifiers;
            while (true) {
                var modifierStart = scanner.getStartPos();
                var modifierKind = token();
                if (token() === 75 /* ConstKeyword */ && permitInvalidConstAsModifier) {
                    // We need to ensure that any subsequent modifiers appear on the same line
                    // so that when 'const' is a standalone declaration, we don't issue an error.
                    if (!tryParse(nextTokenIsOnSameLineAndCanFollowModifier)) {
                        break;
                    }
                }
                else {
                    if (!parseAnyContextualModifier()) {
                        break;
                    }
                }
                var modifier = finishNode(createNode(modifierKind, modifierStart));
                if (!modifiers) {
                    modifiers = createNodeArray([modifier], modifierStart);
                }
                else {
                    modifiers.push(modifier);
                }
            }
            if (modifiers) {
                modifiers.end = scanner.getStartPos();
            }
            return modifiers;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{115,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{115,1} AS 1 AT <0:181>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{115,2} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{115,2} AS 2 AT <0:210>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseAnyContextualModifier) id{115,3} ---
() {
            return ts.isModifierKind(token()) && tryParse(nextTokenCanFollowModifier);
        }
--- END ---
INLINE (parseAnyContextualModifier) id{115,3} AS 3 AT <0:671>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{115,4} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{115,4} AS 4 AT <3:42>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:tryParse) id{115,5} ---
(callback) {
            return speculationHelper(callback, /*isLookAhead*/ false);
        }
--- END ---
INLINE (tryParse) id{115,5} AS 5 AT <3:54>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{115,6} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{115,6} AS 6 AT <0:816>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{115,7} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{115,7} AS 7 AT <6:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{115,8} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{115,8} AS 8 AT <6:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{115,9} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{115,9} AS 9 AT <6:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNodeArray) id{115,10} ---
(elements, pos) {
            var array = (elements || []);
            if (!(pos >= 0)) {
                pos = getNodePos();
            }
            array.pos = pos;
            array.end = pos;
            return array;
        }
--- END ---
INLINE (createNodeArray) id{115,10} AS 10 AT <0:924>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodePos) id{115,11} ---
() {
            return scanner.getStartPos();
        }
--- END ---
INLINE (getNodePos) id{115,11} AS 11 AT <10:113>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parsePrimaryExpression) id{116,0} ---
() {
            switch (token()) {
                case 8 /* NumericLiteral */:
                case 9 /* StringLiteral */:
                case 12 /* NoSubstitutionTemplateLiteral */:
                    return parseLiteralNode();
                case 98 /* ThisKeyword */:
                case 96 /* SuperKeyword */:
                case 94 /* NullKeyword */:
                case 100 /* TrueKeyword */:
                case 85 /* FalseKeyword */:
                    return parseTokenNode();
                case 18 /* OpenParenToken */:
                    return parseParenthesizedExpression();
                case 20 /* OpenBracketToken */:
                    return parseArrayLiteralExpression();
                case 16 /* OpenBraceToken */:
                    return parseObjectLiteralExpression();
                case 119 /* AsyncKeyword */:
                    // Async arrow functions are parsed earlier in parseAssignmentExpressionOrHigher.
                    // If we encounter `async [no LineTerminator here] function` then this is an async
                    // function; otherwise, its an identifier.
                    if (!lookAhead(nextTokenIsFunctionKeywordOnSameLine)) {
                        break;
                    }
                    return parseFunctionExpression();
                case 74 /* ClassKeyword */:
                    return parseClassExpression();
                case 88 /* FunctionKeyword */:
                    return parseFunctionExpression();
                case 93 /* NewKeyword */:
                    return parseNewExpression();
                case 40 /* SlashToken */:
                case 62 /* SlashEqualsToken */:
                    if (reScanSlashToken() === 11 /* RegularExpressionLiteral */) {
                        return parseLiteralNode();
                    }
                    break;
                case 13 /* TemplateHead */:
                    return parseTemplateExpression();
            }
            return parseIdentifier(ts.Diagnostics.Expression_expected);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{116,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{116,1} AS 1 AT <0:25>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseLiteralNode) id{116,2} ---
(internName) {
            return parseLiteralLikeNode(token(), internName);
        }
--- END ---
INLINE (parseLiteralNode) id{116,2} AS 2 AT <0:213>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{116,3} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{116,3} AS 3 AT <2:55>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseIdentifier) id{116,4} ---
(diagnosticMessage) {
            return createIdentifier(isIdentifier(), diagnosticMessage);
        }
--- END ---
INLINE (parseIdentifier) id{116,4} AS 4 AT <0:2000>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseArrayTypeOrHigher) id{117,0} ---
() {
            var type = parseNonArrayType();
            while (!scanner.hasPrecedingLineBreak() && parseOptional(20 /* OpenBracketToken */)) {
                if (isStartOfType()) {
                    var node = createNode(169 /* IndexedAccessType */, type.pos);
                    node.objectType = type;
                    node.indexType = parseType();
                    parseExpected(21 /* CloseBracketToken */);
                    type = finishNode(node);
                }
                else {
                    var node = createNode(162 /* ArrayType */, type.pos);
                    node.elementType = type;
                    parseExpected(21 /* CloseBracketToken */);
                    type = finishNode(node);
                }
            }
            return type;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseOptional) id{117,1} ---
(t) {
            if (token() === t) {
                nextToken();
                return true;
            }
            return false;
        }
--- END ---
INLINE (parseOptional) id{117,1} AS 1 AT <0:104>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{117,2} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{117,2} AS 2 AT <1:22>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{117,3} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{117,3} AS 3 AT <1:55>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{117,4} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{117,4} AS 4 AT <0:543>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{117,5} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{117,5} AS 5 AT <4:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{117,6} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{117,6} AS 6 AT <4:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{117,7} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{117,7} AS 7 AT <4:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextTokenCanFollowModifier) id{118,0} ---
() {
            if (token() === 75 /* ConstKeyword */) {
                // 'const' is only a modifier if followed by 'enum'.
                return nextToken() === 82 /* EnumKeyword */;
            }
            if (token() === 83 /* ExportKeyword */) {
                nextToken();
                if (token() === 78 /* DefaultKeyword */) {
                    return lookAhead(nextTokenIsClassOrFunctionOrAsync);
                }
                return token() !== 38 /* AsteriskToken */ && token() !== 117 /* AsKeyword */ && token() !== 16 /* OpenBraceToken */ && canFollowModifier();
            }
            if (token() === 78 /* DefaultKeyword */) {
                return nextTokenIsClassOrFunctionOrAsync();
            }
            if (token() === 114 /* StaticKeyword */) {
                nextToken();
                return canFollowModifier();
            }
            return nextTokenIsOnSameLineAndCanFollowModifier();
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{118,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{118,1} AS 1 AT <0:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{118,2} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{118,2} AS 2 AT <0:218>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{118,3} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{118,3} AS 3 AT <0:272>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{118,4} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{118,4} AS 4 AT <0:305>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{118,5} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{118,5} AS 5 AT <0:458>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{118,6} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{118,6} AS 6 AT <0:496>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{118,7} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{118,7} AS 7 AT <0:531>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:canFollowModifier) id{118,8} ---
() {
            return token() === 20 /* OpenBracketToken */
                || token() === 16 /* OpenBraceToken */
                || token() === 38 /* AsteriskToken */
                || token() === 23 /* DotDotDotToken */
                || isLiteralPropertyName();
        }
--- END ---
INLINE (canFollowModifier) id{118,8} AS 8 AT <0:570>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{118,9} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{118,9} AS 9 AT <8:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{118,10} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{118,10} AS 10 AT <8:81>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{118,11} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{118,11} AS 11 AT <8:136>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{118,12} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{118,12} AS 12 AT <8:190>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isLiteralPropertyName) id{118,13} ---
() {
            return ts.tokenIsIdentifierOrKeyword(token()) ||
                token() === 9 /* StringLiteral */ ||
                token() === 8 /* NumericLiteral */;
        }
--- END ---
INLINE (isLiteralPropertyName) id{118,13} AS 13 AT <8:245>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{118,14} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{118,14} AS 14 AT <13:54>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{118,15} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{118,15} AS 15 AT <13:82>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{118,16} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{118,16} AS 16 AT <13:135>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{118,17} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{118,17} AS 17 AT <0:621>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{118,18} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{118,18} AS 18 AT <0:750>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{118,19} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{118,19} AS 19 AT <0:805>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:canFollowModifier) id{118,20} ---
() {
            return token() === 20 /* OpenBracketToken */
                || token() === 16 /* OpenBraceToken */
                || token() === 38 /* AsteriskToken */
                || token() === 23 /* DotDotDotToken */
                || isLiteralPropertyName();
        }
--- END ---
INLINE (canFollowModifier) id{118,20} AS 20 AT <0:841>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{118,21} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{118,21} AS 21 AT <20:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{118,22} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{118,22} AS 22 AT <20:81>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{118,23} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{118,23} AS 23 AT <20:136>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{118,24} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{118,24} AS 24 AT <20:190>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isLiteralPropertyName) id{118,25} ---
() {
            return ts.tokenIsIdentifierOrKeyword(token()) ||
                token() === 9 /* StringLiteral */ ||
                token() === 8 /* NumericLiteral */;
        }
--- END ---
INLINE (isLiteralPropertyName) id{118,25} AS 25 AT <20:245>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{118,26} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{118,26} AS 26 AT <25:54>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{118,27} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{118,27} AS 27 AT <25:82>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{118,28} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{118,28} AS 28 AT <25:135>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextTokenIsOnSameLineAndCanFollowModifier) id{118,29} ---
() {
            nextToken();
            if (scanner.hasPrecedingLineBreak()) {
                return false;
            }
            return canFollowModifier();
        }
--- END ---
INLINE (nextTokenIsOnSameLineAndCanFollowModifier) id{118,29} AS 29 AT <0:895>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{118,30} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{118,30} AS 30 AT <29:17>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:canFollowModifier) id{118,31} ---
() {
            return token() === 20 /* OpenBracketToken */
                || token() === 16 /* OpenBraceToken */
                || token() === 38 /* AsteriskToken */
                || token() === 23 /* DotDotDotToken */
                || isLiteralPropertyName();
        }
--- END ---
INLINE (canFollowModifier) id{118,31} AS 31 AT <29:144>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{118,32} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{118,32} AS 32 AT <31:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{118,33} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{118,33} AS 33 AT <31:81>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{118,34} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{118,34} AS 34 AT <31:136>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{118,35} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{118,35} AS 35 AT <31:190>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isLiteralPropertyName) id{118,36} ---
() {
            return ts.tokenIsIdentifierOrKeyword(token()) ||
                token() === 9 /* StringLiteral */ ||
                token() === 8 /* NumericLiteral */;
        }
--- END ---
INLINE (isLiteralPropertyName) id{118,36} AS 36 AT <31:245>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{118,37} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{118,37} AS 37 AT <36:54>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{118,38} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{118,38} AS 38 AT <36:82>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{118,39} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{118,39} AS 39 AT <36:135>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:addJSDocComment) id{119,0} ---
(node) {
            var comments = ts.getJSDocCommentRanges(node, sourceFile.text);
            if (comments) {
                for (var _i = 0, comments_2 = comments; _i < comments_2.length; _i++) {
                    var comment = comments_2[_i];
                    var jsDoc = JSDocParser.parseJSDocComment(node, comment.pos, comment.end - comment.pos);
                    if (!jsDoc) {
                        continue;
                    }
                    if (!node.jsDoc) {
                        node.jsDoc = [];
                    }
                    node.jsDoc.push(jsDoc);
                }
            }
            return node;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:filter) id{120,0} ---
(array, f) {
        if (array) {
            var len = array.length;
            var i = 0;
            while (i < len && f(array[i]))
                i++;
            if (i < len) {
                var result = array.slice(0, i);
                i++;
                while (i < len) {
                    var item = array[i];
                    if (f(item)) {
                        result.push(item);
                    }
                    i++;
                }
                return result;
            }
        }
        return array;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseRightSideOfDot) id{121,0} ---
(allowIdentifierNames) {
            // Technically a keyword is valid here as all identifiers and keywords are identifier names.
            // However, often we'll encounter this in error situations when the identifier or keyword
            // is actually starting another valid construct.
            //
            // So, we check for the following specific case:
            //
            //      name.
            //      identifierOrKeyword identifierNameOrKeyword
            //
            // Note: the newlines are important here.  For example, if that above code
            // were rewritten into:
            //
            //      name.identifierOrKeyword
            //      identifierNameOrKeyword
            //
            // Then we would consider it valid.  That's because ASI would take effect and
            // the code would be implicitly: "name.identifierOrKeyword; identifierNameOrKeyword".
            // In the first case though, ASI will not take effect because there is not a
            // line terminator after the identifier or keyword.
            if (scanner.hasPrecedingLineBreak() && ts.tokenIsIdentifierOrKeyword(token())) {
                var matchesPattern = lookAhead(nextTokenIsIdentifierOrKeywordOnSameLine);
                if (matchesPattern) {
                    // Report that we need an identifier.  However, report it right after the dot,
                    // and not on the next token.  This is because the next token might actually
                    // be an identifier and the error would be quite confusing.
                    return createMissingNode(70 /* Identifier */, /*reportAtCurrentPosition*/ true, ts.Diagnostics.Identifier_expected);
                }
            }
            return allowIdentifierNames ? parseIdentifierName() : parseIdentifier();
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseIdentifierName) id{121,1} ---
() {
            return createIdentifier(ts.tokenIsIdentifierOrKeyword(token()));
        }
--- END ---
INLINE (parseIdentifierName) id{121,1} AS 1 AT <0:1780>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{121,2} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{121,2} AS 2 AT <1:71>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseIdentifier) id{121,3} ---
(diagnosticMessage) {
            return createIdentifier(isIdentifier(), diagnosticMessage);
        }
--- END ---
INLINE (parseIdentifier) id{121,3} AS 3 AT <0:1804>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isUnambiguouslyStartOfFunctionType) id{122,0} ---
() {
            nextToken();
            if (token() === 19 /* CloseParenToken */ || token() === 23 /* DotDotDotToken */) {
                // ( )
                // ( ...
                return true;
            }
            if (skipParameterStart()) {
                // We successfully skipped modifiers (if any) and an identifier or binding pattern,
                // now see if we have something that indicates a parameter declaration
                if (token() === 55 /* ColonToken */ || token() === 25 /* CommaToken */ ||
                    token() === 54 /* QuestionToken */ || token() === 57 /* EqualsToken */) {
                    // ( xxx :
                    // ( xxx ,
                    // ( xxx ?
                    // ( xxx =
                    return true;
                }
                if (token() === 19 /* CloseParenToken */) {
                    nextToken();
                    if (token() === 35 /* EqualsGreaterThanToken */) {
                        // ( xxx ) =>
                        return true;
                    }
                }
            }
            return false;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{122,1} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{122,1} AS 1 AT <0:17>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{122,2} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{122,2} AS 2 AT <0:46>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{122,3} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{122,3} AS 3 AT <0:86>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{122,4} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{122,4} AS 4 AT <0:463>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{122,5} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{122,5} AS 5 AT <0:498>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{122,6} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{122,6} AS 6 AT <0:553>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{122,7} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{122,7} AS 7 AT <0:591>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{122,8} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{122,8} AS 8 AT <0:822>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseObjectTypeMembers) id{123,0} ---
() {
            var members;
            if (parseExpected(16 /* OpenBraceToken */)) {
                members = parseList(4 /* TypeMembers */, parseTypeMember);
                parseExpected(17 /* CloseBraceToken */);
            }
            else {
                members = createMissingList();
            }
            return members;
        }
--- END ---
[deoptimizing (DEOPT soft): begin 0xd6230dd31e1 <JS Function nextTokenCanFollowModifier (SharedFunctionInfo 0x3504a53f3af1)> (opt #118) @50, FP to SP delta: 128, caller sp: 0x7fff5fbfd4f0]
            ;;; deoptimize at 0_162: Insufficient type feedback for combined type of binary operation
  reading input frame nextTokenCanFollowModifier => node=29, args=1, height=2; inputs:
      0: 0xd6230dd31e1 ; [fp - 16] 0xd6230dd31e1 <JS Function nextTokenCanFollowModifier (SharedFunctionInfo 0x3504a53f3af1)>
      1: 0x1f9f6c0532e1 ; [fp + 16] 0x1f9f6c0532e1 <JS Global Object>
      2: 0xd6230d980d1 ; [fp - 24] 0xd6230d980d1 <FixedArray[334]>
      3: 0x4600000000 ; rax 70
  translating frame nextTokenCanFollowModifier => node=29, height=8
    0x7fff5fbfd4e8: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd4e0: [top + 32] <- 0x2c21d24171bf ;  caller's pc
    0x7fff5fbfd4d8: [top + 24] <- 0x7fff5fbfd540 ;  caller's fp
    0x7fff5fbfd4d0: [top + 16] <- 0xd6230d980d1 ;  context    0xd6230d980d1 <FixedArray[334]>  (input #2)
    0x7fff5fbfd4c8: [top + 8] <- 0xd6230dd31e1 ;  function    0xd6230dd31e1 <JS Function nextTokenCanFollowModifier (SharedFunctionInfo 0x3504a53f3af1)>  (input #0)
    0x7fff5fbfd4c0: [top + 0] <- 0x4600000000 ;  70  (input #3)
[deoptimizing (soft): end 0xd6230dd31e1 <JS Function nextTokenCanFollowModifier (SharedFunctionInfo 0x3504a53f3af1)> @50 => node=29, pc=0x2c21d243cbf1, caller sp=0x7fff5fbfd4f0, state=NO_REGISTERS, took 0.061 ms]
--- FUNCTION SOURCE (native string.js:lastIndexOf) id{124,0} ---
(w,x){
if((%IS_VAR(this)===null)||(this===(void 0)))throw %make_type_error(17,"String.prototype.lastIndexOf");
var y=(%_ToString(this));
var z=y.length;
var w=(%_ToString(w));
var A=w.length;
var v=z-A;
var t=(%_ToNumber(x));
if(!(!%_IsSmi(%IS_VAR(t))&&!(t==t))){
t=(%_ToInteger(t));
if(t<0){
t=0;
}
if(t+A<z){
v=t;
}
}
if(v<0){
return-1;
}
return %StringLastIndexOf(y,w,v);
}
--- END ---
--- FUNCTION SOURCE (native array.js:join) id{125,0} ---
(B){
if((%IS_VAR(this)===null)||(this===(void 0)))throw %make_type_error(17,"Array.prototype.join");
var q=(%_ToObject(this));
var r=(%_ToLength(q.length));
return InnerArrayJoin(B,q,r);
}
--- END ---
--- FUNCTION SOURCE (native array.js:InnerArrayJoin) id{126,0} ---
(B,q,r){
if((B===(void 0))){
B=',';
}else{
B=(%_ToString(B));
}
if(r===1){
var z=q[0];
if((z==null))return'';
return(%_ToString(z));
}
return Join(q,r,B,false);
}
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:scanJSDocToken) id{128,0} ---
() {
            if (pos >= end) {
                return token = 1 /* EndOfFileToken */;
            }
            startPos = pos;
            tokenPos = pos;
            var ch = text.charCodeAt(pos);
            switch (ch) {
                case 9 /* tab */:
                case 11 /* verticalTab */:
                case 12 /* formFeed */:
                case 32 /* space */:
                    while (pos < end && isWhiteSpaceSingleLine(text.charCodeAt(pos))) {
                        pos++;
                    }
                    return token = 5 /* WhitespaceTrivia */;
                case 64 /* at */:
                    pos++;
                    return token = 56 /* AtToken */;
                case 10 /* lineFeed */:
                case 13 /* carriageReturn */:
                    pos++;
                    return token = 4 /* NewLineTrivia */;
                case 42 /* asterisk */:
                    pos++;
                    return token = 38 /* AsteriskToken */;
                case 123 /* openBrace */:
                    pos++;
                    return token = 16 /* OpenBraceToken */;
                case 125 /* closeBrace */:
                    pos++;
                    return token = 17 /* CloseBraceToken */;
                case 91 /* openBracket */:
                    pos++;
                    return token = 20 /* OpenBracketToken */;
                case 93 /* closeBracket */:
                    pos++;
                    return token = 21 /* CloseBracketToken */;
                case 61 /* equals */:
                    pos++;
                    return token = 57 /* EqualsToken */;
                case 44 /* comma */:
                    pos++;
                    return token = 25 /* CommaToken */;
                case 46 /* dot */:
                    pos++;
                    return token = 22 /* DotToken */;
            }
            if (isIdentifierStart(ch, 5 /* Latest */)) {
                pos++;
                while (isIdentifierPart(text.charCodeAt(pos), 5 /* Latest */) && pos < end) {
                    pos++;
                }
                return token = 70 /* Identifier */;
            }
            else {
                return pos += 1, token = 0 /* Unknown */;
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIdentifierStart) id{128,1} ---
(ch, languageVersion) {
        return ch >= 65 /* A */ && ch <= 90 /* Z */ || ch >= 97 /* a */ && ch <= 122 /* z */ ||
            ch === 36 /* $ */ || ch === 95 /* _ */ ||
            ch > 127 /* maxAsciiCharacter */ && isUnicodeIdentifierStart(ch, languageVersion);
    }
--- END ---
INLINE (isIdentifierStart) id{128,1} AS 1 AT <0:1910>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIdentifierPart) id{128,2} ---
(ch, languageVersion) {
        return ch >= 65 /* A */ && ch <= 90 /* Z */ || ch >= 97 /* a */ && ch <= 122 /* z */ ||
            ch >= 48 /* _0 */ && ch <= 57 /* _9 */ || ch === 36 /* $ */ || ch === 95 /* _ */ ||
            ch > 127 /* maxAsciiCharacter */ && isUnicodeIdentifierPart(ch, languageVersion);
    }
--- END ---
INLINE (isIdentifierPart) id{128,2} AS 2 AT <0:1997>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseDelimitedList) id{129,0} ---
(kind, parseElement, considerSemicolonAsDelimiter) {
            var saveParsingContext = parsingContext;
            parsingContext |= 1 << kind;
            var result = createNodeArray();
            var commaStart = -1; // Meaning the previous token was not a comma
            while (true) {
                if (isListElement(kind, /*inErrorRecovery*/ false)) {
                    result.push(parseListElement(kind, parseElement));
                    commaStart = scanner.getTokenPos();
                    if (parseOptional(25 /* CommaToken */)) {
                        continue;
                    }
                    commaStart = -1; // Back to the state where the last token was not a comma
                    if (isListTerminator(kind)) {
                        break;
                    }
                    // We didn't get a comma, and the list wasn't terminated, explicitly parse
                    // out a comma so we give a good error message.
                    parseExpected(25 /* CommaToken */);
                    // If the token was a semicolon, and the caller allows that, then skip it and
                    // continue.  This ensures we get back on track and don't result in tons of
                    // parse errors.  For example, this can happen when people do things like use
                    // a semicolon to delimit object literal members.   Note: we'll have already
                    // reported an error when we called parseExpected above.
                    if (considerSemicolonAsDelimiter && token() === 24 /* SemicolonToken */ && !scanner.hasPrecedingLineBreak()) {
                        nextToken();
                    }
                    continue;
                }
                if (isListTerminator(kind)) {
                    break;
                }
                if (abortParsingListOrMoveToNextToken(kind)) {
                    break;
                }
            }
            // Recording the trailing comma is deliberately done after the previous
            // loop, and not just if we see a list terminator. This is because the list
            // may have ended incorrectly, but it is still important to know if there
            // was a trailing comma.
            // Check if the last token was a comma.
            if (commaStart >= 0) {
                // Always preserve a trailing comma by marking it on the NodeArray
                result.hasTrailingComma = true;
            }
            result.end = getNodeEnd();
            parsingContext = saveParsingContext;
            return result;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNodeArray) id{129,1} ---
(elements, pos) {
            var array = (elements || []);
            if (!(pos >= 0)) {
                pos = getNodePos();
            }
            array.pos = pos;
            array.end = pos;
            return array;
        }
--- END ---
INLINE (createNodeArray) id{129,1} AS 1 AT <0:172>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodePos) id{129,2} ---
() {
            return scanner.getStartPos();
        }
--- END ---
INLINE (getNodePos) id{129,2} AS 2 AT <1:113>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseListElement) id{129,3} ---
(parsingContext, parseElement) {
            var node = currentNode(parsingContext);
            if (node) {
                return consumeNode(node);
            }
            return parseElement();
        }
--- END ---
INLINE (parseListElement) id{129,3} AS 3 AT <0:399>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseOptional) id{129,4} ---
(t) {
            if (token() === t) {
                nextToken();
                return true;
            }
            return false;
        }
--- END ---
INLINE (parseOptional) id{129,4} AS 4 AT <0:518>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{129,5} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{129,5} AS 5 AT <4:22>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{129,6} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{129,6} AS 6 AT <4:55>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeEnd) id{129,7} ---
() {
            return scanner.getStartPos();
        }
--- END ---
INLINE (getNodeEnd) id{129,7} AS 7 AT <0:2498>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTextPos) id{130,0} ---
() { return pos; }
--- END ---
--- FUNCTION SOURCE (native array.js:StackPush) id{131,0} ---
(J,K){
J.values[J.length++]=K;
}
--- END ---
--- FUNCTION SOURCE (native array.js:UseSparseVariant) id{132,0} ---
(q,r,F,G){
if(!F||r<1000||%HasComplexElements(q)){
return false;
}
if(!%_IsSmi(r)){
return true;
}
var H=r>>2;
var I=%EstimateNumberOfElements(q);
return(I<H)&&
(G>I*4);
}
--- END ---
--- FUNCTION SOURCE (native array.js:StackPop) id{133,0} ---
(J){
J.values[--J.length]=null
}
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseVariableDeclaration) id{134,0} ---
() {
            var node = createNode(223 /* VariableDeclaration */);
            node.name = parseIdentifierOrPattern();
            node.type = parseTypeAnnotation();
            if (!isInOrOfKeyword(token())) {
                node.initializer = parseInitializer(/*inParameter*/ false);
            }
            return finishNode(node);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{134,1} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{134,1} AS 1 AT <0:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{134,2} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{134,2} AS 2 AT <1:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{134,3} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{134,3} AS 3 AT <1:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{134,4} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{134,4} AS 4 AT <1:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseIdentifierOrPattern) id{134,5} ---
() {
            if (token() === 20 /* OpenBracketToken */) {
                return parseArrayBindingPattern();
            }
            if (token() === 16 /* OpenBraceToken */) {
                return parseObjectBindingPattern();
            }
            return parseIdentifier();
        }
--- END ---
INLINE (parseIdentifierOrPattern) id{134,5} AS 5 AT <0:95>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{134,6} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{134,6} AS 6 AT <5:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{134,7} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{134,7} AS 7 AT <5:143>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseIdentifier) id{134,8} ---
(diagnosticMessage) {
            return createIdentifier(isIdentifier(), diagnosticMessage);
        }
--- END ---
INLINE (parseIdentifier) id{134,8} AS 8 AT <5:267>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseTypeAnnotation) id{134,9} ---
() {
            return parseOptional(55 /* ColonToken */) ? parseType() : undefined;
        }
--- END ---
INLINE (parseTypeAnnotation) id{134,9} AS 9 AT <0:147>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseOptional) id{134,10} ---
(t) {
            if (token() === t) {
                nextToken();
                return true;
            }
            return false;
        }
--- END ---
INLINE (parseOptional) id{134,10} AS 10 AT <9:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{134,11} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{134,11} AS 11 AT <10:22>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{134,12} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{134,12} AS 12 AT <10:55>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseType) id{134,13} ---
() {
            // The rules about 'yield' only apply to actual code/expression contexts.  They don't
            // apply to 'type' contexts.  So we disable these parameters here before moving on.
            return doOutsideOfContext(20480 /* TypeExcludesFlags */, parseTypeWorker);
        }
--- END ---
INLINE (parseType) id{134,13} AS 13 AT <9:61>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{134,14} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{134,14} AS 14 AT <0:203>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isInOrOfKeyword) id{134,15} ---
(t) {
            return t === 91 /* InKeyword */ || t === 140 /* OfKeyword */;
        }
--- END ---
INLINE (isInOrOfKeyword) id{134,15} AS 15 AT <0:187>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isVariableDeclaratorListTerminator) id{135,0} ---
() {
            // If we can consume a semicolon (either explicitly, or with ASI), then consider us done
            // with parsing the list of  variable declarators.
            if (canParseSemicolon()) {
                return true;
            }
            // in the case where we're parsing the variable declarator of a 'for-in' statement, we
            // are done if we see an 'in' keyword in front of us. Same with for-of
            if (isInOrOfKeyword(token())) {
                return true;
            }
            // ERROR RECOVERY TWEAK:
            // For better error recovery, if we see an '=>' then we just stop immediately.  We've got an
            // arrow function here and it's going to be very unlikely that we'll resynchronize and get
            // another variable declaration.
            if (token() === 35 /* EqualsGreaterThanToken */) {
                return true;
            }
            // Keep trying to parse out variable declarators.
            return false;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:canParseSemicolon) id{135,1} ---
() {
            // If there's a real semicolon, then we can always parse it out.
            if (token() === 24 /* SemicolonToken */) {
                return true;
            }
            // We can parse out an optional semicolon in ASI cases in the following cases.
            return token() === 17 /* CloseBraceToken */ || token() === 1 /* EndOfFileToken */ || scanner.hasPrecedingLineBreak();
        }
--- END ---
INLINE (canParseSemicolon) id{135,1} AS 1 AT <0:185>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{135,2} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{135,2} AS 2 AT <1:98>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{135,3} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{135,3} AS 3 AT <1:290>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{135,4} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{135,4} AS 4 AT <1:330>
[deoptimizing (DEOPT eager): begin 0xd6230d98e21 <JS Function parseTypeWorker (SharedFunctionInfo 0x3504a53f7b71)> (opt #37) @18, FP to SP delta: 224, caller sp: 0x7fff5fbfcd30]
            ;;; deoptimize at 12_221: wrong map
  reading input frame parseTypeWorker => node=67, args=1, height=2; inputs:
      0: 0xd6230d98e21 ; [fp - 16] 0xd6230d98e21 <JS Function parseTypeWorker (SharedFunctionInfo 0x3504a53f7b71)>
      1: 0x1f9f6c0532e1 ; [fp + 16] 0x1f9f6c0532e1 <JS Global Object>
      2: 0xd6230d980d1 ; [fp - 24] 0xd6230d980d1 <FixedArray[334]>
      3: 0xd6230d98d91 ; [fp - 56] 0xd6230d98d91 <JS Function parseUnionTypeOrHigher (SharedFunctionInfo 0x3504a53f7631)>
  reading input frame parseUnionTypeOrHigher => node=7, args=1, height=2; inputs:
      0: 0xd6230d98d91 ; (literal 37) 0xd6230d98d91 <JS Function parseUnionTypeOrHigher (SharedFunctionInfo 0x3504a53f7631)>
      1: 0x1f9f6c0532e1 ; (literal 34) 0x1f9f6c0532e1 <JS Global Object>
      2: 0xd6230d980d1 ; (literal 35) 0xd6230d980d1 <FixedArray[334]>
      3: 0xd6230d98d01 ; [fp - 64] 0xd6230d98d01 <JS Function parseUnionOrIntersectionType (SharedFunctionInfo 0x3504a53f74b1)>
  reading input frame parseUnionOrIntersectionType => node=88, args=4, height=7; inputs:
      0: 0xd6230d98d01 ; (literal 38) 0xd6230d98d01 <JS Function parseUnionOrIntersectionType (SharedFunctionInfo 0x3504a53f74b1)>
      1: 0x1f9f6c0532e1 ; (literal 34) 0x1f9f6c0532e1 <JS Global Object>
      2: 0xa400000000 ; (literal 39) 164
      3: 0xd6230d98d49 ; [fp - 72] 0xd6230d98d49 <JS Function parseIntersectionTypeOrHigher (SharedFunctionInfo 0x3504a53f7571)>
      4: 0x3000000000 ; (literal 40) 48
      5: 0xd6230d980d1 ; (literal 35) 0xd6230d980d1 <FixedArray[334]>
      6: 0x139ed25993a9 ; rbx 0x139ed25993a9 <a NodeObject with map 0x33abe2a67519>
      7: 0x30bcea404311 ; (literal 41) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; (literal 41) 0x30bcea404311 <undefined>
      9: 0xd6230db0809 ; rdx 0xd6230db0809 <JS Function createNodeArray (SharedFunctionInfo 0x3504a53f2fb1)>
     10: 0x30bcea404311 ; (literal 41) 0x30bcea404311 <undefined>
     11: 0x139ed2599429 ; rcx 0x139ed2599429 <JS Array[1]>
  translating frame parseTypeWorker => node=67, height=8
    0x7fff5fbfcd28: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfcd20: [top + 32] <- 0x2c21d248f2cd ;  caller's pc
    0x7fff5fbfcd18: [top + 24] <- 0x7fff5fbfcd60 ;  caller's fp
    0x7fff5fbfcd10: [top + 16] <- 0xd6230d980d1 ;  context    0xd6230d980d1 <FixedArray[334]>  (input #2)
    0x7fff5fbfcd08: [top + 8] <- 0xd6230d98e21 ;  function    0xd6230d98e21 <JS Function parseTypeWorker (SharedFunctionInfo 0x3504a53f7b71)>  (input #0)
    0x7fff5fbfcd00: [top + 0] <- 0xd6230d98d91 ;  0xd6230d98d91 <JS Function parseUnionTypeOrHigher (SharedFunctionInfo 0x3504a53f7631)>  (input #3)
  translating frame parseUnionTypeOrHigher => node=7, height=8
    0x7fff5fbfccf8: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfccf0: [top + 32] <- 0x2c21d241ff43 ;  caller's pc
    0x7fff5fbfcce8: [top + 24] <- 0x7fff5fbfcd18 ;  caller's fp
    0x7fff5fbfcce0: [top + 16] <- 0xd6230d980d1 ;  context    0xd6230d980d1 <FixedArray[334]>  (input #2)
    0x7fff5fbfccd8: [top + 8] <- 0xd6230d98d91 ;  function    0xd6230d98d91 <JS Function parseUnionTypeOrHigher (SharedFunctionInfo 0x3504a53f7631)>  (input #0)
    0x7fff5fbfccd0: [top + 0] <- 0xd6230d98d01 ;  0xd6230d98d01 <JS Function parseUnionOrIntersectionType (SharedFunctionInfo 0x3504a53f74b1)>  (input #3)
  translating frame parseUnionOrIntersectionType => node=88, height=48
    0x7fff5fbfccc8: [top + 104] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfccc0: [top + 96] <- 0xa400000000 ;  164  (input #2)
    0x7fff5fbfccb8: [top + 88] <- 0xd6230d98d49 ;  0xd6230d98d49 <JS Function parseIntersectionTypeOrHigher (SharedFunctionInfo 0x3504a53f7571)>  (input #3)
    0x7fff5fbfccb0: [top + 80] <- 0x3000000000 ;  48  (input #4)
    0x7fff5fbfcca8: [top + 72] <- 0x2c21d24201f6 ;  caller's pc
    0x7fff5fbfcca0: [top + 64] <- 0x7fff5fbfcce8 ;  caller's fp
    0x7fff5fbfcc98: [top + 56] <- 0xd6230d980d1 ;  context    0xd6230d980d1 <FixedArray[334]>  (input #5)
    0x7fff5fbfcc90: [top + 48] <- 0xd6230d98d01 ;  function    0xd6230d98d01 <JS Function parseUnionOrIntersectionType (SharedFunctionInfo 0x3504a53f74b1)>  (input #0)
    0x7fff5fbfcc88: [top + 40] <- 0x139ed25993a9 ;  0x139ed25993a9 <a NodeObject with map 0x33abe2a67519>  (input #6)
    0x7fff5fbfcc80: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfcc78: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfcc70: [top + 16] <- 0xd6230db0809 ;  0xd6230db0809 <JS Function createNodeArray (SharedFunctionInfo 0x3504a53f2fb1)>  (input #9)
    0x7fff5fbfcc68: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #10)
    0x7fff5fbfcc60: [top + 0] <- 0x139ed2599429 ;  0x139ed2599429 <JS Array[1]>  (input #11)
[deoptimizing (eager): end 0xd6230d98e21 <JS Function parseTypeWorker (SharedFunctionInfo 0x3504a53f7b71)> @18 => node=88, pc=0x2c21d24203b8, caller sp=0x7fff5fbfcd30, state=NO_REGISTERS, took 0.162 ms]
[deoptimizer unlinked: parseTypeWorker / d6230d98e21]
[deoptimizing (DEOPT lazy): begin 0xd6230d98e21 <JS Function parseTypeWorker (SharedFunctionInfo 0x3504a53f7b71)> (opt #37) @15, FP to SP delta: 224, caller sp: 0x7fff5fbfd450]
  reading input frame parseTypeWorker => node=67, args=1, height=2; inputs:
      0: 0xd6230d98e21 ; [fp - 16] 0xd6230d98e21 <JS Function parseTypeWorker (SharedFunctionInfo 0x3504a53f7b71)>
      1: 0x1f9f6c0532e1 ; [fp + 16] 0x1f9f6c0532e1 <JS Global Object>
      2: 0xd6230d980d1 ; [fp - 24] 0xd6230d980d1 <FixedArray[334]>
      3: 0xd6230d98d91 ; [fp - 56] 0xd6230d98d91 <JS Function parseUnionTypeOrHigher (SharedFunctionInfo 0x3504a53f7631)>
  reading input frame parseUnionTypeOrHigher => node=7, args=1, height=2; inputs:
      0: 0xd6230d98d91 ; (literal 37) 0xd6230d98d91 <JS Function parseUnionTypeOrHigher (SharedFunctionInfo 0x3504a53f7631)>
      1: 0x1f9f6c0532e1 ; (literal 34) 0x1f9f6c0532e1 <JS Global Object>
      2: 0xd6230d980d1 ; (literal 35) 0xd6230d980d1 <FixedArray[334]>
      3: 0xd6230d98d01 ; [fp - 64] 0xd6230d98d01 <JS Function parseUnionOrIntersectionType (SharedFunctionInfo 0x3504a53f74b1)>
  reading input frame parseUnionOrIntersectionType => node=36, args=4, height=5; inputs:
      0: 0xd6230d98d01 ; (literal 38) 0xd6230d98d01 <JS Function parseUnionOrIntersectionType (SharedFunctionInfo 0x3504a53f74b1)>
      1: 0x1f9f6c0532e1 ; (literal 34) 0x1f9f6c0532e1 <JS Global Object>
      2: 0xa400000000 ; (literal 39) 164
      3: 0xd6230d98d49 ; [fp - 72] 0xd6230d98d49 <JS Function parseIntersectionTypeOrHigher (SharedFunctionInfo 0x3504a53f7571)>
      4: 0x3000000000 ; (literal 40) 48
      5: 0xd6230d980d1 ; (literal 35) 0xd6230d980d1 <FixedArray[334]>
      6: 0x30bcea404311 ; (literal 41) 0x30bcea404311 <undefined>
      7: 0x30bcea404311 ; (literal 41) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; (literal 41) 0x30bcea404311 <undefined>
      9: 0x139ed25930a1 ; rbx 0x139ed25930a1 <a NodeObject with map 0x33abe2a67621>
  translating frame parseTypeWorker => node=67, height=8
    0x7fff5fbfd448: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd440: [top + 32] <- 0x2c21d248f2cd ;  caller's pc
    0x7fff5fbfd438: [top + 24] <- 0x7fff5fbfd480 ;  caller's fp
    0x7fff5fbfd430: [top + 16] <- 0xd6230d980d1 ;  context    0xd6230d980d1 <FixedArray[334]>  (input #2)
    0x7fff5fbfd428: [top + 8] <- 0xd6230d98e21 ;  function    0xd6230d98e21 <JS Function parseTypeWorker (SharedFunctionInfo 0x3504a53f7b71)>  (input #0)
    0x7fff5fbfd420: [top + 0] <- 0xd6230d98d91 ;  0xd6230d98d91 <JS Function parseUnionTypeOrHigher (SharedFunctionInfo 0x3504a53f7631)>  (input #3)
  translating frame parseUnionTypeOrHigher => node=7, height=8
    0x7fff5fbfd418: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd410: [top + 32] <- 0x2c21d241ff43 ;  caller's pc
    0x7fff5fbfd408: [top + 24] <- 0x7fff5fbfd438 ;  caller's fp
    0x7fff5fbfd400: [top + 16] <- 0xd6230d980d1 ;  context    0xd6230d980d1 <FixedArray[334]>  (input #2)
    0x7fff5fbfd3f8: [top + 8] <- 0xd6230d98d91 ;  function    0xd6230d98d91 <JS Function parseUnionTypeOrHigher (SharedFunctionInfo 0x3504a53f7631)>  (input #0)
    0x7fff5fbfd3f0: [top + 0] <- 0xd6230d98d01 ;  0xd6230d98d01 <JS Function parseUnionOrIntersectionType (SharedFunctionInfo 0x3504a53f74b1)>  (input #3)
  translating frame parseUnionOrIntersectionType => node=36, height=32
    0x7fff5fbfd3e8: [top + 88] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd3e0: [top + 80] <- 0xa400000000 ;  164  (input #2)
    0x7fff5fbfd3d8: [top + 72] <- 0xd6230d98d49 ;  0xd6230d98d49 <JS Function parseIntersectionTypeOrHigher (SharedFunctionInfo 0x3504a53f7571)>  (input #3)
    0x7fff5fbfd3d0: [top + 64] <- 0x3000000000 ;  48  (input #4)
    0x7fff5fbfd3c8: [top + 56] <- 0x2c21d24201f6 ;  caller's pc
    0x7fff5fbfd3c0: [top + 48] <- 0x7fff5fbfd408 ;  caller's fp
    0x7fff5fbfd3b8: [top + 40] <- 0xd6230d980d1 ;  context    0xd6230d980d1 <FixedArray[334]>  (input #5)
    0x7fff5fbfd3b0: [top + 32] <- 0xd6230d98d01 ;  function    0xd6230d98d01 <JS Function parseUnionOrIntersectionType (SharedFunctionInfo 0x3504a53f74b1)>  (input #0)
    0x7fff5fbfd3a8: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfd3a0: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfd398: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfd390: [top + 0] <- 0x139ed25930a1 ;  0x139ed25930a1 <a NodeObject with map 0x33abe2a67621>  (input #9)
[deoptimizing (lazy): end 0xd6230d98e21 <JS Function parseTypeWorker (SharedFunctionInfo 0x3504a53f7b71)> @15 => node=36, pc=0x2c21d242032a, caller sp=0x7fff5fbfd450, state=TOS_REGISTER, took 0.149 ms]
[deoptimizing (DEOPT soft): begin 0xd6230db05c9 <JS Function scan (SharedFunctionInfo 0x16f3adb53cc1)> (opt #78) @137, FP to SP delta: 128, caller sp: 0x7fff5fbfd2f0]
            ;;; deoptimize at 0_5605: Insufficient type feedback for LHS of binary operation
  reading input frame scan => node=1528, args=1, height=9; inputs:
      0: 0xd6230db05c9 ; [fp - 16] 0xd6230db05c9 <JS Function scan (SharedFunctionInfo 0x16f3adb53cc1)>
      1: 0xd6230dd29d9 ; [fp + 16] 0xd6230dd29d9 <an Object with map 0x33abe2a503e9>
      2: 0xd6230dd5e59 ; rcx 0xd6230dd5e59 <FixedArray[39]>
      3: 0x30bcea4069a9 ; (literal 8) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      4: 0x30bcea4069a9 ; (literal 8) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      5: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
      6: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
      7: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
      9: 0x2f05bb83a839 ; [fp - 64] 0x2f05bb83a839 <Very long string[189592]>
     10: 0x30bcea4b47a9 ; rax 0x30bcea4b47a9 <JS Function charCodeAt (SharedFunctionInfo 0x30bcea46c659)>
  translating frame scan => node=1528, height=64
    0x7fff5fbfd2e8: [top + 96] <- 0xd6230dd29d9 ;  0xd6230dd29d9 <an Object with map 0x33abe2a503e9>  (input #1)
    0x7fff5fbfd2e0: [top + 88] <- 0x2c21d246f5b1 ;  caller's pc
    0x7fff5fbfd2d8: [top + 80] <- 0x7fff5fbfd318 ;  caller's fp
    0x7fff5fbfd2d0: [top + 72] <- 0xd6230dd5e59 ;  context    0xd6230dd5e59 <FixedArray[39]>  (input #2)
    0x7fff5fbfd2c8: [top + 64] <- 0xd6230db05c9 ;  function    0xd6230db05c9 <JS Function scan (SharedFunctionInfo 0x16f3adb53cc1)>  (input #0)
    0x7fff5fbfd2c0: [top + 56] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #3)
    0x7fff5fbfd2b8: [top + 48] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #4)
    0x7fff5fbfd2b0: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfd2a8: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfd2a0: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfd298: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfd290: [top + 8] <- 0x2f05bb83a839 ;  0x2f05bb83a839 <Very long string[189592]>  (input #9)
    0x7fff5fbfd288: [top + 0] <- 0x30bcea4b47a9 ;  0x30bcea4b47a9 <JS Function charCodeAt (SharedFunctionInfo 0x30bcea46c659)>  (input #10)
[deoptimizing (soft): end 0xd6230db05c9 <JS Function scan (SharedFunctionInfo 0x16f3adb53cc1)> @137 => node=1528, pc=0x2c21d240902d, caller sp=0x7fff5fbfd2f0, state=TOS_REGISTER, took 0.081 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:setText) id{136,0} ---
(newText, start, length) {
            text = newText || "";
            end = length === undefined ? text.length : start + length;
            setTextPos(start || 0);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parsePropertyNameWorker) id{137,0} ---
(allowComputedPropertyNames) {
            if (token() === 9 /* StringLiteral */ || token() === 8 /* NumericLiteral */) {
                return parseLiteralNode(/*internName*/ true);
            }
            if (allowComputedPropertyNames && token() === 20 /* OpenBracketToken */) {
                return parseComputedPropertyName();
            }
            return parseIdentifierName();
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{137,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{137,1} AS 1 AT <0:47>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{137,2} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{137,2} AS 2 AT <0:84>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{137,3} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{137,3} AS 3 AT <0:244>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseIdentifierName) id{137,4} ---
() {
            return createIdentifier(ts.tokenIsIdentifierOrKeyword(token()));
        }
--- END ---
INLINE (parseIdentifierName) id{137,4} AS 4 AT <0:370>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{137,5} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{137,5} AS 5 AT <4:71>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:scan) id{138,0} ---
() {
            startPos = pos;
            hasExtendedUnicodeEscape = false;
            precedingLineBreak = false;
            tokenIsUnterminated = false;
            while (true) {
                tokenPos = pos;
                if (pos >= end) {
                    return token = 1 /* EndOfFileToken */;
                }
                var ch = text.charCodeAt(pos);
                // Special handling for shebang
                if (ch === 35 /* hash */ && pos === 0 && isShebangTrivia(text, pos)) {
                    pos = scanShebangTrivia(text, pos);
                    if (skipTrivia) {
                        continue;
                    }
                    else {
                        return token = 6 /* ShebangTrivia */;
                    }
                }
                switch (ch) {
                    case 10 /* lineFeed */:
                    case 13 /* carriageReturn */:
                        precedingLineBreak = true;
                        if (skipTrivia) {
                            pos++;
                            continue;
                        }
                        else {
                            if (ch === 13 /* carriageReturn */ && pos + 1 < end && text.charCodeAt(pos + 1) === 10 /* lineFeed */) {
                                // consume both CR and LF
                                pos += 2;
                            }
                            else {
                                pos++;
                            }
                            return token = 4 /* NewLineTrivia */;
                        }
                    case 9 /* tab */:
                    case 11 /* verticalTab */:
                    case 12 /* formFeed */:
                    case 32 /* space */:
                        if (skipTrivia) {
                            pos++;
                            continue;
                        }
                        else {
                            while (pos < end && isWhiteSpaceSingleLine(text.charCodeAt(pos))) {
                                pos++;
                            }
                            return token = 5 /* WhitespaceTrivia */;
                        }
                    case 33 /* exclamation */:
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            if (text.charCodeAt(pos + 2) === 61 /* equals */) {
                                return pos += 3, token = 34 /* ExclamationEqualsEqualsToken */;
                            }
                            return pos += 2, token = 32 /* ExclamationEqualsToken */;
                        }
                        pos++;
                        return token = 50 /* ExclamationToken */;
                    case 34 /* doubleQuote */:
                    case 39 /* singleQuote */:
                        tokenValue = scanString();
                        return token = 9 /* StringLiteral */;
                    case 96 /* backtick */:
                        return token = scanTemplateAndSetTokenValue();
                    case 37 /* percent */:
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 63 /* PercentEqualsToken */;
                        }
                        pos++;
                        return token = 41 /* PercentToken */;
                    case 38 /* ampersand */:
                        if (text.charCodeAt(pos + 1) === 38 /* ampersand */) {
                            return pos += 2, token = 52 /* AmpersandAmpersandToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 67 /* AmpersandEqualsToken */;
                        }
                        pos++;
                        return token = 47 /* AmpersandToken */;
                    case 40 /* openParen */:
                        pos++;
                        return token = 18 /* OpenParenToken */;
                    case 41 /* closeParen */:
                        pos++;
                        return token = 19 /* CloseParenToken */;
                    case 42 /* asterisk */:
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 60 /* AsteriskEqualsToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 42 /* asterisk */) {
                            if (text.charCodeAt(pos + 2) === 61 /* equals */) {
                                return pos += 3, token = 61 /* AsteriskAsteriskEqualsToken */;
                            }
                            return pos += 2, token = 39 /* AsteriskAsteriskToken */;
                        }
                        pos++;
                        return token = 38 /* AsteriskToken */;
                    case 43 /* plus */:
                        if (text.charCodeAt(pos + 1) === 43 /* plus */) {
                            return pos += 2, token = 42 /* PlusPlusToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 58 /* PlusEqualsToken */;
                        }
                        pos++;
                        return token = 36 /* PlusToken */;
                    case 44 /* comma */:
                        pos++;
                        return token = 25 /* CommaToken */;
                    case 45 /* minus */:
                        if (text.charCodeAt(pos + 1) === 45 /* minus */) {
                            return pos += 2, token = 43 /* MinusMinusToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 59 /* MinusEqualsToken */;
                        }
                        pos++;
                        return token = 37 /* MinusToken */;
                    case 46 /* dot */:
                        if (isDigit(text.charCodeAt(pos + 1))) {
                            tokenValue = scanNumber();
                            return token = 8 /* NumericLiteral */;
                        }
                        if (text.charCodeAt(pos + 1) === 46 /* dot */ && text.charCodeAt(pos + 2) === 46 /* dot */) {
                            return pos += 3, token = 23 /* DotDotDotToken */;
                        }
                        pos++;
                        return token = 22 /* DotToken */;
                    case 47 /* slash */:
                        // Single-line comment
                        if (text.charCodeAt(pos + 1) === 47 /* slash */) {
                            pos += 2;
                            while (pos < end) {
                                if (isLineBreak(text.charCodeAt(pos))) {
                                    break;
                                }
                                pos++;
                            }
                            if (skipTrivia) {
                                continue;
                            }
                            else {
                                return token = 2 /* SingleLineCommentTrivia */;
                            }
                        }
                        // Multi-line comment
                        if (text.charCodeAt(pos + 1) === 42 /* asterisk */) {
                            pos += 2;
                            var commentClosed = false;
                            while (pos < end) {
                                var ch_2 = text.charCodeAt(pos);
                                if (ch_2 === 42 /* asterisk */ && text.charCodeAt(pos + 1) === 47 /* slash */) {
                                    pos += 2;
                                    commentClosed = true;
                                    break;
                                }
                                if (isLineBreak(ch_2)) {
                                    precedingLineBreak = true;
                                }
                                pos++;
                            }
                            if (!commentClosed) {
                                error(ts.Diagnostics.Asterisk_Slash_expected);
                            }
                            if (skipTrivia) {
                                continue;
                            }
                            else {
                                tokenIsUnterminated = !commentClosed;
                                return token = 3 /* MultiLineCommentTrivia */;
                            }
                        }
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 62 /* SlashEqualsToken */;
                        }
                        pos++;
                        return token = 40 /* SlashToken */;
                    case 48 /* _0 */:
                        if (pos + 2 < end && (text.charCodeAt(pos + 1) === 88 /* X */ || text.charCodeAt(pos + 1) === 120 /* x */)) {
                            pos += 2;
                            var value = scanMinimumNumberOfHexDigits(1);
                            if (value < 0) {
                                error(ts.Diagnostics.Hexadecimal_digit_expected);
                                value = 0;
                            }
                            tokenValue = "" + value;
                            return token = 8 /* NumericLiteral */;
                        }
                        else if (pos + 2 < end && (text.charCodeAt(pos + 1) === 66 /* B */ || text.charCodeAt(pos + 1) === 98 /* b */)) {
                            pos += 2;
                            var value = scanBinaryOrOctalDigits(/* base */ 2);
                            if (value < 0) {
                                error(ts.Diagnostics.Binary_digit_expected);
                                value = 0;
                            }
                            tokenValue = "" + value;
                            return token = 8 /* NumericLiteral */;
                        }
                        else if (pos + 2 < end && (text.charCodeAt(pos + 1) === 79 /* O */ || text.charCodeAt(pos + 1) === 111 /* o */)) {
                            pos += 2;
                            var value = scanBinaryOrOctalDigits(/* base */ 8);
                            if (value < 0) {
                                error(ts.Diagnostics.Octal_digit_expected);
                                value = 0;
                            }
                            tokenValue = "" + value;
                            return token = 8 /* NumericLiteral */;
                        }
                        // Try to parse as an octal
                        if (pos + 1 < end && isOctalDigit(text.charCodeAt(pos + 1))) {
                            tokenValue = "" + scanOctalDigits();
                            return token = 8 /* NumericLiteral */;
                        }
                    // This fall-through is a deviation from the EcmaScript grammar. The grammar says that a leading zero
                    // can only be followed by an octal digit, a dot, or the end of the number literal. However, we are being
                    // permissive and allowing decimal digits of the form 08* and 09* (which many browsers also do).
                    case 49 /* _1 */:
                    case 50 /* _2 */:
                    case 51 /* _3 */:
                    case 52 /* _4 */:
                    case 53 /* _5 */:
                    case 54 /* _6 */:
                    case 55 /* _7 */:
                    case 56 /* _8 */:
                    case 57 /* _9 */:
                        tokenValue = scanNumber();
                        return token = 8 /* NumericLiteral */;
                    case 58 /* colon */:
                        pos++;
                        return token = 55 /* ColonToken */;
                    case 59 /* semicolon */:
                        pos++;
                        return token = 24 /* SemicolonToken */;
                    case 60 /* lessThan */:
                        if (isConflictMarkerTrivia(text, pos)) {
                            pos = scanConflictMarkerTrivia(text, pos, error);
                            if (skipTrivia) {
                                continue;
                            }
                            else {
                                return token = 7 /* ConflictMarkerTrivia */;
                            }
                        }
                        if (text.charCodeAt(pos + 1) === 60 /* lessThan */) {
                            if (text.charCodeAt(pos + 2) === 61 /* equals */) {
                                return pos += 3, token = 64 /* LessThanLessThanEqualsToken */;
                            }
                            return pos += 2, token = 44 /* LessThanLessThanToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 29 /* LessThanEqualsToken */;
                        }
                        if (languageVariant === 1 /* JSX */ &&
                            text.charCodeAt(pos + 1) === 47 /* slash */ &&
                            text.charCodeAt(pos + 2) !== 42 /* asterisk */) {
                            return pos += 2, token = 27 /* LessThanSlashToken */;
                        }
                        pos++;
                        return token = 26 /* LessThanToken */;
                    case 61 /* equals */:
                        if (isConflictMarkerTrivia(text, pos)) {
                            pos = scanConflictMarkerTrivia(text, pos, error);
                            if (skipTrivia) {
                                continue;
                            }
                            else {
                                return token = 7 /* ConflictMarkerTrivia */;
                            }
                        }
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            if (text.charCodeAt(pos + 2) === 61 /* equals */) {
                                return pos += 3, token = 33 /* EqualsEqualsEqualsToken */;
                            }
                            return pos += 2, token = 31 /* EqualsEqualsToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 62 /* greaterThan */) {
                            return pos += 2, token = 35 /* EqualsGreaterThanToken */;
                        }
                        pos++;
                        return token = 57 /* EqualsToken */;
                    case 62 /* greaterThan */:
                        if (isConflictMarkerTrivia(text, pos)) {
                            pos = scanConflictMarkerTrivia(text, pos, error);
                            if (skipTrivia) {
                                continue;
                            }
                            else {
                                return token = 7 /* ConflictMarkerTrivia */;
                            }
                        }
                        pos++;
                        return token = 28 /* GreaterThanToken */;
                    case 63 /* question */:
                        pos++;
                        return token = 54 /* QuestionToken */;
                    case 91 /* openBracket */:
                        pos++;
                        return token = 20 /* OpenBracketToken */;
                    case 93 /* closeBracket */:
                        pos++;
                        return token = 21 /* CloseBracketToken */;
                    case 94 /* caret */:
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 69 /* CaretEqualsToken */;
                        }
                        pos++;
                        return token = 49 /* CaretToken */;
                    case 123 /* openBrace */:
                        pos++;
                        return token = 16 /* OpenBraceToken */;
                    case 124 /* bar */:
                        if (text.charCodeAt(pos + 1) === 124 /* bar */) {
                            return pos += 2, token = 53 /* BarBarToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 68 /* BarEqualsToken */;
                        }
                        pos++;
                        return token = 48 /* BarToken */;
                    case 125 /* closeBrace */:
                        pos++;
                        return token = 17 /* CloseBraceToken */;
                    case 126 /* tilde */:
                        pos++;
                        return token = 51 /* TildeToken */;
                    case 64 /* at */:
                        pos++;
                        return token = 56 /* AtToken */;
                    case 92 /* backslash */:
                        var cookedChar = peekUnicodeEscape();
                        if (cookedChar >= 0 && isIdentifierStart(cookedChar, languageVersion)) {
                            pos += 6;
                            tokenValue = String.fromCharCode(cookedChar) + scanIdentifierParts();
                            return token = getIdentifierToken();
                        }
                        error(ts.Diagnostics.Invalid_character);
                        pos++;
                        return token = 0 /* Unknown */;
                    default:
                        if (isIdentifierStart(ch, languageVersion)) {
                            pos++;
                            while (pos < end && isIdentifierPart(ch = text.charCodeAt(pos), languageVersion))
                                pos++;
                            tokenValue = text.substring(tokenPos, pos);
                            if (ch === 92 /* backslash */) {
                                tokenValue += scanIdentifierParts();
                            }
                            return token = getIdentifierToken();
                        }
                        else if (isWhiteSpaceSingleLine(ch)) {
                            pos++;
                            continue;
                        }
                        else if (isLineBreak(ch)) {
                            precedingLineBreak = true;
                            pos++;
                            continue;
                        }
                        error(ts.Diagnostics.Invalid_character);
                        pos++;
                        return token = 0 /* Unknown */;
                }
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isDigit) id{138,1} ---
(ch) {
        return ch >= 48 /* _0 */ && ch <= 57 /* _9 */;
    }
--- END ---
INLINE (isDigit) id{138,1} AS 1 AT <0:6077>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIdentifierStart) id{138,2} ---
(ch, languageVersion) {
        return ch >= 65 /* A */ && ch <= 90 /* Z */ || ch >= 97 /* a */ && ch <= 122 /* z */ ||
            ch === 36 /* $ */ || ch === 95 /* _ */ ||
            ch > 127 /* maxAsciiCharacter */ && isUnicodeIdentifierStart(ch, languageVersion);
    }
--- END ---
INLINE (isIdentifierStart) id{138,2} AS 2 AT <0:17770>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIdentifierPart) id{138,3} ---
(ch, languageVersion) {
        return ch >= 65 /* A */ && ch <= 90 /* Z */ || ch >= 97 /* a */ && ch <= 122 /* z */ ||
            ch >= 48 /* _0 */ && ch <= 57 /* _9 */ || ch === 36 /* $ */ || ch === 95 /* _ */ ||
            ch > 127 /* maxAsciiCharacter */ && isUnicodeIdentifierPart(ch, languageVersion);
    }
--- END ---
INLINE (isIdentifierPart) id{138,3} AS 3 AT <0:17895>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseJSDocComment) id{139,0} ---
(parent, start, length) {
                var saveToken = currentToken;
                var saveParseDiagnosticsLength = parseDiagnostics.length;
                var saveParseErrorBeforeNextFinishedNode = parseErrorBeforeNextFinishedNode;
                var comment = parseJSDocCommentWorker(start, length);
                if (comment) {
                    comment.parent = parent;
                }
                currentToken = saveToken;
                parseDiagnostics.length = saveParseDiagnosticsLength;
                parseErrorBeforeNextFinishedNode = saveParseErrorBeforeNextFinishedNode;
                return comment;
            }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseLiteralLikeNode) id{140,0} ---
(kind, internName) {
            var node = createNode(kind);
            var text = scanner.getTokenValue();
            node.text = internName ? internIdentifier(text) : text;
            if (scanner.hasExtendedUnicodeEscape()) {
                node.hasExtendedUnicodeEscape = true;
            }
            if (scanner.isUnterminated()) {
                node.isUnterminated = true;
            }
            var tokenPos = scanner.getTokenPos();
            nextToken();
            finishNode(node);
            // Octal literals are not allowed in strict mode or ES5
            // Note that theoretically the following condition would hold true literals like 009,
            // which is not octal.But because of how the scanner separates the tokens, we would
            // never get a token like this. Instead, we would get 00 and 9 as two separate tokens.
            // We also do not need to check for negatives because any prefix operator would be part of a
            // parent unary expression.
            if (node.kind === 8 /* NumericLiteral */
                && sourceText.charCodeAt(tokenPos) === 48 /* _0 */
                && ts.isOctalDigit(sourceText.charCodeAt(tokenPos + 1))) {
                node.isOctalLiteral = true;
            }
            return node;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{140,1} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{140,1} AS 1 AT <0:44>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{140,2} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{140,2} AS 2 AT <1:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{140,3} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{140,3} AS 3 AT <1:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{140,4} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{140,4} AS 4 AT <1:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:internIdentifier) id{140,5} ---
(text) {
            text = ts.escapeIdentifier(text);
            return identifiers[text] || (identifiers[text] = text);
        }
--- END ---
INLINE (internIdentifier) id{140,5} AS 5 AT <0:147>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{140,6} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{140,6} AS 6 AT <0:464>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseTypeWorker) id{141,0} ---
() {
            if (isStartOfFunctionType()) {
                return parseFunctionOrConstructorType(158 /* FunctionType */);
            }
            if (token() === 93 /* NewKeyword */) {
                return parseFunctionOrConstructorType(159 /* ConstructorType */);
            }
            return parseUnionTypeOrHigher();
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isStartOfFunctionType) id{141,1} ---
() {
            if (token() === 26 /* LessThanToken */) {
                return true;
            }
            return token() === 18 /* OpenParenToken */ && lookAhead(isUnambiguouslyStartOfFunctionType);
        }
--- END ---
INLINE (isStartOfFunctionType) id{141,1} AS 1 AT <0:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{141,2} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{141,2} AS 2 AT <1:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{141,3} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{141,3} AS 3 AT <1:121>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:lookAhead) id{141,4} ---
(callback) {
            return speculationHelper(callback, /*isLookAhead*/ true);
        }
--- END ---
INLINE (lookAhead) id{141,4} AS 4 AT <1:160>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseFunctionOrConstructorType) id{141,5} ---
(kind) {
            var node = createNode(kind);
            if (kind === 159 /* ConstructorType */) {
                parseExpected(93 /* NewKeyword */);
            }
            fillSignature(35 /* EqualsGreaterThanToken */, /*yieldContext*/ false, /*awaitContext*/ false, /*requireCompleteParameterList*/ false, node);
            return finishNode(node);
        }
--- END ---
INLINE (parseFunctionOrConstructorType) id{141,5} AS 5 AT <0:71>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{141,6} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{141,6} AS 6 AT <5:32>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{141,7} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{141,7} AS 7 AT <6:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{141,8} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{141,8} AS 8 AT <6:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{141,9} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{141,9} AS 9 AT <6:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{141,10} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{141,10} AS 10 AT <0:157>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseUnionTypeOrHigher) id{141,11} ---
() {
            return parseUnionOrIntersectionType(164 /* UnionType */, parseIntersectionTypeOrHigher, 48 /* BarToken */);
        }
--- END ---
INLINE (parseUnionTypeOrHigher) id{141,11} AS 11 AT <0:307>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseUnionOrIntersectionType) id{141,12} ---
(kind, parseConstituentType, operator) {
            parseOptional(operator);
            var type = parseConstituentType();
            if (token() === operator) {
                var types = createNodeArray([type], type.pos);
                while (parseOptional(operator)) {
                    types.push(parseConstituentType());
                }
                types.end = getNodeEnd();
                var node = createNode(kind, type.pos);
                node.types = types;
                type = finishNode(node);
            }
            return type;
        }
--- END ---
INLINE (parseUnionOrIntersectionType) id{141,12} AS 12 AT <11:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseOptional) id{141,13} ---
(t) {
            if (token() === t) {
                nextToken();
                return true;
            }
            return false;
        }
--- END ---
INLINE (parseOptional) id{141,13} AS 13 AT <12:53>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{141,14} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{141,14} AS 14 AT <13:22>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{141,15} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{141,15} AS 15 AT <13:55>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{141,16} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{141,16} AS 16 AT <12:141>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNodeArray) id{141,17} ---
(elements, pos) {
            var array = (elements || []);
            if (!(pos >= 0)) {
                pos = getNodePos();
            }
            array.pos = pos;
            array.end = pos;
            return array;
        }
--- END ---
INLINE (createNodeArray) id{141,17} AS 17 AT <12:193>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodePos) id{141,18} ---
() {
            return scanner.getStartPos();
        }
--- END ---
INLINE (getNodePos) id{141,18} AS 18 AT <17:113>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseOptional) id{141,19} ---
(t) {
            if (token() === t) {
                nextToken();
                return true;
            }
            return false;
        }
--- END ---
INLINE (parseOptional) id{141,19} AS 19 AT <12:251>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{141,20} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{141,20} AS 20 AT <19:22>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{141,21} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{141,21} AS 21 AT <19:55>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseIntersectionTypeOrHigher) id{141,22} ---
() {
            return parseUnionOrIntersectionType(165 /* IntersectionType */, parseTypeOperatorOrHigher, 47 /* AmpersandToken */);
        }
--- END ---
INLINE (parseIntersectionTypeOrHigher) id{141,22} AS 22 AT <12:309>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeEnd) id{141,23} ---
() {
            return scanner.getStartPos();
        }
--- END ---
INLINE (getNodeEnd) id{141,23} AS 23 AT <12:380>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{141,24} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{141,24} AS 24 AT <12:421>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{141,25} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{141,25} AS 25 AT <24:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{141,26} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{141,26} AS 26 AT <24:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{141,27} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{141,27} AS 27 AT <24:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isLeftHandSideExpressionKind) id{142,0} ---
(kind) {
        return kind === 177 /* PropertyAccessExpression */
            || kind === 178 /* ElementAccessExpression */
            || kind === 180 /* NewExpression */
            || kind === 179 /* CallExpression */
            || kind === 246 /* JsxElement */
            || kind === 247 /* JsxSelfClosingElement */
            || kind === 181 /* TaggedTemplateExpression */
            || kind === 175 /* ArrayLiteralExpression */
            || kind === 183 /* ParenthesizedExpression */
            || kind === 176 /* ObjectLiteralExpression */
            || kind === 197 /* ClassExpression */
            || kind === 184 /* FunctionExpression */
            || kind === 70 /* Identifier */
            || kind === 11 /* RegularExpressionLiteral */
            || kind === 8 /* NumericLiteral */
            || kind === 9 /* StringLiteral */
            || kind === 12 /* NoSubstitutionTemplateLiteral */
            || kind === 194 /* TemplateExpression */
            || kind === 85 /* FalseKeyword */
            || kind === 94 /* NullKeyword */
            || kind === 98 /* ThisKeyword */
            || kind === 100 /* TrueKeyword */
            || kind === 96 /* SuperKeyword */
            || kind === 201 /* NonNullExpression */;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseIncrementExpression) id{143,0} ---
() {
            if (token() === 42 /* PlusPlusToken */ || token() === 43 /* MinusMinusToken */) {
                var node = createNode(190 /* PrefixUnaryExpression */);
                node.operator = token();
                nextToken();
                node.operand = parseLeftHandSideExpressionOrHigher();
                return finishNode(node);
            }
            else if (sourceFile.languageVariant === 1 /* JSX */ && token() === 26 /* LessThanToken */ && lookAhead(nextTokenIsIdentifierOrKeyword)) {
                // JSXElement is part of primaryExpression
                return parseJsxElementOrSelfClosingElement(/*inExpressionContext*/ true);
            }
            var expression = parseLeftHandSideExpressionOrHigher();
            ts.Debug.assert(ts.isLeftHandSideExpression(expression));
            if ((token() === 42 /* PlusPlusToken */ || token() === 43 /* MinusMinusToken */) && !scanner.hasPrecedingLineBreak()) {
                var node = createNode(191 /* PostfixUnaryExpression */, expression.pos);
                node.operand = expression;
                node.operator = token();
                nextToken();
                return finishNode(node);
            }
            return expression;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{143,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{143,1} AS 1 AT <0:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{143,2} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{143,2} AS 2 AT <0:59>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{143,3} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{143,3} AS 3 AT <0:834>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{143,4} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{143,4} AS 4 AT <0:872>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseSimpleUnaryExpression) id{144,0} ---
() {
            switch (token()) {
                case 36 /* PlusToken */:
                case 37 /* MinusToken */:
                case 51 /* TildeToken */:
                case 50 /* ExclamationToken */:
                    return parsePrefixUnaryExpression();
                case 79 /* DeleteKeyword */:
                    return parseDeleteExpression();
                case 102 /* TypeOfKeyword */:
                    return parseTypeOfExpression();
                case 104 /* VoidKeyword */:
                    return parseVoidExpression();
                case 26 /* LessThanToken */:
                    // This is modified UnaryExpression grammar in TypeScript
                    //  UnaryExpression (modified):
                    //      < type > UnaryExpression
                    return parseTypeAssertion();
                case 120 /* AwaitKeyword */:
                    if (isAwaitExpression()) {
                        return parseAwaitExpression();
                    }
                default:
                    return parseIncrementExpression();
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{144,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{144,1} AS 1 AT <0:25>
[deoptimizing (DEOPT soft): begin 0xd6230db08e1 <JS Function isListTerminator (SharedFunctionInfo 0x3504a53f4271)> (opt #91) @27, FP to SP delta: 32, caller sp: 0x7fff5fbfd4b0]
            ;;; deoptimize at 0_959: Insufficient type feedback for combined type of binary operation
  reading input frame isListTerminator => node=217, args=2, height=3; inputs:
      0: 0xd6230db08e1 ; [fp - 16] 0xd6230db08e1 <JS Function isListTerminator (SharedFunctionInfo 0x3504a53f4271)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x700000000 ; [fp + 16] 7
      3: 0xd6230d980d1 ; [fp - 24] 0xd6230d980d1 <FixedArray[334]>
      4: 0x30bcea4069a9 ; (literal 4) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      5: 0x6b00000000 ; rax 107
  translating frame isListTerminator => node=217, height=16
    0x7fff5fbfd4a8: [top + 56] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd4a0: [top + 48] <- 0x700000000 ;  7  (input #2)
    0x7fff5fbfd498: [top + 40] <- 0x2c21d24be8a4 ;  caller's pc
    0x7fff5fbfd490: [top + 32] <- 0x7fff5fbfd528 ;  caller's fp
    0x7fff5fbfd488: [top + 24] <- 0xd6230d980d1 ;  context    0xd6230d980d1 <FixedArray[334]>  (input #3)
    0x7fff5fbfd480: [top + 16] <- 0xd6230db08e1 ;  function    0xd6230db08e1 <JS Function isListTerminator (SharedFunctionInfo 0x3504a53f4271)>  (input #0)
    0x7fff5fbfd478: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #4)
    0x7fff5fbfd470: [top + 0] <- 0x6b00000000 ;  107  (input #5)
[deoptimizing (soft): end 0xd6230db08e1 <JS Function isListTerminator (SharedFunctionInfo 0x3504a53f4271)> @27 => node=217, pc=0x2c21d2412a19, caller sp=0x7fff5fbfd4b0, state=NO_REGISTERS, took 0.051 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isKeyword) id{145,0} ---
(token) {
        return 71 /* FirstKeyword */ <= token && token <= 140 /* LastKeyword */;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:tryParseAccessorDeclaration) id{146,0} ---
(fullStart, decorators, modifiers) {
            if (parseContextualModifier(124 /* GetKeyword */)) {
                return parseAccessorDeclaration(151 /* GetAccessor */, fullStart, decorators, modifiers);
            }
            else if (parseContextualModifier(133 /* SetKeyword */)) {
                return parseAccessorDeclaration(152 /* SetAccessor */, fullStart, decorators, modifiers);
            }
            return undefined;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseContextualModifier) id{146,1} ---
(t) {
            return token() === t && tryParse(nextTokenCanFollowModifier);
        }
--- END ---
INLINE (parseContextualModifier) id{146,1} AS 1 AT <0:53>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{146,2} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{146,2} AS 2 AT <1:25>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseContextualModifier) id{146,3} ---
(t) {
            return token() === t && tryParse(nextTokenCanFollowModifier);
        }
--- END ---
INLINE (parseContextualModifier) id{146,3} AS 3 AT <0:243>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{146,4} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{146,4} AS 4 AT <3:25>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parsePropertyOrMethodDeclaration) id{147,0} ---
(fullStart, decorators, modifiers) {
            var asteriskToken = parseOptionalToken(38 /* AsteriskToken */);
            var name = parsePropertyName();
            // Note: this is not legal as per the grammar.  But we allow it in the parser and
            // report an error in the grammar checker.
            var questionToken = parseOptionalToken(54 /* QuestionToken */);
            if (asteriskToken || token() === 18 /* OpenParenToken */ || token() === 26 /* LessThanToken */) {
                return parseMethodDeclaration(fullStart, decorators, modifiers, asteriskToken, name, questionToken, ts.Diagnostics.or_expected);
            }
            else {
                return parsePropertyDeclaration(fullStart, decorators, modifiers, name, questionToken);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseOptionalToken) id{147,1} ---
(t) {
            if (token() === t) {
                return parseTokenNode();
            }
            return undefined;
        }
--- END ---
INLINE (parseOptionalToken) id{147,1} AS 1 AT <0:69>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{147,2} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{147,2} AS 2 AT <1:22>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseTokenNode) id{147,3} ---
() {
            var node = createNode(token());
            nextToken();
            return finishNode(node);
        }
--- END ---
INLINE (parseTokenNode) id{147,3} AS 3 AT <1:62>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{147,4} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{147,4} AS 4 AT <3:39>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{147,5} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{147,5} AS 5 AT <3:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{147,6} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{147,6} AS 6 AT <5:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{147,7} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{147,7} AS 7 AT <5:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{147,8} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{147,8} AS 8 AT <5:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{147,9} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{147,9} AS 9 AT <3:61>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parsePropertyName) id{147,10} ---
() {
            return parsePropertyNameWorker(/*allowComputedPropertyNames*/ true);
        }
--- END ---
INLINE (parsePropertyName) id{147,10} AS 10 AT <0:136>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parsePropertyNameWorker) id{147,11} ---
(allowComputedPropertyNames) {
            if (token() === 9 /* StringLiteral */ || token() === 8 /* NumericLiteral */) {
                return parseLiteralNode(/*internName*/ true);
            }
            if (allowComputedPropertyNames && token() === 20 /* OpenBracketToken */) {
                return parseComputedPropertyName();
            }
            return parseIdentifierName();
        }
--- END ---
INLINE (parsePropertyNameWorker) id{147,11} AS 11 AT <10:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{147,12} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{147,12} AS 12 AT <11:47>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{147,13} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{147,13} AS 13 AT <11:84>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{147,14} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{147,14} AS 14 AT <11:244>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseIdentifierName) id{147,15} ---
() {
            return createIdentifier(ts.tokenIsIdentifierOrKeyword(token()));
        }
--- END ---
INLINE (parseIdentifierName) id{147,15} AS 15 AT <11:370>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{147,16} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{147,16} AS 16 AT <15:71>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseOptionalToken) id{147,17} ---
(t) {
            if (token() === t) {
                return parseTokenNode();
            }
            return undefined;
        }
--- END ---
INLINE (parseOptionalToken) id{147,17} AS 17 AT <0:338>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{147,18} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{147,18} AS 18 AT <17:22>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseTokenNode) id{147,19} ---
() {
            var node = createNode(token());
            nextToken();
            return finishNode(node);
        }
--- END ---
INLINE (parseTokenNode) id{147,19} AS 19 AT <17:62>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{147,20} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{147,20} AS 20 AT <19:39>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{147,21} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{147,21} AS 21 AT <19:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{147,22} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{147,22} AS 22 AT <21:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{147,23} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{147,23} AS 23 AT <21:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{147,24} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{147,24} AS 24 AT <21:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{147,25} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{147,25} AS 25 AT <19:61>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{147,26} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{147,26} AS 26 AT <0:415>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{147,27} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{147,27} AS 27 AT <0:454>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseMethodDeclaration) id{148,0} ---
(fullStart, decorators, modifiers, asteriskToken, name, questionToken, diagnosticMessage) {
            var method = createNode(149 /* MethodDeclaration */, fullStart);
            method.decorators = decorators;
            method.modifiers = modifiers;
            method.asteriskToken = asteriskToken;
            method.name = name;
            method.questionToken = questionToken;
            var isGenerator = !!asteriskToken;
            var isAsync = ts.hasModifier(method, 256 /* Async */);
            fillSignature(55 /* ColonToken */, /*yieldContext*/ isGenerator, /*awaitContext*/ isAsync, /*requireCompleteParameterList*/ false, method);
            method.body = parseFunctionBlockOrSemicolon(isGenerator, isAsync, diagnosticMessage);
            return addJSDocComment(finishNode(method));
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{148,1} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{148,1} AS 1 AT <0:117>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{148,2} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{148,2} AS 2 AT <1:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{148,3} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{148,3} AS 3 AT <1:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{148,4} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{148,4} AS 4 AT <1:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseFunctionBlockOrSemicolon) id{148,5} ---
(isGenerator, isAsync, diagnosticMessage) {
            if (token() !== 16 /* OpenBraceToken */ && canParseSemicolon()) {
                parseSemicolon();
                return;
            }
            return parseFunctionBlock(isGenerator, isAsync, /*ignoreMissingOpenBrace*/ false, diagnosticMessage);
        }
--- END ---
INLINE (parseFunctionBlockOrSemicolon) id{148,5} AS 5 AT <0:679>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{148,6} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{148,6} AS 6 AT <5:60>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:canParseSemicolon) id{148,7} ---
() {
            // If there's a real semicolon, then we can always parse it out.
            if (token() === 24 /* SemicolonToken */) {
                return true;
            }
            // We can parse out an optional semicolon in ASI cases in the following cases.
            return token() === 17 /* CloseBraceToken */ || token() === 1 /* EndOfFileToken */ || scanner.hasPrecedingLineBreak();
        }
--- END ---
INLINE (canParseSemicolon) id{148,7} AS 7 AT <5:99>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{148,8} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{148,8} AS 8 AT <7:98>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{148,9} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{148,9} AS 9 AT <7:290>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{148,10} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{148,10} AS 10 AT <7:330>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseSemicolon) id{148,11} ---
() {
            if (canParseSemicolon()) {
                if (token() === 24 /* SemicolonToken */) {
                    // consume the semicolon if it was explicitly provided.
                    nextToken();
                }
                return true;
            }
            else {
                return parseExpected(24 /* SemicolonToken */);
            }
        }
--- END ---
INLINE (parseSemicolon) id{148,11} AS 11 AT <5:138>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:canParseSemicolon) id{148,12} ---
() {
            // If there's a real semicolon, then we can always parse it out.
            if (token() === 24 /* SemicolonToken */) {
                return true;
            }
            // We can parse out an optional semicolon in ASI cases in the following cases.
            return token() === 17 /* CloseBraceToken */ || token() === 1 /* EndOfFileToken */ || scanner.hasPrecedingLineBreak();
        }
--- END ---
INLINE (canParseSemicolon) id{148,12} AS 12 AT <11:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{148,13} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{148,13} AS 13 AT <12:98>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{148,14} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{148,14} AS 14 AT <12:290>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{148,15} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{148,15} AS 15 AT <12:330>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{148,16} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{148,16} AS 16 AT <11:64>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{148,17} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{148,17} AS 17 AT <11:199>
[deoptimizing (DEOPT eager): begin 0xd6230d98c71 <JS Function parseArrayTypeOrHigher (SharedFunctionInfo 0x3504a53f7271)> (opt #117) @17, FP to SP delta: 88, caller sp: 0x7fff5fbfcc80]
            ;;; deoptimize at 0_579: wrong map
  reading input frame parseArrayTypeOrHigher => node=77, args=1, height=3; inputs:
      0: 0xd6230d98c71 ; [fp - 16] 0xd6230d98c71 <JS Function parseArrayTypeOrHigher (SharedFunctionInfo 0x3504a53f7271)>
      1: 0x1f9f6c0532e1 ; [fp + 16] 0x1f9f6c0532e1 <JS Global Object>
      2: 0xd6230d980d1 ; rbx 0xd6230d980d1 <FixedArray[334]>
      3: 0x133f51067c41 ; rdi 0x133f51067c41 <a NodeObject with map 0x33abe2a67621>
      4: 0x30bcea404311 ; (literal 15) 0x30bcea404311 <undefined>
  translating frame parseArrayTypeOrHigher => node=77, height=16
    0x7fff5fbfcc78: [top + 48] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfcc70: [top + 40] <- 0x2c21d2460ae8 ;  caller's pc
    0x7fff5fbfcc68: [top + 32] <- 0x7fff5fbfcc98 ;  caller's fp
    0x7fff5fbfcc60: [top + 24] <- 0xd6230d980d1 ;  context    0xd6230d980d1 <FixedArray[334]>  (input #2)
    0x7fff5fbfcc58: [top + 16] <- 0xd6230d98c71 ;  function    0xd6230d98c71 <JS Function parseArrayTypeOrHigher (SharedFunctionInfo 0x3504a53f7271)>  (input #0)
    0x7fff5fbfcc50: [top + 8] <- 0x133f51067c41 ;  0x133f51067c41 <a NodeObject with map 0x33abe2a67621>  (input #3)
    0x7fff5fbfcc48: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
[deoptimizing (eager): end 0xd6230d98c71 <JS Function parseArrayTypeOrHigher (SharedFunctionInfo 0x3504a53f7271)> @17 => node=77, pc=0x2c21d2420b8c, caller sp=0x7fff5fbfcc80, state=NO_REGISTERS, took 0.059 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isListTerminator) id{149,0} ---
(kind) {
            if (token() === 1 /* EndOfFileToken */) {
                // Being at the end of the file ends all lists.
                return true;
            }
            switch (kind) {
                case 1 /* BlockStatements */:
                case 2 /* SwitchClauses */:
                case 4 /* TypeMembers */:
                case 5 /* ClassMembers */:
                case 6 /* EnumMembers */:
                case 12 /* ObjectLiteralMembers */:
                case 9 /* ObjectBindingElements */:
                case 22 /* ImportOrExportSpecifiers */:
                    return token() === 17 /* CloseBraceToken */;
                case 3 /* SwitchClauseStatements */:
                    return token() === 17 /* CloseBraceToken */ || token() === 72 /* CaseKeyword */ || token() === 78 /* DefaultKeyword */;
                case 7 /* HeritageClauseElement */:
                    return token() === 16 /* OpenBraceToken */ || token() === 84 /* ExtendsKeyword */ || token() === 107 /* ImplementsKeyword */;
                case 8 /* VariableDeclarations */:
                    return isVariableDeclaratorListTerminator();
                case 18 /* TypeParameters */:
                    // Tokens other than '>' are here for better error recovery
                    return token() === 28 /* GreaterThanToken */ || token() === 18 /* OpenParenToken */ || token() === 16 /* OpenBraceToken */ || token() === 84 /* ExtendsKeyword */ || token() === 107 /* ImplementsKeyword */;
                case 11 /* ArgumentExpressions */:
                    // Tokens other than ')' are here for better error recovery
                    return token() === 19 /* CloseParenToken */ || token() === 24 /* SemicolonToken */;
                case 15 /* ArrayLiteralMembers */:
                case 20 /* TupleElementTypes */:
                case 10 /* ArrayBindingElements */:
                    return token() === 21 /* CloseBracketToken */;
                case 16 /* Parameters */:
                case 17 /* RestProperties */:
                    // Tokens other than ')' and ']' (the latter for index signatures) are here for better error recovery
                    return token() === 19 /* CloseParenToken */ || token() === 21 /* CloseBracketToken */ /*|| token === SyntaxKind.OpenBraceToken*/;
                case 19 /* TypeArguments */:
                    // All other tokens should cause the type-argument to terminate except comma token
                    return token() !== 25 /* CommaToken */;
                case 21 /* HeritageClauses */:
                    return token() === 16 /* OpenBraceToken */ || token() === 17 /* CloseBraceToken */;
                case 13 /* JsxAttributes */:
                    return token() === 28 /* GreaterThanToken */ || token() === 40 /* SlashToken */;
                case 14 /* JsxChildren */:
                    return token() === 26 /* LessThanToken */ && lookAhead(nextTokenIsSlash);
                case 23 /* JSDocFunctionParameters */:
                    return token() === 19 /* CloseParenToken */ || token() === 55 /* ColonToken */ || token() === 17 /* CloseBraceToken */;
                case 24 /* JSDocTypeArguments */:
                    return token() === 28 /* GreaterThanToken */ || token() === 17 /* CloseBraceToken */;
                case 26 /* JSDocTupleTypes */:
                    return token() === 21 /* CloseBracketToken */ || token() === 17 /* CloseBraceToken */;
                case 25 /* JSDocRecordMembers */:
                    return token() === 17 /* CloseBraceToken */;
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{149,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{149,1} AS 1 AT <0:25>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{149,2} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{149,2} AS 2 AT <0:602>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{149,3} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{149,3} AS 3 AT <0:912>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{149,4} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{149,4} AS 4 AT <0:951>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{149,5} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{149,5} AS 5 AT <0:990>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{149,6} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{149,6} AS 6 AT <0:1300>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{149,7} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{149,7} AS 7 AT <0:1913>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{149,8} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{149,8} AS 8 AT <0:2190>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{149,9} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{149,9} AS 9 AT <0:2230>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{149,10} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{149,10} AS 10 AT <0:2488>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{149,11} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{149,11} AS 11 AT <0:2595>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{149,12} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{149,12} AS 12 AT <0:2634>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:modifierToFlag) id{150,0} ---
(token) {
        switch (token) {
            case 114 /* StaticKeyword */: return 32 /* Static */;
            case 113 /* PublicKeyword */: return 4 /* Public */;
            case 112 /* ProtectedKeyword */: return 16 /* Protected */;
            case 111 /* PrivateKeyword */: return 8 /* Private */;
            case 116 /* AbstractKeyword */: return 128 /* Abstract */;
            case 83 /* ExportKeyword */: return 1 /* Export */;
            case 123 /* DeclareKeyword */: return 2 /* Ambient */;
            case 75 /* ConstKeyword */: return 2048 /* Const */;
            case 78 /* DefaultKeyword */: return 512 /* Default */;
            case 119 /* AsyncKeyword */: return 256 /* Async */;
            case 130 /* ReadonlyKeyword */: return 64 /* Readonly */;
        }
        return 0 /* None */;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseFunctionDeclaration) id{151,0} ---
(fullStart, decorators, modifiers) {
            var node = createNode(225 /* FunctionDeclaration */, fullStart);
            node.decorators = decorators;
            node.modifiers = modifiers;
            parseExpected(88 /* FunctionKeyword */);
            node.asteriskToken = parseOptionalToken(38 /* AsteriskToken */);
            node.name = ts.hasModifier(node, 512 /* Default */) ? parseOptionalIdentifier() : parseIdentifier();
            var isGenerator = !!node.asteriskToken;
            var isAsync = ts.hasModifier(node, 256 /* Async */);
            fillSignature(55 /* ColonToken */, /*yieldContext*/ isGenerator, /*awaitContext*/ isAsync, /*requireCompleteParameterList*/ false, node);
            node.body = parseFunctionBlockOrSemicolon(isGenerator, isAsync, ts.Diagnostics.or_expected);
            return addJSDocComment(finishNode(node));
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{151,1} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{151,1} AS 1 AT <0:60>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{151,2} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{151,2} AS 2 AT <1:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{151,3} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{151,3} AS 3 AT <1:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{151,4} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{151,4} AS 4 AT <1:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseOptionalToken) id{151,5} ---
(t) {
            if (token() === t) {
                return parseTokenNode();
            }
            return undefined;
        }
--- END ---
INLINE (parseOptionalToken) id{151,5} AS 5 AT <0:282>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{151,6} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{151,6} AS 6 AT <5:22>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseTokenNode) id{151,7} ---
() {
            var node = createNode(token());
            nextToken();
            return finishNode(node);
        }
--- END ---
INLINE (parseTokenNode) id{151,7} AS 7 AT <5:62>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{151,8} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{151,8} AS 8 AT <7:39>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{151,9} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{151,9} AS 9 AT <7:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{151,10} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{151,10} AS 10 AT <9:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{151,11} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{151,11} AS 11 AT <9:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{151,12} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{151,12} AS 12 AT <9:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{151,13} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{151,13} AS 13 AT <7:61>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseIdentifier) id{151,14} ---
(diagnosticMessage) {
            return createIdentifier(isIdentifier(), diagnosticMessage);
        }
--- END ---
INLINE (parseIdentifier) id{151,14} AS 14 AT <0:420>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseFunctionBlockOrSemicolon) id{151,15} ---
(isGenerator, isAsync, diagnosticMessage) {
            if (token() !== 16 /* OpenBraceToken */ && canParseSemicolon()) {
                parseSemicolon();
                return;
            }
            return parseFunctionBlock(isGenerator, isAsync, /*ignoreMissingOpenBrace*/ false, diagnosticMessage);
        }
--- END ---
INLINE (parseFunctionBlockOrSemicolon) id{151,15} AS 15 AT <0:730>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{151,16} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{151,16} AS 16 AT <15:60>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:canParseSemicolon) id{151,17} ---
() {
            // If there's a real semicolon, then we can always parse it out.
            if (token() === 24 /* SemicolonToken */) {
                return true;
            }
            // We can parse out an optional semicolon in ASI cases in the following cases.
            return token() === 17 /* CloseBraceToken */ || token() === 1 /* EndOfFileToken */ || scanner.hasPrecedingLineBreak();
        }
--- END ---
INLINE (canParseSemicolon) id{151,17} AS 17 AT <15:99>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{151,18} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{151,18} AS 18 AT <17:98>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{151,19} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{151,19} AS 19 AT <17:290>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{151,20} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{151,20} AS 20 AT <17:330>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseSemicolon) id{151,21} ---
() {
            if (canParseSemicolon()) {
                if (token() === 24 /* SemicolonToken */) {
                    // consume the semicolon if it was explicitly provided.
                    nextToken();
                }
                return true;
            }
            else {
                return parseExpected(24 /* SemicolonToken */);
            }
        }
--- END ---
INLINE (parseSemicolon) id{151,21} AS 21 AT <15:138>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:canParseSemicolon) id{151,22} ---
() {
            // If there's a real semicolon, then we can always parse it out.
            if (token() === 24 /* SemicolonToken */) {
                return true;
            }
            // We can parse out an optional semicolon in ASI cases in the following cases.
            return token() === 17 /* CloseBraceToken */ || token() === 1 /* EndOfFileToken */ || scanner.hasPrecedingLineBreak();
        }
--- END ---
INLINE (canParseSemicolon) id{151,22} AS 22 AT <21:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{151,23} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{151,23} AS 23 AT <22:98>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{151,24} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{151,24} AS 24 AT <22:290>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{151,25} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{151,25} AS 25 AT <22:330>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{151,26} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{151,26} AS 26 AT <21:64>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{151,27} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{151,27} AS 27 AT <21:199>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextTokenCanFollowModifier) id{152,0} ---
() {
            if (token() === 75 /* ConstKeyword */) {
                // 'const' is only a modifier if followed by 'enum'.
                return nextToken() === 82 /* EnumKeyword */;
            }
            if (token() === 83 /* ExportKeyword */) {
                nextToken();
                if (token() === 78 /* DefaultKeyword */) {
                    return lookAhead(nextTokenIsClassOrFunctionOrAsync);
                }
                return token() !== 38 /* AsteriskToken */ && token() !== 117 /* AsKeyword */ && token() !== 16 /* OpenBraceToken */ && canFollowModifier();
            }
            if (token() === 78 /* DefaultKeyword */) {
                return nextTokenIsClassOrFunctionOrAsync();
            }
            if (token() === 114 /* StaticKeyword */) {
                nextToken();
                return canFollowModifier();
            }
            return nextTokenIsOnSameLineAndCanFollowModifier();
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{152,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{152,1} AS 1 AT <0:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{152,2} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{152,2} AS 2 AT <0:150>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{152,3} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{152,3} AS 3 AT <0:218>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{152,4} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{152,4} AS 4 AT <0:272>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{152,5} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{152,5} AS 5 AT <0:305>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{152,6} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{152,6} AS 6 AT <0:458>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{152,7} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{152,7} AS 7 AT <0:496>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{152,8} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{152,8} AS 8 AT <0:531>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:canFollowModifier) id{152,9} ---
() {
            return token() === 20 /* OpenBracketToken */
                || token() === 16 /* OpenBraceToken */
                || token() === 38 /* AsteriskToken */
                || token() === 23 /* DotDotDotToken */
                || isLiteralPropertyName();
        }
--- END ---
INLINE (canFollowModifier) id{152,9} AS 9 AT <0:570>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{152,10} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{152,10} AS 10 AT <9:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{152,11} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{152,11} AS 11 AT <9:81>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{152,12} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{152,12} AS 12 AT <9:136>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{152,13} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{152,13} AS 13 AT <9:190>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isLiteralPropertyName) id{152,14} ---
() {
            return ts.tokenIsIdentifierOrKeyword(token()) ||
                token() === 9 /* StringLiteral */ ||
                token() === 8 /* NumericLiteral */;
        }
--- END ---
INLINE (isLiteralPropertyName) id{152,14} AS 14 AT <9:245>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{152,15} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{152,15} AS 15 AT <14:54>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{152,16} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{152,16} AS 16 AT <14:82>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{152,17} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{152,17} AS 17 AT <14:135>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{152,18} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{152,18} AS 18 AT <0:621>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{152,19} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{152,19} AS 19 AT <0:750>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{152,20} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{152,20} AS 20 AT <0:805>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:canFollowModifier) id{152,21} ---
() {
            return token() === 20 /* OpenBracketToken */
                || token() === 16 /* OpenBraceToken */
                || token() === 38 /* AsteriskToken */
                || token() === 23 /* DotDotDotToken */
                || isLiteralPropertyName();
        }
--- END ---
INLINE (canFollowModifier) id{152,21} AS 21 AT <0:841>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{152,22} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{152,22} AS 22 AT <21:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{152,23} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{152,23} AS 23 AT <21:81>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{152,24} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{152,24} AS 24 AT <21:136>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{152,25} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{152,25} AS 25 AT <21:190>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isLiteralPropertyName) id{152,26} ---
() {
            return ts.tokenIsIdentifierOrKeyword(token()) ||
                token() === 9 /* StringLiteral */ ||
                token() === 8 /* NumericLiteral */;
        }
--- END ---
INLINE (isLiteralPropertyName) id{152,26} AS 26 AT <21:245>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{152,27} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{152,27} AS 27 AT <26:54>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{152,28} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{152,28} AS 28 AT <26:82>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{152,29} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{152,29} AS 29 AT <26:135>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextTokenIsOnSameLineAndCanFollowModifier) id{152,30} ---
() {
            nextToken();
            if (scanner.hasPrecedingLineBreak()) {
                return false;
            }
            return canFollowModifier();
        }
--- END ---
INLINE (nextTokenIsOnSameLineAndCanFollowModifier) id{152,30} AS 30 AT <0:895>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{152,31} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{152,31} AS 31 AT <30:17>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:canFollowModifier) id{152,32} ---
() {
            return token() === 20 /* OpenBracketToken */
                || token() === 16 /* OpenBraceToken */
                || token() === 38 /* AsteriskToken */
                || token() === 23 /* DotDotDotToken */
                || isLiteralPropertyName();
        }
--- END ---
INLINE (canFollowModifier) id{152,32} AS 32 AT <30:144>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{152,33} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{152,33} AS 33 AT <32:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{152,34} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{152,34} AS 34 AT <32:81>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{152,35} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{152,35} AS 35 AT <32:136>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{152,36} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{152,36} AS 36 AT <32:190>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isLiteralPropertyName) id{152,37} ---
() {
            return ts.tokenIsIdentifierOrKeyword(token()) ||
                token() === 9 /* StringLiteral */ ||
                token() === 8 /* NumericLiteral */;
        }
--- END ---
INLINE (isLiteralPropertyName) id{152,37} AS 37 AT <32:245>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{152,38} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{152,38} AS 38 AT <37:54>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{152,39} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{152,39} AS 39 AT <37:82>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{152,40} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{152,40} AS 40 AT <37:135>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:currentNode) id{153,0} ---
(parsingContext) {
            // If there is an outstanding parse error that we've encountered, but not attached to
            // some node, then we cannot get a node from the old source tree.  This is because we
            // want to mark the next node we encounter as being unusable.
            //
            // Note: This may be too conservative.  Perhaps we could reuse the node and set the bit
            // on it (or its leftmost child) as having the error.  For now though, being conservative
            // is nice and likely won't ever affect perf.
            if (parseErrorBeforeNextFinishedNode) {
                return undefined;
            }
            if (!syntaxCursor) {
                // if we don't have a cursor, we could never return a node from the old tree.
                return undefined;
            }
            var node = syntaxCursor.currentNode(scanner.getStartPos());
            // Can't reuse a missing node.
            if (ts.nodeIsMissing(node)) {
                return undefined;
            }
            // Can't reuse a node that intersected the change range.
            if (node.intersectsChange) {
                return undefined;
            }
            // Can't reuse a node that contains a parse error.  This is necessary so that we
            // produce the same set of errors again.
            if (ts.containsParseError(node)) {
                return undefined;
            }
            // We can only reuse a node if it was parsed under the same strict mode that we're
            // currently in.  i.e. if we originally parsed a node in non-strict mode, but then
            // the user added 'using strict' at the top of the file, then we can't use that node
            // again as the presence of strict mode may cause us to parse the tokens in the file
            // differently.
            //
            // Note: we *can* reuse tokens when the strict mode changes.  That's because tokens
            // are unaffected by strict mode.  It's just the parser will decide what to do with it
            // differently depending on what mode it is in.
            //
            // This also applies to all our other context flags as well.
            var nodeContextFlags = node.flags & 96256 /* ContextFlags */;
            if (nodeContextFlags !== contextFlags) {
                return undefined;
            }
            // Ok, we have a node that looks like it could be reused.  Now verify that it is valid
            // in the current list parsing context that we're currently at.
            if (!canReuseNode(node, parsingContext)) {
                return undefined;
            }
            return node;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseVariableDeclarationList) id{154,0} ---
(inForStatementInitializer) {
            var node = createNode(224 /* VariableDeclarationList */);
            switch (token()) {
                case 103 /* VarKeyword */:
                    break;
                case 109 /* LetKeyword */:
                    node.flags |= 1 /* Let */;
                    break;
                case 75 /* ConstKeyword */:
                    node.flags |= 2 /* Const */;
                    break;
                default:
                    ts.Debug.fail();
            }
            nextToken();
            // The user may have written the following:
            //
            //    for (let of X) { }
            //
            // In this case, we want to parse an empty declaration list, and then parse 'of'
            // as a keyword. The reason this is not automatic is that 'of' is a valid identifier.
            // So we need to look ahead to determine if 'of' should be treated as a keyword in
            // this context.
            // The checker will then give an error that there is an empty declaration list.
            if (token() === 140 /* OfKeyword */ && lookAhead(canFollowContextualOfKeyword)) {
                node.declarations = createMissingList();
            }
            else {
                var savedDisallowIn = inDisallowInContext();
                setDisallowInContext(inForStatementInitializer);
                node.declarations = parseDelimitedList(8 /* VariableDeclarations */, parseVariableDeclaration);
                setDisallowInContext(savedDisallowIn);
            }
            return finishNode(node);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{154,1} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{154,1} AS 1 AT <0:53>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{154,2} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{154,2} AS 2 AT <1:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{154,3} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{154,3} AS 3 AT <1:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{154,4} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{154,4} AS 4 AT <1:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{154,5} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{154,5} AS 5 AT <0:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{154,6} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{154,6} AS 6 AT <0:526>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{154,7} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{154,7} AS 7 AT <0:1085>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:inDisallowInContext) id{154,8} ---
() {
            return inContext(2048 /* DisallowInContext */);
        }
--- END ---
INLINE (inDisallowInContext) id{154,8} AS 8 AT <0:1291>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:inContext) id{154,9} ---
(flags) {
            return (contextFlags & flags) !== 0;
        }
--- END ---
INLINE (inContext) id{154,9} AS 9 AT <8:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:setDisallowInContext) id{154,10} ---
(val) {
            setContextFlag(val, 2048 /* DisallowInContext */);
        }
--- END ---
INLINE (setDisallowInContext) id{154,10} AS 10 AT <0:1330>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:setContextFlag) id{154,11} ---
(val, flag) {
            if (val) {
                contextFlags |= flag;
            }
            else {
                contextFlags &= ~flag;
            }
        }
--- END ---
INLINE (setContextFlag) id{154,11} AS 11 AT <10:20>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:setDisallowInContext) id{154,12} ---
(val) {
            setContextFlag(val, 2048 /* DisallowInContext */);
        }
--- END ---
INLINE (setDisallowInContext) id{154,12} AS 12 AT <0:1507>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:setContextFlag) id{154,13} ---
(val, flag) {
            if (val) {
                contextFlags |= flag;
            }
            else {
                contextFlags &= ~flag;
            }
        }
--- END ---
INLINE (setContextFlag) id{154,13} AS 13 AT <12:20>
[deoptimizing (DEOPT soft): begin 0xd6230db0971 <JS Function isListElement (SharedFunctionInfo 0x3504a53f3df1)> (opt #88) @50, FP to SP delta: 112, caller sp: 0x7fff5fbfd938]
            ;;; deoptimize at 0_2048: Insufficient type feedback for combined type of binary operation
  reading input frame isListElement => node=249, args=3, height=4; inputs:
      0: 0xd6230db0971 ; [fp - 16] 0xd6230db0971 <JS Function isListElement (SharedFunctionInfo 0x3504a53f3df1)>
      1: 0x1f9f6c0532e1 ; [fp + 32] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x600000000 ; [fp + 24] 6
      3: 0x30bcea404421 ; [fp + 16] 0x30bcea404421 <false>
      4: 0xd6230d980d1 ; [fp - 24] 0xd6230d980d1 <FixedArray[334]>
      5: 0x30bcea4069a9 ; (literal 14) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      6: 0x30bcea404311 ; [fp - 32] 0x30bcea404311 <undefined>
      7: 0x4600000000 ; rax 70
  translating frame isListElement => node=249, height=24
    0x7fff5fbfd930: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd928: [top + 64] <- 0x600000000 ;  6  (input #2)
    0x7fff5fbfd920: [top + 56] <- 0x30bcea404421 ;  0x30bcea404421 <false>  (input #3)
    0x7fff5fbfd918: [top + 48] <- 0x2c21d24be42c ;  caller's pc
    0x7fff5fbfd910: [top + 40] <- 0x7fff5fbfd9b0 ;  caller's fp
    0x7fff5fbfd908: [top + 32] <- 0xd6230d980d1 ;  context    0xd6230d980d1 <FixedArray[334]>  (input #4)
    0x7fff5fbfd900: [top + 24] <- 0xd6230db0971 ;  function    0xd6230db0971 <JS Function isListElement (SharedFunctionInfo 0x3504a53f3df1)>  (input #0)
    0x7fff5fbfd8f8: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #5)
    0x7fff5fbfd8f0: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfd8e8: [top + 0] <- 0x4600000000 ;  70  (input #7)
[deoptimizing (soft): end 0xd6230db0971 <JS Function isListElement (SharedFunctionInfo 0x3504a53f3df1)> @50 => node=249, pc=0x2c21d2413fea, caller sp=0x7fff5fbfd938, state=NO_REGISTERS, took 0.056 ms]
[deoptimizing (DEOPT soft): begin 0xd6230db05c9 <JS Function scan (SharedFunctionInfo 0x16f3adb53cc1)> (opt #138) @100, FP to SP delta: 128, caller sp: 0x7fff5fbfd770]
            ;;; deoptimize at 0_9037: Insufficient type feedback for LHS of binary operation
  reading input frame scan => node=249, args=1, height=8; inputs:
      0: 0xd6230db05c9 ; [fp - 16] 0xd6230db05c9 <JS Function scan (SharedFunctionInfo 0x16f3adb53cc1)>
      1: 0xd6230dd29d9 ; [fp + 16] 0xd6230dd29d9 <an Object with map 0x33abe2a503e9>
      2: 0xd6230dd5e59 ; rcx 0xd6230dd5e59 <FixedArray[39]>
      3: 0x30bcea4069a9 ; (literal 8) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      4: 48 ; (int) [fp - 32] 
      5: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
      6: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
      7: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
      9: 48 ; (int) [fp - 32] 
  translating frame scan => node=249, height=56
    0x7fff5fbfd768: [top + 88] <- 0xd6230dd29d9 ;  0xd6230dd29d9 <an Object with map 0x33abe2a503e9>  (input #1)
    0x7fff5fbfd760: [top + 80] <- 0x2c21d246f5b1 ;  caller's pc
    0x7fff5fbfd758: [top + 72] <- 0x7fff5fbfd798 ;  caller's fp
    0x7fff5fbfd750: [top + 64] <- 0xd6230dd5e59 ;  context    0xd6230dd5e59 <FixedArray[39]>  (input #2)
    0x7fff5fbfd748: [top + 56] <- 0xd6230db05c9 ;  function    0xd6230db05c9 <JS Function scan (SharedFunctionInfo 0x16f3adb53cc1)>  (input #0)
    0x7fff5fbfd740: [top + 48] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #3)
    0x7fff5fbfd738: [top + 40] <- 0x3000000000 ;  48  (input #4)
    0x7fff5fbfd730: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfd728: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfd720: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfd718: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfd710: [top + 0] <- 0x3000000000 ;  48  (input #9)
[deoptimizing (soft): end 0xd6230db05c9 <JS Function scan (SharedFunctionInfo 0x16f3adb53cc1)> @100 => node=249, pc=0x2c21d24064b1, caller sp=0x7fff5fbfd770, state=NO_REGISTERS, took 0.063 ms]
[deoptimizing (DEOPT soft): begin 0xd6230db2999 <JS Function parseLiteralLikeNode (SharedFunctionInfo 0x3504a53f56b1)> (opt #140) @57, FP to SP delta: 120, caller sp: 0x7fff5fbfd630]
            ;;; deoptimize at 0_1117: Insufficient type feedback for combined type of binary operation
  reading input frame parseLiteralLikeNode => node=245, args=3, height=5; inputs:
      0: 0xd6230db2999 ; [fp - 16] 0xd6230db2999 <JS Function parseLiteralLikeNode (SharedFunctionInfo 0x3504a53f56b1)>
      1: 0x1f9f6c0532e1 ; [fp + 32] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x800000000 ; [fp + 24] 8
      3: 0x30bcea404311 ; [fp + 16] 0x30bcea404311 <undefined>
      4: 0xd6230d980d1 ; [fp - 24] 0xd6230d980d1 <FixedArray[334]>
      5: 0x376e2da18391 ; [fp - 64] 0x376e2da18391 <a TokenObject with map 0x33abe2a67fc1>
      6: 0x30bcea4069a9 ; (literal 23) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x2d28100000000 ; [fp - 104] 184961
      8: 0x3000000000 ; rax 48
  translating frame parseLiteralLikeNode => node=245, height=32
    0x7fff5fbfd628: [top + 80] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd620: [top + 72] <- 0x800000000 ;  8  (input #2)
    0x7fff5fbfd618: [top + 64] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #3)
    0x7fff5fbfd610: [top + 56] <- 0x2c21d24b482f ;  caller's pc
    0x7fff5fbfd608: [top + 48] <- 0x7fff5fbfd660 ;  caller's fp
    0x7fff5fbfd600: [top + 40] <- 0xd6230d980d1 ;  context    0xd6230d980d1 <FixedArray[334]>  (input #4)
    0x7fff5fbfd5f8: [top + 32] <- 0xd6230db2999 ;  function    0xd6230db2999 <JS Function parseLiteralLikeNode (SharedFunctionInfo 0x3504a53f56b1)>  (input #0)
    0x7fff5fbfd5f0: [top + 24] <- 0x376e2da18391 ;  0x376e2da18391 <a TokenObject with map 0x33abe2a67fc1>  (input #5)
    0x7fff5fbfd5e8: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfd5e0: [top + 8] <- 0x2d28100000000 ;  184961  (input #7)
    0x7fff5fbfd5d8: [top + 0] <- 0x3000000000 ;  48  (input #8)
[deoptimizing (soft): end 0xd6230db2999 <JS Function parseLiteralLikeNode (SharedFunctionInfo 0x3504a53f56b1)> @57 => node=245, pc=0x2c21d244e463, caller sp=0x7fff5fbfd630, state=NO_REGISTERS, took 0.058 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:scan) id{155,0} ---
() {
            startPos = pos;
            hasExtendedUnicodeEscape = false;
            precedingLineBreak = false;
            tokenIsUnterminated = false;
            while (true) {
                tokenPos = pos;
                if (pos >= end) {
                    return token = 1 /* EndOfFileToken */;
                }
                var ch = text.charCodeAt(pos);
                // Special handling for shebang
                if (ch === 35 /* hash */ && pos === 0 && isShebangTrivia(text, pos)) {
                    pos = scanShebangTrivia(text, pos);
                    if (skipTrivia) {
                        continue;
                    }
                    else {
                        return token = 6 /* ShebangTrivia */;
                    }
                }
                switch (ch) {
                    case 10 /* lineFeed */:
                    case 13 /* carriageReturn */:
                        precedingLineBreak = true;
                        if (skipTrivia) {
                            pos++;
                            continue;
                        }
                        else {
                            if (ch === 13 /* carriageReturn */ && pos + 1 < end && text.charCodeAt(pos + 1) === 10 /* lineFeed */) {
                                // consume both CR and LF
                                pos += 2;
                            }
                            else {
                                pos++;
                            }
                            return token = 4 /* NewLineTrivia */;
                        }
                    case 9 /* tab */:
                    case 11 /* verticalTab */:
                    case 12 /* formFeed */:
                    case 32 /* space */:
                        if (skipTrivia) {
                            pos++;
                            continue;
                        }
                        else {
                            while (pos < end && isWhiteSpaceSingleLine(text.charCodeAt(pos))) {
                                pos++;
                            }
                            return token = 5 /* WhitespaceTrivia */;
                        }
                    case 33 /* exclamation */:
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            if (text.charCodeAt(pos + 2) === 61 /* equals */) {
                                return pos += 3, token = 34 /* ExclamationEqualsEqualsToken */;
                            }
                            return pos += 2, token = 32 /* ExclamationEqualsToken */;
                        }
                        pos++;
                        return token = 50 /* ExclamationToken */;
                    case 34 /* doubleQuote */:
                    case 39 /* singleQuote */:
                        tokenValue = scanString();
                        return token = 9 /* StringLiteral */;
                    case 96 /* backtick */:
                        return token = scanTemplateAndSetTokenValue();
                    case 37 /* percent */:
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 63 /* PercentEqualsToken */;
                        }
                        pos++;
                        return token = 41 /* PercentToken */;
                    case 38 /* ampersand */:
                        if (text.charCodeAt(pos + 1) === 38 /* ampersand */) {
                            return pos += 2, token = 52 /* AmpersandAmpersandToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 67 /* AmpersandEqualsToken */;
                        }
                        pos++;
                        return token = 47 /* AmpersandToken */;
                    case 40 /* openParen */:
                        pos++;
                        return token = 18 /* OpenParenToken */;
                    case 41 /* closeParen */:
                        pos++;
                        return token = 19 /* CloseParenToken */;
                    case 42 /* asterisk */:
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 60 /* AsteriskEqualsToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 42 /* asterisk */) {
                            if (text.charCodeAt(pos + 2) === 61 /* equals */) {
                                return pos += 3, token = 61 /* AsteriskAsteriskEqualsToken */;
                            }
                            return pos += 2, token = 39 /* AsteriskAsteriskToken */;
                        }
                        pos++;
                        return token = 38 /* AsteriskToken */;
                    case 43 /* plus */:
                        if (text.charCodeAt(pos + 1) === 43 /* plus */) {
                            return pos += 2, token = 42 /* PlusPlusToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 58 /* PlusEqualsToken */;
                        }
                        pos++;
                        return token = 36 /* PlusToken */;
                    case 44 /* comma */:
                        pos++;
                        return token = 25 /* CommaToken */;
                    case 45 /* minus */:
                        if (text.charCodeAt(pos + 1) === 45 /* minus */) {
                            return pos += 2, token = 43 /* MinusMinusToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 59 /* MinusEqualsToken */;
                        }
                        pos++;
                        return token = 37 /* MinusToken */;
                    case 46 /* dot */:
                        if (isDigit(text.charCodeAt(pos + 1))) {
                            tokenValue = scanNumber();
                            return token = 8 /* NumericLiteral */;
                        }
                        if (text.charCodeAt(pos + 1) === 46 /* dot */ && text.charCodeAt(pos + 2) === 46 /* dot */) {
                            return pos += 3, token = 23 /* DotDotDotToken */;
                        }
                        pos++;
                        return token = 22 /* DotToken */;
                    case 47 /* slash */:
                        // Single-line comment
                        if (text.charCodeAt(pos + 1) === 47 /* slash */) {
                            pos += 2;
                            while (pos < end) {
                                if (isLineBreak(text.charCodeAt(pos))) {
                                    break;
                                }
                                pos++;
                            }
                            if (skipTrivia) {
                                continue;
                            }
                            else {
                                return token = 2 /* SingleLineCommentTrivia */;
                            }
                        }
                        // Multi-line comment
                        if (text.charCodeAt(pos + 1) === 42 /* asterisk */) {
                            pos += 2;
                            var commentClosed = false;
                            while (pos < end) {
                                var ch_2 = text.charCodeAt(pos);
                                if (ch_2 === 42 /* asterisk */ && text.charCodeAt(pos + 1) === 47 /* slash */) {
                                    pos += 2;
                                    commentClosed = true;
                                    break;
                                }
                                if (isLineBreak(ch_2)) {
                                    precedingLineBreak = true;
                                }
                                pos++;
                            }
                            if (!commentClosed) {
                                error(ts.Diagnostics.Asterisk_Slash_expected);
                            }
                            if (skipTrivia) {
                                continue;
                            }
                            else {
                                tokenIsUnterminated = !commentClosed;
                                return token = 3 /* MultiLineCommentTrivia */;
                            }
                        }
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 62 /* SlashEqualsToken */;
                        }
                        pos++;
                        return token = 40 /* SlashToken */;
                    case 48 /* _0 */:
                        if (pos + 2 < end && (text.charCodeAt(pos + 1) === 88 /* X */ || text.charCodeAt(pos + 1) === 120 /* x */)) {
                            pos += 2;
                            var value = scanMinimumNumberOfHexDigits(1);
                            if (value < 0) {
                                error(ts.Diagnostics.Hexadecimal_digit_expected);
                                value = 0;
                            }
                            tokenValue = "" + value;
                            return token = 8 /* NumericLiteral */;
                        }
                        else if (pos + 2 < end && (text.charCodeAt(pos + 1) === 66 /* B */ || text.charCodeAt(pos + 1) === 98 /* b */)) {
                            pos += 2;
                            var value = scanBinaryOrOctalDigits(/* base */ 2);
                            if (value < 0) {
                                error(ts.Diagnostics.Binary_digit_expected);
                                value = 0;
                            }
                            tokenValue = "" + value;
                            return token = 8 /* NumericLiteral */;
                        }
                        else if (pos + 2 < end && (text.charCodeAt(pos + 1) === 79 /* O */ || text.charCodeAt(pos + 1) === 111 /* o */)) {
                            pos += 2;
                            var value = scanBinaryOrOctalDigits(/* base */ 8);
                            if (value < 0) {
                                error(ts.Diagnostics.Octal_digit_expected);
                                value = 0;
                            }
                            tokenValue = "" + value;
                            return token = 8 /* NumericLiteral */;
                        }
                        // Try to parse as an octal
                        if (pos + 1 < end && isOctalDigit(text.charCodeAt(pos + 1))) {
                            tokenValue = "" + scanOctalDigits();
                            return token = 8 /* NumericLiteral */;
                        }
                    // This fall-through is a deviation from the EcmaScript grammar. The grammar says that a leading zero
                    // can only be followed by an octal digit, a dot, or the end of the number literal. However, we are being
                    // permissive and allowing decimal digits of the form 08* and 09* (which many browsers also do).
                    case 49 /* _1 */:
                    case 50 /* _2 */:
                    case 51 /* _3 */:
                    case 52 /* _4 */:
                    case 53 /* _5 */:
                    case 54 /* _6 */:
                    case 55 /* _7 */:
                    case 56 /* _8 */:
                    case 57 /* _9 */:
                        tokenValue = scanNumber();
                        return token = 8 /* NumericLiteral */;
                    case 58 /* colon */:
                        pos++;
                        return token = 55 /* ColonToken */;
                    case 59 /* semicolon */:
                        pos++;
                        return token = 24 /* SemicolonToken */;
                    case 60 /* lessThan */:
                        if (isConflictMarkerTrivia(text, pos)) {
                            pos = scanConflictMarkerTrivia(text, pos, error);
                            if (skipTrivia) {
                                continue;
                            }
                            else {
                                return token = 7 /* ConflictMarkerTrivia */;
                            }
                        }
                        if (text.charCodeAt(pos + 1) === 60 /* lessThan */) {
                            if (text.charCodeAt(pos + 2) === 61 /* equals */) {
                                return pos += 3, token = 64 /* LessThanLessThanEqualsToken */;
                            }
                            return pos += 2, token = 44 /* LessThanLessThanToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 29 /* LessThanEqualsToken */;
                        }
                        if (languageVariant === 1 /* JSX */ &&
                            text.charCodeAt(pos + 1) === 47 /* slash */ &&
                            text.charCodeAt(pos + 2) !== 42 /* asterisk */) {
                            return pos += 2, token = 27 /* LessThanSlashToken */;
                        }
                        pos++;
                        return token = 26 /* LessThanToken */;
                    case 61 /* equals */:
                        if (isConflictMarkerTrivia(text, pos)) {
                            pos = scanConflictMarkerTrivia(text, pos, error);
                            if (skipTrivia) {
                                continue;
                            }
                            else {
                                return token = 7 /* ConflictMarkerTrivia */;
                            }
                        }
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            if (text.charCodeAt(pos + 2) === 61 /* equals */) {
                                return pos += 3, token = 33 /* EqualsEqualsEqualsToken */;
                            }
                            return pos += 2, token = 31 /* EqualsEqualsToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 62 /* greaterThan */) {
                            return pos += 2, token = 35 /* EqualsGreaterThanToken */;
                        }
                        pos++;
                        return token = 57 /* EqualsToken */;
                    case 62 /* greaterThan */:
                        if (isConflictMarkerTrivia(text, pos)) {
                            pos = scanConflictMarkerTrivia(text, pos, error);
                            if (skipTrivia) {
                                continue;
                            }
                            else {
                                return token = 7 /* ConflictMarkerTrivia */;
                            }
                        }
                        pos++;
                        return token = 28 /* GreaterThanToken */;
                    case 63 /* question */:
                        pos++;
                        return token = 54 /* QuestionToken */;
                    case 91 /* openBracket */:
                        pos++;
                        return token = 20 /* OpenBracketToken */;
                    case 93 /* closeBracket */:
                        pos++;
                        return token = 21 /* CloseBracketToken */;
                    case 94 /* caret */:
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 69 /* CaretEqualsToken */;
                        }
                        pos++;
                        return token = 49 /* CaretToken */;
                    case 123 /* openBrace */:
                        pos++;
                        return token = 16 /* OpenBraceToken */;
                    case 124 /* bar */:
                        if (text.charCodeAt(pos + 1) === 124 /* bar */) {
                            return pos += 2, token = 53 /* BarBarToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos += 2, token = 68 /* BarEqualsToken */;
                        }
                        pos++;
                        return token = 48 /* BarToken */;
                    case 125 /* closeBrace */:
                        pos++;
                        return token = 17 /* CloseBraceToken */;
                    case 126 /* tilde */:
                        pos++;
                        return token = 51 /* TildeToken */;
                    case 64 /* at */:
                        pos++;
                        return token = 56 /* AtToken */;
                    case 92 /* backslash */:
                        var cookedChar = peekUnicodeEscape();
                        if (cookedChar >= 0 && isIdentifierStart(cookedChar, languageVersion)) {
                            pos += 6;
                            tokenValue = String.fromCharCode(cookedChar) + scanIdentifierParts();
                            return token = getIdentifierToken();
                        }
                        error(ts.Diagnostics.Invalid_character);
                        pos++;
                        return token = 0 /* Unknown */;
                    default:
                        if (isIdentifierStart(ch, languageVersion)) {
                            pos++;
                            while (pos < end && isIdentifierPart(ch = text.charCodeAt(pos), languageVersion))
                                pos++;
                            tokenValue = text.substring(tokenPos, pos);
                            if (ch === 92 /* backslash */) {
                                tokenValue += scanIdentifierParts();
                            }
                            return token = getIdentifierToken();
                        }
                        else if (isWhiteSpaceSingleLine(ch)) {
                            pos++;
                            continue;
                        }
                        else if (isLineBreak(ch)) {
                            precedingLineBreak = true;
                            pos++;
                            continue;
                        }
                        error(ts.Diagnostics.Invalid_character);
                        pos++;
                        return token = 0 /* Unknown */;
                }
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isDigit) id{155,1} ---
(ch) {
        return ch >= 48 /* _0 */ && ch <= 57 /* _9 */;
    }
--- END ---
INLINE (isDigit) id{155,1} AS 1 AT <0:6077>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isOctalDigit) id{155,2} ---
(ch) {
        return ch >= 48 /* _0 */ && ch <= 55 /* _7 */;
    }
--- END ---
INLINE (isOctalDigit) id{155,2} AS 2 AT <0:10885>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIdentifierStart) id{155,3} ---
(ch, languageVersion) {
        return ch >= 65 /* A */ && ch <= 90 /* Z */ || ch >= 97 /* a */ && ch <= 122 /* z */ ||
            ch === 36 /* $ */ || ch === 95 /* _ */ ||
            ch > 127 /* maxAsciiCharacter */ && isUnicodeIdentifierStart(ch, languageVersion);
    }
--- END ---
INLINE (isIdentifierStart) id{155,3} AS 3 AT <0:17770>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIdentifierPart) id{155,4} ---
(ch, languageVersion) {
        return ch >= 65 /* A */ && ch <= 90 /* Z */ || ch >= 97 /* a */ && ch <= 122 /* z */ ||
            ch >= 48 /* _0 */ && ch <= 57 /* _9 */ || ch === 36 /* $ */ || ch === 95 /* _ */ ||
            ch > 127 /* maxAsciiCharacter */ && isUnicodeIdentifierPart(ch, languageVersion);
    }
--- END ---
INLINE (isIdentifierPart) id{155,4} AS 4 AT <0:17895>
[deoptimizing (DEOPT eager): begin 0xd6230dafec1 <JS Function filter (SharedFunctionInfo 0xc2bd2ae1429)> (opt #120) @3, FP to SP delta: 56, caller sp: 0x7fff5fbfe188]
            ;;; deoptimize at 0_61: wrong map
  reading input frame filter => node=18, args=3, height=5; inputs:
      0: 0xd6230dafec1 ; [fp - 16] 0xd6230dafec1 <JS Function filter (SharedFunctionInfo 0xc2bd2ae1429)>
      1: 0x16f3adb61821 ; [fp + 32] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x2f05bb89cfc9 ; rbx 0x2f05bb89cfc9 <JS Array[0]>
      3: 0x376e2da38fa1 ; [fp + 16] 0x376e2da38fa1 <JS Function (SharedFunctionInfo 0x27864c467639)>
      4: 0xd6230db3179 ; [fp - 24] 0xd6230db3179 <FixedArray[95]>
      5: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
      6: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
      7: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
  translating frame filter => node=18, height=32
    0x7fff5fbfe180: [top + 80] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfe178: [top + 72] <- 0x2f05bb89cfc9 ;  0x2f05bb89cfc9 <JS Array[0]>  (input #2)
    0x7fff5fbfe170: [top + 64] <- 0x376e2da38fa1 ;  0x376e2da38fa1 <JS Function (SharedFunctionInfo 0x27864c467639)>  (input #3)
    0x7fff5fbfe168: [top + 56] <- 0x2c21d24e8678 ;  caller's pc
    0x7fff5fbfe160: [top + 48] <- 0x7fff5fbfe200 ;  caller's fp
    0x7fff5fbfe158: [top + 40] <- 0xd6230db3179 ;  context    0xd6230db3179 <FixedArray[95]>  (input #4)
    0x7fff5fbfe150: [top + 32] <- 0xd6230dafec1 ;  function    0xd6230dafec1 <JS Function filter (SharedFunctionInfo 0xc2bd2ae1429)>  (input #0)
    0x7fff5fbfe148: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfe140: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfe138: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfe130: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
[deoptimizing (eager): end 0xd6230dafec1 <JS Function filter (SharedFunctionInfo 0xc2bd2ae1429)> @3 => node=18, pc=0x2c21d23f06cf, caller sp=0x7fff5fbfe188, state=NO_REGISTERS, took 0.072 ms]
[deoptimizing (DEOPT eager): begin 0xd6230db1df9 <JS Function concatenate (SharedFunctionInfo 0xc2bd2ae1c69)> (opt #64) @2, FP to SP delta: 24, caller sp: 0x7fff5fbfe178]
            ;;; deoptimize at 1_33: unexpected object
  reading input frame concatenate => node=14, args=3, height=2; inputs:
      0: 0xd6230db1df9 ; [fp - 16] 0xd6230db1df9 <JS Function concatenate (SharedFunctionInfo 0xc2bd2ae1c69)>
      1: 0x16f3adb61821 ; [fp + 32] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x376e2da38081 ; [fp + 24] 0x376e2da38081 <JS Array[28]>
      3: 0x2f05bb89cfc9 ; rdx 0x2f05bb89cfc9 <JS Array[0]>
      4: 0xd6230db3179 ; rax 0xd6230db3179 <FixedArray[95]>
      5: 0xd6230db1e41 ; rbx 0xd6230db1e41 <JS Function some (SharedFunctionInfo 0xc2bd2ae1ba9)>
  reading arguments adaptor frame concatenate => height=2; inputs:
      0: 0xd6230db1e41 ; (literal 3) 0xd6230db1e41 <JS Function some (SharedFunctionInfo 0xc2bd2ae1ba9)>
      1: 0x1f9f6c0532e1 ; (literal 4) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2f05bb89cfc9 ; rdx 0x2f05bb89cfc9 <JS Array[0]>
  reading input frame some => node=3, args=3, height=4; inputs:
      0: 0xd6230db1e41 ; (literal 3) 0xd6230db1e41 <JS Function some (SharedFunctionInfo 0xc2bd2ae1ba9)>
      1: 0x1f9f6c0532e1 ; (literal 4) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2f05bb89cfc9 ; rdx 0x2f05bb89cfc9 <JS Array[0]>
      3: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
      4: 0xd6230db3179 ; (literal 6) 0xd6230db3179 <FixedArray[95]>
      5: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
      6: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
      7: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
  translating frame concatenate => node=14, height=8
    0x7fff5fbfe170: [top + 56] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfe168: [top + 48] <- 0x376e2da38081 ;  0x376e2da38081 <JS Array[28]>  (input #2)
    0x7fff5fbfe160: [top + 40] <- 0x2f05bb89cfc9 ;  0x2f05bb89cfc9 <JS Array[0]>  (input #3)
    0x7fff5fbfe158: [top + 32] <- 0x2c21d24e8720 ;  caller's pc
    0x7fff5fbfe150: [top + 24] <- 0x7fff5fbfe200 ;  caller's fp
    0x7fff5fbfe148: [top + 16] <- 0xd6230db3179 ;  context    0xd6230db3179 <FixedArray[95]>  (input #4)
    0x7fff5fbfe140: [top + 8] <- 0xd6230db1df9 ;  function    0xd6230db1df9 <JS Function concatenate (SharedFunctionInfo 0xc2bd2ae1c69)>  (input #0)
    0x7fff5fbfe138: [top + 0] <- 0xd6230db1e41 ;  0xd6230db1e41 <JS Function some (SharedFunctionInfo 0xc2bd2ae1ba9)>  (input #5)
  translating arguments adaptor => height=16
    0x7fff5fbfe130: [top + 48] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfe128: [top + 40] <- 0x2f05bb89cfc9 ;  0x2f05bb89cfc9 <JS Array[0]>  (input #2)
    0x7fff5fbfe120: [top + 32] <- 0x2c21d2428815 ;  caller's pc
    0x7fff5fbfe118: [top + 24] <- 0x7fff5fbfe150 ;  caller's fp
    0x7fff5fbfe110: [top + 16] <- 0xe00000000 ;  context (adaptor sentinel)
    0x7fff5fbfe108: [top + 8] <- 0xd6230db1e41 ;  function    0xd6230db1e41 <JS Function some (SharedFunctionInfo 0xc2bd2ae1ba9)>  (input #0)
    0x7fff5fbfe100: [top + 0] <- 0x100000000 ;  argc (1)
  translating frame some => node=3, height=24
    0x7fff5fbfe0f8: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfe0f0: [top + 64] <- 0x2f05bb89cfc9 ;  0x2f05bb89cfc9 <JS Array[0]>  (input #2)
    0x7fff5fbfe0e8: [top + 56] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #3)
    0x7fff5fbfe0e0: [top + 48] <- 0x2c21d2207e55 ;  caller's pc
    0x7fff5fbfe0d8: [top + 40] <- 0x7fff5fbfe118 ;  caller's fp
    0x7fff5fbfe0d0: [top + 32] <- 0xd6230db3179 ;  context    0xd6230db3179 <FixedArray[95]>  (input #4)
    0x7fff5fbfe0c8: [top + 24] <- 0xd6230db1e41 ;  function    0xd6230db1e41 <JS Function some (SharedFunctionInfo 0xc2bd2ae1ba9)>  (input #0)
    0x7fff5fbfe0c0: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfe0b8: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfe0b0: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
[deoptimizing (eager): end 0xd6230db1df9 <JS Function concatenate (SharedFunctionInfo 0xc2bd2ae1c69)> @2 => node=3, pc=0x2c21d242898d, caller sp=0x7fff5fbfe178, state=NO_REGISTERS, took 0.828 ms]
[deoptimizing (DEOPT eager): begin 0xd6230db1541 <JS Function addJSDocComment (SharedFunctionInfo 0x3504a53f0c71)> (opt #119) @3, FP to SP delta: 56, caller sp: 0x7fff5fbfde10]
            ;;; deoptimize at 0_77: wrong map
  reading input frame addJSDocComment => node=38, args=2, height=8; inputs:
      0: 0xd6230db1541 ; [fp - 16] 0xd6230db1541 <JS Function addJSDocComment (SharedFunctionInfo 0x3504a53f0c71)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x376e2da3e1b1 ; [fp + 16] 0x376e2da3e1b1 <a NodeObject with map 0x33abe2a679e9>
      3: 0xd6230d980d1 ; rbx 0xd6230d980d1 <FixedArray[334]>
      4: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
      5: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
      6: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
      7: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
      9: 0x16f3adb61821 ; [fp - 32] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
     10: 0xd6230db1589 ; rax 0xd6230db1589 <JS Function getJSDocCommentRanges (SharedFunctionInfo 0x3504a53ce519)>
  translating frame addJSDocComment => node=38, height=56
    0x7fff5fbfde08: [top + 96] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfde00: [top + 88] <- 0x376e2da3e1b1 ;  0x376e2da3e1b1 <a NodeObject with map 0x33abe2a679e9>  (input #2)
    0x7fff5fbfddf8: [top + 80] <- 0x2c21d24b0f9c ;  caller's pc
    0x7fff5fbfddf0: [top + 72] <- 0x7fff5fbfdf08 ;  caller's fp
    0x7fff5fbfdde8: [top + 64] <- 0xd6230d980d1 ;  context    0xd6230d980d1 <FixedArray[334]>  (input #3)
    0x7fff5fbfdde0: [top + 56] <- 0xd6230db1541 ;  function    0xd6230db1541 <JS Function addJSDocComment (SharedFunctionInfo 0x3504a53f0c71)>  (input #0)
    0x7fff5fbfddd8: [top + 48] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfddd0: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfddc8: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfddc0: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfddb8: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfddb0: [top + 8] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #9)
    0x7fff5fbfdda8: [top + 0] <- 0xd6230db1589 ;  0xd6230db1589 <JS Function getJSDocCommentRanges (SharedFunctionInfo 0x3504a53ce519)>  (input #10)
[deoptimizing (eager): end 0xd6230db1541 <JS Function addJSDocComment (SharedFunctionInfo 0x3504a53f0c71)> @3 => node=38, pc=0x2c21d24224a5, caller sp=0x7fff5fbfde10, state=TOS_REGISTER, took 0.092 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:tryParseTypeExpression) id{156,0} ---
() {
                    return tryParse(function () {
                        skipWhitespace();
                        if (token() !== 16 /* OpenBraceToken */) {
                            return undefined;
                        }
                        return parseJSDocTypeExpression();
                    });
                }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:tryParse) id{156,1} ---
(callback) {
            return speculationHelper(callback, /*isLookAhead*/ false);
        }
--- END ---
INLINE (tryParse) id{156,1} AS 1 AT <0:32>
[deoptimizing (DEOPT soft): begin 0xd6230dd38e9 <JS Function parseParameter (SharedFunctionInfo 0x3504a53f5d71)> (opt #84) @128, FP to SP delta: 256, caller sp: 0x7fff5fbfd8c0]
            ;;; deoptimize at 0_139: Insufficient type feedback for generic named access
  reading input frame parseParameter => node=64, args=1, height=4; inputs:
      0: 0xd6230dd38e9 ; [fp - 16] 0xd6230dd38e9 <JS Function parseParameter (SharedFunctionInfo 0x3504a53f5d71)>
      1: 0x1f9f6c0532e1 ; [fp + 16] 0x1f9f6c0532e1 <JS Global Object>
      2: 0xd6230d980d1 ; [fp - 24] 0xd6230d980d1 <FixedArray[334]>
      3: 0x376e2da7fd91 ; [fp - 64] 0x376e2da7fd91 <a NodeObject with map 0x33abe2a669c1>
      4: 0x376e2da7fd91 ; [fp - 64] 0x376e2da7fd91 <a NodeObject with map 0x33abe2a669c1>
      5: 0x376e2da7fe11 ; rax 0x376e2da7fe11 <an IdentifierObject with map 0x33abe2a67a99>
  translating frame parseParameter => node=64, height=24
    0x7fff5fbfd8b8: [top + 56] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd8b0: [top + 48] <- 0x2c21d24be62b ;  caller's pc
    0x7fff5fbfd8a8: [top + 40] <- 0x7fff5fbfd938 ;  caller's fp
    0x7fff5fbfd8a0: [top + 32] <- 0xd6230d980d1 ;  context    0xd6230d980d1 <FixedArray[334]>  (input #2)
    0x7fff5fbfd898: [top + 24] <- 0xd6230dd38e9 ;  function    0xd6230dd38e9 <JS Function parseParameter (SharedFunctionInfo 0x3504a53f5d71)>  (input #0)
    0x7fff5fbfd890: [top + 16] <- 0x376e2da7fd91 ;  0x376e2da7fd91 <a NodeObject with map 0x33abe2a669c1>  (input #3)
    0x7fff5fbfd888: [top + 8] <- 0x376e2da7fd91 ;  0x376e2da7fd91 <a NodeObject with map 0x33abe2a669c1>  (input #4)
    0x7fff5fbfd880: [top + 0] <- 0x376e2da7fe11 ;  0x376e2da7fe11 <an IdentifierObject with map 0x33abe2a67a99>  (input #5)
[deoptimizing (soft): end 0xd6230dd38e9 <JS Function parseParameter (SharedFunctionInfo 0x3504a53f5d71)> @128 => node=64, pc=0x2c21d24258ad, caller sp=0x7fff5fbfd8c0, state=TOS_REGISTER, took 0.065 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseTagComments) id{157,0} ---
(indent) {
                    var comments = [];
                    var state = 0 /* BeginningOfLine */;
                    var margin;
                    function pushComment(text) {
                        if (!margin) {
                            margin = indent;
                        }
                        comments.push(text);
                        indent += text.length;
                    }
                    while (token() !== 56 /* AtToken */ && token() !== 1 /* EndOfFileToken */) {
                        switch (token()) {
                            case 4 /* NewLineTrivia */:
                                if (state >= 1 /* SawAsterisk */) {
                                    state = 0 /* BeginningOfLine */;
                                    comments.push(scanner.getTokenText());
                                }
                                indent = 0;
                                break;
                            case 56 /* AtToken */:
                                // Done
                                break;
                            case 5 /* WhitespaceTrivia */:
                                if (state === 2 /* SavingComments */) {
                                    pushComment(scanner.getTokenText());
                                }
                                else {
                                    var whitespace = scanner.getTokenText();
                                    // if the whitespace crosses the margin, take only the whitespace that passes the margin
                                    if (margin !== undefined && indent + whitespace.length > margin) {
                                        comments.push(whitespace.slice(margin - indent - 1));
                                    }
                                    indent += whitespace.length;
                                }
                                break;
                            case 38 /* AsteriskToken */:
                                if (state === 0 /* BeginningOfLine */) {
                                    // leading asterisks start recording on the *next* (non-whitespace) token
                                    state = 1 /* SawAsterisk */;
                                    indent += scanner.getTokenText().length;
                                    break;
                                }
                            // FALLTHROUGH otherwise to record the * as a comment
                            default:
                                state = 2 /* SavingComments */; // leading identifiers start recording as well
                                pushComment(scanner.getTokenText());
                                break;
                        }
                        if (token() === 56 /* AtToken */) {
                            // Done
                            break;
                        }
                        nextJSDocToken();
                    }
                    removeLeadingNewlines(comments);
                    removeTrailingNewlines(comments);
                    return comments;
                }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{157,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{157,1} AS 1 AT <0:439>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{157,2} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{157,2} AS 2 AT <0:471>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{157,3} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{157,3} AS 3 AT <0:541>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{157,4} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{157,4} AS 4 AT <0:2770>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isListElement) id{158,0} ---
(parsingContext, inErrorRecovery) {
            var node = currentNode(parsingContext);
            if (node) {
                return true;
            }
            switch (parsingContext) {
                case 0 /* SourceElements */:
                case 1 /* BlockStatements */:
                case 3 /* SwitchClauseStatements */:
                    // If we're in error recovery, then we don't want to treat ';' as an empty statement.
                    // The problem is that ';' can show up in far too many contexts, and if we see one
                    // and assume it's a statement, then we may bail out inappropriately from whatever
                    // we're parsing.  For example, if we have a semicolon in the middle of a class, then
                    // we really don't want to assume the class is over and we're on a statement in the
                    // outer module.  We just want to consume and move on.
                    return !(token() === 24 /* SemicolonToken */ && inErrorRecovery) && isStartOfStatement();
                case 2 /* SwitchClauses */:
                    return token() === 72 /* CaseKeyword */ || token() === 78 /* DefaultKeyword */;
                case 4 /* TypeMembers */:
                    return lookAhead(isTypeMemberStart);
                case 5 /* ClassMembers */:
                    // We allow semicolons as class elements (as specified by ES6) as long as we're
                    // not in error recovery.  If we're in error recovery, we don't want an errant
                    // semicolon to be treated as a class member (since they're almost always used
                    // for statements.
                    return lookAhead(isClassMemberStart) || (token() === 24 /* SemicolonToken */ && !inErrorRecovery);
                case 6 /* EnumMembers */:
                    // Include open bracket computed properties. This technically also lets in indexers,
                    // which would be a candidate for improved error reporting.
                    return token() === 20 /* OpenBracketToken */ || isLiteralPropertyName();
                case 12 /* ObjectLiteralMembers */:
                    return token() === 20 /* OpenBracketToken */ || token() === 38 /* AsteriskToken */ || token() === 23 /* DotDotDotToken */ || isLiteralPropertyName();
                case 17 /* RestProperties */:
                    return isLiteralPropertyName();
                case 9 /* ObjectBindingElements */:
                    return token() === 20 /* OpenBracketToken */ || token() === 23 /* DotDotDotToken */ || isLiteralPropertyName();
                case 7 /* HeritageClauseElement */:
                    // If we see { } then only consume it as an expression if it is followed by , or {
                    // That way we won't consume the body of a class in its heritage clause.
                    if (token() === 16 /* OpenBraceToken */) {
                        return lookAhead(isValidHeritageClauseObjectLiteral);
                    }
                    if (!inErrorRecovery) {
                        return isStartOfLeftHandSideExpression() && !isHeritageClauseExtendsOrImplementsKeyword();
                    }
                    else {
                        // If we're in error recovery we tighten up what we're willing to match.
                        // That way we don't treat something like "this" as a valid heritage clause
                        // element during recovery.
                        return isIdentifier() && !isHeritageClauseExtendsOrImplementsKeyword();
                    }
                case 8 /* VariableDeclarations */:
                    return isIdentifierOrPattern();
                case 10 /* ArrayBindingElements */:
                    return token() === 25 /* CommaToken */ || token() === 23 /* DotDotDotToken */ || isIdentifierOrPattern();
                case 18 /* TypeParameters */:
                    return isIdentifier();
                case 11 /* ArgumentExpressions */:
                case 15 /* ArrayLiteralMembers */:
                    return token() === 25 /* CommaToken */ || token() === 23 /* DotDotDotToken */ || isStartOfExpression();
                case 16 /* Parameters */:
                    return isStartOfParameter();
                case 19 /* TypeArguments */:
                case 20 /* TupleElementTypes */:
                    return token() === 25 /* CommaToken */ || isStartOfType();
                case 21 /* HeritageClauses */:
                    return isHeritageClause();
                case 22 /* ImportOrExportSpecifiers */:
                    return ts.tokenIsIdentifierOrKeyword(token());
                case 13 /* JsxAttributes */:
                    return ts.tokenIsIdentifierOrKeyword(token()) || token() === 16 /* OpenBraceToken */;
                case 14 /* JsxChildren */:
                    return true;
                case 23 /* JSDocFunctionParameters */:
                case 24 /* JSDocTypeArguments */:
                case 26 /* JSDocTupleTypes */:
                    return JSDocParser.isJSDocType();
                case 25 /* JSDocRecordMembers */:
                    return isSimplePropertyName();
            }
            ts.Debug.fail("Non-exhaustive case in 'isListElement'.");
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{158,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{158,1} AS 1 AT <0:963>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:lookAhead) id{158,2} ---
(callback) {
            return speculationHelper(callback, /*isLookAhead*/ true);
        }
--- END ---
INLINE (lookAhead) id{158,2} AS 2 AT <0:1257>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:lookAhead) id{158,3} ---
(callback) {
            return speculationHelper(callback, /*isLookAhead*/ true);
        }
--- END ---
INLINE (lookAhead) id{158,3} AS 3 AT <0:1694>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{158,4} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{158,4} AS 4 AT <0:2040>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isLiteralPropertyName) id{158,5} ---
() {
            return ts.tokenIsIdentifierOrKeyword(token()) ||
                token() === 9 /* StringLiteral */ ||
                token() === 8 /* NumericLiteral */;
        }
--- END ---
INLINE (isLiteralPropertyName) id{158,5} AS 5 AT <0:2081>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{158,6} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{158,6} AS 6 AT <5:54>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{158,7} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{158,7} AS 7 AT <5:82>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{158,8} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{158,8} AS 8 AT <5:135>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{158,9} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{158,9} AS 9 AT <0:2882>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isHeritageClauseExtendsOrImplementsKeyword) id{158,10} ---
() {
            if (token() === 107 /* ImplementsKeyword */ ||
                token() === 84 /* ExtendsKeyword */) {
                return lookAhead(nextTokenIsStartOfExpression);
            }
            return false;
        }
--- END ---
INLINE (isHeritageClauseExtendsOrImplementsKeyword) id{158,10} AS 10 AT <0:3134>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{158,11} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{158,11} AS 11 AT <10:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{158,12} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{158,12} AS 12 AT <10:80>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIdentifierOrPattern) id{158,13} ---
() {
            return token() === 16 /* OpenBraceToken */ || token() === 20 /* OpenBracketToken */ || isIdentifier();
        }
--- END ---
INLINE (isIdentifierOrPattern) id{158,13} AS 13 AT <0:3674>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{158,14} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{158,14} AS 14 AT <13:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{158,15} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{158,15} AS 15 AT <13:63>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isStartOfParameter) id{158,16} ---
() {
            return token() === 23 /* DotDotDotToken */ || isIdentifierOrPattern() || ts.isModifierKind(token()) || token() === 56 /* AtToken */ || token() === 98 /* ThisKeyword */;
        }
--- END ---
INLINE (isStartOfParameter) id{158,16} AS 16 AT <0:4261>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{158,17} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{158,17} AS 17 AT <16:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIdentifierOrPattern) id{158,18} ---
() {
            return token() === 16 /* OpenBraceToken */ || token() === 20 /* OpenBracketToken */ || isIdentifier();
        }
--- END ---
INLINE (isIdentifierOrPattern) id{158,18} AS 18 AT <16:63>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{158,19} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{158,19} AS 19 AT <18:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{158,20} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{158,20} AS 20 AT <18:63>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{158,21} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{158,21} AS 21 AT <16:108>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{158,22} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{158,22} AS 22 AT <16:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{158,23} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{158,23} AS 23 AT <16:152>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{158,24} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{158,24} AS 24 AT <0:4404>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isHeritageClause) id{158,25} ---
() {
            return token() === 84 /* ExtendsKeyword */ || token() === 107 /* ImplementsKeyword */;
        }
--- END ---
INLINE (isHeritageClause) id{158,25} AS 25 AT <0:4530>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{158,26} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{158,26} AS 26 AT <25:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{158,27} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{158,27} AS 27 AT <25:63>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{158,28} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{158,28} AS 28 AT <0:4663>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseJSDocIdentifierName) id{159,0} ---
() {
                    return createJSDocIdentifier(ts.tokenIsIdentifierOrKeyword(token()));
                }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{159,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{159,1} AS 1 AT <0:84>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createJSDocIdentifier) id{160,0} ---
(isIdentifier) {
                    if (!isIdentifier) {
                        parseErrorAtCurrentToken(ts.Diagnostics.Identifier_expected);
                        return undefined;
                    }
                    var pos = scanner.getTokenPos();
                    var end = scanner.getTextPos();
                    var result = createNode(70 /* Identifier */, pos);
                    result.text = content.substring(pos, end);
                    finishNode(result, end);
                    nextJSDocToken();
                    return result;
                }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{160,1} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{160,1} AS 1 AT <0:346>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{160,2} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{160,2} AS 2 AT <1:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{160,3} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{160,3} AS 3 AT <1:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{160,4} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{160,4} AS 4 AT <1:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:setTextPos) id{161,0} ---
(textPos) {
            ts.Debug.assert(textPos >= 0);
            pos = textPos;
            startPos = textPos;
            tokenPos = textPos;
            token = 0 /* Unknown */;
            precedingLineBreak = false;
            tokenValue = undefined;
            hasExtendedUnicodeEscape = false;
            tokenIsUnterminated = false;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:concatenate) id{162,0} ---
(array1, array2) {
        if (!some(array2))
            return array1;
        if (!some(array1))
            return array2;
        return array1.concat(array2);
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:some) id{162,1} ---
(array, predicate) {
        if (array) {
            if (predicate) {
                for (var _i = 0, array_5 = array; _i < array_5.length; _i++) {
                    var v = array_5[_i];
                    if (predicate(v)) {
                        return true;
                    }
                }
            }
            else {
                return array.length > 0;
            }
        }
        return false;
    }
--- END ---
INLINE (some) id{162,1} AS 1 AT <0:32>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:) id{163,0} ---
(comment) {
            return text.charCodeAt(comment.pos + 1) === 42 /* asterisk */ &&
                text.charCodeAt(comment.pos + 2) === 42 /* asterisk */ &&
                text.charCodeAt(comment.pos + 3) !== 47 /* slash */;
        }
--- END ---
--- FUNCTION SOURCE (native array.js:DoJoin) id{164,0} ---
(q,r,F,B,A){
if(UseSparseVariant(q,r,F,r)){
%NormalizeElements(q);
var x=GetSortedArrayKeys(q,%GetArrayKeys(q,r));
if(B===''){
if(x.length===0)return'';
return SparseJoin(q,x,A);
}else{
return SparseJoinWithSeparatorJS(
q,x,r,A,B);
}
}
if(r===1){
return ConvertToString(A,q[0]);
}
var D=new g(r);
for(var y=0;y<r;y++){
D[y]=ConvertToString(A,q[y]);
}
if(B===''){
return %StringBuilderConcat(D,r,'');
}else{
return %StringBuilderJoin(D,r,B);
}
}
--- END ---
[deoptimizing (DEOPT eager): begin 0xd6230d98e21 <JS Function parseTypeWorker (SharedFunctionInfo 0x3504a53f7b71)> (opt #141) @18, FP to SP delta: 224, caller sp: 0x7fff5fbfda90]
            ;;; deoptimize at 12_221: wrong map
  reading input frame parseTypeWorker => node=67, args=1, height=2; inputs:
      0: 0xd6230d98e21 ; [fp - 16] 0xd6230d98e21 <JS Function parseTypeWorker (SharedFunctionInfo 0x3504a53f7b71)>
      1: 0x1f9f6c0532e1 ; [fp + 16] 0x1f9f6c0532e1 <JS Global Object>
      2: 0xd6230d980d1 ; [fp - 24] 0xd6230d980d1 <FixedArray[334]>
      3: 0xd6230d98d91 ; [fp - 56] 0xd6230d98d91 <JS Function parseUnionTypeOrHigher (SharedFunctionInfo 0x3504a53f7631)>
  reading input frame parseUnionTypeOrHigher => node=7, args=1, height=2; inputs:
      0: 0xd6230d98d91 ; (literal 37) 0xd6230d98d91 <JS Function parseUnionTypeOrHigher (SharedFunctionInfo 0x3504a53f7631)>
      1: 0x1f9f6c0532e1 ; (literal 34) 0x1f9f6c0532e1 <JS Global Object>
      2: 0xd6230d980d1 ; (literal 35) 0xd6230d980d1 <FixedArray[334]>
      3: 0xd6230d98d01 ; [fp - 64] 0xd6230d98d01 <JS Function parseUnionOrIntersectionType (SharedFunctionInfo 0x3504a53f74b1)>
  reading input frame parseUnionOrIntersectionType => node=88, args=4, height=7; inputs:
      0: 0xd6230d98d01 ; (literal 38) 0xd6230d98d01 <JS Function parseUnionOrIntersectionType (SharedFunctionInfo 0x3504a53f74b1)>
      1: 0x1f9f6c0532e1 ; (literal 34) 0x1f9f6c0532e1 <JS Global Object>
      2: 0xa400000000 ; (literal 39) 164
      3: 0xd6230d98d49 ; [fp - 72] 0xd6230d98d49 <JS Function parseIntersectionTypeOrHigher (SharedFunctionInfo 0x3504a53f7571)>
      4: 0x3000000000 ; (literal 40) 48
      5: 0xd6230d980d1 ; (literal 35) 0xd6230d980d1 <FixedArray[334]>
      6: 0x104003eb0461 ; rbx 0x104003eb0461 <a NodeObject with map 0x33abe2a68a11>
      7: 0x30bcea404311 ; (literal 41) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; (literal 41) 0x30bcea404311 <undefined>
      9: 0xd6230db0809 ; rdx 0xd6230db0809 <JS Function createNodeArray (SharedFunctionInfo 0x3504a53f2fb1)>
     10: 0x30bcea404311 ; (literal 41) 0x30bcea404311 <undefined>
     11: 0x104003eb0681 ; rcx 0x104003eb0681 <JS Array[1]>
  translating frame parseTypeWorker => node=67, height=8
    0x7fff5fbfda88: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfda80: [top + 32] <- 0x2c21d248f2cd ;  caller's pc
    0x7fff5fbfda78: [top + 24] <- 0x7fff5fbfdac0 ;  caller's fp
    0x7fff5fbfda70: [top + 16] <- 0xd6230d980d1 ;  context    0xd6230d980d1 <FixedArray[334]>  (input #2)
    0x7fff5fbfda68: [top + 8] <- 0xd6230d98e21 ;  function    0xd6230d98e21 <JS Function parseTypeWorker (SharedFunctionInfo 0x3504a53f7b71)>  (input #0)
    0x7fff5fbfda60: [top + 0] <- 0xd6230d98d91 ;  0xd6230d98d91 <JS Function parseUnionTypeOrHigher (SharedFunctionInfo 0x3504a53f7631)>  (input #3)
  translating frame parseUnionTypeOrHigher => node=7, height=8
    0x7fff5fbfda58: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfda50: [top + 32] <- 0x2c21d241ff43 ;  caller's pc
    0x7fff5fbfda48: [top + 24] <- 0x7fff5fbfda78 ;  caller's fp
    0x7fff5fbfda40: [top + 16] <- 0xd6230d980d1 ;  context    0xd6230d980d1 <FixedArray[334]>  (input #2)
    0x7fff5fbfda38: [top + 8] <- 0xd6230d98d91 ;  function    0xd6230d98d91 <JS Function parseUnionTypeOrHigher (SharedFunctionInfo 0x3504a53f7631)>  (input #0)
    0x7fff5fbfda30: [top + 0] <- 0xd6230d98d01 ;  0xd6230d98d01 <JS Function parseUnionOrIntersectionType (SharedFunctionInfo 0x3504a53f74b1)>  (input #3)
  translating frame parseUnionOrIntersectionType => node=88, height=48
    0x7fff5fbfda28: [top + 104] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfda20: [top + 96] <- 0xa400000000 ;  164  (input #2)
    0x7fff5fbfda18: [top + 88] <- 0xd6230d98d49 ;  0xd6230d98d49 <JS Function parseIntersectionTypeOrHigher (SharedFunctionInfo 0x3504a53f7571)>  (input #3)
    0x7fff5fbfda10: [top + 80] <- 0x3000000000 ;  48  (input #4)
    0x7fff5fbfda08: [top + 72] <- 0x2c21d24201f6 ;  caller's pc
    0x7fff5fbfda00: [top + 64] <- 0x7fff5fbfda48 ;  caller's fp
    0x7fff5fbfd9f8: [top + 56] <- 0xd6230d980d1 ;  context    0xd6230d980d1 <FixedArray[334]>  (input #5)
    0x7fff5fbfd9f0: [top + 48] <- 0xd6230d98d01 ;  function    0xd6230d98d01 <JS Function parseUnionOrIntersectionType (SharedFunctionInfo 0x3504a53f74b1)>  (input #0)
    0x7fff5fbfd9e8: [top + 40] <- 0x104003eb0461 ;  0x104003eb0461 <a NodeObject with map 0x33abe2a68a11>  (input #6)
    0x7fff5fbfd9e0: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfd9d8: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfd9d0: [top + 16] <- 0xd6230db0809 ;  0xd6230db0809 <JS Function createNodeArray (SharedFunctionInfo 0x3504a53f2fb1)>  (input #9)
    0x7fff5fbfd9c8: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #10)
    0x7fff5fbfd9c0: [top + 0] <- 0x104003eb0681 ;  0x104003eb0681 <JS Array[1]>  (input #11)
[deoptimizing (eager): end 0xd6230d98e21 <JS Function parseTypeWorker (SharedFunctionInfo 0x3504a53f7b71)> @18 => node=88, pc=0x2c21d24203b8, caller sp=0x7fff5fbfda90, state=NO_REGISTERS, took 0.214 ms]
[deoptimizer unlinked: parseTypeWorker / d6230d98e21]
[deoptimizing (DEOPT lazy): begin 0xd6230d98e21 <JS Function parseTypeWorker (SharedFunctionInfo 0x3504a53f7b71)> (opt #141) @90, FP to SP delta: 224, caller sp: 0x7fff5fbfdd30]
  reading input frame parseTypeWorker => node=22, args=1, height=2; inputs:
      0: 0xd6230d98e21 ; [fp - 16] 0xd6230d98e21 <JS Function parseTypeWorker (SharedFunctionInfo 0x3504a53f7b71)>
      1: 0x1f9f6c0532e1 ; [fp + 16] 0x1f9f6c0532e1 <JS Global Object>
      2: 0xd6230d980d1 ; [fp - 24] 0xd6230d980d1 <FixedArray[334]>
      3: 0xd6230db24d1 ; [fp - 96] 0xd6230db24d1 <JS Function parseFunctionOrConstructorType (SharedFunctionInfo 0x3504a53f6d31)>
  reading input frame parseFunctionOrConstructorType => node=57, args=2, height=2; inputs:
      0: 0xd6230db24d1 ; (literal 55) 0xd6230db24d1 <JS Function parseFunctionOrConstructorType (SharedFunctionInfo 0x3504a53f6d31)>
      1: 0x1f9f6c0532e1 ; (literal 34) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x9e00000000 ; (literal 56) 158
      3: 0xd6230d980d1 ; (literal 35) 0xd6230d980d1 <FixedArray[334]>
      4: 0x104003eaf6d9 ; [fp - 224] 0x104003eaf6d9 <a NodeObject with map 0x33abe2a67d01>
  translating frame parseTypeWorker => node=22, height=8
    0x7fff5fbfdd28: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdd20: [top + 32] <- 0x2c21d248f2cd ;  caller's pc
    0x7fff5fbfdd18: [top + 24] <- 0x7fff5fbfdd60 ;  caller's fp
    0x7fff5fbfdd10: [top + 16] <- 0xd6230d980d1 ;  context    0xd6230d980d1 <FixedArray[334]>  (input #2)
    0x7fff5fbfdd08: [top + 8] <- 0xd6230d98e21 ;  function    0xd6230d98e21 <JS Function parseTypeWorker (SharedFunctionInfo 0x3504a53f7b71)>  (input #0)
    0x7fff5fbfdd00: [top + 0] <- 0xd6230db24d1 ;  0xd6230db24d1 <JS Function parseFunctionOrConstructorType (SharedFunctionInfo 0x3504a53f6d31)>  (input #3)
  translating frame parseFunctionOrConstructorType => node=57, height=8
    0x7fff5fbfdcf8: [top + 48] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdcf0: [top + 40] <- 0x9e00000000 ;  158  (input #2)
    0x7fff5fbfdce8: [top + 32] <- 0x2c21d241fe59 ;  caller's pc
    0x7fff5fbfdce0: [top + 24] <- 0x7fff5fbfdd18 ;  caller's fp
    0x7fff5fbfdcd8: [top + 16] <- 0xd6230d980d1 ;  context    0xd6230d980d1 <FixedArray[334]>  (input #3)
    0x7fff5fbfdcd0: [top + 8] <- 0xd6230db24d1 ;  function    0xd6230db24d1 <JS Function parseFunctionOrConstructorType (SharedFunctionInfo 0x3504a53f6d31)>  (input #0)
    0x7fff5fbfdcc8: [top + 0] <- 0x104003eaf6d9 ;  0x104003eaf6d9 <a NodeObject with map 0x33abe2a67d01>  (input #4)
[deoptimizing (lazy): end 0xd6230d98e21 <JS Function parseTypeWorker (SharedFunctionInfo 0x3504a53f7b71)> @90 => node=57, pc=0x2c21d2440007, caller sp=0x7fff5fbfdd30, state=NO_REGISTERS, took 0.086 ms]
[deoptimizing (DEOPT soft): begin 0xd6230db30e9 <JS Function skipParameterStart (SharedFunctionInfo 0x3504a53f77b1)> (opt #105) @10, FP to SP delta: 40, caller sp: 0x7fff5fbfd620]
            ;;; deoptimize at 0_175: Insufficient type feedback for combined type of binary operation
  reading input frame skipParameterStart => node=66, args=1, height=3; inputs:
      0: 0xd6230db30e9 ; [fp - 16] 0xd6230db30e9 <JS Function skipParameterStart (SharedFunctionInfo 0x3504a53f77b1)>
      1: 0x1f9f6c0532e1 ; [fp + 16] 0x1f9f6c0532e1 <JS Global Object>
      2: 0xd6230d980d1 ; [fp - 24] 0xd6230d980d1 <FixedArray[334]>
      3: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
      4: 0x1200000000 ; rax 18
  translating frame skipParameterStart => node=66, height=16
    0x7fff5fbfd618: [top + 48] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd610: [top + 40] <- 0x2c21d24b9e31 ;  caller's pc
    0x7fff5fbfd608: [top + 32] <- 0x7fff5fbfd640 ;  caller's fp
    0x7fff5fbfd600: [top + 24] <- 0xd6230d980d1 ;  context    0xd6230d980d1 <FixedArray[334]>  (input #2)
    0x7fff5fbfd5f8: [top + 16] <- 0xd6230db30e9 ;  function    0xd6230db30e9 <JS Function skipParameterStart (SharedFunctionInfo 0x3504a53f77b1)>  (input #0)
    0x7fff5fbfd5f0: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #3)
    0x7fff5fbfd5e8: [top + 0] <- 0x1200000000 ;  18  (input #4)
[deoptimizing (soft): end 0xd6230db30e9 <JS Function skipParameterStart (SharedFunctionInfo 0x3504a53f77b1)> @10 => node=66, pc=0x2c21d246a266, caller sp=0x7fff5fbfd620, state=NO_REGISTERS, took 0.074 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseTypeWorker) id{165,0} ---
() {
            if (isStartOfFunctionType()) {
                return parseFunctionOrConstructorType(158 /* FunctionType */);
            }
            if (token() === 93 /* NewKeyword */) {
                return parseFunctionOrConstructorType(159 /* ConstructorType */);
            }
            return parseUnionTypeOrHigher();
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isStartOfFunctionType) id{165,1} ---
() {
            if (token() === 26 /* LessThanToken */) {
                return true;
            }
            return token() === 18 /* OpenParenToken */ && lookAhead(isUnambiguouslyStartOfFunctionType);
        }
--- END ---
INLINE (isStartOfFunctionType) id{165,1} AS 1 AT <0:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{165,2} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{165,2} AS 2 AT <1:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{165,3} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{165,3} AS 3 AT <1:121>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:lookAhead) id{165,4} ---
(callback) {
            return speculationHelper(callback, /*isLookAhead*/ true);
        }
--- END ---
INLINE (lookAhead) id{165,4} AS 4 AT <1:160>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseFunctionOrConstructorType) id{165,5} ---
(kind) {
            var node = createNode(kind);
            if (kind === 159 /* ConstructorType */) {
                parseExpected(93 /* NewKeyword */);
            }
            fillSignature(35 /* EqualsGreaterThanToken */, /*yieldContext*/ false, /*awaitContext*/ false, /*requireCompleteParameterList*/ false, node);
            return finishNode(node);
        }
--- END ---
INLINE (parseFunctionOrConstructorType) id{165,5} AS 5 AT <0:71>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{165,6} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{165,6} AS 6 AT <5:32>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{165,7} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{165,7} AS 7 AT <6:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{165,8} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{165,8} AS 8 AT <6:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{165,9} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{165,9} AS 9 AT <6:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{165,10} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{165,10} AS 10 AT <0:157>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseFunctionOrConstructorType) id{165,11} ---
(kind) {
            var node = createNode(kind);
            if (kind === 159 /* ConstructorType */) {
                parseExpected(93 /* NewKeyword */);
            }
            fillSignature(35 /* EqualsGreaterThanToken */, /*yieldContext*/ false, /*awaitContext*/ false, /*requireCompleteParameterList*/ false, node);
            return finishNode(node);
        }
--- END ---
INLINE (parseFunctionOrConstructorType) id{165,11} AS 11 AT <0:215>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{165,12} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{165,12} AS 12 AT <11:32>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{165,13} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{165,13} AS 13 AT <12:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{165,14} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{165,14} AS 14 AT <12:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{165,15} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{165,15} AS 15 AT <12:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseUnionTypeOrHigher) id{165,16} ---
() {
            return parseUnionOrIntersectionType(164 /* UnionType */, parseIntersectionTypeOrHigher, 48 /* BarToken */);
        }
--- END ---
INLINE (parseUnionTypeOrHigher) id{165,16} AS 16 AT <0:307>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseUnionOrIntersectionType) id{165,17} ---
(kind, parseConstituentType, operator) {
            parseOptional(operator);
            var type = parseConstituentType();
            if (token() === operator) {
                var types = createNodeArray([type], type.pos);
                while (parseOptional(operator)) {
                    types.push(parseConstituentType());
                }
                types.end = getNodeEnd();
                var node = createNode(kind, type.pos);
                node.types = types;
                type = finishNode(node);
            }
            return type;
        }
--- END ---
INLINE (parseUnionOrIntersectionType) id{165,17} AS 17 AT <16:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseOptional) id{165,18} ---
(t) {
            if (token() === t) {
                nextToken();
                return true;
            }
            return false;
        }
--- END ---
INLINE (parseOptional) id{165,18} AS 18 AT <17:53>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{165,19} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{165,19} AS 19 AT <18:22>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{165,20} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{165,20} AS 20 AT <18:55>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{165,21} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{165,21} AS 21 AT <17:141>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNodeArray) id{165,22} ---
(elements, pos) {
            var array = (elements || []);
            if (!(pos >= 0)) {
                pos = getNodePos();
            }
            array.pos = pos;
            array.end = pos;
            return array;
        }
--- END ---
INLINE (createNodeArray) id{165,22} AS 22 AT <17:193>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodePos) id{165,23} ---
() {
            return scanner.getStartPos();
        }
--- END ---
INLINE (getNodePos) id{165,23} AS 23 AT <22:113>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseOptional) id{165,24} ---
(t) {
            if (token() === t) {
                nextToken();
                return true;
            }
            return false;
        }
--- END ---
INLINE (parseOptional) id{165,24} AS 24 AT <17:251>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{165,25} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{165,25} AS 25 AT <24:22>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{165,26} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{165,26} AS 26 AT <24:55>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseIntersectionTypeOrHigher) id{165,27} ---
() {
            return parseUnionOrIntersectionType(165 /* IntersectionType */, parseTypeOperatorOrHigher, 47 /* AmpersandToken */);
        }
--- END ---
INLINE (parseIntersectionTypeOrHigher) id{165,27} AS 27 AT <17:309>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeEnd) id{165,28} ---
() {
            return scanner.getStartPos();
        }
--- END ---
INLINE (getNodeEnd) id{165,28} AS 28 AT <17:380>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseJSDocCommentWorker) id{166,0} ---
(start, length) {
                var content = sourceText;
                start = start || 0;
                var end = length === undefined ? content.length : start + length;
                length = end - start;
                ts.Debug.assert(start >= 0);
                ts.Debug.assert(start <= end);
                ts.Debug.assert(end <= content.length);
                var tags;
                var comments = [];
                var result;
                // Check for /** (JSDoc opening part)
                if (!isJsDocStart(content, start)) {
                    return result;
                }
                // + 3 for leading /**, - 5 in total for /** */
                scanner.scanRange(start + 3, length - 5, function () {
                    // Initially we can parse out a tag.  We also have seen a starting asterisk.
                    // This is so that /** * @type */ doesn't parse.
                    var advanceToken = true;
                    var state = 1 /* SawAsterisk */;
                    var margin = undefined;
                    // + 4 for leading '/** '
                    var indent = start - Math.max(content.lastIndexOf("\x5cn", start), 0) + 4;
                    function pushComment(text) {
                        if (!margin) {
                            margin = indent;
                        }
                        comments.push(text);
                        indent += text.length;
                    }
                    nextJSDocToken();
                    while (token() === 5 /* WhitespaceTrivia */) {
                        nextJSDocToken();
                    }
                    if (token() === 4 /* NewLineTrivia */) {
                        state = 0 /* BeginningOfLine */;
                        indent = 0;
                        nextJSDocToken();
                    }
                    while (token() !== 1 /* EndOfFileToken */) {
                        switch (token()) {
                            case 56 /* AtToken */:
                                if (state === 0 /* BeginningOfLine */ || state === 1 /* SawAsterisk */) {
                                    removeTrailingNewlines(comments);
                                    parseTag(indent);
                                    // NOTE: According to usejsdoc.org, a tag goes to end of line, except the last tag.
                                    // Real-world comments may break this rule, so "BeginningOfLine" will not be a real line beginning
                                    // for malformed examples like `/** @param {string} x @returns {number} the length */`
                                    state = 0 /* BeginningOfLine */;
                                    advanceToken = false;
                                    margin = undefined;
                                    indent++;
                                }
                                else {
                                    pushComment(scanner.getTokenText());
                                }
                                break;
                            case 4 /* NewLineTrivia */:
                                comments.push(scanner.getTokenText());
                                state = 0 /* BeginningOfLine */;
                                indent = 0;
                                break;
                            case 38 /* AsteriskToken */:
                                var asterisk = scanner.getTokenText();
                                if (state === 1 /* SawAsterisk */ || state === 2 /* SavingComments */) {
                                    // If we've already seen an asterisk, then we can no longer parse a tag on this line
                                    state = 2 /* SavingComments */;
                                    pushComment(asterisk);
                                }
                                else {
                                    // Ignore the first asterisk on a line
                                    state = 1 /* SawAsterisk */;
                                    indent += asterisk.length;
                                }
                                break;
                            case 70 /* Identifier */:
                                // Anything else is doc comment text. We just save it. Because it
                                // wasn't a tag, we can no longer parse a tag on this line until we hit the next
                                // line break.
                                pushComment(scanner.getTokenText());
                                state = 2 /* SavingComments */;
                                break;
                            case 5 /* WhitespaceTrivia */:
                                // only collect whitespace if we're already saving comments or have just crossed the comment indent margin
                                var whitespace = scanner.getTokenText();
                                if (state === 2 /* SavingComments */) {
                                    comments.push(whitespace);
                                }
                                else if (margin !== undefined && indent + whitespace.length > margin) {
                                    comments.push(whitespace.slice(margin - indent - 1));
                                }
                                indent += whitespace.length;
                                break;
                            case 1 /* EndOfFileToken */:
                                break;
                            default:
                                // anything other than whitespace or asterisk at the beginning of the line starts the comment text
                                state = 2 /* SavingComments */;
                                pushComment(scanner.getTokenText());
                                break;
                        }
                        if (advanceToken) {
                            nextJSDocToken();
                        }
                        else {
                            advanceToken = true;
                        }
                    }
                    removeLeadingNewlines(comments);
                    removeTrailingNewlines(comments);
                    result = createJSDocComment();
                });
                return result;
                function removeLeadingNewlines(comments) {
                    while (comments.length && (comments[0] === "\x5cn" || comments[0] === "\x5cr")) {
                        comments.shift();
                    }
                }
                function removeTrailingNewlines(comments) {
                    while (comments.length && (comments[comments.length - 1] === "\x5cn" || comments[comments.length - 1] === "\x5cr")) {
                        comments.pop();
                    }
                }
                function isJsDocStart(content, start) {
                    return content.charCodeAt(start) === 47 /* slash */ &&
                        content.charCodeAt(start + 1) === 42 /* asterisk */ &&
                        content.charCodeAt(start + 2) === 42 /* asterisk */ &&
                        content.charCodeAt(start + 3) !== 42 /* asterisk */;
                }
                function createJSDocComment() {
                    var result = createNode(278 /* JSDocComment */, start);
                    result.tags = tags;
                    result.comment = comments.length ? comments.join("") : undefined;
                    return finishNode(result, end);
                }
                function skipWhitespace() {
                    while (token() === 5 /* WhitespaceTrivia */ || token() === 4 /* NewLineTrivia */) {
                        nextJSDocToken();
                    }
                }
                function parseTag(indent) {
                    ts.Debug.assert(token() === 56 /* AtToken */);
                    var atToken = createNode(56 /* AtToken */, scanner.getTokenPos());
                    atToken.end = scanner.getTextPos();
                    nextJSDocToken();
                    var tagName = parseJSDocIdentifierName();
                    skipWhitespace();
                    if (!tagName) {
                        return;
                    }
                    var tag;
                    if (tagName) {
                        switch (tagName.text) {
                            case "augments":
                                tag = parseAugmentsTag(atToken, tagName);
                                break;
                            case "param":
                                tag = parseParamTag(atToken, tagName);
                                break;
                            case "return":
                            case "returns":
                                tag = parseReturnTag(atToken, tagName);
                                break;
                            case "template":
                                tag = parseTemplateTag(atToken, tagName);
                                break;
                            case "type":
                                tag = parseTypeTag(atToken, tagName);
                                break;
                            case "typedef":
                                tag = parseTypedefTag(atToken, tagName);
                                break;
                            default:
                                tag = parseUnknownTag(atToken, tagName);
                                break;
                        }
                    }
                    else {
                        tag = parseUnknownTag(atToken, tagName);
                    }
                    if (!tag) {
                        // a badly malformed tag should not be added to the list of tags
                        return;
                    }
                    addTag(tag, parseTagComments(indent + tag.end - tag.pos));
                }
                function parseTagComments(indent) {
                    var comments = [];
                    var state = 0 /* BeginningOfLine */;
                    var margin;
                    function pushComment(text) {
                        if (!margin) {
                            margin = indent;
                        }
                        comments.push(text);
                        indent += text.length;
                    }
                    while (token() !== 56 /* AtToken */ && token() !== 1 /* EndOfFileToken */) {
                        switch (token()) {
                            case 4 /* NewLineTrivia */:
                                if (state >= 1 /* SawAsterisk */) {
                                    state = 0 /* BeginningOfLine */;
                                    comments.push(scanner.getTokenText());
                                }
                                indent = 0;
                                break;
                            case 56 /* AtToken */:
                                // Done
                                break;
                            case 5 /* WhitespaceTrivia */:
                                if (state === 2 /* SavingComments */) {
                                    pushComment(scanner.getTokenText());
                                }
                                else {
                                    var whitespace = scanner.getTokenText();
                                    // if the whitespace crosses the margin, take only the whitespace that passes the margin
                                    if (margin !== undefined && indent + whitespace.length > margin) {
                                        comments.push(whitespace.slice(margin - indent - 1));
                                    }
                                    indent += whitespace.length;
                                }
                                break;
                            case 38 /* AsteriskToken */:
                                if (state === 0 /* BeginningOfLine */) {
                                    // leading asterisks start recording on the *next* (non-whitespace) token
                                    state = 1 /* SawAsterisk */;
                                    indent += scanner.getTokenText().length;
                                    break;
                                }
                            // FALLTHROUGH otherwise to record the * as a comment
                            default:
                                state = 2 /* SavingComments */; // leading identifiers start recording as well
                                pushComment(scanner.getTokenText());
                                break;
                        }
                        if (token() === 56 /* AtToken */) {
                            // Done
                            break;
                        }
                        nextJSDocToken();
                    }
                    removeLeadingNewlines(comments);
                    removeTrailingNewlines(comments);
                    return comments;
                }
                function parseUnknownTag(atToken, tagName) {
                    var result = createNode(279 /* JSDocTag */, atToken.pos);
                    result.atToken = atToken;
                    result.tagName = tagName;
                    return finishNode(result);
                }
                function addTag(tag, comments) {
                    tag.comment = comments.join("");
                    if (!tags) {
                        tags = createNodeArray([tag], tag.pos);
                    }
                    else {
                        tags.push(tag);
                    }
                    tags.end = tag.end;
                }
                function tryParseTypeExpression() {
                    return tryParse(function () {
                        skipWhitespace();
                        if (token() !== 16 /* OpenBraceToken */) {
                            return undefined;
                        }
                        return parseJSDocTypeExpression();
                    });
                }
                function parseParamTag(atToken, tagName) {
                    var typeExpression = tryParseTypeExpression();
                    skipWhitespace();
                    var name;
                    var isBracketed;
                    // Looking for something like '[foo]' or 'foo'
                    if (parseOptionalToken(20 /* OpenBracketToken */)) {
                        name = parseJSDocIdentifierName();
                        skipWhitespace();
                        isBracketed = true;
                        // May have an optional default, e.g. '[foo = 42]'
                        if (parseOptionalToken(57 /* EqualsToken */)) {
                            parseExpression();
                        }
                        parseExpected(21 /* CloseBracketToken */);
                    }
                    else if (ts.tokenIsIdentifierOrKeyword(token())) {
                        name = parseJSDocIdentifierName();
                    }
                    if (!name) {
                        parseErrorAtPosition(scanner.getStartPos(), 0, ts.Diagnostics.Identifier_expected);
                        return undefined;
                    }
                    var preName, postName;
                    if (typeExpression) {
                        postName = name;
                    }
                    else {
                        preName = name;
                    }
                    if (!typeExpression) {
                        typeExpression = tryParseTypeExpression();
                    }
                    var result = createNode(281 /* JSDocParameterTag */, atToken.pos);
                    result.atToken = atToken;
                    result.tagName = tagName;
                    result.preParameterName = preName;
                    result.typeExpression = typeExpression;
                    result.postParameterName = postName;
                    result.parameterName = postName || preName;
                    result.isBracketed = isBracketed;
                    return finishNode(result);
                }
                function parseReturnTag(atToken, tagName) {
                    if (ts.forEach(tags, function (t) { return t.kind === 282 /* JSDocReturnTag */; })) {
                        parseErrorAtPosition(tagName.pos, scanner.getTokenPos() - tagName.pos, ts.Diagnostics._0_tag_already_specified, tagName.text);
                    }
                    var result = createNode(282 /* JSDocReturnTag */, atToken.pos);
                    result.atToken = atToken;
                    result.tagName = tagName;
                    result.typeExpression = tryParseTypeExpression();
                    return finishNode(result);
                }
                function parseTypeTag(atToken, tagName) {
                    if (ts.forEach(tags, function (t) { return t.kind === 283 /* JSDocTypeTag */; })) {
                        parseErrorAtPosition(tagName.pos, scanner.getTokenPos() - tagName.pos, ts.Diagnostics._0_tag_already_specified, tagName.text);
                    }
                    var result = createNode(283 /* JSDocTypeTag */, atToken.pos);
                    result.atToken = atToken;
                    result.tagName = tagName;
                    result.typeExpression = tryParseTypeExpression();
                    return finishNode(result);
                }
                function parsePropertyTag(atToken, tagName) {
                    var typeExpression = tryParseTypeExpression();
                    skipWhitespace();
                    var name = parseJSDocIdentifierName();
                    skipWhitespace();
                    if (!name) {
                        parseErrorAtPosition(scanner.getStartPos(), /*length*/ 0, ts.Diagnostics.Identifier_expected);
                        return undefined;
                    }
                    var result = createNode(286 /* JSDocPropertyTag */, atToken.pos);
                    result.atToken = atToken;
                    result.tagName = tagName;
                    result.name = name;
                    result.typeExpression = typeExpression;
                    return finishNode(result);
                }
                function parseAugmentsTag(atToken, tagName) {
                    var typeExpression = tryParseTypeExpression();
                    var result = createNode(280 /* JSDocAugmentsTag */, atToken.pos);
                    result.atToken = atToken;
                    result.tagName = tagName;
                    result.typeExpression = typeExpression;
                    return finishNode(result);
                }
                function parseTypedefTag(atToken, tagName) {
                    var typeExpression = tryParseTypeExpression();
                    skipWhitespace();
                    var typedefTag = createNode(285 /* JSDocTypedefTag */, atToken.pos);
                    typedefTag.atToken = atToken;
                    typedefTag.tagName = tagName;
                    typedefTag.fullName = parseJSDocTypeNameWithNamespace(/*flags*/ 0);
                    if (typedefTag.fullName) {
                        var rightNode = typedefTag.fullName;
                        while (rightNode.kind !== 70 /* Identifier */) {
                            rightNode = rightNode.body;
                        }
                        typedefTag.name = rightNode;
                    }
                    typedefTag.typeExpression = typeExpression;
                    skipWhitespace();
                    if (typeExpression) {
                        if (typeExpression.type.kind === 272 /* JSDocTypeReference */) {
                            var jsDocTypeReference = typeExpression.type;
                            if (jsDocTypeReference.name.kind === 70 /* Identifier */) {
                                var name_14 = jsDocTypeReference.name;
                                if (name_14.text === "Object") {
                                    typedefTag.jsDocTypeLiteral = scanChildTags();
                                }
                            }
                        }
                        if (!typedefTag.jsDocTypeLiteral) {
                            typedefTag.jsDocTypeLiteral = typeExpression.type;
                        }
                    }
                    else {
                        typedefTag.jsDocTypeLiteral = scanChildTags();
                    }
                    return finishNode(typedefTag);
                    function scanChildTags() {
                        var jsDocTypeLiteral = createNode(287 /* JSDocTypeLiteral */, scanner.getStartPos());
                        var resumePos = scanner.getStartPos();
                        var canParseTag = true;
                        var seenAsterisk = false;
                        var parentTagTerminated = false;
                        while (token() !== 1 /* EndOfFileToken */ && !parentTagTerminated) {
                            nextJSDocToken();
                            switch (token()) {
                                case 56 /* AtToken */:
                                    if (canParseTag) {
                                        parentTagTerminated = !tryParseChildTag(jsDocTypeLiteral);
                                        if (!parentTagTerminated) {
                                            resumePos = scanner.getStartPos();
                                        }
                                    }
                                    seenAsterisk = false;
                                    break;
                                case 4 /* NewLineTrivia */:
                                    resumePos = scanner.getStartPos() - 1;
                                    canParseTag = true;
                                    seenAsterisk = false;
                                    break;
                                case 38 /* AsteriskToken */:
                                    if (seenAsterisk) {
                                        canParseTag = false;
                                    }
                                    seenAsterisk = true;
                                    break;
                                case 70 /* Identifier */:
                                    canParseTag = false;
                                case 1 /* EndOfFileToken */:
                                    break;
                            }
                        }
                        scanner.setTextPos(resumePos);
                        return finishNode(jsDocTypeLiteral);
                    }
                    function parseJSDocTypeNameWithNamespace(flags) {
                        var pos = scanner.getTokenPos();
                        var typeNameOrNamespaceName = parseJSDocIdentifierName();
                        if (typeNameOrNamespaceName && parseOptional(22 /* DotToken */)) {
                            var jsDocNamespaceNode = createNode(230 /* ModuleDeclaration */, pos);
                            jsDocNamespaceNode.flags |= flags;
                            jsDocNamespaceNode.name = typeNameOrNamespaceName;
                            jsDocNamespaceNode.body = parseJSDocTypeNameWithNamespace(4 /* NestedNamespace */);
                            return jsDocNamespaceNode;
                        }
                        if (typeNameOrNamespaceName && flags & 4 /* NestedNamespace */) {
                            typeNameOrNamespaceName.isInJSDocNamespace = true;
                        }
                        return typeNameOrNamespaceName;
                    }
                }
                function tryParseChildTag(parentTag) {
                    ts.Debug.assert(token() === 56 /* AtToken */);
                    var atToken = createNode(56 /* AtToken */, scanner.getStartPos());
                    atToken.end = scanner.getTextPos();
                    nextJSDocToken();
                    var tagName = parseJSDocIdentifierName();
                    skipWhitespace();
                    if (!tagName) {
                        return false;
                    }
                    switch (tagName.text) {
                        case "type":
                            if (parentTag.jsDocTypeTag) {
                                // already has a @type tag, terminate the parent tag now.
                                return false;
                            }
                            parentTag.jsDocTypeTag = parseTypeTag(atToken, tagName);
                            return true;
                        case "prop":
                        case "property":
                            var propertyTag = parsePropertyTag(atToken, tagName);
                            if (propertyTag) {
                                if (!parentTag.jsDocPropertyTags) {
                                    parentTag.jsDocPropertyTags = [];
                                }
                                parentTag.jsDocPropertyTags.push(propertyTag);
                                return true;
                            }
                            // Error parsing property tag
                            return false;
                    }
                    return false;
                }
                function parseTemplateTag(atToken, tagName) {
                    if (ts.forEach(tags, function (t) { return t.kind === 284 /* JSDocTemplateTag */; })) {
                        parseErrorAtPosition(tagName.pos, scanner.getTokenPos() - tagName.pos, ts.Diagnostics._0_tag_already_specified, tagName.text);
                    }
                    // Type parameter list looks like '@template T,U,V'
                    var typeParameters = createNodeArray();
                    while (true) {
                        var name_15 = parseJSDocIdentifierName();
                        skipWhitespace();
                        if (!name_15) {
                            parseErrorAtPosition(scanner.getStartPos(), 0, ts.Diagnostics.Identifier_expected);
                            return undefined;
                        }
                        var typeParameter = createNode(143 /* TypeParameter */, name_15.pos);
                        typeParameter.name = name_15;
                        finishNode(typeParameter);
                        typeParameters.push(typeParameter);
                        if (token() === 25 /* CommaToken */) {
                            nextJSDocToken();
                            skipWhitespace();
                        }
                        else {
                            break;
                        }
                    }
                    var result = createNode(284 /* JSDocTemplateTag */, atToken.pos);
                    result.atToken = atToken;
                    result.tagName = tagName;
                    result.typeParameters = typeParameters;
                    finishNode(result);
                    typeParameters.end = result.end;
                    return result;
                }
                function nextJSDocToken() {
                    return currentToken = scanner.scanJSDocToken();
                }
                function parseJSDocIdentifierName() {
                    return createJSDocIdentifier(ts.tokenIsIdentifierOrKeyword(token()));
                }
                function createJSDocIdentifier(isIdentifier) {
                    if (!isIdentifier) {
                        parseErrorAtCurrentToken(ts.Diagnostics.Identifier_expected);
                        return undefined;
                    }
                    var pos = scanner.getTokenPos();
                    var end = scanner.getTextPos();
                    var result = createNode(70 /* Identifier */, pos);
                    result.text = content.substring(pos, end);
                    finishNode(result, end);
                    nextJSDocToken();
                    return result;
                }
            }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseParameter) id{167,0} ---
() {
            var node = createNode(144 /* Parameter */);
            if (token() === 98 /* ThisKeyword */) {
                node.name = createIdentifier(/*isIdentifier*/ true, undefined);
                node.type = parseParameterType();
                return finishNode(node);
            }
            node.decorators = parseDecorators();
            node.modifiers = parseModifiers();
            node.dotDotDotToken = parseOptionalToken(23 /* DotDotDotToken */);
            // FormalParameter [Yield,Await]:
            //      BindingElement[?Yield,?Await]
            node.name = parseIdentifierOrPattern();
            if (ts.getFullWidth(node.name) === 0 && !ts.hasModifiers(node) && ts.isModifierKind(token())) {
                // in cases like
                // 'use strict'
                // function foo(static)
                // isParameter('static') === true, because of isModifier('static')
                // however 'static' is not a legal identifier in a strict mode.
                // so result of this function will be ParameterDeclaration (flags = 0, name = missing, type = undefined, initializer = undefined)
                // and current token will not change => parsing of the enclosing parameter list will last till the end of time (or OOM)
                // to avoid this we'll advance cursor to the next token.
                nextToken();
            }
            node.questionToken = parseOptionalToken(54 /* QuestionToken */);
            node.type = parseParameterType();
            node.initializer = parseBindingElementInitializer(/*inParameter*/ true);
            // Do not check for initializers in an ambient context for parameters. This is not
            // a grammar error because the grammar allows arbitrary call signatures in
            // an ambient context.
            // It is actually not necessary for this to be an error at all. The reason is that
            // function/constructor implementations are syntactically disallowed in ambient
            // contexts. In addition, parameter initializers are semantically disallowed in
            // overload signatures. So parameter initializers are transitively disallowed in
            // ambient contexts.
            return addJSDocComment(finishNode(node));
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{167,1} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{167,1} AS 1 AT <0:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{167,2} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{167,2} AS 2 AT <1:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{167,3} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{167,3} AS 3 AT <1:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{167,4} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{167,4} AS 4 AT <1:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{167,5} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{167,5} AS 5 AT <0:77>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseParameterType) id{167,6} ---
() {
            if (parseOptional(55 /* ColonToken */)) {
                return parseType();
            }
            return undefined;
        }
--- END ---
INLINE (parseParameterType) id{167,6} AS 6 AT <0:221>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseOptional) id{167,7} ---
(t) {
            if (token() === t) {
                nextToken();
                return true;
            }
            return false;
        }
--- END ---
INLINE (parseOptional) id{167,7} AS 7 AT <6:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{167,8} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{167,8} AS 8 AT <7:22>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{167,9} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{167,9} AS 9 AT <7:55>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseType) id{167,10} ---
() {
            // The rules about 'yield' only apply to actual code/expression contexts.  They don't
            // apply to 'type' contexts.  So we disable these parameters here before moving on.
            return doOutsideOfContext(20480 /* TypeExcludesFlags */, parseTypeWorker);
        }
--- END ---
INLINE (parseType) id{167,10} AS 10 AT <6:82>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseOptionalToken) id{167,11} ---
(t) {
            if (token() === t) {
                return parseTokenNode();
            }
            return undefined;
        }
--- END ---
INLINE (parseOptionalToken) id{167,11} AS 11 AT <0:428>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{167,12} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{167,12} AS 12 AT <11:22>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseTokenNode) id{167,13} ---
() {
            var node = createNode(token());
            nextToken();
            return finishNode(node);
        }
--- END ---
INLINE (parseTokenNode) id{167,13} AS 13 AT <11:62>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{167,14} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{167,14} AS 14 AT <13:39>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{167,15} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{167,15} AS 15 AT <13:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{167,16} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{167,16} AS 16 AT <15:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{167,17} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{167,17} AS 17 AT <15:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{167,18} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{167,18} AS 18 AT <15:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{167,19} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{167,19} AS 19 AT <13:61>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseIdentifierOrPattern) id{167,20} ---
() {
            if (token() === 20 /* OpenBracketToken */) {
                return parseArrayBindingPattern();
            }
            if (token() === 16 /* OpenBraceToken */) {
                return parseObjectBindingPattern();
            }
            return parseIdentifier();
        }
--- END ---
INLINE (parseIdentifierOrPattern) id{167,20} AS 20 AT <0:593>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{167,21} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{167,21} AS 21 AT <20:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{167,22} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{167,22} AS 22 AT <20:143>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseIdentifier) id{167,23} ---
(diagnosticMessage) {
            return createIdentifier(isIdentifier(), diagnosticMessage);
        }
--- END ---
INLINE (parseIdentifier) id{167,23} AS 23 AT <20:267>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseOptionalToken) id{167,24} ---
(t) {
            if (token() === t) {
                return parseTokenNode();
            }
            return undefined;
        }
--- END ---
INLINE (parseOptionalToken) id{167,24} AS 24 AT <0:1428>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{167,25} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{167,25} AS 25 AT <24:22>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseTokenNode) id{167,26} ---
() {
            var node = createNode(token());
            nextToken();
            return finishNode(node);
        }
--- END ---
INLINE (parseTokenNode) id{167,26} AS 26 AT <24:62>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{167,27} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{167,27} AS 27 AT <26:39>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{167,28} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{167,28} AS 28 AT <26:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{167,29} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{167,29} AS 29 AT <28:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{167,30} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{167,30} AS 30 AT <28:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{167,31} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{167,31} AS 31 AT <28:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:removeTrailingNewlines) id{168,0} ---
(comments) {
                    while (comments.length && (comments[comments.length - 1] === "\x5cn" || comments[comments.length - 1] === "\x5cr")) {
                        comments.pop();
                    }
                }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseTag) id{169,0} ---
(indent) {
                    ts.Debug.assert(token() === 56 /* AtToken */);
                    var atToken = createNode(56 /* AtToken */, scanner.getTokenPos());
                    atToken.end = scanner.getTextPos();
                    nextJSDocToken();
                    var tagName = parseJSDocIdentifierName();
                    skipWhitespace();
                    if (!tagName) {
                        return;
                    }
                    var tag;
                    if (tagName) {
                        switch (tagName.text) {
                            case "augments":
                                tag = parseAugmentsTag(atToken, tagName);
                                break;
                            case "param":
                                tag = parseParamTag(atToken, tagName);
                                break;
                            case "return":
                            case "returns":
                                tag = parseReturnTag(atToken, tagName);
                                break;
                            case "template":
                                tag = parseTemplateTag(atToken, tagName);
                                break;
                            case "type":
                                tag = parseTypeTag(atToken, tagName);
                                break;
                            case "typedef":
                                tag = parseTypedefTag(atToken, tagName);
                                break;
                            default:
                                tag = parseUnknownTag(atToken, tagName);
                                break;
                        }
                    }
                    else {
                        tag = parseUnknownTag(atToken, tagName);
                    }
                    if (!tag) {
                        // a badly malformed tag should not be added to the list of tags
                        return;
                    }
                    addTag(tag, parseTagComments(indent + tag.end - tag.pos));
                }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{169,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{169,1} AS 1 AT <0:47>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{169,2} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{169,2} AS 2 AT <0:112>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{169,3} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{169,3} AS 3 AT <2:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{169,4} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{169,4} AS 4 AT <2:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{169,5} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{169,5} AS 5 AT <2:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:addTag) id{170,0} ---
(tag, comments) {
                    tag.comment = comments.join("");
                    if (!tags) {
                        tags = createNodeArray([tag], tag.pos);
                    }
                    else {
                        tags.push(tag);
                    }
                    tags.end = tag.end;
                }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNodeArray) id{170,1} ---
(elements, pos) {
            var array = (elements || []);
            if (!(pos >= 0)) {
                pos = getNodePos();
            }
            array.pos = pos;
            array.end = pos;
            return array;
        }
--- END ---
INLINE (createNodeArray) id{170,1} AS 1 AT <0:135>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodePos) id{170,2} ---
() {
            return scanner.getStartPos();
        }
--- END ---
INLINE (getNodePos) id{170,2} AS 2 AT <1:113>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:skipWhitespace) id{171,0} ---
() {
                    while (token() === 5 /* WhitespaceTrivia */ || token() === 4 /* NewLineTrivia */) {
                        nextJSDocToken();
                    }
                }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{171,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{171,1} AS 1 AT <0:32>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{171,2} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{171,2} AS 2 AT <0:72>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:speculationHelper) id{172,0} ---
(callback, isLookahead) {
            var savePos = pos;
            var saveStartPos = startPos;
            var saveTokenPos = tokenPos;
            var saveToken = token;
            var saveTokenValue = tokenValue;
            var savePrecedingLineBreak = precedingLineBreak;
            var result = callback();
            // If our callback returned something 'falsy' or we're just looking ahead,
            // then unconditionally restore us to where we were.
            if (!result || isLookahead) {
                pos = savePos;
                startPos = saveStartPos;
                tokenPos = saveTokenPos;
                token = saveToken;
                tokenValue = saveTokenValue;
                precedingLineBreak = savePrecedingLineBreak;
            }
            return result;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseParamTag) id{173,0} ---
(atToken, tagName) {
                    var typeExpression = tryParseTypeExpression();
                    skipWhitespace();
                    var name;
                    var isBracketed;
                    // Looking for something like '[foo]' or 'foo'
                    if (parseOptionalToken(20 /* OpenBracketToken */)) {
                        name = parseJSDocIdentifierName();
                        skipWhitespace();
                        isBracketed = true;
                        // May have an optional default, e.g. '[foo = 42]'
                        if (parseOptionalToken(57 /* EqualsToken */)) {
                            parseExpression();
                        }
                        parseExpected(21 /* CloseBracketToken */);
                    }
                    else if (ts.tokenIsIdentifierOrKeyword(token())) {
                        name = parseJSDocIdentifierName();
                    }
                    if (!name) {
                        parseErrorAtPosition(scanner.getStartPos(), 0, ts.Diagnostics.Identifier_expected);
                        return undefined;
                    }
                    var preName, postName;
                    if (typeExpression) {
                        postName = name;
                    }
                    else {
                        preName = name;
                    }
                    if (!typeExpression) {
                        typeExpression = tryParseTypeExpression();
                    }
                    var result = createNode(281 /* JSDocParameterTag */, atToken.pos);
                    result.atToken = atToken;
                    result.tagName = tagName;
                    result.preParameterName = preName;
                    result.typeExpression = typeExpression;
                    result.postParameterName = postName;
                    result.parameterName = postName || preName;
                    result.isBracketed = isBracketed;
                    return finishNode(result);
                }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseOptionalToken) id{173,1} ---
(t) {
            if (token() === t) {
                return parseTokenNode();
            }
            return undefined;
        }
--- END ---
INLINE (parseOptionalToken) id{173,1} AS 1 AT <0:284>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{173,2} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{173,2} AS 2 AT <1:22>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseTokenNode) id{173,3} ---
() {
            var node = createNode(token());
            nextToken();
            return finishNode(node);
        }
--- END ---
INLINE (parseTokenNode) id{173,3} AS 3 AT <1:62>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{173,4} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{173,4} AS 4 AT <3:39>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{173,5} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{173,5} AS 5 AT <3:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{173,6} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{173,6} AS 6 AT <5:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{173,7} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{173,7} AS 7 AT <5:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{173,8} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{173,8} AS 8 AT <5:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{173,9} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{173,9} AS 9 AT <3:61>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{173,10} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{173,10} AS 10 AT <0:846>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{173,11} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{173,11} AS 11 AT <0:1546>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{173,12} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{173,12} AS 12 AT <11:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{173,13} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{173,13} AS 13 AT <11:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{173,14} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{173,14} AS 14 AT <11:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isStartOfType) id{174,0} ---
() {
            switch (token()) {
                case 118 /* AnyKeyword */:
                case 134 /* StringKeyword */:
                case 132 /* NumberKeyword */:
                case 121 /* BooleanKeyword */:
                case 135 /* SymbolKeyword */:
                case 104 /* VoidKeyword */:
                case 137 /* UndefinedKeyword */:
                case 94 /* NullKeyword */:
                case 98 /* ThisKeyword */:
                case 102 /* TypeOfKeyword */:
                case 129 /* NeverKeyword */:
                case 16 /* OpenBraceToken */:
                case 20 /* OpenBracketToken */:
                case 26 /* LessThanToken */:
                case 48 /* BarToken */:
                case 47 /* AmpersandToken */:
                case 93 /* NewKeyword */:
                case 9 /* StringLiteral */:
                case 8 /* NumericLiteral */:
                case 100 /* TrueKeyword */:
                case 85 /* FalseKeyword */:
                    return true;
                case 37 /* MinusToken */:
                    return lookAhead(nextTokenIsNumericLiteral);
                case 18 /* OpenParenToken */:
                    // Only consider '(' the start of a type if followed by ')', '...', an identifier, a modifier,
                    // or something that starts a type. We don't want to consider things like '(1)' a type.
                    return lookAhead(isStartOfParenthesizedOrFunctionType);
                default:
                    return isIdentifier();
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{174,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{174,1} AS 1 AT <0:25>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseList) id{175,0} ---
(kind, parseElement) {
            var saveParsingContext = parsingContext;
            parsingContext |= 1 << kind;
            var result = createNodeArray();
            while (!isListTerminator(kind)) {
                if (isListElement(kind, /*inErrorRecovery*/ false)) {
                    var element = parseListElement(kind, parseElement);
                    result.push(element);
                    continue;
                }
                if (abortParsingListOrMoveToNextToken(kind)) {
                    break;
                }
            }
            result.end = getNodeEnd();
            parsingContext = saveParsingContext;
            return result;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNodeArray) id{175,1} ---
(elements, pos) {
            var array = (elements || []);
            if (!(pos >= 0)) {
                pos = getNodePos();
            }
            array.pos = pos;
            array.end = pos;
            return array;
        }
--- END ---
INLINE (createNodeArray) id{175,1} AS 1 AT <0:142>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodePos) id{175,2} ---
() {
            return scanner.getStartPos();
        }
--- END ---
INLINE (getNodePos) id{175,2} AS 2 AT <1:113>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseListElement) id{175,3} ---
(parsingContext, parseElement) {
            var node = currentNode(parsingContext);
            if (node) {
                return consumeNode(node);
            }
            return parseElement();
        }
--- END ---
INLINE (parseListElement) id{175,3} AS 3 AT <0:311>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeEnd) id{175,4} ---
() {
            return scanner.getStartPos();
        }
--- END ---
INLINE (getNodeEnd) id{175,4} AS 4 AT <0:586>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseExpressionWithTypeArguments) id{176,0} ---
() {
            var node = createNode(199 /* ExpressionWithTypeArguments */);
            node.expression = parseLeftHandSideExpressionOrHigher();
            if (token() === 26 /* LessThanToken */) {
                node.typeArguments = parseBracketedList(19 /* TypeArguments */, parseType, 26 /* LessThanToken */, 28 /* GreaterThanToken */);
            }
            return finishNode(node);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{176,1} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{176,1} AS 1 AT <0:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{176,2} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{176,2} AS 2 AT <1:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{176,3} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{176,3} AS 3 AT <1:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{176,4} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{176,4} AS 4 AT <1:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{176,5} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{176,5} AS 5 AT <0:164>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseBracketedList) id{176,6} ---
(kind, parseElement, open, close) {
            if (parseExpected(open)) {
                var result = parseDelimitedList(kind, parseElement);
                parseExpected(close);
                return result;
            }
            return createMissingList();
        }
--- END ---
INLINE (parseBracketedList) id{176,6} AS 6 AT <0:239>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseHeritageClause) id{177,0} ---
() {
            if (token() === 84 /* ExtendsKeyword */ || token() === 107 /* ImplementsKeyword */) {
                var node = createNode(255 /* HeritageClause */);
                node.token = token();
                nextToken();
                node.types = parseDelimitedList(7 /* HeritageClauseElement */, parseExpressionWithTypeArguments);
                return finishNode(node);
            }
            return undefined;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{177,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{177,1} AS 1 AT <0:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{177,2} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{177,2} AS 2 AT <0:60>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{177,3} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{177,3} AS 3 AT <0:130>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{177,4} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{177,4} AS 4 AT <3:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{177,5} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{177,5} AS 5 AT <3:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{177,6} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{177,6} AS 6 AT <3:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{177,7} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{177,7} AS 7 AT <0:197>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{177,8} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{177,8} AS 8 AT <0:222>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:skipParameterStart) id{178,0} ---
() {
            if (ts.isModifierKind(token())) {
                // Skip modifiers
                parseModifiers();
            }
            if (isIdentifier() || token() === 98 /* ThisKeyword */) {
                nextToken();
                return true;
            }
            if (token() === 20 /* OpenBracketToken */ || token() === 16 /* OpenBraceToken */) {
                // Return true if we can parse an array or object binding pattern with no errors
                var previousErrorCount = parseDiagnostics.length;
                parseIdentifierOrPattern();
                return previousErrorCount === parseDiagnostics.length;
            }
            return false;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{178,1} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{178,1} AS 1 AT <0:39>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{178,2} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{178,2} AS 2 AT <0:167>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{178,3} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{178,3} AS 3 AT <0:219>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{178,4} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{178,4} AS 4 AT <0:291>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{178,5} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{178,5} AS 5 AT <0:332>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseMemberExpressionRest) id{179,0} ---
(expression) {
            while (true) {
                var dotToken = parseOptionalToken(22 /* DotToken */);
                if (dotToken) {
                    var propertyAccess = createNode(177 /* PropertyAccessExpression */, expression.pos);
                    propertyAccess.expression = expression;
                    propertyAccess.name = parseRightSideOfDot(/*allowIdentifierNames*/ true);
                    expression = finishNode(propertyAccess);
                    continue;
                }
                if (token() === 50 /* ExclamationToken */ && !scanner.hasPrecedingLineBreak()) {
                    nextToken();
                    var nonNullExpression = createNode(201 /* NonNullExpression */, expression.pos);
                    nonNullExpression.expression = expression;
                    expression = finishNode(nonNullExpression);
                    continue;
                }
                // when in the [Decorator] context, we do not parse ElementAccess as it could be part of a ComputedPropertyName
                if (!inDecoratorContext() && parseOptional(20 /* OpenBracketToken */)) {
                    var indexedAccess = createNode(178 /* ElementAccessExpression */, expression.pos);
                    indexedAccess.expression = expression;
                    // It's not uncommon for a user to write: "new Type[]".
                    // Check for that common pattern and report a better error message.
                    if (token() !== 21 /* CloseBracketToken */) {
                        indexedAccess.argumentExpression = allowInAnd(parseExpression);
                        if (indexedAccess.argumentExpression.kind === 9 /* StringLiteral */ || indexedAccess.argumentExpression.kind === 8 /* NumericLiteral */) {
                            var literal = indexedAccess.argumentExpression;
                            literal.text = internIdentifier(literal.text);
                        }
                    }
                    parseExpected(21 /* CloseBracketToken */);
                    expression = finishNode(indexedAccess);
                    continue;
                }
                if (token() === 12 /* NoSubstitutionTemplateLiteral */ || token() === 13 /* TemplateHead */) {
                    var tagExpression = createNode(181 /* TaggedTemplateExpression */, expression.pos);
                    tagExpression.tag = expression;
                    tagExpression.template = token() === 12 /* NoSubstitutionTemplateLiteral */
                        ? parseLiteralNode()
                        : parseTemplateExpression();
                    expression = finishNode(tagExpression);
                    continue;
                }
                return expression;
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseOptionalToken) id{179,1} ---
(t) {
            if (token() === t) {
                return parseTokenNode();
            }
            return undefined;
        }
--- END ---
INLINE (parseOptionalToken) id{179,1} AS 1 AT <0:73>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{179,2} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{179,2} AS 2 AT <1:22>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseTokenNode) id{179,3} ---
() {
            var node = createNode(token());
            nextToken();
            return finishNode(node);
        }
--- END ---
INLINE (parseTokenNode) id{179,3} AS 3 AT <1:62>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{179,4} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{179,4} AS 4 AT <3:39>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{179,5} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{179,5} AS 5 AT <3:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{179,6} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{179,6} AS 6 AT <5:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{179,7} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{179,7} AS 7 AT <5:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{179,8} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{179,8} AS 8 AT <5:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{179,9} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{179,9} AS 9 AT <3:61>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{179,10} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{179,10} AS 10 AT <0:185>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{179,11} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{179,11} AS 11 AT <10:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{179,12} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{179,12} AS 12 AT <10:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{179,13} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{179,13} AS 13 AT <10:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{179,14} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{179,14} AS 14 AT <0:532>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:inDecoratorContext) id{179,15} ---
() {
            return inContext(8192 /* DecoratorContext */);
        }
--- END ---
INLINE (inDecoratorContext) id{179,15} AS 15 AT <0:1067>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:inContext) id{179,16} ---
(flags) {
            return (contextFlags & flags) !== 0;
        }
--- END ---
INLINE (inContext) id{179,16} AS 16 AT <15:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseOptional) id{179,17} ---
(t) {
            if (token() === t) {
                nextToken();
                return true;
            }
            return false;
        }
--- END ---
INLINE (parseOptional) id{179,17} AS 17 AT <0:1091>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{179,18} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{179,18} AS 18 AT <17:22>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{179,19} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{179,19} AS 19 AT <17:55>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{179,20} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{179,20} AS 20 AT <0:2168>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{179,21} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{179,21} AS 21 AT <0:2222>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:addJSDocComment) id{180,0} ---
(node) {
            var comments = ts.getJSDocCommentRanges(node, sourceFile.text);
            if (comments) {
                for (var _i = 0, comments_2 = comments; _i < comments_2.length; _i++) {
                    var comment = comments_2[_i];
                    var jsDoc = JSDocParser.parseJSDocComment(node, comment.pos, comment.end - comment.pos);
                    if (!jsDoc) {
                        continue;
                    }
                    if (!node.jsDoc) {
                        node.jsDoc = [];
                    }
                    node.jsDoc.push(jsDoc);
                }
            }
            return node;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:filter) id{181,0} ---
(array, f) {
        if (array) {
            var len = array.length;
            var i = 0;
            while (i < len && f(array[i]))
                i++;
            if (i < len) {
                var result = array.slice(0, i);
                i++;
                while (i < len) {
                    var item = array[i];
                    if (f(item)) {
                        result.push(item);
                    }
                    i++;
                }
                return result;
            }
        }
        return array;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseArrayTypeOrHigher) id{182,0} ---
() {
            var type = parseNonArrayType();
            while (!scanner.hasPrecedingLineBreak() && parseOptional(20 /* OpenBracketToken */)) {
                if (isStartOfType()) {
                    var node = createNode(169 /* IndexedAccessType */, type.pos);
                    node.objectType = type;
                    node.indexType = parseType();
                    parseExpected(21 /* CloseBracketToken */);
                    type = finishNode(node);
                }
                else {
                    var node = createNode(162 /* ArrayType */, type.pos);
                    node.elementType = type;
                    parseExpected(21 /* CloseBracketToken */);
                    type = finishNode(node);
                }
            }
            return type;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseOptional) id{182,1} ---
(t) {
            if (token() === t) {
                nextToken();
                return true;
            }
            return false;
        }
--- END ---
INLINE (parseOptional) id{182,1} AS 1 AT <0:104>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{182,2} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{182,2} AS 2 AT <1:22>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{182,3} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{182,3} AS 3 AT <1:55>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{182,4} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{182,4} AS 4 AT <0:218>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{182,5} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{182,5} AS 5 AT <4:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{182,6} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{182,6} AS 6 AT <4:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{182,7} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{182,7} AS 7 AT <4:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseType) id{182,8} ---
() {
            // The rules about 'yield' only apply to actual code/expression contexts.  They don't
            // apply to 'type' contexts.  So we disable these parameters here before moving on.
            return doOutsideOfContext(20480 /* TypeExcludesFlags */, parseTypeWorker);
        }
--- END ---
INLINE (parseType) id{182,8} AS 8 AT <0:350>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{182,9} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{182,9} AS 9 AT <0:543>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{182,10} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{182,10} AS 10 AT <9:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{182,11} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{182,11} AS 11 AT <9:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{182,12} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{182,12} AS 12 AT <9:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isStartOfMappedType) id{183,0} ---
() {
            nextToken();
            if (token() === 130 /* ReadonlyKeyword */) {
                nextToken();
            }
            return token() === 20 /* OpenBracketToken */ && nextTokenIsIdentifier() && nextToken() === 91 /* InKeyword */;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{183,1} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{183,1} AS 1 AT <0:17>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{183,2} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{183,2} AS 2 AT <0:46>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{183,3} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{183,3} AS 3 AT <0:103>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{183,4} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{183,4} AS 4 AT <0:149>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextTokenIsIdentifier) id{183,5} ---
() {
            nextToken();
            return isIdentifier();
        }
--- END ---
INLINE (nextTokenIsIdentifier) id{183,5} AS 5 AT <0:190>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{183,6} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{183,6} AS 6 AT <5:17>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{183,7} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{183,7} AS 7 AT <0:217>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseTypeLiteral) id{184,0} ---
() {
            var node = createNode(161 /* TypeLiteral */);
            node.members = parseObjectTypeMembers();
            return finishNode(node);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{184,1} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{184,1} AS 1 AT <0:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{184,2} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{184,2} AS 2 AT <1:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{184,3} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{184,3} AS 3 AT <1:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{184,4} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{184,4} AS 4 AT <1:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseObjectTypeMembers) id{184,5} ---
() {
            var members;
            if (parseExpected(16 /* OpenBraceToken */)) {
                members = parseList(4 /* TypeMembers */, parseTypeMember);
                parseExpected(17 /* CloseBraceToken */);
            }
            else {
                members = createMissingList();
            }
            return members;
        }
--- END ---
INLINE (parseObjectTypeMembers) id{184,5} AS 5 AT <0:90>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isStartOfConstructSignature) id{185,0} ---
() {
            nextToken();
            return token() === 18 /* OpenParenToken */ || token() === 26 /* LessThanToken */;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{185,1} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{185,1} AS 1 AT <0:17>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{185,2} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{185,2} AS 2 AT <0:49>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{185,3} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{185,3} AS 3 AT <0:88>
[deoptimizing (DEOPT eager): begin 0xd6230db2909 <JS Function parseIncrementExpression (SharedFunctionInfo 0x3504a53f9731)> (opt #143) @3, FP to SP delta: 64, caller sp: 0x7fff5fbfd330]
            ;;; deoptimize at 0_397: wrong map
  reading input frame parseIncrementExpression => node=16, args=1, height=3; inputs:
      0: 0xd6230db2909 ; [fp - 16] 0xd6230db2909 <JS Function parseIncrementExpression (SharedFunctionInfo 0x3504a53f9731)>
      1: 0x1f9f6c0532e1 ; [fp + 16] 0x1f9f6c0532e1 <JS Global Object>
      2: 0xd6230d980d1 ; rax 0xd6230d980d1 <FixedArray[334]>
      3: 0x30bcea404311 ; (literal 3) 0x30bcea404311 <undefined>
      4: 0x30bcea404311 ; (literal 3) 0x30bcea404311 <undefined>
  translating frame parseIncrementExpression => node=16, height=16
    0x7fff5fbfd328: [top + 48] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd320: [top + 40] <- 0x2c21d24d661e ;  caller's pc
    0x7fff5fbfd318: [top + 32] <- 0x7fff5fbfd348 ;  caller's fp
    0x7fff5fbfd310: [top + 24] <- 0xd6230d980d1 ;  context    0xd6230d980d1 <FixedArray[334]>  (input #2)
    0x7fff5fbfd308: [top + 16] <- 0xd6230db2909 ;  function    0xd6230db2909 <JS Function parseIncrementExpression (SharedFunctionInfo 0x3504a53f9731)>  (input #0)
    0x7fff5fbfd300: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #3)
    0x7fff5fbfd2f8: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
[deoptimizing (eager): end 0xd6230db2909 <JS Function parseIncrementExpression (SharedFunctionInfo 0x3504a53f9731)> @3 => node=16, pc=0x2c21d244db54, caller sp=0x7fff5fbfd330, state=NO_REGISTERS, took 0.058 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseTypeParameter) id{186,0} ---
() {
            var node = createNode(143 /* TypeParameter */);
            node.name = parseIdentifier();
            if (parseOptional(84 /* ExtendsKeyword */)) {
                // It's not uncommon for people to write improper constraints to a generic.  If the
                // user writes a constraint that is an expression and not an actual type, then parse
                // it out as an expression (so we can recover well), but report that a type is needed
                // instead.
                if (isStartOfType() || !isStartOfExpression()) {
                    node.constraint = parseType();
                }
                else {
                    // It was not a type, and it looked like an expression.  Parse out an expression
                    // here so we recover well.  Note: it is important that we call parseUnaryExpression
                    // and not parseExpression here.  If the user has:
                    //
                    //      <T extends "">
                    //
                    // We do *not* want to consume the  >  as we're consuming the expression for "".
                    node.expression = parseUnaryExpressionOrHigher();
                }
            }
            return finishNode(node);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{186,1} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{186,1} AS 1 AT <0:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{186,2} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{186,2} AS 2 AT <1:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{186,3} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{186,3} AS 3 AT <1:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{186,4} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{186,4} AS 4 AT <1:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseIdentifier) id{186,5} ---
(diagnosticMessage) {
            return createIdentifier(isIdentifier(), diagnosticMessage);
        }
--- END ---
INLINE (parseIdentifier) id{186,5} AS 5 AT <0:89>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseOptional) id{186,6} ---
(t) {
            if (token() === t) {
                nextToken();
                return true;
            }
            return false;
        }
--- END ---
INLINE (parseOptional) id{186,6} AS 6 AT <0:124>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{186,7} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{186,7} AS 7 AT <6:22>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{186,8} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{186,8} AS 8 AT <6:55>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseType) id{186,9} ---
() {
            // The rules about 'yield' only apply to actual code/expression contexts.  They don't
            // apply to 'type' contexts.  So we disable these parameters here before moving on.
            return doOutsideOfContext(20480 /* TypeExcludesFlags */, parseTypeWorker);
        }
--- END ---
INLINE (parseType) id{186,9} AS 9 AT <0:600>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseLiteralLikeNode) id{187,0} ---
(kind, internName) {
            var node = createNode(kind);
            var text = scanner.getTokenValue();
            node.text = internName ? internIdentifier(text) : text;
            if (scanner.hasExtendedUnicodeEscape()) {
                node.hasExtendedUnicodeEscape = true;
            }
            if (scanner.isUnterminated()) {
                node.isUnterminated = true;
            }
            var tokenPos = scanner.getTokenPos();
            nextToken();
            finishNode(node);
            // Octal literals are not allowed in strict mode or ES5
            // Note that theoretically the following condition would hold true literals like 009,
            // which is not octal.But because of how the scanner separates the tokens, we would
            // never get a token like this. Instead, we would get 00 and 9 as two separate tokens.
            // We also do not need to check for negatives because any prefix operator would be part of a
            // parent unary expression.
            if (node.kind === 8 /* NumericLiteral */
                && sourceText.charCodeAt(tokenPos) === 48 /* _0 */
                && ts.isOctalDigit(sourceText.charCodeAt(tokenPos + 1))) {
                node.isOctalLiteral = true;
            }
            return node;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{187,1} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{187,1} AS 1 AT <0:44>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{187,2} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{187,2} AS 2 AT <1:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{187,3} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{187,3} AS 3 AT <1:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{187,4} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{187,4} AS 4 AT <1:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:internIdentifier) id{187,5} ---
(text) {
            text = ts.escapeIdentifier(text);
            return identifiers[text] || (identifiers[text] = text);
        }
--- END ---
INLINE (internIdentifier) id{187,5} AS 5 AT <0:147>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nextToken) id{187,6} ---
() {
            return currentToken = scanner.scan();
        }
--- END ---
INLINE (nextToken) id{187,6} AS 6 AT <0:464>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseTypeOperator) id{188,0} ---
(operator) {
            var node = createNode(168 /* TypeOperator */);
            parseExpected(operator);
            node.operator = operator;
            node.type = parseTypeOperatorOrHigher();
            return finishNode(node);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createNode) id{188,1} ---
(kind, pos) {
            nodeCount++;
            if (!(pos >= 0)) {
                pos = scanner.getStartPos();
            }
            return kind >= 141 /* FirstNode */ ? new NodeConstructor(kind, pos, pos) :
                kind === 70 /* Identifier */ ? new IdentifierConstructor(kind, pos, pos) :
                    new TokenConstructor(kind, pos, pos);
        }
--- END ---
INLINE (createNode) id{188,1} AS 1 AT <0:36>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:NodeObject) id{188,2} ---
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }
--- END ---
INLINE (NodeObject) id{188,2} AS 2 AT <1:178>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:IdentifierObject) id{188,3} ---
(_kind, pos, end) {
            return _super.call(this, pos, end) || this;
        }
--- END ---
INLINE (IdentifierObject) id{188,3} AS 3 AT <1:263>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TokenObject) id{188,4} ---
(kind, pos, end) {
            var _this = _super.call(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }
--- END ---
INLINE (TokenObject) id{188,4} AS 4 AT <1:327>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:parseTypeOperatorOrHigher) id{188,5} ---
() {
            switch (token()) {
                case 126 /* KeyOfKeyword */:
                    return parseTypeOperator(126 /* KeyOfKeyword */);
            }
            return parseArrayTypeOrHigher();
        }
--- END ---
INLINE (parseTypeOperatorOrHigher) id{188,5} AS 5 AT <0:171>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:token) id{188,6} ---
() {
            return currentToken;
        }
--- END ---
INLINE (token) id{188,6} AS 6 AT <5:25>
[deoptimizing (DEOPT soft): begin 0x8b78adb4779 <JS Function parseTagComments (SharedFunctionInfo 0xd6230d1fa71)> (opt #157) @23, FP to SP delta: 72, caller sp: 0x7fff5fbfd278]
            ;;; deoptimize at 0_1727: Insufficient type feedback for LHS of binary operation
  reading input frame parseTagComments => node=351, args=2, height=9; inputs:
      0: 0x8b78adb4779 ; [fp - 16] 0x8b78adb4779 <JS Function parseTagComments (SharedFunctionInfo 0xd6230d1fa71)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1900000000 ; [fp + 16] 25
      3: 0x8b78adb52f9 ; rbx 0x8b78adb52f9 <FixedArray[7]>
      4: 0x30bcea4069a9 ; (literal 4) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      5: 1 ; (int) [fp - 48] 
      6: 0x8b78adb5341 ; [fp - 32] 0x8b78adb5341 <JS Function pushComment (SharedFunctionInfo 0xd6230d45901)>
      7: 0x8b78adb5761 ; [fp - 56] 0x8b78adb5761 <String[23]:                        >
      8: 0x30bcea4a15c9 ; [fp - 72] 0x30bcea4a15c9 <JS Function push (SharedFunctionInfo 0x30bcea475769)>
      9: 0x8b78adb5389 ; [fp - 64] 0x8b78adb5389 <JS Array[25]>
     10: 0x8b78adb5761 ; [fp - 56] 0x8b78adb5761 <String[23]:                        >
     11: 0x30bcea4ae431 ; rax 0x30bcea4ae431 <JS Function slice (SharedFunctionInfo 0x30bcea43e5e9)>
  translating frame parseTagComments => node=351, height=64
    0x7fff5fbfd270: [top + 104] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd268: [top + 96] <- 0x1900000000 ;  25  (input #2)
    0x7fff5fbfd260: [top + 88] <- 0x2c21d23f9326 ;  caller's pc
    0x7fff5fbfd258: [top + 80] <- 0x7fff5fbfd2e0 ;  caller's fp
    0x7fff5fbfd250: [top + 72] <- 0x8b78adb52f9 ;  context    0x8b78adb52f9 <FixedArray[7]>  (input #3)
    0x7fff5fbfd248: [top + 64] <- 0x8b78adb4779 ;  function    0x8b78adb4779 <JS Function parseTagComments (SharedFunctionInfo 0xd6230d1fa71)>  (input #0)
    0x7fff5fbfd240: [top + 56] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #4)
    0x7fff5fbfd238: [top + 48] <- 0x100000000 ;  1  (input #5)
    0x7fff5fbfd230: [top + 40] <- 0x8b78adb5341 ;  0x8b78adb5341 <JS Function pushComment (SharedFunctionInfo 0xd6230d45901)>  (input #6)
    0x7fff5fbfd228: [top + 32] <- 0x8b78adb5761 ;  0x8b78adb5761 <String[23]:                        >  (input #7)
    0x7fff5fbfd220: [top + 24] <- 0x30bcea4a15c9 ;  0x30bcea4a15c9 <JS Function push (SharedFunctionInfo 0x30bcea475769)>  (input #8)
    0x7fff5fbfd218: [top + 16] <- 0x8b78adb5389 ;  0x8b78adb5389 <JS Array[25]>  (input #9)
    0x7fff5fbfd210: [top + 8] <- 0x8b78adb5761 ;  0x8b78adb5761 <String[23]:                        >  (input #10)
    0x7fff5fbfd208: [top + 0] <- 0x30bcea4ae431 ;  0x30bcea4ae431 <JS Function slice (SharedFunctionInfo 0x30bcea43e5e9)>  (input #11)
[deoptimizing (soft): end 0x8b78adb4779 <JS Function parseTagComments (SharedFunctionInfo 0xd6230d1fa71)> @23 => node=351, pc=0x2c21d2454867, caller sp=0x7fff5fbfd278, state=TOS_REGISTER, took 0.193 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:) id{189,0} ---
(node) {
                return ts.hasModifier(node, 1 /* Export */)
                    || node.kind === 234 /* ImportEqualsDeclaration */ && node.moduleReference.kind === 245 /* ExternalModuleReference */
                    || node.kind === 235 /* ImportDeclaration */
                    || node.kind === 240 /* ExportAssignment */
                    || node.kind === 241 /* ExportDeclaration */
                    ? node
                    : undefined;
            }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:collectModuleReferences) id{190,0} ---
(node, inAmbientModule) {
                switch (node.kind) {
                    case 235 /* ImportDeclaration */:
                    case 234 /* ImportEqualsDeclaration */:
                    case 241 /* ExportDeclaration */:
                        var moduleNameExpr = ts.getExternalModuleName(node);
                        if (!moduleNameExpr || moduleNameExpr.kind !== 9 /* StringLiteral */) {
                            break;
                        }
                        if (!moduleNameExpr.text) {
                            break;
                        }
                        // TypeScript 1.0 spec (April 2014): 12.1.6
                        // An ExternalImportDeclaration in an AmbientExternalModuleDeclaration may reference other external modules
                        // only through top - level external module names. Relative external module names are not permitted.
                        if (!inAmbientModule || !ts.isExternalModuleNameRelative(moduleNameExpr.text)) {
                            (imports || (imports = [])).push(moduleNameExpr);
                        }
                        break;
                    case 230 /* ModuleDeclaration */:
                        if (ts.isAmbientModule(node) && (inAmbientModule || ts.hasModifier(node, 2 /* Ambient */) || ts.isDeclarationFile(file))) {
                            var moduleName = node.name;
                            // Ambient module declarations can be interpreted as augmentations for some existing external modules.
                            // This will happen in two cases:
                            // - if current file is external module then module augmentation is a ambient module declaration defined in the top level scope
                            // - if current file is not external module then module augmentation is an ambient module declaration with non-relative module name
                            //   immediately nested in top level ambient module declaration .
                            if (isExternalModuleFile || (inAmbientModule && !ts.isExternalModuleNameRelative(moduleName.text))) {
                                (moduleAugmentations || (moduleAugmentations = [])).push(moduleName);
                            }
                            else if (!inAmbientModule) {
                                if (isDtsFile) {
                                    // for global .d.ts files record name of ambient module
                                    (ambientModules || (ambientModules = [])).push(moduleName.text);
                                }
                                // An AmbientExternalModuleDeclaration declares an external module.
                                // This type of declaration is permitted only in the global module.
                                // The StringLiteral must specify a top - level external module name.
                                // Relative external module names are not permitted
                                // NOTE: body of ambient module is always a module block, if it exists
                                var body = node.body;
                                if (body) {
                                    for (var _i = 0, _a = body.statements; _i < _a.length; _i++) {
                                        var statement = _a[_i];
                                        collectModuleReferences(statement, /*inAmbientModule*/ true);
                                    }
                                }
                            }
                        }
                }
            }
--- END ---
[marking dependent code 0x2c21d247c621 (opt #71) for deoptimization, reason: prototype-check]
[deoptimize marked code in all contexts]
[deoptimizer unlinked: getJSDocCommentRanges / d6230db1589]
[deoptimizing (DEOPT soft): begin 0xd6230db2489 <JS Function modifierToFlag (SharedFunctionInfo 0x3504a53d5419)> (opt #150) @1, FP to SP delta: 24, caller sp: 0x7fff5fbfd810]
            ;;; deoptimize at 0_18: Insufficient type feedback for combined type of binary operation
  reading input frame modifierToFlag => node=24, args=2, height=3; inputs:
      0: 0xd6230db2489 ; [fp - 16] 0xd6230db2489 <JS Function modifierToFlag (SharedFunctionInfo 0x3504a53d5419)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x8200000000 ; [fp + 16] 130
      3: 0xd6230db34c9 ; [fp - 24] 0xd6230db34c9 <FixedArray[156]>
      4: 0x30bcea4069a9 ; (literal 2) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      5: 0x8200000000 ; [fp + 16] 130
  translating frame modifierToFlag => node=24, height=16
    0x7fff5fbfd808: [top + 56] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd800: [top + 48] <- 0x8200000000 ;  130  (input #2)
    0x7fff5fbfd7f8: [top + 40] <- 0x2c21d243f35d ;  caller's pc
    0x7fff5fbfd7f0: [top + 32] <- 0x7fff5fbfd850 ;  caller's fp
    0x7fff5fbfd7e8: [top + 24] <- 0xd6230db34c9 ;  context    0xd6230db34c9 <FixedArray[156]>  (input #3)
    0x7fff5fbfd7e0: [top + 16] <- 0xd6230db2489 ;  function    0xd6230db2489 <JS Function modifierToFlag (SharedFunctionInfo 0x3504a53d5419)>  (input #0)
    0x7fff5fbfd7d8: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #4)
    0x7fff5fbfd7d0: [top + 0] <- 0x8200000000 ;  130  (input #5)
[deoptimizing (soft): end 0xd6230db2489 <JS Function modifierToFlag (SharedFunctionInfo 0x3504a53d5419)> @1 => node=24, pc=0x2c21d243f623, caller sp=0x7fff5fbfd810, state=NO_REGISTERS, took 0.053 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{191,0} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isAmbientModule) id{192,0} ---
(node) {
        return node && node.kind === 230 /* ModuleDeclaration */ &&
            (node.name.kind === 9 /* StringLiteral */ || isGlobalScopeAugmentation(node));
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isGlobalScopeAugmentation) id{192,1} ---
(module) {
        return !!(module.flags & 512 /* GlobalAugmentation */);
    }
--- END ---
INLINE (isGlobalScopeAugmentation) id{192,1} AS 1 AT <0:134>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isInJavaScriptFile) id{193,0} ---
(node) {
        return node && !!(node.flags & 65536 /* JavaScriptFile */);
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isExpression) id{194,0} ---
(node) {
        return isExpressionKind(ts.skipPartiallyEmittedExpressions(node).kind);
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isExpressionKind) id{194,1} ---
(kind) {
        return kind === 193 /* ConditionalExpression */
            || kind === 195 /* YieldExpression */
            || kind === 185 /* ArrowFunction */
            || kind === 192 /* BinaryExpression */
            || kind === 196 /* SpreadElement */
            || kind === 200 /* AsExpression */
            || kind === 198 /* OmittedExpression */
            || isUnaryExpressionKind(kind);
    }
--- END ---
INLINE (isExpressionKind) id{194,1} AS 1 AT <0:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isUnaryExpressionKind) id{194,2} ---
(kind) {
        return kind === 190 /* PrefixUnaryExpression */
            || kind === 191 /* PostfixUnaryExpression */
            || kind === 186 /* DeleteExpression */
            || kind === 187 /* TypeOfExpression */
            || kind === 188 /* VoidExpression */
            || kind === 189 /* AwaitExpression */
            || kind === 182 /* TypeAssertionExpression */
            || isLeftHandSideExpressionKind(kind);
    }
--- END ---
INLINE (isUnaryExpressionKind) id{194,2} AS 2 AT <1:376>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:bind) id{195,0} ---
(node) {
            if (!node) {
                return;
            }
            node.parent = parent;
            var saveInStrictMode = inStrictMode;
            // First we bind declaration nodes to a symbol if possible. We'll both create a symbol
            // and then potentially add the symbol to an appropriate symbol table. Possible
            // destination symbol tables are:
            //
            //  1) The 'exports' table of the current container's symbol.
            //  2) The 'members' table of the current container's symbol.
            //  3) The 'locals' table of the current container.
            //
            // However, not all symbols will end up in any of these tables. 'Anonymous' symbols
            // (like TypeLiterals for example) will not be put in any table.
            bindWorker(node);
            // Then we recurse into the children of the node to bind them as well. For certain
            // symbols we do specialized work when we recurse. For example, we'll keep track of
            // the current 'container' node when it changes. This helps us know which symbol table
            // a local should go into for example. Since terminal nodes are known not to have
            // children, as an optimization we don't process those.
            if (node.kind > 140 /* LastToken */) {
                var saveParent = parent;
                parent = node;
                var containerFlags = getContainerFlags(node);
                if (containerFlags === 0 /* None */) {
                    bindChildren(node);
                }
                else {
                    bindContainer(node, containerFlags);
                }
                parent = saveParent;
            }
            else if (!skipTransformFlagAggregation && (node.transformFlags & 536870912 /* HasComputedFlags */) === 0) {
                subtreeTransformFlags |= computeTransformFlagsForNode(node, 0);
            }
            inStrictMode = saveInStrictMode;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:SymbolObject) id{196,0} ---
(flags, name) {
            this.flags = flags;
            this.name = name;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createSymbol) id{197,0} ---
(flags, name) {
            symbolCount++;
            return new Symbol(flags, name);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:SymbolObject) id{197,1} ---
(flags, name) {
            this.flags = flags;
            this.name = name;
        }
--- END ---
INLINE (SymbolObject) id{197,1} AS 1 AT <0:62>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:declareSymbolAndAddToSymbolTable) id{198,0} ---
(node, symbolFlags, symbolExcludes) {
            // Just call this directly so that the return type of this function stays "void".
            return declareSymbolAndAddToSymbolTableWorker(node, symbolFlags, symbolExcludes);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:bindEachChild) id{199,0} ---
(node) {
            ts.forEachChild(node, bind, bindEach);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:bindWorker) id{200,0} ---
(node) {
            switch (node.kind) {
                /* Strict mode checks */
                case 70 /* Identifier */:
                    // for typedef type names with namespaces, bind the new jsdoc type symbol here
                    // because it requires all containing namespaces to be in effect, namely the
                    // current "blockScopeContainer" needs to be set to its immediate namespace parent.
                    if (node.isInJSDocNamespace) {
                        var parentNode = node.parent;
                        while (parentNode && parentNode.kind !== 285 /* JSDocTypedefTag */) {
                            parentNode = parentNode.parent;
                        }
                        bindBlockScopedDeclaration(parentNode, 524288 /* TypeAlias */, 793064 /* TypeAliasExcludes */);
                        break;
                    }
                case 98 /* ThisKeyword */:
                    if (currentFlow && (ts.isExpression(node) || parent.kind === 258 /* ShorthandPropertyAssignment */)) {
                        node.flowNode = currentFlow;
                    }
                    return checkStrictModeIdentifier(node);
                case 177 /* PropertyAccessExpression */:
                    if (currentFlow && isNarrowableReference(node)) {
                        node.flowNode = currentFlow;
                    }
                    break;
                case 192 /* BinaryExpression */:
                    if (ts.isInJavaScriptFile(node)) {
                        var specialKind = ts.getSpecialPropertyAssignmentKind(node);
                        switch (specialKind) {
                            case 1 /* ExportsProperty */:
                                bindExportsPropertyAssignment(node);
                                break;
                            case 2 /* ModuleExports */:
                                bindModuleExportsAssignment(node);
                                break;
                            case 3 /* PrototypeProperty */:
                                bindPrototypePropertyAssignment(node);
                                break;
                            case 4 /* ThisProperty */:
                                bindThisPropertyAssignment(node);
                                break;
                            case 0 /* None */:
                                // Nothing to do
                                break;
                            default:
                                ts.Debug.fail("Unknown special property assignment kind");
                        }
                    }
                    return checkStrictModeBinaryExpression(node);
                case 256 /* CatchClause */:
                    return checkStrictModeCatchClause(node);
                case 186 /* DeleteExpression */:
                    return checkStrictModeDeleteExpression(node);
                case 8 /* NumericLiteral */:
                    return checkStrictModeNumericLiteral(node);
                case 191 /* PostfixUnaryExpression */:
                    return checkStrictModePostfixUnaryExpression(node);
                case 190 /* PrefixUnaryExpression */:
                    return checkStrictModePrefixUnaryExpression(node);
                case 217 /* WithStatement */:
                    return checkStrictModeWithStatement(node);
                case 167 /* ThisType */:
                    seenThisKeyword = true;
                    return;
                case 156 /* TypePredicate */:
                    return checkTypePredicate(node);
                case 143 /* TypeParameter */:
                    return declareSymbolAndAddToSymbolTable(node, 262144 /* TypeParameter */, 530920 /* TypeParameterExcludes */);
                case 144 /* Parameter */:
                    return bindParameter(node);
                case 223 /* VariableDeclaration */:
                case 174 /* BindingElement */:
                    return bindVariableDeclarationOrBindingElement(node);
                case 147 /* PropertyDeclaration */:
                case 146 /* PropertySignature */:
                case 271 /* JSDocRecordMember */:
                    return bindPropertyOrMethodOrAccessor(node, 4 /* Property */ | (node.questionToken ? 536870912 /* Optional */ : 0 /* None */), 0 /* PropertyExcludes */);
                case 286 /* JSDocPropertyTag */:
                    return bindJSDocProperty(node);
                case 257 /* PropertyAssignment */:
                case 258 /* ShorthandPropertyAssignment */:
                    return bindPropertyOrMethodOrAccessor(node, 4 /* Property */, 0 /* PropertyExcludes */);
                case 260 /* EnumMember */:
                    return bindPropertyOrMethodOrAccessor(node, 8 /* EnumMember */, 900095 /* EnumMemberExcludes */);
                case 259 /* SpreadAssignment */:
                case 251 /* JsxSpreadAttribute */:
                    var root = container;
                    var hasRest = false;
                    while (root.parent) {
                        if (root.kind === 176 /* ObjectLiteralExpression */ &&
                            root.parent.kind === 192 /* BinaryExpression */ &&
                            root.parent.operatorToken.kind === 57 /* EqualsToken */ &&
                            root.parent.left === root) {
                            hasRest = true;
                            break;
                        }
                        root = root.parent;
                    }
                    return;
                case 153 /* CallSignature */:
                case 154 /* ConstructSignature */:
                case 155 /* IndexSignature */:
                    return declareSymbolAndAddToSymbolTable(node, 131072 /* Signature */, 0 /* None */);
                case 149 /* MethodDeclaration */:
                case 148 /* MethodSignature */:
                    // If this is an ObjectLiteralExpression method, then it sits in the same space
                    // as other properties in the object literal.  So we use SymbolFlags.PropertyExcludes
                    // so that it will conflict with any other object literal members with the same
                    // name.
                    return bindPropertyOrMethodOrAccessor(node, 8192 /* Method */ | (node.questionToken ? 536870912 /* Optional */ : 0 /* None */), ts.isObjectLiteralMethod(node) ? 0 /* PropertyExcludes */ : 99263 /* MethodExcludes */);
                case 225 /* FunctionDeclaration */:
                    return bindFunctionDeclaration(node);
                case 150 /* Constructor */:
                    return declareSymbolAndAddToSymbolTable(node, 16384 /* Constructor */, /*symbolExcludes:*/ 0 /* None */);
                case 151 /* GetAccessor */:
                    return bindPropertyOrMethodOrAccessor(node, 32768 /* GetAccessor */, 41919 /* GetAccessorExcludes */);
                case 152 /* SetAccessor */:
                    return bindPropertyOrMethodOrAccessor(node, 65536 /* SetAccessor */, 74687 /* SetAccessorExcludes */);
                case 158 /* FunctionType */:
                case 159 /* ConstructorType */:
                case 274 /* JSDocFunctionType */:
                    return bindFunctionOrConstructorType(node);
                case 161 /* TypeLiteral */:
                case 170 /* MappedType */:
                case 287 /* JSDocTypeLiteral */:
                case 270 /* JSDocRecordType */:
                    return bindAnonymousDeclaration(node, 2048 /* TypeLiteral */, "__type");
                case 176 /* ObjectLiteralExpression */:
                    return bindObjectLiteralExpression(node);
                case 184 /* FunctionExpression */:
                case 185 /* ArrowFunction */:
                    return bindFunctionExpression(node);
                case 179 /* CallExpression */:
                    if (ts.isInJavaScriptFile(node)) {
                        bindCallExpression(node);
                    }
                    break;
                // Members of classes, interfaces, and modules
                case 197 /* ClassExpression */:
                case 226 /* ClassDeclaration */:
                    // All classes are automatically in strict mode in ES6.
                    inStrictMode = true;
                    return bindClassLikeDeclaration(node);
                case 227 /* InterfaceDeclaration */:
                    return bindBlockScopedDeclaration(node, 64 /* Interface */, 792968 /* InterfaceExcludes */);
                case 285 /* JSDocTypedefTag */:
                    if (!node.fullName || node.fullName.kind === 70 /* Identifier */) {
                        return bindBlockScopedDeclaration(node, 524288 /* TypeAlias */, 793064 /* TypeAliasExcludes */);
                    }
                    break;
                case 228 /* TypeAliasDeclaration */:
                    return bindBlockScopedDeclaration(node, 524288 /* TypeAlias */, 793064 /* TypeAliasExcludes */);
                case 229 /* EnumDeclaration */:
                    return bindEnumDeclaration(node);
                case 230 /* ModuleDeclaration */:
                    return bindModuleDeclaration(node);
                // Imports and exports
                case 234 /* ImportEqualsDeclaration */:
                case 237 /* NamespaceImport */:
                case 239 /* ImportSpecifier */:
                case 243 /* ExportSpecifier */:
                    return declareSymbolAndAddToSymbolTable(node, 8388608 /* Alias */, 8388608 /* AliasExcludes */);
                case 233 /* NamespaceExportDeclaration */:
                    return bindNamespaceExportDeclaration(node);
                case 236 /* ImportClause */:
                    return bindImportClause(node);
                case 241 /* ExportDeclaration */:
                    return bindExportDeclaration(node);
                case 240 /* ExportAssignment */:
                    return bindExportAssignment(node);
                case 261 /* SourceFile */:
                    updateStrictModeStatementList(node.statements);
                    return bindSourceFileIfExternalModule();
                case 204 /* Block */:
                    if (!ts.isFunctionLike(node.parent)) {
                        return;
                    }
                // Fall through
                case 231 /* ModuleBlock */:
                    return updateStrictModeStatementList(node.statements);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:declareSymbolAndAddToSymbolTable) id{200,1} ---
(node, symbolFlags, symbolExcludes) {
            // Just call this directly so that the return type of this function stays "void".
            return declareSymbolAndAddToSymbolTableWorker(node, symbolFlags, symbolExcludes);
        }
--- END ---
INLINE (declareSymbolAndAddToSymbolTable) id{200,1} AS 1 AT <0:3659>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:declareSymbolAndAddToSymbolTable) id{200,2} ---
(node, symbolFlags, symbolExcludes) {
            // Just call this directly so that the return type of this function stays "void".
            return declareSymbolAndAddToSymbolTableWorker(node, symbolFlags, symbolExcludes);
        }
--- END ---
INLINE (declareSymbolAndAddToSymbolTable) id{200,2} AS 2 AT <0:5731>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:updateStrictModeStatementList) id{200,3} ---
(statements) {
            if (!inStrictMode) {
                for (var _i = 0, statements_2 = statements; _i < statements_2.length; _i++) {
                    var statement = statements_2[_i];
                    if (!ts.isPrologueDirective(statement)) {
                        return;
                    }
                    if (isUseStrictPrologueDirective(statement)) {
                        inStrictMode = true;
                        return;
                    }
                }
            }
        }
--- END ---
INLINE (updateStrictModeStatementList) id{200,3} AS 3 AT <0:10085>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:bindSourceFileIfExternalModule) id{200,4} ---
() {
            setExportContextFlag(file);
            if (ts.isExternalModule(file)) {
                bindSourceFileAsExternalModule();
            }
        }
--- END ---
INLINE (bindSourceFileIfExternalModule) id{200,4} AS 4 AT <0:10160>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:setExportContextFlag) id{200,5} ---
(node) {
            // A declaration source file or ambient module declaration that contains no export declarations (but possibly regular
            // declarations with export modifiers) is an export context in which declarations are implicitly exported.
            if (ts.isInAmbientContext(node) && !hasExportDeclarations(node)) {
                node.flags |= 32 /* ExportContext */;
            }
            else {
                node.flags &= ~32 /* ExportContext */;
            }
        }
--- END ---
INLINE (setExportContextFlag) id{200,5} AS 5 AT <4:17>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:hasExportDeclarations) id{200,6} ---
(node) {
            var body = node.kind === 261 /* SourceFile */ ? node : node.body;
            if (body && (body.kind === 261 /* SourceFile */ || body.kind === 231 /* ModuleBlock */)) {
                for (var _i = 0, _a = body.statements; _i < _a.length; _i++) {
                    var stat = _a[_i];
                    if (stat.kind === 241 /* ExportDeclaration */ || stat.kind === 240 /* ExportAssignment */) {
                        return true;
                    }
                }
            }
            return false;
        }
--- END ---
INLINE (hasExportDeclarations) id{200,6} AS 6 AT <5:306>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isDynamicName) id{201,0} ---
(name) {
        return name.kind === 142 /* ComputedPropertyName */ &&
            !isStringOrNumericLiteral(name.expression) &&
            !isWellKnownSymbolSyntactically(name.expression);
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isBindingPattern) id{202,0} ---
(node) {
        if (node) {
            var kind = node.kind;
            return kind === 173 /* ArrayBindingPattern */
                || kind === 172 /* ObjectBindingPattern */;
        }
        return false;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:bindPropertyOrMethodOrAccessor) id{203,0} ---
(node, symbolFlags, symbolExcludes) {
            if (!ts.isDeclarationFile(file) && !ts.isInAmbientContext(node)) {
                if (ts.isAsyncFunctionLike(node)) {
                    emitFlags |= 1024 /* HasAsyncFunctions */;
                }
            }
            if (currentFlow && ts.isObjectLiteralOrClassExpressionMethod(node)) {
                node.flowNode = currentFlow;
            }
            return ts.hasDynamicName(node)
                ? bindAnonymousDeclaration(node, symbolFlags, "__computed")
                : declareSymbolAndAddToSymbolTable(node, symbolFlags, symbolExcludes);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:declareSymbolAndAddToSymbolTable) id{203,1} ---
(node, symbolFlags, symbolExcludes) {
            // Just call this directly so that the return type of this function stays "void".
            return declareSymbolAndAddToSymbolTableWorker(node, symbolFlags, symbolExcludes);
        }
--- END ---
INLINE (declareSymbolAndAddToSymbolTable) id{203,1} AS 1 AT <0:542>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isObjectLiteralOrClassExpressionMethod) id{204,0} ---
(node) {
        return node.kind === 149 /* MethodDeclaration */ &&
            (node.parent.kind === 176 /* ObjectLiteralExpression */ ||
                node.parent.kind === 197 /* ClassExpression */);
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getContainerFlags) id{205,0} ---
(node) {
            switch (node.kind) {
                case 197 /* ClassExpression */:
                case 226 /* ClassDeclaration */:
                case 229 /* EnumDeclaration */:
                case 176 /* ObjectLiteralExpression */:
                case 161 /* TypeLiteral */:
                case 287 /* JSDocTypeLiteral */:
                case 270 /* JSDocRecordType */:
                    return 1 /* IsContainer */;
                case 227 /* InterfaceDeclaration */:
                    return 1 /* IsContainer */ | 64 /* IsInterface */;
                case 274 /* JSDocFunctionType */:
                case 230 /* ModuleDeclaration */:
                case 228 /* TypeAliasDeclaration */:
                case 170 /* MappedType */:
                    return 1 /* IsContainer */ | 32 /* HasLocals */;
                case 261 /* SourceFile */:
                    return 1 /* IsContainer */ | 4 /* IsControlFlowContainer */ | 32 /* HasLocals */;
                case 149 /* MethodDeclaration */:
                    if (ts.isObjectLiteralOrClassExpressionMethod(node)) {
                        return 1 /* IsContainer */ | 4 /* IsControlFlowContainer */ | 32 /* HasLocals */ | 8 /* IsFunctionLike */ | 128 /* IsObjectLiteralOrClassExpressionMethod */;
                    }
                case 150 /* Constructor */:
                case 225 /* FunctionDeclaration */:
                case 148 /* MethodSignature */:
                case 151 /* GetAccessor */:
                case 152 /* SetAccessor */:
                case 153 /* CallSignature */:
                case 154 /* ConstructSignature */:
                case 155 /* IndexSignature */:
                case 158 /* FunctionType */:
                case 159 /* ConstructorType */:
                    return 1 /* IsContainer */ | 4 /* IsControlFlowContainer */ | 32 /* HasLocals */ | 8 /* IsFunctionLike */;
                case 184 /* FunctionExpression */:
                case 185 /* ArrowFunction */:
                    return 1 /* IsContainer */ | 4 /* IsControlFlowContainer */ | 32 /* HasLocals */ | 8 /* IsFunctionLike */ | 16 /* IsFunctionExpression */;
                case 231 /* ModuleBlock */:
                    return 4 /* IsControlFlowContainer */;
                case 147 /* PropertyDeclaration */:
                    return node.initializer ? 4 /* IsControlFlowContainer */ : 0;
                case 256 /* CatchClause */:
                case 211 /* ForStatement */:
                case 212 /* ForInStatement */:
                case 213 /* ForOfStatement */:
                case 232 /* CaseBlock */:
                    return 2 /* IsBlockScopedContainer */;
                case 204 /* Block */:
                    // do not treat blocks directly inside a function as a block-scoped-container.
                    // Locals that reside in this block should go to the function locals. Otherwise 'x'
                    // would not appear to be a redeclaration of a block scoped local in the following
                    // example:
                    //
                    //      function foo() {
                    //          var x;
                    //          let x;
                    //      }
                    //
                    // If we placed 'var x' into the function locals and 'let x' into the locals of
                    // the block, then there would be no collision.
                    //
                    // By not creating a new block-scoped-container here, we ensure that both 'var x'
                    // and 'let x' go into the Function-container's locals, and we do get a collision
                    // conflict.
                    return ts.isFunctionLike(node.parent) ? 0 /* None */ : 2 /* IsBlockScopedContainer */;
            }
            return 0 /* None */;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:bindChildrenWorker) id{206,0} ---
(node) {
            // Binding of JsDocComment should be done before the current block scope container changes.
            // because the scope of JsDocComment should not be affected by whether the current node is a
            // container or not.
            if (ts.isInJavaScriptFile(node) && node.jsDoc) {
                ts.forEach(node.jsDoc, bind);
            }
            if (checkUnreachable(node)) {
                bindEachChild(node);
                return;
            }
            switch (node.kind) {
                case 210 /* WhileStatement */:
                    bindWhileStatement(node);
                    break;
                case 209 /* DoStatement */:
                    bindDoStatement(node);
                    break;
                case 211 /* ForStatement */:
                    bindForStatement(node);
                    break;
                case 212 /* ForInStatement */:
                case 213 /* ForOfStatement */:
                    bindForInOrForOfStatement(node);
                    break;
                case 208 /* IfStatement */:
                    bindIfStatement(node);
                    break;
                case 216 /* ReturnStatement */:
                case 220 /* ThrowStatement */:
                    bindReturnOrThrow(node);
                    break;
                case 215 /* BreakStatement */:
                case 214 /* ContinueStatement */:
                    bindBreakOrContinueStatement(node);
                    break;
                case 221 /* TryStatement */:
                    bindTryStatement(node);
                    break;
                case 218 /* SwitchStatement */:
                    bindSwitchStatement(node);
                    break;
                case 232 /* CaseBlock */:
                    bindCaseBlock(node);
                    break;
                case 253 /* CaseClause */:
                    bindCaseClause(node);
                    break;
                case 219 /* LabeledStatement */:
                    bindLabeledStatement(node);
                    break;
                case 190 /* PrefixUnaryExpression */:
                    bindPrefixUnaryExpressionFlow(node);
                    break;
                case 191 /* PostfixUnaryExpression */:
                    bindPostfixUnaryExpressionFlow(node);
                    break;
                case 192 /* BinaryExpression */:
                    bindBinaryExpressionFlow(node);
                    break;
                case 186 /* DeleteExpression */:
                    bindDeleteExpressionFlow(node);
                    break;
                case 193 /* ConditionalExpression */:
                    bindConditionalExpressionFlow(node);
                    break;
                case 223 /* VariableDeclaration */:
                    bindVariableDeclarationFlow(node);
                    break;
                case 179 /* CallExpression */:
                    bindCallExpressionFlow(node);
                    break;
                default:
                    bindEachChild(node);
                    break;
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:bindVariableDeclarationFlow) id{206,1} ---
(node) {
            bindEachChild(node);
            if (node.initializer || node.parent.parent.kind === 212 /* ForInStatement */ || node.parent.parent.kind === 213 /* ForOfStatement */) {
                bindInitializedVariableFlow(node);
            }
        }
--- END ---
INLINE (bindVariableDeclarationFlow) id{206,1} AS 1 AT <0:2835>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:bindEachChild) id{206,2} ---
(node) {
            ts.forEachChild(node, bind, bindEach);
        }
--- END ---
INLINE (bindEachChild) id{206,2} AS 2 AT <1:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:bindEachChild) id{206,3} ---
(node) {
            ts.forEachChild(node, bind, bindEach);
        }
--- END ---
INLINE (bindEachChild) id{206,3} AS 3 AT <0:3066>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nodeIsPresent) id{207,0} ---
(node) {
        return !nodeIsMissing(node);
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nodeIsMissing) id{207,1} ---
(node) {
        if (node === undefined) {
            return true;
        }
        return node.pos === node.end && node.pos >= 0 && node.kind !== 1 /* EndOfFileToken */;
    }
--- END ---
INLINE (nodeIsMissing) id{207,1} AS 1 AT <0:25>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isParameterPropertyDeclaration) id{208,0} ---
(node) {
        return ts.hasModifier(node, 92 /* ParameterPropertyModifier */) && node.parent.kind === 150 /* Constructor */ && ts.isClassLike(node.parent.parent);
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:addDeclarationToSymbol) id{209,0} ---
(symbol, node, symbolFlags) {
            symbol.flags |= symbolFlags;
            node.symbol = symbol;
            if (!symbol.declarations) {
                symbol.declarations = [];
            }
            symbol.declarations.push(node);
            if (symbolFlags & 1952 /* HasExports */ && !symbol.exports) {
                symbol.exports = ts.createMap();
            }
            if (symbolFlags & 6240 /* HasMembers */ && !symbol.members) {
                symbol.members = ts.createMap();
            }
            if (symbolFlags & 107455 /* Value */) {
                var valueDeclaration = symbol.valueDeclaration;
                if (!valueDeclaration ||
                    (valueDeclaration.kind !== node.kind && valueDeclaration.kind === 230 /* ModuleDeclaration */)) {
                    // other kinds of value declarations take precedence over modules
                    symbol.valueDeclaration = node;
                }
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:declareSymbol) id{210,0} ---
(symbolTable, parent, node, includes, excludes) {
            ts.Debug.assert(!ts.hasDynamicName(node));
            var isDefaultExport = ts.hasModifier(node, 512 /* Default */);
            // The exported symbol for an export default function/class node is always named "default"
            var name = isDefaultExport && parent ? "default" : getDeclarationName(node);
            var symbol;
            if (name === undefined) {
                symbol = createSymbol(0 /* None */, "__missing");
            }
            else {
                // Check and see if the symbol table already has a symbol with this name.  If not,
                // create a new symbol with this name and add it to the table.  Note that we don't
                // give the new symbol any flags *yet*.  This ensures that it will not conflict
                // with the 'excludes' flags we pass in.
                //
                // If we do get an existing symbol, see if it conflicts with the new symbol we're
                // creating.  For example, a 'var' symbol and a 'class' symbol will conflict within
                // the same symbol table.  If we have a conflict, report the issue on each
                // declaration we have for this symbol, and then create a new symbol for this
                // declaration.
                //
                // Note that when properties declared in Javascript constructors
                // (marked by isReplaceableByMethod) conflict with another symbol, the property loses.
                // Always. This allows the common Javascript pattern of overwriting a prototype method
                // with an bound instance method of the same type: `this.method = this.method.bind(this)`
                //
                // If we created a new symbol, either because we didn't have a symbol with this name
                // in the symbol table, or we conflicted with an existing symbol, then just add this
                // node as the sole declaration of the new symbol.
                //
                // Otherwise, we'll be merging into a compatible existing symbol (for example when
                // you have multiple 'vars' with the same name in the same container).  In this case
                // just add this node into the declarations list of the symbol.
                symbol = symbolTable[name] || (symbolTable[name] = createSymbol(0 /* None */, name));
                if (name && (includes & 788448 /* Classifiable */)) {
                    classifiableNames[name] = name;
                }
                if (symbol.flags & excludes) {
                    if (symbol.isReplaceableByMethod) {
                        // Javascript constructor-declared symbols can be discarded in favor of
                        // prototype symbols like methods.
                        symbol = symbolTable[name] = createSymbol(0 /* None */, name);
                    }
                    else {
                        if (node.name) {
                            node.name.parent = node;
                        }
                        // Report errors every position with duplicate declaration
                        // Report errors on previous encountered declarations
                        var message_1 = symbol.flags & 2 /* BlockScopedVariable */
                            ? ts.Diagnostics.Cannot_redeclare_block_scoped_variable_0
                            : ts.Diagnostics.Duplicate_identifier_0;
                        if (symbol.declarations && symbol.declarations.length) {
                            // If the current node is a default export of some sort, then check if
                            // there are any other default exports that we need to error on.
                            // We'll know whether we have other default exports depending on if `symbol` already has a declaration list set.
                            if (isDefaultExport) {
                                message_1 = ts.Diagnostics.A_module_cannot_have_multiple_default_exports;
                            }
                            else {
                                // This is to properly report an error in the case "export default { }" is after export default of class declaration or function declaration.
                                // Error on multiple export default in the following case:
                                // 1. multiple export default of class declaration or function declaration by checking NodeFlags.Default
                                // 2. multiple export default of export assignment. This one doesn't have NodeFlags.Default on (as export default doesn't considered as modifiers)
                                if (symbol.declarations && symbol.declarations.length &&
                                    (isDefaultExport || (node.kind === 240 /* ExportAssignment */ && !node.isExportEquals))) {
                                    message_1 = ts.Diagnostics.A_module_cannot_have_multiple_default_exports;
                                }
                            }
                        }
                        ts.forEach(symbol.declarations, function (declaration) {
                            file.bindDiagnostics.push(ts.createDiagnosticForNode(declaration.name || declaration, message_1, getDisplayName(declaration)));
                        });
                        file.bindDiagnostics.push(ts.createDiagnosticForNode(node.name || node, message_1, getDisplayName(node)));
                        symbol = createSymbol(0 /* None */, name);
                    }
                }
            }
            addDeclarationToSymbol(symbol, node, includes);
            symbol.parent = parent;
            return symbol;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createSymbol) id{210,1} ---
(flags, name) {
            symbolCount++;
            return new Symbol(flags, name);
        }
--- END ---
INLINE (createSymbol) id{210,1} AS 1 AT <0:2384>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:SymbolObject) id{210,2} ---
(flags, name) {
            this.flags = flags;
            this.name = name;
        }
--- END ---
INLINE (SymbolObject) id{210,2} AS 2 AT <1:62>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:declareSymbolAndAddToSymbolTableWorker) id{211,0} ---
(node, symbolFlags, symbolExcludes) {
            switch (container.kind) {
                // Modules, source files, and classes need specialized handling for how their
                // members are declared (for example, a member of a class will go into a specific
                // symbol table depending on if it is static or not). We defer to specialized
                // handlers to take care of declaring these child members.
                case 230 /* ModuleDeclaration */:
                    return declareModuleMember(node, symbolFlags, symbolExcludes);
                case 261 /* SourceFile */:
                    return declareSourceFileMember(node, symbolFlags, symbolExcludes);
                case 197 /* ClassExpression */:
                case 226 /* ClassDeclaration */:
                    return declareClassMember(node, symbolFlags, symbolExcludes);
                case 229 /* EnumDeclaration */:
                    return declareSymbol(container.symbol.exports, container.symbol, node, symbolFlags, symbolExcludes);
                case 161 /* TypeLiteral */:
                case 176 /* ObjectLiteralExpression */:
                case 227 /* InterfaceDeclaration */:
                case 270 /* JSDocRecordType */:
                case 287 /* JSDocTypeLiteral */:
                    // Interface/Object-types always have their children added to the 'members' of
                    // their container. They are only accessible through an instance of their
                    // container, and are never in scope otherwise (even inside the body of the
                    // object / type / interface declaring them). An exception is type parameters,
                    // which are in scope without qualification (similar to 'locals').
                    return declareSymbol(container.symbol.members, container.symbol, node, symbolFlags, symbolExcludes);
                case 158 /* FunctionType */:
                case 159 /* ConstructorType */:
                case 153 /* CallSignature */:
                case 154 /* ConstructSignature */:
                case 155 /* IndexSignature */:
                case 149 /* MethodDeclaration */:
                case 148 /* MethodSignature */:
                case 150 /* Constructor */:
                case 151 /* GetAccessor */:
                case 152 /* SetAccessor */:
                case 225 /* FunctionDeclaration */:
                case 184 /* FunctionExpression */:
                case 185 /* ArrowFunction */:
                case 274 /* JSDocFunctionType */:
                case 228 /* TypeAliasDeclaration */:
                case 170 /* MappedType */:
                    // All the children of these container types are never visible through another
                    // symbol (i.e. through another symbol's 'exports' or 'members').  Instead,
                    // they're only accessed 'lexically' (i.e. from code that exists underneath
                    // their container in the tree.  To accomplish this, we simply add their declared
                    // symbol to the 'locals' of the container.  These symbols can then be found as
                    // the type checker walks up the containers, checking them for matching names.
                    return declareSymbol(container.locals, /*parent*/ undefined, node, symbolFlags, symbolExcludes);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:declareSourceFileMember) id{211,1} ---
(node, symbolFlags, symbolExcludes) {
            return ts.isExternalModule(file)
                ? declareModuleMember(node, symbolFlags, symbolExcludes)
                : declareSymbol(file.locals, undefined, node, symbolFlags, symbolExcludes);
        }
--- END ---
INLINE (declareSourceFileMember) id{211,1} AS 1 AT <0:640>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isObjectLiteralMethod) id{212,0} ---
(node) {
        return node && node.kind === 149 /* MethodDeclaration */ && node.parent.kind === 176 /* ObjectLiteralExpression */;
    }
--- END ---
[deoptimizing (DEOPT eager): begin 0x2f05bb806029 <JS Function bindWorker (SharedFunctionInfo 0x16f3adb5c261)> (opt #200) @110, FP to SP delta: 192, caller sp: 0x7fff5fbfd0b0]
            ;;; deoptimize at 0_453: wrong map
  reading input frame bindWorker => node=42, args=2, height=8; inputs:
      0: 0x2f05bb806029 ; [fp - 16] 0x2f05bb806029 <JS Function bindWorker (SharedFunctionInfo 0x16f3adb5c261)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x286514cabe69 ; rcx 0x286514cabe69 <an IdentifierObject with map 0x33abe2a6fb81>
      3: 0xd6230dfeea1 ; rbx 0xd6230dfeea1 <FixedArray[147]>
      4: 0x30bcea4069a9 ; (literal 12) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      5: 0x30bcea404311 ; (literal 11) 0x30bcea404311 <undefined>
      6: 0x30bcea404311 ; (literal 11) 0x30bcea404311 <undefined>
      7: 0x30bcea404311 ; (literal 11) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; (literal 11) 0x30bcea404311 <undefined>
      9: 0x30bcea404311 ; (literal 11) 0x30bcea404311 <undefined>
     10: 0x4600000000 ; rax 70
  translating frame bindWorker => node=42, height=56
    0x7fff5fbfd0a8: [top + 96] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd0a0: [top + 88] <- 0x286514cabe69 ;  0x286514cabe69 <an IdentifierObject with map 0x33abe2a6fb81>  (input #2)
    0x7fff5fbfd098: [top + 80] <- 0x2c21d254dc06 ;  caller's pc
    0x7fff5fbfd090: [top + 72] <- 0x7fff5fbfd0d8 ;  caller's fp
    0x7fff5fbfd088: [top + 64] <- 0xd6230dfeea1 ;  context    0xd6230dfeea1 <FixedArray[147]>  (input #3)
    0x7fff5fbfd080: [top + 56] <- 0x2f05bb806029 ;  function    0x2f05bb806029 <JS Function bindWorker (SharedFunctionInfo 0x16f3adb5c261)>  (input #0)
    0x7fff5fbfd078: [top + 48] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #4)
    0x7fff5fbfd070: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfd068: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfd060: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfd058: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfd050: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
    0x7fff5fbfd048: [top + 0] <- 0x4600000000 ;  70  (input #10)
[deoptimizing (eager): end 0x2f05bb806029 <JS Function bindWorker (SharedFunctionInfo 0x16f3adb5c261)> @110 => node=42, pc=0x2c21d2542889, caller sp=0x7fff5fbfd0b0, state=NO_REGISTERS, took 0.071 ms]
[deoptimizing (DEOPT eager): begin 0xd6230dcabc1 <JS Function isExpression (SharedFunctionInfo 0x3504a53d99d9)> (opt #194) @4, FP to SP delta: 56, caller sp: 0x7fff5fbfd048]
            ;;; deoptimize at 0_81: wrong map
  reading input frame isExpression => node=20, args=2, height=4; inputs:
      0: 0xd6230dcabc1 ; [fp - 16] 0xd6230dcabc1 <JS Function isExpression (SharedFunctionInfo 0x3504a53d99d9)>
      1: 0x16f3adb61821 ; [fp + 24] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x286514cabe69 ; [fp + 16] 0x286514cabe69 <an IdentifierObject with map 0x33abe2a6fb81>
      3: 0xd6230db34c9 ; [fp - 24] 0xd6230db34c9 <FixedArray[156]>
      4: 0xd6230dd8a71 ; [fp - 32] 0xd6230dd8a71 <JS Function isExpressionKind (SharedFunctionInfo 0x3504a53d9919)>
      5: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
      6: 0x286514cabe69 ; rax 0x286514cabe69 <an IdentifierObject with map 0x33abe2a6fb81>
  translating frame isExpression => node=20, height=24
    0x7fff5fbfd040: [top + 64] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfd038: [top + 56] <- 0x286514cabe69 ;  0x286514cabe69 <an IdentifierObject with map 0x33abe2a6fb81>  (input #2)
    0x7fff5fbfd030: [top + 48] <- 0x2c21d254390d ;  caller's pc
    0x7fff5fbfd028: [top + 40] <- 0x7fff5fbfd090 ;  caller's fp
    0x7fff5fbfd020: [top + 32] <- 0xd6230db34c9 ;  context    0xd6230db34c9 <FixedArray[156]>  (input #3)
    0x7fff5fbfd018: [top + 24] <- 0xd6230dcabc1 ;  function    0xd6230dcabc1 <JS Function isExpression (SharedFunctionInfo 0x3504a53d99d9)>  (input #0)
    0x7fff5fbfd010: [top + 16] <- 0xd6230dd8a71 ;  0xd6230dd8a71 <JS Function isExpressionKind (SharedFunctionInfo 0x3504a53d9919)>  (input #4)
    0x7fff5fbfd008: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfd000: [top + 0] <- 0x286514cabe69 ;  0x286514cabe69 <an IdentifierObject with map 0x33abe2a6fb81>  (input #6)
[deoptimizing (eager): end 0xd6230dcabc1 <JS Function isExpression (SharedFunctionInfo 0x3504a53d99d9)> @4 => node=20, pc=0x2c21d25251af, caller sp=0x7fff5fbfd048, state=TOS_REGISTER, took 0.062 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isExpressionKind) id{213,0} ---
(kind) {
        return kind === 193 /* ConditionalExpression */
            || kind === 195 /* YieldExpression */
            || kind === 185 /* ArrowFunction */
            || kind === 192 /* BinaryExpression */
            || kind === 196 /* SpreadElement */
            || kind === 200 /* AsExpression */
            || kind === 198 /* OmittedExpression */
            || isUnaryExpressionKind(kind);
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isUnaryExpressionKind) id{213,1} ---
(kind) {
        return kind === 190 /* PrefixUnaryExpression */
            || kind === 191 /* PostfixUnaryExpression */
            || kind === 186 /* DeleteExpression */
            || kind === 187 /* TypeOfExpression */
            || kind === 188 /* VoidExpression */
            || kind === 189 /* AwaitExpression */
            || kind === 182 /* TypeAssertionExpression */
            || isLeftHandSideExpressionKind(kind);
    }
--- END ---
INLINE (isUnaryExpressionKind) id{213,1} AS 1 AT <0:376>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isExpression) id{214,0} ---
(node) {
        return isExpressionKind(ts.skipPartiallyEmittedExpressions(node).kind);
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isExpressionKind) id{214,1} ---
(kind) {
        return kind === 193 /* ConditionalExpression */
            || kind === 195 /* YieldExpression */
            || kind === 185 /* ArrowFunction */
            || kind === 192 /* BinaryExpression */
            || kind === 196 /* SpreadElement */
            || kind === 200 /* AsExpression */
            || kind === 198 /* OmittedExpression */
            || isUnaryExpressionKind(kind);
    }
--- END ---
INLINE (isExpressionKind) id{214,1} AS 1 AT <0:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isUnaryExpressionKind) id{214,2} ---
(kind) {
        return kind === 190 /* PrefixUnaryExpression */
            || kind === 191 /* PostfixUnaryExpression */
            || kind === 186 /* DeleteExpression */
            || kind === 187 /* TypeOfExpression */
            || kind === 188 /* VoidExpression */
            || kind === 189 /* AwaitExpression */
            || kind === 182 /* TypeAssertionExpression */
            || isLeftHandSideExpressionKind(kind);
    }
--- END ---
INLINE (isUnaryExpressionKind) id{214,2} AS 2 AT <1:376>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:bindWorker) id{215,0} ---
(node) {
            switch (node.kind) {
                /* Strict mode checks */
                case 70 /* Identifier */:
                    // for typedef type names with namespaces, bind the new jsdoc type symbol here
                    // because it requires all containing namespaces to be in effect, namely the
                    // current "blockScopeContainer" needs to be set to its immediate namespace parent.
                    if (node.isInJSDocNamespace) {
                        var parentNode = node.parent;
                        while (parentNode && parentNode.kind !== 285 /* JSDocTypedefTag */) {
                            parentNode = parentNode.parent;
                        }
                        bindBlockScopedDeclaration(parentNode, 524288 /* TypeAlias */, 793064 /* TypeAliasExcludes */);
                        break;
                    }
                case 98 /* ThisKeyword */:
                    if (currentFlow && (ts.isExpression(node) || parent.kind === 258 /* ShorthandPropertyAssignment */)) {
                        node.flowNode = currentFlow;
                    }
                    return checkStrictModeIdentifier(node);
                case 177 /* PropertyAccessExpression */:
                    if (currentFlow && isNarrowableReference(node)) {
                        node.flowNode = currentFlow;
                    }
                    break;
                case 192 /* BinaryExpression */:
                    if (ts.isInJavaScriptFile(node)) {
                        var specialKind = ts.getSpecialPropertyAssignmentKind(node);
                        switch (specialKind) {
                            case 1 /* ExportsProperty */:
                                bindExportsPropertyAssignment(node);
                                break;
                            case 2 /* ModuleExports */:
                                bindModuleExportsAssignment(node);
                                break;
                            case 3 /* PrototypeProperty */:
                                bindPrototypePropertyAssignment(node);
                                break;
                            case 4 /* ThisProperty */:
                                bindThisPropertyAssignment(node);
                                break;
                            case 0 /* None */:
                                // Nothing to do
                                break;
                            default:
                                ts.Debug.fail("Unknown special property assignment kind");
                        }
                    }
                    return checkStrictModeBinaryExpression(node);
                case 256 /* CatchClause */:
                    return checkStrictModeCatchClause(node);
                case 186 /* DeleteExpression */:
                    return checkStrictModeDeleteExpression(node);
                case 8 /* NumericLiteral */:
                    return checkStrictModeNumericLiteral(node);
                case 191 /* PostfixUnaryExpression */:
                    return checkStrictModePostfixUnaryExpression(node);
                case 190 /* PrefixUnaryExpression */:
                    return checkStrictModePrefixUnaryExpression(node);
                case 217 /* WithStatement */:
                    return checkStrictModeWithStatement(node);
                case 167 /* ThisType */:
                    seenThisKeyword = true;
                    return;
                case 156 /* TypePredicate */:
                    return checkTypePredicate(node);
                case 143 /* TypeParameter */:
                    return declareSymbolAndAddToSymbolTable(node, 262144 /* TypeParameter */, 530920 /* TypeParameterExcludes */);
                case 144 /* Parameter */:
                    return bindParameter(node);
                case 223 /* VariableDeclaration */:
                case 174 /* BindingElement */:
                    return bindVariableDeclarationOrBindingElement(node);
                case 147 /* PropertyDeclaration */:
                case 146 /* PropertySignature */:
                case 271 /* JSDocRecordMember */:
                    return bindPropertyOrMethodOrAccessor(node, 4 /* Property */ | (node.questionToken ? 536870912 /* Optional */ : 0 /* None */), 0 /* PropertyExcludes */);
                case 286 /* JSDocPropertyTag */:
                    return bindJSDocProperty(node);
                case 257 /* PropertyAssignment */:
                case 258 /* ShorthandPropertyAssignment */:
                    return bindPropertyOrMethodOrAccessor(node, 4 /* Property */, 0 /* PropertyExcludes */);
                case 260 /* EnumMember */:
                    return bindPropertyOrMethodOrAccessor(node, 8 /* EnumMember */, 900095 /* EnumMemberExcludes */);
                case 259 /* SpreadAssignment */:
                case 251 /* JsxSpreadAttribute */:
                    var root = container;
                    var hasRest = false;
                    while (root.parent) {
                        if (root.kind === 176 /* ObjectLiteralExpression */ &&
                            root.parent.kind === 192 /* BinaryExpression */ &&
                            root.parent.operatorToken.kind === 57 /* EqualsToken */ &&
                            root.parent.left === root) {
                            hasRest = true;
                            break;
                        }
                        root = root.parent;
                    }
                    return;
                case 153 /* CallSignature */:
                case 154 /* ConstructSignature */:
                case 155 /* IndexSignature */:
                    return declareSymbolAndAddToSymbolTable(node, 131072 /* Signature */, 0 /* None */);
                case 149 /* MethodDeclaration */:
                case 148 /* MethodSignature */:
                    // If this is an ObjectLiteralExpression method, then it sits in the same space
                    // as other properties in the object literal.  So we use SymbolFlags.PropertyExcludes
                    // so that it will conflict with any other object literal members with the same
                    // name.
                    return bindPropertyOrMethodOrAccessor(node, 8192 /* Method */ | (node.questionToken ? 536870912 /* Optional */ : 0 /* None */), ts.isObjectLiteralMethod(node) ? 0 /* PropertyExcludes */ : 99263 /* MethodExcludes */);
                case 225 /* FunctionDeclaration */:
                    return bindFunctionDeclaration(node);
                case 150 /* Constructor */:
                    return declareSymbolAndAddToSymbolTable(node, 16384 /* Constructor */, /*symbolExcludes:*/ 0 /* None */);
                case 151 /* GetAccessor */:
                    return bindPropertyOrMethodOrAccessor(node, 32768 /* GetAccessor */, 41919 /* GetAccessorExcludes */);
                case 152 /* SetAccessor */:
                    return bindPropertyOrMethodOrAccessor(node, 65536 /* SetAccessor */, 74687 /* SetAccessorExcludes */);
                case 158 /* FunctionType */:
                case 159 /* ConstructorType */:
                case 274 /* JSDocFunctionType */:
                    return bindFunctionOrConstructorType(node);
                case 161 /* TypeLiteral */:
                case 170 /* MappedType */:
                case 287 /* JSDocTypeLiteral */:
                case 270 /* JSDocRecordType */:
                    return bindAnonymousDeclaration(node, 2048 /* TypeLiteral */, "__type");
                case 176 /* ObjectLiteralExpression */:
                    return bindObjectLiteralExpression(node);
                case 184 /* FunctionExpression */:
                case 185 /* ArrowFunction */:
                    return bindFunctionExpression(node);
                case 179 /* CallExpression */:
                    if (ts.isInJavaScriptFile(node)) {
                        bindCallExpression(node);
                    }
                    break;
                // Members of classes, interfaces, and modules
                case 197 /* ClassExpression */:
                case 226 /* ClassDeclaration */:
                    // All classes are automatically in strict mode in ES6.
                    inStrictMode = true;
                    return bindClassLikeDeclaration(node);
                case 227 /* InterfaceDeclaration */:
                    return bindBlockScopedDeclaration(node, 64 /* Interface */, 792968 /* InterfaceExcludes */);
                case 285 /* JSDocTypedefTag */:
                    if (!node.fullName || node.fullName.kind === 70 /* Identifier */) {
                        return bindBlockScopedDeclaration(node, 524288 /* TypeAlias */, 793064 /* TypeAliasExcludes */);
                    }
                    break;
                case 228 /* TypeAliasDeclaration */:
                    return bindBlockScopedDeclaration(node, 524288 /* TypeAlias */, 793064 /* TypeAliasExcludes */);
                case 229 /* EnumDeclaration */:
                    return bindEnumDeclaration(node);
                case 230 /* ModuleDeclaration */:
                    return bindModuleDeclaration(node);
                // Imports and exports
                case 234 /* ImportEqualsDeclaration */:
                case 237 /* NamespaceImport */:
                case 239 /* ImportSpecifier */:
                case 243 /* ExportSpecifier */:
                    return declareSymbolAndAddToSymbolTable(node, 8388608 /* Alias */, 8388608 /* AliasExcludes */);
                case 233 /* NamespaceExportDeclaration */:
                    return bindNamespaceExportDeclaration(node);
                case 236 /* ImportClause */:
                    return bindImportClause(node);
                case 241 /* ExportDeclaration */:
                    return bindExportDeclaration(node);
                case 240 /* ExportAssignment */:
                    return bindExportAssignment(node);
                case 261 /* SourceFile */:
                    updateStrictModeStatementList(node.statements);
                    return bindSourceFileIfExternalModule();
                case 204 /* Block */:
                    if (!ts.isFunctionLike(node.parent)) {
                        return;
                    }
                // Fall through
                case 231 /* ModuleBlock */:
                    return updateStrictModeStatementList(node.statements);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkTypePredicate) id{215,1} ---
(node) {
            var parameterName = node.parameterName, type = node.type;
            if (parameterName && parameterName.kind === 70 /* Identifier */) {
                checkStrictModeIdentifier(parameterName);
            }
            if (parameterName && parameterName.kind === 167 /* ThisType */) {
                seenThisKeyword = true;
            }
            bind(type);
        }
--- END ---
INLINE (checkTypePredicate) id{215,1} AS 1 AT <0:3560>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:declareSymbolAndAddToSymbolTable) id{215,2} ---
(node, symbolFlags, symbolExcludes) {
            // Just call this directly so that the return type of this function stays "void".
            return declareSymbolAndAddToSymbolTableWorker(node, symbolFlags, symbolExcludes);
        }
--- END ---
INLINE (declareSymbolAndAddToSymbolTable) id{215,2} AS 2 AT <0:3659>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:declareSymbolAndAddToSymbolTable) id{215,3} ---
(node, symbolFlags, symbolExcludes) {
            // Just call this directly so that the return type of this function stays "void".
            return declareSymbolAndAddToSymbolTableWorker(node, symbolFlags, symbolExcludes);
        }
--- END ---
INLINE (declareSymbolAndAddToSymbolTable) id{215,3} AS 3 AT <0:5731>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:updateStrictModeStatementList) id{215,4} ---
(statements) {
            if (!inStrictMode) {
                for (var _i = 0, statements_2 = statements; _i < statements_2.length; _i++) {
                    var statement = statements_2[_i];
                    if (!ts.isPrologueDirective(statement)) {
                        return;
                    }
                    if (isUseStrictPrologueDirective(statement)) {
                        inStrictMode = true;
                        return;
                    }
                }
            }
        }
--- END ---
INLINE (updateStrictModeStatementList) id{215,4} AS 4 AT <0:10085>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:bindSourceFileIfExternalModule) id{215,5} ---
() {
            setExportContextFlag(file);
            if (ts.isExternalModule(file)) {
                bindSourceFileAsExternalModule();
            }
        }
--- END ---
INLINE (bindSourceFileIfExternalModule) id{215,5} AS 5 AT <0:10160>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:setExportContextFlag) id{215,6} ---
(node) {
            // A declaration source file or ambient module declaration that contains no export declarations (but possibly regular
            // declarations with export modifiers) is an export context in which declarations are implicitly exported.
            if (ts.isInAmbientContext(node) && !hasExportDeclarations(node)) {
                node.flags |= 32 /* ExportContext */;
            }
            else {
                node.flags &= ~32 /* ExportContext */;
            }
        }
--- END ---
INLINE (setExportContextFlag) id{215,6} AS 6 AT <5:17>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:hasExportDeclarations) id{215,7} ---
(node) {
            var body = node.kind === 261 /* SourceFile */ ? node : node.body;
            if (body && (body.kind === 261 /* SourceFile */ || body.kind === 231 /* ModuleBlock */)) {
                for (var _i = 0, _a = body.statements; _i < _a.length; _i++) {
                    var stat = _a[_i];
                    if (stat.kind === 241 /* ExportDeclaration */ || stat.kind === 240 /* ExportAssignment */) {
                        return true;
                    }
                }
            }
            return false;
        }
--- END ---
INLINE (hasExportDeclarations) id{215,7} AS 7 AT <6:306>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:bindParameter) id{216,0} ---
(node) {
            if (inStrictMode) {
                // It is a SyntaxError if the identifier eval or arguments appears within a FormalParameterList of a
                // strict mode FunctionLikeDeclaration or FunctionExpression(13.1)
                checkStrictModeEvalOrArguments(node, node.name);
            }
            if (ts.isBindingPattern(node.name)) {
                bindAnonymousDeclaration(node, 1 /* FunctionScopedVariable */, getDestructuringParameterName(node));
            }
            else {
                declareSymbolAndAddToSymbolTable(node, 1 /* FunctionScopedVariable */, 107455 /* ParameterExcludes */);
            }
            // If this is a property-parameter, then also declare the property symbol into the
            // containing class.
            if (ts.isParameterPropertyDeclaration(node)) {
                var classDeclaration = node.parent.parent;
                declareSymbol(classDeclaration.symbol.members, classDeclaration.symbol, node, 4 /* Property */ | (node.questionToken ? 536870912 /* Optional */ : 0 /* None */), 0 /* PropertyExcludes */);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:declareSymbolAndAddToSymbolTable) id{216,1} ---
(node, symbolFlags, symbolExcludes) {
            // Just call this directly so that the return type of this function stays "void".
            return declareSymbolAndAddToSymbolTableWorker(node, symbolFlags, symbolExcludes);
        }
--- END ---
INLINE (declareSymbolAndAddToSymbolTable) id{216,1} AS 1 AT <0:536>
[deoptimizing (DEOPT soft): begin 0x2f05bb805771 <JS Function declareSymbolAndAddToSymbolTableWorker (SharedFunctionInfo 0x16f3adb5ab21)> (opt #211) @2, FP to SP delta: 40, caller sp: 0x7fff5fbfd998]
            ;;; deoptimize at 0_50: Insufficient type feedback for combined type of binary operation
  reading input frame declareSymbolAndAddToSymbolTableWorker => node=30, args=4, height=3; inputs:
      0: 0x2f05bb805771 ; [fp - 16] 0x2f05bb805771 <JS Function declareSymbolAndAddToSymbolTableWorker (SharedFunctionInfo 0x16f3adb5ab21)>
      1: 0x1f9f6c0532e1 ; [fp + 40] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x286514c33559 ; [fp + 32] 0x286514c33559 <a NodeObject with map 0x33abe2a67889>
      3: 0x4000000000000 ; [fp + 24] 262144
      4: 0x819e800000000 ; [fp + 16] 530920
      5: 0xd6230dfeea1 ; [fp - 24] 0xd6230dfeea1 <FixedArray[147]>
      6: 0x30bcea4069a9 ; (literal 4) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0xe400000000 ; rax 228
  translating frame declareSymbolAndAddToSymbolTableWorker => node=30, height=16
    0x7fff5fbfd990: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd988: [top + 64] <- 0x286514c33559 ;  0x286514c33559 <a NodeObject with map 0x33abe2a67889>  (input #2)
    0x7fff5fbfd980: [top + 56] <- 0x4000000000000 ;  262144  (input #3)
    0x7fff5fbfd978: [top + 48] <- 0x819e800000000 ;  530920  (input #4)
    0x7fff5fbfd970: [top + 40] <- 0x2c21d255f2d5 ;  caller's pc
    0x7fff5fbfd968: [top + 32] <- 0x7fff5fbfda68 ;  caller's fp
    0x7fff5fbfd960: [top + 24] <- 0xd6230dfeea1 ;  context    0xd6230dfeea1 <FixedArray[147]>  (input #5)
    0x7fff5fbfd958: [top + 16] <- 0x2f05bb805771 ;  function    0x2f05bb805771 <JS Function declareSymbolAndAddToSymbolTableWorker (SharedFunctionInfo 0x16f3adb5ab21)>  (input #0)
    0x7fff5fbfd950: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfd948: [top + 0] <- 0xe400000000 ;  228  (input #7)
[deoptimizing (soft): end 0x2f05bb805771 <JS Function declareSymbolAndAddToSymbolTableWorker (SharedFunctionInfo 0x16f3adb5ab21)> @2 => node=30, pc=0x2c21d2526886, caller sp=0x7fff5fbfd998, state=NO_REGISTERS, took 0.063 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:forEachChild) id{217,0} ---
(node, cbNode, cbNodeArray) {
        if (!node) {
            return;
        }
        // The visitXXX functions could be written as local functions that close over the cbNode and cbNodeArray
        // callback parameters, but that causes a closure allocation for each invocation with noticeable effects
        // on performance.
        var visitNodes = cbNodeArray ? visitNodeArray : visitEachNode;
        var cbNodes = cbNodeArray || cbNode;
        switch (node.kind) {
            case 141 /* QualifiedName */:
                return visitNode(cbNode, node.left) ||
                    visitNode(cbNode, node.right);
            case 143 /* TypeParameter */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.constraint) ||
                    visitNode(cbNode, node.expression);
            case 258 /* ShorthandPropertyAssignment */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNode(cbNode, node.equalsToken) ||
                    visitNode(cbNode, node.objectAssignmentInitializer);
            case 259 /* SpreadAssignment */:
                return visitNode(cbNode, node.expression);
            case 144 /* Parameter */:
            case 147 /* PropertyDeclaration */:
            case 146 /* PropertySignature */:
            case 257 /* PropertyAssignment */:
            case 223 /* VariableDeclaration */:
            case 174 /* BindingElement */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.propertyName) ||
                    visitNode(cbNode, node.dotDotDotToken) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNode(cbNode, node.type) ||
                    visitNode(cbNode, node.initializer);
            case 158 /* FunctionType */:
            case 159 /* ConstructorType */:
            case 153 /* CallSignature */:
            case 154 /* ConstructSignature */:
            case 155 /* IndexSignature */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNodes(cbNodes, node.parameters) ||
                    visitNode(cbNode, node.type);
            case 149 /* MethodDeclaration */:
            case 148 /* MethodSignature */:
            case 150 /* Constructor */:
            case 151 /* GetAccessor */:
            case 152 /* SetAccessor */:
            case 184 /* FunctionExpression */:
            case 225 /* FunctionDeclaration */:
            case 185 /* ArrowFunction */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.asteriskToken) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNodes(cbNodes, node.parameters) ||
                    visitNode(cbNode, node.type) ||
                    visitNode(cbNode, node.equalsGreaterThanToken) ||
                    visitNode(cbNode, node.body);
            case 157 /* TypeReference */:
                return visitNode(cbNode, node.typeName) ||
                    visitNodes(cbNodes, node.typeArguments);
            case 156 /* TypePredicate */:
                return visitNode(cbNode, node.parameterName) ||
                    visitNode(cbNode, node.type);
            case 160 /* TypeQuery */:
                return visitNode(cbNode, node.exprName);
            case 161 /* TypeLiteral */:
                return visitNodes(cbNodes, node.members);
            case 162 /* ArrayType */:
                return visitNode(cbNode, node.elementType);
            case 163 /* TupleType */:
                return visitNodes(cbNodes, node.elementTypes);
            case 164 /* UnionType */:
            case 165 /* IntersectionType */:
                return visitNodes(cbNodes, node.types);
            case 166 /* ParenthesizedType */:
            case 168 /* TypeOperator */:
                return visitNode(cbNode, node.type);
            case 169 /* IndexedAccessType */:
                return visitNode(cbNode, node.objectType) ||
                    visitNode(cbNode, node.indexType);
            case 170 /* MappedType */:
                return visitNode(cbNode, node.readonlyToken) ||
                    visitNode(cbNode, node.typeParameter) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNode(cbNode, node.type);
            case 171 /* LiteralType */:
                return visitNode(cbNode, node.literal);
            case 172 /* ObjectBindingPattern */:
            case 173 /* ArrayBindingPattern */:
                return visitNodes(cbNodes, node.elements);
            case 175 /* ArrayLiteralExpression */:
                return visitNodes(cbNodes, node.elements);
            case 176 /* ObjectLiteralExpression */:
                return visitNodes(cbNodes, node.properties);
            case 177 /* PropertyAccessExpression */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.name);
            case 178 /* ElementAccessExpression */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.argumentExpression);
            case 179 /* CallExpression */:
            case 180 /* NewExpression */:
                return visitNode(cbNode, node.expression) ||
                    visitNodes(cbNodes, node.typeArguments) ||
                    visitNodes(cbNodes, node.arguments);
            case 181 /* TaggedTemplateExpression */:
                return visitNode(cbNode, node.tag) ||
                    visitNode(cbNode, node.template);
            case 182 /* TypeAssertionExpression */:
                return visitNode(cbNode, node.type) ||
                    visitNode(cbNode, node.expression);
            case 183 /* ParenthesizedExpression */:
                return visitNode(cbNode, node.expression);
            case 186 /* DeleteExpression */:
                return visitNode(cbNode, node.expression);
            case 187 /* TypeOfExpression */:
                return visitNode(cbNode, node.expression);
            case 188 /* VoidExpression */:
                return visitNode(cbNode, node.expression);
            case 190 /* PrefixUnaryExpression */:
                return visitNode(cbNode, node.operand);
            case 195 /* YieldExpression */:
                return visitNode(cbNode, node.asteriskToken) ||
                    visitNode(cbNode, node.expression);
            case 189 /* AwaitExpression */:
                return visitNode(cbNode, node.expression);
            case 191 /* PostfixUnaryExpression */:
                return visitNode(cbNode, node.operand);
            case 192 /* BinaryExpression */:
                return visitNode(cbNode, node.left) ||
                    visitNode(cbNode, node.operatorToken) ||
                    visitNode(cbNode, node.right);
            case 200 /* AsExpression */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.type);
            case 201 /* NonNullExpression */:
                return visitNode(cbNode, node.expression);
            case 193 /* ConditionalExpression */:
                return visitNode(cbNode, node.condition) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNode(cbNode, node.whenTrue) ||
                    visitNode(cbNode, node.colonToken) ||
                    visitNode(cbNode, node.whenFalse);
            case 196 /* SpreadElement */:
                return visitNode(cbNode, node.expression);
            case 204 /* Block */:
            case 231 /* ModuleBlock */:
                return visitNodes(cbNodes, node.statements);
            case 261 /* SourceFile */:
                return visitNodes(cbNodes, node.statements) ||
                    visitNode(cbNode, node.endOfFileToken);
            case 205 /* VariableStatement */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.declarationList);
            case 224 /* VariableDeclarationList */:
                return visitNodes(cbNodes, node.declarations);
            case 207 /* ExpressionStatement */:
                return visitNode(cbNode, node.expression);
            case 208 /* IfStatement */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.thenStatement) ||
                    visitNode(cbNode, node.elseStatement);
            case 209 /* DoStatement */:
                return visitNode(cbNode, node.statement) ||
                    visitNode(cbNode, node.expression);
            case 210 /* WhileStatement */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.statement);
            case 211 /* ForStatement */:
                return visitNode(cbNode, node.initializer) ||
                    visitNode(cbNode, node.condition) ||
                    visitNode(cbNode, node.incrementor) ||
                    visitNode(cbNode, node.statement);
            case 212 /* ForInStatement */:
                return visitNode(cbNode, node.initializer) ||
                    visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.statement);
            case 213 /* ForOfStatement */:
                return visitNode(cbNode, node.initializer) ||
                    visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.statement);
            case 214 /* ContinueStatement */:
            case 215 /* BreakStatement */:
                return visitNode(cbNode, node.label);
            case 216 /* ReturnStatement */:
                return visitNode(cbNode, node.expression);
            case 217 /* WithStatement */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.statement);
            case 218 /* SwitchStatement */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.caseBlock);
            case 232 /* CaseBlock */:
                return visitNodes(cbNodes, node.clauses);
            case 253 /* CaseClause */:
                return visitNode(cbNode, node.expression) ||
                    visitNodes(cbNodes, node.statements);
            case 254 /* DefaultClause */:
                return visitNodes(cbNodes, node.statements);
            case 219 /* LabeledStatement */:
                return visitNode(cbNode, node.label) ||
                    visitNode(cbNode, node.statement);
            case 220 /* ThrowStatement */:
                return visitNode(cbNode, node.expression);
            case 221 /* TryStatement */:
                return visitNode(cbNode, node.tryBlock) ||
                    visitNode(cbNode, node.catchClause) ||
                    visitNode(cbNode, node.finallyBlock);
            case 256 /* CatchClause */:
                return visitNode(cbNode, node.variableDeclaration) ||
                    visitNode(cbNode, node.block);
            case 145 /* Decorator */:
                return visitNode(cbNode, node.expression);
            case 226 /* ClassDeclaration */:
            case 197 /* ClassExpression */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNodes(cbNodes, node.heritageClauses) ||
                    visitNodes(cbNodes, node.members);
            case 227 /* InterfaceDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNodes(cbNodes, node.heritageClauses) ||
                    visitNodes(cbNodes, node.members);
            case 228 /* TypeAliasDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNode(cbNode, node.type);
            case 229 /* EnumDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.members);
            case 260 /* EnumMember */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.initializer);
            case 230 /* ModuleDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.body);
            case 234 /* ImportEqualsDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.moduleReference);
            case 235 /* ImportDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.importClause) ||
                    visitNode(cbNode, node.moduleSpecifier);
            case 236 /* ImportClause */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.namedBindings);
            case 233 /* NamespaceExportDeclaration */:
                return visitNode(cbNode, node.name);
            case 237 /* NamespaceImport */:
                return visitNode(cbNode, node.name);
            case 238 /* NamedImports */:
            case 242 /* NamedExports */:
                return visitNodes(cbNodes, node.elements);
            case 241 /* ExportDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.exportClause) ||
                    visitNode(cbNode, node.moduleSpecifier);
            case 239 /* ImportSpecifier */:
            case 243 /* ExportSpecifier */:
                return visitNode(cbNode, node.propertyName) ||
                    visitNode(cbNode, node.name);
            case 240 /* ExportAssignment */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.expression);
            case 194 /* TemplateExpression */:
                return visitNode(cbNode, node.head) || visitNodes(cbNodes, node.templateSpans);
            case 202 /* TemplateSpan */:
                return visitNode(cbNode, node.expression) || visitNode(cbNode, node.literal);
            case 142 /* ComputedPropertyName */:
                return visitNode(cbNode, node.expression);
            case 255 /* HeritageClause */:
                return visitNodes(cbNodes, node.types);
            case 199 /* ExpressionWithTypeArguments */:
                return visitNode(cbNode, node.expression) ||
                    visitNodes(cbNodes, node.typeArguments);
            case 245 /* ExternalModuleReference */:
                return visitNode(cbNode, node.expression);
            case 244 /* MissingDeclaration */:
                return visitNodes(cbNodes, node.decorators);
            case 246 /* JsxElement */:
                return visitNode(cbNode, node.openingElement) ||
                    visitNodes(cbNodes, node.children) ||
                    visitNode(cbNode, node.closingElement);
            case 247 /* JsxSelfClosingElement */:
            case 248 /* JsxOpeningElement */:
                return visitNode(cbNode, node.tagName) ||
                    visitNodes(cbNodes, node.attributes);
            case 250 /* JsxAttribute */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.initializer);
            case 251 /* JsxSpreadAttribute */:
                return visitNode(cbNode, node.expression);
            case 252 /* JsxExpression */:
                return visitNode(cbNode, node.expression);
            case 249 /* JsxClosingElement */:
                return visitNode(cbNode, node.tagName);
            case 262 /* JSDocTypeExpression */:
                return visitNode(cbNode, node.type);
            case 266 /* JSDocUnionType */:
                return visitNodes(cbNodes, node.types);
            case 267 /* JSDocTupleType */:
                return visitNodes(cbNodes, node.types);
            case 265 /* JSDocArrayType */:
                return visitNode(cbNode, node.elementType);
            case 269 /* JSDocNonNullableType */:
                return visitNode(cbNode, node.type);
            case 268 /* JSDocNullableType */:
                return visitNode(cbNode, node.type);
            case 270 /* JSDocRecordType */:
                return visitNode(cbNode, node.literal);
            case 272 /* JSDocTypeReference */:
                return visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.typeArguments);
            case 273 /* JSDocOptionalType */:
                return visitNode(cbNode, node.type);
            case 274 /* JSDocFunctionType */:
                return visitNodes(cbNodes, node.parameters) ||
                    visitNode(cbNode, node.type);
            case 275 /* JSDocVariadicType */:
                return visitNode(cbNode, node.type);
            case 276 /* JSDocConstructorType */:
                return visitNode(cbNode, node.type);
            case 277 /* JSDocThisType */:
                return visitNode(cbNode, node.type);
            case 271 /* JSDocRecordMember */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.type);
            case 278 /* JSDocComment */:
                return visitNodes(cbNodes, node.tags);
            case 281 /* JSDocParameterTag */:
                return visitNode(cbNode, node.preParameterName) ||
                    visitNode(cbNode, node.typeExpression) ||
                    visitNode(cbNode, node.postParameterName);
            case 282 /* JSDocReturnTag */:
                return visitNode(cbNode, node.typeExpression);
            case 283 /* JSDocTypeTag */:
                return visitNode(cbNode, node.typeExpression);
            case 280 /* JSDocAugmentsTag */:
                return visitNode(cbNode, node.typeExpression);
            case 284 /* JSDocTemplateTag */:
                return visitNodes(cbNodes, node.typeParameters);
            case 285 /* JSDocTypedefTag */:
                return visitNode(cbNode, node.typeExpression) ||
                    visitNode(cbNode, node.fullName) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.jsDocTypeLiteral);
            case 287 /* JSDocTypeLiteral */:
                return visitNodes(cbNodes, node.jsDocPropertyTags);
            case 286 /* JSDocPropertyTag */:
                return visitNode(cbNode, node.typeExpression) ||
                    visitNode(cbNode, node.name);
            case 294 /* PartiallyEmittedExpression */:
                return visitNode(cbNode, node.expression);
            case 288 /* JSDocLiteralType */:
                return visitNode(cbNode, node.literal);
        }
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{217,1} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{217,1} AS 1 AT <0:692>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{217,2} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{217,2} AS 2 AT <0:744>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{217,3} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{217,3} AS 3 AT <0:802>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{217,4} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{217,4} AS 4 AT <0:1658>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{217,5} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{217,5} AS 5 AT <0:1718>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{217,6} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{217,6} AS 6 AT <0:1777>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{217,7} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{217,7} AS 7 AT <0:1837>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{217,8} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{217,8} AS 8 AT <0:1899>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{217,9} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{217,9} AS 9 AT <0:1951>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{217,10} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{217,10} AS 10 AT <0:2012>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{217,11} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{217,11} AS 11 AT <0:2064>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{217,12} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{217,12} AS 12 AT <0:2341>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{217,13} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{217,13} AS 13 AT <0:2401>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{217,14} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{217,14} AS 14 AT <0:2460>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{217,15} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{217,15} AS 15 AT <0:2524>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{217,16} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{217,16} AS 16 AT <0:2584>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{217,17} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{217,17} AS 17 AT <0:2984>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{217,18} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{217,18} AS 18 AT <0:3044>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{217,19} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{217,19} AS 19 AT <0:3103>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{217,20} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{217,20} AS 20 AT <0:3164>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{217,21} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{217,21} AS 21 AT <0:3216>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{217,22} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{217,22} AS 22 AT <0:3277>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{217,23} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{217,23} AS 23 AT <0:3341>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{217,24} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{217,24} AS 24 AT <0:3401>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{217,25} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{217,25} AS 25 AT <0:3453>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{217,26} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{217,26} AS 26 AT <0:3523>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{217,27} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{217,27} AS 27 AT <0:3618>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{217,28} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{217,28} AS 28 AT <0:3674>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{217,29} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{217,29} AS 29 AT <0:3780>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{217,30} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{217,30} AS 30 AT <0:3841>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{217,31} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{217,31} AS 31 AT <0:4125>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{217,32} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{217,32} AS 32 AT <0:4223>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{217,33} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{217,33} AS 33 AT <0:4369>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{217,34} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{217,34} AS 34 AT <0:4512>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{217,35} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{217,35} AS 35 AT <0:4611>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{217,36} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{217,36} AS 36 AT <0:4669>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{217,37} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{217,37} AS 37 AT <0:4766>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{217,38} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{217,38} AS 38 AT <0:4827>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{217,39} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{217,39} AS 39 AT <0:4888>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{217,40} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{217,40} AS 40 AT <0:4949>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{217,41} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{217,41} AS 41 AT <0:8393>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{217,42} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{217,42} AS 42 AT <0:8562>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{217,43} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{217,43} AS 43 AT <0:8622>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{217,44} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{217,44} AS 44 AT <0:8681>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{217,45} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{217,45} AS 45 AT <0:8797>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{217,46} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{217,46} AS 46 AT <0:12363>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{217,47} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{217,47} AS 47 AT <0:12423>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{217,48} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{217,48} AS 48 AT <0:12482>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{217,49} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{217,49} AS 49 AT <0:12534>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{217,50} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{217,50} AS 50 AT <0:12598>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{217,51} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{217,51} AS 51 AT <0:12663>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{217,52} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{217,52} AS 52 AT <0:12770>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{217,53} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{217,53} AS 53 AT <0:12830>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{217,54} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{217,54} AS 54 AT <0:12889>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{217,55} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{217,55} AS 55 AT <0:12941>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{217,56} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{217,56} AS 56 AT <0:13005>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{217,57} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{217,57} AS 57 AT <0:15971>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{217,58} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{217,58} AS 58 AT <0:16083>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:declareSymbolAndAddToSymbolTableWorker) id{218,0} ---
(node, symbolFlags, symbolExcludes) {
            switch (container.kind) {
                // Modules, source files, and classes need specialized handling for how their
                // members are declared (for example, a member of a class will go into a specific
                // symbol table depending on if it is static or not). We defer to specialized
                // handlers to take care of declaring these child members.
                case 230 /* ModuleDeclaration */:
                    return declareModuleMember(node, symbolFlags, symbolExcludes);
                case 261 /* SourceFile */:
                    return declareSourceFileMember(node, symbolFlags, symbolExcludes);
                case 197 /* ClassExpression */:
                case 226 /* ClassDeclaration */:
                    return declareClassMember(node, symbolFlags, symbolExcludes);
                case 229 /* EnumDeclaration */:
                    return declareSymbol(container.symbol.exports, container.symbol, node, symbolFlags, symbolExcludes);
                case 161 /* TypeLiteral */:
                case 176 /* ObjectLiteralExpression */:
                case 227 /* InterfaceDeclaration */:
                case 270 /* JSDocRecordType */:
                case 287 /* JSDocTypeLiteral */:
                    // Interface/Object-types always have their children added to the 'members' of
                    // their container. They are only accessible through an instance of their
                    // container, and are never in scope otherwise (even inside the body of the
                    // object / type / interface declaring them). An exception is type parameters,
                    // which are in scope without qualification (similar to 'locals').
                    return declareSymbol(container.symbol.members, container.symbol, node, symbolFlags, symbolExcludes);
                case 158 /* FunctionType */:
                case 159 /* ConstructorType */:
                case 153 /* CallSignature */:
                case 154 /* ConstructSignature */:
                case 155 /* IndexSignature */:
                case 149 /* MethodDeclaration */:
                case 148 /* MethodSignature */:
                case 150 /* Constructor */:
                case 151 /* GetAccessor */:
                case 152 /* SetAccessor */:
                case 225 /* FunctionDeclaration */:
                case 184 /* FunctionExpression */:
                case 185 /* ArrowFunction */:
                case 274 /* JSDocFunctionType */:
                case 228 /* TypeAliasDeclaration */:
                case 170 /* MappedType */:
                    // All the children of these container types are never visible through another
                    // symbol (i.e. through another symbol's 'exports' or 'members').  Instead,
                    // they're only accessed 'lexically' (i.e. from code that exists underneath
                    // their container in the tree.  To accomplish this, we simply add their declared
                    // symbol to the 'locals' of the container.  These symbols can then be found as
                    // the type checker walks up the containers, checking them for matching names.
                    return declareSymbol(container.locals, /*parent*/ undefined, node, symbolFlags, symbolExcludes);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:declareSourceFileMember) id{218,1} ---
(node, symbolFlags, symbolExcludes) {
            return ts.isExternalModule(file)
                ? declareModuleMember(node, symbolFlags, symbolExcludes)
                : declareSymbol(file.locals, undefined, node, symbolFlags, symbolExcludes);
        }
--- END ---
INLINE (declareSourceFileMember) id{218,1} AS 1 AT <0:640>
[marking dependent code 0x2c21d2559ac1 (opt #209) for deoptimization, reason: allocation-site-tenuring-changed]
[marking dependent code 0x2c21d24b8221 (opt #119) for deoptimization, reason: allocation-site-tenuring-changed]
[marking dependent code 0x2c21d250d961 (opt #180) for deoptimization, reason: allocation-site-tenuring-changed]
[marking dependent code 0x2c21d23f9a81 (opt #170) for deoptimization, reason: allocation-site-tenuring-changed]
[marking dependent code 0x2c21d24b26a1 (opt #115) for deoptimization, reason: allocation-site-tenuring-changed]
[deoptimize marked code in all contexts]
[deoptimizer unlinked: addDeclarationToSymbol / 2f05bb804691]
[deoptimizer unlinked: addTag / 215b0af9beb1]
[deoptimizer unlinked: addTag / 215b0af9e449]
[deoptimizer unlinked: addTag / 215b0afc5739]
[deoptimizer unlinked: addTag / 215b0afc7069]
[deoptimizer unlinked: addTag / 215b0afcc981]
[deoptimizer unlinked: addTag / 215b0afce271]
[deoptimizer unlinked: addTag / 215b0afd9841]
[deoptimizer unlinked: addTag / 215b0afde959]
[deoptimizer unlinked: addTag / 215b0af6a779]
[deoptimizer unlinked: addTag / 215b0af94c61]
[deoptimizer unlinked: addTag / 215b0af991e1]
[deoptimizer unlinked: addTag / 215b0af9c1c9]
[deoptimizer unlinked: addTag / 215b0afa1d89]
[deoptimizer unlinked: addTag / 215b0afee561]
[deoptimizer unlinked: addTag / 4179de53c49]
[deoptimizer unlinked: addTag / 4179de54f09]
[deoptimizer unlinked: addTag / 4179de56af1]
[deoptimizer unlinked: addTag / 4179de57fa9]
[deoptimizer unlinked: addTag / 4179deba231]
[deoptimizer unlinked: addTag / 4179dec79d9]
[deoptimizer unlinked: addTag / 4179dedc721]
[deoptimizer unlinked: addTag / 4179dedf349]
[deoptimizer unlinked: addTag / 4179dee35b9]
[deoptimizer unlinked: addTag / 2e2f69322c71]
[deoptimizer unlinked: addTag / 2e2f69323c21]
[deoptimizer unlinked: addTag / 2e2f69326321]
[deoptimizer unlinked: addTag / 2e2f693272b1]
[deoptimizer unlinked: addTag / 2e2f693284d9]
[deoptimizer unlinked: addTag / 2e2f69329d59]
[deoptimizer unlinked: addTag / 2e2f6932b0a1]
[deoptimizer unlinked: addTag / 2e2f6932c4c9]
[deoptimizer unlinked: addTag / 2e2f6932e5d9]
[deoptimizer unlinked: addTag / 2e2f69333389]
[deoptimizer unlinked: addTag / 2e2f69334321]
[deoptimizer unlinked: addTag / 2e2f69335bf1]
[deoptimizer unlinked: addTag / 2e2f69338af1]
[deoptimizer unlinked: addTag / 2e2f6933a0a1]
[deoptimizer unlinked: addTag / 2e2f6933b761]
[deoptimizer unlinked: addTag / 2e2f6933df69]
[deoptimizer unlinked: addTag / 2e2f6933f071]
[deoptimizer unlinked: addTag / 2e2f69342ef1]
[deoptimizer unlinked: addTag / 2e2f693440c9]
[deoptimizer unlinked: addTag / 2e2f69347989]
[deoptimizer unlinked: addTag / 2e2f693487f1]
[deoptimizer unlinked: addTag / 2e2f69352159]
[deoptimizer unlinked: addTag / 2e2f69353139]
[deoptimizer unlinked: addTag / 2e2f69354661]
[deoptimizer unlinked: addTag / 2e2f69355ab1]
[deoptimizer unlinked: addTag / 2e2f69357029]
[deoptimizer unlinked: addTag / 2e2f69358609]
[deoptimizer unlinked: addTag / 2e2f69359a29]
[deoptimizer unlinked: addTag / 2e2f6935af71]
[deoptimizer unlinked: addTag / 2e2f6935c3a1]
[deoptimizer unlinked: addTag / 2e2f6935d8d1]
[deoptimizer unlinked: addTag / 2e2f6935ecf9]
[deoptimizer unlinked: addTag / 2e2f69360329]
[deoptimizer unlinked: addTag / 2e2f69361749]
[deoptimizer unlinked: addTag / 2e2f69362ca1]
[deoptimizer unlinked: addTag / 2e2f69364219]
[deoptimizer unlinked: addTag / 2e2f69365759]
[deoptimizer unlinked: addTag / 2e2f69366cb9]
[deoptimizer unlinked: addTag / 2e2f69368109]
[deoptimizer unlinked: addTag / 2e2f69369501]
[deoptimizer unlinked: addTag / 2e2f6936ab21]
[deoptimizer unlinked: addTag / 2e2f6936c151]
[deoptimizer unlinked: addTag / 2e2f6936d591]
[deoptimizer unlinked: addTag / 2e2f6936ebb9]
[deoptimizer unlinked: addTag / 2e2f69370171]
[deoptimizer unlinked: addTag / 2e2f693717a9]
[deoptimizer unlinked: addTag / 2e2f69372d39]
[deoptimizer unlinked: addTag / 2e2f693742f1]
[deoptimizer unlinked: addTag / 2e2f69375881]
[deoptimizer unlinked: addTag / 2e2f69376e59]
[deoptimizer unlinked: addTag / 2e2f693783f9]
[deoptimizer unlinked: addTag / 2e2f69379931]
[deoptimizer unlinked: addTag / 2e2f6937ad51]
[deoptimizer unlinked: addTag / 2e2f6937c1e9]
[deoptimizer unlinked: addTag / 2e2f6937d609]
[deoptimizer unlinked: addTag / 2e2f6937ea51]
[deoptimizer unlinked: addTag / 2e2f6937fec1]
[deoptimizer unlinked: addTag / 2e2f693813e9]
[deoptimizer unlinked: addTag / 2e2f69382981]
[deoptimizer unlinked: addTag / 2e2f69383dd1]
[deoptimizer unlinked: addTag / 2e2f69385469]
[deoptimizer unlinked: addTag / 2e2f69386ad1]
[deoptimizer unlinked: addTag / 2e2f693882d1]
[deoptimizer unlinked: addTag / 2e2f69389921]
[deoptimizer unlinked: addTag / 2e2f6938afc1]
[deoptimizer unlinked: addTag / 2e2f6938c529]
[deoptimizer unlinked: addTag / 2e2f6938dbb9]
[deoptimizer unlinked: addTag / 2e2f6938f041]
[deoptimizer unlinked: addTag / 2e2f693906d9]
[deoptimizer unlinked: addTag / 2e2f69391cb1]
[deoptimizer unlinked: addTag / 2e2f69393279]
[deoptimizer unlinked: addTag / 2e2f69394811]
[deoptimizer unlinked: addTag / 2e2f69395d39]
[deoptimizer unlinked: addTag / 2e2f69397419]
[deoptimizer unlinked: addTag / 2e2f693989c1]
[deoptimizer unlinked: addTag / 2e2f69399f31]
[deoptimizer unlinked: addJSDocComment / d6230db1541]
[deoptimizer unlinked: addTag / 286514cfea39]
[deoptimizer unlinked: parseModifiers / d6230db0cd1]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:addDeclarationToSymbol) id{219,0} ---
(symbol, node, symbolFlags) {
            symbol.flags |= symbolFlags;
            node.symbol = symbol;
            if (!symbol.declarations) {
                symbol.declarations = [];
            }
            symbol.declarations.push(node);
            if (symbolFlags & 1952 /* HasExports */ && !symbol.exports) {
                symbol.exports = ts.createMap();
            }
            if (symbolFlags & 6240 /* HasMembers */ && !symbol.members) {
                symbol.members = ts.createMap();
            }
            if (symbolFlags & 107455 /* Value */) {
                var valueDeclaration = symbol.valueDeclaration;
                if (!valueDeclaration ||
                    (valueDeclaration.kind !== node.kind && valueDeclaration.kind === 230 /* ModuleDeclaration */)) {
                    // other kinds of value declarations take precedence over modules
                    symbol.valueDeclaration = node;
                }
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:bindFunctionOrConstructorType) id{220,0} ---
(node) {
            // For a given function symbol "<...>(...) => T" we want to generate a symbol identical
            // to the one we would get for: { <...>(...): T }
            //
            // We do that by making an anonymous type literal symbol, and then setting the function
            // symbol as its sole member. To the rest of the system, this symbol will be  indistinguishable
            // from an actual type literal symbol you would have gotten had you used the long form.
            var symbol = createSymbol(131072 /* Signature */, getDeclarationName(node));
            addDeclarationToSymbol(symbol, node, 131072 /* Signature */);
            var typeLiteralSymbol = createSymbol(2048 /* TypeLiteral */, "__type");
            addDeclarationToSymbol(typeLiteralSymbol, node, 2048 /* TypeLiteral */);
            typeLiteralSymbol.members = ts.createMap();
            typeLiteralSymbol.members[symbol.name] = symbol;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createSymbol) id{220,1} ---
(flags, name) {
            symbolCount++;
            return new Symbol(flags, name);
        }
--- END ---
INLINE (createSymbol) id{220,1} AS 1 AT <0:519>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:SymbolObject) id{220,2} ---
(flags, name) {
            this.flags = flags;
            this.name = name;
        }
--- END ---
INLINE (SymbolObject) id{220,2} AS 2 AT <1:62>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createSymbol) id{220,3} ---
(flags, name) {
            symbolCount++;
            return new Symbol(flags, name);
        }
--- END ---
INLINE (createSymbol) id{220,3} AS 3 AT <0:693>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:SymbolObject) id{220,4} ---
(flags, name) {
            this.flags = flags;
            this.name = name;
        }
--- END ---
INLINE (SymbolObject) id{220,4} AS 4 AT <3:62>
[deoptimizing (DEOPT soft): begin 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> (opt #217) @173, FP to SP delta: 728, caller sp: 0x7fff5fbfdb88]
            ;;; deoptimize at 0_8317: Insufficient type feedback for generic named access
  reading input frame forEachChild => node=2541, args=4, height=4; inputs:
      0: 0xd6230dc36a9 ; [fp - 16] 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>
      1: 0x16f3adb61821 ; [fp + 40] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x33c68035b9d1 ; [fp + 32] 0x33c68035b9d1 <a NodeObject with map 0x33abe2a68961>
      3: 0x29cc38dda4f9 ; [fp + 24] 0x29cc38dda4f9 <JS Function (SharedFunctionInfo 0x371f85c089c9)>
      4: 0x30bcea404311 ; [fp + 16] 0x30bcea404311 <undefined>
      5: 0xd6230d99249 ; rbx 0xd6230d99249 <FixedArray[15]>
      6: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0xd6230dd5db1 ; [fp - 32] 0xd6230dd5db1 <JS Function visitEachNode (SharedFunctionInfo 0x3504a53f00e9)>
      8: 0x29cc38dda4f9 ; [fp - 40] 0x29cc38dda4f9 <JS Function (SharedFunctionInfo 0x371f85c089c9)>
  translating frame forEachChild => node=2541, height=24
    0x7fff5fbfdb80: [top + 80] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfdb78: [top + 72] <- 0x33c68035b9d1 ;  0x33c68035b9d1 <a NodeObject with map 0x33abe2a68961>  (input #2)
    0x7fff5fbfdb70: [top + 64] <- 0x29cc38dda4f9 ;  0x29cc38dda4f9 <JS Function (SharedFunctionInfo 0x371f85c089c9)>  (input #3)
    0x7fff5fbfdb68: [top + 56] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfdb60: [top + 48] <- 0x2c21d2207e55 ;  caller's pc
    0x7fff5fbfdb58: [top + 40] <- 0x7fff5fbfdba0 ;  caller's fp
    0x7fff5fbfdb50: [top + 32] <- 0xd6230d99249 ;  context    0xd6230d99249 <FixedArray[15]>  (input #5)
    0x7fff5fbfdb48: [top + 24] <- 0xd6230dc36a9 ;  function    0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>  (input #0)
    0x7fff5fbfdb40: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfdb38: [top + 8] <- 0xd6230dd5db1 ;  0xd6230dd5db1 <JS Function visitEachNode (SharedFunctionInfo 0x3504a53f00e9)>  (input #7)
    0x7fff5fbfdb30: [top + 0] <- 0x29cc38dda4f9 ;  0x29cc38dda4f9 <JS Function (SharedFunctionInfo 0x371f85c089c9)>  (input #8)
[deoptimizing (soft): end 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> @173 => node=2541, pc=0x2c21d24c6fb4, caller sp=0x7fff5fbfdb88, state=NO_REGISTERS, took 0.089 ms]
[deoptimizing (DEOPT soft): begin 0x2f05bb804691 <JS Function addDeclarationToSymbol (SharedFunctionInfo 0x16f3adb57e21)> (opt #219) @11, FP to SP delta: 40, caller sp: 0x7fff5fbfdb18]
            ;;; deoptimize at 0_307: Insufficient type feedback for generic named access
  reading input frame addDeclarationToSymbol => node=120, args=4, height=2; inputs:
      0: 0x2f05bb804691 ; [fp - 16] 0x2f05bb804691 <JS Function addDeclarationToSymbol (SharedFunctionInfo 0x16f3adb57e21)>
      1: 0x1f9f6c0532e1 ; [fp + 40] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x29cc38dda7b9 ; rbx 0x29cc38dda7b9 <a SymbolObject with map 0x33abe2a6bd49>
      3: 0x286514cff711 ; [fp + 24] 0x286514cff711 <a NodeObject with map 0x33abe2a70f71>
      4: 0x20000000000 ; [fp + 16] 512
      5: 0xd6230dfeea1 ; [fp - 24] 0xd6230dfeea1 <FixedArray[147]>
      6: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
  translating frame addDeclarationToSymbol => node=120, height=8
    0x7fff5fbfdb10: [top + 64] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdb08: [top + 56] <- 0x29cc38dda7b9 ;  0x29cc38dda7b9 <a SymbolObject with map 0x33abe2a6bd49>  (input #2)
    0x7fff5fbfdb00: [top + 48] <- 0x286514cff711 ;  0x286514cff711 <a NodeObject with map 0x33abe2a70f71>  (input #3)
    0x7fff5fbfdaf8: [top + 40] <- 0x20000000000 ;  512  (input #4)
    0x7fff5fbfdaf0: [top + 32] <- 0x2c21d255b47e ;  caller's pc
    0x7fff5fbfdae8: [top + 24] <- 0x7fff5fbfdb68 ;  caller's fp
    0x7fff5fbfdae0: [top + 16] <- 0xd6230dfeea1 ;  context    0xd6230dfeea1 <FixedArray[147]>  (input #5)
    0x7fff5fbfdad8: [top + 8] <- 0x2f05bb804691 ;  function    0x2f05bb804691 <JS Function addDeclarationToSymbol (SharedFunctionInfo 0x16f3adb57e21)>  (input #0)
    0x7fff5fbfdad0: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
[deoptimizing (soft): end 0x2f05bb804691 <JS Function addDeclarationToSymbol (SharedFunctionInfo 0x16f3adb57e21)> @11 => node=120, pc=0x2c21d2524ad8, caller sp=0x7fff5fbfdb18, state=NO_REGISTERS, took 0.067 ms]
[deoptimizing (DEOPT soft): begin 0x2f05bb806029 <JS Function bindWorker (SharedFunctionInfo 0x16f3adb5c261)> (opt #215) @4, FP to SP delta: 208, caller sp: 0x7fff5fbfdb80]
            ;;; deoptimize at 0_10482: Insufficient type feedback for generic named access
  reading input frame bindWorker => node=1817, args=2, height=7; inputs:
      0: 0x2f05bb806029 ; [fp - 16] 0x2f05bb806029 <JS Function bindWorker (SharedFunctionInfo 0x16f3adb5c261)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x33c68035b9d1 ; [fp + 16] 0x33c68035b9d1 <a NodeObject with map 0x33abe2a68961>
      3: 0xd6230dfeea1 ; rax 0xd6230dfeea1 <FixedArray[147]>
      4: 0x30bcea4069a9 ; (literal 14) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      5: 0x30bcea404311 ; (literal 13) 0x30bcea404311 <undefined>
      6: 0x30bcea404311 ; (literal 13) 0x30bcea404311 <undefined>
      7: 0x30bcea404311 ; (literal 13) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; (literal 13) 0x30bcea404311 <undefined>
      9: 0x30bcea404311 ; (literal 13) 0x30bcea404311 <undefined>
  translating frame bindWorker => node=1817, height=48
    0x7fff5fbfdb78: [top + 88] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdb70: [top + 80] <- 0x33c68035b9d1 ;  0x33c68035b9d1 <a NodeObject with map 0x33abe2a68961>  (input #2)
    0x7fff5fbfdb68: [top + 72] <- 0x2c21d254dc06 ;  caller's pc
    0x7fff5fbfdb60: [top + 64] <- 0x7fff5fbfdba8 ;  caller's fp
    0x7fff5fbfdb58: [top + 56] <- 0xd6230dfeea1 ;  context    0xd6230dfeea1 <FixedArray[147]>  (input #3)
    0x7fff5fbfdb50: [top + 48] <- 0x2f05bb806029 ;  function    0x2f05bb806029 <JS Function bindWorker (SharedFunctionInfo 0x16f3adb5c261)>  (input #0)
    0x7fff5fbfdb48: [top + 40] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #4)
    0x7fff5fbfdb40: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfdb38: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfdb30: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfdb28: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfdb20: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
[deoptimizing (soft): end 0x2f05bb806029 <JS Function bindWorker (SharedFunctionInfo 0x16f3adb5c261)> @4 => node=1817, pc=0x2c21d2544d5b, caller sp=0x7fff5fbfdb80, state=NO_REGISTERS, took 0.066 ms]
[deoptimizing (DEOPT eager): begin 0xd6230dceca1 <JS Function isBindingPattern (SharedFunctionInfo 0x3504a53d8899)> (opt #202) @3, FP to SP delta: 24, caller sp: 0x7fff5fbfd6d8]
            ;;; deoptimize at 0_56: Unknown map in polymorphic access
  reading input frame isBindingPattern => node=9, args=2, height=2; inputs:
      0: 0xd6230dceca1 ; [fp - 16] 0xd6230dceca1 <JS Function isBindingPattern (SharedFunctionInfo 0x3504a53d8899)>
      1: 0x16f3adb61821 ; [fp + 24] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x33c6803da241 ; rax 0x33c6803da241 <a NodeObject with map 0x33abe2a67679>
      3: 0xd6230db34c9 ; [fp - 24] 0xd6230db34c9 <FixedArray[156]>
      4: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
  translating frame isBindingPattern => node=9, height=8
    0x7fff5fbfd6d0: [top + 48] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfd6c8: [top + 40] <- 0x33c6803da241 ;  0x33c6803da241 <a NodeObject with map 0x33abe2a67679>  (input #2)
    0x7fff5fbfd6c0: [top + 32] <- 0x2c21d23fe437 ;  caller's pc
    0x7fff5fbfd6b8: [top + 24] <- 0x7fff5fbfd6f0 ;  caller's fp
    0x7fff5fbfd6b0: [top + 16] <- 0xd6230db34c9 ;  context    0xd6230db34c9 <FixedArray[156]>  (input #3)
    0x7fff5fbfd6a8: [top + 8] <- 0xd6230dceca1 ;  function    0xd6230dceca1 <JS Function isBindingPattern (SharedFunctionInfo 0x3504a53d8899)>  (input #0)
    0x7fff5fbfd6a0: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
[deoptimizing (eager): end 0xd6230dceca1 <JS Function isBindingPattern (SharedFunctionInfo 0x3504a53d8899)> @3 => node=9, pc=0x2c21d23fdd4b, caller sp=0x7fff5fbfd6d8, state=NO_REGISTERS, took 0.053 ms]
[deoptimizing (DEOPT eager): begin 0x2f05bb805771 <JS Function declareSymbolAndAddToSymbolTableWorker (SharedFunctionInfo 0x16f3adb5ab21)> (opt #218) @6, FP to SP delta: 40, caller sp: 0x7fff5fbfd480]
            ;;; deoptimize at 0_1823: Unknown map in polymorphic access
  reading input frame declareSymbolAndAddToSymbolTableWorker => node=196, args=4, height=2; inputs:
      0: 0x2f05bb805771 ; [fp - 16] 0x2f05bb805771 <JS Function declareSymbolAndAddToSymbolTableWorker (SharedFunctionInfo 0x16f3adb5ab21)>
      1: 0x1f9f6c0532e1 ; [fp + 40] 0x1f9f6c0532e1 <JS Global Object>
      2: 0xe0c907c6411 ; [fp + 32] 0xe0c907c6411 <a NodeObject with map 0x33abe2a66ff1>
      3: 0x2000000400000000 ; [fp + 24] 536870916
      4: 0x00000000 ; [fp + 16] 0
      5: 0xd6230dfeea1 ; rax 0xd6230dfeea1 <FixedArray[147]>
      6: 0x30bcea4069a9 ; (literal 4) 0x30bcea4069a9 <Odd Oddball: optimized_out>
  translating frame declareSymbolAndAddToSymbolTableWorker => node=196, height=8
    0x7fff5fbfd478: [top + 64] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd470: [top + 56] <- 0xe0c907c6411 ;  0xe0c907c6411 <a NodeObject with map 0x33abe2a66ff1>  (input #2)
    0x7fff5fbfd468: [top + 48] <- 0x2000000400000000 ;  536870916  (input #3)
    0x7fff5fbfd460: [top + 40] <- 0x00000000 ;  0  (input #4)
    0x7fff5fbfd458: [top + 32] <- 0x2c21d25556ed ;  caller's pc
    0x7fff5fbfd450: [top + 24] <- 0x7fff5fbfd4c8 ;  caller's fp
    0x7fff5fbfd448: [top + 16] <- 0xd6230dfeea1 ;  context    0xd6230dfeea1 <FixedArray[147]>  (input #5)
    0x7fff5fbfd440: [top + 8] <- 0x2f05bb805771 ;  function    0x2f05bb805771 <JS Function declareSymbolAndAddToSymbolTableWorker (SharedFunctionInfo 0x16f3adb5ab21)>  (input #0)
    0x7fff5fbfd438: [top + 0] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
[deoptimizing (eager): end 0x2f05bb805771 <JS Function declareSymbolAndAddToSymbolTableWorker (SharedFunctionInfo 0x16f3adb5ab21)> @6 => node=196, pc=0x2c21d2527007, caller sp=0x7fff5fbfd480, state=NO_REGISTERS, took 0.059 ms]
[deoptimizing (DEOPT eager): begin 0x2f05bb804769 <JS Function declareSymbol (SharedFunctionInfo 0x16f3adb58061)> (opt #210) @24, FP to SP delta: 80, caller sp: 0x7fff5fbfd2b8]
            ;;; deoptimize at 0_2585: wrong map
  reading input frame declareSymbol => node=221, args=6, height=4; inputs:
      0: 0x2f05bb804769 ; [fp - 16] 0x2f05bb804769 <JS Function declareSymbol (SharedFunctionInfo 0x16f3adb58061)>
      1: 0x1f9f6c0532e1 ; [fp + 56] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x29cc38ddddc1 ; [fp + 48] 0x29cc38ddddc1 <an Object with map 0x33abe2a3d1a1>
      3: 0x30bcea404311 ; [fp + 40] 0x30bcea404311 <undefined>
      4: 0xe0c907ff401 ; [fp + 32] 0xe0c907ff401 <a NodeObject with map 0x33abe2a6fa21>
      5: 0x10000000000000 ; [fp + 24] 1048576
      6: 0x1a3be00000000 ; [fp + 16] 107454
      7: 0x29cc38de49f1 ; [fp - 24] 0x29cc38de49f1 <FixedArray[5]>
      8: 0x30bcea404421 ; [fp - 56] 0x30bcea404421 <false>
      9: 0x286514cf18d9 ; [fp - 64] 0x286514cf18d9 <String[8]: Collator>
     10: 0x29cc38de3a11 ; rdx 0x29cc38de3a11 <a SymbolObject with map 0x33abe2a71181>
  translating frame declareSymbol => node=221, height=24
    0x7fff5fbfd2b0: [top + 96] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd2a8: [top + 88] <- 0x29cc38ddddc1 ;  0x29cc38ddddc1 <an Object with map 0x33abe2a3d1a1>  (input #2)
    0x7fff5fbfd2a0: [top + 80] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #3)
    0x7fff5fbfd298: [top + 72] <- 0xe0c907ff401 ;  0xe0c907ff401 <a NodeObject with map 0x33abe2a6fa21>  (input #4)
    0x7fff5fbfd290: [top + 64] <- 0x10000000000000 ;  1048576  (input #5)
    0x7fff5fbfd288: [top + 56] <- 0x1a3be00000000 ;  107454  (input #6)
    0x7fff5fbfd280: [top + 48] <- 0x2c21d25730b6 ;  caller's pc
    0x7fff5fbfd278: [top + 40] <- 0x7fff5fbfd2f0 ;  caller's fp
    0x7fff5fbfd270: [top + 32] <- 0x29cc38de49f1 ;  context    0x29cc38de49f1 <FixedArray[5]>  (input #7)
    0x7fff5fbfd268: [top + 24] <- 0x2f05bb804769 ;  function    0x2f05bb804769 <JS Function declareSymbol (SharedFunctionInfo 0x16f3adb58061)>  (input #0)
    0x7fff5fbfd260: [top + 16] <- 0x30bcea404421 ;  0x30bcea404421 <false>  (input #8)
    0x7fff5fbfd258: [top + 8] <- 0x286514cf18d9 ;  0x286514cf18d9 <String[8]: Collator>  (input #9)
    0x7fff5fbfd250: [top + 0] <- 0x29cc38de3a11 ;  0x29cc38de3a11 <a SymbolObject with map 0x33abe2a71181>  (input #10)
[deoptimizing (eager): end 0x2f05bb804769 <JS Function declareSymbol (SharedFunctionInfo 0x16f3adb58061)> @24 => node=221, pc=0x2c21d2522a9a, caller sp=0x7fff5fbfd2b8, state=NO_REGISTERS, took 0.079 ms]
[deoptimizing (DEOPT eager): begin 0x2f05bb804919 <JS Function bindChildrenWorker (SharedFunctionInfo 0x16f3adb584e1)> (opt #206) @18, FP to SP delta: 72, caller sp: 0x7fff5fbfd418]
            ;;; deoptimize at 1_62: wrong map
  reading input frame bindChildrenWorker => node=485, args=2, height=3; inputs:
      0: 0x2f05bb804919 ; [fp - 16] 0x2f05bb804919 <JS Function bindChildrenWorker (SharedFunctionInfo 0x16f3adb584e1)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0xe0c907ff401 ; rax 0xe0c907ff401 <a NodeObject with map 0x33abe2a71339>
      3: 0xd6230dfeea1 ; [fp - 24] 0xd6230dfeea1 <FixedArray[147]>
      4: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      5: 0x2f05bb805609 ; [fp - 56] 0x2f05bb805609 <JS Function bindVariableDeclarationFlow (SharedFunctionInfo 0x16f3adb5a761)>
  reading input frame bindVariableDeclarationFlow => node=5, args=2, height=1; inputs:
      0: 0x2f05bb805609 ; (literal 10) 0x2f05bb805609 <JS Function bindVariableDeclarationFlow (SharedFunctionInfo 0x16f3adb5a761)>
      1: 0x1f9f6c0532e1 ; (literal 8) 0x1f9f6c0532e1 <JS Global Object>
      2: 0xe0c907ff401 ; rax 0xe0c907ff401 <a NodeObject with map 0x33abe2a71339>
      3: 0xd6230dfeea1 ; (literal 9) 0xd6230dfeea1 <FixedArray[147]>
  translating frame bindChildrenWorker => node=485, height=16
    0x7fff5fbfd410: [top + 56] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd408: [top + 48] <- 0xe0c907ff401 ;  0xe0c907ff401 <a NodeObject with map 0x33abe2a71339>  (input #2)
    0x7fff5fbfd400: [top + 40] <- 0x2c21d2547875 ;  caller's pc
    0x7fff5fbfd3f8: [top + 32] <- 0x7fff5fbfd438 ;  caller's fp
    0x7fff5fbfd3f0: [top + 24] <- 0xd6230dfeea1 ;  context    0xd6230dfeea1 <FixedArray[147]>  (input #3)
    0x7fff5fbfd3e8: [top + 16] <- 0x2f05bb804919 ;  function    0x2f05bb804919 <JS Function bindChildrenWorker (SharedFunctionInfo 0x16f3adb584e1)>  (input #0)
    0x7fff5fbfd3e0: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #4)
    0x7fff5fbfd3d8: [top + 0] <- 0x2f05bb805609 ;  0x2f05bb805609 <JS Function bindVariableDeclarationFlow (SharedFunctionInfo 0x16f3adb5a761)>  (input #5)
  translating frame bindVariableDeclarationFlow => node=5, height=0
    0x7fff5fbfd3d0: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd3c8: [top + 32] <- 0xe0c907ff401 ;  0xe0c907ff401 <a NodeObject with map 0x33abe2a71339>  (input #2)
    0x7fff5fbfd3c0: [top + 24] <- 0x2c21d25486b4 ;  caller's pc
    0x7fff5fbfd3b8: [top + 16] <- 0x7fff5fbfd3f8 ;  caller's fp
    0x7fff5fbfd3b0: [top + 8] <- 0xd6230dfeea1 ;  context    0xd6230dfeea1 <FixedArray[147]>  (input #3)
    0x7fff5fbfd3a8: [top + 0] <- 0x2f05bb805609 ;  function    0x2f05bb805609 <JS Function bindVariableDeclarationFlow (SharedFunctionInfo 0x16f3adb5a761)>  (input #0)
[deoptimizing (eager): end 0x2f05bb804919 <JS Function bindChildrenWorker (SharedFunctionInfo 0x16f3adb584e1)> @18 => node=5, pc=0x2c21d2524e60, caller sp=0x7fff5fbfd418, state=NO_REGISTERS, took 0.093 ms]
[deoptimizer unlinked: bindChildrenWorker / 2f05bb804919]
[deoptimizing (DEOPT lazy): begin 0x2f05bb804919 <JS Function bindChildrenWorker (SharedFunctionInfo 0x16f3adb584e1)> (opt #206) @11, FP to SP delta: 72, caller sp: 0x7fff5fbfd6a0]
  reading input frame bindChildrenWorker => node=520, args=2, height=3; inputs:
      0: 0x2f05bb804919 ; [fp - 16] 0x2f05bb804919 <JS Function bindChildrenWorker (SharedFunctionInfo 0x16f3adb584e1)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0xe0c90741621 ; [fp + 16] 0xe0c90741621 <a NodeObject with map 0x33abe2a712e1>
      3: 0xd6230dfeea1 ; [fp - 24] 0xd6230dfeea1 <FixedArray[147]>
      4: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      5: 0x2f05bb8048d1 ; [fp - 40] 0x2f05bb8048d1 <JS Function bindEachChild (SharedFunctionInfo 0x16f3adb58421)>
  reading input frame bindEachChild => node=5, args=2, height=1; inputs:
      0: 0x2f05bb8048d1 ; (literal 7) 0x2f05bb8048d1 <JS Function bindEachChild (SharedFunctionInfo 0x16f3adb58421)>
      1: 0x1f9f6c0532e1 ; (literal 8) 0x1f9f6c0532e1 <JS Global Object>
      2: 0xe0c90741621 ; [fp + 16] 0xe0c90741621 <a NodeObject with map 0x33abe2a712e1>
      3: 0xd6230dfeea1 ; (literal 9) 0xd6230dfeea1 <FixedArray[147]>
  translating frame bindChildrenWorker => node=520, height=16
    0x7fff5fbfd698: [top + 56] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd690: [top + 48] <- 0xe0c90741621 ;  0xe0c90741621 <a NodeObject with map 0x33abe2a712e1>  (input #2)
    0x7fff5fbfd688: [top + 40] <- 0x2c21d2547875 ;  caller's pc
    0x7fff5fbfd680: [top + 32] <- 0x7fff5fbfd6c0 ;  caller's fp
    0x7fff5fbfd678: [top + 24] <- 0xd6230dfeea1 ;  context    0xd6230dfeea1 <FixedArray[147]>  (input #3)
    0x7fff5fbfd670: [top + 16] <- 0x2f05bb804919 ;  function    0x2f05bb804919 <JS Function bindChildrenWorker (SharedFunctionInfo 0x16f3adb584e1)>  (input #0)
    0x7fff5fbfd668: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #4)
    0x7fff5fbfd660: [top + 0] <- 0x2f05bb8048d1 ;  0x2f05bb8048d1 <JS Function bindEachChild (SharedFunctionInfo 0x16f3adb58421)>  (input #5)
  translating frame bindEachChild => node=5, height=0
    0x7fff5fbfd658: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd650: [top + 32] <- 0xe0c90741621 ;  0xe0c90741621 <a NodeObject with map 0x33abe2a712e1>  (input #2)
    0x7fff5fbfd648: [top + 24] <- 0x2c21d254871a ;  caller's pc
    0x7fff5fbfd640: [top + 16] <- 0x7fff5fbfd680 ;  caller's fp
    0x7fff5fbfd638: [top + 8] <- 0xd6230dfeea1 ;  context    0xd6230dfeea1 <FixedArray[147]>  (input #3)
    0x7fff5fbfd630: [top + 0] <- 0x2f05bb8048d1 ;  function    0x2f05bb8048d1 <JS Function bindEachChild (SharedFunctionInfo 0x16f3adb58421)>  (input #0)
[deoptimizing (lazy): end 0x2f05bb804919 <JS Function bindChildrenWorker (SharedFunctionInfo 0x16f3adb584e1)> @11 => node=5, pc=0x2c21d2548ff5, caller sp=0x7fff5fbfd6a0, state=NO_REGISTERS, took 0.103 ms]
[deoptimizing (DEOPT lazy): begin 0x2f05bb804919 <JS Function bindChildrenWorker (SharedFunctionInfo 0x16f3adb584e1)> (opt #206) @11, FP to SP delta: 72, caller sp: 0x7fff5fbfd830]
  reading input frame bindChildrenWorker => node=520, args=2, height=3; inputs:
      0: 0x2f05bb804919 ; [fp - 16] 0x2f05bb804919 <JS Function bindChildrenWorker (SharedFunctionInfo 0x16f3adb584e1)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x33c6803da3c1 ; [fp + 16] 0x33c6803da3c1 <a NodeObject with map 0x33abe2a695c1>
      3: 0xd6230dfeea1 ; [fp - 24] 0xd6230dfeea1 <FixedArray[147]>
      4: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      5: 0x2f05bb8048d1 ; [fp - 40] 0x2f05bb8048d1 <JS Function bindEachChild (SharedFunctionInfo 0x16f3adb58421)>
  reading input frame bindEachChild => node=5, args=2, height=1; inputs:
      0: 0x2f05bb8048d1 ; (literal 7) 0x2f05bb8048d1 <JS Function bindEachChild (SharedFunctionInfo 0x16f3adb58421)>
      1: 0x1f9f6c0532e1 ; (literal 8) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x33c6803da3c1 ; [fp + 16] 0x33c6803da3c1 <a NodeObject with map 0x33abe2a695c1>
      3: 0xd6230dfeea1 ; (literal 9) 0xd6230dfeea1 <FixedArray[147]>
  translating frame bindChildrenWorker => node=520, height=16
    0x7fff5fbfd828: [top + 56] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd820: [top + 48] <- 0x33c6803da3c1 ;  0x33c6803da3c1 <a NodeObject with map 0x33abe2a695c1>  (input #2)
    0x7fff5fbfd818: [top + 40] <- 0x2c21d2547875 ;  caller's pc
    0x7fff5fbfd810: [top + 32] <- 0x7fff5fbfd850 ;  caller's fp
    0x7fff5fbfd808: [top + 24] <- 0xd6230dfeea1 ;  context    0xd6230dfeea1 <FixedArray[147]>  (input #3)
    0x7fff5fbfd800: [top + 16] <- 0x2f05bb804919 ;  function    0x2f05bb804919 <JS Function bindChildrenWorker (SharedFunctionInfo 0x16f3adb584e1)>  (input #0)
    0x7fff5fbfd7f8: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #4)
    0x7fff5fbfd7f0: [top + 0] <- 0x2f05bb8048d1 ;  0x2f05bb8048d1 <JS Function bindEachChild (SharedFunctionInfo 0x16f3adb58421)>  (input #5)
  translating frame bindEachChild => node=5, height=0
    0x7fff5fbfd7e8: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd7e0: [top + 32] <- 0x33c6803da3c1 ;  0x33c6803da3c1 <a NodeObject with map 0x33abe2a695c1>  (input #2)
    0x7fff5fbfd7d8: [top + 24] <- 0x2c21d254871a ;  caller's pc
    0x7fff5fbfd7d0: [top + 16] <- 0x7fff5fbfd810 ;  caller's fp
    0x7fff5fbfd7c8: [top + 8] <- 0xd6230dfeea1 ;  context    0xd6230dfeea1 <FixedArray[147]>  (input #3)
    0x7fff5fbfd7c0: [top + 0] <- 0x2f05bb8048d1 ;  function    0x2f05bb8048d1 <JS Function bindEachChild (SharedFunctionInfo 0x16f3adb58421)>  (input #0)
[deoptimizing (lazy): end 0x2f05bb804919 <JS Function bindChildrenWorker (SharedFunctionInfo 0x16f3adb584e1)> @11 => node=5, pc=0x2c21d2548ff5, caller sp=0x7fff5fbfd830, state=NO_REGISTERS, took 0.092 ms]
[deoptimizing (DEOPT lazy): begin 0x2f05bb804919 <JS Function bindChildrenWorker (SharedFunctionInfo 0x16f3adb584e1)> (opt #206) @11, FP to SP delta: 72, caller sp: 0x7fff5fbfdab8]
  reading input frame bindChildrenWorker => node=520, args=2, height=3; inputs:
      0: 0x2f05bb804919 ; [fp - 16] 0x2f05bb804919 <JS Function bindChildrenWorker (SharedFunctionInfo 0x16f3adb584e1)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x33c68035b9d1 ; [fp + 16] 0x33c68035b9d1 <a NodeObject with map 0x33abe2a68961>
      3: 0xd6230dfeea1 ; [fp - 24] 0xd6230dfeea1 <FixedArray[147]>
      4: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      5: 0x2f05bb8048d1 ; [fp - 40] 0x2f05bb8048d1 <JS Function bindEachChild (SharedFunctionInfo 0x16f3adb58421)>
  reading input frame bindEachChild => node=5, args=2, height=1; inputs:
      0: 0x2f05bb8048d1 ; (literal 7) 0x2f05bb8048d1 <JS Function bindEachChild (SharedFunctionInfo 0x16f3adb58421)>
      1: 0x1f9f6c0532e1 ; (literal 8) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x33c68035b9d1 ; [fp + 16] 0x33c68035b9d1 <a NodeObject with map 0x33abe2a68961>
      3: 0xd6230dfeea1 ; (literal 9) 0xd6230dfeea1 <FixedArray[147]>
  translating frame bindChildrenWorker => node=520, height=16
    0x7fff5fbfdab0: [top + 56] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdaa8: [top + 48] <- 0x33c68035b9d1 ;  0x33c68035b9d1 <a NodeObject with map 0x33abe2a68961>  (input #2)
    0x7fff5fbfdaa0: [top + 40] <- 0x2c21d2547875 ;  caller's pc
    0x7fff5fbfda98: [top + 32] <- 0x7fff5fbfdad8 ;  caller's fp
    0x7fff5fbfda90: [top + 24] <- 0xd6230dfeea1 ;  context    0xd6230dfeea1 <FixedArray[147]>  (input #3)
    0x7fff5fbfda88: [top + 16] <- 0x2f05bb804919 ;  function    0x2f05bb804919 <JS Function bindChildrenWorker (SharedFunctionInfo 0x16f3adb584e1)>  (input #0)
    0x7fff5fbfda80: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #4)
    0x7fff5fbfda78: [top + 0] <- 0x2f05bb8048d1 ;  0x2f05bb8048d1 <JS Function bindEachChild (SharedFunctionInfo 0x16f3adb58421)>  (input #5)
  translating frame bindEachChild => node=5, height=0
    0x7fff5fbfda70: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfda68: [top + 32] <- 0x33c68035b9d1 ;  0x33c68035b9d1 <a NodeObject with map 0x33abe2a68961>  (input #2)
    0x7fff5fbfda60: [top + 24] <- 0x2c21d254871a ;  caller's pc
    0x7fff5fbfda58: [top + 16] <- 0x7fff5fbfda98 ;  caller's fp
    0x7fff5fbfda50: [top + 8] <- 0xd6230dfeea1 ;  context    0xd6230dfeea1 <FixedArray[147]>  (input #3)
    0x7fff5fbfda48: [top + 0] <- 0x2f05bb8048d1 ;  function    0x2f05bb8048d1 <JS Function bindEachChild (SharedFunctionInfo 0x16f3adb58421)>  (input #0)
[deoptimizing (lazy): end 0x2f05bb804919 <JS Function bindChildrenWorker (SharedFunctionInfo 0x16f3adb584e1)> @11 => node=5, pc=0x2c21d2548ff5, caller sp=0x7fff5fbfdab8, state=NO_REGISTERS, took 0.088 ms]
[deoptimizing (DEOPT lazy): begin 0x2f05bb804919 <JS Function bindChildrenWorker (SharedFunctionInfo 0x16f3adb584e1)> (opt #206) @11, FP to SP delta: 72, caller sp: 0x7fff5fbfdcd0]
  reading input frame bindChildrenWorker => node=520, args=2, height=3; inputs:
      0: 0x2f05bb804919 ; [fp - 16] 0x2f05bb804919 <JS Function bindChildrenWorker (SharedFunctionInfo 0x16f3adb584e1)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x286514cff711 ; [fp + 16] 0x286514cff711 <a NodeObject with map 0x33abe2a71231>
      3: 0xd6230dfeea1 ; [fp - 24] 0xd6230dfeea1 <FixedArray[147]>
      4: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      5: 0x2f05bb8048d1 ; [fp - 40] 0x2f05bb8048d1 <JS Function bindEachChild (SharedFunctionInfo 0x16f3adb58421)>
  reading input frame bindEachChild => node=5, args=2, height=1; inputs:
      0: 0x2f05bb8048d1 ; (literal 7) 0x2f05bb8048d1 <JS Function bindEachChild (SharedFunctionInfo 0x16f3adb58421)>
      1: 0x1f9f6c0532e1 ; (literal 8) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x286514cff711 ; [fp + 16] 0x286514cff711 <a NodeObject with map 0x33abe2a71231>
      3: 0xd6230dfeea1 ; (literal 9) 0xd6230dfeea1 <FixedArray[147]>
  translating frame bindChildrenWorker => node=520, height=16
    0x7fff5fbfdcc8: [top + 56] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdcc0: [top + 48] <- 0x286514cff711 ;  0x286514cff711 <a NodeObject with map 0x33abe2a71231>  (input #2)
    0x7fff5fbfdcb8: [top + 40] <- 0x2c21d2547875 ;  caller's pc
    0x7fff5fbfdcb0: [top + 32] <- 0x7fff5fbfdcf0 ;  caller's fp
    0x7fff5fbfdca8: [top + 24] <- 0xd6230dfeea1 ;  context    0xd6230dfeea1 <FixedArray[147]>  (input #3)
    0x7fff5fbfdca0: [top + 16] <- 0x2f05bb804919 ;  function    0x2f05bb804919 <JS Function bindChildrenWorker (SharedFunctionInfo 0x16f3adb584e1)>  (input #0)
    0x7fff5fbfdc98: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #4)
    0x7fff5fbfdc90: [top + 0] <- 0x2f05bb8048d1 ;  0x2f05bb8048d1 <JS Function bindEachChild (SharedFunctionInfo 0x16f3adb58421)>  (input #5)
  translating frame bindEachChild => node=5, height=0
    0x7fff5fbfdc88: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdc80: [top + 32] <- 0x286514cff711 ;  0x286514cff711 <a NodeObject with map 0x33abe2a71231>  (input #2)
    0x7fff5fbfdc78: [top + 24] <- 0x2c21d254871a ;  caller's pc
    0x7fff5fbfdc70: [top + 16] <- 0x7fff5fbfdcb0 ;  caller's fp
    0x7fff5fbfdc68: [top + 8] <- 0xd6230dfeea1 ;  context    0xd6230dfeea1 <FixedArray[147]>  (input #3)
    0x7fff5fbfdc60: [top + 0] <- 0x2f05bb8048d1 ;  function    0x2f05bb8048d1 <JS Function bindEachChild (SharedFunctionInfo 0x16f3adb58421)>  (input #0)
[deoptimizing (lazy): end 0x2f05bb804919 <JS Function bindChildrenWorker (SharedFunctionInfo 0x16f3adb584e1)> @11 => node=5, pc=0x2c21d2548ff5, caller sp=0x7fff5fbfdcd0, state=NO_REGISTERS, took 0.081 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:bindWorker) id{221,0} ---
(node) {
            switch (node.kind) {
                /* Strict mode checks */
                case 70 /* Identifier */:
                    // for typedef type names with namespaces, bind the new jsdoc type symbol here
                    // because it requires all containing namespaces to be in effect, namely the
                    // current "blockScopeContainer" needs to be set to its immediate namespace parent.
                    if (node.isInJSDocNamespace) {
                        var parentNode = node.parent;
                        while (parentNode && parentNode.kind !== 285 /* JSDocTypedefTag */) {
                            parentNode = parentNode.parent;
                        }
                        bindBlockScopedDeclaration(parentNode, 524288 /* TypeAlias */, 793064 /* TypeAliasExcludes */);
                        break;
                    }
                case 98 /* ThisKeyword */:
                    if (currentFlow && (ts.isExpression(node) || parent.kind === 258 /* ShorthandPropertyAssignment */)) {
                        node.flowNode = currentFlow;
                    }
                    return checkStrictModeIdentifier(node);
                case 177 /* PropertyAccessExpression */:
                    if (currentFlow && isNarrowableReference(node)) {
                        node.flowNode = currentFlow;
                    }
                    break;
                case 192 /* BinaryExpression */:
                    if (ts.isInJavaScriptFile(node)) {
                        var specialKind = ts.getSpecialPropertyAssignmentKind(node);
                        switch (specialKind) {
                            case 1 /* ExportsProperty */:
                                bindExportsPropertyAssignment(node);
                                break;
                            case 2 /* ModuleExports */:
                                bindModuleExportsAssignment(node);
                                break;
                            case 3 /* PrototypeProperty */:
                                bindPrototypePropertyAssignment(node);
                                break;
                            case 4 /* ThisProperty */:
                                bindThisPropertyAssignment(node);
                                break;
                            case 0 /* None */:
                                // Nothing to do
                                break;
                            default:
                                ts.Debug.fail("Unknown special property assignment kind");
                        }
                    }
                    return checkStrictModeBinaryExpression(node);
                case 256 /* CatchClause */:
                    return checkStrictModeCatchClause(node);
                case 186 /* DeleteExpression */:
                    return checkStrictModeDeleteExpression(node);
                case 8 /* NumericLiteral */:
                    return checkStrictModeNumericLiteral(node);
                case 191 /* PostfixUnaryExpression */:
                    return checkStrictModePostfixUnaryExpression(node);
                case 190 /* PrefixUnaryExpression */:
                    return checkStrictModePrefixUnaryExpression(node);
                case 217 /* WithStatement */:
                    return checkStrictModeWithStatement(node);
                case 167 /* ThisType */:
                    seenThisKeyword = true;
                    return;
                case 156 /* TypePredicate */:
                    return checkTypePredicate(node);
                case 143 /* TypeParameter */:
                    return declareSymbolAndAddToSymbolTable(node, 262144 /* TypeParameter */, 530920 /* TypeParameterExcludes */);
                case 144 /* Parameter */:
                    return bindParameter(node);
                case 223 /* VariableDeclaration */:
                case 174 /* BindingElement */:
                    return bindVariableDeclarationOrBindingElement(node);
                case 147 /* PropertyDeclaration */:
                case 146 /* PropertySignature */:
                case 271 /* JSDocRecordMember */:
                    return bindPropertyOrMethodOrAccessor(node, 4 /* Property */ | (node.questionToken ? 536870912 /* Optional */ : 0 /* None */), 0 /* PropertyExcludes */);
                case 286 /* JSDocPropertyTag */:
                    return bindJSDocProperty(node);
                case 257 /* PropertyAssignment */:
                case 258 /* ShorthandPropertyAssignment */:
                    return bindPropertyOrMethodOrAccessor(node, 4 /* Property */, 0 /* PropertyExcludes */);
                case 260 /* EnumMember */:
                    return bindPropertyOrMethodOrAccessor(node, 8 /* EnumMember */, 900095 /* EnumMemberExcludes */);
                case 259 /* SpreadAssignment */:
                case 251 /* JsxSpreadAttribute */:
                    var root = container;
                    var hasRest = false;
                    while (root.parent) {
                        if (root.kind === 176 /* ObjectLiteralExpression */ &&
                            root.parent.kind === 192 /* BinaryExpression */ &&
                            root.parent.operatorToken.kind === 57 /* EqualsToken */ &&
                            root.parent.left === root) {
                            hasRest = true;
                            break;
                        }
                        root = root.parent;
                    }
                    return;
                case 153 /* CallSignature */:
                case 154 /* ConstructSignature */:
                case 155 /* IndexSignature */:
                    return declareSymbolAndAddToSymbolTable(node, 131072 /* Signature */, 0 /* None */);
                case 149 /* MethodDeclaration */:
                case 148 /* MethodSignature */:
                    // If this is an ObjectLiteralExpression method, then it sits in the same space
                    // as other properties in the object literal.  So we use SymbolFlags.PropertyExcludes
                    // so that it will conflict with any other object literal members with the same
                    // name.
                    return bindPropertyOrMethodOrAccessor(node, 8192 /* Method */ | (node.questionToken ? 536870912 /* Optional */ : 0 /* None */), ts.isObjectLiteralMethod(node) ? 0 /* PropertyExcludes */ : 99263 /* MethodExcludes */);
                case 225 /* FunctionDeclaration */:
                    return bindFunctionDeclaration(node);
                case 150 /* Constructor */:
                    return declareSymbolAndAddToSymbolTable(node, 16384 /* Constructor */, /*symbolExcludes:*/ 0 /* None */);
                case 151 /* GetAccessor */:
                    return bindPropertyOrMethodOrAccessor(node, 32768 /* GetAccessor */, 41919 /* GetAccessorExcludes */);
                case 152 /* SetAccessor */:
                    return bindPropertyOrMethodOrAccessor(node, 65536 /* SetAccessor */, 74687 /* SetAccessorExcludes */);
                case 158 /* FunctionType */:
                case 159 /* ConstructorType */:
                case 274 /* JSDocFunctionType */:
                    return bindFunctionOrConstructorType(node);
                case 161 /* TypeLiteral */:
                case 170 /* MappedType */:
                case 287 /* JSDocTypeLiteral */:
                case 270 /* JSDocRecordType */:
                    return bindAnonymousDeclaration(node, 2048 /* TypeLiteral */, "__type");
                case 176 /* ObjectLiteralExpression */:
                    return bindObjectLiteralExpression(node);
                case 184 /* FunctionExpression */:
                case 185 /* ArrowFunction */:
                    return bindFunctionExpression(node);
                case 179 /* CallExpression */:
                    if (ts.isInJavaScriptFile(node)) {
                        bindCallExpression(node);
                    }
                    break;
                // Members of classes, interfaces, and modules
                case 197 /* ClassExpression */:
                case 226 /* ClassDeclaration */:
                    // All classes are automatically in strict mode in ES6.
                    inStrictMode = true;
                    return bindClassLikeDeclaration(node);
                case 227 /* InterfaceDeclaration */:
                    return bindBlockScopedDeclaration(node, 64 /* Interface */, 792968 /* InterfaceExcludes */);
                case 285 /* JSDocTypedefTag */:
                    if (!node.fullName || node.fullName.kind === 70 /* Identifier */) {
                        return bindBlockScopedDeclaration(node, 524288 /* TypeAlias */, 793064 /* TypeAliasExcludes */);
                    }
                    break;
                case 228 /* TypeAliasDeclaration */:
                    return bindBlockScopedDeclaration(node, 524288 /* TypeAlias */, 793064 /* TypeAliasExcludes */);
                case 229 /* EnumDeclaration */:
                    return bindEnumDeclaration(node);
                case 230 /* ModuleDeclaration */:
                    return bindModuleDeclaration(node);
                // Imports and exports
                case 234 /* ImportEqualsDeclaration */:
                case 237 /* NamespaceImport */:
                case 239 /* ImportSpecifier */:
                case 243 /* ExportSpecifier */:
                    return declareSymbolAndAddToSymbolTable(node, 8388608 /* Alias */, 8388608 /* AliasExcludes */);
                case 233 /* NamespaceExportDeclaration */:
                    return bindNamespaceExportDeclaration(node);
                case 236 /* ImportClause */:
                    return bindImportClause(node);
                case 241 /* ExportDeclaration */:
                    return bindExportDeclaration(node);
                case 240 /* ExportAssignment */:
                    return bindExportAssignment(node);
                case 261 /* SourceFile */:
                    updateStrictModeStatementList(node.statements);
                    return bindSourceFileIfExternalModule();
                case 204 /* Block */:
                    if (!ts.isFunctionLike(node.parent)) {
                        return;
                    }
                // Fall through
                case 231 /* ModuleBlock */:
                    return updateStrictModeStatementList(node.statements);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkTypePredicate) id{221,1} ---
(node) {
            var parameterName = node.parameterName, type = node.type;
            if (parameterName && parameterName.kind === 70 /* Identifier */) {
                checkStrictModeIdentifier(parameterName);
            }
            if (parameterName && parameterName.kind === 167 /* ThisType */) {
                seenThisKeyword = true;
            }
            bind(type);
        }
--- END ---
INLINE (checkTypePredicate) id{221,1} AS 1 AT <0:3560>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:declareSymbolAndAddToSymbolTable) id{221,2} ---
(node, symbolFlags, symbolExcludes) {
            // Just call this directly so that the return type of this function stays "void".
            return declareSymbolAndAddToSymbolTableWorker(node, symbolFlags, symbolExcludes);
        }
--- END ---
INLINE (declareSymbolAndAddToSymbolTable) id{221,2} AS 2 AT <0:3659>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:declareSymbolAndAddToSymbolTable) id{221,3} ---
(node, symbolFlags, symbolExcludes) {
            // Just call this directly so that the return type of this function stays "void".
            return declareSymbolAndAddToSymbolTableWorker(node, symbolFlags, symbolExcludes);
        }
--- END ---
INLINE (declareSymbolAndAddToSymbolTable) id{221,3} AS 3 AT <0:5731>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:bindAnonymousDeclaration) id{221,4} ---
(node, symbolFlags, name) {
            var symbol = createSymbol(symbolFlags, name);
            addDeclarationToSymbol(symbol, node, symbolFlags);
        }
--- END ---
INLINE (bindAnonymousDeclaration) id{221,4} AS 4 AT <0:7511>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createSymbol) id{221,5} ---
(flags, name) {
            symbolCount++;
            return new Symbol(flags, name);
        }
--- END ---
INLINE (createSymbol) id{221,5} AS 5 AT <4:53>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:SymbolObject) id{221,6} ---
(flags, name) {
            this.flags = flags;
            this.name = name;
        }
--- END ---
INLINE (SymbolObject) id{221,6} AS 6 AT <5:62>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:updateStrictModeStatementList) id{221,7} ---
(statements) {
            if (!inStrictMode) {
                for (var _i = 0, statements_2 = statements; _i < statements_2.length; _i++) {
                    var statement = statements_2[_i];
                    if (!ts.isPrologueDirective(statement)) {
                        return;
                    }
                    if (isUseStrictPrologueDirective(statement)) {
                        inStrictMode = true;
                        return;
                    }
                }
            }
        }
--- END ---
INLINE (updateStrictModeStatementList) id{221,7} AS 7 AT <0:10085>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:bindSourceFileIfExternalModule) id{221,8} ---
() {
            setExportContextFlag(file);
            if (ts.isExternalModule(file)) {
                bindSourceFileAsExternalModule();
            }
        }
--- END ---
INLINE (bindSourceFileIfExternalModule) id{221,8} AS 8 AT <0:10160>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:setExportContextFlag) id{221,9} ---
(node) {
            // A declaration source file or ambient module declaration that contains no export declarations (but possibly regular
            // declarations with export modifiers) is an export context in which declarations are implicitly exported.
            if (ts.isInAmbientContext(node) && !hasExportDeclarations(node)) {
                node.flags |= 32 /* ExportContext */;
            }
            else {
                node.flags &= ~32 /* ExportContext */;
            }
        }
--- END ---
INLINE (setExportContextFlag) id{221,9} AS 9 AT <8:17>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:hasExportDeclarations) id{221,10} ---
(node) {
            var body = node.kind === 261 /* SourceFile */ ? node : node.body;
            if (body && (body.kind === 261 /* SourceFile */ || body.kind === 231 /* ModuleBlock */)) {
                for (var _i = 0, _a = body.statements; _i < _a.length; _i++) {
                    var stat = _a[_i];
                    if (stat.kind === 241 /* ExportDeclaration */ || stat.kind === 240 /* ExportAssignment */) {
                        return true;
                    }
                }
            }
            return false;
        }
--- END ---
INLINE (hasExportDeclarations) id{221,10} AS 10 AT <9:306>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:updateStrictModeStatementList) id{221,11} ---
(statements) {
            if (!inStrictMode) {
                for (var _i = 0, statements_2 = statements; _i < statements_2.length; _i++) {
                    var statement = statements_2[_i];
                    if (!ts.isPrologueDirective(statement)) {
                        return;
                    }
                    if (isUseStrictPrologueDirective(statement)) {
                        inStrictMode = true;
                        return;
                    }
                }
            }
        }
--- END ---
INLINE (updateStrictModeStatementList) id{221,11} AS 11 AT <0:10448>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:bindBlockScopedDeclaration) id{222,0} ---
(node, symbolFlags, symbolExcludes) {
            switch (blockScopeContainer.kind) {
                case 230 /* ModuleDeclaration */:
                    declareModuleMember(node, symbolFlags, symbolExcludes);
                    break;
                case 261 /* SourceFile */:
                    if (ts.isExternalModule(container)) {
                        declareModuleMember(node, symbolFlags, symbolExcludes);
                        break;
                    }
                // fall through.
                default:
                    if (!blockScopeContainer.locals) {
                        blockScopeContainer.locals = ts.createMap();
                        addToContainerChain(blockScopeContainer);
                    }
                    declareSymbol(blockScopeContainer.locals, undefined, node, symbolFlags, symbolExcludes);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:bindChildrenWorker) id{223,0} ---
(node) {
            // Binding of JsDocComment should be done before the current block scope container changes.
            // because the scope of JsDocComment should not be affected by whether the current node is a
            // container or not.
            if (ts.isInJavaScriptFile(node) && node.jsDoc) {
                ts.forEach(node.jsDoc, bind);
            }
            if (checkUnreachable(node)) {
                bindEachChild(node);
                return;
            }
            switch (node.kind) {
                case 210 /* WhileStatement */:
                    bindWhileStatement(node);
                    break;
                case 209 /* DoStatement */:
                    bindDoStatement(node);
                    break;
                case 211 /* ForStatement */:
                    bindForStatement(node);
                    break;
                case 212 /* ForInStatement */:
                case 213 /* ForOfStatement */:
                    bindForInOrForOfStatement(node);
                    break;
                case 208 /* IfStatement */:
                    bindIfStatement(node);
                    break;
                case 216 /* ReturnStatement */:
                case 220 /* ThrowStatement */:
                    bindReturnOrThrow(node);
                    break;
                case 215 /* BreakStatement */:
                case 214 /* ContinueStatement */:
                    bindBreakOrContinueStatement(node);
                    break;
                case 221 /* TryStatement */:
                    bindTryStatement(node);
                    break;
                case 218 /* SwitchStatement */:
                    bindSwitchStatement(node);
                    break;
                case 232 /* CaseBlock */:
                    bindCaseBlock(node);
                    break;
                case 253 /* CaseClause */:
                    bindCaseClause(node);
                    break;
                case 219 /* LabeledStatement */:
                    bindLabeledStatement(node);
                    break;
                case 190 /* PrefixUnaryExpression */:
                    bindPrefixUnaryExpressionFlow(node);
                    break;
                case 191 /* PostfixUnaryExpression */:
                    bindPostfixUnaryExpressionFlow(node);
                    break;
                case 192 /* BinaryExpression */:
                    bindBinaryExpressionFlow(node);
                    break;
                case 186 /* DeleteExpression */:
                    bindDeleteExpressionFlow(node);
                    break;
                case 193 /* ConditionalExpression */:
                    bindConditionalExpressionFlow(node);
                    break;
                case 223 /* VariableDeclaration */:
                    bindVariableDeclarationFlow(node);
                    break;
                case 179 /* CallExpression */:
                    bindCallExpressionFlow(node);
                    break;
                default:
                    bindEachChild(node);
                    break;
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:bindVariableDeclarationFlow) id{223,1} ---
(node) {
            bindEachChild(node);
            if (node.initializer || node.parent.parent.kind === 212 /* ForInStatement */ || node.parent.parent.kind === 213 /* ForOfStatement */) {
                bindInitializedVariableFlow(node);
            }
        }
--- END ---
INLINE (bindVariableDeclarationFlow) id{223,1} AS 1 AT <0:2835>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:bindEachChild) id{223,2} ---
(node) {
            ts.forEachChild(node, bind, bindEach);
        }
--- END ---
INLINE (bindEachChild) id{223,2} AS 2 AT <1:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:bindEachChild) id{223,3} ---
(node) {
            ts.forEachChild(node, bind, bindEach);
        }
--- END ---
INLINE (bindEachChild) id{223,3} AS 3 AT <0:3066>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:forEachChild) id{224,0} ---
(node, cbNode, cbNodeArray) {
        if (!node) {
            return;
        }
        // The visitXXX functions could be written as local functions that close over the cbNode and cbNodeArray
        // callback parameters, but that causes a closure allocation for each invocation with noticeable effects
        // on performance.
        var visitNodes = cbNodeArray ? visitNodeArray : visitEachNode;
        var cbNodes = cbNodeArray || cbNode;
        switch (node.kind) {
            case 141 /* QualifiedName */:
                return visitNode(cbNode, node.left) ||
                    visitNode(cbNode, node.right);
            case 143 /* TypeParameter */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.constraint) ||
                    visitNode(cbNode, node.expression);
            case 258 /* ShorthandPropertyAssignment */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNode(cbNode, node.equalsToken) ||
                    visitNode(cbNode, node.objectAssignmentInitializer);
            case 259 /* SpreadAssignment */:
                return visitNode(cbNode, node.expression);
            case 144 /* Parameter */:
            case 147 /* PropertyDeclaration */:
            case 146 /* PropertySignature */:
            case 257 /* PropertyAssignment */:
            case 223 /* VariableDeclaration */:
            case 174 /* BindingElement */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.propertyName) ||
                    visitNode(cbNode, node.dotDotDotToken) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNode(cbNode, node.type) ||
                    visitNode(cbNode, node.initializer);
            case 158 /* FunctionType */:
            case 159 /* ConstructorType */:
            case 153 /* CallSignature */:
            case 154 /* ConstructSignature */:
            case 155 /* IndexSignature */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNodes(cbNodes, node.parameters) ||
                    visitNode(cbNode, node.type);
            case 149 /* MethodDeclaration */:
            case 148 /* MethodSignature */:
            case 150 /* Constructor */:
            case 151 /* GetAccessor */:
            case 152 /* SetAccessor */:
            case 184 /* FunctionExpression */:
            case 225 /* FunctionDeclaration */:
            case 185 /* ArrowFunction */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.asteriskToken) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNodes(cbNodes, node.parameters) ||
                    visitNode(cbNode, node.type) ||
                    visitNode(cbNode, node.equalsGreaterThanToken) ||
                    visitNode(cbNode, node.body);
            case 157 /* TypeReference */:
                return visitNode(cbNode, node.typeName) ||
                    visitNodes(cbNodes, node.typeArguments);
            case 156 /* TypePredicate */:
                return visitNode(cbNode, node.parameterName) ||
                    visitNode(cbNode, node.type);
            case 160 /* TypeQuery */:
                return visitNode(cbNode, node.exprName);
            case 161 /* TypeLiteral */:
                return visitNodes(cbNodes, node.members);
            case 162 /* ArrayType */:
                return visitNode(cbNode, node.elementType);
            case 163 /* TupleType */:
                return visitNodes(cbNodes, node.elementTypes);
            case 164 /* UnionType */:
            case 165 /* IntersectionType */:
                return visitNodes(cbNodes, node.types);
            case 166 /* ParenthesizedType */:
            case 168 /* TypeOperator */:
                return visitNode(cbNode, node.type);
            case 169 /* IndexedAccessType */:
                return visitNode(cbNode, node.objectType) ||
                    visitNode(cbNode, node.indexType);
            case 170 /* MappedType */:
                return visitNode(cbNode, node.readonlyToken) ||
                    visitNode(cbNode, node.typeParameter) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNode(cbNode, node.type);
            case 171 /* LiteralType */:
                return visitNode(cbNode, node.literal);
            case 172 /* ObjectBindingPattern */:
            case 173 /* ArrayBindingPattern */:
                return visitNodes(cbNodes, node.elements);
            case 175 /* ArrayLiteralExpression */:
                return visitNodes(cbNodes, node.elements);
            case 176 /* ObjectLiteralExpression */:
                return visitNodes(cbNodes, node.properties);
            case 177 /* PropertyAccessExpression */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.name);
            case 178 /* ElementAccessExpression */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.argumentExpression);
            case 179 /* CallExpression */:
            case 180 /* NewExpression */:
                return visitNode(cbNode, node.expression) ||
                    visitNodes(cbNodes, node.typeArguments) ||
                    visitNodes(cbNodes, node.arguments);
            case 181 /* TaggedTemplateExpression */:
                return visitNode(cbNode, node.tag) ||
                    visitNode(cbNode, node.template);
            case 182 /* TypeAssertionExpression */:
                return visitNode(cbNode, node.type) ||
                    visitNode(cbNode, node.expression);
            case 183 /* ParenthesizedExpression */:
                return visitNode(cbNode, node.expression);
            case 186 /* DeleteExpression */:
                return visitNode(cbNode, node.expression);
            case 187 /* TypeOfExpression */:
                return visitNode(cbNode, node.expression);
            case 188 /* VoidExpression */:
                return visitNode(cbNode, node.expression);
            case 190 /* PrefixUnaryExpression */:
                return visitNode(cbNode, node.operand);
            case 195 /* YieldExpression */:
                return visitNode(cbNode, node.asteriskToken) ||
                    visitNode(cbNode, node.expression);
            case 189 /* AwaitExpression */:
                return visitNode(cbNode, node.expression);
            case 191 /* PostfixUnaryExpression */:
                return visitNode(cbNode, node.operand);
            case 192 /* BinaryExpression */:
                return visitNode(cbNode, node.left) ||
                    visitNode(cbNode, node.operatorToken) ||
                    visitNode(cbNode, node.right);
            case 200 /* AsExpression */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.type);
            case 201 /* NonNullExpression */:
                return visitNode(cbNode, node.expression);
            case 193 /* ConditionalExpression */:
                return visitNode(cbNode, node.condition) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNode(cbNode, node.whenTrue) ||
                    visitNode(cbNode, node.colonToken) ||
                    visitNode(cbNode, node.whenFalse);
            case 196 /* SpreadElement */:
                return visitNode(cbNode, node.expression);
            case 204 /* Block */:
            case 231 /* ModuleBlock */:
                return visitNodes(cbNodes, node.statements);
            case 261 /* SourceFile */:
                return visitNodes(cbNodes, node.statements) ||
                    visitNode(cbNode, node.endOfFileToken);
            case 205 /* VariableStatement */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.declarationList);
            case 224 /* VariableDeclarationList */:
                return visitNodes(cbNodes, node.declarations);
            case 207 /* ExpressionStatement */:
                return visitNode(cbNode, node.expression);
            case 208 /* IfStatement */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.thenStatement) ||
                    visitNode(cbNode, node.elseStatement);
            case 209 /* DoStatement */:
                return visitNode(cbNode, node.statement) ||
                    visitNode(cbNode, node.expression);
            case 210 /* WhileStatement */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.statement);
            case 211 /* ForStatement */:
                return visitNode(cbNode, node.initializer) ||
                    visitNode(cbNode, node.condition) ||
                    visitNode(cbNode, node.incrementor) ||
                    visitNode(cbNode, node.statement);
            case 212 /* ForInStatement */:
                return visitNode(cbNode, node.initializer) ||
                    visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.statement);
            case 213 /* ForOfStatement */:
                return visitNode(cbNode, node.initializer) ||
                    visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.statement);
            case 214 /* ContinueStatement */:
            case 215 /* BreakStatement */:
                return visitNode(cbNode, node.label);
            case 216 /* ReturnStatement */:
                return visitNode(cbNode, node.expression);
            case 217 /* WithStatement */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.statement);
            case 218 /* SwitchStatement */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.caseBlock);
            case 232 /* CaseBlock */:
                return visitNodes(cbNodes, node.clauses);
            case 253 /* CaseClause */:
                return visitNode(cbNode, node.expression) ||
                    visitNodes(cbNodes, node.statements);
            case 254 /* DefaultClause */:
                return visitNodes(cbNodes, node.statements);
            case 219 /* LabeledStatement */:
                return visitNode(cbNode, node.label) ||
                    visitNode(cbNode, node.statement);
            case 220 /* ThrowStatement */:
                return visitNode(cbNode, node.expression);
            case 221 /* TryStatement */:
                return visitNode(cbNode, node.tryBlock) ||
                    visitNode(cbNode, node.catchClause) ||
                    visitNode(cbNode, node.finallyBlock);
            case 256 /* CatchClause */:
                return visitNode(cbNode, node.variableDeclaration) ||
                    visitNode(cbNode, node.block);
            case 145 /* Decorator */:
                return visitNode(cbNode, node.expression);
            case 226 /* ClassDeclaration */:
            case 197 /* ClassExpression */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNodes(cbNodes, node.heritageClauses) ||
                    visitNodes(cbNodes, node.members);
            case 227 /* InterfaceDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNodes(cbNodes, node.heritageClauses) ||
                    visitNodes(cbNodes, node.members);
            case 228 /* TypeAliasDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNode(cbNode, node.type);
            case 229 /* EnumDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.members);
            case 260 /* EnumMember */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.initializer);
            case 230 /* ModuleDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.body);
            case 234 /* ImportEqualsDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.moduleReference);
            case 235 /* ImportDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.importClause) ||
                    visitNode(cbNode, node.moduleSpecifier);
            case 236 /* ImportClause */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.namedBindings);
            case 233 /* NamespaceExportDeclaration */:
                return visitNode(cbNode, node.name);
            case 237 /* NamespaceImport */:
                return visitNode(cbNode, node.name);
            case 238 /* NamedImports */:
            case 242 /* NamedExports */:
                return visitNodes(cbNodes, node.elements);
            case 241 /* ExportDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.exportClause) ||
                    visitNode(cbNode, node.moduleSpecifier);
            case 239 /* ImportSpecifier */:
            case 243 /* ExportSpecifier */:
                return visitNode(cbNode, node.propertyName) ||
                    visitNode(cbNode, node.name);
            case 240 /* ExportAssignment */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.expression);
            case 194 /* TemplateExpression */:
                return visitNode(cbNode, node.head) || visitNodes(cbNodes, node.templateSpans);
            case 202 /* TemplateSpan */:
                return visitNode(cbNode, node.expression) || visitNode(cbNode, node.literal);
            case 142 /* ComputedPropertyName */:
                return visitNode(cbNode, node.expression);
            case 255 /* HeritageClause */:
                return visitNodes(cbNodes, node.types);
            case 199 /* ExpressionWithTypeArguments */:
                return visitNode(cbNode, node.expression) ||
                    visitNodes(cbNodes, node.typeArguments);
            case 245 /* ExternalModuleReference */:
                return visitNode(cbNode, node.expression);
            case 244 /* MissingDeclaration */:
                return visitNodes(cbNodes, node.decorators);
            case 246 /* JsxElement */:
                return visitNode(cbNode, node.openingElement) ||
                    visitNodes(cbNodes, node.children) ||
                    visitNode(cbNode, node.closingElement);
            case 247 /* JsxSelfClosingElement */:
            case 248 /* JsxOpeningElement */:
                return visitNode(cbNode, node.tagName) ||
                    visitNodes(cbNodes, node.attributes);
            case 250 /* JsxAttribute */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.initializer);
            case 251 /* JsxSpreadAttribute */:
                return visitNode(cbNode, node.expression);
            case 252 /* JsxExpression */:
                return visitNode(cbNode, node.expression);
            case 249 /* JsxClosingElement */:
                return visitNode(cbNode, node.tagName);
            case 262 /* JSDocTypeExpression */:
                return visitNode(cbNode, node.type);
            case 266 /* JSDocUnionType */:
                return visitNodes(cbNodes, node.types);
            case 267 /* JSDocTupleType */:
                return visitNodes(cbNodes, node.types);
            case 265 /* JSDocArrayType */:
                return visitNode(cbNode, node.elementType);
            case 269 /* JSDocNonNullableType */:
                return visitNode(cbNode, node.type);
            case 268 /* JSDocNullableType */:
                return visitNode(cbNode, node.type);
            case 270 /* JSDocRecordType */:
                return visitNode(cbNode, node.literal);
            case 272 /* JSDocTypeReference */:
                return visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.typeArguments);
            case 273 /* JSDocOptionalType */:
                return visitNode(cbNode, node.type);
            case 274 /* JSDocFunctionType */:
                return visitNodes(cbNodes, node.parameters) ||
                    visitNode(cbNode, node.type);
            case 275 /* JSDocVariadicType */:
                return visitNode(cbNode, node.type);
            case 276 /* JSDocConstructorType */:
                return visitNode(cbNode, node.type);
            case 277 /* JSDocThisType */:
                return visitNode(cbNode, node.type);
            case 271 /* JSDocRecordMember */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.type);
            case 278 /* JSDocComment */:
                return visitNodes(cbNodes, node.tags);
            case 281 /* JSDocParameterTag */:
                return visitNode(cbNode, node.preParameterName) ||
                    visitNode(cbNode, node.typeExpression) ||
                    visitNode(cbNode, node.postParameterName);
            case 282 /* JSDocReturnTag */:
                return visitNode(cbNode, node.typeExpression);
            case 283 /* JSDocTypeTag */:
                return visitNode(cbNode, node.typeExpression);
            case 280 /* JSDocAugmentsTag */:
                return visitNode(cbNode, node.typeExpression);
            case 284 /* JSDocTemplateTag */:
                return visitNodes(cbNodes, node.typeParameters);
            case 285 /* JSDocTypedefTag */:
                return visitNode(cbNode, node.typeExpression) ||
                    visitNode(cbNode, node.fullName) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.jsDocTypeLiteral);
            case 287 /* JSDocTypeLiteral */:
                return visitNodes(cbNodes, node.jsDocPropertyTags);
            case 286 /* JSDocPropertyTag */:
                return visitNode(cbNode, node.typeExpression) ||
                    visitNode(cbNode, node.name);
            case 294 /* PartiallyEmittedExpression */:
                return visitNode(cbNode, node.expression);
            case 288 /* JSDocLiteralType */:
                return visitNode(cbNode, node.literal);
        }
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{224,1} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{224,1} AS 1 AT <0:544>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{224,2} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{224,2} AS 2 AT <0:596>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{224,3} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{224,3} AS 3 AT <0:692>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{224,4} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{224,4} AS 4 AT <0:744>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{224,5} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{224,5} AS 5 AT <0:802>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{224,6} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{224,6} AS 6 AT <0:1658>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{224,7} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{224,7} AS 7 AT <0:1718>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{224,8} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{224,8} AS 8 AT <0:1777>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{224,9} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{224,9} AS 9 AT <0:1837>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{224,10} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{224,10} AS 10 AT <0:1899>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{224,11} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{224,11} AS 11 AT <0:1951>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{224,12} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{224,12} AS 12 AT <0:2012>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{224,13} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{224,13} AS 13 AT <0:2064>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{224,14} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{224,14} AS 14 AT <0:2341>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{224,15} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{224,15} AS 15 AT <0:2401>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{224,16} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{224,16} AS 16 AT <0:2460>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{224,17} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{224,17} AS 17 AT <0:2524>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{224,18} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{224,18} AS 18 AT <0:2584>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{224,19} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{224,19} AS 19 AT <0:2984>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{224,20} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{224,20} AS 20 AT <0:3044>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{224,21} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{224,21} AS 21 AT <0:3103>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{224,22} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{224,22} AS 22 AT <0:3164>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{224,23} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{224,23} AS 23 AT <0:3216>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{224,24} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{224,24} AS 24 AT <0:3277>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{224,25} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{224,25} AS 25 AT <0:3341>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{224,26} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{224,26} AS 26 AT <0:3401>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{224,27} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{224,27} AS 27 AT <0:3453>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{224,28} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{224,28} AS 28 AT <0:3523>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{224,29} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{224,29} AS 29 AT <0:3618>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{224,30} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{224,30} AS 30 AT <0:3674>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{224,31} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{224,31} AS 31 AT <0:3780>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{224,32} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{224,32} AS 32 AT <0:3841>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{224,33} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{224,33} AS 33 AT <0:4029>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{224,34} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{224,34} AS 34 AT <0:4125>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{224,35} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{224,35} AS 35 AT <0:4223>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{224,36} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{224,36} AS 36 AT <0:4369>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{224,37} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{224,37} AS 37 AT <0:4512>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{224,38} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{224,38} AS 38 AT <0:4611>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{224,39} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{224,39} AS 39 AT <0:4669>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{224,40} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{224,40} AS 40 AT <0:4766>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{224,41} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{224,41} AS 41 AT <0:4827>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{224,42} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{224,42} AS 42 AT <0:4888>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{224,43} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{224,43} AS 43 AT <0:4949>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{224,44} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{224,44} AS 44 AT <0:8393>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{224,45} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{224,45} AS 45 AT <0:8562>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{224,46} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{224,46} AS 46 AT <0:8622>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{224,47} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{224,47} AS 47 AT <0:8681>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{224,48} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{224,48} AS 48 AT <0:8797>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{224,49} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{224,49} AS 49 AT <0:12363>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{224,50} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{224,50} AS 50 AT <0:12423>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{224,51} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{224,51} AS 51 AT <0:12482>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{224,52} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{224,52} AS 52 AT <0:12534>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{224,53} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{224,53} AS 53 AT <0:12598>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{224,54} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{224,54} AS 54 AT <0:12663>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{224,55} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{224,55} AS 55 AT <0:12770>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{224,56} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{224,56} AS 56 AT <0:12830>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{224,57} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{224,57} AS 57 AT <0:12889>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{224,58} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{224,58} AS 58 AT <0:12941>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:addDeclarationToSymbol) id{225,0} ---
(symbol, node, symbolFlags) {
            symbol.flags |= symbolFlags;
            node.symbol = symbol;
            if (!symbol.declarations) {
                symbol.declarations = [];
            }
            symbol.declarations.push(node);
            if (symbolFlags & 1952 /* HasExports */ && !symbol.exports) {
                symbol.exports = ts.createMap();
            }
            if (symbolFlags & 6240 /* HasMembers */ && !symbol.members) {
                symbol.members = ts.createMap();
            }
            if (symbolFlags & 107455 /* Value */) {
                var valueDeclaration = symbol.valueDeclaration;
                if (!valueDeclaration ||
                    (valueDeclaration.kind !== node.kind && valueDeclaration.kind === 230 /* ModuleDeclaration */)) {
                    // other kinds of value declarations take precedence over modules
                    symbol.valueDeclaration = node;
                }
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:declareSymbol) id{226,0} ---
(symbolTable, parent, node, includes, excludes) {
            ts.Debug.assert(!ts.hasDynamicName(node));
            var isDefaultExport = ts.hasModifier(node, 512 /* Default */);
            // The exported symbol for an export default function/class node is always named "default"
            var name = isDefaultExport && parent ? "default" : getDeclarationName(node);
            var symbol;
            if (name === undefined) {
                symbol = createSymbol(0 /* None */, "__missing");
            }
            else {
                // Check and see if the symbol table already has a symbol with this name.  If not,
                // create a new symbol with this name and add it to the table.  Note that we don't
                // give the new symbol any flags *yet*.  This ensures that it will not conflict
                // with the 'excludes' flags we pass in.
                //
                // If we do get an existing symbol, see if it conflicts with the new symbol we're
                // creating.  For example, a 'var' symbol and a 'class' symbol will conflict within
                // the same symbol table.  If we have a conflict, report the issue on each
                // declaration we have for this symbol, and then create a new symbol for this
                // declaration.
                //
                // Note that when properties declared in Javascript constructors
                // (marked by isReplaceableByMethod) conflict with another symbol, the property loses.
                // Always. This allows the common Javascript pattern of overwriting a prototype method
                // with an bound instance method of the same type: `this.method = this.method.bind(this)`
                //
                // If we created a new symbol, either because we didn't have a symbol with this name
                // in the symbol table, or we conflicted with an existing symbol, then just add this
                // node as the sole declaration of the new symbol.
                //
                // Otherwise, we'll be merging into a compatible existing symbol (for example when
                // you have multiple 'vars' with the same name in the same container).  In this case
                // just add this node into the declarations list of the symbol.
                symbol = symbolTable[name] || (symbolTable[name] = createSymbol(0 /* None */, name));
                if (name && (includes & 788448 /* Classifiable */)) {
                    classifiableNames[name] = name;
                }
                if (symbol.flags & excludes) {
                    if (symbol.isReplaceableByMethod) {
                        // Javascript constructor-declared symbols can be discarded in favor of
                        // prototype symbols like methods.
                        symbol = symbolTable[name] = createSymbol(0 /* None */, name);
                    }
                    else {
                        if (node.name) {
                            node.name.parent = node;
                        }
                        // Report errors every position with duplicate declaration
                        // Report errors on previous encountered declarations
                        var message_1 = symbol.flags & 2 /* BlockScopedVariable */
                            ? ts.Diagnostics.Cannot_redeclare_block_scoped_variable_0
                            : ts.Diagnostics.Duplicate_identifier_0;
                        if (symbol.declarations && symbol.declarations.length) {
                            // If the current node is a default export of some sort, then check if
                            // there are any other default exports that we need to error on.
                            // We'll know whether we have other default exports depending on if `symbol` already has a declaration list set.
                            if (isDefaultExport) {
                                message_1 = ts.Diagnostics.A_module_cannot_have_multiple_default_exports;
                            }
                            else {
                                // This is to properly report an error in the case "export default { }" is after export default of class declaration or function declaration.
                                // Error on multiple export default in the following case:
                                // 1. multiple export default of class declaration or function declaration by checking NodeFlags.Default
                                // 2. multiple export default of export assignment. This one doesn't have NodeFlags.Default on (as export default doesn't considered as modifiers)
                                if (symbol.declarations && symbol.declarations.length &&
                                    (isDefaultExport || (node.kind === 240 /* ExportAssignment */ && !node.isExportEquals))) {
                                    message_1 = ts.Diagnostics.A_module_cannot_have_multiple_default_exports;
                                }
                            }
                        }
                        ts.forEach(symbol.declarations, function (declaration) {
                            file.bindDiagnostics.push(ts.createDiagnosticForNode(declaration.name || declaration, message_1, getDisplayName(declaration)));
                        });
                        file.bindDiagnostics.push(ts.createDiagnosticForNode(node.name || node, message_1, getDisplayName(node)));
                        symbol = createSymbol(0 /* None */, name);
                    }
                }
            }
            addDeclarationToSymbol(symbol, node, includes);
            symbol.parent = parent;
            return symbol;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createSymbol) id{226,1} ---
(flags, name) {
            symbolCount++;
            return new Symbol(flags, name);
        }
--- END ---
INLINE (createSymbol) id{226,1} AS 1 AT <0:2384>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:SymbolObject) id{226,2} ---
(flags, name) {
            this.flags = flags;
            this.name = name;
        }
--- END ---
INLINE (SymbolObject) id{226,2} AS 2 AT <1:62>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:declareSymbolAndAddToSymbolTableWorker) id{227,0} ---
(node, symbolFlags, symbolExcludes) {
            switch (container.kind) {
                // Modules, source files, and classes need specialized handling for how their
                // members are declared (for example, a member of a class will go into a specific
                // symbol table depending on if it is static or not). We defer to specialized
                // handlers to take care of declaring these child members.
                case 230 /* ModuleDeclaration */:
                    return declareModuleMember(node, symbolFlags, symbolExcludes);
                case 261 /* SourceFile */:
                    return declareSourceFileMember(node, symbolFlags, symbolExcludes);
                case 197 /* ClassExpression */:
                case 226 /* ClassDeclaration */:
                    return declareClassMember(node, symbolFlags, symbolExcludes);
                case 229 /* EnumDeclaration */:
                    return declareSymbol(container.symbol.exports, container.symbol, node, symbolFlags, symbolExcludes);
                case 161 /* TypeLiteral */:
                case 176 /* ObjectLiteralExpression */:
                case 227 /* InterfaceDeclaration */:
                case 270 /* JSDocRecordType */:
                case 287 /* JSDocTypeLiteral */:
                    // Interface/Object-types always have their children added to the 'members' of
                    // their container. They are only accessible through an instance of their
                    // container, and are never in scope otherwise (even inside the body of the
                    // object / type / interface declaring them). An exception is type parameters,
                    // which are in scope without qualification (similar to 'locals').
                    return declareSymbol(container.symbol.members, container.symbol, node, symbolFlags, symbolExcludes);
                case 158 /* FunctionType */:
                case 159 /* ConstructorType */:
                case 153 /* CallSignature */:
                case 154 /* ConstructSignature */:
                case 155 /* IndexSignature */:
                case 149 /* MethodDeclaration */:
                case 148 /* MethodSignature */:
                case 150 /* Constructor */:
                case 151 /* GetAccessor */:
                case 152 /* SetAccessor */:
                case 225 /* FunctionDeclaration */:
                case 184 /* FunctionExpression */:
                case 185 /* ArrowFunction */:
                case 274 /* JSDocFunctionType */:
                case 228 /* TypeAliasDeclaration */:
                case 170 /* MappedType */:
                    // All the children of these container types are never visible through another
                    // symbol (i.e. through another symbol's 'exports' or 'members').  Instead,
                    // they're only accessed 'lexically' (i.e. from code that exists underneath
                    // their container in the tree.  To accomplish this, we simply add their declared
                    // symbol to the 'locals' of the container.  These symbols can then be found as
                    // the type checker walks up the containers, checking them for matching names.
                    return declareSymbol(container.locals, /*parent*/ undefined, node, symbolFlags, symbolExcludes);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:declareSourceFileMember) id{227,1} ---
(node, symbolFlags, symbolExcludes) {
            return ts.isExternalModule(file)
                ? declareModuleMember(node, symbolFlags, symbolExcludes)
                : declareSymbol(file.locals, undefined, node, symbolFlags, symbolExcludes);
        }
--- END ---
INLINE (declareSourceFileMember) id{227,1} AS 1 AT <0:640>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:forEach) id{228,0} ---
(array, callback) {
        if (array) {
            for (var i = 0, len = array.length; i < len; i++) {
                var result = callback(array[i], i);
                if (result) {
                    return result;
                }
            }
        }
        return undefined;
    }
--- END ---
[deoptimizing (DEOPT eager): begin 0xd6230dcddc1 <JS Function isDynamicName (SharedFunctionInfo 0x3504a53d2359)> (opt #201) @2, FP to SP delta: 24, caller sp: 0x7fff5fbfd668]
  reading input frame isDynamicName => node=4, args=2, height=1; inputs:
      0: 0xd6230dcddc1 ; [fp - 16] 0xd6230dcddc1 <JS Function isDynamicName (SharedFunctionInfo 0x3504a53d2359)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x33c6803f5b41 ; rax 0x33c6803f5b41 <a TokenObject with map 0x33abe2a67fc1>
      3: 0xd6230db34c9 ; [fp - 24] 0xd6230db34c9 <FixedArray[156]>
  translating frame isDynamicName => node=4, height=0
    0x7fff5fbfd660: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd658: [top + 32] <- 0x33c6803f5b41 ;  0x33c6803f5b41 <a TokenObject with map 0x33abe2a67fc1>  (input #2)
    0x7fff5fbfd650: [top + 24] <- 0x2c21d2523338 ;  caller's pc
    0x7fff5fbfd648: [top + 16] <- 0x7fff5fbfd680 ;  caller's fp
    0x7fff5fbfd640: [top + 8] <- 0xd6230db34c9 ;  context    0xd6230db34c9 <FixedArray[156]>  (input #3)
    0x7fff5fbfd638: [top + 0] <- 0xd6230dcddc1 ;  function    0xd6230dcddc1 <JS Function isDynamicName (SharedFunctionInfo 0x3504a53d2359)>  (input #0)
[deoptimizing (eager): end 0xd6230dcddc1 <JS Function isDynamicName (SharedFunctionInfo 0x3504a53d2359)> @2 => node=4, pc=0x2c21d2523406, caller sp=0x7fff5fbfd668, state=NO_REGISTERS, took 0.059 ms]
[deoptimizing (DEOPT eager): begin 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> (opt #224) @314, FP to SP delta: 728, caller sp: 0x7fff5fbfd6f8]
            ;;; deoptimize at 0_3423: Unknown map in polymorphic access
  reading input frame forEachChild => node=874, args=4, height=5; inputs:
      0: 0xd6230dc36a9 ; [fp - 16] 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>
      1: 0x16f3adb61821 ; [fp + 40] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x33c68039f721 ; rcx 0x33c68039f721 <a NodeObject with map 0x33abe2a70159>
      3: 0x2f05bb805f51 ; [fp + 24] 0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>
      4: 0x2f05bb804889 ; [fp + 16] 0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>
      5: 0xd6230d99249 ; rbx 0xd6230d99249 <FixedArray[15]>
      6: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      8: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      9: 0x30bcea404311 ; rax 0x30bcea404311 <undefined>
  translating frame forEachChild => node=874, height=32
    0x7fff5fbfd6f0: [top + 88] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfd6e8: [top + 80] <- 0x33c68039f721 ;  0x33c68039f721 <a NodeObject with map 0x33abe2a70159>  (input #2)
    0x7fff5fbfd6e0: [top + 72] <- 0x2f05bb805f51 ;  0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>  (input #3)
    0x7fff5fbfd6d8: [top + 64] <- 0x2f05bb804889 ;  0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>  (input #4)
    0x7fff5fbfd6d0: [top + 56] <- 0x2c21d2577908 ;  caller's pc
    0x7fff5fbfd6c8: [top + 48] <- 0x7fff5fbfd740 ;  caller's fp
    0x7fff5fbfd6c0: [top + 40] <- 0xd6230d99249 ;  context    0xd6230d99249 <FixedArray[15]>  (input #5)
    0x7fff5fbfd6b8: [top + 32] <- 0xd6230dc36a9 ;  function    0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>  (input #0)
    0x7fff5fbfd6b0: [top + 24] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfd6a8: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #7)
    0x7fff5fbfd6a0: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #8)
    0x7fff5fbfd698: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
[deoptimizing (eager): end 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> @314 => node=874, pc=0x2c21d24c5c12, caller sp=0x7fff5fbfd6f8, state=TOS_REGISTER, took 0.097 ms]
[deoptimizer unlinked: forEachChild / d6230dc36a9]
[deoptimizing (DEOPT eager): begin 0x2f05bb804691 <JS Function addDeclarationToSymbol (SharedFunctionInfo 0x16f3adb57e21)> (opt #225) @30, FP to SP delta: 48, caller sp: 0x7fff5fbfd5b0]
            ;;; deoptimize at 0_713: wrong map
  reading input frame addDeclarationToSymbol => node=277, args=4, height=2; inputs:
      0: 0x2f05bb804691 ; [fp - 16] 0x2f05bb804691 <JS Function addDeclarationToSymbol (SharedFunctionInfo 0x16f3adb57e21)>
      1: 0x1f9f6c0532e1 ; [fp + 40] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x19a2de35b349 ; rbx 0x19a2de35b349 <a SymbolObject with map 0x33abe2a6fb29>
      3: 0x33c68039f7a1 ; [fp + 24] 0x33c68039f7a1 <a NodeObject with map 0x33abe2a70051>
      4: 0x200000000000 ; [fp + 16] 8192
      5: 0xd6230dfeea1 ; [fp - 24] 0xd6230dfeea1 <FixedArray[147]>
      6: 0x33c68039f721 ; rax 0x33c68039f721 <a NodeObject with map 0x33abe2a70159>
  translating frame addDeclarationToSymbol => node=277, height=8
    0x7fff5fbfd5a8: [top + 64] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd5a0: [top + 56] <- 0x19a2de35b349 ;  0x19a2de35b349 <a SymbolObject with map 0x33abe2a6fb29>  (input #2)
    0x7fff5fbfd598: [top + 48] <- 0x33c68039f7a1 ;  0x33c68039f7a1 <a NodeObject with map 0x33abe2a70051>  (input #3)
    0x7fff5fbfd590: [top + 40] <- 0x200000000000 ;  8192  (input #4)
    0x7fff5fbfd588: [top + 32] <- 0x2c21d257f06d ;  caller's pc
    0x7fff5fbfd580: [top + 24] <- 0x7fff5fbfd600 ;  caller's fp
    0x7fff5fbfd578: [top + 16] <- 0xd6230dfeea1 ;  context    0xd6230dfeea1 <FixedArray[147]>  (input #5)
    0x7fff5fbfd570: [top + 8] <- 0x2f05bb804691 ;  function    0x2f05bb804691 <JS Function addDeclarationToSymbol (SharedFunctionInfo 0x16f3adb57e21)>  (input #0)
    0x7fff5fbfd568: [top + 0] <- 0x33c68039f721 ;  0x33c68039f721 <a NodeObject with map 0x33abe2a70159>  (input #6)
[deoptimizing (eager): end 0x2f05bb804691 <JS Function addDeclarationToSymbol (SharedFunctionInfo 0x16f3adb57e21)> @30 => node=277, pc=0x2c21d2524c9e, caller sp=0x7fff5fbfd5b0, state=NO_REGISTERS, took 0.069 ms]
[deoptimizing (DEOPT lazy): begin 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> (opt #224) @134, FP to SP delta: 728, caller sp: 0x7fff5fbfdc68]
  reading input frame forEachChild => node=4009, args=4, height=5; inputs:
      0: 0xd6230dc36a9 ; [fp - 16] 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>
      1: 0x16f3adb61821 ; [fp + 40] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x33c680347939 ; [fp + 32] 0x33c680347939 <a NodeObject with map 0x33abe2a70101>
      3: 0x2f05bb805f51 ; [fp + 24] 0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>
      4: 0x2f05bb804889 ; [fp + 16] 0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>
      5: 0xd6230d99249 ; [fp - 24] 0xd6230d99249 <FixedArray[15]>
      6: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      8: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      9: 0xd6230dd5d69 ; [fp - 32] 0xd6230dd5d69 <JS Function visitNodeArray (SharedFunctionInfo 0x3504a53f0029)>
  reading input frame visitNodeArray => node=14, args=3, height=2; inputs:
      0: 0xd6230dd5d69 ; (literal 7) 0xd6230dd5d69 <JS Function visitNodeArray (SharedFunctionInfo 0x3504a53f0029)>
      1: 0x1f9f6c0532e1 ; (literal 8) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2f05bb804889 ; [fp - 40] 0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>
      3: 0x33c68035f091 ; [fp - 136] 0x33c68035f091 <JS Array[20]>
      4: 0xd6230d99249 ; (literal 9) 0xd6230d99249 <FixedArray[15]>
      5: 0x30bcea404311 ; rax 0x30bcea404311 <undefined>
  translating frame forEachChild => node=4009, height=32
    0x7fff5fbfdc60: [top + 88] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfdc58: [top + 80] <- 0x33c680347939 ;  0x33c680347939 <a NodeObject with map 0x33abe2a70101>  (input #2)
    0x7fff5fbfdc50: [top + 72] <- 0x2f05bb805f51 ;  0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>  (input #3)
    0x7fff5fbfdc48: [top + 64] <- 0x2f05bb804889 ;  0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>  (input #4)
    0x7fff5fbfdc40: [top + 56] <- 0x2c21d2577908 ;  caller's pc
    0x7fff5fbfdc38: [top + 48] <- 0x7fff5fbfdcb0 ;  caller's fp
    0x7fff5fbfdc30: [top + 40] <- 0xd6230d99249 ;  context    0xd6230d99249 <FixedArray[15]>  (input #5)
    0x7fff5fbfdc28: [top + 32] <- 0xd6230dc36a9 ;  function    0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>  (input #0)
    0x7fff5fbfdc20: [top + 24] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfdc18: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #7)
    0x7fff5fbfdc10: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #8)
    0x7fff5fbfdc08: [top + 0] <- 0xd6230dd5d69 ;  0xd6230dd5d69 <JS Function visitNodeArray (SharedFunctionInfo 0x3504a53f0029)>  (input #9)
  translating frame visitNodeArray => node=14, height=8
    0x7fff5fbfdc00: [top + 56] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdbf8: [top + 48] <- 0x2f05bb804889 ;  0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>  (input #2)
    0x7fff5fbfdbf0: [top + 40] <- 0x33c68035f091 ;  0x33c68035f091 <JS Array[20]>  (input #3)
    0x7fff5fbfdbe8: [top + 32] <- 0x2c21d24c8424 ;  caller's pc
    0x7fff5fbfdbe0: [top + 24] <- 0x7fff5fbfdc38 ;  caller's fp
    0x7fff5fbfdbd8: [top + 16] <- 0xd6230d99249 ;  context    0xd6230d99249 <FixedArray[15]>  (input #4)
    0x7fff5fbfdbd0: [top + 8] <- 0xd6230dd5d69 ;  function    0xd6230dd5d69 <JS Function visitNodeArray (SharedFunctionInfo 0x3504a53f0029)>  (input #0)
    0x7fff5fbfdbc8: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
[deoptimizing (lazy): end 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> @134 => node=14, pc=0x2c21d25490ed, caller sp=0x7fff5fbfdc68, state=TOS_REGISTER, took 0.124 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isDynamicName) id{229,0} ---
(name) {
        return name.kind === 142 /* ComputedPropertyName */ &&
            !isStringOrNumericLiteral(name.expression) &&
            !isWellKnownSymbolSyntactically(name.expression);
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isBindingPattern) id{230,0} ---
(node) {
        if (node) {
            var kind = node.kind;
            return kind === 173 /* ArrayBindingPattern */
                || kind === 172 /* ObjectBindingPattern */;
        }
        return false;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:forEachChild) id{231,0} ---
(node, cbNode, cbNodeArray) {
        if (!node) {
            return;
        }
        // The visitXXX functions could be written as local functions that close over the cbNode and cbNodeArray
        // callback parameters, but that causes a closure allocation for each invocation with noticeable effects
        // on performance.
        var visitNodes = cbNodeArray ? visitNodeArray : visitEachNode;
        var cbNodes = cbNodeArray || cbNode;
        switch (node.kind) {
            case 141 /* QualifiedName */:
                return visitNode(cbNode, node.left) ||
                    visitNode(cbNode, node.right);
            case 143 /* TypeParameter */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.constraint) ||
                    visitNode(cbNode, node.expression);
            case 258 /* ShorthandPropertyAssignment */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNode(cbNode, node.equalsToken) ||
                    visitNode(cbNode, node.objectAssignmentInitializer);
            case 259 /* SpreadAssignment */:
                return visitNode(cbNode, node.expression);
            case 144 /* Parameter */:
            case 147 /* PropertyDeclaration */:
            case 146 /* PropertySignature */:
            case 257 /* PropertyAssignment */:
            case 223 /* VariableDeclaration */:
            case 174 /* BindingElement */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.propertyName) ||
                    visitNode(cbNode, node.dotDotDotToken) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNode(cbNode, node.type) ||
                    visitNode(cbNode, node.initializer);
            case 158 /* FunctionType */:
            case 159 /* ConstructorType */:
            case 153 /* CallSignature */:
            case 154 /* ConstructSignature */:
            case 155 /* IndexSignature */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNodes(cbNodes, node.parameters) ||
                    visitNode(cbNode, node.type);
            case 149 /* MethodDeclaration */:
            case 148 /* MethodSignature */:
            case 150 /* Constructor */:
            case 151 /* GetAccessor */:
            case 152 /* SetAccessor */:
            case 184 /* FunctionExpression */:
            case 225 /* FunctionDeclaration */:
            case 185 /* ArrowFunction */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.asteriskToken) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNodes(cbNodes, node.parameters) ||
                    visitNode(cbNode, node.type) ||
                    visitNode(cbNode, node.equalsGreaterThanToken) ||
                    visitNode(cbNode, node.body);
            case 157 /* TypeReference */:
                return visitNode(cbNode, node.typeName) ||
                    visitNodes(cbNodes, node.typeArguments);
            case 156 /* TypePredicate */:
                return visitNode(cbNode, node.parameterName) ||
                    visitNode(cbNode, node.type);
            case 160 /* TypeQuery */:
                return visitNode(cbNode, node.exprName);
            case 161 /* TypeLiteral */:
                return visitNodes(cbNodes, node.members);
            case 162 /* ArrayType */:
                return visitNode(cbNode, node.elementType);
            case 163 /* TupleType */:
                return visitNodes(cbNodes, node.elementTypes);
            case 164 /* UnionType */:
            case 165 /* IntersectionType */:
                return visitNodes(cbNodes, node.types);
            case 166 /* ParenthesizedType */:
            case 168 /* TypeOperator */:
                return visitNode(cbNode, node.type);
            case 169 /* IndexedAccessType */:
                return visitNode(cbNode, node.objectType) ||
                    visitNode(cbNode, node.indexType);
            case 170 /* MappedType */:
                return visitNode(cbNode, node.readonlyToken) ||
                    visitNode(cbNode, node.typeParameter) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNode(cbNode, node.type);
            case 171 /* LiteralType */:
                return visitNode(cbNode, node.literal);
            case 172 /* ObjectBindingPattern */:
            case 173 /* ArrayBindingPattern */:
                return visitNodes(cbNodes, node.elements);
            case 175 /* ArrayLiteralExpression */:
                return visitNodes(cbNodes, node.elements);
            case 176 /* ObjectLiteralExpression */:
                return visitNodes(cbNodes, node.properties);
            case 177 /* PropertyAccessExpression */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.name);
            case 178 /* ElementAccessExpression */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.argumentExpression);
            case 179 /* CallExpression */:
            case 180 /* NewExpression */:
                return visitNode(cbNode, node.expression) ||
                    visitNodes(cbNodes, node.typeArguments) ||
                    visitNodes(cbNodes, node.arguments);
            case 181 /* TaggedTemplateExpression */:
                return visitNode(cbNode, node.tag) ||
                    visitNode(cbNode, node.template);
            case 182 /* TypeAssertionExpression */:
                return visitNode(cbNode, node.type) ||
                    visitNode(cbNode, node.expression);
            case 183 /* ParenthesizedExpression */:
                return visitNode(cbNode, node.expression);
            case 186 /* DeleteExpression */:
                return visitNode(cbNode, node.expression);
            case 187 /* TypeOfExpression */:
                return visitNode(cbNode, node.expression);
            case 188 /* VoidExpression */:
                return visitNode(cbNode, node.expression);
            case 190 /* PrefixUnaryExpression */:
                return visitNode(cbNode, node.operand);
            case 195 /* YieldExpression */:
                return visitNode(cbNode, node.asteriskToken) ||
                    visitNode(cbNode, node.expression);
            case 189 /* AwaitExpression */:
                return visitNode(cbNode, node.expression);
            case 191 /* PostfixUnaryExpression */:
                return visitNode(cbNode, node.operand);
            case 192 /* BinaryExpression */:
                return visitNode(cbNode, node.left) ||
                    visitNode(cbNode, node.operatorToken) ||
                    visitNode(cbNode, node.right);
            case 200 /* AsExpression */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.type);
            case 201 /* NonNullExpression */:
                return visitNode(cbNode, node.expression);
            case 193 /* ConditionalExpression */:
                return visitNode(cbNode, node.condition) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNode(cbNode, node.whenTrue) ||
                    visitNode(cbNode, node.colonToken) ||
                    visitNode(cbNode, node.whenFalse);
            case 196 /* SpreadElement */:
                return visitNode(cbNode, node.expression);
            case 204 /* Block */:
            case 231 /* ModuleBlock */:
                return visitNodes(cbNodes, node.statements);
            case 261 /* SourceFile */:
                return visitNodes(cbNodes, node.statements) ||
                    visitNode(cbNode, node.endOfFileToken);
            case 205 /* VariableStatement */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.declarationList);
            case 224 /* VariableDeclarationList */:
                return visitNodes(cbNodes, node.declarations);
            case 207 /* ExpressionStatement */:
                return visitNode(cbNode, node.expression);
            case 208 /* IfStatement */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.thenStatement) ||
                    visitNode(cbNode, node.elseStatement);
            case 209 /* DoStatement */:
                return visitNode(cbNode, node.statement) ||
                    visitNode(cbNode, node.expression);
            case 210 /* WhileStatement */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.statement);
            case 211 /* ForStatement */:
                return visitNode(cbNode, node.initializer) ||
                    visitNode(cbNode, node.condition) ||
                    visitNode(cbNode, node.incrementor) ||
                    visitNode(cbNode, node.statement);
            case 212 /* ForInStatement */:
                return visitNode(cbNode, node.initializer) ||
                    visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.statement);
            case 213 /* ForOfStatement */:
                return visitNode(cbNode, node.initializer) ||
                    visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.statement);
            case 214 /* ContinueStatement */:
            case 215 /* BreakStatement */:
                return visitNode(cbNode, node.label);
            case 216 /* ReturnStatement */:
                return visitNode(cbNode, node.expression);
            case 217 /* WithStatement */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.statement);
            case 218 /* SwitchStatement */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.caseBlock);
            case 232 /* CaseBlock */:
                return visitNodes(cbNodes, node.clauses);
            case 253 /* CaseClause */:
                return visitNode(cbNode, node.expression) ||
                    visitNodes(cbNodes, node.statements);
            case 254 /* DefaultClause */:
                return visitNodes(cbNodes, node.statements);
            case 219 /* LabeledStatement */:
                return visitNode(cbNode, node.label) ||
                    visitNode(cbNode, node.statement);
            case 220 /* ThrowStatement */:
                return visitNode(cbNode, node.expression);
            case 221 /* TryStatement */:
                return visitNode(cbNode, node.tryBlock) ||
                    visitNode(cbNode, node.catchClause) ||
                    visitNode(cbNode, node.finallyBlock);
            case 256 /* CatchClause */:
                return visitNode(cbNode, node.variableDeclaration) ||
                    visitNode(cbNode, node.block);
            case 145 /* Decorator */:
                return visitNode(cbNode, node.expression);
            case 226 /* ClassDeclaration */:
            case 197 /* ClassExpression */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNodes(cbNodes, node.heritageClauses) ||
                    visitNodes(cbNodes, node.members);
            case 227 /* InterfaceDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNodes(cbNodes, node.heritageClauses) ||
                    visitNodes(cbNodes, node.members);
            case 228 /* TypeAliasDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNode(cbNode, node.type);
            case 229 /* EnumDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.members);
            case 260 /* EnumMember */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.initializer);
            case 230 /* ModuleDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.body);
            case 234 /* ImportEqualsDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.moduleReference);
            case 235 /* ImportDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.importClause) ||
                    visitNode(cbNode, node.moduleSpecifier);
            case 236 /* ImportClause */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.namedBindings);
            case 233 /* NamespaceExportDeclaration */:
                return visitNode(cbNode, node.name);
            case 237 /* NamespaceImport */:
                return visitNode(cbNode, node.name);
            case 238 /* NamedImports */:
            case 242 /* NamedExports */:
                return visitNodes(cbNodes, node.elements);
            case 241 /* ExportDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.exportClause) ||
                    visitNode(cbNode, node.moduleSpecifier);
            case 239 /* ImportSpecifier */:
            case 243 /* ExportSpecifier */:
                return visitNode(cbNode, node.propertyName) ||
                    visitNode(cbNode, node.name);
            case 240 /* ExportAssignment */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.expression);
            case 194 /* TemplateExpression */:
                return visitNode(cbNode, node.head) || visitNodes(cbNodes, node.templateSpans);
            case 202 /* TemplateSpan */:
                return visitNode(cbNode, node.expression) || visitNode(cbNode, node.literal);
            case 142 /* ComputedPropertyName */:
                return visitNode(cbNode, node.expression);
            case 255 /* HeritageClause */:
                return visitNodes(cbNodes, node.types);
            case 199 /* ExpressionWithTypeArguments */:
                return visitNode(cbNode, node.expression) ||
                    visitNodes(cbNodes, node.typeArguments);
            case 245 /* ExternalModuleReference */:
                return visitNode(cbNode, node.expression);
            case 244 /* MissingDeclaration */:
                return visitNodes(cbNodes, node.decorators);
            case 246 /* JsxElement */:
                return visitNode(cbNode, node.openingElement) ||
                    visitNodes(cbNodes, node.children) ||
                    visitNode(cbNode, node.closingElement);
            case 247 /* JsxSelfClosingElement */:
            case 248 /* JsxOpeningElement */:
                return visitNode(cbNode, node.tagName) ||
                    visitNodes(cbNodes, node.attributes);
            case 250 /* JsxAttribute */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.initializer);
            case 251 /* JsxSpreadAttribute */:
                return visitNode(cbNode, node.expression);
            case 252 /* JsxExpression */:
                return visitNode(cbNode, node.expression);
            case 249 /* JsxClosingElement */:
                return visitNode(cbNode, node.tagName);
            case 262 /* JSDocTypeExpression */:
                return visitNode(cbNode, node.type);
            case 266 /* JSDocUnionType */:
                return visitNodes(cbNodes, node.types);
            case 267 /* JSDocTupleType */:
                return visitNodes(cbNodes, node.types);
            case 265 /* JSDocArrayType */:
                return visitNode(cbNode, node.elementType);
            case 269 /* JSDocNonNullableType */:
                return visitNode(cbNode, node.type);
            case 268 /* JSDocNullableType */:
                return visitNode(cbNode, node.type);
            case 270 /* JSDocRecordType */:
                return visitNode(cbNode, node.literal);
            case 272 /* JSDocTypeReference */:
                return visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.typeArguments);
            case 273 /* JSDocOptionalType */:
                return visitNode(cbNode, node.type);
            case 274 /* JSDocFunctionType */:
                return visitNodes(cbNodes, node.parameters) ||
                    visitNode(cbNode, node.type);
            case 275 /* JSDocVariadicType */:
                return visitNode(cbNode, node.type);
            case 276 /* JSDocConstructorType */:
                return visitNode(cbNode, node.type);
            case 277 /* JSDocThisType */:
                return visitNode(cbNode, node.type);
            case 271 /* JSDocRecordMember */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.type);
            case 278 /* JSDocComment */:
                return visitNodes(cbNodes, node.tags);
            case 281 /* JSDocParameterTag */:
                return visitNode(cbNode, node.preParameterName) ||
                    visitNode(cbNode, node.typeExpression) ||
                    visitNode(cbNode, node.postParameterName);
            case 282 /* JSDocReturnTag */:
                return visitNode(cbNode, node.typeExpression);
            case 283 /* JSDocTypeTag */:
                return visitNode(cbNode, node.typeExpression);
            case 280 /* JSDocAugmentsTag */:
                return visitNode(cbNode, node.typeExpression);
            case 284 /* JSDocTemplateTag */:
                return visitNodes(cbNodes, node.typeParameters);
            case 285 /* JSDocTypedefTag */:
                return visitNode(cbNode, node.typeExpression) ||
                    visitNode(cbNode, node.fullName) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.jsDocTypeLiteral);
            case 287 /* JSDocTypeLiteral */:
                return visitNodes(cbNodes, node.jsDocPropertyTags);
            case 286 /* JSDocPropertyTag */:
                return visitNode(cbNode, node.typeExpression) ||
                    visitNode(cbNode, node.name);
            case 294 /* PartiallyEmittedExpression */:
                return visitNode(cbNode, node.expression);
            case 288 /* JSDocLiteralType */:
                return visitNode(cbNode, node.literal);
        }
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{231,1} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{231,1} AS 1 AT <0:544>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{231,2} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{231,2} AS 2 AT <0:596>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{231,3} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{231,3} AS 3 AT <0:692>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{231,4} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{231,4} AS 4 AT <0:744>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{231,5} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{231,5} AS 5 AT <0:802>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{231,6} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{231,6} AS 6 AT <0:1658>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{231,7} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{231,7} AS 7 AT <0:1718>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{231,8} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{231,8} AS 8 AT <0:1777>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{231,9} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{231,9} AS 9 AT <0:1837>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{231,10} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{231,10} AS 10 AT <0:1899>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{231,11} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{231,11} AS 11 AT <0:1951>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{231,12} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{231,12} AS 12 AT <0:2012>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{231,13} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{231,13} AS 13 AT <0:2064>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{231,14} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{231,14} AS 14 AT <0:2341>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{231,15} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{231,15} AS 15 AT <0:2401>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{231,16} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{231,16} AS 16 AT <0:2460>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{231,17} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{231,17} AS 17 AT <0:2524>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{231,18} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{231,18} AS 18 AT <0:2584>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{231,19} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{231,19} AS 19 AT <0:2984>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{231,20} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{231,20} AS 20 AT <0:3044>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{231,21} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{231,21} AS 21 AT <0:3103>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{231,22} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{231,22} AS 22 AT <0:3164>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{231,23} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{231,23} AS 23 AT <0:3216>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{231,24} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{231,24} AS 24 AT <0:3277>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{231,25} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{231,25} AS 25 AT <0:3341>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{231,26} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{231,26} AS 26 AT <0:3401>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{231,27} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{231,27} AS 27 AT <0:3453>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{231,28} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{231,28} AS 28 AT <0:3523>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{231,29} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{231,29} AS 29 AT <0:3618>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{231,30} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{231,30} AS 30 AT <0:3674>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{231,31} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{231,31} AS 31 AT <0:3780>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{231,32} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{231,32} AS 32 AT <0:3841>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{231,33} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{231,33} AS 33 AT <0:4029>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{231,34} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{231,34} AS 34 AT <0:4125>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{231,35} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{231,35} AS 35 AT <0:4223>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{231,36} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{231,36} AS 36 AT <0:4369>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{231,37} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{231,37} AS 37 AT <0:4512>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{231,38} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{231,38} AS 38 AT <0:4611>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{231,39} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{231,39} AS 39 AT <0:4669>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{231,40} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{231,40} AS 40 AT <0:4766>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{231,41} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{231,41} AS 41 AT <0:4827>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{231,42} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{231,42} AS 42 AT <0:4888>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{231,43} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{231,43} AS 43 AT <0:4949>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{231,44} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{231,44} AS 44 AT <0:8393>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{231,45} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{231,45} AS 45 AT <0:8562>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{231,46} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{231,46} AS 46 AT <0:8622>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{231,47} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{231,47} AS 47 AT <0:8681>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{231,48} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{231,48} AS 48 AT <0:8797>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{231,49} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{231,49} AS 49 AT <0:12363>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{231,50} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{231,50} AS 50 AT <0:12423>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{231,51} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{231,51} AS 51 AT <0:12482>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{231,52} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{231,52} AS 52 AT <0:12534>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{231,53} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{231,53} AS 53 AT <0:12598>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{231,54} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{231,54} AS 54 AT <0:12663>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{231,55} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{231,55} AS 55 AT <0:12770>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{231,56} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{231,56} AS 56 AT <0:12830>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{231,57} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{231,57} AS 57 AT <0:12889>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{231,58} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{231,58} AS 58 AT <0:12941>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:bindContainer) id{232,0} ---
(node, containerFlags) {
            // Before we recurse into a node's children, we first save the existing parent, container
            // and block-container.  Then after we pop out of processing the children, we restore
            // these saved values.
            var saveContainer = container;
            var savedBlockScopeContainer = blockScopeContainer;
            // Depending on what kind of node this is, we may have to adjust the current container
            // and block-container.   If the current node is a container, then it is automatically
            // considered the current block-container as well.  Also, for containers that we know
            // may contain locals, we proactively initialize the .locals field. We do this because
            // it's highly likely that the .locals will be needed to place some child in (for example,
            // a parameter, or variable declaration).
            //
            // However, we do not proactively create the .locals for block-containers because it's
            // totally normal and common for block-containers to never actually have a block-scoped
            // variable in them.  We don't want to end up allocating an object for every 'block' we
            // run into when most of them won't be necessary.
            //
            // Finally, if this is a block-container, then we clear out any existing .locals object
            // it may contain within it.  This happens in incremental scenarios.  Because we can be
            // reusing a node from a previous compilation, that node may have had 'locals' created
            // for it.  We must clear this so we don't accidentally move any stale data forward from
            // a previous compilation.
            if (containerFlags & 1 /* IsContainer */) {
                container = blockScopeContainer = node;
                if (containerFlags & 32 /* HasLocals */) {
                    container.locals = ts.createMap();
                }
                addToContainerChain(container);
            }
            else if (containerFlags & 2 /* IsBlockScopedContainer */) {
                blockScopeContainer = node;
                blockScopeContainer.locals = undefined;
            }
            if (containerFlags & 4 /* IsControlFlowContainer */) {
                var saveCurrentFlow = currentFlow;
                var saveBreakTarget = currentBreakTarget;
                var saveContinueTarget = currentContinueTarget;
                var saveReturnTarget = currentReturnTarget;
                var saveActiveLabels = activeLabels;
                var saveHasExplicitReturn = hasExplicitReturn;
                var isIIFE = containerFlags & 16 /* IsFunctionExpression */ && !ts.hasModifier(node, 256 /* Async */) && !!ts.getImmediatelyInvokedFunctionExpression(node);
                // A non-async IIFE is considered part of the containing control flow. Return statements behave
                // similarly to break statements that exit to a label just past the statement body.
                if (isIIFE) {
                    currentReturnTarget = createBranchLabel();
                }
                else {
                    currentFlow = { flags: 2 /* Start */ };
                    if (containerFlags & (16 /* IsFunctionExpression */ | 128 /* IsObjectLiteralOrClassExpressionMethod */)) {
                        currentFlow.container = node;
                    }
                    currentReturnTarget = undefined;
                }
                currentBreakTarget = undefined;
                currentContinueTarget = undefined;
                activeLabels = undefined;
                hasExplicitReturn = false;
                bindChildren(node);
                // Reset all reachability check related flags on node (for incremental scenarios)
                node.flags &= ~1408 /* ReachabilityAndEmitFlags */;
                if (!(currentFlow.flags & 1 /* Unreachable */) && containerFlags & 8 /* IsFunctionLike */ && ts.nodeIsPresent(node.body)) {
                    node.flags |= 128 /* HasImplicitReturn */;
                    if (hasExplicitReturn)
                        node.flags |= 256 /* HasExplicitReturn */;
                }
                if (node.kind === 261 /* SourceFile */) {
                    node.flags |= emitFlags;
                }
                if (isIIFE) {
                    addAntecedent(currentReturnTarget, currentFlow);
                    currentFlow = finishFlowLabel(currentReturnTarget);
                }
                else {
                    currentFlow = saveCurrentFlow;
                }
                currentBreakTarget = saveBreakTarget;
                currentContinueTarget = saveContinueTarget;
                currentReturnTarget = saveReturnTarget;
                activeLabels = saveActiveLabels;
                hasExplicitReturn = saveHasExplicitReturn;
            }
            else if (containerFlags & 64 /* IsInterface */) {
                seenThisKeyword = false;
                bindChildren(node);
                node.flags = seenThisKeyword ? node.flags | 64 /* ContainsThis */ : node.flags & ~64 /* ContainsThis */;
            }
            else {
                bindChildren(node);
            }
            container = saveContainer;
            blockScopeContainer = savedBlockScopeContainer;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:addToContainerChain) id{232,1} ---
(next) {
            if (lastContainer) {
                lastContainer.nextContainer = next;
            }
            lastContainer = next;
        }
--- END ---
INLINE (addToContainerChain) id{232,1} AS 1 AT <0:2009>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:addDeclarationToSymbol) id{233,0} ---
(symbol, node, symbolFlags) {
            symbol.flags |= symbolFlags;
            node.symbol = symbol;
            if (!symbol.declarations) {
                symbol.declarations = [];
            }
            symbol.declarations.push(node);
            if (symbolFlags & 1952 /* HasExports */ && !symbol.exports) {
                symbol.exports = ts.createMap();
            }
            if (symbolFlags & 6240 /* HasMembers */ && !symbol.members) {
                symbol.members = ts.createMap();
            }
            if (symbolFlags & 107455 /* Value */) {
                var valueDeclaration = symbol.valueDeclaration;
                if (!valueDeclaration ||
                    (valueDeclaration.kind !== node.kind && valueDeclaration.kind === 230 /* ModuleDeclaration */)) {
                    // other kinds of value declarations take precedence over modules
                    symbol.valueDeclaration = node;
                }
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:skipPartiallyEmittedExpressions) id{234,0} ---
(node) {
        while (node.kind === 294 /* PartiallyEmittedExpression */) {
            node = node.expression;
        }
        return node;
    }
--- END ---
[deoptimizing (DEOPT soft): begin 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> (opt #231) @206, FP to SP delta: 744, caller sp: 0x7fff5fbfcd58]
            ;;; deoptimize at 0_5064: Insufficient type feedback for generic named access
  reading input frame forEachChild => node=95, args=4, height=5; inputs:
      0: 0xd6230dc36a9 ; [fp - 16] 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>
      1: 0x16f3adb61821 ; [fp + 40] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x2be622f29f19 ; [fp + 32] 0x2be622f29f19 <a NodeObject with map 0x33abe2a68019>
      3: 0x2f05bb805f51 ; [fp + 24] 0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>
      4: 0x2f05bb804889 ; [fp + 16] 0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>
      5: 0xd6230d99249 ; rbx 0xd6230d99249 <FixedArray[15]>
      6: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0xd6230dd5d69 ; [fp - 32] 0xd6230dd5d69 <JS Function visitNodeArray (SharedFunctionInfo 0x3504a53f0029)>
      8: 0x2f05bb804889 ; [fp - 40] 0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>
      9: 0xab00000000 ; rax 171
  translating frame forEachChild => node=95, height=32
    0x7fff5fbfcd50: [top + 88] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfcd48: [top + 80] <- 0x2be622f29f19 ;  0x2be622f29f19 <a NodeObject with map 0x33abe2a68019>  (input #2)
    0x7fff5fbfcd40: [top + 72] <- 0x2f05bb805f51 ;  0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>  (input #3)
    0x7fff5fbfcd38: [top + 64] <- 0x2f05bb804889 ;  0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>  (input #4)
    0x7fff5fbfcd30: [top + 56] <- 0x2c21d2577908 ;  caller's pc
    0x7fff5fbfcd28: [top + 48] <- 0x7fff5fbfcda0 ;  caller's fp
    0x7fff5fbfcd20: [top + 40] <- 0xd6230d99249 ;  context    0xd6230d99249 <FixedArray[15]>  (input #5)
    0x7fff5fbfcd18: [top + 32] <- 0xd6230dc36a9 ;  function    0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>  (input #0)
    0x7fff5fbfcd10: [top + 24] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfcd08: [top + 16] <- 0xd6230dd5d69 ;  0xd6230dd5d69 <JS Function visitNodeArray (SharedFunctionInfo 0x3504a53f0029)>  (input #7)
    0x7fff5fbfcd00: [top + 8] <- 0x2f05bb804889 ;  0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>  (input #8)
    0x7fff5fbfccf8: [top + 0] <- 0xab00000000 ;  171  (input #9)
[deoptimizing (soft): end 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> @206 => node=95, pc=0x2c21d24c2f46, caller sp=0x7fff5fbfcd58, state=NO_REGISTERS, took 0.100 ms]
[deoptimizer unlinked: forEachChild / d6230dc36a9]
[deoptimizing (DEOPT lazy): begin 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> (opt #231) @378, FP to SP delta: 744, caller sp: 0x7fff5fbfd160]
  reading input frame forEachChild => node=610, args=4, height=5; inputs:
      0: 0xd6230dc36a9 ; [fp - 16] 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>
      1: 0x16f3adb61821 ; [fp + 40] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x9a02227f799 ; [fp + 32] 0x9a02227f799 <a NodeObject with map 0x33abe2a6fd39>
      3: 0x2f05bb805f51 ; [fp + 24] 0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>
      4: 0x2f05bb804889 ; [fp + 16] 0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>
      5: 0xd6230d99249 ; [fp - 24] 0xd6230d99249 <FixedArray[15]>
      6: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      8: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      9: 0xd6230dd5d21 ; [fp - 656] 0xd6230dd5d21 <JS Function visitNode (SharedFunctionInfo 0x3504a53eff69)>
  reading input frame visitNode => node=14, args=3, height=2; inputs:
      0: 0xd6230dd5d21 ; (literal 10) 0xd6230dd5d21 <JS Function visitNode (SharedFunctionInfo 0x3504a53eff69)>
      1: 0x1f9f6c0532e1 ; (literal 8) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2f05bb805f51 ; [fp + 24] 0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>
      3: 0x2be622f29f19 ; [fp - 664] 0x2be622f29f19 <a NodeObject with map 0x33abe2a68019>
      4: 0xd6230d99249 ; (literal 9) 0xd6230d99249 <FixedArray[15]>
      5: 0x30bcea404311 ; rax 0x30bcea404311 <undefined>
  translating frame forEachChild => node=610, height=32
    0x7fff5fbfd158: [top + 88] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfd150: [top + 80] <- 0x9a02227f799 ;  0x9a02227f799 <a NodeObject with map 0x33abe2a6fd39>  (input #2)
    0x7fff5fbfd148: [top + 72] <- 0x2f05bb805f51 ;  0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>  (input #3)
    0x7fff5fbfd140: [top + 64] <- 0x2f05bb804889 ;  0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>  (input #4)
    0x7fff5fbfd138: [top + 56] <- 0x2c21d2577908 ;  caller's pc
    0x7fff5fbfd130: [top + 48] <- 0x7fff5fbfd1a8 ;  caller's fp
    0x7fff5fbfd128: [top + 40] <- 0xd6230d99249 ;  context    0xd6230d99249 <FixedArray[15]>  (input #5)
    0x7fff5fbfd120: [top + 32] <- 0xd6230dc36a9 ;  function    0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>  (input #0)
    0x7fff5fbfd118: [top + 24] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfd110: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #7)
    0x7fff5fbfd108: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #8)
    0x7fff5fbfd100: [top + 0] <- 0xd6230dd5d21 ;  0xd6230dd5d21 <JS Function visitNode (SharedFunctionInfo 0x3504a53eff69)>  (input #9)
  translating frame visitNode => node=14, height=8
    0x7fff5fbfd0f8: [top + 56] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd0f0: [top + 48] <- 0x2f05bb805f51 ;  0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>  (input #2)
    0x7fff5fbfd0e8: [top + 40] <- 0x2be622f29f19 ;  0x2be622f29f19 <a NodeObject with map 0x33abe2a68019>  (input #3)
    0x7fff5fbfd0e0: [top + 32] <- 0x2c21d24c5704 ;  caller's pc
    0x7fff5fbfd0d8: [top + 24] <- 0x7fff5fbfd130 ;  caller's fp
    0x7fff5fbfd0d0: [top + 16] <- 0xd6230d99249 ;  context    0xd6230d99249 <FixedArray[15]>  (input #4)
    0x7fff5fbfd0c8: [top + 8] <- 0xd6230dd5d21 ;  function    0xd6230dd5d21 <JS Function visitNode (SharedFunctionInfo 0x3504a53eff69)>  (input #0)
    0x7fff5fbfd0c0: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
[deoptimizing (lazy): end 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> @378 => node=14, pc=0x2c21d24ca56d, caller sp=0x7fff5fbfd160, state=TOS_REGISTER, took 0.128 ms]
[deoptimizing (DEOPT lazy): begin 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> (opt #231) @313, FP to SP delta: 744, caller sp: 0x7fff5fbfd658]
  reading input frame forEachChild => node=1026, args=4, height=5; inputs:
      0: 0xd6230dc36a9 ; [fp - 16] 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>
      1: 0x16f3adb61821 ; [fp + 40] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x9ebbbf5cd51 ; [fp + 32] 0x9ebbbf5cd51 <a NodeObject with map 0x33abe2a700a9>
      3: 0x2f05bb805f51 ; [fp + 24] 0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>
      4: 0x2f05bb804889 ; [fp + 16] 0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>
      5: 0xd6230d99249 ; [fp - 24] 0xd6230d99249 <FixedArray[15]>
      6: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0xd6230dd5d69 ; [fp - 32] 0xd6230dd5d69 <JS Function visitNodeArray (SharedFunctionInfo 0x3504a53f0029)>
      8: 0x2f05bb804889 ; [fp - 40] 0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>
      9: 0xd6230dd5d69 ; [fp - 32] 0xd6230dd5d69 <JS Function visitNodeArray (SharedFunctionInfo 0x3504a53f0029)>
  reading input frame visitNodeArray => node=14, args=3, height=2; inputs:
      0: 0xd6230dd5d69 ; (literal 7) 0xd6230dd5d69 <JS Function visitNodeArray (SharedFunctionInfo 0x3504a53f0029)>
      1: 0x1f9f6c0532e1 ; (literal 8) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2f05bb804889 ; [fp - 40] 0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>
      3: 0x1ff95b80a3a1 ; [fp - 472] 0x1ff95b80a3a1 <JS Array[2]>
      4: 0xd6230d99249 ; (literal 9) 0xd6230d99249 <FixedArray[15]>
      5: 0x30bcea404311 ; rax 0x30bcea404311 <undefined>
  translating frame forEachChild => node=1026, height=32
    0x7fff5fbfd650: [top + 88] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfd648: [top + 80] <- 0x9ebbbf5cd51 ;  0x9ebbbf5cd51 <a NodeObject with map 0x33abe2a700a9>  (input #2)
    0x7fff5fbfd640: [top + 72] <- 0x2f05bb805f51 ;  0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>  (input #3)
    0x7fff5fbfd638: [top + 64] <- 0x2f05bb804889 ;  0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>  (input #4)
    0x7fff5fbfd630: [top + 56] <- 0x2c21d2577908 ;  caller's pc
    0x7fff5fbfd628: [top + 48] <- 0x7fff5fbfd6a0 ;  caller's fp
    0x7fff5fbfd620: [top + 40] <- 0xd6230d99249 ;  context    0xd6230d99249 <FixedArray[15]>  (input #5)
    0x7fff5fbfd618: [top + 32] <- 0xd6230dc36a9 ;  function    0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>  (input #0)
    0x7fff5fbfd610: [top + 24] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfd608: [top + 16] <- 0xd6230dd5d69 ;  0xd6230dd5d69 <JS Function visitNodeArray (SharedFunctionInfo 0x3504a53f0029)>  (input #7)
    0x7fff5fbfd600: [top + 8] <- 0x2f05bb804889 ;  0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>  (input #8)
    0x7fff5fbfd5f8: [top + 0] <- 0xd6230dd5d69 ;  0xd6230dd5d69 <JS Function visitNodeArray (SharedFunctionInfo 0x3504a53f0029)>  (input #9)
  translating frame visitNodeArray => node=14, height=8
    0x7fff5fbfd5f0: [top + 56] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd5e8: [top + 48] <- 0x2f05bb804889 ;  0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>  (input #2)
    0x7fff5fbfd5e0: [top + 40] <- 0x1ff95b80a3a1 ;  0x1ff95b80a3a1 <JS Array[2]>  (input #3)
    0x7fff5fbfd5d8: [top + 32] <- 0x2c21d24c5c0a ;  caller's pc
    0x7fff5fbfd5d0: [top + 24] <- 0x7fff5fbfd628 ;  caller's fp
    0x7fff5fbfd5c8: [top + 16] <- 0xd6230d99249 ;  context    0xd6230d99249 <FixedArray[15]>  (input #4)
    0x7fff5fbfd5c0: [top + 8] <- 0xd6230dd5d69 ;  function    0xd6230dd5d69 <JS Function visitNodeArray (SharedFunctionInfo 0x3504a53f0029)>  (input #0)
    0x7fff5fbfd5b8: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
[deoptimizing (lazy): end 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> @313 => node=14, pc=0x2c21d25490ed, caller sp=0x7fff5fbfd658, state=TOS_REGISTER, took 0.141 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:forEachChild) id{235,0} ---
(node, cbNode, cbNodeArray) {
        if (!node) {
            return;
        }
        // The visitXXX functions could be written as local functions that close over the cbNode and cbNodeArray
        // callback parameters, but that causes a closure allocation for each invocation with noticeable effects
        // on performance.
        var visitNodes = cbNodeArray ? visitNodeArray : visitEachNode;
        var cbNodes = cbNodeArray || cbNode;
        switch (node.kind) {
            case 141 /* QualifiedName */:
                return visitNode(cbNode, node.left) ||
                    visitNode(cbNode, node.right);
            case 143 /* TypeParameter */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.constraint) ||
                    visitNode(cbNode, node.expression);
            case 258 /* ShorthandPropertyAssignment */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNode(cbNode, node.equalsToken) ||
                    visitNode(cbNode, node.objectAssignmentInitializer);
            case 259 /* SpreadAssignment */:
                return visitNode(cbNode, node.expression);
            case 144 /* Parameter */:
            case 147 /* PropertyDeclaration */:
            case 146 /* PropertySignature */:
            case 257 /* PropertyAssignment */:
            case 223 /* VariableDeclaration */:
            case 174 /* BindingElement */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.propertyName) ||
                    visitNode(cbNode, node.dotDotDotToken) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNode(cbNode, node.type) ||
                    visitNode(cbNode, node.initializer);
            case 158 /* FunctionType */:
            case 159 /* ConstructorType */:
            case 153 /* CallSignature */:
            case 154 /* ConstructSignature */:
            case 155 /* IndexSignature */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNodes(cbNodes, node.parameters) ||
                    visitNode(cbNode, node.type);
            case 149 /* MethodDeclaration */:
            case 148 /* MethodSignature */:
            case 150 /* Constructor */:
            case 151 /* GetAccessor */:
            case 152 /* SetAccessor */:
            case 184 /* FunctionExpression */:
            case 225 /* FunctionDeclaration */:
            case 185 /* ArrowFunction */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.asteriskToken) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNodes(cbNodes, node.parameters) ||
                    visitNode(cbNode, node.type) ||
                    visitNode(cbNode, node.equalsGreaterThanToken) ||
                    visitNode(cbNode, node.body);
            case 157 /* TypeReference */:
                return visitNode(cbNode, node.typeName) ||
                    visitNodes(cbNodes, node.typeArguments);
            case 156 /* TypePredicate */:
                return visitNode(cbNode, node.parameterName) ||
                    visitNode(cbNode, node.type);
            case 160 /* TypeQuery */:
                return visitNode(cbNode, node.exprName);
            case 161 /* TypeLiteral */:
                return visitNodes(cbNodes, node.members);
            case 162 /* ArrayType */:
                return visitNode(cbNode, node.elementType);
            case 163 /* TupleType */:
                return visitNodes(cbNodes, node.elementTypes);
            case 164 /* UnionType */:
            case 165 /* IntersectionType */:
                return visitNodes(cbNodes, node.types);
            case 166 /* ParenthesizedType */:
            case 168 /* TypeOperator */:
                return visitNode(cbNode, node.type);
            case 169 /* IndexedAccessType */:
                return visitNode(cbNode, node.objectType) ||
                    visitNode(cbNode, node.indexType);
            case 170 /* MappedType */:
                return visitNode(cbNode, node.readonlyToken) ||
                    visitNode(cbNode, node.typeParameter) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNode(cbNode, node.type);
            case 171 /* LiteralType */:
                return visitNode(cbNode, node.literal);
            case 172 /* ObjectBindingPattern */:
            case 173 /* ArrayBindingPattern */:
                return visitNodes(cbNodes, node.elements);
            case 175 /* ArrayLiteralExpression */:
                return visitNodes(cbNodes, node.elements);
            case 176 /* ObjectLiteralExpression */:
                return visitNodes(cbNodes, node.properties);
            case 177 /* PropertyAccessExpression */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.name);
            case 178 /* ElementAccessExpression */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.argumentExpression);
            case 179 /* CallExpression */:
            case 180 /* NewExpression */:
                return visitNode(cbNode, node.expression) ||
                    visitNodes(cbNodes, node.typeArguments) ||
                    visitNodes(cbNodes, node.arguments);
            case 181 /* TaggedTemplateExpression */:
                return visitNode(cbNode, node.tag) ||
                    visitNode(cbNode, node.template);
            case 182 /* TypeAssertionExpression */:
                return visitNode(cbNode, node.type) ||
                    visitNode(cbNode, node.expression);
            case 183 /* ParenthesizedExpression */:
                return visitNode(cbNode, node.expression);
            case 186 /* DeleteExpression */:
                return visitNode(cbNode, node.expression);
            case 187 /* TypeOfExpression */:
                return visitNode(cbNode, node.expression);
            case 188 /* VoidExpression */:
                return visitNode(cbNode, node.expression);
            case 190 /* PrefixUnaryExpression */:
                return visitNode(cbNode, node.operand);
            case 195 /* YieldExpression */:
                return visitNode(cbNode, node.asteriskToken) ||
                    visitNode(cbNode, node.expression);
            case 189 /* AwaitExpression */:
                return visitNode(cbNode, node.expression);
            case 191 /* PostfixUnaryExpression */:
                return visitNode(cbNode, node.operand);
            case 192 /* BinaryExpression */:
                return visitNode(cbNode, node.left) ||
                    visitNode(cbNode, node.operatorToken) ||
                    visitNode(cbNode, node.right);
            case 200 /* AsExpression */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.type);
            case 201 /* NonNullExpression */:
                return visitNode(cbNode, node.expression);
            case 193 /* ConditionalExpression */:
                return visitNode(cbNode, node.condition) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNode(cbNode, node.whenTrue) ||
                    visitNode(cbNode, node.colonToken) ||
                    visitNode(cbNode, node.whenFalse);
            case 196 /* SpreadElement */:
                return visitNode(cbNode, node.expression);
            case 204 /* Block */:
            case 231 /* ModuleBlock */:
                return visitNodes(cbNodes, node.statements);
            case 261 /* SourceFile */:
                return visitNodes(cbNodes, node.statements) ||
                    visitNode(cbNode, node.endOfFileToken);
            case 205 /* VariableStatement */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.declarationList);
            case 224 /* VariableDeclarationList */:
                return visitNodes(cbNodes, node.declarations);
            case 207 /* ExpressionStatement */:
                return visitNode(cbNode, node.expression);
            case 208 /* IfStatement */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.thenStatement) ||
                    visitNode(cbNode, node.elseStatement);
            case 209 /* DoStatement */:
                return visitNode(cbNode, node.statement) ||
                    visitNode(cbNode, node.expression);
            case 210 /* WhileStatement */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.statement);
            case 211 /* ForStatement */:
                return visitNode(cbNode, node.initializer) ||
                    visitNode(cbNode, node.condition) ||
                    visitNode(cbNode, node.incrementor) ||
                    visitNode(cbNode, node.statement);
            case 212 /* ForInStatement */:
                return visitNode(cbNode, node.initializer) ||
                    visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.statement);
            case 213 /* ForOfStatement */:
                return visitNode(cbNode, node.initializer) ||
                    visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.statement);
            case 214 /* ContinueStatement */:
            case 215 /* BreakStatement */:
                return visitNode(cbNode, node.label);
            case 216 /* ReturnStatement */:
                return visitNode(cbNode, node.expression);
            case 217 /* WithStatement */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.statement);
            case 218 /* SwitchStatement */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.caseBlock);
            case 232 /* CaseBlock */:
                return visitNodes(cbNodes, node.clauses);
            case 253 /* CaseClause */:
                return visitNode(cbNode, node.expression) ||
                    visitNodes(cbNodes, node.statements);
            case 254 /* DefaultClause */:
                return visitNodes(cbNodes, node.statements);
            case 219 /* LabeledStatement */:
                return visitNode(cbNode, node.label) ||
                    visitNode(cbNode, node.statement);
            case 220 /* ThrowStatement */:
                return visitNode(cbNode, node.expression);
            case 221 /* TryStatement */:
                return visitNode(cbNode, node.tryBlock) ||
                    visitNode(cbNode, node.catchClause) ||
                    visitNode(cbNode, node.finallyBlock);
            case 256 /* CatchClause */:
                return visitNode(cbNode, node.variableDeclaration) ||
                    visitNode(cbNode, node.block);
            case 145 /* Decorator */:
                return visitNode(cbNode, node.expression);
            case 226 /* ClassDeclaration */:
            case 197 /* ClassExpression */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNodes(cbNodes, node.heritageClauses) ||
                    visitNodes(cbNodes, node.members);
            case 227 /* InterfaceDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNodes(cbNodes, node.heritageClauses) ||
                    visitNodes(cbNodes, node.members);
            case 228 /* TypeAliasDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNode(cbNode, node.type);
            case 229 /* EnumDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.members);
            case 260 /* EnumMember */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.initializer);
            case 230 /* ModuleDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.body);
            case 234 /* ImportEqualsDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.moduleReference);
            case 235 /* ImportDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.importClause) ||
                    visitNode(cbNode, node.moduleSpecifier);
            case 236 /* ImportClause */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.namedBindings);
            case 233 /* NamespaceExportDeclaration */:
                return visitNode(cbNode, node.name);
            case 237 /* NamespaceImport */:
                return visitNode(cbNode, node.name);
            case 238 /* NamedImports */:
            case 242 /* NamedExports */:
                return visitNodes(cbNodes, node.elements);
            case 241 /* ExportDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.exportClause) ||
                    visitNode(cbNode, node.moduleSpecifier);
            case 239 /* ImportSpecifier */:
            case 243 /* ExportSpecifier */:
                return visitNode(cbNode, node.propertyName) ||
                    visitNode(cbNode, node.name);
            case 240 /* ExportAssignment */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.expression);
            case 194 /* TemplateExpression */:
                return visitNode(cbNode, node.head) || visitNodes(cbNodes, node.templateSpans);
            case 202 /* TemplateSpan */:
                return visitNode(cbNode, node.expression) || visitNode(cbNode, node.literal);
            case 142 /* ComputedPropertyName */:
                return visitNode(cbNode, node.expression);
            case 255 /* HeritageClause */:
                return visitNodes(cbNodes, node.types);
            case 199 /* ExpressionWithTypeArguments */:
                return visitNode(cbNode, node.expression) ||
                    visitNodes(cbNodes, node.typeArguments);
            case 245 /* ExternalModuleReference */:
                return visitNode(cbNode, node.expression);
            case 244 /* MissingDeclaration */:
                return visitNodes(cbNodes, node.decorators);
            case 246 /* JsxElement */:
                return visitNode(cbNode, node.openingElement) ||
                    visitNodes(cbNodes, node.children) ||
                    visitNode(cbNode, node.closingElement);
            case 247 /* JsxSelfClosingElement */:
            case 248 /* JsxOpeningElement */:
                return visitNode(cbNode, node.tagName) ||
                    visitNodes(cbNodes, node.attributes);
            case 250 /* JsxAttribute */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.initializer);
            case 251 /* JsxSpreadAttribute */:
                return visitNode(cbNode, node.expression);
            case 252 /* JsxExpression */:
                return visitNode(cbNode, node.expression);
            case 249 /* JsxClosingElement */:
                return visitNode(cbNode, node.tagName);
            case 262 /* JSDocTypeExpression */:
                return visitNode(cbNode, node.type);
            case 266 /* JSDocUnionType */:
                return visitNodes(cbNodes, node.types);
            case 267 /* JSDocTupleType */:
                return visitNodes(cbNodes, node.types);
            case 265 /* JSDocArrayType */:
                return visitNode(cbNode, node.elementType);
            case 269 /* JSDocNonNullableType */:
                return visitNode(cbNode, node.type);
            case 268 /* JSDocNullableType */:
                return visitNode(cbNode, node.type);
            case 270 /* JSDocRecordType */:
                return visitNode(cbNode, node.literal);
            case 272 /* JSDocTypeReference */:
                return visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.typeArguments);
            case 273 /* JSDocOptionalType */:
                return visitNode(cbNode, node.type);
            case 274 /* JSDocFunctionType */:
                return visitNodes(cbNodes, node.parameters) ||
                    visitNode(cbNode, node.type);
            case 275 /* JSDocVariadicType */:
                return visitNode(cbNode, node.type);
            case 276 /* JSDocConstructorType */:
                return visitNode(cbNode, node.type);
            case 277 /* JSDocThisType */:
                return visitNode(cbNode, node.type);
            case 271 /* JSDocRecordMember */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.type);
            case 278 /* JSDocComment */:
                return visitNodes(cbNodes, node.tags);
            case 281 /* JSDocParameterTag */:
                return visitNode(cbNode, node.preParameterName) ||
                    visitNode(cbNode, node.typeExpression) ||
                    visitNode(cbNode, node.postParameterName);
            case 282 /* JSDocReturnTag */:
                return visitNode(cbNode, node.typeExpression);
            case 283 /* JSDocTypeTag */:
                return visitNode(cbNode, node.typeExpression);
            case 280 /* JSDocAugmentsTag */:
                return visitNode(cbNode, node.typeExpression);
            case 284 /* JSDocTemplateTag */:
                return visitNodes(cbNodes, node.typeParameters);
            case 285 /* JSDocTypedefTag */:
                return visitNode(cbNode, node.typeExpression) ||
                    visitNode(cbNode, node.fullName) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.jsDocTypeLiteral);
            case 287 /* JSDocTypeLiteral */:
                return visitNodes(cbNodes, node.jsDocPropertyTags);
            case 286 /* JSDocPropertyTag */:
                return visitNode(cbNode, node.typeExpression) ||
                    visitNode(cbNode, node.name);
            case 294 /* PartiallyEmittedExpression */:
                return visitNode(cbNode, node.expression);
            case 288 /* JSDocLiteralType */:
                return visitNode(cbNode, node.literal);
        }
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{235,1} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{235,1} AS 1 AT <0:544>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{235,2} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{235,2} AS 2 AT <0:596>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{235,3} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{235,3} AS 3 AT <0:692>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{235,4} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{235,4} AS 4 AT <0:744>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{235,5} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{235,5} AS 5 AT <0:802>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{235,6} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{235,6} AS 6 AT <0:1658>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{235,7} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{235,7} AS 7 AT <0:1718>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{235,8} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{235,8} AS 8 AT <0:1777>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{235,9} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{235,9} AS 9 AT <0:1837>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{235,10} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{235,10} AS 10 AT <0:1899>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{235,11} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{235,11} AS 11 AT <0:1951>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{235,12} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{235,12} AS 12 AT <0:2012>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{235,13} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{235,13} AS 13 AT <0:2064>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{235,14} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{235,14} AS 14 AT <0:2341>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{235,15} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{235,15} AS 15 AT <0:2401>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{235,16} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{235,16} AS 16 AT <0:2460>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{235,17} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{235,17} AS 17 AT <0:2524>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{235,18} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{235,18} AS 18 AT <0:2584>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{235,19} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{235,19} AS 19 AT <0:2984>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{235,20} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{235,20} AS 20 AT <0:3044>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{235,21} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{235,21} AS 21 AT <0:3103>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{235,22} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{235,22} AS 22 AT <0:3164>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{235,23} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{235,23} AS 23 AT <0:3216>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{235,24} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{235,24} AS 24 AT <0:3277>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{235,25} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{235,25} AS 25 AT <0:3341>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{235,26} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{235,26} AS 26 AT <0:3401>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{235,27} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{235,27} AS 27 AT <0:3453>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{235,28} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{235,28} AS 28 AT <0:3523>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{235,29} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{235,29} AS 29 AT <0:3618>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{235,30} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{235,30} AS 30 AT <0:3674>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{235,31} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{235,31} AS 31 AT <0:3780>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{235,32} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{235,32} AS 32 AT <0:3841>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{235,33} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{235,33} AS 33 AT <0:4029>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{235,34} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{235,34} AS 34 AT <0:4125>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{235,35} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{235,35} AS 35 AT <0:4223>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{235,36} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{235,36} AS 36 AT <0:4369>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{235,37} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{235,37} AS 37 AT <0:4512>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{235,38} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{235,38} AS 38 AT <0:4611>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{235,39} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{235,39} AS 39 AT <0:4669>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{235,40} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{235,40} AS 40 AT <0:4766>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{235,41} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{235,41} AS 41 AT <0:4827>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{235,42} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{235,42} AS 42 AT <0:4888>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{235,43} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{235,43} AS 43 AT <0:4949>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{235,44} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{235,44} AS 44 AT <0:5042>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{235,45} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{235,45} AS 45 AT <0:8393>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{235,46} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{235,46} AS 46 AT <0:8562>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{235,47} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{235,47} AS 47 AT <0:8622>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{235,48} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{235,48} AS 48 AT <0:8681>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{235,49} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{235,49} AS 49 AT <0:8797>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{235,50} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{235,50} AS 50 AT <0:12363>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{235,51} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{235,51} AS 51 AT <0:12423>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{235,52} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{235,52} AS 52 AT <0:12482>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{235,53} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{235,53} AS 53 AT <0:12534>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{235,54} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{235,54} AS 54 AT <0:12598>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{235,55} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{235,55} AS 55 AT <0:12663>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{235,56} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{235,56} AS 56 AT <0:12770>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{235,57} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{235,57} AS 57 AT <0:12830>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{235,58} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{235,58} AS 58 AT <0:12889>
[deoptimizing (DEOPT lazy): begin 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> (opt #231) @134, FP to SP delta: 744, caller sp: 0x7fff5fbfdc20]
  reading input frame forEachChild => node=4009, args=4, height=5; inputs:
      0: 0xd6230dc36a9 ; [fp - 16] 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>
      1: 0x16f3adb61821 ; [fp + 40] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x33c68034c3b9 ; [fp + 32] 0x33c68034c3b9 <a NodeObject with map 0x33abe2a70101>
      3: 0x2f05bb805f51 ; [fp + 24] 0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>
      4: 0x2f05bb804889 ; [fp + 16] 0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>
      5: 0xd6230d99249 ; [fp - 24] 0xd6230d99249 <FixedArray[15]>
      6: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      8: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      9: 0xd6230dd5d69 ; [fp - 32] 0xd6230dd5d69 <JS Function visitNodeArray (SharedFunctionInfo 0x3504a53f0029)>
  reading input frame visitNodeArray => node=14, args=3, height=2; inputs:
      0: 0xd6230dd5d69 ; (literal 7) 0xd6230dd5d69 <JS Function visitNodeArray (SharedFunctionInfo 0x3504a53f0029)>
      1: 0x1f9f6c0532e1 ; (literal 8) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2f05bb804889 ; [fp - 40] 0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>
      3: 0x1b98fbcb7861 ; [fp - 136] 0x1b98fbcb7861 <JS Array[263]>
      4: 0xd6230d99249 ; (literal 9) 0xd6230d99249 <FixedArray[15]>
      5: 0x30bcea404311 ; rax 0x30bcea404311 <undefined>
  translating frame forEachChild => node=4009, height=32
    0x7fff5fbfdc18: [top + 88] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfdc10: [top + 80] <- 0x33c68034c3b9 ;  0x33c68034c3b9 <a NodeObject with map 0x33abe2a70101>  (input #2)
    0x7fff5fbfdc08: [top + 72] <- 0x2f05bb805f51 ;  0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>  (input #3)
    0x7fff5fbfdc00: [top + 64] <- 0x2f05bb804889 ;  0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>  (input #4)
    0x7fff5fbfdbf8: [top + 56] <- 0x2c21d2577908 ;  caller's pc
    0x7fff5fbfdbf0: [top + 48] <- 0x7fff5fbfdc68 ;  caller's fp
    0x7fff5fbfdbe8: [top + 40] <- 0xd6230d99249 ;  context    0xd6230d99249 <FixedArray[15]>  (input #5)
    0x7fff5fbfdbe0: [top + 32] <- 0xd6230dc36a9 ;  function    0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>  (input #0)
    0x7fff5fbfdbd8: [top + 24] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfdbd0: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #7)
    0x7fff5fbfdbc8: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #8)
    0x7fff5fbfdbc0: [top + 0] <- 0xd6230dd5d69 ;  0xd6230dd5d69 <JS Function visitNodeArray (SharedFunctionInfo 0x3504a53f0029)>  (input #9)
  translating frame visitNodeArray => node=14, height=8
    0x7fff5fbfdbb8: [top + 56] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdbb0: [top + 48] <- 0x2f05bb804889 ;  0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>  (input #2)
    0x7fff5fbfdba8: [top + 40] <- 0x1b98fbcb7861 ;  0x1b98fbcb7861 <JS Array[263]>  (input #3)
    0x7fff5fbfdba0: [top + 32] <- 0x2c21d24c8424 ;  caller's pc
    0x7fff5fbfdb98: [top + 24] <- 0x7fff5fbfdbf0 ;  caller's fp
    0x7fff5fbfdb90: [top + 16] <- 0xd6230d99249 ;  context    0xd6230d99249 <FixedArray[15]>  (input #4)
    0x7fff5fbfdb88: [top + 8] <- 0xd6230dd5d69 ;  function    0xd6230dd5d69 <JS Function visitNodeArray (SharedFunctionInfo 0x3504a53f0029)>  (input #0)
    0x7fff5fbfdb80: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
[deoptimizing (lazy): end 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> @134 => node=14, pc=0x2c21d25490ed, caller sp=0x7fff5fbfdc20, state=TOS_REGISTER, took 0.130 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:modifierToFlag) id{236,0} ---
(token) {
        switch (token) {
            case 114 /* StaticKeyword */: return 32 /* Static */;
            case 113 /* PublicKeyword */: return 4 /* Public */;
            case 112 /* ProtectedKeyword */: return 16 /* Protected */;
            case 111 /* PrivateKeyword */: return 8 /* Private */;
            case 116 /* AbstractKeyword */: return 128 /* Abstract */;
            case 83 /* ExportKeyword */: return 1 /* Export */;
            case 123 /* DeclareKeyword */: return 2 /* Ambient */;
            case 75 /* ConstKeyword */: return 2048 /* Const */;
            case 78 /* DefaultKeyword */: return 512 /* Default */;
            case 119 /* AsyncKeyword */: return 256 /* Async */;
            case 130 /* ReadonlyKeyword */: return 64 /* Readonly */;
        }
        return 0 /* None */;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:bindVariableDeclarationOrBindingElement) id{237,0} ---
(node) {
            if (inStrictMode) {
                checkStrictModeEvalOrArguments(node, node.name);
            }
            if (!ts.isBindingPattern(node.name)) {
                if (ts.isBlockOrCatchScoped(node)) {
                    bindBlockScopedVariableDeclaration(node);
                }
                else if (ts.isParameterDeclaration(node)) {
                    // It is safe to walk up parent chain to find whether the node is a destructing parameter declaration
                    // because its parent chain has already been set up, since parents are set before descending into children.
                    //
                    // If node is a binding element in parameter declaration, we need to use ParameterExcludes.
                    // Using ParameterExcludes flag allows the compiler to report an error on duplicate identifiers in Parameter Declaration
                    // For example:
                    //      function foo([a,a]) {} // Duplicate Identifier error
                    //      function bar(a,a) {}   // Duplicate Identifier error, parameter declaration in this case is handled in bindParameter
                    //                             // which correctly set excluded symbols
                    declareSymbolAndAddToSymbolTable(node, 1 /* FunctionScopedVariable */, 107455 /* ParameterExcludes */);
                }
                else {
                    declareSymbolAndAddToSymbolTable(node, 1 /* FunctionScopedVariable */, 107454 /* FunctionScopedVariableExcludes */);
                }
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:bindBlockScopedVariableDeclaration) id{237,1} ---
(node) {
            bindBlockScopedDeclaration(node, 2 /* BlockScopedVariable */, 107455 /* BlockScopedVariableExcludes */);
        }
--- END ---
INLINE (bindBlockScopedVariableDeclaration) id{237,1} AS 1 AT <0:244>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:declareSymbolAndAddToSymbolTable) id{237,2} ---
(node, symbolFlags, symbolExcludes) {
            // Just call this directly so that the return type of this function stays "void".
            return declareSymbolAndAddToSymbolTableWorker(node, symbolFlags, symbolExcludes);
        }
--- END ---
INLINE (declareSymbolAndAddToSymbolTable) id{237,2} AS 2 AT <0:1428>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isBlockOrCatchScoped) id{238,0} ---
(declaration) {
        return (ts.getCombinedNodeFlags(declaration) & 3 /* BlockScoped */) !== 0 ||
            isCatchClauseVariableDeclarationOrBindingElement(declaration);
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isCatchClauseVariableDeclarationOrBindingElement) id{238,1} ---
(declaration) {
        var node = getRootDeclaration(declaration);
        return node.kind === 223 /* VariableDeclaration */ && node.parent.kind === 256 /* CatchClause */;
    }
--- END ---
INLINE (isCatchClauseVariableDeclarationOrBindingElement) id{238,1} AS 1 AT <0:113>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getRootDeclaration) id{238,2} ---
(node) {
        while (node.kind === 174 /* BindingElement */) {
            node = node.parent.parent;
        }
        return node;
    }
--- END ---
INLINE (getRootDeclaration) id{238,2} AS 2 AT <1:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getCombinedNodeFlags) id{239,0} ---
(node) {
        node = walkUpBindingElementsAndPatterns(node);
        var flags = node.flags;
        if (node.kind === 223 /* VariableDeclaration */) {
            node = node.parent;
        }
        if (node && node.kind === 224 /* VariableDeclarationList */) {
            flags |= node.flags;
            node = node.parent;
        }
        if (node && node.kind === 205 /* VariableStatement */) {
            flags |= node.flags;
        }
        return flags;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:walkUpBindingElementsAndPatterns) id{239,1} ---
(node) {
        while (node && (node.kind === 174 /* BindingElement */ || ts.isBindingPattern(node))) {
            node = node.parent;
        }
        return node;
    }
--- END ---
INLINE (walkUpBindingElementsAndPatterns) id{239,1} AS 1 AT <0:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isParameterDeclaration) id{240,0} ---
(node) {
        var root = getRootDeclaration(node);
        return root.kind === 144 /* Parameter */;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getRootDeclaration) id{240,1} ---
(node) {
        while (node.kind === 174 /* BindingElement */) {
            node = node.parent.parent;
        }
        return node;
    }
--- END ---
INLINE (getRootDeclaration) id{240,1} AS 1 AT <0:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkUnreachable) id{241,0} ---
(node) {
            if (!(currentFlow.flags & 1 /* Unreachable */)) {
                return false;
            }
            if (currentFlow === unreachableFlow) {
                var reportError = 
                // report error on all statements except empty ones
                (ts.isStatementButNotDeclaration(node) && node.kind !== 206 /* EmptyStatement */) ||
                    // report error on class declarations
                    node.kind === 226 /* ClassDeclaration */ ||
                    // report error on instantiated modules or const-enums only modules if preserveConstEnums is set
                    (node.kind === 230 /* ModuleDeclaration */ && shouldReportErrorOnModuleDeclaration(node)) ||
                    // report error on regular enums and const enums if preserveConstEnums is set
                    (node.kind === 229 /* EnumDeclaration */ && (!ts.isConstEnumDeclaration(node) || options.preserveConstEnums));
                if (reportError) {
                    currentFlow = reportedUnreachableFlow;
                    // unreachable code is reported if
                    // - user has explicitly asked about it AND
                    // - statement is in not ambient context (statements in ambient context is already an error
                    //   so we should not report extras) AND
                    //   - node is not variable statement OR
                    //   - node is block scoped variable statement OR
                    //   - node is not block scoped variable statement and at least one variable declaration has initializer
                    //   Rationale: we don't want to report errors on non-initialized var's since they are hoisted
                    //   On the other side we do want to report errors on non-initialized 'lets' because of TDZ
                    var reportUnreachableCode = !options.allowUnreachableCode &&
                        !ts.isInAmbientContext(node) &&
                        (node.kind !== 205 /* VariableStatement */ ||
                            ts.getCombinedNodeFlags(node.declarationList) & 3 /* BlockScoped */ ||
                            ts.forEach(node.declarationList.declarations, function (d) { return d.initializer; }));
                    if (reportUnreachableCode) {
                        errorOnFirstToken(node, ts.Diagnostics.Unreachable_code_detected);
                    }
                }
            }
            return true;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:bindChildren) id{242,0} ---
(node) {
            if (skipTransformFlagAggregation) {
                bindChildrenWorker(node);
            }
            else if (node.transformFlags & 536870912 /* HasComputedFlags */) {
                skipTransformFlagAggregation = true;
                bindChildrenWorker(node);
                skipTransformFlagAggregation = false;
                subtreeTransformFlags |= node.transformFlags & ~getTransformFlagsSubtreeExclusions(node.kind);
            }
            else {
                var savedSubtreeTransformFlags = subtreeTransformFlags;
                subtreeTransformFlags = 0;
                bindChildrenWorker(node);
                subtreeTransformFlags = savedSubtreeTransformFlags | computeTransformFlagsForNode(node, subtreeTransformFlags);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:hasDynamicName) id{243,0} ---
(declaration) {
        return declaration.name && isDynamicName(declaration.name);
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isDynamicName) id{243,1} ---
(name) {
        return name.kind === 142 /* ComputedPropertyName */ &&
            !isStringOrNumericLiteral(name.expression) &&
            !isWellKnownSymbolSyntactically(name.expression);
    }
--- END ---
INLINE (isDynamicName) id{243,1} AS 1 AT <0:51>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getModifierFlags) id{244,0} ---
(node) {
        if (node.modifierFlagsCache & 536870912 /* HasComputedFlags */) {
            return node.modifierFlagsCache & ~536870912 /* HasComputedFlags */;
        }
        var flags = 0 /* None */;
        if (node.modifiers) {
            for (var _i = 0, _a = node.modifiers; _i < _a.length; _i++) {
                var modifier = _a[_i];
                flags |= modifierToFlag(modifier.kind);
            }
        }
        if (node.flags & 4 /* NestedNamespace */ || (node.kind === 70 /* Identifier */ && node.isInJSDocNamespace)) {
            flags |= 1 /* Export */;
        }
        node.modifierFlagsCache = flags | 536870912 /* HasComputedFlags */;
        return flags;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkStrictModeIdentifier) id{245,0} ---
(node) {
            if (inStrictMode &&
                node.originalKeywordKind >= 107 /* FirstFutureReservedWord */ &&
                node.originalKeywordKind <= 115 /* LastFutureReservedWord */ &&
                !ts.isIdentifierName(node) &&
                !ts.isInAmbientContext(node)) {
                // Report error only if there are no parse errors in file
                if (!file.parseDiagnostics.length) {
                    file.bindDiagnostics.push(ts.createDiagnosticForNode(node, getStrictModeIdentifierMessage(node), ts.declarationNameToString(node)));
                }
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createMap) id{246,0} ---
(template) {
        var map = createObject(null); // tslint:disable-line:no-null-keyword
        // Using 'delete' on an object causes V8 to put the object in dictionary mode.
        // This disables creation of hidden classes, which are expensive when an object is
        // constantly changing shape.
        map["__"] = undefined;
        delete map["__"];
        // Copies keys/values from template. Note that for..in will not throw if
        // template is undefined, and instead will just exit the loop.
        for (var key in template)
            if (hasOwnProperty.call(template, key)) {
                map[key] = template[key];
            }
        return map;
    }
--- END ---
[deoptimizing (DEOPT eager): begin 0xd6230dac271 <JS Function createMap (SharedFunctionInfo 0xc2bd2ae0b29)> (opt #246) @20, FP to SP delta: 72, caller sp: 0x7fff5fbfd6d0]
            ;;; deoptimize at 0_523: null or undefined in for-in
  reading input frame createMap => node=49, args=2, height=4; inputs:
      0: 0xd6230dac271 ; [fp - 16] 0xd6230dac271 <JS Function createMap (SharedFunctionInfo 0xc2bd2ae0b29)>
      1: 0x16f3adb61821 ; [fp + 24] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x30bcea404311 ; [fp + 16] 0x30bcea404311 <undefined>
      3: 0xd6230db3179 ; [fp - 24] 0xd6230db3179 <FixedArray[95]>
      4: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
      5: 0x24c89adb8d19 ; [fp - 32] 0x24c89adb8d19 <an Object with map 0x33abe2a3d1a1>
      6: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
  translating frame createMap => node=49, height=24
    0x7fff5fbfd6c8: [top + 64] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfd6c0: [top + 56] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #2)
    0x7fff5fbfd6b8: [top + 48] <- 0x2c21d2207e55 ;  caller's pc
    0x7fff5fbfd6b0: [top + 40] <- 0x7fff5fbfd6e8 ;  caller's fp
    0x7fff5fbfd6a8: [top + 32] <- 0xd6230db3179 ;  context    0xd6230db3179 <FixedArray[95]>  (input #3)
    0x7fff5fbfd6a0: [top + 24] <- 0xd6230dac271 ;  function    0xd6230dac271 <JS Function createMap (SharedFunctionInfo 0xc2bd2ae0b29)>  (input #0)
    0x7fff5fbfd698: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfd690: [top + 8] <- 0x24c89adb8d19 ;  0x24c89adb8d19 <an Object with map 0x33abe2a3d1a1>  (input #5)
    0x7fff5fbfd688: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
[deoptimizing (eager): end 0xd6230dac271 <JS Function createMap (SharedFunctionInfo 0xc2bd2ae0b29)> @20 => node=49, pc=0x2c21d23cd4a0, caller sp=0x7fff5fbfd6d0, state=NO_REGISTERS, took 0.217 ms]
[deoptimizing (DEOPT soft): begin 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> (opt #235) @264, FP to SP delta: 752, caller sp: 0x7fff5fbfd328]
            ;;; deoptimize at 0_3954: Insufficient type feedback for generic named access
  reading input frame forEachChild => node=95, args=4, height=5; inputs:
      0: 0xd6230dc36a9 ; [fp - 16] 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>
      1: 0x16f3adb61821 ; [fp + 40] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x1ff95b8fad91 ; [fp + 32] 0x1ff95b8fad91 <a NodeObject with map 0x33abe2a66f99>
      3: 0x2f05bb805f51 ; [fp + 24] 0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>
      4: 0x2f05bb804889 ; [fp + 16] 0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>
      5: 0xd6230d99249 ; rbx 0xd6230d99249 <FixedArray[15]>
      6: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0xd6230dd5d69 ; [fp - 32] 0xd6230dd5d69 <JS Function visitNodeArray (SharedFunctionInfo 0x3504a53f0029)>
      8: 0x2f05bb804889 ; [fp - 40] 0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>
      9: 0xa000000000 ; rax 160
  translating frame forEachChild => node=95, height=32
    0x7fff5fbfd320: [top + 88] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfd318: [top + 80] <- 0x1ff95b8fad91 ;  0x1ff95b8fad91 <a NodeObject with map 0x33abe2a66f99>  (input #2)
    0x7fff5fbfd310: [top + 72] <- 0x2f05bb805f51 ;  0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>  (input #3)
    0x7fff5fbfd308: [top + 64] <- 0x2f05bb804889 ;  0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>  (input #4)
    0x7fff5fbfd300: [top + 56] <- 0x2c21d2577908 ;  caller's pc
    0x7fff5fbfd2f8: [top + 48] <- 0x7fff5fbfd370 ;  caller's fp
    0x7fff5fbfd2f0: [top + 40] <- 0xd6230d99249 ;  context    0xd6230d99249 <FixedArray[15]>  (input #5)
    0x7fff5fbfd2e8: [top + 32] <- 0xd6230dc36a9 ;  function    0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>  (input #0)
    0x7fff5fbfd2e0: [top + 24] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfd2d8: [top + 16] <- 0xd6230dd5d69 ;  0xd6230dd5d69 <JS Function visitNodeArray (SharedFunctionInfo 0x3504a53f0029)>  (input #7)
    0x7fff5fbfd2d0: [top + 8] <- 0x2f05bb804889 ;  0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>  (input #8)
    0x7fff5fbfd2c8: [top + 0] <- 0xa000000000 ;  160  (input #9)
[deoptimizing (soft): end 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> @264 => node=95, pc=0x2c21d24c2f46, caller sp=0x7fff5fbfd328, state=NO_REGISTERS, took 0.121 ms]
[deoptimizer unlinked: forEachChild / d6230dc36a9]
[deoptimizing (DEOPT lazy): begin 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> (opt #235) @380, FP to SP delta: 752, caller sp: 0x7fff5fbfd730]
  reading input frame forEachChild => node=610, args=4, height=5; inputs:
      0: 0xd6230dc36a9 ; [fp - 16] 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>
      1: 0x16f3adb61821 ; [fp + 40] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x1ff95b83c6c1 ; [fp + 32] 0x1ff95b83c6c1 <a NodeObject with map 0x33abe2a6ffa1>
      3: 0x2f05bb805f51 ; [fp + 24] 0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>
      4: 0x2f05bb804889 ; [fp + 16] 0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>
      5: 0xd6230d99249 ; [fp - 24] 0xd6230d99249 <FixedArray[15]>
      6: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      8: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      9: 0xd6230dd5d21 ; [fp - 664] 0xd6230dd5d21 <JS Function visitNode (SharedFunctionInfo 0x3504a53eff69)>
  reading input frame visitNode => node=14, args=3, height=2; inputs:
      0: 0xd6230dd5d21 ; (literal 10) 0xd6230dd5d21 <JS Function visitNode (SharedFunctionInfo 0x3504a53eff69)>
      1: 0x1f9f6c0532e1 ; (literal 8) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2f05bb805f51 ; [fp + 24] 0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>
      3: 0x1ff95b8fad91 ; [fp - 672] 0x1ff95b8fad91 <a NodeObject with map 0x33abe2a66f99>
      4: 0xd6230d99249 ; (literal 9) 0xd6230d99249 <FixedArray[15]>
      5: 0x30bcea404311 ; rax 0x30bcea404311 <undefined>
  translating frame forEachChild => node=610, height=32
    0x7fff5fbfd728: [top + 88] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfd720: [top + 80] <- 0x1ff95b83c6c1 ;  0x1ff95b83c6c1 <a NodeObject with map 0x33abe2a6ffa1>  (input #2)
    0x7fff5fbfd718: [top + 72] <- 0x2f05bb805f51 ;  0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>  (input #3)
    0x7fff5fbfd710: [top + 64] <- 0x2f05bb804889 ;  0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>  (input #4)
    0x7fff5fbfd708: [top + 56] <- 0x2c21d2577908 ;  caller's pc
    0x7fff5fbfd700: [top + 48] <- 0x7fff5fbfd778 ;  caller's fp
    0x7fff5fbfd6f8: [top + 40] <- 0xd6230d99249 ;  context    0xd6230d99249 <FixedArray[15]>  (input #5)
    0x7fff5fbfd6f0: [top + 32] <- 0xd6230dc36a9 ;  function    0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>  (input #0)
    0x7fff5fbfd6e8: [top + 24] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfd6e0: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #7)
    0x7fff5fbfd6d8: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #8)
    0x7fff5fbfd6d0: [top + 0] <- 0xd6230dd5d21 ;  0xd6230dd5d21 <JS Function visitNode (SharedFunctionInfo 0x3504a53eff69)>  (input #9)
  translating frame visitNode => node=14, height=8
    0x7fff5fbfd6c8: [top + 56] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd6c0: [top + 48] <- 0x2f05bb805f51 ;  0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>  (input #2)
    0x7fff5fbfd6b8: [top + 40] <- 0x1ff95b8fad91 ;  0x1ff95b8fad91 <a NodeObject with map 0x33abe2a66f99>  (input #3)
    0x7fff5fbfd6b0: [top + 32] <- 0x2c21d24c5704 ;  caller's pc
    0x7fff5fbfd6a8: [top + 24] <- 0x7fff5fbfd700 ;  caller's fp
    0x7fff5fbfd6a0: [top + 16] <- 0xd6230d99249 ;  context    0xd6230d99249 <FixedArray[15]>  (input #4)
    0x7fff5fbfd698: [top + 8] <- 0xd6230dd5d21 ;  function    0xd6230dd5d21 <JS Function visitNode (SharedFunctionInfo 0x3504a53eff69)>  (input #0)
    0x7fff5fbfd690: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
[deoptimizing (lazy): end 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> @380 => node=14, pc=0x2c21d24ca56d, caller sp=0x7fff5fbfd730, state=TOS_REGISTER, took 0.145 ms]
[deoptimizing (DEOPT lazy): begin 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> (opt #235) @132, FP to SP delta: 752, caller sp: 0x7fff5fbfdc28]
  reading input frame forEachChild => node=4009, args=4, height=5; inputs:
      0: 0xd6230dc36a9 ; [fp - 16] 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>
      1: 0x16f3adb61821 ; [fp + 40] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x1b98fbcc7a69 ; [fp + 32] 0x1b98fbcc7a69 <a NodeObject with map 0x33abe2a70101>
      3: 0x2f05bb805f51 ; [fp + 24] 0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>
      4: 0x2f05bb804889 ; [fp + 16] 0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>
      5: 0xd6230d99249 ; [fp - 24] 0xd6230d99249 <FixedArray[15]>
      6: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      8: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      9: 0xd6230dd5d69 ; [fp - 32] 0xd6230dd5d69 <JS Function visitNodeArray (SharedFunctionInfo 0x3504a53f0029)>
  reading input frame visitNodeArray => node=14, args=3, height=2; inputs:
      0: 0xd6230dd5d69 ; (literal 7) 0xd6230dd5d69 <JS Function visitNodeArray (SharedFunctionInfo 0x3504a53f0029)>
      1: 0x1f9f6c0532e1 ; (literal 8) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2f05bb804889 ; [fp - 40] 0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>
      3: 0x9ebbbf0f1f9 ; [fp - 128] 0x9ebbbf0f1f9 <JS Array[174]>
      4: 0xd6230d99249 ; (literal 9) 0xd6230d99249 <FixedArray[15]>
      5: 0x30bcea404311 ; rax 0x30bcea404311 <undefined>
  translating frame forEachChild => node=4009, height=32
    0x7fff5fbfdc20: [top + 88] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfdc18: [top + 80] <- 0x1b98fbcc7a69 ;  0x1b98fbcc7a69 <a NodeObject with map 0x33abe2a70101>  (input #2)
    0x7fff5fbfdc10: [top + 72] <- 0x2f05bb805f51 ;  0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>  (input #3)
    0x7fff5fbfdc08: [top + 64] <- 0x2f05bb804889 ;  0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>  (input #4)
    0x7fff5fbfdc00: [top + 56] <- 0x2c21d2577908 ;  caller's pc
    0x7fff5fbfdbf8: [top + 48] <- 0x7fff5fbfdc70 ;  caller's fp
    0x7fff5fbfdbf0: [top + 40] <- 0xd6230d99249 ;  context    0xd6230d99249 <FixedArray[15]>  (input #5)
    0x7fff5fbfdbe8: [top + 32] <- 0xd6230dc36a9 ;  function    0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>  (input #0)
    0x7fff5fbfdbe0: [top + 24] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfdbd8: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #7)
    0x7fff5fbfdbd0: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #8)
    0x7fff5fbfdbc8: [top + 0] <- 0xd6230dd5d69 ;  0xd6230dd5d69 <JS Function visitNodeArray (SharedFunctionInfo 0x3504a53f0029)>  (input #9)
  translating frame visitNodeArray => node=14, height=8
    0x7fff5fbfdbc0: [top + 56] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdbb8: [top + 48] <- 0x2f05bb804889 ;  0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>  (input #2)
    0x7fff5fbfdbb0: [top + 40] <- 0x9ebbbf0f1f9 ;  0x9ebbbf0f1f9 <JS Array[174]>  (input #3)
    0x7fff5fbfdba8: [top + 32] <- 0x2c21d24c8424 ;  caller's pc
    0x7fff5fbfdba0: [top + 24] <- 0x7fff5fbfdbf8 ;  caller's fp
    0x7fff5fbfdb98: [top + 16] <- 0xd6230d99249 ;  context    0xd6230d99249 <FixedArray[15]>  (input #4)
    0x7fff5fbfdb90: [top + 8] <- 0xd6230dd5d69 ;  function    0xd6230dd5d69 <JS Function visitNodeArray (SharedFunctionInfo 0x3504a53f0029)>  (input #0)
    0x7fff5fbfdb88: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
[deoptimizing (lazy): end 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> @132 => node=14, pc=0x2c21d25490ed, caller sp=0x7fff5fbfdc28, state=TOS_REGISTER, took 0.130 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:forEachChild) id{247,0} ---
(node, cbNode, cbNodeArray) {
        if (!node) {
            return;
        }
        // The visitXXX functions could be written as local functions that close over the cbNode and cbNodeArray
        // callback parameters, but that causes a closure allocation for each invocation with noticeable effects
        // on performance.
        var visitNodes = cbNodeArray ? visitNodeArray : visitEachNode;
        var cbNodes = cbNodeArray || cbNode;
        switch (node.kind) {
            case 141 /* QualifiedName */:
                return visitNode(cbNode, node.left) ||
                    visitNode(cbNode, node.right);
            case 143 /* TypeParameter */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.constraint) ||
                    visitNode(cbNode, node.expression);
            case 258 /* ShorthandPropertyAssignment */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNode(cbNode, node.equalsToken) ||
                    visitNode(cbNode, node.objectAssignmentInitializer);
            case 259 /* SpreadAssignment */:
                return visitNode(cbNode, node.expression);
            case 144 /* Parameter */:
            case 147 /* PropertyDeclaration */:
            case 146 /* PropertySignature */:
            case 257 /* PropertyAssignment */:
            case 223 /* VariableDeclaration */:
            case 174 /* BindingElement */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.propertyName) ||
                    visitNode(cbNode, node.dotDotDotToken) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNode(cbNode, node.type) ||
                    visitNode(cbNode, node.initializer);
            case 158 /* FunctionType */:
            case 159 /* ConstructorType */:
            case 153 /* CallSignature */:
            case 154 /* ConstructSignature */:
            case 155 /* IndexSignature */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNodes(cbNodes, node.parameters) ||
                    visitNode(cbNode, node.type);
            case 149 /* MethodDeclaration */:
            case 148 /* MethodSignature */:
            case 150 /* Constructor */:
            case 151 /* GetAccessor */:
            case 152 /* SetAccessor */:
            case 184 /* FunctionExpression */:
            case 225 /* FunctionDeclaration */:
            case 185 /* ArrowFunction */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.asteriskToken) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNodes(cbNodes, node.parameters) ||
                    visitNode(cbNode, node.type) ||
                    visitNode(cbNode, node.equalsGreaterThanToken) ||
                    visitNode(cbNode, node.body);
            case 157 /* TypeReference */:
                return visitNode(cbNode, node.typeName) ||
                    visitNodes(cbNodes, node.typeArguments);
            case 156 /* TypePredicate */:
                return visitNode(cbNode, node.parameterName) ||
                    visitNode(cbNode, node.type);
            case 160 /* TypeQuery */:
                return visitNode(cbNode, node.exprName);
            case 161 /* TypeLiteral */:
                return visitNodes(cbNodes, node.members);
            case 162 /* ArrayType */:
                return visitNode(cbNode, node.elementType);
            case 163 /* TupleType */:
                return visitNodes(cbNodes, node.elementTypes);
            case 164 /* UnionType */:
            case 165 /* IntersectionType */:
                return visitNodes(cbNodes, node.types);
            case 166 /* ParenthesizedType */:
            case 168 /* TypeOperator */:
                return visitNode(cbNode, node.type);
            case 169 /* IndexedAccessType */:
                return visitNode(cbNode, node.objectType) ||
                    visitNode(cbNode, node.indexType);
            case 170 /* MappedType */:
                return visitNode(cbNode, node.readonlyToken) ||
                    visitNode(cbNode, node.typeParameter) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNode(cbNode, node.type);
            case 171 /* LiteralType */:
                return visitNode(cbNode, node.literal);
            case 172 /* ObjectBindingPattern */:
            case 173 /* ArrayBindingPattern */:
                return visitNodes(cbNodes, node.elements);
            case 175 /* ArrayLiteralExpression */:
                return visitNodes(cbNodes, node.elements);
            case 176 /* ObjectLiteralExpression */:
                return visitNodes(cbNodes, node.properties);
            case 177 /* PropertyAccessExpression */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.name);
            case 178 /* ElementAccessExpression */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.argumentExpression);
            case 179 /* CallExpression */:
            case 180 /* NewExpression */:
                return visitNode(cbNode, node.expression) ||
                    visitNodes(cbNodes, node.typeArguments) ||
                    visitNodes(cbNodes, node.arguments);
            case 181 /* TaggedTemplateExpression */:
                return visitNode(cbNode, node.tag) ||
                    visitNode(cbNode, node.template);
            case 182 /* TypeAssertionExpression */:
                return visitNode(cbNode, node.type) ||
                    visitNode(cbNode, node.expression);
            case 183 /* ParenthesizedExpression */:
                return visitNode(cbNode, node.expression);
            case 186 /* DeleteExpression */:
                return visitNode(cbNode, node.expression);
            case 187 /* TypeOfExpression */:
                return visitNode(cbNode, node.expression);
            case 188 /* VoidExpression */:
                return visitNode(cbNode, node.expression);
            case 190 /* PrefixUnaryExpression */:
                return visitNode(cbNode, node.operand);
            case 195 /* YieldExpression */:
                return visitNode(cbNode, node.asteriskToken) ||
                    visitNode(cbNode, node.expression);
            case 189 /* AwaitExpression */:
                return visitNode(cbNode, node.expression);
            case 191 /* PostfixUnaryExpression */:
                return visitNode(cbNode, node.operand);
            case 192 /* BinaryExpression */:
                return visitNode(cbNode, node.left) ||
                    visitNode(cbNode, node.operatorToken) ||
                    visitNode(cbNode, node.right);
            case 200 /* AsExpression */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.type);
            case 201 /* NonNullExpression */:
                return visitNode(cbNode, node.expression);
            case 193 /* ConditionalExpression */:
                return visitNode(cbNode, node.condition) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNode(cbNode, node.whenTrue) ||
                    visitNode(cbNode, node.colonToken) ||
                    visitNode(cbNode, node.whenFalse);
            case 196 /* SpreadElement */:
                return visitNode(cbNode, node.expression);
            case 204 /* Block */:
            case 231 /* ModuleBlock */:
                return visitNodes(cbNodes, node.statements);
            case 261 /* SourceFile */:
                return visitNodes(cbNodes, node.statements) ||
                    visitNode(cbNode, node.endOfFileToken);
            case 205 /* VariableStatement */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.declarationList);
            case 224 /* VariableDeclarationList */:
                return visitNodes(cbNodes, node.declarations);
            case 207 /* ExpressionStatement */:
                return visitNode(cbNode, node.expression);
            case 208 /* IfStatement */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.thenStatement) ||
                    visitNode(cbNode, node.elseStatement);
            case 209 /* DoStatement */:
                return visitNode(cbNode, node.statement) ||
                    visitNode(cbNode, node.expression);
            case 210 /* WhileStatement */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.statement);
            case 211 /* ForStatement */:
                return visitNode(cbNode, node.initializer) ||
                    visitNode(cbNode, node.condition) ||
                    visitNode(cbNode, node.incrementor) ||
                    visitNode(cbNode, node.statement);
            case 212 /* ForInStatement */:
                return visitNode(cbNode, node.initializer) ||
                    visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.statement);
            case 213 /* ForOfStatement */:
                return visitNode(cbNode, node.initializer) ||
                    visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.statement);
            case 214 /* ContinueStatement */:
            case 215 /* BreakStatement */:
                return visitNode(cbNode, node.label);
            case 216 /* ReturnStatement */:
                return visitNode(cbNode, node.expression);
            case 217 /* WithStatement */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.statement);
            case 218 /* SwitchStatement */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.caseBlock);
            case 232 /* CaseBlock */:
                return visitNodes(cbNodes, node.clauses);
            case 253 /* CaseClause */:
                return visitNode(cbNode, node.expression) ||
                    visitNodes(cbNodes, node.statements);
            case 254 /* DefaultClause */:
                return visitNodes(cbNodes, node.statements);
            case 219 /* LabeledStatement */:
                return visitNode(cbNode, node.label) ||
                    visitNode(cbNode, node.statement);
            case 220 /* ThrowStatement */:
                return visitNode(cbNode, node.expression);
            case 221 /* TryStatement */:
                return visitNode(cbNode, node.tryBlock) ||
                    visitNode(cbNode, node.catchClause) ||
                    visitNode(cbNode, node.finallyBlock);
            case 256 /* CatchClause */:
                return visitNode(cbNode, node.variableDeclaration) ||
                    visitNode(cbNode, node.block);
            case 145 /* Decorator */:
                return visitNode(cbNode, node.expression);
            case 226 /* ClassDeclaration */:
            case 197 /* ClassExpression */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNodes(cbNodes, node.heritageClauses) ||
                    visitNodes(cbNodes, node.members);
            case 227 /* InterfaceDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNodes(cbNodes, node.heritageClauses) ||
                    visitNodes(cbNodes, node.members);
            case 228 /* TypeAliasDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNode(cbNode, node.type);
            case 229 /* EnumDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.members);
            case 260 /* EnumMember */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.initializer);
            case 230 /* ModuleDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.body);
            case 234 /* ImportEqualsDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.moduleReference);
            case 235 /* ImportDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.importClause) ||
                    visitNode(cbNode, node.moduleSpecifier);
            case 236 /* ImportClause */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.namedBindings);
            case 233 /* NamespaceExportDeclaration */:
                return visitNode(cbNode, node.name);
            case 237 /* NamespaceImport */:
                return visitNode(cbNode, node.name);
            case 238 /* NamedImports */:
            case 242 /* NamedExports */:
                return visitNodes(cbNodes, node.elements);
            case 241 /* ExportDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.exportClause) ||
                    visitNode(cbNode, node.moduleSpecifier);
            case 239 /* ImportSpecifier */:
            case 243 /* ExportSpecifier */:
                return visitNode(cbNode, node.propertyName) ||
                    visitNode(cbNode, node.name);
            case 240 /* ExportAssignment */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.expression);
            case 194 /* TemplateExpression */:
                return visitNode(cbNode, node.head) || visitNodes(cbNodes, node.templateSpans);
            case 202 /* TemplateSpan */:
                return visitNode(cbNode, node.expression) || visitNode(cbNode, node.literal);
            case 142 /* ComputedPropertyName */:
                return visitNode(cbNode, node.expression);
            case 255 /* HeritageClause */:
                return visitNodes(cbNodes, node.types);
            case 199 /* ExpressionWithTypeArguments */:
                return visitNode(cbNode, node.expression) ||
                    visitNodes(cbNodes, node.typeArguments);
            case 245 /* ExternalModuleReference */:
                return visitNode(cbNode, node.expression);
            case 244 /* MissingDeclaration */:
                return visitNodes(cbNodes, node.decorators);
            case 246 /* JsxElement */:
                return visitNode(cbNode, node.openingElement) ||
                    visitNodes(cbNodes, node.children) ||
                    visitNode(cbNode, node.closingElement);
            case 247 /* JsxSelfClosingElement */:
            case 248 /* JsxOpeningElement */:
                return visitNode(cbNode, node.tagName) ||
                    visitNodes(cbNodes, node.attributes);
            case 250 /* JsxAttribute */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.initializer);
            case 251 /* JsxSpreadAttribute */:
                return visitNode(cbNode, node.expression);
            case 252 /* JsxExpression */:
                return visitNode(cbNode, node.expression);
            case 249 /* JsxClosingElement */:
                return visitNode(cbNode, node.tagName);
            case 262 /* JSDocTypeExpression */:
                return visitNode(cbNode, node.type);
            case 266 /* JSDocUnionType */:
                return visitNodes(cbNodes, node.types);
            case 267 /* JSDocTupleType */:
                return visitNodes(cbNodes, node.types);
            case 265 /* JSDocArrayType */:
                return visitNode(cbNode, node.elementType);
            case 269 /* JSDocNonNullableType */:
                return visitNode(cbNode, node.type);
            case 268 /* JSDocNullableType */:
                return visitNode(cbNode, node.type);
            case 270 /* JSDocRecordType */:
                return visitNode(cbNode, node.literal);
            case 272 /* JSDocTypeReference */:
                return visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.typeArguments);
            case 273 /* JSDocOptionalType */:
                return visitNode(cbNode, node.type);
            case 274 /* JSDocFunctionType */:
                return visitNodes(cbNodes, node.parameters) ||
                    visitNode(cbNode, node.type);
            case 275 /* JSDocVariadicType */:
                return visitNode(cbNode, node.type);
            case 276 /* JSDocConstructorType */:
                return visitNode(cbNode, node.type);
            case 277 /* JSDocThisType */:
                return visitNode(cbNode, node.type);
            case 271 /* JSDocRecordMember */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.type);
            case 278 /* JSDocComment */:
                return visitNodes(cbNodes, node.tags);
            case 281 /* JSDocParameterTag */:
                return visitNode(cbNode, node.preParameterName) ||
                    visitNode(cbNode, node.typeExpression) ||
                    visitNode(cbNode, node.postParameterName);
            case 282 /* JSDocReturnTag */:
                return visitNode(cbNode, node.typeExpression);
            case 283 /* JSDocTypeTag */:
                return visitNode(cbNode, node.typeExpression);
            case 280 /* JSDocAugmentsTag */:
                return visitNode(cbNode, node.typeExpression);
            case 284 /* JSDocTemplateTag */:
                return visitNodes(cbNodes, node.typeParameters);
            case 285 /* JSDocTypedefTag */:
                return visitNode(cbNode, node.typeExpression) ||
                    visitNode(cbNode, node.fullName) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.jsDocTypeLiteral);
            case 287 /* JSDocTypeLiteral */:
                return visitNodes(cbNodes, node.jsDocPropertyTags);
            case 286 /* JSDocPropertyTag */:
                return visitNode(cbNode, node.typeExpression) ||
                    visitNode(cbNode, node.name);
            case 294 /* PartiallyEmittedExpression */:
                return visitNode(cbNode, node.expression);
            case 288 /* JSDocLiteralType */:
                return visitNode(cbNode, node.literal);
        }
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{247,1} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{247,1} AS 1 AT <0:544>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{247,2} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{247,2} AS 2 AT <0:596>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{247,3} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{247,3} AS 3 AT <0:692>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{247,4} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{247,4} AS 4 AT <0:744>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{247,5} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{247,5} AS 5 AT <0:802>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{247,6} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{247,6} AS 6 AT <0:1658>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{247,7} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{247,7} AS 7 AT <0:1718>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{247,8} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{247,8} AS 8 AT <0:1777>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{247,9} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{247,9} AS 9 AT <0:1837>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{247,10} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{247,10} AS 10 AT <0:1899>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{247,11} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{247,11} AS 11 AT <0:1951>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{247,12} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{247,12} AS 12 AT <0:2012>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{247,13} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{247,13} AS 13 AT <0:2064>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{247,14} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{247,14} AS 14 AT <0:2341>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{247,15} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{247,15} AS 15 AT <0:2401>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{247,16} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{247,16} AS 16 AT <0:2460>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{247,17} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{247,17} AS 17 AT <0:2524>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{247,18} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{247,18} AS 18 AT <0:2584>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{247,19} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{247,19} AS 19 AT <0:2984>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{247,20} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{247,20} AS 20 AT <0:3044>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{247,21} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{247,21} AS 21 AT <0:3103>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{247,22} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{247,22} AS 22 AT <0:3164>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{247,23} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{247,23} AS 23 AT <0:3216>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{247,24} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{247,24} AS 24 AT <0:3277>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{247,25} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{247,25} AS 25 AT <0:3341>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{247,26} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{247,26} AS 26 AT <0:3401>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{247,27} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{247,27} AS 27 AT <0:3453>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{247,28} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{247,28} AS 28 AT <0:3523>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{247,29} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{247,29} AS 29 AT <0:3618>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{247,30} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{247,30} AS 30 AT <0:3674>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{247,31} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{247,31} AS 31 AT <0:3780>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{247,32} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{247,32} AS 32 AT <0:3841>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{247,33} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{247,33} AS 33 AT <0:3932>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{247,34} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{247,34} AS 34 AT <0:4029>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{247,35} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{247,35} AS 35 AT <0:4125>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{247,36} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{247,36} AS 36 AT <0:4223>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{247,37} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{247,37} AS 37 AT <0:4369>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{247,38} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{247,38} AS 38 AT <0:4512>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{247,39} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{247,39} AS 39 AT <0:4611>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{247,40} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{247,40} AS 40 AT <0:4669>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{247,41} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{247,41} AS 41 AT <0:4766>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{247,42} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{247,42} AS 42 AT <0:4827>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{247,43} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{247,43} AS 43 AT <0:4888>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{247,44} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{247,44} AS 44 AT <0:4949>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{247,45} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{247,45} AS 45 AT <0:5042>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{247,46} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{247,46} AS 46 AT <0:8393>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{247,47} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{247,47} AS 47 AT <0:8562>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{247,48} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{247,48} AS 48 AT <0:8622>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{247,49} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{247,49} AS 49 AT <0:8681>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{247,50} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{247,50} AS 50 AT <0:8797>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{247,51} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{247,51} AS 51 AT <0:12363>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{247,52} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{247,52} AS 52 AT <0:12423>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{247,53} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{247,53} AS 53 AT <0:12482>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{247,54} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{247,54} AS 54 AT <0:12534>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{247,55} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{247,55} AS 55 AT <0:12598>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{247,56} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{247,56} AS 56 AT <0:12663>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{247,57} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{247,57} AS 57 AT <0:12770>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{247,58} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{247,58} AS 58 AT <0:12830>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getDeclarationName) id{248,0} ---
(node) {
            if (node.name) {
                if (ts.isAmbientModule(node)) {
                    return ts.isGlobalScopeAugmentation(node) ? "__global" : "\x5c"" + node.name.text + "\x5c"";
                }
                if (node.name.kind === 142 /* ComputedPropertyName */) {
                    var nameExpression = node.name.expression;
                    // treat computed property names where expression is string/numeric literal as just string/numeric literal
                    if (ts.isStringOrNumericLiteral(nameExpression)) {
                        return nameExpression.text;
                    }
                    ts.Debug.assert(ts.isWellKnownSymbolSyntactically(nameExpression));
                    return ts.getPropertyNameForKnownSymbolName(nameExpression.name.text);
                }
                return node.name.text;
            }
            switch (node.kind) {
                case 150 /* Constructor */:
                    return "__constructor";
                case 158 /* FunctionType */:
                case 153 /* CallSignature */:
                    return "__call";
                case 159 /* ConstructorType */:
                case 154 /* ConstructSignature */:
                    return "__new";
                case 155 /* IndexSignature */:
                    return "__index";
                case 241 /* ExportDeclaration */:
                    return "__export";
                case 240 /* ExportAssignment */:
                    return node.isExportEquals ? "export=" : "default";
                case 192 /* BinaryExpression */:
                    switch (ts.getSpecialPropertyAssignmentKind(node)) {
                        case 2 /* ModuleExports */:
                            // module.exports = ...
                            return "export=";
                        case 1 /* ExportsProperty */:
                        case 4 /* ThisProperty */:
                            // exports.x = ... or this.y = ...
                            return node.left.name.text;
                        case 3 /* PrototypeProperty */:
                            // className.prototype.methodName = ...
                            return node.left.expression.name.text;
                    }
                    ts.Debug.fail("Unknown binary declaration kind");
                    break;
                case 225 /* FunctionDeclaration */:
                case 226 /* ClassDeclaration */:
                    return ts.hasModifier(node, 512 /* Default */) ? "default" : undefined;
                case 274 /* JSDocFunctionType */:
                    return ts.isJSDocConstructSignature(node) ? "__new" : "__call";
                case 144 /* Parameter */:
                    // Parameters with names are handled at the top of this function.  Parameters
                    // without names can only come from JSDocFunctionTypes.
                    ts.Debug.assert(node.parent.kind === 274 /* JSDocFunctionType */);
                    var functionType = node.parent;
                    var index = ts.indexOf(functionType.parameters, node);
                    return "arg" + index;
                case 285 /* JSDocTypedefTag */:
                    var parentNode = node.parent && node.parent.parent;
                    var nameFromParentNode = void 0;
                    if (parentNode && parentNode.kind === 205 /* VariableStatement */) {
                        if (parentNode.declarationList.declarations.length > 0) {
                            var nameIdentifier = parentNode.declarationList.declarations[0].name;
                            if (nameIdentifier.kind === 70 /* Identifier */) {
                                nameFromParentNode = nameIdentifier.text;
                            }
                        }
                    }
                    return nameFromParentNode;
            }
        }
--- END ---
[deoptimizing (DEOPT eager): begin 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> (opt #247) @289, FP to SP delta: 752, caller sp: 0x7fff5fbfdc28]
            ;;; deoptimize at 0_3008: Unknown map in polymorphic access
  reading input frame forEachChild => node=857, args=4, height=4; inputs:
      0: 0xd6230dc36a9 ; [fp - 16] 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>
      1: 0x16f3adb61821 ; [fp + 40] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x1b98fbcd0759 ; rax 0x1b98fbcd0759 <a NodeObject with map 0x33abe2a71499>
      3: 0x2f05bb805f51 ; [fp + 24] 0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>
      4: 0x2f05bb804889 ; [fp + 16] 0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>
      5: 0xd6230d99249 ; [fp - 24] 0xd6230d99249 <FixedArray[15]>
      6: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0xd6230dd5d69 ; [fp - 32] 0xd6230dd5d69 <JS Function visitNodeArray (SharedFunctionInfo 0x3504a53f0029)>
      8: 0x2f05bb804889 ; [fp - 40] 0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>
  translating frame forEachChild => node=857, height=24
    0x7fff5fbfdc20: [top + 80] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfdc18: [top + 72] <- 0x1b98fbcd0759 ;  0x1b98fbcd0759 <a NodeObject with map 0x33abe2a71499>  (input #2)
    0x7fff5fbfdc10: [top + 64] <- 0x2f05bb805f51 ;  0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>  (input #3)
    0x7fff5fbfdc08: [top + 56] <- 0x2f05bb804889 ;  0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>  (input #4)
    0x7fff5fbfdc00: [top + 48] <- 0x2c21d2577908 ;  caller's pc
    0x7fff5fbfdbf8: [top + 40] <- 0x7fff5fbfdc70 ;  caller's fp
    0x7fff5fbfdbf0: [top + 32] <- 0xd6230d99249 ;  context    0xd6230d99249 <FixedArray[15]>  (input #5)
    0x7fff5fbfdbe8: [top + 24] <- 0xd6230dc36a9 ;  function    0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>  (input #0)
    0x7fff5fbfdbe0: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfdbd8: [top + 8] <- 0xd6230dd5d69 ;  0xd6230dd5d69 <JS Function visitNodeArray (SharedFunctionInfo 0x3504a53f0029)>  (input #7)
    0x7fff5fbfdbd0: [top + 0] <- 0x2f05bb804889 ;  0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>  (input #8)
[deoptimizing (eager): end 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> @289 => node=857, pc=0x2c21d24c5960, caller sp=0x7fff5fbfdc28, state=NO_REGISTERS, took 0.101 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{249,0} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
[deoptimizing (DEOPT eager): begin 0x2f05bb804691 <JS Function addDeclarationToSymbol (SharedFunctionInfo 0x16f3adb57e21)> (opt #233) @30, FP to SP delta: 48, caller sp: 0x7fff5fbfdb18]
            ;;; deoptimize at 0_713: wrong map
  reading input frame addDeclarationToSymbol => node=277, args=4, height=2; inputs:
      0: 0x2f05bb804691 ; [fp - 16] 0x2f05bb804691 <JS Function addDeclarationToSymbol (SharedFunctionInfo 0x16f3adb57e21)>
      1: 0x1f9f6c0532e1 ; [fp + 40] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2998a25d3399 ; rbx 0x2998a25d3399 <a SymbolObject with map 0x33abe2a6fb29>
      3: 0x1b98fbcd15d9 ; [fp + 24] 0x1b98fbcd15d9 <a NodeObject with map 0x33abe2a71441>
      4: 0x1000000000 ; [fp + 16] 16
      5: 0xd6230dfeea1 ; [fp - 24] 0xd6230dfeea1 <FixedArray[147]>
      6: 0x1b98fbcd1259 ; rax 0x1b98fbcd1259 <a NodeObject with map 0x33abe2a714f1>
  translating frame addDeclarationToSymbol => node=277, height=8
    0x7fff5fbfdb10: [top + 64] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdb08: [top + 56] <- 0x2998a25d3399 ;  0x2998a25d3399 <a SymbolObject with map 0x33abe2a6fb29>  (input #2)
    0x7fff5fbfdb00: [top + 48] <- 0x1b98fbcd15d9 ;  0x1b98fbcd15d9 <a NodeObject with map 0x33abe2a71441>  (input #3)
    0x7fff5fbfdaf8: [top + 40] <- 0x1000000000 ;  16  (input #4)
    0x7fff5fbfdaf0: [top + 32] <- 0x2c21d257f06d ;  caller's pc
    0x7fff5fbfdae8: [top + 24] <- 0x7fff5fbfdb68 ;  caller's fp
    0x7fff5fbfdae0: [top + 16] <- 0xd6230dfeea1 ;  context    0xd6230dfeea1 <FixedArray[147]>  (input #5)
    0x7fff5fbfdad8: [top + 8] <- 0x2f05bb804691 ;  function    0x2f05bb804691 <JS Function addDeclarationToSymbol (SharedFunctionInfo 0x16f3adb57e21)>  (input #0)
    0x7fff5fbfdad0: [top + 0] <- 0x1b98fbcd1259 ;  0x1b98fbcd1259 <a NodeObject with map 0x33abe2a714f1>  (input #6)
[deoptimizing (eager): end 0x2f05bb804691 <JS Function addDeclarationToSymbol (SharedFunctionInfo 0x16f3adb57e21)> @30 => node=277, pc=0x2c21d2524c9e, caller sp=0x7fff5fbfdb18, state=NO_REGISTERS, took 0.122 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:forEachChild) id{250,0} ---
(node, cbNode, cbNodeArray) {
        if (!node) {
            return;
        }
        // The visitXXX functions could be written as local functions that close over the cbNode and cbNodeArray
        // callback parameters, but that causes a closure allocation for each invocation with noticeable effects
        // on performance.
        var visitNodes = cbNodeArray ? visitNodeArray : visitEachNode;
        var cbNodes = cbNodeArray || cbNode;
        switch (node.kind) {
            case 141 /* QualifiedName */:
                return visitNode(cbNode, node.left) ||
                    visitNode(cbNode, node.right);
            case 143 /* TypeParameter */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.constraint) ||
                    visitNode(cbNode, node.expression);
            case 258 /* ShorthandPropertyAssignment */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNode(cbNode, node.equalsToken) ||
                    visitNode(cbNode, node.objectAssignmentInitializer);
            case 259 /* SpreadAssignment */:
                return visitNode(cbNode, node.expression);
            case 144 /* Parameter */:
            case 147 /* PropertyDeclaration */:
            case 146 /* PropertySignature */:
            case 257 /* PropertyAssignment */:
            case 223 /* VariableDeclaration */:
            case 174 /* BindingElement */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.propertyName) ||
                    visitNode(cbNode, node.dotDotDotToken) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNode(cbNode, node.type) ||
                    visitNode(cbNode, node.initializer);
            case 158 /* FunctionType */:
            case 159 /* ConstructorType */:
            case 153 /* CallSignature */:
            case 154 /* ConstructSignature */:
            case 155 /* IndexSignature */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNodes(cbNodes, node.parameters) ||
                    visitNode(cbNode, node.type);
            case 149 /* MethodDeclaration */:
            case 148 /* MethodSignature */:
            case 150 /* Constructor */:
            case 151 /* GetAccessor */:
            case 152 /* SetAccessor */:
            case 184 /* FunctionExpression */:
            case 225 /* FunctionDeclaration */:
            case 185 /* ArrowFunction */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.asteriskToken) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNodes(cbNodes, node.parameters) ||
                    visitNode(cbNode, node.type) ||
                    visitNode(cbNode, node.equalsGreaterThanToken) ||
                    visitNode(cbNode, node.body);
            case 157 /* TypeReference */:
                return visitNode(cbNode, node.typeName) ||
                    visitNodes(cbNodes, node.typeArguments);
            case 156 /* TypePredicate */:
                return visitNode(cbNode, node.parameterName) ||
                    visitNode(cbNode, node.type);
            case 160 /* TypeQuery */:
                return visitNode(cbNode, node.exprName);
            case 161 /* TypeLiteral */:
                return visitNodes(cbNodes, node.members);
            case 162 /* ArrayType */:
                return visitNode(cbNode, node.elementType);
            case 163 /* TupleType */:
                return visitNodes(cbNodes, node.elementTypes);
            case 164 /* UnionType */:
            case 165 /* IntersectionType */:
                return visitNodes(cbNodes, node.types);
            case 166 /* ParenthesizedType */:
            case 168 /* TypeOperator */:
                return visitNode(cbNode, node.type);
            case 169 /* IndexedAccessType */:
                return visitNode(cbNode, node.objectType) ||
                    visitNode(cbNode, node.indexType);
            case 170 /* MappedType */:
                return visitNode(cbNode, node.readonlyToken) ||
                    visitNode(cbNode, node.typeParameter) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNode(cbNode, node.type);
            case 171 /* LiteralType */:
                return visitNode(cbNode, node.literal);
            case 172 /* ObjectBindingPattern */:
            case 173 /* ArrayBindingPattern */:
                return visitNodes(cbNodes, node.elements);
            case 175 /* ArrayLiteralExpression */:
                return visitNodes(cbNodes, node.elements);
            case 176 /* ObjectLiteralExpression */:
                return visitNodes(cbNodes, node.properties);
            case 177 /* PropertyAccessExpression */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.name);
            case 178 /* ElementAccessExpression */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.argumentExpression);
            case 179 /* CallExpression */:
            case 180 /* NewExpression */:
                return visitNode(cbNode, node.expression) ||
                    visitNodes(cbNodes, node.typeArguments) ||
                    visitNodes(cbNodes, node.arguments);
            case 181 /* TaggedTemplateExpression */:
                return visitNode(cbNode, node.tag) ||
                    visitNode(cbNode, node.template);
            case 182 /* TypeAssertionExpression */:
                return visitNode(cbNode, node.type) ||
                    visitNode(cbNode, node.expression);
            case 183 /* ParenthesizedExpression */:
                return visitNode(cbNode, node.expression);
            case 186 /* DeleteExpression */:
                return visitNode(cbNode, node.expression);
            case 187 /* TypeOfExpression */:
                return visitNode(cbNode, node.expression);
            case 188 /* VoidExpression */:
                return visitNode(cbNode, node.expression);
            case 190 /* PrefixUnaryExpression */:
                return visitNode(cbNode, node.operand);
            case 195 /* YieldExpression */:
                return visitNode(cbNode, node.asteriskToken) ||
                    visitNode(cbNode, node.expression);
            case 189 /* AwaitExpression */:
                return visitNode(cbNode, node.expression);
            case 191 /* PostfixUnaryExpression */:
                return visitNode(cbNode, node.operand);
            case 192 /* BinaryExpression */:
                return visitNode(cbNode, node.left) ||
                    visitNode(cbNode, node.operatorToken) ||
                    visitNode(cbNode, node.right);
            case 200 /* AsExpression */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.type);
            case 201 /* NonNullExpression */:
                return visitNode(cbNode, node.expression);
            case 193 /* ConditionalExpression */:
                return visitNode(cbNode, node.condition) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNode(cbNode, node.whenTrue) ||
                    visitNode(cbNode, node.colonToken) ||
                    visitNode(cbNode, node.whenFalse);
            case 196 /* SpreadElement */:
                return visitNode(cbNode, node.expression);
            case 204 /* Block */:
            case 231 /* ModuleBlock */:
                return visitNodes(cbNodes, node.statements);
            case 261 /* SourceFile */:
                return visitNodes(cbNodes, node.statements) ||
                    visitNode(cbNode, node.endOfFileToken);
            case 205 /* VariableStatement */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.declarationList);
            case 224 /* VariableDeclarationList */:
                return visitNodes(cbNodes, node.declarations);
            case 207 /* ExpressionStatement */:
                return visitNode(cbNode, node.expression);
            case 208 /* IfStatement */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.thenStatement) ||
                    visitNode(cbNode, node.elseStatement);
            case 209 /* DoStatement */:
                return visitNode(cbNode, node.statement) ||
                    visitNode(cbNode, node.expression);
            case 210 /* WhileStatement */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.statement);
            case 211 /* ForStatement */:
                return visitNode(cbNode, node.initializer) ||
                    visitNode(cbNode, node.condition) ||
                    visitNode(cbNode, node.incrementor) ||
                    visitNode(cbNode, node.statement);
            case 212 /* ForInStatement */:
                return visitNode(cbNode, node.initializer) ||
                    visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.statement);
            case 213 /* ForOfStatement */:
                return visitNode(cbNode, node.initializer) ||
                    visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.statement);
            case 214 /* ContinueStatement */:
            case 215 /* BreakStatement */:
                return visitNode(cbNode, node.label);
            case 216 /* ReturnStatement */:
                return visitNode(cbNode, node.expression);
            case 217 /* WithStatement */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.statement);
            case 218 /* SwitchStatement */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.caseBlock);
            case 232 /* CaseBlock */:
                return visitNodes(cbNodes, node.clauses);
            case 253 /* CaseClause */:
                return visitNode(cbNode, node.expression) ||
                    visitNodes(cbNodes, node.statements);
            case 254 /* DefaultClause */:
                return visitNodes(cbNodes, node.statements);
            case 219 /* LabeledStatement */:
                return visitNode(cbNode, node.label) ||
                    visitNode(cbNode, node.statement);
            case 220 /* ThrowStatement */:
                return visitNode(cbNode, node.expression);
            case 221 /* TryStatement */:
                return visitNode(cbNode, node.tryBlock) ||
                    visitNode(cbNode, node.catchClause) ||
                    visitNode(cbNode, node.finallyBlock);
            case 256 /* CatchClause */:
                return visitNode(cbNode, node.variableDeclaration) ||
                    visitNode(cbNode, node.block);
            case 145 /* Decorator */:
                return visitNode(cbNode, node.expression);
            case 226 /* ClassDeclaration */:
            case 197 /* ClassExpression */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNodes(cbNodes, node.heritageClauses) ||
                    visitNodes(cbNodes, node.members);
            case 227 /* InterfaceDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNodes(cbNodes, node.heritageClauses) ||
                    visitNodes(cbNodes, node.members);
            case 228 /* TypeAliasDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNode(cbNode, node.type);
            case 229 /* EnumDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.members);
            case 260 /* EnumMember */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.initializer);
            case 230 /* ModuleDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.body);
            case 234 /* ImportEqualsDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.moduleReference);
            case 235 /* ImportDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.importClause) ||
                    visitNode(cbNode, node.moduleSpecifier);
            case 236 /* ImportClause */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.namedBindings);
            case 233 /* NamespaceExportDeclaration */:
                return visitNode(cbNode, node.name);
            case 237 /* NamespaceImport */:
                return visitNode(cbNode, node.name);
            case 238 /* NamedImports */:
            case 242 /* NamedExports */:
                return visitNodes(cbNodes, node.elements);
            case 241 /* ExportDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.exportClause) ||
                    visitNode(cbNode, node.moduleSpecifier);
            case 239 /* ImportSpecifier */:
            case 243 /* ExportSpecifier */:
                return visitNode(cbNode, node.propertyName) ||
                    visitNode(cbNode, node.name);
            case 240 /* ExportAssignment */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.expression);
            case 194 /* TemplateExpression */:
                return visitNode(cbNode, node.head) || visitNodes(cbNodes, node.templateSpans);
            case 202 /* TemplateSpan */:
                return visitNode(cbNode, node.expression) || visitNode(cbNode, node.literal);
            case 142 /* ComputedPropertyName */:
                return visitNode(cbNode, node.expression);
            case 255 /* HeritageClause */:
                return visitNodes(cbNodes, node.types);
            case 199 /* ExpressionWithTypeArguments */:
                return visitNode(cbNode, node.expression) ||
                    visitNodes(cbNodes, node.typeArguments);
            case 245 /* ExternalModuleReference */:
                return visitNode(cbNode, node.expression);
            case 244 /* MissingDeclaration */:
                return visitNodes(cbNodes, node.decorators);
            case 246 /* JsxElement */:
                return visitNode(cbNode, node.openingElement) ||
                    visitNodes(cbNodes, node.children) ||
                    visitNode(cbNode, node.closingElement);
            case 247 /* JsxSelfClosingElement */:
            case 248 /* JsxOpeningElement */:
                return visitNode(cbNode, node.tagName) ||
                    visitNodes(cbNodes, node.attributes);
            case 250 /* JsxAttribute */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.initializer);
            case 251 /* JsxSpreadAttribute */:
                return visitNode(cbNode, node.expression);
            case 252 /* JsxExpression */:
                return visitNode(cbNode, node.expression);
            case 249 /* JsxClosingElement */:
                return visitNode(cbNode, node.tagName);
            case 262 /* JSDocTypeExpression */:
                return visitNode(cbNode, node.type);
            case 266 /* JSDocUnionType */:
                return visitNodes(cbNodes, node.types);
            case 267 /* JSDocTupleType */:
                return visitNodes(cbNodes, node.types);
            case 265 /* JSDocArrayType */:
                return visitNode(cbNode, node.elementType);
            case 269 /* JSDocNonNullableType */:
                return visitNode(cbNode, node.type);
            case 268 /* JSDocNullableType */:
                return visitNode(cbNode, node.type);
            case 270 /* JSDocRecordType */:
                return visitNode(cbNode, node.literal);
            case 272 /* JSDocTypeReference */:
                return visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.typeArguments);
            case 273 /* JSDocOptionalType */:
                return visitNode(cbNode, node.type);
            case 274 /* JSDocFunctionType */:
                return visitNodes(cbNodes, node.parameters) ||
                    visitNode(cbNode, node.type);
            case 275 /* JSDocVariadicType */:
                return visitNode(cbNode, node.type);
            case 276 /* JSDocConstructorType */:
                return visitNode(cbNode, node.type);
            case 277 /* JSDocThisType */:
                return visitNode(cbNode, node.type);
            case 271 /* JSDocRecordMember */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.type);
            case 278 /* JSDocComment */:
                return visitNodes(cbNodes, node.tags);
            case 281 /* JSDocParameterTag */:
                return visitNode(cbNode, node.preParameterName) ||
                    visitNode(cbNode, node.typeExpression) ||
                    visitNode(cbNode, node.postParameterName);
            case 282 /* JSDocReturnTag */:
                return visitNode(cbNode, node.typeExpression);
            case 283 /* JSDocTypeTag */:
                return visitNode(cbNode, node.typeExpression);
            case 280 /* JSDocAugmentsTag */:
                return visitNode(cbNode, node.typeExpression);
            case 284 /* JSDocTemplateTag */:
                return visitNodes(cbNodes, node.typeParameters);
            case 285 /* JSDocTypedefTag */:
                return visitNode(cbNode, node.typeExpression) ||
                    visitNode(cbNode, node.fullName) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.jsDocTypeLiteral);
            case 287 /* JSDocTypeLiteral */:
                return visitNodes(cbNodes, node.jsDocPropertyTags);
            case 286 /* JSDocPropertyTag */:
                return visitNode(cbNode, node.typeExpression) ||
                    visitNode(cbNode, node.name);
            case 294 /* PartiallyEmittedExpression */:
                return visitNode(cbNode, node.expression);
            case 288 /* JSDocLiteralType */:
                return visitNode(cbNode, node.literal);
        }
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{250,1} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{250,1} AS 1 AT <0:544>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{250,2} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{250,2} AS 2 AT <0:596>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{250,3} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{250,3} AS 3 AT <0:692>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{250,4} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{250,4} AS 4 AT <0:744>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{250,5} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{250,5} AS 5 AT <0:802>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{250,6} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{250,6} AS 6 AT <0:1658>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{250,7} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{250,7} AS 7 AT <0:1718>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{250,8} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{250,8} AS 8 AT <0:1777>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{250,9} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{250,9} AS 9 AT <0:1837>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{250,10} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{250,10} AS 10 AT <0:1899>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{250,11} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{250,11} AS 11 AT <0:1951>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{250,12} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{250,12} AS 12 AT <0:2012>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{250,13} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{250,13} AS 13 AT <0:2064>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{250,14} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{250,14} AS 14 AT <0:2341>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{250,15} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{250,15} AS 15 AT <0:2401>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{250,16} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{250,16} AS 16 AT <0:2460>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{250,17} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{250,17} AS 17 AT <0:2524>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{250,18} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{250,18} AS 18 AT <0:2584>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{250,19} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{250,19} AS 19 AT <0:2984>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{250,20} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{250,20} AS 20 AT <0:3044>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{250,21} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{250,21} AS 21 AT <0:3103>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{250,22} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{250,22} AS 22 AT <0:3164>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{250,23} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{250,23} AS 23 AT <0:3216>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{250,24} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{250,24} AS 24 AT <0:3277>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{250,25} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{250,25} AS 25 AT <0:3341>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{250,26} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{250,26} AS 26 AT <0:3401>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{250,27} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{250,27} AS 27 AT <0:3453>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{250,28} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{250,28} AS 28 AT <0:3523>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{250,29} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{250,29} AS 29 AT <0:3618>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{250,30} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{250,30} AS 30 AT <0:3674>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{250,31} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{250,31} AS 31 AT <0:3780>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{250,32} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{250,32} AS 32 AT <0:3841>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{250,33} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{250,33} AS 33 AT <0:3932>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{250,34} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{250,34} AS 34 AT <0:4029>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{250,35} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{250,35} AS 35 AT <0:4125>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{250,36} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{250,36} AS 36 AT <0:4223>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{250,37} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{250,37} AS 37 AT <0:4369>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{250,38} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{250,38} AS 38 AT <0:4512>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{250,39} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{250,39} AS 39 AT <0:4611>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{250,40} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{250,40} AS 40 AT <0:4669>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{250,41} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{250,41} AS 41 AT <0:4766>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{250,42} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{250,42} AS 42 AT <0:4827>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{250,43} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{250,43} AS 43 AT <0:4888>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{250,44} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{250,44} AS 44 AT <0:4949>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{250,45} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{250,45} AS 45 AT <0:5042>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{250,46} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{250,46} AS 46 AT <0:8393>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{250,47} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{250,47} AS 47 AT <0:8562>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{250,48} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{250,48} AS 48 AT <0:8622>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{250,49} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{250,49} AS 49 AT <0:8681>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{250,50} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{250,50} AS 50 AT <0:8797>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{250,51} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{250,51} AS 51 AT <0:12363>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{250,52} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{250,52} AS 52 AT <0:12423>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{250,53} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{250,53} AS 53 AT <0:12482>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{250,54} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{250,54} AS 54 AT <0:12534>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{250,55} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{250,55} AS 55 AT <0:12598>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{250,56} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{250,56} AS 56 AT <0:12663>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{250,57} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{250,57} AS 57 AT <0:12770>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{250,58} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{250,58} AS 58 AT <0:12830>
[deoptimizing (DEOPT eager): begin 0x2f05bb806029 <JS Function bindWorker (SharedFunctionInfo 0x16f3adb5c261)> (opt #221) @33, FP to SP delta: 240, caller sp: 0x7fff5fbfe0c0]
            ;;; deoptimize at 10_36: wrong map
  reading input frame bindWorker => node=1764, args=2, height=8; inputs:
      0: 0x2f05bb806029 ; [fp - 16] 0x2f05bb806029 <JS Function bindWorker (SharedFunctionInfo 0x16f3adb5c261)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2f05bb83a721 ; [fp + 16] 0x2f05bb83a721 <a SourceFileObject with map 0x33abe2a715f9>
      3: 0xd6230dfeea1 ; [fp - 24] 0xd6230dfeea1 <FixedArray[147]>
      4: 0x30bcea4069a9 ; (literal 20) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      5: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
      6: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
      7: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
      9: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     10: 0x2f05bb8060b9 ; [fp - 88] 0x2f05bb8060b9 <JS Function bindSourceFileIfExternalModule (SharedFunctionInfo 0x16f3adb5c3e1)>
  reading input frame bindSourceFileIfExternalModule => node=7, args=1, height=2; inputs:
      0: 0x2f05bb8060b9 ; (literal 25) 0x2f05bb8060b9 <JS Function bindSourceFileIfExternalModule (SharedFunctionInfo 0x16f3adb5c3e1)>
      1: 0x1f9f6c0532e1 ; (literal 22) 0x1f9f6c0532e1 <JS Global Object>
      2: 0xd6230dfeea1 ; (literal 23) 0xd6230dfeea1 <FixedArray[147]>
      3: 0x2f05bb805891 ; [fp - 112] 0x2f05bb805891 <JS Function setExportContextFlag (SharedFunctionInfo 0x16f3adb5ae21)>
  reading input frame setExportContextFlag => node=36, args=2, height=2; inputs:
      0: 0x2f05bb805891 ; (literal 26) 0x2f05bb805891 <JS Function setExportContextFlag (SharedFunctionInfo 0x16f3adb5ae21)>
      1: 0x1f9f6c0532e1 ; (literal 22) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2f05bb83a721 ; rbx 0x2f05bb83a721 <a SourceFileObject with map 0x33abe2a715f9>
      3: 0xd6230dfeea1 ; (literal 23) 0xd6230dfeea1 <FixedArray[147]>
      4: 0x2f05bb805849 ; rax 0x2f05bb805849 <JS Function hasExportDeclarations (SharedFunctionInfo 0x16f3adb5ad61)>
  reading input frame hasExportDeclarations => node=3, args=2, height=5; inputs:
      0: 0x2f05bb805849 ; (literal 27) 0x2f05bb805849 <JS Function hasExportDeclarations (SharedFunctionInfo 0x16f3adb5ad61)>
      1: 0x1f9f6c0532e1 ; (literal 22) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2f05bb83a721 ; rbx 0x2f05bb83a721 <a SourceFileObject with map 0x33abe2a715f9>
      3: 0xd6230dfeea1 ; (literal 23) 0xd6230dfeea1 <FixedArray[147]>
      4: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
      5: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
      6: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
      7: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
  translating frame bindWorker => node=1764, height=56
    0x7fff5fbfe0b8: [top + 96] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfe0b0: [top + 88] <- 0x2f05bb83a721 ;  0x2f05bb83a721 <a SourceFileObject with map 0x33abe2a715f9>  (input #2)
    0x7fff5fbfe0a8: [top + 80] <- 0x2c21d254dc06 ;  caller's pc
    0x7fff5fbfe0a0: [top + 72] <- 0x7fff5fbfe0e8 ;  caller's fp
    0x7fff5fbfe098: [top + 64] <- 0xd6230dfeea1 ;  context    0xd6230dfeea1 <FixedArray[147]>  (input #3)
    0x7fff5fbfe090: [top + 56] <- 0x2f05bb806029 ;  function    0x2f05bb806029 <JS Function bindWorker (SharedFunctionInfo 0x16f3adb5c261)>  (input #0)
    0x7fff5fbfe088: [top + 48] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #4)
    0x7fff5fbfe080: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfe078: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfe070: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfe068: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfe060: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
    0x7fff5fbfe058: [top + 0] <- 0x2f05bb8060b9 ;  0x2f05bb8060b9 <JS Function bindSourceFileIfExternalModule (SharedFunctionInfo 0x16f3adb5c3e1)>  (input #10)
  translating frame bindSourceFileIfExternalModule => node=7, height=8
    0x7fff5fbfe050: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfe048: [top + 32] <- 0x2c21d2544cbf ;  caller's pc
    0x7fff5fbfe040: [top + 24] <- 0x7fff5fbfe0a0 ;  caller's fp
    0x7fff5fbfe038: [top + 16] <- 0xd6230dfeea1 ;  context    0xd6230dfeea1 <FixedArray[147]>  (input #2)
    0x7fff5fbfe030: [top + 8] <- 0x2f05bb8060b9 ;  function    0x2f05bb8060b9 <JS Function bindSourceFileIfExternalModule (SharedFunctionInfo 0x16f3adb5c3e1)>  (input #0)
    0x7fff5fbfe028: [top + 0] <- 0x2f05bb805891 ;  0x2f05bb805891 <JS Function setExportContextFlag (SharedFunctionInfo 0x16f3adb5ae21)>  (input #3)
  translating frame setExportContextFlag => node=36, height=8
    0x7fff5fbfe020: [top + 48] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfe018: [top + 40] <- 0x2f05bb83a721 ;  0x2f05bb83a721 <a SourceFileObject with map 0x33abe2a715f9>  (input #2)
    0x7fff5fbfe010: [top + 32] <- 0x2c21d25452fb ;  caller's pc
    0x7fff5fbfe008: [top + 24] <- 0x7fff5fbfe040 ;  caller's fp
    0x7fff5fbfe000: [top + 16] <- 0xd6230dfeea1 ;  context    0xd6230dfeea1 <FixedArray[147]>  (input #3)
    0x7fff5fbfdff8: [top + 8] <- 0x2f05bb805891 ;  function    0x2f05bb805891 <JS Function setExportContextFlag (SharedFunctionInfo 0x16f3adb5ae21)>  (input #0)
    0x7fff5fbfdff0: [top + 0] <- 0x2f05bb805849 ;  0x2f05bb805849 <JS Function hasExportDeclarations (SharedFunctionInfo 0x16f3adb5ad61)>  (input #4)
  translating frame hasExportDeclarations => node=3, height=32
    0x7fff5fbfdfe8: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdfe0: [top + 64] <- 0x2f05bb83a721 ;  0x2f05bb83a721 <a SourceFileObject with map 0x33abe2a715f9>  (input #2)
    0x7fff5fbfdfd8: [top + 56] <- 0x2c21d25454d6 ;  caller's pc
    0x7fff5fbfdfd0: [top + 48] <- 0x7fff5fbfe008 ;  caller's fp
    0x7fff5fbfdfc8: [top + 40] <- 0xd6230dfeea1 ;  context    0xd6230dfeea1 <FixedArray[147]>  (input #3)
    0x7fff5fbfdfc0: [top + 32] <- 0x2f05bb805849 ;  function    0x2f05bb805849 <JS Function hasExportDeclarations (SharedFunctionInfo 0x16f3adb5ad61)>  (input #0)
    0x7fff5fbfdfb8: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfdfb0: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfdfa8: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfdfa0: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
[deoptimizing (eager): end 0x2f05bb806029 <JS Function bindWorker (SharedFunctionInfo 0x16f3adb5c261)> @33 => node=3, pc=0x2c21d2545a4e, caller sp=0x7fff5fbfe0c0, state=NO_REGISTERS, took 0.205 ms]
[deoptimizing (DEOPT eager): begin 0x2f05bb8059f9 <JS Function bindBlockScopedDeclaration (SharedFunctionInfo 0x16f3adb5b1e1)> (opt #222) @2, FP to SP delta: 56, caller sp: 0x7fff5fbfda90]
            ;;; deoptimize at 0_77: wrong map
  reading input frame bindBlockScopedDeclaration => node=4, args=4, height=2; inputs:
      0: 0x2f05bb8059f9 ; [fp - 16] 0x2f05bb8059f9 <JS Function bindBlockScopedDeclaration (SharedFunctionInfo 0x16f3adb5b1e1)>
      1: 0x1f9f6c0532e1 ; [fp + 40] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2f05bb89c069 ; [fp + 32] 0x2f05bb89c069 <a NodeObject with map 0x33abe2a69569>
      3: 0x4000000000 ; [fp + 24] 64
      4: 0xc198800000000 ; [fp + 16] 792968
      5: 0xd6230dfeea1 ; rax 0xd6230dfeea1 <FixedArray[147]>
      6: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
  translating frame bindBlockScopedDeclaration => node=4, height=8
    0x7fff5fbfda88: [top + 64] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfda80: [top + 56] <- 0x2f05bb89c069 ;  0x2f05bb89c069 <a NodeObject with map 0x33abe2a69569>  (input #2)
    0x7fff5fbfda78: [top + 48] <- 0x4000000000 ;  64  (input #3)
    0x7fff5fbfda70: [top + 40] <- 0xc198800000000 ;  792968  (input #4)
    0x7fff5fbfda68: [top + 32] <- 0x2c21d2544944 ;  caller's pc
    0x7fff5fbfda60: [top + 24] <- 0x7fff5fbfdad8 ;  caller's fp
    0x7fff5fbfda58: [top + 16] <- 0xd6230dfeea1 ;  context    0xd6230dfeea1 <FixedArray[147]>  (input #5)
    0x7fff5fbfda50: [top + 8] <- 0x2f05bb8059f9 ;  function    0x2f05bb8059f9 <JS Function bindBlockScopedDeclaration (SharedFunctionInfo 0x16f3adb5b1e1)>  (input #0)
    0x7fff5fbfda48: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
[deoptimizing (eager): end 0x2f05bb8059f9 <JS Function bindBlockScopedDeclaration (SharedFunctionInfo 0x16f3adb5b1e1)> @2 => node=4, pc=0x2c21d23fe68a, caller sp=0x7fff5fbfda90, state=NO_REGISTERS, took 0.051 ms]
[deoptimizing (DEOPT eager): begin 0x2f05bb805771 <JS Function declareSymbolAndAddToSymbolTableWorker (SharedFunctionInfo 0x16f3adb5ab21)> (opt #227) @18, FP to SP delta: 48, caller sp: 0x7fff5fbfd130]
            ;;; deoptimize at 1_192: wrong map
  reading input frame declareSymbolAndAddToSymbolTableWorker => node=69, args=4, height=3; inputs:
      0: 0x2f05bb805771 ; [fp - 16] 0x2f05bb805771 <JS Function declareSymbolAndAddToSymbolTableWorker (SharedFunctionInfo 0x16f3adb5ab21)>
      1: 0x1f9f6c0532e1 ; [fp + 40] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2f05bb8cba41 ; [fp + 32] 0x2f05bb8cba41 <a NodeObject with map 0x33abe2a67939>
      3: 0x100000000 ; [fp + 24] 1
      4: 0x1a3be00000000 ; [fp + 16] 107454
      5: 0xd6230dfeea1 ; [fp - 24] 0xd6230dfeea1 <FixedArray[147]>
      6: 0x30bcea4069a9 ; (literal 4) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x2f05bb805801 ; [fp - 32] 0x2f05bb805801 <JS Function declareSourceFileMember (SharedFunctionInfo 0x16f3adb5aca1)>
  reading input frame declareSourceFileMember => node=8, args=4, height=1; inputs:
      0: 0x2f05bb805801 ; (literal 5) 0x2f05bb805801 <JS Function declareSourceFileMember (SharedFunctionInfo 0x16f3adb5aca1)>
      1: 0x1f9f6c0532e1 ; (literal 6) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2f05bb8cba41 ; [fp + 32] 0x2f05bb8cba41 <a NodeObject with map 0x33abe2a67939>
      3: 0x100000000 ; [fp + 24] 1
      4: 0x1a3be00000000 ; [fp + 16] 107454
      5: 0xd6230dfeea1 ; (literal 7) 0xd6230dfeea1 <FixedArray[147]>
  translating frame declareSymbolAndAddToSymbolTableWorker => node=69, height=16
    0x7fff5fbfd128: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd120: [top + 64] <- 0x2f05bb8cba41 ;  0x2f05bb8cba41 <a NodeObject with map 0x33abe2a67939>  (input #2)
    0x7fff5fbfd118: [top + 56] <- 0x100000000 ;  1  (input #3)
    0x7fff5fbfd110: [top + 48] <- 0x1a3be00000000 ;  107454  (input #4)
    0x7fff5fbfd108: [top + 40] <- 0x2c21d258f847 ;  caller's pc
    0x7fff5fbfd100: [top + 32] <- 0x7fff5fbfd170 ;  caller's fp
    0x7fff5fbfd0f8: [top + 24] <- 0xd6230dfeea1 ;  context    0xd6230dfeea1 <FixedArray[147]>  (input #5)
    0x7fff5fbfd0f0: [top + 16] <- 0x2f05bb805771 ;  function    0x2f05bb805771 <JS Function declareSymbolAndAddToSymbolTableWorker (SharedFunctionInfo 0x16f3adb5ab21)>  (input #0)
    0x7fff5fbfd0e8: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfd0e0: [top + 0] <- 0x2f05bb805801 ;  0x2f05bb805801 <JS Function declareSourceFileMember (SharedFunctionInfo 0x16f3adb5aca1)>  (input #7)
  translating frame declareSourceFileMember => node=8, height=0
    0x7fff5fbfd0d8: [top + 56] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd0d0: [top + 48] <- 0x2f05bb8cba41 ;  0x2f05bb8cba41 <a NodeObject with map 0x33abe2a67939>  (input #2)
    0x7fff5fbfd0c8: [top + 40] <- 0x100000000 ;  1  (input #3)
    0x7fff5fbfd0c0: [top + 32] <- 0x1a3be00000000 ;  107454  (input #4)
    0x7fff5fbfd0b8: [top + 24] <- 0x2c21d2526f1c ;  caller's pc
    0x7fff5fbfd0b0: [top + 16] <- 0x7fff5fbfd100 ;  caller's fp
    0x7fff5fbfd0a8: [top + 8] <- 0xd6230dfeea1 ;  context    0xd6230dfeea1 <FixedArray[147]>  (input #5)
    0x7fff5fbfd0a0: [top + 0] <- 0x2f05bb805801 ;  function    0x2f05bb805801 <JS Function declareSourceFileMember (SharedFunctionInfo 0x16f3adb5aca1)>  (input #0)
[deoptimizing (eager): end 0x2f05bb805771 <JS Function declareSymbolAndAddToSymbolTableWorker (SharedFunctionInfo 0x16f3adb5ab21)> @18 => node=8, pc=0x2c21d252724c, caller sp=0x7fff5fbfd130, state=NO_REGISTERS, took 0.155 ms]
[deoptimizing (DEOPT soft): begin 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> (opt #250) @132, FP to SP delta: 752, caller sp: 0x7fff5fbfce68]
            ;;; deoptimize at 0_11980: Insufficient type feedback for generic named access
  reading input frame forEachChild => node=3724, args=4, height=4; inputs:
      0: 0xd6230dc36a9 ; [fp - 16] 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>
      1: 0x16f3adb61821 ; [fp + 40] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x2f05bb8cd3c1 ; [fp + 32] 0x2f05bb8cd3c1 <a NodeObject with map 0x33abe2a711d9>
      3: 0x2f05bb805f51 ; [fp + 24] 0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>
      4: 0x2f05bb804889 ; [fp + 16] 0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>
      5: 0xd6230d99249 ; [fp - 24] 0xd6230d99249 <FixedArray[15]>
      6: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0xd6230dd5d69 ; [fp - 32] 0xd6230dd5d69 <JS Function visitNodeArray (SharedFunctionInfo 0x3504a53f0029)>
      8: 0x2f05bb804889 ; [fp - 40] 0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>
  translating frame forEachChild => node=3724, height=24
    0x7fff5fbfce60: [top + 80] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfce58: [top + 72] <- 0x2f05bb8cd3c1 ;  0x2f05bb8cd3c1 <a NodeObject with map 0x33abe2a711d9>  (input #2)
    0x7fff5fbfce50: [top + 64] <- 0x2f05bb805f51 ;  0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>  (input #3)
    0x7fff5fbfce48: [top + 56] <- 0x2f05bb804889 ;  0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>  (input #4)
    0x7fff5fbfce40: [top + 48] <- 0x2c21d2577908 ;  caller's pc
    0x7fff5fbfce38: [top + 40] <- 0x7fff5fbfceb0 ;  caller's fp
    0x7fff5fbfce30: [top + 32] <- 0xd6230d99249 ;  context    0xd6230d99249 <FixedArray[15]>  (input #5)
    0x7fff5fbfce28: [top + 24] <- 0xd6230dc36a9 ;  function    0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>  (input #0)
    0x7fff5fbfce20: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfce18: [top + 8] <- 0xd6230dd5d69 ;  0xd6230dd5d69 <JS Function visitNodeArray (SharedFunctionInfo 0x3504a53f0029)>  (input #7)
    0x7fff5fbfce10: [top + 0] <- 0x2f05bb804889 ;  0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>  (input #8)
[deoptimizing (soft): end 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> @132 => node=3724, pc=0x2c21d24c7f99, caller sp=0x7fff5fbfce68, state=NO_REGISTERS, took 0.100 ms]
[deoptimizer unlinked: forEachChild / d6230dc36a9]
[deoptimizing (DEOPT soft): begin 0x2f05bb805a89 <JS Function checkStrictModeIdentifier (SharedFunctionInfo 0x16f3adb5b361)> (opt #245) @2, FP to SP delta: 24, caller sp: 0x7fff5fbfcd18]
  reading input frame checkStrictModeIdentifier => node=22, args=2, height=1; inputs:
      0: 0x2f05bb805a89 ; [fp - 16] 0x2f05bb805a89 <JS Function checkStrictModeIdentifier (SharedFunctionInfo 0x16f3adb5b361)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2f05bb8d5619 ; [fp + 16] 0x2f05bb8d5619 <an IdentifierObject with map 0x33abe2a6fb81>
      3: 0xd6230dfeea1 ; rax 0xd6230dfeea1 <FixedArray[147]>
  translating frame checkStrictModeIdentifier => node=22, height=0
    0x7fff5fbfcd10: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfcd08: [top + 32] <- 0x2f05bb8d5619 ;  0x2f05bb8d5619 <an IdentifierObject with map 0x33abe2a6fb81>  (input #2)
    0x7fff5fbfcd00: [top + 24] <- 0x2c21d25439bf ;  caller's pc
    0x7fff5fbfccf8: [top + 16] <- 0x7fff5fbfcd60 ;  caller's fp
    0x7fff5fbfccf0: [top + 8] <- 0xd6230dfeea1 ;  context    0xd6230dfeea1 <FixedArray[147]>  (input #3)
    0x7fff5fbfcce8: [top + 0] <- 0x2f05bb805a89 ;  function    0x2f05bb805a89 <JS Function checkStrictModeIdentifier (SharedFunctionInfo 0x16f3adb5b361)>  (input #0)
[deoptimizing (soft): end 0x2f05bb805a89 <JS Function checkStrictModeIdentifier (SharedFunctionInfo 0x16f3adb5b361)> @2 => node=22, pc=0x2c21d25258cd, caller sp=0x7fff5fbfcd18, state=NO_REGISTERS, took 0.063 ms]
[deoptimizing (DEOPT eager): begin 0xd6230dd0c99 <JS Function isObjectLiteralMethod (SharedFunctionInfo 0x3504a53cf059)> (opt #212) @3, FP to SP delta: 24, caller sp: 0x7fff5fbfcc08]
  reading input frame isObjectLiteralMethod => node=4, args=2, height=1; inputs:
      0: 0xd6230dd0c99 ; [fp - 16] 0xd6230dd0c99 <JS Function isObjectLiteralMethod (SharedFunctionInfo 0x3504a53cf059)>
      1: 0x16f3adb61821 ; [fp + 24] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x2f05bb8e0a99 ; rax 0x2f05bb8e0a99 <a NodeObject with map 0x33abe2a68801>
      3: 0xd6230db34c9 ; [fp - 24] 0xd6230db34c9 <FixedArray[156]>
  translating frame isObjectLiteralMethod => node=4, height=0
    0x7fff5fbfcc00: [top + 40] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfcbf8: [top + 32] <- 0x2f05bb8e0a99 ;  0x2f05bb8e0a99 <a NodeObject with map 0x33abe2a68801>  (input #2)
    0x7fff5fbfcbf0: [top + 24] <- 0x2c21d254459c ;  caller's pc
    0x7fff5fbfcbe8: [top + 16] <- 0x7fff5fbfcc70 ;  caller's fp
    0x7fff5fbfcbe0: [top + 8] <- 0xd6230db34c9 ;  context    0xd6230db34c9 <FixedArray[156]>  (input #3)
    0x7fff5fbfcbd8: [top + 0] <- 0xd6230dd0c99 ;  function    0xd6230dd0c99 <JS Function isObjectLiteralMethod (SharedFunctionInfo 0x3504a53cf059)>  (input #0)
[deoptimizing (eager): end 0xd6230dd0c99 <JS Function isObjectLiteralMethod (SharedFunctionInfo 0x3504a53cf059)> @3 => node=4, pc=0x2c21d2549f06, caller sp=0x7fff5fbfcc08, state=NO_REGISTERS, took 0.047 ms]
[deoptimizing (DEOPT eager): begin 0xd6230dcc5f9 <JS Function isObjectLiteralOrClassExpressionMethod (SharedFunctionInfo 0x3504a53cf119)> (opt #204) @2, FP to SP delta: 24, caller sp: 0x7fff5fbfcbb0]
  reading input frame isObjectLiteralOrClassExpressionMethod => node=4, args=2, height=1; inputs:
      0: 0xd6230dcc5f9 ; [fp - 16] 0xd6230dcc5f9 <JS Function isObjectLiteralOrClassExpressionMethod (SharedFunctionInfo 0x3504a53cf119)>
      1: 0x16f3adb61821 ; [fp + 24] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x2f05bb8e0a99 ; rax 0x2f05bb8e0a99 <a NodeObject with map 0x33abe2a68801>
      3: 0xd6230db34c9 ; [fp - 24] 0xd6230db34c9 <FixedArray[156]>
  translating frame isObjectLiteralOrClassExpressionMethod => node=4, height=0
    0x7fff5fbfcba8: [top + 40] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfcba0: [top + 32] <- 0x2f05bb8e0a99 ;  0x2f05bb8e0a99 <a NodeObject with map 0x33abe2a68801>  (input #2)
    0x7fff5fbfcb98: [top + 24] <- 0x2c21d25555d3 ;  caller's pc
    0x7fff5fbfcb90: [top + 16] <- 0x7fff5fbfcbf8 ;  caller's fp
    0x7fff5fbfcb88: [top + 8] <- 0xd6230db34c9 ;  context    0xd6230db34c9 <FixedArray[156]>  (input #3)
    0x7fff5fbfcb80: [top + 0] <- 0xd6230dcc5f9 ;  function    0xd6230dcc5f9 <JS Function isObjectLiteralOrClassExpressionMethod (SharedFunctionInfo 0x3504a53cf119)>  (input #0)
[deoptimizing (eager): end 0xd6230dcc5f9 <JS Function isObjectLiteralOrClassExpressionMethod (SharedFunctionInfo 0x3504a53cf119)> @2 => node=4, pc=0x2c21d2549b26, caller sp=0x7fff5fbfcbb0, state=NO_REGISTERS, took 0.046 ms]
[deoptimizing (DEOPT soft): begin 0x2f05bb8064f1 <JS Function bindParameter (SharedFunctionInfo 0x16f3adb5cf21)> (opt #216) @2, FP to SP delta: 56, caller sp: 0x7fff5fbfc8e0]
            ;;; deoptimize at 0_298: Insufficient type feedback for generic named access
  reading input frame bindParameter => node=9, args=2, height=2; inputs:
      0: 0x2f05bb8064f1 ; [fp - 16] 0x2f05bb8064f1 <JS Function bindParameter (SharedFunctionInfo 0x16f3adb5cf21)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2f05bb8f8891 ; [fp + 16] 0x2f05bb8f8891 <a NodeObject with map 0x33abe2a674c1>
      3: 0xd6230dfeea1 ; rax 0xd6230dfeea1 <FixedArray[147]>
      4: 0x30bcea404311 ; (literal 3) 0x30bcea404311 <undefined>
  translating frame bindParameter => node=9, height=8
    0x7fff5fbfc8d8: [top + 48] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfc8d0: [top + 40] <- 0x2f05bb8f8891 ;  0x2f05bb8f8891 <a NodeObject with map 0x33abe2a674c1>  (input #2)
    0x7fff5fbfc8c8: [top + 32] <- 0x2c21d254400a ;  caller's pc
    0x7fff5fbfc8c0: [top + 24] <- 0x7fff5fbfc928 ;  caller's fp
    0x7fff5fbfc8b8: [top + 16] <- 0xd6230dfeea1 ;  context    0xd6230dfeea1 <FixedArray[147]>  (input #3)
    0x7fff5fbfc8b0: [top + 8] <- 0x2f05bb8064f1 ;  function    0x2f05bb8064f1 <JS Function bindParameter (SharedFunctionInfo 0x16f3adb5cf21)>  (input #0)
    0x7fff5fbfc8a8: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
[deoptimizing (soft): end 0x2f05bb8064f1 <JS Function bindParameter (SharedFunctionInfo 0x16f3adb5cf21)> @2 => node=9, pc=0x2c21d2527631, caller sp=0x7fff5fbfc8e0, state=NO_REGISTERS, took 0.153 ms]
[deoptimizing (DEOPT eager): begin 0x2f05bb8047f9 <JS Function bindContainer (SharedFunctionInfo 0x16f3adb581e1)> (opt #232) @15, FP to SP delta: 168, caller sp: 0x7fff5fbfcfd8]
            ;;; deoptimize at 0_5111: wrong map
  reading input frame bindContainer => node=884, args=3, height=11; inputs:
      0: 0x2f05bb8047f9 ; [fp - 16] 0x2f05bb8047f9 <JS Function bindContainer (SharedFunctionInfo 0x16f3adb581e1)>
      1: 0x1f9f6c0532e1 ; [fp + 32] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2f05bb8cd641 ; rbx 0x2f05bb8cd641 <a NodeObject with map 0x33abe2a71289>
      3: 0x4100000000 ; [fp + 16] 65
      4: 0xd6230dfeea1 ; [fp - 24] 0xd6230dfeea1 <FixedArray[147]>
      5: 0x2f05bb89ce69 ; [fp - 32] 0x2f05bb89ce69 <a NodeObject with map 0x33abe2a71231>
      6: 0x2f05bb89ce69 ; [fp - 40] 0x2f05bb89ce69 <a NodeObject with map 0x33abe2a71231>
      7: 0x30bcea404311 ; (literal 3) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; (literal 3) 0x30bcea404311 <undefined>
      9: 0x30bcea404311 ; (literal 3) 0x30bcea404311 <undefined>
     10: 0x30bcea404311 ; (literal 3) 0x30bcea404311 <undefined>
     11: 0x30bcea404311 ; (literal 3) 0x30bcea404311 <undefined>
     12: 0x30bcea404311 ; (literal 3) 0x30bcea404311 <undefined>
     13: 0x30bcea404311 ; (literal 3) 0x30bcea404311 <undefined>
     14: 0x2f05bb8cd641 ; rbx 0x2f05bb8cd641 <a NodeObject with map 0x33abe2a71289>
  translating frame bindContainer => node=884, height=80
    0x7fff5fbfcfd0: [top + 128] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfcfc8: [top + 120] <- 0x2f05bb8cd641 ;  0x2f05bb8cd641 <a NodeObject with map 0x33abe2a71289>  (input #2)
    0x7fff5fbfcfc0: [top + 112] <- 0x4100000000 ;  65  (input #3)
    0x7fff5fbfcfb8: [top + 104] <- 0x2c21d254dd70 ;  caller's pc
    0x7fff5fbfcfb0: [top + 96] <- 0x7fff5fbfd000 ;  caller's fp
    0x7fff5fbfcfa8: [top + 88] <- 0xd6230dfeea1 ;  context    0xd6230dfeea1 <FixedArray[147]>  (input #4)
    0x7fff5fbfcfa0: [top + 80] <- 0x2f05bb8047f9 ;  function    0x2f05bb8047f9 <JS Function bindContainer (SharedFunctionInfo 0x16f3adb581e1)>  (input #0)
    0x7fff5fbfcf98: [top + 72] <- 0x2f05bb89ce69 ;  0x2f05bb89ce69 <a NodeObject with map 0x33abe2a71231>  (input #5)
    0x7fff5fbfcf90: [top + 64] <- 0x2f05bb89ce69 ;  0x2f05bb89ce69 <a NodeObject with map 0x33abe2a71231>  (input #6)
    0x7fff5fbfcf88: [top + 56] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfcf80: [top + 48] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfcf78: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
    0x7fff5fbfcf70: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #10)
    0x7fff5fbfcf68: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #11)
    0x7fff5fbfcf60: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #12)
    0x7fff5fbfcf58: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #13)
    0x7fff5fbfcf50: [top + 0] <- 0x2f05bb8cd641 ;  0x2f05bb8cd641 <a NodeObject with map 0x33abe2a71289>  (input #14)
[deoptimizing (eager): end 0x2f05bb8047f9 <JS Function bindContainer (SharedFunctionInfo 0x16f3adb581e1)> @15 => node=884, pc=0x2c21d2547509, caller sp=0x7fff5fbfcfd8, state=NO_REGISTERS, took 0.099 ms]
[deoptimizer unlinked: bindContainer / 2f05bb8047f9]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:bindWorker) id{251,0} ---
(node) {
            switch (node.kind) {
                /* Strict mode checks */
                case 70 /* Identifier */:
                    // for typedef type names with namespaces, bind the new jsdoc type symbol here
                    // because it requires all containing namespaces to be in effect, namely the
                    // current "blockScopeContainer" needs to be set to its immediate namespace parent.
                    if (node.isInJSDocNamespace) {
                        var parentNode = node.parent;
                        while (parentNode && parentNode.kind !== 285 /* JSDocTypedefTag */) {
                            parentNode = parentNode.parent;
                        }
                        bindBlockScopedDeclaration(parentNode, 524288 /* TypeAlias */, 793064 /* TypeAliasExcludes */);
                        break;
                    }
                case 98 /* ThisKeyword */:
                    if (currentFlow && (ts.isExpression(node) || parent.kind === 258 /* ShorthandPropertyAssignment */)) {
                        node.flowNode = currentFlow;
                    }
                    return checkStrictModeIdentifier(node);
                case 177 /* PropertyAccessExpression */:
                    if (currentFlow && isNarrowableReference(node)) {
                        node.flowNode = currentFlow;
                    }
                    break;
                case 192 /* BinaryExpression */:
                    if (ts.isInJavaScriptFile(node)) {
                        var specialKind = ts.getSpecialPropertyAssignmentKind(node);
                        switch (specialKind) {
                            case 1 /* ExportsProperty */:
                                bindExportsPropertyAssignment(node);
                                break;
                            case 2 /* ModuleExports */:
                                bindModuleExportsAssignment(node);
                                break;
                            case 3 /* PrototypeProperty */:
                                bindPrototypePropertyAssignment(node);
                                break;
                            case 4 /* ThisProperty */:
                                bindThisPropertyAssignment(node);
                                break;
                            case 0 /* None */:
                                // Nothing to do
                                break;
                            default:
                                ts.Debug.fail("Unknown special property assignment kind");
                        }
                    }
                    return checkStrictModeBinaryExpression(node);
                case 256 /* CatchClause */:
                    return checkStrictModeCatchClause(node);
                case 186 /* DeleteExpression */:
                    return checkStrictModeDeleteExpression(node);
                case 8 /* NumericLiteral */:
                    return checkStrictModeNumericLiteral(node);
                case 191 /* PostfixUnaryExpression */:
                    return checkStrictModePostfixUnaryExpression(node);
                case 190 /* PrefixUnaryExpression */:
                    return checkStrictModePrefixUnaryExpression(node);
                case 217 /* WithStatement */:
                    return checkStrictModeWithStatement(node);
                case 167 /* ThisType */:
                    seenThisKeyword = true;
                    return;
                case 156 /* TypePredicate */:
                    return checkTypePredicate(node);
                case 143 /* TypeParameter */:
                    return declareSymbolAndAddToSymbolTable(node, 262144 /* TypeParameter */, 530920 /* TypeParameterExcludes */);
                case 144 /* Parameter */:
                    return bindParameter(node);
                case 223 /* VariableDeclaration */:
                case 174 /* BindingElement */:
                    return bindVariableDeclarationOrBindingElement(node);
                case 147 /* PropertyDeclaration */:
                case 146 /* PropertySignature */:
                case 271 /* JSDocRecordMember */:
                    return bindPropertyOrMethodOrAccessor(node, 4 /* Property */ | (node.questionToken ? 536870912 /* Optional */ : 0 /* None */), 0 /* PropertyExcludes */);
                case 286 /* JSDocPropertyTag */:
                    return bindJSDocProperty(node);
                case 257 /* PropertyAssignment */:
                case 258 /* ShorthandPropertyAssignment */:
                    return bindPropertyOrMethodOrAccessor(node, 4 /* Property */, 0 /* PropertyExcludes */);
                case 260 /* EnumMember */:
                    return bindPropertyOrMethodOrAccessor(node, 8 /* EnumMember */, 900095 /* EnumMemberExcludes */);
                case 259 /* SpreadAssignment */:
                case 251 /* JsxSpreadAttribute */:
                    var root = container;
                    var hasRest = false;
                    while (root.parent) {
                        if (root.kind === 176 /* ObjectLiteralExpression */ &&
                            root.parent.kind === 192 /* BinaryExpression */ &&
                            root.parent.operatorToken.kind === 57 /* EqualsToken */ &&
                            root.parent.left === root) {
                            hasRest = true;
                            break;
                        }
                        root = root.parent;
                    }
                    return;
                case 153 /* CallSignature */:
                case 154 /* ConstructSignature */:
                case 155 /* IndexSignature */:
                    return declareSymbolAndAddToSymbolTable(node, 131072 /* Signature */, 0 /* None */);
                case 149 /* MethodDeclaration */:
                case 148 /* MethodSignature */:
                    // If this is an ObjectLiteralExpression method, then it sits in the same space
                    // as other properties in the object literal.  So we use SymbolFlags.PropertyExcludes
                    // so that it will conflict with any other object literal members with the same
                    // name.
                    return bindPropertyOrMethodOrAccessor(node, 8192 /* Method */ | (node.questionToken ? 536870912 /* Optional */ : 0 /* None */), ts.isObjectLiteralMethod(node) ? 0 /* PropertyExcludes */ : 99263 /* MethodExcludes */);
                case 225 /* FunctionDeclaration */:
                    return bindFunctionDeclaration(node);
                case 150 /* Constructor */:
                    return declareSymbolAndAddToSymbolTable(node, 16384 /* Constructor */, /*symbolExcludes:*/ 0 /* None */);
                case 151 /* GetAccessor */:
                    return bindPropertyOrMethodOrAccessor(node, 32768 /* GetAccessor */, 41919 /* GetAccessorExcludes */);
                case 152 /* SetAccessor */:
                    return bindPropertyOrMethodOrAccessor(node, 65536 /* SetAccessor */, 74687 /* SetAccessorExcludes */);
                case 158 /* FunctionType */:
                case 159 /* ConstructorType */:
                case 274 /* JSDocFunctionType */:
                    return bindFunctionOrConstructorType(node);
                case 161 /* TypeLiteral */:
                case 170 /* MappedType */:
                case 287 /* JSDocTypeLiteral */:
                case 270 /* JSDocRecordType */:
                    return bindAnonymousDeclaration(node, 2048 /* TypeLiteral */, "__type");
                case 176 /* ObjectLiteralExpression */:
                    return bindObjectLiteralExpression(node);
                case 184 /* FunctionExpression */:
                case 185 /* ArrowFunction */:
                    return bindFunctionExpression(node);
                case 179 /* CallExpression */:
                    if (ts.isInJavaScriptFile(node)) {
                        bindCallExpression(node);
                    }
                    break;
                // Members of classes, interfaces, and modules
                case 197 /* ClassExpression */:
                case 226 /* ClassDeclaration */:
                    // All classes are automatically in strict mode in ES6.
                    inStrictMode = true;
                    return bindClassLikeDeclaration(node);
                case 227 /* InterfaceDeclaration */:
                    return bindBlockScopedDeclaration(node, 64 /* Interface */, 792968 /* InterfaceExcludes */);
                case 285 /* JSDocTypedefTag */:
                    if (!node.fullName || node.fullName.kind === 70 /* Identifier */) {
                        return bindBlockScopedDeclaration(node, 524288 /* TypeAlias */, 793064 /* TypeAliasExcludes */);
                    }
                    break;
                case 228 /* TypeAliasDeclaration */:
                    return bindBlockScopedDeclaration(node, 524288 /* TypeAlias */, 793064 /* TypeAliasExcludes */);
                case 229 /* EnumDeclaration */:
                    return bindEnumDeclaration(node);
                case 230 /* ModuleDeclaration */:
                    return bindModuleDeclaration(node);
                // Imports and exports
                case 234 /* ImportEqualsDeclaration */:
                case 237 /* NamespaceImport */:
                case 239 /* ImportSpecifier */:
                case 243 /* ExportSpecifier */:
                    return declareSymbolAndAddToSymbolTable(node, 8388608 /* Alias */, 8388608 /* AliasExcludes */);
                case 233 /* NamespaceExportDeclaration */:
                    return bindNamespaceExportDeclaration(node);
                case 236 /* ImportClause */:
                    return bindImportClause(node);
                case 241 /* ExportDeclaration */:
                    return bindExportDeclaration(node);
                case 240 /* ExportAssignment */:
                    return bindExportAssignment(node);
                case 261 /* SourceFile */:
                    updateStrictModeStatementList(node.statements);
                    return bindSourceFileIfExternalModule();
                case 204 /* Block */:
                    if (!ts.isFunctionLike(node.parent)) {
                        return;
                    }
                // Fall through
                case 231 /* ModuleBlock */:
                    return updateStrictModeStatementList(node.statements);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkTypePredicate) id{251,1} ---
(node) {
            var parameterName = node.parameterName, type = node.type;
            if (parameterName && parameterName.kind === 70 /* Identifier */) {
                checkStrictModeIdentifier(parameterName);
            }
            if (parameterName && parameterName.kind === 167 /* ThisType */) {
                seenThisKeyword = true;
            }
            bind(type);
        }
--- END ---
INLINE (checkTypePredicate) id{251,1} AS 1 AT <0:3560>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:declareSymbolAndAddToSymbolTable) id{251,2} ---
(node, symbolFlags, symbolExcludes) {
            // Just call this directly so that the return type of this function stays "void".
            return declareSymbolAndAddToSymbolTableWorker(node, symbolFlags, symbolExcludes);
        }
--- END ---
INLINE (declareSymbolAndAddToSymbolTable) id{251,2} AS 2 AT <0:3659>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:declareSymbolAndAddToSymbolTable) id{251,3} ---
(node, symbolFlags, symbolExcludes) {
            // Just call this directly so that the return type of this function stays "void".
            return declareSymbolAndAddToSymbolTableWorker(node, symbolFlags, symbolExcludes);
        }
--- END ---
INLINE (declareSymbolAndAddToSymbolTable) id{251,3} AS 3 AT <0:5731>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:bindAnonymousDeclaration) id{251,4} ---
(node, symbolFlags, name) {
            var symbol = createSymbol(symbolFlags, name);
            addDeclarationToSymbol(symbol, node, symbolFlags);
        }
--- END ---
INLINE (bindAnonymousDeclaration) id{251,4} AS 4 AT <0:7511>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createSymbol) id{251,5} ---
(flags, name) {
            symbolCount++;
            return new Symbol(flags, name);
        }
--- END ---
INLINE (createSymbol) id{251,5} AS 5 AT <4:53>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:SymbolObject) id{251,6} ---
(flags, name) {
            this.flags = flags;
            this.name = name;
        }
--- END ---
INLINE (SymbolObject) id{251,6} AS 6 AT <5:62>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:updateStrictModeStatementList) id{251,7} ---
(statements) {
            if (!inStrictMode) {
                for (var _i = 0, statements_2 = statements; _i < statements_2.length; _i++) {
                    var statement = statements_2[_i];
                    if (!ts.isPrologueDirective(statement)) {
                        return;
                    }
                    if (isUseStrictPrologueDirective(statement)) {
                        inStrictMode = true;
                        return;
                    }
                }
            }
        }
--- END ---
INLINE (updateStrictModeStatementList) id{251,7} AS 7 AT <0:10085>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:bindSourceFileIfExternalModule) id{251,8} ---
() {
            setExportContextFlag(file);
            if (ts.isExternalModule(file)) {
                bindSourceFileAsExternalModule();
            }
        }
--- END ---
INLINE (bindSourceFileIfExternalModule) id{251,8} AS 8 AT <0:10160>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:setExportContextFlag) id{251,9} ---
(node) {
            // A declaration source file or ambient module declaration that contains no export declarations (but possibly regular
            // declarations with export modifiers) is an export context in which declarations are implicitly exported.
            if (ts.isInAmbientContext(node) && !hasExportDeclarations(node)) {
                node.flags |= 32 /* ExportContext */;
            }
            else {
                node.flags &= ~32 /* ExportContext */;
            }
        }
--- END ---
INLINE (setExportContextFlag) id{251,9} AS 9 AT <8:17>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:hasExportDeclarations) id{251,10} ---
(node) {
            var body = node.kind === 261 /* SourceFile */ ? node : node.body;
            if (body && (body.kind === 261 /* SourceFile */ || body.kind === 231 /* ModuleBlock */)) {
                for (var _i = 0, _a = body.statements; _i < _a.length; _i++) {
                    var stat = _a[_i];
                    if (stat.kind === 241 /* ExportDeclaration */ || stat.kind === 240 /* ExportAssignment */) {
                        return true;
                    }
                }
            }
            return false;
        }
--- END ---
INLINE (hasExportDeclarations) id{251,10} AS 10 AT <9:306>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:updateStrictModeStatementList) id{251,11} ---
(statements) {
            if (!inStrictMode) {
                for (var _i = 0, statements_2 = statements; _i < statements_2.length; _i++) {
                    var statement = statements_2[_i];
                    if (!ts.isPrologueDirective(statement)) {
                        return;
                    }
                    if (isUseStrictPrologueDirective(statement)) {
                        inStrictMode = true;
                        return;
                    }
                }
            }
        }
--- END ---
INLINE (updateStrictModeStatementList) id{251,11} AS 11 AT <0:10448>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isObjectLiteralOrClassExpressionMethod) id{252,0} ---
(node) {
        return node.kind === 149 /* MethodDeclaration */ &&
            (node.parent.kind === 176 /* ObjectLiteralExpression */ ||
                node.parent.kind === 197 /* ClassExpression */);
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:forEachChild) id{253,0} ---
(node, cbNode, cbNodeArray) {
        if (!node) {
            return;
        }
        // The visitXXX functions could be written as local functions that close over the cbNode and cbNodeArray
        // callback parameters, but that causes a closure allocation for each invocation with noticeable effects
        // on performance.
        var visitNodes = cbNodeArray ? visitNodeArray : visitEachNode;
        var cbNodes = cbNodeArray || cbNode;
        switch (node.kind) {
            case 141 /* QualifiedName */:
                return visitNode(cbNode, node.left) ||
                    visitNode(cbNode, node.right);
            case 143 /* TypeParameter */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.constraint) ||
                    visitNode(cbNode, node.expression);
            case 258 /* ShorthandPropertyAssignment */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNode(cbNode, node.equalsToken) ||
                    visitNode(cbNode, node.objectAssignmentInitializer);
            case 259 /* SpreadAssignment */:
                return visitNode(cbNode, node.expression);
            case 144 /* Parameter */:
            case 147 /* PropertyDeclaration */:
            case 146 /* PropertySignature */:
            case 257 /* PropertyAssignment */:
            case 223 /* VariableDeclaration */:
            case 174 /* BindingElement */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.propertyName) ||
                    visitNode(cbNode, node.dotDotDotToken) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNode(cbNode, node.type) ||
                    visitNode(cbNode, node.initializer);
            case 158 /* FunctionType */:
            case 159 /* ConstructorType */:
            case 153 /* CallSignature */:
            case 154 /* ConstructSignature */:
            case 155 /* IndexSignature */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNodes(cbNodes, node.parameters) ||
                    visitNode(cbNode, node.type);
            case 149 /* MethodDeclaration */:
            case 148 /* MethodSignature */:
            case 150 /* Constructor */:
            case 151 /* GetAccessor */:
            case 152 /* SetAccessor */:
            case 184 /* FunctionExpression */:
            case 225 /* FunctionDeclaration */:
            case 185 /* ArrowFunction */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.asteriskToken) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNodes(cbNodes, node.parameters) ||
                    visitNode(cbNode, node.type) ||
                    visitNode(cbNode, node.equalsGreaterThanToken) ||
                    visitNode(cbNode, node.body);
            case 157 /* TypeReference */:
                return visitNode(cbNode, node.typeName) ||
                    visitNodes(cbNodes, node.typeArguments);
            case 156 /* TypePredicate */:
                return visitNode(cbNode, node.parameterName) ||
                    visitNode(cbNode, node.type);
            case 160 /* TypeQuery */:
                return visitNode(cbNode, node.exprName);
            case 161 /* TypeLiteral */:
                return visitNodes(cbNodes, node.members);
            case 162 /* ArrayType */:
                return visitNode(cbNode, node.elementType);
            case 163 /* TupleType */:
                return visitNodes(cbNodes, node.elementTypes);
            case 164 /* UnionType */:
            case 165 /* IntersectionType */:
                return visitNodes(cbNodes, node.types);
            case 166 /* ParenthesizedType */:
            case 168 /* TypeOperator */:
                return visitNode(cbNode, node.type);
            case 169 /* IndexedAccessType */:
                return visitNode(cbNode, node.objectType) ||
                    visitNode(cbNode, node.indexType);
            case 170 /* MappedType */:
                return visitNode(cbNode, node.readonlyToken) ||
                    visitNode(cbNode, node.typeParameter) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNode(cbNode, node.type);
            case 171 /* LiteralType */:
                return visitNode(cbNode, node.literal);
            case 172 /* ObjectBindingPattern */:
            case 173 /* ArrayBindingPattern */:
                return visitNodes(cbNodes, node.elements);
            case 175 /* ArrayLiteralExpression */:
                return visitNodes(cbNodes, node.elements);
            case 176 /* ObjectLiteralExpression */:
                return visitNodes(cbNodes, node.properties);
            case 177 /* PropertyAccessExpression */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.name);
            case 178 /* ElementAccessExpression */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.argumentExpression);
            case 179 /* CallExpression */:
            case 180 /* NewExpression */:
                return visitNode(cbNode, node.expression) ||
                    visitNodes(cbNodes, node.typeArguments) ||
                    visitNodes(cbNodes, node.arguments);
            case 181 /* TaggedTemplateExpression */:
                return visitNode(cbNode, node.tag) ||
                    visitNode(cbNode, node.template);
            case 182 /* TypeAssertionExpression */:
                return visitNode(cbNode, node.type) ||
                    visitNode(cbNode, node.expression);
            case 183 /* ParenthesizedExpression */:
                return visitNode(cbNode, node.expression);
            case 186 /* DeleteExpression */:
                return visitNode(cbNode, node.expression);
            case 187 /* TypeOfExpression */:
                return visitNode(cbNode, node.expression);
            case 188 /* VoidExpression */:
                return visitNode(cbNode, node.expression);
            case 190 /* PrefixUnaryExpression */:
                return visitNode(cbNode, node.operand);
            case 195 /* YieldExpression */:
                return visitNode(cbNode, node.asteriskToken) ||
                    visitNode(cbNode, node.expression);
            case 189 /* AwaitExpression */:
                return visitNode(cbNode, node.expression);
            case 191 /* PostfixUnaryExpression */:
                return visitNode(cbNode, node.operand);
            case 192 /* BinaryExpression */:
                return visitNode(cbNode, node.left) ||
                    visitNode(cbNode, node.operatorToken) ||
                    visitNode(cbNode, node.right);
            case 200 /* AsExpression */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.type);
            case 201 /* NonNullExpression */:
                return visitNode(cbNode, node.expression);
            case 193 /* ConditionalExpression */:
                return visitNode(cbNode, node.condition) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNode(cbNode, node.whenTrue) ||
                    visitNode(cbNode, node.colonToken) ||
                    visitNode(cbNode, node.whenFalse);
            case 196 /* SpreadElement */:
                return visitNode(cbNode, node.expression);
            case 204 /* Block */:
            case 231 /* ModuleBlock */:
                return visitNodes(cbNodes, node.statements);
            case 261 /* SourceFile */:
                return visitNodes(cbNodes, node.statements) ||
                    visitNode(cbNode, node.endOfFileToken);
            case 205 /* VariableStatement */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.declarationList);
            case 224 /* VariableDeclarationList */:
                return visitNodes(cbNodes, node.declarations);
            case 207 /* ExpressionStatement */:
                return visitNode(cbNode, node.expression);
            case 208 /* IfStatement */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.thenStatement) ||
                    visitNode(cbNode, node.elseStatement);
            case 209 /* DoStatement */:
                return visitNode(cbNode, node.statement) ||
                    visitNode(cbNode, node.expression);
            case 210 /* WhileStatement */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.statement);
            case 211 /* ForStatement */:
                return visitNode(cbNode, node.initializer) ||
                    visitNode(cbNode, node.condition) ||
                    visitNode(cbNode, node.incrementor) ||
                    visitNode(cbNode, node.statement);
            case 212 /* ForInStatement */:
                return visitNode(cbNode, node.initializer) ||
                    visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.statement);
            case 213 /* ForOfStatement */:
                return visitNode(cbNode, node.initializer) ||
                    visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.statement);
            case 214 /* ContinueStatement */:
            case 215 /* BreakStatement */:
                return visitNode(cbNode, node.label);
            case 216 /* ReturnStatement */:
                return visitNode(cbNode, node.expression);
            case 217 /* WithStatement */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.statement);
            case 218 /* SwitchStatement */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.caseBlock);
            case 232 /* CaseBlock */:
                return visitNodes(cbNodes, node.clauses);
            case 253 /* CaseClause */:
                return visitNode(cbNode, node.expression) ||
                    visitNodes(cbNodes, node.statements);
            case 254 /* DefaultClause */:
                return visitNodes(cbNodes, node.statements);
            case 219 /* LabeledStatement */:
                return visitNode(cbNode, node.label) ||
                    visitNode(cbNode, node.statement);
            case 220 /* ThrowStatement */:
                return visitNode(cbNode, node.expression);
            case 221 /* TryStatement */:
                return visitNode(cbNode, node.tryBlock) ||
                    visitNode(cbNode, node.catchClause) ||
                    visitNode(cbNode, node.finallyBlock);
            case 256 /* CatchClause */:
                return visitNode(cbNode, node.variableDeclaration) ||
                    visitNode(cbNode, node.block);
            case 145 /* Decorator */:
                return visitNode(cbNode, node.expression);
            case 226 /* ClassDeclaration */:
            case 197 /* ClassExpression */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNodes(cbNodes, node.heritageClauses) ||
                    visitNodes(cbNodes, node.members);
            case 227 /* InterfaceDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNodes(cbNodes, node.heritageClauses) ||
                    visitNodes(cbNodes, node.members);
            case 228 /* TypeAliasDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNode(cbNode, node.type);
            case 229 /* EnumDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.members);
            case 260 /* EnumMember */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.initializer);
            case 230 /* ModuleDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.body);
            case 234 /* ImportEqualsDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.moduleReference);
            case 235 /* ImportDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.importClause) ||
                    visitNode(cbNode, node.moduleSpecifier);
            case 236 /* ImportClause */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.namedBindings);
            case 233 /* NamespaceExportDeclaration */:
                return visitNode(cbNode, node.name);
            case 237 /* NamespaceImport */:
                return visitNode(cbNode, node.name);
            case 238 /* NamedImports */:
            case 242 /* NamedExports */:
                return visitNodes(cbNodes, node.elements);
            case 241 /* ExportDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.exportClause) ||
                    visitNode(cbNode, node.moduleSpecifier);
            case 239 /* ImportSpecifier */:
            case 243 /* ExportSpecifier */:
                return visitNode(cbNode, node.propertyName) ||
                    visitNode(cbNode, node.name);
            case 240 /* ExportAssignment */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.expression);
            case 194 /* TemplateExpression */:
                return visitNode(cbNode, node.head) || visitNodes(cbNodes, node.templateSpans);
            case 202 /* TemplateSpan */:
                return visitNode(cbNode, node.expression) || visitNode(cbNode, node.literal);
            case 142 /* ComputedPropertyName */:
                return visitNode(cbNode, node.expression);
            case 255 /* HeritageClause */:
                return visitNodes(cbNodes, node.types);
            case 199 /* ExpressionWithTypeArguments */:
                return visitNode(cbNode, node.expression) ||
                    visitNodes(cbNodes, node.typeArguments);
            case 245 /* ExternalModuleReference */:
                return visitNode(cbNode, node.expression);
            case 244 /* MissingDeclaration */:
                return visitNodes(cbNodes, node.decorators);
            case 246 /* JsxElement */:
                return visitNode(cbNode, node.openingElement) ||
                    visitNodes(cbNodes, node.children) ||
                    visitNode(cbNode, node.closingElement);
            case 247 /* JsxSelfClosingElement */:
            case 248 /* JsxOpeningElement */:
                return visitNode(cbNode, node.tagName) ||
                    visitNodes(cbNodes, node.attributes);
            case 250 /* JsxAttribute */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.initializer);
            case 251 /* JsxSpreadAttribute */:
                return visitNode(cbNode, node.expression);
            case 252 /* JsxExpression */:
                return visitNode(cbNode, node.expression);
            case 249 /* JsxClosingElement */:
                return visitNode(cbNode, node.tagName);
            case 262 /* JSDocTypeExpression */:
                return visitNode(cbNode, node.type);
            case 266 /* JSDocUnionType */:
                return visitNodes(cbNodes, node.types);
            case 267 /* JSDocTupleType */:
                return visitNodes(cbNodes, node.types);
            case 265 /* JSDocArrayType */:
                return visitNode(cbNode, node.elementType);
            case 269 /* JSDocNonNullableType */:
                return visitNode(cbNode, node.type);
            case 268 /* JSDocNullableType */:
                return visitNode(cbNode, node.type);
            case 270 /* JSDocRecordType */:
                return visitNode(cbNode, node.literal);
            case 272 /* JSDocTypeReference */:
                return visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.typeArguments);
            case 273 /* JSDocOptionalType */:
                return visitNode(cbNode, node.type);
            case 274 /* JSDocFunctionType */:
                return visitNodes(cbNodes, node.parameters) ||
                    visitNode(cbNode, node.type);
            case 275 /* JSDocVariadicType */:
                return visitNode(cbNode, node.type);
            case 276 /* JSDocConstructorType */:
                return visitNode(cbNode, node.type);
            case 277 /* JSDocThisType */:
                return visitNode(cbNode, node.type);
            case 271 /* JSDocRecordMember */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.type);
            case 278 /* JSDocComment */:
                return visitNodes(cbNodes, node.tags);
            case 281 /* JSDocParameterTag */:
                return visitNode(cbNode, node.preParameterName) ||
                    visitNode(cbNode, node.typeExpression) ||
                    visitNode(cbNode, node.postParameterName);
            case 282 /* JSDocReturnTag */:
                return visitNode(cbNode, node.typeExpression);
            case 283 /* JSDocTypeTag */:
                return visitNode(cbNode, node.typeExpression);
            case 280 /* JSDocAugmentsTag */:
                return visitNode(cbNode, node.typeExpression);
            case 284 /* JSDocTemplateTag */:
                return visitNodes(cbNodes, node.typeParameters);
            case 285 /* JSDocTypedefTag */:
                return visitNode(cbNode, node.typeExpression) ||
                    visitNode(cbNode, node.fullName) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.jsDocTypeLiteral);
            case 287 /* JSDocTypeLiteral */:
                return visitNodes(cbNodes, node.jsDocPropertyTags);
            case 286 /* JSDocPropertyTag */:
                return visitNode(cbNode, node.typeExpression) ||
                    visitNode(cbNode, node.name);
            case 294 /* PartiallyEmittedExpression */:
                return visitNode(cbNode, node.expression);
            case 288 /* JSDocLiteralType */:
                return visitNode(cbNode, node.literal);
        }
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{253,1} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{253,1} AS 1 AT <0:544>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{253,2} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{253,2} AS 2 AT <0:596>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{253,3} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{253,3} AS 3 AT <0:692>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{253,4} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{253,4} AS 4 AT <0:744>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{253,5} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{253,5} AS 5 AT <0:802>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{253,6} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{253,6} AS 6 AT <0:1658>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{253,7} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{253,7} AS 7 AT <0:1718>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{253,8} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{253,8} AS 8 AT <0:1777>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{253,9} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{253,9} AS 9 AT <0:1837>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{253,10} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{253,10} AS 10 AT <0:1899>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{253,11} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{253,11} AS 11 AT <0:1951>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{253,12} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{253,12} AS 12 AT <0:2012>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{253,13} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{253,13} AS 13 AT <0:2064>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{253,14} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{253,14} AS 14 AT <0:2341>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{253,15} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{253,15} AS 15 AT <0:2401>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{253,16} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{253,16} AS 16 AT <0:2460>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{253,17} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{253,17} AS 17 AT <0:2524>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{253,18} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{253,18} AS 18 AT <0:2584>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{253,19} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{253,19} AS 19 AT <0:2984>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{253,20} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{253,20} AS 20 AT <0:3044>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{253,21} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{253,21} AS 21 AT <0:3103>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{253,22} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{253,22} AS 22 AT <0:3164>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{253,23} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{253,23} AS 23 AT <0:3216>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{253,24} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{253,24} AS 24 AT <0:3277>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{253,25} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{253,25} AS 25 AT <0:3341>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{253,26} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{253,26} AS 26 AT <0:3401>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{253,27} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{253,27} AS 27 AT <0:3453>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{253,28} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{253,28} AS 28 AT <0:3523>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{253,29} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{253,29} AS 29 AT <0:3618>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{253,30} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{253,30} AS 30 AT <0:3674>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{253,31} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{253,31} AS 31 AT <0:3780>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{253,32} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{253,32} AS 32 AT <0:3841>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{253,33} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{253,33} AS 33 AT <0:3932>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{253,34} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{253,34} AS 34 AT <0:4029>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{253,35} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{253,35} AS 35 AT <0:4125>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{253,36} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{253,36} AS 36 AT <0:4223>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{253,37} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{253,37} AS 37 AT <0:4369>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{253,38} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{253,38} AS 38 AT <0:4512>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{253,39} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{253,39} AS 39 AT <0:4611>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{253,40} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{253,40} AS 40 AT <0:4669>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{253,41} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{253,41} AS 41 AT <0:4766>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{253,42} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{253,42} AS 42 AT <0:4827>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{253,43} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{253,43} AS 43 AT <0:4888>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{253,44} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{253,44} AS 44 AT <0:4949>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{253,45} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{253,45} AS 45 AT <0:5042>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{253,46} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{253,46} AS 46 AT <0:8393>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{253,47} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{253,47} AS 47 AT <0:8453>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{253,48} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{253,48} AS 48 AT <0:8562>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{253,49} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{253,49} AS 49 AT <0:8622>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{253,50} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{253,50} AS 50 AT <0:8681>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{253,51} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{253,51} AS 51 AT <0:8797>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{253,52} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{253,52} AS 52 AT <0:11956>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{253,53} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{253,53} AS 53 AT <0:12016>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{253,54} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{253,54} AS 54 AT <0:12075>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{253,55} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{253,55} AS 55 AT <0:12127>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{253,56} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{253,56} AS 56 AT <0:12191>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{253,57} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{253,57} AS 57 AT <0:12256>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{253,58} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{253,58} AS 58 AT <0:12363>
[deoptimizing (DEOPT lazy): begin 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> (opt #250) @181, FP to SP delta: 752, caller sp: 0x7fff5fbfd470]
  reading input frame forEachChild => node=2546, args=4, height=5; inputs:
      0: 0xd6230dc36a9 ; [fp - 16] 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>
      1: 0x16f3adb61821 ; [fp + 40] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x2f05bb8a8f49 ; [fp + 32] 0x2f05bb8a8f49 <a NodeObject with map 0x33abe2a68961>
      3: 0x2f05bb805f51 ; [fp + 24] 0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>
      4: 0x2f05bb804889 ; [fp + 16] 0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>
      5: 0xd6230d99249 ; [fp - 24] 0xd6230d99249 <FixedArray[15]>
      6: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      8: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      9: 0x30bcea404311 ; rax 0x30bcea404311 <undefined>
  translating frame forEachChild => node=2546, height=32
    0x7fff5fbfd468: [top + 88] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfd460: [top + 80] <- 0x2f05bb8a8f49 ;  0x2f05bb8a8f49 <a NodeObject with map 0x33abe2a68961>  (input #2)
    0x7fff5fbfd458: [top + 72] <- 0x2f05bb805f51 ;  0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>  (input #3)
    0x7fff5fbfd450: [top + 64] <- 0x2f05bb804889 ;  0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>  (input #4)
    0x7fff5fbfd448: [top + 56] <- 0x2c21d2577908 ;  caller's pc
    0x7fff5fbfd440: [top + 48] <- 0x7fff5fbfd4b8 ;  caller's fp
    0x7fff5fbfd438: [top + 40] <- 0xd6230d99249 ;  context    0xd6230d99249 <FixedArray[15]>  (input #5)
    0x7fff5fbfd430: [top + 32] <- 0xd6230dc36a9 ;  function    0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>  (input #0)
    0x7fff5fbfd428: [top + 24] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfd420: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #7)
    0x7fff5fbfd418: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #8)
    0x7fff5fbfd410: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
[deoptimizing (lazy): end 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> @181 => node=2546, pc=0x2c21d24c6fff, caller sp=0x7fff5fbfd470, state=TOS_REGISTER, took 0.087 ms]
[deoptimizing (DEOPT lazy): begin 0x2f05bb8047f9 <JS Function bindContainer (SharedFunctionInfo 0x16f3adb581e1)> (opt #232) @25, FP to SP delta: 168, caller sp: 0x7fff5fbfd5e0]
  reading input frame bindContainer => node=490, args=3, height=10; inputs:
      0: 0x2f05bb8047f9 ; [fp - 16] 0x2f05bb8047f9 <JS Function bindContainer (SharedFunctionInfo 0x16f3adb581e1)>
      1: 0x1f9f6c0532e1 ; [fp + 32] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2f05bb8a8f49 ; [fp + 24] 0x2f05bb8a8f49 <a NodeObject with map 0x33abe2a68961>
      3: 0x400000000 ; [fp + 16] 4
      4: 0xd6230dfeea1 ; [fp - 24] 0xd6230dfeea1 <FixedArray[147]>
      5: 0x2f05bb89ce69 ; [fp - 32] 0x2f05bb89ce69 <a NodeObject with map 0x33abe2a71231>
      6: 0x2f05bb89ce69 ; [fp - 40] 0x2f05bb89ce69 <a NodeObject with map 0x33abe2a71231>
      7: 0x141921205479 ; [fp - 88] 0x141921205479 <an Object with map 0x33abe2a51889>
      8: 0x30bcea404311 ; [fp - 96] 0x30bcea404311 <undefined>
      9: 0x30bcea404311 ; [fp - 104] 0x30bcea404311 <undefined>
     10: 0x30bcea404311 ; [fp - 112] 0x30bcea404311 <undefined>
     11: 0x30bcea404311 ; [fp - 120] 0x30bcea404311 <undefined>
     12: 0x30bcea404421 ; [fp - 128] 0x30bcea404421 <false>
     13: 0x00000000 ; [fp - 152] 0
  translating frame bindContainer => node=490, height=72
    0x7fff5fbfd5d8: [top + 120] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd5d0: [top + 112] <- 0x2f05bb8a8f49 ;  0x2f05bb8a8f49 <a NodeObject with map 0x33abe2a68961>  (input #2)
    0x7fff5fbfd5c8: [top + 104] <- 0x400000000 ;  4  (input #3)
    0x7fff5fbfd5c0: [top + 96] <- 0x2c21d254dd70 ;  caller's pc
    0x7fff5fbfd5b8: [top + 88] <- 0x7fff5fbfd608 ;  caller's fp
    0x7fff5fbfd5b0: [top + 80] <- 0xd6230dfeea1 ;  context    0xd6230dfeea1 <FixedArray[147]>  (input #4)
    0x7fff5fbfd5a8: [top + 72] <- 0x2f05bb8047f9 ;  function    0x2f05bb8047f9 <JS Function bindContainer (SharedFunctionInfo 0x16f3adb581e1)>  (input #0)
    0x7fff5fbfd5a0: [top + 64] <- 0x2f05bb89ce69 ;  0x2f05bb89ce69 <a NodeObject with map 0x33abe2a71231>  (input #5)
    0x7fff5fbfd598: [top + 56] <- 0x2f05bb89ce69 ;  0x2f05bb89ce69 <a NodeObject with map 0x33abe2a71231>  (input #6)
    0x7fff5fbfd590: [top + 48] <- 0x141921205479 ;  0x141921205479 <an Object with map 0x33abe2a51889>  (input #7)
    0x7fff5fbfd588: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfd580: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
    0x7fff5fbfd578: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #10)
    0x7fff5fbfd570: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #11)
    0x7fff5fbfd568: [top + 8] <- 0x30bcea404421 ;  0x30bcea404421 <false>  (input #12)
    0x7fff5fbfd560: [top + 0] <- 0x00000000 ;  0  (input #13)
[deoptimizing (lazy): end 0x2f05bb8047f9 <JS Function bindContainer (SharedFunctionInfo 0x16f3adb581e1)> @25 => node=490, pc=0x2c21d2546f8a, caller sp=0x7fff5fbfd5e0, state=NO_REGISTERS, took 0.077 ms]
[deoptimizing (DEOPT lazy): begin 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> (opt #250) @83, FP to SP delta: 752, caller sp: 0x7fff5fbfd988]
  reading input frame forEachChild => node=4394, args=4, height=5; inputs:
      0: 0xd6230dc36a9 ; [fp - 16] 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>
      1: 0x16f3adb61821 ; [fp + 40] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x2f05bb89ce69 ; [fp + 32] 0x2f05bb89ce69 <a NodeObject with map 0x33abe2a71231>
      3: 0x2f05bb805f51 ; [fp + 24] 0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>
      4: 0x2f05bb804889 ; [fp + 16] 0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>
      5: 0xd6230d99249 ; [fp - 24] 0xd6230d99249 <FixedArray[15]>
      6: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      8: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      9: 0x30bcea404311 ; rax 0x30bcea404311 <undefined>
  translating frame forEachChild => node=4394, height=32
    0x7fff5fbfd980: [top + 88] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfd978: [top + 80] <- 0x2f05bb89ce69 ;  0x2f05bb89ce69 <a NodeObject with map 0x33abe2a71231>  (input #2)
    0x7fff5fbfd970: [top + 72] <- 0x2f05bb805f51 ;  0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>  (input #3)
    0x7fff5fbfd968: [top + 64] <- 0x2f05bb804889 ;  0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>  (input #4)
    0x7fff5fbfd960: [top + 56] <- 0x2c21d2577908 ;  caller's pc
    0x7fff5fbfd958: [top + 48] <- 0x7fff5fbfd9d0 ;  caller's fp
    0x7fff5fbfd950: [top + 40] <- 0xd6230d99249 ;  context    0xd6230d99249 <FixedArray[15]>  (input #5)
    0x7fff5fbfd948: [top + 32] <- 0xd6230dc36a9 ;  function    0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>  (input #0)
    0x7fff5fbfd940: [top + 24] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfd938: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #7)
    0x7fff5fbfd930: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #8)
    0x7fff5fbfd928: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
[deoptimizing (lazy): end 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> @83 => node=4394, pc=0x2c21d24c89d8, caller sp=0x7fff5fbfd988, state=TOS_REGISTER, took 0.081 ms]
[deoptimizing (DEOPT lazy): begin 0x2f05bb8047f9 <JS Function bindContainer (SharedFunctionInfo 0x16f3adb581e1)> (opt #232) @9, FP to SP delta: 168, caller sp: 0x7fff5fbfdaf8]
  reading input frame bindContainer => node=924, args=3, height=10; inputs:
      0: 0x2f05bb8047f9 ; [fp - 16] 0x2f05bb8047f9 <JS Function bindContainer (SharedFunctionInfo 0x16f3adb581e1)>
      1: 0x1f9f6c0532e1 ; [fp + 32] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2f05bb89ce69 ; [fp + 24] 0x2f05bb89ce69 <a NodeObject with map 0x33abe2a71231>
      3: 0x2100000000 ; [fp + 16] 33
      4: 0xd6230dfeea1 ; [fp - 24] 0xd6230dfeea1 <FixedArray[147]>
      5: 0x2f05bb83a721 ; [fp - 32] 0x2f05bb83a721 <a SourceFileObject with map 0x33abe2a716a9>
      6: 0x2f05bb83a721 ; [fp - 40] 0x2f05bb83a721 <a SourceFileObject with map 0x33abe2a716a9>
      7: 0x30bcea404311 ; (literal 3) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; (literal 3) 0x30bcea404311 <undefined>
      9: 0x30bcea404311 ; (literal 3) 0x30bcea404311 <undefined>
     10: 0x30bcea404311 ; (literal 3) 0x30bcea404311 <undefined>
     11: 0x30bcea404311 ; (literal 3) 0x30bcea404311 <undefined>
     12: 0x30bcea404311 ; (literal 3) 0x30bcea404311 <undefined>
     13: 0x30bcea404311 ; (literal 3) 0x30bcea404311 <undefined>
  translating frame bindContainer => node=924, height=72
    0x7fff5fbfdaf0: [top + 120] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdae8: [top + 112] <- 0x2f05bb89ce69 ;  0x2f05bb89ce69 <a NodeObject with map 0x33abe2a71231>  (input #2)
    0x7fff5fbfdae0: [top + 104] <- 0x2100000000 ;  33  (input #3)
    0x7fff5fbfdad8: [top + 96] <- 0x2c21d254dd70 ;  caller's pc
    0x7fff5fbfdad0: [top + 88] <- 0x7fff5fbfdb20 ;  caller's fp
    0x7fff5fbfdac8: [top + 80] <- 0xd6230dfeea1 ;  context    0xd6230dfeea1 <FixedArray[147]>  (input #4)
    0x7fff5fbfdac0: [top + 72] <- 0x2f05bb8047f9 ;  function    0x2f05bb8047f9 <JS Function bindContainer (SharedFunctionInfo 0x16f3adb581e1)>  (input #0)
    0x7fff5fbfdab8: [top + 64] <- 0x2f05bb83a721 ;  0x2f05bb83a721 <a SourceFileObject with map 0x33abe2a716a9>  (input #5)
    0x7fff5fbfdab0: [top + 56] <- 0x2f05bb83a721 ;  0x2f05bb83a721 <a SourceFileObject with map 0x33abe2a716a9>  (input #6)
    0x7fff5fbfdaa8: [top + 48] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfdaa0: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfda98: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
    0x7fff5fbfda90: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #10)
    0x7fff5fbfda88: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #11)
    0x7fff5fbfda80: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #12)
    0x7fff5fbfda78: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #13)
[deoptimizing (lazy): end 0x2f05bb8047f9 <JS Function bindContainer (SharedFunctionInfo 0x16f3adb581e1)> @9 => node=924, pc=0x2c21d25475c5, caller sp=0x7fff5fbfdaf8, state=NO_REGISTERS, took 0.085 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:declareSymbolAndAddToSymbolTableWorker) id{254,0} ---
(node, symbolFlags, symbolExcludes) {
            switch (container.kind) {
                // Modules, source files, and classes need specialized handling for how their
                // members are declared (for example, a member of a class will go into a specific
                // symbol table depending on if it is static or not). We defer to specialized
                // handlers to take care of declaring these child members.
                case 230 /* ModuleDeclaration */:
                    return declareModuleMember(node, symbolFlags, symbolExcludes);
                case 261 /* SourceFile */:
                    return declareSourceFileMember(node, symbolFlags, symbolExcludes);
                case 197 /* ClassExpression */:
                case 226 /* ClassDeclaration */:
                    return declareClassMember(node, symbolFlags, symbolExcludes);
                case 229 /* EnumDeclaration */:
                    return declareSymbol(container.symbol.exports, container.symbol, node, symbolFlags, symbolExcludes);
                case 161 /* TypeLiteral */:
                case 176 /* ObjectLiteralExpression */:
                case 227 /* InterfaceDeclaration */:
                case 270 /* JSDocRecordType */:
                case 287 /* JSDocTypeLiteral */:
                    // Interface/Object-types always have their children added to the 'members' of
                    // their container. They are only accessible through an instance of their
                    // container, and are never in scope otherwise (even inside the body of the
                    // object / type / interface declaring them). An exception is type parameters,
                    // which are in scope without qualification (similar to 'locals').
                    return declareSymbol(container.symbol.members, container.symbol, node, symbolFlags, symbolExcludes);
                case 158 /* FunctionType */:
                case 159 /* ConstructorType */:
                case 153 /* CallSignature */:
                case 154 /* ConstructSignature */:
                case 155 /* IndexSignature */:
                case 149 /* MethodDeclaration */:
                case 148 /* MethodSignature */:
                case 150 /* Constructor */:
                case 151 /* GetAccessor */:
                case 152 /* SetAccessor */:
                case 225 /* FunctionDeclaration */:
                case 184 /* FunctionExpression */:
                case 185 /* ArrowFunction */:
                case 274 /* JSDocFunctionType */:
                case 228 /* TypeAliasDeclaration */:
                case 170 /* MappedType */:
                    // All the children of these container types are never visible through another
                    // symbol (i.e. through another symbol's 'exports' or 'members').  Instead,
                    // they're only accessed 'lexically' (i.e. from code that exists underneath
                    // their container in the tree.  To accomplish this, we simply add their declared
                    // symbol to the 'locals' of the container.  These symbols can then be found as
                    // the type checker walks up the containers, checking them for matching names.
                    return declareSymbol(container.locals, /*parent*/ undefined, node, symbolFlags, symbolExcludes);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:declareSourceFileMember) id{254,1} ---
(node, symbolFlags, symbolExcludes) {
            return ts.isExternalModule(file)
                ? declareModuleMember(node, symbolFlags, symbolExcludes)
                : declareSymbol(file.locals, undefined, node, symbolFlags, symbolExcludes);
        }
--- END ---
INLINE (declareSourceFileMember) id{254,1} AS 1 AT <0:640>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:declareClassMember) id{254,2} ---
(node, symbolFlags, symbolExcludes) {
            return ts.hasModifier(node, 32 /* Static */)
                ? declareSymbol(container.symbol.exports, container.symbol, node, symbolFlags, symbolExcludes)
                : declareSymbol(container.symbol.members, container.symbol, node, symbolFlags, symbolExcludes);
        }
--- END ---
INLINE (declareClassMember) id{254,2} AS 2 AT <0:824>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:addDeclarationToSymbol) id{255,0} ---
(symbol, node, symbolFlags) {
            symbol.flags |= symbolFlags;
            node.symbol = symbol;
            if (!symbol.declarations) {
                symbol.declarations = [];
            }
            symbol.declarations.push(node);
            if (symbolFlags & 1952 /* HasExports */ && !symbol.exports) {
                symbol.exports = ts.createMap();
            }
            if (symbolFlags & 6240 /* HasMembers */ && !symbol.members) {
                symbol.members = ts.createMap();
            }
            if (symbolFlags & 107455 /* Value */) {
                var valueDeclaration = symbol.valueDeclaration;
                if (!valueDeclaration ||
                    (valueDeclaration.kind !== node.kind && valueDeclaration.kind === 230 /* ModuleDeclaration */)) {
                    // other kinds of value declarations take precedence over modules
                    symbol.valueDeclaration = node;
                }
            }
        }
--- END ---
[deoptimizing (DEOPT soft): begin 0x2f05bb8046d9 <JS Function getDeclarationName (SharedFunctionInfo 0x16f3adb57ee1)> (opt #248) @18, FP to SP delta: 40, caller sp: 0x7fff5fbfd838]
            ;;; deoptimize at 0_174: Insufficient type feedback for generic named access
  reading input frame getDeclarationName => node=65, args=2, height=9; inputs:
      0: 0x2f05bb8046d9 ; [fp - 16] 0x2f05bb8046d9 <JS Function getDeclarationName (SharedFunctionInfo 0x16f3adb57ee1)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x35fa3c4370b9 ; [fp + 16] 0x35fa3c4370b9 <a NodeObject with map 0x33abe2a696c9>
      3: 0xd6230dfeea1 ; [fp - 24] 0xd6230dfeea1 <FixedArray[147]>
      4: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
      5: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
      6: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
      7: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
      9: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
     10: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
     11: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
  translating frame getDeclarationName => node=65, height=64
    0x7fff5fbfd830: [top + 104] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd828: [top + 96] <- 0x35fa3c4370b9 ;  0x35fa3c4370b9 <a NodeObject with map 0x33abe2a696c9>  (input #2)
    0x7fff5fbfd820: [top + 88] <- 0x2c21d257ece4 ;  caller's pc
    0x7fff5fbfd818: [top + 80] <- 0x7fff5fbfd888 ;  caller's fp
    0x7fff5fbfd810: [top + 72] <- 0xd6230dfeea1 ;  context    0xd6230dfeea1 <FixedArray[147]>  (input #3)
    0x7fff5fbfd808: [top + 64] <- 0x2f05bb8046d9 ;  function    0x2f05bb8046d9 <JS Function getDeclarationName (SharedFunctionInfo 0x16f3adb57ee1)>  (input #0)
    0x7fff5fbfd800: [top + 56] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfd7f8: [top + 48] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfd7f0: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfd7e8: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfd7e0: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfd7d8: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
    0x7fff5fbfd7d0: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #10)
    0x7fff5fbfd7c8: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #11)
[deoptimizing (soft): end 0x2f05bb8046d9 <JS Function getDeclarationName (SharedFunctionInfo 0x16f3adb57ee1)> @18 => node=65, pc=0x2c21d25237fe, caller sp=0x7fff5fbfd838, state=NO_REGISTERS, took 0.071 ms]
[deoptimizing (DEOPT soft): begin 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> (opt #253) @65, FP to SP delta: 760, caller sp: 0x7fff5fbfcfb8]
            ;;; deoptimize at 0_14899: Insufficient type feedback for generic named access
  reading input frame forEachChild => node=95, args=4, height=5; inputs:
      0: 0xd6230dc36a9 ; [fp - 16] 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>
      1: 0x16f3adb61821 ; [fp + 40] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x35fa3c442f01 ; [fp + 32] 0x35fa3c442f01 <a NodeObject with map 0x33abe2a68c21>
      3: 0x2f05bb805f51 ; [fp + 24] 0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>
      4: 0x2f05bb804889 ; [fp + 16] 0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>
      5: 0xd6230d99249 ; rbx 0xd6230d99249 <FixedArray[15]>
      6: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0xd6230dd5d69 ; rcx 0xd6230dd5d69 <JS Function visitNodeArray (SharedFunctionInfo 0x3504a53f0029)>
      8: 0x2f05bb804889 ; [fp - 40] 0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>
      9: 0xf100000000 ; rax 241
  translating frame forEachChild => node=95, height=32
    0x7fff5fbfcfb0: [top + 88] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfcfa8: [top + 80] <- 0x35fa3c442f01 ;  0x35fa3c442f01 <a NodeObject with map 0x33abe2a68c21>  (input #2)
    0x7fff5fbfcfa0: [top + 72] <- 0x2f05bb805f51 ;  0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>  (input #3)
    0x7fff5fbfcf98: [top + 64] <- 0x2f05bb804889 ;  0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>  (input #4)
    0x7fff5fbfcf90: [top + 56] <- 0x2c21d2577908 ;  caller's pc
    0x7fff5fbfcf88: [top + 48] <- 0x7fff5fbfd000 ;  caller's fp
    0x7fff5fbfcf80: [top + 40] <- 0xd6230d99249 ;  context    0xd6230d99249 <FixedArray[15]>  (input #5)
    0x7fff5fbfcf78: [top + 32] <- 0xd6230dc36a9 ;  function    0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>  (input #0)
    0x7fff5fbfcf70: [top + 24] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfcf68: [top + 16] <- 0xd6230dd5d69 ;  0xd6230dd5d69 <JS Function visitNodeArray (SharedFunctionInfo 0x3504a53f0029)>  (input #7)
    0x7fff5fbfcf60: [top + 8] <- 0x2f05bb804889 ;  0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>  (input #8)
    0x7fff5fbfcf58: [top + 0] <- 0xf100000000 ;  241  (input #9)
[deoptimizing (soft): end 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> @65 => node=95, pc=0x2c21d24c2f46, caller sp=0x7fff5fbfcfb8, state=NO_REGISTERS, took 0.089 ms]
[deoptimizer unlinked: forEachChild / d6230dc36a9]
[deoptimizing (DEOPT eager): begin 0xd6230dceca1 <JS Function isBindingPattern (SharedFunctionInfo 0x3504a53d8899)> (opt #230) @3, FP to SP delta: 24, caller sp: 0x7fff5fbfc9a8]
            ;;; deoptimize at 0_56: Unknown map in polymorphic access
  reading input frame isBindingPattern => node=9, args=2, height=2; inputs:
      0: 0xd6230dceca1 ; [fp - 16] 0xd6230dceca1 <JS Function isBindingPattern (SharedFunctionInfo 0x3504a53d8899)>
      1: 0x16f3adb61821 ; [fp + 24] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x35fa3c4786a9 ; rax 0x35fa3c4786a9 <a NodeObject with map 0x33abe2a68b71>
      3: 0xd6230db34c9 ; [fp - 24] 0xd6230db34c9 <FixedArray[156]>
      4: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
  translating frame isBindingPattern => node=9, height=8
    0x7fff5fbfc9a0: [top + 48] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfc998: [top + 40] <- 0x35fa3c4786a9 ;  0x35fa3c4786a9 <a NodeObject with map 0x33abe2a68b71>  (input #2)
    0x7fff5fbfc990: [top + 32] <- 0x2c21d23fe437 ;  caller's pc
    0x7fff5fbfc988: [top + 24] <- 0x7fff5fbfc9c0 ;  caller's fp
    0x7fff5fbfc980: [top + 16] <- 0xd6230db34c9 ;  context    0xd6230db34c9 <FixedArray[156]>  (input #3)
    0x7fff5fbfc978: [top + 8] <- 0xd6230dceca1 ;  function    0xd6230dceca1 <JS Function isBindingPattern (SharedFunctionInfo 0x3504a53d8899)>  (input #0)
    0x7fff5fbfc970: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
[deoptimizing (eager): end 0xd6230dceca1 <JS Function isBindingPattern (SharedFunctionInfo 0x3504a53d8899)> @3 => node=9, pc=0x2c21d23fdd4b, caller sp=0x7fff5fbfc9a8, state=NO_REGISTERS, took 0.055 ms]
[deoptimizing (DEOPT lazy): begin 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> (opt #253) @199, FP to SP delta: 760, caller sp: 0x7fff5fbfd4f8]
  reading input frame forEachChild => node=2546, args=4, height=5; inputs:
      0: 0xd6230dc36a9 ; [fp - 16] 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>
      1: 0x16f3adb61821 ; [fp + 40] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x35fa3c43bda1 ; [fp + 32] 0x35fa3c43bda1 <a NodeObject with map 0x33abe2a68961>
      3: 0x2f05bb805f51 ; [fp + 24] 0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>
      4: 0x2f05bb804889 ; [fp + 16] 0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>
      5: 0xd6230d99249 ; [fp - 24] 0xd6230d99249 <FixedArray[15]>
      6: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      8: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      9: 0x30bcea404311 ; rax 0x30bcea404311 <undefined>
  translating frame forEachChild => node=2546, height=32
    0x7fff5fbfd4f0: [top + 88] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfd4e8: [top + 80] <- 0x35fa3c43bda1 ;  0x35fa3c43bda1 <a NodeObject with map 0x33abe2a68961>  (input #2)
    0x7fff5fbfd4e0: [top + 72] <- 0x2f05bb805f51 ;  0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>  (input #3)
    0x7fff5fbfd4d8: [top + 64] <- 0x2f05bb804889 ;  0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>  (input #4)
    0x7fff5fbfd4d0: [top + 56] <- 0x2c21d2577908 ;  caller's pc
    0x7fff5fbfd4c8: [top + 48] <- 0x7fff5fbfd540 ;  caller's fp
    0x7fff5fbfd4c0: [top + 40] <- 0xd6230d99249 ;  context    0xd6230d99249 <FixedArray[15]>  (input #5)
    0x7fff5fbfd4b8: [top + 32] <- 0xd6230dc36a9 ;  function    0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>  (input #0)
    0x7fff5fbfd4b0: [top + 24] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfd4a8: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #7)
    0x7fff5fbfd4a0: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #8)
    0x7fff5fbfd498: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
[deoptimizing (lazy): end 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> @199 => node=2546, pc=0x2c21d24c6fff, caller sp=0x7fff5fbfd4f8, state=TOS_REGISTER, took 0.081 ms]
[deoptimizing (DEOPT lazy): begin 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> (opt #253) @84, FP to SP delta: 760, caller sp: 0x7fff5fbfd9d0]
  reading input frame forEachChild => node=4394, args=4, height=5; inputs:
      0: 0xd6230dc36a9 ; [fp - 16] 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>
      1: 0x16f3adb61821 ; [fp + 40] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x35fa3c4370b9 ; [fp + 32] 0x35fa3c4370b9 <a NodeObject with map 0x33abe2a71129>
      3: 0x2f05bb805f51 ; [fp + 24] 0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>
      4: 0x2f05bb804889 ; [fp + 16] 0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>
      5: 0xd6230d99249 ; [fp - 24] 0xd6230d99249 <FixedArray[15]>
      6: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      8: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      9: 0x30bcea404311 ; rax 0x30bcea404311 <undefined>
  translating frame forEachChild => node=4394, height=32
    0x7fff5fbfd9c8: [top + 88] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfd9c0: [top + 80] <- 0x35fa3c4370b9 ;  0x35fa3c4370b9 <a NodeObject with map 0x33abe2a71129>  (input #2)
    0x7fff5fbfd9b8: [top + 72] <- 0x2f05bb805f51 ;  0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>  (input #3)
    0x7fff5fbfd9b0: [top + 64] <- 0x2f05bb804889 ;  0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>  (input #4)
    0x7fff5fbfd9a8: [top + 56] <- 0x2c21d2577908 ;  caller's pc
    0x7fff5fbfd9a0: [top + 48] <- 0x7fff5fbfda18 ;  caller's fp
    0x7fff5fbfd998: [top + 40] <- 0xd6230d99249 ;  context    0xd6230d99249 <FixedArray[15]>  (input #5)
    0x7fff5fbfd990: [top + 32] <- 0xd6230dc36a9 ;  function    0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>  (input #0)
    0x7fff5fbfd988: [top + 24] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfd980: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #7)
    0x7fff5fbfd978: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #8)
    0x7fff5fbfd970: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
[deoptimizing (lazy): end 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> @84 => node=4394, pc=0x2c21d24c89d8, caller sp=0x7fff5fbfd9d0, state=TOS_REGISTER, took 0.073 ms]
[deoptimizing (DEOPT soft): begin 0x2f05bb806029 <JS Function bindWorker (SharedFunctionInfo 0x16f3adb5c261)> (opt #251) @131, FP to SP delta: 248, caller sp: 0x7fff5fbfcee8]
            ;;; deoptimize at 0_1349: Insufficient type feedback for generic named access
  reading input frame bindWorker => node=248, args=2, height=7; inputs:
      0: 0x2f05bb806029 ; [fp - 16] 0x2f05bb806029 <JS Function bindWorker (SharedFunctionInfo 0x16f3adb5c261)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x35fa3c4a9be1 ; [fp + 16] 0x35fa3c4a9be1 <a NodeObject with map 0x33abe2a68c79>
      3: 0xd6230dfeea1 ; rbx 0xd6230dfeea1 <FixedArray[147]>
      4: 0x30bcea4069a9 ; (literal 20) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      5: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
      6: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
      7: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
      9: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
  translating frame bindWorker => node=248, height=48
    0x7fff5fbfcee0: [top + 88] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfced8: [top + 80] <- 0x35fa3c4a9be1 ;  0x35fa3c4a9be1 <a NodeObject with map 0x33abe2a68c79>  (input #2)
    0x7fff5fbfced0: [top + 72] <- 0x2c21d254dc06 ;  caller's pc
    0x7fff5fbfcec8: [top + 64] <- 0x7fff5fbfcf10 ;  caller's fp
    0x7fff5fbfcec0: [top + 56] <- 0xd6230dfeea1 ;  context    0xd6230dfeea1 <FixedArray[147]>  (input #3)
    0x7fff5fbfceb8: [top + 48] <- 0x2f05bb806029 ;  function    0x2f05bb806029 <JS Function bindWorker (SharedFunctionInfo 0x16f3adb5c261)>  (input #0)
    0x7fff5fbfceb0: [top + 40] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #4)
    0x7fff5fbfcea8: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfcea0: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfce98: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfce90: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfce88: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
[deoptimizing (soft): end 0x2f05bb806029 <JS Function bindWorker (SharedFunctionInfo 0x16f3adb5c261)> @131 => node=248, pc=0x2c21d2543a4b, caller sp=0x7fff5fbfcee8, state=NO_REGISTERS, took 0.064 ms]
[marking dependent code 0x2c21d2518601 (opt #190) for deoptimization, reason: prototype-check]
[marking dependent code 0x2c21d25743a1 (opt #221) for deoptimization, reason: prototype-check]
[deoptimize marked code in all contexts]
[deoptimizer unlinked: collectModuleReferences / 29cc38d068f9]
[deoptimizing (DEOPT eager): begin 0x2f05bb804691 <JS Function addDeclarationToSymbol (SharedFunctionInfo 0x16f3adb57e21)> (opt #255) @16, FP to SP delta: 56, caller sp: 0x7fff5fbfd370]
            ;;; deoptimize at 0_307: wrong map
  reading input frame addDeclarationToSymbol => node=120, args=4, height=2; inputs:
      0: 0x2f05bb804691 ; [fp - 16] 0x2f05bb804691 <JS Function addDeclarationToSymbol (SharedFunctionInfo 0x16f3adb57e21)>
      1: 0x1f9f6c0532e1 ; [fp + 40] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x141921271d99 ; rbx 0x141921271d99 <a SymbolObject with map 0x33abe2a717b1>
      3: 0x35fa3c443381 ; [fp + 24] 0x35fa3c443381 <a NodeObject with map 0x33abe2a70f71>
      4: 0x20000000000 ; [fp + 16] 512
      5: 0xd6230dfeea1 ; [fp - 24] 0xd6230dfeea1 <FixedArray[147]>
      6: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
  translating frame addDeclarationToSymbol => node=120, height=8
    0x7fff5fbfd368: [top + 64] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd360: [top + 56] <- 0x141921271d99 ;  0x141921271d99 <a SymbolObject with map 0x33abe2a717b1>  (input #2)
    0x7fff5fbfd358: [top + 48] <- 0x35fa3c443381 ;  0x35fa3c443381 <a NodeObject with map 0x33abe2a70f71>  (input #3)
    0x7fff5fbfd350: [top + 40] <- 0x20000000000 ;  512  (input #4)
    0x7fff5fbfd348: [top + 32] <- 0x2c21d257f06d ;  caller's pc
    0x7fff5fbfd340: [top + 24] <- 0x7fff5fbfd3c0 ;  caller's fp
    0x7fff5fbfd338: [top + 16] <- 0xd6230dfeea1 ;  context    0xd6230dfeea1 <FixedArray[147]>  (input #5)
    0x7fff5fbfd330: [top + 8] <- 0x2f05bb804691 ;  function    0x2f05bb804691 <JS Function addDeclarationToSymbol (SharedFunctionInfo 0x16f3adb57e21)>  (input #0)
    0x7fff5fbfd328: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
[deoptimizing (eager): end 0x2f05bb804691 <JS Function addDeclarationToSymbol (SharedFunctionInfo 0x16f3adb57e21)> @16 => node=120, pc=0x2c21d2524ad8, caller sp=0x7fff5fbfd370, state=NO_REGISTERS, took 0.068 ms]
[deoptimizing (DEOPT soft): begin 0x2f05bb805771 <JS Function declareSymbolAndAddToSymbolTableWorker (SharedFunctionInfo 0x16f3adb5ab21)> (opt #254) @21, FP to SP delta: 64, caller sp: 0x7fff5fbfccf8]
            ;;; deoptimize at 2_136: Insufficient type feedback for generic named access
  reading input frame declareSymbolAndAddToSymbolTableWorker => node=101, args=4, height=3; inputs:
      0: 0x2f05bb805771 ; [fp - 16] 0x2f05bb805771 <JS Function declareSymbolAndAddToSymbolTableWorker (SharedFunctionInfo 0x16f3adb5ab21)>
      1: 0x1f9f6c0532e1 ; [fp + 40] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x35fa3c4a9d21 ; [fp + 32] 0x35fa3c4a9d21 <a NodeObject with map 0x33abe2a68801>
      3: 0x200000000000 ; [fp + 24] 8192
      4: 0x183bf00000000 ; [fp + 16] 99263
      5: 0xd6230dfeea1 ; [fp - 24] 0xd6230dfeea1 <FixedArray[147]>
      6: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x2f05bb8057b9 ; [fp - 32] 0x2f05bb8057b9 <JS Function declareClassMember (SharedFunctionInfo 0x16f3adb5abe1)>
  reading input frame declareClassMember => node=7, args=4, height=1; inputs:
      0: 0x2f05bb8057b9 ; (literal 7) 0x2f05bb8057b9 <JS Function declareClassMember (SharedFunctionInfo 0x16f3adb5abe1)>
      1: 0x1f9f6c0532e1 ; (literal 8) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x35fa3c4a9d21 ; [fp + 32] 0x35fa3c4a9d21 <a NodeObject with map 0x33abe2a68801>
      3: 0x200000000000 ; [fp + 24] 8192
      4: 0x183bf00000000 ; [fp + 16] 99263
      5: 0xd6230dfeea1 ; (literal 9) 0xd6230dfeea1 <FixedArray[147]>
  translating frame declareSymbolAndAddToSymbolTableWorker => node=101, height=16
    0x7fff5fbfccf0: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfcce8: [top + 64] <- 0x35fa3c4a9d21 ;  0x35fa3c4a9d21 <a NodeObject with map 0x33abe2a68801>  (input #2)
    0x7fff5fbfcce0: [top + 56] <- 0x200000000000 ;  8192  (input #3)
    0x7fff5fbfccd8: [top + 48] <- 0x183bf00000000 ;  99263  (input #4)
    0x7fff5fbfccd0: [top + 40] <- 0x2c21d25556ed ;  caller's pc
    0x7fff5fbfccc8: [top + 32] <- 0x7fff5fbfcd40 ;  caller's fp
    0x7fff5fbfccc0: [top + 24] <- 0xd6230dfeea1 ;  context    0xd6230dfeea1 <FixedArray[147]>  (input #5)
    0x7fff5fbfccb8: [top + 16] <- 0x2f05bb805771 ;  function    0x2f05bb805771 <JS Function declareSymbolAndAddToSymbolTableWorker (SharedFunctionInfo 0x16f3adb5ab21)>  (input #0)
    0x7fff5fbfccb0: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfcca8: [top + 0] <- 0x2f05bb8057b9 ;  0x2f05bb8057b9 <JS Function declareClassMember (SharedFunctionInfo 0x16f3adb5abe1)>  (input #7)
  translating frame declareClassMember => node=7, height=0
    0x7fff5fbfcca0: [top + 56] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfcc98: [top + 48] <- 0x35fa3c4a9d21 ;  0x35fa3c4a9d21 <a NodeObject with map 0x33abe2a68801>  (input #2)
    0x7fff5fbfcc90: [top + 40] <- 0x200000000000 ;  8192  (input #3)
    0x7fff5fbfcc88: [top + 32] <- 0x183bf00000000 ;  99263  (input #4)
    0x7fff5fbfcc80: [top + 24] <- 0x2c21d2526f53 ;  caller's pc
    0x7fff5fbfcc78: [top + 16] <- 0x7fff5fbfccc8 ;  caller's fp
    0x7fff5fbfcc70: [top + 8] <- 0xd6230dfeea1 ;  context    0xd6230dfeea1 <FixedArray[147]>  (input #5)
    0x7fff5fbfcc68: [top + 0] <- 0x2f05bb8057b9 ;  function    0x2f05bb8057b9 <JS Function declareClassMember (SharedFunctionInfo 0x16f3adb5abe1)>  (input #0)
[deoptimizing (soft): end 0x2f05bb805771 <JS Function declareSymbolAndAddToSymbolTableWorker (SharedFunctionInfo 0x16f3adb5ab21)> @21 => node=7, pc=0x2c21d25a489e, caller sp=0x7fff5fbfccf8, state=NO_REGISTERS, took 0.103 ms]
[deoptimizing (DEOPT soft): begin 0x2f05bb805699 <JS Function getContainerFlags (SharedFunctionInfo 0x16f3adb5a8e1)> (opt #205) @4, FP to SP delta: 40, caller sp: 0x7fff5fbfcdd8]
            ;;; deoptimize at 0_2333: Insufficient type feedback for generic named access
  reading input frame getContainerFlags => node=30, args=2, height=3; inputs:
      0: 0x2f05bb805699 ; [fp - 16] 0x2f05bb805699 <JS Function getContainerFlags (SharedFunctionInfo 0x16f3adb5a8e1)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x35fa3c4a9da1 ; [fp + 16] 0x35fa3c4a9da1 <a NodeObject with map 0x33abe2a71c29>
      3: 0xd6230dfeea1 ; [fp - 24] 0xd6230dfeea1 <FixedArray[147]>
      4: 0x30bcea4069a9 ; (literal 2) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      5: 0x9300000000 ; rax 147
  translating frame getContainerFlags => node=30, height=16
    0x7fff5fbfcdd0: [top + 56] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfcdc8: [top + 48] <- 0x35fa3c4a9da1 ;  0x35fa3c4a9da1 <a NodeObject with map 0x33abe2a71c29>  (input #2)
    0x7fff5fbfcdc0: [top + 40] <- 0x2c21d254dd0c ;  caller's pc
    0x7fff5fbfcdb8: [top + 32] <- 0x7fff5fbfce00 ;  caller's fp
    0x7fff5fbfcdb0: [top + 24] <- 0xd6230dfeea1 ;  context    0xd6230dfeea1 <FixedArray[147]>  (input #3)
    0x7fff5fbfcda8: [top + 16] <- 0x2f05bb805699 ;  function    0x2f05bb805699 <JS Function getContainerFlags (SharedFunctionInfo 0x16f3adb5a8e1)>  (input #0)
    0x7fff5fbfcda0: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #4)
    0x7fff5fbfcd98: [top + 0] <- 0x9300000000 ;  147  (input #5)
[deoptimizing (soft): end 0x2f05bb805699 <JS Function getContainerFlags (SharedFunctionInfo 0x16f3adb5a8e1)> @4 => node=30, pc=0x2c21d2545ea3, caller sp=0x7fff5fbfcdd8, state=NO_REGISTERS, took 0.058 ms]
[deoptimizing (DEOPT eager): begin 0xd6230dcc5f9 <JS Function isObjectLiteralOrClassExpressionMethod (SharedFunctionInfo 0x3504a53cf119)> (opt #252) @3, FP to SP delta: 24, caller sp: 0x7fff5fbfd208]
            ;;; deoptimize at 0_86: wrong map
  reading input frame isObjectLiteralOrClassExpressionMethod => node=9, args=2, height=2; inputs:
      0: 0xd6230dcc5f9 ; [fp - 16] 0xd6230dcc5f9 <JS Function isObjectLiteralOrClassExpressionMethod (SharedFunctionInfo 0x3504a53cf119)>
      1: 0x16f3adb61821 ; [fp + 24] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x35fa3c442709 ; rbx 0x35fa3c442709 <a NodeObject with map 0x33abe2a691f9>
      3: 0xd6230db34c9 ; [fp - 24] 0xd6230db34c9 <FixedArray[156]>
      4: 0x30bcea4043b1 ; rax 0x30bcea4043b1 <true>
  translating frame isObjectLiteralOrClassExpressionMethod => node=9, height=8
    0x7fff5fbfd200: [top + 48] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfd1f8: [top + 40] <- 0x35fa3c442709 ;  0x35fa3c442709 <a NodeObject with map 0x33abe2a691f9>  (input #2)
    0x7fff5fbfd1f0: [top + 32] <- 0x2c21d25555d3 ;  caller's pc
    0x7fff5fbfd1e8: [top + 24] <- 0x7fff5fbfd250 ;  caller's fp
    0x7fff5fbfd1e0: [top + 16] <- 0xd6230db34c9 ;  context    0xd6230db34c9 <FixedArray[156]>  (input #3)
    0x7fff5fbfd1d8: [top + 8] <- 0xd6230dcc5f9 ;  function    0xd6230dcc5f9 <JS Function isObjectLiteralOrClassExpressionMethod (SharedFunctionInfo 0x3504a53cf119)>  (input #0)
    0x7fff5fbfd1d0: [top + 0] <- 0x30bcea4043b1 ;  0x30bcea4043b1 <true>  (input #4)
[deoptimizing (eager): end 0xd6230dcc5f9 <JS Function isObjectLiteralOrClassExpressionMethod (SharedFunctionInfo 0x3504a53cf119)> @3 => node=9, pc=0x2c21d2549b89, caller sp=0x7fff5fbfd208, state=TOS_REGISTER, took 0.065 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:forEachChild) id{256,0} ---
(node, cbNode, cbNodeArray) {
        if (!node) {
            return;
        }
        // The visitXXX functions could be written as local functions that close over the cbNode and cbNodeArray
        // callback parameters, but that causes a closure allocation for each invocation with noticeable effects
        // on performance.
        var visitNodes = cbNodeArray ? visitNodeArray : visitEachNode;
        var cbNodes = cbNodeArray || cbNode;
        switch (node.kind) {
            case 141 /* QualifiedName */:
                return visitNode(cbNode, node.left) ||
                    visitNode(cbNode, node.right);
            case 143 /* TypeParameter */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.constraint) ||
                    visitNode(cbNode, node.expression);
            case 258 /* ShorthandPropertyAssignment */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNode(cbNode, node.equalsToken) ||
                    visitNode(cbNode, node.objectAssignmentInitializer);
            case 259 /* SpreadAssignment */:
                return visitNode(cbNode, node.expression);
            case 144 /* Parameter */:
            case 147 /* PropertyDeclaration */:
            case 146 /* PropertySignature */:
            case 257 /* PropertyAssignment */:
            case 223 /* VariableDeclaration */:
            case 174 /* BindingElement */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.propertyName) ||
                    visitNode(cbNode, node.dotDotDotToken) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNode(cbNode, node.type) ||
                    visitNode(cbNode, node.initializer);
            case 158 /* FunctionType */:
            case 159 /* ConstructorType */:
            case 153 /* CallSignature */:
            case 154 /* ConstructSignature */:
            case 155 /* IndexSignature */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNodes(cbNodes, node.parameters) ||
                    visitNode(cbNode, node.type);
            case 149 /* MethodDeclaration */:
            case 148 /* MethodSignature */:
            case 150 /* Constructor */:
            case 151 /* GetAccessor */:
            case 152 /* SetAccessor */:
            case 184 /* FunctionExpression */:
            case 225 /* FunctionDeclaration */:
            case 185 /* ArrowFunction */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.asteriskToken) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNodes(cbNodes, node.parameters) ||
                    visitNode(cbNode, node.type) ||
                    visitNode(cbNode, node.equalsGreaterThanToken) ||
                    visitNode(cbNode, node.body);
            case 157 /* TypeReference */:
                return visitNode(cbNode, node.typeName) ||
                    visitNodes(cbNodes, node.typeArguments);
            case 156 /* TypePredicate */:
                return visitNode(cbNode, node.parameterName) ||
                    visitNode(cbNode, node.type);
            case 160 /* TypeQuery */:
                return visitNode(cbNode, node.exprName);
            case 161 /* TypeLiteral */:
                return visitNodes(cbNodes, node.members);
            case 162 /* ArrayType */:
                return visitNode(cbNode, node.elementType);
            case 163 /* TupleType */:
                return visitNodes(cbNodes, node.elementTypes);
            case 164 /* UnionType */:
            case 165 /* IntersectionType */:
                return visitNodes(cbNodes, node.types);
            case 166 /* ParenthesizedType */:
            case 168 /* TypeOperator */:
                return visitNode(cbNode, node.type);
            case 169 /* IndexedAccessType */:
                return visitNode(cbNode, node.objectType) ||
                    visitNode(cbNode, node.indexType);
            case 170 /* MappedType */:
                return visitNode(cbNode, node.readonlyToken) ||
                    visitNode(cbNode, node.typeParameter) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNode(cbNode, node.type);
            case 171 /* LiteralType */:
                return visitNode(cbNode, node.literal);
            case 172 /* ObjectBindingPattern */:
            case 173 /* ArrayBindingPattern */:
                return visitNodes(cbNodes, node.elements);
            case 175 /* ArrayLiteralExpression */:
                return visitNodes(cbNodes, node.elements);
            case 176 /* ObjectLiteralExpression */:
                return visitNodes(cbNodes, node.properties);
            case 177 /* PropertyAccessExpression */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.name);
            case 178 /* ElementAccessExpression */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.argumentExpression);
            case 179 /* CallExpression */:
            case 180 /* NewExpression */:
                return visitNode(cbNode, node.expression) ||
                    visitNodes(cbNodes, node.typeArguments) ||
                    visitNodes(cbNodes, node.arguments);
            case 181 /* TaggedTemplateExpression */:
                return visitNode(cbNode, node.tag) ||
                    visitNode(cbNode, node.template);
            case 182 /* TypeAssertionExpression */:
                return visitNode(cbNode, node.type) ||
                    visitNode(cbNode, node.expression);
            case 183 /* ParenthesizedExpression */:
                return visitNode(cbNode, node.expression);
            case 186 /* DeleteExpression */:
                return visitNode(cbNode, node.expression);
            case 187 /* TypeOfExpression */:
                return visitNode(cbNode, node.expression);
            case 188 /* VoidExpression */:
                return visitNode(cbNode, node.expression);
            case 190 /* PrefixUnaryExpression */:
                return visitNode(cbNode, node.operand);
            case 195 /* YieldExpression */:
                return visitNode(cbNode, node.asteriskToken) ||
                    visitNode(cbNode, node.expression);
            case 189 /* AwaitExpression */:
                return visitNode(cbNode, node.expression);
            case 191 /* PostfixUnaryExpression */:
                return visitNode(cbNode, node.operand);
            case 192 /* BinaryExpression */:
                return visitNode(cbNode, node.left) ||
                    visitNode(cbNode, node.operatorToken) ||
                    visitNode(cbNode, node.right);
            case 200 /* AsExpression */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.type);
            case 201 /* NonNullExpression */:
                return visitNode(cbNode, node.expression);
            case 193 /* ConditionalExpression */:
                return visitNode(cbNode, node.condition) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNode(cbNode, node.whenTrue) ||
                    visitNode(cbNode, node.colonToken) ||
                    visitNode(cbNode, node.whenFalse);
            case 196 /* SpreadElement */:
                return visitNode(cbNode, node.expression);
            case 204 /* Block */:
            case 231 /* ModuleBlock */:
                return visitNodes(cbNodes, node.statements);
            case 261 /* SourceFile */:
                return visitNodes(cbNodes, node.statements) ||
                    visitNode(cbNode, node.endOfFileToken);
            case 205 /* VariableStatement */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.declarationList);
            case 224 /* VariableDeclarationList */:
                return visitNodes(cbNodes, node.declarations);
            case 207 /* ExpressionStatement */:
                return visitNode(cbNode, node.expression);
            case 208 /* IfStatement */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.thenStatement) ||
                    visitNode(cbNode, node.elseStatement);
            case 209 /* DoStatement */:
                return visitNode(cbNode, node.statement) ||
                    visitNode(cbNode, node.expression);
            case 210 /* WhileStatement */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.statement);
            case 211 /* ForStatement */:
                return visitNode(cbNode, node.initializer) ||
                    visitNode(cbNode, node.condition) ||
                    visitNode(cbNode, node.incrementor) ||
                    visitNode(cbNode, node.statement);
            case 212 /* ForInStatement */:
                return visitNode(cbNode, node.initializer) ||
                    visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.statement);
            case 213 /* ForOfStatement */:
                return visitNode(cbNode, node.initializer) ||
                    visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.statement);
            case 214 /* ContinueStatement */:
            case 215 /* BreakStatement */:
                return visitNode(cbNode, node.label);
            case 216 /* ReturnStatement */:
                return visitNode(cbNode, node.expression);
            case 217 /* WithStatement */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.statement);
            case 218 /* SwitchStatement */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.caseBlock);
            case 232 /* CaseBlock */:
                return visitNodes(cbNodes, node.clauses);
            case 253 /* CaseClause */:
                return visitNode(cbNode, node.expression) ||
                    visitNodes(cbNodes, node.statements);
            case 254 /* DefaultClause */:
                return visitNodes(cbNodes, node.statements);
            case 219 /* LabeledStatement */:
                return visitNode(cbNode, node.label) ||
                    visitNode(cbNode, node.statement);
            case 220 /* ThrowStatement */:
                return visitNode(cbNode, node.expression);
            case 221 /* TryStatement */:
                return visitNode(cbNode, node.tryBlock) ||
                    visitNode(cbNode, node.catchClause) ||
                    visitNode(cbNode, node.finallyBlock);
            case 256 /* CatchClause */:
                return visitNode(cbNode, node.variableDeclaration) ||
                    visitNode(cbNode, node.block);
            case 145 /* Decorator */:
                return visitNode(cbNode, node.expression);
            case 226 /* ClassDeclaration */:
            case 197 /* ClassExpression */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNodes(cbNodes, node.heritageClauses) ||
                    visitNodes(cbNodes, node.members);
            case 227 /* InterfaceDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNodes(cbNodes, node.heritageClauses) ||
                    visitNodes(cbNodes, node.members);
            case 228 /* TypeAliasDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNode(cbNode, node.type);
            case 229 /* EnumDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.members);
            case 260 /* EnumMember */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.initializer);
            case 230 /* ModuleDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.body);
            case 234 /* ImportEqualsDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.moduleReference);
            case 235 /* ImportDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.importClause) ||
                    visitNode(cbNode, node.moduleSpecifier);
            case 236 /* ImportClause */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.namedBindings);
            case 233 /* NamespaceExportDeclaration */:
                return visitNode(cbNode, node.name);
            case 237 /* NamespaceImport */:
                return visitNode(cbNode, node.name);
            case 238 /* NamedImports */:
            case 242 /* NamedExports */:
                return visitNodes(cbNodes, node.elements);
            case 241 /* ExportDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.exportClause) ||
                    visitNode(cbNode, node.moduleSpecifier);
            case 239 /* ImportSpecifier */:
            case 243 /* ExportSpecifier */:
                return visitNode(cbNode, node.propertyName) ||
                    visitNode(cbNode, node.name);
            case 240 /* ExportAssignment */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.expression);
            case 194 /* TemplateExpression */:
                return visitNode(cbNode, node.head) || visitNodes(cbNodes, node.templateSpans);
            case 202 /* TemplateSpan */:
                return visitNode(cbNode, node.expression) || visitNode(cbNode, node.literal);
            case 142 /* ComputedPropertyName */:
                return visitNode(cbNode, node.expression);
            case 255 /* HeritageClause */:
                return visitNodes(cbNodes, node.types);
            case 199 /* ExpressionWithTypeArguments */:
                return visitNode(cbNode, node.expression) ||
                    visitNodes(cbNodes, node.typeArguments);
            case 245 /* ExternalModuleReference */:
                return visitNode(cbNode, node.expression);
            case 244 /* MissingDeclaration */:
                return visitNodes(cbNodes, node.decorators);
            case 246 /* JsxElement */:
                return visitNode(cbNode, node.openingElement) ||
                    visitNodes(cbNodes, node.children) ||
                    visitNode(cbNode, node.closingElement);
            case 247 /* JsxSelfClosingElement */:
            case 248 /* JsxOpeningElement */:
                return visitNode(cbNode, node.tagName) ||
                    visitNodes(cbNodes, node.attributes);
            case 250 /* JsxAttribute */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.initializer);
            case 251 /* JsxSpreadAttribute */:
                return visitNode(cbNode, node.expression);
            case 252 /* JsxExpression */:
                return visitNode(cbNode, node.expression);
            case 249 /* JsxClosingElement */:
                return visitNode(cbNode, node.tagName);
            case 262 /* JSDocTypeExpression */:
                return visitNode(cbNode, node.type);
            case 266 /* JSDocUnionType */:
                return visitNodes(cbNodes, node.types);
            case 267 /* JSDocTupleType */:
                return visitNodes(cbNodes, node.types);
            case 265 /* JSDocArrayType */:
                return visitNode(cbNode, node.elementType);
            case 269 /* JSDocNonNullableType */:
                return visitNode(cbNode, node.type);
            case 268 /* JSDocNullableType */:
                return visitNode(cbNode, node.type);
            case 270 /* JSDocRecordType */:
                return visitNode(cbNode, node.literal);
            case 272 /* JSDocTypeReference */:
                return visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.typeArguments);
            case 273 /* JSDocOptionalType */:
                return visitNode(cbNode, node.type);
            case 274 /* JSDocFunctionType */:
                return visitNodes(cbNodes, node.parameters) ||
                    visitNode(cbNode, node.type);
            case 275 /* JSDocVariadicType */:
                return visitNode(cbNode, node.type);
            case 276 /* JSDocConstructorType */:
                return visitNode(cbNode, node.type);
            case 277 /* JSDocThisType */:
                return visitNode(cbNode, node.type);
            case 271 /* JSDocRecordMember */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.type);
            case 278 /* JSDocComment */:
                return visitNodes(cbNodes, node.tags);
            case 281 /* JSDocParameterTag */:
                return visitNode(cbNode, node.preParameterName) ||
                    visitNode(cbNode, node.typeExpression) ||
                    visitNode(cbNode, node.postParameterName);
            case 282 /* JSDocReturnTag */:
                return visitNode(cbNode, node.typeExpression);
            case 283 /* JSDocTypeTag */:
                return visitNode(cbNode, node.typeExpression);
            case 280 /* JSDocAugmentsTag */:
                return visitNode(cbNode, node.typeExpression);
            case 284 /* JSDocTemplateTag */:
                return visitNodes(cbNodes, node.typeParameters);
            case 285 /* JSDocTypedefTag */:
                return visitNode(cbNode, node.typeExpression) ||
                    visitNode(cbNode, node.fullName) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.jsDocTypeLiteral);
            case 287 /* JSDocTypeLiteral */:
                return visitNodes(cbNodes, node.jsDocPropertyTags);
            case 286 /* JSDocPropertyTag */:
                return visitNode(cbNode, node.typeExpression) ||
                    visitNode(cbNode, node.name);
            case 294 /* PartiallyEmittedExpression */:
                return visitNode(cbNode, node.expression);
            case 288 /* JSDocLiteralType */:
                return visitNode(cbNode, node.literal);
        }
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{256,1} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{256,1} AS 1 AT <0:544>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{256,2} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{256,2} AS 2 AT <0:596>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{256,3} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{256,3} AS 3 AT <0:692>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{256,4} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{256,4} AS 4 AT <0:744>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{256,5} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{256,5} AS 5 AT <0:802>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{256,6} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{256,6} AS 6 AT <0:1658>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{256,7} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{256,7} AS 7 AT <0:1718>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{256,8} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{256,8} AS 8 AT <0:1777>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{256,9} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{256,9} AS 9 AT <0:1837>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{256,10} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{256,10} AS 10 AT <0:1899>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{256,11} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{256,11} AS 11 AT <0:1951>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{256,12} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{256,12} AS 12 AT <0:2012>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{256,13} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{256,13} AS 13 AT <0:2064>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{256,14} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{256,14} AS 14 AT <0:2341>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{256,15} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{256,15} AS 15 AT <0:2401>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{256,16} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{256,16} AS 16 AT <0:2460>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{256,17} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{256,17} AS 17 AT <0:2524>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{256,18} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{256,18} AS 18 AT <0:2584>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{256,19} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{256,19} AS 19 AT <0:2984>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{256,20} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{256,20} AS 20 AT <0:3044>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{256,21} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{256,21} AS 21 AT <0:3103>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{256,22} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{256,22} AS 22 AT <0:3164>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{256,23} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{256,23} AS 23 AT <0:3216>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{256,24} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{256,24} AS 24 AT <0:3277>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{256,25} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{256,25} AS 25 AT <0:3341>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{256,26} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{256,26} AS 26 AT <0:3401>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{256,27} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{256,27} AS 27 AT <0:3453>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{256,28} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{256,28} AS 28 AT <0:3523>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{256,29} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{256,29} AS 29 AT <0:3618>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{256,30} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{256,30} AS 30 AT <0:3674>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{256,31} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{256,31} AS 31 AT <0:3780>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{256,32} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{256,32} AS 32 AT <0:3841>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{256,33} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{256,33} AS 33 AT <0:3932>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{256,34} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{256,34} AS 34 AT <0:4029>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{256,35} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{256,35} AS 35 AT <0:4125>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{256,36} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{256,36} AS 36 AT <0:4223>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{256,37} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{256,37} AS 37 AT <0:4369>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{256,38} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{256,38} AS 38 AT <0:4512>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{256,39} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{256,39} AS 39 AT <0:4611>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{256,40} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{256,40} AS 40 AT <0:4669>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{256,41} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{256,41} AS 41 AT <0:4766>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{256,42} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{256,42} AS 42 AT <0:4827>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{256,43} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{256,43} AS 43 AT <0:4888>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{256,44} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{256,44} AS 44 AT <0:4949>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{256,45} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{256,45} AS 45 AT <0:5042>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{256,46} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{256,46} AS 46 AT <0:5530>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{256,47} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{256,47} AS 47 AT <0:5588>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{256,48} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{256,48} AS 48 AT <0:8393>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{256,49} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{256,49} AS 49 AT <0:8453>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{256,50} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{256,50} AS 50 AT <0:8562>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{256,51} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{256,51} AS 51 AT <0:8622>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{256,52} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{256,52} AS 52 AT <0:8681>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{256,53} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{256,53} AS 53 AT <0:8797>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{256,54} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{256,54} AS 54 AT <0:11956>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{256,55} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{256,55} AS 55 AT <0:12016>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{256,56} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{256,56} AS 56 AT <0:12075>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{256,57} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{256,57} AS 57 AT <0:12127>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{256,58} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{256,58} AS 58 AT <0:12191>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:bindParameter) id{257,0} ---
(node) {
            if (inStrictMode) {
                // It is a SyntaxError if the identifier eval or arguments appears within a FormalParameterList of a
                // strict mode FunctionLikeDeclaration or FunctionExpression(13.1)
                checkStrictModeEvalOrArguments(node, node.name);
            }
            if (ts.isBindingPattern(node.name)) {
                bindAnonymousDeclaration(node, 1 /* FunctionScopedVariable */, getDestructuringParameterName(node));
            }
            else {
                declareSymbolAndAddToSymbolTable(node, 1 /* FunctionScopedVariable */, 107455 /* ParameterExcludes */);
            }
            // If this is a property-parameter, then also declare the property symbol into the
            // containing class.
            if (ts.isParameterPropertyDeclaration(node)) {
                var classDeclaration = node.parent.parent;
                declareSymbol(classDeclaration.symbol.members, classDeclaration.symbol, node, 4 /* Property */ | (node.questionToken ? 536870912 /* Optional */ : 0 /* None */), 0 /* PropertyExcludes */);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:declareSymbolAndAddToSymbolTable) id{257,1} ---
(node, symbolFlags, symbolExcludes) {
            // Just call this directly so that the return type of this function stays "void".
            return declareSymbolAndAddToSymbolTableWorker(node, symbolFlags, symbolExcludes);
        }
--- END ---
INLINE (declareSymbolAndAddToSymbolTable) id{257,1} AS 1 AT <0:536>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:bindWorker) id{258,0} ---
(node) {
            switch (node.kind) {
                /* Strict mode checks */
                case 70 /* Identifier */:
                    // for typedef type names with namespaces, bind the new jsdoc type symbol here
                    // because it requires all containing namespaces to be in effect, namely the
                    // current "blockScopeContainer" needs to be set to its immediate namespace parent.
                    if (node.isInJSDocNamespace) {
                        var parentNode = node.parent;
                        while (parentNode && parentNode.kind !== 285 /* JSDocTypedefTag */) {
                            parentNode = parentNode.parent;
                        }
                        bindBlockScopedDeclaration(parentNode, 524288 /* TypeAlias */, 793064 /* TypeAliasExcludes */);
                        break;
                    }
                case 98 /* ThisKeyword */:
                    if (currentFlow && (ts.isExpression(node) || parent.kind === 258 /* ShorthandPropertyAssignment */)) {
                        node.flowNode = currentFlow;
                    }
                    return checkStrictModeIdentifier(node);
                case 177 /* PropertyAccessExpression */:
                    if (currentFlow && isNarrowableReference(node)) {
                        node.flowNode = currentFlow;
                    }
                    break;
                case 192 /* BinaryExpression */:
                    if (ts.isInJavaScriptFile(node)) {
                        var specialKind = ts.getSpecialPropertyAssignmentKind(node);
                        switch (specialKind) {
                            case 1 /* ExportsProperty */:
                                bindExportsPropertyAssignment(node);
                                break;
                            case 2 /* ModuleExports */:
                                bindModuleExportsAssignment(node);
                                break;
                            case 3 /* PrototypeProperty */:
                                bindPrototypePropertyAssignment(node);
                                break;
                            case 4 /* ThisProperty */:
                                bindThisPropertyAssignment(node);
                                break;
                            case 0 /* None */:
                                // Nothing to do
                                break;
                            default:
                                ts.Debug.fail("Unknown special property assignment kind");
                        }
                    }
                    return checkStrictModeBinaryExpression(node);
                case 256 /* CatchClause */:
                    return checkStrictModeCatchClause(node);
                case 186 /* DeleteExpression */:
                    return checkStrictModeDeleteExpression(node);
                case 8 /* NumericLiteral */:
                    return checkStrictModeNumericLiteral(node);
                case 191 /* PostfixUnaryExpression */:
                    return checkStrictModePostfixUnaryExpression(node);
                case 190 /* PrefixUnaryExpression */:
                    return checkStrictModePrefixUnaryExpression(node);
                case 217 /* WithStatement */:
                    return checkStrictModeWithStatement(node);
                case 167 /* ThisType */:
                    seenThisKeyword = true;
                    return;
                case 156 /* TypePredicate */:
                    return checkTypePredicate(node);
                case 143 /* TypeParameter */:
                    return declareSymbolAndAddToSymbolTable(node, 262144 /* TypeParameter */, 530920 /* TypeParameterExcludes */);
                case 144 /* Parameter */:
                    return bindParameter(node);
                case 223 /* VariableDeclaration */:
                case 174 /* BindingElement */:
                    return bindVariableDeclarationOrBindingElement(node);
                case 147 /* PropertyDeclaration */:
                case 146 /* PropertySignature */:
                case 271 /* JSDocRecordMember */:
                    return bindPropertyOrMethodOrAccessor(node, 4 /* Property */ | (node.questionToken ? 536870912 /* Optional */ : 0 /* None */), 0 /* PropertyExcludes */);
                case 286 /* JSDocPropertyTag */:
                    return bindJSDocProperty(node);
                case 257 /* PropertyAssignment */:
                case 258 /* ShorthandPropertyAssignment */:
                    return bindPropertyOrMethodOrAccessor(node, 4 /* Property */, 0 /* PropertyExcludes */);
                case 260 /* EnumMember */:
                    return bindPropertyOrMethodOrAccessor(node, 8 /* EnumMember */, 900095 /* EnumMemberExcludes */);
                case 259 /* SpreadAssignment */:
                case 251 /* JsxSpreadAttribute */:
                    var root = container;
                    var hasRest = false;
                    while (root.parent) {
                        if (root.kind === 176 /* ObjectLiteralExpression */ &&
                            root.parent.kind === 192 /* BinaryExpression */ &&
                            root.parent.operatorToken.kind === 57 /* EqualsToken */ &&
                            root.parent.left === root) {
                            hasRest = true;
                            break;
                        }
                        root = root.parent;
                    }
                    return;
                case 153 /* CallSignature */:
                case 154 /* ConstructSignature */:
                case 155 /* IndexSignature */:
                    return declareSymbolAndAddToSymbolTable(node, 131072 /* Signature */, 0 /* None */);
                case 149 /* MethodDeclaration */:
                case 148 /* MethodSignature */:
                    // If this is an ObjectLiteralExpression method, then it sits in the same space
                    // as other properties in the object literal.  So we use SymbolFlags.PropertyExcludes
                    // so that it will conflict with any other object literal members with the same
                    // name.
                    return bindPropertyOrMethodOrAccessor(node, 8192 /* Method */ | (node.questionToken ? 536870912 /* Optional */ : 0 /* None */), ts.isObjectLiteralMethod(node) ? 0 /* PropertyExcludes */ : 99263 /* MethodExcludes */);
                case 225 /* FunctionDeclaration */:
                    return bindFunctionDeclaration(node);
                case 150 /* Constructor */:
                    return declareSymbolAndAddToSymbolTable(node, 16384 /* Constructor */, /*symbolExcludes:*/ 0 /* None */);
                case 151 /* GetAccessor */:
                    return bindPropertyOrMethodOrAccessor(node, 32768 /* GetAccessor */, 41919 /* GetAccessorExcludes */);
                case 152 /* SetAccessor */:
                    return bindPropertyOrMethodOrAccessor(node, 65536 /* SetAccessor */, 74687 /* SetAccessorExcludes */);
                case 158 /* FunctionType */:
                case 159 /* ConstructorType */:
                case 274 /* JSDocFunctionType */:
                    return bindFunctionOrConstructorType(node);
                case 161 /* TypeLiteral */:
                case 170 /* MappedType */:
                case 287 /* JSDocTypeLiteral */:
                case 270 /* JSDocRecordType */:
                    return bindAnonymousDeclaration(node, 2048 /* TypeLiteral */, "__type");
                case 176 /* ObjectLiteralExpression */:
                    return bindObjectLiteralExpression(node);
                case 184 /* FunctionExpression */:
                case 185 /* ArrowFunction */:
                    return bindFunctionExpression(node);
                case 179 /* CallExpression */:
                    if (ts.isInJavaScriptFile(node)) {
                        bindCallExpression(node);
                    }
                    break;
                // Members of classes, interfaces, and modules
                case 197 /* ClassExpression */:
                case 226 /* ClassDeclaration */:
                    // All classes are automatically in strict mode in ES6.
                    inStrictMode = true;
                    return bindClassLikeDeclaration(node);
                case 227 /* InterfaceDeclaration */:
                    return bindBlockScopedDeclaration(node, 64 /* Interface */, 792968 /* InterfaceExcludes */);
                case 285 /* JSDocTypedefTag */:
                    if (!node.fullName || node.fullName.kind === 70 /* Identifier */) {
                        return bindBlockScopedDeclaration(node, 524288 /* TypeAlias */, 793064 /* TypeAliasExcludes */);
                    }
                    break;
                case 228 /* TypeAliasDeclaration */:
                    return bindBlockScopedDeclaration(node, 524288 /* TypeAlias */, 793064 /* TypeAliasExcludes */);
                case 229 /* EnumDeclaration */:
                    return bindEnumDeclaration(node);
                case 230 /* ModuleDeclaration */:
                    return bindModuleDeclaration(node);
                // Imports and exports
                case 234 /* ImportEqualsDeclaration */:
                case 237 /* NamespaceImport */:
                case 239 /* ImportSpecifier */:
                case 243 /* ExportSpecifier */:
                    return declareSymbolAndAddToSymbolTable(node, 8388608 /* Alias */, 8388608 /* AliasExcludes */);
                case 233 /* NamespaceExportDeclaration */:
                    return bindNamespaceExportDeclaration(node);
                case 236 /* ImportClause */:
                    return bindImportClause(node);
                case 241 /* ExportDeclaration */:
                    return bindExportDeclaration(node);
                case 240 /* ExportAssignment */:
                    return bindExportAssignment(node);
                case 261 /* SourceFile */:
                    updateStrictModeStatementList(node.statements);
                    return bindSourceFileIfExternalModule();
                case 204 /* Block */:
                    if (!ts.isFunctionLike(node.parent)) {
                        return;
                    }
                // Fall through
                case 231 /* ModuleBlock */:
                    return updateStrictModeStatementList(node.statements);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isNarrowableReference) id{258,1} ---
(expr) {
            return expr.kind === 70 /* Identifier */ ||
                expr.kind === 98 /* ThisKeyword */ ||
                expr.kind === 177 /* PropertyAccessExpression */ && isNarrowableReference(expr.expression);
        }
--- END ---
INLINE (isNarrowableReference) id{258,1} AS 1 AT <0:1280>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkTypePredicate) id{258,2} ---
(node) {
            var parameterName = node.parameterName, type = node.type;
            if (parameterName && parameterName.kind === 70 /* Identifier */) {
                checkStrictModeIdentifier(parameterName);
            }
            if (parameterName && parameterName.kind === 167 /* ThisType */) {
                seenThisKeyword = true;
            }
            bind(type);
        }
--- END ---
INLINE (checkTypePredicate) id{258,2} AS 2 AT <0:3560>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:declareSymbolAndAddToSymbolTable) id{258,3} ---
(node, symbolFlags, symbolExcludes) {
            // Just call this directly so that the return type of this function stays "void".
            return declareSymbolAndAddToSymbolTableWorker(node, symbolFlags, symbolExcludes);
        }
--- END ---
INLINE (declareSymbolAndAddToSymbolTable) id{258,3} AS 3 AT <0:3659>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:declareSymbolAndAddToSymbolTable) id{258,4} ---
(node, symbolFlags, symbolExcludes) {
            // Just call this directly so that the return type of this function stays "void".
            return declareSymbolAndAddToSymbolTableWorker(node, symbolFlags, symbolExcludes);
        }
--- END ---
INLINE (declareSymbolAndAddToSymbolTable) id{258,4} AS 4 AT <0:5731>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:declareSymbolAndAddToSymbolTable) id{258,5} ---
(node, symbolFlags, symbolExcludes) {
            // Just call this directly so that the return type of this function stays "void".
            return declareSymbolAndAddToSymbolTableWorker(node, symbolFlags, symbolExcludes);
        }
--- END ---
INLINE (declareSymbolAndAddToSymbolTable) id{258,5} AS 5 AT <0:6660>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:bindAnonymousDeclaration) id{258,6} ---
(node, symbolFlags, name) {
            var symbol = createSymbol(symbolFlags, name);
            addDeclarationToSymbol(symbol, node, symbolFlags);
        }
--- END ---
INLINE (bindAnonymousDeclaration) id{258,6} AS 6 AT <0:7511>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createSymbol) id{258,7} ---
(flags, name) {
            symbolCount++;
            return new Symbol(flags, name);
        }
--- END ---
INLINE (createSymbol) id{258,7} AS 7 AT <6:53>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:SymbolObject) id{258,8} ---
(flags, name) {
            this.flags = flags;
            this.name = name;
        }
--- END ---
INLINE (SymbolObject) id{258,8} AS 8 AT <7:62>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:declareSymbolAndAddToSymbolTable) id{258,9} ---
(node, symbolFlags, symbolExcludes) {
            // Just call this directly so that the return type of this function stays "void".
            return declareSymbolAndAddToSymbolTableWorker(node, symbolFlags, symbolExcludes);
        }
--- END ---
INLINE (declareSymbolAndAddToSymbolTable) id{258,9} AS 9 AT <0:9502>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:bindImportClause) id{258,10} ---
(node) {
            if (node.name) {
                declareSymbolAndAddToSymbolTable(node, 8388608 /* Alias */, 8388608 /* AliasExcludes */);
            }
        }
--- END ---
INLINE (bindImportClause) id{258,10} AS 10 AT <0:9788>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:bindExportDeclaration) id{258,11} ---
(node) {
            if (!container.symbol || !container.symbol.exports) {
                // Export * in some sort of block construct
                bindAnonymousDeclaration(node, 1073741824 /* ExportStar */, getDeclarationName(node));
            }
            else if (!node.exportClause) {
                // All export * declarations are collected in an __export symbol
                declareSymbol(container.symbol.exports, container.symbol, node, 1073741824 /* ExportStar */, 0 /* None */);
            }
        }
--- END ---
INLINE (bindExportDeclaration) id{258,11} AS 11 AT <0:9889>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:updateStrictModeStatementList) id{258,12} ---
(statements) {
            if (!inStrictMode) {
                for (var _i = 0, statements_2 = statements; _i < statements_2.length; _i++) {
                    var statement = statements_2[_i];
                    if (!ts.isPrologueDirective(statement)) {
                        return;
                    }
                    if (isUseStrictPrologueDirective(statement)) {
                        inStrictMode = true;
                        return;
                    }
                }
            }
        }
--- END ---
INLINE (updateStrictModeStatementList) id{258,12} AS 12 AT <0:10085>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:bindSourceFileIfExternalModule) id{258,13} ---
() {
            setExportContextFlag(file);
            if (ts.isExternalModule(file)) {
                bindSourceFileAsExternalModule();
            }
        }
--- END ---
INLINE (bindSourceFileIfExternalModule) id{258,13} AS 13 AT <0:10160>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:setExportContextFlag) id{258,14} ---
(node) {
            // A declaration source file or ambient module declaration that contains no export declarations (but possibly regular
            // declarations with export modifiers) is an export context in which declarations are implicitly exported.
            if (ts.isInAmbientContext(node) && !hasExportDeclarations(node)) {
                node.flags |= 32 /* ExportContext */;
            }
            else {
                node.flags &= ~32 /* ExportContext */;
            }
        }
--- END ---
INLINE (setExportContextFlag) id{258,14} AS 14 AT <13:17>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:hasExportDeclarations) id{258,15} ---
(node) {
            var body = node.kind === 261 /* SourceFile */ ? node : node.body;
            if (body && (body.kind === 261 /* SourceFile */ || body.kind === 231 /* ModuleBlock */)) {
                for (var _i = 0, _a = body.statements; _i < _a.length; _i++) {
                    var stat = _a[_i];
                    if (stat.kind === 241 /* ExportDeclaration */ || stat.kind === 240 /* ExportAssignment */) {
                        return true;
                    }
                }
            }
            return false;
        }
--- END ---
INLINE (hasExportDeclarations) id{258,15} AS 15 AT <14:306>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:updateStrictModeStatementList) id{258,16} ---
(statements) {
            if (!inStrictMode) {
                for (var _i = 0, statements_2 = statements; _i < statements_2.length; _i++) {
                    var statement = statements_2[_i];
                    if (!ts.isPrologueDirective(statement)) {
                        return;
                    }
                    if (isUseStrictPrologueDirective(statement)) {
                        inStrictMode = true;
                        return;
                    }
                }
            }
        }
--- END ---
INLINE (updateStrictModeStatementList) id{258,16} AS 16 AT <0:10448>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkStrictModeEvalOrArguments) id{259,0} ---
(contextNode, name) {
            if (name && name.kind === 70 /* Identifier */) {
                var identifier = name;
                if (isEvalOrArgumentsIdentifier(identifier)) {
                    // We check first if the name is inside class declaration or class expression; if so give explicit message
                    // otherwise report generic error message.
                    var span_3 = ts.getErrorSpanForNode(file, name);
                    file.bindDiagnostics.push(ts.createFileDiagnostic(file, span_3.start, span_3.length, getStrictModeEvalOrArgumentsMessage(contextNode), identifier.text));
                }
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isEvalOrArgumentsIdentifier) id{259,1} ---
(node) {
            return node.kind === 70 /* Identifier */ &&
                (node.text === "eval" || node.text === "arguments");
        }
--- END ---
INLINE (isEvalOrArgumentsIdentifier) id{259,1} AS 1 AT <0:142>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isBindingPattern) id{260,0} ---
(node) {
        if (node) {
            var kind = node.kind;
            return kind === 173 /* ArrayBindingPattern */
                || kind === 172 /* ObjectBindingPattern */;
        }
        return false;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getContainerFlags) id{261,0} ---
(node) {
            switch (node.kind) {
                case 197 /* ClassExpression */:
                case 226 /* ClassDeclaration */:
                case 229 /* EnumDeclaration */:
                case 176 /* ObjectLiteralExpression */:
                case 161 /* TypeLiteral */:
                case 287 /* JSDocTypeLiteral */:
                case 270 /* JSDocRecordType */:
                    return 1 /* IsContainer */;
                case 227 /* InterfaceDeclaration */:
                    return 1 /* IsContainer */ | 64 /* IsInterface */;
                case 274 /* JSDocFunctionType */:
                case 230 /* ModuleDeclaration */:
                case 228 /* TypeAliasDeclaration */:
                case 170 /* MappedType */:
                    return 1 /* IsContainer */ | 32 /* HasLocals */;
                case 261 /* SourceFile */:
                    return 1 /* IsContainer */ | 4 /* IsControlFlowContainer */ | 32 /* HasLocals */;
                case 149 /* MethodDeclaration */:
                    if (ts.isObjectLiteralOrClassExpressionMethod(node)) {
                        return 1 /* IsContainer */ | 4 /* IsControlFlowContainer */ | 32 /* HasLocals */ | 8 /* IsFunctionLike */ | 128 /* IsObjectLiteralOrClassExpressionMethod */;
                    }
                case 150 /* Constructor */:
                case 225 /* FunctionDeclaration */:
                case 148 /* MethodSignature */:
                case 151 /* GetAccessor */:
                case 152 /* SetAccessor */:
                case 153 /* CallSignature */:
                case 154 /* ConstructSignature */:
                case 155 /* IndexSignature */:
                case 158 /* FunctionType */:
                case 159 /* ConstructorType */:
                    return 1 /* IsContainer */ | 4 /* IsControlFlowContainer */ | 32 /* HasLocals */ | 8 /* IsFunctionLike */;
                case 184 /* FunctionExpression */:
                case 185 /* ArrowFunction */:
                    return 1 /* IsContainer */ | 4 /* IsControlFlowContainer */ | 32 /* HasLocals */ | 8 /* IsFunctionLike */ | 16 /* IsFunctionExpression */;
                case 231 /* ModuleBlock */:
                    return 4 /* IsControlFlowContainer */;
                case 147 /* PropertyDeclaration */:
                    return node.initializer ? 4 /* IsControlFlowContainer */ : 0;
                case 256 /* CatchClause */:
                case 211 /* ForStatement */:
                case 212 /* ForInStatement */:
                case 213 /* ForOfStatement */:
                case 232 /* CaseBlock */:
                    return 2 /* IsBlockScopedContainer */;
                case 204 /* Block */:
                    // do not treat blocks directly inside a function as a block-scoped-container.
                    // Locals that reside in this block should go to the function locals. Otherwise 'x'
                    // would not appear to be a redeclaration of a block scoped local in the following
                    // example:
                    //
                    //      function foo() {
                    //          var x;
                    //          let x;
                    //      }
                    //
                    // If we placed 'var x' into the function locals and 'let x' into the locals of
                    // the block, then there would be no collision.
                    //
                    // By not creating a new block-scoped-container here, we ensure that both 'var x'
                    // and 'let x' go into the Function-container's locals, and we do get a collision
                    // conflict.
                    return ts.isFunctionLike(node.parent) ? 0 /* None */ : 2 /* IsBlockScopedContainer */;
            }
            return 0 /* None */;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:declareSymbolAndAddToSymbolTableWorker) id{262,0} ---
(node, symbolFlags, symbolExcludes) {
            switch (container.kind) {
                // Modules, source files, and classes need specialized handling for how their
                // members are declared (for example, a member of a class will go into a specific
                // symbol table depending on if it is static or not). We defer to specialized
                // handlers to take care of declaring these child members.
                case 230 /* ModuleDeclaration */:
                    return declareModuleMember(node, symbolFlags, symbolExcludes);
                case 261 /* SourceFile */:
                    return declareSourceFileMember(node, symbolFlags, symbolExcludes);
                case 197 /* ClassExpression */:
                case 226 /* ClassDeclaration */:
                    return declareClassMember(node, symbolFlags, symbolExcludes);
                case 229 /* EnumDeclaration */:
                    return declareSymbol(container.symbol.exports, container.symbol, node, symbolFlags, symbolExcludes);
                case 161 /* TypeLiteral */:
                case 176 /* ObjectLiteralExpression */:
                case 227 /* InterfaceDeclaration */:
                case 270 /* JSDocRecordType */:
                case 287 /* JSDocTypeLiteral */:
                    // Interface/Object-types always have their children added to the 'members' of
                    // their container. They are only accessible through an instance of their
                    // container, and are never in scope otherwise (even inside the body of the
                    // object / type / interface declaring them). An exception is type parameters,
                    // which are in scope without qualification (similar to 'locals').
                    return declareSymbol(container.symbol.members, container.symbol, node, symbolFlags, symbolExcludes);
                case 158 /* FunctionType */:
                case 159 /* ConstructorType */:
                case 153 /* CallSignature */:
                case 154 /* ConstructSignature */:
                case 155 /* IndexSignature */:
                case 149 /* MethodDeclaration */:
                case 148 /* MethodSignature */:
                case 150 /* Constructor */:
                case 151 /* GetAccessor */:
                case 152 /* SetAccessor */:
                case 225 /* FunctionDeclaration */:
                case 184 /* FunctionExpression */:
                case 185 /* ArrowFunction */:
                case 274 /* JSDocFunctionType */:
                case 228 /* TypeAliasDeclaration */:
                case 170 /* MappedType */:
                    // All the children of these container types are never visible through another
                    // symbol (i.e. through another symbol's 'exports' or 'members').  Instead,
                    // they're only accessed 'lexically' (i.e. from code that exists underneath
                    // their container in the tree.  To accomplish this, we simply add their declared
                    // symbol to the 'locals' of the container.  These symbols can then be found as
                    // the type checker walks up the containers, checking them for matching names.
                    return declareSymbol(container.locals, /*parent*/ undefined, node, symbolFlags, symbolExcludes);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:declareSourceFileMember) id{262,1} ---
(node, symbolFlags, symbolExcludes) {
            return ts.isExternalModule(file)
                ? declareModuleMember(node, symbolFlags, symbolExcludes)
                : declareSymbol(file.locals, undefined, node, symbolFlags, symbolExcludes);
        }
--- END ---
INLINE (declareSourceFileMember) id{262,1} AS 1 AT <0:640>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:declareClassMember) id{262,2} ---
(node, symbolFlags, symbolExcludes) {
            return ts.hasModifier(node, 32 /* Static */)
                ? declareSymbol(container.symbol.exports, container.symbol, node, symbolFlags, symbolExcludes)
                : declareSymbol(container.symbol.members, container.symbol, node, symbolFlags, symbolExcludes);
        }
--- END ---
INLINE (declareClassMember) id{262,2} AS 2 AT <0:824>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isObjectLiteralOrClassExpressionMethod) id{263,0} ---
(node) {
        return node.kind === 149 /* MethodDeclaration */ &&
            (node.parent.kind === 176 /* ObjectLiteralExpression */ ||
                node.parent.kind === 197 /* ClassExpression */);
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:addDeclarationToSymbol) id{264,0} ---
(symbol, node, symbolFlags) {
            symbol.flags |= symbolFlags;
            node.symbol = symbol;
            if (!symbol.declarations) {
                symbol.declarations = [];
            }
            symbol.declarations.push(node);
            if (symbolFlags & 1952 /* HasExports */ && !symbol.exports) {
                symbol.exports = ts.createMap();
            }
            if (symbolFlags & 6240 /* HasMembers */ && !symbol.members) {
                symbol.members = ts.createMap();
            }
            if (symbolFlags & 107455 /* Value */) {
                var valueDeclaration = symbol.valueDeclaration;
                if (!valueDeclaration ||
                    (valueDeclaration.kind !== node.kind && valueDeclaration.kind === 230 /* ModuleDeclaration */)) {
                    // other kinds of value declarations take precedence over modules
                    symbol.valueDeclaration = node;
                }
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isObjectLiteralMethod) id{265,0} ---
(node) {
        return node && node.kind === 149 /* MethodDeclaration */ && node.parent.kind === 176 /* ObjectLiteralExpression */;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:bindContainer) id{266,0} ---
(node, containerFlags) {
            // Before we recurse into a node's children, we first save the existing parent, container
            // and block-container.  Then after we pop out of processing the children, we restore
            // these saved values.
            var saveContainer = container;
            var savedBlockScopeContainer = blockScopeContainer;
            // Depending on what kind of node this is, we may have to adjust the current container
            // and block-container.   If the current node is a container, then it is automatically
            // considered the current block-container as well.  Also, for containers that we know
            // may contain locals, we proactively initialize the .locals field. We do this because
            // it's highly likely that the .locals will be needed to place some child in (for example,
            // a parameter, or variable declaration).
            //
            // However, we do not proactively create the .locals for block-containers because it's
            // totally normal and common for block-containers to never actually have a block-scoped
            // variable in them.  We don't want to end up allocating an object for every 'block' we
            // run into when most of them won't be necessary.
            //
            // Finally, if this is a block-container, then we clear out any existing .locals object
            // it may contain within it.  This happens in incremental scenarios.  Because we can be
            // reusing a node from a previous compilation, that node may have had 'locals' created
            // for it.  We must clear this so we don't accidentally move any stale data forward from
            // a previous compilation.
            if (containerFlags & 1 /* IsContainer */) {
                container = blockScopeContainer = node;
                if (containerFlags & 32 /* HasLocals */) {
                    container.locals = ts.createMap();
                }
                addToContainerChain(container);
            }
            else if (containerFlags & 2 /* IsBlockScopedContainer */) {
                blockScopeContainer = node;
                blockScopeContainer.locals = undefined;
            }
            if (containerFlags & 4 /* IsControlFlowContainer */) {
                var saveCurrentFlow = currentFlow;
                var saveBreakTarget = currentBreakTarget;
                var saveContinueTarget = currentContinueTarget;
                var saveReturnTarget = currentReturnTarget;
                var saveActiveLabels = activeLabels;
                var saveHasExplicitReturn = hasExplicitReturn;
                var isIIFE = containerFlags & 16 /* IsFunctionExpression */ && !ts.hasModifier(node, 256 /* Async */) && !!ts.getImmediatelyInvokedFunctionExpression(node);
                // A non-async IIFE is considered part of the containing control flow. Return statements behave
                // similarly to break statements that exit to a label just past the statement body.
                if (isIIFE) {
                    currentReturnTarget = createBranchLabel();
                }
                else {
                    currentFlow = { flags: 2 /* Start */ };
                    if (containerFlags & (16 /* IsFunctionExpression */ | 128 /* IsObjectLiteralOrClassExpressionMethod */)) {
                        currentFlow.container = node;
                    }
                    currentReturnTarget = undefined;
                }
                currentBreakTarget = undefined;
                currentContinueTarget = undefined;
                activeLabels = undefined;
                hasExplicitReturn = false;
                bindChildren(node);
                // Reset all reachability check related flags on node (for incremental scenarios)
                node.flags &= ~1408 /* ReachabilityAndEmitFlags */;
                if (!(currentFlow.flags & 1 /* Unreachable */) && containerFlags & 8 /* IsFunctionLike */ && ts.nodeIsPresent(node.body)) {
                    node.flags |= 128 /* HasImplicitReturn */;
                    if (hasExplicitReturn)
                        node.flags |= 256 /* HasExplicitReturn */;
                }
                if (node.kind === 261 /* SourceFile */) {
                    node.flags |= emitFlags;
                }
                if (isIIFE) {
                    addAntecedent(currentReturnTarget, currentFlow);
                    currentFlow = finishFlowLabel(currentReturnTarget);
                }
                else {
                    currentFlow = saveCurrentFlow;
                }
                currentBreakTarget = saveBreakTarget;
                currentContinueTarget = saveContinueTarget;
                currentReturnTarget = saveReturnTarget;
                activeLabels = saveActiveLabels;
                hasExplicitReturn = saveHasExplicitReturn;
            }
            else if (containerFlags & 64 /* IsInterface */) {
                seenThisKeyword = false;
                bindChildren(node);
                node.flags = seenThisKeyword ? node.flags | 64 /* ContainsThis */ : node.flags & ~64 /* ContainsThis */;
            }
            else {
                bindChildren(node);
            }
            container = saveContainer;
            blockScopeContainer = savedBlockScopeContainer;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:addToContainerChain) id{266,1} ---
(next) {
            if (lastContainer) {
                lastContainer.nextContainer = next;
            }
            lastContainer = next;
        }
--- END ---
INLINE (addToContainerChain) id{266,1} AS 1 AT <0:2009>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getCombinedModifierFlags) id{267,0} ---
(node) {
        node = walkUpBindingElementsAndPatterns(node);
        var flags = ts.getModifierFlags(node);
        if (node.kind === 223 /* VariableDeclaration */) {
            node = node.parent;
        }
        if (node && node.kind === 224 /* VariableDeclarationList */) {
            flags |= ts.getModifierFlags(node);
            node = node.parent;
        }
        if (node && node.kind === 205 /* VariableStatement */) {
            flags |= ts.getModifierFlags(node);
        }
        return flags;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:walkUpBindingElementsAndPatterns) id{267,1} ---
(node) {
        while (node && (node.kind === 174 /* BindingElement */ || ts.isBindingPattern(node))) {
            node = node.parent;
        }
        return node;
    }
--- END ---
INLINE (walkUpBindingElementsAndPatterns) id{267,1} AS 1 AT <0:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:bindFunctionDeclaration) id{268,0} ---
(node) {
            if (!ts.isDeclarationFile(file) && !ts.isInAmbientContext(node)) {
                if (ts.isAsyncFunctionLike(node)) {
                    emitFlags |= 1024 /* HasAsyncFunctions */;
                }
            }
            checkStrictModeFunctionName(node);
            if (inStrictMode) {
                checkStrictModeFunctionDeclaration(node);
                bindBlockScopedDeclaration(node, 16 /* Function */, 106927 /* FunctionExcludes */);
            }
            else {
                declareSymbolAndAddToSymbolTable(node, 16 /* Function */, 106927 /* FunctionExcludes */);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkStrictModeFunctionName) id{268,1} ---
(node) {
            if (inStrictMode) {
                // It is a SyntaxError if the identifier eval or arguments appears within a FormalParameterList of a strict mode FunctionDeclaration or FunctionExpression (13.1))
                checkStrictModeEvalOrArguments(node, node.name);
            }
        }
--- END ---
INLINE (checkStrictModeFunctionName) id{268,1} AS 1 AT <0:247>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:declareSymbolAndAddToSymbolTable) id{268,2} ---
(node, symbolFlags, symbolExcludes) {
            // Just call this directly so that the return type of this function stays "void".
            return declareSymbolAndAddToSymbolTableWorker(node, symbolFlags, symbolExcludes);
        }
--- END ---
INLINE (declareSymbolAndAddToSymbolTable) id{268,2} AS 2 AT <0:521>
[deoptimizing (DEOPT eager): begin 0x2f05bb804691 <JS Function addDeclarationToSymbol (SharedFunctionInfo 0x16f3adb57e21)> (opt #264) @23, FP to SP delta: 64, caller sp: 0x7fff5fbfcd18]
            ;;; deoptimize at 0_444: Unknown map in polymorphic access
  reading input frame addDeclarationToSymbol => node=181, args=4, height=2; inputs:
      0: 0x2f05bb804691 ; [fp - 16] 0x2f05bb804691 <JS Function addDeclarationToSymbol (SharedFunctionInfo 0x16f3adb57e21)>
      1: 0x1f9f6c0532e1 ; [fp + 40] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x181e01154ee9 ; rbx 0x181e01154ee9 <a SymbolObject with map 0x33abe2a6fb29>
      3: 0x35fa3c449181 ; [fp + 24] 0x35fa3c449181 <a NodeObject with map 0x33abe2a6fe41>
      4: 0x4000000000 ; [fp + 16] 64
      5: 0xd6230dfeea1 ; [fp - 24] 0xd6230dfeea1 <FixedArray[147]>
      6: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
  translating frame addDeclarationToSymbol => node=181, height=8
    0x7fff5fbfcd10: [top + 64] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfcd08: [top + 56] <- 0x181e01154ee9 ;  0x181e01154ee9 <a SymbolObject with map 0x33abe2a6fb29>  (input #2)
    0x7fff5fbfcd00: [top + 48] <- 0x35fa3c449181 ;  0x35fa3c449181 <a NodeObject with map 0x33abe2a6fe41>  (input #3)
    0x7fff5fbfccf8: [top + 40] <- 0x4000000000 ;  64  (input #4)
    0x7fff5fbfccf0: [top + 32] <- 0x2c21d257f06d ;  caller's pc
    0x7fff5fbfcce8: [top + 24] <- 0x7fff5fbfcd68 ;  caller's fp
    0x7fff5fbfcce0: [top + 16] <- 0xd6230dfeea1 ;  context    0xd6230dfeea1 <FixedArray[147]>  (input #5)
    0x7fff5fbfccd8: [top + 8] <- 0x2f05bb804691 ;  function    0x2f05bb804691 <JS Function addDeclarationToSymbol (SharedFunctionInfo 0x16f3adb57e21)>  (input #0)
    0x7fff5fbfccd0: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
[deoptimizing (eager): end 0x2f05bb804691 <JS Function addDeclarationToSymbol (SharedFunctionInfo 0x16f3adb57e21)> @23 => node=181, pc=0x2c21d2524b97, caller sp=0x7fff5fbfcd18, state=NO_REGISTERS, took 0.069 ms]
[deoptimizing (DEOPT eager): begin 0x2f05bb805771 <JS Function declareSymbolAndAddToSymbolTableWorker (SharedFunctionInfo 0x16f3adb5ab21)> (opt #262) @7, FP to SP delta: 64, caller sp: 0x7fff5fbfc7d0]
            ;;; deoptimize at 0_1830: wrong map
  reading input frame declareSymbolAndAddToSymbolTableWorker => node=216, args=4, height=5; inputs:
      0: 0x2f05bb805771 ; [fp - 16] 0x2f05bb805771 <JS Function declareSymbolAndAddToSymbolTableWorker (SharedFunctionInfo 0x16f3adb5ab21)>
      1: 0x1f9f6c0532e1 ; [fp + 40] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x35fa3c4766d1 ; [fp + 32] 0x35fa3c4766d1 <a NodeObject with map 0x33abe2a675c9>
      3: 0x200000000000 ; [fp + 24] 8192
      4: 0x183bf00000000 ; [fp + 16] 99263
      5: 0xd6230dfeea1 ; [fp - 24] 0xd6230dfeea1 <FixedArray[147]>
      6: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x2f05bb804769 ; [fp - 32] 0x2f05bb804769 <JS Function declareSymbol (SharedFunctionInfo 0x16f3adb58061)>
      8: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
      9: 0x181e01154ee9 ; rax 0x181e01154ee9 <a SymbolObject with map 0x33abe2a72151>
  translating frame declareSymbolAndAddToSymbolTableWorker => node=216, height=32
    0x7fff5fbfc7c8: [top + 88] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfc7c0: [top + 80] <- 0x35fa3c4766d1 ;  0x35fa3c4766d1 <a NodeObject with map 0x33abe2a675c9>  (input #2)
    0x7fff5fbfc7b8: [top + 72] <- 0x200000000000 ;  8192  (input #3)
    0x7fff5fbfc7b0: [top + 64] <- 0x183bf00000000 ;  99263  (input #4)
    0x7fff5fbfc7a8: [top + 56] <- 0x2c21d25556ed ;  caller's pc
    0x7fff5fbfc7a0: [top + 48] <- 0x7fff5fbfc818 ;  caller's fp
    0x7fff5fbfc798: [top + 40] <- 0xd6230dfeea1 ;  context    0xd6230dfeea1 <FixedArray[147]>  (input #5)
    0x7fff5fbfc790: [top + 32] <- 0x2f05bb805771 ;  function    0x2f05bb805771 <JS Function declareSymbolAndAddToSymbolTableWorker (SharedFunctionInfo 0x16f3adb5ab21)>  (input #0)
    0x7fff5fbfc788: [top + 24] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfc780: [top + 16] <- 0x2f05bb804769 ;  0x2f05bb804769 <JS Function declareSymbol (SharedFunctionInfo 0x16f3adb58061)>  (input #7)
    0x7fff5fbfc778: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfc770: [top + 0] <- 0x181e01154ee9 ;  0x181e01154ee9 <a SymbolObject with map 0x33abe2a72151>  (input #9)
[deoptimizing (eager): end 0x2f05bb805771 <JS Function declareSymbolAndAddToSymbolTableWorker (SharedFunctionInfo 0x16f3adb5ab21)> @7 => node=216, pc=0x2c21d252703b, caller sp=0x7fff5fbfc7d0, state=TOS_REGISTER, took 0.076 ms]
[deoptimizing (DEOPT eager): begin 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> (opt #256) @133, FP to SP delta: 776, caller sp: 0x7fff5fbfce38]
            ;;; deoptimize at 0_12794: wrong map
  reading input frame forEachChild => node=95, args=4, height=5; inputs:
      0: 0xd6230dc36a9 ; [fp - 16] 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>
      1: 0x16f3adb61821 ; [fp + 40] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x27864c476619 ; rdx 0x27864c476619 <a NodeObject with map 0x33abe2a72201>
      3: 0x2f05bb805f51 ; [fp + 24] 0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>
      4: 0x2f05bb804889 ; [fp + 16] 0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>
      5: 0xd6230d99249 ; rbx 0xd6230d99249 <FixedArray[15]>
      6: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0xd6230dd5d69 ; [fp - 32] 0xd6230dd5d69 <JS Function visitNodeArray (SharedFunctionInfo 0x3504a53f0029)>
      8: 0x2f05bb804889 ; [fp - 40] 0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>
      9: 0xe400000000 ; rax 228
  translating frame forEachChild => node=95, height=32
    0x7fff5fbfce30: [top + 88] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfce28: [top + 80] <- 0x27864c476619 ;  0x27864c476619 <a NodeObject with map 0x33abe2a72201>  (input #2)
    0x7fff5fbfce20: [top + 72] <- 0x2f05bb805f51 ;  0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>  (input #3)
    0x7fff5fbfce18: [top + 64] <- 0x2f05bb804889 ;  0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>  (input #4)
    0x7fff5fbfce10: [top + 56] <- 0x2c21d2577908 ;  caller's pc
    0x7fff5fbfce08: [top + 48] <- 0x7fff5fbfce80 ;  caller's fp
    0x7fff5fbfce00: [top + 40] <- 0xd6230d99249 ;  context    0xd6230d99249 <FixedArray[15]>  (input #5)
    0x7fff5fbfcdf8: [top + 32] <- 0xd6230dc36a9 ;  function    0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>  (input #0)
    0x7fff5fbfcdf0: [top + 24] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfcde8: [top + 16] <- 0xd6230dd5d69 ;  0xd6230dd5d69 <JS Function visitNodeArray (SharedFunctionInfo 0x3504a53f0029)>  (input #7)
    0x7fff5fbfcde0: [top + 8] <- 0x2f05bb804889 ;  0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>  (input #8)
    0x7fff5fbfcdd8: [top + 0] <- 0xe400000000 ;  228  (input #9)
[deoptimizing (eager): end 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> @133 => node=95, pc=0x2c21d24c2f46, caller sp=0x7fff5fbfce38, state=NO_REGISTERS, took 0.121 ms]
[deoptimizer unlinked: forEachChild / d6230dc36a9]
[deoptimizing (DEOPT lazy): begin 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> (opt #256) @241, FP to SP delta: 776, caller sp: 0x7fff5fbfd458]
  reading input frame forEachChild => node=2546, args=4, height=5; inputs:
      0: 0xd6230dc36a9 ; [fp - 16] 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>
      1: 0x16f3adb61821 ; [fp + 40] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x35fa3c43c8c1 ; [fp + 32] 0x35fa3c43c8c1 <a NodeObject with map 0x33abe2a68961>
      3: 0x2f05bb805f51 ; [fp + 24] 0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>
      4: 0x2f05bb804889 ; [fp + 16] 0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>
      5: 0xd6230d99249 ; [fp - 24] 0xd6230d99249 <FixedArray[15]>
      6: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      8: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      9: 0x30bcea404311 ; rax 0x30bcea404311 <undefined>
  translating frame forEachChild => node=2546, height=32
    0x7fff5fbfd450: [top + 88] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfd448: [top + 80] <- 0x35fa3c43c8c1 ;  0x35fa3c43c8c1 <a NodeObject with map 0x33abe2a68961>  (input #2)
    0x7fff5fbfd440: [top + 72] <- 0x2f05bb805f51 ;  0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>  (input #3)
    0x7fff5fbfd438: [top + 64] <- 0x2f05bb804889 ;  0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>  (input #4)
    0x7fff5fbfd430: [top + 56] <- 0x2c21d2577908 ;  caller's pc
    0x7fff5fbfd428: [top + 48] <- 0x7fff5fbfd4a0 ;  caller's fp
    0x7fff5fbfd420: [top + 40] <- 0xd6230d99249 ;  context    0xd6230d99249 <FixedArray[15]>  (input #5)
    0x7fff5fbfd418: [top + 32] <- 0xd6230dc36a9 ;  function    0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>  (input #0)
    0x7fff5fbfd410: [top + 24] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfd408: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #7)
    0x7fff5fbfd400: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #8)
    0x7fff5fbfd3f8: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
[deoptimizing (lazy): end 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> @241 => node=2546, pc=0x2c21d24c6fff, caller sp=0x7fff5fbfd458, state=TOS_REGISTER, took 0.093 ms]
[deoptimizing (DEOPT lazy): begin 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> (opt #256) @129, FP to SP delta: 776, caller sp: 0x7fff5fbfd988]
  reading input frame forEachChild => node=4394, args=4, height=5; inputs:
      0: 0xd6230dc36a9 ; [fp - 16] 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>
      1: 0x16f3adb61821 ; [fp + 40] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x35fa3c43b7f9 ; [fp + 32] 0x35fa3c43b7f9 <a NodeObject with map 0x33abe2a71231>
      3: 0x2f05bb805f51 ; [fp + 24] 0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>
      4: 0x2f05bb804889 ; [fp + 16] 0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>
      5: 0xd6230d99249 ; [fp - 24] 0xd6230d99249 <FixedArray[15]>
      6: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      8: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      9: 0x30bcea404311 ; rax 0x30bcea404311 <undefined>
  translating frame forEachChild => node=4394, height=32
    0x7fff5fbfd980: [top + 88] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfd978: [top + 80] <- 0x35fa3c43b7f9 ;  0x35fa3c43b7f9 <a NodeObject with map 0x33abe2a71231>  (input #2)
    0x7fff5fbfd970: [top + 72] <- 0x2f05bb805f51 ;  0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>  (input #3)
    0x7fff5fbfd968: [top + 64] <- 0x2f05bb804889 ;  0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>  (input #4)
    0x7fff5fbfd960: [top + 56] <- 0x2c21d2577908 ;  caller's pc
    0x7fff5fbfd958: [top + 48] <- 0x7fff5fbfd9d0 ;  caller's fp
    0x7fff5fbfd950: [top + 40] <- 0xd6230d99249 ;  context    0xd6230d99249 <FixedArray[15]>  (input #5)
    0x7fff5fbfd948: [top + 32] <- 0xd6230dc36a9 ;  function    0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>  (input #0)
    0x7fff5fbfd940: [top + 24] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfd938: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #7)
    0x7fff5fbfd930: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #8)
    0x7fff5fbfd928: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
[deoptimizing (lazy): end 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> @129 => node=4394, pc=0x2c21d24c89d8, caller sp=0x7fff5fbfd988, state=TOS_REGISTER, took 0.077 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:addDeclarationToSymbol) id{269,0} ---
(symbol, node, symbolFlags) {
            symbol.flags |= symbolFlags;
            node.symbol = symbol;
            if (!symbol.declarations) {
                symbol.declarations = [];
            }
            symbol.declarations.push(node);
            if (symbolFlags & 1952 /* HasExports */ && !symbol.exports) {
                symbol.exports = ts.createMap();
            }
            if (symbolFlags & 6240 /* HasMembers */ && !symbol.members) {
                symbol.members = ts.createMap();
            }
            if (symbolFlags & 107455 /* Value */) {
                var valueDeclaration = symbol.valueDeclaration;
                if (!valueDeclaration ||
                    (valueDeclaration.kind !== node.kind && valueDeclaration.kind === 230 /* ModuleDeclaration */)) {
                    // other kinds of value declarations take precedence over modules
                    symbol.valueDeclaration = node;
                }
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:declareSymbolAndAddToSymbolTableWorker) id{270,0} ---
(node, symbolFlags, symbolExcludes) {
            switch (container.kind) {
                // Modules, source files, and classes need specialized handling for how their
                // members are declared (for example, a member of a class will go into a specific
                // symbol table depending on if it is static or not). We defer to specialized
                // handlers to take care of declaring these child members.
                case 230 /* ModuleDeclaration */:
                    return declareModuleMember(node, symbolFlags, symbolExcludes);
                case 261 /* SourceFile */:
                    return declareSourceFileMember(node, symbolFlags, symbolExcludes);
                case 197 /* ClassExpression */:
                case 226 /* ClassDeclaration */:
                    return declareClassMember(node, symbolFlags, symbolExcludes);
                case 229 /* EnumDeclaration */:
                    return declareSymbol(container.symbol.exports, container.symbol, node, symbolFlags, symbolExcludes);
                case 161 /* TypeLiteral */:
                case 176 /* ObjectLiteralExpression */:
                case 227 /* InterfaceDeclaration */:
                case 270 /* JSDocRecordType */:
                case 287 /* JSDocTypeLiteral */:
                    // Interface/Object-types always have their children added to the 'members' of
                    // their container. They are only accessible through an instance of their
                    // container, and are never in scope otherwise (even inside the body of the
                    // object / type / interface declaring them). An exception is type parameters,
                    // which are in scope without qualification (similar to 'locals').
                    return declareSymbol(container.symbol.members, container.symbol, node, symbolFlags, symbolExcludes);
                case 158 /* FunctionType */:
                case 159 /* ConstructorType */:
                case 153 /* CallSignature */:
                case 154 /* ConstructSignature */:
                case 155 /* IndexSignature */:
                case 149 /* MethodDeclaration */:
                case 148 /* MethodSignature */:
                case 150 /* Constructor */:
                case 151 /* GetAccessor */:
                case 152 /* SetAccessor */:
                case 225 /* FunctionDeclaration */:
                case 184 /* FunctionExpression */:
                case 185 /* ArrowFunction */:
                case 274 /* JSDocFunctionType */:
                case 228 /* TypeAliasDeclaration */:
                case 170 /* MappedType */:
                    // All the children of these container types are never visible through another
                    // symbol (i.e. through another symbol's 'exports' or 'members').  Instead,
                    // they're only accessed 'lexically' (i.e. from code that exists underneath
                    // their container in the tree.  To accomplish this, we simply add their declared
                    // symbol to the 'locals' of the container.  These symbols can then be found as
                    // the type checker walks up the containers, checking them for matching names.
                    return declareSymbol(container.locals, /*parent*/ undefined, node, symbolFlags, symbolExcludes);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:declareSourceFileMember) id{270,1} ---
(node, symbolFlags, symbolExcludes) {
            return ts.isExternalModule(file)
                ? declareModuleMember(node, symbolFlags, symbolExcludes)
                : declareSymbol(file.locals, undefined, node, symbolFlags, symbolExcludes);
        }
--- END ---
INLINE (declareSourceFileMember) id{270,1} AS 1 AT <0:640>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:declareClassMember) id{270,2} ---
(node, symbolFlags, symbolExcludes) {
            return ts.hasModifier(node, 32 /* Static */)
                ? declareSymbol(container.symbol.exports, container.symbol, node, symbolFlags, symbolExcludes)
                : declareSymbol(container.symbol.members, container.symbol, node, symbolFlags, symbolExcludes);
        }
--- END ---
INLINE (declareClassMember) id{270,2} AS 2 AT <0:824>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:forEachChild) id{271,0} ---
(node, cbNode, cbNodeArray) {
        if (!node) {
            return;
        }
        // The visitXXX functions could be written as local functions that close over the cbNode and cbNodeArray
        // callback parameters, but that causes a closure allocation for each invocation with noticeable effects
        // on performance.
        var visitNodes = cbNodeArray ? visitNodeArray : visitEachNode;
        var cbNodes = cbNodeArray || cbNode;
        switch (node.kind) {
            case 141 /* QualifiedName */:
                return visitNode(cbNode, node.left) ||
                    visitNode(cbNode, node.right);
            case 143 /* TypeParameter */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.constraint) ||
                    visitNode(cbNode, node.expression);
            case 258 /* ShorthandPropertyAssignment */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNode(cbNode, node.equalsToken) ||
                    visitNode(cbNode, node.objectAssignmentInitializer);
            case 259 /* SpreadAssignment */:
                return visitNode(cbNode, node.expression);
            case 144 /* Parameter */:
            case 147 /* PropertyDeclaration */:
            case 146 /* PropertySignature */:
            case 257 /* PropertyAssignment */:
            case 223 /* VariableDeclaration */:
            case 174 /* BindingElement */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.propertyName) ||
                    visitNode(cbNode, node.dotDotDotToken) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNode(cbNode, node.type) ||
                    visitNode(cbNode, node.initializer);
            case 158 /* FunctionType */:
            case 159 /* ConstructorType */:
            case 153 /* CallSignature */:
            case 154 /* ConstructSignature */:
            case 155 /* IndexSignature */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNodes(cbNodes, node.parameters) ||
                    visitNode(cbNode, node.type);
            case 149 /* MethodDeclaration */:
            case 148 /* MethodSignature */:
            case 150 /* Constructor */:
            case 151 /* GetAccessor */:
            case 152 /* SetAccessor */:
            case 184 /* FunctionExpression */:
            case 225 /* FunctionDeclaration */:
            case 185 /* ArrowFunction */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.asteriskToken) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNodes(cbNodes, node.parameters) ||
                    visitNode(cbNode, node.type) ||
                    visitNode(cbNode, node.equalsGreaterThanToken) ||
                    visitNode(cbNode, node.body);
            case 157 /* TypeReference */:
                return visitNode(cbNode, node.typeName) ||
                    visitNodes(cbNodes, node.typeArguments);
            case 156 /* TypePredicate */:
                return visitNode(cbNode, node.parameterName) ||
                    visitNode(cbNode, node.type);
            case 160 /* TypeQuery */:
                return visitNode(cbNode, node.exprName);
            case 161 /* TypeLiteral */:
                return visitNodes(cbNodes, node.members);
            case 162 /* ArrayType */:
                return visitNode(cbNode, node.elementType);
            case 163 /* TupleType */:
                return visitNodes(cbNodes, node.elementTypes);
            case 164 /* UnionType */:
            case 165 /* IntersectionType */:
                return visitNodes(cbNodes, node.types);
            case 166 /* ParenthesizedType */:
            case 168 /* TypeOperator */:
                return visitNode(cbNode, node.type);
            case 169 /* IndexedAccessType */:
                return visitNode(cbNode, node.objectType) ||
                    visitNode(cbNode, node.indexType);
            case 170 /* MappedType */:
                return visitNode(cbNode, node.readonlyToken) ||
                    visitNode(cbNode, node.typeParameter) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNode(cbNode, node.type);
            case 171 /* LiteralType */:
                return visitNode(cbNode, node.literal);
            case 172 /* ObjectBindingPattern */:
            case 173 /* ArrayBindingPattern */:
                return visitNodes(cbNodes, node.elements);
            case 175 /* ArrayLiteralExpression */:
                return visitNodes(cbNodes, node.elements);
            case 176 /* ObjectLiteralExpression */:
                return visitNodes(cbNodes, node.properties);
            case 177 /* PropertyAccessExpression */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.name);
            case 178 /* ElementAccessExpression */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.argumentExpression);
            case 179 /* CallExpression */:
            case 180 /* NewExpression */:
                return visitNode(cbNode, node.expression) ||
                    visitNodes(cbNodes, node.typeArguments) ||
                    visitNodes(cbNodes, node.arguments);
            case 181 /* TaggedTemplateExpression */:
                return visitNode(cbNode, node.tag) ||
                    visitNode(cbNode, node.template);
            case 182 /* TypeAssertionExpression */:
                return visitNode(cbNode, node.type) ||
                    visitNode(cbNode, node.expression);
            case 183 /* ParenthesizedExpression */:
                return visitNode(cbNode, node.expression);
            case 186 /* DeleteExpression */:
                return visitNode(cbNode, node.expression);
            case 187 /* TypeOfExpression */:
                return visitNode(cbNode, node.expression);
            case 188 /* VoidExpression */:
                return visitNode(cbNode, node.expression);
            case 190 /* PrefixUnaryExpression */:
                return visitNode(cbNode, node.operand);
            case 195 /* YieldExpression */:
                return visitNode(cbNode, node.asteriskToken) ||
                    visitNode(cbNode, node.expression);
            case 189 /* AwaitExpression */:
                return visitNode(cbNode, node.expression);
            case 191 /* PostfixUnaryExpression */:
                return visitNode(cbNode, node.operand);
            case 192 /* BinaryExpression */:
                return visitNode(cbNode, node.left) ||
                    visitNode(cbNode, node.operatorToken) ||
                    visitNode(cbNode, node.right);
            case 200 /* AsExpression */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.type);
            case 201 /* NonNullExpression */:
                return visitNode(cbNode, node.expression);
            case 193 /* ConditionalExpression */:
                return visitNode(cbNode, node.condition) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNode(cbNode, node.whenTrue) ||
                    visitNode(cbNode, node.colonToken) ||
                    visitNode(cbNode, node.whenFalse);
            case 196 /* SpreadElement */:
                return visitNode(cbNode, node.expression);
            case 204 /* Block */:
            case 231 /* ModuleBlock */:
                return visitNodes(cbNodes, node.statements);
            case 261 /* SourceFile */:
                return visitNodes(cbNodes, node.statements) ||
                    visitNode(cbNode, node.endOfFileToken);
            case 205 /* VariableStatement */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.declarationList);
            case 224 /* VariableDeclarationList */:
                return visitNodes(cbNodes, node.declarations);
            case 207 /* ExpressionStatement */:
                return visitNode(cbNode, node.expression);
            case 208 /* IfStatement */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.thenStatement) ||
                    visitNode(cbNode, node.elseStatement);
            case 209 /* DoStatement */:
                return visitNode(cbNode, node.statement) ||
                    visitNode(cbNode, node.expression);
            case 210 /* WhileStatement */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.statement);
            case 211 /* ForStatement */:
                return visitNode(cbNode, node.initializer) ||
                    visitNode(cbNode, node.condition) ||
                    visitNode(cbNode, node.incrementor) ||
                    visitNode(cbNode, node.statement);
            case 212 /* ForInStatement */:
                return visitNode(cbNode, node.initializer) ||
                    visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.statement);
            case 213 /* ForOfStatement */:
                return visitNode(cbNode, node.initializer) ||
                    visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.statement);
            case 214 /* ContinueStatement */:
            case 215 /* BreakStatement */:
                return visitNode(cbNode, node.label);
            case 216 /* ReturnStatement */:
                return visitNode(cbNode, node.expression);
            case 217 /* WithStatement */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.statement);
            case 218 /* SwitchStatement */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.caseBlock);
            case 232 /* CaseBlock */:
                return visitNodes(cbNodes, node.clauses);
            case 253 /* CaseClause */:
                return visitNode(cbNode, node.expression) ||
                    visitNodes(cbNodes, node.statements);
            case 254 /* DefaultClause */:
                return visitNodes(cbNodes, node.statements);
            case 219 /* LabeledStatement */:
                return visitNode(cbNode, node.label) ||
                    visitNode(cbNode, node.statement);
            case 220 /* ThrowStatement */:
                return visitNode(cbNode, node.expression);
            case 221 /* TryStatement */:
                return visitNode(cbNode, node.tryBlock) ||
                    visitNode(cbNode, node.catchClause) ||
                    visitNode(cbNode, node.finallyBlock);
            case 256 /* CatchClause */:
                return visitNode(cbNode, node.variableDeclaration) ||
                    visitNode(cbNode, node.block);
            case 145 /* Decorator */:
                return visitNode(cbNode, node.expression);
            case 226 /* ClassDeclaration */:
            case 197 /* ClassExpression */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNodes(cbNodes, node.heritageClauses) ||
                    visitNodes(cbNodes, node.members);
            case 227 /* InterfaceDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNodes(cbNodes, node.heritageClauses) ||
                    visitNodes(cbNodes, node.members);
            case 228 /* TypeAliasDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNode(cbNode, node.type);
            case 229 /* EnumDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.members);
            case 260 /* EnumMember */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.initializer);
            case 230 /* ModuleDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.body);
            case 234 /* ImportEqualsDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.moduleReference);
            case 235 /* ImportDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.importClause) ||
                    visitNode(cbNode, node.moduleSpecifier);
            case 236 /* ImportClause */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.namedBindings);
            case 233 /* NamespaceExportDeclaration */:
                return visitNode(cbNode, node.name);
            case 237 /* NamespaceImport */:
                return visitNode(cbNode, node.name);
            case 238 /* NamedImports */:
            case 242 /* NamedExports */:
                return visitNodes(cbNodes, node.elements);
            case 241 /* ExportDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.exportClause) ||
                    visitNode(cbNode, node.moduleSpecifier);
            case 239 /* ImportSpecifier */:
            case 243 /* ExportSpecifier */:
                return visitNode(cbNode, node.propertyName) ||
                    visitNode(cbNode, node.name);
            case 240 /* ExportAssignment */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.expression);
            case 194 /* TemplateExpression */:
                return visitNode(cbNode, node.head) || visitNodes(cbNodes, node.templateSpans);
            case 202 /* TemplateSpan */:
                return visitNode(cbNode, node.expression) || visitNode(cbNode, node.literal);
            case 142 /* ComputedPropertyName */:
                return visitNode(cbNode, node.expression);
            case 255 /* HeritageClause */:
                return visitNodes(cbNodes, node.types);
            case 199 /* ExpressionWithTypeArguments */:
                return visitNode(cbNode, node.expression) ||
                    visitNodes(cbNodes, node.typeArguments);
            case 245 /* ExternalModuleReference */:
                return visitNode(cbNode, node.expression);
            case 244 /* MissingDeclaration */:
                return visitNodes(cbNodes, node.decorators);
            case 246 /* JsxElement */:
                return visitNode(cbNode, node.openingElement) ||
                    visitNodes(cbNodes, node.children) ||
                    visitNode(cbNode, node.closingElement);
            case 247 /* JsxSelfClosingElement */:
            case 248 /* JsxOpeningElement */:
                return visitNode(cbNode, node.tagName) ||
                    visitNodes(cbNodes, node.attributes);
            case 250 /* JsxAttribute */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.initializer);
            case 251 /* JsxSpreadAttribute */:
                return visitNode(cbNode, node.expression);
            case 252 /* JsxExpression */:
                return visitNode(cbNode, node.expression);
            case 249 /* JsxClosingElement */:
                return visitNode(cbNode, node.tagName);
            case 262 /* JSDocTypeExpression */:
                return visitNode(cbNode, node.type);
            case 266 /* JSDocUnionType */:
                return visitNodes(cbNodes, node.types);
            case 267 /* JSDocTupleType */:
                return visitNodes(cbNodes, node.types);
            case 265 /* JSDocArrayType */:
                return visitNode(cbNode, node.elementType);
            case 269 /* JSDocNonNullableType */:
                return visitNode(cbNode, node.type);
            case 268 /* JSDocNullableType */:
                return visitNode(cbNode, node.type);
            case 270 /* JSDocRecordType */:
                return visitNode(cbNode, node.literal);
            case 272 /* JSDocTypeReference */:
                return visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.typeArguments);
            case 273 /* JSDocOptionalType */:
                return visitNode(cbNode, node.type);
            case 274 /* JSDocFunctionType */:
                return visitNodes(cbNodes, node.parameters) ||
                    visitNode(cbNode, node.type);
            case 275 /* JSDocVariadicType */:
                return visitNode(cbNode, node.type);
            case 276 /* JSDocConstructorType */:
                return visitNode(cbNode, node.type);
            case 277 /* JSDocThisType */:
                return visitNode(cbNode, node.type);
            case 271 /* JSDocRecordMember */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.type);
            case 278 /* JSDocComment */:
                return visitNodes(cbNodes, node.tags);
            case 281 /* JSDocParameterTag */:
                return visitNode(cbNode, node.preParameterName) ||
                    visitNode(cbNode, node.typeExpression) ||
                    visitNode(cbNode, node.postParameterName);
            case 282 /* JSDocReturnTag */:
                return visitNode(cbNode, node.typeExpression);
            case 283 /* JSDocTypeTag */:
                return visitNode(cbNode, node.typeExpression);
            case 280 /* JSDocAugmentsTag */:
                return visitNode(cbNode, node.typeExpression);
            case 284 /* JSDocTemplateTag */:
                return visitNodes(cbNodes, node.typeParameters);
            case 285 /* JSDocTypedefTag */:
                return visitNode(cbNode, node.typeExpression) ||
                    visitNode(cbNode, node.fullName) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.jsDocTypeLiteral);
            case 287 /* JSDocTypeLiteral */:
                return visitNodes(cbNodes, node.jsDocPropertyTags);
            case 286 /* JSDocPropertyTag */:
                return visitNode(cbNode, node.typeExpression) ||
                    visitNode(cbNode, node.name);
            case 294 /* PartiallyEmittedExpression */:
                return visitNode(cbNode, node.expression);
            case 288 /* JSDocLiteralType */:
                return visitNode(cbNode, node.literal);
        }
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{271,1} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{271,1} AS 1 AT <0:544>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{271,2} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{271,2} AS 2 AT <0:596>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{271,3} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{271,3} AS 3 AT <0:692>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{271,4} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{271,4} AS 4 AT <0:744>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{271,5} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{271,5} AS 5 AT <0:802>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{271,6} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{271,6} AS 6 AT <0:1658>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{271,7} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{271,7} AS 7 AT <0:1718>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{271,8} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{271,8} AS 8 AT <0:1777>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{271,9} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{271,9} AS 9 AT <0:1837>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{271,10} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{271,10} AS 10 AT <0:1899>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{271,11} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{271,11} AS 11 AT <0:1951>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{271,12} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{271,12} AS 12 AT <0:2012>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{271,13} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{271,13} AS 13 AT <0:2064>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{271,14} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{271,14} AS 14 AT <0:2341>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{271,15} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{271,15} AS 15 AT <0:2401>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{271,16} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{271,16} AS 16 AT <0:2460>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{271,17} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{271,17} AS 17 AT <0:2524>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{271,18} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{271,18} AS 18 AT <0:2584>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{271,19} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{271,19} AS 19 AT <0:2984>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{271,20} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{271,20} AS 20 AT <0:3044>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{271,21} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{271,21} AS 21 AT <0:3103>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{271,22} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{271,22} AS 22 AT <0:3164>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{271,23} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{271,23} AS 23 AT <0:3216>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{271,24} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{271,24} AS 24 AT <0:3277>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{271,25} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{271,25} AS 25 AT <0:3341>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{271,26} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{271,26} AS 26 AT <0:3401>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{271,27} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{271,27} AS 27 AT <0:3453>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{271,28} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{271,28} AS 28 AT <0:3523>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{271,29} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{271,29} AS 29 AT <0:3618>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{271,30} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{271,30} AS 30 AT <0:3674>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{271,31} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{271,31} AS 31 AT <0:3780>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{271,32} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{271,32} AS 32 AT <0:3841>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{271,33} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{271,33} AS 33 AT <0:3932>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{271,34} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{271,34} AS 34 AT <0:4029>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{271,35} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{271,35} AS 35 AT <0:4125>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{271,36} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{271,36} AS 36 AT <0:4223>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{271,37} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{271,37} AS 37 AT <0:4369>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{271,38} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{271,38} AS 38 AT <0:4512>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{271,39} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{271,39} AS 39 AT <0:4611>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{271,40} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{271,40} AS 40 AT <0:4669>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{271,41} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{271,41} AS 41 AT <0:4766>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{271,42} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{271,42} AS 42 AT <0:4827>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{271,43} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{271,43} AS 43 AT <0:4888>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{271,44} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{271,44} AS 44 AT <0:4949>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{271,45} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{271,45} AS 45 AT <0:5042>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{271,46} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{271,46} AS 46 AT <0:5530>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{271,47} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{271,47} AS 47 AT <0:5588>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{271,48} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{271,48} AS 48 AT <0:8393>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{271,49} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{271,49} AS 49 AT <0:8453>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{271,50} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{271,50} AS 50 AT <0:8562>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{271,51} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{271,51} AS 51 AT <0:8622>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{271,52} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{271,52} AS 52 AT <0:8681>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{271,53} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{271,53} AS 53 AT <0:8797>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{271,54} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{271,54} AS 54 AT <0:11956>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{271,55} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{271,55} AS 55 AT <0:12016>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{271,56} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{271,56} AS 56 AT <0:12075>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{271,57} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{271,57} AS 57 AT <0:12127>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{271,58} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{271,58} AS 58 AT <0:12191>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:declareModuleMember) id{272,0} ---
(node, symbolFlags, symbolExcludes) {
            var hasExportModifier = ts.getCombinedModifierFlags(node) & 1 /* Export */;
            if (symbolFlags & 8388608 /* Alias */) {
                if (node.kind === 243 /* ExportSpecifier */ || (node.kind === 234 /* ImportEqualsDeclaration */ && hasExportModifier)) {
                    return declareSymbol(container.symbol.exports, container.symbol, node, symbolFlags, symbolExcludes);
                }
                else {
                    return declareSymbol(container.locals, undefined, node, symbolFlags, symbolExcludes);
                }
            }
            else {
                // Exported module members are given 2 symbols: A local symbol that is classified with an ExportValue,
                // ExportType, or ExportContainer flag, and an associated export symbol with all the correct flags set
                // on it. There are 2 main reasons:
                //
                //   1. We treat locals and exports of the same name as mutually exclusive within a container.
                //      That means the binder will issue a Duplicate Identifier error if you mix locals and exports
                //      with the same name in the same container.
                //      TODO: Make this a more specific error and decouple it from the exclusion logic.
                //   2. When we checkIdentifier in the checker, we set its resolved symbol to the local symbol,
                //      but return the export symbol (by calling getExportSymbolOfValueSymbolIfExported). That way
                //      when the emitter comes back to it, it knows not to qualify the name if it was found in a containing scope.
                // NOTE: Nested ambient modules always should go to to 'locals' table to prevent their automatic merge
                //       during global merging in the checker. Why? The only case when ambient module is permitted inside another module is module augmentation
                //       and this case is specially handled. Module augmentations should only be merged with original module definition
                //       and should never be merged directly with other augmentation, and the latter case would be possible if automatic merge is allowed.
                var isJSDocTypedefInJSDocNamespace = node.kind === 285 /* JSDocTypedefTag */ &&
                    node.name &&
                    node.name.kind === 70 /* Identifier */ &&
                    node.name.isInJSDocNamespace;
                if ((!ts.isAmbientModule(node) && (hasExportModifier || container.flags & 32 /* ExportContext */)) || isJSDocTypedefInJSDocNamespace) {
                    var exportKind = (symbolFlags & 107455 /* Value */ ? 1048576 /* ExportValue */ : 0) |
                        (symbolFlags & 793064 /* Type */ ? 2097152 /* ExportType */ : 0) |
                        (symbolFlags & 1920 /* Namespace */ ? 4194304 /* ExportNamespace */ : 0);
                    var local = declareSymbol(container.locals, undefined, node, exportKind, symbolExcludes);
                    local.exportSymbol = declareSymbol(container.symbol.exports, container.symbol, node, symbolFlags, symbolExcludes);
                    node.localSymbol = local;
                    return local;
                }
                else {
                    return declareSymbol(container.locals, undefined, node, symbolFlags, symbolExcludes);
                }
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createMap) id{273,0} ---
(template) {
        var map = createObject(null); // tslint:disable-line:no-null-keyword
        // Using 'delete' on an object causes V8 to put the object in dictionary mode.
        // This disables creation of hidden classes, which are expensive when an object is
        // constantly changing shape.
        map["__"] = undefined;
        delete map["__"];
        // Copies keys/values from template. Note that for..in will not throw if
        // template is undefined, and instead will just exit the loop.
        for (var key in template)
            if (hasOwnProperty.call(template, key)) {
                map[key] = template[key];
            }
        return map;
    }
--- END ---
[deoptimizing (DEOPT eager): begin 0xd6230dac271 <JS Function createMap (SharedFunctionInfo 0xc2bd2ae0b29)> (opt #273) @20, FP to SP delta: 72, caller sp: 0x7fff5fbfc4a8]
            ;;; deoptimize at 0_523: null or undefined in for-in
  reading input frame createMap => node=49, args=2, height=4; inputs:
      0: 0xd6230dac271 ; [fp - 16] 0xd6230dac271 <JS Function createMap (SharedFunctionInfo 0xc2bd2ae0b29)>
      1: 0x16f3adb61821 ; [fp + 24] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x30bcea404311 ; [fp + 16] 0x30bcea404311 <undefined>
      3: 0xd6230db3179 ; [fp - 24] 0xd6230db3179 <FixedArray[95]>
      4: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
      5: 0x3571adbc4761 ; [fp - 32] 0x3571adbc4761 <an Object with map 0x33abe2a3d1a1>
      6: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
  translating frame createMap => node=49, height=24
    0x7fff5fbfc4a0: [top + 64] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfc498: [top + 56] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #2)
    0x7fff5fbfc490: [top + 48] <- 0x2c21d2207e55 ;  caller's pc
    0x7fff5fbfc488: [top + 40] <- 0x7fff5fbfc4c0 ;  caller's fp
    0x7fff5fbfc480: [top + 32] <- 0xd6230db3179 ;  context    0xd6230db3179 <FixedArray[95]>  (input #3)
    0x7fff5fbfc478: [top + 24] <- 0xd6230dac271 ;  function    0xd6230dac271 <JS Function createMap (SharedFunctionInfo 0xc2bd2ae0b29)>  (input #0)
    0x7fff5fbfc470: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfc468: [top + 8] <- 0x3571adbc4761 ;  0x3571adbc4761 <an Object with map 0x33abe2a3d1a1>  (input #5)
    0x7fff5fbfc460: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
[deoptimizing (eager): end 0xd6230dac271 <JS Function createMap (SharedFunctionInfo 0xc2bd2ae0b29)> @20 => node=49, pc=0x2c21d23cd4a0, caller sp=0x7fff5fbfc4a8, state=NO_REGISTERS, took 0.066 ms]
[deoptimizing (DEOPT eager): begin 0xd6230dc82c9 <JS Function isAmbientModule (SharedFunctionInfo 0x3504a53cd0d9)> (opt #192) @4, FP to SP delta: 24, caller sp: 0x7fff5fbfcbd0]
            ;;; deoptimize at 0_94: wrong map
  reading input frame isAmbientModule => node=9, args=2, height=2; inputs:
      0: 0xd6230dc82c9 ; [fp - 16] 0xd6230dc82c9 <JS Function isAmbientModule (SharedFunctionInfo 0x3504a53cd0d9)>
      1: 0x16f3adb61821 ; [fp + 24] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x1d75d8660fd9 ; rbx 0x1d75d8660fd9 <a NodeObject with map 0x33abe2a70f71>
      3: 0xd6230db34c9 ; [fp - 24] 0xd6230db34c9 <FixedArray[156]>
      4: 0x30bcea4043b1 ; rax 0x30bcea4043b1 <true>
  translating frame isAmbientModule => node=9, height=8
    0x7fff5fbfcbc8: [top + 48] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfcbc0: [top + 40] <- 0x1d75d8660fd9 ;  0x1d75d8660fd9 <a NodeObject with map 0x33abe2a70f71>  (input #2)
    0x7fff5fbfcbb8: [top + 32] <- 0x2c21d252377a ;  caller's pc
    0x7fff5fbfcbb0: [top + 24] <- 0x7fff5fbfcc28 ;  caller's fp
    0x7fff5fbfcba8: [top + 16] <- 0xd6230db34c9 ;  context    0xd6230db34c9 <FixedArray[156]>  (input #3)
    0x7fff5fbfcba0: [top + 8] <- 0xd6230dc82c9 ;  function    0xd6230dc82c9 <JS Function isAmbientModule (SharedFunctionInfo 0x3504a53cd0d9)>  (input #0)
    0x7fff5fbfcb98: [top + 0] <- 0x30bcea4043b1 ;  0x30bcea4043b1 <true>  (input #4)
[deoptimizing (eager): end 0xd6230dc82c9 <JS Function isAmbientModule (SharedFunctionInfo 0x3504a53cd0d9)> @4 => node=9, pc=0x2c21d24ea867, caller sp=0x7fff5fbfcbd0, state=TOS_REGISTER, took 0.083 ms]
[deoptimizing (DEOPT eager): begin 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> (opt #271) @118, FP to SP delta: 776, caller sp: 0x7fff5fbfce38]
            ;;; deoptimize at 0_13552: wrong map
  reading input frame forEachChild => node=95, args=4, height=5; inputs:
      0: 0xd6230dc36a9 ; [fp - 16] 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>
      1: 0x16f3adb61821 ; [fp + 40] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x1d75d8660fd9 ; rbx 0x1d75d8660fd9 <a NodeObject with map 0x33abe2a72309>
      3: 0x2f05bb805f51 ; [fp + 24] 0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>
      4: 0x2f05bb804889 ; [fp + 16] 0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>
      5: 0xd6230d99249 ; [fp - 24] 0xd6230d99249 <FixedArray[15]>
      6: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0xd6230dd5d69 ; [fp - 32] 0xd6230dd5d69 <JS Function visitNodeArray (SharedFunctionInfo 0x3504a53f0029)>
      8: 0x2f05bb804889 ; [fp - 40] 0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>
      9: 0xe600000000 ; rax 230
  translating frame forEachChild => node=95, height=32
    0x7fff5fbfce30: [top + 88] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfce28: [top + 80] <- 0x1d75d8660fd9 ;  0x1d75d8660fd9 <a NodeObject with map 0x33abe2a72309>  (input #2)
    0x7fff5fbfce20: [top + 72] <- 0x2f05bb805f51 ;  0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>  (input #3)
    0x7fff5fbfce18: [top + 64] <- 0x2f05bb804889 ;  0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>  (input #4)
    0x7fff5fbfce10: [top + 56] <- 0x2c21d2577908 ;  caller's pc
    0x7fff5fbfce08: [top + 48] <- 0x7fff5fbfce80 ;  caller's fp
    0x7fff5fbfce00: [top + 40] <- 0xd6230d99249 ;  context    0xd6230d99249 <FixedArray[15]>  (input #5)
    0x7fff5fbfcdf8: [top + 32] <- 0xd6230dc36a9 ;  function    0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>  (input #0)
    0x7fff5fbfcdf0: [top + 24] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfcde8: [top + 16] <- 0xd6230dd5d69 ;  0xd6230dd5d69 <JS Function visitNodeArray (SharedFunctionInfo 0x3504a53f0029)>  (input #7)
    0x7fff5fbfcde0: [top + 8] <- 0x2f05bb804889 ;  0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>  (input #8)
    0x7fff5fbfcdd8: [top + 0] <- 0xe600000000 ;  230  (input #9)
[deoptimizing (eager): end 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> @118 => node=95, pc=0x2c21d24c2f46, caller sp=0x7fff5fbfce38, state=NO_REGISTERS, took 0.165 ms]
[deoptimizer unlinked: forEachChild / d6230dc36a9]
[deoptimizing (DEOPT eager): begin 0xd6230dd1771 <JS Function getCombinedNodeFlags (SharedFunctionInfo 0x3504a53df441)> (opt #239) @16, FP to SP delta: 48, caller sp: 0x7fff5fbfc428]
  reading input frame getCombinedNodeFlags => node=164, args=2, height=2; inputs:
      0: 0xd6230dd1771 ; [fp - 16] 0xd6230dd1771 <JS Function getCombinedNodeFlags (SharedFunctionInfo 0x3504a53df441)>
      1: 0x16f3adb61821 ; [fp + 24] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x1d75d866d909 ; rax 0x1d75d866d909 <a NodeObject with map 0x33abe2a68599>
      3: 0xd6230dd73d1 ; [fp - 24] 0xd6230dd73d1 <FixedArray[11]>
      4: 2 ; rdx 
  translating frame getCombinedNodeFlags => node=164, height=8
    0x7fff5fbfc420: [top + 48] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfc418: [top + 40] <- 0x1d75d866d909 ;  0x1d75d866d909 <a NodeObject with map 0x33abe2a68599>  (input #2)
    0x7fff5fbfc410: [top + 32] <- 0x2c21d258fff4 ;  caller's pc
    0x7fff5fbfc408: [top + 24] <- 0x7fff5fbfc448 ;  caller's fp
    0x7fff5fbfc400: [top + 16] <- 0xd6230dd73d1 ;  context    0xd6230dd73d1 <FixedArray[11]>  (input #3)
    0x7fff5fbfc3f8: [top + 8] <- 0xd6230dd1771 ;  function    0xd6230dd1771 <JS Function getCombinedNodeFlags (SharedFunctionInfo 0x3504a53df441)>  (input #0)
    0x7fff5fbfc3f0: [top + 0] <- 0x200000000 ;  2  (input #4)
[deoptimizing (eager): end 0xd6230dd1771 <JS Function getCombinedNodeFlags (SharedFunctionInfo 0x3504a53df441)> @16 => node=164, pc=0x2c21d23fe217, caller sp=0x7fff5fbfc428, state=NO_REGISTERS, took 0.095 ms]
[deoptimizing (DEOPT eager): begin 0x2f05bb8047b1 <JS Function declareModuleMember (SharedFunctionInfo 0x16f3adb58121)> (opt #272) @18, FP to SP delta: 72, caller sp: 0x7fff5fbfc418]
            ;;; deoptimize at 0_3012: wrong map
  reading input frame declareModuleMember => node=347, args=4, height=6; inputs:
      0: 0x2f05bb8047b1 ; [fp - 16] 0x2f05bb8047b1 <JS Function declareModuleMember (SharedFunctionInfo 0x16f3adb58121)>
      1: 0x1f9f6c0532e1 ; [fp + 40] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1d75d86c5599 ; [fp + 32] 0x1d75d86c5599 <a NodeObject with map 0x33abe2a6fa21>
      3: 0x200000000 ; [fp + 24] 2
      4: 0x1a3bf00000000 ; [fp + 16] 107455
      5: 0xd6230dfeea1 ; rdx 0xd6230dfeea1 <FixedArray[147]>
      6: 1 ; rax 
      7: 0x30bcea4069a9 ; (literal 2) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      8: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
      9: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
     10: 1048576 ; rbx 
  translating frame declareModuleMember => node=347, height=40
    0x7fff5fbfc410: [top + 96] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfc408: [top + 88] <- 0x1d75d86c5599 ;  0x1d75d86c5599 <a NodeObject with map 0x33abe2a6fa21>  (input #2)
    0x7fff5fbfc400: [top + 80] <- 0x200000000 ;  2  (input #3)
    0x7fff5fbfc3f8: [top + 72] <- 0x1a3bf00000000 ;  107455  (input #4)
    0x7fff5fbfc3f0: [top + 64] <- 0x2c21d23fe76f ;  caller's pc
    0x7fff5fbfc3e8: [top + 56] <- 0x7fff5fbfc438 ;  caller's fp
    0x7fff5fbfc3e0: [top + 48] <- 0xd6230dfeea1 ;  context    0xd6230dfeea1 <FixedArray[147]>  (input #5)
    0x7fff5fbfc3d8: [top + 40] <- 0x2f05bb8047b1 ;  function    0x2f05bb8047b1 <JS Function declareModuleMember (SharedFunctionInfo 0x16f3adb58121)>  (input #0)
    0x7fff5fbfc3d0: [top + 32] <- 0x100000000 ;  1  (input #6)
    0x7fff5fbfc3c8: [top + 24] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #7)
    0x7fff5fbfc3c0: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfc3b8: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
    0x7fff5fbfc3b0: [top + 0] <- 0x10000000000000 ;  1048576  (input #10)
[deoptimizing (eager): end 0x2f05bb8047b1 <JS Function declareModuleMember (SharedFunctionInfo 0x16f3adb58121)> @18 => node=347, pc=0x2c21d2573050, caller sp=0x7fff5fbfc418, state=TOS_REGISTER, took 0.110 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:bindBlockScopedDeclaration) id{274,0} ---
(node, symbolFlags, symbolExcludes) {
            switch (blockScopeContainer.kind) {
                case 230 /* ModuleDeclaration */:
                    declareModuleMember(node, symbolFlags, symbolExcludes);
                    break;
                case 261 /* SourceFile */:
                    if (ts.isExternalModule(container)) {
                        declareModuleMember(node, symbolFlags, symbolExcludes);
                        break;
                    }
                // fall through.
                default:
                    if (!blockScopeContainer.locals) {
                        blockScopeContainer.locals = ts.createMap();
                        addToContainerChain(blockScopeContainer);
                    }
                    declareSymbol(blockScopeContainer.locals, undefined, node, symbolFlags, symbolExcludes);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isAmbientModule) id{275,0} ---
(node) {
        return node && node.kind === 230 /* ModuleDeclaration */ &&
            (node.name.kind === 9 /* StringLiteral */ || isGlobalScopeAugmentation(node));
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isGlobalScopeAugmentation) id{275,1} ---
(module) {
        return !!(module.flags & 512 /* GlobalAugmentation */);
    }
--- END ---
INLINE (isGlobalScopeAugmentation) id{275,1} AS 1 AT <0:134>
[deoptimizing (DEOPT lazy): begin 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> (opt #271) @241, FP to SP delta: 776, caller sp: 0x7fff5fbfd458]
  reading input frame forEachChild => node=2546, args=4, height=5; inputs:
      0: 0xd6230dc36a9 ; [fp - 16] 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>
      1: 0x16f3adb61821 ; [fp + 40] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x27864c479ef1 ; [fp + 32] 0x27864c479ef1 <a NodeObject with map 0x33abe2a71b79>
      3: 0x2f05bb805f51 ; [fp + 24] 0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>
      4: 0x2f05bb804889 ; [fp + 16] 0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>
      5: 0xd6230d99249 ; [fp - 24] 0xd6230d99249 <FixedArray[15]>
      6: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      8: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      9: 0x30bcea404311 ; rax 0x30bcea404311 <undefined>
  translating frame forEachChild => node=2546, height=32
    0x7fff5fbfd450: [top + 88] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfd448: [top + 80] <- 0x27864c479ef1 ;  0x27864c479ef1 <a NodeObject with map 0x33abe2a71b79>  (input #2)
    0x7fff5fbfd440: [top + 72] <- 0x2f05bb805f51 ;  0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>  (input #3)
    0x7fff5fbfd438: [top + 64] <- 0x2f05bb804889 ;  0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>  (input #4)
    0x7fff5fbfd430: [top + 56] <- 0x2c21d2577908 ;  caller's pc
    0x7fff5fbfd428: [top + 48] <- 0x7fff5fbfd4a0 ;  caller's fp
    0x7fff5fbfd420: [top + 40] <- 0xd6230d99249 ;  context    0xd6230d99249 <FixedArray[15]>  (input #5)
    0x7fff5fbfd418: [top + 32] <- 0xd6230dc36a9 ;  function    0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>  (input #0)
    0x7fff5fbfd410: [top + 24] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfd408: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #7)
    0x7fff5fbfd400: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #8)
    0x7fff5fbfd3f8: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
[deoptimizing (lazy): end 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> @241 => node=2546, pc=0x2c21d24c6fff, caller sp=0x7fff5fbfd458, state=TOS_REGISTER, took 0.145 ms]
[deoptimizing (DEOPT lazy): begin 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> (opt #271) @129, FP to SP delta: 776, caller sp: 0x7fff5fbfd988]
  reading input frame forEachChild => node=4394, args=4, height=5; inputs:
      0: 0xd6230dc36a9 ; [fp - 16] 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>
      1: 0x16f3adb61821 ; [fp + 40] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x27864c477591 ; [fp + 32] 0x27864c477591 <a NodeObject with map 0x33abe2a71231>
      3: 0x2f05bb805f51 ; [fp + 24] 0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>
      4: 0x2f05bb804889 ; [fp + 16] 0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>
      5: 0xd6230d99249 ; [fp - 24] 0xd6230d99249 <FixedArray[15]>
      6: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      8: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      9: 0x30bcea404311 ; rax 0x30bcea404311 <undefined>
  translating frame forEachChild => node=4394, height=32
    0x7fff5fbfd980: [top + 88] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfd978: [top + 80] <- 0x27864c477591 ;  0x27864c477591 <a NodeObject with map 0x33abe2a71231>  (input #2)
    0x7fff5fbfd970: [top + 72] <- 0x2f05bb805f51 ;  0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>  (input #3)
    0x7fff5fbfd968: [top + 64] <- 0x2f05bb804889 ;  0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>  (input #4)
    0x7fff5fbfd960: [top + 56] <- 0x2c21d2577908 ;  caller's pc
    0x7fff5fbfd958: [top + 48] <- 0x7fff5fbfd9d0 ;  caller's fp
    0x7fff5fbfd950: [top + 40] <- 0xd6230d99249 ;  context    0xd6230d99249 <FixedArray[15]>  (input #5)
    0x7fff5fbfd948: [top + 32] <- 0xd6230dc36a9 ;  function    0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>  (input #0)
    0x7fff5fbfd940: [top + 24] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfd938: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #7)
    0x7fff5fbfd930: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #8)
    0x7fff5fbfd928: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
[deoptimizing (lazy): end 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> @129 => node=4394, pc=0x2c21d24c89d8, caller sp=0x7fff5fbfd988, state=TOS_REGISTER, took 0.114 ms]
[deoptimizing (DEOPT eager): begin 0x2f05bb806029 <JS Function bindWorker (SharedFunctionInfo 0x16f3adb5c261)> (opt #258) @114, FP to SP delta: 288, caller sp: 0x7fff5fbfd210]
            ;;; deoptimize at 0_4266: Unknown map in polymorphic access
  reading input frame bindWorker => node=733, args=2, height=7; inputs:
      0: 0x2f05bb806029 ; [fp - 16] 0x2f05bb806029 <JS Function bindWorker (SharedFunctionInfo 0x16f3adb5c261)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1d75d8677409 ; rdx 0x1d75d8677409 <a NodeObject with map 0x33abe2a693b1>
      3: 0xd6230dfeea1 ; rax 0xd6230dfeea1 <FixedArray[147]>
      4: 0x30bcea4069a9 ; (literal 26) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      5: 0x30bcea404311 ; (literal 25) 0x30bcea404311 <undefined>
      6: 0x30bcea404311 ; (literal 25) 0x30bcea404311 <undefined>
      7: 0x30bcea404311 ; (literal 25) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; (literal 25) 0x30bcea404311 <undefined>
      9: 0x30bcea404311 ; (literal 25) 0x30bcea404311 <undefined>
  translating frame bindWorker => node=733, height=48
    0x7fff5fbfd208: [top + 88] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd200: [top + 80] <- 0x1d75d8677409 ;  0x1d75d8677409 <a NodeObject with map 0x33abe2a693b1>  (input #2)
    0x7fff5fbfd1f8: [top + 72] <- 0x2c21d254dc06 ;  caller's pc
    0x7fff5fbfd1f0: [top + 64] <- 0x7fff5fbfd238 ;  caller's fp
    0x7fff5fbfd1e8: [top + 56] <- 0xd6230dfeea1 ;  context    0xd6230dfeea1 <FixedArray[147]>  (input #3)
    0x7fff5fbfd1e0: [top + 48] <- 0x2f05bb806029 ;  function    0x2f05bb806029 <JS Function bindWorker (SharedFunctionInfo 0x16f3adb5c261)>  (input #0)
    0x7fff5fbfd1d8: [top + 40] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #4)
    0x7fff5fbfd1d0: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfd1c8: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfd1c0: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfd1b8: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfd1b0: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
[deoptimizing (eager): end 0x2f05bb806029 <JS Function bindWorker (SharedFunctionInfo 0x16f3adb5c261)> @114 => node=733, pc=0x2c21d2544048, caller sp=0x7fff5fbfd210, state=NO_REGISTERS, took 0.119 ms]
[deoptimizing (DEOPT eager): begin 0x2f05bb805699 <JS Function getContainerFlags (SharedFunctionInfo 0x16f3adb5a8e1)> (opt #261) @5, FP to SP delta: 40, caller sp: 0x7fff5fbfd210]
            ;;; deoptimize at 0_2333: wrong map
  reading input frame getContainerFlags => node=30, args=2, height=3; inputs:
      0: 0x2f05bb805699 ; [fp - 16] 0x2f05bb805699 <JS Function getContainerFlags (SharedFunctionInfo 0x16f3adb5a8e1)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1d75d8677409 ; rbx 0x1d75d8677409 <a NodeObject with map 0x33abe2a72519>
      3: 0xd6230dfeea1 ; [fp - 24] 0xd6230dfeea1 <FixedArray[147]>
      4: 0x30bcea4069a9 ; (literal 2) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      5: 0x9300000000 ; rax 147
  translating frame getContainerFlags => node=30, height=16
    0x7fff5fbfd208: [top + 56] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd200: [top + 48] <- 0x1d75d8677409 ;  0x1d75d8677409 <a NodeObject with map 0x33abe2a72519>  (input #2)
    0x7fff5fbfd1f8: [top + 40] <- 0x2c21d254dd0c ;  caller's pc
    0x7fff5fbfd1f0: [top + 32] <- 0x7fff5fbfd238 ;  caller's fp
    0x7fff5fbfd1e8: [top + 24] <- 0xd6230dfeea1 ;  context    0xd6230dfeea1 <FixedArray[147]>  (input #3)
    0x7fff5fbfd1e0: [top + 16] <- 0x2f05bb805699 ;  function    0x2f05bb805699 <JS Function getContainerFlags (SharedFunctionInfo 0x16f3adb5a8e1)>  (input #0)
    0x7fff5fbfd1d8: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #4)
    0x7fff5fbfd1d0: [top + 0] <- 0x9300000000 ;  147  (input #5)
[deoptimizing (eager): end 0x2f05bb805699 <JS Function getContainerFlags (SharedFunctionInfo 0x16f3adb5a8e1)> @5 => node=30, pc=0x2c21d2545ea3, caller sp=0x7fff5fbfd210, state=NO_REGISTERS, took 0.081 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:forEachChild) id{276,0} ---
(node, cbNode, cbNodeArray) {
        if (!node) {
            return;
        }
        // The visitXXX functions could be written as local functions that close over the cbNode and cbNodeArray
        // callback parameters, but that causes a closure allocation for each invocation with noticeable effects
        // on performance.
        var visitNodes = cbNodeArray ? visitNodeArray : visitEachNode;
        var cbNodes = cbNodeArray || cbNode;
        switch (node.kind) {
            case 141 /* QualifiedName */:
                return visitNode(cbNode, node.left) ||
                    visitNode(cbNode, node.right);
            case 143 /* TypeParameter */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.constraint) ||
                    visitNode(cbNode, node.expression);
            case 258 /* ShorthandPropertyAssignment */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNode(cbNode, node.equalsToken) ||
                    visitNode(cbNode, node.objectAssignmentInitializer);
            case 259 /* SpreadAssignment */:
                return visitNode(cbNode, node.expression);
            case 144 /* Parameter */:
            case 147 /* PropertyDeclaration */:
            case 146 /* PropertySignature */:
            case 257 /* PropertyAssignment */:
            case 223 /* VariableDeclaration */:
            case 174 /* BindingElement */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.propertyName) ||
                    visitNode(cbNode, node.dotDotDotToken) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNode(cbNode, node.type) ||
                    visitNode(cbNode, node.initializer);
            case 158 /* FunctionType */:
            case 159 /* ConstructorType */:
            case 153 /* CallSignature */:
            case 154 /* ConstructSignature */:
            case 155 /* IndexSignature */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNodes(cbNodes, node.parameters) ||
                    visitNode(cbNode, node.type);
            case 149 /* MethodDeclaration */:
            case 148 /* MethodSignature */:
            case 150 /* Constructor */:
            case 151 /* GetAccessor */:
            case 152 /* SetAccessor */:
            case 184 /* FunctionExpression */:
            case 225 /* FunctionDeclaration */:
            case 185 /* ArrowFunction */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.asteriskToken) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNodes(cbNodes, node.parameters) ||
                    visitNode(cbNode, node.type) ||
                    visitNode(cbNode, node.equalsGreaterThanToken) ||
                    visitNode(cbNode, node.body);
            case 157 /* TypeReference */:
                return visitNode(cbNode, node.typeName) ||
                    visitNodes(cbNodes, node.typeArguments);
            case 156 /* TypePredicate */:
                return visitNode(cbNode, node.parameterName) ||
                    visitNode(cbNode, node.type);
            case 160 /* TypeQuery */:
                return visitNode(cbNode, node.exprName);
            case 161 /* TypeLiteral */:
                return visitNodes(cbNodes, node.members);
            case 162 /* ArrayType */:
                return visitNode(cbNode, node.elementType);
            case 163 /* TupleType */:
                return visitNodes(cbNodes, node.elementTypes);
            case 164 /* UnionType */:
            case 165 /* IntersectionType */:
                return visitNodes(cbNodes, node.types);
            case 166 /* ParenthesizedType */:
            case 168 /* TypeOperator */:
                return visitNode(cbNode, node.type);
            case 169 /* IndexedAccessType */:
                return visitNode(cbNode, node.objectType) ||
                    visitNode(cbNode, node.indexType);
            case 170 /* MappedType */:
                return visitNode(cbNode, node.readonlyToken) ||
                    visitNode(cbNode, node.typeParameter) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNode(cbNode, node.type);
            case 171 /* LiteralType */:
                return visitNode(cbNode, node.literal);
            case 172 /* ObjectBindingPattern */:
            case 173 /* ArrayBindingPattern */:
                return visitNodes(cbNodes, node.elements);
            case 175 /* ArrayLiteralExpression */:
                return visitNodes(cbNodes, node.elements);
            case 176 /* ObjectLiteralExpression */:
                return visitNodes(cbNodes, node.properties);
            case 177 /* PropertyAccessExpression */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.name);
            case 178 /* ElementAccessExpression */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.argumentExpression);
            case 179 /* CallExpression */:
            case 180 /* NewExpression */:
                return visitNode(cbNode, node.expression) ||
                    visitNodes(cbNodes, node.typeArguments) ||
                    visitNodes(cbNodes, node.arguments);
            case 181 /* TaggedTemplateExpression */:
                return visitNode(cbNode, node.tag) ||
                    visitNode(cbNode, node.template);
            case 182 /* TypeAssertionExpression */:
                return visitNode(cbNode, node.type) ||
                    visitNode(cbNode, node.expression);
            case 183 /* ParenthesizedExpression */:
                return visitNode(cbNode, node.expression);
            case 186 /* DeleteExpression */:
                return visitNode(cbNode, node.expression);
            case 187 /* TypeOfExpression */:
                return visitNode(cbNode, node.expression);
            case 188 /* VoidExpression */:
                return visitNode(cbNode, node.expression);
            case 190 /* PrefixUnaryExpression */:
                return visitNode(cbNode, node.operand);
            case 195 /* YieldExpression */:
                return visitNode(cbNode, node.asteriskToken) ||
                    visitNode(cbNode, node.expression);
            case 189 /* AwaitExpression */:
                return visitNode(cbNode, node.expression);
            case 191 /* PostfixUnaryExpression */:
                return visitNode(cbNode, node.operand);
            case 192 /* BinaryExpression */:
                return visitNode(cbNode, node.left) ||
                    visitNode(cbNode, node.operatorToken) ||
                    visitNode(cbNode, node.right);
            case 200 /* AsExpression */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.type);
            case 201 /* NonNullExpression */:
                return visitNode(cbNode, node.expression);
            case 193 /* ConditionalExpression */:
                return visitNode(cbNode, node.condition) ||
                    visitNode(cbNode, node.questionToken) ||
                    visitNode(cbNode, node.whenTrue) ||
                    visitNode(cbNode, node.colonToken) ||
                    visitNode(cbNode, node.whenFalse);
            case 196 /* SpreadElement */:
                return visitNode(cbNode, node.expression);
            case 204 /* Block */:
            case 231 /* ModuleBlock */:
                return visitNodes(cbNodes, node.statements);
            case 261 /* SourceFile */:
                return visitNodes(cbNodes, node.statements) ||
                    visitNode(cbNode, node.endOfFileToken);
            case 205 /* VariableStatement */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.declarationList);
            case 224 /* VariableDeclarationList */:
                return visitNodes(cbNodes, node.declarations);
            case 207 /* ExpressionStatement */:
                return visitNode(cbNode, node.expression);
            case 208 /* IfStatement */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.thenStatement) ||
                    visitNode(cbNode, node.elseStatement);
            case 209 /* DoStatement */:
                return visitNode(cbNode, node.statement) ||
                    visitNode(cbNode, node.expression);
            case 210 /* WhileStatement */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.statement);
            case 211 /* ForStatement */:
                return visitNode(cbNode, node.initializer) ||
                    visitNode(cbNode, node.condition) ||
                    visitNode(cbNode, node.incrementor) ||
                    visitNode(cbNode, node.statement);
            case 212 /* ForInStatement */:
                return visitNode(cbNode, node.initializer) ||
                    visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.statement);
            case 213 /* ForOfStatement */:
                return visitNode(cbNode, node.initializer) ||
                    visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.statement);
            case 214 /* ContinueStatement */:
            case 215 /* BreakStatement */:
                return visitNode(cbNode, node.label);
            case 216 /* ReturnStatement */:
                return visitNode(cbNode, node.expression);
            case 217 /* WithStatement */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.statement);
            case 218 /* SwitchStatement */:
                return visitNode(cbNode, node.expression) ||
                    visitNode(cbNode, node.caseBlock);
            case 232 /* CaseBlock */:
                return visitNodes(cbNodes, node.clauses);
            case 253 /* CaseClause */:
                return visitNode(cbNode, node.expression) ||
                    visitNodes(cbNodes, node.statements);
            case 254 /* DefaultClause */:
                return visitNodes(cbNodes, node.statements);
            case 219 /* LabeledStatement */:
                return visitNode(cbNode, node.label) ||
                    visitNode(cbNode, node.statement);
            case 220 /* ThrowStatement */:
                return visitNode(cbNode, node.expression);
            case 221 /* TryStatement */:
                return visitNode(cbNode, node.tryBlock) ||
                    visitNode(cbNode, node.catchClause) ||
                    visitNode(cbNode, node.finallyBlock);
            case 256 /* CatchClause */:
                return visitNode(cbNode, node.variableDeclaration) ||
                    visitNode(cbNode, node.block);
            case 145 /* Decorator */:
                return visitNode(cbNode, node.expression);
            case 226 /* ClassDeclaration */:
            case 197 /* ClassExpression */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNodes(cbNodes, node.heritageClauses) ||
                    visitNodes(cbNodes, node.members);
            case 227 /* InterfaceDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNodes(cbNodes, node.heritageClauses) ||
                    visitNodes(cbNodes, node.members);
            case 228 /* TypeAliasDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.typeParameters) ||
                    visitNode(cbNode, node.type);
            case 229 /* EnumDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.members);
            case 260 /* EnumMember */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.initializer);
            case 230 /* ModuleDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.body);
            case 234 /* ImportEqualsDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.moduleReference);
            case 235 /* ImportDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.importClause) ||
                    visitNode(cbNode, node.moduleSpecifier);
            case 236 /* ImportClause */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.namedBindings);
            case 233 /* NamespaceExportDeclaration */:
                return visitNode(cbNode, node.name);
            case 237 /* NamespaceImport */:
                return visitNode(cbNode, node.name);
            case 238 /* NamedImports */:
            case 242 /* NamedExports */:
                return visitNodes(cbNodes, node.elements);
            case 241 /* ExportDeclaration */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.exportClause) ||
                    visitNode(cbNode, node.moduleSpecifier);
            case 239 /* ImportSpecifier */:
            case 243 /* ExportSpecifier */:
                return visitNode(cbNode, node.propertyName) ||
                    visitNode(cbNode, node.name);
            case 240 /* ExportAssignment */:
                return visitNodes(cbNodes, node.decorators) ||
                    visitNodes(cbNodes, node.modifiers) ||
                    visitNode(cbNode, node.expression);
            case 194 /* TemplateExpression */:
                return visitNode(cbNode, node.head) || visitNodes(cbNodes, node.templateSpans);
            case 202 /* TemplateSpan */:
                return visitNode(cbNode, node.expression) || visitNode(cbNode, node.literal);
            case 142 /* ComputedPropertyName */:
                return visitNode(cbNode, node.expression);
            case 255 /* HeritageClause */:
                return visitNodes(cbNodes, node.types);
            case 199 /* ExpressionWithTypeArguments */:
                return visitNode(cbNode, node.expression) ||
                    visitNodes(cbNodes, node.typeArguments);
            case 245 /* ExternalModuleReference */:
                return visitNode(cbNode, node.expression);
            case 244 /* MissingDeclaration */:
                return visitNodes(cbNodes, node.decorators);
            case 246 /* JsxElement */:
                return visitNode(cbNode, node.openingElement) ||
                    visitNodes(cbNodes, node.children) ||
                    visitNode(cbNode, node.closingElement);
            case 247 /* JsxSelfClosingElement */:
            case 248 /* JsxOpeningElement */:
                return visitNode(cbNode, node.tagName) ||
                    visitNodes(cbNodes, node.attributes);
            case 250 /* JsxAttribute */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.initializer);
            case 251 /* JsxSpreadAttribute */:
                return visitNode(cbNode, node.expression);
            case 252 /* JsxExpression */:
                return visitNode(cbNode, node.expression);
            case 249 /* JsxClosingElement */:
                return visitNode(cbNode, node.tagName);
            case 262 /* JSDocTypeExpression */:
                return visitNode(cbNode, node.type);
            case 266 /* JSDocUnionType */:
                return visitNodes(cbNodes, node.types);
            case 267 /* JSDocTupleType */:
                return visitNodes(cbNodes, node.types);
            case 265 /* JSDocArrayType */:
                return visitNode(cbNode, node.elementType);
            case 269 /* JSDocNonNullableType */:
                return visitNode(cbNode, node.type);
            case 268 /* JSDocNullableType */:
                return visitNode(cbNode, node.type);
            case 270 /* JSDocRecordType */:
                return visitNode(cbNode, node.literal);
            case 272 /* JSDocTypeReference */:
                return visitNode(cbNode, node.name) ||
                    visitNodes(cbNodes, node.typeArguments);
            case 273 /* JSDocOptionalType */:
                return visitNode(cbNode, node.type);
            case 274 /* JSDocFunctionType */:
                return visitNodes(cbNodes, node.parameters) ||
                    visitNode(cbNode, node.type);
            case 275 /* JSDocVariadicType */:
                return visitNode(cbNode, node.type);
            case 276 /* JSDocConstructorType */:
                return visitNode(cbNode, node.type);
            case 277 /* JSDocThisType */:
                return visitNode(cbNode, node.type);
            case 271 /* JSDocRecordMember */:
                return visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.type);
            case 278 /* JSDocComment */:
                return visitNodes(cbNodes, node.tags);
            case 281 /* JSDocParameterTag */:
                return visitNode(cbNode, node.preParameterName) ||
                    visitNode(cbNode, node.typeExpression) ||
                    visitNode(cbNode, node.postParameterName);
            case 282 /* JSDocReturnTag */:
                return visitNode(cbNode, node.typeExpression);
            case 283 /* JSDocTypeTag */:
                return visitNode(cbNode, node.typeExpression);
            case 280 /* JSDocAugmentsTag */:
                return visitNode(cbNode, node.typeExpression);
            case 284 /* JSDocTemplateTag */:
                return visitNodes(cbNodes, node.typeParameters);
            case 285 /* JSDocTypedefTag */:
                return visitNode(cbNode, node.typeExpression) ||
                    visitNode(cbNode, node.fullName) ||
                    visitNode(cbNode, node.name) ||
                    visitNode(cbNode, node.jsDocTypeLiteral);
            case 287 /* JSDocTypeLiteral */:
                return visitNodes(cbNodes, node.jsDocPropertyTags);
            case 286 /* JSDocPropertyTag */:
                return visitNode(cbNode, node.typeExpression) ||
                    visitNode(cbNode, node.name);
            case 294 /* PartiallyEmittedExpression */:
                return visitNode(cbNode, node.expression);
            case 288 /* JSDocLiteralType */:
                return visitNode(cbNode, node.literal);
        }
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{276,1} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{276,1} AS 1 AT <0:544>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{276,2} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{276,2} AS 2 AT <0:596>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{276,3} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{276,3} AS 3 AT <0:692>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{276,4} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{276,4} AS 4 AT <0:744>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{276,5} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{276,5} AS 5 AT <0:802>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{276,6} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{276,6} AS 6 AT <0:1658>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{276,7} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{276,7} AS 7 AT <0:1718>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{276,8} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{276,8} AS 8 AT <0:1777>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{276,9} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{276,9} AS 9 AT <0:1837>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{276,10} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{276,10} AS 10 AT <0:1899>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{276,11} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{276,11} AS 11 AT <0:1951>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{276,12} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{276,12} AS 12 AT <0:2012>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{276,13} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{276,13} AS 13 AT <0:2064>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{276,14} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{276,14} AS 14 AT <0:2341>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{276,15} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{276,15} AS 15 AT <0:2401>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{276,16} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{276,16} AS 16 AT <0:2460>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{276,17} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{276,17} AS 17 AT <0:2524>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{276,18} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{276,18} AS 18 AT <0:2584>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{276,19} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{276,19} AS 19 AT <0:2984>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{276,20} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{276,20} AS 20 AT <0:3044>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{276,21} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{276,21} AS 21 AT <0:3103>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{276,22} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{276,22} AS 22 AT <0:3164>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{276,23} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{276,23} AS 23 AT <0:3216>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{276,24} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{276,24} AS 24 AT <0:3277>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{276,25} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{276,25} AS 25 AT <0:3341>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{276,26} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{276,26} AS 26 AT <0:3401>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{276,27} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{276,27} AS 27 AT <0:3453>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{276,28} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{276,28} AS 28 AT <0:3523>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{276,29} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{276,29} AS 29 AT <0:3618>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{276,30} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{276,30} AS 30 AT <0:3674>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{276,31} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{276,31} AS 31 AT <0:3780>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{276,32} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{276,32} AS 32 AT <0:3841>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{276,33} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{276,33} AS 33 AT <0:3932>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{276,34} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{276,34} AS 34 AT <0:4029>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{276,35} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{276,35} AS 35 AT <0:4125>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{276,36} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{276,36} AS 36 AT <0:4223>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{276,37} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{276,37} AS 37 AT <0:4369>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{276,38} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{276,38} AS 38 AT <0:4512>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{276,39} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{276,39} AS 39 AT <0:4611>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{276,40} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{276,40} AS 40 AT <0:4669>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{276,41} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{276,41} AS 41 AT <0:4766>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{276,42} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{276,42} AS 42 AT <0:4827>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{276,43} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{276,43} AS 43 AT <0:4888>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{276,44} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{276,44} AS 44 AT <0:4949>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{276,45} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{276,45} AS 45 AT <0:5042>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{276,46} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{276,46} AS 46 AT <0:5530>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{276,47} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{276,47} AS 47 AT <0:5588>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{276,48} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{276,48} AS 48 AT <0:8393>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{276,49} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{276,49} AS 49 AT <0:8453>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{276,50} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{276,50} AS 50 AT <0:8562>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{276,51} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{276,51} AS 51 AT <0:8622>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{276,52} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{276,52} AS 52 AT <0:8681>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{276,53} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{276,53} AS 53 AT <0:8797>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{276,54} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{276,54} AS 54 AT <0:11956>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{276,55} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{276,55} AS 55 AT <0:12016>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNode) id{276,56} ---
(cbNode, node) {
        if (node) {
            return cbNode(node);
        }
    }
--- END ---
INLINE (visitNode) id{276,56} AS 56 AT <0:12075>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{276,57} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{276,57} AS 57 AT <0:12127>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visitNodeArray) id{276,58} ---
(cbNodes, nodes) {
        if (nodes) {
            return cbNodes(nodes);
        }
    }
--- END ---
INLINE (visitNodeArray) id{276,58} AS 58 AT <0:12191>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:bindWorker) id{277,0} ---
(node) {
            switch (node.kind) {
                /* Strict mode checks */
                case 70 /* Identifier */:
                    // for typedef type names with namespaces, bind the new jsdoc type symbol here
                    // because it requires all containing namespaces to be in effect, namely the
                    // current "blockScopeContainer" needs to be set to its immediate namespace parent.
                    if (node.isInJSDocNamespace) {
                        var parentNode = node.parent;
                        while (parentNode && parentNode.kind !== 285 /* JSDocTypedefTag */) {
                            parentNode = parentNode.parent;
                        }
                        bindBlockScopedDeclaration(parentNode, 524288 /* TypeAlias */, 793064 /* TypeAliasExcludes */);
                        break;
                    }
                case 98 /* ThisKeyword */:
                    if (currentFlow && (ts.isExpression(node) || parent.kind === 258 /* ShorthandPropertyAssignment */)) {
                        node.flowNode = currentFlow;
                    }
                    return checkStrictModeIdentifier(node);
                case 177 /* PropertyAccessExpression */:
                    if (currentFlow && isNarrowableReference(node)) {
                        node.flowNode = currentFlow;
                    }
                    break;
                case 192 /* BinaryExpression */:
                    if (ts.isInJavaScriptFile(node)) {
                        var specialKind = ts.getSpecialPropertyAssignmentKind(node);
                        switch (specialKind) {
                            case 1 /* ExportsProperty */:
                                bindExportsPropertyAssignment(node);
                                break;
                            case 2 /* ModuleExports */:
                                bindModuleExportsAssignment(node);
                                break;
                            case 3 /* PrototypeProperty */:
                                bindPrototypePropertyAssignment(node);
                                break;
                            case 4 /* ThisProperty */:
                                bindThisPropertyAssignment(node);
                                break;
                            case 0 /* None */:
                                // Nothing to do
                                break;
                            default:
                                ts.Debug.fail("Unknown special property assignment kind");
                        }
                    }
                    return checkStrictModeBinaryExpression(node);
                case 256 /* CatchClause */:
                    return checkStrictModeCatchClause(node);
                case 186 /* DeleteExpression */:
                    return checkStrictModeDeleteExpression(node);
                case 8 /* NumericLiteral */:
                    return checkStrictModeNumericLiteral(node);
                case 191 /* PostfixUnaryExpression */:
                    return checkStrictModePostfixUnaryExpression(node);
                case 190 /* PrefixUnaryExpression */:
                    return checkStrictModePrefixUnaryExpression(node);
                case 217 /* WithStatement */:
                    return checkStrictModeWithStatement(node);
                case 167 /* ThisType */:
                    seenThisKeyword = true;
                    return;
                case 156 /* TypePredicate */:
                    return checkTypePredicate(node);
                case 143 /* TypeParameter */:
                    return declareSymbolAndAddToSymbolTable(node, 262144 /* TypeParameter */, 530920 /* TypeParameterExcludes */);
                case 144 /* Parameter */:
                    return bindParameter(node);
                case 223 /* VariableDeclaration */:
                case 174 /* BindingElement */:
                    return bindVariableDeclarationOrBindingElement(node);
                case 147 /* PropertyDeclaration */:
                case 146 /* PropertySignature */:
                case 271 /* JSDocRecordMember */:
                    return bindPropertyOrMethodOrAccessor(node, 4 /* Property */ | (node.questionToken ? 536870912 /* Optional */ : 0 /* None */), 0 /* PropertyExcludes */);
                case 286 /* JSDocPropertyTag */:
                    return bindJSDocProperty(node);
                case 257 /* PropertyAssignment */:
                case 258 /* ShorthandPropertyAssignment */:
                    return bindPropertyOrMethodOrAccessor(node, 4 /* Property */, 0 /* PropertyExcludes */);
                case 260 /* EnumMember */:
                    return bindPropertyOrMethodOrAccessor(node, 8 /* EnumMember */, 900095 /* EnumMemberExcludes */);
                case 259 /* SpreadAssignment */:
                case 251 /* JsxSpreadAttribute */:
                    var root = container;
                    var hasRest = false;
                    while (root.parent) {
                        if (root.kind === 176 /* ObjectLiteralExpression */ &&
                            root.parent.kind === 192 /* BinaryExpression */ &&
                            root.parent.operatorToken.kind === 57 /* EqualsToken */ &&
                            root.parent.left === root) {
                            hasRest = true;
                            break;
                        }
                        root = root.parent;
                    }
                    return;
                case 153 /* CallSignature */:
                case 154 /* ConstructSignature */:
                case 155 /* IndexSignature */:
                    return declareSymbolAndAddToSymbolTable(node, 131072 /* Signature */, 0 /* None */);
                case 149 /* MethodDeclaration */:
                case 148 /* MethodSignature */:
                    // If this is an ObjectLiteralExpression method, then it sits in the same space
                    // as other properties in the object literal.  So we use SymbolFlags.PropertyExcludes
                    // so that it will conflict with any other object literal members with the same
                    // name.
                    return bindPropertyOrMethodOrAccessor(node, 8192 /* Method */ | (node.questionToken ? 536870912 /* Optional */ : 0 /* None */), ts.isObjectLiteralMethod(node) ? 0 /* PropertyExcludes */ : 99263 /* MethodExcludes */);
                case 225 /* FunctionDeclaration */:
                    return bindFunctionDeclaration(node);
                case 150 /* Constructor */:
                    return declareSymbolAndAddToSymbolTable(node, 16384 /* Constructor */, /*symbolExcludes:*/ 0 /* None */);
                case 151 /* GetAccessor */:
                    return bindPropertyOrMethodOrAccessor(node, 32768 /* GetAccessor */, 41919 /* GetAccessorExcludes */);
                case 152 /* SetAccessor */:
                    return bindPropertyOrMethodOrAccessor(node, 65536 /* SetAccessor */, 74687 /* SetAccessorExcludes */);
                case 158 /* FunctionType */:
                case 159 /* ConstructorType */:
                case 274 /* JSDocFunctionType */:
                    return bindFunctionOrConstructorType(node);
                case 161 /* TypeLiteral */:
                case 170 /* MappedType */:
                case 287 /* JSDocTypeLiteral */:
                case 270 /* JSDocRecordType */:
                    return bindAnonymousDeclaration(node, 2048 /* TypeLiteral */, "__type");
                case 176 /* ObjectLiteralExpression */:
                    return bindObjectLiteralExpression(node);
                case 184 /* FunctionExpression */:
                case 185 /* ArrowFunction */:
                    return bindFunctionExpression(node);
                case 179 /* CallExpression */:
                    if (ts.isInJavaScriptFile(node)) {
                        bindCallExpression(node);
                    }
                    break;
                // Members of classes, interfaces, and modules
                case 197 /* ClassExpression */:
                case 226 /* ClassDeclaration */:
                    // All classes are automatically in strict mode in ES6.
                    inStrictMode = true;
                    return bindClassLikeDeclaration(node);
                case 227 /* InterfaceDeclaration */:
                    return bindBlockScopedDeclaration(node, 64 /* Interface */, 792968 /* InterfaceExcludes */);
                case 285 /* JSDocTypedefTag */:
                    if (!node.fullName || node.fullName.kind === 70 /* Identifier */) {
                        return bindBlockScopedDeclaration(node, 524288 /* TypeAlias */, 793064 /* TypeAliasExcludes */);
                    }
                    break;
                case 228 /* TypeAliasDeclaration */:
                    return bindBlockScopedDeclaration(node, 524288 /* TypeAlias */, 793064 /* TypeAliasExcludes */);
                case 229 /* EnumDeclaration */:
                    return bindEnumDeclaration(node);
                case 230 /* ModuleDeclaration */:
                    return bindModuleDeclaration(node);
                // Imports and exports
                case 234 /* ImportEqualsDeclaration */:
                case 237 /* NamespaceImport */:
                case 239 /* ImportSpecifier */:
                case 243 /* ExportSpecifier */:
                    return declareSymbolAndAddToSymbolTable(node, 8388608 /* Alias */, 8388608 /* AliasExcludes */);
                case 233 /* NamespaceExportDeclaration */:
                    return bindNamespaceExportDeclaration(node);
                case 236 /* ImportClause */:
                    return bindImportClause(node);
                case 241 /* ExportDeclaration */:
                    return bindExportDeclaration(node);
                case 240 /* ExportAssignment */:
                    return bindExportAssignment(node);
                case 261 /* SourceFile */:
                    updateStrictModeStatementList(node.statements);
                    return bindSourceFileIfExternalModule();
                case 204 /* Block */:
                    if (!ts.isFunctionLike(node.parent)) {
                        return;
                    }
                // Fall through
                case 231 /* ModuleBlock */:
                    return updateStrictModeStatementList(node.statements);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isNarrowableReference) id{277,1} ---
(expr) {
            return expr.kind === 70 /* Identifier */ ||
                expr.kind === 98 /* ThisKeyword */ ||
                expr.kind === 177 /* PropertyAccessExpression */ && isNarrowableReference(expr.expression);
        }
--- END ---
INLINE (isNarrowableReference) id{277,1} AS 1 AT <0:1280>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkTypePredicate) id{277,2} ---
(node) {
            var parameterName = node.parameterName, type = node.type;
            if (parameterName && parameterName.kind === 70 /* Identifier */) {
                checkStrictModeIdentifier(parameterName);
            }
            if (parameterName && parameterName.kind === 167 /* ThisType */) {
                seenThisKeyword = true;
            }
            bind(type);
        }
--- END ---
INLINE (checkTypePredicate) id{277,2} AS 2 AT <0:3560>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:declareSymbolAndAddToSymbolTable) id{277,3} ---
(node, symbolFlags, symbolExcludes) {
            // Just call this directly so that the return type of this function stays "void".
            return declareSymbolAndAddToSymbolTableWorker(node, symbolFlags, symbolExcludes);
        }
--- END ---
INLINE (declareSymbolAndAddToSymbolTable) id{277,3} AS 3 AT <0:3659>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:declareSymbolAndAddToSymbolTable) id{277,4} ---
(node, symbolFlags, symbolExcludes) {
            // Just call this directly so that the return type of this function stays "void".
            return declareSymbolAndAddToSymbolTableWorker(node, symbolFlags, symbolExcludes);
        }
--- END ---
INLINE (declareSymbolAndAddToSymbolTable) id{277,4} AS 4 AT <0:5731>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:declareSymbolAndAddToSymbolTable) id{277,5} ---
(node, symbolFlags, symbolExcludes) {
            // Just call this directly so that the return type of this function stays "void".
            return declareSymbolAndAddToSymbolTableWorker(node, symbolFlags, symbolExcludes);
        }
--- END ---
INLINE (declareSymbolAndAddToSymbolTable) id{277,5} AS 5 AT <0:6660>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:bindAnonymousDeclaration) id{277,6} ---
(node, symbolFlags, name) {
            var symbol = createSymbol(symbolFlags, name);
            addDeclarationToSymbol(symbol, node, symbolFlags);
        }
--- END ---
INLINE (bindAnonymousDeclaration) id{277,6} AS 6 AT <0:7511>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createSymbol) id{277,7} ---
(flags, name) {
            symbolCount++;
            return new Symbol(flags, name);
        }
--- END ---
INLINE (createSymbol) id{277,7} AS 7 AT <6:53>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:SymbolObject) id{277,8} ---
(flags, name) {
            this.flags = flags;
            this.name = name;
        }
--- END ---
INLINE (SymbolObject) id{277,8} AS 8 AT <7:62>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:declareSymbolAndAddToSymbolTable) id{277,9} ---
(node, symbolFlags, symbolExcludes) {
            // Just call this directly so that the return type of this function stays "void".
            return declareSymbolAndAddToSymbolTableWorker(node, symbolFlags, symbolExcludes);
        }
--- END ---
INLINE (declareSymbolAndAddToSymbolTable) id{277,9} AS 9 AT <0:9502>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:bindImportClause) id{277,10} ---
(node) {
            if (node.name) {
                declareSymbolAndAddToSymbolTable(node, 8388608 /* Alias */, 8388608 /* AliasExcludes */);
            }
        }
--- END ---
INLINE (bindImportClause) id{277,10} AS 10 AT <0:9788>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:bindExportDeclaration) id{277,11} ---
(node) {
            if (!container.symbol || !container.symbol.exports) {
                // Export * in some sort of block construct
                bindAnonymousDeclaration(node, 1073741824 /* ExportStar */, getDeclarationName(node));
            }
            else if (!node.exportClause) {
                // All export * declarations are collected in an __export symbol
                declareSymbol(container.symbol.exports, container.symbol, node, 1073741824 /* ExportStar */, 0 /* None */);
            }
        }
--- END ---
INLINE (bindExportDeclaration) id{277,11} AS 11 AT <0:9889>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:updateStrictModeStatementList) id{277,12} ---
(statements) {
            if (!inStrictMode) {
                for (var _i = 0, statements_2 = statements; _i < statements_2.length; _i++) {
                    var statement = statements_2[_i];
                    if (!ts.isPrologueDirective(statement)) {
                        return;
                    }
                    if (isUseStrictPrologueDirective(statement)) {
                        inStrictMode = true;
                        return;
                    }
                }
            }
        }
--- END ---
INLINE (updateStrictModeStatementList) id{277,12} AS 12 AT <0:10085>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:bindSourceFileIfExternalModule) id{277,13} ---
() {
            setExportContextFlag(file);
            if (ts.isExternalModule(file)) {
                bindSourceFileAsExternalModule();
            }
        }
--- END ---
INLINE (bindSourceFileIfExternalModule) id{277,13} AS 13 AT <0:10160>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:setExportContextFlag) id{277,14} ---
(node) {
            // A declaration source file or ambient module declaration that contains no export declarations (but possibly regular
            // declarations with export modifiers) is an export context in which declarations are implicitly exported.
            if (ts.isInAmbientContext(node) && !hasExportDeclarations(node)) {
                node.flags |= 32 /* ExportContext */;
            }
            else {
                node.flags &= ~32 /* ExportContext */;
            }
        }
--- END ---
INLINE (setExportContextFlag) id{277,14} AS 14 AT <13:17>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:hasExportDeclarations) id{277,15} ---
(node) {
            var body = node.kind === 261 /* SourceFile */ ? node : node.body;
            if (body && (body.kind === 261 /* SourceFile */ || body.kind === 231 /* ModuleBlock */)) {
                for (var _i = 0, _a = body.statements; _i < _a.length; _i++) {
                    var stat = _a[_i];
                    if (stat.kind === 241 /* ExportDeclaration */ || stat.kind === 240 /* ExportAssignment */) {
                        return true;
                    }
                }
            }
            return false;
        }
--- END ---
INLINE (hasExportDeclarations) id{277,15} AS 15 AT <14:306>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:updateStrictModeStatementList) id{277,16} ---
(statements) {
            if (!inStrictMode) {
                for (var _i = 0, statements_2 = statements; _i < statements_2.length; _i++) {
                    var statement = statements_2[_i];
                    if (!ts.isPrologueDirective(statement)) {
                        return;
                    }
                    if (isUseStrictPrologueDirective(statement)) {
                        inStrictMode = true;
                        return;
                    }
                }
            }
        }
--- END ---
INLINE (updateStrictModeStatementList) id{277,16} AS 16 AT <0:10448>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getContainerFlags) id{278,0} ---
(node) {
            switch (node.kind) {
                case 197 /* ClassExpression */:
                case 226 /* ClassDeclaration */:
                case 229 /* EnumDeclaration */:
                case 176 /* ObjectLiteralExpression */:
                case 161 /* TypeLiteral */:
                case 287 /* JSDocTypeLiteral */:
                case 270 /* JSDocRecordType */:
                    return 1 /* IsContainer */;
                case 227 /* InterfaceDeclaration */:
                    return 1 /* IsContainer */ | 64 /* IsInterface */;
                case 274 /* JSDocFunctionType */:
                case 230 /* ModuleDeclaration */:
                case 228 /* TypeAliasDeclaration */:
                case 170 /* MappedType */:
                    return 1 /* IsContainer */ | 32 /* HasLocals */;
                case 261 /* SourceFile */:
                    return 1 /* IsContainer */ | 4 /* IsControlFlowContainer */ | 32 /* HasLocals */;
                case 149 /* MethodDeclaration */:
                    if (ts.isObjectLiteralOrClassExpressionMethod(node)) {
                        return 1 /* IsContainer */ | 4 /* IsControlFlowContainer */ | 32 /* HasLocals */ | 8 /* IsFunctionLike */ | 128 /* IsObjectLiteralOrClassExpressionMethod */;
                    }
                case 150 /* Constructor */:
                case 225 /* FunctionDeclaration */:
                case 148 /* MethodSignature */:
                case 151 /* GetAccessor */:
                case 152 /* SetAccessor */:
                case 153 /* CallSignature */:
                case 154 /* ConstructSignature */:
                case 155 /* IndexSignature */:
                case 158 /* FunctionType */:
                case 159 /* ConstructorType */:
                    return 1 /* IsContainer */ | 4 /* IsControlFlowContainer */ | 32 /* HasLocals */ | 8 /* IsFunctionLike */;
                case 184 /* FunctionExpression */:
                case 185 /* ArrowFunction */:
                    return 1 /* IsContainer */ | 4 /* IsControlFlowContainer */ | 32 /* HasLocals */ | 8 /* IsFunctionLike */ | 16 /* IsFunctionExpression */;
                case 231 /* ModuleBlock */:
                    return 4 /* IsControlFlowContainer */;
                case 147 /* PropertyDeclaration */:
                    return node.initializer ? 4 /* IsControlFlowContainer */ : 0;
                case 256 /* CatchClause */:
                case 211 /* ForStatement */:
                case 212 /* ForInStatement */:
                case 213 /* ForOfStatement */:
                case 232 /* CaseBlock */:
                    return 2 /* IsBlockScopedContainer */;
                case 204 /* Block */:
                    // do not treat blocks directly inside a function as a block-scoped-container.
                    // Locals that reside in this block should go to the function locals. Otherwise 'x'
                    // would not appear to be a redeclaration of a block scoped local in the following
                    // example:
                    //
                    //      function foo() {
                    //          var x;
                    //          let x;
                    //      }
                    //
                    // If we placed 'var x' into the function locals and 'let x' into the locals of
                    // the block, then there would be no collision.
                    //
                    // By not creating a new block-scoped-container here, we ensure that both 'var x'
                    // and 'let x' go into the Function-container's locals, and we do get a collision
                    // conflict.
                    return ts.isFunctionLike(node.parent) ? 0 /* None */ : 2 /* IsBlockScopedContainer */;
            }
            return 0 /* None */;
        }
--- END ---
[deoptimizing (DEOPT eager): begin 0xd6230dd0c99 <JS Function isObjectLiteralMethod (SharedFunctionInfo 0x3504a53cf059)> (opt #265) @6, FP to SP delta: 24, caller sp: 0x7fff5fbfc848]
  reading input frame isObjectLiteralMethod => node=9, args=2, height=2; inputs:
      0: 0xd6230dd0c99 ; [fp - 16] 0xd6230dd0c99 <JS Function isObjectLiteralMethod (SharedFunctionInfo 0x3504a53cf059)>
      1: 0x16f3adb61821 ; [fp + 24] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x1d75d86d1f09 ; rax 0x1d75d86d1f09 <a NodeObject with map 0x33abe2a68801>
      3: 0xd6230db34c9 ; [fp - 24] 0xd6230db34c9 <FixedArray[156]>
      4: 0x30bcea4043b1 ; rbx 0x30bcea4043b1 <true>
  translating frame isObjectLiteralMethod => node=9, height=8
    0x7fff5fbfc840: [top + 48] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfc838: [top + 40] <- 0x1d75d86d1f09 ;  0x1d75d86d1f09 <a NodeObject with map 0x33abe2a68801>  (input #2)
    0x7fff5fbfc830: [top + 32] <- 0x2c21d25db1c7 ;  caller's pc
    0x7fff5fbfc828: [top + 24] <- 0x7fff5fbfc968 ;  caller's fp
    0x7fff5fbfc820: [top + 16] <- 0xd6230db34c9 ;  context    0xd6230db34c9 <FixedArray[156]>  (input #3)
    0x7fff5fbfc818: [top + 8] <- 0xd6230dd0c99 ;  function    0xd6230dd0c99 <JS Function isObjectLiteralMethod (SharedFunctionInfo 0x3504a53cf059)>  (input #0)
    0x7fff5fbfc810: [top + 0] <- 0x30bcea4043b1 ;  0x30bcea4043b1 <true>  (input #4)
[deoptimizing (eager): end 0xd6230dd0c99 <JS Function isObjectLiteralMethod (SharedFunctionInfo 0x3504a53cf059)> @6 => node=9, pc=0x2c21d2549f87, caller sp=0x7fff5fbfc848, state=TOS_REGISTER, took 0.057 ms]
[deoptimizing (DEOPT eager): begin 0xd6230dcc5f9 <JS Function isObjectLiteralOrClassExpressionMethod (SharedFunctionInfo 0x3504a53cf119)> (opt #263) @4, FP to SP delta: 24, caller sp: 0x7fff5fbfc7d0]
            ;;; deoptimize at 0_93: wrong map
  reading input frame isObjectLiteralOrClassExpressionMethod => node=9, args=2, height=2; inputs:
      0: 0xd6230dcc5f9 ; [fp - 16] 0xd6230dcc5f9 <JS Function isObjectLiteralOrClassExpressionMethod (SharedFunctionInfo 0x3504a53cf119)>
      1: 0x16f3adb61821 ; [fp + 24] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x1d75d86d1f09 ; rbx 0x1d75d86d1f09 <a NodeObject with map 0x33abe2a68801>
      3: 0xd6230db34c9 ; [fp - 24] 0xd6230db34c9 <FixedArray[156]>
      4: 0x30bcea4043b1 ; rax 0x30bcea4043b1 <true>
  translating frame isObjectLiteralOrClassExpressionMethod => node=9, height=8
    0x7fff5fbfc7c8: [top + 48] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfc7c0: [top + 40] <- 0x1d75d86d1f09 ;  0x1d75d86d1f09 <a NodeObject with map 0x33abe2a68801>  (input #2)
    0x7fff5fbfc7b8: [top + 32] <- 0x2c21d25555d3 ;  caller's pc
    0x7fff5fbfc7b0: [top + 24] <- 0x7fff5fbfc818 ;  caller's fp
    0x7fff5fbfc7a8: [top + 16] <- 0xd6230db34c9 ;  context    0xd6230db34c9 <FixedArray[156]>  (input #3)
    0x7fff5fbfc7a0: [top + 8] <- 0xd6230dcc5f9 ;  function    0xd6230dcc5f9 <JS Function isObjectLiteralOrClassExpressionMethod (SharedFunctionInfo 0x3504a53cf119)>  (input #0)
    0x7fff5fbfc798: [top + 0] <- 0x30bcea4043b1 ;  0x30bcea4043b1 <true>  (input #4)
[deoptimizing (eager): end 0xd6230dcc5f9 <JS Function isObjectLiteralOrClassExpressionMethod (SharedFunctionInfo 0x3504a53cf119)> @4 => node=9, pc=0x2c21d2549b89, caller sp=0x7fff5fbfc7d0, state=TOS_REGISTER, took 0.095 ms]
[deoptimizing (DEOPT eager): begin 0x2f05bb805771 <JS Function declareSymbolAndAddToSymbolTableWorker (SharedFunctionInfo 0x16f3adb5ab21)> (opt #270) @17, FP to SP delta: 64, caller sp: 0x7fff5fbfc7d0]
            ;;; deoptimize at 2_247: wrong map
  reading input frame declareSymbolAndAddToSymbolTableWorker => node=101, args=4, height=3; inputs:
      0: 0x2f05bb805771 ; [fp - 16] 0x2f05bb805771 <JS Function declareSymbolAndAddToSymbolTableWorker (SharedFunctionInfo 0x16f3adb5ab21)>
      1: 0x1f9f6c0532e1 ; [fp + 40] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1d75d86d1f09 ; [fp + 32] 0x1d75d86d1f09 <a NodeObject with map 0x33abe2a68801>
      3: 0x200000000000 ; [fp + 24] 8192
      4: 0x183bf00000000 ; [fp + 16] 99263
      5: 0xd6230dfeea1 ; [fp - 24] 0xd6230dfeea1 <FixedArray[147]>
      6: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x2f05bb8057b9 ; [fp - 32] 0x2f05bb8057b9 <JS Function declareClassMember (SharedFunctionInfo 0x16f3adb5abe1)>
  reading input frame declareClassMember => node=8, args=4, height=1; inputs:
      0: 0x2f05bb8057b9 ; (literal 7) 0x2f05bb8057b9 <JS Function declareClassMember (SharedFunctionInfo 0x16f3adb5abe1)>
      1: 0x1f9f6c0532e1 ; (literal 8) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1d75d86d1f09 ; [fp + 32] 0x1d75d86d1f09 <a NodeObject with map 0x33abe2a68801>
      3: 0x200000000000 ; [fp + 24] 8192
      4: 0x183bf00000000 ; [fp + 16] 99263
      5: 0xd6230dfeea1 ; (literal 9) 0xd6230dfeea1 <FixedArray[147]>
  translating frame declareSymbolAndAddToSymbolTableWorker => node=101, height=16
    0x7fff5fbfc7c8: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfc7c0: [top + 64] <- 0x1d75d86d1f09 ;  0x1d75d86d1f09 <a NodeObject with map 0x33abe2a68801>  (input #2)
    0x7fff5fbfc7b8: [top + 56] <- 0x200000000000 ;  8192  (input #3)
    0x7fff5fbfc7b0: [top + 48] <- 0x183bf00000000 ;  99263  (input #4)
    0x7fff5fbfc7a8: [top + 40] <- 0x2c21d25556ed ;  caller's pc
    0x7fff5fbfc7a0: [top + 32] <- 0x7fff5fbfc818 ;  caller's fp
    0x7fff5fbfc798: [top + 24] <- 0xd6230dfeea1 ;  context    0xd6230dfeea1 <FixedArray[147]>  (input #5)
    0x7fff5fbfc790: [top + 16] <- 0x2f05bb805771 ;  function    0x2f05bb805771 <JS Function declareSymbolAndAddToSymbolTableWorker (SharedFunctionInfo 0x16f3adb5ab21)>  (input #0)
    0x7fff5fbfc788: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfc780: [top + 0] <- 0x2f05bb8057b9 ;  0x2f05bb8057b9 <JS Function declareClassMember (SharedFunctionInfo 0x16f3adb5abe1)>  (input #7)
  translating frame declareClassMember => node=8, height=0
    0x7fff5fbfc778: [top + 56] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfc770: [top + 48] <- 0x1d75d86d1f09 ;  0x1d75d86d1f09 <a NodeObject with map 0x33abe2a68801>  (input #2)
    0x7fff5fbfc768: [top + 40] <- 0x200000000000 ;  8192  (input #3)
    0x7fff5fbfc760: [top + 32] <- 0x183bf00000000 ;  99263  (input #4)
    0x7fff5fbfc758: [top + 24] <- 0x2c21d2526f53 ;  caller's pc
    0x7fff5fbfc750: [top + 16] <- 0x7fff5fbfc7a0 ;  caller's fp
    0x7fff5fbfc748: [top + 8] <- 0xd6230dfeea1 ;  context    0xd6230dfeea1 <FixedArray[147]>  (input #5)
    0x7fff5fbfc740: [top + 0] <- 0x2f05bb8057b9 ;  function    0x2f05bb8057b9 <JS Function declareClassMember (SharedFunctionInfo 0x16f3adb5abe1)>  (input #0)
[deoptimizing (eager): end 0x2f05bb805771 <JS Function declareSymbolAndAddToSymbolTableWorker (SharedFunctionInfo 0x16f3adb5ab21)> @17 => node=8, pc=0x2c21d25a4945, caller sp=0x7fff5fbfc7d0, state=NO_REGISTERS, took 0.214 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:declareClassMember) id{279,0} ---
(node, symbolFlags, symbolExcludes) {
            return ts.hasModifier(node, 32 /* Static */)
                ? declareSymbol(container.symbol.exports, container.symbol, node, symbolFlags, symbolExcludes)
                : declareSymbol(container.symbol.members, container.symbol, node, symbolFlags, symbolExcludes);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isObjectLiteralOrClassExpressionMethod) id{280,0} ---
(node) {
        return node.kind === 149 /* MethodDeclaration */ &&
            (node.parent.kind === 176 /* ObjectLiteralExpression */ ||
                node.parent.kind === 197 /* ClassExpression */);
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:declareSymbolAndAddToSymbolTableWorker) id{281,0} ---
(node, symbolFlags, symbolExcludes) {
            switch (container.kind) {
                // Modules, source files, and classes need specialized handling for how their
                // members are declared (for example, a member of a class will go into a specific
                // symbol table depending on if it is static or not). We defer to specialized
                // handlers to take care of declaring these child members.
                case 230 /* ModuleDeclaration */:
                    return declareModuleMember(node, symbolFlags, symbolExcludes);
                case 261 /* SourceFile */:
                    return declareSourceFileMember(node, symbolFlags, symbolExcludes);
                case 197 /* ClassExpression */:
                case 226 /* ClassDeclaration */:
                    return declareClassMember(node, symbolFlags, symbolExcludes);
                case 229 /* EnumDeclaration */:
                    return declareSymbol(container.symbol.exports, container.symbol, node, symbolFlags, symbolExcludes);
                case 161 /* TypeLiteral */:
                case 176 /* ObjectLiteralExpression */:
                case 227 /* InterfaceDeclaration */:
                case 270 /* JSDocRecordType */:
                case 287 /* JSDocTypeLiteral */:
                    // Interface/Object-types always have their children added to the 'members' of
                    // their container. They are only accessible through an instance of their
                    // container, and are never in scope otherwise (even inside the body of the
                    // object / type / interface declaring them). An exception is type parameters,
                    // which are in scope without qualification (similar to 'locals').
                    return declareSymbol(container.symbol.members, container.symbol, node, symbolFlags, symbolExcludes);
                case 158 /* FunctionType */:
                case 159 /* ConstructorType */:
                case 153 /* CallSignature */:
                case 154 /* ConstructSignature */:
                case 155 /* IndexSignature */:
                case 149 /* MethodDeclaration */:
                case 148 /* MethodSignature */:
                case 150 /* Constructor */:
                case 151 /* GetAccessor */:
                case 152 /* SetAccessor */:
                case 225 /* FunctionDeclaration */:
                case 184 /* FunctionExpression */:
                case 185 /* ArrowFunction */:
                case 274 /* JSDocFunctionType */:
                case 228 /* TypeAliasDeclaration */:
                case 170 /* MappedType */:
                    // All the children of these container types are never visible through another
                    // symbol (i.e. through another symbol's 'exports' or 'members').  Instead,
                    // they're only accessed 'lexically' (i.e. from code that exists underneath
                    // their container in the tree.  To accomplish this, we simply add their declared
                    // symbol to the 'locals' of the container.  These symbols can then be found as
                    // the type checker walks up the containers, checking them for matching names.
                    return declareSymbol(container.locals, /*parent*/ undefined, node, symbolFlags, symbolExcludes);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:declareSourceFileMember) id{281,1} ---
(node, symbolFlags, symbolExcludes) {
            return ts.isExternalModule(file)
                ? declareModuleMember(node, symbolFlags, symbolExcludes)
                : declareSymbol(file.locals, undefined, node, symbolFlags, symbolExcludes);
        }
--- END ---
INLINE (declareSourceFileMember) id{281,1} AS 1 AT <0:640>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:declareClassMember) id{281,2} ---
(node, symbolFlags, symbolExcludes) {
            return ts.hasModifier(node, 32 /* Static */)
                ? declareSymbol(container.symbol.exports, container.symbol, node, symbolFlags, symbolExcludes)
                : declareSymbol(container.symbol.members, container.symbol, node, symbolFlags, symbolExcludes);
        }
--- END ---
INLINE (declareClassMember) id{281,2} AS 2 AT <0:824>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isObjectLiteralMethod) id{282,0} ---
(node) {
        return node && node.kind === 149 /* MethodDeclaration */ && node.parent.kind === 176 /* ObjectLiteralExpression */;
    }
--- END ---
[deoptimizing (DEOPT eager): begin 0x2f05bb804691 <JS Function addDeclarationToSymbol (SharedFunctionInfo 0x16f3adb57e21)> (opt #269) @16, FP to SP delta: 64, caller sp: 0x7fff5fbfcc58]
            ;;; deoptimize at 0_307: Unknown map in polymorphic access
  reading input frame addDeclarationToSymbol => node=120, args=4, height=2; inputs:
      0: 0x2f05bb804691 ; [fp - 16] 0x2f05bb804691 <JS Function addDeclarationToSymbol (SharedFunctionInfo 0x16f3adb57e21)>
      1: 0x1f9f6c0532e1 ; [fp + 40] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1baf624d6e19 ; rbx 0x1baf624d6e19 <a SymbolObject with map 0x33abe2a6fb29>
      3: 0x1d75d867cf99 ; [fp + 24] 0x1d75d867cf99 <a NodeObject with map 0x33abe2a70f71>
      4: 0x20000000000 ; [fp + 16] 512
      5: 0xd6230dfeea1 ; [fp - 24] 0xd6230dfeea1 <FixedArray[147]>
      6: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
  translating frame addDeclarationToSymbol => node=120, height=8
    0x7fff5fbfcc50: [top + 64] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfcc48: [top + 56] <- 0x1baf624d6e19 ;  0x1baf624d6e19 <a SymbolObject with map 0x33abe2a6fb29>  (input #2)
    0x7fff5fbfcc40: [top + 48] <- 0x1d75d867cf99 ;  0x1d75d867cf99 <a NodeObject with map 0x33abe2a70f71>  (input #3)
    0x7fff5fbfcc38: [top + 40] <- 0x20000000000 ;  512  (input #4)
    0x7fff5fbfcc30: [top + 32] <- 0x2c21d257f06d ;  caller's pc
    0x7fff5fbfcc28: [top + 24] <- 0x7fff5fbfcca8 ;  caller's fp
    0x7fff5fbfcc20: [top + 16] <- 0xd6230dfeea1 ;  context    0xd6230dfeea1 <FixedArray[147]>  (input #5)
    0x7fff5fbfcc18: [top + 8] <- 0x2f05bb804691 ;  function    0x2f05bb804691 <JS Function addDeclarationToSymbol (SharedFunctionInfo 0x16f3adb57e21)>  (input #0)
    0x7fff5fbfcc10: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
[deoptimizing (eager): end 0x2f05bb804691 <JS Function addDeclarationToSymbol (SharedFunctionInfo 0x16f3adb57e21)> @16 => node=120, pc=0x2c21d2524ad8, caller sp=0x7fff5fbfcc58, state=NO_REGISTERS, took 0.065 ms]
--- FUNCTION SOURCE (native string.js:indexOf) id{283,0} ---
(s,t){
if((%IS_VAR(this)===null)||(this===(void 0)))throw %make_type_error(17,"String.prototype.indexOf");
var u=(%_ToString(this));
s=(%_ToString(s));
var v=(%_ToInteger(t));
if(v<0)v=0;
if(v>u.length)v=u.length;
return %StringIndexOf(u,s,v);
}
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getCombinedNodeFlags) id{284,0} ---
(node) {
        node = walkUpBindingElementsAndPatterns(node);
        var flags = node.flags;
        if (node.kind === 223 /* VariableDeclaration */) {
            node = node.parent;
        }
        if (node && node.kind === 224 /* VariableDeclarationList */) {
            flags |= node.flags;
            node = node.parent;
        }
        if (node && node.kind === 205 /* VariableStatement */) {
            flags |= node.flags;
        }
        return flags;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:walkUpBindingElementsAndPatterns) id{284,1} ---
(node) {
        while (node && (node.kind === 174 /* BindingElement */ || ts.isBindingPattern(node))) {
            node = node.parent;
        }
        return node;
    }
--- END ---
INLINE (walkUpBindingElementsAndPatterns) id{284,1} AS 1 AT <0:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:addDeclarationToSymbol) id{285,0} ---
(symbol, node, symbolFlags) {
            symbol.flags |= symbolFlags;
            node.symbol = symbol;
            if (!symbol.declarations) {
                symbol.declarations = [];
            }
            symbol.declarations.push(node);
            if (symbolFlags & 1952 /* HasExports */ && !symbol.exports) {
                symbol.exports = ts.createMap();
            }
            if (symbolFlags & 6240 /* HasMembers */ && !symbol.members) {
                symbol.members = ts.createMap();
            }
            if (symbolFlags & 107455 /* Value */) {
                var valueDeclaration = symbol.valueDeclaration;
                if (!valueDeclaration ||
                    (valueDeclaration.kind !== node.kind && valueDeclaration.kind === 230 /* ModuleDeclaration */)) {
                    // other kinds of value declarations take precedence over modules
                    symbol.valueDeclaration = node;
                }
            }
        }
--- END ---
[deoptimizing (DEOPT eager): begin 0xd6230dd1771 <JS Function getCombinedNodeFlags (SharedFunctionInfo 0x3504a53df441)> (opt #284) @9, FP to SP delta: 48, caller sp: 0x7fff5fbfcdf8]
            ;;; deoptimize at 0_88: wrong map
  reading input frame getCombinedNodeFlags => node=15, args=2, height=3; inputs:
      0: 0xd6230dd1771 ; [fp - 16] 0xd6230dd1771 <JS Function getCombinedNodeFlags (SharedFunctionInfo 0x3504a53df441)>
      1: 0x16f3adb61821 ; [fp + 24] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x1d75d8685d99 ; [fp + 16] 0x1d75d8685d99 <a NodeObject with map 0x33abe2a69461>
      3: 0xd6230dd73d1 ; [fp - 24] 0xd6230dd73d1 <FixedArray[11]>
      4: 0x30bcea404311 ; (literal 3) 0x30bcea404311 <undefined>
      5: 0x1d75d8685d99 ; rax 0x1d75d8685d99 <a NodeObject with map 0x33abe2a69461>
  translating frame getCombinedNodeFlags => node=15, height=16
    0x7fff5fbfcdf0: [top + 56] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfcde8: [top + 48] <- 0x1d75d8685d99 ;  0x1d75d8685d99 <a NodeObject with map 0x33abe2a69461>  (input #2)
    0x7fff5fbfcde0: [top + 40] <- 0x2c21d25df9da ;  caller's pc
    0x7fff5fbfcdd8: [top + 32] <- 0x7fff5fbfce10 ;  caller's fp
    0x7fff5fbfcdd0: [top + 24] <- 0xd6230dd73d1 ;  context    0xd6230dd73d1 <FixedArray[11]>  (input #3)
    0x7fff5fbfcdc8: [top + 16] <- 0xd6230dd1771 ;  function    0xd6230dd1771 <JS Function getCombinedNodeFlags (SharedFunctionInfo 0x3504a53df441)>  (input #0)
    0x7fff5fbfcdc0: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfcdb8: [top + 0] <- 0x1d75d8685d99 ;  0x1d75d8685d99 <a NodeObject with map 0x33abe2a69461>  (input #5)
[deoptimizing (eager): end 0xd6230dd1771 <JS Function getCombinedNodeFlags (SharedFunctionInfo 0x3504a53df441)> @9 => node=15, pc=0x2c21d23fe0a1, caller sp=0x7fff5fbfcdf8, state=TOS_REGISTER, took 0.065 ms]
[deoptimizing (DEOPT soft): begin 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> (opt #276) @131, FP to SP delta: 776, caller sp: 0x7fff5fbfce38]
            ;;; deoptimize at 0_13126: Insufficient type feedback for generic named access
  reading input frame forEachChild => node=95, args=4, height=5; inputs:
      0: 0xd6230dc36a9 ; [fp - 16] 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>
      1: 0x16f3adb61821 ; [fp + 40] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x1d75d8685d99 ; [fp + 32] 0x1d75d8685d99 <a NodeObject with map 0x33abe2a726d1>
      3: 0x2f05bb805f51 ; [fp + 24] 0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>
      4: 0x2f05bb804889 ; [fp + 16] 0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>
      5: 0xd6230d99249 ; rbx 0xd6230d99249 <FixedArray[15]>
      6: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0xd6230dd5d69 ; [fp - 32] 0xd6230dd5d69 <JS Function visitNodeArray (SharedFunctionInfo 0x3504a53f0029)>
      8: 0x2f05bb804889 ; [fp - 40] 0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>
      9: 0xe500000000 ; rax 229
  translating frame forEachChild => node=95, height=32
    0x7fff5fbfce30: [top + 88] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfce28: [top + 80] <- 0x1d75d8685d99 ;  0x1d75d8685d99 <a NodeObject with map 0x33abe2a726d1>  (input #2)
    0x7fff5fbfce20: [top + 72] <- 0x2f05bb805f51 ;  0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>  (input #3)
    0x7fff5fbfce18: [top + 64] <- 0x2f05bb804889 ;  0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>  (input #4)
    0x7fff5fbfce10: [top + 56] <- 0x2c21d2577908 ;  caller's pc
    0x7fff5fbfce08: [top + 48] <- 0x7fff5fbfce80 ;  caller's fp
    0x7fff5fbfce00: [top + 40] <- 0xd6230d99249 ;  context    0xd6230d99249 <FixedArray[15]>  (input #5)
    0x7fff5fbfcdf8: [top + 32] <- 0xd6230dc36a9 ;  function    0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>  (input #0)
    0x7fff5fbfcdf0: [top + 24] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfcde8: [top + 16] <- 0xd6230dd5d69 ;  0xd6230dd5d69 <JS Function visitNodeArray (SharedFunctionInfo 0x3504a53f0029)>  (input #7)
    0x7fff5fbfcde0: [top + 8] <- 0x2f05bb804889 ;  0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>  (input #8)
    0x7fff5fbfcdd8: [top + 0] <- 0xe500000000 ;  229  (input #9)
[deoptimizing (soft): end 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> @131 => node=95, pc=0x2c21d24c2f46, caller sp=0x7fff5fbfce38, state=NO_REGISTERS, took 0.128 ms]
[deoptimizer unlinked: forEachChild / d6230dc36a9]
[deoptimizing (DEOPT soft): begin 0x2f05bb805771 <JS Function declareSymbolAndAddToSymbolTableWorker (SharedFunctionInfo 0x16f3adb5ab21)> (opt #281) @11, FP to SP delta: 64, caller sp: 0x7fff5fbfcaa8]
            ;;; deoptimize at 0_977: Insufficient type feedback for generic named access
  reading input frame declareSymbolAndAddToSymbolTableWorker => node=30, args=4, height=3; inputs:
      0: 0x2f05bb805771 ; [fp - 16] 0x2f05bb805771 <JS Function declareSymbolAndAddToSymbolTableWorker (SharedFunctionInfo 0x16f3adb5ab21)>
      1: 0x1f9f6c0532e1 ; [fp + 40] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1d75d86e5b59 ; [fp + 32] 0x1d75d86e5b59 <a NodeObject with map 0x33abe2a69409>
      3: 0x800000000 ; [fp + 24] 8
      4: 0xdbbff00000000 ; [fp + 16] 900095
      5: 0xd6230dfeea1 ; rbx 0xd6230dfeea1 <FixedArray[147]>
      6: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0xe500000000 ; rax 229
  translating frame declareSymbolAndAddToSymbolTableWorker => node=30, height=16
    0x7fff5fbfcaa0: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfca98: [top + 64] <- 0x1d75d86e5b59 ;  0x1d75d86e5b59 <a NodeObject with map 0x33abe2a69409>  (input #2)
    0x7fff5fbfca90: [top + 56] <- 0x800000000 ;  8  (input #3)
    0x7fff5fbfca88: [top + 48] <- 0xdbbff00000000 ;  900095  (input #4)
    0x7fff5fbfca80: [top + 40] <- 0x2c21d25556ed ;  caller's pc
    0x7fff5fbfca78: [top + 32] <- 0x7fff5fbfcaf0 ;  caller's fp
    0x7fff5fbfca70: [top + 24] <- 0xd6230dfeea1 ;  context    0xd6230dfeea1 <FixedArray[147]>  (input #5)
    0x7fff5fbfca68: [top + 16] <- 0x2f05bb805771 ;  function    0x2f05bb805771 <JS Function declareSymbolAndAddToSymbolTableWorker (SharedFunctionInfo 0x16f3adb5ab21)>  (input #0)
    0x7fff5fbfca60: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfca58: [top + 0] <- 0xe500000000 ;  229  (input #7)
[deoptimizing (soft): end 0x2f05bb805771 <JS Function declareSymbolAndAddToSymbolTableWorker (SharedFunctionInfo 0x16f3adb5ab21)> @11 => node=30, pc=0x2c21d2526886, caller sp=0x7fff5fbfcaa8, state=NO_REGISTERS, took 0.067 ms]
[deoptimizing (DEOPT lazy): begin 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> (opt #276) @241, FP to SP delta: 776, caller sp: 0x7fff5fbfd458]
  reading input frame forEachChild => node=2546, args=4, height=5; inputs:
      0: 0xd6230dc36a9 ; [fp - 16] 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>
      1: 0x16f3adb61821 ; [fp + 40] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x1d75d865ea39 ; [fp + 32] 0x1d75d865ea39 <a NodeObject with map 0x33abe2a68961>
      3: 0x2f05bb805f51 ; [fp + 24] 0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>
      4: 0x2f05bb804889 ; [fp + 16] 0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>
      5: 0xd6230d99249 ; [fp - 24] 0xd6230d99249 <FixedArray[15]>
      6: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      8: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      9: 0x30bcea404311 ; rax 0x30bcea404311 <undefined>
  translating frame forEachChild => node=2546, height=32
    0x7fff5fbfd450: [top + 88] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfd448: [top + 80] <- 0x1d75d865ea39 ;  0x1d75d865ea39 <a NodeObject with map 0x33abe2a68961>  (input #2)
    0x7fff5fbfd440: [top + 72] <- 0x2f05bb805f51 ;  0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>  (input #3)
    0x7fff5fbfd438: [top + 64] <- 0x2f05bb804889 ;  0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>  (input #4)
    0x7fff5fbfd430: [top + 56] <- 0x2c21d2577908 ;  caller's pc
    0x7fff5fbfd428: [top + 48] <- 0x7fff5fbfd4a0 ;  caller's fp
    0x7fff5fbfd420: [top + 40] <- 0xd6230d99249 ;  context    0xd6230d99249 <FixedArray[15]>  (input #5)
    0x7fff5fbfd418: [top + 32] <- 0xd6230dc36a9 ;  function    0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>  (input #0)
    0x7fff5fbfd410: [top + 24] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfd408: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #7)
    0x7fff5fbfd400: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #8)
    0x7fff5fbfd3f8: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
[deoptimizing (lazy): end 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> @241 => node=2546, pc=0x2c21d24c6fff, caller sp=0x7fff5fbfd458, state=TOS_REGISTER, took 0.082 ms]
[deoptimizing (DEOPT lazy): begin 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> (opt #276) @129, FP to SP delta: 776, caller sp: 0x7fff5fbfd988]
  reading input frame forEachChild => node=4394, args=4, height=5; inputs:
      0: 0xd6230dc36a9 ; [fp - 16] 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>
      1: 0x16f3adb61821 ; [fp + 40] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x1d75d865b5c9 ; [fp + 32] 0x1d75d865b5c9 <a NodeObject with map 0x33abe2a71231>
      3: 0x2f05bb805f51 ; [fp + 24] 0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>
      4: 0x2f05bb804889 ; [fp + 16] 0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>
      5: 0xd6230d99249 ; [fp - 24] 0xd6230d99249 <FixedArray[15]>
      6: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      8: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      9: 0x30bcea404311 ; rax 0x30bcea404311 <undefined>
  translating frame forEachChild => node=4394, height=32
    0x7fff5fbfd980: [top + 88] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfd978: [top + 80] <- 0x1d75d865b5c9 ;  0x1d75d865b5c9 <a NodeObject with map 0x33abe2a71231>  (input #2)
    0x7fff5fbfd970: [top + 72] <- 0x2f05bb805f51 ;  0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>  (input #3)
    0x7fff5fbfd968: [top + 64] <- 0x2f05bb804889 ;  0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>  (input #4)
    0x7fff5fbfd960: [top + 56] <- 0x2c21d2577908 ;  caller's pc
    0x7fff5fbfd958: [top + 48] <- 0x7fff5fbfd9d0 ;  caller's fp
    0x7fff5fbfd950: [top + 40] <- 0xd6230d99249 ;  context    0xd6230d99249 <FixedArray[15]>  (input #5)
    0x7fff5fbfd948: [top + 32] <- 0xd6230dc36a9 ;  function    0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>  (input #0)
    0x7fff5fbfd940: [top + 24] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfd938: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #7)
    0x7fff5fbfd930: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #8)
    0x7fff5fbfd928: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
[deoptimizing (lazy): end 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> @129 => node=4394, pc=0x2c21d24c89d8, caller sp=0x7fff5fbfd988, state=TOS_REGISTER, took 0.075 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:declareModuleMember) id{286,0} ---
(node, symbolFlags, symbolExcludes) {
            var hasExportModifier = ts.getCombinedModifierFlags(node) & 1 /* Export */;
            if (symbolFlags & 8388608 /* Alias */) {
                if (node.kind === 243 /* ExportSpecifier */ || (node.kind === 234 /* ImportEqualsDeclaration */ && hasExportModifier)) {
                    return declareSymbol(container.symbol.exports, container.symbol, node, symbolFlags, symbolExcludes);
                }
                else {
                    return declareSymbol(container.locals, undefined, node, symbolFlags, symbolExcludes);
                }
            }
            else {
                // Exported module members are given 2 symbols: A local symbol that is classified with an ExportValue,
                // ExportType, or ExportContainer flag, and an associated export symbol with all the correct flags set
                // on it. There are 2 main reasons:
                //
                //   1. We treat locals and exports of the same name as mutually exclusive within a container.
                //      That means the binder will issue a Duplicate Identifier error if you mix locals and exports
                //      with the same name in the same container.
                //      TODO: Make this a more specific error and decouple it from the exclusion logic.
                //   2. When we checkIdentifier in the checker, we set its resolved symbol to the local symbol,
                //      but return the export symbol (by calling getExportSymbolOfValueSymbolIfExported). That way
                //      when the emitter comes back to it, it knows not to qualify the name if it was found in a containing scope.
                // NOTE: Nested ambient modules always should go to to 'locals' table to prevent their automatic merge
                //       during global merging in the checker. Why? The only case when ambient module is permitted inside another module is module augmentation
                //       and this case is specially handled. Module augmentations should only be merged with original module definition
                //       and should never be merged directly with other augmentation, and the latter case would be possible if automatic merge is allowed.
                var isJSDocTypedefInJSDocNamespace = node.kind === 285 /* JSDocTypedefTag */ &&
                    node.name &&
                    node.name.kind === 70 /* Identifier */ &&
                    node.name.isInJSDocNamespace;
                if ((!ts.isAmbientModule(node) && (hasExportModifier || container.flags & 32 /* ExportContext */)) || isJSDocTypedefInJSDocNamespace) {
                    var exportKind = (symbolFlags & 107455 /* Value */ ? 1048576 /* ExportValue */ : 0) |
                        (symbolFlags & 793064 /* Type */ ? 2097152 /* ExportType */ : 0) |
                        (symbolFlags & 1920 /* Namespace */ ? 4194304 /* ExportNamespace */ : 0);
                    var local = declareSymbol(container.locals, undefined, node, exportKind, symbolExcludes);
                    local.exportSymbol = declareSymbol(container.symbol.exports, container.symbol, node, symbolFlags, symbolExcludes);
                    node.localSymbol = local;
                    return local;
                }
                else {
                    return declareSymbol(container.locals, undefined, node, symbolFlags, symbolExcludes);
                }
            }
        }
--- END ---
[deoptimizing (DEOPT lazy): begin 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> (opt #250) @177, FP to SP delta: 752, caller sp: 0x7fff5fbfdf50]
  reading input frame forEachChild => node=2580, args=4, height=5; inputs:
      0: 0xd6230dc36a9 ; [fp - 16] 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>
      1: 0x16f3adb61821 ; [fp + 40] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x2f05bb83a721 ; [fp + 32] 0x2f05bb83a721 <a SourceFileObject with map 0x33abe2a716a9>
      3: 0x2f05bb805f51 ; [fp + 24] 0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>
      4: 0x2f05bb804889 ; [fp + 16] 0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>
      5: 0xd6230d99249 ; [fp - 24] 0xd6230d99249 <FixedArray[15]>
      6: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      8: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      9: 0xd6230dd5d69 ; [fp - 32] 0xd6230dd5d69 <JS Function visitNodeArray (SharedFunctionInfo 0x3504a53f0029)>
  reading input frame visitNodeArray => node=14, args=3, height=2; inputs:
      0: 0xd6230dd5d69 ; (literal 7) 0xd6230dd5d69 <JS Function visitNodeArray (SharedFunctionInfo 0x3504a53f0029)>
      1: 0x1f9f6c0532e1 ; (literal 8) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2f05bb804889 ; [fp - 40] 0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>
      3: 0x2f05bb83a701 ; [fp - 160] 0x2f05bb83a701 <JS Array[64]>
      4: 0xd6230d99249 ; (literal 9) 0xd6230d99249 <FixedArray[15]>
      5: 0x30bcea404311 ; rax 0x30bcea404311 <undefined>
  translating frame forEachChild => node=2580, height=32
    0x7fff5fbfdf48: [top + 88] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfdf40: [top + 80] <- 0x2f05bb83a721 ;  0x2f05bb83a721 <a SourceFileObject with map 0x33abe2a716a9>  (input #2)
    0x7fff5fbfdf38: [top + 72] <- 0x2f05bb805f51 ;  0x2f05bb805f51 <JS Function bind (SharedFunctionInfo 0x16f3adb5c021)>  (input #3)
    0x7fff5fbfdf30: [top + 64] <- 0x2f05bb804889 ;  0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>  (input #4)
    0x7fff5fbfdf28: [top + 56] <- 0x2c21d2577908 ;  caller's pc
    0x7fff5fbfdf20: [top + 48] <- 0x7fff5fbfdf98 ;  caller's fp
    0x7fff5fbfdf18: [top + 40] <- 0xd6230d99249 ;  context    0xd6230d99249 <FixedArray[15]>  (input #5)
    0x7fff5fbfdf10: [top + 32] <- 0xd6230dc36a9 ;  function    0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)>  (input #0)
    0x7fff5fbfdf08: [top + 24] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfdf00: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #7)
    0x7fff5fbfdef8: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #8)
    0x7fff5fbfdef0: [top + 0] <- 0xd6230dd5d69 ;  0xd6230dd5d69 <JS Function visitNodeArray (SharedFunctionInfo 0x3504a53f0029)>  (input #9)
  translating frame visitNodeArray => node=14, height=8
    0x7fff5fbfdee8: [top + 56] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdee0: [top + 48] <- 0x2f05bb804889 ;  0x2f05bb804889 <JS Function bindEach (SharedFunctionInfo 0x16f3adb58361)>  (input #2)
    0x7fff5fbfded8: [top + 40] <- 0x2f05bb83a701 ;  0x2f05bb83a701 <JS Array[64]>  (input #3)
    0x7fff5fbfded0: [top + 32] <- 0x2c21d24c7047 ;  caller's pc
    0x7fff5fbfdec8: [top + 24] <- 0x7fff5fbfdf20 ;  caller's fp
    0x7fff5fbfdec0: [top + 16] <- 0xd6230d99249 ;  context    0xd6230d99249 <FixedArray[15]>  (input #4)
    0x7fff5fbfdeb8: [top + 8] <- 0xd6230dd5d69 ;  function    0xd6230dd5d69 <JS Function visitNodeArray (SharedFunctionInfo 0x3504a53f0029)>  (input #0)
    0x7fff5fbfdeb0: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
[deoptimizing (lazy): end 0xd6230dc36a9 <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> @177 => node=14, pc=0x2c21d25490ed, caller sp=0x7fff5fbfdf50, state=TOS_REGISTER, took 0.128 ms]
[deoptimizing (DEOPT lazy): begin 0x2f05bb8047f9 <JS Function bindContainer (SharedFunctionInfo 0x16f3adb581e1)> (opt #232) @25, FP to SP delta: 168, caller sp: 0x7fff5fbfe0c0]
  reading input frame bindContainer => node=490, args=3, height=10; inputs:
      0: 0x2f05bb8047f9 ; [fp - 16] 0x2f05bb8047f9 <JS Function bindContainer (SharedFunctionInfo 0x16f3adb581e1)>
      1: 0x1f9f6c0532e1 ; [fp + 32] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2f05bb83a721 ; [fp + 24] 0x2f05bb83a721 <a SourceFileObject with map 0x33abe2a716a9>
      3: 0x2500000000 ; [fp + 16] 37
      4: 0xd6230dfeea1 ; [fp - 24] 0xd6230dfeea1 <FixedArray[147]>
      5: 0x30bcea404311 ; [fp - 32] 0x30bcea404311 <undefined>
      6: 0x30bcea404311 ; [fp - 40] 0x30bcea404311 <undefined>
      7: 0x30bcea404311 ; [fp - 88] 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; [fp - 96] 0x30bcea404311 <undefined>
      9: 0x30bcea404311 ; [fp - 104] 0x30bcea404311 <undefined>
     10: 0x30bcea404311 ; [fp - 112] 0x30bcea404311 <undefined>
     11: 0x30bcea404311 ; [fp - 120] 0x30bcea404311 <undefined>
     12: 0x30bcea404421 ; [fp - 128] 0x30bcea404421 <false>
     13: 0x00000000 ; [fp - 152] 0
  translating frame bindContainer => node=490, height=72
    0x7fff5fbfe0b8: [top + 120] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfe0b0: [top + 112] <- 0x2f05bb83a721 ;  0x2f05bb83a721 <a SourceFileObject with map 0x33abe2a716a9>  (input #2)
    0x7fff5fbfe0a8: [top + 104] <- 0x2500000000 ;  37  (input #3)
    0x7fff5fbfe0a0: [top + 96] <- 0x2c21d254dd70 ;  caller's pc
    0x7fff5fbfe098: [top + 88] <- 0x7fff5fbfe0e8 ;  caller's fp
    0x7fff5fbfe090: [top + 80] <- 0xd6230dfeea1 ;  context    0xd6230dfeea1 <FixedArray[147]>  (input #4)
    0x7fff5fbfe088: [top + 72] <- 0x2f05bb8047f9 ;  function    0x2f05bb8047f9 <JS Function bindContainer (SharedFunctionInfo 0x16f3adb581e1)>  (input #0)
    0x7fff5fbfe080: [top + 64] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfe078: [top + 56] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfe070: [top + 48] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfe068: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfe060: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
    0x7fff5fbfe058: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #10)
    0x7fff5fbfe050: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #11)
    0x7fff5fbfe048: [top + 8] <- 0x30bcea404421 ;  0x30bcea404421 <false>  (input #12)
    0x7fff5fbfe040: [top + 0] <- 0x00000000 ;  0  (input #13)
[deoptimizing (lazy): end 0x2f05bb8047f9 <JS Function bindContainer (SharedFunctionInfo 0x16f3adb581e1)> @25 => node=490, pc=0x2c21d2546f8a, caller sp=0x7fff5fbfe0c0, state=NO_REGISTERS, took 0.070 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isDeclarationKind) id{287,0} ---
(kind) {
        return kind === 185 /* ArrowFunction */
            || kind === 174 /* BindingElement */
            || kind === 226 /* ClassDeclaration */
            || kind === 197 /* ClassExpression */
            || kind === 150 /* Constructor */
            || kind === 229 /* EnumDeclaration */
            || kind === 260 /* EnumMember */
            || kind === 243 /* ExportSpecifier */
            || kind === 225 /* FunctionDeclaration */
            || kind === 184 /* FunctionExpression */
            || kind === 151 /* GetAccessor */
            || kind === 236 /* ImportClause */
            || kind === 234 /* ImportEqualsDeclaration */
            || kind === 239 /* ImportSpecifier */
            || kind === 227 /* InterfaceDeclaration */
            || kind === 149 /* MethodDeclaration */
            || kind === 148 /* MethodSignature */
            || kind === 230 /* ModuleDeclaration */
            || kind === 233 /* NamespaceExportDeclaration */
            || kind === 237 /* NamespaceImport */
            || kind === 144 /* Parameter */
            || kind === 257 /* PropertyAssignment */
            || kind === 147 /* PropertyDeclaration */
            || kind === 146 /* PropertySignature */
            || kind === 152 /* SetAccessor */
            || kind === 258 /* ShorthandPropertyAssignment */
            || kind === 228 /* TypeAliasDeclaration */
            || kind === 143 /* TypeParameter */
            || kind === 223 /* VariableDeclaration */
            || kind === 285 /* JSDocTypedefTag */;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarTopLevelElementForRequiredDeclareModifier) id{288,0} ---
(node) {
            // A declare modifier is required for any top level .d.ts declaration except export=, export default, export as namespace
            // interfaces and imports categories:
            //
            //  DeclarationElement:
            //     ExportAssignment
            //     export_opt   InterfaceDeclaration
            //     export_opt   TypeAliasDeclaration
            //     export_opt   ImportDeclaration
            //     export_opt   ExternalImportDeclaration
            //     export_opt   AmbientDeclaration
            //
            // TODO: The spec needs to be amended to reflect this grammar.
            if (node.kind === 227 /* InterfaceDeclaration */ ||
                node.kind === 228 /* TypeAliasDeclaration */ ||
                node.kind === 235 /* ImportDeclaration */ ||
                node.kind === 234 /* ImportEqualsDeclaration */ ||
                node.kind === 241 /* ExportDeclaration */ ||
                node.kind === 240 /* ExportAssignment */ ||
                node.kind === 233 /* NamespaceExportDeclaration */ ||
                ts.getModifierFlags(node) & (2 /* Ambient */ | 1 /* Export */ | 512 /* Default */)) {
                return false;
            }
            return grammarErrorOnFirstToken(node, ts.Diagnostics.A_declare_modifier_is_required_for_a_top_level_declaration_in_a_d_ts_file);
        }
--- END ---
[deoptimizing (DEOPT eager): begin 0x29cc38d2a121 <JS Function checkGrammarTopLevelElementForRequiredDeclareModifier (SharedFunctionInfo 0x1b98fbc15611)> (opt #288) @4, FP to SP delta: 32, caller sp: 0x7fff5fbfe0a8]
            ;;; deoptimize at 0_783: wrong map
  reading input frame checkGrammarTopLevelElementForRequiredDeclareModifier => node=30, args=2, height=1; inputs:
      0: 0x29cc38d2a121 ; [fp - 16] 0x29cc38d2a121 <JS Function checkGrammarTopLevelElementForRequiredDeclareModifier (SharedFunctionInfo 0x1b98fbc15611)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1b98fbcd0759 ; rax 0x1b98fbcd0759 <a NodeObject with map 0x33abe2a714f1>
      3: 0x29cc38d04261 ; [fp - 24] 0x29cc38d04261 <FixedArray[1022]>
  translating frame checkGrammarTopLevelElementForRequiredDeclareModifier => node=30, height=0
    0x7fff5fbfe0a0: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfe098: [top + 32] <- 0x1b98fbcd0759 ;  0x1b98fbcd0759 <a NodeObject with map 0x33abe2a714f1>  (input #2)
    0x7fff5fbfe090: [top + 24] <- 0x2c21d25aa61c ;  caller's pc
    0x7fff5fbfe088: [top + 16] <- 0x7fff5fbfe0d8 ;  caller's fp
    0x7fff5fbfe080: [top + 8] <- 0x29cc38d04261 ;  context    0x29cc38d04261 <FixedArray[1022]>  (input #3)
    0x7fff5fbfe078: [top + 0] <- 0x29cc38d2a121 ;  function    0x29cc38d2a121 <JS Function checkGrammarTopLevelElementForRequiredDeclareModifier (SharedFunctionInfo 0x1b98fbc15611)>  (input #0)
[deoptimizing (eager): end 0x29cc38d2a121 <JS Function checkGrammarTopLevelElementForRequiredDeclareModifier (SharedFunctionInfo 0x1b98fbc15611)> @4 => node=30, pc=0x2c21d25ab354, caller sp=0x7fff5fbfe0a8, state=NO_REGISTERS, took 0.056 ms]
[deoptimizing (DEOPT eager): begin 0xd6230dcc7f1 <JS Function hasDynamicName (SharedFunctionInfo 0x3504a53d2299)> (opt #243) @6, FP to SP delta: 32, caller sp: 0x7fff5fbfdfb8]
            ;;; deoptimize at 1_28: Unknown map in polymorphic access
  reading input frame hasDynamicName => node=20, args=2, height=2; inputs:
      0: 0xd6230dcc7f1 ; [fp - 16] 0xd6230dcc7f1 <JS Function hasDynamicName (SharedFunctionInfo 0x3504a53d2299)>
      1: 0x16f3adb61821 ; [fp + 24] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x1229b1b7059 ; [fp + 16] 0x1229b1b7059 <a NodeObject with map 0x33abe2a6fd91>
      3: 0xd6230db34c9 ; [fp - 24] 0xd6230db34c9 <FixedArray[156]>
      4: 0xd6230dcddc1 ; rbx 0xd6230dcddc1 <JS Function isDynamicName (SharedFunctionInfo 0x3504a53d2359)>
  reading input frame isDynamicName => node=3, args=2, height=1; inputs:
      0: 0xd6230dcddc1 ; (literal 4) 0xd6230dcddc1 <JS Function isDynamicName (SharedFunctionInfo 0x3504a53d2359)>
      1: 0x1f9f6c0532e1 ; (literal 5) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1229b1b8e31 ; rax 0x1229b1b8e31 <an IdentifierObject with map 0x33abe2a6fb81>
      3: 0xd6230db34c9 ; (literal 6) 0xd6230db34c9 <FixedArray[156]>
  translating frame hasDynamicName => node=20, height=8
    0x7fff5fbfdfb0: [top + 48] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfdfa8: [top + 40] <- 0x1229b1b7059 ;  0x1229b1b7059 <a NodeObject with map 0x33abe2a6fd91>  (input #2)
    0x7fff5fbfdfa0: [top + 32] <- 0x2c21d25fc599 ;  caller's pc
    0x7fff5fbfdf98: [top + 24] <- 0x7fff5fbfdff8 ;  caller's fp
    0x7fff5fbfdf90: [top + 16] <- 0xd6230db34c9 ;  context    0xd6230db34c9 <FixedArray[156]>  (input #3)
    0x7fff5fbfdf88: [top + 8] <- 0xd6230dcc7f1 ;  function    0xd6230dcc7f1 <JS Function hasDynamicName (SharedFunctionInfo 0x3504a53d2299)>  (input #0)
    0x7fff5fbfdf80: [top + 0] <- 0xd6230dcddc1 ;  0xd6230dcddc1 <JS Function isDynamicName (SharedFunctionInfo 0x3504a53d2359)>  (input #4)
  translating frame isDynamicName => node=3, height=0
    0x7fff5fbfdf78: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdf70: [top + 32] <- 0x1229b1b8e31 ;  0x1229b1b8e31 <an IdentifierObject with map 0x33abe2a6fb81>  (input #2)
    0x7fff5fbfdf68: [top + 24] <- 0x2c21d2523338 ;  caller's pc
    0x7fff5fbfdf60: [top + 16] <- 0x7fff5fbfdf98 ;  caller's fp
    0x7fff5fbfdf58: [top + 8] <- 0xd6230db34c9 ;  context    0xd6230db34c9 <FixedArray[156]>  (input #3)
    0x7fff5fbfdf50: [top + 0] <- 0xd6230dcddc1 ;  function    0xd6230dcddc1 <JS Function isDynamicName (SharedFunctionInfo 0x3504a53d2359)>  (input #0)
[deoptimizing (eager): end 0xd6230dcc7f1 <JS Function hasDynamicName (SharedFunctionInfo 0x3504a53d2299)> @6 => node=3, pc=0x2c21d2523406, caller sp=0x7fff5fbfdfb8, state=NO_REGISTERS, took 0.092 ms]
[deoptimizing (DEOPT eager): begin 0xd6230daf4a1 <JS Function forEach (SharedFunctionInfo 0xc2bd2ae0d69)> (opt #228) @8, FP to SP delta: 40, caller sp: 0x7fff5fbfdfb8]
            ;;; deoptimize at 0_177: unexpected object
  reading input frame forEach => node=88, args=3, height=5; inputs:
      0: 0xd6230daf4a1 ; [fp - 16] 0xd6230daf4a1 <JS Function forEach (SharedFunctionInfo 0xc2bd2ae0d69)>
      1: 0x16f3adb61821 ; [fp + 32] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x29cc38d3a1e9 ; [fp + 24] 0x29cc38d3a1e9 <JS Array[1]>
      3: 0x74e2ec5fd01 ; [fp + 16] 0x74e2ec5fd01 <JS Function (SharedFunctionInfo 0x371f85cd9ff9)>
      4: 0xd6230db3179 ; [fp - 24] 0xd6230db3179 <FixedArray[95]>
      5: 0 ; (int) [fp - 40] 
      6: 1 ; (int) [fp - 32] 
      7: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
      8: 0x1229b1b7059 ; rax 0x1229b1b7059 <a NodeObject with map 0x33abe2a6fd91>
  translating frame forEach => node=88, height=32
    0x7fff5fbfdfb0: [top + 80] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfdfa8: [top + 72] <- 0x29cc38d3a1e9 ;  0x29cc38d3a1e9 <JS Array[1]>  (input #2)
    0x7fff5fbfdfa0: [top + 64] <- 0x74e2ec5fd01 ;  0x74e2ec5fd01 <JS Function (SharedFunctionInfo 0x371f85cd9ff9)>  (input #3)
    0x7fff5fbfdf98: [top + 56] <- 0x2c21d25fc6aa ;  caller's pc
    0x7fff5fbfdf90: [top + 48] <- 0x7fff5fbfdff8 ;  caller's fp
    0x7fff5fbfdf88: [top + 40] <- 0xd6230db3179 ;  context    0xd6230db3179 <FixedArray[95]>  (input #4)
    0x7fff5fbfdf80: [top + 32] <- 0xd6230daf4a1 ;  function    0xd6230daf4a1 <JS Function forEach (SharedFunctionInfo 0xc2bd2ae0d69)>  (input #0)
    0x7fff5fbfdf78: [top + 24] <- 0x00000000 ;  0  (input #5)
    0x7fff5fbfdf70: [top + 16] <- 0x100000000 ;  1  (input #6)
    0x7fff5fbfdf68: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfdf60: [top + 0] <- 0x1229b1b7059 ;  0x1229b1b7059 <a NodeObject with map 0x33abe2a6fd91>  (input #8)
[deoptimizing (eager): end 0xd6230daf4a1 <JS Function forEach (SharedFunctionInfo 0xc2bd2ae0d69)> @8 => node=88, pc=0x2c21d23de7a6, caller sp=0x7fff5fbfdfb8, state=TOS_REGISTER, took 0.060 ms]
[deoptimizer unlinked: forEach / d6230daf4a1]
[deoptimizing (DEOPT lazy): begin 0xd6230daf4a1 <JS Function forEach (SharedFunctionInfo 0xc2bd2ae0d69)> (opt #228) @7, FP to SP delta: 40, caller sp: 0x7fff5fbfe130]
  reading input frame forEach => node=88, args=3, height=5; inputs:
      0: 0xd6230daf4a1 ; [fp - 16] 0xd6230daf4a1 <JS Function forEach (SharedFunctionInfo 0xc2bd2ae0d69)>
      1: 0x16f3adb61821 ; [fp + 32] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x1d75d8656a99 ; [fp + 24] 0x1d75d8656a99 <JS Array[1604]>
      3: 0x29cc38d28429 ; [fp + 16] 0x29cc38d28429 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>
      4: 0xd6230db3179 ; [fp - 24] 0xd6230db3179 <FixedArray[95]>
      5: 2 ; (int) [fp - 40] 
      6: 1604 ; (int) [fp - 32] 
      7: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; rax 0x30bcea404311 <undefined>
  translating frame forEach => node=88, height=32
    0x7fff5fbfe128: [top + 80] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfe120: [top + 72] <- 0x1d75d8656a99 ;  0x1d75d8656a99 <JS Array[1604]>  (input #2)
    0x7fff5fbfe118: [top + 64] <- 0x29cc38d28429 ;  0x29cc38d28429 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>  (input #3)
    0x7fff5fbfe110: [top + 56] <- 0x2c21d25a9bf8 ;  caller's pc
    0x7fff5fbfe108: [top + 48] <- 0x7fff5fbfe150 ;  caller's fp
    0x7fff5fbfe100: [top + 40] <- 0xd6230db3179 ;  context    0xd6230db3179 <FixedArray[95]>  (input #4)
    0x7fff5fbfe0f8: [top + 32] <- 0xd6230daf4a1 ;  function    0xd6230daf4a1 <JS Function forEach (SharedFunctionInfo 0xc2bd2ae0d69)>  (input #0)
    0x7fff5fbfe0f0: [top + 24] <- 0x200000000 ;  2  (input #5)
    0x7fff5fbfe0e8: [top + 16] <- 0x64400000000 ;  1604  (input #6)
    0x7fff5fbfe0e0: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfe0d8: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
[deoptimizing (lazy): end 0xd6230daf4a1 <JS Function forEach (SharedFunctionInfo 0xc2bd2ae0d69)> @7 => node=88, pc=0x2c21d23de7a6, caller sp=0x7fff5fbfe130, state=TOS_REGISTER, took 0.071 ms]
[deoptimizing (DEOPT eager): begin 0xd6230dcddc1 <JS Function isDynamicName (SharedFunctionInfo 0x3504a53d2359)> (opt #229) @2, FP to SP delta: 24, caller sp: 0x7fff5fbfdf78]
            ;;; deoptimize at 0_28: Unknown map in polymorphic access
  reading input frame isDynamicName => node=4, args=2, height=1; inputs:
      0: 0xd6230dcddc1 ; [fp - 16] 0xd6230dcddc1 <JS Function isDynamicName (SharedFunctionInfo 0x3504a53d2359)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1229b1b8ed9 ; rax 0x1229b1b8ed9 <an IdentifierObject with map 0x33abe2a6fb81>
      3: 0xd6230db34c9 ; [fp - 24] 0xd6230db34c9 <FixedArray[156]>
  translating frame isDynamicName => node=4, height=0
    0x7fff5fbfdf70: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdf68: [top + 32] <- 0x1229b1b8ed9 ;  0x1229b1b8ed9 <an IdentifierObject with map 0x33abe2a6fb81>  (input #2)
    0x7fff5fbfdf60: [top + 24] <- 0x2c21d2523338 ;  caller's pc
    0x7fff5fbfdf58: [top + 16] <- 0x7fff5fbfdf90 ;  caller's fp
    0x7fff5fbfdf50: [top + 8] <- 0xd6230db34c9 ;  context    0xd6230db34c9 <FixedArray[156]>  (input #3)
    0x7fff5fbfdf48: [top + 0] <- 0xd6230dcddc1 ;  function    0xd6230dcddc1 <JS Function isDynamicName (SharedFunctionInfo 0x3504a53d2359)>  (input #0)
[deoptimizing (eager): end 0xd6230dcddc1 <JS Function isDynamicName (SharedFunctionInfo 0x3504a53d2359)> @2 => node=4, pc=0x2c21d2523406, caller sp=0x7fff5fbfdf78, state=NO_REGISTERS, took 0.042 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{289,0} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{290,0} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:reportObviousModifierErrors) id{291,0} ---
(node) {
            return !node.modifiers
                ? false
                : shouldReportBadModifier(node)
                    ? grammarErrorOnFirstToken(node, ts.Diagnostics.Modifiers_cannot_appear_here)
                    : undefined;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkSourceElement) id{292,0} ---
(node) {
            if (!node) {
                return;
            }
            var kind = node.kind;
            if (cancellationToken) {
                // Only bother checking on a few construct kinds.  We don't want to be excessively
                // hitting the cancellation token on every node we check.
                switch (kind) {
                    case 230 /* ModuleDeclaration */:
                    case 226 /* ClassDeclaration */:
                    case 227 /* InterfaceDeclaration */:
                    case 225 /* FunctionDeclaration */:
                        cancellationToken.throwIfCancellationRequested();
                }
            }
            switch (kind) {
                case 143 /* TypeParameter */:
                    return checkTypeParameter(node);
                case 144 /* Parameter */:
                    return checkParameter(node);
                case 147 /* PropertyDeclaration */:
                case 146 /* PropertySignature */:
                    return checkPropertyDeclaration(node);
                case 158 /* FunctionType */:
                case 159 /* ConstructorType */:
                case 153 /* CallSignature */:
                case 154 /* ConstructSignature */:
                    return checkSignatureDeclaration(node);
                case 155 /* IndexSignature */:
                    return checkSignatureDeclaration(node);
                case 149 /* MethodDeclaration */:
                case 148 /* MethodSignature */:
                    return checkMethodDeclaration(node);
                case 150 /* Constructor */:
                    return checkConstructorDeclaration(node);
                case 151 /* GetAccessor */:
                case 152 /* SetAccessor */:
                    return checkAccessorDeclaration(node);
                case 157 /* TypeReference */:
                    return checkTypeReferenceNode(node);
                case 156 /* TypePredicate */:
                    return checkTypePredicate(node);
                case 160 /* TypeQuery */:
                    return checkTypeQuery(node);
                case 161 /* TypeLiteral */:
                    return checkTypeLiteral(node);
                case 162 /* ArrayType */:
                    return checkArrayType(node);
                case 163 /* TupleType */:
                    return checkTupleType(node);
                case 164 /* UnionType */:
                case 165 /* IntersectionType */:
                    return checkUnionOrIntersectionType(node);
                case 166 /* ParenthesizedType */:
                case 168 /* TypeOperator */:
                    return checkSourceElement(node.type);
                case 169 /* IndexedAccessType */:
                    return checkIndexedAccessType(node);
                case 170 /* MappedType */:
                    return checkMappedType(node);
                case 225 /* FunctionDeclaration */:
                    return checkFunctionDeclaration(node);
                case 204 /* Block */:
                case 231 /* ModuleBlock */:
                    return checkBlock(node);
                case 205 /* VariableStatement */:
                    return checkVariableStatement(node);
                case 207 /* ExpressionStatement */:
                    return checkExpressionStatement(node);
                case 208 /* IfStatement */:
                    return checkIfStatement(node);
                case 209 /* DoStatement */:
                    return checkDoStatement(node);
                case 210 /* WhileStatement */:
                    return checkWhileStatement(node);
                case 211 /* ForStatement */:
                    return checkForStatement(node);
                case 212 /* ForInStatement */:
                    return checkForInStatement(node);
                case 213 /* ForOfStatement */:
                    return checkForOfStatement(node);
                case 214 /* ContinueStatement */:
                case 215 /* BreakStatement */:
                    return checkBreakOrContinueStatement(node);
                case 216 /* ReturnStatement */:
                    return checkReturnStatement(node);
                case 217 /* WithStatement */:
                    return checkWithStatement(node);
                case 218 /* SwitchStatement */:
                    return checkSwitchStatement(node);
                case 219 /* LabeledStatement */:
                    return checkLabeledStatement(node);
                case 220 /* ThrowStatement */:
                    return checkThrowStatement(node);
                case 221 /* TryStatement */:
                    return checkTryStatement(node);
                case 223 /* VariableDeclaration */:
                    return checkVariableDeclaration(node);
                case 174 /* BindingElement */:
                    return checkBindingElement(node);
                case 226 /* ClassDeclaration */:
                    return checkClassDeclaration(node);
                case 227 /* InterfaceDeclaration */:
                    return checkInterfaceDeclaration(node);
                case 228 /* TypeAliasDeclaration */:
                    return checkTypeAliasDeclaration(node);
                case 229 /* EnumDeclaration */:
                    return checkEnumDeclaration(node);
                case 230 /* ModuleDeclaration */:
                    return checkModuleDeclaration(node);
                case 235 /* ImportDeclaration */:
                    return checkImportDeclaration(node);
                case 234 /* ImportEqualsDeclaration */:
                    return checkImportEqualsDeclaration(node);
                case 241 /* ExportDeclaration */:
                    return checkExportDeclaration(node);
                case 240 /* ExportAssignment */:
                    return checkExportAssignment(node);
                case 206 /* EmptyStatement */:
                    checkGrammarStatementInAmbientContext(node);
                    return;
                case 222 /* DebuggerStatement */:
                    checkGrammarStatementInAmbientContext(node);
                    return;
                case 244 /* MissingDeclaration */:
                    return checkMissingDeclaration(node);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkPropertyDeclaration) id{292,1} ---
(node) {
            // Grammar checking
            checkGrammarDecorators(node) || checkGrammarModifiers(node) || checkGrammarProperty(node) || checkGrammarComputedPropertyName(node.name);
            checkVariableLikeDeclaration(node);
        }
--- END ---
INLINE (checkPropertyDeclaration) id{292,1} AS 1 AT <0:1021>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarComputedPropertyName) id{292,2} ---
(node) {
            // If node is not a computedPropertyName, just skip the grammar checking
            if (node.kind !== 142 /* ComputedPropertyName */) {
                return false;
            }
            var computedPropertyName = node;
            if (computedPropertyName.expression.kind === 192 /* BinaryExpression */ && computedPropertyName.expression.operatorToken.kind === 25 /* CommaToken */) {
                return grammarErrorOnNode(computedPropertyName.expression, ts.Diagnostics.A_comma_expression_is_not_allowed_in_a_computed_property_name);
            }
        }
--- END ---
INLINE (checkGrammarComputedPropertyName) id{292,2} AS 2 AT <1:146>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkArrayType) id{292,3} ---
(node) {
            checkSourceElement(node.elementType);
        }
--- END ---
INLINE (checkArrayType) id{292,3} AS 3 AT <0:2275>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkUnionOrIntersectionType) id{292,4} ---
(node) {
            ts.forEach(node.types, checkSourceElement);
        }
--- END ---
INLINE (checkUnionOrIntersectionType) id{292,4} AS 4 AT <0:2506>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkFunctionDeclaration) id{292,5} ---
(node) {
            if (produceDiagnostics) {
                checkFunctionOrMethodDeclaration(node) || checkGrammarForGenerator(node);
                checkCollisionWithCapturedSuperVariable(node, node.name);
                checkCollisionWithCapturedThisVariable(node, node.name);
                checkCollisionWithRequireExportsInGeneratedCode(node, node.name);
                checkCollisionWithGlobalPromiseInGeneratedCode(node, node.name);
            }
        }
--- END ---
INLINE (checkFunctionDeclaration) id{292,5} AS 5 AT <0:2974>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkCollisionWithCapturedThisVariable) id{292,6} ---
(node, name) {
            if (needCollisionCheckForIdentifier(node, name, "_this")) {
                potentialThisCollisions.push(node);
            }
        }
--- END ---
INLINE (checkCollisionWithCapturedThisVariable) id{292,6} AS 6 AT <5:227>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkVariableStatement) id{292,7} ---
(node) {
            // Grammar checking
            checkGrammarDecorators(node) || checkGrammarModifiers(node) || checkGrammarVariableDeclarationList(node.declarationList) || checkGrammarForDisallowedLetOrConstStatement(node);
            ts.forEach(node.declarationList.declarations, checkSourceElement);
        }
--- END ---
INLINE (checkVariableStatement) id{292,7} AS 7 AT <0:3210>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarVariableDeclarationList) id{292,8} ---
(declarationList) {
            var declarations = declarationList.declarations;
            if (checkGrammarForDisallowedTrailingComma(declarationList.declarations)) {
                return true;
            }
            if (!declarationList.declarations.length) {
                return grammarErrorAtPos(ts.getSourceFileOfNode(declarationList), declarations.pos, declarations.end - declarations.pos, ts.Diagnostics.Variable_declaration_list_cannot_be_empty);
            }
        }
--- END ---
INLINE (checkGrammarVariableDeclarationList) id{292,8} AS 8 AT <7:116>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarForDisallowedTrailingComma) id{292,9} ---
(list) {
            if (list && list.hasTrailingComma) {
                var start = list.end - ",".length;
                var end = list.end;
                var sourceFile = ts.getSourceFileOfNode(list[0]);
                return grammarErrorAtPos(sourceFile, start, end - start, ts.Diagnostics.Trailing_comma_not_allowed);
            }
        }
--- END ---
INLINE (checkGrammarForDisallowedTrailingComma) id{292,9} AS 9 AT <8:97>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarForDisallowedLetOrConstStatement) id{292,10} ---
(node) {
            if (!allowLetAndConstDeclarations(node.parent)) {
                if (ts.isLet(node.declarationList)) {
                    return grammarErrorOnNode(node, ts.Diagnostics.let_declarations_can_only_be_declared_inside_a_block);
                }
                else if (ts.isConst(node.declarationList)) {
                    return grammarErrorOnNode(node, ts.Diagnostics.const_declarations_can_only_be_declared_inside_a_block);
                }
            }
        }
--- END ---
INLINE (checkGrammarForDisallowedLetOrConstStatement) id{292,10} AS 10 AT <7:177>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:allowLetAndConstDeclarations) id{292,11} ---
(parent) {
            switch (parent.kind) {
                case 208 /* IfStatement */:
                case 209 /* DoStatement */:
                case 210 /* WhileStatement */:
                case 217 /* WithStatement */:
                case 211 /* ForStatement */:
                case 212 /* ForInStatement */:
                case 213 /* ForOfStatement */:
                    return false;
                case 219 /* LabeledStatement */:
                    return allowLetAndConstDeclarations(parent.parent);
            }
            return true;
        }
--- END ---
INLINE (allowLetAndConstDeclarations) id{292,11} AS 11 AT <10:26>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkVariableDeclaration) id{292,12} ---
(node) {
            checkGrammarVariableDeclaration(node);
            return checkVariableLikeDeclaration(node);
        }
--- END ---
INLINE (checkVariableDeclaration) id{292,12} AS 12 AT <0:4789>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getEffectiveDeclarationFlags) id{293,0} ---
(n, flagsToCheck) {
            var flags = ts.getCombinedModifierFlags(n);
            // children of classes (even ambient classes) should not be marked as ambient or export
            // because those flags have no useful semantics there.
            if (n.parent.kind !== 227 /* InterfaceDeclaration */ &&
                n.parent.kind !== 226 /* ClassDeclaration */ &&
                n.parent.kind !== 197 /* ClassExpression */ &&
                ts.isInAmbientContext(n)) {
                if (!(flags & 2 /* Ambient */)) {
                    // It is nested in an ambient context, which means it is automatically exported
                    flags |= 1 /* Export */;
                }
                flags |= 2 /* Ambient */;
            }
            return flags & flagsToCheck;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeLinks) id{294,0} ---
(node) {
            var nodeId = getNodeId(node);
            return nodeLinks[nodeId] || (nodeLinks[nodeId] = { flags: 0 });
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeId) id{294,1} ---
(node) {
        if (!node.id) {
            node.id = nextNodeId;
            nextNodeId++;
        }
        return node.id;
    }
--- END ---
INLINE (getNodeId) id{294,1} AS 1 AT <0:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getWidenedTypeForVariableLikeDeclaration) id{295,0} ---
(declaration, reportErrors) {
            var type = getTypeForVariableLikeDeclaration(declaration, /*includeOptionality*/ true);
            if (type) {
                if (reportErrors) {
                    reportErrorsFromWidening(declaration, type);
                }
                // During a normal type check we'll never get to here with a property assignment (the check of the containing
                // object literal uses a different path). We exclude widening only so that language services and type verification
                // tools see the actual type.
                if (declaration.kind === 257 /* PropertyAssignment */) {
                    return type;
                }
                return getWidenedType(type);
            }
            // Rest parameters default to type any[], other parameters default to type any
            type = declaration.dotDotDotToken ? anyArrayType : anyType;
            // Report implicit any errors unless this is a private property within an ambient declaration
            if (reportErrors && compilerOptions.noImplicitAny) {
                if (!declarationBelongsToPrivateAmbientMember(declaration)) {
                    reportImplicitAnyError(declaration, type);
                }
            }
            return type;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:reportErrorsFromWidening) id{295,1} ---
(declaration, type) {
            if (produceDiagnostics && compilerOptions.noImplicitAny && type.flags & 2097152 /* ContainsWideningType */) {
                // Report implicit any error within type if possible, otherwise report error on declaration
                if (!reportWideningErrorsInType(type)) {
                    reportImplicitAnyError(declaration, type);
                }
            }
        }
--- END ---
INLINE (reportErrorsFromWidening) id{295,1} AS 1 AT <0:210>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:convertAutoToAny) id{296,0} ---
(type) {
            return type === autoType ? anyType : type === autoArrayType ? anyArrayType : type;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:hasQuestionToken) id{297,0} ---
(node) {
        if (node) {
            switch (node.kind) {
                case 144 /* Parameter */:
                case 149 /* MethodDeclaration */:
                case 148 /* MethodSignature */:
                case 258 /* ShorthandPropertyAssignment */:
                case 257 /* PropertyAssignment */:
                case 147 /* PropertyDeclaration */:
                case 146 /* PropertySignature */:
                    return node.questionToken !== undefined;
            }
        }
        return false;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{298,0} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{298,1} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{298,1} AS 1 AT <0:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isAsyncFunctionLike) id{299,0} ---
(node) {
        return isFunctionLike(node) && hasModifier(node, 256 /* Async */) && !isAccessor(node);
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isFunctionLike) id{299,1} ---
(node) {
        return node && isFunctionLikeKind(node.kind);
    }
--- END ---
INLINE (isFunctionLike) id{299,1} AS 1 AT <0:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:hasModifier) id{299,2} ---
(node, flags) {
        return (getModifierFlags(node) & flags) !== 0;
    }
--- END ---
INLINE (hasModifier) id{299,2} AS 2 AT <0:48>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nodeIsMissing) id{300,0} ---
(node) {
        if (node === undefined) {
            return true;
        }
        return node.pos === node.end && node.pos >= 0 && node.kind !== 1 /* EndOfFileToken */;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isClassLike) id{301,0} ---
(node) {
        return node && (node.kind === 226 /* ClassDeclaration */ || node.kind === 197 /* ClassExpression */);
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkCollisionWithCapturedThisVariable) id{302,0} ---
(node, name) {
            if (needCollisionCheckForIdentifier(node, name, "_this")) {
                potentialThisCollisions.push(node);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isReservedMemberName) id{303,0} ---
(name) {
            return name.charCodeAt(0) === 95 /* _ */ &&
                name.charCodeAt(1) === 95 /* _ */ &&
                name.charCodeAt(2) !== 95 /* _ */ &&
                name.charCodeAt(2) !== 64 /* at */;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:lastOrUndefined) id{304,0} ---
(array) {
        return array && array.length > 0
            ? array[array.length - 1]
            : undefined;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isDeclaredRestParam) id{305,0} ---
(node) {
        return node && node.dotDotDotToken !== undefined;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarForNonSymbolComputedProperty) id{306,0} ---
(node, message) {
            if (ts.isDynamicName(node)) {
                return grammarErrorOnNode(node, message);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkCollisionWithArgumentsInGeneratedCode) id{307,0} ---
(node) {
            // no rest parameters \x5c declaration context \x5c overload - no codegen impact
            if (!ts.hasDeclaredRestParameter(node) || ts.isInAmbientContext(node) || ts.nodeIsMissing(node.body)) {
                return;
            }
            ts.forEach(node.parameters, function (p) {
                if (p.name && !ts.isBindingPattern(p.name) && p.name.text === argumentsSymbol.name) {
                    error(p, ts.Diagnostics.Duplicate_identifier_arguments_Compiler_uses_arguments_to_initialize_rest_parameters);
                }
            });
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:hasDeclaredRestParameter) id{308,0} ---
(s) {
        return isDeclaredRestParam(ts.lastOrUndefined(s.parameters));
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isDeclaredRestParam) id{308,1} ---
(node) {
        return node && node.dotDotDotToken !== undefined;
    }
--- END ---
INLINE (isDeclaredRestParam) id{308,1} AS 1 AT <0:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:registerForUnusedIdentifiersCheck) id{309,0} ---
(node) {
            if (deferredUnusedIdentifierNodes) {
                deferredUnusedIdentifierNodes.push(node);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarFunctionLikeDeclaration) id{310,0} ---
(node) {
            // Prevent cascading error by short-circuit
            var file = ts.getSourceFileOfNode(node);
            return checkGrammarDecorators(node) || checkGrammarModifiers(node) || checkGrammarTypeParameterList(node.typeParameters, file) ||
                checkGrammarParameterList(node.parameters) || checkGrammarArrowFunction(node, file);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarTypeParameterList) id{310,1} ---
(typeParameters, file) {
            if (checkGrammarForDisallowedTrailingComma(typeParameters)) {
                return true;
            }
            if (typeParameters && typeParameters.length === 0) {
                var start = typeParameters.pos - "<".length;
                var end = ts.skipTrivia(file.text, typeParameters.end) + ">".length;
                return grammarErrorAtPos(file, start, end - start, ts.Diagnostics.Type_parameter_list_cannot_be_empty);
            }
        }
--- END ---
INLINE (checkGrammarTypeParameterList) id{310,1} AS 1 AT <0:200>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarForDisallowedTrailingComma) id{310,2} ---
(list) {
            if (list && list.hasTrailingComma) {
                var start = list.end - ",".length;
                var end = list.end;
                var sourceFile = ts.getSourceFileOfNode(list[0]);
                return grammarErrorAtPos(sourceFile, start, end - start, ts.Diagnostics.Trailing_comma_not_allowed);
            }
        }
--- END ---
INLINE (checkGrammarForDisallowedTrailingComma) id{310,2} AS 2 AT <1:41>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isCatchClauseVariableDeclarationOrBindingElement) id{311,0} ---
(declaration) {
        var node = getRootDeclaration(declaration);
        return node.kind === 223 /* VariableDeclaration */ && node.parent.kind === 256 /* CatchClause */;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getRootDeclaration) id{311,1} ---
(node) {
        while (node.kind === 174 /* BindingElement */) {
            node = node.parent.parent;
        }
        return node;
    }
--- END ---
INLINE (getRootDeclaration) id{311,1} AS 1 AT <0:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isFunctionLikeKind) id{312,0} ---
(kind) {
        switch (kind) {
            case 150 /* Constructor */:
            case 184 /* FunctionExpression */:
            case 225 /* FunctionDeclaration */:
            case 185 /* ArrowFunction */:
            case 149 /* MethodDeclaration */:
            case 148 /* MethodSignature */:
            case 151 /* GetAccessor */:
            case 152 /* SetAccessor */:
            case 153 /* CallSignature */:
            case 154 /* ConstructSignature */:
            case 155 /* IndexSignature */:
            case 158 /* FunctionType */:
            case 159 /* ConstructorType */:
                return true;
        }
        return false;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isDynamicName) id{313,0} ---
(name) {
        return name.kind === 142 /* ComputedPropertyName */ &&
            !isStringOrNumericLiteral(name.expression) &&
            !isWellKnownSymbolSyntactically(name.expression);
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isSourceFileJavaScript) id{314,0} ---
(file) {
        return isInJavaScriptFile(file);
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isInJavaScriptFile) id{314,1} ---
(node) {
        return node && !!(node.flags & 65536 /* JavaScriptFile */);
    }
--- END ---
INLINE (isInJavaScriptFile) id{314,1} AS 1 AT <0:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeFromTypeNode) id{315,0} ---
(node) {
            switch (node.kind) {
                case 118 /* AnyKeyword */:
                case 263 /* JSDocAllType */:
                case 264 /* JSDocUnknownType */:
                    return anyType;
                case 134 /* StringKeyword */:
                    return stringType;
                case 132 /* NumberKeyword */:
                    return numberType;
                case 121 /* BooleanKeyword */:
                    return booleanType;
                case 135 /* SymbolKeyword */:
                    return esSymbolType;
                case 104 /* VoidKeyword */:
                    return voidType;
                case 137 /* UndefinedKeyword */:
                    return undefinedType;
                case 94 /* NullKeyword */:
                    return nullType;
                case 129 /* NeverKeyword */:
                    return neverType;
                case 289 /* JSDocNullKeyword */:
                    return nullType;
                case 290 /* JSDocUndefinedKeyword */:
                    return undefinedType;
                case 291 /* JSDocNeverKeyword */:
                    return neverType;
                case 167 /* ThisType */:
                case 98 /* ThisKeyword */:
                    return getTypeFromThisTypeNode(node);
                case 171 /* LiteralType */:
                    return getTypeFromLiteralTypeNode(node);
                case 288 /* JSDocLiteralType */:
                    return getTypeFromLiteralTypeNode(node.literal);
                case 157 /* TypeReference */:
                case 272 /* JSDocTypeReference */:
                    return getTypeFromTypeReference(node);
                case 156 /* TypePredicate */:
                    return booleanType;
                case 199 /* ExpressionWithTypeArguments */:
                    return getTypeFromTypeReference(node);
                case 160 /* TypeQuery */:
                    return getTypeFromTypeQueryNode(node);
                case 162 /* ArrayType */:
                case 265 /* JSDocArrayType */:
                    return getTypeFromArrayTypeNode(node);
                case 163 /* TupleType */:
                    return getTypeFromTupleTypeNode(node);
                case 164 /* UnionType */:
                case 266 /* JSDocUnionType */:
                    return getTypeFromUnionTypeNode(node);
                case 165 /* IntersectionType */:
                    return getTypeFromIntersectionTypeNode(node);
                case 166 /* ParenthesizedType */:
                case 268 /* JSDocNullableType */:
                case 269 /* JSDocNonNullableType */:
                case 276 /* JSDocConstructorType */:
                case 277 /* JSDocThisType */:
                case 273 /* JSDocOptionalType */:
                    return getTypeFromTypeNode(node.type);
                case 270 /* JSDocRecordType */:
                    return getTypeFromTypeNode(node.literal);
                case 158 /* FunctionType */:
                case 159 /* ConstructorType */:
                case 161 /* TypeLiteral */:
                case 287 /* JSDocTypeLiteral */:
                case 274 /* JSDocFunctionType */:
                    return getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode(node);
                case 168 /* TypeOperator */:
                    return getTypeFromTypeOperatorNode(node);
                case 169 /* IndexedAccessType */:
                    return getTypeFromIndexedAccessTypeNode(node);
                case 170 /* MappedType */:
                    return getTypeFromMappedTypeNode(node);
                // This function assumes that an identifier or qualified name is a type expression
                // Callers should first ensure this by calling isTypeNode
                case 70 /* Identifier */:
                case 141 /* QualifiedName */:
                    var symbol = getSymbolAtLocation(node);
                    return symbol && getDeclaredTypeOfSymbol(symbol);
                case 267 /* JSDocTupleType */:
                    return getTypeFromJSDocTupleType(node);
                case 275 /* JSDocVariadicType */:
                    return getTypeFromJSDocVariadicType(node);
                default:
                    return unknownType;
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeFromArrayTypeNode) id{315,1} ---
(node) {
            var links = getNodeLinks(node);
            if (!links.resolvedType) {
                links.resolvedType = createArrayType(getTypeFromTypeNode(node.elementType));
            }
            return links.resolvedType;
        }
--- END ---
INLINE (getTypeFromArrayTypeNode) id{315,1} AS 1 AT <0:2107>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeLinks) id{315,2} ---
(node) {
            var nodeId = getNodeId(node);
            return nodeLinks[nodeId] || (nodeLinks[nodeId] = { flags: 0 });
        }
--- END ---
INLINE (getNodeLinks) id{315,2} AS 2 AT <1:33>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeId) id{315,3} ---
(node) {
        if (!node.id) {
            node.id = nextNodeId;
            nextNodeId++;
        }
        return node.id;
    }
--- END ---
INLINE (getNodeId) id{315,3} AS 3 AT <2:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createArrayType) id{315,4} ---
(elementType) {
            return createTypeFromGenericGlobalType(globalArrayType, [elementType]);
        }
--- END ---
INLINE (createArrayType) id{315,4} AS 4 AT <1:129>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createTypeFromGenericGlobalType) id{315,5} ---
(genericGlobalType, typeArguments) {
            return genericGlobalType !== emptyGenericType ? createTypeReference(genericGlobalType, typeArguments) : emptyObjectType;
        }
--- END ---
INLINE (createTypeFromGenericGlobalType) id{315,5} AS 5 AT <4:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createTypeReference) id{315,6} ---
(target, typeArguments) {
            var id = getTypeListId(typeArguments);
            var type = target.instantiations[id];
            if (!type) {
                type = target.instantiations[id] = createObjectType(4 /* Reference */, target.symbol);
                type.flags |= typeArguments ? getPropagatingFlagsOfTypes(typeArguments, /*excludeKinds*/ 0) : 0;
                type.target = target;
                type.typeArguments = typeArguments;
            }
            return type;
        }
--- END ---
INLINE (createTypeReference) id{315,6} AS 6 AT <5:97>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createObjectType) id{315,7} ---
(objectFlags, symbol) {
            var type = createType(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol = symbol;
            return type;
        }
--- END ---
INLINE (createObjectType) id{315,7} AS 7 AT <6:203>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropagatingFlagsOfTypes) id{315,8} ---
(types, excludeKinds) {
            var result = 0;
            for (var _i = 0, types_3 = types; _i < types_3.length; _i++) {
                var type = types_3[_i];
                if (!(type.flags & excludeKinds)) {
                    result |= type.flags;
                }
            }
            return result & 14680064 /* PropagatingFlags */;
        }
--- END ---
INLINE (getPropagatingFlagsOfTypes) id{315,8} AS 8 AT <6:301>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeFromUnionTypeNode) id{315,9} ---
(node) {
            var links = getNodeLinks(node);
            if (!links.resolvedType) {
                links.resolvedType = getUnionType(ts.map(node.types, getTypeFromTypeNode), /*subtypeReduction*/ false, getAliasSymbolForTypeNode(node), getAliasTypeArgumentsForTypeNode(node));
            }
            return links.resolvedType;
        }
--- END ---
INLINE (getTypeFromUnionTypeNode) id{315,9} AS 9 AT <0:2356>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeLinks) id{315,10} ---
(node) {
            var nodeId = getNodeId(node);
            return nodeLinks[nodeId] || (nodeLinks[nodeId] = { flags: 0 });
        }
--- END ---
INLINE (getNodeLinks) id{315,10} AS 10 AT <9:33>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeId) id{315,11} ---
(node) {
        if (!node.id) {
            node.id = nextNodeId;
            nextNodeId++;
        }
        return node.id;
    }
--- END ---
INLINE (getNodeId) id{315,11} AS 11 AT <10:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getAliasSymbolForTypeNode) id{315,12} ---
(node) {
            return node.parent.kind === 228 /* TypeAliasDeclaration */ ? getSymbolOfNode(node.parent) : undefined;
        }
--- END ---
INLINE (getAliasSymbolForTypeNode) id{315,12} AS 12 AT <9:211>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{315,13} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{315,13} AS 13 AT <12:82>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{315,14} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{315,14} AS 14 AT <13:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getAliasTypeArgumentsForTypeNode) id{315,15} ---
(node) {
            var symbol = getAliasSymbolForTypeNode(node);
            return symbol ? getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol) : undefined;
        }
--- END ---
INLINE (getAliasTypeArgumentsForTypeNode) id{315,15} AS 15 AT <9:244>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getAliasSymbolForTypeNode) id{315,16} ---
(node) {
            return node.parent.kind === 228 /* TypeAliasDeclaration */ ? getSymbolOfNode(node.parent) : undefined;
        }
--- END ---
INLINE (getAliasSymbolForTypeNode) id{315,16} AS 16 AT <15:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{315,17} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{315,17} AS 17 AT <16:82>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{315,18} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{315,18} AS 18 AT <17:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{316,0} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{316,1} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{316,1} AS 1 AT <0:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getApparentType) id{317,0} ---
(type) {
            var t = type.flags & 540672 /* TypeVariable */ ? getApparentTypeOfTypeVariable(type) : type;
            return t.flags & 262178 /* StringLike */ ? globalStringType :
                t.flags & 340 /* NumberLike */ ? globalNumberType :
                    t.flags & 136 /* BooleanLike */ ? globalBooleanType :
                        t.flags & 512 /* ESSymbol */ ? getGlobalESSymbolType() :
                            t;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createSymbol) id{318,0} ---
(flags, name) {
            symbolCount++;
            return new Symbol(flags, name);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:SymbolObject) id{318,1} ---
(flags, name) {
            this.flags = flags;
            this.name = name;
        }
--- END ---
INLINE (SymbolObject) id{318,1} AS 1 AT <0:62>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:symbolIsValue) id{319,0} ---
(symbol) {
            // If it is an instantiated symbol, then it is a value if the symbol it is an
            // instantiation of is a value.
            if (symbol.flags & 16777216 /* Instantiated */) {
                return symbolIsValue(getSymbolLinks(symbol).target);
            }
            // If the symbol has the value flag, it is trivially a value.
            if (symbol.flags & 107455 /* Value */) {
                return true;
            }
            // If it is an alias, then it is a value if the symbol it resolves to is a value.
            if (symbol.flags & 8388608 /* Alias */) {
                return (resolveAlias(symbol).flags & 107455 /* Value */) !== 0;
            }
            return false;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{319,1} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{319,1} AS 1 AT <0:244>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{319,2} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{319,2} AS 2 AT <1:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:popTypeResolution) id{320,0} ---
() {
            resolutionTargets.pop();
            resolutionPropertyNames.pop();
            return resolutionResults.pop();
        }
--- END ---
[deoptimizing (DEOPT eager): begin 0x29cc38d1bc31 <JS Function getMergedSymbol (SharedFunctionInfo 0x2e2f693e9a51)> (opt #289) @3, FP to SP delta: 24, caller sp: 0x7fff5fbfde80]
            ;;; deoptimize at 0_70: unexpected object
  reading input frame getMergedSymbol => node=26, args=2, height=3; inputs:
      0: 0x29cc38d1bc31 ; [fp - 16] 0x29cc38d1bc31 <JS Function getMergedSymbol (SharedFunctionInfo 0x2e2f693e9a51)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x29cc38d0de61 ; [fp + 16] 0x29cc38d0de61 <a SymbolObject with map 0x33abe2a72991>
      3: 0x29cc38d04261 ; [fp - 24] 0x29cc38d04261 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
      5: 0x1500000000 ; rax 21
  translating frame getMergedSymbol => node=26, height=16
    0x7fff5fbfde78: [top + 56] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfde70: [top + 48] <- 0x29cc38d0de61 ;  0x29cc38d0de61 <a SymbolObject with map 0x33abe2a72991>  (input #2)
    0x7fff5fbfde68: [top + 40] <- 0x2c21d25d175a ;  caller's pc
    0x7fff5fbfde60: [top + 32] <- 0x7fff5fbfde98 ;  caller's fp
    0x7fff5fbfde58: [top + 24] <- 0x29cc38d04261 ;  context    0x29cc38d04261 <FixedArray[1022]>  (input #3)
    0x7fff5fbfde50: [top + 16] <- 0x29cc38d1bc31 ;  function    0x29cc38d1bc31 <JS Function getMergedSymbol (SharedFunctionInfo 0x2e2f693e9a51)>  (input #0)
    0x7fff5fbfde48: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfde40: [top + 0] <- 0x1500000000 ;  21  (input #5)
[deoptimizing (eager): end 0x29cc38d1bc31 <JS Function getMergedSymbol (SharedFunctionInfo 0x2e2f693e9a51)> @3 => node=26, pc=0x2c21d25d186f, caller sp=0x7fff5fbfde80, state=TOS_REGISTER, took 0.065 ms]
[deoptimizing (DEOPT eager): begin 0x29cc38d1af89 <JS Function getSymbolLinks (SharedFunctionInfo 0x2e2f693e7651)> (opt #298) @11, FP to SP delta: 40, caller sp: 0x7fff5fbfdec8]
            ;;; deoptimize at 1_134: Unknown map in polymorphic access
  reading input frame getSymbolLinks => node=42, args=2, height=3; inputs:
      0: 0x29cc38d1af89 ; [fp - 16] 0x29cc38d1af89 <JS Function getSymbolLinks (SharedFunctionInfo 0x2e2f693e7651)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x74e2ec56c79 ; rbx 0x74e2ec56c79 <a SymbolObject with map 0x33abe2a74ca1>
      3: 0x29cc38d04261 ; [fp - 24] 0x29cc38d04261 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 3) 0x30bcea404311 <undefined>
      5: 0xd6230dc9a29 ; [fp - 32] 0xd6230dc9a29 <JS Function getSymbolId (SharedFunctionInfo 0x1f9f6c00b809)>
  reading input frame getSymbolId => node=5, args=2, height=1; inputs:
      0: 0xd6230dc9a29 ; (literal 4) 0xd6230dc9a29 <JS Function getSymbolId (SharedFunctionInfo 0x1f9f6c00b809)>
      1: 0x1f9f6c0532e1 ; (literal 5) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x74e2ec56c79 ; rbx 0x74e2ec56c79 <a SymbolObject with map 0x33abe2a74ca1>
      3: 0xd6230de6939 ; (literal 6) 0xd6230de6939 <FixedArray[12]>
  translating frame getSymbolLinks => node=42, height=16
    0x7fff5fbfdec0: [top + 56] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdeb8: [top + 48] <- 0x74e2ec56c79 ;  0x74e2ec56c79 <a SymbolObject with map 0x33abe2a74ca1>  (input #2)
    0x7fff5fbfdeb0: [top + 40] <- 0x2c21d25e7681 ;  caller's pc
    0x7fff5fbfdea8: [top + 32] <- 0x7fff5fbfdf08 ;  caller's fp
    0x7fff5fbfdea0: [top + 24] <- 0x29cc38d04261 ;  context    0x29cc38d04261 <FixedArray[1022]>  (input #3)
    0x7fff5fbfde98: [top + 16] <- 0x29cc38d1af89 ;  function    0x29cc38d1af89 <JS Function getSymbolLinks (SharedFunctionInfo 0x2e2f693e7651)>  (input #0)
    0x7fff5fbfde90: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfde88: [top + 0] <- 0xd6230dc9a29 ;  0xd6230dc9a29 <JS Function getSymbolId (SharedFunctionInfo 0x1f9f6c00b809)>  (input #5)
  translating frame getSymbolId => node=5, height=0
    0x7fff5fbfde80: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfde78: [top + 32] <- 0x74e2ec56c79 ;  0x74e2ec56c79 <a SymbolObject with map 0x33abe2a74ca1>  (input #2)
    0x7fff5fbfde70: [top + 24] <- 0x2c21d25e3dc3 ;  caller's pc
    0x7fff5fbfde68: [top + 16] <- 0x7fff5fbfdea8 ;  caller's fp
    0x7fff5fbfde60: [top + 8] <- 0xd6230de6939 ;  context    0xd6230de6939 <FixedArray[12]>  (input #3)
    0x7fff5fbfde58: [top + 0] <- 0xd6230dc9a29 ;  function    0xd6230dc9a29 <JS Function getSymbolId (SharedFunctionInfo 0x1f9f6c00b809)>  (input #0)
[deoptimizing (eager): end 0x29cc38d1af89 <JS Function getSymbolLinks (SharedFunctionInfo 0x2e2f693e7651)> @11 => node=5, pc=0x2c21d25e7d67, caller sp=0x7fff5fbfdec8, state=NO_REGISTERS, took 0.218 ms]
[deoptimizing (DEOPT eager): begin 0x29cc38d1bd51 <JS Function symbolIsValue (SharedFunctionInfo 0x2e2f693e9d51)> (opt #319) @2, FP to SP delta: 56, caller sp: 0x7fff5fbfdcd0]
            ;;; deoptimize at 0_167: wrong map
  reading input frame symbolIsValue => node=4, args=2, height=1; inputs:
      0: 0x29cc38d1bd51 ; [fp - 16] 0x29cc38d1bd51 <JS Function symbolIsValue (SharedFunctionInfo 0x2e2f693e9d51)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x74e2ec573e9 ; rax 0x74e2ec573e9 <a SymbolObject with map 0x33abe2a728e1>
      3: 0x29cc38d04261 ; [fp - 24] 0x29cc38d04261 <FixedArray[1022]>
  translating frame symbolIsValue => node=4, height=0
    0x7fff5fbfdcc8: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdcc0: [top + 32] <- 0x74e2ec573e9 ;  0x74e2ec573e9 <a SymbolObject with map 0x33abe2a728e1>  (input #2)
    0x7fff5fbfdcb8: [top + 24] <- 0x2c21d253dc48 ;  caller's pc
    0x7fff5fbfdcb0: [top + 16] <- 0x7fff5fbfdd30 ;  caller's fp
    0x7fff5fbfdca8: [top + 8] <- 0x29cc38d04261 ;  context    0x29cc38d04261 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdca0: [top + 0] <- 0x29cc38d1bd51 ;  function    0x29cc38d1bd51 <JS Function symbolIsValue (SharedFunctionInfo 0x2e2f693e9d51)>  (input #0)
[deoptimizing (eager): end 0x29cc38d1bd51 <JS Function symbolIsValue (SharedFunctionInfo 0x2e2f693e9d51)> @2 => node=4, pc=0x2c21d260e0c6, caller sp=0x7fff5fbfdcd0, state=NO_REGISTERS, took 0.049 ms]
[deoptimizing (DEOPT eager): begin 0xd6230dc9a29 <JS Function getSymbolId (SharedFunctionInfo 0x1f9f6c00b809)> (opt #290) @9, FP to SP delta: 24, caller sp: 0x7fff5fbfdce0]
            ;;; deoptimize at 0_134: Unknown map in polymorphic access
  reading input frame getSymbolId => node=5, args=2, height=1; inputs:
      0: 0xd6230dc9a29 ; [fp - 16] 0xd6230dc9a29 <JS Function getSymbolId (SharedFunctionInfo 0x1f9f6c00b809)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x74e2ec573e9 ; rbx 0x74e2ec573e9 <a SymbolObject with map 0x33abe2a74cf9>
      3: 0xd6230de6939 ; rax 0xd6230de6939 <FixedArray[12]>
  translating frame getSymbolId => node=5, height=0
    0x7fff5fbfdcd8: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdcd0: [top + 32] <- 0x74e2ec573e9 ;  0x74e2ec573e9 <a SymbolObject with map 0x33abe2a74cf9>  (input #2)
    0x7fff5fbfdcc8: [top + 24] <- 0x2c21d25e3dc3 ;  caller's pc
    0x7fff5fbfdcc0: [top + 16] <- 0x7fff5fbfdd00 ;  caller's fp
    0x7fff5fbfdcb8: [top + 8] <- 0xd6230de6939 ;  context    0xd6230de6939 <FixedArray[12]>  (input #3)
    0x7fff5fbfdcb0: [top + 0] <- 0xd6230dc9a29 ;  function    0xd6230dc9a29 <JS Function getSymbolId (SharedFunctionInfo 0x1f9f6c00b809)>  (input #0)
[deoptimizing (eager): end 0xd6230dc9a29 <JS Function getSymbolId (SharedFunctionInfo 0x1f9f6c00b809)> @9 => node=5, pc=0x2c21d25e7d67, caller sp=0x7fff5fbfdce0, state=NO_REGISTERS, took 0.047 ms]
[deoptimizing (DEOPT eager): begin 0xd6230dafba9 <JS Function lastOrUndefined (SharedFunctionInfo 0xc2bd2ae2569)> (opt #304) @3, FP to SP delta: 24, caller sp: 0x7fff5fbfdb10]
            ;;; deoptimize at 0_39: wrong map
  reading input frame lastOrUndefined => node=11, args=2, height=1; inputs:
      0: 0xd6230dafba9 ; [fp - 16] 0xd6230dafba9 <JS Function lastOrUndefined (SharedFunctionInfo 0xc2bd2ae2569)>
      1: 0x16f3adb61821 ; [fp + 24] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x29cc38d19e71 ; rax 0x29cc38d19e71 <JS Array[0]>
      3: 0xd6230db3179 ; [fp - 24] 0xd6230db3179 <FixedArray[95]>
  translating frame lastOrUndefined => node=11, height=0
    0x7fff5fbfdb08: [top + 40] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfdb00: [top + 32] <- 0x29cc38d19e71 ;  0x29cc38d19e71 <JS Array[0]>  (input #2)
    0x7fff5fbfdaf8: [top + 24] <- 0x2c21d260f659 ;  caller's pc
    0x7fff5fbfdaf0: [top + 16] <- 0x7fff5fbfdb88 ;  caller's fp
    0x7fff5fbfdae8: [top + 8] <- 0xd6230db3179 ;  context    0xd6230db3179 <FixedArray[95]>  (input #3)
    0x7fff5fbfdae0: [top + 0] <- 0xd6230dafba9 ;  function    0xd6230dafba9 <JS Function lastOrUndefined (SharedFunctionInfo 0xc2bd2ae2569)>  (input #0)
[deoptimizing (eager): end 0xd6230dafba9 <JS Function lastOrUndefined (SharedFunctionInfo 0xc2bd2ae2569)> @3 => node=11, pc=0x2c21d23ec167, caller sp=0x7fff5fbfdb10, state=NO_REGISTERS, took 0.046 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isGlobalSourceFile) id{321,0} ---
(node) {
            return node.kind === 261 /* SourceFile */ && !ts.isExternalOrCommonJsModule(node);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexSymbol) id{322,0} ---
(symbol) {
            return symbol.members["__index"];
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{323,0} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:addOptionality) id{324,0} ---
(type, optional) {
            return strictNullChecks && optional ? includeFalsyTypes(type, 2048 /* Undefined */) : type;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbol) id{325,0} ---
(symbols, name, meaning) {
            if (meaning) {
                var symbol = symbols[name];
                if (symbol) {
                    ts.Debug.assert((symbol.flags & 16777216 /* Instantiated */) === 0, "Should never get an instantiated symbol here.");
                    if (symbol.flags & meaning) {
                        return symbol;
                    }
                    if (symbol.flags & 8388608 /* Alias */) {
                        var target = resolveAlias(symbol);
                        // Unknown symbol means an error occurred in alias resolution, treat it as positive answer to avoid cascading errors
                        if (target === unknownSymbol || target.flags & meaning) {
                            return symbol;
                        }
                    }
                }
            }
            // return undefined if we can't find a symbol.
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getInterfaceBaseTypeNodes) id{326,0} ---
(node) {
        var heritageClause = getHeritageClause(node.heritageClauses, 84 /* ExtendsKeyword */);
        return heritageClause ? heritageClause.types : undefined;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getHeritageClause) id{326,1} ---
(clauses, kind) {
        if (clauses) {
            for (var _i = 0, clauses_1 = clauses; _i < clauses_1.length; _i++) {
                var clause = clauses_1[_i];
                if (clause.token === kind) {
                    return clause;
                }
            }
        }
        return undefined;
    }
--- END ---
INLINE (getHeritageClause) id{326,1} AS 1 AT <0:38>
[deoptimizing (DEOPT soft): begin 0x29cc38d28429 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> (opt #292) @89, FP to SP delta: 168, caller sp: 0x7fff5fbfd9a0]
            ;;; deoptimize at 0_2687: Insufficient type feedback for generic named access
  reading input frame checkSourceElement => node=486, args=2, height=4; inputs:
      0: 0x29cc38d28429 ; [fp - 16] 0x29cc38d28429 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x286514cc0ec1 ; [fp + 16] 0x286514cc0ec1 <a NodeObject with map 0x33abe2a68859>
      3: 0x29cc38d04261 ; rax 0x29cc38d04261 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 25) 0x30bcea404311 <undefined>
      5: 0x30bcea4069a9 ; (literal 26) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      6: 0x30bcea4069a9 ; (literal 26) 0x30bcea4069a9 <Odd Oddball: optimized_out>
  translating frame checkSourceElement => node=486, height=24
    0x7fff5fbfd998: [top + 64] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd990: [top + 56] <- 0x286514cc0ec1 ;  0x286514cc0ec1 <a NodeObject with map 0x33abe2a68859>  (input #2)
    0x7fff5fbfd988: [top + 48] <- 0x2c21d26249fe ;  caller's pc
    0x7fff5fbfd980: [top + 40] <- 0x7fff5fbfda48 ;  caller's fp
    0x7fff5fbfd978: [top + 32] <- 0x29cc38d04261 ;  context    0x29cc38d04261 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd970: [top + 24] <- 0x29cc38d28429 ;  function    0x29cc38d28429 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>  (input #0)
    0x7fff5fbfd968: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfd960: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #5)
    0x7fff5fbfd958: [top + 0] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
[deoptimizing (soft): end 0x29cc38d28429 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> @89 => node=486, pc=0x2c21d25ec2e0, caller sp=0x7fff5fbfd9a0, state=NO_REGISTERS, took 0.064 ms]
[deoptimizer unlinked: checkSourceElement / 29cc38d28429]
[deoptimizing (DEOPT lazy): begin 0x29cc38d28429 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> (opt #292) @100, FP to SP delta: 168, caller sp: 0x7fff5fbfda68]
  reading input frame checkSourceElement => node=422, args=2, height=5; inputs:
      0: 0x29cc38d28429 ; [fp - 16] 0x29cc38d28429 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x286514caa1c1 ; [fp + 16] 0x286514caa1c1 <a NodeObject with map 0x33abe2a67519>
      3: 0x29cc38d04261 ; [fp - 24] 0x29cc38d04261 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 25) 0x30bcea404311 <undefined>
      5: 0x30bcea4069a9 ; (literal 26) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      6: 0x30bcea4069a9 ; (literal 26) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x29cc38d26611 ; [fp - 160] 0x29cc38d26611 <JS Function checkArrayType (SharedFunctionInfo 0x1b98fbc0b1c1)>
  reading input frame checkArrayType => node=5, args=2, height=1; inputs:
      0: 0x29cc38d26611 ; (literal 38) 0x29cc38d26611 <JS Function checkArrayType (SharedFunctionInfo 0x1b98fbc0b1c1)>
      1: 0x1f9f6c0532e1 ; (literal 28) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x286514caa1c1 ; [fp + 16] 0x286514caa1c1 <a NodeObject with map 0x33abe2a67519>
      3: 0x29cc38d04261 ; (literal 29) 0x29cc38d04261 <FixedArray[1022]>
  translating frame checkSourceElement => node=422, height=32
    0x7fff5fbfda60: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfda58: [top + 64] <- 0x286514caa1c1 ;  0x286514caa1c1 <a NodeObject with map 0x33abe2a67519>  (input #2)
    0x7fff5fbfda50: [top + 56] <- 0x2c21d2207e55 ;  caller's pc
    0x7fff5fbfda48: [top + 48] <- 0x7fff5fbfda80 ;  caller's fp
    0x7fff5fbfda40: [top + 40] <- 0x29cc38d04261 ;  context    0x29cc38d04261 <FixedArray[1022]>  (input #3)
    0x7fff5fbfda38: [top + 32] <- 0x29cc38d28429 ;  function    0x29cc38d28429 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>  (input #0)
    0x7fff5fbfda30: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfda28: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #5)
    0x7fff5fbfda20: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfda18: [top + 0] <- 0x29cc38d26611 ;  0x29cc38d26611 <JS Function checkArrayType (SharedFunctionInfo 0x1b98fbc0b1c1)>  (input #7)
  translating frame checkArrayType => node=5, height=0
    0x7fff5fbfda10: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfda08: [top + 32] <- 0x286514caa1c1 ;  0x286514caa1c1 <a NodeObject with map 0x33abe2a67519>  (input #2)
    0x7fff5fbfda00: [top + 24] <- 0x2c21d25ec271 ;  caller's pc
    0x7fff5fbfd9f8: [top + 16] <- 0x7fff5fbfda48 ;  caller's fp
    0x7fff5fbfd9f0: [top + 8] <- 0x29cc38d04261 ;  context    0x29cc38d04261 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd9e8: [top + 0] <- 0x29cc38d26611 ;  function    0x29cc38d26611 <JS Function checkArrayType (SharedFunctionInfo 0x1b98fbc0b1c1)>  (input #0)
[deoptimizing (lazy): end 0x29cc38d28429 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> @100 => node=5, pc=0x2c21d25956c2, caller sp=0x7fff5fbfda68, state=NO_REGISTERS, took 0.098 ms]
[deoptimizing (DEOPT lazy): begin 0x29cc38d28429 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> (opt #292) @94, FP to SP delta: 168, caller sp: 0x7fff5fbfdbc8]
  reading input frame checkSourceElement => node=467, args=2, height=5; inputs:
      0: 0x29cc38d28429 ; [fp - 16] 0x29cc38d28429 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x286514c7ce09 ; [fp + 16] 0x286514c7ce09 <a NodeObject with map 0x33abe2a67f69>
      3: 0x29cc38d04261 ; [fp - 24] 0x29cc38d04261 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 25) 0x30bcea404311 <undefined>
      5: 0x30bcea4069a9 ; (literal 26) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      6: 0x30bcea4069a9 ; (literal 26) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x29cc38d266a1 ; [fp - 144] 0x29cc38d266a1 <JS Function checkUnionOrIntersectionType (SharedFunctionInfo 0x1b98fbc0b341)>
  reading input frame checkUnionOrIntersectionType => node=5, args=2, height=1; inputs:
      0: 0x29cc38d266a1 ; (literal 37) 0x29cc38d266a1 <JS Function checkUnionOrIntersectionType (SharedFunctionInfo 0x1b98fbc0b341)>
      1: 0x1f9f6c0532e1 ; (literal 28) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x286514c7ce09 ; [fp + 16] 0x286514c7ce09 <a NodeObject with map 0x33abe2a67f69>
      3: 0x29cc38d04261 ; (literal 29) 0x29cc38d04261 <FixedArray[1022]>
  translating frame checkSourceElement => node=467, height=32
    0x7fff5fbfdbc0: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdbb8: [top + 64] <- 0x286514c7ce09 ;  0x286514c7ce09 <a NodeObject with map 0x33abe2a67f69>  (input #2)
    0x7fff5fbfdbb0: [top + 56] <- 0x2c21d25f3311 ;  caller's pc
    0x7fff5fbfdba8: [top + 48] <- 0x7fff5fbfdc18 ;  caller's fp
    0x7fff5fbfdba0: [top + 40] <- 0x29cc38d04261 ;  context    0x29cc38d04261 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdb98: [top + 32] <- 0x29cc38d28429 ;  function    0x29cc38d28429 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>  (input #0)
    0x7fff5fbfdb90: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfdb88: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #5)
    0x7fff5fbfdb80: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfdb78: [top + 0] <- 0x29cc38d266a1 ;  0x29cc38d266a1 <JS Function checkUnionOrIntersectionType (SharedFunctionInfo 0x1b98fbc0b341)>  (input #7)
  translating frame checkUnionOrIntersectionType => node=5, height=0
    0x7fff5fbfdb70: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdb68: [top + 32] <- 0x286514c7ce09 ;  0x286514c7ce09 <a NodeObject with map 0x33abe2a67f69>  (input #2)
    0x7fff5fbfdb60: [top + 24] <- 0x2c21d25ec2d3 ;  caller's pc
    0x7fff5fbfdb58: [top + 16] <- 0x7fff5fbfdba8 ;  caller's fp
    0x7fff5fbfdb50: [top + 8] <- 0x29cc38d04261 ;  context    0x29cc38d04261 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdb48: [top + 0] <- 0x29cc38d266a1 ;  function    0x29cc38d266a1 <JS Function checkUnionOrIntersectionType (SharedFunctionInfo 0x1b98fbc0b341)>  (input #0)
[deoptimizing (lazy): end 0x29cc38d28429 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> @94 => node=5, pc=0x2c21d261f1ee, caller sp=0x7fff5fbfdbc8, state=NO_REGISTERS, took 0.089 ms]
[deoptimizing (DEOPT soft): begin 0x29cc38d1fd29 <JS Function getTypeFromTypeNode (SharedFunctionInfo 0x2e2f693f5581)> (opt #315) @11, FP to SP delta: 296, caller sp: 0x7fff5fbfd760]
            ;;; deoptimize at 0_2856: Insufficient type feedback for generic named access
  reading input frame getTypeFromTypeNode => node=443, args=2, height=3; inputs:
      0: 0x29cc38d1fd29 ; [fp - 16] 0x29cc38d1fd29 <JS Function getTypeFromTypeNode (SharedFunctionInfo 0x2e2f693f5581)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x286514cc0ec1 ; [fp + 16] 0x286514cc0ec1 <a NodeObject with map 0x33abe2a68859>
      3: 0x29cc38d04261 ; rcx 0x29cc38d04261 <FixedArray[1022]>
      4: 0x30bcea4069a9 ; (literal 28) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      5: 0x30bcea404311 ; (literal 27) 0x30bcea404311 <undefined>
  translating frame getTypeFromTypeNode => node=443, height=16
    0x7fff5fbfd758: [top + 56] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd750: [top + 48] <- 0x286514cc0ec1 ;  0x286514cc0ec1 <a NodeObject with map 0x33abe2a68859>  (input #2)
    0x7fff5fbfd748: [top + 40] <- 0x2c21d263f70e ;  caller's pc
    0x7fff5fbfd740: [top + 32] <- 0x7fff5fbfd888 ;  caller's fp
    0x7fff5fbfd738: [top + 24] <- 0x29cc38d04261 ;  context    0x29cc38d04261 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd730: [top + 16] <- 0x29cc38d1fd29 ;  function    0x29cc38d1fd29 <JS Function getTypeFromTypeNode (SharedFunctionInfo 0x2e2f693f5581)>  (input #0)
    0x7fff5fbfd728: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #4)
    0x7fff5fbfd720: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
[deoptimizing (soft): end 0x29cc38d1fd29 <JS Function getTypeFromTypeNode (SharedFunctionInfo 0x2e2f693f5581)> @11 => node=443, pc=0x2c21d25f873b, caller sp=0x7fff5fbfd760, state=NO_REGISTERS, took 0.048 ms]
[deoptimizer unlinked: getTypeFromTypeNode / 29cc38d1fd29]
[deoptimizing (DEOPT lazy): begin 0x29cc38d1fd29 <JS Function getTypeFromTypeNode (SharedFunctionInfo 0x2e2f693f5581)> (opt #315) @82, FP to SP delta: 296, caller sp: 0x7fff5fbfd8a8]
  reading input frame getTypeFromTypeNode => node=332, args=2, height=4; inputs:
      0: 0x29cc38d1fd29 ; [fp - 16] 0x29cc38d1fd29 <JS Function getTypeFromTypeNode (SharedFunctionInfo 0x2e2f693f5581)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x286514caa1c1 ; [fp + 16] 0x286514caa1c1 <a NodeObject with map 0x33abe2a73801>
      3: 0x29cc38d04261 ; [fp - 24] 0x29cc38d04261 <FixedArray[1022]>
      4: 0x30bcea4069a9 ; (literal 28) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      5: 0x30bcea404311 ; (literal 27) 0x30bcea404311 <undefined>
      6: 0x29cc38d1f231 ; [fp - 72] 0x29cc38d1f231 <JS Function getTypeFromArrayTypeNode (SharedFunctionInfo 0x2e2f693f3291)>
  reading input frame getTypeFromArrayTypeNode => node=71, args=2, height=6; inputs:
      0: 0x29cc38d1f231 ; (literal 40) 0x29cc38d1f231 <JS Function getTypeFromArrayTypeNode (SharedFunctionInfo 0x2e2f693f3291)>
      1: 0x1f9f6c0532e1 ; (literal 30) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x286514caa1c1 ; [fp + 16] 0x286514caa1c1 <a NodeObject with map 0x33abe2a73801>
      3: 0x29cc38d04261 ; (literal 31) 0x29cc38d04261 <FixedArray[1022]>
      4: 0xe185ff08599 ; [fp - 208] 0xe185ff08599 <an Object with map 0x33abe2a51889>
      5: 0xe185ff08599 ; [fp - 208] 0xe185ff08599 <an Object with map 0x33abe2a51889>
      6: 0x29cc38d1f1e9 ; [fp - 216] 0x29cc38d1f1e9 <JS Function createArrayType (SharedFunctionInfo 0x2e2f693f31d1)>
      7: 0x30bcea404311 ; (literal 27) 0x30bcea404311 <undefined>
      8: 0xe185ff07e71 ; rax 0xe185ff07e71 <a TypeObject with map 0x33abe2a6d0e1>
  translating frame getTypeFromTypeNode => node=332, height=24
    0x7fff5fbfd8a0: [top + 64] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd898: [top + 56] <- 0x286514caa1c1 ;  0x286514caa1c1 <a NodeObject with map 0x33abe2a73801>  (input #2)
    0x7fff5fbfd890: [top + 48] <- 0x2c21d2207e55 ;  caller's pc
    0x7fff5fbfd888: [top + 40] <- 0x7fff5fbfd8c0 ;  caller's fp
    0x7fff5fbfd880: [top + 32] <- 0x29cc38d04261 ;  context    0x29cc38d04261 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd878: [top + 24] <- 0x29cc38d1fd29 ;  function    0x29cc38d1fd29 <JS Function getTypeFromTypeNode (SharedFunctionInfo 0x2e2f693f5581)>  (input #0)
    0x7fff5fbfd870: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #4)
    0x7fff5fbfd868: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfd860: [top + 0] <- 0x29cc38d1f231 ;  0x29cc38d1f231 <JS Function getTypeFromArrayTypeNode (SharedFunctionInfo 0x2e2f693f3291)>  (input #6)
  translating frame getTypeFromArrayTypeNode => node=71, height=40
    0x7fff5fbfd858: [top + 80] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd850: [top + 72] <- 0x286514caa1c1 ;  0x286514caa1c1 <a NodeObject with map 0x33abe2a73801>  (input #2)
    0x7fff5fbfd848: [top + 64] <- 0x2c21d25f869b ;  caller's pc
    0x7fff5fbfd840: [top + 56] <- 0x7fff5fbfd888 ;  caller's fp
    0x7fff5fbfd838: [top + 48] <- 0x29cc38d04261 ;  context    0x29cc38d04261 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd830: [top + 40] <- 0x29cc38d1f231 ;  function    0x29cc38d1f231 <JS Function getTypeFromArrayTypeNode (SharedFunctionInfo 0x2e2f693f3291)>  (input #0)
    0x7fff5fbfd828: [top + 32] <- 0xe185ff08599 ;  0xe185ff08599 <an Object with map 0x33abe2a51889>  (input #4)
    0x7fff5fbfd820: [top + 24] <- 0xe185ff08599 ;  0xe185ff08599 <an Object with map 0x33abe2a51889>  (input #5)
    0x7fff5fbfd818: [top + 16] <- 0x29cc38d1f1e9 ;  0x29cc38d1f1e9 <JS Function createArrayType (SharedFunctionInfo 0x2e2f693f31d1)>  (input #6)
    0x7fff5fbfd810: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfd808: [top + 0] <- 0xe185ff07e71 ;  0xe185ff07e71 <a TypeObject with map 0x33abe2a6d0e1>  (input #8)
[deoptimizing (lazy): end 0x29cc38d1fd29 <JS Function getTypeFromTypeNode (SharedFunctionInfo 0x2e2f693f5581)> @82 => node=71, pc=0x2c21d2595859, caller sp=0x7fff5fbfd8a8, state=NO_REGISTERS, took 0.129 ms]
[deoptimizing (DEOPT lazy): begin 0x29cc38d1fd29 <JS Function getTypeFromTypeNode (SharedFunctionInfo 0x2e2f693f5581)> (opt #315) @32, FP to SP delta: 296, caller sp: 0x7fff5fbfda90]
  reading input frame getTypeFromTypeNode => node=377, args=2, height=4; inputs:
      0: 0x29cc38d1fd29 ; [fp - 16] 0x29cc38d1fd29 <JS Function getTypeFromTypeNode (SharedFunctionInfo 0x2e2f693f5581)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x286514c7ce09 ; [fp + 16] 0x286514c7ce09 <a NodeObject with map 0x33abe2a73fe9>
      3: 0x29cc38d04261 ; [fp - 24] 0x29cc38d04261 <FixedArray[1022]>
      4: 0x30bcea4069a9 ; (literal 28) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      5: 0x30bcea404311 ; (literal 27) 0x30bcea404311 <undefined>
      6: 0x29cc38d1f549 ; [fp - 32] 0x29cc38d1f549 <JS Function getTypeFromUnionTypeNode (SharedFunctionInfo 0x2e2f693f3e91)>
  reading input frame getTypeFromUnionTypeNode => node=71, args=2, height=6; inputs:
      0: 0x29cc38d1f549 ; (literal 29) 0x29cc38d1f549 <JS Function getTypeFromUnionTypeNode (SharedFunctionInfo 0x2e2f693f3e91)>
      1: 0x1f9f6c0532e1 ; (literal 30) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x286514c7ce09 ; [fp + 16] 0x286514c7ce09 <a NodeObject with map 0x33abe2a73fe9>
      3: 0x29cc38d04261 ; (literal 31) 0x29cc38d04261 <FixedArray[1022]>
      4: 0xe185ff08549 ; [fp - 64] 0xe185ff08549 <an Object with map 0x33abe2a51889>
      5: 0xe185ff08549 ; [fp - 64] 0xe185ff08549 <an Object with map 0x33abe2a51889>
      6: 0x29cc38d18071 ; [fp - 72] 0x29cc38d18071 <JS Function getUnionType (SharedFunctionInfo 0x2e2f693f3d11)>
      7: 0x30bcea404311 ; (literal 27) 0x30bcea404311 <undefined>
      8: 0xe185ff08569 ; rax 0xe185ff08569 <JS Array[2]>
  translating frame getTypeFromTypeNode => node=377, height=24
    0x7fff5fbfda88: [top + 64] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfda80: [top + 56] <- 0x286514c7ce09 ;  0x286514c7ce09 <a NodeObject with map 0x33abe2a73fe9>  (input #2)
    0x7fff5fbfda78: [top + 48] <- 0x2c21d25f6cab ;  caller's pc
    0x7fff5fbfda70: [top + 40] <- 0x7fff5fbfdae8 ;  caller's fp
    0x7fff5fbfda68: [top + 32] <- 0x29cc38d04261 ;  context    0x29cc38d04261 <FixedArray[1022]>  (input #3)
    0x7fff5fbfda60: [top + 24] <- 0x29cc38d1fd29 ;  function    0x29cc38d1fd29 <JS Function getTypeFromTypeNode (SharedFunctionInfo 0x2e2f693f5581)>  (input #0)
    0x7fff5fbfda58: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #4)
    0x7fff5fbfda50: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfda48: [top + 0] <- 0x29cc38d1f549 ;  0x29cc38d1f549 <JS Function getTypeFromUnionTypeNode (SharedFunctionInfo 0x2e2f693f3e91)>  (input #6)
  translating frame getTypeFromUnionTypeNode => node=71, height=40
    0x7fff5fbfda40: [top + 80] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfda38: [top + 72] <- 0x286514c7ce09 ;  0x286514c7ce09 <a NodeObject with map 0x33abe2a73fe9>  (input #2)
    0x7fff5fbfda30: [top + 64] <- 0x2c21d25f86fd ;  caller's pc
    0x7fff5fbfda28: [top + 56] <- 0x7fff5fbfda70 ;  caller's fp
    0x7fff5fbfda20: [top + 48] <- 0x29cc38d04261 ;  context    0x29cc38d04261 <FixedArray[1022]>  (input #3)
    0x7fff5fbfda18: [top + 40] <- 0x29cc38d1f549 ;  function    0x29cc38d1f549 <JS Function getTypeFromUnionTypeNode (SharedFunctionInfo 0x2e2f693f3e91)>  (input #0)
    0x7fff5fbfda10: [top + 32] <- 0xe185ff08549 ;  0xe185ff08549 <an Object with map 0x33abe2a51889>  (input #4)
    0x7fff5fbfda08: [top + 24] <- 0xe185ff08549 ;  0xe185ff08549 <an Object with map 0x33abe2a51889>  (input #5)
    0x7fff5fbfda00: [top + 16] <- 0x29cc38d18071 ;  0x29cc38d18071 <JS Function getUnionType (SharedFunctionInfo 0x2e2f693f3d11)>  (input #6)
    0x7fff5fbfd9f8: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfd9f0: [top + 0] <- 0xe185ff08569 ;  0xe185ff08569 <JS Array[2]>  (input #8)
[deoptimizing (lazy): end 0x29cc38d1fd29 <JS Function getTypeFromTypeNode (SharedFunctionInfo 0x2e2f693f5581)> @32 => node=71, pc=0x2c21d261f3a5, caller sp=0x7fff5fbfda90, state=NO_REGISTERS, took 0.216 ms]
[deoptimizing (DEOPT lazy): begin 0x29cc38d28429 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> (opt #292) @109, FP to SP delta: 168, caller sp: 0x7fff5fbfdec8]
  reading input frame checkSourceElement => node=280, args=2, height=5; inputs:
      0: 0x29cc38d28429 ; [fp - 16] 0x29cc38d28429 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x286514c303f9 ; [fp + 16] 0x286514c303f9 <a NodeObject with map 0x33abe2a70521>
      3: 0x29cc38d04261 ; [fp - 24] 0x29cc38d04261 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 25) 0x30bcea404311 <undefined>
      5: 0x30bcea4069a9 ; (literal 26) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      6: 0x30bcea4069a9 ; (literal 26) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x30bcea404311 ; rax 0x30bcea404311 <undefined>
  translating frame checkSourceElement => node=280, height=32
    0x7fff5fbfdec0: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdeb8: [top + 64] <- 0x286514c303f9 ;  0x286514c303f9 <a NodeObject with map 0x33abe2a70521>  (input #2)
    0x7fff5fbfdeb0: [top + 56] <- 0x2c21d2207e55 ;  caller's pc
    0x7fff5fbfdea8: [top + 48] <- 0x7fff5fbfdee0 ;  caller's fp
    0x7fff5fbfdea0: [top + 40] <- 0x29cc38d04261 ;  context    0x29cc38d04261 <FixedArray[1022]>  (input #3)
    0x7fff5fbfde98: [top + 32] <- 0x29cc38d28429 ;  function    0x29cc38d28429 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>  (input #0)
    0x7fff5fbfde90: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfde88: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #5)
    0x7fff5fbfde80: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfde78: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
[deoptimizing (lazy): end 0x29cc38d28429 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> @109 => node=280, pc=0x2c21d25ec122, caller sp=0x7fff5fbfdec8, state=TOS_REGISTER, took 0.059 ms]
[deoptimizing (DEOPT lazy): begin 0x29cc38d28429 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> (opt #292) @16, FP to SP delta: 168, caller sp: 0x7fff5fbfe098]
  reading input frame checkSourceElement => node=948, args=2, height=5; inputs:
      0: 0x29cc38d28429 ; [fp - 16] 0x29cc38d28429 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x286514c21ab1 ; [fp + 16] 0x286514c21ab1 <a NodeObject with map 0x33abe2a70101>
      3: 0x29cc38d04261 ; [fp - 24] 0x29cc38d04261 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 25) 0x30bcea404311 <undefined>
      5: 0x30bcea4069a9 ; (literal 26) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      6: 0x30bcea4069a9 ; (literal 26) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x30bcea404311 ; rax 0x30bcea404311 <undefined>
  translating frame checkSourceElement => node=948, height=32
    0x7fff5fbfe090: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfe088: [top + 64] <- 0x286514c21ab1 ;  0x286514c21ab1 <a NodeObject with map 0x33abe2a70101>  (input #2)
    0x7fff5fbfe080: [top + 56] <- 0x2c21d2207e55 ;  caller's pc
    0x7fff5fbfe078: [top + 48] <- 0x7fff5fbfe0b0 ;  caller's fp
    0x7fff5fbfe070: [top + 40] <- 0x29cc38d04261 ;  context    0x29cc38d04261 <FixedArray[1022]>  (input #3)
    0x7fff5fbfe068: [top + 32] <- 0x29cc38d28429 ;  function    0x29cc38d28429 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>  (input #0)
    0x7fff5fbfe060: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfe058: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #5)
    0x7fff5fbfe050: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfe048: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
[deoptimizing (lazy): end 0x29cc38d28429 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> @16 => node=948, pc=0x2c21d25ec795, caller sp=0x7fff5fbfe098, state=TOS_REGISTER, took 0.063 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{327,0} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{327,1} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{327,1} AS 1 AT <0:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveName) id{328,0} ---
(location, name, meaning, nameNotFoundMessage, nameArg) {
            var result;
            var lastLocation;
            var propertyWithInvalidInitializer;
            var errorLocation = location;
            var grandparent;
            var isInExternalModule = false;
            loop: while (location) {
                // Locals of a source file are not in scope (because they get merged into the global symbol table)
                if (location.locals && !isGlobalSourceFile(location)) {
                    if (result = getSymbol(location.locals, name, meaning)) {
                        var useResult = true;
                        if (ts.isFunctionLike(location) && lastLocation && lastLocation !== location.body) {
                            // symbol lookup restrictions for function-like declarations
                            // - Type parameters of a function are in scope in the entire function declaration, including the parameter
                            //   list and return type. However, local types are only in scope in the function body.
                            // - parameters are only in the scope of function body
                            // This restriction does not apply to JSDoc comment types because they are parented
                            // at a higher level than type parameters would normally be
                            if (meaning & result.flags & 793064 /* Type */ && lastLocation.kind !== 278 /* JSDocComment */) {
                                useResult = result.flags & 262144 /* TypeParameter */
                                    ? lastLocation === location.type ||
                                        lastLocation.kind === 144 /* Parameter */ ||
                                        lastLocation.kind === 143 /* TypeParameter */
                                    : false;
                            }
                            if (meaning & 107455 /* Value */ && result.flags & 1 /* FunctionScopedVariable */) {
                                // parameters are visible only inside function body, parameter list and return type
                                // technically for parameter list case here we might mix parameters and variables declared in function,
                                // however it is detected separately when checking initializers of parameters
                                // to make sure that they reference no variables declared after them.
                                useResult =
                                    lastLocation.kind === 144 /* Parameter */ ||
                                        (lastLocation === location.type &&
                                            result.valueDeclaration.kind === 144 /* Parameter */);
                            }
                        }
                        if (useResult) {
                            break loop;
                        }
                        else {
                            result = undefined;
                        }
                    }
                }
                switch (location.kind) {
                    case 261 /* SourceFile */:
                        if (!ts.isExternalOrCommonJsModule(location))
                            break;
                        isInExternalModule = true;
                    case 230 /* ModuleDeclaration */:
                        var moduleExports = getSymbolOfNode(location).exports;
                        if (location.kind === 261 /* SourceFile */ || ts.isAmbientModule(location)) {
                            // It's an external module. First see if the module has an export default and if the local
                            // name of that export default matches.
                            if (result = moduleExports["default"]) {
                                var localSymbol = ts.getLocalSymbolForExportDefault(result);
                                if (localSymbol && (result.flags & meaning) && localSymbol.name === name) {
                                    break loop;
                                }
                                result = undefined;
                            }
                            // Because of module/namespace merging, a module's exports are in scope,
                            // yet we never want to treat an export specifier as putting a member in scope.
                            // Therefore, if the name we find is purely an export specifier, it is not actually considered in scope.
                            // Two things to note about this:
                            //     1. We have to check this without calling getSymbol. The problem with calling getSymbol
                            //        on an export specifier is that it might find the export specifier itself, and try to
                            //        resolve it as an alias. This will cause the checker to consider the export specifier
                            //        a circular alias reference when it might not be.
                            //     2. We check === SymbolFlags.Alias in order to check that the symbol is *purely*
                            //        an alias. If we used &, we'd be throwing out symbols that have non alias aspects,
                            //        which is not the desired behavior.
                            if (moduleExports[name] &&
                                moduleExports[name].flags === 8388608 /* Alias */ &&
                                ts.getDeclarationOfKind(moduleExports[name], 243 /* ExportSpecifier */)) {
                                break;
                            }
                        }
                        if (result = getSymbol(moduleExports, name, meaning & 8914931 /* ModuleMember */)) {
                            break loop;
                        }
                        break;
                    case 229 /* EnumDeclaration */:
                        if (result = getSymbol(getSymbolOfNode(location).exports, name, meaning & 8 /* EnumMember */)) {
                            break loop;
                        }
                        break;
                    case 147 /* PropertyDeclaration */:
                    case 146 /* PropertySignature */:
                        // TypeScript 1.0 spec (April 2014): 8.4.1
                        // Initializer expressions for instance member variables are evaluated in the scope
                        // of the class constructor body but are not permitted to reference parameters or
                        // local variables of the constructor. This effectively means that entities from outer scopes
                        // by the same name as a constructor parameter or local variable are inaccessible
                        // in initializer expressions for instance member variables.
                        if (ts.isClassLike(location.parent) && !(ts.getModifierFlags(location) & 32 /* Static */)) {
                            var ctor = findConstructorDeclaration(location.parent);
                            if (ctor && ctor.locals) {
                                if (getSymbol(ctor.locals, name, meaning & 107455 /* Value */)) {
                                    // Remember the property node, it will be used later to report appropriate error
                                    propertyWithInvalidInitializer = location;
                                }
                            }
                        }
                        break;
                    case 226 /* ClassDeclaration */:
                    case 197 /* ClassExpression */:
                    case 227 /* InterfaceDeclaration */:
                        if (result = getSymbol(getSymbolOfNode(location).members, name, meaning & 793064 /* Type */)) {
                            if (lastLocation && ts.getModifierFlags(lastLocation) & 32 /* Static */) {
                                // TypeScript 1.0 spec (April 2014): 3.4.1
                                // The scope of a type parameter extends over the entire declaration with which the type
                                // parameter list is associated, with the exception of static member declarations in classes.
                                error(errorLocation, ts.Diagnostics.Static_members_cannot_reference_class_type_parameters);
                                return undefined;
                            }
                            break loop;
                        }
                        if (location.kind === 197 /* ClassExpression */ && meaning & 32 /* Class */) {
                            var className = location.name;
                            if (className && name === className.text) {
                                result = location.symbol;
                                break loop;
                            }
                        }
                        break;
                    // It is not legal to reference a class's own type parameters from a computed property name that
                    // belongs to the class. For example:
                    //
                    //   function foo<T>() { return '' }
                    //   class C<T> { // <-- Class's own type parameter T
                    //       [foo<T>()]() { } // <-- Reference to T from class's own computed property
                    //   }
                    //
                    case 142 /* ComputedPropertyName */:
                        grandparent = location.parent.parent;
                        if (ts.isClassLike(grandparent) || grandparent.kind === 227 /* InterfaceDeclaration */) {
                            // A reference to this grandparent's type parameters would be an error
                            if (result = getSymbol(getSymbolOfNode(grandparent).members, name, meaning & 793064 /* Type */)) {
                                error(errorLocation, ts.Diagnostics.A_computed_property_name_cannot_reference_a_type_parameter_from_its_containing_type);
                                return undefined;
                            }
                        }
                        break;
                    case 149 /* MethodDeclaration */:
                    case 148 /* MethodSignature */:
                    case 150 /* Constructor */:
                    case 151 /* GetAccessor */:
                    case 152 /* SetAccessor */:
                    case 225 /* FunctionDeclaration */:
                    case 185 /* ArrowFunction */:
                        if (meaning & 3 /* Variable */ && name === "arguments") {
                            result = argumentsSymbol;
                            break loop;
                        }
                        break;
                    case 184 /* FunctionExpression */:
                        if (meaning & 3 /* Variable */ && name === "arguments") {
                            result = argumentsSymbol;
                            break loop;
                        }
                        if (meaning & 16 /* Function */) {
                            var functionName = location.name;
                            if (functionName && name === functionName.text) {
                                result = location.symbol;
                                break loop;
                            }
                        }
                        break;
                    case 145 /* Decorator */:
                        // Decorators are resolved at the class declaration. Resolving at the parameter
                        // or member would result in looking up locals in the method.
                        //
                        //   function y() {}
                        //   class C {
                        //       method(@y x, y) {} // <-- decorator y should be resolved at the class declaration, not the parameter.
                        //   }
                        //
                        if (location.parent && location.parent.kind === 144 /* Parameter */) {
                            location = location.parent;
                        }
                        //
                        //   function y() {}
                        //   class C {
                        //       @y method(x, y) {} // <-- decorator y should be resolved at the class declaration, not the method.
                        //   }
                        //
                        if (location.parent && ts.isClassElement(location.parent)) {
                            location = location.parent;
                        }
                        break;
                }
                lastLocation = location;
                location = location.parent;
            }
            if (result && nameNotFoundMessage && noUnusedIdentifiers) {
                result.isReferenced = true;
            }
            if (!result) {
                result = getSymbol(globals, name, meaning);
            }
            if (!result) {
                if (nameNotFoundMessage) {
                    if (!errorLocation ||
                        !checkAndReportErrorForMissingPrefix(errorLocation, name, nameArg) &&
                            !checkAndReportErrorForExtendingInterface(errorLocation) &&
                            !checkAndReportErrorForUsingTypeAsNamespace(errorLocation, name, meaning) &&
                            !checkAndReportErrorForUsingTypeAsValue(errorLocation, name, meaning)) {
                        error(errorLocation, nameNotFoundMessage, typeof nameArg === "string" ? nameArg : ts.declarationNameToString(nameArg));
                    }
                }
                return undefined;
            }
            // Perform extra checks only if error reporting was requested
            if (nameNotFoundMessage) {
                if (propertyWithInvalidInitializer) {
                    // We have a match, but the reference occurred within a property initializer and the identifier also binds
                    // to a local variable in the constructor where the code will be emitted.
                    var propertyName = propertyWithInvalidInitializer.name;
                    error(errorLocation, ts.Diagnostics.Initializer_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor, ts.declarationNameToString(propertyName), typeof nameArg === "string" ? nameArg : ts.declarationNameToString(nameArg));
                    return undefined;
                }
                // Only check for block-scoped variable if we are looking for the
                // name with variable meaning
                //      For example,
                //          declare module foo {
                //              interface bar {}
                //          }
                //      const foo/*1*/: foo/*2*/.bar;
                // The foo at /*1*/ and /*2*/ will share same symbol with two meaning
                // block - scope variable and namespace module. However, only when we
                // try to resolve name in /*1*/ which is used in variable position,
                // we want to check for block- scoped
                if (meaning & 2 /* BlockScopedVariable */) {
                    var exportOrLocalSymbol = getExportSymbolOfValueSymbolIfExported(result);
                    if (exportOrLocalSymbol.flags & 2 /* BlockScopedVariable */) {
                        checkResolvedBlockScopedVariable(exportOrLocalSymbol, errorLocation);
                    }
                }
                // If we're in an external module, we can't reference value symbols created from UMD export declarations
                if (result && isInExternalModule && (meaning & 107455 /* Value */) === 107455 /* Value */) {
                    var decls = result.declarations;
                    if (decls && decls.length === 1 && decls[0].kind === 233 /* NamespaceExportDeclaration */) {
                        error(errorLocation, ts.Diagnostics._0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead, name);
                    }
                }
            }
            return result;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isGlobalSourceFile) id{328,1} ---
(node) {
            return node.kind === 261 /* SourceFile */ && !ts.isExternalOrCommonJsModule(node);
        }
--- END ---
INLINE (isGlobalSourceFile) id{328,1} AS 1 AT <0:467>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{328,2} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{328,2} AS 2 AT <0:7735>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{328,3} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{328,3} AS 3 AT <2:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarTypeArguments) id{329,0} ---
(node, typeArguments) {
            return checkGrammarForDisallowedTrailingComma(typeArguments) ||
                checkGrammarForAtLeastOneTypeArgument(node, typeArguments);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarForDisallowedTrailingComma) id{329,1} ---
(list) {
            if (list && list.hasTrailingComma) {
                var start = list.end - ",".length;
                var end = list.end;
                var sourceFile = ts.getSourceFileOfNode(list[0]);
                return grammarErrorAtPos(sourceFile, start, end - start, ts.Diagnostics.Trailing_comma_not_allowed);
            }
        }
--- END ---
INLINE (checkGrammarForDisallowedTrailingComma) id{329,1} AS 1 AT <0:43>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarForAtLeastOneTypeArgument) id{329,2} ---
(node, typeArguments) {
            if (typeArguments && typeArguments.length === 0) {
                var sourceFile = ts.getSourceFileOfNode(node);
                var start = typeArguments.pos - "<".length;
                var end = ts.skipTrivia(sourceFile.text, typeArguments.end) + ">".length;
                return grammarErrorAtPos(sourceFile, start, end - start, ts.Diagnostics.Type_argument_list_cannot_be_empty);
            }
        }
--- END ---
INLINE (checkGrammarForAtLeastOneTypeArgument) id{329,2} AS 2 AT <0:116>
[deoptimizing (DEOPT eager): begin 0x29cc38d1b139 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)> (opt #328) @23, FP to SP delta: 272, caller sp: 0x7fff5fbfdbb8]
            ;;; deoptimize at 0_1446: wrong map
  reading input frame resolveName => node=242, args=6, height=17; inputs:
      0: 0x29cc38d1b139 ; [fp - 16] 0x29cc38d1b139 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)>
      1: 0x1f9f6c0532e1 ; [fp + 56] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x286514c30cf9 ; rbx 0x286514c30cf9 <a NodeObject with map 0x33abe2a70521>
      3: 0x30bcea455419 ; [fp + 40] 0x30bcea455419 <String[1]: U>
      4: 0xc19e800000000 ; [fp + 32] 793064
      5: 0xd6230ded3a9 ; [fp + 24] 0xd6230ded3a9 <an Object with map 0x33abe2a3df61>
      6: 0x286514c68201 ; [fp + 16] 0x286514c68201 <an IdentifierObject with map 0x33abe2a6fb81>
      7: 0x29cc38d04261 ; [fp - 24] 0x29cc38d04261 <FixedArray[1022]>
      8: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
      9: 0x29cc38d0fb39 ; rdx 0x29cc38d0fb39 <a SymbolObject with map 0x33abe2a72ca9>
     10: 0x286514c3ed49 ; rax 0x286514c3ed49 <a NodeObject with map 0x33abe2a67519>
     11: 0x30bcea404311 ; [fp - 40] 0x30bcea404311 <undefined>
     12: 0x286514c68201 ; [fp + 48] 0x286514c68201 <an IdentifierObject with map 0x33abe2a6fb81>
     13: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     14: 0x30bcea404421 ; [fp - 32] 0x30bcea404421 <false>
     15: 0x30bcea4043b1 ; (literal 11) 0x30bcea4043b1 <true>
     16: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     17: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     18: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     19: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     20: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     21: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     22: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     23: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
  translating frame resolveName => node=242, height=128
    0x7fff5fbfdbb0: [top + 200] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdba8: [top + 192] <- 0x286514c30cf9 ;  0x286514c30cf9 <a NodeObject with map 0x33abe2a70521>  (input #2)
    0x7fff5fbfdba0: [top + 184] <- 0x30bcea455419 ;  0x30bcea455419 <String[1]: U>  (input #3)
    0x7fff5fbfdb98: [top + 176] <- 0xc19e800000000 ;  793064  (input #4)
    0x7fff5fbfdb90: [top + 168] <- 0xd6230ded3a9 ;  0xd6230ded3a9 <an Object with map 0x33abe2a3df61>  (input #5)
    0x7fff5fbfdb88: [top + 160] <- 0x286514c68201 ;  0x286514c68201 <an IdentifierObject with map 0x33abe2a6fb81>  (input #6)
    0x7fff5fbfdb80: [top + 152] <- 0x2c21d26139a6 ;  caller's pc
    0x7fff5fbfdb78: [top + 144] <- 0x7fff5fbfdbf8 ;  caller's fp
    0x7fff5fbfdb70: [top + 136] <- 0x29cc38d04261 ;  context    0x29cc38d04261 <FixedArray[1022]>  (input #7)
    0x7fff5fbfdb68: [top + 128] <- 0x29cc38d1b139 ;  function    0x29cc38d1b139 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)>  (input #0)
    0x7fff5fbfdb60: [top + 120] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfdb58: [top + 112] <- 0x29cc38d0fb39 ;  0x29cc38d0fb39 <a SymbolObject with map 0x33abe2a72ca9>  (input #9)
    0x7fff5fbfdb50: [top + 104] <- 0x286514c3ed49 ;  0x286514c3ed49 <a NodeObject with map 0x33abe2a67519>  (input #10)
    0x7fff5fbfdb48: [top + 96] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #11)
    0x7fff5fbfdb40: [top + 88] <- 0x286514c68201 ;  0x286514c68201 <an IdentifierObject with map 0x33abe2a6fb81>  (input #12)
    0x7fff5fbfdb38: [top + 80] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #13)
    0x7fff5fbfdb30: [top + 72] <- 0x30bcea404421 ;  0x30bcea404421 <false>  (input #14)
    0x7fff5fbfdb28: [top + 64] <- 0x30bcea4043b1 ;  0x30bcea4043b1 <true>  (input #15)
    0x7fff5fbfdb20: [top + 56] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #16)
    0x7fff5fbfdb18: [top + 48] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #17)
    0x7fff5fbfdb10: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #18)
    0x7fff5fbfdb08: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #19)
    0x7fff5fbfdb00: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #20)
    0x7fff5fbfdaf8: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #21)
    0x7fff5fbfdaf0: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #22)
    0x7fff5fbfdae8: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #23)
[deoptimizing (eager): end 0x29cc38d1b139 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)> @23 => node=242, pc=0x2c21d25e450f, caller sp=0x7fff5fbfdbb8, state=NO_REGISTERS, took 0.153 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:symbolIsValue) id{330,0} ---
(symbol) {
            // If it is an instantiated symbol, then it is a value if the symbol it is an
            // instantiation of is a value.
            if (symbol.flags & 16777216 /* Instantiated */) {
                return symbolIsValue(getSymbolLinks(symbol).target);
            }
            // If the symbol has the value flag, it is trivially a value.
            if (symbol.flags & 107455 /* Value */) {
                return true;
            }
            // If it is an alias, then it is a value if the symbol it resolves to is a value.
            if (symbol.flags & 8388608 /* Alias */) {
                return (resolveAlias(symbol).flags & 107455 /* Value */) !== 0;
            }
            return false;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{330,1} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{330,1} AS 1 AT <0:244>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{330,2} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{330,2} AS 2 AT <1:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveName) id{331,0} ---
(location, name, meaning, nameNotFoundMessage, nameArg) {
            var result;
            var lastLocation;
            var propertyWithInvalidInitializer;
            var errorLocation = location;
            var grandparent;
            var isInExternalModule = false;
            loop: while (location) {
                // Locals of a source file are not in scope (because they get merged into the global symbol table)
                if (location.locals && !isGlobalSourceFile(location)) {
                    if (result = getSymbol(location.locals, name, meaning)) {
                        var useResult = true;
                        if (ts.isFunctionLike(location) && lastLocation && lastLocation !== location.body) {
                            // symbol lookup restrictions for function-like declarations
                            // - Type parameters of a function are in scope in the entire function declaration, including the parameter
                            //   list and return type. However, local types are only in scope in the function body.
                            // - parameters are only in the scope of function body
                            // This restriction does not apply to JSDoc comment types because they are parented
                            // at a higher level than type parameters would normally be
                            if (meaning & result.flags & 793064 /* Type */ && lastLocation.kind !== 278 /* JSDocComment */) {
                                useResult = result.flags & 262144 /* TypeParameter */
                                    ? lastLocation === location.type ||
                                        lastLocation.kind === 144 /* Parameter */ ||
                                        lastLocation.kind === 143 /* TypeParameter */
                                    : false;
                            }
                            if (meaning & 107455 /* Value */ && result.flags & 1 /* FunctionScopedVariable */) {
                                // parameters are visible only inside function body, parameter list and return type
                                // technically for parameter list case here we might mix parameters and variables declared in function,
                                // however it is detected separately when checking initializers of parameters
                                // to make sure that they reference no variables declared after them.
                                useResult =
                                    lastLocation.kind === 144 /* Parameter */ ||
                                        (lastLocation === location.type &&
                                            result.valueDeclaration.kind === 144 /* Parameter */);
                            }
                        }
                        if (useResult) {
                            break loop;
                        }
                        else {
                            result = undefined;
                        }
                    }
                }
                switch (location.kind) {
                    case 261 /* SourceFile */:
                        if (!ts.isExternalOrCommonJsModule(location))
                            break;
                        isInExternalModule = true;
                    case 230 /* ModuleDeclaration */:
                        var moduleExports = getSymbolOfNode(location).exports;
                        if (location.kind === 261 /* SourceFile */ || ts.isAmbientModule(location)) {
                            // It's an external module. First see if the module has an export default and if the local
                            // name of that export default matches.
                            if (result = moduleExports["default"]) {
                                var localSymbol = ts.getLocalSymbolForExportDefault(result);
                                if (localSymbol && (result.flags & meaning) && localSymbol.name === name) {
                                    break loop;
                                }
                                result = undefined;
                            }
                            // Because of module/namespace merging, a module's exports are in scope,
                            // yet we never want to treat an export specifier as putting a member in scope.
                            // Therefore, if the name we find is purely an export specifier, it is not actually considered in scope.
                            // Two things to note about this:
                            //     1. We have to check this without calling getSymbol. The problem with calling getSymbol
                            //        on an export specifier is that it might find the export specifier itself, and try to
                            //        resolve it as an alias. This will cause the checker to consider the export specifier
                            //        a circular alias reference when it might not be.
                            //     2. We check === SymbolFlags.Alias in order to check that the symbol is *purely*
                            //        an alias. If we used &, we'd be throwing out symbols that have non alias aspects,
                            //        which is not the desired behavior.
                            if (moduleExports[name] &&
                                moduleExports[name].flags === 8388608 /* Alias */ &&
                                ts.getDeclarationOfKind(moduleExports[name], 243 /* ExportSpecifier */)) {
                                break;
                            }
                        }
                        if (result = getSymbol(moduleExports, name, meaning & 8914931 /* ModuleMember */)) {
                            break loop;
                        }
                        break;
                    case 229 /* EnumDeclaration */:
                        if (result = getSymbol(getSymbolOfNode(location).exports, name, meaning & 8 /* EnumMember */)) {
                            break loop;
                        }
                        break;
                    case 147 /* PropertyDeclaration */:
                    case 146 /* PropertySignature */:
                        // TypeScript 1.0 spec (April 2014): 8.4.1
                        // Initializer expressions for instance member variables are evaluated in the scope
                        // of the class constructor body but are not permitted to reference parameters or
                        // local variables of the constructor. This effectively means that entities from outer scopes
                        // by the same name as a constructor parameter or local variable are inaccessible
                        // in initializer expressions for instance member variables.
                        if (ts.isClassLike(location.parent) && !(ts.getModifierFlags(location) & 32 /* Static */)) {
                            var ctor = findConstructorDeclaration(location.parent);
                            if (ctor && ctor.locals) {
                                if (getSymbol(ctor.locals, name, meaning & 107455 /* Value */)) {
                                    // Remember the property node, it will be used later to report appropriate error
                                    propertyWithInvalidInitializer = location;
                                }
                            }
                        }
                        break;
                    case 226 /* ClassDeclaration */:
                    case 197 /* ClassExpression */:
                    case 227 /* InterfaceDeclaration */:
                        if (result = getSymbol(getSymbolOfNode(location).members, name, meaning & 793064 /* Type */)) {
                            if (lastLocation && ts.getModifierFlags(lastLocation) & 32 /* Static */) {
                                // TypeScript 1.0 spec (April 2014): 3.4.1
                                // The scope of a type parameter extends over the entire declaration with which the type
                                // parameter list is associated, with the exception of static member declarations in classes.
                                error(errorLocation, ts.Diagnostics.Static_members_cannot_reference_class_type_parameters);
                                return undefined;
                            }
                            break loop;
                        }
                        if (location.kind === 197 /* ClassExpression */ && meaning & 32 /* Class */) {
                            var className = location.name;
                            if (className && name === className.text) {
                                result = location.symbol;
                                break loop;
                            }
                        }
                        break;
                    // It is not legal to reference a class's own type parameters from a computed property name that
                    // belongs to the class. For example:
                    //
                    //   function foo<T>() { return '' }
                    //   class C<T> { // <-- Class's own type parameter T
                    //       [foo<T>()]() { } // <-- Reference to T from class's own computed property
                    //   }
                    //
                    case 142 /* ComputedPropertyName */:
                        grandparent = location.parent.parent;
                        if (ts.isClassLike(grandparent) || grandparent.kind === 227 /* InterfaceDeclaration */) {
                            // A reference to this grandparent's type parameters would be an error
                            if (result = getSymbol(getSymbolOfNode(grandparent).members, name, meaning & 793064 /* Type */)) {
                                error(errorLocation, ts.Diagnostics.A_computed_property_name_cannot_reference_a_type_parameter_from_its_containing_type);
                                return undefined;
                            }
                        }
                        break;
                    case 149 /* MethodDeclaration */:
                    case 148 /* MethodSignature */:
                    case 150 /* Constructor */:
                    case 151 /* GetAccessor */:
                    case 152 /* SetAccessor */:
                    case 225 /* FunctionDeclaration */:
                    case 185 /* ArrowFunction */:
                        if (meaning & 3 /* Variable */ && name === "arguments") {
                            result = argumentsSymbol;
                            break loop;
                        }
                        break;
                    case 184 /* FunctionExpression */:
                        if (meaning & 3 /* Variable */ && name === "arguments") {
                            result = argumentsSymbol;
                            break loop;
                        }
                        if (meaning & 16 /* Function */) {
                            var functionName = location.name;
                            if (functionName && name === functionName.text) {
                                result = location.symbol;
                                break loop;
                            }
                        }
                        break;
                    case 145 /* Decorator */:
                        // Decorators are resolved at the class declaration. Resolving at the parameter
                        // or member would result in looking up locals in the method.
                        //
                        //   function y() {}
                        //   class C {
                        //       method(@y x, y) {} // <-- decorator y should be resolved at the class declaration, not the parameter.
                        //   }
                        //
                        if (location.parent && location.parent.kind === 144 /* Parameter */) {
                            location = location.parent;
                        }
                        //
                        //   function y() {}
                        //   class C {
                        //       @y method(x, y) {} // <-- decorator y should be resolved at the class declaration, not the method.
                        //   }
                        //
                        if (location.parent && ts.isClassElement(location.parent)) {
                            location = location.parent;
                        }
                        break;
                }
                lastLocation = location;
                location = location.parent;
            }
            if (result && nameNotFoundMessage && noUnusedIdentifiers) {
                result.isReferenced = true;
            }
            if (!result) {
                result = getSymbol(globals, name, meaning);
            }
            if (!result) {
                if (nameNotFoundMessage) {
                    if (!errorLocation ||
                        !checkAndReportErrorForMissingPrefix(errorLocation, name, nameArg) &&
                            !checkAndReportErrorForExtendingInterface(errorLocation) &&
                            !checkAndReportErrorForUsingTypeAsNamespace(errorLocation, name, meaning) &&
                            !checkAndReportErrorForUsingTypeAsValue(errorLocation, name, meaning)) {
                        error(errorLocation, nameNotFoundMessage, typeof nameArg === "string" ? nameArg : ts.declarationNameToString(nameArg));
                    }
                }
                return undefined;
            }
            // Perform extra checks only if error reporting was requested
            if (nameNotFoundMessage) {
                if (propertyWithInvalidInitializer) {
                    // We have a match, but the reference occurred within a property initializer and the identifier also binds
                    // to a local variable in the constructor where the code will be emitted.
                    var propertyName = propertyWithInvalidInitializer.name;
                    error(errorLocation, ts.Diagnostics.Initializer_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor, ts.declarationNameToString(propertyName), typeof nameArg === "string" ? nameArg : ts.declarationNameToString(nameArg));
                    return undefined;
                }
                // Only check for block-scoped variable if we are looking for the
                // name with variable meaning
                //      For example,
                //          declare module foo {
                //              interface bar {}
                //          }
                //      const foo/*1*/: foo/*2*/.bar;
                // The foo at /*1*/ and /*2*/ will share same symbol with two meaning
                // block - scope variable and namespace module. However, only when we
                // try to resolve name in /*1*/ which is used in variable position,
                // we want to check for block- scoped
                if (meaning & 2 /* BlockScopedVariable */) {
                    var exportOrLocalSymbol = getExportSymbolOfValueSymbolIfExported(result);
                    if (exportOrLocalSymbol.flags & 2 /* BlockScopedVariable */) {
                        checkResolvedBlockScopedVariable(exportOrLocalSymbol, errorLocation);
                    }
                }
                // If we're in an external module, we can't reference value symbols created from UMD export declarations
                if (result && isInExternalModule && (meaning & 107455 /* Value */) === 107455 /* Value */) {
                    var decls = result.declarations;
                    if (decls && decls.length === 1 && decls[0].kind === 233 /* NamespaceExportDeclaration */) {
                        error(errorLocation, ts.Diagnostics._0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead, name);
                    }
                }
            }
            return result;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isGlobalSourceFile) id{331,1} ---
(node) {
            return node.kind === 261 /* SourceFile */ && !ts.isExternalOrCommonJsModule(node);
        }
--- END ---
INLINE (isGlobalSourceFile) id{331,1} AS 1 AT <0:467>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{331,2} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{331,2} AS 2 AT <0:7735>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{331,3} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{331,3} AS 3 AT <2:28>
[deoptimizing (DEOPT eager): begin 0x29cc38d1b139 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)> (opt #331) @23, FP to SP delta: 272, caller sp: 0x7fff5fbfdb18]
            ;;; deoptimize at 0_1446: wrong map
  reading input frame resolveName => node=242, args=6, height=17; inputs:
      0: 0x29cc38d1b139 ; [fp - 16] 0x29cc38d1b139 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)>
      1: 0x1f9f6c0532e1 ; [fp + 56] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x286514c31b79 ; rbx 0x286514c31b79 <a NodeObject with map 0x33abe2a70521>
      3: 0x30bcea455419 ; [fp + 40] 0x30bcea455419 <String[1]: U>
      4: 0xc19e800000000 ; [fp + 32] 793064
      5: 0xd6230ded3a9 ; [fp + 24] 0xd6230ded3a9 <an Object with map 0x33abe2a3df61>
      6: 0x286514c93901 ; [fp + 16] 0x286514c93901 <an IdentifierObject with map 0x33abe2a6fb81>
      7: 0x29cc38d04261 ; [fp - 24] 0x29cc38d04261 <FixedArray[1022]>
      8: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
      9: 0x29cc38d0ff41 ; rdx 0x29cc38d0ff41 <a SymbolObject with map 0x33abe2a72ca9>
     10: 0x286514c406d9 ; rax 0x286514c406d9 <a NodeObject with map 0x33abe2a68909>
     11: 0x30bcea404311 ; [fp - 40] 0x30bcea404311 <undefined>
     12: 0x286514c93901 ; [fp + 48] 0x286514c93901 <an IdentifierObject with map 0x33abe2a6fb81>
     13: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     14: 0x30bcea404421 ; [fp - 32] 0x30bcea404421 <false>
     15: 0x30bcea4043b1 ; (literal 11) 0x30bcea4043b1 <true>
     16: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     17: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     18: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     19: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     20: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     21: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     22: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     23: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
  translating frame resolveName => node=242, height=128
    0x7fff5fbfdb10: [top + 200] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdb08: [top + 192] <- 0x286514c31b79 ;  0x286514c31b79 <a NodeObject with map 0x33abe2a70521>  (input #2)
    0x7fff5fbfdb00: [top + 184] <- 0x30bcea455419 ;  0x30bcea455419 <String[1]: U>  (input #3)
    0x7fff5fbfdaf8: [top + 176] <- 0xc19e800000000 ;  793064  (input #4)
    0x7fff5fbfdaf0: [top + 168] <- 0xd6230ded3a9 ;  0xd6230ded3a9 <an Object with map 0x33abe2a3df61>  (input #5)
    0x7fff5fbfdae8: [top + 160] <- 0x286514c93901 ;  0x286514c93901 <an IdentifierObject with map 0x33abe2a6fb81>  (input #6)
    0x7fff5fbfdae0: [top + 152] <- 0x2c21d26139a6 ;  caller's pc
    0x7fff5fbfdad8: [top + 144] <- 0x7fff5fbfdb58 ;  caller's fp
    0x7fff5fbfdad0: [top + 136] <- 0x29cc38d04261 ;  context    0x29cc38d04261 <FixedArray[1022]>  (input #7)
    0x7fff5fbfdac8: [top + 128] <- 0x29cc38d1b139 ;  function    0x29cc38d1b139 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)>  (input #0)
    0x7fff5fbfdac0: [top + 120] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfdab8: [top + 112] <- 0x29cc38d0ff41 ;  0x29cc38d0ff41 <a SymbolObject with map 0x33abe2a72ca9>  (input #9)
    0x7fff5fbfdab0: [top + 104] <- 0x286514c406d9 ;  0x286514c406d9 <a NodeObject with map 0x33abe2a68909>  (input #10)
    0x7fff5fbfdaa8: [top + 96] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #11)
    0x7fff5fbfdaa0: [top + 88] <- 0x286514c93901 ;  0x286514c93901 <an IdentifierObject with map 0x33abe2a6fb81>  (input #12)
    0x7fff5fbfda98: [top + 80] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #13)
    0x7fff5fbfda90: [top + 72] <- 0x30bcea404421 ;  0x30bcea404421 <false>  (input #14)
    0x7fff5fbfda88: [top + 64] <- 0x30bcea4043b1 ;  0x30bcea4043b1 <true>  (input #15)
    0x7fff5fbfda80: [top + 56] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #16)
    0x7fff5fbfda78: [top + 48] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #17)
    0x7fff5fbfda70: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #18)
    0x7fff5fbfda68: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #19)
    0x7fff5fbfda60: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #20)
    0x7fff5fbfda58: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #21)
    0x7fff5fbfda50: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #22)
    0x7fff5fbfda48: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #23)
[deoptimizing (eager): end 0x29cc38d1b139 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)> @23 => node=242, pc=0x2c21d25e450f, caller sp=0x7fff5fbfdb18, state=NO_REGISTERS, took 0.953 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeFromNonGenericTypeReference) id{332,0} ---
(node, symbol) {
            if (node.typeArguments) {
                error(node, ts.Diagnostics.Type_0_is_not_generic, symbolToString(symbol));
                return unknownType;
            }
            return getDeclaredTypeOfSymbol(symbol);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkSourceElement) id{333,0} ---
(node) {
            if (!node) {
                return;
            }
            var kind = node.kind;
            if (cancellationToken) {
                // Only bother checking on a few construct kinds.  We don't want to be excessively
                // hitting the cancellation token on every node we check.
                switch (kind) {
                    case 230 /* ModuleDeclaration */:
                    case 226 /* ClassDeclaration */:
                    case 227 /* InterfaceDeclaration */:
                    case 225 /* FunctionDeclaration */:
                        cancellationToken.throwIfCancellationRequested();
                }
            }
            switch (kind) {
                case 143 /* TypeParameter */:
                    return checkTypeParameter(node);
                case 144 /* Parameter */:
                    return checkParameter(node);
                case 147 /* PropertyDeclaration */:
                case 146 /* PropertySignature */:
                    return checkPropertyDeclaration(node);
                case 158 /* FunctionType */:
                case 159 /* ConstructorType */:
                case 153 /* CallSignature */:
                case 154 /* ConstructSignature */:
                    return checkSignatureDeclaration(node);
                case 155 /* IndexSignature */:
                    return checkSignatureDeclaration(node);
                case 149 /* MethodDeclaration */:
                case 148 /* MethodSignature */:
                    return checkMethodDeclaration(node);
                case 150 /* Constructor */:
                    return checkConstructorDeclaration(node);
                case 151 /* GetAccessor */:
                case 152 /* SetAccessor */:
                    return checkAccessorDeclaration(node);
                case 157 /* TypeReference */:
                    return checkTypeReferenceNode(node);
                case 156 /* TypePredicate */:
                    return checkTypePredicate(node);
                case 160 /* TypeQuery */:
                    return checkTypeQuery(node);
                case 161 /* TypeLiteral */:
                    return checkTypeLiteral(node);
                case 162 /* ArrayType */:
                    return checkArrayType(node);
                case 163 /* TupleType */:
                    return checkTupleType(node);
                case 164 /* UnionType */:
                case 165 /* IntersectionType */:
                    return checkUnionOrIntersectionType(node);
                case 166 /* ParenthesizedType */:
                case 168 /* TypeOperator */:
                    return checkSourceElement(node.type);
                case 169 /* IndexedAccessType */:
                    return checkIndexedAccessType(node);
                case 170 /* MappedType */:
                    return checkMappedType(node);
                case 225 /* FunctionDeclaration */:
                    return checkFunctionDeclaration(node);
                case 204 /* Block */:
                case 231 /* ModuleBlock */:
                    return checkBlock(node);
                case 205 /* VariableStatement */:
                    return checkVariableStatement(node);
                case 207 /* ExpressionStatement */:
                    return checkExpressionStatement(node);
                case 208 /* IfStatement */:
                    return checkIfStatement(node);
                case 209 /* DoStatement */:
                    return checkDoStatement(node);
                case 210 /* WhileStatement */:
                    return checkWhileStatement(node);
                case 211 /* ForStatement */:
                    return checkForStatement(node);
                case 212 /* ForInStatement */:
                    return checkForInStatement(node);
                case 213 /* ForOfStatement */:
                    return checkForOfStatement(node);
                case 214 /* ContinueStatement */:
                case 215 /* BreakStatement */:
                    return checkBreakOrContinueStatement(node);
                case 216 /* ReturnStatement */:
                    return checkReturnStatement(node);
                case 217 /* WithStatement */:
                    return checkWithStatement(node);
                case 218 /* SwitchStatement */:
                    return checkSwitchStatement(node);
                case 219 /* LabeledStatement */:
                    return checkLabeledStatement(node);
                case 220 /* ThrowStatement */:
                    return checkThrowStatement(node);
                case 221 /* TryStatement */:
                    return checkTryStatement(node);
                case 223 /* VariableDeclaration */:
                    return checkVariableDeclaration(node);
                case 174 /* BindingElement */:
                    return checkBindingElement(node);
                case 226 /* ClassDeclaration */:
                    return checkClassDeclaration(node);
                case 227 /* InterfaceDeclaration */:
                    return checkInterfaceDeclaration(node);
                case 228 /* TypeAliasDeclaration */:
                    return checkTypeAliasDeclaration(node);
                case 229 /* EnumDeclaration */:
                    return checkEnumDeclaration(node);
                case 230 /* ModuleDeclaration */:
                    return checkModuleDeclaration(node);
                case 235 /* ImportDeclaration */:
                    return checkImportDeclaration(node);
                case 234 /* ImportEqualsDeclaration */:
                    return checkImportEqualsDeclaration(node);
                case 241 /* ExportDeclaration */:
                    return checkExportDeclaration(node);
                case 240 /* ExportAssignment */:
                    return checkExportAssignment(node);
                case 206 /* EmptyStatement */:
                    checkGrammarStatementInAmbientContext(node);
                    return;
                case 222 /* DebuggerStatement */:
                    checkGrammarStatementInAmbientContext(node);
                    return;
                case 244 /* MissingDeclaration */:
                    return checkMissingDeclaration(node);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkPropertyDeclaration) id{333,1} ---
(node) {
            // Grammar checking
            checkGrammarDecorators(node) || checkGrammarModifiers(node) || checkGrammarProperty(node) || checkGrammarComputedPropertyName(node.name);
            checkVariableLikeDeclaration(node);
        }
--- END ---
INLINE (checkPropertyDeclaration) id{333,1} AS 1 AT <0:1021>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarComputedPropertyName) id{333,2} ---
(node) {
            // If node is not a computedPropertyName, just skip the grammar checking
            if (node.kind !== 142 /* ComputedPropertyName */) {
                return false;
            }
            var computedPropertyName = node;
            if (computedPropertyName.expression.kind === 192 /* BinaryExpression */ && computedPropertyName.expression.operatorToken.kind === 25 /* CommaToken */) {
                return grammarErrorOnNode(computedPropertyName.expression, ts.Diagnostics.A_comma_expression_is_not_allowed_in_a_computed_property_name);
            }
        }
--- END ---
INLINE (checkGrammarComputedPropertyName) id{333,2} AS 2 AT <1:146>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkArrayType) id{333,3} ---
(node) {
            checkSourceElement(node.elementType);
        }
--- END ---
INLINE (checkArrayType) id{333,3} AS 3 AT <0:2275>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkTupleType) id{333,4} ---
(node) {
            // Grammar checking
            var hasErrorFromDisallowedTrailingComma = checkGrammarForDisallowedTrailingComma(node.elementTypes);
            if (!hasErrorFromDisallowedTrailingComma && node.elementTypes.length === 0) {
                grammarErrorOnNode(node, ts.Diagnostics.A_tuple_type_element_list_cannot_be_empty);
            }
            ts.forEach(node.elementTypes, checkSourceElement);
        }
--- END ---
INLINE (checkTupleType) id{333,4} AS 4 AT <0:2366>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarForDisallowedTrailingComma) id{333,5} ---
(list) {
            if (list && list.hasTrailingComma) {
                var start = list.end - ",".length;
                var end = list.end;
                var sourceFile = ts.getSourceFileOfNode(list[0]);
                return grammarErrorAtPos(sourceFile, start, end - start, ts.Diagnostics.Trailing_comma_not_allowed);
            }
        }
--- END ---
INLINE (checkGrammarForDisallowedTrailingComma) id{333,5} AS 5 AT <4:95>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkUnionOrIntersectionType) id{333,6} ---
(node) {
            ts.forEach(node.types, checkSourceElement);
        }
--- END ---
INLINE (checkUnionOrIntersectionType) id{333,6} AS 6 AT <0:2506>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkFunctionDeclaration) id{333,7} ---
(node) {
            if (produceDiagnostics) {
                checkFunctionOrMethodDeclaration(node) || checkGrammarForGenerator(node);
                checkCollisionWithCapturedSuperVariable(node, node.name);
                checkCollisionWithCapturedThisVariable(node, node.name);
                checkCollisionWithRequireExportsInGeneratedCode(node, node.name);
                checkCollisionWithGlobalPromiseInGeneratedCode(node, node.name);
            }
        }
--- END ---
INLINE (checkFunctionDeclaration) id{333,7} AS 7 AT <0:2974>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkCollisionWithCapturedThisVariable) id{333,8} ---
(node, name) {
            if (needCollisionCheckForIdentifier(node, name, "_this")) {
                potentialThisCollisions.push(node);
            }
        }
--- END ---
INLINE (checkCollisionWithCapturedThisVariable) id{333,8} AS 8 AT <7:227>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkVariableStatement) id{333,9} ---
(node) {
            // Grammar checking
            checkGrammarDecorators(node) || checkGrammarModifiers(node) || checkGrammarVariableDeclarationList(node.declarationList) || checkGrammarForDisallowedLetOrConstStatement(node);
            ts.forEach(node.declarationList.declarations, checkSourceElement);
        }
--- END ---
INLINE (checkVariableStatement) id{333,9} AS 9 AT <0:3210>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarVariableDeclarationList) id{333,10} ---
(declarationList) {
            var declarations = declarationList.declarations;
            if (checkGrammarForDisallowedTrailingComma(declarationList.declarations)) {
                return true;
            }
            if (!declarationList.declarations.length) {
                return grammarErrorAtPos(ts.getSourceFileOfNode(declarationList), declarations.pos, declarations.end - declarations.pos, ts.Diagnostics.Variable_declaration_list_cannot_be_empty);
            }
        }
--- END ---
INLINE (checkGrammarVariableDeclarationList) id{333,10} AS 10 AT <9:116>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarForDisallowedTrailingComma) id{333,11} ---
(list) {
            if (list && list.hasTrailingComma) {
                var start = list.end - ",".length;
                var end = list.end;
                var sourceFile = ts.getSourceFileOfNode(list[0]);
                return grammarErrorAtPos(sourceFile, start, end - start, ts.Diagnostics.Trailing_comma_not_allowed);
            }
        }
--- END ---
INLINE (checkGrammarForDisallowedTrailingComma) id{333,11} AS 11 AT <10:97>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarForDisallowedLetOrConstStatement) id{333,12} ---
(node) {
            if (!allowLetAndConstDeclarations(node.parent)) {
                if (ts.isLet(node.declarationList)) {
                    return grammarErrorOnNode(node, ts.Diagnostics.let_declarations_can_only_be_declared_inside_a_block);
                }
                else if (ts.isConst(node.declarationList)) {
                    return grammarErrorOnNode(node, ts.Diagnostics.const_declarations_can_only_be_declared_inside_a_block);
                }
            }
        }
--- END ---
INLINE (checkGrammarForDisallowedLetOrConstStatement) id{333,12} AS 12 AT <9:177>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:allowLetAndConstDeclarations) id{333,13} ---
(parent) {
            switch (parent.kind) {
                case 208 /* IfStatement */:
                case 209 /* DoStatement */:
                case 210 /* WhileStatement */:
                case 217 /* WithStatement */:
                case 211 /* ForStatement */:
                case 212 /* ForInStatement */:
                case 213 /* ForOfStatement */:
                    return false;
                case 219 /* LabeledStatement */:
                    return allowLetAndConstDeclarations(parent.parent);
            }
            return true;
        }
--- END ---
INLINE (allowLetAndConstDeclarations) id{333,13} AS 13 AT <12:26>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getDeclaredTypeOfTypeParameter) id{334,0} ---
(symbol) {
            var links = getSymbolLinks(symbol);
            if (!links.declaredType) {
                var type = createType(16384 /* TypeParameter */);
                type.symbol = symbol;
                if (!ts.getDeclarationOfKind(symbol, 143 /* TypeParameter */).constraint) {
                    type.constraint = noConstraintType;
                }
                links.declaredType = type;
            }
            return links.declaredType;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{334,1} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{334,1} AS 1 AT <0:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{334,2} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{334,2} AS 2 AT <1:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{334,3} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{334,3} AS 3 AT <0:125>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{334,4} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{334,4} AS 4 AT <3:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createObjectType) id{335,0} ---
(objectFlags, symbol) {
            var type = createType(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol = symbol;
            return type;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{335,1} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{335,1} AS 1 AT <0:47>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{335,2} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{335,2} AS 2 AT <1:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeFromTypeReference) id{336,0} ---
(node) {
            var links = getNodeLinks(node);
            if (!links.resolvedType) {
                var symbol = void 0;
                var type = void 0;
                if (node.kind === 272 /* JSDocTypeReference */) {
                    var typeReferenceName = getTypeReferenceName(node);
                    symbol = resolveTypeReferenceName(typeReferenceName);
                    type = getTypeReferenceType(node, symbol);
                }
                else {
                    // We only support expressions that are simple qualified names. For other expressions this produces undefined.
                    var typeNameOrExpression = node.kind === 157 /* TypeReference */
                        ? node.typeName
                        : ts.isEntityNameExpression(node.expression)
                            ? node.expression
                            : undefined;
                    symbol = typeNameOrExpression && resolveEntityName(typeNameOrExpression, 793064 /* Type */) || unknownSymbol;
                    type = symbol === unknownSymbol ? unknownType :
                        symbol.flags & (32 /* Class */ | 64 /* Interface */) ? getTypeFromClassOrInterfaceReference(node, symbol) :
                            symbol.flags & 524288 /* TypeAlias */ ? getTypeFromTypeAliasReference(node, symbol) :
                                getTypeFromNonGenericTypeReference(node, symbol);
                }
                // Cache both the resolved symbol and the resolved type. The resolved symbol is needed in when we check the
                // type reference in checkTypeReferenceOrExpressionWithTypeArguments.
                links.resolvedSymbol = symbol;
                links.resolvedType = type;
            }
            return links.resolvedType;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeLinks) id{336,1} ---
(node) {
            var nodeId = getNodeId(node);
            return nodeLinks[nodeId] || (nodeLinks[nodeId] = { flags: 0 });
        }
--- END ---
INLINE (getNodeLinks) id{336,1} AS 1 AT <0:33>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeId) id{336,2} ---
(node) {
        if (!node.id) {
            node.id = nextNodeId;
            nextNodeId++;
        }
        return node.id;
    }
--- END ---
INLINE (getNodeId) id{336,2} AS 2 AT <1:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeFromNonGenericTypeReference) id{336,3} ---
(node, symbol) {
            if (node.typeArguments) {
                error(node, ts.Diagnostics.Type_0_is_not_generic, symbolToString(symbol));
                return unknownType;
            }
            return getDeclaredTypeOfSymbol(symbol);
        }
--- END ---
INLINE (getTypeFromNonGenericTypeReference) id{336,3} AS 3 AT <0:1368>
[deoptimizing (DEOPT eager): begin 0x29cc38d28429 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> (opt #333) @107, FP to SP delta: 184, caller sp: 0x7fff5fbfdd88]
            ;;; deoptimize at 3_44: wrong map
  reading input frame checkSourceElement => node=422, args=2, height=5; inputs:
      0: 0x29cc38d28429 ; [fp - 16] 0x29cc38d28429 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x286514c411f9 ; rcx 0x286514c411f9 <a NodeObject with map 0x33abe2a73801>
      3: 0x29cc38d04261 ; rbx 0x29cc38d04261 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 25) 0x30bcea404311 <undefined>
      5: 0x30bcea4069a9 ; (literal 26) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      6: 0x30bcea4069a9 ; (literal 26) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x29cc38d26611 ; rdx 0x29cc38d26611 <JS Function checkArrayType (SharedFunctionInfo 0x1b98fbc0b1c1)>
  reading input frame checkArrayType => node=3, args=2, height=1; inputs:
      0: 0x29cc38d26611 ; (literal 38) 0x29cc38d26611 <JS Function checkArrayType (SharedFunctionInfo 0x1b98fbc0b1c1)>
      1: 0x1f9f6c0532e1 ; (literal 28) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x286514c411f9 ; rcx 0x286514c411f9 <a NodeObject with map 0x33abe2a73801>
      3: 0x29cc38d04261 ; (literal 29) 0x29cc38d04261 <FixedArray[1022]>
  translating frame checkSourceElement => node=422, height=32
    0x7fff5fbfdd80: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdd78: [top + 64] <- 0x286514c411f9 ;  0x286514c411f9 <a NodeObject with map 0x33abe2a73801>  (input #2)
    0x7fff5fbfdd70: [top + 56] <- 0x2c21d25fd240 ;  caller's pc
    0x7fff5fbfdd68: [top + 48] <- 0x7fff5fbfddc0 ;  caller's fp
    0x7fff5fbfdd60: [top + 40] <- 0x29cc38d04261 ;  context    0x29cc38d04261 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdd58: [top + 32] <- 0x29cc38d28429 ;  function    0x29cc38d28429 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>  (input #0)
    0x7fff5fbfdd50: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfdd48: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #5)
    0x7fff5fbfdd40: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfdd38: [top + 0] <- 0x29cc38d26611 ;  0x29cc38d26611 <JS Function checkArrayType (SharedFunctionInfo 0x1b98fbc0b1c1)>  (input #7)
  translating frame checkArrayType => node=3, height=0
    0x7fff5fbfdd30: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdd28: [top + 32] <- 0x286514c411f9 ;  0x286514c411f9 <a NodeObject with map 0x33abe2a73801>  (input #2)
    0x7fff5fbfdd20: [top + 24] <- 0x2c21d25ec271 ;  caller's pc
    0x7fff5fbfdd18: [top + 16] <- 0x7fff5fbfdd68 ;  caller's fp
    0x7fff5fbfdd10: [top + 8] <- 0x29cc38d04261 ;  context    0x29cc38d04261 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdd08: [top + 0] <- 0x29cc38d26611 ;  function    0x29cc38d26611 <JS Function checkArrayType (SharedFunctionInfo 0x1b98fbc0b1c1)>  (input #0)
[deoptimizing (eager): end 0x29cc38d28429 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> @107 => node=3, pc=0x2c21d2595666, caller sp=0x7fff5fbfdd88, state=NO_REGISTERS, took 0.101 ms]
[deoptimizer unlinked: checkSourceElement / 29cc38d28429]
[deoptimizing (DEOPT lazy): begin 0x29cc38d28429 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> (opt #333) @123, FP to SP delta: 184, caller sp: 0x7fff5fbfdeb8]
  reading input frame checkSourceElement => node=235, args=2, height=5; inputs:
      0: 0x29cc38d28429 ; [fp - 16] 0x29cc38d28429 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x286514c320f9 ; [fp + 16] 0x286514c320f9 <a NodeObject with map 0x33abe2a73751>
      3: 0x29cc38d04261 ; [fp - 24] 0x29cc38d04261 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 25) 0x30bcea404311 <undefined>
      5: 0x30bcea4069a9 ; (literal 26) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      6: 0x30bcea4069a9 ; (literal 26) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x30bcea404311 ; rax 0x30bcea404311 <undefined>
  translating frame checkSourceElement => node=235, height=32
    0x7fff5fbfdeb0: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdea8: [top + 64] <- 0x286514c320f9 ;  0x286514c320f9 <a NodeObject with map 0x33abe2a73751>  (input #2)
    0x7fff5fbfdea0: [top + 56] <- 0x2c21d2207e55 ;  caller's pc
    0x7fff5fbfde98: [top + 48] <- 0x7fff5fbfded0 ;  caller's fp
    0x7fff5fbfde90: [top + 40] <- 0x29cc38d04261 ;  context    0x29cc38d04261 <FixedArray[1022]>  (input #3)
    0x7fff5fbfde88: [top + 32] <- 0x29cc38d28429 ;  function    0x29cc38d28429 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>  (input #0)
    0x7fff5fbfde80: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfde78: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #5)
    0x7fff5fbfde70: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfde68: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
[deoptimizing (lazy): end 0x29cc38d28429 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> @123 => node=235, pc=0x2c21d25ec0c0, caller sp=0x7fff5fbfdeb8, state=TOS_REGISTER, took 0.055 ms]
[deoptimizing (DEOPT eager): begin 0x29cc38d267c1 <JS Function getEffectiveDeclarationFlags (SharedFunctionInfo 0x1b98fbc0b641)> (opt #293) @4, FP to SP delta: 48, caller sp: 0x7fff5fbfdcc0]
            ;;; deoptimize at 0_260: wrong map
  reading input frame getEffectiveDeclarationFlags => node=18, args=3, height=3; inputs:
      0: 0x29cc38d267c1 ; [fp - 16] 0x29cc38d267c1 <JS Function getEffectiveDeclarationFlags (SharedFunctionInfo 0x1b98fbc0b641)>
      1: 0x1f9f6c0532e1 ; [fp + 32] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x286514c323f9 ; rbx 0x286514c323f9 <a NodeObject with map 0x33abe2a75591>
      3: 0x9b00000000 ; [fp + 16] 155
      4: 0x29cc38d04261 ; [fp - 24] 0x29cc38d04261 <FixedArray[1022]>
      5: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
      6: 0x00000000 ; rax 0
  translating frame getEffectiveDeclarationFlags => node=18, height=16
    0x7fff5fbfdcb8: [top + 64] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdcb0: [top + 56] <- 0x286514c323f9 ;  0x286514c323f9 <a NodeObject with map 0x33abe2a75591>  (input #2)
    0x7fff5fbfdca8: [top + 48] <- 0x9b00000000 ;  155  (input #3)
    0x7fff5fbfdca0: [top + 40] <- 0x2c21d26066b0 ;  caller's pc
    0x7fff5fbfdc98: [top + 32] <- 0x7fff5fbfddb0 ;  caller's fp
    0x7fff5fbfdc90: [top + 24] <- 0x29cc38d04261 ;  context    0x29cc38d04261 <FixedArray[1022]>  (input #4)
    0x7fff5fbfdc88: [top + 16] <- 0x29cc38d267c1 ;  function    0x29cc38d267c1 <JS Function getEffectiveDeclarationFlags (SharedFunctionInfo 0x1b98fbc0b641)>  (input #0)
    0x7fff5fbfdc80: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfdc78: [top + 0] <- 0x00000000 ;  0  (input #6)
[deoptimizing (eager): end 0x29cc38d267c1 <JS Function getEffectiveDeclarationFlags (SharedFunctionInfo 0x1b98fbc0b641)> @4 => node=18, pc=0x2c21d26071e7, caller sp=0x7fff5fbfdcc0, state=TOS_REGISTER, took 0.053 ms]
[deoptimizing (DEOPT eager): begin 0xd6230dc6299 <JS Function hasQuestionToken (SharedFunctionInfo 0x3504a53d0859)> (opt #297) @3, FP to SP delta: 24, caller sp: 0x7fff5fbfdcc0]
            ;;; deoptimize at 0_53: wrong map
  reading input frame hasQuestionToken => node=6, args=2, height=2; inputs:
      0: 0xd6230dc6299 ; [fp - 16] 0xd6230dc6299 <JS Function hasQuestionToken (SharedFunctionInfo 0x3504a53d0859)>
      1: 0x16f3adb61821 ; [fp + 24] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x286514c323f9 ; rax 0x286514c323f9 <a NodeObject with map 0x33abe2a75591>
      3: 0xd6230db34c9 ; [fp - 24] 0xd6230db34c9 <FixedArray[156]>
      4: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
  translating frame hasQuestionToken => node=6, height=8
    0x7fff5fbfdcb8: [top + 48] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfdcb0: [top + 40] <- 0x286514c323f9 ;  0x286514c323f9 <a NodeObject with map 0x33abe2a75591>  (input #2)
    0x7fff5fbfdca8: [top + 32] <- 0x2c21d2606785 ;  caller's pc
    0x7fff5fbfdca0: [top + 24] <- 0x7fff5fbfddb0 ;  caller's fp
    0x7fff5fbfdc98: [top + 16] <- 0xd6230db34c9 ;  context    0xd6230db34c9 <FixedArray[156]>  (input #3)
    0x7fff5fbfdc90: [top + 8] <- 0xd6230dc6299 ;  function    0xd6230dc6299 <JS Function hasQuestionToken (SharedFunctionInfo 0x3504a53d0859)>  (input #0)
    0x7fff5fbfdc88: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
[deoptimizing (eager): end 0xd6230dc6299 <JS Function hasQuestionToken (SharedFunctionInfo 0x3504a53d0859)> @3 => node=6, pc=0x2c21d26074eb, caller sp=0x7fff5fbfdcc0, state=NO_REGISTERS, took 0.044 ms]
[deoptimizing (DEOPT lazy): begin 0x29cc38d28429 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> (opt #333) @16, FP to SP delta: 184, caller sp: 0x7fff5fbfe098]
  reading input frame checkSourceElement => node=948, args=2, height=5; inputs:
      0: 0x29cc38d28429 ; [fp - 16] 0x29cc38d28429 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x286514c21cb1 ; [fp + 16] 0x286514c21cb1 <a NodeObject with map 0x33abe2a70101>
      3: 0x29cc38d04261 ; [fp - 24] 0x29cc38d04261 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 25) 0x30bcea404311 <undefined>
      5: 0x30bcea4069a9 ; (literal 26) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      6: 0x30bcea4069a9 ; (literal 26) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x30bcea404311 ; rax 0x30bcea404311 <undefined>
  translating frame checkSourceElement => node=948, height=32
    0x7fff5fbfe090: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfe088: [top + 64] <- 0x286514c21cb1 ;  0x286514c21cb1 <a NodeObject with map 0x33abe2a70101>  (input #2)
    0x7fff5fbfe080: [top + 56] <- 0x2c21d2207e55 ;  caller's pc
    0x7fff5fbfe078: [top + 48] <- 0x7fff5fbfe0b0 ;  caller's fp
    0x7fff5fbfe070: [top + 40] <- 0x29cc38d04261 ;  context    0x29cc38d04261 <FixedArray[1022]>  (input #3)
    0x7fff5fbfe068: [top + 32] <- 0x29cc38d28429 ;  function    0x29cc38d28429 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>  (input #0)
    0x7fff5fbfe060: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfe058: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #5)
    0x7fff5fbfe050: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfe048: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
[deoptimizing (lazy): end 0x29cc38d28429 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> @16 => node=948, pc=0x2c21d25ec795, caller sp=0x7fff5fbfe098, state=TOS_REGISTER, took 0.124 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkCollisionWithRequireExportsInGeneratedCode) id{337,0} ---
(node, name) {
            // No need to check for require or exports for ES6 modules and later
            if (modulekind >= ts.ModuleKind.ES2015) {
                return;
            }
            if (!needCollisionCheckForIdentifier(node, name, "require") && !needCollisionCheckForIdentifier(node, name, "exports")) {
                return;
            }
            // Uninstantiated modules shouldnt do this check
            if (node.kind === 230 /* ModuleDeclaration */ && ts.getModuleInstanceState(node) !== 1 /* Instantiated */) {
                return;
            }
            // In case of variable declaration, node.parent is variable statement so look at the variable statement's parent
            var parent = getDeclarationContainer(node);
            if (parent.kind === 261 /* SourceFile */ && ts.isExternalOrCommonJsModule(parent)) {
                // If the declaration happens to be in external module, report error that require and exports are reserved keywords
                error(name, ts.Diagnostics.Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module, ts.declarationNameToString(name), ts.declarationNameToString(name));
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeFromTypeNode) id{338,0} ---
(node) {
            switch (node.kind) {
                case 118 /* AnyKeyword */:
                case 263 /* JSDocAllType */:
                case 264 /* JSDocUnknownType */:
                    return anyType;
                case 134 /* StringKeyword */:
                    return stringType;
                case 132 /* NumberKeyword */:
                    return numberType;
                case 121 /* BooleanKeyword */:
                    return booleanType;
                case 135 /* SymbolKeyword */:
                    return esSymbolType;
                case 104 /* VoidKeyword */:
                    return voidType;
                case 137 /* UndefinedKeyword */:
                    return undefinedType;
                case 94 /* NullKeyword */:
                    return nullType;
                case 129 /* NeverKeyword */:
                    return neverType;
                case 289 /* JSDocNullKeyword */:
                    return nullType;
                case 290 /* JSDocUndefinedKeyword */:
                    return undefinedType;
                case 291 /* JSDocNeverKeyword */:
                    return neverType;
                case 167 /* ThisType */:
                case 98 /* ThisKeyword */:
                    return getTypeFromThisTypeNode(node);
                case 171 /* LiteralType */:
                    return getTypeFromLiteralTypeNode(node);
                case 288 /* JSDocLiteralType */:
                    return getTypeFromLiteralTypeNode(node.literal);
                case 157 /* TypeReference */:
                case 272 /* JSDocTypeReference */:
                    return getTypeFromTypeReference(node);
                case 156 /* TypePredicate */:
                    return booleanType;
                case 199 /* ExpressionWithTypeArguments */:
                    return getTypeFromTypeReference(node);
                case 160 /* TypeQuery */:
                    return getTypeFromTypeQueryNode(node);
                case 162 /* ArrayType */:
                case 265 /* JSDocArrayType */:
                    return getTypeFromArrayTypeNode(node);
                case 163 /* TupleType */:
                    return getTypeFromTupleTypeNode(node);
                case 164 /* UnionType */:
                case 266 /* JSDocUnionType */:
                    return getTypeFromUnionTypeNode(node);
                case 165 /* IntersectionType */:
                    return getTypeFromIntersectionTypeNode(node);
                case 166 /* ParenthesizedType */:
                case 268 /* JSDocNullableType */:
                case 269 /* JSDocNonNullableType */:
                case 276 /* JSDocConstructorType */:
                case 277 /* JSDocThisType */:
                case 273 /* JSDocOptionalType */:
                    return getTypeFromTypeNode(node.type);
                case 270 /* JSDocRecordType */:
                    return getTypeFromTypeNode(node.literal);
                case 158 /* FunctionType */:
                case 159 /* ConstructorType */:
                case 161 /* TypeLiteral */:
                case 287 /* JSDocTypeLiteral */:
                case 274 /* JSDocFunctionType */:
                    return getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode(node);
                case 168 /* TypeOperator */:
                    return getTypeFromTypeOperatorNode(node);
                case 169 /* IndexedAccessType */:
                    return getTypeFromIndexedAccessTypeNode(node);
                case 170 /* MappedType */:
                    return getTypeFromMappedTypeNode(node);
                // This function assumes that an identifier or qualified name is a type expression
                // Callers should first ensure this by calling isTypeNode
                case 70 /* Identifier */:
                case 141 /* QualifiedName */:
                    var symbol = getSymbolAtLocation(node);
                    return symbol && getDeclaredTypeOfSymbol(symbol);
                case 267 /* JSDocTupleType */:
                    return getTypeFromJSDocTupleType(node);
                case 275 /* JSDocVariadicType */:
                    return getTypeFromJSDocVariadicType(node);
                default:
                    return unknownType;
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeFromThisTypeNode) id{338,1} ---
(node) {
            var links = getNodeLinks(node);
            if (!links.resolvedType) {
                links.resolvedType = getThisType(node);
            }
            return links.resolvedType;
        }
--- END ---
INLINE (getTypeFromThisTypeNode) id{338,1} AS 1 AT <0:1275>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeLinks) id{338,2} ---
(node) {
            var nodeId = getNodeId(node);
            return nodeLinks[nodeId] || (nodeLinks[nodeId] = { flags: 0 });
        }
--- END ---
INLINE (getNodeLinks) id{338,2} AS 2 AT <1:33>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeId) id{338,3} ---
(node) {
        if (!node.id) {
            node.id = nextNodeId;
            nextNodeId++;
        }
        return node.id;
    }
--- END ---
INLINE (getNodeId) id{338,3} AS 3 AT <2:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeFromArrayTypeNode) id{338,4} ---
(node) {
            var links = getNodeLinks(node);
            if (!links.resolvedType) {
                links.resolvedType = createArrayType(getTypeFromTypeNode(node.elementType));
            }
            return links.resolvedType;
        }
--- END ---
INLINE (getTypeFromArrayTypeNode) id{338,4} AS 4 AT <0:2107>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeLinks) id{338,5} ---
(node) {
            var nodeId = getNodeId(node);
            return nodeLinks[nodeId] || (nodeLinks[nodeId] = { flags: 0 });
        }
--- END ---
INLINE (getNodeLinks) id{338,5} AS 5 AT <4:33>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeId) id{338,6} ---
(node) {
        if (!node.id) {
            node.id = nextNodeId;
            nextNodeId++;
        }
        return node.id;
    }
--- END ---
INLINE (getNodeId) id{338,6} AS 6 AT <5:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createArrayType) id{338,7} ---
(elementType) {
            return createTypeFromGenericGlobalType(globalArrayType, [elementType]);
        }
--- END ---
INLINE (createArrayType) id{338,7} AS 7 AT <4:129>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createTypeFromGenericGlobalType) id{338,8} ---
(genericGlobalType, typeArguments) {
            return genericGlobalType !== emptyGenericType ? createTypeReference(genericGlobalType, typeArguments) : emptyObjectType;
        }
--- END ---
INLINE (createTypeFromGenericGlobalType) id{338,8} AS 8 AT <7:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createTypeReference) id{338,9} ---
(target, typeArguments) {
            var id = getTypeListId(typeArguments);
            var type = target.instantiations[id];
            if (!type) {
                type = target.instantiations[id] = createObjectType(4 /* Reference */, target.symbol);
                type.flags |= typeArguments ? getPropagatingFlagsOfTypes(typeArguments, /*excludeKinds*/ 0) : 0;
                type.target = target;
                type.typeArguments = typeArguments;
            }
            return type;
        }
--- END ---
INLINE (createTypeReference) id{338,9} AS 9 AT <8:97>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createObjectType) id{338,10} ---
(objectFlags, symbol) {
            var type = createType(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol = symbol;
            return type;
        }
--- END ---
INLINE (createObjectType) id{338,10} AS 10 AT <9:203>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropagatingFlagsOfTypes) id{338,11} ---
(types, excludeKinds) {
            var result = 0;
            for (var _i = 0, types_3 = types; _i < types_3.length; _i++) {
                var type = types_3[_i];
                if (!(type.flags & excludeKinds)) {
                    result |= type.flags;
                }
            }
            return result & 14680064 /* PropagatingFlags */;
        }
--- END ---
INLINE (getPropagatingFlagsOfTypes) id{338,11} AS 11 AT <9:301>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeFromTupleTypeNode) id{338,12} ---
(node) {
            var links = getNodeLinks(node);
            if (!links.resolvedType) {
                links.resolvedType = createTupleType(ts.map(node.elementTypes, getTypeFromTypeNode));
            }
            return links.resolvedType;
        }
--- END ---
INLINE (getTypeFromTupleTypeNode) id{338,12} AS 12 AT <0:2208>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeLinks) id{338,13} ---
(node) {
            var nodeId = getNodeId(node);
            return nodeLinks[nodeId] || (nodeLinks[nodeId] = { flags: 0 });
        }
--- END ---
INLINE (getNodeLinks) id{338,13} AS 13 AT <12:33>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeId) id{338,14} ---
(node) {
        if (!node.id) {
            node.id = nextNodeId;
            nextNodeId++;
        }
        return node.id;
    }
--- END ---
INLINE (getNodeId) id{338,14} AS 14 AT <13:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createTupleType) id{338,15} ---
(elementTypes) {
            return createTypeReference(getTupleTypeOfArity(elementTypes.length), elementTypes);
        }
--- END ---
INLINE (createTupleType) id{338,15} AS 15 AT <12:129>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTupleTypeOfArity) id{338,16} ---
(arity) {
            return tupleTypes[arity] || (tupleTypes[arity] = createTupleTypeOfArity(arity));
        }
--- END ---
INLINE (getTupleTypeOfArity) id{338,16} AS 16 AT <15:56>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createTypeReference) id{338,17} ---
(target, typeArguments) {
            var id = getTypeListId(typeArguments);
            var type = target.instantiations[id];
            if (!type) {
                type = target.instantiations[id] = createObjectType(4 /* Reference */, target.symbol);
                type.flags |= typeArguments ? getPropagatingFlagsOfTypes(typeArguments, /*excludeKinds*/ 0) : 0;
                type.target = target;
                type.typeArguments = typeArguments;
            }
            return type;
        }
--- END ---
INLINE (createTypeReference) id{338,17} AS 17 AT <15:36>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createObjectType) id{338,18} ---
(objectFlags, symbol) {
            var type = createType(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol = symbol;
            return type;
        }
--- END ---
INLINE (createObjectType) id{338,18} AS 18 AT <17:203>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{338,19} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{338,19} AS 19 AT <18:47>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isExternalOrCommonJsModule) id{339,0} ---
(file) {
        return (file.externalModuleIndicator || file.commonJsModuleIndicator) !== undefined;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkParameter) id{340,0} ---
(node) {
            // Grammar checking
            // It is a SyntaxError if the Identifier "eval" or the Identifier "arguments" occurs as the
            // Identifier in a PropertySetParameterList of a PropertyAssignment that is contained in strict code
            // or if its FunctionBody is strict code(11.1.5).
            // Grammar checking
            checkGrammarDecorators(node) || checkGrammarModifiers(node);
            checkVariableLikeDeclaration(node);
            var func = ts.getContainingFunction(node);
            if (ts.getModifierFlags(node) & 92 /* ParameterPropertyModifier */) {
                func = ts.getContainingFunction(node);
                if (!(func.kind === 150 /* Constructor */ && ts.nodeIsPresent(func.body))) {
                    error(node, ts.Diagnostics.A_parameter_property_is_only_allowed_in_a_constructor_implementation);
                }
            }
            if (node.questionToken && ts.isBindingPattern(node.name) && func.body) {
                error(node, ts.Diagnostics.A_binding_pattern_parameter_cannot_be_optional_in_an_implementation_signature);
            }
            if (node.name.text === "this") {
                if (ts.indexOf(func.parameters, node) !== 0) {
                    error(node, ts.Diagnostics.A_this_parameter_must_be_the_first_parameter);
                }
                if (func.kind === 150 /* Constructor */ || func.kind === 154 /* ConstructSignature */ || func.kind === 159 /* ConstructorType */) {
                    error(node, ts.Diagnostics.A_constructor_cannot_have_a_this_parameter);
                }
            }
            // Only check rest parameter type if it's not a binding pattern. Since binding patterns are
            // not allowed in a rest parameter, we already have an error from checkGrammarParameterList.
            if (node.dotDotDotToken && !ts.isBindingPattern(node.name) && !isArrayType(getTypeOfSymbol(node.symbol))) {
                error(node, ts.Diagnostics.A_rest_parameter_must_be_of_an_array_type);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isArrayType) id{340,1} ---
(type) {
            return getObjectFlags(type) & 4 /* Reference */ && type.target === globalArrayType;
        }
--- END ---
INLINE (isArrayType) id{340,1} AS 1 AT <0:1906>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{340,2} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{340,2} AS 2 AT <1:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveName) id{341,0} ---
(location, name, meaning, nameNotFoundMessage, nameArg) {
            var result;
            var lastLocation;
            var propertyWithInvalidInitializer;
            var errorLocation = location;
            var grandparent;
            var isInExternalModule = false;
            loop: while (location) {
                // Locals of a source file are not in scope (because they get merged into the global symbol table)
                if (location.locals && !isGlobalSourceFile(location)) {
                    if (result = getSymbol(location.locals, name, meaning)) {
                        var useResult = true;
                        if (ts.isFunctionLike(location) && lastLocation && lastLocation !== location.body) {
                            // symbol lookup restrictions for function-like declarations
                            // - Type parameters of a function are in scope in the entire function declaration, including the parameter
                            //   list and return type. However, local types are only in scope in the function body.
                            // - parameters are only in the scope of function body
                            // This restriction does not apply to JSDoc comment types because they are parented
                            // at a higher level than type parameters would normally be
                            if (meaning & result.flags & 793064 /* Type */ && lastLocation.kind !== 278 /* JSDocComment */) {
                                useResult = result.flags & 262144 /* TypeParameter */
                                    ? lastLocation === location.type ||
                                        lastLocation.kind === 144 /* Parameter */ ||
                                        lastLocation.kind === 143 /* TypeParameter */
                                    : false;
                            }
                            if (meaning & 107455 /* Value */ && result.flags & 1 /* FunctionScopedVariable */) {
                                // parameters are visible only inside function body, parameter list and return type
                                // technically for parameter list case here we might mix parameters and variables declared in function,
                                // however it is detected separately when checking initializers of parameters
                                // to make sure that they reference no variables declared after them.
                                useResult =
                                    lastLocation.kind === 144 /* Parameter */ ||
                                        (lastLocation === location.type &&
                                            result.valueDeclaration.kind === 144 /* Parameter */);
                            }
                        }
                        if (useResult) {
                            break loop;
                        }
                        else {
                            result = undefined;
                        }
                    }
                }
                switch (location.kind) {
                    case 261 /* SourceFile */:
                        if (!ts.isExternalOrCommonJsModule(location))
                            break;
                        isInExternalModule = true;
                    case 230 /* ModuleDeclaration */:
                        var moduleExports = getSymbolOfNode(location).exports;
                        if (location.kind === 261 /* SourceFile */ || ts.isAmbientModule(location)) {
                            // It's an external module. First see if the module has an export default and if the local
                            // name of that export default matches.
                            if (result = moduleExports["default"]) {
                                var localSymbol = ts.getLocalSymbolForExportDefault(result);
                                if (localSymbol && (result.flags & meaning) && localSymbol.name === name) {
                                    break loop;
                                }
                                result = undefined;
                            }
                            // Because of module/namespace merging, a module's exports are in scope,
                            // yet we never want to treat an export specifier as putting a member in scope.
                            // Therefore, if the name we find is purely an export specifier, it is not actually considered in scope.
                            // Two things to note about this:
                            //     1. We have to check this without calling getSymbol. The problem with calling getSymbol
                            //        on an export specifier is that it might find the export specifier itself, and try to
                            //        resolve it as an alias. This will cause the checker to consider the export specifier
                            //        a circular alias reference when it might not be.
                            //     2. We check === SymbolFlags.Alias in order to check that the symbol is *purely*
                            //        an alias. If we used &, we'd be throwing out symbols that have non alias aspects,
                            //        which is not the desired behavior.
                            if (moduleExports[name] &&
                                moduleExports[name].flags === 8388608 /* Alias */ &&
                                ts.getDeclarationOfKind(moduleExports[name], 243 /* ExportSpecifier */)) {
                                break;
                            }
                        }
                        if (result = getSymbol(moduleExports, name, meaning & 8914931 /* ModuleMember */)) {
                            break loop;
                        }
                        break;
                    case 229 /* EnumDeclaration */:
                        if (result = getSymbol(getSymbolOfNode(location).exports, name, meaning & 8 /* EnumMember */)) {
                            break loop;
                        }
                        break;
                    case 147 /* PropertyDeclaration */:
                    case 146 /* PropertySignature */:
                        // TypeScript 1.0 spec (April 2014): 8.4.1
                        // Initializer expressions for instance member variables are evaluated in the scope
                        // of the class constructor body but are not permitted to reference parameters or
                        // local variables of the constructor. This effectively means that entities from outer scopes
                        // by the same name as a constructor parameter or local variable are inaccessible
                        // in initializer expressions for instance member variables.
                        if (ts.isClassLike(location.parent) && !(ts.getModifierFlags(location) & 32 /* Static */)) {
                            var ctor = findConstructorDeclaration(location.parent);
                            if (ctor && ctor.locals) {
                                if (getSymbol(ctor.locals, name, meaning & 107455 /* Value */)) {
                                    // Remember the property node, it will be used later to report appropriate error
                                    propertyWithInvalidInitializer = location;
                                }
                            }
                        }
                        break;
                    case 226 /* ClassDeclaration */:
                    case 197 /* ClassExpression */:
                    case 227 /* InterfaceDeclaration */:
                        if (result = getSymbol(getSymbolOfNode(location).members, name, meaning & 793064 /* Type */)) {
                            if (lastLocation && ts.getModifierFlags(lastLocation) & 32 /* Static */) {
                                // TypeScript 1.0 spec (April 2014): 3.4.1
                                // The scope of a type parameter extends over the entire declaration with which the type
                                // parameter list is associated, with the exception of static member declarations in classes.
                                error(errorLocation, ts.Diagnostics.Static_members_cannot_reference_class_type_parameters);
                                return undefined;
                            }
                            break loop;
                        }
                        if (location.kind === 197 /* ClassExpression */ && meaning & 32 /* Class */) {
                            var className = location.name;
                            if (className && name === className.text) {
                                result = location.symbol;
                                break loop;
                            }
                        }
                        break;
                    // It is not legal to reference a class's own type parameters from a computed property name that
                    // belongs to the class. For example:
                    //
                    //   function foo<T>() { return '' }
                    //   class C<T> { // <-- Class's own type parameter T
                    //       [foo<T>()]() { } // <-- Reference to T from class's own computed property
                    //   }
                    //
                    case 142 /* ComputedPropertyName */:
                        grandparent = location.parent.parent;
                        if (ts.isClassLike(grandparent) || grandparent.kind === 227 /* InterfaceDeclaration */) {
                            // A reference to this grandparent's type parameters would be an error
                            if (result = getSymbol(getSymbolOfNode(grandparent).members, name, meaning & 793064 /* Type */)) {
                                error(errorLocation, ts.Diagnostics.A_computed_property_name_cannot_reference_a_type_parameter_from_its_containing_type);
                                return undefined;
                            }
                        }
                        break;
                    case 149 /* MethodDeclaration */:
                    case 148 /* MethodSignature */:
                    case 150 /* Constructor */:
                    case 151 /* GetAccessor */:
                    case 152 /* SetAccessor */:
                    case 225 /* FunctionDeclaration */:
                    case 185 /* ArrowFunction */:
                        if (meaning & 3 /* Variable */ && name === "arguments") {
                            result = argumentsSymbol;
                            break loop;
                        }
                        break;
                    case 184 /* FunctionExpression */:
                        if (meaning & 3 /* Variable */ && name === "arguments") {
                            result = argumentsSymbol;
                            break loop;
                        }
                        if (meaning & 16 /* Function */) {
                            var functionName = location.name;
                            if (functionName && name === functionName.text) {
                                result = location.symbol;
                                break loop;
                            }
                        }
                        break;
                    case 145 /* Decorator */:
                        // Decorators are resolved at the class declaration. Resolving at the parameter
                        // or member would result in looking up locals in the method.
                        //
                        //   function y() {}
                        //   class C {
                        //       method(@y x, y) {} // <-- decorator y should be resolved at the class declaration, not the parameter.
                        //   }
                        //
                        if (location.parent && location.parent.kind === 144 /* Parameter */) {
                            location = location.parent;
                        }
                        //
                        //   function y() {}
                        //   class C {
                        //       @y method(x, y) {} // <-- decorator y should be resolved at the class declaration, not the method.
                        //   }
                        //
                        if (location.parent && ts.isClassElement(location.parent)) {
                            location = location.parent;
                        }
                        break;
                }
                lastLocation = location;
                location = location.parent;
            }
            if (result && nameNotFoundMessage && noUnusedIdentifiers) {
                result.isReferenced = true;
            }
            if (!result) {
                result = getSymbol(globals, name, meaning);
            }
            if (!result) {
                if (nameNotFoundMessage) {
                    if (!errorLocation ||
                        !checkAndReportErrorForMissingPrefix(errorLocation, name, nameArg) &&
                            !checkAndReportErrorForExtendingInterface(errorLocation) &&
                            !checkAndReportErrorForUsingTypeAsNamespace(errorLocation, name, meaning) &&
                            !checkAndReportErrorForUsingTypeAsValue(errorLocation, name, meaning)) {
                        error(errorLocation, nameNotFoundMessage, typeof nameArg === "string" ? nameArg : ts.declarationNameToString(nameArg));
                    }
                }
                return undefined;
            }
            // Perform extra checks only if error reporting was requested
            if (nameNotFoundMessage) {
                if (propertyWithInvalidInitializer) {
                    // We have a match, but the reference occurred within a property initializer and the identifier also binds
                    // to a local variable in the constructor where the code will be emitted.
                    var propertyName = propertyWithInvalidInitializer.name;
                    error(errorLocation, ts.Diagnostics.Initializer_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor, ts.declarationNameToString(propertyName), typeof nameArg === "string" ? nameArg : ts.declarationNameToString(nameArg));
                    return undefined;
                }
                // Only check for block-scoped variable if we are looking for the
                // name with variable meaning
                //      For example,
                //          declare module foo {
                //              interface bar {}
                //          }
                //      const foo/*1*/: foo/*2*/.bar;
                // The foo at /*1*/ and /*2*/ will share same symbol with two meaning
                // block - scope variable and namespace module. However, only when we
                // try to resolve name in /*1*/ which is used in variable position,
                // we want to check for block- scoped
                if (meaning & 2 /* BlockScopedVariable */) {
                    var exportOrLocalSymbol = getExportSymbolOfValueSymbolIfExported(result);
                    if (exportOrLocalSymbol.flags & 2 /* BlockScopedVariable */) {
                        checkResolvedBlockScopedVariable(exportOrLocalSymbol, errorLocation);
                    }
                }
                // If we're in an external module, we can't reference value symbols created from UMD export declarations
                if (result && isInExternalModule && (meaning & 107455 /* Value */) === 107455 /* Value */) {
                    var decls = result.declarations;
                    if (decls && decls.length === 1 && decls[0].kind === 233 /* NamespaceExportDeclaration */) {
                        error(errorLocation, ts.Diagnostics._0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead, name);
                    }
                }
            }
            return result;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isGlobalSourceFile) id{341,1} ---
(node) {
            return node.kind === 261 /* SourceFile */ && !ts.isExternalOrCommonJsModule(node);
        }
--- END ---
INLINE (isGlobalSourceFile) id{341,1} AS 1 AT <0:467>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{341,2} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{341,2} AS 2 AT <0:7735>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{341,3} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{341,3} AS 3 AT <2:28>
[marking dependent code 0x2c21d256a2a1 (opt #217) for deoptimization, reason: prototype-check]
[marking dependent code 0x2c21d2595921 (opt #247) for deoptimization, reason: prototype-check]
[deoptimize marked code in all contexts]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getDeclaredTypeOfSymbol) id{342,0} ---
(symbol) {
            ts.Debug.assert((symbol.flags & 16777216 /* Instantiated */) === 0);
            if (symbol.flags & (32 /* Class */ | 64 /* Interface */)) {
                return getDeclaredTypeOfClassOrInterface(symbol);
            }
            if (symbol.flags & 524288 /* TypeAlias */) {
                return getDeclaredTypeOfTypeAlias(symbol);
            }
            if (symbol.flags & 262144 /* TypeParameter */) {
                return getDeclaredTypeOfTypeParameter(symbol);
            }
            if (symbol.flags & 384 /* Enum */) {
                return getDeclaredTypeOfEnum(symbol);
            }
            if (symbol.flags & 8 /* EnumMember */) {
                return getDeclaredTypeOfEnumMember(symbol);
            }
            if (symbol.flags & 8388608 /* Alias */) {
                return getDeclaredTypeOfAlias(symbol);
            }
            return unknownType;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getDeclaredTypeOfTypeParameter) id{342,1} ---
(symbol) {
            var links = getSymbolLinks(symbol);
            if (!links.declaredType) {
                var type = createType(16384 /* TypeParameter */);
                type.symbol = symbol;
                if (!ts.getDeclarationOfKind(symbol, 143 /* TypeParameter */).constraint) {
                    type.constraint = noConstraintType;
                }
                links.declaredType = type;
            }
            return links.declaredType;
        }
--- END ---
INLINE (getDeclaredTypeOfTypeParameter) id{342,1} AS 1 AT <0:458>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{342,2} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{342,2} AS 2 AT <1:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{342,3} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{342,3} AS 3 AT <2:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{342,4} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{342,4} AS 4 AT <1:125>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{342,5} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{342,5} AS 5 AT <4:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isNumericName) id{343,0} ---
(name) {
            return name.kind === 142 /* ComputedPropertyName */ ? isNumericComputedName(name) : isNumericLiteralName(name.text);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateType) id{344,0} ---
(type, mapper) {
            if (type && mapper !== identityMapper) {
                // If we are instantiating a type that has a top-level type alias, obtain the instantiation through
                // the type alias instead in order to share instantiations for the same type arguments. This can
                // dramatically reduce the number of structurally identical types we generate. Note that we can only
                // perform this optimization for top-level type aliases. Consider:
                //
                //   function f1<T>(x: T) {
                //     type Foo<X> = { x: X, t: T };
                //     let obj: Foo<T> = { x: x };
                //     return obj;
                //   }
                //   function f2<U>(x: U) { return f1(x); }
                //   let z = f2(42);
                //
                // Above, the declaration of f2 has an inferred return type that is an instantiation of f1's Foo<X>
                // equivalent to { x: U, t: U }. When instantiating this return type, we can't go back to Foo<X>'s
                // cache because all cached instantiations are of the form { x: ???, t: T }, i.e. they have not been
                // instantiated for T. Instead, we need to further instantiate the { x: U, t: U } form.
                if (type.aliasSymbol && isTopLevelTypeAlias(type.aliasSymbol)) {
                    if (type.aliasTypeArguments) {
                        return getTypeAliasInstantiation(type.aliasSymbol, instantiateTypes(type.aliasTypeArguments, mapper));
                    }
                    return type;
                }
                return instantiateTypeNoAlias(type, mapper);
            }
            return type;
        }
--- END ---
[deoptimizing (DEOPT eager): begin 0x29cc38d238c9 <JS Function isNumericName (SharedFunctionInfo 0x2e2f693ff541)> (opt #343) @2, FP to SP delta: 24, caller sp: 0x7fff5fbfde18]
            ;;; deoptimize at 0_32: wrong map
  reading input frame isNumericName => node=4, args=2, height=1; inputs:
      0: 0x29cc38d238c9 ; [fp - 16] 0x29cc38d238c9 <JS Function isNumericName (SharedFunctionInfo 0x2e2f693ff541)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x286514c45c91 ; rax 0x286514c45c91 <an IdentifierObject with map 0x33abe2a6fde9>
      3: 0x29cc38d04261 ; [fp - 24] 0x29cc38d04261 <FixedArray[1022]>
  translating frame isNumericName => node=4, height=0
    0x7fff5fbfde10: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfde08: [top + 32] <- 0x286514c45c91 ;  0x286514c45c91 <an IdentifierObject with map 0x33abe2a6fde9>  (input #2)
    0x7fff5fbfde00: [top + 24] <- 0x2c21d261da8b ;  caller's pc
    0x7fff5fbfddf8: [top + 16] <- 0x7fff5fbfde48 ;  caller's fp
    0x7fff5fbfddf0: [top + 8] <- 0x29cc38d04261 ;  context    0x29cc38d04261 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdde8: [top + 0] <- 0x29cc38d238c9 ;  function    0x29cc38d238c9 <JS Function isNumericName (SharedFunctionInfo 0x2e2f693ff541)>  (input #0)
[deoptimizing (eager): end 0x29cc38d238c9 <JS Function isNumericName (SharedFunctionInfo 0x2e2f693ff541)> @2 => node=4, pc=0x2c21d261dfe6, caller sp=0x7fff5fbfde18, state=NO_REGISTERS, took 0.047 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getAliasSymbolForTypeNode) id{345,0} ---
(node) {
            return node.parent.kind === 228 /* TypeAliasDeclaration */ ? getSymbolOfNode(node.parent) : undefined;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{345,1} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{345,1} AS 1 AT <0:82>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{345,2} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{345,2} AS 2 AT <1:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:hasQuestionToken) id{346,0} ---
(node) {
        if (node) {
            switch (node.kind) {
                case 144 /* Parameter */:
                case 149 /* MethodDeclaration */:
                case 148 /* MethodSignature */:
                case 258 /* ShorthandPropertyAssignment */:
                case 257 /* PropertyAssignment */:
                case 147 /* PropertyDeclaration */:
                case 146 /* PropertySignature */:
                    return node.questionToken !== undefined;
            }
        }
        return false;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeOfVariableOrParameterOrProperty) id{347,0} ---
(symbol) {
            var links = getSymbolLinks(symbol);
            if (!links.type) {
                // Handle prototype property
                if (symbol.flags & 134217728 /* Prototype */) {
                    return links.type = getTypeOfPrototypeProperty(symbol);
                }
                // Handle catch clause variables
                var declaration = symbol.valueDeclaration;
                if (ts.isCatchClauseVariableDeclarationOrBindingElement(declaration)) {
                    return links.type = anyType;
                }
                // Handle export default expressions
                if (declaration.kind === 240 /* ExportAssignment */) {
                    return links.type = checkExpression(declaration.expression);
                }
                if (declaration.flags & 65536 /* JavaScriptFile */ && declaration.kind === 286 /* JSDocPropertyTag */ && declaration.typeExpression) {
                    return links.type = getTypeFromTypeNode(declaration.typeExpression.type);
                }
                // Handle variable, parameter or property
                if (!pushTypeResolution(symbol, 0 /* Type */)) {
                    return unknownType;
                }
                var type = void 0;
                // Handle certain special assignment kinds, which happen to union across multiple declarations:
                // * module.exports = expr
                // * exports.p = expr
                // * this.p = expr
                // * className.prototype.method = expr
                if (declaration.kind === 192 /* BinaryExpression */ ||
                    declaration.kind === 177 /* PropertyAccessExpression */ && declaration.parent.kind === 192 /* BinaryExpression */) {
                    // Use JS Doc type if present on parent expression statement
                    if (declaration.flags & 65536 /* JavaScriptFile */) {
                        var jsdocType = ts.getJSDocType(declaration.parent);
                        if (jsdocType) {
                            return links.type = getTypeFromTypeNode(jsdocType);
                        }
                    }
                    var declaredTypes = ts.map(symbol.declarations, function (decl) { return decl.kind === 192 /* BinaryExpression */ ?
                        checkExpressionCached(decl.right) :
                        checkExpressionCached(decl.parent.right); });
                    type = getUnionType(declaredTypes, /*subtypeReduction*/ true);
                }
                else {
                    type = getWidenedTypeForVariableLikeDeclaration(declaration, /*reportErrors*/ true);
                }
                if (!popTypeResolution()) {
                    type = reportCircularityError(symbol);
                }
                links.type = type;
            }
            return links.type;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{347,1} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{347,1} AS 1 AT <0:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{347,2} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{347,2} AS 2 AT <1:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:popTypeResolution) id{347,3} ---
() {
            resolutionTargets.pop();
            resolutionPropertyNames.pop();
            return resolutionResults.pop();
        }
--- END ---
INLINE (popTypeResolution) id{347,3} AS 3 AT <0:2684>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkSourceElement) id{348,0} ---
(node) {
            if (!node) {
                return;
            }
            var kind = node.kind;
            if (cancellationToken) {
                // Only bother checking on a few construct kinds.  We don't want to be excessively
                // hitting the cancellation token on every node we check.
                switch (kind) {
                    case 230 /* ModuleDeclaration */:
                    case 226 /* ClassDeclaration */:
                    case 227 /* InterfaceDeclaration */:
                    case 225 /* FunctionDeclaration */:
                        cancellationToken.throwIfCancellationRequested();
                }
            }
            switch (kind) {
                case 143 /* TypeParameter */:
                    return checkTypeParameter(node);
                case 144 /* Parameter */:
                    return checkParameter(node);
                case 147 /* PropertyDeclaration */:
                case 146 /* PropertySignature */:
                    return checkPropertyDeclaration(node);
                case 158 /* FunctionType */:
                case 159 /* ConstructorType */:
                case 153 /* CallSignature */:
                case 154 /* ConstructSignature */:
                    return checkSignatureDeclaration(node);
                case 155 /* IndexSignature */:
                    return checkSignatureDeclaration(node);
                case 149 /* MethodDeclaration */:
                case 148 /* MethodSignature */:
                    return checkMethodDeclaration(node);
                case 150 /* Constructor */:
                    return checkConstructorDeclaration(node);
                case 151 /* GetAccessor */:
                case 152 /* SetAccessor */:
                    return checkAccessorDeclaration(node);
                case 157 /* TypeReference */:
                    return checkTypeReferenceNode(node);
                case 156 /* TypePredicate */:
                    return checkTypePredicate(node);
                case 160 /* TypeQuery */:
                    return checkTypeQuery(node);
                case 161 /* TypeLiteral */:
                    return checkTypeLiteral(node);
                case 162 /* ArrayType */:
                    return checkArrayType(node);
                case 163 /* TupleType */:
                    return checkTupleType(node);
                case 164 /* UnionType */:
                case 165 /* IntersectionType */:
                    return checkUnionOrIntersectionType(node);
                case 166 /* ParenthesizedType */:
                case 168 /* TypeOperator */:
                    return checkSourceElement(node.type);
                case 169 /* IndexedAccessType */:
                    return checkIndexedAccessType(node);
                case 170 /* MappedType */:
                    return checkMappedType(node);
                case 225 /* FunctionDeclaration */:
                    return checkFunctionDeclaration(node);
                case 204 /* Block */:
                case 231 /* ModuleBlock */:
                    return checkBlock(node);
                case 205 /* VariableStatement */:
                    return checkVariableStatement(node);
                case 207 /* ExpressionStatement */:
                    return checkExpressionStatement(node);
                case 208 /* IfStatement */:
                    return checkIfStatement(node);
                case 209 /* DoStatement */:
                    return checkDoStatement(node);
                case 210 /* WhileStatement */:
                    return checkWhileStatement(node);
                case 211 /* ForStatement */:
                    return checkForStatement(node);
                case 212 /* ForInStatement */:
                    return checkForInStatement(node);
                case 213 /* ForOfStatement */:
                    return checkForOfStatement(node);
                case 214 /* ContinueStatement */:
                case 215 /* BreakStatement */:
                    return checkBreakOrContinueStatement(node);
                case 216 /* ReturnStatement */:
                    return checkReturnStatement(node);
                case 217 /* WithStatement */:
                    return checkWithStatement(node);
                case 218 /* SwitchStatement */:
                    return checkSwitchStatement(node);
                case 219 /* LabeledStatement */:
                    return checkLabeledStatement(node);
                case 220 /* ThrowStatement */:
                    return checkThrowStatement(node);
                case 221 /* TryStatement */:
                    return checkTryStatement(node);
                case 223 /* VariableDeclaration */:
                    return checkVariableDeclaration(node);
                case 174 /* BindingElement */:
                    return checkBindingElement(node);
                case 226 /* ClassDeclaration */:
                    return checkClassDeclaration(node);
                case 227 /* InterfaceDeclaration */:
                    return checkInterfaceDeclaration(node);
                case 228 /* TypeAliasDeclaration */:
                    return checkTypeAliasDeclaration(node);
                case 229 /* EnumDeclaration */:
                    return checkEnumDeclaration(node);
                case 230 /* ModuleDeclaration */:
                    return checkModuleDeclaration(node);
                case 235 /* ImportDeclaration */:
                    return checkImportDeclaration(node);
                case 234 /* ImportEqualsDeclaration */:
                    return checkImportEqualsDeclaration(node);
                case 241 /* ExportDeclaration */:
                    return checkExportDeclaration(node);
                case 240 /* ExportAssignment */:
                    return checkExportAssignment(node);
                case 206 /* EmptyStatement */:
                    checkGrammarStatementInAmbientContext(node);
                    return;
                case 222 /* DebuggerStatement */:
                    checkGrammarStatementInAmbientContext(node);
                    return;
                case 244 /* MissingDeclaration */:
                    return checkMissingDeclaration(node);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkTypeParameter) id{348,1} ---
(node) {
            // Grammar Checking
            if (node.expression) {
                grammarErrorOnFirstToken(node.expression, ts.Diagnostics.Type_expected);
            }
            checkSourceElement(node.constraint);
            getConstraintOfTypeParameter(getDeclaredTypeOfTypeParameter(getSymbolOfNode(node)));
            if (produceDiagnostics) {
                checkTypeNameIsReserved(node.name, ts.Diagnostics.Type_parameter_name_cannot_be_0);
            }
        }
--- END ---
INLINE (checkTypeParameter) id{348,1} AS 1 AT <0:775>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{348,2} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{348,2} AS 2 AT <1:300>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{348,3} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{348,3} AS 3 AT <2:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getDeclaredTypeOfTypeParameter) id{348,4} ---
(symbol) {
            var links = getSymbolLinks(symbol);
            if (!links.declaredType) {
                var type = createType(16384 /* TypeParameter */);
                type.symbol = symbol;
                if (!ts.getDeclarationOfKind(symbol, 143 /* TypeParameter */).constraint) {
                    type.constraint = noConstraintType;
                }
                links.declaredType = type;
            }
            return links.declaredType;
        }
--- END ---
INLINE (getDeclaredTypeOfTypeParameter) id{348,4} AS 4 AT <1:269>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{348,5} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{348,5} AS 5 AT <4:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{348,6} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{348,6} AS 6 AT <5:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{348,7} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{348,7} AS 7 AT <4:125>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{348,8} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{348,8} AS 8 AT <7:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkTypeNameIsReserved) id{348,9} ---
(name, message) {
            // TS 1.0 spec (April 2014): 3.6.1
            // The predefined type keywords are reserved and cannot be used as names of user defined types.
            switch (name.text) {
                case "any":
                case "number":
                case "boolean":
                case "string":
                case "symbol":
                case "void":
                    error(name, message, name.text);
            }
        }
--- END ---
INLINE (checkTypeNameIsReserved) id{348,9} AS 9 AT <1:379>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkPropertyDeclaration) id{348,10} ---
(node) {
            // Grammar checking
            checkGrammarDecorators(node) || checkGrammarModifiers(node) || checkGrammarProperty(node) || checkGrammarComputedPropertyName(node.name);
            checkVariableLikeDeclaration(node);
        }
--- END ---
INLINE (checkPropertyDeclaration) id{348,10} AS 10 AT <0:1021>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarComputedPropertyName) id{348,11} ---
(node) {
            // If node is not a computedPropertyName, just skip the grammar checking
            if (node.kind !== 142 /* ComputedPropertyName */) {
                return false;
            }
            var computedPropertyName = node;
            if (computedPropertyName.expression.kind === 192 /* BinaryExpression */ && computedPropertyName.expression.operatorToken.kind === 25 /* CommaToken */) {
                return grammarErrorOnNode(computedPropertyName.expression, ts.Diagnostics.A_comma_expression_is_not_allowed_in_a_computed_property_name);
            }
        }
--- END ---
INLINE (checkGrammarComputedPropertyName) id{348,11} AS 11 AT <10:146>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkArrayType) id{348,12} ---
(node) {
            checkSourceElement(node.elementType);
        }
--- END ---
INLINE (checkArrayType) id{348,12} AS 12 AT <0:2275>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkTupleType) id{348,13} ---
(node) {
            // Grammar checking
            var hasErrorFromDisallowedTrailingComma = checkGrammarForDisallowedTrailingComma(node.elementTypes);
            if (!hasErrorFromDisallowedTrailingComma && node.elementTypes.length === 0) {
                grammarErrorOnNode(node, ts.Diagnostics.A_tuple_type_element_list_cannot_be_empty);
            }
            ts.forEach(node.elementTypes, checkSourceElement);
        }
--- END ---
INLINE (checkTupleType) id{348,13} AS 13 AT <0:2366>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarForDisallowedTrailingComma) id{348,14} ---
(list) {
            if (list && list.hasTrailingComma) {
                var start = list.end - ",".length;
                var end = list.end;
                var sourceFile = ts.getSourceFileOfNode(list[0]);
                return grammarErrorAtPos(sourceFile, start, end - start, ts.Diagnostics.Trailing_comma_not_allowed);
            }
        }
--- END ---
INLINE (checkGrammarForDisallowedTrailingComma) id{348,14} AS 14 AT <13:95>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveEntityName) id{349,0} ---
(name, meaning, ignoreErrors, dontResolveAlias, location) {
            if (ts.nodeIsMissing(name)) {
                return undefined;
            }
            var symbol;
            if (name.kind === 70 /* Identifier */) {
                var message = meaning === 1920 /* Namespace */ ? ts.Diagnostics.Cannot_find_namespace_0 : ts.Diagnostics.Cannot_find_name_0;
                symbol = resolveName(location || name, name.text, meaning, ignoreErrors ? undefined : message, name);
                if (!symbol) {
                    return undefined;
                }
            }
            else if (name.kind === 141 /* QualifiedName */ || name.kind === 177 /* PropertyAccessExpression */) {
                var left = name.kind === 141 /* QualifiedName */ ? name.left : name.expression;
                var right = name.kind === 141 /* QualifiedName */ ? name.right : name.name;
                var namespace = resolveEntityName(left, 1920 /* Namespace */, ignoreErrors, /*dontResolveAlias*/ false, location);
                if (!namespace || ts.nodeIsMissing(right)) {
                    return undefined;
                }
                else if (namespace === unknownSymbol) {
                    return namespace;
                }
                symbol = getSymbol(getExportsOfSymbol(namespace), right.text, meaning);
                if (!symbol) {
                    if (!ignoreErrors) {
                        error(right, ts.Diagnostics.Namespace_0_has_no_exported_member_1, getFullyQualifiedName(namespace), ts.declarationNameToString(right));
                    }
                    return undefined;
                }
            }
            else {
                ts.Debug.fail("Unknown entity name kind.");
            }
            ts.Debug.assert((symbol.flags & 16777216 /* Instantiated */) === 0, "Should never get an instantiated symbol here.");
            return (symbol.flags & meaning) || dontResolveAlias ? symbol : resolveAlias(symbol);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getEffectiveDeclarationFlags) id{350,0} ---
(n, flagsToCheck) {
            var flags = ts.getCombinedModifierFlags(n);
            // children of classes (even ambient classes) should not be marked as ambient or export
            // because those flags have no useful semantics there.
            if (n.parent.kind !== 227 /* InterfaceDeclaration */ &&
                n.parent.kind !== 226 /* ClassDeclaration */ &&
                n.parent.kind !== 197 /* ClassExpression */ &&
                ts.isInAmbientContext(n)) {
                if (!(flags & 2 /* Ambient */)) {
                    // It is nested in an ambient context, which means it is automatically exported
                    flags |= 1 /* Export */;
                }
                flags |= 2 /* Ambient */;
            }
            return flags & flagsToCheck;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeOfInstantiatedSymbol) id{351,0} ---
(symbol) {
            var links = getSymbolLinks(symbol);
            if (!links.type) {
                if (!pushTypeResolution(symbol, 0 /* Type */)) {
                    return unknownType;
                }
                var type = instantiateType(getTypeOfSymbol(links.target), links.mapper);
                if (!popTypeResolution()) {
                    type = reportCircularityError(symbol);
                }
                links.type = type;
            }
            return links.type;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{351,1} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{351,1} AS 1 AT <0:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{351,2} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{351,2} AS 2 AT <1:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:popTypeResolution) id{351,3} ---
() {
            resolutionTargets.pop();
            resolutionPropertyNames.pop();
            return resolutionResults.pop();
        }
--- END ---
INLINE (popTypeResolution) id{351,3} AS 3 AT <0:323>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateTypes) id{352,0} ---
(types, mapper) {
            return instantiateList(types, mapper, instantiateType);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateList) id{352,1} ---
(items, mapper, instantiator) {
            if (items && items.length) {
                var result = [];
                for (var _i = 0, items_1 = items; _i < items_1.length; _i++) {
                    var v = items_1[_i];
                    result.push(instantiator(v, mapper));
                }
                return result;
            }
            return items;
        }
--- END ---
INLINE (instantiateList) id{352,1} AS 1 AT <0:37>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:lastOrUndefined) id{353,0} ---
(array) {
        return array && array.length > 0
            ? array[array.length - 1]
            : undefined;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkMethodDeclaration) id{354,0} ---
(node) {
            // Grammar checking
            checkGrammarMethod(node) || checkGrammarComputedPropertyName(node.name);
            // Grammar checking for modifiers is done inside the function checkGrammarFunctionLikeDeclaration
            checkFunctionOrMethodDeclaration(node);
            // Abstract methods cannot have an implementation.
            // Extra checks are to avoid reporting multiple errors relating to the "abstractness" of the node.
            if (ts.getModifierFlags(node) & 128 /* Abstract */ && node.body) {
                error(node, ts.Diagnostics.Method_0_cannot_have_an_implementation_because_it_is_marked_abstract, ts.declarationNameToString(node.name));
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarComputedPropertyName) id{354,1} ---
(node) {
            // If node is not a computedPropertyName, just skip the grammar checking
            if (node.kind !== 142 /* ComputedPropertyName */) {
                return false;
            }
            var computedPropertyName = node;
            if (computedPropertyName.expression.kind === 192 /* BinaryExpression */ && computedPropertyName.expression.operatorToken.kind === 25 /* CommaToken */) {
                return grammarErrorOnNode(computedPropertyName.expression, ts.Diagnostics.A_comma_expression_is_not_allowed_in_a_computed_property_name);
            }
        }
--- END ---
INLINE (checkGrammarComputedPropertyName) id{354,1} AS 1 AT <0:81>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateCached) id{355,0} ---
(type, mapper, instantiator) {
            var instantiations = mapper.instantiations || (mapper.instantiations = []);
            return instantiations[type.id] || (instantiations[type.id] = instantiator(type, mapper));
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateAnonymousType) id{356,0} ---
(type, mapper) {
            var result = createObjectType(16 /* Anonymous */ | 64 /* Instantiated */, type.symbol);
            result.target = type.objectFlags & 64 /* Instantiated */ ? type.target : type;
            result.mapper = type.objectFlags & 64 /* Instantiated */ ? combineTypeMappers(type.mapper, mapper) : mapper;
            result.aliasSymbol = type.aliasSymbol;
            result.aliasTypeArguments = instantiateTypes(type.aliasTypeArguments, mapper);
            return result;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createObjectType) id{356,1} ---
(objectFlags, symbol) {
            var type = createType(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol = symbol;
            return type;
        }
--- END ---
INLINE (createObjectType) id{356,1} AS 1 AT <0:42>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{356,2} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{356,2} AS 2 AT <1:47>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{356,3} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{356,3} AS 3 AT <2:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateTypes) id{356,4} ---
(types, mapper) {
            return instantiateList(types, mapper, instantiateType);
        }
--- END ---
INLINE (instantiateTypes) id{356,4} AS 4 AT <0:420>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateList) id{356,5} ---
(items, mapper, instantiator) {
            if (items && items.length) {
                var result = [];
                for (var _i = 0, items_1 = items; _i < items_1.length; _i++) {
                    var v = items_1[_i];
                    result.push(instantiator(v, mapper));
                }
                return result;
            }
            return items;
        }
--- END ---
INLINE (instantiateList) id{356,5} AS 5 AT <4:37>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeOfSymbol) id{357,0} ---
(symbol) {
            if (symbol.flags & 16777216 /* Instantiated */) {
                return getTypeOfInstantiatedSymbol(symbol);
            }
            if (symbol.flags & (3 /* Variable */ | 4 /* Property */)) {
                return getTypeOfVariableOrParameterOrProperty(symbol);
            }
            if (symbol.flags & (16 /* Function */ | 8192 /* Method */ | 32 /* Class */ | 384 /* Enum */ | 512 /* ValueModule */)) {
                return getTypeOfFuncClassEnumModule(symbol);
            }
            if (symbol.flags & 8 /* EnumMember */) {
                return getTypeOfEnumMember(symbol);
            }
            if (symbol.flags & 98304 /* Accessor */) {
                return getTypeOfAccessors(symbol);
            }
            if (symbol.flags & 8388608 /* Alias */) {
                return getTypeOfAlias(symbol);
            }
            return unknownType;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeOfInstantiatedSymbol) id{357,1} ---
(symbol) {
            var links = getSymbolLinks(symbol);
            if (!links.type) {
                if (!pushTypeResolution(symbol, 0 /* Type */)) {
                    return unknownType;
                }
                var type = instantiateType(getTypeOfSymbol(links.target), links.mapper);
                if (!popTypeResolution()) {
                    type = reportCircularityError(symbol);
                }
                links.type = type;
            }
            return links.type;
        }
--- END ---
INLINE (getTypeOfInstantiatedSymbol) id{357,1} AS 1 AT <0:96>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{357,2} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{357,2} AS 2 AT <1:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{357,3} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{357,3} AS 3 AT <2:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:popTypeResolution) id{357,4} ---
() {
            resolutionTargets.pop();
            resolutionPropertyNames.pop();
            return resolutionResults.pop();
        }
--- END ---
INLINE (popTypeResolution) id{357,4} AS 4 AT <1:323>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeOfFuncClassEnumModule) id{357,5} ---
(symbol) {
            var links = getSymbolLinks(symbol);
            if (!links.type) {
                if (symbol.flags & 1536 /* Module */ && ts.isShorthandAmbientModuleSymbol(symbol)) {
                    links.type = anyType;
                }
                else {
                    var type = createObjectType(16 /* Anonymous */, symbol);
                    links.type = strictNullChecks && symbol.flags & 536870912 /* Optional */ ?
                        includeFalsyTypes(type, 2048 /* Undefined */) : type;
                }
            }
            return links.type;
        }
--- END ---
INLINE (getTypeOfFuncClassEnumModule) id{357,5} AS 5 AT <0:459>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{357,6} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{357,6} AS 6 AT <5:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{357,7} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{357,7} AS 7 AT <6:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createObjectType) id{357,8} ---
(objectFlags, symbol) {
            var type = createType(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol = symbol;
            return type;
        }
--- END ---
INLINE (createObjectType) id{357,8} AS 8 AT <5:305>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{357,9} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{357,9} AS 9 AT <8:47>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{357,10} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{357,10} AS 10 AT <9:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIndependentMember) id{358,0} ---
(symbol) {
            if (symbol.declarations && symbol.declarations.length === 1) {
                var declaration = symbol.declarations[0];
                if (declaration) {
                    switch (declaration.kind) {
                        case 147 /* PropertyDeclaration */:
                        case 146 /* PropertySignature */:
                            return isIndependentVariableLikeDeclaration(declaration);
                        case 149 /* MethodDeclaration */:
                        case 148 /* MethodSignature */:
                        case 150 /* Constructor */:
                            return isIndependentFunctionLikeDeclaration(declaration);
                    }
                }
            }
            return false;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIndependentVariableLikeDeclaration) id{358,1} ---
(node) {
            return node.type && isIndependentType(node.type) || !node.type && !node.initializer;
        }
--- END ---
INLINE (isIndependentVariableLikeDeclaration) id{358,1} AS 1 AT <0:380>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIndependentFunctionLikeDeclaration) id{358,2} ---
(node) {
            if (node.kind !== 150 /* Constructor */ && (!node.type || !isIndependentType(node.type))) {
                return false;
            }
            for (var _i = 0, _a = node.parameters; _i < _a.length; _i++) {
                var parameter = _a[_i];
                if (!isIndependentVariableLikeDeclaration(parameter)) {
                    return false;
                }
            }
            return true;
        }
--- END ---
INLINE (isIndependentFunctionLikeDeclaration) id{358,2} AS 2 AT <0:632>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIndependentVariableLikeDeclaration) id{358,3} ---
(node) {
            return node.type && isIndependentType(node.type) || !node.type && !node.initializer;
        }
--- END ---
INLINE (isIndependentVariableLikeDeclaration) id{358,3} AS 3 AT <2:293>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getDeclaredTypeOfClassOrInterface) id{359,0} ---
(symbol) {
            var links = getSymbolLinks(symbol);
            if (!links.declaredType) {
                var kind = symbol.flags & 32 /* Class */ ? 1 /* Class */ : 2 /* Interface */;
                var type = links.declaredType = createObjectType(kind, symbol);
                var outerTypeParameters = getOuterTypeParametersOfClassOrInterface(symbol);
                var localTypeParameters = getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol);
                // A class or interface is generic if it has type parameters or a "this" type. We always give classes a "this" type
                // because it is not feasible to analyze all members to determine if the "this" type escapes the class (in particular,
                // property types inferred from initializers and method return types inferred from return statements are very hard
                // to exhaustively analyze). We give interfaces a "this" type if we can't definitely determine that they are free of
                // "this" references.
                if (outerTypeParameters || localTypeParameters || kind === 1 /* Class */ || !isIndependentInterface(symbol)) {
                    type.objectFlags |= 4 /* Reference */;
                    type.typeParameters = ts.concatenate(outerTypeParameters, localTypeParameters);
                    type.outerTypeParameters = outerTypeParameters;
                    type.localTypeParameters = localTypeParameters;
                    type.instantiations = ts.createMap();
                    type.instantiations[getTypeListId(type.typeParameters)] = type;
                    type.target = type;
                    type.typeArguments = type.typeParameters;
                    type.thisType = createType(16384 /* TypeParameter */);
                    type.thisType.isThisType = true;
                    type.thisType.symbol = symbol;
                    type.thisType.constraint = type;
                }
            }
            return links.declaredType;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{359,1} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{359,1} AS 1 AT <0:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{359,2} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{359,2} AS 2 AT <1:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createObjectType) id{359,3} ---
(objectFlags, symbol) {
            var type = createType(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol = symbol;
            return type;
        }
--- END ---
INLINE (createObjectType) id{359,3} AS 3 AT <0:240>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{359,4} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{359,4} AS 4 AT <3:47>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{359,5} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{359,5} AS 5 AT <4:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getOuterTypeParametersOfClassOrInterface) id{359,6} ---
(symbol) {
            var declaration = symbol.flags & 32 /* Class */ ? symbol.valueDeclaration : ts.getDeclarationOfKind(symbol, 227 /* InterfaceDeclaration */);
            return appendOuterTypeParameters(undefined, declaration);
        }
--- END ---
INLINE (getOuterTypeParametersOfClassOrInterface) id{359,6} AS 6 AT <0:314>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{359,7} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{359,7} AS 7 AT <0:1738>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{359,8} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{359,8} AS 8 AT <7:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getAliasTypeArgumentsForTypeNode) id{360,0} ---
(node) {
            var symbol = getAliasSymbolForTypeNode(node);
            return symbol ? getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol) : undefined;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getAliasSymbolForTypeNode) id{360,1} ---
(node) {
            return node.parent.kind === 228 /* TypeAliasDeclaration */ ? getSymbolOfNode(node.parent) : undefined;
        }
--- END ---
INLINE (getAliasSymbolForTypeNode) id{360,1} AS 1 AT <0:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{360,2} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{360,2} AS 2 AT <1:82>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{360,3} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{360,3} AS 3 AT <2:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isNumericLiteralName) id{361,0} ---
(name) {
            // The intent of numeric names is that
            //     - they are names with text in a numeric form, and that
            //     - setting properties/indexing with them is always equivalent to doing so with the numeric literal 'numLit',
            //         acquired by applying the abstract 'ToNumber' operation on the name's text.
            //
            // The subtlety is in the latter portion, as we cannot reliably say that anything that looks like a numeric literal is a numeric name.
            // In fact, it is the case that the text of the name must be equal to 'ToString(numLit)' for this to hold.
            //
            // Consider the property name '"0xF00D"'. When one indexes with '0xF00D', they are actually indexing with the value of 'ToString(0xF00D)'
            // according to the ECMAScript specification, so it is actually as if the user indexed with the string '"61453"'.
            // Thus, the text of all numeric literals equivalent to '61543' such as '0xF00D', '0xf00D', '0170015', etc. are not valid numeric names
            // because their 'ToString' representation is not equal to their original text.
            // This is motivated by ECMA-262 sections 9.3.1, 9.8.1, 11.1.5, and 11.2.1.
            //
            // Here, we test whether 'ToString(ToNumber(name))' is exactly equal to 'name'.
            // The '+' prefix operator is equivalent here to applying the abstract ToNumber operation.
            // Applying the 'toString()' method on a number gives us the abstract ToString operation on a number.
            //
            // Note that this accepts the values 'Infinity', '-Infinity', and 'NaN', and that this is intentional.
            // This is desired behavior, because when indexing with them as numeric entities, you are indexing
            // with the strings '"Infinity"', '"-Infinity"', and '"NaN"' respectively.
            return (+name).toString() === name;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isNumericName) id{362,0} ---
(name) {
            return name.kind === 142 /* ComputedPropertyName */ ? isNumericComputedName(name) : isNumericLiteralName(name.text);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:hasProperty) id{363,0} ---
(map, key) {
        return hasOwnProperty.call(map, key);
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode) id{364,0} ---
(node) {
            var links = getNodeLinks(node);
            if (!links.resolvedType) {
                // Deferred resolution of members is handled by resolveObjectTypeMembers
                var aliasSymbol = getAliasSymbolForTypeNode(node);
                if (ts.isEmpty(node.symbol.members) && !aliasSymbol) {
                    links.resolvedType = emptyTypeLiteralType;
                }
                else {
                    var type = createObjectType(16 /* Anonymous */, node.symbol);
                    type.aliasSymbol = aliasSymbol;
                    type.aliasTypeArguments = getAliasTypeArgumentsForTypeNode(node);
                    links.resolvedType = type;
                }
            }
            return links.resolvedType;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeLinks) id{364,1} ---
(node) {
            var nodeId = getNodeId(node);
            return nodeLinks[nodeId] || (nodeLinks[nodeId] = { flags: 0 });
        }
--- END ---
INLINE (getNodeLinks) id{364,1} AS 1 AT <0:33>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeId) id{364,2} ---
(node) {
        if (!node.id) {
            node.id = nextNodeId;
            nextNodeId++;
        }
        return node.id;
    }
--- END ---
INLINE (getNodeId) id{364,2} AS 2 AT <1:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getAliasSymbolForTypeNode) id{364,3} ---
(node) {
            return node.parent.kind === 228 /* TypeAliasDeclaration */ ? getSymbolOfNode(node.parent) : undefined;
        }
--- END ---
INLINE (getAliasSymbolForTypeNode) id{364,3} AS 3 AT <0:215>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{364,4} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{364,4} AS 4 AT <3:82>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{364,5} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{364,5} AS 5 AT <4:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createObjectType) id{364,6} ---
(objectFlags, symbol) {
            var type = createType(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol = symbol;
            return type;
        }
--- END ---
INLINE (createObjectType) id{364,6} AS 6 AT <0:454>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{364,7} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{364,7} AS 7 AT <6:47>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{364,8} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{364,8} AS 8 AT <7:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getAliasTypeArgumentsForTypeNode) id{364,9} ---
(node) {
            var symbol = getAliasSymbolForTypeNode(node);
            return symbol ? getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol) : undefined;
        }
--- END ---
INLINE (getAliasTypeArgumentsForTypeNode) id{364,9} AS 9 AT <0:603>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getAliasSymbolForTypeNode) id{364,10} ---
(node) {
            return node.parent.kind === 228 /* TypeAliasDeclaration */ ? getSymbolOfNode(node.parent) : undefined;
        }
--- END ---
INLINE (getAliasSymbolForTypeNode) id{364,10} AS 10 AT <9:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{364,11} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{364,11} AS 11 AT <10:82>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{364,12} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{364,12} AS 12 AT <11:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateSymbol) id{365,0} ---
(symbol, mapper) {
            if (symbol.flags & 16777216 /* Instantiated */) {
                var links = getSymbolLinks(symbol);
                // If symbol being instantiated is itself a instantiation, fetch the original target and combine the
                // type mappers. This ensures that original type identities are properly preserved and that aliases
                // always reference a non-aliases.
                symbol = links.target;
                mapper = combineTypeMappers(links.mapper, mapper);
            }
            // Keep the flags from the symbol we're instantiating.  Mark that is instantiated, and
            // also transient so that we can just store data on it directly.
            var result = createSymbol(16777216 /* Instantiated */ | 67108864 /* Transient */ | symbol.flags, symbol.name);
            result.declarations = symbol.declarations;
            result.parent = symbol.parent;
            result.target = symbol;
            result.mapper = mapper;
            if (symbol.valueDeclaration) {
                result.valueDeclaration = symbol.valueDeclaration;
            }
            return result;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createSymbol) id{365,1} ---
(flags, name) {
            symbolCount++;
            return new Symbol(flags, name);
        }
--- END ---
INLINE (createSymbol) id{365,1} AS 1 AT <0:738>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:SymbolObject) id{365,2} ---
(flags, name) {
            this.flags = flags;
            this.name = name;
        }
--- END ---
INLINE (SymbolObject) id{365,2} AS 2 AT <1:62>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarMethod) id{366,0} ---
(node) {
            if (checkGrammarDisallowedModifiersOnObjectLiteralExpressionMethod(node) ||
                checkGrammarFunctionLikeDeclaration(node) ||
                checkGrammarForGenerator(node)) {
                return true;
            }
            if (node.parent.kind === 176 /* ObjectLiteralExpression */) {
                if (checkGrammarForInvalidQuestionMark(node.questionToken, ts.Diagnostics.An_object_member_cannot_be_declared_optional)) {
                    return true;
                }
                else if (node.body === undefined) {
                    return grammarErrorAtPos(ts.getSourceFileOfNode(node), node.end - 1, ";".length, ts.Diagnostics._0_expected, "{");
                }
            }
            if (ts.isClassLike(node.parent)) {
                // Technically, computed properties in ambient contexts is disallowed
                // for property declarations and accessors too, not just methods.
                // However, property declarations disallow computed names in general,
                // and accessors are not allowed in ambient contexts in general,
                // so this error only really matters for methods.
                if (ts.isInAmbientContext(node)) {
                    return checkGrammarForNonSymbolComputedProperty(node.name, ts.Diagnostics.A_computed_property_name_in_an_ambient_context_must_directly_refer_to_a_built_in_symbol);
                }
                else if (!node.body) {
                    return checkGrammarForNonSymbolComputedProperty(node.name, ts.Diagnostics.A_computed_property_name_in_a_method_overload_must_directly_refer_to_a_built_in_symbol);
                }
            }
            else if (node.parent.kind === 227 /* InterfaceDeclaration */) {
                return checkGrammarForNonSymbolComputedProperty(node.name, ts.Diagnostics.A_computed_property_name_in_an_interface_must_directly_refer_to_a_built_in_symbol);
            }
            else if (node.parent.kind === 161 /* TypeLiteral */) {
                return checkGrammarForNonSymbolComputedProperty(node.name, ts.Diagnostics.A_computed_property_name_in_a_type_literal_must_directly_refer_to_a_built_in_symbol);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarFunctionLikeDeclaration) id{366,1} ---
(node) {
            // Prevent cascading error by short-circuit
            var file = ts.getSourceFileOfNode(node);
            return checkGrammarDecorators(node) || checkGrammarModifiers(node) || checkGrammarTypeParameterList(node.typeParameters, file) ||
                checkGrammarParameterList(node.parameters) || checkGrammarArrowFunction(node, file);
        }
--- END ---
INLINE (checkGrammarFunctionLikeDeclaration) id{366,1} AS 1 AT <0:113>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarTypeParameterList) id{366,2} ---
(typeParameters, file) {
            if (checkGrammarForDisallowedTrailingComma(typeParameters)) {
                return true;
            }
            if (typeParameters && typeParameters.length === 0) {
                var start = typeParameters.pos - "<".length;
                var end = ts.skipTrivia(file.text, typeParameters.end) + ">".length;
                return grammarErrorAtPos(file, start, end - start, ts.Diagnostics.Type_parameter_list_cannot_be_empty);
            }
        }
--- END ---
INLINE (checkGrammarTypeParameterList) id{366,2} AS 2 AT <1:200>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarForDisallowedTrailingComma) id{366,3} ---
(list) {
            if (list && list.hasTrailingComma) {
                var start = list.end - ",".length;
                var end = list.end;
                var sourceFile = ts.getSourceFileOfNode(list[0]);
                return grammarErrorAtPos(sourceFile, start, end - start, ts.Diagnostics.Trailing_comma_not_allowed);
            }
        }
--- END ---
INLINE (checkGrammarForDisallowedTrailingComma) id{366,3} AS 3 AT <2:41>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarForNonSymbolComputedProperty) id{366,4} ---
(node, message) {
            if (ts.isDynamicName(node)) {
                return grammarErrorOnNode(node, message);
            }
        }
--- END ---
INLINE (checkGrammarForNonSymbolComputedProperty) id{366,4} AS 4 AT <0:1788>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkTypeNameIsReserved) id{367,0} ---
(name, message) {
            // TS 1.0 spec (April 2014): 3.6.1
            // The predefined type keywords are reserved and cannot be used as names of user defined types.
            switch (name.text) {
                case "any":
                case "number":
                case "boolean":
                case "string":
                case "symbol":
                case "void":
                    error(name, message, name.text);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkSignatureDeclaration) id{368,0} ---
(node) {
            // Grammar checking
            if (node.kind === 155 /* IndexSignature */) {
                checkGrammarIndexSignature(node);
            }
            else if (node.kind === 158 /* FunctionType */ || node.kind === 225 /* FunctionDeclaration */ || node.kind === 159 /* ConstructorType */ ||
                node.kind === 153 /* CallSignature */ || node.kind === 150 /* Constructor */ ||
                node.kind === 154 /* ConstructSignature */) {
                checkGrammarFunctionLikeDeclaration(node);
            }
            if (ts.isAsyncFunctionLike(node) && languageVersion < 4 /* ES2017 */) {
                checkExternalEmitHelpers(node, 64 /* Awaiter */);
                if (languageVersion < 2 /* ES2015 */) {
                    checkExternalEmitHelpers(node, 128 /* Generator */);
                }
            }
            checkTypeParameters(node.typeParameters);
            ts.forEach(node.parameters, checkParameter);
            if (node.type) {
                checkSourceElement(node.type);
            }
            if (produceDiagnostics) {
                checkCollisionWithArgumentsInGeneratedCode(node);
                if (compilerOptions.noImplicitAny && !node.type) {
                    switch (node.kind) {
                        case 154 /* ConstructSignature */:
                            error(node, ts.Diagnostics.Construct_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type);
                            break;
                        case 153 /* CallSignature */:
                            error(node, ts.Diagnostics.Call_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type);
                            break;
                    }
                }
                if (node.type) {
                    if (languageVersion >= 2 /* ES2015 */ && isSyntacticallyValidGenerator(node)) {
                        var returnType = getTypeFromTypeNode(node.type);
                        if (returnType === voidType) {
                            error(node.type, ts.Diagnostics.A_generator_cannot_have_a_void_type_annotation);
                        }
                        else {
                            var generatorElementType = getElementTypeOfIterableIterator(returnType) || anyType;
                            var iterableIteratorInstantiation = createIterableIteratorType(generatorElementType);
                            // Naively, one could check that IterableIterator<any> is assignable to the return type annotation.
                            // However, that would not catch the error in the following case.
                            //
                            //    interface BadGenerator extends Iterable<number>, Iterator<string> { }
                            //    function* g(): BadGenerator { } // Iterable and Iterator have different types!
                            //
                            checkTypeAssignableTo(iterableIteratorInstantiation, returnType, node.type);
                        }
                    }
                    else if (ts.isAsyncFunctionLike(node)) {
                        checkAsyncFunctionReturnType(node);
                    }
                }
                if (noUnusedIdentifiers && !node.body) {
                    checkUnusedTypeParameters(node);
                }
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarIndexSignature) id{368,1} ---
(node) {
            // Prevent cascading error by short-circuit
            return checkGrammarDecorators(node) || checkGrammarModifiers(node) || checkGrammarIndexSignatureParameters(node);
        }
--- END ---
INLINE (checkGrammarIndexSignature) id{368,1} AS 1 AT <0:115>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarFunctionLikeDeclaration) id{368,2} ---
(node) {
            // Prevent cascading error by short-circuit
            var file = ts.getSourceFileOfNode(node);
            return checkGrammarDecorators(node) || checkGrammarModifiers(node) || checkGrammarTypeParameterList(node.typeParameters, file) ||
                checkGrammarParameterList(node.parameters) || checkGrammarArrowFunction(node, file);
        }
--- END ---
INLINE (checkGrammarFunctionLikeDeclaration) id{368,2} AS 2 AT <0:488>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarTypeParameterList) id{368,3} ---
(typeParameters, file) {
            if (checkGrammarForDisallowedTrailingComma(typeParameters)) {
                return true;
            }
            if (typeParameters && typeParameters.length === 0) {
                var start = typeParameters.pos - "<".length;
                var end = ts.skipTrivia(file.text, typeParameters.end) + ">".length;
                return grammarErrorAtPos(file, start, end - start, ts.Diagnostics.Type_parameter_list_cannot_be_empty);
            }
        }
--- END ---
INLINE (checkGrammarTypeParameterList) id{368,3} AS 3 AT <2:200>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarForDisallowedTrailingComma) id{368,4} ---
(list) {
            if (list && list.hasTrailingComma) {
                var start = list.end - ",".length;
                var end = list.end;
                var sourceFile = ts.getSourceFileOfNode(list[0]);
                return grammarErrorAtPos(sourceFile, start, end - start, ts.Diagnostics.Trailing_comma_not_allowed);
            }
        }
--- END ---
INLINE (checkGrammarForDisallowedTrailingComma) id{368,4} AS 4 AT <3:41>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkCollisionWithArgumentsInGeneratedCode) id{368,5} ---
(node) {
            // no rest parameters \x5c declaration context \x5c overload - no codegen impact
            if (!ts.hasDeclaredRestParameter(node) || ts.isInAmbientContext(node) || ts.nodeIsMissing(node.body)) {
                return;
            }
            ts.forEach(node.parameters, function (p) {
                if (p.name && !ts.isBindingPattern(p.name) && p.name.text === argumentsSymbol.name) {
                    error(p, ts.Diagnostics.Duplicate_identifier_arguments_Compiler_uses_arguments_to_initialize_rest_parameters);
                }
            });
        }
--- END ---
INLINE (checkCollisionWithArgumentsInGeneratedCode) id{368,5} AS 5 AT <0:1111>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkTypeReferenceNode) id{369,0} ---
(node) {
            checkGrammarTypeArguments(node, node.typeArguments);
            var type = getTypeFromTypeReference(node);
            if (type !== unknownType) {
                if (node.typeArguments) {
                    // Do type argument local checks only if referenced type is successfully resolved
                    ts.forEach(node.typeArguments, checkSourceElement);
                    if (produceDiagnostics) {
                        var symbol = getNodeLinks(node).resolvedSymbol;
                        var typeParameters = symbol.flags & 524288 /* TypeAlias */ ? getSymbolLinks(symbol).typeParameters : type.target.localTypeParameters;
                        checkTypeArgumentConstraints(typeParameters, node.typeArguments);
                    }
                }
                if (type.flags & 16 /* Enum */ && !type.memberTypes && getNodeLinks(node).resolvedSymbol.flags & 8 /* EnumMember */) {
                    error(node, ts.Diagnostics.Enum_type_0_has_members_with_initializers_that_are_not_literals, typeToString(type));
                }
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarTypeArguments) id{369,1} ---
(node, typeArguments) {
            return checkGrammarForDisallowedTrailingComma(typeArguments) ||
                checkGrammarForAtLeastOneTypeArgument(node, typeArguments);
        }
--- END ---
INLINE (checkGrammarTypeArguments) id{369,1} AS 1 AT <0:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarForDisallowedTrailingComma) id{369,2} ---
(list) {
            if (list && list.hasTrailingComma) {
                var start = list.end - ",".length;
                var end = list.end;
                var sourceFile = ts.getSourceFileOfNode(list[0]);
                return grammarErrorAtPos(sourceFile, start, end - start, ts.Diagnostics.Trailing_comma_not_allowed);
            }
        }
--- END ---
INLINE (checkGrammarForDisallowedTrailingComma) id{369,2} AS 2 AT <1:43>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarForAtLeastOneTypeArgument) id{369,3} ---
(node, typeArguments) {
            if (typeArguments && typeArguments.length === 0) {
                var sourceFile = ts.getSourceFileOfNode(node);
                var start = typeArguments.pos - "<".length;
                var end = ts.skipTrivia(sourceFile.text, typeArguments.end) + ">".length;
                return grammarErrorAtPos(sourceFile, start, end - start, ts.Diagnostics.Type_argument_list_cannot_be_empty);
            }
        }
--- END ---
INLINE (checkGrammarForAtLeastOneTypeArgument) id{369,3} AS 3 AT <1:116>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeLinks) id{369,4} ---
(node) {
            var nodeId = getNodeId(node);
            return nodeLinks[nodeId] || (nodeLinks[nodeId] = { flags: 0 });
        }
--- END ---
INLINE (getNodeLinks) id{369,4} AS 4 AT <0:468>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeId) id{369,5} ---
(node) {
        if (!node.id) {
            node.id = nextNodeId;
            nextNodeId++;
        }
        return node.id;
    }
--- END ---
INLINE (getNodeId) id{369,5} AS 5 AT <4:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{369,6} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{369,6} AS 6 AT <0:588>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{369,7} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{369,7} AS 7 AT <6:120>
[deoptimizing (DEOPT eager): begin 0xd6230dc82c9 <JS Function isAmbientModule (SharedFunctionInfo 0x3504a53cd0d9)> (opt #275) @4, FP to SP delta: 24, caller sp: 0x7fff5fbfdf38]
            ;;; deoptimize at 0_94: wrong map
  reading input frame isAmbientModule => node=9, args=2, height=2; inputs:
      0: 0xd6230dc82c9 ; [fp - 16] 0xd6230dc82c9 <JS Function isAmbientModule (SharedFunctionInfo 0x3504a53cd0d9)>
      1: 0x16f3adb61821 ; [fp + 24] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x286514cff711 ; rbx 0x286514cff711 <a NodeObject with map 0x33abe2a71231>
      3: 0xd6230db34c9 ; [fp - 24] 0xd6230db34c9 <FixedArray[156]>
      4: 0x30bcea4043b1 ; rax 0x30bcea4043b1 <true>
  translating frame isAmbientModule => node=9, height=8
    0x7fff5fbfdf30: [top + 48] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfdf28: [top + 40] <- 0x286514cff711 ;  0x286514cff711 <a NodeObject with map 0x33abe2a71231>  (input #2)
    0x7fff5fbfdf20: [top + 32] <- 0x2c21d26850c3 ;  caller's pc
    0x7fff5fbfdf18: [top + 24] <- 0x7fff5fbfdfa8 ;  caller's fp
    0x7fff5fbfdf10: [top + 16] <- 0xd6230db34c9 ;  context    0xd6230db34c9 <FixedArray[156]>  (input #3)
    0x7fff5fbfdf08: [top + 8] <- 0xd6230dc82c9 ;  function    0xd6230dc82c9 <JS Function isAmbientModule (SharedFunctionInfo 0x3504a53cd0d9)>  (input #0)
    0x7fff5fbfdf00: [top + 0] <- 0x30bcea4043b1 ;  0x30bcea4043b1 <true>  (input #4)
[deoptimizing (eager): end 0xd6230dc82c9 <JS Function isAmbientModule (SharedFunctionInfo 0x3504a53cd0d9)> @4 => node=9, pc=0x2c21d24ea867, caller sp=0x7fff5fbfdf38, state=TOS_REGISTER, took 0.055 ms]
[deoptimizing (DEOPT eager): begin 0x29cc38d267c1 <JS Function getEffectiveDeclarationFlags (SharedFunctionInfo 0x1b98fbc0b641)> (opt #350) @4, FP to SP delta: 48, caller sp: 0x7fff5fbfdbb0]
            ;;; deoptimize at 0_260: wrong map
  reading input frame getEffectiveDeclarationFlags => node=18, args=3, height=3; inputs:
      0: 0x29cc38d267c1 ; [fp - 16] 0x29cc38d267c1 <JS Function getEffectiveDeclarationFlags (SharedFunctionInfo 0x1b98fbc0b641)>
      1: 0x1f9f6c0532e1 ; [fp + 32] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x33c6803da241 ; rbx 0x33c6803da241 <a NodeObject with map 0x33abe2a71289>
      3: 0x20100000000 ; [fp + 16] 513
      4: 0x29cc38d04261 ; [fp - 24] 0x29cc38d04261 <FixedArray[1022]>
      5: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
      6: 0x00000000 ; rax 0
  translating frame getEffectiveDeclarationFlags => node=18, height=16
    0x7fff5fbfdba8: [top + 64] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdba0: [top + 56] <- 0x33c6803da241 ;  0x33c6803da241 <a NodeObject with map 0x33abe2a71289>  (input #2)
    0x7fff5fbfdb98: [top + 48] <- 0x20100000000 ;  513  (input #3)
    0x7fff5fbfdb90: [top + 40] <- 0x2c21d25f9901 ;  caller's pc
    0x7fff5fbfdb88: [top + 32] <- 0x7fff5fbfdc38 ;  caller's fp
    0x7fff5fbfdb80: [top + 24] <- 0x29cc38d04261 ;  context    0x29cc38d04261 <FixedArray[1022]>  (input #4)
    0x7fff5fbfdb78: [top + 16] <- 0x29cc38d267c1 ;  function    0x29cc38d267c1 <JS Function getEffectiveDeclarationFlags (SharedFunctionInfo 0x1b98fbc0b641)>  (input #0)
    0x7fff5fbfdb70: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfdb68: [top + 0] <- 0x00000000 ;  0  (input #6)
[deoptimizing (eager): end 0x29cc38d267c1 <JS Function getEffectiveDeclarationFlags (SharedFunctionInfo 0x1b98fbc0b641)> @4 => node=18, pc=0x2c21d26071e7, caller sp=0x7fff5fbfdbb0, state=TOS_REGISTER, took 0.053 ms]
[deoptimizing (DEOPT eager): begin 0xd6230dccac1 <JS Function getInterfaceBaseTypeNodes (SharedFunctionInfo 0x3504a53d1bd9)> (opt #326) @2, FP to SP delta: 24, caller sp: 0x7fff5fbfdac8]
            ;;; deoptimize at 0_60: wrong map
  reading input frame getInterfaceBaseTypeNodes => node=4, args=2, height=2; inputs:
      0: 0xd6230dccac1 ; [fp - 16] 0xd6230dccac1 <JS Function getInterfaceBaseTypeNodes (SharedFunctionInfo 0x3504a53d1bd9)>
      1: 0x16f3adb61821 ; [fp + 24] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x33c6803da241 ; rdx 0x33c6803da241 <a NodeObject with map 0x33abe2a71289>
      3: 0xd6230db34c9 ; rax 0xd6230db34c9 <FixedArray[156]>
      4: 0x30bcea404311 ; (literal 3) 0x30bcea404311 <undefined>
  translating frame getInterfaceBaseTypeNodes => node=4, height=8
    0x7fff5fbfdac0: [top + 48] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfdab8: [top + 40] <- 0x33c6803da241 ;  0x33c6803da241 <a NodeObject with map 0x33abe2a71289>  (input #2)
    0x7fff5fbfdab0: [top + 32] <- 0x2c21d25e8cfe ;  caller's pc
    0x7fff5fbfdaa8: [top + 24] <- 0x7fff5fbfdb20 ;  caller's fp
    0x7fff5fbfdaa0: [top + 16] <- 0xd6230db34c9 ;  context    0xd6230db34c9 <FixedArray[156]>  (input #3)
    0x7fff5fbfda98: [top + 8] <- 0xd6230dccac1 ;  function    0xd6230dccac1 <JS Function getInterfaceBaseTypeNodes (SharedFunctionInfo 0x3504a53d1bd9)>  (input #0)
    0x7fff5fbfda90: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
[deoptimizing (eager): end 0xd6230dccac1 <JS Function getInterfaceBaseTypeNodes (SharedFunctionInfo 0x3504a53d1bd9)> @2 => node=4, pc=0x2c21d25e916a, caller sp=0x7fff5fbfdac8, state=NO_REGISTERS, took 0.057 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexTypeOfType) id{370,0} ---
(type, kind) {
            return getIndexTypeOfStructuredType(getApparentType(type), kind);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getApparentType) id{370,1} ---
(type) {
            var t = type.flags & 540672 /* TypeVariable */ ? getApparentTypeOfTypeVariable(type) : type;
            return t.flags & 262178 /* StringLike */ ? globalStringType :
                t.flags & 340 /* NumberLike */ ? globalNumberType :
                    t.flags & 136 /* BooleanLike */ ? globalBooleanType :
                        t.flags & 512 /* ESSymbol */ ? getGlobalESSymbolType() :
                            t;
        }
--- END ---
INLINE (getApparentType) id{370,1} AS 1 AT <0:63>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexTypeOfStructuredType) id{370,2} ---
(type, kind) {
            var info = getIndexInfoOfStructuredType(type, kind);
            return info && info.type;
        }
--- END ---
INLINE (getIndexTypeOfStructuredType) id{370,2} AS 2 AT <0:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexInfoOfStructuredType) id{370,3} ---
(type, kind) {
            if (type.flags & 229376 /* StructuredType */) {
                var resolved = resolveStructuredTypeMembers(type);
                return kind === 0 /* String */ ? resolved.stringIndexInfo : resolved.numberIndexInfo;
            }
        }
--- END ---
INLINE (getIndexInfoOfStructuredType) id{370,3} AS 3 AT <2:38>
[deoptimizing (DEOPT eager): begin 0xd6230dc8869 <JS Function isClassLike (SharedFunctionInfo 0x3504a53cebd9)> (opt #301) @3, FP to SP delta: 24, caller sp: 0x7fff5fbfdab8]
  reading input frame isClassLike => node=4, args=2, height=1; inputs:
      0: 0xd6230dc8869 ; [fp - 16] 0xd6230dc8869 <JS Function isClassLike (SharedFunctionInfo 0x3504a53cebd9)>
      1: 0x16f3adb61821 ; [fp + 24] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x33c6803da241 ; rax 0x33c6803da241 <a NodeObject with map 0x33abe2a71289>
      3: 0xd6230db34c9 ; [fp - 24] 0xd6230db34c9 <FixedArray[156]>
  translating frame isClassLike => node=4, height=0
    0x7fff5fbfdab0: [top + 40] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfdaa8: [top + 32] <- 0x33c6803da241 ;  0x33c6803da241 <a NodeObject with map 0x33abe2a71289>  (input #2)
    0x7fff5fbfdaa0: [top + 24] <- 0x2c21d261091d ;  caller's pc
    0x7fff5fbfda98: [top + 16] <- 0x7fff5fbfdad0 ;  caller's fp
    0x7fff5fbfda90: [top + 8] <- 0xd6230db34c9 ;  context    0xd6230db34c9 <FixedArray[156]>  (input #3)
    0x7fff5fbfda88: [top + 0] <- 0xd6230dc8869 ;  function    0xd6230dc8869 <JS Function isClassLike (SharedFunctionInfo 0x3504a53cebd9)>  (input #0)
[deoptimizing (eager): end 0xd6230dc8869 <JS Function isClassLike (SharedFunctionInfo 0x3504a53cebd9)> @3 => node=4, pc=0x2c21d2610fc6, caller sp=0x7fff5fbfdab8, state=NO_REGISTERS, took 0.050 ms]
[deoptimizing (DEOPT eager): begin 0xd6230dcd659 <JS Function getCombinedModifierFlags (SharedFunctionInfo 0x3504a53df381)> (opt #267) @12, FP to SP delta: 88, caller sp: 0x7fff5fbfdb68]
            ;;; deoptimize at 0_193: wrong map
  reading input frame getCombinedModifierFlags => node=56, args=2, height=2; inputs:
      0: 0xd6230dcd659 ; [fp - 16] 0xd6230dcd659 <JS Function getCombinedModifierFlags (SharedFunctionInfo 0x3504a53df381)>
      1: 0x16f3adb61821 ; [fp + 24] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0xe0c907ff401 ; rax 0xe0c907ff401 <a NodeObject with map 0x33abe2a71339>
      3: 0xd6230dd73d1 ; [fp - 24] 0xd6230dd73d1 <FixedArray[11]>
      4: 0x00000000 ; [fp - 64] 0
  translating frame getCombinedModifierFlags => node=56, height=8
    0x7fff5fbfdb60: [top + 48] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfdb58: [top + 40] <- 0xe0c907ff401 ;  0xe0c907ff401 <a NodeObject with map 0x33abe2a71339>  (input #2)
    0x7fff5fbfdb50: [top + 32] <- 0x2c21d26071df ;  caller's pc
    0x7fff5fbfdb48: [top + 24] <- 0x7fff5fbfdb88 ;  caller's fp
    0x7fff5fbfdb40: [top + 16] <- 0xd6230dd73d1 ;  context    0xd6230dd73d1 <FixedArray[11]>  (input #3)
    0x7fff5fbfdb38: [top + 8] <- 0xd6230dcd659 ;  function    0xd6230dcd659 <JS Function getCombinedModifierFlags (SharedFunctionInfo 0x3504a53df381)>  (input #0)
    0x7fff5fbfdb30: [top + 0] <- 0x00000000 ;  0  (input #4)
[deoptimizing (eager): end 0xd6230dcd659 <JS Function getCombinedModifierFlags (SharedFunctionInfo 0x3504a53df381)> @12 => node=56, pc=0x2c21d2573387, caller sp=0x7fff5fbfdb68, state=NO_REGISTERS, took 0.086 ms]
[deoptimizing (DEOPT eager): begin 0x29cc38d29ca1 <JS Function checkGrammarMethod (SharedFunctionInfo 0x1b98fbc14a11)> (opt #366) @32, FP to SP delta: 96, caller sp: 0x7fff5fbfdab0]
            ;;; deoptimize at 0_278: wrong map
  reading input frame checkGrammarMethod => node=7, args=2, height=1; inputs:
      0: 0x29cc38d29ca1 ; [fp - 16] 0x29cc38d29ca1 <JS Function checkGrammarMethod (SharedFunctionInfo 0x1b98fbc14a11)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0xe0c907c6a91 ; rax 0xe0c907c6a91 <a NodeObject with map 0x33abe2a70159>
      3: 0x29cc38d04261 ; [fp - 24] 0x29cc38d04261 <FixedArray[1022]>
  translating frame checkGrammarMethod => node=7, height=0
    0x7fff5fbfdaa8: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdaa0: [top + 32] <- 0xe0c907c6a91 ;  0xe0c907c6a91 <a NodeObject with map 0x33abe2a70159>  (input #2)
    0x7fff5fbfda98: [top + 24] <- 0x2c21d267396f ;  caller's pc
    0x7fff5fbfda90: [top + 16] <- 0x7fff5fbfdad0 ;  caller's fp
    0x7fff5fbfda88: [top + 8] <- 0x29cc38d04261 ;  context    0x29cc38d04261 <FixedArray[1022]>  (input #3)
    0x7fff5fbfda80: [top + 0] <- 0x29cc38d29ca1 ;  function    0x29cc38d29ca1 <JS Function checkGrammarMethod (SharedFunctionInfo 0x1b98fbc14a11)>  (input #0)
[deoptimizing (eager): end 0x29cc38d29ca1 <JS Function checkGrammarMethod (SharedFunctionInfo 0x1b98fbc14a11)> @32 => node=7, pc=0x2c21d2611982, caller sp=0x7fff5fbfdab0, state=NO_REGISTERS, took 0.074 ms]
[deoptimizing (DEOPT eager): begin 0x29cc38d1b139 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)> (opt #341) @49, FP to SP delta: 272, caller sp: 0x7fff5fbfd718]
            ;;; deoptimize at 0_8539: wrong map
  reading input frame resolveName => node=1120, args=6, height=17; inputs:
      0: 0x29cc38d1b139 ; [fp - 16] 0x29cc38d1b139 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)>
      1: 0x1f9f6c0532e1 ; [fp + 56] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x33c6803da341 ; rbx 0x33c6803da341 <a NodeObject with map 0x33abe2a71289>
      3: 0x286514cf0699 ; [fp + 40] 0x286514cf0699 <String[23]: ResolvedCollatorOptions>
      4: 0xc19e800000000 ; [fp + 32] 793064
      5: 0xd6230ded3a9 ; [fp + 24] 0xd6230ded3a9 <an Object with map 0x33abe2a3df61>
      6: 0x215b0af2be01 ; [fp + 16] 0x215b0af2be01 <an IdentifierObject with map 0x33abe2a6fb81>
      7: 0x29cc38d04261 ; [fp - 24] 0x29cc38d04261 <FixedArray[1022]>
      8: 0x30bcea4069a9 ; (literal 12) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      9: 0x30bcea404311 ; rax 0x30bcea404311 <undefined>
     10: 0x30bcea4069a9 ; (literal 12) 0x30bcea4069a9 <Odd Oddball: optimized_out>
     11: 0x30bcea404311 ; [fp - 40] 0x30bcea404311 <undefined>
     12: 0x215b0af2be01 ; [fp + 48] 0x215b0af2be01 <an IdentifierObject with map 0x33abe2a6fb81>
     13: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     14: 0x30bcea404421 ; [fp - 32] 0x30bcea404421 <false>
     15: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     16: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     17: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     18: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     19: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     20: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     21: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     22: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     23: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
  translating frame resolveName => node=1120, height=128
    0x7fff5fbfd710: [top + 200] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd708: [top + 192] <- 0x33c6803da341 ;  0x33c6803da341 <a NodeObject with map 0x33abe2a71289>  (input #2)
    0x7fff5fbfd700: [top + 184] <- 0x286514cf0699 ;  0x286514cf0699 <String[23]: ResolvedCollatorOptions>  (input #3)
    0x7fff5fbfd6f8: [top + 176] <- 0xc19e800000000 ;  793064  (input #4)
    0x7fff5fbfd6f0: [top + 168] <- 0xd6230ded3a9 ;  0xd6230ded3a9 <an Object with map 0x33abe2a3df61>  (input #5)
    0x7fff5fbfd6e8: [top + 160] <- 0x215b0af2be01 ;  0x215b0af2be01 <an IdentifierObject with map 0x33abe2a6fb81>  (input #6)
    0x7fff5fbfd6e0: [top + 152] <- 0x2c21d26712a4 ;  caller's pc
    0x7fff5fbfd6d8: [top + 144] <- 0x7fff5fbfd748 ;  caller's fp
    0x7fff5fbfd6d0: [top + 136] <- 0x29cc38d04261 ;  context    0x29cc38d04261 <FixedArray[1022]>  (input #7)
    0x7fff5fbfd6c8: [top + 128] <- 0x29cc38d1b139 ;  function    0x29cc38d1b139 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)>  (input #0)
    0x7fff5fbfd6c0: [top + 120] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #8)
    0x7fff5fbfd6b8: [top + 112] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
    0x7fff5fbfd6b0: [top + 104] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #10)
    0x7fff5fbfd6a8: [top + 96] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #11)
    0x7fff5fbfd6a0: [top + 88] <- 0x215b0af2be01 ;  0x215b0af2be01 <an IdentifierObject with map 0x33abe2a6fb81>  (input #12)
    0x7fff5fbfd698: [top + 80] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #13)
    0x7fff5fbfd690: [top + 72] <- 0x30bcea404421 ;  0x30bcea404421 <false>  (input #14)
    0x7fff5fbfd688: [top + 64] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #15)
    0x7fff5fbfd680: [top + 56] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #16)
    0x7fff5fbfd678: [top + 48] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #17)
    0x7fff5fbfd670: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #18)
    0x7fff5fbfd668: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #19)
    0x7fff5fbfd660: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #20)
    0x7fff5fbfd658: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #21)
    0x7fff5fbfd650: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #22)
    0x7fff5fbfd648: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #23)
[deoptimizing (eager): end 0x29cc38d1b139 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)> @49 => node=1120, pc=0x2c21d25e5a44, caller sp=0x7fff5fbfd718, state=NO_REGISTERS, took 0.231 ms]
[deoptimizing (DEOPT soft): begin 0x29cc38d1b0a9 <JS Function getSymbol (SharedFunctionInfo 0x2e2f693e7951)> (opt #325) @12, FP to SP delta: 40, caller sp: 0x7fff5fbfd640]
            ;;; deoptimize at 0_407: Insufficient type feedback for generic named access
  reading input frame getSymbol => node=96, args=4, height=3; inputs:
      0: 0x29cc38d1b0a9 ; [fp - 16] 0x29cc38d1b0a9 <JS Function getSymbol (SharedFunctionInfo 0x2e2f693e7951)>
      1: 0x1f9f6c0532e1 ; [fp + 40] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x29cc38ddddc1 ; [fp + 32] 0x29cc38ddddc1 <an Object with map 0x33abe2a3d1a1>
      3: 0x286514cf0699 ; [fp + 24] 0x286514cf0699 <String[23]: ResolvedCollatorOptions>
      4: 0xc19e800000000 ; [fp + 16] 793064
      5: 0x29cc38d04261 ; [fp - 24] 0x29cc38d04261 <FixedArray[1022]>
      6: 0x29cc38ddf691 ; [fp - 32] 0x29cc38ddf691 <a SymbolObject with map 0x33abe2a71181>
      7: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
  translating frame getSymbol => node=96, height=16
    0x7fff5fbfd638: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd630: [top + 64] <- 0x29cc38ddddc1 ;  0x29cc38ddddc1 <an Object with map 0x33abe2a3d1a1>  (input #2)
    0x7fff5fbfd628: [top + 56] <- 0x286514cf0699 ;  0x286514cf0699 <String[23]: ResolvedCollatorOptions>  (input #3)
    0x7fff5fbfd620: [top + 48] <- 0xc19e800000000 ;  793064  (input #4)
    0x7fff5fbfd618: [top + 40] <- 0x2c21d25e438b ;  caller's pc
    0x7fff5fbfd610: [top + 32] <- 0x7fff5fbfd6d8 ;  caller's fp
    0x7fff5fbfd608: [top + 24] <- 0x29cc38d04261 ;  context    0x29cc38d04261 <FixedArray[1022]>  (input #5)
    0x7fff5fbfd600: [top + 16] <- 0x29cc38d1b0a9 ;  function    0x29cc38d1b0a9 <JS Function getSymbol (SharedFunctionInfo 0x2e2f693e7951)>  (input #0)
    0x7fff5fbfd5f8: [top + 8] <- 0x29cc38ddf691 ;  0x29cc38ddf691 <a SymbolObject with map 0x33abe2a71181>  (input #6)
    0x7fff5fbfd5f0: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
[deoptimizing (soft): end 0x29cc38d1b0a9 <JS Function getSymbol (SharedFunctionInfo 0x2e2f693e7951)> @12 => node=96, pc=0x2c21d25e6c02, caller sp=0x7fff5fbfd640, state=NO_REGISTERS, took 0.110 ms]
[deoptimizing (DEOPT eager): begin 0x29cc38d261d9 <JS Function checkSignatureDeclaration (SharedFunctionInfo 0x1b98fbc0a681)> (opt #368) @6, FP to SP delta: 120, caller sp: 0x7fff5fbfd808]
            ;;; deoptimize at 0_334: wrong map
  reading input frame checkSignatureDeclaration => node=60, args=2, height=5; inputs:
      0: 0x29cc38d261d9 ; [fp - 16] 0x29cc38d261d9 <JS Function checkSignatureDeclaration (SharedFunctionInfo 0x1b98fbc0a681)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x215b0af8b039 ; rax 0x215b0af8b039 <a NodeObject with map 0x33abe2a70681>
      3: 0x29cc38d04261 ; [fp - 24] 0x29cc38d04261 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 11) 0x30bcea404311 <undefined>
      5: 0x30bcea404311 ; (literal 11) 0x30bcea404311 <undefined>
      6: 0x30bcea404311 ; (literal 11) 0x30bcea404311 <undefined>
      7: 0x30bcea404311 ; (literal 11) 0x30bcea404311 <undefined>
  translating frame checkSignatureDeclaration => node=60, height=32
    0x7fff5fbfd800: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd7f8: [top + 64] <- 0x215b0af8b039 ;  0x215b0af8b039 <a NodeObject with map 0x33abe2a70681>  (input #2)
    0x7fff5fbfd7f0: [top + 56] <- 0x2c21d266ee15 ;  caller's pc
    0x7fff5fbfd7e8: [top + 48] <- 0x7fff5fbfd8b8 ;  caller's fp
    0x7fff5fbfd7e0: [top + 40] <- 0x29cc38d04261 ;  context    0x29cc38d04261 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd7d8: [top + 32] <- 0x29cc38d261d9 ;  function    0x29cc38d261d9 <JS Function checkSignatureDeclaration (SharedFunctionInfo 0x1b98fbc0a681)>  (input #0)
    0x7fff5fbfd7d0: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfd7c8: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfd7c0: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfd7b8: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
[deoptimizing (eager): end 0x29cc38d261d9 <JS Function checkSignatureDeclaration (SharedFunctionInfo 0x1b98fbc0a681)> @6 => node=60, pc=0x2c21d25fcead, caller sp=0x7fff5fbfd808, state=NO_REGISTERS, took 0.095 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeFromClassOrInterfaceReference) id{371,0} ---
(node, symbol) {
            var type = getDeclaredTypeOfSymbol(getMergedSymbol(symbol));
            var typeParameters = type.localTypeParameters;
            if (typeParameters) {
                if (!node.typeArguments || node.typeArguments.length !== typeParameters.length) {
                    error(node, ts.Diagnostics.Generic_type_0_requires_1_type_argument_s, typeToString(type, /*enclosingDeclaration*/ undefined, 1 /* WriteArrayAsGenericType */), typeParameters.length);
                    return unknownType;
                }
                // In a type reference, the outer type parameters of the referenced class or interface are automatically
                // supplied as type arguments and the type reference only specifies arguments for the local type parameters
                // of the class or interface.
                return createTypeReference(type, ts.concatenate(type.outerTypeParameters, ts.map(node.typeArguments, getTypeFromTypeNode)));
            }
            if (node.typeArguments) {
                error(node, ts.Diagnostics.Type_0_is_not_generic, typeToString(type));
                return unknownType;
            }
            return type;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{371,1} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{371,1} AS 1 AT <0:64>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createTypeReference) id{371,2} ---
(target, typeArguments) {
            var id = getTypeListId(typeArguments);
            var type = target.instantiations[id];
            if (!type) {
                type = target.instantiations[id] = createObjectType(4 /* Reference */, target.symbol);
                type.flags |= typeArguments ? getPropagatingFlagsOfTypes(typeArguments, /*excludeKinds*/ 0) : 0;
                type.target = target;
                type.typeArguments = typeArguments;
            }
            return type;
        }
--- END ---
INLINE (createTypeReference) id{371,2} AS 2 AT <0:856>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createObjectType) id{371,3} ---
(objectFlags, symbol) {
            var type = createType(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol = symbol;
            return type;
        }
--- END ---
INLINE (createObjectType) id{371,3} AS 3 AT <2:203>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{371,4} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{371,4} AS 4 AT <3:47>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{371,5} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{371,5} AS 5 AT <4:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropagatingFlagsOfTypes) id{371,6} ---
(types, excludeKinds) {
            var result = 0;
            for (var _i = 0, types_3 = types; _i < types_3.length; _i++) {
                var type = types_3[_i];
                if (!(type.flags & excludeKinds)) {
                    result |= type.flags;
                }
            }
            return result & 14680064 /* PropagatingFlags */;
        }
--- END ---
INLINE (getPropagatingFlagsOfTypes) id{371,6} AS 6 AT <2:301>
[deoptimizing (DEOPT eager): begin 0x29cc38d1fa11 <JS Function getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode (SharedFunctionInfo 0x2e2f693f4bc1)> (opt #364) @18, FP to SP delta: 168, caller sp: 0x7fff5fbfd970]
            ;;; deoptimize at 3_32: wrong map
  reading input frame getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode => node=67, args=2, height=5; inputs:
      0: 0x29cc38d1fa11 ; [fp - 16] 0x29cc38d1fa11 <JS Function getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode (SharedFunctionInfo 0x2e2f693f4bc1)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x215b0af2be81 ; rdi 0x215b0af2be81 <a NodeObject with map 0x33abe2a75901>
      3: 0x29cc38d04261 ; rbx 0x29cc38d04261 <FixedArray[1022]>
      4: 0x11c99f65b2f1 ; rax 0x11c99f65b2f1 <an Object with map 0x33abe2a51889>
      5: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
      6: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
      7: 0x29cc38d1fa59 ; rcx 0x29cc38d1fa59 <JS Function getAliasSymbolForTypeNode (SharedFunctionInfo 0x2e2f693f4c81)>
  reading input frame getAliasSymbolForTypeNode => node=3, args=2, height=1; inputs:
      0: 0x29cc38d1fa59 ; (literal 25) 0x29cc38d1fa59 <JS Function getAliasSymbolForTypeNode (SharedFunctionInfo 0x2e2f693f4c81)>
      1: 0x1f9f6c0532e1 ; (literal 21) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x215b0af2be81 ; rdi 0x215b0af2be81 <a NodeObject with map 0x33abe2a75901>
      3: 0x29cc38d04261 ; (literal 22) 0x29cc38d04261 <FixedArray[1022]>
  translating frame getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode => node=67, height=32
    0x7fff5fbfd968: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd960: [top + 64] <- 0x215b0af2be81 ;  0x215b0af2be81 <a NodeObject with map 0x33abe2a75901>  (input #2)
    0x7fff5fbfd958: [top + 56] <- 0x2c21d2687b8c ;  caller's pc
    0x7fff5fbfd950: [top + 48] <- 0x7fff5fbfd990 ;  caller's fp
    0x7fff5fbfd948: [top + 40] <- 0x29cc38d04261 ;  context    0x29cc38d04261 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd940: [top + 32] <- 0x29cc38d1fa11 ;  function    0x29cc38d1fa11 <JS Function getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode (SharedFunctionInfo 0x2e2f693f4bc1)>  (input #0)
    0x7fff5fbfd938: [top + 24] <- 0x11c99f65b2f1 ;  0x11c99f65b2f1 <an Object with map 0x33abe2a51889>  (input #4)
    0x7fff5fbfd930: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfd928: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfd920: [top + 0] <- 0x29cc38d1fa59 ;  0x29cc38d1fa59 <JS Function getAliasSymbolForTypeNode (SharedFunctionInfo 0x2e2f693f4c81)>  (input #7)
  translating frame getAliasSymbolForTypeNode => node=3, height=0
    0x7fff5fbfd918: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd910: [top + 32] <- 0x215b0af2be81 ;  0x215b0af2be81 <a NodeObject with map 0x33abe2a75901>  (input #2)
    0x7fff5fbfd908: [top + 24] <- 0x2c21d261f902 ;  caller's pc
    0x7fff5fbfd900: [top + 16] <- 0x7fff5fbfd950 ;  caller's fp
    0x7fff5fbfd8f8: [top + 8] <- 0x29cc38d04261 ;  context    0x29cc38d04261 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd8f0: [top + 0] <- 0x29cc38d1fa59 ;  function    0x29cc38d1fa59 <JS Function getAliasSymbolForTypeNode (SharedFunctionInfo 0x2e2f693f4c81)>  (input #0)
[deoptimizing (eager): end 0x29cc38d1fa11 <JS Function getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode (SharedFunctionInfo 0x2e2f693f4bc1)> @18 => node=3, pc=0x2c21d26196c6, caller sp=0x7fff5fbfd970, state=NO_REGISTERS, took 0.109 ms]
[deoptimizing (DEOPT eager): begin 0x29cc38d1faa1 <JS Function getAliasTypeArgumentsForTypeNode (SharedFunctionInfo 0x2e2f693f4d41)> (opt #360) @3, FP to SP delta: 64, caller sp: 0x7fff5fbfd918]
            ;;; deoptimize at 1_32: wrong map
  reading input frame getAliasTypeArgumentsForTypeNode => node=20, args=2, height=3; inputs:
      0: 0x29cc38d1faa1 ; [fp - 16] 0x29cc38d1faa1 <JS Function getAliasTypeArgumentsForTypeNode (SharedFunctionInfo 0x2e2f693f4d41)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x215b0af2be81 ; rcx 0x215b0af2be81 <a NodeObject with map 0x33abe2a75901>
      3: 0x29cc38d04261 ; rax 0x29cc38d04261 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
      5: 0x29cc38d1fa59 ; rbx 0x29cc38d1fa59 <JS Function getAliasSymbolForTypeNode (SharedFunctionInfo 0x2e2f693f4c81)>
  reading input frame getAliasSymbolForTypeNode => node=3, args=2, height=1; inputs:
      0: 0x29cc38d1fa59 ; (literal 8) 0x29cc38d1fa59 <JS Function getAliasSymbolForTypeNode (SharedFunctionInfo 0x2e2f693f4c81)>
      1: 0x1f9f6c0532e1 ; (literal 9) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x215b0af2be81 ; rcx 0x215b0af2be81 <a NodeObject with map 0x33abe2a75901>
      3: 0x29cc38d04261 ; (literal 10) 0x29cc38d04261 <FixedArray[1022]>
  translating frame getAliasTypeArgumentsForTypeNode => node=20, height=16
    0x7fff5fbfd910: [top + 56] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd908: [top + 48] <- 0x215b0af2be81 ;  0x215b0af2be81 <a NodeObject with map 0x33abe2a75901>  (input #2)
    0x7fff5fbfd900: [top + 40] <- 0x2c21d261fa93 ;  caller's pc
    0x7fff5fbfd8f8: [top + 32] <- 0x7fff5fbfd950 ;  caller's fp
    0x7fff5fbfd8f0: [top + 24] <- 0x29cc38d04261 ;  context    0x29cc38d04261 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd8e8: [top + 16] <- 0x29cc38d1faa1 ;  function    0x29cc38d1faa1 <JS Function getAliasTypeArgumentsForTypeNode (SharedFunctionInfo 0x2e2f693f4d41)>  (input #0)
    0x7fff5fbfd8e0: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfd8d8: [top + 0] <- 0x29cc38d1fa59 ;  0x29cc38d1fa59 <JS Function getAliasSymbolForTypeNode (SharedFunctionInfo 0x2e2f693f4c81)>  (input #5)
  translating frame getAliasSymbolForTypeNode => node=3, height=0
    0x7fff5fbfd8d0: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd8c8: [top + 32] <- 0x215b0af2be81 ;  0x215b0af2be81 <a NodeObject with map 0x33abe2a75901>  (input #2)
    0x7fff5fbfd8c0: [top + 24] <- 0x2c21d261989c ;  caller's pc
    0x7fff5fbfd8b8: [top + 16] <- 0x7fff5fbfd8f8 ;  caller's fp
    0x7fff5fbfd8b0: [top + 8] <- 0x29cc38d04261 ;  context    0x29cc38d04261 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd8a8: [top + 0] <- 0x29cc38d1fa59 ;  function    0x29cc38d1fa59 <JS Function getAliasSymbolForTypeNode (SharedFunctionInfo 0x2e2f693f4c81)>  (input #0)
[deoptimizing (eager): end 0x29cc38d1faa1 <JS Function getAliasTypeArgumentsForTypeNode (SharedFunctionInfo 0x2e2f693f4d41)> @3 => node=3, pc=0x2c21d26196c6, caller sp=0x7fff5fbfd918, state=NO_REGISTERS, took 0.083 ms]
[deoptimizing (DEOPT eager): begin 0x29cc38d1e979 <JS Function getIndexSymbol (SharedFunctionInfo 0x2e2f693f1911)> (opt #322) @2, FP to SP delta: 24, caller sp: 0x7fff5fbfd888]
            ;;; deoptimize at 0_36: Unknown map in polymorphic access
  reading input frame getIndexSymbol => node=4, args=2, height=1; inputs:
      0: 0x29cc38d1e979 ; [fp - 16] 0x29cc38d1e979 <JS Function getIndexSymbol (SharedFunctionInfo 0x2e2f693f1911)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x29cc38de4b31 ; rax 0x29cc38de4b31 <a SymbolObject with map 0x33abe2a6fe99>
      3: 0x29cc38d04261 ; [fp - 24] 0x29cc38d04261 <FixedArray[1022]>
  translating frame getIndexSymbol => node=4, height=0
    0x7fff5fbfd880: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd878: [top + 32] <- 0x29cc38de4b31 ;  0x29cc38de4b31 <a SymbolObject with map 0x33abe2a6fe99>  (input #2)
    0x7fff5fbfd870: [top + 24] <- 0x2c21d260c96e ;  caller's pc
    0x7fff5fbfd868: [top + 16] <- 0x7fff5fbfd8d8 ;  caller's fp
    0x7fff5fbfd860: [top + 8] <- 0x29cc38d04261 ;  context    0x29cc38d04261 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd858: [top + 0] <- 0x29cc38d1e979 ;  function    0x29cc38d1e979 <JS Function getIndexSymbol (SharedFunctionInfo 0x2e2f693f1911)>  (input #0)
[deoptimizing (eager): end 0x29cc38d1e979 <JS Function getIndexSymbol (SharedFunctionInfo 0x2e2f693f1911)> @2 => node=4, pc=0x2c21d260cd26, caller sp=0x7fff5fbfd888, state=NO_REGISTERS, took 0.039 ms]
[deoptimizing (DEOPT eager): begin 0xd6230dcdb39 <JS Function isCatchClauseVariableDeclarationOrBindingElement (SharedFunctionInfo 0x3504a53cd019)> (opt #311) @7, FP to SP delta: 40, caller sp: 0x7fff5fbfda00]
            ;;; deoptimize at 0_134: wrong map
  reading input frame isCatchClauseVariableDeclarationOrBindingElement => node=34, args=2, height=3; inputs:
      0: 0xd6230dcdb39 ; [fp - 16] 0xd6230dcdb39 <JS Function isCatchClauseVariableDeclarationOrBindingElement (SharedFunctionInfo 0x3504a53cd019)>
      1: 0x16f3adb61821 ; [fp + 24] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0xe0c907ff401 ; [fp + 16] 0xe0c907ff401 <a NodeObject with map 0x33abe2a71339>
      3: 0xd6230db34c9 ; [fp - 24] 0xd6230db34c9 <FixedArray[156]>
      4: 0xe0c907ff401 ; rbx 0xe0c907ff401 <a NodeObject with map 0x33abe2a71339>
      5: 0x30bcea4043b1 ; rax 0x30bcea4043b1 <true>
  translating frame isCatchClauseVariableDeclarationOrBindingElement => node=34, height=16
    0x7fff5fbfd9f8: [top + 56] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfd9f0: [top + 48] <- 0xe0c907ff401 ;  0xe0c907ff401 <a NodeObject with map 0x33abe2a71339>  (input #2)
    0x7fff5fbfd9e8: [top + 40] <- 0x2c21d266bb03 ;  caller's pc
    0x7fff5fbfd9e0: [top + 32] <- 0x7fff5fbfda50 ;  caller's fp
    0x7fff5fbfd9d8: [top + 24] <- 0xd6230db34c9 ;  context    0xd6230db34c9 <FixedArray[156]>  (input #3)
    0x7fff5fbfd9d0: [top + 16] <- 0xd6230dcdb39 ;  function    0xd6230dcdb39 <JS Function isCatchClauseVariableDeclarationOrBindingElement (SharedFunctionInfo 0x3504a53cd019)>  (input #0)
    0x7fff5fbfd9c8: [top + 8] <- 0xe0c907ff401 ;  0xe0c907ff401 <a NodeObject with map 0x33abe2a71339>  (input #4)
    0x7fff5fbfd9c0: [top + 0] <- 0x30bcea4043b1 ;  0x30bcea4043b1 <true>  (input #5)
[deoptimizing (eager): end 0xd6230dcdb39 <JS Function isCatchClauseVariableDeclarationOrBindingElement (SharedFunctionInfo 0x3504a53cd019)> @7 => node=34, pc=0x2c21d2573b1d, caller sp=0x7fff5fbfda00, state=TOS_REGISTER, took 0.061 ms]
[deoptimizing (DEOPT eager): begin 0xd6230dc62e1 <JS Function isParameterDeclaration (SharedFunctionInfo 0x3504a53d2899)> (opt #240) @3, FP to SP delta: 24, caller sp: 0x7fff5fbfda18]
  reading input frame isParameterDeclaration => node=20, args=2, height=3; inputs:
      0: 0xd6230dc62e1 ; [fp - 16] 0xd6230dc62e1 <JS Function isParameterDeclaration (SharedFunctionInfo 0x3504a53d2899)>
      1: 0x16f3adb61821 ; [fp + 24] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0xe0c907ff401 ; [fp + 16] 0xe0c907ff401 <a NodeObject with map 0x33abe2a71339>
      3: 0xd6230db34c9 ; rax 0xd6230db34c9 <FixedArray[156]>
      4: 0x30bcea404311 ; (literal 3) 0x30bcea404311 <undefined>
      5: 0xd6230dccc29 ; rbx 0xd6230dccc29 <JS Function getRootDeclaration (SharedFunctionInfo 0x3504a53d2959)>
  reading input frame getRootDeclaration => node=5, args=2, height=1; inputs:
      0: 0xd6230dccc29 ; (literal 4) 0xd6230dccc29 <JS Function getRootDeclaration (SharedFunctionInfo 0x3504a53d2959)>
      1: 0x1f9f6c0532e1 ; (literal 5) 0x1f9f6c0532e1 <JS Global Object>
      2: 0xe0c907ff401 ; rdx 0xe0c907ff401 <a NodeObject with map 0x33abe2a71339>
      3: 0xd6230db34c9 ; (literal 6) 0xd6230db34c9 <FixedArray[156]>
  translating frame isParameterDeclaration => node=20, height=16
    0x7fff5fbfda10: [top + 56] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfda08: [top + 48] <- 0xe0c907ff401 ;  0xe0c907ff401 <a NodeObject with map 0x33abe2a71339>  (input #2)
    0x7fff5fbfda00: [top + 40] <- 0x2c21d25fa389 ;  caller's pc
    0x7fff5fbfd9f8: [top + 32] <- 0x7fff5fbfda60 ;  caller's fp
    0x7fff5fbfd9f0: [top + 24] <- 0xd6230db34c9 ;  context    0xd6230db34c9 <FixedArray[156]>  (input #3)
    0x7fff5fbfd9e8: [top + 16] <- 0xd6230dc62e1 ;  function    0xd6230dc62e1 <JS Function isParameterDeclaration (SharedFunctionInfo 0x3504a53d2899)>  (input #0)
    0x7fff5fbfd9e0: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfd9d8: [top + 0] <- 0xd6230dccc29 ;  0xd6230dccc29 <JS Function getRootDeclaration (SharedFunctionInfo 0x3504a53d2959)>  (input #5)
  translating frame getRootDeclaration => node=5, height=0
    0x7fff5fbfd9d0: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd9c8: [top + 32] <- 0xe0c907ff401 ;  0xe0c907ff401 <a NodeObject with map 0x33abe2a71339>  (input #2)
    0x7fff5fbfd9c0: [top + 24] <- 0x2c21d2573e5c ;  caller's pc
    0x7fff5fbfd9b8: [top + 16] <- 0x7fff5fbfd9f8 ;  caller's fp
    0x7fff5fbfd9b0: [top + 8] <- 0xd6230db34c9 ;  context    0xd6230db34c9 <FixedArray[156]>  (input #3)
    0x7fff5fbfd9a8: [top + 0] <- 0xd6230dccc29 ;  function    0xd6230dccc29 <JS Function getRootDeclaration (SharedFunctionInfo 0x3504a53d2959)>  (input #0)
[deoptimizing (eager): end 0xd6230dc62e1 <JS Function isParameterDeclaration (SharedFunctionInfo 0x3504a53d2899)> @3 => node=5, pc=0x2c21d2573d53, caller sp=0x7fff5fbfda18, state=NO_REGISTERS, took 0.102 ms]
[deoptimizing (DEOPT eager): begin 0x29cc38d1fa59 <JS Function getAliasSymbolForTypeNode (SharedFunctionInfo 0x2e2f693f4c81)> (opt #345) @2, FP to SP delta: 56, caller sp: 0x7fff5fbfd920]
            ;;; deoptimize at 0_32: wrong map
  reading input frame getAliasSymbolForTypeNode => node=4, args=2, height=1; inputs:
      0: 0x29cc38d1fa59 ; [fp - 16] 0x29cc38d1fa59 <JS Function getAliasSymbolForTypeNode (SharedFunctionInfo 0x2e2f693f4c81)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x215b0af2c069 ; rax 0x215b0af2c069 <a NodeObject with map 0x33abe2a75901>
      3: 0x29cc38d04261 ; [fp - 24] 0x29cc38d04261 <FixedArray[1022]>
  translating frame getAliasSymbolForTypeNode => node=4, height=0
    0x7fff5fbfd918: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd910: [top + 32] <- 0x215b0af2c069 ;  0x215b0af2c069 <a NodeObject with map 0x33abe2a75901>  (input #2)
    0x7fff5fbfd908: [top + 24] <- 0x2c21d261f902 ;  caller's pc
    0x7fff5fbfd900: [top + 16] <- 0x7fff5fbfd950 ;  caller's fp
    0x7fff5fbfd8f8: [top + 8] <- 0x29cc38d04261 ;  context    0x29cc38d04261 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd8f0: [top + 0] <- 0x29cc38d1fa59 ;  function    0x29cc38d1fa59 <JS Function getAliasSymbolForTypeNode (SharedFunctionInfo 0x2e2f693f4c81)>  (input #0)
[deoptimizing (eager): end 0x29cc38d1fa59 <JS Function getAliasSymbolForTypeNode (SharedFunctionInfo 0x2e2f693f4c81)> @2 => node=4, pc=0x2c21d26196c6, caller sp=0x7fff5fbfd920, state=NO_REGISTERS, took 0.056 ms]
[deoptimizing (DEOPT eager): begin 0xd6230dcf5f1 <JS Function nodeIsMissing (SharedFunctionInfo 0x3504a53cc419)> (opt #300) @2, FP to SP delta: 24, caller sp: 0x7fff5fbfd8c0]
  reading input frame nodeIsMissing => node=7, args=2, height=1; inputs:
      0: 0xd6230dcf5f1 ; [fp - 16] 0xd6230dcf5f1 <JS Function nodeIsMissing (SharedFunctionInfo 0x3504a53cc419)>
      1: 0x16f3adb61821 ; [fp + 24] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x215b0af05be1 ; rax 0x215b0af05be1 <a NodeObject with map 0x33abe2a66f41>
      3: 0xd6230db34c9 ; [fp - 24] 0xd6230db34c9 <FixedArray[156]>
  translating frame nodeIsMissing => node=7, height=0
    0x7fff5fbfd8b8: [top + 40] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfd8b0: [top + 32] <- 0x215b0af05be1 ;  0x215b0af05be1 <a NodeObject with map 0x33abe2a66f41>  (input #2)
    0x7fff5fbfd8a8: [top + 24] <- 0x2c21d2671118 ;  caller's pc
    0x7fff5fbfd8a0: [top + 16] <- 0x7fff5fbfd8f0 ;  caller's fp
    0x7fff5fbfd898: [top + 8] <- 0xd6230db34c9 ;  context    0xd6230db34c9 <FixedArray[156]>  (input #3)
    0x7fff5fbfd890: [top + 0] <- 0xd6230dcf5f1 ;  function    0xd6230dcf5f1 <JS Function nodeIsMissing (SharedFunctionInfo 0x3504a53cc419)>  (input #0)
[deoptimizing (eager): end 0xd6230dcf5f1 <JS Function nodeIsMissing (SharedFunctionInfo 0x3504a53cc419)> @2 => node=7, pc=0x2c21d2527f70, caller sp=0x7fff5fbfd8c0, state=NO_REGISTERS, took 0.053 ms]
[deoptimizing (DEOPT eager): begin 0x29cc38d1b919 <JS Function resolveEntityName (SharedFunctionInfo 0x2e2f693e9091)> (opt #349) @5, FP to SP delta: 48, caller sp: 0x7fff5fbfd930]
            ;;; deoptimize at 0_194: wrong map
  reading input frame resolveEntityName => node=22, args=6, height=6; inputs:
      0: 0x29cc38d1b919 ; [fp - 16] 0x29cc38d1b919 <JS Function resolveEntityName (SharedFunctionInfo 0x2e2f693e9091)>
      1: 0x1f9f6c0532e1 ; [fp + 56] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x215b0af05be1 ; rax 0x215b0af05be1 <a NodeObject with map 0x33abe2a66f41>
      3: 0xc19e800000000 ; [fp + 40] 793064
      4: 0x30bcea404311 ; [fp + 32] 0x30bcea404311 <undefined>
      5: 0x30bcea404311 ; [fp + 24] 0x30bcea404311 <undefined>
      6: 0x30bcea404311 ; [fp + 16] 0x30bcea404311 <undefined>
      7: 0x29cc38d04261 ; [fp - 24] 0x29cc38d04261 <FixedArray[1022]>
      8: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
      9: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
     10: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
     11: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
     12: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
  translating frame resolveEntityName => node=22, height=40
    0x7fff5fbfd928: [top + 112] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd920: [top + 104] <- 0x215b0af05be1 ;  0x215b0af05be1 <a NodeObject with map 0x33abe2a66f41>  (input #2)
    0x7fff5fbfd918: [top + 96] <- 0xc19e800000000 ;  793064  (input #3)
    0x7fff5fbfd910: [top + 88] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfd908: [top + 80] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfd900: [top + 72] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfd8f8: [top + 64] <- 0x2c21d2207e55 ;  caller's pc
    0x7fff5fbfd8f0: [top + 56] <- 0x7fff5fbfd948 ;  caller's fp
    0x7fff5fbfd8e8: [top + 48] <- 0x29cc38d04261 ;  context    0x29cc38d04261 <FixedArray[1022]>  (input #7)
    0x7fff5fbfd8e0: [top + 40] <- 0x29cc38d1b919 ;  function    0x29cc38d1b919 <JS Function resolveEntityName (SharedFunctionInfo 0x2e2f693e9091)>  (input #0)
    0x7fff5fbfd8d8: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfd8d0: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
    0x7fff5fbfd8c8: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #10)
    0x7fff5fbfd8c0: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #11)
    0x7fff5fbfd8b8: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #12)
[deoptimizing (eager): end 0x29cc38d1b919 <JS Function resolveEntityName (SharedFunctionInfo 0x2e2f693e9091)> @5 => node=22, pc=0x2c21d26137fd, caller sp=0x7fff5fbfd930, state=NO_REGISTERS, took 0.133 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeWithThisArgument) id{372,0} ---
(type, thisArgument) {
            if (getObjectFlags(type) & 4 /* Reference */) {
                return createTypeReference(type.target, ts.concatenate(type.typeArguments, [thisArgument || type.target.thisType]));
            }
            return type;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{372,1} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{372,1} AS 1 AT <0:39>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createTypeReference) id{372,2} ---
(target, typeArguments) {
            var id = getTypeListId(typeArguments);
            var type = target.instantiations[id];
            if (!type) {
                type = target.instantiations[id] = createObjectType(4 /* Reference */, target.symbol);
                type.flags |= typeArguments ? getPropagatingFlagsOfTypes(typeArguments, /*excludeKinds*/ 0) : 0;
                type.target = target;
                type.typeArguments = typeArguments;
            }
            return type;
        }
--- END ---
INLINE (createTypeReference) id{372,2} AS 2 AT <0:106>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createObjectType) id{372,3} ---
(objectFlags, symbol) {
            var type = createType(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol = symbol;
            return type;
        }
--- END ---
INLINE (createObjectType) id{372,3} AS 3 AT <2:203>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{372,4} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{372,4} AS 4 AT <3:47>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{372,5} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{372,5} AS 5 AT <4:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropagatingFlagsOfTypes) id{372,6} ---
(types, excludeKinds) {
            var result = 0;
            for (var _i = 0, types_3 = types; _i < types_3.length; _i++) {
                var type = types_3[_i];
                if (!(type.flags & excludeKinds)) {
                    result |= type.flags;
                }
            }
            return result & 14680064 /* PropagatingFlags */;
        }
--- END ---
INLINE (getPropagatingFlagsOfTypes) id{372,6} AS 6 AT <2:301>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbol) id{373,0} ---
(symbols, name, meaning) {
            if (meaning) {
                var symbol = symbols[name];
                if (symbol) {
                    ts.Debug.assert((symbol.flags & 16777216 /* Instantiated */) === 0, "Should never get an instantiated symbol here.");
                    if (symbol.flags & meaning) {
                        return symbol;
                    }
                    if (symbol.flags & 8388608 /* Alias */) {
                        var target = resolveAlias(symbol);
                        // Unknown symbol means an error occurred in alias resolution, treat it as positive answer to avoid cascading errors
                        if (target === unknownSymbol || target.flags & meaning) {
                            return symbol;
                        }
                    }
                }
            }
            // return undefined if we can't find a symbol.
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSignaturesOfType) id{374,0} ---
(type, kind) {
            return getSignaturesOfStructuredType(getApparentType(type), kind);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getApparentType) id{374,1} ---
(type) {
            var t = type.flags & 540672 /* TypeVariable */ ? getApparentTypeOfTypeVariable(type) : type;
            return t.flags & 262178 /* StringLike */ ? globalStringType :
                t.flags & 340 /* NumberLike */ ? globalNumberType :
                    t.flags & 136 /* BooleanLike */ ? globalBooleanType :
                        t.flags & 512 /* ESSymbol */ ? getGlobalESSymbolType() :
                            t;
        }
--- END ---
INLINE (getApparentType) id{374,1} AS 1 AT <0:64>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSignaturesOfStructuredType) id{374,2} ---
(type, kind) {
            if (type.flags & 229376 /* StructuredType */) {
                var resolved = resolveStructuredTypeMembers(type);
                return kind === 0 /* Call */ ? resolved.callSignatures : resolved.constructSignatures;
            }
            return emptyArray;
        }
--- END ---
INLINE (getSignaturesOfStructuredType) id{374,2} AS 2 AT <0:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isCatchClauseVariableDeclarationOrBindingElement) id{375,0} ---
(declaration) {
        var node = getRootDeclaration(declaration);
        return node.kind === 223 /* VariableDeclaration */ && node.parent.kind === 256 /* CatchClause */;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getRootDeclaration) id{375,1} ---
(node) {
        while (node.kind === 174 /* BindingElement */) {
            node = node.parent.parent;
        }
        return node;
    }
--- END ---
INLINE (getRootDeclaration) id{375,1} AS 1 AT <0:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveName) id{376,0} ---
(location, name, meaning, nameNotFoundMessage, nameArg) {
            var result;
            var lastLocation;
            var propertyWithInvalidInitializer;
            var errorLocation = location;
            var grandparent;
            var isInExternalModule = false;
            loop: while (location) {
                // Locals of a source file are not in scope (because they get merged into the global symbol table)
                if (location.locals && !isGlobalSourceFile(location)) {
                    if (result = getSymbol(location.locals, name, meaning)) {
                        var useResult = true;
                        if (ts.isFunctionLike(location) && lastLocation && lastLocation !== location.body) {
                            // symbol lookup restrictions for function-like declarations
                            // - Type parameters of a function are in scope in the entire function declaration, including the parameter
                            //   list and return type. However, local types are only in scope in the function body.
                            // - parameters are only in the scope of function body
                            // This restriction does not apply to JSDoc comment types because they are parented
                            // at a higher level than type parameters would normally be
                            if (meaning & result.flags & 793064 /* Type */ && lastLocation.kind !== 278 /* JSDocComment */) {
                                useResult = result.flags & 262144 /* TypeParameter */
                                    ? lastLocation === location.type ||
                                        lastLocation.kind === 144 /* Parameter */ ||
                                        lastLocation.kind === 143 /* TypeParameter */
                                    : false;
                            }
                            if (meaning & 107455 /* Value */ && result.flags & 1 /* FunctionScopedVariable */) {
                                // parameters are visible only inside function body, parameter list and return type
                                // technically for parameter list case here we might mix parameters and variables declared in function,
                                // however it is detected separately when checking initializers of parameters
                                // to make sure that they reference no variables declared after them.
                                useResult =
                                    lastLocation.kind === 144 /* Parameter */ ||
                                        (lastLocation === location.type &&
                                            result.valueDeclaration.kind === 144 /* Parameter */);
                            }
                        }
                        if (useResult) {
                            break loop;
                        }
                        else {
                            result = undefined;
                        }
                    }
                }
                switch (location.kind) {
                    case 261 /* SourceFile */:
                        if (!ts.isExternalOrCommonJsModule(location))
                            break;
                        isInExternalModule = true;
                    case 230 /* ModuleDeclaration */:
                        var moduleExports = getSymbolOfNode(location).exports;
                        if (location.kind === 261 /* SourceFile */ || ts.isAmbientModule(location)) {
                            // It's an external module. First see if the module has an export default and if the local
                            // name of that export default matches.
                            if (result = moduleExports["default"]) {
                                var localSymbol = ts.getLocalSymbolForExportDefault(result);
                                if (localSymbol && (result.flags & meaning) && localSymbol.name === name) {
                                    break loop;
                                }
                                result = undefined;
                            }
                            // Because of module/namespace merging, a module's exports are in scope,
                            // yet we never want to treat an export specifier as putting a member in scope.
                            // Therefore, if the name we find is purely an export specifier, it is not actually considered in scope.
                            // Two things to note about this:
                            //     1. We have to check this without calling getSymbol. The problem with calling getSymbol
                            //        on an export specifier is that it might find the export specifier itself, and try to
                            //        resolve it as an alias. This will cause the checker to consider the export specifier
                            //        a circular alias reference when it might not be.
                            //     2. We check === SymbolFlags.Alias in order to check that the symbol is *purely*
                            //        an alias. If we used &, we'd be throwing out symbols that have non alias aspects,
                            //        which is not the desired behavior.
                            if (moduleExports[name] &&
                                moduleExports[name].flags === 8388608 /* Alias */ &&
                                ts.getDeclarationOfKind(moduleExports[name], 243 /* ExportSpecifier */)) {
                                break;
                            }
                        }
                        if (result = getSymbol(moduleExports, name, meaning & 8914931 /* ModuleMember */)) {
                            break loop;
                        }
                        break;
                    case 229 /* EnumDeclaration */:
                        if (result = getSymbol(getSymbolOfNode(location).exports, name, meaning & 8 /* EnumMember */)) {
                            break loop;
                        }
                        break;
                    case 147 /* PropertyDeclaration */:
                    case 146 /* PropertySignature */:
                        // TypeScript 1.0 spec (April 2014): 8.4.1
                        // Initializer expressions for instance member variables are evaluated in the scope
                        // of the class constructor body but are not permitted to reference parameters or
                        // local variables of the constructor. This effectively means that entities from outer scopes
                        // by the same name as a constructor parameter or local variable are inaccessible
                        // in initializer expressions for instance member variables.
                        if (ts.isClassLike(location.parent) && !(ts.getModifierFlags(location) & 32 /* Static */)) {
                            var ctor = findConstructorDeclaration(location.parent);
                            if (ctor && ctor.locals) {
                                if (getSymbol(ctor.locals, name, meaning & 107455 /* Value */)) {
                                    // Remember the property node, it will be used later to report appropriate error
                                    propertyWithInvalidInitializer = location;
                                }
                            }
                        }
                        break;
                    case 226 /* ClassDeclaration */:
                    case 197 /* ClassExpression */:
                    case 227 /* InterfaceDeclaration */:
                        if (result = getSymbol(getSymbolOfNode(location).members, name, meaning & 793064 /* Type */)) {
                            if (lastLocation && ts.getModifierFlags(lastLocation) & 32 /* Static */) {
                                // TypeScript 1.0 spec (April 2014): 3.4.1
                                // The scope of a type parameter extends over the entire declaration with which the type
                                // parameter list is associated, with the exception of static member declarations in classes.
                                error(errorLocation, ts.Diagnostics.Static_members_cannot_reference_class_type_parameters);
                                return undefined;
                            }
                            break loop;
                        }
                        if (location.kind === 197 /* ClassExpression */ && meaning & 32 /* Class */) {
                            var className = location.name;
                            if (className && name === className.text) {
                                result = location.symbol;
                                break loop;
                            }
                        }
                        break;
                    // It is not legal to reference a class's own type parameters from a computed property name that
                    // belongs to the class. For example:
                    //
                    //   function foo<T>() { return '' }
                    //   class C<T> { // <-- Class's own type parameter T
                    //       [foo<T>()]() { } // <-- Reference to T from class's own computed property
                    //   }
                    //
                    case 142 /* ComputedPropertyName */:
                        grandparent = location.parent.parent;
                        if (ts.isClassLike(grandparent) || grandparent.kind === 227 /* InterfaceDeclaration */) {
                            // A reference to this grandparent's type parameters would be an error
                            if (result = getSymbol(getSymbolOfNode(grandparent).members, name, meaning & 793064 /* Type */)) {
                                error(errorLocation, ts.Diagnostics.A_computed_property_name_cannot_reference_a_type_parameter_from_its_containing_type);
                                return undefined;
                            }
                        }
                        break;
                    case 149 /* MethodDeclaration */:
                    case 148 /* MethodSignature */:
                    case 150 /* Constructor */:
                    case 151 /* GetAccessor */:
                    case 152 /* SetAccessor */:
                    case 225 /* FunctionDeclaration */:
                    case 185 /* ArrowFunction */:
                        if (meaning & 3 /* Variable */ && name === "arguments") {
                            result = argumentsSymbol;
                            break loop;
                        }
                        break;
                    case 184 /* FunctionExpression */:
                        if (meaning & 3 /* Variable */ && name === "arguments") {
                            result = argumentsSymbol;
                            break loop;
                        }
                        if (meaning & 16 /* Function */) {
                            var functionName = location.name;
                            if (functionName && name === functionName.text) {
                                result = location.symbol;
                                break loop;
                            }
                        }
                        break;
                    case 145 /* Decorator */:
                        // Decorators are resolved at the class declaration. Resolving at the parameter
                        // or member would result in looking up locals in the method.
                        //
                        //   function y() {}
                        //   class C {
                        //       method(@y x, y) {} // <-- decorator y should be resolved at the class declaration, not the parameter.
                        //   }
                        //
                        if (location.parent && location.parent.kind === 144 /* Parameter */) {
                            location = location.parent;
                        }
                        //
                        //   function y() {}
                        //   class C {
                        //       @y method(x, y) {} // <-- decorator y should be resolved at the class declaration, not the method.
                        //   }
                        //
                        if (location.parent && ts.isClassElement(location.parent)) {
                            location = location.parent;
                        }
                        break;
                }
                lastLocation = location;
                location = location.parent;
            }
            if (result && nameNotFoundMessage && noUnusedIdentifiers) {
                result.isReferenced = true;
            }
            if (!result) {
                result = getSymbol(globals, name, meaning);
            }
            if (!result) {
                if (nameNotFoundMessage) {
                    if (!errorLocation ||
                        !checkAndReportErrorForMissingPrefix(errorLocation, name, nameArg) &&
                            !checkAndReportErrorForExtendingInterface(errorLocation) &&
                            !checkAndReportErrorForUsingTypeAsNamespace(errorLocation, name, meaning) &&
                            !checkAndReportErrorForUsingTypeAsValue(errorLocation, name, meaning)) {
                        error(errorLocation, nameNotFoundMessage, typeof nameArg === "string" ? nameArg : ts.declarationNameToString(nameArg));
                    }
                }
                return undefined;
            }
            // Perform extra checks only if error reporting was requested
            if (nameNotFoundMessage) {
                if (propertyWithInvalidInitializer) {
                    // We have a match, but the reference occurred within a property initializer and the identifier also binds
                    // to a local variable in the constructor where the code will be emitted.
                    var propertyName = propertyWithInvalidInitializer.name;
                    error(errorLocation, ts.Diagnostics.Initializer_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor, ts.declarationNameToString(propertyName), typeof nameArg === "string" ? nameArg : ts.declarationNameToString(nameArg));
                    return undefined;
                }
                // Only check for block-scoped variable if we are looking for the
                // name with variable meaning
                //      For example,
                //          declare module foo {
                //              interface bar {}
                //          }
                //      const foo/*1*/: foo/*2*/.bar;
                // The foo at /*1*/ and /*2*/ will share same symbol with two meaning
                // block - scope variable and namespace module. However, only when we
                // try to resolve name in /*1*/ which is used in variable position,
                // we want to check for block- scoped
                if (meaning & 2 /* BlockScopedVariable */) {
                    var exportOrLocalSymbol = getExportSymbolOfValueSymbolIfExported(result);
                    if (exportOrLocalSymbol.flags & 2 /* BlockScopedVariable */) {
                        checkResolvedBlockScopedVariable(exportOrLocalSymbol, errorLocation);
                    }
                }
                // If we're in an external module, we can't reference value symbols created from UMD export declarations
                if (result && isInExternalModule && (meaning & 107455 /* Value */) === 107455 /* Value */) {
                    var decls = result.declarations;
                    if (decls && decls.length === 1 && decls[0].kind === 233 /* NamespaceExportDeclaration */) {
                        error(errorLocation, ts.Diagnostics._0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead, name);
                    }
                }
            }
            return result;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isGlobalSourceFile) id{376,1} ---
(node) {
            return node.kind === 261 /* SourceFile */ && !ts.isExternalOrCommonJsModule(node);
        }
--- END ---
INLINE (isGlobalSourceFile) id{376,1} AS 1 AT <0:467>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{376,2} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{376,2} AS 2 AT <0:3412>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{376,3} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{376,3} AS 3 AT <2:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{376,4} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{376,4} AS 4 AT <0:7735>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{376,5} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{376,5} AS 5 AT <4:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getInterfaceBaseTypeNodes) id{377,0} ---
(node) {
        var heritageClause = getHeritageClause(node.heritageClauses, 84 /* ExtendsKeyword */);
        return heritageClause ? heritageClause.types : undefined;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getHeritageClause) id{377,1} ---
(clauses, kind) {
        if (clauses) {
            for (var _i = 0, clauses_1 = clauses; _i < clauses_1.length; _i++) {
                var clause = clauses_1[_i];
                if (clause.token === kind) {
                    return clause;
                }
            }
        }
        return undefined;
    }
--- END ---
INLINE (getHeritageClause) id{377,1} AS 1 AT <0:38>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveStructuredTypeMembers) id{378,0} ---
(type) {
            if (!type.members) {
                if (type.flags & 32768 /* Object */) {
                    if (type.objectFlags & 4 /* Reference */) {
                        resolveTypeReferenceMembers(type);
                    }
                    else if (type.objectFlags & 3 /* ClassOrInterface */) {
                        resolveClassOrInterfaceMembers(type);
                    }
                    else if (type.objectFlags & 16 /* Anonymous */) {
                        resolveAnonymousTypeMembers(type);
                    }
                    else if (type.objectFlags & 32 /* Mapped */) {
                        resolveMappedTypeMembers(type);
                    }
                }
                else if (type.flags & 65536 /* Union */) {
                    resolveUnionTypeMembers(type);
                }
                else if (type.flags & 131072 /* Intersection */) {
                    resolveIntersectionTypeMembers(type);
                }
            }
            return type;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveTypeReferenceMembers) id{378,1} ---
(type) {
            var source = resolveDeclaredMembers(type.target);
            var typeParameters = ts.concatenate(source.typeParameters, [source.thisType]);
            var typeArguments = type.typeArguments && type.typeArguments.length === typeParameters.length ?
                type.typeArguments : ts.concatenate(type.typeArguments, [type]);
            resolveObjectTypeMembers(type, source, typeParameters, typeArguments);
        }
--- END ---
INLINE (resolveTypeReferenceMembers) id{378,1} AS 1 AT <0:185>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveDeclaredMembers) id{378,2} ---
(type) {
            if (!type.declaredProperties) {
                var symbol = type.symbol;
                type.declaredProperties = getNamedMembers(symbol.members);
                type.declaredCallSignatures = getSignaturesOfSymbol(symbol.members["__call"]);
                type.declaredConstructSignatures = getSignaturesOfSymbol(symbol.members["__new"]);
                type.declaredStringIndexInfo = getIndexInfoOfSymbol(symbol, 0 /* String */);
                type.declaredNumberIndexInfo = getIndexInfoOfSymbol(symbol, 1 /* Number */);
            }
            return type;
        }
--- END ---
INLINE (resolveDeclaredMembers) id{378,2} AS 2 AT <1:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNamedMembers) id{378,3} ---
(members) {
            var result;
            for (var id in members) {
                if (!isReservedMemberName(id)) {
                    if (!result)
                        result = [];
                    var symbol = members[id];
                    if (symbolIsValue(symbol)) {
                        result.push(symbol);
                    }
                }
            }
            return result || emptyArray;
        }
--- END ---
INLINE (getNamedMembers) id{378,3} AS 3 AT <2:137>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isReservedMemberName) id{378,4} ---
(name) {
            return name.charCodeAt(0) === 95 /* _ */ &&
                name.charCodeAt(1) === 95 /* _ */ &&
                name.charCodeAt(2) !== 95 /* _ */ &&
                name.charCodeAt(2) !== 64 /* at */;
        }
--- END ---
INLINE (isReservedMemberName) id{378,4} AS 4 AT <3:95>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexInfoOfSymbol) id{378,5} ---
(symbol, kind) {
            var declaration = getIndexDeclarationOfSymbol(symbol, kind);
            if (declaration) {
                return createIndexInfo(declaration.type ? getTypeFromTypeNode(declaration.type) : anyType, (ts.getModifierFlags(declaration) & 64 /* Readonly */) !== 0, declaration);
            }
            return undefined;
        }
--- END ---
INLINE (getIndexInfoOfSymbol) id{378,5} AS 5 AT <2:411>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createIndexInfo) id{378,6} ---
(type, isReadonly, declaration) {
            return { type: type, isReadonly: isReadonly, declaration: declaration };
        }
--- END ---
INLINE (createIndexInfo) id{378,6} AS 6 AT <5:144>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexInfoOfSymbol) id{378,7} ---
(symbol, kind) {
            var declaration = getIndexDeclarationOfSymbol(symbol, kind);
            if (declaration) {
                return createIndexInfo(declaration.type ? getTypeFromTypeNode(declaration.type) : anyType, (ts.getModifierFlags(declaration) & 64 /* Readonly */) !== 0, declaration);
            }
            return undefined;
        }
--- END ---
INLINE (getIndexInfoOfSymbol) id{378,7} AS 7 AT <2:504>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createIndexInfo) id{378,8} ---
(type, isReadonly, declaration) {
            return { type: type, isReadonly: isReadonly, declaration: declaration };
        }
--- END ---
INLINE (createIndexInfo) id{378,8} AS 8 AT <7:144>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveClassOrInterfaceMembers) id{378,9} ---
(type) {
            resolveObjectTypeMembers(type, resolveDeclaredMembers(type), emptyArray, emptyArray);
        }
--- END ---
INLINE (resolveClassOrInterfaceMembers) id{378,9} AS 9 AT <0:342>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveDeclaredMembers) id{378,10} ---
(type) {
            if (!type.declaredProperties) {
                var symbol = type.symbol;
                type.declaredProperties = getNamedMembers(symbol.members);
                type.declaredCallSignatures = getSignaturesOfSymbol(symbol.members["__call"]);
                type.declaredConstructSignatures = getSignaturesOfSymbol(symbol.members["__new"]);
                type.declaredStringIndexInfo = getIndexInfoOfSymbol(symbol, 0 /* String */);
                type.declaredNumberIndexInfo = getIndexInfoOfSymbol(symbol, 1 /* Number */);
            }
            return type;
        }
--- END ---
INLINE (resolveDeclaredMembers) id{378,10} AS 10 AT <9:52>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNamedMembers) id{378,11} ---
(members) {
            var result;
            for (var id in members) {
                if (!isReservedMemberName(id)) {
                    if (!result)
                        result = [];
                    var symbol = members[id];
                    if (symbolIsValue(symbol)) {
                        result.push(symbol);
                    }
                }
            }
            return result || emptyArray;
        }
--- END ---
INLINE (getNamedMembers) id{378,11} AS 11 AT <10:137>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isReservedMemberName) id{378,12} ---
(name) {
            return name.charCodeAt(0) === 95 /* _ */ &&
                name.charCodeAt(1) === 95 /* _ */ &&
                name.charCodeAt(2) !== 95 /* _ */ &&
                name.charCodeAt(2) !== 64 /* at */;
        }
--- END ---
INLINE (isReservedMemberName) id{378,12} AS 12 AT <11:95>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getBaseTypes) id{379,0} ---
(type) {
            if (!type.resolvedBaseTypes) {
                if (type.objectFlags & 8 /* Tuple */) {
                    type.resolvedBaseTypes = [createArrayType(getUnionType(type.typeParameters))];
                }
                else if (type.symbol.flags & (32 /* Class */ | 64 /* Interface */)) {
                    if (type.symbol.flags & 32 /* Class */) {
                        resolveBaseTypesOfClass(type);
                    }
                    if (type.symbol.flags & 64 /* Interface */) {
                        resolveBaseTypesOfInterface(type);
                    }
                }
                else {
                    ts.Debug.fail("type must be class or interface");
                }
            }
            return type.resolvedBaseTypes;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:forEach) id{380,0} ---
(array, callback) {
        if (array) {
            for (var i = 0, len = array.length; i < len; i++) {
                var result = callback(array[i], i);
                if (result) {
                    return result;
                }
            }
        }
        return undefined;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexInfoOfType) id{381,0} ---
(type, kind) {
            return getIndexInfoOfStructuredType(getApparentType(type), kind);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getApparentType) id{381,1} ---
(type) {
            var t = type.flags & 540672 /* TypeVariable */ ? getApparentTypeOfTypeVariable(type) : type;
            return t.flags & 262178 /* StringLike */ ? globalStringType :
                t.flags & 340 /* NumberLike */ ? globalNumberType :
                    t.flags & 136 /* BooleanLike */ ? globalBooleanType :
                        t.flags & 512 /* ESSymbol */ ? getGlobalESSymbolType() :
                            t;
        }
--- END ---
INLINE (getApparentType) id{381,1} AS 1 AT <0:63>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexInfoOfStructuredType) id{381,2} ---
(type, kind) {
            if (type.flags & 229376 /* StructuredType */) {
                var resolved = resolveStructuredTypeMembers(type);
                return kind === 0 /* String */ ? resolved.stringIndexInfo : resolved.numberIndexInfo;
            }
        }
--- END ---
INLINE (getIndexInfoOfStructuredType) id{381,2} AS 2 AT <0:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexInfoOfSymbol) id{382,0} ---
(symbol, kind) {
            var declaration = getIndexDeclarationOfSymbol(symbol, kind);
            if (declaration) {
                return createIndexInfo(declaration.type ? getTypeFromTypeNode(declaration.type) : anyType, (ts.getModifierFlags(declaration) & 64 /* Readonly */) !== 0, declaration);
            }
            return undefined;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createIndexInfo) id{382,1} ---
(type, isReadonly, declaration) {
            return { type: type, isReadonly: isReadonly, declaration: declaration };
        }
--- END ---
INLINE (createIndexInfo) id{382,1} AS 1 AT <0:144>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nodeIsMissing) id{383,0} ---
(node) {
        if (node === undefined) {
            return true;
        }
        return node.pos === node.end && node.pos >= 0 && node.kind !== 1 /* EndOfFileToken */;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarProperty) id{384,0} ---
(node) {
            if (ts.isClassLike(node.parent)) {
                if (checkGrammarForNonSymbolComputedProperty(node.name, ts.Diagnostics.A_computed_property_name_in_a_class_property_declaration_must_directly_refer_to_a_built_in_symbol)) {
                    return true;
                }
            }
            else if (node.parent.kind === 227 /* InterfaceDeclaration */) {
                if (checkGrammarForNonSymbolComputedProperty(node.name, ts.Diagnostics.A_computed_property_name_in_an_interface_must_directly_refer_to_a_built_in_symbol)) {
                    return true;
                }
                if (node.initializer) {
                    return grammarErrorOnNode(node.initializer, ts.Diagnostics.An_interface_property_cannot_have_an_initializer);
                }
            }
            else if (node.parent.kind === 161 /* TypeLiteral */) {
                if (checkGrammarForNonSymbolComputedProperty(node.name, ts.Diagnostics.A_computed_property_name_in_a_type_literal_must_directly_refer_to_a_built_in_symbol)) {
                    return true;
                }
                if (node.initializer) {
                    return grammarErrorOnNode(node.initializer, ts.Diagnostics.A_type_literal_property_cannot_have_an_initializer);
                }
            }
            if (ts.isInAmbientContext(node) && node.initializer) {
                return grammarErrorOnFirstToken(node.initializer, ts.Diagnostics.Initializers_are_not_allowed_in_ambient_contexts);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarForNonSymbolComputedProperty) id{384,1} ---
(node, message) {
            if (ts.isDynamicName(node)) {
                return grammarErrorOnNode(node, message);
            }
        }
--- END ---
INLINE (checkGrammarForNonSymbolComputedProperty) id{384,1} AS 1 AT <0:406>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isEntityNameExpression) id{385,0} ---
(node) {
        return node.kind === 70 /* Identifier */ ||
            node.kind === 177 /* PropertyAccessExpression */ && isEntityNameExpression(node.expression);
    }
--- END ---
[marking dependent code 0x2c21d2692fa1 (opt #378) for deoptimization, reason: allocation-site-tenuring-changed]
[marking dependent code 0x2c21d26363e1 (opt #298) for deoptimization, reason: allocation-site-tenuring-changed]
[marking dependent code 0x2c21d2642321 (opt #319) for deoptimization, reason: allocation-site-tenuring-changed]
[marking dependent code 0x2c21d2646aa1 (opt #327) for deoptimization, reason: allocation-site-tenuring-changed]
[marking dependent code 0x2c21d2651721 (opt #330) for deoptimization, reason: allocation-site-tenuring-changed]
[marking dependent code 0x2c21d2658e81 (opt #334) for deoptimization, reason: allocation-site-tenuring-changed]
[marking dependent code 0x2c21d26676e1 (opt #342) for deoptimization, reason: allocation-site-tenuring-changed]
[marking dependent code 0x2c21d266b521 (opt #347) for deoptimization, reason: allocation-site-tenuring-changed]
[marking dependent code 0x2c21d266dbe1 (opt #348) for deoptimization, reason: allocation-site-tenuring-changed]
[marking dependent code 0x2c21d2671d61 (opt #351) for deoptimization, reason: allocation-site-tenuring-changed]
[marking dependent code 0x2c21d2676ca1 (opt #357) for deoptimization, reason: allocation-site-tenuring-changed]
[marking dependent code 0x2c21d267b521 (opt #359) for deoptimization, reason: allocation-site-tenuring-changed]
[marking dependent code 0x2c21d2683c81 (opt #369) for deoptimization, reason: allocation-site-tenuring-changed]
[marking dependent code 0x2c21d25701e1 (opt #219) for deoptimization, reason: allocation-site-tenuring-changed]
[marking dependent code 0x2c21d257dfc1 (opt #225) for deoptimization, reason: allocation-site-tenuring-changed]
[marking dependent code 0x2c21d25882c1 (opt #233) for deoptimization, reason: allocation-site-tenuring-changed]
[marking dependent code 0x2c21d25b2821 (opt #255) for deoptimization, reason: allocation-site-tenuring-changed]
[marking dependent code 0x2c21d25c28a1 (opt #264) for deoptimization, reason: allocation-site-tenuring-changed]
[marking dependent code 0x2c21d25c6501 (opt #269) for deoptimization, reason: allocation-site-tenuring-changed]
[marking dependent code 0x2c21d25deae1 (opt #285) for deoptimization, reason: allocation-site-tenuring-changed]
[marking dependent code 0x2c21d25c3a41 (opt #266) for deoptimization, reason: allocation-site-tenuring-changed]
[deoptimize marked code in all contexts]
[deoptimizer unlinked: resolveStructuredTypeMembers / 130b7e1b5e01]
[deoptimizer unlinked: checkTypeReferenceNode / 1030c9d42c69]
[deoptimizer unlinked: getDeclaredTypeOfClassOrInterface / 1030c9d3e3d1]
[deoptimizer unlinked: getTypeOfSymbol / 1030c9d44209]
[deoptimizer unlinked: getTypeOfInstantiatedSymbol / 1030c9d457e1]
[deoptimizer unlinked: checkSourceElement / 130b7e1b6059]
[deoptimizer unlinked: getTypeOfVariableOrParameterOrProperty / 1030c9d3f861]
[deoptimizer unlinked: getDeclaredTypeOfSymbol / 1030c9d3e359]
[deoptimizer unlinked: getDeclaredTypeOfTypeParameter / 1030c9d3ede9]
[deoptimizer unlinked: symbolIsValue / 1030c9d41a69]
[deoptimizer unlinked: getSymbolLinks / 1030c9d3dfd9]
[deoptimizer unlinked: addDeclarationToSymbol / 2f05bb804691]
[deoptimizer unlinked: bindContainer / 2f05bb8047f9]
[deoptimizing (DEOPT lazy): begin 0x130b7e1b5e01 <JS Function resolveStructuredTypeMembers (SharedFunctionInfo 0x2e2f693efe11)> (opt #378) @65, FP to SP delta: 248, caller sp: 0x7fff5fbfdc28]
  reading input frame resolveStructuredTypeMembers => node=104, args=2, height=2; inputs:
      0: 0x130b7e1b5e01 ; [fp - 16] 0x130b7e1b5e01 <JS Function resolveStructuredTypeMembers (SharedFunctionInfo 0x2e2f693efe11)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x101bfd310679 ; [fp + 16] 0x101bfd310679 <a TypeObject with map 0x33abe2a73599>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x130b7e1b5db9 ; [fp - 32] 0x130b7e1b5db9 <JS Function resolveClassOrInterfaceMembers (SharedFunctionInfo 0x2e2f693eed91)>
  reading input frame resolveClassOrInterfaceMembers => node=5, args=2, height=1; inputs:
      0: 0x130b7e1b5db9 ; (literal 15) 0x130b7e1b5db9 <JS Function resolveClassOrInterfaceMembers (SharedFunctionInfo 0x2e2f693eed91)>
      1: 0x1f9f6c0532e1 ; (literal 16) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x101bfd310679 ; [fp + 16] 0x101bfd310679 <a TypeObject with map 0x33abe2a73599>
      3: 0x130b7e1b3d29 ; (literal 17) 0x130b7e1b3d29 <FixedArray[1022]>
  translating frame resolveStructuredTypeMembers => node=104, height=8
    0x7fff5fbfdc20: [top + 48] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdc18: [top + 40] <- 0x101bfd310679 ;  0x101bfd310679 <a TypeObject with map 0x33abe2a73599>  (input #2)
    0x7fff5fbfdc10: [top + 32] <- 0x2c21d262ff14 ;  caller's pc
    0x7fff5fbfdc08: [top + 24] <- 0x7fff5fbfdc58 ;  caller's fp
    0x7fff5fbfdc00: [top + 16] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdbf8: [top + 8] <- 0x130b7e1b5e01 ;  function    0x130b7e1b5e01 <JS Function resolveStructuredTypeMembers (SharedFunctionInfo 0x2e2f693efe11)>  (input #0)
    0x7fff5fbfdbf0: [top + 0] <- 0x130b7e1b5db9 ;  0x130b7e1b5db9 <JS Function resolveClassOrInterfaceMembers (SharedFunctionInfo 0x2e2f693eed91)>  (input #4)
  translating frame resolveClassOrInterfaceMembers => node=5, height=0
    0x7fff5fbfdbe8: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdbe0: [top + 32] <- 0x101bfd310679 ;  0x101bfd310679 <a TypeObject with map 0x33abe2a73599>  (input #2)
    0x7fff5fbfdbd8: [top + 24] <- 0x2c21d260d68b ;  caller's pc
    0x7fff5fbfdbd0: [top + 16] <- 0x7fff5fbfdc08 ;  caller's fp
    0x7fff5fbfdbc8: [top + 8] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdbc0: [top + 0] <- 0x130b7e1b5db9 ;  function    0x130b7e1b5db9 <JS Function resolveClassOrInterfaceMembers (SharedFunctionInfo 0x2e2f693eed91)>  (input #0)
[deoptimizing (lazy): end 0x130b7e1b5e01 <JS Function resolveStructuredTypeMembers (SharedFunctionInfo 0x2e2f693efe11)> @65 => node=5, pc=0x2c21d260d9b8, caller sp=0x7fff5fbfdc28, state=NO_REGISTERS, took 0.095 ms]
[deoptimizing (DEOPT lazy): begin 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> (opt #348) @17, FP to SP delta: 176, caller sp: 0x7fff5fbfe098]
  reading input frame checkSourceElement => node=948, args=2, height=5; inputs:
      0: 0x130b7e1b6059 ; [fp - 16] 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x33c680347439 ; [fp + 16] 0x33c680347439 <a NodeObject with map 0x33abe2a70101>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 29) 0x30bcea404311 <undefined>
      5: 0x30bcea4069a9 ; (literal 30) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      6: 0x30bcea4069a9 ; (literal 30) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x30bcea404311 ; rax 0x30bcea404311 <undefined>
  translating frame checkSourceElement => node=948, height=32
    0x7fff5fbfe090: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfe088: [top + 64] <- 0x33c680347439 ;  0x33c680347439 <a NodeObject with map 0x33abe2a70101>  (input #2)
    0x7fff5fbfe080: [top + 56] <- 0x2c21d2207e55 ;  caller's pc
    0x7fff5fbfe078: [top + 48] <- 0x7fff5fbfe0b0 ;  caller's fp
    0x7fff5fbfe070: [top + 40] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfe068: [top + 32] <- 0x130b7e1b6059 ;  function    0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>  (input #0)
    0x7fff5fbfe060: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfe058: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #5)
    0x7fff5fbfe050: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfe048: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
[deoptimizing (lazy): end 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> @17 => node=948, pc=0x2c21d25ec795, caller sp=0x7fff5fbfe098, state=TOS_REGISTER, took 0.057 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTargetType) id{386,0} ---
(type) {
            return getObjectFlags(type) & 4 /* Reference */ ? type.target : type;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{386,1} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{386,1} AS 1 AT <0:28>
[deoptimizing (DEOPT eager): begin 0x130b7e1b68e9 <JS Function checkGrammarProperty (SharedFunctionInfo 0x1b98fbc15551)> (opt #384) @6, FP to SP delta: 72, caller sp: 0x7fff5fbfdce0]
            ;;; deoptimize at 0_342: wrong map
  reading input frame checkGrammarProperty => node=7, args=2, height=1; inputs:
      0: 0x130b7e1b68e9 ; [fp - 16] 0x130b7e1b68e9 <JS Function checkGrammarProperty (SharedFunctionInfo 0x1b98fbc15551)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x215b0af06a59 ; rax 0x215b0af06a59 <a NodeObject with map 0x33abe2a6ffa1>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
  translating frame checkGrammarProperty => node=7, height=0
    0x7fff5fbfdcd8: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdcd0: [top + 32] <- 0x215b0af06a59 ;  0x215b0af06a59 <a NodeObject with map 0x33abe2a6ffa1>  (input #2)
    0x7fff5fbfdcc8: [top + 24] <- 0x2c21d261076e ;  caller's pc
    0x7fff5fbfdcc0: [top + 16] <- 0x7fff5fbfdcf8 ;  caller's fp
    0x7fff5fbfdcb8: [top + 8] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdcb0: [top + 0] <- 0x130b7e1b68e9 ;  function    0x130b7e1b68e9 <JS Function checkGrammarProperty (SharedFunctionInfo 0x1b98fbc15551)>  (input #0)
[deoptimizing (eager): end 0x130b7e1b68e9 <JS Function checkGrammarProperty (SharedFunctionInfo 0x1b98fbc15551)> @6 => node=7, pc=0x2c21d2610a1c, caller sp=0x7fff5fbfdce0, state=NO_REGISTERS, took 0.053 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:symbolIsValue) id{387,0} ---
(symbol) {
            // If it is an instantiated symbol, then it is a value if the symbol it is an
            // instantiation of is a value.
            if (symbol.flags & 16777216 /* Instantiated */) {
                return symbolIsValue(getSymbolLinks(symbol).target);
            }
            // If the symbol has the value flag, it is trivially a value.
            if (symbol.flags & 107455 /* Value */) {
                return true;
            }
            // If it is an alias, then it is a value if the symbol it resolves to is a value.
            if (symbol.flags & 8388608 /* Alias */) {
                return (resolveAlias(symbol).flags & 107455 /* Value */) !== 0;
            }
            return false;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{387,1} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{387,1} AS 1 AT <0:244>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{387,2} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{387,2} AS 2 AT <1:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropertyOfType) id{388,0} ---
(type, name) {
            type = getApparentType(type);
            if (type.flags & 32768 /* Object */) {
                var resolved = resolveStructuredTypeMembers(type);
                var symbol = resolved.members[name];
                if (symbol && symbolIsValue(symbol)) {
                    return symbol;
                }
                if (resolved === anyFunctionType || resolved.callSignatures.length || resolved.constructSignatures.length) {
                    var symbol_1 = getPropertyOfObjectType(globalFunctionType, name);
                    if (symbol_1) {
                        return symbol_1;
                    }
                }
                return getPropertyOfObjectType(globalObjectType, name);
            }
            if (type.flags & 196608 /* UnionOrIntersection */) {
                return getPropertyOfUnionOrIntersectionType(type, name);
            }
            return undefined;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getApparentType) id{388,1} ---
(type) {
            var t = type.flags & 540672 /* TypeVariable */ ? getApparentTypeOfTypeVariable(type) : type;
            return t.flags & 262178 /* StringLike */ ? globalStringType :
                t.flags & 340 /* NumberLike */ ? globalNumberType :
                    t.flags & 136 /* BooleanLike */ ? globalBooleanType :
                        t.flags & 512 /* ESSymbol */ ? getGlobalESSymbolType() :
                            t;
        }
--- END ---
INLINE (getApparentType) id{388,1} AS 1 AT <0:34>
[deoptimizing (DEOPT eager): begin 0x130b7e1b6859 <JS Function getSignaturesOfType (SharedFunctionInfo 0x2e2f693f0711)> (opt #374) @11, FP to SP delta: 56, caller sp: 0x7fff5fbfdae8]
            ;;; deoptimize at 2_35: wrong map
  reading input frame getSignaturesOfType => node=7, args=3, height=2; inputs:
      0: 0x130b7e1b6859 ; [fp - 16] 0x130b7e1b6859 <JS Function getSignaturesOfType (SharedFunctionInfo 0x2e2f693f0711)>
      1: 0x1f9f6c0532e1 ; [fp + 32] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x101bfd32bd99 ; [fp + 24] 0x101bfd32bd99 <a TypeObject with map 0x33abe2a6d1e9>
      3: 0x00000000 ; [fp + 16] 0
      4: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      5: 0x1030c9d45451 ; rbx 0x1030c9d45451 <JS Function getSignaturesOfStructuredType (SharedFunctionInfo 0x2e2f693f0651)>
  reading input frame getSignaturesOfStructuredType => node=3, args=3, height=2; inputs:
      0: 0x1030c9d45451 ; (literal 10) 0x1030c9d45451 <JS Function getSignaturesOfStructuredType (SharedFunctionInfo 0x2e2f693f0651)>
      1: 0x1f9f6c0532e1 ; (literal 7) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x101bfd32bd99 ; rax 0x101bfd32bd99 <a TypeObject with map 0x33abe2a6d1e9>
      3: 0x00000000 ; [fp + 16] 0
      4: 0x130b7e1b3d29 ; (literal 8) 0x130b7e1b3d29 <FixedArray[1022]>
      5: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
  translating frame getSignaturesOfType => node=7, height=8
    0x7fff5fbfdae0: [top + 56] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdad8: [top + 48] <- 0x101bfd32bd99 ;  0x101bfd32bd99 <a TypeObject with map 0x33abe2a6d1e9>  (input #2)
    0x7fff5fbfdad0: [top + 40] <- 0x00000000 ;  0  (input #3)
    0x7fff5fbfdac8: [top + 32] <- 0x2c21d2630f10 ;  caller's pc
    0x7fff5fbfdac0: [top + 24] <- 0x7fff5fbfdb60 ;  caller's fp
    0x7fff5fbfdab8: [top + 16] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #4)
    0x7fff5fbfdab0: [top + 8] <- 0x130b7e1b6859 ;  function    0x130b7e1b6859 <JS Function getSignaturesOfType (SharedFunctionInfo 0x2e2f693f0711)>  (input #0)
    0x7fff5fbfdaa8: [top + 0] <- 0x1030c9d45451 ;  0x1030c9d45451 <JS Function getSignaturesOfStructuredType (SharedFunctionInfo 0x2e2f693f0651)>  (input #5)
  translating frame getSignaturesOfStructuredType => node=3, height=8
    0x7fff5fbfdaa0: [top + 56] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfda98: [top + 48] <- 0x101bfd32bd99 ;  0x101bfd32bd99 <a TypeObject with map 0x33abe2a6d1e9>  (input #2)
    0x7fff5fbfda90: [top + 40] <- 0x00000000 ;  0  (input #3)
    0x7fff5fbfda88: [top + 32] <- 0x2c21d2630944 ;  caller's pc
    0x7fff5fbfda80: [top + 24] <- 0x7fff5fbfdac0 ;  caller's fp
    0x7fff5fbfda78: [top + 16] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #4)
    0x7fff5fbfda70: [top + 8] <- 0x1030c9d45451 ;  function    0x1030c9d45451 <JS Function getSignaturesOfStructuredType (SharedFunctionInfo 0x2e2f693f0651)>  (input #0)
    0x7fff5fbfda68: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
[deoptimizing (eager): end 0x130b7e1b6859 <JS Function getSignaturesOfType (SharedFunctionInfo 0x2e2f693f0711)> @11 => node=3, pc=0x2c21d2630a0a, caller sp=0x7fff5fbfdae8, state=NO_REGISTERS, took 0.115 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSignaturesOfStructuredType) id{389,0} ---
(type, kind) {
            if (type.flags & 229376 /* StructuredType */) {
                var resolved = resolveStructuredTypeMembers(type);
                return kind === 0 /* Call */ ? resolved.callSignatures : resolved.constructSignatures;
            }
            return emptyArray;
        }
--- END ---
[deoptimizing (DEOPT eager): begin 0x1030c9d45451 <JS Function getSignaturesOfStructuredType (SharedFunctionInfo 0x2e2f693f0651)> (opt #389) @2, FP to SP delta: 24, caller sp: 0x7fff5fbfdaa8]
            ;;; deoptimize at 0_35: wrong map
  reading input frame getSignaturesOfStructuredType => node=4, args=3, height=2; inputs:
      0: 0x1030c9d45451 ; [fp - 16] 0x1030c9d45451 <JS Function getSignaturesOfStructuredType (SharedFunctionInfo 0x2e2f693f0651)>
      1: 0x1f9f6c0532e1 ; [fp + 32] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x101bfd32be69 ; rax 0x101bfd32be69 <a TypeObject with map 0x33abe2a6d349>
      3: 0x00000000 ; [fp + 16] 0
      4: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      5: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
  translating frame getSignaturesOfStructuredType => node=4, height=8
    0x7fff5fbfdaa0: [top + 56] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfda98: [top + 48] <- 0x101bfd32be69 ;  0x101bfd32be69 <a TypeObject with map 0x33abe2a6d349>  (input #2)
    0x7fff5fbfda90: [top + 40] <- 0x00000000 ;  0  (input #3)
    0x7fff5fbfda88: [top + 32] <- 0x2c21d2630944 ;  caller's pc
    0x7fff5fbfda80: [top + 24] <- 0x7fff5fbfdac0 ;  caller's fp
    0x7fff5fbfda78: [top + 16] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #4)
    0x7fff5fbfda70: [top + 8] <- 0x1030c9d45451 ;  function    0x1030c9d45451 <JS Function getSignaturesOfStructuredType (SharedFunctionInfo 0x2e2f693f0651)>  (input #0)
    0x7fff5fbfda68: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
[deoptimizing (eager): end 0x1030c9d45451 <JS Function getSignaturesOfStructuredType (SharedFunctionInfo 0x2e2f693f0651)> @2 => node=4, pc=0x2c21d2630a0a, caller sp=0x7fff5fbfdaa8, state=NO_REGISTERS, took 0.057 ms]
[deoptimizing (DEOPT eager): begin 0x130b7e1b6811 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)> (opt #376) @19, FP to SP delta: 320, caller sp: 0x7fff5fbfd4f8]
            ;;; deoptimize at 0_723: wrong map
  reading input frame resolveName => node=188, args=6, height=17; inputs:
      0: 0x130b7e1b6811 ; [fp - 16] 0x130b7e1b6811 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)>
      1: 0x1f9f6c0532e1 ; [fp + 56] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x33c68039f721 ; rbx 0x33c68039f721 <a NodeObject with map 0x33abe2a75591>
      3: 0x30bcea445541 ; [fp + 40] 0x30bcea445541 <String[1]: K>
      4: 0xc19e800000000 ; [fp + 32] 793064
      5: 0xd6230ded3a9 ; [fp + 24] 0xd6230ded3a9 <an Object with map 0x33abe2a3df61>
      6: 0x215b0af07b81 ; [fp + 16] 0x215b0af07b81 <an IdentifierObject with map 0x33abe2a6fb81>
      7: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      8: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
      9: 0x38be058b7511 ; [fp - 144] 0x38be058b7511 <a SymbolObject with map 0x33abe2a72ca9>
     10: 0xe0c907895b1 ; rax 0xe0c907895b1 <a NodeObject with map 0x33abe2a6fd39>
     11: 0x30bcea404311 ; [fp - 56] 0x30bcea404311 <undefined>
     12: 0x215b0af07b81 ; [fp + 48] 0x215b0af07b81 <an IdentifierObject with map 0x33abe2a6fb81>
     13: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     14: 0x30bcea404421 ; [fp - 48] 0x30bcea404421 <false>
     15: 0x30bcea4043b1 ; (literal 11) 0x30bcea4043b1 <true>
     16: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     17: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     18: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     19: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     20: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     21: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     22: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     23: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
  translating frame resolveName => node=188, height=128
    0x7fff5fbfd4f0: [top + 200] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd4e8: [top + 192] <- 0x33c68039f721 ;  0x33c68039f721 <a NodeObject with map 0x33abe2a75591>  (input #2)
    0x7fff5fbfd4e0: [top + 184] <- 0x30bcea445541 ;  0x30bcea445541 <String[1]: K>  (input #3)
    0x7fff5fbfd4d8: [top + 176] <- 0xc19e800000000 ;  793064  (input #4)
    0x7fff5fbfd4d0: [top + 168] <- 0xd6230ded3a9 ;  0xd6230ded3a9 <an Object with map 0x33abe2a3df61>  (input #5)
    0x7fff5fbfd4c8: [top + 160] <- 0x215b0af07b81 ;  0x215b0af07b81 <an IdentifierObject with map 0x33abe2a6fb81>  (input #6)
    0x7fff5fbfd4c0: [top + 152] <- 0x2c21d26139a6 ;  caller's pc
    0x7fff5fbfd4b8: [top + 144] <- 0x7fff5fbfd538 ;  caller's fp
    0x7fff5fbfd4b0: [top + 136] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #7)
    0x7fff5fbfd4a8: [top + 128] <- 0x130b7e1b6811 ;  function    0x130b7e1b6811 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)>  (input #0)
    0x7fff5fbfd4a0: [top + 120] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfd498: [top + 112] <- 0x38be058b7511 ;  0x38be058b7511 <a SymbolObject with map 0x33abe2a72ca9>  (input #9)
    0x7fff5fbfd490: [top + 104] <- 0xe0c907895b1 ;  0xe0c907895b1 <a NodeObject with map 0x33abe2a6fd39>  (input #10)
    0x7fff5fbfd488: [top + 96] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #11)
    0x7fff5fbfd480: [top + 88] <- 0x215b0af07b81 ;  0x215b0af07b81 <an IdentifierObject with map 0x33abe2a6fb81>  (input #12)
    0x7fff5fbfd478: [top + 80] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #13)
    0x7fff5fbfd470: [top + 72] <- 0x30bcea404421 ;  0x30bcea404421 <false>  (input #14)
    0x7fff5fbfd468: [top + 64] <- 0x30bcea4043b1 ;  0x30bcea4043b1 <true>  (input #15)
    0x7fff5fbfd460: [top + 56] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #16)
    0x7fff5fbfd458: [top + 48] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #17)
    0x7fff5fbfd450: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #18)
    0x7fff5fbfd448: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #19)
    0x7fff5fbfd440: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #20)
    0x7fff5fbfd438: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #21)
    0x7fff5fbfd430: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #22)
    0x7fff5fbfd428: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #23)
[deoptimizing (eager): end 0x130b7e1b6811 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)> @19 => node=188, pc=0x2c21d25e4425, caller sp=0x7fff5fbfd4f8, state=NO_REGISTERS, took 0.146 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d43ff9 <JS Function instantiateCached (SharedFunctionInfo 0x2e2f693f5881)> (opt #355) @6, FP to SP delta: 40, caller sp: 0x7fff5fbfd888]
            ;;; deoptimize at 0_157: wrong map
  reading input frame instantiateCached => node=18, args=4, height=3; inputs:
      0: 0x1030c9d43ff9 ; [fp - 16] 0x1030c9d43ff9 <JS Function instantiateCached (SharedFunctionInfo 0x2e2f693f5881)>
      1: 0x1f9f6c0532e1 ; [fp + 40] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x101bfd32daf9 ; rdi 0x101bfd32daf9 <a TypeObject with map 0x33abe2a741f9>
      3: 0x101bfd32d0a1 ; rax 0x101bfd32d0a1 <JS Function (SharedFunctionInfo 0x371f85cf0581)>
      4: 0x1030c9d559f9 ; [fp + 16] 0x1030c9d559f9 <JS Function instantiateAnonymousType (SharedFunctionInfo 0x2e2f693f6241)>
      5: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      6: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
      7: 0x101bfd32deb1 ; rbx 0x101bfd32deb1 <JS Array[0]>
  translating frame instantiateCached => node=18, height=16
    0x7fff5fbfd880: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd878: [top + 64] <- 0x101bfd32daf9 ;  0x101bfd32daf9 <a TypeObject with map 0x33abe2a741f9>  (input #2)
    0x7fff5fbfd870: [top + 56] <- 0x101bfd32d0a1 ;  0x101bfd32d0a1 <JS Function (SharedFunctionInfo 0x371f85cf0581)>  (input #3)
    0x7fff5fbfd868: [top + 48] <- 0x1030c9d559f9 ;  0x1030c9d559f9 <JS Function instantiateAnonymousType (SharedFunctionInfo 0x2e2f693f6241)>  (input #4)
    0x7fff5fbfd860: [top + 40] <- 0x2c21d261b129 ;  caller's pc
    0x7fff5fbfd858: [top + 32] <- 0x7fff5fbfd8a0 ;  caller's fp
    0x7fff5fbfd850: [top + 24] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #5)
    0x7fff5fbfd848: [top + 16] <- 0x1030c9d43ff9 ;  function    0x1030c9d43ff9 <JS Function instantiateCached (SharedFunctionInfo 0x2e2f693f5881)>  (input #0)
    0x7fff5fbfd840: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfd838: [top + 0] <- 0x101bfd32deb1 ;  0x101bfd32deb1 <JS Array[0]>  (input #7)
[deoptimizing (eager): end 0x1030c9d43ff9 <JS Function instantiateCached (SharedFunctionInfo 0x2e2f693f5881)> @6 => node=18, pc=0x2c21d261b888, caller sp=0x7fff5fbfd888, state=TOS_REGISTER, took 0.067 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d559f9 <JS Function instantiateAnonymousType (SharedFunctionInfo 0x2e2f693f6241)> (opt #356) @2, FP to SP delta: 48, caller sp: 0x7fff5fbfd828]
            ;;; deoptimize at 0_107: wrong map
  reading input frame instantiateAnonymousType => node=4, args=3, height=2; inputs:
      0: 0x1030c9d559f9 ; [fp - 16] 0x1030c9d559f9 <JS Function instantiateAnonymousType (SharedFunctionInfo 0x2e2f693f6241)>
      1: 0x1f9f6c0532e1 ; [fp + 32] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x101bfd32daf9 ; rdi 0x101bfd32daf9 <a TypeObject with map 0x33abe2a741f9>
      3: 0x101bfd32d0a1 ; [fp + 16] 0x101bfd32d0a1 <JS Function (SharedFunctionInfo 0x371f85cf0581)>
      4: 0x130b7e1b3d29 ; rbx 0x130b7e1b3d29 <FixedArray[1022]>
      5: 0x30bcea404311 ; (literal 11) 0x30bcea404311 <undefined>
  translating frame instantiateAnonymousType => node=4, height=8
    0x7fff5fbfd820: [top + 56] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd818: [top + 48] <- 0x101bfd32daf9 ;  0x101bfd32daf9 <a TypeObject with map 0x33abe2a741f9>  (input #2)
    0x7fff5fbfd810: [top + 40] <- 0x101bfd32d0a1 ;  0x101bfd32d0a1 <JS Function (SharedFunctionInfo 0x371f85cf0581)>  (input #3)
    0x7fff5fbfd808: [top + 32] <- 0x2c21d261b92d ;  caller's pc
    0x7fff5fbfd800: [top + 24] <- 0x7fff5fbfd858 ;  caller's fp
    0x7fff5fbfd7f8: [top + 16] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #4)
    0x7fff5fbfd7f0: [top + 8] <- 0x1030c9d559f9 ;  function    0x1030c9d559f9 <JS Function instantiateAnonymousType (SharedFunctionInfo 0x2e2f693f6241)>  (input #0)
    0x7fff5fbfd7e8: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
[deoptimizing (eager): end 0x1030c9d559f9 <JS Function instantiateAnonymousType (SharedFunctionInfo 0x2e2f693f6241)> @2 => node=4, pc=0x2c21d2634a0a, caller sp=0x7fff5fbfd828, state=NO_REGISTERS, took 0.081 ms]
[marking dependent code 0x2c21d265d661 (opt #338) for deoptimization, reason: prototype-check]
[deoptimize marked code in all contexts]
[deoptimizer unlinked: getTypeFromTypeNode / 130b7e1b67c9]
[deoptimizing (DEOPT eager): begin 0x1030c9d5b201 <JS Function checkParameter (SharedFunctionInfo 0x1b98fbc0a201)> (opt #340) @28, FP to SP delta: 112, caller sp: 0x7fff5fbfdd18]
            ;;; deoptimize at 0_1210: wrong map
  reading input frame checkParameter => node=340, args=2, height=4; inputs:
      0: 0x1030c9d5b201 ; [fp - 16] 0x1030c9d5b201 <JS Function checkParameter (SharedFunctionInfo 0x1b98fbc0a201)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0xe0c907cc311 ; [fp + 16] 0xe0c907cc311 <a NodeObject with map 0x33abe2a70999>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x33c6803f61a1 ; rbx 0x33c6803f61a1 <a NodeObject with map 0x33abe2a740f1>
      5: 0x16f3adb61821 ; [fp - 88] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      6: 0xd6230daf459 ; rax 0xd6230daf459 <JS Function indexOf (SharedFunctionInfo 0xc2bd2ae11e9)>
  translating frame checkParameter => node=340, height=24
    0x7fff5fbfdd10: [top + 64] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdd08: [top + 56] <- 0xe0c907cc311 ;  0xe0c907cc311 <a NodeObject with map 0x33abe2a70999>  (input #2)
    0x7fff5fbfdd00: [top + 48] <- 0x2c21d2207e55 ;  caller's pc
    0x7fff5fbfdcf8: [top + 40] <- 0x7fff5fbfdd30 ;  caller's fp
    0x7fff5fbfdcf0: [top + 32] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdce8: [top + 24] <- 0x1030c9d5b201 ;  function    0x1030c9d5b201 <JS Function checkParameter (SharedFunctionInfo 0x1b98fbc0a201)>  (input #0)
    0x7fff5fbfdce0: [top + 16] <- 0x33c6803f61a1 ;  0x33c6803f61a1 <a NodeObject with map 0x33abe2a740f1>  (input #4)
    0x7fff5fbfdcd8: [top + 8] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #5)
    0x7fff5fbfdcd0: [top + 0] <- 0xd6230daf459 ;  0xd6230daf459 <JS Function indexOf (SharedFunctionInfo 0xc2bd2ae11e9)>  (input #6)
[deoptimizing (eager): end 0x1030c9d5b201 <JS Function checkParameter (SharedFunctionInfo 0x1b98fbc0a201)> @28 => node=340, pc=0x2c21d2594578, caller sp=0x7fff5fbfdd18, state=TOS_REGISTER, took 0.297 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{390,0} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{390,1} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{390,1} AS 1 AT <0:120>
[deoptimizing (DEOPT eager): begin 0x1030c9d421e1 <JS Function checkMethodDeclaration (SharedFunctionInfo 0x1b98fbc0aa41)> (opt #354) @5, FP to SP delta: 32, caller sp: 0x7fff5fbfdef8]
            ;;; deoptimize at 0_118: wrong map
  reading input frame checkMethodDeclaration => node=7, args=2, height=1; inputs:
      0: 0x1030c9d421e1 ; [fp - 16] 0x1030c9d421e1 <JS Function checkMethodDeclaration (SharedFunctionInfo 0x1b98fbc0aa41)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x33c68039f721 ; rdx 0x33c68039f721 <a NodeObject with map 0x33abe2a75591>
      3: 0x130b7e1b3d29 ; rax 0x130b7e1b3d29 <FixedArray[1022]>
  translating frame checkMethodDeclaration => node=7, height=0
    0x7fff5fbfdef0: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdee8: [top + 32] <- 0x33c68039f721 ;  0x33c68039f721 <a NodeObject with map 0x33abe2a75591>  (input #2)
    0x7fff5fbfdee0: [top + 24] <- 0x2c21d25ec11a ;  caller's pc
    0x7fff5fbfded8: [top + 16] <- 0x7fff5fbfdf28 ;  caller's fp
    0x7fff5fbfded0: [top + 8] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdec8: [top + 0] <- 0x1030c9d421e1 ;  function    0x1030c9d421e1 <JS Function checkMethodDeclaration (SharedFunctionInfo 0x1b98fbc0aa41)>  (input #0)
[deoptimizing (eager): end 0x1030c9d421e1 <JS Function checkMethodDeclaration (SharedFunctionInfo 0x1b98fbc0aa41)> @5 => node=7, pc=0x2c21d26115cf, caller sp=0x7fff5fbfdef8, state=NO_REGISTERS, took 0.050 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveName) id{391,0} ---
(location, name, meaning, nameNotFoundMessage, nameArg) {
            var result;
            var lastLocation;
            var propertyWithInvalidInitializer;
            var errorLocation = location;
            var grandparent;
            var isInExternalModule = false;
            loop: while (location) {
                // Locals of a source file are not in scope (because they get merged into the global symbol table)
                if (location.locals && !isGlobalSourceFile(location)) {
                    if (result = getSymbol(location.locals, name, meaning)) {
                        var useResult = true;
                        if (ts.isFunctionLike(location) && lastLocation && lastLocation !== location.body) {
                            // symbol lookup restrictions for function-like declarations
                            // - Type parameters of a function are in scope in the entire function declaration, including the parameter
                            //   list and return type. However, local types are only in scope in the function body.
                            // - parameters are only in the scope of function body
                            // This restriction does not apply to JSDoc comment types because they are parented
                            // at a higher level than type parameters would normally be
                            if (meaning & result.flags & 793064 /* Type */ && lastLocation.kind !== 278 /* JSDocComment */) {
                                useResult = result.flags & 262144 /* TypeParameter */
                                    ? lastLocation === location.type ||
                                        lastLocation.kind === 144 /* Parameter */ ||
                                        lastLocation.kind === 143 /* TypeParameter */
                                    : false;
                            }
                            if (meaning & 107455 /* Value */ && result.flags & 1 /* FunctionScopedVariable */) {
                                // parameters are visible only inside function body, parameter list and return type
                                // technically for parameter list case here we might mix parameters and variables declared in function,
                                // however it is detected separately when checking initializers of parameters
                                // to make sure that they reference no variables declared after them.
                                useResult =
                                    lastLocation.kind === 144 /* Parameter */ ||
                                        (lastLocation === location.type &&
                                            result.valueDeclaration.kind === 144 /* Parameter */);
                            }
                        }
                        if (useResult) {
                            break loop;
                        }
                        else {
                            result = undefined;
                        }
                    }
                }
                switch (location.kind) {
                    case 261 /* SourceFile */:
                        if (!ts.isExternalOrCommonJsModule(location))
                            break;
                        isInExternalModule = true;
                    case 230 /* ModuleDeclaration */:
                        var moduleExports = getSymbolOfNode(location).exports;
                        if (location.kind === 261 /* SourceFile */ || ts.isAmbientModule(location)) {
                            // It's an external module. First see if the module has an export default and if the local
                            // name of that export default matches.
                            if (result = moduleExports["default"]) {
                                var localSymbol = ts.getLocalSymbolForExportDefault(result);
                                if (localSymbol && (result.flags & meaning) && localSymbol.name === name) {
                                    break loop;
                                }
                                result = undefined;
                            }
                            // Because of module/namespace merging, a module's exports are in scope,
                            // yet we never want to treat an export specifier as putting a member in scope.
                            // Therefore, if the name we find is purely an export specifier, it is not actually considered in scope.
                            // Two things to note about this:
                            //     1. We have to check this without calling getSymbol. The problem with calling getSymbol
                            //        on an export specifier is that it might find the export specifier itself, and try to
                            //        resolve it as an alias. This will cause the checker to consider the export specifier
                            //        a circular alias reference when it might not be.
                            //     2. We check === SymbolFlags.Alias in order to check that the symbol is *purely*
                            //        an alias. If we used &, we'd be throwing out symbols that have non alias aspects,
                            //        which is not the desired behavior.
                            if (moduleExports[name] &&
                                moduleExports[name].flags === 8388608 /* Alias */ &&
                                ts.getDeclarationOfKind(moduleExports[name], 243 /* ExportSpecifier */)) {
                                break;
                            }
                        }
                        if (result = getSymbol(moduleExports, name, meaning & 8914931 /* ModuleMember */)) {
                            break loop;
                        }
                        break;
                    case 229 /* EnumDeclaration */:
                        if (result = getSymbol(getSymbolOfNode(location).exports, name, meaning & 8 /* EnumMember */)) {
                            break loop;
                        }
                        break;
                    case 147 /* PropertyDeclaration */:
                    case 146 /* PropertySignature */:
                        // TypeScript 1.0 spec (April 2014): 8.4.1
                        // Initializer expressions for instance member variables are evaluated in the scope
                        // of the class constructor body but are not permitted to reference parameters or
                        // local variables of the constructor. This effectively means that entities from outer scopes
                        // by the same name as a constructor parameter or local variable are inaccessible
                        // in initializer expressions for instance member variables.
                        if (ts.isClassLike(location.parent) && !(ts.getModifierFlags(location) & 32 /* Static */)) {
                            var ctor = findConstructorDeclaration(location.parent);
                            if (ctor && ctor.locals) {
                                if (getSymbol(ctor.locals, name, meaning & 107455 /* Value */)) {
                                    // Remember the property node, it will be used later to report appropriate error
                                    propertyWithInvalidInitializer = location;
                                }
                            }
                        }
                        break;
                    case 226 /* ClassDeclaration */:
                    case 197 /* ClassExpression */:
                    case 227 /* InterfaceDeclaration */:
                        if (result = getSymbol(getSymbolOfNode(location).members, name, meaning & 793064 /* Type */)) {
                            if (lastLocation && ts.getModifierFlags(lastLocation) & 32 /* Static */) {
                                // TypeScript 1.0 spec (April 2014): 3.4.1
                                // The scope of a type parameter extends over the entire declaration with which the type
                                // parameter list is associated, with the exception of static member declarations in classes.
                                error(errorLocation, ts.Diagnostics.Static_members_cannot_reference_class_type_parameters);
                                return undefined;
                            }
                            break loop;
                        }
                        if (location.kind === 197 /* ClassExpression */ && meaning & 32 /* Class */) {
                            var className = location.name;
                            if (className && name === className.text) {
                                result = location.symbol;
                                break loop;
                            }
                        }
                        break;
                    // It is not legal to reference a class's own type parameters from a computed property name that
                    // belongs to the class. For example:
                    //
                    //   function foo<T>() { return '' }
                    //   class C<T> { // <-- Class's own type parameter T
                    //       [foo<T>()]() { } // <-- Reference to T from class's own computed property
                    //   }
                    //
                    case 142 /* ComputedPropertyName */:
                        grandparent = location.parent.parent;
                        if (ts.isClassLike(grandparent) || grandparent.kind === 227 /* InterfaceDeclaration */) {
                            // A reference to this grandparent's type parameters would be an error
                            if (result = getSymbol(getSymbolOfNode(grandparent).members, name, meaning & 793064 /* Type */)) {
                                error(errorLocation, ts.Diagnostics.A_computed_property_name_cannot_reference_a_type_parameter_from_its_containing_type);
                                return undefined;
                            }
                        }
                        break;
                    case 149 /* MethodDeclaration */:
                    case 148 /* MethodSignature */:
                    case 150 /* Constructor */:
                    case 151 /* GetAccessor */:
                    case 152 /* SetAccessor */:
                    case 225 /* FunctionDeclaration */:
                    case 185 /* ArrowFunction */:
                        if (meaning & 3 /* Variable */ && name === "arguments") {
                            result = argumentsSymbol;
                            break loop;
                        }
                        break;
                    case 184 /* FunctionExpression */:
                        if (meaning & 3 /* Variable */ && name === "arguments") {
                            result = argumentsSymbol;
                            break loop;
                        }
                        if (meaning & 16 /* Function */) {
                            var functionName = location.name;
                            if (functionName && name === functionName.text) {
                                result = location.symbol;
                                break loop;
                            }
                        }
                        break;
                    case 145 /* Decorator */:
                        // Decorators are resolved at the class declaration. Resolving at the parameter
                        // or member would result in looking up locals in the method.
                        //
                        //   function y() {}
                        //   class C {
                        //       method(@y x, y) {} // <-- decorator y should be resolved at the class declaration, not the parameter.
                        //   }
                        //
                        if (location.parent && location.parent.kind === 144 /* Parameter */) {
                            location = location.parent;
                        }
                        //
                        //   function y() {}
                        //   class C {
                        //       @y method(x, y) {} // <-- decorator y should be resolved at the class declaration, not the method.
                        //   }
                        //
                        if (location.parent && ts.isClassElement(location.parent)) {
                            location = location.parent;
                        }
                        break;
                }
                lastLocation = location;
                location = location.parent;
            }
            if (result && nameNotFoundMessage && noUnusedIdentifiers) {
                result.isReferenced = true;
            }
            if (!result) {
                result = getSymbol(globals, name, meaning);
            }
            if (!result) {
                if (nameNotFoundMessage) {
                    if (!errorLocation ||
                        !checkAndReportErrorForMissingPrefix(errorLocation, name, nameArg) &&
                            !checkAndReportErrorForExtendingInterface(errorLocation) &&
                            !checkAndReportErrorForUsingTypeAsNamespace(errorLocation, name, meaning) &&
                            !checkAndReportErrorForUsingTypeAsValue(errorLocation, name, meaning)) {
                        error(errorLocation, nameNotFoundMessage, typeof nameArg === "string" ? nameArg : ts.declarationNameToString(nameArg));
                    }
                }
                return undefined;
            }
            // Perform extra checks only if error reporting was requested
            if (nameNotFoundMessage) {
                if (propertyWithInvalidInitializer) {
                    // We have a match, but the reference occurred within a property initializer and the identifier also binds
                    // to a local variable in the constructor where the code will be emitted.
                    var propertyName = propertyWithInvalidInitializer.name;
                    error(errorLocation, ts.Diagnostics.Initializer_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor, ts.declarationNameToString(propertyName), typeof nameArg === "string" ? nameArg : ts.declarationNameToString(nameArg));
                    return undefined;
                }
                // Only check for block-scoped variable if we are looking for the
                // name with variable meaning
                //      For example,
                //          declare module foo {
                //              interface bar {}
                //          }
                //      const foo/*1*/: foo/*2*/.bar;
                // The foo at /*1*/ and /*2*/ will share same symbol with two meaning
                // block - scope variable and namespace module. However, only when we
                // try to resolve name in /*1*/ which is used in variable position,
                // we want to check for block- scoped
                if (meaning & 2 /* BlockScopedVariable */) {
                    var exportOrLocalSymbol = getExportSymbolOfValueSymbolIfExported(result);
                    if (exportOrLocalSymbol.flags & 2 /* BlockScopedVariable */) {
                        checkResolvedBlockScopedVariable(exportOrLocalSymbol, errorLocation);
                    }
                }
                // If we're in an external module, we can't reference value symbols created from UMD export declarations
                if (result && isInExternalModule && (meaning & 107455 /* Value */) === 107455 /* Value */) {
                    var decls = result.declarations;
                    if (decls && decls.length === 1 && decls[0].kind === 233 /* NamespaceExportDeclaration */) {
                        error(errorLocation, ts.Diagnostics._0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead, name);
                    }
                }
            }
            return result;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isGlobalSourceFile) id{391,1} ---
(node) {
            return node.kind === 261 /* SourceFile */ && !ts.isExternalOrCommonJsModule(node);
        }
--- END ---
INLINE (isGlobalSourceFile) id{391,1} AS 1 AT <0:467>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{391,2} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{391,2} AS 2 AT <0:3412>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{391,3} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{391,3} AS 3 AT <2:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{391,4} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{391,4} AS 4 AT <0:7735>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{391,5} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{391,5} AS 5 AT <4:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkSourceElement) id{392,0} ---
(node) {
            if (!node) {
                return;
            }
            var kind = node.kind;
            if (cancellationToken) {
                // Only bother checking on a few construct kinds.  We don't want to be excessively
                // hitting the cancellation token on every node we check.
                switch (kind) {
                    case 230 /* ModuleDeclaration */:
                    case 226 /* ClassDeclaration */:
                    case 227 /* InterfaceDeclaration */:
                    case 225 /* FunctionDeclaration */:
                        cancellationToken.throwIfCancellationRequested();
                }
            }
            switch (kind) {
                case 143 /* TypeParameter */:
                    return checkTypeParameter(node);
                case 144 /* Parameter */:
                    return checkParameter(node);
                case 147 /* PropertyDeclaration */:
                case 146 /* PropertySignature */:
                    return checkPropertyDeclaration(node);
                case 158 /* FunctionType */:
                case 159 /* ConstructorType */:
                case 153 /* CallSignature */:
                case 154 /* ConstructSignature */:
                    return checkSignatureDeclaration(node);
                case 155 /* IndexSignature */:
                    return checkSignatureDeclaration(node);
                case 149 /* MethodDeclaration */:
                case 148 /* MethodSignature */:
                    return checkMethodDeclaration(node);
                case 150 /* Constructor */:
                    return checkConstructorDeclaration(node);
                case 151 /* GetAccessor */:
                case 152 /* SetAccessor */:
                    return checkAccessorDeclaration(node);
                case 157 /* TypeReference */:
                    return checkTypeReferenceNode(node);
                case 156 /* TypePredicate */:
                    return checkTypePredicate(node);
                case 160 /* TypeQuery */:
                    return checkTypeQuery(node);
                case 161 /* TypeLiteral */:
                    return checkTypeLiteral(node);
                case 162 /* ArrayType */:
                    return checkArrayType(node);
                case 163 /* TupleType */:
                    return checkTupleType(node);
                case 164 /* UnionType */:
                case 165 /* IntersectionType */:
                    return checkUnionOrIntersectionType(node);
                case 166 /* ParenthesizedType */:
                case 168 /* TypeOperator */:
                    return checkSourceElement(node.type);
                case 169 /* IndexedAccessType */:
                    return checkIndexedAccessType(node);
                case 170 /* MappedType */:
                    return checkMappedType(node);
                case 225 /* FunctionDeclaration */:
                    return checkFunctionDeclaration(node);
                case 204 /* Block */:
                case 231 /* ModuleBlock */:
                    return checkBlock(node);
                case 205 /* VariableStatement */:
                    return checkVariableStatement(node);
                case 207 /* ExpressionStatement */:
                    return checkExpressionStatement(node);
                case 208 /* IfStatement */:
                    return checkIfStatement(node);
                case 209 /* DoStatement */:
                    return checkDoStatement(node);
                case 210 /* WhileStatement */:
                    return checkWhileStatement(node);
                case 211 /* ForStatement */:
                    return checkForStatement(node);
                case 212 /* ForInStatement */:
                    return checkForInStatement(node);
                case 213 /* ForOfStatement */:
                    return checkForOfStatement(node);
                case 214 /* ContinueStatement */:
                case 215 /* BreakStatement */:
                    return checkBreakOrContinueStatement(node);
                case 216 /* ReturnStatement */:
                    return checkReturnStatement(node);
                case 217 /* WithStatement */:
                    return checkWithStatement(node);
                case 218 /* SwitchStatement */:
                    return checkSwitchStatement(node);
                case 219 /* LabeledStatement */:
                    return checkLabeledStatement(node);
                case 220 /* ThrowStatement */:
                    return checkThrowStatement(node);
                case 221 /* TryStatement */:
                    return checkTryStatement(node);
                case 223 /* VariableDeclaration */:
                    return checkVariableDeclaration(node);
                case 174 /* BindingElement */:
                    return checkBindingElement(node);
                case 226 /* ClassDeclaration */:
                    return checkClassDeclaration(node);
                case 227 /* InterfaceDeclaration */:
                    return checkInterfaceDeclaration(node);
                case 228 /* TypeAliasDeclaration */:
                    return checkTypeAliasDeclaration(node);
                case 229 /* EnumDeclaration */:
                    return checkEnumDeclaration(node);
                case 230 /* ModuleDeclaration */:
                    return checkModuleDeclaration(node);
                case 235 /* ImportDeclaration */:
                    return checkImportDeclaration(node);
                case 234 /* ImportEqualsDeclaration */:
                    return checkImportEqualsDeclaration(node);
                case 241 /* ExportDeclaration */:
                    return checkExportDeclaration(node);
                case 240 /* ExportAssignment */:
                    return checkExportAssignment(node);
                case 206 /* EmptyStatement */:
                    checkGrammarStatementInAmbientContext(node);
                    return;
                case 222 /* DebuggerStatement */:
                    checkGrammarStatementInAmbientContext(node);
                    return;
                case 244 /* MissingDeclaration */:
                    return checkMissingDeclaration(node);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkTypeParameter) id{392,1} ---
(node) {
            // Grammar Checking
            if (node.expression) {
                grammarErrorOnFirstToken(node.expression, ts.Diagnostics.Type_expected);
            }
            checkSourceElement(node.constraint);
            getConstraintOfTypeParameter(getDeclaredTypeOfTypeParameter(getSymbolOfNode(node)));
            if (produceDiagnostics) {
                checkTypeNameIsReserved(node.name, ts.Diagnostics.Type_parameter_name_cannot_be_0);
            }
        }
--- END ---
INLINE (checkTypeParameter) id{392,1} AS 1 AT <0:775>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{392,2} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{392,2} AS 2 AT <1:300>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{392,3} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{392,3} AS 3 AT <2:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getDeclaredTypeOfTypeParameter) id{392,4} ---
(symbol) {
            var links = getSymbolLinks(symbol);
            if (!links.declaredType) {
                var type = createType(16384 /* TypeParameter */);
                type.symbol = symbol;
                if (!ts.getDeclarationOfKind(symbol, 143 /* TypeParameter */).constraint) {
                    type.constraint = noConstraintType;
                }
                links.declaredType = type;
            }
            return links.declaredType;
        }
--- END ---
INLINE (getDeclaredTypeOfTypeParameter) id{392,4} AS 4 AT <1:269>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{392,5} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{392,5} AS 5 AT <4:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{392,6} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{392,6} AS 6 AT <5:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{392,7} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{392,7} AS 7 AT <4:125>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{392,8} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{392,8} AS 8 AT <7:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkTypeNameIsReserved) id{392,9} ---
(name, message) {
            // TS 1.0 spec (April 2014): 3.6.1
            // The predefined type keywords are reserved and cannot be used as names of user defined types.
            switch (name.text) {
                case "any":
                case "number":
                case "boolean":
                case "string":
                case "symbol":
                case "void":
                    error(name, message, name.text);
            }
        }
--- END ---
INLINE (checkTypeNameIsReserved) id{392,9} AS 9 AT <1:379>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkPropertyDeclaration) id{392,10} ---
(node) {
            // Grammar checking
            checkGrammarDecorators(node) || checkGrammarModifiers(node) || checkGrammarProperty(node) || checkGrammarComputedPropertyName(node.name);
            checkVariableLikeDeclaration(node);
        }
--- END ---
INLINE (checkPropertyDeclaration) id{392,10} AS 10 AT <0:1021>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarComputedPropertyName) id{392,11} ---
(node) {
            // If node is not a computedPropertyName, just skip the grammar checking
            if (node.kind !== 142 /* ComputedPropertyName */) {
                return false;
            }
            var computedPropertyName = node;
            if (computedPropertyName.expression.kind === 192 /* BinaryExpression */ && computedPropertyName.expression.operatorToken.kind === 25 /* CommaToken */) {
                return grammarErrorOnNode(computedPropertyName.expression, ts.Diagnostics.A_comma_expression_is_not_allowed_in_a_computed_property_name);
            }
        }
--- END ---
INLINE (checkGrammarComputedPropertyName) id{392,11} AS 11 AT <10:146>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkTypeLiteral) id{392,12} ---
(node) {
            ts.forEach(node.members, checkSourceElement);
            if (produceDiagnostics) {
                var type = getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode(node);
                checkIndexConstraints(type);
                checkTypeForDuplicateIndexSignatures(node);
                checkObjectTypeForDuplicateDeclarations(node);
            }
        }
--- END ---
INLINE (checkTypeLiteral) id{392,12} AS 12 AT <0:2182>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkArrayType) id{392,13} ---
(node) {
            checkSourceElement(node.elementType);
        }
--- END ---
INLINE (checkArrayType) id{392,13} AS 13 AT <0:2275>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkTupleType) id{392,14} ---
(node) {
            // Grammar checking
            var hasErrorFromDisallowedTrailingComma = checkGrammarForDisallowedTrailingComma(node.elementTypes);
            if (!hasErrorFromDisallowedTrailingComma && node.elementTypes.length === 0) {
                grammarErrorOnNode(node, ts.Diagnostics.A_tuple_type_element_list_cannot_be_empty);
            }
            ts.forEach(node.elementTypes, checkSourceElement);
        }
--- END ---
INLINE (checkTupleType) id{392,14} AS 14 AT <0:2366>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarForDisallowedTrailingComma) id{392,15} ---
(list) {
            if (list && list.hasTrailingComma) {
                var start = list.end - ",".length;
                var end = list.end;
                var sourceFile = ts.getSourceFileOfNode(list[0]);
                return grammarErrorAtPos(sourceFile, start, end - start, ts.Diagnostics.Trailing_comma_not_allowed);
            }
        }
--- END ---
INLINE (checkGrammarForDisallowedTrailingComma) id{392,15} AS 15 AT <14:95>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getCombinedModifierFlags) id{393,0} ---
(node) {
        node = walkUpBindingElementsAndPatterns(node);
        var flags = ts.getModifierFlags(node);
        if (node.kind === 223 /* VariableDeclaration */) {
            node = node.parent;
        }
        if (node && node.kind === 224 /* VariableDeclarationList */) {
            flags |= ts.getModifierFlags(node);
            node = node.parent;
        }
        if (node && node.kind === 205 /* VariableStatement */) {
            flags |= ts.getModifierFlags(node);
        }
        return flags;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:walkUpBindingElementsAndPatterns) id{393,1} ---
(node) {
        while (node && (node.kind === 174 /* BindingElement */ || ts.isBindingPattern(node))) {
            node = node.parent;
        }
        return node;
    }
--- END ---
INLINE (walkUpBindingElementsAndPatterns) id{393,1} AS 1 AT <0:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getCombinedNodeFlags) id{394,0} ---
(node) {
        node = walkUpBindingElementsAndPatterns(node);
        var flags = node.flags;
        if (node.kind === 223 /* VariableDeclaration */) {
            node = node.parent;
        }
        if (node && node.kind === 224 /* VariableDeclarationList */) {
            flags |= node.flags;
            node = node.parent;
        }
        if (node && node.kind === 205 /* VariableStatement */) {
            flags |= node.flags;
        }
        return flags;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:walkUpBindingElementsAndPatterns) id{394,1} ---
(node) {
        while (node && (node.kind === 174 /* BindingElement */ || ts.isBindingPattern(node))) {
            node = node.parent;
        }
        return node;
    }
--- END ---
INLINE (walkUpBindingElementsAndPatterns) id{394,1} AS 1 AT <0:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveDeclaredMembers) id{395,0} ---
(type) {
            if (!type.declaredProperties) {
                var symbol = type.symbol;
                type.declaredProperties = getNamedMembers(symbol.members);
                type.declaredCallSignatures = getSignaturesOfSymbol(symbol.members["__call"]);
                type.declaredConstructSignatures = getSignaturesOfSymbol(symbol.members["__new"]);
                type.declaredStringIndexInfo = getIndexInfoOfSymbol(symbol, 0 /* String */);
                type.declaredNumberIndexInfo = getIndexInfoOfSymbol(symbol, 1 /* Number */);
            }
            return type;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNamedMembers) id{395,1} ---
(members) {
            var result;
            for (var id in members) {
                if (!isReservedMemberName(id)) {
                    if (!result)
                        result = [];
                    var symbol = members[id];
                    if (symbolIsValue(symbol)) {
                        result.push(symbol);
                    }
                }
            }
            return result || emptyArray;
        }
--- END ---
INLINE (getNamedMembers) id{395,1} AS 1 AT <0:137>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isReservedMemberName) id{395,2} ---
(name) {
            return name.charCodeAt(0) === 95 /* _ */ &&
                name.charCodeAt(1) === 95 /* _ */ &&
                name.charCodeAt(2) !== 95 /* _ */ &&
                name.charCodeAt(2) !== 64 /* at */;
        }
--- END ---
INLINE (isReservedMemberName) id{395,2} AS 2 AT <1:95>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexInfoOfSymbol) id{395,3} ---
(symbol, kind) {
            var declaration = getIndexDeclarationOfSymbol(symbol, kind);
            if (declaration) {
                return createIndexInfo(declaration.type ? getTypeFromTypeNode(declaration.type) : anyType, (ts.getModifierFlags(declaration) & 64 /* Readonly */) !== 0, declaration);
            }
            return undefined;
        }
--- END ---
INLINE (getIndexInfoOfSymbol) id{395,3} AS 3 AT <0:411>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createIndexInfo) id{395,4} ---
(type, isReadonly, declaration) {
            return { type: type, isReadonly: isReadonly, declaration: declaration };
        }
--- END ---
INLINE (createIndexInfo) id{395,4} AS 4 AT <3:144>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexInfoOfSymbol) id{395,5} ---
(symbol, kind) {
            var declaration = getIndexDeclarationOfSymbol(symbol, kind);
            if (declaration) {
                return createIndexInfo(declaration.type ? getTypeFromTypeNode(declaration.type) : anyType, (ts.getModifierFlags(declaration) & 64 /* Readonly */) !== 0, declaration);
            }
            return undefined;
        }
--- END ---
INLINE (getIndexInfoOfSymbol) id{395,5} AS 5 AT <0:504>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createIndexInfo) id{395,6} ---
(type, isReadonly, declaration) {
            return { type: type, isReadonly: isReadonly, declaration: declaration };
        }
--- END ---
INLINE (createIndexInfo) id{395,6} AS 6 AT <5:144>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getEffectiveDeclarationFlags) id{396,0} ---
(n, flagsToCheck) {
            var flags = ts.getCombinedModifierFlags(n);
            // children of classes (even ambient classes) should not be marked as ambient or export
            // because those flags have no useful semantics there.
            if (n.parent.kind !== 227 /* InterfaceDeclaration */ &&
                n.parent.kind !== 226 /* ClassDeclaration */ &&
                n.parent.kind !== 197 /* ClassExpression */ &&
                ts.isInAmbientContext(n)) {
                if (!(flags & 2 /* Ambient */)) {
                    // It is nested in an ambient context, which means it is automatically exported
                    flags |= 1 /* Export */;
                }
                flags |= 2 /* Ambient */;
            }
            return flags & flagsToCheck;
        }
--- END ---
[deoptimizing (DEOPT eager): begin 0x130b7e1b5e49 <JS Function getPropertyOfType (SharedFunctionInfo 0x2e2f693f0591)> (opt #388) @15, FP to SP delta: 64, caller sp: 0x7fff5fbfdc70]
            ;;; deoptimize at 0_212: Unknown map in polymorphic access
  reading input frame getPropertyOfType => node=65, args=3, height=5; inputs:
      0: 0x130b7e1b5e49 ; [fp - 16] 0x130b7e1b5e49 <JS Function getPropertyOfType (SharedFunctionInfo 0x2e2f693f0591)>
      1: 0x1f9f6c0532e1 ; [fp + 32] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x101bfd366819 ; [fp - 48] 0x101bfd366819 <a TypeObject with map 0x33abe2a73f91>
      3: 0x286514cf1e21 ; [fp + 16] 0x286514cf1e21 <String[16]: addEventListener>
      4: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      5: 0x30bcea404311 ; (literal 3) 0x30bcea404311 <undefined>
      6: 0x30bcea404311 ; (literal 3) 0x30bcea404311 <undefined>
      7: 0x30bcea404311 ; (literal 3) 0x30bcea404311 <undefined>
      8: 0x101bfd366819 ; rax 0x101bfd366819 <a TypeObject with map 0x33abe2a73f91>
  translating frame getPropertyOfType => node=65, height=32
    0x7fff5fbfdc68: [top + 80] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdc60: [top + 72] <- 0x101bfd366819 ;  0x101bfd366819 <a TypeObject with map 0x33abe2a73f91>  (input #2)
    0x7fff5fbfdc58: [top + 64] <- 0x286514cf1e21 ;  0x286514cf1e21 <String[16]: addEventListener>  (input #3)
    0x7fff5fbfdc50: [top + 56] <- 0x2c21d262cf63 ;  caller's pc
    0x7fff5fbfdc48: [top + 48] <- 0x7fff5fbfdcf0 ;  caller's fp
    0x7fff5fbfdc40: [top + 40] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #4)
    0x7fff5fbfdc38: [top + 32] <- 0x130b7e1b5e49 ;  function    0x130b7e1b5e49 <JS Function getPropertyOfType (SharedFunctionInfo 0x2e2f693f0591)>  (input #0)
    0x7fff5fbfdc30: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfdc28: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfdc20: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfdc18: [top + 0] <- 0x101bfd366819 ;  0x101bfd366819 <a TypeObject with map 0x33abe2a73f91>  (input #8)
[deoptimizing (eager): end 0x130b7e1b5e49 <JS Function getPropertyOfType (SharedFunctionInfo 0x2e2f693f0591)> @15 => node=65, pc=0x2c21d262ff1c, caller sp=0x7fff5fbfdc70, state=TOS_REGISTER, took 0.071 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveStructuredTypeMembers) id{397,0} ---
(type) {
            if (!type.members) {
                if (type.flags & 32768 /* Object */) {
                    if (type.objectFlags & 4 /* Reference */) {
                        resolveTypeReferenceMembers(type);
                    }
                    else if (type.objectFlags & 3 /* ClassOrInterface */) {
                        resolveClassOrInterfaceMembers(type);
                    }
                    else if (type.objectFlags & 16 /* Anonymous */) {
                        resolveAnonymousTypeMembers(type);
                    }
                    else if (type.objectFlags & 32 /* Mapped */) {
                        resolveMappedTypeMembers(type);
                    }
                }
                else if (type.flags & 65536 /* Union */) {
                    resolveUnionTypeMembers(type);
                }
                else if (type.flags & 131072 /* Intersection */) {
                    resolveIntersectionTypeMembers(type);
                }
            }
            return type;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveTypeReferenceMembers) id{397,1} ---
(type) {
            var source = resolveDeclaredMembers(type.target);
            var typeParameters = ts.concatenate(source.typeParameters, [source.thisType]);
            var typeArguments = type.typeArguments && type.typeArguments.length === typeParameters.length ?
                type.typeArguments : ts.concatenate(type.typeArguments, [type]);
            resolveObjectTypeMembers(type, source, typeParameters, typeArguments);
        }
--- END ---
INLINE (resolveTypeReferenceMembers) id{397,1} AS 1 AT <0:185>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveDeclaredMembers) id{397,2} ---
(type) {
            if (!type.declaredProperties) {
                var symbol = type.symbol;
                type.declaredProperties = getNamedMembers(symbol.members);
                type.declaredCallSignatures = getSignaturesOfSymbol(symbol.members["__call"]);
                type.declaredConstructSignatures = getSignaturesOfSymbol(symbol.members["__new"]);
                type.declaredStringIndexInfo = getIndexInfoOfSymbol(symbol, 0 /* String */);
                type.declaredNumberIndexInfo = getIndexInfoOfSymbol(symbol, 1 /* Number */);
            }
            return type;
        }
--- END ---
INLINE (resolveDeclaredMembers) id{397,2} AS 2 AT <1:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNamedMembers) id{397,3} ---
(members) {
            var result;
            for (var id in members) {
                if (!isReservedMemberName(id)) {
                    if (!result)
                        result = [];
                    var symbol = members[id];
                    if (symbolIsValue(symbol)) {
                        result.push(symbol);
                    }
                }
            }
            return result || emptyArray;
        }
--- END ---
INLINE (getNamedMembers) id{397,3} AS 3 AT <2:137>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isReservedMemberName) id{397,4} ---
(name) {
            return name.charCodeAt(0) === 95 /* _ */ &&
                name.charCodeAt(1) === 95 /* _ */ &&
                name.charCodeAt(2) !== 95 /* _ */ &&
                name.charCodeAt(2) !== 64 /* at */;
        }
--- END ---
INLINE (isReservedMemberName) id{397,4} AS 4 AT <3:95>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexInfoOfSymbol) id{397,5} ---
(symbol, kind) {
            var declaration = getIndexDeclarationOfSymbol(symbol, kind);
            if (declaration) {
                return createIndexInfo(declaration.type ? getTypeFromTypeNode(declaration.type) : anyType, (ts.getModifierFlags(declaration) & 64 /* Readonly */) !== 0, declaration);
            }
            return undefined;
        }
--- END ---
INLINE (getIndexInfoOfSymbol) id{397,5} AS 5 AT <2:411>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createIndexInfo) id{397,6} ---
(type, isReadonly, declaration) {
            return { type: type, isReadonly: isReadonly, declaration: declaration };
        }
--- END ---
INLINE (createIndexInfo) id{397,6} AS 6 AT <5:144>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexInfoOfSymbol) id{397,7} ---
(symbol, kind) {
            var declaration = getIndexDeclarationOfSymbol(symbol, kind);
            if (declaration) {
                return createIndexInfo(declaration.type ? getTypeFromTypeNode(declaration.type) : anyType, (ts.getModifierFlags(declaration) & 64 /* Readonly */) !== 0, declaration);
            }
            return undefined;
        }
--- END ---
INLINE (getIndexInfoOfSymbol) id{397,7} AS 7 AT <2:504>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createIndexInfo) id{397,8} ---
(type, isReadonly, declaration) {
            return { type: type, isReadonly: isReadonly, declaration: declaration };
        }
--- END ---
INLINE (createIndexInfo) id{397,8} AS 8 AT <7:144>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveClassOrInterfaceMembers) id{397,9} ---
(type) {
            resolveObjectTypeMembers(type, resolveDeclaredMembers(type), emptyArray, emptyArray);
        }
--- END ---
INLINE (resolveClassOrInterfaceMembers) id{397,9} AS 9 AT <0:342>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveDeclaredMembers) id{397,10} ---
(type) {
            if (!type.declaredProperties) {
                var symbol = type.symbol;
                type.declaredProperties = getNamedMembers(symbol.members);
                type.declaredCallSignatures = getSignaturesOfSymbol(symbol.members["__call"]);
                type.declaredConstructSignatures = getSignaturesOfSymbol(symbol.members["__new"]);
                type.declaredStringIndexInfo = getIndexInfoOfSymbol(symbol, 0 /* String */);
                type.declaredNumberIndexInfo = getIndexInfoOfSymbol(symbol, 1 /* Number */);
            }
            return type;
        }
--- END ---
INLINE (resolveDeclaredMembers) id{397,10} AS 10 AT <9:52>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNamedMembers) id{397,11} ---
(members) {
            var result;
            for (var id in members) {
                if (!isReservedMemberName(id)) {
                    if (!result)
                        result = [];
                    var symbol = members[id];
                    if (symbolIsValue(symbol)) {
                        result.push(symbol);
                    }
                }
            }
            return result || emptyArray;
        }
--- END ---
INLINE (getNamedMembers) id{397,11} AS 11 AT <10:137>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isReservedMemberName) id{397,12} ---
(name) {
            return name.charCodeAt(0) === 95 /* _ */ &&
                name.charCodeAt(1) === 95 /* _ */ &&
                name.charCodeAt(2) !== 95 /* _ */ &&
                name.charCodeAt(2) !== 64 /* at */;
        }
--- END ---
INLINE (isReservedMemberName) id{397,12} AS 12 AT <11:95>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveEntityName) id{398,0} ---
(name, meaning, ignoreErrors, dontResolveAlias, location) {
            if (ts.nodeIsMissing(name)) {
                return undefined;
            }
            var symbol;
            if (name.kind === 70 /* Identifier */) {
                var message = meaning === 1920 /* Namespace */ ? ts.Diagnostics.Cannot_find_namespace_0 : ts.Diagnostics.Cannot_find_name_0;
                symbol = resolveName(location || name, name.text, meaning, ignoreErrors ? undefined : message, name);
                if (!symbol) {
                    return undefined;
                }
            }
            else if (name.kind === 141 /* QualifiedName */ || name.kind === 177 /* PropertyAccessExpression */) {
                var left = name.kind === 141 /* QualifiedName */ ? name.left : name.expression;
                var right = name.kind === 141 /* QualifiedName */ ? name.right : name.name;
                var namespace = resolveEntityName(left, 1920 /* Namespace */, ignoreErrors, /*dontResolveAlias*/ false, location);
                if (!namespace || ts.nodeIsMissing(right)) {
                    return undefined;
                }
                else if (namespace === unknownSymbol) {
                    return namespace;
                }
                symbol = getSymbol(getExportsOfSymbol(namespace), right.text, meaning);
                if (!symbol) {
                    if (!ignoreErrors) {
                        error(right, ts.Diagnostics.Namespace_0_has_no_exported_member_1, getFullyQualifiedName(namespace), ts.declarationNameToString(right));
                    }
                    return undefined;
                }
            }
            else {
                ts.Debug.fail("Unknown entity name kind.");
            }
            ts.Debug.assert((symbol.flags & 16777216 /* Instantiated */) === 0, "Should never get an instantiated symbol here.");
            return (symbol.flags & meaning) || dontResolveAlias ? symbol : resolveAlias(symbol);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getExportsOfSymbol) id{398,1} ---
(symbol) {
            return symbol.flags & 1536 /* Module */ ? getExportsOfModule(symbol) : symbol.exports || emptySymbols;
        }
--- END ---
INLINE (getExportsOfSymbol) id{398,1} AS 1 AT <0:1284>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getExportsOfModule) id{398,2} ---
(moduleSymbol) {
            var links = getSymbolLinks(moduleSymbol);
            return links.resolvedExports || (links.resolvedExports = getExportsForModule(moduleSymbol));
        }
--- END ---
INLINE (getExportsOfModule) id{398,2} AS 2 AT <1:65>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{398,3} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{398,3} AS 3 AT <2:41>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{398,4} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{398,4} AS 4 AT <3:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSignaturesOfType) id{399,0} ---
(type, kind) {
            return getSignaturesOfStructuredType(getApparentType(type), kind);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getApparentType) id{399,1} ---
(type) {
            var t = type.flags & 540672 /* TypeVariable */ ? getApparentTypeOfTypeVariable(type) : type;
            return t.flags & 262178 /* StringLike */ ? globalStringType :
                t.flags & 340 /* NumberLike */ ? globalNumberType :
                    t.flags & 136 /* BooleanLike */ ? globalBooleanType :
                        t.flags & 512 /* ESSymbol */ ? getGlobalESSymbolType() :
                            t;
        }
--- END ---
INLINE (getApparentType) id{399,1} AS 1 AT <0:64>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSignaturesOfStructuredType) id{399,2} ---
(type, kind) {
            if (type.flags & 229376 /* StructuredType */) {
                var resolved = resolveStructuredTypeMembers(type);
                return kind === 0 /* Call */ ? resolved.callSignatures : resolved.constructSignatures;
            }
            return emptyArray;
        }
--- END ---
INLINE (getSignaturesOfStructuredType) id{399,2} AS 2 AT <0:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeFromTypeNode) id{400,0} ---
(node) {
            switch (node.kind) {
                case 118 /* AnyKeyword */:
                case 263 /* JSDocAllType */:
                case 264 /* JSDocUnknownType */:
                    return anyType;
                case 134 /* StringKeyword */:
                    return stringType;
                case 132 /* NumberKeyword */:
                    return numberType;
                case 121 /* BooleanKeyword */:
                    return booleanType;
                case 135 /* SymbolKeyword */:
                    return esSymbolType;
                case 104 /* VoidKeyword */:
                    return voidType;
                case 137 /* UndefinedKeyword */:
                    return undefinedType;
                case 94 /* NullKeyword */:
                    return nullType;
                case 129 /* NeverKeyword */:
                    return neverType;
                case 289 /* JSDocNullKeyword */:
                    return nullType;
                case 290 /* JSDocUndefinedKeyword */:
                    return undefinedType;
                case 291 /* JSDocNeverKeyword */:
                    return neverType;
                case 167 /* ThisType */:
                case 98 /* ThisKeyword */:
                    return getTypeFromThisTypeNode(node);
                case 171 /* LiteralType */:
                    return getTypeFromLiteralTypeNode(node);
                case 288 /* JSDocLiteralType */:
                    return getTypeFromLiteralTypeNode(node.literal);
                case 157 /* TypeReference */:
                case 272 /* JSDocTypeReference */:
                    return getTypeFromTypeReference(node);
                case 156 /* TypePredicate */:
                    return booleanType;
                case 199 /* ExpressionWithTypeArguments */:
                    return getTypeFromTypeReference(node);
                case 160 /* TypeQuery */:
                    return getTypeFromTypeQueryNode(node);
                case 162 /* ArrayType */:
                case 265 /* JSDocArrayType */:
                    return getTypeFromArrayTypeNode(node);
                case 163 /* TupleType */:
                    return getTypeFromTupleTypeNode(node);
                case 164 /* UnionType */:
                case 266 /* JSDocUnionType */:
                    return getTypeFromUnionTypeNode(node);
                case 165 /* IntersectionType */:
                    return getTypeFromIntersectionTypeNode(node);
                case 166 /* ParenthesizedType */:
                case 268 /* JSDocNullableType */:
                case 269 /* JSDocNonNullableType */:
                case 276 /* JSDocConstructorType */:
                case 277 /* JSDocThisType */:
                case 273 /* JSDocOptionalType */:
                    return getTypeFromTypeNode(node.type);
                case 270 /* JSDocRecordType */:
                    return getTypeFromTypeNode(node.literal);
                case 158 /* FunctionType */:
                case 159 /* ConstructorType */:
                case 161 /* TypeLiteral */:
                case 287 /* JSDocTypeLiteral */:
                case 274 /* JSDocFunctionType */:
                    return getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode(node);
                case 168 /* TypeOperator */:
                    return getTypeFromTypeOperatorNode(node);
                case 169 /* IndexedAccessType */:
                    return getTypeFromIndexedAccessTypeNode(node);
                case 170 /* MappedType */:
                    return getTypeFromMappedTypeNode(node);
                // This function assumes that an identifier or qualified name is a type expression
                // Callers should first ensure this by calling isTypeNode
                case 70 /* Identifier */:
                case 141 /* QualifiedName */:
                    var symbol = getSymbolAtLocation(node);
                    return symbol && getDeclaredTypeOfSymbol(symbol);
                case 267 /* JSDocTupleType */:
                    return getTypeFromJSDocTupleType(node);
                case 275 /* JSDocVariadicType */:
                    return getTypeFromJSDocVariadicType(node);
                default:
                    return unknownType;
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeFromThisTypeNode) id{400,1} ---
(node) {
            var links = getNodeLinks(node);
            if (!links.resolvedType) {
                links.resolvedType = getThisType(node);
            }
            return links.resolvedType;
        }
--- END ---
INLINE (getTypeFromThisTypeNode) id{400,1} AS 1 AT <0:1275>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeLinks) id{400,2} ---
(node) {
            var nodeId = getNodeId(node);
            return nodeLinks[nodeId] || (nodeLinks[nodeId] = { flags: 0 });
        }
--- END ---
INLINE (getNodeLinks) id{400,2} AS 2 AT <1:33>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeId) id{400,3} ---
(node) {
        if (!node.id) {
            node.id = nextNodeId;
            nextNodeId++;
        }
        return node.id;
    }
--- END ---
INLINE (getNodeId) id{400,3} AS 3 AT <2:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeFromArrayTypeNode) id{400,4} ---
(node) {
            var links = getNodeLinks(node);
            if (!links.resolvedType) {
                links.resolvedType = createArrayType(getTypeFromTypeNode(node.elementType));
            }
            return links.resolvedType;
        }
--- END ---
INLINE (getTypeFromArrayTypeNode) id{400,4} AS 4 AT <0:2107>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeLinks) id{400,5} ---
(node) {
            var nodeId = getNodeId(node);
            return nodeLinks[nodeId] || (nodeLinks[nodeId] = { flags: 0 });
        }
--- END ---
INLINE (getNodeLinks) id{400,5} AS 5 AT <4:33>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeId) id{400,6} ---
(node) {
        if (!node.id) {
            node.id = nextNodeId;
            nextNodeId++;
        }
        return node.id;
    }
--- END ---
INLINE (getNodeId) id{400,6} AS 6 AT <5:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createArrayType) id{400,7} ---
(elementType) {
            return createTypeFromGenericGlobalType(globalArrayType, [elementType]);
        }
--- END ---
INLINE (createArrayType) id{400,7} AS 7 AT <4:129>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createTypeFromGenericGlobalType) id{400,8} ---
(genericGlobalType, typeArguments) {
            return genericGlobalType !== emptyGenericType ? createTypeReference(genericGlobalType, typeArguments) : emptyObjectType;
        }
--- END ---
INLINE (createTypeFromGenericGlobalType) id{400,8} AS 8 AT <7:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createTypeReference) id{400,9} ---
(target, typeArguments) {
            var id = getTypeListId(typeArguments);
            var type = target.instantiations[id];
            if (!type) {
                type = target.instantiations[id] = createObjectType(4 /* Reference */, target.symbol);
                type.flags |= typeArguments ? getPropagatingFlagsOfTypes(typeArguments, /*excludeKinds*/ 0) : 0;
                type.target = target;
                type.typeArguments = typeArguments;
            }
            return type;
        }
--- END ---
INLINE (createTypeReference) id{400,9} AS 9 AT <8:97>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createObjectType) id{400,10} ---
(objectFlags, symbol) {
            var type = createType(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol = symbol;
            return type;
        }
--- END ---
INLINE (createObjectType) id{400,10} AS 10 AT <9:203>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropagatingFlagsOfTypes) id{400,11} ---
(types, excludeKinds) {
            var result = 0;
            for (var _i = 0, types_3 = types; _i < types_3.length; _i++) {
                var type = types_3[_i];
                if (!(type.flags & excludeKinds)) {
                    result |= type.flags;
                }
            }
            return result & 14680064 /* PropagatingFlags */;
        }
--- END ---
INLINE (getPropagatingFlagsOfTypes) id{400,11} AS 11 AT <9:301>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeFromTupleTypeNode) id{400,12} ---
(node) {
            var links = getNodeLinks(node);
            if (!links.resolvedType) {
                links.resolvedType = createTupleType(ts.map(node.elementTypes, getTypeFromTypeNode));
            }
            return links.resolvedType;
        }
--- END ---
INLINE (getTypeFromTupleTypeNode) id{400,12} AS 12 AT <0:2208>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeLinks) id{400,13} ---
(node) {
            var nodeId = getNodeId(node);
            return nodeLinks[nodeId] || (nodeLinks[nodeId] = { flags: 0 });
        }
--- END ---
INLINE (getNodeLinks) id{400,13} AS 13 AT <12:33>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeId) id{400,14} ---
(node) {
        if (!node.id) {
            node.id = nextNodeId;
            nextNodeId++;
        }
        return node.id;
    }
--- END ---
INLINE (getNodeId) id{400,14} AS 14 AT <13:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createTupleType) id{400,15} ---
(elementTypes) {
            return createTypeReference(getTupleTypeOfArity(elementTypes.length), elementTypes);
        }
--- END ---
INLINE (createTupleType) id{400,15} AS 15 AT <12:129>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTupleTypeOfArity) id{400,16} ---
(arity) {
            return tupleTypes[arity] || (tupleTypes[arity] = createTupleTypeOfArity(arity));
        }
--- END ---
INLINE (getTupleTypeOfArity) id{400,16} AS 16 AT <15:56>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createTypeReference) id{400,17} ---
(target, typeArguments) {
            var id = getTypeListId(typeArguments);
            var type = target.instantiations[id];
            if (!type) {
                type = target.instantiations[id] = createObjectType(4 /* Reference */, target.symbol);
                type.flags |= typeArguments ? getPropagatingFlagsOfTypes(typeArguments, /*excludeKinds*/ 0) : 0;
                type.target = target;
                type.typeArguments = typeArguments;
            }
            return type;
        }
--- END ---
INLINE (createTypeReference) id{400,17} AS 17 AT <15:36>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createObjectType) id{400,18} ---
(objectFlags, symbol) {
            var type = createType(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol = symbol;
            return type;
        }
--- END ---
INLINE (createObjectType) id{400,18} AS 18 AT <17:203>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{400,19} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{400,19} AS 19 AT <18:47>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkFunctionOrMethodDeclaration) id{401,0} ---
(node) {
            checkDecorators(node);
            checkSignatureDeclaration(node);
            var isAsync = ts.isAsyncFunctionLike(node);
            // Do not use hasDynamicName here, because that returns false for well known symbols.
            // We want to perform checkComputedPropertyName for all computed properties, including
            // well known symbols.
            if (node.name && node.name.kind === 142 /* ComputedPropertyName */) {
                // This check will account for methods in class/interface declarations,
                // as well as accessors in classes/object literals
                checkComputedPropertyName(node.name);
            }
            if (!ts.hasDynamicName(node)) {
                // first we want to check the local symbol that contain this declaration
                // - if node.localSymbol !== undefined - this is current declaration is exported and localSymbol points to the local symbol
                // - if node.localSymbol === undefined - this node is non-exported so we can just pick the result of getSymbolOfNode
                var symbol = getSymbolOfNode(node);
                var localSymbol = node.localSymbol || symbol;
                // Since the javascript won't do semantic analysis like typescript,
                // if the javascript file comes before the typescript file and both contain same name functions,
                // checkFunctionOrConstructorSymbol wouldn't be called if we didnt ignore javascript function.
                var firstDeclaration = ts.forEach(localSymbol.declarations, 
                // Get first non javascript function declaration
                function (declaration) { return declaration.kind === node.kind && !ts.isSourceFileJavaScript(ts.getSourceFileOfNode(declaration)) ?
                    declaration : undefined; });
                // Only type check the symbol once
                if (node === firstDeclaration) {
                    checkFunctionOrConstructorSymbol(localSymbol);
                }
                if (symbol.parent) {
                    // run check once for the first declaration
                    if (ts.getDeclarationOfKind(symbol, node.kind) === node) {
                        // run check on export symbol to check that modifiers agree across all exported declarations
                        checkFunctionOrConstructorSymbol(symbol);
                    }
                }
            }
            checkSourceElement(node.body);
            if (!node.asteriskToken) {
                var returnOrPromisedType = node.type && (isAsync ? checkAsyncFunctionReturnType(node) : getTypeFromTypeNode(node.type));
                checkAllCodePathsInNonVoidFunctionReturnOrThrow(node, returnOrPromisedType);
            }
            if (produceDiagnostics && !node.type) {
                // Report an implicit any error if there is no body, no explicit return type, and node is not a private method
                // in an ambient context
                if (compilerOptions.noImplicitAny && ts.nodeIsMissing(node.body) && !isPrivateWithinAmbient(node)) {
                    reportImplicitAnyError(node, anyType);
                }
                if (node.asteriskToken && ts.nodeIsPresent(node.body)) {
                    // A generator with a body and no type annotation can still cause errors. It can error if the
                    // yielded values have no common supertype, or it can give an implicit any error if it has no
                    // yielded values. The only way to trigger these errors is to try checking its return type.
                    getReturnTypeOfSignature(getSignatureFromDeclaration(node));
                }
            }
            registerForUnusedIdentifiersCheck(node);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{401,1} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{401,1} AS 1 AT <0:1117>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{401,2} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{401,2} AS 2 AT <1:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:registerForUnusedIdentifiersCheck) id{401,3} ---
(node) {
            if (deferredUnusedIdentifierNodes) {
                deferredUnusedIdentifierNodes.push(node);
            }
        }
--- END ---
INLINE (registerForUnusedIdentifiersCheck) id{401,3} AS 3 AT <0:3729>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getOuterTypeParametersOfClassOrInterface) id{402,0} ---
(symbol) {
            var declaration = symbol.flags & 32 /* Class */ ? symbol.valueDeclaration : ts.getDeclarationOfKind(symbol, 227 /* InterfaceDeclaration */);
            return appendOuterTypeParameters(undefined, declaration);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeOfVariableOrParameterOrProperty) id{403,0} ---
(symbol) {
            var links = getSymbolLinks(symbol);
            if (!links.type) {
                // Handle prototype property
                if (symbol.flags & 134217728 /* Prototype */) {
                    return links.type = getTypeOfPrototypeProperty(symbol);
                }
                // Handle catch clause variables
                var declaration = symbol.valueDeclaration;
                if (ts.isCatchClauseVariableDeclarationOrBindingElement(declaration)) {
                    return links.type = anyType;
                }
                // Handle export default expressions
                if (declaration.kind === 240 /* ExportAssignment */) {
                    return links.type = checkExpression(declaration.expression);
                }
                if (declaration.flags & 65536 /* JavaScriptFile */ && declaration.kind === 286 /* JSDocPropertyTag */ && declaration.typeExpression) {
                    return links.type = getTypeFromTypeNode(declaration.typeExpression.type);
                }
                // Handle variable, parameter or property
                if (!pushTypeResolution(symbol, 0 /* Type */)) {
                    return unknownType;
                }
                var type = void 0;
                // Handle certain special assignment kinds, which happen to union across multiple declarations:
                // * module.exports = expr
                // * exports.p = expr
                // * this.p = expr
                // * className.prototype.method = expr
                if (declaration.kind === 192 /* BinaryExpression */ ||
                    declaration.kind === 177 /* PropertyAccessExpression */ && declaration.parent.kind === 192 /* BinaryExpression */) {
                    // Use JS Doc type if present on parent expression statement
                    if (declaration.flags & 65536 /* JavaScriptFile */) {
                        var jsdocType = ts.getJSDocType(declaration.parent);
                        if (jsdocType) {
                            return links.type = getTypeFromTypeNode(jsdocType);
                        }
                    }
                    var declaredTypes = ts.map(symbol.declarations, function (decl) { return decl.kind === 192 /* BinaryExpression */ ?
                        checkExpressionCached(decl.right) :
                        checkExpressionCached(decl.parent.right); });
                    type = getUnionType(declaredTypes, /*subtypeReduction*/ true);
                }
                else {
                    type = getWidenedTypeForVariableLikeDeclaration(declaration, /*reportErrors*/ true);
                }
                if (!popTypeResolution()) {
                    type = reportCircularityError(symbol);
                }
                links.type = type;
            }
            return links.type;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{403,1} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{403,1} AS 1 AT <0:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{403,2} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{403,2} AS 2 AT <1:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:popTypeResolution) id{403,3} ---
() {
            resolutionTargets.pop();
            resolutionPropertyNames.pop();
            return resolutionResults.pop();
        }
--- END ---
INLINE (popTypeResolution) id{403,3} AS 3 AT <0:2684>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createSignature) id{404,0} ---
(declaration, typeParameters, thisParameter, parameters, resolvedReturnType, typePredicate, minArgumentCount, hasRestParameter, hasLiteralTypes) {
            var sig = new Signature(checker);
            sig.declaration = declaration;
            sig.typeParameters = typeParameters;
            sig.parameters = parameters;
            sig.thisParameter = thisParameter;
            sig.resolvedReturnType = resolvedReturnType;
            sig.typePredicate = typePredicate;
            sig.minArgumentCount = minArgumentCount;
            sig.hasRestParameter = hasRestParameter;
            sig.hasLiteralTypes = hasLiteralTypes;
            return sig;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:SignatureObject) id{404,1} ---
(checker) {
            this.checker = checker;
        }
--- END ---
INLINE (SignatureObject) id{404,1} AS 1 AT <0:169>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getAliasTypeArgumentsForTypeNode) id{405,0} ---
(node) {
            var symbol = getAliasSymbolForTypeNode(node);
            return symbol ? getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol) : undefined;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getAliasSymbolForTypeNode) id{405,1} ---
(node) {
            return node.parent.kind === 228 /* TypeAliasDeclaration */ ? getSymbolOfNode(node.parent) : undefined;
        }
--- END ---
INLINE (getAliasSymbolForTypeNode) id{405,1} AS 1 AT <0:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{405,2} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{405,2} AS 2 AT <1:82>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{405,3} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{405,3} AS 3 AT <2:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeFromUnionTypeNode) id{406,0} ---
(node) {
            var links = getNodeLinks(node);
            if (!links.resolvedType) {
                links.resolvedType = getUnionType(ts.map(node.types, getTypeFromTypeNode), /*subtypeReduction*/ false, getAliasSymbolForTypeNode(node), getAliasTypeArgumentsForTypeNode(node));
            }
            return links.resolvedType;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeLinks) id{406,1} ---
(node) {
            var nodeId = getNodeId(node);
            return nodeLinks[nodeId] || (nodeLinks[nodeId] = { flags: 0 });
        }
--- END ---
INLINE (getNodeLinks) id{406,1} AS 1 AT <0:33>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeId) id{406,2} ---
(node) {
        if (!node.id) {
            node.id = nextNodeId;
            nextNodeId++;
        }
        return node.id;
    }
--- END ---
INLINE (getNodeId) id{406,2} AS 2 AT <1:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getAliasSymbolForTypeNode) id{406,3} ---
(node) {
            return node.parent.kind === 228 /* TypeAliasDeclaration */ ? getSymbolOfNode(node.parent) : undefined;
        }
--- END ---
INLINE (getAliasSymbolForTypeNode) id{406,3} AS 3 AT <0:211>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{406,4} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{406,4} AS 4 AT <3:82>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{406,5} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{406,5} AS 5 AT <4:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getAliasTypeArgumentsForTypeNode) id{406,6} ---
(node) {
            var symbol = getAliasSymbolForTypeNode(node);
            return symbol ? getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol) : undefined;
        }
--- END ---
INLINE (getAliasTypeArgumentsForTypeNode) id{406,6} AS 6 AT <0:244>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getAliasSymbolForTypeNode) id{406,7} ---
(node) {
            return node.parent.kind === 228 /* TypeAliasDeclaration */ ? getSymbolOfNode(node.parent) : undefined;
        }
--- END ---
INLINE (getAliasSymbolForTypeNode) id{406,7} AS 7 AT <6:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{406,8} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{406,8} AS 8 AT <7:82>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{406,9} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{406,9} AS 9 AT <8:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:addTypeToUnion) id{407,0} ---
(typeSet, type) {
            var flags = type.flags;
            if (flags & 65536 /* Union */) {
                addTypesToUnion(typeSet, type.types);
            }
            else if (flags & 1 /* Any */) {
                typeSet.containsAny = true;
            }
            else if (!strictNullChecks && flags & 6144 /* Nullable */) {
                if (flags & 2048 /* Undefined */)
                    typeSet.containsUndefined = true;
                if (flags & 4096 /* Null */)
                    typeSet.containsNull = true;
                if (!(flags & 2097152 /* ContainsWideningType */))
                    typeSet.containsNonWideningType = true;
            }
            else if (!(flags & 8192 /* Never */)) {
                if (flags & 2 /* String */)
                    typeSet.containsString = true;
                if (flags & 4 /* Number */)
                    typeSet.containsNumber = true;
                if (flags & 96 /* StringOrNumberLiteral */)
                    typeSet.containsStringOrNumberLiteral = true;
                var len = typeSet.length;
                var index = len && type.id > typeSet[len - 1].id ? ~len : binarySearchTypes(typeSet, type);
                if (index < 0) {
                    if (!(flags & 32768 /* Object */ && type.objectFlags & 16 /* Anonymous */ &&
                        type.symbol && type.symbol.flags & (16 /* Function */ | 8192 /* Method */) && containsIdenticalType(typeSet, type))) {
                        typeSet.splice(~index, 0, type);
                    }
                }
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:addTypesToUnion) id{407,1} ---
(typeSet, types) {
            for (var _i = 0, types_4 = types; _i < types_4.length; _i++) {
                var type = types_4[_i];
                addTypeToUnion(typeSet, type);
            }
        }
--- END ---
INLINE (addTypesToUnion) id{407,1} AS 1 AT <0:115>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:binarySearchTypes) id{407,2} ---
(types, type) {
            var low = 0;
            var high = types.length - 1;
            var typeId = type.id;
            while (low <= high) {
                var middle = low + ((high - low) >> 1);
                var id = types[middle].id;
                if (id === typeId) {
                    return middle;
                }
                else if (id > typeId) {
                    high = middle - 1;
                }
                else {
                    low = middle + 1;
                }
            }
            return ~low;
        }
--- END ---
INLINE (binarySearchTypes) id{407,2} AS 2 AT <0:1165>
[deoptimizing (DEOPT eager): begin 0x17ddd8404489 <JS Function addTypeToUnion (SharedFunctionInfo 0x2e2f693f37d1)> (opt #407) @27, FP to SP delta: 104, caller sp: 0x7fff5fbfd9c0]
            ;;; deoptimize at 2_236: wrong map
  reading input frame addTypeToUnion => node=413, args=3, height=5; inputs:
      0: 0x17ddd8404489 ; [fp - 16] 0x17ddd8404489 <JS Function addTypeToUnion (SharedFunctionInfo 0x2e2f693f37d1)>
      1: 0x1f9f6c0532e1 ; [fp + 32] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x101bfd3ca401 ; rbx 0x101bfd3ca401 <JS Array[0]>
      3: 0x1030c9d51889 ; [fp + 16] 0x1030c9d51889 <a TypeObject with map 0x33abe2a6cf81>
      4: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      5: 0x200000000 ; [fp - 32] 2
      6: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
      8: 0x17ddd8404631 ; [fp - 64] 0x17ddd8404631 <JS Function binarySearchTypes (SharedFunctionInfo 0x2e2f693f3651)>
  reading input frame binarySearchTypes => node=78, args=3, height=6; inputs:
      0: 0x17ddd8404631 ; (literal 7) 0x17ddd8404631 <JS Function binarySearchTypes (SharedFunctionInfo 0x2e2f693f3651)>
      1: 0x1f9f6c0532e1 ; (literal 8) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x101bfd3ca401 ; rbx 0x101bfd3ca401 <JS Array[0]>
      3: 0x1030c9d51889 ; [fp + 16] 0x1030c9d51889 <a TypeObject with map 0x33abe2a6cf81>
      4: 0x130b7e1b3d29 ; (literal 9) 0x130b7e1b3d29 <FixedArray[1022]>
      5: 0x00000000 ; (literal 10) 0
      6: -1 ; (int) [fp - 72] 
      7: 0x800000000 ; rax 8
      8: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
      9: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
  translating frame addTypeToUnion => node=413, height=32
    0x7fff5fbfd9b8: [top + 80] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd9b0: [top + 72] <- 0x101bfd3ca401 ;  0x101bfd3ca401 <JS Array[0]>  (input #2)
    0x7fff5fbfd9a8: [top + 64] <- 0x1030c9d51889 ;  0x1030c9d51889 <a TypeObject with map 0x33abe2a6cf81>  (input #3)
    0x7fff5fbfd9a0: [top + 56] <- 0x2c21d253bc77 ;  caller's pc
    0x7fff5fbfd998: [top + 48] <- 0x7fff5fbfd9f0 ;  caller's fp
    0x7fff5fbfd990: [top + 40] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #4)
    0x7fff5fbfd988: [top + 32] <- 0x17ddd8404489 ;  function    0x17ddd8404489 <JS Function addTypeToUnion (SharedFunctionInfo 0x2e2f693f37d1)>  (input #0)
    0x7fff5fbfd980: [top + 24] <- 0x200000000 ;  2  (input #5)
    0x7fff5fbfd978: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfd970: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfd968: [top + 0] <- 0x17ddd8404631 ;  0x17ddd8404631 <JS Function binarySearchTypes (SharedFunctionInfo 0x2e2f693f3651)>  (input #8)
  translating frame binarySearchTypes => node=78, height=40
    0x7fff5fbfd960: [top + 88] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd958: [top + 80] <- 0x101bfd3ca401 ;  0x101bfd3ca401 <JS Array[0]>  (input #2)
    0x7fff5fbfd950: [top + 72] <- 0x1030c9d51889 ;  0x1030c9d51889 <a TypeObject with map 0x33abe2a6cf81>  (input #3)
    0x7fff5fbfd948: [top + 64] <- 0x2c21d253c254 ;  caller's pc
    0x7fff5fbfd940: [top + 56] <- 0x7fff5fbfd998 ;  caller's fp
    0x7fff5fbfd938: [top + 48] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #4)
    0x7fff5fbfd930: [top + 40] <- 0x17ddd8404631 ;  function    0x17ddd8404631 <JS Function binarySearchTypes (SharedFunctionInfo 0x2e2f693f3651)>  (input #0)
    0x7fff5fbfd928: [top + 32] <- 0x00000000 ;  0  (input #5)
    0x7fff5fbfd920: [top + 24] <- 0xffffffff00000000 ;  -1  (input #6)
    0x7fff5fbfd918: [top + 16] <- 0x800000000 ;  8  (input #7)
    0x7fff5fbfd910: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfd908: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
[deoptimizing (eager): end 0x17ddd8404489 <JS Function addTypeToUnion (SharedFunctionInfo 0x2e2f693f37d1)> @27 => node=78, pc=0x2c21d253c7ca, caller sp=0x7fff5fbfd9c0, state=NO_REGISTERS, took 0.134 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeOfSymbol) id{408,0} ---
(symbol) {
            if (symbol.flags & 16777216 /* Instantiated */) {
                return getTypeOfInstantiatedSymbol(symbol);
            }
            if (symbol.flags & (3 /* Variable */ | 4 /* Property */)) {
                return getTypeOfVariableOrParameterOrProperty(symbol);
            }
            if (symbol.flags & (16 /* Function */ | 8192 /* Method */ | 32 /* Class */ | 384 /* Enum */ | 512 /* ValueModule */)) {
                return getTypeOfFuncClassEnumModule(symbol);
            }
            if (symbol.flags & 8 /* EnumMember */) {
                return getTypeOfEnumMember(symbol);
            }
            if (symbol.flags & 98304 /* Accessor */) {
                return getTypeOfAccessors(symbol);
            }
            if (symbol.flags & 8388608 /* Alias */) {
                return getTypeOfAlias(symbol);
            }
            return unknownType;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeOfInstantiatedSymbol) id{408,1} ---
(symbol) {
            var links = getSymbolLinks(symbol);
            if (!links.type) {
                if (!pushTypeResolution(symbol, 0 /* Type */)) {
                    return unknownType;
                }
                var type = instantiateType(getTypeOfSymbol(links.target), links.mapper);
                if (!popTypeResolution()) {
                    type = reportCircularityError(symbol);
                }
                links.type = type;
            }
            return links.type;
        }
--- END ---
INLINE (getTypeOfInstantiatedSymbol) id{408,1} AS 1 AT <0:96>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{408,2} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{408,2} AS 2 AT <1:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{408,3} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{408,3} AS 3 AT <2:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:popTypeResolution) id{408,4} ---
() {
            resolutionTargets.pop();
            resolutionPropertyNames.pop();
            return resolutionResults.pop();
        }
--- END ---
INLINE (popTypeResolution) id{408,4} AS 4 AT <1:323>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeOfFuncClassEnumModule) id{408,5} ---
(symbol) {
            var links = getSymbolLinks(symbol);
            if (!links.type) {
                if (symbol.flags & 1536 /* Module */ && ts.isShorthandAmbientModuleSymbol(symbol)) {
                    links.type = anyType;
                }
                else {
                    var type = createObjectType(16 /* Anonymous */, symbol);
                    links.type = strictNullChecks && symbol.flags & 536870912 /* Optional */ ?
                        includeFalsyTypes(type, 2048 /* Undefined */) : type;
                }
            }
            return links.type;
        }
--- END ---
INLINE (getTypeOfFuncClassEnumModule) id{408,5} AS 5 AT <0:459>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{408,6} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{408,6} AS 6 AT <5:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{408,7} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{408,7} AS 7 AT <6:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createObjectType) id{408,8} ---
(objectFlags, symbol) {
            var type = createType(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol = symbol;
            return type;
        }
--- END ---
INLINE (createObjectType) id{408,8} AS 8 AT <5:305>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{408,9} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{408,9} AS 9 AT <8:47>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{408,10} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{408,10} AS 10 AT <9:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkUnionOrIntersectionType) id{409,0} ---
(node) {
            ts.forEach(node.types, checkSourceElement);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarProperty) id{410,0} ---
(node) {
            if (ts.isClassLike(node.parent)) {
                if (checkGrammarForNonSymbolComputedProperty(node.name, ts.Diagnostics.A_computed_property_name_in_a_class_property_declaration_must_directly_refer_to_a_built_in_symbol)) {
                    return true;
                }
            }
            else if (node.parent.kind === 227 /* InterfaceDeclaration */) {
                if (checkGrammarForNonSymbolComputedProperty(node.name, ts.Diagnostics.A_computed_property_name_in_an_interface_must_directly_refer_to_a_built_in_symbol)) {
                    return true;
                }
                if (node.initializer) {
                    return grammarErrorOnNode(node.initializer, ts.Diagnostics.An_interface_property_cannot_have_an_initializer);
                }
            }
            else if (node.parent.kind === 161 /* TypeLiteral */) {
                if (checkGrammarForNonSymbolComputedProperty(node.name, ts.Diagnostics.A_computed_property_name_in_a_type_literal_must_directly_refer_to_a_built_in_symbol)) {
                    return true;
                }
                if (node.initializer) {
                    return grammarErrorOnNode(node.initializer, ts.Diagnostics.A_type_literal_property_cannot_have_an_initializer);
                }
            }
            if (ts.isInAmbientContext(node) && node.initializer) {
                return grammarErrorOnFirstToken(node.initializer, ts.Diagnostics.Initializers_are_not_allowed_in_ambient_contexts);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarForNonSymbolComputedProperty) id{410,1} ---
(node, message) {
            if (ts.isDynamicName(node)) {
                return grammarErrorOnNode(node, message);
            }
        }
--- END ---
INLINE (checkGrammarForNonSymbolComputedProperty) id{410,1} AS 1 AT <0:406>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarForNonSymbolComputedProperty) id{410,2} ---
(node, message) {
            if (ts.isDynamicName(node)) {
                return grammarErrorOnNode(node, message);
            }
        }
--- END ---
INLINE (checkGrammarForNonSymbolComputedProperty) id{410,2} AS 2 AT <0:899>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isInAmbientContext) id{411,0} ---
(node) {
        while (node) {
            if (hasModifier(node, 2 /* Ambient */) || (node.kind === 261 /* SourceFile */ && node.isDeclarationFile)) {
                return true;
            }
            node = node.parent;
        }
        return false;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:hasModifier) id{411,1} ---
(node, flags) {
        return (getModifierFlags(node) & flags) !== 0;
    }
--- END ---
INLINE (hasModifier) id{411,1} AS 1 AT <0:48>
[deoptimizing (DEOPT eager): begin 0x130b7e1b5e01 <JS Function resolveStructuredTypeMembers (SharedFunctionInfo 0x2e2f693efe11)> (opt #397) @7, FP to SP delta: 248, caller sp: 0x7fff5fbfdc18]
            ;;; deoptimize at 0_275: wrong map
  reading input frame resolveStructuredTypeMembers => node=48, args=2, height=1; inputs:
      0: 0x130b7e1b5e01 ; [fp - 16] 0x130b7e1b5e01 <JS Function resolveStructuredTypeMembers (SharedFunctionInfo 0x2e2f693efe11)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x101bfd3ff151 ; rax 0x101bfd3ff151 <a TypeObject with map 0x33abe2a73439>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
  translating frame resolveStructuredTypeMembers => node=48, height=0
    0x7fff5fbfdc10: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdc08: [top + 32] <- 0x101bfd3ff151 ;  0x101bfd3ff151 <a TypeObject with map 0x33abe2a73439>  (input #2)
    0x7fff5fbfdc00: [top + 24] <- 0x2c21d262ff14 ;  caller's pc
    0x7fff5fbfdbf8: [top + 16] <- 0x7fff5fbfdc48 ;  caller's fp
    0x7fff5fbfdbf0: [top + 8] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdbe8: [top + 0] <- 0x130b7e1b5e01 ;  function    0x130b7e1b5e01 <JS Function resolveStructuredTypeMembers (SharedFunctionInfo 0x2e2f693efe11)>  (input #0)
[deoptimizing (eager): end 0x130b7e1b5e01 <JS Function resolveStructuredTypeMembers (SharedFunctionInfo 0x2e2f693efe11)> @7 => node=48, pc=0x2c21d260d622, caller sp=0x7fff5fbfdc18, state=NO_REGISTERS, took 0.058 ms]
[deoptimizing (DEOPT eager): begin 0x130b7e1b5d29 <JS Function resolveDeclaredMembers (SharedFunctionInfo 0x2e2f693eeb51)> (opt #395) @2, FP to SP delta: 144, caller sp: 0x7fff5fbfdb90]
            ;;; deoptimize at 0_30: Unknown map in polymorphic access
  reading input frame resolveDeclaredMembers => node=4, args=2, height=2; inputs:
      0: 0x130b7e1b5d29 ; [fp - 16] 0x130b7e1b5d29 <JS Function resolveDeclaredMembers (SharedFunctionInfo 0x2e2f693eeb51)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x101bfd3ff151 ; rax 0x101bfd3ff151 <a TypeObject with map 0x33abe2a73439>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
  translating frame resolveDeclaredMembers => node=4, height=8
    0x7fff5fbfdb88: [top + 48] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdb80: [top + 40] <- 0x101bfd3ff151 ;  0x101bfd3ff151 <a TypeObject with map 0x33abe2a73439>  (input #2)
    0x7fff5fbfdb78: [top + 32] <- 0x2c21d260d988 ;  caller's pc
    0x7fff5fbfdb70: [top + 24] <- 0x7fff5fbfdbc0 ;  caller's fp
    0x7fff5fbfdb68: [top + 16] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdb60: [top + 8] <- 0x130b7e1b5d29 ;  function    0x130b7e1b5d29 <JS Function resolveDeclaredMembers (SharedFunctionInfo 0x2e2f693eeb51)>  (input #0)
    0x7fff5fbfdb58: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
[deoptimizing (eager): end 0x130b7e1b5d29 <JS Function resolveDeclaredMembers (SharedFunctionInfo 0x2e2f693eeb51)> @2 => node=4, pc=0x2c21d260da6a, caller sp=0x7fff5fbfdb90, state=NO_REGISTERS, took 0.052 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:pushTypeResolution) id{412,0} ---
(target, propertyName) {
            var resolutionCycleStartIndex = findResolutionCycleStartIndex(target, propertyName);
            if (resolutionCycleStartIndex >= 0) {
                // A cycle was found
                var length_2 = resolutionTargets.length;
                for (var i = resolutionCycleStartIndex; i < length_2; i++) {
                    resolutionResults[i] = false;
                }
                return false;
            }
            resolutionTargets.push(target);
            resolutionResults.push(/*items*/ true);
            resolutionPropertyNames.push(propertyName);
            return true;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:findResolutionCycleStartIndex) id{412,1} ---
(target, propertyName) {
            for (var i = resolutionTargets.length - 1; i >= 0; i--) {
                if (hasType(resolutionTargets[i], resolutionPropertyNames[i])) {
                    return -1;
                }
                if (resolutionTargets[i] === target && resolutionPropertyNames[i] === propertyName) {
                    return i;
                }
            }
            return -1;
        }
--- END ---
INLINE (findResolutionCycleStartIndex) id{412,1} AS 1 AT <0:69>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isJSDocConstructSignature) id{413,0} ---
(node) {
        return node.kind === 274 /* JSDocFunctionType */ &&
            node.parameters.length > 0 &&
            node.parameters[0].type.kind === 276 /* JSDocConstructorType */;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:hasRestParameter) id{414,0} ---
(s) {
        return isRestParameter(ts.lastOrUndefined(s.parameters));
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isRestParameter) id{414,1} ---
(node) {
        if (node && (node.flags & 65536 /* JavaScriptFile */)) {
            if (node.type && node.type.kind === 275 /* JSDocVariadicType */ ||
                ts.forEach(getJSDocParameterTags(node), function (t) { return t.typeExpression && t.typeExpression.type.kind === 275 /* JSDocVariadicType */; })) {
                return true;
            }
        }
        return isDeclaredRestParam(node);
    }
--- END ---
INLINE (isRestParameter) id{414,1} AS 1 AT <0:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isDeclaredRestParam) id{414,2} ---
(node) {
        return node && node.dotDotDotToken !== undefined;
    }
--- END ---
INLINE (isDeclaredRestParam) id{414,2} AS 2 AT <1:385>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropertyOfType) id{415,0} ---
(type, name) {
            type = getApparentType(type);
            if (type.flags & 32768 /* Object */) {
                var resolved = resolveStructuredTypeMembers(type);
                var symbol = resolved.members[name];
                if (symbol && symbolIsValue(symbol)) {
                    return symbol;
                }
                if (resolved === anyFunctionType || resolved.callSignatures.length || resolved.constructSignatures.length) {
                    var symbol_1 = getPropertyOfObjectType(globalFunctionType, name);
                    if (symbol_1) {
                        return symbol_1;
                    }
                }
                return getPropertyOfObjectType(globalObjectType, name);
            }
            if (type.flags & 196608 /* UnionOrIntersection */) {
                return getPropertyOfUnionOrIntersectionType(type, name);
            }
            return undefined;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getApparentType) id{415,1} ---
(type) {
            var t = type.flags & 540672 /* TypeVariable */ ? getApparentTypeOfTypeVariable(type) : type;
            return t.flags & 262178 /* StringLike */ ? globalStringType :
                t.flags & 340 /* NumberLike */ ? globalNumberType :
                    t.flags & 136 /* BooleanLike */ ? globalBooleanType :
                        t.flags & 512 /* ESSymbol */ ? getGlobalESSymbolType() :
                            t;
        }
--- END ---
INLINE (getApparentType) id{415,1} AS 1 AT <0:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getDeclaredTypeOfClassOrInterface) id{416,0} ---
(symbol) {
            var links = getSymbolLinks(symbol);
            if (!links.declaredType) {
                var kind = symbol.flags & 32 /* Class */ ? 1 /* Class */ : 2 /* Interface */;
                var type = links.declaredType = createObjectType(kind, symbol);
                var outerTypeParameters = getOuterTypeParametersOfClassOrInterface(symbol);
                var localTypeParameters = getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol);
                // A class or interface is generic if it has type parameters or a "this" type. We always give classes a "this" type
                // because it is not feasible to analyze all members to determine if the "this" type escapes the class (in particular,
                // property types inferred from initializers and method return types inferred from return statements are very hard
                // to exhaustively analyze). We give interfaces a "this" type if we can't definitely determine that they are free of
                // "this" references.
                if (outerTypeParameters || localTypeParameters || kind === 1 /* Class */ || !isIndependentInterface(symbol)) {
                    type.objectFlags |= 4 /* Reference */;
                    type.typeParameters = ts.concatenate(outerTypeParameters, localTypeParameters);
                    type.outerTypeParameters = outerTypeParameters;
                    type.localTypeParameters = localTypeParameters;
                    type.instantiations = ts.createMap();
                    type.instantiations[getTypeListId(type.typeParameters)] = type;
                    type.target = type;
                    type.typeArguments = type.typeParameters;
                    type.thisType = createType(16384 /* TypeParameter */);
                    type.thisType.isThisType = true;
                    type.thisType.symbol = symbol;
                    type.thisType.constraint = type;
                }
            }
            return links.declaredType;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{416,1} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{416,1} AS 1 AT <0:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{416,2} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{416,2} AS 2 AT <1:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createObjectType) id{416,3} ---
(objectFlags, symbol) {
            var type = createType(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol = symbol;
            return type;
        }
--- END ---
INLINE (createObjectType) id{416,3} AS 3 AT <0:240>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{416,4} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{416,4} AS 4 AT <3:47>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{416,5} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{416,5} AS 5 AT <4:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getOuterTypeParametersOfClassOrInterface) id{416,6} ---
(symbol) {
            var declaration = symbol.flags & 32 /* Class */ ? symbol.valueDeclaration : ts.getDeclarationOfKind(symbol, 227 /* InterfaceDeclaration */);
            return appendOuterTypeParameters(undefined, declaration);
        }
--- END ---
INLINE (getOuterTypeParametersOfClassOrInterface) id{416,6} AS 6 AT <0:314>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{416,7} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{416,7} AS 7 AT <0:1738>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{416,8} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{416,8} AS 8 AT <7:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveStructuredTypeMembers) id{417,0} ---
(type) {
            if (!type.members) {
                if (type.flags & 32768 /* Object */) {
                    if (type.objectFlags & 4 /* Reference */) {
                        resolveTypeReferenceMembers(type);
                    }
                    else if (type.objectFlags & 3 /* ClassOrInterface */) {
                        resolveClassOrInterfaceMembers(type);
                    }
                    else if (type.objectFlags & 16 /* Anonymous */) {
                        resolveAnonymousTypeMembers(type);
                    }
                    else if (type.objectFlags & 32 /* Mapped */) {
                        resolveMappedTypeMembers(type);
                    }
                }
                else if (type.flags & 65536 /* Union */) {
                    resolveUnionTypeMembers(type);
                }
                else if (type.flags & 131072 /* Intersection */) {
                    resolveIntersectionTypeMembers(type);
                }
            }
            return type;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveTypeReferenceMembers) id{417,1} ---
(type) {
            var source = resolveDeclaredMembers(type.target);
            var typeParameters = ts.concatenate(source.typeParameters, [source.thisType]);
            var typeArguments = type.typeArguments && type.typeArguments.length === typeParameters.length ?
                type.typeArguments : ts.concatenate(type.typeArguments, [type]);
            resolveObjectTypeMembers(type, source, typeParameters, typeArguments);
        }
--- END ---
INLINE (resolveTypeReferenceMembers) id{417,1} AS 1 AT <0:185>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveDeclaredMembers) id{417,2} ---
(type) {
            if (!type.declaredProperties) {
                var symbol = type.symbol;
                type.declaredProperties = getNamedMembers(symbol.members);
                type.declaredCallSignatures = getSignaturesOfSymbol(symbol.members["__call"]);
                type.declaredConstructSignatures = getSignaturesOfSymbol(symbol.members["__new"]);
                type.declaredStringIndexInfo = getIndexInfoOfSymbol(symbol, 0 /* String */);
                type.declaredNumberIndexInfo = getIndexInfoOfSymbol(symbol, 1 /* Number */);
            }
            return type;
        }
--- END ---
INLINE (resolveDeclaredMembers) id{417,2} AS 2 AT <1:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNamedMembers) id{417,3} ---
(members) {
            var result;
            for (var id in members) {
                if (!isReservedMemberName(id)) {
                    if (!result)
                        result = [];
                    var symbol = members[id];
                    if (symbolIsValue(symbol)) {
                        result.push(symbol);
                    }
                }
            }
            return result || emptyArray;
        }
--- END ---
INLINE (getNamedMembers) id{417,3} AS 3 AT <2:137>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isReservedMemberName) id{417,4} ---
(name) {
            return name.charCodeAt(0) === 95 /* _ */ &&
                name.charCodeAt(1) === 95 /* _ */ &&
                name.charCodeAt(2) !== 95 /* _ */ &&
                name.charCodeAt(2) !== 64 /* at */;
        }
--- END ---
INLINE (isReservedMemberName) id{417,4} AS 4 AT <3:95>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexInfoOfSymbol) id{417,5} ---
(symbol, kind) {
            var declaration = getIndexDeclarationOfSymbol(symbol, kind);
            if (declaration) {
                return createIndexInfo(declaration.type ? getTypeFromTypeNode(declaration.type) : anyType, (ts.getModifierFlags(declaration) & 64 /* Readonly */) !== 0, declaration);
            }
            return undefined;
        }
--- END ---
INLINE (getIndexInfoOfSymbol) id{417,5} AS 5 AT <2:411>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createIndexInfo) id{417,6} ---
(type, isReadonly, declaration) {
            return { type: type, isReadonly: isReadonly, declaration: declaration };
        }
--- END ---
INLINE (createIndexInfo) id{417,6} AS 6 AT <5:144>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexInfoOfSymbol) id{417,7} ---
(symbol, kind) {
            var declaration = getIndexDeclarationOfSymbol(symbol, kind);
            if (declaration) {
                return createIndexInfo(declaration.type ? getTypeFromTypeNode(declaration.type) : anyType, (ts.getModifierFlags(declaration) & 64 /* Readonly */) !== 0, declaration);
            }
            return undefined;
        }
--- END ---
INLINE (getIndexInfoOfSymbol) id{417,7} AS 7 AT <2:504>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createIndexInfo) id{417,8} ---
(type, isReadonly, declaration) {
            return { type: type, isReadonly: isReadonly, declaration: declaration };
        }
--- END ---
INLINE (createIndexInfo) id{417,8} AS 8 AT <7:144>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveClassOrInterfaceMembers) id{417,9} ---
(type) {
            resolveObjectTypeMembers(type, resolveDeclaredMembers(type), emptyArray, emptyArray);
        }
--- END ---
INLINE (resolveClassOrInterfaceMembers) id{417,9} AS 9 AT <0:342>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveDeclaredMembers) id{417,10} ---
(type) {
            if (!type.declaredProperties) {
                var symbol = type.symbol;
                type.declaredProperties = getNamedMembers(symbol.members);
                type.declaredCallSignatures = getSignaturesOfSymbol(symbol.members["__call"]);
                type.declaredConstructSignatures = getSignaturesOfSymbol(symbol.members["__new"]);
                type.declaredStringIndexInfo = getIndexInfoOfSymbol(symbol, 0 /* String */);
                type.declaredNumberIndexInfo = getIndexInfoOfSymbol(symbol, 1 /* Number */);
            }
            return type;
        }
--- END ---
INLINE (resolveDeclaredMembers) id{417,10} AS 10 AT <9:52>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNamedMembers) id{417,11} ---
(members) {
            var result;
            for (var id in members) {
                if (!isReservedMemberName(id)) {
                    if (!result)
                        result = [];
                    var symbol = members[id];
                    if (symbolIsValue(symbol)) {
                        result.push(symbol);
                    }
                }
            }
            return result || emptyArray;
        }
--- END ---
INLINE (getNamedMembers) id{417,11} AS 11 AT <10:137>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isReservedMemberName) id{417,12} ---
(name) {
            return name.charCodeAt(0) === 95 /* _ */ &&
                name.charCodeAt(1) === 95 /* _ */ &&
                name.charCodeAt(2) !== 95 /* _ */ &&
                name.charCodeAt(2) !== 64 /* at */;
        }
--- END ---
INLINE (isReservedMemberName) id{417,12} AS 12 AT <11:95>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeParametersFromJSDocTemplate) id{418,0} ---
(declaration) {
            if (declaration.flags & 65536 /* JavaScriptFile */) {
                var templateTag = ts.getJSDocTemplateTag(declaration);
                if (templateTag) {
                    return getTypeParametersFromDeclaration(templateTag.typeParameters);
                }
            }
            return undefined;
        }
--- END ---
[deoptimizing (DEOPT eager): begin 0x1030c9d3ff99 <JS Function checkFunctionOrMethodDeclaration (SharedFunctionInfo 0x1b98fbc0c0c1)> (opt #401) @32, FP to SP delta: 152, caller sp: 0x7fff5fbfdda0]
            ;;; deoptimize at 0_1571: wrong map
  reading input frame checkFunctionOrMethodDeclaration => node=224, args=2, height=8; inputs:
      0: 0x1030c9d3ff99 ; [fp - 16] 0x1030c9d3ff99 <JS Function checkFunctionOrMethodDeclaration (SharedFunctionInfo 0x1b98fbc0c0c1)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x9ebbbf51fb9 ; [fp + 16] 0x9ebbbf51fb9 <a NodeObject with map 0x33abe2a70159>
      3: 0x139ed2539d21 ; [fp - 24] 0x139ed2539d21 <FixedArray[5]>
      4: 0x30bcea404421 ; [fp - 40] 0x30bcea404421 <false>
      5: 0x2069ac91c79 ; [fp - 80] 0x2069ac91c79 <a SymbolObject with map 0x33abe2a728e1>
      6: 0x2069ac91c79 ; rdx 0x2069ac91c79 <a SymbolObject with map 0x33abe2a728e1>
      7: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
      9: 0x16f3adb61821 ; [fp - 96] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
     10: 0xd6230daf4a1 ; rax 0xd6230daf4a1 <JS Function forEach (SharedFunctionInfo 0xc2bd2ae0d69)>
  translating frame checkFunctionOrMethodDeclaration => node=224, height=56
    0x7fff5fbfdd98: [top + 96] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdd90: [top + 88] <- 0x9ebbbf51fb9 ;  0x9ebbbf51fb9 <a NodeObject with map 0x33abe2a70159>  (input #2)
    0x7fff5fbfdd88: [top + 80] <- 0x2c21d2611641 ;  caller's pc
    0x7fff5fbfdd80: [top + 72] <- 0x7fff5fbfddb8 ;  caller's fp
    0x7fff5fbfdd78: [top + 64] <- 0x139ed2539d21 ;  context    0x139ed2539d21 <FixedArray[5]>  (input #3)
    0x7fff5fbfdd70: [top + 56] <- 0x1030c9d3ff99 ;  function    0x1030c9d3ff99 <JS Function checkFunctionOrMethodDeclaration (SharedFunctionInfo 0x1b98fbc0c0c1)>  (input #0)
    0x7fff5fbfdd68: [top + 48] <- 0x30bcea404421 ;  0x30bcea404421 <false>  (input #4)
    0x7fff5fbfdd60: [top + 40] <- 0x2069ac91c79 ;  0x2069ac91c79 <a SymbolObject with map 0x33abe2a728e1>  (input #5)
    0x7fff5fbfdd58: [top + 32] <- 0x2069ac91c79 ;  0x2069ac91c79 <a SymbolObject with map 0x33abe2a728e1>  (input #6)
    0x7fff5fbfdd50: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfdd48: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfdd40: [top + 8] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #9)
    0x7fff5fbfdd38: [top + 0] <- 0xd6230daf4a1 ;  0xd6230daf4a1 <JS Function forEach (SharedFunctionInfo 0xc2bd2ae0d69)>  (input #10)
[deoptimizing (eager): end 0x1030c9d3ff99 <JS Function checkFunctionOrMethodDeclaration (SharedFunctionInfo 0x1b98fbc0c0c1)> @32 => node=224, pc=0x2c21d25fc659, caller sp=0x7fff5fbfdda0, state=TOS_REGISTER, took 0.093 ms]
[deoptimizing (DEOPT eager): begin 0xd6230dcb571 <JS Function isInAmbientContext (SharedFunctionInfo 0x3504a53d15d9)> (opt #411) @7, FP to SP delta: 40, caller sp: 0x7fff5fbfdc30]
            ;;; deoptimize at 0_129: wrong map
  reading input frame isInAmbientContext => node=39, args=2, height=1; inputs:
      0: 0xd6230dcb571 ; [fp - 16] 0xd6230dcb571 <JS Function isInAmbientContext (SharedFunctionInfo 0x3504a53d15d9)>
      1: 0x16f3adb61821 ; [fp + 24] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x2f05bb83a721 ; rax 0x2f05bb83a721 <a SourceFileObject with map 0x33abe2a72889>
      3: 0xd6230db34c9 ; [fp - 24] 0xd6230db34c9 <FixedArray[156]>
  translating frame isInAmbientContext => node=39, height=0
    0x7fff5fbfdc28: [top + 40] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfdc20: [top + 32] <- 0x2f05bb83a721 ;  0x2f05bb83a721 <a SourceFileObject with map 0x33abe2a72889>  (input #2)
    0x7fff5fbfdc18: [top + 24] <- 0x2c21d2606333 ;  caller's pc
    0x7fff5fbfdc10: [top + 16] <- 0x7fff5fbfdd20 ;  caller's fp
    0x7fff5fbfdc08: [top + 8] <- 0xd6230db34c9 ;  context    0xd6230db34c9 <FixedArray[156]>  (input #3)
    0x7fff5fbfdc00: [top + 0] <- 0xd6230dcb571 ;  function    0xd6230dcb571 <JS Function isInAmbientContext (SharedFunctionInfo 0x3504a53d15d9)>  (input #0)
[deoptimizing (eager): end 0xd6230dcb571 <JS Function isInAmbientContext (SharedFunctionInfo 0x3504a53d15d9)> @7 => node=39, pc=0x2c21d2545718, caller sp=0x7fff5fbfdc30, state=NO_REGISTERS, took 0.053 ms]
[deoptimizing (DEOPT eager): begin 0x130b7e1b6811 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)> (opt #391) @87, FP to SP delta: 320, caller sp: 0x7fff5fbfd8f8]
            ;;; deoptimize at 0_7760: Unknown map in polymorphic access
  reading input frame resolveName => node=1143, args=6, height=20; inputs:
      0: 0x130b7e1b6811 ; [fp - 16] 0x130b7e1b6811 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)>
      1: 0x1f9f6c0532e1 ; [fp + 56] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x33c68034a939 ; [fp - 40] 0x33c68034a939 <a NodeObject with map 0x33abe2a70101>
      3: 0x286514cef9f1 ; [fp + 40] 0x286514cef9f1 <String[7]: Element>
      4: 0xc19e800000000 ; [fp + 32] 793064
      5: 0xd6230ded3a9 ; [fp + 24] 0xd6230ded3a9 <an Object with map 0x33abe2a3df61>
      6: 0x2be622fba499 ; [fp + 16] 0x2be622fba499 <an IdentifierObject with map 0x33abe2a6fb81>
      7: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      8: 0x30bcea4069a9 ; (literal 12) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      9: 0x30bcea4069a9 ; (literal 12) 0x30bcea4069a9 <Odd Oddball: optimized_out>
     10: 0x9ebbbf52639 ; [fp - 64] 0x9ebbbf52639 <a NodeObject with map 0x33abe2a70159>
     11: 0x30bcea404311 ; [fp - 56] 0x30bcea404311 <undefined>
     12: 0x2be622fba499 ; [fp + 48] 0x2be622fba499 <an IdentifierObject with map 0x33abe2a6fb81>
     13: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     14: 0x30bcea404421 ; [fp - 48] 0x30bcea404421 <false>
     15: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     16: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     17: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     18: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     19: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     20: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     21: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     22: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     23: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     24: 0x1030c9d3e2b1 ; rdx 0x1030c9d3e2b1 <JS Function getSymbol (SharedFunctionInfo 0x2e2f693e7951)>
     25: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     26: 0x2069ac90b99 ; rcx 0x2069ac90b99 <a SymbolObject with map 0x33abe2a74ca1>
  translating frame resolveName => node=1143, height=152
    0x7fff5fbfd8f0: [top + 224] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd8e8: [top + 216] <- 0x33c68034a939 ;  0x33c68034a939 <a NodeObject with map 0x33abe2a70101>  (input #2)
    0x7fff5fbfd8e0: [top + 208] <- 0x286514cef9f1 ;  0x286514cef9f1 <String[7]: Element>  (input #3)
    0x7fff5fbfd8d8: [top + 200] <- 0xc19e800000000 ;  793064  (input #4)
    0x7fff5fbfd8d0: [top + 192] <- 0xd6230ded3a9 ;  0xd6230ded3a9 <an Object with map 0x33abe2a3df61>  (input #5)
    0x7fff5fbfd8c8: [top + 184] <- 0x2be622fba499 ;  0x2be622fba499 <an IdentifierObject with map 0x33abe2a6fb81>  (input #6)
    0x7fff5fbfd8c0: [top + 176] <- 0x2c21d26b0f30 ;  caller's pc
    0x7fff5fbfd8b8: [top + 168] <- 0x7fff5fbfd978 ;  caller's fp
    0x7fff5fbfd8b0: [top + 160] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #7)
    0x7fff5fbfd8a8: [top + 152] <- 0x130b7e1b6811 ;  function    0x130b7e1b6811 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)>  (input #0)
    0x7fff5fbfd8a0: [top + 144] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #8)
    0x7fff5fbfd898: [top + 136] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #9)
    0x7fff5fbfd890: [top + 128] <- 0x9ebbbf52639 ;  0x9ebbbf52639 <a NodeObject with map 0x33abe2a70159>  (input #10)
    0x7fff5fbfd888: [top + 120] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #11)
    0x7fff5fbfd880: [top + 112] <- 0x2be622fba499 ;  0x2be622fba499 <an IdentifierObject with map 0x33abe2a6fb81>  (input #12)
    0x7fff5fbfd878: [top + 104] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #13)
    0x7fff5fbfd870: [top + 96] <- 0x30bcea404421 ;  0x30bcea404421 <false>  (input #14)
    0x7fff5fbfd868: [top + 88] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #15)
    0x7fff5fbfd860: [top + 80] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #16)
    0x7fff5fbfd858: [top + 72] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #17)
    0x7fff5fbfd850: [top + 64] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #18)
    0x7fff5fbfd848: [top + 56] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #19)
    0x7fff5fbfd840: [top + 48] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #20)
    0x7fff5fbfd838: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #21)
    0x7fff5fbfd830: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #22)
    0x7fff5fbfd828: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #23)
    0x7fff5fbfd820: [top + 16] <- 0x1030c9d3e2b1 ;  0x1030c9d3e2b1 <JS Function getSymbol (SharedFunctionInfo 0x2e2f693e7951)>  (input #24)
    0x7fff5fbfd818: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #25)
    0x7fff5fbfd810: [top + 0] <- 0x2069ac90b99 ;  0x2069ac90b99 <a SymbolObject with map 0x33abe2a74ca1>  (input #26)
[deoptimizing (eager): end 0x130b7e1b6811 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)> @87 => node=1143, pc=0x2c21d25e5863, caller sp=0x7fff5fbfd8f8, state=TOS_REGISTER, took 0.156 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getUnionType) id{419,0} ---
(types, subtypeReduction, aliasSymbol, aliasTypeArguments) {
            if (types.length === 0) {
                return neverType;
            }
            if (types.length === 1) {
                return types[0];
            }
            var typeSet = [];
            addTypesToUnion(typeSet, types);
            if (typeSet.containsAny) {
                return anyType;
            }
            if (subtypeReduction) {
                removeSubtypes(typeSet);
            }
            else if (typeSet.containsStringOrNumberLiteral) {
                removeRedundantLiteralTypes(typeSet);
            }
            if (typeSet.length === 0) {
                return typeSet.containsNull ? typeSet.containsNonWideningType ? nullType : nullWideningType :
                    typeSet.containsUndefined ? typeSet.containsNonWideningType ? undefinedType : undefinedWideningType :
                        neverType;
            }
            return getUnionTypeFromSortedList(typeSet, aliasSymbol, aliasTypeArguments);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:addTypesToUnion) id{419,1} ---
(typeSet, types) {
            for (var _i = 0, types_4 = types; _i < types_4.length; _i++) {
                var type = types_4[_i];
                addTypeToUnion(typeSet, type);
            }
        }
--- END ---
INLINE (addTypesToUnion) id{419,1} AS 1 AT <0:274>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:removeRedundantLiteralTypes) id{419,2} ---
(types) {
            var i = types.length;
            while (i > 0) {
                i--;
                var t = types[i];
                var remove = t.flags & 32 /* StringLiteral */ && types.containsString ||
                    t.flags & 64 /* NumberLiteral */ && types.containsNumber ||
                    t.flags & 96 /* StringOrNumberLiteral */ && t.flags & 1048576 /* FreshLiteral */ && containsType(types, t.regularType);
                if (remove) {
                    ts.orderedRemoveItemAt(types, i);
                }
            }
        }
--- END ---
INLINE (removeRedundantLiteralTypes) id{419,2} AS 2 AT <0:561>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getDeclaredTypeOfSymbol) id{420,0} ---
(symbol) {
            ts.Debug.assert((symbol.flags & 16777216 /* Instantiated */) === 0);
            if (symbol.flags & (32 /* Class */ | 64 /* Interface */)) {
                return getDeclaredTypeOfClassOrInterface(symbol);
            }
            if (symbol.flags & 524288 /* TypeAlias */) {
                return getDeclaredTypeOfTypeAlias(symbol);
            }
            if (symbol.flags & 262144 /* TypeParameter */) {
                return getDeclaredTypeOfTypeParameter(symbol);
            }
            if (symbol.flags & 384 /* Enum */) {
                return getDeclaredTypeOfEnum(symbol);
            }
            if (symbol.flags & 8 /* EnumMember */) {
                return getDeclaredTypeOfEnumMember(symbol);
            }
            if (symbol.flags & 8388608 /* Alias */) {
                return getDeclaredTypeOfAlias(symbol);
            }
            return unknownType;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getDeclaredTypeOfTypeParameter) id{420,1} ---
(symbol) {
            var links = getSymbolLinks(symbol);
            if (!links.declaredType) {
                var type = createType(16384 /* TypeParameter */);
                type.symbol = symbol;
                if (!ts.getDeclarationOfKind(symbol, 143 /* TypeParameter */).constraint) {
                    type.constraint = noConstraintType;
                }
                links.declaredType = type;
            }
            return links.declaredType;
        }
--- END ---
INLINE (getDeclaredTypeOfTypeParameter) id{420,1} AS 1 AT <0:458>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{420,2} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{420,2} AS 2 AT <1:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{420,3} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{420,3} AS 3 AT <2:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{420,4} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{420,4} AS 4 AT <1:125>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{420,5} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{420,5} AS 5 AT <4:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode) id{421,0} ---
(node) {
            var links = getNodeLinks(node);
            if (!links.resolvedType) {
                // Deferred resolution of members is handled by resolveObjectTypeMembers
                var aliasSymbol = getAliasSymbolForTypeNode(node);
                if (ts.isEmpty(node.symbol.members) && !aliasSymbol) {
                    links.resolvedType = emptyTypeLiteralType;
                }
                else {
                    var type = createObjectType(16 /* Anonymous */, node.symbol);
                    type.aliasSymbol = aliasSymbol;
                    type.aliasTypeArguments = getAliasTypeArgumentsForTypeNode(node);
                    links.resolvedType = type;
                }
            }
            return links.resolvedType;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeLinks) id{421,1} ---
(node) {
            var nodeId = getNodeId(node);
            return nodeLinks[nodeId] || (nodeLinks[nodeId] = { flags: 0 });
        }
--- END ---
INLINE (getNodeLinks) id{421,1} AS 1 AT <0:33>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeId) id{421,2} ---
(node) {
        if (!node.id) {
            node.id = nextNodeId;
            nextNodeId++;
        }
        return node.id;
    }
--- END ---
INLINE (getNodeId) id{421,2} AS 2 AT <1:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getAliasSymbolForTypeNode) id{421,3} ---
(node) {
            return node.parent.kind === 228 /* TypeAliasDeclaration */ ? getSymbolOfNode(node.parent) : undefined;
        }
--- END ---
INLINE (getAliasSymbolForTypeNode) id{421,3} AS 3 AT <0:215>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{421,4} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{421,4} AS 4 AT <3:82>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{421,5} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{421,5} AS 5 AT <4:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createObjectType) id{421,6} ---
(objectFlags, symbol) {
            var type = createType(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol = symbol;
            return type;
        }
--- END ---
INLINE (createObjectType) id{421,6} AS 6 AT <0:454>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{421,7} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{421,7} AS 7 AT <6:47>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{421,8} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{421,8} AS 8 AT <7:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getAliasTypeArgumentsForTypeNode) id{421,9} ---
(node) {
            var symbol = getAliasSymbolForTypeNode(node);
            return symbol ? getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol) : undefined;
        }
--- END ---
INLINE (getAliasTypeArgumentsForTypeNode) id{421,9} AS 9 AT <0:603>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getAliasSymbolForTypeNode) id{421,10} ---
(node) {
            return node.parent.kind === 228 /* TypeAliasDeclaration */ ? getSymbolOfNode(node.parent) : undefined;
        }
--- END ---
INLINE (getAliasSymbolForTypeNode) id{421,10} AS 10 AT <9:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{421,11} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{421,11} AS 11 AT <10:82>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{421,12} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{421,12} AS 12 AT <11:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:shouldReportBadModifier) id{422,0} ---
(node) {
            switch (node.kind) {
                case 151 /* GetAccessor */:
                case 152 /* SetAccessor */:
                case 150 /* Constructor */:
                case 147 /* PropertyDeclaration */:
                case 146 /* PropertySignature */:
                case 149 /* MethodDeclaration */:
                case 148 /* MethodSignature */:
                case 155 /* IndexSignature */:
                case 230 /* ModuleDeclaration */:
                case 235 /* ImportDeclaration */:
                case 234 /* ImportEqualsDeclaration */:
                case 241 /* ExportDeclaration */:
                case 240 /* ExportAssignment */:
                case 184 /* FunctionExpression */:
                case 185 /* ArrowFunction */:
                case 144 /* Parameter */:
                    return false;
                default:
                    if (node.parent.kind === 231 /* ModuleBlock */ || node.parent.kind === 261 /* SourceFile */) {
                        return false;
                    }
                    switch (node.kind) {
                        case 225 /* FunctionDeclaration */:
                            return nodeHasAnyModifiersExcept(node, 119 /* AsyncKeyword */);
                        case 226 /* ClassDeclaration */:
                            return nodeHasAnyModifiersExcept(node, 116 /* AbstractKeyword */);
                        case 227 /* InterfaceDeclaration */:
                        case 205 /* VariableStatement */:
                        case 228 /* TypeAliasDeclaration */:
                            return true;
                        case 229 /* EnumDeclaration */:
                            return nodeHasAnyModifiersExcept(node, 75 /* ConstKeyword */);
                        default:
                            ts.Debug.fail();
                            return false;
                    }
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkMethodDeclaration) id{423,0} ---
(node) {
            // Grammar checking
            checkGrammarMethod(node) || checkGrammarComputedPropertyName(node.name);
            // Grammar checking for modifiers is done inside the function checkGrammarFunctionLikeDeclaration
            checkFunctionOrMethodDeclaration(node);
            // Abstract methods cannot have an implementation.
            // Extra checks are to avoid reporting multiple errors relating to the "abstractness" of the node.
            if (ts.getModifierFlags(node) & 128 /* Abstract */ && node.body) {
                error(node, ts.Diagnostics.Method_0_cannot_have_an_implementation_because_it_is_marked_abstract, ts.declarationNameToString(node.name));
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarComputedPropertyName) id{423,1} ---
(node) {
            // If node is not a computedPropertyName, just skip the grammar checking
            if (node.kind !== 142 /* ComputedPropertyName */) {
                return false;
            }
            var computedPropertyName = node;
            if (computedPropertyName.expression.kind === 192 /* BinaryExpression */ && computedPropertyName.expression.operatorToken.kind === 25 /* CommaToken */) {
                return grammarErrorOnNode(computedPropertyName.expression, ts.Diagnostics.A_comma_expression_is_not_allowed_in_a_computed_property_name);
            }
        }
--- END ---
INLINE (checkGrammarComputedPropertyName) id{423,1} AS 1 AT <0:81>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveName) id{424,0} ---
(location, name, meaning, nameNotFoundMessage, nameArg) {
            var result;
            var lastLocation;
            var propertyWithInvalidInitializer;
            var errorLocation = location;
            var grandparent;
            var isInExternalModule = false;
            loop: while (location) {
                // Locals of a source file are not in scope (because they get merged into the global symbol table)
                if (location.locals && !isGlobalSourceFile(location)) {
                    if (result = getSymbol(location.locals, name, meaning)) {
                        var useResult = true;
                        if (ts.isFunctionLike(location) && lastLocation && lastLocation !== location.body) {
                            // symbol lookup restrictions for function-like declarations
                            // - Type parameters of a function are in scope in the entire function declaration, including the parameter
                            //   list and return type. However, local types are only in scope in the function body.
                            // - parameters are only in the scope of function body
                            // This restriction does not apply to JSDoc comment types because they are parented
                            // at a higher level than type parameters would normally be
                            if (meaning & result.flags & 793064 /* Type */ && lastLocation.kind !== 278 /* JSDocComment */) {
                                useResult = result.flags & 262144 /* TypeParameter */
                                    ? lastLocation === location.type ||
                                        lastLocation.kind === 144 /* Parameter */ ||
                                        lastLocation.kind === 143 /* TypeParameter */
                                    : false;
                            }
                            if (meaning & 107455 /* Value */ && result.flags & 1 /* FunctionScopedVariable */) {
                                // parameters are visible only inside function body, parameter list and return type
                                // technically for parameter list case here we might mix parameters and variables declared in function,
                                // however it is detected separately when checking initializers of parameters
                                // to make sure that they reference no variables declared after them.
                                useResult =
                                    lastLocation.kind === 144 /* Parameter */ ||
                                        (lastLocation === location.type &&
                                            result.valueDeclaration.kind === 144 /* Parameter */);
                            }
                        }
                        if (useResult) {
                            break loop;
                        }
                        else {
                            result = undefined;
                        }
                    }
                }
                switch (location.kind) {
                    case 261 /* SourceFile */:
                        if (!ts.isExternalOrCommonJsModule(location))
                            break;
                        isInExternalModule = true;
                    case 230 /* ModuleDeclaration */:
                        var moduleExports = getSymbolOfNode(location).exports;
                        if (location.kind === 261 /* SourceFile */ || ts.isAmbientModule(location)) {
                            // It's an external module. First see if the module has an export default and if the local
                            // name of that export default matches.
                            if (result = moduleExports["default"]) {
                                var localSymbol = ts.getLocalSymbolForExportDefault(result);
                                if (localSymbol && (result.flags & meaning) && localSymbol.name === name) {
                                    break loop;
                                }
                                result = undefined;
                            }
                            // Because of module/namespace merging, a module's exports are in scope,
                            // yet we never want to treat an export specifier as putting a member in scope.
                            // Therefore, if the name we find is purely an export specifier, it is not actually considered in scope.
                            // Two things to note about this:
                            //     1. We have to check this without calling getSymbol. The problem with calling getSymbol
                            //        on an export specifier is that it might find the export specifier itself, and try to
                            //        resolve it as an alias. This will cause the checker to consider the export specifier
                            //        a circular alias reference when it might not be.
                            //     2. We check === SymbolFlags.Alias in order to check that the symbol is *purely*
                            //        an alias. If we used &, we'd be throwing out symbols that have non alias aspects,
                            //        which is not the desired behavior.
                            if (moduleExports[name] &&
                                moduleExports[name].flags === 8388608 /* Alias */ &&
                                ts.getDeclarationOfKind(moduleExports[name], 243 /* ExportSpecifier */)) {
                                break;
                            }
                        }
                        if (result = getSymbol(moduleExports, name, meaning & 8914931 /* ModuleMember */)) {
                            break loop;
                        }
                        break;
                    case 229 /* EnumDeclaration */:
                        if (result = getSymbol(getSymbolOfNode(location).exports, name, meaning & 8 /* EnumMember */)) {
                            break loop;
                        }
                        break;
                    case 147 /* PropertyDeclaration */:
                    case 146 /* PropertySignature */:
                        // TypeScript 1.0 spec (April 2014): 8.4.1
                        // Initializer expressions for instance member variables are evaluated in the scope
                        // of the class constructor body but are not permitted to reference parameters or
                        // local variables of the constructor. This effectively means that entities from outer scopes
                        // by the same name as a constructor parameter or local variable are inaccessible
                        // in initializer expressions for instance member variables.
                        if (ts.isClassLike(location.parent) && !(ts.getModifierFlags(location) & 32 /* Static */)) {
                            var ctor = findConstructorDeclaration(location.parent);
                            if (ctor && ctor.locals) {
                                if (getSymbol(ctor.locals, name, meaning & 107455 /* Value */)) {
                                    // Remember the property node, it will be used later to report appropriate error
                                    propertyWithInvalidInitializer = location;
                                }
                            }
                        }
                        break;
                    case 226 /* ClassDeclaration */:
                    case 197 /* ClassExpression */:
                    case 227 /* InterfaceDeclaration */:
                        if (result = getSymbol(getSymbolOfNode(location).members, name, meaning & 793064 /* Type */)) {
                            if (lastLocation && ts.getModifierFlags(lastLocation) & 32 /* Static */) {
                                // TypeScript 1.0 spec (April 2014): 3.4.1
                                // The scope of a type parameter extends over the entire declaration with which the type
                                // parameter list is associated, with the exception of static member declarations in classes.
                                error(errorLocation, ts.Diagnostics.Static_members_cannot_reference_class_type_parameters);
                                return undefined;
                            }
                            break loop;
                        }
                        if (location.kind === 197 /* ClassExpression */ && meaning & 32 /* Class */) {
                            var className = location.name;
                            if (className && name === className.text) {
                                result = location.symbol;
                                break loop;
                            }
                        }
                        break;
                    // It is not legal to reference a class's own type parameters from a computed property name that
                    // belongs to the class. For example:
                    //
                    //   function foo<T>() { return '' }
                    //   class C<T> { // <-- Class's own type parameter T
                    //       [foo<T>()]() { } // <-- Reference to T from class's own computed property
                    //   }
                    //
                    case 142 /* ComputedPropertyName */:
                        grandparent = location.parent.parent;
                        if (ts.isClassLike(grandparent) || grandparent.kind === 227 /* InterfaceDeclaration */) {
                            // A reference to this grandparent's type parameters would be an error
                            if (result = getSymbol(getSymbolOfNode(grandparent).members, name, meaning & 793064 /* Type */)) {
                                error(errorLocation, ts.Diagnostics.A_computed_property_name_cannot_reference_a_type_parameter_from_its_containing_type);
                                return undefined;
                            }
                        }
                        break;
                    case 149 /* MethodDeclaration */:
                    case 148 /* MethodSignature */:
                    case 150 /* Constructor */:
                    case 151 /* GetAccessor */:
                    case 152 /* SetAccessor */:
                    case 225 /* FunctionDeclaration */:
                    case 185 /* ArrowFunction */:
                        if (meaning & 3 /* Variable */ && name === "arguments") {
                            result = argumentsSymbol;
                            break loop;
                        }
                        break;
                    case 184 /* FunctionExpression */:
                        if (meaning & 3 /* Variable */ && name === "arguments") {
                            result = argumentsSymbol;
                            break loop;
                        }
                        if (meaning & 16 /* Function */) {
                            var functionName = location.name;
                            if (functionName && name === functionName.text) {
                                result = location.symbol;
                                break loop;
                            }
                        }
                        break;
                    case 145 /* Decorator */:
                        // Decorators are resolved at the class declaration. Resolving at the parameter
                        // or member would result in looking up locals in the method.
                        //
                        //   function y() {}
                        //   class C {
                        //       method(@y x, y) {} // <-- decorator y should be resolved at the class declaration, not the parameter.
                        //   }
                        //
                        if (location.parent && location.parent.kind === 144 /* Parameter */) {
                            location = location.parent;
                        }
                        //
                        //   function y() {}
                        //   class C {
                        //       @y method(x, y) {} // <-- decorator y should be resolved at the class declaration, not the method.
                        //   }
                        //
                        if (location.parent && ts.isClassElement(location.parent)) {
                            location = location.parent;
                        }
                        break;
                }
                lastLocation = location;
                location = location.parent;
            }
            if (result && nameNotFoundMessage && noUnusedIdentifiers) {
                result.isReferenced = true;
            }
            if (!result) {
                result = getSymbol(globals, name, meaning);
            }
            if (!result) {
                if (nameNotFoundMessage) {
                    if (!errorLocation ||
                        !checkAndReportErrorForMissingPrefix(errorLocation, name, nameArg) &&
                            !checkAndReportErrorForExtendingInterface(errorLocation) &&
                            !checkAndReportErrorForUsingTypeAsNamespace(errorLocation, name, meaning) &&
                            !checkAndReportErrorForUsingTypeAsValue(errorLocation, name, meaning)) {
                        error(errorLocation, nameNotFoundMessage, typeof nameArg === "string" ? nameArg : ts.declarationNameToString(nameArg));
                    }
                }
                return undefined;
            }
            // Perform extra checks only if error reporting was requested
            if (nameNotFoundMessage) {
                if (propertyWithInvalidInitializer) {
                    // We have a match, but the reference occurred within a property initializer and the identifier also binds
                    // to a local variable in the constructor where the code will be emitted.
                    var propertyName = propertyWithInvalidInitializer.name;
                    error(errorLocation, ts.Diagnostics.Initializer_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor, ts.declarationNameToString(propertyName), typeof nameArg === "string" ? nameArg : ts.declarationNameToString(nameArg));
                    return undefined;
                }
                // Only check for block-scoped variable if we are looking for the
                // name with variable meaning
                //      For example,
                //          declare module foo {
                //              interface bar {}
                //          }
                //      const foo/*1*/: foo/*2*/.bar;
                // The foo at /*1*/ and /*2*/ will share same symbol with two meaning
                // block - scope variable and namespace module. However, only when we
                // try to resolve name in /*1*/ which is used in variable position,
                // we want to check for block- scoped
                if (meaning & 2 /* BlockScopedVariable */) {
                    var exportOrLocalSymbol = getExportSymbolOfValueSymbolIfExported(result);
                    if (exportOrLocalSymbol.flags & 2 /* BlockScopedVariable */) {
                        checkResolvedBlockScopedVariable(exportOrLocalSymbol, errorLocation);
                    }
                }
                // If we're in an external module, we can't reference value symbols created from UMD export declarations
                if (result && isInExternalModule && (meaning & 107455 /* Value */) === 107455 /* Value */) {
                    var decls = result.declarations;
                    if (decls && decls.length === 1 && decls[0].kind === 233 /* NamespaceExportDeclaration */) {
                        error(errorLocation, ts.Diagnostics._0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead, name);
                    }
                }
            }
            return result;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isGlobalSourceFile) id{424,1} ---
(node) {
            return node.kind === 261 /* SourceFile */ && !ts.isExternalOrCommonJsModule(node);
        }
--- END ---
INLINE (isGlobalSourceFile) id{424,1} AS 1 AT <0:467>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{424,2} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{424,2} AS 2 AT <0:3412>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{424,3} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{424,3} AS 3 AT <2:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{424,4} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{424,4} AS 4 AT <0:7735>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{424,5} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{424,5} AS 5 AT <4:28>
[deoptimizing (DEOPT eager): begin 0x130b7e1b5e01 <JS Function resolveStructuredTypeMembers (SharedFunctionInfo 0x2e2f693efe11)> (opt #417) @17, FP to SP delta: 248, caller sp: 0x7fff5fbfd078]
            ;;; deoptimize at 10_86: wrong map
  reading input frame resolveStructuredTypeMembers => node=104, args=2, height=2; inputs:
      0: 0x130b7e1b5e01 ; [fp - 16] 0x130b7e1b5e01 <JS Function resolveStructuredTypeMembers (SharedFunctionInfo 0x2e2f693efe11)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x139ed2569679 ; rax 0x139ed2569679 <a TypeObject with map 0x33abe2a6d1e9>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x130b7e1b5db9 ; [fp - 32] 0x130b7e1b5db9 <JS Function resolveClassOrInterfaceMembers (SharedFunctionInfo 0x2e2f693eed91)>
  reading input frame resolveClassOrInterfaceMembers => node=19, args=2, height=5; inputs:
      0: 0x130b7e1b5db9 ; (literal 15) 0x130b7e1b5db9 <JS Function resolveClassOrInterfaceMembers (SharedFunctionInfo 0x2e2f693eed91)>
      1: 0x1f9f6c0532e1 ; (literal 16) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x139ed2569679 ; rax 0x139ed2569679 <a TypeObject with map 0x33abe2a6d1e9>
      3: 0x130b7e1b3d29 ; (literal 17) 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x130b7e1b5d71 ; [fp - 40] 0x130b7e1b5d71 <JS Function resolveObjectTypeMembers (SharedFunctionInfo 0x2e2f693eecd1)>
      5: 0x30bcea404311 ; (literal 18) 0x30bcea404311 <undefined>
      6: 0x139ed2569679 ; rax 0x139ed2569679 <a TypeObject with map 0x33abe2a6d1e9>
      7: 0x130b7e1b5d29 ; [fp - 48] 0x130b7e1b5d29 <JS Function resolveDeclaredMembers (SharedFunctionInfo 0x2e2f693eeb51)>
  reading input frame resolveDeclaredMembers => node=9, args=2, height=2; inputs:
      0: 0x130b7e1b5d29 ; (literal 19) 0x130b7e1b5d29 <JS Function resolveDeclaredMembers (SharedFunctionInfo 0x2e2f693eeb51)>
      1: 0x1f9f6c0532e1 ; (literal 16) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x139ed2569679 ; rax 0x139ed2569679 <a TypeObject with map 0x33abe2a6d1e9>
      3: 0x130b7e1b3d29 ; (literal 17) 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 18) 0x30bcea404311 <undefined>
  translating frame resolveStructuredTypeMembers => node=104, height=8
    0x7fff5fbfd070: [top + 48] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd068: [top + 40] <- 0x139ed2569679 ;  0x139ed2569679 <a TypeObject with map 0x33abe2a6d1e9>  (input #2)
    0x7fff5fbfd060: [top + 32] <- 0x2c21d269748f ;  caller's pc
    0x7fff5fbfd058: [top + 24] <- 0x7fff5fbfd0b0 ;  caller's fp
    0x7fff5fbfd050: [top + 16] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd048: [top + 8] <- 0x130b7e1b5e01 ;  function    0x130b7e1b5e01 <JS Function resolveStructuredTypeMembers (SharedFunctionInfo 0x2e2f693efe11)>  (input #0)
    0x7fff5fbfd040: [top + 0] <- 0x130b7e1b5db9 ;  0x130b7e1b5db9 <JS Function resolveClassOrInterfaceMembers (SharedFunctionInfo 0x2e2f693eed91)>  (input #4)
  translating frame resolveClassOrInterfaceMembers => node=19, height=32
    0x7fff5fbfd038: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd030: [top + 64] <- 0x139ed2569679 ;  0x139ed2569679 <a TypeObject with map 0x33abe2a6d1e9>  (input #2)
    0x7fff5fbfd028: [top + 56] <- 0x2c21d260d68b ;  caller's pc
    0x7fff5fbfd020: [top + 48] <- 0x7fff5fbfd058 ;  caller's fp
    0x7fff5fbfd018: [top + 40] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd010: [top + 32] <- 0x130b7e1b5db9 ;  function    0x130b7e1b5db9 <JS Function resolveClassOrInterfaceMembers (SharedFunctionInfo 0x2e2f693eed91)>  (input #0)
    0x7fff5fbfd008: [top + 24] <- 0x130b7e1b5d71 ;  0x130b7e1b5d71 <JS Function resolveObjectTypeMembers (SharedFunctionInfo 0x2e2f693eecd1)>  (input #4)
    0x7fff5fbfd000: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfcff8: [top + 8] <- 0x139ed2569679 ;  0x139ed2569679 <a TypeObject with map 0x33abe2a6d1e9>  (input #6)
    0x7fff5fbfcff0: [top + 0] <- 0x130b7e1b5d29 ;  0x130b7e1b5d29 <JS Function resolveDeclaredMembers (SharedFunctionInfo 0x2e2f693eeb51)>  (input #7)
  translating frame resolveDeclaredMembers => node=9, height=8
    0x7fff5fbfcfe8: [top + 48] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfcfe0: [top + 40] <- 0x139ed2569679 ;  0x139ed2569679 <a TypeObject with map 0x33abe2a6d1e9>  (input #2)
    0x7fff5fbfcfd8: [top + 32] <- 0x2c21d260d988 ;  caller's pc
    0x7fff5fbfcfd0: [top + 24] <- 0x7fff5fbfd020 ;  caller's fp
    0x7fff5fbfcfc8: [top + 16] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfcfc0: [top + 8] <- 0x130b7e1b5d29 ;  function    0x130b7e1b5d29 <JS Function resolveDeclaredMembers (SharedFunctionInfo 0x2e2f693eeb51)>  (input #0)
    0x7fff5fbfcfb8: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
[deoptimizing (eager): end 0x130b7e1b5e01 <JS Function resolveStructuredTypeMembers (SharedFunctionInfo 0x2e2f693efe11)> @17 => node=9, pc=0x2c21d260daab, caller sp=0x7fff5fbfd078, state=NO_REGISTERS, took 0.178 ms]
[deoptimizing (DEOPT eager): begin 0x130b7e1b6589 <JS Function getBaseTypes (SharedFunctionInfo 0x2e2f693eda11)> (opt #379) @4, FP to SP delta: 24, caller sp: 0x7fff5fbfcf58]
            ;;; deoptimize at 0_76: wrong map
  reading input frame getBaseTypes => node=6, args=2, height=1; inputs:
      0: 0x130b7e1b6589 ; [fp - 16] 0x130b7e1b6589 <JS Function getBaseTypes (SharedFunctionInfo 0x2e2f693eda11)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x139ed2569679 ; rax 0x139ed2569679 <a TypeObject with map 0x33abe2a76401>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
  translating frame getBaseTypes => node=6, height=0
    0x7fff5fbfcf50: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfcf48: [top + 32] <- 0x139ed2569679 ;  0x139ed2569679 <a TypeObject with map 0x33abe2a76401>  (input #2)
    0x7fff5fbfcf40: [top + 24] <- 0x2c21d260f4e6 ;  caller's pc
    0x7fff5fbfcf38: [top + 16] <- 0x7fff5fbfcfd0 ;  caller's fp
    0x7fff5fbfcf30: [top + 8] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfcf28: [top + 0] <- 0x130b7e1b6589 ;  function    0x130b7e1b6589 <JS Function getBaseTypes (SharedFunctionInfo 0x2e2f693eda11)>  (input #0)
[deoptimizing (eager): end 0x130b7e1b6589 <JS Function getBaseTypes (SharedFunctionInfo 0x2e2f693eda11)> @4 => node=6, pc=0x2c21d260b127, caller sp=0x7fff5fbfcf58, state=NO_REGISTERS, took 0.045 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d44209 <JS Function getTypeOfSymbol (SharedFunctionInfo 0x2e2f693ed051)> (opt #408) @2, FP to SP delta: 128, caller sp: 0x7fff5fbfd8f8]
            ;;; deoptimize at 0_33: wrong map
  reading input frame getTypeOfSymbol => node=4, args=2, height=1; inputs:
      0: 0x1030c9d44209 ; [fp - 16] 0x1030c9d44209 <JS Function getTypeOfSymbol (SharedFunctionInfo 0x2e2f693ed051)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x139ed2567921 ; rax 0x139ed2567921 <a SymbolObject with map 0x33abe2a749e1>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
  translating frame getTypeOfSymbol => node=4, height=0
    0x7fff5fbfd8f0: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd8e8: [top + 32] <- 0x139ed2567921 ;  0x139ed2567921 <a SymbolObject with map 0x33abe2a749e1>  (input #2)
    0x7fff5fbfd8e0: [top + 24] <- 0x2c21d269da9e ;  caller's pc
    0x7fff5fbfd8d8: [top + 16] <- 0x7fff5fbfd920 ;  caller's fp
    0x7fff5fbfd8d0: [top + 8] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd8c8: [top + 0] <- 0x1030c9d44209 ;  function    0x1030c9d44209 <JS Function getTypeOfSymbol (SharedFunctionInfo 0x2e2f693ed051)>  (input #0)
[deoptimizing (eager): end 0x1030c9d44209 <JS Function getTypeOfSymbol (SharedFunctionInfo 0x2e2f693ed051)> @2 => node=4, pc=0x2c21d261cc46, caller sp=0x7fff5fbfd8f8, state=NO_REGISTERS, took 0.056 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveClassOrInterfaceMembers) id{425,0} ---
(type) {
            resolveObjectTypeMembers(type, resolveDeclaredMembers(type), emptyArray, emptyArray);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveDeclaredMembers) id{425,1} ---
(type) {
            if (!type.declaredProperties) {
                var symbol = type.symbol;
                type.declaredProperties = getNamedMembers(symbol.members);
                type.declaredCallSignatures = getSignaturesOfSymbol(symbol.members["__call"]);
                type.declaredConstructSignatures = getSignaturesOfSymbol(symbol.members["__new"]);
                type.declaredStringIndexInfo = getIndexInfoOfSymbol(symbol, 0 /* String */);
                type.declaredNumberIndexInfo = getIndexInfoOfSymbol(symbol, 1 /* Number */);
            }
            return type;
        }
--- END ---
INLINE (resolveDeclaredMembers) id{425,1} AS 1 AT <0:52>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNamedMembers) id{425,2} ---
(members) {
            var result;
            for (var id in members) {
                if (!isReservedMemberName(id)) {
                    if (!result)
                        result = [];
                    var symbol = members[id];
                    if (symbolIsValue(symbol)) {
                        result.push(symbol);
                    }
                }
            }
            return result || emptyArray;
        }
--- END ---
INLINE (getNamedMembers) id{425,2} AS 2 AT <1:137>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isReservedMemberName) id{425,3} ---
(name) {
            return name.charCodeAt(0) === 95 /* _ */ &&
                name.charCodeAt(1) === 95 /* _ */ &&
                name.charCodeAt(2) !== 95 /* _ */ &&
                name.charCodeAt(2) !== 64 /* at */;
        }
--- END ---
INLINE (isReservedMemberName) id{425,3} AS 3 AT <2:95>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexInfoOfSymbol) id{425,4} ---
(symbol, kind) {
            var declaration = getIndexDeclarationOfSymbol(symbol, kind);
            if (declaration) {
                return createIndexInfo(declaration.type ? getTypeFromTypeNode(declaration.type) : anyType, (ts.getModifierFlags(declaration) & 64 /* Readonly */) !== 0, declaration);
            }
            return undefined;
        }
--- END ---
INLINE (getIndexInfoOfSymbol) id{425,4} AS 4 AT <1:411>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createIndexInfo) id{425,5} ---
(type, isReadonly, declaration) {
            return { type: type, isReadonly: isReadonly, declaration: declaration };
        }
--- END ---
INLINE (createIndexInfo) id{425,5} AS 5 AT <4:144>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexInfoOfSymbol) id{425,6} ---
(symbol, kind) {
            var declaration = getIndexDeclarationOfSymbol(symbol, kind);
            if (declaration) {
                return createIndexInfo(declaration.type ? getTypeFromTypeNode(declaration.type) : anyType, (ts.getModifierFlags(declaration) & 64 /* Readonly */) !== 0, declaration);
            }
            return undefined;
        }
--- END ---
INLINE (getIndexInfoOfSymbol) id{425,6} AS 6 AT <1:504>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createIndexInfo) id{425,7} ---
(type, isReadonly, declaration) {
            return { type: type, isReadonly: isReadonly, declaration: declaration };
        }
--- END ---
INLINE (createIndexInfo) id{425,7} AS 7 AT <6:144>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarParameterList) id{426,0} ---
(parameters) {
            var seenOptionalParameter = false;
            var parameterCount = parameters.length;
            for (var i = 0; i < parameterCount; i++) {
                var parameter = parameters[i];
                if (parameter.dotDotDotToken) {
                    if (i !== (parameterCount - 1)) {
                        return grammarErrorOnNode(parameter.dotDotDotToken, ts.Diagnostics.A_rest_parameter_must_be_last_in_a_parameter_list);
                    }
                    if (ts.isBindingPattern(parameter.name)) {
                        return grammarErrorOnNode(parameter.name, ts.Diagnostics.A_rest_element_cannot_contain_a_binding_pattern);
                    }
                    if (parameter.questionToken) {
                        return grammarErrorOnNode(parameter.questionToken, ts.Diagnostics.A_rest_parameter_cannot_be_optional);
                    }
                    if (parameter.initializer) {
                        return grammarErrorOnNode(parameter.name, ts.Diagnostics.A_rest_parameter_cannot_have_an_initializer);
                    }
                }
                else if (parameter.questionToken) {
                    seenOptionalParameter = true;
                    if (parameter.initializer) {
                        return grammarErrorOnNode(parameter.name, ts.Diagnostics.Parameter_cannot_have_question_mark_and_initializer);
                    }
                }
                else if (seenOptionalParameter && !parameter.initializer) {
                    return grammarErrorOnNode(parameter.name, ts.Diagnostics.A_required_parameter_cannot_follow_an_optional_parameter);
                }
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkTypeReferenceNode) id{427,0} ---
(node) {
            checkGrammarTypeArguments(node, node.typeArguments);
            var type = getTypeFromTypeReference(node);
            if (type !== unknownType) {
                if (node.typeArguments) {
                    // Do type argument local checks only if referenced type is successfully resolved
                    ts.forEach(node.typeArguments, checkSourceElement);
                    if (produceDiagnostics) {
                        var symbol = getNodeLinks(node).resolvedSymbol;
                        var typeParameters = symbol.flags & 524288 /* TypeAlias */ ? getSymbolLinks(symbol).typeParameters : type.target.localTypeParameters;
                        checkTypeArgumentConstraints(typeParameters, node.typeArguments);
                    }
                }
                if (type.flags & 16 /* Enum */ && !type.memberTypes && getNodeLinks(node).resolvedSymbol.flags & 8 /* EnumMember */) {
                    error(node, ts.Diagnostics.Enum_type_0_has_members_with_initializers_that_are_not_literals, typeToString(type));
                }
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarTypeArguments) id{427,1} ---
(node, typeArguments) {
            return checkGrammarForDisallowedTrailingComma(typeArguments) ||
                checkGrammarForAtLeastOneTypeArgument(node, typeArguments);
        }
--- END ---
INLINE (checkGrammarTypeArguments) id{427,1} AS 1 AT <0:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarForDisallowedTrailingComma) id{427,2} ---
(list) {
            if (list && list.hasTrailingComma) {
                var start = list.end - ",".length;
                var end = list.end;
                var sourceFile = ts.getSourceFileOfNode(list[0]);
                return grammarErrorAtPos(sourceFile, start, end - start, ts.Diagnostics.Trailing_comma_not_allowed);
            }
        }
--- END ---
INLINE (checkGrammarForDisallowedTrailingComma) id{427,2} AS 2 AT <1:43>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarForAtLeastOneTypeArgument) id{427,3} ---
(node, typeArguments) {
            if (typeArguments && typeArguments.length === 0) {
                var sourceFile = ts.getSourceFileOfNode(node);
                var start = typeArguments.pos - "<".length;
                var end = ts.skipTrivia(sourceFile.text, typeArguments.end) + ">".length;
                return grammarErrorAtPos(sourceFile, start, end - start, ts.Diagnostics.Type_argument_list_cannot_be_empty);
            }
        }
--- END ---
INLINE (checkGrammarForAtLeastOneTypeArgument) id{427,3} AS 3 AT <1:116>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeLinks) id{427,4} ---
(node) {
            var nodeId = getNodeId(node);
            return nodeLinks[nodeId] || (nodeLinks[nodeId] = { flags: 0 });
        }
--- END ---
INLINE (getNodeLinks) id{427,4} AS 4 AT <0:468>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeId) id{427,5} ---
(node) {
        if (!node.id) {
            node.id = nextNodeId;
            nextNodeId++;
        }
        return node.id;
    }
--- END ---
INLINE (getNodeId) id{427,5} AS 5 AT <4:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{427,6} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{427,6} AS 6 AT <0:588>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{427,7} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{427,7} AS 7 AT <6:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:) id{428,0} ---
(p) { seen[p.name] = { prop: p, containingType: type }; }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getLiteralTypeFromPropertyName) id{429,0} ---
(prop) {
            return getDeclarationModifierFlagsFromSymbol(prop) & 24 /* NonPublicAccessibilityModifier */ || ts.startsWith(prop.name, "__@") ?
                neverType :
                getLiteralTypeForText(32 /* StringLiteral */, ts.unescapeIdentifier(prop.name));
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getDeclarationModifierFlagsFromSymbol) id{429,1} ---
(s) {
            return s.valueDeclaration ? ts.getCombinedModifierFlags(s.valueDeclaration) : s.flags & 134217728 /* Prototype */ ? 4 /* Public */ | 32 /* Static */ : 0;
        }
--- END ---
INLINE (getDeclarationModifierFlagsFromSymbol) id{429,1} AS 1 AT <0:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getLiteralTypeForText) id{429,2} ---
(flags, text) {
            var map = flags & 32 /* StringLiteral */ ? stringLiteralTypes : numericLiteralTypes;
            return map[text] || (map[text] = createLiteralType(flags, text));
        }
--- END ---
INLINE (getLiteralTypeForText) id{429,2} AS 2 AT <0:195>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createLiteralType) id{429,3} ---
(flags, text) {
            var type = createType(flags);
            type.text = text;
            return type;
        }
--- END ---
INLINE (createLiteralType) id{429,3} AS 3 AT <2:158>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{429,4} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{429,4} AS 4 AT <3:39>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{429,5} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{429,5} AS 5 AT <4:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:startsWith) id{430,0} ---
(str, prefix) {
        return str.lastIndexOf(prefix, 0) === 0;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:unescapeIdentifier) id{431,0} ---
(identifier) {
        return identifier.length >= 3 && identifier.charCodeAt(0) === 95 /* _ */ && identifier.charCodeAt(1) === 95 /* _ */ && identifier.charCodeAt(2) === 95 /* _ */ ? identifier.substr(1) : identifier;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isSimpleTypeRelatedTo) id{432,0} ---
(source, target, relation, errorReporter) {
            if (target.flags & 8192 /* Never */)
                return false;
            if (target.flags & 1 /* Any */ || source.flags & 8192 /* Never */)
                return true;
            if (source.flags & 262178 /* StringLike */ && target.flags & 2 /* String */)
                return true;
            if (source.flags & 340 /* NumberLike */ && target.flags & 4 /* Number */)
                return true;
            if (source.flags & 136 /* BooleanLike */ && target.flags & 8 /* Boolean */)
                return true;
            if (source.flags & 256 /* EnumLiteral */ && target.flags & 16 /* Enum */ && source.baseType === target)
                return true;
            if (source.flags & 16 /* Enum */ && target.flags & 16 /* Enum */ && isEnumTypeRelatedTo(source, target, errorReporter))
                return true;
            if (source.flags & 2048 /* Undefined */ && (!strictNullChecks || target.flags & (2048 /* Undefined */ | 1024 /* Void */)))
                return true;
            if (source.flags & 4096 /* Null */ && (!strictNullChecks || target.flags & 4096 /* Null */))
                return true;
            if (relation === assignableRelation || relation === comparableRelation) {
                if (source.flags & 1 /* Any */)
                    return true;
                if ((source.flags & 4 /* Number */ | source.flags & 64 /* NumberLiteral */) && target.flags & 272 /* EnumLike */)
                    return true;
                if (source.flags & 256 /* EnumLiteral */ &&
                    target.flags & 256 /* EnumLiteral */ &&
                    source.text === target.text &&
                    isEnumTypeRelatedTo(source.baseType, target.baseType, errorReporter)) {
                    return true;
                }
                if (source.flags & 256 /* EnumLiteral */ &&
                    target.flags & 16 /* Enum */ &&
                    isEnumTypeRelatedTo(target, source.baseType, errorReporter)) {
                    return true;
                }
            }
            return false;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isRelatedTo) id{433,0} ---
(source, target, reportErrors, headMessage) {
                var result;
                if (source.flags & 96 /* StringOrNumberLiteral */ && source.flags & 1048576 /* FreshLiteral */) {
                    source = source.regularType;
                }
                if (target.flags & 96 /* StringOrNumberLiteral */ && target.flags & 1048576 /* FreshLiteral */) {
                    target = target.regularType;
                }
                // both types are the same - covers 'they are the same primitive type or both are Any' or the same type parameter cases
                if (source === target)
                    return -1 /* True */;
                if (relation === identityRelation) {
                    return isIdenticalTo(source, target);
                }
                if (isSimpleTypeRelatedTo(source, target, relation, reportErrors ? reportError : undefined))
                    return -1 /* True */;
                if (getObjectFlags(source) & 128 /* ObjectLiteral */ && source.flags & 1048576 /* FreshLiteral */) {
                    if (hasExcessProperties(source, target, reportErrors)) {
                        if (reportErrors) {
                            reportRelationError(headMessage, source, target);
                        }
                        return 0 /* False */;
                    }
                    // Above we check for excess properties with respect to the entire target type. When union
                    // and intersection types are further deconstructed on the target side, we don't want to
                    // make the check again (as it might fail for a partial target type). Therefore we obtain
                    // the regular source type and proceed with that.
                    if (isUnionOrIntersectionTypeWithoutNullableConstituents(target)) {
                        source = getRegularTypeOfObjectLiteral(source);
                    }
                }
                var saveErrorInfo = errorInfo;
                // Note that these checks are specifically ordered to produce correct results. In particular,
                // we need to deconstruct unions before intersections (because unions are always at the top),
                // and we need to handle "each" relations before "some" relations for the same kind of type.
                if (source.flags & 65536 /* Union */) {
                    if (relation === comparableRelation) {
                        result = someTypeRelatedToType(source, target, reportErrors && !(source.flags & 8190 /* Primitive */));
                    }
                    else {
                        result = eachTypeRelatedToType(source, target, reportErrors && !(source.flags & 8190 /* Primitive */));
                    }
                    if (result) {
                        return result;
                    }
                }
                else if (target.flags & 65536 /* Union */) {
                    if (result = typeRelatedToSomeType(source, target, reportErrors && !(source.flags & 8190 /* Primitive */) && !(target.flags & 8190 /* Primitive */))) {
                        return result;
                    }
                }
                else if (target.flags & 131072 /* Intersection */) {
                    if (result = typeRelatedToEachType(source, target, reportErrors)) {
                        return result;
                    }
                }
                else if (source.flags & 131072 /* Intersection */) {
                    // Check to see if any constituents of the intersection are immediately related to the target.
                    //
                    // Don't report errors though. Checking whether a constituent is related to the source is not actually
                    // useful and leads to some confusing error messages. Instead it is better to let the below checks
                    // take care of this, or to not elaborate at all. For instance,
                    //
                    //    - For an object type (such as 'C = A & B'), users are usually more interested in structural errors.
                    //
                    //    - For a union type (such as '(A | B) = (C & D)'), it's better to hold onto the whole intersection
                    //          than to report that 'D' is not assignable to 'A' or 'B'.
                    //
                    //    - For a primitive type or type parameter (such as 'number = A & B') there is no point in
                    //          breaking the intersection apart.
                    if (result = someTypeRelatedToType(source, target, /*reportErrors*/ false)) {
                        return result;
                    }
                }
                else if (target.flags & 16384 /* TypeParameter */) {
                    // A source type { [P in keyof T]: X } is related to a target type T if X is related to T[P].
                    if (getObjectFlags(source) & 32 /* Mapped */ && getConstraintTypeFromMappedType(source) === getIndexType(target)) {
                        if (!source.declaration.questionToken) {
                            var templateType = getTemplateTypeFromMappedType(source);
                            var indexedAccessType = getIndexedAccessType(target, getTypeParameterFromMappedType(source));
                            if (result = isRelatedTo(templateType, indexedAccessType, reportErrors)) {
                                return result;
                            }
                        }
                    }
                    else {
                        // Given a type parameter K with a constraint keyof T, a type S is
                        // assignable to K if S is assignable to keyof T.
                        var constraint = getConstraintOfTypeParameter(target);
                        if (constraint && constraint.flags & 262144 /* Index */) {
                            if (result = isRelatedTo(source, constraint, reportErrors)) {
                                return result;
                            }
                        }
                    }
                }
                else if (target.flags & 262144 /* Index */) {
                    // A keyof S is related to a keyof T if T is related to S.
                    if (source.flags & 262144 /* Index */) {
                        if (result = isRelatedTo(target.type, source.type, /*reportErrors*/ false)) {
                            return result;
                        }
                    }
                    // Given a type variable T with a constraint C, a type S is assignable to
                    // keyof T if S is assignable to keyof C.
                    if (target.type.flags & 540672 /* TypeVariable */) {
                        var constraint = getConstraintOfTypeVariable(target.type);
                        if (constraint) {
                            if (result = isRelatedTo(source, getIndexType(constraint), reportErrors)) {
                                return result;
                            }
                        }
                    }
                }
                else if (target.flags & 524288 /* IndexedAccess */) {
                    // if we have indexed access types with identical index types, see if relationship holds for
                    // the two object types.
                    if (source.flags & 524288 /* IndexedAccess */ && source.indexType === target.indexType) {
                        if (result = isRelatedTo(source.objectType, target.objectType, reportErrors)) {
                            return result;
                        }
                    }
                    // A type S is related to a type T[K] if S is related to A[K], where K is string-like and
                    // A is the apparent type of S.
                    if (target.constraint) {
                        if (result = isRelatedTo(source, target.constraint, reportErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                }
                if (source.flags & 16384 /* TypeParameter */) {
                    // A source type T is related to a target type { [P in keyof T]: X } if T[P] is related to X.
                    if (getObjectFlags(target) & 32 /* Mapped */ && getConstraintTypeFromMappedType(target) === getIndexType(source)) {
                        var indexedAccessType = getIndexedAccessType(source, getTypeParameterFromMappedType(target));
                        var templateType = getTemplateTypeFromMappedType(target);
                        if (result = isRelatedTo(indexedAccessType, templateType, reportErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                    else {
                        var constraint = getConstraintOfTypeParameter(source);
                        if (!constraint || constraint.flags & 1 /* Any */) {
                            constraint = emptyObjectType;
                        }
                        // The constraint may need to be further instantiated with its 'this' type.
                        constraint = getTypeWithThisArgument(constraint, source);
                        // Report constraint errors only if the constraint is not the empty object type
                        var reportConstraintErrors = reportErrors && constraint !== emptyObjectType;
                        if (result = isRelatedTo(constraint, target, reportConstraintErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                }
                else if (source.flags & 524288 /* IndexedAccess */) {
                    // A type S[K] is related to a type T if A[K] is related to T, where K is string-like and
                    // A is the apparent type of S.
                    if (source.constraint) {
                        if (result = isRelatedTo(source.constraint, target, reportErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                }
                else {
                    if (getObjectFlags(source) & 4 /* Reference */ && getObjectFlags(target) & 4 /* Reference */ && source.target === target.target) {
                        // We have type references to same target type, see if relationship holds for all type arguments
                        if (result = typeArgumentsRelatedTo(source, target, reportErrors)) {
                            return result;
                        }
                    }
                    // Even if relationship doesn't hold for unions, intersections, or generic type references,
                    // it may hold in a structural comparison.
                    var apparentSource = getApparentType(source);
                    // In a check of the form X = A & B, we will have previously checked if A relates to X or B relates
                    // to X. Failing both of those we want to check if the aggregation of A and B's members structurally
                    // relates to X. Thus, we include intersection types on the source side here.
                    if (apparentSource.flags & (32768 /* Object */ | 131072 /* Intersection */) && target.flags & 32768 /* Object */) {
                        // Report structural errors only if we haven't reported any errors yet
                        var reportStructuralErrors = reportErrors && errorInfo === saveErrorInfo && !(source.flags & 8190 /* Primitive */);
                        if (result = objectTypeRelatedTo(apparentSource, source, target, reportStructuralErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                }
                if (reportErrors) {
                    if (source.flags & 32768 /* Object */ && target.flags & 8190 /* Primitive */) {
                        tryElaborateErrorsForPrimitivesAndObjects(source, target);
                    }
                    else if (source.symbol && source.flags & 32768 /* Object */ && globalObjectType === source) {
                        reportError(ts.Diagnostics.The_Object_type_is_assignable_to_very_few_other_types_Did_you_mean_to_use_the_any_type_instead);
                    }
                    reportRelationError(headMessage, source, target);
                }
                return 0 /* False */;
            }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{433,1} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{433,1} AS 1 AT <0:953>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{433,2} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{433,2} AS 2 AT <0:4927>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getConstraintOfTypeVariable) id{433,3} ---
(type) {
            return type.flags & 16384 /* TypeParameter */ ? getConstraintOfTypeParameter(type) :
                type.flags & 524288 /* IndexedAccess */ ? type.constraint :
                    undefined;
        }
--- END ---
INLINE (getConstraintOfTypeVariable) id{433,3} AS 3 AT <0:6792>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{433,4} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{433,4} AS 4 AT <0:8322>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeWithThisArgument) id{433,5} ---
(type, thisArgument) {
            if (getObjectFlags(type) & 4 /* Reference */) {
                return createTypeReference(type.target, ts.concatenate(type.typeArguments, [thisArgument || type.target.thisType]));
            }
            return type;
        }
--- END ---
INLINE (getTypeWithThisArgument) id{433,5} AS 5 AT <0:9283>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{433,6} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{433,6} AS 6 AT <5:39>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createTypeReference) id{433,7} ---
(target, typeArguments) {
            var id = getTypeListId(typeArguments);
            var type = target.instantiations[id];
            if (!type) {
                type = target.instantiations[id] = createObjectType(4 /* Reference */, target.symbol);
                type.flags |= typeArguments ? getPropagatingFlagsOfTypes(typeArguments, /*excludeKinds*/ 0) : 0;
                type.target = target;
                type.typeArguments = typeArguments;
            }
            return type;
        }
--- END ---
INLINE (createTypeReference) id{433,7} AS 7 AT <5:106>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createObjectType) id{433,8} ---
(objectFlags, symbol) {
            var type = createType(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol = symbol;
            return type;
        }
--- END ---
INLINE (createObjectType) id{433,8} AS 8 AT <7:203>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{433,9} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{433,9} AS 9 AT <8:47>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{433,10} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{433,10} AS 10 AT <9:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropagatingFlagsOfTypes) id{433,11} ---
(types, excludeKinds) {
            var result = 0;
            for (var _i = 0, types_3 = types; _i < types_3.length; _i++) {
                var type = types_3[_i];
                if (!(type.flags & excludeKinds)) {
                    result |= type.flags;
                }
            }
            return result & 14680064 /* PropagatingFlags */;
        }
--- END ---
INLINE (getPropagatingFlagsOfTypes) id{433,11} AS 11 AT <7:301>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{433,12} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{433,12} AS 12 AT <0:10374>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{433,13} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{433,13} AS 13 AT <0:10420>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getApparentType) id{433,14} ---
(type) {
            var t = type.flags & 540672 /* TypeVariable */ ? getApparentTypeOfTypeVariable(type) : type;
            return t.flags & 262178 /* StringLike */ ? globalStringType :
                t.flags & 340 /* NumberLike */ ? globalNumberType :
                    t.flags & 136 /* BooleanLike */ ? globalBooleanType :
                        t.flags & 512 /* ESSymbol */ ? getGlobalESSymbolType() :
                            t;
        }
--- END ---
INLINE (getApparentType) id{433,14} AS 14 AT <0:11022>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveStructuredTypeMembers) id{434,0} ---
(type) {
            if (!type.members) {
                if (type.flags & 32768 /* Object */) {
                    if (type.objectFlags & 4 /* Reference */) {
                        resolveTypeReferenceMembers(type);
                    }
                    else if (type.objectFlags & 3 /* ClassOrInterface */) {
                        resolveClassOrInterfaceMembers(type);
                    }
                    else if (type.objectFlags & 16 /* Anonymous */) {
                        resolveAnonymousTypeMembers(type);
                    }
                    else if (type.objectFlags & 32 /* Mapped */) {
                        resolveMappedTypeMembers(type);
                    }
                }
                else if (type.flags & 65536 /* Union */) {
                    resolveUnionTypeMembers(type);
                }
                else if (type.flags & 131072 /* Intersection */) {
                    resolveIntersectionTypeMembers(type);
                }
            }
            return type;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveTypeReferenceMembers) id{434,1} ---
(type) {
            var source = resolveDeclaredMembers(type.target);
            var typeParameters = ts.concatenate(source.typeParameters, [source.thisType]);
            var typeArguments = type.typeArguments && type.typeArguments.length === typeParameters.length ?
                type.typeArguments : ts.concatenate(type.typeArguments, [type]);
            resolveObjectTypeMembers(type, source, typeParameters, typeArguments);
        }
--- END ---
INLINE (resolveTypeReferenceMembers) id{434,1} AS 1 AT <0:185>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveDeclaredMembers) id{434,2} ---
(type) {
            if (!type.declaredProperties) {
                var symbol = type.symbol;
                type.declaredProperties = getNamedMembers(symbol.members);
                type.declaredCallSignatures = getSignaturesOfSymbol(symbol.members["__call"]);
                type.declaredConstructSignatures = getSignaturesOfSymbol(symbol.members["__new"]);
                type.declaredStringIndexInfo = getIndexInfoOfSymbol(symbol, 0 /* String */);
                type.declaredNumberIndexInfo = getIndexInfoOfSymbol(symbol, 1 /* Number */);
            }
            return type;
        }
--- END ---
INLINE (resolveDeclaredMembers) id{434,2} AS 2 AT <1:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNamedMembers) id{434,3} ---
(members) {
            var result;
            for (var id in members) {
                if (!isReservedMemberName(id)) {
                    if (!result)
                        result = [];
                    var symbol = members[id];
                    if (symbolIsValue(symbol)) {
                        result.push(symbol);
                    }
                }
            }
            return result || emptyArray;
        }
--- END ---
INLINE (getNamedMembers) id{434,3} AS 3 AT <2:137>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isReservedMemberName) id{434,4} ---
(name) {
            return name.charCodeAt(0) === 95 /* _ */ &&
                name.charCodeAt(1) === 95 /* _ */ &&
                name.charCodeAt(2) !== 95 /* _ */ &&
                name.charCodeAt(2) !== 64 /* at */;
        }
--- END ---
INLINE (isReservedMemberName) id{434,4} AS 4 AT <3:95>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexInfoOfSymbol) id{434,5} ---
(symbol, kind) {
            var declaration = getIndexDeclarationOfSymbol(symbol, kind);
            if (declaration) {
                return createIndexInfo(declaration.type ? getTypeFromTypeNode(declaration.type) : anyType, (ts.getModifierFlags(declaration) & 64 /* Readonly */) !== 0, declaration);
            }
            return undefined;
        }
--- END ---
INLINE (getIndexInfoOfSymbol) id{434,5} AS 5 AT <2:411>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createIndexInfo) id{434,6} ---
(type, isReadonly, declaration) {
            return { type: type, isReadonly: isReadonly, declaration: declaration };
        }
--- END ---
INLINE (createIndexInfo) id{434,6} AS 6 AT <5:144>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexInfoOfSymbol) id{434,7} ---
(symbol, kind) {
            var declaration = getIndexDeclarationOfSymbol(symbol, kind);
            if (declaration) {
                return createIndexInfo(declaration.type ? getTypeFromTypeNode(declaration.type) : anyType, (ts.getModifierFlags(declaration) & 64 /* Readonly */) !== 0, declaration);
            }
            return undefined;
        }
--- END ---
INLINE (getIndexInfoOfSymbol) id{434,7} AS 7 AT <2:504>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createIndexInfo) id{434,8} ---
(type, isReadonly, declaration) {
            return { type: type, isReadonly: isReadonly, declaration: declaration };
        }
--- END ---
INLINE (createIndexInfo) id{434,8} AS 8 AT <7:144>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveClassOrInterfaceMembers) id{434,9} ---
(type) {
            resolveObjectTypeMembers(type, resolveDeclaredMembers(type), emptyArray, emptyArray);
        }
--- END ---
INLINE (resolveClassOrInterfaceMembers) id{434,9} AS 9 AT <0:342>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveDeclaredMembers) id{434,10} ---
(type) {
            if (!type.declaredProperties) {
                var symbol = type.symbol;
                type.declaredProperties = getNamedMembers(symbol.members);
                type.declaredCallSignatures = getSignaturesOfSymbol(symbol.members["__call"]);
                type.declaredConstructSignatures = getSignaturesOfSymbol(symbol.members["__new"]);
                type.declaredStringIndexInfo = getIndexInfoOfSymbol(symbol, 0 /* String */);
                type.declaredNumberIndexInfo = getIndexInfoOfSymbol(symbol, 1 /* Number */);
            }
            return type;
        }
--- END ---
INLINE (resolveDeclaredMembers) id{434,10} AS 10 AT <9:52>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNamedMembers) id{434,11} ---
(members) {
            var result;
            for (var id in members) {
                if (!isReservedMemberName(id)) {
                    if (!result)
                        result = [];
                    var symbol = members[id];
                    if (symbolIsValue(symbol)) {
                        result.push(symbol);
                    }
                }
            }
            return result || emptyArray;
        }
--- END ---
INLINE (getNamedMembers) id{434,11} AS 11 AT <10:137>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isReservedMemberName) id{434,12} ---
(name) {
            return name.charCodeAt(0) === 95 /* _ */ &&
                name.charCodeAt(1) === 95 /* _ */ &&
                name.charCodeAt(2) !== 95 /* _ */ &&
                name.charCodeAt(2) !== 64 /* at */;
        }
--- END ---
INLINE (isReservedMemberName) id{434,12} AS 12 AT <11:95>
[marking dependent code 0x2c21d2661401 (opt #340) for deoptimization, reason: prototype-check]
[deoptimize marked code in all contexts]
[deoptimizing (DEOPT eager): begin 0x130b7e1b5e49 <JS Function getPropertyOfType (SharedFunctionInfo 0x2e2f693f0591)> (opt #415) @14, FP to SP delta: 64, caller sp: 0x7fff5fbfd7d0]
            ;;; deoptimize at 0_212: Unknown map in polymorphic access
  reading input frame getPropertyOfType => node=65, args=3, height=5; inputs:
      0: 0x130b7e1b5e49 ; [fp - 16] 0x130b7e1b5e49 <JS Function getPropertyOfType (SharedFunctionInfo 0x2e2f693f0591)>
      1: 0x1f9f6c0532e1 ; [fp + 32] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x139ed25c5009 ; [fp - 48] 0x139ed25c5009 <a TypeObject with map 0x33abe2a765b9>
      3: 0x1b98fbca9991 ; [fp + 16] 0x1b98fbca9991 <String[9]: classList>
      4: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      5: 0x30bcea404311 ; (literal 3) 0x30bcea404311 <undefined>
      6: 0x30bcea404311 ; (literal 3) 0x30bcea404311 <undefined>
      7: 0x30bcea404311 ; (literal 3) 0x30bcea404311 <undefined>
      8: 0x139ed25c5009 ; rax 0x139ed25c5009 <a TypeObject with map 0x33abe2a765b9>
  translating frame getPropertyOfType => node=65, height=32
    0x7fff5fbfd7c8: [top + 80] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd7c0: [top + 72] <- 0x139ed25c5009 ;  0x139ed25c5009 <a TypeObject with map 0x33abe2a765b9>  (input #2)
    0x7fff5fbfd7b8: [top + 64] <- 0x1b98fbca9991 ;  0x1b98fbca9991 <String[9]: classList>  (input #3)
    0x7fff5fbfd7b0: [top + 56] <- 0x2c21d262cf63 ;  caller's pc
    0x7fff5fbfd7a8: [top + 48] <- 0x7fff5fbfd850 ;  caller's fp
    0x7fff5fbfd7a0: [top + 40] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #4)
    0x7fff5fbfd798: [top + 32] <- 0x130b7e1b5e49 ;  function    0x130b7e1b5e49 <JS Function getPropertyOfType (SharedFunctionInfo 0x2e2f693f0591)>  (input #0)
    0x7fff5fbfd790: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfd788: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfd780: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfd778: [top + 0] <- 0x139ed25c5009 ;  0x139ed25c5009 <a TypeObject with map 0x33abe2a765b9>  (input #8)
[deoptimizing (eager): end 0x130b7e1b5e49 <JS Function getPropertyOfType (SharedFunctionInfo 0x2e2f693f0591)> @14 => node=65, pc=0x2c21d262ff1c, caller sp=0x7fff5fbfd7d0, state=TOS_REGISTER, took 0.078 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:propertiesRelatedTo) id{435,0} ---
(source, target, reportErrors) {
                if (relation === identityRelation) {
                    return propertiesIdenticalTo(source, target);
                }
                var result = -1 /* True */;
                var properties = getPropertiesOfObjectType(target);
                var requireOptionalProperties = relation === subtypeRelation && !(getObjectFlags(source) & 128 /* ObjectLiteral */);
                for (var _i = 0, properties_3 = properties; _i < properties_3.length; _i++) {
                    var targetProp = properties_3[_i];
                    var sourceProp = getPropertyOfType(source, targetProp.name);
                    if (sourceProp !== targetProp) {
                        if (!sourceProp) {
                            if (!(targetProp.flags & 536870912 /* Optional */) || requireOptionalProperties) {
                                if (reportErrors) {
                                    reportError(ts.Diagnostics.Property_0_is_missing_in_type_1, symbolToString(targetProp), typeToString(source));
                                }
                                return 0 /* False */;
                            }
                        }
                        else if (!(targetProp.flags & 134217728 /* Prototype */)) {
                            var sourcePropFlags = getDeclarationModifierFlagsFromSymbol(sourceProp);
                            var targetPropFlags = getDeclarationModifierFlagsFromSymbol(targetProp);
                            if (sourcePropFlags & 8 /* Private */ || targetPropFlags & 8 /* Private */) {
                                if (sourceProp.valueDeclaration !== targetProp.valueDeclaration) {
                                    if (reportErrors) {
                                        if (sourcePropFlags & 8 /* Private */ && targetPropFlags & 8 /* Private */) {
                                            reportError(ts.Diagnostics.Types_have_separate_declarations_of_a_private_property_0, symbolToString(targetProp));
                                        }
                                        else {
                                            reportError(ts.Diagnostics.Property_0_is_private_in_type_1_but_not_in_type_2, symbolToString(targetProp), typeToString(sourcePropFlags & 8 /* Private */ ? source : target), typeToString(sourcePropFlags & 8 /* Private */ ? target : source));
                                        }
                                    }
                                    return 0 /* False */;
                                }
                            }
                            else if (targetPropFlags & 16 /* Protected */) {
                                var sourceDeclaredInClass = sourceProp.parent && sourceProp.parent.flags & 32 /* Class */;
                                var sourceClass = sourceDeclaredInClass ? getDeclaredTypeOfSymbol(getParentOfSymbol(sourceProp)) : undefined;
                                var targetClass = getDeclaredTypeOfSymbol(getParentOfSymbol(targetProp));
                                if (!sourceClass || !hasBaseType(sourceClass, targetClass)) {
                                    if (reportErrors) {
                                        reportError(ts.Diagnostics.Property_0_is_protected_but_type_1_is_not_a_class_derived_from_2, symbolToString(targetProp), typeToString(sourceClass || source), typeToString(targetClass));
                                    }
                                    return 0 /* False */;
                                }
                            }
                            else if (sourcePropFlags & 16 /* Protected */) {
                                if (reportErrors) {
                                    reportError(ts.Diagnostics.Property_0_is_protected_in_type_1_but_public_in_type_2, symbolToString(targetProp), typeToString(source), typeToString(target));
                                }
                                return 0 /* False */;
                            }
                            var related = isRelatedTo(getTypeOfSymbol(sourceProp), getTypeOfSymbol(targetProp), reportErrors);
                            if (!related) {
                                if (reportErrors) {
                                    reportError(ts.Diagnostics.Types_of_property_0_are_incompatible, symbolToString(targetProp));
                                }
                                return 0 /* False */;
                            }
                            result &= related;
                            // When checking for comparability, be more lenient with optional properties.
                            if (relation !== comparableRelation && sourceProp.flags & 536870912 /* Optional */ && !(targetProp.flags & 536870912 /* Optional */)) {
                                // TypeScript 1.0 spec (April 2014): 3.8.3
                                // S is a subtype of a type T, and T is a supertype of S if ...
                                // S' and T are object types and, for each member M in T..
                                // M is a property and S' contains a property N where
                                // if M is a required property, N is also a required property
                                // (M - property in T)
                                // (N - property in S)
                                if (reportErrors) {
                                    reportError(ts.Diagnostics.Property_0_is_optional_in_type_1_but_required_in_type_2, symbolToString(targetProp), typeToString(source), typeToString(target));
                                }
                                return 0 /* False */;
                            }
                        }
                    }
                }
                return result;
            }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropertiesOfObjectType) id{435,1} ---
(type) {
            if (type.flags & 32768 /* Object */) {
                return resolveStructuredTypeMembers(type).properties;
            }
            return emptyArray;
        }
--- END ---
INLINE (getPropertiesOfObjectType) id{435,1} AS 1 AT <0:247>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getDeclarationModifierFlagsFromSymbol) id{435,2} ---
(s) {
            return s.valueDeclaration ? ts.getCombinedModifierFlags(s.valueDeclaration) : s.flags & 134217728 /* Prototype */ ? 4 /* Public */ | 32 /* Static */ : 0;
        }
--- END ---
INLINE (getDeclarationModifierFlagsFromSymbol) id{435,2} AS 2 AT <0:1329>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getDeclarationModifierFlagsFromSymbol) id{435,3} ---
(s) {
            return s.valueDeclaration ? ts.getCombinedModifierFlags(s.valueDeclaration) : s.flags & 134217728 /* Prototype */ ? 4 /* Public */ | 32 /* Static */ : 0;
        }
--- END ---
INLINE (getDeclarationModifierFlagsFromSymbol) id{435,3} AS 3 AT <0:1430>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:addTypeToUnion) id{436,0} ---
(typeSet, type) {
            var flags = type.flags;
            if (flags & 65536 /* Union */) {
                addTypesToUnion(typeSet, type.types);
            }
            else if (flags & 1 /* Any */) {
                typeSet.containsAny = true;
            }
            else if (!strictNullChecks && flags & 6144 /* Nullable */) {
                if (flags & 2048 /* Undefined */)
                    typeSet.containsUndefined = true;
                if (flags & 4096 /* Null */)
                    typeSet.containsNull = true;
                if (!(flags & 2097152 /* ContainsWideningType */))
                    typeSet.containsNonWideningType = true;
            }
            else if (!(flags & 8192 /* Never */)) {
                if (flags & 2 /* String */)
                    typeSet.containsString = true;
                if (flags & 4 /* Number */)
                    typeSet.containsNumber = true;
                if (flags & 96 /* StringOrNumberLiteral */)
                    typeSet.containsStringOrNumberLiteral = true;
                var len = typeSet.length;
                var index = len && type.id > typeSet[len - 1].id ? ~len : binarySearchTypes(typeSet, type);
                if (index < 0) {
                    if (!(flags & 32768 /* Object */ && type.objectFlags & 16 /* Anonymous */ &&
                        type.symbol && type.symbol.flags & (16 /* Function */ | 8192 /* Method */) && containsIdenticalType(typeSet, type))) {
                        typeSet.splice(~index, 0, type);
                    }
                }
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:addTypesToUnion) id{436,1} ---
(typeSet, types) {
            for (var _i = 0, types_4 = types; _i < types_4.length; _i++) {
                var type = types_4[_i];
                addTypeToUnion(typeSet, type);
            }
        }
--- END ---
INLINE (addTypesToUnion) id{436,1} AS 1 AT <0:115>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:binarySearchTypes) id{436,2} ---
(types, type) {
            var low = 0;
            var high = types.length - 1;
            var typeId = type.id;
            while (low <= high) {
                var middle = low + ((high - low) >> 1);
                var id = types[middle].id;
                if (id === typeId) {
                    return middle;
                }
                else if (id > typeId) {
                    high = middle - 1;
                }
                else {
                    low = middle + 1;
                }
            }
            return ~low;
        }
--- END ---
INLINE (binarySearchTypes) id{436,2} AS 2 AT <0:1165>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getConstraintOfTypeParameter) id{437,0} ---
(typeParameter) {
            if (!typeParameter.constraint) {
                if (typeParameter.target) {
                    var targetConstraint = getConstraintOfTypeParameter(typeParameter.target);
                    typeParameter.constraint = targetConstraint ? instantiateType(targetConstraint, typeParameter.mapper) : noConstraintType;
                }
                else {
                    var constraintDeclaration = getConstraintDeclaration(typeParameter);
                    var constraint = getTypeFromTypeNode(constraintDeclaration);
                    if (hasConstraintReferenceTo(constraint, typeParameter)) {
                        error(constraintDeclaration, ts.Diagnostics.Type_parameter_0_has_a_circular_constraint, typeToString(typeParameter));
                        constraint = unknownType;
                    }
                    typeParameter.constraint = constraint;
                }
            }
            return typeParameter.constraint === noConstraintType ? undefined : typeParameter.constraint;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getConstraintDeclaration) id{437,1} ---
(type) {
            return ts.getDeclarationOfKind(type.symbol, 143 /* TypeParameter */).constraint;
        }
--- END ---
INLINE (getConstraintDeclaration) id{437,1} AS 1 AT <0:433>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:hasConstraintReferenceTo) id{437,2} ---
(type, target) {
            var checked;
            while (type && type.flags & 16384 /* TypeParameter */ && !(type.isThisType) && !ts.contains(checked, type)) {
                if (type === target) {
                    return true;
                }
                (checked || (checked = [])).push(type);
                var constraintDeclaration = getConstraintDeclaration(type);
                type = constraintDeclaration && getTypeFromTypeNode(constraintDeclaration);
            }
            return false;
        }
--- END ---
INLINE (hasConstraintReferenceTo) id{437,2} AS 2 AT <0:579>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getConstraintDeclaration) id{437,3} ---
(type) {
            return ts.getDeclarationOfKind(type.symbol, 143 /* TypeParameter */).constraint;
        }
--- END ---
INLINE (getConstraintDeclaration) id{437,3} AS 3 AT <2:354>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropertyOfType) id{438,0} ---
(type, name) {
            type = getApparentType(type);
            if (type.flags & 32768 /* Object */) {
                var resolved = resolveStructuredTypeMembers(type);
                var symbol = resolved.members[name];
                if (symbol && symbolIsValue(symbol)) {
                    return symbol;
                }
                if (resolved === anyFunctionType || resolved.callSignatures.length || resolved.constructSignatures.length) {
                    var symbol_1 = getPropertyOfObjectType(globalFunctionType, name);
                    if (symbol_1) {
                        return symbol_1;
                    }
                }
                return getPropertyOfObjectType(globalObjectType, name);
            }
            if (type.flags & 196608 /* UnionOrIntersection */) {
                return getPropertyOfUnionOrIntersectionType(type, name);
            }
            return undefined;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getApparentType) id{438,1} ---
(type) {
            var t = type.flags & 540672 /* TypeVariable */ ? getApparentTypeOfTypeVariable(type) : type;
            return t.flags & 262178 /* StringLike */ ? globalStringType :
                t.flags & 340 /* NumberLike */ ? globalNumberType :
                    t.flags & 136 /* BooleanLike */ ? globalBooleanType :
                        t.flags & 512 /* ESSymbol */ ? getGlobalESSymbolType() :
                            t;
        }
--- END ---
INLINE (getApparentType) id{438,1} AS 1 AT <0:34>
[deoptimizing (DEOPT eager): begin 0x130b7e1b5e49 <JS Function getPropertyOfType (SharedFunctionInfo 0x2e2f693f0591)> (opt #438) @14, FP to SP delta: 64, caller sp: 0x7fff5fbfd7c8]
            ;;; deoptimize at 0_212: Unknown map in polymorphic access
  reading input frame getPropertyOfType => node=65, args=3, height=5; inputs:
      0: 0x130b7e1b5e49 ; [fp - 16] 0x130b7e1b5e49 <JS Function getPropertyOfType (SharedFunctionInfo 0x2e2f693f0591)>
      1: 0x1f9f6c0532e1 ; [fp + 32] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x133f5101c7b1 ; [fp - 48] 0x133f5101c7b1 <a TypeObject with map 0x33abe2a766c1>
      3: 0x1b98fbca9991 ; [fp + 16] 0x1b98fbca9991 <String[9]: classList>
      4: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      5: 0x30bcea404311 ; (literal 3) 0x30bcea404311 <undefined>
      6: 0x30bcea404311 ; (literal 3) 0x30bcea404311 <undefined>
      7: 0x30bcea404311 ; (literal 3) 0x30bcea404311 <undefined>
      8: 0x133f5101c7b1 ; rax 0x133f5101c7b1 <a TypeObject with map 0x33abe2a766c1>
  translating frame getPropertyOfType => node=65, height=32
    0x7fff5fbfd7c0: [top + 80] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd7b8: [top + 72] <- 0x133f5101c7b1 ;  0x133f5101c7b1 <a TypeObject with map 0x33abe2a766c1>  (input #2)
    0x7fff5fbfd7b0: [top + 64] <- 0x1b98fbca9991 ;  0x1b98fbca9991 <String[9]: classList>  (input #3)
    0x7fff5fbfd7a8: [top + 56] <- 0x2c21d26de3e8 ;  caller's pc
    0x7fff5fbfd7a0: [top + 48] <- 0x7fff5fbfd850 ;  caller's fp
    0x7fff5fbfd798: [top + 40] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #4)
    0x7fff5fbfd790: [top + 32] <- 0x130b7e1b5e49 ;  function    0x130b7e1b5e49 <JS Function getPropertyOfType (SharedFunctionInfo 0x2e2f693f0591)>  (input #0)
    0x7fff5fbfd788: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfd780: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfd778: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfd770: [top + 0] <- 0x133f5101c7b1 ;  0x133f5101c7b1 <a TypeObject with map 0x33abe2a766c1>  (input #8)
[deoptimizing (eager): end 0x130b7e1b5e49 <JS Function getPropertyOfType (SharedFunctionInfo 0x2e2f693f0591)> @14 => node=65, pc=0x2c21d262ff1c, caller sp=0x7fff5fbfd7c8, state=TOS_REGISTER, took 0.077 ms]
[deoptimizing (DEOPT eager): begin 0x17ddd8404489 <JS Function addTypeToUnion (SharedFunctionInfo 0x2e2f693f37d1)> (opt #436) @27, FP to SP delta: 104, caller sp: 0x7fff5fbfd978]
            ;;; deoptimize at 2_236: wrong map
  reading input frame addTypeToUnion => node=413, args=3, height=5; inputs:
      0: 0x17ddd8404489 ; [fp - 16] 0x17ddd8404489 <JS Function addTypeToUnion (SharedFunctionInfo 0x2e2f693f37d1)>
      1: 0x1f9f6c0532e1 ; [fp + 32] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x133f5103b5e9 ; rbx 0x133f5103b5e9 <JS Array[0]>
      3: 0x1030c9d51889 ; [fp + 16] 0x1030c9d51889 <a TypeObject with map 0x33abe2a6cf81>
      4: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      5: 0x200000000 ; [fp - 32] 2
      6: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
      8: 0x17ddd8404631 ; [fp - 64] 0x17ddd8404631 <JS Function binarySearchTypes (SharedFunctionInfo 0x2e2f693f3651)>
  reading input frame binarySearchTypes => node=78, args=3, height=6; inputs:
      0: 0x17ddd8404631 ; (literal 7) 0x17ddd8404631 <JS Function binarySearchTypes (SharedFunctionInfo 0x2e2f693f3651)>
      1: 0x1f9f6c0532e1 ; (literal 8) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x133f5103b5e9 ; rbx 0x133f5103b5e9 <JS Array[0]>
      3: 0x1030c9d51889 ; [fp + 16] 0x1030c9d51889 <a TypeObject with map 0x33abe2a6cf81>
      4: 0x130b7e1b3d29 ; (literal 9) 0x130b7e1b3d29 <FixedArray[1022]>
      5: 0x00000000 ; (literal 10) 0
      6: -1 ; (int) [fp - 72] 
      7: 0x800000000 ; rax 8
      8: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
      9: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
  translating frame addTypeToUnion => node=413, height=32
    0x7fff5fbfd970: [top + 80] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd968: [top + 72] <- 0x133f5103b5e9 ;  0x133f5103b5e9 <JS Array[0]>  (input #2)
    0x7fff5fbfd960: [top + 64] <- 0x1030c9d51889 ;  0x1030c9d51889 <a TypeObject with map 0x33abe2a6cf81>  (input #3)
    0x7fff5fbfd958: [top + 56] <- 0x2c21d26c476c ;  caller's pc
    0x7fff5fbfd950: [top + 48] <- 0x7fff5fbfd9c0 ;  caller's fp
    0x7fff5fbfd948: [top + 40] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #4)
    0x7fff5fbfd940: [top + 32] <- 0x17ddd8404489 ;  function    0x17ddd8404489 <JS Function addTypeToUnion (SharedFunctionInfo 0x2e2f693f37d1)>  (input #0)
    0x7fff5fbfd938: [top + 24] <- 0x200000000 ;  2  (input #5)
    0x7fff5fbfd930: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfd928: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfd920: [top + 0] <- 0x17ddd8404631 ;  0x17ddd8404631 <JS Function binarySearchTypes (SharedFunctionInfo 0x2e2f693f3651)>  (input #8)
  translating frame binarySearchTypes => node=78, height=40
    0x7fff5fbfd918: [top + 88] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd910: [top + 80] <- 0x133f5103b5e9 ;  0x133f5103b5e9 <JS Array[0]>  (input #2)
    0x7fff5fbfd908: [top + 72] <- 0x1030c9d51889 ;  0x1030c9d51889 <a TypeObject with map 0x33abe2a6cf81>  (input #3)
    0x7fff5fbfd900: [top + 64] <- 0x2c21d253c254 ;  caller's pc
    0x7fff5fbfd8f8: [top + 56] <- 0x7fff5fbfd950 ;  caller's fp
    0x7fff5fbfd8f0: [top + 48] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #4)
    0x7fff5fbfd8e8: [top + 40] <- 0x17ddd8404631 ;  function    0x17ddd8404631 <JS Function binarySearchTypes (SharedFunctionInfo 0x2e2f693f3651)>  (input #0)
    0x7fff5fbfd8e0: [top + 32] <- 0x00000000 ;  0  (input #5)
    0x7fff5fbfd8d8: [top + 24] <- 0xffffffff00000000 ;  -1  (input #6)
    0x7fff5fbfd8d0: [top + 16] <- 0x800000000 ;  8  (input #7)
    0x7fff5fbfd8c8: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfd8c0: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
[deoptimizing (eager): end 0x17ddd8404489 <JS Function addTypeToUnion (SharedFunctionInfo 0x2e2f693f37d1)> @27 => node=78, pc=0x2c21d253c7ca, caller sp=0x7fff5fbfd978, state=NO_REGISTERS, took 0.167 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d445d9 <JS Function getTypeFromUnionTypeNode (SharedFunctionInfo 0x2e2f693f3e91)> (opt #406) @15, FP to SP delta: 168, caller sp: 0x7fff5fbfd978]
            ;;; deoptimize at 0_75: wrong map
  reading input frame getTypeFromUnionTypeNode => node=18, args=2, height=3; inputs:
      0: 0x1030c9d445d9 ; [fp - 16] 0x1030c9d445d9 <JS Function getTypeFromUnionTypeNode (SharedFunctionInfo 0x2e2f693f3e91)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2e2f6939dff9 ; [fp + 16] 0x2e2f6939dff9 <a NodeObject with map 0x33abe2a73fe9>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 13) 0x30bcea404311 <undefined>
      5: 0x133f5103b7b1 ; rax 0x133f5103b7b1 <an Object with map 0x33abe2a73859>
  translating frame getTypeFromUnionTypeNode => node=18, height=16
    0x7fff5fbfd970: [top + 56] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd968: [top + 48] <- 0x2e2f6939dff9 ;  0x2e2f6939dff9 <a NodeObject with map 0x33abe2a73fe9>  (input #2)
    0x7fff5fbfd960: [top + 40] <- 0x2c21d26b232c ;  caller's pc
    0x7fff5fbfd958: [top + 32] <- 0x7fff5fbfdab8 ;  caller's fp
    0x7fff5fbfd950: [top + 24] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd948: [top + 16] <- 0x1030c9d445d9 ;  function    0x1030c9d445d9 <JS Function getTypeFromUnionTypeNode (SharedFunctionInfo 0x2e2f693f3e91)>  (input #0)
    0x7fff5fbfd940: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfd938: [top + 0] <- 0x133f5103b7b1 ;  0x133f5103b7b1 <an Object with map 0x33abe2a73859>  (input #5)
[deoptimizing (eager): end 0x1030c9d445d9 <JS Function getTypeFromUnionTypeNode (SharedFunctionInfo 0x2e2f693f3e91)> @15 => node=18, pc=0x2c21d261f2e4, caller sp=0x7fff5fbfd978, state=TOS_REGISTER, took 0.060 ms]
[deoptimizing (DEOPT soft): begin 0x133f5103c091 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)> (opt #433) @62, FP to SP delta: 296, caller sp: 0x7fff5fbfda68]
            ;;; deoptimize at 0_2706: Insufficient type feedback for generic named access
  reading input frame isRelatedTo => node=415, args=5, height=9; inputs:
      0: 0x133f5103c091 ; [fp - 16] 0x133f5103c091 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)>
      1: 0x1f9f6c0532e1 ; [fp + 48] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x133f5103bae1 ; [fp - 56] 0x133f5103bae1 <a TypeObject with map 0x33abe2a6d0e1>
      3: 0x101bfd33eb39 ; [fp - 40] 0x101bfd33eb39 <a TypeObject with map 0x33abe2a765b9>
      4: 0x30bcea4043b1 ; rdx 0x30bcea4043b1 <true>
      5: 0xd6230df6451 ; [fp + 16] 0xd6230df6451 <an Object with map 0x33abe2a3df61>
      6: 0x133f5103be21 ; rbx 0x133f5103be21 <FixedArray[40]>
      7: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; [fp - 64] 0x30bcea404311 <undefined>
      9: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     10: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     11: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     12: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     13: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     14: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
  translating frame isRelatedTo => node=415, height=64
    0x7fff5fbfda60: [top + 128] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfda58: [top + 120] <- 0x133f5103bae1 ;  0x133f5103bae1 <a TypeObject with map 0x33abe2a6d0e1>  (input #2)
    0x7fff5fbfda50: [top + 112] <- 0x101bfd33eb39 ;  0x101bfd33eb39 <a TypeObject with map 0x33abe2a765b9>  (input #3)
    0x7fff5fbfda48: [top + 104] <- 0x30bcea4043b1 ;  0x30bcea4043b1 <true>  (input #4)
    0x7fff5fbfda40: [top + 96] <- 0xd6230df6451 ;  0xd6230df6451 <an Object with map 0x33abe2a3df61>  (input #5)
    0x7fff5fbfda38: [top + 88] <- 0x2c21d262826d ;  caller's pc
    0x7fff5fbfda30: [top + 80] <- 0x7fff5fbfda88 ;  caller's fp
    0x7fff5fbfda28: [top + 72] <- 0x133f5103be21 ;  context    0x133f5103be21 <FixedArray[40]>  (input #6)
    0x7fff5fbfda20: [top + 64] <- 0x133f5103c091 ;  function    0x133f5103c091 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)>  (input #0)
    0x7fff5fbfda18: [top + 56] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfda10: [top + 48] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfda08: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
    0x7fff5fbfda00: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #10)
    0x7fff5fbfd9f8: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #11)
    0x7fff5fbfd9f0: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #12)
    0x7fff5fbfd9e8: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #13)
    0x7fff5fbfd9e0: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #14)
[deoptimizing (soft): end 0x133f5103c091 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)> @62 => node=415, pc=0x2c21d2628c4e, caller sp=0x7fff5fbfda68, state=NO_REGISTERS, took 0.079 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropertyOfType) id{439,0} ---
(type, name) {
            type = getApparentType(type);
            if (type.flags & 32768 /* Object */) {
                var resolved = resolveStructuredTypeMembers(type);
                var symbol = resolved.members[name];
                if (symbol && symbolIsValue(symbol)) {
                    return symbol;
                }
                if (resolved === anyFunctionType || resolved.callSignatures.length || resolved.constructSignatures.length) {
                    var symbol_1 = getPropertyOfObjectType(globalFunctionType, name);
                    if (symbol_1) {
                        return symbol_1;
                    }
                }
                return getPropertyOfObjectType(globalObjectType, name);
            }
            if (type.flags & 196608 /* UnionOrIntersection */) {
                return getPropertyOfUnionOrIntersectionType(type, name);
            }
            return undefined;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getApparentType) id{439,1} ---
(type) {
            var t = type.flags & 540672 /* TypeVariable */ ? getApparentTypeOfTypeVariable(type) : type;
            return t.flags & 262178 /* StringLike */ ? globalStringType :
                t.flags & 340 /* NumberLike */ ? globalNumberType :
                    t.flags & 136 /* BooleanLike */ ? globalBooleanType :
                        t.flags & 512 /* ESSymbol */ ? getGlobalESSymbolType() :
                            t;
        }
--- END ---
INLINE (getApparentType) id{439,1} AS 1 AT <0:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeOfInstantiatedSymbol) id{440,0} ---
(symbol) {
            var links = getSymbolLinks(symbol);
            if (!links.type) {
                if (!pushTypeResolution(symbol, 0 /* Type */)) {
                    return unknownType;
                }
                var type = instantiateType(getTypeOfSymbol(links.target), links.mapper);
                if (!popTypeResolution()) {
                    type = reportCircularityError(symbol);
                }
                links.type = type;
            }
            return links.type;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{440,1} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{440,1} AS 1 AT <0:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{440,2} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{440,2} AS 2 AT <1:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:popTypeResolution) id{440,3} ---
() {
            resolutionTargets.pop();
            resolutionPropertyNames.pop();
            return resolutionResults.pop();
        }
--- END ---
INLINE (popTypeResolution) id{440,3} AS 3 AT <0:323>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkParameter) id{441,0} ---
(node) {
            // Grammar checking
            // It is a SyntaxError if the Identifier "eval" or the Identifier "arguments" occurs as the
            // Identifier in a PropertySetParameterList of a PropertyAssignment that is contained in strict code
            // or if its FunctionBody is strict code(11.1.5).
            // Grammar checking
            checkGrammarDecorators(node) || checkGrammarModifiers(node);
            checkVariableLikeDeclaration(node);
            var func = ts.getContainingFunction(node);
            if (ts.getModifierFlags(node) & 92 /* ParameterPropertyModifier */) {
                func = ts.getContainingFunction(node);
                if (!(func.kind === 150 /* Constructor */ && ts.nodeIsPresent(func.body))) {
                    error(node, ts.Diagnostics.A_parameter_property_is_only_allowed_in_a_constructor_implementation);
                }
            }
            if (node.questionToken && ts.isBindingPattern(node.name) && func.body) {
                error(node, ts.Diagnostics.A_binding_pattern_parameter_cannot_be_optional_in_an_implementation_signature);
            }
            if (node.name.text === "this") {
                if (ts.indexOf(func.parameters, node) !== 0) {
                    error(node, ts.Diagnostics.A_this_parameter_must_be_the_first_parameter);
                }
                if (func.kind === 150 /* Constructor */ || func.kind === 154 /* ConstructSignature */ || func.kind === 159 /* ConstructorType */) {
                    error(node, ts.Diagnostics.A_constructor_cannot_have_a_this_parameter);
                }
            }
            // Only check rest parameter type if it's not a binding pattern. Since binding patterns are
            // not allowed in a rest parameter, we already have an error from checkGrammarParameterList.
            if (node.dotDotDotToken && !ts.isBindingPattern(node.name) && !isArrayType(getTypeOfSymbol(node.symbol))) {
                error(node, ts.Diagnostics.A_rest_parameter_must_be_of_an_array_type);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isArrayType) id{441,1} ---
(type) {
            return getObjectFlags(type) & 4 /* Reference */ && type.target === globalArrayType;
        }
--- END ---
INLINE (isArrayType) id{441,1} AS 1 AT <0:1906>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{441,2} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{441,2} AS 2 AT <1:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:binarySearchTypes) id{442,0} ---
(types, type) {
            var low = 0;
            var high = types.length - 1;
            var typeId = type.id;
            while (low <= high) {
                var middle = low + ((high - low) >> 1);
                var id = types[middle].id;
                if (id === typeId) {
                    return middle;
                }
                else if (id > typeId) {
                    high = middle - 1;
                }
                else {
                    low = middle + 1;
                }
            }
            return ~low;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:addTypeToUnion) id{443,0} ---
(typeSet, type) {
            var flags = type.flags;
            if (flags & 65536 /* Union */) {
                addTypesToUnion(typeSet, type.types);
            }
            else if (flags & 1 /* Any */) {
                typeSet.containsAny = true;
            }
            else if (!strictNullChecks && flags & 6144 /* Nullable */) {
                if (flags & 2048 /* Undefined */)
                    typeSet.containsUndefined = true;
                if (flags & 4096 /* Null */)
                    typeSet.containsNull = true;
                if (!(flags & 2097152 /* ContainsWideningType */))
                    typeSet.containsNonWideningType = true;
            }
            else if (!(flags & 8192 /* Never */)) {
                if (flags & 2 /* String */)
                    typeSet.containsString = true;
                if (flags & 4 /* Number */)
                    typeSet.containsNumber = true;
                if (flags & 96 /* StringOrNumberLiteral */)
                    typeSet.containsStringOrNumberLiteral = true;
                var len = typeSet.length;
                var index = len && type.id > typeSet[len - 1].id ? ~len : binarySearchTypes(typeSet, type);
                if (index < 0) {
                    if (!(flags & 32768 /* Object */ && type.objectFlags & 16 /* Anonymous */ &&
                        type.symbol && type.symbol.flags & (16 /* Function */ | 8192 /* Method */) && containsIdenticalType(typeSet, type))) {
                        typeSet.splice(~index, 0, type);
                    }
                }
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:addTypesToUnion) id{443,1} ---
(typeSet, types) {
            for (var _i = 0, types_4 = types; _i < types_4.length; _i++) {
                var type = types_4[_i];
                addTypeToUnion(typeSet, type);
            }
        }
--- END ---
INLINE (addTypesToUnion) id{443,1} AS 1 AT <0:115>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:binarySearchTypes) id{443,2} ---
(types, type) {
            var low = 0;
            var high = types.length - 1;
            var typeId = type.id;
            while (low <= high) {
                var middle = low + ((high - low) >> 1);
                var id = types[middle].id;
                if (id === typeId) {
                    return middle;
                }
                else if (id > typeId) {
                    high = middle - 1;
                }
                else {
                    low = middle + 1;
                }
            }
            return ~low;
        }
--- END ---
INLINE (binarySearchTypes) id{443,2} AS 2 AT <0:1165>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isRelatedTo) id{444,0} ---
(source, target, reportErrors, headMessage) {
                var result;
                if (source.flags & 96 /* StringOrNumberLiteral */ && source.flags & 1048576 /* FreshLiteral */) {
                    source = source.regularType;
                }
                if (target.flags & 96 /* StringOrNumberLiteral */ && target.flags & 1048576 /* FreshLiteral */) {
                    target = target.regularType;
                }
                // both types are the same - covers 'they are the same primitive type or both are Any' or the same type parameter cases
                if (source === target)
                    return -1 /* True */;
                if (relation === identityRelation) {
                    return isIdenticalTo(source, target);
                }
                if (isSimpleTypeRelatedTo(source, target, relation, reportErrors ? reportError : undefined))
                    return -1 /* True */;
                if (getObjectFlags(source) & 128 /* ObjectLiteral */ && source.flags & 1048576 /* FreshLiteral */) {
                    if (hasExcessProperties(source, target, reportErrors)) {
                        if (reportErrors) {
                            reportRelationError(headMessage, source, target);
                        }
                        return 0 /* False */;
                    }
                    // Above we check for excess properties with respect to the entire target type. When union
                    // and intersection types are further deconstructed on the target side, we don't want to
                    // make the check again (as it might fail for a partial target type). Therefore we obtain
                    // the regular source type and proceed with that.
                    if (isUnionOrIntersectionTypeWithoutNullableConstituents(target)) {
                        source = getRegularTypeOfObjectLiteral(source);
                    }
                }
                var saveErrorInfo = errorInfo;
                // Note that these checks are specifically ordered to produce correct results. In particular,
                // we need to deconstruct unions before intersections (because unions are always at the top),
                // and we need to handle "each" relations before "some" relations for the same kind of type.
                if (source.flags & 65536 /* Union */) {
                    if (relation === comparableRelation) {
                        result = someTypeRelatedToType(source, target, reportErrors && !(source.flags & 8190 /* Primitive */));
                    }
                    else {
                        result = eachTypeRelatedToType(source, target, reportErrors && !(source.flags & 8190 /* Primitive */));
                    }
                    if (result) {
                        return result;
                    }
                }
                else if (target.flags & 65536 /* Union */) {
                    if (result = typeRelatedToSomeType(source, target, reportErrors && !(source.flags & 8190 /* Primitive */) && !(target.flags & 8190 /* Primitive */))) {
                        return result;
                    }
                }
                else if (target.flags & 131072 /* Intersection */) {
                    if (result = typeRelatedToEachType(source, target, reportErrors)) {
                        return result;
                    }
                }
                else if (source.flags & 131072 /* Intersection */) {
                    // Check to see if any constituents of the intersection are immediately related to the target.
                    //
                    // Don't report errors though. Checking whether a constituent is related to the source is not actually
                    // useful and leads to some confusing error messages. Instead it is better to let the below checks
                    // take care of this, or to not elaborate at all. For instance,
                    //
                    //    - For an object type (such as 'C = A & B'), users are usually more interested in structural errors.
                    //
                    //    - For a union type (such as '(A | B) = (C & D)'), it's better to hold onto the whole intersection
                    //          than to report that 'D' is not assignable to 'A' or 'B'.
                    //
                    //    - For a primitive type or type parameter (such as 'number = A & B') there is no point in
                    //          breaking the intersection apart.
                    if (result = someTypeRelatedToType(source, target, /*reportErrors*/ false)) {
                        return result;
                    }
                }
                else if (target.flags & 16384 /* TypeParameter */) {
                    // A source type { [P in keyof T]: X } is related to a target type T if X is related to T[P].
                    if (getObjectFlags(source) & 32 /* Mapped */ && getConstraintTypeFromMappedType(source) === getIndexType(target)) {
                        if (!source.declaration.questionToken) {
                            var templateType = getTemplateTypeFromMappedType(source);
                            var indexedAccessType = getIndexedAccessType(target, getTypeParameterFromMappedType(source));
                            if (result = isRelatedTo(templateType, indexedAccessType, reportErrors)) {
                                return result;
                            }
                        }
                    }
                    else {
                        // Given a type parameter K with a constraint keyof T, a type S is
                        // assignable to K if S is assignable to keyof T.
                        var constraint = getConstraintOfTypeParameter(target);
                        if (constraint && constraint.flags & 262144 /* Index */) {
                            if (result = isRelatedTo(source, constraint, reportErrors)) {
                                return result;
                            }
                        }
                    }
                }
                else if (target.flags & 262144 /* Index */) {
                    // A keyof S is related to a keyof T if T is related to S.
                    if (source.flags & 262144 /* Index */) {
                        if (result = isRelatedTo(target.type, source.type, /*reportErrors*/ false)) {
                            return result;
                        }
                    }
                    // Given a type variable T with a constraint C, a type S is assignable to
                    // keyof T if S is assignable to keyof C.
                    if (target.type.flags & 540672 /* TypeVariable */) {
                        var constraint = getConstraintOfTypeVariable(target.type);
                        if (constraint) {
                            if (result = isRelatedTo(source, getIndexType(constraint), reportErrors)) {
                                return result;
                            }
                        }
                    }
                }
                else if (target.flags & 524288 /* IndexedAccess */) {
                    // if we have indexed access types with identical index types, see if relationship holds for
                    // the two object types.
                    if (source.flags & 524288 /* IndexedAccess */ && source.indexType === target.indexType) {
                        if (result = isRelatedTo(source.objectType, target.objectType, reportErrors)) {
                            return result;
                        }
                    }
                    // A type S is related to a type T[K] if S is related to A[K], where K is string-like and
                    // A is the apparent type of S.
                    if (target.constraint) {
                        if (result = isRelatedTo(source, target.constraint, reportErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                }
                if (source.flags & 16384 /* TypeParameter */) {
                    // A source type T is related to a target type { [P in keyof T]: X } if T[P] is related to X.
                    if (getObjectFlags(target) & 32 /* Mapped */ && getConstraintTypeFromMappedType(target) === getIndexType(source)) {
                        var indexedAccessType = getIndexedAccessType(source, getTypeParameterFromMappedType(target));
                        var templateType = getTemplateTypeFromMappedType(target);
                        if (result = isRelatedTo(indexedAccessType, templateType, reportErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                    else {
                        var constraint = getConstraintOfTypeParameter(source);
                        if (!constraint || constraint.flags & 1 /* Any */) {
                            constraint = emptyObjectType;
                        }
                        // The constraint may need to be further instantiated with its 'this' type.
                        constraint = getTypeWithThisArgument(constraint, source);
                        // Report constraint errors only if the constraint is not the empty object type
                        var reportConstraintErrors = reportErrors && constraint !== emptyObjectType;
                        if (result = isRelatedTo(constraint, target, reportConstraintErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                }
                else if (source.flags & 524288 /* IndexedAccess */) {
                    // A type S[K] is related to a type T if A[K] is related to T, where K is string-like and
                    // A is the apparent type of S.
                    if (source.constraint) {
                        if (result = isRelatedTo(source.constraint, target, reportErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                }
                else {
                    if (getObjectFlags(source) & 4 /* Reference */ && getObjectFlags(target) & 4 /* Reference */ && source.target === target.target) {
                        // We have type references to same target type, see if relationship holds for all type arguments
                        if (result = typeArgumentsRelatedTo(source, target, reportErrors)) {
                            return result;
                        }
                    }
                    // Even if relationship doesn't hold for unions, intersections, or generic type references,
                    // it may hold in a structural comparison.
                    var apparentSource = getApparentType(source);
                    // In a check of the form X = A & B, we will have previously checked if A relates to X or B relates
                    // to X. Failing both of those we want to check if the aggregation of A and B's members structurally
                    // relates to X. Thus, we include intersection types on the source side here.
                    if (apparentSource.flags & (32768 /* Object */ | 131072 /* Intersection */) && target.flags & 32768 /* Object */) {
                        // Report structural errors only if we haven't reported any errors yet
                        var reportStructuralErrors = reportErrors && errorInfo === saveErrorInfo && !(source.flags & 8190 /* Primitive */);
                        if (result = objectTypeRelatedTo(apparentSource, source, target, reportStructuralErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                }
                if (reportErrors) {
                    if (source.flags & 32768 /* Object */ && target.flags & 8190 /* Primitive */) {
                        tryElaborateErrorsForPrimitivesAndObjects(source, target);
                    }
                    else if (source.symbol && source.flags & 32768 /* Object */ && globalObjectType === source) {
                        reportError(ts.Diagnostics.The_Object_type_is_assignable_to_very_few_other_types_Did_you_mean_to_use_the_any_type_instead);
                    }
                    reportRelationError(headMessage, source, target);
                }
                return 0 /* False */;
            }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{444,1} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{444,1} AS 1 AT <0:953>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{444,2} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{444,2} AS 2 AT <0:4927>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getConstraintOfTypeVariable) id{444,3} ---
(type) {
            return type.flags & 16384 /* TypeParameter */ ? getConstraintOfTypeParameter(type) :
                type.flags & 524288 /* IndexedAccess */ ? type.constraint :
                    undefined;
        }
--- END ---
INLINE (getConstraintOfTypeVariable) id{444,3} AS 3 AT <0:6792>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{444,4} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{444,4} AS 4 AT <0:8322>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeWithThisArgument) id{444,5} ---
(type, thisArgument) {
            if (getObjectFlags(type) & 4 /* Reference */) {
                return createTypeReference(type.target, ts.concatenate(type.typeArguments, [thisArgument || type.target.thisType]));
            }
            return type;
        }
--- END ---
INLINE (getTypeWithThisArgument) id{444,5} AS 5 AT <0:9283>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{444,6} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{444,6} AS 6 AT <5:39>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createTypeReference) id{444,7} ---
(target, typeArguments) {
            var id = getTypeListId(typeArguments);
            var type = target.instantiations[id];
            if (!type) {
                type = target.instantiations[id] = createObjectType(4 /* Reference */, target.symbol);
                type.flags |= typeArguments ? getPropagatingFlagsOfTypes(typeArguments, /*excludeKinds*/ 0) : 0;
                type.target = target;
                type.typeArguments = typeArguments;
            }
            return type;
        }
--- END ---
INLINE (createTypeReference) id{444,7} AS 7 AT <5:106>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createObjectType) id{444,8} ---
(objectFlags, symbol) {
            var type = createType(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol = symbol;
            return type;
        }
--- END ---
INLINE (createObjectType) id{444,8} AS 8 AT <7:203>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{444,9} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{444,9} AS 9 AT <8:47>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{444,10} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{444,10} AS 10 AT <9:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropagatingFlagsOfTypes) id{444,11} ---
(types, excludeKinds) {
            var result = 0;
            for (var _i = 0, types_3 = types; _i < types_3.length; _i++) {
                var type = types_3[_i];
                if (!(type.flags & excludeKinds)) {
                    result |= type.flags;
                }
            }
            return result & 14680064 /* PropagatingFlags */;
        }
--- END ---
INLINE (getPropagatingFlagsOfTypes) id{444,11} AS 11 AT <7:301>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{444,12} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{444,12} AS 12 AT <0:10374>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{444,13} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{444,13} AS 13 AT <0:10420>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getApparentType) id{444,14} ---
(type) {
            var t = type.flags & 540672 /* TypeVariable */ ? getApparentTypeOfTypeVariable(type) : type;
            return t.flags & 262178 /* StringLike */ ? globalStringType :
                t.flags & 340 /* NumberLike */ ? globalNumberType :
                    t.flags & 136 /* BooleanLike */ ? globalBooleanType :
                        t.flags & 512 /* ESSymbol */ ? getGlobalESSymbolType() :
                            t;
        }
--- END ---
INLINE (getApparentType) id{444,14} AS 14 AT <0:11022>
[deoptimizing (DEOPT eager): begin 0x17ddd8404489 <JS Function addTypeToUnion (SharedFunctionInfo 0x2e2f693f37d1)> (opt #443) @27, FP to SP delta: 104, caller sp: 0x7fff5fbfd9f8]
            ;;; deoptimize at 2_236: wrong map
  reading input frame addTypeToUnion => node=413, args=3, height=5; inputs:
      0: 0x17ddd8404489 ; [fp - 16] 0x17ddd8404489 <JS Function addTypeToUnion (SharedFunctionInfo 0x2e2f693f37d1)>
      1: 0x1f9f6c0532e1 ; [fp + 32] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x133f51070921 ; rbx 0x133f51070921 <JS Array[0]>
      3: 0x1030c9d51889 ; [fp + 16] 0x1030c9d51889 <a TypeObject with map 0x33abe2a6cf81>
      4: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      5: 0x200000000 ; [fp - 32] 2
      6: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
      8: 0x17ddd8404631 ; [fp - 64] 0x17ddd8404631 <JS Function binarySearchTypes (SharedFunctionInfo 0x2e2f693f3651)>
  reading input frame binarySearchTypes => node=78, args=3, height=6; inputs:
      0: 0x17ddd8404631 ; (literal 7) 0x17ddd8404631 <JS Function binarySearchTypes (SharedFunctionInfo 0x2e2f693f3651)>
      1: 0x1f9f6c0532e1 ; (literal 8) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x133f51070921 ; rbx 0x133f51070921 <JS Array[0]>
      3: 0x1030c9d51889 ; [fp + 16] 0x1030c9d51889 <a TypeObject with map 0x33abe2a6cf81>
      4: 0x130b7e1b3d29 ; (literal 9) 0x130b7e1b3d29 <FixedArray[1022]>
      5: 0x00000000 ; (literal 10) 0
      6: -1 ; (int) [fp - 72] 
      7: 0x800000000 ; rax 8
      8: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
      9: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
  translating frame addTypeToUnion => node=413, height=32
    0x7fff5fbfd9f0: [top + 80] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd9e8: [top + 72] <- 0x133f51070921 ;  0x133f51070921 <JS Array[0]>  (input #2)
    0x7fff5fbfd9e0: [top + 64] <- 0x1030c9d51889 ;  0x1030c9d51889 <a TypeObject with map 0x33abe2a6cf81>  (input #3)
    0x7fff5fbfd9d8: [top + 56] <- 0x2c21d26c476c ;  caller's pc
    0x7fff5fbfd9d0: [top + 48] <- 0x7fff5fbfda40 ;  caller's fp
    0x7fff5fbfd9c8: [top + 40] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #4)
    0x7fff5fbfd9c0: [top + 32] <- 0x17ddd8404489 ;  function    0x17ddd8404489 <JS Function addTypeToUnion (SharedFunctionInfo 0x2e2f693f37d1)>  (input #0)
    0x7fff5fbfd9b8: [top + 24] <- 0x200000000 ;  2  (input #5)
    0x7fff5fbfd9b0: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfd9a8: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfd9a0: [top + 0] <- 0x17ddd8404631 ;  0x17ddd8404631 <JS Function binarySearchTypes (SharedFunctionInfo 0x2e2f693f3651)>  (input #8)
  translating frame binarySearchTypes => node=78, height=40
    0x7fff5fbfd998: [top + 88] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd990: [top + 80] <- 0x133f51070921 ;  0x133f51070921 <JS Array[0]>  (input #2)
    0x7fff5fbfd988: [top + 72] <- 0x1030c9d51889 ;  0x1030c9d51889 <a TypeObject with map 0x33abe2a6cf81>  (input #3)
    0x7fff5fbfd980: [top + 64] <- 0x2c21d253c254 ;  caller's pc
    0x7fff5fbfd978: [top + 56] <- 0x7fff5fbfd9d0 ;  caller's fp
    0x7fff5fbfd970: [top + 48] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #4)
    0x7fff5fbfd968: [top + 40] <- 0x17ddd8404631 ;  function    0x17ddd8404631 <JS Function binarySearchTypes (SharedFunctionInfo 0x2e2f693f3651)>  (input #0)
    0x7fff5fbfd960: [top + 32] <- 0x00000000 ;  0  (input #5)
    0x7fff5fbfd958: [top + 24] <- 0xffffffff00000000 ;  -1  (input #6)
    0x7fff5fbfd950: [top + 16] <- 0x800000000 ;  8  (input #7)
    0x7fff5fbfd948: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfd940: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
[deoptimizing (eager): end 0x17ddd8404489 <JS Function addTypeToUnion (SharedFunctionInfo 0x2e2f693f37d1)> @27 => node=78, pc=0x2c21d253c7ca, caller sp=0x7fff5fbfd9f8, state=NO_REGISTERS, took 0.151 ms]
[deoptimizing (DEOPT eager): begin 0x17ddd8404631 <JS Function binarySearchTypes (SharedFunctionInfo 0x2e2f693f3651)> (opt #442) @5, FP to SP delta: 32, caller sp: 0x7fff5fbfd9a0]
            ;;; deoptimize at 0_236: wrong map
  reading input frame binarySearchTypes => node=78, args=3, height=6; inputs:
      0: 0x17ddd8404631 ; [fp - 16] 0x17ddd8404631 <JS Function binarySearchTypes (SharedFunctionInfo 0x2e2f693f3651)>
      1: 0x1f9f6c0532e1 ; [fp + 32] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x133f51070b79 ; rbx 0x133f51070b79 <JS Array[0]>
      3: 0x1030c9d51889 ; [fp + 16] 0x1030c9d51889 <a TypeObject with map 0x33abe2a6cf81>
      4: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      5: 0x00000000 ; (literal 2) 0
      6: -1 ; (int) [fp - 32] 
      7: 0x800000000 ; rax 8
      8: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
      9: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
  translating frame binarySearchTypes => node=78, height=40
    0x7fff5fbfd998: [top + 88] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd990: [top + 80] <- 0x133f51070b79 ;  0x133f51070b79 <JS Array[0]>  (input #2)
    0x7fff5fbfd988: [top + 72] <- 0x1030c9d51889 ;  0x1030c9d51889 <a TypeObject with map 0x33abe2a6cf81>  (input #3)
    0x7fff5fbfd980: [top + 64] <- 0x2c21d253c254 ;  caller's pc
    0x7fff5fbfd978: [top + 56] <- 0x7fff5fbfd9d0 ;  caller's fp
    0x7fff5fbfd970: [top + 48] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #4)
    0x7fff5fbfd968: [top + 40] <- 0x17ddd8404631 ;  function    0x17ddd8404631 <JS Function binarySearchTypes (SharedFunctionInfo 0x2e2f693f3651)>  (input #0)
    0x7fff5fbfd960: [top + 32] <- 0x00000000 ;  0  (input #5)
    0x7fff5fbfd958: [top + 24] <- 0xffffffff00000000 ;  -1  (input #6)
    0x7fff5fbfd950: [top + 16] <- 0x800000000 ;  8  (input #7)
    0x7fff5fbfd948: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfd940: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
[deoptimizing (eager): end 0x17ddd8404631 <JS Function binarySearchTypes (SharedFunctionInfo 0x2e2f693f3651)> @5 => node=78, pc=0x2c21d253c7ca, caller sp=0x7fff5fbfd9a0, state=NO_REGISTERS, took 0.056 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkSignatureDeclaration) id{445,0} ---
(node) {
            // Grammar checking
            if (node.kind === 155 /* IndexSignature */) {
                checkGrammarIndexSignature(node);
            }
            else if (node.kind === 158 /* FunctionType */ || node.kind === 225 /* FunctionDeclaration */ || node.kind === 159 /* ConstructorType */ ||
                node.kind === 153 /* CallSignature */ || node.kind === 150 /* Constructor */ ||
                node.kind === 154 /* ConstructSignature */) {
                checkGrammarFunctionLikeDeclaration(node);
            }
            if (ts.isAsyncFunctionLike(node) && languageVersion < 4 /* ES2017 */) {
                checkExternalEmitHelpers(node, 64 /* Awaiter */);
                if (languageVersion < 2 /* ES2015 */) {
                    checkExternalEmitHelpers(node, 128 /* Generator */);
                }
            }
            checkTypeParameters(node.typeParameters);
            ts.forEach(node.parameters, checkParameter);
            if (node.type) {
                checkSourceElement(node.type);
            }
            if (produceDiagnostics) {
                checkCollisionWithArgumentsInGeneratedCode(node);
                if (compilerOptions.noImplicitAny && !node.type) {
                    switch (node.kind) {
                        case 154 /* ConstructSignature */:
                            error(node, ts.Diagnostics.Construct_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type);
                            break;
                        case 153 /* CallSignature */:
                            error(node, ts.Diagnostics.Call_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type);
                            break;
                    }
                }
                if (node.type) {
                    if (languageVersion >= 2 /* ES2015 */ && isSyntacticallyValidGenerator(node)) {
                        var returnType = getTypeFromTypeNode(node.type);
                        if (returnType === voidType) {
                            error(node.type, ts.Diagnostics.A_generator_cannot_have_a_void_type_annotation);
                        }
                        else {
                            var generatorElementType = getElementTypeOfIterableIterator(returnType) || anyType;
                            var iterableIteratorInstantiation = createIterableIteratorType(generatorElementType);
                            // Naively, one could check that IterableIterator<any> is assignable to the return type annotation.
                            // However, that would not catch the error in the following case.
                            //
                            //    interface BadGenerator extends Iterable<number>, Iterator<string> { }
                            //    function* g(): BadGenerator { } // Iterable and Iterator have different types!
                            //
                            checkTypeAssignableTo(iterableIteratorInstantiation, returnType, node.type);
                        }
                    }
                    else if (ts.isAsyncFunctionLike(node)) {
                        checkAsyncFunctionReturnType(node);
                    }
                }
                if (noUnusedIdentifiers && !node.body) {
                    checkUnusedTypeParameters(node);
                }
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarIndexSignature) id{445,1} ---
(node) {
            // Prevent cascading error by short-circuit
            return checkGrammarDecorators(node) || checkGrammarModifiers(node) || checkGrammarIndexSignatureParameters(node);
        }
--- END ---
INLINE (checkGrammarIndexSignature) id{445,1} AS 1 AT <0:115>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarFunctionLikeDeclaration) id{445,2} ---
(node) {
            // Prevent cascading error by short-circuit
            var file = ts.getSourceFileOfNode(node);
            return checkGrammarDecorators(node) || checkGrammarModifiers(node) || checkGrammarTypeParameterList(node.typeParameters, file) ||
                checkGrammarParameterList(node.parameters) || checkGrammarArrowFunction(node, file);
        }
--- END ---
INLINE (checkGrammarFunctionLikeDeclaration) id{445,2} AS 2 AT <0:488>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarTypeParameterList) id{445,3} ---
(typeParameters, file) {
            if (checkGrammarForDisallowedTrailingComma(typeParameters)) {
                return true;
            }
            if (typeParameters && typeParameters.length === 0) {
                var start = typeParameters.pos - "<".length;
                var end = ts.skipTrivia(file.text, typeParameters.end) + ">".length;
                return grammarErrorAtPos(file, start, end - start, ts.Diagnostics.Type_parameter_list_cannot_be_empty);
            }
        }
--- END ---
INLINE (checkGrammarTypeParameterList) id{445,3} AS 3 AT <2:200>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarForDisallowedTrailingComma) id{445,4} ---
(list) {
            if (list && list.hasTrailingComma) {
                var start = list.end - ",".length;
                var end = list.end;
                var sourceFile = ts.getSourceFileOfNode(list[0]);
                return grammarErrorAtPos(sourceFile, start, end - start, ts.Diagnostics.Trailing_comma_not_allowed);
            }
        }
--- END ---
INLINE (checkGrammarForDisallowedTrailingComma) id{445,4} AS 4 AT <3:41>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkCollisionWithArgumentsInGeneratedCode) id{445,5} ---
(node) {
            // no rest parameters \x5c declaration context \x5c overload - no codegen impact
            if (!ts.hasDeclaredRestParameter(node) || ts.isInAmbientContext(node) || ts.nodeIsMissing(node.body)) {
                return;
            }
            ts.forEach(node.parameters, function (p) {
                if (p.name && !ts.isBindingPattern(p.name) && p.name.text === argumentsSymbol.name) {
                    error(p, ts.Diagnostics.Duplicate_identifier_arguments_Compiler_uses_arguments_to_initialize_rest_parameters);
                }
            });
        }
--- END ---
INLINE (checkCollisionWithArgumentsInGeneratedCode) id{445,5} AS 5 AT <0:1111>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createLiteralType) id{446,0} ---
(flags, text) {
            var type = createType(flags);
            type.text = text;
            return type;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{446,1} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{446,1} AS 1 AT <0:39>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{446,2} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{446,2} AS 2 AT <1:35>
[deoptimizing (DEOPT eager): begin 0x1030c9d421e1 <JS Function checkMethodDeclaration (SharedFunctionInfo 0x1b98fbc0aa41)> (opt #423) @5, FP to SP delta: 32, caller sp: 0x7fff5fbfddd8]
            ;;; deoptimize at 0_118: wrong map
  reading input frame checkMethodDeclaration => node=7, args=2, height=1; inputs:
      0: 0x1030c9d421e1 ; [fp - 16] 0x1030c9d421e1 <JS Function checkMethodDeclaration (SharedFunctionInfo 0x1b98fbc0aa41)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2e2f6933ccf1 ; rdx 0x2e2f6933ccf1 <a NodeObject with map 0x33abe2a76611>
      3: 0x130b7e1b3d29 ; rax 0x130b7e1b3d29 <FixedArray[1022]>
  translating frame checkMethodDeclaration => node=7, height=0
    0x7fff5fbfddd0: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfddc8: [top + 32] <- 0x2e2f6933ccf1 ;  0x2e2f6933ccf1 <a NodeObject with map 0x33abe2a76611>  (input #2)
    0x7fff5fbfddc0: [top + 24] <- 0x2c21d26a560d ;  caller's pc
    0x7fff5fbfddb8: [top + 16] <- 0x7fff5fbfde98 ;  caller's fp
    0x7fff5fbfddb0: [top + 8] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdda8: [top + 0] <- 0x1030c9d421e1 ;  function    0x1030c9d421e1 <JS Function checkMethodDeclaration (SharedFunctionInfo 0x1b98fbc0aa41)>  (input #0)
[deoptimizing (eager): end 0x1030c9d421e1 <JS Function checkMethodDeclaration (SharedFunctionInfo 0x1b98fbc0aa41)> @5 => node=7, pc=0x2c21d26115cf, caller sp=0x7fff5fbfddd8, state=NO_REGISTERS, took 0.053 ms]
[deoptimizing (DEOPT eager): begin 0xd6230dc6299 <JS Function hasQuestionToken (SharedFunctionInfo 0x3504a53d0859)> (opt #346) @3, FP to SP delta: 24, caller sp: 0x7fff5fbfdc30]
            ;;; deoptimize at 0_53: wrong map
  reading input frame hasQuestionToken => node=6, args=2, height=2; inputs:
      0: 0xd6230dc6299 ; [fp - 16] 0xd6230dc6299 <JS Function hasQuestionToken (SharedFunctionInfo 0x3504a53d0859)>
      1: 0x16f3adb61821 ; [fp + 24] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x2e2f6933ccf1 ; rax 0x2e2f6933ccf1 <a NodeObject with map 0x33abe2a76611>
      3: 0xd6230db34c9 ; [fp - 24] 0xd6230db34c9 <FixedArray[156]>
      4: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
  translating frame hasQuestionToken => node=6, height=8
    0x7fff5fbfdc28: [top + 48] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfdc20: [top + 40] <- 0x2e2f6933ccf1 ;  0x2e2f6933ccf1 <a NodeObject with map 0x33abe2a76611>  (input #2)
    0x7fff5fbfdc18: [top + 32] <- 0x2c21d2606785 ;  caller's pc
    0x7fff5fbfdc10: [top + 24] <- 0x7fff5fbfdd20 ;  caller's fp
    0x7fff5fbfdc08: [top + 16] <- 0xd6230db34c9 ;  context    0xd6230db34c9 <FixedArray[156]>  (input #3)
    0x7fff5fbfdc00: [top + 8] <- 0xd6230dc6299 ;  function    0xd6230dc6299 <JS Function hasQuestionToken (SharedFunctionInfo 0x3504a53d0859)>  (input #0)
    0x7fff5fbfdbf8: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
[deoptimizing (eager): end 0xd6230dc6299 <JS Function hasQuestionToken (SharedFunctionInfo 0x3504a53d0859)> @3 => node=6, pc=0x2c21d26074eb, caller sp=0x7fff5fbfdc30, state=NO_REGISTERS, took 0.047 ms]
[deoptimizing (DEOPT eager): begin 0x17ddd84043f9 <JS Function getUnionType (SharedFunctionInfo 0x2e2f693f3d11)> (opt #419) @18, FP to SP delta: 72, caller sp: 0x7fff5fbfd940]
            ;;; deoptimize at 2_157: wrong map
  reading input frame getUnionType => node=146, args=5, height=3; inputs:
      0: 0x17ddd84043f9 ; [fp - 16] 0x17ddd84043f9 <JS Function getUnionType (SharedFunctionInfo 0x2e2f693f3d11)>
      1: 0x1f9f6c0532e1 ; [fp + 48] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x133f510af1e9 ; [fp + 40] 0x133f510af1e9 <JS Array[176]>
      3: 0x30bcea404311 ; [fp + 32] 0x30bcea404311 <undefined>
      4: 0x30bcea404311 ; [fp + 24] 0x30bcea404311 <undefined>
      5: 0x30bcea404311 ; [fp + 16] 0x30bcea404311 <undefined>
      6: 0x130b7e1b3d29 ; rax 0x130b7e1b3d29 <FixedArray[1022]>
      7: 0x133f510b10f1 ; rcx 0x133f510b10f1 <JS Array[176]>
      8: 0x1030c9d55339 ; rbx 0x1030c9d55339 <JS Function removeRedundantLiteralTypes (SharedFunctionInfo 0x2e2f693f3c51)>
  reading input frame removeRedundantLiteralTypes => node=36, args=2, height=4; inputs:
      0: 0x1030c9d55339 ; (literal 10) 0x1030c9d55339 <JS Function removeRedundantLiteralTypes (SharedFunctionInfo 0x2e2f693f3c51)>
      1: 0x1f9f6c0532e1 ; (literal 7) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x133f510b10f1 ; rcx 0x133f510b10f1 <JS Array[176]>
      3: 0x130b7e1b3d29 ; (literal 8) 0x130b7e1b3d29 <FixedArray[1022]>
      4: 104 ; rdx 
      5: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
      6: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
  translating frame getUnionType => node=146, height=16
    0x7fff5fbfd938: [top + 80] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd930: [top + 72] <- 0x133f510af1e9 ;  0x133f510af1e9 <JS Array[176]>  (input #2)
    0x7fff5fbfd928: [top + 64] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #3)
    0x7fff5fbfd920: [top + 56] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfd918: [top + 48] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfd910: [top + 40] <- 0x2c21d2207e55 ;  caller's pc
    0x7fff5fbfd908: [top + 32] <- 0x7fff5fbfd958 ;  caller's fp
    0x7fff5fbfd900: [top + 24] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #6)
    0x7fff5fbfd8f8: [top + 16] <- 0x17ddd84043f9 ;  function    0x17ddd84043f9 <JS Function getUnionType (SharedFunctionInfo 0x2e2f693f3d11)>  (input #0)
    0x7fff5fbfd8f0: [top + 8] <- 0x133f510b10f1 ;  0x133f510b10f1 <JS Array[176]>  (input #7)
    0x7fff5fbfd8e8: [top + 0] <- 0x1030c9d55339 ;  0x1030c9d55339 <JS Function removeRedundantLiteralTypes (SharedFunctionInfo 0x2e2f693f3c51)>  (input #8)
  translating frame removeRedundantLiteralTypes => node=36, height=24
    0x7fff5fbfd8e0: [top + 64] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd8d8: [top + 56] <- 0x133f510b10f1 ;  0x133f510b10f1 <JS Array[176]>  (input #2)
    0x7fff5fbfd8d0: [top + 48] <- 0x2c21d253b9d3 ;  caller's pc
    0x7fff5fbfd8c8: [top + 40] <- 0x7fff5fbfd908 ;  caller's fp
    0x7fff5fbfd8c0: [top + 32] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd8b8: [top + 24] <- 0x1030c9d55339 ;  function    0x1030c9d55339 <JS Function removeRedundantLiteralTypes (SharedFunctionInfo 0x2e2f693f3c51)>  (input #0)
    0x7fff5fbfd8b0: [top + 16] <- 0x6800000000 ;  104  (input #4)
    0x7fff5fbfd8a8: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfd8a0: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
[deoptimizing (eager): end 0x17ddd84043f9 <JS Function getUnionType (SharedFunctionInfo 0x2e2f693f3d11)> @18 => node=36, pc=0x2c21d269f283, caller sp=0x7fff5fbfd940, state=NO_REGISTERS, took 0.113 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:addTypeToUnion) id{447,0} ---
(typeSet, type) {
            var flags = type.flags;
            if (flags & 65536 /* Union */) {
                addTypesToUnion(typeSet, type.types);
            }
            else if (flags & 1 /* Any */) {
                typeSet.containsAny = true;
            }
            else if (!strictNullChecks && flags & 6144 /* Nullable */) {
                if (flags & 2048 /* Undefined */)
                    typeSet.containsUndefined = true;
                if (flags & 4096 /* Null */)
                    typeSet.containsNull = true;
                if (!(flags & 2097152 /* ContainsWideningType */))
                    typeSet.containsNonWideningType = true;
            }
            else if (!(flags & 8192 /* Never */)) {
                if (flags & 2 /* String */)
                    typeSet.containsString = true;
                if (flags & 4 /* Number */)
                    typeSet.containsNumber = true;
                if (flags & 96 /* StringOrNumberLiteral */)
                    typeSet.containsStringOrNumberLiteral = true;
                var len = typeSet.length;
                var index = len && type.id > typeSet[len - 1].id ? ~len : binarySearchTypes(typeSet, type);
                if (index < 0) {
                    if (!(flags & 32768 /* Object */ && type.objectFlags & 16 /* Anonymous */ &&
                        type.symbol && type.symbol.flags & (16 /* Function */ | 8192 /* Method */) && containsIdenticalType(typeSet, type))) {
                        typeSet.splice(~index, 0, type);
                    }
                }
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:addTypesToUnion) id{447,1} ---
(typeSet, types) {
            for (var _i = 0, types_4 = types; _i < types_4.length; _i++) {
                var type = types_4[_i];
                addTypeToUnion(typeSet, type);
            }
        }
--- END ---
INLINE (addTypesToUnion) id{447,1} AS 1 AT <0:115>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:binarySearchTypes) id{447,2} ---
(types, type) {
            var low = 0;
            var high = types.length - 1;
            var typeId = type.id;
            while (low <= high) {
                var middle = low + ((high - low) >> 1);
                var id = types[middle].id;
                if (id === typeId) {
                    return middle;
                }
                else if (id > typeId) {
                    high = middle - 1;
                }
                else {
                    low = middle + 1;
                }
            }
            return ~low;
        }
--- END ---
INLINE (binarySearchTypes) id{447,2} AS 2 AT <0:1165>
[deoptimizing (DEOPT eager): begin 0x133f510b9b19 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)> (opt #444) @7, FP to SP delta: 304, caller sp: 0x7fff5fbfd7b0]
            ;;; deoptimize at 0_330: wrong map
  reading input frame isRelatedTo => node=107, args=5, height=9; inputs:
      0: 0x133f510b9b19 ; [fp - 16] 0x133f510b9b19 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)>
      1: 0x1f9f6c0532e1 ; [fp + 48] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x133f510abac9 ; [fp - 32] 0x133f510abac9 <a TypeObject with map 0x33abe2a72d59>
      3: 0x139ed25aea99 ; rdx 0x139ed25aea99 <a TypeObject with map 0x33abe2a767c9>
      4: 0x30bcea404421 ; [fp + 24] 0x30bcea404421 <false>
      5: 0x30bcea404311 ; [fp + 16] 0x30bcea404311 <undefined>
      6: 0x133f510b98a9 ; [fp - 24] 0x133f510b98a9 <FixedArray[40]>
      7: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
      9: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     10: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     11: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     12: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     13: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     14: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
  translating frame isRelatedTo => node=107, height=64
    0x7fff5fbfd7a8: [top + 128] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd7a0: [top + 120] <- 0x133f510abac9 ;  0x133f510abac9 <a TypeObject with map 0x33abe2a72d59>  (input #2)
    0x7fff5fbfd798: [top + 112] <- 0x139ed25aea99 ;  0x139ed25aea99 <a TypeObject with map 0x33abe2a767c9>  (input #3)
    0x7fff5fbfd790: [top + 104] <- 0x30bcea404421 ;  0x30bcea404421 <false>  (input #4)
    0x7fff5fbfd788: [top + 96] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfd780: [top + 88] <- 0x2c21d2207e55 ;  caller's pc
    0x7fff5fbfd778: [top + 80] <- 0x7fff5fbfd7c8 ;  caller's fp
    0x7fff5fbfd770: [top + 72] <- 0x133f510b98a9 ;  context    0x133f510b98a9 <FixedArray[40]>  (input #6)
    0x7fff5fbfd768: [top + 64] <- 0x133f510b9b19 ;  function    0x133f510b9b19 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)>  (input #0)
    0x7fff5fbfd760: [top + 56] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfd758: [top + 48] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfd750: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
    0x7fff5fbfd748: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #10)
    0x7fff5fbfd740: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #11)
    0x7fff5fbfd738: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #12)
    0x7fff5fbfd730: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #13)
    0x7fff5fbfd728: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #14)
[deoptimizing (eager): end 0x133f510b9b19 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)> @7 => node=107, pc=0x2c21d26287c4, caller sp=0x7fff5fbfd7b0, state=NO_REGISTERS, took 0.083 ms]
[deoptimizer unlinked: isRelatedTo / 133f510b9b19]
[deoptimizer unlinked: isRelatedTo / 133f510aa919]
[deoptimizer unlinked: isRelatedTo / 133f510a9401]
[deoptimizer unlinked: isRelatedTo / 133f51087039]
[deoptimizer unlinked: isRelatedTo / 133f51069a81]
[deoptimizing (DEOPT eager): begin 0x1030c9d448d9 <JS Function isSimpleTypeRelatedTo (SharedFunctionInfo 0x2e2f693f7981)> (opt #432) @6, FP to SP delta: 32, caller sp: 0x7fff5fbfd4f8]
            ;;; deoptimize at 0_295: wrong map
  reading input frame isSimpleTypeRelatedTo => node=74, args=5, height=1; inputs:
      0: 0x1030c9d448d9 ; [fp - 16] 0x1030c9d448d9 <JS Function isSimpleTypeRelatedTo (SharedFunctionInfo 0x2e2f693f7981)>
      1: 0x1f9f6c0532e1 ; [fp + 48] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x101bfd3302c9 ; [fp + 40] 0x101bfd3302c9 <a TypeObject with map 0x33abe2a6d979>
      3: 0x139ed25aea99 ; rax 0x139ed25aea99 <a TypeObject with map 0x33abe2a767c9>
      4: 0x130b7e1b5f71 ; [fp + 24] 0x130b7e1b5f71 <an Object with map 0x33abe2a3d1a1>
      5: 0x30bcea404311 ; [fp + 16] 0x30bcea404311 <undefined>
      6: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
  translating frame isSimpleTypeRelatedTo => node=74, height=0
    0x7fff5fbfd4f0: [top + 64] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd4e8: [top + 56] <- 0x101bfd3302c9 ;  0x101bfd3302c9 <a TypeObject with map 0x33abe2a6d979>  (input #2)
    0x7fff5fbfd4e0: [top + 48] <- 0x139ed25aea99 ;  0x139ed25aea99 <a TypeObject with map 0x33abe2a767c9>  (input #3)
    0x7fff5fbfd4d8: [top + 40] <- 0x130b7e1b5f71 ;  0x130b7e1b5f71 <an Object with map 0x33abe2a3d1a1>  (input #4)
    0x7fff5fbfd4d0: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfd4c8: [top + 24] <- 0x2c21d2628965 ;  caller's pc
    0x7fff5fbfd4c0: [top + 16] <- 0x7fff5fbfd550 ;  caller's fp
    0x7fff5fbfd4b8: [top + 8] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #6)
    0x7fff5fbfd4b0: [top + 0] <- 0x1030c9d448d9 ;  function    0x1030c9d448d9 <JS Function isSimpleTypeRelatedTo (SharedFunctionInfo 0x2e2f693f7981)>  (input #0)
[deoptimizing (eager): end 0x1030c9d448d9 <JS Function isSimpleTypeRelatedTo (SharedFunctionInfo 0x2e2f693f7981)> @6 => node=74, pc=0x2c21d262a661, caller sp=0x7fff5fbfd4f8, state=NO_REGISTERS, took 0.060 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isRelatedTo) id{448,0} ---
(source, target, reportErrors, headMessage) {
                var result;
                if (source.flags & 96 /* StringOrNumberLiteral */ && source.flags & 1048576 /* FreshLiteral */) {
                    source = source.regularType;
                }
                if (target.flags & 96 /* StringOrNumberLiteral */ && target.flags & 1048576 /* FreshLiteral */) {
                    target = target.regularType;
                }
                // both types are the same - covers 'they are the same primitive type or both are Any' or the same type parameter cases
                if (source === target)
                    return -1 /* True */;
                if (relation === identityRelation) {
                    return isIdenticalTo(source, target);
                }
                if (isSimpleTypeRelatedTo(source, target, relation, reportErrors ? reportError : undefined))
                    return -1 /* True */;
                if (getObjectFlags(source) & 128 /* ObjectLiteral */ && source.flags & 1048576 /* FreshLiteral */) {
                    if (hasExcessProperties(source, target, reportErrors)) {
                        if (reportErrors) {
                            reportRelationError(headMessage, source, target);
                        }
                        return 0 /* False */;
                    }
                    // Above we check for excess properties with respect to the entire target type. When union
                    // and intersection types are further deconstructed on the target side, we don't want to
                    // make the check again (as it might fail for a partial target type). Therefore we obtain
                    // the regular source type and proceed with that.
                    if (isUnionOrIntersectionTypeWithoutNullableConstituents(target)) {
                        source = getRegularTypeOfObjectLiteral(source);
                    }
                }
                var saveErrorInfo = errorInfo;
                // Note that these checks are specifically ordered to produce correct results. In particular,
                // we need to deconstruct unions before intersections (because unions are always at the top),
                // and we need to handle "each" relations before "some" relations for the same kind of type.
                if (source.flags & 65536 /* Union */) {
                    if (relation === comparableRelation) {
                        result = someTypeRelatedToType(source, target, reportErrors && !(source.flags & 8190 /* Primitive */));
                    }
                    else {
                        result = eachTypeRelatedToType(source, target, reportErrors && !(source.flags & 8190 /* Primitive */));
                    }
                    if (result) {
                        return result;
                    }
                }
                else if (target.flags & 65536 /* Union */) {
                    if (result = typeRelatedToSomeType(source, target, reportErrors && !(source.flags & 8190 /* Primitive */) && !(target.flags & 8190 /* Primitive */))) {
                        return result;
                    }
                }
                else if (target.flags & 131072 /* Intersection */) {
                    if (result = typeRelatedToEachType(source, target, reportErrors)) {
                        return result;
                    }
                }
                else if (source.flags & 131072 /* Intersection */) {
                    // Check to see if any constituents of the intersection are immediately related to the target.
                    //
                    // Don't report errors though. Checking whether a constituent is related to the source is not actually
                    // useful and leads to some confusing error messages. Instead it is better to let the below checks
                    // take care of this, or to not elaborate at all. For instance,
                    //
                    //    - For an object type (such as 'C = A & B'), users are usually more interested in structural errors.
                    //
                    //    - For a union type (such as '(A | B) = (C & D)'), it's better to hold onto the whole intersection
                    //          than to report that 'D' is not assignable to 'A' or 'B'.
                    //
                    //    - For a primitive type or type parameter (such as 'number = A & B') there is no point in
                    //          breaking the intersection apart.
                    if (result = someTypeRelatedToType(source, target, /*reportErrors*/ false)) {
                        return result;
                    }
                }
                else if (target.flags & 16384 /* TypeParameter */) {
                    // A source type { [P in keyof T]: X } is related to a target type T if X is related to T[P].
                    if (getObjectFlags(source) & 32 /* Mapped */ && getConstraintTypeFromMappedType(source) === getIndexType(target)) {
                        if (!source.declaration.questionToken) {
                            var templateType = getTemplateTypeFromMappedType(source);
                            var indexedAccessType = getIndexedAccessType(target, getTypeParameterFromMappedType(source));
                            if (result = isRelatedTo(templateType, indexedAccessType, reportErrors)) {
                                return result;
                            }
                        }
                    }
                    else {
                        // Given a type parameter K with a constraint keyof T, a type S is
                        // assignable to K if S is assignable to keyof T.
                        var constraint = getConstraintOfTypeParameter(target);
                        if (constraint && constraint.flags & 262144 /* Index */) {
                            if (result = isRelatedTo(source, constraint, reportErrors)) {
                                return result;
                            }
                        }
                    }
                }
                else if (target.flags & 262144 /* Index */) {
                    // A keyof S is related to a keyof T if T is related to S.
                    if (source.flags & 262144 /* Index */) {
                        if (result = isRelatedTo(target.type, source.type, /*reportErrors*/ false)) {
                            return result;
                        }
                    }
                    // Given a type variable T with a constraint C, a type S is assignable to
                    // keyof T if S is assignable to keyof C.
                    if (target.type.flags & 540672 /* TypeVariable */) {
                        var constraint = getConstraintOfTypeVariable(target.type);
                        if (constraint) {
                            if (result = isRelatedTo(source, getIndexType(constraint), reportErrors)) {
                                return result;
                            }
                        }
                    }
                }
                else if (target.flags & 524288 /* IndexedAccess */) {
                    // if we have indexed access types with identical index types, see if relationship holds for
                    // the two object types.
                    if (source.flags & 524288 /* IndexedAccess */ && source.indexType === target.indexType) {
                        if (result = isRelatedTo(source.objectType, target.objectType, reportErrors)) {
                            return result;
                        }
                    }
                    // A type S is related to a type T[K] if S is related to A[K], where K is string-like and
                    // A is the apparent type of S.
                    if (target.constraint) {
                        if (result = isRelatedTo(source, target.constraint, reportErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                }
                if (source.flags & 16384 /* TypeParameter */) {
                    // A source type T is related to a target type { [P in keyof T]: X } if T[P] is related to X.
                    if (getObjectFlags(target) & 32 /* Mapped */ && getConstraintTypeFromMappedType(target) === getIndexType(source)) {
                        var indexedAccessType = getIndexedAccessType(source, getTypeParameterFromMappedType(target));
                        var templateType = getTemplateTypeFromMappedType(target);
                        if (result = isRelatedTo(indexedAccessType, templateType, reportErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                    else {
                        var constraint = getConstraintOfTypeParameter(source);
                        if (!constraint || constraint.flags & 1 /* Any */) {
                            constraint = emptyObjectType;
                        }
                        // The constraint may need to be further instantiated with its 'this' type.
                        constraint = getTypeWithThisArgument(constraint, source);
                        // Report constraint errors only if the constraint is not the empty object type
                        var reportConstraintErrors = reportErrors && constraint !== emptyObjectType;
                        if (result = isRelatedTo(constraint, target, reportConstraintErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                }
                else if (source.flags & 524288 /* IndexedAccess */) {
                    // A type S[K] is related to a type T if A[K] is related to T, where K is string-like and
                    // A is the apparent type of S.
                    if (source.constraint) {
                        if (result = isRelatedTo(source.constraint, target, reportErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                }
                else {
                    if (getObjectFlags(source) & 4 /* Reference */ && getObjectFlags(target) & 4 /* Reference */ && source.target === target.target) {
                        // We have type references to same target type, see if relationship holds for all type arguments
                        if (result = typeArgumentsRelatedTo(source, target, reportErrors)) {
                            return result;
                        }
                    }
                    // Even if relationship doesn't hold for unions, intersections, or generic type references,
                    // it may hold in a structural comparison.
                    var apparentSource = getApparentType(source);
                    // In a check of the form X = A & B, we will have previously checked if A relates to X or B relates
                    // to X. Failing both of those we want to check if the aggregation of A and B's members structurally
                    // relates to X. Thus, we include intersection types on the source side here.
                    if (apparentSource.flags & (32768 /* Object */ | 131072 /* Intersection */) && target.flags & 32768 /* Object */) {
                        // Report structural errors only if we haven't reported any errors yet
                        var reportStructuralErrors = reportErrors && errorInfo === saveErrorInfo && !(source.flags & 8190 /* Primitive */);
                        if (result = objectTypeRelatedTo(apparentSource, source, target, reportStructuralErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                }
                if (reportErrors) {
                    if (source.flags & 32768 /* Object */ && target.flags & 8190 /* Primitive */) {
                        tryElaborateErrorsForPrimitivesAndObjects(source, target);
                    }
                    else if (source.symbol && source.flags & 32768 /* Object */ && globalObjectType === source) {
                        reportError(ts.Diagnostics.The_Object_type_is_assignable_to_very_few_other_types_Did_you_mean_to_use_the_any_type_instead);
                    }
                    reportRelationError(headMessage, source, target);
                }
                return 0 /* False */;
            }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{448,1} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{448,1} AS 1 AT <0:953>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{448,2} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{448,2} AS 2 AT <0:4927>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getConstraintOfTypeVariable) id{448,3} ---
(type) {
            return type.flags & 16384 /* TypeParameter */ ? getConstraintOfTypeParameter(type) :
                type.flags & 524288 /* IndexedAccess */ ? type.constraint :
                    undefined;
        }
--- END ---
INLINE (getConstraintOfTypeVariable) id{448,3} AS 3 AT <0:6792>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{448,4} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{448,4} AS 4 AT <0:8322>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeWithThisArgument) id{448,5} ---
(type, thisArgument) {
            if (getObjectFlags(type) & 4 /* Reference */) {
                return createTypeReference(type.target, ts.concatenate(type.typeArguments, [thisArgument || type.target.thisType]));
            }
            return type;
        }
--- END ---
INLINE (getTypeWithThisArgument) id{448,5} AS 5 AT <0:9283>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{448,6} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{448,6} AS 6 AT <5:39>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createTypeReference) id{448,7} ---
(target, typeArguments) {
            var id = getTypeListId(typeArguments);
            var type = target.instantiations[id];
            if (!type) {
                type = target.instantiations[id] = createObjectType(4 /* Reference */, target.symbol);
                type.flags |= typeArguments ? getPropagatingFlagsOfTypes(typeArguments, /*excludeKinds*/ 0) : 0;
                type.target = target;
                type.typeArguments = typeArguments;
            }
            return type;
        }
--- END ---
INLINE (createTypeReference) id{448,7} AS 7 AT <5:106>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createObjectType) id{448,8} ---
(objectFlags, symbol) {
            var type = createType(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol = symbol;
            return type;
        }
--- END ---
INLINE (createObjectType) id{448,8} AS 8 AT <7:203>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{448,9} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{448,9} AS 9 AT <8:47>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{448,10} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{448,10} AS 10 AT <9:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropagatingFlagsOfTypes) id{448,11} ---
(types, excludeKinds) {
            var result = 0;
            for (var _i = 0, types_3 = types; _i < types_3.length; _i++) {
                var type = types_3[_i];
                if (!(type.flags & excludeKinds)) {
                    result |= type.flags;
                }
            }
            return result & 14680064 /* PropagatingFlags */;
        }
--- END ---
INLINE (getPropagatingFlagsOfTypes) id{448,11} AS 11 AT <7:301>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{448,12} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{448,12} AS 12 AT <0:10374>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{448,13} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{448,13} AS 13 AT <0:10420>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getApparentType) id{448,14} ---
(type) {
            var t = type.flags & 540672 /* TypeVariable */ ? getApparentTypeOfTypeVariable(type) : type;
            return t.flags & 262178 /* StringLike */ ? globalStringType :
                t.flags & 340 /* NumberLike */ ? globalNumberType :
                    t.flags & 136 /* BooleanLike */ ? globalBooleanType :
                        t.flags & 512 /* ESSymbol */ ? getGlobalESSymbolType() :
                            t;
        }
--- END ---
INLINE (getApparentType) id{448,14} AS 14 AT <0:11022>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isSimpleTypeRelatedTo) id{449,0} ---
(source, target, relation, errorReporter) {
            if (target.flags & 8192 /* Never */)
                return false;
            if (target.flags & 1 /* Any */ || source.flags & 8192 /* Never */)
                return true;
            if (source.flags & 262178 /* StringLike */ && target.flags & 2 /* String */)
                return true;
            if (source.flags & 340 /* NumberLike */ && target.flags & 4 /* Number */)
                return true;
            if (source.flags & 136 /* BooleanLike */ && target.flags & 8 /* Boolean */)
                return true;
            if (source.flags & 256 /* EnumLiteral */ && target.flags & 16 /* Enum */ && source.baseType === target)
                return true;
            if (source.flags & 16 /* Enum */ && target.flags & 16 /* Enum */ && isEnumTypeRelatedTo(source, target, errorReporter))
                return true;
            if (source.flags & 2048 /* Undefined */ && (!strictNullChecks || target.flags & (2048 /* Undefined */ | 1024 /* Void */)))
                return true;
            if (source.flags & 4096 /* Null */ && (!strictNullChecks || target.flags & 4096 /* Null */))
                return true;
            if (relation === assignableRelation || relation === comparableRelation) {
                if (source.flags & 1 /* Any */)
                    return true;
                if ((source.flags & 4 /* Number */ | source.flags & 64 /* NumberLiteral */) && target.flags & 272 /* EnumLike */)
                    return true;
                if (source.flags & 256 /* EnumLiteral */ &&
                    target.flags & 256 /* EnumLiteral */ &&
                    source.text === target.text &&
                    isEnumTypeRelatedTo(source.baseType, target.baseType, errorReporter)) {
                    return true;
                }
                if (source.flags & 256 /* EnumLiteral */ &&
                    target.flags & 16 /* Enum */ &&
                    isEnumTypeRelatedTo(target, source.baseType, errorReporter)) {
                    return true;
                }
            }
            return false;
        }
--- END ---
[deoptimizing (DEOPT lazy): begin 0x133f510b9b19 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)> (opt #444) @57, FP to SP delta: 304, caller sp: 0x7fff5fbfd9c8]
  reading input frame isRelatedTo => node=573, args=5, height=10; inputs:
      0: 0x133f510b9b19 ; [fp - 16] 0x133f510b9b19 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)>
      1: 0x1f9f6c0532e1 ; [fp + 48] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x133f510abac9 ; [fp - 56] 0x133f510abac9 <a TypeObject with map 0x33abe2a72d59>
      3: 0x133f510b45e9 ; [fp - 40] 0x133f510b45e9 <a TypeObject with map 0x33abe2a6d0e1>
      4: 0x30bcea404421 ; [fp + 24] 0x30bcea404421 <false>
      5: 0x30bcea404311 ; [fp + 16] 0x30bcea404311 <undefined>
      6: 0x133f510b98a9 ; [fp - 24] 0x133f510b98a9 <FixedArray[40]>
      7: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; [fp - 64] 0x30bcea404311 <undefined>
      9: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     10: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     11: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     12: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     13: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     14: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     15: 0x00000000 ; rax 0
  translating frame isRelatedTo => node=573, height=72
    0x7fff5fbfd9c0: [top + 136] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd9b8: [top + 128] <- 0x133f510abac9 ;  0x133f510abac9 <a TypeObject with map 0x33abe2a72d59>  (input #2)
    0x7fff5fbfd9b0: [top + 120] <- 0x133f510b45e9 ;  0x133f510b45e9 <a TypeObject with map 0x33abe2a6d0e1>  (input #3)
    0x7fff5fbfd9a8: [top + 112] <- 0x30bcea404421 ;  0x30bcea404421 <false>  (input #4)
    0x7fff5fbfd9a0: [top + 104] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfd998: [top + 96] <- 0x2c21d262826d ;  caller's pc
    0x7fff5fbfd990: [top + 88] <- 0x7fff5fbfd9e8 ;  caller's fp
    0x7fff5fbfd988: [top + 80] <- 0x133f510b98a9 ;  context    0x133f510b98a9 <FixedArray[40]>  (input #6)
    0x7fff5fbfd980: [top + 72] <- 0x133f510b9b19 ;  function    0x133f510b9b19 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)>  (input #0)
    0x7fff5fbfd978: [top + 64] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfd970: [top + 56] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfd968: [top + 48] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
    0x7fff5fbfd960: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #10)
    0x7fff5fbfd958: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #11)
    0x7fff5fbfd950: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #12)
    0x7fff5fbfd948: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #13)
    0x7fff5fbfd940: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #14)
    0x7fff5fbfd938: [top + 0] <- 0x00000000 ;  0  (input #15)
[deoptimizing (lazy): end 0x133f510b9b19 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)> @57 => node=573, pc=0x2c21d2628e5a, caller sp=0x7fff5fbfd9c8, state=TOS_REGISTER, took 0.081 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNamedMembers) id{450,0} ---
(members) {
            var result;
            for (var id in members) {
                if (!isReservedMemberName(id)) {
                    if (!result)
                        result = [];
                    var symbol = members[id];
                    if (symbolIsValue(symbol)) {
                        result.push(symbol);
                    }
                }
            }
            return result || emptyArray;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isReservedMemberName) id{450,1} ---
(name) {
            return name.charCodeAt(0) === 95 /* _ */ &&
                name.charCodeAt(1) === 95 /* _ */ &&
                name.charCodeAt(2) !== 95 /* _ */ &&
                name.charCodeAt(2) !== 64 /* at */;
        }
--- END ---
INLINE (isReservedMemberName) id{450,1} AS 1 AT <0:95>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:hasQuestionToken) id{451,0} ---
(node) {
        if (node) {
            switch (node.kind) {
                case 144 /* Parameter */:
                case 149 /* MethodDeclaration */:
                case 148 /* MethodSignature */:
                case 258 /* ShorthandPropertyAssignment */:
                case 257 /* PropertyAssignment */:
                case 147 /* PropertyDeclaration */:
                case 146 /* PropertySignature */:
                    return node.questionToken !== undefined;
            }
        }
        return false;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkTypeAssignableTo) id{452,0} ---
(source, target, errorNode, headMessage, containingMessageChain) {
            return checkTypeRelatedTo(source, target, assignableRelation, errorNode, headMessage, containingMessageChain);
        }
--- END ---
[deoptimizing (DEOPT eager): begin 0x133f510f2d19 <JS Function (SharedFunctionInfo 0x371f85c14051)> (opt #428) @2, FP to SP delta: 24, caller sp: 0x7fff5fbfde08]
            ;;; deoptimize at 0_12: wrong map
  reading input frame  => node=4, args=2, height=1; inputs:
      0: 0x133f510f2d19 ; [fp - 16] 0x133f510f2d19 <JS Function (SharedFunctionInfo 0x371f85c14051)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x17ddd84301a9 ; rdi 0x17ddd84301a9 <a SymbolObject with map 0x33abe2a73229>
      3: 0x133f510f2b69 ; rbx 0x133f510f2b69 <FixedArray[6]>
  translating frame  => node=4, height=0
    0x7fff5fbfde00: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfddf8: [top + 32] <- 0x17ddd84301a9 ;  0x17ddd84301a9 <a SymbolObject with map 0x33abe2a73229>  (input #2)
    0x7fff5fbfddf0: [top + 24] <- 0x2c21d2207e55 ;  caller's pc
    0x7fff5fbfdde8: [top + 16] <- 0x7fff5fbfde20 ;  caller's fp
    0x7fff5fbfdde0: [top + 8] <- 0x133f510f2b69 ;  context    0x133f510f2b69 <FixedArray[6]>  (input #3)
    0x7fff5fbfddd8: [top + 0] <- 0x133f510f2d19 ;  function    0x133f510f2d19 <JS Function (SharedFunctionInfo 0x371f85c14051)>  (input #0)
[deoptimizing (eager): end 0x133f510f2d19 <JS Function (SharedFunctionInfo 0x371f85c14051)> @2 => node=4, pc=0x2c21d26bdd06, caller sp=0x7fff5fbfde08, state=NO_REGISTERS, took 0.047 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isGenericMappedType) id{453,0} ---
(type) {
            if (getObjectFlags(type) & 32 /* Mapped */) {
                var constraintType = getConstraintTypeFromMappedType(type);
                return maybeTypeOfKind(constraintType, 540672 /* TypeVariable */ | 262144 /* Index */);
            }
            return false;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{453,1} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{453,1} AS 1 AT <0:25>
[deoptimizing (DEOPT eager): begin 0x130b7e1b6811 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)> (opt #424) @19, FP to SP delta: 320, caller sp: 0x7fff5fbfd818]
            ;;; deoptimize at 0_723: wrong map
  reading input frame resolveName => node=188, args=6, height=17; inputs:
      0: 0x130b7e1b6811 ; [fp - 16] 0x130b7e1b6811 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)>
      1: 0x1f9f6c0532e1 ; [fp + 56] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x9ebbbf631d1 ; rbx 0x9ebbbf631d1 <a NodeObject with map 0x33abe2a70159>
      3: 0x30bcea445541 ; [fp + 40] 0x30bcea445541 <String[1]: K>
      4: 0xc19e800000000 ; [fp + 32] 793064
      5: 0xd6230ded3a9 ; [fp + 24] 0xd6230ded3a9 <an Object with map 0x33abe2a3df61>
      6: 0x2be622fc5939 ; [fp + 16] 0x2be622fc5939 <an IdentifierObject with map 0x33abe2a6fb81>
      7: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      8: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
      9: 0x17ddd84a4349 ; [fp - 144] 0x17ddd84a4349 <a SymbolObject with map 0x33abe2a72ca9>
     10: 0x9a022288761 ; rax 0x9a022288761 <a NodeObject with map 0x33abe2a6fd39>
     11: 0x30bcea404311 ; [fp - 56] 0x30bcea404311 <undefined>
     12: 0x2be622fc5939 ; [fp + 48] 0x2be622fc5939 <an IdentifierObject with map 0x33abe2a6fb81>
     13: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     14: 0x30bcea404421 ; [fp - 48] 0x30bcea404421 <false>
     15: 0x30bcea4043b1 ; (literal 11) 0x30bcea4043b1 <true>
     16: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     17: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     18: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     19: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     20: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     21: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     22: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     23: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
  translating frame resolveName => node=188, height=128
    0x7fff5fbfd810: [top + 200] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd808: [top + 192] <- 0x9ebbbf631d1 ;  0x9ebbbf631d1 <a NodeObject with map 0x33abe2a70159>  (input #2)
    0x7fff5fbfd800: [top + 184] <- 0x30bcea445541 ;  0x30bcea445541 <String[1]: K>  (input #3)
    0x7fff5fbfd7f8: [top + 176] <- 0xc19e800000000 ;  793064  (input #4)
    0x7fff5fbfd7f0: [top + 168] <- 0xd6230ded3a9 ;  0xd6230ded3a9 <an Object with map 0x33abe2a3df61>  (input #5)
    0x7fff5fbfd7e8: [top + 160] <- 0x2be622fc5939 ;  0x2be622fc5939 <an IdentifierObject with map 0x33abe2a6fb81>  (input #6)
    0x7fff5fbfd7e0: [top + 152] <- 0x2c21d26b0f30 ;  caller's pc
    0x7fff5fbfd7d8: [top + 144] <- 0x7fff5fbfd898 ;  caller's fp
    0x7fff5fbfd7d0: [top + 136] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #7)
    0x7fff5fbfd7c8: [top + 128] <- 0x130b7e1b6811 ;  function    0x130b7e1b6811 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)>  (input #0)
    0x7fff5fbfd7c0: [top + 120] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfd7b8: [top + 112] <- 0x17ddd84a4349 ;  0x17ddd84a4349 <a SymbolObject with map 0x33abe2a72ca9>  (input #9)
    0x7fff5fbfd7b0: [top + 104] <- 0x9a022288761 ;  0x9a022288761 <a NodeObject with map 0x33abe2a6fd39>  (input #10)
    0x7fff5fbfd7a8: [top + 96] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #11)
    0x7fff5fbfd7a0: [top + 88] <- 0x2be622fc5939 ;  0x2be622fc5939 <an IdentifierObject with map 0x33abe2a6fb81>  (input #12)
    0x7fff5fbfd798: [top + 80] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #13)
    0x7fff5fbfd790: [top + 72] <- 0x30bcea404421 ;  0x30bcea404421 <false>  (input #14)
    0x7fff5fbfd788: [top + 64] <- 0x30bcea4043b1 ;  0x30bcea4043b1 <true>  (input #15)
    0x7fff5fbfd780: [top + 56] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #16)
    0x7fff5fbfd778: [top + 48] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #17)
    0x7fff5fbfd770: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #18)
    0x7fff5fbfd768: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #19)
    0x7fff5fbfd760: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #20)
    0x7fff5fbfd758: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #21)
    0x7fff5fbfd750: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #22)
    0x7fff5fbfd748: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #23)
[deoptimizing (eager): end 0x130b7e1b6811 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)> @19 => node=188, pc=0x2c21d25e4425, caller sp=0x7fff5fbfd818, state=NO_REGISTERS, took 0.152 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveName) id{454,0} ---
(location, name, meaning, nameNotFoundMessage, nameArg) {
            var result;
            var lastLocation;
            var propertyWithInvalidInitializer;
            var errorLocation = location;
            var grandparent;
            var isInExternalModule = false;
            loop: while (location) {
                // Locals of a source file are not in scope (because they get merged into the global symbol table)
                if (location.locals && !isGlobalSourceFile(location)) {
                    if (result = getSymbol(location.locals, name, meaning)) {
                        var useResult = true;
                        if (ts.isFunctionLike(location) && lastLocation && lastLocation !== location.body) {
                            // symbol lookup restrictions for function-like declarations
                            // - Type parameters of a function are in scope in the entire function declaration, including the parameter
                            //   list and return type. However, local types are only in scope in the function body.
                            // - parameters are only in the scope of function body
                            // This restriction does not apply to JSDoc comment types because they are parented
                            // at a higher level than type parameters would normally be
                            if (meaning & result.flags & 793064 /* Type */ && lastLocation.kind !== 278 /* JSDocComment */) {
                                useResult = result.flags & 262144 /* TypeParameter */
                                    ? lastLocation === location.type ||
                                        lastLocation.kind === 144 /* Parameter */ ||
                                        lastLocation.kind === 143 /* TypeParameter */
                                    : false;
                            }
                            if (meaning & 107455 /* Value */ && result.flags & 1 /* FunctionScopedVariable */) {
                                // parameters are visible only inside function body, parameter list and return type
                                // technically for parameter list case here we might mix parameters and variables declared in function,
                                // however it is detected separately when checking initializers of parameters
                                // to make sure that they reference no variables declared after them.
                                useResult =
                                    lastLocation.kind === 144 /* Parameter */ ||
                                        (lastLocation === location.type &&
                                            result.valueDeclaration.kind === 144 /* Parameter */);
                            }
                        }
                        if (useResult) {
                            break loop;
                        }
                        else {
                            result = undefined;
                        }
                    }
                }
                switch (location.kind) {
                    case 261 /* SourceFile */:
                        if (!ts.isExternalOrCommonJsModule(location))
                            break;
                        isInExternalModule = true;
                    case 230 /* ModuleDeclaration */:
                        var moduleExports = getSymbolOfNode(location).exports;
                        if (location.kind === 261 /* SourceFile */ || ts.isAmbientModule(location)) {
                            // It's an external module. First see if the module has an export default and if the local
                            // name of that export default matches.
                            if (result = moduleExports["default"]) {
                                var localSymbol = ts.getLocalSymbolForExportDefault(result);
                                if (localSymbol && (result.flags & meaning) && localSymbol.name === name) {
                                    break loop;
                                }
                                result = undefined;
                            }
                            // Because of module/namespace merging, a module's exports are in scope,
                            // yet we never want to treat an export specifier as putting a member in scope.
                            // Therefore, if the name we find is purely an export specifier, it is not actually considered in scope.
                            // Two things to note about this:
                            //     1. We have to check this without calling getSymbol. The problem with calling getSymbol
                            //        on an export specifier is that it might find the export specifier itself, and try to
                            //        resolve it as an alias. This will cause the checker to consider the export specifier
                            //        a circular alias reference when it might not be.
                            //     2. We check === SymbolFlags.Alias in order to check that the symbol is *purely*
                            //        an alias. If we used &, we'd be throwing out symbols that have non alias aspects,
                            //        which is not the desired behavior.
                            if (moduleExports[name] &&
                                moduleExports[name].flags === 8388608 /* Alias */ &&
                                ts.getDeclarationOfKind(moduleExports[name], 243 /* ExportSpecifier */)) {
                                break;
                            }
                        }
                        if (result = getSymbol(moduleExports, name, meaning & 8914931 /* ModuleMember */)) {
                            break loop;
                        }
                        break;
                    case 229 /* EnumDeclaration */:
                        if (result = getSymbol(getSymbolOfNode(location).exports, name, meaning & 8 /* EnumMember */)) {
                            break loop;
                        }
                        break;
                    case 147 /* PropertyDeclaration */:
                    case 146 /* PropertySignature */:
                        // TypeScript 1.0 spec (April 2014): 8.4.1
                        // Initializer expressions for instance member variables are evaluated in the scope
                        // of the class constructor body but are not permitted to reference parameters or
                        // local variables of the constructor. This effectively means that entities from outer scopes
                        // by the same name as a constructor parameter or local variable are inaccessible
                        // in initializer expressions for instance member variables.
                        if (ts.isClassLike(location.parent) && !(ts.getModifierFlags(location) & 32 /* Static */)) {
                            var ctor = findConstructorDeclaration(location.parent);
                            if (ctor && ctor.locals) {
                                if (getSymbol(ctor.locals, name, meaning & 107455 /* Value */)) {
                                    // Remember the property node, it will be used later to report appropriate error
                                    propertyWithInvalidInitializer = location;
                                }
                            }
                        }
                        break;
                    case 226 /* ClassDeclaration */:
                    case 197 /* ClassExpression */:
                    case 227 /* InterfaceDeclaration */:
                        if (result = getSymbol(getSymbolOfNode(location).members, name, meaning & 793064 /* Type */)) {
                            if (lastLocation && ts.getModifierFlags(lastLocation) & 32 /* Static */) {
                                // TypeScript 1.0 spec (April 2014): 3.4.1
                                // The scope of a type parameter extends over the entire declaration with which the type
                                // parameter list is associated, with the exception of static member declarations in classes.
                                error(errorLocation, ts.Diagnostics.Static_members_cannot_reference_class_type_parameters);
                                return undefined;
                            }
                            break loop;
                        }
                        if (location.kind === 197 /* ClassExpression */ && meaning & 32 /* Class */) {
                            var className = location.name;
                            if (className && name === className.text) {
                                result = location.symbol;
                                break loop;
                            }
                        }
                        break;
                    // It is not legal to reference a class's own type parameters from a computed property name that
                    // belongs to the class. For example:
                    //
                    //   function foo<T>() { return '' }
                    //   class C<T> { // <-- Class's own type parameter T
                    //       [foo<T>()]() { } // <-- Reference to T from class's own computed property
                    //   }
                    //
                    case 142 /* ComputedPropertyName */:
                        grandparent = location.parent.parent;
                        if (ts.isClassLike(grandparent) || grandparent.kind === 227 /* InterfaceDeclaration */) {
                            // A reference to this grandparent's type parameters would be an error
                            if (result = getSymbol(getSymbolOfNode(grandparent).members, name, meaning & 793064 /* Type */)) {
                                error(errorLocation, ts.Diagnostics.A_computed_property_name_cannot_reference_a_type_parameter_from_its_containing_type);
                                return undefined;
                            }
                        }
                        break;
                    case 149 /* MethodDeclaration */:
                    case 148 /* MethodSignature */:
                    case 150 /* Constructor */:
                    case 151 /* GetAccessor */:
                    case 152 /* SetAccessor */:
                    case 225 /* FunctionDeclaration */:
                    case 185 /* ArrowFunction */:
                        if (meaning & 3 /* Variable */ && name === "arguments") {
                            result = argumentsSymbol;
                            break loop;
                        }
                        break;
                    case 184 /* FunctionExpression */:
                        if (meaning & 3 /* Variable */ && name === "arguments") {
                            result = argumentsSymbol;
                            break loop;
                        }
                        if (meaning & 16 /* Function */) {
                            var functionName = location.name;
                            if (functionName && name === functionName.text) {
                                result = location.symbol;
                                break loop;
                            }
                        }
                        break;
                    case 145 /* Decorator */:
                        // Decorators are resolved at the class declaration. Resolving at the parameter
                        // or member would result in looking up locals in the method.
                        //
                        //   function y() {}
                        //   class C {
                        //       method(@y x, y) {} // <-- decorator y should be resolved at the class declaration, not the parameter.
                        //   }
                        //
                        if (location.parent && location.parent.kind === 144 /* Parameter */) {
                            location = location.parent;
                        }
                        //
                        //   function y() {}
                        //   class C {
                        //       @y method(x, y) {} // <-- decorator y should be resolved at the class declaration, not the method.
                        //   }
                        //
                        if (location.parent && ts.isClassElement(location.parent)) {
                            location = location.parent;
                        }
                        break;
                }
                lastLocation = location;
                location = location.parent;
            }
            if (result && nameNotFoundMessage && noUnusedIdentifiers) {
                result.isReferenced = true;
            }
            if (!result) {
                result = getSymbol(globals, name, meaning);
            }
            if (!result) {
                if (nameNotFoundMessage) {
                    if (!errorLocation ||
                        !checkAndReportErrorForMissingPrefix(errorLocation, name, nameArg) &&
                            !checkAndReportErrorForExtendingInterface(errorLocation) &&
                            !checkAndReportErrorForUsingTypeAsNamespace(errorLocation, name, meaning) &&
                            !checkAndReportErrorForUsingTypeAsValue(errorLocation, name, meaning)) {
                        error(errorLocation, nameNotFoundMessage, typeof nameArg === "string" ? nameArg : ts.declarationNameToString(nameArg));
                    }
                }
                return undefined;
            }
            // Perform extra checks only if error reporting was requested
            if (nameNotFoundMessage) {
                if (propertyWithInvalidInitializer) {
                    // We have a match, but the reference occurred within a property initializer and the identifier also binds
                    // to a local variable in the constructor where the code will be emitted.
                    var propertyName = propertyWithInvalidInitializer.name;
                    error(errorLocation, ts.Diagnostics.Initializer_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor, ts.declarationNameToString(propertyName), typeof nameArg === "string" ? nameArg : ts.declarationNameToString(nameArg));
                    return undefined;
                }
                // Only check for block-scoped variable if we are looking for the
                // name with variable meaning
                //      For example,
                //          declare module foo {
                //              interface bar {}
                //          }
                //      const foo/*1*/: foo/*2*/.bar;
                // The foo at /*1*/ and /*2*/ will share same symbol with two meaning
                // block - scope variable and namespace module. However, only when we
                // try to resolve name in /*1*/ which is used in variable position,
                // we want to check for block- scoped
                if (meaning & 2 /* BlockScopedVariable */) {
                    var exportOrLocalSymbol = getExportSymbolOfValueSymbolIfExported(result);
                    if (exportOrLocalSymbol.flags & 2 /* BlockScopedVariable */) {
                        checkResolvedBlockScopedVariable(exportOrLocalSymbol, errorLocation);
                    }
                }
                // If we're in an external module, we can't reference value symbols created from UMD export declarations
                if (result && isInExternalModule && (meaning & 107455 /* Value */) === 107455 /* Value */) {
                    var decls = result.declarations;
                    if (decls && decls.length === 1 && decls[0].kind === 233 /* NamespaceExportDeclaration */) {
                        error(errorLocation, ts.Diagnostics._0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead, name);
                    }
                }
            }
            return result;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isGlobalSourceFile) id{454,1} ---
(node) {
            return node.kind === 261 /* SourceFile */ && !ts.isExternalOrCommonJsModule(node);
        }
--- END ---
INLINE (isGlobalSourceFile) id{454,1} AS 1 AT <0:467>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{454,2} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{454,2} AS 2 AT <0:3412>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{454,3} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{454,3} AS 3 AT <2:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{454,4} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{454,4} AS 4 AT <0:7735>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{454,5} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{454,5} AS 5 AT <4:28>
[deoptimizing (DEOPT eager): begin 0x17ddd8404489 <JS Function addTypeToUnion (SharedFunctionInfo 0x2e2f693f37d1)> (opt #447) @30, FP to SP delta: 144, caller sp: 0x7fff5fbfd290]
            ;;; deoptimize at 2_236: wrong map
  reading input frame addTypeToUnion => node=413, args=3, height=5; inputs:
      0: 0x17ddd8404489 ; [fp - 16] 0x17ddd8404489 <JS Function addTypeToUnion (SharedFunctionInfo 0x2e2f693f37d1)>
      1: 0x1f9f6c0532e1 ; [fp + 32] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x376e2da31681 ; rbx 0x376e2da31681 <JS Array[3]>
      3: 0x1030c9d51889 ; [fp + 16] 0x1030c9d51889 <a TypeObject with map 0x33abe2a6cf81>
      4: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      5: 0x200000000 ; [fp - 32] 2
      6: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
      8: 0x17ddd8404631 ; [fp - 64] 0x17ddd8404631 <JS Function binarySearchTypes (SharedFunctionInfo 0x2e2f693f3651)>
  reading input frame binarySearchTypes => node=81, args=3, height=6; inputs:
      0: 0x17ddd8404631 ; (literal 7) 0x17ddd8404631 <JS Function binarySearchTypes (SharedFunctionInfo 0x2e2f693f3651)>
      1: 0x1f9f6c0532e1 ; (literal 8) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x376e2da31681 ; rbx 0x376e2da31681 <JS Array[3]>
      3: 0x1030c9d51889 ; [fp + 16] 0x1030c9d51889 <a TypeObject with map 0x33abe2a6cf81>
      4: 0x130b7e1b3d29 ; (literal 9) 0x130b7e1b3d29 <FixedArray[1022]>
      5: 0 ; r8 
      6: 2 ; rdi 
      7: 0x800000000 ; rax 8
      8: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
      9: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
  translating frame addTypeToUnion => node=413, height=32
    0x7fff5fbfd288: [top + 80] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd280: [top + 72] <- 0x376e2da31681 ;  0x376e2da31681 <JS Array[3]>  (input #2)
    0x7fff5fbfd278: [top + 64] <- 0x1030c9d51889 ;  0x1030c9d51889 <a TypeObject with map 0x33abe2a6cf81>  (input #3)
    0x7fff5fbfd270: [top + 56] <- 0x2c21d253bc77 ;  caller's pc
    0x7fff5fbfd268: [top + 48] <- 0x7fff5fbfd2c0 ;  caller's fp
    0x7fff5fbfd260: [top + 40] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #4)
    0x7fff5fbfd258: [top + 32] <- 0x17ddd8404489 ;  function    0x17ddd8404489 <JS Function addTypeToUnion (SharedFunctionInfo 0x2e2f693f37d1)>  (input #0)
    0x7fff5fbfd250: [top + 24] <- 0x200000000 ;  2  (input #5)
    0x7fff5fbfd248: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfd240: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfd238: [top + 0] <- 0x17ddd8404631 ;  0x17ddd8404631 <JS Function binarySearchTypes (SharedFunctionInfo 0x2e2f693f3651)>  (input #8)
  translating frame binarySearchTypes => node=81, height=40
    0x7fff5fbfd230: [top + 88] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd228: [top + 80] <- 0x376e2da31681 ;  0x376e2da31681 <JS Array[3]>  (input #2)
    0x7fff5fbfd220: [top + 72] <- 0x1030c9d51889 ;  0x1030c9d51889 <a TypeObject with map 0x33abe2a6cf81>  (input #3)
    0x7fff5fbfd218: [top + 64] <- 0x2c21d253c254 ;  caller's pc
    0x7fff5fbfd210: [top + 56] <- 0x7fff5fbfd268 ;  caller's fp
    0x7fff5fbfd208: [top + 48] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #4)
    0x7fff5fbfd200: [top + 40] <- 0x17ddd8404631 ;  function    0x17ddd8404631 <JS Function binarySearchTypes (SharedFunctionInfo 0x2e2f693f3651)>  (input #0)
    0x7fff5fbfd1f8: [top + 32] <- 0x00000000 ;  0  (input #5)
    0x7fff5fbfd1f0: [top + 24] <- 0x200000000 ;  2  (input #6)
    0x7fff5fbfd1e8: [top + 16] <- 0x800000000 ;  8  (input #7)
    0x7fff5fbfd1e0: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfd1d8: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
[deoptimizing (eager): end 0x17ddd8404489 <JS Function addTypeToUnion (SharedFunctionInfo 0x2e2f693f37d1)> @30 => node=81, pc=0x2c21d253c5a7, caller sp=0x7fff5fbfd290, state=NO_REGISTERS, took 0.113 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeOfSymbol) id{455,0} ---
(symbol) {
            if (symbol.flags & 16777216 /* Instantiated */) {
                return getTypeOfInstantiatedSymbol(symbol);
            }
            if (symbol.flags & (3 /* Variable */ | 4 /* Property */)) {
                return getTypeOfVariableOrParameterOrProperty(symbol);
            }
            if (symbol.flags & (16 /* Function */ | 8192 /* Method */ | 32 /* Class */ | 384 /* Enum */ | 512 /* ValueModule */)) {
                return getTypeOfFuncClassEnumModule(symbol);
            }
            if (symbol.flags & 8 /* EnumMember */) {
                return getTypeOfEnumMember(symbol);
            }
            if (symbol.flags & 98304 /* Accessor */) {
                return getTypeOfAccessors(symbol);
            }
            if (symbol.flags & 8388608 /* Alias */) {
                return getTypeOfAlias(symbol);
            }
            return unknownType;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeOfInstantiatedSymbol) id{455,1} ---
(symbol) {
            var links = getSymbolLinks(symbol);
            if (!links.type) {
                if (!pushTypeResolution(symbol, 0 /* Type */)) {
                    return unknownType;
                }
                var type = instantiateType(getTypeOfSymbol(links.target), links.mapper);
                if (!popTypeResolution()) {
                    type = reportCircularityError(symbol);
                }
                links.type = type;
            }
            return links.type;
        }
--- END ---
INLINE (getTypeOfInstantiatedSymbol) id{455,1} AS 1 AT <0:96>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{455,2} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{455,2} AS 2 AT <1:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{455,3} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{455,3} AS 3 AT <2:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:popTypeResolution) id{455,4} ---
() {
            resolutionTargets.pop();
            resolutionPropertyNames.pop();
            return resolutionResults.pop();
        }
--- END ---
INLINE (popTypeResolution) id{455,4} AS 4 AT <1:323>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeOfFuncClassEnumModule) id{455,5} ---
(symbol) {
            var links = getSymbolLinks(symbol);
            if (!links.type) {
                if (symbol.flags & 1536 /* Module */ && ts.isShorthandAmbientModuleSymbol(symbol)) {
                    links.type = anyType;
                }
                else {
                    var type = createObjectType(16 /* Anonymous */, symbol);
                    links.type = strictNullChecks && symbol.flags & 536870912 /* Optional */ ?
                        includeFalsyTypes(type, 2048 /* Undefined */) : type;
                }
            }
            return links.type;
        }
--- END ---
INLINE (getTypeOfFuncClassEnumModule) id{455,5} AS 5 AT <0:459>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{455,6} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{455,6} AS 6 AT <5:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{455,7} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{455,7} AS 7 AT <6:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createObjectType) id{455,8} ---
(objectFlags, symbol) {
            var type = createType(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol = symbol;
            return type;
        }
--- END ---
INLINE (createObjectType) id{455,8} AS 8 AT <5:305>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{455,9} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{455,9} AS 9 AT <8:47>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{455,10} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{455,10} AS 10 AT <9:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isConst) id{456,0} ---
(node) {
        return !!(ts.getCombinedNodeFlags(node) & 2 /* Const */)
            || !!(ts.getCombinedModifierFlags(node) & 2048 /* Const */);
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isLet) id{457,0} ---
(node) {
        return !!(ts.getCombinedNodeFlags(node) & 1 /* Let */);
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNumNonRestParameters) id{458,0} ---
(signature) {
            var numParams = signature.parameters.length;
            return signature.hasRestParameter ?
                numParams - 1 :
                numParams;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeOfParameter) id{459,0} ---
(symbol) {
            var type = getTypeOfSymbol(symbol);
            if (strictNullChecks) {
                var declaration = symbol.valueDeclaration;
                if (declaration && declaration.initializer) {
                    return includeFalsyTypes(type, 2048 /* Undefined */);
                }
            }
            return type;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isInAmbientContext) id{460,0} ---
(node) {
        while (node) {
            if (hasModifier(node, 2 /* Ambient */) || (node.kind === 261 /* SourceFile */ && node.isDeclarationFile)) {
                return true;
            }
            node = node.parent;
        }
        return false;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:hasModifier) id{460,1} ---
(node, flags) {
        return (getModifierFlags(node) & flags) !== 0;
    }
--- END ---
INLINE (hasModifier) id{460,1} AS 1 AT <0:48>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:binarySearchTypes) id{461,0} ---
(types, type) {
            var low = 0;
            var high = types.length - 1;
            var typeId = type.id;
            while (low <= high) {
                var middle = low + ((high - low) >> 1);
                var id = types[middle].id;
                if (id === typeId) {
                    return middle;
                }
                else if (id > typeId) {
                    high = middle - 1;
                }
                else {
                    low = middle + 1;
                }
            }
            return ~low;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:addTypeToUnion) id{462,0} ---
(typeSet, type) {
            var flags = type.flags;
            if (flags & 65536 /* Union */) {
                addTypesToUnion(typeSet, type.types);
            }
            else if (flags & 1 /* Any */) {
                typeSet.containsAny = true;
            }
            else if (!strictNullChecks && flags & 6144 /* Nullable */) {
                if (flags & 2048 /* Undefined */)
                    typeSet.containsUndefined = true;
                if (flags & 4096 /* Null */)
                    typeSet.containsNull = true;
                if (!(flags & 2097152 /* ContainsWideningType */))
                    typeSet.containsNonWideningType = true;
            }
            else if (!(flags & 8192 /* Never */)) {
                if (flags & 2 /* String */)
                    typeSet.containsString = true;
                if (flags & 4 /* Number */)
                    typeSet.containsNumber = true;
                if (flags & 96 /* StringOrNumberLiteral */)
                    typeSet.containsStringOrNumberLiteral = true;
                var len = typeSet.length;
                var index = len && type.id > typeSet[len - 1].id ? ~len : binarySearchTypes(typeSet, type);
                if (index < 0) {
                    if (!(flags & 32768 /* Object */ && type.objectFlags & 16 /* Anonymous */ &&
                        type.symbol && type.symbol.flags & (16 /* Function */ | 8192 /* Method */) && containsIdenticalType(typeSet, type))) {
                        typeSet.splice(~index, 0, type);
                    }
                }
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:addTypesToUnion) id{462,1} ---
(typeSet, types) {
            for (var _i = 0, types_4 = types; _i < types_4.length; _i++) {
                var type = types_4[_i];
                addTypeToUnion(typeSet, type);
            }
        }
--- END ---
INLINE (addTypesToUnion) id{462,1} AS 1 AT <0:115>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:binarySearchTypes) id{462,2} ---
(types, type) {
            var low = 0;
            var high = types.length - 1;
            var typeId = type.id;
            while (low <= high) {
                var middle = low + ((high - low) >> 1);
                var id = types[middle].id;
                if (id === typeId) {
                    return middle;
                }
                else if (id > typeId) {
                    high = middle - 1;
                }
                else {
                    low = middle + 1;
                }
            }
            return ~low;
        }
--- END ---
INLINE (binarySearchTypes) id{462,2} AS 2 AT <0:1165>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:map) id{463,0} ---
(array, f) {
        var result;
        if (array) {
            result = [];
            for (var i = 0; i < array.length; i++) {
                result.push(f(array[i], i));
            }
        }
        return result;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkMethodDeclaration) id{464,0} ---
(node) {
            // Grammar checking
            checkGrammarMethod(node) || checkGrammarComputedPropertyName(node.name);
            // Grammar checking for modifiers is done inside the function checkGrammarFunctionLikeDeclaration
            checkFunctionOrMethodDeclaration(node);
            // Abstract methods cannot have an implementation.
            // Extra checks are to avoid reporting multiple errors relating to the "abstractness" of the node.
            if (ts.getModifierFlags(node) & 128 /* Abstract */ && node.body) {
                error(node, ts.Diagnostics.Method_0_cannot_have_an_implementation_because_it_is_marked_abstract, ts.declarationNameToString(node.name));
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarComputedPropertyName) id{464,1} ---
(node) {
            // If node is not a computedPropertyName, just skip the grammar checking
            if (node.kind !== 142 /* ComputedPropertyName */) {
                return false;
            }
            var computedPropertyName = node;
            if (computedPropertyName.expression.kind === 192 /* BinaryExpression */ && computedPropertyName.expression.operatorToken.kind === 25 /* CommaToken */) {
                return grammarErrorOnNode(computedPropertyName.expression, ts.Diagnostics.A_comma_expression_is_not_allowed_in_a_computed_property_name);
            }
        }
--- END ---
INLINE (checkGrammarComputedPropertyName) id{464,1} AS 1 AT <0:81>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:addInheritedMembers) id{465,0} ---
(symbols, baseSymbols) {
            for (var _i = 0, baseSymbols_1 = baseSymbols; _i < baseSymbols_1.length; _i++) {
                var s = baseSymbols_1[_i];
                if (!symbols[s.name]) {
                    symbols[s.name] = s;
                }
            }
        }
--- END ---
[deoptimizing (DEOPT eager): begin 0x1030c9d44621 <JS Function getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode (SharedFunctionInfo 0x2e2f693f4bc1)> (opt #421) @36, FP to SP delta: 168, caller sp: 0x7fff5fbfda30]
            ;;; deoptimize at 0_283: Unknown map in polymorphic access
  reading input frame getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode => node=92, args=2, height=6; inputs:
      0: 0x1030c9d44621 ; [fp - 16] 0x1030c9d44621 <JS Function getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode (SharedFunctionInfo 0x2e2f693f4bc1)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2be622f3ef91 ; rbx 0x2be622f3ef91 <a NodeObject with map 0x33abe2a768d1>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x32c5a0d0f9c9 ; [fp - 56] 0x32c5a0d0f9c9 <an Object with map 0x33abe2a51889>
      5: 0x30bcea404311 ; [fp - 96] 0x30bcea404311 <undefined>
      6: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
      7: 0x16f3adb61821 ; [fp - 104] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      8: 0xd6230dc3771 ; rax 0xd6230dc3771 <JS Function isEmpty (SharedFunctionInfo 0xc2bd2ae32e9)>
  translating frame getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode => node=92, height=40
    0x7fff5fbfda28: [top + 80] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfda20: [top + 72] <- 0x2be622f3ef91 ;  0x2be622f3ef91 <a NodeObject with map 0x33abe2a768d1>  (input #2)
    0x7fff5fbfda18: [top + 64] <- 0x2c21d26a5356 ;  caller's pc
    0x7fff5fbfda10: [top + 56] <- 0x7fff5fbfdaf0 ;  caller's fp
    0x7fff5fbfda08: [top + 48] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfda00: [top + 40] <- 0x1030c9d44621 ;  function    0x1030c9d44621 <JS Function getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode (SharedFunctionInfo 0x2e2f693f4bc1)>  (input #0)
    0x7fff5fbfd9f8: [top + 32] <- 0x32c5a0d0f9c9 ;  0x32c5a0d0f9c9 <an Object with map 0x33abe2a51889>  (input #4)
    0x7fff5fbfd9f0: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfd9e8: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfd9e0: [top + 8] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #7)
    0x7fff5fbfd9d8: [top + 0] <- 0xd6230dc3771 ;  0xd6230dc3771 <JS Function isEmpty (SharedFunctionInfo 0xc2bd2ae32e9)>  (input #8)
[deoptimizing (eager): end 0x1030c9d44621 <JS Function getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode (SharedFunctionInfo 0x2e2f693f4bc1)> @36 => node=92, pc=0x2c21d261f936, caller sp=0x7fff5fbfda30, state=TOS_REGISTER, took 0.087 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkVariableStatement) id{466,0} ---
(node) {
            // Grammar checking
            checkGrammarDecorators(node) || checkGrammarModifiers(node) || checkGrammarVariableDeclarationList(node.declarationList) || checkGrammarForDisallowedLetOrConstStatement(node);
            ts.forEach(node.declarationList.declarations, checkSourceElement);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarVariableDeclarationList) id{466,1} ---
(declarationList) {
            var declarations = declarationList.declarations;
            if (checkGrammarForDisallowedTrailingComma(declarationList.declarations)) {
                return true;
            }
            if (!declarationList.declarations.length) {
                return grammarErrorAtPos(ts.getSourceFileOfNode(declarationList), declarations.pos, declarations.end - declarations.pos, ts.Diagnostics.Variable_declaration_list_cannot_be_empty);
            }
        }
--- END ---
INLINE (checkGrammarVariableDeclarationList) id{466,1} AS 1 AT <0:116>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarForDisallowedTrailingComma) id{466,2} ---
(list) {
            if (list && list.hasTrailingComma) {
                var start = list.end - ",".length;
                var end = list.end;
                var sourceFile = ts.getSourceFileOfNode(list[0]);
                return grammarErrorAtPos(sourceFile, start, end - start, ts.Diagnostics.Trailing_comma_not_allowed);
            }
        }
--- END ---
INLINE (checkGrammarForDisallowedTrailingComma) id{466,2} AS 2 AT <1:97>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarForDisallowedLetOrConstStatement) id{466,3} ---
(node) {
            if (!allowLetAndConstDeclarations(node.parent)) {
                if (ts.isLet(node.declarationList)) {
                    return grammarErrorOnNode(node, ts.Diagnostics.let_declarations_can_only_be_declared_inside_a_block);
                }
                else if (ts.isConst(node.declarationList)) {
                    return grammarErrorOnNode(node, ts.Diagnostics.const_declarations_can_only_be_declared_inside_a_block);
                }
            }
        }
--- END ---
INLINE (checkGrammarForDisallowedLetOrConstStatement) id{466,3} AS 3 AT <0:177>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:allowLetAndConstDeclarations) id{466,4} ---
(parent) {
            switch (parent.kind) {
                case 208 /* IfStatement */:
                case 209 /* DoStatement */:
                case 210 /* WhileStatement */:
                case 217 /* WithStatement */:
                case 211 /* ForStatement */:
                case 212 /* ForInStatement */:
                case 213 /* ForOfStatement */:
                    return false;
                case 219 /* LabeledStatement */:
                    return allowLetAndConstDeclarations(parent.parent);
            }
            return true;
        }
--- END ---
INLINE (allowLetAndConstDeclarations) id{466,4} AS 4 AT <3:26>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkVariableDeclaration) id{467,0} ---
(node) {
            checkGrammarVariableDeclaration(node);
            return checkVariableLikeDeclaration(node);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getBaseTypes) id{468,0} ---
(type) {
            if (!type.resolvedBaseTypes) {
                if (type.objectFlags & 8 /* Tuple */) {
                    type.resolvedBaseTypes = [createArrayType(getUnionType(type.typeParameters))];
                }
                else if (type.symbol.flags & (32 /* Class */ | 64 /* Interface */)) {
                    if (type.symbol.flags & 32 /* Class */) {
                        resolveBaseTypesOfClass(type);
                    }
                    if (type.symbol.flags & 64 /* Interface */) {
                        resolveBaseTypesOfInterface(type);
                    }
                }
                else {
                    ts.Debug.fail("type must be class or interface");
                }
            }
            return type.resolvedBaseTypes;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:check) id{469,0} ---
(type) {
                var target = getTargetType(type);
                return target === checkBase || ts.forEach(getBaseTypes(target), check);
            }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTargetType) id{469,1} ---
(type) {
            return getObjectFlags(type) & 4 /* Reference */ ? type.target : type;
        }
--- END ---
INLINE (getTargetType) id{469,1} AS 1 AT <0:38>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{469,2} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{469,2} AS 2 AT <1:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeListId) id{470,0} ---
(types) {
            var result = "";
            if (types) {
                var length_3 = types.length;
                var i = 0;
                while (i < length_3) {
                    var startId = types[i].id;
                    var count = 1;
                    while (i + count < length_3 && types[i + count].id === startId + count) {
                        count++;
                    }
                    if (result.length) {
                        result += ",";
                    }
                    result += startId;
                    if (count > 1) {
                        result += ":" + count;
                    }
                    i += count;
                }
            }
            return result;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarHeritageClause) id{471,0} ---
(node) {
            var types = node.types;
            if (checkGrammarForDisallowedTrailingComma(types)) {
                return true;
            }
            if (types && types.length === 0) {
                var listType = ts.tokenToString(node.token);
                var sourceFile = ts.getSourceFileOfNode(node);
                return grammarErrorAtPos(sourceFile, types.pos, 0, ts.Diagnostics._0_list_cannot_be_empty, listType);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarForDisallowedTrailingComma) id{471,1} ---
(list) {
            if (list && list.hasTrailingComma) {
                var start = list.end - ",".length;
                var end = list.end;
                var sourceFile = ts.getSourceFileOfNode(list[0]);
                return grammarErrorAtPos(sourceFile, start, end - start, ts.Diagnostics.Trailing_comma_not_allowed);
            }
        }
--- END ---
INLINE (checkGrammarForDisallowedTrailingComma) id{471,1} AS 1 AT <0:61>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:needCollisionCheckForIdentifier) id{472,0} ---
(node, identifier, name) {
            if (!(identifier && identifier.text === name)) {
                return false;
            }
            if (node.kind === 147 /* PropertyDeclaration */ ||
                node.kind === 146 /* PropertySignature */ ||
                node.kind === 149 /* MethodDeclaration */ ||
                node.kind === 148 /* MethodSignature */ ||
                node.kind === 151 /* GetAccessor */ ||
                node.kind === 152 /* SetAccessor */) {
                // it is ok to have member named '_super' or '_this' - member access is always qualified
                return false;
            }
            if (ts.isInAmbientContext(node)) {
                // ambient context - no codegen impact
                return false;
            }
            var root = ts.getRootDeclaration(node);
            if (root.kind === 144 /* Parameter */ && ts.nodeIsMissing(root.parent.body)) {
                // just an overload - no codegen impact
                return false;
            }
            return true;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getErasedSignature) id{473,0} ---
(signature) {
            if (!signature.typeParameters)
                return signature;
            if (!signature.erasedSignatureCache) {
                signature.erasedSignatureCache = instantiateSignature(signature, createTypeEraser(signature.typeParameters), /*eraseTypeParameters*/ true);
            }
            return signature.erasedSignatureCache;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createTypeEraser) id{473,1} ---
(sources) {
            return createTypeMapper(sources, undefined);
        }
--- END ---
INLINE (createTypeEraser) id{473,1} AS 1 AT <0:223>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createTypeMapper) id{473,2} ---
(sources, targets) {
            var count = sources.length;
            var mapper = count == 1 ? createUnaryTypeMapper(sources[0], targets ? targets[0] : anyType) :
                count == 2 ? createBinaryTypeMapper(sources[0], targets ? targets[0] : anyType, sources[1], targets ? targets[1] : anyType) :
                    createArrayTypeMapper(sources, targets);
            mapper.mappedTypes = sources;
            return mapper;
        }
--- END ---
INLINE (createTypeMapper) id{473,2} AS 2 AT <1:31>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNumParametersToCheckForSignatureRelatability) id{474,0} ---
(source, sourceNonRestParamCount, target, targetNonRestParamCount) {
            if (source.hasRestParameter === target.hasRestParameter) {
                if (source.hasRestParameter) {
                    // If both have rest parameters, get the max and add 1 to
                    // compensate for the rest parameter.
                    return Math.max(sourceNonRestParamCount, targetNonRestParamCount) + 1;
                }
                else {
                    return Math.min(sourceNonRestParamCount, targetNonRestParamCount);
                }
            }
            else {
                // Return the count for whichever signature doesn't have rest parameters.
                return source.hasRestParameter ?
                    targetNonRestParamCount :
                    sourceNonRestParamCount;
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:removeRedundantLiteralTypes) id{475,0} ---
(types) {
            var i = types.length;
            while (i > 0) {
                i--;
                var t = types[i];
                var remove = t.flags & 32 /* StringLiteral */ && types.containsString ||
                    t.flags & 64 /* NumberLiteral */ && types.containsNumber ||
                    t.flags & 96 /* StringOrNumberLiteral */ && t.flags & 1048576 /* FreshLiteral */ && containsType(types, t.regularType);
                if (remove) {
                    ts.orderedRemoveItemAt(types, i);
                }
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isTypeAssignableTo) id{476,0} ---
(source, target) {
            return isTypeRelatedTo(source, target, assignableRelation);
        }
--- END ---
[marking dependent code 0x2c21d2672fe1 (opt #352) for deoptimization, reason: allocation-site-tenuring-changed]
[marking dependent code 0x2c21d2675621 (opt #356) for deoptimization, reason: allocation-site-tenuring-changed]
[deoptimize marked code in all contexts]
[deoptimizer unlinked: instantiateTypes / 130b7e1b65d1]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:) id{477,0} ---
(p) { seen[p.name] = { prop: p, containingType: type }; }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:addTypesToUnion) id{478,0} ---
(typeSet, types) {
            for (var _i = 0, types_4 = types; _i < types_4.length; _i++) {
                var type = types_4[_i];
                addTypeToUnion(typeSet, type);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateSignatures) id{479,0} ---
(signatures, mapper) {
            return instantiateList(signatures, mapper, instantiateSignature);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateList) id{479,1} ---
(items, mapper, instantiator) {
            if (items && items.length) {
                var result = [];
                for (var _i = 0, items_1 = items; _i < items_1.length; _i++) {
                    var v = items_1[_i];
                    result.push(instantiator(v, mapper));
                }
                return result;
            }
            return items;
        }
--- END ---
INLINE (instantiateList) id{479,1} AS 1 AT <0:42>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateIndexInfo) id{480,0} ---
(info, mapper) {
            return info && createIndexInfo(instantiateType(info.type, mapper), info.isReadonly, info.declaration);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createIndexInfo) id{480,1} ---
(type, isReadonly, declaration) {
            return { type: type, isReadonly: isReadonly, declaration: declaration };
        }
--- END ---
INLINE (createIndexInfo) id{480,1} AS 1 AT <0:44>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getThisTypeOfSignature) id{481,0} ---
(signature) {
            if (signature.thisParameter) {
                return getTypeOfSymbol(signature.thisParameter);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isParameterDeclaration) id{482,0} ---
(node) {
        var root = getRootDeclaration(node);
        return root.kind === 144 /* Parameter */;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getRootDeclaration) id{482,1} ---
(node) {
        while (node.kind === 174 /* BindingElement */) {
            node = node.parent.parent;
        }
        return node;
    }
--- END ---
INLINE (getRootDeclaration) id{482,1} AS 1 AT <0:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getDeclaredTypeOfTypeParameter) id{483,0} ---
(symbol) {
            var links = getSymbolLinks(symbol);
            if (!links.declaredType) {
                var type = createType(16384 /* TypeParameter */);
                type.symbol = symbol;
                if (!ts.getDeclarationOfKind(symbol, 143 /* TypeParameter */).constraint) {
                    type.constraint = noConstraintType;
                }
                links.declaredType = type;
            }
            return links.declaredType;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{483,1} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{483,1} AS 1 AT <0:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{483,2} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{483,2} AS 2 AT <1:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{483,3} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{483,3} AS 3 AT <0:125>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{483,4} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{483,4} AS 4 AT <3:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateTypeNoAlias) id{484,0} ---
(type, mapper) {
            if (type.flags & 16384 /* TypeParameter */) {
                return mapper(type);
            }
            if (type.flags & 32768 /* Object */) {
                if (type.objectFlags & 16 /* Anonymous */) {
                    // If the anonymous type originates in a declaration of a function, method, class, or
                    // interface, in an object type literal, or in an object literal expression, we may need
                    // to instantiate the type because it might reference a type parameter. We skip instantiation
                    // if none of the type parameters that are in scope in the type's declaration are mapped by
                    // the given mapper, however we can only do that analysis if the type isn't itself an
                    // instantiation.
                    return type.symbol &&
                        type.symbol.flags & (16 /* Function */ | 8192 /* Method */ | 32 /* Class */ | 2048 /* TypeLiteral */ | 4096 /* ObjectLiteral */) &&
                        (type.objectFlags & 64 /* Instantiated */ || isSymbolInScopeOfMappedTypeParameter(type.symbol, mapper)) ?
                        instantiateCached(type, mapper, instantiateAnonymousType) : type;
                }
                if (type.objectFlags & 32 /* Mapped */) {
                    return instantiateCached(type, mapper, instantiateMappedType);
                }
                if (type.objectFlags & 4 /* Reference */) {
                    return createTypeReference(type.target, instantiateTypes(type.typeArguments, mapper));
                }
            }
            if (type.flags & 65536 /* Union */ && !(type.flags & 8190 /* Primitive */)) {
                return getUnionType(instantiateTypes(type.types, mapper), /*subtypeReduction*/ false, type.aliasSymbol, instantiateTypes(type.aliasTypeArguments, mapper));
            }
            if (type.flags & 131072 /* Intersection */) {
                return getIntersectionType(instantiateTypes(type.types, mapper), type.aliasSymbol, instantiateTypes(type.aliasTypeArguments, mapper));
            }
            if (type.flags & 262144 /* Index */) {
                return getIndexType(instantiateType(type.type, mapper));
            }
            if (type.flags & 524288 /* IndexedAccess */) {
                return getIndexedAccessType(instantiateType(type.objectType, mapper), instantiateType(type.indexType, mapper));
            }
            return type;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateCached) id{484,1} ---
(type, mapper, instantiator) {
            var instantiations = mapper.instantiations || (mapper.instantiations = []);
            return instantiations[type.id] || (instantiations[type.id] = instantiator(type, mapper));
        }
--- END ---
INLINE (instantiateCached) id{484,1} AS 1 AT <0:1175>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateCached) id{484,2} ---
(type, mapper, instantiator) {
            var instantiations = mapper.instantiations || (mapper.instantiations = []);
            return instantiations[type.id] || (instantiations[type.id] = instantiator(type, mapper));
        }
--- END ---
INLINE (instantiateCached) id{484,2} AS 2 AT <0:1344>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateTypes) id{484,3} ---
(types, mapper) {
            return instantiateList(types, mapper, instantiateType);
        }
--- END ---
INLINE (instantiateTypes) id{484,3} AS 3 AT <0:1538>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateList) id{484,4} ---
(items, mapper, instantiator) {
            if (items && items.length) {
                var result = [];
                for (var _i = 0, items_1 = items; _i < items_1.length; _i++) {
                    var v = items_1[_i];
                    result.push(instantiator(v, mapper));
                }
                return result;
            }
            return items;
        }
--- END ---
INLINE (instantiateList) id{484,4} AS 4 AT <3:37>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createTypeReference) id{484,5} ---
(target, typeArguments) {
            var id = getTypeListId(typeArguments);
            var type = target.instantiations[id];
            if (!type) {
                type = target.instantiations[id] = createObjectType(4 /* Reference */, target.symbol);
                type.flags |= typeArguments ? getPropagatingFlagsOfTypes(typeArguments, /*excludeKinds*/ 0) : 0;
                type.target = target;
                type.typeArguments = typeArguments;
            }
            return type;
        }
--- END ---
INLINE (createTypeReference) id{484,5} AS 5 AT <0:1505>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createObjectType) id{484,6} ---
(objectFlags, symbol) {
            var type = createType(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol = symbol;
            return type;
        }
--- END ---
INLINE (createObjectType) id{484,6} AS 6 AT <5:203>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{484,7} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{484,7} AS 7 AT <6:47>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{484,8} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{484,8} AS 8 AT <7:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropagatingFlagsOfTypes) id{484,9} ---
(types, excludeKinds) {
            var result = 0;
            for (var _i = 0, types_3 = types; _i < types_3.length; _i++) {
                var type = types_3[_i];
                if (!(type.flags & excludeKinds)) {
                    result |= type.flags;
                }
            }
            return result & 14680064 /* PropagatingFlags */;
        }
--- END ---
INLINE (getPropagatingFlagsOfTypes) id{484,9} AS 9 AT <5:301>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isTypeAny) id{485,0} ---
(type) {
            return type && (type.flags & 1 /* Any */) !== 0;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:indexTypesRelatedTo) id{486,0} ---
(source, originalSource, target, kind, reportErrors) {
                if (relation === identityRelation) {
                    return indexTypesIdenticalTo(source, target, kind);
                }
                var targetInfo = getIndexInfoOfType(target, kind);
                if (!targetInfo || ((targetInfo.type.flags & 1 /* Any */) && !(originalSource.flags & 8190 /* Primitive */))) {
                    // Index signature of type any permits assignment from everything but primitives
                    return -1 /* True */;
                }
                var sourceInfo = getIndexInfoOfType(source, kind) ||
                    kind === 1 /* Number */ && getIndexInfoOfType(source, 0 /* String */);
                if (sourceInfo) {
                    return indexInfoRelatedTo(sourceInfo, targetInfo, reportErrors);
                }
                if (isObjectLiteralType(source)) {
                    var related = -1 /* True */;
                    if (kind === 0 /* String */) {
                        var sourceNumberInfo = getIndexInfoOfType(source, 1 /* Number */);
                        if (sourceNumberInfo) {
                            related = indexInfoRelatedTo(sourceNumberInfo, targetInfo, reportErrors);
                        }
                    }
                    if (related) {
                        related &= eachPropertyRelatedTo(source, targetInfo.type, kind, reportErrors);
                    }
                    return related;
                }
                if (reportErrors) {
                    reportError(ts.Diagnostics.Index_signature_is_missing_in_type_0, typeToString(source));
                }
                return 0 /* False */;
            }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexInfoOfType) id{486,1} ---
(type, kind) {
            return getIndexInfoOfStructuredType(getApparentType(type), kind);
        }
--- END ---
INLINE (getIndexInfoOfType) id{486,1} AS 1 AT <0:231>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getApparentType) id{486,2} ---
(type) {
            var t = type.flags & 540672 /* TypeVariable */ ? getApparentTypeOfTypeVariable(type) : type;
            return t.flags & 262178 /* StringLike */ ? globalStringType :
                t.flags & 340 /* NumberLike */ ? globalNumberType :
                    t.flags & 136 /* BooleanLike */ ? globalBooleanType :
                        t.flags & 512 /* ESSymbol */ ? getGlobalESSymbolType() :
                            t;
        }
--- END ---
INLINE (getApparentType) id{486,2} AS 2 AT <1:63>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexInfoOfStructuredType) id{486,3} ---
(type, kind) {
            if (type.flags & 229376 /* StructuredType */) {
                var resolved = resolveStructuredTypeMembers(type);
                return kind === 0 /* String */ ? resolved.stringIndexInfo : resolved.numberIndexInfo;
            }
        }
--- END ---
INLINE (getIndexInfoOfStructuredType) id{486,3} AS 3 AT <1:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexInfoOfType) id{486,4} ---
(type, kind) {
            return getIndexInfoOfStructuredType(getApparentType(type), kind);
        }
--- END ---
INLINE (getIndexInfoOfType) id{486,4} AS 4 AT <0:587>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getApparentType) id{486,5} ---
(type) {
            var t = type.flags & 540672 /* TypeVariable */ ? getApparentTypeOfTypeVariable(type) : type;
            return t.flags & 262178 /* StringLike */ ? globalStringType :
                t.flags & 340 /* NumberLike */ ? globalNumberType :
                    t.flags & 136 /* BooleanLike */ ? globalBooleanType :
                        t.flags & 512 /* ESSymbol */ ? getGlobalESSymbolType() :
                            t;
        }
--- END ---
INLINE (getApparentType) id{486,5} AS 5 AT <4:63>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexInfoOfStructuredType) id{486,6} ---
(type, kind) {
            if (type.flags & 229376 /* StructuredType */) {
                var resolved = resolveStructuredTypeMembers(type);
                return kind === 0 /* String */ ? resolved.stringIndexInfo : resolved.numberIndexInfo;
            }
        }
--- END ---
INLINE (getIndexInfoOfStructuredType) id{486,6} AS 6 AT <4:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkTypeRelatedTo) id{487,0} ---
(source, target, relation, errorNode, headMessage, containingMessageChain) {
            var errorInfo;
            var sourceStack;
            var targetStack;
            var maybeStack;
            var expandingFlags;
            var depth = 0;
            var overflow = false;
            ts.Debug.assert(relation !== identityRelation || !errorNode, "no error reporting in identity checking");
            var result = isRelatedTo(source, target, /*reportErrors*/ !!errorNode, headMessage);
            if (overflow) {
                error(errorNode, ts.Diagnostics.Excessive_stack_depth_comparing_types_0_and_1, typeToString(source), typeToString(target));
            }
            else if (errorInfo) {
                if (containingMessageChain) {
                    errorInfo = ts.concatenateDiagnosticMessageChains(containingMessageChain, errorInfo);
                }
                diagnostics.add(ts.createDiagnosticForNodeFromMessageChain(errorNode, errorInfo));
            }
            return result !== 0 /* False */;
            function reportError(message, arg0, arg1, arg2) {
                ts.Debug.assert(!!errorNode);
                errorInfo = ts.chainDiagnosticMessages(errorInfo, message, arg0, arg1, arg2);
            }
            function reportRelationError(message, source, target) {
                var sourceType = typeToString(source);
                var targetType = typeToString(target);
                if (sourceType === targetType) {
                    sourceType = typeToString(source, /*enclosingDeclaration*/ undefined, 128 /* UseFullyQualifiedType */);
                    targetType = typeToString(target, /*enclosingDeclaration*/ undefined, 128 /* UseFullyQualifiedType */);
                }
                if (!message) {
                    if (relation === comparableRelation) {
                        message = ts.Diagnostics.Type_0_is_not_comparable_to_type_1;
                    }
                    else if (sourceType === targetType) {
                        message = ts.Diagnostics.Type_0_is_not_assignable_to_type_1_Two_different_types_with_this_name_exist_but_they_are_unrelated;
                    }
                    else {
                        message = ts.Diagnostics.Type_0_is_not_assignable_to_type_1;
                    }
                }
                reportError(message, sourceType, targetType);
            }
            function tryElaborateErrorsForPrimitivesAndObjects(source, target) {
                var sourceType = typeToString(source);
                var targetType = typeToString(target);
                if ((globalStringType === source && stringType === target) ||
                    (globalNumberType === source && numberType === target) ||
                    (globalBooleanType === source && booleanType === target) ||
                    (getGlobalESSymbolType() === source && esSymbolType === target)) {
                    reportError(ts.Diagnostics._0_is_a_primitive_but_1_is_a_wrapper_object_Prefer_using_0_when_possible, targetType, sourceType);
                }
            }
            function isUnionOrIntersectionTypeWithoutNullableConstituents(type) {
                if (!(type.flags & 196608 /* UnionOrIntersection */)) {
                    return false;
                }
                // at this point we know that this is union or intersection type possibly with nullable constituents.
                // check if we still will have compound type if we ignore nullable components.
                var seenNonNullable = false;
                for (var _i = 0, _a = type.types; _i < _a.length; _i++) {
                    var t = _a[_i];
                    if (t.flags & 6144 /* Nullable */) {
                        continue;
                    }
                    if (seenNonNullable) {
                        return true;
                    }
                    seenNonNullable = true;
                }
                return false;
            }
            // Compare two types and return
            // Ternary.True if they are related with no assumptions,
            // Ternary.Maybe if they are related with assumptions of other relationships, or
            // Ternary.False if they are not related.
            function isRelatedTo(source, target, reportErrors, headMessage) {
                var result;
                if (source.flags & 96 /* StringOrNumberLiteral */ && source.flags & 1048576 /* FreshLiteral */) {
                    source = source.regularType;
                }
                if (target.flags & 96 /* StringOrNumberLiteral */ && target.flags & 1048576 /* FreshLiteral */) {
                    target = target.regularType;
                }
                // both types are the same - covers 'they are the same primitive type or both are Any' or the same type parameter cases
                if (source === target)
                    return -1 /* True */;
                if (relation === identityRelation) {
                    return isIdenticalTo(source, target);
                }
                if (isSimpleTypeRelatedTo(source, target, relation, reportErrors ? reportError : undefined))
                    return -1 /* True */;
                if (getObjectFlags(source) & 128 /* ObjectLiteral */ && source.flags & 1048576 /* FreshLiteral */) {
                    if (hasExcessProperties(source, target, reportErrors)) {
                        if (reportErrors) {
                            reportRelationError(headMessage, source, target);
                        }
                        return 0 /* False */;
                    }
                    // Above we check for excess properties with respect to the entire target type. When union
                    // and intersection types are further deconstructed on the target side, we don't want to
                    // make the check again (as it might fail for a partial target type). Therefore we obtain
                    // the regular source type and proceed with that.
                    if (isUnionOrIntersectionTypeWithoutNullableConstituents(target)) {
                        source = getRegularTypeOfObjectLiteral(source);
                    }
                }
                var saveErrorInfo = errorInfo;
                // Note that these checks are specifically ordered to produce correct results. In particular,
                // we need to deconstruct unions before intersections (because unions are always at the top),
                // and we need to handle "each" relations before "some" relations for the same kind of type.
                if (source.flags & 65536 /* Union */) {
                    if (relation === comparableRelation) {
                        result = someTypeRelatedToType(source, target, reportErrors && !(source.flags & 8190 /* Primitive */));
                    }
                    else {
                        result = eachTypeRelatedToType(source, target, reportErrors && !(source.flags & 8190 /* Primitive */));
                    }
                    if (result) {
                        return result;
                    }
                }
                else if (target.flags & 65536 /* Union */) {
                    if (result = typeRelatedToSomeType(source, target, reportErrors && !(source.flags & 8190 /* Primitive */) && !(target.flags & 8190 /* Primitive */))) {
                        return result;
                    }
                }
                else if (target.flags & 131072 /* Intersection */) {
                    if (result = typeRelatedToEachType(source, target, reportErrors)) {
                        return result;
                    }
                }
                else if (source.flags & 131072 /* Intersection */) {
                    // Check to see if any constituents of the intersection are immediately related to the target.
                    //
                    // Don't report errors though. Checking whether a constituent is related to the source is not actually
                    // useful and leads to some confusing error messages. Instead it is better to let the below checks
                    // take care of this, or to not elaborate at all. For instance,
                    //
                    //    - For an object type (such as 'C = A & B'), users are usually more interested in structural errors.
                    //
                    //    - For a union type (such as '(A | B) = (C & D)'), it's better to hold onto the whole intersection
                    //          than to report that 'D' is not assignable to 'A' or 'B'.
                    //
                    //    - For a primitive type or type parameter (such as 'number = A & B') there is no point in
                    //          breaking the intersection apart.
                    if (result = someTypeRelatedToType(source, target, /*reportErrors*/ false)) {
                        return result;
                    }
                }
                else if (target.flags & 16384 /* TypeParameter */) {
                    // A source type { [P in keyof T]: X } is related to a target type T if X is related to T[P].
                    if (getObjectFlags(source) & 32 /* Mapped */ && getConstraintTypeFromMappedType(source) === getIndexType(target)) {
                        if (!source.declaration.questionToken) {
                            var templateType = getTemplateTypeFromMappedType(source);
                            var indexedAccessType = getIndexedAccessType(target, getTypeParameterFromMappedType(source));
                            if (result = isRelatedTo(templateType, indexedAccessType, reportErrors)) {
                                return result;
                            }
                        }
                    }
                    else {
                        // Given a type parameter K with a constraint keyof T, a type S is
                        // assignable to K if S is assignable to keyof T.
                        var constraint = getConstraintOfTypeParameter(target);
                        if (constraint && constraint.flags & 262144 /* Index */) {
                            if (result = isRelatedTo(source, constraint, reportErrors)) {
                                return result;
                            }
                        }
                    }
                }
                else if (target.flags & 262144 /* Index */) {
                    // A keyof S is related to a keyof T if T is related to S.
                    if (source.flags & 262144 /* Index */) {
                        if (result = isRelatedTo(target.type, source.type, /*reportErrors*/ false)) {
                            return result;
                        }
                    }
                    // Given a type variable T with a constraint C, a type S is assignable to
                    // keyof T if S is assignable to keyof C.
                    if (target.type.flags & 540672 /* TypeVariable */) {
                        var constraint = getConstraintOfTypeVariable(target.type);
                        if (constraint) {
                            if (result = isRelatedTo(source, getIndexType(constraint), reportErrors)) {
                                return result;
                            }
                        }
                    }
                }
                else if (target.flags & 524288 /* IndexedAccess */) {
                    // if we have indexed access types with identical index types, see if relationship holds for
                    // the two object types.
                    if (source.flags & 524288 /* IndexedAccess */ && source.indexType === target.indexType) {
                        if (result = isRelatedTo(source.objectType, target.objectType, reportErrors)) {
                            return result;
                        }
                    }
                    // A type S is related to a type T[K] if S is related to A[K], where K is string-like and
                    // A is the apparent type of S.
                    if (target.constraint) {
                        if (result = isRelatedTo(source, target.constraint, reportErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                }
                if (source.flags & 16384 /* TypeParameter */) {
                    // A source type T is related to a target type { [P in keyof T]: X } if T[P] is related to X.
                    if (getObjectFlags(target) & 32 /* Mapped */ && getConstraintTypeFromMappedType(target) === getIndexType(source)) {
                        var indexedAccessType = getIndexedAccessType(source, getTypeParameterFromMappedType(target));
                        var templateType = getTemplateTypeFromMappedType(target);
                        if (result = isRelatedTo(indexedAccessType, templateType, reportErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                    else {
                        var constraint = getConstraintOfTypeParameter(source);
                        if (!constraint || constraint.flags & 1 /* Any */) {
                            constraint = emptyObjectType;
                        }
                        // The constraint may need to be further instantiated with its 'this' type.
                        constraint = getTypeWithThisArgument(constraint, source);
                        // Report constraint errors only if the constraint is not the empty object type
                        var reportConstraintErrors = reportErrors && constraint !== emptyObjectType;
                        if (result = isRelatedTo(constraint, target, reportConstraintErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                }
                else if (source.flags & 524288 /* IndexedAccess */) {
                    // A type S[K] is related to a type T if A[K] is related to T, where K is string-like and
                    // A is the apparent type of S.
                    if (source.constraint) {
                        if (result = isRelatedTo(source.constraint, target, reportErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                }
                else {
                    if (getObjectFlags(source) & 4 /* Reference */ && getObjectFlags(target) & 4 /* Reference */ && source.target === target.target) {
                        // We have type references to same target type, see if relationship holds for all type arguments
                        if (result = typeArgumentsRelatedTo(source, target, reportErrors)) {
                            return result;
                        }
                    }
                    // Even if relationship doesn't hold for unions, intersections, or generic type references,
                    // it may hold in a structural comparison.
                    var apparentSource = getApparentType(source);
                    // In a check of the form X = A & B, we will have previously checked if A relates to X or B relates
                    // to X. Failing both of those we want to check if the aggregation of A and B's members structurally
                    // relates to X. Thus, we include intersection types on the source side here.
                    if (apparentSource.flags & (32768 /* Object */ | 131072 /* Intersection */) && target.flags & 32768 /* Object */) {
                        // Report structural errors only if we haven't reported any errors yet
                        var reportStructuralErrors = reportErrors && errorInfo === saveErrorInfo && !(source.flags & 8190 /* Primitive */);
                        if (result = objectTypeRelatedTo(apparentSource, source, target, reportStructuralErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                }
                if (reportErrors) {
                    if (source.flags & 32768 /* Object */ && target.flags & 8190 /* Primitive */) {
                        tryElaborateErrorsForPrimitivesAndObjects(source, target);
                    }
                    else if (source.symbol && source.flags & 32768 /* Object */ && globalObjectType === source) {
                        reportError(ts.Diagnostics.The_Object_type_is_assignable_to_very_few_other_types_Did_you_mean_to_use_the_any_type_instead);
                    }
                    reportRelationError(headMessage, source, target);
                }
                return 0 /* False */;
            }
            function isIdenticalTo(source, target) {
                var result;
                if (source.flags & 32768 /* Object */ && target.flags & 32768 /* Object */) {
                    if (getObjectFlags(source) & 4 /* Reference */ && getObjectFlags(target) & 4 /* Reference */ && source.target === target.target) {
                        // We have type references to same target type, see if all type arguments are identical
                        if (result = typeArgumentsRelatedTo(source, target, /*reportErrors*/ false)) {
                            return result;
                        }
                    }
                    return objectTypeRelatedTo(source, source, target, /*reportErrors*/ false);
                }
                if (source.flags & 65536 /* Union */ && target.flags & 65536 /* Union */ ||
                    source.flags & 131072 /* Intersection */ && target.flags & 131072 /* Intersection */) {
                    if (result = eachTypeRelatedToSomeType(source, target)) {
                        if (result &= eachTypeRelatedToSomeType(target, source)) {
                            return result;
                        }
                    }
                }
                return 0 /* False */;
            }
            // Check if a property with the given name is known anywhere in the given type. In an object type, a property
            // is considered known if the object type is empty and the check is for assignability, if the object type has
            // index signatures, or if the property is actually declared in the object type. In a union or intersection
            // type, a property is considered known if it is known in any constituent type.
            function isKnownProperty(type, name) {
                if (type.flags & 32768 /* Object */) {
                    var resolved = resolveStructuredTypeMembers(type);
                    if ((relation === assignableRelation || relation === comparableRelation) && (type === globalObjectType || isEmptyObjectType(resolved)) ||
                        resolved.stringIndexInfo ||
                        (resolved.numberIndexInfo && isNumericLiteralName(name)) ||
                        getPropertyOfType(type, name)) {
                        return true;
                    }
                }
                else if (type.flags & 196608 /* UnionOrIntersection */) {
                    for (var _i = 0, _a = type.types; _i < _a.length; _i++) {
                        var t = _a[_i];
                        if (isKnownProperty(t, name)) {
                            return true;
                        }
                    }
                }
                return false;
            }
            function isEmptyObjectType(t) {
                return t.properties.length === 0 &&
                    t.callSignatures.length === 0 &&
                    t.constructSignatures.length === 0 &&
                    !t.stringIndexInfo &&
                    !t.numberIndexInfo;
            }
            function hasExcessProperties(source, target, reportErrors) {
                if (maybeTypeOfKind(target, 32768 /* Object */) && !(getObjectFlags(target) & 512 /* ObjectLiteralPatternWithComputedProperties */)) {
                    for (var _i = 0, _a = getPropertiesOfObjectType(source); _i < _a.length; _i++) {
                        var prop = _a[_i];
                        if (!isKnownProperty(target, prop.name)) {
                            if (reportErrors) {
                                // We know *exactly* where things went wrong when comparing the types.
                                // Use this property as the error node as this will be more helpful in
                                // reasoning about what went wrong.
                                ts.Debug.assert(!!errorNode);
                                errorNode = prop.valueDeclaration;
                                reportError(ts.Diagnostics.Object_literal_may_only_specify_known_properties_and_0_does_not_exist_in_type_1, symbolToString(prop), typeToString(target));
                            }
                            return true;
                        }
                    }
                }
                return false;
            }
            function eachTypeRelatedToSomeType(source, target) {
                var result = -1 /* True */;
                var sourceTypes = source.types;
                for (var _i = 0, sourceTypes_1 = sourceTypes; _i < sourceTypes_1.length; _i++) {
                    var sourceType = sourceTypes_1[_i];
                    var related = typeRelatedToSomeType(sourceType, target, /*reportErrors*/ false);
                    if (!related) {
                        return 0 /* False */;
                    }
                    result &= related;
                }
                return result;
            }
            function typeRelatedToSomeType(source, target, reportErrors) {
                var targetTypes = target.types;
                if (target.flags & 65536 /* Union */ && containsType(targetTypes, source)) {
                    return -1 /* True */;
                }
                var len = targetTypes.length;
                for (var i = 0; i < len; i++) {
                    var related = isRelatedTo(source, targetTypes[i], reportErrors && i === len - 1);
                    if (related) {
                        return related;
                    }
                }
                return 0 /* False */;
            }
            function typeRelatedToEachType(source, target, reportErrors) {
                var result = -1 /* True */;
                var targetTypes = target.types;
                for (var _i = 0, targetTypes_1 = targetTypes; _i < targetTypes_1.length; _i++) {
                    var targetType = targetTypes_1[_i];
                    var related = isRelatedTo(source, targetType, reportErrors);
                    if (!related) {
                        return 0 /* False */;
                    }
                    result &= related;
                }
                return result;
            }
            function someTypeRelatedToType(source, target, reportErrors) {
                var sourceTypes = source.types;
                if (source.flags & 65536 /* Union */ && containsType(sourceTypes, target)) {
                    return -1 /* True */;
                }
                var len = sourceTypes.length;
                for (var i = 0; i < len; i++) {
                    var related = isRelatedTo(sourceTypes[i], target, reportErrors && i === len - 1);
                    if (related) {
                        return related;
                    }
                }
                return 0 /* False */;
            }
            function eachTypeRelatedToType(source, target, reportErrors) {
                var result = -1 /* True */;
                var sourceTypes = source.types;
                for (var _i = 0, sourceTypes_2 = sourceTypes; _i < sourceTypes_2.length; _i++) {
                    var sourceType = sourceTypes_2[_i];
                    var related = isRelatedTo(sourceType, target, reportErrors);
                    if (!related) {
                        return 0 /* False */;
                    }
                    result &= related;
                }
                return result;
            }
            function typeArgumentsRelatedTo(source, target, reportErrors) {
                var sources = source.typeArguments || emptyArray;
                var targets = target.typeArguments || emptyArray;
                if (sources.length !== targets.length && relation === identityRelation) {
                    return 0 /* False */;
                }
                var length = sources.length <= targets.length ? sources.length : targets.length;
                var result = -1 /* True */;
                for (var i = 0; i < length; i++) {
                    var related = isRelatedTo(sources[i], targets[i], reportErrors);
                    if (!related) {
                        return 0 /* False */;
                    }
                    result &= related;
                }
                return result;
            }
            // Determine if two object types are related by structure. First, check if the result is already available in the global cache.
            // Second, check if we have already started a comparison of the given two types in which case we assume the result to be true.
            // Third, check if both types are part of deeply nested chains of generic type instantiations and if so assume the types are
            // equal and infinitely expanding. Fourth, if we have reached a depth of 100 nested comparisons, assume we have runaway recursion
            // and issue an error. Otherwise, actually compare the structure of the two types.
            function objectTypeRelatedTo(source, originalSource, target, reportErrors) {
                if (overflow) {
                    return 0 /* False */;
                }
                var id = relation !== identityRelation || source.id < target.id ? source.id + "," + target.id : target.id + "," + source.id;
                var related = relation[id];
                if (related !== undefined) {
                    if (reportErrors && related === 2 /* Failed */) {
                        // We are elaborating errors and the cached result is an unreported failure. Record the result as a reported
                        // failure and continue computing the relation such that errors get reported.
                        relation[id] = 3 /* FailedAndReported */;
                    }
                    else {
                        return related === 1 /* Succeeded */ ? -1 /* True */ : 0 /* False */;
                    }
                }
                if (depth > 0) {
                    for (var i = 0; i < depth; i++) {
                        // If source and target are already being compared, consider them related with assumptions
                        if (maybeStack[i][id]) {
                            return 1 /* Maybe */;
                        }
                    }
                    if (depth === 100) {
                        overflow = true;
                        return 0 /* False */;
                    }
                }
                else {
                    sourceStack = [];
                    targetStack = [];
                    maybeStack = [];
                    expandingFlags = 0;
                }
                sourceStack[depth] = source;
                targetStack[depth] = target;
                maybeStack[depth] = ts.createMap();
                maybeStack[depth][id] = 1 /* Succeeded */;
                depth++;
                var saveExpandingFlags = expandingFlags;
                if (!(expandingFlags & 1) && isDeeplyNestedGeneric(source, sourceStack, depth))
                    expandingFlags |= 1;
                if (!(expandingFlags & 2) && isDeeplyNestedGeneric(target, targetStack, depth))
                    expandingFlags |= 2;
                var result;
                if (expandingFlags === 3) {
                    result = 1 /* Maybe */;
                }
                else if (isGenericMappedType(source) || isGenericMappedType(target)) {
                    result = mappedTypeRelatedTo(source, target, reportErrors);
                }
                else {
                    result = propertiesRelatedTo(source, target, reportErrors);
                    if (result) {
                        result &= signaturesRelatedTo(source, target, 0 /* Call */, reportErrors);
                        if (result) {
                            result &= signaturesRelatedTo(source, target, 1 /* Construct */, reportErrors);
                            if (result) {
                                result &= indexTypesRelatedTo(source, originalSource, target, 0 /* String */, reportErrors);
                                if (result) {
                                    result &= indexTypesRelatedTo(source, originalSource, target, 1 /* Number */, reportErrors);
                                }
                            }
                        }
                    }
                }
                expandingFlags = saveExpandingFlags;
                depth--;
                if (result) {
                    var maybeCache = maybeStack[depth];
                    // If result is definitely true, copy assumptions to global cache, else copy to next level up
                    var destinationCache = (result === -1 /* True */ || depth === 0) ? relation : maybeStack[depth - 1];
                    ts.copyProperties(maybeCache, destinationCache);
                }
                else {
                    // A false result goes straight into global cache (when something is false under assumptions it
                    // will also be false without assumptions)
                    relation[id] = reportErrors ? 3 /* FailedAndReported */ : 2 /* Failed */;
                }
                return result;
            }
            // A type [P in S]: X is related to a type [P in T]: Y if T is related to S and X is related to Y.
            function mappedTypeRelatedTo(source, target, reportErrors) {
                if (isGenericMappedType(target)) {
                    if (isGenericMappedType(source)) {
                        var result_2;
                        if (relation === identityRelation) {
                            var readonlyMatches = !source.declaration.readonlyToken === !target.declaration.readonlyToken;
                            var optionalMatches = !source.declaration.questionToken === !target.declaration.questionToken;
                            if (readonlyMatches && optionalMatches) {
                                if (result_2 = isRelatedTo(getConstraintTypeFromMappedType(target), getConstraintTypeFromMappedType(source), reportErrors)) {
                                    return result_2 & isRelatedTo(getErasedTemplateTypeFromMappedType(source), getErasedTemplateTypeFromMappedType(target), reportErrors);
                                }
                            }
                        }
                        else {
                            if (relation === comparableRelation || !source.declaration.questionToken || target.declaration.questionToken) {
                                if (result_2 = isRelatedTo(getConstraintTypeFromMappedType(target), getConstraintTypeFromMappedType(source), reportErrors)) {
                                    return result_2 & isRelatedTo(getTemplateTypeFromMappedType(source), getTemplateTypeFromMappedType(target), reportErrors);
                                }
                            }
                        }
                    }
                }
                else if (relation !== identityRelation) {
                    var resolved = resolveStructuredTypeMembers(target);
                    if (isEmptyObjectType(resolved) || resolved.stringIndexInfo && resolved.stringIndexInfo.type.flags & 1 /* Any */) {
                        return -1 /* True */;
                    }
                }
                return 0 /* False */;
            }
            function propertiesRelatedTo(source, target, reportErrors) {
                if (relation === identityRelation) {
                    return propertiesIdenticalTo(source, target);
                }
                var result = -1 /* True */;
                var properties = getPropertiesOfObjectType(target);
                var requireOptionalProperties = relation === subtypeRelation && !(getObjectFlags(source) & 128 /* ObjectLiteral */);
                for (var _i = 0, properties_3 = properties; _i < properties_3.length; _i++) {
                    var targetProp = properties_3[_i];
                    var sourceProp = getPropertyOfType(source, targetProp.name);
                    if (sourceProp !== targetProp) {
                        if (!sourceProp) {
                            if (!(targetProp.flags & 536870912 /* Optional */) || requireOptionalProperties) {
                                if (reportErrors) {
                                    reportError(ts.Diagnostics.Property_0_is_missing_in_type_1, symbolToString(targetProp), typeToString(source));
                                }
                                return 0 /* False */;
                            }
                        }
                        else if (!(targetProp.flags & 134217728 /* Prototype */)) {
                            var sourcePropFlags = getDeclarationModifierFlagsFromSymbol(sourceProp);
                            var targetPropFlags = getDeclarationModifierFlagsFromSymbol(targetProp);
                            if (sourcePropFlags & 8 /* Private */ || targetPropFlags & 8 /* Private */) {
                                if (sourceProp.valueDeclaration !== targetProp.valueDeclaration) {
                                    if (reportErrors) {
                                        if (sourcePropFlags & 8 /* Private */ && targetPropFlags & 8 /* Private */) {
                                            reportError(ts.Diagnostics.Types_have_separate_declarations_of_a_private_property_0, symbolToString(targetProp));
                                        }
                                        else {
                                            reportError(ts.Diagnostics.Property_0_is_private_in_type_1_but_not_in_type_2, symbolToString(targetProp), typeToString(sourcePropFlags & 8 /* Private */ ? source : target), typeToString(sourcePropFlags & 8 /* Private */ ? target : source));
                                        }
                                    }
                                    return 0 /* False */;
                                }
                            }
                            else if (targetPropFlags & 16 /* Protected */) {
                                var sourceDeclaredInClass = sourceProp.parent && sourceProp.parent.flags & 32 /* Class */;
                                var sourceClass = sourceDeclaredInClass ? getDeclaredTypeOfSymbol(getParentOfSymbol(sourceProp)) : undefined;
                                var targetClass = getDeclaredTypeOfSymbol(getParentOfSymbol(targetProp));
                                if (!sourceClass || !hasBaseType(sourceClass, targetClass)) {
                                    if (reportErrors) {
                                        reportError(ts.Diagnostics.Property_0_is_protected_but_type_1_is_not_a_class_derived_from_2, symbolToString(targetProp), typeToString(sourceClass || source), typeToString(targetClass));
                                    }
                                    return 0 /* False */;
                                }
                            }
                            else if (sourcePropFlags & 16 /* Protected */) {
                                if (reportErrors) {
                                    reportError(ts.Diagnostics.Property_0_is_protected_in_type_1_but_public_in_type_2, symbolToString(targetProp), typeToString(source), typeToString(target));
                                }
                                return 0 /* False */;
                            }
                            var related = isRelatedTo(getTypeOfSymbol(sourceProp), getTypeOfSymbol(targetProp), reportErrors);
                            if (!related) {
                                if (reportErrors) {
                                    reportError(ts.Diagnostics.Types_of_property_0_are_incompatible, symbolToString(targetProp));
                                }
                                return 0 /* False */;
                            }
                            result &= related;
                            // When checking for comparability, be more lenient with optional properties.
                            if (relation !== comparableRelation && sourceProp.flags & 536870912 /* Optional */ && !(targetProp.flags & 536870912 /* Optional */)) {
                                // TypeScript 1.0 spec (April 2014): 3.8.3
                                // S is a subtype of a type T, and T is a supertype of S if ...
                                // S' and T are object types and, for each member M in T..
                                // M is a property and S' contains a property N where
                                // if M is a required property, N is also a required property
                                // (M - property in T)
                                // (N - property in S)
                                if (reportErrors) {
                                    reportError(ts.Diagnostics.Property_0_is_optional_in_type_1_but_required_in_type_2, symbolToString(targetProp), typeToString(source), typeToString(target));
                                }
                                return 0 /* False */;
                            }
                        }
                    }
                }
                return result;
            }
            function propertiesIdenticalTo(source, target) {
                if (!(source.flags & 32768 /* Object */ && target.flags & 32768 /* Object */)) {
                    return 0 /* False */;
                }
                var sourceProperties = getPropertiesOfObjectType(source);
                var targetProperties = getPropertiesOfObjectType(target);
                if (sourceProperties.length !== targetProperties.length) {
                    return 0 /* False */;
                }
                var result = -1 /* True */;
                for (var _i = 0, sourceProperties_1 = sourceProperties; _i < sourceProperties_1.length; _i++) {
                    var sourceProp = sourceProperties_1[_i];
                    var targetProp = getPropertyOfObjectType(target, sourceProp.name);
                    if (!targetProp) {
                        return 0 /* False */;
                    }
                    var related = compareProperties(sourceProp, targetProp, isRelatedTo);
                    if (!related) {
                        return 0 /* False */;
                    }
                    result &= related;
                }
                return result;
            }
            function signaturesRelatedTo(source, target, kind, reportErrors) {
                if (relation === identityRelation) {
                    return signaturesIdenticalTo(source, target, kind);
                }
                if (target === anyFunctionType || source === anyFunctionType) {
                    return -1 /* True */;
                }
                var sourceSignatures = getSignaturesOfType(source, kind);
                var targetSignatures = getSignaturesOfType(target, kind);
                if (kind === 1 /* Construct */ && sourceSignatures.length && targetSignatures.length) {
                    if (isAbstractConstructorType(source) && !isAbstractConstructorType(target)) {
                        // An abstract constructor type is not assignable to a non-abstract constructor type
                        // as it would otherwise be possible to new an abstract class. Note that the assignability
                        // check we perform for an extends clause excludes construct signatures from the target,
                        // so this check never proceeds.
                        if (reportErrors) {
                            reportError(ts.Diagnostics.Cannot_assign_an_abstract_constructor_type_to_a_non_abstract_constructor_type);
                        }
                        return 0 /* False */;
                    }
                    if (!constructorVisibilitiesAreCompatible(sourceSignatures[0], targetSignatures[0], reportErrors)) {
                        return 0 /* False */;
                    }
                }
                var result = -1 /* True */;
                var saveErrorInfo = errorInfo;
                outer: for (var _i = 0, targetSignatures_1 = targetSignatures; _i < targetSignatures_1.length; _i++) {
                    var t = targetSignatures_1[_i];
                    // Only elaborate errors from the first failure
                    var shouldElaborateErrors = reportErrors;
                    for (var _a = 0, sourceSignatures_1 = sourceSignatures; _a < sourceSignatures_1.length; _a++) {
                        var s = sourceSignatures_1[_a];
                        var related = signatureRelatedTo(s, t, shouldElaborateErrors);
                        if (related) {
                            result &= related;
                            errorInfo = saveErrorInfo;
                            continue outer;
                        }
                        shouldElaborateErrors = false;
                    }
                    if (shouldElaborateErrors) {
                        reportError(ts.Diagnostics.Type_0_provides_no_match_for_the_signature_1, typeToString(source), signatureToString(t, /*enclosingDeclaration*/ undefined, /*flags*/ undefined, kind));
                    }
                    return 0 /* False */;
                }
                return result;
            }
            /**
             * See signatureAssignableTo, compareSignaturesIdentical
             */
            function signatureRelatedTo(source, target, reportErrors) {
                return compareSignaturesRelated(source, target, /*ignoreReturnTypes*/ false, reportErrors, reportError, isRelatedTo);
            }
            function signaturesIdenticalTo(source, target, kind) {
                var sourceSignatures = getSignaturesOfType(source, kind);
                var targetSignatures = getSignaturesOfType(target, kind);
                if (sourceSignatures.length !== targetSignatures.length) {
                    return 0 /* False */;
                }
                var result = -1 /* True */;
                for (var i = 0, len = sourceSignatures.length; i < len; i++) {
                    var related = compareSignaturesIdentical(sourceSignatures[i], targetSignatures[i], /*partialMatch*/ false, /*ignoreThisTypes*/ false, /*ignoreReturnTypes*/ false, isRelatedTo);
                    if (!related) {
                        return 0 /* False */;
                    }
                    result &= related;
                }
                return result;
            }
            function eachPropertyRelatedTo(source, target, kind, reportErrors) {
                var result = -1 /* True */;
                for (var _i = 0, _a = getPropertiesOfObjectType(source); _i < _a.length; _i++) {
                    var prop = _a[_i];
                    if (kind === 0 /* String */ || isNumericLiteralName(prop.name)) {
                        var related = isRelatedTo(getTypeOfSymbol(prop), target, reportErrors);
                        if (!related) {
                            if (reportErrors) {
                                reportError(ts.Diagnostics.Property_0_is_incompatible_with_index_signature, symbolToString(prop));
                            }
                            return 0 /* False */;
                        }
                        result &= related;
                    }
                }
                return result;
            }
            function indexInfoRelatedTo(sourceInfo, targetInfo, reportErrors) {
                var related = isRelatedTo(sourceInfo.type, targetInfo.type, reportErrors);
                if (!related && reportErrors) {
                    reportError(ts.Diagnostics.Index_signatures_are_incompatible);
                }
                return related;
            }
            function indexTypesRelatedTo(source, originalSource, target, kind, reportErrors) {
                if (relation === identityRelation) {
                    return indexTypesIdenticalTo(source, target, kind);
                }
                var targetInfo = getIndexInfoOfType(target, kind);
                if (!targetInfo || ((targetInfo.type.flags & 1 /* Any */) && !(originalSource.flags & 8190 /* Primitive */))) {
                    // Index signature of type any permits assignment from everything but primitives
                    return -1 /* True */;
                }
                var sourceInfo = getIndexInfoOfType(source, kind) ||
                    kind === 1 /* Number */ && getIndexInfoOfType(source, 0 /* String */);
                if (sourceInfo) {
                    return indexInfoRelatedTo(sourceInfo, targetInfo, reportErrors);
                }
                if (isObjectLiteralType(source)) {
                    var related = -1 /* True */;
                    if (kind === 0 /* String */) {
                        var sourceNumberInfo = getIndexInfoOfType(source, 1 /* Number */);
                        if (sourceNumberInfo) {
                            related = indexInfoRelatedTo(sourceNumberInfo, targetInfo, reportErrors);
                        }
                    }
                    if (related) {
                        related &= eachPropertyRelatedTo(source, targetInfo.type, kind, reportErrors);
                    }
                    return related;
                }
                if (reportErrors) {
                    reportError(ts.Diagnostics.Index_signature_is_missing_in_type_0, typeToString(source));
                }
                return 0 /* False */;
            }
            function indexTypesIdenticalTo(source, target, indexKind) {
                var targetInfo = getIndexInfoOfType(target, indexKind);
                var sourceInfo = getIndexInfoOfType(source, indexKind);
                if (!sourceInfo && !targetInfo) {
                    return -1 /* True */;
                }
                if (sourceInfo && targetInfo && sourceInfo.isReadonly === targetInfo.isReadonly) {
                    return isRelatedTo(sourceInfo.type, targetInfo.type);
                }
                return 0 /* False */;
            }
            function constructorVisibilitiesAreCompatible(sourceSignature, targetSignature, reportErrors) {
                if (!sourceSignature.declaration || !targetSignature.declaration) {
                    return true;
                }
                var sourceAccessibility = ts.getModifierFlags(sourceSignature.declaration) & 24 /* NonPublicAccessibilityModifier */;
                var targetAccessibility = ts.getModifierFlags(targetSignature.declaration) & 24 /* NonPublicAccessibilityModifier */;
                // A public, protected and private signature is assignable to a private signature.
                if (targetAccessibility === 8 /* Private */) {
                    return true;
                }
                // A public and protected signature is assignable to a protected signature.
                if (targetAccessibility === 16 /* Protected */ && sourceAccessibility !== 8 /* Private */) {
                    return true;
                }
                // Only a public signature is assignable to public signature.
                if (targetAccessibility !== 16 /* Protected */ && !sourceAccessibility) {
                    return true;
                }
                if (reportErrors) {
                    reportError(ts.Diagnostics.Cannot_assign_a_0_constructor_type_to_a_1_constructor_type, visibilityToString(sourceAccessibility), visibilityToString(targetAccessibility));
                }
                return false;
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkInheritedPropertiesAreIdentical) id{488,0} ---
(type, typeNode) {
            var baseTypes = getBaseTypes(type);
            if (baseTypes.length < 2) {
                return true;
            }
            var seen = ts.createMap();
            ts.forEach(resolveDeclaredMembers(type).declaredProperties, function (p) { seen[p.name] = { prop: p, containingType: type }; });
            var ok = true;
            for (var _i = 0, baseTypes_2 = baseTypes; _i < baseTypes_2.length; _i++) {
                var base = baseTypes_2[_i];
                var properties = getPropertiesOfObjectType(getTypeWithThisArgument(base, type.thisType));
                for (var _a = 0, properties_7 = properties; _a < properties_7.length; _a++) {
                    var prop = properties_7[_a];
                    var existing = seen[prop.name];
                    if (!existing) {
                        seen[prop.name] = { prop: prop, containingType: base };
                    }
                    else {
                        var isInheritedProperty = existing.containingType !== type;
                        if (isInheritedProperty && !isPropertyIdenticalTo(existing.prop, prop)) {
                            ok = false;
                            var typeName1 = typeToString(existing.containingType);
                            var typeName2 = typeToString(base);
                            var errorInfo = ts.chainDiagnosticMessages(undefined, ts.Diagnostics.Named_property_0_of_types_1_and_2_are_not_identical, symbolToString(prop), typeName1, typeName2);
                            errorInfo = ts.chainDiagnosticMessages(errorInfo, ts.Diagnostics.Interface_0_cannot_simultaneously_extend_types_1_and_2, typeToString(type), typeName1, typeName2);
                            diagnostics.add(ts.createDiagnosticForNodeFromMessageChain(typeNode, errorInfo));
                        }
                    }
                }
            }
            return ok;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveDeclaredMembers) id{488,1} ---
(type) {
            if (!type.declaredProperties) {
                var symbol = type.symbol;
                type.declaredProperties = getNamedMembers(symbol.members);
                type.declaredCallSignatures = getSignaturesOfSymbol(symbol.members["__call"]);
                type.declaredConstructSignatures = getSignaturesOfSymbol(symbol.members["__new"]);
                type.declaredStringIndexInfo = getIndexInfoOfSymbol(symbol, 0 /* String */);
                type.declaredNumberIndexInfo = getIndexInfoOfSymbol(symbol, 1 /* Number */);
            }
            return type;
        }
--- END ---
INLINE (resolveDeclaredMembers) id{488,1} AS 1 AT <0:212>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNamedMembers) id{488,2} ---
(members) {
            var result;
            for (var id in members) {
                if (!isReservedMemberName(id)) {
                    if (!result)
                        result = [];
                    var symbol = members[id];
                    if (symbolIsValue(symbol)) {
                        result.push(symbol);
                    }
                }
            }
            return result || emptyArray;
        }
--- END ---
INLINE (getNamedMembers) id{488,2} AS 2 AT <1:137>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isReservedMemberName) id{488,3} ---
(name) {
            return name.charCodeAt(0) === 95 /* _ */ &&
                name.charCodeAt(1) === 95 /* _ */ &&
                name.charCodeAt(2) !== 95 /* _ */ &&
                name.charCodeAt(2) !== 64 /* at */;
        }
--- END ---
INLINE (isReservedMemberName) id{488,3} AS 3 AT <2:95>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexInfoOfSymbol) id{488,4} ---
(symbol, kind) {
            var declaration = getIndexDeclarationOfSymbol(symbol, kind);
            if (declaration) {
                return createIndexInfo(declaration.type ? getTypeFromTypeNode(declaration.type) : anyType, (ts.getModifierFlags(declaration) & 64 /* Readonly */) !== 0, declaration);
            }
            return undefined;
        }
--- END ---
INLINE (getIndexInfoOfSymbol) id{488,4} AS 4 AT <1:411>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createIndexInfo) id{488,5} ---
(type, isReadonly, declaration) {
            return { type: type, isReadonly: isReadonly, declaration: declaration };
        }
--- END ---
INLINE (createIndexInfo) id{488,5} AS 5 AT <4:144>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexInfoOfSymbol) id{488,6} ---
(symbol, kind) {
            var declaration = getIndexDeclarationOfSymbol(symbol, kind);
            if (declaration) {
                return createIndexInfo(declaration.type ? getTypeFromTypeNode(declaration.type) : anyType, (ts.getModifierFlags(declaration) & 64 /* Readonly */) !== 0, declaration);
            }
            return undefined;
        }
--- END ---
INLINE (getIndexInfoOfSymbol) id{488,6} AS 6 AT <1:504>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createIndexInfo) id{488,7} ---
(type, isReadonly, declaration) {
            return { type: type, isReadonly: isReadonly, declaration: declaration };
        }
--- END ---
INLINE (createIndexInfo) id{488,7} AS 7 AT <6:144>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeWithThisArgument) id{488,8} ---
(type, thisArgument) {
            if (getObjectFlags(type) & 4 /* Reference */) {
                return createTypeReference(type.target, ts.concatenate(type.typeArguments, [thisArgument || type.target.thisType]));
            }
            return type;
        }
--- END ---
INLINE (getTypeWithThisArgument) id{488,8} AS 8 AT <0:547>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{488,9} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{488,9} AS 9 AT <8:39>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createTypeReference) id{488,10} ---
(target, typeArguments) {
            var id = getTypeListId(typeArguments);
            var type = target.instantiations[id];
            if (!type) {
                type = target.instantiations[id] = createObjectType(4 /* Reference */, target.symbol);
                type.flags |= typeArguments ? getPropagatingFlagsOfTypes(typeArguments, /*excludeKinds*/ 0) : 0;
                type.target = target;
                type.typeArguments = typeArguments;
            }
            return type;
        }
--- END ---
INLINE (createTypeReference) id{488,10} AS 10 AT <8:106>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createObjectType) id{488,11} ---
(objectFlags, symbol) {
            var type = createType(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol = symbol;
            return type;
        }
--- END ---
INLINE (createObjectType) id{488,11} AS 11 AT <10:203>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{488,12} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{488,12} AS 12 AT <11:47>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{488,13} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{488,13} AS 13 AT <12:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropagatingFlagsOfTypes) id{488,14} ---
(types, excludeKinds) {
            var result = 0;
            for (var _i = 0, types_3 = types; _i < types_3.length; _i++) {
                var type = types_3[_i];
                if (!(type.flags & excludeKinds)) {
                    result |= type.flags;
                }
            }
            return result & 14680064 /* PropagatingFlags */;
        }
--- END ---
INLINE (getPropagatingFlagsOfTypes) id{488,14} AS 14 AT <10:301>
[deoptimizing (DEOPT eager): begin 0x1030c9d455f1 <JS Function isIndependentMember (SharedFunctionInfo 0x2e2f693ee851)> (opt #358) @2, FP to SP delta: 72, caller sp: 0x7fff5fbfdc30]
            ;;; deoptimize at 0_33: wrong map
  reading input frame isIndependentMember => node=4, args=2, height=3; inputs:
      0: 0x1030c9d455f1 ; [fp - 16] 0x1030c9d455f1 <JS Function isIndependentMember (SharedFunctionInfo 0x2e2f693ee851)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x17ddd8438889 ; rax 0x17ddd8438889 <a SymbolObject with map 0x33abe2a73229>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
      5: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
  translating frame isIndependentMember => node=4, height=16
    0x7fff5fbfdc28: [top + 56] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdc20: [top + 48] <- 0x17ddd8438889 ;  0x17ddd8438889 <a SymbolObject with map 0x33abe2a73229>  (input #2)
    0x7fff5fbfdc18: [top + 40] <- 0x2c21d262ec40 ;  caller's pc
    0x7fff5fbfdc10: [top + 32] <- 0x7fff5fbfdc78 ;  caller's fp
    0x7fff5fbfdc08: [top + 24] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdc00: [top + 16] <- 0x1030c9d455f1 ;  function    0x1030c9d455f1 <JS Function isIndependentMember (SharedFunctionInfo 0x2e2f693ee851)>  (input #0)
    0x7fff5fbfdbf8: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfdbf0: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
[deoptimizing (eager): end 0x1030c9d455f1 <JS Function isIndependentMember (SharedFunctionInfo 0x2e2f693ee851)> @2 => node=4, pc=0x2c21d2631f2c, caller sp=0x7fff5fbfdc30, state=NO_REGISTERS, took 0.092 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexType) id{489,0} ---
(type) {
            return maybeTypeOfKind(type, 540672 /* TypeVariable */) ? getIndexTypeForGenericType(type) :
                getObjectFlags(type) & 32 /* Mapped */ ? getConstraintTypeFromMappedType(type) :
                    type.flags & 1 /* Any */ || getIndexInfoOfType(type, 0 /* String */) ? stringType :
                        getLiteralTypeFromPropertyNames(type);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:maybeTypeOfKind) id{489,1} ---
(type, kind) {
            if (type.flags & kind) {
                return true;
            }
            if (type.flags & 196608 /* UnionOrIntersection */) {
                var types = type.types;
                for (var _i = 0, types_15 = types; _i < types_15.length; _i++) {
                    var t = types_15[_i];
                    if (maybeTypeOfKind(t, kind)) {
                        return true;
                    }
                }
            }
            return false;
        }
--- END ---
INLINE (maybeTypeOfKind) id{489,1} AS 1 AT <0:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexTypeForGenericType) id{489,2} ---
(type) {
            if (!type.resolvedIndexType) {
                type.resolvedIndexType = createType(262144 /* Index */);
                type.resolvedIndexType.type = type;
            }
            return type.resolvedIndexType;
        }
--- END ---
INLINE (getIndexTypeForGenericType) id{489,2} AS 2 AT <0:79>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{489,3} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{489,3} AS 3 AT <2:93>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{489,4} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{489,4} AS 4 AT <3:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{489,5} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{489,5} AS 5 AT <0:130>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexInfoOfType) id{489,6} ---
(type, kind) {
            return getIndexInfoOfStructuredType(getApparentType(type), kind);
        }
--- END ---
INLINE (getIndexInfoOfType) id{489,6} AS 6 AT <0:259>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getApparentType) id{489,7} ---
(type) {
            var t = type.flags & 540672 /* TypeVariable */ ? getApparentTypeOfTypeVariable(type) : type;
            return t.flags & 262178 /* StringLike */ ? globalStringType :
                t.flags & 340 /* NumberLike */ ? globalNumberType :
                    t.flags & 136 /* BooleanLike */ ? globalBooleanType :
                        t.flags & 512 /* ESSymbol */ ? getGlobalESSymbolType() :
                            t;
        }
--- END ---
INLINE (getApparentType) id{489,7} AS 7 AT <6:63>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexInfoOfStructuredType) id{489,8} ---
(type, kind) {
            if (type.flags & 229376 /* StructuredType */) {
                var resolved = resolveStructuredTypeMembers(type);
                return kind === 0 /* String */ ? resolved.stringIndexInfo : resolved.numberIndexInfo;
            }
        }
--- END ---
INLINE (getIndexInfoOfStructuredType) id{489,8} AS 8 AT <6:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getLiteralTypeFromPropertyNames) id{489,9} ---
(type) {
            return getUnionType(ts.map(getPropertiesOfType(type), getLiteralTypeFromPropertyName));
        }
--- END ---
INLINE (getLiteralTypeFromPropertyNames) id{489,9} AS 9 AT <0:339>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropertiesOfType) id{489,10} ---
(type) {
            type = getApparentType(type);
            return type.flags & 196608 /* UnionOrIntersection */ ?
                getPropertiesOfUnionOrIntersectionType(type) :
                getPropertiesOfObjectType(type);
        }
--- END ---
INLINE (getPropertiesOfType) id{489,10} AS 10 AT <9:48>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getApparentType) id{489,11} ---
(type) {
            var t = type.flags & 540672 /* TypeVariable */ ? getApparentTypeOfTypeVariable(type) : type;
            return t.flags & 262178 /* StringLike */ ? globalStringType :
                t.flags & 340 /* NumberLike */ ? globalNumberType :
                    t.flags & 136 /* BooleanLike */ ? globalBooleanType :
                        t.flags & 512 /* ESSymbol */ ? getGlobalESSymbolType() :
                            t;
        }
--- END ---
INLINE (getApparentType) id{489,11} AS 11 AT <10:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropertiesOfObjectType) id{489,12} ---
(type) {
            if (type.flags & 32768 /* Object */) {
                return resolveStructuredTypeMembers(type).properties;
            }
            return emptyArray;
        }
--- END ---
INLINE (getPropertiesOfObjectType) id{489,12} AS 12 AT <10:197>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:signatureRelatedTo) id{490,0} ---
(source, target, reportErrors) {
                return compareSignaturesRelated(source, target, /*ignoreReturnTypes*/ false, reportErrors, reportError, isRelatedTo);
            }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:containsType) id{491,0} ---
(types, type) {
            return binarySearchTypes(types, type) >= 0;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:binarySearchTypes) id{491,1} ---
(types, type) {
            var low = 0;
            var high = types.length - 1;
            var typeId = type.id;
            while (low <= high) {
                var middle = low + ((high - low) >> 1);
                var id = types[middle].id;
                if (id === typeId) {
                    return middle;
                }
                else if (id > typeId) {
                    high = middle - 1;
                }
                else {
                    low = middle + 1;
                }
            }
            return ~low;
        }
--- END ---
INLINE (binarySearchTypes) id{491,1} AS 1 AT <0:35>
[deoptimizing (DEOPT soft): begin 0x1030c9d55f99 <JS Function getNumParametersToCheckForSignatureRelatability (SharedFunctionInfo 0x2e2f693f7801)> (opt #474) @6, FP to SP delta: 24, caller sp: 0x7fff5fbfd768]
            ;;; deoptimize at 0_712: Insufficient type feedback for generic named access
  reading input frame getNumParametersToCheckForSignatureRelatability => node=7, args=5, height=1; inputs:
      0: 0x1030c9d55f99 ; [fp - 16] 0x1030c9d55f99 <JS Function getNumParametersToCheckForSignatureRelatability (SharedFunctionInfo 0x2e2f693f7801)>
      1: 0x1f9f6c0532e1 ; [fp + 48] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x3d4479c4a6c1 ; [fp + 40] 0x3d4479c4a6c1 <a SignatureObject with map 0x33abe2a6d7c1>
      3: 0x100000000 ; [fp + 32] 1
      4: 0x3d4479c4a431 ; [fp + 24] 0x3d4479c4a431 <a SignatureObject with map 0x33abe2a6d7c1>
      5: 0x00000000 ; [fp + 16] 0
      6: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
  translating frame getNumParametersToCheckForSignatureRelatability => node=7, height=0
    0x7fff5fbfd760: [top + 64] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd758: [top + 56] <- 0x3d4479c4a6c1 ;  0x3d4479c4a6c1 <a SignatureObject with map 0x33abe2a6d7c1>  (input #2)
    0x7fff5fbfd750: [top + 48] <- 0x100000000 ;  1  (input #3)
    0x7fff5fbfd748: [top + 40] <- 0x3d4479c4a431 ;  0x3d4479c4a431 <a SignatureObject with map 0x33abe2a6d7c1>  (input #4)
    0x7fff5fbfd740: [top + 32] <- 0x00000000 ;  0  (input #5)
    0x7fff5fbfd738: [top + 24] <- 0x2c21d269c2ca ;  caller's pc
    0x7fff5fbfd730: [top + 16] <- 0x7fff5fbfd7f0 ;  caller's fp
    0x7fff5fbfd728: [top + 8] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #6)
    0x7fff5fbfd720: [top + 0] <- 0x1030c9d55f99 ;  function    0x1030c9d55f99 <JS Function getNumParametersToCheckForSignatureRelatability (SharedFunctionInfo 0x2e2f693f7801)>  (input #0)
[deoptimizing (soft): end 0x1030c9d55f99 <JS Function getNumParametersToCheckForSignatureRelatability (SharedFunctionInfo 0x2e2f693f7801)> @6 => node=7, pc=0x2c21d269d99a, caller sp=0x7fff5fbfd768, state=NO_REGISTERS, took 0.075 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isTypeRelatedTo) id{492,0} ---
(source, target, relation) {
            if (source.flags & 96 /* StringOrNumberLiteral */ && source.flags & 1048576 /* FreshLiteral */) {
                source = source.regularType;
            }
            if (target.flags & 96 /* StringOrNumberLiteral */ && target.flags & 1048576 /* FreshLiteral */) {
                target = target.regularType;
            }
            if (source === target || relation !== identityRelation && isSimpleTypeRelatedTo(source, target, relation)) {
                return true;
            }
            if (source.flags & 32768 /* Object */ && target.flags & 32768 /* Object */) {
                var id = relation !== identityRelation || source.id < target.id ? source.id + "," + target.id : target.id + "," + source.id;
                var related = relation[id];
                if (related !== undefined) {
                    return related === 1 /* Succeeded */;
                }
            }
            if (source.flags & 507904 /* StructuredOrTypeParameter */ || target.flags & 507904 /* StructuredOrTypeParameter */) {
                return checkTypeRelatedTo(source, target, relation, undefined, undefined, undefined);
            }
            return false;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkIndexConstraintForProperty) id{493,0} ---
(prop, propertyType, containingType, indexDeclaration, indexType, indexKind) {
                if (!indexType) {
                    return;
                }
                // index is numeric and property name is not valid numeric literal
                if (indexKind === 1 /* Number */ && !isNumericName(prop.valueDeclaration.name)) {
                    return;
                }
                // perform property check if property or indexer is declared in 'type'
                // this allows to rule out cases when both property and indexer are inherited from the base class
                var errorNode;
                if (prop.valueDeclaration.name.kind === 142 /* ComputedPropertyName */ || prop.parent === containingType.symbol) {
                    errorNode = prop.valueDeclaration;
                }
                else if (indexDeclaration) {
                    errorNode = indexDeclaration;
                }
                else if (getObjectFlags(containingType) & 2 /* Interface */) {
                    // for interfaces property and indexer might be inherited from different bases
                    // check if any base class already has both property and indexer.
                    // check should be performed only if 'type' is the first type that brings property\x5cindexer together
                    var someBaseClassHasBothPropertyAndIndexer = ts.forEach(getBaseTypes(containingType), function (base) { return getPropertyOfObjectType(base, prop.name) && getIndexTypeOfType(base, indexKind); });
                    errorNode = someBaseClassHasBothPropertyAndIndexer ? undefined : containingType.symbol.declarations[0];
                }
                if (errorNode && !isTypeAssignableTo(propertyType, indexType)) {
                    var errorMessage = indexKind === 0 /* String */
                        ? ts.Diagnostics.Property_0_of_type_1_is_not_assignable_to_string_index_type_2
                        : ts.Diagnostics.Property_0_of_type_1_is_not_assignable_to_numeric_index_type_2;
                    error(errorNode, errorMessage, symbolToString(prop), typeToString(propertyType), typeToString(indexType));
                }
            }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isNumericName) id{493,1} ---
(name) {
            return name.kind === 142 /* ComputedPropertyName */ ? isNumericComputedName(name) : isNumericLiteralName(name.text);
        }
--- END ---
INLINE (isNumericName) id{493,1} AS 1 AT <0:295>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isTypeAssignableTo) id{493,2} ---
(source, target) {
            return isTypeRelatedTo(source, target, assignableRelation);
        }
--- END ---
INLINE (isTypeAssignableTo) id{493,2} AS 2 AT <0:1711>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:eachTypeRelatedToType) id{494,0} ---
(source, target, reportErrors) {
                var result = -1 /* True */;
                var sourceTypes = source.types;
                for (var _i = 0, sourceTypes_2 = sourceTypes; _i < sourceTypes_2.length; _i++) {
                    var sourceType = sourceTypes_2[_i];
                    var related = isRelatedTo(sourceType, target, reportErrors);
                    if (!related) {
                        return 0 /* False */;
                    }
                    result &= related;
                }
                return result;
            }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:) id{495,0} ---
(t) { return t === source ? target : t; }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isTypeAnyOrAllConstituentTypesHaveKind) id{496,0} ---
(type, kind) {
            return isTypeAny(type) || isTypeOfKind(type, kind);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isTypeAny) id{496,1} ---
(type) {
            return type && (type.flags & 1 /* Any */) !== 0;
        }
--- END ---
INLINE (isTypeAny) id{496,1} AS 1 AT <0:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveAnonymousTypeMembers) id{497,0} ---
(type) {
            var symbol = type.symbol;
            if (type.target) {
                var members = createInstantiatedSymbolTable(getPropertiesOfObjectType(type.target), type.mapper, /*mappingThisOnly*/ false);
                var callSignatures = instantiateSignatures(getSignaturesOfType(type.target, 0 /* Call */), type.mapper);
                var constructSignatures = instantiateSignatures(getSignaturesOfType(type.target, 1 /* Construct */), type.mapper);
                var stringIndexInfo = instantiateIndexInfo(getIndexInfoOfType(type.target, 0 /* String */), type.mapper);
                var numberIndexInfo = instantiateIndexInfo(getIndexInfoOfType(type.target, 1 /* Number */), type.mapper);
                setStructuredTypeMembers(type, members, callSignatures, constructSignatures, stringIndexInfo, numberIndexInfo);
            }
            else if (symbol.flags & 2048 /* TypeLiteral */) {
                var members = symbol.members;
                var callSignatures = getSignaturesOfSymbol(members["__call"]);
                var constructSignatures = getSignaturesOfSymbol(members["__new"]);
                var stringIndexInfo = getIndexInfoOfSymbol(symbol, 0 /* String */);
                var numberIndexInfo = getIndexInfoOfSymbol(symbol, 1 /* Number */);
                setStructuredTypeMembers(type, members, callSignatures, constructSignatures, stringIndexInfo, numberIndexInfo);
            }
            else {
                // Combinations of function, class, enum and module
                var members = emptySymbols;
                var constructSignatures = emptyArray;
                if (symbol.flags & 1952 /* HasExports */) {
                    members = getExportsOfSymbol(symbol);
                }
                if (symbol.flags & 32 /* Class */) {
                    var classType = getDeclaredTypeOfClassOrInterface(symbol);
                    constructSignatures = getSignaturesOfSymbol(symbol.members["__constructor"]);
                    if (!constructSignatures.length) {
                        constructSignatures = getDefaultConstructSignatures(classType);
                    }
                    var baseConstructorType = getBaseConstructorTypeOfClass(classType);
                    if (baseConstructorType.flags & 32768 /* Object */) {
                        members = createSymbolTable(getNamedMembers(members));
                        addInheritedMembers(members, getPropertiesOfObjectType(baseConstructorType));
                    }
                }
                var numberIndexInfo = symbol.flags & 384 /* Enum */ ? enumNumberIndexInfo : undefined;
                setStructuredTypeMembers(type, members, emptyArray, constructSignatures, undefined, numberIndexInfo);
                // We resolve the members before computing the signatures because a signature may use
                // typeof with a qualified name expression that circularly references the type we are
                // in the process of resolving (see issue #6072). The temporarily empty signature list
                // will never be observed because a qualified name can't reference signatures.
                if (symbol.flags & (16 /* Function */ | 8192 /* Method */)) {
                    type.callSignatures = getSignaturesOfSymbol(symbol);
                }
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropertiesOfObjectType) id{497,1} ---
(type) {
            if (type.flags & 32768 /* Object */) {
                return resolveStructuredTypeMembers(type).properties;
            }
            return emptyArray;
        }
--- END ---
INLINE (getPropertiesOfObjectType) id{497,1} AS 1 AT <0:138>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createInstantiatedSymbolTable) id{497,2} ---
(symbols, mapper, mappingThisOnly) {
            var result = ts.createMap();
            for (var _i = 0, symbols_2 = symbols; _i < symbols_2.length; _i++) {
                var symbol = symbols_2[_i];
                result[symbol.name] = mappingThisOnly && isIndependentMember(symbol) ? symbol : instantiateSymbol(symbol, mapper);
            }
            return result;
        }
--- END ---
INLINE (createInstantiatedSymbolTable) id{497,2} AS 2 AT <0:108>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSignaturesOfType) id{497,3} ---
(type, kind) {
            return getSignaturesOfStructuredType(getApparentType(type), kind);
        }
--- END ---
INLINE (getSignaturesOfType) id{497,3} AS 3 AT <0:278>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getApparentType) id{497,4} ---
(type) {
            var t = type.flags & 540672 /* TypeVariable */ ? getApparentTypeOfTypeVariable(type) : type;
            return t.flags & 262178 /* StringLike */ ? globalStringType :
                t.flags & 340 /* NumberLike */ ? globalNumberType :
                    t.flags & 136 /* BooleanLike */ ? globalBooleanType :
                        t.flags & 512 /* ESSymbol */ ? getGlobalESSymbolType() :
                            t;
        }
--- END ---
INLINE (getApparentType) id{497,4} AS 4 AT <3:64>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSignaturesOfStructuredType) id{497,5} ---
(type, kind) {
            if (type.flags & 229376 /* StructuredType */) {
                var resolved = resolveStructuredTypeMembers(type);
                return kind === 0 /* Call */ ? resolved.callSignatures : resolved.constructSignatures;
            }
            return emptyArray;
        }
--- END ---
INLINE (getSignaturesOfStructuredType) id{497,5} AS 5 AT <3:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateSignatures) id{497,6} ---
(signatures, mapper) {
            return instantiateList(signatures, mapper, instantiateSignature);
        }
--- END ---
INLINE (instantiateSignatures) id{497,6} AS 6 AT <0:256>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateList) id{497,7} ---
(items, mapper, instantiator) {
            if (items && items.length) {
                var result = [];
                for (var _i = 0, items_1 = items; _i < items_1.length; _i++) {
                    var v = items_1[_i];
                    result.push(instantiator(v, mapper));
                }
                return result;
            }
            return items;
        }
--- END ---
INLINE (instantiateList) id{497,7} AS 7 AT <6:42>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSignaturesOfType) id{497,8} ---
(type, kind) {
            return getSignaturesOfStructuredType(getApparentType(type), kind);
        }
--- END ---
INLINE (getSignaturesOfType) id{497,8} AS 8 AT <0:404>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getApparentType) id{497,9} ---
(type) {
            var t = type.flags & 540672 /* TypeVariable */ ? getApparentTypeOfTypeVariable(type) : type;
            return t.flags & 262178 /* StringLike */ ? globalStringType :
                t.flags & 340 /* NumberLike */ ? globalNumberType :
                    t.flags & 136 /* BooleanLike */ ? globalBooleanType :
                        t.flags & 512 /* ESSymbol */ ? getGlobalESSymbolType() :
                            t;
        }
--- END ---
INLINE (getApparentType) id{497,9} AS 9 AT <8:64>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSignaturesOfStructuredType) id{497,10} ---
(type, kind) {
            if (type.flags & 229376 /* StructuredType */) {
                var resolved = resolveStructuredTypeMembers(type);
                return kind === 0 /* Call */ ? resolved.callSignatures : resolved.constructSignatures;
            }
            return emptyArray;
        }
--- END ---
INLINE (getSignaturesOfStructuredType) id{497,10} AS 10 AT <8:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateSignatures) id{497,11} ---
(signatures, mapper) {
            return instantiateList(signatures, mapper, instantiateSignature);
        }
--- END ---
INLINE (instantiateSignatures) id{497,11} AS 11 AT <0:382>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateList) id{497,12} ---
(items, mapper, instantiator) {
            if (items && items.length) {
                var result = [];
                for (var _i = 0, items_1 = items; _i < items_1.length; _i++) {
                    var v = items_1[_i];
                    result.push(instantiator(v, mapper));
                }
                return result;
            }
            return items;
        }
--- END ---
INLINE (instantiateList) id{497,12} AS 12 AT <11:42>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexInfoOfType) id{497,13} ---
(type, kind) {
            return getIndexInfoOfStructuredType(getApparentType(type), kind);
        }
--- END ---
INLINE (getIndexInfoOfType) id{497,13} AS 13 AT <0:530>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getApparentType) id{497,14} ---
(type) {
            var t = type.flags & 540672 /* TypeVariable */ ? getApparentTypeOfTypeVariable(type) : type;
            return t.flags & 262178 /* StringLike */ ? globalStringType :
                t.flags & 340 /* NumberLike */ ? globalNumberType :
                    t.flags & 136 /* BooleanLike */ ? globalBooleanType :
                        t.flags & 512 /* ESSymbol */ ? getGlobalESSymbolType() :
                            t;
        }
--- END ---
INLINE (getApparentType) id{497,14} AS 14 AT <13:63>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkTypeParameter) id{498,0} ---
(node) {
            // Grammar Checking
            if (node.expression) {
                grammarErrorOnFirstToken(node.expression, ts.Diagnostics.Type_expected);
            }
            checkSourceElement(node.constraint);
            getConstraintOfTypeParameter(getDeclaredTypeOfTypeParameter(getSymbolOfNode(node)));
            if (produceDiagnostics) {
                checkTypeNameIsReserved(node.name, ts.Diagnostics.Type_parameter_name_cannot_be_0);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{498,1} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{498,1} AS 1 AT <0:300>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{498,2} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{498,2} AS 2 AT <1:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getDeclaredTypeOfTypeParameter) id{498,3} ---
(symbol) {
            var links = getSymbolLinks(symbol);
            if (!links.declaredType) {
                var type = createType(16384 /* TypeParameter */);
                type.symbol = symbol;
                if (!ts.getDeclarationOfKind(symbol, 143 /* TypeParameter */).constraint) {
                    type.constraint = noConstraintType;
                }
                links.declaredType = type;
            }
            return links.declaredType;
        }
--- END ---
INLINE (getDeclaredTypeOfTypeParameter) id{498,3} AS 3 AT <0:269>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{498,4} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{498,4} AS 4 AT <3:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{498,5} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{498,5} AS 5 AT <4:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{498,6} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{498,6} AS 6 AT <3:125>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{498,7} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{498,7} AS 7 AT <6:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkTypeNameIsReserved) id{498,8} ---
(name, message) {
            // TS 1.0 spec (April 2014): 3.6.1
            // The predefined type keywords are reserved and cannot be used as names of user defined types.
            switch (name.text) {
                case "any":
                case "number":
                case "boolean":
                case "string":
                case "symbol":
                case "void":
                    error(name, message, name.text);
            }
        }
--- END ---
INLINE (checkTypeNameIsReserved) id{498,8} AS 8 AT <0:379>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode) id{499,0} ---
(node) {
            var links = getNodeLinks(node);
            if (!links.resolvedType) {
                // Deferred resolution of members is handled by resolveObjectTypeMembers
                var aliasSymbol = getAliasSymbolForTypeNode(node);
                if (ts.isEmpty(node.symbol.members) && !aliasSymbol) {
                    links.resolvedType = emptyTypeLiteralType;
                }
                else {
                    var type = createObjectType(16 /* Anonymous */, node.symbol);
                    type.aliasSymbol = aliasSymbol;
                    type.aliasTypeArguments = getAliasTypeArgumentsForTypeNode(node);
                    links.resolvedType = type;
                }
            }
            return links.resolvedType;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeLinks) id{499,1} ---
(node) {
            var nodeId = getNodeId(node);
            return nodeLinks[nodeId] || (nodeLinks[nodeId] = { flags: 0 });
        }
--- END ---
INLINE (getNodeLinks) id{499,1} AS 1 AT <0:33>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeId) id{499,2} ---
(node) {
        if (!node.id) {
            node.id = nextNodeId;
            nextNodeId++;
        }
        return node.id;
    }
--- END ---
INLINE (getNodeId) id{499,2} AS 2 AT <1:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getAliasSymbolForTypeNode) id{499,3} ---
(node) {
            return node.parent.kind === 228 /* TypeAliasDeclaration */ ? getSymbolOfNode(node.parent) : undefined;
        }
--- END ---
INLINE (getAliasSymbolForTypeNode) id{499,3} AS 3 AT <0:215>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{499,4} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{499,4} AS 4 AT <3:82>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{499,5} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{499,5} AS 5 AT <4:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createObjectType) id{499,6} ---
(objectFlags, symbol) {
            var type = createType(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol = symbol;
            return type;
        }
--- END ---
INLINE (createObjectType) id{499,6} AS 6 AT <0:454>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{499,7} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{499,7} AS 7 AT <6:47>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{499,8} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{499,8} AS 8 AT <7:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getAliasTypeArgumentsForTypeNode) id{499,9} ---
(node) {
            var symbol = getAliasSymbolForTypeNode(node);
            return symbol ? getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol) : undefined;
        }
--- END ---
INLINE (getAliasTypeArgumentsForTypeNode) id{499,9} AS 9 AT <0:603>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getAliasSymbolForTypeNode) id{499,10} ---
(node) {
            return node.parent.kind === 228 /* TypeAliasDeclaration */ ? getSymbolOfNode(node.parent) : undefined;
        }
--- END ---
INLINE (getAliasSymbolForTypeNode) id{499,10} AS 10 AT <9:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{499,11} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{499,11} AS 11 AT <10:82>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{499,12} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{499,12} AS 12 AT <11:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeFromLiteralTypeNode) id{500,0} ---
(node) {
            var links = getNodeLinks(node);
            if (!links.resolvedType) {
                links.resolvedType = getRegularTypeOfLiteralType(checkExpression(node.literal));
            }
            return links.resolvedType;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeLinks) id{500,1} ---
(node) {
            var nodeId = getNodeId(node);
            return nodeLinks[nodeId] || (nodeLinks[nodeId] = { flags: 0 });
        }
--- END ---
INLINE (getNodeLinks) id{500,1} AS 1 AT <0:33>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeId) id{500,2} ---
(node) {
        if (!node.id) {
            node.id = nextNodeId;
            nextNodeId++;
        }
        return node.id;
    }
--- END ---
INLINE (getNodeId) id{500,2} AS 2 AT <1:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getRegularTypeOfLiteralType) id{500,3} ---
(type) {
            return type.flags & 96 /* StringOrNumberLiteral */ && type.flags & 1048576 /* FreshLiteral */ ? type.regularType : type;
        }
--- END ---
INLINE (getRegularTypeOfLiteralType) id{500,3} AS 3 AT <0:129>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkLiteralExpression) id{501,0} ---
(node) {
            if (node.kind === 8 /* NumericLiteral */) {
                checkGrammarNumericLiteral(node);
            }
            switch (node.kind) {
                case 9 /* StringLiteral */:
                    return getFreshTypeOfLiteralType(getLiteralTypeForText(32 /* StringLiteral */, node.text));
                case 8 /* NumericLiteral */:
                    return getFreshTypeOfLiteralType(getLiteralTypeForText(64 /* NumberLiteral */, node.text));
                case 100 /* TrueKeyword */:
                    return trueType;
                case 85 /* FalseKeyword */:
                    return falseType;
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getLiteralTypeForText) id{501,1} ---
(flags, text) {
            var map = flags & 32 /* StringLiteral */ ? stringLiteralTypes : numericLiteralTypes;
            return map[text] || (map[text] = createLiteralType(flags, text));
        }
--- END ---
INLINE (getLiteralTypeForText) id{501,1} AS 1 AT <0:259>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createLiteralType) id{501,2} ---
(flags, text) {
            var type = createType(flags);
            type.text = text;
            return type;
        }
--- END ---
INLINE (createLiteralType) id{501,2} AS 2 AT <1:158>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{501,3} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{501,3} AS 3 AT <2:39>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{501,4} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{501,4} AS 4 AT <3:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getFreshTypeOfLiteralType) id{501,5} ---
(type) {
            if (type.flags & 96 /* StringOrNumberLiteral */ && !(type.flags & 1048576 /* FreshLiteral */)) {
                if (!type.freshType) {
                    var freshType = createLiteralType(type.flags | 1048576 /* FreshLiteral */, type.text);
                    freshType.regularType = type;
                    type.freshType = freshType;
                }
                return type.freshType;
            }
            return type;
        }
--- END ---
INLINE (getFreshTypeOfLiteralType) id{501,5} AS 5 AT <0:233>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createLiteralType) id{501,6} ---
(flags, text) {
            var type = createType(flags);
            type.text = text;
            return type;
        }
--- END ---
INLINE (createLiteralType) id{501,6} AS 6 AT <5:193>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{501,7} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{501,7} AS 7 AT <6:39>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{501,8} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{501,8} AS 8 AT <7:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isInferentialContext) id{502,0} ---
(mapper) {
            return mapper && mapper.context;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isConstEnumObjectType) id{503,0} ---
(type) {
            return getObjectFlags(type) & 16 /* Anonymous */ && type.symbol && isConstEnumSymbol(type.symbol);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{503,1} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{503,1} AS 1 AT <0:28>
[deoptimizing (DEOPT eager): begin 0x17ddd8404489 <JS Function addTypeToUnion (SharedFunctionInfo 0x2e2f693f37d1)> (opt #462) @44, FP to SP delta: 144, caller sp: 0x7fff5fbfd9d8]
            ;;; deoptimize at 0_144: wrong map
  reading input frame addTypeToUnion => node=34, args=3, height=4; inputs:
      0: 0x17ddd8404489 ; [fp - 16] 0x17ddd8404489 <JS Function addTypeToUnion (SharedFunctionInfo 0x2e2f693f37d1)>
      1: 0x1f9f6c0532e1 ; [fp + 32] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x24c89adb5929 ; [fp + 24] 0x24c89adb5929 <JS Array[1]>
      3: 0x24c89adb5779 ; rdx 0x24c89adb5779 <a TypeObject with map 0x33abe2a6d0e1>
      4: 0x130b7e1b3d29 ; rax 0x130b7e1b3d29 <FixedArray[1022]>
      5: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      6: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
      7: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
  translating frame addTypeToUnion => node=34, height=24
    0x7fff5fbfd9d0: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd9c8: [top + 64] <- 0x24c89adb5929 ;  0x24c89adb5929 <JS Array[1]>  (input #2)
    0x7fff5fbfd9c0: [top + 56] <- 0x24c89adb5779 ;  0x24c89adb5779 <a TypeObject with map 0x33abe2a6d0e1>  (input #3)
    0x7fff5fbfd9b8: [top + 48] <- 0x2c21d24ee792 ;  caller's pc
    0x7fff5fbfd9b0: [top + 40] <- 0x7fff5fbfd9f8 ;  caller's fp
    0x7fff5fbfd9a8: [top + 32] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #4)
    0x7fff5fbfd9a0: [top + 24] <- 0x17ddd8404489 ;  function    0x17ddd8404489 <JS Function addTypeToUnion (SharedFunctionInfo 0x2e2f693f37d1)>  (input #0)
    0x7fff5fbfd998: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #5)
    0x7fff5fbfd990: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfd988: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
[deoptimizing (eager): end 0x17ddd8404489 <JS Function addTypeToUnion (SharedFunctionInfo 0x2e2f693f37d1)> @44 => node=34, pc=0x2c21d253be73, caller sp=0x7fff5fbfd9d8, state=NO_REGISTERS, took 0.067 ms]
[deoptimizing (DEOPT eager): begin 0x17ddd8404441 <JS Function addTypesToUnion (SharedFunctionInfo 0x2e2f693f3891)> (opt #478) @2, FP to SP delta: 32, caller sp: 0x7fff5fbfd980]
            ;;; deoptimize at 0_77: wrong map
  reading input frame addTypesToUnion => node=14, args=3, height=4; inputs:
      0: 0x17ddd8404441 ; [fp - 16] 0x17ddd8404441 <JS Function addTypesToUnion (SharedFunctionInfo 0x2e2f693f3891)>
      1: 0x1f9f6c0532e1 ; [fp + 32] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x24c89adb5929 ; rdx 0x24c89adb5929 <JS Array[1]>
      3: 0x24c89adb5541 ; rax 0x24c89adb5541 <JS Array[4]>
      4: 0x130b7e1b3d29 ; rcx 0x130b7e1b3d29 <FixedArray[1022]>
      5: 0 ; rbx 
      6: 0x24c89adb5541 ; rax 0x24c89adb5541 <JS Array[4]>
      7: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
  translating frame addTypesToUnion => node=14, height=24
    0x7fff5fbfd978: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd970: [top + 64] <- 0x24c89adb5929 ;  0x24c89adb5929 <JS Array[1]>  (input #2)
    0x7fff5fbfd968: [top + 56] <- 0x24c89adb5541 ;  0x24c89adb5541 <JS Array[4]>  (input #3)
    0x7fff5fbfd960: [top + 48] <- 0x2c21d253bebc ;  caller's pc
    0x7fff5fbfd958: [top + 40] <- 0x7fff5fbfd9b0 ;  caller's fp
    0x7fff5fbfd950: [top + 32] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #4)
    0x7fff5fbfd948: [top + 24] <- 0x17ddd8404441 ;  function    0x17ddd8404441 <JS Function addTypesToUnion (SharedFunctionInfo 0x2e2f693f3891)>  (input #0)
    0x7fff5fbfd940: [top + 16] <- 0x00000000 ;  0  (input #5)
    0x7fff5fbfd938: [top + 8] <- 0x24c89adb5541 ;  0x24c89adb5541 <JS Array[4]>  (input #6)
    0x7fff5fbfd930: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
[deoptimizing (eager): end 0x17ddd8404441 <JS Function addTypesToUnion (SharedFunctionInfo 0x2e2f693f3891)> @2 => node=14, pc=0x2c21d253bce9, caller sp=0x7fff5fbfd980, state=NO_REGISTERS, took 0.049 ms]
[deoptimizer unlinked: addTypesToUnion / 17ddd8404441]
[deoptimizing (DEOPT lazy): begin 0x17ddd8404441 <JS Function addTypesToUnion (SharedFunctionInfo 0x2e2f693f3891)> (opt #478) @5, FP to SP delta: 32, caller sp: 0x7fff5fbfda20]
  reading input frame addTypesToUnion => node=88, args=3, height=4; inputs:
      0: 0x17ddd8404441 ; [fp - 16] 0x17ddd8404441 <JS Function addTypesToUnion (SharedFunctionInfo 0x2e2f693f3891)>
      1: 0x1f9f6c0532e1 ; [fp + 32] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x24c89adb5929 ; [fp + 24] 0x24c89adb5929 <JS Array[5]>
      3: 0x24c89adb5871 ; [fp + 16] 0x24c89adb5871 <JS Array[2]>
      4: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      5: 1 ; (int) [fp - 32] 
      6: 0x24c89adb5871 ; [fp + 16] 0x24c89adb5871 <JS Array[2]>
      7: 0x30bcea4069a9 ; (literal 3) 0x30bcea4069a9 <Odd Oddball: optimized_out>
  translating frame addTypesToUnion => node=88, height=24
    0x7fff5fbfda18: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfda10: [top + 64] <- 0x24c89adb5929 ;  0x24c89adb5929 <JS Array[5]>  (input #2)
    0x7fff5fbfda08: [top + 56] <- 0x24c89adb5871 ;  0x24c89adb5871 <JS Array[2]>  (input #3)
    0x7fff5fbfda00: [top + 48] <- 0x2c21d253b8ee ;  caller's pc
    0x7fff5fbfd9f8: [top + 40] <- 0x7fff5fbfda40 ;  caller's fp
    0x7fff5fbfd9f0: [top + 32] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #4)
    0x7fff5fbfd9e8: [top + 24] <- 0x17ddd8404441 ;  function    0x17ddd8404441 <JS Function addTypesToUnion (SharedFunctionInfo 0x2e2f693f3891)>  (input #0)
    0x7fff5fbfd9e0: [top + 16] <- 0x100000000 ;  1  (input #5)
    0x7fff5fbfd9d8: [top + 8] <- 0x24c89adb5871 ;  0x24c89adb5871 <JS Array[2]>  (input #6)
    0x7fff5fbfd9d0: [top + 0] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #7)
[deoptimizing (lazy): end 0x17ddd8404441 <JS Function addTypesToUnion (SharedFunctionInfo 0x2e2f693f3891)> @5 => node=88, pc=0x2c21d253bc7f, caller sp=0x7fff5fbfda20, state=NO_REGISTERS, took 0.050 ms]
[deoptimizing (DEOPT eager): begin 0x24c89adbae61 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)> (opt #448) @3, FP to SP delta: 304, caller sp: 0x7fff5fbfd720]
            ;;; deoptimize at 0_149: wrong map
  reading input frame isRelatedTo => node=49, args=5, height=9; inputs:
      0: 0x24c89adbae61 ; [fp - 16] 0x24c89adbae61 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)>
      1: 0x1f9f6c0532e1 ; [fp + 48] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x24c89adbcb59 ; rdx 0x24c89adbcb59 <a TypeObject with map 0x33abe2a767c9>
      3: 0x1030c9d51889 ; [fp + 32] 0x1030c9d51889 <a TypeObject with map 0x33abe2a6cf81>
      4: 0x30bcea404421 ; [fp + 24] 0x30bcea404421 <false>
      5: 0x30bcea404311 ; [fp + 16] 0x30bcea404311 <undefined>
      6: 0x24c89adbabf1 ; [fp - 24] 0x24c89adbabf1 <FixedArray[40]>
      7: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
      9: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     10: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     11: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     12: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     13: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     14: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
  translating frame isRelatedTo => node=49, height=64
    0x7fff5fbfd718: [top + 128] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd710: [top + 120] <- 0x24c89adbcb59 ;  0x24c89adbcb59 <a TypeObject with map 0x33abe2a767c9>  (input #2)
    0x7fff5fbfd708: [top + 112] <- 0x1030c9d51889 ;  0x1030c9d51889 <a TypeObject with map 0x33abe2a6cf81>  (input #3)
    0x7fff5fbfd700: [top + 104] <- 0x30bcea404421 ;  0x30bcea404421 <false>  (input #4)
    0x7fff5fbfd6f8: [top + 96] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfd6f0: [top + 88] <- 0x2c21d2207e55 ;  caller's pc
    0x7fff5fbfd6e8: [top + 80] <- 0x7fff5fbfd738 ;  caller's fp
    0x7fff5fbfd6e0: [top + 72] <- 0x24c89adbabf1 ;  context    0x24c89adbabf1 <FixedArray[40]>  (input #6)
    0x7fff5fbfd6d8: [top + 64] <- 0x24c89adbae61 ;  function    0x24c89adbae61 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)>  (input #0)
    0x7fff5fbfd6d0: [top + 56] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfd6c8: [top + 48] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfd6c0: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
    0x7fff5fbfd6b8: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #10)
    0x7fff5fbfd6b0: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #11)
    0x7fff5fbfd6a8: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #12)
    0x7fff5fbfd6a0: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #13)
    0x7fff5fbfd698: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #14)
[deoptimizing (eager): end 0x24c89adbae61 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)> @3 => node=49, pc=0x2c21d2628705, caller sp=0x7fff5fbfd720, state=NO_REGISTERS, took 0.082 ms]
[deoptimizer unlinked: isRelatedTo / 24c89adbae61]
[deoptimizer unlinked: isRelatedTo / 24c89adb86e1]
[deoptimizer unlinked: isRelatedTo / 24c89adad501]
[deoptimizer unlinked: isRelatedTo / 24c89ada5679]
[deoptimizer unlinked: isRelatedTo / 24c89ad99309]
[deoptimizer unlinked: isRelatedTo / 24c89ad92e19]
[deoptimizer unlinked: isRelatedTo / 24c89ad8e6c9]
[deoptimizer unlinked: isRelatedTo / 24c89ad82f29]
[deoptimizer unlinked: isRelatedTo / 24c89ad7e7b1]
[deoptimizer unlinked: isRelatedTo / 24c89ad72fd1]
[deoptimizer unlinked: isRelatedTo / 24c89ad6e251]
[deoptimizer unlinked: isRelatedTo / 24c89ad62951]
[deoptimizer unlinked: isRelatedTo / 24c89ad5e201]
[deoptimizer unlinked: isRelatedTo / 24c89ad51fb1]
[deoptimizer unlinked: isRelatedTo / 24c89ad4bec1]
[deoptimizer unlinked: isRelatedTo / 24c89ad40299]
[deoptimizer unlinked: isRelatedTo / 24c89ad3bb01]
[deoptimizer unlinked: isRelatedTo / 24c89ad30341]
[deoptimizer unlinked: isRelatedTo / 24c89ad2dcb1]
[deoptimizer unlinked: isRelatedTo / 24c89ad2cac9]
[deoptimizer unlinked: isRelatedTo / 24c89ad2b9e1]
[deoptimizer unlinked: isRelatedTo / 24c89ad215d9]
[deoptimizer unlinked: isRelatedTo / 24c89ad1fd39]
[deoptimizer unlinked: isRelatedTo / 24c89ad1ec51]
[deoptimizer unlinked: isRelatedTo / 24c89ad0fc19]
[deoptimizer unlinked: isRelatedTo / 24c89ad08d79]
[deoptimizer unlinked: isRelatedTo / 3d4479cf8a41]
[deoptimizer unlinked: isRelatedTo / 3d4479cf5471]
[deoptimizer unlinked: isRelatedTo / 3d4479ce9839]
[deoptimizer unlinked: isRelatedTo / 3d4479ce5bb1]
[deoptimizer unlinked: isRelatedTo / 3d4479cd8771]
[deoptimizer unlinked: isRelatedTo / 3d4479cd00c1]
[deoptimizer unlinked: isRelatedTo / 3d4479ccde19]
[deoptimizer unlinked: isRelatedTo / 3d4479ccac31]
[deoptimizer unlinked: isRelatedTo / 3d4479cbf591]
[deoptimizer unlinked: isRelatedTo / 3d4479cb6209]
[deoptimizer unlinked: isRelatedTo / 3d4479cb3021]
[deoptimizer unlinked: isRelatedTo / 3d4479ca78f1]
[deoptimizer unlinked: isRelatedTo / 3d4479c9bfe1]
[deoptimizer unlinked: isRelatedTo / 3d4479c90801]
[deoptimizer unlinked: isRelatedTo / 3d4479c8e559]
[deoptimizer unlinked: isRelatedTo / 3d4479c8b1f9]
[deoptimizer unlinked: isRelatedTo / 3d4479c7fb79]
[deoptimizer unlinked: isRelatedTo / 3d4479c747f9]
[deoptimizer unlinked: isRelatedTo / 3d4479c69059]
[deoptimizer unlinked: isRelatedTo / 3d4479c643f9]
[deoptimizer unlinked: isRelatedTo / 3d4479c58b99]
[deoptimizer unlinked: isRelatedTo / 3d4479c54d51]
[deoptimizer unlinked: isRelatedTo / 3d4479c471a9]
[deoptimizer unlinked: isRelatedTo / 3d4479c3b591]
[deoptimizer unlinked: isRelatedTo / 3d4479c38a99]
[deoptimizer unlinked: isRelatedTo / 3d4479c344a1]
[deoptimizer unlinked: isRelatedTo / 3d4479c28cc1]
[deoptimizer unlinked: isRelatedTo / 3d4479c240b9]
[deoptimizer unlinked: isRelatedTo / 3d4479c18879]
[deoptimizer unlinked: isRelatedTo / 3d4479c13119]
[deoptimizer unlinked: isRelatedTo / 3d4479c07939]
[deoptimizer unlinked: isRelatedTo / 3e2869cfefd9]
[deoptimizer unlinked: isRelatedTo / 3e2869cf3819]
[deoptimizer unlinked: isRelatedTo / 3e2869cef031]
[deoptimizer unlinked: isRelatedTo / 3e2869ce37f1]
[deoptimizer unlinked: isRelatedTo / 3e2869ccbbe1]
[deoptimizer unlinked: isRelatedTo / 3e2869cc03e1]
[deoptimizer unlinked: isRelatedTo / 3e2869cbe0b9]
[deoptimizer unlinked: isRelatedTo / 3e2869cba599]
[deoptimizer unlinked: isRelatedTo / 3e2869cb6f59]
[deoptimizer unlinked: isRelatedTo / 3e2869cb24c9]
[deoptimizer unlinked: isRelatedTo / 3e2869ca6c09]
[deoptimizer unlinked: isRelatedTo / 3e2869ca16e9]
[deoptimizer unlinked: isRelatedTo / 3e2869c9e4e1]
[deoptimizer unlinked: isRelatedTo / 3e2869c92c71]
[deoptimizer unlinked: isRelatedTo / 3e2869c86151]
[deoptimizer unlinked: isRelatedTo / 3e2869c7a931]
[deoptimizer unlinked: isRelatedTo / 3e2869c76199]
[deoptimizer unlinked: isRelatedTo / 3e2869c6a999]
[deoptimizer unlinked: isRelatedTo / 3e2869c65e29]
[deoptimizer unlinked: isRelatedTo / 3e2869c5a5a9]
[deoptimizer unlinked: isRelatedTo / 3e2869c55a39]
[deoptimizer unlinked: isRelatedTo / 3e2869c4a1b9]
[deoptimizer unlinked: isRelatedTo / 3e2869c45a21]
[deoptimizer unlinked: isRelatedTo / 3e2869c3a221]
[deoptimizer unlinked: isRelatedTo / 3e2869c314f1]
[deoptimizer unlinked: isRelatedTo / 3e2869c30381]
[deoptimizer unlinked: isRelatedTo / 3e2869c2a621]
[deoptimizer unlinked: isRelatedTo / 3e2869c1e989]
[deoptimizer unlinked: isRelatedTo / 3e2869c18459]
[deoptimizer unlinked: isRelatedTo / 3e2869c13a21]
[deoptimizer unlinked: isRelatedTo / 104003eef8d1]
[deoptimizer unlinked: isRelatedTo / 104003eed169]
[deoptimizer unlinked: isRelatedTo / 104003eddf29]
[deoptimizer unlinked: isRelatedTo / 104003ed2809]
[deoptimizer unlinked: isRelatedTo / 104003ec5fa9]
[deoptimizer unlinked: isRelatedTo / 104003eba7a9]
[deoptimizer unlinked: isRelatedTo / 104003eb5fc9]
[deoptimizer unlinked: isRelatedTo / 104003eaa7c9]
[deoptimizer unlinked: isRelatedTo / 104003ea4239]
[deoptimizer unlinked: isRelatedTo / 104003e98a29]
[deoptimizer unlinked: isRelatedTo / 104003e90a79]
[deoptimizer unlinked: isRelatedTo / 104003e84369]
[deoptimizer unlinked: isRelatedTo / 104003e7fee9]
[deoptimizer unlinked: isRelatedTo / 104003e7d601]
[deoptimizer unlinked: isRelatedTo / 104003e7a3b9]
[deoptimizer unlinked: isRelatedTo / 104003e6e061]
[deoptimizer unlinked: isRelatedTo / 104003e5fbd9]
[deoptimizer unlinked: isRelatedTo / 104003e5b441]
[deoptimizer unlinked: isRelatedTo / 104003e4fc29]
[deoptimizer unlinked: isRelatedTo / 104003e4b4b9]
[deoptimizer unlinked: isRelatedTo / 104003e3fca1]
[deoptimizer unlinked: isRelatedTo / 104003e3b531]
[deoptimizer unlinked: isRelatedTo / 104003e2fd19]
[deoptimizer unlinked: isRelatedTo / 104003e2dad1]
[deoptimizer unlinked: isRelatedTo / 104003e2cde1]
[deoptimizer unlinked: isRelatedTo / 104003e29bd9]
[deoptimizer unlinked: isRelatedTo / 104003e1e2f9]
[deoptimizer unlinked: isRelatedTo / 29cc38d0a3e9]
[deoptimizer unlinked: isRelatedTo / 29cc38d6c009]
[deoptimizer unlinked: isRelatedTo / 29cc38d67559]
[deoptimizer unlinked: isRelatedTo / 29cc38d65f69]
[deoptimizer unlinked: isRelatedTo / 29cc38d65559]
[deoptimizer unlinked: isRelatedTo / 29cc38d5bda9]
[deoptimizer unlinked: isRelatedTo / 29cc38d5ac09]
[deoptimizer unlinked: isRelatedTo / 29cc38d55c51]
[deoptimizer unlinked: isRelatedTo / 29cc38d549e1]
[deoptimizer unlinked: isRelatedTo / 29cc38d53f29]
[deoptimizer unlinked: isRelatedTo / 29cc38d533b9]
[deoptimizer unlinked: isRelatedTo / 29cc38d4d621]
[deoptimizer unlinked: isRelatedTo / 29cc38d4bf41]
[deoptimizer unlinked: isRelatedTo / 29cc38d46031]
[deoptimizer unlinked: isRelatedTo / 29cc38d44c01]
[deoptimizer unlinked: isRelatedTo / 29cc38d43d99]
[deoptimizer unlinked: isRelatedTo / 29cc38d3b6f1]
[deoptimizer unlinked: isRelatedTo / 29cc38d38f31]
[deoptimizer unlinked: isRelatedTo / 29cc38d37ee1]
[deoptimizer unlinked: isRelatedTo / 29cc38d322a1]
[deoptimizer unlinked: isRelatedTo / 29cc38d310c9]
[deoptimizer unlinked: isRelatedTo / 29cc38d2b469]
[deoptimizer unlinked: isRelatedTo / 29cc38d2a2b1]
[deoptimizer unlinked: isRelatedTo / 29cc38d24651]
[deoptimizer unlinked: isRelatedTo / 29cc38d234c1]
[deoptimizer unlinked: isRelatedTo / 29cc38d1d129]
[deoptimizer unlinked: isRelatedTo / 29cc38d1c329]
[deoptimizer unlinked: isRelatedTo / 29cc38d166d9]
[deoptimizer unlinked: isRelatedTo / 29cc38d15511]
[deoptimizer unlinked: isRelatedTo / 29cc38d0f8a1]
[deoptimizer unlinked: isRelatedTo / 29cc38d0d1f1]
[deoptimizer unlinked: isRelatedTo / 29cc38ddab31]
[deoptimizer unlinked: isRelatedTo / 29cc38dd9709]
[deoptimizer unlinked: isRelatedTo / 29cc38dd3871]
[deoptimizer unlinked: isRelatedTo / 29cc38dc43c1]
[deoptimizer unlinked: isRelatedTo / 29cc38dbbed9]
[deoptimizer unlinked: isRelatedTo / 29cc38db7151]
[deoptimizer unlinked: isRelatedTo / 29cc38db5c81]
[deoptimizer unlinked: isRelatedTo / 29cc38db5271]
[deoptimizer unlinked: isRelatedTo / 29cc38daf5c1]
[deoptimizer unlinked: isRelatedTo / 29cc38dae009]
[deoptimizer unlinked: isRelatedTo / 29cc38da8389]
[deoptimizer unlinked: isRelatedTo / 29cc38da7239]
[deoptimizer unlinked: isRelatedTo / 29cc38da12b1]
[deoptimizer unlinked: isRelatedTo / 29cc38d9c641]
[deoptimizer unlinked: isRelatedTo / 29cc38d9bc91]
[deoptimizer unlinked: isRelatedTo / 29cc38d90a01]
[deoptimizer unlinked: isRelatedTo / 29cc38d8f231]
[deoptimizer unlinked: isRelatedTo / 29cc38d8dc19]
[deoptimizer unlinked: isRelatedTo / 29cc38d8c4c1]
[deoptimizer unlinked: isRelatedTo / 29cc38d8ad41]
[deoptimizer unlinked: isRelatedTo / 29cc38d88db9]
[deoptimizer unlinked: isRelatedTo / 29cc38d86459]
[deoptimizer unlinked: isRelatedTo / 29cc38d83f19]
[deoptimizer unlinked: isRelatedTo / 29cc38d81629]
[deoptimizer unlinked: isRelatedTo / 29cc38d801c9]
[deoptimizer unlinked: isRelatedTo / 29cc38d7dfa9]
[deoptimizer unlinked: isRelatedTo / 29cc38d7d6a9]
[deoptimizer unlinked: isRelatedTo / 29cc38d7ad21]
[deoptimizer unlinked: isRelatedTo / 29cc38d78579]
[deoptimizer unlinked: isRelatedTo / 29cc38d74f89]
[deoptimizer unlinked: isRelatedTo / 29cc38d73861]
[deoptimizer unlinked: isRelatedTo / 29cc38d72891]
[deoptimizer unlinked: isRelatedTo / 29cc38d71d49]
[deoptimizer unlinked: isRelatedTo / 29cc38d71489]
[deoptimizer unlinked: isRelatedTo / 29cc38d70a59]
[deoptimizer unlinked: isRelatedTo / 29cc38d70181]
[deoptimizer unlinked: isRelatedTo / 19a2de35fa19]
[deoptimizer unlinked: isRelatedTo / 19a2de35edd9]
[deoptimizer unlinked: isRelatedTo / 19a2de35e321]
[deoptimizer unlinked: isRelatedTo / 19a2de35d5a9]
[deoptimizer unlinked: isRelatedTo / 19a2de35c759]
[deoptimizer unlinked: isRelatedTo / 19a2de35bfc1]
[deoptimizer unlinked: isRelatedTo / 19a2de355949]
[deoptimizer unlinked: isRelatedTo / 19a2de3515f1]
[deoptimizer unlinked: isRelatedTo / 19a2de34fe11]
[deoptimizer unlinked: isRelatedTo / 19a2de34db81]
[deoptimizer unlinked: isRelatedTo / 19a2de34c2b1]
[deoptimizer unlinked: isRelatedTo / 19a2de3491b1]
[deoptimizer unlinked: isRelatedTo / 19a2de3486f9]
[deoptimizer unlinked: isRelatedTo / 19a2de3479f1]
[deoptimizer unlinked: isRelatedTo / 19a2de346741]
[deoptimizer unlinked: isRelatedTo / 19a2de345bd1]
[deoptimizer unlinked: isRelatedTo / 19a2de345279]
[deoptimizer unlinked: isRelatedTo / 19a2de3427f1]
[deoptimizer unlinked: isRelatedTo / 19a2de33cba9]
[deoptimizer unlinked: isRelatedTo / 19a2de33c071]
[deoptimizer unlinked: isRelatedTo / 19a2de33afd1]
[deoptimizer unlinked: isRelatedTo / 19a2de339cc9]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSignatureFromDeclaration) id{504,0} ---
(declaration) {
            var links = getNodeLinks(declaration);
            if (!links.resolvedSignature) {
                var parameters = [];
                var hasLiteralTypes = false;
                var minArgumentCount = -1;
                var thisParameter = undefined;
                var hasThisParameter = void 0;
                var isJSConstructSignature = ts.isJSDocConstructSignature(declaration);
                // If this is a JSDoc construct signature, then skip the first parameter in the
                // parameter list.  The first parameter represents the return type of the construct
                // signature.
                for (var i = isJSConstructSignature ? 1 : 0, n = declaration.parameters.length; i < n; i++) {
                    var param = declaration.parameters[i];
                    var paramSymbol = param.symbol;
                    // Include parameter symbol instead of property symbol in the signature
                    if (paramSymbol && !!(paramSymbol.flags & 4 /* Property */) && !ts.isBindingPattern(param.name)) {
                        var resolvedSymbol = resolveName(param, paramSymbol.name, 107455 /* Value */, undefined, undefined);
                        paramSymbol = resolvedSymbol;
                    }
                    if (i === 0 && paramSymbol.name === "this") {
                        hasThisParameter = true;
                        thisParameter = param.symbol;
                    }
                    else {
                        parameters.push(paramSymbol);
                    }
                    if (param.type && param.type.kind === 171 /* LiteralType */) {
                        hasLiteralTypes = true;
                    }
                    if (param.initializer || param.questionToken || param.dotDotDotToken || isJSDocOptionalParameter(param)) {
                        if (minArgumentCount < 0) {
                            minArgumentCount = i - (hasThisParameter ? 1 : 0);
                        }
                    }
                    else {
                        // If we see any required parameters, it means the prior ones were not in fact optional.
                        minArgumentCount = -1;
                    }
                }
                // If only one accessor includes a this-type annotation, the other behaves as if it had the same type annotation
                if ((declaration.kind === 151 /* GetAccessor */ || declaration.kind === 152 /* SetAccessor */) &&
                    !ts.hasDynamicName(declaration) &&
                    (!hasThisParameter || !thisParameter)) {
                    var otherKind = declaration.kind === 151 /* GetAccessor */ ? 152 /* SetAccessor */ : 151 /* GetAccessor */;
                    var other = ts.getDeclarationOfKind(declaration.symbol, otherKind);
                    if (other) {
                        thisParameter = getAnnotatedAccessorThisParameter(other);
                    }
                }
                if (minArgumentCount < 0) {
                    minArgumentCount = declaration.parameters.length - (hasThisParameter ? 1 : 0);
                }
                if (isJSConstructSignature) {
                    minArgumentCount--;
                }
                var classType = declaration.kind === 150 /* Constructor */ ?
                    getDeclaredTypeOfClassOrInterface(getMergedSymbol(declaration.parent.symbol))
                    : undefined;
                var typeParameters = classType ? classType.localTypeParameters :
                    declaration.typeParameters ? getTypeParametersFromDeclaration(declaration.typeParameters) :
                        getTypeParametersFromJSDocTemplate(declaration);
                var returnType = getSignatureReturnTypeFromDeclaration(declaration, isJSConstructSignature, classType);
                var typePredicate = declaration.type && declaration.type.kind === 156 /* TypePredicate */ ?
                    createTypePredicateFromTypePredicateNode(declaration.type) :
                    undefined;
                links.resolvedSignature = createSignature(declaration, typeParameters, thisParameter, parameters, returnType, typePredicate, minArgumentCount, ts.hasRestParameter(declaration), hasLiteralTypes);
            }
            return links.resolvedSignature;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeLinks) id{504,1} ---
(node) {
            var nodeId = getNodeId(node);
            return nodeLinks[nodeId] || (nodeLinks[nodeId] = { flags: 0 });
        }
--- END ---
INLINE (getNodeLinks) id{504,1} AS 1 AT <0:40>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeId) id{504,2} ---
(node) {
        if (!node.id) {
            node.id = nextNodeId;
            nextNodeId++;
        }
        return node.id;
    }
--- END ---
INLINE (getNodeId) id{504,2} AS 2 AT <1:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeParametersFromJSDocTemplate) id{504,3} ---
(declaration) {
            if (declaration.flags & 65536 /* JavaScriptFile */) {
                var templateTag = ts.getJSDocTemplateTag(declaration);
                if (templateTag) {
                    return getTypeParametersFromDeclaration(templateTag.typeParameters);
                }
            }
            return undefined;
        }
--- END ---
INLINE (getTypeParametersFromJSDocTemplate) id{504,3} AS 3 AT <0:3677>
[deoptimizing (DEOPT lazy): begin 0x24c89adbae61 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)> (opt #448) @94, FP to SP delta: 304, caller sp: 0x7fff5fbfdb28]
  reading input frame isRelatedTo => node=2079, args=5, height=10; inputs:
      0: 0x24c89adbae61 ; [fp - 16] 0x24c89adbae61 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)>
      1: 0x1f9f6c0532e1 ; [fp + 48] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x24c89adbc131 ; [fp - 56] 0x24c89adbc131 <a TypeObject with map 0x33abe2a6d349>
      3: 0x19a2de3c14c1 ; [fp - 40] 0x19a2de3c14c1 <a TypeObject with map 0x33abe2a6d349>
      4: 0x30bcea4043b1 ; [fp + 24] 0x30bcea4043b1 <true>
      5: 0x30bcea404311 ; [fp + 16] 0x30bcea404311 <undefined>
      6: 0x24c89adbabf1 ; [fp - 24] 0x24c89adbabf1 <FixedArray[40]>
      7: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; [fp - 64] 0x30bcea404311 <undefined>
      9: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     10: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     11: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     12: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     13: 0x30bcea4069a9 ; (literal 24) 0x30bcea4069a9 <Odd Oddball: optimized_out>
     14: 0x30bcea4069a9 ; (literal 24) 0x30bcea4069a9 <Odd Oddball: optimized_out>
     15: 0xffffffff00000000 ; rax -1
  translating frame isRelatedTo => node=2079, height=72
    0x7fff5fbfdb20: [top + 136] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdb18: [top + 128] <- 0x24c89adbc131 ;  0x24c89adbc131 <a TypeObject with map 0x33abe2a6d349>  (input #2)
    0x7fff5fbfdb10: [top + 120] <- 0x19a2de3c14c1 ;  0x19a2de3c14c1 <a TypeObject with map 0x33abe2a6d349>  (input #3)
    0x7fff5fbfdb08: [top + 112] <- 0x30bcea4043b1 ;  0x30bcea4043b1 <true>  (input #4)
    0x7fff5fbfdb00: [top + 104] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfdaf8: [top + 96] <- 0x2c21d2207e55 ;  caller's pc
    0x7fff5fbfdaf0: [top + 88] <- 0x7fff5fbfdb40 ;  caller's fp
    0x7fff5fbfdae8: [top + 80] <- 0x24c89adbabf1 ;  context    0x24c89adbabf1 <FixedArray[40]>  (input #6)
    0x7fff5fbfdae0: [top + 72] <- 0x24c89adbae61 ;  function    0x24c89adbae61 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)>  (input #0)
    0x7fff5fbfdad8: [top + 64] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfdad0: [top + 56] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfdac8: [top + 48] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
    0x7fff5fbfdac0: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #10)
    0x7fff5fbfdab8: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #11)
    0x7fff5fbfdab0: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #12)
    0x7fff5fbfdaa8: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #13)
    0x7fff5fbfdaa0: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #14)
    0x7fff5fbfda98: [top + 0] <- 0xffffffff00000000 ;  -1  (input #15)
[deoptimizing (lazy): end 0x24c89adbae61 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)> @94 => node=2079, pc=0x2c21d262a031, caller sp=0x7fff5fbfdb28, state=TOS_REGISTER, took 0.088 ms]
[deoptimizing (DEOPT lazy): begin 0x24c89adbae61 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)> (opt #448) @94, FP to SP delta: 304, caller sp: 0x7fff5fbfde18]
  reading input frame isRelatedTo => node=2079, args=5, height=10; inputs:
      0: 0x24c89adbae61 ; [fp - 16] 0x24c89adbae61 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)>
      1: 0x1f9f6c0532e1 ; [fp + 48] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x24c89adbaa39 ; [fp - 56] 0x24c89adbaa39 <a TypeObject with map 0x33abe2a73599>
      3: 0x2069acd2911 ; [fp - 40] 0x2069acd2911 <a TypeObject with map 0x33abe2a73599>
      4: 0x30bcea4043b1 ; [fp + 24] 0x30bcea4043b1 <true>
      5: 0xd6230df7599 ; [fp + 16] 0xd6230df7599 <an Object with map 0x33abe2a3df61>
      6: 0x24c89adbabf1 ; [fp - 24] 0x24c89adbabf1 <FixedArray[40]>
      7: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; [fp - 64] 0x30bcea404311 <undefined>
      9: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     10: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     11: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     12: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     13: 0x30bcea4069a9 ; (literal 24) 0x30bcea4069a9 <Odd Oddball: optimized_out>
     14: 0x30bcea4069a9 ; (literal 24) 0x30bcea4069a9 <Odd Oddball: optimized_out>
     15: 0xffffffff00000000 ; rax -1
  translating frame isRelatedTo => node=2079, height=72
    0x7fff5fbfde10: [top + 136] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfde08: [top + 128] <- 0x24c89adbaa39 ;  0x24c89adbaa39 <a TypeObject with map 0x33abe2a73599>  (input #2)
    0x7fff5fbfde00: [top + 120] <- 0x2069acd2911 ;  0x2069acd2911 <a TypeObject with map 0x33abe2a73599>  (input #3)
    0x7fff5fbfddf8: [top + 112] <- 0x30bcea4043b1 ;  0x30bcea4043b1 <true>  (input #4)
    0x7fff5fbfddf0: [top + 104] <- 0xd6230df7599 ;  0xd6230df7599 <an Object with map 0x33abe2a3df61>  (input #5)
    0x7fff5fbfdde8: [top + 96] <- 0x2c21d2649a8d ;  caller's pc
    0x7fff5fbfdde0: [top + 88] <- 0x7fff5fbfde58 ;  caller's fp
    0x7fff5fbfddd8: [top + 80] <- 0x24c89adbabf1 ;  context    0x24c89adbabf1 <FixedArray[40]>  (input #6)
    0x7fff5fbfddd0: [top + 72] <- 0x24c89adbae61 ;  function    0x24c89adbae61 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)>  (input #0)
    0x7fff5fbfddc8: [top + 64] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfddc0: [top + 56] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfddb8: [top + 48] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
    0x7fff5fbfddb0: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #10)
    0x7fff5fbfdda8: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #11)
    0x7fff5fbfdda0: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #12)
    0x7fff5fbfdd98: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #13)
    0x7fff5fbfdd90: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #14)
    0x7fff5fbfdd88: [top + 0] <- 0xffffffff00000000 ;  -1  (input #15)
[deoptimizing (lazy): end 0x24c89adbae61 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)> @94 => node=2079, pc=0x2c21d262a031, caller sp=0x7fff5fbfde18, state=TOS_REGISTER, took 0.080 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{505,0} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{505,1} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{505,1} AS 1 AT <0:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkFunctionOrMethodDeclaration) id{506,0} ---
(node) {
            checkDecorators(node);
            checkSignatureDeclaration(node);
            var isAsync = ts.isAsyncFunctionLike(node);
            // Do not use hasDynamicName here, because that returns false for well known symbols.
            // We want to perform checkComputedPropertyName for all computed properties, including
            // well known symbols.
            if (node.name && node.name.kind === 142 /* ComputedPropertyName */) {
                // This check will account for methods in class/interface declarations,
                // as well as accessors in classes/object literals
                checkComputedPropertyName(node.name);
            }
            if (!ts.hasDynamicName(node)) {
                // first we want to check the local symbol that contain this declaration
                // - if node.localSymbol !== undefined - this is current declaration is exported and localSymbol points to the local symbol
                // - if node.localSymbol === undefined - this node is non-exported so we can just pick the result of getSymbolOfNode
                var symbol = getSymbolOfNode(node);
                var localSymbol = node.localSymbol || symbol;
                // Since the javascript won't do semantic analysis like typescript,
                // if the javascript file comes before the typescript file and both contain same name functions,
                // checkFunctionOrConstructorSymbol wouldn't be called if we didnt ignore javascript function.
                var firstDeclaration = ts.forEach(localSymbol.declarations, 
                // Get first non javascript function declaration
                function (declaration) { return declaration.kind === node.kind && !ts.isSourceFileJavaScript(ts.getSourceFileOfNode(declaration)) ?
                    declaration : undefined; });
                // Only type check the symbol once
                if (node === firstDeclaration) {
                    checkFunctionOrConstructorSymbol(localSymbol);
                }
                if (symbol.parent) {
                    // run check once for the first declaration
                    if (ts.getDeclarationOfKind(symbol, node.kind) === node) {
                        // run check on export symbol to check that modifiers agree across all exported declarations
                        checkFunctionOrConstructorSymbol(symbol);
                    }
                }
            }
            checkSourceElement(node.body);
            if (!node.asteriskToken) {
                var returnOrPromisedType = node.type && (isAsync ? checkAsyncFunctionReturnType(node) : getTypeFromTypeNode(node.type));
                checkAllCodePathsInNonVoidFunctionReturnOrThrow(node, returnOrPromisedType);
            }
            if (produceDiagnostics && !node.type) {
                // Report an implicit any error if there is no body, no explicit return type, and node is not a private method
                // in an ambient context
                if (compilerOptions.noImplicitAny && ts.nodeIsMissing(node.body) && !isPrivateWithinAmbient(node)) {
                    reportImplicitAnyError(node, anyType);
                }
                if (node.asteriskToken && ts.nodeIsPresent(node.body)) {
                    // A generator with a body and no type annotation can still cause errors. It can error if the
                    // yielded values have no common supertype, or it can give an implicit any error if it has no
                    // yielded values. The only way to trigger these errors is to try checking its return type.
                    getReturnTypeOfSignature(getSignatureFromDeclaration(node));
                }
            }
            registerForUnusedIdentifiersCheck(node);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{506,1} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{506,1} AS 1 AT <0:1117>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{506,2} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{506,2} AS 2 AT <1:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:registerForUnusedIdentifiersCheck) id{506,3} ---
(node) {
            if (deferredUnusedIdentifierNodes) {
                deferredUnusedIdentifierNodes.push(node);
            }
        }
--- END ---
INLINE (registerForUnusedIdentifiersCheck) id{506,3} AS 3 AT <0:3729>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isRelatedTo) id{507,0} ---
(source, target, reportErrors, headMessage) {
                var result;
                if (source.flags & 96 /* StringOrNumberLiteral */ && source.flags & 1048576 /* FreshLiteral */) {
                    source = source.regularType;
                }
                if (target.flags & 96 /* StringOrNumberLiteral */ && target.flags & 1048576 /* FreshLiteral */) {
                    target = target.regularType;
                }
                // both types are the same - covers 'they are the same primitive type or both are Any' or the same type parameter cases
                if (source === target)
                    return -1 /* True */;
                if (relation === identityRelation) {
                    return isIdenticalTo(source, target);
                }
                if (isSimpleTypeRelatedTo(source, target, relation, reportErrors ? reportError : undefined))
                    return -1 /* True */;
                if (getObjectFlags(source) & 128 /* ObjectLiteral */ && source.flags & 1048576 /* FreshLiteral */) {
                    if (hasExcessProperties(source, target, reportErrors)) {
                        if (reportErrors) {
                            reportRelationError(headMessage, source, target);
                        }
                        return 0 /* False */;
                    }
                    // Above we check for excess properties with respect to the entire target type. When union
                    // and intersection types are further deconstructed on the target side, we don't want to
                    // make the check again (as it might fail for a partial target type). Therefore we obtain
                    // the regular source type and proceed with that.
                    if (isUnionOrIntersectionTypeWithoutNullableConstituents(target)) {
                        source = getRegularTypeOfObjectLiteral(source);
                    }
                }
                var saveErrorInfo = errorInfo;
                // Note that these checks are specifically ordered to produce correct results. In particular,
                // we need to deconstruct unions before intersections (because unions are always at the top),
                // and we need to handle "each" relations before "some" relations for the same kind of type.
                if (source.flags & 65536 /* Union */) {
                    if (relation === comparableRelation) {
                        result = someTypeRelatedToType(source, target, reportErrors && !(source.flags & 8190 /* Primitive */));
                    }
                    else {
                        result = eachTypeRelatedToType(source, target, reportErrors && !(source.flags & 8190 /* Primitive */));
                    }
                    if (result) {
                        return result;
                    }
                }
                else if (target.flags & 65536 /* Union */) {
                    if (result = typeRelatedToSomeType(source, target, reportErrors && !(source.flags & 8190 /* Primitive */) && !(target.flags & 8190 /* Primitive */))) {
                        return result;
                    }
                }
                else if (target.flags & 131072 /* Intersection */) {
                    if (result = typeRelatedToEachType(source, target, reportErrors)) {
                        return result;
                    }
                }
                else if (source.flags & 131072 /* Intersection */) {
                    // Check to see if any constituents of the intersection are immediately related to the target.
                    //
                    // Don't report errors though. Checking whether a constituent is related to the source is not actually
                    // useful and leads to some confusing error messages. Instead it is better to let the below checks
                    // take care of this, or to not elaborate at all. For instance,
                    //
                    //    - For an object type (such as 'C = A & B'), users are usually more interested in structural errors.
                    //
                    //    - For a union type (such as '(A | B) = (C & D)'), it's better to hold onto the whole intersection
                    //          than to report that 'D' is not assignable to 'A' or 'B'.
                    //
                    //    - For a primitive type or type parameter (such as 'number = A & B') there is no point in
                    //          breaking the intersection apart.
                    if (result = someTypeRelatedToType(source, target, /*reportErrors*/ false)) {
                        return result;
                    }
                }
                else if (target.flags & 16384 /* TypeParameter */) {
                    // A source type { [P in keyof T]: X } is related to a target type T if X is related to T[P].
                    if (getObjectFlags(source) & 32 /* Mapped */ && getConstraintTypeFromMappedType(source) === getIndexType(target)) {
                        if (!source.declaration.questionToken) {
                            var templateType = getTemplateTypeFromMappedType(source);
                            var indexedAccessType = getIndexedAccessType(target, getTypeParameterFromMappedType(source));
                            if (result = isRelatedTo(templateType, indexedAccessType, reportErrors)) {
                                return result;
                            }
                        }
                    }
                    else {
                        // Given a type parameter K with a constraint keyof T, a type S is
                        // assignable to K if S is assignable to keyof T.
                        var constraint = getConstraintOfTypeParameter(target);
                        if (constraint && constraint.flags & 262144 /* Index */) {
                            if (result = isRelatedTo(source, constraint, reportErrors)) {
                                return result;
                            }
                        }
                    }
                }
                else if (target.flags & 262144 /* Index */) {
                    // A keyof S is related to a keyof T if T is related to S.
                    if (source.flags & 262144 /* Index */) {
                        if (result = isRelatedTo(target.type, source.type, /*reportErrors*/ false)) {
                            return result;
                        }
                    }
                    // Given a type variable T with a constraint C, a type S is assignable to
                    // keyof T if S is assignable to keyof C.
                    if (target.type.flags & 540672 /* TypeVariable */) {
                        var constraint = getConstraintOfTypeVariable(target.type);
                        if (constraint) {
                            if (result = isRelatedTo(source, getIndexType(constraint), reportErrors)) {
                                return result;
                            }
                        }
                    }
                }
                else if (target.flags & 524288 /* IndexedAccess */) {
                    // if we have indexed access types with identical index types, see if relationship holds for
                    // the two object types.
                    if (source.flags & 524288 /* IndexedAccess */ && source.indexType === target.indexType) {
                        if (result = isRelatedTo(source.objectType, target.objectType, reportErrors)) {
                            return result;
                        }
                    }
                    // A type S is related to a type T[K] if S is related to A[K], where K is string-like and
                    // A is the apparent type of S.
                    if (target.constraint) {
                        if (result = isRelatedTo(source, target.constraint, reportErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                }
                if (source.flags & 16384 /* TypeParameter */) {
                    // A source type T is related to a target type { [P in keyof T]: X } if T[P] is related to X.
                    if (getObjectFlags(target) & 32 /* Mapped */ && getConstraintTypeFromMappedType(target) === getIndexType(source)) {
                        var indexedAccessType = getIndexedAccessType(source, getTypeParameterFromMappedType(target));
                        var templateType = getTemplateTypeFromMappedType(target);
                        if (result = isRelatedTo(indexedAccessType, templateType, reportErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                    else {
                        var constraint = getConstraintOfTypeParameter(source);
                        if (!constraint || constraint.flags & 1 /* Any */) {
                            constraint = emptyObjectType;
                        }
                        // The constraint may need to be further instantiated with its 'this' type.
                        constraint = getTypeWithThisArgument(constraint, source);
                        // Report constraint errors only if the constraint is not the empty object type
                        var reportConstraintErrors = reportErrors && constraint !== emptyObjectType;
                        if (result = isRelatedTo(constraint, target, reportConstraintErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                }
                else if (source.flags & 524288 /* IndexedAccess */) {
                    // A type S[K] is related to a type T if A[K] is related to T, where K is string-like and
                    // A is the apparent type of S.
                    if (source.constraint) {
                        if (result = isRelatedTo(source.constraint, target, reportErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                }
                else {
                    if (getObjectFlags(source) & 4 /* Reference */ && getObjectFlags(target) & 4 /* Reference */ && source.target === target.target) {
                        // We have type references to same target type, see if relationship holds for all type arguments
                        if (result = typeArgumentsRelatedTo(source, target, reportErrors)) {
                            return result;
                        }
                    }
                    // Even if relationship doesn't hold for unions, intersections, or generic type references,
                    // it may hold in a structural comparison.
                    var apparentSource = getApparentType(source);
                    // In a check of the form X = A & B, we will have previously checked if A relates to X or B relates
                    // to X. Failing both of those we want to check if the aggregation of A and B's members structurally
                    // relates to X. Thus, we include intersection types on the source side here.
                    if (apparentSource.flags & (32768 /* Object */ | 131072 /* Intersection */) && target.flags & 32768 /* Object */) {
                        // Report structural errors only if we haven't reported any errors yet
                        var reportStructuralErrors = reportErrors && errorInfo === saveErrorInfo && !(source.flags & 8190 /* Primitive */);
                        if (result = objectTypeRelatedTo(apparentSource, source, target, reportStructuralErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                }
                if (reportErrors) {
                    if (source.flags & 32768 /* Object */ && target.flags & 8190 /* Primitive */) {
                        tryElaborateErrorsForPrimitivesAndObjects(source, target);
                    }
                    else if (source.symbol && source.flags & 32768 /* Object */ && globalObjectType === source) {
                        reportError(ts.Diagnostics.The_Object_type_is_assignable_to_very_few_other_types_Did_you_mean_to_use_the_any_type_instead);
                    }
                    reportRelationError(headMessage, source, target);
                }
                return 0 /* False */;
            }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{507,1} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{507,1} AS 1 AT <0:953>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{507,2} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{507,2} AS 2 AT <0:4927>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getConstraintOfTypeVariable) id{507,3} ---
(type) {
            return type.flags & 16384 /* TypeParameter */ ? getConstraintOfTypeParameter(type) :
                type.flags & 524288 /* IndexedAccess */ ? type.constraint :
                    undefined;
        }
--- END ---
INLINE (getConstraintOfTypeVariable) id{507,3} AS 3 AT <0:6792>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{507,4} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{507,4} AS 4 AT <0:8322>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeWithThisArgument) id{507,5} ---
(type, thisArgument) {
            if (getObjectFlags(type) & 4 /* Reference */) {
                return createTypeReference(type.target, ts.concatenate(type.typeArguments, [thisArgument || type.target.thisType]));
            }
            return type;
        }
--- END ---
INLINE (getTypeWithThisArgument) id{507,5} AS 5 AT <0:9283>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{507,6} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{507,6} AS 6 AT <5:39>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createTypeReference) id{507,7} ---
(target, typeArguments) {
            var id = getTypeListId(typeArguments);
            var type = target.instantiations[id];
            if (!type) {
                type = target.instantiations[id] = createObjectType(4 /* Reference */, target.symbol);
                type.flags |= typeArguments ? getPropagatingFlagsOfTypes(typeArguments, /*excludeKinds*/ 0) : 0;
                type.target = target;
                type.typeArguments = typeArguments;
            }
            return type;
        }
--- END ---
INLINE (createTypeReference) id{507,7} AS 7 AT <5:106>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createObjectType) id{507,8} ---
(objectFlags, symbol) {
            var type = createType(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol = symbol;
            return type;
        }
--- END ---
INLINE (createObjectType) id{507,8} AS 8 AT <7:203>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{507,9} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{507,9} AS 9 AT <8:47>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{507,10} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{507,10} AS 10 AT <9:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropagatingFlagsOfTypes) id{507,11} ---
(types, excludeKinds) {
            var result = 0;
            for (var _i = 0, types_3 = types; _i < types_3.length; _i++) {
                var type = types_3[_i];
                if (!(type.flags & excludeKinds)) {
                    result |= type.flags;
                }
            }
            return result & 14680064 /* PropagatingFlags */;
        }
--- END ---
INLINE (getPropagatingFlagsOfTypes) id{507,11} AS 11 AT <7:301>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{507,12} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{507,12} AS 12 AT <0:10374>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{507,13} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{507,13} AS 13 AT <0:10420>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getApparentType) id{507,14} ---
(type) {
            var t = type.flags & 540672 /* TypeVariable */ ? getApparentTypeOfTypeVariable(type) : type;
            return t.flags & 262178 /* StringLike */ ? globalStringType :
                t.flags & 340 /* NumberLike */ ? globalNumberType :
                    t.flags & 136 /* BooleanLike */ ? globalBooleanType :
                        t.flags & 512 /* ESSymbol */ ? getGlobalESSymbolType() :
                            t;
        }
--- END ---
INLINE (getApparentType) id{507,14} AS 14 AT <0:11022>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createUnaryTypeMapper) id{508,0} ---
(source, target) {
            return function (t) { return t === source ? target : t; };
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:addTypeToUnion) id{509,0} ---
(typeSet, type) {
            var flags = type.flags;
            if (flags & 65536 /* Union */) {
                addTypesToUnion(typeSet, type.types);
            }
            else if (flags & 1 /* Any */) {
                typeSet.containsAny = true;
            }
            else if (!strictNullChecks && flags & 6144 /* Nullable */) {
                if (flags & 2048 /* Undefined */)
                    typeSet.containsUndefined = true;
                if (flags & 4096 /* Null */)
                    typeSet.containsNull = true;
                if (!(flags & 2097152 /* ContainsWideningType */))
                    typeSet.containsNonWideningType = true;
            }
            else if (!(flags & 8192 /* Never */)) {
                if (flags & 2 /* String */)
                    typeSet.containsString = true;
                if (flags & 4 /* Number */)
                    typeSet.containsNumber = true;
                if (flags & 96 /* StringOrNumberLiteral */)
                    typeSet.containsStringOrNumberLiteral = true;
                var len = typeSet.length;
                var index = len && type.id > typeSet[len - 1].id ? ~len : binarySearchTypes(typeSet, type);
                if (index < 0) {
                    if (!(flags & 32768 /* Object */ && type.objectFlags & 16 /* Anonymous */ &&
                        type.symbol && type.symbol.flags & (16 /* Function */ | 8192 /* Method */) && containsIdenticalType(typeSet, type))) {
                        typeSet.splice(~index, 0, type);
                    }
                }
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:addTypesToUnion) id{509,1} ---
(typeSet, types) {
            for (var _i = 0, types_4 = types; _i < types_4.length; _i++) {
                var type = types_4[_i];
                addTypeToUnion(typeSet, type);
            }
        }
--- END ---
INLINE (addTypesToUnion) id{509,1} AS 1 AT <0:115>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:binarySearchTypes) id{509,2} ---
(types, type) {
            var low = 0;
            var high = types.length - 1;
            var typeId = type.id;
            while (low <= high) {
                var middle = low + ((high - low) >> 1);
                var id = types[middle].id;
                if (id === typeId) {
                    return middle;
                }
                else if (id > typeId) {
                    high = middle - 1;
                }
                else {
                    low = middle + 1;
                }
            }
            return ~low;
        }
--- END ---
INLINE (binarySearchTypes) id{509,2} AS 2 AT <0:1165>
[deoptimizing (DEOPT eager): begin 0x1030c9d3ca21 <JS Function checkInheritedPropertiesAreIdentical (SharedFunctionInfo 0x1b98fbc0f241)> (opt #488) @132, FP to SP delta: 352, caller sp: 0x7fff5fbfdf48]
            ;;; deoptimize at 0_671: wrong map
  reading input frame checkInheritedPropertiesAreIdentical => node=283, args=3, height=15; inputs:
      0: 0x1030c9d3ca21 ; [fp - 16] 0x1030c9d3ca21 <JS Function checkInheritedPropertiesAreIdentical (SharedFunctionInfo 0x1b98fbc0f241)>
      1: 0x1f9f6c0532e1 ; [fp + 32] 0x1f9f6c0532e1 <JS Global Object>
      2: 0xa76957cc941 ; [fp + 24] 0xa76957cc941 <a TypeObject with map 0x33abe2a73439>
      3: 0x33c6803678f9 ; [fp + 16] 0x33c6803678f9 <an IdentifierObject with map 0x33abe2a6fb81>
      4: 0xa76957ccde1 ; r9 0xa76957ccde1 <FixedArray[6]>
      5: 0x30bcea4069a9 ; (literal 31) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      6: 0x30bcea4043b1 ; r8 0x30bcea4043b1 <true>
      7: 3 ; (int) [fp - 184] 
      8: 0xa76957ccef1 ; [fp - 32] 0xa76957ccef1 <JS Array[9]>
      9: 0xa76957ccad9 ; rbx 0xa76957ccad9 <a TypeObject with map 0x33abe2a73599>
     10: 0x30bcea4069a9 ; (literal 31) 0x30bcea4069a9 <Odd Oddball: optimized_out>
     11: 0 ; rdi 
     12: 0x1030c9d4dca9 ; rax 0x1030c9d4dca9 <JS Array[0]>
     13: 0x30bcea404311 ; (literal 25) 0x30bcea404311 <undefined>
     14: 0x30bcea404311 ; (literal 25) 0x30bcea404311 <undefined>
     15: 0x30bcea404311 ; (literal 25) 0x30bcea404311 <undefined>
     16: 0x30bcea404311 ; (literal 25) 0x30bcea404311 <undefined>
     17: 0x30bcea404311 ; (literal 25) 0x30bcea404311 <undefined>
     18: 0x30bcea404311 ; (literal 25) 0x30bcea404311 <undefined>
  translating frame checkInheritedPropertiesAreIdentical => node=283, height=112
    0x7fff5fbfdf40: [top + 160] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdf38: [top + 152] <- 0xa76957cc941 ;  0xa76957cc941 <a TypeObject with map 0x33abe2a73439>  (input #2)
    0x7fff5fbfdf30: [top + 144] <- 0x33c6803678f9 ;  0x33c6803678f9 <an IdentifierObject with map 0x33abe2a6fb81>  (input #3)
    0x7fff5fbfdf28: [top + 136] <- 0x2c21d26090d7 ;  caller's pc
    0x7fff5fbfdf20: [top + 128] <- 0x7fff5fbfdf98 ;  caller's fp
    0x7fff5fbfdf18: [top + 120] <- 0xa76957ccde1 ;  context    0xa76957ccde1 <FixedArray[6]>  (input #4)
    0x7fff5fbfdf10: [top + 112] <- 0x1030c9d3ca21 ;  function    0x1030c9d3ca21 <JS Function checkInheritedPropertiesAreIdentical (SharedFunctionInfo 0x1b98fbc0f241)>  (input #0)
    0x7fff5fbfdf08: [top + 104] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #5)
    0x7fff5fbfdf00: [top + 96] <- 0x30bcea4043b1 ;  0x30bcea4043b1 <true>  (input #6)
    0x7fff5fbfdef8: [top + 88] <- 0x300000000 ;  3  (input #7)
    0x7fff5fbfdef0: [top + 80] <- 0xa76957ccef1 ;  0xa76957ccef1 <JS Array[9]>  (input #8)
    0x7fff5fbfdee8: [top + 72] <- 0xa76957ccad9 ;  0xa76957ccad9 <a TypeObject with map 0x33abe2a73599>  (input #9)
    0x7fff5fbfdee0: [top + 64] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #10)
    0x7fff5fbfded8: [top + 56] <- 0x00000000 ;  0  (input #11)
    0x7fff5fbfded0: [top + 48] <- 0x1030c9d4dca9 ;  0x1030c9d4dca9 <JS Array[0]>  (input #12)
    0x7fff5fbfdec8: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #13)
    0x7fff5fbfdec0: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #14)
    0x7fff5fbfdeb8: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #15)
    0x7fff5fbfdeb0: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #16)
    0x7fff5fbfdea8: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #17)
    0x7fff5fbfdea0: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #18)
[deoptimizing (eager): end 0x1030c9d3ca21 <JS Function checkInheritedPropertiesAreIdentical (SharedFunctionInfo 0x1b98fbc0f241)> @132 => node=283, pc=0x2c21d260af0b, caller sp=0x7fff5fbfdf48, state=NO_REGISTERS, took 0.111 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d45369 <JS Function addInheritedMembers (SharedFunctionInfo 0x2e2f693eea91)> (opt #465) @2, FP to SP delta: 40, caller sp: 0x7fff5fbfd948]
            ;;; deoptimize at 0_101: wrong map
  reading input frame addInheritedMembers => node=14, args=3, height=4; inputs:
      0: 0x1030c9d45369 ; [fp - 16] 0x1030c9d45369 <JS Function addInheritedMembers (SharedFunctionInfo 0x2e2f693eea91)>
      1: 0x1f9f6c0532e1 ; [fp + 32] 0x1f9f6c0532e1 <JS Global Object>
      2: 0xa76957d1171 ; [fp + 24] 0xa76957d1171 <an Object with map 0x15b5a79120c1>
      3: 0x1030c9d4dca9 ; rax 0x1030c9d4dca9 <JS Array[0]>
      4: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      5: 0 ; rbx 
      6: 0x1030c9d4dca9 ; rax 0x1030c9d4dca9 <JS Array[0]>
      7: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
  translating frame addInheritedMembers => node=14, height=24
    0x7fff5fbfd940: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd938: [top + 64] <- 0xa76957d1171 ;  0xa76957d1171 <an Object with map 0x15b5a79120c1>  (input #2)
    0x7fff5fbfd930: [top + 56] <- 0x1030c9d4dca9 ;  0x1030c9d4dca9 <JS Array[0]>  (input #3)
    0x7fff5fbfd928: [top + 48] <- 0x2c21d260f765 ;  caller's pc
    0x7fff5fbfd920: [top + 40] <- 0x7fff5fbfd9c0 ;  caller's fp
    0x7fff5fbfd918: [top + 32] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #4)
    0x7fff5fbfd910: [top + 24] <- 0x1030c9d45369 ;  function    0x1030c9d45369 <JS Function addInheritedMembers (SharedFunctionInfo 0x2e2f693eea91)>  (input #0)
    0x7fff5fbfd908: [top + 16] <- 0x00000000 ;  0  (input #5)
    0x7fff5fbfd900: [top + 8] <- 0x1030c9d4dca9 ;  0x1030c9d4dca9 <JS Array[0]>  (input #6)
    0x7fff5fbfd8f8: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
[deoptimizing (eager): end 0x1030c9d45369 <JS Function addInheritedMembers (SharedFunctionInfo 0x2e2f693eea91)> @2 => node=14, pc=0x2c21d26307c4, caller sp=0x7fff5fbfd948, state=NO_REGISTERS, took 0.057 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarMethod) id{510,0} ---
(node) {
            if (checkGrammarDisallowedModifiersOnObjectLiteralExpressionMethod(node) ||
                checkGrammarFunctionLikeDeclaration(node) ||
                checkGrammarForGenerator(node)) {
                return true;
            }
            if (node.parent.kind === 176 /* ObjectLiteralExpression */) {
                if (checkGrammarForInvalidQuestionMark(node.questionToken, ts.Diagnostics.An_object_member_cannot_be_declared_optional)) {
                    return true;
                }
                else if (node.body === undefined) {
                    return grammarErrorAtPos(ts.getSourceFileOfNode(node), node.end - 1, ";".length, ts.Diagnostics._0_expected, "{");
                }
            }
            if (ts.isClassLike(node.parent)) {
                // Technically, computed properties in ambient contexts is disallowed
                // for property declarations and accessors too, not just methods.
                // However, property declarations disallow computed names in general,
                // and accessors are not allowed in ambient contexts in general,
                // so this error only really matters for methods.
                if (ts.isInAmbientContext(node)) {
                    return checkGrammarForNonSymbolComputedProperty(node.name, ts.Diagnostics.A_computed_property_name_in_an_ambient_context_must_directly_refer_to_a_built_in_symbol);
                }
                else if (!node.body) {
                    return checkGrammarForNonSymbolComputedProperty(node.name, ts.Diagnostics.A_computed_property_name_in_a_method_overload_must_directly_refer_to_a_built_in_symbol);
                }
            }
            else if (node.parent.kind === 227 /* InterfaceDeclaration */) {
                return checkGrammarForNonSymbolComputedProperty(node.name, ts.Diagnostics.A_computed_property_name_in_an_interface_must_directly_refer_to_a_built_in_symbol);
            }
            else if (node.parent.kind === 161 /* TypeLiteral */) {
                return checkGrammarForNonSymbolComputedProperty(node.name, ts.Diagnostics.A_computed_property_name_in_a_type_literal_must_directly_refer_to_a_built_in_symbol);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarFunctionLikeDeclaration) id{510,1} ---
(node) {
            // Prevent cascading error by short-circuit
            var file = ts.getSourceFileOfNode(node);
            return checkGrammarDecorators(node) || checkGrammarModifiers(node) || checkGrammarTypeParameterList(node.typeParameters, file) ||
                checkGrammarParameterList(node.parameters) || checkGrammarArrowFunction(node, file);
        }
--- END ---
INLINE (checkGrammarFunctionLikeDeclaration) id{510,1} AS 1 AT <0:113>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarTypeParameterList) id{510,2} ---
(typeParameters, file) {
            if (checkGrammarForDisallowedTrailingComma(typeParameters)) {
                return true;
            }
            if (typeParameters && typeParameters.length === 0) {
                var start = typeParameters.pos - "<".length;
                var end = ts.skipTrivia(file.text, typeParameters.end) + ">".length;
                return grammarErrorAtPos(file, start, end - start, ts.Diagnostics.Type_parameter_list_cannot_be_empty);
            }
        }
--- END ---
INLINE (checkGrammarTypeParameterList) id{510,2} AS 2 AT <1:200>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarForDisallowedTrailingComma) id{510,3} ---
(list) {
            if (list && list.hasTrailingComma) {
                var start = list.end - ",".length;
                var end = list.end;
                var sourceFile = ts.getSourceFileOfNode(list[0]);
                return grammarErrorAtPos(sourceFile, start, end - start, ts.Diagnostics.Trailing_comma_not_allowed);
            }
        }
--- END ---
INLINE (checkGrammarForDisallowedTrailingComma) id{510,3} AS 3 AT <2:41>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarForNonSymbolComputedProperty) id{510,4} ---
(node, message) {
            if (ts.isDynamicName(node)) {
                return grammarErrorOnNode(node, message);
            }
        }
--- END ---
INLINE (checkGrammarForNonSymbolComputedProperty) id{510,4} AS 4 AT <0:1788>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarForNonSymbolComputedProperty) id{510,5} ---
(node, message) {
            if (ts.isDynamicName(node)) {
                return grammarErrorOnNode(node, message);
            }
        }
--- END ---
INLINE (checkGrammarForNonSymbolComputedProperty) id{510,5} AS 5 AT <0:2043>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkObjectTypeForDuplicateDeclarations) id{511,0} ---
(node) {
            var names = ts.createMap();
            for (var _i = 0, _a = node.members; _i < _a.length; _i++) {
                var member = _a[_i];
                if (member.kind == 146 /* PropertySignature */) {
                    var memberName = void 0;
                    switch (member.name.kind) {
                        case 9 /* StringLiteral */:
                        case 8 /* NumericLiteral */:
                        case 70 /* Identifier */:
                            memberName = member.name.text;
                            break;
                        default:
                            continue;
                    }
                    if (names[memberName]) {
                        error(member.symbol.valueDeclaration.name, ts.Diagnostics.Duplicate_identifier_0, memberName);
                        error(member.name, ts.Diagnostics.Duplicate_identifier_0, memberName);
                    }
                    else {
                        names[memberName] = true;
                    }
                }
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkFunctionOrConstructorSymbol) id{512,0} ---
(symbol) {
            if (!produceDiagnostics) {
                return;
            }
            function getCanonicalOverload(overloads, implementation) {
                // Consider the canonical set of flags to be the flags of the bodyDeclaration or the first declaration
                // Error on all deviations from this canonical set of flags
                // The caveat is that if some overloads are defined in lib.d.ts, we don't want to
                // report the errors on those. To achieve this, we will say that the implementation is
                // the canonical signature only if it is in the same container as the first overload
                var implementationSharesContainerWithFirstOverload = implementation !== undefined && implementation.parent === overloads[0].parent;
                return implementationSharesContainerWithFirstOverload ? implementation : overloads[0];
            }
            function checkFlagAgreementBetweenOverloads(overloads, implementation, flagsToCheck, someOverloadFlags, allOverloadFlags) {
                // Error if some overloads have a flag that is not shared by all overloads. To find the
                // deviations, we XOR someOverloadFlags with allOverloadFlags
                var someButNotAllOverloadFlags = someOverloadFlags ^ allOverloadFlags;
                if (someButNotAllOverloadFlags !== 0) {
                    var canonicalFlags_1 = getEffectiveDeclarationFlags(getCanonicalOverload(overloads, implementation), flagsToCheck);
                    ts.forEach(overloads, function (o) {
                        var deviation = getEffectiveDeclarationFlags(o, flagsToCheck) ^ canonicalFlags_1;
                        if (deviation & 1 /* Export */) {
                            error(o.name, ts.Diagnostics.Overload_signatures_must_all_be_exported_or_non_exported);
                        }
                        else if (deviation & 2 /* Ambient */) {
                            error(o.name, ts.Diagnostics.Overload_signatures_must_all_be_ambient_or_non_ambient);
                        }
                        else if (deviation & (8 /* Private */ | 16 /* Protected */)) {
                            error(o.name || o, ts.Diagnostics.Overload_signatures_must_all_be_public_private_or_protected);
                        }
                        else if (deviation & 128 /* Abstract */) {
                            error(o.name, ts.Diagnostics.Overload_signatures_must_all_be_abstract_or_non_abstract);
                        }
                    });
                }
            }
            function checkQuestionTokenAgreementBetweenOverloads(overloads, implementation, someHaveQuestionToken, allHaveQuestionToken) {
                if (someHaveQuestionToken !== allHaveQuestionToken) {
                    var canonicalHasQuestionToken_1 = ts.hasQuestionToken(getCanonicalOverload(overloads, implementation));
                    ts.forEach(overloads, function (o) {
                        var deviation = ts.hasQuestionToken(o) !== canonicalHasQuestionToken_1;
                        if (deviation) {
                            error(o.name, ts.Diagnostics.Overload_signatures_must_all_be_optional_or_required);
                        }
                    });
                }
            }
            var flagsToCheck = 1 /* Export */ | 2 /* Ambient */ | 8 /* Private */ | 16 /* Protected */ | 128 /* Abstract */;
            var someNodeFlags = 0 /* None */;
            var allNodeFlags = flagsToCheck;
            var someHaveQuestionToken = false;
            var allHaveQuestionToken = true;
            var hasOverloads = false;
            var bodyDeclaration;
            var lastSeenNonAmbientDeclaration;
            var previousDeclaration;
            var declarations = symbol.declarations;
            var isConstructor = (symbol.flags & 16384 /* Constructor */) !== 0;
            function reportImplementationExpectedError(node) {
                if (node.name && ts.nodeIsMissing(node.name)) {
                    return;
                }
                var seen = false;
                var subsequentNode = ts.forEachChild(node.parent, function (c) {
                    if (seen) {
                        return c;
                    }
                    else {
                        seen = c === node;
                    }
                });
                // We may be here because of some extra nodes between overloads that could not be parsed into a valid node.
                // In this case the subsequent node is not really consecutive (.pos !== node.end), and we must ignore it here.
                if (subsequentNode && subsequentNode.pos === node.end) {
                    if (subsequentNode.kind === node.kind) {
                        var errorNode_1 = subsequentNode.name || subsequentNode;
                        // TODO(jfreeman): These are methods, so handle computed name case
                        if (node.name && subsequentNode.name && node.name.text === subsequentNode.name.text) {
                            var reportError = (node.kind === 149 /* MethodDeclaration */ || node.kind === 148 /* MethodSignature */) &&
                                (ts.getModifierFlags(node) & 32 /* Static */) !== (ts.getModifierFlags(subsequentNode) & 32 /* Static */);
                            // we can get here in two cases
                            // 1. mixed static and instance class members
                            // 2. something with the same name was defined before the set of overloads that prevents them from merging
                            // here we'll report error only for the first case since for second we should already report error in binder
                            if (reportError) {
                                var diagnostic = ts.getModifierFlags(node) & 32 /* Static */ ? ts.Diagnostics.Function_overload_must_be_static : ts.Diagnostics.Function_overload_must_not_be_static;
                                error(errorNode_1, diagnostic);
                            }
                            return;
                        }
                        else if (ts.nodeIsPresent(subsequentNode.body)) {
                            error(errorNode_1, ts.Diagnostics.Function_implementation_name_must_be_0, ts.declarationNameToString(node.name));
                            return;
                        }
                    }
                }
                var errorNode = node.name || node;
                if (isConstructor) {
                    error(errorNode, ts.Diagnostics.Constructor_implementation_is_missing);
                }
                else {
                    // Report different errors regarding non-consecutive blocks of declarations depending on whether
                    // the node in question is abstract.
                    if (ts.getModifierFlags(node) & 128 /* Abstract */) {
                        error(errorNode, ts.Diagnostics.All_declarations_of_an_abstract_method_must_be_consecutive);
                    }
                    else {
                        error(errorNode, ts.Diagnostics.Function_implementation_is_missing_or_not_immediately_following_the_declaration);
                    }
                }
            }
            var duplicateFunctionDeclaration = false;
            var multipleConstructorImplementation = false;
            for (var _i = 0, declarations_4 = declarations; _i < declarations_4.length; _i++) {
                var current = declarations_4[_i];
                var node = current;
                var inAmbientContext = ts.isInAmbientContext(node);
                var inAmbientContextOrInterface = node.parent.kind === 227 /* InterfaceDeclaration */ || node.parent.kind === 161 /* TypeLiteral */ || inAmbientContext;
                if (inAmbientContextOrInterface) {
                    // check if declarations are consecutive only if they are non-ambient
                    // 1. ambient declarations can be interleaved
                    // i.e. this is legal
                    //     declare function foo();
                    //     declare function bar();
                    //     declare function foo();
                    // 2. mixing ambient and non-ambient declarations is a separate error that will be reported - do not want to report an extra one
                    previousDeclaration = undefined;
                }
                if (node.kind === 225 /* FunctionDeclaration */ || node.kind === 149 /* MethodDeclaration */ || node.kind === 148 /* MethodSignature */ || node.kind === 150 /* Constructor */) {
                    var currentNodeFlags = getEffectiveDeclarationFlags(node, flagsToCheck);
                    someNodeFlags |= currentNodeFlags;
                    allNodeFlags &= currentNodeFlags;
                    someHaveQuestionToken = someHaveQuestionToken || ts.hasQuestionToken(node);
                    allHaveQuestionToken = allHaveQuestionToken && ts.hasQuestionToken(node);
                    if (ts.nodeIsPresent(node.body) && bodyDeclaration) {
                        if (isConstructor) {
                            multipleConstructorImplementation = true;
                        }
                        else {
                            duplicateFunctionDeclaration = true;
                        }
                    }
                    else if (previousDeclaration && previousDeclaration.parent === node.parent && previousDeclaration.end !== node.pos) {
                        reportImplementationExpectedError(previousDeclaration);
                    }
                    if (ts.nodeIsPresent(node.body)) {
                        if (!bodyDeclaration) {
                            bodyDeclaration = node;
                        }
                    }
                    else {
                        hasOverloads = true;
                    }
                    previousDeclaration = node;
                    if (!inAmbientContextOrInterface) {
                        lastSeenNonAmbientDeclaration = node;
                    }
                }
            }
            if (multipleConstructorImplementation) {
                ts.forEach(declarations, function (declaration) {
                    error(declaration, ts.Diagnostics.Multiple_constructor_implementations_are_not_allowed);
                });
            }
            if (duplicateFunctionDeclaration) {
                ts.forEach(declarations, function (declaration) {
                    error(declaration.name, ts.Diagnostics.Duplicate_function_implementation);
                });
            }
            // Abstract methods can't have an implementation -- in particular, they don't need one.
            if (lastSeenNonAmbientDeclaration && !lastSeenNonAmbientDeclaration.body &&
                !(ts.getModifierFlags(lastSeenNonAmbientDeclaration) & 128 /* Abstract */) && !lastSeenNonAmbientDeclaration.questionToken) {
                reportImplementationExpectedError(lastSeenNonAmbientDeclaration);
            }
            if (hasOverloads) {
                checkFlagAgreementBetweenOverloads(declarations, bodyDeclaration, flagsToCheck, someNodeFlags, allNodeFlags);
                checkQuestionTokenAgreementBetweenOverloads(declarations, bodyDeclaration, someHaveQuestionToken, allHaveQuestionToken);
                if (bodyDeclaration) {
                    var signatures = getSignaturesOfSymbol(symbol);
                    var bodySignature = getSignatureFromDeclaration(bodyDeclaration);
                    for (var _a = 0, signatures_3 = signatures; _a < signatures_3.length; _a++) {
                        var signature = signatures_3[_a];
                        if (!isImplementationCompatibleWithOverload(bodySignature, signature)) {
                            error(signature.declaration, ts.Diagnostics.Overload_signature_is_not_compatible_with_function_implementation);
                            break;
                        }
                    }
                }
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeFromUnionTypeNode) id{513,0} ---
(node) {
            var links = getNodeLinks(node);
            if (!links.resolvedType) {
                links.resolvedType = getUnionType(ts.map(node.types, getTypeFromTypeNode), /*subtypeReduction*/ false, getAliasSymbolForTypeNode(node), getAliasTypeArgumentsForTypeNode(node));
            }
            return links.resolvedType;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeLinks) id{513,1} ---
(node) {
            var nodeId = getNodeId(node);
            return nodeLinks[nodeId] || (nodeLinks[nodeId] = { flags: 0 });
        }
--- END ---
INLINE (getNodeLinks) id{513,1} AS 1 AT <0:33>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeId) id{513,2} ---
(node) {
        if (!node.id) {
            node.id = nextNodeId;
            nextNodeId++;
        }
        return node.id;
    }
--- END ---
INLINE (getNodeId) id{513,2} AS 2 AT <1:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getAliasSymbolForTypeNode) id{513,3} ---
(node) {
            return node.parent.kind === 228 /* TypeAliasDeclaration */ ? getSymbolOfNode(node.parent) : undefined;
        }
--- END ---
INLINE (getAliasSymbolForTypeNode) id{513,3} AS 3 AT <0:211>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{513,4} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{513,4} AS 4 AT <3:82>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{513,5} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{513,5} AS 5 AT <4:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getAliasTypeArgumentsForTypeNode) id{513,6} ---
(node) {
            var symbol = getAliasSymbolForTypeNode(node);
            return symbol ? getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol) : undefined;
        }
--- END ---
INLINE (getAliasTypeArgumentsForTypeNode) id{513,6} AS 6 AT <0:244>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getAliasSymbolForTypeNode) id{513,7} ---
(node) {
            return node.parent.kind === 228 /* TypeAliasDeclaration */ ? getSymbolOfNode(node.parent) : undefined;
        }
--- END ---
INLINE (getAliasSymbolForTypeNode) id{513,7} AS 7 AT <6:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{513,8} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{513,8} AS 8 AT <7:82>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{513,9} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{513,9} AS 9 AT <8:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkInheritedPropertiesAreIdentical) id{514,0} ---
(type, typeNode) {
            var baseTypes = getBaseTypes(type);
            if (baseTypes.length < 2) {
                return true;
            }
            var seen = ts.createMap();
            ts.forEach(resolveDeclaredMembers(type).declaredProperties, function (p) { seen[p.name] = { prop: p, containingType: type }; });
            var ok = true;
            for (var _i = 0, baseTypes_2 = baseTypes; _i < baseTypes_2.length; _i++) {
                var base = baseTypes_2[_i];
                var properties = getPropertiesOfObjectType(getTypeWithThisArgument(base, type.thisType));
                for (var _a = 0, properties_7 = properties; _a < properties_7.length; _a++) {
                    var prop = properties_7[_a];
                    var existing = seen[prop.name];
                    if (!existing) {
                        seen[prop.name] = { prop: prop, containingType: base };
                    }
                    else {
                        var isInheritedProperty = existing.containingType !== type;
                        if (isInheritedProperty && !isPropertyIdenticalTo(existing.prop, prop)) {
                            ok = false;
                            var typeName1 = typeToString(existing.containingType);
                            var typeName2 = typeToString(base);
                            var errorInfo = ts.chainDiagnosticMessages(undefined, ts.Diagnostics.Named_property_0_of_types_1_and_2_are_not_identical, symbolToString(prop), typeName1, typeName2);
                            errorInfo = ts.chainDiagnosticMessages(errorInfo, ts.Diagnostics.Interface_0_cannot_simultaneously_extend_types_1_and_2, typeToString(type), typeName1, typeName2);
                            diagnostics.add(ts.createDiagnosticForNodeFromMessageChain(typeNode, errorInfo));
                        }
                    }
                }
            }
            return ok;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveDeclaredMembers) id{514,1} ---
(type) {
            if (!type.declaredProperties) {
                var symbol = type.symbol;
                type.declaredProperties = getNamedMembers(symbol.members);
                type.declaredCallSignatures = getSignaturesOfSymbol(symbol.members["__call"]);
                type.declaredConstructSignatures = getSignaturesOfSymbol(symbol.members["__new"]);
                type.declaredStringIndexInfo = getIndexInfoOfSymbol(symbol, 0 /* String */);
                type.declaredNumberIndexInfo = getIndexInfoOfSymbol(symbol, 1 /* Number */);
            }
            return type;
        }
--- END ---
INLINE (resolveDeclaredMembers) id{514,1} AS 1 AT <0:212>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNamedMembers) id{514,2} ---
(members) {
            var result;
            for (var id in members) {
                if (!isReservedMemberName(id)) {
                    if (!result)
                        result = [];
                    var symbol = members[id];
                    if (symbolIsValue(symbol)) {
                        result.push(symbol);
                    }
                }
            }
            return result || emptyArray;
        }
--- END ---
INLINE (getNamedMembers) id{514,2} AS 2 AT <1:137>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isReservedMemberName) id{514,3} ---
(name) {
            return name.charCodeAt(0) === 95 /* _ */ &&
                name.charCodeAt(1) === 95 /* _ */ &&
                name.charCodeAt(2) !== 95 /* _ */ &&
                name.charCodeAt(2) !== 64 /* at */;
        }
--- END ---
INLINE (isReservedMemberName) id{514,3} AS 3 AT <2:95>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexInfoOfSymbol) id{514,4} ---
(symbol, kind) {
            var declaration = getIndexDeclarationOfSymbol(symbol, kind);
            if (declaration) {
                return createIndexInfo(declaration.type ? getTypeFromTypeNode(declaration.type) : anyType, (ts.getModifierFlags(declaration) & 64 /* Readonly */) !== 0, declaration);
            }
            return undefined;
        }
--- END ---
INLINE (getIndexInfoOfSymbol) id{514,4} AS 4 AT <1:411>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createIndexInfo) id{514,5} ---
(type, isReadonly, declaration) {
            return { type: type, isReadonly: isReadonly, declaration: declaration };
        }
--- END ---
INLINE (createIndexInfo) id{514,5} AS 5 AT <4:144>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexInfoOfSymbol) id{514,6} ---
(symbol, kind) {
            var declaration = getIndexDeclarationOfSymbol(symbol, kind);
            if (declaration) {
                return createIndexInfo(declaration.type ? getTypeFromTypeNode(declaration.type) : anyType, (ts.getModifierFlags(declaration) & 64 /* Readonly */) !== 0, declaration);
            }
            return undefined;
        }
--- END ---
INLINE (getIndexInfoOfSymbol) id{514,6} AS 6 AT <1:504>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createIndexInfo) id{514,7} ---
(type, isReadonly, declaration) {
            return { type: type, isReadonly: isReadonly, declaration: declaration };
        }
--- END ---
INLINE (createIndexInfo) id{514,7} AS 7 AT <6:144>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeWithThisArgument) id{514,8} ---
(type, thisArgument) {
            if (getObjectFlags(type) & 4 /* Reference */) {
                return createTypeReference(type.target, ts.concatenate(type.typeArguments, [thisArgument || type.target.thisType]));
            }
            return type;
        }
--- END ---
INLINE (getTypeWithThisArgument) id{514,8} AS 8 AT <0:547>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{514,9} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{514,9} AS 9 AT <8:39>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createTypeReference) id{514,10} ---
(target, typeArguments) {
            var id = getTypeListId(typeArguments);
            var type = target.instantiations[id];
            if (!type) {
                type = target.instantiations[id] = createObjectType(4 /* Reference */, target.symbol);
                type.flags |= typeArguments ? getPropagatingFlagsOfTypes(typeArguments, /*excludeKinds*/ 0) : 0;
                type.target = target;
                type.typeArguments = typeArguments;
            }
            return type;
        }
--- END ---
INLINE (createTypeReference) id{514,10} AS 10 AT <8:106>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createObjectType) id{514,11} ---
(objectFlags, symbol) {
            var type = createType(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol = symbol;
            return type;
        }
--- END ---
INLINE (createObjectType) id{514,11} AS 11 AT <10:203>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{514,12} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{514,12} AS 12 AT <11:47>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{514,13} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{514,13} AS 13 AT <12:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropagatingFlagsOfTypes) id{514,14} ---
(types, excludeKinds) {
            var result = 0;
            for (var _i = 0, types_3 = types; _i < types_3.length; _i++) {
                var type = types_3[_i];
                if (!(type.flags & excludeKinds)) {
                    result |= type.flags;
                }
            }
            return result & 14680064 /* PropagatingFlags */;
        }
--- END ---
INLINE (getPropagatingFlagsOfTypes) id{514,14} AS 14 AT <10:301>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeFromTypeOperatorNode) id{515,0} ---
(node) {
            var links = getNodeLinks(node);
            if (!links.resolvedType) {
                links.resolvedType = getIndexType(getTypeFromTypeNode(node.type));
            }
            return links.resolvedType;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeLinks) id{515,1} ---
(node) {
            var nodeId = getNodeId(node);
            return nodeLinks[nodeId] || (nodeLinks[nodeId] = { flags: 0 });
        }
--- END ---
INLINE (getNodeLinks) id{515,1} AS 1 AT <0:33>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeId) id{515,2} ---
(node) {
        if (!node.id) {
            node.id = nextNodeId;
            nextNodeId++;
        }
        return node.id;
    }
--- END ---
INLINE (getNodeId) id{515,2} AS 2 AT <1:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexType) id{515,3} ---
(type) {
            return maybeTypeOfKind(type, 540672 /* TypeVariable */) ? getIndexTypeForGenericType(type) :
                getObjectFlags(type) & 32 /* Mapped */ ? getConstraintTypeFromMappedType(type) :
                    type.flags & 1 /* Any */ || getIndexInfoOfType(type, 0 /* String */) ? stringType :
                        getLiteralTypeFromPropertyNames(type);
        }
--- END ---
INLINE (getIndexType) id{515,3} AS 3 AT <0:129>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:maybeTypeOfKind) id{515,4} ---
(type, kind) {
            if (type.flags & kind) {
                return true;
            }
            if (type.flags & 196608 /* UnionOrIntersection */) {
                var types = type.types;
                for (var _i = 0, types_15 = types; _i < types_15.length; _i++) {
                    var t = types_15[_i];
                    if (maybeTypeOfKind(t, kind)) {
                        return true;
                    }
                }
            }
            return false;
        }
--- END ---
INLINE (maybeTypeOfKind) id{515,4} AS 4 AT <3:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexTypeForGenericType) id{515,5} ---
(type) {
            if (!type.resolvedIndexType) {
                type.resolvedIndexType = createType(262144 /* Index */);
                type.resolvedIndexType.type = type;
            }
            return type.resolvedIndexType;
        }
--- END ---
INLINE (getIndexTypeForGenericType) id{515,5} AS 5 AT <3:79>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{515,6} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{515,6} AS 6 AT <5:93>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{515,7} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{515,7} AS 7 AT <6:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{515,8} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{515,8} AS 8 AT <3:130>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexInfoOfType) id{515,9} ---
(type, kind) {
            return getIndexInfoOfStructuredType(getApparentType(type), kind);
        }
--- END ---
INLINE (getIndexInfoOfType) id{515,9} AS 9 AT <3:259>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getApparentType) id{515,10} ---
(type) {
            var t = type.flags & 540672 /* TypeVariable */ ? getApparentTypeOfTypeVariable(type) : type;
            return t.flags & 262178 /* StringLike */ ? globalStringType :
                t.flags & 340 /* NumberLike */ ? globalNumberType :
                    t.flags & 136 /* BooleanLike */ ? globalBooleanType :
                        t.flags & 512 /* ESSymbol */ ? getGlobalESSymbolType() :
                            t;
        }
--- END ---
INLINE (getApparentType) id{515,10} AS 10 AT <9:63>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexInfoOfStructuredType) id{515,11} ---
(type, kind) {
            if (type.flags & 229376 /* StructuredType */) {
                var resolved = resolveStructuredTypeMembers(type);
                return kind === 0 /* String */ ? resolved.stringIndexInfo : resolved.numberIndexInfo;
            }
        }
--- END ---
INLINE (getIndexInfoOfStructuredType) id{515,11} AS 11 AT <9:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getLiteralTypeFromPropertyNames) id{515,12} ---
(type) {
            return getUnionType(ts.map(getPropertiesOfType(type), getLiteralTypeFromPropertyName));
        }
--- END ---
INLINE (getLiteralTypeFromPropertyNames) id{515,12} AS 12 AT <3:339>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropertiesOfType) id{515,13} ---
(type) {
            type = getApparentType(type);
            return type.flags & 196608 /* UnionOrIntersection */ ?
                getPropertiesOfUnionOrIntersectionType(type) :
                getPropertiesOfObjectType(type);
        }
--- END ---
INLINE (getPropertiesOfType) id{515,13} AS 13 AT <12:48>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getApparentType) id{515,14} ---
(type) {
            var t = type.flags & 540672 /* TypeVariable */ ? getApparentTypeOfTypeVariable(type) : type;
            return t.flags & 262178 /* StringLike */ ? globalStringType :
                t.flags & 340 /* NumberLike */ ? globalNumberType :
                    t.flags & 136 /* BooleanLike */ ? globalBooleanType :
                        t.flags & 512 /* ESSymbol */ ? getGlobalESSymbolType() :
                            t;
        }
--- END ---
INLINE (getApparentType) id{515,14} AS 14 AT <13:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropertiesOfObjectType) id{515,15} ---
(type) {
            if (type.flags & 32768 /* Object */) {
                return resolveStructuredTypeMembers(type).properties;
            }
            return emptyArray;
        }
--- END ---
INLINE (getPropertiesOfObjectType) id{515,15} AS 15 AT <13:197>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:addInheritedMembers) id{516,0} ---
(symbols, baseSymbols) {
            for (var _i = 0, baseSymbols_1 = baseSymbols; _i < baseSymbols_1.length; _i++) {
                var s = baseSymbols_1[_i];
                if (!symbols[s.name]) {
                    symbols[s.name] = s;
                }
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeParametersFromDeclaration) id{517,0} ---
(typeParameterDeclarations) {
            var result = [];
            ts.forEach(typeParameterDeclarations, function (node) {
                var tp = getDeclaredTypeOfTypeParameter(node.symbol);
                if (!ts.contains(result, tp)) {
                    result.push(tp);
                }
            });
            return result;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getDeclarationModifierFlagsFromSymbol) id{518,0} ---
(s) {
            return s.valueDeclaration ? ts.getCombinedModifierFlags(s.valueDeclaration) : s.flags & 134217728 /* Prototype */ ? 4 /* Public */ | 32 /* Static */ : 0;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeFromIndexedAccessTypeNode) id{519,0} ---
(node) {
            var links = getNodeLinks(node);
            if (!links.resolvedType) {
                links.resolvedType = getIndexedAccessType(getTypeFromTypeNode(node.objectType), getTypeFromTypeNode(node.indexType), node);
            }
            return links.resolvedType;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeLinks) id{519,1} ---
(node) {
            var nodeId = getNodeId(node);
            return nodeLinks[nodeId] || (nodeLinks[nodeId] = { flags: 0 });
        }
--- END ---
INLINE (getNodeLinks) id{519,1} AS 1 AT <0:33>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeId) id{519,2} ---
(node) {
        if (!node.id) {
            node.id = nextNodeId;
            nextNodeId++;
        }
        return node.id;
    }
--- END ---
INLINE (getNodeId) id{519,2} AS 2 AT <1:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:) id{520,0} ---
(heritageElement) {
                if (!ts.isEntityNameExpression(heritageElement.expression)) {
                    error(heritageElement.expression, ts.Diagnostics.An_interface_can_only_extend_an_identifier_Slashqualified_name_with_optional_type_arguments);
                }
                checkTypeReferenceNode(heritageElement);
            }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkIndexedAccessType) id{521,0} ---
(node) {
            getTypeFromIndexedAccessTypeNode(node);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeFromIndexedAccessTypeNode) id{521,1} ---
(node) {
            var links = getNodeLinks(node);
            if (!links.resolvedType) {
                links.resolvedType = getIndexedAccessType(getTypeFromTypeNode(node.objectType), getTypeFromTypeNode(node.indexType), node);
            }
            return links.resolvedType;
        }
--- END ---
INLINE (getTypeFromIndexedAccessTypeNode) id{521,1} AS 1 AT <0:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeLinks) id{521,2} ---
(node) {
            var nodeId = getNodeId(node);
            return nodeLinks[nodeId] || (nodeLinks[nodeId] = { flags: 0 });
        }
--- END ---
INLINE (getNodeLinks) id{521,2} AS 2 AT <1:33>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeId) id{521,3} ---
(node) {
        if (!node.id) {
            node.id = nextNodeId;
            nextNodeId++;
        }
        return node.id;
    }
--- END ---
INLINE (getNodeId) id{521,3} AS 3 AT <2:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateAnonymousType) id{522,0} ---
(type, mapper) {
            var result = createObjectType(16 /* Anonymous */ | 64 /* Instantiated */, type.symbol);
            result.target = type.objectFlags & 64 /* Instantiated */ ? type.target : type;
            result.mapper = type.objectFlags & 64 /* Instantiated */ ? combineTypeMappers(type.mapper, mapper) : mapper;
            result.aliasSymbol = type.aliasSymbol;
            result.aliasTypeArguments = instantiateTypes(type.aliasTypeArguments, mapper);
            return result;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createObjectType) id{522,1} ---
(objectFlags, symbol) {
            var type = createType(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol = symbol;
            return type;
        }
--- END ---
INLINE (createObjectType) id{522,1} AS 1 AT <0:42>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{522,2} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{522,2} AS 2 AT <1:47>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{522,3} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{522,3} AS 3 AT <2:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateTypes) id{522,4} ---
(types, mapper) {
            return instantiateList(types, mapper, instantiateType);
        }
--- END ---
INLINE (instantiateTypes) id{522,4} AS 4 AT <0:420>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateList) id{522,5} ---
(items, mapper, instantiator) {
            if (items && items.length) {
                var result = [];
                for (var _i = 0, items_1 = items; _i < items_1.length; _i++) {
                    var v = items_1[_i];
                    result.push(instantiator(v, mapper));
                }
                return result;
            }
            return items;
        }
--- END ---
INLINE (instantiateList) id{522,5} AS 5 AT <4:37>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNumParametersToCheckForSignatureRelatability) id{523,0} ---
(source, sourceNonRestParamCount, target, targetNonRestParamCount) {
            if (source.hasRestParameter === target.hasRestParameter) {
                if (source.hasRestParameter) {
                    // If both have rest parameters, get the max and add 1 to
                    // compensate for the rest parameter.
                    return Math.max(sourceNonRestParamCount, targetNonRestParamCount) + 1;
                }
                else {
                    return Math.min(sourceNonRestParamCount, targetNonRestParamCount);
                }
            }
            else {
                // Return the count for whichever signature doesn't have rest parameters.
                return source.hasRestParameter ?
                    targetNonRestParamCount :
                    sourceNonRestParamCount;
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarVariableDeclaration) id{524,0} ---
(node) {
            if (node.parent.parent.kind !== 212 /* ForInStatement */ && node.parent.parent.kind !== 213 /* ForOfStatement */) {
                if (ts.isInAmbientContext(node)) {
                    if (node.initializer) {
                        if (ts.isConst(node) && !node.type) {
                            if (!isStringOrNumberLiteralExpression(node.initializer)) {
                                return grammarErrorOnNode(node.initializer, ts.Diagnostics.A_const_initializer_in_an_ambient_context_must_be_a_string_or_numeric_literal);
                            }
                        }
                        else {
                            // Error on equals token which immediate precedes the initializer
                            var equalsTokenLength = "=".length;
                            return grammarErrorAtPos(ts.getSourceFileOfNode(node), node.initializer.pos - equalsTokenLength, equalsTokenLength, ts.Diagnostics.Initializers_are_not_allowed_in_ambient_contexts);
                        }
                    }
                    if (node.initializer && !(ts.isConst(node) && isStringOrNumberLiteralExpression(node.initializer))) {
                        // Error on equals token which immediate precedes the initializer
                        var equalsTokenLength = "=".length;
                        return grammarErrorAtPos(ts.getSourceFileOfNode(node), node.initializer.pos - equalsTokenLength, equalsTokenLength, ts.Diagnostics.Initializers_are_not_allowed_in_ambient_contexts);
                    }
                }
                else if (!node.initializer) {
                    if (ts.isBindingPattern(node.name) && !ts.isBindingPattern(node.parent)) {
                        return grammarErrorOnNode(node, ts.Diagnostics.A_destructuring_declaration_must_have_an_initializer);
                    }
                    if (ts.isConst(node)) {
                        return grammarErrorOnNode(node, ts.Diagnostics.const_declarations_must_be_initialized);
                    }
                }
            }
            var checkLetConstNames = (ts.isLet(node) || ts.isConst(node));
            // 1. LexicalDeclaration : LetOrConst BindingList ;
            // It is a Syntax Error if the BoundNames of BindingList contains "let".
            // 2. ForDeclaration: ForDeclaration : LetOrConst ForBinding
            // It is a Syntax Error if the BoundNames of ForDeclaration contains "let".
            // It is a SyntaxError if a VariableDeclaration or VariableDeclarationNoIn occurs within strict code
            // and its Identifier is eval or arguments
            return checkLetConstNames && checkGrammarNameInLetOrConstDeclarations(node.name);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getUnionType) id{525,0} ---
(types, subtypeReduction, aliasSymbol, aliasTypeArguments) {
            if (types.length === 0) {
                return neverType;
            }
            if (types.length === 1) {
                return types[0];
            }
            var typeSet = [];
            addTypesToUnion(typeSet, types);
            if (typeSet.containsAny) {
                return anyType;
            }
            if (subtypeReduction) {
                removeSubtypes(typeSet);
            }
            else if (typeSet.containsStringOrNumberLiteral) {
                removeRedundantLiteralTypes(typeSet);
            }
            if (typeSet.length === 0) {
                return typeSet.containsNull ? typeSet.containsNonWideningType ? nullType : nullWideningType :
                    typeSet.containsUndefined ? typeSet.containsNonWideningType ? undefinedType : undefinedWideningType :
                        neverType;
            }
            return getUnionTypeFromSortedList(typeSet, aliasSymbol, aliasTypeArguments);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:addTypesToUnion) id{525,1} ---
(typeSet, types) {
            for (var _i = 0, types_4 = types; _i < types_4.length; _i++) {
                var type = types_4[_i];
                addTypeToUnion(typeSet, type);
            }
        }
--- END ---
INLINE (addTypesToUnion) id{525,1} AS 1 AT <0:274>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:removeRedundantLiteralTypes) id{525,2} ---
(types) {
            var i = types.length;
            while (i > 0) {
                i--;
                var t = types[i];
                var remove = t.flags & 32 /* StringLiteral */ && types.containsString ||
                    t.flags & 64 /* NumberLiteral */ && types.containsNumber ||
                    t.flags & 96 /* StringOrNumberLiteral */ && t.flags & 1048576 /* FreshLiteral */ && containsType(types, t.regularType);
                if (remove) {
                    ts.orderedRemoveItemAt(types, i);
                }
            }
        }
--- END ---
INLINE (removeRedundantLiteralTypes) id{525,2} AS 2 AT <0:561>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexDeclarationOfSymbol) id{526,0} ---
(symbol, kind) {
            var syntaxKind = kind === 1 /* Number */ ? 132 /* NumberKeyword */ : 134 /* StringKeyword */;
            var indexSymbol = getIndexSymbol(symbol);
            if (indexSymbol) {
                for (var _i = 0, _a = indexSymbol.declarations; _i < _a.length; _i++) {
                    var decl = _a[_i];
                    var node = decl;
                    if (node.parameters.length === 1) {
                        var parameter = node.parameters[0];
                        if (parameter && parameter.type && parameter.type.kind === syntaxKind) {
                            return node;
                        }
                    }
                }
            }
            return undefined;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexSymbol) id{526,1} ---
(symbol) {
            return symbol.members["__index"];
        }
--- END ---
INLINE (getIndexSymbol) id{526,1} AS 1 AT <0:153>
[deoptimizing (DEOPT eager): begin 0x74e2ec28721 <JS Function checkIndexConstraintForProperty (SharedFunctionInfo 0x371f85ce22b1)> (opt #493) @5, FP to SP delta: 56, caller sp: 0x7fff5fbfde08]
            ;;; deoptimize at 0_330: wrong map
  reading input frame checkIndexConstraintForProperty => node=65, args=7, height=7; inputs:
      0: 0x74e2ec28721 ; [fp - 16] 0x74e2ec28721 <JS Function checkIndexConstraintForProperty (SharedFunctionInfo 0x371f85ce22b1)>
      1: 0x1f9f6c0532e1 ; [fp + 64] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2b2268657929 ; [fp + 56] 0x2b2268657929 <a SymbolObject with map 0x33abe2a73229>
      3: 0x19a2de3c14c1 ; [fp + 48] 0x19a2de3c14c1 <a TypeObject with map 0x33abe2a6d349>
      4: 0xa7695787c89 ; [fp + 40] 0xa7695787c89 <a TypeObject with map 0x33abe2a73f91>
      5: 0x9ebbbfdbeb9 ; [fp + 32] 0x9ebbbfdbeb9 <a NodeObject with map 0x33abe2a70311>
      6: 0x19a2de3d4211 ; rax 0x19a2de3d4211 <a TypeObject with map 0x33abe2a73599>
      7: 0x100000000 ; [fp + 16] 1
      8: 0x74e2ec289a1 ; rbx 0x74e2ec289a1 <FixedArray[6]>
      9: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
     10: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
     11: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
     12: 0x130b7e1b6619 ; rdx 0x130b7e1b6619 <JS Function isNumericName (SharedFunctionInfo 0x2e2f693ff541)>
     13: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
     14: 0x9ebbbf65851 ; rcx 0x9ebbbf65851 <a NodeObject with map 0x33abe2a75591>
  translating frame checkIndexConstraintForProperty => node=65, height=48
    0x7fff5fbfde00: [top + 128] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfddf8: [top + 120] <- 0x2b2268657929 ;  0x2b2268657929 <a SymbolObject with map 0x33abe2a73229>  (input #2)
    0x7fff5fbfddf0: [top + 112] <- 0x19a2de3c14c1 ;  0x19a2de3c14c1 <a TypeObject with map 0x33abe2a6d349>  (input #3)
    0x7fff5fbfdde8: [top + 104] <- 0xa7695787c89 ;  0xa7695787c89 <a TypeObject with map 0x33abe2a73f91>  (input #4)
    0x7fff5fbfdde0: [top + 96] <- 0x9ebbbfdbeb9 ;  0x9ebbbfdbeb9 <a NodeObject with map 0x33abe2a70311>  (input #5)
    0x7fff5fbfddd8: [top + 88] <- 0x19a2de3d4211 ;  0x19a2de3d4211 <a TypeObject with map 0x33abe2a73599>  (input #6)
    0x7fff5fbfddd0: [top + 80] <- 0x100000000 ;  1  (input #7)
    0x7fff5fbfddc8: [top + 72] <- 0x2c21d261d8ab ;  caller's pc
    0x7fff5fbfddc0: [top + 64] <- 0x7fff5fbfde28 ;  caller's fp
    0x7fff5fbfddb8: [top + 56] <- 0x74e2ec289a1 ;  context    0x74e2ec289a1 <FixedArray[6]>  (input #8)
    0x7fff5fbfddb0: [top + 48] <- 0x74e2ec28721 ;  function    0x74e2ec28721 <JS Function checkIndexConstraintForProperty (SharedFunctionInfo 0x371f85ce22b1)>  (input #0)
    0x7fff5fbfdda8: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
    0x7fff5fbfdda0: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #10)
    0x7fff5fbfdd98: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #11)
    0x7fff5fbfdd90: [top + 16] <- 0x130b7e1b6619 ;  0x130b7e1b6619 <JS Function isNumericName (SharedFunctionInfo 0x2e2f693ff541)>  (input #12)
    0x7fff5fbfdd88: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #13)
    0x7fff5fbfdd80: [top + 0] <- 0x9ebbbf65851 ;  0x9ebbbf65851 <a NodeObject with map 0x33abe2a75591>  (input #14)
[deoptimizing (eager): end 0x74e2ec28721 <JS Function checkIndexConstraintForProperty (SharedFunctionInfo 0x371f85ce22b1)> @5 => node=65, pc=0x2c21d261da56, caller sp=0x7fff5fbfde08, state=TOS_REGISTER, took 0.150 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkTypeParameters) id{527,0} ---
(typeParameterDeclarations) {
            if (typeParameterDeclarations) {
                for (var i = 0, n = typeParameterDeclarations.length; i < n; i++) {
                    var node = typeParameterDeclarations[i];
                    checkTypeParameter(node);
                    if (produceDiagnostics) {
                        for (var j = 0; j < i; j++) {
                            if (typeParameterDeclarations[j].symbol === node.symbol) {
                                error(node.name, ts.Diagnostics.Duplicate_identifier_0, ts.declarationNameToString(node.name));
                            }
                        }
                    }
                }
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkTypeParameter) id{527,1} ---
(node) {
            // Grammar Checking
            if (node.expression) {
                grammarErrorOnFirstToken(node.expression, ts.Diagnostics.Type_expected);
            }
            checkSourceElement(node.constraint);
            getConstraintOfTypeParameter(getDeclaredTypeOfTypeParameter(getSymbolOfNode(node)));
            if (produceDiagnostics) {
                checkTypeNameIsReserved(node.name, ts.Diagnostics.Type_parameter_name_cannot_be_0);
            }
        }
--- END ---
INLINE (checkTypeParameter) id{527,1} AS 1 AT <0:240>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{527,2} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{527,2} AS 2 AT <1:300>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{527,3} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{527,3} AS 3 AT <2:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getDeclaredTypeOfTypeParameter) id{527,4} ---
(symbol) {
            var links = getSymbolLinks(symbol);
            if (!links.declaredType) {
                var type = createType(16384 /* TypeParameter */);
                type.symbol = symbol;
                if (!ts.getDeclarationOfKind(symbol, 143 /* TypeParameter */).constraint) {
                    type.constraint = noConstraintType;
                }
                links.declaredType = type;
            }
            return links.declaredType;
        }
--- END ---
INLINE (getDeclaredTypeOfTypeParameter) id{527,4} AS 4 AT <1:269>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{527,5} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{527,5} AS 5 AT <4:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{527,6} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{527,6} AS 6 AT <5:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{527,7} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{527,7} AS 7 AT <4:125>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{527,8} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{527,8} AS 8 AT <7:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkTypeNameIsReserved) id{527,9} ---
(name, message) {
            // TS 1.0 spec (April 2014): 3.6.1
            // The predefined type keywords are reserved and cannot be used as names of user defined types.
            switch (name.text) {
                case "any":
                case "number":
                case "boolean":
                case "string":
                case "symbol":
                case "void":
                    error(name, message, name.text);
            }
        }
--- END ---
INLINE (checkTypeNameIsReserved) id{527,9} AS 9 AT <1:379>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarDecorators) id{528,0} ---
(node) {
            if (!node.decorators) {
                return false;
            }
            if (!ts.nodeCanBeDecorated(node)) {
                if (node.kind === 149 /* MethodDeclaration */ && !ts.nodeIsPresent(node.body)) {
                    return grammarErrorOnFirstToken(node, ts.Diagnostics.A_decorator_can_only_decorate_a_method_implementation_not_an_overload);
                }
                else {
                    return grammarErrorOnFirstToken(node, ts.Diagnostics.Decorators_are_not_valid_here);
                }
            }
            else if (node.kind === 151 /* GetAccessor */ || node.kind === 152 /* SetAccessor */) {
                var accessors = ts.getAllAccessorDeclarations(node.parent.members, node);
                if (accessors.firstAccessor.decorators && node === accessors.secondAccessor) {
                    return grammarErrorOnFirstToken(node, ts.Diagnostics.Decorators_cannot_be_applied_to_multiple_get_Slashset_accessors_of_the_same_name);
                }
            }
            return false;
        }
--- END ---
[marking dependent code 0x2c21d2671041 (opt #349) for deoptimization, reason: prototype-check]
[deoptimize marked code in all contexts]
[deoptimizing (DEOPT eager): begin 0xd6230dcf5f1 <JS Function nodeIsMissing (SharedFunctionInfo 0x3504a53cc419)> (opt #383) @2, FP to SP delta: 24, caller sp: 0x7fff5fbfda38]
  reading input frame nodeIsMissing => node=7, args=2, height=1; inputs:
      0: 0xd6230dcf5f1 ; [fp - 16] 0xd6230dcf5f1 <JS Function nodeIsMissing (SharedFunctionInfo 0x3504a53cc419)>
      1: 0x16f3adb61821 ; [fp + 24] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x9a0222afae1 ; rax 0x9a0222afae1 <an IdentifierObject with map 0x15b5a79122d1>
      3: 0xd6230db34c9 ; [fp - 24] 0xd6230db34c9 <FixedArray[156]>
  translating frame nodeIsMissing => node=7, height=0
    0x7fff5fbfda30: [top + 40] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfda28: [top + 32] <- 0x9a0222afae1 ;  0x9a0222afae1 <an IdentifierObject with map 0x15b5a79122d1>  (input #2)
    0x7fff5fbfda20: [top + 24] <- 0x2c21d272b585 ;  caller's pc
    0x7fff5fbfda18: [top + 16] <- 0x7fff5fbfda60 ;  caller's fp
    0x7fff5fbfda10: [top + 8] <- 0xd6230db34c9 ;  context    0xd6230db34c9 <FixedArray[156]>  (input #3)
    0x7fff5fbfda08: [top + 0] <- 0xd6230dcf5f1 ;  function    0xd6230dcf5f1 <JS Function nodeIsMissing (SharedFunctionInfo 0x3504a53cc419)>  (input #0)
[deoptimizing (eager): end 0xd6230dcf5f1 <JS Function nodeIsMissing (SharedFunctionInfo 0x3504a53cc419)> @2 => node=7, pc=0x2c21d2527f70, caller sp=0x7fff5fbfda38, state=NO_REGISTERS, took 0.060 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d3e2b1 <JS Function getSymbol (SharedFunctionInfo 0x2e2f693e7951)> (opt #373) @13, FP to SP delta: 40, caller sp: 0x7fff5fbfd8b8]
            ;;; deoptimize at 0_407: wrong map
  reading input frame getSymbol => node=96, args=4, height=3; inputs:
      0: 0x1030c9d3e2b1 ; [fp - 16] 0x1030c9d3e2b1 <JS Function getSymbol (SharedFunctionInfo 0x2e2f693e7951)>
      1: 0x1f9f6c0532e1 ; [fp + 40] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x3a4134761bc1 ; [fp + 32] 0x3a4134761bc1 <an Object with map 0x33abe2a3d1a1>
      3: 0x286514cf71b9 ; [fp + 24] 0x286514cf71b9 <String[3]: URL>
      4: 0x1a800000000 ; [fp + 16] 424
      5: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      6: 0x17ddd84636e9 ; rax 0x17ddd84636e9 <a SymbolObject with map 0x33abe2a6fb29>
      7: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
  translating frame getSymbol => node=96, height=16
    0x7fff5fbfd8b0: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd8a8: [top + 64] <- 0x3a4134761bc1 ;  0x3a4134761bc1 <an Object with map 0x33abe2a3d1a1>  (input #2)
    0x7fff5fbfd8a0: [top + 56] <- 0x286514cf71b9 ;  0x286514cf71b9 <String[3]: URL>  (input #3)
    0x7fff5fbfd898: [top + 48] <- 0x1a800000000 ;  424  (input #4)
    0x7fff5fbfd890: [top + 40] <- 0x2c21d26f6ec9 ;  caller's pc
    0x7fff5fbfd888: [top + 32] <- 0x7fff5fbfd9f8 ;  caller's fp
    0x7fff5fbfd880: [top + 24] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #5)
    0x7fff5fbfd878: [top + 16] <- 0x1030c9d3e2b1 ;  function    0x1030c9d3e2b1 <JS Function getSymbol (SharedFunctionInfo 0x2e2f693e7951)>  (input #0)
    0x7fff5fbfd870: [top + 8] <- 0x17ddd84636e9 ;  0x17ddd84636e9 <a SymbolObject with map 0x33abe2a6fb29>  (input #6)
    0x7fff5fbfd868: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
[deoptimizing (eager): end 0x1030c9d3e2b1 <JS Function getSymbol (SharedFunctionInfo 0x2e2f693e7951)> @13 => node=96, pc=0x2c21d25e6c02, caller sp=0x7fff5fbfd8b8, state=NO_REGISTERS, took 0.061 ms]
[deoptimizing (DEOPT soft): begin 0x130b7e1b6811 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)> (opt #454) @114, FP to SP delta: 320, caller sp: 0x7fff5fbfda38]
            ;;; deoptimize at 0_15340: Insufficient type feedback for generic named access
  reading input frame resolveName => node=2268, args=6, height=18; inputs:
      0: 0x130b7e1b6811 ; [fp - 16] 0x130b7e1b6811 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)>
      1: 0x1f9f6c0532e1 ; [fp + 56] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x30bcea404311 ; [fp - 40] 0x30bcea404311 <undefined>
      3: 0x286514cf71b9 ; [fp + 40] 0x286514cf71b9 <String[3]: URL>
      4: 0x11a3bf00000000 ; [fp + 32] 1156031
      5: 0xd6230ded3a9 ; [fp + 24] 0xd6230ded3a9 <an Object with map 0x33abe2a3df61>
      6: 0x9a0222afae1 ; [fp + 16] 0x9a0222afae1 <an IdentifierObject with map 0x15b5a79122d1>
      7: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      8: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
      9: 0x17ddd847f089 ; [fp - 320] 0x17ddd847f089 <a SymbolObject with map 0x33abe2a72c51>
     10: 0x30bcea4069a9 ; (literal 12) 0x30bcea4069a9 <Odd Oddball: optimized_out>
     11: 0x30bcea4069a9 ; (literal 12) 0x30bcea4069a9 <Odd Oddball: optimized_out>
     12: 0x9a0222afae1 ; [fp + 48] 0x9a0222afae1 <an IdentifierObject with map 0x15b5a79122d1>
     13: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     14: 0x30bcea404421 ; [fp - 168] 0x30bcea404421 <false>
     15: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     16: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     17: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     18: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     19: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     20: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     21: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     22: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     23: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     24: 0x17ddd847f089 ; rax 0x17ddd847f089 <a SymbolObject with map 0x33abe2a72c51>
  translating frame resolveName => node=2268, height=136
    0x7fff5fbfda30: [top + 208] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfda28: [top + 200] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #2)
    0x7fff5fbfda20: [top + 192] <- 0x286514cf71b9 ;  0x286514cf71b9 <String[3]: URL>  (input #3)
    0x7fff5fbfda18: [top + 184] <- 0x11a3bf00000000 ;  1156031  (input #4)
    0x7fff5fbfda10: [top + 176] <- 0xd6230ded3a9 ;  0xd6230ded3a9 <an Object with map 0x33abe2a3df61>  (input #5)
    0x7fff5fbfda08: [top + 168] <- 0x9a0222afae1 ;  0x9a0222afae1 <an IdentifierObject with map 0x15b5a79122d1>  (input #6)
    0x7fff5fbfda00: [top + 160] <- 0x2c21d272b66f ;  caller's pc
    0x7fff5fbfd9f8: [top + 152] <- 0x7fff5fbfda60 ;  caller's fp
    0x7fff5fbfd9f0: [top + 144] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #7)
    0x7fff5fbfd9e8: [top + 136] <- 0x130b7e1b6811 ;  function    0x130b7e1b6811 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)>  (input #0)
    0x7fff5fbfd9e0: [top + 128] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfd9d8: [top + 120] <- 0x17ddd847f089 ;  0x17ddd847f089 <a SymbolObject with map 0x33abe2a72c51>  (input #9)
    0x7fff5fbfd9d0: [top + 112] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #10)
    0x7fff5fbfd9c8: [top + 104] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #11)
    0x7fff5fbfd9c0: [top + 96] <- 0x9a0222afae1 ;  0x9a0222afae1 <an IdentifierObject with map 0x15b5a79122d1>  (input #12)
    0x7fff5fbfd9b8: [top + 88] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #13)
    0x7fff5fbfd9b0: [top + 80] <- 0x30bcea404421 ;  0x30bcea404421 <false>  (input #14)
    0x7fff5fbfd9a8: [top + 72] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #15)
    0x7fff5fbfd9a0: [top + 64] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #16)
    0x7fff5fbfd998: [top + 56] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #17)
    0x7fff5fbfd990: [top + 48] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #18)
    0x7fff5fbfd988: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #19)
    0x7fff5fbfd980: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #20)
    0x7fff5fbfd978: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #21)
    0x7fff5fbfd970: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #22)
    0x7fff5fbfd968: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #23)
    0x7fff5fbfd960: [top + 0] <- 0x17ddd847f089 ;  0x17ddd847f089 <a SymbolObject with map 0x33abe2a72c51>  (input #24)
[deoptimizing (soft): end 0x130b7e1b6811 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)> @114 => node=2268, pc=0x2c21d25e672e, caller sp=0x7fff5fbfda38, state=TOS_REGISTER, took 0.195 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d3fe01 <JS Function needCollisionCheckForIdentifier (SharedFunctionInfo 0x1b98fbc0ca81)> (opt #472) @3, FP to SP delta: 32, caller sp: 0x7fff5fbfda30]
            ;;; deoptimize at 0_69: Unknown map in polymorphic access
  reading input frame needCollisionCheckForIdentifier => node=17, args=4, height=2; inputs:
      0: 0x1030c9d3fe01 ; [fp - 16] 0x1030c9d3fe01 <JS Function needCollisionCheckForIdentifier (SharedFunctionInfo 0x1b98fbc0ca81)>
      1: 0x1f9f6c0532e1 ; [fp + 40] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x9a0222afae1 ; [fp + 32] 0x9a0222afae1 <an IdentifierObject with map 0x15b5a79122d1>
      3: 0x9a0222afae1 ; rbx 0x9a0222afae1 <an IdentifierObject with map 0x15b5a79122d1>
      4: 0x3504a53bc5e1 ; [fp + 16] 0x3504a53bc5e1 <String[6]: _super>
      5: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      6: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
  translating frame needCollisionCheckForIdentifier => node=17, height=8
    0x7fff5fbfda28: [top + 64] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfda20: [top + 56] <- 0x9a0222afae1 ;  0x9a0222afae1 <an IdentifierObject with map 0x15b5a79122d1>  (input #2)
    0x7fff5fbfda18: [top + 48] <- 0x9a0222afae1 ;  0x9a0222afae1 <an IdentifierObject with map 0x15b5a79122d1>  (input #3)
    0x7fff5fbfda10: [top + 40] <- 0x3504a53bc5e1 ;  0x3504a53bc5e1 <String[6]: _super>  (input #4)
    0x7fff5fbfda08: [top + 32] <- 0x2c21d25fabcd ;  caller's pc
    0x7fff5fbfda00: [top + 24] <- 0x7fff5fbfda58 ;  caller's fp
    0x7fff5fbfd9f8: [top + 16] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #5)
    0x7fff5fbfd9f0: [top + 8] <- 0x1030c9d3fe01 ;  function    0x1030c9d3fe01 <JS Function needCollisionCheckForIdentifier (SharedFunctionInfo 0x1b98fbc0ca81)>  (input #0)
    0x7fff5fbfd9e8: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
[deoptimizing (eager): end 0x1030c9d3fe01 <JS Function needCollisionCheckForIdentifier (SharedFunctionInfo 0x1b98fbc0ca81)> @3 => node=17, pc=0x2c21d25faf6b, caller sp=0x7fff5fbfda30, state=NO_REGISTERS, took 0.066 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d44209 <JS Function getTypeOfSymbol (SharedFunctionInfo 0x2e2f693ed051)> (opt #455) @2, FP to SP delta: 128, caller sp: 0x7fff5fbfda80]
            ;;; deoptimize at 0_33: wrong map
  reading input frame getTypeOfSymbol => node=4, args=2, height=1; inputs:
      0: 0x1030c9d44209 ; [fp - 16] 0x1030c9d44209 <JS Function getTypeOfSymbol (SharedFunctionInfo 0x2e2f693ed051)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x17ddd847f089 ; rax 0x17ddd847f089 <a SymbolObject with map 0x33abe2a72c51>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
  translating frame getTypeOfSymbol => node=4, height=0
    0x7fff5fbfda78: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfda70: [top + 32] <- 0x17ddd847f089 ;  0x17ddd847f089 <a SymbolObject with map 0x33abe2a72c51>  (input #2)
    0x7fff5fbfda68: [top + 24] <- 0x2c21d272a6dd ;  caller's pc
    0x7fff5fbfda60: [top + 16] <- 0x7fff5fbfdb00 ;  caller's fp
    0x7fff5fbfda58: [top + 8] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfda50: [top + 0] <- 0x1030c9d44209 ;  function    0x1030c9d44209 <JS Function getTypeOfSymbol (SharedFunctionInfo 0x2e2f693ed051)>  (input #0)
[deoptimizing (eager): end 0x1030c9d44209 <JS Function getTypeOfSymbol (SharedFunctionInfo 0x2e2f693ed051)> @2 => node=4, pc=0x2c21d261cc46, caller sp=0x7fff5fbfda80, state=NO_REGISTERS, took 0.061 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d3f861 <JS Function getTypeOfVariableOrParameterOrProperty (SharedFunctionInfo 0x2e2f693ec8d1)> (opt #403) @16, FP to SP delta: 80, caller sp: 0x7fff5fbfda48]
            ;;; deoptimize at 0_81: Unknown map in polymorphic access
  reading input frame getTypeOfVariableOrParameterOrProperty => node=30, args=2, height=7; inputs:
      0: 0x1030c9d3f861 ; [fp - 16] 0x1030c9d3f861 <JS Function getTypeOfVariableOrParameterOrProperty (SharedFunctionInfo 0x2e2f693ec8d1)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x17ddd847f089 ; [fp + 16] 0x17ddd847f089 <a SymbolObject with map 0x33abe2a72c51>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
      5: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
      6: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
      7: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
      9: 0x16ea890a5e61 ; rax 0x16ea890a5e61 <an Object with map 0x33abe2a73ee1>
  translating frame getTypeOfVariableOrParameterOrProperty => node=30, height=48
    0x7fff5fbfda40: [top + 88] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfda38: [top + 80] <- 0x17ddd847f089 ;  0x17ddd847f089 <a SymbolObject with map 0x33abe2a72c51>  (input #2)
    0x7fff5fbfda30: [top + 72] <- 0x2c21d261cd6e ;  caller's pc
    0x7fff5fbfda28: [top + 64] <- 0x7fff5fbfda60 ;  caller's fp
    0x7fff5fbfda20: [top + 56] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfda18: [top + 48] <- 0x1030c9d3f861 ;  function    0x1030c9d3f861 <JS Function getTypeOfVariableOrParameterOrProperty (SharedFunctionInfo 0x2e2f693ec8d1)>  (input #0)
    0x7fff5fbfda10: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfda08: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfda00: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfd9f8: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfd9f0: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfd9e8: [top + 0] <- 0x16ea890a5e61 ;  0x16ea890a5e61 <an Object with map 0x33abe2a73ee1>  (input #9)
[deoptimizing (eager): end 0x1030c9d3f861 <JS Function getTypeOfVariableOrParameterOrProperty (SharedFunctionInfo 0x2e2f693ec8d1)> @16 => node=30, pc=0x2c21d25f5489, caller sp=0x7fff5fbfda48, state=TOS_REGISTER, took 0.073 ms]
[deoptimizing (DEOPT soft): begin 0x1030c9d5a901 <JS Function isConstEnumObjectType (SharedFunctionInfo 0x1b98fbc08941)> (opt #503) @4, FP to SP delta: 32, caller sp: 0x7fff5fbfdb68]
            ;;; deoptimize at 0_77: Insufficient type feedback for generic named access
  reading input frame isConstEnumObjectType => node=13, args=2, height=2; inputs:
      0: 0x1030c9d5a901 ; [fp - 16] 0x1030c9d5a901 <JS Function isConstEnumObjectType (SharedFunctionInfo 0x1b98fbc08941)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x74e2ec75bc1 ; [fp + 16] 0x74e2ec75bc1 <a TypeObject with map 0x33abe2a75a61>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 16 ; rbx 
  translating frame isConstEnumObjectType => node=13, height=8
    0x7fff5fbfdb60: [top + 48] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdb58: [top + 40] <- 0x74e2ec75bc1 ;  0x74e2ec75bc1 <a TypeObject with map 0x33abe2a75a61>  (input #2)
    0x7fff5fbfdb50: [top + 32] <- 0x2c21d26ea24d ;  caller's pc
    0x7fff5fbfdb48: [top + 24] <- 0x7fff5fbfdb98 ;  caller's fp
    0x7fff5fbfdb40: [top + 16] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdb38: [top + 8] <- 0x1030c9d5a901 ;  function    0x1030c9d5a901 <JS Function isConstEnumObjectType (SharedFunctionInfo 0x1b98fbc08941)>  (input #0)
    0x7fff5fbfdb30: [top + 0] <- 0x1000000000 ;  16  (input #4)
[deoptimizing (soft): end 0x1030c9d5a901 <JS Function isConstEnumObjectType (SharedFunctionInfo 0x1b98fbc08941)> @4 => node=13, pc=0x2c21d26ec1d1, caller sp=0x7fff5fbfdb68, state=TOS_REGISTER, took 0.059 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbol) id{529,0} ---
(symbols, name, meaning) {
            if (meaning) {
                var symbol = symbols[name];
                if (symbol) {
                    ts.Debug.assert((symbol.flags & 16777216 /* Instantiated */) === 0, "Should never get an instantiated symbol here.");
                    if (symbol.flags & meaning) {
                        return symbol;
                    }
                    if (symbol.flags & 8388608 /* Alias */) {
                        var target = resolveAlias(symbol);
                        // Unknown symbol means an error occurred in alias resolution, treat it as positive answer to avoid cascading errors
                        if (target === unknownSymbol || target.flags & meaning) {
                            return symbol;
                        }
                    }
                }
            }
            // return undefined if we can't find a symbol.
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveName) id{530,0} ---
(location, name, meaning, nameNotFoundMessage, nameArg) {
            var result;
            var lastLocation;
            var propertyWithInvalidInitializer;
            var errorLocation = location;
            var grandparent;
            var isInExternalModule = false;
            loop: while (location) {
                // Locals of a source file are not in scope (because they get merged into the global symbol table)
                if (location.locals && !isGlobalSourceFile(location)) {
                    if (result = getSymbol(location.locals, name, meaning)) {
                        var useResult = true;
                        if (ts.isFunctionLike(location) && lastLocation && lastLocation !== location.body) {
                            // symbol lookup restrictions for function-like declarations
                            // - Type parameters of a function are in scope in the entire function declaration, including the parameter
                            //   list and return type. However, local types are only in scope in the function body.
                            // - parameters are only in the scope of function body
                            // This restriction does not apply to JSDoc comment types because they are parented
                            // at a higher level than type parameters would normally be
                            if (meaning & result.flags & 793064 /* Type */ && lastLocation.kind !== 278 /* JSDocComment */) {
                                useResult = result.flags & 262144 /* TypeParameter */
                                    ? lastLocation === location.type ||
                                        lastLocation.kind === 144 /* Parameter */ ||
                                        lastLocation.kind === 143 /* TypeParameter */
                                    : false;
                            }
                            if (meaning & 107455 /* Value */ && result.flags & 1 /* FunctionScopedVariable */) {
                                // parameters are visible only inside function body, parameter list and return type
                                // technically for parameter list case here we might mix parameters and variables declared in function,
                                // however it is detected separately when checking initializers of parameters
                                // to make sure that they reference no variables declared after them.
                                useResult =
                                    lastLocation.kind === 144 /* Parameter */ ||
                                        (lastLocation === location.type &&
                                            result.valueDeclaration.kind === 144 /* Parameter */);
                            }
                        }
                        if (useResult) {
                            break loop;
                        }
                        else {
                            result = undefined;
                        }
                    }
                }
                switch (location.kind) {
                    case 261 /* SourceFile */:
                        if (!ts.isExternalOrCommonJsModule(location))
                            break;
                        isInExternalModule = true;
                    case 230 /* ModuleDeclaration */:
                        var moduleExports = getSymbolOfNode(location).exports;
                        if (location.kind === 261 /* SourceFile */ || ts.isAmbientModule(location)) {
                            // It's an external module. First see if the module has an export default and if the local
                            // name of that export default matches.
                            if (result = moduleExports["default"]) {
                                var localSymbol = ts.getLocalSymbolForExportDefault(result);
                                if (localSymbol && (result.flags & meaning) && localSymbol.name === name) {
                                    break loop;
                                }
                                result = undefined;
                            }
                            // Because of module/namespace merging, a module's exports are in scope,
                            // yet we never want to treat an export specifier as putting a member in scope.
                            // Therefore, if the name we find is purely an export specifier, it is not actually considered in scope.
                            // Two things to note about this:
                            //     1. We have to check this without calling getSymbol. The problem with calling getSymbol
                            //        on an export specifier is that it might find the export specifier itself, and try to
                            //        resolve it as an alias. This will cause the checker to consider the export specifier
                            //        a circular alias reference when it might not be.
                            //     2. We check === SymbolFlags.Alias in order to check that the symbol is *purely*
                            //        an alias. If we used &, we'd be throwing out symbols that have non alias aspects,
                            //        which is not the desired behavior.
                            if (moduleExports[name] &&
                                moduleExports[name].flags === 8388608 /* Alias */ &&
                                ts.getDeclarationOfKind(moduleExports[name], 243 /* ExportSpecifier */)) {
                                break;
                            }
                        }
                        if (result = getSymbol(moduleExports, name, meaning & 8914931 /* ModuleMember */)) {
                            break loop;
                        }
                        break;
                    case 229 /* EnumDeclaration */:
                        if (result = getSymbol(getSymbolOfNode(location).exports, name, meaning & 8 /* EnumMember */)) {
                            break loop;
                        }
                        break;
                    case 147 /* PropertyDeclaration */:
                    case 146 /* PropertySignature */:
                        // TypeScript 1.0 spec (April 2014): 8.4.1
                        // Initializer expressions for instance member variables are evaluated in the scope
                        // of the class constructor body but are not permitted to reference parameters or
                        // local variables of the constructor. This effectively means that entities from outer scopes
                        // by the same name as a constructor parameter or local variable are inaccessible
                        // in initializer expressions for instance member variables.
                        if (ts.isClassLike(location.parent) && !(ts.getModifierFlags(location) & 32 /* Static */)) {
                            var ctor = findConstructorDeclaration(location.parent);
                            if (ctor && ctor.locals) {
                                if (getSymbol(ctor.locals, name, meaning & 107455 /* Value */)) {
                                    // Remember the property node, it will be used later to report appropriate error
                                    propertyWithInvalidInitializer = location;
                                }
                            }
                        }
                        break;
                    case 226 /* ClassDeclaration */:
                    case 197 /* ClassExpression */:
                    case 227 /* InterfaceDeclaration */:
                        if (result = getSymbol(getSymbolOfNode(location).members, name, meaning & 793064 /* Type */)) {
                            if (lastLocation && ts.getModifierFlags(lastLocation) & 32 /* Static */) {
                                // TypeScript 1.0 spec (April 2014): 3.4.1
                                // The scope of a type parameter extends over the entire declaration with which the type
                                // parameter list is associated, with the exception of static member declarations in classes.
                                error(errorLocation, ts.Diagnostics.Static_members_cannot_reference_class_type_parameters);
                                return undefined;
                            }
                            break loop;
                        }
                        if (location.kind === 197 /* ClassExpression */ && meaning & 32 /* Class */) {
                            var className = location.name;
                            if (className && name === className.text) {
                                result = location.symbol;
                                break loop;
                            }
                        }
                        break;
                    // It is not legal to reference a class's own type parameters from a computed property name that
                    // belongs to the class. For example:
                    //
                    //   function foo<T>() { return '' }
                    //   class C<T> { // <-- Class's own type parameter T
                    //       [foo<T>()]() { } // <-- Reference to T from class's own computed property
                    //   }
                    //
                    case 142 /* ComputedPropertyName */:
                        grandparent = location.parent.parent;
                        if (ts.isClassLike(grandparent) || grandparent.kind === 227 /* InterfaceDeclaration */) {
                            // A reference to this grandparent's type parameters would be an error
                            if (result = getSymbol(getSymbolOfNode(grandparent).members, name, meaning & 793064 /* Type */)) {
                                error(errorLocation, ts.Diagnostics.A_computed_property_name_cannot_reference_a_type_parameter_from_its_containing_type);
                                return undefined;
                            }
                        }
                        break;
                    case 149 /* MethodDeclaration */:
                    case 148 /* MethodSignature */:
                    case 150 /* Constructor */:
                    case 151 /* GetAccessor */:
                    case 152 /* SetAccessor */:
                    case 225 /* FunctionDeclaration */:
                    case 185 /* ArrowFunction */:
                        if (meaning & 3 /* Variable */ && name === "arguments") {
                            result = argumentsSymbol;
                            break loop;
                        }
                        break;
                    case 184 /* FunctionExpression */:
                        if (meaning & 3 /* Variable */ && name === "arguments") {
                            result = argumentsSymbol;
                            break loop;
                        }
                        if (meaning & 16 /* Function */) {
                            var functionName = location.name;
                            if (functionName && name === functionName.text) {
                                result = location.symbol;
                                break loop;
                            }
                        }
                        break;
                    case 145 /* Decorator */:
                        // Decorators are resolved at the class declaration. Resolving at the parameter
                        // or member would result in looking up locals in the method.
                        //
                        //   function y() {}
                        //   class C {
                        //       method(@y x, y) {} // <-- decorator y should be resolved at the class declaration, not the parameter.
                        //   }
                        //
                        if (location.parent && location.parent.kind === 144 /* Parameter */) {
                            location = location.parent;
                        }
                        //
                        //   function y() {}
                        //   class C {
                        //       @y method(x, y) {} // <-- decorator y should be resolved at the class declaration, not the method.
                        //   }
                        //
                        if (location.parent && ts.isClassElement(location.parent)) {
                            location = location.parent;
                        }
                        break;
                }
                lastLocation = location;
                location = location.parent;
            }
            if (result && nameNotFoundMessage && noUnusedIdentifiers) {
                result.isReferenced = true;
            }
            if (!result) {
                result = getSymbol(globals, name, meaning);
            }
            if (!result) {
                if (nameNotFoundMessage) {
                    if (!errorLocation ||
                        !checkAndReportErrorForMissingPrefix(errorLocation, name, nameArg) &&
                            !checkAndReportErrorForExtendingInterface(errorLocation) &&
                            !checkAndReportErrorForUsingTypeAsNamespace(errorLocation, name, meaning) &&
                            !checkAndReportErrorForUsingTypeAsValue(errorLocation, name, meaning)) {
                        error(errorLocation, nameNotFoundMessage, typeof nameArg === "string" ? nameArg : ts.declarationNameToString(nameArg));
                    }
                }
                return undefined;
            }
            // Perform extra checks only if error reporting was requested
            if (nameNotFoundMessage) {
                if (propertyWithInvalidInitializer) {
                    // We have a match, but the reference occurred within a property initializer and the identifier also binds
                    // to a local variable in the constructor where the code will be emitted.
                    var propertyName = propertyWithInvalidInitializer.name;
                    error(errorLocation, ts.Diagnostics.Initializer_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor, ts.declarationNameToString(propertyName), typeof nameArg === "string" ? nameArg : ts.declarationNameToString(nameArg));
                    return undefined;
                }
                // Only check for block-scoped variable if we are looking for the
                // name with variable meaning
                //      For example,
                //          declare module foo {
                //              interface bar {}
                //          }
                //      const foo/*1*/: foo/*2*/.bar;
                // The foo at /*1*/ and /*2*/ will share same symbol with two meaning
                // block - scope variable and namespace module. However, only when we
                // try to resolve name in /*1*/ which is used in variable position,
                // we want to check for block- scoped
                if (meaning & 2 /* BlockScopedVariable */) {
                    var exportOrLocalSymbol = getExportSymbolOfValueSymbolIfExported(result);
                    if (exportOrLocalSymbol.flags & 2 /* BlockScopedVariable */) {
                        checkResolvedBlockScopedVariable(exportOrLocalSymbol, errorLocation);
                    }
                }
                // If we're in an external module, we can't reference value symbols created from UMD export declarations
                if (result && isInExternalModule && (meaning & 107455 /* Value */) === 107455 /* Value */) {
                    var decls = result.declarations;
                    if (decls && decls.length === 1 && decls[0].kind === 233 /* NamespaceExportDeclaration */) {
                        error(errorLocation, ts.Diagnostics._0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead, name);
                    }
                }
            }
            return result;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isGlobalSourceFile) id{530,1} ---
(node) {
            return node.kind === 261 /* SourceFile */ && !ts.isExternalOrCommonJsModule(node);
        }
--- END ---
INLINE (isGlobalSourceFile) id{530,1} AS 1 AT <0:467>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{530,2} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{530,2} AS 2 AT <0:3412>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{530,3} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{530,3} AS 3 AT <2:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{530,4} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{530,4} AS 4 AT <0:7735>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{530,5} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{530,5} AS 5 AT <4:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getExportSymbolOfValueSymbolIfExported) id{530,6} ---
(symbol) {
            return symbol && (symbol.flags & 1048576 /* ExportValue */) !== 0
                ? getMergedSymbol(symbol.exportSymbol)
                : symbol;
        }
--- END ---
INLINE (getExportSymbolOfValueSymbolIfExported) id{530,6} AS 6 AT <0:15249>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nodeIsMissing) id{531,0} ---
(node) {
        if (node === undefined) {
            return true;
        }
        return node.pos === node.end && node.pos >= 0 && node.kind !== 1 /* EndOfFileToken */;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeOfVariableOrParameterOrProperty) id{532,0} ---
(symbol) {
            var links = getSymbolLinks(symbol);
            if (!links.type) {
                // Handle prototype property
                if (symbol.flags & 134217728 /* Prototype */) {
                    return links.type = getTypeOfPrototypeProperty(symbol);
                }
                // Handle catch clause variables
                var declaration = symbol.valueDeclaration;
                if (ts.isCatchClauseVariableDeclarationOrBindingElement(declaration)) {
                    return links.type = anyType;
                }
                // Handle export default expressions
                if (declaration.kind === 240 /* ExportAssignment */) {
                    return links.type = checkExpression(declaration.expression);
                }
                if (declaration.flags & 65536 /* JavaScriptFile */ && declaration.kind === 286 /* JSDocPropertyTag */ && declaration.typeExpression) {
                    return links.type = getTypeFromTypeNode(declaration.typeExpression.type);
                }
                // Handle variable, parameter or property
                if (!pushTypeResolution(symbol, 0 /* Type */)) {
                    return unknownType;
                }
                var type = void 0;
                // Handle certain special assignment kinds, which happen to union across multiple declarations:
                // * module.exports = expr
                // * exports.p = expr
                // * this.p = expr
                // * className.prototype.method = expr
                if (declaration.kind === 192 /* BinaryExpression */ ||
                    declaration.kind === 177 /* PropertyAccessExpression */ && declaration.parent.kind === 192 /* BinaryExpression */) {
                    // Use JS Doc type if present on parent expression statement
                    if (declaration.flags & 65536 /* JavaScriptFile */) {
                        var jsdocType = ts.getJSDocType(declaration.parent);
                        if (jsdocType) {
                            return links.type = getTypeFromTypeNode(jsdocType);
                        }
                    }
                    var declaredTypes = ts.map(symbol.declarations, function (decl) { return decl.kind === 192 /* BinaryExpression */ ?
                        checkExpressionCached(decl.right) :
                        checkExpressionCached(decl.parent.right); });
                    type = getUnionType(declaredTypes, /*subtypeReduction*/ true);
                }
                else {
                    type = getWidenedTypeForVariableLikeDeclaration(declaration, /*reportErrors*/ true);
                }
                if (!popTypeResolution()) {
                    type = reportCircularityError(symbol);
                }
                links.type = type;
            }
            return links.type;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{532,1} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{532,1} AS 1 AT <0:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{532,2} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{532,2} AS 2 AT <1:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:popTypeResolution) id{532,3} ---
() {
            resolutionTargets.pop();
            resolutionPropertyNames.pop();
            return resolutionResults.pop();
        }
--- END ---
INLINE (popTypeResolution) id{532,3} AS 3 AT <0:2684>
[deoptimizing (DEOPT soft): begin 0x1030c9d448d9 <JS Function isSimpleTypeRelatedTo (SharedFunctionInfo 0x2e2f693f7981)> (opt #449) @10, FP to SP delta: 32, caller sp: 0x7fff5fbfdcb0]
            ;;; deoptimize at 0_526: Insufficient type feedback for generic named access
  reading input frame isSimpleTypeRelatedTo => node=158, args=5, height=1; inputs:
      0: 0x1030c9d448d9 ; [fp - 16] 0x1030c9d448d9 <JS Function isSimpleTypeRelatedTo (SharedFunctionInfo 0x2e2f693f7981)>
      1: 0x1f9f6c0532e1 ; [fp + 48] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1030c9d51969 ; [fp + 40] 0x1030c9d51969 <a TypeObject with map 0x33abe2a6d139>
      3: 0xe185ff3d6d9 ; [fp + 32] 0xe185ff3d6d9 <a TypeObject with map 0x33abe2a6d0e1>
      4: 0x130b7e1b5f71 ; [fp + 24] 0x130b7e1b5f71 <an Object with map 0x33abe2a3d1a1>
      5: 0x30bcea404311 ; [fp + 16] 0x30bcea404311 <undefined>
      6: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
  translating frame isSimpleTypeRelatedTo => node=158, height=0
    0x7fff5fbfdca8: [top + 64] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdca0: [top + 56] <- 0x1030c9d51969 ;  0x1030c9d51969 <a TypeObject with map 0x33abe2a6d139>  (input #2)
    0x7fff5fbfdc98: [top + 48] <- 0xe185ff3d6d9 ;  0xe185ff3d6d9 <a TypeObject with map 0x33abe2a6d0e1>  (input #3)
    0x7fff5fbfdc90: [top + 40] <- 0x130b7e1b5f71 ;  0x130b7e1b5f71 <an Object with map 0x33abe2a3d1a1>  (input #4)
    0x7fff5fbfdc88: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfdc80: [top + 24] <- 0x2c21d2207e55 ;  caller's pc
    0x7fff5fbfdc78: [top + 16] <- 0x7fff5fbfdcc8 ;  caller's fp
    0x7fff5fbfdc70: [top + 8] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #6)
    0x7fff5fbfdc68: [top + 0] <- 0x1030c9d448d9 ;  function    0x1030c9d448d9 <JS Function isSimpleTypeRelatedTo (SharedFunctionInfo 0x2e2f693f7981)>  (input #0)
[deoptimizing (soft): end 0x1030c9d448d9 <JS Function isSimpleTypeRelatedTo (SharedFunctionInfo 0x2e2f693f7981)> @10 => node=158, pc=0x2c21d262a793, caller sp=0x7fff5fbfdcb0, state=NO_REGISTERS, took 0.069 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d46489 <JS Function isTypeRelatedTo (SharedFunctionInfo 0x2e2f693f7a41)> (opt #492) @12, FP to SP delta: 40, caller sp: 0x7fff5fbfdd50]
            ;;; deoptimize at 0_553: wrong map
  reading input frame isTypeRelatedTo => node=129, args=4, height=3; inputs:
      0: 0x1030c9d46489 ; [fp - 16] 0x1030c9d46489 <JS Function isTypeRelatedTo (SharedFunctionInfo 0x2e2f693f7a41)>
      1: 0x1f9f6c0532e1 ; [fp + 40] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1030c9d51969 ; rax 0x1030c9d51969 <a TypeObject with map 0x33abe2a6d139>
      3: 0xe185ff3d6d9 ; [fp - 40] 0xe185ff3d6d9 <a TypeObject with map 0x33abe2a6d0e1>
      4: 0x130b7e1b5f71 ; [fp + 16] 0x130b7e1b5f71 <an Object with map 0x33abe2a3d1a1>
      5: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      6: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
      7: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
  translating frame isTypeRelatedTo => node=129, height=16
    0x7fff5fbfdd48: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdd40: [top + 64] <- 0x1030c9d51969 ;  0x1030c9d51969 <a TypeObject with map 0x33abe2a6d139>  (input #2)
    0x7fff5fbfdd38: [top + 56] <- 0xe185ff3d6d9 ;  0xe185ff3d6d9 <a TypeObject with map 0x33abe2a6d0e1>  (input #3)
    0x7fff5fbfdd30: [top + 48] <- 0x130b7e1b5f71 ;  0x130b7e1b5f71 <an Object with map 0x33abe2a3d1a1>  (input #4)
    0x7fff5fbfdd28: [top + 40] <- 0x2c21d26d367c ;  caller's pc
    0x7fff5fbfdd20: [top + 32] <- 0x7fff5fbfdd68 ;  caller's fp
    0x7fff5fbfdd18: [top + 24] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #5)
    0x7fff5fbfdd10: [top + 16] <- 0x1030c9d46489 ;  function    0x1030c9d46489 <JS Function isTypeRelatedTo (SharedFunctionInfo 0x2e2f693f7a41)>  (input #0)
    0x7fff5fbfdd08: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfdd00: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
[deoptimizing (eager): end 0x1030c9d46489 <JS Function isTypeRelatedTo (SharedFunctionInfo 0x2e2f693f7a41)> @12 => node=129, pc=0x2c21d2664e8c, caller sp=0x7fff5fbfdd50, state=NO_REGISTERS, took 0.060 ms]
[deoptimizing (DEOPT eager): begin 0xe185ffe2be9 <JS Function eachTypeRelatedToType (SharedFunctionInfo 0x130b7e106b61)> (opt #494) @2, FP to SP delta: 48, caller sp: 0x7fff5fbfdb10]
            ;;; deoptimize at 0_117: wrong map
  reading input frame eachTypeRelatedToType => node=4, args=4, height=7; inputs:
      0: 0xe185ffe2be9 ; [fp - 16] 0xe185ffe2be9 <JS Function eachTypeRelatedToType (SharedFunctionInfo 0x130b7e106b61)>
      1: 0x1f9f6c0532e1 ; [fp + 40] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1030c9d51969 ; rbx 0x1030c9d51969 <a TypeObject with map 0x33abe2a6d139>
      3: 0xe185ff3d6d9 ; [fp + 24] 0xe185ff3d6d9 <a TypeObject with map 0x33abe2a6d0e1>
      4: 0x30bcea404421 ; [fp + 16] 0x30bcea404421 <false>
      5: 0xe185ffe26f1 ; [fp - 24] 0xe185ffe26f1 <FixedArray[40]>
      6: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
      7: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
      9: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
     10: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
     11: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
  translating frame eachTypeRelatedToType => node=4, height=48
    0x7fff5fbfdb08: [top + 104] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdb00: [top + 96] <- 0x1030c9d51969 ;  0x1030c9d51969 <a TypeObject with map 0x33abe2a6d139>  (input #2)
    0x7fff5fbfdaf8: [top + 88] <- 0xe185ff3d6d9 ;  0xe185ff3d6d9 <a TypeObject with map 0x33abe2a6d0e1>  (input #3)
    0x7fff5fbfdaf0: [top + 80] <- 0x30bcea404421 ;  0x30bcea404421 <false>  (input #4)
    0x7fff5fbfdae8: [top + 72] <- 0x2c21d2712c1e ;  caller's pc
    0x7fff5fbfdae0: [top + 64] <- 0x7fff5fbfdc38 ;  caller's fp
    0x7fff5fbfdad8: [top + 56] <- 0xe185ffe26f1 ;  context    0xe185ffe26f1 <FixedArray[40]>  (input #5)
    0x7fff5fbfdad0: [top + 48] <- 0xe185ffe2be9 ;  function    0xe185ffe2be9 <JS Function eachTypeRelatedToType (SharedFunctionInfo 0x130b7e106b61)>  (input #0)
    0x7fff5fbfdac8: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfdac0: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfdab8: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfdab0: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
    0x7fff5fbfdaa8: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #10)
    0x7fff5fbfdaa0: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #11)
[deoptimizing (eager): end 0xe185ffe2be9 <JS Function eachTypeRelatedToType (SharedFunctionInfo 0x130b7e106b61)> @2 => node=4, pc=0x2c21d269f870, caller sp=0x7fff5fbfdb10, state=NO_REGISTERS, took 0.070 ms]
[deoptimizing (DEOPT eager): begin 0xe185ffe4ae9 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)> (opt #507) @108, FP to SP delta: 296, caller sp: 0x7fff5fbfd728]
            ;;; deoptimize at 0_9038: wrong map
  reading input frame isRelatedTo => node=1624, args=5, height=9; inputs:
      0: 0xe185ffe4ae9 ; [fp - 16] 0xe185ffe4ae9 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)>
      1: 0x1f9f6c0532e1 ; [fp + 48] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x19a2de336621 ; [fp - 56] 0x19a2de336621 <a TypeObject with map 0x33abe2a72d59>
      3: 0x19a2de3c7c91 ; [fp - 40] 0x19a2de3c7c91 <a TypeObject with map 0x33abe2a73599>
      4: 0x30bcea4043b1 ; [fp + 24] 0x30bcea4043b1 <true>
      5: 0x30bcea404311 ; [fp + 16] 0x30bcea404311 <undefined>
      6: 0xe185ffe4879 ; [fp - 24] 0xe185ffe4879 <FixedArray[40]>
      7: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; [fp - 64] 0x30bcea404311 <undefined>
      9: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     10: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     11: 0x19a2de3c7c91 ; rax 0x19a2de3c7c91 <a TypeObject with map 0x33abe2a73599>
     12: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     13: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     14: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
  translating frame isRelatedTo => node=1624, height=64
    0x7fff5fbfd720: [top + 128] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd718: [top + 120] <- 0x19a2de336621 ;  0x19a2de336621 <a TypeObject with map 0x33abe2a72d59>  (input #2)
    0x7fff5fbfd710: [top + 112] <- 0x19a2de3c7c91 ;  0x19a2de3c7c91 <a TypeObject with map 0x33abe2a73599>  (input #3)
    0x7fff5fbfd708: [top + 104] <- 0x30bcea4043b1 ;  0x30bcea4043b1 <true>  (input #4)
    0x7fff5fbfd700: [top + 96] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfd6f8: [top + 88] <- 0x2c21d2207e55 ;  caller's pc
    0x7fff5fbfd6f0: [top + 80] <- 0x7fff5fbfd740 ;  caller's fp
    0x7fff5fbfd6e8: [top + 72] <- 0xe185ffe4879 ;  context    0xe185ffe4879 <FixedArray[40]>  (input #6)
    0x7fff5fbfd6e0: [top + 64] <- 0xe185ffe4ae9 ;  function    0xe185ffe4ae9 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)>  (input #0)
    0x7fff5fbfd6d8: [top + 56] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfd6d0: [top + 48] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfd6c8: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
    0x7fff5fbfd6c0: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #10)
    0x7fff5fbfd6b8: [top + 24] <- 0x19a2de3c7c91 ;  0x19a2de3c7c91 <a TypeObject with map 0x33abe2a73599>  (input #11)
    0x7fff5fbfd6b0: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #12)
    0x7fff5fbfd6a8: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #13)
    0x7fff5fbfd6a0: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #14)
[deoptimizing (eager): end 0xe185ffe4ae9 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)> @108 => node=1624, pc=0x2c21d2629a7d, caller sp=0x7fff5fbfd728, state=NO_REGISTERS, took 0.087 ms]
[deoptimizer unlinked: isRelatedTo / e185ffe4ae9]
[deoptimizer unlinked: isRelatedTo / e185ffe3cb1]
[deoptimizer unlinked: isRelatedTo / e185ffe3321]
[deoptimizer unlinked: isRelatedTo / e185ffe2961]
[deoptimizer unlinked: isRelatedTo / e185ffe0799]
[deoptimizer unlinked: isRelatedTo / e185ffd9969]
[deoptimizer unlinked: isRelatedTo / e185ffd8c81]
[deoptimizer unlinked: isRelatedTo / e185ffd5bb9]
[deoptimizer unlinked: isRelatedTo / e185ffd1fe1]
[deoptimizer unlinked: isRelatedTo / e185ffd02e1]
[deoptimizer unlinked: isRelatedTo / e185ffcf181]
[deoptimizer unlinked: isRelatedTo / e185ffc5b39]
[deoptimizer unlinked: isRelatedTo / e185ff8e5f1]
[deoptimizer unlinked: isRelatedTo / e185ff8d659]
[deoptimizer unlinked: isRelatedTo / e185ff8a771]
[deoptimizer unlinked: isRelatedTo / e185ff83949]
[deoptimizer unlinked: isRelatedTo / e185ff80f81]
[deoptimizer unlinked: isRelatedTo / e185ff7ff79]
[deoptimizer unlinked: isRelatedTo / e185ff7c009]
[deoptimizer unlinked: isRelatedTo / e185ff78331]
[deoptimizer unlinked: isRelatedTo / e185ff722f1]
[deoptimizer unlinked: isRelatedTo / e185ff66ca9]
[deoptimizer unlinked: isRelatedTo / e185ff63c39]
[deoptimizer unlinked: isRelatedTo / e185ff616a9]
[deoptimizer unlinked: isRelatedTo / e185ff60941]
[deoptimizer unlinked: isRelatedTo / e185ff5dc59]
[deoptimizer unlinked: isRelatedTo / e185ff5b831]
[deoptimizer unlinked: isRelatedTo / e185ff37e51]
[deoptimizer unlinked: isRelatedTo / e185ff37161]
[deoptimizer unlinked: isRelatedTo / e185ff35fb1]
[deoptimizer unlinked: isRelatedTo / e185ff352c1]
[deoptimizer unlinked: isRelatedTo / e185ff345d1]
[deoptimizer unlinked: isRelatedTo / e185ff338e1]
[deoptimizer unlinked: isRelatedTo / e185ff32bf1]
[deoptimizer unlinked: isRelatedTo / e185ff2f951]
[deoptimizer unlinked: isRelatedTo / e185ff24da1]
[deoptimizer unlinked: isRelatedTo / e185ff0db69]
[deoptimizer unlinked: isRelatedTo / e185ff08ae9]
[deoptimizer unlinked: isRelatedTo / e185ff046d1]
[deoptimizer unlinked: isRelatedTo / 74e2ecfd1e1]
[deoptimizer unlinked: isRelatedTo / 74e2ecf3571]
[deoptimizer unlinked: isRelatedTo / 74e2ecf0de1]
[deoptimizer unlinked: isRelatedTo / 74e2ec92451]
[deoptimizer unlinked: isRelatedTo / 74e2ec909b1]
[deoptimizer unlinked: isRelatedTo / 74e2ec8e511]
[deoptimizer unlinked: isRelatedTo / 74e2ec8b461]
[deoptimizer unlinked: isRelatedTo / 74e2ec898b9]
[deoptimizer unlinked: isRelatedTo / 74e2ec867d9]
[deoptimizer unlinked: isRelatedTo / 74e2ec7fe89]
[deoptimizer unlinked: isRelatedTo / 74e2ec7cf61]
[deoptimizer unlinked: isRelatedTo / 74e2ec76729]
[deoptimizer unlinked: isRelatedTo / 74e2ec71ff9]
[deoptimizer unlinked: isRelatedTo / 74e2ec6bc31]
[deoptimizer unlinked: isRelatedTo / 74e2ec68db1]
[deoptimizer unlinked: isRelatedTo / 74e2ec637d9]
[deoptimizer unlinked: isRelatedTo / 74e2ec5df79]
[deoptimizer unlinked: isRelatedTo / 74e2ec5b251]
[deoptimizer unlinked: isRelatedTo / 74e2ec55a79]
[deoptimizer unlinked: isRelatedTo / 74e2ec51641]
[deoptimizer unlinked: isRelatedTo / 74e2ec4d619]
[deoptimizer unlinked: isRelatedTo / 74e2ec47da9]
[deoptimizer unlinked: isRelatedTo / 74e2ec45d89]
[deoptimizer unlinked: isRelatedTo / 74e2ec2f0d1]
[deoptimizer unlinked: isRelatedTo / 74e2ec29dc9]
[deoptimizer unlinked: isRelatedTo / 74e2ec277a9]
[deoptimizer unlinked: isRelatedTo / 74e2ec23a51]
[deoptimizer unlinked: isRelatedTo / 74e2ec1b951]
[deoptimizer unlinked: isRelatedTo / 74e2ec18c11]
[deoptimizer unlinked: isRelatedTo / 74e2ec15739]
[deoptimizer unlinked: isRelatedTo / 74e2ec121a9]
[deoptimizer unlinked: isRelatedTo / 74e2ec0f021]
[deoptimizer unlinked: isRelatedTo / 74e2ec0b909]
[deoptimizer unlinked: isRelatedTo / 74e2ec08ea9]
[deoptimizer unlinked: isRelatedTo / 74e2ec081b9]
[deoptimizer unlinked: isRelatedTo / 74e2ec074c9]
[deoptimizer unlinked: isRelatedTo / 74e2ec05371]
[deoptimizer unlinked: isRelatedTo / 1baf624f7c21]
[deoptimizer unlinked: isRelatedTo / 1baf624ef3b9]
[deoptimizer unlinked: isRelatedTo / 1baf624ee6c9]
[deoptimizer unlinked: isRelatedTo / 1baf624ed9d9]
[deoptimizer unlinked: isRelatedTo / 1baf624ecce9]
[deoptimizer unlinked: isRelatedTo / 1baf624ebff9]
[deoptimizer unlinked: isRelatedTo / 1baf624eb309]
[deoptimizer unlinked: isRelatedTo / 1baf624ea1f1]
[deoptimizer unlinked: isRelatedTo / 1baf624da5a1]
[deoptimizer unlinked: isRelatedTo / 1baf624d98b1]
[deoptimizer unlinked: isRelatedTo / 1baf624d7759]
[deoptimizer unlinked: isRelatedTo / 1baf624ce251]
[deoptimizer unlinked: isRelatedTo / 1baf624c6859]
[deoptimizer unlinked: isRelatedTo / 1baf624c4709]
[deoptimizer unlinked: isRelatedTo / 1baf624bdbd9]
[deoptimizer unlinked: isRelatedTo / 1baf624b5fd9]
[deoptimizer unlinked: isRelatedTo / 1baf624b52e9]
[deoptimizer unlinked: isRelatedTo / 1baf624aa279]
[deoptimizer unlinked: isRelatedTo / 1baf624a9589]
[deoptimizer unlinked: isRelatedTo / 1baf624a8899]
[deoptimizer unlinked: isRelatedTo / 1baf624a7ba9]
[deoptimizer unlinked: isRelatedTo / 1baf624a6a91]
[deoptimizer unlinked: isRelatedTo / 1baf624995f9]
[deoptimizer unlinked: isRelatedTo / 1baf62497459]
[deoptimizer unlinked: isRelatedTo / 1baf62496769]
[deoptimizer unlinked: isRelatedTo / 1baf62495a79]
[deoptimizer unlinked: isRelatedTo / 1baf62494d89]
[deoptimizer unlinked: isRelatedTo / 1baf62492501]
[deoptimizer unlinked: isRelatedTo / 1baf62488fb9]
[deoptimizer unlinked: isRelatedTo / 1baf62480c41]
[deoptimizer unlinked: isRelatedTo / 1baf6247ff51]
[deoptimizer unlinked: isRelatedTo / 1baf6247f261]
[deoptimizer unlinked: isRelatedTo / 1baf6247e571]
[deoptimizer unlinked: isRelatedTo / 1baf6247d881]
[deoptimizer unlinked: isRelatedTo / 1baf6247b719]
[deoptimizer unlinked: isRelatedTo / 1baf62472141]
[deoptimizer unlinked: isRelatedTo / 1baf62469af1]
[deoptimizer unlinked: isRelatedTo / 1baf62467989]
[deoptimizer unlinked: isRelatedTo / 1baf6245e441]
[deoptimizer unlinked: isRelatedTo / 1baf624531f9]
[deoptimizer unlinked: isRelatedTo / 1baf62451091]
[deoptimizer unlinked: isRelatedTo / 1baf62447b89]
[deoptimizer unlinked: isRelatedTo / 1baf6243fae9]
[deoptimizer unlinked: isRelatedTo / 1baf6243edf9]
[deoptimizer unlinked: isRelatedTo / 1baf6243cc91]
[deoptimizer unlinked: isRelatedTo / 1baf62433779]
[deoptimizer unlinked: isRelatedTo / 1baf62429911]
[deoptimizer unlinked: isRelatedTo / 1baf62426879]
[deoptimizer unlinked: isRelatedTo / 1baf6241b349]
[deoptimizer unlinked: isRelatedTo / 3571adbfdf61]
[deoptimizer unlinked: isRelatedTo / 3571adbf5e59]
[deoptimizer unlinked: isRelatedTo / 3571adbf5169]
[deoptimizer unlinked: isRelatedTo / 3571adbf4479]
[deoptimizer unlinked: isRelatedTo / 3571adbf3789]
[deoptimizer unlinked: isRelatedTo / 3571adbf2a99]
[deoptimizer unlinked: isRelatedTo / 3571adbf1da9]
[deoptimizer unlinked: isRelatedTo / 3571adbf10b9]
[deoptimizer unlinked: isRelatedTo / 3571adbf03c9]
[deoptimizer unlinked: isRelatedTo / 3571adbee039]
[deoptimizer unlinked: isRelatedTo / 3571adbe3841]
[deoptimizer unlinked: isRelatedTo / 3571adbd9239]
[deoptimizer unlinked: isRelatedTo / 3571adbd6a39]
[deoptimizer unlinked: isRelatedTo / 3571adbd5d49]
[deoptimizer unlinked: isRelatedTo / 3571adbd5059]
[deoptimizer unlinked: isRelatedTo / 3571adbd4369]
[deoptimizer unlinked: isRelatedTo / 3571adbd3679]
[deoptimizer unlinked: isRelatedTo / 3571adbd1511]
[deoptimizer unlinked: isRelatedTo / 3571adbc7ed9]
[deoptimizer unlinked: isRelatedTo / 3571adbb92a9]
[deoptimizer unlinked: isRelatedTo / 3571adb98679]
[deoptimizer unlinked: isRelatedTo / 3571adb97989]
[deoptimizer unlinked: isRelatedTo / 3571adb96c99]
[deoptimizer unlinked: isRelatedTo / 3571adb95fa9]
[deoptimizer unlinked: isRelatedTo / 3571adb952b9]
[deoptimizer unlinked: isRelatedTo / 3571adb945c9]
[deoptimizer unlinked: isRelatedTo / 3571adb92461]
[deoptimizer unlinked: isRelatedTo / 3571adb88e69]
[deoptimizer unlinked: isRelatedTo / 3571adb80799]
[deoptimizer unlinked: isRelatedTo / 3571adb7faa9]
[deoptimizer unlinked: isRelatedTo / 3571adb7edb9]
[deoptimizer unlinked: isRelatedTo / 3571adb7e0c9]
[deoptimizer unlinked: isRelatedTo / 3571adb7d3d9]
[deoptimizer unlinked: isRelatedTo / 3571adb7c6e9]
[deoptimizer unlinked: isRelatedTo / 3571adb7a581]
[deoptimizer unlinked: isRelatedTo / 3571adb70f89]
[deoptimizer unlinked: isRelatedTo / 3571adb639c9]
[deoptimizer unlinked: isRelatedTo / 3571adb62cd9]
[deoptimizer unlinked: isRelatedTo / 3571adb61fe9]
[deoptimizer unlinked: isRelatedTo / 3571adb612f9]
[deoptimizer unlinked: isRelatedTo / 3571adb60609]
[deoptimizer unlinked: isRelatedTo / 3571adb5f919]
[deoptimizer unlinked: isRelatedTo / 3571adb5ec29]
[deoptimizer unlinked: isRelatedTo / 3571adb5cac1]
[deoptimizer unlinked: isRelatedTo / 3571adb53489]
[deoptimizer unlinked: isRelatedTo / 3571adb49f01]
[deoptimizer unlinked: isRelatedTo / 3571adb47089]
[deoptimizer unlinked: isRelatedTo / 3571adb40ef9]
[deoptimizer unlinked: isRelatedTo / 3571adb3e0c9]
[deoptimizer unlinked: isRelatedTo / 3571adb3b251]
[deoptimizer unlinked: isRelatedTo / 3571adb38421]
[deoptimizer unlinked: isRelatedTo / 3571adb355f1]
[deoptimizer unlinked: isRelatedTo / 3571adb32779]
[deoptimizer unlinked: isRelatedTo / 3571adb2f901]
[deoptimizer unlinked: isRelatedTo / 3571adb2ca89]
[deoptimizer unlinked: isRelatedTo / 3571adb29b81]
[deoptimizer unlinked: isRelatedTo / 3571adb26c79]
[deoptimizer unlinked: isRelatedTo / 3571adb23d71]
[deoptimizer unlinked: isRelatedTo / 3571adb20e69]
[deoptimizer unlinked: isRelatedTo / 3571adb1db99]
[deoptimizer unlinked: isRelatedTo / 3571adb1a8c9]
[deoptimizer unlinked: isRelatedTo / 3571adb17b99]
[deoptimizer unlinked: isRelatedTo / 3571adb14881]
[deoptimizer unlinked: isRelatedTo / 3571adb11569]
[deoptimizer unlinked: isRelatedTo / 181e011fe961]
[deoptimizer unlinked: isRelatedTo / 181e011fdc71]
[deoptimizer unlinked: isRelatedTo / 181e011fcf81]
[deoptimizer unlinked: isRelatedTo / 181e011fc291]
[deoptimizer unlinked: isRelatedTo / 181e011fb5a1]
[deoptimizer unlinked: isRelatedTo / 181e011fa8b1]
[deoptimizer unlinked: isRelatedTo / 181e011f8749]
[deoptimizer unlinked: isRelatedTo / 181e011ef001]
[deoptimizer unlinked: isRelatedTo / 181e011e0bf1]
[deoptimizer unlinked: isRelatedTo / 181e011d75a9]
[deoptimizer unlinked: isRelatedTo / 181e011d02c9]
[deoptimizer unlinked: isRelatedTo / 181e011cf5d9]
[deoptimizer unlinked: isRelatedTo / 181e011ce8e9]
[deoptimizer unlinked: isRelatedTo / 181e011cdbf9]
[deoptimizer unlinked: isRelatedTo / 181e011ccf09]
[deoptimizer unlinked: isRelatedTo / 181e011cada1]
[deoptimizer unlinked: isRelatedTo / 181e011c1651]
[deoptimizer unlinked: isRelatedTo / 181e011b7a81]
[deoptimizer unlinked: isRelatedTo / 181e011b6d91]
[deoptimizer unlinked: isRelatedTo / 181e011b60a1]
[deoptimizer unlinked: isRelatedTo / 181e011b53b1]
[deoptimizer unlinked: isRelatedTo / 181e011b3269]
[deoptimizer unlinked: isRelatedTo / 181e011a9c51]
[deoptimizer unlinked: isRelatedTo / 181e0119bbd1]
[deoptimizer unlinked: isRelatedTo / 181e01199871]
[deoptimizer unlinked: isRelatedTo / 181e01198b81]
[deoptimizer unlinked: isRelatedTo / 181e01197e91]
[deoptimizer unlinked: isRelatedTo / 181e011971a1]
[deoptimizer unlinked: isRelatedTo / 181e011964b1]
[deoptimizer unlinked: isRelatedTo / 181e01194369]
[deoptimizer unlinked: isRelatedTo / 181e0118ad71]
[deoptimizer unlinked: isRelatedTo / 181e0117cce1]
[deoptimizer unlinked: isRelatedTo / 181e0117bff1]
[deoptimizer unlinked: isRelatedTo / 181e0117b301]
[deoptimizer unlinked: isRelatedTo / 181e0117a611]
[deoptimizer unlinked: isRelatedTo / 181e01179921]
[deoptimizer unlinked: isRelatedTo / 181e01178c31]
[deoptimizer unlinked: isRelatedTo / 181e01176ae9]
[deoptimizer unlinked: isRelatedTo / 181e0116d4d1]
[deoptimizer unlinked: isRelatedTo / 181e011646c9]
[deoptimizer unlinked: isRelatedTo / 181e011639d9]
[deoptimizer unlinked: isRelatedTo / 181e01162ce9]
[deoptimizer unlinked: isRelatedTo / 181e01161ff9]
[deoptimizer unlinked: isRelatedTo / 181e0115feb1]
[deoptimizer unlinked: isRelatedTo / 181e01156919]
[deoptimizer unlinked: isRelatedTo / 181e0114e419]
[deoptimizer unlinked: isRelatedTo / 181e0114d729]
[deoptimizer unlinked: isRelatedTo / 181e0114ca39]
[deoptimizer unlinked: isRelatedTo / 181e0114bd49]
[deoptimizer unlinked: isRelatedTo / 181e0114b059]
[deoptimizer unlinked: isRelatedTo / 181e01148f11]
[deoptimizer unlinked: isRelatedTo / 181e0113f959]
[deoptimizer unlinked: isRelatedTo / 181e011371e9]
[deoptimizer unlinked: isRelatedTo / 181e011364f9]
[deoptimizer unlinked: isRelatedTo / 181e01135809]
[deoptimizer unlinked: isRelatedTo / 181e01134b19]
[deoptimizer unlinked: isRelatedTo / 181e01133e29]
[deoptimizer unlinked: isRelatedTo / 181e01131ce1]
[deoptimizer unlinked: isRelatedTo / 181e01128159]
[deoptimizer unlinked: isRelatedTo / 181e0111ea79]
[deoptimizer unlinked: isRelatedTo / 181e0111dd89]
[deoptimizer unlinked: isRelatedTo / 181e0111d099]
[deoptimizer unlinked: isRelatedTo / 181e0111c3a9]
[deoptimizer unlinked: isRelatedTo / 181e0111b6b9]
[deoptimizer unlinked: isRelatedTo / 181e01119571]
[deoptimizer unlinked: isRelatedTo / 181e0110fd11]
[deoptimizer unlinked: isRelatedTo / 181e011069b9]
[deoptimizer unlinked: isRelatedTo / 181e01104871]
[deoptimizer unlinked: isRelatedTo / 1419212f6f99]
[deoptimizer unlinked: isRelatedTo / 1419212eeb81]
[deoptimizer unlinked: isRelatedTo / 1419212eca39]
[deoptimizer unlinked: isRelatedTo / 1419212e33c9]
[deoptimizer unlinked: isRelatedTo / 1419212d9779]
[deoptimizer unlinked: isRelatedTo / 1419212d0041]
[deoptimizer unlinked: isRelatedTo / 1419212cd8c9]
[deoptimizer unlinked: isRelatedTo / 1419212ca539]
[deoptimizer unlinked: isRelatedTo / 1419212c0fa1]
[deoptimizer unlinked: isRelatedTo / 1419212b77a1]
[deoptimizer unlinked: isRelatedTo / 1419212ae109]
[deoptimizer unlinked: isRelatedTo / 1419212abe19]
[deoptimizer unlinked: isRelatedTo / 1419212a9cd1]
[deoptimizer unlinked: isRelatedTo / 1419212a0769]
[deoptimizer unlinked: isRelatedTo / 141921297f71]
[deoptimizer unlinked: isRelatedTo / 141921295e29]
[deoptimizer unlinked: isRelatedTo / 14192128c881]
[deoptimizer unlinked: isRelatedTo / 141921283129]
[deoptimizer unlinked: isRelatedTo / 141921279ad1]
[deoptimizer unlinked: isRelatedTo / 141921277931]
[deoptimizer unlinked: isRelatedTo / 1419212757e9]
[deoptimizer unlinked: isRelatedTo / 14192126c2b1]
[deoptimizer unlinked: isRelatedTo / 141921264139]
[deoptimizer unlinked: isRelatedTo / 141921263449]
[deoptimizer unlinked: isRelatedTo / 141921262759]
[deoptimizer unlinked: isRelatedTo / 141921261a69]
[deoptimizer unlinked: isRelatedTo / 14192125f921]
[deoptimizer unlinked: isRelatedTo / 141921256399]
[deoptimizer unlinked: isRelatedTo / 14192124d879]
[deoptimizer unlinked: isRelatedTo / 14192124b731]
[deoptimizer unlinked: isRelatedTo / 1419212421b9]
[deoptimizer unlinked: isRelatedTo / 141921234bc1]
[deoptimizer unlinked: isRelatedTo / 14192122d611]
[deoptimizer unlinked: isRelatedTo / 141921226061]
[deoptimizer unlinked: isRelatedTo / 14192121eab1]
[deoptimizer unlinked: isRelatedTo / 14192121c911]
[deoptimizer unlinked: isRelatedTo / 14192121a7c9]
[deoptimizer unlinked: isRelatedTo / 141921211291]
[deoptimizer unlinked: isRelatedTo / 141921207c51]
[deoptimizer unlinked: isRelatedTo / 2998a25fa011]
[deoptimizer unlinked: isRelatedTo / 2998a25f73a1]
[deoptimizer unlinked: isRelatedTo / 2998a25f5259]
[deoptimizer unlinked: isRelatedTo / 2998a25ebc81]
[deoptimizer unlinked: isRelatedTo / 2998a25e2229]
[deoptimizer unlinked: isRelatedTo / 2998a25e00e1]
[deoptimizer unlinked: isRelatedTo / 2998a25d6b59]
[deoptimizer unlinked: isRelatedTo / 2998a25cd411]
[deoptimizer unlinked: isRelatedTo / 2998a25cb2c9]
[deoptimizer unlinked: isRelatedTo / 2998a25c1c91]
[deoptimizer unlinked: isRelatedTo / 2998a25b8089]
[deoptimizer unlinked: isRelatedTo / 2998a25b5f41]
[deoptimizer unlinked: isRelatedTo / 2998a25ac929]
[deoptimizer unlinked: isRelatedTo / 2998a25a39b1]
[deoptimizer unlinked: isRelatedTo / 2998a25a1869]
[deoptimizer unlinked: isRelatedTo / 2998a2598321]
[deoptimizer unlinked: isRelatedTo / 2998a258ed01]
[deoptimizer unlinked: isRelatedTo / 2998a258cbb9]
[deoptimizer unlinked: isRelatedTo / 2998a2583601]
[deoptimizer unlinked: isRelatedTo / 2998a25797b1]
[deoptimizer unlinked: isRelatedTo / 2998a2577669]
[deoptimizer unlinked: isRelatedTo / 2998a256dff1]
[deoptimizer unlinked: isRelatedTo / 2998a25643b9]
[deoptimizer unlinked: isRelatedTo / 2998a25636c9]
[deoptimizer unlinked: isRelatedTo / 2998a25629d9]
[deoptimizer unlinked: isRelatedTo / 2998a2561ce9]
[deoptimizer unlinked: isRelatedTo / 2998a2560ff9]
[deoptimizer unlinked: isRelatedTo / 2998a255eeb1]
[deoptimizer unlinked: isRelatedTo / 2998a25558a9]
[deoptimizer unlinked: isRelatedTo / 2998a254af11]
[deoptimizer unlinked: isRelatedTo / 2998a2546ee1]
[deoptimizer unlinked: isRelatedTo / 2998a2545779]
[deoptimizer unlinked: isRelatedTo / 2998a25436f1]
[deoptimizer unlinked: isRelatedTo / 2998a2542a01]
[deoptimizer unlinked: isRelatedTo / 2998a25408b9]
[deoptimizer unlinked: isRelatedTo / 2998a25373b1]
[deoptimizer unlinked: isRelatedTo / 2998a252e791]
[deoptimizer unlinked: isRelatedTo / 2998a252daa1]
[deoptimizer unlinked: isRelatedTo / 2998a252cdb1]
[deoptimizer unlinked: isRelatedTo / 2998a252c0c1]
[deoptimizer unlinked: isRelatedTo / 2998a252b3d1]
[deoptimizer unlinked: isRelatedTo / 2998a2529289]
[deoptimizer unlinked: isRelatedTo / 2998a251fcc1]
[deoptimizer unlinked: isRelatedTo / 317e709f6269]
[deoptimizer unlinked: isRelatedTo / 317e709eca91]
[deoptimizer unlinked: isRelatedTo / 317e709ea881]
[deoptimizer unlinked: isRelatedTo / 317e709e9b91]
[deoptimizer unlinked: isRelatedTo / 317e709e8ea1]
[deoptimizer unlinked: isRelatedTo / 317e709e81b1]
[deoptimizer unlinked: isRelatedTo / 317e709e74c1]
[deoptimizer unlinked: isRelatedTo / 317e709e67d1]
[deoptimizer unlinked: isRelatedTo / 317e709e4689]
[deoptimizer unlinked: isRelatedTo / 317e709db081]
[deoptimizer unlinked: isRelatedTo / 317e709d1979]
[deoptimizer unlinked: isRelatedTo / 317e709d0c89]
[deoptimizer unlinked: isRelatedTo / 317e709cff99]
[deoptimizer unlinked: isRelatedTo / 317e709cf2a9]
[deoptimizer unlinked: isRelatedTo / 317e709ce5b9]
[deoptimizer unlinked: isRelatedTo / 317e709cc471]
[deoptimizer unlinked: isRelatedTo / 317e709c2e79]
[deoptimizer unlinked: isRelatedTo / 317e709ad291]
[deoptimizer unlinked: isRelatedTo / 317e709ac5a1]
[deoptimizer unlinked: isRelatedTo / 317e709ab8b1]
[deoptimizer unlinked: isRelatedTo / 317e709aabc1]
[deoptimizer unlinked: isRelatedTo / 317e709a9ed1]
[deoptimizer unlinked: isRelatedTo / 317e709a91e1]
[deoptimizer unlinked: isRelatedTo / 317e709a6fd9]
[deoptimizer unlinked: isRelatedTo / 317e7099d9f1]
[deoptimizer unlinked: isRelatedTo / 317e7098a5b9]
[deoptimizer unlinked: isRelatedTo / 317e709878b1]
[deoptimizer unlinked: isRelatedTo / 317e70984191]
[deoptimizer unlinked: isRelatedTo / 317e70981859]
[deoptimizer unlinked: isRelatedTo / 317e7097bf51]
[deoptimizer unlinked: isRelatedTo / 317e70978fc9]
[deoptimizer unlinked: isRelatedTo / 317e70972929]
[deoptimizer unlinked: isRelatedTo / 317e7096fbb1]
[deoptimizer unlinked: isRelatedTo / 317e7096c6c1]
[deoptimizer unlinked: isRelatedTo / 317e70966589]
[deoptimizer unlinked: isRelatedTo / 317e709633c9]
[deoptimizer unlinked: isRelatedTo / 317e7095fb11]
[deoptimizer unlinked: isRelatedTo / 317e7095bec1]
[deoptimizer unlinked: isRelatedTo / 317e70958f99]
[deoptimizer unlinked: isRelatedTo / 317e70955971]
[deoptimizer unlinked: isRelatedTo / 317e70952901]
[deoptimizer unlinked: isRelatedTo / 317e7094fbb9]
[deoptimizer unlinked: isRelatedTo / 317e7094c6c9]
[deoptimizer unlinked: isRelatedTo / 317e70947e49]
[deoptimizer unlinked: isRelatedTo / 317e70944aa9]
[deoptimizer unlinked: isRelatedTo / 317e70941121]
[deoptimizer unlinked: isRelatedTo / 317e7093d719]
[deoptimizer unlinked: isRelatedTo / 317e7093a141]
[deoptimizer unlinked: isRelatedTo / 317e70934b19]
[deoptimizer unlinked: isRelatedTo / 317e7092eef1]
[deoptimizer unlinked: isRelatedTo / 317e709280b9]
[deoptimizer unlinked: isRelatedTo / 317e70925c89]
[deoptimizer unlinked: isRelatedTo / 317e70920271]
[deoptimizer unlinked: isRelatedTo / 317e7091be41]
[deoptimizer unlinked: isRelatedTo / 317e70918bd9]
[deoptimizer unlinked: isRelatedTo / 317e70917041]
[deoptimizer unlinked: isRelatedTo / 317e70907bf1]
[deoptimizer unlinked: isRelatedTo / 317e70904dd1]
[deoptimizer unlinked: isRelatedTo / a76957fd7f9]
[deoptimizer unlinked: isRelatedTo / a76957fa409]
[deoptimizer unlinked: isRelatedTo / a76957f7509]
[deoptimizer unlinked: isRelatedTo / a76957f42d9]
[deoptimizer unlinked: isRelatedTo / a76957f0741]
[deoptimizer unlinked: isRelatedTo / a76957ed209]
[deoptimizer unlinked: isRelatedTo / a76957dd0d9]
[deoptimizer unlinked: isRelatedTo / a76957d8761]
[deoptimizer unlinked: isRelatedTo / a76957d7a71]
[deoptimizer unlinked: isRelatedTo / a76957d6d81]
[deoptimizer unlinked: isRelatedTo / a76957d6091]
[deoptimizer unlinked: isRelatedTo / a76957d53a1]
[deoptimizer unlinked: isRelatedTo / a76957d46b1]
[deoptimizer unlinked: isRelatedTo / a76957d39c1]
[deoptimizer unlinked: isRelatedTo / a76957d2cd1]
[deoptimizer unlinked: isRelatedTo / a76957d0729]
[deoptimizer unlinked: isRelatedTo / a76957c9ed9]
[deoptimizer unlinked: isRelatedTo / a76957c8649]
[deoptimizer unlinked: isRelatedTo / a76957c42f9]
[deoptimizer unlinked: isRelatedTo / a76957b7339]
[deoptimizer unlinked: isRelatedTo / a76957b2f19]
[deoptimizer unlinked: isRelatedTo / a76957ad441]
[deoptimizer unlinked: isRelatedTo / a76957aa791]
[deoptimizer unlinked: isRelatedTo / a76957a65f9]
[deoptimizer unlinked: isRelatedTo / a76957a2709]
[deoptimizer unlinked: isRelatedTo / a769579d731]
[deoptimizer unlinked: isRelatedTo / a769579a2e9]
[deoptimizer unlinked: isRelatedTo / a7695796821]
[deoptimizer unlinked: isRelatedTo / a76957937d1]
[deoptimizer unlinked: isRelatedTo / a769578d6c9]
[deoptimizer unlinked: isRelatedTo / a769578a591]
[deoptimizer unlinked: isRelatedTo / a76957867e1]
[deoptimizer unlinked: isRelatedTo / a7695779d31]
[deoptimizer unlinked: isRelatedTo / a7695776bf1]
[deoptimizer unlinked: isRelatedTo / a7695772259]
[deoptimizer unlinked: isRelatedTo / a7695770379]
[deoptimizer unlinked: isRelatedTo / a769576d051]
[deoptimizer unlinked: isRelatedTo / a769576a301]
[deoptimizer unlinked: isRelatedTo / a7695764a61]
[deoptimizer unlinked: isRelatedTo / a7695761af9]
[deoptimizer unlinked: isRelatedTo / a769575d061]
[deoptimizer unlinked: isRelatedTo / a769575c129]
[deoptimizer unlinked: isRelatedTo / a7695759099]
[deoptimizer unlinked: isRelatedTo / a7695754151]
[deoptimizer unlinked: isRelatedTo / a769574d019]
[deoptimizer unlinked: isRelatedTo / a76957483e9]
[deoptimizer unlinked: isRelatedTo / a7695745311]
[deoptimizer unlinked: isRelatedTo / a7695742251]
[deoptimizer unlinked: isRelatedTo / a769573c771]
[deoptimizer unlinked: isRelatedTo / a7695738699]
[deoptimizer unlinked: isRelatedTo / a7695735691]
[deoptimizer unlinked: isRelatedTo / a7695729349]
[deoptimizing (DEOPT lazy): begin 0xe185ffe4ae9 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)> (opt #507) @95, FP to SP delta: 296, caller sp: 0x7fff5fbfdb30]
  reading input frame isRelatedTo => node=2079, args=5, height=10; inputs:
      0: 0xe185ffe4ae9 ; [fp - 16] 0xe185ffe4ae9 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)>
      1: 0x1f9f6c0532e1 ; [fp + 48] 0x1f9f6c0532e1 <JS Global Object>
      2: 0xe185ffe5b09 ; [fp - 56] 0xe185ffe5b09 <a TypeObject with map 0x33abe2a6d349>
      3: 0xa76957e8e81 ; [fp - 40] 0xa76957e8e81 <a TypeObject with map 0x33abe2a6d349>
      4: 0x30bcea4043b1 ; [fp + 24] 0x30bcea4043b1 <true>
      5: 0x30bcea404311 ; [fp + 16] 0x30bcea404311 <undefined>
      6: 0xe185ffe4879 ; [fp - 24] 0xe185ffe4879 <FixedArray[40]>
      7: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; [fp - 64] 0x30bcea404311 <undefined>
      9: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     10: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     11: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     12: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     13: 0x30bcea4069a9 ; (literal 24) 0x30bcea4069a9 <Odd Oddball: optimized_out>
     14: 0x30bcea4069a9 ; (literal 24) 0x30bcea4069a9 <Odd Oddball: optimized_out>
     15: 0xffffffff00000000 ; rax -1
  translating frame isRelatedTo => node=2079, height=72
    0x7fff5fbfdb28: [top + 136] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdb20: [top + 128] <- 0xe185ffe5b09 ;  0xe185ffe5b09 <a TypeObject with map 0x33abe2a6d349>  (input #2)
    0x7fff5fbfdb18: [top + 120] <- 0xa76957e8e81 ;  0xa76957e8e81 <a TypeObject with map 0x33abe2a6d349>  (input #3)
    0x7fff5fbfdb10: [top + 112] <- 0x30bcea4043b1 ;  0x30bcea4043b1 <true>  (input #4)
    0x7fff5fbfdb08: [top + 104] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfdb00: [top + 96] <- 0x2c21d2207e55 ;  caller's pc
    0x7fff5fbfdaf8: [top + 88] <- 0x7fff5fbfdb48 ;  caller's fp
    0x7fff5fbfdaf0: [top + 80] <- 0xe185ffe4879 ;  context    0xe185ffe4879 <FixedArray[40]>  (input #6)
    0x7fff5fbfdae8: [top + 72] <- 0xe185ffe4ae9 ;  function    0xe185ffe4ae9 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)>  (input #0)
    0x7fff5fbfdae0: [top + 64] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfdad8: [top + 56] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfdad0: [top + 48] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
    0x7fff5fbfdac8: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #10)
    0x7fff5fbfdac0: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #11)
    0x7fff5fbfdab8: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #12)
    0x7fff5fbfdab0: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #13)
    0x7fff5fbfdaa8: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #14)
    0x7fff5fbfdaa0: [top + 0] <- 0xffffffff00000000 ;  -1  (input #15)
[deoptimizing (lazy): end 0xe185ffe4ae9 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)> @95 => node=2079, pc=0x2c21d262a031, caller sp=0x7fff5fbfdb30, state=TOS_REGISTER, took 0.108 ms]
[deoptimizing (DEOPT eager): begin 0xe185ffe5089 <JS Function indexTypesRelatedTo (SharedFunctionInfo 0x130b7e1073a1)> (opt #486) @21, FP to SP delta: 112, caller sp: 0x7fff5fbfdc28]
            ;;; deoptimize at 0_317: wrong map
  reading input frame indexTypesRelatedTo => node=80, args=6, height=5; inputs:
      0: 0xe185ffe5089 ; [fp - 16] 0xe185ffe5089 <JS Function indexTypesRelatedTo (SharedFunctionInfo 0x130b7e1073a1)>
      1: 0x1f9f6c0532e1 ; [fp + 56] 0x1f9f6c0532e1 <JS Global Object>
      2: 0xe185ffe46c1 ; [fp + 48] 0xe185ffe46c1 <a TypeObject with map 0x33abe2a74721>
      3: 0xe185ffe46c1 ; [fp + 40] 0xe185ffe46c1 <a TypeObject with map 0x33abe2a74721>
      4: 0x29cc38d58821 ; [fp + 32] 0x29cc38d58821 <a TypeObject with map 0x33abe2a73f91>
      5: 0x100000000 ; [fp + 24] 1
      6: 0x30bcea4043b1 ; [fp + 16] 0x30bcea4043b1 <true>
      7: 0xe185ffe4879 ; [fp - 24] 0xe185ffe4879 <FixedArray[40]>
      8: 0xa76957e8b89 ; rax 0xa76957e8b89 <an Object with map 0x33abe2a6d921>
      9: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     10: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     11: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
  translating frame indexTypesRelatedTo => node=80, height=32
    0x7fff5fbfdc20: [top + 104] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdc18: [top + 96] <- 0xe185ffe46c1 ;  0xe185ffe46c1 <a TypeObject with map 0x33abe2a74721>  (input #2)
    0x7fff5fbfdc10: [top + 88] <- 0xe185ffe46c1 ;  0xe185ffe46c1 <a TypeObject with map 0x33abe2a74721>  (input #3)
    0x7fff5fbfdc08: [top + 80] <- 0x29cc38d58821 ;  0x29cc38d58821 <a TypeObject with map 0x33abe2a73f91>  (input #4)
    0x7fff5fbfdc00: [top + 72] <- 0x100000000 ;  1  (input #5)
    0x7fff5fbfdbf8: [top + 64] <- 0x30bcea4043b1 ;  0x30bcea4043b1 <true>  (input #6)
    0x7fff5fbfdbf0: [top + 56] <- 0x2c21d262bc81 ;  caller's pc
    0x7fff5fbfdbe8: [top + 48] <- 0x7fff5fbfdc80 ;  caller's fp
    0x7fff5fbfdbe0: [top + 40] <- 0xe185ffe4879 ;  context    0xe185ffe4879 <FixedArray[40]>  (input #7)
    0x7fff5fbfdbd8: [top + 32] <- 0xe185ffe5089 ;  function    0xe185ffe5089 <JS Function indexTypesRelatedTo (SharedFunctionInfo 0x130b7e1073a1)>  (input #0)
    0x7fff5fbfdbd0: [top + 24] <- 0xa76957e8b89 ;  0xa76957e8b89 <an Object with map 0x33abe2a6d921>  (input #8)
    0x7fff5fbfdbc8: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
    0x7fff5fbfdbc0: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #10)
    0x7fff5fbfdbb8: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #11)
[deoptimizing (eager): end 0xe185ffe5089 <JS Function indexTypesRelatedTo (SharedFunctionInfo 0x130b7e1073a1)> @21 => node=80, pc=0x2c21d26317da, caller sp=0x7fff5fbfdc28, state=NO_REGISTERS, took 0.076 ms]
[deoptimizing (DEOPT lazy): begin 0xe185ffe4ae9 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)> (opt #507) @95, FP to SP delta: 296, caller sp: 0x7fff5fbfde18]
  reading input frame isRelatedTo => node=2079, args=5, height=10; inputs:
      0: 0xe185ffe4ae9 ; [fp - 16] 0xe185ffe4ae9 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)>
      1: 0x1f9f6c0532e1 ; [fp + 48] 0x1f9f6c0532e1 <JS Global Object>
      2: 0xe185ffe46c1 ; [fp - 56] 0xe185ffe46c1 <a TypeObject with map 0x33abe2a74721>
      3: 0x29cc38d58821 ; [fp - 40] 0x29cc38d58821 <a TypeObject with map 0x33abe2a73f91>
      4: 0x30bcea4043b1 ; [fp + 24] 0x30bcea4043b1 <true>
      5: 0xd6230df7599 ; [fp + 16] 0xd6230df7599 <an Object with map 0x33abe2a3df61>
      6: 0xe185ffe4879 ; [fp - 24] 0xe185ffe4879 <FixedArray[40]>
      7: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; [fp - 64] 0x30bcea404311 <undefined>
      9: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     10: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     11: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     12: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     13: 0x30bcea4069a9 ; (literal 24) 0x30bcea4069a9 <Odd Oddball: optimized_out>
     14: 0x30bcea4069a9 ; (literal 24) 0x30bcea4069a9 <Odd Oddball: optimized_out>
     15: 0xffffffff00000000 ; rax -1
  translating frame isRelatedTo => node=2079, height=72
    0x7fff5fbfde10: [top + 136] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfde08: [top + 128] <- 0xe185ffe46c1 ;  0xe185ffe46c1 <a TypeObject with map 0x33abe2a74721>  (input #2)
    0x7fff5fbfde00: [top + 120] <- 0x29cc38d58821 ;  0x29cc38d58821 <a TypeObject with map 0x33abe2a73f91>  (input #3)
    0x7fff5fbfddf8: [top + 112] <- 0x30bcea4043b1 ;  0x30bcea4043b1 <true>  (input #4)
    0x7fff5fbfddf0: [top + 104] <- 0xd6230df7599 ;  0xd6230df7599 <an Object with map 0x33abe2a3df61>  (input #5)
    0x7fff5fbfdde8: [top + 96] <- 0x2c21d2649a8d ;  caller's pc
    0x7fff5fbfdde0: [top + 88] <- 0x7fff5fbfde58 ;  caller's fp
    0x7fff5fbfddd8: [top + 80] <- 0xe185ffe4879 ;  context    0xe185ffe4879 <FixedArray[40]>  (input #6)
    0x7fff5fbfddd0: [top + 72] <- 0xe185ffe4ae9 ;  function    0xe185ffe4ae9 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)>  (input #0)
    0x7fff5fbfddc8: [top + 64] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfddc0: [top + 56] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfddb8: [top + 48] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
    0x7fff5fbfddb0: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #10)
    0x7fff5fbfdda8: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #11)
    0x7fff5fbfdda0: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #12)
    0x7fff5fbfdd98: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #13)
    0x7fff5fbfdd90: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #14)
    0x7fff5fbfdd88: [top + 0] <- 0xffffffff00000000 ;  -1  (input #15)
[deoptimizing (lazy): end 0xe185ffe4ae9 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)> @95 => node=2079, pc=0x2c21d262a031, caller sp=0x7fff5fbfde18, state=TOS_REGISTER, took 0.083 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d3cdd1 <JS Function instantiateTypeNoAlias (SharedFunctionInfo 0x2e2f693f6781)> (opt #484) @76, FP to SP delta: 224, caller sp: 0x7fff5fbfdd30]
            ;;; deoptimize at 0_854: wrong map
  reading input frame instantiateTypeNoAlias => node=62, args=3, height=1; inputs:
      0: 0x1030c9d3cdd1 ; [fp - 16] 0x1030c9d3cdd1 <JS Function instantiateTypeNoAlias (SharedFunctionInfo 0x2e2f693f6781)>
      1: 0x1f9f6c0532e1 ; [fp + 32] 0x1f9f6c0532e1 <JS Global Object>
      2: 0xe185ffe5b09 ; rax 0xe185ffe5b09 <a TypeObject with map 0x33abe2a6d349>
      3: 0xe185ffe6559 ; [fp + 16] 0xe185ffe6559 <JS Function (SharedFunctionInfo 0x130b7e10b589)>
      4: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
  translating frame instantiateTypeNoAlias => node=62, height=0
    0x7fff5fbfdd28: [top + 48] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdd20: [top + 40] <- 0xe185ffe5b09 ;  0xe185ffe5b09 <a TypeObject with map 0x33abe2a6d349>  (input #2)
    0x7fff5fbfdd18: [top + 32] <- 0xe185ffe6559 ;  0xe185ffe6559 <JS Function (SharedFunctionInfo 0x130b7e10b589)>  (input #3)
    0x7fff5fbfdd10: [top + 24] <- 0x2c21d26691f8 ;  caller's pc
    0x7fff5fbfdd08: [top + 16] <- 0x7fff5fbfdd48 ;  caller's fp
    0x7fff5fbfdd00: [top + 8] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #4)
    0x7fff5fbfdcf8: [top + 0] <- 0x1030c9d3cdd1 ;  function    0x1030c9d3cdd1 <JS Function instantiateTypeNoAlias (SharedFunctionInfo 0x2e2f693f6781)>  (input #0)
[deoptimizing (eager): end 0x1030c9d3cdd1 <JS Function instantiateTypeNoAlias (SharedFunctionInfo 0x2e2f693f6781)> @76 => node=62, pc=0x2c21d261afbc, caller sp=0x7fff5fbfdd30, state=NO_REGISTERS, took 0.053 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d559f9 <JS Function instantiateAnonymousType (SharedFunctionInfo 0x2e2f693f6241)> (opt #522) @2, FP to SP delta: 96, caller sp: 0x7fff5fbfdc90]
            ;;; deoptimize at 0_107: wrong map
  reading input frame instantiateAnonymousType => node=4, args=3, height=2; inputs:
      0: 0x1030c9d559f9 ; [fp - 16] 0x1030c9d559f9 <JS Function instantiateAnonymousType (SharedFunctionInfo 0x2e2f693f6241)>
      1: 0x1f9f6c0532e1 ; [fp + 32] 0x1f9f6c0532e1 <JS Global Object>
      2: 0xe185ffe5b09 ; rdi 0xe185ffe5b09 <a TypeObject with map 0x33abe2a6d349>
      3: 0xe185ffe6559 ; [fp + 16] 0xe185ffe6559 <JS Function (SharedFunctionInfo 0x130b7e10b589)>
      4: 0x130b7e1b3d29 ; rbx 0x130b7e1b3d29 <FixedArray[1022]>
      5: 0x30bcea404311 ; (literal 11) 0x30bcea404311 <undefined>
  translating frame instantiateAnonymousType => node=4, height=8
    0x7fff5fbfdc88: [top + 56] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdc80: [top + 48] <- 0xe185ffe5b09 ;  0xe185ffe5b09 <a TypeObject with map 0x33abe2a6d349>  (input #2)
    0x7fff5fbfdc78: [top + 40] <- 0xe185ffe6559 ;  0xe185ffe6559 <JS Function (SharedFunctionInfo 0x130b7e10b589)>  (input #3)
    0x7fff5fbfdc70: [top + 32] <- 0x2c21d261b92d ;  caller's pc
    0x7fff5fbfdc68: [top + 24] <- 0x7fff5fbfdcc0 ;  caller's fp
    0x7fff5fbfdc60: [top + 16] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #4)
    0x7fff5fbfdc58: [top + 8] <- 0x1030c9d559f9 ;  function    0x1030c9d559f9 <JS Function instantiateAnonymousType (SharedFunctionInfo 0x2e2f693f6241)>  (input #0)
    0x7fff5fbfdc50: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
[deoptimizing (eager): end 0x1030c9d559f9 <JS Function instantiateAnonymousType (SharedFunctionInfo 0x2e2f693f6241)> @2 => node=4, pc=0x2c21d2634a0a, caller sp=0x7fff5fbfdc90, state=NO_REGISTERS, took 0.053 ms]
[deoptimizing (DEOPT eager): begin 0x130b7e1b5e01 <JS Function resolveStructuredTypeMembers (SharedFunctionInfo 0x2e2f693efe11)> (opt #434) @150, FP to SP delta: 248, caller sp: 0x7fff5fbfdc48]
            ;;; deoptimize at 1_125: wrong map
  reading input frame resolveStructuredTypeMembers => node=70, args=2, height=2; inputs:
      0: 0x130b7e1b5e01 ; [fp - 16] 0x130b7e1b5e01 <JS Function resolveStructuredTypeMembers (SharedFunctionInfo 0x2e2f693efe11)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0xe185fff50f1 ; [fp + 16] 0xe185fff50f1 <a TypeObject with map 0x33abe2a73179>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x1030c9d44df1 ; [fp - 112] 0x1030c9d44df1 <JS Function resolveTypeReferenceMembers (SharedFunctionInfo 0x2e2f693eee51)>
  reading input frame resolveTypeReferenceMembers => node=60, args=2, height=6; inputs:
      0: 0x1030c9d44df1 ; (literal 23) 0x1030c9d44df1 <JS Function resolveTypeReferenceMembers (SharedFunctionInfo 0x2e2f693eee51)>
      1: 0x1f9f6c0532e1 ; (literal 16) 0x1f9f6c0532e1 <JS Global Object>
      2: 0xe185fff50f1 ; [fp + 16] 0xe185fff50f1 <a TypeObject with map 0x33abe2a73179>
      3: 0x130b7e1b3d29 ; (literal 17) 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x1030c9d51ea9 ; rbx 0x1030c9d51ea9 <a TypeObject with map 0x33abe2a74989>
      5: 0x30bcea404311 ; (literal 18) 0x30bcea404311 <undefined>
      6: 0x30bcea404311 ; (literal 18) 0x30bcea404311 <undefined>
      7: 0x16f3adb61821 ; [fp - 208] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      8: 0xd6230db1df9 ; rax 0xd6230db1df9 <JS Function concatenate (SharedFunctionInfo 0xc2bd2ae1c69)>
  translating frame resolveStructuredTypeMembers => node=70, height=8
    0x7fff5fbfdc40: [top + 48] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdc38: [top + 40] <- 0xe185fff50f1 ;  0xe185fff50f1 <a TypeObject with map 0x33abe2a73179>  (input #2)
    0x7fff5fbfdc30: [top + 32] <- 0x2c21d26de1f5 ;  caller's pc
    0x7fff5fbfdc28: [top + 24] <- 0x7fff5fbfdcd0 ;  caller's fp
    0x7fff5fbfdc20: [top + 16] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdc18: [top + 8] <- 0x130b7e1b5e01 ;  function    0x130b7e1b5e01 <JS Function resolveStructuredTypeMembers (SharedFunctionInfo 0x2e2f693efe11)>  (input #0)
    0x7fff5fbfdc10: [top + 0] <- 0x1030c9d44df1 ;  0x1030c9d44df1 <JS Function resolveTypeReferenceMembers (SharedFunctionInfo 0x2e2f693eee51)>  (input #4)
  translating frame resolveTypeReferenceMembers => node=60, height=40
    0x7fff5fbfdc08: [top + 80] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdc00: [top + 72] <- 0xe185fff50f1 ;  0xe185fff50f1 <a TypeObject with map 0x33abe2a73179>  (input #2)
    0x7fff5fbfdbf8: [top + 64] <- 0x2c21d260d615 ;  caller's pc
    0x7fff5fbfdbf0: [top + 56] <- 0x7fff5fbfdc28 ;  caller's fp
    0x7fff5fbfdbe8: [top + 48] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdbe0: [top + 40] <- 0x1030c9d44df1 ;  function    0x1030c9d44df1 <JS Function resolveTypeReferenceMembers (SharedFunctionInfo 0x2e2f693eee51)>  (input #0)
    0x7fff5fbfdbd8: [top + 32] <- 0x1030c9d51ea9 ;  0x1030c9d51ea9 <a TypeObject with map 0x33abe2a74989>  (input #4)
    0x7fff5fbfdbd0: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfdbc8: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfdbc0: [top + 8] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #7)
    0x7fff5fbfdbb8: [top + 0] <- 0xd6230db1df9 ;  0xd6230db1df9 <JS Function concatenate (SharedFunctionInfo 0xc2bd2ae1c69)>  (input #8)
[deoptimizing (eager): end 0x130b7e1b5e01 <JS Function resolveStructuredTypeMembers (SharedFunctionInfo 0x2e2f693efe11)> @150 => node=60, pc=0x2c21d262e135, caller sp=0x7fff5fbfdc48, state=TOS_REGISTER, took 0.125 ms]
[deoptimizing (DEOPT eager): begin 0x130b7e1b6661 <JS Function instantiateType (SharedFunctionInfo 0x2e2f693f66c1)> (opt #344) @5, FP to SP delta: 24, caller sp: 0x7fff5fbfdbd8]
            ;;; deoptimize at 0_1316: unexpected object
  reading input frame instantiateType => node=38, args=3, height=2; inputs:
      0: 0x130b7e1b6661 ; [fp - 16] 0x130b7e1b6661 <JS Function instantiateType (SharedFunctionInfo 0x2e2f693f66c1)>
      1: 0x1f9f6c0532e1 ; [fp + 32] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x24c89adb5779 ; [fp + 24] 0x24c89adb5779 <a TypeObject with map 0x33abe2a6d0e1>
      3: 0xe185fff9a69 ; [fp + 16] 0xe185fff9a69 <JS Function (SharedFunctionInfo 0x371f85cf0581)>
      4: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      5: 0x17ddd841a629 ; rax 0x17ddd841a629 <a SymbolObject with map 0x33abe2a72ca9>
  translating frame instantiateType => node=38, height=8
    0x7fff5fbfdbd0: [top + 56] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdbc8: [top + 48] <- 0x24c89adb5779 ;  0x24c89adb5779 <a TypeObject with map 0x33abe2a6d0e1>  (input #2)
    0x7fff5fbfdbc0: [top + 40] <- 0xe185fff9a69 ;  0xe185fff9a69 <JS Function (SharedFunctionInfo 0x371f85cf0581)>  (input #3)
    0x7fff5fbfdbb8: [top + 32] <- 0x2c21d261c8bd ;  caller's pc
    0x7fff5fbfdbb0: [top + 24] <- 0x7fff5fbfdc20 ;  caller's fp
    0x7fff5fbfdba8: [top + 16] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #4)
    0x7fff5fbfdba0: [top + 8] <- 0x130b7e1b6661 ;  function    0x130b7e1b6661 <JS Function instantiateType (SharedFunctionInfo 0x2e2f693f66c1)>  (input #0)
    0x7fff5fbfdb98: [top + 0] <- 0x17ddd841a629 ;  0x17ddd841a629 <a SymbolObject with map 0x33abe2a72ca9>  (input #5)
[deoptimizing (eager): end 0x130b7e1b6661 <JS Function instantiateType (SharedFunctionInfo 0x2e2f693f66c1)> @5 => node=38, pc=0x2c21d261a4b9, caller sp=0x7fff5fbfdbd8, state=TOS_REGISTER, took 0.058 ms]
[deoptimizer unlinked: instantiateType / 130b7e1b6661]
[deoptimizing (DEOPT lazy): begin 0x130b7e1b6661 <JS Function instantiateType (SharedFunctionInfo 0x2e2f693f66c1)> (opt #344) @8, FP to SP delta: 24, caller sp: 0x7fff5fbfdd28]
  reading input frame instantiateType => node=125, args=3, height=2; inputs:
      0: 0x130b7e1b6661 ; [fp - 16] 0x130b7e1b6661 <JS Function instantiateType (SharedFunctionInfo 0x2e2f693f66c1)>
      1: 0x1f9f6c0532e1 ; [fp + 32] 0x1f9f6c0532e1 <JS Global Object>
      2: 0xe185fff4ed9 ; [fp + 24] 0xe185fff4ed9 <a TypeObject with map 0x33abe2a73179>
      3: 0xe185fff9a69 ; [fp + 16] 0xe185fff9a69 <JS Function (SharedFunctionInfo 0x371f85cf0581)>
      4: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      5: 0xe185fff4ed9 ; rax 0xe185fff4ed9 <a TypeObject with map 0x33abe2a73179>
  translating frame instantiateType => node=125, height=8
    0x7fff5fbfdd20: [top + 56] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdd18: [top + 48] <- 0xe185fff4ed9 ;  0xe185fff4ed9 <a TypeObject with map 0x33abe2a73179>  (input #2)
    0x7fff5fbfdd10: [top + 40] <- 0xe185fff9a69 ;  0xe185fff9a69 <JS Function (SharedFunctionInfo 0x371f85cf0581)>  (input #3)
    0x7fff5fbfdd08: [top + 32] <- 0x2c21d260f6e1 ;  caller's pc
    0x7fff5fbfdd00: [top + 24] <- 0x7fff5fbfddb0 ;  caller's fp
    0x7fff5fbfdcf8: [top + 16] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #4)
    0x7fff5fbfdcf0: [top + 8] <- 0x130b7e1b6661 ;  function    0x130b7e1b6661 <JS Function instantiateType (SharedFunctionInfo 0x2e2f693f66c1)>  (input #0)
    0x7fff5fbfdce8: [top + 0] <- 0xe185fff4ed9 ;  0xe185fff4ed9 <a TypeObject with map 0x33abe2a73179>  (input #5)
[deoptimizing (lazy): end 0x130b7e1b6661 <JS Function instantiateType (SharedFunctionInfo 0x2e2f693f66c1)> @8 => node=125, pc=0x2c21d261a662, caller sp=0x7fff5fbfdd28, state=TOS_REGISTER, took 0.064 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveBaseTypesOfInterface) id{533,0} ---
(type) {
            type.resolvedBaseTypes = type.resolvedBaseTypes || emptyArray;
            for (var _i = 0, _a = type.symbol.declarations; _i < _a.length; _i++) {
                var declaration = _a[_i];
                if (declaration.kind === 227 /* InterfaceDeclaration */ && ts.getInterfaceBaseTypeNodes(declaration)) {
                    for (var _b = 0, _c = ts.getInterfaceBaseTypeNodes(declaration); _b < _c.length; _b++) {
                        var node = _c[_b];
                        var baseType = getTypeFromTypeNode(node);
                        if (baseType !== unknownType) {
                            if (getObjectFlags(getTargetType(baseType)) & 3 /* ClassOrInterface */) {
                                if (type !== baseType && !hasBaseType(baseType, type)) {
                                    if (type.resolvedBaseTypes === emptyArray) {
                                        type.resolvedBaseTypes = [baseType];
                                    }
                                    else {
                                        type.resolvedBaseTypes.push(baseType);
                                    }
                                }
                                else {
                                    error(declaration, ts.Diagnostics.Type_0_recursively_references_itself_as_a_base_type, typeToString(type, /*enclosingDeclaration*/ undefined, 1 /* WriteArrayAsGenericType */));
                                }
                            }
                            else {
                                error(node, ts.Diagnostics.An_interface_may_only_extend_a_class_or_another_interface);
                            }
                        }
                    }
                }
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTargetType) id{533,1} ---
(type) {
            return getObjectFlags(type) & 4 /* Reference */ ? type.target : type;
        }
--- END ---
INLINE (getTargetType) id{533,1} AS 1 AT <0:651>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{533,2} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{533,2} AS 2 AT <1:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{533,3} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{533,3} AS 3 AT <0:636>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveStructuredTypeMembers) id{534,0} ---
(type) {
            if (!type.members) {
                if (type.flags & 32768 /* Object */) {
                    if (type.objectFlags & 4 /* Reference */) {
                        resolveTypeReferenceMembers(type);
                    }
                    else if (type.objectFlags & 3 /* ClassOrInterface */) {
                        resolveClassOrInterfaceMembers(type);
                    }
                    else if (type.objectFlags & 16 /* Anonymous */) {
                        resolveAnonymousTypeMembers(type);
                    }
                    else if (type.objectFlags & 32 /* Mapped */) {
                        resolveMappedTypeMembers(type);
                    }
                }
                else if (type.flags & 65536 /* Union */) {
                    resolveUnionTypeMembers(type);
                }
                else if (type.flags & 131072 /* Intersection */) {
                    resolveIntersectionTypeMembers(type);
                }
            }
            return type;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveTypeReferenceMembers) id{534,1} ---
(type) {
            var source = resolveDeclaredMembers(type.target);
            var typeParameters = ts.concatenate(source.typeParameters, [source.thisType]);
            var typeArguments = type.typeArguments && type.typeArguments.length === typeParameters.length ?
                type.typeArguments : ts.concatenate(type.typeArguments, [type]);
            resolveObjectTypeMembers(type, source, typeParameters, typeArguments);
        }
--- END ---
INLINE (resolveTypeReferenceMembers) id{534,1} AS 1 AT <0:185>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveDeclaredMembers) id{534,2} ---
(type) {
            if (!type.declaredProperties) {
                var symbol = type.symbol;
                type.declaredProperties = getNamedMembers(symbol.members);
                type.declaredCallSignatures = getSignaturesOfSymbol(symbol.members["__call"]);
                type.declaredConstructSignatures = getSignaturesOfSymbol(symbol.members["__new"]);
                type.declaredStringIndexInfo = getIndexInfoOfSymbol(symbol, 0 /* String */);
                type.declaredNumberIndexInfo = getIndexInfoOfSymbol(symbol, 1 /* Number */);
            }
            return type;
        }
--- END ---
INLINE (resolveDeclaredMembers) id{534,2} AS 2 AT <1:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNamedMembers) id{534,3} ---
(members) {
            var result;
            for (var id in members) {
                if (!isReservedMemberName(id)) {
                    if (!result)
                        result = [];
                    var symbol = members[id];
                    if (symbolIsValue(symbol)) {
                        result.push(symbol);
                    }
                }
            }
            return result || emptyArray;
        }
--- END ---
INLINE (getNamedMembers) id{534,3} AS 3 AT <2:137>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isReservedMemberName) id{534,4} ---
(name) {
            return name.charCodeAt(0) === 95 /* _ */ &&
                name.charCodeAt(1) === 95 /* _ */ &&
                name.charCodeAt(2) !== 95 /* _ */ &&
                name.charCodeAt(2) !== 64 /* at */;
        }
--- END ---
INLINE (isReservedMemberName) id{534,4} AS 4 AT <3:95>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexInfoOfSymbol) id{534,5} ---
(symbol, kind) {
            var declaration = getIndexDeclarationOfSymbol(symbol, kind);
            if (declaration) {
                return createIndexInfo(declaration.type ? getTypeFromTypeNode(declaration.type) : anyType, (ts.getModifierFlags(declaration) & 64 /* Readonly */) !== 0, declaration);
            }
            return undefined;
        }
--- END ---
INLINE (getIndexInfoOfSymbol) id{534,5} AS 5 AT <2:411>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createIndexInfo) id{534,6} ---
(type, isReadonly, declaration) {
            return { type: type, isReadonly: isReadonly, declaration: declaration };
        }
--- END ---
INLINE (createIndexInfo) id{534,6} AS 6 AT <5:144>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexInfoOfSymbol) id{534,7} ---
(symbol, kind) {
            var declaration = getIndexDeclarationOfSymbol(symbol, kind);
            if (declaration) {
                return createIndexInfo(declaration.type ? getTypeFromTypeNode(declaration.type) : anyType, (ts.getModifierFlags(declaration) & 64 /* Readonly */) !== 0, declaration);
            }
            return undefined;
        }
--- END ---
INLINE (getIndexInfoOfSymbol) id{534,7} AS 7 AT <2:504>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createIndexInfo) id{534,8} ---
(type, isReadonly, declaration) {
            return { type: type, isReadonly: isReadonly, declaration: declaration };
        }
--- END ---
INLINE (createIndexInfo) id{534,8} AS 8 AT <7:144>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveClassOrInterfaceMembers) id{534,9} ---
(type) {
            resolveObjectTypeMembers(type, resolveDeclaredMembers(type), emptyArray, emptyArray);
        }
--- END ---
INLINE (resolveClassOrInterfaceMembers) id{534,9} AS 9 AT <0:342>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveDeclaredMembers) id{534,10} ---
(type) {
            if (!type.declaredProperties) {
                var symbol = type.symbol;
                type.declaredProperties = getNamedMembers(symbol.members);
                type.declaredCallSignatures = getSignaturesOfSymbol(symbol.members["__call"]);
                type.declaredConstructSignatures = getSignaturesOfSymbol(symbol.members["__new"]);
                type.declaredStringIndexInfo = getIndexInfoOfSymbol(symbol, 0 /* String */);
                type.declaredNumberIndexInfo = getIndexInfoOfSymbol(symbol, 1 /* Number */);
            }
            return type;
        }
--- END ---
INLINE (resolveDeclaredMembers) id{534,10} AS 10 AT <9:52>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNamedMembers) id{534,11} ---
(members) {
            var result;
            for (var id in members) {
                if (!isReservedMemberName(id)) {
                    if (!result)
                        result = [];
                    var symbol = members[id];
                    if (symbolIsValue(symbol)) {
                        result.push(symbol);
                    }
                }
            }
            return result || emptyArray;
        }
--- END ---
INLINE (getNamedMembers) id{534,11} AS 11 AT <10:137>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isReservedMemberName) id{534,12} ---
(name) {
            return name.charCodeAt(0) === 95 /* _ */ &&
                name.charCodeAt(1) === 95 /* _ */ &&
                name.charCodeAt(2) !== 95 /* _ */ &&
                name.charCodeAt(2) !== 64 /* at */;
        }
--- END ---
INLINE (isReservedMemberName) id{534,12} AS 12 AT <11:95>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createTypeMapper) id{535,0} ---
(sources, targets) {
            var count = sources.length;
            var mapper = count == 1 ? createUnaryTypeMapper(sources[0], targets ? targets[0] : anyType) :
                count == 2 ? createBinaryTypeMapper(sources[0], targets ? targets[0] : anyType, sources[1], targets ? targets[1] : anyType) :
                    createArrayTypeMapper(sources, targets);
            mapper.mappedTypes = sources;
            return mapper;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeOfSymbol) id{536,0} ---
(symbol) {
            if (symbol.flags & 16777216 /* Instantiated */) {
                return getTypeOfInstantiatedSymbol(symbol);
            }
            if (symbol.flags & (3 /* Variable */ | 4 /* Property */)) {
                return getTypeOfVariableOrParameterOrProperty(symbol);
            }
            if (symbol.flags & (16 /* Function */ | 8192 /* Method */ | 32 /* Class */ | 384 /* Enum */ | 512 /* ValueModule */)) {
                return getTypeOfFuncClassEnumModule(symbol);
            }
            if (symbol.flags & 8 /* EnumMember */) {
                return getTypeOfEnumMember(symbol);
            }
            if (symbol.flags & 98304 /* Accessor */) {
                return getTypeOfAccessors(symbol);
            }
            if (symbol.flags & 8388608 /* Alias */) {
                return getTypeOfAlias(symbol);
            }
            return unknownType;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeOfInstantiatedSymbol) id{536,1} ---
(symbol) {
            var links = getSymbolLinks(symbol);
            if (!links.type) {
                if (!pushTypeResolution(symbol, 0 /* Type */)) {
                    return unknownType;
                }
                var type = instantiateType(getTypeOfSymbol(links.target), links.mapper);
                if (!popTypeResolution()) {
                    type = reportCircularityError(symbol);
                }
                links.type = type;
            }
            return links.type;
        }
--- END ---
INLINE (getTypeOfInstantiatedSymbol) id{536,1} AS 1 AT <0:96>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{536,2} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{536,2} AS 2 AT <1:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{536,3} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{536,3} AS 3 AT <2:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:popTypeResolution) id{536,4} ---
() {
            resolutionTargets.pop();
            resolutionPropertyNames.pop();
            return resolutionResults.pop();
        }
--- END ---
INLINE (popTypeResolution) id{536,4} AS 4 AT <1:323>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeOfFuncClassEnumModule) id{536,5} ---
(symbol) {
            var links = getSymbolLinks(symbol);
            if (!links.type) {
                if (symbol.flags & 1536 /* Module */ && ts.isShorthandAmbientModuleSymbol(symbol)) {
                    links.type = anyType;
                }
                else {
                    var type = createObjectType(16 /* Anonymous */, symbol);
                    links.type = strictNullChecks && symbol.flags & 536870912 /* Optional */ ?
                        includeFalsyTypes(type, 2048 /* Undefined */) : type;
                }
            }
            return links.type;
        }
--- END ---
INLINE (getTypeOfFuncClassEnumModule) id{536,5} AS 5 AT <0:459>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{536,6} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{536,6} AS 6 AT <5:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{536,7} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{536,7} AS 7 AT <6:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createObjectType) id{536,8} ---
(objectFlags, symbol) {
            var type = createType(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol = symbol;
            return type;
        }
--- END ---
INLINE (createObjectType) id{536,8} AS 8 AT <5:305>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{536,9} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{536,9} AS 9 AT <8:47>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{536,10} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{536,10} AS 10 AT <9:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isSimpleTypeRelatedTo) id{537,0} ---
(source, target, relation, errorReporter) {
            if (target.flags & 8192 /* Never */)
                return false;
            if (target.flags & 1 /* Any */ || source.flags & 8192 /* Never */)
                return true;
            if (source.flags & 262178 /* StringLike */ && target.flags & 2 /* String */)
                return true;
            if (source.flags & 340 /* NumberLike */ && target.flags & 4 /* Number */)
                return true;
            if (source.flags & 136 /* BooleanLike */ && target.flags & 8 /* Boolean */)
                return true;
            if (source.flags & 256 /* EnumLiteral */ && target.flags & 16 /* Enum */ && source.baseType === target)
                return true;
            if (source.flags & 16 /* Enum */ && target.flags & 16 /* Enum */ && isEnumTypeRelatedTo(source, target, errorReporter))
                return true;
            if (source.flags & 2048 /* Undefined */ && (!strictNullChecks || target.flags & (2048 /* Undefined */ | 1024 /* Void */)))
                return true;
            if (source.flags & 4096 /* Null */ && (!strictNullChecks || target.flags & 4096 /* Null */))
                return true;
            if (relation === assignableRelation || relation === comparableRelation) {
                if (source.flags & 1 /* Any */)
                    return true;
                if ((source.flags & 4 /* Number */ | source.flags & 64 /* NumberLiteral */) && target.flags & 272 /* EnumLike */)
                    return true;
                if (source.flags & 256 /* EnumLiteral */ &&
                    target.flags & 256 /* EnumLiteral */ &&
                    source.text === target.text &&
                    isEnumTypeRelatedTo(source.baseType, target.baseType, errorReporter)) {
                    return true;
                }
                if (source.flags & 256 /* EnumLiteral */ &&
                    target.flags & 16 /* Enum */ &&
                    isEnumTypeRelatedTo(target, source.baseType, errorReporter)) {
                    return true;
                }
            }
            return false;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateType) id{538,0} ---
(type, mapper) {
            if (type && mapper !== identityMapper) {
                // If we are instantiating a type that has a top-level type alias, obtain the instantiation through
                // the type alias instead in order to share instantiations for the same type arguments. This can
                // dramatically reduce the number of structurally identical types we generate. Note that we can only
                // perform this optimization for top-level type aliases. Consider:
                //
                //   function f1<T>(x: T) {
                //     type Foo<X> = { x: X, t: T };
                //     let obj: Foo<T> = { x: x };
                //     return obj;
                //   }
                //   function f2<U>(x: U) { return f1(x); }
                //   let z = f2(42);
                //
                // Above, the declaration of f2 has an inferred return type that is an instantiation of f1's Foo<X>
                // equivalent to { x: U, t: U }. When instantiating this return type, we can't go back to Foo<X>'s
                // cache because all cached instantiations are of the form { x: ???, t: T }, i.e. they have not been
                // instantiated for T. Instead, we need to further instantiate the { x: U, t: U } form.
                if (type.aliasSymbol && isTopLevelTypeAlias(type.aliasSymbol)) {
                    if (type.aliasTypeArguments) {
                        return getTypeAliasInstantiation(type.aliasSymbol, instantiateTypes(type.aliasTypeArguments, mapper));
                    }
                    return type;
                }
                return instantiateTypeNoAlias(type, mapper);
            }
            return type;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isTopLevelTypeAlias) id{538,1} ---
(symbol) {
            if (symbol.declarations && symbol.declarations.length) {
                var parentKind = symbol.declarations[0].parent.kind;
                return parentKind === 261 /* SourceFile */ || parentKind === 231 /* ModuleBlock */;
            }
            return false;
        }
--- END ---
INLINE (isTopLevelTypeAlias) id{538,1} AS 1 AT <0:1332>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isRelatedTo) id{539,0} ---
(source, target, reportErrors, headMessage) {
                var result;
                if (source.flags & 96 /* StringOrNumberLiteral */ && source.flags & 1048576 /* FreshLiteral */) {
                    source = source.regularType;
                }
                if (target.flags & 96 /* StringOrNumberLiteral */ && target.flags & 1048576 /* FreshLiteral */) {
                    target = target.regularType;
                }
                // both types are the same - covers 'they are the same primitive type or both are Any' or the same type parameter cases
                if (source === target)
                    return -1 /* True */;
                if (relation === identityRelation) {
                    return isIdenticalTo(source, target);
                }
                if (isSimpleTypeRelatedTo(source, target, relation, reportErrors ? reportError : undefined))
                    return -1 /* True */;
                if (getObjectFlags(source) & 128 /* ObjectLiteral */ && source.flags & 1048576 /* FreshLiteral */) {
                    if (hasExcessProperties(source, target, reportErrors)) {
                        if (reportErrors) {
                            reportRelationError(headMessage, source, target);
                        }
                        return 0 /* False */;
                    }
                    // Above we check for excess properties with respect to the entire target type. When union
                    // and intersection types are further deconstructed on the target side, we don't want to
                    // make the check again (as it might fail for a partial target type). Therefore we obtain
                    // the regular source type and proceed with that.
                    if (isUnionOrIntersectionTypeWithoutNullableConstituents(target)) {
                        source = getRegularTypeOfObjectLiteral(source);
                    }
                }
                var saveErrorInfo = errorInfo;
                // Note that these checks are specifically ordered to produce correct results. In particular,
                // we need to deconstruct unions before intersections (because unions are always at the top),
                // and we need to handle "each" relations before "some" relations for the same kind of type.
                if (source.flags & 65536 /* Union */) {
                    if (relation === comparableRelation) {
                        result = someTypeRelatedToType(source, target, reportErrors && !(source.flags & 8190 /* Primitive */));
                    }
                    else {
                        result = eachTypeRelatedToType(source, target, reportErrors && !(source.flags & 8190 /* Primitive */));
                    }
                    if (result) {
                        return result;
                    }
                }
                else if (target.flags & 65536 /* Union */) {
                    if (result = typeRelatedToSomeType(source, target, reportErrors && !(source.flags & 8190 /* Primitive */) && !(target.flags & 8190 /* Primitive */))) {
                        return result;
                    }
                }
                else if (target.flags & 131072 /* Intersection */) {
                    if (result = typeRelatedToEachType(source, target, reportErrors)) {
                        return result;
                    }
                }
                else if (source.flags & 131072 /* Intersection */) {
                    // Check to see if any constituents of the intersection are immediately related to the target.
                    //
                    // Don't report errors though. Checking whether a constituent is related to the source is not actually
                    // useful and leads to some confusing error messages. Instead it is better to let the below checks
                    // take care of this, or to not elaborate at all. For instance,
                    //
                    //    - For an object type (such as 'C = A & B'), users are usually more interested in structural errors.
                    //
                    //    - For a union type (such as '(A | B) = (C & D)'), it's better to hold onto the whole intersection
                    //          than to report that 'D' is not assignable to 'A' or 'B'.
                    //
                    //    - For a primitive type or type parameter (such as 'number = A & B') there is no point in
                    //          breaking the intersection apart.
                    if (result = someTypeRelatedToType(source, target, /*reportErrors*/ false)) {
                        return result;
                    }
                }
                else if (target.flags & 16384 /* TypeParameter */) {
                    // A source type { [P in keyof T]: X } is related to a target type T if X is related to T[P].
                    if (getObjectFlags(source) & 32 /* Mapped */ && getConstraintTypeFromMappedType(source) === getIndexType(target)) {
                        if (!source.declaration.questionToken) {
                            var templateType = getTemplateTypeFromMappedType(source);
                            var indexedAccessType = getIndexedAccessType(target, getTypeParameterFromMappedType(source));
                            if (result = isRelatedTo(templateType, indexedAccessType, reportErrors)) {
                                return result;
                            }
                        }
                    }
                    else {
                        // Given a type parameter K with a constraint keyof T, a type S is
                        // assignable to K if S is assignable to keyof T.
                        var constraint = getConstraintOfTypeParameter(target);
                        if (constraint && constraint.flags & 262144 /* Index */) {
                            if (result = isRelatedTo(source, constraint, reportErrors)) {
                                return result;
                            }
                        }
                    }
                }
                else if (target.flags & 262144 /* Index */) {
                    // A keyof S is related to a keyof T if T is related to S.
                    if (source.flags & 262144 /* Index */) {
                        if (result = isRelatedTo(target.type, source.type, /*reportErrors*/ false)) {
                            return result;
                        }
                    }
                    // Given a type variable T with a constraint C, a type S is assignable to
                    // keyof T if S is assignable to keyof C.
                    if (target.type.flags & 540672 /* TypeVariable */) {
                        var constraint = getConstraintOfTypeVariable(target.type);
                        if (constraint) {
                            if (result = isRelatedTo(source, getIndexType(constraint), reportErrors)) {
                                return result;
                            }
                        }
                    }
                }
                else if (target.flags & 524288 /* IndexedAccess */) {
                    // if we have indexed access types with identical index types, see if relationship holds for
                    // the two object types.
                    if (source.flags & 524288 /* IndexedAccess */ && source.indexType === target.indexType) {
                        if (result = isRelatedTo(source.objectType, target.objectType, reportErrors)) {
                            return result;
                        }
                    }
                    // A type S is related to a type T[K] if S is related to A[K], where K is string-like and
                    // A is the apparent type of S.
                    if (target.constraint) {
                        if (result = isRelatedTo(source, target.constraint, reportErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                }
                if (source.flags & 16384 /* TypeParameter */) {
                    // A source type T is related to a target type { [P in keyof T]: X } if T[P] is related to X.
                    if (getObjectFlags(target) & 32 /* Mapped */ && getConstraintTypeFromMappedType(target) === getIndexType(source)) {
                        var indexedAccessType = getIndexedAccessType(source, getTypeParameterFromMappedType(target));
                        var templateType = getTemplateTypeFromMappedType(target);
                        if (result = isRelatedTo(indexedAccessType, templateType, reportErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                    else {
                        var constraint = getConstraintOfTypeParameter(source);
                        if (!constraint || constraint.flags & 1 /* Any */) {
                            constraint = emptyObjectType;
                        }
                        // The constraint may need to be further instantiated with its 'this' type.
                        constraint = getTypeWithThisArgument(constraint, source);
                        // Report constraint errors only if the constraint is not the empty object type
                        var reportConstraintErrors = reportErrors && constraint !== emptyObjectType;
                        if (result = isRelatedTo(constraint, target, reportConstraintErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                }
                else if (source.flags & 524288 /* IndexedAccess */) {
                    // A type S[K] is related to a type T if A[K] is related to T, where K is string-like and
                    // A is the apparent type of S.
                    if (source.constraint) {
                        if (result = isRelatedTo(source.constraint, target, reportErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                }
                else {
                    if (getObjectFlags(source) & 4 /* Reference */ && getObjectFlags(target) & 4 /* Reference */ && source.target === target.target) {
                        // We have type references to same target type, see if relationship holds for all type arguments
                        if (result = typeArgumentsRelatedTo(source, target, reportErrors)) {
                            return result;
                        }
                    }
                    // Even if relationship doesn't hold for unions, intersections, or generic type references,
                    // it may hold in a structural comparison.
                    var apparentSource = getApparentType(source);
                    // In a check of the form X = A & B, we will have previously checked if A relates to X or B relates
                    // to X. Failing both of those we want to check if the aggregation of A and B's members structurally
                    // relates to X. Thus, we include intersection types on the source side here.
                    if (apparentSource.flags & (32768 /* Object */ | 131072 /* Intersection */) && target.flags & 32768 /* Object */) {
                        // Report structural errors only if we haven't reported any errors yet
                        var reportStructuralErrors = reportErrors && errorInfo === saveErrorInfo && !(source.flags & 8190 /* Primitive */);
                        if (result = objectTypeRelatedTo(apparentSource, source, target, reportStructuralErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                }
                if (reportErrors) {
                    if (source.flags & 32768 /* Object */ && target.flags & 8190 /* Primitive */) {
                        tryElaborateErrorsForPrimitivesAndObjects(source, target);
                    }
                    else if (source.symbol && source.flags & 32768 /* Object */ && globalObjectType === source) {
                        reportError(ts.Diagnostics.The_Object_type_is_assignable_to_very_few_other_types_Did_you_mean_to_use_the_any_type_instead);
                    }
                    reportRelationError(headMessage, source, target);
                }
                return 0 /* False */;
            }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{539,1} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{539,1} AS 1 AT <0:953>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{539,2} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{539,2} AS 2 AT <0:4927>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getConstraintOfTypeVariable) id{539,3} ---
(type) {
            return type.flags & 16384 /* TypeParameter */ ? getConstraintOfTypeParameter(type) :
                type.flags & 524288 /* IndexedAccess */ ? type.constraint :
                    undefined;
        }
--- END ---
INLINE (getConstraintOfTypeVariable) id{539,3} AS 3 AT <0:6792>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{539,4} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{539,4} AS 4 AT <0:8322>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeWithThisArgument) id{539,5} ---
(type, thisArgument) {
            if (getObjectFlags(type) & 4 /* Reference */) {
                return createTypeReference(type.target, ts.concatenate(type.typeArguments, [thisArgument || type.target.thisType]));
            }
            return type;
        }
--- END ---
INLINE (getTypeWithThisArgument) id{539,5} AS 5 AT <0:9283>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{539,6} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{539,6} AS 6 AT <5:39>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createTypeReference) id{539,7} ---
(target, typeArguments) {
            var id = getTypeListId(typeArguments);
            var type = target.instantiations[id];
            if (!type) {
                type = target.instantiations[id] = createObjectType(4 /* Reference */, target.symbol);
                type.flags |= typeArguments ? getPropagatingFlagsOfTypes(typeArguments, /*excludeKinds*/ 0) : 0;
                type.target = target;
                type.typeArguments = typeArguments;
            }
            return type;
        }
--- END ---
INLINE (createTypeReference) id{539,7} AS 7 AT <5:106>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createObjectType) id{539,8} ---
(objectFlags, symbol) {
            var type = createType(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol = symbol;
            return type;
        }
--- END ---
INLINE (createObjectType) id{539,8} AS 8 AT <7:203>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{539,9} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{539,9} AS 9 AT <8:47>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{539,10} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{539,10} AS 10 AT <9:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropagatingFlagsOfTypes) id{539,11} ---
(types, excludeKinds) {
            var result = 0;
            for (var _i = 0, types_3 = types; _i < types_3.length; _i++) {
                var type = types_3[_i];
                if (!(type.flags & excludeKinds)) {
                    result |= type.flags;
                }
            }
            return result & 14680064 /* PropagatingFlags */;
        }
--- END ---
INLINE (getPropagatingFlagsOfTypes) id{539,11} AS 11 AT <7:301>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{539,12} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{539,12} AS 12 AT <0:10374>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{539,13} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{539,13} AS 13 AT <0:10420>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getApparentType) id{539,14} ---
(type) {
            var t = type.flags & 540672 /* TypeVariable */ ? getApparentTypeOfTypeVariable(type) : type;
            return t.flags & 262178 /* StringLike */ ? globalStringType :
                t.flags & 340 /* NumberLike */ ? globalNumberType :
                    t.flags & 136 /* BooleanLike */ ? globalBooleanType :
                        t.flags & 512 /* ESSymbol */ ? getGlobalESSymbolType() :
                            t;
        }
--- END ---
INLINE (getApparentType) id{539,14} AS 14 AT <0:11022>
[marking dependent code 0x2c21d2722461 (opt #517) for deoptimization, reason: allocation-site-tenuring-changed]
[deoptimize marked code in all contexts]
[deoptimizer unlinked: getTypeParametersFromDeclaration / 1030c9d46171]
[deoptimizing (DEOPT eager): begin 0x1030c9d44621 <JS Function getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode (SharedFunctionInfo 0x2e2f693f4bc1)> (opt #499) @42, FP to SP delta: 168, caller sp: 0x7fff5fbfdc48]
            ;;; deoptimize at 0_495: Unknown map in polymorphic access
  reading input frame getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode => node=79, args=2, height=4; inputs:
      0: 0x1030c9d44621 ; [fp - 16] 0x1030c9d44621 <JS Function getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode (SharedFunctionInfo 0x2e2f693f4bc1)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x9a0222ce1c1 ; r8 0x9a0222ce1c1 <a NodeObject with map 0x33abe2a768d1>
      3: 0x130b7e1b3d29 ; rcx 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x32c5a0d7f7f1 ; [fp - 56] 0x32c5a0d7f7f1 <an Object with map 0x33abe2a51889>
      5: 0x30bcea404311 ; rbx 0x30bcea404311 <undefined>
      6: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
  translating frame getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode => node=79, height=24
    0x7fff5fbfdc40: [top + 64] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdc38: [top + 56] <- 0x9a0222ce1c1 ;  0x9a0222ce1c1 <a NodeObject with map 0x33abe2a768d1>  (input #2)
    0x7fff5fbfdc30: [top + 48] <- 0x2c21d26a5356 ;  caller's pc
    0x7fff5fbfdc28: [top + 40] <- 0x7fff5fbfdd08 ;  caller's fp
    0x7fff5fbfdc20: [top + 32] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdc18: [top + 24] <- 0x1030c9d44621 ;  function    0x1030c9d44621 <JS Function getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode (SharedFunctionInfo 0x2e2f693f4bc1)>  (input #0)
    0x7fff5fbfdc10: [top + 16] <- 0x32c5a0d7f7f1 ;  0x32c5a0d7f7f1 <an Object with map 0x33abe2a51889>  (input #4)
    0x7fff5fbfdc08: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfdc00: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
[deoptimizing (eager): end 0x1030c9d44621 <JS Function getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode (SharedFunctionInfo 0x2e2f693f4bc1)> @42 => node=79, pc=0x2c21d261f9ed, caller sp=0x7fff5fbfdc48, state=NO_REGISTERS, took 0.078 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d3efd9 <JS Function shouldReportBadModifier (SharedFunctionInfo 0x1b98fbc135c1)> (opt #422) @3, FP to SP delta: 24, caller sp: 0x7fff5fbfdd58]
            ;;; deoptimize at 0_902: wrong map
  reading input frame shouldReportBadModifier => node=30, args=2, height=4; inputs:
      0: 0x1030c9d3efd9 ; [fp - 16] 0x1030c9d3efd9 <JS Function shouldReportBadModifier (SharedFunctionInfo 0x1b98fbc135c1)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1b98fbcd0759 ; rbx 0x1b98fbcd0759 <a NodeObject with map 0x33abe2a714f1>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea4069a9 ; (literal 2) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      5: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
      6: 0xe100000000 ; rax 225
  translating frame shouldReportBadModifier => node=30, height=24
    0x7fff5fbfdd50: [top + 64] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdd48: [top + 56] <- 0x1b98fbcd0759 ;  0x1b98fbcd0759 <a NodeObject with map 0x33abe2a714f1>  (input #2)
    0x7fff5fbfdd40: [top + 48] <- 0x2c21d261f075 ;  caller's pc
    0x7fff5fbfdd38: [top + 40] <- 0x7fff5fbfdd70 ;  caller's fp
    0x7fff5fbfdd30: [top + 32] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdd28: [top + 24] <- 0x1030c9d3efd9 ;  function    0x1030c9d3efd9 <JS Function shouldReportBadModifier (SharedFunctionInfo 0x1b98fbc135c1)>  (input #0)
    0x7fff5fbfdd20: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #4)
    0x7fff5fbfdd18: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfdd10: [top + 0] <- 0xe100000000 ;  225  (input #6)
[deoptimizing (eager): end 0x1030c9d3efd9 <JS Function shouldReportBadModifier (SharedFunctionInfo 0x1b98fbc135c1)> @3 => node=30, pc=0x2c21d25f0d25, caller sp=0x7fff5fbfdd58, state=NO_REGISTERS, took 0.073 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d40719 <JS Function checkFunctionOrConstructorSymbol (SharedFunctionInfo 0x1b98fbc0b701)> (opt #512) @17, FP to SP delta: 288, caller sp: 0x7fff5fbfdec8]
            ;;; deoptimize at 0_7758: wrong map
  reading input frame checkFunctionOrConstructorSymbol => node=417, args=2, height=29; inputs:
      0: 0x1030c9d40719 ; [fp - 16] 0x1030c9d40719 <JS Function checkFunctionOrConstructorSymbol (SharedFunctionInfo 0x1b98fbc0b701)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x17ddd8427589 ; [fp + 16] 0x17ddd8427589 <a SymbolObject with map 0x33abe2a6fb29>
      3: 0x32c5a0d97939 ; [fp - 24] 0x32c5a0d97939 <FixedArray[6]>
      4: 0x32c5a0d979c1 ; [fp - 32] 0x32c5a0d979c1 <JS Function checkFlagAgreementBetweenOverloads (SharedFunctionInfo 0x371f85cdda69)>
      5: 0x32c5a0d97a09 ; [fp - 40] 0x32c5a0d97a09 <JS Function checkQuestionTokenAgreementBetweenOverloads (SharedFunctionInfo 0x371f85cddb29)>
      6: 0x9b00000000 ; (literal 2) 155
      7: 0 ; (int) [fp - 64] 
      8: 155 ; (int) [fp - 56] 
      9: 0x30bcea404421 ; [fp - 88] 0x30bcea404421 <false>
     10: 0x30bcea4043b1 ; [fp - 80] 0x30bcea4043b1 <true>
     11: 0x30bcea404421 ; [fp - 144] 0x30bcea404421 <false>
     12: 0x30bcea404311 ; [fp - 136] 0x30bcea404311 <undefined>
     13: 0x30bcea404311 ; [fp - 128] 0x30bcea404311 <undefined>
     14: 0x30bcea404311 ; [fp - 120] 0x30bcea404311 <undefined>
     15: 0x2b226860e689 ; [fp - 96] 0x2b226860e689 <JS Array[1]>
     16: 0x32c5a0d97a51 ; [fp - 48] 0x32c5a0d97a51 <JS Function reportImplementationExpectedError (SharedFunctionInfo 0x371f85cddbe9)>
     17: 0x30bcea404421 ; [fp - 112] 0x30bcea404421 <false>
     18: 0x30bcea404421 ; [fp - 72] 0x30bcea404421 <false>
     19: 0 ; (int) [fp - 104] 
     20: 0x2b226860e689 ; [fp - 96] 0x2b226860e689 <JS Array[1]>
     21: 0x30bcea4069a9 ; (literal 3) 0x30bcea4069a9 <Odd Oddball: optimized_out>
     22: 0x1b98fbcd0759 ; rbx 0x1b98fbcd0759 <a NodeObject with map 0x33abe2a714f1>
     23: 0x30bcea4043b1 ; [fp - 168] 0x30bcea4043b1 <true>
     24: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
     25: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
     26: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
     27: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
     28: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
     29: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
     30: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
     31: 0x30bcea404421 ; rax 0x30bcea404421 <false>
  translating frame checkFunctionOrConstructorSymbol => node=417, height=224
    0x7fff5fbfdec0: [top + 264] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdeb8: [top + 256] <- 0x17ddd8427589 ;  0x17ddd8427589 <a SymbolObject with map 0x33abe2a6fb29>  (input #2)
    0x7fff5fbfdeb0: [top + 248] <- 0x2c21d271173c ;  caller's pc
    0x7fff5fbfdea8: [top + 240] <- 0x7fff5fbfdf60 ;  caller's fp
    0x7fff5fbfdea0: [top + 232] <- 0x32c5a0d97939 ;  context    0x32c5a0d97939 <FixedArray[6]>  (input #3)
    0x7fff5fbfde98: [top + 224] <- 0x1030c9d40719 ;  function    0x1030c9d40719 <JS Function checkFunctionOrConstructorSymbol (SharedFunctionInfo 0x1b98fbc0b701)>  (input #0)
    0x7fff5fbfde90: [top + 216] <- 0x32c5a0d979c1 ;  0x32c5a0d979c1 <JS Function checkFlagAgreementBetweenOverloads (SharedFunctionInfo 0x371f85cdda69)>  (input #4)
    0x7fff5fbfde88: [top + 208] <- 0x32c5a0d97a09 ;  0x32c5a0d97a09 <JS Function checkQuestionTokenAgreementBetweenOverloads (SharedFunctionInfo 0x371f85cddb29)>  (input #5)
    0x7fff5fbfde80: [top + 200] <- 0x9b00000000 ;  155  (input #6)
    0x7fff5fbfde78: [top + 192] <- 0x00000000 ;  0  (input #7)
    0x7fff5fbfde70: [top + 184] <- 0x9b00000000 ;  155  (input #8)
    0x7fff5fbfde68: [top + 176] <- 0x30bcea404421 ;  0x30bcea404421 <false>  (input #9)
    0x7fff5fbfde60: [top + 168] <- 0x30bcea4043b1 ;  0x30bcea4043b1 <true>  (input #10)
    0x7fff5fbfde58: [top + 160] <- 0x30bcea404421 ;  0x30bcea404421 <false>  (input #11)
    0x7fff5fbfde50: [top + 152] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #12)
    0x7fff5fbfde48: [top + 144] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #13)
    0x7fff5fbfde40: [top + 136] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #14)
    0x7fff5fbfde38: [top + 128] <- 0x2b226860e689 ;  0x2b226860e689 <JS Array[1]>  (input #15)
    0x7fff5fbfde30: [top + 120] <- 0x32c5a0d97a51 ;  0x32c5a0d97a51 <JS Function reportImplementationExpectedError (SharedFunctionInfo 0x371f85cddbe9)>  (input #16)
    0x7fff5fbfde28: [top + 112] <- 0x30bcea404421 ;  0x30bcea404421 <false>  (input #17)
    0x7fff5fbfde20: [top + 104] <- 0x30bcea404421 ;  0x30bcea404421 <false>  (input #18)
    0x7fff5fbfde18: [top + 96] <- 0x00000000 ;  0  (input #19)
    0x7fff5fbfde10: [top + 88] <- 0x2b226860e689 ;  0x2b226860e689 <JS Array[1]>  (input #20)
    0x7fff5fbfde08: [top + 80] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #21)
    0x7fff5fbfde00: [top + 72] <- 0x1b98fbcd0759 ;  0x1b98fbcd0759 <a NodeObject with map 0x33abe2a714f1>  (input #22)
    0x7fff5fbfddf8: [top + 64] <- 0x30bcea4043b1 ;  0x30bcea4043b1 <true>  (input #23)
    0x7fff5fbfddf0: [top + 56] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #24)
    0x7fff5fbfdde8: [top + 48] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #25)
    0x7fff5fbfdde0: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #26)
    0x7fff5fbfddd8: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #27)
    0x7fff5fbfddd0: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #28)
    0x7fff5fbfddc8: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #29)
    0x7fff5fbfddc0: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #30)
    0x7fff5fbfddb8: [top + 0] <- 0x30bcea404421 ;  0x30bcea404421 <false>  (input #31)
[deoptimizing (eager): end 0x1030c9d40719 <JS Function checkFunctionOrConstructorSymbol (SharedFunctionInfo 0x1b98fbc0b701)> @17 => node=417, pc=0x2c21d26063d4, caller sp=0x7fff5fbfdec8, state=TOS_REGISTER, took 1.078 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d40a49 <JS Function getEffectiveDeclarationFlags (SharedFunctionInfo 0x1b98fbc0b641)> (opt #396) @6, FP to SP delta: 48, caller sp: 0x7fff5fbfddb8]
            ;;; deoptimize at 0_328: wrong map
  reading input frame getEffectiveDeclarationFlags => node=49, args=3, height=2; inputs:
      0: 0x1030c9d40a49 ; [fp - 16] 0x1030c9d40a49 <JS Function getEffectiveDeclarationFlags (SharedFunctionInfo 0x1b98fbc0b641)>
      1: 0x1f9f6c0532e1 ; [fp + 32] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1b98fbcd0759 ; rax 0x1b98fbcd0759 <a NodeObject with map 0x33abe2a714f1>
      3: 0x9b00000000 ; [fp + 16] 155
      4: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      5: 0x200000000 ; [fp - 40] 2
  translating frame getEffectiveDeclarationFlags => node=49, height=8
    0x7fff5fbfddb0: [top + 56] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdda8: [top + 48] <- 0x1b98fbcd0759 ;  0x1b98fbcd0759 <a NodeObject with map 0x33abe2a714f1>  (input #2)
    0x7fff5fbfdda0: [top + 40] <- 0x9b00000000 ;  155  (input #3)
    0x7fff5fbfdd98: [top + 32] <- 0x2c21d26066b0 ;  caller's pc
    0x7fff5fbfdd90: [top + 24] <- 0x7fff5fbfdea8 ;  caller's fp
    0x7fff5fbfdd88: [top + 16] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #4)
    0x7fff5fbfdd80: [top + 8] <- 0x1030c9d40a49 ;  function    0x1030c9d40a49 <JS Function getEffectiveDeclarationFlags (SharedFunctionInfo 0x1b98fbc0b641)>  (input #0)
    0x7fff5fbfdd78: [top + 0] <- 0x200000000 ;  2  (input #5)
[deoptimizing (eager): end 0x1030c9d40a49 <JS Function getEffectiveDeclarationFlags (SharedFunctionInfo 0x1b98fbc0b641)> @6 => node=49, pc=0x2c21d260725b, caller sp=0x7fff5fbfddb8, state=NO_REGISTERS, took 0.062 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d42259 <JS Function checkGrammarMethod (SharedFunctionInfo 0x1b98fbc14a11)> (opt #510) @40, FP to SP delta: 128, caller sp: 0x7fff5fbfda98]
            ;;; deoptimize at 0_1978: wrong map
  reading input frame checkGrammarMethod => node=359, args=2, height=1; inputs:
      0: 0x1030c9d42259 ; [fp - 16] 0x1030c9d42259 <JS Function checkGrammarMethod (SharedFunctionInfo 0x1b98fbc14a11)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x3a9c5995ea61 ; rax 0x3a9c5995ea61 <a NodeObject with map 0x33abe2a70521>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
  translating frame checkGrammarMethod => node=359, height=0
    0x7fff5fbfda90: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfda88: [top + 32] <- 0x3a9c5995ea61 ;  0x3a9c5995ea61 <a NodeObject with map 0x33abe2a70521>  (input #2)
    0x7fff5fbfda80: [top + 24] <- 0x2c21d26fca8f ;  caller's pc
    0x7fff5fbfda78: [top + 16] <- 0x7fff5fbfdab8 ;  caller's fp
    0x7fff5fbfda70: [top + 8] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfda68: [top + 0] <- 0x1030c9d42259 ;  function    0x1030c9d42259 <JS Function checkGrammarMethod (SharedFunctionInfo 0x1b98fbc14a11)>  (input #0)
[deoptimizing (eager): end 0x1030c9d42259 <JS Function checkGrammarMethod (SharedFunctionInfo 0x1b98fbc14a11)> @40 => node=359, pc=0x2c21d2611f83, caller sp=0x7fff5fbfda98, state=NO_REGISTERS, took 0.064 ms]
[deoptimizing (DEOPT eager): begin 0x130b7e1b68e9 <JS Function checkGrammarProperty (SharedFunctionInfo 0x1b98fbc15551)> (opt #410) @7, FP to SP delta: 104, caller sp: 0x7fff5fbfdad8]
            ;;; deoptimize at 0_837: wrong map
  reading input frame checkGrammarProperty => node=79, args=2, height=1; inputs:
      0: 0x130b7e1b68e9 ; [fp - 16] 0x130b7e1b68e9 <JS Function checkGrammarProperty (SharedFunctionInfo 0x1b98fbc15551)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x3a9c5995eae1 ; rax 0x3a9c5995eae1 <a NodeObject with map 0x33abe2a703c1>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
  translating frame checkGrammarProperty => node=79, height=0
    0x7fff5fbfdad0: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdac8: [top + 32] <- 0x3a9c5995eae1 ;  0x3a9c5995eae1 <a NodeObject with map 0x33abe2a703c1>  (input #2)
    0x7fff5fbfdac0: [top + 24] <- 0x2c21d26a5819 ;  caller's pc
    0x7fff5fbfdab8: [top + 16] <- 0x7fff5fbfdb98 ;  caller's fp
    0x7fff5fbfdab0: [top + 8] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdaa8: [top + 0] <- 0x130b7e1b68e9 ;  function    0x130b7e1b68e9 <JS Function checkGrammarProperty (SharedFunctionInfo 0x1b98fbc15551)>  (input #0)
[deoptimizing (eager): end 0x130b7e1b68e9 <JS Function checkGrammarProperty (SharedFunctionInfo 0x1b98fbc15551)> @7 => node=79, pc=0x2c21d2610c15, caller sp=0x7fff5fbfdad8, state=NO_REGISTERS, took 0.051 ms]
[deoptimizing (DEOPT lazy): begin 0xd6230daf4a1 <JS Function forEach (SharedFunctionInfo 0xc2bd2ae0d69)> (opt #228) @7, FP to SP delta: 40, caller sp: 0x7fff5fbfe238]
  reading input frame forEach => node=88, args=3, height=5; inputs:
      0: 0xd6230daf4a1 ; [fp - 16] 0xd6230daf4a1 <JS Function forEach (SharedFunctionInfo 0xc2bd2ae0d69)>
      1: 0x16f3adb61821 ; [fp + 32] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x2f05bb889311 ; [fp + 24] 0x2f05bb889311 <JS Array[2]>
      3: 0x130b7e1b6109 ; [fp + 16] 0x130b7e1b6109 <JS Function checkSourceFile (SharedFunctionInfo 0x1b98fbc10441)>
      4: 0xd6230db3179 ; [fp - 24] 0xd6230db3179 <FixedArray[95]>
      5: 0 ; (int) [fp - 40] 
      6: 2 ; (int) [fp - 32] 
      7: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; rax 0x30bcea404311 <undefined>
  translating frame forEach => node=88, height=32
    0x7fff5fbfe230: [top + 80] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfe228: [top + 72] <- 0x2f05bb889311 ;  0x2f05bb889311 <JS Array[2]>  (input #2)
    0x7fff5fbfe220: [top + 64] <- 0x130b7e1b6109 ;  0x130b7e1b6109 <JS Function checkSourceFile (SharedFunctionInfo 0x1b98fbc10441)>  (input #3)
    0x7fff5fbfe218: [top + 56] <- 0x2c21d25a93ff ;  caller's pc
    0x7fff5fbfe210: [top + 48] <- 0x7fff5fbfe278 ;  caller's fp
    0x7fff5fbfe208: [top + 40] <- 0xd6230db3179 ;  context    0xd6230db3179 <FixedArray[95]>  (input #4)
    0x7fff5fbfe200: [top + 32] <- 0xd6230daf4a1 ;  function    0xd6230daf4a1 <JS Function forEach (SharedFunctionInfo 0xc2bd2ae0d69)>  (input #0)
    0x7fff5fbfe1f8: [top + 24] <- 0x00000000 ;  0  (input #5)
    0x7fff5fbfe1f0: [top + 16] <- 0x200000000 ;  2  (input #6)
    0x7fff5fbfe1e8: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfe1e0: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
[deoptimizing (lazy): end 0xd6230daf4a1 <JS Function forEach (SharedFunctionInfo 0xc2bd2ae0d69)> @7 => node=88, pc=0x2c21d23de7a6, caller sp=0x7fff5fbfe238, state=TOS_REGISTER, took 0.076 ms]
[deoptimizing (DEOPT eager): begin 0xd6230dcb571 <JS Function isInAmbientContext (SharedFunctionInfo 0x3504a53d15d9)> (opt #460) @7, FP to SP delta: 40, caller sp: 0x7fff5fbfe0f0]
            ;;; deoptimize at 0_129: wrong map
  reading input frame isInAmbientContext => node=39, args=2, height=1; inputs:
      0: 0xd6230dcb571 ; [fp - 16] 0xd6230dcb571 <JS Function isInAmbientContext (SharedFunctionInfo 0x3504a53d15d9)>
      1: 0x16f3adb61821 ; [fp + 24] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x2f05bb83a721 ; rax 0x2f05bb83a721 <a SourceFileObject with map 0x15b5a7912591>
      3: 0xd6230db34c9 ; [fp - 24] 0xd6230db34c9 <FixedArray[156]>
  translating frame isInAmbientContext => node=39, height=0
    0x7fff5fbfe0e8: [top + 40] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfe0e0: [top + 32] <- 0x2f05bb83a721 ;  0x2f05bb83a721 <a SourceFileObject with map 0x15b5a7912591>  (input #2)
    0x7fff5fbfe0d8: [top + 24] <- 0x2c21d25aa33b ;  caller's pc
    0x7fff5fbfe0d0: [top + 16] <- 0x7fff5fbfe108 ;  caller's fp
    0x7fff5fbfe0c8: [top + 8] <- 0xd6230db34c9 ;  context    0xd6230db34c9 <FixedArray[156]>  (input #3)
    0x7fff5fbfe0c0: [top + 0] <- 0xd6230dcb571 ;  function    0xd6230dcb571 <JS Function isInAmbientContext (SharedFunctionInfo 0x3504a53d15d9)>  (input #0)
[deoptimizing (eager): end 0xd6230dcb571 <JS Function isInAmbientContext (SharedFunctionInfo 0x3504a53d15d9)> @7 => node=39, pc=0x2c21d2545718, caller sp=0x7fff5fbfe0f0, state=NO_REGISTERS, took 0.058 ms]
[deoptimizing (DEOPT eager): begin 0xd6230dca9c9 <JS Function isExternalOrCommonJsModule (SharedFunctionInfo 0x3504a53cde59)> (opt #339) @2, FP to SP delta: 24, caller sp: 0x7fff5fbfd730]
            ;;; deoptimize at 0_29: Unknown map in polymorphic access
  reading input frame isExternalOrCommonJsModule => node=4, args=2, height=1; inputs:
      0: 0xd6230dca9c9 ; [fp - 16] 0xd6230dca9c9 <JS Function isExternalOrCommonJsModule (SharedFunctionInfo 0x3504a53cde59)>
      1: 0x16f3adb61821 ; [fp + 24] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x2f05bb83a721 ; rax 0x2f05bb83a721 <a SourceFileObject with map 0x15b5a7912591>
      3: 0xd6230db34c9 ; [fp - 24] 0xd6230db34c9 <FixedArray[156]>
  translating frame isExternalOrCommonJsModule => node=4, height=0
    0x7fff5fbfd728: [top + 40] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfd720: [top + 32] <- 0x2f05bb83a721 ;  0x2f05bb83a721 <a SourceFileObject with map 0x15b5a7912591>  (input #2)
    0x7fff5fbfd718: [top + 24] <- 0x2c21d272effe ;  caller's pc
    0x7fff5fbfd710: [top + 16] <- 0x7fff5fbfd870 ;  caller's fp
    0x7fff5fbfd708: [top + 8] <- 0xd6230db34c9 ;  context    0xd6230db34c9 <FixedArray[156]>  (input #3)
    0x7fff5fbfd700: [top + 0] <- 0xd6230dca9c9 ;  function    0xd6230dca9c9 <JS Function isExternalOrCommonJsModule (SharedFunctionInfo 0x3504a53cde59)>  (input #0)
[deoptimizing (eager): end 0xd6230dca9c9 <JS Function isExternalOrCommonJsModule (SharedFunctionInfo 0x3504a53cde59)> @2 => node=4, pc=0x2c21d25e11c6, caller sp=0x7fff5fbfd730, state=NO_REGISTERS, took 0.067 ms]
[deoptimizing (DEOPT eager): begin 0x130b7e1b6811 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)> (opt #530) @116, FP to SP delta: 320, caller sp: 0x7fff5fbfd8b0]
            ;;; deoptimize at 6_47: wrong map
  reading input frame resolveName => node=2270, args=6, height=18; inputs:
      0: 0x130b7e1b6811 ; [fp - 16] 0x130b7e1b6811 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)>
      1: 0x1f9f6c0532e1 ; [fp + 56] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x30bcea404311 ; [fp - 40] 0x30bcea404311 <undefined>
      3: 0x2f05bb888d19 ; [fp + 40] 0x2f05bb888d19 <String[6]: NodeJS>
      4: 0x11a3bf00000000 ; [fp + 32] 1156031
      5: 0xd6230ded3a9 ; rcx 0xd6230ded3a9 <an Object with map 0x33abe2a3df61>
      6: 0x2f05bb8dbad1 ; [fp + 16] 0x2f05bb8dbad1 <an IdentifierObject with map 0x15b5a79122d1>
      7: 0x130b7e1b3d29 ; r8 0x130b7e1b3d29 <FixedArray[1022]>
      8: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
      9: 0x130b7e1b6e09 ; rax 0x130b7e1b6e09 <a SymbolObject with map 0x33abe2a710d1>
     10: 0x30bcea4069a9 ; (literal 14) 0x30bcea4069a9 <Odd Oddball: optimized_out>
     11: 0x30bcea4069a9 ; (literal 14) 0x30bcea4069a9 <Odd Oddball: optimized_out>
     12: 0x2f05bb8dbad1 ; [fp + 48] 0x2f05bb8dbad1 <an IdentifierObject with map 0x15b5a79122d1>
     13: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     14: 0x30bcea404421 ; [fp - 168] 0x30bcea404421 <false>
     15: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     16: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     17: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     18: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     19: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     20: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     21: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     22: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     23: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     24: 0x1030c9d53341 ; rbx 0x1030c9d53341 <JS Function getExportSymbolOfValueSymbolIfExported (SharedFunctionInfo 0x2e2f693e9c91)>
  reading input frame getExportSymbolOfValueSymbolIfExported => node=11, args=2, height=1; inputs:
      0: 0x1030c9d53341 ; (literal 17) 0x1030c9d53341 <JS Function getExportSymbolOfValueSymbolIfExported (SharedFunctionInfo 0x2e2f693e9c91)>
      1: 0x1f9f6c0532e1 ; (literal 11) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x130b7e1b6e09 ; rax 0x130b7e1b6e09 <a SymbolObject with map 0x33abe2a710d1>
      3: 0x130b7e1b3d29 ; (literal 12) 0x130b7e1b3d29 <FixedArray[1022]>
  translating frame resolveName => node=2270, height=136
    0x7fff5fbfd8a8: [top + 208] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd8a0: [top + 200] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #2)
    0x7fff5fbfd898: [top + 192] <- 0x2f05bb888d19 ;  0x2f05bb888d19 <String[6]: NodeJS>  (input #3)
    0x7fff5fbfd890: [top + 184] <- 0x11a3bf00000000 ;  1156031  (input #4)
    0x7fff5fbfd888: [top + 176] <- 0xd6230ded3a9 ;  0xd6230ded3a9 <an Object with map 0x33abe2a3df61>  (input #5)
    0x7fff5fbfd880: [top + 168] <- 0x2f05bb8dbad1 ;  0x2f05bb8dbad1 <an IdentifierObject with map 0x15b5a79122d1>  (input #6)
    0x7fff5fbfd878: [top + 160] <- 0x2c21d272b66f ;  caller's pc
    0x7fff5fbfd870: [top + 152] <- 0x7fff5fbfd8d8 ;  caller's fp
    0x7fff5fbfd868: [top + 144] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #7)
    0x7fff5fbfd860: [top + 136] <- 0x130b7e1b6811 ;  function    0x130b7e1b6811 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)>  (input #0)
    0x7fff5fbfd858: [top + 128] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfd850: [top + 120] <- 0x130b7e1b6e09 ;  0x130b7e1b6e09 <a SymbolObject with map 0x33abe2a710d1>  (input #9)
    0x7fff5fbfd848: [top + 112] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #10)
    0x7fff5fbfd840: [top + 104] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #11)
    0x7fff5fbfd838: [top + 96] <- 0x2f05bb8dbad1 ;  0x2f05bb8dbad1 <an IdentifierObject with map 0x15b5a79122d1>  (input #12)
    0x7fff5fbfd830: [top + 88] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #13)
    0x7fff5fbfd828: [top + 80] <- 0x30bcea404421 ;  0x30bcea404421 <false>  (input #14)
    0x7fff5fbfd820: [top + 72] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #15)
    0x7fff5fbfd818: [top + 64] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #16)
    0x7fff5fbfd810: [top + 56] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #17)
    0x7fff5fbfd808: [top + 48] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #18)
    0x7fff5fbfd800: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #19)
    0x7fff5fbfd7f8: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #20)
    0x7fff5fbfd7f0: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #21)
    0x7fff5fbfd7e8: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #22)
    0x7fff5fbfd7e0: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #23)
    0x7fff5fbfd7d8: [top + 0] <- 0x1030c9d53341 ;  0x1030c9d53341 <JS Function getExportSymbolOfValueSymbolIfExported (SharedFunctionInfo 0x2e2f693e9c91)>  (input #24)
  translating frame getExportSymbolOfValueSymbolIfExported => node=11, height=0
    0x7fff5fbfd7d0: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd7c8: [top + 32] <- 0x130b7e1b6e09 ;  0x130b7e1b6e09 <a SymbolObject with map 0x33abe2a710d1>  (input #2)
    0x7fff5fbfd7c0: [top + 24] <- 0x2c21d25e6726 ;  caller's pc
    0x7fff5fbfd7b8: [top + 16] <- 0x7fff5fbfd870 ;  caller's fp
    0x7fff5fbfd7b0: [top + 8] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd7a8: [top + 0] <- 0x1030c9d53341 ;  function    0x1030c9d53341 <JS Function getExportSymbolOfValueSymbolIfExported (SharedFunctionInfo 0x2e2f693e9c91)>  (input #0)
[deoptimizing (eager): end 0x130b7e1b6811 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)> @116 => node=11, pc=0x2c21d272b867, caller sp=0x7fff5fbfd8b0, state=NO_REGISTERS, took 1.073 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d44209 <JS Function getTypeOfSymbol (SharedFunctionInfo 0x2e2f693ed051)> (opt #536) @3, FP to SP delta: 128, caller sp: 0x7fff5fbfd8f8]
            ;;; deoptimize at 0_169: wrong map
  reading input frame getTypeOfSymbol => node=7, args=2, height=1; inputs:
      0: 0x1030c9d44209 ; [fp - 16] 0x1030c9d44209 <JS Function getTypeOfSymbol (SharedFunctionInfo 0x2e2f693ed051)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x130b7e1b6e09 ; rax 0x130b7e1b6e09 <a SymbolObject with map 0x33abe2a710d1>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
  translating frame getTypeOfSymbol => node=7, height=0
    0x7fff5fbfd8f0: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd8e8: [top + 32] <- 0x130b7e1b6e09 ;  0x130b7e1b6e09 <a SymbolObject with map 0x33abe2a710d1>  (input #2)
    0x7fff5fbfd8e0: [top + 24] <- 0x2c21d272a6dd ;  caller's pc
    0x7fff5fbfd8d8: [top + 16] <- 0x7fff5fbfd978 ;  caller's fp
    0x7fff5fbfd8d0: [top + 8] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd8c8: [top + 0] <- 0x1030c9d44209 ;  function    0x1030c9d44209 <JS Function getTypeOfSymbol (SharedFunctionInfo 0x2e2f693ed051)>  (input #0)
[deoptimizing (eager): end 0x1030c9d44209 <JS Function getTypeOfSymbol (SharedFunctionInfo 0x2e2f693ed051)> @3 => node=7, pc=0x2c21d261cd05, caller sp=0x7fff5fbfd8f8, state=NO_REGISTERS, took 0.053 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d53b69 <JS Function isTypeAny (SharedFunctionInfo 0x2e2f693ebc11)> (opt #485) @3, FP to SP delta: 24, caller sp: 0x7fff5fbfdab8]
  reading input frame isTypeAny => node=4, args=2, height=1; inputs:
      0: 0x1030c9d53b69 ; [fp - 16] 0x1030c9d53b69 <JS Function isTypeAny (SharedFunctionInfo 0x2e2f693ebc11)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x32c5a0dbde01 ; rax 0x32c5a0dbde01 <a TypeObject with map 0x33abe2a6d1e9>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
  translating frame isTypeAny => node=4, height=0
    0x7fff5fbfdab0: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdaa8: [top + 32] <- 0x32c5a0dbde01 ;  0x32c5a0dbde01 <a TypeObject with map 0x33abe2a6d1e9>  (input #2)
    0x7fff5fbfdaa0: [top + 24] <- 0x2c21d2740bd2 ;  caller's pc
    0x7fff5fbfda98: [top + 16] <- 0x7fff5fbfdb00 ;  caller's fp
    0x7fff5fbfda90: [top + 8] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfda88: [top + 0] <- 0x1030c9d53b69 ;  function    0x1030c9d53b69 <JS Function isTypeAny (SharedFunctionInfo 0x2e2f693ebc11)>  (input #0)
[deoptimizing (eager): end 0x1030c9d53b69 <JS Function isTypeAny (SharedFunctionInfo 0x2e2f693ebc11)> @3 => node=4, pc=0x2c21d26a0ba6, caller sp=0x7fff5fbfdab8, state=NO_REGISTERS, took 0.046 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d46859 <JS Function resolveAnonymousTypeMembers (SharedFunctionInfo 0x2e2f693ef811)> (opt #497) @4, FP to SP delta: 392, caller sp: 0x7fff5fbfd938]
            ;;; deoptimize at 0_884: wrong map
  reading input frame resolveAnonymousTypeMembers => node=74, args=2, height=9; inputs:
      0: 0x1030c9d46859 ; [fp - 16] 0x1030c9d46859 <JS Function resolveAnonymousTypeMembers (SharedFunctionInfo 0x2e2f693ef811)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x32c5a0dbde01 ; rax 0x32c5a0dbde01 <a TypeObject with map 0x33abe2a6d1e9>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x130b7e1b6e09 ; rcx 0x130b7e1b6e09 <a SymbolObject with map 0x33abe2a75ab9>
      5: 0x30bcea404311 ; (literal 17) 0x30bcea404311 <undefined>
      6: 0x30bcea404311 ; (literal 17) 0x30bcea404311 <undefined>
      7: 0x30bcea404311 ; (literal 17) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; (literal 17) 0x30bcea404311 <undefined>
      9: 0x30bcea404311 ; (literal 17) 0x30bcea404311 <undefined>
     10: 0x30bcea404311 ; (literal 17) 0x30bcea404311 <undefined>
     11: 0x30bcea404311 ; (literal 17) 0x30bcea404311 <undefined>
  translating frame resolveAnonymousTypeMembers => node=74, height=64
    0x7fff5fbfd930: [top + 104] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd928: [top + 96] <- 0x32c5a0dbde01 ;  0x32c5a0dbde01 <a TypeObject with map 0x33abe2a6d1e9>  (input #2)
    0x7fff5fbfd920: [top + 88] <- 0x2c21d27353bc ;  caller's pc
    0x7fff5fbfd918: [top + 80] <- 0x7fff5fbfda30 ;  caller's fp
    0x7fff5fbfd910: [top + 72] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd908: [top + 64] <- 0x1030c9d46859 ;  function    0x1030c9d46859 <JS Function resolveAnonymousTypeMembers (SharedFunctionInfo 0x2e2f693ef811)>  (input #0)
    0x7fff5fbfd900: [top + 56] <- 0x130b7e1b6e09 ;  0x130b7e1b6e09 <a SymbolObject with map 0x33abe2a75ab9>  (input #4)
    0x7fff5fbfd8f8: [top + 48] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfd8f0: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfd8e8: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfd8e0: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfd8d8: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
    0x7fff5fbfd8d0: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #10)
    0x7fff5fbfd8c8: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #11)
[deoptimizing (eager): end 0x1030c9d46859 <JS Function resolveAnonymousTypeMembers (SharedFunctionInfo 0x2e2f693ef811)> @4 => node=74, pc=0x2c21d2689643, caller sp=0x7fff5fbfd938, state=NO_REGISTERS, took 0.081 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d41a69 <JS Function symbolIsValue (SharedFunctionInfo 0x2e2f693e9d51)> (opt #387) @4, FP to SP delta: 56, caller sp: 0x7fff5fbfd7e0]
            ;;; deoptimize at 0_576: wrong map
  reading input frame symbolIsValue => node=56, args=2, height=1; inputs:
      0: 0x1030c9d41a69 ; [fp - 16] 0x1030c9d41a69 <JS Function symbolIsValue (SharedFunctionInfo 0x2e2f693e9d51)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1030c9d65831 ; rax 0x1030c9d65831 <a SymbolObject with map 0x33abe2a6fef1>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
  translating frame symbolIsValue => node=56, height=0
    0x7fff5fbfd7d8: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd7d0: [top + 32] <- 0x1030c9d65831 ;  0x1030c9d65831 <a SymbolObject with map 0x33abe2a6fef1>  (input #2)
    0x7fff5fbfd7c8: [top + 24] <- 0x2c21d26f4d51 ;  caller's pc
    0x7fff5fbfd7c0: [top + 16] <- 0x7fff5fbfd838 ;  caller's fp
    0x7fff5fbfd7b8: [top + 8] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd7b0: [top + 0] <- 0x1030c9d41a69 ;  function    0x1030c9d41a69 <JS Function symbolIsValue (SharedFunctionInfo 0x2e2f693e9d51)>  (input #0)
[deoptimizing (eager): end 0x1030c9d41a69 <JS Function symbolIsValue (SharedFunctionInfo 0x2e2f693e9d51)> @4 => node=56, pc=0x2c21d260e230, caller sp=0x7fff5fbfd7e0, state=NO_REGISTERS, took 0.054 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d3fa79 <JS Function getWidenedTypeForVariableLikeDeclaration (SharedFunctionInfo 0x2e2f693ec751)> (opt #295) @5, FP to SP delta: 32, caller sp: 0x7fff5fbfdd20]
            ;;; deoptimize at 0_174: unexpected object
  reading input frame getWidenedTypeForVariableLikeDeclaration => node=34, args=3, height=2; inputs:
      0: 0x1030c9d3fa79 ; [fp - 16] 0x1030c9d3fa79 <JS Function getWidenedTypeForVariableLikeDeclaration (SharedFunctionInfo 0x2e2f693ec751)>
      1: 0x1f9f6c0532e1 ; [fp + 32] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2f05bb8c1211 ; [fp + 24] 0x2f05bb8c1211 <a NodeObject with map 0x33abe2a6ffa1>
      3: 0x30bcea404311 ; rbx 0x30bcea404311 <undefined>
      4: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      5: 0x1030c9d51889 ; rax 0x1030c9d51889 <a TypeObject with map 0x33abe2a6cf81>
  translating frame getWidenedTypeForVariableLikeDeclaration => node=34, height=8
    0x7fff5fbfdd18: [top + 56] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdd10: [top + 48] <- 0x2f05bb8c1211 ;  0x2f05bb8c1211 <a NodeObject with map 0x33abe2a6ffa1>  (input #2)
    0x7fff5fbfdd08: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #3)
    0x7fff5fbfdd00: [top + 32] <- 0x2c21d2207e55 ;  caller's pc
    0x7fff5fbfdcf8: [top + 24] <- 0x7fff5fbfdd38 ;  caller's fp
    0x7fff5fbfdcf0: [top + 16] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #4)
    0x7fff5fbfdce8: [top + 8] <- 0x1030c9d3fa79 ;  function    0x1030c9d3fa79 <JS Function getWidenedTypeForVariableLikeDeclaration (SharedFunctionInfo 0x2e2f693ec751)>  (input #0)
    0x7fff5fbfdce0: [top + 0] <- 0x1030c9d51889 ;  0x1030c9d51889 <a TypeObject with map 0x33abe2a6cf81>  (input #5)
[deoptimizing (eager): end 0x1030c9d3fa79 <JS Function getWidenedTypeForVariableLikeDeclaration (SharedFunctionInfo 0x2e2f693ec751)> @5 => node=34, pc=0x2c21d25f64c7, caller sp=0x7fff5fbfdd20, state=NO_REGISTERS, took 0.069 ms]
[deoptimizing (DEOPT eager): begin 0xd6230dc6299 <JS Function hasQuestionToken (SharedFunctionInfo 0x3504a53d0859)> (opt #451) @4, FP to SP delta: 24, caller sp: 0x7fff5fbfdd20]
            ;;; deoptimize at 0_446: wrong map
  reading input frame hasQuestionToken => node=88, args=2, height=2; inputs:
      0: 0xd6230dc6299 ; [fp - 16] 0xd6230dc6299 <JS Function hasQuestionToken (SharedFunctionInfo 0x3504a53d0859)>
      1: 0x16f3adb61821 ; [fp + 24] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x2f05bb8c1211 ; rax 0x2f05bb8c1211 <a NodeObject with map 0x33abe2a6ffa1>
      3: 0xd6230db34c9 ; [fp - 24] 0xd6230db34c9 <FixedArray[156]>
      4: 0x30bcea4069a9 ; (literal 2) 0x30bcea4069a9 <Odd Oddball: optimized_out>
  translating frame hasQuestionToken => node=88, height=8
    0x7fff5fbfdd18: [top + 48] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfdd10: [top + 40] <- 0x2f05bb8c1211 ;  0x2f05bb8c1211 <a NodeObject with map 0x33abe2a6ffa1>  (input #2)
    0x7fff5fbfdd08: [top + 32] <- 0x2c21d274243c ;  caller's pc
    0x7fff5fbfdd00: [top + 24] <- 0x7fff5fbfdd40 ;  caller's fp
    0x7fff5fbfdcf8: [top + 16] <- 0xd6230db34c9 ;  context    0xd6230db34c9 <FixedArray[156]>  (input #3)
    0x7fff5fbfdcf0: [top + 8] <- 0xd6230dc6299 ;  function    0xd6230dc6299 <JS Function hasQuestionToken (SharedFunctionInfo 0x3504a53d0859)>  (input #0)
    0x7fff5fbfdce8: [top + 0] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #4)
[deoptimizing (eager): end 0xd6230dc6299 <JS Function hasQuestionToken (SharedFunctionInfo 0x3504a53d0859)> @4 => node=88, pc=0x2c21d26076bc, caller sp=0x7fff5fbfdd20, state=NO_REGISTERS, took 0.058 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:reportErrorsFromWidening) id{540,0} ---
(declaration, type) {
            if (produceDiagnostics && compilerOptions.noImplicitAny && type.flags & 2097152 /* ContainsWideningType */) {
                // Report implicit any error within type if possible, otherwise report error on declaration
                if (!reportWideningErrorsInType(type)) {
                    reportImplicitAnyError(declaration, type);
                }
            }
        }
--- END ---
[deoptimizing (DEOPT eager): begin 0x1030c9d3cbb9 <JS Function checkVariableStatement (SharedFunctionInfo 0x1b98fbc0d441)> (opt #466) @18, FP to SP delta: 88, caller sp: 0x7fff5fbfdfb8]
            ;;; deoptimize at 4_37: wrong map
  reading input frame checkVariableStatement => node=61, args=2, height=2; inputs:
      0: 0x1030c9d3cbb9 ; [fp - 16] 0x1030c9d3cbb9 <JS Function checkVariableStatement (SharedFunctionInfo 0x1b98fbc0d441)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2f05bb89c3e9 ; rcx 0x2f05bb89c3e9 <a NodeObject with map 0x33abe2a695c1>
      3: 0x130b7e1b3d29 ; rax 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x1030c9d3f1e1 ; rbx 0x1030c9d3f1e1 <JS Function checkGrammarForDisallowedLetOrConstStatement (SharedFunctionInfo 0x1b98fbc15011)>
  reading input frame checkGrammarForDisallowedLetOrConstStatement => node=14, args=2, height=2; inputs:
      0: 0x1030c9d3f1e1 ; (literal 14) 0x1030c9d3f1e1 <JS Function checkGrammarForDisallowedLetOrConstStatement (SharedFunctionInfo 0x1b98fbc15011)>
      1: 0x1f9f6c0532e1 ; (literal 10) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2f05bb89c3e9 ; rcx 0x2f05bb89c3e9 <a NodeObject with map 0x33abe2a695c1>
      3: 0x130b7e1b3d29 ; (literal 11) 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x1030c9d3f259 ; rdx 0x1030c9d3f259 <JS Function allowLetAndConstDeclarations (SharedFunctionInfo 0x1b98fbc14f51)>
  reading input frame allowLetAndConstDeclarations => node=3, args=2, height=2; inputs:
      0: 0x1030c9d3f259 ; (literal 15) 0x1030c9d3f259 <JS Function allowLetAndConstDeclarations (SharedFunctionInfo 0x1b98fbc14f51)>
      1: 0x1f9f6c0532e1 ; (literal 10) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2f05bb83a721 ; rsi 0x2f05bb83a721 <a SourceFileObject with map 0x15b5a7912591>
      3: 0x130b7e1b3d29 ; (literal 11) 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 12) 0x30bcea404311 <undefined>
  translating frame checkVariableStatement => node=61, height=8
    0x7fff5fbfdfb0: [top + 48] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdfa8: [top + 40] <- 0x2f05bb89c3e9 ;  0x2f05bb89c3e9 <a NodeObject with map 0x33abe2a695c1>  (input #2)
    0x7fff5fbfdfa0: [top + 32] <- 0x2c21d26a4d83 ;  caller's pc
    0x7fff5fbfdf98: [top + 24] <- 0x7fff5fbfe078 ;  caller's fp
    0x7fff5fbfdf90: [top + 16] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdf88: [top + 8] <- 0x1030c9d3cbb9 ;  function    0x1030c9d3cbb9 <JS Function checkVariableStatement (SharedFunctionInfo 0x1b98fbc0d441)>  (input #0)
    0x7fff5fbfdf80: [top + 0] <- 0x1030c9d3f1e1 ;  0x1030c9d3f1e1 <JS Function checkGrammarForDisallowedLetOrConstStatement (SharedFunctionInfo 0x1b98fbc15011)>  (input #4)
  translating frame checkGrammarForDisallowedLetOrConstStatement => node=14, height=8
    0x7fff5fbfdf78: [top + 48] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdf70: [top + 40] <- 0x2f05bb89c3e9 ;  0x2f05bb89c3e9 <a NodeObject with map 0x33abe2a695c1>  (input #2)
    0x7fff5fbfdf68: [top + 32] <- 0x2c21d25ecb2b ;  caller's pc
    0x7fff5fbfdf60: [top + 24] <- 0x7fff5fbfdf98 ;  caller's fp
    0x7fff5fbfdf58: [top + 16] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdf50: [top + 8] <- 0x1030c9d3f1e1 ;  function    0x1030c9d3f1e1 <JS Function checkGrammarForDisallowedLetOrConstStatement (SharedFunctionInfo 0x1b98fbc15011)>  (input #0)
    0x7fff5fbfdf48: [top + 0] <- 0x1030c9d3f259 ;  0x1030c9d3f259 <JS Function allowLetAndConstDeclarations (SharedFunctionInfo 0x1b98fbc14f51)>  (input #4)
  translating frame allowLetAndConstDeclarations => node=3, height=8
    0x7fff5fbfdf40: [top + 48] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdf38: [top + 40] <- 0x2f05bb83a721 ;  0x2f05bb83a721 <a SourceFileObject with map 0x15b5a7912591>  (input #2)
    0x7fff5fbfdf30: [top + 32] <- 0x2c21d25f1b1a ;  caller's pc
    0x7fff5fbfdf28: [top + 24] <- 0x7fff5fbfdf60 ;  caller's fp
    0x7fff5fbfdf20: [top + 16] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdf18: [top + 8] <- 0x1030c9d3f259 ;  function    0x1030c9d3f259 <JS Function allowLetAndConstDeclarations (SharedFunctionInfo 0x1b98fbc14f51)>  (input #0)
    0x7fff5fbfdf10: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
[deoptimizing (eager): end 0x1030c9d3cbb9 <JS Function checkVariableStatement (SharedFunctionInfo 0x1b98fbc0d441)> @18 => node=3, pc=0x2c21d25f1dea, caller sp=0x7fff5fbfdfb8, state=NO_REGISTERS, took 0.169 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d42859 <JS Function resolveEntityName (SharedFunctionInfo 0x2e2f693e9091)> (opt #398) @37, FP to SP delta: 128, caller sp: 0x7fff5fbfdb28]
            ;;; deoptimize at 2_95: wrong map
  reading input frame resolveEntityName => node=436, args=6, height=9; inputs:
      0: 0x1030c9d42859 ; [fp - 16] 0x1030c9d42859 <JS Function resolveEntityName (SharedFunctionInfo 0x2e2f693e9091)>
      1: 0x1f9f6c0532e1 ; [fp + 56] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2f05bb8dc4d1 ; [fp + 48] 0x2f05bb8dc4d1 <a NodeObject with map 0x33abe2a66f41>
      3: 0xc19e800000000 ; [fp + 40] 793064
      4: 0x30bcea404311 ; [fp + 32] 0x30bcea404311 <undefined>
      5: 0x30bcea404311 ; [fp + 24] 0x30bcea404311 <undefined>
      6: 0x30bcea404311 ; [fp + 16] 0x30bcea404311 <undefined>
      7: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      8: 0x30bcea4069a9 ; (literal 10) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      9: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     10: 0x30bcea4069a9 ; (literal 10) 0x30bcea4069a9 <Odd Oddball: optimized_out>
     11: 0x2f05bb8dfdf1 ; [fp - 40] 0x2f05bb8dfdf1 <an IdentifierObject with map 0x33abe2a6fb81>
     12: 0x130b7e1b6e09 ; [fp - 48] 0x130b7e1b6e09 <a SymbolObject with map 0x33abe2a75ab9>
     13: 0x1030c9d3e2b1 ; [fp - 64] 0x1030c9d3e2b1 <JS Function getSymbol (SharedFunctionInfo 0x2e2f693e7951)>
     14: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     15: 0x1030c9d46909 ; [fp - 72] 0x1030c9d46909 <JS Function getExportsOfSymbol (SharedFunctionInfo 0x2e2f693e9751)>
  reading input frame getExportsOfSymbol => node=27, args=2, height=2; inputs:
      0: 0x1030c9d46909 ; (literal 11) 0x1030c9d46909 <JS Function getExportsOfSymbol (SharedFunctionInfo 0x2e2f693e9751)>
      1: 0x1f9f6c0532e1 ; (literal 12) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x130b7e1b6e09 ; [fp - 48] 0x130b7e1b6e09 <a SymbolObject with map 0x33abe2a75ab9>
      3: 0x130b7e1b3d29 ; (literal 13) 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x1030c9d46951 ; [fp - 80] 0x1030c9d46951 <JS Function getExportsOfModule (SharedFunctionInfo 0x2e2f693e9811)>
  reading input frame getExportsOfModule => node=18, args=2, height=3; inputs:
      0: 0x1030c9d46951 ; (literal 14) 0x1030c9d46951 <JS Function getExportsOfModule (SharedFunctionInfo 0x2e2f693e9811)>
      1: 0x1f9f6c0532e1 ; (literal 12) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x130b7e1b6e09 ; [fp - 48] 0x130b7e1b6e09 <a SymbolObject with map 0x33abe2a75ab9>
      3: 0x130b7e1b3d29 ; (literal 13) 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
      5: 0x2271e26d9221 ; rax 0x2271e26d9221 <an Object with map 0x15b5a79125e9>
  translating frame resolveEntityName => node=436, height=64
    0x7fff5fbfdb20: [top + 136] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdb18: [top + 128] <- 0x2f05bb8dc4d1 ;  0x2f05bb8dc4d1 <a NodeObject with map 0x33abe2a66f41>  (input #2)
    0x7fff5fbfdb10: [top + 120] <- 0xc19e800000000 ;  793064  (input #3)
    0x7fff5fbfdb08: [top + 112] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfdb00: [top + 104] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfdaf8: [top + 96] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfdaf0: [top + 88] <- 0x2c21d2207e55 ;  caller's pc
    0x7fff5fbfdae8: [top + 80] <- 0x7fff5fbfdb40 ;  caller's fp
    0x7fff5fbfdae0: [top + 72] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #7)
    0x7fff5fbfdad8: [top + 64] <- 0x1030c9d42859 ;  function    0x1030c9d42859 <JS Function resolveEntityName (SharedFunctionInfo 0x2e2f693e9091)>  (input #0)
    0x7fff5fbfdad0: [top + 56] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #8)
    0x7fff5fbfdac8: [top + 48] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
    0x7fff5fbfdac0: [top + 40] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #10)
    0x7fff5fbfdab8: [top + 32] <- 0x2f05bb8dfdf1 ;  0x2f05bb8dfdf1 <an IdentifierObject with map 0x33abe2a6fb81>  (input #11)
    0x7fff5fbfdab0: [top + 24] <- 0x130b7e1b6e09 ;  0x130b7e1b6e09 <a SymbolObject with map 0x33abe2a75ab9>  (input #12)
    0x7fff5fbfdaa8: [top + 16] <- 0x1030c9d3e2b1 ;  0x1030c9d3e2b1 <JS Function getSymbol (SharedFunctionInfo 0x2e2f693e7951)>  (input #13)
    0x7fff5fbfdaa0: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #14)
    0x7fff5fbfda98: [top + 0] <- 0x1030c9d46909 ;  0x1030c9d46909 <JS Function getExportsOfSymbol (SharedFunctionInfo 0x2e2f693e9751)>  (input #15)
  translating frame getExportsOfSymbol => node=27, height=8
    0x7fff5fbfda90: [top + 48] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfda88: [top + 40] <- 0x130b7e1b6e09 ;  0x130b7e1b6e09 <a SymbolObject with map 0x33abe2a75ab9>  (input #2)
    0x7fff5fbfda80: [top + 32] <- 0x2c21d2613d00 ;  caller's pc
    0x7fff5fbfda78: [top + 24] <- 0x7fff5fbfdae8 ;  caller's fp
    0x7fff5fbfda70: [top + 16] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfda68: [top + 8] <- 0x1030c9d46909 ;  function    0x1030c9d46909 <JS Function getExportsOfSymbol (SharedFunctionInfo 0x2e2f693e9751)>  (input #0)
    0x7fff5fbfda60: [top + 0] <- 0x1030c9d46951 ;  0x1030c9d46951 <JS Function getExportsOfModule (SharedFunctionInfo 0x2e2f693e9811)>  (input #4)
  translating frame getExportsOfModule => node=18, height=16
    0x7fff5fbfda58: [top + 56] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfda50: [top + 48] <- 0x130b7e1b6e09 ;  0x130b7e1b6e09 <a SymbolObject with map 0x33abe2a75ab9>  (input #2)
    0x7fff5fbfda48: [top + 40] <- 0x2c21d268a0dd ;  caller's pc
    0x7fff5fbfda40: [top + 32] <- 0x7fff5fbfda78 ;  caller's fp
    0x7fff5fbfda38: [top + 24] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfda30: [top + 16] <- 0x1030c9d46951 ;  function    0x1030c9d46951 <JS Function getExportsOfModule (SharedFunctionInfo 0x2e2f693e9811)>  (input #0)
    0x7fff5fbfda28: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfda20: [top + 0] <- 0x2271e26d9221 ;  0x2271e26d9221 <an Object with map 0x15b5a79125e9>  (input #5)
[deoptimizing (eager): end 0x1030c9d42859 <JS Function resolveEntityName (SharedFunctionInfo 0x2e2f693e9091)> @37 => node=18, pc=0x2c21d268a224, caller sp=0x7fff5fbfdb28, state=TOS_REGISTER, took 0.208 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarVariableDeclarationList) id{541,0} ---
(declarationList) {
            var declarations = declarationList.declarations;
            if (checkGrammarForDisallowedTrailingComma(declarationList.declarations)) {
                return true;
            }
            if (!declarationList.declarations.length) {
                return grammarErrorAtPos(ts.getSourceFileOfNode(declarationList), declarations.pos, declarations.end - declarations.pos, ts.Diagnostics.Variable_declaration_list_cannot_be_empty);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarForDisallowedTrailingComma) id{541,1} ---
(list) {
            if (list && list.hasTrailingComma) {
                var start = list.end - ",".length;
                var end = list.end;
                var sourceFile = ts.getSourceFileOfNode(list[0]);
                return grammarErrorAtPos(sourceFile, start, end - start, ts.Diagnostics.Trailing_comma_not_allowed);
            }
        }
--- END ---
INLINE (checkGrammarForDisallowedTrailingComma) id{541,1} AS 1 AT <0:97>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:allowLetAndConstDeclarations) id{542,0} ---
(parent) {
            switch (parent.kind) {
                case 208 /* IfStatement */:
                case 209 /* DoStatement */:
                case 210 /* WhileStatement */:
                case 217 /* WithStatement */:
                case 211 /* ForStatement */:
                case 212 /* ForInStatement */:
                case 213 /* ForOfStatement */:
                    return false;
                case 219 /* LabeledStatement */:
                    return allowLetAndConstDeclarations(parent.parent);
            }
            return true;
        }
--- END ---
[deoptimizing (DEOPT eager): begin 0x1030c9d41319 <JS Function resolveBaseTypesOfInterface (SharedFunctionInfo 0x2e2f693edc51)> (opt #533) @29, FP to SP delta: 128, caller sp: 0x7fff5fbfdd88]
            ;;; deoptimize at 1_75: wrong map
  reading input frame resolveBaseTypesOfInterface => node=332, args=2, height=11; inputs:
      0: 0x1030c9d41319 ; [fp - 16] 0x1030c9d41319 <JS Function resolveBaseTypesOfInterface (SharedFunctionInfo 0x2e2f693edc51)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x32c5a0dc7b01 ; [fp + 16] 0x32c5a0dc7b01 <a TypeObject with map 0x33abe2a74251>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0 ; (int) [fp - 40] 
      5: 0x1030c9d657f9 ; [fp - 32] 0x1030c9d657f9 <JS Array[2]>
      6: 0x2f05bb89cd69 ; [fp - 48] 0x2f05bb89cd69 <a NodeObject with map 0x33abe2a70101>
      7: 0 ; (int) [fp - 80] 
      8: 0x2f05bb8cd221 ; [fp - 72] 0x2f05bb8cd221 <JS Array[1]>
      9: 0x2f05bb8dce81 ; [fp - 88] 0x2f05bb8dce81 <a NodeObject with map 0x33abe2a74da9>
     10: 0x32c5a0dc7b89 ; rax 0x32c5a0dc7b89 <a TypeObject with map 0x33abe2a72fc1>
     11: 0x1030c9d3c9d9 ; [fp - 104] 0x1030c9d3c9d9 <JS Function getObjectFlags (SharedFunctionInfo 0x2e2f693e77d1)>
     12: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
     13: 0x1030c9d447c9 ; [fp - 112] 0x1030c9d447c9 <JS Function getTargetType (SharedFunctionInfo 0x2e2f693ed111)>
  reading input frame getTargetType => node=7, args=2, height=1; inputs:
      0: 0x1030c9d447c9 ; (literal 7) 0x1030c9d447c9 <JS Function getTargetType (SharedFunctionInfo 0x2e2f693ed111)>
      1: 0x1f9f6c0532e1 ; (literal 8) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x32c5a0dc7b89 ; rax 0x32c5a0dc7b89 <a TypeObject with map 0x33abe2a72fc1>
      3: 0x130b7e1b3d29 ; (literal 9) 0x130b7e1b3d29 <FixedArray[1022]>
  translating frame resolveBaseTypesOfInterface => node=332, height=80
    0x7fff5fbfdd80: [top + 120] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdd78: [top + 112] <- 0x32c5a0dc7b01 ;  0x32c5a0dc7b01 <a TypeObject with map 0x33abe2a74251>  (input #2)
    0x7fff5fbfdd70: [top + 104] <- 0x2c21d26fdc79 ;  caller's pc
    0x7fff5fbfdd68: [top + 96] <- 0x7fff5fbfdda0 ;  caller's fp
    0x7fff5fbfdd60: [top + 88] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdd58: [top + 80] <- 0x1030c9d41319 ;  function    0x1030c9d41319 <JS Function resolveBaseTypesOfInterface (SharedFunctionInfo 0x2e2f693edc51)>  (input #0)
    0x7fff5fbfdd50: [top + 72] <- 0x00000000 ;  0  (input #4)
    0x7fff5fbfdd48: [top + 64] <- 0x1030c9d657f9 ;  0x1030c9d657f9 <JS Array[2]>  (input #5)
    0x7fff5fbfdd40: [top + 56] <- 0x2f05bb89cd69 ;  0x2f05bb89cd69 <a NodeObject with map 0x33abe2a70101>  (input #6)
    0x7fff5fbfdd38: [top + 48] <- 0x00000000 ;  0  (input #7)
    0x7fff5fbfdd30: [top + 40] <- 0x2f05bb8cd221 ;  0x2f05bb8cd221 <JS Array[1]>  (input #8)
    0x7fff5fbfdd28: [top + 32] <- 0x2f05bb8dce81 ;  0x2f05bb8dce81 <a NodeObject with map 0x33abe2a74da9>  (input #9)
    0x7fff5fbfdd20: [top + 24] <- 0x32c5a0dc7b89 ;  0x32c5a0dc7b89 <a TypeObject with map 0x33abe2a72fc1>  (input #10)
    0x7fff5fbfdd18: [top + 16] <- 0x1030c9d3c9d9 ;  0x1030c9d3c9d9 <JS Function getObjectFlags (SharedFunctionInfo 0x2e2f693e77d1)>  (input #11)
    0x7fff5fbfdd10: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #12)
    0x7fff5fbfdd08: [top + 0] <- 0x1030c9d447c9 ;  0x1030c9d447c9 <JS Function getTargetType (SharedFunctionInfo 0x2e2f693ed111)>  (input #13)
  translating frame getTargetType => node=7, height=0
    0x7fff5fbfdd00: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdcf8: [top + 32] <- 0x32c5a0dc7b89 ;  0x32c5a0dc7b89 <a TypeObject with map 0x33abe2a72fc1>  (input #2)
    0x7fff5fbfdcf0: [top + 24] <- 0x2c21d260b7e7 ;  caller's pc
    0x7fff5fbfdce8: [top + 16] <- 0x7fff5fbfdd68 ;  caller's fp
    0x7fff5fbfdce0: [top + 8] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdcd8: [top + 0] <- 0x1030c9d447c9 ;  function    0x1030c9d447c9 <JS Function getTargetType (SharedFunctionInfo 0x2e2f693ed111)>  (input #0)
[deoptimizing (eager): end 0x1030c9d41319 <JS Function resolveBaseTypesOfInterface (SharedFunctionInfo 0x2e2f693edc51)> @29 => node=7, pc=0x2c21d2627260, caller sp=0x7fff5fbfdd88, state=NO_REGISTERS, took 0.162 ms]
[deoptimizing (DEOPT eager): begin 0x32c5a0dca491 <JS Function check (SharedFunctionInfo 0x130b7e105a31)> (opt #469) @6, FP to SP delta: 64, caller sp: 0x7fff5fbfdcd8]
            ;;; deoptimize at 1_75: wrong map
  reading input frame check => node=20, args=2, height=3; inputs:
      0: 0x32c5a0dca491 ; [fp - 16] 0x32c5a0dca491 <JS Function check (SharedFunctionInfo 0x130b7e105a31)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x32c5a0dc7b89 ; rax 0x32c5a0dc7b89 <a TypeObject with map 0x33abe2a72fc1>
      3: 0x32c5a0dca451 ; [fp - 24] 0x32c5a0dca451 <FixedArray[6]>
      4: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
      5: 0x1030c9d447c9 ; [fp - 32] 0x1030c9d447c9 <JS Function getTargetType (SharedFunctionInfo 0x2e2f693ed111)>
  reading input frame getTargetType => node=7, args=2, height=1; inputs:
      0: 0x1030c9d447c9 ; (literal 6) 0x1030c9d447c9 <JS Function getTargetType (SharedFunctionInfo 0x2e2f693ed111)>
      1: 0x1f9f6c0532e1 ; (literal 7) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x32c5a0dc7b89 ; rax 0x32c5a0dc7b89 <a TypeObject with map 0x33abe2a72fc1>
      3: 0x130b7e1b3d29 ; (literal 8) 0x130b7e1b3d29 <FixedArray[1022]>
  translating frame check => node=20, height=16
    0x7fff5fbfdcd0: [top + 56] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdcc8: [top + 48] <- 0x32c5a0dc7b89 ;  0x32c5a0dc7b89 <a TypeObject with map 0x33abe2a72fc1>  (input #2)
    0x7fff5fbfdcc0: [top + 40] <- 0x2c21d26273c6 ;  caller's pc
    0x7fff5fbfdcb8: [top + 32] <- 0x7fff5fbfdcf0 ;  caller's fp
    0x7fff5fbfdcb0: [top + 24] <- 0x32c5a0dca451 ;  context    0x32c5a0dca451 <FixedArray[6]>  (input #3)
    0x7fff5fbfdca8: [top + 16] <- 0x32c5a0dca491 ;  function    0x32c5a0dca491 <JS Function check (SharedFunctionInfo 0x130b7e105a31)>  (input #0)
    0x7fff5fbfdca0: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfdc98: [top + 0] <- 0x1030c9d447c9 ;  0x1030c9d447c9 <JS Function getTargetType (SharedFunctionInfo 0x2e2f693ed111)>  (input #5)
  translating frame getTargetType => node=7, height=0
    0x7fff5fbfdc90: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdc88: [top + 32] <- 0x32c5a0dc7b89 ;  0x32c5a0dc7b89 <a TypeObject with map 0x33abe2a72fc1>  (input #2)
    0x7fff5fbfdc80: [top + 24] <- 0x2c21d26274bd ;  caller's pc
    0x7fff5fbfdc78: [top + 16] <- 0x7fff5fbfdcb8 ;  caller's fp
    0x7fff5fbfdc70: [top + 8] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdc68: [top + 0] <- 0x1030c9d447c9 ;  function    0x1030c9d447c9 <JS Function getTargetType (SharedFunctionInfo 0x2e2f693ed111)>  (input #0)
[deoptimizing (eager): end 0x32c5a0dca491 <JS Function check (SharedFunctionInfo 0x130b7e105a31)> @6 => node=7, pc=0x2c21d2627260, caller sp=0x7fff5fbfdcd8, state=NO_REGISTERS, took 0.141 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d447c9 <JS Function getTargetType (SharedFunctionInfo 0x2e2f693ed111)> (opt #386) @5, FP to SP delta: 32, caller sp: 0x7fff5fbfdbd0]
            ;;; deoptimize at 0_75: wrong map
  reading input frame getTargetType => node=7, args=2, height=1; inputs:
      0: 0x1030c9d447c9 ; [fp - 16] 0x1030c9d447c9 <JS Function getTargetType (SharedFunctionInfo 0x2e2f693ed111)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1ce442d1b631 ; rax 0x1ce442d1b631 <a TypeObject with map 0x33abe2a74989>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
  translating frame getTargetType => node=7, height=0
    0x7fff5fbfdbc8: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdbc0: [top + 32] <- 0x1ce442d1b631 ;  0x1ce442d1b631 <a TypeObject with map 0x33abe2a74989>  (input #2)
    0x7fff5fbfdbb8: [top + 24] <- 0x2c21d260b7e7 ;  caller's pc
    0x7fff5fbfdbb0: [top + 16] <- 0x7fff5fbfdc30 ;  caller's fp
    0x7fff5fbfdba8: [top + 8] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdba0: [top + 0] <- 0x1030c9d447c9 ;  function    0x1030c9d447c9 <JS Function getTargetType (SharedFunctionInfo 0x2e2f693ed111)>  (input #0)
[deoptimizing (eager): end 0x1030c9d447c9 <JS Function getTargetType (SharedFunctionInfo 0x2e2f693ed111)> @5 => node=7, pc=0x2c21d2627260, caller sp=0x7fff5fbfdbd0, state=NO_REGISTERS, took 0.041 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d410c1 <JS Function getTypeWithThisArgument (SharedFunctionInfo 0x2e2f693eec11)> (opt #372) @5, FP to SP delta: 144, caller sp: 0x7fff5fbfdf30]
            ;;; deoptimize at 0_130: Unknown map in polymorphic access
  reading input frame getTypeWithThisArgument => node=6, args=3, height=1; inputs:
      0: 0x1030c9d410c1 ; [fp - 16] 0x1030c9d410c1 <JS Function getTypeWithThisArgument (SharedFunctionInfo 0x2e2f693eec11)>
      1: 0x1f9f6c0532e1 ; [fp + 32] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x32c5a0dc7b89 ; rcx 0x32c5a0dc7b89 <a TypeObject with map 0x33abe2a74251>
      3: 0x32c5a0dc7fd9 ; [fp + 16] 0x32c5a0dc7fd9 <a TypeObject with map 0x33abe2a730c9>
      4: 0x130b7e1b3d29 ; rax 0x130b7e1b3d29 <FixedArray[1022]>
  translating frame getTypeWithThisArgument => node=6, height=0
    0x7fff5fbfdf28: [top + 48] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdf20: [top + 40] <- 0x32c5a0dc7b89 ;  0x32c5a0dc7b89 <a TypeObject with map 0x33abe2a74251>  (input #2)
    0x7fff5fbfdf18: [top + 32] <- 0x32c5a0dc7fd9 ;  0x32c5a0dc7fd9 <a TypeObject with map 0x33abe2a730c9>  (input #3)
    0x7fff5fbfdf10: [top + 24] <- 0x2c21d26091a4 ;  caller's pc
    0x7fff5fbfdf08: [top + 16] <- 0x7fff5fbfdf98 ;  caller's fp
    0x7fff5fbfdf00: [top + 8] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #4)
    0x7fff5fbfdef8: [top + 0] <- 0x1030c9d410c1 ;  function    0x1030c9d410c1 <JS Function getTypeWithThisArgument (SharedFunctionInfo 0x2e2f693eec11)>  (input #0)
[deoptimizing (eager): end 0x1030c9d410c1 <JS Function getTypeWithThisArgument (SharedFunctionInfo 0x2e2f693eec11)> @5 => node=6, pc=0x2c21d260a340, caller sp=0x7fff5fbfdf30, state=NO_REGISTERS, took 0.049 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIndependentType) id{543,0} ---
(node) {
            switch (node.kind) {
                case 118 /* AnyKeyword */:
                case 134 /* StringKeyword */:
                case 132 /* NumberKeyword */:
                case 121 /* BooleanKeyword */:
                case 135 /* SymbolKeyword */:
                case 104 /* VoidKeyword */:
                case 137 /* UndefinedKeyword */:
                case 94 /* NullKeyword */:
                case 129 /* NeverKeyword */:
                case 171 /* LiteralType */:
                    return true;
                case 162 /* ArrayType */:
                    return isIndependentType(node.elementType);
                case 157 /* TypeReference */:
                    return isIndependentTypeReference(node);
            }
            return false;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIndependentTypeReference) id{543,1} ---
(node) {
            if (node.typeArguments) {
                for (var _i = 0, _a = node.typeArguments; _i < _a.length; _i++) {
                    var typeNode = _a[_i];
                    if (!isIndependentType(typeNode)) {
                        return false;
                    }
                }
            }
            return true;
        }
--- END ---
INLINE (isIndependentTypeReference) id{543,1} AS 1 AT <0:707>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIndependentVariableLikeDeclaration) id{544,0} ---
(node) {
            return node.type && isIndependentType(node.type) || !node.type && !node.initializer;
        }
--- END ---
[deoptimizing (DEOPT eager): begin 0x1030c9d45751 <JS Function isIndependentType (SharedFunctionInfo 0x2e2f693ee611)> (opt #543) @4, FP to SP delta: 24, caller sp: 0x7fff5fbfd898]
            ;;; deoptimize at 1_29: wrong map
  reading input frame isIndependentType => node=142, args=2, height=3; inputs:
      0: 0x1030c9d45751 ; [fp - 16] 0x1030c9d45751 <JS Function isIndependentType (SharedFunctionInfo 0x2e2f693ee611)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2f05bb8c0c91 ; rcx 0x2f05bb8c0c91 <a NodeObject with map 0x33abe2a68a11>
      3: 0x130b7e1b3d29 ; rbx 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea4069a9 ; (literal 4) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      5: 0x1030c9d45799 ; rdx 0x1030c9d45799 <JS Function isIndependentTypeReference (SharedFunctionInfo 0x2e2f693ee551)>
  reading input frame isIndependentTypeReference => node=3, args=2, height=4; inputs:
      0: 0x1030c9d45799 ; (literal 5) 0x1030c9d45799 <JS Function isIndependentTypeReference (SharedFunctionInfo 0x2e2f693ee551)>
      1: 0x1f9f6c0532e1 ; (literal 6) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2f05bb8c0c91 ; rcx 0x2f05bb8c0c91 <a NodeObject with map 0x33abe2a68a11>
      3: 0x130b7e1b3d29 ; (literal 7) 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 3) 0x30bcea404311 <undefined>
      5: 0x30bcea404311 ; (literal 3) 0x30bcea404311 <undefined>
      6: 0x30bcea404311 ; (literal 3) 0x30bcea404311 <undefined>
  translating frame isIndependentType => node=142, height=16
    0x7fff5fbfd890: [top + 56] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd888: [top + 48] <- 0x2f05bb8c0c91 ;  0x2f05bb8c0c91 <a NodeObject with map 0x33abe2a68a11>  (input #2)
    0x7fff5fbfd880: [top + 40] <- 0x2c21d2643464 ;  caller's pc
    0x7fff5fbfd878: [top + 32] <- 0x7fff5fbfd8c8 ;  caller's fp
    0x7fff5fbfd870: [top + 24] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd868: [top + 16] <- 0x1030c9d45751 ;  function    0x1030c9d45751 <JS Function isIndependentType (SharedFunctionInfo 0x2e2f693ee611)>  (input #0)
    0x7fff5fbfd860: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #4)
    0x7fff5fbfd858: [top + 0] <- 0x1030c9d45799 ;  0x1030c9d45799 <JS Function isIndependentTypeReference (SharedFunctionInfo 0x2e2f693ee551)>  (input #5)
  translating frame isIndependentTypeReference => node=3, height=24
    0x7fff5fbfd850: [top + 64] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd848: [top + 56] <- 0x2f05bb8c0c91 ;  0x2f05bb8c0c91 <a NodeObject with map 0x33abe2a68a11>  (input #2)
    0x7fff5fbfd840: [top + 48] <- 0x2c21d2632864 ;  caller's pc
    0x7fff5fbfd838: [top + 40] <- 0x7fff5fbfd878 ;  caller's fp
    0x7fff5fbfd830: [top + 32] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd828: [top + 24] <- 0x1030c9d45799 ;  function    0x1030c9d45799 <JS Function isIndependentTypeReference (SharedFunctionInfo 0x2e2f693ee551)>  (input #0)
    0x7fff5fbfd820: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfd818: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfd810: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
[deoptimizing (eager): end 0x1030c9d45751 <JS Function isIndependentType (SharedFunctionInfo 0x2e2f693ee611)> @4 => node=3, pc=0x2c21d263290d, caller sp=0x7fff5fbfd898, state=NO_REGISTERS, took 0.099 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:symbolIsValue) id{545,0} ---
(symbol) {
            // If it is an instantiated symbol, then it is a value if the symbol it is an
            // instantiation of is a value.
            if (symbol.flags & 16777216 /* Instantiated */) {
                return symbolIsValue(getSymbolLinks(symbol).target);
            }
            // If the symbol has the value flag, it is trivially a value.
            if (symbol.flags & 107455 /* Value */) {
                return true;
            }
            // If it is an alias, then it is a value if the symbol it resolves to is a value.
            if (symbol.flags & 8388608 /* Alias */) {
                return (resolveAlias(symbol).flags & 107455 /* Value */) !== 0;
            }
            return false;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{545,1} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{545,1} AS 1 AT <0:244>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{545,2} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{545,2} AS 2 AT <1:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIndependentMember) id{546,0} ---
(symbol) {
            if (symbol.declarations && symbol.declarations.length === 1) {
                var declaration = symbol.declarations[0];
                if (declaration) {
                    switch (declaration.kind) {
                        case 147 /* PropertyDeclaration */:
                        case 146 /* PropertySignature */:
                            return isIndependentVariableLikeDeclaration(declaration);
                        case 149 /* MethodDeclaration */:
                        case 148 /* MethodSignature */:
                        case 150 /* Constructor */:
                            return isIndependentFunctionLikeDeclaration(declaration);
                    }
                }
            }
            return false;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIndependentVariableLikeDeclaration) id{546,1} ---
(node) {
            return node.type && isIndependentType(node.type) || !node.type && !node.initializer;
        }
--- END ---
INLINE (isIndependentVariableLikeDeclaration) id{546,1} AS 1 AT <0:380>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIndependentFunctionLikeDeclaration) id{546,2} ---
(node) {
            if (node.kind !== 150 /* Constructor */ && (!node.type || !isIndependentType(node.type))) {
                return false;
            }
            for (var _i = 0, _a = node.parameters; _i < _a.length; _i++) {
                var parameter = _a[_i];
                if (!isIndependentVariableLikeDeclaration(parameter)) {
                    return false;
                }
            }
            return true;
        }
--- END ---
INLINE (isIndependentFunctionLikeDeclaration) id{546,2} AS 2 AT <0:632>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIndependentVariableLikeDeclaration) id{546,3} ---
(node) {
            return node.type && isIndependentType(node.type) || !node.type && !node.initializer;
        }
--- END ---
INLINE (isIndependentVariableLikeDeclaration) id{546,3} AS 3 AT <2:293>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateTypes) id{547,0} ---
(types, mapper) {
            return instantiateList(types, mapper, instantiateType);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateList) id{547,1} ---
(items, mapper, instantiator) {
            if (items && items.length) {
                var result = [];
                for (var _i = 0, items_1 = items; _i < items_1.length; _i++) {
                    var v = items_1[_i];
                    result.push(instantiator(v, mapper));
                }
                return result;
            }
            return items;
        }
--- END ---
INLINE (instantiateList) id{547,1} AS 1 AT <0:37>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeOfFuncClassEnumModule) id{548,0} ---
(symbol) {
            var links = getSymbolLinks(symbol);
            if (!links.type) {
                if (symbol.flags & 1536 /* Module */ && ts.isShorthandAmbientModuleSymbol(symbol)) {
                    links.type = anyType;
                }
                else {
                    var type = createObjectType(16 /* Anonymous */, symbol);
                    links.type = strictNullChecks && symbol.flags & 536870912 /* Optional */ ?
                        includeFalsyTypes(type, 2048 /* Undefined */) : type;
                }
            }
            return links.type;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{548,1} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{548,1} AS 1 AT <0:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{548,2} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{548,2} AS 2 AT <1:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createObjectType) id{548,3} ---
(objectFlags, symbol) {
            var type = createType(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol = symbol;
            return type;
        }
--- END ---
INLINE (createObjectType) id{548,3} AS 3 AT <0:305>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{548,4} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{548,4} AS 4 AT <3:47>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{548,5} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{548,5} AS 5 AT <4:35>
[deoptimizing (DEOPT eager): begin 0x1030c9d42ec1 <JS Function getSignatureFromDeclaration (SharedFunctionInfo 0x2e2f693f10d1)> (opt #504) @85, FP to SP delta: 240, caller sp: 0x7fff5fbfd830]
            ;;; deoptimize at 0_4026: wrong map
  reading input frame getSignatureFromDeclaration => node=1108, args=2, height=19; inputs:
      0: 0x1030c9d42ec1 ; [fp - 16] 0x1030c9d42ec1 <JS Function getSignatureFromDeclaration (SharedFunctionInfo 0x2e2f693f10d1)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2f05bb8bdf49 ; rdx 0x2f05bb8bdf49 <a NodeObject with map 0x33abe2a76611>
      3: 0x130b7e1b3d29 ; rax 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x32c5a0de0239 ; [fp - 56] 0x32c5a0de0239 <an Object with map 0x33abe2a51889>
      5: 0x2271e26e2f31 ; [fp - 64] 0x2271e26e2f31 <JS Array[1]>
      6: 0x30bcea404421 ; [fp - 136] 0x30bcea404421 <false>
      7: 0x100000000 ; [fp - 104] 1
      8: 0x30bcea404311 ; [fp - 144] 0x30bcea404311 <undefined>
      9: 0x30bcea404311 ; [fp - 112] 0x30bcea404311 <undefined>
     10: 0x30bcea4069a9 ; (literal 15) 0x30bcea4069a9 <Odd Oddball: optimized_out>
     11: 0x30bcea4069a9 ; (literal 15) 0x30bcea4069a9 <Odd Oddball: optimized_out>
     12: 0x30bcea4069a9 ; (literal 15) 0x30bcea4069a9 <Odd Oddball: optimized_out>
     13: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     14: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     15: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     16: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     17: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
     18: 0x30bcea4069a9 ; (literal 15) 0x30bcea4069a9 <Odd Oddball: optimized_out>
     19: 0x30bcea404311 ; [fp - 208] 0x30bcea404311 <undefined>
     20: 0x1030c9d51969 ; [fp - 216] 0x1030c9d51969 <a TypeObject with map 0x33abe2a6d139>
     21: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
  translating frame getSignatureFromDeclaration => node=1108, height=144
    0x7fff5fbfd828: [top + 184] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd820: [top + 176] <- 0x2f05bb8bdf49 ;  0x2f05bb8bdf49 <a NodeObject with map 0x33abe2a76611>  (input #2)
    0x7fff5fbfd818: [top + 168] <- 0x2c21d264c179 ;  caller's pc
    0x7fff5fbfd810: [top + 160] <- 0x7fff5fbfd888 ;  caller's fp
    0x7fff5fbfd808: [top + 152] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd800: [top + 144] <- 0x1030c9d42ec1 ;  function    0x1030c9d42ec1 <JS Function getSignatureFromDeclaration (SharedFunctionInfo 0x2e2f693f10d1)>  (input #0)
    0x7fff5fbfd7f8: [top + 136] <- 0x32c5a0de0239 ;  0x32c5a0de0239 <an Object with map 0x33abe2a51889>  (input #4)
    0x7fff5fbfd7f0: [top + 128] <- 0x2271e26e2f31 ;  0x2271e26e2f31 <JS Array[1]>  (input #5)
    0x7fff5fbfd7e8: [top + 120] <- 0x30bcea404421 ;  0x30bcea404421 <false>  (input #6)
    0x7fff5fbfd7e0: [top + 112] <- 0x100000000 ;  1  (input #7)
    0x7fff5fbfd7d8: [top + 104] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfd7d0: [top + 96] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
    0x7fff5fbfd7c8: [top + 88] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #10)
    0x7fff5fbfd7c0: [top + 80] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #11)
    0x7fff5fbfd7b8: [top + 72] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #12)
    0x7fff5fbfd7b0: [top + 64] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #13)
    0x7fff5fbfd7a8: [top + 56] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #14)
    0x7fff5fbfd7a0: [top + 48] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #15)
    0x7fff5fbfd798: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #16)
    0x7fff5fbfd790: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #17)
    0x7fff5fbfd788: [top + 24] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #18)
    0x7fff5fbfd780: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #19)
    0x7fff5fbfd778: [top + 8] <- 0x1030c9d51969 ;  0x1030c9d51969 <a TypeObject with map 0x33abe2a6d139>  (input #20)
    0x7fff5fbfd770: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #21)
[deoptimizing (eager): end 0x1030c9d42ec1 <JS Function getSignatureFromDeclaration (SharedFunctionInfo 0x2e2f693f10d1)> @85 => node=1108, pc=0x2c21d2616f0b, caller sp=0x7fff5fbfd830, state=NO_REGISTERS, took 0.139 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveName) id{549,0} ---
(location, name, meaning, nameNotFoundMessage, nameArg) {
            var result;
            var lastLocation;
            var propertyWithInvalidInitializer;
            var errorLocation = location;
            var grandparent;
            var isInExternalModule = false;
            loop: while (location) {
                // Locals of a source file are not in scope (because they get merged into the global symbol table)
                if (location.locals && !isGlobalSourceFile(location)) {
                    if (result = getSymbol(location.locals, name, meaning)) {
                        var useResult = true;
                        if (ts.isFunctionLike(location) && lastLocation && lastLocation !== location.body) {
                            // symbol lookup restrictions for function-like declarations
                            // - Type parameters of a function are in scope in the entire function declaration, including the parameter
                            //   list and return type. However, local types are only in scope in the function body.
                            // - parameters are only in the scope of function body
                            // This restriction does not apply to JSDoc comment types because they are parented
                            // at a higher level than type parameters would normally be
                            if (meaning & result.flags & 793064 /* Type */ && lastLocation.kind !== 278 /* JSDocComment */) {
                                useResult = result.flags & 262144 /* TypeParameter */
                                    ? lastLocation === location.type ||
                                        lastLocation.kind === 144 /* Parameter */ ||
                                        lastLocation.kind === 143 /* TypeParameter */
                                    : false;
                            }
                            if (meaning & 107455 /* Value */ && result.flags & 1 /* FunctionScopedVariable */) {
                                // parameters are visible only inside function body, parameter list and return type
                                // technically for parameter list case here we might mix parameters and variables declared in function,
                                // however it is detected separately when checking initializers of parameters
                                // to make sure that they reference no variables declared after them.
                                useResult =
                                    lastLocation.kind === 144 /* Parameter */ ||
                                        (lastLocation === location.type &&
                                            result.valueDeclaration.kind === 144 /* Parameter */);
                            }
                        }
                        if (useResult) {
                            break loop;
                        }
                        else {
                            result = undefined;
                        }
                    }
                }
                switch (location.kind) {
                    case 261 /* SourceFile */:
                        if (!ts.isExternalOrCommonJsModule(location))
                            break;
                        isInExternalModule = true;
                    case 230 /* ModuleDeclaration */:
                        var moduleExports = getSymbolOfNode(location).exports;
                        if (location.kind === 261 /* SourceFile */ || ts.isAmbientModule(location)) {
                            // It's an external module. First see if the module has an export default and if the local
                            // name of that export default matches.
                            if (result = moduleExports["default"]) {
                                var localSymbol = ts.getLocalSymbolForExportDefault(result);
                                if (localSymbol && (result.flags & meaning) && localSymbol.name === name) {
                                    break loop;
                                }
                                result = undefined;
                            }
                            // Because of module/namespace merging, a module's exports are in scope,
                            // yet we never want to treat an export specifier as putting a member in scope.
                            // Therefore, if the name we find is purely an export specifier, it is not actually considered in scope.
                            // Two things to note about this:
                            //     1. We have to check this without calling getSymbol. The problem with calling getSymbol
                            //        on an export specifier is that it might find the export specifier itself, and try to
                            //        resolve it as an alias. This will cause the checker to consider the export specifier
                            //        a circular alias reference when it might not be.
                            //     2. We check === SymbolFlags.Alias in order to check that the symbol is *purely*
                            //        an alias. If we used &, we'd be throwing out symbols that have non alias aspects,
                            //        which is not the desired behavior.
                            if (moduleExports[name] &&
                                moduleExports[name].flags === 8388608 /* Alias */ &&
                                ts.getDeclarationOfKind(moduleExports[name], 243 /* ExportSpecifier */)) {
                                break;
                            }
                        }
                        if (result = getSymbol(moduleExports, name, meaning & 8914931 /* ModuleMember */)) {
                            break loop;
                        }
                        break;
                    case 229 /* EnumDeclaration */:
                        if (result = getSymbol(getSymbolOfNode(location).exports, name, meaning & 8 /* EnumMember */)) {
                            break loop;
                        }
                        break;
                    case 147 /* PropertyDeclaration */:
                    case 146 /* PropertySignature */:
                        // TypeScript 1.0 spec (April 2014): 8.4.1
                        // Initializer expressions for instance member variables are evaluated in the scope
                        // of the class constructor body but are not permitted to reference parameters or
                        // local variables of the constructor. This effectively means that entities from outer scopes
                        // by the same name as a constructor parameter or local variable are inaccessible
                        // in initializer expressions for instance member variables.
                        if (ts.isClassLike(location.parent) && !(ts.getModifierFlags(location) & 32 /* Static */)) {
                            var ctor = findConstructorDeclaration(location.parent);
                            if (ctor && ctor.locals) {
                                if (getSymbol(ctor.locals, name, meaning & 107455 /* Value */)) {
                                    // Remember the property node, it will be used later to report appropriate error
                                    propertyWithInvalidInitializer = location;
                                }
                            }
                        }
                        break;
                    case 226 /* ClassDeclaration */:
                    case 197 /* ClassExpression */:
                    case 227 /* InterfaceDeclaration */:
                        if (result = getSymbol(getSymbolOfNode(location).members, name, meaning & 793064 /* Type */)) {
                            if (lastLocation && ts.getModifierFlags(lastLocation) & 32 /* Static */) {
                                // TypeScript 1.0 spec (April 2014): 3.4.1
                                // The scope of a type parameter extends over the entire declaration with which the type
                                // parameter list is associated, with the exception of static member declarations in classes.
                                error(errorLocation, ts.Diagnostics.Static_members_cannot_reference_class_type_parameters);
                                return undefined;
                            }
                            break loop;
                        }
                        if (location.kind === 197 /* ClassExpression */ && meaning & 32 /* Class */) {
                            var className = location.name;
                            if (className && name === className.text) {
                                result = location.symbol;
                                break loop;
                            }
                        }
                        break;
                    // It is not legal to reference a class's own type parameters from a computed property name that
                    // belongs to the class. For example:
                    //
                    //   function foo<T>() { return '' }
                    //   class C<T> { // <-- Class's own type parameter T
                    //       [foo<T>()]() { } // <-- Reference to T from class's own computed property
                    //   }
                    //
                    case 142 /* ComputedPropertyName */:
                        grandparent = location.parent.parent;
                        if (ts.isClassLike(grandparent) || grandparent.kind === 227 /* InterfaceDeclaration */) {
                            // A reference to this grandparent's type parameters would be an error
                            if (result = getSymbol(getSymbolOfNode(grandparent).members, name, meaning & 793064 /* Type */)) {
                                error(errorLocation, ts.Diagnostics.A_computed_property_name_cannot_reference_a_type_parameter_from_its_containing_type);
                                return undefined;
                            }
                        }
                        break;
                    case 149 /* MethodDeclaration */:
                    case 148 /* MethodSignature */:
                    case 150 /* Constructor */:
                    case 151 /* GetAccessor */:
                    case 152 /* SetAccessor */:
                    case 225 /* FunctionDeclaration */:
                    case 185 /* ArrowFunction */:
                        if (meaning & 3 /* Variable */ && name === "arguments") {
                            result = argumentsSymbol;
                            break loop;
                        }
                        break;
                    case 184 /* FunctionExpression */:
                        if (meaning & 3 /* Variable */ && name === "arguments") {
                            result = argumentsSymbol;
                            break loop;
                        }
                        if (meaning & 16 /* Function */) {
                            var functionName = location.name;
                            if (functionName && name === functionName.text) {
                                result = location.symbol;
                                break loop;
                            }
                        }
                        break;
                    case 145 /* Decorator */:
                        // Decorators are resolved at the class declaration. Resolving at the parameter
                        // or member would result in looking up locals in the method.
                        //
                        //   function y() {}
                        //   class C {
                        //       method(@y x, y) {} // <-- decorator y should be resolved at the class declaration, not the parameter.
                        //   }
                        //
                        if (location.parent && location.parent.kind === 144 /* Parameter */) {
                            location = location.parent;
                        }
                        //
                        //   function y() {}
                        //   class C {
                        //       @y method(x, y) {} // <-- decorator y should be resolved at the class declaration, not the method.
                        //   }
                        //
                        if (location.parent && ts.isClassElement(location.parent)) {
                            location = location.parent;
                        }
                        break;
                }
                lastLocation = location;
                location = location.parent;
            }
            if (result && nameNotFoundMessage && noUnusedIdentifiers) {
                result.isReferenced = true;
            }
            if (!result) {
                result = getSymbol(globals, name, meaning);
            }
            if (!result) {
                if (nameNotFoundMessage) {
                    if (!errorLocation ||
                        !checkAndReportErrorForMissingPrefix(errorLocation, name, nameArg) &&
                            !checkAndReportErrorForExtendingInterface(errorLocation) &&
                            !checkAndReportErrorForUsingTypeAsNamespace(errorLocation, name, meaning) &&
                            !checkAndReportErrorForUsingTypeAsValue(errorLocation, name, meaning)) {
                        error(errorLocation, nameNotFoundMessage, typeof nameArg === "string" ? nameArg : ts.declarationNameToString(nameArg));
                    }
                }
                return undefined;
            }
            // Perform extra checks only if error reporting was requested
            if (nameNotFoundMessage) {
                if (propertyWithInvalidInitializer) {
                    // We have a match, but the reference occurred within a property initializer and the identifier also binds
                    // to a local variable in the constructor where the code will be emitted.
                    var propertyName = propertyWithInvalidInitializer.name;
                    error(errorLocation, ts.Diagnostics.Initializer_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor, ts.declarationNameToString(propertyName), typeof nameArg === "string" ? nameArg : ts.declarationNameToString(nameArg));
                    return undefined;
                }
                // Only check for block-scoped variable if we are looking for the
                // name with variable meaning
                //      For example,
                //          declare module foo {
                //              interface bar {}
                //          }
                //      const foo/*1*/: foo/*2*/.bar;
                // The foo at /*1*/ and /*2*/ will share same symbol with two meaning
                // block - scope variable and namespace module. However, only when we
                // try to resolve name in /*1*/ which is used in variable position,
                // we want to check for block- scoped
                if (meaning & 2 /* BlockScopedVariable */) {
                    var exportOrLocalSymbol = getExportSymbolOfValueSymbolIfExported(result);
                    if (exportOrLocalSymbol.flags & 2 /* BlockScopedVariable */) {
                        checkResolvedBlockScopedVariable(exportOrLocalSymbol, errorLocation);
                    }
                }
                // If we're in an external module, we can't reference value symbols created from UMD export declarations
                if (result && isInExternalModule && (meaning & 107455 /* Value */) === 107455 /* Value */) {
                    var decls = result.declarations;
                    if (decls && decls.length === 1 && decls[0].kind === 233 /* NamespaceExportDeclaration */) {
                        error(errorLocation, ts.Diagnostics._0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead, name);
                    }
                }
            }
            return result;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isGlobalSourceFile) id{549,1} ---
(node) {
            return node.kind === 261 /* SourceFile */ && !ts.isExternalOrCommonJsModule(node);
        }
--- END ---
INLINE (isGlobalSourceFile) id{549,1} AS 1 AT <0:467>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{549,2} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{549,2} AS 2 AT <0:3412>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{549,3} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{549,3} AS 3 AT <2:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{549,4} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{549,4} AS 4 AT <0:7735>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{549,5} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{549,5} AS 5 AT <4:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getExportSymbolOfValueSymbolIfExported) id{549,6} ---
(symbol) {
            return symbol && (symbol.flags & 1048576 /* ExportValue */) !== 0
                ? getMergedSymbol(symbol.exportSymbol)
                : symbol;
        }
--- END ---
INLINE (getExportSymbolOfValueSymbolIfExported) id{549,6} AS 6 AT <0:15249>
[deoptimizing (DEOPT eager): begin 0x1030c9d3f259 <JS Function allowLetAndConstDeclarations (SharedFunctionInfo 0x1b98fbc14f51)> (opt #542) @2, FP to SP delta: 24, caller sp: 0x7fff5fbfdc30]
  reading input frame allowLetAndConstDeclarations => node=4, args=2, height=2; inputs:
      0: 0x1030c9d3f259 ; [fp - 16] 0x1030c9d3f259 <JS Function allowLetAndConstDeclarations (SharedFunctionInfo 0x1b98fbc14f51)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2f05bb8a8f49 ; rax 0x2f05bb8a8f49 <a NodeObject with map 0x33abe2a68961>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
  translating frame allowLetAndConstDeclarations => node=4, height=8
    0x7fff5fbfdc28: [top + 48] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdc20: [top + 40] <- 0x2f05bb8a8f49 ;  0x2f05bb8a8f49 <a NodeObject with map 0x33abe2a68961>  (input #2)
    0x7fff5fbfdc18: [top + 32] <- 0x2c21d25f1b1a ;  caller's pc
    0x7fff5fbfdc10: [top + 24] <- 0x7fff5fbfdc48 ;  caller's fp
    0x7fff5fbfdc08: [top + 16] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdc00: [top + 8] <- 0x1030c9d3f259 ;  function    0x1030c9d3f259 <JS Function allowLetAndConstDeclarations (SharedFunctionInfo 0x1b98fbc14f51)>  (input #0)
    0x7fff5fbfdbf8: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
[deoptimizing (eager): end 0x1030c9d3f259 <JS Function allowLetAndConstDeclarations (SharedFunctionInfo 0x1b98fbc14f51)> @2 => node=4, pc=0x2c21d25f1dea, caller sp=0x7fff5fbfdc30, state=NO_REGISTERS, took 0.053 ms]
[deoptimizing (DEOPT eager): begin 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> (opt #392) @71, FP to SP delta: 192, caller sp: 0x7fff5fbfda50]
            ;;; deoptimize at 12_36: wrong map
  reading input frame checkSourceElement => node=403, args=2, height=5; inputs:
      0: 0x130b7e1b6059 ; [fp - 16] 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2f05bb8ef4f9 ; rbx 0x2f05bb8ef4f9 <a NodeObject with map 0x33abe2a768d1>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 31) 0x30bcea404311 <undefined>
      5: 0x30bcea4069a9 ; (literal 32) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      6: 0x30bcea4069a9 ; (literal 32) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x1030c9d46811 ; [fp - 64] 0x1030c9d46811 <JS Function checkTypeLiteral (SharedFunctionInfo 0x1b98fbc0b101)>
  reading input frame checkTypeLiteral => node=16, args=2, height=4; inputs:
      0: 0x1030c9d46811 ; (literal 38) 0x1030c9d46811 <JS Function checkTypeLiteral (SharedFunctionInfo 0x1b98fbc0b101)>
      1: 0x1f9f6c0532e1 ; (literal 34) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2f05bb8ef4f9 ; rbx 0x2f05bb8ef4f9 <a NodeObject with map 0x33abe2a768d1>
      3: 0x130b7e1b3d29 ; (literal 35) 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 31) 0x30bcea404311 <undefined>
      5: 0x16f3adb61821 ; [fp - 72] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      6: 0xd6230daf4a1 ; rax 0xd6230daf4a1 <JS Function forEach (SharedFunctionInfo 0xc2bd2ae0d69)>
  translating frame checkSourceElement => node=403, height=32
    0x7fff5fbfda48: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfda40: [top + 64] <- 0x2f05bb8ef4f9 ;  0x2f05bb8ef4f9 <a NodeObject with map 0x33abe2a768d1>  (input #2)
    0x7fff5fbfda38: [top + 56] <- 0x2c21d25f3311 ;  caller's pc
    0x7fff5fbfda30: [top + 48] <- 0x7fff5fbfdaa0 ;  caller's fp
    0x7fff5fbfda28: [top + 40] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfda20: [top + 32] <- 0x130b7e1b6059 ;  function    0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>  (input #0)
    0x7fff5fbfda18: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfda10: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #5)
    0x7fff5fbfda08: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfda00: [top + 0] <- 0x1030c9d46811 ;  0x1030c9d46811 <JS Function checkTypeLiteral (SharedFunctionInfo 0x1b98fbc0b101)>  (input #7)
  translating frame checkTypeLiteral => node=16, height=24
    0x7fff5fbfd9f8: [top + 64] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd9f0: [top + 56] <- 0x2f05bb8ef4f9 ;  0x2f05bb8ef4f9 <a NodeObject with map 0x33abe2a768d1>  (input #2)
    0x7fff5fbfd9e8: [top + 48] <- 0x2c21d25ec240 ;  caller's pc
    0x7fff5fbfd9e0: [top + 40] <- 0x7fff5fbfda30 ;  caller's fp
    0x7fff5fbfd9d8: [top + 32] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd9d0: [top + 24] <- 0x1030c9d46811 ;  function    0x1030c9d46811 <JS Function checkTypeLiteral (SharedFunctionInfo 0x1b98fbc0b101)>  (input #0)
    0x7fff5fbfd9c8: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfd9c0: [top + 8] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #5)
    0x7fff5fbfd9b8: [top + 0] <- 0xd6230daf4a1 ;  0xd6230daf4a1 <JS Function forEach (SharedFunctionInfo 0xc2bd2ae0d69)>  (input #6)
[deoptimizing (eager): end 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> @71 => node=16, pc=0x2c21d2687b00, caller sp=0x7fff5fbfda50, state=TOS_REGISTER, took 0.111 ms]
[deoptimizer unlinked: checkSourceElement / 130b7e1b6059]
[deoptimizing (DEOPT eager): begin 0x1030c9d3e2b1 <JS Function getSymbol (SharedFunctionInfo 0x2e2f693e7951)> (opt #529) @13, FP to SP delta: 40, caller sp: 0x7fff5fbfd488]
            ;;; deoptimize at 0_407: wrong map
  reading input frame getSymbol => node=96, args=4, height=3; inputs:
      0: 0x1030c9d3e2b1 ; [fp - 16] 0x1030c9d3e2b1 <JS Function getSymbol (SharedFunctionInfo 0x2e2f693e7951)>
      1: 0x1f9f6c0532e1 ; [fp + 40] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1030c9d624e1 ; [fp + 32] 0x1030c9d624e1 <an Object with map 0x33abe2a3d1a1>
      3: 0x2f05bb8a4641 ; [fp + 24] 0x2f05bb8a4641 <String[7]: Console>
      4: 0x801e000000000 ; [fp + 16] 524768
      5: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      6: 0x130b7e1bf0c1 ; rax 0x130b7e1bf0c1 <a SymbolObject with map 0x33abe2a73229>
      7: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
  translating frame getSymbol => node=96, height=16
    0x7fff5fbfd480: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd478: [top + 64] <- 0x1030c9d624e1 ;  0x1030c9d624e1 <an Object with map 0x33abe2a3d1a1>  (input #2)
    0x7fff5fbfd470: [top + 56] <- 0x2f05bb8a4641 ;  0x2f05bb8a4641 <String[7]: Console>  (input #3)
    0x7fff5fbfd468: [top + 48] <- 0x801e000000000 ;  524768  (input #4)
    0x7fff5fbfd460: [top + 40] <- 0x2c21d27469b8 ;  caller's pc
    0x7fff5fbfd458: [top + 32] <- 0x7fff5fbfd5c8 ;  caller's fp
    0x7fff5fbfd450: [top + 24] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #5)
    0x7fff5fbfd448: [top + 16] <- 0x1030c9d3e2b1 ;  function    0x1030c9d3e2b1 <JS Function getSymbol (SharedFunctionInfo 0x2e2f693e7951)>  (input #0)
    0x7fff5fbfd440: [top + 8] <- 0x130b7e1bf0c1 ;  0x130b7e1bf0c1 <a SymbolObject with map 0x33abe2a73229>  (input #6)
    0x7fff5fbfd438: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
[deoptimizing (eager): end 0x1030c9d3e2b1 <JS Function getSymbol (SharedFunctionInfo 0x2e2f693e7951)> @13 => node=96, pc=0x2c21d25e6c02, caller sp=0x7fff5fbfd488, state=NO_REGISTERS, took 0.072 ms]
[deoptimizing (DEOPT lazy): begin 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> (opt #392) @22, FP to SP delta: 192, caller sp: 0x7fff5fbfdbd8]
  reading input frame checkSourceElement => node=891, args=2, height=5; inputs:
      0: 0x130b7e1b6059 ; [fp - 16] 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2f05bb8e7291 ; [fp + 16] 0x2f05bb8e7291 <a NodeObject with map 0x33abe2a71339>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 31) 0x30bcea404311 <undefined>
      5: 0x30bcea4069a9 ; (literal 32) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      6: 0x30bcea4069a9 ; (literal 32) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x30bcea404311 ; rax 0x30bcea404311 <undefined>
  translating frame checkSourceElement => node=891, height=32
    0x7fff5fbfdbd0: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdbc8: [top + 64] <- 0x2f05bb8e7291 ;  0x2f05bb8e7291 <a NodeObject with map 0x33abe2a71339>  (input #2)
    0x7fff5fbfdbc0: [top + 56] <- 0x2c21d2207e55 ;  caller's pc
    0x7fff5fbfdbb8: [top + 48] <- 0x7fff5fbfdbf0 ;  caller's fp
    0x7fff5fbfdbb0: [top + 40] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdba8: [top + 32] <- 0x130b7e1b6059 ;  function    0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>  (input #0)
    0x7fff5fbfdba0: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfdb98: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #5)
    0x7fff5fbfdb90: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfdb88: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
[deoptimizing (lazy): end 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> @22 => node=891, pc=0x2c21d25ec702, caller sp=0x7fff5fbfdbd8, state=TOS_REGISTER, took 0.065 ms]
[deoptimizing (DEOPT lazy): begin 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> (opt #392) @38, FP to SP delta: 192, caller sp: 0x7fff5fbfdd80]
  reading input frame checkSourceElement => node=599, args=2, height=5; inputs:
      0: 0x130b7e1b6059 ; [fp - 16] 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2f05bb8cd2c1 ; [fp + 16] 0x2f05bb8cd2c1 <a NodeObject with map 0x33abe2a695c1>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 31) 0x30bcea404311 <undefined>
      5: 0x30bcea4069a9 ; (literal 32) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      6: 0x30bcea4069a9 ; (literal 32) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x30bcea404311 ; rax 0x30bcea404311 <undefined>
  translating frame checkSourceElement => node=599, height=32
    0x7fff5fbfdd78: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdd70: [top + 64] <- 0x2f05bb8cd2c1 ;  0x2f05bb8cd2c1 <a NodeObject with map 0x33abe2a695c1>  (input #2)
    0x7fff5fbfdd68: [top + 56] <- 0x2c21d2207e55 ;  caller's pc
    0x7fff5fbfdd60: [top + 48] <- 0x7fff5fbfdd98 ;  caller's fp
    0x7fff5fbfdd58: [top + 40] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdd50: [top + 32] <- 0x130b7e1b6059 ;  function    0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>  (input #0)
    0x7fff5fbfdd48: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfdd40: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #5)
    0x7fff5fbfdd38: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfdd30: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
[deoptimizing (lazy): end 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> @38 => node=599, pc=0x2c21d25ec423, caller sp=0x7fff5fbfdd80, state=TOS_REGISTER, took 0.072 ms]
[deoptimizing (DEOPT eager): begin 0x32c5a0de8379 <JS Function propertiesRelatedTo (SharedFunctionInfo 0x130b7e106e61)> (opt #435) @23, FP to SP delta: 136, caller sp: 0x7fff5fbfd9a0]
            ;;; deoptimize at 0_1240: wrong map
  reading input frame propertiesRelatedTo => node=281, args=4, height=14; inputs:
      0: 0x32c5a0de8379 ; [fp - 16] 0x32c5a0de8379 <JS Function propertiesRelatedTo (SharedFunctionInfo 0x130b7e106e61)>
      1: 0x1f9f6c0532e1 ; [fp + 40] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x32c5a0de7b79 ; [fp + 32] 0x32c5a0de7b79 <a TypeObject with map 0x33abe2a73599>
      3: 0x1ce442d2be99 ; [fp + 24] 0x1ce442d2be99 <a TypeObject with map 0x33abe2a73599>
      4: 0x30bcea4043b1 ; [fp + 16] 0x30bcea4043b1 <true>
      5: 0x32c5a0de7d61 ; [fp - 24] 0x32c5a0de7d61 <FixedArray[40]>
      6: -1 ; (int) [fp - 64] 
      7: 0x30bcea4069a9 ; (literal 10) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      8: 0x30bcea404421 ; rcx 0x30bcea404421 <false>
      9: 2 ; (int) [fp - 56] 
     10: 0x1ce442d2bf61 ; [fp - 40] 0x1ce442d2bf61 <JS Array[3]>
     11: 0x2069ac90e19 ; rbx 0x2069ac90e19 <a SymbolObject with map 0x33abe2a74cf9>
     12: 0x130b7e1bc789 ; rax 0x130b7e1bc789 <a SymbolObject with map 0x33abe2a6fb29>
     13: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
     14: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
     15: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
     16: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
     17: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
     18: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
  translating frame propertiesRelatedTo => node=281, height=104
    0x7fff5fbfd998: [top + 160] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd990: [top + 152] <- 0x32c5a0de7b79 ;  0x32c5a0de7b79 <a TypeObject with map 0x33abe2a73599>  (input #2)
    0x7fff5fbfd988: [top + 144] <- 0x1ce442d2be99 ;  0x1ce442d2be99 <a TypeObject with map 0x33abe2a73599>  (input #3)
    0x7fff5fbfd980: [top + 136] <- 0x30bcea4043b1 ;  0x30bcea4043b1 <true>  (input #4)
    0x7fff5fbfd978: [top + 128] <- 0x2c21d262bb12 ;  caller's pc
    0x7fff5fbfd970: [top + 120] <- 0x7fff5fbfd9f0 ;  caller's fp
    0x7fff5fbfd968: [top + 112] <- 0x32c5a0de7d61 ;  context    0x32c5a0de7d61 <FixedArray[40]>  (input #5)
    0x7fff5fbfd960: [top + 104] <- 0x32c5a0de8379 ;  function    0x32c5a0de8379 <JS Function propertiesRelatedTo (SharedFunctionInfo 0x130b7e106e61)>  (input #0)
    0x7fff5fbfd958: [top + 96] <- 0xffffffff00000000 ;  -1  (input #6)
    0x7fff5fbfd950: [top + 88] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #7)
    0x7fff5fbfd948: [top + 80] <- 0x30bcea404421 ;  0x30bcea404421 <false>  (input #8)
    0x7fff5fbfd940: [top + 72] <- 0x200000000 ;  2  (input #9)
    0x7fff5fbfd938: [top + 64] <- 0x1ce442d2bf61 ;  0x1ce442d2bf61 <JS Array[3]>  (input #10)
    0x7fff5fbfd930: [top + 56] <- 0x2069ac90e19 ;  0x2069ac90e19 <a SymbolObject with map 0x33abe2a74cf9>  (input #11)
    0x7fff5fbfd928: [top + 48] <- 0x130b7e1bc789 ;  0x130b7e1bc789 <a SymbolObject with map 0x33abe2a6fb29>  (input #12)
    0x7fff5fbfd920: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #13)
    0x7fff5fbfd918: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #14)
    0x7fff5fbfd910: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #15)
    0x7fff5fbfd908: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #16)
    0x7fff5fbfd900: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #17)
    0x7fff5fbfd8f8: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #18)
[deoptimizing (eager): end 0x32c5a0de8379 <JS Function propertiesRelatedTo (SharedFunctionInfo 0x130b7e106e61)> @23 => node=281, pc=0x2c21d262d12b, caller sp=0x7fff5fbfd9a0, state=NO_REGISTERS, took 0.119 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d59311 <JS Function getDeclarationModifierFlagsFromSymbol (SharedFunctionInfo 0x1b98fbc04c81)> (opt #518) @2, FP to SP delta: 32, caller sp: 0x7fff5fbfd8f0]
            ;;; deoptimize at 0_26: wrong map
  reading input frame getDeclarationModifierFlagsFromSymbol => node=4, args=2, height=1; inputs:
      0: 0x1030c9d59311 ; [fp - 16] 0x1030c9d59311 <JS Function getDeclarationModifierFlagsFromSymbol (SharedFunctionInfo 0x1b98fbc04c81)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2069ac90e19 ; rax 0x2069ac90e19 <a SymbolObject with map 0x33abe2a74cf9>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
  translating frame getDeclarationModifierFlagsFromSymbol => node=4, height=0
    0x7fff5fbfd8e8: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd8e0: [top + 32] <- 0x2069ac90e19 ;  0x2069ac90e19 <a SymbolObject with map 0x33abe2a74cf9>  (input #2)
    0x7fff5fbfd8d8: [top + 24] <- 0x2c21d262d1e9 ;  caller's pc
    0x7fff5fbfd8d0: [top + 16] <- 0x7fff5fbfd970 ;  caller's fp
    0x7fff5fbfd8c8: [top + 8] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd8c0: [top + 0] <- 0x1030c9d59311 ;  function    0x1030c9d59311 <JS Function getDeclarationModifierFlagsFromSymbol (SharedFunctionInfo 0x1b98fbc04c81)>  (input #0)
[deoptimizing (eager): end 0x1030c9d59311 <JS Function getDeclarationModifierFlagsFromSymbol (SharedFunctionInfo 0x1b98fbc04c81)> @2 => node=4, pc=0x2c21d269af66, caller sp=0x7fff5fbfd8f0, state=NO_REGISTERS, took 0.074 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d3e3d1 <JS Function getDeclaredTypeOfClassOrInterface (SharedFunctionInfo 0x2e2f693eddd1)> (opt #416) @19, FP to SP delta: 128, caller sp: 0x7fff5fbfdbc0]
            ;;; deoptimize at 0_131: wrong map
  reading input frame getDeclaredTypeOfClassOrInterface => node=43, args=2, height=6; inputs:
      0: 0x1030c9d3e3d1 ; [fp - 16] 0x1030c9d3e3d1 <JS Function getDeclaredTypeOfClassOrInterface (SharedFunctionInfo 0x2e2f693eddd1)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1030c9d658b1 ; rcx 0x1030c9d658b1 <a SymbolObject with map 0x15b5a790ff11>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x2271e26e9bc1 ; rbx 0x2271e26e9bc1 <an Object with map 0x15b5a7907011>
      5: 0x30bcea404311 ; (literal 13) 0x30bcea404311 <undefined>
      6: 0x30bcea404311 ; (literal 13) 0x30bcea404311 <undefined>
      7: 0x30bcea404311 ; (literal 13) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; (literal 13) 0x30bcea404311 <undefined>
  translating frame getDeclaredTypeOfClassOrInterface => node=43, height=40
    0x7fff5fbfdbb8: [top + 80] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdbb0: [top + 72] <- 0x1030c9d658b1 ;  0x1030c9d658b1 <a SymbolObject with map 0x15b5a790ff11>  (input #2)
    0x7fff5fbfdba8: [top + 64] <- 0x2c21d26c5b45 ;  caller's pc
    0x7fff5fbfdba0: [top + 56] <- 0x7fff5fbfdc18 ;  caller's fp
    0x7fff5fbfdb98: [top + 48] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdb90: [top + 40] <- 0x1030c9d3e3d1 ;  function    0x1030c9d3e3d1 <JS Function getDeclaredTypeOfClassOrInterface (SharedFunctionInfo 0x2e2f693eddd1)>  (input #0)
    0x7fff5fbfdb88: [top + 32] <- 0x2271e26e9bc1 ;  0x2271e26e9bc1 <an Object with map 0x15b5a7907011>  (input #4)
    0x7fff5fbfdb80: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfdb78: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfdb70: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfdb68: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
[deoptimizing (eager): end 0x1030c9d3e3d1 <JS Function getDeclaredTypeOfClassOrInterface (SharedFunctionInfo 0x2e2f693eddd1)> @19 => node=43, pc=0x2c21d25e76c0, caller sp=0x7fff5fbfdbc0, state=NO_REGISTERS, took 0.131 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d3e4d9 <JS Function getOuterTypeParametersOfClassOrInterface (SharedFunctionInfo 0x2e2f693ed411)> (opt #402) @2, FP to SP delta: 32, caller sp: 0x7fff5fbfdb60]
            ;;; deoptimize at 0_47: wrong map
  reading input frame getOuterTypeParametersOfClassOrInterface => node=4, args=2, height=2; inputs:
      0: 0x1030c9d3e4d9 ; [fp - 16] 0x1030c9d3e4d9 <JS Function getOuterTypeParametersOfClassOrInterface (SharedFunctionInfo 0x2e2f693ed411)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1030c9d658b1 ; rax 0x1030c9d658b1 <a SymbolObject with map 0x15b5a790ff11>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
  translating frame getOuterTypeParametersOfClassOrInterface => node=4, height=8
    0x7fff5fbfdb58: [top + 48] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdb50: [top + 40] <- 0x1030c9d658b1 ;  0x1030c9d658b1 <a SymbolObject with map 0x15b5a790ff11>  (input #2)
    0x7fff5fbfdb48: [top + 32] <- 0x2c21d25e7796 ;  caller's pc
    0x7fff5fbfdb40: [top + 24] <- 0x7fff5fbfdba0 ;  caller's fp
    0x7fff5fbfdb38: [top + 16] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdb30: [top + 8] <- 0x1030c9d3e4d9 ;  function    0x1030c9d3e4d9 <JS Function getOuterTypeParametersOfClassOrInterface (SharedFunctionInfo 0x2e2f693ed411)>  (input #0)
    0x7fff5fbfdb28: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
[deoptimizing (eager): end 0x1030c9d3e4d9 <JS Function getOuterTypeParametersOfClassOrInterface (SharedFunctionInfo 0x2e2f693ed411)> @2 => node=4, pc=0x2c21d25e7e4a, caller sp=0x7fff5fbfdb60, state=NO_REGISTERS, took 0.090 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d444e9 <JS Function getTypeOfFuncClassEnumModule (SharedFunctionInfo 0x2e2f693ecc91)> (opt #548) @16, FP to SP delta: 80, caller sp: 0x7fff5fbfdc00]
            ;;; deoptimize at 0_81: Unknown map in polymorphic access
  reading input frame getTypeOfFuncClassEnumModule => node=21, args=2, height=4; inputs:
      0: 0x1030c9d444e9 ; [fp - 16] 0x1030c9d444e9 <JS Function getTypeOfFuncClassEnumModule (SharedFunctionInfo 0x2e2f693ecc91)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1030c9d658b1 ; [fp + 16] 0x1030c9d658b1 <a SymbolObject with map 0x15b5a790ff11>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 11) 0x30bcea404311 <undefined>
      5: 0x30bcea404311 ; (literal 11) 0x30bcea404311 <undefined>
      6: 0x2271e26e9bc1 ; rax 0x2271e26e9bc1 <an Object with map 0x33abe2a72ba1>
  translating frame getTypeOfFuncClassEnumModule => node=21, height=24
    0x7fff5fbfdbf8: [top + 64] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdbf0: [top + 56] <- 0x1030c9d658b1 ;  0x1030c9d658b1 <a SymbolObject with map 0x15b5a790ff11>  (input #2)
    0x7fff5fbfdbe8: [top + 48] <- 0x2c21d261cde4 ;  caller's pc
    0x7fff5fbfdbe0: [top + 40] <- 0x7fff5fbfdc18 ;  caller's fp
    0x7fff5fbfdbd8: [top + 32] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdbd0: [top + 24] <- 0x1030c9d444e9 ;  function    0x1030c9d444e9 <JS Function getTypeOfFuncClassEnumModule (SharedFunctionInfo 0x2e2f693ecc91)>  (input #0)
    0x7fff5fbfdbc8: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfdbc0: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfdbb8: [top + 0] <- 0x2271e26e9bc1 ;  0x2271e26e9bc1 <an Object with map 0x33abe2a72ba1>  (input #6)
[deoptimizing (eager): end 0x1030c9d444e9 <JS Function getTypeOfFuncClassEnumModule (SharedFunctionInfo 0x2e2f693ecc91)> @16 => node=21, pc=0x2c21d261eb06, caller sp=0x7fff5fbfdc00, state=TOS_REGISTER, took 0.096 ms]
[deoptimizing (DEOPT eager): begin 0x130b7e1b5e01 <JS Function resolveStructuredTypeMembers (SharedFunctionInfo 0x2e2f693efe11)> (opt #534) @74, FP to SP delta: 248, caller sp: 0x7fff5fbfdb60]
            ;;; deoptimize at 1_61: Unknown map in polymorphic access
  reading input frame resolveStructuredTypeMembers => node=70, args=2, height=2; inputs:
      0: 0x130b7e1b5e01 ; [fp - 16] 0x130b7e1b5e01 <JS Function resolveStructuredTypeMembers (SharedFunctionInfo 0x2e2f693efe11)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x32c5a0de9799 ; rdi 0x32c5a0de9799 <a TypeObject with map 0x33abe2a72fc1>
      3: 0x130b7e1b3d29 ; rax 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x1030c9d44df1 ; rbx 0x1030c9d44df1 <JS Function resolveTypeReferenceMembers (SharedFunctionInfo 0x2e2f693eee51)>
  reading input frame resolveTypeReferenceMembers => node=3, args=2, height=4; inputs:
      0: 0x1030c9d44df1 ; (literal 23) 0x1030c9d44df1 <JS Function resolveTypeReferenceMembers (SharedFunctionInfo 0x2e2f693eee51)>
      1: 0x1f9f6c0532e1 ; (literal 16) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x32c5a0de9799 ; rdi 0x32c5a0de9799 <a TypeObject with map 0x33abe2a72fc1>
      3: 0x130b7e1b3d29 ; (literal 17) 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 18) 0x30bcea404311 <undefined>
      5: 0x30bcea404311 ; (literal 18) 0x30bcea404311 <undefined>
      6: 0x30bcea404311 ; (literal 18) 0x30bcea404311 <undefined>
  translating frame resolveStructuredTypeMembers => node=70, height=8
    0x7fff5fbfdb58: [top + 48] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdb50: [top + 40] <- 0x32c5a0de9799 ;  0x32c5a0de9799 <a TypeObject with map 0x33abe2a72fc1>  (input #2)
    0x7fff5fbfdb48: [top + 32] <- 0x2c21d2687617 ;  caller's pc
    0x7fff5fbfdb40: [top + 24] <- 0x7fff5fbfdba0 ;  caller's fp
    0x7fff5fbfdb38: [top + 16] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdb30: [top + 8] <- 0x130b7e1b5e01 ;  function    0x130b7e1b5e01 <JS Function resolveStructuredTypeMembers (SharedFunctionInfo 0x2e2f693efe11)>  (input #0)
    0x7fff5fbfdb28: [top + 0] <- 0x1030c9d44df1 ;  0x1030c9d44df1 <JS Function resolveTypeReferenceMembers (SharedFunctionInfo 0x2e2f693eee51)>  (input #4)
  translating frame resolveTypeReferenceMembers => node=3, height=24
    0x7fff5fbfdb20: [top + 64] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdb18: [top + 56] <- 0x32c5a0de9799 ;  0x32c5a0de9799 <a TypeObject with map 0x33abe2a72fc1>  (input #2)
    0x7fff5fbfdb10: [top + 48] <- 0x2c21d260d615 ;  caller's pc
    0x7fff5fbfdb08: [top + 40] <- 0x7fff5fbfdb40 ;  caller's fp
    0x7fff5fbfdb00: [top + 32] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdaf8: [top + 24] <- 0x1030c9d44df1 ;  function    0x1030c9d44df1 <JS Function resolveTypeReferenceMembers (SharedFunctionInfo 0x2e2f693eee51)>  (input #0)
    0x7fff5fbfdaf0: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfdae8: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfdae0: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
[deoptimizing (eager): end 0x130b7e1b5e01 <JS Function resolveStructuredTypeMembers (SharedFunctionInfo 0x2e2f693efe11)> @74 => node=3, pc=0x2c21d262e0ad, caller sp=0x7fff5fbfdb60, state=NO_REGISTERS, took 0.164 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d455f1 <JS Function isIndependentMember (SharedFunctionInfo 0x2e2f693ee851)> (opt #546) @8, FP to SP delta: 72, caller sp: 0x7fff5fbfd9b0]
            ;;; deoptimize at 0_218: wrong map
  reading input frame isIndependentMember => node=74, args=2, height=3; inputs:
      0: 0x1030c9d455f1 ; [fp - 16] 0x1030c9d455f1 <JS Function isIndependentMember (SharedFunctionInfo 0x2e2f693ee851)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1030c9d68a19 ; rax 0x1030c9d68a19 <a SymbolObject with map 0x33abe2a6fb29>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
      5: 0x2f05bb8e0a99 ; rbx 0x2f05bb8e0a99 <a NodeObject with map 0x33abe2a71911>
  translating frame isIndependentMember => node=74, height=16
    0x7fff5fbfd9a8: [top + 56] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd9a0: [top + 48] <- 0x1030c9d68a19 ;  0x1030c9d68a19 <a SymbolObject with map 0x33abe2a6fb29>  (input #2)
    0x7fff5fbfd998: [top + 40] <- 0x2c21d262ec40 ;  caller's pc
    0x7fff5fbfd990: [top + 32] <- 0x7fff5fbfd9f8 ;  caller's fp
    0x7fff5fbfd988: [top + 24] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd980: [top + 16] <- 0x1030c9d455f1 ;  function    0x1030c9d455f1 <JS Function isIndependentMember (SharedFunctionInfo 0x2e2f693ee851)>  (input #0)
    0x7fff5fbfd978: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfd970: [top + 0] <- 0x2f05bb8e0a99 ;  0x2f05bb8e0a99 <a NodeObject with map 0x33abe2a71911>  (input #5)
[deoptimizing (eager): end 0x1030c9d455f1 <JS Function isIndependentMember (SharedFunctionInfo 0x2e2f693ee851)> @8 => node=74, pc=0x2c21d2632032, caller sp=0x7fff5fbfd9b0, state=NO_REGISTERS, took 0.096 ms]
[deoptimizing (DEOPT eager): begin 0x130b7e1b6589 <JS Function getBaseTypes (SharedFunctionInfo 0x2e2f693eda11)> (opt #468) @4, FP to SP delta: 24, caller sp: 0x7fff5fbfda28]
            ;;; deoptimize at 0_76: wrong map
  reading input frame getBaseTypes => node=6, args=2, height=1; inputs:
      0: 0x130b7e1b6589 ; [fp - 16] 0x130b7e1b6589 <JS Function getBaseTypes (SharedFunctionInfo 0x2e2f693eda11)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x32c5a0de9799 ; rax 0x32c5a0de9799 <a TypeObject with map 0x33abe2a75539>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
  translating frame getBaseTypes => node=6, height=0
    0x7fff5fbfda20: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfda18: [top + 32] <- 0x32c5a0de9799 ;  0x32c5a0de9799 <a TypeObject with map 0x33abe2a75539>  (input #2)
    0x7fff5fbfda10: [top + 24] <- 0x2c21d260f4e6 ;  caller's pc
    0x7fff5fbfda08: [top + 16] <- 0x7fff5fbfdaa0 ;  caller's fp
    0x7fff5fbfda00: [top + 8] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd9f8: [top + 0] <- 0x130b7e1b6589 ;  function    0x130b7e1b6589 <JS Function getBaseTypes (SharedFunctionInfo 0x2e2f693eda11)>  (input #0)
[deoptimizing (eager): end 0x130b7e1b6589 <JS Function getBaseTypes (SharedFunctionInfo 0x2e2f693eda11)> @4 => node=6, pc=0x2c21d260b127, caller sp=0x7fff5fbfda28, state=NO_REGISTERS, took 0.088 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d421e1 <JS Function checkMethodDeclaration (SharedFunctionInfo 0x1b98fbc0aa41)> (opt #464) @5, FP to SP delta: 32, caller sp: 0x7fff5fbfdc18]
            ;;; deoptimize at 0_118: wrong map
  reading input frame checkMethodDeclaration => node=7, args=2, height=1; inputs:
      0: 0x1030c9d421e1 ; [fp - 16] 0x1030c9d421e1 <JS Function checkMethodDeclaration (SharedFunctionInfo 0x1b98fbc0aa41)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2f05bb8e0a99 ; rdx 0x2f05bb8e0a99 <a NodeObject with map 0x33abe2a71911>
      3: 0x130b7e1b3d29 ; rax 0x130b7e1b3d29 <FixedArray[1022]>
  translating frame checkMethodDeclaration => node=7, height=0
    0x7fff5fbfdc10: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdc08: [top + 32] <- 0x2f05bb8e0a99 ;  0x2f05bb8e0a99 <a NodeObject with map 0x33abe2a71911>  (input #2)
    0x7fff5fbfdc00: [top + 24] <- 0x2c21d25ec11a ;  caller's pc
    0x7fff5fbfdbf8: [top + 16] <- 0x7fff5fbfdc48 ;  caller's fp
    0x7fff5fbfdbf0: [top + 8] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdbe8: [top + 0] <- 0x1030c9d421e1 ;  function    0x1030c9d421e1 <JS Function checkMethodDeclaration (SharedFunctionInfo 0x1b98fbc0aa41)>  (input #0)
[deoptimizing (eager): end 0x1030c9d421e1 <JS Function checkMethodDeclaration (SharedFunctionInfo 0x1b98fbc0aa41)> @5 => node=7, pc=0x2c21d26115cf, caller sp=0x7fff5fbfdc18, state=NO_REGISTERS, took 0.053 ms]
[deoptimizing (DEOPT eager): begin 0x130b7e1b6811 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)> (opt #549) @88, FP to SP delta: 320, caller sp: 0x7fff5fbfd6d0]
            ;;; deoptimize at 0_7760: Unknown map in polymorphic access
  reading input frame resolveName => node=1143, args=6, height=20; inputs:
      0: 0x130b7e1b6811 ; [fp - 16] 0x130b7e1b6811 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)>
      1: 0x1f9f6c0532e1 ; [fp + 56] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2f05bb8cd3c1 ; [fp - 40] 0x2f05bb8cd3c1 <a NodeObject with map 0x33abe2a71289>
      3: 0x2f05bb888c11 ; [fp + 40] 0x2f05bb888c11 <String[8]: Function>
      4: 0xc19e800000000 ; [fp + 32] 793064
      5: 0xd6230ded3a9 ; [fp + 24] 0xd6230ded3a9 <an Object with map 0x33abe2a3df61>
      6: 0x2f05bb8ffcb1 ; [fp + 16] 0x2f05bb8ffcb1 <an IdentifierObject with map 0x33abe2a6fb81>
      7: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      8: 0x30bcea4069a9 ; (literal 14) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      9: 0x30bcea4069a9 ; (literal 14) 0x30bcea4069a9 <Odd Oddball: optimized_out>
     10: 0x2f05bb8e0a99 ; [fp - 64] 0x2f05bb8e0a99 <a NodeObject with map 0x33abe2a71911>
     11: 0x30bcea404311 ; [fp - 56] 0x30bcea404311 <undefined>
     12: 0x2f05bb8ffcb1 ; [fp + 48] 0x2f05bb8ffcb1 <an IdentifierObject with map 0x33abe2a6fb81>
     13: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     14: 0x30bcea404421 ; [fp - 48] 0x30bcea404421 <false>
     15: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     16: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     17: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     18: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     19: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     20: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     21: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     22: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     23: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     24: 0x1030c9d3e2b1 ; rdx 0x1030c9d3e2b1 <JS Function getSymbol (SharedFunctionInfo 0x2e2f693e7951)>
     25: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     26: 0x1030c9d658b1 ; rcx 0x1030c9d658b1 <a SymbolObject with map 0x15b5a790ff11>
  translating frame resolveName => node=1143, height=152
    0x7fff5fbfd6c8: [top + 224] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd6c0: [top + 216] <- 0x2f05bb8cd3c1 ;  0x2f05bb8cd3c1 <a NodeObject with map 0x33abe2a71289>  (input #2)
    0x7fff5fbfd6b8: [top + 208] <- 0x2f05bb888c11 ;  0x2f05bb888c11 <String[8]: Function>  (input #3)
    0x7fff5fbfd6b0: [top + 200] <- 0xc19e800000000 ;  793064  (input #4)
    0x7fff5fbfd6a8: [top + 192] <- 0xd6230ded3a9 ;  0xd6230ded3a9 <an Object with map 0x33abe2a3df61>  (input #5)
    0x7fff5fbfd6a0: [top + 184] <- 0x2f05bb8ffcb1 ;  0x2f05bb8ffcb1 <an IdentifierObject with map 0x33abe2a6fb81>  (input #6)
    0x7fff5fbfd698: [top + 176] <- 0x2c21d26139a6 ;  caller's pc
    0x7fff5fbfd690: [top + 168] <- 0x7fff5fbfd710 ;  caller's fp
    0x7fff5fbfd688: [top + 160] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #7)
    0x7fff5fbfd680: [top + 152] <- 0x130b7e1b6811 ;  function    0x130b7e1b6811 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)>  (input #0)
    0x7fff5fbfd678: [top + 144] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #8)
    0x7fff5fbfd670: [top + 136] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #9)
    0x7fff5fbfd668: [top + 128] <- 0x2f05bb8e0a99 ;  0x2f05bb8e0a99 <a NodeObject with map 0x33abe2a71911>  (input #10)
    0x7fff5fbfd660: [top + 120] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #11)
    0x7fff5fbfd658: [top + 112] <- 0x2f05bb8ffcb1 ;  0x2f05bb8ffcb1 <an IdentifierObject with map 0x33abe2a6fb81>  (input #12)
    0x7fff5fbfd650: [top + 104] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #13)
    0x7fff5fbfd648: [top + 96] <- 0x30bcea404421 ;  0x30bcea404421 <false>  (input #14)
    0x7fff5fbfd640: [top + 88] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #15)
    0x7fff5fbfd638: [top + 80] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #16)
    0x7fff5fbfd630: [top + 72] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #17)
    0x7fff5fbfd628: [top + 64] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #18)
    0x7fff5fbfd620: [top + 56] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #19)
    0x7fff5fbfd618: [top + 48] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #20)
    0x7fff5fbfd610: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #21)
    0x7fff5fbfd608: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #22)
    0x7fff5fbfd600: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #23)
    0x7fff5fbfd5f8: [top + 16] <- 0x1030c9d3e2b1 ;  0x1030c9d3e2b1 <JS Function getSymbol (SharedFunctionInfo 0x2e2f693e7951)>  (input #24)
    0x7fff5fbfd5f0: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #25)
    0x7fff5fbfd5e8: [top + 0] <- 0x1030c9d658b1 ;  0x1030c9d658b1 <a SymbolObject with map 0x15b5a790ff11>  (input #26)
[deoptimizing (eager): end 0x130b7e1b6811 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)> @88 => node=1143, pc=0x2c21d25e5863, caller sp=0x7fff5fbfd6d0, state=TOS_REGISTER, took 1.108 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d3ff99 <JS Function checkFunctionOrMethodDeclaration (SharedFunctionInfo 0x1b98fbc0c0c1)> (opt #506) @45, FP to SP delta: 152, caller sp: 0x7fff5fbfdbe0]
            ;;; deoptimize at 0_2195: wrong map
  reading input frame checkFunctionOrMethodDeclaration => node=298, args=2, height=8; inputs:
      0: 0x1030c9d3ff99 ; [fp - 16] 0x1030c9d3ff99 <JS Function checkFunctionOrMethodDeclaration (SharedFunctionInfo 0x1b98fbc0c0c1)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2f05bb8e0a99 ; [fp + 16] 0x2f05bb8e0a99 <a NodeObject with map 0x33abe2a71911>
      3: 0x32c5a0dec229 ; rdx 0x32c5a0dec229 <FixedArray[5]>
      4: 0x30bcea404421 ; [fp - 40] 0x30bcea404421 <false>
      5: 0x1030c9d68a19 ; [fp - 80] 0x1030c9d68a19 <a SymbolObject with map 0x33abe2a6fb29>
      6: 0x30bcea4069a9 ; (literal 12) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x2f05bb8e0a99 ; [fp - 120] 0x2f05bb8e0a99 <a NodeObject with map 0x33abe2a71911>
      8: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
      9: 0x16f3adb61821 ; [fp - 128] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
     10: 0xd6230dcf7e9 ; rbx 0xd6230dcf7e9 <JS Function getDeclarationOfKind (SharedFunctionInfo 0x3504a53cb519)>
  translating frame checkFunctionOrMethodDeclaration => node=298, height=56
    0x7fff5fbfdbd8: [top + 96] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdbd0: [top + 88] <- 0x2f05bb8e0a99 ;  0x2f05bb8e0a99 <a NodeObject with map 0x33abe2a71911>  (input #2)
    0x7fff5fbfdbc8: [top + 80] <- 0x2c21d2611641 ;  caller's pc
    0x7fff5fbfdbc0: [top + 72] <- 0x7fff5fbfdbf8 ;  caller's fp
    0x7fff5fbfdbb8: [top + 64] <- 0x32c5a0dec229 ;  context    0x32c5a0dec229 <FixedArray[5]>  (input #3)
    0x7fff5fbfdbb0: [top + 56] <- 0x1030c9d3ff99 ;  function    0x1030c9d3ff99 <JS Function checkFunctionOrMethodDeclaration (SharedFunctionInfo 0x1b98fbc0c0c1)>  (input #0)
    0x7fff5fbfdba8: [top + 48] <- 0x30bcea404421 ;  0x30bcea404421 <false>  (input #4)
    0x7fff5fbfdba0: [top + 40] <- 0x1030c9d68a19 ;  0x1030c9d68a19 <a SymbolObject with map 0x33abe2a6fb29>  (input #5)
    0x7fff5fbfdb98: [top + 32] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfdb90: [top + 24] <- 0x2f05bb8e0a99 ;  0x2f05bb8e0a99 <a NodeObject with map 0x33abe2a71911>  (input #7)
    0x7fff5fbfdb88: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfdb80: [top + 8] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #9)
    0x7fff5fbfdb78: [top + 0] <- 0xd6230dcf7e9 ;  0xd6230dcf7e9 <JS Function getDeclarationOfKind (SharedFunctionInfo 0x3504a53cb519)>  (input #10)
[deoptimizing (eager): end 0x1030c9d3ff99 <JS Function checkFunctionOrMethodDeclaration (SharedFunctionInfo 0x1b98fbc0c0c1)> @45 => node=298, pc=0x2c21d25fc76d, caller sp=0x7fff5fbfdbe0, state=TOS_REGISTER, took 0.100 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:hasQuestionToken) id{550,0} ---
(node) {
        if (node) {
            switch (node.kind) {
                case 144 /* Parameter */:
                case 149 /* MethodDeclaration */:
                case 148 /* MethodSignature */:
                case 258 /* ShorthandPropertyAssignment */:
                case 257 /* PropertyAssignment */:
                case 147 /* PropertyDeclaration */:
                case 146 /* PropertySignature */:
                    return node.questionToken !== undefined;
            }
        }
        return false;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:needCollisionCheckForIdentifier) id{551,0} ---
(node, identifier, name) {
            if (!(identifier && identifier.text === name)) {
                return false;
            }
            if (node.kind === 147 /* PropertyDeclaration */ ||
                node.kind === 146 /* PropertySignature */ ||
                node.kind === 149 /* MethodDeclaration */ ||
                node.kind === 148 /* MethodSignature */ ||
                node.kind === 151 /* GetAccessor */ ||
                node.kind === 152 /* SetAccessor */) {
                // it is ok to have member named '_super' or '_this' - member access is always qualified
                return false;
            }
            if (ts.isInAmbientContext(node)) {
                // ambient context - no codegen impact
                return false;
            }
            var root = ts.getRootDeclaration(node);
            if (root.kind === 144 /* Parameter */ && ts.nodeIsMissing(root.parent.body)) {
                // just an overload - no codegen impact
                return false;
            }
            return true;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbol) id{552,0} ---
(symbols, name, meaning) {
            if (meaning) {
                var symbol = symbols[name];
                if (symbol) {
                    ts.Debug.assert((symbol.flags & 16777216 /* Instantiated */) === 0, "Should never get an instantiated symbol here.");
                    if (symbol.flags & meaning) {
                        return symbol;
                    }
                    if (symbol.flags & 8388608 /* Alias */) {
                        var target = resolveAlias(symbol);
                        // Unknown symbol means an error occurred in alias resolution, treat it as positive answer to avoid cascading errors
                        if (target === unknownSymbol || target.flags & meaning) {
                            return symbol;
                        }
                    }
                }
            }
            // return undefined if we can't find a symbol.
        }
--- END ---
[deoptimizing (DEOPT eager): begin 0x1030c9d3ca21 <JS Function checkInheritedPropertiesAreIdentical (SharedFunctionInfo 0x1b98fbc0f241)> (opt #514) @85, FP to SP delta: 352, caller sp: 0x7fff5fbfdcc0]
            ;;; deoptimize at 0_240: Unknown map in polymorphic access
  reading input frame checkInheritedPropertiesAreIdentical => node=142, args=3, height=18; inputs:
      0: 0x1030c9d3ca21 ; [fp - 16] 0x1030c9d3ca21 <JS Function checkInheritedPropertiesAreIdentical (SharedFunctionInfo 0x1b98fbc0f241)>
      1: 0x1f9f6c0532e1 ; [fp + 32] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x3d89260063d1 ; [fp + 24] 0x3d89260063d1 <a TypeObject with map 0x33abe2a74461>
      3: 0x2f05bb8d57d9 ; [fp + 16] 0x2f05bb8d57d9 <an IdentifierObject with map 0x33abe2a6fb81>
      4: 0x3d8926006799 ; [fp - 24] 0x3d8926006799 <FixedArray[6]>
      5: 0x3d89260068a9 ; [fp - 32] 0x3d89260068a9 <JS Array[2]>
      6: 0x30bcea404311 ; (literal 25) 0x30bcea404311 <undefined>
      7: 0x30bcea404311 ; (literal 25) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; (literal 25) 0x30bcea404311 <undefined>
      9: 0x30bcea404311 ; (literal 25) 0x30bcea404311 <undefined>
     10: 0x30bcea404311 ; (literal 25) 0x30bcea404311 <undefined>
     11: 0x30bcea404311 ; (literal 25) 0x30bcea404311 <undefined>
     12: 0x30bcea404311 ; (literal 25) 0x30bcea404311 <undefined>
     13: 0x30bcea404311 ; (literal 25) 0x30bcea404311 <undefined>
     14: 0x30bcea404311 ; (literal 25) 0x30bcea404311 <undefined>
     15: 0x30bcea404311 ; (literal 25) 0x30bcea404311 <undefined>
     16: 0x30bcea404311 ; (literal 25) 0x30bcea404311 <undefined>
     17: 0x30bcea404311 ; (literal 25) 0x30bcea404311 <undefined>
     18: 0x30bcea404311 ; (literal 25) 0x30bcea404311 <undefined>
     19: 0xd6230daf4a1 ; [fp - 56] 0xd6230daf4a1 <JS Function forEach (SharedFunctionInfo 0xc2bd2ae0d69)>
     20: 0x16f3adb61821 ; [fp - 48] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
     21: 0x3d89260063d1 ; rax 0x3d89260063d1 <a TypeObject with map 0x33abe2a74461>
  translating frame checkInheritedPropertiesAreIdentical => node=142, height=136
    0x7fff5fbfdcb8: [top + 184] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdcb0: [top + 176] <- 0x3d89260063d1 ;  0x3d89260063d1 <a TypeObject with map 0x33abe2a74461>  (input #2)
    0x7fff5fbfdca8: [top + 168] <- 0x2f05bb8d57d9 ;  0x2f05bb8d57d9 <an IdentifierObject with map 0x33abe2a6fb81>  (input #3)
    0x7fff5fbfdca0: [top + 160] <- 0x2c21d26090d7 ;  caller's pc
    0x7fff5fbfdc98: [top + 152] <- 0x7fff5fbfdd10 ;  caller's fp
    0x7fff5fbfdc90: [top + 144] <- 0x3d8926006799 ;  context    0x3d8926006799 <FixedArray[6]>  (input #4)
    0x7fff5fbfdc88: [top + 136] <- 0x1030c9d3ca21 ;  function    0x1030c9d3ca21 <JS Function checkInheritedPropertiesAreIdentical (SharedFunctionInfo 0x1b98fbc0f241)>  (input #0)
    0x7fff5fbfdc80: [top + 128] <- 0x3d89260068a9 ;  0x3d89260068a9 <JS Array[2]>  (input #5)
    0x7fff5fbfdc78: [top + 120] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfdc70: [top + 112] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfdc68: [top + 104] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfdc60: [top + 96] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
    0x7fff5fbfdc58: [top + 88] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #10)
    0x7fff5fbfdc50: [top + 80] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #11)
    0x7fff5fbfdc48: [top + 72] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #12)
    0x7fff5fbfdc40: [top + 64] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #13)
    0x7fff5fbfdc38: [top + 56] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #14)
    0x7fff5fbfdc30: [top + 48] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #15)
    0x7fff5fbfdc28: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #16)
    0x7fff5fbfdc20: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #17)
    0x7fff5fbfdc18: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #18)
    0x7fff5fbfdc10: [top + 16] <- 0xd6230daf4a1 ;  0xd6230daf4a1 <JS Function forEach (SharedFunctionInfo 0xc2bd2ae0d69)>  (input #19)
    0x7fff5fbfdc08: [top + 8] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #20)
    0x7fff5fbfdc00: [top + 0] <- 0x3d89260063d1 ;  0x3d89260063d1 <a TypeObject with map 0x33abe2a74461>  (input #21)
[deoptimizing (eager): end 0x1030c9d3ca21 <JS Function checkInheritedPropertiesAreIdentical (SharedFunctionInfo 0x1b98fbc0f241)> @85 => node=142, pc=0x2c21d260a86d, caller sp=0x7fff5fbfdcc0, state=TOS_REGISTER, took 0.135 ms]
[deoptimizing (DEOPT eager): begin 0x3d892600b631 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)> (opt #539) @79, FP to SP delta: 304, caller sp: 0x7fff5fbfdb90]
            ;;; deoptimize at 0_10490: wrong map
  reading input frame isRelatedTo => node=1853, args=5, height=9; inputs:
      0: 0x3d892600b631 ; [fp - 16] 0x3d892600b631 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)>
      1: 0x1f9f6c0532e1 ; [fp + 48] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x3d89260066a1 ; rax 0x3d89260066a1 <a TypeObject with map 0x33abe2a73179>
      3: 0x3d8926006f19 ; rcx 0x3d8926006f19 <a TypeObject with map 0x33abe2a746c9>
      4: 0x30bcea4043b1 ; [fp + 24] 0x30bcea4043b1 <true>
      5: 0xd6230df7599 ; [fp + 16] 0xd6230df7599 <an Object with map 0x33abe2a3df61>
      6: 0x3d892600b3c1 ; [fp - 24] 0x3d892600b3c1 <FixedArray[40]>
      7: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; [fp - 64] 0x30bcea404311 <undefined>
      9: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     10: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     11: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     12: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     13: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     14: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
  translating frame isRelatedTo => node=1853, height=64
    0x7fff5fbfdb88: [top + 128] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdb80: [top + 120] <- 0x3d89260066a1 ;  0x3d89260066a1 <a TypeObject with map 0x33abe2a73179>  (input #2)
    0x7fff5fbfdb78: [top + 112] <- 0x3d8926006f19 ;  0x3d8926006f19 <a TypeObject with map 0x33abe2a746c9>  (input #3)
    0x7fff5fbfdb70: [top + 104] <- 0x30bcea4043b1 ;  0x30bcea4043b1 <true>  (input #4)
    0x7fff5fbfdb68: [top + 96] <- 0xd6230df7599 ;  0xd6230df7599 <an Object with map 0x33abe2a3df61>  (input #5)
    0x7fff5fbfdb60: [top + 88] <- 0x2c21d2649a8d ;  caller's pc
    0x7fff5fbfdb58: [top + 80] <- 0x7fff5fbfdbd0 ;  caller's fp
    0x7fff5fbfdb50: [top + 72] <- 0x3d892600b3c1 ;  context    0x3d892600b3c1 <FixedArray[40]>  (input #6)
    0x7fff5fbfdb48: [top + 64] <- 0x3d892600b631 ;  function    0x3d892600b631 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)>  (input #0)
    0x7fff5fbfdb40: [top + 56] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfdb38: [top + 48] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfdb30: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
    0x7fff5fbfdb28: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #10)
    0x7fff5fbfdb20: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #11)
    0x7fff5fbfdb18: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #12)
    0x7fff5fbfdb10: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #13)
    0x7fff5fbfdb08: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #14)
[deoptimizing (eager): end 0x3d892600b631 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)> @79 => node=1853, pc=0x2c21d2629dc1, caller sp=0x7fff5fbfdb90, state=NO_REGISTERS, took 0.092 ms]
[deoptimizing (DEOPT eager): begin 0x130b7e1b65d1 <JS Function instantiateTypes (SharedFunctionInfo 0x2e2f693f5701)> (opt #547) @4, FP to SP delta: 56, caller sp: 0x7fff5fbfcfa0]
            ;;; deoptimize at 1_62: wrong map
  reading input frame instantiateTypes => node=7, args=3, height=2; inputs:
      0: 0x130b7e1b65d1 ; [fp - 16] 0x130b7e1b65d1 <JS Function instantiateTypes (SharedFunctionInfo 0x2e2f693f5701)>
      1: 0x1f9f6c0532e1 ; [fp + 32] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x32c5a0df8e51 ; r8 0x32c5a0df8e51 <JS Array[2]>
      3: 0x32c5a0df61f9 ; [fp + 16] 0x32c5a0df61f9 <JS Function (SharedFunctionInfo 0x371f85cf0581)>
      4: 0x130b7e1b3d29 ; rbx 0x130b7e1b3d29 <FixedArray[1022]>
      5: 0x1030c9d44191 ; rdx 0x1030c9d44191 <JS Function instantiateList (SharedFunctionInfo 0x2e2f693f5641)>
  reading input frame instantiateList => node=22, args=4, height=5; inputs:
      0: 0x1030c9d44191 ; (literal 3) 0x1030c9d44191 <JS Function instantiateList (SharedFunctionInfo 0x2e2f693f5641)>
      1: 0x1f9f6c0532e1 ; (literal 4) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x32c5a0df8e51 ; r8 0x32c5a0df8e51 <JS Array[2]>
      3: 0x32c5a0df61f9 ; [fp + 16] 0x32c5a0df61f9 <JS Function (SharedFunctionInfo 0x371f85cf0581)>
      4: 0x130b7e1b6661 ; rcx 0x130b7e1b6661 <JS Function instantiateType (SharedFunctionInfo 0x2e2f693f66c1)>
      5: 0x130b7e1b3d29 ; (literal 5) 0x130b7e1b3d29 <FixedArray[1022]>
      6: 0x30bcea404311 ; (literal 6) 0x30bcea404311 <undefined>
      7: 0x30bcea404311 ; (literal 6) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; (literal 6) 0x30bcea404311 <undefined>
      9: 0x30bcea404311 ; (literal 6) 0x30bcea404311 <undefined>
  translating frame instantiateTypes => node=7, height=8
    0x7fff5fbfcf98: [top + 56] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfcf90: [top + 48] <- 0x32c5a0df8e51 ;  0x32c5a0df8e51 <JS Array[2]>  (input #2)
    0x7fff5fbfcf88: [top + 40] <- 0x32c5a0df61f9 ;  0x32c5a0df61f9 <JS Function (SharedFunctionInfo 0x371f85cf0581)>  (input #3)
    0x7fff5fbfcf80: [top + 32] <- 0x2c21d261b397 ;  caller's pc
    0x7fff5fbfcf78: [top + 24] <- 0x7fff5fbfcfc8 ;  caller's fp
    0x7fff5fbfcf70: [top + 16] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #4)
    0x7fff5fbfcf68: [top + 8] <- 0x130b7e1b65d1 ;  function    0x130b7e1b65d1 <JS Function instantiateTypes (SharedFunctionInfo 0x2e2f693f5701)>  (input #0)
    0x7fff5fbfcf60: [top + 0] <- 0x1030c9d44191 ;  0x1030c9d44191 <JS Function instantiateList (SharedFunctionInfo 0x2e2f693f5641)>  (input #5)
  translating frame instantiateList => node=22, height=32
    0x7fff5fbfcf58: [top + 88] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfcf50: [top + 80] <- 0x32c5a0df8e51 ;  0x32c5a0df8e51 <JS Array[2]>  (input #2)
    0x7fff5fbfcf48: [top + 72] <- 0x32c5a0df61f9 ;  0x32c5a0df61f9 <JS Function (SharedFunctionInfo 0x371f85cf0581)>  (input #3)
    0x7fff5fbfcf40: [top + 64] <- 0x130b7e1b6661 ;  0x130b7e1b6661 <JS Function instantiateType (SharedFunctionInfo 0x2e2f693f66c1)>  (input #4)
    0x7fff5fbfcf38: [top + 56] <- 0x2c21d261c704 ;  caller's pc
    0x7fff5fbfcf30: [top + 48] <- 0x7fff5fbfcf78 ;  caller's fp
    0x7fff5fbfcf28: [top + 40] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #5)
    0x7fff5fbfcf20: [top + 32] <- 0x1030c9d44191 ;  function    0x1030c9d44191 <JS Function instantiateList (SharedFunctionInfo 0x2e2f693f5641)>  (input #0)
    0x7fff5fbfcf18: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfcf10: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfcf08: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfcf00: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
[deoptimizing (eager): end 0x130b7e1b65d1 <JS Function instantiateTypes (SharedFunctionInfo 0x2e2f693f5701)> @4 => node=22, pc=0x2c21d261c7ef, caller sp=0x7fff5fbfcfa0, state=NO_REGISTERS, took 0.118 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:indexTypesRelatedTo) id{553,0} ---
(source, originalSource, target, kind, reportErrors) {
                if (relation === identityRelation) {
                    return indexTypesIdenticalTo(source, target, kind);
                }
                var targetInfo = getIndexInfoOfType(target, kind);
                if (!targetInfo || ((targetInfo.type.flags & 1 /* Any */) && !(originalSource.flags & 8190 /* Primitive */))) {
                    // Index signature of type any permits assignment from everything but primitives
                    return -1 /* True */;
                }
                var sourceInfo = getIndexInfoOfType(source, kind) ||
                    kind === 1 /* Number */ && getIndexInfoOfType(source, 0 /* String */);
                if (sourceInfo) {
                    return indexInfoRelatedTo(sourceInfo, targetInfo, reportErrors);
                }
                if (isObjectLiteralType(source)) {
                    var related = -1 /* True */;
                    if (kind === 0 /* String */) {
                        var sourceNumberInfo = getIndexInfoOfType(source, 1 /* Number */);
                        if (sourceNumberInfo) {
                            related = indexInfoRelatedTo(sourceNumberInfo, targetInfo, reportErrors);
                        }
                    }
                    if (related) {
                        related &= eachPropertyRelatedTo(source, targetInfo.type, kind, reportErrors);
                    }
                    return related;
                }
                if (reportErrors) {
                    reportError(ts.Diagnostics.Index_signature_is_missing_in_type_0, typeToString(source));
                }
                return 0 /* False */;
            }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexInfoOfType) id{553,1} ---
(type, kind) {
            return getIndexInfoOfStructuredType(getApparentType(type), kind);
        }
--- END ---
INLINE (getIndexInfoOfType) id{553,1} AS 1 AT <0:231>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getApparentType) id{553,2} ---
(type) {
            var t = type.flags & 540672 /* TypeVariable */ ? getApparentTypeOfTypeVariable(type) : type;
            return t.flags & 262178 /* StringLike */ ? globalStringType :
                t.flags & 340 /* NumberLike */ ? globalNumberType :
                    t.flags & 136 /* BooleanLike */ ? globalBooleanType :
                        t.flags & 512 /* ESSymbol */ ? getGlobalESSymbolType() :
                            t;
        }
--- END ---
INLINE (getApparentType) id{553,2} AS 2 AT <1:63>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexInfoOfStructuredType) id{553,3} ---
(type, kind) {
            if (type.flags & 229376 /* StructuredType */) {
                var resolved = resolveStructuredTypeMembers(type);
                return kind === 0 /* String */ ? resolved.stringIndexInfo : resolved.numberIndexInfo;
            }
        }
--- END ---
INLINE (getIndexInfoOfStructuredType) id{553,3} AS 3 AT <1:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexInfoOfType) id{553,4} ---
(type, kind) {
            return getIndexInfoOfStructuredType(getApparentType(type), kind);
        }
--- END ---
INLINE (getIndexInfoOfType) id{553,4} AS 4 AT <0:587>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getApparentType) id{553,5} ---
(type) {
            var t = type.flags & 540672 /* TypeVariable */ ? getApparentTypeOfTypeVariable(type) : type;
            return t.flags & 262178 /* StringLike */ ? globalStringType :
                t.flags & 340 /* NumberLike */ ? globalNumberType :
                    t.flags & 136 /* BooleanLike */ ? globalBooleanType :
                        t.flags & 512 /* ESSymbol */ ? getGlobalESSymbolType() :
                            t;
        }
--- END ---
INLINE (getApparentType) id{553,5} AS 5 AT <4:63>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexInfoOfStructuredType) id{553,6} ---
(type, kind) {
            if (type.flags & 229376 /* StructuredType */) {
                var resolved = resolveStructuredTypeMembers(type);
                return kind === 0 /* String */ ? resolved.stringIndexInfo : resolved.numberIndexInfo;
            }
        }
--- END ---
INLINE (getIndexInfoOfStructuredType) id{553,6} AS 6 AT <4:34>
[deoptimizing (DEOPT eager): begin 0x1030c9d54e29 <JS Function getErasedSignature (SharedFunctionInfo 0x2e2f693f1791)> (opt #473) @4, FP to SP delta: 72, caller sp: 0x7fff5fbfd150]
            ;;; deoptimize at 0_117: Unknown map in polymorphic access
  reading input frame getErasedSignature => node=7, args=2, height=1; inputs:
      0: 0x1030c9d54e29 ; [fp - 16] 0x1030c9d54e29 <JS Function getErasedSignature (SharedFunctionInfo 0x2e2f693f1791)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x3d8926017629 ; rax 0x3d8926017629 <a SignatureObject with map 0x33abe2a76091>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
  translating frame getErasedSignature => node=7, height=0
    0x7fff5fbfd148: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd140: [top + 32] <- 0x3d8926017629 ;  0x3d8926017629 <a SignatureObject with map 0x33abe2a76091>  (input #2)
    0x7fff5fbfd138: [top + 24] <- 0x2c21d269c013 ;  caller's pc
    0x7fff5fbfd130: [top + 16] <- 0x7fff5fbfd1d8 ;  caller's fp
    0x7fff5fbfd128: [top + 8] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd120: [top + 0] <- 0x1030c9d54e29 ;  function    0x1030c9d54e29 <JS Function getErasedSignature (SharedFunctionInfo 0x2e2f693f1791)>  (input #0)
[deoptimizing (eager): end 0x1030c9d54e29 <JS Function getErasedSignature (SharedFunctionInfo 0x2e2f693f1791)> @4 => node=7, pc=0x2c21d269ccbe, caller sp=0x7fff5fbfd150, state=NO_REGISTERS, took 0.050 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d44fe1 <JS Function instantiateSymbol (SharedFunctionInfo 0x2e2f693f6181)> (opt #365) @2, FP to SP delta: 48, caller sp: 0x7fff5fbfcff8]
            ;;; deoptimize at 0_41: wrong map
  reading input frame instantiateSymbol => node=4, args=3, height=3; inputs:
      0: 0x1030c9d44fe1 ; [fp - 16] 0x1030c9d44fe1 <JS Function instantiateSymbol (SharedFunctionInfo 0x2e2f693f6181)>
      1: 0x1f9f6c0532e1 ; [fp + 32] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x3d89260174c9 ; rax 0x3d89260174c9 <a SymbolObject with map 0x33abe2a747d1>
      3: 0x3d8926017851 ; [fp + 16] 0x3d8926017851 <JS Function (SharedFunctionInfo 0x371f85cf0581)>
      4: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      5: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
      6: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
  translating frame instantiateSymbol => node=4, height=16
    0x7fff5fbfcff0: [top + 64] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfcfe8: [top + 56] <- 0x3d89260174c9 ;  0x3d89260174c9 <a SymbolObject with map 0x33abe2a747d1>  (input #2)
    0x7fff5fbfcfe0: [top + 48] <- 0x3d8926017851 ;  0x3d8926017851 <JS Function (SharedFunctionInfo 0x371f85cf0581)>  (input #3)
    0x7fff5fbfcfd8: [top + 40] <- 0x2c21d261c8bd ;  caller's pc
    0x7fff5fbfcfd0: [top + 32] <- 0x7fff5fbfd040 ;  caller's fp
    0x7fff5fbfcfc8: [top + 24] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #4)
    0x7fff5fbfcfc0: [top + 16] <- 0x1030c9d44fe1 ;  function    0x1030c9d44fe1 <JS Function instantiateSymbol (SharedFunctionInfo 0x2e2f693f6181)>  (input #0)
    0x7fff5fbfcfb8: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfcfb0: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
[deoptimizing (eager): end 0x1030c9d44fe1 <JS Function instantiateSymbol (SharedFunctionInfo 0x2e2f693f6181)> @2 => node=4, pc=0x2c21d262ee2c, caller sp=0x7fff5fbfcff8, state=NO_REGISTERS, took 0.055 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d448d9 <JS Function isSimpleTypeRelatedTo (SharedFunctionInfo 0x2e2f693f7981)> (opt #537) @6, FP to SP delta: 32, caller sp: 0x7fff5fbfd078]
            ;;; deoptimize at 0_295: wrong map
  reading input frame isSimpleTypeRelatedTo => node=74, args=5, height=1; inputs:
      0: 0x1030c9d448d9 ; [fp - 16] 0x1030c9d448d9 <JS Function isSimpleTypeRelatedTo (SharedFunctionInfo 0x2e2f693f7981)>
      1: 0x1f9f6c0532e1 ; [fp + 48] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1030c9d51889 ; [fp + 40] 0x1030c9d51889 <a TypeObject with map 0x33abe2a6cf81>
      3: 0x32c5a0dc7b01 ; rax 0x32c5a0dc7b01 <a TypeObject with map 0x33abe2a74989>
      4: 0x130b7e1b5f71 ; [fp + 24] 0x130b7e1b5f71 <an Object with map 0x33abe2a3d1a1>
      5: 0x30bcea404311 ; [fp + 16] 0x30bcea404311 <undefined>
      6: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
  translating frame isSimpleTypeRelatedTo => node=74, height=0
    0x7fff5fbfd070: [top + 64] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd068: [top + 56] <- 0x1030c9d51889 ;  0x1030c9d51889 <a TypeObject with map 0x33abe2a6cf81>  (input #2)
    0x7fff5fbfd060: [top + 48] <- 0x32c5a0dc7b01 ;  0x32c5a0dc7b01 <a TypeObject with map 0x33abe2a74989>  (input #3)
    0x7fff5fbfd058: [top + 40] <- 0x130b7e1b5f71 ;  0x130b7e1b5f71 <an Object with map 0x33abe2a3d1a1>  (input #4)
    0x7fff5fbfd050: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfd048: [top + 24] <- 0x2c21d2628965 ;  caller's pc
    0x7fff5fbfd040: [top + 16] <- 0x7fff5fbfd0d0 ;  caller's fp
    0x7fff5fbfd038: [top + 8] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #6)
    0x7fff5fbfd030: [top + 0] <- 0x1030c9d448d9 ;  function    0x1030c9d448d9 <JS Function isSimpleTypeRelatedTo (SharedFunctionInfo 0x2e2f693f7981)>  (input #0)
[deoptimizing (eager): end 0x1030c9d448d9 <JS Function isSimpleTypeRelatedTo (SharedFunctionInfo 0x2e2f693f7981)> @6 => node=74, pc=0x2c21d262a661, caller sp=0x7fff5fbfd078, state=NO_REGISTERS, took 0.073 ms]
[deoptimizing (DEOPT soft): begin 0x130b7e1b5e49 <JS Function getPropertyOfType (SharedFunctionInfo 0x2e2f693f0591)> (opt #439) @19, FP to SP delta: 64, caller sp: 0x7fff5fbfcf40]
            ;;; deoptimize at 0_365: Insufficient type feedback for combined type of binary operation
  reading input frame getPropertyOfType => node=104, args=3, height=4; inputs:
      0: 0x130b7e1b5e49 ; [fp - 16] 0x130b7e1b5e49 <JS Function getPropertyOfType (SharedFunctionInfo 0x2e2f693f0591)>
      1: 0x1f9f6c0532e1 ; [fp + 32] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1030c9d51f19 ; [fp - 48] 0x1030c9d51f19 <a TypeObject with map 0x33abe2a73f91>
      3: 0x2f05bb888b51 ; [fp + 16] 0x2f05bb888b51 <String[5]: write>
      4: 0x130b7e1b3d29 ; rax 0x130b7e1b3d29 <FixedArray[1022]>
      5: 0x1030c9d51f19 ; [fp - 56] 0x1030c9d51f19 <a TypeObject with map 0x33abe2a73f91>
      6: 0x30bcea4069a9 ; (literal 7) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x30bcea404311 ; (literal 3) 0x30bcea404311 <undefined>
  translating frame getPropertyOfType => node=104, height=24
    0x7fff5fbfcf38: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfcf30: [top + 64] <- 0x1030c9d51f19 ;  0x1030c9d51f19 <a TypeObject with map 0x33abe2a73f91>  (input #2)
    0x7fff5fbfcf28: [top + 56] <- 0x2f05bb888b51 ;  0x2f05bb888b51 <String[5]: write>  (input #3)
    0x7fff5fbfcf20: [top + 48] <- 0x2c21d262cf63 ;  caller's pc
    0x7fff5fbfcf18: [top + 40] <- 0x7fff5fbfcfc0 ;  caller's fp
    0x7fff5fbfcf10: [top + 32] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #4)
    0x7fff5fbfcf08: [top + 24] <- 0x130b7e1b5e49 ;  function    0x130b7e1b5e49 <JS Function getPropertyOfType (SharedFunctionInfo 0x2e2f693f0591)>  (input #0)
    0x7fff5fbfcf00: [top + 16] <- 0x1030c9d51f19 ;  0x1030c9d51f19 <a TypeObject with map 0x33abe2a73f91>  (input #5)
    0x7fff5fbfcef8: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfcef0: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
[deoptimizing (soft): end 0x130b7e1b5e49 <JS Function getPropertyOfType (SharedFunctionInfo 0x2e2f693f0591)> @19 => node=104, pc=0x2c21d262ffe9, caller sp=0x7fff5fbfcf40, state=NO_REGISTERS, took 0.065 ms]
[deoptimizing (DEOPT eager): begin 0xd6230db19c1 <JS Function getFullWidth (SharedFunctionInfo 0x3504a53cb759)> (opt #60) @2, FP to SP delta: 24, caller sp: 0x7fff5fbfcc50]
            ;;; deoptimize at 0_28: wrong map
  reading input frame getFullWidth => node=4, args=2, height=1; inputs:
      0: 0xd6230db19c1 ; [fp - 16] 0xd6230db19c1 <JS Function getFullWidth (SharedFunctionInfo 0x3504a53cb759)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2f05bb8a8da9 ; rax 0x2f05bb8a8da9 <an IdentifierObject with map 0x33abe2a6fb81>
      3: 0xd6230db34c9 ; [fp - 24] 0xd6230db34c9 <FixedArray[156]>
  translating frame getFullWidth => node=4, height=0
    0x7fff5fbfcc48: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfcc40: [top + 32] <- 0x2f05bb8a8da9 ;  0x2f05bb8a8da9 <an IdentifierObject with map 0x33abe2a6fb81>  (input #2)
    0x7fff5fbfcc38: [top + 24] <- 0x2c21d2752dd5 ;  caller's pc
    0x7fff5fbfcc30: [top + 16] <- 0x7fff5fbfcc68 ;  caller's fp
    0x7fff5fbfcc28: [top + 8] <- 0xd6230db34c9 ;  context    0xd6230db34c9 <FixedArray[156]>  (input #3)
    0x7fff5fbfcc20: [top + 0] <- 0xd6230db19c1 ;  function    0xd6230db19c1 <JS Function getFullWidth (SharedFunctionInfo 0x3504a53cb759)>  (input #0)
[deoptimizing (eager): end 0xd6230db19c1 <JS Function getFullWidth (SharedFunctionInfo 0x3504a53cb759)> @2 => node=4, pc=0x2c21d2426006, caller sp=0x7fff5fbfcc50, state=NO_REGISTERS, took 0.053 ms]
[deoptimizing (DEOPT eager): begin 0x130b7e1b67c9 <JS Function getTypeFromTypeNode (SharedFunctionInfo 0x2e2f693f5581)> (opt #400) @150, FP to SP delta: 320, caller sp: 0x7fff5fbfcef0]
            ;;; deoptimize at 1_75: wrong map
  reading input frame getTypeFromTypeNode => node=188, args=2, height=4; inputs:
      0: 0x130b7e1b67c9 ; [fp - 16] 0x130b7e1b67c9 <JS Function getTypeFromTypeNode (SharedFunctionInfo 0x2e2f693f5581)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2f05bb8ef651 ; [fp + 16] 0x2f05bb8ef651 <a NodeObject with map 0x33abe2a74c49>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea4069a9 ; (literal 28) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      5: 0x30bcea404311 ; (literal 27) 0x30bcea404311 <undefined>
      6: 0x1030c9d45b01 ; [fp - 296] 0x1030c9d45b01 <JS Function getTypeFromThisTypeNode (SharedFunctionInfo 0x2e2f693f54c1)>
  reading input frame getTypeFromThisTypeNode => node=18, args=2, height=3; inputs:
      0: 0x1030c9d45b01 ; (literal 47) 0x1030c9d45b01 <JS Function getTypeFromThisTypeNode (SharedFunctionInfo 0x2e2f693f54c1)>
      1: 0x1f9f6c0532e1 ; (literal 30) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2f05bb8ef651 ; [fp + 16] 0x2f05bb8ef651 <a NodeObject with map 0x33abe2a74c49>
      3: 0x130b7e1b3d29 ; (literal 31) 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 27) 0x30bcea404311 <undefined>
      5: 0x32c5a0decaa1 ; rax 0x32c5a0decaa1 <an Object with map 0x33abe2a73859>
  translating frame getTypeFromTypeNode => node=188, height=24
    0x7fff5fbfcee8: [top + 64] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfcee0: [top + 56] <- 0x2f05bb8ef651 ;  0x2f05bb8ef651 <a NodeObject with map 0x33abe2a74c49>  (input #2)
    0x7fff5fbfced8: [top + 48] <- 0x2c21d25696c7 ;  caller's pc
    0x7fff5fbfced0: [top + 40] <- 0x7fff5fbfcf18 ;  caller's fp
    0x7fff5fbfcec8: [top + 32] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfcec0: [top + 24] <- 0x130b7e1b67c9 ;  function    0x130b7e1b67c9 <JS Function getTypeFromTypeNode (SharedFunctionInfo 0x2e2f693f5581)>  (input #0)
    0x7fff5fbfceb8: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #4)
    0x7fff5fbfceb0: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfcea8: [top + 0] <- 0x1030c9d45b01 ;  0x1030c9d45b01 <JS Function getTypeFromThisTypeNode (SharedFunctionInfo 0x2e2f693f54c1)>  (input #6)
  translating frame getTypeFromThisTypeNode => node=18, height=16
    0x7fff5fbfcea0: [top + 56] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfce98: [top + 48] <- 0x2f05bb8ef651 ;  0x2f05bb8ef651 <a NodeObject with map 0x33abe2a74c49>  (input #2)
    0x7fff5fbfce90: [top + 40] <- 0x2c21d25f8544 ;  caller's pc
    0x7fff5fbfce88: [top + 32] <- 0x7fff5fbfced0 ;  caller's fp
    0x7fff5fbfce80: [top + 24] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfce78: [top + 16] <- 0x1030c9d45b01 ;  function    0x1030c9d45b01 <JS Function getTypeFromThisTypeNode (SharedFunctionInfo 0x2e2f693f54c1)>  (input #0)
    0x7fff5fbfce70: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfce68: [top + 0] <- 0x32c5a0decaa1 ;  0x32c5a0decaa1 <an Object with map 0x33abe2a73859>  (input #5)
[deoptimizing (eager): end 0x130b7e1b67c9 <JS Function getTypeFromTypeNode (SharedFunctionInfo 0x2e2f693f5581)> @150 => node=18, pc=0x2c21d26437e4, caller sp=0x7fff5fbfcef0, state=TOS_REGISTER, took 0.130 ms]
[deoptimizing (DEOPT soft): begin 0x1030c9d55f51 <JS Function getNumNonRestParameters (SharedFunctionInfo 0x2e2f693f7741)> (opt #458) @5, FP to SP delta: 24, caller sp: 0x7fff5fbfd150]
            ;;; deoptimize at 0_145: Insufficient type feedback for LHS of binary operation
  reading input frame getNumNonRestParameters => node=35, args=2, height=2; inputs:
      0: 0x1030c9d55f51 ; [fp - 16] 0x1030c9d55f51 <JS Function getNumNonRestParameters (SharedFunctionInfo 0x2e2f693f7741)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x3d8926028d39 ; rax 0x3d8926028d39 <a SignatureObject with map 0x33abe2a76091>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 2 ; rbx 
  translating frame getNumNonRestParameters => node=35, height=8
    0x7fff5fbfd148: [top + 48] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd140: [top + 40] <- 0x3d8926028d39 ;  0x3d8926028d39 <a SignatureObject with map 0x33abe2a76091>  (input #2)
    0x7fff5fbfd138: [top + 32] <- 0x2c21d269c261 ;  caller's pc
    0x7fff5fbfd130: [top + 24] <- 0x7fff5fbfd1d8 ;  caller's fp
    0x7fff5fbfd128: [top + 16] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd120: [top + 8] <- 0x1030c9d55f51 ;  function    0x1030c9d55f51 <JS Function getNumNonRestParameters (SharedFunctionInfo 0x2e2f693f7741)>  (input #0)
    0x7fff5fbfd118: [top + 0] <- 0x200000000 ;  2  (input #4)
[deoptimizing (soft): end 0x1030c9d55f51 <JS Function getNumNonRestParameters (SharedFunctionInfo 0x2e2f693f7741)> @5 => node=35, pc=0x2c21d269d713, caller sp=0x7fff5fbfd150, state=NO_REGISTERS, took 0.055 ms]
[deoptimizing (DEOPT soft): begin 0x1030c9d55f99 <JS Function getNumParametersToCheckForSignatureRelatability (SharedFunctionInfo 0x2e2f693f7801)> (opt #523) @14, FP to SP delta: 24, caller sp: 0x7fff5fbfd150]
            ;;; deoptimize at 0_409: Insufficient type feedback for LHS of binary operation
  reading input frame getNumParametersToCheckForSignatureRelatability => node=51, args=5, height=2; inputs:
      0: 0x1030c9d55f99 ; [fp - 16] 0x1030c9d55f99 <JS Function getNumParametersToCheckForSignatureRelatability (SharedFunctionInfo 0x2e2f693f7801)>
      1: 0x1f9f6c0532e1 ; [fp + 48] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x3d8926028d39 ; rax 0x3d8926028d39 <a SignatureObject with map 0x33abe2a76091>
      3: 0x100000000 ; rbx 1
      4: 0x3d8926028901 ; [fp + 24] 0x3d8926028901 <a SignatureObject with map 0x33abe2a76091>
      5: 0x100000000 ; rdx 1
      6: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      7: 1.000000e+00 ; xmm0 (double)
  translating frame getNumParametersToCheckForSignatureRelatability => node=51, height=8
    0x7fff5fbfd148: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd140: [top + 64] <- 0x3d8926028d39 ;  0x3d8926028d39 <a SignatureObject with map 0x33abe2a76091>  (input #2)
    0x7fff5fbfd138: [top + 56] <- 0x100000000 ;  1  (input #3)
    0x7fff5fbfd130: [top + 48] <- 0x3d8926028901 ;  0x3d8926028901 <a SignatureObject with map 0x33abe2a76091>  (input #4)
    0x7fff5fbfd128: [top + 40] <- 0x100000000 ;  1  (input #5)
    0x7fff5fbfd120: [top + 32] <- 0x2c21d269c2ca ;  caller's pc
    0x7fff5fbfd118: [top + 24] <- 0x7fff5fbfd1d8 ;  caller's fp
    0x7fff5fbfd110: [top + 16] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #6)
    0x7fff5fbfd108: [top + 8] <- 0x1030c9d55f99 ;  function    0x1030c9d55f99 <JS Function getNumParametersToCheckForSignatureRelatability (SharedFunctionInfo 0x2e2f693f7801)>  (input #0)
    0x7fff5fbfd100: [top + 0] <- 0x30bcea4044f1 ;  0x30bcea4044f1 <Odd Oddball: arguments_marker>  (input #7)
[deoptimizing (soft): end 0x1030c9d55f99 <JS Function getNumParametersToCheckForSignatureRelatability (SharedFunctionInfo 0x2e2f693f7801)> @14 => node=51, pc=0x2c21d269d8ec, caller sp=0x7fff5fbfd150, state=NO_REGISTERS, took 0.064 ms]
1
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createMap) id{554,0} ---
(template) {
        var map = createObject(null); // tslint:disable-line:no-null-keyword
        // Using 'delete' on an object causes V8 to put the object in dictionary mode.
        // This disables creation of hidden classes, which are expensive when an object is
        // constantly changing shape.
        map["__"] = undefined;
        delete map["__"];
        // Copies keys/values from template. Note that for..in will not throw if
        // template is undefined, and instead will just exit the loop.
        for (var key in template)
            if (hasOwnProperty.call(template, key)) {
                map[key] = template[key];
            }
        return map;
    }
--- END ---
[deoptimizing (DEOPT eager): begin 0xd6230dac271 <JS Function createMap (SharedFunctionInfo 0xc2bd2ae0b29)> (opt #554) @20, FP to SP delta: 72, caller sp: 0x7fff5fbfd2e0]
            ;;; deoptimize at 0_523: null or undefined in for-in
  reading input frame createMap => node=49, args=2, height=4; inputs:
      0: 0xd6230dac271 ; [fp - 16] 0xd6230dac271 <JS Function createMap (SharedFunctionInfo 0xc2bd2ae0b29)>
      1: 0x16f3adb61821 ; [fp + 24] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x30bcea404311 ; [fp + 16] 0x30bcea404311 <undefined>
      3: 0xd6230db3179 ; [fp - 24] 0xd6230db3179 <FixedArray[95]>
      4: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
      5: 0x3d892602aa31 ; [fp - 32] 0x3d892602aa31 <an Object with map 0x15b5a79120c1>
      6: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
  translating frame createMap => node=49, height=24
    0x7fff5fbfd2d8: [top + 64] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfd2d0: [top + 56] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #2)
    0x7fff5fbfd2c8: [top + 48] <- 0x2c21d2207e55 ;  caller's pc
    0x7fff5fbfd2c0: [top + 40] <- 0x7fff5fbfd2f8 ;  caller's fp
    0x7fff5fbfd2b8: [top + 32] <- 0xd6230db3179 ;  context    0xd6230db3179 <FixedArray[95]>  (input #3)
    0x7fff5fbfd2b0: [top + 24] <- 0xd6230dac271 ;  function    0xd6230dac271 <JS Function createMap (SharedFunctionInfo 0xc2bd2ae0b29)>  (input #0)
    0x7fff5fbfd2a8: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfd2a0: [top + 8] <- 0x3d892602aa31 ;  0x3d892602aa31 <an Object with map 0x15b5a79120c1>  (input #5)
    0x7fff5fbfd298: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
[deoptimizing (eager): end 0xd6230dac271 <JS Function createMap (SharedFunctionInfo 0xc2bd2ae0b29)> @20 => node=49, pc=0x2c21d23cd4a0, caller sp=0x7fff5fbfd2e0, state=NO_REGISTERS, took 0.056 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveStructuredTypeMembers) id{555,0} ---
(type) {
            if (!type.members) {
                if (type.flags & 32768 /* Object */) {
                    if (type.objectFlags & 4 /* Reference */) {
                        resolveTypeReferenceMembers(type);
                    }
                    else if (type.objectFlags & 3 /* ClassOrInterface */) {
                        resolveClassOrInterfaceMembers(type);
                    }
                    else if (type.objectFlags & 16 /* Anonymous */) {
                        resolveAnonymousTypeMembers(type);
                    }
                    else if (type.objectFlags & 32 /* Mapped */) {
                        resolveMappedTypeMembers(type);
                    }
                }
                else if (type.flags & 65536 /* Union */) {
                    resolveUnionTypeMembers(type);
                }
                else if (type.flags & 131072 /* Intersection */) {
                    resolveIntersectionTypeMembers(type);
                }
            }
            return type;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveTypeReferenceMembers) id{555,1} ---
(type) {
            var source = resolveDeclaredMembers(type.target);
            var typeParameters = ts.concatenate(source.typeParameters, [source.thisType]);
            var typeArguments = type.typeArguments && type.typeArguments.length === typeParameters.length ?
                type.typeArguments : ts.concatenate(type.typeArguments, [type]);
            resolveObjectTypeMembers(type, source, typeParameters, typeArguments);
        }
--- END ---
INLINE (resolveTypeReferenceMembers) id{555,1} AS 1 AT <0:185>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveDeclaredMembers) id{555,2} ---
(type) {
            if (!type.declaredProperties) {
                var symbol = type.symbol;
                type.declaredProperties = getNamedMembers(symbol.members);
                type.declaredCallSignatures = getSignaturesOfSymbol(symbol.members["__call"]);
                type.declaredConstructSignatures = getSignaturesOfSymbol(symbol.members["__new"]);
                type.declaredStringIndexInfo = getIndexInfoOfSymbol(symbol, 0 /* String */);
                type.declaredNumberIndexInfo = getIndexInfoOfSymbol(symbol, 1 /* Number */);
            }
            return type;
        }
--- END ---
INLINE (resolveDeclaredMembers) id{555,2} AS 2 AT <1:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNamedMembers) id{555,3} ---
(members) {
            var result;
            for (var id in members) {
                if (!isReservedMemberName(id)) {
                    if (!result)
                        result = [];
                    var symbol = members[id];
                    if (symbolIsValue(symbol)) {
                        result.push(symbol);
                    }
                }
            }
            return result || emptyArray;
        }
--- END ---
INLINE (getNamedMembers) id{555,3} AS 3 AT <2:137>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isReservedMemberName) id{555,4} ---
(name) {
            return name.charCodeAt(0) === 95 /* _ */ &&
                name.charCodeAt(1) === 95 /* _ */ &&
                name.charCodeAt(2) !== 95 /* _ */ &&
                name.charCodeAt(2) !== 64 /* at */;
        }
--- END ---
INLINE (isReservedMemberName) id{555,4} AS 4 AT <3:95>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexInfoOfSymbol) id{555,5} ---
(symbol, kind) {
            var declaration = getIndexDeclarationOfSymbol(symbol, kind);
            if (declaration) {
                return createIndexInfo(declaration.type ? getTypeFromTypeNode(declaration.type) : anyType, (ts.getModifierFlags(declaration) & 64 /* Readonly */) !== 0, declaration);
            }
            return undefined;
        }
--- END ---
INLINE (getIndexInfoOfSymbol) id{555,5} AS 5 AT <2:411>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createIndexInfo) id{555,6} ---
(type, isReadonly, declaration) {
            return { type: type, isReadonly: isReadonly, declaration: declaration };
        }
--- END ---
INLINE (createIndexInfo) id{555,6} AS 6 AT <5:144>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexInfoOfSymbol) id{555,7} ---
(symbol, kind) {
            var declaration = getIndexDeclarationOfSymbol(symbol, kind);
            if (declaration) {
                return createIndexInfo(declaration.type ? getTypeFromTypeNode(declaration.type) : anyType, (ts.getModifierFlags(declaration) & 64 /* Readonly */) !== 0, declaration);
            }
            return undefined;
        }
--- END ---
INLINE (getIndexInfoOfSymbol) id{555,7} AS 7 AT <2:504>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createIndexInfo) id{555,8} ---
(type, isReadonly, declaration) {
            return { type: type, isReadonly: isReadonly, declaration: declaration };
        }
--- END ---
INLINE (createIndexInfo) id{555,8} AS 8 AT <7:144>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveClassOrInterfaceMembers) id{555,9} ---
(type) {
            resolveObjectTypeMembers(type, resolveDeclaredMembers(type), emptyArray, emptyArray);
        }
--- END ---
INLINE (resolveClassOrInterfaceMembers) id{555,9} AS 9 AT <0:342>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveDeclaredMembers) id{555,10} ---
(type) {
            if (!type.declaredProperties) {
                var symbol = type.symbol;
                type.declaredProperties = getNamedMembers(symbol.members);
                type.declaredCallSignatures = getSignaturesOfSymbol(symbol.members["__call"]);
                type.declaredConstructSignatures = getSignaturesOfSymbol(symbol.members["__new"]);
                type.declaredStringIndexInfo = getIndexInfoOfSymbol(symbol, 0 /* String */);
                type.declaredNumberIndexInfo = getIndexInfoOfSymbol(symbol, 1 /* Number */);
            }
            return type;
        }
--- END ---
INLINE (resolveDeclaredMembers) id{555,10} AS 10 AT <9:52>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNamedMembers) id{555,11} ---
(members) {
            var result;
            for (var id in members) {
                if (!isReservedMemberName(id)) {
                    if (!result)
                        result = [];
                    var symbol = members[id];
                    if (symbolIsValue(symbol)) {
                        result.push(symbol);
                    }
                }
            }
            return result || emptyArray;
        }
--- END ---
INLINE (getNamedMembers) id{555,11} AS 11 AT <10:137>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isReservedMemberName) id{555,12} ---
(name) {
            return name.charCodeAt(0) === 95 /* _ */ &&
                name.charCodeAt(1) === 95 /* _ */ &&
                name.charCodeAt(2) !== 95 /* _ */ &&
                name.charCodeAt(2) !== 64 /* at */;
        }
--- END ---
INLINE (isReservedMemberName) id{555,12} AS 12 AT <11:95>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkPropertyDeclaration) id{556,0} ---
(node) {
            // Grammar checking
            checkGrammarDecorators(node) || checkGrammarModifiers(node) || checkGrammarProperty(node) || checkGrammarComputedPropertyName(node.name);
            checkVariableLikeDeclaration(node);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarComputedPropertyName) id{556,1} ---
(node) {
            // If node is not a computedPropertyName, just skip the grammar checking
            if (node.kind !== 142 /* ComputedPropertyName */) {
                return false;
            }
            var computedPropertyName = node;
            if (computedPropertyName.expression.kind === 192 /* BinaryExpression */ && computedPropertyName.expression.operatorToken.kind === 25 /* CommaToken */) {
                return grammarErrorOnNode(computedPropertyName.expression, ts.Diagnostics.A_comma_expression_is_not_allowed_in_a_computed_property_name);
            }
        }
--- END ---
INLINE (checkGrammarComputedPropertyName) id{556,1} AS 1 AT <0:146>
[deoptimizing (DEOPT eager): begin 0x1030c9d45689 <JS Function isIndependentVariableLikeDeclaration (SharedFunctionInfo 0x2e2f693ee6d1)> (opt #544) @6, FP to SP delta: 24, caller sp: 0x7fff5fbfd950]
            ;;; deoptimize at 0_78: wrong map
  reading input frame isIndependentVariableLikeDeclaration => node=9, args=2, height=2; inputs:
      0: 0x1030c9d45689 ; [fp - 16] 0x1030c9d45689 <JS Function isIndependentVariableLikeDeclaration (SharedFunctionInfo 0x2e2f693ee6d1)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2f05bb8e37d9 ; rax 0x2f05bb8e37d9 <a NodeObject with map 0x33abe2a6ffa1>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea404421 ; rbx 0x30bcea404421 <false>
  translating frame isIndependentVariableLikeDeclaration => node=9, height=8
    0x7fff5fbfd948: [top + 48] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd940: [top + 40] <- 0x2f05bb8e37d9 ;  0x2f05bb8e37d9 <a NodeObject with map 0x33abe2a6ffa1>  (input #2)
    0x7fff5fbfd938: [top + 32] <- 0x2c21d26321b1 ;  caller's pc
    0x7fff5fbfd930: [top + 24] <- 0x7fff5fbfd978 ;  caller's fp
    0x7fff5fbfd928: [top + 16] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd920: [top + 8] <- 0x1030c9d45689 ;  function    0x1030c9d45689 <JS Function isIndependentVariableLikeDeclaration (SharedFunctionInfo 0x2e2f693ee6d1)>  (input #0)
    0x7fff5fbfd918: [top + 0] <- 0x30bcea404421 ;  0x30bcea404421 <false>  (input #4)
[deoptimizing (eager): end 0x1030c9d45689 <JS Function isIndependentVariableLikeDeclaration (SharedFunctionInfo 0x2e2f693ee6d1)> @6 => node=9, pc=0x2c21d2632340, caller sp=0x7fff5fbfd950, state=TOS_REGISTER, took 0.057 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIndependentMember) id{557,0} ---
(symbol) {
            if (symbol.declarations && symbol.declarations.length === 1) {
                var declaration = symbol.declarations[0];
                if (declaration) {
                    switch (declaration.kind) {
                        case 147 /* PropertyDeclaration */:
                        case 146 /* PropertySignature */:
                            return isIndependentVariableLikeDeclaration(declaration);
                        case 149 /* MethodDeclaration */:
                        case 148 /* MethodSignature */:
                        case 150 /* Constructor */:
                            return isIndependentFunctionLikeDeclaration(declaration);
                    }
                }
            }
            return false;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIndependentVariableLikeDeclaration) id{557,1} ---
(node) {
            return node.type && isIndependentType(node.type) || !node.type && !node.initializer;
        }
--- END ---
INLINE (isIndependentVariableLikeDeclaration) id{557,1} AS 1 AT <0:380>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIndependentFunctionLikeDeclaration) id{557,2} ---
(node) {
            if (node.kind !== 150 /* Constructor */ && (!node.type || !isIndependentType(node.type))) {
                return false;
            }
            for (var _i = 0, _a = node.parameters; _i < _a.length; _i++) {
                var parameter = _a[_i];
                if (!isIndependentVariableLikeDeclaration(parameter)) {
                    return false;
                }
            }
            return true;
        }
--- END ---
INLINE (isIndependentFunctionLikeDeclaration) id{557,2} AS 2 AT <0:632>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIndependentVariableLikeDeclaration) id{557,3} ---
(node) {
            return node.type && isIndependentType(node.type) || !node.type && !node.initializer;
        }
--- END ---
INLINE (isIndependentVariableLikeDeclaration) id{557,3} AS 3 AT <2:293>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode) id{558,0} ---
(node) {
            var links = getNodeLinks(node);
            if (!links.resolvedType) {
                // Deferred resolution of members is handled by resolveObjectTypeMembers
                var aliasSymbol = getAliasSymbolForTypeNode(node);
                if (ts.isEmpty(node.symbol.members) && !aliasSymbol) {
                    links.resolvedType = emptyTypeLiteralType;
                }
                else {
                    var type = createObjectType(16 /* Anonymous */, node.symbol);
                    type.aliasSymbol = aliasSymbol;
                    type.aliasTypeArguments = getAliasTypeArgumentsForTypeNode(node);
                    links.resolvedType = type;
                }
            }
            return links.resolvedType;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeLinks) id{558,1} ---
(node) {
            var nodeId = getNodeId(node);
            return nodeLinks[nodeId] || (nodeLinks[nodeId] = { flags: 0 });
        }
--- END ---
INLINE (getNodeLinks) id{558,1} AS 1 AT <0:33>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeId) id{558,2} ---
(node) {
        if (!node.id) {
            node.id = nextNodeId;
            nextNodeId++;
        }
        return node.id;
    }
--- END ---
INLINE (getNodeId) id{558,2} AS 2 AT <1:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getAliasSymbolForTypeNode) id{558,3} ---
(node) {
            return node.parent.kind === 228 /* TypeAliasDeclaration */ ? getSymbolOfNode(node.parent) : undefined;
        }
--- END ---
INLINE (getAliasSymbolForTypeNode) id{558,3} AS 3 AT <0:215>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{558,4} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{558,4} AS 4 AT <3:82>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{558,5} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{558,5} AS 5 AT <4:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createObjectType) id{558,6} ---
(objectFlags, symbol) {
            var type = createType(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol = symbol;
            return type;
        }
--- END ---
INLINE (createObjectType) id{558,6} AS 6 AT <0:454>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{558,7} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{558,7} AS 7 AT <6:47>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{558,8} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{558,8} AS 8 AT <7:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getAliasTypeArgumentsForTypeNode) id{558,9} ---
(node) {
            var symbol = getAliasSymbolForTypeNode(node);
            return symbol ? getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol) : undefined;
        }
--- END ---
INLINE (getAliasTypeArgumentsForTypeNode) id{558,9} AS 9 AT <0:603>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getAliasSymbolForTypeNode) id{558,10} ---
(node) {
            return node.parent.kind === 228 /* TypeAliasDeclaration */ ? getSymbolOfNode(node.parent) : undefined;
        }
--- END ---
INLINE (getAliasSymbolForTypeNode) id{558,10} AS 10 AT <9:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{558,11} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{558,11} AS 11 AT <10:82>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{558,12} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{558,12} AS 12 AT <11:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkSourceElement) id{559,0} ---
(node) {
            if (!node) {
                return;
            }
            var kind = node.kind;
            if (cancellationToken) {
                // Only bother checking on a few construct kinds.  We don't want to be excessively
                // hitting the cancellation token on every node we check.
                switch (kind) {
                    case 230 /* ModuleDeclaration */:
                    case 226 /* ClassDeclaration */:
                    case 227 /* InterfaceDeclaration */:
                    case 225 /* FunctionDeclaration */:
                        cancellationToken.throwIfCancellationRequested();
                }
            }
            switch (kind) {
                case 143 /* TypeParameter */:
                    return checkTypeParameter(node);
                case 144 /* Parameter */:
                    return checkParameter(node);
                case 147 /* PropertyDeclaration */:
                case 146 /* PropertySignature */:
                    return checkPropertyDeclaration(node);
                case 158 /* FunctionType */:
                case 159 /* ConstructorType */:
                case 153 /* CallSignature */:
                case 154 /* ConstructSignature */:
                    return checkSignatureDeclaration(node);
                case 155 /* IndexSignature */:
                    return checkSignatureDeclaration(node);
                case 149 /* MethodDeclaration */:
                case 148 /* MethodSignature */:
                    return checkMethodDeclaration(node);
                case 150 /* Constructor */:
                    return checkConstructorDeclaration(node);
                case 151 /* GetAccessor */:
                case 152 /* SetAccessor */:
                    return checkAccessorDeclaration(node);
                case 157 /* TypeReference */:
                    return checkTypeReferenceNode(node);
                case 156 /* TypePredicate */:
                    return checkTypePredicate(node);
                case 160 /* TypeQuery */:
                    return checkTypeQuery(node);
                case 161 /* TypeLiteral */:
                    return checkTypeLiteral(node);
                case 162 /* ArrayType */:
                    return checkArrayType(node);
                case 163 /* TupleType */:
                    return checkTupleType(node);
                case 164 /* UnionType */:
                case 165 /* IntersectionType */:
                    return checkUnionOrIntersectionType(node);
                case 166 /* ParenthesizedType */:
                case 168 /* TypeOperator */:
                    return checkSourceElement(node.type);
                case 169 /* IndexedAccessType */:
                    return checkIndexedAccessType(node);
                case 170 /* MappedType */:
                    return checkMappedType(node);
                case 225 /* FunctionDeclaration */:
                    return checkFunctionDeclaration(node);
                case 204 /* Block */:
                case 231 /* ModuleBlock */:
                    return checkBlock(node);
                case 205 /* VariableStatement */:
                    return checkVariableStatement(node);
                case 207 /* ExpressionStatement */:
                    return checkExpressionStatement(node);
                case 208 /* IfStatement */:
                    return checkIfStatement(node);
                case 209 /* DoStatement */:
                    return checkDoStatement(node);
                case 210 /* WhileStatement */:
                    return checkWhileStatement(node);
                case 211 /* ForStatement */:
                    return checkForStatement(node);
                case 212 /* ForInStatement */:
                    return checkForInStatement(node);
                case 213 /* ForOfStatement */:
                    return checkForOfStatement(node);
                case 214 /* ContinueStatement */:
                case 215 /* BreakStatement */:
                    return checkBreakOrContinueStatement(node);
                case 216 /* ReturnStatement */:
                    return checkReturnStatement(node);
                case 217 /* WithStatement */:
                    return checkWithStatement(node);
                case 218 /* SwitchStatement */:
                    return checkSwitchStatement(node);
                case 219 /* LabeledStatement */:
                    return checkLabeledStatement(node);
                case 220 /* ThrowStatement */:
                    return checkThrowStatement(node);
                case 221 /* TryStatement */:
                    return checkTryStatement(node);
                case 223 /* VariableDeclaration */:
                    return checkVariableDeclaration(node);
                case 174 /* BindingElement */:
                    return checkBindingElement(node);
                case 226 /* ClassDeclaration */:
                    return checkClassDeclaration(node);
                case 227 /* InterfaceDeclaration */:
                    return checkInterfaceDeclaration(node);
                case 228 /* TypeAliasDeclaration */:
                    return checkTypeAliasDeclaration(node);
                case 229 /* EnumDeclaration */:
                    return checkEnumDeclaration(node);
                case 230 /* ModuleDeclaration */:
                    return checkModuleDeclaration(node);
                case 235 /* ImportDeclaration */:
                    return checkImportDeclaration(node);
                case 234 /* ImportEqualsDeclaration */:
                    return checkImportEqualsDeclaration(node);
                case 241 /* ExportDeclaration */:
                    return checkExportDeclaration(node);
                case 240 /* ExportAssignment */:
                    return checkExportAssignment(node);
                case 206 /* EmptyStatement */:
                    checkGrammarStatementInAmbientContext(node);
                    return;
                case 222 /* DebuggerStatement */:
                    checkGrammarStatementInAmbientContext(node);
                    return;
                case 244 /* MissingDeclaration */:
                    return checkMissingDeclaration(node);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkTypeParameter) id{559,1} ---
(node) {
            // Grammar Checking
            if (node.expression) {
                grammarErrorOnFirstToken(node.expression, ts.Diagnostics.Type_expected);
            }
            checkSourceElement(node.constraint);
            getConstraintOfTypeParameter(getDeclaredTypeOfTypeParameter(getSymbolOfNode(node)));
            if (produceDiagnostics) {
                checkTypeNameIsReserved(node.name, ts.Diagnostics.Type_parameter_name_cannot_be_0);
            }
        }
--- END ---
INLINE (checkTypeParameter) id{559,1} AS 1 AT <0:775>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{559,2} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{559,2} AS 2 AT <1:300>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{559,3} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{559,3} AS 3 AT <2:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getDeclaredTypeOfTypeParameter) id{559,4} ---
(symbol) {
            var links = getSymbolLinks(symbol);
            if (!links.declaredType) {
                var type = createType(16384 /* TypeParameter */);
                type.symbol = symbol;
                if (!ts.getDeclarationOfKind(symbol, 143 /* TypeParameter */).constraint) {
                    type.constraint = noConstraintType;
                }
                links.declaredType = type;
            }
            return links.declaredType;
        }
--- END ---
INLINE (getDeclaredTypeOfTypeParameter) id{559,4} AS 4 AT <1:269>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{559,5} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{559,5} AS 5 AT <4:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{559,6} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{559,6} AS 6 AT <5:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{559,7} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{559,7} AS 7 AT <4:125>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{559,8} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{559,8} AS 8 AT <7:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkTypeNameIsReserved) id{559,9} ---
(name, message) {
            // TS 1.0 spec (April 2014): 3.6.1
            // The predefined type keywords are reserved and cannot be used as names of user defined types.
            switch (name.text) {
                case "any":
                case "number":
                case "boolean":
                case "string":
                case "symbol":
                case "void":
                    error(name, message, name.text);
            }
        }
--- END ---
INLINE (checkTypeNameIsReserved) id{559,9} AS 9 AT <1:379>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkPropertyDeclaration) id{559,10} ---
(node) {
            // Grammar checking
            checkGrammarDecorators(node) || checkGrammarModifiers(node) || checkGrammarProperty(node) || checkGrammarComputedPropertyName(node.name);
            checkVariableLikeDeclaration(node);
        }
--- END ---
INLINE (checkPropertyDeclaration) id{559,10} AS 10 AT <0:1021>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarComputedPropertyName) id{559,11} ---
(node) {
            // If node is not a computedPropertyName, just skip the grammar checking
            if (node.kind !== 142 /* ComputedPropertyName */) {
                return false;
            }
            var computedPropertyName = node;
            if (computedPropertyName.expression.kind === 192 /* BinaryExpression */ && computedPropertyName.expression.operatorToken.kind === 25 /* CommaToken */) {
                return grammarErrorOnNode(computedPropertyName.expression, ts.Diagnostics.A_comma_expression_is_not_allowed_in_a_computed_property_name);
            }
        }
--- END ---
INLINE (checkGrammarComputedPropertyName) id{559,11} AS 11 AT <10:146>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkTypeQuery) id{559,12} ---
(node) {
            getTypeFromTypeQueryNode(node);
        }
--- END ---
INLINE (checkTypeQuery) id{559,12} AS 12 AT <0:2089>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeFromTypeQueryNode) id{559,13} ---
(node) {
            var links = getNodeLinks(node);
            if (!links.resolvedType) {
                // TypeScript 1.0 spec (April 2014): 3.6.3
                // The expression is processed as an identifier expression (section 4.3)
                // or property access expression(section 4.10),
                // the widened type(section 3.9) of which becomes the result.
                links.resolvedType = getWidenedType(checkExpression(node.exprName));
            }
            return links.resolvedType;
        }
--- END ---
INLINE (getTypeFromTypeQueryNode) id{559,13} AS 13 AT <12:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeLinks) id{559,14} ---
(node) {
            var nodeId = getNodeId(node);
            return nodeLinks[nodeId] || (nodeLinks[nodeId] = { flags: 0 });
        }
--- END ---
INLINE (getNodeLinks) id{559,14} AS 14 AT <13:33>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeId) id{559,15} ---
(node) {
        if (!node.id) {
            node.id = nextNodeId;
            nextNodeId++;
        }
        return node.id;
    }
--- END ---
INLINE (getNodeId) id{559,15} AS 15 AT <14:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkTypeLiteral) id{559,16} ---
(node) {
            ts.forEach(node.members, checkSourceElement);
            if (produceDiagnostics) {
                var type = getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode(node);
                checkIndexConstraints(type);
                checkTypeForDuplicateIndexSignatures(node);
                checkObjectTypeForDuplicateDeclarations(node);
            }
        }
--- END ---
INLINE (checkTypeLiteral) id{559,16} AS 16 AT <0:2182>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveName) id{560,0} ---
(location, name, meaning, nameNotFoundMessage, nameArg) {
            var result;
            var lastLocation;
            var propertyWithInvalidInitializer;
            var errorLocation = location;
            var grandparent;
            var isInExternalModule = false;
            loop: while (location) {
                // Locals of a source file are not in scope (because they get merged into the global symbol table)
                if (location.locals && !isGlobalSourceFile(location)) {
                    if (result = getSymbol(location.locals, name, meaning)) {
                        var useResult = true;
                        if (ts.isFunctionLike(location) && lastLocation && lastLocation !== location.body) {
                            // symbol lookup restrictions for function-like declarations
                            // - Type parameters of a function are in scope in the entire function declaration, including the parameter
                            //   list and return type. However, local types are only in scope in the function body.
                            // - parameters are only in the scope of function body
                            // This restriction does not apply to JSDoc comment types because they are parented
                            // at a higher level than type parameters would normally be
                            if (meaning & result.flags & 793064 /* Type */ && lastLocation.kind !== 278 /* JSDocComment */) {
                                useResult = result.flags & 262144 /* TypeParameter */
                                    ? lastLocation === location.type ||
                                        lastLocation.kind === 144 /* Parameter */ ||
                                        lastLocation.kind === 143 /* TypeParameter */
                                    : false;
                            }
                            if (meaning & 107455 /* Value */ && result.flags & 1 /* FunctionScopedVariable */) {
                                // parameters are visible only inside function body, parameter list and return type
                                // technically for parameter list case here we might mix parameters and variables declared in function,
                                // however it is detected separately when checking initializers of parameters
                                // to make sure that they reference no variables declared after them.
                                useResult =
                                    lastLocation.kind === 144 /* Parameter */ ||
                                        (lastLocation === location.type &&
                                            result.valueDeclaration.kind === 144 /* Parameter */);
                            }
                        }
                        if (useResult) {
                            break loop;
                        }
                        else {
                            result = undefined;
                        }
                    }
                }
                switch (location.kind) {
                    case 261 /* SourceFile */:
                        if (!ts.isExternalOrCommonJsModule(location))
                            break;
                        isInExternalModule = true;
                    case 230 /* ModuleDeclaration */:
                        var moduleExports = getSymbolOfNode(location).exports;
                        if (location.kind === 261 /* SourceFile */ || ts.isAmbientModule(location)) {
                            // It's an external module. First see if the module has an export default and if the local
                            // name of that export default matches.
                            if (result = moduleExports["default"]) {
                                var localSymbol = ts.getLocalSymbolForExportDefault(result);
                                if (localSymbol && (result.flags & meaning) && localSymbol.name === name) {
                                    break loop;
                                }
                                result = undefined;
                            }
                            // Because of module/namespace merging, a module's exports are in scope,
                            // yet we never want to treat an export specifier as putting a member in scope.
                            // Therefore, if the name we find is purely an export specifier, it is not actually considered in scope.
                            // Two things to note about this:
                            //     1. We have to check this without calling getSymbol. The problem with calling getSymbol
                            //        on an export specifier is that it might find the export specifier itself, and try to
                            //        resolve it as an alias. This will cause the checker to consider the export specifier
                            //        a circular alias reference when it might not be.
                            //     2. We check === SymbolFlags.Alias in order to check that the symbol is *purely*
                            //        an alias. If we used &, we'd be throwing out symbols that have non alias aspects,
                            //        which is not the desired behavior.
                            if (moduleExports[name] &&
                                moduleExports[name].flags === 8388608 /* Alias */ &&
                                ts.getDeclarationOfKind(moduleExports[name], 243 /* ExportSpecifier */)) {
                                break;
                            }
                        }
                        if (result = getSymbol(moduleExports, name, meaning & 8914931 /* ModuleMember */)) {
                            break loop;
                        }
                        break;
                    case 229 /* EnumDeclaration */:
                        if (result = getSymbol(getSymbolOfNode(location).exports, name, meaning & 8 /* EnumMember */)) {
                            break loop;
                        }
                        break;
                    case 147 /* PropertyDeclaration */:
                    case 146 /* PropertySignature */:
                        // TypeScript 1.0 spec (April 2014): 8.4.1
                        // Initializer expressions for instance member variables are evaluated in the scope
                        // of the class constructor body but are not permitted to reference parameters or
                        // local variables of the constructor. This effectively means that entities from outer scopes
                        // by the same name as a constructor parameter or local variable are inaccessible
                        // in initializer expressions for instance member variables.
                        if (ts.isClassLike(location.parent) && !(ts.getModifierFlags(location) & 32 /* Static */)) {
                            var ctor = findConstructorDeclaration(location.parent);
                            if (ctor && ctor.locals) {
                                if (getSymbol(ctor.locals, name, meaning & 107455 /* Value */)) {
                                    // Remember the property node, it will be used later to report appropriate error
                                    propertyWithInvalidInitializer = location;
                                }
                            }
                        }
                        break;
                    case 226 /* ClassDeclaration */:
                    case 197 /* ClassExpression */:
                    case 227 /* InterfaceDeclaration */:
                        if (result = getSymbol(getSymbolOfNode(location).members, name, meaning & 793064 /* Type */)) {
                            if (lastLocation && ts.getModifierFlags(lastLocation) & 32 /* Static */) {
                                // TypeScript 1.0 spec (April 2014): 3.4.1
                                // The scope of a type parameter extends over the entire declaration with which the type
                                // parameter list is associated, with the exception of static member declarations in classes.
                                error(errorLocation, ts.Diagnostics.Static_members_cannot_reference_class_type_parameters);
                                return undefined;
                            }
                            break loop;
                        }
                        if (location.kind === 197 /* ClassExpression */ && meaning & 32 /* Class */) {
                            var className = location.name;
                            if (className && name === className.text) {
                                result = location.symbol;
                                break loop;
                            }
                        }
                        break;
                    // It is not legal to reference a class's own type parameters from a computed property name that
                    // belongs to the class. For example:
                    //
                    //   function foo<T>() { return '' }
                    //   class C<T> { // <-- Class's own type parameter T
                    //       [foo<T>()]() { } // <-- Reference to T from class's own computed property
                    //   }
                    //
                    case 142 /* ComputedPropertyName */:
                        grandparent = location.parent.parent;
                        if (ts.isClassLike(grandparent) || grandparent.kind === 227 /* InterfaceDeclaration */) {
                            // A reference to this grandparent's type parameters would be an error
                            if (result = getSymbol(getSymbolOfNode(grandparent).members, name, meaning & 793064 /* Type */)) {
                                error(errorLocation, ts.Diagnostics.A_computed_property_name_cannot_reference_a_type_parameter_from_its_containing_type);
                                return undefined;
                            }
                        }
                        break;
                    case 149 /* MethodDeclaration */:
                    case 148 /* MethodSignature */:
                    case 150 /* Constructor */:
                    case 151 /* GetAccessor */:
                    case 152 /* SetAccessor */:
                    case 225 /* FunctionDeclaration */:
                    case 185 /* ArrowFunction */:
                        if (meaning & 3 /* Variable */ && name === "arguments") {
                            result = argumentsSymbol;
                            break loop;
                        }
                        break;
                    case 184 /* FunctionExpression */:
                        if (meaning & 3 /* Variable */ && name === "arguments") {
                            result = argumentsSymbol;
                            break loop;
                        }
                        if (meaning & 16 /* Function */) {
                            var functionName = location.name;
                            if (functionName && name === functionName.text) {
                                result = location.symbol;
                                break loop;
                            }
                        }
                        break;
                    case 145 /* Decorator */:
                        // Decorators are resolved at the class declaration. Resolving at the parameter
                        // or member would result in looking up locals in the method.
                        //
                        //   function y() {}
                        //   class C {
                        //       method(@y x, y) {} // <-- decorator y should be resolved at the class declaration, not the parameter.
                        //   }
                        //
                        if (location.parent && location.parent.kind === 144 /* Parameter */) {
                            location = location.parent;
                        }
                        //
                        //   function y() {}
                        //   class C {
                        //       @y method(x, y) {} // <-- decorator y should be resolved at the class declaration, not the method.
                        //   }
                        //
                        if (location.parent && ts.isClassElement(location.parent)) {
                            location = location.parent;
                        }
                        break;
                }
                lastLocation = location;
                location = location.parent;
            }
            if (result && nameNotFoundMessage && noUnusedIdentifiers) {
                result.isReferenced = true;
            }
            if (!result) {
                result = getSymbol(globals, name, meaning);
            }
            if (!result) {
                if (nameNotFoundMessage) {
                    if (!errorLocation ||
                        !checkAndReportErrorForMissingPrefix(errorLocation, name, nameArg) &&
                            !checkAndReportErrorForExtendingInterface(errorLocation) &&
                            !checkAndReportErrorForUsingTypeAsNamespace(errorLocation, name, meaning) &&
                            !checkAndReportErrorForUsingTypeAsValue(errorLocation, name, meaning)) {
                        error(errorLocation, nameNotFoundMessage, typeof nameArg === "string" ? nameArg : ts.declarationNameToString(nameArg));
                    }
                }
                return undefined;
            }
            // Perform extra checks only if error reporting was requested
            if (nameNotFoundMessage) {
                if (propertyWithInvalidInitializer) {
                    // We have a match, but the reference occurred within a property initializer and the identifier also binds
                    // to a local variable in the constructor where the code will be emitted.
                    var propertyName = propertyWithInvalidInitializer.name;
                    error(errorLocation, ts.Diagnostics.Initializer_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor, ts.declarationNameToString(propertyName), typeof nameArg === "string" ? nameArg : ts.declarationNameToString(nameArg));
                    return undefined;
                }
                // Only check for block-scoped variable if we are looking for the
                // name with variable meaning
                //      For example,
                //          declare module foo {
                //              interface bar {}
                //          }
                //      const foo/*1*/: foo/*2*/.bar;
                // The foo at /*1*/ and /*2*/ will share same symbol with two meaning
                // block - scope variable and namespace module. However, only when we
                // try to resolve name in /*1*/ which is used in variable position,
                // we want to check for block- scoped
                if (meaning & 2 /* BlockScopedVariable */) {
                    var exportOrLocalSymbol = getExportSymbolOfValueSymbolIfExported(result);
                    if (exportOrLocalSymbol.flags & 2 /* BlockScopedVariable */) {
                        checkResolvedBlockScopedVariable(exportOrLocalSymbol, errorLocation);
                    }
                }
                // If we're in an external module, we can't reference value symbols created from UMD export declarations
                if (result && isInExternalModule && (meaning & 107455 /* Value */) === 107455 /* Value */) {
                    var decls = result.declarations;
                    if (decls && decls.length === 1 && decls[0].kind === 233 /* NamespaceExportDeclaration */) {
                        error(errorLocation, ts.Diagnostics._0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead, name);
                    }
                }
            }
            return result;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isGlobalSourceFile) id{560,1} ---
(node) {
            return node.kind === 261 /* SourceFile */ && !ts.isExternalOrCommonJsModule(node);
        }
--- END ---
INLINE (isGlobalSourceFile) id{560,1} AS 1 AT <0:467>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{560,2} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{560,2} AS 2 AT <0:3412>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{560,3} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{560,3} AS 3 AT <2:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{560,4} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{560,4} AS 4 AT <0:7735>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{560,5} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{560,5} AS 5 AT <4:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getExportSymbolOfValueSymbolIfExported) id{560,6} ---
(symbol) {
            return symbol && (symbol.flags & 1048576 /* ExportValue */) !== 0
                ? getMergedSymbol(symbol.exportSymbol)
                : symbol;
        }
--- END ---
INLINE (getExportSymbolOfValueSymbolIfExported) id{560,6} AS 6 AT <0:15249>
[deoptimizing (DEOPT eager): begin 0xd6230dd1771 <JS Function getCombinedNodeFlags (SharedFunctionInfo 0x3504a53df441)> (opt #394) @9, FP to SP delta: 56, caller sp: 0x7fff5fbfd4d0]
            ;;; deoptimize at 0_88: wrong map
  reading input frame getCombinedNodeFlags => node=15, args=2, height=3; inputs:
      0: 0xd6230dd1771 ; [fp - 16] 0xd6230dd1771 <JS Function getCombinedNodeFlags (SharedFunctionInfo 0x3504a53df441)>
      1: 0x16f3adb61821 ; [fp + 24] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x286514c21c31 ; [fp + 16] 0x286514c21c31 <a NodeObject with map 0x33abe2a70101>
      3: 0xd6230dd73d1 ; [fp - 24] 0xd6230dd73d1 <FixedArray[11]>
      4: 0x30bcea404311 ; (literal 3) 0x30bcea404311 <undefined>
      5: 0x286514c21c31 ; rdx 0x286514c21c31 <a NodeObject with map 0x33abe2a70101>
  translating frame getCombinedNodeFlags => node=15, height=16
    0x7fff5fbfd4c8: [top + 56] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfd4c0: [top + 48] <- 0x286514c21c31 ;  0x286514c21c31 <a NodeObject with map 0x33abe2a70101>  (input #2)
    0x7fff5fbfd4b8: [top + 40] <- 0x2c21d258fff4 ;  caller's pc
    0x7fff5fbfd4b0: [top + 32] <- 0x7fff5fbfd4f0 ;  caller's fp
    0x7fff5fbfd4a8: [top + 24] <- 0xd6230dd73d1 ;  context    0xd6230dd73d1 <FixedArray[11]>  (input #3)
    0x7fff5fbfd4a0: [top + 16] <- 0xd6230dd1771 ;  function    0xd6230dd1771 <JS Function getCombinedNodeFlags (SharedFunctionInfo 0x3504a53df441)>  (input #0)
    0x7fff5fbfd498: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfd490: [top + 0] <- 0x286514c21c31 ;  0x286514c21c31 <a NodeObject with map 0x33abe2a70101>  (input #5)
[deoptimizing (eager): end 0xd6230dd1771 <JS Function getCombinedNodeFlags (SharedFunctionInfo 0x3504a53df441)> @9 => node=15, pc=0x2c21d23fe0a1, caller sp=0x7fff5fbfd4d0, state=TOS_REGISTER, took 0.183 ms]
[deoptimizing (DEOPT eager): begin 0xd6230dcdca1 <JS Function isBlockOrCatchScoped (SharedFunctionInfo 0x3504a53ccf59)> (opt #238) @6, FP to SP delta: 32, caller sp: 0x7fff5fbfd510]
            ;;; deoptimize at 2_28: wrong map
  reading input frame isBlockOrCatchScoped => node=46, args=2, height=2; inputs:
      0: 0xd6230dcdca1 ; [fp - 16] 0xd6230dcdca1 <JS Function isBlockOrCatchScoped (SharedFunctionInfo 0x3504a53ccf59)>
      1: 0x16f3adb61821 ; [fp + 24] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x286514c21c31 ; [fp + 16] 0x286514c21c31 <a NodeObject with map 0x33abe2a70101>
      3: 0xd6230db34c9 ; rbx 0xd6230db34c9 <FixedArray[156]>
      4: 0xd6230dcdb39 ; rdx 0xd6230dcdb39 <JS Function isCatchClauseVariableDeclarationOrBindingElement (SharedFunctionInfo 0x3504a53cd019)>
  reading input frame isCatchClauseVariableDeclarationOrBindingElement => node=20, args=2, height=3; inputs:
      0: 0xd6230dcdb39 ; (literal 5) 0xd6230dcdb39 <JS Function isCatchClauseVariableDeclarationOrBindingElement (SharedFunctionInfo 0x3504a53cd019)>
      1: 0x1f9f6c0532e1 ; (literal 6) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x286514c21c31 ; [fp + 16] 0x286514c21c31 <a NodeObject with map 0x33abe2a70101>
      3: 0xd6230db34c9 ; (literal 7) 0xd6230db34c9 <FixedArray[156]>
      4: 0x30bcea404311 ; (literal 8) 0x30bcea404311 <undefined>
      5: 0xd6230dccc29 ; rax 0xd6230dccc29 <JS Function getRootDeclaration (SharedFunctionInfo 0x3504a53d2959)>
  reading input frame getRootDeclaration => node=5, args=2, height=1; inputs:
      0: 0xd6230dccc29 ; (literal 9) 0xd6230dccc29 <JS Function getRootDeclaration (SharedFunctionInfo 0x3504a53d2959)>
      1: 0x1f9f6c0532e1 ; (literal 6) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x286514c21c31 ; rcx 0x286514c21c31 <a NodeObject with map 0x33abe2a70101>
      3: 0xd6230db34c9 ; (literal 7) 0xd6230db34c9 <FixedArray[156]>
  translating frame isBlockOrCatchScoped => node=46, height=8
    0x7fff5fbfd508: [top + 48] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfd500: [top + 40] <- 0x286514c21c31 ;  0x286514c21c31 <a NodeObject with map 0x33abe2a70101>  (input #2)
    0x7fff5fbfd4f8: [top + 32] <- 0x2c21d27613db ;  caller's pc
    0x7fff5fbfd4f0: [top + 24] <- 0x7fff5fbfd528 ;  caller's fp
    0x7fff5fbfd4e8: [top + 16] <- 0xd6230db34c9 ;  context    0xd6230db34c9 <FixedArray[156]>  (input #3)
    0x7fff5fbfd4e0: [top + 8] <- 0xd6230dcdca1 ;  function    0xd6230dcdca1 <JS Function isBlockOrCatchScoped (SharedFunctionInfo 0x3504a53ccf59)>  (input #0)
    0x7fff5fbfd4d8: [top + 0] <- 0xd6230dcdb39 ;  0xd6230dcdb39 <JS Function isCatchClauseVariableDeclarationOrBindingElement (SharedFunctionInfo 0x3504a53cd019)>  (input #4)
  translating frame isCatchClauseVariableDeclarationOrBindingElement => node=20, height=16
    0x7fff5fbfd4d0: [top + 56] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd4c8: [top + 48] <- 0x286514c21c31 ;  0x286514c21c31 <a NodeObject with map 0x33abe2a70101>  (input #2)
    0x7fff5fbfd4c0: [top + 40] <- 0x2c21d23fdf9f ;  caller's pc
    0x7fff5fbfd4b8: [top + 32] <- 0x7fff5fbfd4f0 ;  caller's fp
    0x7fff5fbfd4b0: [top + 24] <- 0xd6230db34c9 ;  context    0xd6230db34c9 <FixedArray[156]>  (input #3)
    0x7fff5fbfd4a8: [top + 16] <- 0xd6230dcdb39 ;  function    0xd6230dcdb39 <JS Function isCatchClauseVariableDeclarationOrBindingElement (SharedFunctionInfo 0x3504a53cd019)>  (input #0)
    0x7fff5fbfd4a0: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfd498: [top + 0] <- 0xd6230dccc29 ;  0xd6230dccc29 <JS Function getRootDeclaration (SharedFunctionInfo 0x3504a53d2959)>  (input #5)
  translating frame getRootDeclaration => node=5, height=0
    0x7fff5fbfd490: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd488: [top + 32] <- 0x286514c21c31 ;  0x286514c21c31 <a NodeObject with map 0x33abe2a70101>  (input #2)
    0x7fff5fbfd480: [top + 24] <- 0x2c21d2573abc ;  caller's pc
    0x7fff5fbfd478: [top + 16] <- 0x7fff5fbfd4b8 ;  caller's fp
    0x7fff5fbfd470: [top + 8] <- 0xd6230db34c9 ;  context    0xd6230db34c9 <FixedArray[156]>  (input #3)
    0x7fff5fbfd468: [top + 0] <- 0xd6230dccc29 ;  function    0xd6230dccc29 <JS Function getRootDeclaration (SharedFunctionInfo 0x3504a53d2959)>  (input #0)
[deoptimizing (eager): end 0xd6230dcdca1 <JS Function isBlockOrCatchScoped (SharedFunctionInfo 0x3504a53ccf59)> @6 => node=5, pc=0x2c21d2573d53, caller sp=0x7fff5fbfd510, state=NO_REGISTERS, took 0.185 ms]
[deoptimizing (DEOPT eager): begin 0x130b7e1b6811 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)> (opt #560) @115, FP to SP delta: 312, caller sp: 0x7fff5fbfd798]
            ;;; deoptimize at 6_47: wrong map
  reading input frame resolveName => node=2270, args=6, height=18; inputs:
      0: 0x130b7e1b6811 ; [fp - 16] 0x130b7e1b6811 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)>
      1: 0x1f9f6c0532e1 ; [fp + 56] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x30bcea404311 ; [fp - 32] 0x30bcea404311 <undefined>
      3: 0x2f05bb8a5311 ; [fp + 40] 0x2f05bb8a5311 <String[5]: Error>
      4: 0x11a3bf00000000 ; [fp + 32] 1156031
      5: 0xd6230ded3a9 ; rcx 0xd6230ded3a9 <an Object with map 0x33abe2a3df61>
      6: 0x2f05bb8f23d1 ; [fp + 16] 0x2f05bb8f23d1 <an IdentifierObject with map 0x15b5a79122d1>
      7: 0x130b7e1b3d29 ; r8 0x130b7e1b3d29 <FixedArray[1022]>
      8: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
      9: 0x2069ac90bd9 ; rax 0x2069ac90bd9 <a SymbolObject with map 0x33abe2a74ca1>
     10: 0x30bcea4069a9 ; (literal 14) 0x30bcea4069a9 <Odd Oddball: optimized_out>
     11: 0x30bcea4069a9 ; (literal 14) 0x30bcea4069a9 <Odd Oddball: optimized_out>
     12: 0x2f05bb8f23d1 ; [fp + 48] 0x2f05bb8f23d1 <an IdentifierObject with map 0x15b5a79122d1>
     13: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     14: 0x30bcea404421 ; [fp - 160] 0x30bcea404421 <false>
     15: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     16: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     17: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     18: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     19: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     20: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     21: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     22: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     23: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     24: 0x1030c9d53341 ; rbx 0x1030c9d53341 <JS Function getExportSymbolOfValueSymbolIfExported (SharedFunctionInfo 0x2e2f693e9c91)>
  reading input frame getExportSymbolOfValueSymbolIfExported => node=11, args=2, height=1; inputs:
      0: 0x1030c9d53341 ; (literal 17) 0x1030c9d53341 <JS Function getExportSymbolOfValueSymbolIfExported (SharedFunctionInfo 0x2e2f693e9c91)>
      1: 0x1f9f6c0532e1 ; (literal 11) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2069ac90bd9 ; rax 0x2069ac90bd9 <a SymbolObject with map 0x33abe2a74ca1>
      3: 0x130b7e1b3d29 ; (literal 12) 0x130b7e1b3d29 <FixedArray[1022]>
  translating frame resolveName => node=2270, height=136
    0x7fff5fbfd790: [top + 208] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd788: [top + 200] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #2)
    0x7fff5fbfd780: [top + 192] <- 0x2f05bb8a5311 ;  0x2f05bb8a5311 <String[5]: Error>  (input #3)
    0x7fff5fbfd778: [top + 184] <- 0x11a3bf00000000 ;  1156031  (input #4)
    0x7fff5fbfd770: [top + 176] <- 0xd6230ded3a9 ;  0xd6230ded3a9 <an Object with map 0x33abe2a3df61>  (input #5)
    0x7fff5fbfd768: [top + 168] <- 0x2f05bb8f23d1 ;  0x2f05bb8f23d1 <an IdentifierObject with map 0x15b5a79122d1>  (input #6)
    0x7fff5fbfd760: [top + 160] <- 0x2c21d272b66f ;  caller's pc
    0x7fff5fbfd758: [top + 152] <- 0x7fff5fbfd7c0 ;  caller's fp
    0x7fff5fbfd750: [top + 144] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #7)
    0x7fff5fbfd748: [top + 136] <- 0x130b7e1b6811 ;  function    0x130b7e1b6811 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)>  (input #0)
    0x7fff5fbfd740: [top + 128] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfd738: [top + 120] <- 0x2069ac90bd9 ;  0x2069ac90bd9 <a SymbolObject with map 0x33abe2a74ca1>  (input #9)
    0x7fff5fbfd730: [top + 112] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #10)
    0x7fff5fbfd728: [top + 104] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #11)
    0x7fff5fbfd720: [top + 96] <- 0x2f05bb8f23d1 ;  0x2f05bb8f23d1 <an IdentifierObject with map 0x15b5a79122d1>  (input #12)
    0x7fff5fbfd718: [top + 88] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #13)
    0x7fff5fbfd710: [top + 80] <- 0x30bcea404421 ;  0x30bcea404421 <false>  (input #14)
    0x7fff5fbfd708: [top + 72] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #15)
    0x7fff5fbfd700: [top + 64] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #16)
    0x7fff5fbfd6f8: [top + 56] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #17)
    0x7fff5fbfd6f0: [top + 48] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #18)
    0x7fff5fbfd6e8: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #19)
    0x7fff5fbfd6e0: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #20)
    0x7fff5fbfd6d8: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #21)
    0x7fff5fbfd6d0: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #22)
    0x7fff5fbfd6c8: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #23)
    0x7fff5fbfd6c0: [top + 0] <- 0x1030c9d53341 ;  0x1030c9d53341 <JS Function getExportSymbolOfValueSymbolIfExported (SharedFunctionInfo 0x2e2f693e9c91)>  (input #24)
  translating frame getExportSymbolOfValueSymbolIfExported => node=11, height=0
    0x7fff5fbfd6b8: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd6b0: [top + 32] <- 0x2069ac90bd9 ;  0x2069ac90bd9 <a SymbolObject with map 0x33abe2a74ca1>  (input #2)
    0x7fff5fbfd6a8: [top + 24] <- 0x2c21d25e6726 ;  caller's pc
    0x7fff5fbfd6a0: [top + 16] <- 0x7fff5fbfd758 ;  caller's fp
    0x7fff5fbfd698: [top + 8] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd690: [top + 0] <- 0x1030c9d53341 ;  function    0x1030c9d53341 <JS Function getExportSymbolOfValueSymbolIfExported (SharedFunctionInfo 0x2e2f693e9c91)>  (input #0)
[deoptimizing (eager): end 0x130b7e1b6811 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)> @115 => node=11, pc=0x2c21d272b867, caller sp=0x7fff5fbfd798, state=NO_REGISTERS, took 0.732 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isAmbientModule) id{561,0} ---
(node) {
        return node && node.kind === 230 /* ModuleDeclaration */ &&
            (node.name.kind === 9 /* StringLiteral */ || isGlobalScopeAugmentation(node));
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isGlobalScopeAugmentation) id{561,1} ---
(module) {
        return !!(module.flags & 512 /* GlobalAugmentation */);
    }
--- END ---
INLINE (isGlobalScopeAugmentation) id{561,1} AS 1 AT <0:134>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isExternalOrCommonJsModule) id{562,0} ---
(file) {
        return (file.externalModuleIndicator || file.commonJsModuleIndicator) !== undefined;
    }
--- END ---
[deoptimizing (DEOPT eager): begin 0xd6230dcf5f1 <JS Function nodeIsMissing (SharedFunctionInfo 0x3504a53cc419)> (opt #531) @2, FP to SP delta: 24, caller sp: 0x7fff5fbfd798]
  reading input frame nodeIsMissing => node=7, args=2, height=1; inputs:
      0: 0xd6230dcf5f1 ; [fp - 16] 0xd6230dcf5f1 <JS Function nodeIsMissing (SharedFunctionInfo 0x3504a53cc419)>
      1: 0x16f3adb61821 ; [fp + 24] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x2f05bb8f32c1 ; rax 0x2f05bb8f32c1 <an IdentifierObject with map 0x33abe2a6db89>
      3: 0xd6230db34c9 ; [fp - 24] 0xd6230db34c9 <FixedArray[156]>
  translating frame nodeIsMissing => node=7, height=0
    0x7fff5fbfd790: [top + 40] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfd788: [top + 32] <- 0x2f05bb8f32c1 ;  0x2f05bb8f32c1 <an IdentifierObject with map 0x33abe2a6db89>  (input #2)
    0x7fff5fbfd780: [top + 24] <- 0x2c21d272b585 ;  caller's pc
    0x7fff5fbfd778: [top + 16] <- 0x7fff5fbfd7c0 ;  caller's fp
    0x7fff5fbfd770: [top + 8] <- 0xd6230db34c9 ;  context    0xd6230db34c9 <FixedArray[156]>  (input #3)
    0x7fff5fbfd768: [top + 0] <- 0xd6230dcf5f1 ;  function    0xd6230dcf5f1 <JS Function nodeIsMissing (SharedFunctionInfo 0x3504a53cc419)>  (input #0)
[deoptimizing (eager): end 0xd6230dcf5f1 <JS Function nodeIsMissing (SharedFunctionInfo 0x3504a53cc419)> @2 => node=7, pc=0x2c21d2527f70, caller sp=0x7fff5fbfd798, state=NO_REGISTERS, took 0.084 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveName) id{563,0} ---
(location, name, meaning, nameNotFoundMessage, nameArg) {
            var result;
            var lastLocation;
            var propertyWithInvalidInitializer;
            var errorLocation = location;
            var grandparent;
            var isInExternalModule = false;
            loop: while (location) {
                // Locals of a source file are not in scope (because they get merged into the global symbol table)
                if (location.locals && !isGlobalSourceFile(location)) {
                    if (result = getSymbol(location.locals, name, meaning)) {
                        var useResult = true;
                        if (ts.isFunctionLike(location) && lastLocation && lastLocation !== location.body) {
                            // symbol lookup restrictions for function-like declarations
                            // - Type parameters of a function are in scope in the entire function declaration, including the parameter
                            //   list and return type. However, local types are only in scope in the function body.
                            // - parameters are only in the scope of function body
                            // This restriction does not apply to JSDoc comment types because they are parented
                            // at a higher level than type parameters would normally be
                            if (meaning & result.flags & 793064 /* Type */ && lastLocation.kind !== 278 /* JSDocComment */) {
                                useResult = result.flags & 262144 /* TypeParameter */
                                    ? lastLocation === location.type ||
                                        lastLocation.kind === 144 /* Parameter */ ||
                                        lastLocation.kind === 143 /* TypeParameter */
                                    : false;
                            }
                            if (meaning & 107455 /* Value */ && result.flags & 1 /* FunctionScopedVariable */) {
                                // parameters are visible only inside function body, parameter list and return type
                                // technically for parameter list case here we might mix parameters and variables declared in function,
                                // however it is detected separately when checking initializers of parameters
                                // to make sure that they reference no variables declared after them.
                                useResult =
                                    lastLocation.kind === 144 /* Parameter */ ||
                                        (lastLocation === location.type &&
                                            result.valueDeclaration.kind === 144 /* Parameter */);
                            }
                        }
                        if (useResult) {
                            break loop;
                        }
                        else {
                            result = undefined;
                        }
                    }
                }
                switch (location.kind) {
                    case 261 /* SourceFile */:
                        if (!ts.isExternalOrCommonJsModule(location))
                            break;
                        isInExternalModule = true;
                    case 230 /* ModuleDeclaration */:
                        var moduleExports = getSymbolOfNode(location).exports;
                        if (location.kind === 261 /* SourceFile */ || ts.isAmbientModule(location)) {
                            // It's an external module. First see if the module has an export default and if the local
                            // name of that export default matches.
                            if (result = moduleExports["default"]) {
                                var localSymbol = ts.getLocalSymbolForExportDefault(result);
                                if (localSymbol && (result.flags & meaning) && localSymbol.name === name) {
                                    break loop;
                                }
                                result = undefined;
                            }
                            // Because of module/namespace merging, a module's exports are in scope,
                            // yet we never want to treat an export specifier as putting a member in scope.
                            // Therefore, if the name we find is purely an export specifier, it is not actually considered in scope.
                            // Two things to note about this:
                            //     1. We have to check this without calling getSymbol. The problem with calling getSymbol
                            //        on an export specifier is that it might find the export specifier itself, and try to
                            //        resolve it as an alias. This will cause the checker to consider the export specifier
                            //        a circular alias reference when it might not be.
                            //     2. We check === SymbolFlags.Alias in order to check that the symbol is *purely*
                            //        an alias. If we used &, we'd be throwing out symbols that have non alias aspects,
                            //        which is not the desired behavior.
                            if (moduleExports[name] &&
                                moduleExports[name].flags === 8388608 /* Alias */ &&
                                ts.getDeclarationOfKind(moduleExports[name], 243 /* ExportSpecifier */)) {
                                break;
                            }
                        }
                        if (result = getSymbol(moduleExports, name, meaning & 8914931 /* ModuleMember */)) {
                            break loop;
                        }
                        break;
                    case 229 /* EnumDeclaration */:
                        if (result = getSymbol(getSymbolOfNode(location).exports, name, meaning & 8 /* EnumMember */)) {
                            break loop;
                        }
                        break;
                    case 147 /* PropertyDeclaration */:
                    case 146 /* PropertySignature */:
                        // TypeScript 1.0 spec (April 2014): 8.4.1
                        // Initializer expressions for instance member variables are evaluated in the scope
                        // of the class constructor body but are not permitted to reference parameters or
                        // local variables of the constructor. This effectively means that entities from outer scopes
                        // by the same name as a constructor parameter or local variable are inaccessible
                        // in initializer expressions for instance member variables.
                        if (ts.isClassLike(location.parent) && !(ts.getModifierFlags(location) & 32 /* Static */)) {
                            var ctor = findConstructorDeclaration(location.parent);
                            if (ctor && ctor.locals) {
                                if (getSymbol(ctor.locals, name, meaning & 107455 /* Value */)) {
                                    // Remember the property node, it will be used later to report appropriate error
                                    propertyWithInvalidInitializer = location;
                                }
                            }
                        }
                        break;
                    case 226 /* ClassDeclaration */:
                    case 197 /* ClassExpression */:
                    case 227 /* InterfaceDeclaration */:
                        if (result = getSymbol(getSymbolOfNode(location).members, name, meaning & 793064 /* Type */)) {
                            if (lastLocation && ts.getModifierFlags(lastLocation) & 32 /* Static */) {
                                // TypeScript 1.0 spec (April 2014): 3.4.1
                                // The scope of a type parameter extends over the entire declaration with which the type
                                // parameter list is associated, with the exception of static member declarations in classes.
                                error(errorLocation, ts.Diagnostics.Static_members_cannot_reference_class_type_parameters);
                                return undefined;
                            }
                            break loop;
                        }
                        if (location.kind === 197 /* ClassExpression */ && meaning & 32 /* Class */) {
                            var className = location.name;
                            if (className && name === className.text) {
                                result = location.symbol;
                                break loop;
                            }
                        }
                        break;
                    // It is not legal to reference a class's own type parameters from a computed property name that
                    // belongs to the class. For example:
                    //
                    //   function foo<T>() { return '' }
                    //   class C<T> { // <-- Class's own type parameter T
                    //       [foo<T>()]() { } // <-- Reference to T from class's own computed property
                    //   }
                    //
                    case 142 /* ComputedPropertyName */:
                        grandparent = location.parent.parent;
                        if (ts.isClassLike(grandparent) || grandparent.kind === 227 /* InterfaceDeclaration */) {
                            // A reference to this grandparent's type parameters would be an error
                            if (result = getSymbol(getSymbolOfNode(grandparent).members, name, meaning & 793064 /* Type */)) {
                                error(errorLocation, ts.Diagnostics.A_computed_property_name_cannot_reference_a_type_parameter_from_its_containing_type);
                                return undefined;
                            }
                        }
                        break;
                    case 149 /* MethodDeclaration */:
                    case 148 /* MethodSignature */:
                    case 150 /* Constructor */:
                    case 151 /* GetAccessor */:
                    case 152 /* SetAccessor */:
                    case 225 /* FunctionDeclaration */:
                    case 185 /* ArrowFunction */:
                        if (meaning & 3 /* Variable */ && name === "arguments") {
                            result = argumentsSymbol;
                            break loop;
                        }
                        break;
                    case 184 /* FunctionExpression */:
                        if (meaning & 3 /* Variable */ && name === "arguments") {
                            result = argumentsSymbol;
                            break loop;
                        }
                        if (meaning & 16 /* Function */) {
                            var functionName = location.name;
                            if (functionName && name === functionName.text) {
                                result = location.symbol;
                                break loop;
                            }
                        }
                        break;
                    case 145 /* Decorator */:
                        // Decorators are resolved at the class declaration. Resolving at the parameter
                        // or member would result in looking up locals in the method.
                        //
                        //   function y() {}
                        //   class C {
                        //       method(@y x, y) {} // <-- decorator y should be resolved at the class declaration, not the parameter.
                        //   }
                        //
                        if (location.parent && location.parent.kind === 144 /* Parameter */) {
                            location = location.parent;
                        }
                        //
                        //   function y() {}
                        //   class C {
                        //       @y method(x, y) {} // <-- decorator y should be resolved at the class declaration, not the method.
                        //   }
                        //
                        if (location.parent && ts.isClassElement(location.parent)) {
                            location = location.parent;
                        }
                        break;
                }
                lastLocation = location;
                location = location.parent;
            }
            if (result && nameNotFoundMessage && noUnusedIdentifiers) {
                result.isReferenced = true;
            }
            if (!result) {
                result = getSymbol(globals, name, meaning);
            }
            if (!result) {
                if (nameNotFoundMessage) {
                    if (!errorLocation ||
                        !checkAndReportErrorForMissingPrefix(errorLocation, name, nameArg) &&
                            !checkAndReportErrorForExtendingInterface(errorLocation) &&
                            !checkAndReportErrorForUsingTypeAsNamespace(errorLocation, name, meaning) &&
                            !checkAndReportErrorForUsingTypeAsValue(errorLocation, name, meaning)) {
                        error(errorLocation, nameNotFoundMessage, typeof nameArg === "string" ? nameArg : ts.declarationNameToString(nameArg));
                    }
                }
                return undefined;
            }
            // Perform extra checks only if error reporting was requested
            if (nameNotFoundMessage) {
                if (propertyWithInvalidInitializer) {
                    // We have a match, but the reference occurred within a property initializer and the identifier also binds
                    // to a local variable in the constructor where the code will be emitted.
                    var propertyName = propertyWithInvalidInitializer.name;
                    error(errorLocation, ts.Diagnostics.Initializer_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor, ts.declarationNameToString(propertyName), typeof nameArg === "string" ? nameArg : ts.declarationNameToString(nameArg));
                    return undefined;
                }
                // Only check for block-scoped variable if we are looking for the
                // name with variable meaning
                //      For example,
                //          declare module foo {
                //              interface bar {}
                //          }
                //      const foo/*1*/: foo/*2*/.bar;
                // The foo at /*1*/ and /*2*/ will share same symbol with two meaning
                // block - scope variable and namespace module. However, only when we
                // try to resolve name in /*1*/ which is used in variable position,
                // we want to check for block- scoped
                if (meaning & 2 /* BlockScopedVariable */) {
                    var exportOrLocalSymbol = getExportSymbolOfValueSymbolIfExported(result);
                    if (exportOrLocalSymbol.flags & 2 /* BlockScopedVariable */) {
                        checkResolvedBlockScopedVariable(exportOrLocalSymbol, errorLocation);
                    }
                }
                // If we're in an external module, we can't reference value symbols created from UMD export declarations
                if (result && isInExternalModule && (meaning & 107455 /* Value */) === 107455 /* Value */) {
                    var decls = result.declarations;
                    if (decls && decls.length === 1 && decls[0].kind === 233 /* NamespaceExportDeclaration */) {
                        error(errorLocation, ts.Diagnostics._0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead, name);
                    }
                }
            }
            return result;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isGlobalSourceFile) id{563,1} ---
(node) {
            return node.kind === 261 /* SourceFile */ && !ts.isExternalOrCommonJsModule(node);
        }
--- END ---
INLINE (isGlobalSourceFile) id{563,1} AS 1 AT <0:467>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{563,2} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{563,2} AS 2 AT <0:3412>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{563,3} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{563,3} AS 3 AT <2:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{563,4} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{563,4} AS 4 AT <0:7735>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{563,5} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{563,5} AS 5 AT <4:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getExportSymbolOfValueSymbolIfExported) id{563,6} ---
(symbol) {
            return symbol && (symbol.flags & 1048576 /* ExportValue */) !== 0
                ? getMergedSymbol(symbol.exportSymbol)
                : symbol;
        }
--- END ---
INLINE (getExportSymbolOfValueSymbolIfExported) id{563,6} AS 6 AT <0:15249>
[deoptimizing (DEOPT eager): begin 0x1030c9d3fe01 <JS Function needCollisionCheckForIdentifier (SharedFunctionInfo 0x1b98fbc0ca81)> (opt #551) @3, FP to SP delta: 48, caller sp: 0x7fff5fbfd790]
            ;;; deoptimize at 0_69: Unknown map in polymorphic access
  reading input frame needCollisionCheckForIdentifier => node=17, args=4, height=2; inputs:
      0: 0x1030c9d3fe01 ; [fp - 16] 0x1030c9d3fe01 <JS Function needCollisionCheckForIdentifier (SharedFunctionInfo 0x1b98fbc0ca81)>
      1: 0x1f9f6c0532e1 ; [fp + 40] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2f05bb8f32c1 ; [fp + 32] 0x2f05bb8f32c1 <an IdentifierObject with map 0x33abe2a6db89>
      3: 0x2f05bb8f32c1 ; rbx 0x2f05bb8f32c1 <an IdentifierObject with map 0x33abe2a6db89>
      4: 0x3504a53bc5e1 ; [fp + 16] 0x3504a53bc5e1 <String[6]: _super>
      5: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      6: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
  translating frame needCollisionCheckForIdentifier => node=17, height=8
    0x7fff5fbfd788: [top + 64] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd780: [top + 56] <- 0x2f05bb8f32c1 ;  0x2f05bb8f32c1 <an IdentifierObject with map 0x33abe2a6db89>  (input #2)
    0x7fff5fbfd778: [top + 48] <- 0x2f05bb8f32c1 ;  0x2f05bb8f32c1 <an IdentifierObject with map 0x33abe2a6db89>  (input #3)
    0x7fff5fbfd770: [top + 40] <- 0x3504a53bc5e1 ;  0x3504a53bc5e1 <String[6]: _super>  (input #4)
    0x7fff5fbfd768: [top + 32] <- 0x2c21d25fabcd ;  caller's pc
    0x7fff5fbfd760: [top + 24] <- 0x7fff5fbfd7b8 ;  caller's fp
    0x7fff5fbfd758: [top + 16] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #5)
    0x7fff5fbfd750: [top + 8] <- 0x1030c9d3fe01 ;  function    0x1030c9d3fe01 <JS Function needCollisionCheckForIdentifier (SharedFunctionInfo 0x1b98fbc0ca81)>  (input #0)
    0x7fff5fbfd748: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
[deoptimizing (eager): end 0x1030c9d3fe01 <JS Function needCollisionCheckForIdentifier (SharedFunctionInfo 0x1b98fbc0ca81)> @3 => node=17, pc=0x2c21d25faf6b, caller sp=0x7fff5fbfd790, state=NO_REGISTERS, took 0.068 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d3f861 <JS Function getTypeOfVariableOrParameterOrProperty (SharedFunctionInfo 0x2e2f693ec8d1)> (opt #532) @16, FP to SP delta: 80, caller sp: 0x7fff5fbfd7a8]
            ;;; deoptimize at 0_81: Unknown map in polymorphic access
  reading input frame getTypeOfVariableOrParameterOrProperty => node=30, args=2, height=7; inputs:
      0: 0x1030c9d3f861 ; [fp - 16] 0x1030c9d3f861 <JS Function getTypeOfVariableOrParameterOrProperty (SharedFunctionInfo 0x2e2f693ec8d1)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1030c9d51581 ; [fp + 16] 0x1030c9d51581 <a SymbolObject with map 0x33abe2a72af1>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
      5: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
      6: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
      7: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
      9: 0x1030c9d51581 ; rax 0x1030c9d51581 <a SymbolObject with map 0x33abe2a72af1>
  translating frame getTypeOfVariableOrParameterOrProperty => node=30, height=48
    0x7fff5fbfd7a0: [top + 88] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd798: [top + 80] <- 0x1030c9d51581 ;  0x1030c9d51581 <a SymbolObject with map 0x33abe2a72af1>  (input #2)
    0x7fff5fbfd790: [top + 72] <- 0x2c21d261cd6e ;  caller's pc
    0x7fff5fbfd788: [top + 64] <- 0x7fff5fbfd7c0 ;  caller's fp
    0x7fff5fbfd780: [top + 56] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd778: [top + 48] <- 0x1030c9d3f861 ;  function    0x1030c9d3f861 <JS Function getTypeOfVariableOrParameterOrProperty (SharedFunctionInfo 0x2e2f693ec8d1)>  (input #0)
    0x7fff5fbfd770: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfd768: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfd760: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfd758: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfd750: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfd748: [top + 0] <- 0x1030c9d51581 ;  0x1030c9d51581 <a SymbolObject with map 0x33abe2a72af1>  (input #9)
[deoptimizing (eager): end 0x1030c9d3f861 <JS Function getTypeOfVariableOrParameterOrProperty (SharedFunctionInfo 0x2e2f693ec8d1)> @16 => node=30, pc=0x2c21d25f5489, caller sp=0x7fff5fbfd7a8, state=TOS_REGISTER, took 0.092 ms]
[deoptimizing (DEOPT lazy): begin 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> (opt #392) @40, FP to SP delta: 192, caller sp: 0x7fff5fbfdf28]
  reading input frame checkSourceElement => node=580, args=2, height=5; inputs:
      0: 0x130b7e1b6059 ; [fp - 16] 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2f05bb8a8f49 ; [fp + 16] 0x2f05bb8a8f49 <a NodeObject with map 0x33abe2a71b79>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 31) 0x30bcea404311 <undefined>
      5: 0x30bcea4069a9 ; (literal 32) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      6: 0x30bcea4069a9 ; (literal 32) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x30bcea404311 ; rax 0x30bcea404311 <undefined>
  translating frame checkSourceElement => node=580, height=32
    0x7fff5fbfdf20: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdf18: [top + 64] <- 0x2f05bb8a8f49 ;  0x2f05bb8a8f49 <a NodeObject with map 0x33abe2a71b79>  (input #2)
    0x7fff5fbfdf10: [top + 56] <- 0x2c21d268616c ;  caller's pc
    0x7fff5fbfdf08: [top + 48] <- 0x7fff5fbfdf98 ;  caller's fp
    0x7fff5fbfdf00: [top + 40] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdef8: [top + 32] <- 0x130b7e1b6059 ;  function    0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>  (input #0)
    0x7fff5fbfdef0: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfdee8: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #5)
    0x7fff5fbfdee0: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfded8: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
[deoptimizing (lazy): end 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> @40 => node=580, pc=0x2c21d25ec3f2, caller sp=0x7fff5fbfdf28, state=TOS_REGISTER, took 0.066 ms]
[deoptimizing (DEOPT lazy): begin 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> (opt #392) @13, FP to SP delta: 192, caller sp: 0x7fff5fbfe098]
  reading input frame checkSourceElement => node=1005, args=2, height=5; inputs:
      0: 0x130b7e1b6059 ; [fp - 16] 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2f05bb89ce69 ; [fp + 16] 0x2f05bb89ce69 <a NodeObject with map 0x33abe2a71231>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 31) 0x30bcea404311 <undefined>
      5: 0x30bcea4069a9 ; (literal 32) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      6: 0x30bcea4069a9 ; (literal 32) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x30bcea404311 ; rax 0x30bcea404311 <undefined>
  translating frame checkSourceElement => node=1005, height=32
    0x7fff5fbfe090: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfe088: [top + 64] <- 0x2f05bb89ce69 ;  0x2f05bb89ce69 <a NodeObject with map 0x33abe2a71231>  (input #2)
    0x7fff5fbfe080: [top + 56] <- 0x2c21d2207e55 ;  caller's pc
    0x7fff5fbfe078: [top + 48] <- 0x7fff5fbfe0b0 ;  caller's fp
    0x7fff5fbfe070: [top + 40] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfe068: [top + 32] <- 0x130b7e1b6059 ;  function    0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>  (input #0)
    0x7fff5fbfe060: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfe058: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #5)
    0x7fff5fbfe050: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfe048: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
[deoptimizing (lazy): end 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> @13 => node=1005, pc=0x2c21d25ec828, caller sp=0x7fff5fbfe098, state=TOS_REGISTER, took 0.056 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d41a69 <JS Function symbolIsValue (SharedFunctionInfo 0x2e2f693e9d51)> (opt #545) @22, FP to SP delta: 56, caller sp: 0x7fff5fbfd6a8]
            ;;; deoptimize at 0_266: wrong map
  reading input frame symbolIsValue => node=42, args=2, height=4; inputs:
      0: 0x1030c9d41a69 ; [fp - 16] 0x1030c9d41a69 <JS Function symbolIsValue (SharedFunctionInfo 0x2e2f693e9d51)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x32c5a0dd4021 ; [fp + 16] 0x32c5a0dd4021 <a SymbolObject with map 0x33abe2a749e1>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x1030c9d41a69 ; [fp - 32] 0x1030c9d41a69 <JS Function symbolIsValue (SharedFunctionInfo 0x2e2f693e9d51)>
      5: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
      6: 0x32c5a0dd4021 ; rax 0x32c5a0dd4021 <a SymbolObject with map 0x33abe2a749e1>
  translating frame symbolIsValue => node=42, height=24
    0x7fff5fbfd6a0: [top + 64] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd698: [top + 56] <- 0x32c5a0dd4021 ;  0x32c5a0dd4021 <a SymbolObject with map 0x33abe2a749e1>  (input #2)
    0x7fff5fbfd690: [top + 48] <- 0x2c21d262ff9b ;  caller's pc
    0x7fff5fbfd688: [top + 40] <- 0x7fff5fbfd6d8 ;  caller's fp
    0x7fff5fbfd680: [top + 32] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd678: [top + 24] <- 0x1030c9d41a69 ;  function    0x1030c9d41a69 <JS Function symbolIsValue (SharedFunctionInfo 0x2e2f693e9d51)>  (input #0)
    0x7fff5fbfd670: [top + 16] <- 0x1030c9d41a69 ;  0x1030c9d41a69 <JS Function symbolIsValue (SharedFunctionInfo 0x2e2f693e9d51)>  (input #4)
    0x7fff5fbfd668: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfd660: [top + 0] <- 0x32c5a0dd4021 ;  0x32c5a0dd4021 <a SymbolObject with map 0x33abe2a749e1>  (input #6)
[deoptimizing (eager): end 0x1030c9d41a69 <JS Function symbolIsValue (SharedFunctionInfo 0x2e2f693e9d51)> @22 => node=42, pc=0x2c21d260e15f, caller sp=0x7fff5fbfd6a8, state=TOS_REGISTER, took 0.068 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateTypes) id{564,0} ---
(types, mapper) {
            return instantiateList(types, mapper, instantiateType);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateList) id{564,1} ---
(items, mapper, instantiator) {
            if (items && items.length) {
                var result = [];
                for (var _i = 0, items_1 = items; _i < items_1.length; _i++) {
                    var v = items_1[_i];
                    result.push(instantiator(v, mapper));
                }
                return result;
            }
            return items;
        }
--- END ---
INLINE (instantiateList) id{564,1} AS 1 AT <0:37>
[deoptimizing (DEOPT eager): begin 0x130b7e1b65d1 <JS Function instantiateTypes (SharedFunctionInfo 0x2e2f693f5701)> (opt #564) @4, FP to SP delta: 56, caller sp: 0x7fff5fbfd260]
            ;;; deoptimize at 1_62: wrong map
  reading input frame instantiateTypes => node=7, args=3, height=2; inputs:
      0: 0x130b7e1b65d1 ; [fp - 16] 0x130b7e1b65d1 <JS Function instantiateTypes (SharedFunctionInfo 0x2e2f693f5701)>
      1: 0x1f9f6c0532e1 ; [fp + 32] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x32c5a0de4919 ; r8 0x32c5a0de4919 <JS Array[3]>
      3: 0x32c5a0dd2329 ; [fp + 16] 0x32c5a0dd2329 <JS Function (SharedFunctionInfo 0x371f85cf0581)>
      4: 0x130b7e1b3d29 ; rbx 0x130b7e1b3d29 <FixedArray[1022]>
      5: 0x1030c9d44191 ; rdx 0x1030c9d44191 <JS Function instantiateList (SharedFunctionInfo 0x2e2f693f5641)>
  reading input frame instantiateList => node=22, args=4, height=5; inputs:
      0: 0x1030c9d44191 ; (literal 3) 0x1030c9d44191 <JS Function instantiateList (SharedFunctionInfo 0x2e2f693f5641)>
      1: 0x1f9f6c0532e1 ; (literal 4) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x32c5a0de4919 ; r8 0x32c5a0de4919 <JS Array[3]>
      3: 0x32c5a0dd2329 ; [fp + 16] 0x32c5a0dd2329 <JS Function (SharedFunctionInfo 0x371f85cf0581)>
      4: 0x130b7e1b6661 ; rcx 0x130b7e1b6661 <JS Function instantiateType (SharedFunctionInfo 0x2e2f693f66c1)>
      5: 0x130b7e1b3d29 ; (literal 5) 0x130b7e1b3d29 <FixedArray[1022]>
      6: 0x30bcea404311 ; (literal 6) 0x30bcea404311 <undefined>
      7: 0x30bcea404311 ; (literal 6) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; (literal 6) 0x30bcea404311 <undefined>
      9: 0x30bcea404311 ; (literal 6) 0x30bcea404311 <undefined>
  translating frame instantiateTypes => node=7, height=8
    0x7fff5fbfd258: [top + 56] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd250: [top + 48] <- 0x32c5a0de4919 ;  0x32c5a0de4919 <JS Array[3]>  (input #2)
    0x7fff5fbfd248: [top + 40] <- 0x32c5a0dd2329 ;  0x32c5a0dd2329 <JS Function (SharedFunctionInfo 0x371f85cf0581)>  (input #3)
    0x7fff5fbfd240: [top + 32] <- 0x2c21d261b397 ;  caller's pc
    0x7fff5fbfd238: [top + 24] <- 0x7fff5fbfd288 ;  caller's fp
    0x7fff5fbfd230: [top + 16] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #4)
    0x7fff5fbfd228: [top + 8] <- 0x130b7e1b65d1 ;  function    0x130b7e1b65d1 <JS Function instantiateTypes (SharedFunctionInfo 0x2e2f693f5701)>  (input #0)
    0x7fff5fbfd220: [top + 0] <- 0x1030c9d44191 ;  0x1030c9d44191 <JS Function instantiateList (SharedFunctionInfo 0x2e2f693f5641)>  (input #5)
  translating frame instantiateList => node=22, height=32
    0x7fff5fbfd218: [top + 88] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd210: [top + 80] <- 0x32c5a0de4919 ;  0x32c5a0de4919 <JS Array[3]>  (input #2)
    0x7fff5fbfd208: [top + 72] <- 0x32c5a0dd2329 ;  0x32c5a0dd2329 <JS Function (SharedFunctionInfo 0x371f85cf0581)>  (input #3)
    0x7fff5fbfd200: [top + 64] <- 0x130b7e1b6661 ;  0x130b7e1b6661 <JS Function instantiateType (SharedFunctionInfo 0x2e2f693f66c1)>  (input #4)
    0x7fff5fbfd1f8: [top + 56] <- 0x2c21d261c704 ;  caller's pc
    0x7fff5fbfd1f0: [top + 48] <- 0x7fff5fbfd238 ;  caller's fp
    0x7fff5fbfd1e8: [top + 40] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #5)
    0x7fff5fbfd1e0: [top + 32] <- 0x1030c9d44191 ;  function    0x1030c9d44191 <JS Function instantiateList (SharedFunctionInfo 0x2e2f693f5641)>  (input #0)
    0x7fff5fbfd1d8: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfd1d0: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfd1c8: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfd1c0: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
[deoptimizing (eager): end 0x130b7e1b65d1 <JS Function instantiateTypes (SharedFunctionInfo 0x2e2f693f5701)> @4 => node=22, pc=0x2c21d261c7ef, caller sp=0x7fff5fbfd260, state=NO_REGISTERS, took 0.116 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeOfSymbol) id{565,0} ---
(symbol) {
            if (symbol.flags & 16777216 /* Instantiated */) {
                return getTypeOfInstantiatedSymbol(symbol);
            }
            if (symbol.flags & (3 /* Variable */ | 4 /* Property */)) {
                return getTypeOfVariableOrParameterOrProperty(symbol);
            }
            if (symbol.flags & (16 /* Function */ | 8192 /* Method */ | 32 /* Class */ | 384 /* Enum */ | 512 /* ValueModule */)) {
                return getTypeOfFuncClassEnumModule(symbol);
            }
            if (symbol.flags & 8 /* EnumMember */) {
                return getTypeOfEnumMember(symbol);
            }
            if (symbol.flags & 98304 /* Accessor */) {
                return getTypeOfAccessors(symbol);
            }
            if (symbol.flags & 8388608 /* Alias */) {
                return getTypeOfAlias(symbol);
            }
            return unknownType;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeOfInstantiatedSymbol) id{565,1} ---
(symbol) {
            var links = getSymbolLinks(symbol);
            if (!links.type) {
                if (!pushTypeResolution(symbol, 0 /* Type */)) {
                    return unknownType;
                }
                var type = instantiateType(getTypeOfSymbol(links.target), links.mapper);
                if (!popTypeResolution()) {
                    type = reportCircularityError(symbol);
                }
                links.type = type;
            }
            return links.type;
        }
--- END ---
INLINE (getTypeOfInstantiatedSymbol) id{565,1} AS 1 AT <0:96>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{565,2} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{565,2} AS 2 AT <1:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{565,3} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{565,3} AS 3 AT <2:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:popTypeResolution) id{565,4} ---
() {
            resolutionTargets.pop();
            resolutionPropertyNames.pop();
            return resolutionResults.pop();
        }
--- END ---
INLINE (popTypeResolution) id{565,4} AS 4 AT <1:323>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeOfFuncClassEnumModule) id{565,5} ---
(symbol) {
            var links = getSymbolLinks(symbol);
            if (!links.type) {
                if (symbol.flags & 1536 /* Module */ && ts.isShorthandAmbientModuleSymbol(symbol)) {
                    links.type = anyType;
                }
                else {
                    var type = createObjectType(16 /* Anonymous */, symbol);
                    links.type = strictNullChecks && symbol.flags & 536870912 /* Optional */ ?
                        includeFalsyTypes(type, 2048 /* Undefined */) : type;
                }
            }
            return links.type;
        }
--- END ---
INLINE (getTypeOfFuncClassEnumModule) id{565,5} AS 5 AT <0:459>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{565,6} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{565,6} AS 6 AT <5:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{565,7} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{565,7} AS 7 AT <6:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createObjectType) id{565,8} ---
(objectFlags, symbol) {
            var type = createType(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol = symbol;
            return type;
        }
--- END ---
INLINE (createObjectType) id{565,8} AS 8 AT <5:305>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{565,9} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{565,9} AS 9 AT <8:47>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{565,10} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{565,10} AS 10 AT <9:35>
[deoptimizing (DEOPT eager): begin 0x130b7e1b5e01 <JS Function resolveStructuredTypeMembers (SharedFunctionInfo 0x2e2f693efe11)> (opt #555) @167, FP to SP delta: 264, caller sp: 0x7fff5fbfd188]
            ;;; deoptimize at 1_326: wrong map
  reading input frame resolveStructuredTypeMembers => node=70, args=2, height=2; inputs:
      0: 0x130b7e1b5e01 ; [fp - 16] 0x130b7e1b5e01 <JS Function resolveStructuredTypeMembers (SharedFunctionInfo 0x2e2f693efe11)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2069ace3579 ; rdx 0x2069ace3579 <a TypeObject with map 0x33abe2a73179>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x1030c9d44df1 ; [fp - 112] 0x1030c9d44df1 <JS Function resolveTypeReferenceMembers (SharedFunctionInfo 0x2e2f693eee51)>
  reading input frame resolveTypeReferenceMembers => node=160, args=2, height=6; inputs:
      0: 0x1030c9d44df1 ; (literal 23) 0x1030c9d44df1 <JS Function resolveTypeReferenceMembers (SharedFunctionInfo 0x2e2f693eee51)>
      1: 0x1f9f6c0532e1 ; (literal 16) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2069ace3579 ; rdx 0x2069ace3579 <a TypeObject with map 0x33abe2a73179>
      3: 0x130b7e1b3d29 ; (literal 17) 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x2069ace35d9 ; [fp - 104] 0x2069ace35d9 <a TypeObject with map 0x33abe2a74989>
      5: 0x3d8926094561 ; [fp - 256] 0x3d8926094561 <JS Array[2]>
      6: 0x30bcea404311 ; (literal 18) 0x30bcea404311 <undefined>
      7: 0x16f3adb61821 ; [fp - 264] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      8: 0xd6230db1df9 ; rbx 0xd6230db1df9 <JS Function concatenate (SharedFunctionInfo 0xc2bd2ae1c69)>
  translating frame resolveStructuredTypeMembers => node=70, height=8
    0x7fff5fbfd180: [top + 48] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd178: [top + 40] <- 0x2069ace3579 ;  0x2069ace3579 <a TypeObject with map 0x33abe2a73179>  (input #2)
    0x7fff5fbfd170: [top + 32] <- 0x2c21d26149dd ;  caller's pc
    0x7fff5fbfd168: [top + 24] <- 0x7fff5fbfd1a0 ;  caller's fp
    0x7fff5fbfd160: [top + 16] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd158: [top + 8] <- 0x130b7e1b5e01 ;  function    0x130b7e1b5e01 <JS Function resolveStructuredTypeMembers (SharedFunctionInfo 0x2e2f693efe11)>  (input #0)
    0x7fff5fbfd150: [top + 0] <- 0x1030c9d44df1 ;  0x1030c9d44df1 <JS Function resolveTypeReferenceMembers (SharedFunctionInfo 0x2e2f693eee51)>  (input #4)
  translating frame resolveTypeReferenceMembers => node=160, height=40
    0x7fff5fbfd148: [top + 80] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd140: [top + 72] <- 0x2069ace3579 ;  0x2069ace3579 <a TypeObject with map 0x33abe2a73179>  (input #2)
    0x7fff5fbfd138: [top + 64] <- 0x2c21d260d615 ;  caller's pc
    0x7fff5fbfd130: [top + 56] <- 0x7fff5fbfd168 ;  caller's fp
    0x7fff5fbfd128: [top + 48] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd120: [top + 40] <- 0x1030c9d44df1 ;  function    0x1030c9d44df1 <JS Function resolveTypeReferenceMembers (SharedFunctionInfo 0x2e2f693eee51)>  (input #0)
    0x7fff5fbfd118: [top + 32] <- 0x2069ace35d9 ;  0x2069ace35d9 <a TypeObject with map 0x33abe2a74989>  (input #4)
    0x7fff5fbfd110: [top + 24] <- 0x3d8926094561 ;  0x3d8926094561 <JS Array[2]>  (input #5)
    0x7fff5fbfd108: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfd100: [top + 8] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #7)
    0x7fff5fbfd0f8: [top + 0] <- 0xd6230db1df9 ;  0xd6230db1df9 <JS Function concatenate (SharedFunctionInfo 0xc2bd2ae1c69)>  (input #8)
[deoptimizing (eager): end 0x130b7e1b5e01 <JS Function resolveStructuredTypeMembers (SharedFunctionInfo 0x2e2f693efe11)> @167 => node=160, pc=0x2c21d262e2df, caller sp=0x7fff5fbfd188, state=TOS_REGISTER, took 0.126 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateTypeNoAlias) id{566,0} ---
(type, mapper) {
            if (type.flags & 16384 /* TypeParameter */) {
                return mapper(type);
            }
            if (type.flags & 32768 /* Object */) {
                if (type.objectFlags & 16 /* Anonymous */) {
                    // If the anonymous type originates in a declaration of a function, method, class, or
                    // interface, in an object type literal, or in an object literal expression, we may need
                    // to instantiate the type because it might reference a type parameter. We skip instantiation
                    // if none of the type parameters that are in scope in the type's declaration are mapped by
                    // the given mapper, however we can only do that analysis if the type isn't itself an
                    // instantiation.
                    return type.symbol &&
                        type.symbol.flags & (16 /* Function */ | 8192 /* Method */ | 32 /* Class */ | 2048 /* TypeLiteral */ | 4096 /* ObjectLiteral */) &&
                        (type.objectFlags & 64 /* Instantiated */ || isSymbolInScopeOfMappedTypeParameter(type.symbol, mapper)) ?
                        instantiateCached(type, mapper, instantiateAnonymousType) : type;
                }
                if (type.objectFlags & 32 /* Mapped */) {
                    return instantiateCached(type, mapper, instantiateMappedType);
                }
                if (type.objectFlags & 4 /* Reference */) {
                    return createTypeReference(type.target, instantiateTypes(type.typeArguments, mapper));
                }
            }
            if (type.flags & 65536 /* Union */ && !(type.flags & 8190 /* Primitive */)) {
                return getUnionType(instantiateTypes(type.types, mapper), /*subtypeReduction*/ false, type.aliasSymbol, instantiateTypes(type.aliasTypeArguments, mapper));
            }
            if (type.flags & 131072 /* Intersection */) {
                return getIntersectionType(instantiateTypes(type.types, mapper), type.aliasSymbol, instantiateTypes(type.aliasTypeArguments, mapper));
            }
            if (type.flags & 262144 /* Index */) {
                return getIndexType(instantiateType(type.type, mapper));
            }
            if (type.flags & 524288 /* IndexedAccess */) {
                return getIndexedAccessType(instantiateType(type.objectType, mapper), instantiateType(type.indexType, mapper));
            }
            return type;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateCached) id{566,1} ---
(type, mapper, instantiator) {
            var instantiations = mapper.instantiations || (mapper.instantiations = []);
            return instantiations[type.id] || (instantiations[type.id] = instantiator(type, mapper));
        }
--- END ---
INLINE (instantiateCached) id{566,1} AS 1 AT <0:1175>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateCached) id{566,2} ---
(type, mapper, instantiator) {
            var instantiations = mapper.instantiations || (mapper.instantiations = []);
            return instantiations[type.id] || (instantiations[type.id] = instantiator(type, mapper));
        }
--- END ---
INLINE (instantiateCached) id{566,2} AS 2 AT <0:1344>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateTypes) id{566,3} ---
(types, mapper) {
            return instantiateList(types, mapper, instantiateType);
        }
--- END ---
INLINE (instantiateTypes) id{566,3} AS 3 AT <0:1538>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateList) id{566,4} ---
(items, mapper, instantiator) {
            if (items && items.length) {
                var result = [];
                for (var _i = 0, items_1 = items; _i < items_1.length; _i++) {
                    var v = items_1[_i];
                    result.push(instantiator(v, mapper));
                }
                return result;
            }
            return items;
        }
--- END ---
INLINE (instantiateList) id{566,4} AS 4 AT <3:37>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createTypeReference) id{566,5} ---
(target, typeArguments) {
            var id = getTypeListId(typeArguments);
            var type = target.instantiations[id];
            if (!type) {
                type = target.instantiations[id] = createObjectType(4 /* Reference */, target.symbol);
                type.flags |= typeArguments ? getPropagatingFlagsOfTypes(typeArguments, /*excludeKinds*/ 0) : 0;
                type.target = target;
                type.typeArguments = typeArguments;
            }
            return type;
        }
--- END ---
INLINE (createTypeReference) id{566,5} AS 5 AT <0:1505>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createObjectType) id{566,6} ---
(objectFlags, symbol) {
            var type = createType(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol = symbol;
            return type;
        }
--- END ---
INLINE (createObjectType) id{566,6} AS 6 AT <5:203>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{566,7} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{566,7} AS 7 AT <6:47>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{566,8} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{566,8} AS 8 AT <7:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropagatingFlagsOfTypes) id{566,9} ---
(types, excludeKinds) {
            var result = 0;
            for (var _i = 0, types_3 = types; _i < types_3.length; _i++) {
                var type = types_3[_i];
                if (!(type.flags & excludeKinds)) {
                    result |= type.flags;
                }
            }
            return result & 14680064 /* PropagatingFlags */;
        }
--- END ---
INLINE (getPropagatingFlagsOfTypes) id{566,9} AS 9 AT <5:301>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateTypes) id{566,10} ---
(types, mapper) {
            return instantiateList(types, mapper, instantiateType);
        }
--- END ---
INLINE (instantiateTypes) id{566,10} AS 10 AT <0:1743>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateList) id{566,11} ---
(items, mapper, instantiator) {
            if (items && items.length) {
                var result = [];
                for (var _i = 0, items_1 = items; _i < items_1.length; _i++) {
                    var v = items_1[_i];
                    result.push(instantiator(v, mapper));
                }
                return result;
            }
            return items;
        }
--- END ---
INLINE (instantiateList) id{566,11} AS 11 AT <10:37>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateTypes) id{566,12} ---
(types, mapper) {
            return instantiateList(types, mapper, instantiateType);
        }
--- END ---
INLINE (instantiateTypes) id{566,12} AS 12 AT <0:1827>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateList) id{566,13} ---
(items, mapper, instantiator) {
            if (items && items.length) {
                var result = [];
                for (var _i = 0, items_1 = items; _i < items_1.length; _i++) {
                    var v = items_1[_i];
                    result.push(instantiator(v, mapper));
                }
                return result;
            }
            return items;
        }
--- END ---
INLINE (instantiateList) id{566,13} AS 13 AT <12:37>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIndependentType) id{567,0} ---
(node) {
            switch (node.kind) {
                case 118 /* AnyKeyword */:
                case 134 /* StringKeyword */:
                case 132 /* NumberKeyword */:
                case 121 /* BooleanKeyword */:
                case 135 /* SymbolKeyword */:
                case 104 /* VoidKeyword */:
                case 137 /* UndefinedKeyword */:
                case 94 /* NullKeyword */:
                case 129 /* NeverKeyword */:
                case 171 /* LiteralType */:
                    return true;
                case 162 /* ArrayType */:
                    return isIndependentType(node.elementType);
                case 157 /* TypeReference */:
                    return isIndependentTypeReference(node);
            }
            return false;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIndependentTypeReference) id{567,1} ---
(node) {
            if (node.typeArguments) {
                for (var _i = 0, _a = node.typeArguments; _i < _a.length; _i++) {
                    var typeNode = _a[_i];
                    if (!isIndependentType(typeNode)) {
                        return false;
                    }
                }
            }
            return true;
        }
--- END ---
INLINE (isIndependentTypeReference) id{567,1} AS 1 AT <0:707>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:symbolIsValue) id{568,0} ---
(symbol) {
            // If it is an instantiated symbol, then it is a value if the symbol it is an
            // instantiation of is a value.
            if (symbol.flags & 16777216 /* Instantiated */) {
                return symbolIsValue(getSymbolLinks(symbol).target);
            }
            // If the symbol has the value flag, it is trivially a value.
            if (symbol.flags & 107455 /* Value */) {
                return true;
            }
            // If it is an alias, then it is a value if the symbol it resolves to is a value.
            if (symbol.flags & 8388608 /* Alias */) {
                return (resolveAlias(symbol).flags & 107455 /* Value */) !== 0;
            }
            return false;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{568,1} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{568,1} AS 1 AT <0:244>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{568,2} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{568,2} AS 2 AT <1:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkIndexConstraintForProperty) id{569,0} ---
(prop, propertyType, containingType, indexDeclaration, indexType, indexKind) {
                if (!indexType) {
                    return;
                }
                // index is numeric and property name is not valid numeric literal
                if (indexKind === 1 /* Number */ && !isNumericName(prop.valueDeclaration.name)) {
                    return;
                }
                // perform property check if property or indexer is declared in 'type'
                // this allows to rule out cases when both property and indexer are inherited from the base class
                var errorNode;
                if (prop.valueDeclaration.name.kind === 142 /* ComputedPropertyName */ || prop.parent === containingType.symbol) {
                    errorNode = prop.valueDeclaration;
                }
                else if (indexDeclaration) {
                    errorNode = indexDeclaration;
                }
                else if (getObjectFlags(containingType) & 2 /* Interface */) {
                    // for interfaces property and indexer might be inherited from different bases
                    // check if any base class already has both property and indexer.
                    // check should be performed only if 'type' is the first type that brings property\x5cindexer together
                    var someBaseClassHasBothPropertyAndIndexer = ts.forEach(getBaseTypes(containingType), function (base) { return getPropertyOfObjectType(base, prop.name) && getIndexTypeOfType(base, indexKind); });
                    errorNode = someBaseClassHasBothPropertyAndIndexer ? undefined : containingType.symbol.declarations[0];
                }
                if (errorNode && !isTypeAssignableTo(propertyType, indexType)) {
                    var errorMessage = indexKind === 0 /* String */
                        ? ts.Diagnostics.Property_0_of_type_1_is_not_assignable_to_string_index_type_2
                        : ts.Diagnostics.Property_0_of_type_1_is_not_assignable_to_numeric_index_type_2;
                    error(errorNode, errorMessage, symbolToString(prop), typeToString(propertyType), typeToString(indexType));
                }
            }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isNumericName) id{569,1} ---
(name) {
            return name.kind === 142 /* ComputedPropertyName */ ? isNumericComputedName(name) : isNumericLiteralName(name.text);
        }
--- END ---
INLINE (isNumericName) id{569,1} AS 1 AT <0:295>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isTypeAssignableTo) id{569,2} ---
(source, target) {
            return isTypeRelatedTo(source, target, assignableRelation);
        }
--- END ---
INLINE (isTypeAssignableTo) id{569,2} AS 2 AT <0:1711>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkVariableLikeDeclaration) id{570,0} ---
(node) {
            checkDecorators(node);
            checkSourceElement(node.type);
            // For a computed property, just check the initializer and exit
            // Do not use hasDynamicName here, because that returns false for well known symbols.
            // We want to perform checkComputedPropertyName for all computed properties, including
            // well known symbols.
            if (node.name.kind === 142 /* ComputedPropertyName */) {
                checkComputedPropertyName(node.name);
                if (node.initializer) {
                    checkExpressionCached(node.initializer);
                }
            }
            if (node.kind === 174 /* BindingElement */) {
                if (node.parent.kind === 172 /* ObjectBindingPattern */ && languageVersion < 5 /* ESNext */ && !ts.isInAmbientContext(node)) {
                    checkExternalEmitHelpers(node, 4 /* Rest */);
                }
                // check computed properties inside property names of binding elements
                if (node.propertyName && node.propertyName.kind === 142 /* ComputedPropertyName */) {
                    checkComputedPropertyName(node.propertyName);
                }
                // check private/protected variable access
                var parent_11 = node.parent.parent;
                var parentType = getTypeForBindingElementParent(parent_11);
                var name_24 = node.propertyName || node.name;
                var property = getPropertyOfType(parentType, ts.getTextOfPropertyName(name_24));
                markPropertyAsReferenced(property);
                if (parent_11.initializer && property && getParentOfSymbol(property)) {
                    checkClassPropertyAccess(parent_11, parent_11.initializer, parentType, property);
                }
            }
            // For a binding pattern, check contained binding elements
            if (ts.isBindingPattern(node.name)) {
                ts.forEach(node.name.elements, checkSourceElement);
            }
            // For a parameter declaration with an initializer, error and exit if the containing function doesn't have a body
            if (node.initializer && ts.getRootDeclaration(node).kind === 144 /* Parameter */ && ts.nodeIsMissing(ts.getContainingFunction(node).body)) {
                error(node, ts.Diagnostics.A_parameter_initializer_is_only_allowed_in_a_function_or_constructor_implementation);
                return;
            }
            // For a binding pattern, validate the initializer and exit
            if (ts.isBindingPattern(node.name)) {
                // Don't validate for-in initializer as it is already an error
                if (node.initializer && node.parent.parent.kind !== 212 /* ForInStatement */) {
                    checkTypeAssignableTo(checkExpressionCached(node.initializer), getWidenedTypeForVariableLikeDeclaration(node), node, /*headMessage*/ undefined);
                    checkParameterInitializer(node);
                }
                return;
            }
            var symbol = getSymbolOfNode(node);
            var type = convertAutoToAny(getTypeOfVariableOrParameterOrProperty(symbol));
            if (node === symbol.valueDeclaration) {
                // Node is the primary declaration of the symbol, just validate the initializer
                // Don't validate for-in initializer as it is already an error
                if (node.initializer && node.parent.parent.kind !== 212 /* ForInStatement */) {
                    checkTypeAssignableTo(checkExpressionCached(node.initializer), type, node, /*headMessage*/ undefined);
                    checkParameterInitializer(node);
                }
            }
            else {
                // Node is a secondary declaration, check that type is identical to primary declaration and check that
                // initializer is consistent with type associated with the node
                var declarationType = convertAutoToAny(getWidenedTypeForVariableLikeDeclaration(node));
                if (type !== unknownType && declarationType !== unknownType && !isTypeIdenticalTo(type, declarationType)) {
                    error(node.name, ts.Diagnostics.Subsequent_variable_declarations_must_have_the_same_type_Variable_0_must_be_of_type_1_but_here_has_type_2, ts.declarationNameToString(node.name), typeToString(type), typeToString(declarationType));
                }
                if (node.initializer) {
                    checkTypeAssignableTo(checkExpressionCached(node.initializer), declarationType, node, /*headMessage*/ undefined);
                }
                if (!areDeclarationFlagsIdentical(node, symbol.valueDeclaration)) {
                    error(symbol.valueDeclaration.name, ts.Diagnostics.All_declarations_of_0_must_have_identical_modifiers, ts.declarationNameToString(node.name));
                    error(node.name, ts.Diagnostics.All_declarations_of_0_must_have_identical_modifiers, ts.declarationNameToString(node.name));
                }
            }
            if (node.kind !== 147 /* PropertyDeclaration */ && node.kind !== 146 /* PropertySignature */) {
                // We know we don't have a binding pattern or computed name here
                checkExportsOnMergedDeclarations(node);
                if (node.kind === 223 /* VariableDeclaration */ || node.kind === 174 /* BindingElement */) {
                    checkVarDeclaredNamesNotShadowed(node);
                }
                checkCollisionWithCapturedSuperVariable(node, node.name);
                checkCollisionWithCapturedThisVariable(node, node.name);
                checkCollisionWithRequireExportsInGeneratedCode(node, node.name);
                checkCollisionWithGlobalPromiseInGeneratedCode(node, node.name);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{570,1} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{570,1} AS 1 AT <0:3074>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{570,2} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{570,2} AS 2 AT <1:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:convertAutoToAny) id{570,3} ---
(type) {
            return type === autoType ? anyType : type === autoArrayType ? anyArrayType : type;
        }
--- END ---
INLINE (convertAutoToAny) id{570,3} AS 3 AT <0:3120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:convertAutoToAny) id{570,4} ---
(type) {
            return type === autoType ? anyType : type === autoArrayType ? anyArrayType : type;
        }
--- END ---
INLINE (convertAutoToAny) id{570,4} AS 4 AT <0:3973>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isTypeIdenticalTo) id{570,5} ---
(source, target) {
            return isTypeRelatedTo(source, target, identityRelation);
        }
--- END ---
INLINE (isTypeIdenticalTo) id{570,5} AS 5 AT <0:4119>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkCollisionWithCapturedThisVariable) id{570,6} ---
(node, name) {
            if (needCollisionCheckForIdentifier(node, name, "_this")) {
                potentialThisCollisions.push(node);
            }
        }
--- END ---
INLINE (checkCollisionWithCapturedThisVariable) id{570,6} AS 6 AT <0:5570>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeFromTypeNode) id{571,0} ---
(node) {
            switch (node.kind) {
                case 118 /* AnyKeyword */:
                case 263 /* JSDocAllType */:
                case 264 /* JSDocUnknownType */:
                    return anyType;
                case 134 /* StringKeyword */:
                    return stringType;
                case 132 /* NumberKeyword */:
                    return numberType;
                case 121 /* BooleanKeyword */:
                    return booleanType;
                case 135 /* SymbolKeyword */:
                    return esSymbolType;
                case 104 /* VoidKeyword */:
                    return voidType;
                case 137 /* UndefinedKeyword */:
                    return undefinedType;
                case 94 /* NullKeyword */:
                    return nullType;
                case 129 /* NeverKeyword */:
                    return neverType;
                case 289 /* JSDocNullKeyword */:
                    return nullType;
                case 290 /* JSDocUndefinedKeyword */:
                    return undefinedType;
                case 291 /* JSDocNeverKeyword */:
                    return neverType;
                case 167 /* ThisType */:
                case 98 /* ThisKeyword */:
                    return getTypeFromThisTypeNode(node);
                case 171 /* LiteralType */:
                    return getTypeFromLiteralTypeNode(node);
                case 288 /* JSDocLiteralType */:
                    return getTypeFromLiteralTypeNode(node.literal);
                case 157 /* TypeReference */:
                case 272 /* JSDocTypeReference */:
                    return getTypeFromTypeReference(node);
                case 156 /* TypePredicate */:
                    return booleanType;
                case 199 /* ExpressionWithTypeArguments */:
                    return getTypeFromTypeReference(node);
                case 160 /* TypeQuery */:
                    return getTypeFromTypeQueryNode(node);
                case 162 /* ArrayType */:
                case 265 /* JSDocArrayType */:
                    return getTypeFromArrayTypeNode(node);
                case 163 /* TupleType */:
                    return getTypeFromTupleTypeNode(node);
                case 164 /* UnionType */:
                case 266 /* JSDocUnionType */:
                    return getTypeFromUnionTypeNode(node);
                case 165 /* IntersectionType */:
                    return getTypeFromIntersectionTypeNode(node);
                case 166 /* ParenthesizedType */:
                case 268 /* JSDocNullableType */:
                case 269 /* JSDocNonNullableType */:
                case 276 /* JSDocConstructorType */:
                case 277 /* JSDocThisType */:
                case 273 /* JSDocOptionalType */:
                    return getTypeFromTypeNode(node.type);
                case 270 /* JSDocRecordType */:
                    return getTypeFromTypeNode(node.literal);
                case 158 /* FunctionType */:
                case 159 /* ConstructorType */:
                case 161 /* TypeLiteral */:
                case 287 /* JSDocTypeLiteral */:
                case 274 /* JSDocFunctionType */:
                    return getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode(node);
                case 168 /* TypeOperator */:
                    return getTypeFromTypeOperatorNode(node);
                case 169 /* IndexedAccessType */:
                    return getTypeFromIndexedAccessTypeNode(node);
                case 170 /* MappedType */:
                    return getTypeFromMappedTypeNode(node);
                // This function assumes that an identifier or qualified name is a type expression
                // Callers should first ensure this by calling isTypeNode
                case 70 /* Identifier */:
                case 141 /* QualifiedName */:
                    var symbol = getSymbolAtLocation(node);
                    return symbol && getDeclaredTypeOfSymbol(symbol);
                case 267 /* JSDocTupleType */:
                    return getTypeFromJSDocTupleType(node);
                case 275 /* JSDocVariadicType */:
                    return getTypeFromJSDocVariadicType(node);
                default:
                    return unknownType;
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeFromThisTypeNode) id{571,1} ---
(node) {
            var links = getNodeLinks(node);
            if (!links.resolvedType) {
                links.resolvedType = getThisType(node);
            }
            return links.resolvedType;
        }
--- END ---
INLINE (getTypeFromThisTypeNode) id{571,1} AS 1 AT <0:1275>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeLinks) id{571,2} ---
(node) {
            var nodeId = getNodeId(node);
            return nodeLinks[nodeId] || (nodeLinks[nodeId] = { flags: 0 });
        }
--- END ---
INLINE (getNodeLinks) id{571,2} AS 2 AT <1:33>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeId) id{571,3} ---
(node) {
        if (!node.id) {
            node.id = nextNodeId;
            nextNodeId++;
        }
        return node.id;
    }
--- END ---
INLINE (getNodeId) id{571,3} AS 3 AT <2:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeFromLiteralTypeNode) id{571,4} ---
(node) {
            var links = getNodeLinks(node);
            if (!links.resolvedType) {
                links.resolvedType = getRegularTypeOfLiteralType(checkExpression(node.literal));
            }
            return links.resolvedType;
        }
--- END ---
INLINE (getTypeFromLiteralTypeNode) id{571,4} AS 4 AT <0:1377>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeLinks) id{571,5} ---
(node) {
            var nodeId = getNodeId(node);
            return nodeLinks[nodeId] || (nodeLinks[nodeId] = { flags: 0 });
        }
--- END ---
INLINE (getNodeLinks) id{571,5} AS 5 AT <4:33>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeId) id{571,6} ---
(node) {
        if (!node.id) {
            node.id = nextNodeId;
            nextNodeId++;
        }
        return node.id;
    }
--- END ---
INLINE (getNodeId) id{571,6} AS 6 AT <5:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getRegularTypeOfLiteralType) id{571,7} ---
(type) {
            return type.flags & 96 /* StringOrNumberLiteral */ && type.flags & 1048576 /* FreshLiteral */ ? type.regularType : type;
        }
--- END ---
INLINE (getRegularTypeOfLiteralType) id{571,7} AS 7 AT <4:129>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeFromTypeQueryNode) id{571,8} ---
(node) {
            var links = getNodeLinks(node);
            if (!links.resolvedType) {
                // TypeScript 1.0 spec (April 2014): 3.6.3
                // The expression is processed as an identifier expression (section 4.3)
                // or property access expression(section 4.10),
                // the widened type(section 3.9) of which becomes the result.
                links.resolvedType = getWidenedType(checkExpression(node.exprName));
            }
            return links.resolvedType;
        }
--- END ---
INLINE (getTypeFromTypeQueryNode) id{571,8} AS 8 AT <0:1959>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeLinks) id{571,9} ---
(node) {
            var nodeId = getNodeId(node);
            return nodeLinks[nodeId] || (nodeLinks[nodeId] = { flags: 0 });
        }
--- END ---
INLINE (getNodeLinks) id{571,9} AS 9 AT <8:33>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeId) id{571,10} ---
(node) {
        if (!node.id) {
            node.id = nextNodeId;
            nextNodeId++;
        }
        return node.id;
    }
--- END ---
INLINE (getNodeId) id{571,10} AS 10 AT <9:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeFromArrayTypeNode) id{571,11} ---
(node) {
            var links = getNodeLinks(node);
            if (!links.resolvedType) {
                links.resolvedType = createArrayType(getTypeFromTypeNode(node.elementType));
            }
            return links.resolvedType;
        }
--- END ---
INLINE (getTypeFromArrayTypeNode) id{571,11} AS 11 AT <0:2107>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeLinks) id{571,12} ---
(node) {
            var nodeId = getNodeId(node);
            return nodeLinks[nodeId] || (nodeLinks[nodeId] = { flags: 0 });
        }
--- END ---
INLINE (getNodeLinks) id{571,12} AS 12 AT <11:33>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeId) id{571,13} ---
(node) {
        if (!node.id) {
            node.id = nextNodeId;
            nextNodeId++;
        }
        return node.id;
    }
--- END ---
INLINE (getNodeId) id{571,13} AS 13 AT <12:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createArrayType) id{571,14} ---
(elementType) {
            return createTypeFromGenericGlobalType(globalArrayType, [elementType]);
        }
--- END ---
INLINE (createArrayType) id{571,14} AS 14 AT <11:129>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createTypeFromGenericGlobalType) id{571,15} ---
(genericGlobalType, typeArguments) {
            return genericGlobalType !== emptyGenericType ? createTypeReference(genericGlobalType, typeArguments) : emptyObjectType;
        }
--- END ---
INLINE (createTypeFromGenericGlobalType) id{571,15} AS 15 AT <14:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createTypeReference) id{571,16} ---
(target, typeArguments) {
            var id = getTypeListId(typeArguments);
            var type = target.instantiations[id];
            if (!type) {
                type = target.instantiations[id] = createObjectType(4 /* Reference */, target.symbol);
                type.flags |= typeArguments ? getPropagatingFlagsOfTypes(typeArguments, /*excludeKinds*/ 0) : 0;
                type.target = target;
                type.typeArguments = typeArguments;
            }
            return type;
        }
--- END ---
INLINE (createTypeReference) id{571,16} AS 16 AT <15:97>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createObjectType) id{571,17} ---
(objectFlags, symbol) {
            var type = createType(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol = symbol;
            return type;
        }
--- END ---
INLINE (createObjectType) id{571,17} AS 17 AT <16:203>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropagatingFlagsOfTypes) id{571,18} ---
(types, excludeKinds) {
            var result = 0;
            for (var _i = 0, types_3 = types; _i < types_3.length; _i++) {
                var type = types_3[_i];
                if (!(type.flags & excludeKinds)) {
                    result |= type.flags;
                }
            }
            return result & 14680064 /* PropagatingFlags */;
        }
--- END ---
INLINE (getPropagatingFlagsOfTypes) id{571,18} AS 18 AT <16:301>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:needCollisionCheckForIdentifier) id{572,0} ---
(node, identifier, name) {
            if (!(identifier && identifier.text === name)) {
                return false;
            }
            if (node.kind === 147 /* PropertyDeclaration */ ||
                node.kind === 146 /* PropertySignature */ ||
                node.kind === 149 /* MethodDeclaration */ ||
                node.kind === 148 /* MethodSignature */ ||
                node.kind === 151 /* GetAccessor */ ||
                node.kind === 152 /* SetAccessor */) {
                // it is ok to have member named '_super' or '_this' - member access is always qualified
                return false;
            }
            if (ts.isInAmbientContext(node)) {
                // ambient context - no codegen impact
                return false;
            }
            var root = ts.getRootDeclaration(node);
            if (root.kind === 144 /* Parameter */ && ts.nodeIsMissing(root.parent.body)) {
                // just an overload - no codegen impact
                return false;
            }
            return true;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getWidenedTypeForVariableLikeDeclaration) id{573,0} ---
(declaration, reportErrors) {
            var type = getTypeForVariableLikeDeclaration(declaration, /*includeOptionality*/ true);
            if (type) {
                if (reportErrors) {
                    reportErrorsFromWidening(declaration, type);
                }
                // During a normal type check we'll never get to here with a property assignment (the check of the containing
                // object literal uses a different path). We exclude widening only so that language services and type verification
                // tools see the actual type.
                if (declaration.kind === 257 /* PropertyAssignment */) {
                    return type;
                }
                return getWidenedType(type);
            }
            // Rest parameters default to type any[], other parameters default to type any
            type = declaration.dotDotDotToken ? anyArrayType : anyType;
            // Report implicit any errors unless this is a private property within an ambient declaration
            if (reportErrors && compilerOptions.noImplicitAny) {
                if (!declarationBelongsToPrivateAmbientMember(declaration)) {
                    reportImplicitAnyError(declaration, type);
                }
            }
            return type;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:reportErrorsFromWidening) id{573,1} ---
(declaration, type) {
            if (produceDiagnostics && compilerOptions.noImplicitAny && type.flags & 2097152 /* ContainsWideningType */) {
                // Report implicit any error within type if possible, otherwise report error on declaration
                if (!reportWideningErrorsInType(type)) {
                    reportImplicitAnyError(declaration, type);
                }
            }
        }
--- END ---
INLINE (reportErrorsFromWidening) id{573,1} AS 1 AT <0:210>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getContainingFunction) id{574,0} ---
(node) {
        while (true) {
            node = node.parent;
            if (!node || isFunctionLike(node)) {
                return node;
            }
        }
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isFunctionLike) id{574,1} ---
(node) {
        return node && isFunctionLikeKind(node.kind);
    }
--- END ---
INLINE (isFunctionLike) id{574,1} AS 1 AT <0:89>
[deoptimizing (DEOPT eager): begin 0x130b7e1b6811 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)> (opt #563) @77, FP to SP delta: 288, caller sp: 0x7fff5fbfd748]
            ;;; deoptimize at 0_3437: wrong map
  reading input frame resolveName => node=591, args=6, height=18; inputs:
      0: 0x130b7e1b6811 ; [fp - 16] 0x130b7e1b6811 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)>
      1: 0x1f9f6c0532e1 ; [fp + 56] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x35fa3c4370b9 ; [fp - 64] 0x35fa3c4370b9 <a NodeObject with map 0x33abe2a71231>
      3: 0x2f05bb888cf9 ; [fp + 40] 0x2f05bb888cf9 <String[6]: Buffer>
      4: 0x11a3bf00000000 ; [fp + 32] 1156031
      5: 0xd6230ded3a9 ; [fp + 24] 0xd6230ded3a9 <an Object with map 0x33abe2a3df61>
      6: 0x35fa3c49c339 ; [fp + 16] 0x35fa3c49c339 <an IdentifierObject with map 0x15b5a79122d1>
      7: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      8: 0x30bcea4069a9 ; (literal 14) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      9: 0x30bcea4069a9 ; (literal 14) 0x30bcea4069a9 <Odd Oddball: optimized_out>
     10: 0x30bcea4069a9 ; (literal 14) 0x30bcea4069a9 <Odd Oddball: optimized_out>
     11: 0x30bcea404311 ; [fp - 40] 0x30bcea404311 <undefined>
     12: 0x35fa3c49c339 ; [fp + 48] 0x35fa3c49c339 <an IdentifierObject with map 0x15b5a79122d1>
     13: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     14: 0x30bcea404421 ; [fp - 184] 0x30bcea404421 <false>
     15: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     16: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     17: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     18: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     19: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     20: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     21: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     22: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     23: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     24: 0x130b7e1c5679 ; rcx 0x130b7e1c5679 <a SymbolObject with map 0x33abe2a71079>
  translating frame resolveName => node=591, height=136
    0x7fff5fbfd740: [top + 208] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd738: [top + 200] <- 0x35fa3c4370b9 ;  0x35fa3c4370b9 <a NodeObject with map 0x33abe2a71231>  (input #2)
    0x7fff5fbfd730: [top + 192] <- 0x2f05bb888cf9 ;  0x2f05bb888cf9 <String[6]: Buffer>  (input #3)
    0x7fff5fbfd728: [top + 184] <- 0x11a3bf00000000 ;  1156031  (input #4)
    0x7fff5fbfd720: [top + 176] <- 0xd6230ded3a9 ;  0xd6230ded3a9 <an Object with map 0x33abe2a3df61>  (input #5)
    0x7fff5fbfd718: [top + 168] <- 0x35fa3c49c339 ;  0x35fa3c49c339 <an IdentifierObject with map 0x15b5a79122d1>  (input #6)
    0x7fff5fbfd710: [top + 160] <- 0x2c21d272b66f ;  caller's pc
    0x7fff5fbfd708: [top + 152] <- 0x7fff5fbfd770 ;  caller's fp
    0x7fff5fbfd700: [top + 144] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #7)
    0x7fff5fbfd6f8: [top + 136] <- 0x130b7e1b6811 ;  function    0x130b7e1b6811 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)>  (input #0)
    0x7fff5fbfd6f0: [top + 128] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #8)
    0x7fff5fbfd6e8: [top + 120] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #9)
    0x7fff5fbfd6e0: [top + 112] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #10)
    0x7fff5fbfd6d8: [top + 104] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #11)
    0x7fff5fbfd6d0: [top + 96] <- 0x35fa3c49c339 ;  0x35fa3c49c339 <an IdentifierObject with map 0x15b5a79122d1>  (input #12)
    0x7fff5fbfd6c8: [top + 88] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #13)
    0x7fff5fbfd6c0: [top + 80] <- 0x30bcea404421 ;  0x30bcea404421 <false>  (input #14)
    0x7fff5fbfd6b8: [top + 72] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #15)
    0x7fff5fbfd6b0: [top + 64] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #16)
    0x7fff5fbfd6a8: [top + 56] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #17)
    0x7fff5fbfd6a0: [top + 48] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #18)
    0x7fff5fbfd698: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #19)
    0x7fff5fbfd690: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #20)
    0x7fff5fbfd688: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #21)
    0x7fff5fbfd680: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #22)
    0x7fff5fbfd678: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #23)
    0x7fff5fbfd670: [top + 0] <- 0x130b7e1c5679 ;  0x130b7e1c5679 <a SymbolObject with map 0x33abe2a71079>  (input #24)
[deoptimizing (eager): end 0x130b7e1b6811 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)> @77 => node=591, pc=0x2c21d25e50f2, caller sp=0x7fff5fbfd748, state=TOS_REGISTER, took 0.157 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d44209 <JS Function getTypeOfSymbol (SharedFunctionInfo 0x2e2f693ed051)> (opt #565) @24, FP to SP delta: 128, caller sp: 0x7fff5fbfdb90]
            ;;; deoptimize at 5_116: wrong map
  reading input frame getTypeOfSymbol => node=97, args=2, height=2; inputs:
      0: 0x1030c9d44209 ; [fp - 16] 0x1030c9d44209 <JS Function getTypeOfSymbol (SharedFunctionInfo 0x2e2f693ed051)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x130b7e1c6131 ; rbx 0x130b7e1c6131 <a SymbolObject with map 0x33abe2a6dd41>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x1030c9d444e9 ; [fp - 32] 0x1030c9d444e9 <JS Function getTypeOfFuncClassEnumModule (SharedFunctionInfo 0x2e2f693ecc91)>
  reading input frame getTypeOfFuncClassEnumModule => node=34, args=2, height=3; inputs:
      0: 0x1030c9d444e9 ; (literal 17) 0x1030c9d444e9 <JS Function getTypeOfFuncClassEnumModule (SharedFunctionInfo 0x2e2f693ecc91)>
      1: 0x1f9f6c0532e1 ; (literal 18) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x130b7e1c6131 ; rbx 0x130b7e1c6131 <a SymbolObject with map 0x33abe2a6dd41>
      3: 0x130b7e1b3d29 ; (literal 19) 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x35e9f8e412d9 ; rax 0x35e9f8e412d9 <an Object with map 0x33abe2a72ba1>
      5: 0x30bcea404311 ; (literal 20) 0x30bcea404311 <undefined>
  translating frame getTypeOfSymbol => node=97, height=8
    0x7fff5fbfdb88: [top + 48] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdb80: [top + 40] <- 0x130b7e1c6131 ;  0x130b7e1c6131 <a SymbolObject with map 0x33abe2a6dd41>  (input #2)
    0x7fff5fbfdb78: [top + 32] <- 0x2c21d274804d ;  caller's pc
    0x7fff5fbfdb70: [top + 24] <- 0x7fff5fbfdc30 ;  caller's fp
    0x7fff5fbfdb68: [top + 16] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdb60: [top + 8] <- 0x1030c9d44209 ;  function    0x1030c9d44209 <JS Function getTypeOfSymbol (SharedFunctionInfo 0x2e2f693ed051)>  (input #0)
    0x7fff5fbfdb58: [top + 0] <- 0x1030c9d444e9 ;  0x1030c9d444e9 <JS Function getTypeOfFuncClassEnumModule (SharedFunctionInfo 0x2e2f693ecc91)>  (input #4)
  translating frame getTypeOfFuncClassEnumModule => node=34, height=16
    0x7fff5fbfdb50: [top + 56] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdb48: [top + 48] <- 0x130b7e1c6131 ;  0x130b7e1c6131 <a SymbolObject with map 0x33abe2a6dd41>  (input #2)
    0x7fff5fbfdb40: [top + 40] <- 0x2c21d261cde4 ;  caller's pc
    0x7fff5fbfdb38: [top + 32] <- 0x7fff5fbfdb70 ;  caller's fp
    0x7fff5fbfdb30: [top + 24] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdb28: [top + 16] <- 0x1030c9d444e9 ;  function    0x1030c9d444e9 <JS Function getTypeOfFuncClassEnumModule (SharedFunctionInfo 0x2e2f693ecc91)>  (input #0)
    0x7fff5fbfdb20: [top + 8] <- 0x35e9f8e412d9 ;  0x35e9f8e412d9 <an Object with map 0x33abe2a72ba1>  (input #4)
    0x7fff5fbfdb18: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
[deoptimizing (eager): end 0x1030c9d44209 <JS Function getTypeOfSymbol (SharedFunctionInfo 0x2e2f693ed051)> @24 => node=34, pc=0x2c21d261eb3d, caller sp=0x7fff5fbfdb90, state=NO_REGISTERS, took 0.102 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d42981 <JS Function getTypeFromClassOrInterfaceReference (SharedFunctionInfo 0x2e2f693f2391)> (opt #371) @16, FP to SP delta: 168, caller sp: 0x7fff5fbfdae8]
            ;;; deoptimize at 0_1008: wrong map
  reading input frame getTypeFromClassOrInterfaceReference => node=63, args=3, height=3; inputs:
      0: 0x1030c9d42981 ; [fp - 16] 0x1030c9d42981 <JS Function getTypeFromClassOrInterfaceReference (SharedFunctionInfo 0x2e2f693f2391)>
      1: 0x1f9f6c0532e1 ; [fp + 32] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x35fa3c49c3e1 ; rbx 0x35fa3c49c3e1 <a NodeObject with map 0x33abe2a67eb9>
      3: 0x1030c9d658b1 ; [fp + 16] 0x1030c9d658b1 <a SymbolObject with map 0x15b5a790ff11>
      4: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      5: 0x32c5a0de9799 ; [fp - 32] 0x32c5a0de9799 <a TypeObject with map 0x15b5a7910281>
      6: 0x30bcea4069a9 ; (literal 17) 0x30bcea4069a9 <Odd Oddball: optimized_out>
  translating frame getTypeFromClassOrInterfaceReference => node=63, height=16
    0x7fff5fbfdae0: [top + 64] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdad8: [top + 56] <- 0x35fa3c49c3e1 ;  0x35fa3c49c3e1 <a NodeObject with map 0x33abe2a67eb9>  (input #2)
    0x7fff5fbfdad0: [top + 48] <- 0x1030c9d658b1 ;  0x1030c9d658b1 <a SymbolObject with map 0x15b5a790ff11>  (input #3)
    0x7fff5fbfdac8: [top + 40] <- 0x2c21d274b72b ;  caller's pc
    0x7fff5fbfdac0: [top + 32] <- 0x7fff5fbfdb38 ;  caller's fp
    0x7fff5fbfdab8: [top + 24] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #4)
    0x7fff5fbfdab0: [top + 16] <- 0x1030c9d42981 ;  function    0x1030c9d42981 <JS Function getTypeFromClassOrInterfaceReference (SharedFunctionInfo 0x2e2f693f2391)>  (input #0)
    0x7fff5fbfdaa8: [top + 8] <- 0x32c5a0de9799 ;  0x32c5a0de9799 <a TypeObject with map 0x15b5a7910281>  (input #5)
    0x7fff5fbfdaa0: [top + 0] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
[deoptimizing (eager): end 0x1030c9d42981 <JS Function getTypeFromClassOrInterfaceReference (SharedFunctionInfo 0x2e2f693f2391)> @16 => node=63, pc=0x2c21d2614626, caller sp=0x7fff5fbfdae8, state=NO_REGISTERS, took 0.072 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d45369 <JS Function addInheritedMembers (SharedFunctionInfo 0x2e2f693eea91)> (opt #516) @7, FP to SP delta: 40, caller sp: 0x7fff5fbfd790]
            ;;; deoptimize at 0_191: wrong map
  reading input frame addInheritedMembers => node=18, args=3, height=4; inputs:
      0: 0x1030c9d45369 ; [fp - 16] 0x1030c9d45369 <JS Function addInheritedMembers (SharedFunctionInfo 0x2e2f693eea91)>
      1: 0x1f9f6c0532e1 ; [fp + 32] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x3d89260c8a41 ; [fp + 24] 0x3d89260c8a41 <an Object with map 0x15b5a79120c1>
      3: 0x35e9f8e41d19 ; rax 0x35e9f8e41d19 <JS Array[1]>
      4: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      5: 0 ; rbx 
      6: 0x35e9f8e41d19 ; rax 0x35e9f8e41d19 <JS Array[1]>
      7: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
  translating frame addInheritedMembers => node=18, height=24
    0x7fff5fbfd788: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd780: [top + 64] <- 0x3d89260c8a41 ;  0x3d89260c8a41 <an Object with map 0x15b5a79120c1>  (input #2)
    0x7fff5fbfd778: [top + 56] <- 0x35e9f8e41d19 ;  0x35e9f8e41d19 <JS Array[1]>  (input #3)
    0x7fff5fbfd770: [top + 48] <- 0x2c21d2689af8 ;  caller's pc
    0x7fff5fbfd768: [top + 40] <- 0x7fff5fbfd7e8 ;  caller's fp
    0x7fff5fbfd760: [top + 32] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #4)
    0x7fff5fbfd758: [top + 24] <- 0x1030c9d45369 ;  function    0x1030c9d45369 <JS Function addInheritedMembers (SharedFunctionInfo 0x2e2f693eea91)>  (input #0)
    0x7fff5fbfd750: [top + 16] <- 0x00000000 ;  0  (input #5)
    0x7fff5fbfd748: [top + 8] <- 0x35e9f8e41d19 ;  0x35e9f8e41d19 <JS Array[1]>  (input #6)
    0x7fff5fbfd740: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
[deoptimizing (eager): end 0x1030c9d45369 <JS Function addInheritedMembers (SharedFunctionInfo 0x2e2f693eea91)> @7 => node=18, pc=0x2c21d26306ae, caller sp=0x7fff5fbfd790, state=NO_REGISTERS, took 0.061 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getDeclarationModifierFlagsFromSymbol) id{575,0} ---
(s) {
            return s.valueDeclaration ? ts.getCombinedModifierFlags(s.valueDeclaration) : s.flags & 134217728 /* Prototype */ ? 4 /* Public */ | 32 /* Static */ : 0;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getErasedSignature) id{576,0} ---
(signature) {
            if (!signature.typeParameters)
                return signature;
            if (!signature.erasedSignatureCache) {
                signature.erasedSignatureCache = instantiateSignature(signature, createTypeEraser(signature.typeParameters), /*eraseTypeParameters*/ true);
            }
            return signature.erasedSignatureCache;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createTypeEraser) id{576,1} ---
(sources) {
            return createTypeMapper(sources, undefined);
        }
--- END ---
INLINE (createTypeEraser) id{576,1} AS 1 AT <0:223>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createTypeMapper) id{576,2} ---
(sources, targets) {
            var count = sources.length;
            var mapper = count == 1 ? createUnaryTypeMapper(sources[0], targets ? targets[0] : anyType) :
                count == 2 ? createBinaryTypeMapper(sources[0], targets ? targets[0] : anyType, sources[1], targets ? targets[1] : anyType) :
                    createArrayTypeMapper(sources, targets);
            mapper.mappedTypes = sources;
            return mapper;
        }
--- END ---
INLINE (createTypeMapper) id{576,2} AS 2 AT <1:31>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateSymbol) id{577,0} ---
(symbol, mapper) {
            if (symbol.flags & 16777216 /* Instantiated */) {
                var links = getSymbolLinks(symbol);
                // If symbol being instantiated is itself a instantiation, fetch the original target and combine the
                // type mappers. This ensures that original type identities are properly preserved and that aliases
                // always reference a non-aliases.
                symbol = links.target;
                mapper = combineTypeMappers(links.mapper, mapper);
            }
            // Keep the flags from the symbol we're instantiating.  Mark that is instantiated, and
            // also transient so that we can just store data on it directly.
            var result = createSymbol(16777216 /* Instantiated */ | 67108864 /* Transient */ | symbol.flags, symbol.name);
            result.declarations = symbol.declarations;
            result.parent = symbol.parent;
            result.target = symbol;
            result.mapper = mapper;
            if (symbol.valueDeclaration) {
                result.valueDeclaration = symbol.valueDeclaration;
            }
            return result;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{577,1} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{577,1} AS 1 AT <0:109>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{577,2} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{577,2} AS 2 AT <1:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createSymbol) id{577,3} ---
(flags, name) {
            symbolCount++;
            return new Symbol(flags, name);
        }
--- END ---
INLINE (createSymbol) id{577,3} AS 3 AT <0:738>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:SymbolObject) id{577,4} ---
(flags, name) {
            this.flags = flags;
            this.name = name;
        }
--- END ---
INLINE (SymbolObject) id{577,4} AS 4 AT <3:62>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveStructuredTypeMembers) id{578,0} ---
(type) {
            if (!type.members) {
                if (type.flags & 32768 /* Object */) {
                    if (type.objectFlags & 4 /* Reference */) {
                        resolveTypeReferenceMembers(type);
                    }
                    else if (type.objectFlags & 3 /* ClassOrInterface */) {
                        resolveClassOrInterfaceMembers(type);
                    }
                    else if (type.objectFlags & 16 /* Anonymous */) {
                        resolveAnonymousTypeMembers(type);
                    }
                    else if (type.objectFlags & 32 /* Mapped */) {
                        resolveMappedTypeMembers(type);
                    }
                }
                else if (type.flags & 65536 /* Union */) {
                    resolveUnionTypeMembers(type);
                }
                else if (type.flags & 131072 /* Intersection */) {
                    resolveIntersectionTypeMembers(type);
                }
            }
            return type;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveTypeReferenceMembers) id{578,1} ---
(type) {
            var source = resolveDeclaredMembers(type.target);
            var typeParameters = ts.concatenate(source.typeParameters, [source.thisType]);
            var typeArguments = type.typeArguments && type.typeArguments.length === typeParameters.length ?
                type.typeArguments : ts.concatenate(type.typeArguments, [type]);
            resolveObjectTypeMembers(type, source, typeParameters, typeArguments);
        }
--- END ---
INLINE (resolveTypeReferenceMembers) id{578,1} AS 1 AT <0:185>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveDeclaredMembers) id{578,2} ---
(type) {
            if (!type.declaredProperties) {
                var symbol = type.symbol;
                type.declaredProperties = getNamedMembers(symbol.members);
                type.declaredCallSignatures = getSignaturesOfSymbol(symbol.members["__call"]);
                type.declaredConstructSignatures = getSignaturesOfSymbol(symbol.members["__new"]);
                type.declaredStringIndexInfo = getIndexInfoOfSymbol(symbol, 0 /* String */);
                type.declaredNumberIndexInfo = getIndexInfoOfSymbol(symbol, 1 /* Number */);
            }
            return type;
        }
--- END ---
INLINE (resolveDeclaredMembers) id{578,2} AS 2 AT <1:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNamedMembers) id{578,3} ---
(members) {
            var result;
            for (var id in members) {
                if (!isReservedMemberName(id)) {
                    if (!result)
                        result = [];
                    var symbol = members[id];
                    if (symbolIsValue(symbol)) {
                        result.push(symbol);
                    }
                }
            }
            return result || emptyArray;
        }
--- END ---
INLINE (getNamedMembers) id{578,3} AS 3 AT <2:137>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isReservedMemberName) id{578,4} ---
(name) {
            return name.charCodeAt(0) === 95 /* _ */ &&
                name.charCodeAt(1) === 95 /* _ */ &&
                name.charCodeAt(2) !== 95 /* _ */ &&
                name.charCodeAt(2) !== 64 /* at */;
        }
--- END ---
INLINE (isReservedMemberName) id{578,4} AS 4 AT <3:95>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexInfoOfSymbol) id{578,5} ---
(symbol, kind) {
            var declaration = getIndexDeclarationOfSymbol(symbol, kind);
            if (declaration) {
                return createIndexInfo(declaration.type ? getTypeFromTypeNode(declaration.type) : anyType, (ts.getModifierFlags(declaration) & 64 /* Readonly */) !== 0, declaration);
            }
            return undefined;
        }
--- END ---
INLINE (getIndexInfoOfSymbol) id{578,5} AS 5 AT <2:411>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createIndexInfo) id{578,6} ---
(type, isReadonly, declaration) {
            return { type: type, isReadonly: isReadonly, declaration: declaration };
        }
--- END ---
INLINE (createIndexInfo) id{578,6} AS 6 AT <5:144>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexInfoOfSymbol) id{578,7} ---
(symbol, kind) {
            var declaration = getIndexDeclarationOfSymbol(symbol, kind);
            if (declaration) {
                return createIndexInfo(declaration.type ? getTypeFromTypeNode(declaration.type) : anyType, (ts.getModifierFlags(declaration) & 64 /* Readonly */) !== 0, declaration);
            }
            return undefined;
        }
--- END ---
INLINE (getIndexInfoOfSymbol) id{578,7} AS 7 AT <2:504>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createIndexInfo) id{578,8} ---
(type, isReadonly, declaration) {
            return { type: type, isReadonly: isReadonly, declaration: declaration };
        }
--- END ---
INLINE (createIndexInfo) id{578,8} AS 8 AT <7:144>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveClassOrInterfaceMembers) id{578,9} ---
(type) {
            resolveObjectTypeMembers(type, resolveDeclaredMembers(type), emptyArray, emptyArray);
        }
--- END ---
INLINE (resolveClassOrInterfaceMembers) id{578,9} AS 9 AT <0:342>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveDeclaredMembers) id{578,10} ---
(type) {
            if (!type.declaredProperties) {
                var symbol = type.symbol;
                type.declaredProperties = getNamedMembers(symbol.members);
                type.declaredCallSignatures = getSignaturesOfSymbol(symbol.members["__call"]);
                type.declaredConstructSignatures = getSignaturesOfSymbol(symbol.members["__new"]);
                type.declaredStringIndexInfo = getIndexInfoOfSymbol(symbol, 0 /* String */);
                type.declaredNumberIndexInfo = getIndexInfoOfSymbol(symbol, 1 /* Number */);
            }
            return type;
        }
--- END ---
INLINE (resolveDeclaredMembers) id{578,10} AS 10 AT <9:52>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNamedMembers) id{578,11} ---
(members) {
            var result;
            for (var id in members) {
                if (!isReservedMemberName(id)) {
                    if (!result)
                        result = [];
                    var symbol = members[id];
                    if (symbolIsValue(symbol)) {
                        result.push(symbol);
                    }
                }
            }
            return result || emptyArray;
        }
--- END ---
INLINE (getNamedMembers) id{578,11} AS 11 AT <10:137>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isReservedMemberName) id{578,12} ---
(name) {
            return name.charCodeAt(0) === 95 /* _ */ &&
                name.charCodeAt(1) === 95 /* _ */ &&
                name.charCodeAt(2) !== 95 /* _ */ &&
                name.charCodeAt(2) !== 64 /* at */;
        }
--- END ---
INLINE (isReservedMemberName) id{578,12} AS 12 AT <11:95>
[deoptimizing (DEOPT eager): begin 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> (opt #559) @121, FP to SP delta: 200, caller sp: 0x7fff5fbfd898]
            ;;; deoptimize at 10_183: wrong map
  reading input frame checkSourceElement => node=197, args=2, height=5; inputs:
      0: 0x130b7e1b6059 ; [fp - 16] 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x35fa3c4a9da1 ; rbx 0x35fa3c4a9da1 <a NodeObject with map 0x33abe2a71c29>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 33) 0x30bcea404311 <undefined>
      5: 0x30bcea4069a9 ; (literal 34) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      6: 0x30bcea4069a9 ; (literal 34) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x1030c9d41f79 ; [fp - 96] 0x1030c9d41f79 <JS Function checkPropertyDeclaration (SharedFunctionInfo 0x1b98fbc0a981)>
  reading input frame checkPropertyDeclaration => node=7, args=2, height=1; inputs:
      0: 0x1030c9d41f79 ; (literal 43) 0x1030c9d41f79 <JS Function checkPropertyDeclaration (SharedFunctionInfo 0x1b98fbc0a981)>
      1: 0x1f9f6c0532e1 ; (literal 36) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x35fa3c4a9da1 ; rbx 0x35fa3c4a9da1 <a NodeObject with map 0x33abe2a71c29>
      3: 0x130b7e1b3d29 ; (literal 37) 0x130b7e1b3d29 <FixedArray[1022]>
  translating frame checkSourceElement => node=197, height=32
    0x7fff5fbfd890: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd888: [top + 64] <- 0x35fa3c4a9da1 ;  0x35fa3c4a9da1 <a NodeObject with map 0x33abe2a71c29>  (input #2)
    0x7fff5fbfd880: [top + 56] <- 0x2c21d2207e55 ;  caller's pc
    0x7fff5fbfd878: [top + 48] <- 0x7fff5fbfd8b0 ;  caller's fp
    0x7fff5fbfd870: [top + 40] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd868: [top + 32] <- 0x130b7e1b6059 ;  function    0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>  (input #0)
    0x7fff5fbfd860: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfd858: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #5)
    0x7fff5fbfd850: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfd848: [top + 0] <- 0x1030c9d41f79 ;  0x1030c9d41f79 <JS Function checkPropertyDeclaration (SharedFunctionInfo 0x1b98fbc0a981)>  (input #7)
  translating frame checkPropertyDeclaration => node=7, height=0
    0x7fff5fbfd840: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd838: [top + 32] <- 0x35fa3c4a9da1 ;  0x35fa3c4a9da1 <a NodeObject with map 0x33abe2a71c29>  (input #2)
    0x7fff5fbfd830: [top + 24] <- 0x2c21d25ec087 ;  caller's pc
    0x7fff5fbfd828: [top + 16] <- 0x7fff5fbfd878 ;  caller's fp
    0x7fff5fbfd820: [top + 8] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd818: [top + 0] <- 0x1030c9d41f79 ;  function    0x1030c9d41f79 <JS Function checkPropertyDeclaration (SharedFunctionInfo 0x1b98fbc0a981)>  (input #0)
[deoptimizing (eager): end 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> @121 => node=7, pc=0x2c21d2610785, caller sp=0x7fff5fbfd898, state=NO_REGISTERS, took 0.103 ms]
[deoptimizer unlinked: checkSourceElement / 130b7e1b6059]
[deoptimizing (DEOPT lazy): begin 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> (opt #559) @20, FP to SP delta: 200, caller sp: 0x7fff5fbfda48]
  reading input frame checkSourceElement => node=929, args=2, height=5; inputs:
      0: 0x130b7e1b6059 ; [fp - 16] 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x35fa3c4795c9 ; [fp + 16] 0x35fa3c4795c9 <a NodeObject with map 0x33abe2a71289>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 33) 0x30bcea404311 <undefined>
      5: 0x30bcea4069a9 ; (literal 34) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      6: 0x30bcea4069a9 ; (literal 34) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x30bcea404311 ; rax 0x30bcea404311 <undefined>
  translating frame checkSourceElement => node=929, height=32
    0x7fff5fbfda40: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfda38: [top + 64] <- 0x35fa3c4795c9 ;  0x35fa3c4795c9 <a NodeObject with map 0x33abe2a71289>  (input #2)
    0x7fff5fbfda30: [top + 56] <- 0x2c21d2207e55 ;  caller's pc
    0x7fff5fbfda28: [top + 48] <- 0x7fff5fbfda60 ;  caller's fp
    0x7fff5fbfda20: [top + 40] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfda18: [top + 32] <- 0x130b7e1b6059 ;  function    0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>  (input #0)
    0x7fff5fbfda10: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfda08: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #5)
    0x7fff5fbfda00: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfd9f8: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
[deoptimizing (lazy): end 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> @20 => node=929, pc=0x2c21d25ec764, caller sp=0x7fff5fbfda48, state=TOS_REGISTER, took 0.067 ms]
[deoptimizing (DEOPT lazy): begin 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> (opt #559) @41, FP to SP delta: 200, caller sp: 0x7fff5fbfdbf8]
  reading input frame checkSourceElement => node=580, args=2, height=5; inputs:
      0: 0x130b7e1b6059 ; [fp - 16] 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x35fa3c44b6f1 ; [fp + 16] 0x35fa3c44b6f1 <a NodeObject with map 0x33abe2a71b79>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 33) 0x30bcea404311 <undefined>
      5: 0x30bcea4069a9 ; (literal 34) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      6: 0x30bcea4069a9 ; (literal 34) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x30bcea404311 ; rax 0x30bcea404311 <undefined>
  translating frame checkSourceElement => node=580, height=32
    0x7fff5fbfdbf0: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdbe8: [top + 64] <- 0x35fa3c44b6f1 ;  0x35fa3c44b6f1 <a NodeObject with map 0x33abe2a71b79>  (input #2)
    0x7fff5fbfdbe0: [top + 56] <- 0x2c21d268616c ;  caller's pc
    0x7fff5fbfdbd8: [top + 48] <- 0x7fff5fbfdc68 ;  caller's fp
    0x7fff5fbfdbd0: [top + 40] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdbc8: [top + 32] <- 0x130b7e1b6059 ;  function    0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>  (input #0)
    0x7fff5fbfdbc0: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfdbb8: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #5)
    0x7fff5fbfdbb0: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfdba8: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
[deoptimizing (lazy): end 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> @41 => node=580, pc=0x2c21d25ec3f2, caller sp=0x7fff5fbfdbf8, state=TOS_REGISTER, took 0.056 ms]
[deoptimizing (DEOPT lazy): begin 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> (opt #559) @13, FP to SP delta: 200, caller sp: 0x7fff5fbfdd70]
  reading input frame checkSourceElement => node=1005, args=2, height=5; inputs:
      0: 0x130b7e1b6059 ; [fp - 16] 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x35fa3c443381 ; [fp + 16] 0x35fa3c443381 <a NodeObject with map 0x33abe2a71231>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 33) 0x30bcea404311 <undefined>
      5: 0x30bcea4069a9 ; (literal 34) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      6: 0x30bcea4069a9 ; (literal 34) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x30bcea404311 ; rax 0x30bcea404311 <undefined>
  translating frame checkSourceElement => node=1005, height=32
    0x7fff5fbfdd68: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdd60: [top + 64] <- 0x35fa3c443381 ;  0x35fa3c443381 <a NodeObject with map 0x33abe2a71231>  (input #2)
    0x7fff5fbfdd58: [top + 56] <- 0x2c21d2207e55 ;  caller's pc
    0x7fff5fbfdd50: [top + 48] <- 0x7fff5fbfdd88 ;  caller's fp
    0x7fff5fbfdd48: [top + 40] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdd40: [top + 32] <- 0x130b7e1b6059 ;  function    0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>  (input #0)
    0x7fff5fbfdd38: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfdd30: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #5)
    0x7fff5fbfdd28: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfdd20: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
[deoptimizing (lazy): end 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> @13 => node=1005, pc=0x2c21d25ec828, caller sp=0x7fff5fbfdd70, state=TOS_REGISTER, took 0.058 ms]
[deoptimizing (DEOPT lazy): begin 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> (opt #559) @41, FP to SP delta: 200, caller sp: 0x7fff5fbfdf20]
  reading input frame checkSourceElement => node=580, args=2, height=5; inputs:
      0: 0x130b7e1b6059 ; [fp - 16] 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x35fa3c43bf61 ; [fp + 16] 0x35fa3c43bf61 <a NodeObject with map 0x33abe2a71b79>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 33) 0x30bcea404311 <undefined>
      5: 0x30bcea4069a9 ; (literal 34) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      6: 0x30bcea4069a9 ; (literal 34) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x30bcea404311 ; rax 0x30bcea404311 <undefined>
  translating frame checkSourceElement => node=580, height=32
    0x7fff5fbfdf18: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdf10: [top + 64] <- 0x35fa3c43bf61 ;  0x35fa3c43bf61 <a NodeObject with map 0x33abe2a71b79>  (input #2)
    0x7fff5fbfdf08: [top + 56] <- 0x2c21d268616c ;  caller's pc
    0x7fff5fbfdf00: [top + 48] <- 0x7fff5fbfdf90 ;  caller's fp
    0x7fff5fbfdef8: [top + 40] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdef0: [top + 32] <- 0x130b7e1b6059 ;  function    0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>  (input #0)
    0x7fff5fbfdee8: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfdee0: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #5)
    0x7fff5fbfded8: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfded0: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
[deoptimizing (lazy): end 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> @41 => node=580, pc=0x2c21d25ec3f2, caller sp=0x7fff5fbfdf20, state=TOS_REGISTER, took 0.067 ms]
[deoptimizing (DEOPT lazy): begin 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> (opt #559) @13, FP to SP delta: 200, caller sp: 0x7fff5fbfe098]
  reading input frame checkSourceElement => node=1005, args=2, height=5; inputs:
      0: 0x130b7e1b6059 ; [fp - 16] 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x35fa3c4371b9 ; [fp + 16] 0x35fa3c4371b9 <a NodeObject with map 0x33abe2a71231>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 33) 0x30bcea404311 <undefined>
      5: 0x30bcea4069a9 ; (literal 34) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      6: 0x30bcea4069a9 ; (literal 34) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x30bcea404311 ; rax 0x30bcea404311 <undefined>
  translating frame checkSourceElement => node=1005, height=32
    0x7fff5fbfe090: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfe088: [top + 64] <- 0x35fa3c4371b9 ;  0x35fa3c4371b9 <a NodeObject with map 0x33abe2a71231>  (input #2)
    0x7fff5fbfe080: [top + 56] <- 0x2c21d2207e55 ;  caller's pc
    0x7fff5fbfe078: [top + 48] <- 0x7fff5fbfe0b0 ;  caller's fp
    0x7fff5fbfe070: [top + 40] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfe068: [top + 32] <- 0x130b7e1b6059 ;  function    0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>  (input #0)
    0x7fff5fbfe060: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfe058: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #5)
    0x7fff5fbfe050: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfe048: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
[deoptimizing (lazy): end 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> @13 => node=1005, pc=0x2c21d25ec828, caller sp=0x7fff5fbfe098, state=TOS_REGISTER, took 0.059 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeOfVariableOrParameterOrProperty) id{579,0} ---
(symbol) {
            var links = getSymbolLinks(symbol);
            if (!links.type) {
                // Handle prototype property
                if (symbol.flags & 134217728 /* Prototype */) {
                    return links.type = getTypeOfPrototypeProperty(symbol);
                }
                // Handle catch clause variables
                var declaration = symbol.valueDeclaration;
                if (ts.isCatchClauseVariableDeclarationOrBindingElement(declaration)) {
                    return links.type = anyType;
                }
                // Handle export default expressions
                if (declaration.kind === 240 /* ExportAssignment */) {
                    return links.type = checkExpression(declaration.expression);
                }
                if (declaration.flags & 65536 /* JavaScriptFile */ && declaration.kind === 286 /* JSDocPropertyTag */ && declaration.typeExpression) {
                    return links.type = getTypeFromTypeNode(declaration.typeExpression.type);
                }
                // Handle variable, parameter or property
                if (!pushTypeResolution(symbol, 0 /* Type */)) {
                    return unknownType;
                }
                var type = void 0;
                // Handle certain special assignment kinds, which happen to union across multiple declarations:
                // * module.exports = expr
                // * exports.p = expr
                // * this.p = expr
                // * className.prototype.method = expr
                if (declaration.kind === 192 /* BinaryExpression */ ||
                    declaration.kind === 177 /* PropertyAccessExpression */ && declaration.parent.kind === 192 /* BinaryExpression */) {
                    // Use JS Doc type if present on parent expression statement
                    if (declaration.flags & 65536 /* JavaScriptFile */) {
                        var jsdocType = ts.getJSDocType(declaration.parent);
                        if (jsdocType) {
                            return links.type = getTypeFromTypeNode(jsdocType);
                        }
                    }
                    var declaredTypes = ts.map(symbol.declarations, function (decl) { return decl.kind === 192 /* BinaryExpression */ ?
                        checkExpressionCached(decl.right) :
                        checkExpressionCached(decl.parent.right); });
                    type = getUnionType(declaredTypes, /*subtypeReduction*/ true);
                }
                else {
                    type = getWidenedTypeForVariableLikeDeclaration(declaration, /*reportErrors*/ true);
                }
                if (!popTypeResolution()) {
                    type = reportCircularityError(symbol);
                }
                links.type = type;
            }
            return links.type;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{579,1} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{579,1} AS 1 AT <0:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{579,2} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{579,2} AS 2 AT <1:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:popTypeResolution) id{579,3} ---
() {
            resolutionTargets.pop();
            resolutionPropertyNames.pop();
            return resolutionResults.pop();
        }
--- END ---
INLINE (popTypeResolution) id{579,3} AS 3 AT <0:2684>
[deoptimizing (DEOPT eager): begin 0xd6230dcfaf1 <JS Function isEntityNameExpression (SharedFunctionInfo 0x3504a53d5ad9)> (opt #385) @2, FP to SP delta: 24, caller sp: 0x7fff5fbfdc90]
  reading input frame isEntityNameExpression => node=4, args=2, height=1; inputs:
      0: 0xd6230dcfaf1 ; [fp - 16] 0xd6230dcfaf1 <JS Function isEntityNameExpression (SharedFunctionInfo 0x3504a53d5ad9)>
      1: 0x16f3adb61821 ; [fp + 24] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x35fa3c4aa5e1 ; rax 0x35fa3c4aa5e1 <a NodeObject with map 0x33abe2a71b21>
      3: 0xd6230db34c9 ; [fp - 24] 0xd6230db34c9 <FixedArray[156]>
  translating frame isEntityNameExpression => node=4, height=0
    0x7fff5fbfdc88: [top + 40] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfdc80: [top + 32] <- 0x35fa3c4aa5e1 ;  0x35fa3c4aa5e1 <a NodeObject with map 0x33abe2a71b21>  (input #2)
    0x7fff5fbfdc78: [top + 24] <- 0x2c21d25e8dbb ;  caller's pc
    0x7fff5fbfdc70: [top + 16] <- 0x7fff5fbfdce8 ;  caller's fp
    0x7fff5fbfdc68: [top + 8] <- 0xd6230db34c9 ;  context    0xd6230db34c9 <FixedArray[156]>  (input #3)
    0x7fff5fbfdc60: [top + 0] <- 0xd6230dcfaf1 ;  function    0xd6230dcfaf1 <JS Function isEntityNameExpression (SharedFunctionInfo 0x3504a53d5ad9)>  (input #0)
[deoptimizing (eager): end 0xd6230dcfaf1 <JS Function isEntityNameExpression (SharedFunctionInfo 0x3504a53d5ad9)> @2 => node=4, pc=0x2c21d25b5326, caller sp=0x7fff5fbfdc90, state=NO_REGISTERS, took 0.051 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d3e2b1 <JS Function getSymbol (SharedFunctionInfo 0x2e2f693e7951)> (opt #552) @13, FP to SP delta: 40, caller sp: 0x7fff5fbfda70]
            ;;; deoptimize at 0_407: wrong map
  reading input frame getSymbol => node=96, args=4, height=3; inputs:
      0: 0x1030c9d3e2b1 ; [fp - 16] 0x1030c9d3e2b1 <JS Function getSymbol (SharedFunctionInfo 0x2e2f693e7951)>
      1: 0x1f9f6c0532e1 ; [fp + 40] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x130b7e1c5839 ; [fp + 32] 0x130b7e1c5839 <an Object with map 0x33abe2a3d1a1>
      3: 0x35fa3c439c39 ; [fp + 24] 0x35fa3c439c39 <String[3]: net>
      4: 0x78000000000 ; [fp + 16] 1920
      5: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      6: 0x130b7e1cab61 ; rax 0x130b7e1cab61 <a SymbolObject with map 0x33abe2a72ca9>
      7: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
  translating frame getSymbol => node=96, height=16
    0x7fff5fbfda68: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfda60: [top + 64] <- 0x130b7e1c5839 ;  0x130b7e1c5839 <an Object with map 0x33abe2a3d1a1>  (input #2)
    0x7fff5fbfda58: [top + 56] <- 0x35fa3c439c39 ;  0x35fa3c439c39 <String[3]: net>  (input #3)
    0x7fff5fbfda50: [top + 48] <- 0x78000000000 ;  1920  (input #4)
    0x7fff5fbfda48: [top + 40] <- 0x2c21d25e438b ;  caller's pc
    0x7fff5fbfda40: [top + 32] <- 0x7fff5fbfdb08 ;  caller's fp
    0x7fff5fbfda38: [top + 24] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #5)
    0x7fff5fbfda30: [top + 16] <- 0x1030c9d3e2b1 ;  function    0x1030c9d3e2b1 <JS Function getSymbol (SharedFunctionInfo 0x2e2f693e7951)>  (input #0)
    0x7fff5fbfda28: [top + 8] <- 0x130b7e1cab61 ;  0x130b7e1cab61 <a SymbolObject with map 0x33abe2a72ca9>  (input #6)
    0x7fff5fbfda20: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
[deoptimizing (eager): end 0x1030c9d3e2b1 <JS Function getSymbol (SharedFunctionInfo 0x2e2f693e7951)> @13 => node=96, pc=0x2c21d25e6c02, caller sp=0x7fff5fbfda70, state=NO_REGISTERS, took 0.078 ms]
[deoptimizing (DEOPT eager): begin 0xd6230dccac1 <JS Function getInterfaceBaseTypeNodes (SharedFunctionInfo 0x3504a53d1bd9)> (opt #377) @2, FP to SP delta: 24, caller sp: 0x7fff5fbfdc90]
            ;;; deoptimize at 0_60: wrong map
  reading input frame getInterfaceBaseTypeNodes => node=4, args=2, height=2; inputs:
      0: 0xd6230dccac1 ; [fp - 16] 0xd6230dccac1 <JS Function getInterfaceBaseTypeNodes (SharedFunctionInfo 0x3504a53d1bd9)>
      1: 0x16f3adb61821 ; [fp + 24] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x35fa3c442941 ; rdx 0x35fa3c442941 <a NodeObject with map 0x33abe2a71d89>
      3: 0xd6230db34c9 ; rax 0xd6230db34c9 <FixedArray[156]>
      4: 0x30bcea404311 ; (literal 3) 0x30bcea404311 <undefined>
  translating frame getInterfaceBaseTypeNodes => node=4, height=8
    0x7fff5fbfdc88: [top + 48] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfdc80: [top + 40] <- 0x35fa3c442941 ;  0x35fa3c442941 <a NodeObject with map 0x33abe2a71d89>  (input #2)
    0x7fff5fbfdc78: [top + 32] <- 0x2c21d25e8cfe ;  caller's pc
    0x7fff5fbfdc70: [top + 24] <- 0x7fff5fbfdce8 ;  caller's fp
    0x7fff5fbfdc68: [top + 16] <- 0xd6230db34c9 ;  context    0xd6230db34c9 <FixedArray[156]>  (input #3)
    0x7fff5fbfdc60: [top + 8] <- 0xd6230dccac1 ;  function    0xd6230dccac1 <JS Function getInterfaceBaseTypeNodes (SharedFunctionInfo 0x3504a53d1bd9)>  (input #0)
    0x7fff5fbfdc58: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
[deoptimizing (eager): end 0xd6230dccac1 <JS Function getInterfaceBaseTypeNodes (SharedFunctionInfo 0x3504a53d1bd9)> @2 => node=4, pc=0x2c21d25e916a, caller sp=0x7fff5fbfdc90, state=NO_REGISTERS, took 0.060 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:nodeIsMissing) id{580,0} ---
(node) {
        if (node === undefined) {
            return true;
        }
        return node.pos === node.end && node.pos >= 0 && node.kind !== 1 /* EndOfFileToken */;
    }
--- END ---
[deoptimizing (DEOPT eager): begin 0x1030c9d455f1 <JS Function isIndependentMember (SharedFunctionInfo 0x2e2f693ee851)> (opt #557) @33, FP to SP delta: 72, caller sp: 0x7fff5fbfd638]
            ;;; deoptimize at 1_32: Unknown map in polymorphic access
  reading input frame isIndependentMember => node=128, args=2, height=4; inputs:
      0: 0x1030c9d455f1 ; [fp - 16] 0x1030c9d455f1 <JS Function isIndependentMember (SharedFunctionInfo 0x2e2f693ee851)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x30b09d334839 ; [fp + 16] 0x30b09d334839 <a SymbolObject with map 0x33abe2a6fb29>
      3: 0x130b7e1b3d29 ; rax 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      5: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      6: 0x1030c9d45689 ; rbx 0x1030c9d45689 <JS Function isIndependentVariableLikeDeclaration (SharedFunctionInfo 0x2e2f693ee6d1)>
  reading input frame isIndependentVariableLikeDeclaration => node=3, args=2, height=1; inputs:
      0: 0x1030c9d45689 ; (literal 11) 0x1030c9d45689 <JS Function isIndependentVariableLikeDeclaration (SharedFunctionInfo 0x2e2f693ee6d1)>
      1: 0x1f9f6c0532e1 ; (literal 8) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1229b15aac1 ; rdx 0x1229b15aac1 <a NodeObject with map 0x33abe2a71c29>
      3: 0x130b7e1b3d29 ; (literal 9) 0x130b7e1b3d29 <FixedArray[1022]>
  translating frame isIndependentMember => node=128, height=24
    0x7fff5fbfd630: [top + 64] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd628: [top + 56] <- 0x30b09d334839 ;  0x30b09d334839 <a SymbolObject with map 0x33abe2a6fb29>  (input #2)
    0x7fff5fbfd620: [top + 48] <- 0x2c21d262ec40 ;  caller's pc
    0x7fff5fbfd618: [top + 40] <- 0x7fff5fbfd680 ;  caller's fp
    0x7fff5fbfd610: [top + 32] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd608: [top + 24] <- 0x1030c9d455f1 ;  function    0x1030c9d455f1 <JS Function isIndependentMember (SharedFunctionInfo 0x2e2f693ee851)>  (input #0)
    0x7fff5fbfd600: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #4)
    0x7fff5fbfd5f8: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #5)
    0x7fff5fbfd5f0: [top + 0] <- 0x1030c9d45689 ;  0x1030c9d45689 <JS Function isIndependentVariableLikeDeclaration (SharedFunctionInfo 0x2e2f693ee6d1)>  (input #6)
  translating frame isIndependentVariableLikeDeclaration => node=3, height=0
    0x7fff5fbfd5e8: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd5e0: [top + 32] <- 0x1229b15aac1 ;  0x1229b15aac1 <a NodeObject with map 0x33abe2a71c29>  (input #2)
    0x7fff5fbfd5d8: [top + 24] <- 0x2c21d26321b1 ;  caller's pc
    0x7fff5fbfd5d0: [top + 16] <- 0x7fff5fbfd618 ;  caller's fp
    0x7fff5fbfd5c8: [top + 8] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd5c0: [top + 0] <- 0x1030c9d45689 ;  function    0x1030c9d45689 <JS Function isIndependentVariableLikeDeclaration (SharedFunctionInfo 0x2e2f693ee6d1)>  (input #0)
[deoptimizing (eager): end 0x1030c9d455f1 <JS Function isIndependentMember (SharedFunctionInfo 0x2e2f693ee851)> @33 => node=3, pc=0x2c21d26322a6, caller sp=0x7fff5fbfd638, state=NO_REGISTERS, took 0.103 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkMethodDeclaration) id{581,0} ---
(node) {
            // Grammar checking
            checkGrammarMethod(node) || checkGrammarComputedPropertyName(node.name);
            // Grammar checking for modifiers is done inside the function checkGrammarFunctionLikeDeclaration
            checkFunctionOrMethodDeclaration(node);
            // Abstract methods cannot have an implementation.
            // Extra checks are to avoid reporting multiple errors relating to the "abstractness" of the node.
            if (ts.getModifierFlags(node) & 128 /* Abstract */ && node.body) {
                error(node, ts.Diagnostics.Method_0_cannot_have_an_implementation_because_it_is_marked_abstract, ts.declarationNameToString(node.name));
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarComputedPropertyName) id{581,1} ---
(node) {
            // If node is not a computedPropertyName, just skip the grammar checking
            if (node.kind !== 142 /* ComputedPropertyName */) {
                return false;
            }
            var computedPropertyName = node;
            if (computedPropertyName.expression.kind === 192 /* BinaryExpression */ && computedPropertyName.expression.operatorToken.kind === 25 /* CommaToken */) {
                return grammarErrorOnNode(computedPropertyName.expression, ts.Diagnostics.A_comma_expression_is_not_allowed_in_a_computed_property_name);
            }
        }
--- END ---
INLINE (checkGrammarComputedPropertyName) id{581,1} AS 1 AT <0:81>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNumNonRestParameters) id{582,0} ---
(signature) {
            var numParams = signature.parameters.length;
            return signature.hasRestParameter ?
                numParams - 1 :
                numParams;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIndependentMember) id{583,0} ---
(symbol) {
            if (symbol.declarations && symbol.declarations.length === 1) {
                var declaration = symbol.declarations[0];
                if (declaration) {
                    switch (declaration.kind) {
                        case 147 /* PropertyDeclaration */:
                        case 146 /* PropertySignature */:
                            return isIndependentVariableLikeDeclaration(declaration);
                        case 149 /* MethodDeclaration */:
                        case 148 /* MethodSignature */:
                        case 150 /* Constructor */:
                            return isIndependentFunctionLikeDeclaration(declaration);
                    }
                }
            }
            return false;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIndependentVariableLikeDeclaration) id{583,1} ---
(node) {
            return node.type && isIndependentType(node.type) || !node.type && !node.initializer;
        }
--- END ---
INLINE (isIndependentVariableLikeDeclaration) id{583,1} AS 1 AT <0:380>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIndependentFunctionLikeDeclaration) id{583,2} ---
(node) {
            if (node.kind !== 150 /* Constructor */ && (!node.type || !isIndependentType(node.type))) {
                return false;
            }
            for (var _i = 0, _a = node.parameters; _i < _a.length; _i++) {
                var parameter = _a[_i];
                if (!isIndependentVariableLikeDeclaration(parameter)) {
                    return false;
                }
            }
            return true;
        }
--- END ---
INLINE (isIndependentFunctionLikeDeclaration) id{583,2} AS 2 AT <0:632>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIndependentVariableLikeDeclaration) id{583,3} ---
(node) {
            return node.type && isIndependentType(node.type) || !node.type && !node.initializer;
        }
--- END ---
INLINE (isIndependentVariableLikeDeclaration) id{583,3} AS 3 AT <2:293>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbol) id{584,0} ---
(symbols, name, meaning) {
            if (meaning) {
                var symbol = symbols[name];
                if (symbol) {
                    ts.Debug.assert((symbol.flags & 16777216 /* Instantiated */) === 0, "Should never get an instantiated symbol here.");
                    if (symbol.flags & meaning) {
                        return symbol;
                    }
                    if (symbol.flags & 8388608 /* Alias */) {
                        var target = resolveAlias(symbol);
                        // Unknown symbol means an error occurred in alias resolution, treat it as positive answer to avoid cascading errors
                        if (target === unknownSymbol || target.flags & meaning) {
                            return symbol;
                        }
                    }
                }
            }
            // return undefined if we can't find a symbol.
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeForVariableLikeDeclaration) id{585,0} ---
(declaration, includeOptionality) {
            if (declaration.flags & 65536 /* JavaScriptFile */) {
                // If this is a variable in a JavaScript file, then use the JSDoc type (if it has
                // one as its type), otherwise fallback to the below standard TS codepaths to
                // try to figure it out.
                var type = getTypeForVariableLikeDeclarationFromJSDocComment(declaration);
                if (type && type !== unknownType) {
                    return type;
                }
            }
            // A variable declared in a for..in statement is of type string, or of type keyof T when the
            // right hand expression is of a type parameter type.
            if (declaration.parent.parent.kind === 212 /* ForInStatement */) {
                var indexType = getIndexType(checkNonNullExpression(declaration.parent.parent.expression));
                return indexType.flags & (16384 /* TypeParameter */ | 262144 /* Index */) ? indexType : stringType;
            }
            if (declaration.parent.parent.kind === 213 /* ForOfStatement */) {
                // checkRightHandSideOfForOf will return undefined if the for-of expression type was
                // missing properties/signatures required to get its iteratedType (like
                // [Symbol.iterator] or next). This may be because we accessed properties from anyType,
                // or it may have led to an error inside getElementTypeOfIterable.
                return checkRightHandSideOfForOf(declaration.parent.parent.expression) || anyType;
            }
            if (ts.isBindingPattern(declaration.parent)) {
                return getTypeForBindingElement(declaration);
            }
            // Use type from type annotation if one is present
            if (declaration.type) {
                return addOptionality(getTypeFromTypeNode(declaration.type), /*optional*/ declaration.questionToken && includeOptionality);
            }
            if ((compilerOptions.noImplicitAny || declaration.flags & 65536 /* JavaScriptFile */) &&
                declaration.kind === 223 /* VariableDeclaration */ && !ts.isBindingPattern(declaration.name) &&
                !(ts.getCombinedModifierFlags(declaration) & 1 /* Export */) && !ts.isInAmbientContext(declaration)) {
                // If --noImplicitAny is on or the declaration is in a Javascript file,
                // use control flow tracked 'any' type for non-ambient, non-exported var or let variables with no
                // initializer or a 'null' or 'undefined' initializer.
                if (!(ts.getCombinedNodeFlags(declaration) & 2 /* Const */) && (!declaration.initializer || isNullOrUndefined(declaration.initializer))) {
                    return autoType;
                }
                // Use control flow tracked 'any[]' type for non-ambient, non-exported variables with an empty array
                // literal initializer.
                if (declaration.initializer && isEmptyArrayLiteral(declaration.initializer)) {
                    return autoArrayType;
                }
            }
            if (declaration.kind === 144 /* Parameter */) {
                var func = declaration.parent;
                // For a parameter of a set accessor, use the type of the get accessor if one is present
                if (func.kind === 152 /* SetAccessor */ && !ts.hasDynamicName(func)) {
                    var getter = ts.getDeclarationOfKind(declaration.parent.symbol, 151 /* GetAccessor */);
                    if (getter) {
                        var getterSignature = getSignatureFromDeclaration(getter);
                        var thisParameter = getAccessorThisParameter(func);
                        if (thisParameter && declaration === thisParameter) {
                            // Use the type from the *getter*
                            ts.Debug.assert(!thisParameter.type);
                            return getTypeOfSymbol(getterSignature.thisParameter);
                        }
                        return getReturnTypeOfSignature(getterSignature);
                    }
                }
                // Use contextual parameter type if one is available
                var type = void 0;
                if (declaration.symbol.name === "this") {
                    type = getContextualThisParameterType(func);
                }
                else {
                    type = getContextuallyTypedParameterType(declaration);
                }
                if (type) {
                    return addOptionality(type, /*optional*/ declaration.questionToken && includeOptionality);
                }
            }
            // Use the type of the initializer expression if one is present
            if (declaration.initializer) {
                var type = checkDeclarationInitializer(declaration);
                return addOptionality(type, /*optional*/ declaration.questionToken && includeOptionality);
            }
            // If it is a short-hand property assignment, use the type of the identifier
            if (declaration.kind === 258 /* ShorthandPropertyAssignment */) {
                return checkIdentifier(declaration.name);
            }
            // If the declaration specifies a binding pattern, use the type implied by the binding pattern
            if (ts.isBindingPattern(declaration.name)) {
                return getTypeFromBindingPattern(declaration.name, /*includePatternInType*/ false, /*reportErrors*/ true);
            }
            // No type specified and nothing can be inferred
            return undefined;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:addOptionality) id{585,1} ---
(type, optional) {
            return strictNullChecks && optional ? includeFalsyTypes(type, 2048 /* Undefined */) : type;
        }
--- END ---
INLINE (addOptionality) id{585,1} AS 1 AT <0:1856>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveName) id{586,0} ---
(location, name, meaning, nameNotFoundMessage, nameArg) {
            var result;
            var lastLocation;
            var propertyWithInvalidInitializer;
            var errorLocation = location;
            var grandparent;
            var isInExternalModule = false;
            loop: while (location) {
                // Locals of a source file are not in scope (because they get merged into the global symbol table)
                if (location.locals && !isGlobalSourceFile(location)) {
                    if (result = getSymbol(location.locals, name, meaning)) {
                        var useResult = true;
                        if (ts.isFunctionLike(location) && lastLocation && lastLocation !== location.body) {
                            // symbol lookup restrictions for function-like declarations
                            // - Type parameters of a function are in scope in the entire function declaration, including the parameter
                            //   list and return type. However, local types are only in scope in the function body.
                            // - parameters are only in the scope of function body
                            // This restriction does not apply to JSDoc comment types because they are parented
                            // at a higher level than type parameters would normally be
                            if (meaning & result.flags & 793064 /* Type */ && lastLocation.kind !== 278 /* JSDocComment */) {
                                useResult = result.flags & 262144 /* TypeParameter */
                                    ? lastLocation === location.type ||
                                        lastLocation.kind === 144 /* Parameter */ ||
                                        lastLocation.kind === 143 /* TypeParameter */
                                    : false;
                            }
                            if (meaning & 107455 /* Value */ && result.flags & 1 /* FunctionScopedVariable */) {
                                // parameters are visible only inside function body, parameter list and return type
                                // technically for parameter list case here we might mix parameters and variables declared in function,
                                // however it is detected separately when checking initializers of parameters
                                // to make sure that they reference no variables declared after them.
                                useResult =
                                    lastLocation.kind === 144 /* Parameter */ ||
                                        (lastLocation === location.type &&
                                            result.valueDeclaration.kind === 144 /* Parameter */);
                            }
                        }
                        if (useResult) {
                            break loop;
                        }
                        else {
                            result = undefined;
                        }
                    }
                }
                switch (location.kind) {
                    case 261 /* SourceFile */:
                        if (!ts.isExternalOrCommonJsModule(location))
                            break;
                        isInExternalModule = true;
                    case 230 /* ModuleDeclaration */:
                        var moduleExports = getSymbolOfNode(location).exports;
                        if (location.kind === 261 /* SourceFile */ || ts.isAmbientModule(location)) {
                            // It's an external module. First see if the module has an export default and if the local
                            // name of that export default matches.
                            if (result = moduleExports["default"]) {
                                var localSymbol = ts.getLocalSymbolForExportDefault(result);
                                if (localSymbol && (result.flags & meaning) && localSymbol.name === name) {
                                    break loop;
                                }
                                result = undefined;
                            }
                            // Because of module/namespace merging, a module's exports are in scope,
                            // yet we never want to treat an export specifier as putting a member in scope.
                            // Therefore, if the name we find is purely an export specifier, it is not actually considered in scope.
                            // Two things to note about this:
                            //     1. We have to check this without calling getSymbol. The problem with calling getSymbol
                            //        on an export specifier is that it might find the export specifier itself, and try to
                            //        resolve it as an alias. This will cause the checker to consider the export specifier
                            //        a circular alias reference when it might not be.
                            //     2. We check === SymbolFlags.Alias in order to check that the symbol is *purely*
                            //        an alias. If we used &, we'd be throwing out symbols that have non alias aspects,
                            //        which is not the desired behavior.
                            if (moduleExports[name] &&
                                moduleExports[name].flags === 8388608 /* Alias */ &&
                                ts.getDeclarationOfKind(moduleExports[name], 243 /* ExportSpecifier */)) {
                                break;
                            }
                        }
                        if (result = getSymbol(moduleExports, name, meaning & 8914931 /* ModuleMember */)) {
                            break loop;
                        }
                        break;
                    case 229 /* EnumDeclaration */:
                        if (result = getSymbol(getSymbolOfNode(location).exports, name, meaning & 8 /* EnumMember */)) {
                            break loop;
                        }
                        break;
                    case 147 /* PropertyDeclaration */:
                    case 146 /* PropertySignature */:
                        // TypeScript 1.0 spec (April 2014): 8.4.1
                        // Initializer expressions for instance member variables are evaluated in the scope
                        // of the class constructor body but are not permitted to reference parameters or
                        // local variables of the constructor. This effectively means that entities from outer scopes
                        // by the same name as a constructor parameter or local variable are inaccessible
                        // in initializer expressions for instance member variables.
                        if (ts.isClassLike(location.parent) && !(ts.getModifierFlags(location) & 32 /* Static */)) {
                            var ctor = findConstructorDeclaration(location.parent);
                            if (ctor && ctor.locals) {
                                if (getSymbol(ctor.locals, name, meaning & 107455 /* Value */)) {
                                    // Remember the property node, it will be used later to report appropriate error
                                    propertyWithInvalidInitializer = location;
                                }
                            }
                        }
                        break;
                    case 226 /* ClassDeclaration */:
                    case 197 /* ClassExpression */:
                    case 227 /* InterfaceDeclaration */:
                        if (result = getSymbol(getSymbolOfNode(location).members, name, meaning & 793064 /* Type */)) {
                            if (lastLocation && ts.getModifierFlags(lastLocation) & 32 /* Static */) {
                                // TypeScript 1.0 spec (April 2014): 3.4.1
                                // The scope of a type parameter extends over the entire declaration with which the type
                                // parameter list is associated, with the exception of static member declarations in classes.
                                error(errorLocation, ts.Diagnostics.Static_members_cannot_reference_class_type_parameters);
                                return undefined;
                            }
                            break loop;
                        }
                        if (location.kind === 197 /* ClassExpression */ && meaning & 32 /* Class */) {
                            var className = location.name;
                            if (className && name === className.text) {
                                result = location.symbol;
                                break loop;
                            }
                        }
                        break;
                    // It is not legal to reference a class's own type parameters from a computed property name that
                    // belongs to the class. For example:
                    //
                    //   function foo<T>() { return '' }
                    //   class C<T> { // <-- Class's own type parameter T
                    //       [foo<T>()]() { } // <-- Reference to T from class's own computed property
                    //   }
                    //
                    case 142 /* ComputedPropertyName */:
                        grandparent = location.parent.parent;
                        if (ts.isClassLike(grandparent) || grandparent.kind === 227 /* InterfaceDeclaration */) {
                            // A reference to this grandparent's type parameters would be an error
                            if (result = getSymbol(getSymbolOfNode(grandparent).members, name, meaning & 793064 /* Type */)) {
                                error(errorLocation, ts.Diagnostics.A_computed_property_name_cannot_reference_a_type_parameter_from_its_containing_type);
                                return undefined;
                            }
                        }
                        break;
                    case 149 /* MethodDeclaration */:
                    case 148 /* MethodSignature */:
                    case 150 /* Constructor */:
                    case 151 /* GetAccessor */:
                    case 152 /* SetAccessor */:
                    case 225 /* FunctionDeclaration */:
                    case 185 /* ArrowFunction */:
                        if (meaning & 3 /* Variable */ && name === "arguments") {
                            result = argumentsSymbol;
                            break loop;
                        }
                        break;
                    case 184 /* FunctionExpression */:
                        if (meaning & 3 /* Variable */ && name === "arguments") {
                            result = argumentsSymbol;
                            break loop;
                        }
                        if (meaning & 16 /* Function */) {
                            var functionName = location.name;
                            if (functionName && name === functionName.text) {
                                result = location.symbol;
                                break loop;
                            }
                        }
                        break;
                    case 145 /* Decorator */:
                        // Decorators are resolved at the class declaration. Resolving at the parameter
                        // or member would result in looking up locals in the method.
                        //
                        //   function y() {}
                        //   class C {
                        //       method(@y x, y) {} // <-- decorator y should be resolved at the class declaration, not the parameter.
                        //   }
                        //
                        if (location.parent && location.parent.kind === 144 /* Parameter */) {
                            location = location.parent;
                        }
                        //
                        //   function y() {}
                        //   class C {
                        //       @y method(x, y) {} // <-- decorator y should be resolved at the class declaration, not the method.
                        //   }
                        //
                        if (location.parent && ts.isClassElement(location.parent)) {
                            location = location.parent;
                        }
                        break;
                }
                lastLocation = location;
                location = location.parent;
            }
            if (result && nameNotFoundMessage && noUnusedIdentifiers) {
                result.isReferenced = true;
            }
            if (!result) {
                result = getSymbol(globals, name, meaning);
            }
            if (!result) {
                if (nameNotFoundMessage) {
                    if (!errorLocation ||
                        !checkAndReportErrorForMissingPrefix(errorLocation, name, nameArg) &&
                            !checkAndReportErrorForExtendingInterface(errorLocation) &&
                            !checkAndReportErrorForUsingTypeAsNamespace(errorLocation, name, meaning) &&
                            !checkAndReportErrorForUsingTypeAsValue(errorLocation, name, meaning)) {
                        error(errorLocation, nameNotFoundMessage, typeof nameArg === "string" ? nameArg : ts.declarationNameToString(nameArg));
                    }
                }
                return undefined;
            }
            // Perform extra checks only if error reporting was requested
            if (nameNotFoundMessage) {
                if (propertyWithInvalidInitializer) {
                    // We have a match, but the reference occurred within a property initializer and the identifier also binds
                    // to a local variable in the constructor where the code will be emitted.
                    var propertyName = propertyWithInvalidInitializer.name;
                    error(errorLocation, ts.Diagnostics.Initializer_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor, ts.declarationNameToString(propertyName), typeof nameArg === "string" ? nameArg : ts.declarationNameToString(nameArg));
                    return undefined;
                }
                // Only check for block-scoped variable if we are looking for the
                // name with variable meaning
                //      For example,
                //          declare module foo {
                //              interface bar {}
                //          }
                //      const foo/*1*/: foo/*2*/.bar;
                // The foo at /*1*/ and /*2*/ will share same symbol with two meaning
                // block - scope variable and namespace module. However, only when we
                // try to resolve name in /*1*/ which is used in variable position,
                // we want to check for block- scoped
                if (meaning & 2 /* BlockScopedVariable */) {
                    var exportOrLocalSymbol = getExportSymbolOfValueSymbolIfExported(result);
                    if (exportOrLocalSymbol.flags & 2 /* BlockScopedVariable */) {
                        checkResolvedBlockScopedVariable(exportOrLocalSymbol, errorLocation);
                    }
                }
                // If we're in an external module, we can't reference value symbols created from UMD export declarations
                if (result && isInExternalModule && (meaning & 107455 /* Value */) === 107455 /* Value */) {
                    var decls = result.declarations;
                    if (decls && decls.length === 1 && decls[0].kind === 233 /* NamespaceExportDeclaration */) {
                        error(errorLocation, ts.Diagnostics._0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead, name);
                    }
                }
            }
            return result;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isGlobalSourceFile) id{586,1} ---
(node) {
            return node.kind === 261 /* SourceFile */ && !ts.isExternalOrCommonJsModule(node);
        }
--- END ---
INLINE (isGlobalSourceFile) id{586,1} AS 1 AT <0:467>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{586,2} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{586,2} AS 2 AT <0:3412>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{586,3} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{586,3} AS 3 AT <2:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{586,4} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{586,4} AS 4 AT <0:7735>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{586,5} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{586,5} AS 5 AT <4:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getExportSymbolOfValueSymbolIfExported) id{586,6} ---
(symbol) {
            return symbol && (symbol.flags & 1048576 /* ExportValue */) !== 0
                ? getMergedSymbol(symbol.exportSymbol)
                : symbol;
        }
--- END ---
INLINE (getExportSymbolOfValueSymbolIfExported) id{586,6} AS 6 AT <0:15249>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeWithThisArgument) id{587,0} ---
(type, thisArgument) {
            if (getObjectFlags(type) & 4 /* Reference */) {
                return createTypeReference(type.target, ts.concatenate(type.typeArguments, [thisArgument || type.target.thisType]));
            }
            return type;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{587,1} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{587,1} AS 1 AT <0:39>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createTypeReference) id{587,2} ---
(target, typeArguments) {
            var id = getTypeListId(typeArguments);
            var type = target.instantiations[id];
            if (!type) {
                type = target.instantiations[id] = createObjectType(4 /* Reference */, target.symbol);
                type.flags |= typeArguments ? getPropagatingFlagsOfTypes(typeArguments, /*excludeKinds*/ 0) : 0;
                type.target = target;
                type.typeArguments = typeArguments;
            }
            return type;
        }
--- END ---
INLINE (createTypeReference) id{587,2} AS 2 AT <0:106>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createObjectType) id{587,3} ---
(objectFlags, symbol) {
            var type = createType(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol = symbol;
            return type;
        }
--- END ---
INLINE (createObjectType) id{587,3} AS 3 AT <2:203>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{587,4} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{587,4} AS 4 AT <3:47>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{587,5} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{587,5} AS 5 AT <4:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropagatingFlagsOfTypes) id{587,6} ---
(types, excludeKinds) {
            var result = 0;
            for (var _i = 0, types_3 = types; _i < types_3.length; _i++) {
                var type = types_3[_i];
                if (!(type.flags & excludeKinds)) {
                    result |= type.flags;
                }
            }
            return result & 14680064 /* PropagatingFlags */;
        }
--- END ---
INLINE (getPropagatingFlagsOfTypes) id{587,6} AS 6 AT <2:301>
[deoptimizing (DEOPT eager): begin 0x1030c9d41f79 <JS Function checkPropertyDeclaration (SharedFunctionInfo 0x1b98fbc0a981)> (opt #556) @11, FP to SP delta: 24, caller sp: 0x7fff5fbfdd38]
            ;;; deoptimize at 0_183: wrong map
  reading input frame checkPropertyDeclaration => node=7, args=2, height=1; inputs:
      0: 0x1030c9d41f79 ; [fp - 16] 0x1030c9d41f79 <JS Function checkPropertyDeclaration (SharedFunctionInfo 0x1b98fbc0a981)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x35fa3c465f91 ; rdx 0x35fa3c465f91 <a NodeObject with map 0x33abe2a71c29>
      3: 0x130b7e1b3d29 ; rax 0x130b7e1b3d29 <FixedArray[1022]>
  translating frame checkPropertyDeclaration => node=7, height=0
    0x7fff5fbfdd30: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdd28: [top + 32] <- 0x35fa3c465f91 ;  0x35fa3c465f91 <a NodeObject with map 0x33abe2a71c29>  (input #2)
    0x7fff5fbfdd20: [top + 24] <- 0x2c21d25ec087 ;  caller's pc
    0x7fff5fbfdd18: [top + 16] <- 0x7fff5fbfdd68 ;  caller's fp
    0x7fff5fbfdd10: [top + 8] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdd08: [top + 0] <- 0x1030c9d41f79 ;  function    0x1030c9d41f79 <JS Function checkPropertyDeclaration (SharedFunctionInfo 0x1b98fbc0a981)>  (input #0)
[deoptimizing (eager): end 0x1030c9d41f79 <JS Function checkPropertyDeclaration (SharedFunctionInfo 0x1b98fbc0a981)> @11 => node=7, pc=0x2c21d2610785, caller sp=0x7fff5fbfdd38, state=NO_REGISTERS, took 0.050 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkSourceElement) id{588,0} ---
(node) {
            if (!node) {
                return;
            }
            var kind = node.kind;
            if (cancellationToken) {
                // Only bother checking on a few construct kinds.  We don't want to be excessively
                // hitting the cancellation token on every node we check.
                switch (kind) {
                    case 230 /* ModuleDeclaration */:
                    case 226 /* ClassDeclaration */:
                    case 227 /* InterfaceDeclaration */:
                    case 225 /* FunctionDeclaration */:
                        cancellationToken.throwIfCancellationRequested();
                }
            }
            switch (kind) {
                case 143 /* TypeParameter */:
                    return checkTypeParameter(node);
                case 144 /* Parameter */:
                    return checkParameter(node);
                case 147 /* PropertyDeclaration */:
                case 146 /* PropertySignature */:
                    return checkPropertyDeclaration(node);
                case 158 /* FunctionType */:
                case 159 /* ConstructorType */:
                case 153 /* CallSignature */:
                case 154 /* ConstructSignature */:
                    return checkSignatureDeclaration(node);
                case 155 /* IndexSignature */:
                    return checkSignatureDeclaration(node);
                case 149 /* MethodDeclaration */:
                case 148 /* MethodSignature */:
                    return checkMethodDeclaration(node);
                case 150 /* Constructor */:
                    return checkConstructorDeclaration(node);
                case 151 /* GetAccessor */:
                case 152 /* SetAccessor */:
                    return checkAccessorDeclaration(node);
                case 157 /* TypeReference */:
                    return checkTypeReferenceNode(node);
                case 156 /* TypePredicate */:
                    return checkTypePredicate(node);
                case 160 /* TypeQuery */:
                    return checkTypeQuery(node);
                case 161 /* TypeLiteral */:
                    return checkTypeLiteral(node);
                case 162 /* ArrayType */:
                    return checkArrayType(node);
                case 163 /* TupleType */:
                    return checkTupleType(node);
                case 164 /* UnionType */:
                case 165 /* IntersectionType */:
                    return checkUnionOrIntersectionType(node);
                case 166 /* ParenthesizedType */:
                case 168 /* TypeOperator */:
                    return checkSourceElement(node.type);
                case 169 /* IndexedAccessType */:
                    return checkIndexedAccessType(node);
                case 170 /* MappedType */:
                    return checkMappedType(node);
                case 225 /* FunctionDeclaration */:
                    return checkFunctionDeclaration(node);
                case 204 /* Block */:
                case 231 /* ModuleBlock */:
                    return checkBlock(node);
                case 205 /* VariableStatement */:
                    return checkVariableStatement(node);
                case 207 /* ExpressionStatement */:
                    return checkExpressionStatement(node);
                case 208 /* IfStatement */:
                    return checkIfStatement(node);
                case 209 /* DoStatement */:
                    return checkDoStatement(node);
                case 210 /* WhileStatement */:
                    return checkWhileStatement(node);
                case 211 /* ForStatement */:
                    return checkForStatement(node);
                case 212 /* ForInStatement */:
                    return checkForInStatement(node);
                case 213 /* ForOfStatement */:
                    return checkForOfStatement(node);
                case 214 /* ContinueStatement */:
                case 215 /* BreakStatement */:
                    return checkBreakOrContinueStatement(node);
                case 216 /* ReturnStatement */:
                    return checkReturnStatement(node);
                case 217 /* WithStatement */:
                    return checkWithStatement(node);
                case 218 /* SwitchStatement */:
                    return checkSwitchStatement(node);
                case 219 /* LabeledStatement */:
                    return checkLabeledStatement(node);
                case 220 /* ThrowStatement */:
                    return checkThrowStatement(node);
                case 221 /* TryStatement */:
                    return checkTryStatement(node);
                case 223 /* VariableDeclaration */:
                    return checkVariableDeclaration(node);
                case 174 /* BindingElement */:
                    return checkBindingElement(node);
                case 226 /* ClassDeclaration */:
                    return checkClassDeclaration(node);
                case 227 /* InterfaceDeclaration */:
                    return checkInterfaceDeclaration(node);
                case 228 /* TypeAliasDeclaration */:
                    return checkTypeAliasDeclaration(node);
                case 229 /* EnumDeclaration */:
                    return checkEnumDeclaration(node);
                case 230 /* ModuleDeclaration */:
                    return checkModuleDeclaration(node);
                case 235 /* ImportDeclaration */:
                    return checkImportDeclaration(node);
                case 234 /* ImportEqualsDeclaration */:
                    return checkImportEqualsDeclaration(node);
                case 241 /* ExportDeclaration */:
                    return checkExportDeclaration(node);
                case 240 /* ExportAssignment */:
                    return checkExportAssignment(node);
                case 206 /* EmptyStatement */:
                    checkGrammarStatementInAmbientContext(node);
                    return;
                case 222 /* DebuggerStatement */:
                    checkGrammarStatementInAmbientContext(node);
                    return;
                case 244 /* MissingDeclaration */:
                    return checkMissingDeclaration(node);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkTypeParameter) id{588,1} ---
(node) {
            // Grammar Checking
            if (node.expression) {
                grammarErrorOnFirstToken(node.expression, ts.Diagnostics.Type_expected);
            }
            checkSourceElement(node.constraint);
            getConstraintOfTypeParameter(getDeclaredTypeOfTypeParameter(getSymbolOfNode(node)));
            if (produceDiagnostics) {
                checkTypeNameIsReserved(node.name, ts.Diagnostics.Type_parameter_name_cannot_be_0);
            }
        }
--- END ---
INLINE (checkTypeParameter) id{588,1} AS 1 AT <0:775>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{588,2} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{588,2} AS 2 AT <1:300>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{588,3} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{588,3} AS 3 AT <2:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getDeclaredTypeOfTypeParameter) id{588,4} ---
(symbol) {
            var links = getSymbolLinks(symbol);
            if (!links.declaredType) {
                var type = createType(16384 /* TypeParameter */);
                type.symbol = symbol;
                if (!ts.getDeclarationOfKind(symbol, 143 /* TypeParameter */).constraint) {
                    type.constraint = noConstraintType;
                }
                links.declaredType = type;
            }
            return links.declaredType;
        }
--- END ---
INLINE (getDeclaredTypeOfTypeParameter) id{588,4} AS 4 AT <1:269>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{588,5} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{588,5} AS 5 AT <4:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{588,6} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{588,6} AS 6 AT <5:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{588,7} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{588,7} AS 7 AT <4:125>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{588,8} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{588,8} AS 8 AT <7:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkTypeNameIsReserved) id{588,9} ---
(name, message) {
            // TS 1.0 spec (April 2014): 3.6.1
            // The predefined type keywords are reserved and cannot be used as names of user defined types.
            switch (name.text) {
                case "any":
                case "number":
                case "boolean":
                case "string":
                case "symbol":
                case "void":
                    error(name, message, name.text);
            }
        }
--- END ---
INLINE (checkTypeNameIsReserved) id{588,9} AS 9 AT <1:379>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkPropertyDeclaration) id{588,10} ---
(node) {
            // Grammar checking
            checkGrammarDecorators(node) || checkGrammarModifiers(node) || checkGrammarProperty(node) || checkGrammarComputedPropertyName(node.name);
            checkVariableLikeDeclaration(node);
        }
--- END ---
INLINE (checkPropertyDeclaration) id{588,10} AS 10 AT <0:1021>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarComputedPropertyName) id{588,11} ---
(node) {
            // If node is not a computedPropertyName, just skip the grammar checking
            if (node.kind !== 142 /* ComputedPropertyName */) {
                return false;
            }
            var computedPropertyName = node;
            if (computedPropertyName.expression.kind === 192 /* BinaryExpression */ && computedPropertyName.expression.operatorToken.kind === 25 /* CommaToken */) {
                return grammarErrorOnNode(computedPropertyName.expression, ts.Diagnostics.A_comma_expression_is_not_allowed_in_a_computed_property_name);
            }
        }
--- END ---
INLINE (checkGrammarComputedPropertyName) id{588,11} AS 11 AT <10:146>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkTypeQuery) id{588,12} ---
(node) {
            getTypeFromTypeQueryNode(node);
        }
--- END ---
INLINE (checkTypeQuery) id{588,12} AS 12 AT <0:2089>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeFromTypeQueryNode) id{588,13} ---
(node) {
            var links = getNodeLinks(node);
            if (!links.resolvedType) {
                // TypeScript 1.0 spec (April 2014): 3.6.3
                // The expression is processed as an identifier expression (section 4.3)
                // or property access expression(section 4.10),
                // the widened type(section 3.9) of which becomes the result.
                links.resolvedType = getWidenedType(checkExpression(node.exprName));
            }
            return links.resolvedType;
        }
--- END ---
INLINE (getTypeFromTypeQueryNode) id{588,13} AS 13 AT <12:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeLinks) id{588,14} ---
(node) {
            var nodeId = getNodeId(node);
            return nodeLinks[nodeId] || (nodeLinks[nodeId] = { flags: 0 });
        }
--- END ---
INLINE (getNodeLinks) id{588,14} AS 14 AT <13:33>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeId) id{588,15} ---
(node) {
        if (!node.id) {
            node.id = nextNodeId;
            nextNodeId++;
        }
        return node.id;
    }
--- END ---
INLINE (getNodeId) id{588,15} AS 15 AT <14:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkTypeLiteral) id{588,16} ---
(node) {
            ts.forEach(node.members, checkSourceElement);
            if (produceDiagnostics) {
                var type = getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode(node);
                checkIndexConstraints(type);
                checkTypeForDuplicateIndexSignatures(node);
                checkObjectTypeForDuplicateDeclarations(node);
            }
        }
--- END ---
INLINE (checkTypeLiteral) id{588,16} AS 16 AT <0:2182>
[deoptimizing (DEOPT eager): begin 0x130b7e1b6811 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)> (opt #586) @92, FP to SP delta: 328, caller sp: 0x7fff5fbfd858]
            ;;; deoptimize at 0_5443: wrong map
  reading input frame resolveName => node=783, args=6, height=18; inputs:
      0: 0x130b7e1b6811 ; [fp - 16] 0x130b7e1b6811 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)>
      1: 0x1f9f6c0532e1 ; [fp + 56] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x35fa3c437239 ; [fp - 64] 0x35fa3c437239 <a NodeObject with map 0x33abe2a71231>
      3: 0x35fa3c438569 ; [fp + 40] 0x35fa3c438569 <String[5]: Agent>
      4: 0xc19e800000000 ; [fp + 32] 793064
      5: 0xd6230ded3a9 ; [fp + 24] 0xd6230ded3a9 <an Object with map 0x33abe2a3df61>
      6: 0x35fa3c49f621 ; [fp + 16] 0x35fa3c49f621 <an IdentifierObject with map 0x33abe2a6fb81>
      7: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      8: 0x30bcea4069a9 ; (literal 14) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      9: 0x30bcea404311 ; [fp - 248] 0x30bcea404311 <undefined>
     10: 0x30bcea4069a9 ; (literal 14) 0x30bcea4069a9 <Odd Oddball: optimized_out>
     11: 0x30bcea404311 ; [fp - 40] 0x30bcea404311 <undefined>
     12: 0x35fa3c49f621 ; [fp + 48] 0x35fa3c49f621 <an IdentifierObject with map 0x33abe2a6fb81>
     13: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     14: 0x30bcea404421 ; [fp - 184] 0x30bcea404421 <false>
     15: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     16: 0x1030c9d6f839 ; [fp - 216] 0x1030c9d6f839 <an Object with map 0x33abe2a3d1a1>
     17: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     18: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     19: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     20: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     21: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     22: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     23: 0x30bcea404311 ; (literal 9) 0x30bcea404311 <undefined>
     24: 0x1030c9d73069 ; rax 0x1030c9d73069 <a SymbolObject with map 0x15b5a790ff11>
  translating frame resolveName => node=783, height=136
    0x7fff5fbfd850: [top + 208] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd848: [top + 200] <- 0x35fa3c437239 ;  0x35fa3c437239 <a NodeObject with map 0x33abe2a71231>  (input #2)
    0x7fff5fbfd840: [top + 192] <- 0x35fa3c438569 ;  0x35fa3c438569 <String[5]: Agent>  (input #3)
    0x7fff5fbfd838: [top + 184] <- 0xc19e800000000 ;  793064  (input #4)
    0x7fff5fbfd830: [top + 176] <- 0xd6230ded3a9 ;  0xd6230ded3a9 <an Object with map 0x33abe2a3df61>  (input #5)
    0x7fff5fbfd828: [top + 168] <- 0x35fa3c49f621 ;  0x35fa3c49f621 <an IdentifierObject with map 0x33abe2a6fb81>  (input #6)
    0x7fff5fbfd820: [top + 160] <- 0x2c21d26139a6 ;  caller's pc
    0x7fff5fbfd818: [top + 152] <- 0x7fff5fbfd898 ;  caller's fp
    0x7fff5fbfd810: [top + 144] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #7)
    0x7fff5fbfd808: [top + 136] <- 0x130b7e1b6811 ;  function    0x130b7e1b6811 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)>  (input #0)
    0x7fff5fbfd800: [top + 128] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #8)
    0x7fff5fbfd7f8: [top + 120] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
    0x7fff5fbfd7f0: [top + 112] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #10)
    0x7fff5fbfd7e8: [top + 104] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #11)
    0x7fff5fbfd7e0: [top + 96] <- 0x35fa3c49f621 ;  0x35fa3c49f621 <an IdentifierObject with map 0x33abe2a6fb81>  (input #12)
    0x7fff5fbfd7d8: [top + 88] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #13)
    0x7fff5fbfd7d0: [top + 80] <- 0x30bcea404421 ;  0x30bcea404421 <false>  (input #14)
    0x7fff5fbfd7c8: [top + 72] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #15)
    0x7fff5fbfd7c0: [top + 64] <- 0x1030c9d6f839 ;  0x1030c9d6f839 <an Object with map 0x33abe2a3d1a1>  (input #16)
    0x7fff5fbfd7b8: [top + 56] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #17)
    0x7fff5fbfd7b0: [top + 48] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #18)
    0x7fff5fbfd7a8: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #19)
    0x7fff5fbfd7a0: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #20)
    0x7fff5fbfd798: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #21)
    0x7fff5fbfd790: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #22)
    0x7fff5fbfd788: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #23)
    0x7fff5fbfd780: [top + 0] <- 0x1030c9d73069 ;  0x1030c9d73069 <a SymbolObject with map 0x15b5a790ff11>  (input #24)
[deoptimizing (eager): end 0x130b7e1b6811 <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)> @92 => node=783, pc=0x2c21d25e5399, caller sp=0x7fff5fbfd858, state=TOS_REGISTER, took 0.268 ms]
[deoptimizing (DEOPT eager): begin 0x17ddd84043f9 <JS Function getUnionType (SharedFunctionInfo 0x2e2f693f3d11)> (opt #525) @14, FP to SP delta: 72, caller sp: 0x7fff5fbfd6e0]
            ;;; deoptimize at 2_35: wrong map
  reading input frame getUnionType => node=146, args=5, height=3; inputs:
      0: 0x17ddd84043f9 ; [fp - 16] 0x17ddd84043f9 <JS Function getUnionType (SharedFunctionInfo 0x2e2f693f3d11)>
      1: 0x1f9f6c0532e1 ; [fp + 48] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x8b78ad551f9 ; [fp + 40] 0x8b78ad551f9 <JS Array[3]>
      3: 0x30bcea404421 ; [fp + 32] 0x30bcea404421 <false>
      4: 0x30bcea404311 ; [fp + 24] 0x30bcea404311 <undefined>
      5: 0x30bcea404311 ; [fp + 16] 0x30bcea404311 <undefined>
      6: 0x130b7e1b3d29 ; rax 0x130b7e1b3d29 <FixedArray[1022]>
      7: 0x8b78ad554c1 ; rcx 0x8b78ad554c1 <JS Array[3]>
      8: 0x1030c9d55339 ; rbx 0x1030c9d55339 <JS Function removeRedundantLiteralTypes (SharedFunctionInfo 0x2e2f693f3c51)>
  reading input frame removeRedundantLiteralTypes => node=3, args=2, height=4; inputs:
      0: 0x1030c9d55339 ; (literal 10) 0x1030c9d55339 <JS Function removeRedundantLiteralTypes (SharedFunctionInfo 0x2e2f693f3c51)>
      1: 0x1f9f6c0532e1 ; (literal 7) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x8b78ad554c1 ; rcx 0x8b78ad554c1 <JS Array[3]>
      3: 0x130b7e1b3d29 ; (literal 8) 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
      5: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
      6: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
  translating frame getUnionType => node=146, height=16
    0x7fff5fbfd6d8: [top + 80] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd6d0: [top + 72] <- 0x8b78ad551f9 ;  0x8b78ad551f9 <JS Array[3]>  (input #2)
    0x7fff5fbfd6c8: [top + 64] <- 0x30bcea404421 ;  0x30bcea404421 <false>  (input #3)
    0x7fff5fbfd6c0: [top + 56] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfd6b8: [top + 48] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfd6b0: [top + 40] <- 0x2c21d271b1ba ;  caller's pc
    0x7fff5fbfd6a8: [top + 32] <- 0x7fff5fbfd788 ;  caller's fp
    0x7fff5fbfd6a0: [top + 24] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #6)
    0x7fff5fbfd698: [top + 16] <- 0x17ddd84043f9 ;  function    0x17ddd84043f9 <JS Function getUnionType (SharedFunctionInfo 0x2e2f693f3d11)>  (input #0)
    0x7fff5fbfd690: [top + 8] <- 0x8b78ad554c1 ;  0x8b78ad554c1 <JS Array[3]>  (input #7)
    0x7fff5fbfd688: [top + 0] <- 0x1030c9d55339 ;  0x1030c9d55339 <JS Function removeRedundantLiteralTypes (SharedFunctionInfo 0x2e2f693f3c51)>  (input #8)
  translating frame removeRedundantLiteralTypes => node=3, height=24
    0x7fff5fbfd680: [top + 64] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd678: [top + 56] <- 0x8b78ad554c1 ;  0x8b78ad554c1 <JS Array[3]>  (input #2)
    0x7fff5fbfd670: [top + 48] <- 0x2c21d253b9d3 ;  caller's pc
    0x7fff5fbfd668: [top + 40] <- 0x7fff5fbfd6a8 ;  caller's fp
    0x7fff5fbfd660: [top + 32] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd658: [top + 24] <- 0x1030c9d55339 ;  function    0x1030c9d55339 <JS Function removeRedundantLiteralTypes (SharedFunctionInfo 0x2e2f693f3c51)>  (input #0)
    0x7fff5fbfd650: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfd648: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfd640: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
[deoptimizing (eager): end 0x17ddd84043f9 <JS Function getUnionType (SharedFunctionInfo 0x2e2f693f3d11)> @14 => node=3, pc=0x2c21d269f20d, caller sp=0x7fff5fbfd6e0, state=NO_REGISTERS, took 0.508 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d3e2b1 <JS Function getSymbol (SharedFunctionInfo 0x2e2f693e7951)> (opt #584) @18, FP to SP delta: 40, caller sp: 0x7fff5fbfd608]
            ;;; deoptimize at 0_701: wrong map
  reading input frame getSymbol => node=168, args=4, height=3; inputs:
      0: 0x1030c9d3e2b1 ; [fp - 16] 0x1030c9d3e2b1 <JS Function getSymbol (SharedFunctionInfo 0x2e2f693e7951)>
      1: 0x1f9f6c0532e1 ; [fp + 40] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x130b7e1c58b9 ; [fp + 32] 0x130b7e1c58b9 <an Object with map 0x33abe2a3d1a1>
      3: 0x35fa3c438651 ; [fp + 24] 0x35fa3c438651 <String[5]: child>
      4: 0x78000000000 ; [fp + 16] 1920
      5: 0x130b7e1b3d29 ; rbx 0x130b7e1b3d29 <FixedArray[1022]>
      6: 0x130b7e1cac01 ; [fp - 32] 0x130b7e1cac01 <a SymbolObject with map 0x33abe2a72ca9>
      7: 0x130b7e1eeb91 ; rax 0x130b7e1eeb91 <a SymbolObject with map 0x33abe2a71079>
  translating frame getSymbol => node=168, height=16
    0x7fff5fbfd600: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd5f8: [top + 64] <- 0x130b7e1c58b9 ;  0x130b7e1c58b9 <an Object with map 0x33abe2a3d1a1>  (input #2)
    0x7fff5fbfd5f0: [top + 56] <- 0x35fa3c438651 ;  0x35fa3c438651 <String[5]: child>  (input #3)
    0x7fff5fbfd5e8: [top + 48] <- 0x78000000000 ;  1920  (input #4)
    0x7fff5fbfd5e0: [top + 40] <- 0x2c21d25e438b ;  caller's pc
    0x7fff5fbfd5d8: [top + 32] <- 0x7fff5fbfd6a0 ;  caller's fp
    0x7fff5fbfd5d0: [top + 24] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #5)
    0x7fff5fbfd5c8: [top + 16] <- 0x1030c9d3e2b1 ;  function    0x1030c9d3e2b1 <JS Function getSymbol (SharedFunctionInfo 0x2e2f693e7951)>  (input #0)
    0x7fff5fbfd5c0: [top + 8] <- 0x130b7e1cac01 ;  0x130b7e1cac01 <a SymbolObject with map 0x33abe2a72ca9>  (input #6)
    0x7fff5fbfd5b8: [top + 0] <- 0x130b7e1eeb91 ;  0x130b7e1eeb91 <a SymbolObject with map 0x33abe2a71079>  (input #7)
[deoptimizing (eager): end 0x1030c9d3e2b1 <JS Function getSymbol (SharedFunctionInfo 0x2e2f693e7951)> @18 => node=168, pc=0x2c21d25e6cb2, caller sp=0x7fff5fbfd608, state=NO_REGISTERS, took 0.326 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isInAmbientContext) id{589,0} ---
(node) {
        while (node) {
            if (hasModifier(node, 2 /* Ambient */) || (node.kind === 261 /* SourceFile */ && node.isDeclarationFile)) {
                return true;
            }
            node = node.parent;
        }
        return false;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:hasModifier) id{589,1} ---
(node, flags) {
        return (getModifierFlags(node) & flags) !== 0;
    }
--- END ---
INLINE (hasModifier) id{589,1} AS 1 AT <0:48>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeOfFuncClassEnumModule) id{590,0} ---
(symbol) {
            var links = getSymbolLinks(symbol);
            if (!links.type) {
                if (symbol.flags & 1536 /* Module */ && ts.isShorthandAmbientModuleSymbol(symbol)) {
                    links.type = anyType;
                }
                else {
                    var type = createObjectType(16 /* Anonymous */, symbol);
                    links.type = strictNullChecks && symbol.flags & 536870912 /* Optional */ ?
                        includeFalsyTypes(type, 2048 /* Undefined */) : type;
                }
            }
            return links.type;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{590,1} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{590,1} AS 1 AT <0:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{590,2} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{590,2} AS 2 AT <1:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createObjectType) id{590,3} ---
(objectFlags, symbol) {
            var type = createType(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol = symbol;
            return type;
        }
--- END ---
INLINE (createObjectType) id{590,3} AS 3 AT <0:305>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{590,4} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{590,4} AS 4 AT <3:47>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{590,5} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{590,5} AS 5 AT <4:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbol) id{591,0} ---
(symbols, name, meaning) {
            if (meaning) {
                var symbol = symbols[name];
                if (symbol) {
                    ts.Debug.assert((symbol.flags & 16777216 /* Instantiated */) === 0, "Should never get an instantiated symbol here.");
                    if (symbol.flags & meaning) {
                        return symbol;
                    }
                    if (symbol.flags & 8388608 /* Alias */) {
                        var target = resolveAlias(symbol);
                        // Unknown symbol means an error occurred in alias resolution, treat it as positive answer to avoid cascading errors
                        if (target === unknownSymbol || target.flags & meaning) {
                            return symbol;
                        }
                    }
                }
            }
            // return undefined if we can't find a symbol.
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getDeclaredTypeOfClassOrInterface) id{593,0} ---
(symbol) {
            var links = getSymbolLinks(symbol);
            if (!links.declaredType) {
                var kind = symbol.flags & 32 /* Class */ ? 1 /* Class */ : 2 /* Interface */;
                var type = links.declaredType = createObjectType(kind, symbol);
                var outerTypeParameters = getOuterTypeParametersOfClassOrInterface(symbol);
                var localTypeParameters = getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol);
                // A class or interface is generic if it has type parameters or a "this" type. We always give classes a "this" type
                // because it is not feasible to analyze all members to determine if the "this" type escapes the class (in particular,
                // property types inferred from initializers and method return types inferred from return statements are very hard
                // to exhaustively analyze). We give interfaces a "this" type if we can't definitely determine that they are free of
                // "this" references.
                if (outerTypeParameters || localTypeParameters || kind === 1 /* Class */ || !isIndependentInterface(symbol)) {
                    type.objectFlags |= 4 /* Reference */;
                    type.typeParameters = ts.concatenate(outerTypeParameters, localTypeParameters);
                    type.outerTypeParameters = outerTypeParameters;
                    type.localTypeParameters = localTypeParameters;
                    type.instantiations = ts.createMap();
                    type.instantiations[getTypeListId(type.typeParameters)] = type;
                    type.target = type;
                    type.typeArguments = type.typeParameters;
                    type.thisType = createType(16384 /* TypeParameter */);
                    type.thisType.isThisType = true;
                    type.thisType.symbol = symbol;
                    type.thisType.constraint = type;
                }
            }
            return links.declaredType;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{593,1} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{593,1} AS 1 AT <0:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{593,2} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{593,2} AS 2 AT <1:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createObjectType) id{593,3} ---
(objectFlags, symbol) {
            var type = createType(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol = symbol;
            return type;
        }
--- END ---
INLINE (createObjectType) id{593,3} AS 3 AT <0:240>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{593,4} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{593,4} AS 4 AT <3:47>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{593,5} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{593,5} AS 5 AT <4:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getOuterTypeParametersOfClassOrInterface) id{593,6} ---
(symbol) {
            var declaration = symbol.flags & 32 /* Class */ ? symbol.valueDeclaration : ts.getDeclarationOfKind(symbol, 227 /* InterfaceDeclaration */);
            return appendOuterTypeParameters(undefined, declaration);
        }
--- END ---
INLINE (getOuterTypeParametersOfClassOrInterface) id{593,6} AS 6 AT <0:314>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{593,7} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{593,7} AS 7 AT <0:1738>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{593,8} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{593,8} AS 8 AT <7:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropertyOfType) id{594,0} ---
(type, name) {
            type = getApparentType(type);
            if (type.flags & 32768 /* Object */) {
                var resolved = resolveStructuredTypeMembers(type);
                var symbol = resolved.members[name];
                if (symbol && symbolIsValue(symbol)) {
                    return symbol;
                }
                if (resolved === anyFunctionType || resolved.callSignatures.length || resolved.constructSignatures.length) {
                    var symbol_1 = getPropertyOfObjectType(globalFunctionType, name);
                    if (symbol_1) {
                        return symbol_1;
                    }
                }
                return getPropertyOfObjectType(globalObjectType, name);
            }
            if (type.flags & 196608 /* UnionOrIntersection */) {
                return getPropertyOfUnionOrIntersectionType(type, name);
            }
            return undefined;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getApparentType) id{594,1} ---
(type) {
            var t = type.flags & 540672 /* TypeVariable */ ? getApparentTypeOfTypeVariable(type) : type;
            return t.flags & 262178 /* StringLike */ ? globalStringType :
                t.flags & 340 /* NumberLike */ ? globalNumberType :
                    t.flags & 136 /* BooleanLike */ ? globalBooleanType :
                        t.flags & 512 /* ESSymbol */ ? getGlobalESSymbolType() :
                            t;
        }
--- END ---
INLINE (getApparentType) id{594,1} AS 1 AT <0:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropertyOfObjectType) id{594,2} ---
(type, name) {
            if (type.flags & 32768 /* Object */) {
                var resolved = resolveStructuredTypeMembers(type);
                var symbol = resolved.members[name];
                if (symbol && symbolIsValue(symbol)) {
                    return symbol;
                }
            }
        }
--- END ---
INLINE (getPropertyOfObjectType) id{594,2} AS 2 AT <0:687>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkFunctionDeclaration) id{595,0} ---
(node) {
            if (produceDiagnostics) {
                checkFunctionOrMethodDeclaration(node) || checkGrammarForGenerator(node);
                checkCollisionWithCapturedSuperVariable(node, node.name);
                checkCollisionWithCapturedThisVariable(node, node.name);
                checkCollisionWithRequireExportsInGeneratedCode(node, node.name);
                checkCollisionWithGlobalPromiseInGeneratedCode(node, node.name);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkCollisionWithCapturedThisVariable) id{595,1} ---
(node, name) {
            if (needCollisionCheckForIdentifier(node, name, "_this")) {
                potentialThisCollisions.push(node);
            }
        }
--- END ---
INLINE (checkCollisionWithCapturedThisVariable) id{595,1} AS 1 AT <0:227>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveEntityName) id{596,0} ---
(name, meaning, ignoreErrors, dontResolveAlias, location) {
            if (ts.nodeIsMissing(name)) {
                return undefined;
            }
            var symbol;
            if (name.kind === 70 /* Identifier */) {
                var message = meaning === 1920 /* Namespace */ ? ts.Diagnostics.Cannot_find_namespace_0 : ts.Diagnostics.Cannot_find_name_0;
                symbol = resolveName(location || name, name.text, meaning, ignoreErrors ? undefined : message, name);
                if (!symbol) {
                    return undefined;
                }
            }
            else if (name.kind === 141 /* QualifiedName */ || name.kind === 177 /* PropertyAccessExpression */) {
                var left = name.kind === 141 /* QualifiedName */ ? name.left : name.expression;
                var right = name.kind === 141 /* QualifiedName */ ? name.right : name.name;
                var namespace = resolveEntityName(left, 1920 /* Namespace */, ignoreErrors, /*dontResolveAlias*/ false, location);
                if (!namespace || ts.nodeIsMissing(right)) {
                    return undefined;
                }
                else if (namespace === unknownSymbol) {
                    return namespace;
                }
                symbol = getSymbol(getExportsOfSymbol(namespace), right.text, meaning);
                if (!symbol) {
                    if (!ignoreErrors) {
                        error(right, ts.Diagnostics.Namespace_0_has_no_exported_member_1, getFullyQualifiedName(namespace), ts.declarationNameToString(right));
                    }
                    return undefined;
                }
            }
            else {
                ts.Debug.fail("Unknown entity name kind.");
            }
            ts.Debug.assert((symbol.flags & 16777216 /* Instantiated */) === 0, "Should never get an instantiated symbol here.");
            return (symbol.flags & meaning) || dontResolveAlias ? symbol : resolveAlias(symbol);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getExportsOfSymbol) id{596,1} ---
(symbol) {
            return symbol.flags & 1536 /* Module */ ? getExportsOfModule(symbol) : symbol.exports || emptySymbols;
        }
--- END ---
INLINE (getExportsOfSymbol) id{596,1} AS 1 AT <0:1284>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getExportsOfModule) id{596,2} ---
(moduleSymbol) {
            var links = getSymbolLinks(moduleSymbol);
            return links.resolvedExports || (links.resolvedExports = getExportsForModule(moduleSymbol));
        }
--- END ---
INLINE (getExportsOfModule) id{596,2} AS 2 AT <1:65>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{596,3} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{596,3} AS 3 AT <2:41>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{596,4} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{596,4} AS 4 AT <3:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getCombinedNodeFlags) id{597,0} ---
(node) {
        node = walkUpBindingElementsAndPatterns(node);
        var flags = node.flags;
        if (node.kind === 223 /* VariableDeclaration */) {
            node = node.parent;
        }
        if (node && node.kind === 224 /* VariableDeclarationList */) {
            flags |= node.flags;
            node = node.parent;
        }
        if (node && node.kind === 205 /* VariableStatement */) {
            flags |= node.flags;
        }
        return flags;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:walkUpBindingElementsAndPatterns) id{597,1} ---
(node) {
        while (node && (node.kind === 174 /* BindingElement */ || ts.isBindingPattern(node))) {
            node = node.parent;
        }
        return node;
    }
--- END ---
INLINE (walkUpBindingElementsAndPatterns) id{597,1} AS 1 AT <0:24>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isConstEnumObjectType) id{598,0} ---
(type) {
            return getObjectFlags(type) & 16 /* Anonymous */ && type.symbol && isConstEnumSymbol(type.symbol);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{598,1} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{598,1} AS 1 AT <0:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isConstEnumSymbol) id{598,2} ---
(symbol) {
            return (symbol.flags & 128 /* ConstEnum */) !== 0;
        }
--- END ---
INLINE (isConstEnumSymbol) id{598,2} AS 2 AT <0:88>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getBaseTypes) id{599,0} ---
(type) {
            if (!type.resolvedBaseTypes) {
                if (type.objectFlags & 8 /* Tuple */) {
                    type.resolvedBaseTypes = [createArrayType(getUnionType(type.typeParameters))];
                }
                else if (type.symbol.flags & (32 /* Class */ | 64 /* Interface */)) {
                    if (type.symbol.flags & 32 /* Class */) {
                        resolveBaseTypesOfClass(type);
                    }
                    if (type.symbol.flags & 64 /* Interface */) {
                        resolveBaseTypesOfInterface(type);
                    }
                }
                else {
                    ts.Debug.fail("type must be class or interface");
                }
            }
            return type.resolvedBaseTypes;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTargetType) id{600,0} ---
(type) {
            return getObjectFlags(type) & 4 /* Reference */ ? type.target : type;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{600,1} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{600,1} AS 1 AT <0:28>
[deoptimizing (DEOPT eager): begin 0x1030c9d3f861 <JS Function getTypeOfVariableOrParameterOrProperty (SharedFunctionInfo 0x2e2f693ec8d1)> (opt #579) @18, FP to SP delta: 80, caller sp: 0x7fff5fbfd9f0]
            ;;; deoptimize at 0_161: wrong map
  reading input frame getTypeOfVariableOrParameterOrProperty => node=43, args=2, height=6; inputs:
      0: 0x1030c9d3f861 ; [fp - 16] 0x1030c9d3f861 <JS Function getTypeOfVariableOrParameterOrProperty (SharedFunctionInfo 0x2e2f693ec8d1)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x130b7e1d83c1 ; rax 0x130b7e1d83c1 <a SymbolObject with map 0x33abe2a547f9>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x35e9f8e88919 ; [fp - 56] 0x35e9f8e88919 <an Object with map 0x33abe2a72ba1>
      5: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
      6: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
      7: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
  translating frame getTypeOfVariableOrParameterOrProperty => node=43, height=40
    0x7fff5fbfd9e8: [top + 80] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd9e0: [top + 72] <- 0x130b7e1d83c1 ;  0x130b7e1d83c1 <a SymbolObject with map 0x33abe2a547f9>  (input #2)
    0x7fff5fbfd9d8: [top + 64] <- 0x2c21d276eb1b ;  caller's pc
    0x7fff5fbfd9d0: [top + 56] <- 0x7fff5fbfda80 ;  caller's fp
    0x7fff5fbfd9c8: [top + 48] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd9c0: [top + 40] <- 0x1030c9d3f861 ;  function    0x1030c9d3f861 <JS Function getTypeOfVariableOrParameterOrProperty (SharedFunctionInfo 0x2e2f693ec8d1)>  (input #0)
    0x7fff5fbfd9b8: [top + 32] <- 0x35e9f8e88919 ;  0x35e9f8e88919 <an Object with map 0x33abe2a72ba1>  (input #4)
    0x7fff5fbfd9b0: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfd9a8: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfd9a0: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfd998: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
[deoptimizing (eager): end 0x1030c9d3f861 <JS Function getTypeOfVariableOrParameterOrProperty (SharedFunctionInfo 0x2e2f693ec8d1)> @18 => node=43, pc=0x2c21d25f54c0, caller sp=0x7fff5fbfd9f0, state=NO_REGISTERS, took 0.129 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d3f529 <JS Function checkVariableLikeDeclaration (SharedFunctionInfo 0x1b98fbc0d141)> (opt #570) @47, FP to SP delta: 144, caller sp: 0x7fff5fbfdaa0]
            ;;; deoptimize at 0_3217: Unknown map in polymorphic access
  reading input frame checkVariableLikeDeclaration => node=847, args=2, height=9; inputs:
      0: 0x1030c9d3f529 ; [fp - 16] 0x1030c9d3f529 <JS Function checkVariableLikeDeclaration (SharedFunctionInfo 0x1b98fbc0d141)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x35fa3c48cbe1 ; [fp + 16] 0x35fa3c48cbe1 <a NodeObject with map 0x33abe2a71339>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 11) 0x30bcea404311 <undefined>
      5: 0x30bcea404311 ; (literal 11) 0x30bcea404311 <undefined>
      6: 0x30bcea404311 ; (literal 11) 0x30bcea404311 <undefined>
      7: 0x30bcea404311 ; (literal 11) 0x30bcea404311 <undefined>
      8: 0x130b7e1d83c1 ; rbx 0x130b7e1d83c1 <a SymbolObject with map 0x33abe2a547f9>
      9: 0x30bcea404311 ; (literal 11) 0x30bcea404311 <undefined>
     10: 0x30bcea404311 ; (literal 11) 0x30bcea404311 <undefined>
     11: 0x1feaa866e71 ; rax 0x1feaa866e71 <a TypeObject with map 0x33abe2a6d1e9>
  translating frame checkVariableLikeDeclaration => node=847, height=64
    0x7fff5fbfda98: [top + 104] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfda90: [top + 96] <- 0x35fa3c48cbe1 ;  0x35fa3c48cbe1 <a NodeObject with map 0x33abe2a71339>  (input #2)
    0x7fff5fbfda88: [top + 88] <- 0x2c21d26fd979 ;  caller's pc
    0x7fff5fbfda80: [top + 80] <- 0x7fff5fbfdab8 ;  caller's fp
    0x7fff5fbfda78: [top + 72] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfda70: [top + 64] <- 0x1030c9d3f529 ;  function    0x1030c9d3f529 <JS Function checkVariableLikeDeclaration (SharedFunctionInfo 0x1b98fbc0d141)>  (input #0)
    0x7fff5fbfda68: [top + 56] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfda60: [top + 48] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfda58: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfda50: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfda48: [top + 24] <- 0x130b7e1d83c1 ;  0x130b7e1d83c1 <a SymbolObject with map 0x33abe2a547f9>  (input #8)
    0x7fff5fbfda40: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
    0x7fff5fbfda38: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #10)
    0x7fff5fbfda30: [top + 0] <- 0x1feaa866e71 ;  0x1feaa866e71 <a TypeObject with map 0x33abe2a6d1e9>  (input #11)
[deoptimizing (eager): end 0x1030c9d3f529 <JS Function checkVariableLikeDeclaration (SharedFunctionInfo 0x1b98fbc0d141)> @47 => node=847, pc=0x2c21d25f3f52, caller sp=0x7fff5fbfdaa0, state=TOS_REGISTER, took 0.156 ms]
[deoptimizing (DEOPT eager): begin 0x130b7e1b5e49 <JS Function getPropertyOfType (SharedFunctionInfo 0x2e2f693f0591)> (opt #594) @21, FP to SP delta: 88, caller sp: 0x7fff5fbfd3e0]
            ;;; deoptimize at 0_396: wrong map
  reading input frame getPropertyOfType => node=139, args=3, height=4; inputs:
      0: 0x130b7e1b5e49 ; [fp - 16] 0x130b7e1b5e49 <JS Function getPropertyOfType (SharedFunctionInfo 0x2e2f693f0591)>
      1: 0x1f9f6c0532e1 ; [fp + 32] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1feaa872b79 ; [fp - 48] 0x1feaa872b79 <a TypeObject with map 0x33abe2a75e81>
      3: 0x1229b1b7ff1 ; [fp + 16] 0x1229b1b7ff1 <String[5]: apply>
      4: 0x130b7e1b3d29 ; rax 0x130b7e1b3d29 <FixedArray[1022]>
      5: 0x1feaa872b79 ; rdx 0x1feaa872b79 <a TypeObject with map 0x33abe2a75e81>
      6: 0x30bcea4069a9 ; (literal 9) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
  translating frame getPropertyOfType => node=139, height=24
    0x7fff5fbfd3d8: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd3d0: [top + 64] <- 0x1feaa872b79 ;  0x1feaa872b79 <a TypeObject with map 0x33abe2a75e81>  (input #2)
    0x7fff5fbfd3c8: [top + 56] <- 0x1229b1b7ff1 ;  0x1229b1b7ff1 <String[5]: apply>  (input #3)
    0x7fff5fbfd3c0: [top + 48] <- 0x2c21d262cf63 ;  caller's pc
    0x7fff5fbfd3b8: [top + 40] <- 0x7fff5fbfd460 ;  caller's fp
    0x7fff5fbfd3b0: [top + 32] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #4)
    0x7fff5fbfd3a8: [top + 24] <- 0x130b7e1b5e49 ;  function    0x130b7e1b5e49 <JS Function getPropertyOfType (SharedFunctionInfo 0x2e2f693f0591)>  (input #0)
    0x7fff5fbfd3a0: [top + 16] <- 0x1feaa872b79 ;  0x1feaa872b79 <a TypeObject with map 0x33abe2a75e81>  (input #5)
    0x7fff5fbfd398: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfd390: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
[deoptimizing (eager): end 0x130b7e1b5e49 <JS Function getPropertyOfType (SharedFunctionInfo 0x2e2f693f0591)> @21 => node=139, pc=0x2c21d2630017, caller sp=0x7fff5fbfd3e0, state=NO_REGISTERS, took 0.180 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:propertiesRelatedTo) id{601,0} ---
(source, target, reportErrors) {
                if (relation === identityRelation) {
                    return propertiesIdenticalTo(source, target);
                }
                var result = -1 /* True */;
                var properties = getPropertiesOfObjectType(target);
                var requireOptionalProperties = relation === subtypeRelation && !(getObjectFlags(source) & 128 /* ObjectLiteral */);
                for (var _i = 0, properties_3 = properties; _i < properties_3.length; _i++) {
                    var targetProp = properties_3[_i];
                    var sourceProp = getPropertyOfType(source, targetProp.name);
                    if (sourceProp !== targetProp) {
                        if (!sourceProp) {
                            if (!(targetProp.flags & 536870912 /* Optional */) || requireOptionalProperties) {
                                if (reportErrors) {
                                    reportError(ts.Diagnostics.Property_0_is_missing_in_type_1, symbolToString(targetProp), typeToString(source));
                                }
                                return 0 /* False */;
                            }
                        }
                        else if (!(targetProp.flags & 134217728 /* Prototype */)) {
                            var sourcePropFlags = getDeclarationModifierFlagsFromSymbol(sourceProp);
                            var targetPropFlags = getDeclarationModifierFlagsFromSymbol(targetProp);
                            if (sourcePropFlags & 8 /* Private */ || targetPropFlags & 8 /* Private */) {
                                if (sourceProp.valueDeclaration !== targetProp.valueDeclaration) {
                                    if (reportErrors) {
                                        if (sourcePropFlags & 8 /* Private */ && targetPropFlags & 8 /* Private */) {
                                            reportError(ts.Diagnostics.Types_have_separate_declarations_of_a_private_property_0, symbolToString(targetProp));
                                        }
                                        else {
                                            reportError(ts.Diagnostics.Property_0_is_private_in_type_1_but_not_in_type_2, symbolToString(targetProp), typeToString(sourcePropFlags & 8 /* Private */ ? source : target), typeToString(sourcePropFlags & 8 /* Private */ ? target : source));
                                        }
                                    }
                                    return 0 /* False */;
                                }
                            }
                            else if (targetPropFlags & 16 /* Protected */) {
                                var sourceDeclaredInClass = sourceProp.parent && sourceProp.parent.flags & 32 /* Class */;
                                var sourceClass = sourceDeclaredInClass ? getDeclaredTypeOfSymbol(getParentOfSymbol(sourceProp)) : undefined;
                                var targetClass = getDeclaredTypeOfSymbol(getParentOfSymbol(targetProp));
                                if (!sourceClass || !hasBaseType(sourceClass, targetClass)) {
                                    if (reportErrors) {
                                        reportError(ts.Diagnostics.Property_0_is_protected_but_type_1_is_not_a_class_derived_from_2, symbolToString(targetProp), typeToString(sourceClass || source), typeToString(targetClass));
                                    }
                                    return 0 /* False */;
                                }
                            }
                            else if (sourcePropFlags & 16 /* Protected */) {
                                if (reportErrors) {
                                    reportError(ts.Diagnostics.Property_0_is_protected_in_type_1_but_public_in_type_2, symbolToString(targetProp), typeToString(source), typeToString(target));
                                }
                                return 0 /* False */;
                            }
                            var related = isRelatedTo(getTypeOfSymbol(sourceProp), getTypeOfSymbol(targetProp), reportErrors);
                            if (!related) {
                                if (reportErrors) {
                                    reportError(ts.Diagnostics.Types_of_property_0_are_incompatible, symbolToString(targetProp));
                                }
                                return 0 /* False */;
                            }
                            result &= related;
                            // When checking for comparability, be more lenient with optional properties.
                            if (relation !== comparableRelation && sourceProp.flags & 536870912 /* Optional */ && !(targetProp.flags & 536870912 /* Optional */)) {
                                // TypeScript 1.0 spec (April 2014): 3.8.3
                                // S is a subtype of a type T, and T is a supertype of S if ...
                                // S' and T are object types and, for each member M in T..
                                // M is a property and S' contains a property N where
                                // if M is a required property, N is also a required property
                                // (M - property in T)
                                // (N - property in S)
                                if (reportErrors) {
                                    reportError(ts.Diagnostics.Property_0_is_optional_in_type_1_but_required_in_type_2, symbolToString(targetProp), typeToString(source), typeToString(target));
                                }
                                return 0 /* False */;
                            }
                        }
                    }
                }
                return result;
            }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropertiesOfObjectType) id{601,1} ---
(type) {
            if (type.flags & 32768 /* Object */) {
                return resolveStructuredTypeMembers(type).properties;
            }
            return emptyArray;
        }
--- END ---
INLINE (getPropertiesOfObjectType) id{601,1} AS 1 AT <0:247>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getDeclarationModifierFlagsFromSymbol) id{601,2} ---
(s) {
            return s.valueDeclaration ? ts.getCombinedModifierFlags(s.valueDeclaration) : s.flags & 134217728 /* Prototype */ ? 4 /* Public */ | 32 /* Static */ : 0;
        }
--- END ---
INLINE (getDeclarationModifierFlagsFromSymbol) id{601,2} AS 2 AT <0:1329>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getDeclarationModifierFlagsFromSymbol) id{601,3} ---
(s) {
            return s.valueDeclaration ? ts.getCombinedModifierFlags(s.valueDeclaration) : s.flags & 134217728 /* Prototype */ ? 4 /* Public */ | 32 /* Static */ : 0;
        }
--- END ---
INLINE (getDeclarationModifierFlagsFromSymbol) id{601,3} AS 3 AT <0:1430>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropertyOfObjectType) id{602,0} ---
(type, name) {
            if (type.flags & 32768 /* Object */) {
                var resolved = resolveStructuredTypeMembers(type);
                var symbol = resolved.members[name];
                if (symbol && symbolIsValue(symbol)) {
                    return symbol;
                }
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeOfSymbol) id{603,0} ---
(symbol) {
            if (symbol.flags & 16777216 /* Instantiated */) {
                return getTypeOfInstantiatedSymbol(symbol);
            }
            if (symbol.flags & (3 /* Variable */ | 4 /* Property */)) {
                return getTypeOfVariableOrParameterOrProperty(symbol);
            }
            if (symbol.flags & (16 /* Function */ | 8192 /* Method */ | 32 /* Class */ | 384 /* Enum */ | 512 /* ValueModule */)) {
                return getTypeOfFuncClassEnumModule(symbol);
            }
            if (symbol.flags & 8 /* EnumMember */) {
                return getTypeOfEnumMember(symbol);
            }
            if (symbol.flags & 98304 /* Accessor */) {
                return getTypeOfAccessors(symbol);
            }
            if (symbol.flags & 8388608 /* Alias */) {
                return getTypeOfAlias(symbol);
            }
            return unknownType;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeOfInstantiatedSymbol) id{603,1} ---
(symbol) {
            var links = getSymbolLinks(symbol);
            if (!links.type) {
                if (!pushTypeResolution(symbol, 0 /* Type */)) {
                    return unknownType;
                }
                var type = instantiateType(getTypeOfSymbol(links.target), links.mapper);
                if (!popTypeResolution()) {
                    type = reportCircularityError(symbol);
                }
                links.type = type;
            }
            return links.type;
        }
--- END ---
INLINE (getTypeOfInstantiatedSymbol) id{603,1} AS 1 AT <0:96>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{603,2} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{603,2} AS 2 AT <1:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{603,3} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{603,3} AS 3 AT <2:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:popTypeResolution) id{603,4} ---
() {
            resolutionTargets.pop();
            resolutionPropertyNames.pop();
            return resolutionResults.pop();
        }
--- END ---
INLINE (popTypeResolution) id{603,4} AS 4 AT <1:323>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeOfFuncClassEnumModule) id{603,5} ---
(symbol) {
            var links = getSymbolLinks(symbol);
            if (!links.type) {
                if (symbol.flags & 1536 /* Module */ && ts.isShorthandAmbientModuleSymbol(symbol)) {
                    links.type = anyType;
                }
                else {
                    var type = createObjectType(16 /* Anonymous */, symbol);
                    links.type = strictNullChecks && symbol.flags & 536870912 /* Optional */ ?
                        includeFalsyTypes(type, 2048 /* Undefined */) : type;
                }
            }
            return links.type;
        }
--- END ---
INLINE (getTypeOfFuncClassEnumModule) id{603,5} AS 5 AT <0:459>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{603,6} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{603,6} AS 6 AT <5:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{603,7} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{603,7} AS 7 AT <6:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createObjectType) id{603,8} ---
(objectFlags, symbol) {
            var type = createType(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol = symbol;
            return type;
        }
--- END ---
INLINE (createObjectType) id{603,8} AS 8 AT <5:305>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{603,9} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{603,9} AS 9 AT <8:47>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{603,10} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{603,10} AS 10 AT <9:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isRelatedTo) id{604,0} ---
(source, target, reportErrors, headMessage) {
                var result;
                if (source.flags & 96 /* StringOrNumberLiteral */ && source.flags & 1048576 /* FreshLiteral */) {
                    source = source.regularType;
                }
                if (target.flags & 96 /* StringOrNumberLiteral */ && target.flags & 1048576 /* FreshLiteral */) {
                    target = target.regularType;
                }
                // both types are the same - covers 'they are the same primitive type or both are Any' or the same type parameter cases
                if (source === target)
                    return -1 /* True */;
                if (relation === identityRelation) {
                    return isIdenticalTo(source, target);
                }
                if (isSimpleTypeRelatedTo(source, target, relation, reportErrors ? reportError : undefined))
                    return -1 /* True */;
                if (getObjectFlags(source) & 128 /* ObjectLiteral */ && source.flags & 1048576 /* FreshLiteral */) {
                    if (hasExcessProperties(source, target, reportErrors)) {
                        if (reportErrors) {
                            reportRelationError(headMessage, source, target);
                        }
                        return 0 /* False */;
                    }
                    // Above we check for excess properties with respect to the entire target type. When union
                    // and intersection types are further deconstructed on the target side, we don't want to
                    // make the check again (as it might fail for a partial target type). Therefore we obtain
                    // the regular source type and proceed with that.
                    if (isUnionOrIntersectionTypeWithoutNullableConstituents(target)) {
                        source = getRegularTypeOfObjectLiteral(source);
                    }
                }
                var saveErrorInfo = errorInfo;
                // Note that these checks are specifically ordered to produce correct results. In particular,
                // we need to deconstruct unions before intersections (because unions are always at the top),
                // and we need to handle "each" relations before "some" relations for the same kind of type.
                if (source.flags & 65536 /* Union */) {
                    if (relation === comparableRelation) {
                        result = someTypeRelatedToType(source, target, reportErrors && !(source.flags & 8190 /* Primitive */));
                    }
                    else {
                        result = eachTypeRelatedToType(source, target, reportErrors && !(source.flags & 8190 /* Primitive */));
                    }
                    if (result) {
                        return result;
                    }
                }
                else if (target.flags & 65536 /* Union */) {
                    if (result = typeRelatedToSomeType(source, target, reportErrors && !(source.flags & 8190 /* Primitive */) && !(target.flags & 8190 /* Primitive */))) {
                        return result;
                    }
                }
                else if (target.flags & 131072 /* Intersection */) {
                    if (result = typeRelatedToEachType(source, target, reportErrors)) {
                        return result;
                    }
                }
                else if (source.flags & 131072 /* Intersection */) {
                    // Check to see if any constituents of the intersection are immediately related to the target.
                    //
                    // Don't report errors though. Checking whether a constituent is related to the source is not actually
                    // useful and leads to some confusing error messages. Instead it is better to let the below checks
                    // take care of this, or to not elaborate at all. For instance,
                    //
                    //    - For an object type (such as 'C = A & B'), users are usually more interested in structural errors.
                    //
                    //    - For a union type (such as '(A | B) = (C & D)'), it's better to hold onto the whole intersection
                    //          than to report that 'D' is not assignable to 'A' or 'B'.
                    //
                    //    - For a primitive type or type parameter (such as 'number = A & B') there is no point in
                    //          breaking the intersection apart.
                    if (result = someTypeRelatedToType(source, target, /*reportErrors*/ false)) {
                        return result;
                    }
                }
                else if (target.flags & 16384 /* TypeParameter */) {
                    // A source type { [P in keyof T]: X } is related to a target type T if X is related to T[P].
                    if (getObjectFlags(source) & 32 /* Mapped */ && getConstraintTypeFromMappedType(source) === getIndexType(target)) {
                        if (!source.declaration.questionToken) {
                            var templateType = getTemplateTypeFromMappedType(source);
                            var indexedAccessType = getIndexedAccessType(target, getTypeParameterFromMappedType(source));
                            if (result = isRelatedTo(templateType, indexedAccessType, reportErrors)) {
                                return result;
                            }
                        }
                    }
                    else {
                        // Given a type parameter K with a constraint keyof T, a type S is
                        // assignable to K if S is assignable to keyof T.
                        var constraint = getConstraintOfTypeParameter(target);
                        if (constraint && constraint.flags & 262144 /* Index */) {
                            if (result = isRelatedTo(source, constraint, reportErrors)) {
                                return result;
                            }
                        }
                    }
                }
                else if (target.flags & 262144 /* Index */) {
                    // A keyof S is related to a keyof T if T is related to S.
                    if (source.flags & 262144 /* Index */) {
                        if (result = isRelatedTo(target.type, source.type, /*reportErrors*/ false)) {
                            return result;
                        }
                    }
                    // Given a type variable T with a constraint C, a type S is assignable to
                    // keyof T if S is assignable to keyof C.
                    if (target.type.flags & 540672 /* TypeVariable */) {
                        var constraint = getConstraintOfTypeVariable(target.type);
                        if (constraint) {
                            if (result = isRelatedTo(source, getIndexType(constraint), reportErrors)) {
                                return result;
                            }
                        }
                    }
                }
                else if (target.flags & 524288 /* IndexedAccess */) {
                    // if we have indexed access types with identical index types, see if relationship holds for
                    // the two object types.
                    if (source.flags & 524288 /* IndexedAccess */ && source.indexType === target.indexType) {
                        if (result = isRelatedTo(source.objectType, target.objectType, reportErrors)) {
                            return result;
                        }
                    }
                    // A type S is related to a type T[K] if S is related to A[K], where K is string-like and
                    // A is the apparent type of S.
                    if (target.constraint) {
                        if (result = isRelatedTo(source, target.constraint, reportErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                }
                if (source.flags & 16384 /* TypeParameter */) {
                    // A source type T is related to a target type { [P in keyof T]: X } if T[P] is related to X.
                    if (getObjectFlags(target) & 32 /* Mapped */ && getConstraintTypeFromMappedType(target) === getIndexType(source)) {
                        var indexedAccessType = getIndexedAccessType(source, getTypeParameterFromMappedType(target));
                        var templateType = getTemplateTypeFromMappedType(target);
                        if (result = isRelatedTo(indexedAccessType, templateType, reportErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                    else {
                        var constraint = getConstraintOfTypeParameter(source);
                        if (!constraint || constraint.flags & 1 /* Any */) {
                            constraint = emptyObjectType;
                        }
                        // The constraint may need to be further instantiated with its 'this' type.
                        constraint = getTypeWithThisArgument(constraint, source);
                        // Report constraint errors only if the constraint is not the empty object type
                        var reportConstraintErrors = reportErrors && constraint !== emptyObjectType;
                        if (result = isRelatedTo(constraint, target, reportConstraintErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                }
                else if (source.flags & 524288 /* IndexedAccess */) {
                    // A type S[K] is related to a type T if A[K] is related to T, where K is string-like and
                    // A is the apparent type of S.
                    if (source.constraint) {
                        if (result = isRelatedTo(source.constraint, target, reportErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                }
                else {
                    if (getObjectFlags(source) & 4 /* Reference */ && getObjectFlags(target) & 4 /* Reference */ && source.target === target.target) {
                        // We have type references to same target type, see if relationship holds for all type arguments
                        if (result = typeArgumentsRelatedTo(source, target, reportErrors)) {
                            return result;
                        }
                    }
                    // Even if relationship doesn't hold for unions, intersections, or generic type references,
                    // it may hold in a structural comparison.
                    var apparentSource = getApparentType(source);
                    // In a check of the form X = A & B, we will have previously checked if A relates to X or B relates
                    // to X. Failing both of those we want to check if the aggregation of A and B's members structurally
                    // relates to X. Thus, we include intersection types on the source side here.
                    if (apparentSource.flags & (32768 /* Object */ | 131072 /* Intersection */) && target.flags & 32768 /* Object */) {
                        // Report structural errors only if we haven't reported any errors yet
                        var reportStructuralErrors = reportErrors && errorInfo === saveErrorInfo && !(source.flags & 8190 /* Primitive */);
                        if (result = objectTypeRelatedTo(apparentSource, source, target, reportStructuralErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                }
                if (reportErrors) {
                    if (source.flags & 32768 /* Object */ && target.flags & 8190 /* Primitive */) {
                        tryElaborateErrorsForPrimitivesAndObjects(source, target);
                    }
                    else if (source.symbol && source.flags & 32768 /* Object */ && globalObjectType === source) {
                        reportError(ts.Diagnostics.The_Object_type_is_assignable_to_very_few_other_types_Did_you_mean_to_use_the_any_type_instead);
                    }
                    reportRelationError(headMessage, source, target);
                }
                return 0 /* False */;
            }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{604,1} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{604,1} AS 1 AT <0:953>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{604,2} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{604,2} AS 2 AT <0:4927>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getConstraintOfTypeVariable) id{604,3} ---
(type) {
            return type.flags & 16384 /* TypeParameter */ ? getConstraintOfTypeParameter(type) :
                type.flags & 524288 /* IndexedAccess */ ? type.constraint :
                    undefined;
        }
--- END ---
INLINE (getConstraintOfTypeVariable) id{604,3} AS 3 AT <0:6792>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{604,4} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{604,4} AS 4 AT <0:8322>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeWithThisArgument) id{604,5} ---
(type, thisArgument) {
            if (getObjectFlags(type) & 4 /* Reference */) {
                return createTypeReference(type.target, ts.concatenate(type.typeArguments, [thisArgument || type.target.thisType]));
            }
            return type;
        }
--- END ---
INLINE (getTypeWithThisArgument) id{604,5} AS 5 AT <0:9283>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{604,6} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{604,6} AS 6 AT <5:39>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createTypeReference) id{604,7} ---
(target, typeArguments) {
            var id = getTypeListId(typeArguments);
            var type = target.instantiations[id];
            if (!type) {
                type = target.instantiations[id] = createObjectType(4 /* Reference */, target.symbol);
                type.flags |= typeArguments ? getPropagatingFlagsOfTypes(typeArguments, /*excludeKinds*/ 0) : 0;
                type.target = target;
                type.typeArguments = typeArguments;
            }
            return type;
        }
--- END ---
INLINE (createTypeReference) id{604,7} AS 7 AT <5:106>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createObjectType) id{604,8} ---
(objectFlags, symbol) {
            var type = createType(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol = symbol;
            return type;
        }
--- END ---
INLINE (createObjectType) id{604,8} AS 8 AT <7:203>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{604,9} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{604,9} AS 9 AT <8:47>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{604,10} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{604,10} AS 10 AT <9:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropagatingFlagsOfTypes) id{604,11} ---
(types, excludeKinds) {
            var result = 0;
            for (var _i = 0, types_3 = types; _i < types_3.length; _i++) {
                var type = types_3[_i];
                if (!(type.flags & excludeKinds)) {
                    result |= type.flags;
                }
            }
            return result & 14680064 /* PropagatingFlags */;
        }
--- END ---
INLINE (getPropagatingFlagsOfTypes) id{604,11} AS 11 AT <7:301>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{604,12} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{604,12} AS 12 AT <0:10374>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{604,13} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{604,13} AS 13 AT <0:10420>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getApparentType) id{604,14} ---
(type) {
            var t = type.flags & 540672 /* TypeVariable */ ? getApparentTypeOfTypeVariable(type) : type;
            return t.flags & 262178 /* StringLike */ ? globalStringType :
                t.flags & 340 /* NumberLike */ ? globalNumberType :
                    t.flags & 136 /* BooleanLike */ ? globalBooleanType :
                        t.flags & 512 /* ESSymbol */ ? getGlobalESSymbolType() :
                            t;
        }
--- END ---
INLINE (getApparentType) id{604,14} AS 14 AT <0:11022>
[deoptimizing (DEOPT eager): begin 0x1030c9d445d9 <JS Function getTypeFromUnionTypeNode (SharedFunctionInfo 0x2e2f693f3e91)> (opt #513) @19, FP to SP delta: 168, caller sp: 0x7fff5fbfd590]
            ;;; deoptimize at 0_153: wrong map
  reading input frame getTypeFromUnionTypeNode => node=79, args=2, height=7; inputs:
      0: 0x1030c9d445d9 ; [fp - 16] 0x1030c9d445d9 <JS Function getTypeFromUnionTypeNode (SharedFunctionInfo 0x2e2f693f3e91)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x35fa3c4b9be1 ; rbx 0x35fa3c4b9be1 <a NodeObject with map 0x33abe2a54959>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x1feaa8a2e59 ; [fp - 56] 0x1feaa8a2e59 <an Object with map 0x33abe2a51889>
      5: 0x1feaa8a2e59 ; [fp - 56] 0x1feaa8a2e59 <an Object with map 0x33abe2a51889>
      6: 0x17ddd84043f9 ; [fp - 64] 0x17ddd84043f9 <JS Function getUnionType (SharedFunctionInfo 0x2e2f693f3d11)>
      7: 0x30bcea404311 ; (literal 13) 0x30bcea404311 <undefined>
      8: 0x16f3adb61821 ; [fp - 72] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      9: 0xd6230dc98d1 ; rax 0xd6230dc98d1 <JS Function map (SharedFunctionInfo 0xc2bd2ae1669)>
  translating frame getTypeFromUnionTypeNode => node=79, height=48
    0x7fff5fbfd588: [top + 88] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd580: [top + 80] <- 0x35fa3c4b9be1 ;  0x35fa3c4b9be1 <a NodeObject with map 0x33abe2a54959>  (input #2)
    0x7fff5fbfd578: [top + 72] <- 0x2c21d276fe4c ;  caller's pc
    0x7fff5fbfd570: [top + 64] <- 0x7fff5fbfd698 ;  caller's fp
    0x7fff5fbfd568: [top + 56] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd560: [top + 48] <- 0x1030c9d445d9 ;  function    0x1030c9d445d9 <JS Function getTypeFromUnionTypeNode (SharedFunctionInfo 0x2e2f693f3e91)>  (input #0)
    0x7fff5fbfd558: [top + 40] <- 0x1feaa8a2e59 ;  0x1feaa8a2e59 <an Object with map 0x33abe2a51889>  (input #4)
    0x7fff5fbfd550: [top + 32] <- 0x1feaa8a2e59 ;  0x1feaa8a2e59 <an Object with map 0x33abe2a51889>  (input #5)
    0x7fff5fbfd548: [top + 24] <- 0x17ddd84043f9 ;  0x17ddd84043f9 <JS Function getUnionType (SharedFunctionInfo 0x2e2f693f3d11)>  (input #6)
    0x7fff5fbfd540: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfd538: [top + 8] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #8)
    0x7fff5fbfd530: [top + 0] <- 0xd6230dc98d1 ;  0xd6230dc98d1 <JS Function map (SharedFunctionInfo 0xc2bd2ae1669)>  (input #9)
[deoptimizing (eager): end 0x1030c9d445d9 <JS Function getTypeFromUnionTypeNode (SharedFunctionInfo 0x2e2f693f3e91)> @19 => node=79, pc=0x2c21d261f353, caller sp=0x7fff5fbfd590, state=TOS_REGISTER, took 0.212 ms]
[deoptimizing (DEOPT eager): begin 0x17ddd8404489 <JS Function addTypeToUnion (SharedFunctionInfo 0x2e2f693f37d1)> (opt #509) @36, FP to SP delta: 144, caller sp: 0x7fff5fbfd498]
            ;;; deoptimize at 0_1357: wrong map
  reading input frame addTypeToUnion => node=458, args=3, height=4; inputs:
      0: 0x17ddd8404489 ; [fp - 16] 0x17ddd8404489 <JS Function addTypeToUnion (SharedFunctionInfo 0x2e2f693f37d1)>
      1: 0x1f9f6c0532e1 ; [fp + 32] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1feaa8a2f61 ; [fp + 24] 0x1feaa8a2f61 <JS Array[1]>
      3: 0x1feaa8a2931 ; rax 0x1feaa8a2931 <a TypeObject with map 0x33abe2a75a61>
      4: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      5: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      6: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: -2 ; (int) [fp - 120] 
  translating frame addTypeToUnion => node=458, height=24
    0x7fff5fbfd490: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd488: [top + 64] <- 0x1feaa8a2f61 ;  0x1feaa8a2f61 <JS Array[1]>  (input #2)
    0x7fff5fbfd480: [top + 56] <- 0x1feaa8a2931 ;  0x1feaa8a2931 <a TypeObject with map 0x33abe2a75a61>  (input #3)
    0x7fff5fbfd478: [top + 48] <- 0x2c21d253bc77 ;  caller's pc
    0x7fff5fbfd470: [top + 40] <- 0x7fff5fbfd4c8 ;  caller's fp
    0x7fff5fbfd468: [top + 32] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #4)
    0x7fff5fbfd460: [top + 24] <- 0x17ddd8404489 ;  function    0x17ddd8404489 <JS Function addTypeToUnion (SharedFunctionInfo 0x2e2f693f37d1)>  (input #0)
    0x7fff5fbfd458: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #5)
    0x7fff5fbfd450: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfd448: [top + 0] <- 0xfffffffe00000000 ;  -2  (input #7)
[deoptimizing (eager): end 0x17ddd8404489 <JS Function addTypeToUnion (SharedFunctionInfo 0x2e2f693f37d1)> @36 => node=458, pc=0x2c21d253c2ee, caller sp=0x7fff5fbfd498, state=NO_REGISTERS, took 0.162 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkFunctionOrMethodDeclaration) id{605,0} ---
(node) {
            checkDecorators(node);
            checkSignatureDeclaration(node);
            var isAsync = ts.isAsyncFunctionLike(node);
            // Do not use hasDynamicName here, because that returns false for well known symbols.
            // We want to perform checkComputedPropertyName for all computed properties, including
            // well known symbols.
            if (node.name && node.name.kind === 142 /* ComputedPropertyName */) {
                // This check will account for methods in class/interface declarations,
                // as well as accessors in classes/object literals
                checkComputedPropertyName(node.name);
            }
            if (!ts.hasDynamicName(node)) {
                // first we want to check the local symbol that contain this declaration
                // - if node.localSymbol !== undefined - this is current declaration is exported and localSymbol points to the local symbol
                // - if node.localSymbol === undefined - this node is non-exported so we can just pick the result of getSymbolOfNode
                var symbol = getSymbolOfNode(node);
                var localSymbol = node.localSymbol || symbol;
                // Since the javascript won't do semantic analysis like typescript,
                // if the javascript file comes before the typescript file and both contain same name functions,
                // checkFunctionOrConstructorSymbol wouldn't be called if we didnt ignore javascript function.
                var firstDeclaration = ts.forEach(localSymbol.declarations, 
                // Get first non javascript function declaration
                function (declaration) { return declaration.kind === node.kind && !ts.isSourceFileJavaScript(ts.getSourceFileOfNode(declaration)) ?
                    declaration : undefined; });
                // Only type check the symbol once
                if (node === firstDeclaration) {
                    checkFunctionOrConstructorSymbol(localSymbol);
                }
                if (symbol.parent) {
                    // run check once for the first declaration
                    if (ts.getDeclarationOfKind(symbol, node.kind) === node) {
                        // run check on export symbol to check that modifiers agree across all exported declarations
                        checkFunctionOrConstructorSymbol(symbol);
                    }
                }
            }
            checkSourceElement(node.body);
            if (!node.asteriskToken) {
                var returnOrPromisedType = node.type && (isAsync ? checkAsyncFunctionReturnType(node) : getTypeFromTypeNode(node.type));
                checkAllCodePathsInNonVoidFunctionReturnOrThrow(node, returnOrPromisedType);
            }
            if (produceDiagnostics && !node.type) {
                // Report an implicit any error if there is no body, no explicit return type, and node is not a private method
                // in an ambient context
                if (compilerOptions.noImplicitAny && ts.nodeIsMissing(node.body) && !isPrivateWithinAmbient(node)) {
                    reportImplicitAnyError(node, anyType);
                }
                if (node.asteriskToken && ts.nodeIsPresent(node.body)) {
                    // A generator with a body and no type annotation can still cause errors. It can error if the
                    // yielded values have no common supertype, or it can give an implicit any error if it has no
                    // yielded values. The only way to trigger these errors is to try checking its return type.
                    getReturnTypeOfSignature(getSignatureFromDeclaration(node));
                }
            }
            registerForUnusedIdentifiersCheck(node);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{605,1} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{605,1} AS 1 AT <0:1117>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{605,2} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{605,2} AS 2 AT <1:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:registerForUnusedIdentifiersCheck) id{605,3} ---
(node) {
            if (deferredUnusedIdentifierNodes) {
                deferredUnusedIdentifierNodes.push(node);
            }
        }
--- END ---
INLINE (registerForUnusedIdentifiersCheck) id{605,3} AS 3 AT <0:3729>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNumParametersToCheckForSignatureRelatability) id{606,0} ---
(source, sourceNonRestParamCount, target, targetNonRestParamCount) {
            if (source.hasRestParameter === target.hasRestParameter) {
                if (source.hasRestParameter) {
                    // If both have rest parameters, get the max and add 1 to
                    // compensate for the rest parameter.
                    return Math.max(sourceNonRestParamCount, targetNonRestParamCount) + 1;
                }
                else {
                    return Math.min(sourceNonRestParamCount, targetNonRestParamCount);
                }
            }
            else {
                // Return the count for whichever signature doesn't have rest parameters.
                return source.hasRestParameter ?
                    targetNonRestParamCount :
                    sourceNonRestParamCount;
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeOfVariableOrParameterOrProperty) id{607,0} ---
(symbol) {
            var links = getSymbolLinks(symbol);
            if (!links.type) {
                // Handle prototype property
                if (symbol.flags & 134217728 /* Prototype */) {
                    return links.type = getTypeOfPrototypeProperty(symbol);
                }
                // Handle catch clause variables
                var declaration = symbol.valueDeclaration;
                if (ts.isCatchClauseVariableDeclarationOrBindingElement(declaration)) {
                    return links.type = anyType;
                }
                // Handle export default expressions
                if (declaration.kind === 240 /* ExportAssignment */) {
                    return links.type = checkExpression(declaration.expression);
                }
                if (declaration.flags & 65536 /* JavaScriptFile */ && declaration.kind === 286 /* JSDocPropertyTag */ && declaration.typeExpression) {
                    return links.type = getTypeFromTypeNode(declaration.typeExpression.type);
                }
                // Handle variable, parameter or property
                if (!pushTypeResolution(symbol, 0 /* Type */)) {
                    return unknownType;
                }
                var type = void 0;
                // Handle certain special assignment kinds, which happen to union across multiple declarations:
                // * module.exports = expr
                // * exports.p = expr
                // * this.p = expr
                // * className.prototype.method = expr
                if (declaration.kind === 192 /* BinaryExpression */ ||
                    declaration.kind === 177 /* PropertyAccessExpression */ && declaration.parent.kind === 192 /* BinaryExpression */) {
                    // Use JS Doc type if present on parent expression statement
                    if (declaration.flags & 65536 /* JavaScriptFile */) {
                        var jsdocType = ts.getJSDocType(declaration.parent);
                        if (jsdocType) {
                            return links.type = getTypeFromTypeNode(jsdocType);
                        }
                    }
                    var declaredTypes = ts.map(symbol.declarations, function (decl) { return decl.kind === 192 /* BinaryExpression */ ?
                        checkExpressionCached(decl.right) :
                        checkExpressionCached(decl.parent.right); });
                    type = getUnionType(declaredTypes, /*subtypeReduction*/ true);
                }
                else {
                    type = getWidenedTypeForVariableLikeDeclaration(declaration, /*reportErrors*/ true);
                }
                if (!popTypeResolution()) {
                    type = reportCircularityError(symbol);
                }
                links.type = type;
            }
            return links.type;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{607,1} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{607,1} AS 1 AT <0:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{607,2} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{607,2} AS 2 AT <1:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:popTypeResolution) id{607,3} ---
() {
            resolutionTargets.pop();
            resolutionPropertyNames.pop();
            return resolutionResults.pop();
        }
--- END ---
INLINE (popTypeResolution) id{607,3} AS 3 AT <0:2684>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeFromClassOrInterfaceReference) id{608,0} ---
(node, symbol) {
            var type = getDeclaredTypeOfSymbol(getMergedSymbol(symbol));
            var typeParameters = type.localTypeParameters;
            if (typeParameters) {
                if (!node.typeArguments || node.typeArguments.length !== typeParameters.length) {
                    error(node, ts.Diagnostics.Generic_type_0_requires_1_type_argument_s, typeToString(type, /*enclosingDeclaration*/ undefined, 1 /* WriteArrayAsGenericType */), typeParameters.length);
                    return unknownType;
                }
                // In a type reference, the outer type parameters of the referenced class or interface are automatically
                // supplied as type arguments and the type reference only specifies arguments for the local type parameters
                // of the class or interface.
                return createTypeReference(type, ts.concatenate(type.outerTypeParameters, ts.map(node.typeArguments, getTypeFromTypeNode)));
            }
            if (node.typeArguments) {
                error(node, ts.Diagnostics.Type_0_is_not_generic, typeToString(type));
                return unknownType;
            }
            return type;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{608,1} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{608,1} AS 1 AT <0:64>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createTypeReference) id{608,2} ---
(target, typeArguments) {
            var id = getTypeListId(typeArguments);
            var type = target.instantiations[id];
            if (!type) {
                type = target.instantiations[id] = createObjectType(4 /* Reference */, target.symbol);
                type.flags |= typeArguments ? getPropagatingFlagsOfTypes(typeArguments, /*excludeKinds*/ 0) : 0;
                type.target = target;
                type.typeArguments = typeArguments;
            }
            return type;
        }
--- END ---
INLINE (createTypeReference) id{608,2} AS 2 AT <0:856>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createObjectType) id{608,3} ---
(objectFlags, symbol) {
            var type = createType(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol = symbol;
            return type;
        }
--- END ---
INLINE (createObjectType) id{608,3} AS 3 AT <2:203>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{608,4} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{608,4} AS 4 AT <3:47>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{608,5} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{608,5} AS 5 AT <4:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropagatingFlagsOfTypes) id{608,6} ---
(types, excludeKinds) {
            var result = 0;
            for (var _i = 0, types_3 = types; _i < types_3.length; _i++) {
                var type = types_3[_i];
                if (!(type.flags & excludeKinds)) {
                    result |= type.flags;
                }
            }
            return result & 14680064 /* PropagatingFlags */;
        }
--- END ---
INLINE (getPropagatingFlagsOfTypes) id{608,6} AS 6 AT <2:301>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getInterfaceBaseTypeNodes) id{609,0} ---
(node) {
        var heritageClause = getHeritageClause(node.heritageClauses, 84 /* ExtendsKeyword */);
        return heritageClause ? heritageClause.types : undefined;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getHeritageClause) id{609,1} ---
(clauses, kind) {
        if (clauses) {
            for (var _i = 0, clauses_1 = clauses; _i < clauses_1.length; _i++) {
                var clause = clauses_1[_i];
                if (clause.token === kind) {
                    return clause;
                }
            }
        }
        return undefined;
    }
--- END ---
INLINE (getHeritageClause) id{609,1} AS 1 AT <0:38>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkVariableLikeDeclaration) id{610,0} ---
(node) {
            checkDecorators(node);
            checkSourceElement(node.type);
            // For a computed property, just check the initializer and exit
            // Do not use hasDynamicName here, because that returns false for well known symbols.
            // We want to perform checkComputedPropertyName for all computed properties, including
            // well known symbols.
            if (node.name.kind === 142 /* ComputedPropertyName */) {
                checkComputedPropertyName(node.name);
                if (node.initializer) {
                    checkExpressionCached(node.initializer);
                }
            }
            if (node.kind === 174 /* BindingElement */) {
                if (node.parent.kind === 172 /* ObjectBindingPattern */ && languageVersion < 5 /* ESNext */ && !ts.isInAmbientContext(node)) {
                    checkExternalEmitHelpers(node, 4 /* Rest */);
                }
                // check computed properties inside property names of binding elements
                if (node.propertyName && node.propertyName.kind === 142 /* ComputedPropertyName */) {
                    checkComputedPropertyName(node.propertyName);
                }
                // check private/protected variable access
                var parent_11 = node.parent.parent;
                var parentType = getTypeForBindingElementParent(parent_11);
                var name_24 = node.propertyName || node.name;
                var property = getPropertyOfType(parentType, ts.getTextOfPropertyName(name_24));
                markPropertyAsReferenced(property);
                if (parent_11.initializer && property && getParentOfSymbol(property)) {
                    checkClassPropertyAccess(parent_11, parent_11.initializer, parentType, property);
                }
            }
            // For a binding pattern, check contained binding elements
            if (ts.isBindingPattern(node.name)) {
                ts.forEach(node.name.elements, checkSourceElement);
            }
            // For a parameter declaration with an initializer, error and exit if the containing function doesn't have a body
            if (node.initializer && ts.getRootDeclaration(node).kind === 144 /* Parameter */ && ts.nodeIsMissing(ts.getContainingFunction(node).body)) {
                error(node, ts.Diagnostics.A_parameter_initializer_is_only_allowed_in_a_function_or_constructor_implementation);
                return;
            }
            // For a binding pattern, validate the initializer and exit
            if (ts.isBindingPattern(node.name)) {
                // Don't validate for-in initializer as it is already an error
                if (node.initializer && node.parent.parent.kind !== 212 /* ForInStatement */) {
                    checkTypeAssignableTo(checkExpressionCached(node.initializer), getWidenedTypeForVariableLikeDeclaration(node), node, /*headMessage*/ undefined);
                    checkParameterInitializer(node);
                }
                return;
            }
            var symbol = getSymbolOfNode(node);
            var type = convertAutoToAny(getTypeOfVariableOrParameterOrProperty(symbol));
            if (node === symbol.valueDeclaration) {
                // Node is the primary declaration of the symbol, just validate the initializer
                // Don't validate for-in initializer as it is already an error
                if (node.initializer && node.parent.parent.kind !== 212 /* ForInStatement */) {
                    checkTypeAssignableTo(checkExpressionCached(node.initializer), type, node, /*headMessage*/ undefined);
                    checkParameterInitializer(node);
                }
            }
            else {
                // Node is a secondary declaration, check that type is identical to primary declaration and check that
                // initializer is consistent with type associated with the node
                var declarationType = convertAutoToAny(getWidenedTypeForVariableLikeDeclaration(node));
                if (type !== unknownType && declarationType !== unknownType && !isTypeIdenticalTo(type, declarationType)) {
                    error(node.name, ts.Diagnostics.Subsequent_variable_declarations_must_have_the_same_type_Variable_0_must_be_of_type_1_but_here_has_type_2, ts.declarationNameToString(node.name), typeToString(type), typeToString(declarationType));
                }
                if (node.initializer) {
                    checkTypeAssignableTo(checkExpressionCached(node.initializer), declarationType, node, /*headMessage*/ undefined);
                }
                if (!areDeclarationFlagsIdentical(node, symbol.valueDeclaration)) {
                    error(symbol.valueDeclaration.name, ts.Diagnostics.All_declarations_of_0_must_have_identical_modifiers, ts.declarationNameToString(node.name));
                    error(node.name, ts.Diagnostics.All_declarations_of_0_must_have_identical_modifiers, ts.declarationNameToString(node.name));
                }
            }
            if (node.kind !== 147 /* PropertyDeclaration */ && node.kind !== 146 /* PropertySignature */) {
                // We know we don't have a binding pattern or computed name here
                checkExportsOnMergedDeclarations(node);
                if (node.kind === 223 /* VariableDeclaration */ || node.kind === 174 /* BindingElement */) {
                    checkVarDeclaredNamesNotShadowed(node);
                }
                checkCollisionWithCapturedSuperVariable(node, node.name);
                checkCollisionWithCapturedThisVariable(node, node.name);
                checkCollisionWithRequireExportsInGeneratedCode(node, node.name);
                checkCollisionWithGlobalPromiseInGeneratedCode(node, node.name);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{610,1} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{610,1} AS 1 AT <0:3074>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{610,2} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{610,2} AS 2 AT <1:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:convertAutoToAny) id{610,3} ---
(type) {
            return type === autoType ? anyType : type === autoArrayType ? anyArrayType : type;
        }
--- END ---
INLINE (convertAutoToAny) id{610,3} AS 3 AT <0:3120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:convertAutoToAny) id{610,4} ---
(type) {
            return type === autoType ? anyType : type === autoArrayType ? anyArrayType : type;
        }
--- END ---
INLINE (convertAutoToAny) id{610,4} AS 4 AT <0:3973>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isTypeIdenticalTo) id{610,5} ---
(source, target) {
            return isTypeRelatedTo(source, target, identityRelation);
        }
--- END ---
INLINE (isTypeIdenticalTo) id{610,5} AS 5 AT <0:4119>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkCollisionWithCapturedThisVariable) id{610,6} ---
(node, name) {
            if (needCollisionCheckForIdentifier(node, name, "_this")) {
                potentialThisCollisions.push(node);
            }
        }
--- END ---
INLINE (checkCollisionWithCapturedThisVariable) id{610,6} AS 6 AT <0:5570>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isEntityNameExpression) id{611,0} ---
(node) {
        return node.kind === 70 /* Identifier */ ||
            node.kind === 177 /* PropertyAccessExpression */ && isEntityNameExpression(node.expression);
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropertyOfType) id{612,0} ---
(type, name) {
            type = getApparentType(type);
            if (type.flags & 32768 /* Object */) {
                var resolved = resolveStructuredTypeMembers(type);
                var symbol = resolved.members[name];
                if (symbol && symbolIsValue(symbol)) {
                    return symbol;
                }
                if (resolved === anyFunctionType || resolved.callSignatures.length || resolved.constructSignatures.length) {
                    var symbol_1 = getPropertyOfObjectType(globalFunctionType, name);
                    if (symbol_1) {
                        return symbol_1;
                    }
                }
                return getPropertyOfObjectType(globalObjectType, name);
            }
            if (type.flags & 196608 /* UnionOrIntersection */) {
                return getPropertyOfUnionOrIntersectionType(type, name);
            }
            return undefined;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getApparentType) id{612,1} ---
(type) {
            var t = type.flags & 540672 /* TypeVariable */ ? getApparentTypeOfTypeVariable(type) : type;
            return t.flags & 262178 /* StringLike */ ? globalStringType :
                t.flags & 340 /* NumberLike */ ? globalNumberType :
                    t.flags & 136 /* BooleanLike */ ? globalBooleanType :
                        t.flags & 512 /* ESSymbol */ ? getGlobalESSymbolType() :
                            t;
        }
--- END ---
INLINE (getApparentType) id{612,1} AS 1 AT <0:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropertyOfObjectType) id{612,2} ---
(type, name) {
            if (type.flags & 32768 /* Object */) {
                var resolved = resolveStructuredTypeMembers(type);
                var symbol = resolved.members[name];
                if (symbol && symbolIsValue(symbol)) {
                    return symbol;
                }
            }
        }
--- END ---
INLINE (getPropertyOfObjectType) id{612,2} AS 2 AT <0:496>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropertyOfObjectType) id{612,3} ---
(type, name) {
            if (type.flags & 32768 /* Object */) {
                var resolved = resolveStructuredTypeMembers(type);
                var symbol = resolved.members[name];
                if (symbol && symbolIsValue(symbol)) {
                    return symbol;
                }
            }
        }
--- END ---
INLINE (getPropertyOfObjectType) id{612,3} AS 3 AT <0:687>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarProperty) id{613,0} ---
(node) {
            if (ts.isClassLike(node.parent)) {
                if (checkGrammarForNonSymbolComputedProperty(node.name, ts.Diagnostics.A_computed_property_name_in_a_class_property_declaration_must_directly_refer_to_a_built_in_symbol)) {
                    return true;
                }
            }
            else if (node.parent.kind === 227 /* InterfaceDeclaration */) {
                if (checkGrammarForNonSymbolComputedProperty(node.name, ts.Diagnostics.A_computed_property_name_in_an_interface_must_directly_refer_to_a_built_in_symbol)) {
                    return true;
                }
                if (node.initializer) {
                    return grammarErrorOnNode(node.initializer, ts.Diagnostics.An_interface_property_cannot_have_an_initializer);
                }
            }
            else if (node.parent.kind === 161 /* TypeLiteral */) {
                if (checkGrammarForNonSymbolComputedProperty(node.name, ts.Diagnostics.A_computed_property_name_in_a_type_literal_must_directly_refer_to_a_built_in_symbol)) {
                    return true;
                }
                if (node.initializer) {
                    return grammarErrorOnNode(node.initializer, ts.Diagnostics.A_type_literal_property_cannot_have_an_initializer);
                }
            }
            if (ts.isInAmbientContext(node) && node.initializer) {
                return grammarErrorOnFirstToken(node.initializer, ts.Diagnostics.Initializers_are_not_allowed_in_ambient_contexts);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarForNonSymbolComputedProperty) id{613,1} ---
(node, message) {
            if (ts.isDynamicName(node)) {
                return grammarErrorOnNode(node, message);
            }
        }
--- END ---
INLINE (checkGrammarForNonSymbolComputedProperty) id{613,1} AS 1 AT <0:76>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarForNonSymbolComputedProperty) id{613,2} ---
(node, message) {
            if (ts.isDynamicName(node)) {
                return grammarErrorOnNode(node, message);
            }
        }
--- END ---
INLINE (checkGrammarForNonSymbolComputedProperty) id{613,2} AS 2 AT <0:406>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarForNonSymbolComputedProperty) id{613,3} ---
(node, message) {
            if (ts.isDynamicName(node)) {
                return grammarErrorOnNode(node, message);
            }
        }
--- END ---
INLINE (checkGrammarForNonSymbolComputedProperty) id{613,3} AS 3 AT <0:899>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:shouldReportBadModifier) id{614,0} ---
(node) {
            switch (node.kind) {
                case 151 /* GetAccessor */:
                case 152 /* SetAccessor */:
                case 150 /* Constructor */:
                case 147 /* PropertyDeclaration */:
                case 146 /* PropertySignature */:
                case 149 /* MethodDeclaration */:
                case 148 /* MethodSignature */:
                case 155 /* IndexSignature */:
                case 230 /* ModuleDeclaration */:
                case 235 /* ImportDeclaration */:
                case 234 /* ImportEqualsDeclaration */:
                case 241 /* ExportDeclaration */:
                case 240 /* ExportAssignment */:
                case 184 /* FunctionExpression */:
                case 185 /* ArrowFunction */:
                case 144 /* Parameter */:
                    return false;
                default:
                    if (node.parent.kind === 231 /* ModuleBlock */ || node.parent.kind === 261 /* SourceFile */) {
                        return false;
                    }
                    switch (node.kind) {
                        case 225 /* FunctionDeclaration */:
                            return nodeHasAnyModifiersExcept(node, 119 /* AsyncKeyword */);
                        case 226 /* ClassDeclaration */:
                            return nodeHasAnyModifiersExcept(node, 116 /* AbstractKeyword */);
                        case 227 /* InterfaceDeclaration */:
                        case 205 /* VariableStatement */:
                        case 228 /* TypeAliasDeclaration */:
                            return true;
                        case 229 /* EnumDeclaration */:
                            return nodeHasAnyModifiersExcept(node, 75 /* ConstKeyword */);
                        default:
                            ts.Debug.fail();
                            return false;
                    }
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isSimpleTypeRelatedTo) id{615,0} ---
(source, target, relation, errorReporter) {
            if (target.flags & 8192 /* Never */)
                return false;
            if (target.flags & 1 /* Any */ || source.flags & 8192 /* Never */)
                return true;
            if (source.flags & 262178 /* StringLike */ && target.flags & 2 /* String */)
                return true;
            if (source.flags & 340 /* NumberLike */ && target.flags & 4 /* Number */)
                return true;
            if (source.flags & 136 /* BooleanLike */ && target.flags & 8 /* Boolean */)
                return true;
            if (source.flags & 256 /* EnumLiteral */ && target.flags & 16 /* Enum */ && source.baseType === target)
                return true;
            if (source.flags & 16 /* Enum */ && target.flags & 16 /* Enum */ && isEnumTypeRelatedTo(source, target, errorReporter))
                return true;
            if (source.flags & 2048 /* Undefined */ && (!strictNullChecks || target.flags & (2048 /* Undefined */ | 1024 /* Void */)))
                return true;
            if (source.flags & 4096 /* Null */ && (!strictNullChecks || target.flags & 4096 /* Null */))
                return true;
            if (relation === assignableRelation || relation === comparableRelation) {
                if (source.flags & 1 /* Any */)
                    return true;
                if ((source.flags & 4 /* Number */ | source.flags & 64 /* NumberLiteral */) && target.flags & 272 /* EnumLike */)
                    return true;
                if (source.flags & 256 /* EnumLiteral */ &&
                    target.flags & 256 /* EnumLiteral */ &&
                    source.text === target.text &&
                    isEnumTypeRelatedTo(source.baseType, target.baseType, errorReporter)) {
                    return true;
                }
                if (source.flags & 256 /* EnumLiteral */ &&
                    target.flags & 16 /* Enum */ &&
                    isEnumTypeRelatedTo(target, source.baseType, errorReporter)) {
                    return true;
                }
            }
            return false;
        }
--- END ---
[deoptimizing (DEOPT eager): begin 0x27eeba819f11 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)> (opt #604) @79, FP to SP delta: 312, caller sp: 0x7fff5fbfd3c8]
            ;;; deoptimize at 0_10490: Unknown map in polymorphic access
  reading input frame isRelatedTo => node=1900, args=5, height=10; inputs:
      0: 0x27eeba819f11 ; [fp - 16] 0x27eeba819f11 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)>
      1: 0x1f9f6c0532e1 ; [fp + 48] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x3d89260fd7b1 ; [fp - 56] 0x3d89260fd7b1 <a TypeObject with map 0x33abe2a74461>
      3: 0x27eeba818d79 ; rcx 0x27eeba818d79 <a TypeObject with map 0x33abe2a65e11>
      4: 0x30bcea4043b1 ; [fp + 24] 0x30bcea4043b1 <true>
      5: 0x30bcea404311 ; [fp + 16] 0x30bcea404311 <undefined>
      6: 0x27eeba819ca1 ; [fp - 24] 0x27eeba819ca1 <FixedArray[40]>
      7: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; [fp - 64] 0x30bcea404311 <undefined>
      9: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     10: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     11: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     12: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     13: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     14: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     15: 0x3d89260fd7b1 ; rax 0x3d89260fd7b1 <a TypeObject with map 0x33abe2a74461>
  translating frame isRelatedTo => node=1900, height=72
    0x7fff5fbfd3c0: [top + 136] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd3b8: [top + 128] <- 0x3d89260fd7b1 ;  0x3d89260fd7b1 <a TypeObject with map 0x33abe2a74461>  (input #2)
    0x7fff5fbfd3b0: [top + 120] <- 0x27eeba818d79 ;  0x27eeba818d79 <a TypeObject with map 0x33abe2a65e11>  (input #3)
    0x7fff5fbfd3a8: [top + 112] <- 0x30bcea4043b1 ;  0x30bcea4043b1 <true>  (input #4)
    0x7fff5fbfd3a0: [top + 104] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfd398: [top + 96] <- 0x2c21d2207e55 ;  caller's pc
    0x7fff5fbfd390: [top + 88] <- 0x7fff5fbfd3e0 ;  caller's fp
    0x7fff5fbfd388: [top + 80] <- 0x27eeba819ca1 ;  context    0x27eeba819ca1 <FixedArray[40]>  (input #6)
    0x7fff5fbfd380: [top + 72] <- 0x27eeba819f11 ;  function    0x27eeba819f11 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)>  (input #0)
    0x7fff5fbfd378: [top + 64] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfd370: [top + 56] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfd368: [top + 48] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
    0x7fff5fbfd360: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #10)
    0x7fff5fbfd358: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #11)
    0x7fff5fbfd350: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #12)
    0x7fff5fbfd348: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #13)
    0x7fff5fbfd340: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #14)
    0x7fff5fbfd338: [top + 0] <- 0x3d89260fd7b1 ;  0x3d89260fd7b1 <a TypeObject with map 0x33abe2a74461>  (input #15)
[deoptimizing (eager): end 0x27eeba819f11 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)> @79 => node=1900, pc=0x2c21d2629de6, caller sp=0x7fff5fbfd3c8, state=NO_REGISTERS, took 0.114 ms]
[deoptimizer unlinked: isRelatedTo / 27eeba819f11]
[deoptimizer unlinked: isRelatedTo / 27eeba80a959]
[deoptimizer unlinked: isRelatedTo / 27eeba808769]
[deoptimizer unlinked: isRelatedTo / 27eeba805329]
[deoptimizer unlinked: isRelatedTo / 1feaa8ff749]
[deoptimizer unlinked: isRelatedTo / 1feaa8f95a9]
[deoptimizer unlinked: isRelatedTo / 1feaa8f7af1]
[deoptimizer unlinked: isRelatedTo / 1feaa8ef331]
[deoptimizer unlinked: isRelatedTo / 1feaa8ed9a9]
[deoptimizer unlinked: isRelatedTo / 1feaa8e98a1]
[deoptimizer unlinked: isRelatedTo / 1feaa8e7409]
[deoptimizer unlinked: isRelatedTo / 1feaa8c7c29]
[deoptimizer unlinked: isRelatedTo / 1feaa8a9689]
[deoptimizer unlinked: isRelatedTo / 1feaa86a661]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateTypes) id{616,0} ---
(types, mapper) {
            return instantiateList(types, mapper, instantiateType);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateList) id{616,1} ---
(items, mapper, instantiator) {
            if (items && items.length) {
                var result = [];
                for (var _i = 0, items_1 = items; _i < items_1.length; _i++) {
                    var v = items_1[_i];
                    result.push(instantiator(v, mapper));
                }
                return result;
            }
            return items;
        }
--- END ---
INLINE (instantiateList) id{616,1} AS 1 AT <0:37>
[deoptimizing (DEOPT eager): begin 0x1030c9d55f99 <JS Function getNumParametersToCheckForSignatureRelatability (SharedFunctionInfo 0x2e2f693f7801)> (opt #606) @6, FP to SP delta: 24, caller sp: 0x7fff5fbfceb8]
            ;;; deoptimize at 0_712: wrong map
  reading input frame getNumParametersToCheckForSignatureRelatability => node=7, args=5, height=1; inputs:
      0: 0x1030c9d55f99 ; [fp - 16] 0x1030c9d55f99 <JS Function getNumParametersToCheckForSignatureRelatability (SharedFunctionInfo 0x2e2f693f7801)>
      1: 0x1f9f6c0532e1 ; [fp + 48] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x27eeba8360e9 ; rax 0x27eeba8360e9 <a SignatureObject with map 0x33abe2a76091>
      3: 0x00000000 ; [fp + 32] 0
      4: 0x27eeba8352d9 ; [fp + 24] 0x27eeba8352d9 <a SignatureObject with map 0x33abe2a76091>
      5: 0x200000000 ; [fp + 16] 2
      6: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
  translating frame getNumParametersToCheckForSignatureRelatability => node=7, height=0
    0x7fff5fbfceb0: [top + 64] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfcea8: [top + 56] <- 0x27eeba8360e9 ;  0x27eeba8360e9 <a SignatureObject with map 0x33abe2a76091>  (input #2)
    0x7fff5fbfcea0: [top + 48] <- 0x00000000 ;  0  (input #3)
    0x7fff5fbfce98: [top + 40] <- 0x27eeba8352d9 ;  0x27eeba8352d9 <a SignatureObject with map 0x33abe2a76091>  (input #4)
    0x7fff5fbfce90: [top + 32] <- 0x200000000 ;  2  (input #5)
    0x7fff5fbfce88: [top + 24] <- 0x2c21d269c2ca ;  caller's pc
    0x7fff5fbfce80: [top + 16] <- 0x7fff5fbfcf40 ;  caller's fp
    0x7fff5fbfce78: [top + 8] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #6)
    0x7fff5fbfce70: [top + 0] <- 0x1030c9d55f99 ;  function    0x1030c9d55f99 <JS Function getNumParametersToCheckForSignatureRelatability (SharedFunctionInfo 0x2e2f693f7801)>  (input #0)
[deoptimizing (eager): end 0x1030c9d55f99 <JS Function getNumParametersToCheckForSignatureRelatability (SharedFunctionInfo 0x2e2f693f7801)> @6 => node=7, pc=0x2c21d269d99a, caller sp=0x7fff5fbfceb8, state=NO_REGISTERS, took 0.066 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateAnonymousType) id{617,0} ---
(type, mapper) {
            var result = createObjectType(16 /* Anonymous */ | 64 /* Instantiated */, type.symbol);
            result.target = type.objectFlags & 64 /* Instantiated */ ? type.target : type;
            result.mapper = type.objectFlags & 64 /* Instantiated */ ? combineTypeMappers(type.mapper, mapper) : mapper;
            result.aliasSymbol = type.aliasSymbol;
            result.aliasTypeArguments = instantiateTypes(type.aliasTypeArguments, mapper);
            return result;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createObjectType) id{617,1} ---
(objectFlags, symbol) {
            var type = createType(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol = symbol;
            return type;
        }
--- END ---
INLINE (createObjectType) id{617,1} AS 1 AT <0:42>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{617,2} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{617,2} AS 2 AT <1:47>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{617,3} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{617,3} AS 3 AT <2:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateTypes) id{617,4} ---
(types, mapper) {
            return instantiateList(types, mapper, instantiateType);
        }
--- END ---
INLINE (instantiateTypes) id{617,4} AS 4 AT <0:420>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateList) id{617,5} ---
(items, mapper, instantiator) {
            if (items && items.length) {
                var result = [];
                for (var _i = 0, items_1 = items; _i < items_1.length; _i++) {
                    var v = items_1[_i];
                    result.push(instantiator(v, mapper));
                }
                return result;
            }
            return items;
        }
--- END ---
INLINE (instantiateList) id{617,5} AS 5 AT <4:37>
[deoptimizing (DEOPT lazy): begin 0x27eeba819f11 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)> (opt #604) @96, FP to SP delta: 312, caller sp: 0x7fff5fbfd7e0]
  reading input frame isRelatedTo => node=2079, args=5, height=10; inputs:
      0: 0x27eeba819f11 ; [fp - 16] 0x27eeba819f11 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)>
      1: 0x1f9f6c0532e1 ; [fp + 48] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x27eeba821bb9 ; [fp - 56] 0x27eeba821bb9 <a TypeObject with map 0x33abe2a6d349>
      3: 0x27eeba821c41 ; [fp - 40] 0x27eeba821c41 <a TypeObject with map 0x33abe2a6d349>
      4: 0x30bcea4043b1 ; [fp + 24] 0x30bcea4043b1 <true>
      5: 0x30bcea404311 ; [fp + 16] 0x30bcea404311 <undefined>
      6: 0x27eeba819ca1 ; [fp - 24] 0x27eeba819ca1 <FixedArray[40]>
      7: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; [fp - 64] 0x30bcea404311 <undefined>
      9: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     10: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     11: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     12: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     13: 0x30bcea4069a9 ; (literal 24) 0x30bcea4069a9 <Odd Oddball: optimized_out>
     14: 0x30bcea4069a9 ; (literal 24) 0x30bcea4069a9 <Odd Oddball: optimized_out>
     15: 0x100000000 ; rax 1
  translating frame isRelatedTo => node=2079, height=72
    0x7fff5fbfd7d8: [top + 136] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd7d0: [top + 128] <- 0x27eeba821bb9 ;  0x27eeba821bb9 <a TypeObject with map 0x33abe2a6d349>  (input #2)
    0x7fff5fbfd7c8: [top + 120] <- 0x27eeba821c41 ;  0x27eeba821c41 <a TypeObject with map 0x33abe2a6d349>  (input #3)
    0x7fff5fbfd7c0: [top + 112] <- 0x30bcea4043b1 ;  0x30bcea4043b1 <true>  (input #4)
    0x7fff5fbfd7b8: [top + 104] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfd7b0: [top + 96] <- 0x2c21d2207e55 ;  caller's pc
    0x7fff5fbfd7a8: [top + 88] <- 0x7fff5fbfd7f8 ;  caller's fp
    0x7fff5fbfd7a0: [top + 80] <- 0x27eeba819ca1 ;  context    0x27eeba819ca1 <FixedArray[40]>  (input #6)
    0x7fff5fbfd798: [top + 72] <- 0x27eeba819f11 ;  function    0x27eeba819f11 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)>  (input #0)
    0x7fff5fbfd790: [top + 64] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfd788: [top + 56] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfd780: [top + 48] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
    0x7fff5fbfd778: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #10)
    0x7fff5fbfd770: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #11)
    0x7fff5fbfd768: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #12)
    0x7fff5fbfd760: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #13)
    0x7fff5fbfd758: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #14)
    0x7fff5fbfd750: [top + 0] <- 0x100000000 ;  1  (input #15)
[deoptimizing (lazy): end 0x27eeba819f11 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)> @96 => node=2079, pc=0x2c21d262a031, caller sp=0x7fff5fbfd7e0, state=TOS_REGISTER, took 0.098 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isRelatedTo) id{618,0} ---
(source, target, reportErrors, headMessage) {
                var result;
                if (source.flags & 96 /* StringOrNumberLiteral */ && source.flags & 1048576 /* FreshLiteral */) {
                    source = source.regularType;
                }
                if (target.flags & 96 /* StringOrNumberLiteral */ && target.flags & 1048576 /* FreshLiteral */) {
                    target = target.regularType;
                }
                // both types are the same - covers 'they are the same primitive type or both are Any' or the same type parameter cases
                if (source === target)
                    return -1 /* True */;
                if (relation === identityRelation) {
                    return isIdenticalTo(source, target);
                }
                if (isSimpleTypeRelatedTo(source, target, relation, reportErrors ? reportError : undefined))
                    return -1 /* True */;
                if (getObjectFlags(source) & 128 /* ObjectLiteral */ && source.flags & 1048576 /* FreshLiteral */) {
                    if (hasExcessProperties(source, target, reportErrors)) {
                        if (reportErrors) {
                            reportRelationError(headMessage, source, target);
                        }
                        return 0 /* False */;
                    }
                    // Above we check for excess properties with respect to the entire target type. When union
                    // and intersection types are further deconstructed on the target side, we don't want to
                    // make the check again (as it might fail for a partial target type). Therefore we obtain
                    // the regular source type and proceed with that.
                    if (isUnionOrIntersectionTypeWithoutNullableConstituents(target)) {
                        source = getRegularTypeOfObjectLiteral(source);
                    }
                }
                var saveErrorInfo = errorInfo;
                // Note that these checks are specifically ordered to produce correct results. In particular,
                // we need to deconstruct unions before intersections (because unions are always at the top),
                // and we need to handle "each" relations before "some" relations for the same kind of type.
                if (source.flags & 65536 /* Union */) {
                    if (relation === comparableRelation) {
                        result = someTypeRelatedToType(source, target, reportErrors && !(source.flags & 8190 /* Primitive */));
                    }
                    else {
                        result = eachTypeRelatedToType(source, target, reportErrors && !(source.flags & 8190 /* Primitive */));
                    }
                    if (result) {
                        return result;
                    }
                }
                else if (target.flags & 65536 /* Union */) {
                    if (result = typeRelatedToSomeType(source, target, reportErrors && !(source.flags & 8190 /* Primitive */) && !(target.flags & 8190 /* Primitive */))) {
                        return result;
                    }
                }
                else if (target.flags & 131072 /* Intersection */) {
                    if (result = typeRelatedToEachType(source, target, reportErrors)) {
                        return result;
                    }
                }
                else if (source.flags & 131072 /* Intersection */) {
                    // Check to see if any constituents of the intersection are immediately related to the target.
                    //
                    // Don't report errors though. Checking whether a constituent is related to the source is not actually
                    // useful and leads to some confusing error messages. Instead it is better to let the below checks
                    // take care of this, or to not elaborate at all. For instance,
                    //
                    //    - For an object type (such as 'C = A & B'), users are usually more interested in structural errors.
                    //
                    //    - For a union type (such as '(A | B) = (C & D)'), it's better to hold onto the whole intersection
                    //          than to report that 'D' is not assignable to 'A' or 'B'.
                    //
                    //    - For a primitive type or type parameter (such as 'number = A & B') there is no point in
                    //          breaking the intersection apart.
                    if (result = someTypeRelatedToType(source, target, /*reportErrors*/ false)) {
                        return result;
                    }
                }
                else if (target.flags & 16384 /* TypeParameter */) {
                    // A source type { [P in keyof T]: X } is related to a target type T if X is related to T[P].
                    if (getObjectFlags(source) & 32 /* Mapped */ && getConstraintTypeFromMappedType(source) === getIndexType(target)) {
                        if (!source.declaration.questionToken) {
                            var templateType = getTemplateTypeFromMappedType(source);
                            var indexedAccessType = getIndexedAccessType(target, getTypeParameterFromMappedType(source));
                            if (result = isRelatedTo(templateType, indexedAccessType, reportErrors)) {
                                return result;
                            }
                        }
                    }
                    else {
                        // Given a type parameter K with a constraint keyof T, a type S is
                        // assignable to K if S is assignable to keyof T.
                        var constraint = getConstraintOfTypeParameter(target);
                        if (constraint && constraint.flags & 262144 /* Index */) {
                            if (result = isRelatedTo(source, constraint, reportErrors)) {
                                return result;
                            }
                        }
                    }
                }
                else if (target.flags & 262144 /* Index */) {
                    // A keyof S is related to a keyof T if T is related to S.
                    if (source.flags & 262144 /* Index */) {
                        if (result = isRelatedTo(target.type, source.type, /*reportErrors*/ false)) {
                            return result;
                        }
                    }
                    // Given a type variable T with a constraint C, a type S is assignable to
                    // keyof T if S is assignable to keyof C.
                    if (target.type.flags & 540672 /* TypeVariable */) {
                        var constraint = getConstraintOfTypeVariable(target.type);
                        if (constraint) {
                            if (result = isRelatedTo(source, getIndexType(constraint), reportErrors)) {
                                return result;
                            }
                        }
                    }
                }
                else if (target.flags & 524288 /* IndexedAccess */) {
                    // if we have indexed access types with identical index types, see if relationship holds for
                    // the two object types.
                    if (source.flags & 524288 /* IndexedAccess */ && source.indexType === target.indexType) {
                        if (result = isRelatedTo(source.objectType, target.objectType, reportErrors)) {
                            return result;
                        }
                    }
                    // A type S is related to a type T[K] if S is related to A[K], where K is string-like and
                    // A is the apparent type of S.
                    if (target.constraint) {
                        if (result = isRelatedTo(source, target.constraint, reportErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                }
                if (source.flags & 16384 /* TypeParameter */) {
                    // A source type T is related to a target type { [P in keyof T]: X } if T[P] is related to X.
                    if (getObjectFlags(target) & 32 /* Mapped */ && getConstraintTypeFromMappedType(target) === getIndexType(source)) {
                        var indexedAccessType = getIndexedAccessType(source, getTypeParameterFromMappedType(target));
                        var templateType = getTemplateTypeFromMappedType(target);
                        if (result = isRelatedTo(indexedAccessType, templateType, reportErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                    else {
                        var constraint = getConstraintOfTypeParameter(source);
                        if (!constraint || constraint.flags & 1 /* Any */) {
                            constraint = emptyObjectType;
                        }
                        // The constraint may need to be further instantiated with its 'this' type.
                        constraint = getTypeWithThisArgument(constraint, source);
                        // Report constraint errors only if the constraint is not the empty object type
                        var reportConstraintErrors = reportErrors && constraint !== emptyObjectType;
                        if (result = isRelatedTo(constraint, target, reportConstraintErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                }
                else if (source.flags & 524288 /* IndexedAccess */) {
                    // A type S[K] is related to a type T if A[K] is related to T, where K is string-like and
                    // A is the apparent type of S.
                    if (source.constraint) {
                        if (result = isRelatedTo(source.constraint, target, reportErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                }
                else {
                    if (getObjectFlags(source) & 4 /* Reference */ && getObjectFlags(target) & 4 /* Reference */ && source.target === target.target) {
                        // We have type references to same target type, see if relationship holds for all type arguments
                        if (result = typeArgumentsRelatedTo(source, target, reportErrors)) {
                            return result;
                        }
                    }
                    // Even if relationship doesn't hold for unions, intersections, or generic type references,
                    // it may hold in a structural comparison.
                    var apparentSource = getApparentType(source);
                    // In a check of the form X = A & B, we will have previously checked if A relates to X or B relates
                    // to X. Failing both of those we want to check if the aggregation of A and B's members structurally
                    // relates to X. Thus, we include intersection types on the source side here.
                    if (apparentSource.flags & (32768 /* Object */ | 131072 /* Intersection */) && target.flags & 32768 /* Object */) {
                        // Report structural errors only if we haven't reported any errors yet
                        var reportStructuralErrors = reportErrors && errorInfo === saveErrorInfo && !(source.flags & 8190 /* Primitive */);
                        if (result = objectTypeRelatedTo(apparentSource, source, target, reportStructuralErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                }
                if (reportErrors) {
                    if (source.flags & 32768 /* Object */ && target.flags & 8190 /* Primitive */) {
                        tryElaborateErrorsForPrimitivesAndObjects(source, target);
                    }
                    else if (source.symbol && source.flags & 32768 /* Object */ && globalObjectType === source) {
                        reportError(ts.Diagnostics.The_Object_type_is_assignable_to_very_few_other_types_Did_you_mean_to_use_the_any_type_instead);
                    }
                    reportRelationError(headMessage, source, target);
                }
                return 0 /* False */;
            }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{618,1} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{618,1} AS 1 AT <0:953>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{618,2} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{618,2} AS 2 AT <0:4927>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getConstraintOfTypeVariable) id{618,3} ---
(type) {
            return type.flags & 16384 /* TypeParameter */ ? getConstraintOfTypeParameter(type) :
                type.flags & 524288 /* IndexedAccess */ ? type.constraint :
                    undefined;
        }
--- END ---
INLINE (getConstraintOfTypeVariable) id{618,3} AS 3 AT <0:6792>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{618,4} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{618,4} AS 4 AT <0:8322>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeWithThisArgument) id{618,5} ---
(type, thisArgument) {
            if (getObjectFlags(type) & 4 /* Reference */) {
                return createTypeReference(type.target, ts.concatenate(type.typeArguments, [thisArgument || type.target.thisType]));
            }
            return type;
        }
--- END ---
INLINE (getTypeWithThisArgument) id{618,5} AS 5 AT <0:9283>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{618,6} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{618,6} AS 6 AT <5:39>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createTypeReference) id{618,7} ---
(target, typeArguments) {
            var id = getTypeListId(typeArguments);
            var type = target.instantiations[id];
            if (!type) {
                type = target.instantiations[id] = createObjectType(4 /* Reference */, target.symbol);
                type.flags |= typeArguments ? getPropagatingFlagsOfTypes(typeArguments, /*excludeKinds*/ 0) : 0;
                type.target = target;
                type.typeArguments = typeArguments;
            }
            return type;
        }
--- END ---
INLINE (createTypeReference) id{618,7} AS 7 AT <5:106>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createObjectType) id{618,8} ---
(objectFlags, symbol) {
            var type = createType(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol = symbol;
            return type;
        }
--- END ---
INLINE (createObjectType) id{618,8} AS 8 AT <7:203>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{618,9} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{618,9} AS 9 AT <8:47>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{618,10} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{618,10} AS 10 AT <9:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropagatingFlagsOfTypes) id{618,11} ---
(types, excludeKinds) {
            var result = 0;
            for (var _i = 0, types_3 = types; _i < types_3.length; _i++) {
                var type = types_3[_i];
                if (!(type.flags & excludeKinds)) {
                    result |= type.flags;
                }
            }
            return result & 14680064 /* PropagatingFlags */;
        }
--- END ---
INLINE (getPropagatingFlagsOfTypes) id{618,11} AS 11 AT <7:301>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{618,12} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{618,12} AS 12 AT <0:10374>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{618,13} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{618,13} AS 13 AT <0:10420>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getApparentType) id{618,14} ---
(type) {
            var t = type.flags & 540672 /* TypeVariable */ ? getApparentTypeOfTypeVariable(type) : type;
            return t.flags & 262178 /* StringLike */ ? globalStringType :
                t.flags & 340 /* NumberLike */ ? globalNumberType :
                    t.flags & 136 /* BooleanLike */ ? globalBooleanType :
                        t.flags & 512 /* ESSymbol */ ? getGlobalESSymbolType() :
                            t;
        }
--- END ---
INLINE (getApparentType) id{618,14} AS 14 AT <0:11022>
[deoptimizing (DEOPT lazy): begin 0x27eeba819f11 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)> (opt #604) @96, FP to SP delta: 312, caller sp: 0x7fff5fbfdae8]
  reading input frame isRelatedTo => node=2079, args=5, height=10; inputs:
      0: 0x27eeba819f11 ; [fp - 16] 0x27eeba819f11 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)>
      1: 0x1f9f6c0532e1 ; [fp + 48] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x27eeba818c21 ; [fp - 56] 0x27eeba818c21 <a TypeObject with map 0x33abe2a746c9>
      3: 0x27eeba819ba9 ; [fp - 40] 0x27eeba819ba9 <a TypeObject with map 0x33abe2a746c9>
      4: 0x30bcea4043b1 ; [fp + 24] 0x30bcea4043b1 <true>
      5: 0xd6230df7599 ; [fp + 16] 0xd6230df7599 <an Object with map 0x33abe2a3df61>
      6: 0x27eeba819ca1 ; [fp - 24] 0x27eeba819ca1 <FixedArray[40]>
      7: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; [fp - 64] 0x30bcea404311 <undefined>
      9: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     10: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     11: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     12: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     13: 0x30bcea4069a9 ; (literal 24) 0x30bcea4069a9 <Odd Oddball: optimized_out>
     14: 0x30bcea4069a9 ; (literal 24) 0x30bcea4069a9 <Odd Oddball: optimized_out>
     15: 0x100000000 ; rax 1
  translating frame isRelatedTo => node=2079, height=72
    0x7fff5fbfdae0: [top + 136] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdad8: [top + 128] <- 0x27eeba818c21 ;  0x27eeba818c21 <a TypeObject with map 0x33abe2a746c9>  (input #2)
    0x7fff5fbfdad0: [top + 120] <- 0x27eeba819ba9 ;  0x27eeba819ba9 <a TypeObject with map 0x33abe2a746c9>  (input #3)
    0x7fff5fbfdac8: [top + 112] <- 0x30bcea4043b1 ;  0x30bcea4043b1 <true>  (input #4)
    0x7fff5fbfdac0: [top + 104] <- 0xd6230df7599 ;  0xd6230df7599 <an Object with map 0x33abe2a3df61>  (input #5)
    0x7fff5fbfdab8: [top + 96] <- 0x2c21d2649a8d ;  caller's pc
    0x7fff5fbfdab0: [top + 88] <- 0x7fff5fbfdb28 ;  caller's fp
    0x7fff5fbfdaa8: [top + 80] <- 0x27eeba819ca1 ;  context    0x27eeba819ca1 <FixedArray[40]>  (input #6)
    0x7fff5fbfdaa0: [top + 72] <- 0x27eeba819f11 ;  function    0x27eeba819f11 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)>  (input #0)
    0x7fff5fbfda98: [top + 64] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfda90: [top + 56] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfda88: [top + 48] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
    0x7fff5fbfda80: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #10)
    0x7fff5fbfda78: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #11)
    0x7fff5fbfda70: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #12)
    0x7fff5fbfda68: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #13)
    0x7fff5fbfda60: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #14)
    0x7fff5fbfda58: [top + 0] <- 0x100000000 ;  1  (input #15)
[deoptimizing (lazy): end 0x27eeba819f11 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)> @96 => node=2079, pc=0x2c21d262a031, caller sp=0x7fff5fbfdae8, state=TOS_REGISTER, took 0.110 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkArrayType) id{619,0} ---
(node) {
            checkSourceElement(node.elementType);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarMethod) id{620,0} ---
(node) {
            if (checkGrammarDisallowedModifiersOnObjectLiteralExpressionMethod(node) ||
                checkGrammarFunctionLikeDeclaration(node) ||
                checkGrammarForGenerator(node)) {
                return true;
            }
            if (node.parent.kind === 176 /* ObjectLiteralExpression */) {
                if (checkGrammarForInvalidQuestionMark(node.questionToken, ts.Diagnostics.An_object_member_cannot_be_declared_optional)) {
                    return true;
                }
                else if (node.body === undefined) {
                    return grammarErrorAtPos(ts.getSourceFileOfNode(node), node.end - 1, ";".length, ts.Diagnostics._0_expected, "{");
                }
            }
            if (ts.isClassLike(node.parent)) {
                // Technically, computed properties in ambient contexts is disallowed
                // for property declarations and accessors too, not just methods.
                // However, property declarations disallow computed names in general,
                // and accessors are not allowed in ambient contexts in general,
                // so this error only really matters for methods.
                if (ts.isInAmbientContext(node)) {
                    return checkGrammarForNonSymbolComputedProperty(node.name, ts.Diagnostics.A_computed_property_name_in_an_ambient_context_must_directly_refer_to_a_built_in_symbol);
                }
                else if (!node.body) {
                    return checkGrammarForNonSymbolComputedProperty(node.name, ts.Diagnostics.A_computed_property_name_in_a_method_overload_must_directly_refer_to_a_built_in_symbol);
                }
            }
            else if (node.parent.kind === 227 /* InterfaceDeclaration */) {
                return checkGrammarForNonSymbolComputedProperty(node.name, ts.Diagnostics.A_computed_property_name_in_an_interface_must_directly_refer_to_a_built_in_symbol);
            }
            else if (node.parent.kind === 161 /* TypeLiteral */) {
                return checkGrammarForNonSymbolComputedProperty(node.name, ts.Diagnostics.A_computed_property_name_in_a_type_literal_must_directly_refer_to_a_built_in_symbol);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarFunctionLikeDeclaration) id{620,1} ---
(node) {
            // Prevent cascading error by short-circuit
            var file = ts.getSourceFileOfNode(node);
            return checkGrammarDecorators(node) || checkGrammarModifiers(node) || checkGrammarTypeParameterList(node.typeParameters, file) ||
                checkGrammarParameterList(node.parameters) || checkGrammarArrowFunction(node, file);
        }
--- END ---
INLINE (checkGrammarFunctionLikeDeclaration) id{620,1} AS 1 AT <0:113>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarTypeParameterList) id{620,2} ---
(typeParameters, file) {
            if (checkGrammarForDisallowedTrailingComma(typeParameters)) {
                return true;
            }
            if (typeParameters && typeParameters.length === 0) {
                var start = typeParameters.pos - "<".length;
                var end = ts.skipTrivia(file.text, typeParameters.end) + ">".length;
                return grammarErrorAtPos(file, start, end - start, ts.Diagnostics.Type_parameter_list_cannot_be_empty);
            }
        }
--- END ---
INLINE (checkGrammarTypeParameterList) id{620,2} AS 2 AT <1:200>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarForDisallowedTrailingComma) id{620,3} ---
(list) {
            if (list && list.hasTrailingComma) {
                var start = list.end - ",".length;
                var end = list.end;
                var sourceFile = ts.getSourceFileOfNode(list[0]);
                return grammarErrorAtPos(sourceFile, start, end - start, ts.Diagnostics.Trailing_comma_not_allowed);
            }
        }
--- END ---
INLINE (checkGrammarForDisallowedTrailingComma) id{620,3} AS 3 AT <2:41>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarForNonSymbolComputedProperty) id{620,4} ---
(node, message) {
            if (ts.isDynamicName(node)) {
                return grammarErrorOnNode(node, message);
            }
        }
--- END ---
INLINE (checkGrammarForNonSymbolComputedProperty) id{620,4} AS 4 AT <0:1260>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarForNonSymbolComputedProperty) id{620,5} ---
(node, message) {
            if (ts.isDynamicName(node)) {
                return grammarErrorOnNode(node, message);
            }
        }
--- END ---
INLINE (checkGrammarForNonSymbolComputedProperty) id{620,5} AS 5 AT <0:1788>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarForNonSymbolComputedProperty) id{620,6} ---
(node, message) {
            if (ts.isDynamicName(node)) {
                return grammarErrorOnNode(node, message);
            }
        }
--- END ---
INLINE (checkGrammarForNonSymbolComputedProperty) id{620,6} AS 6 AT <0:2043>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNumParametersToCheckForSignatureRelatability) id{621,0} ---
(source, sourceNonRestParamCount, target, targetNonRestParamCount) {
            if (source.hasRestParameter === target.hasRestParameter) {
                if (source.hasRestParameter) {
                    // If both have rest parameters, get the max and add 1 to
                    // compensate for the rest parameter.
                    return Math.max(sourceNonRestParamCount, targetNonRestParamCount) + 1;
                }
                else {
                    return Math.min(sourceNonRestParamCount, targetNonRestParamCount);
                }
            }
            else {
                // Return the count for whichever signature doesn't have rest parameters.
                return source.hasRestParameter ?
                    targetNonRestParamCount :
                    sourceNonRestParamCount;
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateList) id{622,0} ---
(items, mapper, instantiator) {
            if (items && items.length) {
                var result = [];
                for (var _i = 0, items_1 = items; _i < items_1.length; _i++) {
                    var v = items_1[_i];
                    result.push(instantiator(v, mapper));
                }
                return result;
            }
            return items;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isClassLike) id{623,0} ---
(node) {
        return node && (node.kind === 226 /* ClassDeclaration */ || node.kind === 197 /* ClassExpression */);
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveAnonymousTypeMembers) id{624,0} ---
(type) {
            var symbol = type.symbol;
            if (type.target) {
                var members = createInstantiatedSymbolTable(getPropertiesOfObjectType(type.target), type.mapper, /*mappingThisOnly*/ false);
                var callSignatures = instantiateSignatures(getSignaturesOfType(type.target, 0 /* Call */), type.mapper);
                var constructSignatures = instantiateSignatures(getSignaturesOfType(type.target, 1 /* Construct */), type.mapper);
                var stringIndexInfo = instantiateIndexInfo(getIndexInfoOfType(type.target, 0 /* String */), type.mapper);
                var numberIndexInfo = instantiateIndexInfo(getIndexInfoOfType(type.target, 1 /* Number */), type.mapper);
                setStructuredTypeMembers(type, members, callSignatures, constructSignatures, stringIndexInfo, numberIndexInfo);
            }
            else if (symbol.flags & 2048 /* TypeLiteral */) {
                var members = symbol.members;
                var callSignatures = getSignaturesOfSymbol(members["__call"]);
                var constructSignatures = getSignaturesOfSymbol(members["__new"]);
                var stringIndexInfo = getIndexInfoOfSymbol(symbol, 0 /* String */);
                var numberIndexInfo = getIndexInfoOfSymbol(symbol, 1 /* Number */);
                setStructuredTypeMembers(type, members, callSignatures, constructSignatures, stringIndexInfo, numberIndexInfo);
            }
            else {
                // Combinations of function, class, enum and module
                var members = emptySymbols;
                var constructSignatures = emptyArray;
                if (symbol.flags & 1952 /* HasExports */) {
                    members = getExportsOfSymbol(symbol);
                }
                if (symbol.flags & 32 /* Class */) {
                    var classType = getDeclaredTypeOfClassOrInterface(symbol);
                    constructSignatures = getSignaturesOfSymbol(symbol.members["__constructor"]);
                    if (!constructSignatures.length) {
                        constructSignatures = getDefaultConstructSignatures(classType);
                    }
                    var baseConstructorType = getBaseConstructorTypeOfClass(classType);
                    if (baseConstructorType.flags & 32768 /* Object */) {
                        members = createSymbolTable(getNamedMembers(members));
                        addInheritedMembers(members, getPropertiesOfObjectType(baseConstructorType));
                    }
                }
                var numberIndexInfo = symbol.flags & 384 /* Enum */ ? enumNumberIndexInfo : undefined;
                setStructuredTypeMembers(type, members, emptyArray, constructSignatures, undefined, numberIndexInfo);
                // We resolve the members before computing the signatures because a signature may use
                // typeof with a qualified name expression that circularly references the type we are
                // in the process of resolving (see issue #6072). The temporarily empty signature list
                // will never be observed because a qualified name can't reference signatures.
                if (symbol.flags & (16 /* Function */ | 8192 /* Method */)) {
                    type.callSignatures = getSignaturesOfSymbol(symbol);
                }
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropertiesOfObjectType) id{624,1} ---
(type) {
            if (type.flags & 32768 /* Object */) {
                return resolveStructuredTypeMembers(type).properties;
            }
            return emptyArray;
        }
--- END ---
INLINE (getPropertiesOfObjectType) id{624,1} AS 1 AT <0:138>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createInstantiatedSymbolTable) id{624,2} ---
(symbols, mapper, mappingThisOnly) {
            var result = ts.createMap();
            for (var _i = 0, symbols_2 = symbols; _i < symbols_2.length; _i++) {
                var symbol = symbols_2[_i];
                result[symbol.name] = mappingThisOnly && isIndependentMember(symbol) ? symbol : instantiateSymbol(symbol, mapper);
            }
            return result;
        }
--- END ---
INLINE (createInstantiatedSymbolTable) id{624,2} AS 2 AT <0:108>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSignaturesOfType) id{624,3} ---
(type, kind) {
            return getSignaturesOfStructuredType(getApparentType(type), kind);
        }
--- END ---
INLINE (getSignaturesOfType) id{624,3} AS 3 AT <0:278>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getApparentType) id{624,4} ---
(type) {
            var t = type.flags & 540672 /* TypeVariable */ ? getApparentTypeOfTypeVariable(type) : type;
            return t.flags & 262178 /* StringLike */ ? globalStringType :
                t.flags & 340 /* NumberLike */ ? globalNumberType :
                    t.flags & 136 /* BooleanLike */ ? globalBooleanType :
                        t.flags & 512 /* ESSymbol */ ? getGlobalESSymbolType() :
                            t;
        }
--- END ---
INLINE (getApparentType) id{624,4} AS 4 AT <3:64>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSignaturesOfStructuredType) id{624,5} ---
(type, kind) {
            if (type.flags & 229376 /* StructuredType */) {
                var resolved = resolveStructuredTypeMembers(type);
                return kind === 0 /* Call */ ? resolved.callSignatures : resolved.constructSignatures;
            }
            return emptyArray;
        }
--- END ---
INLINE (getSignaturesOfStructuredType) id{624,5} AS 5 AT <3:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateSignatures) id{624,6} ---
(signatures, mapper) {
            return instantiateList(signatures, mapper, instantiateSignature);
        }
--- END ---
INLINE (instantiateSignatures) id{624,6} AS 6 AT <0:256>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateList) id{624,7} ---
(items, mapper, instantiator) {
            if (items && items.length) {
                var result = [];
                for (var _i = 0, items_1 = items; _i < items_1.length; _i++) {
                    var v = items_1[_i];
                    result.push(instantiator(v, mapper));
                }
                return result;
            }
            return items;
        }
--- END ---
INLINE (instantiateList) id{624,7} AS 7 AT <6:42>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSignaturesOfType) id{624,8} ---
(type, kind) {
            return getSignaturesOfStructuredType(getApparentType(type), kind);
        }
--- END ---
INLINE (getSignaturesOfType) id{624,8} AS 8 AT <0:404>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getApparentType) id{624,9} ---
(type) {
            var t = type.flags & 540672 /* TypeVariable */ ? getApparentTypeOfTypeVariable(type) : type;
            return t.flags & 262178 /* StringLike */ ? globalStringType :
                t.flags & 340 /* NumberLike */ ? globalNumberType :
                    t.flags & 136 /* BooleanLike */ ? globalBooleanType :
                        t.flags & 512 /* ESSymbol */ ? getGlobalESSymbolType() :
                            t;
        }
--- END ---
INLINE (getApparentType) id{624,9} AS 9 AT <8:64>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSignaturesOfStructuredType) id{624,10} ---
(type, kind) {
            if (type.flags & 229376 /* StructuredType */) {
                var resolved = resolveStructuredTypeMembers(type);
                return kind === 0 /* Call */ ? resolved.callSignatures : resolved.constructSignatures;
            }
            return emptyArray;
        }
--- END ---
INLINE (getSignaturesOfStructuredType) id{624,10} AS 10 AT <8:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateSignatures) id{624,11} ---
(signatures, mapper) {
            return instantiateList(signatures, mapper, instantiateSignature);
        }
--- END ---
INLINE (instantiateSignatures) id{624,11} AS 11 AT <0:382>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateList) id{624,12} ---
(items, mapper, instantiator) {
            if (items && items.length) {
                var result = [];
                for (var _i = 0, items_1 = items; _i < items_1.length; _i++) {
                    var v = items_1[_i];
                    result.push(instantiator(v, mapper));
                }
                return result;
            }
            return items;
        }
--- END ---
INLINE (instantiateList) id{624,12} AS 12 AT <11:42>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexInfoOfType) id{624,13} ---
(type, kind) {
            return getIndexInfoOfStructuredType(getApparentType(type), kind);
        }
--- END ---
INLINE (getIndexInfoOfType) id{624,13} AS 13 AT <0:530>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getApparentType) id{624,14} ---
(type) {
            var t = type.flags & 540672 /* TypeVariable */ ? getApparentTypeOfTypeVariable(type) : type;
            return t.flags & 262178 /* StringLike */ ? globalStringType :
                t.flags & 340 /* NumberLike */ ? globalNumberType :
                    t.flags & 136 /* BooleanLike */ ? globalBooleanType :
                        t.flags & 512 /* ESSymbol */ ? getGlobalESSymbolType() :
                            t;
        }
--- END ---
INLINE (getApparentType) id{624,14} AS 14 AT <13:63>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:addTypesToUnion) id{625,0} ---
(typeSet, types) {
            for (var _i = 0, types_4 = types; _i < types_4.length; _i++) {
                var type = types_4[_i];
                addTypeToUnion(typeSet, type);
            }
        }
--- END ---
[deoptimizing (DEOPT eager): begin 0xd6230dc82c9 <JS Function isAmbientModule (SharedFunctionInfo 0x3504a53cd0d9)> (opt #561) @4, FP to SP delta: 24, caller sp: 0x7fff5fbfdbf8]
            ;;; deoptimize at 0_94: wrong map
  reading input frame isAmbientModule => node=9, args=2, height=2; inputs:
      0: 0xd6230dc82c9 ; [fp - 16] 0xd6230dc82c9 <JS Function isAmbientModule (SharedFunctionInfo 0x3504a53cd0d9)>
      1: 0x16f3adb61821 ; [fp + 24] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      2: 0x1d75d8660fd9 ; rbx 0x1d75d8660fd9 <a NodeObject with map 0x33abe2a72361>
      3: 0xd6230db34c9 ; [fp - 24] 0xd6230db34c9 <FixedArray[156]>
      4: 0x30bcea4043b1 ; rax 0x30bcea4043b1 <true>
  translating frame isAmbientModule => node=9, height=8
    0x7fff5fbfdbf0: [top + 48] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #1)
    0x7fff5fbfdbe8: [top + 40] <- 0x1d75d8660fd9 ;  0x1d75d8660fd9 <a NodeObject with map 0x33abe2a72361>  (input #2)
    0x7fff5fbfdbe0: [top + 32] <- 0x2c21d26850c3 ;  caller's pc
    0x7fff5fbfdbd8: [top + 24] <- 0x7fff5fbfdc68 ;  caller's fp
    0x7fff5fbfdbd0: [top + 16] <- 0xd6230db34c9 ;  context    0xd6230db34c9 <FixedArray[156]>  (input #3)
    0x7fff5fbfdbc8: [top + 8] <- 0xd6230dc82c9 ;  function    0xd6230dc82c9 <JS Function isAmbientModule (SharedFunctionInfo 0x3504a53cd0d9)>  (input #0)
    0x7fff5fbfdbc0: [top + 0] <- 0x30bcea4043b1 ;  0x30bcea4043b1 <true>  (input #4)
[deoptimizing (eager): end 0xd6230dc82c9 <JS Function isAmbientModule (SharedFunctionInfo 0x3504a53cd0d9)> @4 => node=9, pc=0x2c21d24ea867, caller sp=0x7fff5fbfdbf8, state=TOS_REGISTER, took 0.058 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d3f319 <JS Function checkGrammarVariableDeclaration (SharedFunctionInfo 0x1b98fbc14d11)> (opt #524) @30, FP to SP delta: 120, caller sp: 0x7fff5fbfd778]
            ;;; deoptimize at 0_2712: wrong map
  reading input frame checkGrammarVariableDeclaration => node=634, args=2, height=4; inputs:
      0: 0x1030c9d3f319 ; [fp - 16] 0x1030c9d3f319 <JS Function checkGrammarVariableDeclaration (SharedFunctionInfo 0x1b98fbc14d11)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1d75d86c5599 ; rcx 0x1d75d86c5599 <a NodeObject with map 0x33abe2a71339>
      3: 0x130b7e1b3d29 ; rbx 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
      5: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
      6: 0x30bcea4043b1 ; rax 0x30bcea4043b1 <true>
  translating frame checkGrammarVariableDeclaration => node=634, height=24
    0x7fff5fbfd770: [top + 64] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd768: [top + 56] <- 0x1d75d86c5599 ;  0x1d75d86c5599 <a NodeObject with map 0x33abe2a71339>  (input #2)
    0x7fff5fbfd760: [top + 48] <- 0x2c21d26fd92f ;  caller's pc
    0x7fff5fbfd758: [top + 40] <- 0x7fff5fbfd790 ;  caller's fp
    0x7fff5fbfd750: [top + 32] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd748: [top + 24] <- 0x1030c9d3f319 ;  function    0x1030c9d3f319 <JS Function checkGrammarVariableDeclaration (SharedFunctionInfo 0x1b98fbc14d11)>  (input #0)
    0x7fff5fbfd740: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfd738: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfd730: [top + 0] <- 0x30bcea4043b1 ;  0x30bcea4043b1 <true>  (input #6)
[deoptimizing (eager): end 0x1030c9d3f319 <JS Function checkGrammarVariableDeclaration (SharedFunctionInfo 0x1b98fbc14d11)> @30 => node=634, pc=0x2c21d25f2c88, caller sp=0x7fff5fbfd778, state=TOS_REGISTER, took 0.067 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkVariableStatement) id{626,0} ---
(node) {
            // Grammar checking
            checkGrammarDecorators(node) || checkGrammarModifiers(node) || checkGrammarVariableDeclarationList(node.declarationList) || checkGrammarForDisallowedLetOrConstStatement(node);
            ts.forEach(node.declarationList.declarations, checkSourceElement);
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarVariableDeclarationList) id{626,1} ---
(declarationList) {
            var declarations = declarationList.declarations;
            if (checkGrammarForDisallowedTrailingComma(declarationList.declarations)) {
                return true;
            }
            if (!declarationList.declarations.length) {
                return grammarErrorAtPos(ts.getSourceFileOfNode(declarationList), declarations.pos, declarations.end - declarations.pos, ts.Diagnostics.Variable_declaration_list_cannot_be_empty);
            }
        }
--- END ---
INLINE (checkGrammarVariableDeclarationList) id{626,1} AS 1 AT <0:116>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarForDisallowedTrailingComma) id{626,2} ---
(list) {
            if (list && list.hasTrailingComma) {
                var start = list.end - ",".length;
                var end = list.end;
                var sourceFile = ts.getSourceFileOfNode(list[0]);
                return grammarErrorAtPos(sourceFile, start, end - start, ts.Diagnostics.Trailing_comma_not_allowed);
            }
        }
--- END ---
INLINE (checkGrammarForDisallowedTrailingComma) id{626,2} AS 2 AT <1:97>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarForDisallowedLetOrConstStatement) id{626,3} ---
(node) {
            if (!allowLetAndConstDeclarations(node.parent)) {
                if (ts.isLet(node.declarationList)) {
                    return grammarErrorOnNode(node, ts.Diagnostics.let_declarations_can_only_be_declared_inside_a_block);
                }
                else if (ts.isConst(node.declarationList)) {
                    return grammarErrorOnNode(node, ts.Diagnostics.const_declarations_can_only_be_declared_inside_a_block);
                }
            }
        }
--- END ---
INLINE (checkGrammarForDisallowedLetOrConstStatement) id{626,3} AS 3 AT <0:177>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:allowLetAndConstDeclarations) id{626,4} ---
(parent) {
            switch (parent.kind) {
                case 208 /* IfStatement */:
                case 209 /* DoStatement */:
                case 210 /* WhileStatement */:
                case 217 /* WithStatement */:
                case 211 /* ForStatement */:
                case 212 /* ForInStatement */:
                case 213 /* ForOfStatement */:
                    return false;
                case 219 /* LabeledStatement */:
                    return allowLetAndConstDeclarations(parent.parent);
            }
            return true;
        }
--- END ---
INLINE (allowLetAndConstDeclarations) id{626,4} AS 4 AT <3:26>
[deoptimizing (DEOPT eager): begin 0x1030c9d3e3d1 <JS Function getDeclaredTypeOfClassOrInterface (SharedFunctionInfo 0x2e2f693eddd1)> (opt #593) @16, FP to SP delta: 128, caller sp: 0x7fff5fbfd590]
            ;;; deoptimize at 0_81: Unknown map in polymorphic access
  reading input frame getDeclaredTypeOfClassOrInterface => node=30, args=2, height=7; inputs:
      0: 0x1030c9d3e3d1 ; [fp - 16] 0x1030c9d3e3d1 <JS Function getDeclaredTypeOfClassOrInterface (SharedFunctionInfo 0x2e2f693eddd1)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x38be05825489 ; [fp + 16] 0x38be05825489 <a SymbolObject with map 0x33abe2a6dd41>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 13) 0x30bcea404311 <undefined>
      5: 0x30bcea404311 ; (literal 13) 0x30bcea404311 <undefined>
      6: 0x30bcea404311 ; (literal 13) 0x30bcea404311 <undefined>
      7: 0x30bcea404311 ; (literal 13) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; (literal 13) 0x30bcea404311 <undefined>
      9: 0x35e9f8e545e9 ; rax 0x35e9f8e545e9 <an Object with map 0x33abe2a6db31>
  translating frame getDeclaredTypeOfClassOrInterface => node=30, height=48
    0x7fff5fbfd588: [top + 88] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd580: [top + 80] <- 0x38be05825489 ;  0x38be05825489 <a SymbolObject with map 0x33abe2a6dd41>  (input #2)
    0x7fff5fbfd578: [top + 72] <- 0x2c21d27ad4dc ;  caller's pc
    0x7fff5fbfd570: [top + 64] <- 0x7fff5fbfd730 ;  caller's fp
    0x7fff5fbfd568: [top + 56] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd560: [top + 48] <- 0x1030c9d3e3d1 ;  function    0x1030c9d3e3d1 <JS Function getDeclaredTypeOfClassOrInterface (SharedFunctionInfo 0x2e2f693eddd1)>  (input #0)
    0x7fff5fbfd558: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfd550: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfd548: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfd540: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfd538: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfd530: [top + 0] <- 0x35e9f8e545e9 ;  0x35e9f8e545e9 <an Object with map 0x33abe2a6db31>  (input #9)
[deoptimizing (eager): end 0x1030c9d3e3d1 <JS Function getDeclaredTypeOfClassOrInterface (SharedFunctionInfo 0x2e2f693eddd1)> @16 => node=30, pc=0x2c21d25e7689, caller sp=0x7fff5fbfd590, state=TOS_REGISTER, took 0.085 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d46859 <JS Function resolveAnonymousTypeMembers (SharedFunctionInfo 0x2e2f693ef811)> (opt #624) @15, FP to SP delta: 416, caller sp: 0x7fff5fbfd750]
            ;;; deoptimize at 0_2032: wrong map
  reading input frame resolveAnonymousTypeMembers => node=654, args=2, height=10; inputs:
      0: 0x1030c9d46859 ; [fp - 16] 0x1030c9d46859 <JS Function resolveAnonymousTypeMembers (SharedFunctionInfo 0x2e2f693ef811)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2dc1fba9b1f1 ; [fp + 16] 0x2dc1fba9b1f1 <a TypeObject with map 0x33abe2a6d1e9>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x38be05825489 ; [fp - 32] 0x38be05825489 <a SymbolObject with map 0x33abe2a6dd41>
      5: 0x3d89260f3f91 ; [fp - 48] 0x3d89260f3f91 <an Object with map 0x15b5a79120c1>
      6: 0x30bcea404311 ; (literal 17) 0x30bcea404311 <undefined>
      7: 0x30bcea4069a9 ; (literal 18) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      8: 0x30bcea404311 ; (literal 17) 0x30bcea404311 <undefined>
      9: 0x30bcea404311 ; (literal 17) 0x30bcea404311 <undefined>
     10: 0x2dc1fba9b281 ; [fp - 56] 0x2dc1fba9b281 <a TypeObject with map 0x33abe2a72fc1>
     11: 0x30bcea404311 ; (literal 17) 0x30bcea404311 <undefined>
     12: 0x1030c9d4dca9 ; rax 0x1030c9d4dca9 <JS Array[0]>
  translating frame resolveAnonymousTypeMembers => node=654, height=72
    0x7fff5fbfd748: [top + 112] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd740: [top + 104] <- 0x2dc1fba9b1f1 ;  0x2dc1fba9b1f1 <a TypeObject with map 0x33abe2a6d1e9>  (input #2)
    0x7fff5fbfd738: [top + 96] <- 0x2c21d277b9dc ;  caller's pc
    0x7fff5fbfd730: [top + 88] <- 0x7fff5fbfd858 ;  caller's fp
    0x7fff5fbfd728: [top + 80] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd720: [top + 72] <- 0x1030c9d46859 ;  function    0x1030c9d46859 <JS Function resolveAnonymousTypeMembers (SharedFunctionInfo 0x2e2f693ef811)>  (input #0)
    0x7fff5fbfd718: [top + 64] <- 0x38be05825489 ;  0x38be05825489 <a SymbolObject with map 0x33abe2a6dd41>  (input #4)
    0x7fff5fbfd710: [top + 56] <- 0x3d89260f3f91 ;  0x3d89260f3f91 <an Object with map 0x15b5a79120c1>  (input #5)
    0x7fff5fbfd708: [top + 48] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfd700: [top + 40] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #7)
    0x7fff5fbfd6f8: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfd6f0: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
    0x7fff5fbfd6e8: [top + 16] <- 0x2dc1fba9b281 ;  0x2dc1fba9b281 <a TypeObject with map 0x33abe2a72fc1>  (input #10)
    0x7fff5fbfd6e0: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #11)
    0x7fff5fbfd6d8: [top + 0] <- 0x1030c9d4dca9 ;  0x1030c9d4dca9 <JS Array[0]>  (input #12)
[deoptimizing (eager): end 0x1030c9d46859 <JS Function resolveAnonymousTypeMembers (SharedFunctionInfo 0x2e2f693ef811)> @15 => node=654, pc=0x2c21d2689973, caller sp=0x7fff5fbfd750, state=TOS_REGISTER, took 0.092 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d455f1 <JS Function isIndependentMember (SharedFunctionInfo 0x2e2f693ee851)> (opt #583) @33, FP to SP delta: 72, caller sp: 0x7fff5fbfd850]
            ;;; deoptimize at 1_32: Unknown map in polymorphic access
  reading input frame isIndependentMember => node=128, args=2, height=4; inputs:
      0: 0x1030c9d455f1 ; [fp - 16] 0x1030c9d455f1 <JS Function isIndependentMember (SharedFunctionInfo 0x2e2f693ee851)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x38be05828671 ; [fp + 16] 0x38be05828671 <a SymbolObject with map 0x33abe2a6fb29>
      3: 0x130b7e1b3d29 ; rax 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      5: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      6: 0x1030c9d45689 ; rbx 0x1030c9d45689 <JS Function isIndependentVariableLikeDeclaration (SharedFunctionInfo 0x2e2f693ee6d1)>
  reading input frame isIndependentVariableLikeDeclaration => node=3, args=2, height=1; inputs:
      0: 0x1030c9d45689 ; (literal 11) 0x1030c9d45689 <JS Function isIndependentVariableLikeDeclaration (SharedFunctionInfo 0x2e2f693ee6d1)>
      1: 0x1f9f6c0532e1 ; (literal 8) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1d75d8677409 ; rdx 0x1d75d8677409 <a NodeObject with map 0x33abe2a72519>
      3: 0x130b7e1b3d29 ; (literal 9) 0x130b7e1b3d29 <FixedArray[1022]>
  translating frame isIndependentMember => node=128, height=24
    0x7fff5fbfd848: [top + 64] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd840: [top + 56] <- 0x38be05828671 ;  0x38be05828671 <a SymbolObject with map 0x33abe2a6fb29>  (input #2)
    0x7fff5fbfd838: [top + 48] <- 0x2c21d262ec40 ;  caller's pc
    0x7fff5fbfd830: [top + 40] <- 0x7fff5fbfd898 ;  caller's fp
    0x7fff5fbfd828: [top + 32] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd820: [top + 24] <- 0x1030c9d455f1 ;  function    0x1030c9d455f1 <JS Function isIndependentMember (SharedFunctionInfo 0x2e2f693ee851)>  (input #0)
    0x7fff5fbfd818: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #4)
    0x7fff5fbfd810: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #5)
    0x7fff5fbfd808: [top + 0] <- 0x1030c9d45689 ;  0x1030c9d45689 <JS Function isIndependentVariableLikeDeclaration (SharedFunctionInfo 0x2e2f693ee6d1)>  (input #6)
  translating frame isIndependentVariableLikeDeclaration => node=3, height=0
    0x7fff5fbfd800: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd7f8: [top + 32] <- 0x1d75d8677409 ;  0x1d75d8677409 <a NodeObject with map 0x33abe2a72519>  (input #2)
    0x7fff5fbfd7f0: [top + 24] <- 0x2c21d26321b1 ;  caller's pc
    0x7fff5fbfd7e8: [top + 16] <- 0x7fff5fbfd830 ;  caller's fp
    0x7fff5fbfd7e0: [top + 8] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd7d8: [top + 0] <- 0x1030c9d45689 ;  function    0x1030c9d45689 <JS Function isIndependentVariableLikeDeclaration (SharedFunctionInfo 0x2e2f693ee6d1)>  (input #0)
[deoptimizing (eager): end 0x1030c9d455f1 <JS Function isIndependentMember (SharedFunctionInfo 0x2e2f693ee851)> @33 => node=3, pc=0x2c21d26322a6, caller sp=0x7fff5fbfd850, state=NO_REGISTERS, took 0.112 ms]
[deoptimizing (DEOPT eager): begin 0x130b7e1b68e9 <JS Function checkGrammarProperty (SharedFunctionInfo 0x1b98fbc15551)> (opt #613) @3, FP to SP delta: 136, caller sp: 0x7fff5fbfdad8]
            ;;; deoptimize at 0_44: wrong map
  reading input frame checkGrammarProperty => node=16, args=2, height=3; inputs:
      0: 0x130b7e1b68e9 ; [fp - 16] 0x130b7e1b68e9 <JS Function checkGrammarProperty (SharedFunctionInfo 0x1b98fbc15551)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1d75d8677409 ; rbx 0x1d75d8677409 <a NodeObject with map 0x33abe2a72519>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x16f3adb61821 ; [fp - 32] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
      5: 0xd6230dc8869 ; rax 0xd6230dc8869 <JS Function isClassLike (SharedFunctionInfo 0x3504a53cebd9)>
  translating frame checkGrammarProperty => node=16, height=16
    0x7fff5fbfdad0: [top + 56] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdac8: [top + 48] <- 0x1d75d8677409 ;  0x1d75d8677409 <a NodeObject with map 0x33abe2a72519>  (input #2)
    0x7fff5fbfdac0: [top + 40] <- 0x2c21d278d88e ;  caller's pc
    0x7fff5fbfdab8: [top + 32] <- 0x7fff5fbfdba0 ;  caller's fp
    0x7fff5fbfdab0: [top + 24] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdaa8: [top + 16] <- 0x130b7e1b68e9 ;  function    0x130b7e1b68e9 <JS Function checkGrammarProperty (SharedFunctionInfo 0x1b98fbc15551)>  (input #0)
    0x7fff5fbfdaa0: [top + 8] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #4)
    0x7fff5fbfda98: [top + 0] <- 0xd6230dc8869 ;  0xd6230dc8869 <JS Function isClassLike (SharedFunctionInfo 0x3504a53cebd9)>  (input #5)
[deoptimizing (eager): end 0x130b7e1b68e9 <JS Function checkGrammarProperty (SharedFunctionInfo 0x1b98fbc15551)> @3 => node=16, pc=0x2c21d26108dc, caller sp=0x7fff5fbfdad8, state=TOS_REGISTER, took 0.068 ms]
[deoptimizing (DEOPT eager): begin 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> (opt #588) @124, FP to SP delta: 200, caller sp: 0x7fff5fbfdbc0]
            ;;; deoptimize at 10_183: Unknown map in polymorphic access
  reading input frame checkSourceElement => node=197, args=2, height=5; inputs:
      0: 0x130b7e1b6059 ; [fp - 16] 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1d75d8677409 ; rbx 0x1d75d8677409 <a NodeObject with map 0x33abe2a72519>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 33) 0x30bcea404311 <undefined>
      5: 0x30bcea4069a9 ; (literal 34) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      6: 0x30bcea4069a9 ; (literal 34) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x1030c9d41f79 ; [fp - 96] 0x1030c9d41f79 <JS Function checkPropertyDeclaration (SharedFunctionInfo 0x1b98fbc0a981)>
  reading input frame checkPropertyDeclaration => node=7, args=2, height=1; inputs:
      0: 0x1030c9d41f79 ; (literal 43) 0x1030c9d41f79 <JS Function checkPropertyDeclaration (SharedFunctionInfo 0x1b98fbc0a981)>
      1: 0x1f9f6c0532e1 ; (literal 36) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1d75d8677409 ; rbx 0x1d75d8677409 <a NodeObject with map 0x33abe2a72519>
      3: 0x130b7e1b3d29 ; (literal 37) 0x130b7e1b3d29 <FixedArray[1022]>
  translating frame checkSourceElement => node=197, height=32
    0x7fff5fbfdbb8: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdbb0: [top + 64] <- 0x1d75d8677409 ;  0x1d75d8677409 <a NodeObject with map 0x33abe2a72519>  (input #2)
    0x7fff5fbfdba8: [top + 56] <- 0x2c21d2207e55 ;  caller's pc
    0x7fff5fbfdba0: [top + 48] <- 0x7fff5fbfdbd8 ;  caller's fp
    0x7fff5fbfdb98: [top + 40] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdb90: [top + 32] <- 0x130b7e1b6059 ;  function    0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>  (input #0)
    0x7fff5fbfdb88: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfdb80: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #5)
    0x7fff5fbfdb78: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfdb70: [top + 0] <- 0x1030c9d41f79 ;  0x1030c9d41f79 <JS Function checkPropertyDeclaration (SharedFunctionInfo 0x1b98fbc0a981)>  (input #7)
  translating frame checkPropertyDeclaration => node=7, height=0
    0x7fff5fbfdb68: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdb60: [top + 32] <- 0x1d75d8677409 ;  0x1d75d8677409 <a NodeObject with map 0x33abe2a72519>  (input #2)
    0x7fff5fbfdb58: [top + 24] <- 0x2c21d25ec087 ;  caller's pc
    0x7fff5fbfdb50: [top + 16] <- 0x7fff5fbfdba0 ;  caller's fp
    0x7fff5fbfdb48: [top + 8] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdb40: [top + 0] <- 0x1030c9d41f79 ;  function    0x1030c9d41f79 <JS Function checkPropertyDeclaration (SharedFunctionInfo 0x1b98fbc0a981)>  (input #0)
[deoptimizing (eager): end 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> @124 => node=7, pc=0x2c21d2610785, caller sp=0x7fff5fbfdbc0, state=NO_REGISTERS, took 0.129 ms]
[deoptimizer unlinked: checkSourceElement / 130b7e1b6059]
[deoptimizing (DEOPT lazy): begin 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> (opt #588) @23, FP to SP delta: 200, caller sp: 0x7fff5fbfdd70]
  reading input frame checkSourceElement => node=929, args=2, height=5; inputs:
      0: 0x130b7e1b6059 ; [fp - 16] 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1d75d8679f19 ; [fp + 16] 0x1d75d8679f19 <a NodeObject with map 0x33abe2a71289>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 33) 0x30bcea404311 <undefined>
      5: 0x30bcea4069a9 ; (literal 34) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      6: 0x30bcea4069a9 ; (literal 34) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x30bcea404311 ; rax 0x30bcea404311 <undefined>
  translating frame checkSourceElement => node=929, height=32
    0x7fff5fbfdd68: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdd60: [top + 64] <- 0x1d75d8679f19 ;  0x1d75d8679f19 <a NodeObject with map 0x33abe2a71289>  (input #2)
    0x7fff5fbfdd58: [top + 56] <- 0x2c21d2207e55 ;  caller's pc
    0x7fff5fbfdd50: [top + 48] <- 0x7fff5fbfdd88 ;  caller's fp
    0x7fff5fbfdd48: [top + 40] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdd40: [top + 32] <- 0x130b7e1b6059 ;  function    0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>  (input #0)
    0x7fff5fbfdd38: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfdd30: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #5)
    0x7fff5fbfdd28: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfdd20: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
[deoptimizing (lazy): end 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> @23 => node=929, pc=0x2c21d25ec764, caller sp=0x7fff5fbfdd70, state=TOS_REGISTER, took 0.064 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIndependentMember) id{627,0} ---
(symbol) {
            if (symbol.declarations && symbol.declarations.length === 1) {
                var declaration = symbol.declarations[0];
                if (declaration) {
                    switch (declaration.kind) {
                        case 147 /* PropertyDeclaration */:
                        case 146 /* PropertySignature */:
                            return isIndependentVariableLikeDeclaration(declaration);
                        case 149 /* MethodDeclaration */:
                        case 148 /* MethodSignature */:
                        case 150 /* Constructor */:
                            return isIndependentFunctionLikeDeclaration(declaration);
                    }
                }
            }
            return false;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIndependentVariableLikeDeclaration) id{627,1} ---
(node) {
            return node.type && isIndependentType(node.type) || !node.type && !node.initializer;
        }
--- END ---
INLINE (isIndependentVariableLikeDeclaration) id{627,1} AS 1 AT <0:380>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIndependentFunctionLikeDeclaration) id{627,2} ---
(node) {
            if (node.kind !== 150 /* Constructor */ && (!node.type || !isIndependentType(node.type))) {
                return false;
            }
            for (var _i = 0, _a = node.parameters; _i < _a.length; _i++) {
                var parameter = _a[_i];
                if (!isIndependentVariableLikeDeclaration(parameter)) {
                    return false;
                }
            }
            return true;
        }
--- END ---
INLINE (isIndependentFunctionLikeDeclaration) id{627,2} AS 2 AT <0:632>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isIndependentVariableLikeDeclaration) id{627,3} ---
(node) {
            return node.type && isIndependentType(node.type) || !node.type && !node.initializer;
        }
--- END ---
INLINE (isIndependentVariableLikeDeclaration) id{627,3} AS 3 AT <2:293>
[deoptimizing (DEOPT eager): begin 0x1030c9d448d9 <JS Function isSimpleTypeRelatedTo (SharedFunctionInfo 0x2e2f693f7981)> (opt #615) @8, FP to SP delta: 32, caller sp: 0x7fff5fbfcbd8]
            ;;; deoptimize at 0_410: wrong map
  reading input frame isSimpleTypeRelatedTo => node=116, args=5, height=1; inputs:
      0: 0x1030c9d448d9 ; [fp - 16] 0x1030c9d448d9 <JS Function isSimpleTypeRelatedTo (SharedFunctionInfo 0x2e2f693f7981)>
      1: 0x1f9f6c0532e1 ; [fp + 48] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1030c9d518c1 ; [fp + 40] 0x1030c9d518c1 <a TypeObject with map 0x33abe2a6cf81>
      3: 0x1030c9d51e71 ; rax 0x1030c9d51e71 <a TypeObject with map 0x33abe2a73599>
      4: 0x130b7e1b5f71 ; [fp + 24] 0x130b7e1b5f71 <an Object with map 0x33abe2a3d1a1>
      5: 0x30bcea404311 ; [fp + 16] 0x30bcea404311 <undefined>
      6: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
  translating frame isSimpleTypeRelatedTo => node=116, height=0
    0x7fff5fbfcbd0: [top + 64] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfcbc8: [top + 56] <- 0x1030c9d518c1 ;  0x1030c9d518c1 <a TypeObject with map 0x33abe2a6cf81>  (input #2)
    0x7fff5fbfcbc0: [top + 48] <- 0x1030c9d51e71 ;  0x1030c9d51e71 <a TypeObject with map 0x33abe2a73599>  (input #3)
    0x7fff5fbfcbb8: [top + 40] <- 0x130b7e1b5f71 ;  0x130b7e1b5f71 <an Object with map 0x33abe2a3d1a1>  (input #4)
    0x7fff5fbfcbb0: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfcba8: [top + 24] <- 0x2c21d27a7bc3 ;  caller's pc
    0x7fff5fbfcba0: [top + 16] <- 0x7fff5fbfcd10 ;  caller's fp
    0x7fff5fbfcb98: [top + 8] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #6)
    0x7fff5fbfcb90: [top + 0] <- 0x1030c9d448d9 ;  function    0x1030c9d448d9 <JS Function isSimpleTypeRelatedTo (SharedFunctionInfo 0x2e2f693f7981)>  (input #0)
[deoptimizing (eager): end 0x1030c9d448d9 <JS Function isSimpleTypeRelatedTo (SharedFunctionInfo 0x2e2f693f7981)> @8 => node=116, pc=0x2c21d262a6fa, caller sp=0x7fff5fbfcbd8, state=NO_REGISTERS, took 0.076 ms]
[deoptimizing (DEOPT eager): begin 0x130b7e1b5e49 <JS Function getPropertyOfType (SharedFunctionInfo 0x2e2f693f0591)> (opt #612) @22, FP to SP delta: 120, caller sp: 0x7fff5fbfca88]
            ;;; deoptimize at 0_411: wrong map
  reading input frame getPropertyOfType => node=156, args=3, height=5; inputs:
      0: 0x130b7e1b5e49 ; [fp - 16] 0x130b7e1b5e49 <JS Function getPropertyOfType (SharedFunctionInfo 0x2e2f693f0591)>
      1: 0x1f9f6c0532e1 ; [fp + 32] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1030c9d51f51 ; [fp - 48] 0x1030c9d51f51 <a TypeObject with map 0x33abe2a73599>
      3: 0x1229b1b7ff1 ; [fp + 16] 0x1229b1b7ff1 <String[5]: apply>
      4: 0x130b7e1b3d29 ; rax 0x130b7e1b3d29 <FixedArray[1022]>
      5: 0x1030c9d51f51 ; rdx 0x1030c9d51f51 <a TypeObject with map 0x33abe2a73599>
      6: 0x30bcea4069a9 ; (literal 9) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
      8: 0x1030c9d4dca9 ; rbx 0x1030c9d4dca9 <JS Array[0]>
  translating frame getPropertyOfType => node=156, height=32
    0x7fff5fbfca80: [top + 80] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfca78: [top + 72] <- 0x1030c9d51f51 ;  0x1030c9d51f51 <a TypeObject with map 0x33abe2a73599>  (input #2)
    0x7fff5fbfca70: [top + 64] <- 0x1229b1b7ff1 ;  0x1229b1b7ff1 <String[5]: apply>  (input #3)
    0x7fff5fbfca68: [top + 56] <- 0x2c21d279806b ;  caller's pc
    0x7fff5fbfca60: [top + 48] <- 0x7fff5fbfcb20 ;  caller's fp
    0x7fff5fbfca58: [top + 40] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #4)
    0x7fff5fbfca50: [top + 32] <- 0x130b7e1b5e49 ;  function    0x130b7e1b5e49 <JS Function getPropertyOfType (SharedFunctionInfo 0x2e2f693f0591)>  (input #0)
    0x7fff5fbfca48: [top + 24] <- 0x1030c9d51f51 ;  0x1030c9d51f51 <a TypeObject with map 0x33abe2a73599>  (input #5)
    0x7fff5fbfca40: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfca38: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfca30: [top + 0] <- 0x1030c9d4dca9 ;  0x1030c9d4dca9 <JS Array[0]>  (input #8)
[deoptimizing (eager): end 0x130b7e1b5e49 <JS Function getPropertyOfType (SharedFunctionInfo 0x2e2f693f0591)> @22 => node=156, pc=0x2c21d263003b, caller sp=0x7fff5fbfca88, state=TOS_REGISTER, took 0.079 ms]
[deoptimizing (DEOPT eager): begin 0x2dc1fbad4179 <JS Function propertiesRelatedTo (SharedFunctionInfo 0x130b7e106e61)> (opt #601) @22, FP to SP delta: 152, caller sp: 0x7fff5fbfcb50]
            ;;; deoptimize at 0_785: wrong map
  reading input frame propertiesRelatedTo => node=280, args=4, height=14; inputs:
      0: 0x2dc1fbad4179 ; [fp - 16] 0x2dc1fbad4179 <JS Function propertiesRelatedTo (SharedFunctionInfo 0x130b7e106e61)>
      1: 0x1f9f6c0532e1 ; [fp + 40] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1030c9d51f51 ; [fp + 32] 0x1030c9d51f51 <a TypeObject with map 0x33abe2a73599>
      3: 0x1030c9d51e71 ; [fp + 24] 0x1030c9d51e71 <a TypeObject with map 0x33abe2a73599>
      4: 0x30bcea404421 ; [fp + 16] 0x30bcea404421 <false>
      5: 0x2dc1fbad3b61 ; [fp - 24] 0x2dc1fbad3b61 <FixedArray[40]>
      6: -1 ; (int) [fp - 64] 
      7: 0x30bcea4069a9 ; (literal 10) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      8: 0x30bcea404421 ; [fp - 48] 0x30bcea404421 <false>
      9: 0 ; (int) [fp - 56] 
     10: 0x2069ac93051 ; [fp - 40] 0x2069ac93051 <JS Array[8]>
     11: 0x1b98fbcd4559 ; rbx 0x1b98fbcd4559 <a SymbolObject with map 0x33abe2a6fb29>
     12: 0x30bcea4069a9 ; (literal 10) 0x30bcea4069a9 <Odd Oddball: optimized_out>
     13: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
     14: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
     15: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
     16: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
     17: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
     18: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
  translating frame propertiesRelatedTo => node=280, height=104
    0x7fff5fbfcb48: [top + 160] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfcb40: [top + 152] <- 0x1030c9d51f51 ;  0x1030c9d51f51 <a TypeObject with map 0x33abe2a73599>  (input #2)
    0x7fff5fbfcb38: [top + 144] <- 0x1030c9d51e71 ;  0x1030c9d51e71 <a TypeObject with map 0x33abe2a73599>  (input #3)
    0x7fff5fbfcb30: [top + 136] <- 0x30bcea404421 ;  0x30bcea404421 <false>  (input #4)
    0x7fff5fbfcb28: [top + 128] <- 0x2c21d262bb12 ;  caller's pc
    0x7fff5fbfcb20: [top + 120] <- 0x7fff5fbfcba0 ;  caller's fp
    0x7fff5fbfcb18: [top + 112] <- 0x2dc1fbad3b61 ;  context    0x2dc1fbad3b61 <FixedArray[40]>  (input #5)
    0x7fff5fbfcb10: [top + 104] <- 0x2dc1fbad4179 ;  function    0x2dc1fbad4179 <JS Function propertiesRelatedTo (SharedFunctionInfo 0x130b7e106e61)>  (input #0)
    0x7fff5fbfcb08: [top + 96] <- 0xffffffff00000000 ;  -1  (input #6)
    0x7fff5fbfcb00: [top + 88] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #7)
    0x7fff5fbfcaf8: [top + 80] <- 0x30bcea404421 ;  0x30bcea404421 <false>  (input #8)
    0x7fff5fbfcaf0: [top + 72] <- 0x00000000 ;  0  (input #9)
    0x7fff5fbfcae8: [top + 64] <- 0x2069ac93051 ;  0x2069ac93051 <JS Array[8]>  (input #10)
    0x7fff5fbfcae0: [top + 56] <- 0x1b98fbcd4559 ;  0x1b98fbcd4559 <a SymbolObject with map 0x33abe2a6fb29>  (input #11)
    0x7fff5fbfcad8: [top + 48] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #12)
    0x7fff5fbfcad0: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #13)
    0x7fff5fbfcac8: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #14)
    0x7fff5fbfcac0: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #15)
    0x7fff5fbfcab8: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #16)
    0x7fff5fbfcab0: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #17)
    0x7fff5fbfcaa8: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #18)
[deoptimizing (eager): end 0x2dc1fbad4179 <JS Function propertiesRelatedTo (SharedFunctionInfo 0x130b7e106e61)> @22 => node=280, pc=0x2c21d262cfc4, caller sp=0x7fff5fbfcb50, state=NO_REGISTERS, took 0.107 ms]
[deoptimizer unlinked: propertiesRelatedTo / 2dc1fbad4179]
[deoptimizer unlinked: propertiesRelatedTo / 2dc1fbaba4b1]
[deoptimizer unlinked: propertiesRelatedTo / 2dc1fba9d069]
[deoptimizer unlinked: propertiesRelatedTo / 2dc1fba1e801]
[deoptimizer unlinked: propertiesRelatedTo / 27eeba8f6309]
[deoptimizer unlinked: propertiesRelatedTo / 27eeba8e47a9]
[deoptimizer unlinked: propertiesRelatedTo / 27eeba8c41d1]
[deoptimizer unlinked: propertiesRelatedTo / 27eeba8a0de1]
[deoptimizer unlinked: propertiesRelatedTo / 27eeba81a2b9]
[deoptimizer unlinked: propertiesRelatedTo / 27eeba80ad01]
[deoptimizer unlinked: propertiesRelatedTo / 27eeba808b11]
[deoptimizer unlinked: propertiesRelatedTo / 27eeba8056d1]
[deoptimizer unlinked: propertiesRelatedTo / 1feaa8ffaf1]
[deoptimizer unlinked: propertiesRelatedTo / 1feaa8f9951]
[deoptimizer unlinked: propertiesRelatedTo / 1feaa8f7e99]
[deoptimizer unlinked: propertiesRelatedTo / 1feaa8ef6d9]
[deoptimizer unlinked: propertiesRelatedTo / 1feaa8edd51]
[deoptimizer unlinked: propertiesRelatedTo / 1feaa8e9c49]
[deoptimizer unlinked: propertiesRelatedTo / 1feaa8e77b1]
[deoptimizer unlinked: propertiesRelatedTo / 1feaa8c7fd1]
[deoptimizer unlinked: propertiesRelatedTo / 1feaa8a9a31]
[deoptimizer unlinked: propertiesRelatedTo / 1feaa86aa09]
[deoptimizing (DEOPT eager): begin 0x2dc1fbad3dd1 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)> (opt #618) @155, FP to SP delta: 312, caller sp: 0x7fff5fbfcd48]
            ;;; deoptimize at 0_12103: wrong map
  reading input frame isRelatedTo => node=2117, args=5, height=9; inputs:
      0: 0x2dc1fbad3dd1 ; [fp - 16] 0x2dc1fbad3dd1 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)>
      1: 0x1f9f6c0532e1 ; [fp + 48] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1030c9d51e71 ; rcx 0x1030c9d51e71 <a TypeObject with map 0x33abe2a73599>
      3: 0x1030c9d518c1 ; [fp - 40] 0x1030c9d518c1 <a TypeObject with map 0x33abe2a6cf81>
      4: 0x30bcea4043b1 ; rbx 0x30bcea4043b1 <true>
      5: 0x30bcea404311 ; [fp + 16] 0x30bcea404311 <undefined>
      6: 0x2dc1fbad3b61 ; rdx 0x2dc1fbad3b61 <FixedArray[40]>
      7: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
      8: 0x30bcea4069a9 ; (literal 24) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      9: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     10: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     11: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     12: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     13: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     14: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
  translating frame isRelatedTo => node=2117, height=64
    0x7fff5fbfcd40: [top + 128] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfcd38: [top + 120] <- 0x1030c9d51e71 ;  0x1030c9d51e71 <a TypeObject with map 0x33abe2a73599>  (input #2)
    0x7fff5fbfcd30: [top + 112] <- 0x1030c9d518c1 ;  0x1030c9d518c1 <a TypeObject with map 0x33abe2a6cf81>  (input #3)
    0x7fff5fbfcd28: [top + 104] <- 0x30bcea4043b1 ;  0x30bcea4043b1 <true>  (input #4)
    0x7fff5fbfcd20: [top + 96] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfcd18: [top + 88] <- 0x2c21d2207e55 ;  caller's pc
    0x7fff5fbfcd10: [top + 80] <- 0x7fff5fbfcd60 ;  caller's fp
    0x7fff5fbfcd08: [top + 72] <- 0x2dc1fbad3b61 ;  context    0x2dc1fbad3b61 <FixedArray[40]>  (input #6)
    0x7fff5fbfcd00: [top + 64] <- 0x2dc1fbad3dd1 ;  function    0x2dc1fbad3dd1 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)>  (input #0)
    0x7fff5fbfccf8: [top + 56] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfccf0: [top + 48] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #8)
    0x7fff5fbfcce8: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
    0x7fff5fbfcce0: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #10)
    0x7fff5fbfccd8: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #11)
    0x7fff5fbfccd0: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #12)
    0x7fff5fbfccc8: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #13)
    0x7fff5fbfccc0: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #14)
[deoptimizing (eager): end 0x2dc1fbad3dd1 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)> @155 => node=2117, pc=0x2c21d262a09d, caller sp=0x7fff5fbfcd48, state=NO_REGISTERS, took 0.086 ms]
[deoptimizer unlinked: isRelatedTo / 2dc1fbad3dd1]
[deoptimizer unlinked: isRelatedTo / 2dc1fbaba109]
[deoptimizer unlinked: isRelatedTo / 2dc1fba9ccc1]
[deoptimizer unlinked: isRelatedTo / 2dc1fba1e459]
[deoptimizer unlinked: isRelatedTo / 27eeba8f5f61]
[deoptimizer unlinked: isRelatedTo / 27eeba8e4401]
[deoptimizer unlinked: isRelatedTo / 27eeba8c3e29]
[deoptimizer unlinked: isRelatedTo / 27eeba8a0a39]
[deoptimizer unlinked: isRelatedTo / 27eeba819f11]
[deoptimizing (DEOPT lazy): begin 0x2dc1fbad3dd1 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)> (opt #618) @95, FP to SP delta: 312, caller sp: 0x7fff5fbfd158]
  reading input frame isRelatedTo => node=2079, args=5, height=10; inputs:
      0: 0x2dc1fbad3dd1 ; [fp - 16] 0x2dc1fbad3dd1 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)>
      1: 0x1f9f6c0532e1 ; [fp + 48] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2dc1fbade6a9 ; [fp - 56] 0x2dc1fbade6a9 <a TypeObject with map 0x33abe2a75e81>
      3: 0x2dc1fbade801 ; [fp - 40] 0x2dc1fbade801 <a TypeObject with map 0x33abe2a75e81>
      4: 0x30bcea4043b1 ; [fp + 24] 0x30bcea4043b1 <true>
      5: 0x30bcea404311 ; [fp + 16] 0x30bcea404311 <undefined>
      6: 0x2dc1fbad3b61 ; [fp - 24] 0x2dc1fbad3b61 <FixedArray[40]>
      7: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; [fp - 64] 0x30bcea404311 <undefined>
      9: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     10: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     11: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     12: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     13: 0x30bcea4069a9 ; (literal 24) 0x30bcea4069a9 <Odd Oddball: optimized_out>
     14: 0x30bcea4069a9 ; (literal 24) 0x30bcea4069a9 <Odd Oddball: optimized_out>
     15: 0xffffffff00000000 ; rax -1
  translating frame isRelatedTo => node=2079, height=72
    0x7fff5fbfd150: [top + 136] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd148: [top + 128] <- 0x2dc1fbade6a9 ;  0x2dc1fbade6a9 <a TypeObject with map 0x33abe2a75e81>  (input #2)
    0x7fff5fbfd140: [top + 120] <- 0x2dc1fbade801 ;  0x2dc1fbade801 <a TypeObject with map 0x33abe2a75e81>  (input #3)
    0x7fff5fbfd138: [top + 112] <- 0x30bcea4043b1 ;  0x30bcea4043b1 <true>  (input #4)
    0x7fff5fbfd130: [top + 104] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfd128: [top + 96] <- 0x2c21d2207e55 ;  caller's pc
    0x7fff5fbfd120: [top + 88] <- 0x7fff5fbfd170 ;  caller's fp
    0x7fff5fbfd118: [top + 80] <- 0x2dc1fbad3b61 ;  context    0x2dc1fbad3b61 <FixedArray[40]>  (input #6)
    0x7fff5fbfd110: [top + 72] <- 0x2dc1fbad3dd1 ;  function    0x2dc1fbad3dd1 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)>  (input #0)
    0x7fff5fbfd108: [top + 64] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfd100: [top + 56] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfd0f8: [top + 48] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
    0x7fff5fbfd0f0: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #10)
    0x7fff5fbfd0e8: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #11)
    0x7fff5fbfd0e0: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #12)
    0x7fff5fbfd0d8: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #13)
    0x7fff5fbfd0d0: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #14)
    0x7fff5fbfd0c8: [top + 0] <- 0xffffffff00000000 ;  -1  (input #15)
[deoptimizing (lazy): end 0x2dc1fbad3dd1 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)> @95 => node=2079, pc=0x2c21d262a031, caller sp=0x7fff5fbfd158, state=TOS_REGISTER, took 0.093 ms]
[deoptimizing (DEOPT lazy): begin 0x2dc1fbad4179 <JS Function propertiesRelatedTo (SharedFunctionInfo 0x130b7e106e61)> (opt #601) @44, FP to SP delta: 152, caller sp: 0x7fff5fbfd268]
  reading input frame propertiesRelatedTo => node=1037, args=4, height=15; inputs:
      0: 0x2dc1fbad4179 ; [fp - 16] 0x2dc1fbad4179 <JS Function propertiesRelatedTo (SharedFunctionInfo 0x130b7e106e61)>
      1: 0x1f9f6c0532e1 ; [fp + 40] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1feaa856609 ; [fp + 32] 0x1feaa856609 <a TypeObject with map 0x33abe2a74931>
      3: 0x3d89260e87d1 ; [fp + 24] 0x3d89260e87d1 <a TypeObject with map 0x33abe2a74931>
      4: 0x30bcea4043b1 ; [fp + 16] 0x30bcea4043b1 <true>
      5: 0x2dc1fbad3b61 ; [fp - 24] 0x2dc1fbad3b61 <FixedArray[40]>
      6: -1 ; (int) [fp - 64] 
      7: 0x30bcea4069a9 ; (literal 10) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      8: 0x30bcea404421 ; [fp - 48] 0x30bcea404421 <false>
      9: 0 ; (int) [fp - 56] 
     10: 0x35e9f8ec32f1 ; [fp - 40] 0x35e9f8ec32f1 <JS Array[21]>
     11: 0x27eeba8ac2e9 ; [fp - 72] 0x27eeba8ac2e9 <a SymbolObject with map 0x33abe2a749e1>
     12: 0x2dc1fbada241 ; [fp - 80] 0x2dc1fbada241 <a SymbolObject with map 0x33abe2a749e1>
     13: 0x30bcea4069a9 ; (literal 10) 0x30bcea4069a9 <Odd Oddball: optimized_out>
     14: 0x30bcea4069a9 ; (literal 10) 0x30bcea4069a9 <Odd Oddball: optimized_out>
     15: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
     16: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
     17: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
     18: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
     19: 0xffffffff00000000 ; rax -1
  translating frame propertiesRelatedTo => node=1037, height=112
    0x7fff5fbfd260: [top + 168] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd258: [top + 160] <- 0x1feaa856609 ;  0x1feaa856609 <a TypeObject with map 0x33abe2a74931>  (input #2)
    0x7fff5fbfd250: [top + 152] <- 0x3d89260e87d1 ;  0x3d89260e87d1 <a TypeObject with map 0x33abe2a74931>  (input #3)
    0x7fff5fbfd248: [top + 144] <- 0x30bcea4043b1 ;  0x30bcea4043b1 <true>  (input #4)
    0x7fff5fbfd240: [top + 136] <- 0x2c21d262bb12 ;  caller's pc
    0x7fff5fbfd238: [top + 128] <- 0x7fff5fbfd2b8 ;  caller's fp
    0x7fff5fbfd230: [top + 120] <- 0x2dc1fbad3b61 ;  context    0x2dc1fbad3b61 <FixedArray[40]>  (input #5)
    0x7fff5fbfd228: [top + 112] <- 0x2dc1fbad4179 ;  function    0x2dc1fbad4179 <JS Function propertiesRelatedTo (SharedFunctionInfo 0x130b7e106e61)>  (input #0)
    0x7fff5fbfd220: [top + 104] <- 0xffffffff00000000 ;  -1  (input #6)
    0x7fff5fbfd218: [top + 96] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #7)
    0x7fff5fbfd210: [top + 88] <- 0x30bcea404421 ;  0x30bcea404421 <false>  (input #8)
    0x7fff5fbfd208: [top + 80] <- 0x00000000 ;  0  (input #9)
    0x7fff5fbfd200: [top + 72] <- 0x35e9f8ec32f1 ;  0x35e9f8ec32f1 <JS Array[21]>  (input #10)
    0x7fff5fbfd1f8: [top + 64] <- 0x27eeba8ac2e9 ;  0x27eeba8ac2e9 <a SymbolObject with map 0x33abe2a749e1>  (input #11)
    0x7fff5fbfd1f0: [top + 56] <- 0x2dc1fbada241 ;  0x2dc1fbada241 <a SymbolObject with map 0x33abe2a749e1>  (input #12)
    0x7fff5fbfd1e8: [top + 48] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #13)
    0x7fff5fbfd1e0: [top + 40] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #14)
    0x7fff5fbfd1d8: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #15)
    0x7fff5fbfd1d0: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #16)
    0x7fff5fbfd1c8: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #17)
    0x7fff5fbfd1c0: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #18)
    0x7fff5fbfd1b8: [top + 0] <- 0xffffffff00000000 ;  -1  (input #19)
[deoptimizing (lazy): end 0x2dc1fbad4179 <JS Function propertiesRelatedTo (SharedFunctionInfo 0x130b7e106e61)> @44 => node=1037, pc=0x2c21d262dab7, caller sp=0x7fff5fbfd268, state=TOS_REGISTER, took 0.150 ms]
[deoptimizing (DEOPT lazy): begin 0x2dc1fbad3dd1 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)> (opt #618) @95, FP to SP delta: 312, caller sp: 0x7fff5fbfd460]
  reading input frame isRelatedTo => node=2079, args=5, height=10; inputs:
      0: 0x2dc1fbad3dd1 ; [fp - 16] 0x2dc1fbad3dd1 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)>
      1: 0x1f9f6c0532e1 ; [fp + 48] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1feaa856609 ; [fp - 56] 0x1feaa856609 <a TypeObject with map 0x33abe2a74931>
      3: 0x3d89260e87d1 ; [fp - 40] 0x3d89260e87d1 <a TypeObject with map 0x33abe2a74931>
      4: 0x30bcea4043b1 ; [fp + 24] 0x30bcea4043b1 <true>
      5: 0x30bcea404311 ; [fp + 16] 0x30bcea404311 <undefined>
      6: 0x2dc1fbad3b61 ; [fp - 24] 0x2dc1fbad3b61 <FixedArray[40]>
      7: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; [fp - 64] 0x30bcea404311 <undefined>
      9: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     10: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     11: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     12: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     13: 0x30bcea4069a9 ; (literal 24) 0x30bcea4069a9 <Odd Oddball: optimized_out>
     14: 0x30bcea4069a9 ; (literal 24) 0x30bcea4069a9 <Odd Oddball: optimized_out>
     15: 0x100000000 ; rax 1
  translating frame isRelatedTo => node=2079, height=72
    0x7fff5fbfd458: [top + 136] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd450: [top + 128] <- 0x1feaa856609 ;  0x1feaa856609 <a TypeObject with map 0x33abe2a74931>  (input #2)
    0x7fff5fbfd448: [top + 120] <- 0x3d89260e87d1 ;  0x3d89260e87d1 <a TypeObject with map 0x33abe2a74931>  (input #3)
    0x7fff5fbfd440: [top + 112] <- 0x30bcea4043b1 ;  0x30bcea4043b1 <true>  (input #4)
    0x7fff5fbfd438: [top + 104] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfd430: [top + 96] <- 0x2c21d2207e55 ;  caller's pc
    0x7fff5fbfd428: [top + 88] <- 0x7fff5fbfd478 ;  caller's fp
    0x7fff5fbfd420: [top + 80] <- 0x2dc1fbad3b61 ;  context    0x2dc1fbad3b61 <FixedArray[40]>  (input #6)
    0x7fff5fbfd418: [top + 72] <- 0x2dc1fbad3dd1 ;  function    0x2dc1fbad3dd1 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)>  (input #0)
    0x7fff5fbfd410: [top + 64] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfd408: [top + 56] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfd400: [top + 48] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
    0x7fff5fbfd3f8: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #10)
    0x7fff5fbfd3f0: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #11)
    0x7fff5fbfd3e8: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #12)
    0x7fff5fbfd3e0: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #13)
    0x7fff5fbfd3d8: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #14)
    0x7fff5fbfd3d0: [top + 0] <- 0x100000000 ;  1  (input #15)
[deoptimizing (lazy): end 0x2dc1fbad3dd1 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)> @95 => node=2079, pc=0x2c21d262a031, caller sp=0x7fff5fbfd460, state=TOS_REGISTER, took 0.092 ms]
[deoptimizing (DEOPT lazy): begin 0x2dc1fbad3dd1 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)> (opt #618) @95, FP to SP delta: 312, caller sp: 0x7fff5fbfd878]
  reading input frame isRelatedTo => node=2079, args=5, height=10; inputs:
      0: 0x2dc1fbad3dd1 ; [fp - 16] 0x2dc1fbad3dd1 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)>
      1: 0x1f9f6c0532e1 ; [fp + 48] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2dc1fbad8c49 ; [fp - 56] 0x2dc1fbad8c49 <a TypeObject with map 0x33abe2a6d349>
      3: 0x2dc1fbad8cd1 ; [fp - 40] 0x2dc1fbad8cd1 <a TypeObject with map 0x33abe2a6d349>
      4: 0x30bcea4043b1 ; [fp + 24] 0x30bcea4043b1 <true>
      5: 0x30bcea404311 ; [fp + 16] 0x30bcea404311 <undefined>
      6: 0x2dc1fbad3b61 ; [fp - 24] 0x2dc1fbad3b61 <FixedArray[40]>
      7: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; [fp - 64] 0x30bcea404311 <undefined>
      9: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     10: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     11: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     12: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     13: 0x30bcea4069a9 ; (literal 24) 0x30bcea4069a9 <Odd Oddball: optimized_out>
     14: 0x30bcea4069a9 ; (literal 24) 0x30bcea4069a9 <Odd Oddball: optimized_out>
     15: 0x100000000 ; rax 1
  translating frame isRelatedTo => node=2079, height=72
    0x7fff5fbfd870: [top + 136] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd868: [top + 128] <- 0x2dc1fbad8c49 ;  0x2dc1fbad8c49 <a TypeObject with map 0x33abe2a6d349>  (input #2)
    0x7fff5fbfd860: [top + 120] <- 0x2dc1fbad8cd1 ;  0x2dc1fbad8cd1 <a TypeObject with map 0x33abe2a6d349>  (input #3)
    0x7fff5fbfd858: [top + 112] <- 0x30bcea4043b1 ;  0x30bcea4043b1 <true>  (input #4)
    0x7fff5fbfd850: [top + 104] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfd848: [top + 96] <- 0x2c21d2207e55 ;  caller's pc
    0x7fff5fbfd840: [top + 88] <- 0x7fff5fbfd890 ;  caller's fp
    0x7fff5fbfd838: [top + 80] <- 0x2dc1fbad3b61 ;  context    0x2dc1fbad3b61 <FixedArray[40]>  (input #6)
    0x7fff5fbfd830: [top + 72] <- 0x2dc1fbad3dd1 ;  function    0x2dc1fbad3dd1 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)>  (input #0)
    0x7fff5fbfd828: [top + 64] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfd820: [top + 56] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfd818: [top + 48] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
    0x7fff5fbfd810: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #10)
    0x7fff5fbfd808: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #11)
    0x7fff5fbfd800: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #12)
    0x7fff5fbfd7f8: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #13)
    0x7fff5fbfd7f0: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #14)
    0x7fff5fbfd7e8: [top + 0] <- 0x100000000 ;  1  (input #15)
[deoptimizing (lazy): end 0x2dc1fbad3dd1 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)> @95 => node=2079, pc=0x2c21d262a031, caller sp=0x7fff5fbfd878, state=TOS_REGISTER, took 0.100 ms]
[deoptimizing (DEOPT lazy): begin 0x2dc1fbad4179 <JS Function propertiesRelatedTo (SharedFunctionInfo 0x130b7e106e61)> (opt #601) @44, FP to SP delta: 152, caller sp: 0x7fff5fbfd988]
  reading input frame propertiesRelatedTo => node=1037, args=4, height=15; inputs:
      0: 0x2dc1fbad4179 ; [fp - 16] 0x2dc1fbad4179 <JS Function propertiesRelatedTo (SharedFunctionInfo 0x130b7e106e61)>
      1: 0x1f9f6c0532e1 ; [fp + 40] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2dc1fbad3a29 ; [fp + 32] 0x2dc1fbad3a29 <a TypeObject with map 0x33abe2a746c9>
      3: 0x2dc1fbad3b01 ; [fp + 24] 0x2dc1fbad3b01 <a TypeObject with map 0x33abe2a746c9>
      4: 0x30bcea4043b1 ; [fp + 16] 0x30bcea4043b1 <true>
      5: 0x2dc1fbad3b61 ; [fp - 24] 0x2dc1fbad3b61 <FixedArray[40]>
      6: -1 ; (int) [fp - 64] 
      7: 0x30bcea4069a9 ; (literal 10) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      8: 0x30bcea404421 ; [fp - 48] 0x30bcea404421 <false>
      9: 1 ; (int) [fp - 56] 
     10: 0x35e9f8ee3529 ; [fp - 40] 0x35e9f8ee3529 <JS Array[21]>
     11: 0x1030c9da4fc1 ; [fp - 72] 0x1030c9da4fc1 <a SymbolObject with map 0x33abe2a73229>
     12: 0x1030c9de9159 ; [fp - 80] 0x1030c9de9159 <a SymbolObject with map 0x33abe2a73229>
     13: 0x30bcea4069a9 ; (literal 10) 0x30bcea4069a9 <Odd Oddball: optimized_out>
     14: 0x30bcea4069a9 ; (literal 10) 0x30bcea4069a9 <Odd Oddball: optimized_out>
     15: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
     16: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
     17: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
     18: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
     19: 0x100000000 ; rax 1
  translating frame propertiesRelatedTo => node=1037, height=112
    0x7fff5fbfd980: [top + 168] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd978: [top + 160] <- 0x2dc1fbad3a29 ;  0x2dc1fbad3a29 <a TypeObject with map 0x33abe2a746c9>  (input #2)
    0x7fff5fbfd970: [top + 152] <- 0x2dc1fbad3b01 ;  0x2dc1fbad3b01 <a TypeObject with map 0x33abe2a746c9>  (input #3)
    0x7fff5fbfd968: [top + 144] <- 0x30bcea4043b1 ;  0x30bcea4043b1 <true>  (input #4)
    0x7fff5fbfd960: [top + 136] <- 0x2c21d262bb12 ;  caller's pc
    0x7fff5fbfd958: [top + 128] <- 0x7fff5fbfd9d8 ;  caller's fp
    0x7fff5fbfd950: [top + 120] <- 0x2dc1fbad3b61 ;  context    0x2dc1fbad3b61 <FixedArray[40]>  (input #5)
    0x7fff5fbfd948: [top + 112] <- 0x2dc1fbad4179 ;  function    0x2dc1fbad4179 <JS Function propertiesRelatedTo (SharedFunctionInfo 0x130b7e106e61)>  (input #0)
    0x7fff5fbfd940: [top + 104] <- 0xffffffff00000000 ;  -1  (input #6)
    0x7fff5fbfd938: [top + 96] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #7)
    0x7fff5fbfd930: [top + 88] <- 0x30bcea404421 ;  0x30bcea404421 <false>  (input #8)
    0x7fff5fbfd928: [top + 80] <- 0x100000000 ;  1  (input #9)
    0x7fff5fbfd920: [top + 72] <- 0x35e9f8ee3529 ;  0x35e9f8ee3529 <JS Array[21]>  (input #10)
    0x7fff5fbfd918: [top + 64] <- 0x1030c9da4fc1 ;  0x1030c9da4fc1 <a SymbolObject with map 0x33abe2a73229>  (input #11)
    0x7fff5fbfd910: [top + 56] <- 0x1030c9de9159 ;  0x1030c9de9159 <a SymbolObject with map 0x33abe2a73229>  (input #12)
    0x7fff5fbfd908: [top + 48] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #13)
    0x7fff5fbfd900: [top + 40] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #14)
    0x7fff5fbfd8f8: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #15)
    0x7fff5fbfd8f0: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #16)
    0x7fff5fbfd8e8: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #17)
    0x7fff5fbfd8e0: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #18)
    0x7fff5fbfd8d8: [top + 0] <- 0x100000000 ;  1  (input #19)
[deoptimizing (lazy): end 0x2dc1fbad4179 <JS Function propertiesRelatedTo (SharedFunctionInfo 0x130b7e106e61)> @44 => node=1037, pc=0x2c21d262dab7, caller sp=0x7fff5fbfd988, state=TOS_REGISTER, took 0.125 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isSymbolInScopeOfMappedTypeParameter) id{628,0} ---
(symbol, mapper) {
            if (!(symbol.declarations && symbol.declarations.length)) {
                return false;
            }
            var mappedTypes = mapper.mappedTypes;
            // Starting with the parent of the symbol's declaration, check if the mapper maps any of
            // the type parameters introduced by enclosing declarations. We just pick the first
            // declaration since multiple declarations will all have the same parent anyway.
            var node = symbol.declarations[0];
            while (node) {
                switch (node.kind) {
                    case 158 /* FunctionType */:
                    case 159 /* ConstructorType */:
                    case 225 /* FunctionDeclaration */:
                    case 149 /* MethodDeclaration */:
                    case 148 /* MethodSignature */:
                    case 150 /* Constructor */:
                    case 153 /* CallSignature */:
                    case 154 /* ConstructSignature */:
                    case 155 /* IndexSignature */:
                    case 151 /* GetAccessor */:
                    case 152 /* SetAccessor */:
                    case 184 /* FunctionExpression */:
                    case 185 /* ArrowFunction */:
                    case 226 /* ClassDeclaration */:
                    case 197 /* ClassExpression */:
                    case 227 /* InterfaceDeclaration */:
                    case 228 /* TypeAliasDeclaration */:
                        var declaration = node;
                        if (declaration.typeParameters) {
                            for (var _i = 0, _a = declaration.typeParameters; _i < _a.length; _i++) {
                                var d = _a[_i];
                                if (ts.contains(mappedTypes, getDeclaredTypeOfTypeParameter(getSymbolOfNode(d)))) {
                                    return true;
                                }
                            }
                        }
                        if (ts.isClassLike(node) || node.kind === 227 /* InterfaceDeclaration */) {
                            var thisType = getDeclaredTypeOfClassOrInterface(getSymbolOfNode(node)).thisType;
                            if (thisType && ts.contains(mappedTypes, thisType)) {
                                return true;
                            }
                        }
                        break;
                    case 274 /* JSDocFunctionType */:
                        var func = node;
                        for (var _b = 0, _c = func.parameters; _b < _c.length; _b++) {
                            var p = _c[_b];
                            if (ts.contains(mappedTypes, getTypeOfNode(p))) {
                                return true;
                            }
                        }
                        break;
                    case 230 /* ModuleDeclaration */:
                    case 261 /* SourceFile */:
                        return false;
                }
                node = node.parent;
            }
            return false;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{628,1} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{628,1} AS 1 AT <0:1821>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{628,2} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{628,2} AS 2 AT <1:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getDeclaredTypeOfTypeParameter) id{628,3} ---
(symbol) {
            var links = getSymbolLinks(symbol);
            if (!links.declaredType) {
                var type = createType(16384 /* TypeParameter */);
                type.symbol = symbol;
                if (!ts.getDeclarationOfKind(symbol, 143 /* TypeParameter */).constraint) {
                    type.constraint = noConstraintType;
                }
                links.declaredType = type;
            }
            return links.declaredType;
        }
--- END ---
INLINE (getDeclaredTypeOfTypeParameter) id{628,3} AS 3 AT <0:1790>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{628,4} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{628,4} AS 4 AT <3:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{628,5} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{628,5} AS 5 AT <4:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{628,6} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{628,6} AS 6 AT <3:125>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{628,7} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{628,7} AS 7 AT <6:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{628,8} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{628,8} AS 8 AT <0:2161>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{628,9} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{628,9} AS 9 AT <8:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isRelatedTo) id{629,0} ---
(source, target, reportErrors, headMessage) {
                var result;
                if (source.flags & 96 /* StringOrNumberLiteral */ && source.flags & 1048576 /* FreshLiteral */) {
                    source = source.regularType;
                }
                if (target.flags & 96 /* StringOrNumberLiteral */ && target.flags & 1048576 /* FreshLiteral */) {
                    target = target.regularType;
                }
                // both types are the same - covers 'they are the same primitive type or both are Any' or the same type parameter cases
                if (source === target)
                    return -1 /* True */;
                if (relation === identityRelation) {
                    return isIdenticalTo(source, target);
                }
                if (isSimpleTypeRelatedTo(source, target, relation, reportErrors ? reportError : undefined))
                    return -1 /* True */;
                if (getObjectFlags(source) & 128 /* ObjectLiteral */ && source.flags & 1048576 /* FreshLiteral */) {
                    if (hasExcessProperties(source, target, reportErrors)) {
                        if (reportErrors) {
                            reportRelationError(headMessage, source, target);
                        }
                        return 0 /* False */;
                    }
                    // Above we check for excess properties with respect to the entire target type. When union
                    // and intersection types are further deconstructed on the target side, we don't want to
                    // make the check again (as it might fail for a partial target type). Therefore we obtain
                    // the regular source type and proceed with that.
                    if (isUnionOrIntersectionTypeWithoutNullableConstituents(target)) {
                        source = getRegularTypeOfObjectLiteral(source);
                    }
                }
                var saveErrorInfo = errorInfo;
                // Note that these checks are specifically ordered to produce correct results. In particular,
                // we need to deconstruct unions before intersections (because unions are always at the top),
                // and we need to handle "each" relations before "some" relations for the same kind of type.
                if (source.flags & 65536 /* Union */) {
                    if (relation === comparableRelation) {
                        result = someTypeRelatedToType(source, target, reportErrors && !(source.flags & 8190 /* Primitive */));
                    }
                    else {
                        result = eachTypeRelatedToType(source, target, reportErrors && !(source.flags & 8190 /* Primitive */));
                    }
                    if (result) {
                        return result;
                    }
                }
                else if (target.flags & 65536 /* Union */) {
                    if (result = typeRelatedToSomeType(source, target, reportErrors && !(source.flags & 8190 /* Primitive */) && !(target.flags & 8190 /* Primitive */))) {
                        return result;
                    }
                }
                else if (target.flags & 131072 /* Intersection */) {
                    if (result = typeRelatedToEachType(source, target, reportErrors)) {
                        return result;
                    }
                }
                else if (source.flags & 131072 /* Intersection */) {
                    // Check to see if any constituents of the intersection are immediately related to the target.
                    //
                    // Don't report errors though. Checking whether a constituent is related to the source is not actually
                    // useful and leads to some confusing error messages. Instead it is better to let the below checks
                    // take care of this, or to not elaborate at all. For instance,
                    //
                    //    - For an object type (such as 'C = A & B'), users are usually more interested in structural errors.
                    //
                    //    - For a union type (such as '(A | B) = (C & D)'), it's better to hold onto the whole intersection
                    //          than to report that 'D' is not assignable to 'A' or 'B'.
                    //
                    //    - For a primitive type or type parameter (such as 'number = A & B') there is no point in
                    //          breaking the intersection apart.
                    if (result = someTypeRelatedToType(source, target, /*reportErrors*/ false)) {
                        return result;
                    }
                }
                else if (target.flags & 16384 /* TypeParameter */) {
                    // A source type { [P in keyof T]: X } is related to a target type T if X is related to T[P].
                    if (getObjectFlags(source) & 32 /* Mapped */ && getConstraintTypeFromMappedType(source) === getIndexType(target)) {
                        if (!source.declaration.questionToken) {
                            var templateType = getTemplateTypeFromMappedType(source);
                            var indexedAccessType = getIndexedAccessType(target, getTypeParameterFromMappedType(source));
                            if (result = isRelatedTo(templateType, indexedAccessType, reportErrors)) {
                                return result;
                            }
                        }
                    }
                    else {
                        // Given a type parameter K with a constraint keyof T, a type S is
                        // assignable to K if S is assignable to keyof T.
                        var constraint = getConstraintOfTypeParameter(target);
                        if (constraint && constraint.flags & 262144 /* Index */) {
                            if (result = isRelatedTo(source, constraint, reportErrors)) {
                                return result;
                            }
                        }
                    }
                }
                else if (target.flags & 262144 /* Index */) {
                    // A keyof S is related to a keyof T if T is related to S.
                    if (source.flags & 262144 /* Index */) {
                        if (result = isRelatedTo(target.type, source.type, /*reportErrors*/ false)) {
                            return result;
                        }
                    }
                    // Given a type variable T with a constraint C, a type S is assignable to
                    // keyof T if S is assignable to keyof C.
                    if (target.type.flags & 540672 /* TypeVariable */) {
                        var constraint = getConstraintOfTypeVariable(target.type);
                        if (constraint) {
                            if (result = isRelatedTo(source, getIndexType(constraint), reportErrors)) {
                                return result;
                            }
                        }
                    }
                }
                else if (target.flags & 524288 /* IndexedAccess */) {
                    // if we have indexed access types with identical index types, see if relationship holds for
                    // the two object types.
                    if (source.flags & 524288 /* IndexedAccess */ && source.indexType === target.indexType) {
                        if (result = isRelatedTo(source.objectType, target.objectType, reportErrors)) {
                            return result;
                        }
                    }
                    // A type S is related to a type T[K] if S is related to A[K], where K is string-like and
                    // A is the apparent type of S.
                    if (target.constraint) {
                        if (result = isRelatedTo(source, target.constraint, reportErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                }
                if (source.flags & 16384 /* TypeParameter */) {
                    // A source type T is related to a target type { [P in keyof T]: X } if T[P] is related to X.
                    if (getObjectFlags(target) & 32 /* Mapped */ && getConstraintTypeFromMappedType(target) === getIndexType(source)) {
                        var indexedAccessType = getIndexedAccessType(source, getTypeParameterFromMappedType(target));
                        var templateType = getTemplateTypeFromMappedType(target);
                        if (result = isRelatedTo(indexedAccessType, templateType, reportErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                    else {
                        var constraint = getConstraintOfTypeParameter(source);
                        if (!constraint || constraint.flags & 1 /* Any */) {
                            constraint = emptyObjectType;
                        }
                        // The constraint may need to be further instantiated with its 'this' type.
                        constraint = getTypeWithThisArgument(constraint, source);
                        // Report constraint errors only if the constraint is not the empty object type
                        var reportConstraintErrors = reportErrors && constraint !== emptyObjectType;
                        if (result = isRelatedTo(constraint, target, reportConstraintErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                }
                else if (source.flags & 524288 /* IndexedAccess */) {
                    // A type S[K] is related to a type T if A[K] is related to T, where K is string-like and
                    // A is the apparent type of S.
                    if (source.constraint) {
                        if (result = isRelatedTo(source.constraint, target, reportErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                }
                else {
                    if (getObjectFlags(source) & 4 /* Reference */ && getObjectFlags(target) & 4 /* Reference */ && source.target === target.target) {
                        // We have type references to same target type, see if relationship holds for all type arguments
                        if (result = typeArgumentsRelatedTo(source, target, reportErrors)) {
                            return result;
                        }
                    }
                    // Even if relationship doesn't hold for unions, intersections, or generic type references,
                    // it may hold in a structural comparison.
                    var apparentSource = getApparentType(source);
                    // In a check of the form X = A & B, we will have previously checked if A relates to X or B relates
                    // to X. Failing both of those we want to check if the aggregation of A and B's members structurally
                    // relates to X. Thus, we include intersection types on the source side here.
                    if (apparentSource.flags & (32768 /* Object */ | 131072 /* Intersection */) && target.flags & 32768 /* Object */) {
                        // Report structural errors only if we haven't reported any errors yet
                        var reportStructuralErrors = reportErrors && errorInfo === saveErrorInfo && !(source.flags & 8190 /* Primitive */);
                        if (result = objectTypeRelatedTo(apparentSource, source, target, reportStructuralErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                }
                if (reportErrors) {
                    if (source.flags & 32768 /* Object */ && target.flags & 8190 /* Primitive */) {
                        tryElaborateErrorsForPrimitivesAndObjects(source, target);
                    }
                    else if (source.symbol && source.flags & 32768 /* Object */ && globalObjectType === source) {
                        reportError(ts.Diagnostics.The_Object_type_is_assignable_to_very_few_other_types_Did_you_mean_to_use_the_any_type_instead);
                    }
                    reportRelationError(headMessage, source, target);
                }
                return 0 /* False */;
            }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{629,1} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{629,1} AS 1 AT <0:953>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{629,2} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{629,2} AS 2 AT <0:4927>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getConstraintOfTypeVariable) id{629,3} ---
(type) {
            return type.flags & 16384 /* TypeParameter */ ? getConstraintOfTypeParameter(type) :
                type.flags & 524288 /* IndexedAccess */ ? type.constraint :
                    undefined;
        }
--- END ---
INLINE (getConstraintOfTypeVariable) id{629,3} AS 3 AT <0:6792>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{629,4} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{629,4} AS 4 AT <0:8322>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeWithThisArgument) id{629,5} ---
(type, thisArgument) {
            if (getObjectFlags(type) & 4 /* Reference */) {
                return createTypeReference(type.target, ts.concatenate(type.typeArguments, [thisArgument || type.target.thisType]));
            }
            return type;
        }
--- END ---
INLINE (getTypeWithThisArgument) id{629,5} AS 5 AT <0:9283>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{629,6} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{629,6} AS 6 AT <5:39>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createTypeReference) id{629,7} ---
(target, typeArguments) {
            var id = getTypeListId(typeArguments);
            var type = target.instantiations[id];
            if (!type) {
                type = target.instantiations[id] = createObjectType(4 /* Reference */, target.symbol);
                type.flags |= typeArguments ? getPropagatingFlagsOfTypes(typeArguments, /*excludeKinds*/ 0) : 0;
                type.target = target;
                type.typeArguments = typeArguments;
            }
            return type;
        }
--- END ---
INLINE (createTypeReference) id{629,7} AS 7 AT <5:106>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createObjectType) id{629,8} ---
(objectFlags, symbol) {
            var type = createType(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol = symbol;
            return type;
        }
--- END ---
INLINE (createObjectType) id{629,8} AS 8 AT <7:203>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{629,9} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{629,9} AS 9 AT <8:47>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{629,10} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{629,10} AS 10 AT <9:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropagatingFlagsOfTypes) id{629,11} ---
(types, excludeKinds) {
            var result = 0;
            for (var _i = 0, types_3 = types; _i < types_3.length; _i++) {
                var type = types_3[_i];
                if (!(type.flags & excludeKinds)) {
                    result |= type.flags;
                }
            }
            return result & 14680064 /* PropagatingFlags */;
        }
--- END ---
INLINE (getPropagatingFlagsOfTypes) id{629,11} AS 11 AT <7:301>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{629,12} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{629,12} AS 12 AT <0:10374>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{629,13} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
INLINE (getObjectFlags) id{629,13} AS 13 AT <0:10420>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getApparentType) id{629,14} ---
(type) {
            var t = type.flags & 540672 /* TypeVariable */ ? getApparentTypeOfTypeVariable(type) : type;
            return t.flags & 262178 /* StringLike */ ? globalStringType :
                t.flags & 340 /* NumberLike */ ? globalNumberType :
                    t.flags & 136 /* BooleanLike */ ? globalBooleanType :
                        t.flags & 512 /* ESSymbol */ ? getGlobalESSymbolType() :
                            t;
        }
--- END ---
INLINE (getApparentType) id{629,14} AS 14 AT <0:11022>
[deoptimizing (DEOPT lazy): begin 0x2dc1fbad3dd1 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)> (opt #618) @95, FP to SP delta: 312, caller sp: 0x7fff5fbfdb80]
  reading input frame isRelatedTo => node=2079, args=5, height=10; inputs:
      0: 0x2dc1fbad3dd1 ; [fp - 16] 0x2dc1fbad3dd1 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)>
      1: 0x1f9f6c0532e1 ; [fp + 48] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2dc1fbad3a29 ; [fp - 56] 0x2dc1fbad3a29 <a TypeObject with map 0x33abe2a746c9>
      3: 0x2dc1fbad3b01 ; [fp - 40] 0x2dc1fbad3b01 <a TypeObject with map 0x33abe2a746c9>
      4: 0x30bcea4043b1 ; [fp + 24] 0x30bcea4043b1 <true>
      5: 0xd6230df7599 ; [fp + 16] 0xd6230df7599 <an Object with map 0x33abe2a3df61>
      6: 0x2dc1fbad3b61 ; [fp - 24] 0x2dc1fbad3b61 <FixedArray[40]>
      7: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; [fp - 64] 0x30bcea404311 <undefined>
      9: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     10: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     11: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     12: 0x30bcea404311 ; (literal 19) 0x30bcea404311 <undefined>
     13: 0x30bcea4069a9 ; (literal 24) 0x30bcea4069a9 <Odd Oddball: optimized_out>
     14: 0x30bcea4069a9 ; (literal 24) 0x30bcea4069a9 <Odd Oddball: optimized_out>
     15: 0x100000000 ; rax 1
  translating frame isRelatedTo => node=2079, height=72
    0x7fff5fbfdb78: [top + 136] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdb70: [top + 128] <- 0x2dc1fbad3a29 ;  0x2dc1fbad3a29 <a TypeObject with map 0x33abe2a746c9>  (input #2)
    0x7fff5fbfdb68: [top + 120] <- 0x2dc1fbad3b01 ;  0x2dc1fbad3b01 <a TypeObject with map 0x33abe2a746c9>  (input #3)
    0x7fff5fbfdb60: [top + 112] <- 0x30bcea4043b1 ;  0x30bcea4043b1 <true>  (input #4)
    0x7fff5fbfdb58: [top + 104] <- 0xd6230df7599 ;  0xd6230df7599 <an Object with map 0x33abe2a3df61>  (input #5)
    0x7fff5fbfdb50: [top + 96] <- 0x2c21d2649a8d ;  caller's pc
    0x7fff5fbfdb48: [top + 88] <- 0x7fff5fbfdbc0 ;  caller's fp
    0x7fff5fbfdb40: [top + 80] <- 0x2dc1fbad3b61 ;  context    0x2dc1fbad3b61 <FixedArray[40]>  (input #6)
    0x7fff5fbfdb38: [top + 72] <- 0x2dc1fbad3dd1 ;  function    0x2dc1fbad3dd1 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)>  (input #0)
    0x7fff5fbfdb30: [top + 64] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfdb28: [top + 56] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfdb20: [top + 48] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #9)
    0x7fff5fbfdb18: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #10)
    0x7fff5fbfdb10: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #11)
    0x7fff5fbfdb08: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #12)
    0x7fff5fbfdb00: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #13)
    0x7fff5fbfdaf8: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #14)
    0x7fff5fbfdaf0: [top + 0] <- 0x100000000 ;  1  (input #15)
[deoptimizing (lazy): end 0x2dc1fbad3dd1 <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)> @95 => node=2079, pc=0x2c21d262a031, caller sp=0x7fff5fbfdb80, state=TOS_REGISTER, took 0.095 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkSourceElement) id{630,0} ---
(node) {
            if (!node) {
                return;
            }
            var kind = node.kind;
            if (cancellationToken) {
                // Only bother checking on a few construct kinds.  We don't want to be excessively
                // hitting the cancellation token on every node we check.
                switch (kind) {
                    case 230 /* ModuleDeclaration */:
                    case 226 /* ClassDeclaration */:
                    case 227 /* InterfaceDeclaration */:
                    case 225 /* FunctionDeclaration */:
                        cancellationToken.throwIfCancellationRequested();
                }
            }
            switch (kind) {
                case 143 /* TypeParameter */:
                    return checkTypeParameter(node);
                case 144 /* Parameter */:
                    return checkParameter(node);
                case 147 /* PropertyDeclaration */:
                case 146 /* PropertySignature */:
                    return checkPropertyDeclaration(node);
                case 158 /* FunctionType */:
                case 159 /* ConstructorType */:
                case 153 /* CallSignature */:
                case 154 /* ConstructSignature */:
                    return checkSignatureDeclaration(node);
                case 155 /* IndexSignature */:
                    return checkSignatureDeclaration(node);
                case 149 /* MethodDeclaration */:
                case 148 /* MethodSignature */:
                    return checkMethodDeclaration(node);
                case 150 /* Constructor */:
                    return checkConstructorDeclaration(node);
                case 151 /* GetAccessor */:
                case 152 /* SetAccessor */:
                    return checkAccessorDeclaration(node);
                case 157 /* TypeReference */:
                    return checkTypeReferenceNode(node);
                case 156 /* TypePredicate */:
                    return checkTypePredicate(node);
                case 160 /* TypeQuery */:
                    return checkTypeQuery(node);
                case 161 /* TypeLiteral */:
                    return checkTypeLiteral(node);
                case 162 /* ArrayType */:
                    return checkArrayType(node);
                case 163 /* TupleType */:
                    return checkTupleType(node);
                case 164 /* UnionType */:
                case 165 /* IntersectionType */:
                    return checkUnionOrIntersectionType(node);
                case 166 /* ParenthesizedType */:
                case 168 /* TypeOperator */:
                    return checkSourceElement(node.type);
                case 169 /* IndexedAccessType */:
                    return checkIndexedAccessType(node);
                case 170 /* MappedType */:
                    return checkMappedType(node);
                case 225 /* FunctionDeclaration */:
                    return checkFunctionDeclaration(node);
                case 204 /* Block */:
                case 231 /* ModuleBlock */:
                    return checkBlock(node);
                case 205 /* VariableStatement */:
                    return checkVariableStatement(node);
                case 207 /* ExpressionStatement */:
                    return checkExpressionStatement(node);
                case 208 /* IfStatement */:
                    return checkIfStatement(node);
                case 209 /* DoStatement */:
                    return checkDoStatement(node);
                case 210 /* WhileStatement */:
                    return checkWhileStatement(node);
                case 211 /* ForStatement */:
                    return checkForStatement(node);
                case 212 /* ForInStatement */:
                    return checkForInStatement(node);
                case 213 /* ForOfStatement */:
                    return checkForOfStatement(node);
                case 214 /* ContinueStatement */:
                case 215 /* BreakStatement */:
                    return checkBreakOrContinueStatement(node);
                case 216 /* ReturnStatement */:
                    return checkReturnStatement(node);
                case 217 /* WithStatement */:
                    return checkWithStatement(node);
                case 218 /* SwitchStatement */:
                    return checkSwitchStatement(node);
                case 219 /* LabeledStatement */:
                    return checkLabeledStatement(node);
                case 220 /* ThrowStatement */:
                    return checkThrowStatement(node);
                case 221 /* TryStatement */:
                    return checkTryStatement(node);
                case 223 /* VariableDeclaration */:
                    return checkVariableDeclaration(node);
                case 174 /* BindingElement */:
                    return checkBindingElement(node);
                case 226 /* ClassDeclaration */:
                    return checkClassDeclaration(node);
                case 227 /* InterfaceDeclaration */:
                    return checkInterfaceDeclaration(node);
                case 228 /* TypeAliasDeclaration */:
                    return checkTypeAliasDeclaration(node);
                case 229 /* EnumDeclaration */:
                    return checkEnumDeclaration(node);
                case 230 /* ModuleDeclaration */:
                    return checkModuleDeclaration(node);
                case 235 /* ImportDeclaration */:
                    return checkImportDeclaration(node);
                case 234 /* ImportEqualsDeclaration */:
                    return checkImportEqualsDeclaration(node);
                case 241 /* ExportDeclaration */:
                    return checkExportDeclaration(node);
                case 240 /* ExportAssignment */:
                    return checkExportAssignment(node);
                case 206 /* EmptyStatement */:
                    checkGrammarStatementInAmbientContext(node);
                    return;
                case 222 /* DebuggerStatement */:
                    checkGrammarStatementInAmbientContext(node);
                    return;
                case 244 /* MissingDeclaration */:
                    return checkMissingDeclaration(node);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkTypeParameter) id{630,1} ---
(node) {
            // Grammar Checking
            if (node.expression) {
                grammarErrorOnFirstToken(node.expression, ts.Diagnostics.Type_expected);
            }
            checkSourceElement(node.constraint);
            getConstraintOfTypeParameter(getDeclaredTypeOfTypeParameter(getSymbolOfNode(node)));
            if (produceDiagnostics) {
                checkTypeNameIsReserved(node.name, ts.Diagnostics.Type_parameter_name_cannot_be_0);
            }
        }
--- END ---
INLINE (checkTypeParameter) id{630,1} AS 1 AT <0:775>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{630,2} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{630,2} AS 2 AT <1:300>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{630,3} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{630,3} AS 3 AT <2:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getDeclaredTypeOfTypeParameter) id{630,4} ---
(symbol) {
            var links = getSymbolLinks(symbol);
            if (!links.declaredType) {
                var type = createType(16384 /* TypeParameter */);
                type.symbol = symbol;
                if (!ts.getDeclarationOfKind(symbol, 143 /* TypeParameter */).constraint) {
                    type.constraint = noConstraintType;
                }
                links.declaredType = type;
            }
            return links.declaredType;
        }
--- END ---
INLINE (getDeclaredTypeOfTypeParameter) id{630,4} AS 4 AT <1:269>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{630,5} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{630,5} AS 5 AT <4:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{630,6} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{630,6} AS 6 AT <5:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{630,7} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{630,7} AS 7 AT <4:125>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{630,8} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{630,8} AS 8 AT <7:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkTypeNameIsReserved) id{630,9} ---
(name, message) {
            // TS 1.0 spec (April 2014): 3.6.1
            // The predefined type keywords are reserved and cannot be used as names of user defined types.
            switch (name.text) {
                case "any":
                case "number":
                case "boolean":
                case "string":
                case "symbol":
                case "void":
                    error(name, message, name.text);
            }
        }
--- END ---
INLINE (checkTypeNameIsReserved) id{630,9} AS 9 AT <1:379>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkPropertyDeclaration) id{630,10} ---
(node) {
            // Grammar checking
            checkGrammarDecorators(node) || checkGrammarModifiers(node) || checkGrammarProperty(node) || checkGrammarComputedPropertyName(node.name);
            checkVariableLikeDeclaration(node);
        }
--- END ---
INLINE (checkPropertyDeclaration) id{630,10} AS 10 AT <0:1021>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarComputedPropertyName) id{630,11} ---
(node) {
            // If node is not a computedPropertyName, just skip the grammar checking
            if (node.kind !== 142 /* ComputedPropertyName */) {
                return false;
            }
            var computedPropertyName = node;
            if (computedPropertyName.expression.kind === 192 /* BinaryExpression */ && computedPropertyName.expression.operatorToken.kind === 25 /* CommaToken */) {
                return grammarErrorOnNode(computedPropertyName.expression, ts.Diagnostics.A_comma_expression_is_not_allowed_in_a_computed_property_name);
            }
        }
--- END ---
INLINE (checkGrammarComputedPropertyName) id{630,11} AS 11 AT <10:146>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkTypeQuery) id{630,12} ---
(node) {
            getTypeFromTypeQueryNode(node);
        }
--- END ---
INLINE (checkTypeQuery) id{630,12} AS 12 AT <0:2089>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeFromTypeQueryNode) id{630,13} ---
(node) {
            var links = getNodeLinks(node);
            if (!links.resolvedType) {
                // TypeScript 1.0 spec (April 2014): 3.6.3
                // The expression is processed as an identifier expression (section 4.3)
                // or property access expression(section 4.10),
                // the widened type(section 3.9) of which becomes the result.
                links.resolvedType = getWidenedType(checkExpression(node.exprName));
            }
            return links.resolvedType;
        }
--- END ---
INLINE (getTypeFromTypeQueryNode) id{630,13} AS 13 AT <12:21>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeLinks) id{630,14} ---
(node) {
            var nodeId = getNodeId(node);
            return nodeLinks[nodeId] || (nodeLinks[nodeId] = { flags: 0 });
        }
--- END ---
INLINE (getNodeLinks) id{630,14} AS 14 AT <13:33>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeId) id{630,15} ---
(node) {
        if (!node.id) {
            node.id = nextNodeId;
            nextNodeId++;
        }
        return node.id;
    }
--- END ---
INLINE (getNodeId) id{630,15} AS 15 AT <14:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkTypeLiteral) id{630,16} ---
(node) {
            ts.forEach(node.members, checkSourceElement);
            if (produceDiagnostics) {
                var type = getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode(node);
                checkIndexConstraints(type);
                checkTypeForDuplicateIndexSignatures(node);
                checkObjectTypeForDuplicateDeclarations(node);
            }
        }
--- END ---
INLINE (checkTypeLiteral) id{630,16} AS 16 AT <0:2182>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isAmbientModule) id{631,0} ---
(node) {
        return node && node.kind === 230 /* ModuleDeclaration */ &&
            (node.name.kind === 9 /* StringLiteral */ || isGlobalScopeAugmentation(node));
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isGlobalScopeAugmentation) id{631,1} ---
(module) {
        return !!(module.flags & 512 /* GlobalAugmentation */);
    }
--- END ---
INLINE (isGlobalScopeAugmentation) id{631,1} AS 1 AT <0:134>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropertyOfType) id{632,0} ---
(type, name) {
            type = getApparentType(type);
            if (type.flags & 32768 /* Object */) {
                var resolved = resolveStructuredTypeMembers(type);
                var symbol = resolved.members[name];
                if (symbol && symbolIsValue(symbol)) {
                    return symbol;
                }
                if (resolved === anyFunctionType || resolved.callSignatures.length || resolved.constructSignatures.length) {
                    var symbol_1 = getPropertyOfObjectType(globalFunctionType, name);
                    if (symbol_1) {
                        return symbol_1;
                    }
                }
                return getPropertyOfObjectType(globalObjectType, name);
            }
            if (type.flags & 196608 /* UnionOrIntersection */) {
                return getPropertyOfUnionOrIntersectionType(type, name);
            }
            return undefined;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getApparentType) id{632,1} ---
(type) {
            var t = type.flags & 540672 /* TypeVariable */ ? getApparentTypeOfTypeVariable(type) : type;
            return t.flags & 262178 /* StringLike */ ? globalStringType :
                t.flags & 340 /* NumberLike */ ? globalNumberType :
                    t.flags & 136 /* BooleanLike */ ? globalBooleanType :
                        t.flags & 512 /* ESSymbol */ ? getGlobalESSymbolType() :
                            t;
        }
--- END ---
INLINE (getApparentType) id{632,1} AS 1 AT <0:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropertyOfObjectType) id{632,2} ---
(type, name) {
            if (type.flags & 32768 /* Object */) {
                var resolved = resolveStructuredTypeMembers(type);
                var symbol = resolved.members[name];
                if (symbol && symbolIsValue(symbol)) {
                    return symbol;
                }
            }
        }
--- END ---
INLINE (getPropertyOfObjectType) id{632,2} AS 2 AT <0:496>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropertyOfObjectType) id{632,3} ---
(type, name) {
            if (type.flags & 32768 /* Object */) {
                var resolved = resolveStructuredTypeMembers(type);
                var symbol = resolved.members[name];
                if (symbol && symbolIsValue(symbol)) {
                    return symbol;
                }
            }
        }
--- END ---
INLINE (getPropertyOfObjectType) id{632,3} AS 3 AT <0:687>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createInstantiatedSymbolTable) id{633,0} ---
(symbols, mapper, mappingThisOnly) {
            var result = ts.createMap();
            for (var _i = 0, symbols_2 = symbols; _i < symbols_2.length; _i++) {
                var symbol = symbols_2[_i];
                result[symbol.name] = mappingThisOnly && isIndependentMember(symbol) ? symbol : instantiateSymbol(symbol, mapper);
            }
            return result;
        }
--- END ---
[deoptimizing (DEOPT lazy): begin 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> (opt #588) @44, FP to SP delta: 200, caller sp: 0x7fff5fbfdf20]
  reading input frame checkSourceElement => node=580, args=2, height=5; inputs:
      0: 0x130b7e1b6059 ; [fp - 16] 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1d75d865e259 ; [fp + 16] 0x1d75d865e259 <a NodeObject with map 0x33abe2a71b79>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 33) 0x30bcea404311 <undefined>
      5: 0x30bcea4069a9 ; (literal 34) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      6: 0x30bcea4069a9 ; (literal 34) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x30bcea404311 ; rax 0x30bcea404311 <undefined>
  translating frame checkSourceElement => node=580, height=32
    0x7fff5fbfdf18: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdf10: [top + 64] <- 0x1d75d865e259 ;  0x1d75d865e259 <a NodeObject with map 0x33abe2a71b79>  (input #2)
    0x7fff5fbfdf08: [top + 56] <- 0x2c21d268616c ;  caller's pc
    0x7fff5fbfdf00: [top + 48] <- 0x7fff5fbfdf90 ;  caller's fp
    0x7fff5fbfdef8: [top + 40] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdef0: [top + 32] <- 0x130b7e1b6059 ;  function    0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>  (input #0)
    0x7fff5fbfdee8: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfdee0: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #5)
    0x7fff5fbfded8: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfded0: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
[deoptimizing (lazy): end 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> @44 => node=580, pc=0x2c21d25ec3f2, caller sp=0x7fff5fbfdf20, state=TOS_REGISTER, took 0.074 ms]
[deoptimizing (DEOPT lazy): begin 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> (opt #588) @16, FP to SP delta: 200, caller sp: 0x7fff5fbfe098]
  reading input frame checkSourceElement => node=1005, args=2, height=5; inputs:
      0: 0x130b7e1b6059 ; [fp - 16] 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1d75d865b149 ; [fp + 16] 0x1d75d865b149 <a NodeObject with map 0x33abe2a71231>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 33) 0x30bcea404311 <undefined>
      5: 0x30bcea4069a9 ; (literal 34) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      6: 0x30bcea4069a9 ; (literal 34) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x30bcea404311 ; rax 0x30bcea404311 <undefined>
  translating frame checkSourceElement => node=1005, height=32
    0x7fff5fbfe090: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfe088: [top + 64] <- 0x1d75d865b149 ;  0x1d75d865b149 <a NodeObject with map 0x33abe2a71231>  (input #2)
    0x7fff5fbfe080: [top + 56] <- 0x2c21d2207e55 ;  caller's pc
    0x7fff5fbfe078: [top + 48] <- 0x7fff5fbfe0b0 ;  caller's fp
    0x7fff5fbfe070: [top + 40] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfe068: [top + 32] <- 0x130b7e1b6059 ;  function    0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>  (input #0)
    0x7fff5fbfe060: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfe058: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #5)
    0x7fff5fbfe050: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfe048: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
[deoptimizing (lazy): end 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> @16 => node=1005, pc=0x2c21d25ec828, caller sp=0x7fff5fbfe098, state=TOS_REGISTER, took 0.054 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeFromUnionTypeNode) id{634,0} ---
(node) {
            var links = getNodeLinks(node);
            if (!links.resolvedType) {
                links.resolvedType = getUnionType(ts.map(node.types, getTypeFromTypeNode), /*subtypeReduction*/ false, getAliasSymbolForTypeNode(node), getAliasTypeArgumentsForTypeNode(node));
            }
            return links.resolvedType;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeLinks) id{634,1} ---
(node) {
            var nodeId = getNodeId(node);
            return nodeLinks[nodeId] || (nodeLinks[nodeId] = { flags: 0 });
        }
--- END ---
INLINE (getNodeLinks) id{634,1} AS 1 AT <0:33>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeId) id{634,2} ---
(node) {
        if (!node.id) {
            node.id = nextNodeId;
            nextNodeId++;
        }
        return node.id;
    }
--- END ---
INLINE (getNodeId) id{634,2} AS 2 AT <1:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getAliasSymbolForTypeNode) id{634,3} ---
(node) {
            return node.parent.kind === 228 /* TypeAliasDeclaration */ ? getSymbolOfNode(node.parent) : undefined;
        }
--- END ---
INLINE (getAliasSymbolForTypeNode) id{634,3} AS 3 AT <0:211>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{634,4} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{634,4} AS 4 AT <3:82>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{634,5} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{634,5} AS 5 AT <4:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getAliasTypeArgumentsForTypeNode) id{634,6} ---
(node) {
            var symbol = getAliasSymbolForTypeNode(node);
            return symbol ? getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol) : undefined;
        }
--- END ---
INLINE (getAliasTypeArgumentsForTypeNode) id{634,6} AS 6 AT <0:244>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getAliasSymbolForTypeNode) id{634,7} ---
(node) {
            return node.parent.kind === 228 /* TypeAliasDeclaration */ ? getSymbolOfNode(node.parent) : undefined;
        }
--- END ---
INLINE (getAliasSymbolForTypeNode) id{634,7} AS 7 AT <6:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolOfNode) id{634,8} ---
(node) {
            return getMergedSymbol(node.symbol);
        }
--- END ---
INLINE (getSymbolOfNode) id{634,8} AS 8 AT <7:82>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getMergedSymbol) id{634,9} ---
(symbol) {
            var merged;
            return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
--- END ---
INLINE (getMergedSymbol) id{634,9} AS 9 AT <8:28>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:addTypeToUnion) id{635,0} ---
(typeSet, type) {
            var flags = type.flags;
            if (flags & 65536 /* Union */) {
                addTypesToUnion(typeSet, type.types);
            }
            else if (flags & 1 /* Any */) {
                typeSet.containsAny = true;
            }
            else if (!strictNullChecks && flags & 6144 /* Nullable */) {
                if (flags & 2048 /* Undefined */)
                    typeSet.containsUndefined = true;
                if (flags & 4096 /* Null */)
                    typeSet.containsNull = true;
                if (!(flags & 2097152 /* ContainsWideningType */))
                    typeSet.containsNonWideningType = true;
            }
            else if (!(flags & 8192 /* Never */)) {
                if (flags & 2 /* String */)
                    typeSet.containsString = true;
                if (flags & 4 /* Number */)
                    typeSet.containsNumber = true;
                if (flags & 96 /* StringOrNumberLiteral */)
                    typeSet.containsStringOrNumberLiteral = true;
                var len = typeSet.length;
                var index = len && type.id > typeSet[len - 1].id ? ~len : binarySearchTypes(typeSet, type);
                if (index < 0) {
                    if (!(flags & 32768 /* Object */ && type.objectFlags & 16 /* Anonymous */ &&
                        type.symbol && type.symbol.flags & (16 /* Function */ | 8192 /* Method */) && containsIdenticalType(typeSet, type))) {
                        typeSet.splice(~index, 0, type);
                    }
                }
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:addTypesToUnion) id{635,1} ---
(typeSet, types) {
            for (var _i = 0, types_4 = types; _i < types_4.length; _i++) {
                var type = types_4[_i];
                addTypeToUnion(typeSet, type);
            }
        }
--- END ---
INLINE (addTypesToUnion) id{635,1} AS 1 AT <0:115>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:binarySearchTypes) id{635,2} ---
(types, type) {
            var low = 0;
            var high = types.length - 1;
            var typeId = type.id;
            while (low <= high) {
                var middle = low + ((high - low) >> 1);
                var id = types[middle].id;
                if (id === typeId) {
                    return middle;
                }
                else if (id > typeId) {
                    high = middle - 1;
                }
                else {
                    low = middle + 1;
                }
            }
            return ~low;
        }
--- END ---
INLINE (binarySearchTypes) id{635,2} AS 2 AT <0:1165>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getDeclaredTypeOfClassOrInterface) id{636,0} ---
(symbol) {
            var links = getSymbolLinks(symbol);
            if (!links.declaredType) {
                var kind = symbol.flags & 32 /* Class */ ? 1 /* Class */ : 2 /* Interface */;
                var type = links.declaredType = createObjectType(kind, symbol);
                var outerTypeParameters = getOuterTypeParametersOfClassOrInterface(symbol);
                var localTypeParameters = getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol);
                // A class or interface is generic if it has type parameters or a "this" type. We always give classes a "this" type
                // because it is not feasible to analyze all members to determine if the "this" type escapes the class (in particular,
                // property types inferred from initializers and method return types inferred from return statements are very hard
                // to exhaustively analyze). We give interfaces a "this" type if we can't definitely determine that they are free of
                // "this" references.
                if (outerTypeParameters || localTypeParameters || kind === 1 /* Class */ || !isIndependentInterface(symbol)) {
                    type.objectFlags |= 4 /* Reference */;
                    type.typeParameters = ts.concatenate(outerTypeParameters, localTypeParameters);
                    type.outerTypeParameters = outerTypeParameters;
                    type.localTypeParameters = localTypeParameters;
                    type.instantiations = ts.createMap();
                    type.instantiations[getTypeListId(type.typeParameters)] = type;
                    type.target = type;
                    type.typeArguments = type.typeParameters;
                    type.thisType = createType(16384 /* TypeParameter */);
                    type.thisType.isThisType = true;
                    type.thisType.symbol = symbol;
                    type.thisType.constraint = type;
                }
            }
            return links.declaredType;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{636,1} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{636,1} AS 1 AT <0:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{636,2} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{636,2} AS 2 AT <1:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createObjectType) id{636,3} ---
(objectFlags, symbol) {
            var type = createType(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol = symbol;
            return type;
        }
--- END ---
INLINE (createObjectType) id{636,3} AS 3 AT <0:240>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{636,4} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{636,4} AS 4 AT <3:47>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{636,5} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{636,5} AS 5 AT <4:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getOuterTypeParametersOfClassOrInterface) id{636,6} ---
(symbol) {
            var declaration = symbol.flags & 32 /* Class */ ? symbol.valueDeclaration : ts.getDeclarationOfKind(symbol, 227 /* InterfaceDeclaration */);
            return appendOuterTypeParameters(undefined, declaration);
        }
--- END ---
INLINE (getOuterTypeParametersOfClassOrInterface) id{636,6} AS 6 AT <0:314>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createType) id{636,7} ---
(flags) {
            var result = new Type(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }
--- END ---
INLINE (createType) id{636,7} AS 7 AT <0:1738>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:TypeObject) id{636,8} ---
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }
--- END ---
INLINE (TypeObject) id{636,8} AS 8 AT <7:35>
[deoptimizing (DEOPT eager): begin 0x1030c9d410c1 <JS Function getTypeWithThisArgument (SharedFunctionInfo 0x2e2f693eec11)> (opt #587) @9, FP to SP delta: 152, caller sp: 0x7fff5fbfdb58]
            ;;; deoptimize at 0_195: wrong map
  reading input frame getTypeWithThisArgument => node=63, args=3, height=7; inputs:
      0: 0x1030c9d410c1 ; [fp - 16] 0x1030c9d410c1 <JS Function getTypeWithThisArgument (SharedFunctionInfo 0x2e2f693eec11)>
      1: 0x1f9f6c0532e1 ; [fp + 32] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2dc1fba9b281 ; rcx 0x2dc1fba9b281 <a TypeObject with map 0x33abe2a54641>
      3: 0x30bcea404311 ; rbx 0x30bcea404311 <undefined>
      4: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      5: 0x1030c9d3cb31 ; [fp - 40] 0x1030c9d3cb31 <JS Function createTypeReference (SharedFunctionInfo 0x2e2f693f2151)>
      6: 0x30bcea404311 ; (literal 16) 0x30bcea404311 <undefined>
      7: 0x2dc1fba9b281 ; [fp - 48] 0x2dc1fba9b281 <a TypeObject with map 0x33abe2a54641>
      8: 0xd6230db1df9 ; [fp - 64] 0xd6230db1df9 <JS Function concatenate (SharedFunctionInfo 0xc2bd2ae1c69)>
      9: 0x16f3adb61821 ; [fp - 56] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
     10: 0x30bcea404311 ; rax 0x30bcea404311 <undefined>
  translating frame getTypeWithThisArgument => node=63, height=48
    0x7fff5fbfdb50: [top + 96] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdb48: [top + 88] <- 0x2dc1fba9b281 ;  0x2dc1fba9b281 <a TypeObject with map 0x33abe2a54641>  (input #2)
    0x7fff5fbfdb40: [top + 80] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #3)
    0x7fff5fbfdb38: [top + 72] <- 0x2c21d2207e55 ;  caller's pc
    0x7fff5fbfdb30: [top + 64] <- 0x7fff5fbfdb70 ;  caller's fp
    0x7fff5fbfdb28: [top + 56] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #4)
    0x7fff5fbfdb20: [top + 48] <- 0x1030c9d410c1 ;  function    0x1030c9d410c1 <JS Function getTypeWithThisArgument (SharedFunctionInfo 0x2e2f693eec11)>  (input #0)
    0x7fff5fbfdb18: [top + 40] <- 0x1030c9d3cb31 ;  0x1030c9d3cb31 <JS Function createTypeReference (SharedFunctionInfo 0x2e2f693f2151)>  (input #5)
    0x7fff5fbfdb10: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfdb08: [top + 24] <- 0x2dc1fba9b281 ;  0x2dc1fba9b281 <a TypeObject with map 0x33abe2a54641>  (input #7)
    0x7fff5fbfdb00: [top + 16] <- 0xd6230db1df9 ;  0xd6230db1df9 <JS Function concatenate (SharedFunctionInfo 0xc2bd2ae1c69)>  (input #8)
    0x7fff5fbfdaf8: [top + 8] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #9)
    0x7fff5fbfdaf0: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #10)
[deoptimizing (eager): end 0x1030c9d410c1 <JS Function getTypeWithThisArgument (SharedFunctionInfo 0x2e2f693eec11)> @9 => node=63, pc=0x2c21d260a3c7, caller sp=0x7fff5fbfdb58, state=NO_REGISTERS, took 0.097 ms]
[deoptimizing (DEOPT eager): begin 0x130b7e1b6589 <JS Function getBaseTypes (SharedFunctionInfo 0x2e2f693eda11)> (opt #599) @4, FP to SP delta: 24, caller sp: 0x7fff5fbfdb90]
            ;;; deoptimize at 0_76: wrong map
  reading input frame getBaseTypes => node=6, args=2, height=1; inputs:
      0: 0x130b7e1b6589 ; [fp - 16] 0x130b7e1b6589 <JS Function getBaseTypes (SharedFunctionInfo 0x2e2f693eda11)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2dc1fba9b281 ; rax 0x2dc1fba9b281 <a TypeObject with map 0x33abe2a54641>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
  translating frame getBaseTypes => node=6, height=0
    0x7fff5fbfdb88: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdb80: [top + 32] <- 0x2dc1fba9b281 ;  0x2dc1fba9b281 <a TypeObject with map 0x33abe2a54641>  (input #2)
    0x7fff5fbfdb78: [top + 24] <- 0x2c21d2748237 ;  caller's pc
    0x7fff5fbfdb70: [top + 16] <- 0x7fff5fbfdc30 ;  caller's fp
    0x7fff5fbfdb68: [top + 8] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdb60: [top + 0] <- 0x130b7e1b6589 ;  function    0x130b7e1b6589 <JS Function getBaseTypes (SharedFunctionInfo 0x2e2f693eda11)>  (input #0)
[deoptimizing (eager): end 0x130b7e1b6589 <JS Function getBaseTypes (SharedFunctionInfo 0x2e2f693eda11)> @4 => node=6, pc=0x2c21d260b127, caller sp=0x7fff5fbfdb90, state=NO_REGISTERS, took 0.052 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d549a9 <JS Function getPropertyOfObjectType (SharedFunctionInfo 0x2e2f693eff91)> (opt #602) @2, FP to SP delta: 40, caller sp: 0x7fff5fbfdaf0]
            ;;; deoptimize at 0_35: wrong map
  reading input frame getPropertyOfObjectType => node=4, args=3, height=3; inputs:
      0: 0x1030c9d549a9 ; [fp - 16] 0x1030c9d549a9 <JS Function getPropertyOfObjectType (SharedFunctionInfo 0x2e2f693eff91)>
      1: 0x1f9f6c0532e1 ; [fp + 32] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2dc1fba9b281 ; rax 0x2dc1fba9b281 <a TypeObject with map 0x33abe2a53a39>
      3: 0x2f05bb888a69 ; [fp + 16] 0x2f05bb888a69 <String[11]: addListener>
      4: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      5: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
      6: 0x30bcea404311 ; (literal 1) 0x30bcea404311 <undefined>
  translating frame getPropertyOfObjectType => node=4, height=16
    0x7fff5fbfdae8: [top + 64] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdae0: [top + 56] <- 0x2dc1fba9b281 ;  0x2dc1fba9b281 <a TypeObject with map 0x33abe2a53a39>  (input #2)
    0x7fff5fbfdad8: [top + 48] <- 0x2f05bb888a69 ;  0x2f05bb888a69 <String[11]: addListener>  (input #3)
    0x7fff5fbfdad0: [top + 40] <- 0x2c21d277869c ;  caller's pc
    0x7fff5fbfdac8: [top + 32] <- 0x7fff5fbfdb68 ;  caller's fp
    0x7fff5fbfdac0: [top + 24] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #4)
    0x7fff5fbfdab8: [top + 16] <- 0x1030c9d549a9 ;  function    0x1030c9d549a9 <JS Function getPropertyOfObjectType (SharedFunctionInfo 0x2e2f693eff91)>  (input #0)
    0x7fff5fbfdab0: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfdaa8: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
[deoptimizing (eager): end 0x1030c9d549a9 <JS Function getPropertyOfObjectType (SharedFunctionInfo 0x2e2f693eff91)> @2 => node=4, pc=0x2c21d274ee4c, caller sp=0x7fff5fbfdaf0, state=NO_REGISTERS, took 0.064 ms]
[deoptimizing (DEOPT eager): begin 0x130b7e1b5e01 <JS Function resolveStructuredTypeMembers (SharedFunctionInfo 0x2e2f693efe11)> (opt #578) @138, FP to SP delta: 264, caller sp: 0x7fff5fbfdaa0]
            ;;; deoptimize at 1_198: Unknown map in polymorphic access
  reading input frame resolveStructuredTypeMembers => node=70, args=2, height=2; inputs:
      0: 0x130b7e1b5e01 ; [fp - 16] 0x130b7e1b5e01 <JS Function resolveStructuredTypeMembers (SharedFunctionInfo 0x2e2f693efe11)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2dc1fba9b281 ; rbx 0x2dc1fba9b281 <a TypeObject with map 0x33abe2a53a39>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x1030c9d44df1 ; [fp - 112] 0x1030c9d44df1 <JS Function resolveTypeReferenceMembers (SharedFunctionInfo 0x2e2f693eee51)>
  reading input frame resolveTypeReferenceMembers => node=52, args=2, height=5; inputs:
      0: 0x1030c9d44df1 ; (literal 23) 0x1030c9d44df1 <JS Function resolveTypeReferenceMembers (SharedFunctionInfo 0x2e2f693eee51)>
      1: 0x1f9f6c0532e1 ; (literal 16) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x2dc1fba9b281 ; rbx 0x2dc1fba9b281 <a TypeObject with map 0x33abe2a53a39>
      3: 0x130b7e1b3d29 ; (literal 17) 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x2dc1fba9b281 ; [fp - 104] 0x2dc1fba9b281 <a TypeObject with map 0x33abe2a53a39>
      5: 0x30bcea404311 ; (literal 18) 0x30bcea404311 <undefined>
      6: 0x30bcea404311 ; (literal 18) 0x30bcea404311 <undefined>
      7: 0x22cd6eec6cb1 ; rax 0x22cd6eec6cb1 <JS Array[1]>
  translating frame resolveStructuredTypeMembers => node=70, height=8
    0x7fff5fbfda98: [top + 48] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfda90: [top + 40] <- 0x2dc1fba9b281 ;  0x2dc1fba9b281 <a TypeObject with map 0x33abe2a53a39>  (input #2)
    0x7fff5fbfda88: [top + 32] <- 0x2c21d274eec3 ;  caller's pc
    0x7fff5fbfda80: [top + 24] <- 0x7fff5fbfdac8 ;  caller's fp
    0x7fff5fbfda78: [top + 16] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfda70: [top + 8] <- 0x130b7e1b5e01 ;  function    0x130b7e1b5e01 <JS Function resolveStructuredTypeMembers (SharedFunctionInfo 0x2e2f693efe11)>  (input #0)
    0x7fff5fbfda68: [top + 0] <- 0x1030c9d44df1 ;  0x1030c9d44df1 <JS Function resolveTypeReferenceMembers (SharedFunctionInfo 0x2e2f693eee51)>  (input #4)
  translating frame resolveTypeReferenceMembers => node=52, height=32
    0x7fff5fbfda60: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfda58: [top + 64] <- 0x2dc1fba9b281 ;  0x2dc1fba9b281 <a TypeObject with map 0x33abe2a53a39>  (input #2)
    0x7fff5fbfda50: [top + 56] <- 0x2c21d260d615 ;  caller's pc
    0x7fff5fbfda48: [top + 48] <- 0x7fff5fbfda80 ;  caller's fp
    0x7fff5fbfda40: [top + 40] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfda38: [top + 32] <- 0x1030c9d44df1 ;  function    0x1030c9d44df1 <JS Function resolveTypeReferenceMembers (SharedFunctionInfo 0x2e2f693eee51)>  (input #0)
    0x7fff5fbfda30: [top + 24] <- 0x2dc1fba9b281 ;  0x2dc1fba9b281 <a TypeObject with map 0x33abe2a53a39>  (input #4)
    0x7fff5fbfda28: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfda20: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfda18: [top + 0] <- 0x22cd6eec6cb1 ;  0x22cd6eec6cb1 <JS Array[1]>  (input #7)
[deoptimizing (eager): end 0x130b7e1b5e01 <JS Function resolveStructuredTypeMembers (SharedFunctionInfo 0x2e2f693efe11)> @138 => node=52, pc=0x2c21d262e1cd, caller sp=0x7fff5fbfdaa0, state=TOS_REGISTER, took 0.121 ms]
[deoptimizing (DEOPT eager): begin 0x130b7e1b5e49 <JS Function getPropertyOfType (SharedFunctionInfo 0x2e2f693f0591)> (opt #632) @21, FP to SP delta: 120, caller sp: 0x7fff5fbfd490]
            ;;; deoptimize at 0_396: Unknown map in polymorphic access
  reading input frame getPropertyOfType => node=139, args=3, height=4; inputs:
      0: 0x130b7e1b5e49 ; [fp - 16] 0x130b7e1b5e49 <JS Function getPropertyOfType (SharedFunctionInfo 0x2e2f693f0591)>
      1: 0x1f9f6c0532e1 ; [fp + 32] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x22cd6eed4df9 ; [fp - 48] 0x22cd6eed4df9 <a TypeObject with map 0x33abe2a746c9>
      3: 0x2f05bb8a3a51 ; [fp + 16] 0x2f05bb8a3a51 <String[5]: isTTY>
      4: 0x130b7e1b3d29 ; rax 0x130b7e1b3d29 <FixedArray[1022]>
      5: 0x22cd6eed4df9 ; rdx 0x22cd6eed4df9 <a TypeObject with map 0x33abe2a746c9>
      6: 0x30bcea4069a9 ; (literal 9) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
  translating frame getPropertyOfType => node=139, height=24
    0x7fff5fbfd488: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd480: [top + 64] <- 0x22cd6eed4df9 ;  0x22cd6eed4df9 <a TypeObject with map 0x33abe2a746c9>  (input #2)
    0x7fff5fbfd478: [top + 56] <- 0x2f05bb8a3a51 ;  0x2f05bb8a3a51 <String[5]: isTTY>  (input #3)
    0x7fff5fbfd470: [top + 48] <- 0x2c21d262cf63 ;  caller's pc
    0x7fff5fbfd468: [top + 40] <- 0x7fff5fbfd510 ;  caller's fp
    0x7fff5fbfd460: [top + 32] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #4)
    0x7fff5fbfd458: [top + 24] <- 0x130b7e1b5e49 ;  function    0x130b7e1b5e49 <JS Function getPropertyOfType (SharedFunctionInfo 0x2e2f693f0591)>  (input #0)
    0x7fff5fbfd450: [top + 16] <- 0x22cd6eed4df9 ;  0x22cd6eed4df9 <a TypeObject with map 0x33abe2a746c9>  (input #5)
    0x7fff5fbfd448: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfd440: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
[deoptimizing (eager): end 0x130b7e1b5e49 <JS Function getPropertyOfType (SharedFunctionInfo 0x2e2f693f0591)> @21 => node=139, pc=0x2c21d2630017, caller sp=0x7fff5fbfd490, state=NO_REGISTERS, took 0.078 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d54e29 <JS Function getErasedSignature (SharedFunctionInfo 0x2e2f693f1791)> (opt #576) @2, FP to SP delta: 72, caller sp: 0x7fff5fbfc978]
            ;;; deoptimize at 0_40: wrong map
  reading input frame getErasedSignature => node=4, args=2, height=1; inputs:
      0: 0x1030c9d54e29 ; [fp - 16] 0x1030c9d54e29 <JS Function getErasedSignature (SharedFunctionInfo 0x2e2f693f1791)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x3d8926016df1 ; rax 0x3d8926016df1 <a SignatureObject with map 0x15b5a790cc31>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
  translating frame getErasedSignature => node=4, height=0
    0x7fff5fbfc970: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfc968: [top + 32] <- 0x3d8926016df1 ;  0x3d8926016df1 <a SignatureObject with map 0x15b5a790cc31>  (input #2)
    0x7fff5fbfc960: [top + 24] <- 0x2c21d269c043 ;  caller's pc
    0x7fff5fbfc958: [top + 16] <- 0x7fff5fbfca00 ;  caller's fp
    0x7fff5fbfc950: [top + 8] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfc948: [top + 0] <- 0x1030c9d54e29 ;  function    0x1030c9d54e29 <JS Function getErasedSignature (SharedFunctionInfo 0x2e2f693f1791)>  (input #0)
[deoptimizing (eager): end 0x1030c9d54e29 <JS Function getErasedSignature (SharedFunctionInfo 0x2e2f693f1791)> @2 => node=4, pc=0x2c21d269cc46, caller sp=0x7fff5fbfc978, state=NO_REGISTERS, took 0.048 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveStructuredTypeMembers) id{637,0} ---
(type) {
            if (!type.members) {
                if (type.flags & 32768 /* Object */) {
                    if (type.objectFlags & 4 /* Reference */) {
                        resolveTypeReferenceMembers(type);
                    }
                    else if (type.objectFlags & 3 /* ClassOrInterface */) {
                        resolveClassOrInterfaceMembers(type);
                    }
                    else if (type.objectFlags & 16 /* Anonymous */) {
                        resolveAnonymousTypeMembers(type);
                    }
                    else if (type.objectFlags & 32 /* Mapped */) {
                        resolveMappedTypeMembers(type);
                    }
                }
                else if (type.flags & 65536 /* Union */) {
                    resolveUnionTypeMembers(type);
                }
                else if (type.flags & 131072 /* Intersection */) {
                    resolveIntersectionTypeMembers(type);
                }
            }
            return type;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveTypeReferenceMembers) id{637,1} ---
(type) {
            var source = resolveDeclaredMembers(type.target);
            var typeParameters = ts.concatenate(source.typeParameters, [source.thisType]);
            var typeArguments = type.typeArguments && type.typeArguments.length === typeParameters.length ?
                type.typeArguments : ts.concatenate(type.typeArguments, [type]);
            resolveObjectTypeMembers(type, source, typeParameters, typeArguments);
        }
--- END ---
INLINE (resolveTypeReferenceMembers) id{637,1} AS 1 AT <0:185>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveDeclaredMembers) id{637,2} ---
(type) {
            if (!type.declaredProperties) {
                var symbol = type.symbol;
                type.declaredProperties = getNamedMembers(symbol.members);
                type.declaredCallSignatures = getSignaturesOfSymbol(symbol.members["__call"]);
                type.declaredConstructSignatures = getSignaturesOfSymbol(symbol.members["__new"]);
                type.declaredStringIndexInfo = getIndexInfoOfSymbol(symbol, 0 /* String */);
                type.declaredNumberIndexInfo = getIndexInfoOfSymbol(symbol, 1 /* Number */);
            }
            return type;
        }
--- END ---
INLINE (resolveDeclaredMembers) id{637,2} AS 2 AT <1:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNamedMembers) id{637,3} ---
(members) {
            var result;
            for (var id in members) {
                if (!isReservedMemberName(id)) {
                    if (!result)
                        result = [];
                    var symbol = members[id];
                    if (symbolIsValue(symbol)) {
                        result.push(symbol);
                    }
                }
            }
            return result || emptyArray;
        }
--- END ---
INLINE (getNamedMembers) id{637,3} AS 3 AT <2:137>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isReservedMemberName) id{637,4} ---
(name) {
            return name.charCodeAt(0) === 95 /* _ */ &&
                name.charCodeAt(1) === 95 /* _ */ &&
                name.charCodeAt(2) !== 95 /* _ */ &&
                name.charCodeAt(2) !== 64 /* at */;
        }
--- END ---
INLINE (isReservedMemberName) id{637,4} AS 4 AT <3:95>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexInfoOfSymbol) id{637,5} ---
(symbol, kind) {
            var declaration = getIndexDeclarationOfSymbol(symbol, kind);
            if (declaration) {
                return createIndexInfo(declaration.type ? getTypeFromTypeNode(declaration.type) : anyType, (ts.getModifierFlags(declaration) & 64 /* Readonly */) !== 0, declaration);
            }
            return undefined;
        }
--- END ---
INLINE (getIndexInfoOfSymbol) id{637,5} AS 5 AT <2:411>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createIndexInfo) id{637,6} ---
(type, isReadonly, declaration) {
            return { type: type, isReadonly: isReadonly, declaration: declaration };
        }
--- END ---
INLINE (createIndexInfo) id{637,6} AS 6 AT <5:144>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexInfoOfSymbol) id{637,7} ---
(symbol, kind) {
            var declaration = getIndexDeclarationOfSymbol(symbol, kind);
            if (declaration) {
                return createIndexInfo(declaration.type ? getTypeFromTypeNode(declaration.type) : anyType, (ts.getModifierFlags(declaration) & 64 /* Readonly */) !== 0, declaration);
            }
            return undefined;
        }
--- END ---
INLINE (getIndexInfoOfSymbol) id{637,7} AS 7 AT <2:504>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createIndexInfo) id{637,8} ---
(type, isReadonly, declaration) {
            return { type: type, isReadonly: isReadonly, declaration: declaration };
        }
--- END ---
INLINE (createIndexInfo) id{637,8} AS 8 AT <7:144>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveClassOrInterfaceMembers) id{637,9} ---
(type) {
            resolveObjectTypeMembers(type, resolveDeclaredMembers(type), emptyArray, emptyArray);
        }
--- END ---
INLINE (resolveClassOrInterfaceMembers) id{637,9} AS 9 AT <0:342>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveDeclaredMembers) id{637,10} ---
(type) {
            if (!type.declaredProperties) {
                var symbol = type.symbol;
                type.declaredProperties = getNamedMembers(symbol.members);
                type.declaredCallSignatures = getSignaturesOfSymbol(symbol.members["__call"]);
                type.declaredConstructSignatures = getSignaturesOfSymbol(symbol.members["__new"]);
                type.declaredStringIndexInfo = getIndexInfoOfSymbol(symbol, 0 /* String */);
                type.declaredNumberIndexInfo = getIndexInfoOfSymbol(symbol, 1 /* Number */);
            }
            return type;
        }
--- END ---
INLINE (resolveDeclaredMembers) id{637,10} AS 10 AT <9:52>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNamedMembers) id{637,11} ---
(members) {
            var result;
            for (var id in members) {
                if (!isReservedMemberName(id)) {
                    if (!result)
                        result = [];
                    var symbol = members[id];
                    if (symbolIsValue(symbol)) {
                        result.push(symbol);
                    }
                }
            }
            return result || emptyArray;
        }
--- END ---
INLINE (getNamedMembers) id{637,11} AS 11 AT <10:137>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isReservedMemberName) id{637,12} ---
(name) {
            return name.charCodeAt(0) === 95 /* _ */ &&
                name.charCodeAt(1) === 95 /* _ */ &&
                name.charCodeAt(2) !== 95 /* _ */ &&
                name.charCodeAt(2) !== 64 /* at */;
        }
--- END ---
INLINE (isReservedMemberName) id{637,12} AS 12 AT <11:95>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:isSimpleTypeRelatedTo) id{638,0} ---
(source, target, relation, errorReporter) {
            if (target.flags & 8192 /* Never */)
                return false;
            if (target.flags & 1 /* Any */ || source.flags & 8192 /* Never */)
                return true;
            if (source.flags & 262178 /* StringLike */ && target.flags & 2 /* String */)
                return true;
            if (source.flags & 340 /* NumberLike */ && target.flags & 4 /* Number */)
                return true;
            if (source.flags & 136 /* BooleanLike */ && target.flags & 8 /* Boolean */)
                return true;
            if (source.flags & 256 /* EnumLiteral */ && target.flags & 16 /* Enum */ && source.baseType === target)
                return true;
            if (source.flags & 16 /* Enum */ && target.flags & 16 /* Enum */ && isEnumTypeRelatedTo(source, target, errorReporter))
                return true;
            if (source.flags & 2048 /* Undefined */ && (!strictNullChecks || target.flags & (2048 /* Undefined */ | 1024 /* Void */)))
                return true;
            if (source.flags & 4096 /* Null */ && (!strictNullChecks || target.flags & 4096 /* Null */))
                return true;
            if (relation === assignableRelation || relation === comparableRelation) {
                if (source.flags & 1 /* Any */)
                    return true;
                if ((source.flags & 4 /* Number */ | source.flags & 64 /* NumberLiteral */) && target.flags & 272 /* EnumLike */)
                    return true;
                if (source.flags & 256 /* EnumLiteral */ &&
                    target.flags & 256 /* EnumLiteral */ &&
                    source.text === target.text &&
                    isEnumTypeRelatedTo(source.baseType, target.baseType, errorReporter)) {
                    return true;
                }
                if (source.flags & 256 /* EnumLiteral */ &&
                    target.flags & 16 /* Enum */ &&
                    isEnumTypeRelatedTo(target, source.baseType, errorReporter)) {
                    return true;
                }
            }
            return false;
        }
--- END ---
[deoptimizing (DEOPT eager): begin 0x130b7e1b67c9 <JS Function getTypeFromTypeNode (SharedFunctionInfo 0x2e2f693f5581)> (opt #571) @39, FP to SP delta: 264, caller sp: 0x7fff5fbfd258]
            ;;; deoptimize at 11_169: wrong map
  reading input frame getTypeFromTypeNode => node=332, args=2, height=4; inputs:
      0: 0x130b7e1b67c9 ; [fp - 16] 0x130b7e1b67c9 <JS Function getTypeFromTypeNode (SharedFunctionInfo 0x2e2f693f5581)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1229b19d2e9 ; rcx 0x1229b19d2e9 <a NodeObject with map 0x33abe2a536c9>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea4069a9 ; (literal 26) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      5: 0x30bcea404311 ; (literal 25) 0x30bcea404311 <undefined>
      6: 0x1030c9d43629 ; [fp - 32] 0x1030c9d43629 <JS Function getTypeFromArrayTypeNode (SharedFunctionInfo 0x2e2f693f3291)>
  reading input frame getTypeFromArrayTypeNode => node=31, args=2, height=2; inputs:
      0: 0x1030c9d43629 ; (literal 27) 0x1030c9d43629 <JS Function getTypeFromArrayTypeNode (SharedFunctionInfo 0x2e2f693f3291)>
      1: 0x1f9f6c0532e1 ; (literal 28) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1229b19d2e9 ; rcx 0x1229b19d2e9 <a NodeObject with map 0x33abe2a536c9>
      3: 0x130b7e1b3d29 ; (literal 29) 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x37554ca14a99 ; rax 0x37554ca14a99 <an Object with map 0x33abe2a51889>
  translating frame getTypeFromTypeNode => node=332, height=24
    0x7fff5fbfd250: [top + 64] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd248: [top + 56] <- 0x1229b19d2e9 ;  0x1229b19d2e9 <a NodeObject with map 0x33abe2a536c9>  (input #2)
    0x7fff5fbfd240: [top + 48] <- 0x2c21d2787b77 ;  caller's pc
    0x7fff5fbfd238: [top + 40] <- 0x7fff5fbfd298 ;  caller's fp
    0x7fff5fbfd230: [top + 32] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd228: [top + 24] <- 0x130b7e1b67c9 ;  function    0x130b7e1b67c9 <JS Function getTypeFromTypeNode (SharedFunctionInfo 0x2e2f693f5581)>  (input #0)
    0x7fff5fbfd220: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #4)
    0x7fff5fbfd218: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfd210: [top + 0] <- 0x1030c9d43629 ;  0x1030c9d43629 <JS Function getTypeFromArrayTypeNode (SharedFunctionInfo 0x2e2f693f3291)>  (input #6)
  translating frame getTypeFromArrayTypeNode => node=31, height=8
    0x7fff5fbfd208: [top + 48] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd200: [top + 40] <- 0x1229b19d2e9 ;  0x1229b19d2e9 <a NodeObject with map 0x33abe2a536c9>  (input #2)
    0x7fff5fbfd1f8: [top + 32] <- 0x2c21d25f869b ;  caller's pc
    0x7fff5fbfd1f0: [top + 24] <- 0x7fff5fbfd238 ;  caller's fp
    0x7fff5fbfd1e8: [top + 16] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd1e0: [top + 8] <- 0x1030c9d43629 ;  function    0x1030c9d43629 <JS Function getTypeFromArrayTypeNode (SharedFunctionInfo 0x2e2f693f3291)>  (input #0)
    0x7fff5fbfd1d8: [top + 0] <- 0x37554ca14a99 ;  0x37554ca14a99 <an Object with map 0x33abe2a51889>  (input #4)
[deoptimizing (eager): end 0x130b7e1b67c9 <JS Function getTypeFromTypeNode (SharedFunctionInfo 0x2e2f693f5581)> @39 => node=31, pc=0x2c21d25957fb, caller sp=0x7fff5fbfd258, state=NO_REGISTERS, took 0.130 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:propertiesRelatedTo) id{639,0} ---
(source, target, reportErrors) {
                if (relation === identityRelation) {
                    return propertiesIdenticalTo(source, target);
                }
                var result = -1 /* True */;
                var properties = getPropertiesOfObjectType(target);
                var requireOptionalProperties = relation === subtypeRelation && !(getObjectFlags(source) & 128 /* ObjectLiteral */);
                for (var _i = 0, properties_3 = properties; _i < properties_3.length; _i++) {
                    var targetProp = properties_3[_i];
                    var sourceProp = getPropertyOfType(source, targetProp.name);
                    if (sourceProp !== targetProp) {
                        if (!sourceProp) {
                            if (!(targetProp.flags & 536870912 /* Optional */) || requireOptionalProperties) {
                                if (reportErrors) {
                                    reportError(ts.Diagnostics.Property_0_is_missing_in_type_1, symbolToString(targetProp), typeToString(source));
                                }
                                return 0 /* False */;
                            }
                        }
                        else if (!(targetProp.flags & 134217728 /* Prototype */)) {
                            var sourcePropFlags = getDeclarationModifierFlagsFromSymbol(sourceProp);
                            var targetPropFlags = getDeclarationModifierFlagsFromSymbol(targetProp);
                            if (sourcePropFlags & 8 /* Private */ || targetPropFlags & 8 /* Private */) {
                                if (sourceProp.valueDeclaration !== targetProp.valueDeclaration) {
                                    if (reportErrors) {
                                        if (sourcePropFlags & 8 /* Private */ && targetPropFlags & 8 /* Private */) {
                                            reportError(ts.Diagnostics.Types_have_separate_declarations_of_a_private_property_0, symbolToString(targetProp));
                                        }
                                        else {
                                            reportError(ts.Diagnostics.Property_0_is_private_in_type_1_but_not_in_type_2, symbolToString(targetProp), typeToString(sourcePropFlags & 8 /* Private */ ? source : target), typeToString(sourcePropFlags & 8 /* Private */ ? target : source));
                                        }
                                    }
                                    return 0 /* False */;
                                }
                            }
                            else if (targetPropFlags & 16 /* Protected */) {
                                var sourceDeclaredInClass = sourceProp.parent && sourceProp.parent.flags & 32 /* Class */;
                                var sourceClass = sourceDeclaredInClass ? getDeclaredTypeOfSymbol(getParentOfSymbol(sourceProp)) : undefined;
                                var targetClass = getDeclaredTypeOfSymbol(getParentOfSymbol(targetProp));
                                if (!sourceClass || !hasBaseType(sourceClass, targetClass)) {
                                    if (reportErrors) {
                                        reportError(ts.Diagnostics.Property_0_is_protected_but_type_1_is_not_a_class_derived_from_2, symbolToString(targetProp), typeToString(sourceClass || source), typeToString(targetClass));
                                    }
                                    return 0 /* False */;
                                }
                            }
                            else if (sourcePropFlags & 16 /* Protected */) {
                                if (reportErrors) {
                                    reportError(ts.Diagnostics.Property_0_is_protected_in_type_1_but_public_in_type_2, symbolToString(targetProp), typeToString(source), typeToString(target));
                                }
                                return 0 /* False */;
                            }
                            var related = isRelatedTo(getTypeOfSymbol(sourceProp), getTypeOfSymbol(targetProp), reportErrors);
                            if (!related) {
                                if (reportErrors) {
                                    reportError(ts.Diagnostics.Types_of_property_0_are_incompatible, symbolToString(targetProp));
                                }
                                return 0 /* False */;
                            }
                            result &= related;
                            // When checking for comparability, be more lenient with optional properties.
                            if (relation !== comparableRelation && sourceProp.flags & 536870912 /* Optional */ && !(targetProp.flags & 536870912 /* Optional */)) {
                                // TypeScript 1.0 spec (April 2014): 3.8.3
                                // S is a subtype of a type T, and T is a supertype of S if ...
                                // S' and T are object types and, for each member M in T..
                                // M is a property and S' contains a property N where
                                // if M is a required property, N is also a required property
                                // (M - property in T)
                                // (N - property in S)
                                if (reportErrors) {
                                    reportError(ts.Diagnostics.Property_0_is_optional_in_type_1_but_required_in_type_2, symbolToString(targetProp), typeToString(source), typeToString(target));
                                }
                                return 0 /* False */;
                            }
                        }
                    }
                }
                return result;
            }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropertiesOfObjectType) id{639,1} ---
(type) {
            if (type.flags & 32768 /* Object */) {
                return resolveStructuredTypeMembers(type).properties;
            }
            return emptyArray;
        }
--- END ---
INLINE (getPropertiesOfObjectType) id{639,1} AS 1 AT <0:247>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getDeclarationModifierFlagsFromSymbol) id{639,2} ---
(s) {
            return s.valueDeclaration ? ts.getCombinedModifierFlags(s.valueDeclaration) : s.flags & 134217728 /* Prototype */ ? 4 /* Public */ | 32 /* Static */ : 0;
        }
--- END ---
INLINE (getDeclarationModifierFlagsFromSymbol) id{639,2} AS 2 AT <0:1329>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getDeclarationModifierFlagsFromSymbol) id{639,3} ---
(s) {
            return s.valueDeclaration ? ts.getCombinedModifierFlags(s.valueDeclaration) : s.flags & 134217728 /* Prototype */ ? 4 /* Public */ | 32 /* Static */ : 0;
        }
--- END ---
INLINE (getDeclarationModifierFlagsFromSymbol) id{639,3} AS 3 AT <0:1430>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropertyOfObjectType) id{640,0} ---
(type, name) {
            if (type.flags & 32768 /* Object */) {
                var resolved = resolveStructuredTypeMembers(type);
                var symbol = resolved.members[name];
                if (symbol && symbolIsValue(symbol)) {
                    return symbol;
                }
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTargetSymbol) id{641,0} ---
(s) {
            // if symbol is instantiated its flags are not copied from the 'target'
            // so we'll need to get back original 'target' symbol to work with correct set of flags
            return s.flags & 16777216 /* Instantiated */ ? getSymbolLinks(s).target : s;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolLinks) id{641,1} ---
(symbol) {
            if (symbol.flags & 67108864 /* Transient */)
                return symbol;
            var id = getSymbolId(symbol);
            return symbolLinks[id] || (symbolLinks[id] = {});
        }
--- END ---
INLINE (getSymbolLinks) id{641,1} AS 1 AT <0:249>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSymbolId) id{641,2} ---
(symbol) {
        if (!symbol.id) {
            symbol.id = nextSymbolId;
            nextSymbolId++;
        }
        return symbol.id;
    }
--- END ---
INLINE (getSymbolId) id{641,2} AS 2 AT <1:120>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropertyOfType) id{642,0} ---
(type, name) {
            type = getApparentType(type);
            if (type.flags & 32768 /* Object */) {
                var resolved = resolveStructuredTypeMembers(type);
                var symbol = resolved.members[name];
                if (symbol && symbolIsValue(symbol)) {
                    return symbol;
                }
                if (resolved === anyFunctionType || resolved.callSignatures.length || resolved.constructSignatures.length) {
                    var symbol_1 = getPropertyOfObjectType(globalFunctionType, name);
                    if (symbol_1) {
                        return symbol_1;
                    }
                }
                return getPropertyOfObjectType(globalObjectType, name);
            }
            if (type.flags & 196608 /* UnionOrIntersection */) {
                return getPropertyOfUnionOrIntersectionType(type, name);
            }
            return undefined;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getApparentType) id{642,1} ---
(type) {
            var t = type.flags & 540672 /* TypeVariable */ ? getApparentTypeOfTypeVariable(type) : type;
            return t.flags & 262178 /* StringLike */ ? globalStringType :
                t.flags & 340 /* NumberLike */ ? globalNumberType :
                    t.flags & 136 /* BooleanLike */ ? globalBooleanType :
                        t.flags & 512 /* ESSymbol */ ? getGlobalESSymbolType() :
                            t;
        }
--- END ---
INLINE (getApparentType) id{642,1} AS 1 AT <0:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropertyOfObjectType) id{642,2} ---
(type, name) {
            if (type.flags & 32768 /* Object */) {
                var resolved = resolveStructuredTypeMembers(type);
                var symbol = resolved.members[name];
                if (symbol && symbolIsValue(symbol)) {
                    return symbol;
                }
            }
        }
--- END ---
INLINE (getPropertyOfObjectType) id{642,2} AS 2 AT <0:496>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropertyOfObjectType) id{642,3} ---
(type, name) {
            if (type.flags & 32768 /* Object */) {
                var resolved = resolveStructuredTypeMembers(type);
                var symbol = resolved.members[name];
                if (symbol && symbolIsValue(symbol)) {
                    return symbol;
                }
            }
        }
--- END ---
INLINE (getPropertyOfObjectType) id{642,3} AS 3 AT <0:687>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getObjectFlags) id{643,0} ---
(type) {
            return type.flags & 32768 /* Object */ ? type.objectFlags : 0;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getErasedSignature) id{644,0} ---
(signature) {
            if (!signature.typeParameters)
                return signature;
            if (!signature.erasedSignatureCache) {
                signature.erasedSignatureCache = instantiateSignature(signature, createTypeEraser(signature.typeParameters), /*eraseTypeParameters*/ true);
            }
            return signature.erasedSignatureCache;
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createTypeEraser) id{644,1} ---
(sources) {
            return createTypeMapper(sources, undefined);
        }
--- END ---
INLINE (createTypeEraser) id{644,1} AS 1 AT <0:223>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createTypeMapper) id{644,2} ---
(sources, targets) {
            var count = sources.length;
            var mapper = count == 1 ? createUnaryTypeMapper(sources[0], targets ? targets[0] : anyType) :
                count == 2 ? createBinaryTypeMapper(sources[0], targets ? targets[0] : anyType, sources[1], targets ? targets[1] : anyType) :
                    createArrayTypeMapper(sources, targets);
            mapper.mappedTypes = sources;
            return mapper;
        }
--- END ---
INLINE (createTypeMapper) id{644,2} AS 2 AT <1:31>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getClassLikeDeclarationOfSymbol) id{645,0} ---
(symbol) {
            return ts.forEach(symbol.declarations, function (d) { return ts.isClassLike(d) ? d : undefined; });
        }
--- END ---
[deoptimizing (DEOPT eager): begin 0x1030c9d3ff99 <JS Function checkFunctionOrMethodDeclaration (SharedFunctionInfo 0x1b98fbc0c0c1)> (opt #605) @33, FP to SP delta: 160, caller sp: 0x7fff5fbfdc38]
            ;;; deoptimize at 0_1571: wrong map
  reading input frame checkFunctionOrMethodDeclaration => node=224, args=2, height=8; inputs:
      0: 0x1030c9d3ff99 ; [fp - 16] 0x1030c9d3ff99 <JS Function checkFunctionOrMethodDeclaration (SharedFunctionInfo 0x1b98fbc0c0c1)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1d75d867cf19 ; [fp + 16] 0x1d75d867cf19 <a NodeObject with map 0x33abe2a714f1>
      3: 0x37554cafa971 ; [fp - 24] 0x37554cafa971 <FixedArray[5]>
      4: 0x30bcea404421 ; [fp - 40] 0x30bcea404421 <false>
      5: 0x38be05825c31 ; [fp - 80] 0x38be05825c31 <a SymbolObject with map 0x33abe2a725c9>
      6: 0x38be05825c31 ; rdx 0x38be05825c31 <a SymbolObject with map 0x33abe2a725c9>
      7: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
      8: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
      9: 0x16f3adb61821 ; [fp - 96] 0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>
     10: 0xd6230daf4a1 ; rax 0xd6230daf4a1 <JS Function forEach (SharedFunctionInfo 0xc2bd2ae0d69)>
  translating frame checkFunctionOrMethodDeclaration => node=224, height=56
    0x7fff5fbfdc30: [top + 96] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdc28: [top + 88] <- 0x1d75d867cf19 ;  0x1d75d867cf19 <a NodeObject with map 0x33abe2a714f1>  (input #2)
    0x7fff5fbfdc20: [top + 80] <- 0x2c21d2794ecc ;  caller's pc
    0x7fff5fbfdc18: [top + 72] <- 0x7fff5fbfdc68 ;  caller's fp
    0x7fff5fbfdc10: [top + 64] <- 0x37554cafa971 ;  context    0x37554cafa971 <FixedArray[5]>  (input #3)
    0x7fff5fbfdc08: [top + 56] <- 0x1030c9d3ff99 ;  function    0x1030c9d3ff99 <JS Function checkFunctionOrMethodDeclaration (SharedFunctionInfo 0x1b98fbc0c0c1)>  (input #0)
    0x7fff5fbfdc00: [top + 48] <- 0x30bcea404421 ;  0x30bcea404421 <false>  (input #4)
    0x7fff5fbfdbf8: [top + 40] <- 0x38be05825c31 ;  0x38be05825c31 <a SymbolObject with map 0x33abe2a725c9>  (input #5)
    0x7fff5fbfdbf0: [top + 32] <- 0x38be05825c31 ;  0x38be05825c31 <a SymbolObject with map 0x33abe2a725c9>  (input #6)
    0x7fff5fbfdbe8: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfdbe0: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #8)
    0x7fff5fbfdbd8: [top + 8] <- 0x16f3adb61821 ;  0x16f3adb61821 <an Object with map 0x33abe2a5dbc9>  (input #9)
    0x7fff5fbfdbd0: [top + 0] <- 0xd6230daf4a1 ;  0xd6230daf4a1 <JS Function forEach (SharedFunctionInfo 0xc2bd2ae0d69)>  (input #10)
[deoptimizing (eager): end 0x1030c9d3ff99 <JS Function checkFunctionOrMethodDeclaration (SharedFunctionInfo 0x1b98fbc0c0c1)> @33 => node=224, pc=0x2c21d25fc659, caller sp=0x7fff5fbfdc38, state=TOS_REGISTER, took 0.117 ms]
[deoptimizing (DEOPT eager): begin 0x37554cafc2a9 <JS Function propertiesRelatedTo (SharedFunctionInfo 0x130b7e106e61)> (opt #639) @22, FP to SP delta: 152, caller sp: 0x7fff5fbfd540]
            ;;; deoptimize at 0_785: wrong map
  reading input frame propertiesRelatedTo => node=280, args=4, height=14; inputs:
      0: 0x37554cafc2a9 ; [fp - 16] 0x37554cafc2a9 <JS Function propertiesRelatedTo (SharedFunctionInfo 0x130b7e106e61)>
      1: 0x1f9f6c0532e1 ; [fp + 40] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x37554cafb1f9 ; [fp + 32] 0x37554cafb1f9 <a TypeObject with map 0x33abe2a746c9>
      3: 0x1ce442d2be99 ; [fp + 24] 0x1ce442d2be99 <a TypeObject with map 0x33abe2a73599>
      4: 0x30bcea4043b1 ; [fp + 16] 0x30bcea4043b1 <true>
      5: 0x37554cafbc91 ; [fp - 24] 0x37554cafbc91 <FixedArray[40]>
      6: -1 ; (int) [fp - 64] 
      7: 0x30bcea4069a9 ; (literal 10) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      8: 0x30bcea404421 ; [fp - 48] 0x30bcea404421 <false>
      9: 2 ; (int) [fp - 56] 
     10: 0x1ce442d2bf61 ; [fp - 40] 0x1ce442d2bf61 <JS Array[3]>
     11: 0x2069ac90e19 ; rbx 0x2069ac90e19 <a SymbolObject with map 0x33abe2a74cf9>
     12: 0x30bcea4069a9 ; (literal 10) 0x30bcea4069a9 <Odd Oddball: optimized_out>
     13: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
     14: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
     15: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
     16: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
     17: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
     18: 0x30bcea404311 ; (literal 5) 0x30bcea404311 <undefined>
  translating frame propertiesRelatedTo => node=280, height=104
    0x7fff5fbfd538: [top + 160] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd530: [top + 152] <- 0x37554cafb1f9 ;  0x37554cafb1f9 <a TypeObject with map 0x33abe2a746c9>  (input #2)
    0x7fff5fbfd528: [top + 144] <- 0x1ce442d2be99 ;  0x1ce442d2be99 <a TypeObject with map 0x33abe2a73599>  (input #3)
    0x7fff5fbfd520: [top + 136] <- 0x30bcea4043b1 ;  0x30bcea4043b1 <true>  (input #4)
    0x7fff5fbfd518: [top + 128] <- 0x2c21d262bb12 ;  caller's pc
    0x7fff5fbfd510: [top + 120] <- 0x7fff5fbfd590 ;  caller's fp
    0x7fff5fbfd508: [top + 112] <- 0x37554cafbc91 ;  context    0x37554cafbc91 <FixedArray[40]>  (input #5)
    0x7fff5fbfd500: [top + 104] <- 0x37554cafc2a9 ;  function    0x37554cafc2a9 <JS Function propertiesRelatedTo (SharedFunctionInfo 0x130b7e106e61)>  (input #0)
    0x7fff5fbfd4f8: [top + 96] <- 0xffffffff00000000 ;  -1  (input #6)
    0x7fff5fbfd4f0: [top + 88] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #7)
    0x7fff5fbfd4e8: [top + 80] <- 0x30bcea404421 ;  0x30bcea404421 <false>  (input #8)
    0x7fff5fbfd4e0: [top + 72] <- 0x200000000 ;  2  (input #9)
    0x7fff5fbfd4d8: [top + 64] <- 0x1ce442d2bf61 ;  0x1ce442d2bf61 <JS Array[3]>  (input #10)
    0x7fff5fbfd4d0: [top + 56] <- 0x2069ac90e19 ;  0x2069ac90e19 <a SymbolObject with map 0x33abe2a74cf9>  (input #11)
    0x7fff5fbfd4c8: [top + 48] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #12)
    0x7fff5fbfd4c0: [top + 40] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #13)
    0x7fff5fbfd4b8: [top + 32] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #14)
    0x7fff5fbfd4b0: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #15)
    0x7fff5fbfd4a8: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #16)
    0x7fff5fbfd4a0: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #17)
    0x7fff5fbfd498: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #18)
[deoptimizing (eager): end 0x37554cafc2a9 <JS Function propertiesRelatedTo (SharedFunctionInfo 0x130b7e106e61)> @22 => node=280, pc=0x2c21d262cfc4, caller sp=0x7fff5fbfd540, state=NO_REGISTERS, took 0.110 ms]
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeFromTypeNode) id{646,0} ---
(node) {
            switch (node.kind) {
                case 118 /* AnyKeyword */:
                case 263 /* JSDocAllType */:
                case 264 /* JSDocUnknownType */:
                    return anyType;
                case 134 /* StringKeyword */:
                    return stringType;
                case 132 /* NumberKeyword */:
                    return numberType;
                case 121 /* BooleanKeyword */:
                    return booleanType;
                case 135 /* SymbolKeyword */:
                    return esSymbolType;
                case 104 /* VoidKeyword */:
                    return voidType;
                case 137 /* UndefinedKeyword */:
                    return undefinedType;
                case 94 /* NullKeyword */:
                    return nullType;
                case 129 /* NeverKeyword */:
                    return neverType;
                case 289 /* JSDocNullKeyword */:
                    return nullType;
                case 290 /* JSDocUndefinedKeyword */:
                    return undefinedType;
                case 291 /* JSDocNeverKeyword */:
                    return neverType;
                case 167 /* ThisType */:
                case 98 /* ThisKeyword */:
                    return getTypeFromThisTypeNode(node);
                case 171 /* LiteralType */:
                    return getTypeFromLiteralTypeNode(node);
                case 288 /* JSDocLiteralType */:
                    return getTypeFromLiteralTypeNode(node.literal);
                case 157 /* TypeReference */:
                case 272 /* JSDocTypeReference */:
                    return getTypeFromTypeReference(node);
                case 156 /* TypePredicate */:
                    return booleanType;
                case 199 /* ExpressionWithTypeArguments */:
                    return getTypeFromTypeReference(node);
                case 160 /* TypeQuery */:
                    return getTypeFromTypeQueryNode(node);
                case 162 /* ArrayType */:
                case 265 /* JSDocArrayType */:
                    return getTypeFromArrayTypeNode(node);
                case 163 /* TupleType */:
                    return getTypeFromTupleTypeNode(node);
                case 164 /* UnionType */:
                case 266 /* JSDocUnionType */:
                    return getTypeFromUnionTypeNode(node);
                case 165 /* IntersectionType */:
                    return getTypeFromIntersectionTypeNode(node);
                case 166 /* ParenthesizedType */:
                case 268 /* JSDocNullableType */:
                case 269 /* JSDocNonNullableType */:
                case 276 /* JSDocConstructorType */:
                case 277 /* JSDocThisType */:
                case 273 /* JSDocOptionalType */:
                    return getTypeFromTypeNode(node.type);
                case 270 /* JSDocRecordType */:
                    return getTypeFromTypeNode(node.literal);
                case 158 /* FunctionType */:
                case 159 /* ConstructorType */:
                case 161 /* TypeLiteral */:
                case 287 /* JSDocTypeLiteral */:
                case 274 /* JSDocFunctionType */:
                    return getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode(node);
                case 168 /* TypeOperator */:
                    return getTypeFromTypeOperatorNode(node);
                case 169 /* IndexedAccessType */:
                    return getTypeFromIndexedAccessTypeNode(node);
                case 170 /* MappedType */:
                    return getTypeFromMappedTypeNode(node);
                // This function assumes that an identifier or qualified name is a type expression
                // Callers should first ensure this by calling isTypeNode
                case 70 /* Identifier */:
                case 141 /* QualifiedName */:
                    var symbol = getSymbolAtLocation(node);
                    return symbol && getDeclaredTypeOfSymbol(symbol);
                case 267 /* JSDocTupleType */:
                    return getTypeFromJSDocTupleType(node);
                case 275 /* JSDocVariadicType */:
                    return getTypeFromJSDocVariadicType(node);
                default:
                    return unknownType;
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeFromThisTypeNode) id{646,1} ---
(node) {
            var links = getNodeLinks(node);
            if (!links.resolvedType) {
                links.resolvedType = getThisType(node);
            }
            return links.resolvedType;
        }
--- END ---
INLINE (getTypeFromThisTypeNode) id{646,1} AS 1 AT <0:1275>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeLinks) id{646,2} ---
(node) {
            var nodeId = getNodeId(node);
            return nodeLinks[nodeId] || (nodeLinks[nodeId] = { flags: 0 });
        }
--- END ---
INLINE (getNodeLinks) id{646,2} AS 2 AT <1:33>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeId) id{646,3} ---
(node) {
        if (!node.id) {
            node.id = nextNodeId;
            nextNodeId++;
        }
        return node.id;
    }
--- END ---
INLINE (getNodeId) id{646,3} AS 3 AT <2:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeFromLiteralTypeNode) id{646,4} ---
(node) {
            var links = getNodeLinks(node);
            if (!links.resolvedType) {
                links.resolvedType = getRegularTypeOfLiteralType(checkExpression(node.literal));
            }
            return links.resolvedType;
        }
--- END ---
INLINE (getTypeFromLiteralTypeNode) id{646,4} AS 4 AT <0:1377>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeLinks) id{646,5} ---
(node) {
            var nodeId = getNodeId(node);
            return nodeLinks[nodeId] || (nodeLinks[nodeId] = { flags: 0 });
        }
--- END ---
INLINE (getNodeLinks) id{646,5} AS 5 AT <4:33>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeId) id{646,6} ---
(node) {
        if (!node.id) {
            node.id = nextNodeId;
            nextNodeId++;
        }
        return node.id;
    }
--- END ---
INLINE (getNodeId) id{646,6} AS 6 AT <5:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getRegularTypeOfLiteralType) id{646,7} ---
(type) {
            return type.flags & 96 /* StringOrNumberLiteral */ && type.flags & 1048576 /* FreshLiteral */ ? type.regularType : type;
        }
--- END ---
INLINE (getRegularTypeOfLiteralType) id{646,7} AS 7 AT <4:129>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeFromTypeQueryNode) id{646,8} ---
(node) {
            var links = getNodeLinks(node);
            if (!links.resolvedType) {
                // TypeScript 1.0 spec (April 2014): 3.6.3
                // The expression is processed as an identifier expression (section 4.3)
                // or property access expression(section 4.10),
                // the widened type(section 3.9) of which becomes the result.
                links.resolvedType = getWidenedType(checkExpression(node.exprName));
            }
            return links.resolvedType;
        }
--- END ---
INLINE (getTypeFromTypeQueryNode) id{646,8} AS 8 AT <0:1959>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeLinks) id{646,9} ---
(node) {
            var nodeId = getNodeId(node);
            return nodeLinks[nodeId] || (nodeLinks[nodeId] = { flags: 0 });
        }
--- END ---
INLINE (getNodeLinks) id{646,9} AS 9 AT <8:33>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeId) id{646,10} ---
(node) {
        if (!node.id) {
            node.id = nextNodeId;
            nextNodeId++;
        }
        return node.id;
    }
--- END ---
INLINE (getNodeId) id{646,10} AS 10 AT <9:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getTypeFromArrayTypeNode) id{646,11} ---
(node) {
            var links = getNodeLinks(node);
            if (!links.resolvedType) {
                links.resolvedType = createArrayType(getTypeFromTypeNode(node.elementType));
            }
            return links.resolvedType;
        }
--- END ---
INLINE (getTypeFromArrayTypeNode) id{646,11} AS 11 AT <0:2107>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeLinks) id{646,12} ---
(node) {
            var nodeId = getNodeId(node);
            return nodeLinks[nodeId] || (nodeLinks[nodeId] = { flags: 0 });
        }
--- END ---
INLINE (getNodeLinks) id{646,12} AS 12 AT <11:33>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getNodeId) id{646,13} ---
(node) {
        if (!node.id) {
            node.id = nextNodeId;
            nextNodeId++;
        }
        return node.id;
    }
--- END ---
INLINE (getNodeId) id{646,13} AS 13 AT <12:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createArrayType) id{646,14} ---
(elementType) {
            return createTypeFromGenericGlobalType(globalArrayType, [elementType]);
        }
--- END ---
INLINE (createArrayType) id{646,14} AS 14 AT <11:129>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createTypeFromGenericGlobalType) id{646,15} ---
(genericGlobalType, typeArguments) {
            return genericGlobalType !== emptyGenericType ? createTypeReference(genericGlobalType, typeArguments) : emptyObjectType;
        }
--- END ---
INLINE (createTypeFromGenericGlobalType) id{646,15} AS 15 AT <14:35>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createTypeReference) id{646,16} ---
(target, typeArguments) {
            var id = getTypeListId(typeArguments);
            var type = target.instantiations[id];
            if (!type) {
                type = target.instantiations[id] = createObjectType(4 /* Reference */, target.symbol);
                type.flags |= typeArguments ? getPropagatingFlagsOfTypes(typeArguments, /*excludeKinds*/ 0) : 0;
                type.target = target;
                type.typeArguments = typeArguments;
            }
            return type;
        }
--- END ---
INLINE (createTypeReference) id{646,16} AS 16 AT <15:97>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createObjectType) id{646,17} ---
(objectFlags, symbol) {
            var type = createType(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol = symbol;
            return type;
        }
--- END ---
INLINE (createObjectType) id{646,17} AS 17 AT <16:203>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropagatingFlagsOfTypes) id{646,18} ---
(types, excludeKinds) {
            var result = 0;
            for (var _i = 0, types_3 = types; _i < types_3.length; _i++) {
                var type = types_3[_i];
                if (!(type.flags & excludeKinds)) {
                    result |= type.flags;
                }
            }
            return result & 14680064 /* PropagatingFlags */;
        }
--- END ---
INLINE (getPropagatingFlagsOfTypes) id{646,18} AS 18 AT <16:301>
[deoptimizing (DEOPT eager): begin 0x1030c9d44209 <JS Function getTypeOfSymbol (SharedFunctionInfo 0x2e2f693ed051)> (opt #603) @28, FP to SP delta: 128, caller sp: 0x7fff5fbfd9e0]
            ;;; deoptimize at 5_116: wrong map
  reading input frame getTypeOfSymbol => node=97, args=2, height=2; inputs:
      0: 0x1030c9d44209 ; [fp - 16] 0x1030c9d44209 <JS Function getTypeOfSymbol (SharedFunctionInfo 0x2e2f693ed051)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x38be05825c31 ; rax 0x38be05825c31 <a SymbolObject with map 0x33abe2a537d1>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x1030c9d444e9 ; [fp - 32] 0x1030c9d444e9 <JS Function getTypeOfFuncClassEnumModule (SharedFunctionInfo 0x2e2f693ecc91)>
  reading input frame getTypeOfFuncClassEnumModule => node=34, args=2, height=3; inputs:
      0: 0x1030c9d444e9 ; (literal 17) 0x1030c9d444e9 <JS Function getTypeOfFuncClassEnumModule (SharedFunctionInfo 0x2e2f693ecc91)>
      1: 0x1f9f6c0532e1 ; (literal 18) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x38be05825c31 ; rax 0x38be05825c31 <a SymbolObject with map 0x33abe2a537d1>
      3: 0x130b7e1b3d29 ; (literal 19) 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x3da5527219c9 ; [fp - 64] 0x3da5527219c9 <an Object with map 0x15b5a7907011>
      5: 0x30bcea404311 ; (literal 20) 0x30bcea404311 <undefined>
  translating frame getTypeOfSymbol => node=97, height=8
    0x7fff5fbfd9d8: [top + 48] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd9d0: [top + 40] <- 0x38be05825c31 ;  0x38be05825c31 <a SymbolObject with map 0x33abe2a537d1>  (input #2)
    0x7fff5fbfd9c8: [top + 32] <- 0x2c21d272a6dd ;  caller's pc
    0x7fff5fbfd9c0: [top + 24] <- 0x7fff5fbfda60 ;  caller's fp
    0x7fff5fbfd9b8: [top + 16] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd9b0: [top + 8] <- 0x1030c9d44209 ;  function    0x1030c9d44209 <JS Function getTypeOfSymbol (SharedFunctionInfo 0x2e2f693ed051)>  (input #0)
    0x7fff5fbfd9a8: [top + 0] <- 0x1030c9d444e9 ;  0x1030c9d444e9 <JS Function getTypeOfFuncClassEnumModule (SharedFunctionInfo 0x2e2f693ecc91)>  (input #4)
  translating frame getTypeOfFuncClassEnumModule => node=34, height=16
    0x7fff5fbfd9a0: [top + 56] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd998: [top + 48] <- 0x38be05825c31 ;  0x38be05825c31 <a SymbolObject with map 0x33abe2a537d1>  (input #2)
    0x7fff5fbfd990: [top + 40] <- 0x2c21d261cde4 ;  caller's pc
    0x7fff5fbfd988: [top + 32] <- 0x7fff5fbfd9c0 ;  caller's fp
    0x7fff5fbfd980: [top + 24] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd978: [top + 16] <- 0x1030c9d444e9 ;  function    0x1030c9d444e9 <JS Function getTypeOfFuncClassEnumModule (SharedFunctionInfo 0x2e2f693ecc91)>  (input #0)
    0x7fff5fbfd970: [top + 8] <- 0x3da5527219c9 ;  0x3da5527219c9 <an Object with map 0x15b5a7907011>  (input #4)
    0x7fff5fbfd968: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
[deoptimizing (eager): end 0x1030c9d44209 <JS Function getTypeOfSymbol (SharedFunctionInfo 0x2e2f693ed051)> @28 => node=34, pc=0x2c21d261eb3d, caller sp=0x7fff5fbfd9e0, state=NO_REGISTERS, took 0.148 ms]
--- FUNCTION SOURCE (native regexp.js:RegExpSubclassExec) id{647,0} ---
(B,C,Q){
if((Q===(void 0))){
Q=B.exec;
}
if((typeof(Q)==='function')){
var J=%_Call(Q,B,C);
if(!(%_IsJSReceiver(J))&&!(J===null)){
throw %make_type_error(48);
}
return J;
}
return %_Call(RegExpExecJS,B,C);
}
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:resolveAnonymousTypeMembers) id{648,0} ---
(type) {
            var symbol = type.symbol;
            if (type.target) {
                var members = createInstantiatedSymbolTable(getPropertiesOfObjectType(type.target), type.mapper, /*mappingThisOnly*/ false);
                var callSignatures = instantiateSignatures(getSignaturesOfType(type.target, 0 /* Call */), type.mapper);
                var constructSignatures = instantiateSignatures(getSignaturesOfType(type.target, 1 /* Construct */), type.mapper);
                var stringIndexInfo = instantiateIndexInfo(getIndexInfoOfType(type.target, 0 /* String */), type.mapper);
                var numberIndexInfo = instantiateIndexInfo(getIndexInfoOfType(type.target, 1 /* Number */), type.mapper);
                setStructuredTypeMembers(type, members, callSignatures, constructSignatures, stringIndexInfo, numberIndexInfo);
            }
            else if (symbol.flags & 2048 /* TypeLiteral */) {
                var members = symbol.members;
                var callSignatures = getSignaturesOfSymbol(members["__call"]);
                var constructSignatures = getSignaturesOfSymbol(members["__new"]);
                var stringIndexInfo = getIndexInfoOfSymbol(symbol, 0 /* String */);
                var numberIndexInfo = getIndexInfoOfSymbol(symbol, 1 /* Number */);
                setStructuredTypeMembers(type, members, callSignatures, constructSignatures, stringIndexInfo, numberIndexInfo);
            }
            else {
                // Combinations of function, class, enum and module
                var members = emptySymbols;
                var constructSignatures = emptyArray;
                if (symbol.flags & 1952 /* HasExports */) {
                    members = getExportsOfSymbol(symbol);
                }
                if (symbol.flags & 32 /* Class */) {
                    var classType = getDeclaredTypeOfClassOrInterface(symbol);
                    constructSignatures = getSignaturesOfSymbol(symbol.members["__constructor"]);
                    if (!constructSignatures.length) {
                        constructSignatures = getDefaultConstructSignatures(classType);
                    }
                    var baseConstructorType = getBaseConstructorTypeOfClass(classType);
                    if (baseConstructorType.flags & 32768 /* Object */) {
                        members = createSymbolTable(getNamedMembers(members));
                        addInheritedMembers(members, getPropertiesOfObjectType(baseConstructorType));
                    }
                }
                var numberIndexInfo = symbol.flags & 384 /* Enum */ ? enumNumberIndexInfo : undefined;
                setStructuredTypeMembers(type, members, emptyArray, constructSignatures, undefined, numberIndexInfo);
                // We resolve the members before computing the signatures because a signature may use
                // typeof with a qualified name expression that circularly references the type we are
                // in the process of resolving (see issue #6072). The temporarily empty signature list
                // will never be observed because a qualified name can't reference signatures.
                if (symbol.flags & (16 /* Function */ | 8192 /* Method */)) {
                    type.callSignatures = getSignaturesOfSymbol(symbol);
                }
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getPropertiesOfObjectType) id{648,1} ---
(type) {
            if (type.flags & 32768 /* Object */) {
                return resolveStructuredTypeMembers(type).properties;
            }
            return emptyArray;
        }
--- END ---
INLINE (getPropertiesOfObjectType) id{648,1} AS 1 AT <0:138>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:createInstantiatedSymbolTable) id{648,2} ---
(symbols, mapper, mappingThisOnly) {
            var result = ts.createMap();
            for (var _i = 0, symbols_2 = symbols; _i < symbols_2.length; _i++) {
                var symbol = symbols_2[_i];
                result[symbol.name] = mappingThisOnly && isIndependentMember(symbol) ? symbol : instantiateSymbol(symbol, mapper);
            }
            return result;
        }
--- END ---
INLINE (createInstantiatedSymbolTable) id{648,2} AS 2 AT <0:108>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSignaturesOfType) id{648,3} ---
(type, kind) {
            return getSignaturesOfStructuredType(getApparentType(type), kind);
        }
--- END ---
INLINE (getSignaturesOfType) id{648,3} AS 3 AT <0:278>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getApparentType) id{648,4} ---
(type) {
            var t = type.flags & 540672 /* TypeVariable */ ? getApparentTypeOfTypeVariable(type) : type;
            return t.flags & 262178 /* StringLike */ ? globalStringType :
                t.flags & 340 /* NumberLike */ ? globalNumberType :
                    t.flags & 136 /* BooleanLike */ ? globalBooleanType :
                        t.flags & 512 /* ESSymbol */ ? getGlobalESSymbolType() :
                            t;
        }
--- END ---
INLINE (getApparentType) id{648,4} AS 4 AT <3:64>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSignaturesOfStructuredType) id{648,5} ---
(type, kind) {
            if (type.flags & 229376 /* StructuredType */) {
                var resolved = resolveStructuredTypeMembers(type);
                return kind === 0 /* Call */ ? resolved.callSignatures : resolved.constructSignatures;
            }
            return emptyArray;
        }
--- END ---
INLINE (getSignaturesOfStructuredType) id{648,5} AS 5 AT <3:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateSignatures) id{648,6} ---
(signatures, mapper) {
            return instantiateList(signatures, mapper, instantiateSignature);
        }
--- END ---
INLINE (instantiateSignatures) id{648,6} AS 6 AT <0:256>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateList) id{648,7} ---
(items, mapper, instantiator) {
            if (items && items.length) {
                var result = [];
                for (var _i = 0, items_1 = items; _i < items_1.length; _i++) {
                    var v = items_1[_i];
                    result.push(instantiator(v, mapper));
                }
                return result;
            }
            return items;
        }
--- END ---
INLINE (instantiateList) id{648,7} AS 7 AT <6:42>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSignaturesOfType) id{648,8} ---
(type, kind) {
            return getSignaturesOfStructuredType(getApparentType(type), kind);
        }
--- END ---
INLINE (getSignaturesOfType) id{648,8} AS 8 AT <0:404>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getApparentType) id{648,9} ---
(type) {
            var t = type.flags & 540672 /* TypeVariable */ ? getApparentTypeOfTypeVariable(type) : type;
            return t.flags & 262178 /* StringLike */ ? globalStringType :
                t.flags & 340 /* NumberLike */ ? globalNumberType :
                    t.flags & 136 /* BooleanLike */ ? globalBooleanType :
                        t.flags & 512 /* ESSymbol */ ? getGlobalESSymbolType() :
                            t;
        }
--- END ---
INLINE (getApparentType) id{648,9} AS 9 AT <8:64>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getSignaturesOfStructuredType) id{648,10} ---
(type, kind) {
            if (type.flags & 229376 /* StructuredType */) {
                var resolved = resolveStructuredTypeMembers(type);
                return kind === 0 /* Call */ ? resolved.callSignatures : resolved.constructSignatures;
            }
            return emptyArray;
        }
--- END ---
INLINE (getSignaturesOfStructuredType) id{648,10} AS 10 AT <8:34>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateSignatures) id{648,11} ---
(signatures, mapper) {
            return instantiateList(signatures, mapper, instantiateSignature);
        }
--- END ---
INLINE (instantiateSignatures) id{648,11} AS 11 AT <0:382>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:instantiateList) id{648,12} ---
(items, mapper, instantiator) {
            if (items && items.length) {
                var result = [];
                for (var _i = 0, items_1 = items; _i < items_1.length; _i++) {
                    var v = items_1[_i];
                    result.push(instantiator(v, mapper));
                }
                return result;
            }
            return items;
        }
--- END ---
INLINE (instantiateList) id{648,12} AS 12 AT <11:42>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getIndexInfoOfType) id{648,13} ---
(type, kind) {
            return getIndexInfoOfStructuredType(getApparentType(type), kind);
        }
--- END ---
INLINE (getIndexInfoOfType) id{648,13} AS 13 AT <0:530>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getApparentType) id{648,14} ---
(type) {
            var t = type.flags & 540672 /* TypeVariable */ ? getApparentTypeOfTypeVariable(type) : type;
            return t.flags & 262178 /* StringLike */ ? globalStringType :
                t.flags & 340 /* NumberLike */ ? globalNumberType :
                    t.flags & 136 /* BooleanLike */ ? globalBooleanType :
                        t.flags & 512 /* ESSymbol */ ? getGlobalESSymbolType() :
                            t;
        }
--- END ---
INLINE (getApparentType) id{648,14} AS 14 AT <13:63>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:getDeclarationOfKind) id{649,0} ---
(symbol, kind) {
        var declarations = symbol.declarations;
        if (declarations) {
            for (var _i = 0, declarations_1 = declarations; _i < declarations_1.length; _i++) {
                var declaration = declarations_1[_i];
                if (declaration.kind === kind) {
                    return declaration;
                }
            }
        }
        return undefined;
    }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:checkGrammarModifiers) id{650,0} ---
(node) {
            var quickResult = reportObviousModifierErrors(node);
            if (quickResult !== undefined) {
                return quickResult;
            }
            var lastStatic, lastPrivate, lastProtected, lastDeclare, lastAsync, lastReadonly;
            var flags = 0 /* None */;
            for (var _i = 0, _a = node.modifiers; _i < _a.length; _i++) {
                var modifier = _a[_i];
                if (modifier.kind !== 130 /* ReadonlyKeyword */) {
                    if (node.kind === 146 /* PropertySignature */ || node.kind === 148 /* MethodSignature */) {
                        return grammarErrorOnNode(modifier, ts.Diagnostics._0_modifier_cannot_appear_on_a_type_member, ts.tokenToString(modifier.kind));
                    }
                    if (node.kind === 155 /* IndexSignature */) {
                        return grammarErrorOnNode(modifier, ts.Diagnostics._0_modifier_cannot_appear_on_an_index_signature, ts.tokenToString(modifier.kind));
                    }
                }
                switch (modifier.kind) {
                    case 75 /* ConstKeyword */:
                        if (node.kind !== 229 /* EnumDeclaration */ && node.parent.kind === 226 /* ClassDeclaration */) {
                            return grammarErrorOnNode(node, ts.Diagnostics.A_class_member_cannot_have_the_0_keyword, ts.tokenToString(75 /* ConstKeyword */));
                        }
                        break;
                    case 113 /* PublicKeyword */:
                    case 112 /* ProtectedKeyword */:
                    case 111 /* PrivateKeyword */:
                        var text = visibilityToString(ts.modifierToFlag(modifier.kind));
                        if (modifier.kind === 112 /* ProtectedKeyword */) {
                            lastProtected = modifier;
                        }
                        else if (modifier.kind === 111 /* PrivateKeyword */) {
                            lastPrivate = modifier;
                        }
                        if (flags & 28 /* AccessibilityModifier */) {
                            return grammarErrorOnNode(modifier, ts.Diagnostics.Accessibility_modifier_already_seen);
                        }
                        else if (flags & 32 /* Static */) {
                            return grammarErrorOnNode(modifier, ts.Diagnostics._0_modifier_must_precede_1_modifier, text, "static");
                        }
                        else if (flags & 64 /* Readonly */) {
                            return grammarErrorOnNode(modifier, ts.Diagnostics._0_modifier_must_precede_1_modifier, text, "readonly");
                        }
                        else if (flags & 256 /* Async */) {
                            return grammarErrorOnNode(modifier, ts.Diagnostics._0_modifier_must_precede_1_modifier, text, "async");
                        }
                        else if (node.parent.kind === 231 /* ModuleBlock */ || node.parent.kind === 261 /* SourceFile */) {
                            return grammarErrorOnNode(modifier, ts.Diagnostics._0_modifier_cannot_appear_on_a_module_or_namespace_element, text);
                        }
                        else if (flags & 128 /* Abstract */) {
                            if (modifier.kind === 111 /* PrivateKeyword */) {
                                return grammarErrorOnNode(modifier, ts.Diagnostics._0_modifier_cannot_be_used_with_1_modifier, text, "abstract");
                            }
                            else {
                                return grammarErrorOnNode(modifier, ts.Diagnostics._0_modifier_must_precede_1_modifier, text, "abstract");
                            }
                        }
                        flags |= ts.modifierToFlag(modifier.kind);
                        break;
                    case 114 /* StaticKeyword */:
                        if (flags & 32 /* Static */) {
                            return grammarErrorOnNode(modifier, ts.Diagnostics._0_modifier_already_seen, "static");
                        }
                        else if (flags & 64 /* Readonly */) {
                            return grammarErrorOnNode(modifier, ts.Diagnostics._0_modifier_must_precede_1_modifier, "static", "readonly");
                        }
                        else if (flags & 256 /* Async */) {
                            return grammarErrorOnNode(modifier, ts.Diagnostics._0_modifier_must_precede_1_modifier, "static", "async");
                        }
                        else if (node.parent.kind === 231 /* ModuleBlock */ || node.parent.kind === 261 /* SourceFile */) {
                            return grammarErrorOnNode(modifier, ts.Diagnostics._0_modifier_cannot_appear_on_a_module_or_namespace_element, "static");
                        }
                        else if (node.kind === 144 /* Parameter */) {
                            return grammarErrorOnNode(modifier, ts.Diagnostics._0_modifier_cannot_appear_on_a_parameter, "static");
                        }
                        else if (flags & 128 /* Abstract */) {
                            return grammarErrorOnNode(modifier, ts.Diagnostics._0_modifier_cannot_be_used_with_1_modifier, "static", "abstract");
                        }
                        flags |= 32 /* Static */;
                        lastStatic = modifier;
                        break;
                    case 130 /* ReadonlyKeyword */:
                        if (flags & 64 /* Readonly */) {
                            return grammarErrorOnNode(modifier, ts.Diagnostics._0_modifier_already_seen, "readonly");
                        }
                        else if (node.kind !== 147 /* PropertyDeclaration */ && node.kind !== 146 /* PropertySignature */ && node.kind !== 155 /* IndexSignature */ && node.kind !== 144 /* Parameter */) {
                            // If node.kind === SyntaxKind.Parameter, checkParameter report an error if it's not a parameter property.
                            return grammarErrorOnNode(modifier, ts.Diagnostics.readonly_modifier_can_only_appear_on_a_property_declaration_or_index_signature);
                        }
                        flags |= 64 /* Readonly */;
                        lastReadonly = modifier;
                        break;
                    case 83 /* ExportKeyword */:
                        if (flags & 1 /* Export */) {
                            return grammarErrorOnNode(modifier, ts.Diagnostics._0_modifier_already_seen, "export");
                        }
                        else if (flags & 2 /* Ambient */) {
                            return grammarErrorOnNode(modifier, ts.Diagnostics._0_modifier_must_precede_1_modifier, "export", "declare");
                        }
                        else if (flags & 128 /* Abstract */) {
                            return grammarErrorOnNode(modifier, ts.Diagnostics._0_modifier_must_precede_1_modifier, "export", "abstract");
                        }
                        else if (flags & 256 /* Async */) {
                            return grammarErrorOnNode(modifier, ts.Diagnostics._0_modifier_must_precede_1_modifier, "export", "async");
                        }
                        else if (node.parent.kind === 226 /* ClassDeclaration */) {
                            return grammarErrorOnNode(modifier, ts.Diagnostics._0_modifier_cannot_appear_on_a_class_element, "export");
                        }
                        else if (node.kind === 144 /* Parameter */) {
                            return grammarErrorOnNode(modifier, ts.Diagnostics._0_modifier_cannot_appear_on_a_parameter, "export");
                        }
                        flags |= 1 /* Export */;
                        break;
                    case 123 /* DeclareKeyword */:
                        if (flags & 2 /* Ambient */) {
                            return grammarErrorOnNode(modifier, ts.Diagnostics._0_modifier_already_seen, "declare");
                        }
                        else if (flags & 256 /* Async */) {
                            return grammarErrorOnNode(modifier, ts.Diagnostics._0_modifier_cannot_be_used_in_an_ambient_context, "async");
                        }
                        else if (node.parent.kind === 226 /* ClassDeclaration */) {
                            return grammarErrorOnNode(modifier, ts.Diagnostics._0_modifier_cannot_appear_on_a_class_element, "declare");
                        }
                        else if (node.kind === 144 /* Parameter */) {
                            return grammarErrorOnNode(modifier, ts.Diagnostics._0_modifier_cannot_appear_on_a_parameter, "declare");
                        }
                        else if (ts.isInAmbientContext(node.parent) && node.parent.kind === 231 /* ModuleBlock */) {
                            return grammarErrorOnNode(modifier, ts.Diagnostics.A_declare_modifier_cannot_be_used_in_an_already_ambient_context);
                        }
                        flags |= 2 /* Ambient */;
                        lastDeclare = modifier;
                        break;
                    case 116 /* AbstractKeyword */:
                        if (flags & 128 /* Abstract */) {
                            return grammarErrorOnNode(modifier, ts.Diagnostics._0_modifier_already_seen, "abstract");
                        }
                        if (node.kind !== 226 /* ClassDeclaration */) {
                            if (node.kind !== 149 /* MethodDeclaration */ &&
                                node.kind !== 147 /* PropertyDeclaration */ &&
                                node.kind !== 151 /* GetAccessor */ &&
                                node.kind !== 152 /* SetAccessor */) {
                                return grammarErrorOnNode(modifier, ts.Diagnostics.abstract_modifier_can_only_appear_on_a_class_method_or_property_declaration);
                            }
                            if (!(node.parent.kind === 226 /* ClassDeclaration */ && ts.getModifierFlags(node.parent) & 128 /* Abstract */)) {
                                return grammarErrorOnNode(modifier, ts.Diagnostics.Abstract_methods_can_only_appear_within_an_abstract_class);
                            }
                            if (flags & 32 /* Static */) {
                                return grammarErrorOnNode(modifier, ts.Diagnostics._0_modifier_cannot_be_used_with_1_modifier, "static", "abstract");
                            }
                            if (flags & 8 /* Private */) {
                                return grammarErrorOnNode(modifier, ts.Diagnostics._0_modifier_cannot_be_used_with_1_modifier, "private", "abstract");
                            }
                        }
                        flags |= 128 /* Abstract */;
                        break;
                    case 119 /* AsyncKeyword */:
                        if (flags & 256 /* Async */) {
                            return grammarErrorOnNode(modifier, ts.Diagnostics._0_modifier_already_seen, "async");
                        }
                        else if (flags & 2 /* Ambient */ || ts.isInAmbientContext(node.parent)) {
                            return grammarErrorOnNode(modifier, ts.Diagnostics._0_modifier_cannot_be_used_in_an_ambient_context, "async");
                        }
                        else if (node.kind === 144 /* Parameter */) {
                            return grammarErrorOnNode(modifier, ts.Diagnostics._0_modifier_cannot_appear_on_a_parameter, "async");
                        }
                        flags |= 256 /* Async */;
                        lastAsync = modifier;
                        break;
                }
            }
            if (node.kind === 150 /* Constructor */) {
                if (flags & 32 /* Static */) {
                    return grammarErrorOnNode(lastStatic, ts.Diagnostics._0_modifier_cannot_appear_on_a_constructor_declaration, "static");
                }
                if (flags & 128 /* Abstract */) {
                    return grammarErrorOnNode(lastStatic, ts.Diagnostics._0_modifier_cannot_appear_on_a_constructor_declaration, "abstract");
                }
                else if (flags & 256 /* Async */) {
                    return grammarErrorOnNode(lastAsync, ts.Diagnostics._0_modifier_cannot_appear_on_a_constructor_declaration, "async");
                }
                else if (flags & 64 /* Readonly */) {
                    return grammarErrorOnNode(lastReadonly, ts.Diagnostics._0_modifier_cannot_appear_on_a_constructor_declaration, "readonly");
                }
                return;
            }
            else if ((node.kind === 235 /* ImportDeclaration */ || node.kind === 234 /* ImportEqualsDeclaration */) && flags & 2 /* Ambient */) {
                return grammarErrorOnNode(lastDeclare, ts.Diagnostics.A_0_modifier_cannot_be_used_with_an_import_declaration, "declare");
            }
            else if (node.kind === 144 /* Parameter */ && (flags & 92 /* ParameterPropertyModifier */) && ts.isBindingPattern(node.name)) {
                return grammarErrorOnNode(node, ts.Diagnostics.A_parameter_property_may_not_be_declared_using_a_binding_pattern);
            }
            else if (node.kind === 144 /* Parameter */ && (flags & 92 /* ParameterPropertyModifier */) && node.dotDotDotToken) {
                return grammarErrorOnNode(node, ts.Diagnostics.A_parameter_property_cannot_be_declared_using_a_rest_parameter);
            }
            if (flags & 256 /* Async */) {
                return checkGrammarAsyncModifier(node, lastAsync);
            }
        }
--- END ---
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:reportObviousModifierErrors) id{650,1} ---
(node) {
            return !node.modifiers
                ? false
                : shouldReportBadModifier(node)
                    ? grammarErrorOnFirstToken(node, ts.Diagnostics.Modifiers_cannot_appear_here)
                    : undefined;
        }
--- END ---
INLINE (reportObviousModifierErrors) id{650,1} AS 1 AT <0:39>
--- FUNCTION SOURCE (/Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:visibilityToString) id{650,2} ---
(flags) {
            if (flags === 8 /* Private */) {
                return "private";
            }
            if (flags === 16 /* Protected */) {
                return "protected";
            }
            return "public";
        }
--- END ---
INLINE (visibilityToString) id{650,2} AS 2 AT <0:1648>
[deoptimizing (DEOPT eager): begin 0x1030c9d3e359 <JS Function getDeclaredTypeOfSymbol (SharedFunctionInfo 0x2e2f693ee491)> (opt #420) @8, FP to SP delta: 88, caller sp: 0x7fff5fbfdba0]
            ;;; deoptimize at 0_266: wrong map
  reading input frame getDeclaredTypeOfSymbol => node=50, args=2, height=1; inputs:
      0: 0x1030c9d3e359 ; [fp - 16] 0x1030c9d3e359 <JS Function getDeclaredTypeOfSymbol (SharedFunctionInfo 0x2e2f693ee491)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x38be05825e51 ; rax 0x38be05825e51 <a SymbolObject with map 0x33abe2a71079>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
  translating frame getDeclaredTypeOfSymbol => node=50, height=0
    0x7fff5fbfdb98: [top + 40] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdb90: [top + 32] <- 0x38be05825e51 ;  0x38be05825e51 <a SymbolObject with map 0x33abe2a71079>  (input #2)
    0x7fff5fbfdb88: [top + 24] <- 0x2c21d27d4581 ;  caller's pc
    0x7fff5fbfdb80: [top + 16] <- 0x7fff5fbfdc20 ;  caller's fp
    0x7fff5fbfdb78: [top + 8] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdb70: [top + 0] <- 0x1030c9d3e359 ;  function    0x1030c9d3e359 <JS Function getDeclaredTypeOfSymbol (SharedFunctionInfo 0x2e2f693ee491)>  (input #0)
[deoptimizing (eager): end 0x1030c9d3e359 <JS Function getDeclaredTypeOfSymbol (SharedFunctionInfo 0x2e2f693ee491)> @8 => node=50, pc=0x2c21d25e7336, caller sp=0x7fff5fbfdba0, state=NO_REGISTERS, took 0.080 ms]
[marking dependent code 0x2c21d26c5081 (opt #420) for deoptimization, reason: field-type]
[marking dependent code 0x2c21d26e1001 (opt #437) for deoptimization, reason: field-type]
[marking dependent code 0x2c21d242fa61 (opt #483) for deoptimization, reason: field-type]
[marking dependent code 0x2c21d2708f41 (opt #498) for deoptimization, reason: field-type]
[marking dependent code 0x2c21d2727701 (opt #527) for deoptimization, reason: field-type]
[marking dependent code 0x2c21d27b2601 (opt #628) for deoptimization, reason: field-type]
[marking dependent code 0x2c21d27b7b41 (opt #630) for deoptimization, reason: field-type]
[deoptimize marked code in all contexts]
[deoptimizer unlinked: checkSourceElement / 130b7e1b6059]
[deoptimizer unlinked: isSymbolInScopeOfMappedTypeParameter / 1030c9d45871]
[deoptimizer unlinked: checkTypeParameters / 1030c9d404b1]
[deoptimizer unlinked: checkTypeParameter / 1030c9d43671]
[deoptimizer unlinked: getDeclaredTypeOfTypeParameter / 1030c9d3ede9]
[deoptimizer unlinked: getConstraintOfTypeParameter / 1030c9d43749]
[deoptimizing (DEOPT lazy): begin 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> (opt #630) @17, FP to SP delta: 200, caller sp: 0x7fff5fbfdd70]
  reading input frame checkSourceElement => node=986, args=2, height=5; inputs:
      0: 0x130b7e1b6059 ; [fp - 16] 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1d75d8685d99 ; [fp + 16] 0x1d75d8685d99 <a NodeObject with map 0x33abe2a51621>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 33) 0x30bcea404311 <undefined>
      5: 0x30bcea4069a9 ; (literal 34) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      6: 0x30bcea4069a9 ; (literal 34) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x30bcea404311 ; rax 0x30bcea404311 <undefined>
  translating frame checkSourceElement => node=986, height=32
    0x7fff5fbfdd68: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdd60: [top + 64] <- 0x1d75d8685d99 ;  0x1d75d8685d99 <a NodeObject with map 0x33abe2a51621>  (input #2)
    0x7fff5fbfdd58: [top + 56] <- 0x2c21d2207e55 ;  caller's pc
    0x7fff5fbfdd50: [top + 48] <- 0x7fff5fbfdd88 ;  caller's fp
    0x7fff5fbfdd48: [top + 40] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdd40: [top + 32] <- 0x130b7e1b6059 ;  function    0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>  (input #0)
    0x7fff5fbfdd38: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfdd30: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #5)
    0x7fff5fbfdd28: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfdd20: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
[deoptimizing (lazy): end 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> @17 => node=986, pc=0x2c21d25ec7f7, caller sp=0x7fff5fbfdd70, state=TOS_REGISTER, took 0.064 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d42619 <JS Function getTypeFromTypeReference (SharedFunctionInfo 0x2e2f693f28d1)> (opt #336) @31, FP to SP delta: 96, caller sp: 0x7fff5fbfd9f8]
            ;;; deoptimize at 0_1256: wrong map
  reading input frame getTypeFromTypeReference => node=322, args=2, height=6; inputs:
      0: 0x1030c9d42619 ; [fp - 16] 0x1030c9d42619 <JS Function getTypeFromTypeReference (SharedFunctionInfo 0x2e2f693f28d1)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1229b110049 ; [fp + 16] 0x1229b110049 <a NodeObject with map 0x33abe2a735f1>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x261c1f474ed9 ; [fp - 56] 0x261c1f474ed9 <an Object with map 0x33abe2a51889>
      5: 0x38be05825e51 ; rax 0x38be05825e51 <a SymbolObject with map 0x33abe2a63fd1>
      6: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
      7: 0x30bcea404311 ; (literal 7) 0x30bcea404311 <undefined>
      8: 0x30bcea4069a9 ; (literal 13) 0x30bcea4069a9 <Odd Oddball: optimized_out>
  translating frame getTypeFromTypeReference => node=322, height=40
    0x7fff5fbfd9f0: [top + 80] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd9e8: [top + 72] <- 0x1229b110049 ;  0x1229b110049 <a NodeObject with map 0x33abe2a735f1>  (input #2)
    0x7fff5fbfd9e0: [top + 64] <- 0x2c21d26cd7cf ;  caller's pc
    0x7fff5fbfd9d8: [top + 56] <- 0x7fff5fbfda78 ;  caller's fp
    0x7fff5fbfd9d0: [top + 48] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd9c8: [top + 40] <- 0x1030c9d42619 ;  function    0x1030c9d42619 <JS Function getTypeFromTypeReference (SharedFunctionInfo 0x2e2f693f28d1)>  (input #0)
    0x7fff5fbfd9c0: [top + 32] <- 0x261c1f474ed9 ;  0x261c1f474ed9 <an Object with map 0x33abe2a51889>  (input #4)
    0x7fff5fbfd9b8: [top + 24] <- 0x38be05825e51 ;  0x38be05825e51 <a SymbolObject with map 0x33abe2a63fd1>  (input #5)
    0x7fff5fbfd9b0: [top + 16] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
    0x7fff5fbfd9a8: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
    0x7fff5fbfd9a0: [top + 0] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #8)
[deoptimizing (eager): end 0x1030c9d42619 <JS Function getTypeFromTypeReference (SharedFunctionInfo 0x2e2f693f28d1)> @31 => node=322, pc=0x2c21d26134af, caller sp=0x7fff5fbfd9f8, state=NO_REGISTERS, took 0.149 ms]
[deoptimizing (DEOPT soft): begin 0x1030c9d42c69 <JS Function checkTypeReferenceNode (SharedFunctionInfo 0x1b98fbc0af81)> (opt #427) @63, FP to SP delta: 128, caller sp: 0x7fff5fbfda98]
            ;;; deoptimize at 0_846: Insufficient type feedback for generic named access
  reading input frame checkTypeReferenceNode => node=248, args=2, height=4; inputs:
      0: 0x1030c9d42c69 ; [fp - 16] 0x1030c9d42c69 <JS Function checkTypeReferenceNode (SharedFunctionInfo 0x1b98fbc0af81)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1229b110049 ; [fp + 16] 0x1229b110049 <a NodeObject with map 0x33abe2a735f1>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x261c1f473491 ; [fp - 64] 0x261c1f473491 <a TypeObject with map 0x33abe2a51831>
      5: 0x30bcea404311 ; (literal 15) 0x30bcea404311 <undefined>
      6: 0x30bcea404311 ; (literal 15) 0x30bcea404311 <undefined>
  translating frame checkTypeReferenceNode => node=248, height=24
    0x7fff5fbfda90: [top + 64] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfda88: [top + 56] <- 0x1229b110049 ;  0x1229b110049 <a NodeObject with map 0x33abe2a735f1>  (input #2)
    0x7fff5fbfda80: [top + 48] <- 0x2c21d25ec1ad ;  caller's pc
    0x7fff5fbfda78: [top + 40] <- 0x7fff5fbfdac8 ;  caller's fp
    0x7fff5fbfda70: [top + 32] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfda68: [top + 24] <- 0x1030c9d42c69 ;  function    0x1030c9d42c69 <JS Function checkTypeReferenceNode (SharedFunctionInfo 0x1b98fbc0af81)>  (input #0)
    0x7fff5fbfda60: [top + 16] <- 0x261c1f473491 ;  0x261c1f473491 <a TypeObject with map 0x33abe2a51831>  (input #4)
    0x7fff5fbfda58: [top + 8] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #5)
    0x7fff5fbfda50: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #6)
[deoptimizing (soft): end 0x1030c9d42c69 <JS Function checkTypeReferenceNode (SharedFunctionInfo 0x1b98fbc0af81)> @63 => node=248, pc=0x2c21d26158be, caller sp=0x7fff5fbfda98, state=NO_REGISTERS, took 0.132 ms]
[deoptimizing (DEOPT lazy): begin 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> (opt #630) @44, FP to SP delta: 200, caller sp: 0x7fff5fbfdf20]
  reading input frame checkSourceElement => node=580, args=2, height=5; inputs:
      0: 0x130b7e1b6059 ; [fp - 16] 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1d75d865ea39 ; [fp + 16] 0x1d75d865ea39 <a NodeObject with map 0x33abe2a71b79>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 33) 0x30bcea404311 <undefined>
      5: 0x30bcea4069a9 ; (literal 34) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      6: 0x30bcea4069a9 ; (literal 34) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x30bcea404311 ; rax 0x30bcea404311 <undefined>
  translating frame checkSourceElement => node=580, height=32
    0x7fff5fbfdf18: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfdf10: [top + 64] <- 0x1d75d865ea39 ;  0x1d75d865ea39 <a NodeObject with map 0x33abe2a71b79>  (input #2)
    0x7fff5fbfdf08: [top + 56] <- 0x2c21d268616c ;  caller's pc
    0x7fff5fbfdf00: [top + 48] <- 0x7fff5fbfdf90 ;  caller's fp
    0x7fff5fbfdef8: [top + 40] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfdef0: [top + 32] <- 0x130b7e1b6059 ;  function    0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>  (input #0)
    0x7fff5fbfdee8: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfdee0: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #5)
    0x7fff5fbfded8: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfded0: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
[deoptimizing (lazy): end 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> @44 => node=580, pc=0x2c21d25ec3f2, caller sp=0x7fff5fbfdf20, state=TOS_REGISTER, took 0.137 ms]
[deoptimizing (DEOPT lazy): begin 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> (opt #630) @16, FP to SP delta: 200, caller sp: 0x7fff5fbfe098]
  reading input frame checkSourceElement => node=1005, args=2, height=5; inputs:
      0: 0x130b7e1b6059 ; [fp - 16] 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1d75d865b5c9 ; [fp + 16] 0x1d75d865b5c9 <a NodeObject with map 0x33abe2a71231>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea404311 ; (literal 33) 0x30bcea404311 <undefined>
      5: 0x30bcea4069a9 ; (literal 34) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      6: 0x30bcea4069a9 ; (literal 34) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      7: 0x30bcea404311 ; rax 0x30bcea404311 <undefined>
  translating frame checkSourceElement => node=1005, height=32
    0x7fff5fbfe090: [top + 72] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfe088: [top + 64] <- 0x1d75d865b5c9 ;  0x1d75d865b5c9 <a NodeObject with map 0x33abe2a71231>  (input #2)
    0x7fff5fbfe080: [top + 56] <- 0x2c21d2207e55 ;  caller's pc
    0x7fff5fbfe078: [top + 48] <- 0x7fff5fbfe0b0 ;  caller's fp
    0x7fff5fbfe070: [top + 40] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfe068: [top + 32] <- 0x130b7e1b6059 ;  function    0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)>  (input #0)
    0x7fff5fbfe060: [top + 24] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #4)
    0x7fff5fbfe058: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #5)
    0x7fff5fbfe050: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #6)
    0x7fff5fbfe048: [top + 0] <- 0x30bcea404311 ;  0x30bcea404311 <undefined>  (input #7)
[deoptimizing (lazy): end 0x130b7e1b6059 <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> @16 => node=1005, pc=0x2c21d25ec828, caller sp=0x7fff5fbfe098, state=TOS_REGISTER, took 0.154 ms]
[deoptimizing (DEOPT eager): begin 0x1030c9d455f1 <JS Function isIndependentMember (SharedFunctionInfo 0x2e2f693ee851)> (opt #627) @39, FP to SP delta: 80, caller sp: 0x7fff5fbfda30]
            ;;; deoptimize at 1_78: Unknown map in polymorphic access
  reading input frame isIndependentMember => node=128, args=2, height=4; inputs:
      0: 0x1030c9d455f1 ; [fp - 16] 0x1030c9d455f1 <JS Function isIndependentMember (SharedFunctionInfo 0x2e2f693ee851)>
      1: 0x1f9f6c0532e1 ; [fp + 24] 0x1f9f6c0532e1 <JS Global Object>
      2: 0x30b09d30c7e1 ; [fp + 16] 0x30b09d30c7e1 <a SymbolObject with map 0x33abe2a6fb29>
      3: 0x130b7e1b3d29 ; [fp - 24] 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      5: 0x30bcea4069a9 ; (literal 6) 0x30bcea4069a9 <Odd Oddball: optimized_out>
      6: 0x1030c9d45689 ; [fp - 80] 0x1030c9d45689 <JS Function isIndependentVariableLikeDeclaration (SharedFunctionInfo 0x2e2f693ee6d1)>
  reading input frame isIndependentVariableLikeDeclaration => node=9, args=2, height=2; inputs:
      0: 0x1030c9d45689 ; (literal 11) 0x1030c9d45689 <JS Function isIndependentVariableLikeDeclaration (SharedFunctionInfo 0x2e2f693ee6d1)>
      1: 0x1f9f6c0532e1 ; (literal 8) 0x1f9f6c0532e1 <JS Global Object>
      2: 0x1d75d86e7859 ; rbx 0x1d75d86e7859 <a NodeObject with map 0x33abe2a71c29>
      3: 0x130b7e1b3d29 ; (literal 9) 0x130b7e1b3d29 <FixedArray[1022]>
      4: 0x30bcea404421 ; rax 0x30bcea404421 <false>
  translating frame isIndependentMember => node=128, height=24
    0x7fff5fbfda28: [top + 64] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfda20: [top + 56] <- 0x30b09d30c7e1 ;  0x30b09d30c7e1 <a SymbolObject with map 0x33abe2a6fb29>  (input #2)
    0x7fff5fbfda18: [top + 48] <- 0x2c21d27bc3af ;  caller's pc
    0x7fff5fbfda10: [top + 40] <- 0x7fff5fbfda70 ;  caller's fp
    0x7fff5fbfda08: [top + 32] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfda00: [top + 24] <- 0x1030c9d455f1 ;  function    0x1030c9d455f1 <JS Function isIndependentMember (SharedFunctionInfo 0x2e2f693ee851)>  (input #0)
    0x7fff5fbfd9f8: [top + 16] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #4)
    0x7fff5fbfd9f0: [top + 8] <- 0x30bcea4069a9 ;  0x30bcea4069a9 <Odd Oddball: optimized_out>  (input #5)
    0x7fff5fbfd9e8: [top + 0] <- 0x1030c9d45689 ;  0x1030c9d45689 <JS Function isIndependentVariableLikeDeclaration (SharedFunctionInfo 0x2e2f693ee6d1)>  (input #6)
  translating frame isIndependentVariableLikeDeclaration => node=9, height=8
    0x7fff5fbfd9e0: [top + 48] <- 0x1f9f6c0532e1 ;  0x1f9f6c0532e1 <JS Global Object>  (input #1)
    0x7fff5fbfd9d8: [top + 40] <- 0x1d75d86e7859 ;  0x1d75d86e7859 <a NodeObject with map 0x33abe2a71c29>  (input #2)
    0x7fff5fbfd9d0: [top + 32] <- 0x2c21d26321b1 ;  caller's pc
    0x7fff5fbfd9c8: [top + 24] <- 0x7fff5fbfda10 ;  caller's fp
    0x7fff5fbfd9c0: [top + 16] <- 0x130b7e1b3d29 ;  context    0x130b7e1b3d29 <FixedArray[1022]>  (input #3)
    0x7fff5fbfd9b8: [top + 8] <- 0x1030c9d45689 ;  function    0x1030c9d45689 <JS Function isIndependentVariableLikeDeclaration (SharedFunctionInfo 0x2e2f693ee6d1)>  (input #0)
    0x7fff5fbfd9b0: [top + 0] <- 0x30bcea404421 ;  0x30bcea404421 <false>  (input #4)
[deoptimizing (eager): end 0x1030c9d455f1 <JS Function isIndependentMember (SharedFunctionInfo 0x2e2f693ee851)> @39 => node=9, pc=0x2c21d2632340, caller sp=0x7fff5fbfda30, state=TOS_REGISTER, took 0.117 ms]
