
## /Users/cevek/Dev/github/v8_IR_Analizer/node_modules/typescript/lib/typescript.js:

### isLineBreak:
<pre class="code">
(ch) {
        // ES5 7.3:
        // The ECMAScript line terminator characters are listed in Table 3.
        //     Table 3: Line Terminator Characters
        //     Code Unit Value     Name                    Formal Name
        //     \x5cu000A              Line Feed               &lt;LF&gt;
        //     \x5cu000D              Carriage Return         &lt;CR&gt;
        //     \x5cu2028              Line separator          &lt;LS&gt;
        //     \x5cu2029              Paragraph separator     &lt;PS&gt;
        // Only the characters in Table 3 are treated as line terminators. Other new line or line
        // breaking characters are treated as white space but not as line terminators.
        return ch === 10 /* lineFeed */ ||
            ch === 13 /* carriageReturn */ ||
            ch === 8232 /* lineSeparator */ ||
            ch === 8233 /* paragraphSeparator */;
    }</pre>



### token:
<pre class="code">
() {
            return currentToken;
        }</pre>



### nextToken:
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>



### parseOptional:
<pre class="code">
(t) {
            if (<b title="Inlined">🔷token</b>() === t) {
                <b title="Inlined">🔷nextToken</b>();
                return true;
            }
            return false;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>



### getStartPos:
<pre class="code">
() { return startPos; }</pre>



### isIdentifierPart:
<pre class="code">
(ch, languageVersion) {
        return ch &gt;= 65 /* A */ && ch &lt;= 90 /* Z */ || ch &gt;= 97 /* a */ && ch &lt;= 122 /* z */ ||
            ch &gt;= 48 /* _0 */ && ch &lt;= 57 /* _9 */ || ch === 36 /* $ */ || ch === 95 /* _ */ ||
            ch &gt; 127 /* maxAsciiCharacter */ && 🔶️<i><b title="CallWithDescriptor">isUnicodeIdentifierPart</b></i>(ch, languageVersion);
    }</pre>



### scan:
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
() {
            startPos = pos;
            hasExtendedUnicodeEscape = false;
            precedingLineBreak = false;
            tokenIsUnterminated = false;
            while (true) {
                tokenPos = pos;
                if (pos &gt;= end) {
                    return token = 1 /* EndOfFileToken */;
                }
                var ch = text.charCodeAt(pos);
                // Special handling for shebang
                if (ch === 35 /* hash */ && pos ⚠️<i><b title="CompareGeneric">=== 0</b></i> && 🔶️<i><b title="CallWithDescriptor">isShebangTrivia</b></i>(text, pos)) {
                    pos = 🔶️<i><b title="CallWithDescriptor">scanShebangTrivia</b></i>(text, pos);
                    if (skipTrivia) {
                        continue;
                    }
                    else {
                        return token = 6 /* ShebangTrivia */;
                    }
                }
                switch (ch) {
                    case 10 /* lineFeed */:
                    case 13 /* carriageReturn */:
                        precedingLineBreak = true;
                        if (skipTrivia) {
                            pos++;
                            continue;
                        }
                        else {
                            if (ch === 13 /* carriageReturn */ && pos + 1 &lt; end && text.charCodeAt(pos + 1) === 10 /* lineFeed */) {
                                // consume both CR and LF
                                pos += 2;
                            }
                            else {
                                pos++;
                            }
                            return token = 4 /* NewLineTrivia */;
                        }
                    case 9 /* tab */:
                    case 11 /* verticalTab */:
                    case 12 /* formFeed */:
                    case 32 /* space */:
                        if (skipTrivia) {
                            pos++;
                            continue;
                        }
                        else {
                            while (pos ⚠️<i><b title="CompareGeneric">< end</b></i> && 🔶<i><b title="Did not inline: target text too big">isWhiteSpaceSingleLine</b></i>(text.🔶️<i><b title="CallWithDescriptor">charCodeAt</b></i>(pos))) {
                                pos++;
                            }
                            return token = 5 /* WhitespaceTrivia */;
                        }
                    case 33 /* exclamation */:
                        if (text.⚠️<i><b title="LoadNamedGeneric">charCodeAt</b></i>(pos ⚠️<i><b title="Add">+ 1</b></i>) ⚠️<i><b title="CompareGeneric">=== 61</b></i> /* equals */) {
                            if (text.⚠️<i><b title="LoadNamedGeneric">charCodeAt</b></i>(pos ⚠️<i><b title="Add">+ 2</b></i>) ⚠️<i><b title="CompareGeneric">=== 61</b></i> /* equals */) {
                                return pos +⚠️<i><b title="Add">= 3</b></i>, token = 34 /* ExclamationEqualsEqualsToken */;
                            }
                            return pos +⚠️<i><b title="Add">= 2</b></i>, token = 32 /* ExclamationEqualsToken */;
                        }
                        pos++;
                        return token = 50 /* ExclamationToken */;
                    case 34 /* doubleQuote */:
                    case 39 /* singleQuote */:
                        tokenValue = 🔶<i><b title="Did not inline: target text too big">scanString</b></i>();
                        return token = 9 /* StringLiteral */;
                    case 96 /* backtick */:
                        return token = 🔶️<i><b title="CallWithDescriptor">scanTemplateAndSetTokenValue</b></i>();
                    case 37 /* percent */:
                        if (text.🔶️<i><b title="CallWithDescriptor">charCodeAt</b></i>(pos ⚠️<i><b title="Add">+ 1</b></i>) ⚠️<i><b title="CompareGeneric">=== 61</b></i> /* equals */) {
                            return pos +⚠️<i><b title="Add">= 2</b></i>, token = 63 /* PercentEqualsToken */;
                        }
                        pos++;
                        return token = 41 /* PercentToken */;
                    case 38 /* ampersand */:
                        if (text.🔶️<i><b title="CallWithDescriptor">charCodeAt</b></i>(pos ⚠️<i><b title="Add">+ 1</b></i>) ⚠️<i><b title="CompareGeneric">=== 38</b></i> /* ampersand */) {
                            return pos +⚠️<i><b title="Add">= 2</b></i>, token = 52 /* AmpersandAmpersandToken */;
                        }
                        if (text.⚠️<i><b title="LoadNamedGeneric">charCodeAt</b></i>(pos ⚠️<i><b title="Add">+ 1</b></i>) ⚠️<i><b title="CompareGeneric">=== 61</b></i> /* equals */) {
                            return pos +⚠️<i><b title="Add">= 2</b></i>, token = 67 /* AmpersandEqualsToken */;
                        }
                        pos++;
                        return token = 47 /* AmpersandToken */;
                    case 40 /* openParen */:
                        pos++;
                        return token = 18 /* OpenParenToken */;
                    case 41 /* closeParen */:
                        pos++;
                        return token = 19 /* CloseParenToken */;
                    case 42 /* asterisk */:
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos +⚠️<i><b title="Add">= 2</b></i>, token = 60 /* AsteriskEqualsToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 42 /* asterisk */) {
                            if (text.🔶️<i><b title="CallWithDescriptor">charCodeAt</b></i>(pos ⚠️<i><b title="Add">+ 2</b></i>) ⚠️<i><b title="CompareGeneric">=== 61</b></i> /* equals */) {
                                return pos +⚠️<i><b title="Add">= 3</b></i>, token = 61 /* AsteriskAsteriskEqualsToken */;
                            }
                            return pos +⚠️<i><b title="Add">= 2</b></i>, token = 39 /* AsteriskAsteriskToken */;
                        }
                        pos++;
                        return token = 38 /* AsteriskToken */;
                    case 43 /* plus */:
                        if (text.🔶️<i><b title="CallWithDescriptor">charCodeAt</b></i>(pos ⚠️<i><b title="Add">+ 1</b></i>) ⚠️<i><b title="CompareGeneric">=== 43</b></i> /* plus */) {
                            return pos +⚠️<i><b title="Add">= 2</b></i>, token = 42 /* PlusPlusToken */;
                        }
                        if (text.🔶️<i><b title="CallWithDescriptor">charCodeAt</b></i>(pos ⚠️<i><b title="Add">+ 1</b></i>) ⚠️<i><b title="CompareGeneric">=== 61</b></i> /* equals */) {
                            return pos +⚠️<i><b title="Add">= 2</b></i>, token = 58 /* PlusEqualsToken */;
                        }
                        pos++;
                        return token = 36 /* PlusToken */;
                    case 44 /* comma */:
                        pos++;
                        return token = 25 /* CommaToken */;
                    case 45 /* minus */:
                        if (text.charCodeAt(pos + 1) === 45 /* minus */) {
                            return pos +⚠️<i><b title="Add">= 2</b></i>, token = 43 /* MinusMinusToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos +⚠️<i><b title="Add">= 2</b></i>, token = 59 /* MinusEqualsToken */;
                        }
                        pos++;
                        return token = 37 /* MinusToken */;
                    case 46 /* dot */:
                        if (<b title="Inlined">🔷isDigit</b>(text.charCodeAt(pos + 1))) {
                            tokenValue = 🔶️<i><b title="CallWithDescriptor">scanNumber</b></i>();
                            return token = 8 /* NumericLiteral */;
                        }
                        if (text.charCodeAt(pos + 1) === 46 /* dot */ && text.charCodeAt(pos + 2) === 46 /* dot */) {
                            return pos += 3, token = 23 /* DotDotDotToken */;
                        }
                        pos++;
                        return token = 22 /* DotToken */;
                    case 47 /* slash */:
                        // Single-line comment
                        if (text.charCodeAt(pos + 1) === 47 /* slash */) {
                            pos += 2;
                            while (pos &lt; end) {
                                if (🔶<i><b title="Did not inline: target text too big">isLineBreak</b></i>(text.charCodeAt(pos))) {
                                    break;
                                }
                                pos++;
                            }
                            if (skipTrivia) {
                                continue;
                            }
                            else {
                                return token = 2 /* SingleLineCommentTrivia */;
                            }
                        }
                        // Multi-line comment
                        if (text.charCodeAt(pos + 1) === 42 /* asterisk */) {
                            pos += 2;
                            var commentClosed = false;
                            while (pos &lt; end) {
                                var ch_2 = text.charCodeAt(pos);
                                if (ch_2 === 42 /* asterisk */ && text.charCodeAt(pos + 1) === 47 /* slash */) {
                                    pos += 2;
                                    commentClosed = true;
                                    break;
                                }
                                if (🔶<i><b title="Did not inline: target text too big">isLineBreak</b></i>(ch_2)) {
                                    precedingLineBreak = true;
                                }
                                pos++;
                            }
                            if (!commentClosed) {
                                🔶️<i><b title="CallWithDescriptor">error</b></i>(ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Asterisk_Slash_expected</b></i>);
                            }
                            if (skipTrivia) {
                                continue;
                            }
                            else {
                                tokenIsUnterminated = !commentClosed;
                                return token = 3 /* MultiLineCommentTrivia */;
                            }
                        }
                        if (text.⚠️<i><b title="LoadNamedGeneric">charCodeAt</b></i>(pos ⚠️<i><b title="Add">+ 1</b></i>) ⚠️<i><b title="CompareGeneric">=== 61</b></i> /* equals */) {
                            return pos +⚠️<i><b title="Add">= 2</b></i>, token = 62 /* SlashEqualsToken */;
                        }
                        pos++;
                        return token = 40 /* SlashToken */;
                    case 48 /* _0 */:
                        if (pos + 2 &lt; end && (text.⚠️<i><b title="LoadNamedGeneric">charCodeAt</b></i>(pos + 1) === 88 /* X */ || text.⚠️<i><b title="LoadNamedGeneric">charCodeAt</b></i>(pos + 1) === 120 /* x */)) {
                            pos +⚠️<i><b title="Add">= 2</b></i>;
                            var value = 🔶️<i><b title="CallWithDescriptor">scanMinimumNumberOfHexDigits</b></i>(1);
                            if (value ⚠️<i><b title="CompareGeneric">< 0</b></i>) {
                                🔶️<i><b title="CallWithDescriptor">error</b></i>(ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Hexadecimal_digit_expected</b></i>);
                                value = 0;
                            }
                            tokenValue = "" + value;
                            return token = 8 /* NumericLiteral */;
                        }
                        else if (pos + 2 &lt; end && (text.⚠️<i><b title="LoadNamedGeneric">charCodeAt</b></i>(pos + 1) === 66 /* B */ || text.🔶️<i><b title="CallWithDescriptor">charCodeAt</b></i>(pos + 1) === 98 /* b */)) {
                            pos +⚠️<i><b title="Add">= 2</b></i>;
                            var value = 🔶️<i><b title="CallWithDescriptor">scanBinaryOrOctalDigits</b></i>(/* base */ 2);
                            if (value &lt; 0) {
                                🔶️<i><b title="CallWithDescriptor">error</b></i>(ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Binary_digit_expected</b></i>);
                                value = 0;
                            }
                            tokenValue = "" + value;
                            return token = 8 /* NumericLiteral */;
                        }
                        else if (pos + 2 &lt; end && (text.🔶️<i><b title="CallWithDescriptor">charCodeAt</b></i>(pos + 1) === 79 /* O */ || text.🔶️<i><b title="CallWithDescriptor">charCodeAt</b></i>(pos + 1) === 111 /* o */)) {
                            pos +⚠️<i><b title="Add">= 2</b></i>;
                            var value = 🔶️<i><b title="CallWithDescriptor">scanBinaryOrOctalDigits</b></i>(/* base */ 8);
                            if (value &lt; 0) {
                                🔶️<i><b title="CallWithDescriptor">error</b></i>(ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Octal_digit_expected</b></i>);
                                value = 0;
                            }
                            tokenValue = "" + value;
                            return token = 8 /* NumericLiteral */;
                        }
                        // Try to parse as an octal
                        if (pos + 1 &lt; end && <b title="Inlined">🔷isOctalDigit</b>(text.⚠️<i><b title="LoadNamedGeneric">charCodeAt</b></i>(pos + 1))) {
                            tokenValue = "" + 🔶️<i><b title="CallWithDescriptor">scanOctalDigits</b></i>();
                            return token = 8 /* NumericLiteral */;
                        }
                    // This fall-through is a deviation from the EcmaScript grammar. The grammar says that a leading zero
                    // can only be followed by an octal digit, a dot, or the end of the number literal. However, we are being
                    // permissive and allowing decimal digits of the form 08* and 09* (which many browsers also do).
                    case 49 /* _1 */:
                    case 50 /* _2 */:
                    case 51 /* _3 */:
                    case 52 /* _4 */:
                    case 53 /* _5 */:
                    case 54 /* _6 */:
                    case 55 /* _7 */:
                    case 56 /* _8 */:
                    case 57 /* _9 */:
                        tokenValue = 🔶️<i><b title="CallWithDescriptor">scanNumber</b></i>();
                        return token = 8 /* NumericLiteral */;
                    case 58 /* colon */:
                        pos++;
                        return token = 55 /* ColonToken */;
                    case 59 /* semicolon */:
                        pos++;
                        return token = 24 /* SemicolonToken */;
                    case 60 /* lessThan */:
                        if (🔶️<i><b title="CallWithDescriptor">isConflictMarkerTrivia</b></i>(text, pos)) {
                            pos = 🔶️<i><b title="CallWithDescriptor">scanConflictMarkerTrivia</b></i>(text, pos, error);
                            if (skipTrivia) {
                                continue;
                            }
                            else {
                                return token = 7 /* ConflictMarkerTrivia */;
                            }
                        }
                        if (text.charCodeAt(pos + 1) === 60 /* lessThan */) {
                            if (text.⚠️<i><b title="LoadNamedGeneric">charCodeAt</b></i>(pos ⚠️<i><b title="Add">+ 2</b></i>) ⚠️<i><b title="CompareGeneric">=== 61</b></i> /* equals */) {
                                return pos +⚠️<i><b title="Add">= 3</b></i>, token = 64 /* LessThanLessThanEqualsToken */;
                            }
                            return pos +⚠️<i><b title="Add">= 2</b></i>, token = 44 /* LessThanLessThanToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos +⚠️<i><b title="Add">= 2</b></i>, token = 29 /* LessThanEqualsToken */;
                        }
                        if (languageVariant === 1 /* JSX */ &&
                            text.🔶️<i><b title="CallWithDescriptor">charCodeAt</b></i>(pos ⚠️<i><b title="Add">+ 1</b></i>) ⚠️<i><b title="CompareGeneric">=== 47</b></i> /* slash */ &&
                            text.🔶️<i><b title="CallWithDescriptor">charCodeAt</b></i>(pos ⚠️<i><b title="Add">+ 2</b></i>) ⚠️<i><b title="CompareGeneric">!== 42</b></i> /* asterisk */) {
                            return pos +⚠️<i><b title="Add">= 2</b></i>, token = 27 /* LessThanSlashToken */;
                        }
                        pos++;
                        return token = 26 /* LessThanToken */;
                    case 61 /* equals */:
                        if (🔶️<i><b title="CallWithDescriptor">isConflictMarkerTrivia</b></i>(text, pos)) {
                            pos = 🔶️<i><b title="CallWithDescriptor">scanConflictMarkerTrivia</b></i>(text, pos, error);
                            if (skipTrivia) {
                                continue;
                            }
                            else {
                                return token = 7 /* ConflictMarkerTrivia */;
                            }
                        }
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            if (text.⚠️<i><b title="LoadNamedGeneric">charCodeAt</b></i>(pos ⚠️<i><b title="Add">+ 2</b></i>) ⚠️<i><b title="CompareGeneric">=== 61</b></i> /* equals */) {
                                return pos +⚠️<i><b title="Add">= 3</b></i>, token = 33 /* EqualsEqualsEqualsToken */;
                            }
                            return pos +⚠️<i><b title="Add">= 2</b></i>, token = 31 /* EqualsEqualsToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 62 /* greaterThan */) {
                            return pos += 2, token = 35 /* EqualsGreaterThanToken */;
                        }
                        pos++;
                        return token = 57 /* EqualsToken */;
                    case 62 /* greaterThan */:
                        if (🔶️<i><b title="CallWithDescriptor">isConflictMarkerTrivia</b></i>(text, pos)) {
                            pos = 🔶️<i><b title="CallWithDescriptor">scanConflictMarkerTrivia</b></i>(text, pos, error);
                            if (skipTrivia) {
                                continue;
                            }
                            else {
                                return token = 7 /* ConflictMarkerTrivia */;
                            }
                        }
                        pos++;
                        return token = 28 /* GreaterThanToken */;
                    case 63 /* question */:
                        pos++;
                        return token = 54 /* QuestionToken */;
                    case 91 /* openBracket */:
                        pos++;
                        return token = 20 /* OpenBracketToken */;
                    case 93 /* closeBracket */:
                        pos++;
                        return token = 21 /* CloseBracketToken */;
                    case 94 /* caret */:
                        if (text.🔶️<i><b title="CallWithDescriptor">charCodeAt</b></i>(pos ⚠️<i><b title="Add">+ 1</b></i>) ⚠️<i><b title="CompareGeneric">=== 61</b></i> /* equals */) {
                            return pos +⚠️<i><b title="Add">= 2</b></i>, token = 69 /* CaretEqualsToken */;
                        }
                        pos++;
                        return token = 49 /* CaretToken */;
                    case 123 /* openBrace */:
                        pos++;
                        return token = 16 /* OpenBraceToken */;
                    case 124 /* bar */:
                        if (text.charCodeAt(pos + 1) === 124 /* bar */) {
                            return pos +⚠️<i><b title="Add">= 2</b></i>, token = 53 /* BarBarToken */;
                        }
                        if (text.charCodeAt(pos + 1) === 61 /* equals */) {
                            return pos +⚠️<i><b title="Add">= 2</b></i>, token = 68 /* BarEqualsToken */;
                        }
                        pos++;
                        return token = 48 /* BarToken */;
                    case 125 /* closeBrace */:
                        pos++;
                        return token = 17 /* CloseBraceToken */;
                    case 126 /* tilde */:
                        pos++;
                        return token = 51 /* TildeToken */;
                    case 64 /* at */:
                        pos++;
                        return token = 56 /* AtToken */;
                    case 92 /* backslash */:
                        var cookedChar = 🔶️<i><b title="CallWithDescriptor">peekUnicodeEscape</b></i>();
                        if (cookedChar &gt;= 0 && 🔶<i><b title="Did not inline: unknown">isIdentifierStart</b></i>(cookedChar, languageVersion)) {
                            pos +⚠️<i><b title="Add">= 6</b></i>;
                            tokenValue = String.fromCharCode(cookedChar) ⚠️<i><b title="Add">+ scanIdentifierParts</b></i>();
                            return token = 🔶<i><b title="Did not inline: unknown">getIdentifierToken</b></i>();
                        }
                        🔶️<i><b title="CallWithDescriptor">error</b></i>(ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Invalid_character</b></i>);
                        pos++;
                        return token = 0 /* Unknown */;
                    default:
                        if (<b title="Inlined">🔷isIdentifierStart</b>(ch, languageVersion)) {
                            pos++;
                            while (pos &lt; end && <b title="Inlined">🔷isIdentifierPart</b>(ch = text.charCodeAt(pos), languageVersion))
                                pos++;
                            tokenValue = text.🔶<i><b title="Did not inline: unknown">substring</b></i>(tokenPos, pos);
                            if (ch === 92 /* backslash */) {
                                tokenValue +⚠️<i><b title="Add">= scanIdentifierParts</b></i>();
                            }
                            return token = 🔶<i><b title="Did not inline: unknown">getIdentifierToken</b></i>();
                        }
                        else if (🔶<i><b title="Did not inline: target text too big">isWhiteSpaceSingleLine</b></i>(ch)) {
                            pos++;
                            continue;
                        }
                        else if (🔶<i><b title="Did not inline: target text too big">isLineBreak</b></i>(ch)) {
                            precedingLineBreak = true;
                            pos++;
                            continue;
                        }
                        🔶️<i><b title="CallWithDescriptor">error</b></i>(ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Invalid_character</b></i>);
                        pos++;
                        return token = 0 /* Unknown */;
                }
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>isDigit</summary>
<pre class="code">
(ch) {
        return ch &gt;= 48 /* _0 */ && ch &lt;= 57 /* _9 */;
    }</pre>

</details>
<details>
<summary>isOctalDigit</summary>
<pre class="code">
(ch) {
        return ch &gt;= 48 /* _0 */ && ch ⚠️<i><b title="CompareGeneric"><= 55</b></i> /* _7 */;
    }</pre>

</details>
<details>
<summary>isIdentifierStart</summary>
<pre class="code">
(ch, languageVersion) {
        return ch &gt;= 65 /* A */ && ch &lt;= 90 /* Z */ || ch &gt;= 97 /* a */ && ch &lt;= 122 /* z */ ||
            ch === 36 /* $ */ || ch === 95 /* _ */ ||
            ch &gt; 127 /* maxAsciiCharacter */ && 🔶️<i><b title="CallWithDescriptor">isUnicodeIdentifierStart</b></i>(ch, languageVersion);
    }</pre>

</details>
<details>
<summary>isIdentifierPart</summary>
<pre class="code">
(ch, languageVersion) {
        return ch &gt;= 65 /* A */ && ch &lt;= 90 /* Z */ || ch &gt;= 97 /* a */ && ch &lt;= 122 /* z */ ||
            ch &gt;= 48 /* _0 */ && ch &lt;= 57 /* _9 */ || ch === 36 /* $ */ || ch === 95 /* _ */ ||
            ch &gt; 127 /* maxAsciiCharacter */ && 🔶️<i><b title="CallWithDescriptor">isUnicodeIdentifierPart</b></i>(ch, languageVersion);
    }</pre>

</details>
</blockquote>



### hasPrecedingLineBreak:
<pre class="code">
() { return precedingLineBreak; }</pre>



### createNode:
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>



### finishNode:
<pre class="code">
(node, end) {
            node.end ⚠️<i><b title="StoreNamedGeneric">= end</b></i> === undefined ? scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>() : end;
            if (contextFlags) {
                node.flags ⚠️<i><b title="StoreNamedGeneric">|= contextFlags</b></i>;
            }
            // Keep track on the node if we encountered an error while parsing it.  If we did, then
            // we cannot reuse the node incrementally.  Once we've marked this node, clear out the
            // flag so that we don't mark any subsequent nodes.
            if (parseErrorBeforeNextFinishedNode) {
                parseErrorBeforeNextFinishedNode = false;
                node.flags ⚠️<i><b title="StoreNamedGeneric">|= 32768</b></i> /* ThisNodeHasError */;
            }
            return node;
        }</pre>



### speculationHelper:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(callback, isLookahead) {
            var savePos = pos;
            var saveStartPos = startPos;
            var saveTokenPos = tokenPos;
            var saveToken = token;
            var saveTokenValue = tokenValue;
            var savePrecedingLineBreak = precedingLineBreak;
            var result = 🔶️<i><b title="CallWithDescriptor">callback</b></i>();
            // If our callback returned something 'falsy' or we're just looking ahead,
            // then unconditionally restore us to where we were.
            if (!result || isLookahead) {
                pos = savePos;
                startPos = saveStartPos;
                tokenPos = saveTokenPos;
                token = saveToken;
                tokenValue = saveTokenValue;
                precedingLineBreak = savePrecedingLineBreak;
            }
            return result;
        }</pre>



### getIdentifierToken:
<pre class="code">
() {
            // Reserved words are between 2 and 11 characters long and start with a lowercase letter
            var len = tokenValue.length;
            if (len &gt;= 2 && len &lt;= 11) {
                var ch = tokenValue.charCodeAt(0);
                if (ch &gt;= 97 /* a */ && ch &lt;= 122 /* z */ && hasOwnProperty.🔶️<i><b title="CallWithDescriptor">call</b></i>(textToToken, tokenValue)) {
                    return token = textToToken⚠️<i><b title="LoadKeyedGeneric">[tokenValue]</b></i>;
                }
            }
            return token = 70 /* Identifier */;
        }</pre>



### createIdentifier:
<pre class="code">
(isIdentifier, diagnosticMessage) {
            identifierCount++;
            if (isIdentifier) {
                var node = <b title="Inlined">🔷createNode</b>(70 /* Identifier */);
                // Store original token kind if it is not just an Identifier so we can report appropriate error later in type checker
                if (<b title="Inlined">🔷token</b>() !== 70 /* Identifier */) {
                    node.originalKeywordKind = <b title="Inlined">🔷token</b>();
                }
                node.text ⚠️<i><b title="StoreNamedGeneric">= internIdentifier</b></i>(scanner.🔶<i><b title="Did not inline: unknown">getTokenValue</b></i>());
                <b title="Inlined">🔷nextToken</b>();
                return 🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(node);
            }
            return 🔶️<i><b title="CallWithDescriptor">createMissingNode</b></i>(70 /* Identifier */, /*reportAtCurrentPosition*/ false, diagnosticMessage || ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Identifier_expected</b></i>);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createNode</summary>
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>internIdentifier</summary>
<pre class="code">
(text) {
            text = ts.🔶<i><b title="Did not inline: unknown">escapeIdentifier</b></i>(text);
            return identifiers⚠️<i><b title="LoadKeyedGeneric">[text]</b></i> || (identifiers[text] ⚠️<i><b title="StoreKeyedGeneric">= text</b></i>);
        }</pre>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>



### getTokenValue:
<pre class="code">
() { return tokenValue; }</pre>



### escapeIdentifier:
<pre class="code">
(identifier) {
        return identifier.length &gt;= 2 && identifier.charCodeAt(0) === 95 /* _ */ && identifier.charCodeAt(1) === 95 /* _ */ ? "_" + identifier : identifier;
    }</pre>



### nextJSDocToken:
<pre class="code">
() {
                    return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scanJSDocToken</b></i>();
                }</pre>



### getTokenText:
<pre class="code">
() { return text.🔶<i><b title="Did not inline: unknown">substring</b></i>(tokenPos, pos); }</pre>



### parseIdentifier:
<pre class="code">
(diagnosticMessage) {
            return 🔶<i><b title="Did not inline: target text too big">createIdentifier</b></i>(🔶<i><b title="Did not inline: target text too big">isIdentifier</b></i>(), diagnosticMessage);
        }</pre>



### parseListElement:
<pre class="code">
(parsingContext, parseElement) {
            var node = 🔶<i><b title="Did not inline: target text too big">currentNode</b></i>(parsingContext);
            if (node) {
                return 🔶️<i><b title="CallWithDescriptor">consumeNode</b></i>(node);
            }
            return 🔶️<i><b title="CallWithDescriptor">parseElement</b></i>();
        }</pre>



### isWhiteSpaceSingleLine:
<pre class="code">
(ch) {
        // Note: nextLine is in the Zs space, and should be considered to be a whitespace.
        // It is explicitly not a line-break as it isn't in the exact set specified by EcmaScript.
        return ch === 32 /* space */ ||
            ch === 9 /* tab */ ||
            ch === 11 /* verticalTab */ ||
            ch === 12 /* formFeed */ ||
            ch === 160 /* nonBreakingSpace */ ||
            ch === 133 /* nextLine */ ||
            ch === 5760 /* ogham */ ||
            ch &gt;= 8192 /* enQuad */ && ch ⚠️<i><b title="CompareGeneric"><= 8203</b></i> /* zeroWidthSpace */ ||
            ch === 8239 /* narrowNoBreakSpace */ ||
            ch === 8287 /* mathematicalSpace */ ||
            ch === 12288 /* ideographicSpace */ ||
            ch === 65279 /* byteOrderMark */;
    }</pre>



### isIdentifier:
<pre class="code">
() {
            if (<b title="Inlined">🔷token</b>() === 70 /* Identifier */) {
                return true;
            }
            // If we have a 'yield' keyword, and we're in the [yield] context, then 'yield' is
            // considered a keyword and is not an identifier.
            if (<b title="Inlined">🔷token</b>() === 115 /* YieldKeyword */ && 🔶️<i><b title="CallWithDescriptor">inYieldContext</b></i>()) {
                return false;
            }
            // If we have a 'await' keyword, and we're in the [Await] context, then 'await' is
            // considered a keyword and is not an identifier.
            if (<b title="Inlined">🔷token</b>() === 120 /* AwaitKeyword */ && 🔶️<i><b title="CallWithDescriptor">inAwaitContext</b></i>()) {
                return false;
            }
            return <b title="Inlined">🔷token</b>() &gt; 106 /* LastReservedWord */;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>



### isIdentifierStart:
<pre class="code">
(ch, languageVersion) {
        return ch &gt;= 65 /* A */ && ch &lt;= 90 /* Z */ || ch &gt;= 97 /* a */ && ch &lt;= 122 /* z */ ||
            ch === 36 /* $ */ || ch === 95 /* _ */ ||
            ch &gt; 127 /* maxAsciiCharacter */ && 🔶️<i><b title="CallWithDescriptor">isUnicodeIdentifierStart</b></i>(ch, languageVersion);
    }</pre>



### ⛔ pushComment (deoptimizated):
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(text) {
                        if (!margin) {
                            margin = indent;
                        }
                        comments.push(text);
                        indent += text.length;
                    }</pre>

```diff
- Deopt: <JS Function doOutsideOfContext (SharedFunctionInfo 0x3504a53f1271)> (opt #33) @20, FP to SP delta: 248, caller sp: 0x7fff5fbfd678
```



### getLeadingCommentRanges:
<pre class="code">
(text, pos) {
        return <b title="Inlined">🔷reduceEachLeadingCommentRange</b>(text, pos, appendCommentRange, undefined, undefined);
    }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>reduceEachLeadingCommentRange</summary>
<pre class="code">
(text, pos, cb, state, initial) {
        return 🔶<i><b title="Did not inline: target text too big">iterateCommentRanges</b></i>(/*reduce*/ true, text, pos, /*trailing*/ false, cb, state, initial);
    }</pre>

</details>
</blockquote>



### iterateCommentRanges:
<pre class="code">
(reduce, text, pos, trailing, cb, state, initial) {
        var pendingPos;
        var pendingEnd;
        var pendingKind;
        var pendingHasTrailingNewLine;
        var hasPendingCommentRange = false;
        var collecting = trailing || pos === 0;
        var accumulator = initial;
        scan: while (pos &gt;= 0 && pos &lt; text.length) {
            var ch = text.charCodeAt(pos);
            switch (ch) {
                case 13 /* carriageReturn */:
                    if (text.charCodeAt(pos + 1) === 10 /* lineFeed */) {
                        pos++;
                    }
                case 10 /* lineFeed */:
                    pos++;
                    if (trailing) {
                        break scan;
                    }
                    collecting = true;
                    if (hasPendingCommentRange) {
                        pendingHasTrailingNewLine = true;
                    }
                    continue;
                case 9 /* tab */:
                case 11 /* verticalTab */:
                case 12 /* formFeed */:
                case 32 /* space */:
                    pos++;
                    continue;
                case 47 /* slash */:
                    var nextChar = text.charCodeAt(pos + 1);
                    var hasTrailingNewLine = false;
                    if (nextChar === 47 /* slash */ || nextChar === 42 /* asterisk */) {
                        var kind = nextChar === 47 /* slash */ ? 2 /* SingleLineCommentTrivia */ : 3 /* MultiLineCommentTrivia */;
                        var startPos = pos;
                        pos += 2;
                        if (nextChar === 47 /* slash */) {
                            while (pos &lt; text.length) {
                                if (🔶<i><b title="Did not inline: target text too big">isLineBreak</b></i>(text.charCodeAt(pos))) {
                                    hasTrailingNewLine = true;
                                    break;
                                }
                                pos++;
                            }
                        }
                        else {
                            while (pos &lt; text.length) {
                                if (text.charCodeAt(pos) === 42 /* asterisk */ && text.charCodeAt(pos + 1) === 47 /* slash */) {
                                    pos += 2;
                                    break;
                                }
                                pos++;
                            }
                        }
                        if (collecting) {
                            if (hasPendingCommentRange) {
                                accumulator = <b title="Inlined">🔷cb</b>(pendingPos, pendingEnd, pendingKind, pendingHasTrailingNewLine, state, accumulator);
                                if (!reduce && accumulator) {
                                    // If we are not reducing and we have a truthy result, return it.
                                    return accumulator;
                                }
                                hasPendingCommentRange = false;
                            }
                            pendingPos = startPos;
                            pendingEnd = pos;
                            pendingKind = kind;
                            pendingHasTrailingNewLine = hasTrailingNewLine;
                            hasPendingCommentRange = true;
                        }
                        continue;
                    }
                    break scan;
                default:
                    if (ch &gt; 127 /* maxAsciiCharacter */ && (🔶️<i><b title="CallWithDescriptor">isWhiteSpace</b></i>(ch))) {
                        if (hasPendingCommentRange && 🔶<i><b title="Did not inline: target text too big">isLineBreak</b></i>(ch)) {
                            pendingHasTrailingNewLine = true;
                        }
                        pos++;
                        continue;
                    }
                    break scan;
            }
        }
        if (hasPendingCommentRange) {
            accumulator = <b title="Inlined">🔷cb</b>(pendingPos, pendingEnd, pendingKind, pendingHasTrailingNewLine, state, accumulator);
        }
        return accumulator;
    }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>cb</summary>
<pre class="code">
(pos, end, kind, hasTrailingNewLine, _state, comments) {
        if (!comments) {
            comments = [];
        }
        comments.push({ pos: pos, end: end, hasTrailingNewLine: hasTrailingNewLine, kind: kind });
        return comments;
    }</pre>

</details>
<details>
<summary>cb</summary>
<pre class="code">
(pos, end, kind, hasTrailingNewLine, _state, comments) {
        if (!comments) {
            comments = [];
        }
        comments.push({ pos: pos, end: end, hasTrailingNewLine: hasTrailingNewLine, kind: kind });
        return comments;
    }</pre>

</details>
</blockquote>



### tryParse:
<pre class="code">
(callback) {
            return 🔶<i><b title="Did not inline: target text too big">speculationHelper</b></i>(callback, /*isLookAhead*/ false);
        }</pre>



### parseIntersectionTypeOrHigher:
<pre class="code">
() {
            return <b title="Inlined">🔷parseUnionOrIntersectionType</b>(165 /* IntersectionType */, parseTypeOperatorOrHigher, 47 /* AmpersandToken */);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>parseUnionOrIntersectionType</summary>
<pre class="code">
(kind, parseConstituentType, operator) {
            <b title="Inlined">🔷parseOptional</b>(operator);
            var type = parseConstituentType();
            if (<b title="Inlined">🔷token</b>() === operator) {
                var types = <b title="Inlined">🔷createNodeArray</b>([type], type.pos);
                while (<b title="Inlined">🔷parseOptional</b>(operator)) {
                    types.push(🔶️<i><b title="CallWithDescriptor">parseConstituentType</b></i>());
                }
                types.end = <b title="Inlined">🔷getNodeEnd</b>();
                var node = <b title="Inlined">🔷createNode</b>(kind, type.pos);
                node.types = types;
                type = 🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(node);
            }
            return type;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>parseOptional</summary>
<pre class="code">
(t) {
            if (<b title="Inlined">🔷token</b>() === t) {
                <b title="Inlined">🔷nextToken</b>();
                return true;
            }
            return false;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>createNodeArray</summary>
<pre class="code">
(elements, pos) {
            var array = (elements || []);
            if (!(pos &gt;= 0)) {
                pos = <b title="Inlined">🔷getNodePos</b>();
            }
            array.pos ⚠️<i><b title="StoreNamedGeneric">= pos</b></i>;
            array.end = pos;
            return array;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getNodePos</summary>
<pre class="code">
() {
            return scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>parseOptional</summary>
<pre class="code">
(t) {
            if (<b title="Inlined">🔷token</b>() === t) {
                <b title="Inlined">🔷nextToken</b>();
                return true;
            }
            return false;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>getNodeEnd</summary>
<pre class="code">
() {
            return scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
        }</pre>

</details>
<details>
<summary>createNode</summary>
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>



### parseTypeOperatorOrHigher:
<pre class="code">
() {
            switch (<b title="Inlined">🔷token</b>()) {
                case 126 /* KeyOfKeyword */:
                    return 🔶<i><b title="Did not inline: unknown">parseTypeOperator</b></i>(126 /* KeyOfKeyword */);
            }
            return 🔶<i><b title="Did not inline: target text too big">parseArrayTypeOrHigher</b></i>();
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>



### isStartOfFunctionType:
<pre class="code">
() {
            if (<b title="Inlined">🔷token</b>() === 26 /* LessThanToken */) {
                return true;
            }
            return <b title="Inlined">🔷token</b>() === 18 /* OpenParenToken */ && <b title="Inlined">🔷lookAhead</b>(isUnambiguouslyStartOfFunctionType);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>lookAhead</summary>
<pre class="code">
(callback) {
            return 🔶<i><b title="Did not inline: target text too big">speculationHelper</b></i>(callback, /*isLookAhead*/ true);
        }</pre>

</details>
</blockquote>



### parseType:
<pre class="code">
() {
            // The rules about 'yield' only apply to actual code/expression contexts.  They don't
            // apply to 'type' contexts.  So we disable these parameters here before moving on.
            return 🔶<i><b title="Did not inline: target text too big">doOutsideOfContext</b></i>(20480 /* TypeExcludesFlags */, parseTypeWorker);
        }</pre>



### doOutsideOfContext:
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(context, func) {
            // contextFlagsToClear will contain only the context flags that are
            // currently set that we need to temporarily clear
            // We don't just blindly reset to the previous flags to ensure
            // that we do not mutate cached flags for the incremental
            // parser (ThisNodeHasError, ThisNodeOrAnySubNodesHasError, and
            // HasAggregatedChildData).
            var contextFlagsToClear = context & contextFlags;
            if (contextFlagsToClear) {
                // clear the requested context flags
                🔶<i><b title="Did not inline: unknown">setContextFlag</b></i>(/*val*/ false, contextFlagsToClear);
                var result = 🔶️<i><b title="CallWithDescriptor">func</b></i>();
                // restore the context flags we just cleared
                🔶<i><b title="Did not inline: unknown">setContextFlag</b></i>(/*val*/ true, contextFlagsToClear);
                return result;
            }
            // no need to do anything special as we are not in any of the requested contexts
            return 🔶️<i><b title="CallWithDescriptor">func</b></i>();
        }</pre>



### getTokenPos:
<pre class="code">
() { return tokenPos; }</pre>



### TokenOrIdentifierObject:
<pre class="code">
(pos, end) {
            // Set properties in same order as NodeObject
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.parent = undefined;
        }</pre>



### parseTypeWorker:
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
() {
            if (<b title="Inlined">🔷isStartOfFunctionType</b>()) {
                return <b title="Inlined">🔷parseFunctionOrConstructorType</b>(158 /* FunctionType */);
            }
            if (<b title="Inlined">🔷token</b>() === 93 /* NewKeyword */) {
                return <b title="Inlined">🔷parseFunctionOrConstructorType</b>(159 /* ConstructorType */);
            }
            return <b title="Inlined">🔷parseUnionTypeOrHigher</b>();
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>isStartOfFunctionType</summary>
<pre class="code">
() {
            if (<b title="Inlined">🔷token</b>() === 26 /* LessThanToken */) {
                return true;
            }
            return <b title="Inlined">🔷token</b>() === 18 /* OpenParenToken */ && <b title="Inlined">🔷lookAhead</b>(isUnambiguouslyStartOfFunctionType);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>lookAhead</summary>
<pre class="code">
(callback) {
            return 🔶<i><b title="Did not inline: target text too big">speculationHelper</b></i>(callback, /*isLookAhead*/ true);
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>parseFunctionOrConstructorType</summary>
<pre class="code">
(kind) {
            var node = <b title="Inlined">🔷createNode</b>(kind);
            if (kind === 159 /* ConstructorType */) {
                🔶<i><b title="Did not inline: target text too big">parseExpected</b></i>(93 /* NewKeyword */);
            }
            🔶<i><b title="Did not inline: target text too big">fillSignature</b></i>(35 /* EqualsGreaterThanToken */, /*yieldContext*/ false, /*awaitContext*/ false, /*requireCompleteParameterList*/ false, node);
            return 🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(node);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createNode</summary>
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>parseFunctionOrConstructorType</summary>
<pre class="code">
(kind) {
            var node = <b title="Inlined">🔷createNode</b>(kind);
            if (kind === 159 /* ConstructorType */) {
                🔶<i><b title="Did not inline: target text too big">parseExpected</b></i>(93 /* NewKeyword */);
            }
            🔶<i><b title="Did not inline: target text too big">fillSignature</b></i>(35 /* EqualsGreaterThanToken */, /*yieldContext*/ false, /*awaitContext*/ false, /*requireCompleteParameterList*/ false, node);
            return 🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(node);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createNode</summary>
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>parseUnionTypeOrHigher</summary>
<pre class="code">
() {
            return <b title="Inlined">🔷parseUnionOrIntersectionType</b>(164 /* UnionType */, parseIntersectionTypeOrHigher, 48 /* BarToken */);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>parseUnionOrIntersectionType</summary>
<pre class="code">
(kind, parseConstituentType, operator) {
            <b title="Inlined">🔷parseOptional</b>(operator);
            var type = 🔶️<i><b title="CallWithDescriptor">parseConstituentType</b></i>();
            if (<b title="Inlined">🔷token</b>() === operator) {
                var types = <b title="Inlined">🔷createNodeArray</b>([type], type⚠️<i><b title="LoadNamedGeneric">.pos</b></i>);
                while (<b title="Inlined">🔷parseOptional</b>(operator)) {
                    types.push(<b title="Inlined">🔷parseConstituentType</b>());
                }
                types.end = <b title="Inlined">🔷getNodeEnd</b>();
                var node = 🔶<i><b title="Did not inline: unknown">createNode</b></i>(kind, type⚠️<i><b title="LoadNamedGeneric">.pos</b></i>);
                node.types = types;
                type = 🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(node);
            }
            return type;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>parseOptional</summary>
<pre class="code">
(t) {
            if (<b title="Inlined">🔷token</b>() === t) {
                <b title="Inlined">🔷nextToken</b>();
                return true;
            }
            return false;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>createNodeArray</summary>
<pre class="code">
(elements, pos) {
            var array = (elements || []);
            if (!(pos &gt;= 0)) {
                pos = <b title="Inlined">🔷getNodePos</b>();
            }
            array.pos ⚠️<i><b title="StoreNamedGeneric">= pos</b></i>;
            array.end = pos;
            return array;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getNodePos</summary>
<pre class="code">
() {
            return scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>parseOptional</summary>
<pre class="code">
(t) {
            if (<b title="Inlined">🔷token</b>() === t) {
                <b title="Inlined">🔷nextToken</b>();
                return true;
            }
            return false;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>parseConstituentType</summary>
<pre class="code">
() {
            return 🔶️<i><b title="CallWithDescriptor">parseUnionOrIntersectionType</b></i>(165 /* IntersectionType */, parseTypeOperatorOrHigher, 47 /* AmpersandToken */);
        }</pre>

</details>
<details>
<summary>getNodeEnd</summary>
<pre class="code">
() {
            return scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>



### createNodeArray:
<pre class="code">
(elements, pos) {
            var array = (elements || []);
            if (!(pos &gt;= 0)) {
                pos = <b title="Inlined">🔷getNodePos</b>();
            }
            array.pos ⚠️<i><b title="StoreNamedGeneric">= pos</b></i>;
            array.end = pos;
            return array;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getNodePos</summary>
<pre class="code">
() {
            return scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
        }</pre>

</details>
</blockquote>



### ⛔ lookAhead (deoptimizated):
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(callback) {
            return 🔶<i><b title="Did not inline: target text too big">speculationHelper</b></i>(callback, /*isLookahead*/ true);
        }</pre>

```diff
- Deopt: <JS Function doOutsideOfContext (SharedFunctionInfo 0x3504a53f1271)> (opt #58) @3, FP to SP delta: 248, caller sp: 0x7fff5fbfd820
```

```diff
- Deopt: <JS Function isLiteralPropertyName (SharedFunctionInfo 0x3504a53f34f1)> (opt #56) @6, FP to SP delta: 32, caller sp: 0x7fff5fbfdad0
```

```diff
- Deopt: <JS Function scan (SharedFunctionInfo 0x16f3adb53cc1)> (opt #43) @128, FP to SP delta: 128, caller sp: 0x7fff5fbfdb80
```



### ⛔ inContext (deoptimizated):
<pre class="code">
(flags) {
            return (contextFlags & flags) !== 0;
        }</pre>

```diff
- Deopt: <JS Function scan (SharedFunctionInfo 0x16f3adb53cc1)> (opt #16) @96, FP to SP delta: 96, caller sp: 0x7fff5fbfda18
```



### setAwaitContext:
<pre class="code">
(val) {
            <b title="Inlined">🔷setContextFlag</b>(val, 16384 /* AwaitContext */);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>setContextFlag</summary>
<pre class="code">
(val, flag) {
            if (val) {
                contextFlags |⚠️<i><b title="Bitwise">= flag</b></i>;
            }
            else {
                contextFlags &= ~flag;
            }
        }</pre>

</details>
</blockquote>



### tokenIsIdentifierOrKeyword:
<pre class="code">
(token) {
        return token &gt;= 70 /* Identifier */;
    }</pre>



### inDisallowInContext:
<pre class="code">
() {
            return <b title="Inlined">🔷inContext</b>(2048 /* DisallowInContext */);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>inContext</summary>
<pre class="code">
(flags) {
            return (contextFlags & flags) !== 0;
        }</pre>

</details>
</blockquote>



### parseExpected:
<pre class="code">
(kind, diagnosticMessage, shouldAdvance) {
            if (shouldAdvance === void 0) { shouldAdvance = true; }
            if (<b title="Inlined">🔷token</b>() === kind) {
                if (shouldAdvance) {
                    <b title="Inlined">🔷nextToken</b>();
                }
                return true;
            }
            // Report specific message if provided with one.  Otherwise, report generic fallback message.
            if (diagnosticMessage) {
                🔶️<i><b title="CallWithDescriptor">parseErrorAtCurrentToken</b></i>(diagnosticMessage);
            }
            else {
                🔶️<i><b title="CallWithDescriptor">parseErrorAtCurrentToken</b></i>(ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">._0_expected</b></i>, ts.🔶️<i><b title="CallWithDescriptor">tokenToString</b></i>(kind));
            }
            return false;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>



### getNodeEnd:
<pre class="code">
() {
            return scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
        }</pre>



### parseAnyContextualModifier:
<pre class="code">
() {
            return ts.🔶<i><b title="Did not inline: unknown">isModifierKind</b></i>(<b title="Inlined">🔷token</b>()) && <b title="Inlined">🔷tryParse</b>(nextTokenCanFollowModifier);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>tryParse</summary>
<pre class="code">
(callback) {
            return 🔶<i><b title="Did not inline: target text too big">speculationHelper</b></i>(callback, /*isLookAhead*/ false);
        }</pre>

</details>
</blockquote>



### parseOptionalToken:
<pre class="code">
(t) {
            if (<b title="Inlined">🔷token</b>() === t) {
                return <b title="Inlined">🔷parseTokenNode</b>();
            }
            return undefined;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>parseTokenNode</summary>
<pre class="code">
() {
            var node = <b title="Inlined">🔷createNode</b>(<b title="Inlined">🔷token</b>());
            <b title="Inlined">🔷nextToken</b>();
            return 🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(node);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>createNode</summary>
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### parseKeywordAndNoDot:
<pre class="code">
() {
            var node = <b title="Inlined">🔷parseTokenNode</b>();
            return <b title="Inlined">🔷token</b>() === 22 /* DotToken */ ? undefined : node;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>parseTokenNode</summary>
<pre class="code">
() {
            var node = <b title="Inlined">🔷createNode</b>(<b title="Inlined">🔷token</b>());
            <b title="Inlined">🔷nextToken</b>();
            return 🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(node);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>createNode</summary>
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>



### parseIdentifierOrPattern:
<pre class="code">
() {
            if (<b title="Inlined">🔷token</b>() === 20 /* OpenBracketToken */) {
                return 🔶️<i><b title="CallWithDescriptor">parseArrayBindingPattern</b></i>();
            }
            if (<b title="Inlined">🔷token</b>() === 16 /* OpenBraceToken */) {
                return 🔶️<i><b title="CallWithDescriptor">parseObjectBindingPattern</b></i>();
            }
            return <b title="Inlined">🔷parseIdentifier</b>();
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>parseIdentifier</summary>
<pre class="code">
(diagnosticMessage) {
            return 🔶<i><b title="Did not inline: target text too big">createIdentifier</b></i>(🔶<i><b title="Did not inline: target text too big">isIdentifier</b></i>(), diagnosticMessage);
        }</pre>

</details>
</blockquote>



### parseInitializer:
<pre class="code">
(inParameter) {
            if (<b title="Inlined">🔷token</b>() !== 57 /* EqualsToken */) {
                // It's not uncommon during typing for the user to miss writing the '=' token.  Check if
                // there is no newline after the last token and if we're on an expression.  If so, parse
                // this as an equals-value clause with a missing equals.
                // NOTE: There are two places where we allow equals-value clauses.  The first is in a
                // variable declarator.  The second is with a parameter.  For variable declarators
                // it's more likely that a { would be a allowed (as an object literal).  While this
                // is also allowed for parameters, the risk is that we consume the { as an object
                // literal when it really will be for the block following the parameter.
                if (scanner.🔶<i><b title="Did not inline: unknown">hasPrecedingLineBreak</b></i>() || (inParameter && <b title="Inlined">🔷token</b>() === 16 /* OpenBraceToken */) || !🔶<i><b title="Did not inline: target text too big">isStartOfExpression</b></i>()) {
                    // preceding line break, open brace in a parameter (likely a function body) or current token is not an expression -
                    // do not try to parse initializer
                    return undefined;
                }
            }
            // Initializer[In, Yield] :
            //     = AssignmentExpression[?In, ?Yield]
            🔶<i><b title="Did not inline: target text too big">parseExpected</b></i>(57 /* EqualsToken */);
            return 🔶️<i><b title="CallWithDescriptor">parseAssignmentExpressionOrHigher</b></i>();
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>



### isBinaryOperator:
<pre class="code">
() {
            if (<b title="Inlined">🔷inDisallowInContext</b>() && 🔶<i><b title="Did not inline: unknown">token</b></i>() ⚠️<i><b title="CompareGeneric">=== 91</b></i> /* InKeyword */) {
                return false;
            }
            return 🔶<i><b title="Did not inline: target text too big">getBinaryOperatorPrecedence</b></i>() &gt; 0;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>inDisallowInContext</summary>
<pre class="code">
() {
            return <b title="Inlined">🔷inContext</b>(2048 /* DisallowInContext */);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>inContext</summary>
<pre class="code">
(flags) {
            return (contextFlags & flags) !== 0;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### isModifierKind:
<pre class="code">
(token) {
        switch (token) {
            case 116 /* AbstractKeyword */:
            case 119 /* AsyncKeyword */:
            case 75 /* ConstKeyword */:
            case 123 /* DeclareKeyword */:
            case 78 /* DefaultKeyword */:
            case 83 /* ExportKeyword */:
            case 113 /* PublicKeyword */:
            case 111 /* PrivateKeyword */:
            case 112 /* ProtectedKeyword */:
            case 130 /* ReadonlyKeyword */:
            case 114 /* StaticKeyword */:
                return true;
        }
        return false;
    }</pre>



### isStartOfParameter:
<pre class="code">
() {
            return <b title="Inlined">🔷token</b>() === 23 /* DotDotDotToken */ || <b title="Inlined">🔷isIdentifierOrPattern</b>() || ts.🔶<i><b title="Did not inline: unknown">isModifierKind</b></i>(<b title="Inlined">🔷token</b>()) || <b title="Inlined">🔷token</b>() === 56 /* AtToken */ || <b title="Inlined">🔷token</b>() === 98 /* ThisKeyword */;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>isIdentifierOrPattern</summary>
<pre class="code">
() {
            return <b title="Inlined">🔷token</b>() === 16 /* OpenBraceToken */ || <b title="Inlined">🔷token</b>() === 20 /* OpenBracketToken */ || 🔶<i><b title="Did not inline: target text too big">isIdentifier</b></i>();
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>



### getNodePos:
<pre class="code">
() {
            return scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
        }</pre>



### isLiteralPropertyName:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
() {
            return ts.🔶<i><b title="Did not inline: unknown">tokenIsIdentifierOrKeyword</b></i>(<b title="Inlined">🔷token</b>()) ||
                <b title="Inlined">🔷token</b>() === 9 /* StringLiteral */ ||
                <b title="Inlined">🔷token</b>() === 8 /* NumericLiteral */;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>



### tryScan:
<pre class="code">
(callback) {
            return 🔶<i><b title="Did not inline: target text too big">speculationHelper</b></i>(callback, /*isLookahead*/ false);
        }</pre>



### parseSemicolon:
<pre class="code">
() {
            if (<b title="Inlined">🔷canParseSemicolon</b>()) {
                if (<b title="Inlined">🔷token</b>() === 24 /* SemicolonToken */) {
                    // consume the semicolon if it was explicitly provided.
                    <b title="Inlined">🔷nextToken</b>();
                }
                return true;
            }
            else {
                return 🔶<i><b title="Did not inline: target text too big">parseExpected</b></i>(24 /* SemicolonToken */);
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>canParseSemicolon</summary>
<pre class="code">
() {
            // If there's a real semicolon, then we can always parse it out.
            if (<b title="Inlined">🔷token</b>() === 24 /* SemicolonToken */) {
                return true;
            }
            // We can parse out an optional semicolon in ASI cases in the following cases.
            return <b title="Inlined">🔷token</b>() === 17 /* CloseBraceToken */ || <b title="Inlined">🔷token</b>() === 1 /* EndOfFileToken */ || scanner.🔶<i><b title="Did not inline: unknown">hasPrecedingLineBreak</b></i>();
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>



### getFullWidth:
<pre class="code">
(node) {
        return node.end - node.pos;
    }</pre>



### parseParameterType:
<pre class="code">
() {
            if (<b title="Inlined">🔷parseOptional</b>(55 /* ColonToken */)) {
                return <b title="Inlined">🔷parseType</b>();
            }
            return undefined;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>parseOptional</summary>
<pre class="code">
(t) {
            if (<b title="Inlined">🔷token</b>() === t) {
                <b title="Inlined">🔷nextToken</b>();
                return true;
            }
            return false;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>parseType</summary>
<pre class="code">
() {
            // The rules about 'yield' only apply to actual code/expression contexts.  They don't
            // apply to 'type' contexts.  So we disable these parameters here before moving on.
            return 🔶<i><b title="Did not inline: target text too big">doOutsideOfContext</b></i>(20480 /* TypeExcludesFlags */, parseTypeWorker);
        }</pre>

</details>
</blockquote>



### parseBindingElementInitializer:
<pre class="code">
(inParameter) {
            return inParameter ? <b title="Inlined">🔷parseParameterInitializer</b>() : 🔶️<i><b title="CallWithDescriptor">parseNonParameterInitializer</b></i>();
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>parseParameterInitializer</summary>
<pre class="code">
() {
            return 🔶<i><b title="Did not inline: target text too big">parseInitializer</b></i>(/*inParameter*/ true);
        }</pre>

</details>
</blockquote>



### getTrailingCommentRanges:
<pre class="code">
(text, pos) {
        return <b title="Inlined">🔷reduceEachTrailingCommentRange</b>(text, pos, appendCommentRange, undefined, undefined);
    }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>reduceEachTrailingCommentRange</summary>
<pre class="code">
(text, pos, cb, state, initial) {
        return 🔶<i><b title="Did not inline: target text too big">iterateCommentRanges</b></i>(/*reduce*/ true, text, pos, /*trailing*/ true, cb, state, initial);
    }</pre>

</details>
</blockquote>



### concatenate:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(array1, array2) {
        if (!<b title="Inlined">🔷some</b>(array2))
            return array1;
        if (!🔶️<i><b title="CallWithDescriptor">some</b></i>(array1))
            return array2;
        return array1.🔶️<i><b title="CallWithDescriptor">concat</b></i>(array2);
    }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>some</summary>
<pre class="code">
(array, predicate) {
        if (array) {
            if (predicate) {
                for (var _i = 0, array_5 = array; _i ⚠️<i><b title="CompareGeneric">< array_5</b></i>⚠️<i><b title="LoadNamedGeneric">.length</b></i>; _i++) {
                    var v = array_5⚠️<i><b title="LoadKeyedGeneric">[_i]</b></i>;
                    if (🔶️<i><b title="CallWithDescriptor">predicate</b></i>(v)) {
                        return true;
                    }
                }
            }
            else {
                return array⚠️<i><b title="LoadNamedGeneric">.length</b></i> &gt; 0;
            }
        }
        return false;
    }</pre>

</details>
</blockquote>



### parseIdentifierName:
<pre class="code">
() {
            return 🔶<i><b title="Did not inline: target text too big">createIdentifier</b></i>(ts.🔶<i><b title="Did not inline: unknown">tokenIsIdentifierOrKeyword</b></i>(<b title="Inlined">🔷token</b>()));
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>



### isIndexSignature:
<pre class="code">
() {
            if (<b title="Inlined">🔷token</b>() !== 20 /* OpenBracketToken */) {
                return false;
            }
            return 🔶<i><b title="Did not inline: unknown">lookAhead</b></i>(isUnambiguouslyIndexSignature);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>



### parsePropertyName:
<pre class="code">
() {
            return <b title="Inlined">🔷parsePropertyNameWorker</b>(/*allowComputedPropertyNames*/ true);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>parsePropertyNameWorker</summary>
<pre class="code">
(allowComputedPropertyNames) {
            if (<b title="Inlined">🔷token</b>() === 9 /* StringLiteral */ || <b title="Inlined">🔷token</b>() === 8 /* NumericLiteral */) {
                return 🔶<i><b title="Did not inline: unknown">parseLiteralNode</b></i>(/*internName*/ true);
            }
            if (allowComputedPropertyNames && <b title="Inlined">🔷token</b>() === 20 /* OpenBracketToken */) {
                return 🔶️<i><b title="CallWithDescriptor">parseComputedPropertyName</b></i>();
            }
            return <b title="Inlined">🔷parseIdentifierName</b>();
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>parseIdentifierName</summary>
<pre class="code">
() {
            return 🔶<i><b title="Did not inline: target text too big">createIdentifier</b></i>(ts.🔶<i><b title="Did not inline: unknown">tokenIsIdentifierOrKeyword</b></i>(<b title="Inlined">🔷token</b>()));
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>



### parseTypeMember:
<pre class="code">
() {
            if (<b title="Inlined">🔷token</b>() === 18 /* OpenParenToken */ || <b title="Inlined">🔷token</b>() === 26 /* LessThanToken */) {
                return <b title="Inlined">🔷parseSignatureMember</b>(153 /* CallSignature */);
            }
            if (<b title="Inlined">🔷token</b>() === 93 /* NewKeyword */ && <b title="Inlined">🔷lookAhead</b>(isStartOfConstructSignature)) {
                return <b title="Inlined">🔷parseSignatureMember</b>(154 /* ConstructSignature */);
            }
            var fullStart = 🔶<i><b title="Did not inline: unknown">getNodePos</b></i>();
            var modifiers = 🔶<i><b title="Did not inline: target text too big">parseModifiers</b></i>();
            if (🔶<i><b title="Did not inline: unknown">isIndexSignature</b></i>()) {
                return 🔶️<i><b title="CallWithDescriptor">parseIndexSignatureDeclaration</b></i>(fullStart, /*decorators*/ undefined, modifiers);
            }
            return 🔶<i><b title="Did not inline: target text too big">parsePropertyOrMethodSignature</b></i>(fullStart, modifiers);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>parseSignatureMember</summary>
<pre class="code">
(kind) {
            var node = <b title="Inlined">🔷createNode</b>(kind);
            if (kind === 154 /* ConstructSignature */) {
                🔶<i><b title="Did not inline: target text too big">parseExpected</b></i>(93 /* NewKeyword */);
            }
            🔶<i><b title="Did not inline: target text too big">fillSignature</b></i>(55 /* ColonToken */, /*yieldContext*/ false, /*awaitContext*/ false, /*requireCompleteParameterList*/ false, node);
            <b title="Inlined">🔷parseTypeMemberSemicolon</b>();
            return 🔶<i><b title="Did not inline: target text too big">addJSDocComment</b></i>(🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(node));
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createNode</summary>
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>parseTypeMemberSemicolon</summary>
<pre class="code">
() {
            // We allow type members to be separated by commas or (possibly ASI) semicolons.
            // First check if it was a comma.  If so, we're done with the member.
            if (<b title="Inlined">🔷parseOptional</b>(25 /* CommaToken */)) {
                return;
            }
            // Didn't have a comma.  We must have a (possible ASI) semicolon.
            <b title="Inlined">🔷parseSemicolon</b>();
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>parseOptional</summary>
<pre class="code">
(t) {
            if (<b title="Inlined">🔷token</b>() === t) {
                <b title="Inlined">🔷nextToken</b>();
                return true;
            }
            return false;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>parseSemicolon</summary>
<pre class="code">
() {
            if (<b title="Inlined">🔷canParseSemicolon</b>()) {
                if (<b title="Inlined">🔷token</b>() === 24 /* SemicolonToken */) {
                    // consume the semicolon if it was explicitly provided.
                    <b title="Inlined">🔷nextToken</b>();
                }
                return true;
            }
            else {
                return 🔶<i><b title="Did not inline: target text too big">parseExpected</b></i>(24 /* SemicolonToken */);
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>canParseSemicolon</summary>
<pre class="code">
() {
            // If there's a real semicolon, then we can always parse it out.
            if (<b title="Inlined">🔷token</b>() === 24 /* SemicolonToken */) {
                return true;
            }
            // We can parse out an optional semicolon in ASI cases in the following cases.
            return <b title="Inlined">🔷token</b>() === 17 /* CloseBraceToken */ || <b title="Inlined">🔷token</b>() === 1 /* EndOfFileToken */ || scanner.🔶<i><b title="Did not inline: unknown">hasPrecedingLineBreak</b></i>();
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>lookAhead</summary>
<pre class="code">
(callback) {
            return 🔶<i><b title="Did not inline: target text too big">speculationHelper</b></i>(callback, /*isLookAhead*/ true);
        }</pre>

</details>
<details>
<summary>parseSignatureMember</summary>
<pre class="code">
(kind) {
            var node = <b title="Inlined">🔷createNode</b>(kind);
            if (kind === 154 /* ConstructSignature */) {
                🔶<i><b title="Did not inline: target text too big">parseExpected</b></i>(93 /* NewKeyword */);
            }
            🔶<i><b title="Did not inline: target text too big">fillSignature</b></i>(55 /* ColonToken */, /*yieldContext*/ false, /*awaitContext*/ false, /*requireCompleteParameterList*/ false, node);
            <b title="Inlined">🔷parseTypeMemberSemicolon</b>();
            return 🔶<i><b title="Did not inline: target text too big">addJSDocComment</b></i>(🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(node));
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createNode</summary>
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>parseTypeMemberSemicolon</summary>
<pre class="code">
() {
            // We allow type members to be separated by commas or (possibly ASI) semicolons.
            // First check if it was a comma.  If so, we're done with the member.
            if (<b title="Inlined">🔷parseOptional</b>(25 /* CommaToken */)) {
                return;
            }
            // Didn't have a comma.  We must have a (possible ASI) semicolon.
            <b title="Inlined">🔷parseSemicolon</b>();
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>parseOptional</summary>
<pre class="code">
(t) {
            if (<b title="Inlined">🔷token</b>() === t) {
                <b title="Inlined">🔷nextToken</b>();
                return true;
            }
            return false;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>parseSemicolon</summary>
<pre class="code">
() {
            if (<b title="Inlined">🔷canParseSemicolon</b>()) {
                if (🔶<i><b title="Did not inline: unknown">token</b></i>() === 24 /* SemicolonToken */) {
                    // consume the semicolon if it was explicitly provided.
                    🔶<i><b title="Did not inline: unknown">nextToken</b></i>();
                }
                return true;
            }
            else {
                return 🔶<i><b title="Did not inline: target text too big">parseExpected</b></i>(24 /* SemicolonToken */);
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>canParseSemicolon</summary>
<pre class="code">
() {
            // If there's a real semicolon, then we can always parse it out.
            if (<b title="Inlined">🔷token</b>() === 24 /* SemicolonToken */) {
                return true;
            }
            // We can parse out an optional semicolon in ASI cases in the following cases.
            return <b title="Inlined">🔷token</b>() === 17 /* CloseBraceToken */ || <b title="Inlined">🔷token</b>() === 1 /* EndOfFileToken */ || scanner.🔶<i><b title="Did not inline: unknown">hasPrecedingLineBreak</b></i>();
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>



### parseTypeMemberSemicolon:
<pre class="code">
() {
            // We allow type members to be separated by commas or (possibly ASI) semicolons.
            // First check if it was a comma.  If so, we're done with the member.
            if (<b title="Inlined">🔷parseOptional</b>(25 /* CommaToken */)) {
                return;
            }
            // Didn't have a comma.  We must have a (possible ASI) semicolon.
            <b title="Inlined">🔷parseSemicolon</b>();
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>parseOptional</summary>
<pre class="code">
(t) {
            if (<b title="Inlined">🔷token</b>() === t) {
                <b title="Inlined">🔷nextToken</b>();
                return true;
            }
            return false;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>parseSemicolon</summary>
<pre class="code">
() {
            if (<b title="Inlined">🔷canParseSemicolon</b>()) {
                if (<b title="Inlined">🔷token</b>() === 24 /* SemicolonToken */) {
                    // consume the semicolon if it was explicitly provided.
                    <b title="Inlined">🔷nextToken</b>();
                }
                return true;
            }
            else {
                return 🔶<i><b title="Did not inline: target text too big">parseExpected</b></i>(24 /* SemicolonToken */);
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>canParseSemicolon</summary>
<pre class="code">
() {
            // If there's a real semicolon, then we can always parse it out.
            if (<b title="Inlined">🔷token</b>() === 24 /* SemicolonToken */) {
                return true;
            }
            // We can parse out an optional semicolon in ASI cases in the following cases.
            return <b title="Inlined">🔷token</b>() === 17 /* CloseBraceToken */ || <b title="Inlined">🔷token</b>() === 1 /* EndOfFileToken */ || scanner.🔶<i><b title="Did not inline: unknown">hasPrecedingLineBreak</b></i>();
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### parseTypeParameters:
<pre class="code">
() {
            if (<b title="Inlined">🔷token</b>() === 26 /* LessThanToken */) {
                return <b title="Inlined">🔷parseBracketedList</b>(18 /* TypeParameters */, parseTypeParameter, 26 /* LessThanToken */, 28 /* GreaterThanToken */);
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>parseBracketedList</summary>
<pre class="code">
(kind, parseElement, open, close) {
            if (🔶<i><b title="Did not inline: target text too big">parseExpected</b></i>(open)) {
                var result = 🔶<i><b title="Did not inline: target text too big">parseDelimitedList</b></i>(kind, parseElement);
                🔶<i><b title="Did not inline: target text too big">parseExpected</b></i>(close);
                return result;
            }
            return 🔶️<i><b title="CallWithDescriptor">createMissingList</b></i>();
        }</pre>

</details>
</blockquote>



### getJSDocCommentRanges:
<pre class="code">
(node, text) {
        var commentRanges = (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 144 /* Parameter */ ||
            node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 143 /* TypeParameter */ ||
            node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 184 /* FunctionExpression */ ||
            node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 185 /* ArrowFunction */) ?
            ts.🔶<i><b title="Did not inline: unknown">concatenate</b></i>(ts.⚠️<i><b title="LoadNamedGeneric">getTrailingCommentRanges</b></i>(text, node.pos), ts.🔶<i><b title="Did not inline: unknown">getLeadingCommentRanges</b></i>(text, node.pos)) :
            <b title="Inlined">🔷getLeadingCommentRangesOfNodeFromText</b>(node, text);
        // True if the comment starts with '/**' but not if it is '/**/'
        return ts.🔶<i><b title="Did not inline: unknown">filter</b></i>(commentRanges, 🔶️<i><b title="CallWithDescriptor">function</b></i> (comment) {
            return text.charCodeAt(comment.pos + 1) === 42 /* asterisk */ &&
                text.charCodeAt(comment.pos + 2) === 42 /* asterisk */ &&
                text.charCodeAt(comment.pos + 3) !== 47 /* slash */;
        });
    }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getLeadingCommentRangesOfNodeFromText</summary>
<pre class="code">
(node, text) {
        return ts.🔶<i><b title="Did not inline: unknown">getLeadingCommentRanges</b></i>(text, node⚠️<i><b title="LoadNamedGeneric">.pos</b></i>);
    }</pre>

</details>
</blockquote>



### parseTypeAnnotation:
<pre class="code">
() {
            return <b title="Inlined">🔷parseOptional</b>(55 /* ColonToken */) ? <b title="Inlined">🔷parseType</b>() : undefined;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>parseOptional</summary>
<pre class="code">
(t) {
            if (<b title="Inlined">🔷token</b>() === t) {
                <b title="Inlined">🔷nextToken</b>();
                return true;
            }
            return false;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>parseType</summary>
<pre class="code">
() {
            // The rules about 'yield' only apply to actual code/expression contexts.  They don't
            // apply to 'type' contexts.  So we disable these parameters here before moving on.
            return 🔶<i><b title="Did not inline: target text too big">doOutsideOfContext</b></i>(20480 /* TypeExcludesFlags */, parseTypeWorker);
        }</pre>

</details>
</blockquote>



### setContextFlag:
<pre class="code">
(val, flag) {
            if (val) {
                contextFlags |⚠️<i><b title="Bitwise">= flag</b></i>;
            }
            else {
                contextFlags &= ~flag;
            }
        }</pre>



### fillSignature:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(returnToken, yieldContext, awaitContext, requireCompleteParameterList, signature) {
            var returnTokenRequired = returnToken === 35 /* EqualsGreaterThanToken */;
            signature.typeParameters ⚠️<i><b title="StoreNamedGeneric">= parseTypeParameters</b></i>();
            signature.parameters ⚠️<i><b title="StoreNamedGeneric">= parseParameterList</b></i>(yieldContext, awaitContext, requireCompleteParameterList);
            if (returnTokenRequired) {
                🔶<i><b title="Did not inline: target text too big">parseExpected</b></i>(returnToken);
                signature.type = <b title="Inlined">🔷parseTypeOrTypePredicate</b>();
            }
            else if (<b title="Inlined">🔷parseOptional</b>(returnToken)) {
                signature.type ⚠️<i><b title="StoreNamedGeneric">= parseTypeOrTypePredicate</b></i>();
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>parseTypeParameters</summary>
<pre class="code">
() {
            if (<b title="Inlined">🔷token</b>() === 26 /* LessThanToken */) {
                return <b title="Inlined">🔷parseBracketedList</b>(18 /* TypeParameters */, parseTypeParameter, 26 /* LessThanToken */, 28 /* GreaterThanToken */);
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>parseBracketedList</summary>
<pre class="code">
(kind, parseElement, open, close) {
            if (🔶<i><b title="Did not inline: target text too big">parseExpected</b></i>(open)) {
                var result = 🔶<i><b title="Did not inline: target text too big">parseDelimitedList</b></i>(kind, parseElement);
                🔶<i><b title="Did not inline: target text too big">parseExpected</b></i>(close);
                return result;
            }
            return 🔶️<i><b title="CallWithDescriptor">createMissingList</b></i>();
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>parseTypeOrTypePredicate</summary>
<pre class="code">
() {
            var typePredicateVariable = 🔶<i><b title="Did not inline: target text too big">isIdentifier</b></i>() && <b title="Inlined">🔷tryParse</b>(parseTypePredicatePrefix);
            var type = <b title="Inlined">🔷parseType</b>();
            if (typePredicateVariable) {
                var node = <b title="Inlined">🔷createNode</b>(156 /* TypePredicate */, typePredicateVariable⚠️<i><b title="LoadNamedGeneric">.pos</b></i>);
                node.parameterName ⚠️<i><b title="StoreNamedGeneric">= typePredicateVariable</b></i>;
                node.type ⚠️<i><b title="StoreNamedGeneric">= type</b></i>;
                return 🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(node);
            }
            else {
                return type;
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>tryParse</summary>
<pre class="code">
(callback) {
            return 🔶<i><b title="Did not inline: target text too big">speculationHelper</b></i>(callback, /*isLookAhead*/ false);
        }</pre>

</details>
<details>
<summary>parseType</summary>
<pre class="code">
() {
            // The rules about 'yield' only apply to actual code/expression contexts.  They don't
            // apply to 'type' contexts.  So we disable these parameters here before moving on.
            return 🔶<i><b title="Did not inline: target text too big">doOutsideOfContext</b></i>(20480 /* TypeExcludesFlags */, parseTypeWorker);
        }</pre>

</details>
<details>
<summary>createNode</summary>
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>parseOptional</summary>
<pre class="code">
(t) {
            if (<b title="Inlined">🔷token</b>() === t) {
                <b title="Inlined">🔷nextToken</b>();
                return true;
            }
            return false;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>parseTypeOrTypePredicate</summary>
<pre class="code">
() {
            var typePredicateVariable = 🔶<i><b title="Did not inline: target text too big">isIdentifier</b></i>() && <b title="Inlined">🔷tryParse</b>(parseTypePredicatePrefix);
            var type = <b title="Inlined">🔷parseType</b>();
            if (typePredicateVariable) {
                var node = <b title="Inlined">🔷createNode</b>(156 /* TypePredicate */, typePredicateVariable⚠️<i><b title="LoadNamedGeneric">.pos</b></i>);
                node.parameterName ⚠️<i><b title="StoreNamedGeneric">= typePredicateVariable</b></i>;
                node.type ⚠️<i><b title="StoreNamedGeneric">= type</b></i>;
                return 🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(node);
            }
            else {
                return type;
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>tryParse</summary>
<pre class="code">
(callback) {
            return 🔶<i><b title="Did not inline: target text too big">speculationHelper</b></i>(callback, /*isLookAhead*/ false);
        }</pre>

</details>
<details>
<summary>parseType</summary>
<pre class="code">
() {
            // The rules about 'yield' only apply to actual code/expression contexts.  They don't
            // apply to 'type' contexts.  So we disable these parameters here before moving on.
            return 🔶<i><b title="Did not inline: target text too big">doOutsideOfContext</b></i>(20480 /* TypeExcludesFlags */, parseTypeWorker);
        }</pre>

</details>
<details>
<summary>createNode</summary>
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>



### parseParameterList:
<pre class="code">
(yieldContext, awaitContext, requireCompleteParameterList) {
            // FormalParameters [Yield,Await]: (modified)
            //      [empty]
            //      FormalParameterList[?Yield,Await]
            //
            // FormalParameter[Yield,Await]: (modified)
            //      BindingElement[?Yield,Await]
            //
            // BindingElement [Yield,Await]: (modified)
            //      SingleNameBinding[?Yield,?Await]
            //      BindingPattern[?Yield,?Await]Initializer [In, ?Yield,?Await] opt
            //
            // SingleNameBinding [Yield,Await]:
            //      BindingIdentifier[?Yield,?Await]Initializer [In, ?Yield,?Await] opt
            if (🔶<i><b title="Did not inline: target text too big">parseExpected</b></i>(18 /* OpenParenToken */)) {
                var savedYieldContext = <b title="Inlined">🔷inYieldContext</b>();
                var savedAwaitContext = <b title="Inlined">🔷inAwaitContext</b>();
                <b title="Inlined">🔷setYieldContext</b>(yieldContext);
                <b title="Inlined">🔷setAwaitContext</b>(awaitContext);
                var result = 🔶<i><b title="Did not inline: target text too big">parseDelimitedList</b></i>(16 /* Parameters */, parseParameter);
                <b title="Inlined">🔷setYieldContext</b>(savedYieldContext);
                <b title="Inlined">🔷setAwaitContext</b>(savedAwaitContext);
                if (!🔶<i><b title="Did not inline: target text too big">parseExpected</b></i>(19 /* CloseParenToken */) && requireCompleteParameterList) {
                    // Caller insisted that we had to end with a )   We didn't.  So just return
                    // undefined here.
                    return undefined;
                }
                return result;
            }
            // We didn't even have an open paren.  If the caller requires a complete parameter list,
            // we definitely can't provide that.  However, if they're ok with an incomplete one,
            // then just return an empty set of parameters.
            return requireCompleteParameterList ? undefined : 🔶️<i><b title="CallWithDescriptor">createMissingList</b></i>();
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>inYieldContext</summary>
<pre class="code">
() {
            return <b title="Inlined">🔷inContext</b>(4096 /* YieldContext */);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>inContext</summary>
<pre class="code">
(flags) {
            return (contextFlags & flags) !== 0;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>inAwaitContext</summary>
<pre class="code">
() {
            return <b title="Inlined">🔷inContext</b>(16384 /* AwaitContext */);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>inContext</summary>
<pre class="code">
(flags) {
            return (contextFlags & flags) !== 0;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>setYieldContext</summary>
<pre class="code">
(val) {
            <b title="Inlined">🔷setContextFlag</b>(val, 4096 /* YieldContext */);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>setContextFlag</summary>
<pre class="code">
(val, flag) {
            if (val) {
                contextFlags |⚠️<i><b title="Bitwise">= flag</b></i>;
            }
            else {
                contextFlags &= ~flag;
            }
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>setAwaitContext</summary>
<pre class="code">
(val) {
            <b title="Inlined">🔷setContextFlag</b>(val, 16384 /* AwaitContext */);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>setContextFlag</summary>
<pre class="code">
(val, flag) {
            if (val) {
                contextFlags |⚠️<i><b title="Bitwise">= flag</b></i>;
            }
            else {
                contextFlags &= ~flag;
            }
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>setYieldContext</summary>
<pre class="code">
(val) {
            <b title="Inlined">🔷setContextFlag</b>(val, 4096 /* YieldContext */);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>setContextFlag</summary>
<pre class="code">
(val, flag) {
            if (val) {
                contextFlags |⚠️<i><b title="Bitwise">= flag</b></i>;
            }
            else {
                contextFlags &= ~flag;
            }
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>setAwaitContext</summary>
<pre class="code">
(val) {
            <b title="Inlined">🔷setContextFlag</b>(val, 16384 /* AwaitContext */);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>setContextFlag</summary>
<pre class="code">
(val, flag) {
            if (val) {
                contextFlags |⚠️<i><b title="Bitwise">= flag</b></i>;
            }
            else {
                contextFlags &= ~flag;
            }
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### parseNonArrayType:
<pre class="code">
() {
            switch (<b title="Inlined">🔷token</b>()) {
                case 118 /* AnyKeyword */:
                case 134 /* StringKeyword */:
                case 132 /* NumberKeyword */:
                case 121 /* BooleanKeyword */:
                case 135 /* SymbolKeyword */:
                case 137 /* UndefinedKeyword */:
                case 129 /* NeverKeyword */:
                    // If these are followed by a dot, then parse these out as a dotted type reference instead.
                    var node = <b title="Inlined">🔷tryParse</b>(parseKeywordAndNoDot);
                    return node || 🔶<i><b title="Did not inline: unknown">parseTypeReference</b></i>();
                case 9 /* StringLiteral */:
                case 8 /* NumericLiteral */:
                case 100 /* TrueKeyword */:
                case 85 /* FalseKeyword */:
                    return <b title="Inlined">🔷parseLiteralTypeNode</b>();
                case 37 /* MinusToken */:
                    return 🔶<i><b title="Did not inline: unknown">lookAhead</b></i>(nextTokenIsNumericLiteral) ? 🔶️<i><b title="CallWithDescriptor">parseLiteralTypeNode</b></i>() : 🔶<i><b title="Did not inline: unknown">parseTypeReference</b></i>();
                case 104 /* VoidKeyword */:
                case 94 /* NullKeyword */:
                    return <b title="Inlined">🔷parseTokenNode</b>();
                case 98 /* ThisKeyword */: {
                    var thisKeyword = <b title="Inlined">🔷parseThisTypeNode</b>();
                    if (🔶<i><b title="Did not inline: unknown">token</b></i>() === 125 /* IsKeyword */ && !scanner.⚠️<i><b title="LoadNamedGeneric">hasPrecedingLineBreak</b></i>()) {
                        return 🔶️<i><b title="CallWithDescriptor">parseThisTypePredicate</b></i>(thisKeyword);
                    }
                    else {
                        return thisKeyword;
                    }
                }
                case 102 /* TypeOfKeyword */:
                    return 🔶️<i><b title="CallWithDescriptor">parseTypeQuery</b></i>();
                case 16 /* OpenBraceToken */:
                    return 🔶<i><b title="Did not inline: unknown">lookAhead</b></i>(isStartOfMappedType) ? 🔶️<i><b title="CallWithDescriptor">parseMappedType</b></i>() : 🔶<i><b title="Did not inline: unknown">parseTypeLiteral</b></i>();
                case 20 /* OpenBracketToken */:
                    return 🔶️<i><b title="CallWithDescriptor">parseTupleType</b></i>();
                case 18 /* OpenParenToken */:
                    return 🔶️<i><b title="CallWithDescriptor">parseParenthesizedType</b></i>();
                default:
                    return 🔶<i><b title="Did not inline: unknown">parseTypeReference</b></i>();
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>tryParse</summary>
<pre class="code">
(callback) {
            return 🔶<i><b title="Did not inline: target text too big">speculationHelper</b></i>(callback, /*isLookAhead*/ false);
        }</pre>

</details>
<details>
<summary>parseLiteralTypeNode</summary>
<pre class="code">
() {
            var node = <b title="Inlined">🔷createNode</b>(171 /* LiteralType */);
            node.literal = 🔶<i><b title="Did not inline: target text too big">parseSimpleUnaryExpression</b></i>();
            🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(node);
            return node;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createNode</summary>
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>parseTokenNode</summary>
<pre class="code">
() {
            var node = <b title="Inlined">🔷createNode</b>(<b title="Inlined">🔷token</b>());
            <b title="Inlined">🔷nextToken</b>();
            return 🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(node);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>createNode</summary>
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>parseThisTypeNode</summary>
<pre class="code">
() {
            var node = <b title="Inlined">🔷createNode</b>(167 /* ThisType */);
            <b title="Inlined">🔷nextToken</b>();
            return 🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(node);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createNode</summary>
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### isStartOfLeftHandSideExpression:
<pre class="code">
() {
            switch (<b title="Inlined">🔷token</b>()) {
                case 98 /* ThisKeyword */:
                case 96 /* SuperKeyword */:
                case 94 /* NullKeyword */:
                case 100 /* TrueKeyword */:
                case 85 /* FalseKeyword */:
                case 8 /* NumericLiteral */:
                case 9 /* StringLiteral */:
                case 12 /* NoSubstitutionTemplateLiteral */:
                case 13 /* TemplateHead */:
                case 18 /* OpenParenToken */:
                case 20 /* OpenBracketToken */:
                case 16 /* OpenBraceToken */:
                case 88 /* FunctionKeyword */:
                case 74 /* ClassKeyword */:
                case 93 /* NewKeyword */:
                case 40 /* SlashToken */:
                case 62 /* SlashEqualsToken */:
                case 70 /* Identifier */:
                    return true;
                default:
                    return 🔶<i><b title="Did not inline: target text too big">isIdentifier</b></i>();
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>



### parseTypePredicatePrefix:
<pre class="code">
() {
            var id = <b title="Inlined">🔷parseIdentifier</b>();
            if (<b title="Inlined">🔷token</b>() === 125 /* IsKeyword */ && !scanner.🔶<i><b title="Did not inline: unknown">hasPrecedingLineBreak</b></i>()) {
                <b title="Inlined">🔷nextToken</b>();
                return id;
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>parseIdentifier</summary>
<pre class="code">
(diagnosticMessage) {
            return 🔶<i><b title="Did not inline: target text too big">createIdentifier</b></i>(🔶<i><b title="Did not inline: target text too big">isIdentifier</b></i>(), diagnosticMessage);
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>



### getBinaryOperatorPrecedence:
<pre class="code">
() {
            switch (<b title="Inlined">🔷token</b>()) {
                case 53 /* BarBarToken */:
                    return 1;
                case 52 /* AmpersandAmpersandToken */:
                    return 2;
                case 48 /* BarToken */:
                    return 3;
                case 49 /* CaretToken */:
                    return 4;
                case 47 /* AmpersandToken */:
                    return 5;
                case 31 /* EqualsEqualsToken */:
                case 32 /* ExclamationEqualsToken */:
                case 33 /* EqualsEqualsEqualsToken */:
                case 34 /* ExclamationEqualsEqualsToken */:
                    return 6;
                case 26 /* LessThanToken */:
                case 28 /* GreaterThanToken */:
                case 29 /* LessThanEqualsToken */:
                case 30 /* GreaterThanEqualsToken */:
                case 92 /* InstanceOfKeyword */:
                case 91 /* InKeyword */:
                case 117 /* AsKeyword */:
                    return 7;
                case 44 /* LessThanLessThanToken */:
                case 45 /* GreaterThanGreaterThanToken */:
                case 46 /* GreaterThanGreaterThanGreaterThanToken */:
                    return 8;
                case 36 /* PlusToken */:
                case 37 /* MinusToken */:
                    return 9;
                case 38 /* AsteriskToken */:
                case 40 /* SlashToken */:
                case 41 /* PercentToken */:
                    return 10;
                case 39 /* AsteriskAsteriskToken */:
                    return 11;
            }
            // -1 is lower than all other precedences.  Returning it will cause binary expression
            // parsing to stop.
            return -1;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>



### isStartOfExpression:
<pre class="code">
() {
            if (🔶<i><b title="Did not inline: target text too big">isStartOfLeftHandSideExpression</b></i>()) {
                return true;
            }
            switch (<b title="Inlined">🔷token</b>()) {
                case 36 /* PlusToken */:
                case 37 /* MinusToken */:
                case 51 /* TildeToken */:
                case 50 /* ExclamationToken */:
                case 79 /* DeleteKeyword */:
                case 102 /* TypeOfKeyword */:
                case 104 /* VoidKeyword */:
                case 42 /* PlusPlusToken */:
                case 43 /* MinusMinusToken */:
                case 26 /* LessThanToken */:
                case 120 /* AwaitKeyword */:
                case 115 /* YieldKeyword */:
                    // Yield/await always starts an expression.  Either it is an identifier (in which case
                    // it is definitely an expression).  Or it's a keyword (either because we're in
                    // a generator or async function, or in strict mode (or both)) and it started a yield or await expression.
                    return true;
                default:
                    // Error tolerance.  If we see the start of some binary operator, we consider
                    // that the start of an expression.  That way we'll parse out a missing identifier,
                    // give a good message about an identifier being missing, and then consume the
                    // rest of the binary expression.
                    if (<b title="Inlined">🔷isBinaryOperator</b>()) {
                        return true;
                    }
                    return 🔶<i><b title="Did not inline: target text too big">isIdentifier</b></i>();
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>isBinaryOperator</summary>
<pre class="code">
() {
            if (<b title="Inlined">🔷inDisallowInContext</b>() && 🔶<i><b title="Did not inline: unknown">token</b></i>() ⚠️<i><b title="CompareGeneric">=== 91</b></i> /* InKeyword */) {
                return false;
            }
            return 🔶<i><b title="Did not inline: target text too big">getBinaryOperatorPrecedence</b></i>() &gt; 0;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>inDisallowInContext</summary>
<pre class="code">
() {
            return <b title="Inlined">🔷inContext</b>(2048 /* DisallowInContext */);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>inContext</summary>
<pre class="code">
(flags) {
            return (contextFlags & flags) !== 0;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>



### parseParameter:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
() {
            var node = <b title="Inlined">🔷createNode</b>(144 /* Parameter */);
            if (<b title="Inlined">🔷token</b>() === 98 /* ThisKeyword */) {
                node.name = 🔶<i><b title="Did not inline: target text too big">createIdentifier</b></i>(/*isIdentifier*/ true, undefined);
                node.type = <b title="Inlined">🔷parseParameterType</b>();
                return 🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(node);
            }
            node.decorators = 🔶<i><b title="Did not inline: target text too big">parseDecorators</b></i>();
            node.modifiers = 🔶<i><b title="Did not inline: target text too big">parseModifiers</b></i>();
            node.dotDotDotToken = <b title="Inlined">🔷parseOptionalToken</b>(23 /* DotDotDotToken */);
            // FormalParameter [Yield,Await]:
            //      BindingElement[?Yield,?Await]
            node.name = <b title="Inlined">🔷parseIdentifierOrPattern</b>();
            if (ts.🔶<i><b title="Did not inline: unknown">getFullWidth</b></i>(node.name) === 0 && !ts.⚠️<i><b title="LoadNamedGeneric">hasModifiers</b></i>(node) && ts.⚠️<i><b title="LoadNamedGeneric">isModifierKind</b></i>(🔶<i><b title="Did not inline: unknown">token</b></i>())) {
                // in cases like
                // 'use strict'
                // function foo(static)
                // isParameter('static') === true, because of isModifier('static')
                // however 'static' is not a legal identifier in a strict mode.
                // so result of this function will be ParameterDeclaration (flags = 0, name = missing, type = undefined, initializer = undefined)
                // and current token will not change =&gt; parsing of the enclosing parameter list will last till the end of time (or OOM)
                // to avoid this we'll advance cursor to the next token.
                🔶<i><b title="Did not inline: unknown">nextToken</b></i>();
            }
            node.questionToken = <b title="Inlined">🔷parseOptionalToken</b>(54 /* QuestionToken */);
            node.type = 🔶<i><b title="Did not inline: unknown">parseParameterType</b></i>();
            node.initializer = 🔶<i><b title="Did not inline: unknown">parseBindingElementInitializer</b></i>(/*inParameter*/ true);
            // Do not check for initializers in an ambient context for parameters. This is not
            // a grammar error because the grammar allows arbitrary call signatures in
            // an ambient context.
            // It is actually not necessary for this to be an error at all. The reason is that
            // function/constructor implementations are syntactically disallowed in ambient
            // contexts. In addition, parameter initializers are semantically disallowed in
            // overload signatures. So parameter initializers are transitively disallowed in
            // ambient contexts.
            return 🔶<i><b title="Did not inline: target text too big">addJSDocComment</b></i>(🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(node));
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createNode</summary>
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>parseParameterType</summary>
<pre class="code">
() {
            if (<b title="Inlined">🔷parseOptional</b>(55 /* ColonToken */)) {
                return <b title="Inlined">🔷parseType</b>();
            }
            return undefined;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>parseOptional</summary>
<pre class="code">
(t) {
            if (<b title="Inlined">🔷token</b>() === t) {
                <b title="Inlined">🔷nextToken</b>();
                return true;
            }
            return false;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>parseType</summary>
<pre class="code">
() {
            // The rules about 'yield' only apply to actual code/expression contexts.  They don't
            // apply to 'type' contexts.  So we disable these parameters here before moving on.
            return 🔶<i><b title="Did not inline: target text too big">doOutsideOfContext</b></i>(20480 /* TypeExcludesFlags */, parseTypeWorker);
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>parseOptionalToken</summary>
<pre class="code">
(t) {
            if (<b title="Inlined">🔷token</b>() === t) {
                return <b title="Inlined">🔷parseTokenNode</b>();
            }
            return undefined;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>parseTokenNode</summary>
<pre class="code">
() {
            var node = <b title="Inlined">🔷createNode</b>(<b title="Inlined">🔷token</b>());
            <b title="Inlined">🔷nextToken</b>();
            return 🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(node);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>createNode</summary>
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>parseIdentifierOrPattern</summary>
<pre class="code">
() {
            if (<b title="Inlined">🔷token</b>() === 20 /* OpenBracketToken */) {
                return 🔶️<i><b title="CallWithDescriptor">parseArrayBindingPattern</b></i>();
            }
            if (<b title="Inlined">🔷token</b>() === 16 /* OpenBraceToken */) {
                return 🔶️<i><b title="CallWithDescriptor">parseObjectBindingPattern</b></i>();
            }
            return <b title="Inlined">🔷parseIdentifier</b>();
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>parseIdentifier</summary>
<pre class="code">
(diagnosticMessage) {
            return 🔶<i><b title="Did not inline: target text too big">createIdentifier</b></i>(🔶<i><b title="Did not inline: target text too big">isIdentifier</b></i>(), diagnosticMessage);
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>parseOptionalToken</summary>
<pre class="code">
(t) {
            if (<b title="Inlined">🔷token</b>() === t) {
                return <b title="Inlined">🔷parseTokenNode</b>();
            }
            return undefined;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>parseTokenNode</summary>
<pre class="code">
() {
            var node = <b title="Inlined">🔷createNode</b>(<b title="Inlined">🔷token</b>());
            🔶<i><b title="Did not inline: unknown">nextToken</b></i>();
            return 🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(node);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>createNode</summary>
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>



### parseTypeOrTypePredicate:
<pre class="code">
() {
            var typePredicateVariable = 🔶<i><b title="Did not inline: target text too big">isIdentifier</b></i>() && <b title="Inlined">🔷tryParse</b>(parseTypePredicatePrefix);
            var type = <b title="Inlined">🔷parseType</b>();
            if (typePredicateVariable) {
                var node = <b title="Inlined">🔷createNode</b>(156 /* TypePredicate */, typePredicateVariable⚠️<i><b title="LoadNamedGeneric">.pos</b></i>);
                node.parameterName ⚠️<i><b title="StoreNamedGeneric">= typePredicateVariable</b></i>;
                node.type ⚠️<i><b title="StoreNamedGeneric">= type</b></i>;
                return 🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(node);
            }
            else {
                return type;
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>tryParse</summary>
<pre class="code">
(callback) {
            return 🔶<i><b title="Did not inline: target text too big">speculationHelper</b></i>(callback, /*isLookAhead*/ false);
        }</pre>

</details>
<details>
<summary>parseType</summary>
<pre class="code">
() {
            // The rules about 'yield' only apply to actual code/expression contexts.  They don't
            // apply to 'type' contexts.  So we disable these parameters here before moving on.
            return 🔶<i><b title="Did not inline: target text too big">doOutsideOfContext</b></i>(20480 /* TypeExcludesFlags */, parseTypeWorker);
        }</pre>

</details>
<details>
<summary>createNode</summary>
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### isStartOfDeclaration:
<pre class="code">
() {
            return <b title="Inlined">🔷lookAhead</b>(isDeclaration);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>lookAhead</summary>
<pre class="code">
(callback) {
            return 🔶<i><b title="Did not inline: target text too big">speculationHelper</b></i>(callback, /*isLookAhead*/ true);
        }</pre>

</details>
</blockquote>



### isListElement:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(parsingContext, inErrorRecovery) {
            var node = 🔶<i><b title="Did not inline: target text too big">currentNode</b></i>(parsingContext);
            if (node) {
                return true;
            }
            ⚠️<i><b title="CompareGeneric">switch</b></i> (parsingContext) {
                case 0 /* SourceElements */:
                case 1 /* BlockStatements */:
                case 3 /* SwitchClauseStatements */:
                    // If we're in error recovery, then we don't want to treat ';' as an empty statement.
                    // The problem is that ';' can show up in far too many contexts, and if we see one
                    // and assume it's a statement, then we may bail out inappropriately from whatever
                    // we're parsing.  For example, if we have a semicolon in the middle of a class, then
                    // we really don't want to assume the class is over and we're on a statement in the
                    // outer module.  We just want to consume and move on.
                    return !(<b title="Inlined">🔷token</b>() === 24 /* SemicolonToken */ && inErrorRecovery) && 🔶<i><b title="Did not inline: target text too big">isStartOfStatement</b></i>();
                case 2 /* SwitchClauses */:
                    return 🔶<i><b title="Did not inline: unknown">token</b></i>() ⚠️<i><b title="CompareGeneric">=== 72</b></i> /* CaseKeyword */ || 🔶<i><b title="Did not inline: unknown">token</b></i>() ⚠️<i><b title="CompareGeneric">=== 78</b></i> /* DefaultKeyword */;
                case 4 /* TypeMembers */:
                    return <b title="Inlined">🔷lookAhead</b>(isTypeMemberStart);
                case 5 /* ClassMembers */:
                    // We allow semicolons as class elements (as specified by ES6) as long as we're
                    // not in error recovery.  If we're in error recovery, we don't want an errant
                    // semicolon to be treated as a class member (since they're almost always used
                    // for statements.
                    return <b title="Inlined">🔷lookAhead</b>(isClassMemberStart) || (🔶<i><b title="Did not inline: unknown">token</b></i>() ⚠️<i><b title="CompareGeneric">=== 24</b></i> /* SemicolonToken */ && !inErrorRecovery);
                case 6 /* EnumMembers */:
                    // Include open bracket computed properties. This technically also lets in indexers,
                    // which would be a candidate for improved error reporting.
                    return <b title="Inlined">🔷token</b>() === 20 /* OpenBracketToken */ || <b title="Inlined">🔷isLiteralPropertyName</b>();
                case 12 /* ObjectLiteralMembers */:
                    return 🔶<i><b title="Did not inline: unknown">token</b></i>() ⚠️<i><b title="CompareGeneric">=== 20</b></i> /* OpenBracketToken */ || 🔶<i><b title="Did not inline: unknown">token</b></i>() ⚠️<i><b title="CompareGeneric">=== 38</b></i> /* AsteriskToken */ || 🔶<i><b title="Did not inline: unknown">token</b></i>() ⚠️<i><b title="CompareGeneric">=== 23</b></i> /* DotDotDotToken */ || 🔶<i><b title="Did not inline: unknown">isLiteralPropertyName</b></i>();
                case 17 /* RestProperties */:
                    return 🔶<i><b title="Did not inline: unknown">isLiteralPropertyName</b></i>();
                case 9 /* ObjectBindingElements */:
                    return 🔶<i><b title="Did not inline: unknown">token</b></i>() ⚠️<i><b title="CompareGeneric">=== 20</b></i> /* OpenBracketToken */ || 🔶<i><b title="Did not inline: unknown">token</b></i>() ⚠️<i><b title="CompareGeneric">=== 23</b></i> /* DotDotDotToken */ || 🔶<i><b title="Did not inline: unknown">isLiteralPropertyName</b></i>();
                case 7 /* HeritageClauseElement */:
                    // If we see { } then only consume it as an expression if it is followed by , or {
                    // That way we won't consume the body of a class in its heritage clause.
                    if (<b title="Inlined">🔷token</b>() === 16 /* OpenBraceToken */) {
                        return 🔶<i><b title="Did not inline: unknown">lookAhead</b></i>(isValidHeritageClauseObjectLiteral);
                    }
                    if (!inErrorRecovery) {
                        return 🔶<i><b title="Did not inline: target text too big">isStartOfLeftHandSideExpression</b></i>() && !<b title="Inlined">🔷isHeritageClauseExtendsOrImplementsKeyword</b>();
                    }
                    else {
                        // If we're in error recovery we tighten up what we're willing to match.
                        // That way we don't treat something like "this" as a valid heritage clause
                        // element during recovery.
                        return 🔶<i><b title="Did not inline: target text too big">isIdentifier</b></i>() && !🔶️<i><b title="CallWithDescriptor">isHeritageClauseExtendsOrImplementsKeyword</b></i>();
                    }
                case 8 /* VariableDeclarations */:
                    return <b title="Inlined">🔷isIdentifierOrPattern</b>();
                case 10 /* ArrayBindingElements */:
                    return 🔶<i><b title="Did not inline: unknown">token</b></i>() ⚠️<i><b title="CompareGeneric">=== 25</b></i> /* CommaToken */ || 🔶<i><b title="Did not inline: unknown">token</b></i>() ⚠️<i><b title="CompareGeneric">=== 23</b></i> /* DotDotDotToken */ || 🔶️<i><b title="CallWithDescriptor">isIdentifierOrPattern</b></i>();
                case 18 /* TypeParameters */:
                    return 🔶<i><b title="Did not inline: target text too big">isIdentifier</b></i>();
                case 11 /* ArgumentExpressions */:
                case 15 /* ArrayLiteralMembers */:
                    return 🔶<i><b title="Did not inline: unknown">token</b></i>() ⚠️<i><b title="CompareGeneric">=== 25</b></i> /* CommaToken */ || 🔶<i><b title="Did not inline: unknown">token</b></i>() ⚠️<i><b title="CompareGeneric">=== 23</b></i> /* DotDotDotToken */ || 🔶<i><b title="Did not inline: target text too big">isStartOfExpression</b></i>();
                case 16 /* Parameters */:
                    return <b title="Inlined">🔷isStartOfParameter</b>();
                case 19 /* TypeArguments */:
                case 20 /* TupleElementTypes */:
                    return <b title="Inlined">🔷token</b>() === 25 /* CommaToken */ || 🔶<i><b title="Did not inline: target text too big">isStartOfType</b></i>();
                case 21 /* HeritageClauses */:
                    return <b title="Inlined">🔷isHeritageClause</b>();
                case 22 /* ImportOrExportSpecifiers */:
                    return ts.🔶<i><b title="Did not inline: unknown">tokenIsIdentifierOrKeyword</b></i>(<b title="Inlined">🔷token</b>());
                case 13 /* JsxAttributes */:
                    return ts.⚠️<i><b title="LoadNamedGeneric">tokenIsIdentifierOrKeyword</b></i>(🔶<i><b title="Did not inline: unknown">token</b></i>()) || 🔶<i><b title="Did not inline: unknown">token</b></i>() ⚠️<i><b title="CompareGeneric">=== 16</b></i> /* OpenBraceToken */;
                case 14 /* JsxChildren */:
                    return true;
                case 23 /* JSDocFunctionParameters */:
                case 24 /* JSDocTypeArguments */:
                case 26 /* JSDocTupleTypes */:
                    return JSDocParser.🔶️<i><b title="CallWithDescriptor">isJSDocType</b></i>();
                case 25 /* JSDocRecordMembers */:
                    return 🔶️<i><b title="CallWithDescriptor">isSimplePropertyName</b></i>();
            }
            ts⚠️<i><b title="LoadNamedGeneric">.Debug</b></i>.⚠️<i><b title="LoadNamedGeneric">fail</b></i>("Non-exhaustive case in 'isListElement'.");
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>lookAhead</summary>
<pre class="code">
(callback) {
            return 🔶<i><b title="Did not inline: target text too big">speculationHelper</b></i>(callback, /*isLookAhead*/ true);
        }</pre>

</details>
<details>
<summary>lookAhead</summary>
<pre class="code">
(callback) {
            return 🔶<i><b title="Did not inline: target text too big">speculationHelper</b></i>(callback, /*isLookAhead*/ true);
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>isLiteralPropertyName</summary>
<pre class="code">
() {
            return ts.🔶<i><b title="Did not inline: unknown">tokenIsIdentifierOrKeyword</b></i>(<b title="Inlined">🔷token</b>()) ||
                <b title="Inlined">🔷token</b>() === 9 /* StringLiteral */ ||
                <b title="Inlined">🔷token</b>() === 8 /* NumericLiteral */;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>isHeritageClauseExtendsOrImplementsKeyword</summary>
<pre class="code">
() {
            if (<b title="Inlined">🔷token</b>() === 107 /* ImplementsKeyword */ ||
                <b title="Inlined">🔷token</b>() === 84 /* ExtendsKeyword */) {
                return 🔶<i><b title="Did not inline: unknown">lookAhead</b></i>(nextTokenIsStartOfExpression);
            }
            return false;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>isIdentifierOrPattern</summary>
<pre class="code">
() {
            return <b title="Inlined">🔷token</b>() === 16 /* OpenBraceToken */ || <b title="Inlined">🔷token</b>() === 20 /* OpenBracketToken */ || 🔶<i><b title="Did not inline: target text too big">isIdentifier</b></i>();
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>isStartOfParameter</summary>
<pre class="code">
() {
            return <b title="Inlined">🔷token</b>() === 23 /* DotDotDotToken */ || <b title="Inlined">🔷isIdentifierOrPattern</b>() || ts.🔶<i><b title="Did not inline: unknown">isModifierKind</b></i>(<b title="Inlined">🔷token</b>()) || <b title="Inlined">🔷token</b>() === 56 /* AtToken */ || <b title="Inlined">🔷token</b>() === 98 /* ThisKeyword */;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>isIdentifierOrPattern</summary>
<pre class="code">
() {
            return <b title="Inlined">🔷token</b>() === 16 /* OpenBraceToken */ || <b title="Inlined">🔷token</b>() === 20 /* OpenBracketToken */ || 🔶<i><b title="Did not inline: target text too big">isIdentifier</b></i>();
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>isHeritageClause</summary>
<pre class="code">
() {
            return <b title="Inlined">🔷token</b>() === 84 /* ExtendsKeyword */ || <b title="Inlined">🔷token</b>() === 107 /* ImplementsKeyword */;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>



### parseContextualModifier:
<pre class="code">
(t) {
            return <b title="Inlined">🔷token</b>() === t && 🔶<i><b title="Did not inline: unknown">tryParse</b></i>(nextTokenCanFollowModifier);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>



### inDecoratorContext:
<pre class="code">
() {
            return <b title="Inlined">🔷inContext</b>(8192 /* DecoratorContext */);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>inContext</summary>
<pre class="code">
(flags) {
            return (contextFlags & flags) !== 0;
        }</pre>

</details>
</blockquote>



### isListTerminator:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(kind) {
            if (<b title="Inlined">🔷token</b>() === 1 /* EndOfFileToken */) {
                // Being at the end of the file ends all lists.
                return true;
            }
            switch (kind) {
                case 1 /* BlockStatements */:
                case 2 /* SwitchClauses */:
                case 4 /* TypeMembers */:
                case 5 /* ClassMembers */:
                case 6 /* EnumMembers */:
                case 12 /* ObjectLiteralMembers */:
                case 9 /* ObjectBindingElements */:
                case 22 /* ImportOrExportSpecifiers */:
                    return <b title="Inlined">🔷token</b>() === 17 /* CloseBraceToken */;
                case 3 /* SwitchClauseStatements */:
                    return 🔶<i><b title="Did not inline: unknown">token</b></i>() ⚠️<i><b title="CompareGeneric">=== 17</b></i> /* CloseBraceToken */ || 🔶<i><b title="Did not inline: unknown">token</b></i>() ⚠️<i><b title="CompareGeneric">=== 72</b></i> /* CaseKeyword */ || 🔶<i><b title="Did not inline: unknown">token</b></i>() ⚠️<i><b title="CompareGeneric">=== 78</b></i> /* DefaultKeyword */;
                case 7 /* HeritageClauseElement */:
                    return <b title="Inlined">🔷token</b>() === 16 /* OpenBraceToken */ || <b title="Inlined">🔷token</b>() === 84 /* ExtendsKeyword */ || <b title="Inlined">🔷token</b>() === 107 /* ImplementsKeyword */;
                case 8 /* VariableDeclarations */:
                    return 🔶<i><b title="Did not inline: target text too big">isVariableDeclaratorListTerminator</b></i>();
                case 18 /* TypeParameters */:
                    // Tokens other than '&gt;' are here for better error recovery
                    return <b title="Inlined">🔷token</b>() === 28 /* GreaterThanToken */ || 🔶<i><b title="Did not inline: unknown">token</b></i>() ⚠️<i><b title="CompareGeneric">=== 18</b></i> /* OpenParenToken */ || 🔶<i><b title="Did not inline: unknown">token</b></i>() ⚠️<i><b title="CompareGeneric">=== 16</b></i> /* OpenBraceToken */ || 🔶<i><b title="Did not inline: unknown">token</b></i>() ⚠️<i><b title="CompareGeneric">=== 84</b></i> /* ExtendsKeyword */ || 🔶<i><b title="Did not inline: unknown">token</b></i>() ⚠️<i><b title="CompareGeneric">=== 107</b></i> /* ImplementsKeyword */;
                case 11 /* ArgumentExpressions */:
                    // Tokens other than ')' are here for better error recovery
                    return 🔶<i><b title="Did not inline: unknown">token</b></i>() ⚠️<i><b title="CompareGeneric">=== 19</b></i> /* CloseParenToken */ || 🔶<i><b title="Did not inline: unknown">token</b></i>() ⚠️<i><b title="CompareGeneric">=== 24</b></i> /* SemicolonToken */;
                case 15 /* ArrayLiteralMembers */:
                case 20 /* TupleElementTypes */:
                case 10 /* ArrayBindingElements */:
                    return <b title="Inlined">🔷token</b>() === 21 /* CloseBracketToken */;
                case 16 /* Parameters */:
                case 17 /* RestProperties */:
                    // Tokens other than ')' and ']' (the latter for index signatures) are here for better error recovery
                    return <b title="Inlined">🔷token</b>() === 19 /* CloseParenToken */ || <b title="Inlined">🔷token</b>() === 21 /* CloseBracketToken */ /*|| token === SyntaxKind.OpenBraceToken*/;
                case 19 /* TypeArguments */:
                    // All other tokens should cause the type-argument to terminate except comma token
                    return <b title="Inlined">🔷token</b>() !== 25 /* CommaToken */;
                case 21 /* HeritageClauses */:
                    return <b title="Inlined">🔷token</b>() === 16 /* OpenBraceToken */ || <b title="Inlined">🔷token</b>() === 17 /* CloseBraceToken */;
                case 13 /* JsxAttributes */:
                    return 🔶<i><b title="Did not inline: unknown">token</b></i>() ⚠️<i><b title="CompareGeneric">=== 28</b></i> /* GreaterThanToken */ || 🔶<i><b title="Did not inline: unknown">token</b></i>() ⚠️<i><b title="CompareGeneric">=== 40</b></i> /* SlashToken */;
                case 14 /* JsxChildren */:
                    return 🔶<i><b title="Did not inline: unknown">token</b></i>() ⚠️<i><b title="CompareGeneric">=== 26</b></i> /* LessThanToken */ && 🔶<i><b title="Did not inline: unknown">lookAhead</b></i>(nextTokenIsSlash);
                case 23 /* JSDocFunctionParameters */:
                    return 🔶<i><b title="Did not inline: unknown">token</b></i>() ⚠️<i><b title="CompareGeneric">=== 19</b></i> /* CloseParenToken */ || 🔶<i><b title="Did not inline: unknown">token</b></i>() ⚠️<i><b title="CompareGeneric">=== 55</b></i> /* ColonToken */ || 🔶<i><b title="Did not inline: unknown">token</b></i>() ⚠️<i><b title="CompareGeneric">=== 17</b></i> /* CloseBraceToken */;
                case 24 /* JSDocTypeArguments */:
                    return 🔶<i><b title="Did not inline: unknown">token</b></i>() ⚠️<i><b title="CompareGeneric">=== 28</b></i> /* GreaterThanToken */ || 🔶<i><b title="Did not inline: unknown">token</b></i>() ⚠️<i><b title="CompareGeneric">=== 17</b></i> /* CloseBraceToken */;
                case 26 /* JSDocTupleTypes */:
                    return 🔶<i><b title="Did not inline: unknown">token</b></i>() ⚠️<i><b title="CompareGeneric">=== 21</b></i> /* CloseBracketToken */ || 🔶<i><b title="Did not inline: unknown">token</b></i>() ⚠️<i><b title="CompareGeneric">=== 17</b></i> /* CloseBraceToken */;
                case 25 /* JSDocRecordMembers */:
                    return 🔶<i><b title="Did not inline: unknown">token</b></i>() ⚠️<i><b title="CompareGeneric">=== 17</b></i> /* CloseBraceToken */;
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>



### parsePropertyOrMethodSignature:
<pre class="code">
(fullStart, modifiers) {
            var name = <b title="Inlined">🔷parsePropertyName</b>();
            var questionToken = <b title="Inlined">🔷parseOptionalToken</b>(54 /* QuestionToken */);
            if (<b title="Inlined">🔷token</b>() === 18 /* OpenParenToken */ || <b title="Inlined">🔷token</b>() === 26 /* LessThanToken */) {
                var method = <b title="Inlined">🔷createNode</b>(148 /* MethodSignature */, fullStart);
                method.modifiers = modifiers;
                method.name = name;
                method.questionToken = questionToken;
                // Method signatures don't exist in expression contexts.  So they have neither
                // [Yield] nor [Await]
                🔶<i><b title="Did not inline: target text too big">fillSignature</b></i>(55 /* ColonToken */, /*yieldContext*/ false, /*awaitContext*/ false, /*requireCompleteParameterList*/ false, method);
                <b title="Inlined">🔷parseTypeMemberSemicolon</b>();
                return 🔶<i><b title="Did not inline: target text too big">addJSDocComment</b></i>(🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(method));
            }
            else {
                var property = createNode(146 /* PropertySignature */, fullStart);
                property.modifiers = modifiers;
                property.name = name;
                property.questionToken = questionToken;
                property.type = 🔶<i><b title="Did not inline: unknown">parseTypeAnnotation</b></i>();
                if (🔶<i><b title="Did not inline: unknown">token</b></i>() === 57 /* EqualsToken */) {
                    // Although type literal properties cannot not have initializers, we attempt
                    // to parse an initializer so we can report in the checker that an interface
                    // property or type literal property cannot have an initializer.
                    property.initializer ⚠️<i><b title="StoreNamedGeneric">= parseNonParameterInitializer</b></i>();
                }
                🔶<i><b title="Did not inline: unknown">parseTypeMemberSemicolon</b></i>();
                return 🔶<i><b title="Did not inline: target text too big">addJSDocComment</b></i>(🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(property));
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>parsePropertyName</summary>
<pre class="code">
() {
            return <b title="Inlined">🔷parsePropertyNameWorker</b>(/*allowComputedPropertyNames*/ true);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>parsePropertyNameWorker</summary>
<pre class="code">
(allowComputedPropertyNames) {
            if (<b title="Inlined">🔷token</b>() === 9 /* StringLiteral */ || <b title="Inlined">🔷token</b>() === 8 /* NumericLiteral */) {
                return 🔶<i><b title="Did not inline: unknown">parseLiteralNode</b></i>(/*internName*/ true);
            }
            if (allowComputedPropertyNames && <b title="Inlined">🔷token</b>() === 20 /* OpenBracketToken */) {
                return 🔶️<i><b title="CallWithDescriptor">parseComputedPropertyName</b></i>();
            }
            return <b title="Inlined">🔷parseIdentifierName</b>();
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>parseIdentifierName</summary>
<pre class="code">
() {
            return 🔶<i><b title="Did not inline: target text too big">createIdentifier</b></i>(ts.🔶<i><b title="Did not inline: unknown">tokenIsIdentifierOrKeyword</b></i>(<b title="Inlined">🔷token</b>()));
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>parseOptionalToken</summary>
<pre class="code">
(t) {
            if (<b title="Inlined">🔷token</b>() === t) {
                return <b title="Inlined">🔷parseTokenNode</b>();
            }
            return undefined;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>parseTokenNode</summary>
<pre class="code">
() {
            var node = <b title="Inlined">🔷createNode</b>(<b title="Inlined">🔷token</b>());
            <b title="Inlined">🔷nextToken</b>();
            return 🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(node);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>createNode</summary>
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>createNode</summary>
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>parseTypeMemberSemicolon</summary>
<pre class="code">
() {
            // We allow type members to be separated by commas or (possibly ASI) semicolons.
            // First check if it was a comma.  If so, we're done with the member.
            if (<b title="Inlined">🔷parseOptional</b>(25 /* CommaToken */)) {
                return;
            }
            // Didn't have a comma.  We must have a (possible ASI) semicolon.
            <b title="Inlined">🔷parseSemicolon</b>();
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>parseOptional</summary>
<pre class="code">
(t) {
            if (<b title="Inlined">🔷token</b>() === t) {
                <b title="Inlined">🔷nextToken</b>();
                return true;
            }
            return false;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>parseSemicolon</summary>
<pre class="code">
() {
            if (<b title="Inlined">🔷canParseSemicolon</b>()) {
                if (<b title="Inlined">🔷token</b>() === 24 /* SemicolonToken */) {
                    // consume the semicolon if it was explicitly provided.
                    <b title="Inlined">🔷nextToken</b>();
                }
                return true;
            }
            else {
                return 🔶<i><b title="Did not inline: target text too big">parseExpected</b></i>(24 /* SemicolonToken */);
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>canParseSemicolon</summary>
<pre class="code">
() {
            // If there's a real semicolon, then we can always parse it out.
            if (<b title="Inlined">🔷token</b>() === 24 /* SemicolonToken */) {
                return true;
            }
            // We can parse out an optional semicolon in ASI cases in the following cases.
            return <b title="Inlined">🔷token</b>() === 17 /* CloseBraceToken */ || <b title="Inlined">🔷token</b>() === 1 /* EndOfFileToken */ || scanner.🔶<i><b title="Did not inline: unknown">hasPrecedingLineBreak</b></i>();
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>



### parseTypeReference:
<pre class="code">
() {
            var typeName = <b title="Inlined">🔷parseEntityName</b>(/*allowReservedWords*/ false, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>.Type_expected);
            var node = <b title="Inlined">🔷createNode</b>(157 /* TypeReference */, typeName.pos);
            node.typeName = typeName;
            if (!scanner.🔶<i><b title="Did not inline: unknown">hasPrecedingLineBreak</b></i>() && <b title="Inlined">🔷token</b>() === 26 /* LessThanToken */) {
                node.typeArguments = <b title="Inlined">🔷parseBracketedList</b>(19 /* TypeArguments */, parseType, 26 /* LessThanToken */, 28 /* GreaterThanToken */);
            }
            return 🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(node);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>parseEntityName</summary>
<pre class="code">
(allowReservedWords, diagnosticMessage) {
            var entity = <b title="Inlined">🔷parseIdentifier</b>(diagnosticMessage);
            while (<b title="Inlined">🔷parseOptional</b>(22 /* DotToken */)) {
                var node = <b title="Inlined">🔷createNode</b>(141 /* QualifiedName */, entity.pos); // !!!
                node.left = entity;
                node.right = 🔶<i><b title="Did not inline: target text too big">parseRightSideOfDot</b></i>(allowReservedWords);
                entity = 🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(node);
            }
            return entity;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>parseIdentifier</summary>
<pre class="code">
(diagnosticMessage) {
            return 🔶<i><b title="Did not inline: target text too big">createIdentifier</b></i>(🔶<i><b title="Did not inline: target text too big">isIdentifier</b></i>(), diagnosticMessage);
        }</pre>

</details>
<details>
<summary>parseOptional</summary>
<pre class="code">
(t) {
            if (<b title="Inlined">🔷token</b>() === t) {
                <b title="Inlined">🔷nextToken</b>();
                return true;
            }
            return false;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>createNode</summary>
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>createNode</summary>
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>parseBracketedList</summary>
<pre class="code">
(kind, parseElement, open, close) {
            if (🔶<i><b title="Did not inline: target text too big">parseExpected</b></i>(open)) {
                var result = 🔶<i><b title="Did not inline: target text too big">parseDelimitedList</b></i>(kind, parseElement);
                🔶<i><b title="Did not inline: target text too big">parseExpected</b></i>(close);
                return result;
            }
            return 🔶️<i><b title="CallWithDescriptor">createMissingList</b></i>();
        }</pre>

</details>
</blockquote>



### hasModifier:
<pre class="code">
(node, flags) {
        return (🔶<i><b title="Did not inline: target text too big">getModifierFlags</b></i>(node) & flags) !== 0;
    }</pre>



### canParseSemicolon:
<pre class="code">
() {
            // If there's a real semicolon, then we can always parse it out.
            if (<b title="Inlined">🔷token</b>() === 24 /* SemicolonToken */) {
                return true;
            }
            // We can parse out an optional semicolon in ASI cases in the following cases.
            return <b title="Inlined">🔷token</b>() === 17 /* CloseBraceToken */ || <b title="Inlined">🔷token</b>() === 1 /* EndOfFileToken */ || scanner.🔶<i><b title="Did not inline: unknown">hasPrecedingLineBreak</b></i>();
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>



### parseLeftHandSideExpressionOrHigher:
<pre class="code">
() {
            // Original Ecma:
            // LeftHandSideExpression: See 11.2
            //      NewExpression
            //      CallExpression
            //
            // Our simplification:
            //
            // LeftHandSideExpression: See 11.2
            //      MemberExpression
            //      CallExpression
            //
            // See comment in parseMemberExpressionOrHigher on how we replaced NewExpression with
            // MemberExpression to make our lives easier.
            //
            // to best understand the below code, it's important to see how CallExpression expands
            // out into its own productions:
            //
            // CallExpression:
            //      MemberExpression Arguments
            //      CallExpression Arguments
            //      CallExpression[Expression]
            //      CallExpression.IdentifierName
            //      super   (   ArgumentListopt   )
            //      super.IdentifierName
            //
            // Because of the recursion in these calls, we need to bottom out first.  There are two
            // bottom out states we can run into.  Either we see 'super' which must start either of
            // the last two CallExpression productions.  Or we have a MemberExpression which either
            // completes the LeftHandSideExpression, or starts the beginning of the first four
            // CallExpression productions.
            var expression = <b title="Inlined">🔷token</b>() === 96 /* SuperKeyword */
                ? 🔶️<i><b title="CallWithDescriptor">parseSuperExpression</b></i>()
                : 🔶<i><b title="Did not inline: target text too big">parseMemberExpressionOrHigher</b></i>();
            // Now, we *may* be complete.  However, we might have consumed the start of a
            // CallExpression.  As such, we need to consume the rest of it here to be complete.
            return 🔶️<i><b title="CallWithDescriptor">parseCallExpressionRest</b></i>(expression);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>



### parseMemberExpressionOrHigher:
<pre class="code">
() {
            // Note: to make our lives simpler, we decompose the the NewExpression productions and
            // place ObjectCreationExpression and FunctionExpression into PrimaryExpression.
            // like so:
            //
            //   PrimaryExpression : See 11.1
            //      this
            //      Identifier
            //      Literal
            //      ArrayLiteral
            //      ObjectLiteral
            //      (Expression)
            //      FunctionExpression
            //      new MemberExpression Arguments?
            //
            //   MemberExpression : See 11.2
            //      PrimaryExpression
            //      MemberExpression[Expression]
            //      MemberExpression.IdentifierName
            //
            //   CallExpression : See 11.2
            //      MemberExpression
            //      CallExpression Arguments
            //      CallExpression[Expression]
            //      CallExpression.IdentifierName
            //
            // Technically this is ambiguous.  i.e. CallExpression defines:
            //
            //   CallExpression:
            //      CallExpression Arguments
            //
            // If you see: "new Foo()"
            //
            // Then that could be treated as a single ObjectCreationExpression, or it could be
            // treated as the invocation of "new Foo".  We disambiguate that in code (to match
            // the original grammar) by making sure that if we see an ObjectCreationExpression
            // we always consume arguments if they are there. So we treat "new Foo()" as an
            // object creation only, and not at all as an invocation)  Another way to think
            // about this is that for every "new" that we see, we will consume an argument list if
            // it is there as part of the *associated* object creation node.  Any additional
            // argument lists we see, will become invocation expressions.
            //
            // Because there are no other places in the grammar now that refer to FunctionExpression
            // or ObjectCreationExpression, it is safe to push down into the PrimaryExpression
            // production.
            //
            // Because CallExpression and MemberExpression are left recursive, we need to bottom out
            // of the recursion immediately.  So we parse out a primary expression to start with.
            var expression = 🔶<i><b title="Did not inline: target text too big">parsePrimaryExpression</b></i>();
            return 🔶<i><b title="Did not inline: target text too big">parseMemberExpressionRest</b></i>(expression);
        }</pre>



### parseFunctionBlockOrSemicolon:
<pre class="code">
(isGenerator, isAsync, diagnosticMessage) {
            if (<b title="Inlined">🔷token</b>() !== 16 /* OpenBraceToken */ && <b title="Inlined">🔷canParseSemicolon</b>()) {
                <b title="Inlined">🔷parseSemicolon</b>();
                return;
            }
            return 🔶️<i><b title="CallWithDescriptor">parseFunctionBlock</b></i>(isGenerator, isAsync, /*ignoreMissingOpenBrace*/ false, diagnosticMessage);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>canParseSemicolon</summary>
<pre class="code">
() {
            // If there's a real semicolon, then we can always parse it out.
            if (<b title="Inlined">🔷token</b>() === 24 /* SemicolonToken */) {
                return true;
            }
            // We can parse out an optional semicolon in ASI cases in the following cases.
            return <b title="Inlined">🔷token</b>() === 17 /* CloseBraceToken */ || <b title="Inlined">🔷token</b>() === 1 /* EndOfFileToken */ || scanner.🔶<i><b title="Did not inline: unknown">hasPrecedingLineBreak</b></i>();
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>parseSemicolon</summary>
<pre class="code">
() {
            if (<b title="Inlined">🔷canParseSemicolon</b>()) {
                if (<b title="Inlined">🔷token</b>() === 24 /* SemicolonToken */) {
                    // consume the semicolon if it was explicitly provided.
                    <b title="Inlined">🔷nextToken</b>();
                }
                return true;
            }
            else {
                return 🔶<i><b title="Did not inline: target text too big">parseExpected</b></i>(24 /* SemicolonToken */);
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>canParseSemicolon</summary>
<pre class="code">
() {
            // If there's a real semicolon, then we can always parse it out.
            if (<b title="Inlined">🔷token</b>() === 24 /* SemicolonToken */) {
                return true;
            }
            // We can parse out an optional semicolon in ASI cases in the following cases.
            return <b title="Inlined">🔷token</b>() === 17 /* CloseBraceToken */ || <b title="Inlined">🔷token</b>() === 1 /* EndOfFileToken */ || scanner.🔶<i><b title="Did not inline: unknown">hasPrecedingLineBreak</b></i>();
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### parseLiteralNode:
<pre class="code">
(internName) {
            return 🔶<i><b title="Did not inline: target text too big">parseLiteralLikeNode</b></i>(<b title="Inlined">🔷token</b>(), internName);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>



### hasExtendedUnicodeEscape:
<pre class="code">
() { return hasExtendedUnicodeEscape; }</pre>



### isUnterminated:
<pre class="code">
() { return tokenIsUnterminated; }</pre>



### canFollowModifier:
<pre class="code">
() {
            return <b title="Inlined">🔷token</b>() === 20 /* OpenBracketToken */
                || <b title="Inlined">🔷token</b>() === 16 /* OpenBraceToken */
                || <b title="Inlined">🔷token</b>() === 38 /* AsteriskToken */
                || <b title="Inlined">🔷token</b>() === 23 /* DotDotDotToken */
                || <b title="Inlined">🔷isLiteralPropertyName</b>();
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>isLiteralPropertyName</summary>
<pre class="code">
() {
            return ts.🔶<i><b title="Did not inline: unknown">tokenIsIdentifierOrKeyword</b></i>(<b title="Inlined">🔷token</b>()) ||
                <b title="Inlined">🔷token</b>() === 9 /* StringLiteral */ ||
                <b title="Inlined">🔷token</b>() === 8 /* NumericLiteral */;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### isLeftHandSideExpression:
<pre class="code">
(node) {
        return 🔶<i><b title="Did not inline: target text too big">isLeftHandSideExpressionKind</b></i>(ts.🔶<i><b title="Did not inline: unknown">skipPartiallyEmittedExpressions</b></i>(node).kind);
    }</pre>



### skipParameterStart:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
() {
            if (ts.⚠️<i><b title="LoadNamedGeneric">isModifierKind</b></i>(<b title="Inlined">🔷token</b>())) {
                // Skip modifiers
                🔶<i><b title="Did not inline: target text too big">parseModifiers</b></i>();
            }
            if (🔶<i><b title="Did not inline: target text too big">isIdentifier</b></i>() || <b title="Inlined">🔷token</b>() === 98 /* ThisKeyword */) {
                <b title="Inlined">🔷nextToken</b>();
                return true;
            }
            if (<b title="Inlined">🔷token</b>() === 20 /* OpenBracketToken */ || <b title="Inlined">🔷token</b>() === 16 /* OpenBraceToken */) {
                // Return true if we can parse an array or object binding pattern with no errors
                var previousErrorCount = parseDiagnostics⚠️<i><b title="LoadNamedGeneric">.length</b></i>;
                🔶<i><b title="Did not inline: unknown">parseIdentifierOrPattern</b></i>();
                return previousErrorCount ⚠️<i><b title="CompareGeneric">=== parseDiagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.length</b></i>;
            }
            return false;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>



### parseDecorators:
<pre class="code">
() {
            var decorators;
            while (true) {
                var decoratorStart = <b title="Inlined">🔷getNodePos</b>();
                if (!<b title="Inlined">🔷parseOptional</b>(56 /* AtToken */)) {
                    break;
                }
                var decorator = 🔶<i><b title="Did not inline: unknown">createNode</b></i>(145 /* Decorator */, decoratorStart);
                decorator.expression ⚠️<i><b title="StoreNamedGeneric">= doInDecoratorContext</b></i>(parseLeftHandSideExpressionOrHigher);
                🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(decorator);
                if (!decorators) {
                    decorators = 🔶<i><b title="Did not inline: unknown">createNodeArray</b></i>(🔶️<i><b title="CallWithDescriptor">[decorator]</b></i>, decoratorStart);
                }
                else {
                    decorators.🔶️<i><b title="CallWithDescriptor">push</b></i>(decorator);
                }
            }
            if (decorators) {
                decorators.end ⚠️<i><b title="StoreNamedGeneric">= getNodeEnd</b></i>();
            }
            return decorators;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getNodePos</summary>
<pre class="code">
() {
            return scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
        }</pre>

</details>
<details>
<summary>parseOptional</summary>
<pre class="code">
(t) {
            if (<b title="Inlined">🔷token</b>() === t) {
                <b title="Inlined">🔷nextToken</b>();
                return true;
            }
            return false;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### nextTokenIsIdentifierOnSameLine:
<pre class="code">
() {
            <b title="Inlined">🔷nextToken</b>();
            return !scanner.🔶<i><b title="Did not inline: unknown">hasPrecedingLineBreak</b></i>() && 🔶<i><b title="Did not inline: target text too big">isIdentifier</b></i>();
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>



### isDeclaration:
<pre class="code">
() {
            while (true) {
                ⚠️<i><b title="CompareGeneric">switch</b></i> (<b title="Inlined">🔷token</b>()) {
                    case 103 /* VarKeyword */:
                    case 109 /* LetKeyword */:
                    case 75 /* ConstKeyword */:
                    case 88 /* FunctionKeyword */:
                    case 74 /* ClassKeyword */:
                    case 82 /* EnumKeyword */:
                        return true;
                    // 'declare', 'module', 'namespace', 'interface'* and 'type' are all legal JavaScript identifiers;
                    // however, an identifier cannot be followed by another identifier on the same line. This is what we
                    // count on to parse out the respective declarations. For instance, we exploit this to say that
                    //
                    //    namespace n
                    //
                    // can be none other than the beginning of a namespace declaration, but need to respect that JavaScript sees
                    //
                    //    namespace
                    //    n
                    //
                    // as the identifier 'namespace' on one line followed by the identifier 'n' on another.
                    // We need to look one token ahead to see if it permissible to try parsing a declaration.
                    //
                    // *Note*: 'interface' is actually a strict mode reserved word. So while
                    //
                    //   "use strict"
                    //   interface
                    //   I {}
                    //
                    // could be legal, it would add complexity for very little gain.
                    case 108 /* InterfaceKeyword */:
                    case 136 /* TypeKeyword */:
                        return <b title="Inlined">🔷nextTokenIsIdentifierOnSameLine</b>();
                    case 127 /* ModuleKeyword */:
                    case 128 /* NamespaceKeyword */:
                        return <b title="Inlined">🔷nextTokenIsIdentifierOrStringLiteralOnSameLine</b>();
                    case 116 /* AbstractKeyword */:
                    case 119 /* AsyncKeyword */:
                    case 123 /* DeclareKeyword */:
                    case 111 /* PrivateKeyword */:
                    case 112 /* ProtectedKeyword */:
                    case 113 /* PublicKeyword */:
                    case 130 /* ReadonlyKeyword */:
                        <b title="Inlined">🔷nextToken</b>();
                        // ASI takes effect for this modifier.
                        if (scanner.🔶<i><b title="Did not inline: unknown">hasPrecedingLineBreak</b></i>()) {
                            return false;
                        }
                        continue;
                    case 139 /* GlobalKeyword */:
                        🔶<i><b title="Did not inline: unknown">nextToken</b></i>();
                        return 🔶<i><b title="Did not inline: unknown">token</b></i>() ⚠️<i><b title="CompareGeneric">=== 16</b></i> /* OpenBraceToken */ || 🔶<i><b title="Did not inline: unknown">token</b></i>() ⚠️<i><b title="CompareGeneric">=== 70</b></i> /* Identifier */ || 🔶<i><b title="Did not inline: unknown">token</b></i>() ⚠️<i><b title="CompareGeneric">=== 83</b></i> /* ExportKeyword */;
                    case 90 /* ImportKeyword */:
                        <b title="Inlined">🔷nextToken</b>();
                        return <b title="Inlined">🔷token</b>() === 9 /* StringLiteral */ || <b title="Inlined">🔷token</b>() === 38 /* AsteriskToken */ ||
                            🔶<i><b title="Did not inline: unknown">token</b></i>() ⚠️<i><b title="CompareGeneric">=== 16</b></i> /* OpenBraceToken */ || ts.🔶<i><b title="Did not inline: unknown">tokenIsIdentifierOrKeyword</b></i>(🔶<i><b title="Did not inline: unknown">token</b></i>());
                    case 83 /* ExportKeyword */:
                        <b title="Inlined">🔷nextToken</b>();
                        if (<b title="Inlined">🔷token</b>() === 57 /* EqualsToken */ || <b title="Inlined">🔷token</b>() === 38 /* AsteriskToken */ ||
                            <b title="Inlined">🔷token</b>() === 16 /* OpenBraceToken */ || <b title="Inlined">🔷token</b>() === 78 /* DefaultKeyword */ ||
                            <b title="Inlined">🔷token</b>() === 117 /* AsKeyword */) {
                            return true;
                        }
                        continue;
                    case 114 /* StaticKeyword */:
                        🔶<i><b title="Did not inline: unknown">nextToken</b></i>();
                        continue;
                    default:
                        return false;
                }
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>nextTokenIsIdentifierOnSameLine</summary>
<pre class="code">
() {
            <b title="Inlined">🔷nextToken</b>();
            return !scanner.🔶<i><b title="Did not inline: unknown">hasPrecedingLineBreak</b></i>() && 🔶<i><b title="Did not inline: target text too big">isIdentifier</b></i>();
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>nextTokenIsIdentifierOrStringLiteralOnSameLine</summary>
<pre class="code">
() {
            <b title="Inlined">🔷nextToken</b>();
            return !scanner.🔶<i><b title="Did not inline: unknown">hasPrecedingLineBreak</b></i>() && (🔶<i><b title="Did not inline: target text too big">isIdentifier</b></i>() || <b title="Inlined">🔷token</b>() === 9 /* StringLiteral */);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>



### setDisallowInContext:
<pre class="code">
(val) {
            <b title="Inlined">🔷setContextFlag</b>(val, 2048 /* DisallowInContext */);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>setContextFlag</summary>
<pre class="code">
(val, flag) {
            if (val) {
                contextFlags |⚠️<i><b title="Bitwise">= flag</b></i>;
            }
            else {
                contextFlags &= ~flag;
            }
        }</pre>

</details>
</blockquote>



### scanString:
<pre class="code">
(allowEscapes) {
            if (allowEscapes === void 0) { allowEscapes = true; }
            var quote = text.charCodeAt(pos);
            pos++;
            var result = "";
            var start = pos;
            while (true) {
                if (pos &gt;= end) {
                    result +⚠️<i><b title="Add">= text</b></i>.⚠️<i><b title="LoadNamedGeneric">substring</b></i>(start, pos);
                    tokenIsUnterminated = true;
                    🔶️<i><b title="CallWithDescriptor">error</b></i>(ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Unterminated_string_literal</b></i>);
                    break;
                }
                var ch = text.charCodeAt(pos);
                if (ch === quote) {
                    result += text.🔶<i><b title="Did not inline: unknown">substring</b></i>(start, pos);
                    pos++;
                    break;
                }
                if (ch === 92 /* backslash */ && allowEscapes) {
                    result +⚠️<i><b title="Add">= text</b></i>.🔶<i><b title="Did not inline: unknown">substring</b></i>(start, pos);
                    result +⚠️<i><b title="Add">= scanEscapeSequence</b></i>();
                    start = pos;
                    continue;
                }
                if (🔶<i><b title="Did not inline: target text too big">isLineBreak</b></i>(ch)) {
                    result +⚠️<i><b title="Add">= text</b></i>.🔶<i><b title="Did not inline: unknown">substring</b></i>(start, pos);
                    tokenIsUnterminated = true;
                    🔶️<i><b title="CallWithDescriptor">error</b></i>(ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Unterminated_string_literal</b></i>);
                    break;
                }
                pos++;
            }
            return result;
        }</pre>



### isStartOfStatement:
<pre class="code">
() {
            ⚠️<i><b title="CompareGeneric">switch</b></i> (<b title="Inlined">🔷token</b>()) {
                case 56 /* AtToken */:
                case 24 /* SemicolonToken */:
                case 16 /* OpenBraceToken */:
                case 103 /* VarKeyword */:
                case 109 /* LetKeyword */:
                case 88 /* FunctionKeyword */:
                case 74 /* ClassKeyword */:
                case 82 /* EnumKeyword */:
                case 89 /* IfKeyword */:
                case 80 /* DoKeyword */:
                case 105 /* WhileKeyword */:
                case 87 /* ForKeyword */:
                case 76 /* ContinueKeyword */:
                case 71 /* BreakKeyword */:
                case 95 /* ReturnKeyword */:
                case 106 /* WithKeyword */:
                case 97 /* SwitchKeyword */:
                case 99 /* ThrowKeyword */:
                case 101 /* TryKeyword */:
                case 77 /* DebuggerKeyword */:
                // 'catch' and 'finally' do not actually indicate that the code is part of a statement,
                // however, we say they are here so that we may gracefully parse them and error later.
                case 73 /* CatchKeyword */:
                case 86 /* FinallyKeyword */:
                    return true;
                case 75 /* ConstKeyword */:
                case 83 /* ExportKeyword */:
                case 90 /* ImportKeyword */:
                    return <b title="Inlined">🔷isStartOfDeclaration</b>();
                case 119 /* AsyncKeyword */:
                case 123 /* DeclareKeyword */:
                case 108 /* InterfaceKeyword */:
                case 127 /* ModuleKeyword */:
                case 128 /* NamespaceKeyword */:
                case 136 /* TypeKeyword */:
                case 139 /* GlobalKeyword */:
                    // When these don't start a declaration, they're an identifier in an expression statement
                    return true;
                case 113 /* PublicKeyword */:
                case 111 /* PrivateKeyword */:
                case 112 /* ProtectedKeyword */:
                case 114 /* StaticKeyword */:
                case 130 /* ReadonlyKeyword */:
                    // When these don't start a declaration, they may be the start of a class member if an identifier
                    // immediately follows. Otherwise they're an identifier in an expression statement.
                    return 🔶<i><b title="Did not inline: unknown">isStartOfDeclaration</b></i>() || !🔶<i><b title="Did not inline: unknown">lookAhead</b></i>(nextTokenIsIdentifierOrKeywordOnSameLine);
                default:
                    return 🔶<i><b title="Did not inline: target text too big">isStartOfExpression</b></i>();
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>isStartOfDeclaration</summary>
<pre class="code">
() {
            return <b title="Inlined">🔷lookAhead</b>(isDeclaration);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>lookAhead</summary>
<pre class="code">
(callback) {
            return 🔶<i><b title="Did not inline: target text too big">speculationHelper</b></i>(callback, /*isLookAhead*/ true);
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### parseStatement:
<pre class="code">
() {
            ⚠️<i><b title="CompareGeneric">switch</b></i> (<b title="Inlined">🔷token</b>()) {
                case 24 /* SemicolonToken */:
                    return 🔶️<i><b title="CallWithDescriptor">parseEmptyStatement</b></i>();
                case 16 /* OpenBraceToken */:
                    return 🔶️<i><b title="CallWithDescriptor">parseBlock</b></i>(/*ignoreMissingOpenBrace*/ false);
                case 103 /* VarKeyword */:
                    return <b title="Inlined">🔷parseVariableStatement</b>(scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>(), /*decorators*/ undefined, /*modifiers*/ undefined);
                case 109 /* LetKeyword */:
                    if (🔶️<i><b title="CallWithDescriptor">isLetDeclaration</b></i>()) {
                        return 🔶️<i><b title="CallWithDescriptor">parseVariableStatement</b></i>(scanner.⚠️<i><b title="LoadNamedGeneric">getStartPos</b></i>(), /*decorators*/ undefined, /*modifiers*/ undefined);
                    }
                    break;
                case 88 /* FunctionKeyword */:
                    return 🔶<i><b title="Did not inline: target text too big">parseFunctionDeclaration</b></i>(scanner.⚠️<i><b title="LoadNamedGeneric">getStartPos</b></i>(), /*decorators*/ undefined, /*modifiers*/ undefined);
                case 74 /* ClassKeyword */:
                    return <b title="Inlined">🔷parseClassDeclaration</b>(scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>(), /*decorators*/ undefined, /*modifiers*/ undefined);
                case 89 /* IfKeyword */:
                    return 🔶️<i><b title="CallWithDescriptor">parseIfStatement</b></i>();
                case 80 /* DoKeyword */:
                    return 🔶️<i><b title="CallWithDescriptor">parseDoStatement</b></i>();
                case 105 /* WhileKeyword */:
                    return 🔶️<i><b title="CallWithDescriptor">parseWhileStatement</b></i>();
                case 87 /* ForKeyword */:
                    return 🔶️<i><b title="CallWithDescriptor">parseForOrForInOrForOfStatement</b></i>();
                case 76 /* ContinueKeyword */:
                    return 🔶️<i><b title="CallWithDescriptor">parseBreakOrContinueStatement</b></i>(214 /* ContinueStatement */);
                case 71 /* BreakKeyword */:
                    return 🔶️<i><b title="CallWithDescriptor">parseBreakOrContinueStatement</b></i>(215 /* BreakStatement */);
                case 95 /* ReturnKeyword */:
                    return 🔶️<i><b title="CallWithDescriptor">parseReturnStatement</b></i>();
                case 106 /* WithKeyword */:
                    return 🔶️<i><b title="CallWithDescriptor">parseWithStatement</b></i>();
                case 97 /* SwitchKeyword */:
                    return 🔶️<i><b title="CallWithDescriptor">parseSwitchStatement</b></i>();
                case 99 /* ThrowKeyword */:
                    return 🔶️<i><b title="CallWithDescriptor">parseThrowStatement</b></i>();
                case 101 /* TryKeyword */:
                // Include 'catch' and 'finally' for error recovery.
                case 73 /* CatchKeyword */:
                case 86 /* FinallyKeyword */:
                    return 🔶️<i><b title="CallWithDescriptor">parseTryStatement</b></i>();
                case 77 /* DebuggerKeyword */:
                    return 🔶️<i><b title="CallWithDescriptor">parseDebuggerStatement</b></i>();
                case 56 /* AtToken */:
                    return 🔶<i><b title="Did not inline: target text too big">parseDeclaration</b></i>();
                case 119 /* AsyncKeyword */:
                case 108 /* InterfaceKeyword */:
                case 136 /* TypeKeyword */:
                case 127 /* ModuleKeyword */:
                case 128 /* NamespaceKeyword */:
                case 123 /* DeclareKeyword */:
                case 75 /* ConstKeyword */:
                case 82 /* EnumKeyword */:
                case 83 /* ExportKeyword */:
                case 90 /* ImportKeyword */:
                case 111 /* PrivateKeyword */:
                case 112 /* ProtectedKeyword */:
                case 113 /* PublicKeyword */:
                case 116 /* AbstractKeyword */:
                case 114 /* StaticKeyword */:
                case 130 /* ReadonlyKeyword */:
                case 139 /* GlobalKeyword */:
                    if (<b title="Inlined">🔷isStartOfDeclaration</b>()) {
                        return 🔶<i><b title="Did not inline: target text too big">parseDeclaration</b></i>();
                    }
                    break;
            }
            return 🔶️<i><b title="CallWithDescriptor">parseExpressionOrLabeledStatement</b></i>();
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>parseVariableStatement</summary>
<pre class="code">
(fullStart, decorators, modifiers) {
            var node = <b title="Inlined">🔷createNode</b>(205 /* VariableStatement */, fullStart);
            node.decorators = decorators;
            node.modifiers = modifiers;
            node.declarationList = 🔶<i><b title="Did not inline: target text too big">parseVariableDeclarationList</b></i>(/*inForStatementInitializer*/ false);
            <b title="Inlined">🔷parseSemicolon</b>();
            return 🔶<i><b title="Did not inline: target text too big">addJSDocComment</b></i>(🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(node));
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createNode</summary>
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>parseSemicolon</summary>
<pre class="code">
() {
            if (<b title="Inlined">🔷canParseSemicolon</b>()) {
                if (<b title="Inlined">🔷token</b>() === 24 /* SemicolonToken */) {
                    // consume the semicolon if it was explicitly provided.
                    <b title="Inlined">🔷nextToken</b>();
                }
                return true;
            }
            else {
                return 🔶<i><b title="Did not inline: target text too big">parseExpected</b></i>(24 /* SemicolonToken */);
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>canParseSemicolon</summary>
<pre class="code">
() {
            // If there's a real semicolon, then we can always parse it out.
            if (<b title="Inlined">🔷token</b>() === 24 /* SemicolonToken */) {
                return true;
            }
            // We can parse out an optional semicolon in ASI cases in the following cases.
            return <b title="Inlined">🔷token</b>() === 17 /* CloseBraceToken */ || <b title="Inlined">🔷token</b>() === 1 /* EndOfFileToken */ || scanner.🔶<i><b title="Did not inline: unknown">hasPrecedingLineBreak</b></i>();
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>parseClassDeclaration</summary>
<pre class="code">
(fullStart, decorators, modifiers) {
            return 🔶️<i><b title="CallWithDescriptor">parseClassDeclarationOrExpression</b></i>(fullStart, decorators, modifiers, 226 /* ClassDeclaration */);
        }</pre>

</details>
<details>
<summary>isStartOfDeclaration</summary>
<pre class="code">
() {
            return <b title="Inlined">🔷lookAhead</b>(isDeclaration);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>lookAhead</summary>
<pre class="code">
(callback) {
            return 🔶<i><b title="Did not inline: target text too big">speculationHelper</b></i>(callback, /*isLookAhead*/ true);
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### parseDeclaration:
<pre class="code">
() {
            var fullStart = <b title="Inlined">🔷getNodePos</b>();
            var decorators = parseDecorators();
            var modifiers = parseModifiers();
            switch (<b title="Inlined">🔷token</b>()) {
                case 103 /* VarKeyword */:
                case 109 /* LetKeyword */:
                case 75 /* ConstKeyword */:
                    return <b title="Inlined">🔷parseVariableStatement</b>(fullStart, decorators, modifiers);
                case 88 /* FunctionKeyword */:
                    return 🔶<i><b title="Did not inline: target text too big">parseFunctionDeclaration</b></i>(fullStart, decorators, modifiers);
                case 74 /* ClassKeyword */:
                    return <b title="Inlined">🔷parseClassDeclaration</b>(fullStart, decorators, modifiers);
                case 108 /* InterfaceKeyword */:
                    return <b title="Inlined">🔷parseInterfaceDeclaration</b>(fullStart, decorators, modifiers);
                case 136 /* TypeKeyword */:
                    return 🔶️<i><b title="CallWithDescriptor">parseTypeAliasDeclaration</b></i>(fullStart, decorators, modifiers);
                case 82 /* EnumKeyword */:
                    return 🔶️<i><b title="CallWithDescriptor">parseEnumDeclaration</b></i>(fullStart, decorators, modifiers);
                case 139 /* GlobalKeyword */:
                case 127 /* ModuleKeyword */:
                case 128 /* NamespaceKeyword */:
                    return 🔶️<i><b title="CallWithDescriptor">parseModuleDeclaration</b></i>(fullStart, decorators, modifiers);
                case 90 /* ImportKeyword */:
                    return 🔶️<i><b title="CallWithDescriptor">parseImportDeclarationOrImportEqualsDeclaration</b></i>(fullStart, decorators, modifiers);
                case 83 /* ExportKeyword */:
                    🔶<i><b title="Did not inline: unknown">nextToken</b></i>();
                    switch (🔶<i><b title="Did not inline: unknown">token</b></i>()) {
                        case 78 /* DefaultKeyword */:
                        case 57 /* EqualsToken */:
                            return 🔶️<i><b title="CallWithDescriptor">parseExportAssignment</b></i>(fullStart, decorators, modifiers);
                        case 117 /* AsKeyword */:
                            return 🔶️<i><b title="CallWithDescriptor">parseNamespaceExportDeclaration</b></i>(fullStart, decorators, modifiers);
                        default:
                            return 🔶️<i><b title="CallWithDescriptor">parseExportDeclaration</b></i>(fullStart, decorators, modifiers);
                    }
                default:
                    if (decorators || modifiers) {
                        // We reached this point because we encountered decorators and/or modifiers and assumed a declaration
                        // would follow. For recovery and error reporting purposes, return an incomplete declaration.
                        var node = 🔶️<i><b title="CallWithDescriptor">createMissingNode</b></i>(244 /* MissingDeclaration */, /*reportAtCurrentPosition*/ true, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Declaration_expected</b></i>);
                        node.pos ⚠️<i><b title="StoreNamedGeneric">= fullStart</b></i>;
                        node.decorators ⚠️<i><b title="StoreNamedGeneric">= decorators</b></i>;
                        node.modifiers ⚠️<i><b title="StoreNamedGeneric">= modifiers</b></i>;
                        return 🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(node);
                    }
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getNodePos</summary>
<pre class="code">
() {
            return scanner.getStartPos();
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>parseVariableStatement</summary>
<pre class="code">
(fullStart, decorators, modifiers) {
            var node = <b title="Inlined">🔷createNode</b>(205 /* VariableStatement */, fullStart);
            node.decorators = decorators;
            node.modifiers = modifiers;
            node.declarationList = 🔶<i><b title="Did not inline: target text too big">parseVariableDeclarationList</b></i>(/*inForStatementInitializer*/ false);
            <b title="Inlined">🔷parseSemicolon</b>();
            return 🔶<i><b title="Did not inline: target text too big">addJSDocComment</b></i>(🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(node));
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createNode</summary>
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>parseSemicolon</summary>
<pre class="code">
() {
            if (<b title="Inlined">🔷canParseSemicolon</b>()) {
                if (<b title="Inlined">🔷token</b>() === 24 /* SemicolonToken */) {
                    // consume the semicolon if it was explicitly provided.
                    <b title="Inlined">🔷nextToken</b>();
                }
                return true;
            }
            else {
                return 🔶<i><b title="Did not inline: target text too big">parseExpected</b></i>(24 /* SemicolonToken */);
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>canParseSemicolon</summary>
<pre class="code">
() {
            // If there's a real semicolon, then we can always parse it out.
            if (<b title="Inlined">🔷token</b>() === 24 /* SemicolonToken */) {
                return true;
            }
            // We can parse out an optional semicolon in ASI cases in the following cases.
            return <b title="Inlined">🔷token</b>() === 17 /* CloseBraceToken */ || <b title="Inlined">🔷token</b>() === 1 /* EndOfFileToken */ || scanner.🔶<i><b title="Did not inline: unknown">hasPrecedingLineBreak</b></i>();
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>parseClassDeclaration</summary>
<pre class="code">
(fullStart, decorators, modifiers) {
            return 🔶️<i><b title="CallWithDescriptor">parseClassDeclarationOrExpression</b></i>(fullStart, decorators, modifiers, 226 /* ClassDeclaration */);
        }</pre>

</details>
<details>
<summary>parseInterfaceDeclaration</summary>
<pre class="code">
(fullStart, decorators, modifiers) {
            var node = <b title="Inlined">🔷createNode</b>(227 /* InterfaceDeclaration */, fullStart);
            node.decorators = decorators;
            node.modifiers = modifiers;
            🔶<i><b title="Did not inline: target text too big">parseExpected</b></i>(108 /* InterfaceKeyword */);
            node.name = <b title="Inlined">🔷parseIdentifier</b>();
            node.typeParameters = <b title="Inlined">🔷parseTypeParameters</b>();
            node.heritageClauses = <b title="Inlined">🔷parseHeritageClauses</b>();
            node.members = <b title="Inlined">🔷parseObjectTypeMembers</b>();
            return 🔶<i><b title="Did not inline: target text too big">addJSDocComment</b></i>(🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(node));
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createNode</summary>
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>parseIdentifier</summary>
<pre class="code">
(diagnosticMessage) {
            return 🔶<i><b title="Did not inline: target text too big">createIdentifier</b></i>(🔶<i><b title="Did not inline: target text too big">isIdentifier</b></i>(), diagnosticMessage);
        }</pre>

</details>
<details>
<summary>parseTypeParameters</summary>
<pre class="code">
() {
            if (<b title="Inlined">🔷token</b>() === 26 /* LessThanToken */) {
                return <b title="Inlined">🔷parseBracketedList</b>(18 /* TypeParameters */, parseTypeParameter, 26 /* LessThanToken */, 28 /* GreaterThanToken */);
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>parseBracketedList</summary>
<pre class="code">
(kind, parseElement, open, close) {
            if (🔶<i><b title="Did not inline: target text too big">parseExpected</b></i>(open)) {
                var result = 🔶<i><b title="Did not inline: target text too big">parseDelimitedList</b></i>(kind, parseElement);
                🔶<i><b title="Did not inline: target text too big">parseExpected</b></i>(close);
                return result;
            }
            return 🔶️<i><b title="CallWithDescriptor">createMissingList</b></i>();
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>parseHeritageClauses</summary>
<pre class="code">
() {
            // ClassTail[Yield,Await] : (Modified) See 14.5
            //      ClassHeritage[?Yield,?Await]opt { ClassBody[?Yield,?Await]opt }
            if (<b title="Inlined">🔷isHeritageClause</b>()) {
                return 🔶<i><b title="Did not inline: target text too big">parseList</b></i>(21 /* HeritageClauses */, parseHeritageClause);
            }
            return undefined;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>isHeritageClause</summary>
<pre class="code">
() {
            return <b title="Inlined">🔷token</b>() === 84 /* ExtendsKeyword */ || <b title="Inlined">🔷token</b>() === 107 /* ImplementsKeyword */;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>parseObjectTypeMembers</summary>
<pre class="code">
() {
            var members;
            if (🔶<i><b title="Did not inline: target text too big">parseExpected</b></i>(16 /* OpenBraceToken */)) {
                members = 🔶<i><b title="Did not inline: target text too big">parseList</b></i>(4 /* TypeMembers */, parseTypeMember);
                🔶<i><b title="Did not inline: target text too big">parseExpected</b></i>(17 /* CloseBraceToken */);
            }
            else {
                members = 🔶️<i><b title="CallWithDescriptor">createMissingList</b></i>();
            }
            return members;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### parseModifiers:
<pre class="code">
(permitInvalidConstAsModifier) {
            var modifiers;
            while (true) {
                var modifierStart = scanner.getStartPos();
                var modifierKind = <b title="Inlined">🔷token</b>();
                if (<b title="Inlined">🔷token</b>() === 75 /* ConstKeyword */ && permitInvalidConstAsModifier) {
                    // We need to ensure that any subsequent modifiers appear on the same line
                    // so that when 'const' is a standalone declaration, we don't issue an error.
                    if (!🔶<i><b title="Did not inline: unknown">tryParse</b></i>(nextTokenIsOnSameLineAndCanFollowModifier)) {
                        break;
                    }
                }
                else {
                    if (!<b title="Inlined">🔷parseAnyContextualModifier</b>()) {
                        break;
                    }
                }
                var modifier = 🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(<b title="Inlined">🔷createNode</b>(modifierKind, modifierStart));
                if (!modifiers) {
                    modifiers = <b title="Inlined">🔷createNodeArray</b>([modifier], modifierStart);
                }
                else {
                    modifiers.🔶️<i><b title="CallWithDescriptor">push</b></i>(modifier);
                }
            }
            if (modifiers) {
                modifiers.end = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return modifiers;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>parseAnyContextualModifier</summary>
<pre class="code">
() {
            return ts.🔶<i><b title="Did not inline: unknown">isModifierKind</b></i>(<b title="Inlined">🔷token</b>()) && <b title="Inlined">🔷tryParse</b>(nextTokenCanFollowModifier);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>tryParse</summary>
<pre class="code">
(callback) {
            return 🔶<i><b title="Did not inline: target text too big">speculationHelper</b></i>(callback, /*isLookAhead*/ false);
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>createNode</summary>
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>createNodeArray</summary>
<pre class="code">
(elements, pos) {
            var array = (elements || []);
            if (!(pos &gt;= 0)) {
                pos = <b title="Inlined">🔷getNodePos</b>();
            }
            array.pos ⚠️<i><b title="StoreNamedGeneric">= pos</b></i>;
            array.end = pos;
            return array;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getNodePos</summary>
<pre class="code">
() {
            return scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### parsePrimaryExpression:
<pre class="code">
() {
            switch (<b title="Inlined">🔷token</b>()) {
                case 8 /* NumericLiteral */:
                case 9 /* StringLiteral */:
                case 12 /* NoSubstitutionTemplateLiteral */:
                    return <b title="Inlined">🔷parseLiteralNode</b>();
                case 98 /* ThisKeyword */:
                case 96 /* SuperKeyword */:
                case 94 /* NullKeyword */:
                case 100 /* TrueKeyword */:
                case 85 /* FalseKeyword */:
                    return 🔶️<i><b title="CallWithDescriptor">parseTokenNode</b></i>();
                case 18 /* OpenParenToken */:
                    return 🔶️<i><b title="CallWithDescriptor">parseParenthesizedExpression</b></i>();
                case 20 /* OpenBracketToken */:
                    return 🔶️<i><b title="CallWithDescriptor">parseArrayLiteralExpression</b></i>();
                case 16 /* OpenBraceToken */:
                    return 🔶️<i><b title="CallWithDescriptor">parseObjectLiteralExpression</b></i>();
                case 119 /* AsyncKeyword */:
                    // Async arrow functions are parsed earlier in parseAssignmentExpressionOrHigher.
                    // If we encounter `async [no LineTerminator here] function` then this is an async
                    // function; otherwise, its an identifier.
                    if (!🔶<i><b title="Did not inline: unknown">lookAhead</b></i>(nextTokenIsFunctionKeywordOnSameLine)) {
                        break;
                    }
                    return 🔶️<i><b title="CallWithDescriptor">parseFunctionExpression</b></i>();
                case 74 /* ClassKeyword */:
                    return 🔶️<i><b title="CallWithDescriptor">parseClassExpression</b></i>();
                case 88 /* FunctionKeyword */:
                    return 🔶️<i><b title="CallWithDescriptor">parseFunctionExpression</b></i>();
                case 93 /* NewKeyword */:
                    return 🔶️<i><b title="CallWithDescriptor">parseNewExpression</b></i>();
                case 40 /* SlashToken */:
                case 62 /* SlashEqualsToken */:
                    if (🔶️<i><b title="CallWithDescriptor">reScanSlashToken</b></i>() ⚠️<i><b title="CompareGeneric">=== 11</b></i> /* RegularExpressionLiteral */) {
                        return 🔶<i><b title="Did not inline: unknown">parseLiteralNode</b></i>();
                    }
                    break;
                case 13 /* TemplateHead */:
                    return 🔶️<i><b title="CallWithDescriptor">parseTemplateExpression</b></i>();
            }
            return <b title="Inlined">🔷parseIdentifier</b>(ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>.Expression_expected);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>parseLiteralNode</summary>
<pre class="code">
(internName) {
            return 🔶<i><b title="Did not inline: target text too big">parseLiteralLikeNode</b></i>(<b title="Inlined">🔷token</b>(), internName);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>parseIdentifier</summary>
<pre class="code">
(diagnosticMessage) {
            return 🔶<i><b title="Did not inline: target text too big">createIdentifier</b></i>(🔶<i><b title="Did not inline: target text too big">isIdentifier</b></i>(), diagnosticMessage);
        }</pre>

</details>
</blockquote>



### parseArrayTypeOrHigher:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
() {
            var type = 🔶<i><b title="Did not inline: target text too big">parseNonArrayType</b></i>();
            while (!scanner.🔶<i><b title="Did not inline: unknown">hasPrecedingLineBreak</b></i>() && <b title="Inlined">🔷parseOptional</b>(20 /* OpenBracketToken */)) {
                if (🔶<i><b title="Did not inline: target text too big">isStartOfType</b></i>()) {
                    var node = <b title="Inlined">🔷createNode</b>(169 /* IndexedAccessType */, type.pos);
                    node.objectType = type;
                    node.indexType = <b title="Inlined">🔷parseType</b>();
                    🔶<i><b title="Did not inline: target text too big">parseExpected</b></i>(21 /* CloseBracketToken */);
                    type = 🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(node);
                }
                else {
                    var node = <b title="Inlined">🔷createNode</b>(162 /* ArrayType */, type⚠️<i><b title="LoadNamedGeneric">.pos</b></i>);
                    node.elementType = type;
                    🔶<i><b title="Did not inline: target text too big">parseExpected</b></i>(21 /* CloseBracketToken */);
                    type = 🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(node);
                }
            }
            return type;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>parseOptional</summary>
<pre class="code">
(t) {
            if (<b title="Inlined">🔷token</b>() === t) {
                <b title="Inlined">🔷nextToken</b>();
                return true;
            }
            return false;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>createNode</summary>
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>parseType</summary>
<pre class="code">
() {
            // The rules about 'yield' only apply to actual code/expression contexts.  They don't
            // apply to 'type' contexts.  So we disable these parameters here before moving on.
            return 🔶<i><b title="Did not inline: target text too big">doOutsideOfContext</b></i>(20480 /* TypeExcludesFlags */, parseTypeWorker);
        }</pre>

</details>
<details>
<summary>createNode</summary>
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### nextTokenCanFollowModifier:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
() {
            if (<b title="Inlined">🔷token</b>() === 75 /* ConstKeyword */) {
                // 'const' is only a modifier if followed by 'enum'.
                return <b title="Inlined">🔷nextToken</b>() === 82 /* EnumKeyword */;
            }
            if (<b title="Inlined">🔷token</b>() === 83 /* ExportKeyword */) {
                <b title="Inlined">🔷nextToken</b>();
                if (<b title="Inlined">🔷token</b>() === 78 /* DefaultKeyword */) {
                    return 🔶<i><b title="Did not inline: unknown">lookAhead</b></i>(nextTokenIsClassOrFunctionOrAsync);
                }
                return <b title="Inlined">🔷token</b>() !== 38 /* AsteriskToken */ && <b title="Inlined">🔷token</b>() !== 117 /* AsKeyword */ && <b title="Inlined">🔷token</b>() !== 16 /* OpenBraceToken */ && <b title="Inlined">🔷canFollowModifier</b>();
            }
            if (<b title="Inlined">🔷token</b>() === 78 /* DefaultKeyword */) {
                return 🔶️<i><b title="CallWithDescriptor">nextTokenIsClassOrFunctionOrAsync</b></i>();
            }
            if (<b title="Inlined">🔷token</b>() === 114 /* StaticKeyword */) {
                <b title="Inlined">🔷nextToken</b>();
                return <b title="Inlined">🔷canFollowModifier</b>();
            }
            return <b title="Inlined">🔷nextTokenIsOnSameLineAndCanFollowModifier</b>();
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>canFollowModifier</summary>
<pre class="code">
() {
            return <b title="Inlined">🔷token</b>() === 20 /* OpenBracketToken */
                || <b title="Inlined">🔷token</b>() === 16 /* OpenBraceToken */
                || <b title="Inlined">🔷token</b>() === 38 /* AsteriskToken */
                || <b title="Inlined">🔷token</b>() === 23 /* DotDotDotToken */
                || <b title="Inlined">🔷isLiteralPropertyName</b>();
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>isLiteralPropertyName</summary>
<pre class="code">
() {
            return ts.🔶<i><b title="Did not inline: unknown">tokenIsIdentifierOrKeyword</b></i>(<b title="Inlined">🔷token</b>()) ||
                <b title="Inlined">🔷token</b>() === 9 /* StringLiteral */ ||
                <b title="Inlined">🔷token</b>() === 8 /* NumericLiteral */;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
<details>
<summary>canFollowModifier</summary>
<pre class="code">
() {
            return <b title="Inlined">🔷token</b>() === 20 /* OpenBracketToken */
                || <b title="Inlined">🔷token</b>() === 16 /* OpenBraceToken */
                || <b title="Inlined">🔷token</b>() === 38 /* AsteriskToken */
                || <b title="Inlined">🔷token</b>() === 23 /* DotDotDotToken */
                || <b title="Inlined">🔷isLiteralPropertyName</b>();
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>isLiteralPropertyName</summary>
<pre class="code">
() {
            return ts.🔶<i><b title="Did not inline: unknown">tokenIsIdentifierOrKeyword</b></i>(<b title="Inlined">🔷token</b>()) ||
                <b title="Inlined">🔷token</b>() === 9 /* StringLiteral */ ||
                <b title="Inlined">🔷token</b>() === 8 /* NumericLiteral */;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>nextTokenIsOnSameLineAndCanFollowModifier</summary>
<pre class="code">
() {
            <b title="Inlined">🔷nextToken</b>();
            if (scanner.🔶<i><b title="Did not inline: unknown">hasPrecedingLineBreak</b></i>()) {
                return false;
            }
            return <b title="Inlined">🔷canFollowModifier</b>();
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
<details>
<summary>canFollowModifier</summary>
<pre class="code">
() {
            return <b title="Inlined">🔷token</b>() === 20 /* OpenBracketToken */
                || <b title="Inlined">🔷token</b>() === 16 /* OpenBraceToken */
                || <b title="Inlined">🔷token</b>() === 38 /* AsteriskToken */
                || <b title="Inlined">🔷token</b>() === 23 /* DotDotDotToken */
                || <b title="Inlined">🔷isLiteralPropertyName</b>();
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>isLiteralPropertyName</summary>
<pre class="code">
() {
            return ts.🔶<i><b title="Did not inline: unknown">tokenIsIdentifierOrKeyword</b></i>(<b title="Inlined">🔷token</b>()) ||
                <b title="Inlined">🔷token</b>() === 9 /* StringLiteral */ ||
                <b title="Inlined">🔷token</b>() === 8 /* NumericLiteral */;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>



### addJSDocComment:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(node) {
            var comments = ts.⚠️<i><b title="LoadNamedGeneric">getJSDocCommentRanges</b></i>(node, sourceFile.text);
            if (comments) {
                for (var _i = 0, comments_2 = comments; _i &lt; comments_2.length; _i++) {
                    var comment = comments_2[_i];
                    var jsDoc = JSDocParser.🔶<i><b title="Did not inline: target text too big">parseJSDocComment</b></i>(node, comment.pos, comment.end - comment.pos);
                    if (!jsDoc) {
                        continue;
                    }
                    if (!node⚠️<i><b title="LoadNamedGeneric">.jsDoc</b></i>) {
                        node.jsDoc ⚠️<i><b title="StoreNamedGeneric">= [];</b></i>
                    }
                    node.jsDoc.push(jsDoc);
                }
            }
            return node;
        }</pre>



### filter:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(array, f) {
        if (array) {
            var len = array.length;
            var i = 0;
            while (i &lt; len && 🔶️<i><b title="CallWithDescriptor">f</b></i>(array[i]))
                i++;
            if (i &lt; len) {
                var result = array.slice(0, i);
                i++;
                while (i &lt; len) {
                    var item = array[i];
                    if (🔶️<i><b title="CallWithDescriptor">f</b></i>(item)) {
                        result.push(item);
                    }
                    i++;
                }
                return result;
            }
        }
        return array;
    }</pre>



### parseRightSideOfDot:
<pre class="code">
(allowIdentifierNames) {
            // Technically a keyword is valid here as all identifiers and keywords are identifier names.
            // However, often we'll encounter this in error situations when the identifier or keyword
            // is actually starting another valid construct.
            //
            // So, we check for the following specific case:
            //
            //      name.
            //      identifierOrKeyword identifierNameOrKeyword
            //
            // Note: the newlines are important here.  For example, if that above code
            // were rewritten into:
            //
            //      name.identifierOrKeyword
            //      identifierNameOrKeyword
            //
            // Then we would consider it valid.  That's because ASI would take effect and
            // the code would be implicitly: "name.identifierOrKeyword; identifierNameOrKeyword".
            // In the first case though, ASI will not take effect because there is not a
            // line terminator after the identifier or keyword.
            if (scanner.🔶<i><b title="Did not inline: unknown">hasPrecedingLineBreak</b></i>() && ts.🔶<i><b title="Did not inline: unknown">tokenIsIdentifierOrKeyword</b></i>(🔶<i><b title="Did not inline: unknown">token</b></i>())) {
                var matchesPattern = 🔶<i><b title="Did not inline: unknown">lookAhead</b></i>(nextTokenIsIdentifierOrKeywordOnSameLine);
                if (matchesPattern) {
                    // Report that we need an identifier.  However, report it right after the dot,
                    // and not on the next token.  This is because the next token might actually
                    // be an identifier and the error would be quite confusing.
                    return 🔶️<i><b title="CallWithDescriptor">createMissingNode</b></i>(70 /* Identifier */, /*reportAtCurrentPosition*/ true, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Identifier_expected</b></i>);
                }
            }
            return allowIdentifierNames ? <b title="Inlined">🔷parseIdentifierName</b>() : <b title="Inlined">🔷parseIdentifier</b>();
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>parseIdentifierName</summary>
<pre class="code">
() {
            return 🔶<i><b title="Did not inline: target text too big">createIdentifier</b></i>(ts.🔶<i><b title="Did not inline: unknown">tokenIsIdentifierOrKeyword</b></i>(<b title="Inlined">🔷token</b>()));
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>parseIdentifier</summary>
<pre class="code">
(diagnosticMessage) {
            return 🔶<i><b title="Did not inline: target text too big">createIdentifier</b></i>(🔶<i><b title="Did not inline: target text too big">isIdentifier</b></i>(), diagnosticMessage);
        }</pre>

</details>
</blockquote>



### isUnambiguouslyStartOfFunctionType:
<pre class="code">
() {
            <b title="Inlined">🔷nextToken</b>();
            if (<b title="Inlined">🔷token</b>() === 19 /* CloseParenToken */ || <b title="Inlined">🔷token</b>() === 23 /* DotDotDotToken */) {
                // ( )
                // ( ...
                return true;
            }
            if (🔶<i><b title="Did not inline: target text too big">skipParameterStart</b></i>()) {
                // We successfully skipped modifiers (if any) and an identifier or binding pattern,
                // now see if we have something that indicates a parameter declaration
                if (<b title="Inlined">🔷token</b>() === 55 /* ColonToken */ || <b title="Inlined">🔷token</b>() === 25 /* CommaToken */ ||
                    <b title="Inlined">🔷token</b>() === 54 /* QuestionToken */ || <b title="Inlined">🔷token</b>() === 57 /* EqualsToken */) {
                    // ( xxx :
                    // ( xxx ,
                    // ( xxx ?
                    // ( xxx =
                    return true;
                }
                if (<b title="Inlined">🔷token</b>() === 19 /* CloseParenToken */) {
                    🔶<i><b title="Did not inline: unknown">nextToken</b></i>();
                    if (🔶<i><b title="Did not inline: unknown">token</b></i>() ⚠️<i><b title="CompareGeneric">=== 35</b></i> /* EqualsGreaterThanToken */) {
                        // ( xxx ) =&gt;
                        return true;
                    }
                }
            }
            return false;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>



### ⛔ parseObjectTypeMembers (deoptimizated):
<pre class="code">
() {
            var members;
            if (🔶<i><b title="Did not inline: target text too big">parseExpected</b></i>(16 /* OpenBraceToken */)) {
                members = 🔶<i><b title="Did not inline: target text too big">parseList</b></i>(4 /* TypeMembers */, parseTypeMember);
                🔶<i><b title="Did not inline: target text too big">parseExpected</b></i>(17 /* CloseBraceToken */);
            }
            else {
                members = 🔶️<i><b title="CallWithDescriptor">createMissingList</b></i>();
            }
            return members;
        }</pre>

```diff
- Deopt: <JS Function nextTokenCanFollowModifier (SharedFunctionInfo 0x3504a53f3af1)> (opt #118) @50, FP to SP delta: 128, caller sp: 0x7fff5fbfd4f0
```



### scanJSDocToken:
<pre class="code">
() {
            if (pos &gt;= end) {
                return token = 1 /* EndOfFileToken */;
            }
            startPos = pos;
            tokenPos = pos;
            var ch = text.charCodeAt(pos);
            switch (ch) {
                case 9 /* tab */:
                case 11 /* verticalTab */:
                case 12 /* formFeed */:
                case 32 /* space */:
                    while (pos &lt; end && 🔶<i><b title="Did not inline: target text too big">isWhiteSpaceSingleLine</b></i>(text.charCodeAt(pos))) {
                        pos++;
                    }
                    return token = 5 /* WhitespaceTrivia */;
                case 64 /* at */:
                    pos++;
                    return token = 56 /* AtToken */;
                case 10 /* lineFeed */:
                case 13 /* carriageReturn */:
                    pos++;
                    return token = 4 /* NewLineTrivia */;
                case 42 /* asterisk */:
                    pos++;
                    return token = 38 /* AsteriskToken */;
                case 123 /* openBrace */:
                    pos++;
                    return token = 16 /* OpenBraceToken */;
                case 125 /* closeBrace */:
                    pos++;
                    return token = 17 /* CloseBraceToken */;
                case 91 /* openBracket */:
                    pos++;
                    return token = 20 /* OpenBracketToken */;
                case 93 /* closeBracket */:
                    pos++;
                    return token = 21 /* CloseBracketToken */;
                case 61 /* equals */:
                    pos++;
                    return token = 57 /* EqualsToken */;
                case 44 /* comma */:
                    pos++;
                    return token = 25 /* CommaToken */;
                case 46 /* dot */:
                    pos++;
                    return token = 22 /* DotToken */;
            }
            if (<b title="Inlined">🔷isIdentifierStart</b>(ch, 5 /* Latest */)) {
                pos++;
                while (<b title="Inlined">🔷isIdentifierPart</b>(text.charCodeAt(pos), 5 /* Latest */) && pos &lt; end) {
                    pos++;
                }
                return token = 70 /* Identifier */;
            }
            else {
                return pos += 1, token = 0 /* Unknown */;
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>isIdentifierStart</summary>
<pre class="code">
(ch, languageVersion) {
        return ch &gt;= 65 /* A */ && ch &lt;= 90 /* Z */ || ch &gt;= 97 /* a */ && ch &lt;= 122 /* z */ ||
            ch === 36 /* $ */ || ch === 95 /* _ */ ||
            ch &gt; 127 /* maxAsciiCharacter */ && 🔶️<i><b title="CallWithDescriptor">isUnicodeIdentifierStart</b></i>(ch, languageVersion);
    }</pre>

</details>
<details>
<summary>isIdentifierPart</summary>
<pre class="code">
(ch, languageVersion) {
        return ch &gt;= 65 /* A */ && ch &lt;= 90 /* Z */ || ch &gt;= 97 /* a */ && ch &lt;= 122 /* z */ ||
            ch &gt;= 48 /* _0 */ && ch &lt;= 57 /* _9 */ || ch === 36 /* $ */ || ch === 95 /* _ */ ||
            ch &gt; 127 /* maxAsciiCharacter */ && 🔶️<i><b title="CallWithDescriptor">isUnicodeIdentifierPart</b></i>(ch, languageVersion);
    }</pre>

</details>
</blockquote>



### parseDelimitedList:
<pre class="code">
(kind, parseElement, considerSemicolonAsDelimiter) {
            var saveParsingContext = parsingContext;
            parsingContext |= 1 &lt;&lt; kind;
            var result = <b title="Inlined">🔷createNodeArray</b>();
            var commaStart = -1; // Meaning the previous token was not a comma
            while (true) {
                if (🔶<i><b title="Did not inline: target text too big">isListElement</b></i>(kind, /*inErrorRecovery*/ false)) {
                    result.push(<b title="Inlined">🔷parseListElement</b>(kind, parseElement));
                    commaStart = scanner.🔶<i><b title="Did not inline: unknown">getTokenPos</b></i>();
                    if (<b title="Inlined">🔷parseOptional</b>(25 /* CommaToken */)) {
                        continue;
                    }
                    commaStart = -1; // Back to the state where the last token was not a comma
                    if (🔶<i><b title="Did not inline: target text too big">isListTerminator</b></i>(kind)) {
                        break;
                    }
                    // We didn't get a comma, and the list wasn't terminated, explicitly parse
                    // out a comma so we give a good error message.
                    🔶<i><b title="Did not inline: target text too big">parseExpected</b></i>(25 /* CommaToken */);
                    // If the token was a semicolon, and the caller allows that, then skip it and
                    // continue.  This ensures we get back on track and don't result in tons of
                    // parse errors.  For example, this can happen when people do things like use
                    // a semicolon to delimit object literal members.   Note: we'll have already
                    // reported an error when we called parseExpected above.
                    if (considerSemicolonAsDelimiter && 🔶<i><b title="Did not inline: unknown">token</b></i>() ⚠️<i><b title="CompareGeneric">=== 24</b></i> /* SemicolonToken */ && !scanner.⚠️<i><b title="LoadNamedGeneric">hasPrecedingLineBreak</b></i>()) {
                        🔶<i><b title="Did not inline: unknown">nextToken</b></i>();
                    }
                    continue;
                }
                if (🔶<i><b title="Did not inline: target text too big">isListTerminator</b></i>(kind)) {
                    break;
                }
                if (🔶️<i><b title="CallWithDescriptor">abortParsingListOrMoveToNextToken</b></i>(kind)) {
                    break;
                }
            }
            // Recording the trailing comma is deliberately done after the previous
            // loop, and not just if we see a list terminator. This is because the list
            // may have ended incorrectly, but it is still important to know if there
            // was a trailing comma.
            // Check if the last token was a comma.
            if (commaStart &gt;= 0) {
                // Always preserve a trailing comma by marking it on the NodeArray
                result.hasTrailingComma ⚠️<i><b title="StoreNamedGeneric">= true</b></i>;
            }
            result.end = <b title="Inlined">🔷getNodeEnd</b>();
            parsingContext = saveParsingContext;
            return result;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createNodeArray</summary>
<pre class="code">
(elements, pos) {
            var array = (elements || []);
            if (!(pos &gt;= 0)) {
                pos = <b title="Inlined">🔷getNodePos</b>();
            }
            array.pos ⚠️<i><b title="StoreNamedGeneric">= pos</b></i>;
            array.end = pos;
            return array;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getNodePos</summary>
<pre class="code">
() {
            return scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>parseListElement</summary>
<pre class="code">
(parsingContext, parseElement) {
            var node = 🔶<i><b title="Did not inline: target text too big">currentNode</b></i>(parsingContext);
            if (node) {
                return 🔶️<i><b title="CallWithDescriptor">consumeNode</b></i>(node);
            }
            return 🔶️<i><b title="CallWithDescriptor">parseElement</b></i>();
        }</pre>

</details>
<details>
<summary>parseOptional</summary>
<pre class="code">
(t) {
            if (<b title="Inlined">🔷token</b>() === t) {
                <b title="Inlined">🔷nextToken</b>();
                return true;
            }
            return false;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>getNodeEnd</summary>
<pre class="code">
() {
            return scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
        }</pre>

</details>
</blockquote>



### getTextPos:
<pre class="code">
() { return pos; }</pre>



### parseVariableDeclaration:
<pre class="code">
() {
            var node = <b title="Inlined">🔷createNode</b>(223 /* VariableDeclaration */);
            node.name = <b title="Inlined">🔷parseIdentifierOrPattern</b>();
            node.type = <b title="Inlined">🔷parseTypeAnnotation</b>();
            if (!<b title="Inlined">🔷isInOrOfKeyword</b>(<b title="Inlined">🔷token</b>())) {
                node.initializer = 🔶<i><b title="Did not inline: target text too big">parseInitializer</b></i>(/*inParameter*/ false);
            }
            return 🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(node);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createNode</summary>
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>parseIdentifierOrPattern</summary>
<pre class="code">
() {
            if (<b title="Inlined">🔷token</b>() === 20 /* OpenBracketToken */) {
                return 🔶️<i><b title="CallWithDescriptor">parseArrayBindingPattern</b></i>();
            }
            if (<b title="Inlined">🔷token</b>() === 16 /* OpenBraceToken */) {
                return 🔶️<i><b title="CallWithDescriptor">parseObjectBindingPattern</b></i>();
            }
            return <b title="Inlined">🔷parseIdentifier</b>();
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>parseIdentifier</summary>
<pre class="code">
(diagnosticMessage) {
            return 🔶<i><b title="Did not inline: target text too big">createIdentifier</b></i>(🔶<i><b title="Did not inline: target text too big">isIdentifier</b></i>(), diagnosticMessage);
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>parseTypeAnnotation</summary>
<pre class="code">
() {
            return <b title="Inlined">🔷parseOptional</b>(55 /* ColonToken */) ? <b title="Inlined">🔷parseType</b>() : undefined;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>parseOptional</summary>
<pre class="code">
(t) {
            if (<b title="Inlined">🔷token</b>() === t) {
                <b title="Inlined">🔷nextToken</b>();
                return true;
            }
            return false;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>parseType</summary>
<pre class="code">
() {
            // The rules about 'yield' only apply to actual code/expression contexts.  They don't
            // apply to 'type' contexts.  So we disable these parameters here before moving on.
            return 🔶<i><b title="Did not inline: target text too big">doOutsideOfContext</b></i>(20480 /* TypeExcludesFlags */, parseTypeWorker);
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>isInOrOfKeyword</summary>
<pre class="code">
(t) {
            return t === 91 /* InKeyword */ || t === 140 /* OfKeyword */;
        }</pre>

</details>
</blockquote>



### isVariableDeclaratorListTerminator:
<pre class="code">
() {
            // If we can consume a semicolon (either explicitly, or with ASI), then consider us done
            // with parsing the list of  variable declarators.
            if (<b title="Inlined">🔷canParseSemicolon</b>()) {
                return true;
            }
            // in the case where we're parsing the variable declarator of a 'for-in' statement, we
            // are done if we see an 'in' keyword in front of us. Same with for-of
            if (🔶️<i><b title="CallWithDescriptor">isInOrOfKeyword</b></i>(🔶<i><b title="Did not inline: unknown">token</b></i>())) {
                return true;
            }
            // ERROR RECOVERY TWEAK:
            // For better error recovery, if we see an '=&gt;' then we just stop immediately.  We've got an
            // arrow function here and it's going to be very unlikely that we'll resynchronize and get
            // another variable declaration.
            if (🔶<i><b title="Did not inline: unknown">token</b></i>() ⚠️<i><b title="CompareGeneric">=== 35</b></i> /* EqualsGreaterThanToken */) {
                return true;
            }
            // Keep trying to parse out variable declarators.
            return false;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>canParseSemicolon</summary>
<pre class="code">
() {
            // If there's a real semicolon, then we can always parse it out.
            if (<b title="Inlined">🔷token</b>() === 24 /* SemicolonToken */) {
                return true;
            }
            // We can parse out an optional semicolon in ASI cases in the following cases.
            return <b title="Inlined">🔷token</b>() === 17 /* CloseBraceToken */ || <b title="Inlined">🔷token</b>() === 1 /* EndOfFileToken */ || scanner.🔶<i><b title="Did not inline: unknown">hasPrecedingLineBreak</b></i>();
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### setText:
<pre class="code">
(newText, start, length) {
            text = newText || "";
            end = length === undefined ? text.length : start + length;
            🔶<i><b title="Did not inline: unknown">setTextPos</b></i>(start || 0);
        }</pre>



### parsePropertyNameWorker:
<pre class="code">
(allowComputedPropertyNames) {
            if (<b title="Inlined">🔷token</b>() === 9 /* StringLiteral */ || <b title="Inlined">🔷token</b>() === 8 /* NumericLiteral */) {
                return 🔶<i><b title="Did not inline: unknown">parseLiteralNode</b></i>(/*internName*/ true);
            }
            if (allowComputedPropertyNames && <b title="Inlined">🔷token</b>() === 20 /* OpenBracketToken */) {
                return 🔶️<i><b title="CallWithDescriptor">parseComputedPropertyName</b></i>();
            }
            return <b title="Inlined">🔷parseIdentifierName</b>();
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>parseIdentifierName</summary>
<pre class="code">
() {
            return 🔶<i><b title="Did not inline: target text too big">createIdentifier</b></i>(ts.🔶<i><b title="Did not inline: unknown">tokenIsIdentifierOrKeyword</b></i>(<b title="Inlined">🔷token</b>()));
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### parseJSDocComment:
<pre class="code">
(parent, start, length) {
                var saveToken = currentToken;
                var saveParseDiagnosticsLength = parseDiagnostics.length;
                var saveParseErrorBeforeNextFinishedNode = parseErrorBeforeNextFinishedNode;
                var comment = parseJSDocCommentWorker(start, length);
                if (comment) {
                    comment.parent = parent;
                }
                currentToken = saveToken;
                parseDiagnostics.length ⚠️<i><b title="StoreNamedGeneric">= saveParseDiagnosticsLength</b></i>;
                parseErrorBeforeNextFinishedNode = saveParseErrorBeforeNextFinishedNode;
                return comment;
            }</pre>



### parseLiteralLikeNode:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(kind, internName) {
            var node = <b title="Inlined">🔷createNode</b>(kind);
            var text = scanner.🔶<i><b title="Did not inline: unknown">getTokenValue</b></i>();
            node.text ⚠️<i><b title="StoreNamedGeneric">= internName</b></i> ? <b title="Inlined">🔷internIdentifier</b>(text) : text;
            if (scanner.🔶<i><b title="Did not inline: unknown">hasExtendedUnicodeEscape</b></i>()) {
                node.hasExtendedUnicodeEscape ⚠️<i><b title="StoreNamedGeneric">= true</b></i>;
            }
            if (scanner.🔶<i><b title="Did not inline: unknown">isUnterminated</b></i>()) {
                node.isUnterminated ⚠️<i><b title="StoreNamedGeneric">= true</b></i>;
            }
            var tokenPos = scanner.🔶<i><b title="Did not inline: unknown">getTokenPos</b></i>();
            <b title="Inlined">🔷nextToken</b>();
            🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(node);
            // Octal literals are not allowed in strict mode or ES5
            // Note that theoretically the following condition would hold true literals like 009,
            // which is not octal.But because of how the scanner separates the tokens, we would
            // never get a token like this. Instead, we would get 00 and 9 as two separate tokens.
            // We also do not need to check for negatives because any prefix operator would be part of a
            // parent unary expression.
            if (node.kind === 8 /* NumericLiteral */
                && sourceText.charCodeAt(tokenPos) === 48 /* _0 */
                && ts.🔶️<i><b title="CallWithDescriptor">isOctalDigit</b></i>(sourceText.🔶️<i><b title="CallWithDescriptor">charCodeAt</b></i>(tokenPos + 1))) {
                node.isOctalLiteral ⚠️<i><b title="StoreNamedGeneric">= true</b></i>;
            }
            return node;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createNode</summary>
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>internIdentifier</summary>
<pre class="code">
(text) {
            text = ts.🔶<i><b title="Did not inline: unknown">escapeIdentifier</b></i>(text);
            return identifiers⚠️<i><b title="LoadKeyedGeneric">[text]</b></i> || (identifiers[text] ⚠️<i><b title="StoreKeyedGeneric">= text</b></i>);
        }</pre>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>



### isLeftHandSideExpressionKind:
<pre class="code">
(kind) {
        return kind === 177 /* PropertyAccessExpression */
            || kind === 178 /* ElementAccessExpression */
            || kind === 180 /* NewExpression */
            || kind === 179 /* CallExpression */
            || kind === 246 /* JsxElement */
            || kind === 247 /* JsxSelfClosingElement */
            || kind === 181 /* TaggedTemplateExpression */
            || kind === 175 /* ArrayLiteralExpression */
            || kind === 183 /* ParenthesizedExpression */
            || kind === 176 /* ObjectLiteralExpression */
            || kind === 197 /* ClassExpression */
            || kind === 184 /* FunctionExpression */
            || kind === 70 /* Identifier */
            || kind === 11 /* RegularExpressionLiteral */
            || kind === 8 /* NumericLiteral */
            || kind === 9 /* StringLiteral */
            || kind ⚠️<i><b title="CompareGeneric">=== 12</b></i> /* NoSubstitutionTemplateLiteral */
            || kind ⚠️<i><b title="CompareGeneric">=== 194</b></i> /* TemplateExpression */
            || kind ⚠️<i><b title="CompareGeneric">=== 85</b></i> /* FalseKeyword */
            || kind ⚠️<i><b title="CompareGeneric">=== 94</b></i> /* NullKeyword */
            || kind ⚠️<i><b title="CompareGeneric">=== 98</b></i> /* ThisKeyword */
            || kind ⚠️<i><b title="CompareGeneric">=== 100</b></i> /* TrueKeyword */
            || kind ⚠️<i><b title="CompareGeneric">=== 96</b></i> /* SuperKeyword */
            || kind ⚠️<i><b title="CompareGeneric">=== 201</b></i> /* NonNullExpression */;
    }</pre>



### parseIncrementExpression:
<pre class="code">
() {
            if (<b title="Inlined">🔷token</b>() === 42 /* PlusPlusToken */ || <b title="Inlined">🔷token</b>() === 43 /* MinusMinusToken */) {
                var node = 🔶<i><b title="Did not inline: unknown">createNode</b></i>(190 /* PrefixUnaryExpression */);
                node.operator ⚠️<i><b title="StoreNamedGeneric">= token</b></i>();
                🔶<i><b title="Did not inline: unknown">nextToken</b></i>();
                node.operand ⚠️<i><b title="StoreNamedGeneric">= parseLeftHandSideExpressionOrHigher</b></i>();
                return 🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(node);
            }
            else if (sourceFile.languageVariant === 1 /* JSX */ && 🔶<i><b title="Did not inline: unknown">token</b></i>() ⚠️<i><b title="CompareGeneric">=== 26</b></i> /* LessThanToken */ && 🔶<i><b title="Did not inline: unknown">lookAhead</b></i>(nextTokenIsIdentifierOrKeyword)) {
                // JSXElement is part of primaryExpression
                return 🔶️<i><b title="CallWithDescriptor">parseJsxElementOrSelfClosingElement</b></i>(/*inExpressionContext*/ true);
            }
            var expression = 🔶<i><b title="Did not inline: target text too big">parseLeftHandSideExpressionOrHigher</b></i>();
            ts⚠️<i><b title="LoadNamedGeneric">.Debug</b></i>.🔶️<i><b title="CallWithDescriptor">assert</b></i>(ts.⚠️<i><b title="LoadNamedGeneric">isLeftHandSideExpression</b></i>(expression));
            if ((<b title="Inlined">🔷token</b>() === 42 /* PlusPlusToken */ || <b title="Inlined">🔷token</b>() === 43 /* MinusMinusToken */) && !scanner.⚠️<i><b title="LoadNamedGeneric">hasPrecedingLineBreak</b></i>()) {
                var node = 🔶<i><b title="Did not inline: unknown">createNode</b></i>(191 /* PostfixUnaryExpression */, expression⚠️<i><b title="LoadNamedGeneric">.pos</b></i>);
                node.operand ⚠️<i><b title="StoreNamedGeneric">= expression</b></i>;
                node.operator ⚠️<i><b title="StoreNamedGeneric">= token</b></i>();
                🔶<i><b title="Did not inline: unknown">nextToken</b></i>();
                return 🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(node);
            }
            return expression;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>



### parseSimpleUnaryExpression:
<pre class="code">
() {
            switch (<b title="Inlined">🔷token</b>()) {
                case 36 /* PlusToken */:
                case 37 /* MinusToken */:
                case 51 /* TildeToken */:
                case 50 /* ExclamationToken */:
                    return 🔶️<i><b title="CallWithDescriptor">parsePrefixUnaryExpression</b></i>();
                case 79 /* DeleteKeyword */:
                    return 🔶️<i><b title="CallWithDescriptor">parseDeleteExpression</b></i>();
                case 102 /* TypeOfKeyword */:
                    return 🔶️<i><b title="CallWithDescriptor">parseTypeOfExpression</b></i>();
                case 104 /* VoidKeyword */:
                    return 🔶️<i><b title="CallWithDescriptor">parseVoidExpression</b></i>();
                case 26 /* LessThanToken */:
                    // This is modified UnaryExpression grammar in TypeScript
                    //  UnaryExpression (modified):
                    //      &lt; type &gt; UnaryExpression
                    return 🔶️<i><b title="CallWithDescriptor">parseTypeAssertion</b></i>();
                case 120 /* AwaitKeyword */:
                    if (🔶️<i><b title="CallWithDescriptor">isAwaitExpression</b></i>()) {
                        return 🔶️<i><b title="CallWithDescriptor">parseAwaitExpression</b></i>();
                    }
                default:
                    return 🔶<i><b title="Did not inline: target text too big">parseIncrementExpression</b></i>();
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>



### isKeyword:
<pre class="code">
(token) {
        return 71 /* FirstKeyword */ &lt;= token && token &lt;= 140 /* LastKeyword */;
    }</pre>



### tryParseAccessorDeclaration:
<pre class="code">
(fullStart, decorators, modifiers) {
            if (<b title="Inlined">🔷parseContextualModifier</b>(124 /* GetKeyword */)) {
                return 🔶️<i><b title="CallWithDescriptor">parseAccessorDeclaration</b></i>(151 /* GetAccessor */, fullStart, decorators, modifiers);
            }
            else if (<b title="Inlined">🔷parseContextualModifier</b>(133 /* SetKeyword */)) {
                return 🔶️<i><b title="CallWithDescriptor">parseAccessorDeclaration</b></i>(152 /* SetAccessor */, fullStart, decorators, modifiers);
            }
            return undefined;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>parseContextualModifier</summary>
<pre class="code">
(t) {
            return <b title="Inlined">🔷token</b>() === t && 🔶<i><b title="Did not inline: unknown">tryParse</b></i>(nextTokenCanFollowModifier);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>parseContextualModifier</summary>
<pre class="code">
(t) {
            return <b title="Inlined">🔷token</b>() === t && 🔶<i><b title="Did not inline: unknown">tryParse</b></i>(nextTokenCanFollowModifier);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### parsePropertyOrMethodDeclaration:
<pre class="code">
(fullStart, decorators, modifiers) {
            var asteriskToken = <b title="Inlined">🔷parseOptionalToken</b>(38 /* AsteriskToken */);
            var name = <b title="Inlined">🔷parsePropertyName</b>();
            // Note: this is not legal as per the grammar.  But we allow it in the parser and
            // report an error in the grammar checker.
            var questionToken = <b title="Inlined">🔷parseOptionalToken</b>(54 /* QuestionToken */);
            if (asteriskToken || <b title="Inlined">🔷token</b>() === 18 /* OpenParenToken */ || <b title="Inlined">🔷token</b>() === 26 /* LessThanToken */) {
                return 🔶<i><b title="Did not inline: target text too big">parseMethodDeclaration</b></i>(fullStart, decorators, modifiers, asteriskToken, name, questionToken, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>.or_expected);
            }
            else {
                return 🔶️<i><b title="CallWithDescriptor">parsePropertyDeclaration</b></i>(fullStart, decorators, modifiers, name, questionToken);
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>parseOptionalToken</summary>
<pre class="code">
(t) {
            if (<b title="Inlined">🔷token</b>() === t) {
                return <b title="Inlined">🔷parseTokenNode</b>();
            }
            return undefined;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>parseTokenNode</summary>
<pre class="code">
() {
            var node = <b title="Inlined">🔷createNode</b>(<b title="Inlined">🔷token</b>());
            <b title="Inlined">🔷nextToken</b>();
            return 🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(node);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>createNode</summary>
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>parsePropertyName</summary>
<pre class="code">
() {
            return <b title="Inlined">🔷parsePropertyNameWorker</b>(/*allowComputedPropertyNames*/ true);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>parsePropertyNameWorker</summary>
<pre class="code">
(allowComputedPropertyNames) {
            if (<b title="Inlined">🔷token</b>() === 9 /* StringLiteral */ || <b title="Inlined">🔷token</b>() === 8 /* NumericLiteral */) {
                return 🔶<i><b title="Did not inline: unknown">parseLiteralNode</b></i>(/*internName*/ true);
            }
            if (allowComputedPropertyNames && <b title="Inlined">🔷token</b>() === 20 /* OpenBracketToken */) {
                return 🔶️<i><b title="CallWithDescriptor">parseComputedPropertyName</b></i>();
            }
            return <b title="Inlined">🔷parseIdentifierName</b>();
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>parseIdentifierName</summary>
<pre class="code">
() {
            return 🔶<i><b title="Did not inline: target text too big">createIdentifier</b></i>(ts.🔶<i><b title="Did not inline: unknown">tokenIsIdentifierOrKeyword</b></i>(<b title="Inlined">🔷token</b>()));
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>parseOptionalToken</summary>
<pre class="code">
(t) {
            if (<b title="Inlined">🔷token</b>() === t) {
                return <b title="Inlined">🔷parseTokenNode</b>();
            }
            return undefined;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>parseTokenNode</summary>
<pre class="code">
() {
            var node = <b title="Inlined">🔷createNode</b>(<b title="Inlined">🔷token</b>());
            <b title="Inlined">🔷nextToken</b>();
            return 🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(node);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>createNode</summary>
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>



### parseMethodDeclaration:
<pre class="code">
(fullStart, decorators, modifiers, asteriskToken, name, questionToken, diagnosticMessage) {
            var method = <b title="Inlined">🔷createNode</b>(149 /* MethodDeclaration */, fullStart);
            method.decorators = decorators;
            method.modifiers = modifiers;
            method.asteriskToken = asteriskToken;
            method.name = name;
            method.questionToken = questionToken;
            var isGenerator = !!asteriskToken;
            var isAsync = ts.🔶<i><b title="Did not inline: unknown">hasModifier</b></i>(method, 256 /* Async */);
            🔶<i><b title="Did not inline: target text too big">fillSignature</b></i>(55 /* ColonToken */, /*yieldContext*/ isGenerator, /*awaitContext*/ isAsync, /*requireCompleteParameterList*/ false, method);
            method.body = <b title="Inlined">🔷parseFunctionBlockOrSemicolon</b>(isGenerator, isAsync, diagnosticMessage);
            return 🔶<i><b title="Did not inline: target text too big">addJSDocComment</b></i>(🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(method));
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createNode</summary>
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>parseFunctionBlockOrSemicolon</summary>
<pre class="code">
(isGenerator, isAsync, diagnosticMessage) {
            if (<b title="Inlined">🔷token</b>() !== 16 /* OpenBraceToken */ && <b title="Inlined">🔷canParseSemicolon</b>()) {
                <b title="Inlined">🔷parseSemicolon</b>();
                return;
            }
            return 🔶️<i><b title="CallWithDescriptor">parseFunctionBlock</b></i>(isGenerator, isAsync, /*ignoreMissingOpenBrace*/ false, diagnosticMessage);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>canParseSemicolon</summary>
<pre class="code">
() {
            // If there's a real semicolon, then we can always parse it out.
            if (<b title="Inlined">🔷token</b>() === 24 /* SemicolonToken */) {
                return true;
            }
            // We can parse out an optional semicolon in ASI cases in the following cases.
            return <b title="Inlined">🔷token</b>() === 17 /* CloseBraceToken */ || <b title="Inlined">🔷token</b>() === 1 /* EndOfFileToken */ || scanner.🔶<i><b title="Did not inline: unknown">hasPrecedingLineBreak</b></i>();
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>parseSemicolon</summary>
<pre class="code">
() {
            if (<b title="Inlined">🔷canParseSemicolon</b>()) {
                if (<b title="Inlined">🔷token</b>() === 24 /* SemicolonToken */) {
                    // consume the semicolon if it was explicitly provided.
                    <b title="Inlined">🔷nextToken</b>();
                }
                return true;
            }
            else {
                return 🔶<i><b title="Did not inline: target text too big">parseExpected</b></i>(24 /* SemicolonToken */);
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>canParseSemicolon</summary>
<pre class="code">
() {
            // If there's a real semicolon, then we can always parse it out.
            if (<b title="Inlined">🔷token</b>() === 24 /* SemicolonToken */) {
                return true;
            }
            // We can parse out an optional semicolon in ASI cases in the following cases.
            return <b title="Inlined">🔷token</b>() === 17 /* CloseBraceToken */ || <b title="Inlined">🔷token</b>() === 1 /* EndOfFileToken */ || scanner.🔶<i><b title="Did not inline: unknown">hasPrecedingLineBreak</b></i>();
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>



### modifierToFlag:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(token) {
        switch (token) {
            case 114 /* StaticKeyword */: return 32 /* Static */;
            case 113 /* PublicKeyword */: return 4 /* Public */;
            case 112 /* ProtectedKeyword */: return 16 /* Protected */;
            case 111 /* PrivateKeyword */: return 8 /* Private */;
            case 116 /* AbstractKeyword */: return 128 /* Abstract */;
            case 83 /* ExportKeyword */: return 1 /* Export */;
            case 123 /* DeclareKeyword */: return 2 /* Ambient */;
            case 75 /* ConstKeyword */: return 2048 /* Const */;
            case 78 /* DefaultKeyword */: return 512 /* Default */;
            case 119 /* AsyncKeyword */: return 256 /* Async */;
            case 130 /* ReadonlyKeyword */: return 64 /* Readonly */;
        }
        return 0 /* None */;
    }</pre>



### parseFunctionDeclaration:
<pre class="code">
(fullStart, decorators, modifiers) {
            var node = <b title="Inlined">🔷createNode</b>(225 /* FunctionDeclaration */, fullStart);
            node.decorators = decorators;
            node.modifiers = modifiers;
            🔶<i><b title="Did not inline: target text too big">parseExpected</b></i>(88 /* FunctionKeyword */);
            node.asteriskToken = <b title="Inlined">🔷parseOptionalToken</b>(38 /* AsteriskToken */);
            node.name = ts.⚠️<i><b title="LoadNamedGeneric">hasModifier</b></i>(node, 512 /* Default */) ? 🔶️<i><b title="CallWithDescriptor">parseOptionalIdentifier</b></i>() : <b title="Inlined">🔷parseIdentifier</b>();
            var isGenerator = !!node.asteriskToken;
            var isAsync = ts.🔶<i><b title="Did not inline: unknown">hasModifier</b></i>(node, 256 /* Async */);
            🔶<i><b title="Did not inline: target text too big">fillSignature</b></i>(55 /* ColonToken */, /*yieldContext*/ isGenerator, /*awaitContext*/ isAsync, /*requireCompleteParameterList*/ false, node);
            node.body = <b title="Inlined">🔷parseFunctionBlockOrSemicolon</b>(isGenerator, isAsync, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>.or_expected);
            return 🔶<i><b title="Did not inline: target text too big">addJSDocComment</b></i>(🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(node));
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createNode</summary>
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>parseOptionalToken</summary>
<pre class="code">
(t) {
            if (<b title="Inlined">🔷token</b>() === t) {
                return <b title="Inlined">🔷parseTokenNode</b>();
            }
            return undefined;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>parseTokenNode</summary>
<pre class="code">
() {
            var node = <b title="Inlined">🔷createNode</b>(<b title="Inlined">🔷token</b>());
            <b title="Inlined">🔷nextToken</b>();
            return 🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(node);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>createNode</summary>
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>parseIdentifier</summary>
<pre class="code">
(diagnosticMessage) {
            return 🔶<i><b title="Did not inline: target text too big">createIdentifier</b></i>(🔶<i><b title="Did not inline: target text too big">isIdentifier</b></i>(), diagnosticMessage);
        }</pre>

</details>
<details>
<summary>parseFunctionBlockOrSemicolon</summary>
<pre class="code">
(isGenerator, isAsync, diagnosticMessage) {
            if (<b title="Inlined">🔷token</b>() !== 16 /* OpenBraceToken */ && <b title="Inlined">🔷canParseSemicolon</b>()) {
                <b title="Inlined">🔷parseSemicolon</b>();
                return;
            }
            return 🔶️<i><b title="CallWithDescriptor">parseFunctionBlock</b></i>(isGenerator, isAsync, /*ignoreMissingOpenBrace*/ false, diagnosticMessage);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>canParseSemicolon</summary>
<pre class="code">
() {
            // If there's a real semicolon, then we can always parse it out.
            if (<b title="Inlined">🔷token</b>() === 24 /* SemicolonToken */) {
                return true;
            }
            // We can parse out an optional semicolon in ASI cases in the following cases.
            return <b title="Inlined">🔷token</b>() === 17 /* CloseBraceToken */ || <b title="Inlined">🔷token</b>() === 1 /* EndOfFileToken */ || scanner.🔶<i><b title="Did not inline: unknown">hasPrecedingLineBreak</b></i>();
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>parseSemicolon</summary>
<pre class="code">
() {
            if (<b title="Inlined">🔷canParseSemicolon</b>()) {
                if (<b title="Inlined">🔷token</b>() === 24 /* SemicolonToken */) {
                    // consume the semicolon if it was explicitly provided.
                    <b title="Inlined">🔷nextToken</b>();
                }
                return true;
            }
            else {
                return 🔶<i><b title="Did not inline: target text too big">parseExpected</b></i>(24 /* SemicolonToken */);
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>canParseSemicolon</summary>
<pre class="code">
() {
            // If there's a real semicolon, then we can always parse it out.
            if (<b title="Inlined">🔷token</b>() === 24 /* SemicolonToken */) {
                return true;
            }
            // We can parse out an optional semicolon in ASI cases in the following cases.
            return <b title="Inlined">🔷token</b>() === 17 /* CloseBraceToken */ || <b title="Inlined">🔷token</b>() === 1 /* EndOfFileToken */ || scanner.🔶<i><b title="Did not inline: unknown">hasPrecedingLineBreak</b></i>();
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>



### currentNode:
<pre class="code">
(parsingContext) {
            // If there is an outstanding parse error that we've encountered, but not attached to
            // some node, then we cannot get a node from the old source tree.  This is because we
            // want to mark the next node we encounter as being unusable.
            //
            // Note: This may be too conservative.  Perhaps we could reuse the node and set the bit
            // on it (or its leftmost child) as having the error.  For now though, being conservative
            // is nice and likely won't ever affect perf.
            if (parseErrorBeforeNextFinishedNode) {
                return undefined;
            }
            if (!syntaxCursor) {
                // if we don't have a cursor, we could never return a node from the old tree.
                return undefined;
            }
            var node = syntaxCursor.🔶<i><b title="Did not inline: target text too big">currentNode</b></i>(scanner.⚠️<i><b title="LoadNamedGeneric">getStartPos</b></i>());
            // Can't reuse a missing node.
            if (ts.🔶<i><b title="Did not inline: unknown">nodeIsMissing</b></i>(node)) {
                return undefined;
            }
            // Can't reuse a node that intersected the change range.
            if (node⚠️<i><b title="LoadNamedGeneric">.intersectsChange</b></i>) {
                return undefined;
            }
            // Can't reuse a node that contains a parse error.  This is necessary so that we
            // produce the same set of errors again.
            if (ts.🔶️<i><b title="CallWithDescriptor">containsParseError</b></i>(node)) {
                return undefined;
            }
            // We can only reuse a node if it was parsed under the same strict mode that we're
            // currently in.  i.e. if we originally parsed a node in non-strict mode, but then
            // the user added 'using strict' at the top of the file, then we can't use that node
            // again as the presence of strict mode may cause us to parse the tokens in the file
            // differently.
            //
            // Note: we *can* reuse tokens when the strict mode changes.  That's because tokens
            // are unaffected by strict mode.  It's just the parser will decide what to do with it
            // differently depending on what mode it is in.
            //
            // This also applies to all our other context flags as well.
            var nodeContextFlags = node⚠️<i><b title="LoadNamedGeneric">.flags</b></i> ⚠️<i><b title="Bitwise">& 96256</b></i> /* ContextFlags */;
            if (nodeContextFlags ⚠️<i><b title="CompareGeneric">!== contextFlags</b></i>) {
                return undefined;
            }
            // Ok, we have a node that looks like it could be reused.  Now verify that it is valid
            // in the current list parsing context that we're currently at.
            if (!🔶️<i><b title="CallWithDescriptor">canReuseNode</b></i>(node, parsingContext)) {
                return undefined;
            }
            return node;
        }</pre>



### parseVariableDeclarationList:
<pre class="code">
(inForStatementInitializer) {
            var node = <b title="Inlined">🔷createNode</b>(224 /* VariableDeclarationList */);
            switch (<b title="Inlined">🔷token</b>()) {
                case 103 /* VarKeyword */:
                    break;
                case 109 /* LetKeyword */:
                    node.flags ⚠️<i><b title="LoadNamedGeneric">|= 1</b></i> /* Let */;
                    break;
                case 75 /* ConstKeyword */:
                    node.flags |= 2 /* Const */;
                    break;
                default:
                    ts⚠️<i><b title="LoadNamedGeneric">.Debug</b></i>.🔶️<i><b title="CallWithDescriptor">fail</b></i>();
            }
            <b title="Inlined">🔷nextToken</b>();
            // The user may have written the following:
            //
            //    for (let of X) { }
            //
            // In this case, we want to parse an empty declaration list, and then parse 'of'
            // as a keyword. The reason this is not automatic is that 'of' is a valid identifier.
            // So we need to look ahead to determine if 'of' should be treated as a keyword in
            // this context.
            // The checker will then give an error that there is an empty declaration list.
            if (<b title="Inlined">🔷token</b>() === 140 /* OfKeyword */ && 🔶<i><b title="Did not inline: unknown">lookAhead</b></i>(canFollowContextualOfKeyword)) {
                node.declarations ⚠️<i><b title="StoreNamedGeneric">= createMissingList</b></i>();
            }
            else {
                var savedDisallowIn = <b title="Inlined">🔷inDisallowInContext</b>();
                <b title="Inlined">🔷setDisallowInContext</b>(inForStatementInitializer);
                node.declarations = 🔶<i><b title="Did not inline: target text too big">parseDelimitedList</b></i>(8 /* VariableDeclarations */, parseVariableDeclaration);
                <b title="Inlined">🔷setDisallowInContext</b>(savedDisallowIn);
            }
            return 🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(node);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createNode</summary>
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>inDisallowInContext</summary>
<pre class="code">
() {
            return <b title="Inlined">🔷inContext</b>(2048 /* DisallowInContext */);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>inContext</summary>
<pre class="code">
(flags) {
            return (contextFlags & flags) !== 0;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>setDisallowInContext</summary>
<pre class="code">
(val) {
            <b title="Inlined">🔷setContextFlag</b>(val, 2048 /* DisallowInContext */);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>setContextFlag</summary>
<pre class="code">
(val, flag) {
            if (val) {
                contextFlags |⚠️<i><b title="Bitwise">= flag</b></i>;
            }
            else {
                contextFlags &= ~flag;
            }
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>setDisallowInContext</summary>
<pre class="code">
(val) {
            <b title="Inlined">🔷setContextFlag</b>(val, 2048 /* DisallowInContext */);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>setContextFlag</summary>
<pre class="code">
(val, flag) {
            if (val) {
                contextFlags |⚠️<i><b title="Bitwise">= flag</b></i>;
            }
            else {
                contextFlags &= ~flag;
            }
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### tryParseTypeExpression:
<pre class="code">
() {
                    return <b title="Inlined">🔷tryParse</b>(🔶️<i><b title="CallWithDescriptor">function</b></i> () {
                        skipWhitespace();
                        if (token() !== 16 /* OpenBraceToken */) {
                            return undefined;
                        }
                        return parseJSDocTypeExpression();
                    });
                }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>tryParse</summary>
<pre class="code">
(callback) {
            return 🔶<i><b title="Did not inline: target text too big">speculationHelper</b></i>(callback, /*isLookAhead*/ false);
        }</pre>

</details>
</blockquote>



### parseTagComments:
<pre class="code">
(indent) {
                    var comments = [];
                    var state = 0 /* BeginningOfLine */;
                    var margin;
                    🔶️<i><b title="CallWithDescriptor">function</b></i> pushComment(text) {
                        if (!margin) {
                            margin = indent;
                        }
                        comments.push(text);
                        indent += text.length;
                    }
                    while (<b title="Inlined">🔷token</b>() !== 56 /* AtToken */ && <b title="Inlined">🔷token</b>() !== 1 /* EndOfFileToken */) {
                        switch (<b title="Inlined">🔷token</b>()) {
                            case 4 /* NewLineTrivia */:
                                if (state &gt;= 1 /* SawAsterisk */) {
                                    state = 0 /* BeginningOfLine */;
                                    comments.push(scanner.🔶<i><b title="Did not inline: unknown">getTokenText</b></i>());
                                }
                                indent = 0;
                                break;
                            case 56 /* AtToken */:
                                // Done
                                break;
                            case 5 /* WhitespaceTrivia */:
                                if (state === 2 /* SavingComments */) {
                                    🔶<i><b title="Did not inline: unknown">pushComment</b></i>(scanner.🔶<i><b title="Did not inline: unknown">getTokenText</b></i>());
                                }
                                else {
                                    var whitespace = scanner.getTokenText();
                                    // if the whitespace crosses the margin, take only the whitespace that passes the margin
                                    if (margin !== undefined && indent + whitespace.length &gt; margin) {
                                        comments.⚠️<i><b title="LoadNamedGeneric">push</b></i>(whitespace.⚠️<i><b title="LoadNamedGeneric">slice</b></i>(margin ⚠️<i><b title="Sub">- indent</b></i> - 1));
                                    }
                                    indent += whitespace.length;
                                }
                                break;
                            case 38 /* AsteriskToken */:
                                if (state === 0 /* BeginningOfLine */) {
                                    // leading asterisks start recording on the *next* (non-whitespace) token
                                    state = 1 /* SawAsterisk */;
                                    indent += scanner.🔶<i><b title="Did not inline: unknown">getTokenText</b></i>().length;
                                    break;
                                }
                            // FALLTHROUGH otherwise to record the * as a comment
                            default:
                                state = 2 /* SavingComments */; // leading identifiers start recording as well
                                🔶<i><b title="Did not inline: unknown">pushComment</b></i>(scanner.🔶<i><b title="Did not inline: unknown">getTokenText</b></i>());
                                break;
                        }
                        if (<b title="Inlined">🔷token</b>() === 56 /* AtToken */) {
                            // Done
                            break;
                        }
                        🔶<i><b title="Did not inline: unknown">nextJSDocToken</b></i>();
                    }
                    🔶️<i><b title="CallWithDescriptor">removeLeadingNewlines</b></i>(comments);
                    🔶<i><b title="Did not inline: unknown">removeTrailingNewlines</b></i>(comments);
                    return comments;
                }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>



### parseJSDocIdentifierName:
<pre class="code">
() {
                    return 🔶<i><b title="Did not inline: unknown">createJSDocIdentifier</b></i>(ts.🔶<i><b title="Did not inline: unknown">tokenIsIdentifierOrKeyword</b></i>(<b title="Inlined">🔷token</b>()));
                }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>



### createJSDocIdentifier:
<pre class="code">
(isIdentifier) {
                    if (!isIdentifier) {
                        🔶️<i><b title="CallWithDescriptor">parseErrorAtCurrentToken</b></i>(ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Identifier_expected</b></i>);
                        return undefined;
                    }
                    var pos = scanner.🔶<i><b title="Did not inline: unknown">getTokenPos</b></i>();
                    var end = scanner.🔶<i><b title="Did not inline: unknown">getTextPos</b></i>();
                    var result = <b title="Inlined">🔷createNode</b>(70 /* Identifier */, pos);
                    result.text = content.🔶<i><b title="Did not inline: unknown">substring</b></i>(pos, end);
                    🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(result, end);
                    🔶<i><b title="Did not inline: unknown">nextJSDocToken</b></i>();
                    return result;
                }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createNode</summary>
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### setTextPos:
<pre class="code">
(textPos) {
            ts⚠️<i><b title="LoadNamedGeneric">.Debug</b></i>.🔶️<i><b title="CallWithDescriptor">assert</b></i>(textPos &gt;= 0);
            pos = textPos;
            startPos = textPos;
            tokenPos = textPos;
            token = 0 /* Unknown */;
            precedingLineBreak = false;
            tokenValue = undefined;
            hasExtendedUnicodeEscape = false;
            tokenIsUnterminated = false;
        }</pre>



### :
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(heritageElement) {
                if (!ts.🔶<i><b title="Did not inline: unknown">isEntityNameExpression</b></i>(heritageElement.expression)) {
                    🔶️<i><b title="CallWithDescriptor">error</b></i>(heritageElement⚠️<i><b title="LoadNamedGeneric">.expression</b></i>, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.An_interface_can_only_extend_an_identifier_Slashqualified_name_with_optional_type_arguments</b></i>);
                }
                🔶<i><b title="Did not inline: target text too big">checkTypeReferenceNode</b></i>(heritageElement);
            }</pre>



### parseJSDocCommentWorker:
<pre class="code">
(start, length) {
                var content = sourceText;
                start = start || 0;
                var end = length === undefined ? content⚠️<i><b title="LoadNamedGeneric">.length</b></i> : start + length;
                length = end - start;
                ts⚠️<i><b title="LoadNamedGeneric">.Debug</b></i>.🔶️<i><b title="CallWithDescriptor">assert</b></i>(start &gt;= 0);
                ts⚠️<i><b title="LoadNamedGeneric">.Debug</b></i>.🔶️<i><b title="CallWithDescriptor">assert</b></i>(start &lt;= end);
                ts⚠️<i><b title="LoadNamedGeneric">.Debug</b></i>.🔶️<i><b title="CallWithDescriptor">assert</b></i>(end &lt;= content.length);
                var tags;
                var comments = [];
                var result;
                // Check for /** (JSDoc opening part)
                if (!🔶️<i><b title="CallWithDescriptor">isJsDocStart</b></i>(content, start)) {
                    return result;
                }
                // + 3 for leading /**, - 5 in total for /** */
                scanner.🔶️<i><b title="CallWithDescriptor">scanRange</b></i>(start + 3, length - 5, 🔶️<i><b title="CallWithDescriptor">function</b></i> () {
                    // Initially we can parse out a tag.  We also have seen a starting asterisk.
                    // This is so that /** * @type */ doesn't parse.
                    var advanceToken = true;
                    var state = 1 /* SawAsterisk */;
                    var margin = undefined;
                    // + 4 for leading '/** '
                    var indent = start - Math.max(content.lastIndexOf("\x5cn", start), 0) + 4;
                    function pushComment(text) {
                        if (!margin) {
                            margin = indent;
                        }
                        comments.push(text);
                        indent += text.length;
                    }
                    nextJSDocToken();
                    while (token() === 5 /* WhitespaceTrivia */) {
                        nextJSDocToken();
                    }
                    if (token() === 4 /* NewLineTrivia */) {
                        state = 0 /* BeginningOfLine */;
                        indent = 0;
                        nextJSDocToken();
                    }
                    while (token() !== 1 /* EndOfFileToken */) {
                        switch (token()) {
                            case 56 /* AtToken */:
                                if (state === 0 /* BeginningOfLine */ || state === 1 /* SawAsterisk */) {
                                    removeTrailingNewlines(comments);
                                    parseTag(indent);
                                    // NOTE: According to usejsdoc.org, a tag goes to end of line, except the last tag.
                                    // Real-world comments may break this rule, so "BeginningOfLine" will not be a real line beginning
                                    // for malformed examples like `/** @param {string} x @returns {number} the length */`
                                    state = 0 /* BeginningOfLine */;
                                    advanceToken = false;
                                    margin = undefined;
                                    indent++;
                                }
                                else {
                                    pushComment(scanner.getTokenText());
                                }
                                break;
                            case 4 /* NewLineTrivia */:
                                comments.push(scanner.getTokenText());
                                state = 0 /* BeginningOfLine */;
                                indent = 0;
                                break;
                            case 38 /* AsteriskToken */:
                                var asterisk = scanner.getTokenText();
                                if (state === 1 /* SawAsterisk */ || state === 2 /* SavingComments */) {
                                    // If we've already seen an asterisk, then we can no longer parse a tag on this line
                                    state = 2 /* SavingComments */;
                                    pushComment(asterisk);
                                }
                                else {
                                    // Ignore the first asterisk on a line
                                    state = 1 /* SawAsterisk */;
                                    indent += asterisk.length;
                                }
                                break;
                            case 70 /* Identifier */:
                                // Anything else is doc comment text. We just save it. Because it
                                // wasn't a tag, we can no longer parse a tag on this line until we hit the next
                                // line break.
                                pushComment(scanner.getTokenText());
                                state = 2 /* SavingComments */;
                                break;
                            case 5 /* WhitespaceTrivia */:
                                // only collect whitespace if we're already saving comments or have just crossed the comment indent margin
                                var whitespace = scanner.getTokenText();
                                if (state === 2 /* SavingComments */) {
                                    comments.push(whitespace);
                                }
                                else if (margin !== undefined && indent + whitespace.length &gt; margin) {
                                    comments.push(whitespace.slice(margin - indent - 1));
                                }
                                indent += whitespace.length;
                                break;
                            case 1 /* EndOfFileToken */:
                                break;
                            default:
                                // anything other than whitespace or asterisk at the beginning of the line starts the comment text
                                state = 2 /* SavingComments */;
                                pushComment(scanner.getTokenText());
                                break;
                        }
                        if (advanceToken) {
                            nextJSDocToken();
                        }
                        else {
                            advanceToken = true;
                        }
                    }
                    removeLeadingNewlines(comments);
                    removeTrailingNewlines(comments);
                    result = createJSDocComment();
                });
                return result;
             🔶️<i><b title="CallWithDescriptor">   function</b></i> removeLeadingNewlines(comments) {
                    while (comments.length && (comments[0] === "\x5cn" || comments[0] === "\x5cr")) {
                        comments.shift();
                    }
                }
       🔶️<i><b title="CallWithDescriptor">         function</b></i> removeTrailingNewlines(comments) {
                    while (comments.length && (comments[comments.length - 1] === "\x5cn" || comments[comments.length - 1] === "\x5cr")) {
                        comments.pop();
                    }
                }
 🔶️<i><b title="CallWithDescriptor">               function</b></i> isJsDocStart(content, start) {
                    return content.charCodeAt(start) === 47 /* slash */ &&
                        content.charCodeAt(start + 1) === 42 /* asterisk */ &&
                        content.charCodeAt(start + 2) === 42 /* asterisk */ &&
                        content.charCodeAt(start + 3) !== 42 /* asterisk */;
                }
 🔶️<i><b title="CallWithDescriptor">               function</b></i> createJSDocComment() {
                    var result = createNode(278 /* JSDocComment */, start);
                    result.tags = tags;
                    result.comment = comments.length ? comments.join("") : undefined;
                    return finishNode(result, end);
                }
 🔶️<i><b title="CallWithDescriptor">               function</b></i> skipWhitespace() {
                    while (token() === 5 /* WhitespaceTrivia */ || token() === 4 /* NewLineTrivia */) {
                        nextJSDocToken();
                    }
                }
 🔶️<i><b title="CallWithDescriptor">               function</b></i> parseTag(indent) {
                    ts.Debug.assert(token() === 56 /* AtToken */);
                    var atToken = createNode(56 /* AtToken */, scanner.getTokenPos());
                    atToken.end = scanner.getTextPos();
                    nextJSDocToken();
                    var tagName = parseJSDocIdentifierName();
                    skipWhitespace();
                    if (!tagName) {
                        return;
                    }
                    var tag;
                    if (tagName) {
                        switch (tagName.text) {
                            case "augments":
                                tag = parseAugmentsTag(atToken, tagName);
                                break;
                            case "param":
                                tag = parseParamTag(atToken, tagName);
                                break;
                            case "return":
                            case "returns":
                                tag = parseReturnTag(atToken, tagName);
                                break;
                            case "template":
                                tag = parseTemplateTag(atToken, tagName);
                                break;
                            case "type":
                                tag = parseTypeTag(atToken, tagName);
                                break;
                            case "typedef":
                                tag = parseTypedefTag(atToken, tagName);
                                break;
                            default:
                                tag = parseUnknownTag(atToken, tagName);
                                break;
                        }
                    }
                    else {
                        tag = parseUnknownTag(atToken, tagName);
                    }
                    if (!tag) {
                        // a badly malformed tag should not be added to the list of tags
                        return;
                    }
                    addTag(tag, parseTagComments(indent + tag.end - tag.pos));
                }
 🔶️<i><b title="CallWithDescriptor">               function</b></i> parseTagComments(indent) {
                    var comments = [];
                    var state = 0 /* BeginningOfLine */;
                    var margin;
                    function pushComment(text) {
                        if (!margin) {
                            margin = indent;
                        }
                        comments.push(text);
                        indent += text.length;
                    }
                    while (token() !== 56 /* AtToken */ && token() !== 1 /* EndOfFileToken */) {
                        switch (token()) {
                            case 4 /* NewLineTrivia */:
                                if (state &gt;= 1 /* SawAsterisk */) {
                                    state = 0 /* BeginningOfLine */;
                                    comments.push(scanner.getTokenText());
                                }
                                indent = 0;
                                break;
                            case 56 /* AtToken */:
                                // Done
                                break;
                            case 5 /* WhitespaceTrivia */:
                                if (state === 2 /* SavingComments */) {
                                    pushComment(scanner.getTokenText());
                                }
                                else {
                                    var whitespace = scanner.getTokenText();
                                    // if the whitespace crosses the margin, take only the whitespace that passes the margin
                                    if (margin !== undefined && indent + whitespace.length &gt; margin) {
                                        comments.push(whitespace.slice(margin - indent - 1));
                                    }
                                    indent += whitespace.length;
                                }
                                break;
                            case 38 /* AsteriskToken */:
                                if (state === 0 /* BeginningOfLine */) {
                                    // leading asterisks start recording on the *next* (non-whitespace) token
                                    state = 1 /* SawAsterisk */;
                                    indent += scanner.getTokenText().length;
                                    break;
                                }
                            // FALLTHROUGH otherwise to record the * as a comment
                            default:
                                state = 2 /* SavingComments */; // leading identifiers start recording as well
                                pushComment(scanner.getTokenText());
                                break;
                        }
                        if (token() === 56 /* AtToken */) {
                            // Done
                            break;
                        }
                        nextJSDocToken();
                    }
                    removeLeadingNewlines(comments);
                    removeTrailingNewlines(comments);
                    return comments;
                }
 🔶️<i><b title="CallWithDescriptor">               function</b></i> parseUnknownTag(atToken, tagName) {
                    var result = createNode(279 /* JSDocTag */, atToken.pos);
                    result.atToken = atToken;
                    result.tagName = tagName;
                    return finishNode(result);
                }
 🔶️<i><b title="CallWithDescriptor">               function</b></i> addTag(tag, comments) {
                    tag.comment = comments.join("");
                    if (!tags) {
                        tags = createNodeArray([tag], tag.pos);
                    }
                    else {
                        tags.push(tag);
                    }
                    tags.end = tag.end;
                }
 🔶️<i><b title="CallWithDescriptor">               function</b></i> tryParseTypeExpression() {
                    return tryParse(function () {
                        skipWhitespace();
                        if (token() !== 16 /* OpenBraceToken */) {
                            return undefined;
                        }
                        return parseJSDocTypeExpression();
                    });
                }
 🔶️<i><b title="CallWithDescriptor">               function</b></i> parseParamTag(atToken, tagName) {
                    var typeExpression = tryParseTypeExpression();
                    skipWhitespace();
                    var name;
                    var isBracketed;
                    // Looking for something like '[foo]' or 'foo'
                    if (parseOptionalToken(20 /* OpenBracketToken */)) {
                        name = parseJSDocIdentifierName();
                        skipWhitespace();
                        isBracketed = true;
                        // May have an optional default, e.g. '[foo = 42]'
                        if (parseOptionalToken(57 /* EqualsToken */)) {
                            parseExpression();
                        }
                        parseExpected(21 /* CloseBracketToken */);
                    }
                    else if (ts.tokenIsIdentifierOrKeyword(token())) {
                        name = parseJSDocIdentifierName();
                    }
                    if (!name) {
                        parseErrorAtPosition(scanner.getStartPos(), 0, ts.Diagnostics.Identifier_expected);
                        return undefined;
                    }
                    var preName, postName;
                    if (typeExpression) {
                        postName = name;
                    }
                    else {
                        preName = name;
                    }
                    if (!typeExpression) {
                        typeExpression = tryParseTypeExpression();
                    }
                    var result = createNode(281 /* JSDocParameterTag */, atToken.pos);
                    result.atToken = atToken;
                    result.tagName = tagName;
                    result.preParameterName = preName;
                    result.typeExpression = typeExpression;
                    result.postParameterName = postName;
                    result.parameterName = postName || preName;
                    result.isBracketed = isBracketed;
                    return finishNode(result);
                }
 🔶️<i><b title="CallWithDescriptor">               function</b></i> parseReturnTag(atToken, tagName) {
                    if (ts.forEach(tags, function (t) { return t.kind === 282 /* JSDocReturnTag */; })) {
                        parseErrorAtPosition(tagName.pos, scanner.getTokenPos() - tagName.pos, ts.Diagnostics._0_tag_already_specified, tagName.text);
                    }
                    var result = createNode(282 /* JSDocReturnTag */, atToken.pos);
                    result.atToken = atToken;
                    result.tagName = tagName;
                    result.typeExpression = tryParseTypeExpression();
                    return finishNode(result);
                }
 🔶️<i><b title="CallWithDescriptor">               function</b></i> parseTypeTag(atToken, tagName) {
                    if (ts.forEach(tags, function (t) { return t.kind === 283 /* JSDocTypeTag */; })) {
                        parseErrorAtPosition(tagName.pos, scanner.getTokenPos() - tagName.pos, ts.Diagnostics._0_tag_already_specified, tagName.text);
                    }
                    var result = createNode(283 /* JSDocTypeTag */, atToken.pos);
                    result.atToken = atToken;
                    result.tagName = tagName;
                    result.typeExpression = tryParseTypeExpression();
                    return finishNode(result);
                }
 🔶️<i><b title="CallWithDescriptor">               function</b></i> parsePropertyTag(atToken, tagName) {
                    var typeExpression = tryParseTypeExpression();
                    skipWhitespace();
                    var name = parseJSDocIdentifierName();
                    skipWhitespace();
                    if (!name) {
                        parseErrorAtPosition(scanner.getStartPos(), /*length*/ 0, ts.Diagnostics.Identifier_expected);
                        return undefined;
                    }
                    var result = createNode(286 /* JSDocPropertyTag */, atToken.pos);
                    result.atToken = atToken;
                    result.tagName = tagName;
                    result.name = name;
                    result.typeExpression = typeExpression;
                    return finishNode(result);
                }
 🔶️<i><b title="CallWithDescriptor">               function</b></i> parseAugmentsTag(atToken, tagName) {
                    var typeExpression = tryParseTypeExpression();
                    var result = createNode(280 /* JSDocAugmentsTag */, atToken.pos);
                    result.atToken = atToken;
                    result.tagName = tagName;
                    result.typeExpression = typeExpression;
                    return finishNode(result);
                }
 🔶️<i><b title="CallWithDescriptor">               function</b></i> parseTypedefTag(atToken, tagName) {
                    var typeExpression = tryParseTypeExpression();
                    skipWhitespace();
                    var typedefTag = createNode(285 /* JSDocTypedefTag */, atToken.pos);
                    typedefTag.atToken = atToken;
                    typedefTag.tagName = tagName;
                    typedefTag.fullName = parseJSDocTypeNameWithNamespace(/*flags*/ 0);
                    if (typedefTag.fullName) {
                        var rightNode = typedefTag.fullName;
                        while (rightNode.kind !== 70 /* Identifier */) {
                            rightNode = rightNode.body;
                        }
                        typedefTag.name = rightNode;
                    }
                    typedefTag.typeExpression = typeExpression;
                    skipWhitespace();
                    if (typeExpression) {
                        if (typeExpression.type.kind === 272 /* JSDocTypeReference */) {
                            var jsDocTypeReference = typeExpression.type;
                            if (jsDocTypeReference.name.kind === 70 /* Identifier */) {
                                var name_14 = jsDocTypeReference.name;
                                if (name_14.text === "Object") {
                                    typedefTag.jsDocTypeLiteral = scanChildTags();
                                }
                            }
                        }
                        if (!typedefTag.jsDocTypeLiteral) {
                            typedefTag.jsDocTypeLiteral = typeExpression.type;
                        }
                    }
                    else {
                        typedefTag.jsDocTypeLiteral = scanChildTags();
                    }
                    return finishNode(typedefTag);
                    function scanChildTags() {
                        var jsDocTypeLiteral = createNode(287 /* JSDocTypeLiteral */, scanner.getStartPos());
                        var resumePos = scanner.getStartPos();
                        var canParseTag = true;
                        var seenAsterisk = false;
                        var parentTagTerminated = false;
                        while (token() !== 1 /* EndOfFileToken */ && !parentTagTerminated) {
                            nextJSDocToken();
                            switch (token()) {
                                case 56 /* AtToken */:
                                    if (canParseTag) {
                                        parentTagTerminated = !tryParseChildTag(jsDocTypeLiteral);
                                        if (!parentTagTerminated) {
                                            resumePos = scanner.getStartPos();
                                        }
                                    }
                                    seenAsterisk = false;
                                    break;
                                case 4 /* NewLineTrivia */:
                                    resumePos = scanner.getStartPos() - 1;
                                    canParseTag = true;
                                    seenAsterisk = false;
                                    break;
                                case 38 /* AsteriskToken */:
                                    if (seenAsterisk) {
                                        canParseTag = false;
                                    }
                                    seenAsterisk = true;
                                    break;
                                case 70 /* Identifier */:
                                    canParseTag = false;
                                case 1 /* EndOfFileToken */:
                                    break;
                            }
                        }
                        scanner.setTextPos(resumePos);
                        return finishNode(jsDocTypeLiteral);
                    }
                    function parseJSDocTypeNameWithNamespace(flags) {
                        var pos = scanner.getTokenPos();
                        var typeNameOrNamespaceName = parseJSDocIdentifierName();
                        if (typeNameOrNamespaceName && parseOptional(22 /* DotToken */)) {
                            var jsDocNamespaceNode = createNode(230 /* ModuleDeclaration */, pos);
                            jsDocNamespaceNode.flags |= flags;
                            jsDocNamespaceNode.name = typeNameOrNamespaceName;
                            jsDocNamespaceNode.body = parseJSDocTypeNameWithNamespace(4 /* NestedNamespace */);
                            return jsDocNamespaceNode;
                        }
                        if (typeNameOrNamespaceName && flags & 4 /* NestedNamespace */) {
                            typeNameOrNamespaceName.isInJSDocNamespace = true;
                        }
                        return typeNameOrNamespaceName;
                    }
                }
 🔶️<i><b title="CallWithDescriptor">               function</b></i> tryParseChildTag(parentTag) {
                    ts.Debug.assert(token() === 56 /* AtToken */);
                    var atToken = createNode(56 /* AtToken */, scanner.getStartPos());
                    atToken.end = scanner.getTextPos();
                    nextJSDocToken();
                    var tagName = parseJSDocIdentifierName();
                    skipWhitespace();
                    if (!tagName) {
                        return false;
                    }
                    switch (tagName.text) {
                        case "type":
                            if (parentTag.jsDocTypeTag) {
                                // already has a @type tag, terminate the parent tag now.
                                return false;
                            }
                            parentTag.jsDocTypeTag = parseTypeTag(atToken, tagName);
                            return true;
                        case "prop":
                        case "property":
                            var propertyTag = parsePropertyTag(atToken, tagName);
                            if (propertyTag) {
                                if (!parentTag.jsDocPropertyTags) {
                                    parentTag.jsDocPropertyTags = [];
                                }
                                parentTag.jsDocPropertyTags.push(propertyTag);
                                return true;
                            }
                            // Error parsing property tag
                            return false;
                    }
                    return false;
                }
 🔶️<i><b title="CallWithDescriptor">               function</b></i> parseTemplateTag(atToken, tagName) {
                    if (ts.forEach(tags, function (t) { return t.kind === 284 /* JSDocTemplateTag */; })) {
                        parseErrorAtPosition(tagName.pos, scanner.getTokenPos() - tagName.pos, ts.Diagnostics._0_tag_already_specified, tagName.text);
                    }
                    // Type parameter list looks like '@template T,U,V'
                    var typeParameters = createNodeArray();
                    while (true) {
                        var name_15 = parseJSDocIdentifierName();
                        skipWhitespace();
                        if (!name_15) {
                            parseErrorAtPosition(scanner.getStartPos(), 0, ts.Diagnostics.Identifier_expected);
                            return undefined;
                        }
                        var typeParameter = createNode(143 /* TypeParameter */, name_15.pos);
                        typeParameter.name = name_15;
                        finishNode(typeParameter);
                        typeParameters.push(typeParameter);
                        if (token() === 25 /* CommaToken */) {
                            nextJSDocToken();
                            skipWhitespace();
                        }
                        else {
                            break;
                        }
                    }
                    var result = createNode(284 /* JSDocTemplateTag */, atToken.pos);
                    result.atToken = atToken;
                    result.tagName = tagName;
                    result.typeParameters = typeParameters;
                    finishNode(result);
                    typeParameters.end = result.end;
                    return result;
                }
 🔶️<i><b title="CallWithDescriptor">               function</b></i> nextJSDocToken() {
                    return currentToken = scanner.scanJSDocToken();
                }
 🔶️<i><b title="CallWithDescriptor">               function</b></i> parseJSDocIdentifierName() {
                    return createJSDocIdentifier(ts.tokenIsIdentifierOrKeyword(token()));
                }
 🔶️<i><b title="CallWithDescriptor">               function</b></i> createJSDocIdentifier(isIdentifier) {
                    if (!isIdentifier) {
                        parseErrorAtCurrentToken(ts.Diagnostics.Identifier_expected);
                        return undefined;
                    }
                    var pos = scanner.getTokenPos();
                    var end = scanner.getTextPos();
                    var result = createNode(70 /* Identifier */, pos);
                    result.text = content.substring(pos, end);
                    finishNode(result, end);
                    nextJSDocToken();
                    return result;
                }
            }</pre>



### removeTrailingNewlines:
<pre class="code">
(comments) {
                    while (comments.length && (comments[comments.length - 1] === "\x5cn" || comments[comments.length - 1] === "\x5cr")) {
                        comments.pop();
                    }
                }</pre>



### parseTag:
<pre class="code">
(indent) {
                    ts⚠️<i><b title="LoadNamedGeneric">.Debug</b></i>.🔶️<i><b title="CallWithDescriptor">assert</b></i>(<b title="Inlined">🔷token</b>() === 56 /* AtToken */);
                    var atToken = <b title="Inlined">🔷createNode</b>(56 /* AtToken */, scanner.🔶<i><b title="Did not inline: unknown">getTokenPos</b></i>());
                    atToken.end = scanner.🔶<i><b title="Did not inline: unknown">getTextPos</b></i>();
                    🔶<i><b title="Did not inline: unknown">nextJSDocToken</b></i>();
                    var tagName = parseJSDocIdentifierName();
                    🔶<i><b title="Did not inline: unknown">skipWhitespace</b></i>();
                    if (!tagName) {
                        return;
                    }
                    var tag;
                    if (tagName) {
                        switch (tagName.text) {
                            case "augments":
                                tag = 🔶️<i><b title="CallWithDescriptor">parseAugmentsTag</b></i>(atToken, tagName);
                                break;
                            case "param":
                                tag = 🔶<i><b title="Did not inline: unknown">parseParamTag</b></i>(atToken, tagName);
                                break;
                            case "return":
                            case "returns":
                                tag = 🔶️<i><b title="CallWithDescriptor">parseReturnTag</b></i>(atToken, tagName);
                                break;
                            case "template":
                                tag = 🔶️<i><b title="CallWithDescriptor">parseTemplateTag</b></i>(atToken, tagName);
                                break;
                            case "type":
                                tag = 🔶️<i><b title="CallWithDescriptor">parseTypeTag</b></i>(atToken, tagName);
                                break;
                            case "typedef":
                                tag = 🔶️<i><b title="CallWithDescriptor">parseTypedefTag</b></i>(atToken, tagName);
                                break;
                            default:
                                tag = 🔶️<i><b title="CallWithDescriptor">parseUnknownTag</b></i>(atToken, tagName);
                                break;
                        }
                    }
                    else {
                        tag = 🔶️<i><b title="CallWithDescriptor">parseUnknownTag</b></i>(atToken, tagName);
                    }
                    if (!tag) {
                        // a badly malformed tag should not be added to the list of tags
                        return;
                    }
                    🔶<i><b title="Did not inline: unknown">addTag</b></i>(tag, 🔶<i><b title="Did not inline: unknown">parseTagComments</b></i>(indent + tag.end - tag.pos));
                }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>createNode</summary>
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### addTag:
<pre class="code">
(tag, comments) {
                    tag.comment ⚠️<i><b title="StoreNamedGeneric">= comments</b></i>.🔶<i><b title="Did not inline: unknown">join</b></i>("");
                    if (!tags) {
                        tags = <b title="Inlined">🔷createNodeArray</b>([tag], tag.pos);
                    }
                    else {
                        tags.push(tag);
                    }
                    tags.end = tag.end;
                }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createNodeArray</summary>
<pre class="code">
(elements, pos) {
            var array = (elements || []);
            if (!(pos &gt;= 0)) {
                pos = <b title="Inlined">🔷getNodePos</b>();
            }
            array.pos ⚠️<i><b title="StoreNamedGeneric">= pos</b></i>;
            array.end = pos;
            return array;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getNodePos</summary>
<pre class="code">
() {
            return scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### skipWhitespace:
<pre class="code">
() {
                    while (<b title="Inlined">🔷token</b>() === 5 /* WhitespaceTrivia */ || <b title="Inlined">🔷token</b>() === 4 /* NewLineTrivia */) {
                        🔶<i><b title="Did not inline: unknown">nextJSDocToken</b></i>();
                    }
                }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>



### parseParamTag:
<pre class="code">
(atToken, tagName) {
                    var typeExpression = 🔶<i><b title="Did not inline: unknown">tryParseTypeExpression</b></i>();
                    🔶<i><b title="Did not inline: unknown">skipWhitespace</b></i>();
                    var name;
                    var isBracketed;
                    // Looking for something like '[foo]' or 'foo'
                    if (<b title="Inlined">🔷parseOptionalToken</b>(20 /* OpenBracketToken */)) {
                        name = 🔶<i><b title="Did not inline: unknown">parseJSDocIdentifierName</b></i>();
                        🔶<i><b title="Did not inline: unknown">skipWhitespace</b></i>();
                        isBracketed = true;
                        // May have an optional default, e.g. '[foo = 42]'
                        if (🔶<i><b title="Did not inline: unknown">parseOptionalToken</b></i>(57 /* EqualsToken */)) {
                            🔶️<i><b title="CallWithDescriptor">parseExpression</b></i>();
                        }
                        🔶<i><b title="Did not inline: target text too big">parseExpected</b></i>(21 /* CloseBracketToken */);
                    }
                    else if (ts.⚠️<i><b title="LoadNamedGeneric">tokenIsIdentifierOrKeyword</b></i>(<b title="Inlined">🔷token</b>())) {
                        name = 🔶<i><b title="Did not inline: unknown">parseJSDocIdentifierName</b></i>();
                    }
                    if (!name) {
                        🔶️<i><b title="CallWithDescriptor">parseErrorAtPosition</b></i>(scanner.⚠️<i><b title="LoadNamedGeneric">getStartPos</b></i>(), 0, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Identifier_expected</b></i>);
                        return undefined;
                    }
                    var preName, postName;
                    if (typeExpression) {
                        postName = name;
                    }
                    else {
                        preName = name;
                    }
                    if (!typeExpression) {
                        typeExpression = 🔶<i><b title="Did not inline: unknown">tryParseTypeExpression</b></i>();
                    }
                    var result = <b title="Inlined">🔷createNode</b>(281 /* JSDocParameterTag */, atToken.pos);
                    result.atToken = atToken;
                    result.tagName = tagName;
                    result.preParameterName = preName;
                    result.typeExpression = typeExpression;
                    result.postParameterName = postName;
                    result.parameterName = postName || preName;
                    result.isBracketed = isBracketed;
                    return 🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(result);
                }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>parseOptionalToken</summary>
<pre class="code">
(t) {
            if (<b title="Inlined">🔷token</b>() === t) {
                return <b title="Inlined">🔷parseTokenNode</b>();
            }
            return undefined;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>parseTokenNode</summary>
<pre class="code">
() {
            var node = <b title="Inlined">🔷createNode</b>(<b title="Inlined">🔷token</b>());
            <b title="Inlined">🔷nextToken</b>();
            return 🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(node);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>createNode</summary>
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>createNode</summary>
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### isStartOfType:
<pre class="code">
() {
            switch (<b title="Inlined">🔷token</b>()) {
                case 118 /* AnyKeyword */:
                case 134 /* StringKeyword */:
                case 132 /* NumberKeyword */:
                case 121 /* BooleanKeyword */:
                case 135 /* SymbolKeyword */:
                case 104 /* VoidKeyword */:
                case 137 /* UndefinedKeyword */:
                case 94 /* NullKeyword */:
                case 98 /* ThisKeyword */:
                case 102 /* TypeOfKeyword */:
                case 129 /* NeverKeyword */:
                case 16 /* OpenBraceToken */:
                case 20 /* OpenBracketToken */:
                case 26 /* LessThanToken */:
                case 48 /* BarToken */:
                case 47 /* AmpersandToken */:
                case 93 /* NewKeyword */:
                case 9 /* StringLiteral */:
                case 8 /* NumericLiteral */:
                case 100 /* TrueKeyword */:
                case 85 /* FalseKeyword */:
                    return true;
                case 37 /* MinusToken */:
                    return 🔶<i><b title="Did not inline: unknown">lookAhead</b></i>(nextTokenIsNumericLiteral);
                case 18 /* OpenParenToken */:
                    // Only consider '(' the start of a type if followed by ')', '...', an identifier, a modifier,
                    // or something that starts a type. We don't want to consider things like '(1)' a type.
                    return 🔶<i><b title="Did not inline: unknown">lookAhead</b></i>(isStartOfParenthesizedOrFunctionType);
                default:
                    return 🔶<i><b title="Did not inline: target text too big">isIdentifier</b></i>();
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>



### parseList:
<pre class="code">
(kind, parseElement) {
            var saveParsingContext = parsingContext;
            parsingContext |= 1 &lt;&lt; kind;
            var result = <b title="Inlined">🔷createNodeArray</b>();
            while (!🔶<i><b title="Did not inline: target text too big">isListTerminator</b></i>(kind)) {
                if (🔶<i><b title="Did not inline: target text too big">isListElement</b></i>(kind, /*inErrorRecovery*/ false)) {
                    var element = <b title="Inlined">🔷parseListElement</b>(kind, parseElement);
                    result.🔶️<i><b title="CallWithDescriptor">push</b></i>(element);
                    continue;
                }
                if (🔶️<i><b title="CallWithDescriptor">abortParsingListOrMoveToNextToken</b></i>(kind)) {
                    break;
                }
            }
            result.end = <b title="Inlined">🔷getNodeEnd</b>();
            parsingContext = saveParsingContext;
            return result;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createNodeArray</summary>
<pre class="code">
(elements, pos) {
            var array = (elements || []);
            if (!(pos &gt;= 0)) {
                pos = <b title="Inlined">🔷getNodePos</b>();
            }
            array.pos ⚠️<i><b title="StoreNamedGeneric">= pos</b></i>;
            array.end = pos;
            return array;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getNodePos</summary>
<pre class="code">
() {
            return scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>parseListElement</summary>
<pre class="code">
(parsingContext, parseElement) {
            var node = 🔶<i><b title="Did not inline: target text too big">currentNode</b></i>(parsingContext);
            if (node) {
                return 🔶️<i><b title="CallWithDescriptor">consumeNode</b></i>(node);
            }
            return 🔶️<i><b title="CallWithDescriptor">parseElement</b></i>();
        }</pre>

</details>
<details>
<summary>getNodeEnd</summary>
<pre class="code">
() {
            return scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
        }</pre>

</details>
</blockquote>



### parseExpressionWithTypeArguments:
<pre class="code">
() {
            var node = <b title="Inlined">🔷createNode</b>(199 /* ExpressionWithTypeArguments */);
            node.expression = 🔶<i><b title="Did not inline: target text too big">parseLeftHandSideExpressionOrHigher</b></i>();
            if (<b title="Inlined">🔷token</b>() === 26 /* LessThanToken */) {
                node.typeArguments = <b title="Inlined">🔷parseBracketedList</b>(19 /* TypeArguments */, parseType, 26 /* LessThanToken */, 28 /* GreaterThanToken */);
            }
            return 🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(node);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createNode</summary>
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>parseBracketedList</summary>
<pre class="code">
(kind, parseElement, open, close) {
            if (🔶<i><b title="Did not inline: target text too big">parseExpected</b></i>(open)) {
                var result = 🔶<i><b title="Did not inline: target text too big">parseDelimitedList</b></i>(kind, parseElement);
                🔶<i><b title="Did not inline: target text too big">parseExpected</b></i>(close);
                return result;
            }
            return 🔶️<i><b title="CallWithDescriptor">createMissingList</b></i>();
        }</pre>

</details>
</blockquote>



### parseHeritageClause:
<pre class="code">
() {
            if (<b title="Inlined">🔷token</b>() === 84 /* ExtendsKeyword */ || <b title="Inlined">🔷token</b>() === 107 /* ImplementsKeyword */) {
                var node = <b title="Inlined">🔷createNode</b>(255 /* HeritageClause */);
                node.token = <b title="Inlined">🔷token</b>();
                <b title="Inlined">🔷nextToken</b>();
                node.types = 🔶<i><b title="Did not inline: target text too big">parseDelimitedList</b></i>(7 /* HeritageClauseElement */, parseExpressionWithTypeArguments);
                return 🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(node);
            }
            return undefined;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>createNode</summary>
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>



### parseMemberExpressionRest:
<pre class="code">
(expression) {
            while (true) {
                var dotToken = <b title="Inlined">🔷parseOptionalToken</b>(22 /* DotToken */);
                if (dotToken) {
                    var propertyAccess = <b title="Inlined">🔷createNode</b>(177 /* PropertyAccessExpression */, expression.pos);
                    propertyAccess.expression = expression;
                    propertyAccess.name = 🔶<i><b title="Did not inline: target text too big">parseRightSideOfDot</b></i>(/*allowIdentifierNames*/ true);
                    expression = 🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(propertyAccess);
                    continue;
                }
                if (<b title="Inlined">🔷token</b>() === 50 /* ExclamationToken */ && !scanner.🔶<i><b title="Did not inline: unknown">hasPrecedingLineBreak</b></i>()) {
                    🔶<i><b title="Did not inline: unknown">nextToken</b></i>();
                    var nonNullExpression = 🔶<i><b title="Did not inline: unknown">createNode</b></i>(201 /* NonNullExpression */, expression⚠️<i><b title="LoadNamedGeneric">.pos</b></i>);
                    nonNullExpression.expression ⚠️<i><b title="StoreNamedGeneric">= expression</b></i>;
                    expression = 🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(nonNullExpression);
                    continue;
                }
                // when in the [Decorator] context, we do not parse ElementAccess as it could be part of a ComputedPropertyName
                if (!<b title="Inlined">🔷inDecoratorContext</b>() && <b title="Inlined">🔷parseOptional</b>(20 /* OpenBracketToken */)) {
                    var indexedAccess = 🔶<i><b title="Did not inline: unknown">createNode</b></i>(178 /* ElementAccessExpression */, expression⚠️<i><b title="LoadNamedGeneric">.pos</b></i>);
                    indexedAccess.expression ⚠️<i><b title="StoreNamedGeneric">= expression</b></i>;
                    // It's not uncommon for a user to write: "new Type[]".
                    // Check for that common pattern and report a better error message.
                    if (🔶<i><b title="Did not inline: unknown">token</b></i>() ⚠️<i><b title="CompareGeneric">!== 21</b></i> /* CloseBracketToken */) {
                        indexedAccess.argumentExpression ⚠️<i><b title="StoreNamedGeneric">= allowInAnd</b></i>(parseExpression);
                        if (indexedAccess⚠️<i><b title="LoadNamedGeneric">.argumentExpression</b></i>⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 9</b></i> /* StringLiteral */ || indexedAccess⚠️<i><b title="LoadNamedGeneric">.argumentExpression</b></i>⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 8</b></i> /* NumericLiteral */) {
                            var literal = indexedAccess⚠️<i><b title="LoadNamedGeneric">.argumentExpression</b></i>;
                            literal.text ⚠️<i><b title="StoreNamedGeneric">= internIdentifier</b></i>(literal⚠️<i><b title="LoadNamedGeneric">.text</b></i>);
                        }
                    }
                    🔶<i><b title="Did not inline: target text too big">parseExpected</b></i>(21 /* CloseBracketToken */);
                    expression = 🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(indexedAccess);
                    continue;
                }
                if (<b title="Inlined">🔷token</b>() === 12 /* NoSubstitutionTemplateLiteral */ || <b title="Inlined">🔷token</b>() === 13 /* TemplateHead */) {
                    var tagExpression = 🔶<i><b title="Did not inline: unknown">createNode</b></i>(181 /* TaggedTemplateExpression */, expression⚠️<i><b title="LoadNamedGeneric">.pos</b></i>);
                    tagExpression.tag ⚠️<i><b title="StoreNamedGeneric">= expression</b></i>;
                    tagExpression.template ⚠️<i><b title="StoreNamedGeneric">= token</b></i>() ⚠️<i><b title="CompareGeneric">=== 12</b></i> /* NoSubstitutionTemplateLiteral */
                        ? 🔶<i><b title="Did not inline: unknown">parseLiteralNode</b></i>()
                        : 🔶️<i><b title="CallWithDescriptor">parseTemplateExpression</b></i>();
                    expression = 🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(tagExpression);
                    continue;
                }
                return expression;
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>parseOptionalToken</summary>
<pre class="code">
(t) {
            if (<b title="Inlined">🔷token</b>() === t) {
                return <b title="Inlined">🔷parseTokenNode</b>();
            }
            return undefined;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>parseTokenNode</summary>
<pre class="code">
() {
            var node = <b title="Inlined">🔷createNode</b>(<b title="Inlined">🔷token</b>());
            <b title="Inlined">🔷nextToken</b>();
            return 🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(node);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>createNode</summary>
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>createNode</summary>
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>inDecoratorContext</summary>
<pre class="code">
() {
            return <b title="Inlined">🔷inContext</b>(8192 /* DecoratorContext */);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>inContext</summary>
<pre class="code">
(flags) {
            return (contextFlags & flags) !== 0;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>parseOptional</summary>
<pre class="code">
(t) {
            if (<b title="Inlined">🔷token</b>() === t) {
                <b title="Inlined">🔷nextToken</b>();
                return true;
            }
            return false;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>



### isStartOfMappedType:
<pre class="code">
() {
            <b title="Inlined">🔷nextToken</b>();
            if (<b title="Inlined">🔷token</b>() === 130 /* ReadonlyKeyword */) {
                <b title="Inlined">🔷nextToken</b>();
            }
            return <b title="Inlined">🔷token</b>() === 20 /* OpenBracketToken */ && <b title="Inlined">🔷nextTokenIsIdentifier</b>() && <b title="Inlined">🔷nextToken</b>() === 91 /* InKeyword */;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>nextTokenIsIdentifier</summary>
<pre class="code">
() {
            <b title="Inlined">🔷nextToken</b>();
            return 🔶<i><b title="Did not inline: target text too big">isIdentifier</b></i>();
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>



### parseTypeLiteral:
<pre class="code">
() {
            var node = <b title="Inlined">🔷createNode</b>(161 /* TypeLiteral */);
            node.members = <b title="Inlined">🔷parseObjectTypeMembers</b>();
            return 🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(node);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createNode</summary>
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>parseObjectTypeMembers</summary>
<pre class="code">
() {
            var members;
            if (🔶<i><b title="Did not inline: target text too big">parseExpected</b></i>(16 /* OpenBraceToken */)) {
                members = 🔶<i><b title="Did not inline: target text too big">parseList</b></i>(4 /* TypeMembers */, parseTypeMember);
                🔶<i><b title="Did not inline: target text too big">parseExpected</b></i>(17 /* CloseBraceToken */);
            }
            else {
                members = 🔶️<i><b title="CallWithDescriptor">createMissingList</b></i>();
            }
            return members;
        }</pre>

</details>
</blockquote>



### isStartOfConstructSignature:
<pre class="code">
() {
            <b title="Inlined">🔷nextToken</b>();
            return <b title="Inlined">🔷token</b>() === 18 /* OpenParenToken */ || <b title="Inlined">🔷token</b>() === 26 /* LessThanToken */;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>



### parseTypeParameter:
<pre class="code">
() {
            var node = <b title="Inlined">🔷createNode</b>(143 /* TypeParameter */);
            node.name = <b title="Inlined">🔷parseIdentifier</b>();
            if (<b title="Inlined">🔷parseOptional</b>(84 /* ExtendsKeyword */)) {
                // It's not uncommon for people to write improper constraints to a generic.  If the
                // user writes a constraint that is an expression and not an actual type, then parse
                // it out as an expression (so we can recover well), but report that a type is needed
                // instead.
                if (🔶<i><b title="Did not inline: target text too big">isStartOfType</b></i>() || !🔶<i><b title="Did not inline: target text too big">isStartOfExpression</b></i>()) {
                    node.constraint = <b title="Inlined">🔷parseType</b>();
                }
                else {
                    // It was not a type, and it looked like an expression.  Parse out an expression
                    // here so we recover well.  Note: it is important that we call parseUnaryExpression
                    // and not parseExpression here.  If the user has:
                    //
                    //      &lt;T extends ""&gt;
                    //
                    // We do *not* want to consume the  &gt;  as we're consuming the expression for "".
                    node.expression ⚠️<i><b title="StoreNamedGeneric">= parseUnaryExpressionOrHigher</b></i>();
                }
            }
            return 🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(node);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createNode</summary>
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>parseIdentifier</summary>
<pre class="code">
(diagnosticMessage) {
            return 🔶<i><b title="Did not inline: target text too big">createIdentifier</b></i>(🔶<i><b title="Did not inline: target text too big">isIdentifier</b></i>(), diagnosticMessage);
        }</pre>

</details>
<details>
<summary>parseOptional</summary>
<pre class="code">
(t) {
            if (<b title="Inlined">🔷token</b>() === t) {
                <b title="Inlined">🔷nextToken</b>();
                return true;
            }
            return false;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
<details>
<summary>nextToken</summary>
<pre class="code">
() {
            return currentToken = scanner.🔶<i><b title="Did not inline: unknown">scan</b></i>();
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>parseType</summary>
<pre class="code">
() {
            // The rules about 'yield' only apply to actual code/expression contexts.  They don't
            // apply to 'type' contexts.  So we disable these parameters here before moving on.
            return 🔶<i><b title="Did not inline: target text too big">doOutsideOfContext</b></i>(20480 /* TypeExcludesFlags */, parseTypeWorker);
        }</pre>

</details>
</blockquote>



### parseTypeOperator:
<pre class="code">
(operator) {
            var node = <b title="Inlined">🔷createNode</b>(168 /* TypeOperator */);
            🔶<i><b title="Did not inline: target text too big">parseExpected</b></i>(operator);
            node.operator = operator;
            node.type = <b title="Inlined">🔷parseTypeOperatorOrHigher</b>();
            return 🔶<i><b title="Did not inline: target text too big">finishNode</b></i>(node);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createNode</summary>
<pre class="code">
(kind, pos) {
            nodeCount++;
            if (!(pos ⚠️<i><b title="CompareGeneric">>= 0</b></i>)) {
                pos = scanner.🔶<i><b title="Did not inline: unknown">getStartPos</b></i>();
            }
            return kind &gt;= 141 /* FirstNode */ ? <b title="Inlined">🔷new NodeConstructor</b>(kind, pos, pos) :
                kind === 70 /* Identifier */ ? <b title="Inlined">🔷new IdentifierConstructor</b>(kind, pos, pos) :
                    <b title="Inlined">🔷new TokenConstructor</b>(kind, pos, pos);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new NodeConstructor</summary>
<pre class="code">
(kind, pos, end) {
            this.pos = pos;
            this.end = end;
            this.flags = 0 /* None */;
            this.transformFlags = undefined;
            this.parent = undefined;
            this.kind = kind;
        }</pre>

</details>
<details>
<summary>new IdentifierConstructor</summary>
<pre class="code">
(_kind, pos, end) {
            return _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
        }</pre>

</details>
<details>
<summary>new TokenConstructor</summary>
<pre class="code">
(kind, pos, end) {
            var _this = _super.🔶️<i><b title="CallWithDescriptor">call</b></i>(this, pos, end) || this;
            _this.kind = kind;
            return _this;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>parseTypeOperatorOrHigher</summary>
<pre class="code">
() {
            switch (<b title="Inlined">🔷token</b>()) {
                case 126 /* KeyOfKeyword */:
                    return 🔶<i><b title="Did not inline: unknown">parseTypeOperator</b></i>(126 /* KeyOfKeyword */);
            }
            return 🔶<i><b title="Did not inline: target text too big">parseArrayTypeOrHigher</b></i>();
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>token</summary>
<pre class="code">
() {
            return currentToken;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### ⛔ collectModuleReferences (deoptimizated):
<pre class="code">
(node, inAmbientModule) {
                switch (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i>) {
                    case 235 /* ImportDeclaration */:
                    case 234 /* ImportEqualsDeclaration */:
                    case 241 /* ExportDeclaration */:
                        var moduleNameExpr = ts.⚠️<i><b title="LoadNamedGeneric">getExternalModuleName</b></i>(node);
                        if (!moduleNameExpr || moduleNameExpr.kind !== 9 /* StringLiteral */) {
                            break;
                        }
                        if (!moduleNameExpr.text) {
                            break;
                        }
                        // TypeScript 1.0 spec (April 2014): 12.1.6
                        // An ExternalImportDeclaration in an AmbientExternalModuleDeclaration may reference other external modules
                        // only through top - level external module names. Relative external module names are not permitted.
                        if (!inAmbientModule || !ts.🔶️<i><b title="CallWithDescriptor">isExternalModuleNameRelative</b></i>(moduleNameExpr.text)) {
                            (imports || (imports = [])).push(moduleNameExpr);
                        }
                        break;
                    case 230 /* ModuleDeclaration */:
                        if (ts.🔶<i><b title="Did not inline: unknown">isAmbientModule</b></i>(node) && (inAmbientModule || ts.🔶<i><b title="Did not inline: unknown">hasModifier</b></i>(node, 2 /* Ambient */) || ts.🔶️<i><b title="CallWithDescriptor">isDeclarationFile</b></i>(file))) {
                            var moduleName = node.name;
                            // Ambient module declarations can be interpreted as augmentations for some existing external modules.
                            // This will happen in two cases:
                            // - if current file is external module then module augmentation is a ambient module declaration defined in the top level scope
                            // - if current file is not external module then module augmentation is an ambient module declaration with non-relative module name
                            //   immediately nested in top level ambient module declaration .
                            if (isExternalModuleFile || (inAmbientModule && !ts.🔶️<i><b title="CallWithDescriptor">isExternalModuleNameRelative</b></i>(moduleName⚠️<i><b title="LoadNamedGeneric">.text</b></i>))) {
                                (moduleAugmentations || (moduleAugmentations = 🔶️<i><b title="CallWithDescriptor">[])).</b></i>🔶️<i><b title="CallWithDescriptor">push</b></i>(moduleName);
                            }
                            else if (!inAmbientModule) {
                                if (isDtsFile) {
                                    // for global .d.ts files record name of ambient module
                                    (ambientModules || (ambientModules = [])).push(moduleName.text);
                                }
                                // An AmbientExternalModuleDeclaration declares an external module.
                                // This type of declaration is permitted only in the global module.
                                // The StringLiteral must specify a top - level external module name.
                                // Relative external module names are not permitted
                                // NOTE: body of ambient module is always a module block, if it exists
                                var body = node.body;
                                if (body) {
                                    for (var _i = 0, _a = body.statements; _i &lt; _a.length; _i++) {
                                        var statement = _a[_i];
                                        🔶<i><b title="Did not inline: target text too big">collectModuleReferences</b></i>(statement, /*inAmbientModule*/ true);
                                    }
                                }
                            }
                        }
                }
            }</pre>

```diff
- Deopt: <JS Function modifierToFlag (SharedFunctionInfo 0x3504a53d5419)> (opt #150) @1, FP to SP delta: 24, caller sp: 0x7fff5fbfd810
```



### visitNodeArray:
<pre class="code">
(cbNodes, nodes) {
        if (nodes) {
            return 🔶️<i><b title="CallWithDescriptor">cbNodes</b></i>(nodes);
        }
    }</pre>



### isAmbientModule:
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(node) {
        return node && node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 230 /* ModuleDeclaration */ &&
            (node⚠️<i><b title="LoadNamedGeneric">.name</b></i>.kind === 9 /* StringLiteral */ || <b title="Inlined">🔷isGlobalScopeAugmentation</b>(node));
    }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>isGlobalScopeAugmentation</summary>
<pre class="code">
(module) {
        return !!(module⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 512 /* GlobalAugmentation */);
    }</pre>

</details>
</blockquote>



### isInJavaScriptFile:
<pre class="code">
(node) {
        return node && !!(node⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 65536 /* JavaScriptFile */);
    }</pre>



### isExpression:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(node) {
        return <b title="Inlined">🔷isExpressionKind</b>(ts.🔶<i><b title="Did not inline: unknown">skipPartiallyEmittedExpressions</b></i>(node).kind);
    }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>isExpressionKind</summary>
<pre class="code">
(kind) {
        return kind === 193 /* ConditionalExpression */
            || kind === 195 /* YieldExpression */
            || kind === 185 /* ArrowFunction */
            || kind === 192 /* BinaryExpression */
            || kind === 196 /* SpreadElement */
            || kind === 200 /* AsExpression */
            || kind === 198 /* OmittedExpression */
            || <b title="Inlined">🔷isUnaryExpressionKind</b>(kind);
    }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>isUnaryExpressionKind</summary>
<pre class="code">
(kind) {
        return kind === 190 /* PrefixUnaryExpression */
            || kind === 191 /* PostfixUnaryExpression */
            || kind === 186 /* DeleteExpression */
            || kind === 187 /* TypeOfExpression */
            || kind === 188 /* VoidExpression */
            || kind === 189 /* AwaitExpression */
            || kind === 182 /* TypeAssertionExpression */
            || 🔶<i><b title="Did not inline: target text too big">isLeftHandSideExpressionKind</b></i>(kind);
    }</pre>

</details>
</blockquote>

</details>
</blockquote>



### bind:
<pre class="code">
(node) {
            if (!node) {
                return;
            }
            node.parent ⚠️<i><b title="StoreNamedGeneric">= parent</b></i>;
            var saveInStrictMode = inStrictMode;
            // First we bind declaration nodes to a symbol if possible. We'll both create a symbol
            // and then potentially add the symbol to an appropriate symbol table. Possible
            // destination symbol tables are:
            //
            //  1) The 'exports' table of the current container's symbol.
            //  2) The 'members' table of the current container's symbol.
            //  3) The 'locals' table of the current container.
            //
            // However, not all symbols will end up in any of these tables. 'Anonymous' symbols
            // (like TypeLiterals for example) will not be put in any table.
            🔶<i><b title="Did not inline: target text too big">bindWorker</b></i>(node);
            // Then we recurse into the children of the node to bind them as well. For certain
            // symbols we do specialized work when we recurse. For example, we'll keep track of
            // the current 'container' node when it changes. This helps us know which symbol table
            // a local should go into for example. Since terminal nodes are known not to have
            // children, as an optimization we don't process those.
            if (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> &gt; 140 /* LastToken */) {
                var saveParent = parent;
                parent = node;
                var containerFlags = 🔶<i><b title="Did not inline: target text too big">getContainerFlags</b></i>(node);
                if (containerFlags === 0 /* None */) {
                    🔶<i><b title="Did not inline: target text too big">bindChildren</b></i>(node);
                }
                else {
                    🔶<i><b title="Did not inline: target text too big">bindContainer</b></i>(node, containerFlags);
                }
                parent = saveParent;
            }
            else if (!skipTransformFlagAggregation && (node⚠️<i><b title="LoadNamedGeneric">.transformFlags</b></i> ⚠️<i><b title="Bitwise">& 536870912</b></i> /* HasComputedFlags */) ⚠️<i><b title="CompareGeneric">=== 0</b></i>) {
                subtreeTransformFlags |⚠️<i><b title="Bitwise">= computeTransformFlagsForNode</b></i>(node, 0);
            }
            inStrictMode = saveInStrictMode;
        }</pre>



### SymbolObject:
<pre class="code">
(flags, name) {
            this.flags = flags;
            this.name = name;
        }</pre>



### createSymbol:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(flags, name) {
            symbolCount++;
            return <b title="Inlined">🔷new Symbol</b>(flags, name);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new Symbol</summary>
<pre class="code">
(flags, name) {
            this.flags = flags;
            this.name = name;
        }</pre>

</details>
</blockquote>



### declareSymbolAndAddToSymbolTable:
<pre class="code">
(node, symbolFlags, symbolExcludes) {
            // Just call this directly so that the return type of this function stays "void".
            return 🔶<i><b title="Did not inline: target text too big">declareSymbolAndAddToSymbolTableWorker</b></i>(node, symbolFlags, symbolExcludes);
        }</pre>



### bindEachChild:
<pre class="code">
(node) {
            ts.🔶<i><b title="Did not inline: unknown">forEachChild</b></i>(node, bind, bindEach);
        }</pre>



### bindWorker:
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(node) {
            switch (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i>) {
                /* Strict mode checks */
                case 70 /* Identifier */:
                    // for typedef type names with namespaces, bind the new jsdoc type symbol here
                    // because it requires all containing namespaces to be in effect, namely the
                    // current "blockScopeContainer" needs to be set to its immediate namespace parent.
                    if (node.isInJSDocNamespace) {
                        var parentNode = node⚠️<i><b title="LoadNamedGeneric">.parent</b></i>;
                        while (parentNode && parentNode⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">!== 285</b></i> /* JSDocTypedefTag */) {
                            parentNode = parentNode⚠️<i><b title="LoadNamedGeneric">.parent</b></i>;
                        }
                        🔶<i><b title="Did not inline: target text too big">bindBlockScopedDeclaration</b></i>(parentNode, 524288 /* TypeAlias */, 793064 /* TypeAliasExcludes */);
                        break;
                    }
                case 98 /* ThisKeyword */:
                    if (currentFlow && (ts.⚠️<i><b title="LoadNamedGeneric">isExpression</b></i>(node) || parent⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 258</b></i> /* ShorthandPropertyAssignment */)) {
                        node.flowNode ⚠️<i><b title="StoreNamedGeneric">= currentFlow</b></i>;
                    }
                    return 🔶<i><b title="Did not inline: target text too big">checkStrictModeIdentifier</b></i>(node);
                case 177 /* PropertyAccessExpression */:
                    if (currentFlow && <b title="Inlined">🔷isNarrowableReference</b>(node)) {
                        node.flowNode = currentFlow;
                    }
                    break;
                case 192 /* BinaryExpression */:
                    if (ts.🔶<i><b title="Did not inline: unknown">isInJavaScriptFile</b></i>(node)) {
                        var specialKind = ts.🔶️<i><b title="CallWithDescriptor">getSpecialPropertyAssignmentKind</b></i>(node);
                        ⚠️<i><b title="CompareGeneric">switch</b></i> (specialKind) {
                            case 1 /* ExportsProperty */:
                                🔶️<i><b title="CallWithDescriptor">bindExportsPropertyAssignment</b></i>(node);
                                break;
                            case 2 /* ModuleExports */:
                                🔶️<i><b title="CallWithDescriptor">bindModuleExportsAssignment</b></i>(node);
                                break;
                            case 3 /* PrototypeProperty */:
                                🔶️<i><b title="CallWithDescriptor">bindPrototypePropertyAssignment</b></i>(node);
                                break;
                            case 4 /* ThisProperty */:
                                🔶️<i><b title="CallWithDescriptor">bindThisPropertyAssignment</b></i>(node);
                                break;
                            case 0 /* None */:
                                // Nothing to do
                                break;
                            default:
                                ts⚠️<i><b title="LoadNamedGeneric">.Debug</b></i>.🔶️<i><b title="CallWithDescriptor">fail</b></i>("Unknown special property assignment kind");
                        }
                    }
                    return 🔶️<i><b title="CallWithDescriptor">checkStrictModeBinaryExpression</b></i>(node);
                case 256 /* CatchClause */:
                    return 🔶️<i><b title="CallWithDescriptor">checkStrictModeCatchClause</b></i>(node);
                case 186 /* DeleteExpression */:
                    return 🔶️<i><b title="CallWithDescriptor">checkStrictModeDeleteExpression</b></i>(node);
                case 8 /* NumericLiteral */:
                    return 🔶️<i><b title="CallWithDescriptor">checkStrictModeNumericLiteral</b></i>(node);
                case 191 /* PostfixUnaryExpression */:
                    return 🔶️<i><b title="CallWithDescriptor">checkStrictModePostfixUnaryExpression</b></i>(node);
                case 190 /* PrefixUnaryExpression */:
                    return 🔶️<i><b title="CallWithDescriptor">checkStrictModePrefixUnaryExpression</b></i>(node);
                case 217 /* WithStatement */:
                    return 🔶️<i><b title="CallWithDescriptor">checkStrictModeWithStatement</b></i>(node);
                case 167 /* ThisType */:
                    seenThisKeyword = true;
                    return;
                case 156 /* TypePredicate */:
                    return <b title="Inlined">🔷checkTypePredicate</b>(node);
                case 143 /* TypeParameter */:
                    return <b title="Inlined">🔷declareSymbolAndAddToSymbolTable</b>(node, 262144 /* TypeParameter */, 530920 /* TypeParameterExcludes */);
                case 144 /* Parameter */:
                    return 🔶<i><b title="Did not inline: target text too big">bindParameter</b></i>(node);
                case 223 /* VariableDeclaration */:
                case 174 /* BindingElement */:
                    return 🔶<i><b title="Did not inline: target text too big">bindVariableDeclarationOrBindingElement</b></i>(node);
                case 147 /* PropertyDeclaration */:
                case 146 /* PropertySignature */:
                case 271 /* JSDocRecordMember */:
                    return 🔶<i><b title="Did not inline: target text too big">bindPropertyOrMethodOrAccessor</b></i>(node, 4 /* Property */ | (node.questionToken ? 536870912 /* Optional */ : 0 /* None */), 0 /* PropertyExcludes */);
                case 286 /* JSDocPropertyTag */:
                    return 🔶️<i><b title="CallWithDescriptor">bindJSDocProperty</b></i>(node);
                case 257 /* PropertyAssignment */:
                case 258 /* ShorthandPropertyAssignment */:
                    return 🔶<i><b title="Did not inline: target text too big">bindPropertyOrMethodOrAccessor</b></i>(node, 4 /* Property */, 0 /* PropertyExcludes */);
                case 260 /* EnumMember */:
                    return 🔶<i><b title="Did not inline: target text too big">bindPropertyOrMethodOrAccessor</b></i>(node, 8 /* EnumMember */, 900095 /* EnumMemberExcludes */);
                case 259 /* SpreadAssignment */:
                case 251 /* JsxSpreadAttribute */:
                    var root = container;
                    var hasRest = false;
                    while (root⚠️<i><b title="LoadNamedGeneric">.parent</b></i>) {
                        if (root⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 176</b></i> /* ObjectLiteralExpression */ &&
                            root⚠️<i><b title="LoadNamedGeneric">.parent</b></i>⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 192</b></i> /* BinaryExpression */ &&
                            root⚠️<i><b title="LoadNamedGeneric">.parent</b></i>⚠️<i><b title="LoadNamedGeneric">.operatorToken</b></i>⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 57</b></i> /* EqualsToken */ &&
                            root⚠️<i><b title="LoadNamedGeneric">.parent</b></i>⚠️<i><b title="LoadNamedGeneric">.left</b></i> ⚠️<i><b title="CompareGeneric">=== root</b></i>) {
                            hasRest = true;
                            break;
                        }
                        root = root⚠️<i><b title="LoadNamedGeneric">.parent</b></i>;
                    }
                    return;
                case 153 /* CallSignature */:
                case 154 /* ConstructSignature */:
                case 155 /* IndexSignature */:
                    return <b title="Inlined">🔷declareSymbolAndAddToSymbolTable</b>(node, 131072 /* Signature */, 0 /* None */);
                case 149 /* MethodDeclaration */:
                case 148 /* MethodSignature */:
                    // If this is an ObjectLiteralExpression method, then it sits in the same space
                    // as other properties in the object literal.  So we use SymbolFlags.PropertyExcludes
                    // so that it will conflict with any other object literal members with the same
                    // name.
                    return 🔶<i><b title="Did not inline: target text too big">bindPropertyOrMethodOrAccessor</b></i>(node, 8192 /* Method */ | (node.questionToken ? 536870912 /* Optional */ : 0 /* None */), ts.🔶<i><b title="Did not inline: unknown">isObjectLiteralMethod</b></i>(node) ? 0 /* PropertyExcludes */ : 99263 /* MethodExcludes */);
                case 225 /* FunctionDeclaration */:
                    return 🔶<i><b title="Did not inline: target text too big">bindFunctionDeclaration</b></i>(node);
                case 150 /* Constructor */:
                    return <b title="Inlined">🔷declareSymbolAndAddToSymbolTable</b>(node, 16384 /* Constructor */, /*symbolExcludes:*/ 0 /* None */);
                case 151 /* GetAccessor */:
                    return 🔶<i><b title="Did not inline: target text too big">bindPropertyOrMethodOrAccessor</b></i>(node, 32768 /* GetAccessor */, 41919 /* GetAccessorExcludes */);
                case 152 /* SetAccessor */:
                    return 🔶<i><b title="Did not inline: target text too big">bindPropertyOrMethodOrAccessor</b></i>(node, 65536 /* SetAccessor */, 74687 /* SetAccessorExcludes */);
                case 158 /* FunctionType */:
                case 159 /* ConstructorType */:
                case 274 /* JSDocFunctionType */:
                    return 🔶<i><b title="Did not inline: target text too big">bindFunctionOrConstructorType</b></i>(node);
                case 161 /* TypeLiteral */:
                case 170 /* MappedType */:
                case 287 /* JSDocTypeLiteral */:
                case 270 /* JSDocRecordType */:
                    return <b title="Inlined">🔷bindAnonymousDeclaration</b>(node, 2048 /* TypeLiteral */, "__type");
                case 176 /* ObjectLiteralExpression */:
                    return 🔶️<i><b title="CallWithDescriptor">bindObjectLiteralExpression</b></i>(node);
                case 184 /* FunctionExpression */:
                case 185 /* ArrowFunction */:
                    return 🔶️<i><b title="CallWithDescriptor">bindFunctionExpression</b></i>(node);
                case 179 /* CallExpression */:
                    if (ts.🔶<i><b title="Did not inline: unknown">isInJavaScriptFile</b></i>(node)) {
                        🔶️<i><b title="CallWithDescriptor">bindCallExpression</b></i>(node);
                    }
                    break;
                // Members of classes, interfaces, and modules
                case 197 /* ClassExpression */:
                case 226 /* ClassDeclaration */:
                    // All classes are automatically in strict mode in ES6.
                    inStrictMode = true;
                    return 🔶️<i><b title="CallWithDescriptor">bindClassLikeDeclaration</b></i>(node);
                case 227 /* InterfaceDeclaration */:
                    return 🔶<i><b title="Did not inline: target text too big">bindBlockScopedDeclaration</b></i>(node, 64 /* Interface */, 792968 /* InterfaceExcludes */);
                case 285 /* JSDocTypedefTag */:
                    if (!node⚠️<i><b title="LoadNamedGeneric">.fullName</b></i> || node⚠️<i><b title="LoadNamedGeneric">.fullName</b></i>⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 70</b></i> /* Identifier */) {
                        return 🔶<i><b title="Did not inline: target text too big">bindBlockScopedDeclaration</b></i>(node, 524288 /* TypeAlias */, 793064 /* TypeAliasExcludes */);
                    }
                    break;
                case 228 /* TypeAliasDeclaration */:
                    return 🔶<i><b title="Did not inline: target text too big">bindBlockScopedDeclaration</b></i>(node, 524288 /* TypeAlias */, 793064 /* TypeAliasExcludes */);
                case 229 /* EnumDeclaration */:
                    return 🔶️<i><b title="CallWithDescriptor">bindEnumDeclaration</b></i>(node);
                case 230 /* ModuleDeclaration */:
                    return 🔶️<i><b title="CallWithDescriptor">bindModuleDeclaration</b></i>(node);
                // Imports and exports
                case 234 /* ImportEqualsDeclaration */:
                case 237 /* NamespaceImport */:
                case 239 /* ImportSpecifier */:
                case 243 /* ExportSpecifier */:
                    return <b title="Inlined">🔷declareSymbolAndAddToSymbolTable</b>(node, 8388608 /* Alias */, 8388608 /* AliasExcludes */);
                case 233 /* NamespaceExportDeclaration */:
                    return 🔶️<i><b title="CallWithDescriptor">bindNamespaceExportDeclaration</b></i>(node);
                case 236 /* ImportClause */:
                    return <b title="Inlined">🔷bindImportClause</b>(node);
                case 241 /* ExportDeclaration */:
                    return <b title="Inlined">🔷bindExportDeclaration</b>(node);
                case 240 /* ExportAssignment */:
                    return 🔶️<i><b title="CallWithDescriptor">bindExportAssignment</b></i>(node);
                case 261 /* SourceFile */:
                    <b title="Inlined">🔷updateStrictModeStatementList</b>(node.statements);
                    return <b title="Inlined">🔷bindSourceFileIfExternalModule</b>();
                case 204 /* Block */:
                    if (!ts.⚠️<i><b title="LoadNamedGeneric">isFunctionLike</b></i>(node⚠️<i><b title="LoadNamedGeneric">.parent</b></i>)) {
                        return;
                    }
                // Fall through
                case 231 /* ModuleBlock */:
                    return <b title="Inlined">🔷updateStrictModeStatementList</b>(node.statements);
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>isNarrowableReference</summary>
<pre class="code">
(expr) {
            return expr.kind === 70 /* Identifier */ ||
                expr.kind === 98 /* ThisKeyword */ ||
                expr.kind === 177 /* PropertyAccessExpression */ && 🔶️<i><b title="CallWithDescriptor">isNarrowableReference</b></i>(expr.expression);
        }</pre>

</details>
<details>
<summary>checkTypePredicate</summary>
<pre class="code">
(node) {
            var parameterName = node.parameterName, type = node.type;
            if (parameterName && parameterName.kind === 70 /* Identifier */) {
                🔶<i><b title="Did not inline: target text too big">checkStrictModeIdentifier</b></i>(parameterName);
            }
            if (parameterName && parameterName.kind === 167 /* ThisType */) {
                seenThisKeyword = true;
            }
            🔶<i><b title="Did not inline: target text too big">bind</b></i>(type);
        }</pre>

</details>
<details>
<summary>declareSymbolAndAddToSymbolTable</summary>
<pre class="code">
(node, symbolFlags, symbolExcludes) {
            // Just call this directly so that the return type of this function stays "void".
            return 🔶<i><b title="Did not inline: target text too big">declareSymbolAndAddToSymbolTableWorker</b></i>(node, symbolFlags, symbolExcludes);
        }</pre>

</details>
<details>
<summary>declareSymbolAndAddToSymbolTable</summary>
<pre class="code">
(node, symbolFlags, symbolExcludes) {
            // Just call this directly so that the return type of this function stays "void".
            return 🔶<i><b title="Did not inline: target text too big">declareSymbolAndAddToSymbolTableWorker</b></i>(node, symbolFlags, symbolExcludes);
        }</pre>

</details>
<details>
<summary>declareSymbolAndAddToSymbolTable</summary>
<pre class="code">
(node, symbolFlags, symbolExcludes) {
            // Just call this directly so that the return type of this function stays "void".
            return 🔶<i><b title="Did not inline: target text too big">declareSymbolAndAddToSymbolTableWorker</b></i>(node, symbolFlags, symbolExcludes);
        }</pre>

</details>
<details>
<summary>bindAnonymousDeclaration</summary>
<pre class="code">
(node, symbolFlags, name) {
            var symbol = <b title="Inlined">🔷createSymbol</b>(symbolFlags, name);
            🔶<i><b title="Did not inline: target text too big">addDeclarationToSymbol</b></i>(symbol, node, symbolFlags);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createSymbol</summary>
<pre class="code">
(flags, name) {
            symbolCount++;
            return <b title="Inlined">🔷new Symbol</b>(flags, name);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new Symbol</summary>
<pre class="code">
(flags, name) {
            this.flags = flags;
            this.name = name;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>declareSymbolAndAddToSymbolTable</summary>
<pre class="code">
(node, symbolFlags, symbolExcludes) {
            // Just call this directly so that the return type of this function stays "void".
            return 🔶<i><b title="Did not inline: target text too big">declareSymbolAndAddToSymbolTableWorker</b></i>(node, symbolFlags, symbolExcludes);
        }</pre>

</details>
<details>
<summary>bindImportClause</summary>
<pre class="code">
(node) {
            if (node.name) {
                🔶<i><b title="Did not inline: unknown">declareSymbolAndAddToSymbolTable</b></i>(node, 8388608 /* Alias */, 8388608 /* AliasExcludes */);
            }
        }</pre>

</details>
<details>
<summary>bindExportDeclaration</summary>
<pre class="code">
(node) {
            if (!container⚠️<i><b title="LoadNamedGeneric">.symbol</b></i> || !container⚠️<i><b title="LoadNamedGeneric">.symbol</b></i>⚠️<i><b title="LoadNamedGeneric">.exports</b></i>) {
                // Export * in some sort of block construct
                🔶️<i><b title="CallWithDescriptor">bindAnonymousDeclaration</b></i>(node, 1073741824 /* ExportStar */, 🔶<i><b title="Did not inline: target text too big">getDeclarationName</b></i>(node));
            }
            else if (!node⚠️<i><b title="LoadNamedGeneric">.exportClause</b></i>) {
                // All export * declarations are collected in an __export symbol
                🔶<i><b title="Did not inline: target text too big">declareSymbol</b></i>(container⚠️<i><b title="LoadNamedGeneric">.symbol</b></i>⚠️<i><b title="LoadNamedGeneric">.exports</b></i>, container⚠️<i><b title="LoadNamedGeneric">.symbol</b></i>, node, 1073741824 /* ExportStar */, 0 /* None */);
            }
        }</pre>

</details>
<details>
<summary>updateStrictModeStatementList</summary>
<pre class="code">
(statements) {
            if (!inStrictMode) {
                for (var _i = 0, statements_2 = statements; _i &lt; statements_2.length; _i++) {
                    var statement = statements_2[_i];
                    if (!ts.🔶️<i><b title="CallWithDescriptor">isPrologueDirective</b></i>(statement)) {
                        return;
                    }
                    if (🔶️<i><b title="CallWithDescriptor">isUseStrictPrologueDirective</b></i>(statement)) {
                        inStrictMode = true;
                        return;
                    }
                }
            }
        }</pre>

</details>
<details>
<summary>bindSourceFileIfExternalModule</summary>
<pre class="code">
() {
            <b title="Inlined">🔷setExportContextFlag</b>(file);
            if (ts.🔶️<i><b title="CallWithDescriptor">isExternalModule</b></i>(file)) {
                🔶️<i><b title="CallWithDescriptor">bindSourceFileAsExternalModule</b></i>();
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>setExportContextFlag</summary>
<pre class="code">
(node) {
            // A declaration source file or ambient module declaration that contains no export declarations (but possibly regular
            // declarations with export modifiers) is an export context in which declarations are implicitly exported.
            if (ts.🔶<i><b title="Did not inline: unknown">isInAmbientContext</b></i>(node) && !<b title="Inlined">🔷hasExportDeclarations</b>(node)) {
                node.flags |= 32 /* ExportContext */;
            }
            else {
                node.flags &= ~32 /* ExportContext */;
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>hasExportDeclarations</summary>
<pre class="code">
(node) {
            var body = node.kind === 261 /* SourceFile */ ? node : node.body;
            if (body && (body.kind === 261 /* SourceFile */ || body.kind === 231 /* ModuleBlock */)) {
                for (var _i = 0, _a = body.statements; _i &lt; _a.length; _i++) {
                    var stat = _a[_i];
                    if (stat⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 241 /* ExportDeclaration */ || stat⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 240 /* ExportAssignment */) {
                        return true;
                    }
                }
            }
            return false;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>updateStrictModeStatementList</summary>
<pre class="code">
(statements) {
            if (!inStrictMode) {
                for (var _i = 0, statements_2 = statements; _i &lt; statements_2.length; _i++) {
                    var statement = statements_2[_i];
                    if (!ts.🔶️<i><b title="CallWithDescriptor">isPrologueDirective</b></i>(statement)) {
                        return;
                    }
                    if (🔶️<i><b title="CallWithDescriptor">isUseStrictPrologueDirective</b></i>(statement)) {
                        inStrictMode = true;
                        return;
                    }
                }
            }
        }</pre>

</details>
</blockquote>



### isDynamicName:
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(name) {
        return name⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 142 /* ComputedPropertyName */ &&
            !🔶️<i><b title="CallWithDescriptor">isStringOrNumericLiteral</b></i>(name⚠️<i><b title="LoadNamedGeneric">.expression</b></i>) &&
            !🔶️<i><b title="CallWithDescriptor">isWellKnownSymbolSyntactically</b></i>(name⚠️<i><b title="LoadNamedGeneric">.expression</b></i>);
    }</pre>



### isBindingPattern:
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(node) {
        if (node) {
            var kind = node⚠️<i><b title="LoadNamedGeneric">.kind</b></i>;
            return kind === 173 /* ArrayBindingPattern */
                || kind === 172 /* ObjectBindingPattern */;
        }
        return false;
    }</pre>



### bindPropertyOrMethodOrAccessor:
<pre class="code">
(node, symbolFlags, symbolExcludes) {
            if (!ts.🔶️<i><b title="CallWithDescriptor">isDeclarationFile</b></i>(file) && !ts.🔶<i><b title="Did not inline: unknown">isInAmbientContext</b></i>(node)) {
                if (ts.🔶<i><b title="Did not inline: unknown">isAsyncFunctionLike</b></i>(node)) {
                    emitFlags |⚠️<i><b title="Bitwise">= 1024</b></i> /* HasAsyncFunctions */;
                }
            }
            if (currentFlow && ts.🔶<i><b title="Did not inline: unknown">isObjectLiteralOrClassExpressionMethod</b></i>(node)) {
                node.flowNode ⚠️<i><b title="StoreNamedGeneric">= currentFlow</b></i>;
            }
            return ts.🔶<i><b title="Did not inline: unknown">hasDynamicName</b></i>(node)
                ? 🔶️<i><b title="CallWithDescriptor">bindAnonymousDeclaration</b></i>(node, symbolFlags, "__computed")
                : <b title="Inlined">🔷declareSymbolAndAddToSymbolTable</b>(node, symbolFlags, symbolExcludes);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>declareSymbolAndAddToSymbolTable</summary>
<pre class="code">
(node, symbolFlags, symbolExcludes) {
            // Just call this directly so that the return type of this function stays "void".
            return 🔶<i><b title="Did not inline: target text too big">declareSymbolAndAddToSymbolTableWorker</b></i>(node, symbolFlags, symbolExcludes);
        }</pre>

</details>
</blockquote>



### isObjectLiteralOrClassExpressionMethod:
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(node) {
        return node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 149 /* MethodDeclaration */ &&
            (node.parent.kind === 176 /* ObjectLiteralExpression */ ||
                node.parent.kind === 197 /* ClassExpression */);
    }</pre>



### ⛔ getContainerFlags (deoptimizated):
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(node) {
            switch (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i>) {
                case 197 /* ClassExpression */:
                case 226 /* ClassDeclaration */:
                case 229 /* EnumDeclaration */:
                case 176 /* ObjectLiteralExpression */:
                case 161 /* TypeLiteral */:
                case 287 /* JSDocTypeLiteral */:
                case 270 /* JSDocRecordType */:
                    return 1 /* IsContainer */;
                case 227 /* InterfaceDeclaration */:
                    return 1 /* IsContainer */ | 64 /* IsInterface */;
                case 274 /* JSDocFunctionType */:
                case 230 /* ModuleDeclaration */:
                case 228 /* TypeAliasDeclaration */:
                case 170 /* MappedType */:
                    return 1 /* IsContainer */ | 32 /* HasLocals */;
                case 261 /* SourceFile */:
                    return 1 /* IsContainer */ | 4 /* IsControlFlowContainer */ | 32 /* HasLocals */;
                case 149 /* MethodDeclaration */:
                    if (ts.🔶<i><b title="Did not inline: unknown">isObjectLiteralOrClassExpressionMethod</b></i>(node)) {
                        return 1 /* IsContainer */ | 4 /* IsControlFlowContainer */ | 32 /* HasLocals */ | 8 /* IsFunctionLike */ | 128 /* IsObjectLiteralOrClassExpressionMethod */;
                    }
                case 150 /* Constructor */:
                case 225 /* FunctionDeclaration */:
                case 148 /* MethodSignature */:
                case 151 /* GetAccessor */:
                case 152 /* SetAccessor */:
                case 153 /* CallSignature */:
                case 154 /* ConstructSignature */:
                case 155 /* IndexSignature */:
                case 158 /* FunctionType */:
                case 159 /* ConstructorType */:
                    return 1 /* IsContainer */ | 4 /* IsControlFlowContainer */ | 32 /* HasLocals */ | 8 /* IsFunctionLike */;
                case 184 /* FunctionExpression */:
                case 185 /* ArrowFunction */:
                    return 1 /* IsContainer */ | 4 /* IsControlFlowContainer */ | 32 /* HasLocals */ | 8 /* IsFunctionLike */ | 16 /* IsFunctionExpression */;
                case 231 /* ModuleBlock */:
                    return 4 /* IsControlFlowContainer */;
                case 147 /* PropertyDeclaration */:
                    return node.initializer ? 4 /* IsControlFlowContainer */ : 0;
                case 256 /* CatchClause */:
                case 211 /* ForStatement */:
                case 212 /* ForInStatement */:
                case 213 /* ForOfStatement */:
                case 232 /* CaseBlock */:
                    return 2 /* IsBlockScopedContainer */;
                case 204 /* Block */:
                    // do not treat blocks directly inside a function as a block-scoped-container.
                    // Locals that reside in this block should go to the function locals. Otherwise 'x'
                    // would not appear to be a redeclaration of a block scoped local in the following
                    // example:
                    //
                    //      function foo() {
                    //          var x;
                    //          let x;
                    //      }
                    //
                    // If we placed 'var x' into the function locals and 'let x' into the locals of
                    // the block, then there would be no collision.
                    //
                    // By not creating a new block-scoped-container here, we ensure that both 'var x'
                    // and 'let x' go into the Function-container's locals, and we do get a collision
                    // conflict.
                    return ts.🔶️<i><b title="CallWithDescriptor">isFunctionLike</b></i>(node⚠️<i><b title="LoadNamedGeneric">.parent</b></i>) ? 0 /* None */ : 2 /* IsBlockScopedContainer */;
            }
            return 0 /* None */;
        }</pre>

```diff
- Deopt: <JS Function isObjectLiteralMethod (SharedFunctionInfo 0x3504a53cf059)> (opt #265) @6, FP to SP delta: 24, caller sp: 0x7fff5fbfc848
```

```diff
- Deopt: <JS Function isObjectLiteralOrClassExpressionMethod (SharedFunctionInfo 0x3504a53cf119)> (opt #263) @4, FP to SP delta: 24, caller sp: 0x7fff5fbfc7d0
```

```diff
- Deopt: <JS Function declareSymbolAndAddToSymbolTableWorker (SharedFunctionInfo 0x16f3adb5ab21)> (opt #270) @17, FP to SP delta: 64, caller sp: 0x7fff5fbfc7d0
```



### bindChildrenWorker:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(node) {
            // Binding of JsDocComment should be done before the current block scope container changes.
            // because the scope of JsDocComment should not be affected by whether the current node is a
            // container or not.
            if (ts.🔶<i><b title="Did not inline: unknown">isInJavaScriptFile</b></i>(node) && node⚠️<i><b title="LoadNamedGeneric">.jsDoc</b></i>) {
                ts.🔶<i><b title="Did not inline: unknown">forEach</b></i>(node⚠️<i><b title="LoadNamedGeneric">.jsDoc</b></i>, bind);
            }
            if (🔶<i><b title="Did not inline: target text too big">checkUnreachable</b></i>(node)) {
                🔶<i><b title="Did not inline: unknown">bindEachChild</b></i>(node);
                return;
            }
            switch (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i>) {
                case 210 /* WhileStatement */:
                    🔶️<i><b title="CallWithDescriptor">bindWhileStatement</b></i>(node);
                    break;
                case 209 /* DoStatement */:
                    🔶️<i><b title="CallWithDescriptor">bindDoStatement</b></i>(node);
                    break;
                case 211 /* ForStatement */:
                    🔶️<i><b title="CallWithDescriptor">bindForStatement</b></i>(node);
                    break;
                case 212 /* ForInStatement */:
                case 213 /* ForOfStatement */:
                    🔶️<i><b title="CallWithDescriptor">bindForInOrForOfStatement</b></i>(node);
                    break;
                case 208 /* IfStatement */:
                    🔶️<i><b title="CallWithDescriptor">bindIfStatement</b></i>(node);
                    break;
                case 216 /* ReturnStatement */:
                case 220 /* ThrowStatement */:
                    🔶️<i><b title="CallWithDescriptor">bindReturnOrThrow</b></i>(node);
                    break;
                case 215 /* BreakStatement */:
                case 214 /* ContinueStatement */:
                    🔶️<i><b title="CallWithDescriptor">bindBreakOrContinueStatement</b></i>(node);
                    break;
                case 221 /* TryStatement */:
                    🔶️<i><b title="CallWithDescriptor">bindTryStatement</b></i>(node);
                    break;
                case 218 /* SwitchStatement */:
                    🔶️<i><b title="CallWithDescriptor">bindSwitchStatement</b></i>(node);
                    break;
                case 232 /* CaseBlock */:
                    🔶️<i><b title="CallWithDescriptor">bindCaseBlock</b></i>(node);
                    break;
                case 253 /* CaseClause */:
                    🔶️<i><b title="CallWithDescriptor">bindCaseClause</b></i>(node);
                    break;
                case 219 /* LabeledStatement */:
                    🔶️<i><b title="CallWithDescriptor">bindLabeledStatement</b></i>(node);
                    break;
                case 190 /* PrefixUnaryExpression */:
                    🔶️<i><b title="CallWithDescriptor">bindPrefixUnaryExpressionFlow</b></i>(node);
                    break;
                case 191 /* PostfixUnaryExpression */:
                    🔶️<i><b title="CallWithDescriptor">bindPostfixUnaryExpressionFlow</b></i>(node);
                    break;
                case 192 /* BinaryExpression */:
                    🔶️<i><b title="CallWithDescriptor">bindBinaryExpressionFlow</b></i>(node);
                    break;
                case 186 /* DeleteExpression */:
                    🔶️<i><b title="CallWithDescriptor">bindDeleteExpressionFlow</b></i>(node);
                    break;
                case 193 /* ConditionalExpression */:
                    🔶️<i><b title="CallWithDescriptor">bindConditionalExpressionFlow</b></i>(node);
                    break;
                case 223 /* VariableDeclaration */:
                    <b title="Inlined">🔷bindVariableDeclarationFlow</b>(node);
                    break;
                case 179 /* CallExpression */:
                    🔶️<i><b title="CallWithDescriptor">bindCallExpressionFlow</b></i>(node);
                    break;
                default:
                    <b title="Inlined">🔷bindEachChild</b>(node);
                    break;
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>bindVariableDeclarationFlow</summary>
<pre class="code">
(node) {
            <b title="Inlined">🔷bindEachChild</b>(node);
            if (node.initializer || node.parent.parent.kind === 212 /* ForInStatement */ || node.parent.parent.kind === 213 /* ForOfStatement */) {
                🔶️<i><b title="CallWithDescriptor">bindInitializedVariableFlow</b></i>(node);
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>bindEachChild</summary>
<pre class="code">
(node) {
            ts.🔶<i><b title="Did not inline: unknown">forEachChild</b></i>(node, bind, bindEach);
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>bindEachChild</summary>
<pre class="code">
(node) {
            ts.🔶<i><b title="Did not inline: unknown">forEachChild</b></i>(node, bind, bindEach);
        }</pre>

</details>
</blockquote>



### nodeIsPresent:
<pre class="code">
(node) {
        return !<b title="Inlined">🔷nodeIsMissing</b>(node);
    }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>nodeIsMissing</summary>
<pre class="code">
(node) {
        if (node === undefined) {
            return true;
        }
        return node⚠️<i><b title="LoadNamedGeneric">.pos</b></i> ⚠️<i><b title="CompareGeneric">=== node</b></i>⚠️<i><b title="LoadNamedGeneric">.end</b></i> && node⚠️<i><b title="LoadNamedGeneric">.pos</b></i> ⚠️<i><b title="CompareGeneric">>= 0</b></i> && node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">!== 1</b></i> /* EndOfFileToken */;
    }</pre>

</details>
</blockquote>



### isParameterPropertyDeclaration:
<pre class="code">
(node) {
        return ts.🔶<i><b title="Did not inline: unknown">hasModifier</b></i>(node, 92 /* ParameterPropertyModifier */) && node⚠️<i><b title="LoadNamedGeneric">.parent</b></i>⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 150</b></i> /* Constructor */ && ts.🔶<i><b title="Did not inline: unknown">isClassLike</b></i>(node⚠️<i><b title="LoadNamedGeneric">.parent</b></i>⚠️<i><b title="LoadNamedGeneric">.parent</b></i>);
    }</pre>



### ⛔ addDeclarationToSymbol (deoptimizated):
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

```diff
- Deopt: <JS Function getDeclarationName (SharedFunctionInfo 0x16f3adb57ee1)> (opt #248) @18, FP to SP delta: 40, caller sp: 0x7fff5fbfd838
```

```diff
- Deopt: <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> (opt #253) @65, FP to SP delta: 760, caller sp: 0x7fff5fbfcfb8
```

```diff
- Deopt: <JS Function isBindingPattern (SharedFunctionInfo 0x3504a53d8899)> (opt #230) @3, FP to SP delta: 24, caller sp: 0x7fff5fbfc9a8
```

```diff
- Deopt: <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> (opt #253) @199, FP to SP delta: 760, caller sp: 0x7fff5fbfd4f8
```

```diff
- Deopt: <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> (opt #253) @84, FP to SP delta: 760, caller sp: 0x7fff5fbfd9d0
```

```diff
- Deopt: <JS Function bindWorker (SharedFunctionInfo 0x16f3adb5c261)> (opt #251) @131, FP to SP delta: 248, caller sp: 0x7fff5fbfcee8
```

```diff
- Deopt: <JS Function addDeclarationToSymbol (SharedFunctionInfo 0x16f3adb57e21)> (opt #255) @16, FP to SP delta: 56, caller sp: 0x7fff5fbfd370
```

```diff
- Deopt: <JS Function declareSymbolAndAddToSymbolTableWorker (SharedFunctionInfo 0x16f3adb5ab21)> (opt #254) @21, FP to SP delta: 64, caller sp: 0x7fff5fbfccf8
```

```diff
- Deopt: <JS Function getContainerFlags (SharedFunctionInfo 0x16f3adb5a8e1)> (opt #205) @4, FP to SP delta: 40, caller sp: 0x7fff5fbfcdd8
```

```diff
- Deopt: <JS Function isObjectLiteralOrClassExpressionMethod (SharedFunctionInfo 0x3504a53cf119)> (opt #252) @3, FP to SP delta: 24, caller sp: 0x7fff5fbfd208
```

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(symbol, node, symbolFlags) {
            symbol.flags ⚠️<i><b title="StoreNamedGeneric">|= symbolFlags</b></i>;
            node.symbol ⚠️<i><b title="StoreNamedGeneric">= symbol</b></i>;
            if (!symbol⚠️<i><b title="LoadNamedGeneric">.declarations</b></i>) {
                symbol.declarations = [];
            }
            symbol.declarations.push(node);
            if (symbolFlags & 1952 /* HasExports */ && !symbol.exports) {
                symbol.exports ⚠️<i><b title="StoreNamedGeneric">= ts</b></i>.🔶<i><b title="Did not inline: unknown">createMap</b></i>();
            }
            if (symbolFlags & 6240 /* HasMembers */ && !symbol⚠️<i><b title="LoadNamedGeneric">.members</b></i>) {
                symbol.members ⚠️<i><b title="StoreNamedGeneric">= ts</b></i>.🔶<i><b title="Did not inline: unknown">createMap</b></i>();
            }
            if (symbolFlags & 107455 /* Value */) {
                var valueDeclaration = symbol⚠️<i><b title="LoadNamedGeneric">.valueDeclaration</b></i>;
                if (!valueDeclaration ||
                    (valueDeclaration⚠️<i><b title="LoadNamedGeneric">.kind</b></i> !== node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> && valueDeclaration.kind === 230 /* ModuleDeclaration */)) {
                    // other kinds of value declarations take precedence over modules
                    symbol.valueDeclaration ⚠️<i><b title="StoreNamedGeneric">= node</b></i>;
                }
            }
        }</pre>

```diff
- Deopt: <JS Function getCombinedNodeFlags (SharedFunctionInfo 0x3504a53df441)> (opt #284) @9, FP to SP delta: 48, caller sp: 0x7fff5fbfcdf8
```

```diff
- Deopt: <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> (opt #276) @131, FP to SP delta: 776, caller sp: 0x7fff5fbfce38
```

```diff
- Deopt: <JS Function declareSymbolAndAddToSymbolTableWorker (SharedFunctionInfo 0x16f3adb5ab21)> (opt #281) @11, FP to SP delta: 64, caller sp: 0x7fff5fbfcaa8
```

```diff
- Deopt: <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> (opt #276) @241, FP to SP delta: 776, caller sp: 0x7fff5fbfd458
```

```diff
- Deopt: <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> (opt #276) @129, FP to SP delta: 776, caller sp: 0x7fff5fbfd988
```



### declareSymbol:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(symbolTable, parent, node, includes, excludes) {
            ts⚠️<i><b title="LoadNamedGeneric">.Debug</b></i>.🔶️<i><b title="CallWithDescriptor">assert</b></i>(!ts.⚠️<i><b title="LoadNamedGeneric">hasDynamicName</b></i>(node));
            var isDefaultExport = ts.🔶<i><b title="Did not inline: unknown">hasModifier</b></i>(node, 512 /* Default */);
            // The exported symbol for an export default function/class node is always named "default"
            var name = isDefaultExport && parent ? "default" : 🔶<i><b title="Did not inline: target text too big">getDeclarationName</b></i>(node);
            var symbol;
            if (name === undefined) {
                symbol = 🔶<i><b title="Did not inline: unknown">createSymbol</b></i>(0 /* None */, "__missing");
            }
            else {
                // Check and see if the symbol table already has a symbol with this name.  If not,
                // create a new symbol with this name and add it to the table.  Note that we don't
                // give the new symbol any flags *yet*.  This ensures that it will not conflict
                // with the 'excludes' flags we pass in.
                //
                // If we do get an existing symbol, see if it conflicts with the new symbol we're
                // creating.  For example, a 'var' symbol and a 'class' symbol will conflict within
                // the same symbol table.  If we have a conflict, report the issue on each
                // declaration we have for this symbol, and then create a new symbol for this
                // declaration.
                //
                // Note that when properties declared in Javascript constructors
                // (marked by isReplaceableByMethod) conflict with another symbol, the property loses.
                // Always. This allows the common Javascript pattern of overwriting a prototype method
                // with an bound instance method of the same type: `this.method = this.method.bind(this)`
                //
                // If we created a new symbol, either because we didn't have a symbol with this name
                // in the symbol table, or we conflicted with an existing symbol, then just add this
                // node as the sole declaration of the new symbol.
                //
                // Otherwise, we'll be merging into a compatible existing symbol (for example when
                // you have multiple 'vars' with the same name in the same container).  In this case
                // just add this node into the declarations list of the symbol.
                symbol = symbolTable⚠️<i><b title="LoadKeyedGeneric">[name]</b></i> || (symbolTable[name] ⚠️<i><b title="StoreKeyedGeneric">= createSymbol</b></i>(0 /* None */, name));
                if (name && (includes & 788448 /* Classifiable */)) {
                    classifiableNames[name] ⚠️<i><b title="StoreKeyedGeneric">= name</b></i>;
                }
                if (symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & excludes) {
                    if (symbol⚠️<i><b title="LoadNamedGeneric">.isReplaceableByMethod</b></i>) {
                        // Javascript constructor-declared symbols can be discarded in favor of
                        // prototype symbols like methods.
                        symbol = symbolTable[name] ⚠️<i><b title="StoreKeyedGeneric">= createSymbol</b></i>(0 /* None */, name);
                    }
                    else {
                        if (node⚠️<i><b title="LoadNamedGeneric">.name</b></i>) {
                            node⚠️<i><b title="LoadNamedGeneric">.name</b></i>.parent ⚠️<i><b title="StoreNamedGeneric">= node</b></i>;
                        }
                        // Report errors every position with duplicate declaration
                        // Report errors on previous encountered declarations
                        var message_1 = symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> ⚠️<i><b title="Bitwise">& 2</b></i> /* BlockScopedVariable */
                            ? ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Cannot_redeclare_block_scoped_variable_0</b></i>
                            : ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Duplicate_identifier_0</b></i>;
                        if (symbol⚠️<i><b title="LoadNamedGeneric">.declarations</b></i> && symbol⚠️<i><b title="LoadNamedGeneric">.declarations</b></i>⚠️<i><b title="LoadNamedGeneric">.length</b></i>) {
                            // If the current node is a default export of some sort, then check if
                            // there are any other default exports that we need to error on.
                            // We'll know whether we have other default exports depending on if `symbol` already has a declaration list set.
                            if (isDefaultExport) {
                                message_1 = ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.A_module_cannot_have_multiple_default_exports</b></i>;
                            }
                            else {
                                // This is to properly report an error in the case "export default { }" is after export default of class declaration or function declaration.
                                // Error on multiple export default in the following case:
                                // 1. multiple export default of class declaration or function declaration by checking NodeFlags.Default
                                // 2. multiple export default of export assignment. This one doesn't have NodeFlags.Default on (as export default doesn't considered as modifiers)
                                if (symbol⚠️<i><b title="LoadNamedGeneric">.declarations</b></i> && symbol⚠️<i><b title="LoadNamedGeneric">.declarations</b></i>⚠️<i><b title="LoadNamedGeneric">.length</b></i> &&
                                    (isDefaultExport || (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 240</b></i> /* ExportAssignment */ && !node⚠️<i><b title="LoadNamedGeneric">.isExportEquals</b></i>))) {
                                    message_1 = ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.A_module_cannot_have_multiple_default_exports</b></i>;
                                }
                            }
                        }
                        ts.⚠️<i><b title="LoadNamedGeneric">forEach</b></i>(symbol⚠️<i><b title="LoadNamedGeneric">.declarations</b></i>, 🔶️<i><b title="CallWithDescriptor">function</b></i> (declaration) {
                            file.bindDiagnostics.push(ts.createDiagnosticForNode(declaration.name || declaration, message_1, getDisplayName(declaration)));
                        });
                        file⚠️<i><b title="LoadNamedGeneric">.bindDiagnostics</b></i>.⚠️<i><b title="LoadNamedGeneric">push</b></i>(ts.🔶️<i><b title="CallWithDescriptor">createDiagnosticForNode</b></i>(node⚠️<i><b title="LoadNamedGeneric">.name</b></i> || node, message_1, 🔶️<i><b title="CallWithDescriptor">getDisplayName</b></i>(node)));
                        symbol = 🔶<i><b title="Did not inline: unknown">createSymbol</b></i>(0 /* None */, name);
                    }
                }
            }
            🔶<i><b title="Did not inline: target text too big">addDeclarationToSymbol</b></i>(symbol, node, includes);
            symbol.parent ⚠️<i><b title="StoreNamedGeneric">= parent</b></i>;
            return symbol;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createSymbol</summary>
<pre class="code">
(flags, name) {
            symbolCount++;
            return <b title="Inlined">🔷new Symbol</b>(flags, name);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new Symbol</summary>
<pre class="code">
(flags, name) {
            this.flags = flags;
            this.name = name;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### declareSymbolAndAddToSymbolTableWorker:
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(node, symbolFlags, symbolExcludes) {
            switch (container⚠️<i><b title="LoadNamedGeneric">.kind</b></i>) {
                // Modules, source files, and classes need specialized handling for how their
                // members are declared (for example, a member of a class will go into a specific
                // symbol table depending on if it is static or not). We defer to specialized
                // handlers to take care of declaring these child members.
                case 230 /* ModuleDeclaration */:
                    return 🔶<i><b title="Did not inline: target text too big">declareModuleMember</b></i>(node, symbolFlags, symbolExcludes);
                case 261 /* SourceFile */:
                    return <b title="Inlined">🔷declareSourceFileMember</b>(node, symbolFlags, symbolExcludes);
                case 197 /* ClassExpression */:
                case 226 /* ClassDeclaration */:
                    return <b title="Inlined">🔷declareClassMember</b>(node, symbolFlags, symbolExcludes);
                case 229 /* EnumDeclaration */:
                    return 🔶<i><b title="Did not inline: target text too big">declareSymbol</b></i>(container⚠️<i><b title="LoadNamedGeneric">.symbol</b></i>⚠️<i><b title="LoadNamedGeneric">.exports</b></i>, container⚠️<i><b title="LoadNamedGeneric">.symbol</b></i>, node, symbolFlags, symbolExcludes);
                case 161 /* TypeLiteral */:
                case 176 /* ObjectLiteralExpression */:
                case 227 /* InterfaceDeclaration */:
                case 270 /* JSDocRecordType */:
                case 287 /* JSDocTypeLiteral */:
                    // Interface/Object-types always have their children added to the 'members' of
                    // their container. They are only accessible through an instance of their
                    // container, and are never in scope otherwise (even inside the body of the
                    // object / type / interface declaring them). An exception is type parameters,
                    // which are in scope without qualification (similar to 'locals').
                    return 🔶<i><b title="Did not inline: target text too big">declareSymbol</b></i>(container.symbol.members, container⚠️<i><b title="LoadNamedGeneric">.symbol</b></i>, node, symbolFlags, symbolExcludes);
                case 158 /* FunctionType */:
                case 159 /* ConstructorType */:
                case 153 /* CallSignature */:
                case 154 /* ConstructSignature */:
                case 155 /* IndexSignature */:
                case 149 /* MethodDeclaration */:
                case 148 /* MethodSignature */:
                case 150 /* Constructor */:
                case 151 /* GetAccessor */:
                case 152 /* SetAccessor */:
                case 225 /* FunctionDeclaration */:
                case 184 /* FunctionExpression */:
                case 185 /* ArrowFunction */:
                case 274 /* JSDocFunctionType */:
                case 228 /* TypeAliasDeclaration */:
                case 170 /* MappedType */:
                    // All the children of these container types are never visible through another
                    // symbol (i.e. through another symbol's 'exports' or 'members').  Instead,
                    // they're only accessed 'lexically' (i.e. from code that exists underneath
                    // their container in the tree.  To accomplish this, we simply add their declared
                    // symbol to the 'locals' of the container.  These symbols can then be found as
                    // the type checker walks up the containers, checking them for matching names.
                    return 🔶<i><b title="Did not inline: target text too big">declareSymbol</b></i>(container⚠️<i><b title="LoadNamedGeneric">.locals</b></i>, /*parent*/ undefined, node, symbolFlags, symbolExcludes);
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>declareSourceFileMember</summary>
<pre class="code">
(node, symbolFlags, symbolExcludes) {
            return ts.🔶️<i><b title="CallWithDescriptor">isExternalModule</b></i>(file)
                ? 🔶<i><b title="Did not inline: target text too big">declareModuleMember</b></i>(node, symbolFlags, symbolExcludes)
                : 🔶<i><b title="Did not inline: target text too big">declareSymbol</b></i>(file.locals, undefined, node, symbolFlags, symbolExcludes);
        }</pre>

</details>
<details>
<summary>declareClassMember</summary>
<pre class="code">
(node, symbolFlags, symbolExcludes) {
            return ts.🔶<i><b title="Did not inline: unknown">hasModifier</b></i>(node, 32 /* Static */)
                ? 🔶<i><b title="Did not inline: target text too big">declareSymbol</b></i>(container.symbol.exports, container.symbol, node, symbolFlags, symbolExcludes)
                : 🔶<i><b title="Did not inline: target text too big">declareSymbol</b></i>(container.symbol.members, container.symbol, node, symbolFlags, symbolExcludes);
        }</pre>

</details>
</blockquote>



### ⛔ isObjectLiteralMethod (deoptimizated):
<div>~recompile~</div>

```diff
- Deopt: <JS Function bindWorker (SharedFunctionInfo 0x16f3adb5c261)> (opt #200) @110, FP to SP delta: 192, caller sp: 0x7fff5fbfd0b0
```

```diff
- Deopt: <JS Function isExpression (SharedFunctionInfo 0x3504a53d99d9)> (opt #194) @4, FP to SP delta: 56, caller sp: 0x7fff5fbfd048
```

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(node) {
        return node && node.kind === 149 /* MethodDeclaration */ && node.parent.kind === 176 /* ObjectLiteralExpression */;
    }</pre>

```diff
- Deopt: <JS Function addDeclarationToSymbol (SharedFunctionInfo 0x16f3adb57e21)> (opt #269) @16, FP to SP delta: 64, caller sp: 0x7fff5fbfcc58
```



### isExpressionKind:
<pre class="code">
(kind) {
        return kind === 193 /* ConditionalExpression */
            || kind === 195 /* YieldExpression */
            || kind === 185 /* ArrowFunction */
            || kind === 192 /* BinaryExpression */
            || kind === 196 /* SpreadElement */
            || kind === 200 /* AsExpression */
            || kind === 198 /* OmittedExpression */
            || <b title="Inlined">🔷isUnaryExpressionKind</b>(kind);
    }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>isUnaryExpressionKind</summary>
<pre class="code">
(kind) {
        return kind === 190 /* PrefixUnaryExpression */
            || kind === 191 /* PostfixUnaryExpression */
            || kind === 186 /* DeleteExpression */
            || kind === 187 /* TypeOfExpression */
            || kind === 188 /* VoidExpression */
            || kind === 189 /* AwaitExpression */
            || kind === 182 /* TypeAssertionExpression */
            || 🔶<i><b title="Did not inline: target text too big">isLeftHandSideExpressionKind</b></i>(kind);
    }</pre>

</details>
</blockquote>



### bindParameter:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(node) {
            if (inStrictMode) {
                // It is a SyntaxError if the identifier eval or arguments appears within a FormalParameterList of a
                // strict mode FunctionLikeDeclaration or FunctionExpression(13.1)
                🔶<i><b title="Did not inline: target text too big">checkStrictModeEvalOrArguments</b></i>(node, node.name);
            }
            if (ts.🔶<i><b title="Did not inline: unknown">isBindingPattern</b></i>(node.name)) {
                🔶️<i><b title="CallWithDescriptor">bindAnonymousDeclaration</b></i>(node, 1 /* FunctionScopedVariable */, 🔶️<i><b title="CallWithDescriptor">getDestructuringParameterName</b></i>(node));
            }
            else {
                <b title="Inlined">🔷declareSymbolAndAddToSymbolTable</b>(node, 1 /* FunctionScopedVariable */, 107455 /* ParameterExcludes */);
            }
            // If this is a property-parameter, then also declare the property symbol into the
            // containing class.
            if (ts.🔶<i><b title="Did not inline: unknown">isParameterPropertyDeclaration</b></i>(node)) {
                var classDeclaration = node⚠️<i><b title="LoadNamedGeneric">.parent</b></i>⚠️<i><b title="LoadNamedGeneric">.parent</b></i>;
                🔶<i><b title="Did not inline: target text too big">declareSymbol</b></i>(classDeclaration⚠️<i><b title="LoadNamedGeneric">.symbol</b></i>⚠️<i><b title="LoadNamedGeneric">.members</b></i>, classDeclaration⚠️<i><b title="LoadNamedGeneric">.symbol</b></i>, node, 4 /* Property */ | (node⚠️<i><b title="LoadNamedGeneric">.questionToken</b></i> ? 536870912 /* Optional */ : 0 /* None */), 0 /* PropertyExcludes */);
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>declareSymbolAndAddToSymbolTable</summary>
<pre class="code">
(node, symbolFlags, symbolExcludes) {
            // Just call this directly so that the return type of this function stays "void".
            return 🔶<i><b title="Did not inline: target text too big">declareSymbolAndAddToSymbolTableWorker</b></i>(node, symbolFlags, symbolExcludes);
        }</pre>

</details>
</blockquote>



### forEachChild:
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(node, cbNode, cbNodeArray) {
        if (!node) {
            return;
        }
        // The visitXXX functions could be written as local functions that close over the cbNode and cbNodeArray
        // callback parameters, but that causes a closure allocation for each invocation with noticeable effects
        // on performance.
        var visitNodes = cbNodeArray ? visitNodeArray : visitEachNode;
        var cbNodes = cbNodeArray || cbNode;
        switch (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i>) {
            case 141 /* QualifiedName */:
                return <b title="Inlined">🔷visitNode</b>(cbNode, node.left) ||
                    <b title="Inlined">🔷visitNode</b>(cbNode, node.right);
            case 143 /* TypeParameter */:
                return <b title="Inlined">🔷visitNode</b>(cbNode, node.name) ||
                    <b title="Inlined">🔷visitNode</b>(cbNode, node.constraint) ||
                    <b title="Inlined">🔷visitNode</b>(cbNode, node.expression);
            case 258 /* ShorthandPropertyAssignment */:
                return 🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node⚠️<i><b title="LoadNamedGeneric">.decorators</b></i>) ||
                    🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node⚠️<i><b title="LoadNamedGeneric">.modifiers</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.name</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.questionToken</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.equalsToken</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.objectAssignmentInitializer</b></i>);
            case 259 /* SpreadAssignment */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.expression</b></i>);
            case 144 /* Parameter */:
            case 147 /* PropertyDeclaration */:
            case 146 /* PropertySignature */:
            case 257 /* PropertyAssignment */:
            case 223 /* VariableDeclaration */:
            case 174 /* BindingElement */:
                return <b title="Inlined">🔷visitNodes</b>(cbNodes, node⚠️<i><b title="LoadNamedGeneric">.decorators</b></i>) ||
                    <b title="Inlined">🔷visitNodes</b>(cbNodes, node⚠️<i><b title="LoadNamedGeneric">.modifiers</b></i>) ||
                    <b title="Inlined">🔷visitNode</b>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.propertyName</b></i>) ||
                    <b title="Inlined">🔷visitNode</b>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.dotDotDotToken</b></i>) ||
                    <b title="Inlined">🔷visitNode</b>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.name</b></i>) ||
                    <b title="Inlined">🔷visitNode</b>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.questionToken</b></i>) ||
                    <b title="Inlined">🔷visitNode</b>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.type</b></i>) ||
                    <b title="Inlined">🔷visitNode</b>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.initializer</b></i>);
            case 158 /* FunctionType */:
            case 159 /* ConstructorType */:
            case 153 /* CallSignature */:
            case 154 /* ConstructSignature */:
            case 155 /* IndexSignature */:
                return <b title="Inlined">🔷visitNodes</b>(cbNodes, node.decorators) ||
                    <b title="Inlined">🔷visitNodes</b>(cbNodes, node.modifiers) ||
                    <b title="Inlined">🔷visitNodes</b>(cbNodes, node.typeParameters) ||
                    <b title="Inlined">🔷visitNodes</b>(cbNodes, node.parameters) ||
                    <b title="Inlined">🔷visitNode</b>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.type</b></i>);
            case 149 /* MethodDeclaration */:
            case 148 /* MethodSignature */:
            case 150 /* Constructor */:
            case 151 /* GetAccessor */:
            case 152 /* SetAccessor */:
            case 184 /* FunctionExpression */:
            case 225 /* FunctionDeclaration */:
            case 185 /* ArrowFunction */:
                return <b title="Inlined">🔷visitNodes</b>(cbNodes, node⚠️<i><b title="LoadNamedGeneric">.decorators</b></i>) ||
                    <b title="Inlined">🔷visitNodes</b>(cbNodes, node⚠️<i><b title="LoadNamedGeneric">.modifiers</b></i>) ||
                    <b title="Inlined">🔷visitNode</b>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.asteriskToken</b></i>) ||
                    <b title="Inlined">🔷visitNode</b>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.name</b></i>) ||
                    <b title="Inlined">🔷visitNode</b>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.questionToken</b></i>) ||
                    <b title="Inlined">🔷visitNodes</b>(cbNodes, node⚠️<i><b title="LoadNamedGeneric">.typeParameters</b></i>) ||
                    <b title="Inlined">🔷visitNodes</b>(cbNodes, node⚠️<i><b title="LoadNamedGeneric">.parameters</b></i>) ||
                    <b title="Inlined">🔷visitNode</b>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.type</b></i>) ||
                    <b title="Inlined">🔷visitNode</b>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.equalsGreaterThanToken</b></i>) ||
                    <b title="Inlined">🔷visitNode</b>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.body</b></i>);
            case 157 /* TypeReference */:
                return <b title="Inlined">🔷visitNode</b>(cbNode, node.typeName) ||
                    <b title="Inlined">🔷visitNodes</b>(cbNodes, node.typeArguments);
            case 156 /* TypePredicate */:
                return <b title="Inlined">🔷visitNode</b>(cbNode, node.parameterName) ||
                    <b title="Inlined">🔷visitNode</b>(cbNode, node.type);
            case 160 /* TypeQuery */:
                return <b title="Inlined">🔷visitNode</b>(cbNode, node.exprName);
            case 161 /* TypeLiteral */:
                return <b title="Inlined">🔷visitNodes</b>(cbNodes, node.members);
            case 162 /* ArrayType */:
                return <b title="Inlined">🔷visitNode</b>(cbNode, node.elementType);
            case 163 /* TupleType */:
                return <b title="Inlined">🔷visitNodes</b>(cbNodes, node.elementTypes);
            case 164 /* UnionType */:
            case 165 /* IntersectionType */:
                return <b title="Inlined">🔷visitNodes</b>(cbNodes, node.types);
            case 166 /* ParenthesizedType */:
            case 168 /* TypeOperator */:
                return <b title="Inlined">🔷visitNode</b>(cbNode, node.type);
            case 169 /* IndexedAccessType */:
                return <b title="Inlined">🔷visitNode</b>(cbNode, node.objectType) ||
                    <b title="Inlined">🔷visitNode</b>(cbNode, node.indexType);
            case 170 /* MappedType */:
                return <b title="Inlined">🔷visitNode</b>(cbNode, node.readonlyToken) ||
                    <b title="Inlined">🔷visitNode</b>(cbNode, node.typeParameter) ||
                    <b title="Inlined">🔷visitNode</b>(cbNode, node.questionToken) ||
                    <b title="Inlined">🔷visitNode</b>(cbNode, node.type);
            case 171 /* LiteralType */:
                return <b title="Inlined">🔷visitNode</b>(cbNode, node.literal);
            case 172 /* ObjectBindingPattern */:
            case 173 /* ArrayBindingPattern */:
                return 🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node⚠️<i><b title="LoadNamedGeneric">.elements</b></i>);
            case 175 /* ArrayLiteralExpression */:
                return 🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node⚠️<i><b title="LoadNamedGeneric">.elements</b></i>);
            case 176 /* ObjectLiteralExpression */:
                return 🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node⚠️<i><b title="LoadNamedGeneric">.properties</b></i>);
            case 177 /* PropertyAccessExpression */:
                return <b title="Inlined">🔷visitNode</b>(cbNode, node.expression) ||
                    <b title="Inlined">🔷visitNode</b>(cbNode, node.name);
            case 178 /* ElementAccessExpression */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.expression</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.argumentExpression</b></i>);
            case 179 /* CallExpression */:
            case 180 /* NewExpression */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.expression</b></i>) ||
                    🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node⚠️<i><b title="LoadNamedGeneric">.typeArguments</b></i>) ||
                    🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node⚠️<i><b title="LoadNamedGeneric">.arguments</b></i>);
            case 181 /* TaggedTemplateExpression */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.tag</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.template</b></i>);
            case 182 /* TypeAssertionExpression */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.type</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.expression</b></i>);
            case 183 /* ParenthesizedExpression */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.expression</b></i>);
            case 186 /* DeleteExpression */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.expression</b></i>);
            case 187 /* TypeOfExpression */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.expression</b></i>);
            case 188 /* VoidExpression */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.expression</b></i>);
            case 190 /* PrefixUnaryExpression */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.operand</b></i>);
            case 195 /* YieldExpression */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.asteriskToken</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.expression</b></i>);
            case 189 /* AwaitExpression */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.expression</b></i>);
            case 191 /* PostfixUnaryExpression */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.operand</b></i>);
            case 192 /* BinaryExpression */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.left</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.operatorToken</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.right</b></i>);
            case 200 /* AsExpression */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.expression</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.type</b></i>);
            case 201 /* NonNullExpression */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.expression</b></i>);
            case 193 /* ConditionalExpression */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.condition</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.questionToken</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.whenTrue</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.colonToken</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.whenFalse</b></i>);
            case 196 /* SpreadElement */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.expression</b></i>);
            case 204 /* Block */:
            case 231 /* ModuleBlock */:
                return 🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node.statements);
            case 261 /* SourceFile */:
                return <b title="Inlined">🔷visitNodes</b>(cbNodes, node.statements) ||
                    <b title="Inlined">🔷visitNode</b>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.endOfFileToken</b></i>);
            case 205 /* VariableStatement */:
                return <b title="Inlined">🔷visitNodes</b>(cbNodes, node.decorators) ||
                    <b title="Inlined">🔷visitNodes</b>(cbNodes, node.modifiers) ||
                    <b title="Inlined">🔷visitNode</b>(cbNode, node.declarationList);
            case 224 /* VariableDeclarationList */:
                return <b title="Inlined">🔷visitNodes</b>(cbNodes, node.declarations);
            case 207 /* ExpressionStatement */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.expression</b></i>);
            case 208 /* IfStatement */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.expression</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.thenStatement</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.elseStatement</b></i>);
            case 209 /* DoStatement */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.statement</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.expression</b></i>);
            case 210 /* WhileStatement */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.expression</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.statement</b></i>);
            case 211 /* ForStatement */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.initializer</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.condition</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.incrementor</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.statement</b></i>);
            case 212 /* ForInStatement */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.initializer</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.expression</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.statement</b></i>);
            case 213 /* ForOfStatement */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.initializer</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.expression</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.statement</b></i>);
            case 214 /* ContinueStatement */:
            case 215 /* BreakStatement */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.label</b></i>);
            case 216 /* ReturnStatement */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.expression</b></i>);
            case 217 /* WithStatement */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.expression</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.statement</b></i>);
            case 218 /* SwitchStatement */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.expression</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.caseBlock</b></i>);
            case 232 /* CaseBlock */:
                return 🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node⚠️<i><b title="LoadNamedGeneric">.clauses</b></i>);
            case 253 /* CaseClause */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.expression</b></i>) ||
                    🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node⚠️<i><b title="LoadNamedGeneric">.statements</b></i>);
            case 254 /* DefaultClause */:
                return 🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node⚠️<i><b title="LoadNamedGeneric">.statements</b></i>);
            case 219 /* LabeledStatement */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.label</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.statement</b></i>);
            case 220 /* ThrowStatement */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.expression</b></i>);
            case 221 /* TryStatement */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.tryBlock</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.catchClause</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.finallyBlock</b></i>);
            case 256 /* CatchClause */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.variableDeclaration</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.block</b></i>);
            case 145 /* Decorator */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.expression</b></i>);
            case 226 /* ClassDeclaration */:
            case 197 /* ClassExpression */:
                return <b title="Inlined">🔷visitNodes</b>(cbNodes, node.decorators) ||
                    <b title="Inlined">🔷visitNodes</b>(cbNodes, node.modifiers) ||
                    <b title="Inlined">🔷visitNode</b>(cbNode, node.name) ||
                    <b title="Inlined">🔷visitNodes</b>(cbNodes, node.typeParameters) ||
                    <b title="Inlined">🔷visitNodes</b>(cbNodes, node.heritageClauses) ||
                    🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node.members);
            case 227 /* InterfaceDeclaration */:
                return 🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node.decorators) ||
                    🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node.modifiers) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node.name) ||
                    🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node.typeParameters) ||
                    🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node.heritageClauses) ||
                    🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node.members);
            case 228 /* TypeAliasDeclaration */:
                return 🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node.decorators) ||
                    🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node.modifiers) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node.name) ||
                    🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node.typeParameters) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node.type);
            case 229 /* EnumDeclaration */:
                return 🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node⚠️<i><b title="LoadNamedGeneric">.decorators</b></i>) ||
                    🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node⚠️<i><b title="LoadNamedGeneric">.modifiers</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.name</b></i>) ||
                    🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node⚠️<i><b title="LoadNamedGeneric">.members</b></i>);
            case 260 /* EnumMember */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.name</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.initializer</b></i>);
            case 230 /* ModuleDeclaration */:
                return 🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node.decorators) ||
                    🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node.modifiers) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node.name) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node.body);
            case 234 /* ImportEqualsDeclaration */:
                return 🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node⚠️<i><b title="LoadNamedGeneric">.decorators</b></i>) ||
                    🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node⚠️<i><b title="LoadNamedGeneric">.modifiers</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.name</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.moduleReference</b></i>);
            case 235 /* ImportDeclaration */:
                return 🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node.decorators) ||
                    🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node.modifiers) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node.importClause) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node.moduleSpecifier);
            case 236 /* ImportClause */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node.name) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node.namedBindings);
            case 233 /* NamespaceExportDeclaration */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.name</b></i>);
            case 237 /* NamespaceImport */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node.name);
            case 238 /* NamedImports */:
            case 242 /* NamedExports */:
                return 🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node⚠️<i><b title="LoadNamedGeneric">.elements</b></i>);
            case 241 /* ExportDeclaration */:
                return 🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node⚠️<i><b title="LoadNamedGeneric">.decorators</b></i>) ||
                    🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node⚠️<i><b title="LoadNamedGeneric">.modifiers</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.exportClause</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.moduleSpecifier</b></i>);
            case 239 /* ImportSpecifier */:
            case 243 /* ExportSpecifier */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node.propertyName) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node.name);
            case 240 /* ExportAssignment */:
                return 🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node⚠️<i><b title="LoadNamedGeneric">.decorators</b></i>) ||
                    🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node⚠️<i><b title="LoadNamedGeneric">.modifiers</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.expression</b></i>);
            case 194 /* TemplateExpression */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.head</b></i>) || 🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node⚠️<i><b title="LoadNamedGeneric">.templateSpans</b></i>);
            case 202 /* TemplateSpan */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.expression</b></i>) || 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.literal</b></i>);
            case 142 /* ComputedPropertyName */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.expression</b></i>);
            case 255 /* HeritageClause */:
                return 🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node.types);
            case 199 /* ExpressionWithTypeArguments */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node.expression) ||
                    🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node.typeArguments);
            case 245 /* ExternalModuleReference */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.expression</b></i>);
            case 244 /* MissingDeclaration */:
                return 🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node⚠️<i><b title="LoadNamedGeneric">.decorators</b></i>);
            case 246 /* JsxElement */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.openingElement</b></i>) ||
                    🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node⚠️<i><b title="LoadNamedGeneric">.children</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.closingElement</b></i>);
            case 247 /* JsxSelfClosingElement */:
            case 248 /* JsxOpeningElement */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.tagName</b></i>) ||
                    🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node⚠️<i><b title="LoadNamedGeneric">.attributes</b></i>);
            case 250 /* JsxAttribute */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.name</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.initializer</b></i>);
            case 251 /* JsxSpreadAttribute */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.expression</b></i>);
            case 252 /* JsxExpression */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.expression</b></i>);
            case 249 /* JsxClosingElement */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.tagName</b></i>);
            case 262 /* JSDocTypeExpression */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node.type);
            case 266 /* JSDocUnionType */:
                return 🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node⚠️<i><b title="LoadNamedGeneric">.types</b></i>);
            case 267 /* JSDocTupleType */:
                return 🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node⚠️<i><b title="LoadNamedGeneric">.types</b></i>);
            case 265 /* JSDocArrayType */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.elementType</b></i>);
            case 269 /* JSDocNonNullableType */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.type</b></i>);
            case 268 /* JSDocNullableType */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.type</b></i>);
            case 270 /* JSDocRecordType */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.literal</b></i>);
            case 272 /* JSDocTypeReference */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node.name) ||
                    🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node.typeArguments);
            case 273 /* JSDocOptionalType */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.type</b></i>);
            case 274 /* JSDocFunctionType */:
                return 🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node⚠️<i><b title="LoadNamedGeneric">.parameters</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.type</b></i>);
            case 275 /* JSDocVariadicType */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.type</b></i>);
            case 276 /* JSDocConstructorType */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.type</b></i>);
            case 277 /* JSDocThisType */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.type</b></i>);
            case 271 /* JSDocRecordMember */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.name</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.type</b></i>);
            case 278 /* JSDocComment */:
                return 🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node⚠️<i><b title="LoadNamedGeneric">.tags</b></i>);
            case 281 /* JSDocParameterTag */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.preParameterName</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.typeExpression</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.postParameterName</b></i>);
            case 282 /* JSDocReturnTag */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.typeExpression</b></i>);
            case 283 /* JSDocTypeTag */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.typeExpression</b></i>);
            case 280 /* JSDocAugmentsTag */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.typeExpression</b></i>);
            case 284 /* JSDocTemplateTag */:
                return 🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node⚠️<i><b title="LoadNamedGeneric">.typeParameters</b></i>);
            case 285 /* JSDocTypedefTag */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.typeExpression</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.fullName</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.name</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.jsDocTypeLiteral</b></i>);
            case 287 /* JSDocTypeLiteral */:
                return 🔶️<i><b title="CallWithDescriptor">visitNodes</b></i>(cbNodes, node⚠️<i><b title="LoadNamedGeneric">.jsDocPropertyTags</b></i>);
            case 286 /* JSDocPropertyTag */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.typeExpression</b></i>) ||
                    🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.name</b></i>);
            case 294 /* PartiallyEmittedExpression */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.expression</b></i>);
            case 288 /* JSDocLiteralType */:
                return 🔶<i><b title="Did not inline: unknown">visitNode</b></i>(cbNode, node⚠️<i><b title="LoadNamedGeneric">.literal</b></i>);
        }
    }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>visitNode</summary>
<pre class="code">
(cbNode, node) {
        if (node) {
            return 🔶️<i><b title="CallWithDescriptor">cbNode</b></i>(node);
        }
    }</pre>

</details>
<details>
<summary>visitNode</summary>
<pre class="code">
(cbNode, node) {
        if (node) {
            return 🔶️<i><b title="CallWithDescriptor">cbNode</b></i>(node);
        }
    }</pre>

</details>
<details>
<summary>visitNode</summary>
<pre class="code">
(cbNode, node) {
        if (node) {
            return 🔶️<i><b title="CallWithDescriptor">cbNode</b></i>(node);
        }
    }</pre>

</details>
<details>
<summary>visitNode</summary>
<pre class="code">
(cbNode, node) {
        if (node) {
            return 🔶️<i><b title="CallWithDescriptor">cbNode</b></i>(node);
        }
    }</pre>

</details>
<details>
<summary>visitNode</summary>
<pre class="code">
(cbNode, node) {
        if (node) {
            return 🔶️<i><b title="CallWithDescriptor">cbNode</b></i>(node);
        }
    }</pre>

</details>
<details>
<summary>visitNodes</summary>
<pre class="code">
(cbNodes, nodes) {
        if (nodes) {
            return 🔶️<i><b title="CallWithDescriptor">cbNodes</b></i>(nodes);
        }
    }</pre>

</details>
<details>
<summary>visitNodes</summary>
<pre class="code">
(cbNodes, nodes) {
        if (nodes) {
            return 🔶️<i><b title="CallWithDescriptor">cbNodes</b></i>(nodes);
        }
    }</pre>

</details>
<details>
<summary>visitNode</summary>
<pre class="code">
(cbNode, node) {
        if (node) {
            return 🔶️<i><b title="CallWithDescriptor">cbNode</b></i>(node);
        }
    }</pre>

</details>
<details>
<summary>visitNode</summary>
<pre class="code">
(cbNode, node) {
        if (node) {
            return 🔶️<i><b title="CallWithDescriptor">cbNode</b></i>(node);
        }
    }</pre>

</details>
<details>
<summary>visitNode</summary>
<pre class="code">
(cbNode, node) {
        if (node) {
            return 🔶️<i><b title="CallWithDescriptor">cbNode</b></i>(node);
        }
    }</pre>

</details>
<details>
<summary>visitNode</summary>
<pre class="code">
(cbNode, node) {
        if (node) {
            return 🔶️<i><b title="CallWithDescriptor">cbNode</b></i>(node);
        }
    }</pre>

</details>
<details>
<summary>visitNode</summary>
<pre class="code">
(cbNode, node) {
        if (node) {
            return 🔶️<i><b title="CallWithDescriptor">cbNode</b></i>(node);
        }
    }</pre>

</details>
<details>
<summary>visitNode</summary>
<pre class="code">
(cbNode, node) {
        if (node) {
            return 🔶️<i><b title="CallWithDescriptor">cbNode</b></i>(node);
        }
    }</pre>

</details>
<details>
<summary>visitNodes</summary>
<pre class="code">
(cbNodes, nodes) {
        if (nodes) {
            return 🔶️<i><b title="CallWithDescriptor">cbNodes</b></i>(nodes);
        }
    }</pre>

</details>
<details>
<summary>visitNodes</summary>
<pre class="code">
(cbNodes, nodes) {
        if (nodes) {
            return 🔶️<i><b title="CallWithDescriptor">cbNodes</b></i>(nodes);
        }
    }</pre>

</details>
<details>
<summary>visitNodes</summary>
<pre class="code">
(cbNodes, nodes) {
        if (nodes) {
            return 🔶️<i><b title="CallWithDescriptor">cbNodes</b></i>(nodes);
        }
    }</pre>

</details>
<details>
<summary>visitNodes</summary>
<pre class="code">
(cbNodes, nodes) {
        if (nodes) {
            return 🔶️<i><b title="CallWithDescriptor">cbNodes</b></i>(nodes);
        }
    }</pre>

</details>
<details>
<summary>visitNode</summary>
<pre class="code">
(cbNode, node) {
        if (node) {
            return 🔶️<i><b title="CallWithDescriptor">cbNode</b></i>(node);
        }
    }</pre>

</details>
<details>
<summary>visitNodes</summary>
<pre class="code">
(cbNodes, nodes) {
        if (nodes) {
            return 🔶️<i><b title="CallWithDescriptor">cbNodes</b></i>(nodes);
        }
    }</pre>

</details>
<details>
<summary>visitNodes</summary>
<pre class="code">
(cbNodes, nodes) {
        if (nodes) {
            return 🔶️<i><b title="CallWithDescriptor">cbNodes</b></i>(nodes);
        }
    }</pre>

</details>
<details>
<summary>visitNode</summary>
<pre class="code">
(cbNode, node) {
        if (node) {
            return 🔶️<i><b title="CallWithDescriptor">cbNode</b></i>(node);
        }
    }</pre>

</details>
<details>
<summary>visitNode</summary>
<pre class="code">
(cbNode, node) {
        if (node) {
            return 🔶️<i><b title="CallWithDescriptor">cbNode</b></i>(node);
        }
    }</pre>

</details>
<details>
<summary>visitNode</summary>
<pre class="code">
(cbNode, node) {
        if (node) {
            return 🔶️<i><b title="CallWithDescriptor">cbNode</b></i>(node);
        }
    }</pre>

</details>
<details>
<summary>visitNodes</summary>
<pre class="code">
(cbNodes, nodes) {
        if (nodes) {
            return 🔶️<i><b title="CallWithDescriptor">cbNodes</b></i>(nodes);
        }
    }</pre>

</details>
<details>
<summary>visitNodes</summary>
<pre class="code">
(cbNodes, nodes) {
        if (nodes) {
            return 🔶️<i><b title="CallWithDescriptor">cbNodes</b></i>(nodes);
        }
    }</pre>

</details>
<details>
<summary>visitNode</summary>
<pre class="code">
(cbNode, node) {
        if (node) {
            return 🔶️<i><b title="CallWithDescriptor">cbNode</b></i>(node);
        }
    }</pre>

</details>
<details>
<summary>visitNode</summary>
<pre class="code">
(cbNode, node) {
        if (node) {
            return 🔶️<i><b title="CallWithDescriptor">cbNode</b></i>(node);
        }
    }</pre>

</details>
<details>
<summary>visitNode</summary>
<pre class="code">
(cbNode, node) {
        if (node) {
            return 🔶️<i><b title="CallWithDescriptor">cbNode</b></i>(node);
        }
    }</pre>

</details>
<details>
<summary>visitNode</summary>
<pre class="code">
(cbNode, node) {
        if (node) {
            return 🔶️<i><b title="CallWithDescriptor">cbNode</b></i>(node);
        }
    }</pre>

</details>
<details>
<summary>visitNodes</summary>
<pre class="code">
(cbNodes, nodes) {
        if (nodes) {
            return 🔶️<i><b title="CallWithDescriptor">cbNodes</b></i>(nodes);
        }
    }</pre>

</details>
<details>
<summary>visitNode</summary>
<pre class="code">
(cbNode, node) {
        if (node) {
            return 🔶️<i><b title="CallWithDescriptor">cbNode</b></i>(node);
        }
    }</pre>

</details>
<details>
<summary>visitNode</summary>
<pre class="code">
(cbNode, node) {
        if (node) {
            return 🔶️<i><b title="CallWithDescriptor">cbNode</b></i>(node);
        }
    }</pre>

</details>
<details>
<summary>visitNode</summary>
<pre class="code">
(cbNode, node) {
        if (node) {
            return 🔶️<i><b title="CallWithDescriptor">cbNode</b></i>(node);
        }
    }</pre>

</details>
<details>
<summary>visitNodes</summary>
<pre class="code">
(cbNodes, nodes) {
        if (nodes) {
            return 🔶️<i><b title="CallWithDescriptor">cbNodes</b></i>(nodes);
        }
    }</pre>

</details>
<details>
<summary>visitNode</summary>
<pre class="code">
(cbNode, node) {
        if (node) {
            return 🔶️<i><b title="CallWithDescriptor">cbNode</b></i>(node);
        }
    }</pre>

</details>
<details>
<summary>visitNodes</summary>
<pre class="code">
(cbNodes, nodes) {
        if (nodes) {
            return 🔶️<i><b title="CallWithDescriptor">cbNodes</b></i>(nodes);
        }
    }</pre>

</details>
<details>
<summary>visitNodes</summary>
<pre class="code">
(cbNodes, nodes) {
        if (nodes) {
            return 🔶️<i><b title="CallWithDescriptor">cbNodes</b></i>(nodes);
        }
    }</pre>

</details>
<details>
<summary>visitNode</summary>
<pre class="code">
(cbNode, node) {
        if (node) {
            return 🔶️<i><b title="CallWithDescriptor">cbNode</b></i>(node);
        }
    }</pre>

</details>
<details>
<summary>visitNode</summary>
<pre class="code">
(cbNode, node) {
        if (node) {
            return 🔶️<i><b title="CallWithDescriptor">cbNode</b></i>(node);
        }
    }</pre>

</details>
<details>
<summary>visitNode</summary>
<pre class="code">
(cbNode, node) {
        if (node) {
            return 🔶️<i><b title="CallWithDescriptor">cbNode</b></i>(node);
        }
    }</pre>

</details>
<details>
<summary>visitNode</summary>
<pre class="code">
(cbNode, node) {
        if (node) {
            return 🔶️<i><b title="CallWithDescriptor">cbNode</b></i>(node);
        }
    }</pre>

</details>
<details>
<summary>visitNode</summary>
<pre class="code">
(cbNode, node) {
        if (node) {
            return 🔶️<i><b title="CallWithDescriptor">cbNode</b></i>(node);
        }
    }</pre>

</details>
<details>
<summary>visitNode</summary>
<pre class="code">
(cbNode, node) {
        if (node) {
            return 🔶️<i><b title="CallWithDescriptor">cbNode</b></i>(node);
        }
    }</pre>

</details>
<details>
<summary>visitNode</summary>
<pre class="code">
(cbNode, node) {
        if (node) {
            return 🔶️<i><b title="CallWithDescriptor">cbNode</b></i>(node);
        }
    }</pre>

</details>
<details>
<summary>visitNode</summary>
<pre class="code">
(cbNode, node) {
        if (node) {
            return 🔶️<i><b title="CallWithDescriptor">cbNode</b></i>(node);
        }
    }</pre>

</details>
<details>
<summary>visitNode</summary>
<pre class="code">
(cbNode, node) {
        if (node) {
            return 🔶️<i><b title="CallWithDescriptor">cbNode</b></i>(node);
        }
    }</pre>

</details>
<details>
<summary>visitNode</summary>
<pre class="code">
(cbNode, node) {
        if (node) {
            return 🔶️<i><b title="CallWithDescriptor">cbNode</b></i>(node);
        }
    }</pre>

</details>
<details>
<summary>visitNodes</summary>
<pre class="code">
(cbNodes, nodes) {
        if (nodes) {
            return 🔶️<i><b title="CallWithDescriptor">cbNodes</b></i>(nodes);
        }
    }</pre>

</details>
<details>
<summary>visitNode</summary>
<pre class="code">
(cbNode, node) {
        if (node) {
            return 🔶️<i><b title="CallWithDescriptor">cbNode</b></i>(node);
        }
    }</pre>

</details>
<details>
<summary>visitNodes</summary>
<pre class="code">
(cbNodes, nodes) {
        if (nodes) {
            return 🔶️<i><b title="CallWithDescriptor">cbNodes</b></i>(nodes);
        }
    }</pre>

</details>
<details>
<summary>visitNodes</summary>
<pre class="code">
(cbNodes, nodes) {
        if (nodes) {
            return 🔶️<i><b title="CallWithDescriptor">cbNodes</b></i>(nodes);
        }
    }</pre>

</details>
<details>
<summary>visitNode</summary>
<pre class="code">
(cbNode, node) {
        if (node) {
            return 🔶️<i><b title="CallWithDescriptor">cbNode</b></i>(node);
        }
    }</pre>

</details>
<details>
<summary>visitNodes</summary>
<pre class="code">
(cbNodes, nodes) {
        if (nodes) {
            return 🔶️<i><b title="CallWithDescriptor">cbNodes</b></i>(nodes);
        }
    }</pre>

</details>
<details>
<summary>visitNodes</summary>
<pre class="code">
(cbNodes, nodes) {
        if (nodes) {
            return 🔶️<i><b title="CallWithDescriptor">cbNodes</b></i>(nodes);
        }
    }</pre>

</details>
<details>
<summary>visitNodes</summary>
<pre class="code">
(cbNodes, nodes) {
        if (nodes) {
            return 🔶️<i><b title="CallWithDescriptor">cbNodes</b></i>(nodes);
        }
    }</pre>

</details>
<details>
<summary>visitNode</summary>
<pre class="code">
(cbNode, node) {
        if (node) {
            return 🔶️<i><b title="CallWithDescriptor">cbNode</b></i>(node);
        }
    }</pre>

</details>
<details>
<summary>visitNodes</summary>
<pre class="code">
(cbNodes, nodes) {
        if (nodes) {
            return 🔶️<i><b title="CallWithDescriptor">cbNodes</b></i>(nodes);
        }
    }</pre>

</details>
<details>
<summary>visitNodes</summary>
<pre class="code">
(cbNodes, nodes) {
        if (nodes) {
            return 🔶️<i><b title="CallWithDescriptor">cbNodes</b></i>(nodes);
        }
    }</pre>

</details>
</blockquote>



### bindFunctionOrConstructorType:
<pre class="code">
(node) {
            // For a given function symbol "&lt;...&gt;(...) =&gt; T" we want to generate a symbol identical
            // to the one we would get for: { &lt;...&gt;(...): T }
            //
            // We do that by making an anonymous type literal symbol, and then setting the function
            // symbol as its sole member. To the rest of the system, this symbol will be  indistinguishable
            // from an actual type literal symbol you would have gotten had you used the long form.
            var symbol = <b title="Inlined">🔷createSymbol</b>(131072 /* Signature */, 🔶<i><b title="Did not inline: target text too big">getDeclarationName</b></i>(node));
            🔶<i><b title="Did not inline: target text too big">addDeclarationToSymbol</b></i>(symbol, node, 131072 /* Signature */);
            var typeLiteralSymbol = <b title="Inlined">🔷createSymbol</b>(2048 /* TypeLiteral */, "__type");
            🔶<i><b title="Did not inline: target text too big">addDeclarationToSymbol</b></i>(typeLiteralSymbol, node, 2048 /* TypeLiteral */);
            typeLiteralSymbol.members = ts.🔶<i><b title="Did not inline: unknown">createMap</b></i>();
            typeLiteralSymbol.members[symbol.name] ⚠️<i><b title="StoreKeyedGeneric">= symbol</b></i>;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createSymbol</summary>
<pre class="code">
(flags, name) {
            symbolCount++;
            return <b title="Inlined">🔷new Symbol</b>(flags, name);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new Symbol</summary>
<pre class="code">
(flags, name) {
            this.flags = flags;
            this.name = name;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>createSymbol</summary>
<pre class="code">
(flags, name) {
            symbolCount++;
            return <b title="Inlined">🔷new Symbol</b>(flags, name);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new Symbol</summary>
<pre class="code">
(flags, name) {
            this.flags = flags;
            this.name = name;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### bindBlockScopedDeclaration:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(node, symbolFlags, symbolExcludes) {
            switch (blockScopeContainer⚠️<i><b title="LoadNamedGeneric">.kind</b></i>) {
                case 230 /* ModuleDeclaration */:
                    🔶<i><b title="Did not inline: target text too big">declareModuleMember</b></i>(node, symbolFlags, symbolExcludes);
                    break;
                case 261 /* SourceFile */:
                    if (ts.🔶️<i><b title="CallWithDescriptor">isExternalModule</b></i>(container)) {
                        🔶<i><b title="Did not inline: target text too big">declareModuleMember</b></i>(node, symbolFlags, symbolExcludes);
                        break;
                    }
                // fall through.
                default:
                    if (!blockScopeContainer.locals) {
                        blockScopeContainer.locals ⚠️<i><b title="StoreNamedGeneric">= ts</b></i>.🔶<i><b title="Did not inline: unknown">createMap</b></i>();
                        🔶️<i><b title="CallWithDescriptor">addToContainerChain</b></i>(blockScopeContainer);
                    }
                    🔶<i><b title="Did not inline: target text too big">declareSymbol</b></i>(blockScopeContainer.locals, undefined, node, symbolFlags, symbolExcludes);
            }
        }</pre>



### ⛔ forEach (deoptimizated):
<div>~recompile~</div>

```diff
- Deopt: <JS Function isDynamicName (SharedFunctionInfo 0x3504a53d2359)> (opt #201) @2, FP to SP delta: 24, caller sp: 0x7fff5fbfd668
```

```diff
- Deopt: <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> (opt #224) @314, FP to SP delta: 728, caller sp: 0x7fff5fbfd6f8
```

```diff
- Deopt: <JS Function addDeclarationToSymbol (SharedFunctionInfo 0x16f3adb57e21)> (opt #225) @30, FP to SP delta: 48, caller sp: 0x7fff5fbfd5b0
```

```diff
- Deopt: <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> (opt #224) @134, FP to SP delta: 728, caller sp: 0x7fff5fbfdc68
```

<div>~recompile~</div>
<pre class="code">
(array, callback) {
        if (array) {
            for (var i = 0, len = array.length; i &lt; len; i++) {
                var result = 🔶️<i><b title="CallWithDescriptor">callback</b></i>(array[i], i);
                if (result) {
                    return result;
                }
            }
        }
        return undefined;
    }</pre>



### bindContainer:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(node, containerFlags) {
            // Before we recurse into a node's children, we first save the existing parent, container
            // and block-container.  Then after we pop out of processing the children, we restore
            // these saved values.
            var saveContainer = container;
            var savedBlockScopeContainer = blockScopeContainer;
            // Depending on what kind of node this is, we may have to adjust the current container
            // and block-container.   If the current node is a container, then it is automatically
            // considered the current block-container as well.  Also, for containers that we know
            // may contain locals, we proactively initialize the .locals field. We do this because
            // it's highly likely that the .locals will be needed to place some child in (for example,
            // a parameter, or variable declaration).
            //
            // However, we do not proactively create the .locals for block-containers because it's
            // totally normal and common for block-containers to never actually have a block-scoped
            // variable in them.  We don't want to end up allocating an object for every 'block' we
            // run into when most of them won't be necessary.
            //
            // Finally, if this is a block-container, then we clear out any existing .locals object
            // it may contain within it.  This happens in incremental scenarios.  Because we can be
            // reusing a node from a previous compilation, that node may have had 'locals' created
            // for it.  We must clear this so we don't accidentally move any stale data forward from
            // a previous compilation.
            if (containerFlags & 1 /* IsContainer */) {
                container = blockScopeContainer = node;
                if (containerFlags & 32 /* HasLocals */) {
                    container.locals ⚠️<i><b title="StoreNamedGeneric">= ts</b></i>.⚠️<i><b title="LoadNamedGeneric">createMap</b></i>();
                }
                <b title="Inlined">🔷addToContainerChain</b>(container);
            }
            else if (containerFlags & 2 /* IsBlockScopedContainer */) {
                blockScopeContainer = node;
                blockScopeContainer.locals ⚠️<i><b title="StoreNamedGeneric">= undefined</b></i>;
            }
            if (containerFlags & 4 /* IsControlFlowContainer */) {
                var saveCurrentFlow = currentFlow;
                var saveBreakTarget = currentBreakTarget;
                var saveContinueTarget = currentContinueTarget;
                var saveReturnTarget = currentReturnTarget;
                var saveActiveLabels = activeLabels;
                var saveHasExplicitReturn = hasExplicitReturn;
                var isIIFE = containerFlags & 16 /* IsFunctionExpression */ && !ts.⚠️<i><b title="LoadNamedGeneric">hasModifier</b></i>(node, 256 /* Async */) && !!ts.🔶️<i><b title="CallWithDescriptor">getImmediatelyInvokedFunctionExpression</b></i>(node);
                // A non-async IIFE is considered part of the containing control flow. Return statements behave
                // similarly to break statements that exit to a label just past the statement body.
                if (isIIFE) {
                    currentReturnTarget = 🔶️<i><b title="CallWithDescriptor">createBranchLabel</b></i>();
                }
                else {
                    currentFlow = { flags: 2 /* Start */ };
                    if (containerFlags & (16 /* IsFunctionExpression */ | 128 /* IsObjectLiteralOrClassExpressionMethod */)) {
                        currentFlow.container ⚠️<i><b title="StoreNamedGeneric">= node</b></i>;
                    }
                    currentReturnTarget = undefined;
                }
                currentBreakTarget = undefined;
                currentContinueTarget = undefined;
                activeLabels = undefined;
                hasExplicitReturn = false;
                🔶<i><b title="Did not inline: target text too big">bindChildren</b></i>(node);
                // Reset all reachability check related flags on node (for incremental scenarios)
                node.flags ⚠️<i><b title="LoadNamedGeneric">&= ~1</b></i>408 /* ReachabilityAndEmitFlags */;
                if (!(currentFlow.flags & 1 /* Unreachable */) && containerFlags & 8 /* IsFunctionLike */ && ts.⚠️<i><b title="LoadNamedGeneric">nodeIsPresent</b></i>(node⚠️<i><b title="LoadNamedGeneric">.body</b></i>)) {
                    node.flags ⚠️<i><b title="LoadNamedGeneric">|= 128</b></i> /* HasImplicitReturn */;
                    if (hasExplicitReturn)
                        node.flags ⚠️<i><b title="StoreNamedGeneric">|= 256</b></i> /* HasExplicitReturn */;
                }
                if (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 261 /* SourceFile */) {
                    node.flags ⚠️<i><b title="LoadNamedGeneric">|= emitFlags</b></i>;
                }
                if (isIIFE) {
                    🔶️<i><b title="CallWithDescriptor">addAntecedent</b></i>(currentReturnTarget, currentFlow);
                    currentFlow = 🔶️<i><b title="CallWithDescriptor">finishFlowLabel</b></i>(currentReturnTarget);
                }
                else {
                    currentFlow = saveCurrentFlow;
                }
                currentBreakTarget = saveBreakTarget;
                currentContinueTarget = saveContinueTarget;
                currentReturnTarget = saveReturnTarget;
                activeLabels = saveActiveLabels;
                hasExplicitReturn = saveHasExplicitReturn;
            }
            else if (containerFlags & 64 /* IsInterface */) {
                seenThisKeyword = false;
                🔶<i><b title="Did not inline: target text too big">bindChildren</b></i>(node);
                node.flags ⚠️<i><b title="StoreNamedGeneric">= seenThisKeyword</b></i> ? node.flags | 64 /* ContainsThis */ : node⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & ~64 /* ContainsThis */;
            }
            else {
                🔶<i><b title="Did not inline: target text too big">bindChildren</b></i>(node);
            }
            container = saveContainer;
            blockScopeContainer = savedBlockScopeContainer;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>addToContainerChain</summary>
<pre class="code">
(next) {
            if (lastContainer) {
                lastContainer.nextContainer ⚠️<i><b title="StoreNamedGeneric">= next</b></i>;
            }
            lastContainer = next;
        }</pre>

</details>
</blockquote>



### ⛔ skipPartiallyEmittedExpressions (deoptimizated):
<pre class="code">
(node) {
        while (node.kind === 294 /* PartiallyEmittedExpression */) {
            node = node⚠️<i><b title="LoadNamedGeneric">.expression</b></i>;
        }
        return node;
    }</pre>

```diff
- Deopt: <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> (opt #231) @206, FP to SP delta: 744, caller sp: 0x7fff5fbfcd58
```

```diff
- Deopt: <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> (opt #231) @378, FP to SP delta: 744, caller sp: 0x7fff5fbfd160
```

```diff
- Deopt: <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> (opt #231) @313, FP to SP delta: 744, caller sp: 0x7fff5fbfd658
```



### bindVariableDeclarationOrBindingElement:
<pre class="code">
(node) {
            if (inStrictMode) {
                🔶<i><b title="Did not inline: target text too big">checkStrictModeEvalOrArguments</b></i>(node, node⚠️<i><b title="LoadNamedGeneric">.name</b></i>);
            }
            if (!ts.⚠️<i><b title="LoadNamedGeneric">isBindingPattern</b></i>(node.name)) {
                if (ts.⚠️<i><b title="LoadNamedGeneric">isBlockOrCatchScoped</b></i>(node)) {
                    <b title="Inlined">🔷bindBlockScopedVariableDeclaration</b>(node);
                }
                else if (ts.🔶<i><b title="Did not inline: unknown">isParameterDeclaration</b></i>(node)) {
                    // It is safe to walk up parent chain to find whether the node is a destructing parameter declaration
                    // because its parent chain has already been set up, since parents are set before descending into children.
                    //
                    // If node is a binding element in parameter declaration, we need to use ParameterExcludes.
                    // Using ParameterExcludes flag allows the compiler to report an error on duplicate identifiers in Parameter Declaration
                    // For example:
                    //      function foo([a,a]) {} // Duplicate Identifier error
                    //      function bar(a,a) {}   // Duplicate Identifier error, parameter declaration in this case is handled in bindParameter
                    //                             // which correctly set excluded symbols
                    🔶<i><b title="Did not inline: unknown">declareSymbolAndAddToSymbolTable</b></i>(node, 1 /* FunctionScopedVariable */, 107455 /* ParameterExcludes */);
                }
                else {
                    <b title="Inlined">🔷declareSymbolAndAddToSymbolTable</b>(node, 1 /* FunctionScopedVariable */, 107454 /* FunctionScopedVariableExcludes */);
                }
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>bindBlockScopedVariableDeclaration</summary>
<pre class="code">
(node) {
            🔶<i><b title="Did not inline: target text too big">bindBlockScopedDeclaration</b></i>(node, 2 /* BlockScopedVariable */, 107455 /* BlockScopedVariableExcludes */);
        }</pre>

</details>
<details>
<summary>declareSymbolAndAddToSymbolTable</summary>
<pre class="code">
(node, symbolFlags, symbolExcludes) {
            // Just call this directly so that the return type of this function stays "void".
            return 🔶<i><b title="Did not inline: target text too big">declareSymbolAndAddToSymbolTableWorker</b></i>(node, symbolFlags, symbolExcludes);
        }</pre>

</details>
</blockquote>



### isBlockOrCatchScoped:
<pre class="code">
(declaration) {
        return (ts.🔶<i><b title="Did not inline: unknown">getCombinedNodeFlags</b></i>(declaration) & 3 /* BlockScoped */) !== 0 ||
            <b title="Inlined">🔷isCatchClauseVariableDeclarationOrBindingElement</b>(declaration);
    }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>isCatchClauseVariableDeclarationOrBindingElement</summary>
<pre class="code">
(declaration) {
        var node = <b title="Inlined">🔷getRootDeclaration</b>(declaration);
        return node.kind === 223 /* VariableDeclaration */ && node.parent.kind === 256 /* CatchClause */;
    }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getRootDeclaration</summary>
<pre class="code">
(node) {
        while (node.kind === 174 /* BindingElement */) {
            node = node⚠️<i><b title="LoadNamedGeneric">.parent</b></i>⚠️<i><b title="LoadNamedGeneric">.parent</b></i>;
        }
        return node;
    }</pre>

</details>
</blockquote>

</details>
</blockquote>



### getCombinedNodeFlags:
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(node) {
        node = <b title="Inlined">🔷walkUpBindingElementsAndPatterns</b>(node);
        var flags = node⚠️<i><b title="LoadNamedGeneric">.flags</b></i>;
        if (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 223 /* VariableDeclaration */) {
            node = node.parent;
        }
        if (node && node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 224 /* VariableDeclarationList */) {
            flags |= node.flags;
            node = node.parent;
        }
        if (node && node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 205 /* VariableStatement */) {
            flags |= node.flags;
        }
        return flags;
    }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>walkUpBindingElementsAndPatterns</summary>
<pre class="code">
(node) {
        while (node && (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 174 /* BindingElement */ || ts.🔶<i><b title="Did not inline: unknown">isBindingPattern</b></i>(node))) {
            node = node⚠️<i><b title="LoadNamedGeneric">.parent</b></i>;
        }
        return node;
    }</pre>

</details>
</blockquote>



### isParameterDeclaration:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(node) {
        var root = <b title="Inlined">🔷getRootDeclaration</b>(node);
        return root.kind === 144 /* Parameter */;
    }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getRootDeclaration</summary>
<pre class="code">
(node) {
        while (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 174 /* BindingElement */) {
            node = node⚠️<i><b title="LoadNamedGeneric">.parent</b></i>⚠️<i><b title="LoadNamedGeneric">.parent</b></i>;
        }
        return node;
    }</pre>

</details>
</blockquote>



### checkUnreachable:
<pre class="code">
(node) {
            if (!(currentFlow.flags & 1 /* Unreachable */)) {
                return false;
            }
            if (currentFlow ⚠️<i><b title="CompareGeneric">=== unreachableFlow</b></i>) {
                var reportError = 
                // report error on all statements except empty ones
                (ts.⚠️<i><b title="LoadNamedGeneric">isStatementButNotDeclaration</b></i>(node) && node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">!== 206</b></i> /* EmptyStatement */) ||
                    // report error on class declarations
                    node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 226</b></i> /* ClassDeclaration */ ||
                    // report error on instantiated modules or const-enums only modules if preserveConstEnums is set
                    (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 230</b></i> /* ModuleDeclaration */ && 🔶️<i><b title="CallWithDescriptor">shouldReportErrorOnModuleDeclaration</b></i>(node)) ||
                    // report error on regular enums and const enums if preserveConstEnums is set
                    (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 229</b></i> /* EnumDeclaration */ && (!ts.🔶️<i><b title="CallWithDescriptor">isConstEnumDeclaration</b></i>(node) || options⚠️<i><b title="LoadNamedGeneric">.preserveConstEnums</b></i>));
                if (reportError) {
                    currentFlow = reportedUnreachableFlow;
                    // unreachable code is reported if
                    // - user has explicitly asked about it AND
                    // - statement is in not ambient context (statements in ambient context is already an error
                    //   so we should not report extras) AND
                    //   - node is not variable statement OR
                    //   - node is block scoped variable statement OR
                    //   - node is not block scoped variable statement and at least one variable declaration has initializer
                    //   Rationale: we don't want to report errors on non-initialized var's since they are hoisted
                    //   On the other side we do want to report errors on non-initialized 'lets' because of TDZ
                    var reportUnreachableCode = !options⚠️<i><b title="LoadNamedGeneric">.allowUnreachableCode</b></i> &&
                        !ts.⚠️<i><b title="LoadNamedGeneric">isInAmbientContext</b></i>(node) &&
                        (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">!== 205</b></i> /* VariableStatement */ ||
                            ts.🔶<i><b title="Did not inline: unknown">getCombinedNodeFlags</b></i>(node⚠️<i><b title="LoadNamedGeneric">.declarationList</b></i>) ⚠️<i><b title="Bitwise">& 3</b></i> /* BlockScoped */ ||
                            ts.⚠️<i><b title="LoadNamedGeneric">forEach</b></i>(node⚠️<i><b title="LoadNamedGeneric">.declarationList</b></i>⚠️<i><b title="LoadNamedGeneric">.declarations</b></i>, 🔶️<i><b title="CallWithDescriptor">function</b></i> (d) { return d.initializer; }));
                    if (reportUnreachableCode) {
                        🔶️<i><b title="CallWithDescriptor">errorOnFirstToken</b></i>(node, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Unreachable_code_detected</b></i>);
                    }
                }
            }
            return true;
        }</pre>



### bindChildren:
<pre class="code">
(node) {
            if (skipTransformFlagAggregation) {
                🔶<i><b title="Did not inline: target text too big">bindChildrenWorker</b></i>(node);
            }
            else if (node⚠️<i><b title="LoadNamedGeneric">.transformFlags</b></i> ⚠️<i><b title="Bitwise">& 536870912</b></i> /* HasComputedFlags */) {
                skipTransformFlagAggregation = true;
                🔶<i><b title="Did not inline: target text too big">bindChildrenWorker</b></i>(node);
                skipTransformFlagAggregation = false;
                subtreeTransformFlags |⚠️<i><b title="Bitwise">= node</b></i>⚠️<i><b title="LoadNamedGeneric">.transformFlags</b></i> ⚠️<i><b title="Bitwise">& ~ge</b></i>tTransformFlagsSubtreeExclusions(node⚠️<i><b title="LoadNamedGeneric">.kind</b></i>);
            }
            else {
                var savedSubtreeTransformFlags = subtreeTransformFlags;
                subtreeTransformFlags = 0;
                🔶<i><b title="Did not inline: target text too big">bindChildrenWorker</b></i>(node);
                subtreeTransformFlags = savedSubtreeTransformFlags ⚠️<i><b title="Bitwise">| computeTransformFlagsForNode</b></i>(node, subtreeTransformFlags);
            }
        }</pre>



### hasDynamicName:
<pre class="code">
(declaration) {
        return declaration⚠️<i><b title="LoadNamedGeneric">.name</b></i> && <b title="Inlined">🔷isDynamicName</b>(declaration.name);
    }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>isDynamicName</summary>
<pre class="code">
(name) {
        return name.kind === 142 /* ComputedPropertyName */ &&
            !🔶️<i><b title="CallWithDescriptor">isStringOrNumericLiteral</b></i>(name⚠️<i><b title="LoadNamedGeneric">.expression</b></i>) &&
            !🔶️<i><b title="CallWithDescriptor">isWellKnownSymbolSyntactically</b></i>(name⚠️<i><b title="LoadNamedGeneric">.expression</b></i>);
    }</pre>

</details>
</blockquote>



### getModifierFlags:
<pre class="code">
(node) {
        if (node⚠️<i><b title="LoadNamedGeneric">.modifierFlagsCache</b></i> & 536870912 /* HasComputedFlags */) {
            return node⚠️<i><b title="LoadNamedGeneric">.modifierFlagsCache</b></i> & ~536870912 /* HasComputedFlags */;
        }
        var flags = 0 /* None */;
        if (node⚠️<i><b title="LoadNamedGeneric">.modifiers</b></i>) {
            for (var _i = 0, _a = node.modifiers; _i &lt; _a.length; _i++) {
                var modifier = _a[_i];
                flags |= 🔶<i><b title="Did not inline: target text too big">modifierToFlag</b></i>(modifier.kind);
            }
        }
        if (node⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 4 /* NestedNamespace */ || (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 70 /* Identifier */ && node⚠️<i><b title="LoadNamedGeneric">.isInJSDocNamespace</b></i>)) {
            flags |⚠️<i><b title="Bitwise">= 1</b></i> /* Export */;
        }
        node.modifierFlagsCache ⚠️<i><b title="StoreNamedGeneric">= flags</b></i> | 536870912 /* HasComputedFlags */;
        return flags;
    }</pre>



### checkStrictModeIdentifier:
<pre class="code">
(node) {
            if (inStrictMode &&
                node⚠️<i><b title="LoadNamedGeneric">.originalKeywordKind</b></i> ⚠️<i><b title="CompareGeneric">>= 107</b></i> /* FirstFutureReservedWord */ &&
                node⚠️<i><b title="LoadNamedGeneric">.originalKeywordKind</b></i> &lt;= 115 /* LastFutureReservedWord */ &&
                !ts.🔶️<i><b title="CallWithDescriptor">isIdentifierName</b></i>(node) &&
                !ts.🔶<i><b title="Did not inline: unknown">isInAmbientContext</b></i>(node)) {
                // Report error only if there are no parse errors in file
                if (!file⚠️<i><b title="LoadNamedGeneric">.parseDiagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.length</b></i>) {
                    file⚠️<i><b title="LoadNamedGeneric">.bindDiagnostics</b></i>.🔶️<i><b title="CallWithDescriptor">push</b></i>(ts.🔶️<i><b title="CallWithDescriptor">createDiagnosticForNode</b></i>(node, 🔶️<i><b title="CallWithDescriptor">getStrictModeIdentifierMessage</b></i>(node), ts.🔶️<i><b title="CallWithDescriptor">declarationNameToString</b></i>(node)));
                }
            }
        }</pre>



### ⛔ createMap (deoptimizated):
<div>~recompile~</div>

```diff
- Deopt: <JS Function createMap (SharedFunctionInfo 0xc2bd2ae0b29)> (opt #246) @20, FP to SP delta: 72, caller sp: 0x7fff5fbfd6d0
```

```diff
- Deopt: <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> (opt #235) @264, FP to SP delta: 752, caller sp: 0x7fff5fbfd328
```

```diff
- Deopt: <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> (opt #235) @380, FP to SP delta: 752, caller sp: 0x7fff5fbfd730
```

```diff
- Deopt: <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> (opt #235) @132, FP to SP delta: 752, caller sp: 0x7fff5fbfdc28
```

<div>~recompile~</div>

```diff
- Deopt: <JS Function createMap (SharedFunctionInfo 0xc2bd2ae0b29)> (opt #273) @20, FP to SP delta: 72, caller sp: 0x7fff5fbfc4a8
```

```diff
- Deopt: <JS Function isAmbientModule (SharedFunctionInfo 0x3504a53cd0d9)> (opt #192) @4, FP to SP delta: 24, caller sp: 0x7fff5fbfcbd0
```

```diff
- Deopt: <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> (opt #271) @118, FP to SP delta: 776, caller sp: 0x7fff5fbfce38
```

```diff
- Deopt: <JS Function getCombinedNodeFlags (SharedFunctionInfo 0x3504a53df441)> (opt #239) @16, FP to SP delta: 48, caller sp: 0x7fff5fbfc428
```

```diff
- Deopt: <JS Function declareModuleMember (SharedFunctionInfo 0x16f3adb58121)> (opt #272) @18, FP to SP delta: 72, caller sp: 0x7fff5fbfc418
```

<div>~recompile~</div>
<pre class="code">
(template) {
        var map = createObject(null); // tslint:disable-line:no-null-keyword
        // Using 'delete' on an object causes V8 to put the object in dictionary mode.
        // This disables creation of hidden classes, which are expensive when an object is
        // constantly changing shape.
        map["__"] = undefined;
        🔶️<i><b title="CallWithDescriptor">delete</b></i> map["__"];
        // Copies keys/values from template. Note that for..in will not throw if
        // template is undefined, and instead will just exit the loop.
        🔶️<i><b title="CallWithDescriptor">for</b></i> (var key in template)
            if (hasOwnProperty.🔶️<i><b title="CallWithDescriptor">call</b></i>(template, key)) {
                map[key] ⚠️<i><b title="StoreKeyedGeneric">= template</b></i>⚠️<i><b title="LoadKeyedGeneric">[key]</b></i>;
            }
        return map;
    }</pre>

```diff
- Deopt: <JS Function createMap (SharedFunctionInfo 0xc2bd2ae0b29)> (opt #554) @20, FP to SP delta: 72, caller sp: 0x7fff5fbfd2e0
```



### ⛔ getDeclarationName (deoptimizated):
<pre class="code">
(node) {
            if (node⚠️<i><b title="LoadNamedGeneric">.name</b></i>) {
                if (ts.🔶<i><b title="Did not inline: unknown">isAmbientModule</b></i>(node)) {
                    return ts.🔶️<i><b title="CallWithDescriptor">isGlobalScopeAugmentation</b></i>(node) ? "__global" : "\x5c"" + n⚠️<i><b title="LoadNamedGeneric">ode</b></i>.n⚠️<i><b title="LoadNamedGeneric">ame</b></i>.text + "\x5c"";
                }
                if⚠️<i><b title="LoadNamedGeneric"> (nod</b></i>e.name.kind === 142 /* ComputedPropertyName */) {
                    var nameExpression ⚠️<i><b title="LoadNamedGeneric">= node</b></i>.name.expression;
                    // treat computed property names where expression is string/numeric literal as just string/numeric literal
                    i⚠️<i><b title="LoadNamedGeneric">f</b></i> (ts.isStringOrNumericLiteral(nameExpression)) {
                        return nameExpr⚠️<i><b title="LoadNamedGeneric">ession</b></i>.text;
                    }
                ⚠️<i><b title="LoadNamedGeneric">    ts</b></i>.⚠️<i><b title="LoadNamedGeneric">Debug</b></i>.asse🔶️<i><b title="CallWithDescriptor">rt</b></i>(ts.isWellKnownSymbolSyntactically(nameExpression));
                    retu🔶️<i><b title="CallWithDescriptor">rn</b></i> ts.getPropertyNameForKnownSymbolName(nameExpr⚠️<i><b title="LoadNamedGeneric">ession</b></i>.name.text);
                }
                return node.name.text;
            }
      ⚠️<i><b title="CompareGeneric">      switch</b></i> (node.kind) {
                case 150 /* Constructor */:
                    return "__constructor";
                case 158 /* FunctionType */:
                case 153 /* CallSignature */:
                    return "__call";
                case 159 /* ConstructorType */:
                case 154 /* ConstructSignature */:
                    return "__new";
                case 155 /* IndexSignature */:
                    return "__index";
                case 241 /* ExportDeclaration */:
                    return "__export";
                case 240 /* ExportAssignment */:
                    retur⚠️<i><b title="LoadNamedGeneric">n</b></i> node.isExportEquals ? "export=" : "default";
                case 192 /* BinaryExpression */:
              ⚠️<i><b title="CompareGeneric">      switch</b></i> (ts.getSpecialPropertyAssignmentKind(node)) {
                        case 2 /* ModuleExports */:
                            // module.exports = ...
                            return "export=";
                        case 1 /* ExportsProperty */:
                        case 4 /* ThisProperty */:
                            // exports.x = ... or this.y = ...
                            retur⚠️<i><b title="LoadNamedGeneric">n</b></i> nod⚠️<i><b title="LoadNamedGeneric">e</b></i>.lef⚠️<i><b title="LoadNamedGeneric">t</b></i>.name.text;
                        case 3 /* PrototypeProperty */:
                            // className.prototype.methodName = ...
                            retur⚠️<i><b title="LoadNamedGeneric">n</b></i> nod⚠️<i><b title="LoadNamedGeneric">e</b></i>.left.expr⚠️<i><b title="LoadNamedGeneric">ession</b></i>.name.text;
                    }
                ⚠️<i><b title="LoadNamedGeneric">    ts</b></i>.⚠️<i><b title="LoadNamedGeneric">Debug</b></i>.fail("Unknown binary declaration kind");
                    break;
                case 225 /* FunctionDeclaration */:
                case 226 /* ClassDeclaration */:
                    retu🔶️<i><b title="CallWithDescriptor">rn</b></i> ts.hasModifier(node, 512 /* Default */) ? "default" : undefined;
                case 274 /* JSDocFunctionType */:
                    retu⚠️<i><b title="LoadNamedGeneric">rn</b></i> ts.isJSDocConstructSignature(node) ? "__new" : "__call";
                case 144 /* Parameter */:
                    // Parameters with names are handled at the top of this function.  Parameters
                    // without names can only come from JSDocFunctionTypes.
                ⚠️<i><b title="LoadNamedGeneric">    ts</b></i>.⚠️<i><b title="LoadNamedGeneric">Debug</b></i>.asser⚠️<i><b title="LoadNamedGeneric">t</b></i>(node.⚠️<i><b title="LoadNamedGeneric">parent</b></i>⚠️<i><b title="CompareGeneric">.kind</b></i> === 274 /* JSDocFunctionType */);
                    var functionType ⚠️<i><b title="LoadNamedGeneric">= node</b></i>.parent;
                    var index🔶️<i><b title="CallWithDescriptor"> = ts</b></i>.indexOf(functi⚠️<i><b title="LoadNamedGeneric">onType</b></i>.parameters, node);
                    return "arg" + index;
                case 285 /* JSDocTypedefTag */:
                    var parentNode ⚠️<i><b title="LoadNamedGeneric">= node</b></i>.parent &⚠️<i><b title="LoadNamedGeneric">& node</b></i>.⚠️<i><b title="LoadNamedGeneric">parent</b></i>.parent;
                    var nameFromParentNode = void 0;
                    if (parentNode && pare⚠️<i><b title="LoadNamedGeneric">ntNode</b></i>⚠️<i><b title="CompareGeneric">.kind</b></i> === 205 /* VariableStatement */) {
                        if (pare⚠️<i><b title="LoadNamedGeneric">ntNode</b></i>.declarati⚠️<i><b title="LoadNamedGeneric">onList</b></i>.declar⚠️<i><b title="LoadNamedGeneric">ations</b></i>.l⚠️<i><b title="CompareGeneric">ength</b></i> &gt; 0) {
                            var nameIdentifier = pare⚠️<i><b title="LoadNamedGeneric">ntNode</b></i>.declarati⚠️<i><b title="LoadNamedGeneric">onList</b></i>.declar⚠️<i><b title="LoadKeyedGeneric">ations</b></i>[0].name;
                            if (nameIden⚠️<i><b title="LoadNamedGeneric">tifier</b></i>⚠️<i><b title="CompareGeneric">.kind</b></i> === 70 /* Identifier */) {
                                nameFromParentNode = nameIden⚠️<i><b title="LoadNamedGeneric">tifier</b></i>.text;
                            }
                        }
                    }
                    return nameFromParentNode;
            }
        }</pre>

```diff
- Deopt: <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> (opt #247) @289, FP to SP delta: 752, caller sp: 0x7fff5fbfdc28
```



### ⛔ visitNode (deoptimizated):
<pre class="code">
(cbNode, node) {
        if (node) {
            return 🔶️<i><b title="CallWithDescriptor">cbNode</b></i>(node);
        }
    }</pre>

```diff
- Deopt: <JS Function addDeclarationToSymbol (SharedFunctionInfo 0x16f3adb57e21)> (opt #233) @30, FP to SP delta: 48, caller sp: 0x7fff5fbfdb18
```



### checkStrictModeEvalOrArguments:
<pre class="code">
(contextNode, name) {
            if (name && name.kind === 70 /* Identifier */) {
                var identifier = name;
                if (<b title="Inlined">🔷isEvalOrArgumentsIdentifier</b>(identifier)) {
                    // We check first if the name is inside class declaration or class expression; if so give explicit message
                    // otherwise report generic error message.
                    var span_3 = ts.⚠️<i><b title="LoadNamedGeneric">getErrorSpanForNode</b></i>(file, name);
                    file⚠️<i><b title="LoadNamedGeneric">.bindDiagnostics</b></i>.🔶️<i><b title="CallWithDescriptor">push</b></i>(ts.🔶️<i><b title="CallWithDescriptor">createFileDiagnostic</b></i>(file, span_3⚠️<i><b title="LoadNamedGeneric">.start</b></i>, span_3⚠️<i><b title="LoadNamedGeneric">.length</b></i>, 🔶️<i><b title="CallWithDescriptor">getStrictModeEvalOrArgumentsMessage</b></i>(contextNode), identifier⚠️<i><b title="LoadNamedGeneric">.text</b></i>));
                }
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>isEvalOrArgumentsIdentifier</summary>
<pre class="code">
(node) {
            return node.kind === 70 /* Identifier */ &&
                (node.text === "eval" || node.text === "arguments");
        }</pre>

</details>
</blockquote>



### getCombinedModifierFlags:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(node) {
        node = <b title="Inlined">🔷walkUpBindingElementsAndPatterns</b>(node);
        var flags = ts.🔶<i><b title="Did not inline: target text too big">getModifierFlags</b></i>(node);
        if (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 223 /* VariableDeclaration */) {
            node = node.parent;
        }
        if (node && node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 224 /* VariableDeclarationList */) {
            flags |= ts.🔶<i><b title="Did not inline: target text too big">getModifierFlags</b></i>(node);
            node = node.parent;
        }
        if (node && node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 205 /* VariableStatement */) {
            flags |= ts.🔶<i><b title="Did not inline: target text too big">getModifierFlags</b></i>(node);
        }
        return flags;
    }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>walkUpBindingElementsAndPatterns</summary>
<pre class="code">
(node) {
        while (node && (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 174 /* BindingElement */ || ts.🔶<i><b title="Did not inline: unknown">isBindingPattern</b></i>(node))) {
            node = node⚠️<i><b title="LoadNamedGeneric">.parent</b></i>;
        }
        return node;
    }</pre>

</details>
</blockquote>



### bindFunctionDeclaration:
<pre class="code">
(node) {
            if (!ts.🔶️<i><b title="CallWithDescriptor">isDeclarationFile</b></i>(file) && !ts.⚠️<i><b title="LoadNamedGeneric">isInAmbientContext</b></i>(node)) {
                if (ts.🔶<i><b title="Did not inline: unknown">isAsyncFunctionLike</b></i>(node)) {
                    emitFlags |⚠️<i><b title="Bitwise">= 1024</b></i> /* HasAsyncFunctions */;
                }
            }
            <b title="Inlined">🔷checkStrictModeFunctionName</b>(node);
            if (inStrictMode) {
                🔶️<i><b title="CallWithDescriptor">checkStrictModeFunctionDeclaration</b></i>(node);
                🔶<i><b title="Did not inline: target text too big">bindBlockScopedDeclaration</b></i>(node, 16 /* Function */, 106927 /* FunctionExcludes */);
            }
            else {
                <b title="Inlined">🔷declareSymbolAndAddToSymbolTable</b>(node, 16 /* Function */, 106927 /* FunctionExcludes */);
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>checkStrictModeFunctionName</summary>
<pre class="code">
(node) {
            if (inStrictMode) {
                // It is a SyntaxError if the identifier eval or arguments appears within a FormalParameterList of a strict mode FunctionDeclaration or FunctionExpression (13.1))
                🔶<i><b title="Did not inline: target text too big">checkStrictModeEvalOrArguments</b></i>(node, node⚠️<i><b title="LoadNamedGeneric">.name</b></i>);
            }
        }</pre>

</details>
<details>
<summary>declareSymbolAndAddToSymbolTable</summary>
<pre class="code">
(node, symbolFlags, symbolExcludes) {
            // Just call this directly so that the return type of this function stays "void".
            return 🔶<i><b title="Did not inline: target text too big">declareSymbolAndAddToSymbolTableWorker</b></i>(node, symbolFlags, symbolExcludes);
        }</pre>

</details>
</blockquote>



### ⛔ declareModuleMember (deoptimizated):
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(node, symbolFlags, symbolExcludes) {
            var hasExportModifier = ts.🔶<i><b title="Did not inline: unknown">getCombinedModifierFlags</b></i>(node) & 1 /* Export */;
            if (symbolFlags & 8388608 /* Alias */) {
                if (node.kind === 243 /* ExportSpecifier */ || (node.kind === 234 /* ImportEqualsDeclaration */ && hasExportModifier)) {
                    return 🔶<i><b title="Did not inline: target text too big">declareSymbol</b></i>(container.symbol.exports, container.symbol, node, symbolFlags, symbolExcludes);
                }
                else {
                    return 🔶<i><b title="Did not inline: target text too big">declareSymbol</b></i>(container.locals, undefined, node, symbolFlags, symbolExcludes);
                }
            }
            else {
                // Exported module members are given 2 symbols: A local symbol that is classified with an ExportValue,
                // ExportType, or ExportContainer flag, and an associated export symbol with all the correct flags set
                // on it. There are 2 main reasons:
                //
                //   1. We treat locals and exports of the same name as mutually exclusive within a container.
                //      That means the binder will issue a Duplicate Identifier error if you mix locals and exports
                //      with the same name in the same container.
                //      TODO: Make this a more specific error and decouple it from the exclusion logic.
                //   2. When we checkIdentifier in the checker, we set its resolved symbol to the local symbol,
                //      but return the export symbol (by calling getExportSymbolOfValueSymbolIfExported). That way
                //      when the emitter comes back to it, it knows not to qualify the name if it was found in a containing scope.
                // NOTE: Nested ambient modules always should go to to 'locals' table to prevent their automatic merge
                //       during global merging in the checker. Why? The only case when ambient module is permitted inside another module is module augmentation
                //       and this case is specially handled. Module augmentations should only be merged with original module definition
                //       and should never be merged directly with other augmentation, and the latter case would be possible if automatic merge is allowed.
                var isJSDocTypedefInJSDocNamespace = node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 285 /* JSDocTypedefTag */ &&
                    node⚠️<i><b title="LoadNamedGeneric">.name</b></i> &&
                    node⚠️<i><b title="LoadNamedGeneric">.name</b></i>⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 70</b></i> /* Identifier */ &&
                    node⚠️<i><b title="LoadNamedGeneric">.name</b></i>⚠️<i><b title="LoadNamedGeneric">.isInJSDocNamespace</b></i>;
                if ((!ts.⚠️<i><b title="LoadNamedGeneric">isAmbientModule</b></i>(node) && (hasExportModifier || container.flags & 32 /* ExportContext */)) || isJSDocTypedefInJSDocNamespace) {
                    var exportKind = (symbolFlags & 107455 /* Value */ ? 1048576 /* ExportValue */ : 0) |
                        (symbolFlags & 793064 /* Type */ ? 2097152 /* ExportType */ : 0) |
                        (symbolFlags & 1920 /* Namespace */ ? 4194304 /* ExportNamespace */ : 0);
                    var local = declareSymbol(container.locals, undefined, node, exportKind, symbolExcludes);
                    local.exportSymbol = 🔶<i><b title="Did not inline: target text too big">declareSymbol</b></i>(container.symbol.exports, container.symbol, node, symbolFlags, symbolExcludes);
                    node.localSymbol ⚠️<i><b title="StoreNamedGeneric">= local</b></i>;
                    return local;
                }
                else {
                    return 🔶<i><b title="Did not inline: target text too big">declareSymbol</b></i>(container.locals, undefined, node, symbolFlags, symbolExcludes);
                }
            }
        }</pre>

```diff
- Deopt: <JS Function forEachChild (SharedFunctionInfo 0x3504a53f01a9)> (opt #250) @177, FP to SP delta: 752, caller sp: 0x7fff5fbfdf50
```

```diff
- Deopt: <JS Function bindContainer (SharedFunctionInfo 0x16f3adb581e1)> (opt #232) @25, FP to SP delta: 168, caller sp: 0x7fff5fbfe0c0
```



### declareClassMember:
<pre class="code">
(node, symbolFlags, symbolExcludes) {
            return ts.🔶<i><b title="Did not inline: unknown">hasModifier</b></i>(node, 32 /* Static */)
                ? 🔶<i><b title="Did not inline: target text too big">declareSymbol</b></i>(container.symbol.exports, container.symbol, node, symbolFlags, symbolExcludes)
                : 🔶<i><b title="Did not inline: target text too big">declareSymbol</b></i>(container.symbol.members, container.symbol, node, symbolFlags, symbolExcludes);
        }</pre>



### isDeclarationKind:
<pre class="code">
(kind) {
        return kind === 185 /* ArrowFunction */
            || kind === 174 /* BindingElement */
            || kind === 226 /* ClassDeclaration */
            || kind === 197 /* ClassExpression */
            || kind === 150 /* Constructor */
            || kind === 229 /* EnumDeclaration */
            || kind === 260 /* EnumMember */
            || kind === 243 /* ExportSpecifier */
            || kind === 225 /* FunctionDeclaration */
            || kind === 184 /* FunctionExpression */
            || kind === 151 /* GetAccessor */
            || kind === 236 /* ImportClause */
            || kind === 234 /* ImportEqualsDeclaration */
            || kind === 239 /* ImportSpecifier */
            || kind === 227 /* InterfaceDeclaration */
            || kind === 149 /* MethodDeclaration */
            || kind === 148 /* MethodSignature */
            || kind === 230 /* ModuleDeclaration */
            || kind === 233 /* NamespaceExportDeclaration */
            || kind === 237 /* NamespaceImport */
            || kind === 144 /* Parameter */
            || kind === 257 /* PropertyAssignment */
            || kind === 147 /* PropertyDeclaration */
            || kind === 146 /* PropertySignature */
            || kind === 152 /* SetAccessor */
            || kind === 258 /* ShorthandPropertyAssignment */
            || kind === 228 /* TypeAliasDeclaration */
            || kind === 143 /* TypeParameter */
            || kind === 223 /* VariableDeclaration */
            || kind === 285 /* JSDocTypedefTag */;
    }</pre>



### ⛔ checkGrammarTopLevelElementForRequiredDeclareModifier (deoptimizated):
<pre class="code">
(node) {
            // A declare modifier is required for any top level .d.ts declaration except export=, export default, export as namespace
            // interfaces and imports categories:
            //
            //  DeclarationElement:
            //     ExportAssignment
            //     export_opt   InterfaceDeclaration
            //     export_opt   TypeAliasDeclaration
            //     export_opt   ImportDeclaration
            //     export_opt   ExternalImportDeclaration
            //     export_opt   AmbientDeclaration
            //
            // TODO: The spec needs to be amended to reflect this grammar.
            if (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 227 /* InterfaceDeclaration */ ||
                node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 228 /* TypeAliasDeclaration */ ||
                node.kind === 235 /* ImportDeclaration */ ||
                node.kind === 234 /* ImportEqualsDeclaration */ ||
                node.kind === 241 /* ExportDeclaration */ ||
                node.kind === 240 /* ExportAssignment */ ||
                node.kind === 233 /* NamespaceExportDeclaration */ ||
                ts.🔶<i><b title="Did not inline: target text too big">getModifierFlags</b></i>(node) & (2 /* Ambient */ | 1 /* Export */ | 512 /* Default */)) {
                return false;
            }
            return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnFirstToken</b></i>(node, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.A_declare_modifier_is_required_for_a_top_level_declaration_in_a_d_ts_file</b></i>);
        }</pre>

```diff
- Deopt: <JS Function checkGrammarTopLevelElementForRequiredDeclareModifier (SharedFunctionInfo 0x1b98fbc15611)> (opt #288) @4, FP to SP delta: 32, caller sp: 0x7fff5fbfe0a8
```

```diff
- Deopt: <JS Function hasDynamicName (SharedFunctionInfo 0x3504a53d2299)> (opt #243) @6, FP to SP delta: 32, caller sp: 0x7fff5fbfdfb8
```

```diff
- Deopt: <JS Function forEach (SharedFunctionInfo 0xc2bd2ae0d69)> (opt #228) @8, FP to SP delta: 40, caller sp: 0x7fff5fbfdfb8
```

```diff
- Deopt: <JS Function forEach (SharedFunctionInfo 0xc2bd2ae0d69)> (opt #228) @7, FP to SP delta: 40, caller sp: 0x7fff5fbfe130
```

```diff
- Deopt: <JS Function isDynamicName (SharedFunctionInfo 0x3504a53d2359)> (opt #229) @2, FP to SP delta: 24, caller sp: 0x7fff5fbfdf78
```



### getMergedSymbol:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(symbol) {
            var merged;
            return symbol && symbol⚠️<i><b title="LoadNamedGeneric">.mergeId</b></i> && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }</pre>



### getSymbolId:
<pre class="code">
(symbol) {
        if (!symbol⚠️<i><b title="LoadNamedGeneric">.id</b></i>) {
            symbol.id ⚠️<i><b title="StoreNamedGeneric">= nextSymbolId</b></i>;
            nextSymbolId++;
        }
        return symbol.id;
    }</pre>



### reportObviousModifierErrors:
<pre class="code">
(node) {
            return !node⚠️<i><b title="LoadNamedGeneric">.modifiers</b></i>
                ? false
                : 🔶<i><b title="Did not inline: target text too big">shouldReportBadModifier</b></i>(node)
                    ? 🔶️<i><b title="CallWithDescriptor">grammarErrorOnFirstToken</b></i>(node, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Modifiers_cannot_appear_here</b></i>)
                    : undefined;
        }</pre>



### checkSourceElement:
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(node) {
            if (!node) {
                return;
            }
            var kind = node.kind;
            if (cancellationToken) {
                // Only bother checking on a few construct kinds.  We don't want to be excessively
                // hitting the cancellation token on every node we check.
                ⚠️<i><b title="CompareGeneric">switch</b></i> (kind) {
                    case 230 /* ModuleDeclaration */:
                    case 226 /* ClassDeclaration */:
                    case 227 /* InterfaceDeclaration */:
                    case 225 /* FunctionDeclaration */:
                        cancellationToken.⚠️<i><b title="LoadNamedGeneric">throwIfCancellationRequested</b></i>();
                }
            }
            switch (kind) {
                case 143 /* TypeParameter */:
                    return <b title="Inlined">🔷checkTypeParameter</b>(node);
                case 144 /* Parameter */:
                    return 🔶<i><b title="Did not inline: unknown">checkParameter</b></i>(node);
                case 147 /* PropertyDeclaration */:
                case 146 /* PropertySignature */:
                    return <b title="Inlined">🔷checkPropertyDeclaration</b>(node);
                case 158 /* FunctionType */:
                case 159 /* ConstructorType */:
                case 153 /* CallSignature */:
                case 154 /* ConstructSignature */:
                    return 🔶<i><b title="Did not inline: target text too big">checkSignatureDeclaration</b></i>(node);
                case 155 /* IndexSignature */:
                    return 🔶<i><b title="Did not inline: target text too big">checkSignatureDeclaration</b></i>(node);
                case 149 /* MethodDeclaration */:
                case 148 /* MethodSignature */:
                    return 🔶<i><b title="Did not inline: target text too big">checkMethodDeclaration</b></i>(node);
                case 150 /* Constructor */:
                    return 🔶️<i><b title="CallWithDescriptor">checkConstructorDeclaration</b></i>(node);
                case 151 /* GetAccessor */:
                case 152 /* SetAccessor */:
                    return 🔶️<i><b title="CallWithDescriptor">checkAccessorDeclaration</b></i>(node);
                case 157 /* TypeReference */:
                    return 🔶<i><b title="Did not inline: target text too big">checkTypeReferenceNode</b></i>(node);
                case 156 /* TypePredicate */:
                    return 🔶️<i><b title="CallWithDescriptor">checkTypePredicate</b></i>(node);
                case 160 /* TypeQuery */:
                    return <b title="Inlined">🔷checkTypeQuery</b>(node);
                case 161 /* TypeLiteral */:
                    return <b title="Inlined">🔷checkTypeLiteral</b>(node);
                case 162 /* ArrayType */:
                    return 🔶<i><b title="Did not inline: unknown">checkArrayType</b></i>(node);
                case 163 /* TupleType */:
                    return 🔶️<i><b title="CallWithDescriptor">checkTupleType</b></i>(node);
                case 164 /* UnionType */:
                case 165 /* IntersectionType */:
                    return 🔶<i><b title="Did not inline: unknown">checkUnionOrIntersectionType</b></i>(node);
                case 166 /* ParenthesizedType */:
                case 168 /* TypeOperator */:
                    return 🔶<i><b title="Did not inline: target text too big">checkSourceElement</b></i>(node.type);
                case 169 /* IndexedAccessType */:
                    return 🔶<i><b title="Did not inline: unknown">checkIndexedAccessType</b></i>(node);
                case 170 /* MappedType */:
                    return 🔶️<i><b title="CallWithDescriptor">checkMappedType</b></i>(node);
                case 225 /* FunctionDeclaration */:
                    return 🔶<i><b title="Did not inline: unknown">checkFunctionDeclaration</b></i>(node);
                case 204 /* Block */:
                case 231 /* ModuleBlock */:
                    return 🔶️<i><b title="CallWithDescriptor">checkBlock</b></i>(node);
                case 205 /* VariableStatement */:
                    return 🔶<i><b title="Did not inline: unknown">checkVariableStatement</b></i>(node);
                case 207 /* ExpressionStatement */:
                    return 🔶️<i><b title="CallWithDescriptor">checkExpressionStatement</b></i>(node);
                case 208 /* IfStatement */:
                    return 🔶️<i><b title="CallWithDescriptor">checkIfStatement</b></i>(node);
                case 209 /* DoStatement */:
                    return 🔶️<i><b title="CallWithDescriptor">checkDoStatement</b></i>(node);
                case 210 /* WhileStatement */:
                    return 🔶️<i><b title="CallWithDescriptor">checkWhileStatement</b></i>(node);
                case 211 /* ForStatement */:
                    return 🔶️<i><b title="CallWithDescriptor">checkForStatement</b></i>(node);
                case 212 /* ForInStatement */:
                    return 🔶️<i><b title="CallWithDescriptor">checkForInStatement</b></i>(node);
                case 213 /* ForOfStatement */:
                    return 🔶️<i><b title="CallWithDescriptor">checkForOfStatement</b></i>(node);
                case 214 /* ContinueStatement */:
                case 215 /* BreakStatement */:
                    return 🔶️<i><b title="CallWithDescriptor">checkBreakOrContinueStatement</b></i>(node);
                case 216 /* ReturnStatement */:
                    return 🔶️<i><b title="CallWithDescriptor">checkReturnStatement</b></i>(node);
                case 217 /* WithStatement */:
                    return 🔶️<i><b title="CallWithDescriptor">checkWithStatement</b></i>(node);
                case 218 /* SwitchStatement */:
                    return 🔶️<i><b title="CallWithDescriptor">checkSwitchStatement</b></i>(node);
                case 219 /* LabeledStatement */:
                    return 🔶️<i><b title="CallWithDescriptor">checkLabeledStatement</b></i>(node);
                case 220 /* ThrowStatement */:
                    return 🔶️<i><b title="CallWithDescriptor">checkThrowStatement</b></i>(node);
                case 221 /* TryStatement */:
                    return 🔶️<i><b title="CallWithDescriptor">checkTryStatement</b></i>(node);
                case 223 /* VariableDeclaration */:
                    return 🔶<i><b title="Did not inline: unknown">checkVariableDeclaration</b></i>(node);
                case 174 /* BindingElement */:
                    return 🔶️<i><b title="CallWithDescriptor">checkBindingElement</b></i>(node);
                case 226 /* ClassDeclaration */:
                    return 🔶️<i><b title="CallWithDescriptor">checkClassDeclaration</b></i>(node);
                case 227 /* InterfaceDeclaration */:
                    return 🔶️<i><b title="CallWithDescriptor">checkInterfaceDeclaration</b></i>(node);
                case 228 /* TypeAliasDeclaration */:
                    return 🔶️<i><b title="CallWithDescriptor">checkTypeAliasDeclaration</b></i>(node);
                case 229 /* EnumDeclaration */:
                    return 🔶️<i><b title="CallWithDescriptor">checkEnumDeclaration</b></i>(node);
                case 230 /* ModuleDeclaration */:
                    return 🔶️<i><b title="CallWithDescriptor">checkModuleDeclaration</b></i>(node);
                case 235 /* ImportDeclaration */:
                    return 🔶️<i><b title="CallWithDescriptor">checkImportDeclaration</b></i>(node);
                case 234 /* ImportEqualsDeclaration */:
                    return 🔶️<i><b title="CallWithDescriptor">checkImportEqualsDeclaration</b></i>(node);
                case 241 /* ExportDeclaration */:
                    return 🔶️<i><b title="CallWithDescriptor">checkExportDeclaration</b></i>(node);
                case 240 /* ExportAssignment */:
                    return 🔶️<i><b title="CallWithDescriptor">checkExportAssignment</b></i>(node);
                case 206 /* EmptyStatement */:
                    🔶️<i><b title="CallWithDescriptor">checkGrammarStatementInAmbientContext</b></i>(node);
                    return;
                case 222 /* DebuggerStatement */:
                    🔶️<i><b title="CallWithDescriptor">checkGrammarStatementInAmbientContext</b></i>(node);
                    return;
                case 244 /* MissingDeclaration */:
                    return 🔶️<i><b title="CallWithDescriptor">checkMissingDeclaration</b></i>(node);
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>checkTypeParameter</summary>
<pre class="code">
(node) {
            // Grammar Checking
            if (node.expression) {
                🔶️<i><b title="CallWithDescriptor">grammarErrorOnFirstToken</b></i>(node⚠️<i><b title="LoadNamedGeneric">.expression</b></i>, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Type_expected</b></i>);
            }
            🔶<i><b title="Did not inline: target text too big">checkSourceElement</b></i>(node.constraint);
            🔶<i><b title="Did not inline: target text too big">getConstraintOfTypeParameter</b></i>(<b title="Inlined">🔷getDeclaredTypeOfTypeParameter</b>(<b title="Inlined">🔷getSymbolOfNode</b>(node)));
            if (produceDiagnostics) {
                <b title="Inlined">🔷checkTypeNameIsReserved</b>(node.name, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>.Type_parameter_name_cannot_be_0);
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getSymbolOfNode</summary>
<pre class="code">
(node) {
            return <b title="Inlined">🔷getMergedSymbol</b>(node.symbol);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getMergedSymbol</summary>
<pre class="code">
(symbol) {
            var merged;
            return symbol && symbol⚠️<i><b title="LoadNamedGeneric">.mergeId</b></i> && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>getDeclaredTypeOfTypeParameter</summary>
<pre class="code">
(symbol) {
            var links = <b title="Inlined">🔷getSymbolLinks</b>(symbol);
            if (!links.declaredType) {
                var type = <b title="Inlined">🔷createType</b>(16384 /* TypeParameter */);
                type.symbol = symbol;
                if (!ts.🔶<i><b title="Did not inline: unknown">getDeclarationOfKind</b></i>(symbol, 143 /* TypeParameter */).constraint) {
                    type.constraint ⚠️<i><b title="StoreNamedGeneric">= noConstraintType</b></i>;
                }
                links.declaredType = type;
            }
            return links.declaredType;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getSymbolLinks</summary>
<pre class="code">
(symbol) {
            if (symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 67108864 /* Transient */)
                return symbol;
            var id = <b title="Inlined">🔷getSymbolId</b>(symbol);
            return symbolLinks⚠️<i><b title="LoadKeyedGeneric">[id]</b></i> || (symbolLinks[id] = {});
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getSymbolId</summary>
<pre class="code">
(symbol) {
        if (!symbol⚠️<i><b title="LoadNamedGeneric">.id</b></i>) {
            symbol.id ⚠️<i><b title="StoreNamedGeneric">= nextSymbolId</b></i>;
            nextSymbolId++;
        }
        return symbol⚠️<i><b title="LoadNamedGeneric">.id</b></i>;
    }</pre>

</details>
</blockquote>

</details>
<details>
<summary>createType</summary>
<pre class="code">
(flags) {
            var result = <b title="Inlined">🔷new Type</b>(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new Type</summary>
<pre class="code">
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>checkTypeNameIsReserved</summary>
<pre class="code">
(name, message) {
            // TS 1.0 spec (April 2014): 3.6.1
            // The predefined type keywords are reserved and cannot be used as names of user defined types.
            switch (name.text) {
                case "any":
                case "number":
                case "boolean":
                case "string":
                case "symbol":
                case "void":
                    🔶️<i><b title="CallWithDescriptor">error</b></i>(name, message, name⚠️<i><b title="LoadNamedGeneric">.text</b></i>);
            }
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>checkPropertyDeclaration</summary>
<pre class="code">
(node) {
            // Grammar checking
            🔶<i><b title="Did not inline: target text too big">checkGrammarDecorators</b></i>(node) || 🔶<i><b title="Did not inline: target text too big">checkGrammarModifiers</b></i>(node) || 🔶<i><b title="Did not inline: target text too big">checkGrammarProperty</b></i>(node) || <b title="Inlined">🔷checkGrammarComputedPropertyName</b>(node.name);
            🔶<i><b title="Did not inline: target text too big">checkVariableLikeDeclaration</b></i>(node);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>checkGrammarComputedPropertyName</summary>
<pre class="code">
(node) {
            // If node is not a computedPropertyName, just skip the grammar checking
            if (node.kind !== 142 /* ComputedPropertyName */) {
                return false;
            }
            var computedPropertyName = node;
            if (computedPropertyName⚠️<i><b title="LoadNamedGeneric">.expression</b></i>⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 192</b></i> /* BinaryExpression */ && computedPropertyName⚠️<i><b title="LoadNamedGeneric">.expression</b></i>⚠️<i><b title="LoadNamedGeneric">.operatorToken</b></i>⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 25</b></i> /* CommaToken */) {
                return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(computedPropertyName⚠️<i><b title="LoadNamedGeneric">.expression</b></i>, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.A_comma_expression_is_not_allowed_in_a_computed_property_name</b></i>);
            }
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>checkTypeQuery</summary>
<pre class="code">
(node) {
            <b title="Inlined">🔷getTypeFromTypeQueryNode</b>(node);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getTypeFromTypeQueryNode</summary>
<pre class="code">
(node) {
            var links = <b title="Inlined">🔷getNodeLinks</b>(node);
            if (!links.resolvedType) {
                // TypeScript 1.0 spec (April 2014): 3.6.3
                // The expression is processed as an identifier expression (section 4.3)
                // or property access expression(section 4.10),
                // the widened type(section 3.9) of which becomes the result.
                links.resolvedType ⚠️<i><b title="StoreNamedGeneric">= getWidenedType</b></i>(🔶️<i><b title="CallWithDescriptor">checkExpression</b></i>(node.exprName));
            }
            return links.resolvedType;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getNodeLinks</summary>
<pre class="code">
(node) {
            var nodeId = <b title="Inlined">🔷getNodeId</b>(node);
            return nodeLinks⚠️<i><b title="LoadKeyedGeneric">[nodeId]</b></i> || (nodeLinks[nodeId] = { flags: 0 });
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getNodeId</summary>
<pre class="code">
(node) {
        if (!node⚠️<i><b title="LoadNamedGeneric">.id</b></i>) {
            node.id ⚠️<i><b title="StoreNamedGeneric">= nextNodeId</b></i>;
            nextNodeId++;
        }
        return node⚠️<i><b title="LoadNamedGeneric">.id</b></i>;
    }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>checkTypeLiteral</summary>
<pre class="code">
(node) {
            ts.🔶<i><b title="Did not inline: unknown">forEach</b></i>(node.members, checkSourceElement);
            if (produceDiagnostics) {
                var type = 🔶<i><b title="Did not inline: target text too big">getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode</b></i>(node);
                🔶️<i><b title="CallWithDescriptor">checkIndexConstraints</b></i>(type);
                🔶️<i><b title="CallWithDescriptor">checkTypeForDuplicateIndexSignatures</b></i>(node);
                🔶<i><b title="Did not inline: target text too big">checkObjectTypeForDuplicateDeclarations</b></i>(node);
            }
        }</pre>

</details>
</blockquote>



### ⛔ getEffectiveDeclarationFlags (deoptimizated):
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(n, flagsToCheck) {
            var flags = ts.🔶<i><b title="Did not inline: unknown">getCombinedModifierFlags</b></i>(n);
            // children of classes (even ambient classes) should not be marked as ambient or export
            // because those flags have no useful semantics there.
            if (n⚠️<i><b title="LoadNamedGeneric">.parent</b></i>⚠️<i><b title="LoadNamedGeneric">.kind</b></i> !== 227 /* InterfaceDeclaration */ &&
                n.parent⚠️<i><b title="LoadNamedGeneric">.kind</b></i> !== 226 /* ClassDeclaration */ &&
                n.parent⚠️<i><b title="LoadNamedGeneric">.kind</b></i> !== 197 /* ClassExpression */ &&
                ts.🔶<i><b title="Did not inline: unknown">isInAmbientContext</b></i>(n)) {
                if (!(flags & 2 /* Ambient */)) {
                    // It is nested in an ambient context, which means it is automatically exported
                    flags |= 1 /* Export */;
                }
                flags |= 2 /* Ambient */;
            }
            return flags & flagsToCheck;
        }</pre>

```diff
- Deopt: <JS Function getPropertyOfType (SharedFunctionInfo 0x2e2f693f0591)> (opt #388) @15, FP to SP delta: 64, caller sp: 0x7fff5fbfdc70
```



### getNodeLinks:
<pre class="code">
(node) {
            var nodeId = <b title="Inlined">🔷getNodeId</b>(node);
            return nodeLinks⚠️<i><b title="LoadKeyedGeneric">[nodeId]</b></i> || (nodeLinks[nodeId] = { flags: 0 });
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getNodeId</summary>
<pre class="code">
(node) {
        if (!node⚠️<i><b title="LoadNamedGeneric">.id</b></i>) {
            node.id ⚠️<i><b title="StoreNamedGeneric">= nextNodeId</b></i>;
            nextNodeId++;
        }
        return node⚠️<i><b title="LoadNamedGeneric">.id</b></i>;
    }</pre>

</details>
</blockquote>



### getWidenedTypeForVariableLikeDeclaration:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(declaration, reportErrors) {
            var type = getTypeForVariableLikeDeclaration(declaration, /*includeOptionality*/ true);
            if (type) {
                if (reportErrors) {
                    <b title="Inlined">🔷reportErrorsFromWidening</b>(declaration, type);
                }
                // During a normal type check we'll never get to here with a property assignment (the check of the containing
                // object literal uses a different path). We exclude widening only so that language services and type verification
                // tools see the actual type.
                if (declaration⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 257 /* PropertyAssignment */) {
                    return type;
                }
                return 🔶️<i><b title="CallWithDescriptor">getWidenedType</b></i>(type);
            }
            // Rest parameters default to type any[], other parameters default to type any
            type = declaration⚠️<i><b title="LoadNamedGeneric">.dotDotDotToken</b></i> ? anyArrayType : anyType;
            // Report implicit any errors unless this is a private property within an ambient declaration
            if (reportErrors && compilerOptions⚠️<i><b title="LoadNamedGeneric">.noImplicitAny</b></i>) {
                if (!🔶️<i><b title="CallWithDescriptor">declarationBelongsToPrivateAmbientMember</b></i>(declaration)) {
                    🔶️<i><b title="CallWithDescriptor">reportImplicitAnyError</b></i>(declaration, type);
                }
            }
            return type;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>reportErrorsFromWidening</summary>
<pre class="code">
(declaration, type) {
            if (produceDiagnostics && compilerOptions.noImplicitAny && type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> ⚠️<i><b title="Bitwise">& 2097152</b></i> /* ContainsWideningType */) {
                // Report implicit any error within type if possible, otherwise report error on declaration
                if (!🔶️<i><b title="CallWithDescriptor">reportWideningErrorsInType</b></i>(type)) {
                    🔶️<i><b title="CallWithDescriptor">reportImplicitAnyError</b></i>(declaration, type);
                }
            }
        }</pre>

</details>
</blockquote>



### convertAutoToAny:
<pre class="code">
(type) {
            return type === autoType ? anyType : type === autoArrayType ? anyArrayType : type;
        }</pre>



### hasQuestionToken:
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(node) {
        if (node) {
            switch (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i>) {
                case 144 /* Parameter */:
                case 149 /* MethodDeclaration */:
                case 148 /* MethodSignature */:
                case 258 /* ShorthandPropertyAssignment */:
                case 257 /* PropertyAssignment */:
                case 147 /* PropertyDeclaration */:
                case 146 /* PropertySignature */:
                    return node⚠️<i><b title="LoadNamedGeneric">.questionToken</b></i> !== undefined;
            }
        }
        return false;
    }</pre>



### getSymbolLinks:
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(symbol) {
            if (symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 67108864 /* Transient */)
                return symbol;
            var id = <b title="Inlined">🔷getSymbolId</b>(symbol);
            return symbolLinks⚠️<i><b title="LoadKeyedGeneric">[id]</b></i> || (symbolLinks[id] = {});
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getSymbolId</summary>
<pre class="code">
(symbol) {
        if (!symbol⚠️<i><b title="LoadNamedGeneric">.id</b></i>) {
            symbol.id ⚠️<i><b title="StoreNamedGeneric">= nextSymbolId</b></i>;
            nextSymbolId++;
        }
        return symbol⚠️<i><b title="LoadNamedGeneric">.id</b></i>;
    }</pre>

</details>
</blockquote>



### isAsyncFunctionLike:
<pre class="code">
(node) {
        return <b title="Inlined">🔷isFunctionLike</b>(node) && <b title="Inlined">🔷hasModifier</b>(node, 256 /* Async */) && !🔶️<i><b title="CallWithDescriptor">isAccessor</b></i>(node);
    }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>isFunctionLike</summary>
<pre class="code">
(node) {
        return node && 🔶<i><b title="Did not inline: target text too big">isFunctionLikeKind</b></i>(node⚠️<i><b title="LoadNamedGeneric">.kind</b></i>);
    }</pre>

</details>
<details>
<summary>hasModifier</summary>
<pre class="code">
(node, flags) {
        return (🔶<i><b title="Did not inline: target text too big">getModifierFlags</b></i>(node) & flags) !== 0;
    }</pre>

</details>
</blockquote>



### ⛔ nodeIsMissing (deoptimizated):
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(node) {
        if (node === undefined) {
            return true;
        }
        return node⚠️<i><b title="LoadNamedGeneric">.pos</b></i> === node⚠️<i><b title="LoadNamedGeneric">.end</b></i> && node⚠️<i><b title="LoadNamedGeneric">.pos</b></i> ⚠️<i><b title="CompareGeneric">>= 0</b></i> && node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">!== 1</b></i> /* EndOfFileToken */;
    }</pre>

```diff
- Deopt: <JS Function isIndependentMember (SharedFunctionInfo 0x2e2f693ee851)> (opt #557) @33, FP to SP delta: 72, caller sp: 0x7fff5fbfd638
```



### isClassLike:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(node) {
        return node && (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 226 /* ClassDeclaration */ || node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 197 /* ClassExpression */);
    }</pre>



### checkCollisionWithCapturedThisVariable:
<pre class="code">
(node, name) {
            if (🔶<i><b title="Did not inline: target text too big">needCollisionCheckForIdentifier</b></i>(node, name, "_this")) {
                potentialThisCollisions.🔶️<i><b title="CallWithDescriptor">push</b></i>(node);
            }
        }</pre>



### isReservedMemberName:
<pre class="code">
(name) {
            return name.charCodeAt(0) === 95 /* _ */ &&
                name.charCodeAt(1) === 95 /* _ */ &&
                name.charCodeAt(2) !== 95 /* _ */ &&
                name.charCodeAt(2) !== 64 /* at */;
        }</pre>



### lastOrUndefined:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(array) {
        return array && array.length &gt; 0
            ? array[array.length - 1]
            : undefined;
    }</pre>



### isDeclaredRestParam:
<pre class="code">
(node) {
        return node && node.dotDotDotToken !== undefined;
    }</pre>



### checkGrammarForNonSymbolComputedProperty:
<pre class="code">
(node, message) {
            if (ts.🔶<i><b title="Did not inline: unknown">isDynamicName</b></i>(node)) {
                return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(node, message);
            }
        }</pre>



### checkCollisionWithArgumentsInGeneratedCode:
<pre class="code">
(node) {
            // no rest parameters \x5c declaration context \x5c overload - no codegen impact
            if🔶️<i><b title="CallWithDescriptor"> (!ts</b></i>.hasDeclaredRestParameter(node) 🔶️<i><b title="CallWithDescriptor">|| ts</b></i>.isInAmbientContext(node) 🔶️<i><b title="CallWithDescriptor">|| ts</b></i>.nodeIsMissin⚠️<i><b title="LoadNamedGeneric">g</b></i>(node.body)) {
                return;
            }
         🔶️<i><b title="CallWithDescriptor">   ts</b></i>.forEac⚠️<i><b title="LoadNamedGeneric">h</b></i>(node.parame🔶️<i><b title="CallWithDescriptor">ters</b></i>, function (p) {
                if (p.name && !ts.isBindingPattern(p.name) && p.name.text === argumentsSymbol.name) {
                    error(p, ts.Diagnostics.Duplicate_identifier_arguments_Compiler_uses_arguments_to_initialize_rest_parameters);
                }
            });
        }</pre>



### hasDeclaredRestParameter:
<pre class="code">
(s) {
        return <b title="Inlined">🔷isDeclaredRestParam</b>(ts.⚠️<i><b title="LoadNamedGeneric">lastOrUndefined</b></i>(s⚠️<i><b title="LoadNamedGeneric">.parameters</b></i>));
    }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>isDeclaredRestParam</summary>
<pre class="code">
(node) {
        return node && node.dotDotDotToken !== undefined;
    }</pre>

</details>
</blockquote>



### registerForUnusedIdentifiersCheck:
<pre class="code">
(node) {
            if (deferredUnusedIdentifierNodes) {
                deferredUnusedIdentifierNodes.🔶️<i><b title="CallWithDescriptor">push</b></i>(node);
            }
        }</pre>



### checkGrammarFunctionLikeDeclaration:
<pre class="code">
(node) {
            // Prevent cascading error by short-circuit
            var file = ts.🔶️<i><b title="CallWithDescriptor">getSourceFileOfNode</b></i>(node);
            return 🔶<i><b title="Did not inline: target text too big">checkGrammarDecorators</b></i>(node) || 🔶<i><b title="Did not inline: target text too big">checkGrammarModifiers</b></i>(node) || <b title="Inlined">🔷checkGrammarTypeParameterList</b>(node.typeParameters, file) ||
                🔶<i><b title="Did not inline: target text too big">checkGrammarParameterList</b></i>(node⚠️<i><b title="LoadNamedGeneric">.parameters</b></i>) || 🔶️<i><b title="CallWithDescriptor">checkGrammarArrowFunction</b></i>(node, file);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>checkGrammarTypeParameterList</summary>
<pre class="code">
(typeParameters, file) {
            if (<b title="Inlined">🔷checkGrammarForDisallowedTrailingComma</b>(typeParameters)) {
                return true;
            }
            if (typeParameters && typeParameters.length === 0) {
                var start = typeParameters⚠️<i><b title="LoadNamedGeneric">.pos</b></i> ⚠️<i><b title="Sub">- "<"</b></i>.length;
                var end = ts.🔶️<i><b title="CallWithDescriptor">skipTrivia</b></i>(file⚠️<i><b title="LoadNamedGeneric">.text</b></i>, typeParameters⚠️<i><b title="LoadNamedGeneric">.end</b></i>) ⚠️<i><b title="Add">+ ">"</b></i>.length;
                return 🔶️<i><b title="CallWithDescriptor">grammarErrorAtPos</b></i>(file, start, end - start, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Type_parameter_list_cannot_be_empty</b></i>);
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>checkGrammarForDisallowedTrailingComma</summary>
<pre class="code">
(list) {
            if (list && list.hasTrailingComma) {
                var start = list⚠️<i><b title="LoadNamedGeneric">.end</b></i> ⚠️<i><b title="Sub">- ","</b></i>.length;
                var end = list⚠️<i><b title="LoadNamedGeneric">.end</b></i>;
                var sourceFile = ts.🔶️<i><b title="CallWithDescriptor">getSourceFileOfNode</b></i>(list⚠️<i><b title="LoadKeyedGeneric">[0]</b></i>);
                return 🔶️<i><b title="CallWithDescriptor">grammarErrorAtPos</b></i>(sourceFile, start, end ⚠️<i><b title="Sub">- start</b></i>, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Trailing_comma_not_allowed</b></i>);
            }
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### isCatchClauseVariableDeclarationOrBindingElement:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(declaration) {
        var node = <b title="Inlined">🔷getRootDeclaration</b>(declaration);
        return node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 223 /* VariableDeclaration */ && node.parent.kind === 256 /* CatchClause */;
    }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getRootDeclaration</summary>
<pre class="code">
(node) {
        while (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 174 /* BindingElement */) {
            node = node⚠️<i><b title="LoadNamedGeneric">.parent</b></i>⚠️<i><b title="LoadNamedGeneric">.parent</b></i>;
        }
        return node;
    }</pre>

</details>
</blockquote>



### isFunctionLikeKind:
<pre class="code">
(kind) {
        switch (kind) {
            case 150 /* Constructor */:
            case 184 /* FunctionExpression */:
            case 225 /* FunctionDeclaration */:
            case 185 /* ArrowFunction */:
            case 149 /* MethodDeclaration */:
            case 148 /* MethodSignature */:
            case 151 /* GetAccessor */:
            case 152 /* SetAccessor */:
            case 153 /* CallSignature */:
            case 154 /* ConstructSignature */:
            case 155 /* IndexSignature */:
            case 158 /* FunctionType */:
            case 159 /* ConstructorType */:
                return true;
        }
        return false;
    }</pre>



### isSourceFileJavaScript:
<pre class="code">
(file) {
        return <b title="Inlined">🔷isInJavaScriptFile</b>(file);
    }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>isInJavaScriptFile</summary>
<pre class="code">
(node) {
        return node && !!(node⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 65536 /* JavaScriptFile */);
    }</pre>

</details>
</blockquote>



### getTypeFromTypeNode:
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(node) {
            ⚠️<i><b title="CompareGeneric">switch</b></i> (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i>) {
                case 118 /* AnyKeyword */:
                case 263 /* JSDocAllType */:
                case 264 /* JSDocUnknownType */:
                    return anyType;
                case 134 /* StringKeyword */:
                    return stringType;
                case 132 /* NumberKeyword */:
                    return numberType;
                case 121 /* BooleanKeyword */:
                    return booleanType;
                case 135 /* SymbolKeyword */:
                    return esSymbolType;
                case 104 /* VoidKeyword */:
                    return voidType;
                case 137 /* UndefinedKeyword */:
                    return undefinedType;
                case 94 /* NullKeyword */:
                    return nullType;
                case 129 /* NeverKeyword */:
                    return neverType;
                case 289 /* JSDocNullKeyword */:
                    return nullType;
                case 290 /* JSDocUndefinedKeyword */:
                    return undefinedType;
                case 291 /* JSDocNeverKeyword */:
                    return neverType;
                case 167 /* ThisType */:
                case 98 /* ThisKeyword */:
                    return <b title="Inlined">🔷getTypeFromThisTypeNode</b>(node);
                case 171 /* LiteralType */:
                    return <b title="Inlined">🔷getTypeFromLiteralTypeNode</b>(node);
                case 288 /* JSDocLiteralType */:
                    return 🔶<i><b title="Did not inline: unknown">getTypeFromLiteralTypeNode</b></i>(node⚠️<i><b title="LoadNamedGeneric">.literal</b></i>);
                case 157 /* TypeReference */:
                case 272 /* JSDocTypeReference */:
                    return 🔶<i><b title="Did not inline: target text too big">getTypeFromTypeReference</b></i>(node);
                case 156 /* TypePredicate */:
                    return booleanType;
                case 199 /* ExpressionWithTypeArguments */:
                    return 🔶<i><b title="Did not inline: target text too big">getTypeFromTypeReference</b></i>(node);
                case 160 /* TypeQuery */:
                    return <b title="Inlined">🔷getTypeFromTypeQueryNode</b>(node);
                case 162 /* ArrayType */:
                case 265 /* JSDocArrayType */:
                    return <b title="Inlined">🔷getTypeFromArrayTypeNode</b>(node);
                case 163 /* TupleType */:
                    return 🔶️<i><b title="CallWithDescriptor">getTypeFromTupleTypeNode</b></i>(node);
                case 164 /* UnionType */:
                case 266 /* JSDocUnionType */:
                    return 🔶<i><b title="Did not inline: unknown">getTypeFromUnionTypeNode</b></i>(node);
                case 165 /* IntersectionType */:
                    return 🔶️<i><b title="CallWithDescriptor">getTypeFromIntersectionTypeNode</b></i>(node);
                case 166 /* ParenthesizedType */:
                case 268 /* JSDocNullableType */:
                case 269 /* JSDocNonNullableType */:
                case 276 /* JSDocConstructorType */:
                case 277 /* JSDocThisType */:
                case 273 /* JSDocOptionalType */:
                    return 🔶<i><b title="Did not inline: target text too big">getTypeFromTypeNode</b></i>(node.type);
                case 270 /* JSDocRecordType */:
                    return 🔶<i><b title="Did not inline: target text too big">getTypeFromTypeNode</b></i>(node⚠️<i><b title="LoadNamedGeneric">.literal</b></i>);
                case 158 /* FunctionType */:
                case 159 /* ConstructorType */:
                case 161 /* TypeLiteral */:
                case 287 /* JSDocTypeLiteral */:
                case 274 /* JSDocFunctionType */:
                    return 🔶<i><b title="Did not inline: target text too big">getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode</b></i>(node);
                case 168 /* TypeOperator */:
                    return 🔶<i><b title="Did not inline: unknown">getTypeFromTypeOperatorNode</b></i>(node);
                case 169 /* IndexedAccessType */:
                    return 🔶<i><b title="Did not inline: unknown">getTypeFromIndexedAccessTypeNode</b></i>(node);
                case 170 /* MappedType */:
                    return 🔶️<i><b title="CallWithDescriptor">getTypeFromMappedTypeNode</b></i>(node);
                // This function assumes that an identifier or qualified name is a type expression
                // Callers should first ensure this by calling isTypeNode
                case 70 /* Identifier */:
                case 141 /* QualifiedName */:
                    var symbol = 🔶️<i><b title="CallWithDescriptor">getSymbolAtLocation</b></i>(node);
                    return symbol && 🔶<i><b title="Did not inline: target text too big">getDeclaredTypeOfSymbol</b></i>(symbol);
                case 267 /* JSDocTupleType */:
                    return 🔶️<i><b title="CallWithDescriptor">getTypeFromJSDocTupleType</b></i>(node);
                case 275 /* JSDocVariadicType */:
                    return 🔶️<i><b title="CallWithDescriptor">getTypeFromJSDocVariadicType</b></i>(node);
                default:
                    return unknownType;
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getTypeFromThisTypeNode</summary>
<pre class="code">
(node) {
            var links = <b title="Inlined">🔷getNodeLinks</b>(node);
            if (!links.resolvedType) {
                links.resolvedType ⚠️<i><b title="StoreNamedGeneric">= getThisType</b></i>(node);
            }
            return links.resolvedType;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getNodeLinks</summary>
<pre class="code">
(node) {
            var nodeId = <b title="Inlined">🔷getNodeId</b>(node);
            return nodeLinks⚠️<i><b title="LoadKeyedGeneric">[nodeId]</b></i> || (nodeLinks[nodeId] = { flags: 0 });
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getNodeId</summary>
<pre class="code">
(node) {
        if (!node⚠️<i><b title="LoadNamedGeneric">.id</b></i>) {
            node.id ⚠️<i><b title="StoreNamedGeneric">= nextNodeId</b></i>;
            nextNodeId++;
        }
        return node⚠️<i><b title="LoadNamedGeneric">.id</b></i>;
    }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>getTypeFromLiteralTypeNode</summary>
<pre class="code">
(node) {
            var links = <b title="Inlined">🔷getNodeLinks</b>(node);
            if (!links.resolvedType) {
                links.resolvedType ⚠️<i><b title="StoreNamedGeneric">= getRegularTypeOfLiteralType</b></i>(checkExpression(node.literal));
            }
            return links.resolvedType;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getNodeLinks</summary>
<pre class="code">
(node) {
            var nodeId = <b title="Inlined">🔷getNodeId</b>(node);
            return nodeLinks⚠️<i><b title="LoadKeyedGeneric">[nodeId]</b></i> || (nodeLinks[nodeId] = { flags: 0 });
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getNodeId</summary>
<pre class="code">
(node) {
        if (!node⚠️<i><b title="LoadNamedGeneric">.id</b></i>) {
            node.id ⚠️<i><b title="StoreNamedGeneric">= nextNodeId</b></i>;
            nextNodeId++;
        }
        return node⚠️<i><b title="LoadNamedGeneric">.id</b></i>;
    }</pre>

</details>
</blockquote>

</details>
<details>
<summary>getRegularTypeOfLiteralType</summary>
<pre class="code">
(type) {
            return type.flags & 96 /* StringOrNumberLiteral */ && type.flags & 1048576 /* FreshLiteral */ ? type.regularType : type;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>getTypeFromTypeQueryNode</summary>
<pre class="code">
(node) {
            var links = <b title="Inlined">🔷getNodeLinks</b>(node);
            if (!links.resolvedType) {
                // TypeScript 1.0 spec (April 2014): 3.6.3
                // The expression is processed as an identifier expression (section 4.3)
                // or property access expression(section 4.10),
                // the widened type(section 3.9) of which becomes the result.
                links.resolvedType ⚠️<i><b title="StoreNamedGeneric">= getWidenedType</b></i>(🔶️<i><b title="CallWithDescriptor">checkExpression</b></i>(node.exprName));
            }
            return links.resolvedType;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getNodeLinks</summary>
<pre class="code">
(node) {
            var nodeId = <b title="Inlined">🔷getNodeId</b>(node);
            return nodeLinks⚠️<i><b title="LoadKeyedGeneric">[nodeId]</b></i> || (nodeLinks[nodeId] = { flags: 0 });
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getNodeId</summary>
<pre class="code">
(node) {
        if (!node⚠️<i><b title="LoadNamedGeneric">.id</b></i>) {
            node.id ⚠️<i><b title="StoreNamedGeneric">= nextNodeId</b></i>;
            nextNodeId++;
        }
        return node⚠️<i><b title="LoadNamedGeneric">.id</b></i>;
    }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>getTypeFromArrayTypeNode</summary>
<pre class="code">
(node) {
            var links = <b title="Inlined">🔷getNodeLinks</b>(node);
            if (!links.resolvedType) {
                links.resolvedType ⚠️<i><b title="StoreNamedGeneric">= createArrayType</b></i>(🔶<i><b title="Did not inline: target text too big">getTypeFromTypeNode</b></i>(node.elementType));
            }
            return links.resolvedType;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getNodeLinks</summary>
<pre class="code">
(node) {
            var nodeId = <b title="Inlined">🔷getNodeId</b>(node);
            return nodeLinks⚠️<i><b title="LoadKeyedGeneric">[nodeId]</b></i> || (nodeLinks[nodeId] = { flags: 0 });
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getNodeId</summary>
<pre class="code">
(node) {
        if (!node⚠️<i><b title="LoadNamedGeneric">.id</b></i>) {
            node.id ⚠️<i><b title="StoreNamedGeneric">= nextNodeId</b></i>;
            nextNodeId++;
        }
        return node⚠️<i><b title="LoadNamedGeneric">.id</b></i>;
    }</pre>

</details>
</blockquote>

</details>
<details>
<summary>createArrayType</summary>
<pre class="code">
(elementType) {
            return <b title="Inlined">🔷createTypeFromGenericGlobalType</b>(globalArrayType, [elementType]);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createTypeFromGenericGlobalType</summary>
<pre class="code">
(genericGlobalType, typeArguments) {
            return genericGlobalType !== emptyGenericType ? <b title="Inlined">🔷createTypeReference</b>(genericGlobalType, typeArguments) : emptyObjectType;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createTypeReference</summary>
<pre class="code">
(target, typeArguments) {
            var id = 🔶<i><b title="Did not inline: target text too big">getTypeListId</b></i>(typeArguments);
            var type = target⚠️<i><b title="LoadNamedGeneric">.instantiations</b></i>⚠️<i><b title="LoadKeyedGeneric">[id]</b></i>;
            if (!type) {
                type = target⚠️<i><b title="LoadNamedGeneric">.instantiations</b></i>[id] ⚠️<i><b title="StoreKeyedGeneric">= createObjectType</b></i>(4 /* Reference */, target⚠️<i><b title="LoadNamedGeneric">.symbol</b></i>);
                type.flags |= typeArguments ? <b title="Inlined">🔷getPropagatingFlagsOfTypes</b>(typeArguments, /*excludeKinds*/ 0) : 0;
                type.target = target;
                type.typeArguments = typeArguments;
            }
            return type;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createObjectType</summary>
<pre class="code">
(objectFlags, symbol) {
            var type = createType(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol ⚠️<i><b title="StoreNamedGeneric">= symbol</b></i>;
            return type;
        }</pre>

</details>
<details>
<summary>getPropagatingFlagsOfTypes</summary>
<pre class="code">
(types, excludeKinds) {
            var result = 0;
            for (var _i = 0, types_3 = types; _i &lt; types_3⚠️<i><b title="LoadNamedGeneric">.length</b></i>; _i++) {
                var type = types_3⚠️<i><b title="LoadKeyedGeneric">[_i]</b></i>;
                if (!(type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & excludeKinds)) {
                    result |= type⚠️<i><b title="LoadNamedGeneric">.flags</b></i>;
                }
            }
            return result & 14680064 /* PropagatingFlags */;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>



### createType:
<pre class="code">
(flags) {
            var result = <b title="Inlined">🔷new Type</b>(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new Type</summary>
<pre class="code">
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }</pre>

</details>
</blockquote>



### getApparentType:
<pre class="code">
(type) {
            var t = type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 540672 /* TypeVariable */ ? 🔶️<i><b title="CallWithDescriptor">getApparentTypeOfTypeVariable</b></i>(type) : type;
            return t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 262178 /* StringLike */ ? globalStringType :
                t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 340 /* NumberLike */ ? globalNumberType :
                    t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 136 /* BooleanLike */ ? globalBooleanType :
                        t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 512 /* ESSymbol */ ? 🔶️<i><b title="CallWithDescriptor">getGlobalESSymbolType</b></i>() :
                            t;
        }</pre>



### symbolIsValue:
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(symbol) {
            // If it is an instantiated symbol, then it is a value if the symbol it is an
            // instantiation of is a value.
            if (symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 16777216 /* Instantiated */) {
                return 🔶<i><b title="Did not inline: target text too big">symbolIsValue</b></i>(<b title="Inlined">🔷getSymbolLinks</b>(symbol).target);
            }
            // If the symbol has the value flag, it is trivially a value.
            if (symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 107455 /* Value */) {
                return true;
            }
            // If it is an alias, then it is a value if the symbol it resolves to is a value.
            if (symbol.flags & 8388608 /* Alias */) {
                return (🔶️<i><b title="CallWithDescriptor">resolveAlias</b></i>(symbol)⚠️<i><b title="LoadNamedGeneric">.flags</b></i> ⚠️<i><b title="Bitwise">& 107455</b></i> /* Value */) ⚠️<i><b title="CompareGeneric">!== 0</b></i>;
            }
            return false;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getSymbolLinks</summary>
<pre class="code">
(symbol) {
            if (symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 67108864 /* Transient */)
                return symbol;
            var id = <b title="Inlined">🔷getSymbolId</b>(symbol);
            return symbolLinks⚠️<i><b title="LoadKeyedGeneric">[id]</b></i> || (symbolLinks[id] = {});
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getSymbolId</summary>
<pre class="code">
(symbol) {
        if (!symbol⚠️<i><b title="LoadNamedGeneric">.id</b></i>) {
            symbol.id ⚠️<i><b title="StoreNamedGeneric">= nextSymbolId</b></i>;
            nextSymbolId++;
        }
        return symbol⚠️<i><b title="LoadNamedGeneric">.id</b></i>;
    }</pre>

</details>
</blockquote>

</details>
</blockquote>



### ⛔ popTypeResolution (deoptimizated):
<pre class="code">
() {
            resolutionTargets.pop();
            resolutionPropertyNames.pop();
            return resolutionResults.pop();
        }</pre>

```diff
- Deopt: <JS Function getMergedSymbol (SharedFunctionInfo 0x2e2f693e9a51)> (opt #289) @3, FP to SP delta: 24, caller sp: 0x7fff5fbfde80
```

```diff
- Deopt: <JS Function getSymbolLinks (SharedFunctionInfo 0x2e2f693e7651)> (opt #298) @11, FP to SP delta: 40, caller sp: 0x7fff5fbfdec8
```

```diff
- Deopt: <JS Function symbolIsValue (SharedFunctionInfo 0x2e2f693e9d51)> (opt #319) @2, FP to SP delta: 56, caller sp: 0x7fff5fbfdcd0
```

```diff
- Deopt: <JS Function getSymbolId (SharedFunctionInfo 0x1f9f6c00b809)> (opt #290) @9, FP to SP delta: 24, caller sp: 0x7fff5fbfdce0
```

```diff
- Deopt: <JS Function lastOrUndefined (SharedFunctionInfo 0xc2bd2ae2569)> (opt #304) @3, FP to SP delta: 24, caller sp: 0x7fff5fbfdb10
```



### isGlobalSourceFile:
<pre class="code">
(node) {
            return node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 261 /* SourceFile */ && !ts.🔶<i><b title="Did not inline: unknown">isExternalOrCommonJsModule</b></i>(node);
        }</pre>



### getIndexSymbol:
<pre class="code">
(symbol) {
            return symbol.members⚠️<i><b title="LoadNamedGeneric">["__i</b></i>ndex"];
        }</pre>



### addOptionality:
<pre class="code">
(type, optional) {
            return strictNullChecks && optional ? 🔶️<i><b title="CallWithDescriptor">includeFalsyTypes</b></i>(type, 2048 /* Undefined */) : type;
        }</pre>



### ⛔ getSymbol (deoptimizated):
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

```diff
- Deopt: <JS Function checkInheritedPropertiesAreIdentical (SharedFunctionInfo 0x1b98fbc0f241)> (opt #514) @85, FP to SP delta: 352, caller sp: 0x7fff5fbfdcc0
```

```diff
- Deopt: <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)> (opt #539) @79, FP to SP delta: 304, caller sp: 0x7fff5fbfdb90
```

```diff
- Deopt: <JS Function instantiateTypes (SharedFunctionInfo 0x2e2f693f5701)> (opt #547) @4, FP to SP delta: 56, caller sp: 0x7fff5fbfcfa0
```

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(symbols, name, meaning) {
            if (meaning) {
                var symbol = symbols⚠️<i><b title="LoadKeyedGeneric">[name]</b></i>;
                if (symbol) {
                    ts⚠️<i><b title="LoadNamedGeneric">.Debug</b></i>.🔶️<i><b title="CallWithDescriptor">assert</b></i>((symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 16777216 /* Instantiated */) === 0, "Should never get an instantiated symbol here.");
                    if (symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & meaning) {
                        return symbol;
                    }
                    if (symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 8388608 /* Alias */) {
                        var target = 🔶️<i><b title="CallWithDescriptor">resolveAlias</b></i>(symbol);
                        // Unknown symbol means an error occurred in alias resolution, treat it as positive answer to avoid cascading errors
                        if (target === unknownSymbol || target.flags & meaning) {
                            return symbol;
                        }
                    }
                }
            }
            // return undefined if we can't find a symbol.
        }</pre>



### getInterfaceBaseTypeNodes:
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(node) {
        var heritageClause = <b title="Inlined">🔷getHeritageClause</b>(node.heritageClauses, 84 /* ExtendsKeyword */);
        return heritageClause ? heritageClause.types : undefined;
    }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getHeritageClause</summary>
<pre class="code">
(clauses, kind) {
        if (clauses) {
            for (var _i = 0, clauses_1 = clauses; _i &lt; clauses_1.length; _i++) {
                var clause = clauses_1[_i];
                if (clause.token === kind) {
                    return clause;
                }
            }
        }
        return undefined;
    }</pre>

</details>
</blockquote>



### resolveName:
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(location, name, meaning, nameNotFoundMessage, nameArg) {
            var result;
            var lastLocation;
            var propertyWithInvalidInitializer;
            var errorLocation = location;
            var grandparent;
            var isInExternalModule = false;
            loop: while (location) {
                // Locals of a source file are not in scope (because they get merged into the global symbol table)
                if (location⚠️<i><b title="LoadNamedGeneric">.locals</b></i> && !<b title="Inlined">🔷isGlobalSourceFile</b>(location)) {
                    if (result = getSymbol(location⚠️<i><b title="LoadNamedGeneric">.locals</b></i>, name, meaning)) {
                        var useResult = true;
                        if (ts.⚠️<i><b title="LoadNamedGeneric">isFunctionLike</b></i>(location) && lastLocation && lastLocation ⚠️<i><b title="CompareGeneric">!== location</b></i>⚠️<i><b title="LoadNamedGeneric">.body</b></i>) {
                            // symbol lookup restrictions for function-like declarations
                            // - Type parameters of a function are in scope in the entire function declaration, including the parameter
                            //   list and return type. However, local types are only in scope in the function body.
                            // - parameters are only in the scope of function body
                            // This restriction does not apply to JSDoc comment types because they are parented
                            // at a higher level than type parameters would normally be
                            if (meaning & result.flags & 793064 /* Type */ && lastLocation⚠️<i><b title="LoadNamedGeneric">.kind</b></i> !== 278 /* JSDocComment */) {
                                useResult = result.flags & 262144 /* TypeParameter */
                                    ? lastLocation === location⚠️<i><b title="LoadNamedGeneric">.type</b></i> ||
                                        lastLocation.kind === 144 /* Parameter */ ||
                                        lastLocation⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 143</b></i> /* TypeParameter */
                                    : false;
                            }
                            if (meaning & 107455 /* Value */ && result.flags & 1 /* FunctionScopedVariable */) {
                                // parameters are visible only inside function body, parameter list and return type
                                // technically for parameter list case here we might mix parameters and variables declared in function,
                                // however it is detected separately when checking initializers of parameters
                                // to make sure that they reference no variables declared after them.
                                useResult =
                                    lastLocation⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 144</b></i> /* Parameter */ ||
                                        (lastLocation ⚠️<i><b title="CompareGeneric">=== location</b></i>⚠️<i><b title="LoadNamedGeneric">.type</b></i> &&
                                            result⚠️<i><b title="LoadNamedGeneric">.valueDeclaration</b></i>⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 144</b></i> /* Parameter */);
                            }
                        }
                        if (useResult) {
                            break loop;
                        }
                        else {
                            result = undefined;
                        }
                    }
                }
                switch (location⚠️<i><b title="LoadNamedGeneric">.kind</b></i>) {
                    case 261 /* SourceFile */:
                        if (!ts.⚠️<i><b title="LoadNamedGeneric">isExternalOrCommonJsModule</b></i>(location))
                            break;
                        isInExternalModule = true;
                    case 230 /* ModuleDeclaration */:
                        var moduleExports = <b title="Inlined">🔷getSymbolOfNode</b>(location).exports;
                        if (location.kind === 261 /* SourceFile */ || ts.🔶<i><b title="Did not inline: unknown">isAmbientModule</b></i>(location)) {
                            // It's an external module. First see if the module has an export default and if the local
                            // name of that export default matches.
                            if (result = moduleExports⚠️<i><b title="LoadNamedGeneric">["def</b></i>ault"]) {
                                var localSymbol = ts.🔶️<i><b title="CallWithDescriptor">getLocalSymbolForExportDefault</b></i>(result);
                                if (localSymbol && (result⚠️<i><b title="LoadNamedGeneric">.flags</b></i> ⚠️<i><b title="Bitwise">& meaning</b></i>) && localSymbol⚠️<i><b title="LoadNamedGeneric">.name</b></i> ⚠️<i><b title="CompareGeneric">=== name</b></i>) {
                                    break loop;
                                }
                                result = undefined;
                            }
                            // Because of module/namespace merging, a module's exports are in scope,
                            // yet we never want to treat an export specifier as putting a member in scope.
                            // Therefore, if the name we find is purely an export specifier, it is not actually considered in scope.
                            // Two things to note about this:
                            //     1. We have to check this without calling getSymbol. The problem with calling getSymbol
                            //        on an export specifier is that it might find the export specifier itself, and try to
                            //        resolve it as an alias. This will cause the checker to consider the export specifier
                            //        a circular alias reference when it might not be.
                            //     2. We check === SymbolFlags.Alias in order to check that the symbol is *purely*
                            //        an alias. If we used &, we'd be throwing out symbols that have non alias aspects,
                            //        which is not the desired behavior.
                            if (moduleExports⚠️<i><b title="LoadKeyedGeneric">[name]</b></i> &&
                                moduleExports⚠️<i><b title="LoadKeyedGeneric">[name]</b></i>.flags === 8388608 /* Alias */ &&
                                ts.🔶<i><b title="Did not inline: unknown">getDeclarationOfKind</b></i>(moduleExports⚠️<i><b title="LoadKeyedGeneric">[name]</b></i>, 243 /* ExportSpecifier */)) {
                                break;
                            }
                        }
                        if (result = 🔶<i><b title="Did not inline: target text too big">getSymbol</b></i>(moduleExports, name, meaning & 8914931 /* ModuleMember */)) {
                            break loop;
                        }
                        break;
                    case 229 /* EnumDeclaration */:
                        if (result = 🔶<i><b title="Did not inline: target text too big">getSymbol</b></i>(🔶<i><b title="Did not inline: unknown">getSymbolOfNode</b></i>(location)⚠️<i><b title="LoadNamedGeneric">.exports</b></i>, name, meaning ⚠️<i><b title="Bitwise">& 8</b></i> /* EnumMember */)) {
                            break loop;
                        }
                        break;
                    case 147 /* PropertyDeclaration */:
                    case 146 /* PropertySignature */:
                        // TypeScript 1.0 spec (April 2014): 8.4.1
                        // Initializer expressions for instance member variables are evaluated in the scope
                        // of the class constructor body but are not permitted to reference parameters or
                        // local variables of the constructor. This effectively means that entities from outer scopes
                        // by the same name as a constructor parameter or local variable are inaccessible
                        // in initializer expressions for instance member variables.
                        if (ts.⚠️<i><b title="LoadNamedGeneric">isClassLike</b></i>(location.parent) && !(ts.🔶<i><b title="Did not inline: target text too big">getModifierFlags</b></i>(location) ⚠️<i><b title="Bitwise">& 32</b></i> /* Static */)) {
                            var ctor = 🔶️<i><b title="CallWithDescriptor">findConstructorDeclaration</b></i>(location⚠️<i><b title="LoadNamedGeneric">.parent</b></i>);
                            if (ctor && ctor⚠️<i><b title="LoadNamedGeneric">.locals</b></i>) {
                                if (🔶<i><b title="Did not inline: target text too big">getSymbol</b></i>(ctor⚠️<i><b title="LoadNamedGeneric">.locals</b></i>, name, meaning ⚠️<i><b title="Bitwise">& 107455</b></i> /* Value */)) {
                                    // Remember the property node, it will be used later to report appropriate error
                                    propertyWithInvalidInitializer = location;
                                }
                            }
                        }
                        break;
                    case 226 /* ClassDeclaration */:
                    case 197 /* ClassExpression */:
                    case 227 /* InterfaceDeclaration */:
                        if (result = 🔶<i><b title="Did not inline: target text too big">getSymbol</b></i>(<b title="Inlined">🔷getSymbolOfNode</b>(location)⚠️<i><b title="LoadNamedGeneric">.members</b></i>, name, meaning & 793064 /* Type */)) {
                            if (lastLocation && ts.🔶<i><b title="Did not inline: target text too big">getModifierFlags</b></i>(lastLocation) & 32 /* Static */) {
                                // TypeScript 1.0 spec (April 2014): 3.4.1
                                // The scope of a type parameter extends over the entire declaration with which the type
                                // parameter list is associated, with the exception of static member declarations in classes.
                                🔶️<i><b title="CallWithDescriptor">error</b></i>(errorLocation, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Static_members_cannot_reference_class_type_parameters</b></i>);
                                return undefined;
                            }
                            break loop;
                        }
                        if (location.kind === 197 /* ClassExpression */ && meaning ⚠️<i><b title="Bitwise">& 32</b></i> /* Class */) {
                            var className = location⚠️<i><b title="LoadNamedGeneric">.name</b></i>;
                            if (className && name ⚠️<i><b title="CompareGeneric">=== className</b></i>⚠️<i><b title="LoadNamedGeneric">.text</b></i>) {
                                result = location⚠️<i><b title="LoadNamedGeneric">.symbol</b></i>;
                                break loop;
                            }
                        }
                        break;
                    // It is not legal to reference a class's own type parameters from a computed property name that
                    // belongs to the class. For example:
                    //
                    //   function foo&lt;T&gt;() { return '' }
                    //   class C&lt;T&gt; { // &lt;-- Class's own type parameter T
                    //       [foo&lt;T&gt;()]() { } // &lt;-- Reference to T from class's own computed property
                    //   }
                    //
                    case 142 /* ComputedPropertyName */:
                        grandparent = location⚠️<i><b title="LoadNamedGeneric">.parent</b></i>⚠️<i><b title="LoadNamedGeneric">.parent</b></i>;
                        if (ts.🔶<i><b title="Did not inline: unknown">isClassLike</b></i>(grandparent) || grandparent⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 227</b></i> /* InterfaceDeclaration */) {
                            // A reference to this grandparent's type parameters would be an error
                            if (result = 🔶<i><b title="Did not inline: target text too big">getSymbol</b></i>(🔶<i><b title="Did not inline: unknown">getSymbolOfNode</b></i>(grandparent)⚠️<i><b title="LoadNamedGeneric">.members</b></i>, name, meaning ⚠️<i><b title="Bitwise">& 793064</b></i> /* Type */)) {
                                🔶️<i><b title="CallWithDescriptor">error</b></i>(errorLocation, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.A_computed_property_name_cannot_reference_a_type_parameter_from_its_containing_type</b></i>);
                                return undefined;
                            }
                        }
                        break;
                    case 149 /* MethodDeclaration */:
                    case 148 /* MethodSignature */:
                    case 150 /* Constructor */:
                    case 151 /* GetAccessor */:
                    case 152 /* SetAccessor */:
                    case 225 /* FunctionDeclaration */:
                    case 185 /* ArrowFunction */:
                        if (meaning & 3 /* Variable */ && name ⚠️<i><b title="CompareGeneric">=== "</b></i>arguments") {
                            result = argumentsSymbol;
                            break loop;
                        }
                        break;
                    case 184 /* FunctionExpression */:
                        if (meaning ⚠️<i><b title="Bitwise">& 3</b></i> /* Variable */ && name ⚠️<i><b title="CompareGeneric">=== "</b></i>arguments") {
                            result = argumentsSymbol;
                            break loop;
                        }
                        if (meaning ⚠️<i><b title="Bitwise">& 16</b></i> /* Function */) {
                            var functionName = location⚠️<i><b title="LoadNamedGeneric">.name</b></i>;
                            if (functionName && name ⚠️<i><b title="CompareGeneric">=== functionName</b></i>⚠️<i><b title="LoadNamedGeneric">.text</b></i>) {
                                result = location⚠️<i><b title="LoadNamedGeneric">.symbol</b></i>;
                                break loop;
                            }
                        }
                        break;
                    case 145 /* Decorator */:
                        // Decorators are resolved at the class declaration. Resolving at the parameter
                        // or member would result in looking up locals in the method.
                        //
                        //   function y() {}
                        //   class C {
                        //       method(@y x, y) {} // &lt;-- decorator y should be resolved at the class declaration, not the parameter.
                        //   }
                        //
                        if (location⚠️<i><b title="LoadNamedGeneric">.parent</b></i> && location⚠️<i><b title="LoadNamedGeneric">.parent</b></i>⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 144</b></i> /* Parameter */) {
                            location = location⚠️<i><b title="LoadNamedGeneric">.parent</b></i>;
                        }
                        //
                        //   function y() {}
                        //   class C {
                        //       @y method(x, y) {} // &lt;-- decorator y should be resolved at the class declaration, not the method.
                        //   }
                        //
                        if (location⚠️<i><b title="LoadNamedGeneric">.parent</b></i> && ts.🔶️<i><b title="CallWithDescriptor">isClassElement</b></i>(location⚠️<i><b title="LoadNamedGeneric">.parent</b></i>)) {
                            location = location⚠️<i><b title="LoadNamedGeneric">.parent</b></i>;
                        }
                        break;
                }
                lastLocation = location;
                location = location⚠️<i><b title="LoadNamedGeneric">.parent</b></i>;
            }
            if (result && nameNotFoundMessage && noUnusedIdentifiers) {
                result.isReferenced ⚠️<i><b title="StoreNamedGeneric">= true</b></i>;
            }
            if (!result) {
                result = 🔶<i><b title="Did not inline: target text too big">getSymbol</b></i>(globals, name, meaning);
            }
            if (!result) {
                if (nameNotFoundMessage) {
                    if (!errorLocation ||
                        !🔶️<i><b title="CallWithDescriptor">checkAndReportErrorForMissingPrefix</b></i>(errorLocation, name, nameArg) &&
                            !🔶️<i><b title="CallWithDescriptor">checkAndReportErrorForExtendingInterface</b></i>(errorLocation) &&
                            !🔶️<i><b title="CallWithDescriptor">checkAndReportErrorForUsingTypeAsNamespace</b></i>(errorLocation, name, meaning) &&
                            !🔶️<i><b title="CallWithDescriptor">checkAndReportErrorForUsingTypeAsValue</b></i>(errorLocation, name, meaning)) {
                        🔶️<i><b title="CallWithDescriptor">error</b></i>(errorLocation, nameNotFoundMessage, typeof nameArg === "string" ? nameArg : ts.🔶️<i><b title="CallWithDescriptor">declarationNameToString</b></i>(nameArg));
                    }
                }
                return undefined;
            }
            // Perform extra checks only if error reporting was requested
            if (nameNotFoundMessage) {
                if (propertyWithInvalidInitializer) {
                    // We have a match, but the reference occurred within a property initializer and the identifier also binds
                    // to a local variable in the constructor where the code will be emitted.
                    var propertyName = propertyWithInvalidInitializer⚠️<i><b title="LoadNamedGeneric">.name</b></i>;
                    🔶️<i><b title="CallWithDescriptor">error</b></i>(errorLocation, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Initializer_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor</b></i>, ts.⚠️<i><b title="LoadNamedGeneric">declarationNameToString</b></i>(propertyName), typeof nameArg === "string" ? nameArg : ts.🔶️<i><b title="CallWithDescriptor">declarationNameToString</b></i>(nameArg));
                    return undefined;
                }
                // Only check for block-scoped variable if we are looking for the
                // name with variable meaning
                //      For example,
                //          declare module foo {
                //              interface bar {}
                //          }
                //      const foo/*1*/: foo/*2*/.bar;
                // The foo at /*1*/ and /*2*/ will share same symbol with two meaning
                // block - scope variable and namespace module. However, only when we
                // try to resolve name in /*1*/ which is used in variable position,
                // we want to check for block- scoped
                if (meaning & 2 /* BlockScopedVariable */) {
                    var exportOrLocalSymbol = <b title="Inlined">🔷getExportSymbolOfValueSymbolIfExported</b>(result);
                    if (exportOrLocalSymbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 2 /* BlockScopedVariable */) {
                        🔶️<i><b title="CallWithDescriptor">checkResolvedBlockScopedVariable</b></i>(exportOrLocalSymbol, errorLocation);
                    }
                }
                // If we're in an external module, we can't reference value symbols created from UMD export declarations
                if (result && isInExternalModule && (meaning ⚠️<i><b title="Bitwise">& 107455</b></i> /* Value */) ⚠️<i><b title="CompareGeneric">=== 107455</b></i> /* Value */) {
                    var decls = result⚠️<i><b title="LoadNamedGeneric">.declarations</b></i>;
                    if (decls && decls⚠️<i><b title="LoadNamedGeneric">.length</b></i> ⚠️<i><b title="CompareGeneric">=== 1</b></i> && decls⚠️<i><b title="LoadKeyedGeneric">[0]</b></i>⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 233</b></i> /* NamespaceExportDeclaration */) {
                        🔶️<i><b title="CallWithDescriptor">error</b></i>(errorLocation, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">._0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead</b></i>, name);
                    }
                }
            }
            return result;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>isGlobalSourceFile</summary>
<pre class="code">
(node) {
            return node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 261 /* SourceFile */ && !ts.🔶<i><b title="Did not inline: unknown">isExternalOrCommonJsModule</b></i>(node);
        }</pre>

</details>
<details>
<summary>getSymbolOfNode</summary>
<pre class="code">
(node) {
            return <b title="Inlined">🔷getMergedSymbol</b>(node.symbol);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getMergedSymbol</summary>
<pre class="code">
(symbol) {
            var merged;
            return symbol && symbol⚠️<i><b title="LoadNamedGeneric">.mergeId</b></i> && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>getSymbolOfNode</summary>
<pre class="code">
(node) {
            return <b title="Inlined">🔷getMergedSymbol</b>(node.symbol);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getMergedSymbol</summary>
<pre class="code">
(symbol) {
            var merged;
            return symbol && symbol⚠️<i><b title="LoadNamedGeneric">.mergeId</b></i> && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>getExportSymbolOfValueSymbolIfExported</summary>
<pre class="code">
(symbol) {
            return symbol && (symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 1048576 /* ExportValue */) !== 0
                ? 🔶<i><b title="Did not inline: unknown">getMergedSymbol</b></i>(symbol⚠️<i><b title="LoadNamedGeneric">.exportSymbol</b></i>)
                : symbol;
        }</pre>

</details>
</blockquote>



### checkGrammarTypeArguments:
<pre class="code">
(node, typeArguments) {
            return <b title="Inlined">🔷checkGrammarForDisallowedTrailingComma</b>(typeArguments) ||
                <b title="Inlined">🔷checkGrammarForAtLeastOneTypeArgument</b>(node, typeArguments);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>checkGrammarForDisallowedTrailingComma</summary>
<pre class="code">
(list) {
            if (list && list.hasTrailingComma) {
                var start = list⚠️<i><b title="LoadNamedGeneric">.end</b></i> ⚠️<i><b title="Sub">- ","</b></i>.length;
                var end = list⚠️<i><b title="LoadNamedGeneric">.end</b></i>;
                var sourceFile = ts.🔶️<i><b title="CallWithDescriptor">getSourceFileOfNode</b></i>(list⚠️<i><b title="LoadKeyedGeneric">[0]</b></i>);
                return 🔶️<i><b title="CallWithDescriptor">grammarErrorAtPos</b></i>(sourceFile, start, end ⚠️<i><b title="Sub">- start</b></i>, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Trailing_comma_not_allowed</b></i>);
            }
        }</pre>

</details>
<details>
<summary>checkGrammarForAtLeastOneTypeArgument</summary>
<pre class="code">
(node, typeArguments) {
            if (typeArguments && typeArguments.length === 0) {
                var sourceFile = ts.🔶️<i><b title="CallWithDescriptor">getSourceFileOfNode</b></i>(node);
                var start = typeArguments⚠️<i><b title="LoadNamedGeneric">.pos</b></i> ⚠️<i><b title="Sub">- "<"</b></i>.length;
                var end = ts.🔶️<i><b title="CallWithDescriptor">skipTrivia</b></i>(sourceFile⚠️<i><b title="LoadNamedGeneric">.text</b></i>, typeArguments⚠️<i><b title="LoadNamedGeneric">.end</b></i>) ⚠️<i><b title="Add">+ ">"</b></i>.length;
                return 🔶️<i><b title="CallWithDescriptor">grammarErrorAtPos</b></i>(sourceFile, start, end - start, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Type_argument_list_cannot_be_empty</b></i>);
            }
        }</pre>

</details>
</blockquote>



### getTypeFromNonGenericTypeReference:
<pre class="code">
(node, symbol) {
            if (node.typeArguments) {
                🔶️<i><b title="CallWithDescriptor">error</b></i>(node, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Type_0_is_not_generic</b></i>, 🔶️<i><b title="CallWithDescriptor">symbolToString</b></i>(symbol));
                return unknownType;
            }
            return 🔶<i><b title="Did not inline: target text too big">getDeclaredTypeOfSymbol</b></i>(symbol);
        }</pre>



### getDeclaredTypeOfTypeParameter:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(symbol) {
            var links = <b title="Inlined">🔷getSymbolLinks</b>(symbol);
            if (!links.declaredType) {
                var type = <b title="Inlined">🔷createType</b>(16384 /* TypeParameter */);
                type.symbol = symbol;
                if (!ts.🔶<i><b title="Did not inline: unknown">getDeclarationOfKind</b></i>(symbol, 143 /* TypeParameter */).constraint) {
                    type.constraint ⚠️<i><b title="StoreNamedGeneric">= noConstraintType</b></i>;
                }
                links.declaredType = type;
            }
            return links.declaredType;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getSymbolLinks</summary>
<pre class="code">
(symbol) {
            if (symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 67108864 /* Transient */)
                return symbol;
            var id = <b title="Inlined">🔷getSymbolId</b>(symbol);
            return symbolLinks⚠️<i><b title="LoadKeyedGeneric">[id]</b></i> || (symbolLinks[id] = {});
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getSymbolId</summary>
<pre class="code">
(symbol) {
        if (!symbol⚠️<i><b title="LoadNamedGeneric">.id</b></i>) {
            symbol.id ⚠️<i><b title="StoreNamedGeneric">= nextSymbolId</b></i>;
            nextSymbolId++;
        }
        return symbol⚠️<i><b title="LoadNamedGeneric">.id</b></i>;
    }</pre>

</details>
</blockquote>

</details>
<details>
<summary>createType</summary>
<pre class="code">
(flags) {
            var result = <b title="Inlined">🔷new Type</b>(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new Type</summary>
<pre class="code">
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### createObjectType:
<pre class="code">
(objectFlags, symbol) {
            var type = <b title="Inlined">🔷createType</b>(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol ⚠️<i><b title="StoreNamedGeneric">= symbol</b></i>;
            return type;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createType</summary>
<pre class="code">
(flags) {
            var result = <b title="Inlined">🔷new Type</b>(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new Type</summary>
<pre class="code">
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### getTypeFromTypeReference:
<pre class="code">
(node) {
            var links = <b title="Inlined">🔷getNodeLinks</b>(node);
            if (!links.resolvedType) {
                var symbol = void 0;
                var type = void 0;
                if (node.kind === 272 /* JSDocTypeReference */) {
                    var typeReferenceName = 🔶️<i><b title="CallWithDescriptor">getTypeReferenceName</b></i>(node);
                    symbol = 🔶️<i><b title="CallWithDescriptor">resolveTypeReferenceName</b></i>(typeReferenceName);
                    type = 🔶️<i><b title="CallWithDescriptor">getTypeReferenceType</b></i>(node, symbol);
                }
                else {
                    // We only support expressions that are simple qualified names. For other expressions this produces undefined.
                    var typeNameOrExpression = node.kind === 157 /* TypeReference */
                        ? node.typeName
                        : ts.🔶<i><b title="Did not inline: unknown">isEntityNameExpression</b></i>(node.expression)
                            ? node.expression
                            : undefined;
                    symbol = typeNameOrExpression && 🔶<i><b title="Did not inline: target text too big">resolveEntityName</b></i>(typeNameOrExpression, 793064 /* Type */) || unknownSymbol;
                    type = symbol === unknownSymbol ? unknownType :
                        symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & (32 /* Class */ | 64 /* Interface */) ? 🔶<i><b title="Did not inline: target text too big">getTypeFromClassOrInterfaceReference</b></i>(node, symbol) :
                            symbol.flags & 524288 /* TypeAlias */ ? 🔶️<i><b title="CallWithDescriptor">getTypeFromTypeAliasReference</b></i>(node, symbol) :
                                <b title="Inlined">🔷getTypeFromNonGenericTypeReference</b>(node, symbol);
                }
                // Cache both the resolved symbol and the resolved type. The resolved symbol is needed in when we check the
                // type reference in checkTypeReferenceOrExpressionWithTypeArguments.
                links.resolvedSymbol ⚠️<i><b title="StoreNamedGeneric">= symbol</b></i>;
                links.resolvedType = type;
            }
            return links.resolvedType;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getNodeLinks</summary>
<pre class="code">
(node) {
            var nodeId = <b title="Inlined">🔷getNodeId</b>(node);
            return nodeLinks⚠️<i><b title="LoadKeyedGeneric">[nodeId]</b></i> || (nodeLinks[nodeId] = { flags: 0 });
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getNodeId</summary>
<pre class="code">
(node) {
        if (!node⚠️<i><b title="LoadNamedGeneric">.id</b></i>) {
            node.id ⚠️<i><b title="StoreNamedGeneric">= nextNodeId</b></i>;
            nextNodeId++;
        }
        return node⚠️<i><b title="LoadNamedGeneric">.id</b></i>;
    }</pre>

</details>
</blockquote>

</details>
<details>
<summary>getTypeFromNonGenericTypeReference</summary>
<pre class="code">
(node, symbol) {
            if (node.typeArguments) {
                🔶️<i><b title="CallWithDescriptor">error</b></i>(node, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Type_0_is_not_generic</b></i>, 🔶️<i><b title="CallWithDescriptor">symbolToString</b></i>(symbol));
                return unknownType;
            }
            return 🔶<i><b title="Did not inline: target text too big">getDeclaredTypeOfSymbol</b></i>(symbol);
        }</pre>

</details>
</blockquote>



### checkCollisionWithRequireExportsInGeneratedCode:
<pre class="code">
(node, name) {
            // No need to check for require or exports for ES6 modules and later
            if (modulekind &gt;= ts⚠️<i><b title="LoadNamedGeneric">.ModuleKind</b></i>.ES2015) {
                return;
            }
            if (!🔶<i><b title="Did not inline: target text too big">needCollisionCheckForIdentifier</b></i>(node, name, "require") && !🔶<i><b title="Did not inline: target text too big">needCollisionCheckForIdentifier</b></i>(node, name, "exports")) {
                return;
            }
            // Uninstantiated modules shouldnt do this check
            if (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 230</b></i> /* ModuleDeclaration */ && ts.🔶️<i><b title="CallWithDescriptor">getModuleInstanceState</b></i>(node) ⚠️<i><b title="CompareGeneric">!== 1</b></i> /* Instantiated */) {
                return;
            }
            // In case of variable declaration, node.parent is variable statement so look at the variable statement's parent
            var parent = 🔶️<i><b title="CallWithDescriptor">getDeclarationContainer</b></i>(node);
            if (parent⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 261</b></i> /* SourceFile */ && ts.🔶<i><b title="Did not inline: unknown">isExternalOrCommonJsModule</b></i>(parent)) {
                // If the declaration happens to be in external module, report error that require and exports are reserved keywords
                🔶️<i><b title="CallWithDescriptor">error</b></i>(name, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module</b></i>, ts.🔶️<i><b title="CallWithDescriptor">declarationNameToString</b></i>(name), ts.🔶️<i><b title="CallWithDescriptor">declarationNameToString</b></i>(name));
            }
        }</pre>



### ⛔ isExternalOrCommonJsModule (deoptimizated):
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(file) {
        return (file.externalModuleIndicator || file.commonJsModuleIndicator) !== undefined;
    }</pre>

```diff
- Deopt: <JS Function nodeIsMissing (SharedFunctionInfo 0x3504a53cc419)> (opt #531) @2, FP to SP delta: 24, caller sp: 0x7fff5fbfd798
```



### checkParameter:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(node) {
            // Grammar checking
            // It is a SyntaxError if the Identifier "eval" or the Identifier "arguments" occurs as the
            // Identifier in a PropertySetParameterList of a PropertyAssignment that is contained in strict code
            // or if its FunctionBody is strict code(11.1.5).
            // Grammar checking
            🔶<i><b title="Did not inline: target text too big">checkGrammarDecorators</b></i>(node) || 🔶<i><b title="Did not inline: target text too big">checkGrammarModifiers</b></i>(node);
            🔶<i><b title="Did not inline: target text too big">checkVariableLikeDeclaration</b></i>(node);
            var func = ts.🔶<i><b title="Did not inline: unknown">getContainingFunction</b></i>(node);
            if (ts.🔶<i><b title="Did not inline: target text too big">getModifierFlags</b></i>(node) & 92 /* ParameterPropertyModifier */) {
                func = ts.🔶<i><b title="Did not inline: unknown">getContainingFunction</b></i>(node);
                if (!(func⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 150</b></i> /* Constructor */ && ts.🔶<i><b title="Did not inline: unknown">nodeIsPresent</b></i>(func⚠️<i><b title="LoadNamedGeneric">.body</b></i>))) {
                    🔶️<i><b title="CallWithDescriptor">error</b></i>(node, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.A_parameter_property_is_only_allowed_in_a_constructor_implementation</b></i>);
                }
            }
            if (node.questionToken && ts.⚠️<i><b title="LoadNamedGeneric">isBindingPattern</b></i>(node.name) && func⚠️<i><b title="LoadNamedGeneric">.body</b></i>) {
                🔶️<i><b title="CallWithDescriptor">error</b></i>(node, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.A_binding_pattern_parameter_cannot_be_optional_in_an_implementation_signature</b></i>);
            }
            if (node.name.text === "this") {
                if (ts.🔶<i><b title="Did not inline: unknown">indexOf</b></i>(func.parameters, node) !== 0) {
                    🔶️<i><b title="CallWithDescriptor">error</b></i>(node, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.A_this_parameter_must_be_the_first_parameter</b></i>);
                }
                if (func.kind === 150 /* Constructor */ || func.kind === 154 /* ConstructSignature */ || func.kind === 159 /* ConstructorType */) {
                    🔶️<i><b title="CallWithDescriptor">error</b></i>(node, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.A_constructor_cannot_have_a_this_parameter</b></i>);
                }
            }
            // Only check rest parameter type if it's not a binding pattern. Since binding patterns are
            // not allowed in a rest parameter, we already have an error from checkGrammarParameterList.
            if (node.dotDotDotToken && !ts.🔶<i><b title="Did not inline: unknown">isBindingPattern</b></i>(node.name) && !<b title="Inlined">🔷isArrayType</b>(getTypeOfSymbol(node.symbol))) {
                🔶️<i><b title="CallWithDescriptor">error</b></i>(node, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.A_rest_parameter_must_be_of_an_array_type</b></i>);
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>isArrayType</summary>
<pre class="code">
(type) {
            return <b title="Inlined">🔷getObjectFlags</b>(type) & 4 /* Reference */ && type.target === globalArrayType;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getObjectFlags</summary>
<pre class="code">
(type) {
            return type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 32768 /* Object */ ? type⚠️<i><b title="LoadNamedGeneric">.objectFlags</b></i> : 0;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### getDeclaredTypeOfSymbol:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(symbol) {
            ts⚠️<i><b title="LoadNamedGeneric">.Debug</b></i>.🔶️<i><b title="CallWithDescriptor">assert</b></i>((symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 16777216 /* Instantiated */) === 0);
            if (symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & (32 /* Class */ | 64 /* Interface */)) {
                return 🔶<i><b title="Did not inline: target text too big">getDeclaredTypeOfClassOrInterface</b></i>(symbol);
            }
            if (symbol.flags & 524288 /* TypeAlias */) {
                return 🔶️<i><b title="CallWithDescriptor">getDeclaredTypeOfTypeAlias</b></i>(symbol);
            }
            if (symbol.flags & 262144 /* TypeParameter */) {
                return <b title="Inlined">🔷getDeclaredTypeOfTypeParameter</b>(symbol);
            }
            if (symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> ⚠️<i><b title="Bitwise">& 384</b></i> /* Enum */) {
                return 🔶️<i><b title="CallWithDescriptor">getDeclaredTypeOfEnum</b></i>(symbol);
            }
            if (symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> ⚠️<i><b title="Bitwise">& 8</b></i> /* EnumMember */) {
                return 🔶️<i><b title="CallWithDescriptor">getDeclaredTypeOfEnumMember</b></i>(symbol);
            }
            if (symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> ⚠️<i><b title="Bitwise">& 8388608</b></i> /* Alias */) {
                return 🔶️<i><b title="CallWithDescriptor">getDeclaredTypeOfAlias</b></i>(symbol);
            }
            return unknownType;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getDeclaredTypeOfTypeParameter</summary>
<pre class="code">
(symbol) {
            var links = <b title="Inlined">🔷getSymbolLinks</b>(symbol);
            if (!links.declaredType) {
                var type = <b title="Inlined">🔷createType</b>(16384 /* TypeParameter */);
                type.symbol = symbol;
                if (!ts.🔶<i><b title="Did not inline: unknown">getDeclarationOfKind</b></i>(symbol, 143 /* TypeParameter */).constraint) {
                    type.constraint ⚠️<i><b title="StoreNamedGeneric">= noConstraintType</b></i>;
                }
                links.declaredType = type;
            }
            return links.declaredType;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getSymbolLinks</summary>
<pre class="code">
(symbol) {
            if (symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 67108864 /* Transient */)
                return symbol;
            var id = <b title="Inlined">🔷getSymbolId</b>(symbol);
            return symbolLinks⚠️<i><b title="LoadKeyedGeneric">[id]</b></i> || (symbolLinks[id] = {});
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getSymbolId</summary>
<pre class="code">
(symbol) {
        if (!symbol⚠️<i><b title="LoadNamedGeneric">.id</b></i>) {
            symbol.id ⚠️<i><b title="StoreNamedGeneric">= nextSymbolId</b></i>;
            nextSymbolId++;
        }
        return symbol⚠️<i><b title="LoadNamedGeneric">.id</b></i>;
    }</pre>

</details>
</blockquote>

</details>
<details>
<summary>createType</summary>
<pre class="code">
(flags) {
            var result = <b title="Inlined">🔷new Type</b>(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new Type</summary>
<pre class="code">
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>



### isNumericName:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(name) {
            return name.kind === 142 /* ComputedPropertyName */ ? 🔶️<i><b title="CallWithDescriptor">isNumericComputedName</b></i>(name) : 🔶<i><b title="Did not inline: target text too big">isNumericLiteralName</b></i>(name.text);
        }</pre>



### ⛔ instantiateType (deoptimizated):
<div>~recompile~</div>

```diff
- Deopt: <JS Function isNumericName (SharedFunctionInfo 0x2e2f693ff541)> (opt #343) @2, FP to SP delta: 24, caller sp: 0x7fff5fbfde18
```

<div>~recompile~</div>
<pre class="code">
(type, mapper) {
            if (type && mapper !== identityMapper) {
                // If we are instantiating a type that has a top-level type alias, obtain the instantiation through
                // the type alias instead in order to share instantiations for the same type arguments. This can
                // dramatically reduce the number of structurally identical types we generate. Note that we can only
                // perform this optimization for top-level type aliases. Consider:
                //
                //   function f1&lt;T&gt;(x: T) {
                //     type Foo&lt;X&gt; = { x: X, t: T };
                //     let obj: Foo&lt;T&gt; = { x: x };
                //     return obj;
                //   }
                //   function f2&lt;U&gt;(x: U) { return f1(x); }
                //   let z = f2(42);
                //
                // Above, the declaration of f2 has an inferred return type that is an instantiation of f1's Foo&lt;X&gt;
                // equivalent to { x: U, t: U }. When instantiating this return type, we can't go back to Foo&lt;X&gt;'s
                // cache because all cached instantiations are of the form { x: ???, t: T }, i.e. they have not been
                // instantiated for T. Instead, we need to further instantiate the { x: U, t: U } form.
                if (type⚠️<i><b title="LoadNamedGeneric">.aliasSymbol</b></i> && <b title="Inlined">🔷isTopLevelTypeAlias</b>(type⚠️<i><b title="LoadNamedGeneric">.aliasSymbol</b></i>)) {
                    if (type⚠️<i><b title="LoadNamedGeneric">.aliasTypeArguments</b></i>) {
                        return 🔶️<i><b title="CallWithDescriptor">getTypeAliasInstantiation</b></i>(type⚠️<i><b title="LoadNamedGeneric">.aliasSymbol</b></i>, 🔶<i><b title="Did not inline: unknown">instantiateTypes</b></i>(type⚠️<i><b title="LoadNamedGeneric">.aliasTypeArguments</b></i>, mapper));
                    }
                    return type;
                }
                return 🔶<i><b title="Did not inline: target text too big">instantiateTypeNoAlias</b></i>(type, mapper);
            }
            return type;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>isTopLevelTypeAlias</summary>
<pre class="code">
(symbol) {
            if (symbol⚠️<i><b title="LoadNamedGeneric">.declarations</b></i> && symbol⚠️<i><b title="LoadNamedGeneric">.declarations</b></i>⚠️<i><b title="LoadNamedGeneric">.length</b></i>) {
                var parentKind = symbol⚠️<i><b title="LoadNamedGeneric">.declarations</b></i>[0]⚠️<i><b title="LoadNamedGeneric">.parent</b></i>⚠️<i><b title="LoadNamedGeneric">.kind</b></i>;
                return parentKind === 261 /* SourceFile */ || parentKind ⚠️<i><b title="CompareGeneric">=== 231</b></i> /* ModuleBlock */;
            }
            return false;
        }</pre>

</details>
</blockquote>



### getAliasSymbolForTypeNode:
<pre class="code">
(node) {
            return node.parent⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 228 /* TypeAliasDeclaration */ ? <b title="Inlined">🔷getSymbolOfNode</b>(node.parent) : undefined;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getSymbolOfNode</summary>
<pre class="code">
(node) {
            return <b title="Inlined">🔷getMergedSymbol</b>(node.symbol);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getMergedSymbol</summary>
<pre class="code">
(symbol) {
            var merged;
            return symbol && symbol⚠️<i><b title="LoadNamedGeneric">.mergeId</b></i> && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### getTypeOfVariableOrParameterOrProperty:
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(symbol) {
            var links = <b title="Inlined">🔷getSymbolLinks</b>(symbol);
            if (!links⚠️<i><b title="LoadNamedGeneric">.type</b></i>) {
                // Handle prototype property
                if (symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 134217728 /* Prototype */) {
                    return links.type ⚠️<i><b title="StoreNamedGeneric">= getTypeOfPrototypeProperty</b></i>(symbol);
                }
                // Handle catch clause variables
                var declaration = symbol.valueDeclaration;
                if (ts.⚠️<i><b title="LoadNamedGeneric">isCatchClauseVariableDeclarationOrBindingElement</b></i>(declaration)) {
                    return links.type ⚠️<i><b title="StoreNamedGeneric">= anyType</b></i>;
                }
                // Handle export default expressions
                if (declaration⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 240 /* ExportAssignment */) {
                    return links.type ⚠️<i><b title="StoreNamedGeneric">= checkExpression</b></i>(declaration⚠️<i><b title="LoadNamedGeneric">.expression</b></i>);
                }
                if (declaration⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 65536 /* JavaScriptFile */ && declaration⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 286</b></i> /* JSDocPropertyTag */ && declaration⚠️<i><b title="LoadNamedGeneric">.typeExpression</b></i>) {
                    return links.type ⚠️<i><b title="StoreNamedGeneric">= getTypeFromTypeNode</b></i>(declaration⚠️<i><b title="LoadNamedGeneric">.typeExpression</b></i>⚠️<i><b title="LoadNamedGeneric">.type</b></i>);
                }
                // Handle variable, parameter or property
                if (!🔶<i><b title="Did not inline: target text too big">pushTypeResolution</b></i>(symbol, 0 /* Type */)) {
                    return unknownType;
                }
                var type = void 0;
                // Handle certain special assignment kinds, which happen to union across multiple declarations:
                // * module.exports = expr
                // * exports.p = expr
                // * this.p = expr
                // * className.prototype.method = expr
                if (declaration⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 192 /* BinaryExpression */ ||
                    declaration⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 177 /* PropertyAccessExpression */ && declaration⚠️<i><b title="LoadNamedGeneric">.parent</b></i>⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 192</b></i> /* BinaryExpression */) {
                    // Use JS Doc type if present on parent expression statement
                    if (declaration⚠️<i><b title="LoadNamedGeneric">.flags</b></i> ⚠️<i><b title="Bitwise">& 65536</b></i> /* JavaScriptFile */) {
                        var jsdocType = ts.🔶️<i><b title="CallWithDescriptor">getJSDocType</b></i>(declaration⚠️<i><b title="LoadNamedGeneric">.parent</b></i>);
                        if (jsdocType) {
                            return links.type ⚠️<i><b title="StoreNamedGeneric">= getTypeFromTypeNode</b></i>(jsdocType);
                        }
                    }
                    var declaredTypes = ts.⚠️<i><b title="LoadNamedGeneric">map</b></i>(symbol⚠️<i><b title="LoadNamedGeneric">.declarations</b></i>, 🔶️<i><b title="CallWithDescriptor">function</b></i> (decl) { return decl.kind === 192 /* BinaryExpression */ ?
                        checkExpressionCached(decl.right) :
                        checkExpressionCached(decl.parent.right); });
                    type = 🔶<i><b title="Did not inline: target text too big">getUnionType</b></i>(declaredTypes, /*subtypeReduction*/ true);
                }
                else {
                    type = 🔶<i><b title="Did not inline: target text too big">getWidenedTypeForVariableLikeDeclaration</b></i>(declaration, /*reportErrors*/ true);
                }
                if (!<b title="Inlined">🔷popTypeResolution</b>()) {
                    type = 🔶️<i><b title="CallWithDescriptor">reportCircularityError</b></i>(symbol);
                }
                links.type = type;
            }
            return links.type;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getSymbolLinks</summary>
<pre class="code">
(symbol) {
            if (symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 67108864 /* Transient */)
                return symbol;
            var id = <b title="Inlined">🔷getSymbolId</b>(symbol);
            return symbolLinks⚠️<i><b title="LoadKeyedGeneric">[id]</b></i> || (symbolLinks[id] = {});
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getSymbolId</summary>
<pre class="code">
(symbol) {
        if (!symbol⚠️<i><b title="LoadNamedGeneric">.id</b></i>) {
            symbol.id ⚠️<i><b title="StoreNamedGeneric">= nextSymbolId</b></i>;
            nextSymbolId++;
        }
        return symbol⚠️<i><b title="LoadNamedGeneric">.id</b></i>;
    }</pre>

</details>
</blockquote>

</details>
<details>
<summary>popTypeResolution</summary>
<pre class="code">
() {
            resolutionTargets.pop();
            resolutionPropertyNames.pop();
            return resolutionResults.pop();
        }</pre>

</details>
</blockquote>



### resolveEntityName:
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(name, meaning, ignoreErrors, dontResolveAlias, location) {
            if (ts.⚠️<i><b title="LoadNamedGeneric">nodeIsMissing</b></i>(name)) {
                return undefined;
            }
            var symbol;
            if (name.kind === 70 /* Identifier */) {
                var message = meaning === 1920 /* Namespace */ ? ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>.Cannot_find_namespace_0 : ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>.Cannot_find_name_0;
                symbol = 🔶<i><b title="Did not inline: target text too big">resolveName</b></i>(location || name, name.text, meaning, ignoreErrors ? undefined : message, name);
                if (!symbol) {
                    return undefined;
                }
            }
            else if (name.kind === 141 /* QualifiedName */ || name.kind === 177 /* PropertyAccessExpression */) {
                var left = name.kind === 141 /* QualifiedName */ ? name.left : name.expression;
                var right = name.kind === 141 /* QualifiedName */ ? name.right : name.name;
                var namespace = resolveEntityName(left, 1920 /* Namespace */, ignoreErrors, /*dontResolveAlias*/ false, location);
                if (!namespace || ts.⚠️<i><b title="LoadNamedGeneric">nodeIsMissing</b></i>(right)) {
                    return undefined;
                }
                else if (namespace === unknownSymbol) {
                    return namespace;
                }
                symbol = 🔶<i><b title="Did not inline: target text too big">getSymbol</b></i>(<b title="Inlined">🔷getExportsOfSymbol</b>(namespace), right.text, meaning);
                if (!symbol) {
                    if (!ignoreErrors) {
                        🔶️<i><b title="CallWithDescriptor">error</b></i>(right, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Namespace_0_has_no_exported_member_1</b></i>, 🔶️<i><b title="CallWithDescriptor">getFullyQualifiedName</b></i>(namespace), ts.⚠️<i><b title="LoadNamedGeneric">declarationNameToString</b></i>(right));
                    }
                    return undefined;
                }
            }
            else {
                ts⚠️<i><b title="LoadNamedGeneric">.Debug</b></i>.⚠️<i><b title="LoadNamedGeneric">fail</b></i>("Unknown entity name kind.");
            }
            ts⚠️<i><b title="LoadNamedGeneric">.Debug</b></i>.🔶️<i><b title="CallWithDescriptor">assert</b></i>((symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 16777216 /* Instantiated */) === 0, "Should never get an instantiated symbol here.");
            return (symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & meaning) || dontResolveAlias ? symbol : 🔶️<i><b title="CallWithDescriptor">resolveAlias</b></i>(symbol);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getExportsOfSymbol</summary>
<pre class="code">
(symbol) {
            return symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 1536 /* Module */ ? <b title="Inlined">🔷getExportsOfModule</b>(symbol) : symbol.exports || emptySymbols;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getExportsOfModule</summary>
<pre class="code">
(moduleSymbol) {
            var links = <b title="Inlined">🔷getSymbolLinks</b>(moduleSymbol);
            return links⚠️<i><b title="LoadNamedGeneric">.resolvedExports</b></i> || (links.resolvedExports = getExportsForModule(moduleSymbol));
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getSymbolLinks</summary>
<pre class="code">
(symbol) {
            if (symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 67108864 /* Transient */)
                return symbol;
            var id = <b title="Inlined">🔷getSymbolId</b>(symbol);
            return symbolLinks⚠️<i><b title="LoadKeyedGeneric">[id]</b></i> || (symbolLinks[id] = {});
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getSymbolId</summary>
<pre class="code">
(symbol) {
        if (!symbol⚠️<i><b title="LoadNamedGeneric">.id</b></i>) {
            symbol.id ⚠️<i><b title="StoreNamedGeneric">= nextSymbolId</b></i>;
            nextSymbolId++;
        }
        return symbol⚠️<i><b title="LoadNamedGeneric">.id</b></i>;
    }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>



### getTypeOfInstantiatedSymbol:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(symbol) {
            var links = <b title="Inlined">🔷getSymbolLinks</b>(symbol);
            if (!links.type) {
                if (!🔶<i><b title="Did not inline: target text too big">pushTypeResolution</b></i>(symbol, 0 /* Type */)) {
                    return unknownType;
                }
                var type = 🔶<i><b title="Did not inline: target text too big">instantiateType</b></i>(🔶<i><b title="Did not inline: target text too big">getTypeOfSymbol</b></i>(links.target), links.mapper);
                if (!<b title="Inlined">🔷popTypeResolution</b>()) {
                    type = 🔶️<i><b title="CallWithDescriptor">reportCircularityError</b></i>(symbol);
                }
                links.type = type;
            }
            return links.type;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getSymbolLinks</summary>
<pre class="code">
(symbol) {
            if (symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 67108864 /* Transient */)
                return symbol;
            var id = <b title="Inlined">🔷getSymbolId</b>(symbol);
            return symbolLinks⚠️<i><b title="LoadKeyedGeneric">[id]</b></i> || (symbolLinks[id] = {});
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getSymbolId</summary>
<pre class="code">
(symbol) {
        if (!symbol⚠️<i><b title="LoadNamedGeneric">.id</b></i>) {
            symbol.id ⚠️<i><b title="StoreNamedGeneric">= nextSymbolId</b></i>;
            nextSymbolId++;
        }
        return symbol⚠️<i><b title="LoadNamedGeneric">.id</b></i>;
    }</pre>

</details>
</blockquote>

</details>
<details>
<summary>popTypeResolution</summary>
<pre class="code">
() {
            resolutionTargets.pop();
            resolutionPropertyNames.pop();
            return resolutionResults.pop();
        }</pre>

</details>
</blockquote>



### instantiateTypes:
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(types, mapper) {
            return <b title="Inlined">🔷instantiateList</b>(types, mapper, instantiateType);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>instantiateList</summary>
<pre class="code">
(items, mapper, instantiator) {
            if (items && items.length) {
                var result = [];
                for (var _i = 0, items_1 = items; _i &lt; items_1.length; _i++) {
                    var v = items_1[_i];
                    result.push(🔶️<i><b title="CallWithDescriptor">instantiator</b></i>(v, mapper));
                }
                return result;
            }
            return items;
        }</pre>

</details>
</blockquote>



### checkMethodDeclaration:
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(node) {
            // Grammar checking
            🔶<i><b title="Did not inline: target text too big">checkGrammarMethod</b></i>(node) || <b title="Inlined">🔷checkGrammarComputedPropertyName</b>(node.name);
            // Grammar checking for modifiers is done inside the function checkGrammarFunctionLikeDeclaration
            🔶<i><b title="Did not inline: target text too big">checkFunctionOrMethodDeclaration</b></i>(node);
            // Abstract methods cannot have an implementation.
            // Extra checks are to avoid reporting multiple errors relating to the "abstractness" of the node.
            if (ts.🔶<i><b title="Did not inline: target text too big">getModifierFlags</b></i>(node) & 128 /* Abstract */ && node⚠️<i><b title="LoadNamedGeneric">.body</b></i>) {
                🔶️<i><b title="CallWithDescriptor">error</b></i>(node, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Method_0_cannot_have_an_implementation_because_it_is_marked_abstract</b></i>, ts.🔶️<i><b title="CallWithDescriptor">declarationNameToString</b></i>(node⚠️<i><b title="LoadNamedGeneric">.name</b></i>));
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>checkGrammarComputedPropertyName</summary>
<pre class="code">
(node) {
            // If node is not a computedPropertyName, just skip the grammar checking
            if (node.kind !== 142 /* ComputedPropertyName */) {
                return false;
            }
            var computedPropertyName = node;
            if (computedPropertyName⚠️<i><b title="LoadNamedGeneric">.expression</b></i>⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 192</b></i> /* BinaryExpression */ && computedPropertyName⚠️<i><b title="LoadNamedGeneric">.expression</b></i>⚠️<i><b title="LoadNamedGeneric">.operatorToken</b></i>⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 25</b></i> /* CommaToken */) {
                return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(computedPropertyName⚠️<i><b title="LoadNamedGeneric">.expression</b></i>, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.A_comma_expression_is_not_allowed_in_a_computed_property_name</b></i>);
            }
        }</pre>

</details>
</blockquote>



### instantiateCached:
<pre class="code">
(type, mapper, instantiator) {
            var instantiations = mapper.instantiations || (mapper.instantiations = []);
            return instantiations⚠️<i><b title="LoadKeyedGeneric">[type</b></i>.id] || (instantiations[type.id] = 🔶️<i><b title="CallWithDescriptor">instantiator</b></i>(type, mapper));
        }</pre>



### instantiateAnonymousType:
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(type, mapper) {
            var result = <b title="Inlined">🔷createObjectType</b>(16 /* Anonymous */ | 64 /* Instantiated */, type.symbol);
            result.target = type.objectFlags & 64 /* Instantiated */ ? type⚠️<i><b title="LoadNamedGeneric">.target</b></i> : type;
            result.mapper = type.objectFlags & 64 /* Instantiated */ ? 🔶️<i><b title="CallWithDescriptor">combineTypeMappers</b></i>(type⚠️<i><b title="LoadNamedGeneric">.mapper</b></i>, mapper) : mapper;
            result.aliasSymbol ⚠️<i><b title="StoreNamedGeneric">= type</b></i>.aliasSymbol;
            result.aliasTypeArguments = <b title="Inlined">🔷instantiateTypes</b>(type.aliasTypeArguments, mapper);
            return result;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createObjectType</summary>
<pre class="code">
(objectFlags, symbol) {
            var type = <b title="Inlined">🔷createType</b>(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol ⚠️<i><b title="StoreNamedGeneric">= symbol</b></i>;
            return type;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createType</summary>
<pre class="code">
(flags) {
            var result = <b title="Inlined">🔷new Type</b>(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new Type</summary>
<pre class="code">
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>instantiateTypes</summary>
<pre class="code">
(types, mapper) {
            return <b title="Inlined">🔷instantiateList</b>(types, mapper, instantiateType);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>instantiateList</summary>
<pre class="code">
(items, mapper, instantiator) {
            if (items && items.length) {
                var result = [];
                for (var _i = 0, items_1 = items; _i &lt; items_1.length; _i++) {
                    var v = items_1[_i];
                    result.push(🔶️<i><b title="CallWithDescriptor">instantiator</b></i>(v, mapper));
                }
                return result;
            }
            return items;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### getTypeOfSymbol:
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(symbol) {
            if (symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 16777216 /* Instantiated */) {
                return <b title="Inlined">🔷getTypeOfInstantiatedSymbol</b>(symbol);
            }
            if (symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & (3 /* Variable */ | 4 /* Property */)) {
                return 🔶<i><b title="Did not inline: target text too big">getTypeOfVariableOrParameterOrProperty</b></i>(symbol);
            }
            if (symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & (16 /* Function */ | 8192 /* Method */ | 32 /* Class */ | 384 /* Enum */ | 512 /* ValueModule */)) {
                return <b title="Inlined">🔷getTypeOfFuncClassEnumModule</b>(symbol);
            }
            if (symbol.flags & 8 /* EnumMember */) {
                return 🔶️<i><b title="CallWithDescriptor">getTypeOfEnumMember</b></i>(symbol);
            }
            if (symbol.flags & 98304 /* Accessor */) {
                return 🔶️<i><b title="CallWithDescriptor">getTypeOfAccessors</b></i>(symbol);
            }
            if (symbol.flags & 8388608 /* Alias */) {
                return 🔶️<i><b title="CallWithDescriptor">getTypeOfAlias</b></i>(symbol);
            }
            return unknownType;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getTypeOfInstantiatedSymbol</summary>
<pre class="code">
(symbol) {
            var links = <b title="Inlined">🔷getSymbolLinks</b>(symbol);
            if (!links.type) {
                if (!🔶<i><b title="Did not inline: target text too big">pushTypeResolution</b></i>(symbol, 0 /* Type */)) {
                    return unknownType;
                }
                var type = 🔶<i><b title="Did not inline: target text too big">instantiateType</b></i>(🔶<i><b title="Did not inline: target text too big">getTypeOfSymbol</b></i>(links.target), links.mapper);
                if (!<b title="Inlined">🔷popTypeResolution</b>()) {
                    type = 🔶️<i><b title="CallWithDescriptor">reportCircularityError</b></i>(symbol);
                }
                links.type = type;
            }
            return links.type;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getSymbolLinks</summary>
<pre class="code">
(symbol) {
            if (symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 67108864 /* Transient */)
                return symbol;
            var id = <b title="Inlined">🔷getSymbolId</b>(symbol);
            return symbolLinks⚠️<i><b title="LoadKeyedGeneric">[id]</b></i> || (symbolLinks[id] = {});
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getSymbolId</summary>
<pre class="code">
(symbol) {
        if (!symbol⚠️<i><b title="LoadNamedGeneric">.id</b></i>) {
            symbol.id ⚠️<i><b title="StoreNamedGeneric">= nextSymbolId</b></i>;
            nextSymbolId++;
        }
        return symbol⚠️<i><b title="LoadNamedGeneric">.id</b></i>;
    }</pre>

</details>
</blockquote>

</details>
<details>
<summary>popTypeResolution</summary>
<pre class="code">
() {
            resolutionTargets.pop();
            resolutionPropertyNames.pop();
            return resolutionResults.pop();
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>getTypeOfFuncClassEnumModule</summary>
<pre class="code">
(symbol) {
            var links = <b title="Inlined">🔷getSymbolLinks</b>(symbol);
            if (!links⚠️<i><b title="LoadNamedGeneric">.type</b></i>) {
                if (symbol.flags & 1536 /* Module */ && ts.🔶️<i><b title="CallWithDescriptor">isShorthandAmbientModuleSymbol</b></i>(symbol)) {
                    links.type ⚠️<i><b title="StoreNamedGeneric">= anyType</b></i>;
                }
                else {
                    var type = <b title="Inlined">🔷createObjectType</b>(16 /* Anonymous */, symbol);
                    links.type = strictNullChecks && symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> ⚠️<i><b title="Bitwise">& 536870912</b></i> /* Optional */ ?
                        🔶️<i><b title="CallWithDescriptor">includeFalsyTypes</b></i>(type, 2048 /* Undefined */) : type;
                }
            }
            return links⚠️<i><b title="LoadNamedGeneric">.type</b></i>;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getSymbolLinks</summary>
<pre class="code">
(symbol) {
            if (symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 67108864 /* Transient */)
                return symbol;
            var id = <b title="Inlined">🔷getSymbolId</b>(symbol);
            return symbolLinks⚠️<i><b title="LoadKeyedGeneric">[id]</b></i> || (symbolLinks[id] = {});
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getSymbolId</summary>
<pre class="code">
(symbol) {
        if (!symbol⚠️<i><b title="LoadNamedGeneric">.id</b></i>) {
            symbol.id ⚠️<i><b title="StoreNamedGeneric">= nextSymbolId</b></i>;
            nextSymbolId++;
        }
        return symbol⚠️<i><b title="LoadNamedGeneric">.id</b></i>;
    }</pre>

</details>
</blockquote>

</details>
<details>
<summary>createObjectType</summary>
<pre class="code">
(objectFlags, symbol) {
            var type = <b title="Inlined">🔷createType</b>(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol ⚠️<i><b title="StoreNamedGeneric">= symbol</b></i>;
            return type;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createType</summary>
<pre class="code">
(flags) {
            var result = <b title="Inlined">🔷new Type</b>(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new Type</summary>
<pre class="code">
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>



### isIndependentMember:
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(symbol) {
            if (symbol.declarations && symbol.declarations.length === 1) {
                var declaration = symbol.declarations[0];
                if (declaration) {
                    ⚠️<i><b title="CompareGeneric">switch</b></i> (declaration⚠️<i><b title="LoadNamedGeneric">.kind</b></i>) {
                        case 147 /* PropertyDeclaration */:
                        case 146 /* PropertySignature */:
                            return <b title="Inlined">🔷isIndependentVariableLikeDeclaration</b>(declaration);
                        case 149 /* MethodDeclaration */:
                        case 148 /* MethodSignature */:
                        case 150 /* Constructor */:
                            return <b title="Inlined">🔷isIndependentFunctionLikeDeclaration</b>(declaration);
                    }
                }
            }
            return false;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>isIndependentVariableLikeDeclaration</summary>
<pre class="code">
(node) {
            return node⚠️<i><b title="LoadNamedGeneric">.type</b></i> && 🔶<i><b title="Did not inline: target text too big">isIndependentType</b></i>(node⚠️<i><b title="LoadNamedGeneric">.type</b></i>) || !node.type && !node⚠️<i><b title="LoadNamedGeneric">.initializer</b></i>;
        }</pre>

</details>
<details>
<summary>isIndependentFunctionLikeDeclaration</summary>
<pre class="code">
(node) {
            if (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> !== 150 /* Constructor */ && (!node⚠️<i><b title="LoadNamedGeneric">.type</b></i> || !🔶<i><b title="Did not inline: target text too big">isIndependentType</b></i>(node⚠️<i><b title="LoadNamedGeneric">.type</b></i>))) {
                return false;
            }
            for (var _i = 0, _a = node.parameters; _i &lt; _a.length; _i++) {
                var parameter = _a[_i];
                if (!<b title="Inlined">🔷isIndependentVariableLikeDeclaration</b>(parameter)) {
                    return false;
                }
            }
            return true;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>isIndependentVariableLikeDeclaration</summary>
<pre class="code">
(node) {
            return node⚠️<i><b title="LoadNamedGeneric">.type</b></i> && 🔶<i><b title="Did not inline: target text too big">isIndependentType</b></i>(node⚠️<i><b title="LoadNamedGeneric">.type</b></i>) || !node.type && !node⚠️<i><b title="LoadNamedGeneric">.initializer</b></i>;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### getDeclaredTypeOfClassOrInterface:
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(symbol) {
            var links = <b title="Inlined">🔷getSymbolLinks</b>(symbol);
            if (!links⚠️<i><b title="LoadNamedGeneric">.declaredType</b></i>) {
                var kind = symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 32 /* Class */ ? 1 /* Class */ : 2 /* Interface */;
                var type = links.declaredType = <b title="Inlined">🔷createObjectType</b>(kind, symbol);
                var outerTypeParameters = <b title="Inlined">🔷getOuterTypeParametersOfClassOrInterface</b>(symbol);
                var localTypeParameters = 🔶️<i><b title="CallWithDescriptor">getLocalTypeParametersOfClassOrInterfaceOrTypeAlias</b></i>(symbol);
                // A class or interface is generic if it has type parameters or a "this" type. We always give classes a "this" type
                // because it is not feasible to analyze all members to determine if the "this" type escapes the class (in particular,
                // property types inferred from initializers and method return types inferred from return statements are very hard
                // to exhaustively analyze). We give interfaces a "this" type if we can't definitely determine that they are free of
                // "this" references.
                if (outerTypeParameters || localTypeParameters || kind === 1 /* Class */ || !🔶️<i><b title="CallWithDescriptor">isIndependentInterface</b></i>(symbol)) {
                    type.objectFlags |= 4 /* Reference */;
                    type.typeParameters = ts.⚠️<i><b title="LoadNamedGeneric">concatenate</b></i>(outerTypeParameters, localTypeParameters);
                    type.outerTypeParameters = outerTypeParameters;
                    type.localTypeParameters ⚠️<i><b title="StoreNamedGeneric">= localTypeParameters</b></i>;
                    type.instantiations = ts.🔶<i><b title="Did not inline: unknown">createMap</b></i>();
                    type.instantiations[🔶<i><b title="Did not inline: target text too big">getTypeListId</b></i>(type.typeParameters)] ⚠️<i><b title="StoreKeyedGeneric">= type</b></i>;
                    type.target = type;
                    type.typeArguments ⚠️<i><b title="StoreNamedGeneric">= type</b></i>.typeParameters;
                    type.thisType = <b title="Inlined">🔷createType</b>(16384 /* TypeParameter */);
                    type.thisType.isThisType = true;
                    type.thisType.symbol ⚠️<i><b title="StoreNamedGeneric">= symbol</b></i>;
                    type.thisType.constraint = type;
                }
            }
            return links.declaredType;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getSymbolLinks</summary>
<pre class="code">
(symbol) {
            if (symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 67108864 /* Transient */)
                return symbol;
            var id = <b title="Inlined">🔷getSymbolId</b>(symbol);
            return symbolLinks⚠️<i><b title="LoadKeyedGeneric">[id]</b></i> || (symbolLinks[id] = {});
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getSymbolId</summary>
<pre class="code">
(symbol) {
        if (!symbol⚠️<i><b title="LoadNamedGeneric">.id</b></i>) {
            symbol.id ⚠️<i><b title="StoreNamedGeneric">= nextSymbolId</b></i>;
            nextSymbolId++;
        }
        return symbol⚠️<i><b title="LoadNamedGeneric">.id</b></i>;
    }</pre>

</details>
</blockquote>

</details>
<details>
<summary>createObjectType</summary>
<pre class="code">
(objectFlags, symbol) {
            var type = <b title="Inlined">🔷createType</b>(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol ⚠️<i><b title="StoreNamedGeneric">= symbol</b></i>;
            return type;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createType</summary>
<pre class="code">
(flags) {
            var result = <b title="Inlined">🔷new Type</b>(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new Type</summary>
<pre class="code">
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>getOuterTypeParametersOfClassOrInterface</summary>
<pre class="code">
(symbol) {
            var declaration = symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 32 /* Class */ ? symbol.valueDeclaration : ts.🔶<i><b title="Did not inline: unknown">getDeclarationOfKind</b></i>(symbol, 227 /* InterfaceDeclaration */);
            return 🔶️<i><b title="CallWithDescriptor">appendOuterTypeParameters</b></i>(undefined, declaration);
        }</pre>

</details>
<details>
<summary>createType</summary>
<pre class="code">
(flags) {
            var result = <b title="Inlined">🔷new Type</b>(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new Type</summary>
<pre class="code">
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### getAliasTypeArgumentsForTypeNode:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(node) {
            var symbol = <b title="Inlined">🔷getAliasSymbolForTypeNode</b>(node);
            return symbol ? 🔶️<i><b title="CallWithDescriptor">getLocalTypeParametersOfClassOrInterfaceOrTypeAlias</b></i>(symbol) : undefined;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getAliasSymbolForTypeNode</summary>
<pre class="code">
(node) {
            return node⚠️<i><b title="LoadNamedGeneric">.parent</b></i>⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 228 /* TypeAliasDeclaration */ ? <b title="Inlined">🔷getSymbolOfNode</b>(node.parent) : undefined;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getSymbolOfNode</summary>
<pre class="code">
(node) {
            return <b title="Inlined">🔷getMergedSymbol</b>(node.symbol);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getMergedSymbol</summary>
<pre class="code">
(symbol) {
            var merged;
            return symbol && symbol⚠️<i><b title="LoadNamedGeneric">.mergeId</b></i> && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>



### isNumericLiteralName:
<pre class="code">
(name) {
            // The intent of numeric names is that
            //     - they are names with text in a numeric form, and that
            //     - setting properties/indexing with them is always equivalent to doing so with the numeric literal 'numLit',
            //         acquired by applying the abstract 'ToNumber' operation on the name's text.
            //
            // The subtlety is in the latter portion, as we cannot reliably say that anything that looks like a numeric literal is a numeric name.
            // In fact, it is the case that the text of the name must be equal to 'ToString(numLit)' for this to hold.
            //
            // Consider the property name '"0xF00D"'. When one indexes with '0xF00D', they are actually indexing with the value of 'ToString(0xF00D)'
            // according to the ECMAScript specification, so it is actually as if the user indexed with the string '"61453"'.
            // Thus, the text of all numeric literals equivalent to '61543' such as '0xF00D', '0xf00D', '0170015', etc. are not valid numeric names
            // because their 'ToString' representation is not equal to their original text.
            // This is motivated by ECMA-262 sections 9.3.1, 9.8.1, 11.1.5, and 11.2.1.
            //
            // Here, we test whether 'ToString(ToNumber(name))' is exactly equal to 'name'.
            // The '+' prefix operator is equivalent here to applying the abstract ToNumber operation.
            // Applying the 'toString()' method on a number gives us the abstract ToString operation on a number.
            //
            // Note that this accepts the values 'Infinity', '-Infinity', and 'NaN', and that this is intentional.
            // This is desired behavior, because when indexing with them as numeric entities, you are indexing
            // with the strings '"Infinity"', '"-Infinity"', and '"NaN"' respectively.
            return (🔶️<i><b title="CallWithDescriptor">+name</b></i>).🔶️<i><b title="CallWithDescriptor">toString</b></i>() === name;
        }</pre>



### hasProperty:
<pre class="code">
(map, key) {
        return hasOwnProperty.🔶️<i><b title="CallWithDescriptor">call</b></i>(map, key);
    }</pre>



### getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode:
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(node) {
            var links = <b title="Inlined">🔷getNodeLinks</b>(node);
            if (!links.resolvedType) {
                // Deferred resolution of members is handled by resolveObjectTypeMembers
                var aliasSymbol = <b title="Inlined">🔷getAliasSymbolForTypeNode</b>(node);
                if (ts.🔶️<i><b title="CallWithDescriptor">isEmpty</b></i>(node⚠️<i><b title="LoadNamedGeneric">.symbol</b></i>.members) && !aliasSymbol) {
                    links.resolvedType ⚠️<i><b title="StoreNamedGeneric">= emptyTypeLiteralType</b></i>;
                }
                else {
                    var type = <b title="Inlined">🔷createObjectType</b>(16 /* Anonymous */, node⚠️<i><b title="LoadNamedGeneric">.symbol</b></i>);
                    type.aliasSymbol = aliasSymbol;
                    type.aliasTypeArguments = <b title="Inlined">🔷getAliasTypeArgumentsForTypeNode</b>(node);
                    links.resolvedType ⚠️<i><b title="StoreNamedGeneric">= type</b></i>;
                }
            }
            return links.resolvedType;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getNodeLinks</summary>
<pre class="code">
(node) {
            var nodeId = <b title="Inlined">🔷getNodeId</b>(node);
            return nodeLinks⚠️<i><b title="LoadKeyedGeneric">[nodeId]</b></i> || (nodeLinks[nodeId] = { flags: 0 });
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getNodeId</summary>
<pre class="code">
(node) {
        if (!node⚠️<i><b title="LoadNamedGeneric">.id</b></i>) {
            node.id ⚠️<i><b title="StoreNamedGeneric">= nextNodeId</b></i>;
            nextNodeId++;
        }
        return node⚠️<i><b title="LoadNamedGeneric">.id</b></i>;
    }</pre>

</details>
</blockquote>

</details>
<details>
<summary>getAliasSymbolForTypeNode</summary>
<pre class="code">
(node) {
            return node⚠️<i><b title="LoadNamedGeneric">.parent</b></i>⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 228 /* TypeAliasDeclaration */ ? <b title="Inlined">🔷getSymbolOfNode</b>(node.parent) : undefined;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getSymbolOfNode</summary>
<pre class="code">
(node) {
            return <b title="Inlined">🔷getMergedSymbol</b>(node.symbol);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getMergedSymbol</summary>
<pre class="code">
(symbol) {
            var merged;
            return symbol && symbol⚠️<i><b title="LoadNamedGeneric">.mergeId</b></i> && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>createObjectType</summary>
<pre class="code">
(objectFlags, symbol) {
            var type = <b title="Inlined">🔷createType</b>(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol ⚠️<i><b title="StoreNamedGeneric">= symbol</b></i>;
            return type;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createType</summary>
<pre class="code">
(flags) {
            var result = <b title="Inlined">🔷new Type</b>(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new Type</summary>
<pre class="code">
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>getAliasTypeArgumentsForTypeNode</summary>
<pre class="code">
(node) {
            var symbol = <b title="Inlined">🔷getAliasSymbolForTypeNode</b>(node);
            return symbol ? 🔶️<i><b title="CallWithDescriptor">getLocalTypeParametersOfClassOrInterfaceOrTypeAlias</b></i>(symbol) : undefined;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getAliasSymbolForTypeNode</summary>
<pre class="code">
(node) {
            return node⚠️<i><b title="LoadNamedGeneric">.parent</b></i>⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 228 /* TypeAliasDeclaration */ ? <b title="Inlined">🔷getSymbolOfNode</b>(node.parent) : undefined;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getSymbolOfNode</summary>
<pre class="code">
(node) {
            return <b title="Inlined">🔷getMergedSymbol</b>(node.symbol);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getMergedSymbol</summary>
<pre class="code">
(symbol) {
            var merged;
            return symbol && symbol⚠️<i><b title="LoadNamedGeneric">.mergeId</b></i> && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>



### instantiateSymbol:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(symbol, mapper) {
            if (symbol.flags & 16777216 /* Instantiated */) {
                var links = <b title="Inlined">🔷getSymbolLinks</b>(symbol);
                // If symbol being instantiated is itself a instantiation, fetch the original target and combine the
                // type mappers. This ensures that original type identities are properly preserved and that aliases
                // always reference a non-aliases.
                symbol = links.target;
                mapper = 🔶️<i><b title="CallWithDescriptor">combineTypeMappers</b></i>(links.mapper, mapper);
            }
            // Keep the flags from the symbol we're instantiating.  Mark that is instantiated, and
            // also transient so that we can just store data on it directly.
            var result = <b title="Inlined">🔷createSymbol</b>(16777216 /* Instantiated */ | 67108864 /* Transient */ | symbol.flags, symbol.name);
            result.declarations = symbol.declarations;
            result.parent = symbol.parent;
            result.target = symbol;
            result.mapper ⚠️<i><b title="StoreNamedGeneric">= mapper</b></i>;
            if (symbol.valueDeclaration) {
                result.valueDeclaration = symbol.valueDeclaration;
            }
            return result;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getSymbolLinks</summary>
<pre class="code">
(symbol) {
            if (symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 67108864 /* Transient */)
                return symbol;
            var id = <b title="Inlined">🔷getSymbolId</b>(symbol);
            return symbolLinks⚠️<i><b title="LoadKeyedGeneric">[id]</b></i> || (symbolLinks[id] = {});
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getSymbolId</summary>
<pre class="code">
(symbol) {
        if (!symbol⚠️<i><b title="LoadNamedGeneric">.id</b></i>) {
            symbol.id ⚠️<i><b title="StoreNamedGeneric">= nextSymbolId</b></i>;
            nextSymbolId++;
        }
        return symbol⚠️<i><b title="LoadNamedGeneric">.id</b></i>;
    }</pre>

</details>
</blockquote>

</details>
<details>
<summary>createSymbol</summary>
<pre class="code">
(flags, name) {
            symbolCount++;
            return <b title="Inlined">🔷new Symbol</b>(flags, name);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new Symbol</summary>
<pre class="code">
(flags, name) {
            this.flags = flags;
            this.name = name;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### checkGrammarMethod:
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(node) {
            if (🔶️<i><b title="CallWithDescriptor">checkGrammarDisallowedModifiersOnObjectLiteralExpressionMethod</b></i>(node) ||
                <b title="Inlined">🔷checkGrammarFunctionLikeDeclaration</b>(node) ||
                🔶️<i><b title="CallWithDescriptor">checkGrammarForGenerator</b></i>(node)) {
                return true;
            }
            if (node⚠️<i><b title="LoadNamedGeneric">.parent</b></i>⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 176 /* ObjectLiteralExpression */) {
                if (🔶️<i><b title="CallWithDescriptor">checkGrammarForInvalidQuestionMark</b></i>(node⚠️<i><b title="LoadNamedGeneric">.questionToken</b></i>, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.An_object_member_cannot_be_declared_optional</b></i>)) {
                    return true;
                }
                else if (node⚠️<i><b title="LoadNamedGeneric">.body</b></i> === undefined) {
                    return 🔶️<i><b title="CallWithDescriptor">grammarErrorAtPos</b></i>(ts.🔶️<i><b title="CallWithDescriptor">getSourceFileOfNode</b></i>(node), node⚠️<i><b title="LoadNamedGeneric">.end</b></i> ⚠️<i><b title="Sub">- 1</b></i>, ";".length, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">._0_expected</b></i>, "{");
                }
            }
            if (ts.🔶<i><b title="Did not inline: unknown">isClassLike</b></i>(node⚠️<i><b title="LoadNamedGeneric">.parent</b></i>)) {
                // Technically, computed properties in ambient contexts is disallowed
                // for property declarations and accessors too, not just methods.
                // However, property declarations disallow computed names in general,
                // and accessors are not allowed in ambient contexts in general,
                // so this error only really matters for methods.
                if (ts.🔶<i><b title="Did not inline: unknown">isInAmbientContext</b></i>(node)) {
                    return <b title="Inlined">🔷checkGrammarForNonSymbolComputedProperty</b>(node.name, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>.A_computed_property_name_in_an_ambient_context_must_directly_refer_to_a_built_in_symbol);
                }
                else if (!node⚠️<i><b title="LoadNamedGeneric">.body</b></i>) {
                    return 🔶<i><b title="Did not inline: unknown">checkGrammarForNonSymbolComputedProperty</b></i>(node⚠️<i><b title="LoadNamedGeneric">.name</b></i>, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.A_computed_property_name_in_a_method_overload_must_directly_refer_to_a_built_in_symbol</b></i>);
                }
            }
            else if (node.parent⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 227 /* InterfaceDeclaration */) {
                return <b title="Inlined">🔷checkGrammarForNonSymbolComputedProperty</b>(node.name, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>.A_computed_property_name_in_an_interface_must_directly_refer_to_a_built_in_symbol);
            }
            else if (node.parent.kind === 161 /* TypeLiteral */) {
                return <b title="Inlined">🔷checkGrammarForNonSymbolComputedProperty</b>(node.name, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>.A_computed_property_name_in_a_type_literal_must_directly_refer_to_a_built_in_symbol);
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>checkGrammarFunctionLikeDeclaration</summary>
<pre class="code">
(node) {
            // Prevent cascading error by short-circuit
            var file = ts.🔶️<i><b title="CallWithDescriptor">getSourceFileOfNode</b></i>(node);
            return 🔶<i><b title="Did not inline: target text too big">checkGrammarDecorators</b></i>(node) || 🔶<i><b title="Did not inline: target text too big">checkGrammarModifiers</b></i>(node) || <b title="Inlined">🔷checkGrammarTypeParameterList</b>(node.typeParameters, file) ||
                🔶<i><b title="Did not inline: target text too big">checkGrammarParameterList</b></i>(node⚠️<i><b title="LoadNamedGeneric">.parameters</b></i>) || 🔶️<i><b title="CallWithDescriptor">checkGrammarArrowFunction</b></i>(node, file);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>checkGrammarTypeParameterList</summary>
<pre class="code">
(typeParameters, file) {
            if (<b title="Inlined">🔷checkGrammarForDisallowedTrailingComma</b>(typeParameters)) {
                return true;
            }
            if (typeParameters && typeParameters.length === 0) {
                var start = typeParameters⚠️<i><b title="LoadNamedGeneric">.pos</b></i> ⚠️<i><b title="Sub">- "<"</b></i>.length;
                var end = ts.🔶️<i><b title="CallWithDescriptor">skipTrivia</b></i>(file⚠️<i><b title="LoadNamedGeneric">.text</b></i>, typeParameters⚠️<i><b title="LoadNamedGeneric">.end</b></i>) ⚠️<i><b title="Add">+ ">"</b></i>.length;
                return 🔶️<i><b title="CallWithDescriptor">grammarErrorAtPos</b></i>(file, start, end - start, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Type_parameter_list_cannot_be_empty</b></i>);
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>checkGrammarForDisallowedTrailingComma</summary>
<pre class="code">
(list) {
            if (list && list.hasTrailingComma) {
                var start = list⚠️<i><b title="LoadNamedGeneric">.end</b></i> ⚠️<i><b title="Sub">- ","</b></i>.length;
                var end = list⚠️<i><b title="LoadNamedGeneric">.end</b></i>;
                var sourceFile = ts.🔶️<i><b title="CallWithDescriptor">getSourceFileOfNode</b></i>(list⚠️<i><b title="LoadKeyedGeneric">[0]</b></i>);
                return 🔶️<i><b title="CallWithDescriptor">grammarErrorAtPos</b></i>(sourceFile, start, end ⚠️<i><b title="Sub">- start</b></i>, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Trailing_comma_not_allowed</b></i>);
            }
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>checkGrammarForNonSymbolComputedProperty</summary>
<pre class="code">
(node, message) {
            if (ts.🔶<i><b title="Did not inline: unknown">isDynamicName</b></i>(node)) {
                return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(node, message);
            }
        }</pre>

</details>
<details>
<summary>checkGrammarForNonSymbolComputedProperty</summary>
<pre class="code">
(node, message) {
            if (ts.🔶<i><b title="Did not inline: unknown">isDynamicName</b></i>(node)) {
                return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(node, message);
            }
        }</pre>

</details>
<details>
<summary>checkGrammarForNonSymbolComputedProperty</summary>
<pre class="code">
(node, message) {
            if (ts.🔶<i><b title="Did not inline: unknown">isDynamicName</b></i>(node)) {
                return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(node, message);
            }
        }</pre>

</details>
</blockquote>



### checkTypeNameIsReserved:
<pre class="code">
(name, message) {
            // TS 1.0 spec (April 2014): 3.6.1
            // The predefined type keywords are reserved and cannot be used as names of user defined types.
            switch (name.text) {
                case "any":
                case "number":
                case "boolean":
                case "string":
                case "symbol":
                case "void":
                    🔶️<i><b title="CallWithDescriptor">error</b></i>(name, message, name⚠️<i><b title="LoadNamedGeneric">.text</b></i>);
            }
        }</pre>



### checkSignatureDeclaration:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(node) {
            // Grammar checking
            if (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 155 /* IndexSignature */) {
                <b title="Inlined">🔷checkGrammarIndexSignature</b>(node);
            }
            else if (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 158 /* FunctionType */ || node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 225 /* FunctionDeclaration */ || node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 159 /* ConstructorType */ ||
                node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 153 /* CallSignature */ || node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 150 /* Constructor */ ||
                node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 154 /* ConstructSignature */) {
                <b title="Inlined">🔷checkGrammarFunctionLikeDeclaration</b>(node);
            }
            if (ts.⚠️<i><b title="LoadNamedGeneric">isAsyncFunctionLike</b></i>(node) && languageVersion &lt; 4 /* ES2017 */) {
                🔶️<i><b title="CallWithDescriptor">checkExternalEmitHelpers</b></i>(node, 64 /* Awaiter */);
                if (languageVersion ⚠️<i><b title="CompareGeneric">< 2</b></i> /* ES2015 */) {
                    🔶️<i><b title="CallWithDescriptor">checkExternalEmitHelpers</b></i>(node, 128 /* Generator */);
                }
            }
            🔶<i><b title="Did not inline: target text too big">checkTypeParameters</b></i>(node⚠️<i><b title="LoadNamedGeneric">.typeParameters</b></i>);
            ts.🔶<i><b title="Did not inline: unknown">forEach</b></i>(node⚠️<i><b title="LoadNamedGeneric">.parameters</b></i>, checkParameter);
            if (node⚠️<i><b title="LoadNamedGeneric">.type</b></i>) {
                🔶<i><b title="Did not inline: target text too big">checkSourceElement</b></i>(node⚠️<i><b title="LoadNamedGeneric">.type</b></i>);
            }
            if (produceDiagnostics) {
                <b title="Inlined">🔷checkCollisionWithArgumentsInGeneratedCode</b>(node);
                if (compilerOptions.noImplicitAny && !node⚠️<i><b title="LoadNamedGeneric">.type</b></i>) {
                    ⚠️<i><b title="CompareGeneric">switch</b></i> (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i>) {
                        case 154 /* ConstructSignature */:
                            🔶️<i><b title="CallWithDescriptor">error</b></i>(node, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Construct_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type</b></i>);
                            break;
                        case 153 /* CallSignature */:
                            🔶️<i><b title="CallWithDescriptor">error</b></i>(node, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Call_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type</b></i>);
                            break;
                    }
                }
                if (node⚠️<i><b title="LoadNamedGeneric">.type</b></i>) {
                    if (languageVersion &gt;= 2 /* ES2015 */ && 🔶️<i><b title="CallWithDescriptor">isSyntacticallyValidGenerator</b></i>(node)) {
                        var returnType = 🔶<i><b title="Did not inline: target text too big">getTypeFromTypeNode</b></i>(node⚠️<i><b title="LoadNamedGeneric">.type</b></i>);
                        if (returnType ⚠️<i><b title="CompareGeneric">=== voidType</b></i>) {
                            🔶️<i><b title="CallWithDescriptor">error</b></i>(node⚠️<i><b title="LoadNamedGeneric">.type</b></i>, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.A_generator_cannot_have_a_void_type_annotation</b></i>);
                        }
                        else {
                            var generatorElementType = 🔶️<i><b title="CallWithDescriptor">getElementTypeOfIterableIterator</b></i>(returnType) || anyType;
                            var iterableIteratorInstantiation = 🔶️<i><b title="CallWithDescriptor">createIterableIteratorType</b></i>(generatorElementType);
                            // Naively, one could check that IterableIterator&lt;any&gt; is assignable to the return type annotation.
                            // However, that would not catch the error in the following case.
                            //
                            //    interface BadGenerator extends Iterable&lt;number&gt;, Iterator&lt;string&gt; { }
                            //    function* g(): BadGenerator { } // Iterable and Iterator have different types!
                            //
                            🔶<i><b title="Did not inline: unknown">checkTypeAssignableTo</b></i>(iterableIteratorInstantiation, returnType, node⚠️<i><b title="LoadNamedGeneric">.type</b></i>);
                        }
                    }
                    else if (ts.🔶<i><b title="Did not inline: unknown">isAsyncFunctionLike</b></i>(node)) {
                        🔶️<i><b title="CallWithDescriptor">checkAsyncFunctionReturnType</b></i>(node);
                    }
                }
                if (noUnusedIdentifiers && !node⚠️<i><b title="LoadNamedGeneric">.body</b></i>) {
                    🔶️<i><b title="CallWithDescriptor">checkUnusedTypeParameters</b></i>(node);
                }
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>checkGrammarIndexSignature</summary>
<pre class="code">
(node) {
            // Prevent cascading error by short-circuit
            return 🔶<i><b title="Did not inline: target text too big">checkGrammarDecorators</b></i>(node) || 🔶<i><b title="Did not inline: target text too big">checkGrammarModifiers</b></i>(node) || 🔶️<i><b title="CallWithDescriptor">checkGrammarIndexSignatureParameters</b></i>(node);
        }</pre>

</details>
<details>
<summary>checkGrammarFunctionLikeDeclaration</summary>
<pre class="code">
(node) {
            // Prevent cascading error by short-circuit
            var file = ts.🔶️<i><b title="CallWithDescriptor">getSourceFileOfNode</b></i>(node);
            return 🔶<i><b title="Did not inline: target text too big">checkGrammarDecorators</b></i>(node) || 🔶<i><b title="Did not inline: target text too big">checkGrammarModifiers</b></i>(node) || <b title="Inlined">🔷checkGrammarTypeParameterList</b>(node.typeParameters, file) ||
                🔶<i><b title="Did not inline: target text too big">checkGrammarParameterList</b></i>(node⚠️<i><b title="LoadNamedGeneric">.parameters</b></i>) || 🔶️<i><b title="CallWithDescriptor">checkGrammarArrowFunction</b></i>(node, file);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>checkGrammarTypeParameterList</summary>
<pre class="code">
(typeParameters, file) {
            if (<b title="Inlined">🔷checkGrammarForDisallowedTrailingComma</b>(typeParameters)) {
                return true;
            }
            if (typeParameters && typeParameters.length === 0) {
                var start = typeParameters⚠️<i><b title="LoadNamedGeneric">.pos</b></i> ⚠️<i><b title="Sub">- "<"</b></i>.length;
                var end = ts.🔶️<i><b title="CallWithDescriptor">skipTrivia</b></i>(file⚠️<i><b title="LoadNamedGeneric">.text</b></i>, typeParameters⚠️<i><b title="LoadNamedGeneric">.end</b></i>) ⚠️<i><b title="Add">+ ">"</b></i>.length;
                return 🔶️<i><b title="CallWithDescriptor">grammarErrorAtPos</b></i>(file, start, end - start, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Type_parameter_list_cannot_be_empty</b></i>);
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>checkGrammarForDisallowedTrailingComma</summary>
<pre class="code">
(list) {
            if (list && list.hasTrailingComma) {
                var start = list⚠️<i><b title="LoadNamedGeneric">.end</b></i> ⚠️<i><b title="Sub">- ","</b></i>.length;
                var end = list⚠️<i><b title="LoadNamedGeneric">.end</b></i>;
                var sourceFile = ts.🔶️<i><b title="CallWithDescriptor">getSourceFileOfNode</b></i>(list⚠️<i><b title="LoadKeyedGeneric">[0]</b></i>);
                return 🔶️<i><b title="CallWithDescriptor">grammarErrorAtPos</b></i>(sourceFile, start, end ⚠️<i><b title="Sub">- start</b></i>, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Trailing_comma_not_allowed</b></i>);
            }
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>checkCollisionWithArgumentsInGeneratedCode</summary>
<pre class="code">
(node) {
            // no rest parameters \x5c declaration context \x5c overload - no codegen impact
            if🔶️<i><b title="CallWithDescriptor"> (!ts</b></i>.hasDeclaredRestParameter(node) 🔶️<i><b title="CallWithDescriptor">|| ts</b></i>.isInAmbientContext(node) 🔶️<i><b title="CallWithDescriptor">|| ts</b></i>.nodeIsMissin⚠️<i><b title="LoadNamedGeneric">g</b></i>(node.body)) {
                return;
            }
         🔶️<i><b title="CallWithDescriptor">   ts</b></i>.forEac⚠️<i><b title="LoadNamedGeneric">h</b></i>(node.parame🔶️<i><b title="CallWithDescriptor">ters</b></i>, function (p) {
                if (p.name && !ts.isBindingPattern(p.name) && p.name.text === argumentsSymbol.name) {
                    error(p, ts.Diagnostics.Duplicate_identifier_arguments_Compiler_uses_arguments_to_initialize_rest_parameters);
                }
            });
        }</pre>

</details>
</blockquote>



### checkTypeReferenceNode:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(node) {
            <b title="Inlined">🔷checkGrammarTypeArguments</b>(node, node.typeArguments);
            var type = getTypeFromTypeReference(node);
            if (type !== unknownType) {
                if (node.typeArguments) {
                    // Do type argument local checks only if referenced type is successfully resolved
                    ts.🔶<i><b title="Did not inline: unknown">forEach</b></i>(node.typeArguments, checkSourceElement);
                    if (produceDiagnostics) {
                        var symbol = <b title="Inlined">🔷getNodeLinks</b>(node).resolvedSymbol;
                        var typeParameters = symbol.flags & 524288 /* TypeAlias */ ? <b title="Inlined">🔷getSymbolLinks</b>(symbol)⚠️<i><b title="LoadNamedGeneric">.typeParameters</b></i> : type.target.localTypeParameters;
                        🔶️<i><b title="CallWithDescriptor">checkTypeArgumentConstraints</b></i>(typeParameters, node.typeArguments);
                    }
                }
                if (type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 16 /* Enum */ && !type⚠️<i><b title="LoadNamedGeneric">.memberTypes</b></i> && 🔶<i><b title="Did not inline: unknown">getNodeLinks</b></i>(node)⚠️<i><b title="LoadNamedGeneric">.resolvedSymbol</b></i>⚠️<i><b title="LoadNamedGeneric">.flags</b></i> ⚠️<i><b title="Bitwise">& 8</b></i> /* EnumMember */) {
                    🔶️<i><b title="CallWithDescriptor">error</b></i>(node, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Enum_type_0_has_members_with_initializers_that_are_not_literals</b></i>, 🔶️<i><b title="CallWithDescriptor">typeToString</b></i>(type));
                }
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>checkGrammarTypeArguments</summary>
<pre class="code">
(node, typeArguments) {
            return <b title="Inlined">🔷checkGrammarForDisallowedTrailingComma</b>(typeArguments) ||
                <b title="Inlined">🔷checkGrammarForAtLeastOneTypeArgument</b>(node, typeArguments);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>checkGrammarForDisallowedTrailingComma</summary>
<pre class="code">
(list) {
            if (list && list.hasTrailingComma) {
                var start = list⚠️<i><b title="LoadNamedGeneric">.end</b></i> ⚠️<i><b title="Sub">- ","</b></i>.length;
                var end = list⚠️<i><b title="LoadNamedGeneric">.end</b></i>;
                var sourceFile = ts.🔶️<i><b title="CallWithDescriptor">getSourceFileOfNode</b></i>(list⚠️<i><b title="LoadKeyedGeneric">[0]</b></i>);
                return 🔶️<i><b title="CallWithDescriptor">grammarErrorAtPos</b></i>(sourceFile, start, end ⚠️<i><b title="Sub">- start</b></i>, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Trailing_comma_not_allowed</b></i>);
            }
        }</pre>

</details>
<details>
<summary>checkGrammarForAtLeastOneTypeArgument</summary>
<pre class="code">
(node, typeArguments) {
            if (typeArguments && typeArguments.length === 0) {
                var sourceFile = ts.🔶️<i><b title="CallWithDescriptor">getSourceFileOfNode</b></i>(node);
                var start = typeArguments⚠️<i><b title="LoadNamedGeneric">.pos</b></i> ⚠️<i><b title="Sub">- "<"</b></i>.length;
                var end = ts.🔶️<i><b title="CallWithDescriptor">skipTrivia</b></i>(sourceFile⚠️<i><b title="LoadNamedGeneric">.text</b></i>, typeArguments⚠️<i><b title="LoadNamedGeneric">.end</b></i>) ⚠️<i><b title="Add">+ ">"</b></i>.length;
                return 🔶️<i><b title="CallWithDescriptor">grammarErrorAtPos</b></i>(sourceFile, start, end - start, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Type_argument_list_cannot_be_empty</b></i>);
            }
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>getNodeLinks</summary>
<pre class="code">
(node) {
            var nodeId = <b title="Inlined">🔷getNodeId</b>(node);
            return nodeLinks⚠️<i><b title="LoadKeyedGeneric">[nodeId]</b></i> || (nodeLinks[nodeId] = { flags: 0 });
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getNodeId</summary>
<pre class="code">
(node) {
        if (!node⚠️<i><b title="LoadNamedGeneric">.id</b></i>) {
            node.id ⚠️<i><b title="StoreNamedGeneric">= nextNodeId</b></i>;
            nextNodeId++;
        }
        return node⚠️<i><b title="LoadNamedGeneric">.id</b></i>;
    }</pre>

</details>
</blockquote>

</details>
<details>
<summary>getSymbolLinks</summary>
<pre class="code">
(symbol) {
            if (symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 67108864 /* Transient */)
                return symbol;
            var id = <b title="Inlined">🔷getSymbolId</b>(symbol);
            return symbolLinks⚠️<i><b title="LoadKeyedGeneric">[id]</b></i> || (symbolLinks[id] = {});
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getSymbolId</summary>
<pre class="code">
(symbol) {
        if (!symbol⚠️<i><b title="LoadNamedGeneric">.id</b></i>) {
            symbol.id ⚠️<i><b title="StoreNamedGeneric">= nextSymbolId</b></i>;
            nextSymbolId++;
        }
        return symbol⚠️<i><b title="LoadNamedGeneric">.id</b></i>;
    }</pre>

</details>
</blockquote>

</details>
</blockquote>



### getIndexTypeOfType:
<pre class="code">
(type, kind) {
            return <b title="Inlined">🔷getIndexTypeOfStructuredType</b>(<b title="Inlined">🔷getApparentType</b>(type), kind);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getApparentType</summary>
<pre class="code">
(type) {
            var t = type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 540672 /* TypeVariable */ ? 🔶️<i><b title="CallWithDescriptor">getApparentTypeOfTypeVariable</b></i>(type) : type;
            return t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 262178 /* StringLike */ ? globalStringType :
                t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 340 /* NumberLike */ ? globalNumberType :
                    t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 136 /* BooleanLike */ ? globalBooleanType :
                        t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 512 /* ESSymbol */ ? 🔶️<i><b title="CallWithDescriptor">getGlobalESSymbolType</b></i>() :
                            t;
        }</pre>

</details>
<details>
<summary>getIndexTypeOfStructuredType</summary>
<pre class="code">
(type, kind) {
            var info = <b title="Inlined">🔷getIndexInfoOfStructuredType</b>(type, kind);
            return info && info.type;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getIndexInfoOfStructuredType</summary>
<pre class="code">
(type, kind) {
            if (type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 229376 /* StructuredType */) {
                var resolved = 🔶<i><b title="Did not inline: target text too big">resolveStructuredTypeMembers</b></i>(type);
                return kind === 0 /* String */ ? resolved⚠️<i><b title="LoadNamedGeneric">.stringIndexInfo</b></i> : resolved⚠️<i><b title="LoadNamedGeneric">.numberIndexInfo</b></i>;
            }
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### getTypeFromClassOrInterfaceReference:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(node, symbol) {
            var type = getDeclaredTypeOfSymbol(<b title="Inlined">🔷getMergedSymbol</b>(symbol));
            var typeParameters = type⚠️<i><b title="LoadNamedGeneric">.localTypeParameters</b></i>;
            if (typeParameters) {
                if (!node.typeArguments || node.typeArguments.length !== typeParameters.length) {
                    🔶️<i><b title="CallWithDescriptor">error</b></i>(node, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Generic_type_0_requires_1_type_argument_s</b></i>, 🔶️<i><b title="CallWithDescriptor">typeToString</b></i>(type, /*enclosingDeclaration*/ undefined, 1 /* WriteArrayAsGenericType */), typeParameters⚠️<i><b title="LoadNamedGeneric">.length</b></i>);
                    return unknownType;
                }
                // In a type reference, the outer type parameters of the referenced class or interface are automatically
                // supplied as type arguments and the type reference only specifies arguments for the local type parameters
                // of the class or interface.
                return <b title="Inlined">🔷createTypeReference</b>(type, ts.⚠️<i><b title="LoadNamedGeneric">concatenate</b></i>(type.outerTypeParameters, ts.🔶<i><b title="Did not inline: unknown">map</b></i>(node.typeArguments, getTypeFromTypeNode)));
            }
            if (node.typeArguments) {
                🔶️<i><b title="CallWithDescriptor">error</b></i>(node, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Type_0_is_not_generic</b></i>, 🔶️<i><b title="CallWithDescriptor">typeToString</b></i>(type));
                return unknownType;
            }
            return type;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getMergedSymbol</summary>
<pre class="code">
(symbol) {
            var merged;
            return symbol && symbol⚠️<i><b title="LoadNamedGeneric">.mergeId</b></i> && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }</pre>

</details>
<details>
<summary>createTypeReference</summary>
<pre class="code">
(target, typeArguments) {
            var id = 🔶<i><b title="Did not inline: target text too big">getTypeListId</b></i>(typeArguments);
            var type = target⚠️<i><b title="LoadNamedGeneric">.instantiations</b></i>⚠️<i><b title="LoadKeyedGeneric">[id]</b></i>;
            if (!type) {
                type = target⚠️<i><b title="LoadNamedGeneric">.instantiations</b></i>[id] ⚠️<i><b title="StoreKeyedGeneric">= createObjectType</b></i>(4 /* Reference */, target⚠️<i><b title="LoadNamedGeneric">.symbol</b></i>);
                type.flags |= typeArguments ? <b title="Inlined">🔷getPropagatingFlagsOfTypes</b>(typeArguments, /*excludeKinds*/ 0) : 0;
                type.target = target;
                type.typeArguments = typeArguments;
            }
            return type;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createObjectType</summary>
<pre class="code">
(objectFlags, symbol) {
            var type = <b title="Inlined">🔷createType</b>(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol ⚠️<i><b title="StoreNamedGeneric">= symbol</b></i>;
            return type;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createType</summary>
<pre class="code">
(flags) {
            var result = <b title="Inlined">🔷new Type</b>(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new Type</summary>
<pre class="code">
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>getPropagatingFlagsOfTypes</summary>
<pre class="code">
(types, excludeKinds) {
            var result = 0;
            for (var _i = 0, types_3 = types; _i &lt; types_3⚠️<i><b title="LoadNamedGeneric">.length</b></i>; _i++) {
                var type = types_3⚠️<i><b title="LoadKeyedGeneric">[_i]</b></i>;
                if (!(type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & excludeKinds)) {
                    result |= type⚠️<i><b title="LoadNamedGeneric">.flags</b></i>;
                }
            }
            return result & 14680064 /* PropagatingFlags */;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### getTypeWithThisArgument:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(type, thisArgument) {
            if (<b title="Inlined">🔷getObjectFlags</b>(type) & 4 /* Reference */) {
                return <b title="Inlined">🔷createTypeReference</b>(type⚠️<i><b title="LoadNamedGeneric">.target</b></i>, ts.⚠️<i><b title="LoadNamedGeneric">concatenate</b></i>(type⚠️<i><b title="LoadNamedGeneric">.typeArguments</b></i>, [thisArgument || type.target.thisType]));
            }
            return type;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getObjectFlags</summary>
<pre class="code">
(type) {
            return type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 32768 /* Object */ ? type⚠️<i><b title="LoadNamedGeneric">.objectFlags</b></i> : 0;
        }</pre>

</details>
<details>
<summary>createTypeReference</summary>
<pre class="code">
(target, typeArguments) {
            var id = 🔶<i><b title="Did not inline: target text too big">getTypeListId</b></i>(typeArguments);
            var type = target⚠️<i><b title="LoadNamedGeneric">.instantiations</b></i>⚠️<i><b title="LoadKeyedGeneric">[id]</b></i>;
            if (!type) {
                type = target⚠️<i><b title="LoadNamedGeneric">.instantiations</b></i>[id] ⚠️<i><b title="StoreKeyedGeneric">= createObjectType</b></i>(4 /* Reference */, target⚠️<i><b title="LoadNamedGeneric">.symbol</b></i>);
                type.flags |= typeArguments ? <b title="Inlined">🔷getPropagatingFlagsOfTypes</b>(typeArguments, /*excludeKinds*/ 0) : 0;
                type.target = target;
                type.typeArguments = typeArguments;
            }
            return type;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createObjectType</summary>
<pre class="code">
(objectFlags, symbol) {
            var type = <b title="Inlined">🔷createType</b>(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol ⚠️<i><b title="StoreNamedGeneric">= symbol</b></i>;
            return type;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createType</summary>
<pre class="code">
(flags) {
            var result = <b title="Inlined">🔷new Type</b>(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new Type</summary>
<pre class="code">
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>getPropagatingFlagsOfTypes</summary>
<pre class="code">
(types, excludeKinds) {
            var result = 0;
            for (var _i = 0, types_3 = types; _i &lt; types_3⚠️<i><b title="LoadNamedGeneric">.length</b></i>; _i++) {
                var type = types_3⚠️<i><b title="LoadKeyedGeneric">[_i]</b></i>;
                if (!(type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & excludeKinds)) {
                    result |= type⚠️<i><b title="LoadNamedGeneric">.flags</b></i>;
                }
            }
            return result & 14680064 /* PropagatingFlags */;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### getSignaturesOfType:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(type, kind) {
            return <b title="Inlined">🔷getSignaturesOfStructuredType</b>(<b title="Inlined">🔷getApparentType</b>(type), kind);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getApparentType</summary>
<pre class="code">
(type) {
            var t = type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 540672 /* TypeVariable */ ? 🔶️<i><b title="CallWithDescriptor">getApparentTypeOfTypeVariable</b></i>(type) : type;
            return t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 262178 /* StringLike */ ? globalStringType :
                t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 340 /* NumberLike */ ? globalNumberType :
                    t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 136 /* BooleanLike */ ? globalBooleanType :
                        t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 512 /* ESSymbol */ ? 🔶️<i><b title="CallWithDescriptor">getGlobalESSymbolType</b></i>() :
                            t;
        }</pre>

</details>
<details>
<summary>getSignaturesOfStructuredType</summary>
<pre class="code">
(type, kind) {
            if (type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 229376 /* StructuredType */) {
                var resolved = 🔶<i><b title="Did not inline: target text too big">resolveStructuredTypeMembers</b></i>(type);
                return kind === 0 /* Call */ ? resolved⚠️<i><b title="LoadNamedGeneric">.callSignatures</b></i> : resolved⚠️<i><b title="LoadNamedGeneric">.constructSignatures</b></i>;
            }
            return emptyArray;
        }</pre>

</details>
</blockquote>



### resolveStructuredTypeMembers:
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(type) {
            if (!type⚠️<i><b title="LoadNamedGeneric">.members</b></i>) {
                if (type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 32768 /* Object */) {
                    if (type⚠️<i><b title="LoadNamedGeneric">.objectFlags</b></i> & 4 /* Reference */) {
                        <b title="Inlined">🔷resolveTypeReferenceMembers</b>(type);
                    }
                    else if (type⚠️<i><b title="LoadNamedGeneric">.objectFlags</b></i> & 3 /* ClassOrInterface */) {
                        <b title="Inlined">🔷resolveClassOrInterfaceMembers</b>(type);
                    }
                    else if (type.objectFlags & 16 /* Anonymous */) {
                        🔶<i><b title="Did not inline: target text too big">resolveAnonymousTypeMembers</b></i>(type);
                    }
                    else if (type⚠️<i><b title="LoadNamedGeneric">.objectFlags</b></i> ⚠️<i><b title="Bitwise">& 32</b></i> /* Mapped */) {
                        🔶️<i><b title="CallWithDescriptor">resolveMappedTypeMembers</b></i>(type);
                    }
                }
                else if (type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> ⚠️<i><b title="Bitwise">& 65536</b></i> /* Union */) {
                    🔶️<i><b title="CallWithDescriptor">resolveUnionTypeMembers</b></i>(type);
                }
                else if (type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> ⚠️<i><b title="Bitwise">& 131072</b></i> /* Intersection */) {
                    🔶️<i><b title="CallWithDescriptor">resolveIntersectionTypeMembers</b></i>(type);
                }
            }
            return type;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>resolveTypeReferenceMembers</summary>
<pre class="code">
(type) {
            var source = <b title="Inlined">🔷resolveDeclaredMembers</b>(type.target);
            var typeParameters = ts.🔶<i><b title="Did not inline: unknown">concatenate</b></i>(source⚠️<i><b title="LoadNamedGeneric">.typeParameters</b></i>, [source⚠️<i><b title="LoadNamedGeneric">.thisType]</b></i>);
            var typeArguments = type⚠️<i><b title="LoadNamedGeneric">.typeArguments</b></i> && type.typeArguments.length === typeParameters.length ?
                type.typeArguments : ts.🔶<i><b title="Did not inline: unknown">concatenate</b></i>(type⚠️<i><b title="LoadNamedGeneric">.typeArguments</b></i>, [type]);
            🔶️<i><b title="CallWithDescriptor">resolveObjectTypeMembers</b></i>(type, source, typeParameters, typeArguments);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>resolveDeclaredMembers</summary>
<pre class="code">
(type) {
            if (!type⚠️<i><b title="LoadNamedGeneric">.declaredProperties</b></i>) {
                var symbol = type.symbol;
                type.declaredProperties ⚠️<i><b title="StoreNamedGeneric">= getNamedMembers</b></i>(symbol.members);
                type.declaredCallSignatures ⚠️<i><b title="StoreNamedGeneric">= getSignaturesOfSymbol</b></i>(symbol⚠️<i><b title="LoadNamedGeneric">.members</b></i>⚠️<i><b title="LoadNamedGeneric">["__c</b></i>all"]);
                type.declaredConstructSignatures ⚠️<i><b title="StoreNamedGeneric">= getSignaturesOfSymbol</b></i>(symbol⚠️<i><b title="LoadNamedGeneric">.members</b></i>⚠️<i><b title="LoadNamedGeneric">["__n</b></i>ew"]);
                type.declaredStringIndexInfo ⚠️<i><b title="StoreNamedGeneric">= getIndexInfoOfSymbol</b></i>(symbol, 0 /* String */);
                type.declaredNumberIndexInfo ⚠️<i><b title="StoreNamedGeneric">= getIndexInfoOfSymbol</b></i>(symbol, 1 /* Number */);
            }
            return type;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getNamedMembers</summary>
<pre class="code">
(members) {
            var result;
            🔶️<i><b title="CallWithDescriptor">for</b></i> (var id in members) {
                if (!<b title="Inlined">🔷isReservedMemberName</b>(id)) {
                    if (!result)
                        result = [];
                    var symbol = members⚠️<i><b title="LoadKeyedGeneric">[id]</b></i>;
                    if (🔶<i><b title="Did not inline: target text too big">symbolIsValue</b></i>(symbol)) {
                        result.push(symbol);
                    }
                }
            }
            return result || emptyArray;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>isReservedMemberName</summary>
<pre class="code">
(name) {
            return name.charCodeAt(0) === 95 /* _ */ &&
                name.charCodeAt(1) === 95 /* _ */ &&
                name.charCodeAt(2) !== 95 /* _ */ &&
                name.charCodeAt(2) !== 64 /* at */;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>getIndexInfoOfSymbol</summary>
<pre class="code">
(symbol, kind) {
            var declaration = getIndexDeclarationOfSymbol(symbol, kind);
            if (declaration) {
                return <b title="Inlined">🔷createIndexInfo</b>(declaration.type ? 🔶<i><b title="Did not inline: target text too big">getTypeFromTypeNode</b></i>(declaration.type) : anyType, (ts.🔶<i><b title="Did not inline: target text too big">getModifierFlags</b></i>(declaration) & 64 /* Readonly */) !== 0, declaration);
            }
            return undefined;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createIndexInfo</summary>
<pre class="code">
(type, isReadonly, declaration) {
            return { type: type, isReadonly: isReadonly, declaration: declaration };
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>getIndexInfoOfSymbol</summary>
<pre class="code">
(symbol, kind) {
            var declaration = getIndexDeclarationOfSymbol(symbol, kind);
            if (declaration) {
                return <b title="Inlined">🔷createIndexInfo</b>(declaration.type ? 🔶<i><b title="Did not inline: target text too big">getTypeFromTypeNode</b></i>(declaration.type) : anyType, (ts.🔶<i><b title="Did not inline: target text too big">getModifierFlags</b></i>(declaration) & 64 /* Readonly */) !== 0, declaration);
            }
            return undefined;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createIndexInfo</summary>
<pre class="code">
(type, isReadonly, declaration) {
            return { type: type, isReadonly: isReadonly, declaration: declaration };
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>resolveClassOrInterfaceMembers</summary>
<pre class="code">
(type) {
            🔶️<i><b title="CallWithDescriptor">resolveObjectTypeMembers</b></i>(type, <b title="Inlined">🔷resolveDeclaredMembers</b>(type), emptyArray, emptyArray);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>resolveDeclaredMembers</summary>
<pre class="code">
(type) {
            if (!type⚠️<i><b title="LoadNamedGeneric">.declaredProperties</b></i>) {
                var symbol = type⚠️<i><b title="LoadNamedGeneric">.symbol</b></i>;
                type.declaredProperties ⚠️<i><b title="StoreNamedGeneric">= getNamedMembers</b></i>(symbol.members);
                type.declaredCallSignatures ⚠️<i><b title="StoreNamedGeneric">= getSignaturesOfSymbol</b></i>(symbol⚠️<i><b title="LoadNamedGeneric">.members</b></i>⚠️<i><b title="LoadNamedGeneric">["__c</b></i>all"]);
                type.declaredConstructSignatures ⚠️<i><b title="StoreNamedGeneric">= getSignaturesOfSymbol</b></i>(symbol⚠️<i><b title="LoadNamedGeneric">.members</b></i>⚠️<i><b title="LoadNamedGeneric">["__n</b></i>ew"]);
                type.declaredStringIndexInfo ⚠️<i><b title="StoreNamedGeneric">= getIndexInfoOfSymbol</b></i>(symbol, 0 /* String */);
                type.declaredNumberIndexInfo ⚠️<i><b title="StoreNamedGeneric">= getIndexInfoOfSymbol</b></i>(symbol, 1 /* Number */);
            }
            return type;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getNamedMembers</summary>
<pre class="code">
(members) {
            var result;
            🔶️<i><b title="CallWithDescriptor">for</b></i> (var id in members) {
                if (!<b title="Inlined">🔷isReservedMemberName</b>(id)) {
                    if (!result)
                        result = [];
                    var symbol = members⚠️<i><b title="LoadKeyedGeneric">[id]</b></i>;
                    if (🔶<i><b title="Did not inline: target text too big">symbolIsValue</b></i>(symbol)) {
                        result.push(symbol);
                    }
                }
            }
            return result || emptyArray;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>isReservedMemberName</summary>
<pre class="code">
(name) {
            return name.charCodeAt(0) === 95 /* _ */ &&
                name.charCodeAt(1) === 95 /* _ */ &&
                name.charCodeAt(2) !== 95 /* _ */ &&
                name.charCodeAt(2) !== 64 /* at */;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>



### getBaseTypes:
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(type) {
            if (!type⚠️<i><b title="LoadNamedGeneric">.resolvedBaseTypes</b></i>) {
                if (type.objectFlags & 8 /* Tuple */) {
                    type.resolvedBaseTypes ⚠️<i><b title="StoreNamedGeneric">= [createArrayType</b></i>(🔶<i><b title="Did not inline: target text too big">getUnionType</b></i>(type⚠️<i><b title="LoadNamedGeneric">.typeParameters</b></i>))];
                }
                else if (type.symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & (32 /* Class */ | 64 /* Interface */)) {
                    if (type.symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 32 /* Class */) {
                        🔶️<i><b title="CallWithDescriptor">resolveBaseTypesOfClass</b></i>(type);
                    }
                    if (type⚠️<i><b title="LoadNamedGeneric">.symbol</b></i>⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 64 /* Interface */) {
                        🔶<i><b title="Did not inline: target text too big">resolveBaseTypesOfInterface</b></i>(type);
                    }
                }
                else {
                    ts⚠️<i><b title="LoadNamedGeneric">.Debug</b></i>.⚠️<i><b title="LoadNamedGeneric">fail</b></i>("type must be class or interface");
                }
            }
            return type⚠️<i><b title="LoadNamedGeneric">.resolvedBaseTypes</b></i>;
        }</pre>



### getIndexInfoOfType:
<pre class="code">
(type, kind) {
            return <b title="Inlined">🔷getIndexInfoOfStructuredType</b>(<b title="Inlined">🔷getApparentType</b>(type), kind);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getApparentType</summary>
<pre class="code">
(type) {
            var t = type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 540672 /* TypeVariable */ ? 🔶️<i><b title="CallWithDescriptor">getApparentTypeOfTypeVariable</b></i>(type) : type;
            return t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 262178 /* StringLike */ ? globalStringType :
                t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 340 /* NumberLike */ ? globalNumberType :
                    t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 136 /* BooleanLike */ ? globalBooleanType :
                        t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 512 /* ESSymbol */ ? 🔶️<i><b title="CallWithDescriptor">getGlobalESSymbolType</b></i>() :
                            t;
        }</pre>

</details>
<details>
<summary>getIndexInfoOfStructuredType</summary>
<pre class="code">
(type, kind) {
            if (type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 229376 /* StructuredType */) {
                var resolved = 🔶<i><b title="Did not inline: target text too big">resolveStructuredTypeMembers</b></i>(type);
                return kind === 0 /* String */ ? resolved⚠️<i><b title="LoadNamedGeneric">.stringIndexInfo</b></i> : resolved⚠️<i><b title="LoadNamedGeneric">.numberIndexInfo</b></i>;
            }
        }</pre>

</details>
</blockquote>



### getIndexInfoOfSymbol:
<pre class="code">
(symbol, kind) {
            var declaration = getIndexDeclarationOfSymbol(symbol, kind);
            if (declaration) {
                return <b title="Inlined">🔷createIndexInfo</b>(declaration.type ? 🔶<i><b title="Did not inline: target text too big">getTypeFromTypeNode</b></i>(declaration.type) : anyType, (ts.🔶<i><b title="Did not inline: target text too big">getModifierFlags</b></i>(declaration) & 64 /* Readonly */) !== 0, declaration);
            }
            return undefined;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createIndexInfo</summary>
<pre class="code">
(type, isReadonly, declaration) {
            return { type: type, isReadonly: isReadonly, declaration: declaration };
        }</pre>

</details>
</blockquote>



### checkGrammarProperty:
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(node) {
            if (ts.🔶<i><b title="Did not inline: unknown">isClassLike</b></i>(node.parent)) {
                if (<b title="Inlined">🔷checkGrammarForNonSymbolComputedProperty</b>(node.name, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>.A_computed_property_name_in_a_class_property_declaration_must_directly_refer_to_a_built_in_symbol)) {
                    return true;
                }
            }
            else if (node.parent⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 227 /* InterfaceDeclaration */) {
                if (<b title="Inlined">🔷checkGrammarForNonSymbolComputedProperty</b>(node.name, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>.A_computed_property_name_in_an_interface_must_directly_refer_to_a_built_in_symbol)) {
                    return true;
                }
                if (node.initializer) {
                    return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(node⚠️<i><b title="LoadNamedGeneric">.initializer</b></i>, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.An_interface_property_cannot_have_an_initializer</b></i>);
                }
            }
            else if (node.parent.kind === 161 /* TypeLiteral */) {
                if (<b title="Inlined">🔷checkGrammarForNonSymbolComputedProperty</b>(node.name, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>.A_computed_property_name_in_a_type_literal_must_directly_refer_to_a_built_in_symbol)) {
                    return true;
                }
                if (node.initializer) {
                    return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(node⚠️<i><b title="LoadNamedGeneric">.initializer</b></i>, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.A_type_literal_property_cannot_have_an_initializer</b></i>);
                }
            }
            if (ts.🔶<i><b title="Did not inline: unknown">isInAmbientContext</b></i>(node) && node.initializer) {
                return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnFirstToken</b></i>(node⚠️<i><b title="LoadNamedGeneric">.initializer</b></i>, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Initializers_are_not_allowed_in_ambient_contexts</b></i>);
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>checkGrammarForNonSymbolComputedProperty</summary>
<pre class="code">
(node, message) {
            if (ts.🔶<i><b title="Did not inline: unknown">isDynamicName</b></i>(node)) {
                return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(node, message);
            }
        }</pre>

</details>
<details>
<summary>checkGrammarForNonSymbolComputedProperty</summary>
<pre class="code">
(node, message) {
            if (ts.🔶<i><b title="Did not inline: unknown">isDynamicName</b></i>(node)) {
                return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(node, message);
            }
        }</pre>

</details>
<details>
<summary>checkGrammarForNonSymbolComputedProperty</summary>
<pre class="code">
(node, message) {
            if (ts.🔶<i><b title="Did not inline: unknown">isDynamicName</b></i>(node)) {
                return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(node, message);
            }
        }</pre>

</details>
</blockquote>



### ⛔ isEntityNameExpression (deoptimizated):
<div>~recompile~</div>

```diff
- Deopt: <JS Function resolveStructuredTypeMembers (SharedFunctionInfo 0x2e2f693efe11)> (opt #378) @65, FP to SP delta: 248, caller sp: 0x7fff5fbfdc28
```

```diff
- Deopt: <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> (opt #348) @17, FP to SP delta: 176, caller sp: 0x7fff5fbfe098
```

<div>~recompile~</div>
<pre class="code">
(node) {
        return node.kind === 70 /* Identifier */ ||
            node.kind === 177 /* PropertyAccessExpression */ && 🔶<i><b title="Did not inline: unknown">isEntityNameExpression</b></i>(node.expression);
    }</pre>



### getTargetType:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(type) {
            return <b title="Inlined">🔷getObjectFlags</b>(type) & 4 /* Reference */ ? type⚠️<i><b title="LoadNamedGeneric">.target</b></i> : type;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getObjectFlags</summary>
<pre class="code">
(type) {
            return type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 32768 /* Object */ ? type⚠️<i><b title="LoadNamedGeneric">.objectFlags</b></i> : 0;
        }</pre>

</details>
</blockquote>



### getPropertyOfType:
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(type, name) {
            type = <b title="Inlined">🔷getApparentType</b>(type);
            if (type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 32768 /* Object */) {
                var resolved = resolveStructuredTypeMembers(type);
                var symbol = resolved⚠️<i><b title="LoadNamedGeneric">.members</b></i>⚠️<i><b title="LoadKeyedGeneric">[name]</b></i>;
                if (symbol && 🔶<i><b title="Did not inline: target text too big">symbolIsValue</b></i>(symbol)) {
                    return symbol;
                }
                if (resolved === anyFunctionType || resolved⚠️<i><b title="LoadNamedGeneric">.callSignatures</b></i>.length || resolved.constructSignatures.length) {
                    var symbol_1 = <b title="Inlined">🔷getPropertyOfObjectType</b>(globalFunctionType, name);
                    if (symbol_1) {
                        return symbol_1;
                    }
                }
                return <b title="Inlined">🔷getPropertyOfObjectType</b>(globalObjectType, name);
            }
            if (type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> ⚠️<i><b title="Bitwise">& 196608</b></i> /* UnionOrIntersection */) {
                return 🔶️<i><b title="CallWithDescriptor">getPropertyOfUnionOrIntersectionType</b></i>(type, name);
            }
            return undefined;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getApparentType</summary>
<pre class="code">
(type) {
            var t = type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 540672 /* TypeVariable */ ? 🔶️<i><b title="CallWithDescriptor">getApparentTypeOfTypeVariable</b></i>(type) : type;
            return t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 262178 /* StringLike */ ? globalStringType :
                t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 340 /* NumberLike */ ? globalNumberType :
                    t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 136 /* BooleanLike */ ? globalBooleanType :
                        t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 512 /* ESSymbol */ ? 🔶️<i><b title="CallWithDescriptor">getGlobalESSymbolType</b></i>() :
                            t;
        }</pre>

</details>
<details>
<summary>getPropertyOfObjectType</summary>
<pre class="code">
(type, name) {
            if (type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 32768 /* Object */) {
                var resolved = resolveStructuredTypeMembers(type);
                var symbol = resolved.members⚠️<i><b title="LoadKeyedGeneric">[name]</b></i>;
                if (symbol && 🔶<i><b title="Did not inline: target text too big">symbolIsValue</b></i>(symbol)) {
                    return symbol;
                }
            }
        }</pre>

</details>
<details>
<summary>getPropertyOfObjectType</summary>
<pre class="code">
(type, name) {
            if (type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 32768 /* Object */) {
                var resolved = resolveStructuredTypeMembers(type);
                var symbol = resolved.members⚠️<i><b title="LoadKeyedGeneric">[name]</b></i>;
                if (symbol && 🔶<i><b title="Did not inline: target text too big">symbolIsValue</b></i>(symbol)) {
                    return symbol;
                }
            }
        }</pre>

</details>
</blockquote>



### ⛔ getSignaturesOfStructuredType (deoptimizated):
<pre class="code">
(type, kind) {
            if (type.flags & 229376 /* StructuredType */) {
                var resolved = resolveStructuredTypeMembers(type);
                return kind === 0 /* Call */ ? resolved.callSignatures : resolved.constructSignatures;
            }
            return emptyArray;
        }</pre>

```diff
- Deopt: <JS Function getSignaturesOfStructuredType (SharedFunctionInfo 0x2e2f693f0651)> (opt #389) @2, FP to SP delta: 24, caller sp: 0x7fff5fbfdaa8
```

```diff
- Deopt: <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)> (opt #376) @19, FP to SP delta: 320, caller sp: 0x7fff5fbfd4f8
```

```diff
- Deopt: <JS Function instantiateCached (SharedFunctionInfo 0x2e2f693f5881)> (opt #355) @6, FP to SP delta: 40, caller sp: 0x7fff5fbfd888
```

```diff
- Deopt: <JS Function instantiateAnonymousType (SharedFunctionInfo 0x2e2f693f6241)> (opt #356) @2, FP to SP delta: 48, caller sp: 0x7fff5fbfd828
```

```diff
- Deopt: <JS Function checkParameter (SharedFunctionInfo 0x1b98fbc0a201)> (opt #340) @28, FP to SP delta: 112, caller sp: 0x7fff5fbfdd18
```



### resolveDeclaredMembers:
<pre class="code">
(type) {
            if (!type.declaredProperties) {
                var symbol = type.symbol;
                type.declaredProperties ⚠️<i><b title="StoreNamedGeneric">= getNamedMembers</b></i>(symbol.members);
                type.declaredCallSignatures ⚠️<i><b title="StoreNamedGeneric">= getSignaturesOfSymbol</b></i>(symbol.members⚠️<i><b title="LoadNamedGeneric">["__c</b></i>all"]);
                type.declaredConstructSignatures = 🔶️<i><b title="CallWithDescriptor">getSignaturesOfSymbol</b></i>(symbol.members⚠️<i><b title="LoadNamedGeneric">["__n</b></i>ew"]);
                type.declaredStringIndexInfo ⚠️<i><b title="StoreNamedGeneric">= getIndexInfoOfSymbol</b></i>(symbol, 0 /* String */);
                type.declaredNumberIndexInfo ⚠️<i><b title="StoreNamedGeneric">= getIndexInfoOfSymbol</b></i>(symbol, 1 /* Number */);
            }
            return type;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getNamedMembers</summary>
<pre class="code">
(members) {
            var result;
            🔶️<i><b title="CallWithDescriptor">for</b></i> (var id in members) {
                if (!<b title="Inlined">🔷isReservedMemberName</b>(id)) {
                    if (!result)
                        result = [];
                    var symbol = members⚠️<i><b title="LoadKeyedGeneric">[id]</b></i>;
                    if (🔶<i><b title="Did not inline: target text too big">symbolIsValue</b></i>(symbol)) {
                        result.push(symbol);
                    }
                }
            }
            return result || emptyArray;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>isReservedMemberName</summary>
<pre class="code">
(name) {
            return name.charCodeAt(0) === 95 /* _ */ &&
                name.charCodeAt(1) === 95 /* _ */ &&
                name.charCodeAt(2) !== 95 /* _ */ &&
                name.charCodeAt(2) !== 64 /* at */;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>getIndexInfoOfSymbol</summary>
<pre class="code">
(symbol, kind) {
            var declaration = getIndexDeclarationOfSymbol(symbol, kind);
            if (declaration) {
                return <b title="Inlined">🔷createIndexInfo</b>(declaration.type ? 🔶<i><b title="Did not inline: target text too big">getTypeFromTypeNode</b></i>(declaration.type) : anyType, (ts.🔶<i><b title="Did not inline: target text too big">getModifierFlags</b></i>(declaration) & 64 /* Readonly */) !== 0, declaration);
            }
            return undefined;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createIndexInfo</summary>
<pre class="code">
(type, isReadonly, declaration) {
            return { type: type, isReadonly: isReadonly, declaration: declaration };
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>getIndexInfoOfSymbol</summary>
<pre class="code">
(symbol, kind) {
            var declaration = getIndexDeclarationOfSymbol(symbol, kind);
            if (declaration) {
                return <b title="Inlined">🔷createIndexInfo</b>(declaration.type ? 🔶<i><b title="Did not inline: target text too big">getTypeFromTypeNode</b></i>(declaration.type) : anyType, (ts.🔶<i><b title="Did not inline: target text too big">getModifierFlags</b></i>(declaration) & 64 /* Readonly */) !== 0, declaration);
            }
            return undefined;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createIndexInfo</summary>
<pre class="code">
(type, isReadonly, declaration) {
            return { type: type, isReadonly: isReadonly, declaration: declaration };
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### checkFunctionOrMethodDeclaration:
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(node) {
            🔶️<i><b title="CallWithDescriptor">checkDecorators</b></i>(node);
            🔶<i><b title="Did not inline: target text too big">checkSignatureDeclaration</b></i>(node);
            var isAsync = ts.🔶<i><b title="Did not inline: unknown">isAsyncFunctionLike</b></i>(node);
            // Do not use hasDynamicName here, because that returns false for well known symbols.
            // We want to perform checkComputedPropertyName for all computed properties, including
            // well known symbols.
            if (node⚠️<i><b title="LoadNamedGeneric">.name</b></i> && node⚠️<i><b title="LoadNamedGeneric">.name</b></i>.kind === 142 /* ComputedPropertyName */) {
                // This check will account for methods in class/interface declarations,
                // as well as accessors in classes/object literals
                🔶️<i><b title="CallWithDescriptor">checkComputedPropertyName</b></i>(node⚠️<i><b title="LoadNamedGeneric">.name</b></i>);
            }
            if (!ts.⚠️<i><b title="LoadNamedGeneric">hasDynamicName</b></i>(node)) {
                // first we want to check the local symbol that contain this declaration
                // - if node.localSymbol !== undefined - this is current declaration is exported and localSymbol points to the local symbol
                // - if node.localSymbol === undefined - this node is non-exported so we can just pick the result of getSymbolOfNode
                var symbol = <b title="Inlined">🔷getSymbolOfNode</b>(node);
                var localSymbol = node⚠️<i><b title="LoadNamedGeneric">.localSymbol</b></i> || symbol;
                // Since the javascript won't do semantic analysis like typescript,
                // if the javascript file comes before the typescript file and both contain same name functions,
                // checkFunctionOrConstructorSymbol wouldn't be called if we didnt ignore javascript function.
                var firstDeclaration = ts.🔶<i><b title="Did not inline: unknown">forEach</b></i>(localSymbol.declarations, 
                // Get first non javascript function declaration
                🔶️<i><b title="CallWithDescriptor">function</b></i> (declaration) { return declaration.kind === node.kind && !ts.isSourceFileJavaScript(ts.getSourceFileOfNode(declaration)) ?
                    declaration : undefined; });
                // Only type check the symbol once
                if (node === firstDeclaration) {
                    🔶<i><b title="Did not inline: target text too big">checkFunctionOrConstructorSymbol</b></i>(localSymbol);
                }
                if (symbol.parent) {
                    // run check once for the first declaration
                    if (ts.🔶<i><b title="Did not inline: unknown">getDeclarationOfKind</b></i>(symbol, node⚠️<i><b title="LoadNamedGeneric">.kind</b></i>) === node) {
                        // run check on export symbol to check that modifiers agree across all exported declarations
                        🔶<i><b title="Did not inline: target text too big">checkFunctionOrConstructorSymbol</b></i>(symbol);
                    }
                }
            }
            🔶<i><b title="Did not inline: target text too big">checkSourceElement</b></i>(node⚠️<i><b title="LoadNamedGeneric">.body</b></i>);
            if (!node⚠️<i><b title="LoadNamedGeneric">.asteriskToken</b></i>) {
                var returnOrPromisedType = node⚠️<i><b title="LoadNamedGeneric">.type</b></i> && (isAsync ? 🔶️<i><b title="CallWithDescriptor">checkAsyncFunctionReturnType</b></i>(node) : 🔶<i><b title="Did not inline: target text too big">getTypeFromTypeNode</b></i>(node⚠️<i><b title="LoadNamedGeneric">.type</b></i>));
                🔶️<i><b title="CallWithDescriptor">checkAllCodePathsInNonVoidFunctionReturnOrThrow</b></i>(node, returnOrPromisedType);
            }
            if (produceDiagnostics && !node⚠️<i><b title="LoadNamedGeneric">.type</b></i>) {
                // Report an implicit any error if there is no body, no explicit return type, and node is not a private method
                // in an ambient context
                if (compilerOptions⚠️<i><b title="LoadNamedGeneric">.noImplicitAny</b></i> && ts.🔶<i><b title="Did not inline: unknown">nodeIsMissing</b></i>(node⚠️<i><b title="LoadNamedGeneric">.body</b></i>) && !🔶️<i><b title="CallWithDescriptor">isPrivateWithinAmbient</b></i>(node)) {
                    🔶️<i><b title="CallWithDescriptor">reportImplicitAnyError</b></i>(node, anyType);
                }
                if (node⚠️<i><b title="LoadNamedGeneric">.asteriskToken</b></i> && ts.🔶<i><b title="Did not inline: unknown">nodeIsPresent</b></i>(node⚠️<i><b title="LoadNamedGeneric">.body</b></i>)) {
                    // A generator with a body and no type annotation can still cause errors. It can error if the
                    // yielded values have no common supertype, or it can give an implicit any error if it has no
                    // yielded values. The only way to trigger these errors is to try checking its return type.
                    🔶️<i><b title="CallWithDescriptor">getReturnTypeOfSignature</b></i>(🔶<i><b title="Did not inline: unknown">getSignatureFromDeclaration</b></i>(node));
                }
            }
            <b title="Inlined">🔷registerForUnusedIdentifiersCheck</b>(node);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getSymbolOfNode</summary>
<pre class="code">
(node) {
            return <b title="Inlined">🔷getMergedSymbol</b>(node.symbol);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getMergedSymbol</summary>
<pre class="code">
(symbol) {
            var merged;
            return symbol && symbol⚠️<i><b title="LoadNamedGeneric">.mergeId</b></i> && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>registerForUnusedIdentifiersCheck</summary>
<pre class="code">
(node) {
            if (deferredUnusedIdentifierNodes) {
                deferredUnusedIdentifierNodes.🔶️<i><b title="CallWithDescriptor">push</b></i>(node);
            }
        }</pre>

</details>
</blockquote>



### getOuterTypeParametersOfClassOrInterface:
<pre class="code">
(symbol) {
            var declaration = symbol.flags & 32 /* Class */ ? symbol⚠️<i><b title="LoadNamedGeneric">.valueDeclaration</b></i> : ts.🔶<i><b title="Did not inline: unknown">getDeclarationOfKind</b></i>(symbol, 227 /* InterfaceDeclaration */);
            return 🔶️<i><b title="CallWithDescriptor">appendOuterTypeParameters</b></i>(undefined, declaration);
        }</pre>



### createSignature:
<pre class="code">
(declaration, typeParameters, thisParameter, parameters, resolvedReturnType, typePredicate, minArgumentCount, hasRestParameter, hasLiteralTypes) {
            var sig = <b title="Inlined">🔷new Signature</b>(checker);
            sig.declaration = declaration;
            sig.typeParameters = typeParameters;
            sig.parameters = parameters;
            sig.thisParameter = thisParameter;
            sig.resolvedReturnType = resolvedReturnType;
            sig.typePredicate = typePredicate;
            sig.minArgumentCount = minArgumentCount;
            sig.hasRestParameter = hasRestParameter;
            sig.hasLiteralTypes ⚠️<i><b title="StoreNamedGeneric">= hasLiteralTypes</b></i>;
            return sig;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new Signature</summary>
<pre class="code">
(checker) {
            this.checker = checker;
        }</pre>

</details>
</blockquote>



### getTypeFromUnionTypeNode:
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(node) {
            var links = <b title="Inlined">🔷getNodeLinks</b>(node);
            if (!links.resolvedType) {
                links.resolvedType ⚠️<i><b title="StoreNamedGeneric">= getUnionType</b></i>(ts.🔶<i><b title="Did not inline: unknown">map</b></i>(node.types, getTypeFromTypeNode), /*subtypeReduction*/ false, <b title="Inlined">🔷getAliasSymbolForTypeNode</b>(node), <b title="Inlined">🔷getAliasTypeArgumentsForTypeNode</b>(node));
            }
            return links.resolvedType;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getNodeLinks</summary>
<pre class="code">
(node) {
            var nodeId = <b title="Inlined">🔷getNodeId</b>(node);
            return nodeLinks⚠️<i><b title="LoadKeyedGeneric">[nodeId]</b></i> || (nodeLinks[nodeId] = { flags: 0 });
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getNodeId</summary>
<pre class="code">
(node) {
        if (!node⚠️<i><b title="LoadNamedGeneric">.id</b></i>) {
            node.id ⚠️<i><b title="StoreNamedGeneric">= nextNodeId</b></i>;
            nextNodeId++;
        }
        return node⚠️<i><b title="LoadNamedGeneric">.id</b></i>;
    }</pre>

</details>
</blockquote>

</details>
<details>
<summary>getAliasSymbolForTypeNode</summary>
<pre class="code">
(node) {
            return node⚠️<i><b title="LoadNamedGeneric">.parent</b></i>⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 228 /* TypeAliasDeclaration */ ? <b title="Inlined">🔷getSymbolOfNode</b>(node.parent) : undefined;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getSymbolOfNode</summary>
<pre class="code">
(node) {
            return <b title="Inlined">🔷getMergedSymbol</b>(node.symbol);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getMergedSymbol</summary>
<pre class="code">
(symbol) {
            var merged;
            return symbol && symbol⚠️<i><b title="LoadNamedGeneric">.mergeId</b></i> && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>getAliasTypeArgumentsForTypeNode</summary>
<pre class="code">
(node) {
            var symbol = <b title="Inlined">🔷getAliasSymbolForTypeNode</b>(node);
            return symbol ? 🔶️<i><b title="CallWithDescriptor">getLocalTypeParametersOfClassOrInterfaceOrTypeAlias</b></i>(symbol) : undefined;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getAliasSymbolForTypeNode</summary>
<pre class="code">
(node) {
            return node⚠️<i><b title="LoadNamedGeneric">.parent</b></i>⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 228 /* TypeAliasDeclaration */ ? <b title="Inlined">🔷getSymbolOfNode</b>(node.parent) : undefined;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getSymbolOfNode</summary>
<pre class="code">
(node) {
            return <b title="Inlined">🔷getMergedSymbol</b>(node.symbol);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getMergedSymbol</summary>
<pre class="code">
(symbol) {
            var merged;
            return symbol && symbol⚠️<i><b title="LoadNamedGeneric">.mergeId</b></i> && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>



### addTypeToUnion:
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(typeSet, type) {
            var flags = type⚠️<i><b title="LoadNamedGeneric">.flags</b></i>;
            if (flags & 65536 /* Union */) {
                <b title="Inlined">🔷addTypesToUnion</b>(typeSet, type.types);
            }
            else if (flags & 1 /* Any */) {
                typeSet.containsAny ⚠️<i><b title="StoreNamedGeneric">= true</b></i>;
            }
            else if (!strictNullChecks && flags & 6144 /* Nullable */) {
                if (flags & 2048 /* Undefined */)
                    typeSet.containsUndefined ⚠️<i><b title="StoreNamedGeneric">= true</b></i>;
                if (flags & 4096 /* Null */)
                    typeSet.containsNull ⚠️<i><b title="StoreNamedGeneric">= true</b></i>;
                if (!(flags & 2097152 /* ContainsWideningType */))
                    typeSet.containsNonWideningType ⚠️<i><b title="StoreNamedGeneric">= true</b></i>;
            }
            else if (!(flags & 8192 /* Never */)) {
                if (flags & 2 /* String */)
                    typeSet.containsString ⚠️<i><b title="StoreNamedGeneric">= true</b></i>;
                if (flags & 4 /* Number */)
                    typeSet.containsNumber ⚠️<i><b title="StoreNamedGeneric">= true</b></i>;
                if (flags & 96 /* StringOrNumberLiteral */)
                    typeSet.containsStringOrNumberLiteral ⚠️<i><b title="StoreNamedGeneric">= true</b></i>;
                var len = typeSet⚠️<i><b title="LoadNamedGeneric">.length</b></i>;
                var index = len && type⚠️<i><b title="LoadNamedGeneric">.id</b></i> &gt; typeSet⚠️<i><b title="LoadKeyedGeneric">[len</b></i> - 1]⚠️<i><b title="LoadNamedGeneric">.id</b></i> ? ~len : <b title="Inlined">🔷binarySearchTypes</b>(typeSet, type);
                if (index &lt; 0) {
                    if (!(flags & 32768 /* Object */ && type⚠️<i><b title="LoadNamedGeneric">.objectFlags</b></i> & 16 /* Anonymous */ &&
                        type.symbol && type.symbol.flags & (16 /* Function */ | 8192 /* Method */) && 🔶️<i><b title="CallWithDescriptor">containsIdenticalType</b></i>(typeSet, type))) {
                        typeSet.🔶️<i><b title="CallWithDescriptor">splice</b></i>(~index, 0, type);
                    }
                }
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>addTypesToUnion</summary>
<pre class="code">
(typeSet, types) {
            for (var _i = 0, types_4 = types; _i &lt; types_4.length; _i++) {
                var type = types_4[_i];
                🔶<i><b title="Did not inline: target text too big">addTypeToUnion</b></i>(typeSet, type);
            }
        }</pre>

</details>
<details>
<summary>binarySearchTypes</summary>
<pre class="code">
(types, type) {
            var low = 0;
            var high = types⚠️<i><b title="LoadNamedGeneric">.length</b></i> - 1;
            var typeId = type⚠️<i><b title="LoadNamedGeneric">.id</b></i>;
            while (low &lt;= high) {
                var middle = low + ((high - low) &gt;&gt; 1);
                var id = types⚠️<i><b title="LoadKeyedGeneric">[middle]</b></i>⚠️<i><b title="LoadNamedGeneric">.id</b></i>;
                if (id === typeId) {
                    return middle;
                }
                else if (id &gt; typeId) {
                    high = middle - 1;
                }
                else {
                    low = middle + 1;
                }
            }
            return ~low;
        }</pre>

</details>
</blockquote>



### checkUnionOrIntersectionType:
<pre class="code">
(node) {
            ts.🔶<i><b title="Did not inline: unknown">forEach</b></i>(node.types, checkSourceElement);
        }</pre>



### isInAmbientContext:
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(node) {
        while (node) {
            if (<b title="Inlined">🔷hasModifier</b>(node, 2 /* Ambient */) || (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 261 /* SourceFile */ && node.isDeclarationFile)) {
                return true;
            }
            node = node⚠️<i><b title="LoadNamedGeneric">.parent</b></i>;
        }
        return false;
    }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>hasModifier</summary>
<pre class="code">
(node, flags) {
        return (🔶<i><b title="Did not inline: target text too big">getModifierFlags</b></i>(node) & flags) !== 0;
    }</pre>

</details>
</blockquote>



### pushTypeResolution:
<pre class="code">
(target, propertyName) {
            var resolutionCycleStartIndex = <b title="Inlined">🔷findResolutionCycleStartIndex</b>(target, propertyName);
            if (resolutionCycleStartIndex &gt;= 0) {
                // A cycle was found
                var length_2 = resolutionTargets⚠️<i><b title="LoadNamedGeneric">.length</b></i>;
                for (var i = resolutionCycleStartIndex; i ⚠️<i><b title="CompareGeneric">< length_2</b></i>; i++) {
                    resolutionResults[i] ⚠️<i><b title="StoreKeyedGeneric">= false</b></i>;
                }
                return false;
            }
            resolutionTargets.push(target);
            resolutionResults.push(/*items*/ true);
            resolutionPropertyNames.push(propertyName);
            return true;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>findResolutionCycleStartIndex</summary>
<pre class="code">
(target, propertyName) {
            for (var i = resolutionTargets.length - 1; i &gt;= 0; i--) {
                if (🔶️<i><b title="CallWithDescriptor">hasType</b></i>(resolutionTargets[i], resolutionPropertyNames[i])) {
                    return -1;
                }
                if (resolutionTargets[i] === target && resolutionPropertyNames⚠️<i><b title="LoadKeyedGeneric">[i]</b></i> ⚠️<i><b title="CompareGeneric">=== propertyName</b></i>) {
                    return i;
                }
            }
            return -1;
        }</pre>

</details>
</blockquote>



### isJSDocConstructSignature:
<pre class="code">
(node) {
        return node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 274 /* JSDocFunctionType */ &&
            node⚠️<i><b title="LoadNamedGeneric">.parameters</b></i>⚠️<i><b title="LoadNamedGeneric">.length</b></i> ⚠️<i><b title="CompareGeneric">> 0</b></i> &&
            node⚠️<i><b title="LoadNamedGeneric">.parameters</b></i>⚠️<i><b title="LoadKeyedGeneric">[0]</b></i>⚠️<i><b title="LoadNamedGeneric">.type</b></i>⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 276</b></i> /* JSDocConstructorType */;
    }</pre>



### hasRestParameter:
<pre class="code">
(s) {
        return <b title="Inlined">🔷isRestParameter</b>(ts.⚠️<i><b title="LoadNamedGeneric">lastOrUndefined</b></i>(s⚠️<i><b title="LoadNamedGeneric">.parameters</b></i>));
    }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>isRestParameter</summary>
<pre class="code">
(node) {
        if (node && (node.flags & 65536 /* JavaScriptFile */)) {
            if (node⚠️<i><b title="LoadNamedGeneric">.type</b></i> && node⚠️<i><b title="LoadNamedGeneric">.type</b></i>⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 275</b></i> /* JSDocVariadicType */ ||
                ts.🔶<i><b title="Did not inline: unknown">forEach</b></i>(🔶️<i><b title="CallWithDescriptor">getJSDocParameterTags</b></i>(node), 🔶️<i><b title="CallWithDescriptor">function</b></i> (t) { return t.typeExpression && t.typeExpression.type.kind === 275 /* JSDocVariadicType */; })) {
                return true;
            }
        }
        return <b title="Inlined">🔷isDeclaredRestParam</b>(node);
    }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>isDeclaredRestParam</summary>
<pre class="code">
(node) {
        return node && node.dotDotDotToken !== undefined;
    }</pre>

</details>
</blockquote>

</details>
</blockquote>



### ⛔ getTypeParametersFromJSDocTemplate (deoptimizated):
<pre class="code">
(declaration) {
            if (declaration⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 65536 /* JavaScriptFile */) {
                var templateTag = ts.🔶️<i><b title="CallWithDescriptor">getJSDocTemplateTag</b></i>(declaration);
                if (templateTag) {
                    return 🔶<i><b title="Did not inline: target has context-allocated variables">getTypeParametersFromDeclaration</b></i>(templateTag⚠️<i><b title="LoadNamedGeneric">.typeParameters</b></i>);
                }
            }
            return undefined;
        }</pre>

```diff
- Deopt: <JS Function checkFunctionOrMethodDeclaration (SharedFunctionInfo 0x1b98fbc0c0c1)> (opt #401) @32, FP to SP delta: 152, caller sp: 0x7fff5fbfdda0
```

```diff
- Deopt: <JS Function isInAmbientContext (SharedFunctionInfo 0x3504a53d15d9)> (opt #411) @7, FP to SP delta: 40, caller sp: 0x7fff5fbfdc30
```

```diff
- Deopt: <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)> (opt #391) @87, FP to SP delta: 320, caller sp: 0x7fff5fbfd8f8
```



### getUnionType:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(types, subtypeReduction, aliasSymbol, aliasTypeArguments) {
            if (types.length === 0) {
                return neverType;
            }
            if (types.length === 1) {
                return types[0];
            }
            var typeSet = [];
            <b title="Inlined">🔷addTypesToUnion</b>(typeSet, types);
            if (typeSet⚠️<i><b title="LoadNamedGeneric">.containsAny</b></i>) {
                return anyType;
            }
            if (subtypeReduction) {
                🔶️<i><b title="CallWithDescriptor">removeSubtypes</b></i>(typeSet);
            }
            else if (typeSet⚠️<i><b title="LoadNamedGeneric">.containsStringOrNumberLiteral</b></i>) {
                <b title="Inlined">🔷removeRedundantLiteralTypes</b>(typeSet);
            }
            if (typeSet⚠️<i><b title="LoadNamedGeneric">.length</b></i> === 0) {
                return typeSet⚠️<i><b title="LoadNamedGeneric">.containsNull</b></i> ? typeSet⚠️<i><b title="LoadNamedGeneric">.containsNonWideningType</b></i> ? nullType : nullWideningType :
                    typeSet⚠️<i><b title="LoadNamedGeneric">.containsUndefined</b></i> ? typeSet⚠️<i><b title="LoadNamedGeneric">.containsNonWideningType</b></i> ? undefinedType : undefinedWideningType :
                        neverType;
            }
            return 🔶️<i><b title="CallWithDescriptor">getUnionTypeFromSortedList</b></i>(typeSet, aliasSymbol, aliasTypeArguments);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>addTypesToUnion</summary>
<pre class="code">
(typeSet, types) {
            for (var _i = 0, types_4 = types; _i &lt; types_4.length; _i++) {
                var type = types_4[_i];
                🔶<i><b title="Did not inline: target text too big">addTypeToUnion</b></i>(typeSet, type);
            }
        }</pre>

</details>
<details>
<summary>removeRedundantLiteralTypes</summary>
<pre class="code">
(types) {
            var i = types.length;
            while (i &gt; 0) {
                i--;
                var t = types[i];
                var remove = t.flags & 32 /* StringLiteral */ && types.containsString ||
                    t.flags & 64 /* NumberLiteral */ && types⚠️<i><b title="LoadNamedGeneric">.containsNumber</b></i> ||
                    t.flags & 96 /* StringOrNumberLiteral */ && t.flags & 1048576 /* FreshLiteral */ && 🔶<i><b title="Did not inline: unknown">containsType</b></i>(types, t⚠️<i><b title="LoadNamedGeneric">.regularType</b></i>);
                if (remove) {
                    ts.🔶️<i><b title="CallWithDescriptor">orderedRemoveItemAt</b></i>(types, i);
                }
            }
        }</pre>

</details>
</blockquote>



### shouldReportBadModifier:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(node) {
            switch (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i>) {
                case 151 /* GetAccessor */:
                case 152 /* SetAccessor */:
                case 150 /* Constructor */:
                case 147 /* PropertyDeclaration */:
                case 146 /* PropertySignature */:
                case 149 /* MethodDeclaration */:
                case 148 /* MethodSignature */:
                case 155 /* IndexSignature */:
                case 230 /* ModuleDeclaration */:
                case 235 /* ImportDeclaration */:
                case 234 /* ImportEqualsDeclaration */:
                case 241 /* ExportDeclaration */:
                case 240 /* ExportAssignment */:
                case 184 /* FunctionExpression */:
                case 185 /* ArrowFunction */:
                case 144 /* Parameter */:
                    return false;
                default:
                    if (node⚠️<i><b title="LoadNamedGeneric">.parent</b></i>.kind === 231 /* ModuleBlock */ || node⚠️<i><b title="LoadNamedGeneric">.parent</b></i>.kind === 261 /* SourceFile */) {
                        return false;
                    }
                    ⚠️<i><b title="CompareGeneric">switch</b></i> (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i>) {
                        case 225 /* FunctionDeclaration */:
                            return 🔶️<i><b title="CallWithDescriptor">nodeHasAnyModifiersExcept</b></i>(node, 119 /* AsyncKeyword */);
                        case 226 /* ClassDeclaration */:
                            return 🔶️<i><b title="CallWithDescriptor">nodeHasAnyModifiersExcept</b></i>(node, 116 /* AbstractKeyword */);
                        case 227 /* InterfaceDeclaration */:
                        case 205 /* VariableStatement */:
                        case 228 /* TypeAliasDeclaration */:
                            return true;
                        case 229 /* EnumDeclaration */:
                            return 🔶️<i><b title="CallWithDescriptor">nodeHasAnyModifiersExcept</b></i>(node, 75 /* ConstKeyword */);
                        default:
                            ts⚠️<i><b title="LoadNamedGeneric">.Debug</b></i>.🔶️<i><b title="CallWithDescriptor">fail</b></i>();
                            return false;
                    }
            }
        }</pre>



### resolveClassOrInterfaceMembers:
<pre class="code">
(type) {
            🔶️<i><b title="CallWithDescriptor">resolveObjectTypeMembers</b></i>(type, <b title="Inlined">🔷resolveDeclaredMembers</b>(type), emptyArray, emptyArray);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>resolveDeclaredMembers</summary>
<pre class="code">
(type) {
            if (!type⚠️<i><b title="LoadNamedGeneric">.declaredProperties</b></i>) {
                var symbol = type.symbol;
                type.declaredProperties ⚠️<i><b title="StoreNamedGeneric">= getNamedMembers</b></i>(symbol.members);
                type.declaredCallSignatures ⚠️<i><b title="StoreNamedGeneric">= getSignaturesOfSymbol</b></i>(symbol.members⚠️<i><b title="LoadNamedGeneric">["__c</b></i>all"]);
                type.declaredConstructSignatures ⚠️<i><b title="StoreNamedGeneric">= getSignaturesOfSymbol</b></i>(symbol.members⚠️<i><b title="LoadNamedGeneric">["__n</b></i>ew"]);
                type.declaredStringIndexInfo ⚠️<i><b title="StoreNamedGeneric">= getIndexInfoOfSymbol</b></i>(symbol, 0 /* String */);
                type.declaredNumberIndexInfo ⚠️<i><b title="StoreNamedGeneric">= getIndexInfoOfSymbol</b></i>(symbol, 1 /* Number */);
            }
            return type;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getNamedMembers</summary>
<pre class="code">
(members) {
            var result;
            🔶️<i><b title="CallWithDescriptor">for</b></i> (var id in members) {
                if (!<b title="Inlined">🔷isReservedMemberName</b>(id)) {
                    if (!result)
                        result = [];
                    var symbol = members⚠️<i><b title="LoadKeyedGeneric">[id]</b></i>;
                    if (🔶<i><b title="Did not inline: target text too big">symbolIsValue</b></i>(symbol)) {
                        result.push(symbol);
                    }
                }
            }
            return result || emptyArray;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>isReservedMemberName</summary>
<pre class="code">
(name) {
            return name.charCodeAt(0) === 95 /* _ */ &&
                name.charCodeAt(1) === 95 /* _ */ &&
                name.charCodeAt(2) !== 95 /* _ */ &&
                name.charCodeAt(2) !== 64 /* at */;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>getIndexInfoOfSymbol</summary>
<pre class="code">
(symbol, kind) {
            var declaration = getIndexDeclarationOfSymbol(symbol, kind);
            if (declaration) {
                return <b title="Inlined">🔷createIndexInfo</b>(declaration.type ? 🔶<i><b title="Did not inline: target text too big">getTypeFromTypeNode</b></i>(declaration.type) : anyType, (ts.🔶<i><b title="Did not inline: target text too big">getModifierFlags</b></i>(declaration) & 64 /* Readonly */) !== 0, declaration);
            }
            return undefined;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createIndexInfo</summary>
<pre class="code">
(type, isReadonly, declaration) {
            return { type: type, isReadonly: isReadonly, declaration: declaration };
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>getIndexInfoOfSymbol</summary>
<pre class="code">
(symbol, kind) {
            var declaration = getIndexDeclarationOfSymbol(symbol, kind);
            if (declaration) {
                return <b title="Inlined">🔷createIndexInfo</b>(declaration.type ? 🔶<i><b title="Did not inline: target text too big">getTypeFromTypeNode</b></i>(declaration.type) : anyType, (ts.🔶<i><b title="Did not inline: target text too big">getModifierFlags</b></i>(declaration) & 64 /* Readonly */) !== 0, declaration);
            }
            return undefined;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createIndexInfo</summary>
<pre class="code">
(type, isReadonly, declaration) {
            return { type: type, isReadonly: isReadonly, declaration: declaration };
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>



### checkGrammarParameterList:
<pre class="code">
(parameters) {
            var seenOptionalParameter = false;
            var parameterCount = parameters.length;
            for (var i = 0; i &lt; parameterCount; i++) {
                var parameter = parameters[i];
                if (parameter.dotDotDotToken) {
                    if (i !== (parameterCount - 1)) {
                        return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(parameter⚠️<i><b title="LoadNamedGeneric">.dotDotDotToken</b></i>, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.A_rest_parameter_must_be_last_in_a_parameter_list</b></i>);
                    }
                    if (ts.⚠️<i><b title="LoadNamedGeneric">isBindingPattern</b></i>(parameter.name)) {
                        return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(parameter⚠️<i><b title="LoadNamedGeneric">.name</b></i>, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.A_rest_element_cannot_contain_a_binding_pattern</b></i>);
                    }
                    if (parameter.questionToken) {
                        return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(parameter⚠️<i><b title="LoadNamedGeneric">.questionToken</b></i>, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.A_rest_parameter_cannot_be_optional</b></i>);
                    }
                    if (parameter.initializer) {
                        return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(parameter⚠️<i><b title="LoadNamedGeneric">.name</b></i>, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.A_rest_parameter_cannot_have_an_initializer</b></i>);
                    }
                }
                else if (parameter.questionToken) {
                    seenOptionalParameter = true;
                    if (parameter.initializer) {
                        return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(parameter⚠️<i><b title="LoadNamedGeneric">.name</b></i>, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Parameter_cannot_have_question_mark_and_initializer</b></i>);
                    }
                }
                else if (seenOptionalParameter && !parameter⚠️<i><b title="LoadNamedGeneric">.initializer</b></i>) {
                    return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(parameter⚠️<i><b title="LoadNamedGeneric">.name</b></i>, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.A_required_parameter_cannot_follow_an_optional_parameter</b></i>);
                }
            }
        }</pre>



### getLiteralTypeFromPropertyName:
<pre class="code">
(prop) {
            return <b title="Inlined">🔷getDeclarationModifierFlagsFromSymbol</b>(prop) & 24 /* NonPublicAccessibilityModifier */ || ts.🔶<i><b title="Did not inline: unknown">startsWith</b></i>(prop.name, "__@") ?
                neverType :
                <b title="Inlined">🔷getLiteralTypeForText</b>(32 /* StringLiteral */, ts.⚠️<i><b title="LoadNamedGeneric">unescapeIdentifier</b></i>(prop.name));
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getDeclarationModifierFlagsFromSymbol</summary>
<pre class="code">
(s) {
            return s.valueDeclaration ? ts.🔶<i><b title="Did not inline: unknown">getCombinedModifierFlags</b></i>(s.valueDeclaration) : s⚠️<i><b title="LoadNamedGeneric">.flags</b></i> ⚠️<i><b title="Bitwise">& 134217728</b></i> /* Prototype */ ? 4 /* Public */ | 32 /* Static */ : 0;
        }</pre>

</details>
<details>
<summary>getLiteralTypeForText</summary>
<pre class="code">
(flags, text) {
            var map = flags & 32 /* StringLiteral */ ? stringLiteralTypes : numericLiteralTypes;
            return map⚠️<i><b title="LoadKeyedGeneric">[text]</b></i> || (map[text] ⚠️<i><b title="StoreKeyedGeneric">= createLiteralType</b></i>(flags, text));
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createLiteralType</summary>
<pre class="code">
(flags, text) {
            var type = <b title="Inlined">🔷createType</b>(flags);
            type.text = text;
            return type;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createType</summary>
<pre class="code">
(flags) {
            var result = <b title="Inlined">🔷new Type</b>(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new Type</summary>
<pre class="code">
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>



### startsWith:
<pre class="code">
(str, prefix) {
        return str.🔶<i><b title="Did not inline: unknown">lastIndexOf</b></i>(prefix, 0) === 0;
    }</pre>



### unescapeIdentifier:
<pre class="code">
(identifier) {
        return identifier.length &gt;= 3 && identifier.charCodeAt(0) === 95 /* _ */ && identifier.🔶️<i><b title="CallWithDescriptor">charCodeAt</b></i>(1) ⚠️<i><b title="CompareGeneric">=== 95</b></i> /* _ */ && identifier.🔶️<i><b title="CallWithDescriptor">charCodeAt</b></i>(2) ⚠️<i><b title="CompareGeneric">=== 95</b></i> /* _ */ ? identifier.🔶️<i><b title="CallWithDescriptor">substr</b></i>(1) : identifier;
    }</pre>



### ⛔ isSimpleTypeRelatedTo (deoptimizated):
<div>~recompile~</div>

<div>~recompile~</div>

```diff
- Deopt: <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)> (opt #444) @57, FP to SP delta: 304, caller sp: 0x7fff5fbfd9c8
```

<div>~recompile~</div>

<div>~recompile~</div>

```diff
- Deopt: <JS Function isRelatedTo (SharedFunctionInfo 0x130b7e1064a1)> (opt #604) @79, FP to SP delta: 312, caller sp: 0x7fff5fbfd3c8
```

<div>~recompile~</div>
<pre class="code">
(source, target, relation, errorReporter) {
            if (target⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 8192 /* Never */)
                return false;
            if (target⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 1 /* Any */ || source⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 8192 /* Never */)
                return true;
            if (source⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 262178 /* StringLike */ && target⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 2 /* String */)
                return true;
            if (source⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 340 /* NumberLike */ && target.flags & 4 /* Number */)
                return true;
            if (source⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 136 /* BooleanLike */ && target.flags & 8 /* Boolean */)
                return true;
            if (source⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 256 /* EnumLiteral */ && target⚠️<i><b title="LoadNamedGeneric">.flags</b></i> ⚠️<i><b title="Bitwise">& 16</b></i> /* Enum */ && source⚠️<i><b title="LoadNamedGeneric">.baseType</b></i> ⚠️<i><b title="CompareGeneric">=== target</b></i>)
                return true;
            if (source⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 16 /* Enum */ && target⚠️<i><b title="LoadNamedGeneric">.flags</b></i> ⚠️<i><b title="Bitwise">& 16</b></i> /* Enum */ && 🔶️<i><b title="CallWithDescriptor">isEnumTypeRelatedTo</b></i>(source, target, errorReporter))
                return true;
            if (source⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 2048 /* Undefined */ && (!strictNullChecks || target⚠️<i><b title="LoadNamedGeneric">.flags</b></i> ⚠️<i><b title="Bitwise">& (20</b></i>48 /* Undefined */ | 1024 /* Void */)))
                return true;
            if (source⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 4096 /* Null */ && (!strictNullChecks || target⚠️<i><b title="LoadNamedGeneric">.flags</b></i> ⚠️<i><b title="Bitwise">& 4096</b></i> /* Null */))
                return true;
            if (relation === assignableRelation || relation ⚠️<i><b title="CompareGeneric">=== comparableRelation</b></i>) {
                if (source⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 1 /* Any */)
                    return true;
                if ((source⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 4 /* Number */ | source⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 64 /* NumberLiteral */) && target.flags & 272 /* EnumLike */)
                    return true;
                if (source⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 256 /* EnumLiteral */ &&
                    target⚠️<i><b title="LoadNamedGeneric">.flags</b></i> ⚠️<i><b title="Bitwise">& 256</b></i> /* EnumLiteral */ &&
                    source⚠️<i><b title="LoadNamedGeneric">.text</b></i> ⚠️<i><b title="CompareGeneric">=== target</b></i>⚠️<i><b title="LoadNamedGeneric">.text</b></i> &&
                    🔶️<i><b title="CallWithDescriptor">isEnumTypeRelatedTo</b></i>(source⚠️<i><b title="LoadNamedGeneric">.baseType</b></i>, target⚠️<i><b title="LoadNamedGeneric">.baseType</b></i>, errorReporter)) {
                    return true;
                }
                if (source⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 256 /* EnumLiteral */ &&
                    target⚠️<i><b title="LoadNamedGeneric">.flags</b></i> ⚠️<i><b title="Bitwise">& 16</b></i> /* Enum */ &&
                    🔶️<i><b title="CallWithDescriptor">isEnumTypeRelatedTo</b></i>(target, source⚠️<i><b title="LoadNamedGeneric">.baseType</b></i>, errorReporter)) {
                    return true;
                }
            }
            return false;
        }</pre>

```diff
- Deopt: <JS Function getTypeFromTypeNode (SharedFunctionInfo 0x2e2f693f5581)> (opt #571) @39, FP to SP delta: 264, caller sp: 0x7fff5fbfd258
```



### isRelatedTo:
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(source, target, reportErrors, headMessage) {
                var result;
                if (source⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 96 /* StringOrNumberLiteral */ && source.flags & 1048576 /* FreshLiteral */) {
                    source = source⚠️<i><b title="LoadNamedGeneric">.regularType</b></i>;
                }
                if (target⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 96 /* StringOrNumberLiteral */ && target.flags & 1048576 /* FreshLiteral */) {
                    target = target⚠️<i><b title="LoadNamedGeneric">.regularType</b></i>;
                }
                // both types are the same - covers 'they are the same primitive type or both are Any' or the same type parameter cases
                if (source === target)
                    return -1 /* True */;
                if (relation === identityRelation) {
                    return 🔶️<i><b title="CallWithDescriptor">isIdenticalTo</b></i>(source, target);
                }
                if (🔶<i><b title="Did not inline: target text too big">isSimpleTypeRelatedTo</b></i>(source, target, relation, reportErrors ? reportError : undefined))
                    return -1 /* True */;
                if (<b title="Inlined">🔷getObjectFlags</b>(source) & 128 /* ObjectLiteral */ && source⚠️<i><b title="LoadNamedGeneric">.flags</b></i> ⚠️<i><b title="Bitwise">& 1048576</b></i> /* FreshLiteral */) {
                    if (🔶️<i><b title="CallWithDescriptor">hasExcessProperties</b></i>(source, target, reportErrors)) {
                        if (reportErrors) {
                            🔶️<i><b title="CallWithDescriptor">reportRelationError</b></i>(headMessage, source, target);
                        }
                        return 0 /* False */;
                    }
                    // Above we check for excess properties with respect to the entire target type. When union
                    // and intersection types are further deconstructed on the target side, we don't want to
                    // make the check again (as it might fail for a partial target type). Therefore we obtain
                    // the regular source type and proceed with that.
                    if (🔶️<i><b title="CallWithDescriptor">isUnionOrIntersectionTypeWithoutNullableConstituents</b></i>(target)) {
                        source = 🔶️<i><b title="CallWithDescriptor">getRegularTypeOfObjectLiteral</b></i>(source);
                    }
                }
                var saveErrorInfo = errorInfo;
                // Note that these checks are specifically ordered to produce correct results. In particular,
                // we need to deconstruct unions before intersections (because unions are always at the top),
                // and we need to handle "each" relations before "some" relations for the same kind of type.
                if (source⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 65536 /* Union */) {
                    if (relation === comparableRelation) {
                        result = 🔶️<i><b title="CallWithDescriptor">someTypeRelatedToType</b></i>(source, target, reportErrors && !(source⚠️<i><b title="LoadNamedGeneric">.flags</b></i> ⚠️<i><b title="Bitwise">& 8190</b></i> /* Primitive */));
                    }
                    else {
                        result = 🔶<i><b title="Did not inline: unknown">eachTypeRelatedToType</b></i>(source, target, reportErrors && !(source.flags & 8190 /* Primitive */));
                    }
                    if (result) {
                        return result;
                    }
                }
                else if (target⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 65536 /* Union */) {
                    if (result = 🔶️<i><b title="CallWithDescriptor">typeRelatedToSomeType</b></i>(source, target, reportErrors && !(source.flags & 8190 /* Primitive */) && !(target⚠️<i><b title="LoadNamedGeneric">.flags</b></i> ⚠️<i><b title="Bitwise">& 8190</b></i> /* Primitive */))) {
                        return result;
                    }
                }
                else if (target⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 131072 /* Intersection */) {
                    if (result = 🔶️<i><b title="CallWithDescriptor">typeRelatedToEachType</b></i>(source, target, reportErrors)) {
                        return result;
                    }
                }
                else if (source⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 131072 /* Intersection */) {
                    // Check to see if any constituents of the intersection are immediately related to the target.
                    //
                    // Don't report errors though. Checking whether a constituent is related to the source is not actually
                    // useful and leads to some confusing error messages. Instead it is better to let the below checks
                    // take care of this, or to not elaborate at all. For instance,
                    //
                    //    - For an object type (such as 'C = A & B'), users are usually more interested in structural errors.
                    //
                    //    - For a union type (such as '(A | B) = (C & D)'), it's better to hold onto the whole intersection
                    //          than to report that 'D' is not assignable to 'A' or 'B'.
                    //
                    //    - For a primitive type or type parameter (such as 'number = A & B') there is no point in
                    //          breaking the intersection apart.
                    if (result = 🔶️<i><b title="CallWithDescriptor">someTypeRelatedToType</b></i>(source, target, /*reportErrors*/ false)) {
                        return result;
                    }
                }
                else if (target⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 16384 /* TypeParameter */) {
                    // A source type { [P in keyof T]: X } is related to a target type T if X is related to T[P].
                    if (<b title="Inlined">🔷getObjectFlags</b>(source) & 32 /* Mapped */ && 🔶️<i><b title="CallWithDescriptor">getConstraintTypeFromMappedType</b></i>(source) ⚠️<i><b title="CompareGeneric">=== getIndexType</b></i>(target)) {
                        if (!source⚠️<i><b title="LoadNamedGeneric">.declaration</b></i>⚠️<i><b title="LoadNamedGeneric">.questionToken</b></i>) {
                            var templateType = 🔶️<i><b title="CallWithDescriptor">getTemplateTypeFromMappedType</b></i>(source);
                            var indexedAccessType = 🔶️<i><b title="CallWithDescriptor">getIndexedAccessType</b></i>(target, 🔶️<i><b title="CallWithDescriptor">getTypeParameterFromMappedType</b></i>(source));
                            if (result = 🔶<i><b title="Did not inline: unknown">isRelatedTo</b></i>(templateType, indexedAccessType, reportErrors)) {
                                return result;
                            }
                        }
                    }
                    else {
                        // Given a type parameter K with a constraint keyof T, a type S is
                        // assignable to K if S is assignable to keyof T.
                        var constraint = 🔶<i><b title="Did not inline: target text too big">getConstraintOfTypeParameter</b></i>(target);
                        if (constraint && constraint⚠️<i><b title="LoadNamedGeneric">.flags</b></i> ⚠️<i><b title="Bitwise">& 262144</b></i> /* Index */) {
                            if (result = 🔶<i><b title="Did not inline: unknown">isRelatedTo</b></i>(source, constraint, reportErrors)) {
                                return result;
                            }
                        }
                    }
                }
                else if (target⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 262144 /* Index */) {
                    // A keyof S is related to a keyof T if T is related to S.
                    if (source.flags & 262144 /* Index */) {
                        if (result = 🔶<i><b title="Did not inline: unknown">isRelatedTo</b></i>(target⚠️<i><b title="LoadNamedGeneric">.type</b></i>, source⚠️<i><b title="LoadNamedGeneric">.type</b></i>, /*reportErrors*/ false)) {
                            return result;
                        }
                    }
                    // Given a type variable T with a constraint C, a type S is assignable to
                    // keyof T if S is assignable to keyof C.
                    if (target.type.flags & 540672 /* TypeVariable */) {
                        var constraint = <b title="Inlined">🔷getConstraintOfTypeVariable</b>(target.type);
                        if (constraint) {
                            if (result = 🔶<i><b title="Did not inline: unknown">isRelatedTo</b></i>(source, 🔶<i><b title="Did not inline: unknown">getIndexType</b></i>(constraint), reportErrors)) {
                                return result;
                            }
                        }
                    }
                }
                else if (target⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 524288 /* IndexedAccess */) {
                    // if we have indexed access types with identical index types, see if relationship holds for
                    // the two object types.
                    if (source⚠️<i><b title="LoadNamedGeneric">.flags</b></i> ⚠️<i><b title="Bitwise">& 524288</b></i> /* IndexedAccess */ && source⚠️<i><b title="LoadNamedGeneric">.indexType</b></i> ⚠️<i><b title="CompareGeneric">=== target</b></i>⚠️<i><b title="LoadNamedGeneric">.indexType</b></i>) {
                        if (result = 🔶<i><b title="Did not inline: unknown">isRelatedTo</b></i>(source⚠️<i><b title="LoadNamedGeneric">.objectType</b></i>, target⚠️<i><b title="LoadNamedGeneric">.objectType</b></i>, reportErrors)) {
                            return result;
                        }
                    }
                    // A type S is related to a type T[K] if S is related to A[K], where K is string-like and
                    // A is the apparent type of S.
                    if (target⚠️<i><b title="LoadNamedGeneric">.constraint</b></i>) {
                        if (result = 🔶<i><b title="Did not inline: unknown">isRelatedTo</b></i>(source, target⚠️<i><b title="LoadNamedGeneric">.constraint</b></i>, reportErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                }
                if (source⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 16384 /* TypeParameter */) {
                    // A source type T is related to a target type { [P in keyof T]: X } if T[P] is related to X.
                    if (<b title="Inlined">🔷getObjectFlags</b>(target) & 32 /* Mapped */ && 🔶️<i><b title="CallWithDescriptor">getConstraintTypeFromMappedType</b></i>(target) ⚠️<i><b title="CompareGeneric">=== getIndexType</b></i>(source)) {
                        var indexedAccessType = 🔶️<i><b title="CallWithDescriptor">getIndexedAccessType</b></i>(source, 🔶️<i><b title="CallWithDescriptor">getTypeParameterFromMappedType</b></i>(target));
                        var templateType = 🔶️<i><b title="CallWithDescriptor">getTemplateTypeFromMappedType</b></i>(target);
                        if (result = 🔶<i><b title="Did not inline: unknown">isRelatedTo</b></i>(indexedAccessType, templateType, reportErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                    else {
                        var constraint = 🔶<i><b title="Did not inline: target text too big">getConstraintOfTypeParameter</b></i>(source);
                        if (!constraint || constraint⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 1 /* Any */) {
                            constraint = emptyObjectType;
                        }
                        // The constraint may need to be further instantiated with its 'this' type.
                        constraint = <b title="Inlined">🔷getTypeWithThisArgument</b>(constraint, source);
                        // Report constraint errors only if the constraint is not the empty object type
                        var reportConstraintErrors = reportErrors && constraint !== emptyObjectType;
                        if (result = 🔶<i><b title="Did not inline: unknown">isRelatedTo</b></i>(constraint, target, reportConstraintErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                }
                else if (source⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 524288 /* IndexedAccess */) {
                    // A type S[K] is related to a type T if A[K] is related to T, where K is string-like and
                    // A is the apparent type of S.
                    if (source⚠️<i><b title="LoadNamedGeneric">.constraint</b></i>) {
                        if (result = 🔶<i><b title="Did not inline: unknown">isRelatedTo</b></i>(source⚠️<i><b title="LoadNamedGeneric">.constraint</b></i>, target, reportErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                }
                else {
                    if (<b title="Inlined">🔷getObjectFlags</b>(source) & 4 /* Reference */ && <b title="Inlined">🔷getObjectFlags</b>(target) & 4 /* Reference */ && source⚠️<i><b title="LoadNamedGeneric">.target</b></i> === target⚠️<i><b title="LoadNamedGeneric">.target</b></i>) {
                        // We have type references to same target type, see if relationship holds for all type arguments
                        if (result = 🔶️<i><b title="CallWithDescriptor">typeArgumentsRelatedTo</b></i>(source, target, reportErrors)) {
                            return result;
                        }
                    }
                    // Even if relationship doesn't hold for unions, intersections, or generic type references,
                    // it may hold in a structural comparison.
                    var apparentSource = <b title="Inlined">🔷getApparentType</b>(source);
                    // In a check of the form X = A & B, we will have previously checked if A relates to X or B relates
                    // to X. Failing both of those we want to check if the aggregation of A and B's members structurally
                    // relates to X. Thus, we include intersection types on the source side here.
                    if (apparentSource⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & (32768 /* Object */ | 131072 /* Intersection */) && target⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 32768 /* Object */) {
                        // Report structural errors only if we haven't reported any errors yet
                        var reportStructuralErrors = reportErrors && errorInfo ⚠️<i><b title="CompareGeneric">=== saveErrorInfo</b></i> && !(source⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 8190 /* Primitive */);
                        if (result = 🔶️<i><b title="CallWithDescriptor">objectTypeRelatedTo</b></i>(apparentSource, source, target, reportStructuralErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                }
                if (reportErrors) {
                    if (source.flags & 32768 /* Object */ && target.flags & 8190 /* Primitive */) {
                        🔶️<i><b title="CallWithDescriptor">tryElaborateErrorsForPrimitivesAndObjects</b></i>(source, target);
                    }
                    else if (source.symbol && source⚠️<i><b title="LoadNamedGeneric">.flags</b></i> ⚠️<i><b title="Bitwise">& 32768</b></i> /* Object */ && globalObjectType ⚠️<i><b title="CompareGeneric">=== source</b></i>) {
                        🔶️<i><b title="CallWithDescriptor">reportError</b></i>(ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.The_Object_type_is_assignable_to_very_few_other_types_Did_you_mean_to_use_the_any_type_instead</b></i>);
                    }
                    🔶️<i><b title="CallWithDescriptor">reportRelationError</b></i>(headMessage, source, target);
                }
                return 0 /* False */;
            }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getObjectFlags</summary>
<pre class="code">
(type) {
            return type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 32768 /* Object */ ? type⚠️<i><b title="LoadNamedGeneric">.objectFlags</b></i> : 0;
        }</pre>

</details>
<details>
<summary>getObjectFlags</summary>
<pre class="code">
(type) {
            return type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 32768 /* Object */ ? type⚠️<i><b title="LoadNamedGeneric">.objectFlags</b></i> : 0;
        }</pre>

</details>
<details>
<summary>getConstraintOfTypeVariable</summary>
<pre class="code">
(type) {
            return type.flags & 16384 /* TypeParameter */ ? 🔶<i><b title="Did not inline: target text too big">getConstraintOfTypeParameter</b></i>(type) :
                type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> ⚠️<i><b title="Bitwise">& 524288</b></i> /* IndexedAccess */ ? type⚠️<i><b title="LoadNamedGeneric">.constraint</b></i> :
                    undefined;
        }</pre>

</details>
<details>
<summary>getObjectFlags</summary>
<pre class="code">
(type) {
            return type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 32768 /* Object */ ? type⚠️<i><b title="LoadNamedGeneric">.objectFlags</b></i> : 0;
        }</pre>

</details>
<details>
<summary>getTypeWithThisArgument</summary>
<pre class="code">
(type, thisArgument) {
            if (<b title="Inlined">🔷getObjectFlags</b>(type) & 4 /* Reference */) {
                return <b title="Inlined">🔷createTypeReference</b>(type⚠️<i><b title="LoadNamedGeneric">.target</b></i>, ts.⚠️<i><b title="LoadNamedGeneric">concatenate</b></i>(type⚠️<i><b title="LoadNamedGeneric">.typeArguments</b></i>, [thisArgument || type.target.thisType]));
            }
            return type;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getObjectFlags</summary>
<pre class="code">
(type) {
            return type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 32768 /* Object */ ? type⚠️<i><b title="LoadNamedGeneric">.objectFlags</b></i> : 0;
        }</pre>

</details>
<details>
<summary>createTypeReference</summary>
<pre class="code">
(target, typeArguments) {
            var id = 🔶<i><b title="Did not inline: target text too big">getTypeListId</b></i>(typeArguments);
            var type = target⚠️<i><b title="LoadNamedGeneric">.instantiations</b></i>⚠️<i><b title="LoadKeyedGeneric">[id]</b></i>;
            if (!type) {
                type = target⚠️<i><b title="LoadNamedGeneric">.instantiations</b></i>[id] ⚠️<i><b title="StoreKeyedGeneric">= createObjectType</b></i>(4 /* Reference */, target⚠️<i><b title="LoadNamedGeneric">.symbol</b></i>);
                type.flags |= typeArguments ? <b title="Inlined">🔷getPropagatingFlagsOfTypes</b>(typeArguments, /*excludeKinds*/ 0) : 0;
                type.target = target;
                type.typeArguments = typeArguments;
            }
            return type;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createObjectType</summary>
<pre class="code">
(objectFlags, symbol) {
            var type = <b title="Inlined">🔷createType</b>(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol ⚠️<i><b title="StoreNamedGeneric">= symbol</b></i>;
            return type;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createType</summary>
<pre class="code">
(flags) {
            var result = <b title="Inlined">🔷new Type</b>(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new Type</summary>
<pre class="code">
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>getPropagatingFlagsOfTypes</summary>
<pre class="code">
(types, excludeKinds) {
            var result = 0;
            for (var _i = 0, types_3 = types; _i &lt; types_3⚠️<i><b title="LoadNamedGeneric">.length</b></i>; _i++) {
                var type = types_3⚠️<i><b title="LoadKeyedGeneric">[_i]</b></i>;
                if (!(type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & excludeKinds)) {
                    result |= type⚠️<i><b title="LoadNamedGeneric">.flags</b></i>;
                }
            }
            return result & 14680064 /* PropagatingFlags */;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>getObjectFlags</summary>
<pre class="code">
(type) {
            return type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 32768 /* Object */ ? type⚠️<i><b title="LoadNamedGeneric">.objectFlags</b></i> : 0;
        }</pre>

</details>
<details>
<summary>getObjectFlags</summary>
<pre class="code">
(type) {
            return type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 32768 /* Object */ ? type⚠️<i><b title="LoadNamedGeneric">.objectFlags</b></i> : 0;
        }</pre>

</details>
<details>
<summary>getApparentType</summary>
<pre class="code">
(type) {
            var t = type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 540672 /* TypeVariable */ ? 🔶️<i><b title="CallWithDescriptor">getApparentTypeOfTypeVariable</b></i>(type) : type;
            return t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 262178 /* StringLike */ ? globalStringType :
                t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 340 /* NumberLike */ ? globalNumberType :
                    t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 136 /* BooleanLike */ ? globalBooleanType :
                        t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 512 /* ESSymbol */ ? 🔶️<i><b title="CallWithDescriptor">getGlobalESSymbolType</b></i>() :
                            t;
        }</pre>

</details>
</blockquote>



### propertiesRelatedTo:
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(source, target, reportErrors) {
                if (relation === identityRelation) {
                    return 🔶️<i><b title="CallWithDescriptor">propertiesIdenticalTo</b></i>(source, target);
                }
                var result = -1 /* True */;
                var properties = <b title="Inlined">🔷getPropertiesOfObjectType</b>(target);
                var requireOptionalProperties = relation === subtypeRelation && !(🔶<i><b title="Did not inline: unknown">getObjectFlags</b></i>(source) ⚠️<i><b title="Bitwise">& 128</b></i> /* ObjectLiteral */);
                for (var _i = 0, properties_3 = properties; _i &lt; properties_3.length; _i++) {
                    var targetProp = properties_3[_i];
                    var sourceProp = getPropertyOfType(source, targetProp⚠️<i><b title="LoadNamedGeneric">.name</b></i>);
                    if (sourceProp ⚠️<i><b title="CompareGeneric">!== targetProp</b></i>) {
                        if (!sourceProp) {
                            if (!(targetProp.flags & 536870912 /* Optional */) || requireOptionalProperties) {
                                if (reportErrors) {
                                    🔶️<i><b title="CallWithDescriptor">reportError</b></i>(ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Property_0_is_missing_in_type_1</b></i>, 🔶️<i><b title="CallWithDescriptor">symbolToString</b></i>(targetProp), 🔶️<i><b title="CallWithDescriptor">typeToString</b></i>(source));
                                }
                                return 0 /* False */;
                            }
                        }
                        else if (!(targetProp⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 134217728 /* Prototype */)) {
                            var sourcePropFlags = <b title="Inlined">🔷getDeclarationModifierFlagsFromSymbol</b>(sourceProp);
                            var targetPropFlags = <b title="Inlined">🔷getDeclarationModifierFlagsFromSymbol</b>(targetProp);
                            if (sourcePropFlags & 8 /* Private */ || targetPropFlags & 8 /* Private */) {
                                if (sourceProp⚠️<i><b title="LoadNamedGeneric">.valueDeclaration</b></i> ⚠️<i><b title="CompareGeneric">!== targetProp</b></i>⚠️<i><b title="LoadNamedGeneric">.valueDeclaration</b></i>) {
                                    if (reportErrors) {
                                        if (sourcePropFlags ⚠️<i><b title="Bitwise">& 8</b></i> /* Private */ && targetPropFlags ⚠️<i><b title="Bitwise">& 8</b></i> /* Private */) {
                                            🔶️<i><b title="CallWithDescriptor">reportError</b></i>(ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Types_have_separate_declarations_of_a_private_property_0</b></i>, 🔶️<i><b title="CallWithDescriptor">symbolToString</b></i>(targetProp));
                                        }
                                        else {
                                            🔶️<i><b title="CallWithDescriptor">reportError</b></i>(ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Property_0_is_private_in_type_1_but_not_in_type_2</b></i>, 🔶️<i><b title="CallWithDescriptor">symbolToString</b></i>(targetProp), 🔶️<i><b title="CallWithDescriptor">typeToString</b></i>(sourcePropFlags ⚠️<i><b title="Bitwise">& 8</b></i> /* Private */ ? source : target), 🔶️<i><b title="CallWithDescriptor">typeToString</b></i>(sourcePropFlags ⚠️<i><b title="Bitwise">& 8</b></i> /* Private */ ? target : source));
                                        }
                                    }
                                    return 0 /* False */;
                                }
                            }
                            else if (targetPropFlags & 16 /* Protected */) {
                                var sourceDeclaredInClass = sourceProp⚠️<i><b title="LoadNamedGeneric">.parent</b></i> && sourceProp⚠️<i><b title="LoadNamedGeneric">.parent</b></i>⚠️<i><b title="LoadNamedGeneric">.flags</b></i> ⚠️<i><b title="Bitwise">& 32</b></i> /* Class */;
                                var sourceClass = sourceDeclaredInClass ? 🔶<i><b title="Did not inline: target text too big">getDeclaredTypeOfSymbol</b></i>(🔶️<i><b title="CallWithDescriptor">getParentOfSymbol</b></i>(sourceProp)) : undefined;
                                var targetClass = 🔶<i><b title="Did not inline: target text too big">getDeclaredTypeOfSymbol</b></i>(🔶️<i><b title="CallWithDescriptor">getParentOfSymbol</b></i>(targetProp));
                                if (!sourceClass || !🔶️<i><b title="CallWithDescriptor">hasBaseType</b></i>(sourceClass, targetClass)) {
                                    if (reportErrors) {
                                        🔶️<i><b title="CallWithDescriptor">reportError</b></i>(ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Property_0_is_protected_but_type_1_is_not_a_class_derived_from_2</b></i>, 🔶️<i><b title="CallWithDescriptor">symbolToString</b></i>(targetProp), 🔶️<i><b title="CallWithDescriptor">typeToString</b></i>(sourceClass || source), 🔶️<i><b title="CallWithDescriptor">typeToString</b></i>(targetClass));
                                    }
                                    return 0 /* False */;
                                }
                            }
                            else if (sourcePropFlags & 16 /* Protected */) {
                                if (reportErrors) {
                                    🔶️<i><b title="CallWithDescriptor">reportError</b></i>(ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Property_0_is_protected_in_type_1_but_public_in_type_2</b></i>, 🔶️<i><b title="CallWithDescriptor">symbolToString</b></i>(targetProp), 🔶️<i><b title="CallWithDescriptor">typeToString</b></i>(source), 🔶️<i><b title="CallWithDescriptor">typeToString</b></i>(target));
                                }
                                return 0 /* False */;
                            }
                            var related = 🔶<i><b title="Did not inline: unknown">isRelatedTo</b></i>(🔶<i><b title="Did not inline: target text too big">getTypeOfSymbol</b></i>(sourceProp), 🔶<i><b title="Did not inline: target text too big">getTypeOfSymbol</b></i>(targetProp), reportErrors);
                            if (!related) {
                                if (reportErrors) {
                                    🔶️<i><b title="CallWithDescriptor">reportError</b></i>(ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Types_of_property_0_are_incompatible</b></i>, 🔶️<i><b title="CallWithDescriptor">symbolToString</b></i>(targetProp));
                                }
                                return 0 /* False */;
                            }
                            result &= related;
                            // When checking for comparability, be more lenient with optional properties.
                            if (relation !== comparableRelation && sourceProp.flags & 536870912 /* Optional */ && !(targetProp.flags & 536870912 /* Optional */)) {
                                // TypeScript 1.0 spec (April 2014): 3.8.3
                                // S is a subtype of a type T, and T is a supertype of S if ...
                                // S' and T are object types and, for each member M in T..
                                // M is a property and S' contains a property N where
                                // if M is a required property, N is also a required property
                                // (M - property in T)
                                // (N - property in S)
                                if (reportErrors) {
                                    🔶️<i><b title="CallWithDescriptor">reportError</b></i>(ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Property_0_is_optional_in_type_1_but_required_in_type_2</b></i>, 🔶️<i><b title="CallWithDescriptor">symbolToString</b></i>(targetProp), 🔶️<i><b title="CallWithDescriptor">typeToString</b></i>(source), 🔶️<i><b title="CallWithDescriptor">typeToString</b></i>(target));
                                }
                                return 0 /* False */;
                            }
                        }
                    }
                }
                return result;
            }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getPropertiesOfObjectType</summary>
<pre class="code">
(type) {
            if (type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 32768 /* Object */) {
                return 🔶<i><b title="Did not inline: target text too big">resolveStructuredTypeMembers</b></i>(type)⚠️<i><b title="LoadNamedGeneric">.properties</b></i>;
            }
            return emptyArray;
        }</pre>

</details>
<details>
<summary>getDeclarationModifierFlagsFromSymbol</summary>
<pre class="code">
(s) {
            return s⚠️<i><b title="LoadNamedGeneric">.valueDeclaration</b></i> ? ts.🔶<i><b title="Did not inline: unknown">getCombinedModifierFlags</b></i>(s⚠️<i><b title="LoadNamedGeneric">.valueDeclaration</b></i>) : s⚠️<i><b title="LoadNamedGeneric">.flags</b></i> ⚠️<i><b title="Bitwise">& 134217728</b></i> /* Prototype */ ? 4 /* Public */ | 32 /* Static */ : 0;
        }</pre>

</details>
<details>
<summary>getDeclarationModifierFlagsFromSymbol</summary>
<pre class="code">
(s) {
            return s⚠️<i><b title="LoadNamedGeneric">.valueDeclaration</b></i> ? ts.🔶<i><b title="Did not inline: unknown">getCombinedModifierFlags</b></i>(s⚠️<i><b title="LoadNamedGeneric">.valueDeclaration</b></i>) : s⚠️<i><b title="LoadNamedGeneric">.flags</b></i> ⚠️<i><b title="Bitwise">& 134217728</b></i> /* Prototype */ ? 4 /* Public */ | 32 /* Static */ : 0;
        }</pre>

</details>
</blockquote>



### getConstraintOfTypeParameter:
<pre class="code">
(typeParameter) {
            if (!typeParameter.constraint) {
                if (typeParameter.target) {
                    var targetConstraint = 🔶<i><b title="Did not inline: target text too big">getConstraintOfTypeParameter</b></i>(typeParameter⚠️<i><b title="LoadNamedGeneric">.target</b></i>);
                    typeParameter.constraint ⚠️<i><b title="StoreNamedGeneric">= targetConstraint</b></i> ? 🔶<i><b title="Did not inline: target text too big">instantiateType</b></i>(targetConstraint, typeParameter⚠️<i><b title="LoadNamedGeneric">.mapper</b></i>) : noConstraintType;
                }
                else {
                    var constraintDeclaration = <b title="Inlined">🔷getConstraintDeclaration</b>(typeParameter);
                    var constraint = 🔶<i><b title="Did not inline: target text too big">getTypeFromTypeNode</b></i>(constraintDeclaration);
                    if (<b title="Inlined">🔷hasConstraintReferenceTo</b>(constraint, typeParameter)) {
                        🔶️<i><b title="CallWithDescriptor">error</b></i>(constraintDeclaration, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Type_parameter_0_has_a_circular_constraint</b></i>, 🔶️<i><b title="CallWithDescriptor">typeToString</b></i>(typeParameter));
                        constraint = unknownType;
                    }
                    typeParameter.constraint ⚠️<i><b title="StoreNamedGeneric">= constraint</b></i>;
                }
            }
            return typeParameter.constraint === noConstraintType ? undefined : typeParameter.constraint;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getConstraintDeclaration</summary>
<pre class="code">
(type) {
            return ts.🔶<i><b title="Did not inline: unknown">getDeclarationOfKind</b></i>(type.symbol, 143 /* TypeParameter */).constraint;
        }</pre>

</details>
<details>
<summary>hasConstraintReferenceTo</summary>
<pre class="code">
(type, target) {
            var checked;
            while (type && type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 16384 /* TypeParameter */ && !(type.isThisType) && !ts.🔶️<i><b title="CallWithDescriptor">contains</b></i>(checked, type)) {
                if (type === target) {
                    return true;
                }
                (checked || (checked = [])).push(type);
                var constraintDeclaration = <b title="Inlined">🔷getConstraintDeclaration</b>(type);
                type = constraintDeclaration && 🔶<i><b title="Did not inline: target text too big">getTypeFromTypeNode</b></i>(constraintDeclaration);
            }
            return false;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getConstraintDeclaration</summary>
<pre class="code">
(type) {
            return ts.🔶<i><b title="Did not inline: unknown">getDeclarationOfKind</b></i>(type.symbol, 143 /* TypeParameter */).constraint;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### binarySearchTypes:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(types, type) {
            var low = 0;
            var high = types⚠️<i><b title="LoadNamedGeneric">.length</b></i> - 1;
            var typeId = type⚠️<i><b title="LoadNamedGeneric">.id</b></i>;
            while (low &lt;= high) {
                var middle = low + ((high - low) &gt;&gt; 1);
                var id = types⚠️<i><b title="LoadKeyedGeneric">[middle]</b></i>⚠️<i><b title="LoadNamedGeneric">.id</b></i>;
                if (id === typeId) {
                    return middle;
                }
                else if (id &gt; typeId) {
                    high = middle - 1;
                }
                else {
                    low = middle + 1;
                }
            }
            return ~low;
        }</pre>



### createLiteralType:
<pre class="code">
(flags, text) {
            var type = <b title="Inlined">🔷createType</b>(flags);
            type.text = text;
            return type;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createType</summary>
<pre class="code">
(flags) {
            var result = <b title="Inlined">🔷new Type</b>(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new Type</summary>
<pre class="code">
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### getNamedMembers:
<pre class="code">
(members) {
            var result;
            🔶️<i><b title="CallWithDescriptor">for</b></i> (var id in members) {
                if (!<b title="Inlined">🔷isReservedMemberName</b>(id)) {
                    if (!result)
                        result = [];
                    var symbol = members⚠️<i><b title="LoadKeyedGeneric">[id]</b></i>;
                    if (🔶<i><b title="Did not inline: target text too big">symbolIsValue</b></i>(symbol)) {
                        result.push(symbol);
                    }
                }
            }
            return result || emptyArray;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>isReservedMemberName</summary>
<pre class="code">
(name) {
            return name.charCodeAt(0) === 95 /* _ */ &&
                name.charCodeAt(1) === 95 /* _ */ &&
                name.charCodeAt(2) !== 95 /* _ */ &&
                name.charCodeAt(2) !== 64 /* at */;
        }</pre>

</details>
</blockquote>



### ⛔ checkTypeAssignableTo (deoptimizated):
<pre class="code">
(source, target, errorNode, headMessage, containingMessageChain) {
            return 🔶<i><b title="Did not inline: target text too big">checkTypeRelatedTo</b></i>(source, target, assignableRelation, errorNode, headMessage, containingMessageChain);
        }</pre>

```diff
- Deopt: <JS Function (SharedFunctionInfo 0x371f85c14051)> (opt #428) @2, FP to SP delta: 24, caller sp: 0x7fff5fbfde08
```



### isGenericMappedType:
<pre class="code">
(type) {
            if (<b title="Inlined">🔷getObjectFlags</b>(type) & 32 /* Mapped */) {
                var constraintType = 🔶️<i><b title="CallWithDescriptor">getConstraintTypeFromMappedType</b></i>(type);
                return 🔶️<i><b title="CallWithDescriptor">maybeTypeOfKind</b></i>(constraintType, 540672 /* TypeVariable */ | 262144 /* Index */);
            }
            return false;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getObjectFlags</summary>
<pre class="code">
(type) {
            return type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 32768 /* Object */ ? type⚠️<i><b title="LoadNamedGeneric">.objectFlags</b></i> : 0;
        }</pre>

</details>
</blockquote>



### isConst:
<pre class="code">
(node) {
        return !!(ts.🔶<i><b title="Did not inline: unknown">getCombinedNodeFlags</b></i>(node) & 2 /* Const */)
            || !!(ts.🔶<i><b title="Did not inline: unknown">getCombinedModifierFlags</b></i>(node) & 2048 /* Const */);
    }</pre>



### isLet:
<pre class="code">
(node) {
        return !!(ts.🔶<i><b title="Did not inline: unknown">getCombinedNodeFlags</b></i>(node) & 1 /* Let */);
    }</pre>



### getNumNonRestParameters:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(signature) {
            var numParams = signature.parameters.length;
            return signature.hasRestParameter ?
                numParams - 1 :
                numParams;
        }</pre>



### getTypeOfParameter:
<pre class="code">
(symbol) {
            var type = 🔶<i><b title="Did not inline: target text too big">getTypeOfSymbol</b></i>(symbol);
            if (strictNullChecks) {
                var declaration = symbol⚠️<i><b title="LoadNamedGeneric">.valueDeclaration</b></i>;
                if (declaration && declaration⚠️<i><b title="LoadNamedGeneric">.initializer</b></i>) {
                    return 🔶️<i><b title="CallWithDescriptor">includeFalsyTypes</b></i>(type, 2048 /* Undefined */);
                }
            }
            return type;
        }</pre>



### map:
<pre class="code">
(array, f) {
        var result;
        if (array) {
            result = [];
            for (var i = 0; i &lt; array.length; i++) {
                result.push(🔶️<i><b title="CallWithDescriptor">f</b></i>(array[i], i));
            }
        }
        return result;
    }</pre>



### ⛔ addInheritedMembers (deoptimizated):
<div>~recompile~</div>

```diff
- Deopt: <JS Function getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode (SharedFunctionInfo 0x2e2f693f4bc1)> (opt #421) @36, FP to SP delta: 168, caller sp: 0x7fff5fbfda30
```

<div>~recompile~</div>
<pre class="code">
(symbols, baseSymbols) {
            for (var _i = 0, baseSymbols_1 = baseSymbols; _i &lt; baseSymbols_1.length; _i++) {
                var s = baseSymbols_1[_i];
                if (!symbols⚠️<i><b title="LoadKeyedGeneric">[s</b></i>.name]) {
                    symbols[s.name] ⚠️<i><b title="StoreKeyedGeneric">= s</b></i>;
                }
            }
        }</pre>



### checkVariableStatement:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(node) {
            // Grammar checking
            🔶<i><b title="Did not inline: target text too big">checkGrammarDecorators</b></i>(node) || 🔶<i><b title="Did not inline: target text too big">checkGrammarModifiers</b></i>(node) || <b title="Inlined">🔷checkGrammarVariableDeclarationList</b>(node.declarationList) || <b title="Inlined">🔷checkGrammarForDisallowedLetOrConstStatement</b>(node);
            ts.🔶<i><b title="Did not inline: unknown">forEach</b></i>(node.declarationList.declarations, checkSourceElement);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>checkGrammarVariableDeclarationList</summary>
<pre class="code">
(declarationList) {
            var declarations = declarationList.declarations;
            if (<b title="Inlined">🔷checkGrammarForDisallowedTrailingComma</b>(declarationList.declarations)) {
                return true;
            }
            if (!declarationList.declarations.length) {
                return 🔶️<i><b title="CallWithDescriptor">grammarErrorAtPos</b></i>(ts.🔶️<i><b title="CallWithDescriptor">getSourceFileOfNode</b></i>(declarationList), declarations⚠️<i><b title="LoadNamedGeneric">.pos</b></i>, declarations⚠️<i><b title="LoadNamedGeneric">.end</b></i> ⚠️<i><b title="Sub">- declarations</b></i>⚠️<i><b title="LoadNamedGeneric">.pos</b></i>, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Variable_declaration_list_cannot_be_empty</b></i>);
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>checkGrammarForDisallowedTrailingComma</summary>
<pre class="code">
(list) {
            if (list && list.hasTrailingComma) {
                var start = list⚠️<i><b title="LoadNamedGeneric">.end</b></i> ⚠️<i><b title="Sub">- ","</b></i>.length;
                var end = list⚠️<i><b title="LoadNamedGeneric">.end</b></i>;
                var sourceFile = ts.🔶️<i><b title="CallWithDescriptor">getSourceFileOfNode</b></i>(list⚠️<i><b title="LoadKeyedGeneric">[0]</b></i>);
                return 🔶️<i><b title="CallWithDescriptor">grammarErrorAtPos</b></i>(sourceFile, start, end ⚠️<i><b title="Sub">- start</b></i>, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Trailing_comma_not_allowed</b></i>);
            }
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>checkGrammarForDisallowedLetOrConstStatement</summary>
<pre class="code">
(node) {
            if (!<b title="Inlined">🔷allowLetAndConstDeclarations</b>(node.parent)) {
                if (ts.⚠️<i><b title="LoadNamedGeneric">isLet</b></i>(node⚠️<i><b title="LoadNamedGeneric">.declarationList</b></i>)) {
                    return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(node, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.let_declarations_can_only_be_declared_inside_a_block</b></i>);
                }
                else if (ts.🔶<i><b title="Did not inline: unknown">isConst</b></i>(node⚠️<i><b title="LoadNamedGeneric">.declarationList</b></i>)) {
                    return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(node, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.const_declarations_can_only_be_declared_inside_a_block</b></i>);
                }
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>allowLetAndConstDeclarations</summary>
<pre class="code">
(parent) {
            switch (parent.kind) {
                case 208 /* IfStatement */:
                case 209 /* DoStatement */:
                case 210 /* WhileStatement */:
                case 217 /* WithStatement */:
                case 211 /* ForStatement */:
                case 212 /* ForInStatement */:
                case 213 /* ForOfStatement */:
                    return false;
                case 219 /* LabeledStatement */:
                    return 🔶<i><b title="Did not inline: unknown">allowLetAndConstDeclarations</b></i>(parent⚠️<i><b title="LoadNamedGeneric">.parent</b></i>);
            }
            return true;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### checkVariableDeclaration:
<pre class="code">
(node) {
            🔶<i><b title="Did not inline: target text too big">checkGrammarVariableDeclaration</b></i>(node);
            return 🔶<i><b title="Did not inline: target text too big">checkVariableLikeDeclaration</b></i>(node);
        }</pre>



### check:
<pre class="code">
(type) {
                var target = <b title="Inlined">🔷getTargetType</b>(type);
                return target === checkBase || ts.🔶<i><b title="Did not inline: unknown">forEach</b></i>(🔶<i><b title="Did not inline: target text too big">getBaseTypes</b></i>(target), check);
            }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getTargetType</summary>
<pre class="code">
(type) {
            return <b title="Inlined">🔷getObjectFlags</b>(type) & 4 /* Reference */ ? type.target : type;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getObjectFlags</summary>
<pre class="code">
(type) {
            return type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 32768 /* Object */ ? type⚠️<i><b title="LoadNamedGeneric">.objectFlags</b></i> : 0;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### getTypeListId:
<pre class="code">
(types) {
            var result = "";
            if (types) {
                var length_3 = types⚠️<i><b title="LoadNamedGeneric">.length</b></i>;
                var i = 0;
                while (i &lt; length_3) {
                    var startId = types⚠️<i><b title="LoadKeyedGeneric">[i]</b></i>⚠️<i><b title="LoadNamedGeneric">.id</b></i>;
                    var count = 1;
                    while (i + count &lt; length_3 && types⚠️<i><b title="LoadKeyedGeneric">[i</b></i> + count]⚠️<i><b title="LoadNamedGeneric">.id</b></i> === startId + count) {
                        count++;
                    }
                    if (result.length) {
                        result += ",";
                    }
                    result +🔶️<i><b title="CallWithDescriptor">= startId</b></i>;
                    if (count &gt; 1) {
                        result += ":" 🔶️<i><b title="CallWithDescriptor">+ count</b></i>;
                    }
                    i += count;
                }
            }
            return result;
        }</pre>



### checkGrammarHeritageClause:
<pre class="code">
(node) {
            var types = node.types;
            if (<b title="Inlined">🔷checkGrammarForDisallowedTrailingComma</b>(types)) {
                return true;
            }
            if (types && types.length === 0) {
                var listType = ts.🔶️<i><b title="CallWithDescriptor">tokenToString</b></i>(node⚠️<i><b title="LoadNamedGeneric">.token</b></i>);
                var sourceFile = ts.🔶️<i><b title="CallWithDescriptor">getSourceFileOfNode</b></i>(node);
                return 🔶️<i><b title="CallWithDescriptor">grammarErrorAtPos</b></i>(sourceFile, types⚠️<i><b title="LoadNamedGeneric">.pos</b></i>, 0, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">._0_list_cannot_be_empty</b></i>, listType);
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>checkGrammarForDisallowedTrailingComma</summary>
<pre class="code">
(list) {
            if (list && list.hasTrailingComma) {
                var start = list⚠️<i><b title="LoadNamedGeneric">.end</b></i> ⚠️<i><b title="Sub">- ","</b></i>.length;
                var end = list⚠️<i><b title="LoadNamedGeneric">.end</b></i>;
                var sourceFile = ts.🔶️<i><b title="CallWithDescriptor">getSourceFileOfNode</b></i>(list⚠️<i><b title="LoadKeyedGeneric">[0]</b></i>);
                return 🔶️<i><b title="CallWithDescriptor">grammarErrorAtPos</b></i>(sourceFile, start, end ⚠️<i><b title="Sub">- start</b></i>, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Trailing_comma_not_allowed</b></i>);
            }
        }</pre>

</details>
</blockquote>



### needCollisionCheckForIdentifier:
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(node, identifier, name) {
            if (!(identifier && identifier.text === name)) {
                return false;
            }
            if (node.kind === 147 /* PropertyDeclaration */ ||
                node.kind === 146 /* PropertySignature */ ||
                node.kind === 149 /* MethodDeclaration */ ||
                node.kind === 148 /* MethodSignature */ ||
                node.kind === 151 /* GetAccessor */ ||
                node.kind === 152 /* SetAccessor */) {
                // it is ok to have member named '_super' or '_this' - member access is always qualified
                return false;
            }
            if (ts.🔶<i><b title="Did not inline: unknown">isInAmbientContext</b></i>(node)) {
                // ambient context - no codegen impact
                return false;
            }
            var root = ts.🔶️<i><b title="CallWithDescriptor">getRootDeclaration</b></i>(node);
            if (root⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 144</b></i> /* Parameter */ && ts.🔶<i><b title="Did not inline: unknown">nodeIsMissing</b></i>(root⚠️<i><b title="LoadNamedGeneric">.parent</b></i>⚠️<i><b title="LoadNamedGeneric">.body</b></i>)) {
                // just an overload - no codegen impact
                return false;
            }
            return true;
        }</pre>



### getErasedSignature:
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(signature) {
            if (!signature.typeParameters)
                return signature;
            if (!signature.erasedSignatureCache) {
                signature.erasedSignatureCache ⚠️<i><b title="StoreNamedGeneric">= instantiateSignature</b></i>(signature, <b title="Inlined">🔷createTypeEraser</b>(signature.typeParameters), /*eraseTypeParameters*/ true);
            }
            return signature.erasedSignatureCache;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createTypeEraser</summary>
<pre class="code">
(sources) {
            return <b title="Inlined">🔷createTypeMapper</b>(sources, undefined);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createTypeMapper</summary>
<pre class="code">
(sources, targets) {
            var count = sources.length;
            var mapper = count == 1 ? 🔶<i><b title="Did not inline: target has context-allocated variables">createUnaryTypeMapper</b></i>(sources[0], targets ? targets⚠️<i><b title="LoadKeyedGeneric">[0]</b></i> : anyType) :
                count == 2 ? 🔶️<i><b title="CallWithDescriptor">createBinaryTypeMapper</b></i>(sources[0], targets ? targets⚠️<i><b title="LoadKeyedGeneric">[0]</b></i> : anyType, sources[1], targets ? targets⚠️<i><b title="LoadKeyedGeneric">[1]</b></i> : anyType) :
                    🔶️<i><b title="CallWithDescriptor">createArrayTypeMapper</b></i>(sources, targets);
            mapper.mappedTypes ⚠️<i><b title="StoreNamedGeneric">= sources</b></i>;
            return mapper;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### getNumParametersToCheckForSignatureRelatability:
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(source, sourceNonRestParamCount, target, targetNonRestParamCount) {
            if (source.hasRestParameter ⚠️<i><b title="CompareGeneric">=== target</b></i>.hasRestParameter) {
                if (source.hasRestParameter) {
                    // If both have rest parameters, get the max and add 1 to
                    // compensate for the rest parameter.
                    return Math.max(sourceNonRestParamCount, targetNonRestParamCount) + 1;
                }
                else {
                    return Math.min(sourceNonRestParamCount, targetNonRestParamCount);
                }
            }
            else {
                // Return the count for whichever signature doesn't have rest parameters.
                return source.hasRestParameter ?
                    targetNonRestParamCount :
                    sourceNonRestParamCount;
            }
        }</pre>



### removeRedundantLiteralTypes:
<pre class="code">
(types) {
            var i = types.length;
            while (i &gt; 0) {
                i--;
                var t = types[i];
                var remove = t.flags & 32 /* StringLiteral */ && types.containsString ||
                    t.flags & 64 /* NumberLiteral */ && types⚠️<i><b title="LoadNamedGeneric">.containsNumber</b></i> ||
                    t.flags & 96 /* StringOrNumberLiteral */ && t.flags & 1048576 /* FreshLiteral */ && 🔶<i><b title="Did not inline: unknown">containsType</b></i>(types, t⚠️<i><b title="LoadNamedGeneric">.regularType</b></i>);
                if (remove) {
                    ts.🔶️<i><b title="CallWithDescriptor">orderedRemoveItemAt</b></i>(types, i);
                }
            }
        }</pre>



### isTypeAssignableTo:
<pre class="code">
(source, target) {
            return 🔶<i><b title="Did not inline: target text too big">isTypeRelatedTo</b></i>(source, target, assignableRelation);
        }</pre>



### ⛔ addTypesToUnion (deoptimizated):
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(typeSet, types) {
            for (var _i = 0, types_4 = types; _i &lt; types_4.length; _i++) {
                var type = types_4[_i];
                🔶<i><b title="Did not inline: target text too big">addTypeToUnion</b></i>(typeSet, type);
            }
        }</pre>

```diff
- Deopt: <JS Function isAmbientModule (SharedFunctionInfo 0x3504a53cd0d9)> (opt #561) @4, FP to SP delta: 24, caller sp: 0x7fff5fbfdbf8
```

```diff
- Deopt: <JS Function checkGrammarVariableDeclaration (SharedFunctionInfo 0x1b98fbc14d11)> (opt #524) @30, FP to SP delta: 120, caller sp: 0x7fff5fbfd778
```



### instantiateSignatures:
<pre class="code">
(signatures, mapper) {
            return <b title="Inlined">🔷instantiateList</b>(signatures, mapper, instantiateSignature);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>instantiateList</summary>
<pre class="code">
(items, mapper, instantiator) {
            if (items && items.length) {
                var result = [];
                for (var _i = 0, items_1 = items; _i &lt; items_1.length; _i++) {
                    var v = items_1[_i];
                    result.push(🔶️<i><b title="CallWithDescriptor">instantiator</b></i>(v, mapper));
                }
                return result;
            }
            return items;
        }</pre>

</details>
</blockquote>



### instantiateIndexInfo:
<pre class="code">
(info, mapper) {
            return info && <b title="Inlined">🔷createIndexInfo</b>(🔶<i><b title="Did not inline: target text too big">instantiateType</b></i>(info.type, mapper), info.isReadonly, info.declaration);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createIndexInfo</summary>
<pre class="code">
(type, isReadonly, declaration) {
            return { type: type, isReadonly: isReadonly, declaration: declaration };
        }</pre>

</details>
</blockquote>



### getThisTypeOfSignature:
<pre class="code">
(signature) {
            if (signature.thisParameter) {
                return 🔶<i><b title="Did not inline: target text too big">getTypeOfSymbol</b></i>(signature.thisParameter);
            }
        }</pre>



### instantiateTypeNoAlias:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(type, mapper) {
            if (type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 16384 /* TypeParameter */) {
                return 🔶️<i><b title="CallWithDescriptor">mapper</b></i>(type);
            }
            if (type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 32768 /* Object */) {
                if (type⚠️<i><b title="LoadNamedGeneric">.objectFlags</b></i> & 16 /* Anonymous */) {
                    // If the anonymous type originates in a declaration of a function, method, class, or
                    // interface, in an object type literal, or in an object literal expression, we may need
                    // to instantiate the type because it might reference a type parameter. We skip instantiation
                    // if none of the type parameters that are in scope in the type's declaration are mapped by
                    // the given mapper, however we can only do that analysis if the type isn't itself an
                    // instantiation.
                    return type.symbol &&
                        type.symbol.flags & (16 /* Function */ | 8192 /* Method */ | 32 /* Class */ | 2048 /* TypeLiteral */ | 4096 /* ObjectLiteral */) &&
                        (type.objectFlags & 64 /* Instantiated */ || 🔶<i><b title="Did not inline: target text too big">isSymbolInScopeOfMappedTypeParameter</b></i>(type.symbol, mapper)) ?
                        <b title="Inlined">🔷instantiateCached</b>(type, mapper, instantiateAnonymousType) : type;
                }
                if (type⚠️<i><b title="LoadNamedGeneric">.objectFlags</b></i> & 32 /* Mapped */) {
                    return <b title="Inlined">🔷instantiateCached</b>(type, mapper, instantiateMappedType);
                }
                if (type⚠️<i><b title="LoadNamedGeneric">.objectFlags</b></i> & 4 /* Reference */) {
                    return <b title="Inlined">🔷createTypeReference</b>(type⚠️<i><b title="LoadNamedGeneric">.target</b></i>, <b title="Inlined">🔷instantiateTypes</b>(type.typeArguments, mapper));
                }
            }
            if (type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 65536 /* Union */ && !(type.flags & 8190 /* Primitive */)) {
                return 🔶<i><b title="Did not inline: target text too big">getUnionType</b></i>(<b title="Inlined">🔷instantiateTypes</b>(type.types, mapper), /*subtypeReduction*/ false, type.aliasSymbol, <b title="Inlined">🔷instantiateTypes</b>(type.aliasTypeArguments, mapper));
            }
            if (type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 131072 /* Intersection */) {
                return 🔶️<i><b title="CallWithDescriptor">getIntersectionType</b></i>(🔶<i><b title="Did not inline: unknown">instantiateTypes</b></i>(type⚠️<i><b title="LoadNamedGeneric">.types</b></i>, mapper), type⚠️<i><b title="LoadNamedGeneric">.aliasSymbol</b></i>, 🔶<i><b title="Did not inline: unknown">instantiateTypes</b></i>(type⚠️<i><b title="LoadNamedGeneric">.aliasTypeArguments</b></i>, mapper));
            }
            if (type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 262144 /* Index */) {
                return 🔶<i><b title="Did not inline: unknown">getIndexType</b></i>(🔶<i><b title="Did not inline: target text too big">instantiateType</b></i>(type⚠️<i><b title="LoadNamedGeneric">.type</b></i>, mapper));
            }
            if (type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 524288 /* IndexedAccess */) {
                return 🔶️<i><b title="CallWithDescriptor">getIndexedAccessType</b></i>(🔶<i><b title="Did not inline: target text too big">instantiateType</b></i>(type.objectType, mapper), 🔶<i><b title="Did not inline: target text too big">instantiateType</b></i>(type.indexType, mapper));
            }
            return type;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>instantiateCached</summary>
<pre class="code">
(type, mapper, instantiator) {
            var instantiations = mapper.instantiations || (mapper.instantiations = []);
            return instantiations⚠️<i><b title="LoadKeyedGeneric">[type</b></i>.id] || (instantiations[type.id] ⚠️<i><b title="StoreKeyedGeneric">= instantiator</b></i>(type, mapper));
        }</pre>

</details>
<details>
<summary>instantiateCached</summary>
<pre class="code">
(type, mapper, instantiator) {
            var instantiations = mapper.instantiations || (mapper.instantiations = []);
            return instantiations⚠️<i><b title="LoadKeyedGeneric">[type</b></i>.id] || (instantiations[type.id] ⚠️<i><b title="StoreKeyedGeneric">= instantiator</b></i>(type, mapper));
        }</pre>

</details>
<details>
<summary>instantiateTypes</summary>
<pre class="code">
(types, mapper) {
            return <b title="Inlined">🔷instantiateList</b>(types, mapper, instantiateType);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>instantiateList</summary>
<pre class="code">
(items, mapper, instantiator) {
            if (items && items.length) {
                var result = [];
                for (var _i = 0, items_1 = items; _i &lt; items_1.length; _i++) {
                    var v = items_1[_i];
                    result.push(🔶️<i><b title="CallWithDescriptor">instantiator</b></i>(v, mapper));
                }
                return result;
            }
            return items;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>createTypeReference</summary>
<pre class="code">
(target, typeArguments) {
            var id = 🔶<i><b title="Did not inline: target text too big">getTypeListId</b></i>(typeArguments);
            var type = target⚠️<i><b title="LoadNamedGeneric">.instantiations</b></i>⚠️<i><b title="LoadKeyedGeneric">[id]</b></i>;
            if (!type) {
                type = target⚠️<i><b title="LoadNamedGeneric">.instantiations</b></i>[id] ⚠️<i><b title="StoreKeyedGeneric">= createObjectType</b></i>(4 /* Reference */, target⚠️<i><b title="LoadNamedGeneric">.symbol</b></i>);
                type.flags |= typeArguments ? <b title="Inlined">🔷getPropagatingFlagsOfTypes</b>(typeArguments, /*excludeKinds*/ 0) : 0;
                type.target = target;
                type.typeArguments = typeArguments;
            }
            return type;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createObjectType</summary>
<pre class="code">
(objectFlags, symbol) {
            var type = <b title="Inlined">🔷createType</b>(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol ⚠️<i><b title="StoreNamedGeneric">= symbol</b></i>;
            return type;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createType</summary>
<pre class="code">
(flags) {
            var result = <b title="Inlined">🔷new Type</b>(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new Type</summary>
<pre class="code">
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>getPropagatingFlagsOfTypes</summary>
<pre class="code">
(types, excludeKinds) {
            var result = 0;
            for (var _i = 0, types_3 = types; _i &lt; types_3⚠️<i><b title="LoadNamedGeneric">.length</b></i>; _i++) {
                var type = types_3⚠️<i><b title="LoadKeyedGeneric">[_i]</b></i>;
                if (!(type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & excludeKinds)) {
                    result |= type⚠️<i><b title="LoadNamedGeneric">.flags</b></i>;
                }
            }
            return result & 14680064 /* PropagatingFlags */;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>instantiateTypes</summary>
<pre class="code">
(types, mapper) {
            return <b title="Inlined">🔷instantiateList</b>(types, mapper, instantiateType);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>instantiateList</summary>
<pre class="code">
(items, mapper, instantiator) {
            if (items && items.length) {
                var result = [];
                for (var _i = 0, items_1 = items; _i &lt; items_1.length; _i++) {
                    var v = items_1[_i];
                    result.push(🔶️<i><b title="CallWithDescriptor">instantiator</b></i>(v, mapper));
                }
                return result;
            }
            return items;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>instantiateTypes</summary>
<pre class="code">
(types, mapper) {
            return <b title="Inlined">🔷instantiateList</b>(types, mapper, instantiateType);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>instantiateList</summary>
<pre class="code">
(items, mapper, instantiator) {
            if (items && items.length) {
                var result = [];
                for (var _i = 0, items_1 = items; _i &lt; items_1.length; _i++) {
                    var v = items_1[_i];
                    result.push(🔶️<i><b title="CallWithDescriptor">instantiator</b></i>(v, mapper));
                }
                return result;
            }
            return items;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### isTypeAny:
<pre class="code">
(type) {
            return type && (type.flags & 1 /* Any */) !== 0;
        }</pre>



### indexTypesRelatedTo:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(source, originalSource, target, kind, reportErrors) {
                if (relation === identityRelation) {
                    return 🔶️<i><b title="CallWithDescriptor">indexTypesIdenticalTo</b></i>(source, target, kind);
                }
                var targetInfo = <b title="Inlined">🔷getIndexInfoOfType</b>(target, kind);
                if (!targetInfo || ((targetInfo.type.flags & 1 /* Any */) && !(originalSource⚠️<i><b title="LoadNamedGeneric">.flags</b></i> ⚠️<i><b title="Bitwise">& 8190</b></i> /* Primitive */))) {
                    // Index signature of type any permits assignment from everything but primitives
                    return -1 /* True */;
                }
                var sourceInfo = <b title="Inlined">🔷getIndexInfoOfType</b>(source, kind) ||
                    kind ⚠️<i><b title="CompareGeneric">=== 1</b></i> /* Number */ && 🔶<i><b title="Did not inline: unknown">getIndexInfoOfType</b></i>(source, 0 /* String */);
                if (sourceInfo) {
                    return 🔶️<i><b title="CallWithDescriptor">indexInfoRelatedTo</b></i>(sourceInfo, targetInfo, reportErrors);
                }
                if (🔶️<i><b title="CallWithDescriptor">isObjectLiteralType</b></i>(source)) {
                    var related = -1 /* True */;
                    if (kind ⚠️<i><b title="CompareGeneric">=== 0</b></i> /* String */) {
                        var sourceNumberInfo = 🔶<i><b title="Did not inline: unknown">getIndexInfoOfType</b></i>(source, 1 /* Number */);
                        if (sourceNumberInfo) {
                            related = 🔶️<i><b title="CallWithDescriptor">indexInfoRelatedTo</b></i>(sourceNumberInfo, targetInfo, reportErrors);
                        }
                    }
                    if (related) {
                        related &⚠️<i><b title="Bitwise">= eachPropertyRelatedTo</b></i>(source, targetInfo⚠️<i><b title="LoadNamedGeneric">.type</b></i>, kind, reportErrors);
                    }
                    return related;
                }
                if (reportErrors) {
                    🔶️<i><b title="CallWithDescriptor">reportError</b></i>(ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Index_signature_is_missing_in_type_0</b></i>, 🔶️<i><b title="CallWithDescriptor">typeToString</b></i>(source));
                }
                return 0 /* False */;
            }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getIndexInfoOfType</summary>
<pre class="code">
(type, kind) {
            return <b title="Inlined">🔷getIndexInfoOfStructuredType</b>(<b title="Inlined">🔷getApparentType</b>(type), kind);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getApparentType</summary>
<pre class="code">
(type) {
            var t = type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 540672 /* TypeVariable */ ? 🔶️<i><b title="CallWithDescriptor">getApparentTypeOfTypeVariable</b></i>(type) : type;
            return t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 262178 /* StringLike */ ? globalStringType :
                t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 340 /* NumberLike */ ? globalNumberType :
                    t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 136 /* BooleanLike */ ? globalBooleanType :
                        t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 512 /* ESSymbol */ ? 🔶️<i><b title="CallWithDescriptor">getGlobalESSymbolType</b></i>() :
                            t;
        }</pre>

</details>
<details>
<summary>getIndexInfoOfStructuredType</summary>
<pre class="code">
(type, kind) {
            if (type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 229376 /* StructuredType */) {
                var resolved = 🔶<i><b title="Did not inline: target text too big">resolveStructuredTypeMembers</b></i>(type);
                return kind === 0 /* String */ ? resolved⚠️<i><b title="LoadNamedGeneric">.stringIndexInfo</b></i> : resolved⚠️<i><b title="LoadNamedGeneric">.numberIndexInfo</b></i>;
            }
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>getIndexInfoOfType</summary>
<pre class="code">
(type, kind) {
            return <b title="Inlined">🔷getIndexInfoOfStructuredType</b>(<b title="Inlined">🔷getApparentType</b>(type), kind);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getApparentType</summary>
<pre class="code">
(type) {
            var t = type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 540672 /* TypeVariable */ ? 🔶️<i><b title="CallWithDescriptor">getApparentTypeOfTypeVariable</b></i>(type) : type;
            return t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 262178 /* StringLike */ ? globalStringType :
                t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 340 /* NumberLike */ ? globalNumberType :
                    t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 136 /* BooleanLike */ ? globalBooleanType :
                        t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 512 /* ESSymbol */ ? 🔶️<i><b title="CallWithDescriptor">getGlobalESSymbolType</b></i>() :
                            t;
        }</pre>

</details>
<details>
<summary>getIndexInfoOfStructuredType</summary>
<pre class="code">
(type, kind) {
            if (type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 229376 /* StructuredType */) {
                var resolved = 🔶<i><b title="Did not inline: target text too big">resolveStructuredTypeMembers</b></i>(type);
                return kind === 0 /* String */ ? resolved⚠️<i><b title="LoadNamedGeneric">.stringIndexInfo</b></i> : resolved⚠️<i><b title="LoadNamedGeneric">.numberIndexInfo</b></i>;
            }
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### checkTypeRelatedTo:
<pre class="code">
(source, target, relation, errorNode, headMessage, containingMessageChain) {
            var errorInfo;
            var sourceStack;
            var targetStack;
            var maybeStack;
            var expandingFlags;
            var depth = 0;
            var overflow = false;
            ts⚠️<i><b title="LoadNamedGeneric">.Debug</b></i>.🔶️<i><b title="CallWithDescriptor">assert</b></i>(relation !== identityRelation || !errorNode, "no error reporting in identity checking");
            var result = 🔶<i><b title="Did not inline: unknown">isRelatedTo</b></i>(source, target, /*reportErrors*/ !!errorNode, headMessage);
            if (overflow) {
                🔶️<i><b title="CallWithDescriptor">error</b></i>(errorNode, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Excessive_stack_depth_comparing_types_0_and_1</b></i>, 🔶️<i><b title="CallWithDescriptor">typeToString</b></i>(source), 🔶️<i><b title="CallWithDescriptor">typeToString</b></i>(target));
            }
            else if (errorInfo) {
                if (containingMessageChain) {
                    errorInfo = ts.🔶️<i><b title="CallWithDescriptor">concatenateDiagnosticMessageChains</b></i>(containingMessageChain, errorInfo);
                }
                diagnostics.🔶️<i><b title="CallWithDescriptor">add</b></i>(ts.🔶️<i><b title="CallWithDescriptor">createDiagnosticForNodeFromMessageChain</b></i>(errorNode, errorInfo));
            }
            return result !== 0 /* False */;
            🔶️<i><b title="CallWithDescriptor">function</b></i> reportError(message, arg0, arg1, arg2) {
                ts.Debug.assert(!!errorNode);
                errorInfo = ts.chainDiagnosticMessages(errorInfo, message, arg0, arg1, arg2);
            }
            🔶️<i><b title="CallWithDescriptor">function</b></i> reportRelationError(message, source, target) {
                var sourceType = typeToString(source);
                var targetType = typeToString(target);
                if (sourceType === targetType) {
                    sourceType = typeToString(source, /*enclosingDeclaration*/ undefined, 128 /* UseFullyQualifiedType */);
                    targetType = typeToString(target, /*enclosingDeclaration*/ undefined, 128 /* UseFullyQualifiedType */);
                }
                if (!message) {
                    if (relation === comparableRelation) {
                        message = ts.Diagnostics.Type_0_is_not_comparable_to_type_1;
                    }
                    else if (sourceType === targetType) {
                        message = ts.Diagnostics.Type_0_is_not_assignable_to_type_1_Two_different_types_with_this_name_exist_but_they_are_unrelated;
                    }
                    else {
                        message = ts.Diagnostics.Type_0_is_not_assignable_to_type_1;
                    }
                }
                reportError(message, sourceType, targetType);
            }
            🔶️<i><b title="CallWithDescriptor">function</b></i> tryElaborateErrorsForPrimitivesAndObjects(source, target) {
                var sourceType = typeToString(source);
                var targetType = typeToString(target);
                if ((globalStringType === source && stringType === target) ||
                    (globalNumberType === source && numberType === target) ||
                    (globalBooleanType === source && booleanType === target) ||
                    (getGlobalESSymbolType() === source && esSymbolType === target)) {
                    reportError(ts.Diagnostics._0_is_a_primitive_but_1_is_a_wrapper_object_Prefer_using_0_when_possible, targetType, sourceType);
                }
            }
            🔶️<i><b title="CallWithDescriptor">function</b></i> isUnionOrIntersectionTypeWithoutNullableConstituents(type) {
                if (!(type.flags & 196608 /* UnionOrIntersection */)) {
                    return false;
                }
                // at this point we know that this is union or intersection type possibly with nullable constituents.
                // check if we still will have compound type if we ignore nullable components.
                var seenNonNullable = false;
                for (var _i = 0, _a = type.types; _i &lt; _a.length; _i++) {
                    var t = _a[_i];
                    if (t.flags & 6144 /* Nullable */) {
                        continue;
                    }
                    if (seenNonNullable) {
                        return true;
                    }
                    seenNonNullable = true;
                }
                return false;
            }
            // Compare two types and return
            // Ternary.True if they are related with no assumptions,
            // Ternary.Maybe if they are related with assumptions of other relationships, or
            // Ternary.False if they are not related.
            🔶️<i><b title="CallWithDescriptor">function</b></i> isRelatedTo(source, target, reportErrors, headMessage) {
                var result;
                if (source.flags & 96 /* StringOrNumberLiteral */ && source.flags & 1048576 /* FreshLiteral */) {
                    source = source.regularType;
                }
                if (target.flags & 96 /* StringOrNumberLiteral */ && target.flags & 1048576 /* FreshLiteral */) {
                    target = target.regularType;
                }
                // both types are the same - covers 'they are the same primitive type or both are Any' or the same type parameter cases
                if (source === target)
                    return -1 /* True */;
                if (relation === identityRelation) {
                    return isIdenticalTo(source, target);
                }
                if (isSimpleTypeRelatedTo(source, target, relation, reportErrors ? reportError : undefined))
                    return -1 /* True */;
                if (getObjectFlags(source) & 128 /* ObjectLiteral */ && source.flags & 1048576 /* FreshLiteral */) {
                    if (hasExcessProperties(source, target, reportErrors)) {
                        if (reportErrors) {
                            reportRelationError(headMessage, source, target);
                        }
                        return 0 /* False */;
                    }
                    // Above we check for excess properties with respect to the entire target type. When union
                    // and intersection types are further deconstructed on the target side, we don't want to
                    // make the check again (as it might fail for a partial target type). Therefore we obtain
                    // the regular source type and proceed with that.
                    if (isUnionOrIntersectionTypeWithoutNullableConstituents(target)) {
                        source = getRegularTypeOfObjectLiteral(source);
                    }
                }
                var saveErrorInfo = errorInfo;
                // Note that these checks are specifically ordered to produce correct results. In particular,
                // we need to deconstruct unions before intersections (because unions are always at the top),
                // and we need to handle "each" relations before "some" relations for the same kind of type.
                if (source.flags & 65536 /* Union */) {
                    if (relation === comparableRelation) {
                        result = someTypeRelatedToType(source, target, reportErrors && !(source.flags & 8190 /* Primitive */));
                    }
                    else {
                        result = eachTypeRelatedToType(source, target, reportErrors && !(source.flags & 8190 /* Primitive */));
                    }
                    if (result) {
                        return result;
                    }
                }
                else if (target.flags & 65536 /* Union */) {
                    if (result = typeRelatedToSomeType(source, target, reportErrors && !(source.flags & 8190 /* Primitive */) && !(target.flags & 8190 /* Primitive */))) {
                        return result;
                    }
                }
                else if (target.flags & 131072 /* Intersection */) {
                    if (result = typeRelatedToEachType(source, target, reportErrors)) {
                        return result;
                    }
                }
                else if (source.flags & 131072 /* Intersection */) {
                    // Check to see if any constituents of the intersection are immediately related to the target.
                    //
                    // Don't report errors though. Checking whether a constituent is related to the source is not actually
                    // useful and leads to some confusing error messages. Instead it is better to let the below checks
                    // take care of this, or to not elaborate at all. For instance,
                    //
                    //    - For an object type (such as 'C = A & B'), users are usually more interested in structural errors.
                    //
                    //    - For a union type (such as '(A | B) = (C & D)'), it's better to hold onto the whole intersection
                    //          than to report that 'D' is not assignable to 'A' or 'B'.
                    //
                    //    - For a primitive type or type parameter (such as 'number = A & B') there is no point in
                    //          breaking the intersection apart.
                    if (result = someTypeRelatedToType(source, target, /*reportErrors*/ false)) {
                        return result;
                    }
                }
                else if (target.flags & 16384 /* TypeParameter */) {
                    // A source type { [P in keyof T]: X } is related to a target type T if X is related to T[P].
                    if (getObjectFlags(source) & 32 /* Mapped */ && getConstraintTypeFromMappedType(source) === getIndexType(target)) {
                        if (!source.declaration.questionToken) {
                            var templateType = getTemplateTypeFromMappedType(source);
                            var indexedAccessType = getIndexedAccessType(target, getTypeParameterFromMappedType(source));
                            if (result = isRelatedTo(templateType, indexedAccessType, reportErrors)) {
                                return result;
                            }
                        }
                    }
                    else {
                        // Given a type parameter K with a constraint keyof T, a type S is
                        // assignable to K if S is assignable to keyof T.
                        var constraint = getConstraintOfTypeParameter(target);
                        if (constraint && constraint.flags & 262144 /* Index */) {
                            if (result = isRelatedTo(source, constraint, reportErrors)) {
                                return result;
                            }
                        }
                    }
                }
                else if (target.flags & 262144 /* Index */) {
                    // A keyof S is related to a keyof T if T is related to S.
                    if (source.flags & 262144 /* Index */) {
                        if (result = isRelatedTo(target.type, source.type, /*reportErrors*/ false)) {
                            return result;
                        }
                    }
                    // Given a type variable T with a constraint C, a type S is assignable to
                    // keyof T if S is assignable to keyof C.
                    if (target.type.flags & 540672 /* TypeVariable */) {
                        var constraint = getConstraintOfTypeVariable(target.type);
                        if (constraint) {
                            if (result = isRelatedTo(source, getIndexType(constraint), reportErrors)) {
                                return result;
                            }
                        }
                    }
                }
                else if (target.flags & 524288 /* IndexedAccess */) {
                    // if we have indexed access types with identical index types, see if relationship holds for
                    // the two object types.
                    if (source.flags & 524288 /* IndexedAccess */ && source.indexType === target.indexType) {
                        if (result = isRelatedTo(source.objectType, target.objectType, reportErrors)) {
                            return result;
                        }
                    }
                    // A type S is related to a type T[K] if S is related to A[K], where K is string-like and
                    // A is the apparent type of S.
                    if (target.constraint) {
                        if (result = isRelatedTo(source, target.constraint, reportErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                }
                if (source.flags & 16384 /* TypeParameter */) {
                    // A source type T is related to a target type { [P in keyof T]: X } if T[P] is related to X.
                    if (getObjectFlags(target) & 32 /* Mapped */ && getConstraintTypeFromMappedType(target) === getIndexType(source)) {
                        var indexedAccessType = getIndexedAccessType(source, getTypeParameterFromMappedType(target));
                        var templateType = getTemplateTypeFromMappedType(target);
                        if (result = isRelatedTo(indexedAccessType, templateType, reportErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                    else {
                        var constraint = getConstraintOfTypeParameter(source);
                        if (!constraint || constraint.flags & 1 /* Any */) {
                            constraint = emptyObjectType;
                        }
                        // The constraint may need to be further instantiated with its 'this' type.
                        constraint = getTypeWithThisArgument(constraint, source);
                        // Report constraint errors only if the constraint is not the empty object type
                        var reportConstraintErrors = reportErrors && constraint !== emptyObjectType;
                        if (result = isRelatedTo(constraint, target, reportConstraintErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                }
                else if (source.flags & 524288 /* IndexedAccess */) {
                    // A type S[K] is related to a type T if A[K] is related to T, where K is string-like and
                    // A is the apparent type of S.
                    if (source.constraint) {
                        if (result = isRelatedTo(source.constraint, target, reportErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                }
                else {
                    if (getObjectFlags(source) & 4 /* Reference */ && getObjectFlags(target) & 4 /* Reference */ && source.target === target.target) {
                        // We have type references to same target type, see if relationship holds for all type arguments
                        if (result = typeArgumentsRelatedTo(source, target, reportErrors)) {
                            return result;
                        }
                    }
                    // Even if relationship doesn't hold for unions, intersections, or generic type references,
                    // it may hold in a structural comparison.
                    var apparentSource = getApparentType(source);
                    // In a check of the form X = A & B, we will have previously checked if A relates to X or B relates
                    // to X. Failing both of those we want to check if the aggregation of A and B's members structurally
                    // relates to X. Thus, we include intersection types on the source side here.
                    if (apparentSource.flags & (32768 /* Object */ | 131072 /* Intersection */) && target.flags & 32768 /* Object */) {
                        // Report structural errors only if we haven't reported any errors yet
                        var reportStructuralErrors = reportErrors && errorInfo === saveErrorInfo && !(source.flags & 8190 /* Primitive */);
                        if (result = objectTypeRelatedTo(apparentSource, source, target, reportStructuralErrors)) {
                            errorInfo = saveErrorInfo;
                            return result;
                        }
                    }
                }
                if (reportErrors) {
                    if (source.flags & 32768 /* Object */ && target.flags & 8190 /* Primitive */) {
                        tryElaborateErrorsForPrimitivesAndObjects(source, target);
                    }
                    else if (source.symbol && source.flags & 32768 /* Object */ && globalObjectType === source) {
                        reportError(ts.Diagnostics.The_Object_type_is_assignable_to_very_few_other_types_Did_you_mean_to_use_the_any_type_instead);
                    }
                    reportRelationError(headMessage, source, target);
                }
                return 0 /* False */;
            }
            🔶️<i><b title="CallWithDescriptor">function</b></i> isIdenticalTo(source, target) {
                var result;
                if (source.flags & 32768 /* Object */ && target.flags & 32768 /* Object */) {
                    if (getObjectFlags(source) & 4 /* Reference */ && getObjectFlags(target) & 4 /* Reference */ && source.target === target.target) {
                        // We have type references to same target type, see if all type arguments are identical
                        if (result = typeArgumentsRelatedTo(source, target, /*reportErrors*/ false)) {
                            return result;
                        }
                    }
                    return objectTypeRelatedTo(source, source, target, /*reportErrors*/ false);
                }
                if (source.flags & 65536 /* Union */ && target.flags & 65536 /* Union */ ||
                    source.flags & 131072 /* Intersection */ && target.flags & 131072 /* Intersection */) {
                    if (result = eachTypeRelatedToSomeType(source, target)) {
                        if (result &= eachTypeRelatedToSomeType(target, source)) {
                            return result;
                        }
                    }
                }
                return 0 /* False */;
            }
            // Check if a property with the given name is known anywhere in the given type. In an object type, a property
            // is considered known if the object type is empty and the check is for assignability, if the object type has
            // index signatures, or if the property is actually declared in the object type. In a union or intersection
            // type, a property is considered known if it is known in any constituent type.
            🔶️<i><b title="CallWithDescriptor">function</b></i> isKnownProperty(type, name) {
                if (type.flags & 32768 /* Object */) {
                    var resolved = resolveStructuredTypeMembers(type);
                    if ((relation === assignableRelation || relation === comparableRelation) && (type === globalObjectType || isEmptyObjectType(resolved)) ||
                        resolved.stringIndexInfo ||
                        (resolved.numberIndexInfo && isNumericLiteralName(name)) ||
                        getPropertyOfType(type, name)) {
                        return true;
                    }
                }
                else if (type.flags & 196608 /* UnionOrIntersection */) {
                    for (var _i = 0, _a = type.types; _i &lt; _a.length; _i++) {
                        var t = _a[_i];
                        if (isKnownProperty(t, name)) {
                            return true;
                        }
                    }
                }
                return false;
            }
            🔶️<i><b title="CallWithDescriptor">function</b></i> isEmptyObjectType(t) {
                return t.properties.length === 0 &&
                    t.callSignatures.length === 0 &&
                    t.constructSignatures.length === 0 &&
                    !t.stringIndexInfo &&
                    !t.numberIndexInfo;
            }
            🔶️<i><b title="CallWithDescriptor">function</b></i> hasExcessProperties(source, target, reportErrors) {
                if (maybeTypeOfKind(target, 32768 /* Object */) && !(getObjectFlags(target) & 512 /* ObjectLiteralPatternWithComputedProperties */)) {
                    for (var _i = 0, _a = getPropertiesOfObjectType(source); _i &lt; _a.length; _i++) {
                        var prop = _a[_i];
                        if (!isKnownProperty(target, prop.name)) {
                            if (reportErrors) {
                                // We know *exactly* where things went wrong when comparing the types.
                                // Use this property as the error node as this will be more helpful in
                                // reasoning about what went wrong.
                                ts.Debug.assert(!!errorNode);
                                errorNode = prop.valueDeclaration;
                                reportError(ts.Diagnostics.Object_literal_may_only_specify_known_properties_and_0_does_not_exist_in_type_1, symbolToString(prop), typeToString(target));
                            }
                            return true;
                        }
                    }
                }
                return false;
            }
            🔶️<i><b title="CallWithDescriptor">function</b></i> eachTypeRelatedToSomeType(source, target) {
                var result = -1 /* True */;
                var sourceTypes = source.types;
                for (var _i = 0, sourceTypes_1 = sourceTypes; _i &lt; sourceTypes_1.length; _i++) {
                    var sourceType = sourceTypes_1[_i];
                    var related = typeRelatedToSomeType(sourceType, target, /*reportErrors*/ false);
                    if (!related) {
                        return 0 /* False */;
                    }
                    result &= related;
                }
                return result;
            }
            🔶️<i><b title="CallWithDescriptor">function</b></i> typeRelatedToSomeType(source, target, reportErrors) {
                var targetTypes = target.types;
                if (target.flags & 65536 /* Union */ && containsType(targetTypes, source)) {
                    return -1 /* True */;
                }
                var len = targetTypes.length;
                for (var i = 0; i &lt; len; i++) {
                    var related = isRelatedTo(source, targetTypes[i], reportErrors && i === len - 1);
                    if (related) {
                        return related;
                    }
                }
                return 0 /* False */;
            }
            🔶️<i><b title="CallWithDescriptor">function</b></i> typeRelatedToEachType(source, target, reportErrors) {
                var result = -1 /* True */;
                var targetTypes = target.types;
                for (var _i = 0, targetTypes_1 = targetTypes; _i &lt; targetTypes_1.length; _i++) {
                    var targetType = targetTypes_1[_i];
                    var related = isRelatedTo(source, targetType, reportErrors);
                    if (!related) {
                        return 0 /* False */;
                    }
                    result &= related;
                }
                return result;
            }
            🔶️<i><b title="CallWithDescriptor">function</b></i> someTypeRelatedToType(source, target, reportErrors) {
                var sourceTypes = source.types;
                if (source.flags & 65536 /* Union */ && containsType(sourceTypes, target)) {
                    return -1 /* True */;
                }
                var len = sourceTypes.length;
                for (var i = 0; i &lt; len; i++) {
                    var related = isRelatedTo(sourceTypes[i], target, reportErrors && i === len - 1);
                    if (related) {
                        return related;
                    }
                }
                return 0 /* False */;
            }
            🔶️<i><b title="CallWithDescriptor">function</b></i> eachTypeRelatedToType(source, target, reportErrors) {
                var result = -1 /* True */;
                var sourceTypes = source.types;
                for (var _i = 0, sourceTypes_2 = sourceTypes; _i &lt; sourceTypes_2.length; _i++) {
                    var sourceType = sourceTypes_2[_i];
                    var related = isRelatedTo(sourceType, target, reportErrors);
                    if (!related) {
                        return 0 /* False */;
                    }
                    result &= related;
                }
                return result;
            }
            🔶️<i><b title="CallWithDescriptor">function</b></i> typeArgumentsRelatedTo(source, target, reportErrors) {
                var sources = source.typeArguments || emptyArray;
                var targets = target.typeArguments || emptyArray;
                if (sources.length !== targets.length && relation === identityRelation) {
                    return 0 /* False */;
                }
                var length = sources.length &lt;= targets.length ? sources.length : targets.length;
                var result = -1 /* True */;
                for (var i = 0; i &lt; length; i++) {
                    var related = isRelatedTo(sources[i], targets[i], reportErrors);
                    if (!related) {
                        return 0 /* False */;
                    }
                    result &= related;
                }
                return result;
            }
            // Determine if two object types are related by structure. First, check if the result is already available in the global cache.
            // Second, check if we have already started a comparison of the given two types in which case we assume the result to be true.
            // Third, check if both types are part of deeply nested chains of generic type instantiations and if so assume the types are
            // equal and infinitely expanding. Fourth, if we have reached a depth of 100 nested comparisons, assume we have runaway recursion
            // and issue an error. Otherwise, actually compare the structure of the two types.
            🔶️<i><b title="CallWithDescriptor">function</b></i> objectTypeRelatedTo(source, originalSource, target, reportErrors) {
                if (overflow) {
                    return 0 /* False */;
                }
                var id = relation !== identityRelation || source.id &lt; target.id ? source.id + "," + target.id : target.id + "," + source.id;
                var related = relation[id];
                if (related !== undefined) {
                    if (reportErrors && related === 2 /* Failed */) {
                        // We are elaborating errors and the cached result is an unreported failure. Record the result as a reported
                        // failure and continue computing the relation such that errors get reported.
                        relation[id] = 3 /* FailedAndReported */;
                    }
                    else {
                        return related === 1 /* Succeeded */ ? -1 /* True */ : 0 /* False */;
                    }
                }
                if (depth &gt; 0) {
                    for (var i = 0; i &lt; depth; i++) {
                        // If source and target are already being compared, consider them related with assumptions
                        if (maybeStack[i][id]) {
                            return 1 /* Maybe */;
                        }
                    }
                    if (depth === 100) {
                        overflow = true;
                        return 0 /* False */;
                    }
                }
                else {
                    sourceStack = [];
                    targetStack = [];
                    maybeStack = [];
                    expandingFlags = 0;
                }
                sourceStack[depth] = source;
                targetStack[depth] = target;
                maybeStack[depth] = ts.createMap();
                maybeStack[depth][id] = 1 /* Succeeded */;
                depth++;
                var saveExpandingFlags = expandingFlags;
                if (!(expandingFlags & 1) && isDeeplyNestedGeneric(source, sourceStack, depth))
                    expandingFlags |= 1;
                if (!(expandingFlags & 2) && isDeeplyNestedGeneric(target, targetStack, depth))
                    expandingFlags |= 2;
                var result;
                if (expandingFlags === 3) {
                    result = 1 /* Maybe */;
                }
                else if (isGenericMappedType(source) || isGenericMappedType(target)) {
                    result = mappedTypeRelatedTo(source, target, reportErrors);
                }
                else {
                    result = propertiesRelatedTo(source, target, reportErrors);
                    if (result) {
                        result &= signaturesRelatedTo(source, target, 0 /* Call */, reportErrors);
                        if (result) {
                            result &= signaturesRelatedTo(source, target, 1 /* Construct */, reportErrors);
                            if (result) {
                                result &= indexTypesRelatedTo(source, originalSource, target, 0 /* String */, reportErrors);
                                if (result) {
                                    result &= indexTypesRelatedTo(source, originalSource, target, 1 /* Number */, reportErrors);
                                }
                            }
                        }
                    }
                }
                expandingFlags = saveExpandingFlags;
                depth--;
                if (result) {
                    var maybeCache = maybeStack[depth];
                    // If result is definitely true, copy assumptions to global cache, else copy to next level up
                    var destinationCache = (result === -1 /* True */ || depth === 0) ? relation : maybeStack[depth - 1];
                    ts.copyProperties(maybeCache, destinationCache);
                }
                else {
                    // A false result goes straight into global cache (when something is false under assumptions it
                    // will also be false without assumptions)
                    relation[id] = reportErrors ? 3 /* FailedAndReported */ : 2 /* Failed */;
                }
                return result;
            }
            // A type [P in S]: X is related to a type [P in T]: Y if T is related to S and X is related to Y.
            🔶️<i><b title="CallWithDescriptor">function</b></i> mappedTypeRelatedTo(source, target, reportErrors) {
                if (isGenericMappedType(target)) {
                    if (isGenericMappedType(source)) {
                        var result_2;
                        if (relation === identityRelation) {
                            var readonlyMatches = !source.declaration.readonlyToken === !target.declaration.readonlyToken;
                            var optionalMatches = !source.declaration.questionToken === !target.declaration.questionToken;
                            if (readonlyMatches && optionalMatches) {
                                if (result_2 = isRelatedTo(getConstraintTypeFromMappedType(target), getConstraintTypeFromMappedType(source), reportErrors)) {
                                    return result_2 & isRelatedTo(getErasedTemplateTypeFromMappedType(source), getErasedTemplateTypeFromMappedType(target), reportErrors);
                                }
                            }
                        }
                        else {
                            if (relation === comparableRelation || !source.declaration.questionToken || target.declaration.questionToken) {
                                if (result_2 = isRelatedTo(getConstraintTypeFromMappedType(target), getConstraintTypeFromMappedType(source), reportErrors)) {
                                    return result_2 & isRelatedTo(getTemplateTypeFromMappedType(source), getTemplateTypeFromMappedType(target), reportErrors);
                                }
                            }
                        }
                    }
                }
                else if (relation !== identityRelation) {
                    var resolved = resolveStructuredTypeMembers(target);
                    if (isEmptyObjectType(resolved) || resolved.stringIndexInfo && resolved.stringIndexInfo.type.flags & 1 /* Any */) {
                        return -1 /* True */;
                    }
                }
                return 0 /* False */;
            }
            🔶️<i><b title="CallWithDescriptor">function</b></i> propertiesRelatedTo(source, target, reportErrors) {
                if (relation === identityRelation) {
                    return propertiesIdenticalTo(source, target);
                }
                var result = -1 /* True */;
                var properties = getPropertiesOfObjectType(target);
                var requireOptionalProperties = relation === subtypeRelation && !(getObjectFlags(source) & 128 /* ObjectLiteral */);
                for (var _i = 0, properties_3 = properties; _i &lt; properties_3.length; _i++) {
                    var targetProp = properties_3[_i];
                    var sourceProp = getPropertyOfType(source, targetProp.name);
                    if (sourceProp !== targetProp) {
                        if (!sourceProp) {
                            if (!(targetProp.flags & 536870912 /* Optional */) || requireOptionalProperties) {
                                if (reportErrors) {
                                    reportError(ts.Diagnostics.Property_0_is_missing_in_type_1, symbolToString(targetProp), typeToString(source));
                                }
                                return 0 /* False */;
                            }
                        }
                        else if (!(targetProp.flags & 134217728 /* Prototype */)) {
                            var sourcePropFlags = getDeclarationModifierFlagsFromSymbol(sourceProp);
                            var targetPropFlags = getDeclarationModifierFlagsFromSymbol(targetProp);
                            if (sourcePropFlags & 8 /* Private */ || targetPropFlags & 8 /* Private */) {
                                if (sourceProp.valueDeclaration !== targetProp.valueDeclaration) {
                                    if (reportErrors) {
                                        if (sourcePropFlags & 8 /* Private */ && targetPropFlags & 8 /* Private */) {
                                            reportError(ts.Diagnostics.Types_have_separate_declarations_of_a_private_property_0, symbolToString(targetProp));
                                        }
                                        else {
                                            reportError(ts.Diagnostics.Property_0_is_private_in_type_1_but_not_in_type_2, symbolToString(targetProp), typeToString(sourcePropFlags & 8 /* Private */ ? source : target), typeToString(sourcePropFlags & 8 /* Private */ ? target : source));
                                        }
                                    }
                                    return 0 /* False */;
                                }
                            }
                            else if (targetPropFlags & 16 /* Protected */) {
                                var sourceDeclaredInClass = sourceProp.parent && sourceProp.parent.flags & 32 /* Class */;
                                var sourceClass = sourceDeclaredInClass ? getDeclaredTypeOfSymbol(getParentOfSymbol(sourceProp)) : undefined;
                                var targetClass = getDeclaredTypeOfSymbol(getParentOfSymbol(targetProp));
                                if (!sourceClass || !hasBaseType(sourceClass, targetClass)) {
                                    if (reportErrors) {
                                        reportError(ts.Diagnostics.Property_0_is_protected_but_type_1_is_not_a_class_derived_from_2, symbolToString(targetProp), typeToString(sourceClass || source), typeToString(targetClass));
                                    }
                                    return 0 /* False */;
                                }
                            }
                            else if (sourcePropFlags & 16 /* Protected */) {
                                if (reportErrors) {
                                    reportError(ts.Diagnostics.Property_0_is_protected_in_type_1_but_public_in_type_2, symbolToString(targetProp), typeToString(source), typeToString(target));
                                }
                                return 0 /* False */;
                            }
                            var related = isRelatedTo(getTypeOfSymbol(sourceProp), getTypeOfSymbol(targetProp), reportErrors);
                            if (!related) {
                                if (reportErrors) {
                                    reportError(ts.Diagnostics.Types_of_property_0_are_incompatible, symbolToString(targetProp));
                                }
                                return 0 /* False */;
                            }
                            result &= related;
                            // When checking for comparability, be more lenient with optional properties.
                            if (relation !== comparableRelation && sourceProp.flags & 536870912 /* Optional */ && !(targetProp.flags & 536870912 /* Optional */)) {
                                // TypeScript 1.0 spec (April 2014): 3.8.3
                                // S is a subtype of a type T, and T is a supertype of S if ...
                                // S' and T are object types and, for each member M in T..
                                // M is a property and S' contains a property N where
                                // if M is a required property, N is also a required property
                                // (M - property in T)
                                // (N - property in S)
                                if (reportErrors) {
                                    reportError(ts.Diagnostics.Property_0_is_optional_in_type_1_but_required_in_type_2, symbolToString(targetProp), typeToString(source), typeToString(target));
                                }
                                return 0 /* False */;
                            }
                        }
                    }
                }
                return result;
            }
            🔶️<i><b title="CallWithDescriptor">function</b></i> propertiesIdenticalTo(source, target) {
                if (!(source.flags & 32768 /* Object */ && target.flags & 32768 /* Object */)) {
                    return 0 /* False */;
                }
                var sourceProperties = getPropertiesOfObjectType(source);
                var targetProperties = getPropertiesOfObjectType(target);
                if (sourceProperties.length !== targetProperties.length) {
                    return 0 /* False */;
                }
                var result = -1 /* True */;
                for (var _i = 0, sourceProperties_1 = sourceProperties; _i &lt; sourceProperties_1.length; _i++) {
                    var sourceProp = sourceProperties_1[_i];
                    var targetProp = getPropertyOfObjectType(target, sourceProp.name);
                    if (!targetProp) {
                        return 0 /* False */;
                    }
                    var related = compareProperties(sourceProp, targetProp, isRelatedTo);
                    if (!related) {
                        return 0 /* False */;
                    }
                    result &= related;
                }
                return result;
            }
            🔶️<i><b title="CallWithDescriptor">function</b></i> signaturesRelatedTo(source, target, kind, reportErrors) {
                if (relation === identityRelation) {
                    return signaturesIdenticalTo(source, target, kind);
                }
                if (target === anyFunctionType || source === anyFunctionType) {
                    return -1 /* True */;
                }
                var sourceSignatures = getSignaturesOfType(source, kind);
                var targetSignatures = getSignaturesOfType(target, kind);
                if (kind === 1 /* Construct */ && sourceSignatures.length && targetSignatures.length) {
                    if (isAbstractConstructorType(source) && !isAbstractConstructorType(target)) {
                        // An abstract constructor type is not assignable to a non-abstract constructor type
                        // as it would otherwise be possible to new an abstract class. Note that the assignability
                        // check we perform for an extends clause excludes construct signatures from the target,
                        // so this check never proceeds.
                        if (reportErrors) {
                            reportError(ts.Diagnostics.Cannot_assign_an_abstract_constructor_type_to_a_non_abstract_constructor_type);
                        }
                        return 0 /* False */;
                    }
                    if (!constructorVisibilitiesAreCompatible(sourceSignatures[0], targetSignatures[0], reportErrors)) {
                        return 0 /* False */;
                    }
                }
                var result = -1 /* True */;
                var saveErrorInfo = errorInfo;
                outer: for (var _i = 0, targetSignatures_1 = targetSignatures; _i &lt; targetSignatures_1.length; _i++) {
                    var t = targetSignatures_1[_i];
                    // Only elaborate errors from the first failure
                    var shouldElaborateErrors = reportErrors;
                    for (var _a = 0, sourceSignatures_1 = sourceSignatures; _a &lt; sourceSignatures_1.length; _a++) {
                        var s = sourceSignatures_1[_a];
                        var related = signatureRelatedTo(s, t, shouldElaborateErrors);
                        if (related) {
                            result &= related;
                            errorInfo = saveErrorInfo;
                            continue outer;
                        }
                        shouldElaborateErrors = false;
                    }
                    if (shouldElaborateErrors) {
                        reportError(ts.Diagnostics.Type_0_provides_no_match_for_the_signature_1, typeToString(source), signatureToString(t, /*enclosingDeclaration*/ undefined, /*flags*/ undefined, kind));
                    }
                    return 0 /* False */;
                }
                return result;
            }
            /**
             * See signatureAssignableTo, compareSignaturesIdentical
             */
            🔶️<i><b title="CallWithDescriptor">function</b></i> signatureRelatedTo(source, target, reportErrors) {
                return compareSignaturesRelated(source, target, /*ignoreReturnTypes*/ false, reportErrors, reportError, isRelatedTo);
            }
            🔶️<i><b title="CallWithDescriptor">function</b></i> signaturesIdenticalTo(source, target, kind) {
                var sourceSignatures = getSignaturesOfType(source, kind);
                var targetSignatures = getSignaturesOfType(target, kind);
                if (sourceSignatures.length !== targetSignatures.length) {
                    return 0 /* False */;
                }
                var result = -1 /* True */;
                for (var i = 0, len = sourceSignatures.length; i &lt; len; i++) {
                    var related = compareSignaturesIdentical(sourceSignatures[i], targetSignatures[i], /*partialMatch*/ false, /*ignoreThisTypes*/ false, /*ignoreReturnTypes*/ false, isRelatedTo);
                    if (!related) {
                        return 0 /* False */;
                    }
                    result &= related;
                }
                return result;
            }
            🔶️<i><b title="CallWithDescriptor">function</b></i> eachPropertyRelatedTo(source, target, kind, reportErrors) {
                var result = -1 /* True */;
                for (var _i = 0, _a = getPropertiesOfObjectType(source); _i &lt; _a.length; _i++) {
                    var prop = _a[_i];
                    if (kind === 0 /* String */ || isNumericLiteralName(prop.name)) {
                        var related = isRelatedTo(getTypeOfSymbol(prop), target, reportErrors);
                        if (!related) {
                            if (reportErrors) {
                                reportError(ts.Diagnostics.Property_0_is_incompatible_with_index_signature, symbolToString(prop));
                            }
                            return 0 /* False */;
                        }
                        result &= related;
                    }
                }
                return result;
            }
            🔶️<i><b title="CallWithDescriptor">function</b></i> indexInfoRelatedTo(sourceInfo, targetInfo, reportErrors) {
                var related = isRelatedTo(sourceInfo.type, targetInfo.type, reportErrors);
                if (!related && reportErrors) {
                    reportError(ts.Diagnostics.Index_signatures_are_incompatible);
                }
                return related;
            }
            🔶️<i><b title="CallWithDescriptor">function</b></i> indexTypesRelatedTo(source, originalSource, target, kind, reportErrors) {
                if (relation === identityRelation) {
                    return indexTypesIdenticalTo(source, target, kind);
                }
                var targetInfo = getIndexInfoOfType(target, kind);
                if (!targetInfo || ((targetInfo.type.flags & 1 /* Any */) && !(originalSource.flags & 8190 /* Primitive */))) {
                    // Index signature of type any permits assignment from everything but primitives
                    return -1 /* True */;
                }
                var sourceInfo = getIndexInfoOfType(source, kind) ||
                    kind === 1 /* Number */ && getIndexInfoOfType(source, 0 /* String */);
                if (sourceInfo) {
                    return indexInfoRelatedTo(sourceInfo, targetInfo, reportErrors);
                }
                if (isObjectLiteralType(source)) {
                    var related = -1 /* True */;
                    if (kind === 0 /* String */) {
                        var sourceNumberInfo = getIndexInfoOfType(source, 1 /* Number */);
                        if (sourceNumberInfo) {
                            related = indexInfoRelatedTo(sourceNumberInfo, targetInfo, reportErrors);
                        }
                    }
                    if (related) {
                        related &= eachPropertyRelatedTo(source, targetInfo.type, kind, reportErrors);
                    }
                    return related;
                }
                if (reportErrors) {
                    reportError(ts.Diagnostics.Index_signature_is_missing_in_type_0, typeToString(source));
                }
                return 0 /* False */;
            }
            🔶️<i><b title="CallWithDescriptor">function</b></i> indexTypesIdenticalTo(source, target, indexKind) {
                var targetInfo = getIndexInfoOfType(target, indexKind);
                var sourceInfo = getIndexInfoOfType(source, indexKind);
                if (!sourceInfo && !targetInfo) {
                    return -1 /* True */;
                }
                if (sourceInfo && targetInfo && sourceInfo.isReadonly === targetInfo.isReadonly) {
                    return isRelatedTo(sourceInfo.type, targetInfo.type);
                }
                return 0 /* False */;
            }
            🔶️<i><b title="CallWithDescriptor">function</b></i> constructorVisibilitiesAreCompatible(sourceSignature, targetSignature, reportErrors) {
                if (!sourceSignature.declaration || !targetSignature.declaration) {
                    return true;
                }
                var sourceAccessibility = ts.getModifierFlags(sourceSignature.declaration) & 24 /* NonPublicAccessibilityModifier */;
                var targetAccessibility = ts.getModifierFlags(targetSignature.declaration) & 24 /* NonPublicAccessibilityModifier */;
                // A public, protected and private signature is assignable to a private signature.
                if (targetAccessibility === 8 /* Private */) {
                    return true;
                }
                // A public and protected signature is assignable to a protected signature.
                if (targetAccessibility === 16 /* Protected */ && sourceAccessibility !== 8 /* Private */) {
                    return true;
                }
                // Only a public signature is assignable to public signature.
                if (targetAccessibility !== 16 /* Protected */ && !sourceAccessibility) {
                    return true;
                }
                if (reportErrors) {
                    reportError(ts.Diagnostics.Cannot_assign_a_0_constructor_type_to_a_1_constructor_type, visibilityToString(sourceAccessibility), visibilityToString(targetAccessibility));
                }
                return false;
            }
        }</pre>



### checkInheritedPropertiesAreIdentical:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(type, typeNode) {
            var baseTypes = getBaseTypes(type);
            if (baseTypes.length &lt; 2) {
                return true;
            }
            var seen = ts.🔶<i><b title="Did not inline: unknown">createMap</b></i>();
            ts.⚠️<i><b title="LoadNamedGeneric">forEach</b></i>(<b title="Inlined">🔷resolveDeclaredMembers</b>(type).declaredProperties, 🔶️<i><b title="CallWithDescriptor">function</b></i> (p) { seen[p.name] = { prop: p, containingType: type }; });
            var ok = true;
            for (var _i = 0, baseTypes_2 = baseTypes; _i &lt; baseTypes_2.length; _i++) {
                var base = baseTypes_2[_i];
                var properties = getPropertiesOfObjectType(<b title="Inlined">🔷getTypeWithThisArgument</b>(base, type.thisType));
                for (var _a = 0, properties_7 = properties; _a &lt; properties_7.length; _a++) {
                    var prop = properties_7[_a];
                    var existing = seen[prop.name];
                    if (!existing) {
                        seen[prop.name] ⚠️<i><b title="StoreKeyedGeneric">= { p</b></i>rop: prop, containingType: base };
                    }
                    else {
                        var isInheritedProperty = existing.containingType !== type;
                        if (isInheritedProperty && !🔶️<i><b title="CallWithDescriptor">isPropertyIdenticalTo</b></i>(existing.prop, prop)) {
                            ok = false;
                            var typeName1 = 🔶️<i><b title="CallWithDescriptor">typeToString</b></i>(existing⚠️<i><b title="LoadNamedGeneric">.containingType</b></i>);
                            var typeName2 = 🔶️<i><b title="CallWithDescriptor">typeToString</b></i>(base);
                            var errorInfo = ts.🔶️<i><b title="CallWithDescriptor">chainDiagnosticMessages</b></i>(undefined, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Named_property_0_of_types_1_and_2_are_not_identical</b></i>, 🔶️<i><b title="CallWithDescriptor">symbolToString</b></i>(prop), typeName1, typeName2);
                            errorInfo = ts.🔶️<i><b title="CallWithDescriptor">chainDiagnosticMessages</b></i>(errorInfo, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Interface_0_cannot_simultaneously_extend_types_1_and_2</b></i>, 🔶️<i><b title="CallWithDescriptor">typeToString</b></i>(type), typeName1, typeName2);
                            diagnostics.🔶️<i><b title="CallWithDescriptor">add</b></i>(ts.🔶️<i><b title="CallWithDescriptor">createDiagnosticForNodeFromMessageChain</b></i>(typeNode, errorInfo));
                        }
                    }
                }
            }
            return ok;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>resolveDeclaredMembers</summary>
<pre class="code">
(type) {
            if (!type⚠️<i><b title="LoadNamedGeneric">.declaredProperties</b></i>) {
                var symbol = type.symbol;
                type.declaredProperties ⚠️<i><b title="StoreNamedGeneric">= getNamedMembers</b></i>(symbol.members);
                type.declaredCallSignatures ⚠️<i><b title="StoreNamedGeneric">= getSignaturesOfSymbol</b></i>(symbol.members⚠️<i><b title="LoadNamedGeneric">["__c</b></i>all"]);
                type.declaredConstructSignatures ⚠️<i><b title="StoreNamedGeneric">= getSignaturesOfSymbol</b></i>(symbol.members⚠️<i><b title="LoadNamedGeneric">["__n</b></i>ew"]);
                type.declaredStringIndexInfo ⚠️<i><b title="StoreNamedGeneric">= getIndexInfoOfSymbol</b></i>(symbol, 0 /* String */);
                type.declaredNumberIndexInfo ⚠️<i><b title="StoreNamedGeneric">= getIndexInfoOfSymbol</b></i>(symbol, 1 /* Number */);
            }
            return type;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getNamedMembers</summary>
<pre class="code">
(members) {
            var result;
            🔶️<i><b title="CallWithDescriptor">for</b></i> (var id in members) {
                if (!<b title="Inlined">🔷isReservedMemberName</b>(id)) {
                    if (!result)
                        result = [];
                    var symbol = members⚠️<i><b title="LoadKeyedGeneric">[id]</b></i>;
                    if (🔶<i><b title="Did not inline: target text too big">symbolIsValue</b></i>(symbol)) {
                        result.push(symbol);
                    }
                }
            }
            return result || emptyArray;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>isReservedMemberName</summary>
<pre class="code">
(name) {
            return name.charCodeAt(0) === 95 /* _ */ &&
                name.charCodeAt(1) === 95 /* _ */ &&
                name.charCodeAt(2) !== 95 /* _ */ &&
                name.charCodeAt(2) !== 64 /* at */;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>getIndexInfoOfSymbol</summary>
<pre class="code">
(symbol, kind) {
            var declaration = getIndexDeclarationOfSymbol(symbol, kind);
            if (declaration) {
                return <b title="Inlined">🔷createIndexInfo</b>(declaration.type ? 🔶<i><b title="Did not inline: target text too big">getTypeFromTypeNode</b></i>(declaration.type) : anyType, (ts.🔶<i><b title="Did not inline: target text too big">getModifierFlags</b></i>(declaration) & 64 /* Readonly */) !== 0, declaration);
            }
            return undefined;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createIndexInfo</summary>
<pre class="code">
(type, isReadonly, declaration) {
            return { type: type, isReadonly: isReadonly, declaration: declaration };
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>getIndexInfoOfSymbol</summary>
<pre class="code">
(symbol, kind) {
            var declaration = getIndexDeclarationOfSymbol(symbol, kind);
            if (declaration) {
                return <b title="Inlined">🔷createIndexInfo</b>(declaration.type ? 🔶<i><b title="Did not inline: target text too big">getTypeFromTypeNode</b></i>(declaration.type) : anyType, (ts.🔶<i><b title="Did not inline: target text too big">getModifierFlags</b></i>(declaration) & 64 /* Readonly */) !== 0, declaration);
            }
            return undefined;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createIndexInfo</summary>
<pre class="code">
(type, isReadonly, declaration) {
            return { type: type, isReadonly: isReadonly, declaration: declaration };
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>getTypeWithThisArgument</summary>
<pre class="code">
(type, thisArgument) {
            if (<b title="Inlined">🔷getObjectFlags</b>(type) & 4 /* Reference */) {
                return <b title="Inlined">🔷createTypeReference</b>(type.target, ts.⚠️<i><b title="LoadNamedGeneric">concatenate</b></i>(type.typeArguments, [thisArgument || type.target.thisType]));
            }
            return type;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getObjectFlags</summary>
<pre class="code">
(type) {
            return type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 32768 /* Object */ ? type⚠️<i><b title="LoadNamedGeneric">.objectFlags</b></i> : 0;
        }</pre>

</details>
<details>
<summary>createTypeReference</summary>
<pre class="code">
(target, typeArguments) {
            var id = 🔶<i><b title="Did not inline: target text too big">getTypeListId</b></i>(typeArguments);
            var type = target⚠️<i><b title="LoadNamedGeneric">.instantiations</b></i>⚠️<i><b title="LoadKeyedGeneric">[id]</b></i>;
            if (!type) {
                type = target⚠️<i><b title="LoadNamedGeneric">.instantiations</b></i>[id] ⚠️<i><b title="StoreKeyedGeneric">= createObjectType</b></i>(4 /* Reference */, target⚠️<i><b title="LoadNamedGeneric">.symbol</b></i>);
                type.flags |= typeArguments ? <b title="Inlined">🔷getPropagatingFlagsOfTypes</b>(typeArguments, /*excludeKinds*/ 0) : 0;
                type.target = target;
                type.typeArguments = typeArguments;
            }
            return type;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createObjectType</summary>
<pre class="code">
(objectFlags, symbol) {
            var type = <b title="Inlined">🔷createType</b>(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol ⚠️<i><b title="StoreNamedGeneric">= symbol</b></i>;
            return type;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createType</summary>
<pre class="code">
(flags) {
            var result = <b title="Inlined">🔷new Type</b>(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new Type</summary>
<pre class="code">
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>getPropagatingFlagsOfTypes</summary>
<pre class="code">
(types, excludeKinds) {
            var result = 0;
            for (var _i = 0, types_3 = types; _i &lt; types_3⚠️<i><b title="LoadNamedGeneric">.length</b></i>; _i++) {
                var type = types_3⚠️<i><b title="LoadKeyedGeneric">[_i]</b></i>;
                if (!(type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & excludeKinds)) {
                    result |= type⚠️<i><b title="LoadNamedGeneric">.flags</b></i>;
                }
            }
            return result & 14680064 /* PropagatingFlags */;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>



### getIndexType:
<pre class="code">
(type) {
            return <b title="Inlined">🔷maybeTypeOfKind</b>(type, 540672 /* TypeVariable */) ? <b title="Inlined">🔷getIndexTypeForGenericType</b>(type) :
                <b title="Inlined">🔷getObjectFlags</b>(type) & 32 /* Mapped */ ? 🔶️<i><b title="CallWithDescriptor">getConstraintTypeFromMappedType</b></i>(type) :
                    type.flags & 1 /* Any */ || <b title="Inlined">🔷getIndexInfoOfType</b>(type, 0 /* String */) ? stringType :
                        <b title="Inlined">🔷getLiteralTypeFromPropertyNames</b>(type);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>maybeTypeOfKind</summary>
<pre class="code">
(type, kind) {
            if (type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & kind) {
                return true;
            }
            if (type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 196608 /* UnionOrIntersection */) {
                var types = type.types;
                for (var _i = 0, types_15 = types; _i &lt; types_15.length; _i++) {
                    var t = types_15[_i];
                    if (🔶️<i><b title="CallWithDescriptor">maybeTypeOfKind</b></i>(t, kind)) {
                        return true;
                    }
                }
            }
            return false;
        }</pre>

</details>
<details>
<summary>getIndexTypeForGenericType</summary>
<pre class="code">
(type) {
            if (!type.resolvedIndexType) {
                type.resolvedIndexType = <b title="Inlined">🔷createType</b>(262144 /* Index */);
                type.resolvedIndexType.type = type;
            }
            return type.resolvedIndexType;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createType</summary>
<pre class="code">
(flags) {
            var result = <b title="Inlined">🔷new Type</b>(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new Type</summary>
<pre class="code">
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>getObjectFlags</summary>
<pre class="code">
(type) {
            return type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 32768 /* Object */ ? type⚠️<i><b title="LoadNamedGeneric">.objectFlags</b></i> : 0;
        }</pre>

</details>
<details>
<summary>getIndexInfoOfType</summary>
<pre class="code">
(type, kind) {
            return <b title="Inlined">🔷getIndexInfoOfStructuredType</b>(<b title="Inlined">🔷getApparentType</b>(type), kind);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getApparentType</summary>
<pre class="code">
(type) {
            var t = type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 540672 /* TypeVariable */ ? 🔶️<i><b title="CallWithDescriptor">getApparentTypeOfTypeVariable</b></i>(type) : type;
            return t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 262178 /* StringLike */ ? globalStringType :
                t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 340 /* NumberLike */ ? globalNumberType :
                    t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 136 /* BooleanLike */ ? globalBooleanType :
                        t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 512 /* ESSymbol */ ? 🔶️<i><b title="CallWithDescriptor">getGlobalESSymbolType</b></i>() :
                            t;
        }</pre>

</details>
<details>
<summary>getIndexInfoOfStructuredType</summary>
<pre class="code">
(type, kind) {
            if (type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 229376 /* StructuredType */) {
                var resolved = 🔶<i><b title="Did not inline: target text too big">resolveStructuredTypeMembers</b></i>(type);
                return kind === 0 /* String */ ? resolved⚠️<i><b title="LoadNamedGeneric">.stringIndexInfo</b></i> : resolved⚠️<i><b title="LoadNamedGeneric">.numberIndexInfo</b></i>;
            }
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>getLiteralTypeFromPropertyNames</summary>
<pre class="code">
(type) {
            return 🔶<i><b title="Did not inline: target text too big">getUnionType</b></i>(ts.🔶<i><b title="Did not inline: unknown">map</b></i>(<b title="Inlined">🔷getPropertiesOfType</b>(type), getLiteralTypeFromPropertyName));
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getPropertiesOfType</summary>
<pre class="code">
(type) {
            type = <b title="Inlined">🔷getApparentType</b>(type);
            return type.flags & 196608 /* UnionOrIntersection */ ?
                🔶️<i><b title="CallWithDescriptor">getPropertiesOfUnionOrIntersectionType</b></i>(type) :
                <b title="Inlined">🔷getPropertiesOfObjectType</b>(type);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getApparentType</summary>
<pre class="code">
(type) {
            var t = type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 540672 /* TypeVariable */ ? 🔶️<i><b title="CallWithDescriptor">getApparentTypeOfTypeVariable</b></i>(type) : type;
            return t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 262178 /* StringLike */ ? globalStringType :
                t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 340 /* NumberLike */ ? globalNumberType :
                    t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 136 /* BooleanLike */ ? globalBooleanType :
                        t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 512 /* ESSymbol */ ? 🔶️<i><b title="CallWithDescriptor">getGlobalESSymbolType</b></i>() :
                            t;
        }</pre>

</details>
<details>
<summary>getPropertiesOfObjectType</summary>
<pre class="code">
(type) {
            if (type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 32768 /* Object */) {
                return 🔶<i><b title="Did not inline: target text too big">resolveStructuredTypeMembers</b></i>(type)⚠️<i><b title="LoadNamedGeneric">.properties</b></i>;
            }
            return emptyArray;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>



### signatureRelatedTo:
<pre class="code">
(source, target, reportErrors) {
                return 🔶️<i><b title="CallWithDescriptor">compareSignaturesRelated</b></i>(source, target, /*ignoreReturnTypes*/ false, reportErrors, reportError, isRelatedTo);
            }</pre>



### containsType:
<pre class="code">
(types, type) {
            return <b title="Inlined">🔷binarySearchTypes</b>(types, type) &gt;= 0;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>binarySearchTypes</summary>
<pre class="code">
(types, type) {
            var low = 0;
            var high = types⚠️<i><b title="LoadNamedGeneric">.length</b></i> - 1;
            var typeId = type⚠️<i><b title="LoadNamedGeneric">.id</b></i>;
            while (low &lt;= high) {
                var middle = low + ((high - low) &gt;&gt; 1);
                var id = types⚠️<i><b title="LoadKeyedGeneric">[middle]</b></i>⚠️<i><b title="LoadNamedGeneric">.id</b></i>;
                if (id === typeId) {
                    return middle;
                }
                else if (id &gt; typeId) {
                    high = middle - 1;
                }
                else {
                    low = middle + 1;
                }
            }
            return ~low;
        }</pre>

</details>
</blockquote>



### isTypeRelatedTo:
<pre class="code">
(source, target, relation) {
            if (source⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 96 /* StringOrNumberLiteral */ && source⚠️<i><b title="LoadNamedGeneric">.flags</b></i> ⚠️<i><b title="Bitwise">& 1048576</b></i> /* FreshLiteral */) {
                source = source⚠️<i><b title="LoadNamedGeneric">.regularType</b></i>;
            }
            if (target⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 96 /* StringOrNumberLiteral */ && target⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 1048576 /* FreshLiteral */) {
                target = target⚠️<i><b title="LoadNamedGeneric">.regularType</b></i>;
            }
            if (source === target || relation !== identityRelation && 🔶<i><b title="Did not inline: target text too big">isSimpleTypeRelatedTo</b></i>(source, target, relation)) {
                return true;
            }
            if (source.flags & 32768 /* Object */ && target⚠️<i><b title="LoadNamedGeneric">.flags</b></i> ⚠️<i><b title="Bitwise">& 32768</b></i> /* Object */) {
                var id = relation ⚠️<i><b title="CompareGeneric">!== identityRelation</b></i> || source⚠️<i><b title="LoadNamedGeneric">.id</b></i> ⚠️<i><b title="CompareGeneric">< target</b></i>⚠️<i><b title="LoadNamedGeneric">.id</b></i> ? source⚠️<i><b title="LoadNamedGeneric">.id</b></i> + "," ⚠️<i><b title="Add">+ target</b></i>⚠️<i><b title="LoadNamedGeneric">.id</b></i> : target⚠️<i><b title="LoadNamedGeneric">.id</b></i> + "," ⚠️<i><b title="Add">+ source</b></i>⚠️<i><b title="LoadNamedGeneric">.id</b></i>;
                var related = relation⚠️<i><b title="LoadKeyedGeneric">[id]</b></i>;
                if (related !== undefined) {
                    return related ⚠️<i><b title="CompareGeneric">=== 1</b></i> /* Succeeded */;
                }
            }
            if (source.flags & 507904 /* StructuredOrTypeParameter */ || target⚠️<i><b title="LoadNamedGeneric">.flags</b></i> ⚠️<i><b title="Bitwise">& 507904</b></i> /* StructuredOrTypeParameter */) {
                return 🔶<i><b title="Did not inline: target text too big">checkTypeRelatedTo</b></i>(source, target, relation, undefined, undefined, undefined);
            }
            return false;
        }</pre>



### checkIndexConstraintForProperty:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(prop, propertyType, containingType, indexDeclaration, indexType, indexKind) {
                if (!indexType) {
                    return;
                }
                // index is numeric and property name is not valid numeric literal
                if (indexKind === 1 /* Number */ && !<b title="Inlined">🔷isNumericName</b>(prop.valueDeclaration.name)) {
                    return;
                }
                // perform property check if property or indexer is declared in 'type'
                // this allows to rule out cases when both property and indexer are inherited from the base class
                var errorNode;
                if (prop.valueDeclaration⚠️<i><b title="LoadNamedGeneric">.name</b></i>.kind === 142 /* ComputedPropertyName */ || prop.parent === containingType.symbol) {
                    errorNode = prop.valueDeclaration;
                }
                else if (indexDeclaration) {
                    errorNode = indexDeclaration;
                }
                else if (🔶<i><b title="Did not inline: unknown">getObjectFlags</b></i>(containingType) ⚠️<i><b title="Bitwise">& 2</b></i> /* Interface */) {
                    // for interfaces property and indexer might be inherited from different bases
                    // check if any base class already has both property and indexer.
                    // check should be performed only if 'type' is the first type that brings property\x5cindexer together
                    var someBaseClassHasBothPropertyAndIndexer = 🔶️<i><b title="CallWithDescriptor">ts</b></i>.forEa🔶️<i><b title="CallWithDescriptor">ch</b></i>(getBaseTypes(containingType🔶️<i><b title="CallWithDescriptor">), fu</b></i>nction (base) { return getPropertyOfObjectType(base, prop.name) && getIndexTypeOfType(base, indexKind); });
                    errorNode = someBaseClassHasBothPropertyAndIndexer ? undefined : containingT⚠️<i><b title="LoadNamedGeneric">ype</b></i>.sym⚠️<i><b title="LoadNamedGeneric">bol</b></i>.declarati⚠️<i><b title="LoadKeyedGeneric">ons</b></i>[0];
                }
                if (errorNode &<b title="Inlined">🔷& !isTypeAssignableTo</b>(propertyType, indexType)) {
                    var errorMessage = indexKi⚠️<i><b title="CompareGeneric">nd</b></i> === 0 /* String */
                        ?⚠️<i><b title="LoadNamedGeneric"> ts</b></i>.Diagnost⚠️<i><b title="LoadNamedGeneric">ics</b></i>.Property_0_of_type_1_is_not_assignable_to_string_index_type_2
                        :⚠️<i><b title="LoadNamedGeneric"> ts</b></i>.Diagnost⚠️<i><b title="LoadNamedGeneric">ics</b></i>.Property_0_of_type_1_is_not_assignable_to_numeric_index_type_2;
                 🔶️<i><b title="CallWithDescriptor">   error</b></i>(errorNode, errorMessag🔶️<i><b title="CallWithDescriptor">e</b></i>, symbolToString(prop🔶️<i><b title="CallWithDescriptor">), ty</b></i>peToString(propertyType🔶️<i><b title="CallWithDescriptor">), ty</b></i>peToString(indexType));
                }
            }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>isNumericName</summary>
<pre class="code">
(name) {
            return name.kind === 142 /* ComputedPropertyName */ ? 🔶️<i><b title="CallWithDescriptor">isNumericComputedName</b></i>(name) : 🔶<i><b title="Did not inline: target text too big">isNumericLiteralName</b></i>(name.text);
        }</pre>

</details>
<details>
<summary>& !isTypeAssignableTo</summary>
<pre class="code">
(source, target) {
            return 🔶<i><b title="Did not inline: target text too big">isTypeRelatedTo</b></i>(source, target, assignableRelation);
        }</pre>

</details>
</blockquote>



### eachTypeRelatedToType:
<pre class="code">
(source, target, reportErrors) {
                var result = -1 /* True */;
                var sourceTypes = source.types;
                for (var _i = 0, sourceTypes_2 = sourceTypes; _i &lt; sourceTypes_2.length; _i++) {
                    var sourceType = sourceTypes_2[_i];
                    var related = 🔶<i><b title="Did not inline: unknown">isRelatedTo</b></i>(sourceType, target, reportErrors);
                    if (!related) {
                        return 0 /* False */;
                    }
                    result &= related;
                }
                return result;
            }</pre>



### isTypeAnyOrAllConstituentTypesHaveKind:
<pre class="code">
(type, kind) {
            return <b title="Inlined">🔷isTypeAny</b>(type) || 🔶️<i><b title="CallWithDescriptor">isTypeOfKind</b></i>(type, kind);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>isTypeAny</summary>
<pre class="code">
(type) {
            return type && (type.flags & 1 /* Any */) !== 0;
        }</pre>

</details>
</blockquote>



### resolveAnonymousTypeMembers:
<div>~recompile~</div>

<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(type) {
            var symbol = type.symbol;
            if (type.target) {
                var members = <b title="Inlined">🔷createInstantiatedSymbolTable</b>(<b title="Inlined">🔷getPropertiesOfObjectType</b>(type.target), type.mapper, /*mappingThisOnly*/ false);
                var callSignatures = <b title="Inlined">🔷instantiateSignatures</b>(<b title="Inlined">🔷getSignaturesOfType</b>(type.target, 0 /* Call */), type.mapper);
                var constructSignatures = <b title="Inlined">🔷instantiateSignatures</b>(<b title="Inlined">🔷getSignaturesOfType</b>(type.target, 1 /* Construct */), type.mapper);
                var stringIndexInfo = 🔶<i><b title="Did not inline: unknown">instantiateIndexInfo</b></i>(<b title="Inlined">🔷getIndexInfoOfType</b>(type.target, 0 /* String */), type.mapper);
                var numberIndexInfo = 🔶<i><b title="Did not inline: unknown">instantiateIndexInfo</b></i>(🔶<i><b title="Did not inline: unknown">getIndexInfoOfType</b></i>(type.target, 1 /* Number */), type.mapper);
                🔶️<i><b title="CallWithDescriptor">setStructuredTypeMembers</b></i>(type, members, callSignatures, constructSignatures, stringIndexInfo, numberIndexInfo);
            }
            else if (symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 2048 /* TypeLiteral */) {
                var members = symbol.members;
                var callSignatures = 🔶️<i><b title="CallWithDescriptor">getSignaturesOfSymbol</b></i>(members⚠️<i><b title="LoadNamedGeneric">["__c</b></i>all"]);
                var constructSignatures = 🔶️<i><b title="CallWithDescriptor">getSignaturesOfSymbol</b></i>(members⚠️<i><b title="LoadNamedGeneric">["__n</b></i>ew"]);
                var stringIndexInfo = 🔶<i><b title="Did not inline: unknown">getIndexInfoOfSymbol</b></i>(symbol, 0 /* String */);
                var numberIndexInfo = 🔶<i><b title="Did not inline: unknown">getIndexInfoOfSymbol</b></i>(symbol, 1 /* Number */);
                🔶️<i><b title="CallWithDescriptor">setStructuredTypeMembers</b></i>(type, members, callSignatures, constructSignatures, stringIndexInfo, numberIndexInfo);
            }
            else {
                // Combinations of function, class, enum and module
                var members = emptySymbols;
                var constructSignatures = emptyArray;
                if (symbol.flags & 1952 /* HasExports */) {
                    members = 🔶️<i><b title="CallWithDescriptor">getExportsOfSymbol</b></i>(symbol);
                }
                if (symbol.flags & 32 /* Class */) {
                    var classType = 🔶<i><b title="Did not inline: target text too big">getDeclaredTypeOfClassOrInterface</b></i>(symbol);
                    constructSignatures = 🔶️<i><b title="CallWithDescriptor">getSignaturesOfSymbol</b></i>(symbol.members⚠️<i><b title="LoadNamedGeneric">["__c</b></i>onstructor"]);
                    if (!constructSignatures.length) {
                        constructSignatures = 🔶️<i><b title="CallWithDescriptor">getDefaultConstructSignatures</b></i>(classType);
                    }
                    var baseConstructorType = 🔶️<i><b title="CallWithDescriptor">getBaseConstructorTypeOfClass</b></i>(classType);
                    if (baseConstructorType.flags & 32768 /* Object */) {
                        members = 🔶️<i><b title="CallWithDescriptor">createSymbolTable</b></i>(🔶<i><b title="Did not inline: unknown">getNamedMembers</b></i>(members));
                        🔶<i><b title="Did not inline: unknown">addInheritedMembers</b></i>(members, 🔶️<i><b title="CallWithDescriptor">getPropertiesOfObjectType</b></i>(baseConstructorType));
                    }
                }
                var numberIndexInfo = symbol.flags & 384 /* Enum */ ? enumNumberIndexInfo : undefined;
                🔶️<i><b title="CallWithDescriptor">setStructuredTypeMembers</b></i>(type, members, emptyArray, constructSignatures, undefined, numberIndexInfo);
                // We resolve the members before computing the signatures because a signature may use
                // typeof with a qualified name expression that circularly references the type we are
                // in the process of resolving (see issue #6072). The temporarily empty signature list
                // will never be observed because a qualified name can't reference signatures.
                if (symbol.flags & (16 /* Function */ | 8192 /* Method */)) {
                    type.callSignatures = 🔶️<i><b title="CallWithDescriptor">getSignaturesOfSymbol</b></i>(symbol);
                }
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getPropertiesOfObjectType</summary>
<pre class="code">
(type) {
            if (type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 32768 /* Object */) {
                return 🔶<i><b title="Did not inline: target text too big">resolveStructuredTypeMembers</b></i>(type)⚠️<i><b title="LoadNamedGeneric">.properties</b></i>;
            }
            return emptyArray;
        }</pre>

</details>
<details>
<summary>createInstantiatedSymbolTable</summary>
<pre class="code">
(symbols, mapper, mappingThisOnly) {
            var result = ts.🔶<i><b title="Did not inline: unknown">createMap</b></i>();
            for (var _i = 0, symbols_2 = symbols; _i &lt; symbols_2.length; _i++) {
                var symbol = symbols_2[_i];
                result[symbol.name] ⚠️<i><b title="StoreKeyedGeneric">= mappingThisOnly</b></i> && 🔶<i><b title="Did not inline: target text too big">isIndependentMember</b></i>(symbol) ? symbol : 🔶<i><b title="Did not inline: target text too big">instantiateSymbol</b></i>(symbol, mapper);
            }
            return result;
        }</pre>

</details>
<details>
<summary>getSignaturesOfType</summary>
<pre class="code">
(type, kind) {
            return <b title="Inlined">🔷getSignaturesOfStructuredType</b>(<b title="Inlined">🔷getApparentType</b>(type), kind);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getApparentType</summary>
<pre class="code">
(type) {
            var t = type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 540672 /* TypeVariable */ ? 🔶️<i><b title="CallWithDescriptor">getApparentTypeOfTypeVariable</b></i>(type) : type;
            return t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 262178 /* StringLike */ ? globalStringType :
                t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 340 /* NumberLike */ ? globalNumberType :
                    t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 136 /* BooleanLike */ ? globalBooleanType :
                        t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 512 /* ESSymbol */ ? 🔶️<i><b title="CallWithDescriptor">getGlobalESSymbolType</b></i>() :
                            t;
        }</pre>

</details>
<details>
<summary>getSignaturesOfStructuredType</summary>
<pre class="code">
(type, kind) {
            if (type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 229376 /* StructuredType */) {
                var resolved = 🔶<i><b title="Did not inline: target text too big">resolveStructuredTypeMembers</b></i>(type);
                return kind === 0 /* Call */ ? resolved⚠️<i><b title="LoadNamedGeneric">.callSignatures</b></i> : resolved⚠️<i><b title="LoadNamedGeneric">.constructSignatures</b></i>;
            }
            return emptyArray;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>instantiateSignatures</summary>
<pre class="code">
(signatures, mapper) {
            return <b title="Inlined">🔷instantiateList</b>(signatures, mapper, instantiateSignature);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>instantiateList</summary>
<pre class="code">
(items, mapper, instantiator) {
            if (items && items.length) {
                var result = [];
                for (var _i = 0, items_1 = items; _i &lt; items_1.length; _i++) {
                    var v = items_1[_i];
                    result.push(🔶️<i><b title="CallWithDescriptor">instantiator</b></i>(v, mapper));
                }
                return result;
            }
            return items;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>getSignaturesOfType</summary>
<pre class="code">
(type, kind) {
            return <b title="Inlined">🔷getSignaturesOfStructuredType</b>(<b title="Inlined">🔷getApparentType</b>(type), kind);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getApparentType</summary>
<pre class="code">
(type) {
            var t = type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 540672 /* TypeVariable */ ? 🔶️<i><b title="CallWithDescriptor">getApparentTypeOfTypeVariable</b></i>(type) : type;
            return t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 262178 /* StringLike */ ? globalStringType :
                t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 340 /* NumberLike */ ? globalNumberType :
                    t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 136 /* BooleanLike */ ? globalBooleanType :
                        t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 512 /* ESSymbol */ ? 🔶️<i><b title="CallWithDescriptor">getGlobalESSymbolType</b></i>() :
                            t;
        }</pre>

</details>
<details>
<summary>getSignaturesOfStructuredType</summary>
<pre class="code">
(type, kind) {
            if (type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 229376 /* StructuredType */) {
                var resolved = 🔶<i><b title="Did not inline: target text too big">resolveStructuredTypeMembers</b></i>(type);
                return kind === 0 /* Call */ ? resolved⚠️<i><b title="LoadNamedGeneric">.callSignatures</b></i> : resolved⚠️<i><b title="LoadNamedGeneric">.constructSignatures</b></i>;
            }
            return emptyArray;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>instantiateSignatures</summary>
<pre class="code">
(signatures, mapper) {
            return <b title="Inlined">🔷instantiateList</b>(signatures, mapper, instantiateSignature);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>instantiateList</summary>
<pre class="code">
(items, mapper, instantiator) {
            if (items && items.length) {
                var result = [];
                for (var _i = 0, items_1 = items; _i &lt; items_1.length; _i++) {
                    var v = items_1[_i];
                    result.push(🔶️<i><b title="CallWithDescriptor">instantiator</b></i>(v, mapper));
                }
                return result;
            }
            return items;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>getIndexInfoOfType</summary>
<pre class="code">
(type, kind) {
            return 🔶️<i><b title="CallWithDescriptor">getIndexInfoOfStructuredType</b></i>(<b title="Inlined">🔷getApparentType</b>(type), kind);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getApparentType</summary>
<pre class="code">
(type) {
            var t = type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 540672 /* TypeVariable */ ? 🔶️<i><b title="CallWithDescriptor">getApparentTypeOfTypeVariable</b></i>(type) : type;
            return t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 262178 /* StringLike */ ? globalStringType :
                t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 340 /* NumberLike */ ? globalNumberType :
                    t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 136 /* BooleanLike */ ? globalBooleanType :
                        t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 512 /* ESSymbol */ ? 🔶️<i><b title="CallWithDescriptor">getGlobalESSymbolType</b></i>() :
                            t;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### checkTypeParameter:
<pre class="code">
(node) {
            // Grammar Checking
            if (node.expression) {
                🔶️<i><b title="CallWithDescriptor">grammarErrorOnFirstToken</b></i>(node⚠️<i><b title="LoadNamedGeneric">.expression</b></i>, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Type_expected</b></i>);
            }
            🔶<i><b title="Did not inline: target text too big">checkSourceElement</b></i>(node.constraint);
            🔶<i><b title="Did not inline: target text too big">getConstraintOfTypeParameter</b></i>(<b title="Inlined">🔷getDeclaredTypeOfTypeParameter</b>(<b title="Inlined">🔷getSymbolOfNode</b>(node)));
            if (produceDiagnostics) {
                <b title="Inlined">🔷checkTypeNameIsReserved</b>(node.name, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>.Type_parameter_name_cannot_be_0);
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getSymbolOfNode</summary>
<pre class="code">
(node) {
            return <b title="Inlined">🔷getMergedSymbol</b>(node.symbol);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getMergedSymbol</summary>
<pre class="code">
(symbol) {
            var merged;
            return symbol && symbol⚠️<i><b title="LoadNamedGeneric">.mergeId</b></i> && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>getDeclaredTypeOfTypeParameter</summary>
<pre class="code">
(symbol) {
            var links = <b title="Inlined">🔷getSymbolLinks</b>(symbol);
            if (!links.declaredType) {
                var type = <b title="Inlined">🔷createType</b>(16384 /* TypeParameter */);
                type.symbol = symbol;
                if (!ts.🔶<i><b title="Did not inline: unknown">getDeclarationOfKind</b></i>(symbol, 143 /* TypeParameter */).constraint) {
                    type.constraint ⚠️<i><b title="StoreNamedGeneric">= noConstraintType</b></i>;
                }
                links.declaredType = type;
            }
            return links.declaredType;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getSymbolLinks</summary>
<pre class="code">
(symbol) {
            if (symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 67108864 /* Transient */)
                return symbol;
            var id = <b title="Inlined">🔷getSymbolId</b>(symbol);
            return symbolLinks⚠️<i><b title="LoadKeyedGeneric">[id]</b></i> || (symbolLinks[id] = {});
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getSymbolId</summary>
<pre class="code">
(symbol) {
        if (!symbol⚠️<i><b title="LoadNamedGeneric">.id</b></i>) {
            symbol.id ⚠️<i><b title="StoreNamedGeneric">= nextSymbolId</b></i>;
            nextSymbolId++;
        }
        return symbol⚠️<i><b title="LoadNamedGeneric">.id</b></i>;
    }</pre>

</details>
</blockquote>

</details>
<details>
<summary>createType</summary>
<pre class="code">
(flags) {
            var result = <b title="Inlined">🔷new Type</b>(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new Type</summary>
<pre class="code">
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>checkTypeNameIsReserved</summary>
<pre class="code">
(name, message) {
            // TS 1.0 spec (April 2014): 3.6.1
            // The predefined type keywords are reserved and cannot be used as names of user defined types.
            switch (name.text) {
                case "any":
                case "number":
                case "boolean":
                case "string":
                case "symbol":
                case "void":
                    🔶️<i><b title="CallWithDescriptor">error</b></i>(name, message, name⚠️<i><b title="LoadNamedGeneric">.text</b></i>);
            }
        }</pre>

</details>
</blockquote>



### getTypeFromLiteralTypeNode:
<pre class="code">
(node) {
            var links = <b title="Inlined">🔷getNodeLinks</b>(node);
            if (!links.resolvedType) {
                links.resolvedType ⚠️<i><b title="StoreNamedGeneric">= getRegularTypeOfLiteralType</b></i>(checkExpression(node.literal));
            }
            return links.resolvedType;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getNodeLinks</summary>
<pre class="code">
(node) {
            var nodeId = <b title="Inlined">🔷getNodeId</b>(node);
            return nodeLinks⚠️<i><b title="LoadKeyedGeneric">[nodeId]</b></i> || (nodeLinks[nodeId] = { flags: 0 });
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getNodeId</summary>
<pre class="code">
(node) {
        if (!node⚠️<i><b title="LoadNamedGeneric">.id</b></i>) {
            node.id ⚠️<i><b title="StoreNamedGeneric">= nextNodeId</b></i>;
            nextNodeId++;
        }
        return node⚠️<i><b title="LoadNamedGeneric">.id</b></i>;
    }</pre>

</details>
</blockquote>

</details>
<details>
<summary>getRegularTypeOfLiteralType</summary>
<pre class="code">
(type) {
            return type.flags & 96 /* StringOrNumberLiteral */ && type.flags & 1048576 /* FreshLiteral */ ? type.regularType : type;
        }</pre>

</details>
</blockquote>



### checkLiteralExpression:
<pre class="code">
(node) {
            if (node.kind === 8 /* NumericLiteral */) {
                🔶️<i><b title="CallWithDescriptor">checkGrammarNumericLiteral</b></i>(node);
            }
            ⚠️<i><b title="CompareGeneric">switch</b></i> (node.kind) {
                case 9 /* StringLiteral */:
                    return <b title="Inlined">🔷getFreshTypeOfLiteralType</b>(<b title="Inlined">🔷getLiteralTypeForText</b>(32 /* StringLiteral */, node.text));
                case 8 /* NumericLiteral */:
                    return 🔶️<i><b title="CallWithDescriptor">getFreshTypeOfLiteralType</b></i>(🔶️<i><b title="CallWithDescriptor">getLiteralTypeForText</b></i>(64 /* NumberLiteral */, node⚠️<i><b title="LoadNamedGeneric">.text</b></i>));
                case 100 /* TrueKeyword */:
                    return trueType;
                case 85 /* FalseKeyword */:
                    return falseType;
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getLiteralTypeForText</summary>
<pre class="code">
(flags, text) {
            var map = flags & 32 /* StringLiteral */ ? stringLiteralTypes : numericLiteralTypes;
            return map⚠️<i><b title="LoadKeyedGeneric">[text]</b></i> || (map[text] ⚠️<i><b title="StoreKeyedGeneric">= createLiteralType</b></i>(flags, text));
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createLiteralType</summary>
<pre class="code">
(flags, text) {
            var type = <b title="Inlined">🔷createType</b>(flags);
            type.text = text;
            return type;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createType</summary>
<pre class="code">
(flags) {
            var result = <b title="Inlined">🔷new Type</b>(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new Type</summary>
<pre class="code">
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>getFreshTypeOfLiteralType</summary>
<pre class="code">
(type) {
            if (type.flags & 96 /* StringOrNumberLiteral */ && !(type.flags & 1048576 /* FreshLiteral */)) {
                if (!type.freshType) {
                    var freshType = <b title="Inlined">🔷createLiteralType</b>(type.flags | 1048576 /* FreshLiteral */, type.text);
                    freshType.regularType ⚠️<i><b title="StoreNamedGeneric">= type</b></i>;
                    type.freshType ⚠️<i><b title="StoreNamedGeneric">= freshType</b></i>;
                }
                return type.freshType;
            }
            return type;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createLiteralType</summary>
<pre class="code">
(flags, text) {
            var type = <b title="Inlined">🔷createType</b>(flags);
            type.text = text;
            return type;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createType</summary>
<pre class="code">
(flags) {
            var result = <b title="Inlined">🔷new Type</b>(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new Type</summary>
<pre class="code">
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>



### isInferentialContext:
<pre class="code">
(mapper) {
            return mapper && mapper⚠️<i><b title="LoadNamedGeneric">.context</b></i>;
        }</pre>



### isConstEnumObjectType:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(type) {
            return <b title="Inlined">🔷getObjectFlags</b>(type) & 16 /* Anonymous */ && type.symbol && <b title="Inlined">🔷isConstEnumSymbol</b>(type.symbol);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getObjectFlags</summary>
<pre class="code">
(type) {
            return type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 32768 /* Object */ ? type⚠️<i><b title="LoadNamedGeneric">.objectFlags</b></i> : 0;
        }</pre>

</details>
<details>
<summary>isConstEnumSymbol</summary>
<pre class="code">
(symbol) {
            return (symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 128 /* ConstEnum */) !== 0;
        }</pre>

</details>
</blockquote>



### getSignatureFromDeclaration:
<pre class="code">
(declaration) {
            var links = <b title="Inlined">🔷getNodeLinks</b>(declaration);
            if (!links.resolvedSignature) {
                var parameters = [];
                var hasLiteralTypes = false;
                var minArgumentCount = -1;
                var thisParameter = undefined;
                var hasThisParameter = void 0;
                var isJSConstructSignature = ts.🔶<i><b title="Did not inline: unknown">isJSDocConstructSignature</b></i>(declaration);
                // If this is a JSDoc construct signature, then skip the first parameter in the
                // parameter list.  The first parameter represents the return type of the construct
                // signature.
                for (var i = isJSConstructSignature ? 1 : 0, n = declaration⚠️<i><b title="LoadNamedGeneric">.parameters</b></i>.length; i &lt; n; i++) {
                    var param = declaration⚠️<i><b title="LoadNamedGeneric">.parameters</b></i>[i];
                    var paramSymbol = param.symbol;
                    // Include parameter symbol instead of property symbol in the signature
                    if (paramSymbol && !!(paramSymbol.flags & 4 /* Property */) && !ts.🔶<i><b title="Did not inline: unknown">isBindingPattern</b></i>(param⚠️<i><b title="LoadNamedGeneric">.name</b></i>)) {
                        var resolvedSymbol = 🔶<i><b title="Did not inline: target text too big">resolveName</b></i>(param, paramSymbol⚠️<i><b title="LoadNamedGeneric">.name</b></i>, 107455 /* Value */, undefined, undefined);
                        paramSymbol = resolvedSymbol;
                    }
                    if (i === 0 && paramSymbol.name === "this") {
                        hasThisParameter = true;
                        thisParameter = param.symbol;
                    }
                    else {
                        parameters.push(paramSymbol);
                    }
                    if (param.type && param.type⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 171 /* LiteralType */) {
                        hasLiteralTypes = true;
                    }
                    if (param.initializer || param.questionToken || param.dotDotDotToken || 🔶️<i><b title="CallWithDescriptor">isJSDocOptionalParameter</b></i>(param)) {
                        if (minArgumentCount &lt; 0) {
                            minArgumentCount = i - (hasThisParameter ? 1 : 0);
                        }
                    }
                    else {
                        // If we see any required parameters, it means the prior ones were not in fact optional.
                        minArgumentCount = -1;
                    }
                }
                // If only one accessor includes a this-type annotation, the other behaves as if it had the same type annotation
                if ((declaration⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 151 /* GetAccessor */ || declaration⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 152 /* SetAccessor */) &&
                    !ts.🔶<i><b title="Did not inline: unknown">hasDynamicName</b></i>(declaration) &&
                    (!hasThisParameter || !thisParameter)) {
                    var otherKind = declaration⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 151</b></i> /* GetAccessor */ ? 152 /* SetAccessor */ : 151 /* GetAccessor */;
                    var other = ts.⚠️<i><b title="LoadNamedGeneric">getDeclarationOfKind</b></i>(declaration⚠️<i><b title="LoadNamedGeneric">.symbol</b></i>, otherKind);
                    if (other) {
                        thisParameter = 🔶️<i><b title="CallWithDescriptor">getAnnotatedAccessorThisParameter</b></i>(other);
                    }
                }
                if (minArgumentCount &lt; 0) {
                    minArgumentCount = declaration⚠️<i><b title="LoadNamedGeneric">.parameters</b></i>.length - (hasThisParameter ? 1 : 0);
                }
                if (isJSConstructSignature) {
                    minArgumentCount--;
                }
                var classType = declaration⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 150 /* Constructor */ ?
                    🔶<i><b title="Did not inline: target text too big">getDeclaredTypeOfClassOrInterface</b></i>(🔶<i><b title="Did not inline: unknown">getMergedSymbol</b></i>(declaration⚠️<i><b title="LoadNamedGeneric">.parent</b></i>⚠️<i><b title="LoadNamedGeneric">.symbol</b></i>))
                    : undefined;
                var typeParameters = classType ? classType⚠️<i><b title="LoadNamedGeneric">.localTypeParameters</b></i> :
                    declaration⚠️<i><b title="LoadNamedGeneric">.typeParameters</b></i> ? 🔶<i><b title="Did not inline: target has context-allocated variables">getTypeParametersFromDeclaration</b></i>(declaration.typeParameters) :
                        <b title="Inlined">🔷getTypeParametersFromJSDocTemplate</b>(declaration);
                var returnType = 🔶️<i><b title="CallWithDescriptor">getSignatureReturnTypeFromDeclaration</b></i>(declaration, isJSConstructSignature, classType);
                var typePredicate = declaration⚠️<i><b title="LoadNamedGeneric">.type</b></i> && declaration⚠️<i><b title="LoadNamedGeneric">.type</b></i>⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 156 /* TypePredicate */ ?
                    🔶️<i><b title="CallWithDescriptor">createTypePredicateFromTypePredicateNode</b></i>(declaration.type) :
                    undefined;
                links.resolvedSignature ⚠️<i><b title="StoreNamedGeneric">= createSignature</b></i>(declaration, typeParameters, thisParameter, parameters, returnType, typePredicate, minArgumentCount, ts.🔶<i><b title="Did not inline: unknown">hasRestParameter</b></i>(declaration), hasLiteralTypes);
            }
            return links.resolvedSignature;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getNodeLinks</summary>
<pre class="code">
(node) {
            var nodeId = <b title="Inlined">🔷getNodeId</b>(node);
            return nodeLinks⚠️<i><b title="LoadKeyedGeneric">[nodeId]</b></i> || (nodeLinks[nodeId] = { flags: 0 });
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getNodeId</summary>
<pre class="code">
(node) {
        if (!node⚠️<i><b title="LoadNamedGeneric">.id</b></i>) {
            node.id ⚠️<i><b title="StoreNamedGeneric">= nextNodeId</b></i>;
            nextNodeId++;
        }
        return node⚠️<i><b title="LoadNamedGeneric">.id</b></i>;
    }</pre>

</details>
</blockquote>

</details>
<details>
<summary>getTypeParametersFromJSDocTemplate</summary>
<pre class="code">
(declaration) {
            if (declaration⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 65536 /* JavaScriptFile */) {
                var templateTag = ts.🔶️<i><b title="CallWithDescriptor">getJSDocTemplateTag</b></i>(declaration);
                if (templateTag) {
                    return 🔶<i><b title="Did not inline: target has context-allocated variables">getTypeParametersFromDeclaration</b></i>(templateTag⚠️<i><b title="LoadNamedGeneric">.typeParameters</b></i>);
                }
            }
            return undefined;
        }</pre>

</details>
</blockquote>



### getSymbolOfNode:
<pre class="code">
(node) {
            return <b title="Inlined">🔷getMergedSymbol</b>(node.symbol);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getMergedSymbol</summary>
<pre class="code">
(symbol) {
            var merged;
            return symbol && symbol⚠️<i><b title="LoadNamedGeneric">.mergeId</b></i> && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }</pre>

</details>
</blockquote>



### createUnaryTypeMapper:
<pre class="code">
(source, target) {
            return 🔶️<i><b title="CallWithDescriptor">function</b></i> (t) { return t === source ? target : t; };
        }</pre>



### checkObjectTypeForDuplicateDeclarations:
<pre class="code">
(node) {
            var names = ts.⚠️<i><b title="LoadNamedGeneric">createMap</b></i>();
            for (var _i = 0, _a = node.members; _i &lt; _a.length; _i++) {
                var member = _a[_i];
                if (member⚠️<i><b title="LoadNamedGeneric">.kind</b></i> == 146 /* PropertySignature */) {
                    var memberName = void 0;
                    switch (member.name.kind) {
                        case 9 /* StringLiteral */:
                        case 8 /* NumericLiteral */:
                        case 70 /* Identifier */:
                            memberName = member.name.text;
                            break;
                        default:
                            continue;
                    }
                    if (names⚠️<i><b title="LoadKeyedGeneric">[memberName]</b></i>) {
                        🔶️<i><b title="CallWithDescriptor">error</b></i>(member⚠️<i><b title="LoadNamedGeneric">.symbol</b></i>⚠️<i><b title="LoadNamedGeneric">.valueDeclaration</b></i>⚠️<i><b title="LoadNamedGeneric">.name</b></i>, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Duplicate_identifier_0</b></i>, memberName);
                        🔶️<i><b title="CallWithDescriptor">error</b></i>(member⚠️<i><b title="LoadNamedGeneric">.name</b></i>, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Duplicate_identifier_0</b></i>, memberName);
                    }
                    else {
                        names[memberName] ⚠️<i><b title="StoreKeyedGeneric">= true</b></i>;
                    }
                }
            }
        }</pre>



### checkFunctionOrConstructorSymbol:
<pre class="code">
(symbol) {
            if (!produceDiagnostics) {
                return;
            }
            🔶️<i><b title="CallWithDescriptor">function</b></i> getCanonicalOverload(overloads, implementation) {
                // Consider the canonical set of flags to be the flags of the bodyDeclaration or the first declaration
                // Error on all deviations from this canonical set of flags
                // The caveat is that if some overloads are defined in lib.d.ts, we don't want to
                // report the errors on those. To achieve this, we will say that the implementation is
                // the canonical signature only if it is in the same container as the first overload
                var implementationSharesContainerWithFirstOverload = implementation !== undefined && implementation.parent === overloads[0].parent;
                return implementationSharesContainerWithFirstOverload ? implementation : overloads[0];
            }
            🔶️<i><b title="CallWithDescriptor">function</b></i> checkFlagAgreementBetweenOverloads(overloads, implementation, flagsToCheck, someOverloadFlags, allOverloadFlags) {
                // Error if some overloads have a flag that is not shared by all overloads. To find the
                // deviations, we XOR someOverloadFlags with allOverloadFlags
                var someButNotAllOverloadFlags = someOverloadFlags ^ allOverloadFlags;
                if (someButNotAllOverloadFlags !== 0) {
                    var canonicalFlags_1 = getEffectiveDeclarationFlags(getCanonicalOverload(overloads, implementation), flagsToCheck);
                    ts.forEach(overloads, function (o) {
                        var deviation = getEffectiveDeclarationFlags(o, flagsToCheck) ^ canonicalFlags_1;
                        if (deviation & 1 /* Export */) {
                            error(o.name, ts.Diagnostics.Overload_signatures_must_all_be_exported_or_non_exported);
                        }
                        else if (deviation & 2 /* Ambient */) {
                            error(o.name, ts.Diagnostics.Overload_signatures_must_all_be_ambient_or_non_ambient);
                        }
                        else if (deviation & (8 /* Private */ | 16 /* Protected */)) {
                            error(o.name || o, ts.Diagnostics.Overload_signatures_must_all_be_public_private_or_protected);
                        }
                        else if (deviation & 128 /* Abstract */) {
                            error(o.name, ts.Diagnostics.Overload_signatures_must_all_be_abstract_or_non_abstract);
                        }
                    });
                }
            }
            🔶️<i><b title="CallWithDescriptor">function</b></i> checkQuestionTokenAgreementBetweenOverloads(overloads, implementation, someHaveQuestionToken, allHaveQuestionToken) {
                if (someHaveQuestionToken !== allHaveQuestionToken) {
                    var canonicalHasQuestionToken_1 = ts.hasQuestionToken(getCanonicalOverload(overloads, implementation));
                    ts.forEach(overloads, function (o) {
                        var deviation = ts.hasQuestionToken(o) !== canonicalHasQuestionToken_1;
                        if (deviation) {
                            error(o.name, ts.Diagnostics.Overload_signatures_must_all_be_optional_or_required);
                        }
                    });
                }
            }
            var flagsToCheck = 1 /* Export */ | 2 /* Ambient */ | 8 /* Private */ | 16 /* Protected */ | 128 /* Abstract */;
            var someNodeFlags = 0 /* None */;
            var allNodeFlags = flagsToCheck;
            var someHaveQuestionToken = false;
            var allHaveQuestionToken = true;
            var hasOverloads = false;
            var bodyDeclaration;
            var lastSeenNonAmbientDeclaration;
            var previousDeclaration;
            var declarations = symbol.declarations;
            var isConstructor = (symbol.flags & 16384 /* Constructor */) !== 0;
            🔶️<i><b title="CallWithDescriptor">function</b></i> reportImplementationExpectedError(node) {
                if (node.name && ts.nodeIsMissing(node.name)) {
                    return;
                }
                var seen = false;
                var subsequentNode = ts.forEachChild(node.parent, function (c) {
                    if (seen) {
                        return c;
                    }
                    else {
                        seen = c === node;
                    }
                });
                // We may be here because of some extra nodes between overloads that could not be parsed into a valid node.
                // In this case the subsequent node is not really consecutive (.pos !== node.end), and we must ignore it here.
                if (subsequentNode && subsequentNode.pos === node.end) {
                    if (subsequentNode.kind === node.kind) {
                        var errorNode_1 = subsequentNode.name || subsequentNode;
                        // TODO(jfreeman): These are methods, so handle computed name case
                        if (node.name && subsequentNode.name && node.name.text === subsequentNode.name.text) {
                            var reportError = (node.kind === 149 /* MethodDeclaration */ || node.kind === 148 /* MethodSignature */) &&
                                (ts.getModifierFlags(node) & 32 /* Static */) !== (ts.getModifierFlags(subsequentNode) & 32 /* Static */);
                            // we can get here in two cases
                            // 1. mixed static and instance class members
                            // 2. something with the same name was defined before the set of overloads that prevents them from merging
                            // here we'll report error only for the first case since for second we should already report error in binder
                            if (reportError) {
                                var diagnostic = ts.getModifierFlags(node) & 32 /* Static */ ? ts.Diagnostics.Function_overload_must_be_static : ts.Diagnostics.Function_overload_must_not_be_static;
                                error(errorNode_1, diagnostic);
                            }
                            return;
                        }
                        else if (ts.nodeIsPresent(subsequentNode.body)) {
                            error(errorNode_1, ts.Diagnostics.Function_implementation_name_must_be_0, ts.declarationNameToString(node.name));
                            return;
                        }
                    }
                }
                var errorNode = node.name || node;
                if (isConstructor) {
                    error(errorNode, ts.Diagnostics.Constructor_implementation_is_missing);
                }
                else {
                    // Report different errors regarding non-consecutive blocks of declarations depending on whether
                    // the node in question is abstract.
                    if (ts.getModifierFlags(node) & 128 /* Abstract */) {
                        error(errorNode, ts.Diagnostics.All_declarations_of_an_abstract_method_must_be_consecutive);
                    }
                    else {
                        error(errorNode, ts.Diagnostics.Function_implementation_is_missing_or_not_immediately_following_the_declaration);
                    }
                }
            }
            var duplicateFunctionDeclaration = false;
            var multipleConstructorImplementation = false;
            for (var _i = 0, declarations_4 = declarations; _i &lt; declarations_4.length; _i++) {
                var current = declarations_4[_i];
                var node = current;
                var inAmbientContext = ts.⚠️<i><b title="LoadNamedGeneric">isInAmbientContext</b></i>(node);
                var inAmbientContextOrInterface = node⚠️<i><b title="LoadNamedGeneric">.parent</b></i>⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 227 /* InterfaceDeclaration */ || node.parent.kind === 161 /* TypeLiteral */ || inAmbientContext;
                if (inAmbientContextOrInterface) {
                    // check if declarations are consecutive only if they are non-ambient
                    // 1. ambient declarations can be interleaved
                    // i.e. this is legal
                    //     declare function foo();
                    //     declare function bar();
                    //     declare function foo();
                    // 2. mixing ambient and non-ambient declarations is a separate error that will be reported - do not want to report an extra one
                    previousDeclaration = undefined;
                }
                if (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 225 /* FunctionDeclaration */ || node.kind === 149 /* MethodDeclaration */ || node.kind === 148 /* MethodSignature */ || node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 150</b></i> /* Constructor */) {
                    var currentNodeFlags = 🔶<i><b title="Did not inline: target text too big">getEffectiveDeclarationFlags</b></i>(node, flagsToCheck);
                    someNodeFlags |= currentNodeFlags;
                    allNodeFlags &= currentNodeFlags;
                    someHaveQuestionToken = someHaveQuestionToken || ts.⚠️<i><b title="LoadNamedGeneric">hasQuestionToken</b></i>(node);
                    allHaveQuestionToken = allHaveQuestionToken && ts.⚠️<i><b title="LoadNamedGeneric">hasQuestionToken</b></i>(node);
                    if (ts.🔶<i><b title="Did not inline: unknown">nodeIsPresent</b></i>(node⚠️<i><b title="LoadNamedGeneric">.body</b></i>) && bodyDeclaration) {
                        if (isConstructor) {
                            multipleConstructorImplementation = true;
                        }
                        else {
                            duplicateFunctionDeclaration = true;
                        }
                    }
                    else if (previousDeclaration && previousDeclaration⚠️<i><b title="LoadNamedGeneric">.parent</b></i> ⚠️<i><b title="CompareGeneric">=== node</b></i>⚠️<i><b title="LoadNamedGeneric">.parent</b></i> && previousDeclaration⚠️<i><b title="LoadNamedGeneric">.end</b></i> ⚠️<i><b title="CompareGeneric">!== node</b></i>⚠️<i><b title="LoadNamedGeneric">.pos</b></i>) {
                        🔶️<i><b title="CallWithDescriptor">reportImplementationExpectedError</b></i>(previousDeclaration);
                    }
                    if (ts.🔶<i><b title="Did not inline: unknown">nodeIsPresent</b></i>(node⚠️<i><b title="LoadNamedGeneric">.body</b></i>)) {
                        if (!bodyDeclaration) {
                            bodyDeclaration = node;
                        }
                    }
                    else {
                        hasOverloads = true;
                    }
                    previousDeclaration = node;
                    if (!inAmbientContextOrInterface) {
                        lastSeenNonAmbientDeclaration = node;
                    }
                }
            }
            if (multipleConstructorImplementation) {
                ts.🔶<i><b title="Did not inline: unknown">forEach</b></i>(declarations, 🔶️<i><b title="CallWithDescriptor">function</b></i> (declaration) {
                    error(declaration, ts.Diagnostics.Multiple_constructor_implementations_are_not_allowed);
                });
            }
            if (duplicateFunctionDeclaration) {
                ts.🔶<i><b title="Did not inline: unknown">forEach</b></i>(declarations, 🔶️<i><b title="CallWithDescriptor">function</b></i> (declaration) {
                    error(declaration.name, ts.Diagnostics.Duplicate_function_implementation);
                });
            }
            // Abstract methods can't have an implementation -- in particular, they don't need one.
            if (lastSeenNonAmbientDeclaration && !lastSeenNonAmbientDeclaration⚠️<i><b title="LoadNamedGeneric">.body</b></i> &&
                !(ts.🔶<i><b title="Did not inline: target text too big">getModifierFlags</b></i>(lastSeenNonAmbientDeclaration) ⚠️<i><b title="Bitwise">& 128</b></i> /* Abstract */) && !lastSeenNonAmbientDeclaration⚠️<i><b title="LoadNamedGeneric">.questionToken</b></i>) {
                🔶️<i><b title="CallWithDescriptor">reportImplementationExpectedError</b></i>(lastSeenNonAmbientDeclaration);
            }
            if (hasOverloads) {
                🔶️<i><b title="CallWithDescriptor">checkFlagAgreementBetweenOverloads</b></i>(declarations, bodyDeclaration, flagsToCheck, someNodeFlags, allNodeFlags);
                🔶️<i><b title="CallWithDescriptor">checkQuestionTokenAgreementBetweenOverloads</b></i>(declarations, bodyDeclaration, someHaveQuestionToken, allHaveQuestionToken);
                if (bodyDeclaration) {
                    var signatures = 🔶️<i><b title="CallWithDescriptor">getSignaturesOfSymbol</b></i>(symbol);
                    var bodySignature = 🔶<i><b title="Did not inline: unknown">getSignatureFromDeclaration</b></i>(bodyDeclaration);
                    for (var _a = 0, signatures_3 = signatures; _a &lt; signatures_3⚠️<i><b title="LoadNamedGeneric">.length</b></i>; _a++) {
                        var signature = signatures_3⚠️<i><b title="LoadKeyedGeneric">[_a]</b></i>;
                        if (!🔶️<i><b title="CallWithDescriptor">isImplementationCompatibleWithOverload</b></i>(bodySignature, signature)) {
                            🔶️<i><b title="CallWithDescriptor">error</b></i>(signature⚠️<i><b title="LoadNamedGeneric">.declaration</b></i>, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Overload_signature_is_not_compatible_with_function_implementation</b></i>);
                            break;
                        }
                    }
                }
            }
        }</pre>



### getTypeFromTypeOperatorNode:
<pre class="code">
(node) {
            var links = <b title="Inlined">🔷getNodeLinks</b>(node);
            if (!links.resolvedType) {
                links.resolvedType ⚠️<i><b title="StoreNamedGeneric">= getIndexType</b></i>(getTypeFromTypeNode(node.type));
            }
            return links.resolvedType;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getNodeLinks</summary>
<pre class="code">
(node) {
            var nodeId = <b title="Inlined">🔷getNodeId</b>(node);
            return nodeLinks⚠️<i><b title="LoadKeyedGeneric">[nodeId]</b></i> || (nodeLinks[nodeId] = { flags: 0 });
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getNodeId</summary>
<pre class="code">
(node) {
        if (!node⚠️<i><b title="LoadNamedGeneric">.id</b></i>) {
            node.id ⚠️<i><b title="StoreNamedGeneric">= nextNodeId</b></i>;
            nextNodeId++;
        }
        return node⚠️<i><b title="LoadNamedGeneric">.id</b></i>;
    }</pre>

</details>
</blockquote>

</details>
<details>
<summary>getIndexType</summary>
<pre class="code">
(type) {
            return <b title="Inlined">🔷maybeTypeOfKind</b>(type, 540672 /* TypeVariable */) ? <b title="Inlined">🔷getIndexTypeForGenericType</b>(type) :
                <b title="Inlined">🔷getObjectFlags</b>(type) & 32 /* Mapped */ ? 🔶️<i><b title="CallWithDescriptor">getConstraintTypeFromMappedType</b></i>(type) :
                    type.flags & 1 /* Any */ || <b title="Inlined">🔷getIndexInfoOfType</b>(type, 0 /* String */) ? stringType :
                        <b title="Inlined">🔷getLiteralTypeFromPropertyNames</b>(type);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>maybeTypeOfKind</summary>
<pre class="code">
(type, kind) {
            if (type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & kind) {
                return true;
            }
            if (type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 196608 /* UnionOrIntersection */) {
                var types = type.types;
                for (var _i = 0, types_15 = types; _i &lt; types_15.length; _i++) {
                    var t = types_15[_i];
                    if (🔶️<i><b title="CallWithDescriptor">maybeTypeOfKind</b></i>(t, kind)) {
                        return true;
                    }
                }
            }
            return false;
        }</pre>

</details>
<details>
<summary>getIndexTypeForGenericType</summary>
<pre class="code">
(type) {
            if (!type.resolvedIndexType) {
                type.resolvedIndexType = <b title="Inlined">🔷createType</b>(262144 /* Index */);
                type.resolvedIndexType.type = type;
            }
            return type.resolvedIndexType;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createType</summary>
<pre class="code">
(flags) {
            var result = <b title="Inlined">🔷new Type</b>(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new Type</summary>
<pre class="code">
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>getObjectFlags</summary>
<pre class="code">
(type) {
            return type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 32768 /* Object */ ? type⚠️<i><b title="LoadNamedGeneric">.objectFlags</b></i> : 0;
        }</pre>

</details>
<details>
<summary>getIndexInfoOfType</summary>
<pre class="code">
(type, kind) {
            return <b title="Inlined">🔷getIndexInfoOfStructuredType</b>(<b title="Inlined">🔷getApparentType</b>(type), kind);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getApparentType</summary>
<pre class="code">
(type) {
            var t = type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 540672 /* TypeVariable */ ? 🔶️<i><b title="CallWithDescriptor">getApparentTypeOfTypeVariable</b></i>(type) : type;
            return t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 262178 /* StringLike */ ? globalStringType :
                t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 340 /* NumberLike */ ? globalNumberType :
                    t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 136 /* BooleanLike */ ? globalBooleanType :
                        t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 512 /* ESSymbol */ ? 🔶️<i><b title="CallWithDescriptor">getGlobalESSymbolType</b></i>() :
                            t;
        }</pre>

</details>
<details>
<summary>getIndexInfoOfStructuredType</summary>
<pre class="code">
(type, kind) {
            if (type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 229376 /* StructuredType */) {
                var resolved = 🔶<i><b title="Did not inline: target text too big">resolveStructuredTypeMembers</b></i>(type);
                return kind === 0 /* String */ ? resolved⚠️<i><b title="LoadNamedGeneric">.stringIndexInfo</b></i> : resolved⚠️<i><b title="LoadNamedGeneric">.numberIndexInfo</b></i>;
            }
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>getLiteralTypeFromPropertyNames</summary>
<pre class="code">
(type) {
            return 🔶<i><b title="Did not inline: target text too big">getUnionType</b></i>(ts.🔶<i><b title="Did not inline: unknown">map</b></i>(<b title="Inlined">🔷getPropertiesOfType</b>(type), getLiteralTypeFromPropertyName));
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getPropertiesOfType</summary>
<pre class="code">
(type) {
            type = <b title="Inlined">🔷getApparentType</b>(type);
            return type.flags & 196608 /* UnionOrIntersection */ ?
                🔶️<i><b title="CallWithDescriptor">getPropertiesOfUnionOrIntersectionType</b></i>(type) :
                <b title="Inlined">🔷getPropertiesOfObjectType</b>(type);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getApparentType</summary>
<pre class="code">
(type) {
            var t = type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 540672 /* TypeVariable */ ? 🔶️<i><b title="CallWithDescriptor">getApparentTypeOfTypeVariable</b></i>(type) : type;
            return t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 262178 /* StringLike */ ? globalStringType :
                t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 340 /* NumberLike */ ? globalNumberType :
                    t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 136 /* BooleanLike */ ? globalBooleanType :
                        t⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 512 /* ESSymbol */ ? 🔶️<i><b title="CallWithDescriptor">getGlobalESSymbolType</b></i>() :
                            t;
        }</pre>

</details>
<details>
<summary>getPropertiesOfObjectType</summary>
<pre class="code">
(type) {
            if (type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 32768 /* Object */) {
                return 🔶<i><b title="Did not inline: target text too big">resolveStructuredTypeMembers</b></i>(type)⚠️<i><b title="LoadNamedGeneric">.properties</b></i>;
            }
            return emptyArray;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>



### getTypeParametersFromDeclaration:
<pre class="code">
(typeParameterDeclarations) {
            var result = [];
            ts.🔶<i><b title="Did not inline: unknown">forEach</b></i>(typeParameterDeclarations, 🔶️<i><b title="CallWithDescriptor">function</b></i> (node) {
                var tp = getDeclaredTypeOfTypeParameter(node.symbol);
                if (!ts.contains(result, tp)) {
                    result.push(tp);
                }
            });
            return result;
        }</pre>



### getDeclarationModifierFlagsFromSymbol:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(s) {
            return s⚠️<i><b title="LoadNamedGeneric">.valueDeclaration</b></i> ? ts.🔶<i><b title="Did not inline: unknown">getCombinedModifierFlags</b></i>(s⚠️<i><b title="LoadNamedGeneric">.valueDeclaration</b></i>) : s⚠️<i><b title="LoadNamedGeneric">.flags</b></i> ⚠️<i><b title="Bitwise">& 134217728</b></i> /* Prototype */ ? 4 /* Public */ | 32 /* Static */ : 0;
        }</pre>



### getTypeFromIndexedAccessTypeNode:
<pre class="code">
(node) {
            var links = <b title="Inlined">🔷getNodeLinks</b>(node);
            if (!links.resolvedType) {
                links.resolvedType ⚠️<i><b title="StoreNamedGeneric">= getIndexedAccessType</b></i>(🔶<i><b title="Did not inline: target text too big">getTypeFromTypeNode</b></i>(node.objectType), 🔶<i><b title="Did not inline: target text too big">getTypeFromTypeNode</b></i>(node.indexType), node);
            }
            return links.resolvedType;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getNodeLinks</summary>
<pre class="code">
(node) {
            var nodeId = <b title="Inlined">🔷getNodeId</b>(node);
            return nodeLinks⚠️<i><b title="LoadKeyedGeneric">[nodeId]</b></i> || (nodeLinks[nodeId] = { flags: 0 });
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getNodeId</summary>
<pre class="code">
(node) {
        if (!node⚠️<i><b title="LoadNamedGeneric">.id</b></i>) {
            node.id ⚠️<i><b title="StoreNamedGeneric">= nextNodeId</b></i>;
            nextNodeId++;
        }
        return node⚠️<i><b title="LoadNamedGeneric">.id</b></i>;
    }</pre>

</details>
</blockquote>

</details>
</blockquote>



### checkIndexedAccessType:
<pre class="code">
(node) {
            <b title="Inlined">🔷getTypeFromIndexedAccessTypeNode</b>(node);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getTypeFromIndexedAccessTypeNode</summary>
<pre class="code">
(node) {
            var links = <b title="Inlined">🔷getNodeLinks</b>(node);
            if (!links.resolvedType) {
                links.resolvedType ⚠️<i><b title="StoreNamedGeneric">= getIndexedAccessType</b></i>(🔶<i><b title="Did not inline: target text too big">getTypeFromTypeNode</b></i>(node.objectType), 🔶<i><b title="Did not inline: target text too big">getTypeFromTypeNode</b></i>(node.indexType), node);
            }
            return links.resolvedType;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getNodeLinks</summary>
<pre class="code">
(node) {
            var nodeId = <b title="Inlined">🔷getNodeId</b>(node);
            return nodeLinks⚠️<i><b title="LoadKeyedGeneric">[nodeId]</b></i> || (nodeLinks[nodeId] = { flags: 0 });
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getNodeId</summary>
<pre class="code">
(node) {
        if (!node⚠️<i><b title="LoadNamedGeneric">.id</b></i>) {
            node.id ⚠️<i><b title="StoreNamedGeneric">= nextNodeId</b></i>;
            nextNodeId++;
        }
        return node⚠️<i><b title="LoadNamedGeneric">.id</b></i>;
    }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>



### checkGrammarVariableDeclaration:
<pre class="code">
(node) {
            if (node.parent.parent.kind !== 212 /* ForInStatement */ && node.parent.parent.kind !== 213 /* ForOfStatement */) {
                if (ts.🔶<i><b title="Did not inline: unknown">isInAmbientContext</b></i>(node)) {
                    if (node.initializer) {
                        if (ts.⚠️<i><b title="LoadNamedGeneric">isConst</b></i>(node) && !node⚠️<i><b title="LoadNamedGeneric">.type</b></i>) {
                            if (!🔶️<i><b title="CallWithDescriptor">isStringOrNumberLiteralExpression</b></i>(node⚠️<i><b title="LoadNamedGeneric">.initializer</b></i>)) {
                                return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(node⚠️<i><b title="LoadNamedGeneric">.initializer</b></i>, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.A_const_initializer_in_an_ambient_context_must_be_a_string_or_numeric_literal</b></i>);
                            }
                        }
                        else {
                            // Error on equals token which immediate precedes the initializer
                            var equalsTokenLength = "=".length;
                            return 🔶️<i><b title="CallWithDescriptor">grammarErrorAtPos</b></i>(ts.🔶️<i><b title="CallWithDescriptor">getSourceFileOfNode</b></i>(node), node⚠️<i><b title="LoadNamedGeneric">.initializer</b></i>⚠️<i><b title="LoadNamedGeneric">.pos</b></i> ⚠️<i><b title="Sub">- equalsTokenLength</b></i>, equalsTokenLength, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Initializers_are_not_allowed_in_ambient_contexts</b></i>);
                        }
                    }
                    if (node.initializer && !(ts.⚠️<i><b title="LoadNamedGeneric">isConst</b></i>(node) && 🔶️<i><b title="CallWithDescriptor">isStringOrNumberLiteralExpression</b></i>(node⚠️<i><b title="LoadNamedGeneric">.initializer</b></i>))) {
                        // Error on equals token which immediate precedes the initializer
                        var equalsTokenLength = "=".length;
                        return 🔶️<i><b title="CallWithDescriptor">grammarErrorAtPos</b></i>(ts.🔶️<i><b title="CallWithDescriptor">getSourceFileOfNode</b></i>(node), node⚠️<i><b title="LoadNamedGeneric">.initializer</b></i>⚠️<i><b title="LoadNamedGeneric">.pos</b></i> ⚠️<i><b title="Sub">- equalsTokenLength</b></i>, equalsTokenLength, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Initializers_are_not_allowed_in_ambient_contexts</b></i>);
                    }
                }
                else if (!node⚠️<i><b title="LoadNamedGeneric">.initializer</b></i>) {
                    if (ts.⚠️<i><b title="LoadNamedGeneric">isBindingPattern</b></i>(node⚠️<i><b title="LoadNamedGeneric">.name</b></i>) && !ts.🔶<i><b title="Did not inline: unknown">isBindingPattern</b></i>(node⚠️<i><b title="LoadNamedGeneric">.parent</b></i>)) {
                        return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(node, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.A_destructuring_declaration_must_have_an_initializer</b></i>);
                    }
                    if (ts.⚠️<i><b title="LoadNamedGeneric">isConst</b></i>(node)) {
                        return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(node, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.const_declarations_must_be_initialized</b></i>);
                    }
                }
            }
            var checkLetConstNames = (ts.🔶<i><b title="Did not inline: unknown">isLet</b></i>(node) || ts.🔶<i><b title="Did not inline: unknown">isConst</b></i>(node));
            // 1. LexicalDeclaration : LetOrConst BindingList ;
            // It is a Syntax Error if the BoundNames of BindingList contains "let".
            // 2. ForDeclaration: ForDeclaration : LetOrConst ForBinding
            // It is a Syntax Error if the BoundNames of ForDeclaration contains "let".
            // It is a SyntaxError if a VariableDeclaration or VariableDeclarationNoIn occurs within strict code
            // and its Identifier is eval or arguments
            return checkLetConstNames && 🔶️<i><b title="CallWithDescriptor">checkGrammarNameInLetOrConstDeclarations</b></i>(node.name);
        }</pre>



### getIndexDeclarationOfSymbol:
<pre class="code">
(symbol, kind) {
            var syntaxKind = kind === 1 /* Number */ ? 132 /* NumberKeyword */ : 134 /* StringKeyword */;
            var indexSymbol = <b title="Inlined">🔷getIndexSymbol</b>(symbol);
            if (indexSymbol) {
                for (var _i = 0, _a = indexSymbol.declarations; _i &lt; _a.length; _i++) {
                    var decl = _a[_i];
                    var node = decl;
                    if (node.parameters.length === 1) {
                        var parameter = node.parameters[0];
                        if (parameter && parameter.type && parameter.type.kind === syntaxKind) {
                            return node;
                        }
                    }
                }
            }
            return undefined;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getIndexSymbol</summary>
<pre class="code">
(symbol) {
            return symbol⚠️<i><b title="LoadNamedGeneric">.members</b></i>⚠️<i><b title="LoadNamedGeneric">["__i</b></i>ndex"];
        }</pre>

</details>
</blockquote>



### checkTypeParameters:
<pre class="code">
(typeParameterDeclarations) {
            if (typeParameterDeclarations) {
                for (var i = 0, n = typeParameterDeclarations.length; i &lt; n; i++) {
                    var node = typeParameterDeclarations[i];
                    <b title="Inlined">🔷checkTypeParameter</b>(node);
                    if (produceDiagnostics) {
                        for (var j = 0; j &lt; i; j++) {
                            if (typeParameterDeclarations[j].symbol === node.symbol) {
                                🔶️<i><b title="CallWithDescriptor">error</b></i>(node⚠️<i><b title="LoadNamedGeneric">.name</b></i>, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Duplicate_identifier_0</b></i>, ts.🔶️<i><b title="CallWithDescriptor">declarationNameToString</b></i>(node⚠️<i><b title="LoadNamedGeneric">.name</b></i>));
                            }
                        }
                    }
                }
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>checkTypeParameter</summary>
<pre class="code">
(node) {
            // Grammar Checking
            if (node.expression) {
                🔶️<i><b title="CallWithDescriptor">grammarErrorOnFirstToken</b></i>(node⚠️<i><b title="LoadNamedGeneric">.expression</b></i>, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Type_expected</b></i>);
            }
            🔶<i><b title="Did not inline: target text too big">checkSourceElement</b></i>(node.constraint);
            🔶<i><b title="Did not inline: target text too big">getConstraintOfTypeParameter</b></i>(<b title="Inlined">🔷getDeclaredTypeOfTypeParameter</b>(<b title="Inlined">🔷getSymbolOfNode</b>(node)));
            if (produceDiagnostics) {
                <b title="Inlined">🔷checkTypeNameIsReserved</b>(node.name, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>.Type_parameter_name_cannot_be_0);
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getSymbolOfNode</summary>
<pre class="code">
(node) {
            return <b title="Inlined">🔷getMergedSymbol</b>(node.symbol);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getMergedSymbol</summary>
<pre class="code">
(symbol) {
            var merged;
            return symbol && symbol⚠️<i><b title="LoadNamedGeneric">.mergeId</b></i> && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>getDeclaredTypeOfTypeParameter</summary>
<pre class="code">
(symbol) {
            var links = <b title="Inlined">🔷getSymbolLinks</b>(symbol);
            if (!links.declaredType) {
                var type = <b title="Inlined">🔷createType</b>(16384 /* TypeParameter */);
                type.symbol = symbol;
                if (!ts.🔶<i><b title="Did not inline: unknown">getDeclarationOfKind</b></i>(symbol, 143 /* TypeParameter */).constraint) {
                    type.constraint ⚠️<i><b title="StoreNamedGeneric">= noConstraintType</b></i>;
                }
                links.declaredType = type;
            }
            return links.declaredType;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getSymbolLinks</summary>
<pre class="code">
(symbol) {
            if (symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 67108864 /* Transient */)
                return symbol;
            var id = <b title="Inlined">🔷getSymbolId</b>(symbol);
            return symbolLinks⚠️<i><b title="LoadKeyedGeneric">[id]</b></i> || (symbolLinks[id] = {});
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getSymbolId</summary>
<pre class="code">
(symbol) {
        if (!symbol⚠️<i><b title="LoadNamedGeneric">.id</b></i>) {
            symbol.id ⚠️<i><b title="StoreNamedGeneric">= nextSymbolId</b></i>;
            nextSymbolId++;
        }
        return symbol⚠️<i><b title="LoadNamedGeneric">.id</b></i>;
    }</pre>

</details>
</blockquote>

</details>
<details>
<summary>createType</summary>
<pre class="code">
(flags) {
            var result = <b title="Inlined">🔷new Type</b>(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new Type</summary>
<pre class="code">
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>checkTypeNameIsReserved</summary>
<pre class="code">
(name, message) {
            // TS 1.0 spec (April 2014): 3.6.1
            // The predefined type keywords are reserved and cannot be used as names of user defined types.
            switch (name.text) {
                case "any":
                case "number":
                case "boolean":
                case "string":
                case "symbol":
                case "void":
                    🔶️<i><b title="CallWithDescriptor">error</b></i>(name, message, name⚠️<i><b title="LoadNamedGeneric">.text</b></i>);
            }
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### ⛔ checkGrammarDecorators (deoptimizated):
<pre class="code">
(node) {
            if (!node⚠️<i><b title="LoadNamedGeneric">.decorators</b></i>) {
                return false;
            }
            if (!ts.⚠️<i><b title="LoadNamedGeneric">nodeCanBeDecorated</b></i>(node)) {
                if (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 149</b></i> /* MethodDeclaration */ && !ts.🔶<i><b title="Did not inline: unknown">nodeIsPresent</b></i>(node⚠️<i><b title="LoadNamedGeneric">.body</b></i>)) {
                    return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnFirstToken</b></i>(node, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.A_decorator_can_only_decorate_a_method_implementation_not_an_overload</b></i>);
                }
                else {
                    return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnFirstToken</b></i>(node, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Decorators_are_not_valid_here</b></i>);
                }
            }
            else if (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 151</b></i> /* GetAccessor */ || node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 152</b></i> /* SetAccessor */) {
                var accessors = ts.🔶️<i><b title="CallWithDescriptor">getAllAccessorDeclarations</b></i>(node⚠️<i><b title="LoadNamedGeneric">.parent</b></i>⚠️<i><b title="LoadNamedGeneric">.members</b></i>, node);
                if (accessors⚠️<i><b title="LoadNamedGeneric">.firstAccessor</b></i>⚠️<i><b title="LoadNamedGeneric">.decorators</b></i> && node ⚠️<i><b title="CompareGeneric">=== accessors</b></i>⚠️<i><b title="LoadNamedGeneric">.secondAccessor</b></i>) {
                    return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnFirstToken</b></i>(node, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Decorators_cannot_be_applied_to_multiple_get_Slashset_accessors_of_the_same_name</b></i>);
                }
            }
            return false;
        }</pre>

```diff
- Deopt: <JS Function nodeIsMissing (SharedFunctionInfo 0x3504a53cc419)> (opt #383) @2, FP to SP delta: 24, caller sp: 0x7fff5fbfda38
```

```diff
- Deopt: <JS Function getSymbol (SharedFunctionInfo 0x2e2f693e7951)> (opt #373) @13, FP to SP delta: 40, caller sp: 0x7fff5fbfd8b8
```

```diff
- Deopt: <JS Function resolveName (SharedFunctionInfo 0x2e2f693e7b91)> (opt #454) @114, FP to SP delta: 320, caller sp: 0x7fff5fbfda38
```

```diff
- Deopt: <JS Function needCollisionCheckForIdentifier (SharedFunctionInfo 0x1b98fbc0ca81)> (opt #472) @3, FP to SP delta: 32, caller sp: 0x7fff5fbfda30
```

```diff
- Deopt: <JS Function getTypeOfSymbol (SharedFunctionInfo 0x2e2f693ed051)> (opt #455) @2, FP to SP delta: 128, caller sp: 0x7fff5fbfda80
```

```diff
- Deopt: <JS Function getTypeOfVariableOrParameterOrProperty (SharedFunctionInfo 0x2e2f693ec8d1)> (opt #403) @16, FP to SP delta: 80, caller sp: 0x7fff5fbfda48
```

```diff
- Deopt: <JS Function isConstEnumObjectType (SharedFunctionInfo 0x1b98fbc08941)> (opt #503) @4, FP to SP delta: 32, caller sp: 0x7fff5fbfdb68
```



### resolveBaseTypesOfInterface:
<pre class="code">
(type) {
            type.resolvedBaseTypes ⚠️<i><b title="StoreNamedGeneric">= type</b></i>.resolvedBaseTypes || emptyArray;
            for (var _i = 0, _a = type.symbol.declarations; _i &lt; _a.length; _i++) {
                var declaration = _a[_i];
                if (declaration⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 227 /* InterfaceDeclaration */ && ts.⚠️<i><b title="LoadNamedGeneric">getInterfaceBaseTypeNodes</b></i>(declaration)) {
                    for (var _b = 0, _c = ts.⚠️<i><b title="LoadNamedGeneric">getInterfaceBaseTypeNodes</b></i>(declaration); _b &lt; _c.length; _b++) {
                        var node = _c[_b];
                        var baseType = getTypeFromTypeNode(node);
                        if (baseType !== unknownType) {
                            if (<b title="Inlined">🔷getObjectFlags</b>(<b title="Inlined">🔷getTargetType</b>(baseType)) & 3 /* ClassOrInterface */) {
                                if (type !== baseType && !🔶️<i><b title="CallWithDescriptor">hasBaseType</b></i>(baseType, type)) {
                                    if (type.resolvedBaseTypes === emptyArray) {
                                        type.resolvedBaseTypes = [baseType];
                                    }
                                    else {
                                        type.resolvedBaseTypes.push(baseType);
                                    }
                                }
                                else {
                                    🔶️<i><b title="CallWithDescriptor">error</b></i>(declaration, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Type_0_recursively_references_itself_as_a_base_type</b></i>, 🔶️<i><b title="CallWithDescriptor">typeToString</b></i>(type, /*enclosingDeclaration*/ undefined, 1 /* WriteArrayAsGenericType */));
                                }
                            }
                            else {
                                🔶️<i><b title="CallWithDescriptor">error</b></i>(node, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.An_interface_may_only_extend_a_class_or_another_interface</b></i>);
                            }
                        }
                    }
                }
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getTargetType</summary>
<pre class="code">
(type) {
            return <b title="Inlined">🔷getObjectFlags</b>(type) & 4 /* Reference */ ? type.target : type;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getObjectFlags</summary>
<pre class="code">
(type) {
            return type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 32768 /* Object */ ? type⚠️<i><b title="LoadNamedGeneric">.objectFlags</b></i> : 0;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>getObjectFlags</summary>
<pre class="code">
(type) {
            return type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 32768 /* Object */ ? type⚠️<i><b title="LoadNamedGeneric">.objectFlags</b></i> : 0;
        }</pre>

</details>
</blockquote>



### createTypeMapper:
<pre class="code">
(sources, targets) {
            var count = sources.length;
            var mapper = count == 1 ? 🔶<i><b title="Did not inline: target has context-allocated variables">createUnaryTypeMapper</b></i>(sources[0], targets ? targets[0] : anyType) :
                count == 2 ? 🔶️<i><b title="CallWithDescriptor">createBinaryTypeMapper</b></i>(sources[0], targets ? targets[0] : anyType, sources[1], targets ? targets[1] : anyType) :
                    🔶️<i><b title="CallWithDescriptor">createArrayTypeMapper</b></i>(sources, targets);
            mapper.mappedTypes ⚠️<i><b title="StoreNamedGeneric">= sources</b></i>;
            return mapper;
        }</pre>



### ⛔ reportErrorsFromWidening (deoptimizated):
<pre class="code">
(declaration, type) {
            if (produceDiagnostics && compilerOptions.noImplicitAny && type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> ⚠️<i><b title="Bitwise">& 2097152</b></i> /* ContainsWideningType */) {
                // Report implicit any error within type if possible, otherwise report error on declaration
                if (!🔶️<i><b title="CallWithDescriptor">reportWideningErrorsInType</b></i>(type)) {
                    🔶️<i><b title="CallWithDescriptor">reportImplicitAnyError</b></i>(declaration, type);
                }
            }
        }</pre>

```diff
- Deopt: <JS Function checkVariableStatement (SharedFunctionInfo 0x1b98fbc0d441)> (opt #466) @18, FP to SP delta: 88, caller sp: 0x7fff5fbfdfb8
```

```diff
- Deopt: <JS Function resolveEntityName (SharedFunctionInfo 0x2e2f693e9091)> (opt #398) @37, FP to SP delta: 128, caller sp: 0x7fff5fbfdb28
```



### checkGrammarVariableDeclarationList:
<pre class="code">
(declarationList) {
            var declarations = declarationList.declarations;
            if (<b title="Inlined">🔷checkGrammarForDisallowedTrailingComma</b>(declarationList.declarations)) {
                return true;
            }
            if (!declarationList.declarations.length) {
                return 🔶️<i><b title="CallWithDescriptor">grammarErrorAtPos</b></i>(ts.🔶️<i><b title="CallWithDescriptor">getSourceFileOfNode</b></i>(declarationList), declarations⚠️<i><b title="LoadNamedGeneric">.pos</b></i>, declarations⚠️<i><b title="LoadNamedGeneric">.end</b></i> ⚠️<i><b title="Sub">- declarations</b></i>⚠️<i><b title="LoadNamedGeneric">.pos</b></i>, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Variable_declaration_list_cannot_be_empty</b></i>);
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>checkGrammarForDisallowedTrailingComma</summary>
<pre class="code">
(list) {
            if (list && list.hasTrailingComma) {
                var start = list⚠️<i><b title="LoadNamedGeneric">.end</b></i> ⚠️<i><b title="Sub">- ","</b></i>.length;
                var end = list⚠️<i><b title="LoadNamedGeneric">.end</b></i>;
                var sourceFile = ts.🔶️<i><b title="CallWithDescriptor">getSourceFileOfNode</b></i>(list⚠️<i><b title="LoadKeyedGeneric">[0]</b></i>);
                return 🔶️<i><b title="CallWithDescriptor">grammarErrorAtPos</b></i>(sourceFile, start, end ⚠️<i><b title="Sub">- start</b></i>, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Trailing_comma_not_allowed</b></i>);
            }
        }</pre>

</details>
</blockquote>



### ⛔ allowLetAndConstDeclarations (deoptimizated):
<pre class="code">
(parent) {
            switch (parent.kind) {
                case 208 /* IfStatement */:
                case 209 /* DoStatement */:
                case 210 /* WhileStatement */:
                case 217 /* WithStatement */:
                case 211 /* ForStatement */:
                case 212 /* ForInStatement */:
                case 213 /* ForOfStatement */:
                    return false;
                case 219 /* LabeledStatement */:
                    return 🔶<i><b title="Did not inline: unknown">allowLetAndConstDeclarations</b></i>(parent⚠️<i><b title="LoadNamedGeneric">.parent</b></i>);
            }
            return true;
        }</pre>

```diff
- Deopt: <JS Function resolveBaseTypesOfInterface (SharedFunctionInfo 0x2e2f693edc51)> (opt #533) @29, FP to SP delta: 128, caller sp: 0x7fff5fbfdd88
```

```diff
- Deopt: <JS Function check (SharedFunctionInfo 0x130b7e105a31)> (opt #469) @6, FP to SP delta: 64, caller sp: 0x7fff5fbfdcd8
```

```diff
- Deopt: <JS Function getTargetType (SharedFunctionInfo 0x2e2f693ed111)> (opt #386) @5, FP to SP delta: 32, caller sp: 0x7fff5fbfdbd0
```

```diff
- Deopt: <JS Function getTypeWithThisArgument (SharedFunctionInfo 0x2e2f693eec11)> (opt #372) @5, FP to SP delta: 144, caller sp: 0x7fff5fbfdf30
```



### isIndependentType:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(node) {
            switch (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i>) {
                case 118 /* AnyKeyword */:
                case 134 /* StringKeyword */:
                case 132 /* NumberKeyword */:
                case 121 /* BooleanKeyword */:
                case 135 /* SymbolKeyword */:
                case 104 /* VoidKeyword */:
                case 137 /* UndefinedKeyword */:
                case 94 /* NullKeyword */:
                case 129 /* NeverKeyword */:
                case 171 /* LiteralType */:
                    return true;
                case 162 /* ArrayType */:
                    return 🔶<i><b title="Did not inline: target text too big">isIndependentType</b></i>(node.elementType);
                case 157 /* TypeReference */:
                    return <b title="Inlined">🔷isIndependentTypeReference</b>(node);
            }
            return false;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>isIndependentTypeReference</summary>
<pre class="code">
(node) {
            if (node.typeArguments) {
                for (var _i = 0, _a = node.typeArguments; _i &lt; _a.length; _i++) {
                    var typeNode = _a[_i];
                    if (!🔶<i><b title="Did not inline: target text too big">isIndependentType</b></i>(typeNode)) {
                        return false;
                    }
                }
            }
            return true;
        }</pre>

</details>
</blockquote>



### ⛔ isIndependentVariableLikeDeclaration (deoptimizated):
<pre class="code">
(node) {
            return node.type && 🔶<i><b title="Did not inline: target text too big">isIndependentType</b></i>(node.type) || !node.type && !node⚠️<i><b title="LoadNamedGeneric">.initializer</b></i>;
        }</pre>

```diff
- Deopt: <JS Function isIndependentType (SharedFunctionInfo 0x2e2f693ee611)> (opt #543) @4, FP to SP delta: 24, caller sp: 0x7fff5fbfd898
```



### getTypeOfFuncClassEnumModule:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(symbol) {
            var links = <b title="Inlined">🔷getSymbolLinks</b>(symbol);
            if (!links⚠️<i><b title="LoadNamedGeneric">.type</b></i>) {
                if (symbol.flags & 1536 /* Module */ && ts.🔶️<i><b title="CallWithDescriptor">isShorthandAmbientModuleSymbol</b></i>(symbol)) {
                    links.type ⚠️<i><b title="StoreNamedGeneric">= anyType</b></i>;
                }
                else {
                    var type = <b title="Inlined">🔷createObjectType</b>(16 /* Anonymous */, symbol);
                    links.type = strictNullChecks && symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> ⚠️<i><b title="Bitwise">& 536870912</b></i> /* Optional */ ?
                        🔶️<i><b title="CallWithDescriptor">includeFalsyTypes</b></i>(type, 2048 /* Undefined */) : type;
                }
            }
            return links⚠️<i><b title="LoadNamedGeneric">.type</b></i>;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getSymbolLinks</summary>
<pre class="code">
(symbol) {
            if (symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 67108864 /* Transient */)
                return symbol;
            var id = <b title="Inlined">🔷getSymbolId</b>(symbol);
            return symbolLinks⚠️<i><b title="LoadKeyedGeneric">[id]</b></i> || (symbolLinks[id] = {});
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getSymbolId</summary>
<pre class="code">
(symbol) {
        if (!symbol⚠️<i><b title="LoadNamedGeneric">.id</b></i>) {
            symbol.id ⚠️<i><b title="StoreNamedGeneric">= nextSymbolId</b></i>;
            nextSymbolId++;
        }
        return symbol⚠️<i><b title="LoadNamedGeneric">.id</b></i>;
    }</pre>

</details>
</blockquote>

</details>
<details>
<summary>createObjectType</summary>
<pre class="code">
(objectFlags, symbol) {
            var type = <b title="Inlined">🔷createType</b>(32768 /* Object */);
            type.objectFlags = objectFlags;
            type.symbol ⚠️<i><b title="StoreNamedGeneric">= symbol</b></i>;
            return type;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>createType</summary>
<pre class="code">
(flags) {
            var result = <b title="Inlined">🔷new Type</b>(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new Type</summary>
<pre class="code">
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
</blockquote>



### checkPropertyDeclaration:
<pre class="code">
(node) {
            // Grammar checking
            🔶<i><b title="Did not inline: target text too big">checkGrammarDecorators</b></i>(node) || 🔶<i><b title="Did not inline: target text too big">checkGrammarModifiers</b></i>(node) || 🔶<i><b title="Did not inline: target text too big">checkGrammarProperty</b></i>(node) || <b title="Inlined">🔷checkGrammarComputedPropertyName</b>(node.name);
            🔶<i><b title="Did not inline: target text too big">checkVariableLikeDeclaration</b></i>(node);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>checkGrammarComputedPropertyName</summary>
<pre class="code">
(node) {
            // If node is not a computedPropertyName, just skip the grammar checking
            if (node.kind !== 142 /* ComputedPropertyName */) {
                return false;
            }
            var computedPropertyName = node;
            if (computedPropertyName⚠️<i><b title="LoadNamedGeneric">.expression</b></i>⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 192</b></i> /* BinaryExpression */ && computedPropertyName⚠️<i><b title="LoadNamedGeneric">.expression</b></i>⚠️<i><b title="LoadNamedGeneric">.operatorToken</b></i>⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 25</b></i> /* CommaToken */) {
                return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(computedPropertyName⚠️<i><b title="LoadNamedGeneric">.expression</b></i>, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.A_comma_expression_is_not_allowed_in_a_computed_property_name</b></i>);
            }
        }</pre>

</details>
</blockquote>



### checkVariableLikeDeclaration:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(node) {
            🔶️<i><b title="CallWithDescriptor">checkDecorators</b></i>(node);
            🔶<i><b title="Did not inline: target text too big">checkSourceElement</b></i>(node⚠️<i><b title="LoadNamedGeneric">.type</b></i>);
            // For a computed property, just check the initializer and exit
            // Do not use hasDynamicName here, because that returns false for well known symbols.
            // We want to perform checkComputedPropertyName for all computed properties, including
            // well known symbols.
            if (node⚠️<i><b title="LoadNamedGeneric">.name</b></i>.kind === 142 /* ComputedPropertyName */) {
                🔶️<i><b title="CallWithDescriptor">checkComputedPropertyName</b></i>(node⚠️<i><b title="LoadNamedGeneric">.name</b></i>);
                if (node⚠️<i><b title="LoadNamedGeneric">.initializer</b></i>) {
                    🔶️<i><b title="CallWithDescriptor">checkExpressionCached</b></i>(node⚠️<i><b title="LoadNamedGeneric">.initializer</b></i>);
                }
            }
            if (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 174 /* BindingElement */) {
                if (node⚠️<i><b title="LoadNamedGeneric">.parent</b></i>⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 172</b></i> /* ObjectBindingPattern */ && languageVersion &lt; 5 /* ESNext */ && !ts.🔶<i><b title="Did not inline: unknown">isInAmbientContext</b></i>(node)) {
                    🔶️<i><b title="CallWithDescriptor">checkExternalEmitHelpers</b></i>(node, 4 /* Rest */);
                }
                // check computed properties inside property names of binding elements
                if (node⚠️<i><b title="LoadNamedGeneric">.propertyName</b></i> && node⚠️<i><b title="LoadNamedGeneric">.propertyName</b></i>⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 142</b></i> /* ComputedPropertyName */) {
                    🔶️<i><b title="CallWithDescriptor">checkComputedPropertyName</b></i>(node⚠️<i><b title="LoadNamedGeneric">.propertyName</b></i>);
                }
                // check private/protected variable access
                var parent_11 = node⚠️<i><b title="LoadNamedGeneric">.parent</b></i>⚠️<i><b title="LoadNamedGeneric">.parent</b></i>;
                var parentType = 🔶️<i><b title="CallWithDescriptor">getTypeForBindingElementParent</b></i>(parent_11);
                var name_24 = node⚠️<i><b title="LoadNamedGeneric">.propertyName</b></i> || node⚠️<i><b title="LoadNamedGeneric">.name</b></i>;
                var property = 🔶<i><b title="Did not inline: target text too big">getPropertyOfType</b></i>(parentType, ts.🔶️<i><b title="CallWithDescriptor">getTextOfPropertyName</b></i>(name_24));
                🔶️<i><b title="CallWithDescriptor">markPropertyAsReferenced</b></i>(property);
                if (parent_11⚠️<i><b title="LoadNamedGeneric">.initializer</b></i> && property && 🔶️<i><b title="CallWithDescriptor">getParentOfSymbol</b></i>(property)) {
                    🔶️<i><b title="CallWithDescriptor">checkClassPropertyAccess</b></i>(parent_11, parent_11⚠️<i><b title="LoadNamedGeneric">.initializer</b></i>, parentType, property);
                }
            }
            // For a binding pattern, check contained binding elements
            if (ts.⚠️<i><b title="LoadNamedGeneric">isBindingPattern</b></i>(node⚠️<i><b title="LoadNamedGeneric">.name</b></i>)) {
                ts.⚠️<i><b title="LoadNamedGeneric">forEach</b></i>(node⚠️<i><b title="LoadNamedGeneric">.name</b></i>⚠️<i><b title="LoadNamedGeneric">.elements</b></i>, checkSourceElement);
            }
            // For a parameter declaration with an initializer, error and exit if the containing function doesn't have a body
            if (node⚠️<i><b title="LoadNamedGeneric">.initializer</b></i> && ts.⚠️<i><b title="LoadNamedGeneric">getRootDeclaration</b></i>(node)⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 144</b></i> /* Parameter */ && ts.⚠️<i><b title="LoadNamedGeneric">nodeIsMissing</b></i>(ts.⚠️<i><b title="LoadNamedGeneric">getContainingFunction</b></i>(node)⚠️<i><b title="LoadNamedGeneric">.body</b></i>)) {
                🔶️<i><b title="CallWithDescriptor">error</b></i>(node, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.A_parameter_initializer_is_only_allowed_in_a_function_or_constructor_implementation</b></i>);
                return;
            }
            // For a binding pattern, validate the initializer and exit
            if (ts.⚠️<i><b title="LoadNamedGeneric">isBindingPattern</b></i>(node⚠️<i><b title="LoadNamedGeneric">.name</b></i>)) {
                // Don't validate for-in initializer as it is already an error
                if (node⚠️<i><b title="LoadNamedGeneric">.initializer</b></i> && node⚠️<i><b title="LoadNamedGeneric">.parent</b></i>⚠️<i><b title="LoadNamedGeneric">.parent</b></i>⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">!== 212</b></i> /* ForInStatement */) {
                    🔶<i><b title="Did not inline: unknown">checkTypeAssignableTo</b></i>(🔶️<i><b title="CallWithDescriptor">checkExpressionCached</b></i>(node⚠️<i><b title="LoadNamedGeneric">.initializer</b></i>), 🔶<i><b title="Did not inline: target text too big">getWidenedTypeForVariableLikeDeclaration</b></i>(node), node, /*headMessage*/ undefined);
                    🔶️<i><b title="CallWithDescriptor">checkParameterInitializer</b></i>(node);
                }
                return;
            }
            var symbol = <b title="Inlined">🔷getSymbolOfNode</b>(node);
            var type = <b title="Inlined">🔷convertAutoToAny</b>(🔶<i><b title="Did not inline: target text too big">getTypeOfVariableOrParameterOrProperty</b></i>(symbol));
            if (node === symbol⚠️<i><b title="LoadNamedGeneric">.valueDeclaration</b></i>) {
                // Node is the primary declaration of the symbol, just validate the initializer
                // Don't validate for-in initializer as it is already an error
                if (node⚠️<i><b title="LoadNamedGeneric">.initializer</b></i> && node⚠️<i><b title="LoadNamedGeneric">.parent</b></i>⚠️<i><b title="LoadNamedGeneric">.parent</b></i>⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">!== 212</b></i> /* ForInStatement */) {
                    🔶<i><b title="Did not inline: unknown">checkTypeAssignableTo</b></i>(🔶️<i><b title="CallWithDescriptor">checkExpressionCached</b></i>(node⚠️<i><b title="LoadNamedGeneric">.initializer</b></i>), type, node, /*headMessage*/ undefined);
                    🔶️<i><b title="CallWithDescriptor">checkParameterInitializer</b></i>(node);
                }
            }
            else {
                // Node is a secondary declaration, check that type is identical to primary declaration and check that
                // initializer is consistent with type associated with the node
                var declarationType = <b title="Inlined">🔷convertAutoToAny</b>(🔶<i><b title="Did not inline: target text too big">getWidenedTypeForVariableLikeDeclaration</b></i>(node));
                if (type !== unknownType && declarationType !== unknownType && !<b title="Inlined">🔷isTypeIdenticalTo</b>(type, declarationType)) {
                    🔶️<i><b title="CallWithDescriptor">error</b></i>(node⚠️<i><b title="LoadNamedGeneric">.name</b></i>, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Subsequent_variable_declarations_must_have_the_same_type_Variable_0_must_be_of_type_1_but_here_has_</b></i>type_2, ts.🔶️<i><b title="CallWithDescriptor">declarationNameToString</b></i>(node⚠️<i><b title="LoadNamedGeneric">.name</b></i>), 🔶️<i><b title="CallWithDescriptor">typeToString</b></i>(type), 🔶️<i><b title="CallWithDescriptor">typeToString</b></i>(declarationType));
                }
                if (node.initializer) {
                    🔶<i><b title="Did not inline: unknown">checkTypeAssignableTo</b></i>(🔶️<i><b title="CallWithDescriptor">checkExpressionCached</b></i>(node⚠️<i><b title="LoadNamedGeneric">.initializer</b></i>), declarationType, node, /*headMessage*/ undefined);
                }
                if (!🔶️<i><b title="CallWithDescriptor">areDeclarationFlagsIdentical</b></i>(node, symbol.valueDeclaration)) {
                    🔶️<i><b title="CallWithDescriptor">error</b></i>(symbol⚠️<i><b title="LoadNamedGeneric">.valueDeclaration</b></i>⚠️<i><b title="LoadNamedGeneric">.name</b></i>, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.All_declarations_of_0_must_have_identical_modifiers</b></i>, ts.🔶️<i><b title="CallWithDescriptor">declarationNameToString</b></i>(node⚠️<i><b title="LoadNamedGeneric">.name</b></i>));
                    🔶️<i><b title="CallWithDescriptor">error</b></i>(node⚠️<i><b title="LoadNamedGeneric">.name</b></i>, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.All_declarations_of_0_must_have_identical_modifiers</b></i>, ts.🔶️<i><b title="CallWithDescriptor">declarationNameToString</b></i>(node⚠️<i><b title="LoadNamedGeneric">.name</b></i>));
                }
            }
            if (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> !== 147 /* PropertyDeclaration */ && node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> !== 146 /* PropertySignature */) {
                // We know we don't have a binding pattern or computed name here
                🔶️<i><b title="CallWithDescriptor">checkExportsOnMergedDeclarations</b></i>(node);
                if (node.kind === 223 /* VariableDeclaration */ || node.kind === 174 /* BindingElement */) {
                    🔶️<i><b title="CallWithDescriptor">checkVarDeclaredNamesNotShadowed</b></i>(node);
                }
                🔶️<i><b title="CallWithDescriptor">checkCollisionWithCapturedSuperVariable</b></i>(node, node.name);
                <b title="Inlined">🔷checkCollisionWithCapturedThisVariable</b>(node, node.name);
                🔶<i><b title="Did not inline: target text too big">checkCollisionWithRequireExportsInGeneratedCode</b></i>(node, node.name);
                🔶️<i><b title="CallWithDescriptor">checkCollisionWithGlobalPromiseInGeneratedCode</b></i>(node, node.name);
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getSymbolOfNode</summary>
<pre class="code">
(node) {
            return <b title="Inlined">🔷getMergedSymbol</b>(node.symbol);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getMergedSymbol</summary>
<pre class="code">
(symbol) {
            var merged;
            return symbol && symbol⚠️<i><b title="LoadNamedGeneric">.mergeId</b></i> && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>convertAutoToAny</summary>
<pre class="code">
(type) {
            return type === autoType ? anyType : type === autoArrayType ? anyArrayType : type;
        }</pre>

</details>
<details>
<summary>convertAutoToAny</summary>
<pre class="code">
(type) {
            return type === autoType ? anyType : type === autoArrayType ? anyArrayType : type;
        }</pre>

</details>
<details>
<summary>isTypeIdenticalTo</summary>
<pre class="code">
(source, target) {
            return 🔶<i><b title="Did not inline: target text too big">isTypeRelatedTo</b></i>(source, target, identityRelation);
        }</pre>

</details>
<details>
<summary>checkCollisionWithCapturedThisVariable</summary>
<pre class="code">
(node, name) {
            if (🔶<i><b title="Did not inline: target text too big">needCollisionCheckForIdentifier</b></i>(node, name, "_this")) {
                potentialThisCollisions.🔶️<i><b title="CallWithDescriptor">push</b></i>(node);
            }
        }</pre>

</details>
</blockquote>



### getContainingFunction:
<pre class="code">
(node) {
        while (true) {
            node = node.parent;
            if (!node || <b title="Inlined">🔷isFunctionLike</b>(node)) {
                return node;
            }
        }
    }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>isFunctionLike</summary>
<pre class="code">
(node) {
        return node && 🔶<i><b title="Did not inline: target text too big">isFunctionLikeKind</b></i>(node⚠️<i><b title="LoadNamedGeneric">.kind</b></i>);
    }</pre>

</details>
</blockquote>



### getTypeForVariableLikeDeclaration:
<pre class="code">
(declaration, includeOptionality) {
            if (declaration⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 65536 /* JavaScriptFile */) {
                // If this is a variable in a JavaScript file, then use the JSDoc type (if it has
                // one as its type), otherwise fallback to the below standard TS codepaths to
                // try to figure it out.
                var type = 🔶️<i><b title="CallWithDescriptor">getTypeForVariableLikeDeclarationFromJSDocComment</b></i>(declaration);
                if (type && type ⚠️<i><b title="CompareGeneric">!== unknownType</b></i>) {
                    return type;
                }
            }
            // A variable declared in a for..in statement is of type string, or of type keyof T when the
            // right hand expression is of a type parameter type.
            if (declaration⚠️<i><b title="LoadNamedGeneric">.parent</b></i>⚠️<i><b title="LoadNamedGeneric">.parent</b></i>⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 212 /* ForInStatement */) {
                var indexType = 🔶<i><b title="Did not inline: unknown">getIndexType</b></i>(🔶️<i><b title="CallWithDescriptor">checkNonNullExpression</b></i>(declaration⚠️<i><b title="LoadNamedGeneric">.parent</b></i>⚠️<i><b title="LoadNamedGeneric">.parent</b></i>⚠️<i><b title="LoadNamedGeneric">.expression</b></i>));
                return indexType⚠️<i><b title="LoadNamedGeneric">.flags</b></i> ⚠️<i><b title="Bitwise">& (16</b></i>384 /* TypeParameter */ | 262144 /* Index */) ? indexType : stringType;
            }
            if (declaration⚠️<i><b title="LoadNamedGeneric">.parent</b></i>⚠️<i><b title="LoadNamedGeneric">.parent</b></i>⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 213 /* ForOfStatement */) {
                // checkRightHandSideOfForOf will return undefined if the for-of expression type was
                // missing properties/signatures required to get its iteratedType (like
                // [Symbol.iterator] or next). This may be because we accessed properties from anyType,
                // or it may have led to an error inside getElementTypeOfIterable.
                return 🔶️<i><b title="CallWithDescriptor">checkRightHandSideOfForOf</b></i>(declaration⚠️<i><b title="LoadNamedGeneric">.parent</b></i>⚠️<i><b title="LoadNamedGeneric">.parent</b></i>⚠️<i><b title="LoadNamedGeneric">.expression</b></i>) || anyType;
            }
            if (ts.🔶<i><b title="Did not inline: unknown">isBindingPattern</b></i>(declaration⚠️<i><b title="LoadNamedGeneric">.parent</b></i>)) {
                return 🔶️<i><b title="CallWithDescriptor">getTypeForBindingElement</b></i>(declaration);
            }
            // Use type from type annotation if one is present
            if (declaration⚠️<i><b title="LoadNamedGeneric">.type</b></i>) {
                return <b title="Inlined">🔷addOptionality</b>(🔶<i><b title="Did not inline: target text too big">getTypeFromTypeNode</b></i>(declaration⚠️<i><b title="LoadNamedGeneric">.type</b></i>), /*optional*/ declaration⚠️<i><b title="LoadNamedGeneric">.questionToken</b></i> && includeOptionality);
            }
            if ((compilerOptions⚠️<i><b title="LoadNamedGeneric">.noImplicitAny</b></i> || declaration⚠️<i><b title="LoadNamedGeneric">.flags</b></i> ⚠️<i><b title="Bitwise">& 65536</b></i> /* JavaScriptFile */) &&
                declaration⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 223</b></i> /* VariableDeclaration */ && !ts.🔶<i><b title="Did not inline: unknown">isBindingPattern</b></i>(declaration⚠️<i><b title="LoadNamedGeneric">.name</b></i>) &&
                !(ts.⚠️<i><b title="LoadNamedGeneric">getCombinedModifierFlags</b></i>(declaration) ⚠️<i><b title="Bitwise">& 1</b></i> /* Export */) && !ts.🔶<i><b title="Did not inline: unknown">isInAmbientContext</b></i>(declaration)) {
                // If --noImplicitAny is on or the declaration is in a Javascript file,
                // use control flow tracked 'any' type for non-ambient, non-exported var or let variables with no
                // initializer or a 'null' or 'undefined' initializer.
                if (!(ts.🔶<i><b title="Did not inline: unknown">getCombinedNodeFlags</b></i>(declaration) ⚠️<i><b title="Bitwise">& 2</b></i> /* Const */) && (!declaration⚠️<i><b title="LoadNamedGeneric">.initializer</b></i> || 🔶️<i><b title="CallWithDescriptor">isNullOrUndefined</b></i>(declaration⚠️<i><b title="LoadNamedGeneric">.initializer</b></i>))) {
                    return autoType;
                }
                // Use control flow tracked 'any[]' type for non-ambient, non-exported variables with an empty array
                // literal initializer.
                if (declaration⚠️<i><b title="LoadNamedGeneric">.initializer</b></i> && 🔶️<i><b title="CallWithDescriptor">isEmptyArrayLiteral</b></i>(declaration⚠️<i><b title="LoadNamedGeneric">.initializer</b></i>)) {
                    return autoArrayType;
                }
            }
            if (declaration⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 144</b></i> /* Parameter */) {
                var func = declaration⚠️<i><b title="LoadNamedGeneric">.parent</b></i>;
                // For a parameter of a set accessor, use the type of the get accessor if one is present
                if (func⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 152</b></i> /* SetAccessor */ && !ts.🔶<i><b title="Did not inline: unknown">hasDynamicName</b></i>(func)) {
                    var getter = ts.🔶<i><b title="Did not inline: unknown">getDeclarationOfKind</b></i>(declaration⚠️<i><b title="LoadNamedGeneric">.parent</b></i>⚠️<i><b title="LoadNamedGeneric">.symbol</b></i>, 151 /* GetAccessor */);
                    if (getter) {
                        var getterSignature = 🔶<i><b title="Did not inline: unknown">getSignatureFromDeclaration</b></i>(getter);
                        var thisParameter = 🔶️<i><b title="CallWithDescriptor">getAccessorThisParameter</b></i>(func);
                        if (thisParameter && declaration ⚠️<i><b title="CompareGeneric">=== thisParameter</b></i>) {
                            // Use the type from the *getter*
                            ts⚠️<i><b title="LoadNamedGeneric">.Debug</b></i>.🔶️<i><b title="CallWithDescriptor">assert</b></i>(!thisParameter⚠️<i><b title="LoadNamedGeneric">.type</b></i>);
                            return 🔶<i><b title="Did not inline: target text too big">getTypeOfSymbol</b></i>(getterSignature⚠️<i><b title="LoadNamedGeneric">.thisParameter</b></i>);
                        }
                        return 🔶️<i><b title="CallWithDescriptor">getReturnTypeOfSignature</b></i>(getterSignature);
                    }
                }
                // Use contextual parameter type if one is available
                var type = void 0;
                if (declaration⚠️<i><b title="LoadNamedGeneric">.symbol</b></i>⚠️<i><b title="LoadNamedGeneric">.name</b></i> ⚠️<i><b title="CompareGeneric">=== "</b></i>this") {
                    type = 🔶️<i><b title="CallWithDescriptor">getContextualThisParameterType</b></i>(func);
                }
                else {
                    type = 🔶️<i><b title="CallWithDescriptor">getContextuallyTypedParameterType</b></i>(declaration);
                }
                if (type) {
                    return 🔶<i><b title="Did not inline: unknown">addOptionality</b></i>(type, /*optional*/ declaration⚠️<i><b title="LoadNamedGeneric">.questionToken</b></i> && includeOptionality);
                }
            }
            // Use the type of the initializer expression if one is present
            if (declaration⚠️<i><b title="LoadNamedGeneric">.initializer</b></i>) {
                var type = 🔶️<i><b title="CallWithDescriptor">checkDeclarationInitializer</b></i>(declaration);
                return 🔶<i><b title="Did not inline: unknown">addOptionality</b></i>(type, /*optional*/ declaration⚠️<i><b title="LoadNamedGeneric">.questionToken</b></i> && includeOptionality);
            }
            // If it is a short-hand property assignment, use the type of the identifier
            if (declaration⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 258</b></i> /* ShorthandPropertyAssignment */) {
                return 🔶️<i><b title="CallWithDescriptor">checkIdentifier</b></i>(declaration⚠️<i><b title="LoadNamedGeneric">.name</b></i>);
            }
            // If the declaration specifies a binding pattern, use the type implied by the binding pattern
            if (ts.⚠️<i><b title="LoadNamedGeneric">isBindingPattern</b></i>(declaration⚠️<i><b title="LoadNamedGeneric">.name</b></i>)) {
                return 🔶️<i><b title="CallWithDescriptor">getTypeFromBindingPattern</b></i>(declaration⚠️<i><b title="LoadNamedGeneric">.name</b></i>, /*includePatternInType*/ false, /*reportErrors*/ true);
            }
            // No type specified and nothing can be inferred
            return undefined;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>addOptionality</summary>
<pre class="code">
(type, optional) {
            return strictNullChecks && optional ? 🔶️<i><b title="CallWithDescriptor">includeFalsyTypes</b></i>(type, 2048 /* Undefined */) : type;
        }</pre>

</details>
</blockquote>



### checkFunctionDeclaration:
<pre class="code">
(node) {
            if (produceDiagnostics) {
                🔶<i><b title="Did not inline: target text too big">checkFunctionOrMethodDeclaration</b></i>(node) || 🔶️<i><b title="CallWithDescriptor">checkGrammarForGenerator</b></i>(node);
                🔶️<i><b title="CallWithDescriptor">checkCollisionWithCapturedSuperVariable</b></i>(node, node.name);
                <b title="Inlined">🔷checkCollisionWithCapturedThisVariable</b>(node, node.name);
                🔶<i><b title="Did not inline: target text too big">checkCollisionWithRequireExportsInGeneratedCode</b></i>(node, node.name);
                🔶️<i><b title="CallWithDescriptor">checkCollisionWithGlobalPromiseInGeneratedCode</b></i>(node, node.name);
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>checkCollisionWithCapturedThisVariable</summary>
<pre class="code">
(node, name) {
            if (🔶<i><b title="Did not inline: target text too big">needCollisionCheckForIdentifier</b></i>(node, name, "_this")) {
                potentialThisCollisions.🔶️<i><b title="CallWithDescriptor">push</b></i>(node);
            }
        }</pre>

</details>
</blockquote>



### getPropertyOfObjectType:
<div>~recompile~</div>

<div>~recompile~</div>
<pre class="code">
(type, name) {
            if (type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 32768 /* Object */) {
                var resolved = resolveStructuredTypeMembers(type);
                var symbol = resolved.members⚠️<i><b title="LoadKeyedGeneric">[name]</b></i>;
                if (symbol && 🔶<i><b title="Did not inline: target text too big">symbolIsValue</b></i>(symbol)) {
                    return symbol;
                }
            }
        }</pre>



### checkArrayType:
<pre class="code">
(node) {
            🔶<i><b title="Did not inline: target text too big">checkSourceElement</b></i>(node.elementType);
        }</pre>



### instantiateList:
<pre class="code">
(items, mapper, instantiator) {
            if (items && items.length) {
                var result = [];
                for (var _i = 0, items_1 = items; _i &lt; items_1.length; _i++) {
                    var v = items_1[_i];
                    result.push(🔶️<i><b title="CallWithDescriptor">instantiator</b></i>(v, mapper));
                }
                return result;
            }
            return items;
        }</pre>



### isSymbolInScopeOfMappedTypeParameter:
<pre class="code">
(symbol, mapper) {
            if (!(symbol.declarations && symbol.declarations.length)) {
                return false;
            }
            var mappedTypes = mapper.mappedTypes;
            // Starting with the parent of the symbol's declaration, check if the mapper maps any of
            // the type parameters introduced by enclosing declarations. We just pick the first
            // declaration since multiple declarations will all have the same parent anyway.
            var node = symbol.declarations[0];
            while (node) {
                switch (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i>) {
                    case 158 /* FunctionType */:
                    case 159 /* ConstructorType */:
                    case 225 /* FunctionDeclaration */:
                    case 149 /* MethodDeclaration */:
                    case 148 /* MethodSignature */:
                    case 150 /* Constructor */:
                    case 153 /* CallSignature */:
                    case 154 /* ConstructSignature */:
                    case 155 /* IndexSignature */:
                    case 151 /* GetAccessor */:
                    case 152 /* SetAccessor */:
                    case 184 /* FunctionExpression */:
                    case 185 /* ArrowFunction */:
                    case 226 /* ClassDeclaration */:
                    case 197 /* ClassExpression */:
                    case 227 /* InterfaceDeclaration */:
                    case 228 /* TypeAliasDeclaration */:
                        var declaration = node;
                        if (declaration⚠️<i><b title="LoadNamedGeneric">.typeParameters</b></i>) {
                            for (var _i = 0, _a = declaration.typeParameters; _i &lt; _a.length; _i++) {
                                var d = _a[_i];
                                if (ts.⚠️<i><b title="LoadNamedGeneric">contains</b></i>(mappedTypes, <b title="Inlined">🔷getDeclaredTypeOfTypeParameter</b>(<b title="Inlined">🔷getSymbolOfNode</b>(d)))) {
                                    return true;
                                }
                            }
                        }
                        if (ts.🔶<i><b title="Did not inline: unknown">isClassLike</b></i>(node) || node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 227 /* InterfaceDeclaration */) {
                            var thisType = 🔶<i><b title="Did not inline: target text too big">getDeclaredTypeOfClassOrInterface</b></i>(<b title="Inlined">🔷getSymbolOfNode</b>(node))⚠️<i><b title="LoadNamedGeneric">.thisType</b></i>;
                            if (thisType && ts.⚠️<i><b title="LoadNamedGeneric">contains</b></i>(mappedTypes, thisType)) {
                                return true;
                            }
                        }
                        break;
                    case 274 /* JSDocFunctionType */:
                        var func = node;
                        for (var _b = 0, _c = func⚠️<i><b title="LoadNamedGeneric">.parameters</b></i>; _b ⚠️<i><b title="CompareGeneric">< _c</b></i>⚠️<i><b title="LoadNamedGeneric">.length</b></i>; _b++) {
                            var p = _c⚠️<i><b title="LoadKeyedGeneric">[_b]</b></i>;
                            if (ts.🔶️<i><b title="CallWithDescriptor">contains</b></i>(mappedTypes, 🔶️<i><b title="CallWithDescriptor">getTypeOfNode</b></i>(p))) {
                                return true;
                            }
                        }
                        break;
                    case 230 /* ModuleDeclaration */:
                    case 261 /* SourceFile */:
                        return false;
                }
                node = node⚠️<i><b title="LoadNamedGeneric">.parent</b></i>;
            }
            return false;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getSymbolOfNode</summary>
<pre class="code">
(node) {
            return <b title="Inlined">🔷getMergedSymbol</b>(node.symbol);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getMergedSymbol</summary>
<pre class="code">
(symbol) {
            var merged;
            return symbol && symbol⚠️<i><b title="LoadNamedGeneric">.mergeId</b></i> && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }</pre>

</details>
</blockquote>

</details>
<details>
<summary>getDeclaredTypeOfTypeParameter</summary>
<pre class="code">
(symbol) {
            var links = <b title="Inlined">🔷getSymbolLinks</b>(symbol);
            if (!links.declaredType) {
                var type = <b title="Inlined">🔷createType</b>(16384 /* TypeParameter */);
                type.symbol = symbol;
                if (!ts.🔶<i><b title="Did not inline: unknown">getDeclarationOfKind</b></i>(symbol, 143 /* TypeParameter */).constraint) {
                    type.constraint ⚠️<i><b title="StoreNamedGeneric">= noConstraintType</b></i>;
                }
                links.declaredType = type;
            }
            return links.declaredType;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getSymbolLinks</summary>
<pre class="code">
(symbol) {
            if (symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 67108864 /* Transient */)
                return symbol;
            var id = <b title="Inlined">🔷getSymbolId</b>(symbol);
            return symbolLinks⚠️<i><b title="LoadKeyedGeneric">[id]</b></i> || (symbolLinks[id] = {});
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getSymbolId</summary>
<pre class="code">
(symbol) {
        if (!symbol⚠️<i><b title="LoadNamedGeneric">.id</b></i>) {
            symbol.id ⚠️<i><b title="StoreNamedGeneric">= nextSymbolId</b></i>;
            nextSymbolId++;
        }
        return symbol⚠️<i><b title="LoadNamedGeneric">.id</b></i>;
    }</pre>

</details>
</blockquote>

</details>
<details>
<summary>createType</summary>
<pre class="code">
(flags) {
            var result = <b title="Inlined">🔷new Type</b>(checker, flags);
            typeCount++;
            result.id = typeCount;
            return result;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>new Type</summary>
<pre class="code">
(checker, flags) {
            this.checker = checker;
            this.flags = flags;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>

</details>
<details>
<summary>getSymbolOfNode</summary>
<pre class="code">
(node) {
            return <b title="Inlined">🔷getMergedSymbol</b>(node.symbol);
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getMergedSymbol</summary>
<pre class="code">
(symbol) {
            var merged;
            return symbol && symbol⚠️<i><b title="LoadNamedGeneric">.mergeId</b></i> && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }</pre>

</details>
</blockquote>

</details>
</blockquote>



### ⛔ createInstantiatedSymbolTable (deoptimizated):
<pre class="code">
(symbols, mapper, mappingThisOnly) {
            var result = ts.🔶<i><b title="Did not inline: unknown">createMap</b></i>();
            for (var _i = 0, symbols_2 = symbols; _i &lt; symbols_2.length; _i++) {
                var symbol = symbols_2[_i];
                result[symbol.name] ⚠️<i><b title="StoreKeyedGeneric">= mappingThisOnly</b></i> && 🔶<i><b title="Did not inline: target text too big">isIndependentMember</b></i>(symbol) ? symbol : 🔶<i><b title="Did not inline: target text too big">instantiateSymbol</b></i>(symbol, mapper);
            }
            return result;
        }</pre>

```diff
- Deopt: <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> (opt #588) @44, FP to SP delta: 200, caller sp: 0x7fff5fbfdf20
```

```diff
- Deopt: <JS Function checkSourceElement (SharedFunctionInfo 0x1b98fbc10201)> (opt #588) @16, FP to SP delta: 200, caller sp: 0x7fff5fbfe098
```



### getTargetSymbol:
<pre class="code">
(s) {
            // if symbol is instantiated its flags are not copied from the 'target'
            // so we'll need to get back original 'target' symbol to work with correct set of flags
            return s.flags & 16777216 /* Instantiated */ ? <b title="Inlined">🔷getSymbolLinks</b>(s).target : s;
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getSymbolLinks</summary>
<pre class="code">
(symbol) {
            if (symbol⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 67108864 /* Transient */)
                return symbol;
            var id = <b title="Inlined">🔷getSymbolId</b>(symbol);
            return symbolLinks⚠️<i><b title="LoadKeyedGeneric">[id]</b></i> || (symbolLinks[id] = {});
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>getSymbolId</summary>
<pre class="code">
(symbol) {
        if (!symbol⚠️<i><b title="LoadNamedGeneric">.id</b></i>) {
            symbol.id ⚠️<i><b title="StoreNamedGeneric">= nextSymbolId</b></i>;
            nextSymbolId++;
        }
        return symbol⚠️<i><b title="LoadNamedGeneric">.id</b></i>;
    }</pre>

</details>
</blockquote>

</details>
</blockquote>



### getObjectFlags:
<pre class="code">
(type) {
            return type⚠️<i><b title="LoadNamedGeneric">.flags</b></i> & 32768 /* Object */ ? type⚠️<i><b title="LoadNamedGeneric">.objectFlags</b></i> : 0;
        }</pre>



### ⛔ getClassLikeDeclarationOfSymbol (deoptimizated):
<pre class="code">
(symbol) {
            return ts.🔶<i><b title="Did not inline: unknown">forEach</b></i>(symbol.declarations, 🔶️<i><b title="CallWithDescriptor">function</b></i> (d) { return ts.isClassLike(d) ? d : undefined; });
        }</pre>

```diff
- Deopt: <JS Function checkFunctionOrMethodDeclaration (SharedFunctionInfo 0x1b98fbc0c0c1)> (opt #605) @33, FP to SP delta: 160, caller sp: 0x7fff5fbfdc38
```

```diff
- Deopt: <JS Function propertiesRelatedTo (SharedFunctionInfo 0x130b7e106e61)> (opt #639) @22, FP to SP delta: 152, caller sp: 0x7fff5fbfd540
```



### getDeclarationOfKind:
<pre class="code">
(symbol, kind) {
        var declarations = symbol.declarations;
        if (declarations) {
            for (var _i = 0, declarations_1 = declarations; _i &lt; declarations_1.length; _i++) {
                var declaration = declarations_1[_i];
                if (declaration⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === kind) {
                    return declaration;
                }
            }
        }
        return undefined;
    }</pre>



### checkGrammarModifiers:
<pre class="code">
(node) {
            var quickResult = <b title="Inlined">🔷reportObviousModifierErrors</b>(node);
            if (quickResult !== undefined) {
                return quickResult;
            }
            var lastStatic, lastPrivate, lastProtected, lastDeclare, lastAsync, lastReadonly;
            var flags = 0 /* None */;
            for (var _i = 0, _a = node.modifiers; _i &lt; _a.length; _i++) {
                var modifier = _a[_i];
                if (modifier.kind !== 130 /* ReadonlyKeyword */) {
                    if (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 146 /* PropertySignature */ || node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 148 /* MethodSignature */) {
                        return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(modifier, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">._0_modifier_cannot_appear_on_a_type_member</b></i>, ts.⚠️<i><b title="LoadNamedGeneric">tokenToString</b></i>(modifier⚠️<i><b title="LoadNamedGeneric">.kind</b></i>));
                    }
                    if (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 155 /* IndexSignature */) {
                        return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(modifier, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">._0_modifier_cannot_appear_on_an_index_signature</b></i>, ts.⚠️<i><b title="LoadNamedGeneric">tokenToString</b></i>(modifier⚠️<i><b title="LoadNamedGeneric">.kind</b></i>));
                    }
                }
                ⚠️<i><b title="CompareGeneric">switch</b></i> (modifier.kind) {
                    case 75 /* ConstKeyword */:
                        if (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">!== 229</b></i> /* EnumDeclaration */ && node⚠️<i><b title="LoadNamedGeneric">.parent</b></i>⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 226</b></i> /* ClassDeclaration */) {
                            return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(node, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.A_class_member_cannot_have_the_0_keyword</b></i>, ts.🔶️<i><b title="CallWithDescriptor">tokenToString</b></i>(75 /* ConstKeyword */));
                        }
                        break;
                    case 113 /* PublicKeyword */:
                    case 112 /* ProtectedKeyword */:
                    case 111 /* PrivateKeyword */:
                        var text = <b title="Inlined">🔷visibilityToString</b>(ts.🔶<i><b title="Did not inline: target text too big">modifierToFlag</b></i>(modifier.kind));
                        if (modifier.kind === 112 /* ProtectedKeyword */) {
                            lastProtected = modifier;
                        }
                        else if (modifier⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 111</b></i> /* PrivateKeyword */) {
                            lastPrivate = modifier;
                        }
                        if (flags & 28 /* AccessibilityModifier */) {
                            return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(modifier, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Accessibility_modifier_already_seen</b></i>);
                        }
                        else if (flags & 32 /* Static */) {
                            return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(modifier, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">._0_modifier_must_precede_1_modifier</b></i>, text, "static");
                        }
                        else if (flags & 64 /* Readonly */) {
                            return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(modifier, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">._0_modifier_must_precede_1_modifier</b></i>, text, "readonly");
                        }
                        else if (flags & 256 /* Async */) {
                            return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(modifier, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">._0_modifier_must_precede_1_modifier</b></i>, text, "async");
                        }
                        else if (node.parent.kind === 231 /* ModuleBlock */ || node.parent.kind === 261 /* SourceFile */) {
                            return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(modifier, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">._0_modifier_cannot_appear_on_a_module_or_namespace_element</b></i>, text);
                        }
                        else if (flags & 128 /* Abstract */) {
                            if (modifier⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 111</b></i> /* PrivateKeyword */) {
                                return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(modifier, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">._0_modifier_cannot_be_used_with_1_modifier</b></i>, text, "abstract");
                            }
                            else {
                                return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(modifier, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">._0_modifier_must_precede_1_modifier</b></i>, text, "abstract");
                            }
                        }
                        flags |= ts.⚠️<i><b title="LoadNamedGeneric">modifierToFlag</b></i>(modifier.kind);
                        break;
                    case 114 /* StaticKeyword */:
                        if (flags & 32 /* Static */) {
                            return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(modifier, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">._0_modifier_already_seen</b></i>, "static");
                        }
                        else if (flags & 64 /* Readonly */) {
                            return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(modifier, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">._0_modifier_must_precede_1_modifier</b></i>, "static", "readonly");
                        }
                        else if (flags & 256 /* Async */) {
                            return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(modifier, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">._0_modifier_must_precede_1_modifier</b></i>, "static", "async");
                        }
                        else if (node.parent.kind === 231 /* ModuleBlock */ || node.parent.kind === 261 /* SourceFile */) {
                            return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(modifier, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">._0_modifier_cannot_appear_on_a_module_or_namespace_element</b></i>, "static");
                        }
                        else if (node.kind === 144 /* Parameter */) {
                            return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(modifier, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">._0_modifier_cannot_appear_on_a_parameter</b></i>, "static");
                        }
                        else if (flags & 128 /* Abstract */) {
                            return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(modifier, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">._0_modifier_cannot_be_used_with_1_modifier</b></i>, "static", "abstract");
                        }
                        flags |= 32 /* Static */;
                        lastStatic = modifier;
                        break;
                    case 130 /* ReadonlyKeyword */:
                        if (flags & 64 /* Readonly */) {
                            return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(modifier, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">._0_modifier_already_seen</b></i>, "readonly");
                        }
                        else if (node.kind !== 147 /* PropertyDeclaration */ && node.kind !== 146 /* PropertySignature */ && node.kind !== 155 /* IndexSignature */ && node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">!== 144</b></i> /* Parameter */) {
                            // If node.kind === SyntaxKind.Parameter, checkParameter report an error if it's not a parameter property.
                            return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(modifier, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.readonly_modifier_can_only_appear_on_a_property_declaration_or_index_signature</b></i>);
                        }
                        flags |= 64 /* Readonly */;
                        lastReadonly = modifier;
                        break;
                    case 83 /* ExportKeyword */:
                        if (flags & 1 /* Export */) {
                            return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(modifier, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">._0_modifier_already_seen</b></i>, "export");
                        }
                        else if (flags & 2 /* Ambient */) {
                            return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(modifier, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">._0_modifier_must_precede_1_modifier</b></i>, "export", "declare");
                        }
                        else if (flags & 128 /* Abstract */) {
                            return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(modifier, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">._0_modifier_must_precede_1_modifier</b></i>, "export", "abstract");
                        }
                        else if (flags & 256 /* Async */) {
                            return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(modifier, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">._0_modifier_must_precede_1_modifier</b></i>, "export", "async");
                        }
                        else if (node⚠️<i><b title="LoadNamedGeneric">.parent</b></i>.kind === 226 /* ClassDeclaration */) {
                            return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(modifier, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">._0_modifier_cannot_appear_on_a_class_element</b></i>, "export");
                        }
                        else if (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 144 /* Parameter */) {
                            return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(modifier, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">._0_modifier_cannot_appear_on_a_parameter</b></i>, "export");
                        }
                        flags |= 1 /* Export */;
                        break;
                    case 123 /* DeclareKeyword */:
                        if (flags & 2 /* Ambient */) {
                            return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(modifier, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">._0_modifier_already_seen</b></i>, "declare");
                        }
                        else if (flags & 256 /* Async */) {
                            return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(modifier, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">._0_modifier_cannot_be_used_in_an_ambient_context</b></i>, "async");
                        }
                        else if (node⚠️<i><b title="LoadNamedGeneric">.parent</b></i>.kind === 226 /* ClassDeclaration */) {
                            return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(modifier, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">._0_modifier_cannot_appear_on_a_class_element</b></i>, "declare");
                        }
                        else if (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 144 /* Parameter */) {
                            return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(modifier, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">._0_modifier_cannot_appear_on_a_parameter</b></i>, "declare");
                        }
                        else if (ts.🔶<i><b title="Did not inline: unknown">isInAmbientContext</b></i>(node⚠️<i><b title="LoadNamedGeneric">.parent</b></i>) && node⚠️<i><b title="LoadNamedGeneric">.parent</b></i>.kind === 231 /* ModuleBlock */) {
                            return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(modifier, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.A_declare_modifier_cannot_be_used_in_an_already_ambient_context</b></i>);
                        }
                        flags |= 2 /* Ambient */;
                        lastDeclare = modifier;
                        break;
                    case 116 /* AbstractKeyword */:
                        if (flags ⚠️<i><b title="Bitwise">& 128</b></i> /* Abstract */) {
                            return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(modifier, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">._0_modifier_already_seen</b></i>, "abstract");
                        }
                        if (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">!== 226</b></i> /* ClassDeclaration */) {
                            if (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">!== 149</b></i> /* MethodDeclaration */ &&
                                node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">!== 147</b></i> /* PropertyDeclaration */ &&
                                node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">!== 151</b></i> /* GetAccessor */ &&
                                node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">!== 152</b></i> /* SetAccessor */) {
                                return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(modifier, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.abstract_modifier_can_only_appear_on_a_class_method_or_property_declaration</b></i>);
                            }
                            if (!(node⚠️<i><b title="LoadNamedGeneric">.parent</b></i>⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 226</b></i> /* ClassDeclaration */ && ts.⚠️<i><b title="LoadNamedGeneric">getModifierFlags</b></i>(node⚠️<i><b title="LoadNamedGeneric">.parent</b></i>) ⚠️<i><b title="Bitwise">& 128</b></i> /* Abstract */)) {
                                return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(modifier, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Abstract_methods_can_only_appear_within_an_abstract_class</b></i>);
                            }
                            if (flags ⚠️<i><b title="Bitwise">& 32</b></i> /* Static */) {
                                return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(modifier, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">._0_modifier_cannot_be_used_with_1_modifier</b></i>, "static", "abstract");
                            }
                            if (flags ⚠️<i><b title="Bitwise">& 8</b></i> /* Private */) {
                                return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(modifier, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">._0_modifier_cannot_be_used_with_1_modifier</b></i>, "private", "abstract");
                            }
                        }
                        flags |⚠️<i><b title="Bitwise">= 128</b></i> /* Abstract */;
                        break;
                    case 119 /* AsyncKeyword */:
                        if (flags ⚠️<i><b title="Bitwise">& 256</b></i> /* Async */) {
                            return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(modifier, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">._0_modifier_already_seen</b></i>, "async");
                        }
                        else if (flags ⚠️<i><b title="Bitwise">& 2</b></i> /* Ambient */ || ts.🔶<i><b title="Did not inline: unknown">isInAmbientContext</b></i>(node⚠️<i><b title="LoadNamedGeneric">.parent</b></i>)) {
                            return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(modifier, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">._0_modifier_cannot_be_used_in_an_ambient_context</b></i>, "async");
                        }
                        else if (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> ⚠️<i><b title="CompareGeneric">=== 144</b></i> /* Parameter */) {
                            return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(modifier, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">._0_modifier_cannot_appear_on_a_parameter</b></i>, "async");
                        }
                        flags |⚠️<i><b title="Bitwise">= 256</b></i> /* Async */;
                        lastAsync = modifier;
                        break;
                }
            }
            if (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 150 /* Constructor */) {
                if (flags ⚠️<i><b title="Bitwise">& 32</b></i> /* Static */) {
                    return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(lastStatic, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">._0_modifier_cannot_appear_on_a_constructor_declaration</b></i>, "static");
                }
                if (flags ⚠️<i><b title="Bitwise">& 128</b></i> /* Abstract */) {
                    return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(lastStatic, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">._0_modifier_cannot_appear_on_a_constructor_declaration</b></i>, "abstract");
                }
                else if (flags ⚠️<i><b title="Bitwise">& 256</b></i> /* Async */) {
                    return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(lastAsync, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">._0_modifier_cannot_appear_on_a_constructor_declaration</b></i>, "async");
                }
                else if (flags ⚠️<i><b title="Bitwise">& 64</b></i> /* Readonly */) {
                    return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(lastReadonly, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">._0_modifier_cannot_appear_on_a_constructor_declaration</b></i>, "readonly");
                }
                return;
            }
            else if ((node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 235 /* ImportDeclaration */ || node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 234 /* ImportEqualsDeclaration */) && flags ⚠️<i><b title="Bitwise">& 2</b></i> /* Ambient */) {
                return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(lastDeclare, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.A_0_modifier_cannot_be_used_with_an_import_declaration</b></i>, "declare");
            }
            else if (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 144 /* Parameter */ && (flags ⚠️<i><b title="Bitwise">& 92</b></i> /* ParameterPropertyModifier */) && ts.🔶<i><b title="Did not inline: unknown">isBindingPattern</b></i>(node⚠️<i><b title="LoadNamedGeneric">.name</b></i>)) {
                return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(node, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.A_parameter_property_may_not_be_declared_using_a_binding_pattern</b></i>);
            }
            else if (node⚠️<i><b title="LoadNamedGeneric">.kind</b></i> === 144 /* Parameter */ && (flags ⚠️<i><b title="Bitwise">& 92</b></i> /* ParameterPropertyModifier */) && node⚠️<i><b title="LoadNamedGeneric">.dotDotDotToken</b></i>) {
                return 🔶️<i><b title="CallWithDescriptor">grammarErrorOnNode</b></i>(node, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.A_parameter_property_cannot_be_declared_using_a_rest_parameter</b></i>);
            }
            if (flags & 256 /* Async */) {
                return 🔶️<i><b title="CallWithDescriptor">checkGrammarAsyncModifier</b></i>(node, lastAsync);
            }
        }</pre>
<blockquote>
Inlined functions: 
<details>
<summary>reportObviousModifierErrors</summary>
<pre class="code">
(node) {
            return !node⚠️<i><b title="LoadNamedGeneric">.modifiers</b></i>
                ? false
                : 🔶<i><b title="Did not inline: target text too big">shouldReportBadModifier</b></i>(node)
                    ? 🔶️<i><b title="CallWithDescriptor">grammarErrorOnFirstToken</b></i>(node, ts⚠️<i><b title="LoadNamedGeneric">.Diagnostics</b></i>⚠️<i><b title="LoadNamedGeneric">.Modifiers_cannot_appear_here</b></i>)
                    : undefined;
        }</pre>

</details>
<details>
<summary>visibilityToString</summary>
<pre class="code">
(flags) {
            if (flags === 8 /* Private */) {
                return "private";
            }
            if (flags === 16 /* Protected */) {
                return "protected";
            }
            return "public";
        }</pre>

</details>
</blockquote>



## native string.js:

### substring:
<pre class="code">
(L,M){
if((%IS_VAR(this)===null)||(this===(void 0)))🔶️<i><b title="CallWithDescriptor">throw</b></i> 🔶️<i><b title="CallWithDescriptor">%make_type_error</b></i>(17,"String.prototype.subString");
var p=(🔶️<i><b title="CallWithDescriptor">%_ToString</b></i>(this));
var Z=p.length;
var aa=(🔶️<i><b title="CallWithDescriptor">%_ToInteger</b></i>(L));
if(aa&lt;0){
aa=0;
}else if(aa&gt;Z){
aa=Z;
}
var ab=Z;
if(!(M===(void 0))){
ab=(🔶️<i><b title="CallWithDescriptor">%_ToInteger</b></i>(M));
if(ab&gt;Z){
ab=Z;
}else{
if(ab&lt;0)ab=0;
if(aa&gt;ab){
var ah=ab;
ab=aa;
aa=ah;
}
}
}
return 🔶️<i><b title="CallWithDescriptor">%_SubString</b></i>(p,aa,ab);
}</pre>



### slice:
<pre class="code">
(L,M){
if((%IS_VAR(this)===null)||(this===(void 0)))🔶️<i><b title="CallWithDescriptor">throw</b></i> 🔶️<i><b title="CallWithDescriptor">%make_type_error</b></i>(17,"String.prototype.slice");
var p=(🔶️<i><b title="CallWithDescriptor">%_ToString</b></i>(this));
var Z=p.length;
var aa=(🔶️<i><b title="CallWithDescriptor">%_ToInteger</b></i>(L));
var ab=Z;
if(!(M===(void 0))){
ab=(🔶️<i><b title="CallWithDescriptor">%_ToInteger</b></i>(M));
}
if(aa&lt;0){
aa+⚠️<i><b title="Add">=Z</b></i>;
if(aa⚠️<i><b title="CompareGeneric"><0</b></i>){
aa=0;
}
}else{
if(aa&gt;Z){
return'';
}
}
if(ab&lt;0){
ab+⚠️<i><b title="Add">=Z</b></i>;
if(ab&lt;0){
return'';
}
}else{
if(ab&gt;Z){
ab=Z;
}
}
if(ab&lt;=aa){
return'';
}
return 🔶️<i><b title="CallWithDescriptor">%_SubString</b></i>(p,aa,ab);
}</pre>



### lastIndexOf:
<pre class="code">
(w,x){
if((%IS_VAR(this)===null)||(this===(void 0)))🔶️<i><b title="CallWithDescriptor">throw</b></i> 🔶️<i><b title="CallWithDescriptor">%make_type_error</b></i>(17,"String.prototype.lastIndexOf");
var y=(🔶️<i><b title="CallWithDescriptor">%_ToString</b></i>(this));
var z=y⚠️<i><b title="LoadNamedGeneric">.length</b></i>;
var w=(🔶️<i><b title="CallWithDescriptor">%_ToString</b></i>(w));
var A=w.length;
var v=z-A;
var t=(🔶️<i><b title="CallWithDescriptor">%_ToNumber</b></i>(x));
if(!(!%_IsSmi(%IS_VAR(t))&&!(t==t))){
t=(🔶️<i><b title="CallWithDescriptor">%_ToInteger</b></i>(t));
if(t&lt;0){
t=0;
}
if(t+A&lt;z){
v=t;
}
}
if(v&lt;0){
return-1;
}
return 🔶️<i><b title="CallWithDescriptor">%StringLastIndexOf</b></i>(y,w,v);
}</pre>



### indexOf:
<pre class="code">
(s,t){
if((%IS_VAR(this)===null)||(this===(void 0)))🔶️<i><b title="CallWithDescriptor">throw</b></i> 🔶️<i><b title="CallWithDescriptor">%make_type_error</b></i>(17,"String.prototype.indexOf");
var u=(🔶️<i><b title="CallWithDescriptor">%_ToString</b></i>(this));
s=(🔶️<i><b title="CallWithDescriptor">%_ToString</b></i>(s));
var v=(🔶️<i><b title="CallWithDescriptor">%_ToInteger</b></i>(t));
if(v&lt;0)v=0;
if(v&gt;u⚠️<i><b title="LoadNamedGeneric">.length</b></i>)v=u⚠️<i><b title="LoadNamedGeneric">.length</b></i>;
return 🔶️<i><b title="CallWithDescriptor">%StringIndexOf</b></i>(u,s,v);
}</pre>



## native array.js:

### ConvertToString:
<pre class="code">
(A,O){
if((O==null))return'';
return(🔶️<i><b title="CallWithDescriptor">%_ToString</b></i>(A?O.🔶️<i><b title="CallWithDescriptor">toLocaleString</b></i>():O));
}</pre>



### join:
<pre class="code">
(B){
if((%IS_VAR(this)===null)||(this===(void 0)))🔶️<i><b title="CallWithDescriptor">throw</b></i> 🔶️<i><b title="CallWithDescriptor">%make_type_error</b></i>(17,"Array.prototype.join");
var q=(%_ToObject(this));
var r=(🔶️<i><b title="CallWithDescriptor">%_ToLength</b></i>(q.length));
return 🔶<i><b title="Did not inline: unknown">InnerArrayJoin</b></i>(B,q,r);
}</pre>



### InnerArrayJoin:
<pre class="code">
(B,q,r){
if((B===(void 0))){
B=',';
}else{
B=(🔶️<i><b title="CallWithDescriptor">%_ToString</b></i>(B));
}
if(r===1){
var z=q[0];
if((z==null))return'';
return(🔶️<i><b title="CallWithDescriptor">%_ToString</b></i>(z));
}
return 🔶️<i><b title="CallWithDescriptor">Join</b></i>(q,r,B,false);
}</pre>



### StackPush:
<pre class="code">
(J,K){
J.values[J.length++]=K;
}</pre>



### UseSparseVariant:
<pre class="code">
(q,r,F,G){
if(!F||r&lt;1000||🔶️<i><b title="CallWithDescriptor">%HasComplexElements</b></i>(q)){
return false;
}
if(!%_IsSmi(r)){
return true;
}
var H=r⚠️<i><b title="Sar">>>2</b></i>;
var I=🔶️<i><b title="CallWithDescriptor">%EstimateNumberOfElements</b></i>(q);
return(I⚠️<i><b title="CompareGeneric"><H</b></i>)&&
(G⚠️<i><b title="CompareGeneric">>I</b></i>⚠️<i><b title="Mul">*4);
</b></i>}</pre>



### StackPop:
<pre class="code">
(J){
J.values[--J.length]=null
}</pre>



### ⛔ DoJoin (deoptimizated):
<pre class="code">
(q,r,F,B,A){
if(🔶<i><b title="Did not inline: unknown">UseSparseVariant</b></i>(q,r,F,r)){
🔶️<i><b title="CallWithDescriptor">%NormalizeElements</b></i>(q);
var x=🔶️<i><b title="CallWithDescriptor">GetSortedArrayKeys</b></i>(q,🔶️<i><b title="CallWithDescriptor">%GetArrayKeys</b></i>(q,r));
if(B⚠️<i><b title="CompareGeneric">===''</b></i>){
if(x⚠️<i><b title="LoadNamedGeneric">.length</b></i>⚠️<i><b title="CompareGeneric">===0</b></i>)return'';
return 🔶️<i><b title="CallWithDescriptor">SparseJoin</b></i>(q,x,A);
}else{
return 🔶️<i><b title="CallWithDescriptor">SparseJoinWithSeparatorJS</b></i>(
q,x,r,A,B);
}
}
if(r===1){
return 🔶<i><b title="Did not inline: unknown">ConvertToString</b></i>(A,q⚠️<i><b title="LoadKeyedGeneric">[0]</b></i>);
}
var D=new g(r);
for(var y=0;y&lt;r;y++){
D[y]=🔶<i><b title="Did not inline: unknown">ConvertToString</b></i>(A,q[y]);
}
if(B===''){
return 🔶️<i><b title="CallWithDescriptor">%StringBuilderConcat</b></i>(D,r,'');
}else{
return 🔶️<i><b title="CallWithDescriptor">%StringBuilderJoin</b></i>(D,r,B);
}
}</pre>

```diff
- Deopt: <JS Function parseTypeWorker (SharedFunctionInfo 0x3504a53f7b71)> (opt #141) @18, FP to SP delta: 224, caller sp: 0x7fff5fbfda90
```

```diff
- Deopt: <JS Function parseTypeWorker (SharedFunctionInfo 0x3504a53f7b71)> (opt #141) @90, FP to SP delta: 224, caller sp: 0x7fff5fbfdd30
```

```diff
- Deopt: <JS Function skipParameterStart (SharedFunctionInfo 0x3504a53f77b1)> (opt #105) @10, FP to SP delta: 40, caller sp: 0x7fff5fbfd620
```



## native regexp.js:

### RegExpSubclassExec:
<pre class="code">
(B,C,Q){
if((Q===(void 0))){
Q=B.exec;
}
if((typeof(Q)==='function')){
var J=🔶️<i><b title="CallWithDescriptor">%_Call</b></i>(Q,B,C);
if(!(%_IsJSReceiver(J))&&!(J===null)){
🔶️<i><b title="CallWithDescriptor">throw</b></i> 🔶️<i><b title="CallWithDescriptor">%make_type_error</b></i>(48);
}
return J;
}
return 🔶️<i><b title="CallWithDescriptor">%_Call</b></i>(RegExpExecJS,B,C);
}</pre>


